/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

        (c) Copyright 2009-2016 SAP SE. All rights reserved
    
 */
sap.ui.predefine('sap/me/Calendar',['jquery.sap.global','./CalendarDate','./library','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/core/IconPool','sap/ui/core/date/UniversalDate'],function(q,C,l,a,L,I,U){"use strict";
var b=a.extend("sap.me.Calendar",{metadata:{library:"sap.me",properties:{visible:{type:"boolean",group:"Misc",defaultValue:true},hideNavControls:{type:"boolean",group:"Misc",defaultValue:false},hideMonthTitles:{type:"boolean",group:"Misc",defaultValue:false},monthsPerRow:{type:"int",group:"Misc",defaultValue:1},dayWidth:{type:"int",group:"Misc",defaultValue:45},dayHeight:{type:"int",group:"Misc",defaultValue:50},weeksPerRow:{type:"int",group:"Misc",defaultValue:1},singleRow:{type:"boolean",group:"Misc",defaultValue:null},monthsToDisplay:{type:"int",group:"Misc",defaultValue:1},currentDate:{type:"string",group:"Misc",defaultValue:null},enableMultiselection:{type:"boolean",group:"Misc",defaultValue:false},firstDayOffset:{type:"int",group:"Misc",defaultValue:0},disabledWeekDays:{type:"any",group:"Misc",defaultValue:null},disabledDates:{type:"any",group:"Misc",defaultValue:null},swipeToNavigate:{type:"boolean",group:"Misc",defaultValue:false},design:{type:"sap.me.CalendarDesign",group:"Appearance",defaultValue:sap.me.CalendarDesign.Approval},selectionMode:{type:"sap.me.CalendarSelectionMode",group:"Behavior",defaultValue:sap.me.CalendarSelectionMode.SINGLE},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},days:{type:"any",group:"Appearance",defaultValue:null},months:{type:"any",group:"Appearance",defaultValue:null}},events:{tapOnDate:{parameters:{date:{type:"string"},didSelect:{type:"boolean"}}},changeCurrentDate:{parameters:{currentDate:{type:"string"}}},changeRange:{parameters:{fromDate:{type:"string"},toDate:{type:"string"}}}}}});
b.prototype.init=function(){this.__setCurrentDate((new C().toDateString()),true);var o=sap.m.getLocaleData();this.setDays(o.getDays("abbreviated"));this.setMonths(o.getMonths("abbreviated"));var p=new sap.ui.core.Icon({src:I.getIconURI("navigation-left-arrow")});p.addStyleClass("sapMeCalendarPrevious");p.attachPress(null,this._gotoPrevious,this);p.setParent(this);this._oPrevBtn=p;var n=new sap.ui.core.Icon({src:I.getIconURI("navigation-right-arrow")});n.addStyleClass("sapMeCalendarNext");n.attachPress(null,this._gotoNext,this);n.setParent(this);this._oNextBtn=n;this._oDatesClasses={};this._$interactiveDates=null;this._oLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();this._oLocaleData=L.getInstance(this._oLocale);this._bRtl=sap.ui.getCore().getConfiguration().getRTL();};
b.prototype.exit=function(){this._oPrevBtn.destroy();delete this._oPrevBtn;this._oNextBtn.destroy();delete this._oNextBtn;delete this._oDatesClasses;delete this._$interactiveDates;delete this._$fromDate;delete this._$toDate;};
b.prototype.onBeforeRendering=function(){delete this._$interactiveDates;};
b.prototype.onAfterRendering=function(){var $=this.$();var c=null;var d=this.getDisabledWeekDays()||[];var e=[];var i;var D;for(i=0;i<d.length;i++){e.push(".sapMeCalendarWeekDay"+d[i]);}var f=this.getSingleRow()||this.getMonthsToDisplay()===1;if(!f){e.push(".sapMeCalendarDayNotInCurrentMonth");}if(e.length){var t=e.join(", ");$.find(".sapMeCalendarMonth > div.sapMeCalendarMonthDays").children(t).css({"pointer-events":"none"});c=$.find(".sapMeCalendarMonth > div.sapMeCalendarMonthDays > .sapMeCalendarMonthDay:not("+t+")");}else{c=$.find(".sapMeCalendarMonth > div.sapMeCalendarMonthDays > .sapMeCalendarMonthDay");}var g=this.getDisabledDates()||[];for(i=0;i<g.length;i++){D=g[i];c.children("input[value='"+D+"']").parent().css({"pointer-events":"none"});}for(D in this._oDatesClasses){var s=this._oDatesClasses[D].join(" ");c.children("input[value='"+D+"']").parent().addClass(s);}this._$interactiveDates=c;var h=this.getHideNavControls();this._oPrevBtn.$().css({display:h?"none":""});this._oNextBtn.$().css({display:h?"none":""});};
b.prototype.setEnableMultiselection=function(e){return this.setProperty("selectionMode",e?sap.me.CalendarSelectionMode.MULTIPLE:sap.me.CalendarSelectionMode.SINGLE,true);};
b.prototype.getEnableMultiselection=function(){return this.getProperty("selectionMode")==sap.me.CalendarSelectionMode.MULTIPLE;};
b.prototype.setHideNavControls=function(h){if(this.getDomRef()){this._oPrevBtn.$().css({display:h?"none":""});this._oNextBtn.$().css({display:h?"none":""});}return this.setProperty("hideNavControls",h,true);};
b.prototype.setHideMonthTitles=function(h){if(this.getDomRef()){this.$().find(".sapMeCalendarMonthName").css({visibility:h?"hidden":""});}return this.setProperty("hideMonthTitles",h,true);};
b.prototype.setFirstDayOffset=function(o){o=o%this.getDays().length;return this.setProperty("firstDayOffset",o);};
b.prototype.setWeeksPerRow=function(w){w=w%5;return this.setProperty("weeksPerRow",w);};
b.prototype.setDisabledWeekDays=function(w){w=w||[];return this.setProperty("disabledWeekDays",w);};
b.prototype.setDisabledDates=function(d){d=d||[];var i;for(i=0;i<d.length;i++){var D=d[i];if(typeof D==="string"){D=C.parseFromToDateString(D);}var s=D.toDateString();d[i]=s;}return this.setProperty("disabledDates",d);};
b.prototype.ontouchstart=function(e){if(!this.getSwipeToNavigate()){this._gestureStart(e);}};
b.prototype._gestureStart=function(e){this._$fromDate=this.getEnableMultiselection()?this._getDateDomRef(e.target):null;};
b.prototype.ontouchmove=function(e){if(!this.getSwipeToNavigate()){this._gestureMove(e);}};
b.prototype._gestureMove=function(e){if(this._$fromDate){if(!this._$toDate){this._$fromDate.addClass("sapMeCalendarHighlight");this._$toDate=this._$fromDate;}e.stopPropagation();e.preventDefault();var d=e.target;if(e.touches.length){var t=e.touches[0];d=document.elementFromPoint(t.clientX,t.clientY);}var $=this._getDateDomRef(d);if($&&$!=this._$toDate){this._$toDate.removeClass("sapMeCalendarHighlight");this._$fromDate.addClass("sapMeCalendarHighlight");$.addClass("sapMeCalendarHighlight");this._$toDate=$;}}};
b.prototype.ontouchend=function(e){if(!this.getSwipeToNavigate()){this._gestureEnd(e);}};
b.prototype._gestureEnd=function(e){if(this._$fromDate&&this._$toDate){e.stopPropagation();e.preventDefault();var f=this._getDateValue(this._$fromDate);var t=this._getDateValue(this._$toDate);this._$fromDate.removeClass("sapMeCalendarHighlight");this._$toDate.removeClass("sapMeCalendarHighlight");this.toggleDatesRangeSelection(f,t,true);this.fireChangeRange({fromDate:f,toDate:t});}delete this._$fromDate;delete this._$toDate;};
b.prototype.ontap=function(e){this._gestureSelect(e);};
b.prototype._gestureSelect=function(e){var $=this._getDateDomRef(e.target);if(sap.ui.Device.browser.msie&&sap.ui.Device.browser.version<11){if($.css("pointer-events")=="none"){return;}}if($){var d=this._getDateValue($);var D=!$.hasClass("sapMeCalendarSelected");if(!this.getEnableMultiselection()){if(this.getSelectionMode()==sap.me.CalendarSelectionMode.SINGLE){this.unselectAllDates();}else if(this.getSelectedDates().length>1){this.unselectAllDates();}}if((this.getSelectionMode()==sap.me.CalendarSelectionMode.RANGE)&&(this.getSelectedDates().length==1)){var f=this.getSelectedDates()[0];this.toggleDatesRangeSelection(f,d,true);this.fireChangeRange({fromDate:f,toDate:d});}else{$.toggleClass("sapMeCalendarSelected",D);this._updateDatesWithClass("sapMeCalendarSelected",d,D);this.fireTapOnDate({didSelect:D,date:d});}}};
b.prototype.onswipeleft=function(e){if(this.getSwipeToNavigate()){if(!this._bRtl){this._gotoNext();}else{this._gotoPrevious();}}};
b.prototype.onswiperight=function(e){if(this.getSwipeToNavigate()){if(!this._bRtl){this._gotoPrevious();}else{this._gotoNext();}}};
b.prototype.getSelectedDates=function(){return this._getDatesWithStyleClass("sapMeCalendarSelected");};
b.prototype.toggleDatesSelection=function(d,s){this._toggleDatesStyleClass("sapMeCalendarSelected",d,s);};
b.prototype.toggleDatesType=function(d,t,s){this._toggleDatesStyleClass("sapMeCalendar"+t,d,s);};
b.prototype.removeTypesOfAllDates=function(){this._removeStyleClassOfAllDates("sapMeCalendar"+sap.me.CalendarEventType.Type00);this._removeStyleClassOfAllDates("sapMeCalendar"+sap.me.CalendarEventType.Type01);this._removeStyleClassOfAllDates("sapMeCalendar"+sap.me.CalendarEventType.Type04);this._removeStyleClassOfAllDates("sapMeCalendar"+sap.me.CalendarEventType.Type06);this._removeStyleClassOfAllDates("sapMeCalendar"+sap.me.CalendarEventType.Type07);this._removeStyleClassOfAllDates("sapMeCalendar"+sap.me.CalendarEventType.Type10);};
b.prototype.unselectAllDates=function(){this._removeStyleClassOfAllDates("sapMeCalendarSelected");};
b.prototype.toggleDatesRangeSelection=function(d,D,s){this._toggleDatesRangeStyleClass("sapMeCalendarSelected",d,D,s);};
b.prototype._getDatesWithStyleClass=function(s){var d=[];var D;for(D in this._oDatesClasses){if(q.inArray(s,this._oDatesClasses[D])!==-1){d.push(D);}}return d;};
b.prototype._toggleDatesRangeStyleClass=function(c,d,D,A){var u;var o;if(typeof d=="string"){u=C.parseFromToDateString(d);}else if(d instanceof Date){u=new U(d.getTime());}if(typeof D=="string"){o=C.parseFromToDateString(D);}else if(D instanceof Date){o=new U(D.getTime());}if(u&&o&&typeof u.getTime=="function"&&typeof o.getTime=="function"){if(u.getTime()>o.getTime()){var t=new U(u.getTime());u=o;o=t;}var e=[];var f=new U(u.getTime());var g;while(o-f>=0){g=new Date(f.getTime());e.push(g.toDateString());f.setDate(f.getDate()+1);}this._toggleDatesStyleClass(c,e,A);}};
b.prototype._toggleDatesStyleClass=function(c,d,A){var i;for(i=0;i<d.length;i++){var D=d[i];if(typeof D=="string"){D=C.parseFromToDateString(D);}else if(D instanceof Date){D=new U(D.getTime());}D=new Date(D.getTime());var s=D.toDateString();d[i]=s;this._updateDatesWithClass(c,s,A);if(this._$interactiveDates){this._$interactiveDates.children("input[value='"+s+"']").parent().toggleClass(c,A);}}};
b.prototype._removeStyleClassOfAllDates=function(c){var d;for(d in this._oDatesClasses){this._updateDatesWithClass(c,d,false);}if(this._$interactiveDates){this._$interactiveDates.removeClass(c);}};
b.prototype._gotoPrevious=function(){var s=this.getSingleRow();if(s){this._oInternalDate.previousWeek();}else{this._oInternalDate.previousMonth();}var c=this._oInternalDate.toDateString();this.setCurrentDate(c);this.fireChangeCurrentDate({currentDate:c});};
b.prototype._gotoNext=function(){var s=this.getSingleRow();if(s){this._oInternalDate.nextWeek();}else{this._oInternalDate.nextMonth();}var c=this._oInternalDate.toDateString();this.setCurrentDate(c);this.fireChangeCurrentDate({currentDate:c});};
b.prototype._updateDatesWithClass=function(c,d,A){var s=this._oDatesClasses[d]||[];var i=q.inArray(c,s);if(A&&i===-1){s.push(c);}else if(!A&&i!==-1){s.splice(i,1);}if(s.length===0){this._oDatesClasses[d]=null;delete this._oDatesClasses[d];}else{this._oDatesClasses[d]=s;}};
b.prototype._getDateValue=function($){return $.children("input").eq(0).val();};
b.prototype._getMonthDate=function(d){var $=q(d);var c=q(this.getDomRef());while($&&$!=c&&!$.hasClass("sapMeCalendarMonthDay")){$=$.parent();}return $&&$.parent().hasClass("sapMeCalendarMonth")?$:null;};
b.prototype._getDateDomRef=function(d){var $=d?q(d):null;var t=this.getId();var c=null;while($&&$[0].id!=t&&!$.hasClass("sapMeCalendarMonth")){if($.hasClass("sapMeCalendarMonthDay")&&$.parent().hasClass("sapMeCalendarMonthDays")){c=$;break;}$=$.parent();}return c;};
b.prototype._checkLanguageRegion=function(c,r){return(r===this._oLocale.getRegion()&&c===this._oLocale.getLanguage());};
b.prototype._getIntervalPattern=function(p){return this._oLocaleData.getIntervalPattern(p);};
b.prototype.getCurrentDate=function(){return this._oInternalDate.toDateString();};
b.prototype.setCurrentDate=function(s){this.__setCurrentDate(s,false);return this;};
b.prototype.__setCurrentDate=function(s,S){this._oInternalDate=new C(C.parseFromToDateString(s));this.setProperty("currentDate",this._oInternalDate.toDateString(),S);};
b.parseDate=function(s){var d=C.parseFromToDateString(s,true);return new Date(d.getTime());};
b.prototype._getCalendarFirstDate=function(){var f=new U(this._oInternalDate._date.getTime());if(this.getSingleRow()){f.setHours(12);var d=f.getDay()-this.getFirstDayOffset();var c;if(d<0){c=(7-Math.abs(d))%7;}else{c=d;}f.setDate(f.getDate()-c);}else{q.sap.log.error("You cannot use this method in a non single row calendar, returning current date.");}return f;};
b.prototype.isWeekend=function(d){var s=this._oLocaleData.getWeekendStart(),e=this._oLocaleData.getWeekendEnd(),i=false;if(s<=e){i=(s<=d)&&(d<=e);}else{i=(d>=s)||(d<=e);}return i;};
return b;},true);
sap.ui.predefine('sap/me/CalendarDate',['jquery.sap.global','sap/ui/core/date/UniversalDate'],function(q,U){"use strict";
var t=sap.ui.base.Object.extend("sap.me.CalendarDate",{constructor:function(){if(arguments.length===0||!(arguments[0]instanceof Date||arguments[0]instanceof U)){var d=new Date();this._date=t.createDate(d.getFullYear(),d.getMonth(),d.getDate());}else{var i=arguments[0];if(i instanceof U){i=new Date(i.getTime());}this._date=t.createDate(i.getFullYear(),i.getMonth(),i.getDate());}}});
t.createDate=function(y,m,d){var D=new Date(y,m,d,12,0,0);return new U(D.getTime());};
t._regExpToDateString=/^(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) (\d\d?) (\d\d\d\d)$/i;
t.prototype.getDateObject=function(){return this._date;};
t.prototype.getCopyDateObject=function(){var c=new U(this._date.getTime());return c;};
t.getMonthFromString=function(s){var m=["jan","feb","mar","apr","may","jun","jul","aug","sep","oct","nov","dec"];s=s.toLowerCase();return q.inArray(s,m);};
t.parseFromToDateString=function(f,T){var p;var r=t._regExpToDateString.exec(f);if(r!==null&&r.length===4&&r[0]===f){p=t.createDate(parseInt(r[3],10),t.getMonthFromString(r[1]),parseInt(r[2],10));}else{q.sap.log.warning("The provided string does not match the toDateString format: "+f);if(typeof T==="boolean"&&T){throw new Error("Unparseable string provided: "+f);}var d=new Date(f);p=new U(d.getTime());}return p;};
t.prototype.nextMonth=function(){this._date=t.getNextMonth(this._date);return this._date;};
t.getNextMonth=function(d){var n=new U(d);n.setMonth(n.getMonth()+1,1);n.setHours(12,0,0);return n;};
t.prototype.previousMonth=function(){this._date=t.getPreviousMonth(this._date);return this._date;};
t.getPreviousMonth=function(d){var p=new U(d);p.setMonth(p.getMonth()-1,1);p.setHours(12,0,0);return p;};
t.prototype.nextWeek=function(){this._date.setHours(12);this._date.setDate(this._date.getDate()+7);return this._date;};
t.prototype.previousWeek=function(){this._date.setHours(12);this._date.setDate(this._date.getDate()-7);return this._date;};
t.prototype.toDateString=function(){var d=new Date(this._date.getTime());return d.toDateString();};
return t;},true);
sap.ui.predefine('sap/me/CalendarLegend',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/theming/Parameters'],function(q,l,C,I,P){"use strict";
var a=C.extend("sap.me.CalendarLegend",{metadata:{library:"sap.me",properties:{legendForType00:{type:"string",group:"Misc",defaultValue:null},legendForType01:{type:"string",group:"Misc",defaultValue:null},legendForType04:{type:"string",group:"Misc",defaultValue:null},legendForType06:{type:"string",group:"Misc",defaultValue:null},legendForType07:{type:"string",group:"Misc",defaultValue:null},legendForToday:{type:"string",group:"Misc",defaultValue:null},legendForSelected:{type:"string",group:"Misc",defaultValue:null},legendForSelected00:{type:"string",group:"Misc",defaultValue:null},legendForNormal:{type:"string",group:"Misc",defaultValue:null},expandable:{type:"boolean",group:"Misc",defaultValue:true},expanded:{type:"boolean",group:"Misc",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},legendWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'12.5rem'},visible:{type:"boolean",group:"Appearance",defaultValue:true},design:{type:"sap.me.CalendarDesign",group:"Appearance",defaultValue:sap.me.CalendarDesign.Approval}},aggregations:{labels:{type:"sap.m.Label",multiple:true,singularName:"label",visibility:"hidden"},colors:{type:"sap.ui.core.Control",multiple:true,singularName:"color",visibility:"hidden"},icon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}}}});
a.prototype.init=function(){this._createIcon();I.insertFontFaceStyle();this._legendIndex=[];};
a.prototype.setLegendForType00=function(v){this._setLegendLabelByName("ForType00",v);};
a.prototype.setLegendForType01=function(v){this._setLegendLabelByName("ForType01",v);};
a.prototype.setLegendForType04=function(v){this._setLegendLabelByName("ForType04",v);};
a.prototype.setLegendForType06=function(v){this._setLegendLabelByName("ForType06",v);};
a.prototype.setLegendForType07=function(v){this._setLegendLabelByName("ForType07",v);};
a.prototype.setLegendForToday=function(v){this._setLegendLabelByName("ForToday",v);};
a.prototype.setLegendForSelected=function(v){this._setLegendLabelByName("ForSelected",v);};
a.prototype.setLegendForSelected00=function(v){this._setLegendLabelByName("ForSelected00",v);};
a.prototype.setLegendForNormal=function(v){this._setLegendLabelByName("ForNormal",v);};
a.prototype.setExpanded=function(v){this.setProperty("expanded",v);this._changeIconSrc();};
a.prototype._setLegendLabelByName=function(n,v){var o=sap.ui.getCore().byId(this.getId()+"-"+n);var c=sap.ui.getCore().byId(this.getId()+'-Color'+n);if(!o){o=new sap.m.Label(this.getId()+'-'+n,{width:"auto"});o.addStyleClass("sapUIMeCalendarLegendLabels");this.addAggregation("labels",o,true);o.setText(v);c=new sap.m.Label(this.getId()+'-Color'+n);c.addStyleClass("sapUIMeLegendColor");c.addStyleClass("sapUIMeLegendColor"+n);this.addAggregation("colors",c,true);this._legendIndex.push(n);}else{o.setText(v);if(!v){this.removeAggregation("colors",c,true);this.removeAggregation("labels",o,true);}else{var i=this._legendIndex.indexOf(n);this.insertAggregation("colors",c,i,true);this.insertAggregation("labels",o,i,true);}}this.setProperty("legend"+n,v);};
a.prototype.setExpandable=function(v){this.setProperty("expandable",v);if(!v&&!this.getExpanded()){this.toggleExpandCollapse();}};
a.prototype.setVisible=function(v){this.setProperty("visible",v);};
a.prototype.toggleExpandCollapse=function(){if(!this.getExpandable())return;var e=!this.getExpanded();var $=this.$("LegendMenu");if(e){this.$("LegendMenu").css("display","none").css("height","auto");$.slideDown('600',"swing",q.proxy(this.onTransitionEnded,this));}else{$.slideUp('600',q.proxy(this.onTransitionEnded,this));}this.setProperty("expanded",e,true);this._changeIconSrc();};
a.prototype._createIcon=function(){var i=this.getExpanded()?"collapse":"expand";var c=P.get("sapUiLightIcon");var A=P.get("sapUiHighlight");var s=P.get("sapUiIconInverted");var o=new sap.ui.core.Icon(this.getId()+i,{src:I.getIconURI(i),color:c,activeBackgroundColor:A,activeColor:s,press:q.proxy(this.toggleExpandCollapse,this)});o.addStyleClass("sapUIMeLegendIcon");this.setAggregation("icon",o,true);};
a.prototype._getColorBoxStyle=function(i){var b=this.getId()+"-";var s=i.substr(i.indexOf(b)+b.length);s="sapUIMeLegendColor"+s;return s;};
a.prototype._changeIconSrc=function(){var i=this.getExpanded()?"collapse":"expand";this.getAggregation("icon").setSrc(I.getIconURI(i));};
return a;},true);
sap.ui.predefine('sap/me/CalendarLegendRenderer',['jquery.sap.global'],function(q){"use strict";var C={};
C.render=function(r,c){var l=c.getAggregation("labels");if(c.getVisible()&&l&&l.length>0){var m="";var W=c.getWidth();if(W){m+="width:"+W+";";}r.write("<div");r.writeControlData(c);r.addClass("sapUIMeLegendOuterContainer");r.writeAttribute("style",m);r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMeCalendarLegend");r.addClass("sapMeCalendarLegend"+c.getDesign());r.writeClasses();r.write(">");r.write("<div  id='"+c.getId()+"-arrow'");r.addClass("sapUIMeLegend");r.writeClasses();r.write(">");if(c.getExpandable()){r.renderControl(c.getAggregation("icon"));}r.write("<div id='"+c.getId()+"-LegendMenuContainer'");r.addClass("sapUIMeLegendMenuContainer");r.writeClasses();r.write(">");r.write("<div id='"+c.getId()+"-LegendMenu'");r.addClass("sapUIMeLegendMenu");if(!c.getExpanded()){r.write("style = 'display:none'");}r.writeClasses();r.write(">");var w=c.getLegendWidth();for(var i=0;i<l.length;i++){r.write("<div ");r.addClass("sapUIMeLegendLine");r.writeClasses();r.write(">");r.write("<div ");r.addClass("sapUIMeLegendColor");r.addClass(c._getColorBoxStyle(l[i].getId()));r.writeClasses();r.write("></div>");r.renderControl(l[i]);r.write("</div>");}r.write("</div>");r.write("</div>");r.write("</div>");r.write("</div>");r.write("</div>");}};
return C;},true);
sap.ui.predefine('sap/me/CalendarRenderer',['jquery.sap.global','./CalendarDate','sap/ui/core/LocaleData','sap/ui/core/format/DateFormat','sap/ui/core/date/UniversalDate'],function(q,C,L,D,U){"use strict";var a={};
a.render=function(r,c){if(!c.getVisible()){return;}r.write("<div");r.writeControlData(c);r.addClass("sapMeCalendar");var s="sapMeCalendar"+c.getDesign();r.addClass(s);r.writeClasses();var w=c.getWidth();if(w!=undefined){r.addStyle("width",w);r.writeStyles();}r.write(">");r.renderControl(c._oPrevBtn);r.renderControl(c._oNextBtn);var S=c.getSingleRow();var m=S?1:c.getMonthsToDisplay();var n=new C();var N=n.toDateString();var i;if(m===1){this._renderMonth(r,c,c._oInternalDate.getDateObject(),N);}else{var b=c._oInternalDate.getCopyDateObject();var M=Math.floor(m/2);for(i=0;i<M;i++){b=C.getPreviousMonth(b);}for(i=0;i<m;i++){this._renderMonth(r,c,b,N);b=C.getNextMonth(b);}}r.write("</div>");};
a._formatDate=function(d,p){var b=D.getDateTimeInstance({pattern:p});return b.format(d);};
a._getDateIntervalText=function(d,o,c){var b,e;if(d.getTime()<=o.getTime()){b=new Date(d.getTime());e=new Date(o.getTime());}else{b=new Date(o.getTime());e=new Date(d.getTime());}var i=c._getIntervalPattern("yMMM-y");var I=this._getIntervalSeparator(i,c);var p=i.split(I);return this._formatDate(b,p[0])+I+this._formatDate(e,p[1]);};
a._getMonthAndYear=function(d,c){var p=c._getIntervalPattern("yMMM-y");var i=this._getIntervalSeparator(p,c);var P=p.split(i);return this._formatDate(d,P[0]);};
a._getIntervalSeparator=function(p,c){var f=c._getIntervalPattern("");var i=f.replace("{0}","").replace("{1}","").trim();if(c._checkLanguageRegion("zh","CN")){if(p.indexOf(i===-1)){i=c._getIntervalPattern("MMM-M").replace(/L/g,"").trim();}}return i;};
a._getMonthTitle=function(c,o,i,s,t){var m=this._getMonthAndYear(c,o);if(s){var b=new U(c.getTime());b.setDate(b.getDate()+t-1);if(c.getFullYear()!==b.getFullYear()||c.getMonth()!==b.getMonth()){m=this._getDateIntervalText(c,b,o);}}return m;};
a._renderMonth=function(r,c,m,d){var s=c.getSingleRow();var f=c.getFirstDayOffset();var w=c.getDays();var W=w.length;var b=c.getWeeksPerRow();var e=b*W;var g=(100/e);var h=c.getDayHeight();var M=(100/(s?1:c.getMonthsPerRow()));var t=new Date(m.getTime());var j=C.createDate(t.getFullYear(),t.getMonth(),t.getDate());var k=j.getDate();var l=j.getDay();j.setDate(1);var n=j.getDay();if(n<f){n+=7;}var o=j.getMonth();var p=new U(j);p.setMonth(o+1,0);var u=p.getDate();var v=s?l+1-f:k+n-f;var x=Math.ceil((u+v-k)/7);var T=s?e:(x*7);if(s){j=c._getCalendarFirstDate();}var y=this._getMonthTitle(j,c,k,s,T);if(!s){j.setDate(k-v+1);}r.write('<div');r.addClass("sapMeCalendarMonth");if(!s){r.addClass("sapMeCalendarMonthNotSingle");}r.writeClasses();r.addStyle("width",M+"%");r.writeStyles();r.write(">");r.write('<div');r.addClass("sapMeCalendarMonthName");r.writeClasses();if(c.getHideMonthTitles()){r.addStyle("visibility","hidden");r.writeStyles();}r.write(">");r.writeEscaped(y);r.write("</div>");r.write('<div');r.addClass("sapMeCalendarMonthDayNames");r.writeClasses();r.write(">");var i;for(i=0;i<e;i++){var z=w[(i+f)%W];this._renderDay(r,c,null,z,g);}r.write('</div>');r.write('<div');r.addClass("sapMeCalendarMonthDays");r.writeClasses();r.write(">");for(i=0;i<T;i++){var A=j.getMonth();var B=j.getDay();l=j.getDate();var N=A!==o;t=new Date(j.getTime());var I=t.toDateString();var E=I==d;this._renderDay(r,c,I,l+"",g,h,B,N,E);j.setDate(j.getDate()+1);}r.write('</div>');r.write('</div>');};
a._renderDay=function(r,c,i,s,d,b,e,n,I){r.write("<div");r.addClass("sapMeCalendarMonthDay");if(I){r.addClass("sapMeCalendarDayNow");}if(n&&!c.getSingleRow()){r.addClass("sapMeCalendarDayNotInCurrentMonth");}if(typeof e==="number"){r.addClass("sapMeCalendarWeekDay"+e);if(c.isWeekend(e)){r.addClass("sapMeCalendarWeekendDay");}}r.writeClasses();r.addStyle("width",d+"%");if(b){r.addStyle("height",b+"px");}r.writeStyles();if(i!=null){var f=i.replace(/\s/g,"-");r.writeAttribute('id',c.getId()+"-"+f);}r.write(">");r.write('<span>');r.writeEscaped(s);r.write("</span>");if(i!=null){r.write('<input type="hidden" value="'+i+'"></input>');}r.write("</div>");};
return a;},true);
sap.ui.predefine('sap/me/OverlapCalendar',['jquery.sap.global','./Calendar','./CalendarDate','./library','sap/ui/core/Control','sap/ui/core/theming/Parameters','sap/ui/core/date/UniversalDate'],function(q,C,a,c,d,P,U){"use strict";
var O=d.extend("sap.me.OverlapCalendar",{metadata:{library:"sap.me",properties:{startDate:{type:"string",group:"Data",defaultValue:null},weeksPerRow:{type:"int",group:"Appearance",defaultValue:2},firstDayOffset:{type:"int",group:"Appearance",defaultValue:0},showOverlapIndicator:{type:"boolean",group:"Appearance",defaultValue:false},visible:{type:"boolean",group:"Appearance",defaultValue:true},swipeToNavigate:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'}},aggregations:{calendarEvents:{type:"sap.me.OverlapCalendarEvent",multiple:true,singularName:"calendarEvent"},calendar:{type:"sap.me.Calendar",multiple:false,visibility:"hidden"},typeLabels:{type:"sap.m.Label",multiple:true,singularName:"typeLabel",visibility:"hidden"},nameLabels:{type:"sap.m.Label",multiple:true,singularName:"nameLabel",visibility:"hidden"}},events:{endOfData:{parameters:{before:{type:"boolean"}}},changeDate:{parameters:{firstDate:{type:"object"},lastDate:{type:"object"}}}}}});
O.prototype.init=function(){this.setAggregation("calendar",new C({singleRow:true,weeksPerRow:this.getWeeksPerRow(),monthsPerRow:1,monthsToDisplay:1,dayWidth:48,dayHeight:48,swipeToNavigate:this.getSwipeToNavigate()}));this.getCalendar().attachChangeCurrentDate(this.onCurrentDateChanged,this);this._typeWithBgImages=["04","07"];this._oDaysOverlap={};this._bRtl=sap.ui.getCore().getConfiguration().getRTL();};
O.prototype.onswiperight=function(e){if(this.getSwipeToNavigate()){this.getCalendar().onswiperight(e);}};
O.prototype.onswipeleft=function(e){if(this.getSwipeToNavigate()){this.getCalendar().onswipeleft(e);}};
O.prototype.setSwipeToNavigate=function(s){this.getCalendar().setSwipeToNavigate(s);this.setProperty("swipeToNavigate",s,true);};
O.prototype._getFirstDateDisplayed=function(){var f=this.getCalendar().getFirstDayOffset();var b=this._createDateInDays(this.getStartDate());var i=b.getDate();var e=b.getDay();b.setDate(1);var D=e+1-f;b.setDate(i-D+1);return b;};
O.prototype._getLastDateDisplayed=function(){var w=this.getCalendar().getDays();var W=w.length;var i=this.getCalendar().getWeeksPerRow();var D=i*W;var b=this._getFirstDateDisplayed();var t=this._createDateInDays(b.getTime());t.setDate(t.getDate()+D-1);return t;};
O.prototype.setWeeksPerRow=function(w){this.getCalendar().setWeeksPerRow(w);this.setProperty("weeksPerRow",w);};
O.prototype.getCalendar=function(){return this.getAggregation("calendar");};
O._ctorSafeDate=function(b){var s=b;if(b instanceof U){s=b.getTime();}return s;};
O._getJSDate=function(b){var j=b;if(b instanceof U){j=new Date(b.getTime());}return j;};
O.prototype.setStartDate=function(D){var s=O._ctorSafeDate(D);this.getCalendar().setFirstDayOffset(0);this.getCalendar().setCurrentDate(s);this.setProperty("startDate",s);var o=this._getDaysOffset(this._createDateInDays(s),this._getFirstDateDisplayed());this.getCalendar().setFirstDayOffset(o);};
O.prototype.onCurrentDateChanged=function(e){this.setProperty("startDate",e.getParameter("currentDate"),true);this.getCalendar().invalidate();this._renderCalendarEvents();this.fireChangeDate({firstDate:O._getJSDate(this._getFirstDateDisplayed()),endDate:O._getJSDate(this._getLastDateDisplayed())});};
O.prototype.onBeforeRendering=function(){this._cleanUp();this._aRows=[];this._lastDate=null;this._firstDate=null;var b=this.getCalendarEvents();q.each(b,q.proxy(this._parseCalendarEvent,this));};
O.prototype.onAfterRendering=function(){this._renderCalendarEvents();sap.ui.Device.resize.attachHandler(this._onResize,this);};
O.prototype._onResize=function(){if(this._sDelayedResize){q.sap.clearIntervalCall(this._sDelayedResize);}this._sDelayedResize=q.sap.delayedCall(200,this,this._fireRecomputeElementsSizes);};
O.prototype.exit=function(){this._cleanUp();};
O.prototype._cleanUp=function(){sap.ui.Device.resize.detachHandler(this._onResize,this);};
O.prototype._fireRecomputeElementsSizes=function(){var o=this.$();var e=o.find(".sapMeOverlapCalendarHalfDay");q.merge(e,o.find(".sapMeOverlapCalendarRowLabels"));this._sizeElementsToParent(e);};
O.prototype._getDayId=function(b){var e=this._createDateInDays(this._getFirstDateDisplayed());return this._getDaysOffset(e,this._createDateInDays(b));};
O.prototype._cleanUpDivs=function(){var o=this.$();o.find(".sapMeOverlapCalendarDay").removeClass().addClass("sapMeOverlapCalendarDay");o.find(".sapMeOverlapCalendarHalfDay").remove();o.find(".sapMeOverlapCalendarDay.sapMeOverlapCalendarDayWithHalf").removeClass(".sapMeOverlapCalendarDayWithHalf");o.find(".sapMeOverlapCalendarOverlap").css("background-color","transparent").css("border","none");o.find(".sapMeOverlapCalendarTypeLbl").remove();};
O.prototype._renderCalendarEvents=function(){var i;this._mHalfDays={};this._cleanUpDivs();this._oDaysOverlap={};var b=this.getCalendarEvents();q.each(b,q.proxy(this._renderCalendarEvent,this));q.each(this._mHalfDays,q.proxy(this._renderHalfDayCalendarEvent,this));if(this.getShowOverlapIndicator()){for(i in this._oDaysOverlap){if(this._oDaysOverlap[i]!=undefined&&this._oDaysOverlap[i]>1){var $=q.sap.byId(this._provideId("overlap",i));$.css("background-color",P.get("sapMeOverlapCalendarIndicator"));$.css("border-right","1px solid "+P.get("sapMeOverlapCalendarIndicator"));}}}if(this._firstDate&&this._lastDate){var e=this._getFirstDateDisplayed();e.setDate(e.getDate()+7);var f=this._getLastDateDisplayed();f.setDate(f.getDate()-7);if((this._dayIsBefore(this._lastDate,e))){this.fireEndOfData({before:false});}else if(this._dayIsAfter(this._firstDate,f)){this.fireEndOfData({before:true});}}};
O.prototype._provideId=function(){var s=q.makeArray(arguments).join("-");return this.getId()+"-"+s;};
O.prototype._addToDayOverlap=function(b){if(this._oDaysOverlap[b]==undefined){this._oDaysOverlap[b]=0;}this._oDaysOverlap[b]++;};
O.prototype._getDaysOffset=function(f,s){return Math.abs(this._getRawDaysDifference(f,s));};
O.prototype._getDaysDifference=function(f,s){return this._getRawDaysDifference(f,s);};
O.prototype._getRawDaysDifference=function(f,s){var b=86400000;var e=f.getTime();var g=s.getTime();var h=e-g;return Math.round(h/b);};
O.prototype._dayIsAfter=function(b,e){return(this._getDaysDifference(b,e)>0);};
O.prototype._dayIsBefore=function(b,e){return(this._getDaysDifference(b,e)<0);};
O.prototype._createDateInDays=function(b){var e=O._ctorSafeDate(b);var f=new Date(e);return a.createDate(f.getUTCFullYear(),f.getUTCMonth(),f.getUTCDate());};
O.prototype._sizeElementsToParent=function(e){var b=(e!==null&&e.length)?e.length:0;var $,f;var i,w,h;for(i=0;i<b;i++){$=q(e[i]);if($){f=$.parent();w=f.width();h=f.height();$.width(w).height(h);}}};
O.prototype._renderHalfDayCalendarEvent=function(k,h){var e=h[0];var $=q.sap.byId(k);var t=e.getType();var b=(q.inArray(t,this._typeWithBgImages)>-1);$.addClass("sapMeOverlapCalendarDayWithHalf");var f=q("<div/>");f.addClass("sapMeOverlapCalendarHalfDay").addClass("sapMeOverlapCalendarType"+t+"HalfDayStart");$.append(f);var g=null;if(h.length>1){var i=h[1];var j=i.getType();g=q("<div/>");g.addClass("sapMeOverlapCalendarHalfDay").addClass("sapMeOverlapCalendarType"+j+"HalfDayEnd");}else if(b){g=q("<div/>");g.addClass("sapMeOverlapCalendarHalfDay").addClass("sapMeOverlapCalendarTypeHalfDayEnd");}if(g!==null){$.append(g);}this._sizeElementsToParent([f,g]);};
O.prototype._defineFirstAndLastDates=function(s,e){if(this._lastDate==undefined){this._lastDate=e;}if(this._dayIsAfter(e,this._lastDate)){this._lastDate=e;}if(this._firstDate==undefined){this._firstDate=s;}if(this._dayIsBefore(s,this._firstDate)){this._firstDate=s;}};
O.prototype._renderCalendarEvent=function(i,o){var s=this._createDateInDays(o.getStartDay());var e=this._createDateInDays(o.getEndDay());this._defineFirstAndLastDates(s,e);var b=this._getFirstDateDisplayed();var l=this._getLastDateDisplayed();if((!this._dayIsBefore(e,b))&&(!this._dayIsAfter(s,l))){var r=o.getRow();var f=this._dayIsAfter(s,b)?s:b;e=this._dayIsAfter(e,l)?l:e;var n=this._getDaysOffset(f,e)+1;var g=this._getDaysOffset(b,f);var h="sapMeOverlapCalendarType"+o.getType();var $;var j;if(o.getHalfDay()===true){j=this._getDayId(f);var k=this._provideId(r,j);if(this._mHalfDays[k]==undefined){this._mHalfDays[k]=[];$=q.sap.byId(k);}this._mHalfDays[k].push(o);}else{while(!this._dayIsAfter(f,e)){j=this._getDayId(f);this._addToDayOverlap(j);$=q.sap.byId(this._provideId(r,j));$.addClass(h);f.setDate(f.getDate()+1);}}if($!=undefined){this._createEventLabel(o,f,n,g);}}};
O.prototype._createEventLabel=function(o,b,n,e){var t=o.getTypeName();if(t&&t.length>0){var r=o.getRow();var l=this._provideId(r,this._getDayId(b));var f=this._provideId("row",r,"lbls");var $=q.sap.byId(f);$.width(q.sap.byId(this.getId()).width());var g=this._provideId("lbl",l);if(q.sap.byId(g).length===0){var h=q("<label dir='Inherit' id='"+g+"'>"+t+"</label>");$.append(h);h.addClass("sapMeOverlapCalendarTypeLbl sapMLabel");this._modifyLabel(h,n,e);}}};
O.prototype._modifyLabel=function($,n,b){var e=(100/(this.getCalendar().getWeeksPerRow()*7));var w=(n*e);$.width(w+"%");var o=(b*e);var m=(b==0)?1:0.5;var l=o+"%";if(this._bRtl){$.css("right",l);$.css("padding-right",m+"rem");$.css("text-align","right");}else{$.css("left",l);$.css("padding-left",m+"rem");}};
O.prototype._parseCalendarEvent=function(i,o){var r=o.getRow();if(r!=-1){if(o.getName()!=undefined){if(this._aRows[r]==undefined&&o.getName()!=""){this._aRows[r]=o.getName();}}else{q.sap.log.debug("Calendar event has no name");}}else{q.sap.log.debug("Invalid calendar event row");}};
O.prototype._getLabelForRow=function(i){return this._getLabel(this._aRows[i],"nameLabels").addStyleClass("sapMeOverlapCalendarNameLbl");};
O.prototype._getLabel=function(t,A){var l=new sap.m.Label({text:t});this.addAggregation(A,l,true);return l;};
return O;},true);
sap.ui.predefine('sap/me/OverlapCalendarEvent',['jquery.sap.global','./library','sap/ui/core/Element'],function(q,l,E){"use strict";
var O=E.extend("sap.me.OverlapCalendarEvent",{metadata:{library:"sap.me",properties:{startDay:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},endDay:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},relevant:{type:"boolean",group:"Misc",defaultValue:null,bindable:"bindable"},type:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},typeName:{type:"string",group:"Appearance",defaultValue:null,bindable:"bindable"},halfDay:{type:"boolean",group:"Data",defaultValue:false,bindable:"bindable"},row:{type:"int",group:"Data",defaultValue:-1,bindable:"bindable"},name:{type:"string",group:"Misc",defaultValue:null,bindable:"bindable"}}}});
return O;},true);
sap.ui.predefine('sap/me/OverlapCalendarRenderer',['jquery.sap.global'],function(q){"use strict";var O={};
O.render=function(r,c){if(c.getVisible()==false){return;}r.write("<div");r.writeControlData(c);r.addClass("sapMeOverlapCalendar");r.writeClasses();var w=c.getWidth();if(w!=undefined){r.addStyle("width",w);r.writeStyles();}r.write(">");r.write("<div");r.addClass("sapMeOverlapCalendarCalendar");r.writeClasses();r.write(">");r.renderControl(c.getCalendar());r.write("</div>");r.write("<div");r.addClass("sapMeOverlapCalendarOverlapIndicator");r.writeClasses();r.write(">");var W=7;var a=c.getCalendar().getWeeksPerRow();var d=a*W;var b=new Date(c.getStartDate());var D=(100/d);for(var i=0;i<d;i++){r.write("<div");r.writeAttribute("id",c._provideId("overlap",i));r.addClass("sapMeOverlapCalendarOverlap");r.writeClasses();r.addStyle("width",D+"%");r.writeStyles();r.write("></div>");b.setDate(b.getDate()+1);}r.write("</div>");this._renderGrid(r,c);r.write("</div>");};
O._renderGrid=function(r,c){var w=7;var W=c.getCalendar().getWeeksPerRow();var d=W*w;var a=c._aRows;if(a){var n=a.length;r.write('<div');r.addClass("sapMeOverlapCalendarGrid");r.writeClasses();r.addStyle("width","100%");r.writeStyles();r.write(">");for(var i=0;i<n;i++){if(a[i]!=undefined){this._renderRow(r,c,d,i,new Date(c.getStartDate()));}}r.write('</div>');}};
O._renderRow=function(r,c,d,a,b){var D=(100/d);var e=c.getCalendar().getDayHeight();r.write('<div');r.writeAttribute("id",c._provideId("row",a));r.addClass("sapMeOverlapCalendarRow");r.writeClasses();r.addStyle("height",e+"px");r.writeStyles();r.write(">");r.write('<div');r.writeAttribute("id",c._provideId("row",a,"lbls"));r.addClass("sapMeOverlapCalendarRowLabels");r.writeClasses();r.write(">");r.renderControl(c._getLabelForRow(a));r.write('</div>');for(var i=0;i<d;i++){this._renderDay(r,c,D,e,a,i);b.setDate(b.getDate()+1);}r.write('</div>');};
O._renderDay=function(r,c,d,D,R,i){r.write("<div");r.writeAttribute("id",c._provideId(R,i));r.addClass("sapMeOverlapCalendarDay");r.writeClasses();r.addStyle("width",d+"%");if(D){r.addStyle("height",D+"px");}r.writeStyles();r.write("></div>");};
return O;},true);
sap.ui.predefine('sap/me/ProgressIndicator',['jquery.sap.global','./library','sap/ui/core/Control'],function(q,l,C){"use strict";
var P=C.extend("sap.me.ProgressIndicator",{metadata:{deprecated:true,library:"sap.me",properties:{visible:{type:"boolean",group:"Behavior",defaultValue:true},enabled:{type:"boolean",group:"Behavior",defaultValue:true},barColor:{type:"sap.ui.core.BarColor",group:"Appearance",defaultValue:sap.ui.core.BarColor.NEUTRAL},displayValue:{type:"string",group:"Appearance",defaultValue:'0%'},percentValue:{type:"int",group:"Data",defaultValue:0},showValue:{type:"boolean",group:"Appearance",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'}}}});
P.prototype.setEndBar=function(){var w=this.getPercentValue();var a;var b=this.getBarColor();var t;this.oBar=this.getDomRef("bar");this.oEnd=this.getDomRef("end");this.oBox=this.getDomRef("box");q(this.oEnd).removeClass('sapUIMeProgIndEndHidden');q(this.oEnd).addClass('sapUIMeProgIndEnd');if(w>100){a=(10000/w)+'%';}else{a='100%';}if(w>100){t=(w-100)*20;}else{t=(100-w)*20;}q(this.oBox).animate({width:a},0,'linear');q(this.oEnd).animate({left:a},t,'linear');q(this.oBar).animate({width:w+'%'},t,'linear');if(!this.oThis){this.oThis=this.$();}};
P.prototype.setEndBarGoesBack=function(p){var w=this.getPercentValue();var a;var b=this.getBarColor();var t;this.oBar=this.getDomRef("bar");this.oEnd=this.getDomRef("end");this.oBox=this.getDomRef("box");if(p>100){a=(10000/p)+'%';}else{a='100%';}q(this.oEnd).removeClass('sapUIMeProgIndEnd');q(this.oEnd).addClass('sapUIMeProgIndEndHidden');if(w>100){t=(w-100)*20;}else{t=(100-w)*20;}q(this.oBox).animate({width:a},0,'linear');q(this.oEnd).animate({left:a},t,'linear');q(this.oBar).animate({width:w+'%'},t,'linear');if(!this.oThis){this.oThis=this.$();}};
P.prototype.setPercentValue=function(p){var w=this.getPercentValue();var a;var b=this.getBarColor();this.oBar=this.getDomRef("bar");this.oEnd=this.getDomRef("end");this.oBox=this.getDomRef("box");var t=this;var c;if(p<0){p=0;}if(p>100){a=(10000/p)+'%';}else{a='100%';}if(!this.oBar){c=p*20;this.setProperty('percentValue',p,true);q(this.oBar).animate({width:p+'%'},c,'linear');return this;}if(p>100&&w<=100){c=(100-w)*20;this.setProperty('percentValue',p,true);q(this.oBar).animate({width:'100%'},c,'linear',function(){t.setEndBar();});}else if(p<=100&&w>100){c=(w-100)*20;this.setProperty('percentValue',p,true);q(this.oBar).animate({width:'100%'},c,'linear',function(){t.setEndBarGoesBack();});}else if(p>100&&w>100){if(p>w){c=(p-w)*20;}else{c=(w-p)*20;}a=(10000/p)+'%';this.setProperty('percentValue',p,true);q(this.oBox).animate({width:a},0,'linear');q(this.oEnd).animate({left:a},c,'linear');q(this.oBar).animate({width:p+'%'},c,'linear',function(){});if(!this.oThis){this.oThis=this.$();}}else{if(p>w){c=(p-w)*20;}else{c=(w-p)*20;}this.setProperty('percentValue',p,true);q(this.oBar).animate({width:p+'%'},c,'linear');if(!this.oThis){this.oThis=this.$();}}return this;};
return P;},true);
sap.ui.predefine('sap/me/ProgressIndicatorRenderer',['jquery.sap.global'],function(q){"use strict";var P={};
P.render=function(r,p){var u=new q.sap.Version(sap.ui.getCore().getConfiguration().getCompatibilityVersion("sapMeProgressIndicator"));if(u.compareTo("1.16")>=0){q.sap.log.error("The sap.me.ProgressIndicator control is not supported as of SAPUI5 version 1.16. Please us sap.m.ProgressIndicator instead.");return;}var a=r;var w=p.getWidth();var b=p.getPercentValue();var c;var d;if(!p.getVisible()){return;}if(b>100){c=(10000/b)+'%';}else{c='100%';}a.write('<DIV');a.writeControlData(p);a.writeAttribute('tabIndex','0');if(p.getWidth()&&p.getWidth()!=''){a.writeAttribute('style','width:'+w+';');}if(p.getTooltip_AsString()){a.writeAttributeEscaped('title',p.getDisplayValue()+'- '+p.getTooltip_AsString());}else{a.writeAttributeEscaped('title',p.getDisplayValue());}a.addClass('sapUIMeProgInd');a.writeClasses();a.write('>');a.write('<DIV');a.writeAttribute('id',p.getId()+'-box');if(p.getWidth()&&p.getWidth()!=''){a.writeAttribute('style','width:'+c+';');}a.addClass('sapUIMeProgIndBorder');a.writeClasses();a.write('>');a.write('<DIV');a.writeAttribute('id',p.getId()+'-bar');a.writeAttribute('onselectstart',"return false");a.writeAttribute('style','width:'+p.getPercentValue()+'%;');var B=p.getBarColor();a.addClass("sapUIMeProgIndBar");if(B!=""){a.addClass("sapUIMeProgIndBar"+q.sap.encodeHTML(B));}a.writeClasses();a.write('>');a.write('<DIV');a.writeAttribute('id',p.getId()+'-end');if(b>100){a.addClass('sapUIMeProgIndEnd');}else{a.addClass('sapUIMeProgIndEndHidden');}a.writeClasses();a.writeAttribute('style','position: relative; left:'+c);a.write('>');a.write('</DIV>');a.write('<SPAN');a.addClass('sapUIMeProgIndFont');a.writeClasses();a.write('>');if(p.getShowValue()&&p.getShowValue()==true){if(p.getDisplayValue()&&p.getDisplayValue()!=''){a.writeEscaped(p.getDisplayValue());}}a.write('</SPAN>');a.write('</DIV>');a.write('</DIV>');a.write('</DIV>');};
return P;},true);
sap.ui.predefine('sap/me/TabContainer',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/theming/Parameters'],function(q,l,C,I,P){"use strict";
var T=C.extend("sap.me.TabContainer",{metadata:{deprecated:true,library:"sap.me",properties:{selectedTab:{type:"int",group:"Data",defaultValue:null},badgeInfo:{type:"int",group:"Data",defaultValue:null},badgeNotes:{type:"int",group:"Data",defaultValue:null},badgeAttachments:{type:"int",group:"Data",defaultValue:null},badgePeople:{type:"int",group:"Data",defaultValue:null},expandable:{type:"boolean",group:"Misc",defaultValue:true},expanded:{type:"boolean",group:"Misc",defaultValue:true},visible:{type:"boolean",group:"Misc",defaultValue:true}},aggregations:{tabs:{type:"sap.ui.core.Icon",multiple:true,singularName:"tab",visibility:"hidden"},contentInfo:{type:"sap.ui.core.Control",multiple:false},contentAttachments:{type:"sap.ui.core.Control",multiple:false},contentNotes:{type:"sap.ui.core.Control",multiple:false},contentPeople:{type:"sap.ui.core.Control",multiple:false},badges:{type:"sap.ui.core.Control",multiple:true,singularName:"badge",visibility:"hidden"}},events:{select:{allowPreventDefault:true},expand:{},collapse:{}}}});
T.prototype.init=function(){this.addAggregation("tabs",this._createButton("Info"));this.addAggregation("tabs",this._createButton("Notes"));this.addAggregation("tabs",this._createButton("Attachments"));this.addAggregation("tabs",this._createButton("People"));I.insertFontFaceStyle();this._bFirstRendering=true;};
T.prototype.setBadgeInfo=function(v){this._setBadgeLabelByName("badgeInfo",v);};
T.prototype.setBadgeAttachments=function(v){this._setBadgeLabelByName("badgeAttachments",v);};
T.prototype.setBadgeNotes=function(v){this._setBadgeLabelByName("badgeNotes",v);};
T.prototype.setBadgePeople=function(v){this._setBadgeLabelByName("badgePeople",v);};
T.prototype.onBeforeRendering=function(){if(this.getSelectedTab()==undefined){this.setProperty("selectedTab",0,true);}};
T.prototype._setBadgeLabelByName=function(n,v){var a=sap.ui.getCore().byId(this.getId()+"-"+n);a.setText(v);this.setProperty(n,v);a.toggleStyleClass("sapUIMeTabContainerHiddenBadges",(v==0));};
T.prototype._placeElements=function(){var $=this.$("arrow");var b=this.getAggregation("tabs")[this.getSelectedTab()];if(b&&(b.$().outerWidth()>8)){var L=parseFloat(b.$()[0].offsetLeft)+parseFloat(b.$().outerWidth()/2)-parseFloat($.width()/2);$.css("left",L+"px");}};
T.prototype.onAfterRendering=function(){this.setProperty("expanded",true,true);if(this._bFirstRendering){this._bFirstRendering=false;setTimeout(q.proxy(this._placeElements,this),300);}else{this._placeElements();}};
T.prototype.onThemeChanged=function(){this._placeElements();};
T.prototype.onTransitionEnded=function(){var $=this.$("container");if(this.getExpanded()){this.$("arrow").show();$.css("display","block");this.$().find(".sapUIMeTabContainerContent").removeClass("sapUIMeTabContainerContentClosed");}else{$.css("display","none");this.$().find(".sapUIMeTabContainerContent").addClass("sapUIMeTabContainerContentClosed");}};
T.prototype.toggleExpandCollapse=function(){var e=!this.getExpanded();var $=this.$("container");var a=this.$("arrow");if(e){this.$().find(".sapUIMeTabContainerButtons").children().filter(":eq("+this.getSelectedTab()+")").addClass("sapUIMeTabContainerTabSelected");$.slideDown('400',q.proxy(this.onTransitionEnded,this));this.fireExpand();}else{a.hide();this.$().find(".sapUIMeTabContainerTabSelected").removeClass("sapUIMeTabContainerTabSelected");$.slideUp('400',q.proxy(this.onTransitionEnded,this));this.fireCollapse();}this.setProperty("expanded",e,true);};
T.prototype.onButtonTap=function(e){var b=e.getSource();var i=this.indexOfAggregation("tabs",b);if(i==this.getSelectedTab()&&this.getExpandable()){this.toggleExpandCollapse();}else{this.setProperty("expanded",true,true);var B=b.getId();var c=this._getContentForBtn(B);if(c){if(this.fireSelect()){this.setSelectedTab(i);}}}};
T.prototype._getContentForBtn=function(b){var i=this.getId()+"-";var c=b.substr(b.indexOf(i)+i.length);return this.getAggregation(c);};
T.prototype._getBagdeForBtn=function(b){var i=this.getId()+"-content";var a=b.substr(b.indexOf(i)+i.length);a.charAt(0).toUpperCase();a="badge"+a;return this.getProperty(a);};
T.prototype._getScrollContainer=function(c){return new sap.m.ScrollContainer({content:c});};
T.prototype._createButton=function(i){var s=P.get("sapMeTabIcon"+i);var u=I.getIconURI(s);var c=P.get("sapMeTabColor"+i);var b=new sap.ui.core.Icon(this.getId()+'-content'+i,{src:u,backgroundColor:c,activeColor:P.get("sapUiIconInverted")});b.addStyleClass("sapUIMeTabContainerBtn");b.addStyleClass("sapUIMeTabContainerBtn"+i);b.attachPress(this.onButtonTap,this);var L=new sap.m.Label(this.getId()+'-badge'+i,{textAlign:"Center"});L.addStyleClass("sapUIMeTabContainerBadge");L.addStyleClass("sapUIMeTabContainerBadge"+i);this.addAggregation("badges",L);return b;};
return T;},true);
sap.ui.predefine('sap/me/TabContainerRenderer',['jquery.sap.global'],function(q){"use strict";var T={};
T.render=function(r,c){var u=new q.sap.Version(sap.ui.getCore().getConfiguration().getCompatibilityVersion("sapMeTabContainer"));if(u.compareTo("1.16")>=0){q.sap.log.error("The sap.me.TabContainer control is not supported as of SAPUI5 version 1.16. Please us sap.m.IconTabBar instead.");return;}if(!c.getVisible()){return;}r.write("<div");r.writeControlData(c);r.addClass("sapUIMeTabContainer");r.writeClasses();r.writeStyles();r.write(">");r.write("<div ");r.addClass("sapUIMeTabContainerButtons");r.writeClasses();r.write(">");var b=c.getAggregation("tabs");var I=c.getSelectedTab();var a=c.getAggregation("badges");if(b){if(q.isArray(b)){for(var i=0;i<b.length;i++){var t=b[i].getCustomData();if(c._getContentForBtn(b[i].getId())){r.write("<div ");r.addClass("sapUIMeTabContainerTab");if(i===I){r.addClass("sapUIMeTabContainerTabSelected");}r.writeClasses();r.write(">");if(a&&a[i].getText()!=""){r.renderControl(a[i]);}r.renderControl(b[i]);r.write("</div>");}}}else if(b){r.write("<div ");r.addClass("sapUIMeTabContainerTab");r.writeClasses();r.write(">");if(a&&a[0].getText()!=""){r.renderControl(a[0]);}r.renderControl(b);r.write("</div>");}}r.write("</div>");var C=c._getContentForBtn(b[I].getId());if(C!=undefined){r.write("<div ");r.addClass("sapUIMeTabContainerContent");r.writeClasses();r.write(">");r.write("<div id='"+c.getId()+"-arrow'");r.addClass("sapUIMeTabContainerContentArrow");r.writeClasses();r.write(">");r.write("</div>");r.write("<div id='"+c.getId()+"-container'");r.write(" style='height:auto'");r.addClass("sapUIMeTabContainerTabContent");r.writeClasses();r.write(">");r.renderControl(C);r.write("</div>");r.write("</div>");}r.write("</div>");};
return T;},true);
sap.ui.predefine('sap/me/library',['jquery.sap.global','sap/ui/core/Core','sap/ui/core/library'],function(q,C,l){"use strict";sap.ui.getCore().initLibrary({name:"sap.me",version:"1.42.7",dependencies:["sap.ui.core"],types:["sap.me.CalendarDesign","sap.me.CalendarEventType","sap.me.CalendarSelectionMode"],interfaces:[],controls:["sap.me.Calendar","sap.me.CalendarLegend","sap.me.OverlapCalendar","sap.me.ProgressIndicator","sap.me.TabContainer"],elements:["sap.me.OverlapCalendarEvent"]});sap.me.CalendarDesign={Action:"Action",Approval:"Approval"};sap.me.CalendarEventType={Type00:"Type00",Type01:"Type01",Type04:"Type04",Type06:"Type06",Type07:"Type07",Type10:"Type10"};sap.me.CalendarSelectionMode={SINGLE:"SINGLE",MULTIPLE:"MULTIPLE",RANGE:"RANGE"};return sap.me;},true);
jQuery.sap.registerPreloadedModules({
"name":"sap/me/library-preload",
"version":"2.0",
"modules":{
	"sap/me/manifest.json":'{\n  "_version": "1.2.0",\n  "sap.app": {\n    "_version": "1.2.0",\n    "id": "sap.me",\n    "type": "library",\n    "embeds": [],\n    "applicationVersion": {\n      "version": "1.42.7"\n    },\n    "title": "SAPUI5 library with controls specialized for mobile devices (extension).",\n    "description": "SAPUI5 library with controls specialized for mobile devices (extension).",\n    "ach": "MOB-UIA-LIB-CC",\n    "resources": "resources.json",\n    "offline": true\n  },\n  "sap.ui": {\n    "_version": "1.1.0",\n    "technology": "UI5",\n    "supportedThemes": [\n      "base",\n      "sap_belize",\n      "sap_belize_plus",\n      "sap_bluecrystal",\n      "sap_hcb"\n    ]\n  },\n  "sap.ui5": {\n    "_version": "1.1.0",\n    "dependencies": {\n      "minUI5Version": "1.42",\n      "libs": {\n        "sap.ui.core": {\n          "minVersion": "1.42.7"\n        }\n      }\n    }\n  }\n}'
}});
