/*
 * ! SAP UI development toolkit for HTML5 (SAPUI5)

(c) Copyright 2009-2016 SAP SE. All rights reserved
 */
sap.ui.predefine('sap/ui/rta/RuntimeAuthoring',['jquery.sap.global','sap/ui/base/ManagedObject','sap/ui/rta/ui/ToolsMenu','sap/ui/dt/ElementUtil','sap/ui/dt/DesignTime','sap/ui/dt/OverlayRegistry','sap/ui/dt/Overlay','sap/ui/rta/command/Stack','sap/ui/rta/command/CommandFactory','sap/ui/rta/plugin/Rename','sap/ui/rta/plugin/DragDrop','sap/ui/rta/plugin/RTAElementMover','sap/ui/dt/plugin/CutPaste','sap/ui/rta/plugin/Remove','sap/ui/rta/plugin/Selection','sap/ui/rta/plugin/MultiSelection','sap/ui/dt/plugin/ContextMenu','sap/ui/dt/plugin/TabHandling','sap/ui/fl/FlexControllerFactory','sap/ui/rta/ui/SettingsDialog','sap/ui/rta/ui/AddElementsDialog','./Utils','sap/ui/fl/transport/Transports','sap/ui/fl/transport/TransportSelection','sap/ui/fl/Utils','sap/ui/fl/registry/Settings','sap/m/MessageBox','sap/m/MessageToast','sap/ui/rta/controlAnalyzer/ControlAnalyzerFactory'],function(q,M,T,E,D,O,a,C,b,R,c,d,e,f,S,g,h,j,F,k,A,U,l,m,n,o,p,r,s){"use strict";
var t=M.extend("sap.ui.rta.RuntimeAuthoring",{
metadata:{library:"sap.ui.rta",associations:{"rootControl":{type:"sap.ui.core.Control"}},properties:{"customFieldUrl":"string","showCreateCustomField":"boolean","showToolbars":{type:"boolean",defaultValue:true},"showSettingsDialog":{type:"boolean",defaultValue:true},"showWindowUnloadDialog":{type:"boolean",defaultValue:true},"commandStack":{type:"sap.ui.rta.command.Stack"}},events:{"start":{},"stop":{},"failed":{},"selectionChange":{parameters:{selection:{type:"sap.ui.dt.Overlay[]"}}},"undoRedoStackModified":{}}},
_sAppTitle:null
});
t.prototype.init=function(){this._onCommandStackModified=this._adaptUndoRedoButtons.bind(this);};
t.prototype.start=function(){var i=["sap.ui.comp.smartform.Group","sap.ui.comp.smartform.GroupElement","sap.ui.table.Column","sap.uxap.ObjectPageSection","sap.ui.layout.form.FormElement","sap.ui.layout.form.FormContainer"];var N=this;this._aPopups=[];this._oTextResources=sap.ui.getCore().getLibraryResourceBundle("sap.ui.rta");this._aSupportedControls=["sap.ui.comp.smartform.Group","sap.uxap.ObjectPageSection","sap.uxap.ObjectPageLayout"];if(!this._oDesignTime){this._oRootControl=sap.ui.getCore().byId(this.getRootControl());this._oRTAElementMover=new d({movableTypes:i});this._oRTAElementMover.setCommandFactory(b);this._oRTADragDropPlugin=new c({draggableTypes:i,elementMover:this._oRTAElementMover,commandFactory:b}).attachElementModified(this._handleElementModified,this);this._oRTADragDropPlugin.attachDragStarted(this._handleStopCutPaste,this);this._oCutPastePlugin=new e({movableTypes:i,elementMover:this._oRTAElementMover,commandFactory:b}).attachElementModified(this._handleElementModified,this);this._oRemovePlugin=new f({commandFactory:b}).attachElementModified(this._handleElementModified,this);this._oRenamePlugin=new R({commandStack:this.getCommandStack()});this._oRenamePlugin.attachEditable(this._handleStopCutPaste,this);this._oSelectionPlugin=new S();this._oMultiSelectionPlugin=new g({multiSelectionTypes:["sap.ui.comp.smartform.GroupElement"]});this._oContextMenuPlugin=new h();this._oTabHandlingPlugin=new j();this._buildContextMenu();q.sap.measure.start("rta.dt.startup","Measurement of RTA: DesignTime start up");this._oDesignTime=new D({rootElements:[this._oRootControl],plugins:[this._oRTADragDropPlugin,this._oCutPastePlugin,this._oRemovePlugin,this._oRenamePlugin,this._oSelectionPlugin,this._oMultiSelectionPlugin,this._oContextMenuPlugin,this._oTabHandlingPlugin]});q(a.getOverlayContainer()).addClass("sapUiRta");this._oDesignTime.attachSelectionChange(function(Q){N.fireSelectionChange({selection:Q.getParameter("selection")});},this);this._oDesignTime.attachEventOnce("synced",function(){N.fireStart();q.sap.measure.end("rta.dt.startup","Measurement of RTA: DesignTime start up");});this._oDesignTime.attachEventOnce("syncFailed",function(){N.fireFailed();});}if(this.getShowToolbars()){this._createToolsMenu();var P={"onAfterRendering":function(){this._oToolsMenu._oToolBar.focus();this._oToolsMenu._oToolBar.removeEventDelegate(P,this);}};this._oToolsMenu._oToolBar.addEventDelegate(P,this);this._oToolsMenu.show();}this._oldUnloadHandler=window.onbeforeunload;window.onbeforeunload=this._onUnload.bind(this);};
t.prototype.setCommandStack=function(i){var N=this.getProperty("commandStack");if(N){N.detachModified(this._onCommandStackModified);}if(this._oInternalCommandStack){this._oInternalCommandStack.destroy();delete this._oInternalCommandStack;}var P=this.setProperty("commandStack",i);if(i){i.attachModified(this._onCommandStackModified);}if(this._oRenamePlugin){this._oRenamePlugin.setCommandStack(i);}return P;};
t.prototype.getCommandStack=function(){var i=this.getProperty("commandStack");if(!i){i=new C();this._oInternalCommandStack=i;}this.setCommandStack(i);return i;};
t.prototype._adaptUndoRedoButtons=function(){var i=this.getCommandStack();this._oToolsMenu.adaptUndoRedoEnablement(i.canUndo(),i.canRedo());this.fireUndoRedoStackModified();};
t.prototype.closeToolBars=function(){this._oToolsMenu.hide();};
t.prototype.getSelection=function(){if(this._oDesignTime){return this._oDesignTime.getSelection();}else{return[];}};
t.prototype.stop=function(){var i=this;return this._serializeToLrep().then(function(){i.exit();i.fireStop();});};
t.prototype.restore=function(){this._onRestore();};
t.prototype.transport=function(){this._onTransport();};
t.prototype.undo=function(){this._onUndo();};
t.prototype.redo=function(){this._onRedo();};
t.prototype.canUndo=function(){return this.getCommandStack().canUndo();};
t.prototype.canRedo=function(){return this.getCommandStack().canRedo();};
t.prototype._onUnload=function(){var i=this.getCommandStack();var N=i.canUndo()||i.canRedo();if(N&&this.getShowWindowUnloadDialog()){var P=this._oTextResources.getText("MSG_UNSAVED_CHANGES");return P;}else{window.onbeforeunload=this._oldUnloadHandler;}};
t.prototype._serializeToLrep=function(){var N=this.getCommandStack();var P=F.createForControl(this._oRootControl);var Q=N.getSerializableCommands();Q.forEach(function(W,i){var X=W.getElement();var Y=W.getPreparedActionData();if(Y){P.addPreparedChange(Y.change||Y,X);}else{P.addChange(W.serialize(),X);}});var V=this;return P.saveAll().then(function(){q.sap.log.info("Runtime adaptation successfully transfered changes to layered repository");V.getCommandStack().removeAllCommands();},function(i){var W=i.message||i.status||i;q.sap.log.error("Failed to transfer runtime adaptation changes to layered repository",W);q.sap.require("sap.m.MessageBox");var X=V._oTextResources.getText("MSG_LREP_TRANSFER_ERROR")+"\n"+V._oTextResources.getText("MSG_ERROR_REASON",W);sap.m.MessageBox.error(X);});};
t.prototype._onUndo=function(){this._handleStopCutPaste();this.getCommandStack().undo();};
t.prototype._onRedo=function(){this._handleStopCutPaste();this.getCommandStack().redo();};
t.prototype._createToolsMenu=function(){var i=this;if(!this._oToolsMenu){this._sAppTitle=this._getApplicationTitle();this._oToolsMenu=new T();this._oToolsMenu.createToolbar();this._oToolsMenu.setTitle(this._sAppTitle);this._oToolsMenu.setRootControl(this._oRootControl);this._oToolsMenu._checkTransportAvailable().then(function(N){i._bATOTransportEnabled=N;});this._oToolsMenu.attachToolbarClose(this.closeToolBars,this);this._oToolsMenu.attachClose(this.stop,this);this._oToolsMenu.attachTransport(this._onTransport,this);this._oToolsMenu.attachRestore(this._onRestore,this);this._oToolsMenu.attachUndo(this._onUndo,this);this._oToolsMenu.attachRedo(this._onRedo,this);}};
t.prototype.exit=function(){if(this._oDesignTime){q(a.getOverlayContainer()).removeClass("sapUiRta");this._oDesignTime.destroy();this._oDesignTime=null;}if(this._oToolsMenu){this._oToolsMenu.destroy();this._oToolsMenu=null;}this.setCommandStack(null);window.onbeforeunload=this._oldUnloadHandler;};
t.prototype._onTransport=function(){var i=this;var N=F.createForControl(this._oRootControl);function P(W){n.log.error("Changes could not be applied or saved: "+W);return i._showMessage(p.Icon.ERROR,"HEADER_TRANSPORT_APPLYSAVE_ERROR","MSG_TRANSPORT_APPLYSAVE_ERROR",W).then(function(){throw new Error('createAndApply failed');});}function Q(W){if(W.message==='createAndApply failed'){return;}n.log.error("transport error"+W);return i._showMessage(p.Icon.ERROR,"HEADER_TRANSPORT_ERROR","MSG_TRANSPORT_ERROR",W);}this._handleStopCutPaste();var V=new m();return this._serializeToLrep().then(function(){return N.getComponentChanges().then(function(W){if(W.length>0){return i._createAndApplyChanges(W,N);}})['catch'](P).then(function(){return N.getComponentChanges();}).then(function(W){return!!W.length;}).then(function(W){if(W){return V.openTransportSelection(null,i._oRootControl);}else{i._showMessageToast("MSG_TRANSPORT_SUCCESS");}}).then(function(W){if(W&&W.transport&&W.packageName!=="$TMP"){return i._transportAllLocalChanges(W,N);}})['catch'](Q);});};
t.prototype._createAndApplyChanges=function(i,N){var P=this;return Promise.resolve().then(function(){function V(Q){return Q&&Q.selector&&Q.selector.id;}i.filter(V).forEach(function(Q){var W=sap.ui.getCore().byId(Q.selector.id);N.createAndApplyChange(Q,W);});})['catch'](function(Q){n.log.error("Create and apply error: "+Q);return Q;}).then(function(Q){return N.saveAll().then(function(){if(Q){throw Q;}});})['catch'](function(Q){n.log.error("Create and apply and/or save error: "+Q);return P._showMessage(p.Icon.ERROR,"HEADER_TRANSPORT_APPLYSAVE_ERROR","MSG_TRANSPORT_APPLYSAVE_ERROR",Q);});};
t.prototype._deleteChanges=function(){var i=this;var N=new m();var P=F.createForControl(this._oRootControl);P.getComponentChanges().then(function(Q){return o.getInstance(n.getComponentClassName(i._oRootControl)).then(function(V){if(!V.isProductiveSystem()&&!V.hasMergeErrorOccured()){return N.setTransports(Q,i._oRootControl);}}).then(function(){return P.discardChanges(Q);}).then(function(){return window.location.reload();});})["catch"](function(Q){return i._showMessage(p.Icon.ERROR,"HEADER_RESTORE_FAILED","MSG_RESTORE_FAILED",Q);});};
t.prototype._showMessage=function(i,N,P,Q){if(Q){var V=this._oTextResources.getText(P,[Q.message||Q]);}else{var V=this._oTextResources.getText(P);}var W=this._oTextResources.getText(N);return new Promise(function(X){p.show(V,{icon:i,title:W,onClose:X});});};
t.prototype._showMessageToast=function(i){var N=this._oTextResources.getText(i);r.show(N);};
t.needsRestart=function(){var i=!!window.localStorage.getItem("sap.ui.rta.restart");return i;};
t.enableRestart=function(){window.localStorage.setItem("sap.ui.rta.restart",true);};
t.disableRestart=function(){window.localStorage.removeItem("sap.ui.rta.restart");};
t.prototype._onRestore=function(){var i=this;var N=this._oTextResources.getText("FORM_PERS_RESET_MESSAGE");var P=this._oTextResources.getText("FORM_PERS_RESET_TITLE");this._handleStopCutPaste();function Q(V){if(V==="OK"){i.getCommandStack().removeAllCommands();t.enableRestart();i._deleteChanges();}}p.confirm(N,{icon:p.Icon.WARNING,title:P,onClose:Q});};
t.prototype._transportAllLocalChanges=function(i,N){var P=this;return N.getComponentChanges().then(function(Q){var V=new l();var W=V._convertToChangeTransportData(Q);var X={};X.transportId=i.transport;X.changeIds=W;return V.makeChangesTransportable(X).then(function(){Q.forEach(function(Y){if(Y.getPackage()==='$TMP'){var Z=Y.getDefinition();Z.packageName='';Y.setResponse(Z);}});}).then(function(){P._showMessageToast("MSG_TRANSPORT_SUCCESS");});});};
t.prototype._isEqualParentInfo=function(i,N){var P=!!i&&!!N;if(P&&(i.parent&&N.parent)){P=i.parent.getId()===N.parent.getId();}if(P&&(i.index||N.index)){P=i.index===N.index;}if(P&&(i.aggregation||N.aggregation)){P=i.aggregation===N.aggregation;}return P;};
t.prototype._handleElementModified=function(i){this._handleStopCutPaste();var N=i.getParameter("command");if(N instanceof sap.ui.rta.command.BaseCommand){this.getCommandStack().pushAndExecute(N);}};
t.prototype._handleRemoveElement=function(i){this._oRemovePlugin.removeElement(i);};
t.prototype._openSettingsDialog=function(i){var N=(i.mParameters)?i.getParameter("selectedOverlays"):i;var P=N[0].getElementInstance();this._handleStopCutPaste();if(!this._oSettingsDialog){this._oSettingsDialog=new k();}this._oSettingsDialog.setCommandStack(this.getCommandStack());this._oSettingsDialog.open(P);};
var u=function(i){return this._oDesignTime.getSelection().length<2;};var H=function(i){var N=i.getElementInstance();return s.getControlAnalyzerFor(N).hasParentStableId(i);};var I=function(i){return i.getMovable();};var v=function(i){return i.getElementInstance().getMetadata().getName()==="sap.ui.comp.smartform.GroupElement";};var w=function(i){return i.getElementInstance().getMetadata().getName()==="sap.ui.comp.smartform.Group";};var x=function(i){var N=i.getElementInstance();var P=s.getControlAnalyzerFor(N);if(P._getSimpleFormContainer){return!!P._getSimpleFormContainer(N);}else{return false;}};var y=function(i){return i.getElementInstance().getMetadata().getName()==="sap.ui.comp.smartform.SmartForm";};var z=function(i){var N=i.getElementInstance();return N.getMetadata().getName()==="sap.uxap.ObjectPageSection";};var B=function(i){var N=i.getElementInstance();return N.getMetadata().getName()==="sap.uxap.ObjectPageLayout";};var G=function(i){return this._oRemovePlugin.isRemoveAvailable(i);};var J=function(i){return this._oRemovePlugin.isRemoveEnabled(i);};var K=function(i){return this._oRenamePlugin.isRenameAvailable(i);};var L=function(i){return this._oRenamePlugin.isRenameEnabled(i);};
t.prototype._buildContextMenu=function(){var i=this;this._oContextMenuPlugin.addMenuItem({id:"CTX_RENAME_LABEL",text:i._oTextResources.getText("CTX_RENAME"),handler:this._handleRename.bind(this),available:K.bind(this),enabled:function(N){return(u.call(i,N)&&L.call(i,N));}});this._oContextMenuPlugin.addMenuItem({id:"CTX_ADD_FORM_FIELD",text:i._oTextResources.getText("CTX_ADD_FIELD"),handler:this._handleAddElement.bind(this),available:function(N){var P=N.getElementInstance();return x(N)&&((E.isInstanceOf(P,"sap.ui.layout.form.FormElement"))||(E.isInstanceOf(P,"sap.ui.layout.form.FormContainer")&&P.getTitle()!==null)||(E.isInstanceOf(P,"sap.ui.layout.form.FormContainer")&&P.getToolbar()!==null));},enabled:H});this._oContextMenuPlugin.addMenuItem({id:"CTX_ADD_FIELD",text:i._oTextResources.getText("CTX_ADD_FIELD"),handler:this._handleAddElement.bind(this),available:function(N){return w(N)||v(N);},enabled:function(N){return u.call(i,N)&&(w(N)||H(N));}});this._oContextMenuPlugin.addMenuItem({id:"CTX_ADD_FORM_GROUP",text:i._oTextResources.getText("CTX_ADD_GROUP"),handler:this._handleAddGroup.bind(this),available:function(N){var P=N.getElementInstance();return x(N)&&!E.isInstanceOf(P,"sap.ui.layout.form.FormElement");},enabled:H});this._oContextMenuPlugin.addMenuItem({id:"CTX_ADD_GROUP",text:i._oTextResources.getText("CTX_ADD_GROUP"),handler:this._handleAddGroup.bind(this),available:function(N){return w(N)||y(N);},enabled:function(N){return y(N)||(w(N)&&H(N));}});this._oContextMenuPlugin.addMenuItem({id:"CTX_ADD_SECTION",text:i._oTextResources.getText("CTX_ADD_SECTION"),handler:this._handleAddElement.bind(this),available:function(N){return z(N)||B(N);},enabled:function(N){return U.hasObjectPageLayoutInvisibleSections.bind(U)&&(B(N)||H(N));}});this._oContextMenuPlugin.addMenuItem({id:"CTX_REMOVE",text:i._oTextResources.getText("CTX_REMOVE"),handler:this._handleRemoveElement.bind(this),available:G.bind(this),enabled:J.bind(this)});this._oContextMenuPlugin.addMenuItem({id:"CTX_CUT",text:i._oTextResources.getText("CTX_CUT"),handler:this._handleCutElement.bind(this),available:I});this._oContextMenuPlugin.addMenuItem({id:"CTX_PASTE",text:i._oTextResources.getText("CTX_PASTE"),handler:this._handlePasteElement.bind(this),available:I,enabled:function(N){return i._oCutPastePlugin.isElementPasteable(N);}});this._oContextMenuPlugin.addMenuItem({id:"CTX_GROUP_FIELDS",text:i._oTextResources.getText("CTX_GROUP_FIELDS"),handler:this._handleGroupElements.bind(this),available:function(){var N=i._oDesignTime.getSelection();return(N.length>1);},enabled:function(){var N=true;var P=[];var Q=i._oDesignTime.getSelection();Q.forEach(function(V){var W=V.getElementInstance();P=P.concat(W.getFields());});if(Q.length>3||P.length>3){return false;}Q.some(function(V){var W=V.getElementInstance();if(U.hasGroupElementUnBoundFields(W)){N=false;return true;}});return N;}});this._oContextMenuPlugin.addMenuItem({id:"CTX_UNGROUP_FIELDS",text:i._oTextResources.getText("CTX_UNGROUP_FIELDS"),handler:this._handleUngroupElements.bind(this),available:function(N){var P=N.getElementInstance();var Q=i._oDesignTime.getSelection();return v(N)&&P.getFields().length>1&&Q.length<2;},enabled:function(N){var P=N.getElementInstance();return!U.hasGroupElementUnBoundFields(P);}});this._oContextMenuPlugin.addMenuItem({id:"CTX_SETTINGS",text:"Settings",handler:this._openSettingsDialog.bind(this),available:function(N){var P=N.getElementInstance();if(n.isVendorLayer()&&i.getShowSettingsDialog()){var Q=["sap.ui.comp.smartfilterbar.SmartFilterBar","sap.ui.comp.smarttable.SmartTable","sap.ui.comp.smartform.SmartForm","sap.uxap.ObjectPageLayout","sap.uxap.ObjectPageSection","sap.uxap.ObjectPageHeaderActionButton","sap.uxap.ObjectPageHeader","sap.ui.table.Column"];return Q.some(function(V){return E.isInstanceOf(P,V);});}}});};
t.prototype._handleRename=function(i){var N=i[0];this._oRenamePlugin.startEdit(N);};
t.prototype._handleAddElement=function(i){this._handleStopCutPaste();var N=i[0].getElementInstance();if(!this._oAddElementsDialog){this._oAddElementsDialog=new A({rootControl:this._oRootControl});}this._oAddElementsDialog.setCommandStack(this.getCommandStack());this._oAddElementsDialog.open(N);};
t.prototype._handleCutElement=function(i){var N=i[0];this._oCutPastePlugin.cut(N);};
t.prototype._handlePasteElement=function(i){var N=i[0];this._oCutPastePlugin.paste(N);};
t.prototype._handleStopCutPaste=function(){this._oCutPastePlugin.stopCutAndPaste();};
t.prototype._handleGroupElements=function(){this._handleStopCutPaste();var N=this._oDesignTime.getSelection();var P=this._oContextMenuPlugin.getContextElement();var Q=U.getClosestTypeForControl(P,"sap.ui.comp.smartform.Group");var V=Q.getGroupElements().indexOf(P);var W=U.findSupportedBlock(P,this._aSupportedControls);var X=U.getClosestTypeForControl(P,"sap.ui.comp.smartform.SmartForm");var Y=[];for(var i=0;i<N.length;i++){var Z=N[i].getElementInstance();Y.push(Z);}var $=b.getCommandFor(W,"Group",{source:P,index:V,groupFields:Y,smartForm:X});this.getCommandStack().pushAndExecute($);};
t.prototype._handleUngroupElements=function(){this._handleStopCutPaste();var i=this._oContextMenuPlugin.getContextElement();var N=U.getClosestTypeForControl(i,"sap.ui.comp.smartform.SmartForm");var P=b.getCommandFor(i,"Ungroup",{smartForm:N});this.getCommandStack().pushAndExecute(P);};
t.prototype._handleAddGroup=function(i){this._handleStopCutPaste();var N=this;var P=i[0].getElementInstance();var V=n.getViewForControl(P);var Q=s.getControlAnalyzerFor(P);var W=Q.getClosestType(P);var X=0;X=Q._determineGroupIndex(P);var Y=b.getCommandFor(W,"Add",{newControlId:V.createId(q.sap.uid()),labels:["New Group"],index:X});this.getCommandStack().pushAndExecute(Y);var Z;if(Y._getParentElementId){Z=O.getOverlay(Y._getParentElementId());}else{Z=O.getOverlay(Y.getNewControlId());}Z.setSelected(true);var $={"onAfterRendering":function(){setTimeout(function(){N._oRenamePlugin.startEdit(Z);},0);Z.removeEventDelegate($);}};Z.addEventDelegate($);};
t.prototype._getSmartFormForElement=function(i){while(i&&!E.isInstanceOf(i,"sap.ui.comp.smartform.SmartForm")){i=i.getParent();}return i;};
t.prototype._getApplicationTitle=function(){var i="";var N=sap.ui.core.Component.getOwnerComponentFor(this._oRootControl);if(N){i=N.getMetadata().getManifestEntry("sap.app").title;}return i;};
return t;},true);
sap.ui.predefine('sap/ui/rta/command/AddSimple',['jquery.sap.global','sap/ui/rta/command/FlexCommand','sap/ui/rta/controlAnalyzer/ControlAnalyzerFactory'],function(q,F,C){"use strict";
var A=F.extend("sap.ui.rta.command.AddSimple",{metadata:{library:"sap.ui.rta",properties:{source:{type:"object"},index:{type:"number"},newControlId:{type:"string"},labels:{type:"array"}},associations:{},events:{}}});
A.prototype._getSpecificChangeInfo=function(){var s={changeType:this.getChangeType(),selector:{id:this._getElement().getId()},index:this.getIndex(),newControlId:this.getNewControlId(),labels:this.getLabels()};var c=C.getControlAnalyzerFor(this._getElement());if(c){s=c.mapSpecificChangeData("Add",s);}return s;};
A.prototype._getFlexChange=function(){var s=this._getSpecificChangeInfo();var c=this._completeChangeContent(s);return{change:c,selectorElement:this._getElement()};};
A.prototype._getParentElementId=function(){var t=sap.ui.getCore().byId(this.getNewControlId());var p=t.getParent().getId();return p;};
A.prototype._getForwardActionData=function(e){return this._getFlexChange();};
A.prototype.undo=function(){var a=this.getNewControlId();var o=sap.ui.getCore().byId(a);if(o){o.destroy();}};
A.prototype.serialize=function(){return this._getSpecificChangeInfo();};
return A;},true);
sap.ui.predefine('sap/ui/rta/command/AddSmart',['jquery.sap.global','sap/ui/rta/command/FlexCommand','sap/ui/rta/controlAnalyzer/ControlAnalyzerFactory'],function(q,F,C){"use strict";
var A=F.extend("sap.ui.rta.command.AddSmart",{metadata:{library:"sap.ui.rta",properties:{source:{type:"object"},index:{type:"number"},newControlId:{type:"string"},labels:{type:"array"},jsTypes:{type:"array"},fieldValues:{type:"array"},valuePropertys:{type:"array"}},associations:{},events:{}}});
A.prototype._getSpecificChangeInfo=function(){var s={changeType:this.getChangeType(),index:this.getIndex(),newControlId:this.getNewControlId(),labels:this.getLabels()};if(this.getJsTypes()){s.jsTypes=this.getJsTypes();}if(this.getFieldValues()){s.fieldValues=this.getFieldValues();}if(this.getValuePropertys()){s.valueProperty=this.getValuePropertys();}var c=C.getControlAnalyzerFor(this._getElement());if(c){s=c.mapSpecificChangeData("Add",s);}return s;};
A.prototype._getFlexChange=function(){var s=this._getSpecificChangeInfo();var c=this._completeChangeContent(s);return{change:c,selectorElement:this._getElement()};};
A.prototype._getForwardActionData=function(e){return this._getFlexChange();};
A.prototype.undo=function(){var a=this.getNewControlId();var o=sap.ui.getCore().byId(a);if(o){o.destroy();}};
A.prototype.serialize=function(){return this._getSpecificChangeInfo();};
return A;},true);
sap.ui.predefine('sap/ui/rta/command/BindProperty',['sap/ui/rta/command/FlexCommand',"sap/ui/fl/changeHandler/PropertyBindingChange","sap/ui/rta/Utils"],function(F,P,U){"use strict";
var B=F.extend("sap.ui.rta.command.BindProperty",{metadata:{library:"sap.ui.rta",properties:{propertyName:{type:"string"},newBinding:{type:"string",bindable:false},oldValue:{type:"any"},oldBinding:{type:"string"},changeType:{type:"string",defaultValue:"propertyBindingChange"}},associations:{},events:{}}});
B.prototype.init=function(){this.setChangeHandler(P);};
B.FORWARD=true;B.BACKWARD=false;
B.prototype.bindProperty=function(n,b){if(n==="newBinding"){return this.setNewBinding(b.bindingString);}if(n==="oldBinding"){return this.setOldBinding(b.bindingString);}return F.prototype.bindProperty.apply(this,arguments);};
B.prototype._ensureOld=function(){if((this.getOldValue()===undefined)&&(this.getOldBinding()===undefined)){var e=this._getElement();var b=e.getBindingInfo(this.getPropertyName());if(b&&b.bindingString){this.setOldBinding(b.bindingString);}else{var o=U.getPropertyValue(e,this.getPropertyName());this.setOldValue(o);}}};
B.prototype._getOld=function(){if(this.getOldValue()==="undefined"){return this.getOldValue();}else{return this.getOldBinding();}};
B.prototype._getSpecificChangeInfo=function(f){var e=this._getElement();this._ensureOld();var s={changeType:this.getChangeType(),selector:{id:e.getId(),type:e.getMetadata().getName()},content:{property:this.getPropertyName(),newBinding:f?this.getNewBinding():this._getOld()}};if(f&&typeof this.getOldValue()!=="undefined"){s.content.oldValue=this.getOldValue();}else{s.content.oldBinding=f?this.getOldBinding():this.getNewBinding();}return s;};
B.prototype._getFlexChange=function(f){var s=this._getSpecificChangeInfo(f);var c=this._completeChangeContent(s);return{change:c,selectorElement:this._getElement()};};
B.prototype._getForwardActionData=function(e){return this._getFlexChange(B.FORWARD);};
B.prototype._getBackwardActionData=function(e){return this._getFlexChange(B.BACKWARD);};
B.prototype.serialize=function(){return this._getSpecificChangeInfo(B.FORWARD);};
return B;},true);
sap.ui.predefine('sap/ui/rta/command/Group',['sap/ui/rta/command/BaseCommand','sap/ui/rta/Utils','sap/ui/rta/controlAnalyzer/ControlAnalyzerFactory','sap/ui/dt/ElementDesignTimeMetadata'],function(B,U,C,E){"use strict";
var G=B.extend("sap.ui.rta.command.Group",{metadata:{library:"sap.ui.rta",properties:{source:{type:"object"},index:{type:"number"},labels:{type:"array"},jsTypes:{type:"array"},fieldValues:{type:"array"},valuePropertys:{type:"array"},groupFields:{type:"array"},smartForm:{type:"object"}},associations:{},events:{}}});
G.prototype.init=function(){this._aCommands=[];this._aOdataFields=[];};
G.prototype.undo=function(){this._updateElement();for(var i=0;i<this._aCommands.length;i++){this._aCommands[i].undo();}this.getElement().destroy();};
G.prototype.execute=function(){var t=this;return this._createGroupCommands().then(function(){for(var i=0;i<t._aCommands.length;i++){t._aCommands[i].execute();}});};
G.prototype.getCommands=function(){return this._aCommands;};
G.prototype.serialize=function(){var s=[];for(var i=0;i<this._aCommands.length;i++){s.push(this._aCommands[i].serialize());}return s;};
G.prototype._updateElement=function(){var t=this;sap.ui.getCore().applyChanges();var p=this._aOdataFields.map(function(f){return t._getBindingPath(f);});var e=U.createNewSmartFormGroupElementId(this.getSmartForm(),p);this.setElement(sap.ui.getCore().byId(e));};
G.prototype._createGroupCommands=function(){if(this._aCommands.length>0){return Promise.resolve();}var t=this;var s=sap.ui.rta.controlAnalyzer.ControlAnalyzerFactory.getControlAnalyzerFor(this.getSmartForm());var g=this.getGroupFields();return s.prepare().then(function(){var J=[];var f=[];var F=[];var a=[];var h=s.getHiddenElements();t._aOdataFields=[];for(var i=0;i<g.length;i++){var b=g[i].getFields();for(var z=0;z<b.length;z++){var o=b[z];var p=U.getElementBindingPaths(o);var c=U.findFieldBindingPathInFieldsArray(p,h);var d=h[c];var P=t._getBindingPath(d);t._aOdataFields.push(d);J.push(o.getMetadata().getName());f.push(d["fieldLabel"]);F.push(P);a.push(p[c].valueProperty);}var e=sap.ui.rta.command.CommandFactory.getCommandFor(g[i],"Hide");t._aCommands.push(e);}var n=U.createNewSmartFormGroupElementId(t.getSmartForm(),F);if(sap.ui.getCore().byId(n)){var k=sap.ui.getCore().byId(n);var l=k.getParent();return l.getMetadata().loadDesignTime().then(function(){var D=l.getMetadata().getDesignTime();var m=sap.ui.rta.command.CommandFactory.getCommandFor(k,"Unhide");var q=sap.ui.rta.command.CommandFactory.getCommandFor(l,"Move",{movedElements:[{element:k,sourceIndex:0,targetIndex:t.getIndex()}],target:{publicAggregation:"formElements",aggregation:"formElements",parent:l},source:{publicAggregation:"formElements",aggregation:"formElements",parent:l}},new E({data:D}));var N;for(var j=0;j<f.length;j++){N=N?N+"/"+f[j]:f[j];}var r=sap.ui.rta.command.CommandFactory.getCommandFor(k,"Rename",{newValue:N});t._aCommands.push(r);t._aCommands.push(m);t._aCommands.push(q);});}else{t._aCommands.push(U.createNewAddFieldsCommand(t.getSmartForm(),t.getSource().getParent(),t.getIndex(),J,f,a,F));}});};
G.prototype._getBindingPath=function(d){var p="";if(d.isComplexProperty){p=d.complexTypePropertyName+"/"+d.name;}else{p=d.name;}return p;};
return G;},true);
sap.ui.predefine('sap/ui/rta/command/Hide',['sap/ui/rta/command/FlexCommand',"sap/ui/fl/changeHandler/HideControl"],function(F,H){"use strict";
var a=F.extend("sap.ui.rta.command.Hide",{metadata:{library:"sap.ui.rta",properties:{changeType:{type:"string",defaultValue:"hideControl"}},associations:{},events:{}}});
a.prototype.init=function(){this.setChangeHandler(H);};
a.prototype._undoWithElement=function(e){e.setVisible(true);};
a.prototype.serialize=function(){return{changeType:this.getChangeType(),selector:{id:this._getElement().getId()}};};
return a;},true);
sap.ui.predefine('sap/ui/rta/command/HideForm',['sap/ui/rta/command/FlexCommand','sap/ui/rta/command/Hide',"sap/ui/fl/changeHandler/HideControl"],function(F,H,a){"use strict";
var b=H.extend("sap.ui.rta.command.HideForm",{metadata:{library:"sap.ui.rta",properties:{originalElement:{type:"object"},changeType:{type:"string",defaultValue:"hideControl"},groupId:{type:"string"},groupIndex:{type:"integer"},nextGroupIndex:{type:"integer",defaultValue:-1},fields:{type:"array"}},associations:{},events:{}}});
b.FORWARD=true;b.BACKWARD=false;
b.prototype.init=function(){};
b.prototype._getSpecificChangeInfo=function(f){var e=this.getElement();var o=this.getOriginalElement();var s={};s.selector={};s.selector.id=e.getId();s.changeType=this.getChangeType();s.removedElement={id:o.getId()};if(o instanceof sap.ui.core.Title){this._setGroupInfo(o);}return s;};
b.prototype._setGroupInfo=function(t){var c=this;var C=this.getElement().getContent();var f=[];C.some(function(o,i){if(o===t){c.setGroupId(t.getId());c.setGroupIndex(i);}if(c.getGroupIndex()<i){if(o instanceof sap.ui.core.Title){c.setNextGroupIndex(i);return true;}else{if(o.getVisible()===true){f.push(o);}}}});this.setFields(f);};
b.prototype._getFlexChange=function(f,e){var s=this._getSpecificChangeInfo(f);var c=this._completeChangeContent(s);return{change:c,selectorElement:e};};
b.prototype._getForwardActionData=function(e){return this._getFlexChange(b.FORWARD,e);};
b.prototype._getBackwardActionData=function(e){return this._getFlexChange(b.BACKWARD,e);};
b.prototype._undoWithElement=function(e){var c=this.getOriginalElement();var C=e.getContent();var s=-1;if(this.getChangeType()==="hideSimpleFormField"){C.some(function(f,i){if(f===c){s=i;f.setVisible(true);}if(s>=0&&i>s){if((f instanceof sap.m.Label)||(f instanceof sap.ui.core.Title)){return true;}else{f.setVisible(true);}}});}else if(this.getChangeType()==="removeSimpleFormGroup"){var t=sap.ui.getCore().byId(this.getGroupId());this.getElement().insertContent(t,this.getGroupIndex());if((this.getGroupIndex()===0)&&(this.getNextGroupIndex()>0)){var n=e.removeContent(1);e.insertContent(n,this.getNextGroupIndex());}this.getFields().forEach(function(f){f.setVisible(true);});this.setOriginalElement(t);}};
b.prototype.serialize=function(){return this._getSpecificChangeInfo(b.FORWARD);};
return b;},true);
sap.ui.predefine('sap/ui/rta/command/Move',['jquery.sap.global','sap/ui/rta/command/FlexCommand'],function(q,F){"use strict";
var M=F.extend("sap.ui.rta.command.Move",{metadata:{library:"sap.ui.rta",properties:{movedElements:{type:"array"},target:{type:"object"},source:{type:"object"}},associations:{},events:{}}});
M.prototype._getSpecificChangeInfo=function(f){var s=f?this.getSource():this.getTarget();var t=f?this.getTarget():this.getSource();var S=s.parent||sap.ui.getCore().byId(s.id);if(s.parent){s.id=s.parent.getId();delete s.parent;}if(t.parent){t.id=t.parent.getId();delete t.parent;}var m={changeType:this.getChangeType(),selector:{id:S.getId()},source:s,target:t,movedElements:[]};this.getMovedElements().forEach(function(a){m.movedElements.push({id:a.id||a.element.getId(),sourceIndex:f?a.sourceIndex:a.targetIndex,targetIndex:f?a.targetIndex:a.sourceIndex});});var C=this.getChangeHandler();return C.buildStableChangeInfo(m);};
M.prototype._getFlexChange=function(f){var p=this.getPreparedActionData(f);if(!p){var s=this._getSpecificChangeInfo(f);p=this._completeChangeContent(s);}return p;};
M.prototype._getForwardActionData=function(e){return this._getFlexChange(F.FORWARD);};
M.prototype._getBackwardActionData=function(e){return this._getFlexChange(F.BACKWARD);};
M.prototype.serialize=function(){return this._getSpecificChangeInfo(F.FORWARD);};
return M;},true);
sap.ui.predefine('sap/ui/rta/command/Property',['sap/ui/rta/command/FlexCommand',"sap/ui/fl/changeHandler/PropertyChange","sap/ui/rta/Utils"],function(F,P,U){"use strict";
var a=F.extend("sap.ui.rta.command.Property",{metadata:{library:"sap.ui.rta",properties:{propertyName:{type:"string"},newValue:{type:"any"},oldValue:{type:"any"},semanticMeaning:{type:"string"},changeType:{type:"string",defaultValue:"propertyChange"}},associations:{},events:{}}});
a.prototype.init=function(){this.setChangeHandler(P);};
a.FORWARD=true;a.BACKWARD=false;
a.prototype._ensureOldValue=function(e){if(this.getOldValue()===undefined){var o=U.getPropertyValue(e,this.getPropertyName());this.setOldValue(o);}};
a.prototype._getSpecificChangeInfo=function(f){var e=this._getElement();this._ensureOldValue(e);return{changeType:this.getChangeType(),selector:{id:e.getId(),type:e.getMetadata().getName()},content:{property:this.getPropertyName(),oldValue:f?this.getOldValue():this.getNewValue(),newValue:f?this.getNewValue():this.getOldValue(),semantic:this.getSemanticMeaning()}};};
a.prototype._getFlexChange=function(f){var s=this._getSpecificChangeInfo(f);var c=this._completeChangeContent(s);return{change:c,selectorElement:this._getElement()};};
a.prototype._getForwardActionData=function(e){return this._getFlexChange(a.FORWARD);};
a.prototype._getBackwardActionData=function(e){return this._getFlexChange(a.BACKWARD);};
a.prototype.serialize=function(){return this._getSpecificChangeInfo(a.FORWARD);};
return a;},true);
sap.ui.predefine('sap/ui/rta/command/Remove',['sap/ui/rta/command/FlexCommand'],function(F){"use strict";
var R=F.extend("sap.ui.rta.command.Remove",{metadata:{library:"sap.ui.rta",properties:{removedElement:{type:"object"},removeMetadata:{type:"object"}},associations:{},events:{}}});
R.prototype._getSpecificChangeInfo=function(){var s={changeType:this.getChangeType(),removedElement:{id:this.getRemovedElement().getId()}};var C=this.getChangeHandler();return C.buildStableChangeInfo(s);};
R.prototype._getFlexChange=function(){var p=this.getPreparedActionData(F.FORWARD);if(!p){var s=this._getSpecificChangeInfo();p=this._completeChangeContent(s);}return p;};
R.prototype.undo=function(){var s=this.getPreparedActionData(F.BACKWARD);var r=this.getRemoveMetadata().restoreState;if(r){r.call(this.getElement(),this.getRemovedElement(),s);}else{jQuery.sap.log.error("No restoreState implementation found for remove action ",this.getElement().getMetadata().getName()+".designtime");}};
R.prototype._getForwardActionData=function(e){return this._getFlexChange();};
R.prototype._getBackwardActionData=function(e){var g=this.getRemoveMetadata().getState;if(g){return g.call(this.getElement(),this.getRemovedElement());}else{jQuery.sap.log.error("No getState implementation found for remove action ",this.getElement().getMetadata().getName()+".designtime");}};
R.prototype.serialize=function(){return this._getSpecificChangeInfo(F.FORWARD);};
return R;},true);
sap.ui.predefine('sap/ui/rta/command/Rename',['jquery.sap.global','sap/ui/rta/command/FlexCommand','sap/ui/comp/smartform/flexibility/changes/RenameGroup','sap/ui/comp/smartform/flexibility/changes/RenameField','sap/ui/fl/Change'],function(q,F,R,a,C){"use strict";
var b=F.extend("sap.ui.rta.command.Rename",{metadata:{library:"sap.ui.rta",properties:{renamedElement:{type:"object"},newValue:{type:"string",defaultValue:"new text"},oldValue:{type:"string",defaultValue:undefined},designTimeMetadata:{type:"object"}},associations:{},events:{}}});
b.prototype._getSpecificChangeInfo=function(f){var s={changeType:this.getChangeType(),selector:{id:this.getElement().getId()},renamedElement:{id:this.getRenamedElement().getId()},value:f?this.getNewValue():this.getOldValue()};return s;};
b.prototype._getFlexChange=function(f){var p=this.getPreparedActionData(f);if(!p){var s=this._getSpecificChangeInfo(f);p=this._completeChangeContent(s);}return p;};
b.prototype.undo=function(){var s=this.getPreparedActionData(F.BACKWARD);this.getDesignTimeMetadata().restoreState(this.getRenamedElement(),s);};
b.prototype._getForwardActionData=function(e){return this._getFlexChange(F.FORWARD,e);};
b.prototype._getBackwardActionData=function(e){return this.getDesignTimeMetadata().getState(this.getRenamedElement());};
b.prototype.serialize=function(){return this._getSpecificChangeInfo(F.FORWARD,this._getElement());};
return b;},true);
sap.ui.predefine('sap/ui/rta/command/Stack',['sap/ui/base/ManagedObject'],function(M){"use strict";
var S=M.extend("sap.ui.rta.command.Stack",{metadata:{library:"sap.ui.rta",properties:{},aggregations:{commands:{type:"sap.ui.rta.command.BaseCommand",multiple:true}},events:{modified:{}}}});
S.prototype._toBeExecuted=-1;
S.prototype._getCommandToBeExecuted=function(){return this.getCommands()[this._toBeExecuted];};
S.prototype.pushExecutedCommand=function(c){this.push(c,true);};
S.prototype.push=function(c,e){if(this._bUndoneCommands){this._bUndoneCommands=false;while(this._toBeExecuted>-1){this.pop();}}this.insertCommand(c,0);if(!e){this._toBeExecuted++;}this.fireModified();};
S.prototype.top=function(){return this.getCommands()[0];};
S.prototype.pop=function(){if(this._toBeExecuted>-1){this._toBeExecuted--;}return this.removeCommand(0);};
S.prototype.removeCommand=function(o,s){var r=this.removeAggregation("commands",o,s);this.fireModified();return r;};
S.prototype.removeAllCommands=function(s){var c=this.removeAllAggregation("commands",s);this._toBeExecuted=-1;this.fireModified();return c;};
S.prototype.isEmpty=function(){return this.getCommands().length===0;};
S.prototype.execute=function(){var c=this._getCommandToBeExecuted();if(c){try{c.execute();}catch(e){this.pop();throw(e);}this._toBeExecuted--;this.fireModified();}};
S.prototype._unExecute=function(){if(this.canUndo()){this._bUndoneCommands=true;this._toBeExecuted++;var c=this._getCommandToBeExecuted();if(c){c.undo();this.fireModified();}}};
S.prototype.canUndo=function(){return(this._toBeExecuted+1)<this.getCommands().length;};
S.prototype.undo=function(){this._unExecute();};
S.prototype.canRedo=function(){return!!this._getCommandToBeExecuted();};
S.prototype.redo=function(){this.execute();};
S.prototype.pushAndExecute=function(c){this.push(c);this.execute();};
S.prototype.serialize=function(){var r=[];var c=this.getSerializableCommands();c.forEach(function(C){var s=C.serialize();if(Array.isArray(s)){r.concat(s);}else{r.push(s);}});return r;};
S.prototype.getSerializableCommands=function(){var s=[];var c=this.getCommands();for(var i=c.length-1;i>this._toBeExecuted;i--){var a=this._getSubCommands(c[i]);s=s.concat(a);}return s;};
S.prototype._getSubCommands=function(c){var t=this;var C=[];if(c.getCommands){c.getCommands().forEach(function(s){var a=t._getSubCommands(s);C=C.concat(a);});}else{C.push(c);}return C;};
return S;},true);
sap.ui.predefine('sap/ui/rta/command/Stash',['sap/ui/rta/command/FlexCommand',"sap/ui/fl/changeHandler/StashControl"],function(F,S){"use strict";
var a=F.extend("sap.ui.rta.command.Stash",{metadata:{library:"sap.ui.rta",properties:{changeType:{type:"string",defaultValue:"stashControl"}},associations:{},events:{}}});
a.prototype.init=function(){this.setChangeHandler(S);};
a.prototype._undoWithElement=function(e){e=sap.ui.getCore().byId(e.getId());this.setElement(e);e.setStashed(false);e.setVisible(true);};
a.prototype.serialize=function(){return{changeType:this.getChangeType(),selector:{id:this._getElement().getId()}};};
return a;},true);
sap.ui.predefine('sap/ui/rta/command/Ungroup',['sap/ui/rta/command/BaseCommand','sap/ui/rta/Utils','sap/ui/rta/controlAnalyzer/ControlAnalyzerFactory'],function(B,U,C){"use strict";
var a=B.extend("sap.ui.rta.command.Ungroup",{metadata:{library:"sap.ui.rta",properties:{changeType:{type:"string",defaultValue:"UngroupControl"},smartForm:{type:"object"}},associations:{},events:{}}});
a.prototype.init=function(){this._aCommands=[];this._aUngroupFields=[];};
a.prototype.undo=function(){var u=this._aUngroupFields;var j=[];var f=[];var F=[];var b=[];if(u){for(var i=0;i<u.length;i++){var e=sap.ui.getCore().byId(u[i].controlId);var d=u[i];j.push(e.getFields()[0].getMetadata().getName());f.push(d["sap:label"]);var p="";if(d.isComplexProperty){p=d.complexTypePropertyName+"/"+d.name;}else{p=d.name;}F.push(p);b.push(d.valueProperty);var o=sap.ui.rta.command.CommandFactory.getCommandFor(e,"Hide");o.execute();}var A=U.createNewAddFieldsCommand(this.getSmartForm(),e.getParent(),0,j,f,b,F);A.execute();}};
a.prototype.execute=function(){var t=this;return this._createUngroupCommands().then(function(){for(var i=0;i<t._aCommands.length;i++){t._aCommands[i].execute();}t._updateElement();t.getElement().destroy();});};
a.prototype.getCommands=function(){return this._aCommands;};
a.prototype.serialize=function(){var s=[];for(var i=0;i<this._aCommands.length;i++){s.push(this._aCommands[i].serialize());}return s;};
a.prototype._createUngroupCommands=function(){var t=this;var g=this.getElement().getParent();if(this._aCommands.length>0){return Promise.resolve();}var s=sap.ui.rta.controlAnalyzer.ControlAnalyzerFactory.getControlAnalyzerFor(this.getSmartForm());return s.prepare().then(function(){var h=s.getHiddenElements();var f=t.getElement().getFields();for(var i=0;i<f.length;i++){var F=f[i];var p=U.getElementBindingPaths(F);var b=U.findFieldBindingPathInFieldsArray(p,h);var o=h[b];o["valueProperty"]=p[b].valueProperty;if(o&&o.controlId){var G=sap.ui.getCore().byId(o.controlId);var u=sap.ui.rta.command.CommandFactory.getCommandFor(G,"Unhide");t._aCommands.push(u);}else if(o&&!o.controlId){var P=t._getBindingPath(o);var n=U.createNewAddFieldsCommand(t.getSmartForm(),g,0,[F.getMetadata().getName()],[o["sap:label"]],[p[o.name].valueProperty],[P]);t._aCommands.push(n);o["controlId"]=n.getNewControlId();}t._aUngroupFields.push(o);}});};
a.prototype._updateElement=function(){sap.ui.getCore().applyChanges();if(this._aUngroupFields.length===0||(this.getElement()&&!this.getElement().bIsDestroyed)){return;}var p=[];for(var i=0;i<this._aUngroupFields.length;i++){p.push(this._getBindingPath(this._aUngroupFields[i]));}var e=U.createNewSmartFormGroupElementId(this.getSmartForm(),p);this.setElement(sap.ui.getCore().byId(e));};
a.prototype._getBindingPath=function(d){var p="";if(d.isComplexProperty){p=d.complexTypePropertyName+"/"+d.name;}else{p=d.name;}return p;};
return a;},true);
sap.ui.predefine('sap/ui/rta/command/Unhide',['sap/ui/rta/command/FlexCommand',"sap/ui/fl/changeHandler/UnhideControl"],function(F,U){"use strict";
var a=F.extend("sap.ui.rta.command.Unhide",{metadata:{library:"sap.ui.rta",properties:{changeType:{type:"string",defaultValue:"unhideControl"}},associations:{},events:{}}});
a.prototype.init=function(){this.setChangeHandler(U);};
a.prototype._undoWithElement=function(e){e.setVisible(false);};
a.prototype.serialize=function(){return{changeType:this.getChangeType(),selector:{id:this._getElement().getId()}};};
return a;},true);
sap.ui.predefine('sap/ui/rta/command/UnhideForm',['sap/ui/rta/command/FlexCommand','sap/ui/rta/command/Unhide',"sap/ui/fl/changeHandler/UnhideControl"],function(F,U,a){"use strict";
var b=U.extend("sap.ui.rta.command.UnhideForm",{metadata:{library:"sap.ui.rta",properties:{originalElement:{type:"object"},changeType:{type:"string",defaultValue:"unhideControl"}},associations:{},events:{}}});
b.FORWARD=true;b.BACKWARD=false;
b.prototype.init=function(){};
b.prototype._getSpecificChangeInfo=function(f){var e=this.getElement();var s={};s.selector={};s.selector.id=e.getId();s.changeType=this.getChangeType();s.sUnhideId=this.getOriginalElement().getId();return s;};
b.prototype._getFlexChange=function(f,e){var s=this._getSpecificChangeInfo(f);var c=this._completeChangeContent(s);return{change:c,selectorElement:e};};
b.prototype._getForwardActionData=function(e){return this._getFlexChange(b.FORWARD,e);};
b.prototype._getBackwardActionData=function(e){return this._getFlexChange(b.BACKWARD,e);};
b.prototype._undoWithElement=function(e){var c=this.getOriginalElement();var C=e.getContent();if(this.getChangeType()==="unhideSimpleFormField"){var s=-1;C.some(function(f,i){if(f===c){s=i;f.setVisible(false);}if(s>=0&&i>s){if((f instanceof sap.m.Label)||(f instanceof sap.ui.core.Title)){return true;}else{f.setVisible(false);}}});}};
b.prototype.serialize=function(){return this._getSpecificChangeInfo(b.FORWARD);};
return b;},true);
sap.ui.predefine('sap/ui/rta/command/Unstash',['sap/ui/rta/command/FlexCommand',"sap/ui/fl/changeHandler/UnstashControl"],function(F,U){"use strict";
var a=F.extend("sap.ui.rta.command.Unstash",{metadata:{library:"sap.ui.rta",properties:{changeType:{type:"string",defaultValue:"unstashControl"},parentAggregationName:{type:"string",defaultValue:""},index:{type:"integer",defaultValue:0}},associations:{},events:{}}});
a.prototype.init=function(){this.setChangeHandler(U);};
a.prototype._getForwardActionData=function(e){return this._getFlexChange(F.FORWARD);};
a.prototype._getBackwardActionData=function(e){return this._getFlexChange(F.BACKWARD);};
a.prototype._undoWithElement=function(e){e=sap.ui.getCore().byId(e.getId());this.setElement(e);e.setStashed(true);e.setVisible(false);};
a.prototype._getFlexChange=function(f){return this._completeChangeContent({content:{parentAggregationName:this.getParentAggregationName(),index:this.getIndex()},changeType:this.getChangeType(),selectorElement:this._getElement(),selector:{id:this._getElement().getId()}});};
a.prototype.serialize=function(){return{changeType:this.getChangeType(),selector:{id:this._getElement().getId()},content:{parentAggregationName:this.getParentAggregationName(),index:this.getIndex()}};};
return a;},true);
sap.ui.predefine('sap/ui/rta/controlAnalyzer/Form',['sap/ui/rta/controlAnalyzer/Base','sap/ui/rta/Utils','sap/ui/dt/ElementUtil','sap/ui/fl/Utils'],function(B,U,E,F){"use strict";
var a=B.extend("sap.ui.rta.controlAnalyzer.Form",{metadata:{library:"sap.ui.rta",properties:{}}});
a.prototype.init=function(){};
a.prototype.getFlexChangeType=function(t,e,s){var f;switch(t){case"Rename":if(E.isInstanceOf(e,"sap.ui.layout.form.FormContainer")){f="renameTitle";}else if(E.isInstanceOf(e,"sap.ui.layout.form.FormElement")){f="renameLabel";}break;case"Hide":if(E.isInstanceOf(e,"sap.ui.layout.form.FormContainer")){f="removeSimpleFormGroup";}else if(E.isInstanceOf(e,"sap.ui.layout.form.FormElement")){f="hideSimpleFormField";}break;case"Unhide":if(E.isInstanceOf(e,"sap.ui.layout.form.FormElement")){f="unhideSimpleFormField";}break;case"Add":if(E.isInstanceOf(e,"sap.ui.layout.form.SimpleForm")){f="addSimpleFormGroup";}break;default:break;}return f;};
a.prototype.hasParentStableId=function(o){var b=this._getSimpleFormContainer(o.getElementInstance());return b&&F.checkControlId(b);};
a.prototype.getCommandClass=function(c){var C;switch(c){case"Rename":C='sap.ui.rta.command.RenameForm';break;case"Hide":C='sap.ui.rta.command.HideForm';break;case"Unhide":C='sap.ui.rta.command.UnhideForm';break;case"Add":C='sap.ui.rta.command.AddSimple';break;default:break;}return C;};
a.prototype.getConfiguredElement=function(e){return this._getSimpleFormContainer(e);};
a.prototype.isEditable=function(e){var s=this._getSimpleFormContainer(e);if(s){return this._hasStableIds(s);}};
a.prototype.getRenamableControl=function(e){if(E.isInstanceOf(e,"sap.ui.layout.form.FormElement")){return e.getLabel();}else if(E.isInstanceOf(e,"sap.ui.layout.form.FormContainer")){return e.getTitle();}};
a.prototype.getLabel=function(e){return this.getRenamableControl(e).getText();};
a.prototype.getLabelBinding=function(e){return e.getBindingInfo("text");};
a.prototype.resumeLabelBinding=function(e){var b=e.getBinding("text");if(b){b.resume();}};
a.prototype.createChangeData=function(c,C,h,s){var m={};var b=c.getBindingContext().getObject();var d=b.controlId?b.controlId:b.fieldLabel;var o=sap.ui.getCore().byId(d);var e=!!o;var f=function(){if(e){if(b.visibilityType==="hide"){m={controlId:d,changeType:h?"hideControl":"unhideControl",controlType:"SimpleForm"};}}return m;};return new Promise(function(r,g){r(f());});};
a.prototype.getSelectedBlock=function(c){return U.findSupportedBlock(c,["sap.ui.layout.form.SimpleForm"]);};
a.prototype.getClosestType=function(c){return U.getClosestTypeForControl(c,"sap.ui.layout.form.SimpleForm");};
a.prototype.prepare=function(){var e=this._getSimpleFormElements(this.getControl());if(!this.getPrepared()){for(var i=0;i<e.length;i++){var t=e[i].getText?e[i].getText():e[i].getId();var v=e[i].getVisible?e[i].getVisible():e[i].getParent().getVisible();if(v===false){this._mAvailableElements[e[i].getId()]={fieldLabel:t,quickInfo:t,entityType:"",controlId:e[i].getId(),visibilityType:"hide"};}else{this._mHiddenElements[e[i].getId()]={fieldLabel:t,quickInfo:t,entityType:"",controlId:e[i].getId(),visibilityType:"hide"};}}sap.ui.rta.controlAnalyzer.Base.prototype.prepare.apply(this);}return Promise.resolve();};
a.prototype._getSimpleFormElements=function(e){var b=[];var s=this._getSimpleFormContainer(e);var c=s.getContent();c.forEach(function(f){if(f instanceof sap.m.Label){b.push(f);}});return b;};
a.prototype._getSimpleFormContainer=function(e){if(E.isInstanceOf(e,"sap.ui.layout.form.SimpleForm")){return e;}else if(E.isInstanceOf(e,"sap.ui.layout.form.Form")||E.isInstanceOf(e,"sap.ui.layout.form.FormContainer")||E.isInstanceOf(e,"sap.ui.layout.form.FormElement")){return this._getSimpleFormContainer(e.getParent());}};
a.prototype._hasStableIds=function(e){if(E.isInstanceOf(e,"sap.ui.layout.form.SimpleForm")&&F.checkControlId(e)){var h=e.getContent().some(function(c){var H=!F.checkControlId(c);return H;});return!h;}};
a.prototype._determineGroupIndex=function(e){var i=0;if(e.getMetadata().getName()==="sap.ui.layout.form.FormContainer"){var c=this._getSimpleFormContainer(e).getContent();var s=-1;var t=e.getTitle();if(t!==null){c.some(function(f,b){if(f===t){s=b;}if(s>=0&&b>s){if(f instanceof sap.ui.core.Title){i=b;return true;}}});i=(!i)?c.length:i;}}return i;};
a.prototype._determineIndexOfFormElement=function(f,o){var c=f.getParent().getAggregation("formElements");var i;c.some(function(C,b){if(C===f){i=b;return true;}});i=(o)?i+1:i;return i;};
a.prototype._determineIndexOfFormContainer=function(f){var c=f.getParent().getAggregation("formContainers");var i;c.some(function(C,b){if(C===f){i=b;return true;}});return i;};
a.prototype._getStableElementForCommand=function(e){var s;if(e.getMetadata().getName()==="sap.ui.layout.form.FormContainer"){s=e.getTitle();}else if(e.getMetadata().getName()==="sap.ui.layout.form.FormElement"){s=e.getLabel();}return s;};
a.prototype.mapSpecificChangeData=function(t,s){var r;switch(t){case"Add":r=this._mapAddSpecificChangeData(t,s);break;default:r=this.prototype.mapSpecificChangeData(t,s);break;}return r;};
a.prototype._mapAddSpecificChangeData=function(t,s){if(s.changeType==="addSimpleFormGroup"){s.groupLabel=s.labels[0];delete s.labels;}return s;};
a.prototype.isHideable=function(e){var i=(E.isInstanceOf(e,"sap.ui.layout.form.FormElement")||E.isInstanceOf(e,"sap.ui.layout.form.FormContainer"));return(i&&!this.isMandatory(e));};
return a;},true);
sap.ui.predefine('sap/ui/rta/controlAnalyzer/SmartForm',['sap/ui/rta/controlAnalyzer/Base','sap/ui/rta/Utils','sap/ui/dt/ElementUtil','sap/ui/rta/ModelConverter','sap/ui/comp/odata/MetadataAnalyser','sap/ui/rta/model/ElementPreprocessor'],function(B,U,E,M,a,b){"use strict";
var S=B.extend("sap.ui.rta.controlAnalyzer.SmartForm",{metadata:{library:"sap.ui.rta",properties:{customFieldAvailable:{type:"object",defaultValue:false}}}});
S.rules={};S.rules["EXCLUDEVISIBLERULE"]="excludeVisibleElements";S.rules["EXCLUDEIGNOREDFIELDS"]="excludeIgnoredFields";
S.prototype.init=function(){var t=this;this._mVisibleAndBoundFields;this._mRegisteredRules={};this._mRegisteredRules[S.rules.EXCLUDEVISIBLERULE]=function(e){if(!t._mVisibleAndBoundFields){t._mVisibleAndBoundFields=t.findBoundFields(false);}return t._retrieveElementFromMap(t._mVisibleAndBoundFields,e);};this._mRegisteredRules[S.rules.EXCLUDEIGNOREDFIELDS]=function(e){var i=t._getIgnoredFields();if(e.isComplexProperty){return i.indexOf(e.complexTypePropertyName+"."+e.name)!==-1;}return i.indexOf(e.name)!==-1;};};
S.prototype.setControl=function(c){var s=U.getClosestTypeForControl(c,"sap.ui.comp.smartform.SmartForm");this.setProperty("control",s,true);this.setProperty("selectedControl",c,true);};
S.prototype.getFlexChangeType=function(t,e){var f;switch(t){case"Add":if(E.isInstanceOf(e,"sap.ui.comp.smartform.SmartForm")){f="addGroup";}else if(E.isInstanceOf(e,"sap.ui.comp.smartform.Group")){f="addFields";}break;case"Rename":if(E.isInstanceOf(e,"sap.ui.comp.smartform.SmartForm")){f="renameField";}else if(E.isInstanceOf(e,"sap.ui.comp.smartform.Group")){f="renameGroup";}else if(E.isInstanceOf(e,"sap.ui.comp.smartform.GroupElement")){f="renameField";}break;default:break;}return f;};
S.prototype.mapSpecificChangeData=function(t,s){var r;switch(t){case"Add":r=this._mapAddSpecificChangeData(t,s);break;case"Rename":r=this._mapRenameSpecificChangeData(t,s);break;default:r=this.prototype.mapSpecificChangeData(t,s);break;}return r;};
S.prototype.getRenamableControl=function(e){if(E.isInstanceOf(e,"sap.ui.comp.smartform.Group")){return e.getTitle();}else if(E.isInstanceOf(e,"sap.ui.comp.smartform.GroupElement")){return e.getLabel();}};
S.prototype.getLabel=function(e){if(E.isInstanceOf(e,"sap.ui.comp.smartform.SmartForm")){return e.getTitle();}else if(E.isInstanceOf(e,"sap.ui.comp.smartform.Group")){return e.getLabel();}else if(E.isInstanceOf(e,"sap.ui.comp.smartform.GroupElement")){return e.getLabelText();}};
S.prototype.getLabelBinding=function(e){if(E.isInstanceOf(e,"sap.ui.comp.smartform.SmartForm")){return e.getBindingInfo("title");}else if(E.isInstanceOf(e,"sap.ui.comp.smartform.Group")||E.isInstanceOf(e,"sap.ui.comp.smartform.GroupElement")){return e.getBindingInfo("label");}};
S.prototype.resumeLabelBinding=function(e){if(E.isInstanceOf(e,"sap.ui.comp.smartform.SmartForm")){var o=e.getBinding("title");if(o){o.resume();}}else if(E.isInstanceOf(e,"sap.ui.comp.smartform.Group")||E.isInstanceOf(e,"sap.ui.comp.smartform.GroupElement")){var o=e.getBinding("label");if(o){o.resume();}}};
S.prototype._mapAddSpecificChangeData=function(t,s){if(s.changeType==="addFields"){s.fieldLabels=s.labels;delete s.labels;}else if(s.changeType==="addGroup"){s.groupLabel=s.labels[0];delete s.labels;}return s;};
S.prototype._mapRenameSpecificChangeData=function(t,s){var e=s.element;if(E.isInstanceOf(e,"sap.ui.comp.smartform.SmartForm")){s.fieldLabel=s.value;s.labelProperty="title";}else if(E.isInstanceOf(e,"sap.ui.comp.smartform.Group")){s.groupLabel=s.value;}else if(E.isInstanceOf(e,"sap.ui.comp.smartform.GroupElement")){s.fieldLabel=s.value;s.labelProperty="label";}delete s.value;delete s.element;return s;};
S.prototype.getSelectedBlock=function(c){return U.findSupportedBlock(c,["sap.ui.comp.smartform.Group"]);};
S.prototype.getClosestType=function(c){return U.getClosestTypeForControl(c,"sap.ui.comp.smartform.SmartForm");};
S.prototype.createChangeData=function(c,C,h,s){var m={};var o=c.getBindingContext().getObject();var d=o.controlId?o.controlId:C.getId()+"_"+o.entityName+"_"+o.name;var e=sap.ui.getCore().byId(d);var f=!!e;var g=function(){if(f){m={controlId:d,changeType:h?"hideControl":"unhideControl"};}else{var i=o.complexTypePropertyName?o.complexTypePropertyName+"/"+o.name:o.name;if(C){var G;if(C instanceof sap.ui.comp.smartform.Group){G=C;}else{G=C.getGroups()[0];}var j=G.getGroupElements();var t=U.determineTargetIndex(s,C,j,-1);m={unhide:f,newControlId:d,jsType:"sap.ui.comp.smartfield.SmartField",selectorId:G.getId(),index:t,valueProperty:"value",changeType:"addField",fieldLabel:o.fieldLabel,fieldValue:i};}}return m;};if(h&&!this.isHideable(e)){return U.openRemoveElementConfirmationDialog(e).then(function(i){if(i){return g();}else{return null;}});}else{return new Promise(function(r,i){r(g());});}};
S.prototype.findChangedFieldLabels=function(){if(!this._mFieldsAndLabelNames){this._mFieldsAndLabelNames=this._findChangedFieldLabels();}return this._mFieldsAndLabelNames;};
S.prototype._findChangedFieldLabels=function(){var f={};var i=this.findBoundFields(true);var v=this.findBoundFields(false);var A=jQuery.extend({},i,v);for(var p in A){var F=sap.ui.getCore().byId(A[p]);var t=U.getLabelForElement(F);f[p]=t;}return f;};
S.prototype.findBoundFields=function(o){var s=this.getControl();var g=s.getGroups();var f={elementIds:{},boundFields:{}};var i,j,k=0;for(i=0;i<g.length;i++){var e=g[i].getGroupElements();for(j=0;j<e.length;j++){var F=e[j];var c=F.getFields();for(k=0;k<c.length;k++){var d=c[k];if(d.mBindingInfos){for(var I in d.mBindingInfos){var p=U.getPathFromBindingInfo(I,d.mBindingInfos);var P=d.getParent();if(P&&p){if(o&&!d.getDomRef()){this._addBoundFields(f,p,d);continue;}if(d.getDomRef()&&d.getVisible()&&!o){this._addBoundFields(f,p,d);}}}}}}}return f.boundFields;};
S.prototype._addBoundFields=function(f,p,F){var P=F.getParent();if(f.boundFields[p]){if(P.getFields().length===1){f.boundFields[p]=P.getId();}else if(f.elementIds[F.getId()]&&f.elementIds[F.getId()].getFields()===1){f.boundFields[p]=P.getId();}}else{f.boundFields[p]=P.getId();}f.elementIds[F.getId()]=P;};
S.prototype._prepareCustomFields=function(){var t=this;return U.isCustomFieldAvailable(this.getSelectedControl()).then(function(r){if(r){t.setCustomFieldAvailable(r);}return r;});};
S.prototype._getIgnoredFields=function(){var s=this.getControl();if(s){var c=s.getIgnoredFields();if(c){var i=c.split(",");return i;}}return[];};
S.prototype.getCustomFieldAvailable=function(){if(!this.getPrepared()){this._raiseIllegalState();}return this.getProperty("customFieldAvailable");};
S.prototype.getCustomizeControlModel=function(c,f){var C=this.getClosestType(c);var e=C.getEntityType();if(e){e=e.replace(/\s+/g,'').match(/([^,]+)/g);}if(!f){return M.getConvertedModelWithBoundAndRenamedLabels(C,e,this);}else{return M.getConvertedModelWithBoundAndRenamedLabels(C,e,this).then(function(d){return d.filter(function(m){return!m.checked;});});}};
S.prototype.prepare=function(){if(!this.getPrepared()){var f=this._getFieldFetcherPromise();var i=this._prepareCustomFields();return Promise.all([f,i]);}else{return new Promise().resolve();}};
S.prototype._getFieldFetcherPromise=function(){var t=this;return U.fetchODataPropertiesFor(this.getControl().getModel()).then(function(p){var e=t.getBoundEntityType();Object.keys(p).forEach(function(s){p[s].forEach(function(o){var c=t._applyChanges(o);var f=t._applyRules(c);if(!f&&c.entityName===e){t._mAvailableElements[c.name]=c;}else{t._mHiddenElements[c.name]=c;}});});sap.ui.rta.controlAnalyzer.Base.prototype.prepare.apply(t);});};
S.prototype._applyRules=function(e){var f=this._getRules();var F=false;for(var r in f){var R=f[r];if(R(e)){F=true;break;}}return F;};
S.prototype._applyChanges=function(e){var c=e;var f=this._getChanges();f.forEach(function(C){c=C(c);});return c;};
S.prototype._getRules=function(){return this._mRegisteredRules;};
S.prototype.getBoundEntityType=function(){var c=this.getSelectedControl();if(E.isInstanceOf(c,"sap.ui.comp.smartform.GroupElement")){c=c.getParent();}if(c.getBindingContext()&&c.getModel()){return U.getBoundEntityType(c);}};
S.prototype._retrieveElementFromMap=function(e,o){var r;if(o.isComplexProperty){r=e[o.complexTypePropertyName+"/"+o.name];}else{r=e[o.name];}return r;};
S.prototype._determineGroupIndex=function(e){var I=0;if(e.getMetadata().getName()==="sap.ui.comp.smartform.Group"){var g=e.getParent().getAggregation("formContainers");for(var i=0;i<g.length;i++){if(g[i].getId()===e.getId()){I=i+1;break;}}}return I;};
S.prototype._getChanges=function(){var t=this;return[function(e){var c=t.findChangedFieldLabels(e);var C=t._retrieveElementFromMap(c,e);if(C){e["fieldLabel"]=C;}return e;},function(e){var c;if(!t._mBoundFields){t._mBoundFields=t.findBoundFields(true);}if(e.isComplexProperty){c=t._mBoundFields[e.complexTypePropertyName+"/"+e.name];}else{c=t._mBoundFields[e.name];}if(c){e["controlId"]=c;}return e;}];};
S.prototype.checkTargetZone=function(p,A,m){var s=E.getClosestElementOfType(m,"sap.ui.comp.smartform.SmartForm");var t=E.getClosestElementOfType(p,"sap.ui.comp.smartform.SmartForm");if(s===t){return true;}};
S.prototype.isMandatory=function(e){var m=false;if(E.isInstanceOf(e,"sap.ui.comp.smartform.GroupElement")){var f=e.getFields();for(var i=0;i<f.length;i++){var g=f[i];if(E.isInstanceOf(g,"sap.ui.comp.smartfield.SmartField")&&g.getMandatory()){m=true;break;}}}else if(E.isInstanceOf(e,"sap.ui.comp.smartform.Group")){var G=e.getGroupElements();for(var j=0;j<G.length;j++){return this.isMandatory(G[j]);}}return m;};
S.prototype.isHideable=function(e){return((E.isInstanceOf(e,"sap.ui.comp.smartform.GroupElement")||E.isInstanceOf(e,"sap.ui.comp.smartform.Group"))&&!this.isMandatory(e));};
return S;},true);
sap.ui.predefine('sap/ui/rta/plugin/Remove',['sap/ui/dt/Plugin','sap/ui/rta/Utils','sap/ui/rta/command/CompositeCommand'],function(P,U,C){"use strict";
var R=P.extend("sap.ui.rta.plugin.Remove",{metadata:{library:"sap.ui.rta",properties:{},associations:{},events:{}}});
R.prototype.registerElementOverlay=function(o){o.attachBrowserEvent("keydown",this._onKeyDown,this);};
R.prototype._getEffectiveDesignTimeMetadata=function(o){var d;if(o.isInHiddenTree()){var p=o.getPublicParentAggregationOverlay();d=p.getDesignTimeMetadata();}else{d=o.getDesignTimeMetadata();}return d;};
R.prototype._getRemoveAction=function(o){return this._getEffectiveDesignTimeMetadata(o).getAction("remove",o.getElementInstance());};
R.prototype.isRemoveAvailable=function(o){return!!this._getRemoveAction(o);};
R.prototype.isRemoveEnabled=function(o){var a=this._getRemoveAction(o);if(!a){return false;}if(typeof a.isEnabled!=="undefined"){if(typeof a.isEnabled==="function"){return a.isEnabled(o.getElementInstance());}else{return a.isEnabled;}}return true;};
R.prototype._getConfirmationText=function(o){var a=this._getRemoveAction(o);if(a&&a.getConfirmationText){return a.getConfirmationText(o.getElementInstance());}};
R.prototype.deregisterElementOverlay=function(o){o.detachBrowserEvent("keydown",this._onKeyDown,this);};
R.prototype._onKeyDown=function(e){if(e.keyCode===jQuery.sap.KeyCodes.DELETE){e.stopPropagation();this.removeElement();}};
R.prototype.removeElement=function(o){var s;if(o){s=o;}else{var d=this.getDesignTime();s=d.getSelection();}if(s.length>0){this._handleRemove(s);}};
R.prototype._getRemoveCommand=function(e,r,d){return this.getCommandFactory().getCommandFor(e,"Remove",{removedElement:r},d);};
R.prototype._fireElementModified=function(c){if(c.getCommands().length){this.fireElementModified({"command":c});}};
R.prototype._handleRemove=function(s){var t=this;var p=[];var c=new C();s.forEach(function(o){var a;var r=o.getElementInstance();var e;var d=t._getEffectiveDesignTimeMetadata(o);if(o.isInHiddenTree()){e=o.getPublicParentElementOverlay().getElementInstance();}else{e=r;}if(t.isRemoveEnabled(o)){var b=t._getConfirmationText(o);if(b){p.push(U.openRemoveConfirmationDialog(r,b).then(function(f){if(f){a=t._getRemoveCommand(e,r,d);c.addCommand(a);}}));}else{a=t._getRemoveCommand(e,r,d);c.addCommand(a);}}});if(p.length){Promise.all(p).then(function(){t._fireElementModified(c);});}else{t._fireElementModified(c);}};
return R;},true);
sap.ui.predefine('sap/ui/rta/plugin/Selection',['sap/ui/dt/Plugin','sap/ui/rta/Utils','sap/ui/rta/controlAnalyzer/ControlAnalyzerFactory'],function(P,U,C){"use strict";
var S=P.extend("sap.ui.rta.plugin.Selection",{metadata:{library:"sap.ui.rta",properties:{},associations:{},events:{}}});
S.prototype.registerElementOverlay=function(o){var e=o.getElementInstance();var s=C.getControlAnalyzerFor(e).isEditable(e);o.setSelectable(s);o.attachBrowserEvent("click",this._onClick,this);o.attachBrowserEvent("keydown",this._onKeyDown,this);o.attachBrowserEvent("mousedown",this._onMouseDown,this);};
S.prototype.deregisterElementOverlay=function(o){o.detachBrowserEvent("click",this._onClick,this);o.detachBrowserEvent("keydown",this._onKeyDown,this);o.detachBrowserEvent("mousedown",this._onMouseDown,this);};
S.prototype._onKeyDown=function(e){var o=U.getFocusedOverlay();if(e.keyCode===jQuery.sap.KeyCodes.ENTER){if((o)&&(!o.isSelected())){o.setSelected(true);e.stopPropagation();}}else if((e.keyCode===jQuery.sap.KeyCodes.ARROW_UP)&&(e.shiftKey===false)&&(e.altKey===false)&&(e.ctrlKey===false)){if(o){var p=o.getParentElementOverlay();if((p)&&(p.isSelectable())){p.focus();e.stopPropagation();}}}else if((e.keyCode===jQuery.sap.KeyCodes.ARROW_DOWN)&&(e.shiftKey===false)&&(e.altKey===false)&&(e.ctrlKey===false)){if(o){var f=U.getFirstFocusableChildOverlay(o);if(f){f.focus();e.stopPropagation();}}}else if((e.keyCode===jQuery.sap.KeyCodes.ARROW_LEFT)&&(e.shiftKey===false)&&(e.altKey===false)&&(e.ctrlKey===false)){if(o){var a=U.getPreviousFocusableSiblingOverlay(o);if(a){a.focus();e.stopPropagation();}}}else if((e.keyCode===jQuery.sap.KeyCodes.ARROW_RIGHT)&&(e.shiftKey===false)&&(e.altKey===false)&&(e.ctrlKey===false)){if(o){var n=U.getNextFocusableSiblingOverlay(o);if(n){n.focus();e.stopPropagation();}}}};
S.prototype._onMouseDown=function(e){if(sap.ui.Device.browser.name=="ie"){var o=sap.ui.getCore().byId(e.currentTarget.id);if(o.isSelectable()){o.focus();e.stopPropagation();}else{o.getDomRef().blur();}e.preventDefault;}};
S.prototype._onClick=function(e){var o=sap.ui.getCore().byId(e.currentTarget.id);if(o.isSelectable()){o.setSelected(!o.getSelected());e.preventDefault();e.stopPropagation();}};
return S;},true);
sap.ui.predefine('sap/ui/rta/ui/AddElementsDialog',['jquery.sap.global','sap/ui/rta/library','sap/ui/rta/Utils','sap/ui/dt/OverlayRegistry','sap/ui/core/Control','sap/ui/commons/Label','sap/ui/commons/LabelDesign','sap/m/Dialog','sap/ui/model/json/JSONModel','sap/m/SearchField','sap/m/Button','sap/m/Toolbar','sap/m/ToolbarSpacer','sap/ui/model/Filter','sap/ui/model/FilterOperator','sap/ui/rta/controlAnalyzer/ControlAnalyzerFactory','sap/ui/rta/command/CommandFactory','sap/ui/rta/command/CompositeCommand','sap/m/List','sap/m/CustomListItem','sap/m/ListType','sap/m/ScrollContainer','sap/ui/model/Sorter','sap/ui/dt/ElementUtil'],function(q,l,U,O,C,L,a,D,J,S,B,T,b,F,c,d,e,f,g,h,i,j,k,E){"use strict";
var A=C.extend("sap.ui.rta.ui.AddElementsDialog",{metadata:{library:"sap.ui.rta",properties:{"commandStack":{type:"sap.ui.core.Control"}},associations:{"rootControl":{type:"sap.ui.core.Control"}},events:{"opened":{},"closed":{},"openCustomField":{}}}});
A.prototype.init=function(){this._aData=[];var t=this;this._oModel=new J();this._oTextResources=sap.ui.getCore().getLibraryResourceBundle("sap.ui.rta");this._bAscendingSortOrder=false;this._oDialog=this._createDialog();var m=this._createContent();var n=this._createButtons();m.forEach(function(o){t._oDialog.addContent(o);});n.forEach(function(o){t._oDialog.addButton(o);});this._oDialog.setInitialFocus(this._oInput);};
A.prototype._createDialog=function(){var o;o=new D({title:this._oTextResources.getText("HEADER_FREP")}).addStyleClass("sapUIRtaFieldRepositoryDialog");return o;};
A.prototype._createContent=function(){this._oInput=new S({width:"100%",liveChange:[this._updateModelFilter,this]}).addStyleClass("resourceListIF");var r=new B({text:"",icon:"sap-icon://sort",press:[this._resortList,this]});this._oCustomFieldButton=new B({text:"",icon:"sap-icon://add",tooltip:this._oTextResources.getText("BTN_FREP_CCF"),enabled:false,press:[this._redirectToCustomFieldCreation,this]});this._oToolbarSpacer1=new b();this.oInputFields=new T({content:[this._oInput,r,this._oToolbarSpacer1,this._oCustomFieldButton]});var o=new L({design:a.Bold,tooltip:{parts:[{path:"quickInfo"},{path:"fieldLabel"}],formatter:function(p,t){if(!p){return t;}return p;}},text:"{fieldLabel}"});var s=new k("fieldLabel",this._bAscendingSortOrder);this._oList=new g({mode:"MultiSelect",includeItemInSelection:true,growing:false,growingScrollToLoad:false,select:[this._fnSelected,this]});var m=new h({type:i.Active,selected:"{checked}",content:[o]});this._oModel.setData({modelData:this._aData});this._oList.setModel(this._oModel);this._oList.bindItems({path:"/modelData",template:m,sorter:s});var n=new j({content:this._oList,vertical:true,horizontal:false}).addStyleClass("sapUIRtaCCDialogScrollContainer");return[this.oInputFields,n];};
A.prototype._createButtons=function(){var o=new B({text:this._oTextResources.getText("BTN_FREP_OK"),press:[this.applyChanges,this]});var m=new B({text:this._oTextResources.getText("BTN_FREP_CANCEL"),press:[this.cancelDialog,this]});return[o,m];};
A.prototype.applyChanges=function(){if(this._oCompositeCommand.getCommands().length>0){this.getCommandStack().pushAndExecute(this._oCompositeCommand);}this._oList.removeSelections();this._oCompositeCommand=null;this._mCommands=[];this._oCurrentAnalyzer=null;this._oCurrentSelectedBlock=null;this._oDialog.close();};
A.prototype.cancelDialog=function(){this._oList.removeSelections();this._oCompositeCommand=null;this._mCommands=[];this._oCurrentAnalyzer=null;this._oCurrentSelectedBlock=null;this._oDialog.close();};
A.prototype._fnSelected=function(o){var I=o.getParameter("listItem");var m=I.getBindingContext().getObject();var s=m.name?m.name:null;if(!s){s=m.controlId?m.controlId:null;}if(s){var n=this._mCommands[s];this._executeCommandForSelectedElement(I,n,s);}else{q.sap.log.error("Change could not be applied because of missing id of listItem\n");}};
A.prototype._evaluateTargetIndex=function(s,t,m,n){var I=(s===t&&m<n)?n-1:n;return I;};
A.prototype._getMoveCommand=function(o,m,s){var r;var n=sap.ui.getCore().byId(m.controlId);var p=n?n.getParent():null;var t=O.getOverlay(o).getDesignTimeMetadata();var u;var v;if(o&&p&&(o.getId()!==n.getId())){if(E.isInstanceOf(o,"sap.ui.layout.form.SimpleForm")){var w;if(E.isInstanceOf(s,"sap.ui.layout.form.FormContainer")){v=s.getAggregation("formElements").length;w=s;}else if(E.isInstanceOf(s,"sap.ui.layout.form.FormElement")){v=this._oCurrentAnalyzer._determineIndexOfFormElement(s,true);w=s.getParent();}u=this._oCurrentAnalyzer._determineIndexOfFormElement(n.getParent(),false);var x=n.getParent().getParent();v=this._evaluateTargetIndex(x,w,u,v);r=e.getCommandFor(o,"Move",{movedElements:[{element:n.getParent(),sourceIndex:u,targetIndex:v}],source:{publicParent:o,publicAggregation:"form",parent:x,aggregation:"formElements"},target:{publicParent:o,publicAggregation:"form",parent:w,aggregation:"formElements"}},t);}else{var y=E.getAggregation(p,"formElements");if(y.length>0){u=y.indexOf(n);var z=E.getAggregation(o,"formElements");var G=o.getMetadata().getClass();var v=(s instanceof G)?z.length:z.indexOf(s)+1;v=this._evaluateTargetIndex(p,o,u,v);r=e.getCommandFor(p,"Move",{movedElements:[{element:n,sourceIndex:u,targetIndex:v}],source:{parent:p,publicAggregation:n.sParentAggregationName,aggregation:n.sParentAggregationName},target:{parent:o,publicAggregation:"formElements",aggregation:"formElements"}},t);}}}return r;};
A.prototype._executeCommandForSelectedElement=function(I,o,s){var m=I.getSelected();var t=this;if(o){delete t._mCommands[s];t._oCompositeCommand.removeCommand(o);return;}return this._oCurrentAnalyzer.createChangeData(I,this._oCurrentSelectedBlock,!m,this._oSelectedControl).then(function(n){if(n){if(n.changeType==="addField"){o=e.getCommandFor(t._oCurrentSelectedBlock,"Add",{index:n.index,newControlId:n.newControlId,labels:[n.fieldLabel],jsTypes:[n.jsType],fieldValues:[n.fieldValue],valuePropertys:[n.valueProperty]});t._mCommands[s]=o;t._oCompositeCommand.addCommand(o);}else if(n.changeType==="unhideControl"){if(n.controlType&&n.controlType==="SimpleForm"){var p=sap.ui.getCore().byId(n.controlId).getParent();o=e.getCommandFor(p,"Unhide");}else{o=e.getCommandFor(sap.ui.getCore().byId(n.controlId),"Unhide");}var M=t._getMoveCommand(t._oCurrentSelectedBlock,n,t._oSelectedControl);if(M){var r=new f();r.addCommand(M);r.addCommand(o);o=r;}t._mCommands[s]=o;t._oCompositeCommand.addCommand(o);}else if(n.changeType==="unstashControl"){o=e.getCommandFor(sap.ui.getCore().byId(n.controlId),"Unstash");o.setParentAggregationName(n.parentAggregationName);o.setIndex(n.iTargetIndex);t._mCommands[s]=o;t._oCompositeCommand.addCommand(o);}}else{I.setSelected(!m);}}).catch(function(n){q.sap.log.error("Change could not be applied \n"+n);});};
A.prototype.open=function(o){var t=this;this._oSelectedControl=o;this._mCommands=[];this._oCompositeCommand=new f();if(o.getMetadata().getName().indexOf("ObjectPage")!==-1){this._oDialog.setTitle(this._oTextResources.getText("HEADER_SREP"));}else{this._oDialog.setTitle(this._oTextResources.getText("HEADER_FREP"));}U.isServiceUpToDate(o).then(function(u){if(u){t._oCurrentAnalyzer=d.getControlAnalyzerFor(o);return t._oCurrentAnalyzer.prepare().then(function(){var m=t._oCurrentAnalyzer.getCustomFieldAvailable?t._oCurrentAnalyzer.getCustomFieldAvailable():false;if(m){t.setShowCreateCustomField(true);t._oCurrentFieldExtInfo=m;t.attachEventOnce('openCustomField',null,t._onOpenCustomField,t);}else{t.setShowCreateCustomField(false);}}).then(function(){if(t._oCurrentAnalyzer){t._oCurrentSelectedBlock=t._oCurrentAnalyzer.getSelectedBlock(o);if(/[&?](sap-rta-oldmodel=(true|x)[&#]?)+/i.test(window.location.search)){t._oCurrentAnalyzer.getCustomizeControlModel(o,true).then(function(n){t._oModel.setData({modelData:n});t._oDialog.oPopup.attachOpened(function(){t.fireOpened();});t._oDialog.open();});}else{var m=t._oCurrentAnalyzer.getAvailableElements();t._oModel.setData({modelData:m});t._oDialog.oPopup.attachOpened(function(){t.fireOpened();});t._oDialog.open();}}});}else{t.fireOpened();}});};
A.prototype._resortList=function(o){this._bAscendingSortOrder=!this._bAscendingSortOrder;var m=this._oList.getBinding("items");var s=[];s.push(new k("fieldLabel",this._bAscendingSortOrder));m.sort(s);};
A.prototype._redirectToCustomFieldCreation=function(o){this.fireOpenCustomField();this._oDialog.close();};
A.prototype.setShowCreateCustomField=function(s){this._oCustomFieldButton.setEnabled(s);};
A.prototype._onOpenCustomField=function(o){var m=sap.ushell&&sap.ushell.Container&&sap.ushell.Container.getService("CrossApplicationNavigation");var H=(m&&m.hrefForExternal({target:{semanticObject:"CustomField",action:"develop"},params:{businessContexts:this._oCurrentFieldExtInfo.BusinessContexts,serviceName:this._oCurrentFieldExtInfo.ServiceName,serviceVersion:this._oCurrentFieldExtInfo.ServiceVersion,entityType:this._oCurrentFieldExtInfo.EntityType}}));U.openNewWindow(H);};
A.prototype._updateModelFilter=function(o){var v=o.getParameter("newValue");var m=this._oList.getBinding("items");if((typeof v)==="string"){var n=new F("fieldLabel",c.Contains,v);var p=new F("quickInfo",c.Contains,v);var r=new F({filters:[n,p],and:false});m.filter([r]);}else{m.filter([]);}};
return A;},true);
sap.ui.predefine('sap/ui/rta/ui/SettingsDialog',['jquery.sap.global','sap/ui/rta/library','sap/ui/core/Control','sap/m/Dialog','sap/ui/layout/VerticalLayout','sap/m/Label','sap/m/Input','sap/m/Select','sap/ui/core/Item','sap/m/Button','sap/m/CheckBox','sap/ui/rta/command/CommandFactory','sap/ui/rta/command/CompositeCommand','sap/ui/dt/ElementUtil'],function(q,l,C,D,V,L,I,S,a,B,b,c,d,E){"use strict";
var e=C.extend("sap.ui.rta.ui.SettingsDialog",{metadata:{library:"sap.ui.rta",properties:{"commandStack":{type:"sap.ui.core.Control"}},associations:{"element":{type:"sap.ui.core.Element"}}}});
e.prototype.init=function(){this._oTextResources=sap.ui.getCore().getLibraryResourceBundle("sap.ui.rta");this._oDialog=this._createDialog();};
e.prototype._createDialog=function(){return new D({title:this._oTextResources.getText("HEADER_SETTINGS"),contentHeight:"500px",draggable:true,buttons:[new B({text:this._oTextResources.getText("BTN_FREP_OK"),press:[this._applyChangesAndClose,this]}),new B({text:this._oTextResources.getText("BTN_FREP_CANCEL"),press:[this._cancelDialog,this]})]}).addStyleClass("sapUiPopupWithPadding").addStyleClass("sapUiSizeCompact");};
e.prototype._applyChangesAndClose=function(){this._applyChanges();this._oDialog.close();};
e.prototype._iterateExecutedCommands=function(f){var t=this;Object.keys(this._mCommands).forEach(function(p){f(t._mCommands[p]);});};
e.prototype._applyChanges=function(){var o=new d();this._iterateExecutedCommands(function(f){o.addCommand(f);});if(o.getCommands().length){this.getCommandStack().pushExecutedCommand(o);}};
e.prototype._cancelDialog=function(){this._iterateExecutedCommands(function(o){o.undo();});this._oDialog.close();};
e.prototype._executePropertyChangeCommand=function(o,p,n,O){if(!this._mCommands[p]){var P=c.getCommandFor(o,"Property",{propertyName:p,newValue:n,oldValue:O});this._mCommands[p]=P;P.execute();}else{this._mCommands[p].undo();delete this._mCommands[p];}};
e.prototype._createBooleanEditor=function(o,p,P){var t=this;var f=new b({text:p,selected:P});f.attachSelect(function(g){var n=g.getParameter("selected");var O=!n;t._executePropertyChangeCommand(o,p,n,O);});return f;};
e.prototype._createStringEditor=function(o,p,P){var t=this;var i=new I({value:P});i.attachChange(function(f){var n=f.getParameter("value");var O=P;t._executePropertyChangeCommand(o,p,n,O);});return i;};
e.prototype._createEnumEditor=function(o,p,P,v){var t=this;var s=new S();Object.keys(p).forEach(function(k){s.addItem(new a({text:k,key:p[k]}));});s.setSelectedKey(v);s.attachChange(function(f){var i=f.getParameter("selectedItem");if(i){var n=i.getKey();var O=v;t._executePropertyChangeCommand(o,P,n,O);}});return s;};
e.prototype._updateDialogContent=function(o){var t=this;this._oDialog.removeAllContent();var v=new V();var p=o.getMetadata().getAllProperties();Object.keys(p).forEach(function(P){var f;var g=p[P];var h=o[g._sGetter]();if(g.type==="boolean"){f=t._createBooleanEditor(o,P,h);v.addContent(f);}else if(g.type==="string"||g.type==="sap.ui.core.CSSSize"){f=new V();var i=t._createStringEditor(o,P,h);f.addContent(new L({text:P,labelFor:i.getId()}));f.addContent(i);f.addStyleClass("sapUiRtaDialogEntryWithMargin");}else{var j=q.sap.getObject(g.type);if(j){f=new V();var k=t._createEnumEditor(o,j,P,h);f.addContent(new L({text:P,labelFor:k.getId()}));f.addContent(k);f.addStyleClass("sapUiRtaDialogEntryWithMargin");}}if(f){v.addContent(f);}});this._oDialog.addContent(v);};
e.prototype.open=function(o){this._mCommands={};this._updateDialogContent(o);this._oDialog.open();};
return e;},true);
sap.ui.predefine('sap/ui/rta/util/FakeLrepConnectorLocalStorage',["sap/ui/rta/util/FakeLrepLocalStorage"],function(F){"use strict";var a={};
a.create=function(c){if(Array.isArray(c)){c.forEach(function(e){F.saveChange(e.fileName,e);});}else{F.saveChange(c.fileName,c);}return Promise.resolve();};
a.deleteChange=function(c){F.deleteChange(c.sChangeName);return Promise.resolve({response:undefined,status:"nocontent"});};
a.deleteChanges=function(){F.deleteChanges();return Promise.resolve({response:undefined,status:"nocontent"});};
a.loadChanges=function(c){var C=F.getChanges(),i=this.sInitialComponentJsonPath;return new Promise(function(r,b){jQuery.getJSON(i).done(function(R){R.changes=C;var d={changes:R,componentClassName:c};r(d);}).fail(function(e){b(e);});});};
return a;},true);
sap.ui.predefine('sap/ui/rta/util/FakeLrepLocalStorage',[],function(){"use strict";var R="sap.ui.rta.change";var F={};
F.createChangeKey=function(i){if(i){return R+"."+i;}};
F.forEachLrepChangeInLocalStorage=function(p){for(var k in window.localStorage){if(k.indexOf(R)>-1){p(k);}}};
F.getChange=function(i){if(i){var c=window.localStorage.getItem(this.createChangeKey(i));return JSON.parse(c);}};
F.getChanges=function(){var c=[],C;this.forEachLrepChangeInLocalStorage(function(k){C=JSON.parse(window.localStorage[k]);c.push(C);});return c;};
F.getNumChanges=function(){var c=0;this.forEachLrepChangeInLocalStorage(function(k){c++;});return c;};
F._aModifyCallbacks=[];
F.attachModifyCallback=function(c){this._aModifyCallbacks.push(c);};
F.detachModifyCallback=function(c){var i=this._aModifyCallbacks.indexOf(c);if(i!==-1){this._aModifyCallbacks.splice(i,1);}};
F._callModifyCallbacks=function(){this._aModifyCallbacks.forEach(function(c){c();});};
F.deleteChange=function(i){if(i){window.localStorage.removeItem(this.createChangeKey(i));}this._callModifyCallbacks();};
F.deleteChanges=function(){this.forEachLrepChangeInLocalStorage(function(k){window.localStorage.removeItem(k);});this._callModifyCallbacks();};
F.saveChange=function(i,c){if(i&&c){var C=this.createChangeKey(i),s=JSON.stringify(c);window.localStorage.setItem(C,s);}this._callModifyCallbacks();};
return F;},true);
sap.ui.predefine('sap/ui/rta/util/controlEnablingCheck',["sap/ui/core/UIComponent","sap/ui/core/ComponentContainer","sap/ui/core/XMLTemplateProcessor","sap/ui/core/mvc/XMLView","sap/ui/rta/command/CommandFactory","sap/ui/dt/ElementUtil","sap/ui/dt/ElementDesignTimeMetadata","sap/ui/fl/changeHandler/XmlTreeModifier","sap/ui/fl/changeHandler/JsControlTreeModifier"],function(U,C,X,a,b,E,c,d,J){"use strict";var e=function(m,o){if(e._only&&(m.indexOf(e._only)<0)){return;}QUnit.module(m,{});QUnit.test("When using the 'controlEnablingCheck' function to test if your control is ready for UI adaptation at runtime",function(f){f.ok(o.afterAction,"then you implement a function to check if your action has been successful: See the afterAction parameter.");f.ok(o.afterUndo,"then you implement a function to check if the undo has been successful: See the afterUndo parameter.");f.ok(o.afterRedo,"then you implement a function to check if the redo has been successful: See the afterRedo parameter.");f.ok(o.xmlView,"then you provide an XML view to test on: See the.xmlView parameter.");var x=new DOMParser().parseFromString(o.xmlView,"application/xml").childNodes[0];f.ok(x.tagName.match("View$"),"then you use the sap.ui.core.mvc View tag as the first tag in your view");f.ok(o.action,"then you provide an action: See the action parameter.");f.ok(o.action.name,"then you provide an action name: See the action.name parameter.");f.ok(o.action.controlId,"then you provide the id of the control to operate the action on: See the action.controlId.");f.ok(o.action.parameter,"then you provide parameters for the action: See the action.parameter object.");});QUnit.module(m,{beforeEach:function(f){var t=this;var g=U.extend("sap.ui.rta.control.enabling.comp",{metadata:{manifest:{"sap.app":{"id":"sap.ui.rta.control.enabling.comp","type":"application"}}},createContent:function(){t.oView=sap.ui.xmlview({id:this.createId("view"),viewContent:o.xmlView});return t.oView;}});this.oUiComponent=new g("comp");this.oUiComponentContainer=new C({component:this.oUiComponent});this.oUiComponentContainer.placeAt("test-view");sap.ui.getCore().applyChanges();this.oControl=this.oView.byId(o.action.controlId);return E.loadDesignTimeMetadata(this.oControl).then(function(D){var h=new c({data:D});var p=o.action.parameter(t.oView);t.oCommand=b.getCommandFor(t.oControl,o.action.name,p,h);f.ok(t.oCommand,"then the underlying command is available");});},afterEach:function(){this.oUiComponentContainer.destroy();}});QUnit.test("When executing the underlying command on the control at runtime",function(f){this.oCommand.execute();sap.ui.getCore().applyChanges();o.afterAction(this.oUiComponent,this.oView,J,f);});QUnit.test("When executing and undoing the command",function(f){this.oCommand.execute();this.oCommand.undo();sap.ui.getCore().applyChanges();o.afterUndo(this.oUiComponent,this.oView,J,f);});QUnit.test("When executing, undoing and redoing the command",function(f){this.oCommand.execute();this.oCommand.undo();sap.ui.getCore().applyChanges();this.oCommand.execute();o.afterRedo(this.oUiComponent,this.oView,J,f);});};
e.skip=function(){};
e.only=function(m){e._only=m;};
return e;},true);
/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

(c) Copyright 2009-2016 SAP SE. All rights reserved
 */
sap.ui.predefine('sap/ui/rta/ModelConverter',['jquery.sap.global','sap/ui/comp/odata/FieldSelectorModelConverter','sap/ui/dt/ElementUtil'],function(q,F,E){"use strict";var M={};
M.getConvertedModelWithBoundAndRenamedLabels=function(c,e,C){var t=this;var m=c.getModel();return this._getModelConverter(m).then(function(f){return t._getFieldModel(c,f,e,C);});};
M._getModelConverter=function(m){var o=m.getMetaModel();return o.loaded().then(function(){return new F(m);},function(r){q.sap.log.error("MetadataModel could not be loaded",r);});};
M._getIgnoredFields=function(c){if(c&&c.getIgnoredFields){var C=c.getIgnoredFields();if(C){var i=C.split(",");return i;}}return[];};
M._getFieldModel=function(c,f,e,C){var I=this._getIgnoredFields(c);var o=f.getConvertedModel(e,I);if(!C){throw new Error("ModelConverter: no usable change controller instance found!");}var v=C.findVisibleAndBoundFieldsAndLabelNames(c);var V=v.visibleAndBoundFields;var m=v.fieldsAndLabelNames;var a=v.fieldsAndBoundPropertyName;var b=v.boundFieldsId;var s;for(var z=0;z<e.length;z++){s=e[z];for(var i=0;i<o[s].length;i++){var A=o[s][i];var d=f.getMetaDataAnalyzer()._getNameOfPropertyUsingComplexType(s,A.entityName);if(V[A.name]){A.checked=true;}A.controlId=b[A.name];if(d){A.isComplexType=true;A.complexTypeName=d;if(V[d+"/"+A.name]){A.checked=true;A.controlId=V[d+"/"+A.name];}}var g;var p;if(A.isComplexType){p=A.complexTypeName+"/"+A.name;g=m[p];A.boundProperty=a[p];}else{g=m[A.name];A.boundProperty=a[A.name];}if(g&&g!==A["sap:label"]){A.fieldLabel=g;}}}return o[s];};
return M;},true);
sap.ui.predefine('sap/ui/rta/Utils',['jquery.sap.global','sap/ui/fl/Utils','sap/ui/dt/OverlayUtil','sap/ui/comp/odata/FieldSelectorModelConverter','sap/ui/fl/registry/Settings','sap/ui/comp/smartform/GroupElement','sap/ui/comp/smartform/Group','sap/ui/comp/smartfield/SmartField','sap/uxap/ObjectPageSection','sap/uxap/ObjectPageLayout','sap/ui/core/StashedControlSupport','sap/m/MessageBox','sap/ui/comp/odata/MetadataAnalyser','sap/ui/rta/model/ElementPreprocessor'],function(q,F,O,a,S,G,b,c,d,e,f,M,g,E){"use strict";var U={};U.RESOLVED_PROMISE=Promise.resolve(true);U._sFocusableOverlayClass=".sapUiDtOverlaySelectable";
U.isExtensibilityEnabledInSystem=function(C){var s=F.getComponentClassName(C);if(!s||s==""){return Promise.resolve(false);}return S.getInstance(s).then(function(o){if(o.isModelS){return o.isModelS();}return false;});};
U.isServiceUpToDate=function(C){return this.isExtensibilityEnabledInSystem(C).then(function(h){if(h){q.sap.require("sap.ui.fl.fieldExt.Access");var m=C.getModel();if(m){var s=sap.ui.fl.fieldExt.Access.isServiceOutdated(m.sServiceUrl);if(s){sap.ui.fl.fieldExt.Access.setServiceValid(m.sServiceUrl);sap.ui.getCore().getEventBus().publish("sap.ui.core.UnrecoverableClientStateCorruption","RequestReload",{});return false;}}}return true;});};
U.isCustomFieldAvailable=function(C){var t=this;return this.isExtensibilityEnabledInSystem(C).then(function(s){if(!s){return false;}else{var o=new a(C.getModel());var m=o.getMetaDataAnalyzer();var h=t.getBoundEntityType(C);try{q.sap.require("sap.ui.fl.fieldExt.Access");var j=sap.ui.fl.fieldExt.Access.getBusinessContexts(m.oModel.sServiceUrl,h);return Promise.resolve(j).then(function(r){if(r){if(r.BusinessContexts){if(r.BusinessContexts.length>0){r.EntityType=h;return r;}}}}).catch(function(k){if(k){if(q.isArray(k.errorMessages)){for(var i=0;i<k.errorMessages.length;i++){q.sap.log.error(k.errorMessages[i].text);}}}return false;});}catch(k){q.sap.log.error("exception occured in sap.ui.fl.fieldExt.Access.getBusinessContexts",k);return Promise.resolve();}}});};
U.openRemoveConfirmationDialog=function(o,t){var T=sap.ui.getCore().getLibraryResourceBundle("sap.ui.rta");var s;return new Promise(function(r,h){s=T.getText("CTX_REMOVE_TITLE");var i={messageText:t,titleText:s,icon:"sap-icon://question-mark",removeText:T.getText("BTN_FREP_REMOVE"),cancelText:T.getText("BTN_FREP_CANCEL")};var m=new sap.ui.model.json.JSONModel();m.setData(i);var j;var C=function(){if(j){j.close();j.destroy();j=null;}};var k={removeField:function(){C();r(true);},closeDialog:function(){C();r(false);}};if(!j){j=sap.ui.xmlfragment("sap.ui.rta.view.RemoveElementDialog",k);j.setModel(m);}j.open();});};
U.isMandatorySmartField=function(o){return(o instanceof c)&&o.getMandatory();};
U.isOverlaySelectable=function(o){return o.isSelectable()&&o.$().is(":visible");};
U.getPropertyValue=function(o,p){var m=o.getMetadata().getPropertyLikeSetting(p);var P=m._sGetter;return o[P]();};
U.getOverlayInstanceForDom=function(D){var i=q(D).attr("id");if(i){return sap.ui.getCore().byId(i);}};
U.getFocusedOverlay=function(){if(document.activeElement){var o=sap.ui.getCore().byId(document.activeElement.id);if(o instanceof sap.ui.dt.ElementOverlay){return o;}}};
U.getFirstFocusableChildOverlay=function(o){var h=O.getFirstChildOverlay(o);while(h&&!this.isOverlaySelectable(h)){h=O.getNextSiblingOverlay(h);}return h;};
U.getNextFocusableSiblingOverlay=function(o){var n=O.getNextSiblingOverlay(o);while(n&&!this.isOverlaySelectable(n)){n=O.getNextSiblingOverlay(n);}return n;};
U.getPreviousFocusableSiblingOverlay=function(o){var p=O.getPreviousSiblingOverlay(o);while(p&&!this.isOverlaySelectable(p)){p=O.getPreviousSiblingOverlay(p);}return p;};
U.getClosestTypeForControl=function(C,t){if(C&&C.getMetadata().getName()!==t){return this.getClosestTypeForControl(C.getParent(),t);}return C;};
U._checkIsSupportedControl=function(C,s){for(var i=0;i<s.length;i++){if(C.getMetadata().getName()===s[i]){return true;}}};
U.hasGroupUnBoundFields=function(o){var h=o.getGroupElements();for(var j=0;j<h.length;j++){var i=h[j];if(!this.hasGroupElementBoundFields(i)){return true;}}return false;};
U.hasGroupElementBoundFields=function(o){var h=o.getFields();if(h.length===0||!o.getVisible()){return true;}for(var j=0;j<h.length;j++){var i=h[j];if(!i.getDomRef()){continue;}if(this._isElementBound(i)){return true;}}return false;};
U.hasGroupElementUnBoundFields=function(o){var h=o.getFields();if(h.length===0){return true;}for(var j=0;j<h.length;j++){var i=h[j];if(!i.getDomRef()){continue;}if(!this._isElementBound(i)){return true;}}return false;};
U.getGroupMandatoryElements=function(o){var r=[];if(o instanceof b){var h=o.getGroupElements();for(var i=0;i<h.length;i++){var k=h[i];var l=k.getFields();for(var j=0;j<l.length;j++){var m=l[j];if(!m.getDomRef()){continue;}if(this.isMandatorySmartField(m)){r.push(k);break;}}}}return r;};
U.getObjectPageSections=function(o){var h;var s=[];var i=[];if(o.getMetadata().getName()==="sap.uxap.ObjectPageSection"){h=o.getParent();}else if(o.getMetadata().getName()==="sap.uxap.ObjectPageLayout"){h=o;}s=h.getAggregation("sections");i=f.getStashedControls(h.getId());s=s.concat(i);return s;};
U.hasObjectPageLayoutInvisibleSections=function(o){var s=U.getObjectPageSections(o);if(s.length===0){return false;}for(var i=0;i<s.length;i++){if((s[i].getVisible&&s[i].getVisible()===false)||(s[i].getStashed&&s[i].getStashed()===true)){return true;}}return false;};
U._isElementBound=function(o){var B=o.mBindingInfos;if(Object.keys(B).length===0){return false;}else{for(var p in B){var P=B[p].parts;for(var i=0;i<P.length;i++){if(P[i].model){var m=o.getModel(P[i].model).getMetadata().getName();if(m==="sap.ui.model.odata.ODataModel"||m==="sap.ui.model.odata.v2.ODataModel"){return true;}}else{var m=o.getModel().getMetadata().getName();if(m==="sap.ui.model.odata.ODataModel"||m==="sap.ui.model.odata.v2.ODataModel"){return true;}}}}}};
U.determineTargetIndex=function(s,o,C,i){var h=o.getMetadata().getClass();var t=(s instanceof h)?C.length-i:C.indexOf(s)+1;return t;};
U.findSupportedBlock=function(C,s){if(this._checkIsSupportedControl(C,s)){return C;}else{C=C.getParent();while(C){if(this._checkIsSupportedControl(C,s)){return C;}C=C.getParent();}}};
U.createFieldLabelId=function(o,s,B){var C=o.getId()+"_"+s+"_"+B;C=C.replace("/","_");return C;};
U.getLabelForElement=function(o){var s=o.getLabelText?o.getLabelText():undefined;if(!s){s=o.getLabel?o.getLabel():undefined;}if(!s){s=o.getText?o.getText():undefined;}return(typeof s)==="string"?s:undefined;};
U.getPathFromBindingInfo=function(i,B){var p=B[i]?B[i]:undefined;if(p){if((p.parts instanceof Array)&&p.parts.length>0){p=p.parts[0]?p.parts[0]:undefined;}p=((typeof p.path)==="string")?p.path:p;}if((typeof p)==="string"){p=p;}else{p=undefined;}return p;};
U.getBoundEntityType=function(o,m){var _=m?m:o.getModel();var B=o.getBindingContext();var h=_.oMetadata._getEntityTypeByPath(B.getPath());return h.name;};
U.openNewWindow=function(u){window.open(u,"_blank");};
U.fetchODataPropertiesFor=function(m){var t=this;if(!m){return new Promise(function(r,h){h();});}var o=m.getMetaModel();return o.loaded().then(function(){t._oMetadataAnalyzer=new g(m);var h=new E(t._oMetadataAnalyzer);var i=t._oMetadataAnalyzer.getAllEntityTypeNames();var A={};i.forEach(function(s){A[s]=t._oMetadataAnalyzer.getFieldsByEntityTypeName(s);});Object.keys(A).forEach(function(s){A[s]=h._updateAndFilterFields(A[s]);});return A;},function(r){q.sap.log.error("MetadataModel could not be loaded",r);});};
U.getElementBindingPaths=function(o){var p={};if(o.mBindingInfos){for(var i in o.mBindingInfos){var P=o.mBindingInfos[i].parts[0].path?o.mBindingInfos[i].parts[0].path:"";P=P.split("/")[P.split("/").length-1];p[P]={valueProperty:i};}}return p;};
U.findFieldBindingPathInFieldsArray=function(p,h){var P=Object.keys(p);var D=Object.keys(h);var s="";P.forEach(function(i){if(D.indexOf(i)>=0){s=D[D.indexOf(i)];}});return s;};
U.createNewAddFieldsCommand=function(s,o,i,j,l,v,h){q.sap.require("sap.ui.rta.command.CommandFactory");var A=sap.ui.rta.command.CommandFactory.getCommandFor(o,"Add",{newControlId:U.createNewSmartFormGroupElementId(s,h),index:i,jsTypes:j,labels:l,fieldValues:h,valuePropertys:v});return A;};
U.createNewSmartFormGroupElementId=function(p,P){var s="";var t=P.slice();var h=t.sort();for(var i=0;i<h.length;i++){var j=h[i].replace("/","_");s=s+"__"+j;}return p.getId()+s;};
return U;},true);
sap.ui.predefine('sap/ui/rta/command/BaseCommand',['sap/ui/base/ManagedObject'],function(M){"use strict";
var B=M.extend("sap.ui.rta.command.BaseCommand",{metadata:{library:"sap.ui.rta",properties:{element:{type:"sap.ui.core.Element"},elementId:{type:"string"},name:{type:"string"}},associations:{},events:{}}});
B.ERROR_UNKNOWN_ID="no element for id: ";
B.prototype.prepareActionData=function(){};
B.prototype._executeWithElement=function(e){};
B.prototype.execute=function(){this._withElement(this._executeWithElement.bind(this));};
B.prototype._undoWithElement=function(e){};
B.prototype.undo=function(){this._withElement(this._undoWithElement.bind(this));};
B.prototype._withElement=function(f){var e=this._getElement();if(e){f(e);}else{jQuery.sap.log.error(this.getMetadata().getName(),B.ERROR_UNKNOWN_ID+this.getElementId());}};
B.prototype.serialize=function(){};
B.prototype.isEnabled=function(){return true;};
B.deserialize=function(c){};
B.prototype._getElement=function(){var e=this.getElement();if(!e){e=sap.ui.getCore().byId(this.getElementId());this.setElement(e);}return e;};
return B;},true);
sap.ui.predefine('sap/ui/rta/command/CommandFactory',['sap/ui/base/ManagedObject','sap/ui/rta/controlAnalyzer/ControlAnalyzerFactory','sap/ui/fl/registry/ChangeRegistry'],function(M,C,a){"use strict";var g=function(s,h){var r=a.getInstance().getRegistryItems({controlType:s,changeTypeName:h});if(r&&r[s]&&r[s][h]){var R=r[s][h];return R.getChangeTypeMetadata().getChangeHandler();}else{jQuery.sap.log.warning("No '"+h+"' change handler for "+s+" registered");}};var c=function(E,o,s){var h=o.getName();var A=C.getControlAnalyzerFor(E);if(A.mapSettings){s=A.mapSettings(h,E,s);}var i=A.getConfiguredElement(E);var j=i.getMetadata().getName();var k=A.getFlexChangeType(h,E,s);if(k){var l=g(j,k);if(l){o.setChangeHandler(l);o.setChangeType(k);if(E!==i&&o.setOriginalElement){var S=A._getStableElementForCommand(E);o.setOriginalElement(S);}}}else{jQuery.sap.log.warning("No "+h+" change type registered for "+j);}return true;};var f=function(E,o,s,h){var S=s.source.publicAggregation;var A=h.createAggregationDesignTimeMetadata(S);var i=s.movedElements[0].element||sap.ui.getCore().byId(s.movedElements[0].id);var j=A.getMoveAction(i);A.destroy();if(!j){return false;}var k=E.getMetadata().getName();var l=g(k,j);if(!l){return false;}o.setChangeHandler(l);o.setChangeType(j);return true;};var b=function(E,o,s,D){var h=D.changeType;if(!h){return false;}var i=E.getMetadata().getName();var j=g(i,h);if(!j){return false;}o.setChangeHandler(j);o.setChangeType(h);o.setDesignTimeMetadata(D);return true;};var d=function(E,o,s,D){var r=s.removedElement||sap.ui.getCore().byId(s.removedElement.id);var A=D.getAction("remove",r);var h=A&&A.changeType;if(!h){return false;}var i=E.getMetadata().getName();var j=g(i,h);if(!j){return false;}o.setRemoveMetadata(A);o.setChangeHandler(j);o.setChangeType(h);return true;};var F=function(E,s){var A=C.getControlAnalyzerFor(E);return A.getCommandClass(s);};var G=function(E){var A=C.getControlAnalyzerFor(E);return A.getConfiguredElement(E);};var m={"Hide":{findClass:F,configure:c},"Unhide":{findClass:F,configure:c},"Stash":{clazz:'sap.ui.rta.command.Stash'},"Unstash":{clazz:'sap.ui.rta.command.Unstash'},"Ungroup":{clazz:'sap.ui.rta.command.Ungroup'},"Group":{clazz:'sap.ui.rta.command.Group'},"Move":{clazz:'sap.ui.rta.command.Move',configure:f},"Remove":{clazz:'sap.ui.rta.command.Remove',configure:d},"Add":{findClass:F,configure:c},"Composite":{clazz:'sap.ui.rta.command.CompositeCommand'},"Rename":{clazz:'sap.ui.rta.command.Rename',configure:b},"Property":{clazz:'sap.ui.rta.command.Property'},"BindProperty":{clazz:'sap.ui.rta.command.BindProperty'}};
var e=M.extend("sap.ui.rta.command.CommandFactory",{metadata:{library:"sap.ui.rta",properties:{},associations:{},events:{}}});
e.getCommandFor=function(E,s,S,D){var h=m[s];var i;if(h.findClass){i=h.findClass(E,s);}else{i=h.clazz;}jQuery.sap.require(i);var j=jQuery.sap.getObject(i);var o=G(E);S=jQuery.extend(S,{element:o,name:s});var k=new j(S);var l=true;if(h.configure){l=h.configure(E,k,S,D);}if(l){k.prepareActionData();return k;}else{k.destroy();}};
return e;},true);
sap.ui.predefine('sap/ui/rta/command/CompositeCommand',['sap/ui/rta/command/BaseCommand'],function(B){"use strict";
var C=B.extend("sap.ui.rta.command.CompositeCommand",{metadata:{library:"sap.ui.rta",properties:{},aggregations:{commands:{type:"sap.ui.rta.command.BaseCommand",multiple:true}},events:{}}});
C.prototype.execute=function(){this._forEachCommand(function(c){c.execute();});};
C.prototype.undo=function(){this._forEachCommandInReverseOrder(function(c){c.undo();});};
C.prototype._forEachCommand=function(d){var c=this.getCommands();c.forEach(d,this);};
C.prototype._forEachCommandInReverseOrder=function(d){var c=this.getCommands();for(var i=c.length-1;i>=0;i--){d.call(this,c[i]);}};
return C;},true);
sap.ui.predefine('sap/ui/rta/command/FlexCommand',['sap/ui/rta/command/BaseCommand',"sap/ui/fl/FlexControllerFactory","sap/ui/fl/changeHandler/JsControlTreeModifier","sap/ui/fl/Utils"],function(B,F,J,U){"use strict";
var a=B.extend("sap.ui.rta.command.FlexCommand",{metadata:{library:"sap.ui.rta",properties:{changeHandler:{type:"object"},changeType:{type:"string"}},associations:{},events:{}}});
a.FORWARD=true;a.BACKWARD=false;
a.prototype.getPreparedActionData=function(f){f=(f===a.FORWARD||f===a.BACKWARD)?f:true;if(f){return this._forwardPreparedActionData;}else{return this._backwardPreparedActionData;}};
a.prototype.prepareActionData=function(){this._forwardPreparedActionData=this._getForwardActionData(this._getElement());this._backwardPreparedActionData=this._getBackwardActionData(this._getElement());};
a.prototype._executeWithElement=function(e){var c=this._getForwardActionData(e);this._applyChange(c);};
a.prototype._getForwardActionData=function(e){return{change:this._completeChangeContent({changeType:this.getChangeType(),selector:{id:this._getElement().getId()}}),selectorElement:this._getElement()};};
a.prototype._getBackwardActionData=function(e){};
a.prototype._undoWithElement=function(e){var p=this.getPreparedActionData(a.BACKWARD);if(p){this._applyChange(p);}else{jQuery.log.warning("Undo functionality not supported for element with id "+e.getId());}};
a.prototype._completeChangeContent=function(s){var f=F.createForControl(this.getElement());return f.createChange(s,this.getElement());};
a.prototype._applyChange=function(c){var C=c.change||c;var A=U.getAppComponentForControl(this.getElement());var s=J.bySelector(C.getSelector(),A);this.getChangeHandler().applyChange(C,s,{modifier:J,appComponent:A});};
return a;},true);
sap.ui.predefine('sap/ui/rta/controlAnalyzer/Base',['sap/ui/base/ManagedObject','sap/ui/dt/ElementUtil','sap/ui/fl/Utils'],function(M,E,F){"use strict";var e=["sap.ui.comp.smartform.SmartForm","sap.ui.comp.smartform.Group","sap.ui.comp.smartform.GroupElement","sap.uxap.ObjectPageSection","sap.uxap.ObjectPageLayout"];if(F.isVendorLayer()){e=e.concat(["sap.ui.comp.smartfilterbar.SmartFilterBar","sap.ui.comp.smarttable.SmartTable","sap.uxap.ObjectPageHeader","sap.uxap.ObjectPageHeaderActionButton","sap.ui.table.Column"]);}
var B=M.extend("sap.ui.rta.controlAnalyzer.Base",{
constructor:function(){sap.ui.base.ManagedObject.prototype.constructor.apply(this,arguments);this._mAvailableElements={};this._mHiddenElements={};},
metadata:{library:"sap.ui.rta",properties:{control:"sap.ui.core.Control",selectedControl:"sap.ui.core.Control",prepared:{type:"boolean",defaultValue:false}}}
});
B.prototype._raiseIllegalState=function(){jQuery.sap.log.error("Illegal state, analyzer is not prepared");};
B.prototype.prepare=function(){this.setPrepared(true);};
B.prototype.getAvailableElements=function(){if(!this.getPrepared()){this._raiseIllegalState();}return this._mAvailableElements;};
B.prototype.getHiddenElements=function(){if(!this.getPrepared()){this._raiseIllegalState();}return this._mHiddenElements;};
B.prototype.mapSpecificChangeData=function(t,s){return s;};
B.prototype.getControlsFieldCollection=function(c){};
B.prototype.createChangeData=function(c,C,h){return null;};
B.prototype.findVisibleAndBoundFieldsAndLabelNames=function(c){};
B.prototype.isCustomFieldAvailable=function(c){return Promise.resolve().then(function(){return false;});};
B.prototype.checkTargetZone=function(p,a,m){return true;};
B.prototype.getFlexChangeType=function(t,o,s){return null;};
B.prototype.getCommandClass=function(c){var C;switch(c){case"Rename":C='sap.ui.rta.command.Rename';break;case"Hide":C='sap.ui.rta.command.Hide';break;case"Unhide":C='sap.ui.rta.command.Unhide';break;case"Add":C='sap.ui.rta.command.AddSmart';break;default:break;}return C;};
B.prototype.getConfiguredElement=function(m,c){var C=m.context?m.context:m;return C;};
B.prototype.isEditable=function(o){var i;i=e.some(function(t){return E.isInstanceOf(o,t);});if(i){i=o.getVisible?o.getVisible():true;if(i){i=F.checkControlId(o);}}return i;};
B.prototype.isMandatory=function(o){return false;};
B.prototype.isHideable=function(o){return false;};
B.prototype.hasParentStableId=function(o){var b=o.getParentElementOverlay();var a=b?b.getElementInstance():null;return a&&F.checkControlId(a);};
B.prototype.isRenamable=function(o){return this.isEditable(o)&&this.getRenamableControl(o);};
B.prototype.getRenamableControl=function(o){return null;};
return B;},true);
sap.ui.predefine('sap/ui/rta/controlAnalyzer/ControlAnalyzerFactory',['sap/ui/rta/controlAnalyzer/SmartForm','sap/ui/rta/controlAnalyzer/Form','sap/ui/rta/controlAnalyzer/ObjectPage'],function(){"use strict";var C={};var _={'sap.ui.comp.smartform':{'Constructor':sap.ui.rta.controlAnalyzer.SmartForm},'sap.ui.layout.form':{'Constructor':sap.ui.rta.controlAnalyzer.Form},'sap.uxap':{'Constructor':sap.ui.rta.controlAnalyzer.ObjectPage},'sap':{'Constructor':sap.ui.rta.controlAnalyzer.Base},'findControlAnalyzerByName':function(c,n){var r=c._mapOfControllers[n];if(!r){var i=n.lastIndexOf('.');if(i>0){r=c._mapOfControllers.findControlAnalyzerByName(c,n.substr(0,i));}else if(i===-1){r=c._mapOfControllers.sap;}}return r;}};C._mapOfControllers=_;
C.getControlAnalyzerFor=function(c){var r=null;if(c){var t=c.getMetadata().getName();var d=this._mapOfControllers.findControlAnalyzerByName(this,t);if(d){r=d.instance=new d.Constructor({"control":c});}}return r;};
return C;},true);
sap.ui.predefine('sap/ui/rta/controlAnalyzer/ObjectPage',['sap/ui/rta/controlAnalyzer/Base','sap/ui/rta/Utils','sap/ui/dt/ElementUtil','sap/ui/core/StashedControlSupport'],function(B,U,E,S){"use strict";
var O=B.extend("sap.ui.rta.controlAnalyzer.ObjectPage",{metadata:{library:"sap.ui.rta"}});
O.prototype.setControl=function(c){var o=U.getClosestTypeForControl(c,"sap.uxap.ObjectPageLayout");this.setProperty("control",o,true);this.setProperty("selectedControl",c,true);};
O.prototype.getSelectedBlock=function(c){return U.findSupportedBlock(c,["sap.uxap.ObjectPageLayout"]);};
O.prototype.getClosestType=function(c){return U.getClosestTypeForControl(c,"sap.uxap.ObjectPageLayout");};
O.prototype.getControlsFieldCollection=function(c){throw new Error('getControlsFieldCollection not yet implemented in ObjectPage');};
O.prototype.createChangeData=function(c,C,h,s){var m={};var b=c.getBindingContext().getObject();var a=b.controlId?b.controlId:b.fieldLabel;var o=sap.ui.getCore().byId(a);var d=!!o;var f=function(){if(d){if(b.visibilityType==="hide"){m={controlId:a,changeType:h?"hideControl":"unhideControl"};}else if(b.visibilityType==="stash"){var e=U.getObjectPageSections(C);var t=U.determineTargetIndex(s,C,e,1);m={controlId:a,changeType:h?"stashControl":"unstashControl",parentAggregationName:"sections",iTargetIndex:t};}}return m;};return new Promise(function(r,e){r(f());});};
O.prototype.findVisibleAndBoundFieldsAndLabelNames=function(c){var v=[];var f={};var F={};var e=E.findAllPublicElements(c);var i=0;for(i=0;i<e.length;i++){var o=e[i];if(o instanceof sap.m.ObjectAttribute){v.push(o.getBindingPath("text"));}}return{visibleAndBoundFields:v,fieldsAndLabelNames:f,fieldsAndBoundPropertyName:F};};
O.prototype.prepare=function(){var c=this.getControl();var s=U.getObjectPageSections(c);if(!this.getPrepared()){for(var i=0;i<s.length;i++){var t=s[i].getTitle?s[i].getTitle():s[i].getId();if(s[i].getStashed&&(s[i].getStashed()||s[i].getVisible()===false)){this._mAvailableElements[s[i].getId()]={fieldLabel:t,quickInfo:t,entityType:"",controlId:s[i].getId(),visibilityType:"stash"};}else if(s[i].getVisible&&s[i].getVisible()===false){this._mAvailableElements[s[i].getTitle()]={fieldLabel:t,quickInfo:t,entityType:"",controlId:s[i].getId(),visibilityType:"hide"};}else{this._mHiddenElements[s[i].getTitle()]={fieldLabel:t,quickInfo:t,entityType:"",controlId:s[i].getId(),visibilityType:"hide"};}}sap.ui.rta.controlAnalyzer.Base.prototype.prepare.apply(this);}return Promise.resolve();};
O.prototype.checkTargetZone=function(p,a,m){if(E.isInstanceOf(m,"sap.uxap.ObjectPageSection")){if(E.isInstanceOf(p,"sap.uxap.ObjectPageLayout")){if(m.getParent()===p&&a==="sections"){return true;}}}};
O.prototype.isHideable=function(e){return(E.isInstanceOf(e,"sap.uxap.ObjectPageSection")&&!this.isMandatory(e));};
return O;},true);
sap.ui.predefine('sap/ui/rta/library',['jquery.sap.global','sap/ui/core/Core','sap/ui/core/library'],function(q,C,c){"use strict";sap.ui.getCore().initLibrary({name:"sap.ui.rta",version:"1.42.7",dependencies:["sap.ui.core","sap.m","sap.ui.fl"],types:[],interfaces:[],controls:["sap.ui.rta.ContextMenu","sap.ui.rta.ui.ToolsMenu","sap.ui.rta.AddElementsDialog"],elements:[]});return sap.ui.rta;},true);
sap.ui.predefine('sap/ui/rta/model/ElementPreprocessor',['jquery.sap.global'],function(q){"use strict";var E=function(m){this._oMetadataAnalyzer=m;this._aEntityTypes=[];this.invisibleFields={};};
E.prototype._updateAndFilterFields=function(F,i,I,k){var v=[];for(var f=0;f<F.length;f++){var c=F[f];if(c.visible===false){this.invisibleFields[k]=this.invisibleFields[k]||[];if(this.invisibleFields[k].indexOf(c)===-1){c.isComplexType=I;this.invisibleFields[k].push(c);}continue;}var b=this._isFieldOnIgnoreList(c,i,I);var a=this._isFieldBlacklisted(c);if(!b&&!a){if(this._isComplexType(c)===true){var V=this._resolveComplexTypeToFlatFieldList(c,i);if(V){v=v.concat(V);}}else{v.push(c);}}}return v;};
E.prototype._isComplexType=function(f){if(f&&f.type){if(f.type.toLowerCase().indexOf("edm")!==0){return true;}}return false;};
E.prototype._isFieldBlacklisted=function(c){if(c){if(c.name.toLowerCase().indexOf("uxfc")===0){return true;}else if(c.type.toLowerCase()==="edm.time"){return true;}}return false;};
E.prototype._resolveComplexTypeToFlatFieldList=function(c,I){var r=[];var s=this._oMetadataAnalyzer.getSchemaDefinition();if(c&&c.type&&s){var t=this._getComplexTypeName(c);if(t){var C=s.complexType;var i=0;for(i=0;i<C.length;i++){var o=C[i];o["complexTypePropertyName"]=c.name;o.entityName=c.entityName;if(o.name===t){r=this._getFieldsFromComplexType(o,I);break;}}}}return r;};
E.prototype._getFieldsFromComplexType=function(c,I){var f=this._oMetadataAnalyzer.getFieldsByComplexTypeName(c.name);if(f){for(var i=0;i<f.length;i++){f[i]["isComplexProperty"]=true;f[i]["entityName"]=c.entityName;f[i]["complexTypePropertyName"]=c.complexTypePropertyName;}return this._updateAndFilterFields(f,I,true,c.name);}return[];};
E.prototype._getComplexTypeName=function(c){var t=c.type.split(".");if(t.length===2){return t[1];}return null;};
E.prototype._isFieldOnIgnoreList=function(c,i,I){if(i){var n=this._aEntityTypes.length;var Q=c.entityName+"."+c.name;if(n===1&&!I){if(i.indexOf(c.name)!==-1||i.indexOf(Q)!==-1){return true;}}else if(i.indexOf(Q)!==-1){return true;}}return false;};
E.prototype._getEntityTypes=function(v,a){var b=[];var l;var c;if(!this._oMetadataAnalyzer||!this._oMetadataAnalyzer._oSchemaDefinition){return[];}var A=this._oMetadataAnalyzer._oSchemaDefinition.entityType;if(!v){c=[];for(var t=0;t<A.length;t++){c.push(A[t].name);}}if(!c){c=this._convertEntityTypesToArray(v);}for(var e=0;e<c.length;e++){l=this._oMetadataAnalyzer.getEntityLabelByEntityTypeName(c[e]);b.push({key:c[e],label:l||c[e]});}return b;};
E.prototype._convertEntityTypesToArray=function(e){if(typeof(e)==="string"){var r=e.replace(/ /g,'');return r.split(',');}if(q.isArray(e)){return e;}return undefined;};
E.prototype.destroy=function(){if(this._oMetadataAnalyzer&&this._oMetadataAnalyzer.destroy){this._oMetadataAnalyzer.destroy();}this._oMetadataAnalyzer=null;this._aEntityTypes=null;};
return E;},true);
sap.ui.predefine('sap/ui/rta/plugin/DragDrop',['jquery.sap.global','sap/ui/dt/plugin/ControlDragDrop','sap/ui/rta/plugin/RTAElementMover'],function(q,C,R){"use strict";
var D=C.extend("sap.ui.rta.plugin.DragDrop",{metadata:{library:"sap.ui.rta",properties:{elementMover:{type:"sap.ui.dt.plugin.ElementMover"}},associations:{},events:{dragStarted:{}}}});
D.prototype.init=function(){C.prototype.init.apply(this,arguments);this.setElementMover(new R());};
D.prototype.registerElementOverlay=function(o){if(o.isMovable()){this._attachMovableBrowserEvents(o);}C.prototype.registerElementOverlay.apply(this,arguments);};
D.prototype.deregisterElementOverlay=function(o){C.prototype.deregisterElementOverlay.apply(this,arguments);this._detachMovableBrowserEvents(o);};
D.prototype._attachMovableBrowserEvents=function(o){o.attachBrowserEvent("mouseover",this._onMouseOver,this);o.attachBrowserEvent("mouseleave",this._onMouseLeave,this);};
D.prototype._detachMovableBrowserEvents=function(o){o.detachBrowserEvent("mouseover",this._onMouseOver,this);o.detachBrowserEvent("mouseleave",this._onMouseLeave,this);};
D.prototype.onDragStart=function(o){this.fireDragStarted();C.prototype.onDragStart.apply(this,arguments);this.getDesignTime().getSelection().forEach(function(o){o.setSelected(false);});o.$().addClass("sapUiRtaOverlayPlaceholder");};
D.prototype.onDragEnd=function(o){C.prototype.onDragEnd.apply(this,arguments);o.$().removeClass("sapUiRtaOverlayPlaceholder");o.setSelected(true);o.focus();};
D.prototype.onMovableChange=function(o){C.prototype.onMovableChange.apply(this,arguments);if(o.isMovable()){this._attachMovableBrowserEvents(o);}else{this._detachMovableBrowserEvents(o);}};
D.prototype._onMouseOver=function(e){var o=sap.ui.getCore().byId(e.currentTarget.id);if(o!==this._oPreviousHoverTarget){if(this._oPreviousHoverTarget){this._oPreviousHoverTarget.$().removeClass("sapUiRtaOverlayHover");}this._oPreviousHoverTarget=o;o.$().addClass("sapUiRtaOverlayHover");}e.preventDefault();e.stopPropagation();};
D.prototype._onMouseLeave=function(e){if(this._oPreviousHoverTarget){this._oPreviousHoverTarget.$().removeClass("sapUiRtaOverlayHover");}delete this._oPreviousHoverTarget;e.preventDefault();e.stopPropagation();};
return D;},true);
sap.ui.predefine('sap/ui/rta/plugin/MultiSelection',['sap/ui/dt/Plugin','sap/ui/dt/ElementUtil','sap/ui/rta/Utils'],function(P,E,R){"use strict";
var M=P.extend("sap.ui.rta.plugin.MultiSelection",{metadata:{library:"sap.ui.rta",properties:{multiSelectionTypes:{type:"string[]"}}}});
M.prototype.init=function(){P.prototype.init.apply(this,arguments);this._fnKeyDown=this._onKeyDown.bind(this);this._fnKeyUp=this._onKeyUp.bind(this);window.addEventListener("keydown",this._fnKeyDown);window.addEventListener("keyup",this._fnKeyUp);};
M.prototype.exit=function(){P.prototype.exit.apply(this,arguments);window.removeEventListener("keydown",this._fnKeyDown);window.removeEventListener("keyup",this._fnKeyUp);};
M.prototype.setDesignTime=function(d){this._oDesignTime=d;if(this._oDesignTime){this._oDesignTime.detachSelectionChange(this._onDesignTimeSelectionChange,this);}P.prototype.setDesignTime.apply(this,arguments);if(d){d.attachSelectionChange(this._onDesignTimeSelectionChange,this);}};
M.prototype._onKeyDown=function(e){if(sap.ui.Device.os.name===sap.ui.Device.os.OS.WINDOWS){if(e.keyCode===17){this._oDesignTime.setSelectionMode(sap.ui.dt.SelectionMode.Multi);}}else if(sap.ui.Device.os.name===sap.ui.Device.os.OS.MACINTOSH){if(e.keyCode===91||e.keyCode===93){this._oDesignTime.setSelectionMode(sap.ui.dt.SelectionMode.Multi);}}};
M.prototype._onKeyUp=function(e){if(sap.ui.Device.os.name===sap.ui.Device.os.OS.WINDOWS){if(e.keyCode===17){this._oDesignTime.setSelectionMode(sap.ui.dt.SelectionMode.Single);}}else if(sap.ui.Device.os.name===sap.ui.Device.os.OS.MACINTOSH){if(e.keyCode===91||e.keyCode===93){this._oDesignTime.setSelectionMode(sap.ui.dt.SelectionMode.Single);}}};
M.prototype._onDesignTimeSelectionChange=function(e){if(this._oDesignTime.getSelectionMode()===sap.ui.dt.SelectionMode.Single){return;}var m=this.getMultiSelectionTypes();var b=true;var c=e.getParameter("selection")[e.getParameter("selection").length-1];var s=this._oDesignTime.getSelection();if(s&&s.length===1){c.setSelected(true);return;}if(!c||this._oDesignTime.getSelectionMode()===sap.ui.dt.SelectionMode.Single){return;}m.forEach(function(t,i,a){s.forEach(function(S){if(!E.isInstanceOf(S.getElementInstance(),t)){b=false;}});c.setSelected(b);});};
return M;},true);
sap.ui.predefine('sap/ui/rta/plugin/RTAElementMover',['sap/ui/dt/plugin/ElementMover','sap/ui/dt/OverlayUtil','sap/ui/dt/ElementUtil','sap/ui/fl/Utils','sap/ui/rta/controlAnalyzer/ControlAnalyzerFactory','sap/ui/rta/Utils','sap/ui/rta/command/CommandFactory'],function(E,O,a,F,C,U,b){"use strict";
var R=E.extend("sap.ui.rta.plugin.RTAElementMover",{metadata:{library:"sap.ui.rta",properties:{commandFactory:{type:"object",defaultValue:b},movableTypes:{type:"string[]",defaultValue:["sap.ui.core.Element"]}},associations:{},events:{}}});
R.prototype._hasParentStableId=function(o){var B=o.getParentElementOverlay();var c=B?B.getElementInstance():null;return c&&F.checkControlId(c);};
R.prototype.checkMovable=function(o){var m=E.prototype.checkMovable.apply(this,arguments);var e;var c;if(m){e=o.getElementInstance();c=C.getControlAnalyzerFor(e);m=c.isEditable(e);if(m){var p=o.getPublicParentAggregationOverlay();if(p){var P=p.getDesignTimeMetadata();var M=P.getMoveAction(e);m=!!(M);}else{m=false;}}}return m&&c.hasParentStableId(o);};
R.prototype.checkTargetZone=function(A){var t=E.prototype.checkTargetZone.call(this,A);if(t){var m=this.getMovedOverlay();var M=m.getElementInstance();var o=A.getParent();var p=o.getElementInstance();var s=A.getAggregationName();var c=C.getControlAnalyzerFor(M);t=c.isEditable(p)&&c.checkTargetZone(p,s,M);}return t;};
return R;},true);
sap.ui.predefine('sap/ui/rta/plugin/Rename',['jquery.sap.global','sap/ui/dt/Plugin','sap/ui/dt/ElementUtil','sap/ui/dt/OverlayUtil','sap/ui/dt/OverlayRegistry','sap/ui/rta/Utils','sap/ui/rta/command/Stack','sap/ui/rta/command/CommandFactory','sap/ui/dt/DOMUtil'],function(q,P,E,O,a,U,C,b,D){"use strict";
var R=P.extend("sap.ui.rta.plugin.Rename",{metadata:{library:"sap.ui.rta",properties:{commandStack:{type:"sap.ui.rta.commandStack"},oldValue:"string"},associations:{},events:{"editable":{},"nonEditable":{}}}});
R.prototype.exit=function(){P.prototype.exit.apply(this,arguments);if(this._$oEditableControlDomRef){this._stopEdit();}clearTimeout(this._iStopTimeout);};
R.prototype.setDesignTime=function(d){this._aSelection=[];var o=this.getDesignTime();if(o){o.detachSelectionChange(this._onDesignTimeSelectionChange,this);}P.prototype.setDesignTime.apply(this,arguments);if(d){d.attachSelectionChange(this._onDesignTimeSelectionChange,this);this._aSelection=d.getSelection();}};
R.prototype._getEffectiveDesignTimeMetadata=function(o){var d;if(o.isInHiddenTree()){var p=o.getPublicParentAggregationOverlay();if(p){d=p.getDesignTimeMetadata();}}else{d=o.getDesignTimeMetadata();}return d;};
R.prototype._getRenameAction=function(o){var d=this._getEffectiveDesignTimeMetadata(o);if(d&&d.getAction){return d.getAction("rename",o.getElementInstance());}else{return;}};
R.prototype.isRenameAvailable=function(o){var r=this._getRenameAction(o);if(r){return true;}else{return false;}};
R.prototype.isRenameEnabled=function(o){var A=this._getRenameAction(o);if(!A){return false;}if(typeof A.isEnabled!=="undefined"){if(typeof A.isEnabled==="function"){return A.isEnabled(o.getElementInstance());}else{return A.isEnabled;}}return true;};
R.prototype.registerElementOverlay=function(o){o.attachEvent("editableChange",this._manageClickEvent,this);if(this.isRenameAvailable(o)){o.setEditable(true);}};
R.prototype.deregisterElementOverlay=function(o){o.detachEvent("editableChange",this._manageClickEvent,this);o.detachBrowserEvent("click",this._onClick,this);};
R.prototype._onClick=function(e){var o=sap.ui.getCore().byId(e.currentTarget.id);if(this.isRenameEnabled(o)){this.startEdit(o);e.preventDefault();}};
R.prototype._onDesignTimeSelectionChange=function(e){var t=this;var s=e.getParameter("selection");s.forEach(function(o){if(t._aSelection.indexOf(o)===-1){t._aSelection.push(o);}});t._aSelection.forEach(this._manageClickEvent,this);};
R.prototype._manageClickEvent=function(e){var o=e.getSource?e.getSource():e;if(o.isSelected()&&this.isRenameAvailable(o)){o.attachBrowserEvent("click",this._onClick,this);}else{o.detachBrowserEvent("click",this._onClick,this);}};
R.prototype.startEdit=function(o){this._oEditedOverlay=o;var e=o.getElementInstance();var d=this._getEffectiveDesignTimeMetadata(this._oEditedOverlay);var c=d.getAction("rename",e).domRef(e);this._$oEditableControlDomRef=q(c);var f=sap.ui.dt.OverlayRegistry.getOverlay(c.id)||o;var w=q("<div class='sapUiRtaEditableField'></div>").appendTo(f.$());this._$editableField=q("<div contentEditable='true'></div>").appendTo(w);if(this._$oEditableControlDomRef.text()===""){this._$oEditableControlDomRef.text("_?_");this._$editableField.text("");}else{this._$editableField.text(this._$oEditableControlDomRef.text());}D.copyComputedStyles(this._$oEditableControlDomRef,this._$editableField);this._$editableField.children().remove();this._$editableField.css({"-moz-user-modify":"read-write","-webkit-user-modify":"read-write","-ms-user-modify":"read-write","user-modify":"read-write","text-overflow":"clip","margin-top":parseInt(this._$editableField.css("margin-top"),10)-1+"px","margin-left":parseInt(this._$editableField.css("margin-left"),10)-1+"px"});this._$oEditableControlDomRef.css("visibility","hidden");this._$editableField.one("focus",this._onEditableFieldFocus.bind(this));this._$editableField.on("blur",this._onEditableFieldBlur.bind(this));this._$editableField.on("keydown",this._onEditableFieldKeydown.bind(this));this._$editableField.on("dragstart",this._stopPropagation.bind(this));this._$editableField.on("drag",this._stopPropagation.bind(this));this._$editableField.on("dragend",this._stopPropagation.bind(this));this._$editableField.on("click",this._stopPropagation.bind(this));this._$editableField.on("mousedown",this._stopPropagation.bind(this));this._$editableField.focus();this.setOldValue(this._getCurrentEditableFieldText());};
R.prototype._stopPropagation=function(e){e.stopPropagation();};
R.prototype._onEditableFieldFocus=function(e){this._oEditedOverlay.setSelected(false);var c=e.target;var r=document.createRange();r.selectNodeContents(c);var s=window.getSelection();s.removeAllRanges();s.addRange(r);};
R.prototype._stopEdit=function(r){if(this._$oEditableControlDomRef.text()==="_?_"){this._$oEditableControlDomRef.text("");}this._oEditedOverlay.$().find(".sapUiRtaEditableField").remove();this._$oEditableControlDomRef.css("visibility","visible");if(r){var o=this._oEditedOverlay;this._iStopTimeout=setTimeout(function(){o.setSelected(true);o.focus();},0);}delete this._$editableField;delete this._$oEditableControlDomRef;delete this._oEditedOverlay;};
R.prototype._onEditableFieldBlur=function(e){this._emitLabelChangeEvent();this._stopEdit();};
R.prototype._onEditableFieldKeydown=function(e){if(e.keyCode===q.sap.KeyCodes.ENTER){e.preventDefault();this._emitLabelChangeEvent();this._stopEdit(true);}else if(e.keyCode===q.sap.KeyCodes.ESCAPE){e.preventDefault();this._stopEdit(true);}};
R.prototype._emitLabelChangeEvent=function(){var t=this._getCurrentEditableFieldText();if(this.getOldValue()!==t){this._$oEditableControlDomRef.text(t);try{var r;var e;var o=this._oEditedOverlay.getElementInstance();if(this._oEditedOverlay.isInHiddenTree()){e=this._oEditedOverlay.getPublicParentElementOverlay().getElementInstance();}else{e=o;}r=b.getCommandFor(e,"Rename",{renamedElement:o,newValue:t},this._getRenameAction(this._oEditedOverlay));this.getCommandStack().pushAndExecute(r);}catch(c){q.sap.log.error("Error during rename : ",c);}}};
R.prototype._getCurrentEditableFieldText=function(){return this._$editableField.text();};
return R;},true);
sap.ui.predefine('sap/ui/rta/ui/ToolsMenu',['sap/ui/rta/library','sap/ui/core/Control','sap/m/Toolbar','sap/m/ToolbarLayoutData','sap/m/ToolbarSpacer','sap/m/Label','sap/ui/core/Popup','sap/ui/fl/registry/Settings','sap/ui/fl/Utils'],function(l,C,T,a,b,L,P,F,U){"use strict";
var c=C.extend("sap.ui.rta.ui.ToolsMenu",{metadata:{library:"sap.ui.rta",aggregations:{"toolbars":{type:"sap.m.Toolbar",multiple:true,singularName:"toolbar"}},events:{"undo":{},"redo":{},"close":{},"toolbarClose":{},"restore":{},"transport":{}}}});
c.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.ui.rta");};
c.prototype.createToolbar=function(){var t=null;var z=P.getNextZIndex();if(!this._oToolBar){var A=null;var o=null;var B=null;var s=null;var d=null;t=" - "+this._oRb.getText("TOOLBAR_TITLE");A=new L({text:t,layoutData:new a({shrinkable:false})});A.bAllowTextSelection=false;t=null;o=new L({text:t,layoutData:new a({shrinkable:false})});o.bAllowTextSelection=false;t=this._oRb.getText("BTN_UNDO");this._oButtonUndo=new sap.m.Button({type:"Transparent",icon:"sap-icon://undo",enabled:false,tooltip:t,layoutData:new a({shrinkable:false})});this._oButtonUndo.data("Action","UNDO",true);this._oButtonUndo.attachEvent('press',this._onUndo,this);t=this._oRb.getText("BTN_REDO");this._oButtonRedo=new sap.m.Button({type:"Transparent",icon:"sap-icon://redo",iconFirst:false,enabled:false,tooltip:t,layoutData:new a({shrinkable:false})});this._oButtonRedo.data("Action","REDO",true);this._oButtonRedo.attachEvent('press',this._onRedo,this);t=this._oRb.getText("BTN_RESTORE");this._oButtonRestore=new sap.m.Button({type:"Transparent",text:t,visible:true,tooltip:t,layoutData:new a({shrinkable:false})});this._oButtonRestore.data("Action","RESTORE",true);this._oButtonRestore.attachEvent('press',this._onRestore,this);t=this._oRb.getText("BTN_EXIT");B=new sap.m.Button({type:"Transparent",text:t,tooltip:t,layoutData:new a({shrinkable:false})});B.data("Action","EXIT",true);B.attachEvent('press',this.close,this);t=this._oRb.getText("BTN_TRANSPORT");this._oButtonTransport=new sap.m.Button({type:"Transparent",text:t,visible:false,tooltip:t,layoutData:new a({shrinkable:false})});this._oButtonTransport.data("Action","TRANSPORT",true);this._oButtonTransport.attachEvent('press',this._onTransport,this);s=new b();this._oToolBar=new T({active:true,content:[o,A,s,this._oButtonUndo,this._oButtonRedo,this._oButtonRestore,this._oButtonTransport,B]});this._oToolBar.addStyleClass("sapUiRTAToolBar");this.addToolbar(this._oToolBar);jQuery("body").prepend('<div id="RTA-Toolbar" style="z-index: '+z+'"></div>');d=jQuery("#RTA-Toolbar").addClass("sapUiRTAToolsMenuWrapper");d=d[0];this.placeAt(d);}};
c.prototype.exit=function(){jQuery("#RTA-Toolbar").remove();};
c.prototype._onTransport=function(){this.fireTransport();};
c.prototype._checkTransportAvailable=function(){var t=this;return F.getInstance(U.getComponentClassName(this._oRootControl)).then(function(s){if(!s.isProductiveSystem()&&!s.hasMergeErrorOccured()){var i=s.isAtoEnabled();t._oButtonTransport.setVisible(true);t.adaptTransportText(i);return i;}}).catch(function(){t._oButtonTransport.setVisible(false);});};
c.prototype.show=function(){this._oToolBar.addStyleClass("sapUiRTAToolBarVisible");this._oToolBar.removeStyleClass("sapUiRTAToolBarInvisible");};
c.prototype.hide=function(){var t=this;this._oToolBar.addStyleClass("sapUiRTAToolBarInvisible");var o=document.getElementsByClassName("sapUiRTAToolBar")[0];var A=function(){t.fireClose();};o.addEventListener("webkitAnimationEnd",A);o.addEventListener("animationend",A);o.addEventListener("oanimationend",A);};
c.prototype._onUndo=function(){this.fireUndo();};
c.prototype._onRedo=function(){this.fireRedo();};
c.prototype._onRestore=function(){this.fireRestore();};
c.prototype.close=function(){this.fireToolbarClose();};
c.prototype.setTitle=function(t){var o=this._oToolBar.getContent()[0];o.setText(t);};
c.prototype.setRootControl=function(o){this._oRootControl=o;};
c.prototype.adaptTransportText=function(A){var t=null;if(A){t=this._oRb.getText("BTN_PUBLISH");}else{t=this._oRb.getText("BTN_TRANSPORT");}this._oButtonTransport.setText(t);this._oButtonTransport.setTooltip(t);};
c.prototype.adaptUndoRedoEnablement=function(d,e){this._oButtonUndo.setEnabled(d);this._oButtonRedo.setEnabled(e);};
return c;},true);
sap.ui.predefine('sap/ui/rta/ui/ToolsMenuRenderer',['jquery.sap.global'],function(q){"use strict";var T={};
T.render=function(r,c){if(c.getToolbars().length!==0){c.getToolbars().forEach(function(C){r.renderControl(C);});}};
return T;},true);
jQuery.sap.registerPreloadedModules({
"name":"sap/ui/rta/library-preload",
"version":"2.0",
"modules":{
	"sap/ui/rta/manifest.json":'{\n  "_version": "1.2.0",\n  "sap.app": {\n    "_version": "1.2.0",\n    "id": "sap.ui.rta",\n    "type": "library",\n    "embeds": [],\n    "applicationVersion": {\n      "version": "1.42.7"\n    },\n    "title": "SAPUI5 library with RTA controls.",\n    "description": "SAPUI5 library with RTA controls.",\n    "ach": "CA-UI5-RTA",\n    "resources": "resources.json",\n    "offline": true\n  },\n  "sap.ui": {\n    "_version": "1.1.0",\n    "technology": "UI5",\n    "supportedThemes": [\n      "base",\n      "sap_bluecrystal",\n      "sap_hcb"\n    ]\n  },\n  "sap.ui5": {\n    "_version": "1.1.0",\n    "dependencies": {\n      "minUI5Version": "1.42",\n      "libs": {\n        "sap.ui.core": {\n          "minVersion": "1.42.7"\n        },\n        "sap.m": {\n          "minVersion": "1.42.7"\n        }\n      }\n    }\n  }\n}',
	"sap/ui/rta/view/RemoveElementDialog.fragment.xml":'<core:FragmentDefinition xmlns:core="sap.ui.core"\n\txmlns:commons="sap.ui.commons" xmlns:layout="sap.ui.layout"\n\txmlns:sap.m="sap.m">\n\t<sap.m:Dialog class="sapUiRtaConfirmationDialog" verticalScrolling="false" title="{/titleText}" icon="{/icon}">\n\t\t<layout:VerticalLayout width="100%">\n\t\t\t<commons:TextView class="sapUiRtaConfirmationDialogText" text="{/messageText}" />\n\t\t</layout:VerticalLayout>\n\t\t<sap.m:beginButton>\n\t\t\t<sap.m:Button class="sapUiRtaConfirmationDialogRemoveButton" text="{/removeText}" press="removeField" />\n\t\t</sap.m:beginButton>\n\t\t<sap.m:endButton>\n\t\t\t<sap.m:Button class="sapUiRtaConfirmationDialogCancelButton" text="{/cancelText}" press="closeDialog" />\n\t\t</sap.m:endButton>\n\t</sap.m:Dialog>\n</core:FragmentDefinition>'
}});
