/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/uxap/AnchorBar',["sap/m/Button","sap/m/PlacementType","sap/m/Popover","sap/m/Toolbar","sap/ui/core/IconPool","sap/ui/core/Item","sap/ui/core/ResizeHandler","sap/ui/core/delegate/ScrollEnablement","sap/ui/layout/HorizontalLayout","sap/ui/Device","sap/ui/core/CustomData","./HierarchicalSelect","./library"],function(B,P,a,T,I,b,R,S,H,D,C,c,l){"use strict";
var A=T.extend("sap.uxap.AnchorBar",{metadata:{library:"sap.uxap",properties:{showPopover:{type:"boolean",defaultValue:true},upperCase:{type:"boolean",defaultValue:false}},associations:{selectedButton:{type:"sap.m.Button",multiple:false}},aggregations:{_select:{type:"sap.uxap.HierarchicalSelect",multiple:false,visibility:"hidden"},_popovers:{type:"sap.m.Popover",multiple:true,visibility:"hidden"},_scrollArrowLeft:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_scrollArrowRight:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}}}});
A.prototype.init=function(){if(T.prototype.init){T.prototype.init.call(this);}this.addStyleClass("sapUxAPAnchorBar");this._oPressHandlers={};this._oSectionInfo={};this._oScroller=null;this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._bRtlScenario=this._bRtl&&!D.browser.msie;this._bHasButtonsBar=D.system.tablet||D.system.desktop;this._oSelect=this._getHierarchicalSelect();if(this._bHasButtonsBar){this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:true,vertical:false,nonTouchScrolling:true});this._iREMSize=parseInt(jQuery("body").css("font-size"),10);this._iTolerance=this._iREMSize*1;this._iOffset=this._iREMSize*3;this._sResizeListenerId=undefined;}this.setDesign("Transparent");};
A.SCROLL_STEP=250;A.SCROLL_DURATION=500;A.DOM_CALC_DELAY=200;
A.prototype.setSelectedButton=function(o){if(typeof o==="string"){o=sap.ui.getCore().byId(o);}if(o){if(o.getId()===this.getSelectedButton()){return this;}var s=o.data("sectionId");if(s){this._oSelect.setSelectedKey(o.getId());}if(this._bHasButtonsBar){this.$().find(".sapUxAPAnchorBarButtonSelected").removeClass("sapUxAPAnchorBarButtonSelected");o.$().addClass("sapUxAPAnchorBarButtonSelected");if(s){this.scrollToSection(s,A.SCROLL_DURATION);}this._setAnchorButtonsTabFocusValues(o);}}return this.setAssociation("selectedButton",o,true);};
A.prototype.setShowPopover=function(v,s){if(this.getShowPopover()===v){return this;}var d,n=!jQuery.isEmptyObject(this._oPressHandlers);if(n){var e=this.getContent()||[];d=this.getSelectedButton();e.forEach(this._detachPopoverHandler,this);}this.setProperty("showPopover",v,true);if(n){this.rerender();if(d){this.setSelectedButton(d);}}return this;};
A.prototype.getSelectedSection=function(){var s=this.getSelectedButton();if(s&&(typeof(s)==="string")){s=sap.ui.getCore().byId(s);}if(s&&(s instanceof B)&&s.data("sectionId")){return sap.ui.getCore().byId(s.data("sectionId"));}return null;};
A.prototype.onBeforeRendering=function(){if(T.prototype.onBeforeRendering){T.prototype.onBeforeRendering.call(this);}var d=this.getContent()||[],u=this.getUpperCase(),p={oLastFirstLevelButton:null,oCurrentPopover:null};this._oSelect.removeAllItems();this._oSelect.setUpperCase(u);this.toggleStyleClass("sapUxAPAnchorBarUpperCase",u);d.forEach(function(o){this._createSelectItem(o);if(this._bHasButtonsBar){this._createPopoverSubMenu(o,p);}},this);};
A.prototype.addContent=function(o,i){o.addStyleClass("sapUxAPAnchorBarButton");o.removeAllAriaDescribedBy();if(this._bHasButtonsBar&&(o.data("secondLevel")===true||o.data("secondLevel")==="true")){o.attachPress(this._handleDirectScroll,this);}return this.addAggregation("content",o,i);};
A.prototype._createSelectItem=function(o){var i=o.data("secondLevel")===true||o.data("secondLevel")==="true";if(o.getText().trim()!=""&&(!i||o.data("bTitleVisible")===true)){var p=new b({key:o.getId(),text:o.getText(),customData:[new C({key:"secondLevel",value:o.data("secondLevel")})]});this._oSelect.addItem(p);}};
A.prototype._createPopoverSubMenu=function(o,p){var i=o.data("secondLevel")===true||o.data("secondLevel")==="true",f=null;if(i){if(p.oLastFirstLevelButton&&p.oCurrentPopover){if(!this._oPressHandlers[p.oLastFirstLevelButton.getId()]){f=jQuery.proxy(this._handlePopover,{oCurrentPopover:p.oCurrentPopover,oLastFirstLevelButton:p.oLastFirstLevelButton});p.oLastFirstLevelButton.attachPress(f);this._oPressHandlers[p.oLastFirstLevelButton.getId()]=f;}p.oCurrentPopover.addContent(o);}else if(this.getShowPopover()){jQuery.sap.log.error("sapUxApAnchorBar :: missing parent first level for item "+o.getText());}else{this.removeContent(o);o.destroy();}}else{p.oLastFirstLevelButton=o;if(this.getShowPopover()){p.oCurrentPopover=new a({placement:P.Bottom,showHeader:false,verticalScrolling:true,horizontalScrolling:false,contentWidth:"auto",showArrow:false});p.oCurrentPopover.addStyleClass("sapUxAPAnchorBarPopover");this._addKeyboardHandling(p.oCurrentPopover);this.addAggregation('_popovers',p.oCurrentPopover);}else if(!this._oPressHandlers[p.oLastFirstLevelButton.getId()]){f=jQuery.proxy(this._handleDirectScroll,this);p.oLastFirstLevelButton.attachPress(f);this._oPressHandlers[p.oLastFirstLevelButton.getId()]=f;}}};
A.prototype._addKeyboardHandling=function(o){o.onsapdown=function(e){if(e.target.nextSibling){e.target.nextSibling.focus();}};o.onsapright=function(e){o.onsapdown(e);};o.onsapup=function(e){if(e.target.previousSibling){e.target.previousSibling.focus();}};o.onsapleft=function(e){o.onsapup(e);};o.onsaphome=function(e){if(e.target.parentElement.firstChild){e.target.parentElement.firstChild.focus();}};o.onsapend=function(e){if(e.target.parentElement.lastChild){e.target.parentElement.lastChild.focus();}};o.onsappageup=this._handlePageUp.bind(o);o.onsappagedown=this._handlePageDown.bind(o);};
A.prototype._detachPopoverHandler=function(o){if(this._oPressHandlers[o.getId()]){o.detachPress(this._oPressHandlers[o.getId()]);this._oPressHandlers[o.getId()]=null;}};
A.prototype._handlePopover=function(e){var p=this.oCurrentPopover.getContent()||[];if(this.oLastFirstLevelButton.$().is(":visible")){if(p.length==1){p[0].firePress({});}else{this.oCurrentPopover.openBy(this.oLastFirstLevelButton);}}};
A.prototype._handleDirectScroll=function(e){if(e.getSource().getParent()instanceof a){e.getSource().getParent().close();}this._requestScrollToSection(e.getSource().data("sectionId"));};
A.prototype._requestScrollToSection=function(r){var o=sap.ui.getCore().byId(r),d=o.getParent();if(this.getParent()instanceof l.ObjectPageLayout){var n=r;if(o instanceof l.ObjectPageSubSection&&d instanceof l.ObjectPageSection){n=d.getId();}this.getParent().setDirectScrollingToSection(n);this.getParent().scrollToSection(o.getId(),null,0,true);}if(o instanceof l.ObjectPageSubSection&&d instanceof l.ObjectPageSection){d.setAssociation("selectedSubSection",o,true);}};
A.prototype._onSelectChange=function(e){var s=e.getParameter("selectedItem"),o;o=sap.ui.getCore().byId(s.getKey());if(o){this._requestScrollToSection(o.data("sectionId"));}else{jQuery.sap.log.error("AnchorBar :: cannot find corresponding button",s.getKey());}};
A.prototype._getHierarchicalSelect=function(){if(!this.getAggregation('_select')){this.setAggregation('_select',new c({width:"100%",icon:"sap-icon://overflow",change:jQuery.proxy(this._onSelectChange,this)}));}return this.getAggregation('_select');};
A.prototype._createScrollArrow=function(L){var s,i,d,o,t=this;if(L){s=this.getId()+"-arrowScrollLeft";i="slim-arrow-left";d="anchorBarArrowLeft";}else{s=this.getId()+"-arrowScrollRight";i="slim-arrow-right";d="anchorBarArrowRight";}o=new B(s,{icon:I.getIconURI(i),type:"Transparent",press:function(e){e.preventDefault();t._handleScrollButtonTap(L);}});o.addEventDelegate({onAfterRendering:function(){if(sap.ui.getCore().getConfiguration().getTheme()!="sap_hcb"){this.$().attr("tabindex",-1);}},onThemeChanged:function(){if(sap.ui.getCore().getConfiguration().getTheme()=="sap_hcb"){this.$().removeAttr("tabindex");}else{this.$().attr("tabindex",-1);}}},o);return new H({content:[o]}).addStyleClass("anchorBarArrow").addStyleClass(d);};
A.prototype._getScrollArrowLeft=function(){var s=this.getAggregation("_scrollArrowLeft");if(s){return s;}else{s=this._createScrollArrow(true);this.setAggregation("_scrollArrowLeft",s);return s;}};
A.prototype._getScrollArrowRight=function(){var s=this.getAggregation("_scrollArrowRight");if(s){return s;}else{s=this._createScrollArrow(false);this.setAggregation("_scrollArrowRight",s);return s;}};
A._hierarchicalSelectModes={"Icon":"icon","Text":"text"};
A.prototype._applyHierarchicalSelectMode=function(){if(this._sHierarchicalSelectMode===A._hierarchicalSelectModes.Icon){this.$().find(".sapUxAPAnchorBarScrollContainer").show();this._oSelect.setWidth("auto");this._oSelect.setAutoAdjustWidth(true);this._oSelect.setType(sap.m.SelectType.IconOnly);this._computeBarSectionsInfo();}else{this.$().find(".sapUxAPAnchorBarScrollContainer").hide();this._oSelect.setWidth("100%");this._oSelect.setAutoAdjustWidth(false);this._oSelect.setType(sap.m.SelectType.Default);}this.$().toggleClass("sapUxAPAnchorBarOverflow",this._sHierarchicalSelectMode===A._hierarchicalSelectModes.Icon);};
A.prototype._adjustSize=function(){var n=l.Utilities.isPhoneScenario()?A._hierarchicalSelectModes.Text:A._hierarchicalSelectModes.Icon;if(n!==this._sHierarchicalSelectMode){this._sHierarchicalSelectMode=n;this._applyHierarchicalSelectMode();}if(this._sHierarchicalSelectMode===A._hierarchicalSelectModes.Icon){if(this._iMaxPosition<0){return;}var $=this.$(),d=$.find(".sapUxAPAnchorBarScrollContainer"),N,e,i;i=d.width();if(this._bRtlScenario){if(D.browser.firefox){e=Math.abs(d.scrollLeft())+i<(this._iMaxPosition-this._iTolerance);N=Math.abs(d.scrollLeft())>=this._iTolerance;}else{e=Math.abs(d.scrollLeft())>=this._iTolerance;N=Math.abs(d.scrollLeft())+i<(this._iMaxPosition-this._iTolerance);}}else{e=d.scrollLeft()+i<(this._iMaxPosition-this._iTolerance);N=d.scrollLeft()>=this._iTolerance;}jQuery.sap.log.debug("AnchorBar :: scrolled at "+d.scrollLeft(),"scrollBegin ["+(N?"true":"false")+"] scrollEnd ["+(e?"true":"false")+"]");$.toggleClass("sapUxAPAnchorBarScrollLeft",N);$.toggleClass("sapUxAPAnchorBarScrollRight",e);}};
A.prototype._handleScrollButtonTap=function(s){var i=((!this._bRtlScenario&&s)||(this._bRtlScenario&&!s))?-1:1;this._oScroller.scrollTo(this._iMaxPosition*i,0,A.SCROLL_DURATION*3);};
A.prototype.scrollToSection=function(i,d){if(this._bHasButtonsBar){var e=d||A.SCROLL_DURATION,s;if((this._sHierarchicalSelectMode===A._hierarchicalSelectModes.Icon)&&this._oSectionInfo[i]){if(this._bRtlScenario&&D.browser.firefox){s=this._oSectionInfo[i].scrollLeft+this._iOffset;}else{s=this._oSectionInfo[i].scrollLeft-this._iOffset;if(s<0){s=0;}}jQuery.sap.log.debug("AnchorBar :: scrolling to section "+i+" of "+s);if(this._sCurrentScrollId!=i){this._sCurrentScrollId=i;if(this._iCurrentScrollTimeout){jQuery.sap.clearDelayedCall(this._iCurrentScrollTimeout);jQuery.sap.byId(this.getId()+"-scroll").parent().stop(true,false);}this._iCurrentScrollTimeout=jQuery.sap.delayedCall(d,this,function(){this._sCurrentScrollId=undefined;this._iCurrentScrollTimeout=undefined;});this._oScroller.scrollTo(s,0,e);}}else{jQuery.sap.log.debug("AnchorBar :: no need to scroll to "+i);}}};
A.prototype.getScrollDelegate=function(){return this._oScroller;};
A.PAGEUP_AND_PAGEDOWN_JUMP_SIZE=5;
A.prototype.onsapdown=function(e){e.preventDefault();if(e.target.nextSibling){e.target.nextSibling.focus();}};
A.prototype.onsapright=function(e){var m=this._bRtl?"onsapup":"onsapdown";this[m](e);};
A.prototype.onsapup=function(e){e.preventDefault();if(e.target.previousSibling){e.target.previousSibling.focus();}};
A.prototype.onsapleft=function(e){var m=this._bRtl?"onsapdown":"onsapup";this[m](e);};
A.prototype.onsaphome=function(e){e.preventDefault();if(e.target.parentElement.firstChild){e.target.parentElement.firstChild.focus();}};
A.prototype.onsapend=function(e){e.preventDefault();if(e.target.parentElement.lastChild){e.target.parentElement.lastChild.focus();}};
A.prototype.onsappageup=function(e){this._handlePageUp(e);};
A.prototype.onsappagedown=function(e){this._handlePageDown(e);};
A.prototype._handlePageUp=function(e){e.preventDefault();var n;var d=this.getContent();d.forEach(function(o,i){if(o.getId()===e.target.id){n=i-(A.PAGEUP_AND_PAGEDOWN_JUMP_SIZE+1);return;}});if(n&&d[n]){d[n].focus();}else if(d[0]){d[0].focus();}};
A.prototype._handlePageDown=function(e){e.preventDefault();var n;var d=this.getContent();d.forEach(function(o,i){if(o.getId()===e.target.id){n=i+A.PAGEUP_AND_PAGEDOWN_JUMP_SIZE+1;return;}});if(n&&d[n]){d[n].focus();}else if(d[d.length-1]){d[d.length-1].focus();}};
A.prototype._setAnchorButtonsTabFocusValues=function(s){var d=this.getContent()||[],$,f='0',n='-1',t="tabIndex";d.forEach(function(o){$=o.$();if(o.sId===s.sId){$.attr(t,f);}else{$.attr(t,n);}});};
A.prototype.onsapskipforward=function(e){this._handleGroupNavigation(e,false);};
A.prototype._handleGroupNavigation=function(e,s){var E=jQuery.Event("keydown"),o={},d=this.getParent().getSections(),f=[this.getDomRef()],g;d.forEach(function(h){g=h.getSubSections().map(function(i){return i.$().attr("tabindex",-1)[0];});f=f.concat(g);});o.scope=f;e.preventDefault();this.$().focus();E.target=e.target;E.keyCode=jQuery.sap.KeyCodes.F6;E.shiftKey=s;jQuery.sap.handleF6GroupNavigation(E,o);};
A.prototype.onAfterRendering=function(){var s;if(T.prototype.onAfterRendering){T.prototype.onAfterRendering.call(this);}s=sap.ui.getCore().byId(this.getSelectedButton());this._sHierarchicalSelectMode=A._hierarchicalSelectModes.Text;this._iMaxPosition=-1;this._sResizeListenerId=R.register(this,jQuery.proxy(this._adjustSize,this));this.$().find(".sapUxAPAnchorBarScrollContainer").scroll(jQuery.proxy(this._onScroll,this));if(s){this.setSelectedButton(s);this._setAnchorButtonsTabFocusValues(s);}if(this._bHasButtonsBar){jQuery.sap.delayedCall(A.DOM_CALC_DELAY,this,function(){this._adjustSize();});}};
A.prototype._onScroll=function(){if(!this._iCurrentSizeCheckTimeout){this._iCurrentSizeCheckTimeout=jQuery.sap.delayedCall(A.SCROLL_DURATION,this,function(){this._iCurrentSizeCheckTimeout=undefined;this._adjustSize();});}};
A.prototype._computeBarSectionsInfo=function(){this._iMaxPosition=0;var d=this.getContent()||[];d.forEach(this._computeNextSectionInfo,this);if(this._bRtlScenario&&(D.browser.webkit||D.browser.firefox)){d.forEach(this._adjustNextSectionInfo,this);this._oScroller.scrollTo(this._iMaxPosition,0,0);}};
A.prototype._computeNextSectionInfo=function(o){if(o.data("bHasSubMenu")){o.$().attr("aria-haspopup","true");}o.$().attr("aria-controls",o.data("sectionId"));var w=o.$().outerWidth(true);this._oSectionInfo[o.data("sectionId")]={scrollLeft:this._iMaxPosition,width:w};this._iMaxPosition+=w;};
A.prototype._adjustNextSectionInfo=function(o){var s=this._oSectionInfo[o.data("sectionId")];if(D.browser.firefox){s.scrollLeft=-s.scrollLeft;}else{s.scrollLeft=this._iMaxPosition-s.scrollLeft-s.width;}};
A.prototype._destroyPopoverContent=function(){var p=this.getAggregation("_popovers");if(Array.isArray(p)){p.forEach(function(d){d.destroyContent();});}};
A.prototype._resetControl=function(){this._destroyPopoverContent();this.getContent().forEach(this._detachPopoverHandler,this);this.destroyContent();return this;};
A.prototype.exit=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}};
return A;});
sap.ui.predefine('sap/uxap/AnchorBarRenderer',["sap/m/ToolbarRenderer","sap/ui/core/Renderer","sap/m/BarInPageEnabler","./AnchorBar","./library"],function(T,R,B,A,l){"use strict";var a=R.extend(T);
a.renderBarContent=function(r,t){if(t._bHasButtonsBar){r.renderControl(t._getScrollArrowLeft());r.write("<div");r.writeAttributeEscaped("id",t.getId()+"-scrollContainer");r.writeAttributeEscaped("aria-label",l.i18nModel.getResourceBundle().getText("ANCHOR_BAR_LABEL"));r.addClass("sapUxAPAnchorBarScrollContainer");r.writeClasses();r.write(">");r.write("<div");r.writeAttributeEscaped("id",t.getId()+"-scroll");r.write(">");a.renderBarItems(r,t);r.write("</div>");r.write("</div>");r.renderControl(t._getScrollArrowRight());}B.addChildClassTo(t._oSelect,t);r.renderControl(t._oSelect);};
a.renderBarItems=function(r,t){var s=t.getSelectedButton();t.getContent().forEach(function(c){B.addChildClassTo(c,t);if(c.getId()===s){c.addStyleClass("sapUxAPAnchorBarButtonSelected");}r.renderControl(c);});};
a.decorateRootElement=function(r,t){T.decorateRootElement.apply(this,arguments);if(t._sHierarchicalSelectMode===A._hierarchicalSelectModes.Icon){r.addClass("sapUxAPAnchorBarOverflow");}};
return a;},true);
sap.ui.predefine('sap/uxap/BlockBase',["sap/ui/core/Control","sap/ui/core/CustomData","./BlockBaseMetadata","./ModelMapping","sap/ui/model/Context","sap/ui/Device","sap/ui/layout/form/ResponsiveGridLayout","./library"],function(C,a,B,M,b,D,R,l){"use strict";
var c=C.extend("sap.uxap.BlockBase",{
metadata:{library:"sap.uxap",properties:{"mode":{type:"string",group:"Appearance"},"visible":{type:"boolean",group:"Appearance",defaultValue:true},"columnLayout":{type:"sap.uxap.BlockBaseColumnLayout",group:"Behavior",defaultValue:"auto"},"formAdjustment":{type:"sap.uxap.BlockBaseFormAdjustment",group:"Behavior",defaultValue:sap.uxap.BlockBaseFormAdjustment.BlockColumns},"showSubSectionMore":{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"mappings",aggregations:{"mappings":{type:"sap.uxap.ModelMapping",multiple:true,singularName:"mapping"},"_views":{type:"sap.ui.core.Control",multiple:true,singularName:"view",visibility:"hidden"}},associations:{"selectedView":{type:"sap.ui.core.Control",multiple:false}},views:{}},
renderer:"sap.uxap.BlockBaseRenderer"
},B);
c.prototype.init=function(){if(!this.getMetadata().hasViews()){this.getMetadata().setView("defaultXML",{viewName:this.getMetadata().getName(),type:"XML"});}this._oMappingApplied={};this._bLazyLoading=false;this._bConnected=false;this._oUpdatedModels={};};
c.prototype.onBeforeRendering=function(){this._applyMapping();if(!this.getMode()||this.getMode()===""){if(this.getMetadata().getView("defaultXML")){this.setMode("defaultXML");}else{jQuery.sap.log.error("BlockBase ::: there is no mode defined for rendering "+this.getMetadata().getName()+". You can either set a default mode on the block metadata or set the mode property before rendering the block.");}}this._applyFormAdjustment();this._bLazyLoading=this._getObjectPageLayout()&&(this._getObjectPageLayout().getEnableLazyLoading()||this._getObjectPageLayout().getUseIconTabBar());};
c.prototype.onAfterRendering=function(){if(this._getObjectPageLayout()){this._getObjectPageLayout()._requestAdjustLayout();}};
c.prototype.setParent=function(p,A,s){C.prototype.setParent.call(this,p,A,s);if(p instanceof l.ObjectPageSubSection){this._bLazyLoading=true;this._oParentObjectPageSubSection=p;}};
c.prototype.setModel=function(m,n){this._applyMapping(n);return C.prototype.setModel.call(this,m,n);};
c.prototype._applyMapping=function(){if(this._bLazyLoading&&!this._bConnected){jQuery.sap.log.debug("BlockBase ::: Ignoring the _applyMapping as the block is not connected");}else{this.getMappings().forEach(function(m,i){var o,I=m.getInternalModelName(),e=m.getExternalPath(),E=m.getExternalModelName(),p;if(e){if(I==""||e==""){throw new Error("BlockBase :: incorrect mapping, one of the modelMapping property is empty");}if(!this._isMappingApplied(I)||(this.getModel(I)!=this.getModel(E))){jQuery.sap.log.info("BlockBase :: mapping external model "+E+" to "+I);o=this.getModel(E);if(o){p=o.resolve(e,this.getBindingContext(E));this._oMappingApplied[I]=true;C.prototype.setModel.call(this,o,I);this.setBindingContext(new b(o,p),I);}}}},this);}};
c.prototype._isMappingApplied=function(i){return this.getModel(i)&&this._oMappingApplied[i];};
c.prototype.propagateProperties=function(n){if(this._bLazyLoading&&!this._bConnected&&!this._oUpdatedModels.hasOwnProperty(n)){this._oUpdatedModels[n]=true;}else{this._applyMapping(n);}return C.prototype.propagateProperties.call(this,n);};
c.prototype.getSupportedModes=function(){var s=jQuery.extend({},this.getMetadata().getViews());for(var k in s){s[k]=k;}return s;};
c.prototype.setMode=function(m){m=this._validateMode(m);if(this.getMode()!==m){this.setProperty("mode",m,false);if(!this._bLazyLoading||this._bConnected){this._initView(m);}}return this;};
c.prototype.setColumnLayout=function(L){if(this._oParentObjectPageSubSection){this._oParentObjectPageSubSection.invalidate();}this.setProperty("columnLayout",L);};
c.prototype.clone=function(){var A=-1,s=this.getAssociation("selectedView"),v=this.getAggregation("_views")||[];if(s){v.forEach(function(V,i){if(V.getId()===s){A=i;}return A<0;});}var n=C.prototype.clone.call(this);if(A>=0){n.setAssociation("selectedView",n.getAggregation("_views")[A]);}return n;};
c.prototype._validateMode=function(m){this.validateProperty("mode",m);if(!this.getMetadata().getView(m)){var s=this.getMetadata()._sClassName||this.getId();if(this.getMetadata().getView("defaultXML")){jQuery.sap.log.warning("BlockBase :: no view defined for block "+s+" for mode "+m+", loading defaultXML instead");m="defaultXML";}else{throw new Error("BlockBase :: no view defined for block "+s+" for mode "+m);}}return m;};
c.prototype._getSelectedViewContent=function(){var v=null,s,V;s=this.getAssociation("selectedView");V=this.getAggregation("_views");if(V){for(var i=0;!v&&i<V.length;i++){if(V[i].getId()===s){v=V[i];}}}return v;};
c.prototype.createView=function(p,m){return sap.ui.xmlview(this.getId()+"-"+m,p);};
c.prototype._initView=function(m){var v,V=this.getAggregation("_views")||[],p=this.getMetadata().getView(m);V.forEach(function(o,i){if(o.data("layoutMode")===m){v=o;}});if(!v){v=this._initNewView(m);}this.setAssociation("selectedView",v,true);if(v.getController()&&v.getController().onParentBlockModeChange){v.getController().onParentBlockModeChange(m);}else{jQuery.sap.log.info("BlockBase ::: could not notify "+p.viewName+" of loading in mode "+m+": missing controller onParentBlockModeChange method");}return v;};
c.prototype._initNewView=function(m){var v=this._getSelectedViewContent(),p=this.getMetadata().getView(m);if(!v||p.viewName!=v.getViewName()){v=this.createView(p,m);if(v){if(v.getController()){v.getController().oParentBlock=this;}v.addCustomData(new a({"key":"layoutMode","value":m}));this.addAggregation("_views",v,true);}else{throw new Error("BlockBase :: no view defined in metadata.views for mode "+m);}}return v;};
c.FORM_ADUSTMENT_OFFSET=32;c._FORM_ADJUSTMENT_CONST={breakpoints:{XL:D.media._predefinedRangeSets.StdExt.points[2]-c.FORM_ADUSTMENT_OFFSET,L:D.media._predefinedRangeSets.StdExt.points[1]-c.FORM_ADUSTMENT_OFFSET,M:D.media._predefinedRangeSets.StdExt.points[0]-c.FORM_ADUSTMENT_OFFSET},labelSpan:{XL:12,L:12,M:12,S:12},emptySpan:{XL:0,L:0,M:0,S:0},columns:{XL:1,L:1,M:1}};c._PARENT_GRID_SIZE=12;
c.prototype._computeFormAdjustmentFields=function(v,L,f,p){if(v&&L&&f&&p){var o=this._computeFormColumns(L,f,p),d=this._computeFormBreakpoints(L,f);return jQuery.extend({},c._FORM_ADJUSTMENT_CONST,{columns:o},{breakpoints:d});}};
c.prototype._computeFormColumns=function(L,f,p){var o=jQuery.extend({},c._FORM_ADJUSTMENT_CONST.columns);if(f===sap.uxap.BlockBaseFormAdjustment.BlockColumns){var i=c._PARENT_GRID_SIZE/p.XL,d=c._PARENT_GRID_SIZE/p.L,e=c._PARENT_GRID_SIZE/p.M;o.XL=L.getSpanXL()/i;o.L=L.getSpanL()/d;o.M=L.getSpanM()/e;}return o;};
c.prototype._computeFormBreakpoints=function(L,f){var o=jQuery.extend({},c._FORM_ADJUSTMENT_CONST.breakpoints);if(f===sap.uxap.BlockBaseFormAdjustment.BlockColumns){o.XL=Math.round(o.XL*L.getSpanXL()/c._PARENT_GRID_SIZE);o.L=Math.round(o.L*L.getSpanL()/c._PARENT_GRID_SIZE);o.M=Math.round(o.M*L.getSpanM()/c._PARENT_GRID_SIZE);}return o;};
c.prototype._applyFormAdjustment=function(){var L=this.getLayoutData(),f=this.getFormAdjustment(),v=this._getSelectedViewContent(),p=this._oParentObjectPageSubSection,F;if(f&&(f!==sap.uxap.BlockBaseFormAdjustment.None)&&v&&L&&p){var P=p._oLayoutConfig;v.getContent().forEach(function(i){if(i.getMetadata().getName()==="sap.ui.layout.form.SimpleForm"){i.setLayout(sap.ui.layout.form.SimpleFormLayout.ResponsiveGridLayout);if(!F){F=this._computeFormAdjustmentFields(v,L,f,P);}this._applyFormAdjustmentFields(F,i);i.setWidth("100%");}else if(i.getMetadata().getName()==="sap.ui.layout.form.Form"){var o=i.getLayout(),r;if(o&&o.getMetadata().getName()==="sap.ui.layout.form.ResponsiveGridLayout"){r=o;}else{r=new R();i.setLayout(r);}if(!F){F=this._computeFormAdjustmentFields(v,L,f,P);}this._applyFormAdjustmentFields(F,r);i.setWidth("100%");}},this);}};
c.prototype._applyFormAdjustmentFields=function(f,F){F.setColumnsXL(f.columns.XL);F.setColumnsL(f.columns.L);F.setColumnsM(f.columns.M);F.setLabelSpanXL(f.labelSpan.XL);F.setLabelSpanL(f.labelSpan.L);F.setLabelSpanM(f.labelSpan.M);F.setLabelSpanS(f.labelSpan.S);F.setEmptySpanXL(f.emptySpan.XL);F.setEmptySpanL(f.emptySpan.L);F.setEmptySpanM(f.emptySpan.M);F.setEmptySpanS(f.emptySpan.S);F.setBreakpointXL(f.breakpoints.XL);F.setBreakpointL(f.breakpoints.L);F.setBreakpointM(f.breakpoints.M);};
c.prototype._getObjectPageLayout=function(){if(!this._oParentObjectPageLayout){this._oParentObjectPageLayout=l.Utilities.getClosestOPL(this);}return this._oParentObjectPageLayout;};
c.prototype.setVisible=function(v,s){this.setProperty("visible",v,s);this._getObjectPageLayout()&&this._getObjectPageLayout()._adjustLayoutAndUxRules();return this;};
c.prototype.setShowSubSectionMore=function(v,i){if(v!=this.getShowSubSectionMore()){this.setProperty("showSubSectionMore",v,true);if(this._oParentObjectPageSubSection){this._oParentObjectPageSubSection.refreshSeeMoreVisibility();}}return this;};
c.prototype.connectToModels=function(){if(!this._bConnected){jQuery.sap.log.debug("BlockBase :: Connecting block to the UI5 model tree");this._bConnected=true;if(this._bLazyLoading){var m=this.getMode();m&&this._initView(m);}this.invalidate();}};
c.prototype._allowPropagationToLoadedViews=function(A){if(!this._bConnected){return;}this.mSkipPropagation._views=!A;};
c.prototype.updateBindingContext=function(s,S,m,u){if(!this._bLazyLoading||this._bConnected){return C.prototype.updateBindingContext.call(this,s,S,m,u);}else{jQuery.sap.log.debug("BlockBase ::: Ignoring the updateBindingContext as the block is not visible for now in the ObjectPageLayout");}};
c.prototype.updateBindings=function(u,m){if(!this._bLazyLoading||this._bConnected){return C.prototype.updateBindings.call(this,u,m);}else{jQuery.sap.log.debug("BlockBase ::: Ignoring the updateBindingContext as the block is not visible for now in the ObjectPageLayout");}};
return c;});
sap.ui.predefine('sap/uxap/BlockBaseMetadata',["jquery.sap.global","sap/ui/core/ElementMetadata"],function(q,E){"use strict";var B=function(c,C){E.apply(this,arguments);this._mViews=C.metadata.views||{};};B.prototype=q.sap.newObject(E.prototype);
B.prototype.applySettings=function(c){var r=c.hasOwnProperty("renderer")?(c.renderer||""):undefined;E.prototype.applySettings.call(this,c);if(r==null){this._sRendererName=null;}};
B.prototype.getRendererName=function(){if(!this._sBlockRenderer){this._sBlockRenderer=this._resolveRendererName();q.sap.log.debug("BlockBaseMetadata :: "+this.getName()+" is renderer with "+this._sBlockRenderer);}return this._sBlockRenderer;};
B.prototype._resolveRendererName=function(){var c=E.prototype.getRendererName.call(this);if(c==null){var p=this.getParent();if(p){c=B.prototype._resolveRendererName.apply(p);}else{throw new Error("BlockBaseMetadata :: no renderer found for "+this.getName());}}return c;};
B.prototype.getView=function(v){return this._mViews[v];};
B.prototype.getViews=function(){return this._mViews;};
B.prototype.setView=function(v,V){this._mViews[v]=V;return this;};
B.prototype.hasViews=function(){return!q.isEmptyObject(this._mViews);};
return B;},true);
sap.ui.predefine('sap/uxap/BlockBaseRenderer',function(){"use strict";var B={};
B.render=function(r,c){if(!c.getVisible()){return;}r.write("<div");r.writeControlData(c);if(c._getSelectedViewContent()){r.addClass('sapUxAPBlockBase');r.addClass("sapUxAPBlockBase"+c.getMode());}else{var C=c.getMetadata().getName().split(".").pop();r.addClass('sapUxAPBlockBaseDefaultSize');r.addClass('sapUxAPBlockBaseDefaultSize'+C+c.getMode());}r.writeClasses();r.write(">");if(c._getSelectedViewContent()){r.renderControl(c._getSelectedViewContent());}r.write("</div>");};
return B;},true);
sap.ui.predefine('sap/uxap/BreadCrumbs',["sap/m/Link","sap/m/Select","sap/m/Text","sap/ui/core/Control","sap/ui/core/ResizeHandler","sap/ui/core/delegate/ItemNavigation","sap/ui/core/Item","sap/ui/core/Icon","sap/ui/Device","./library"],function(L,S,T,C,R,I,a,b,D,l){"use strict";
var B=C.extend("sap.uxap.BreadCrumbs",{metadata:{library:"sap.uxap",properties:{showCurrentLocation:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"links",aggregations:{links:{type:"sap.m.Link",multiple:true,singularName:"link"},currentLocation:{type:"sap.m.Text",multiple:false},_tubeIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_overflowSelect:{type:"sap.m.Select",multiple:false,visibility:"hidden"}}}});
B.PAGEUP_AND_PAGEDOWN_JUMP_SIZE=5;
B.prototype.init=function(){this._iREMSize=parseInt(jQuery("body").css("font-size"),10);this._iContainerMaxHeight=this._iREMSize*2;};
B.prototype.onBeforeRendering=function(){this._bOnPhone=D.system.phone;this._resetControl();};
B.prototype.onAfterRendering=function(){this._handleInitialModeSelection();};
B.prototype._handleInitialModeSelection=function(){if(this._bOnPhone){this._setSelectVisible(true);return this;}this._configureKeyboardHandling();if(!this._iContainerHeight){this._iContainerHeight=this.$().outerHeight();}if(this._iContainerHeight>this._iContainerMaxHeight){this._toggleOverflowMode(true);return this;}this._sResizeListenerId=R.register(this,this._handleScreenResize.bind(this));return this;};
B.prototype._toggleOverflowMode=function(u){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);}this._setSelectVisible(u);this._setBreadcrumbsVisible(!u);this._sResizeListenerId=R.register(this,this._handleScreenResize.bind(this));return this;};
B.prototype._getTubeIcon=function(){if(!this.getAggregation("_tubeIcon")){this.setAggregation("_tubeIcon",new b({"src":"sap-icon://slim-arrow-right","color":"#bfbfbf","size":"1rem","useIconTooltip":false}).addStyleClass("sapUxAPTubeIcon"));}return this.getAggregation("_tubeIcon");};
B.prototype._getOverflowSelect=function(){var o,s;if(!this.getAggregation("_overflowSelect")){s=this.getLinks().reverse()||[];s.unshift(this.getCurrentLocation());o=new S({items:s.map(this._createSelectItem),autoAdjustWidth:true});o.attachChange(this._overflowSelectChangeHandler);this.setAggregation("_overflowSelect",o);}return this.getAggregation("_overflowSelect");};
B.prototype._createSelectItem=function(i){return new a({key:i.getId(),text:i.getText()});};
B.prototype._overflowSelectChangeHandler=function(e){var s=e.getParameter("selectedItem").getKey(),c=sap.ui.getCore().byId(s),d,f;if(c instanceof L){d=c.getHref();c.firePress();if(d){f=c.getTarget();if(f){window.open(d,f);}else{window.location.href=d;}}}return this;};
B.prototype._handleScreenResize=function(e){var s=this._shouldOverflow(),u=this._getUsingOverflowSelect();if(s&&!u){this._toggleOverflowMode(true);}else if(!s&&u){this._toggleOverflowMode(false);}return this;};
B.prototype._shouldOverflow=function(){var $=this._getBreadcrumbsAsJQueryObject(),s,u=this._getUsingOverflowSelect();if(u){this._setBreadcrumbsVisible(true);}$.addClass("sapUxAPInvisible");s=$.outerHeight()>this._iContainerMaxHeight;$.removeClass("sapUxAPInvisible");if(u){this._setBreadcrumbsVisible(false);}return s;};
B.prototype._getBreadcrumbsAsJQueryObject=function(){if(!this._$breadcrumbs){this._$breadcurmbs=this.$("breadcrumbs");}return this._$breadcurmbs;};
B.prototype._getOverflowSelectAsJQueryObject=function(){if(!this._$select){this._$select=this.$("select");}return this._$select;};
B.prototype._setBreadcrumbsVisible=function(v){var $=this.$(),c=this._getBreadcrumbsAsJQueryObject(),f="sapUxAPFullWidth",s="sapUiHidden";if(v){c.removeClass(s);$.removeClass(f);}else{c.addClass(s);$.addClass(f);}return $;};
B.prototype._setSelectVisible=function(v){var $=this._getOverflowSelectAsJQueryObject(),s="sapUiHidden";if(v){$.removeClass(s);}else{$.addClass(s);}return this;};
B.prototype._resetControl=function(){this._iContainerHeight=null;this._$select=null;this._$breadcrumbs=null;this.setAggregation("_overflowSelect",null,true);if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);}return this;};
B.prototype._getAriaLabelledBy=function(){if(!this._oAriaLabelledBy){B.prototype._oAriaLabelledBy=new sap.ui.core.InvisibleText({text:l.i18nModel.getResourceBundle().getText("BREADCRUMB_TRAIL_LABEL")}).toStatic();}return this._oAriaLabelledBy;};
B.prototype._getItemNavigation=function(){if(!this._ItemNavigation){this._ItemNavigation=new I();}return this._ItemNavigation;};
B.prototype._getItemsToNavigate=function(){var i=this.getLinks(),c=this.getCurrentLocation(),s=this.getShowCurrentLocation();if(s&&c){i.push(c);}return i;};
B.prototype._configureKeyboardHandling=function(){var i=this._getItemNavigation(),h=this._getBreadcrumbsAsJQueryObject()[0],s=-1,c=this._getItemsToNavigate(),n=[];c.forEach(function(o){o.$().attr("tabIndex","-1");n.push(o.getDomRef());});this.addDelegate(i);i.setCycling(false);i.setRootDomRef(h);i.setItemDomRefs(n);i.setSelectedIndex(s);this._getBreadcrumbsAsJQueryObject().attr("tabindex","-1");c[0].$().attr("tabindex","0");return this;};
B.prototype.onsappageup=function(e){this._handlePageKeys(e,false);};
B.prototype.onsappagedown=function(e){this._handlePageKeys(e,true);};
B.prototype._handlePageKeys=function(e,m){var n,c=this._getItemsToNavigate(),E=0,i=m?c.length-1:0;e.preventDefault();c.some(function(o,d){if(o.getId()===e.target.id){E=d;return true;}});if(m){n=E+B.PAGEUP_AND_PAGEDOWN_JUMP_SIZE;}else{n=E-B.PAGEUP_AND_PAGEDOWN_JUMP_SIZE;}if(n&&c[n]){c[n].focus();}else if(c[i]){c[i].focus();}};
B.prototype._getUsingOverflowSelect=function(){return!this._getOverflowSelectAsJQueryObject().hasClass("sapUiHidden");};
B.prototype.exit=function(){if(this._ItemNavigation){this.removeDelegate(this._ItemNavigation);this._ItemNavigation.destroy();this._ItemNavigation=null;}this._resetControl();};
return B;});
sap.ui.predefine('sap/uxap/BreadCrumbsRenderer',function(){"use strict";var B={};
B.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapUxAPBreadCrumbs");r.writeClasses();r.writeAttribute("role","navigation");r.writeAttributeEscaped("aria-labelledby",c._getAriaLabelledBy().getId());r.write(">");this._renderOverflowSelect(r,c);if(!c._bOnPhone){this._renderBreadcrumbTrail(r,c);}r.write("</div>");};
B._renderBreadcrumbTrail=function(r,c){var l=c.getLinks(),C=c.getCurrentLocation(),t=c._getTubeIcon(),s=c.getShowCurrentLocation();r.write("<ul id='"+c.getId()+"-breadcrumbs'");r.write(">");l.forEach(function(L){r.write("<li>");r.renderControl(L);r.renderControl(t);r.write("</li>");});if(s){r.write("<li>");r.renderControl(C);r.write("</li>");}r.write("</ul>");};
B._renderOverflowSelect=function(r,c){var t=c._getTubeIcon();r.write("<div id='"+c.getId()+"-select'");r.addClass("sapUiHidden");r.writeClasses();r.write(">");r.write('<span class="sapUxAPBreadCrumbsDots">...</span>');r.renderControl(t);r.renderControl(c._getOverflowSelect());r.write("</div>");};
return B;},true);
sap.ui.predefine('sap/uxap/HierarchicalSelect',["jquery.sap.global","sap/m/Select","sap/ui/Device","./library"],function(q,S,D,l){"use strict";
var H=S.extend("sap.uxap.HierarchicalSelect",{metadata:{library:"sap.uxap",properties:{upperCase:{type:"boolean",group:"Appearance",defaultValue:false}}}});
H.POPOVER_MIN_WIDTH_REM=11;
H.prototype.onAfterRendering=function(){S.prototype.onAfterRendering.apply(this,arguments);this.$().attr("tabindex","-1");};
H.prototype.onAfterRenderingPicker=function(){S.prototype.onAfterRenderingPicker.call(this);var i=this.getItems()||[];i.forEach(function(I){var c=(I.data("secondLevel")===true)?"sapUxAPHierarchicalSelectSecondLevel":"sapUxAPHierarchicalSelectFirstLevel";I.$().addClass(c);},this);};
H.prototype.setUpperCase=function(v,s){this.setProperty("upperCase",v,s);this.toggleStyleClass("sapUxAPHierarchicalSelectUpperCase",v);var p=this.getAggregation("picker");if(p){p.toggleStyleClass("sapMSltPickerFirstLevelUpperCase",v);if(!s){p.invalidate();}}return this;};
H.prototype.onsapenter=S.prototype.onsapspace;["onsapup","onsappageup","onsappagedown","onsaphome","onsapend"].forEach(function(n){H.prototype[n]=function(e){S.prototype[n].call(this,e);e.stopPropagation();};});
H.prototype._createDialog=function(){var d=S.prototype._createDialog.call(this),c=d.getCustomHeader();if(c){c.addStyleClass("sapUxAPHierarchicalSelect");}return d;};
H.prototype._decoratePopover=function(p){S.prototype._decoratePopover.call(this,p);p._adaptPositionParams=function(){this._marginTop=0;this._marginLeft=0;this._marginRight=0;this._marginBottom=0;this._arrowOffset=0;this._offsets=["0 0","0 0","0 0","0 0"];this._myPositions=["end bottom","end center","end top","begin center"];this._atPositions=["end top","end center","end bottom","begin center"];};if(D.system.tablet||D.system.desktop){var r=q.position.scrollbarWidth();if(r>0){p.setOffsetX(r);}}};
H.prototype._onAfterRenderingPopover=function(){var p=this.getPicker(),P=p.getDomRef("cont"),m=P.style.minWidth;if(q.sap.endsWith(m,"rem")){m=m.substring(0,m.length-3);var M=parseFloat(m);if(M<H.POPOVER_MIN_WIDTH_REM&&P){P.style.minWidth=H.POPOVER_MIN_WIDTH_REM+"rem";}}};
return H;});
sap.ui.predefine('sap/uxap/HierarchicalSelectRenderer',["sap/m/SelectRenderer","sap/ui/core/Renderer"],function(S,R){"use strict";var H=R.extend(S);
H.addClass=function(r){r.addClass("sapUxAPHierarchicalSelect");};
return H;},true);
sap.ui.predefine('sap/uxap/LazyLoading',["jquery.sap.global","sap/ui/Device","sap/ui/base/Metadata","./ObjectPageSubSection"],function(q,D,M,O){"use strict";var L=M.createClass("sap.uxap._helpers.LazyLoading",{constructor:function(o){this._oObjectPageLayout=o;this._$html=q("html");this._iPreviousScrollTop=0;this._iScrollProgress=0;this._iPreviousScrollTimestamp=0;this._sLazyLoadingTimer=null;this.setLazyLoadingParameters();}});
L.prototype.setLazyLoadingParameters=function(){this.LAZY_LOADING_DELAY=200;this.LAZY_LOADING_EXTRA_PAGE_SIZE=0.5;if(this._isPhone()){this.NUMBER_OF_SUBSECTIONS_TO_PRELOAD={"FirstRendering":1,"ScrollToSection":1};}else if(this._isTablet()){this.NUMBER_OF_SUBSECTIONS_TO_PRELOAD={"FirstRendering":2,"ScrollToSection":1};}else if(this._isTabletSize()){this.NUMBER_OF_SUBSECTIONS_TO_PRELOAD={"FirstRendering":2,"ScrollToSection":2};}else{this.NUMBER_OF_SUBSECTIONS_TO_PRELOAD={"FirstRendering":3,"ScrollToSection":3};}this.LAZY_LOADING_FAST_SCROLLING_THRESHOLD=5;};
L.prototype.lazyLoadDuringScroll=function(s,t,p){var P,d,f=false;this._iScrollProgress=s-this._iPreviousScrollTop;P=Math.round(Math.abs(this._iScrollProgress)/p*100);if(P>=this.LAZY_LOADING_FAST_SCROLLING_THRESHOLD){f=true;}this._iPreviousScrollTop=s;this._iPreviousScrollTimestamp=t||0;d=(s===0)?0:this.LAZY_LOADING_DELAY;if(f&&this._sLazyLoadingTimer){q.sap.log.debug("ObjectPageLayout :: lazyLoading","delayed by "+d+" ms because of fast scroll");q.sap.clearDelayedCall(this._sLazyLoadingTimer);this._sLazyLoadingTimer=null;}if(!this._sLazyLoadingTimer){this._sLazyLoadingTimer=q.sap.delayedCall(d,this,this.doLazyLoading);}};
L.prototype.doLazyLoading=function(){var h=this._oObjectPageLayout._getHeightRelatedParameters(),s=this._oObjectPageLayout._oSectionInfo,S,i,p,b=this._iPreviousScrollTop>=(h.iHeaderContentHeight),e,E=-1,o={},t,a,c;p=(h.iScreenHeight-(b?h.iAnchorBarHeight:0)-(b?h.iHeaderTitleHeightStickied:0));S=h.iScrollTop;t=Date.now()-this._iPreviousScrollTimestamp;a=(t<(this.LAZY_LOADING_DELAY/2))&&(Math.abs(this._iScrollProgress)>5);if(a){if(this._iScrollProgress>=0){c=Math.round(Math.min(this._iScrollProgress*20,p/2));}else{c=-1*Math.round(Math.min(Math.abs(this._iScrollProgress)*20,p/2));}S+=c;q.sap.log.debug("ObjectPageLayout :: lazyLoading","Visible page shifted from : "+c);}i=S+p;S+=16;q.each(s,q.proxy(function(I,d){if(!d.isSection&&!d.loaded&&d.sectionReference.getParent()&&d.sectionReference.getParent().getVisible()){if(d.positionTop<=i&&S<d.positionBottom-1){o[I]=I;}else if(d.positionTop>i&&d.positionTop<i+p*this.LAZY_LOADING_EXTRA_PAGE_SIZE&&(E==-1||d.positionTop<E)){E=d.positionTop;e=I;}}},this));if(E!=-1&&q.isEmptyObject(o)){q.sap.log.debug("ObjectPageLayout :: lazyLoading","extra section added : "+e);o[e]=e;}q.each(o,q.proxy(function(d,f){q.sap.log.debug("ObjectPageLayout :: lazyLoading","connecting "+f);sap.ui.getCore().byId(f).connectToModels();s[f].loaded=true;},this));if(a){this._sLazyLoadingTimer=q.sap.delayedCall(this.LAZY_LOADING_DELAY,this,this.doLazyLoading);}else{if(E){this._sLazyLoadingTimer=q.sap.delayedCall(5*this.LAZY_LOADING_DELAY,this,this.doLazyLoading);}else{this._sLazyLoadingTimer=null;}}};
L.prototype.getSubsectionsToPreload=function(a,i){var s,t;if(i){s=this.NUMBER_OF_SUBSECTIONS_TO_PRELOAD.ScrollToSection;t=false;}else{s=this.NUMBER_OF_SUBSECTIONS_TO_PRELOAD.FirstRendering;t=true;}var S=[];a.some(function(o){if(!t&&i){t=o.getId()==i;}if(t&&o instanceof O){if(o.getVisible()&&o._getInternalVisible()){S.push(o);s--;}}return s<=0;});return S;};
L.prototype._isPhone=function(){return this._$html.hasClass("sapUiMedia-Std-Phone")||D.system.phone;};
L.prototype._isTablet=function(){return D.system.tablet;};
L.prototype._isTabletSize=function(){return this._$html.hasClass("sapUiMedia-Std-Tablet");};
return L;},false);
sap.ui.predefine('sap/uxap/ModelMapping',["sap/ui/core/Element","./library"],function(E,l){"use strict";
var M=E.extend("sap.uxap.ModelMapping",{metadata:{library:"sap.uxap",properties:{externalModelName:{type:"string",group:"Misc",defaultValue:null},internalModelName:{type:"string",group:"Misc",defaultValue:"Model"},externalPath:{type:"string",group:"Misc",defaultValue:null}}}});
return M;});
sap.ui.predefine('sap/uxap/ObjectPageHeader',["sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/core/CustomData","sap/ui/core/Icon","sap/ui/Device","sap/m/Breadcrumbs","./ObjectPageHeaderActionButton","sap/ui/core/ResizeHandler","sap/m/Text","sap/m/Button","sap/m/ActionSheet","sap/m/Image","./library"],function(C,I,a,b,D,B,O,R,T,c,A,d,l){"use strict";
var e=C.extend("sap.uxap.ObjectPageHeader",{metadata:{library:"sap.uxap",properties:{objectImageURI:{type:"string",defaultValue:null},objectImageAlt:{type:"string",defaultValue:''},objectImageDensityAware:{type:"boolean",defaultValue:false},objectTitle:{type:"string",defaultValue:null},objectSubtitle:{type:"string",defaultValue:null},objectImageShape:{type:"sap.uxap.ObjectPageHeaderPictureShape",defaultValue:sap.uxap.ObjectPageHeaderPictureShape.Square},isObjectIconAlwaysVisible:{type:"boolean",defaultValue:false},isObjectTitleAlwaysVisible:{type:"boolean",defaultValue:true},isObjectSubtitleAlwaysVisible:{type:"boolean",defaultValue:true},isActionAreaAlwaysVisible:{type:"boolean",defaultValue:true},headerDesign:{type:"sap.uxap.ObjectPageHeaderDesign",defaultValue:sap.uxap.ObjectPageHeaderDesign.Light},showTitleSelector:{type:"boolean",group:"Misc",defaultValue:false},markFavorite:{type:"boolean",group:"Misc",defaultValue:false},markFlagged:{type:"boolean",group:"Misc",defaultValue:false},showMarkers:{type:"boolean",group:"Misc",defaultValue:false},markLocked:{type:"boolean",group:"Misc",defaultValue:false},showPlaceholder:{type:"boolean",group:"Misc",defaultValue:false},markChanges:{type:"boolean",group:"Misc",defaultValue:false}},defaultAggregation:"actions",aggregations:{_breadCrumbs:{type:"sap.m.Breadcrumbs",multiple:false,visibility:"hidden"},breadCrumbsLinks:{type:"sap.m.Link",multiple:true,singularName:"breadCrumbLink"},_overflowButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_expandButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_objectImage:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_lockIconCont:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_lockIcon:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_titleArrowIconCont:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_titleArrowIcon:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_favIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_flagIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_overflowActionSheet:{type:"sap.m.ActionSheet",multiple:false,visibility:"hidden"},_changesIconCont:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_changesIcon:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_sideContentBtn:{type:"sap.m.Button",multiple:false,visibility:"hidden"},navigationBar:{type:"sap.m.Bar",multiple:false},actions:{type:"sap.ui.core.Control",multiple:true,singularName:"action"},sideContentButton:{type:"sap.m.Button",multiple:false}},events:{titleSelectorPress:{parameters:{domRef:{type:"string"}}},markLockedPress:{parameters:{domRef:{type:"string"}}},markChangesPress:{parameters:{domRef:{type:"string"}}}}}});
e.prototype._iAvailablePercentageForActions=0.3;
e.prototype.init=function(){if(!this.oLibraryResourceBundle){this.oLibraryResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");}if(!this.oLibraryResourceBundleOP){this.oLibraryResourceBundleOP=l.i18nModel.getResourceBundle();}this._oOverflowActionSheet=this._getInternalAggregation("_overflowActionSheet");this._oOverflowButton=this._getInternalAggregation("_overflowButton").attachPress(this._handleOverflowButtonPress,this);this._oExpandButton=this._getInternalAggregation("_expandButton");this._oActionSheetButtonMap={};this._oFlagIcon=this._getInternalAggregation("_flagIcon");this._oFavIcon=this._getInternalAggregation("_favIcon");this._oTitleArrowIcon=this._getInternalAggregation("_titleArrowIcon").attachPress(this._handleArrowPress,this);this._oTitleArrowIconCont=this._getInternalAggregation("_titleArrowIconCont").attachPress(this._handleArrowPress,this);this._oLockIcon=this._getInternalAggregation("_lockIcon").attachPress(this._handleLockPress,this);this._oLockIconCont=this._getInternalAggregation("_lockIconCont").attachPress(this._handleLockPress,this);this._oChangesIcon=this._getInternalAggregation("_changesIcon").attachPress(this._handleChangesPress,this);this._oChangesIconCont=this._getInternalAggregation("_changesIconCont").attachPress(this._handleChangesPress,this);};
e.prototype._handleOverflowButtonPress=function(E){this._oOverflowActionSheet.openBy(this._oOverflowButton);};
e.prototype._handleArrowPress=function(E){this.fireTitleSelectorPress({domRef:E.getSource().getDomRef()});};
e.prototype._handleLockPress=function(E){this.fireMarkLockedPress({domRef:E.getSource().getDomRef()});};
e.prototype._handleChangesPress=function(E){this.fireMarkChangesPress({domRef:E.getSource().getDomRef()});};
e._internalAggregationFactory={"_objectImage":function(P){var h,s=P.getObjectImageURI();if(s.indexOf("sap-icon://")==0){h=new b();h.addStyleClass("sapUxAPObjectPageHeaderObjectImageIcon");}else{h=new d({densityAware:P.getObjectImageDensityAware(),alt:P.getObjectImageAlt(),decorative:false});h.addStyleClass("sapUxAPObjectPageHeaderObjectImage");}h.setSrc(s);if(P.getObjectImageAlt()){h.setTooltip(P.getObjectImageAlt());}return h;},"_overflowActionSheet":function(){return new A({placement:sap.m.PlacementType.Bottom});},"_lockIconCont":function(P){return this._getButton(P,"sap-icon://private","lock-cont");},"_breadCrumbs":function(P){return new B({links:P.getAggregation("breadCrumbLinks")});},"_lockIcon":function(P){return this._getButton(P,"sap-icon://private","lock",P.oLibraryResourceBundleOP.getText("TOOLTIP_OP_LOCK_MARK_VALUE"));},"_titleArrowIconCont":function(P){return this._getButton(P,"sap-icon://arrow-down","titleArrow-cont",P.oLibraryResourceBundleOP.getText("OP_SELECT_ARROW_TOOLTIP"));},"_titleArrowIcon":function(P){return this._getButton(P,"sap-icon://arrow-down","titleArrow",P.oLibraryResourceBundleOP.getText("OP_SELECT_ARROW_TOOLTIP"));},"_favIcon":function(P){return this._getIcon(P,"favorite",P.oLibraryResourceBundleOP.getText("TOOLTIP_OP_FAVORITE_MARK_VALUE"));},"_flagIcon":function(P){return this._getIcon(P,"flag",P.oLibraryResourceBundleOP.getText("TOOLTIP_OP_FLAG_MARK_VALUE"));},"_overflowButton":function(P){return this._getButton(P,"sap-icon://overflow","overflow");},"_expandButton":function(P){return this._getButton(P,"sap-icon://slim-arrow-down","expand",P.oLibraryResourceBundleOP.getText("TOOLTIP_OP_EXPAND_HEADER_BTN"));},"_changesIconCont":function(P){return this._getButton(P,"sap-icon://user-edit","changes-cont",P.oLibraryResourceBundleOP.getText("TOOLTIP_OP_CHANGES_MARK_VALUE"));},"_changesIcon":function(P){return this._getButton(P,"sap-icon://user-edit","changes",P.oLibraryResourceBundleOP.getText("TOOLTIP_OP_CHANGES_MARK_VALUE"));},_getIcon:function(P,i,t){return I.createControlByURI({id:this._getParentAugmentedId(P,i),tooltip:t,src:I.getIconURI(i),visible:false});},_getButton:function(P,i,s,t){return new c({id:this._getParentAugmentedId(P,s),tooltip:t,icon:i,type:sap.m.ButtonType.Transparent});},_getParentAugmentedId:function(P,s){return P.getId()+"-"+s;}};
e.prototype._getInternalAggregation=function(s){if(!this.getAggregation(s)){this.setAggregation(s,e._internalAggregationFactory[s](this));}return this.getAggregation(s);};
e.prototype._applyActionProperty=function(P,h){var n=h[0];if(this.getProperty(P)!==n){h.unshift(P);this.setProperty.apply(this,h);this._notifyParentOfChanges();}return this;};
e.prototype._applyObjectImageProperty=function(P,h){var n=h[0];if(this.getProperty(P)!==n){h.unshift(P);this.setProperty.apply(this,h);this._destroyObjectImage();this._notifyParentOfChanges();}return this;};
e.prototype._proxyMethodToBreadCrumbControl=function(F,h){var i=this._getInternalAggregation("_breadCrumbs"),r=i[F].apply(i,h);this.invalidate();return r;};
e.prototype.setHeaderDesign=function(h){this.setProperty("headerDesign",h);if(this.getParent()){this.getParent().invalidate();}return this;};
e.prototype._shiftHeaderTitle=function(){var P=this.getParent(),s,$,i;if(!P||(typeof P._calculateShiftOffset!=="function")){return;}s=P._calculateShiftOffset();$=this.$().find(".sapUxAPObjectPageHeaderIdentifierActions");i=parseInt($.css(s.sStyleAttribute),10);$.css(s.sStyleAttribute,i+"px");if(typeof P._shiftHeader==="function"){P._shiftHeader(s.sStyleAttribute,s.iMarginalsOffset+"px");}};
e.prototype.setObjectTitle=function(n){var s=this.getProperty("objectTitle"),h=s!==n;this._applyActionProperty("objectTitle",Array.prototype.slice.call(arguments));if(h&&this.mEventRegistry["_titleChange"]){this.fireEvent("_titleChange",{"id":this.getId(),"name":"objectTitle","oldValue":s,"newValue":n});}return this;};
var p=["objectSubtitle","showTitleSelector","markLocked","markFavorite","markFlagged","showMarkers","showPlaceholder","markChanges"],o=["objectImageURI","objectImageAlt","objectImageDensityAware","objectImageShape"];var g=function(P){var s="set"+P.charAt(0).toUpperCase()+P.slice(1);e.prototype[s]=function(){var h=Array.prototype.slice.call(arguments);this._applyActionProperty.call(this,P,h);};};var G=function(P){var s="set"+P.charAt(0).toUpperCase()+P.slice(1);e.prototype[s]=function(){var h=Array.prototype.slice.call(arguments);this._applyObjectImageProperty.call(this,P,h);};};var f=function(P,s,t){var h="set"+P.charAt(0).toUpperCase()+P.slice(1);s[h]=function(){var i=Array.prototype.slice.call(arguments);i.unshift(P);t.setProperty.apply(t,i);return this.setProperty.apply(this,i);};};p.forEach(g);o.forEach(G);
e.prototype.getBreadCrumbsLinks=function(){return this._getInternalAggregation("_breadCrumbs").getLinks();};
e.prototype.addBreadCrumbLink=function(){return this._proxyMethodToBreadCrumbControl("addLink",arguments);};
e.prototype.indexOfBreadCrumbLink=function(){return this._proxyMethodToBreadCrumbControl("indexOfLink",arguments);};
e.prototype.insertBreadCrumbLink=function(){return this._proxyMethodToBreadCrumbControl("insertLink",arguments);};
e.prototype.removeBreadCrumbLink=function(){return this._proxyMethodToBreadCrumbControl("removeLink",arguments);};
e.prototype.removeAllBreadCrumbsLinks=function(){return this._proxyMethodToBreadCrumbControl("removeAllLinks",arguments);};
e.prototype.destroyBreadCrumbsLinks=function(){return this._proxyMethodToBreadCrumbControl("destroyLinks",arguments);};
e.prototype._destroyObjectImage=function(){var s="_objectImage",h=this.getAggregation(s);if(h){h.destroy();this.setAggregation(s,null);}};
e.prototype.onBeforeRendering=function(){if(this.getShowPlaceholder()){this._oPlaceholder=I.createControlByURI({src:I.getIconURI("picture"),visible:true});}var s=this.getSideContentButton();if(s&&!s.getTooltip()){s.setTooltip(this.oLibraryResourceBundleOP.getText("TOOLTIP_OP_SHOW_SIDE_CONTENT"));}var h=this.getActions()||[];this._oOverflowActionSheet.removeAllButtons();this._oActionSheetButtonMap={};if(h.length>1||this._hasOneButtonShowText(h)){h.forEach(function(i){if(i instanceof c&&!(i instanceof O)){i._bInternalVisible=i.getVisible();i._getInternalVisible=function(){return this._bInternalVisible;};i._setInternalVisible=function(v,k){this.$().toggle(v);if(v!=this._bInternalVisible){this._bInternalVisible=v;if(k){this.invalidate();}}};i.onAfterRendering=function(){if(!this._getInternalVisible()){this.$().hide();}};}if(i instanceof c&&(i.getType()==="Default"||i.getType()==="Unstyled")){i.setProperty("type",sap.m.ButtonType.Transparent,false);}if(i instanceof c&&i.getVisible()){var j=this._createActionSheetButton(i);this._oActionSheetButtonMap[i.getId()]=j;this._oOverflowActionSheet.addButton(j);f("text",i,j);f("icon",i,j);}},this);}this._oTitleArrowIcon.setVisible(this.getShowTitleSelector());this._oFavIcon.setVisible(this.getMarkFavorite());this._oFlagIcon.setVisible(this.getMarkFlagged());this._attachDetachActionButtonsHandler(false);};
e.prototype._createActionSheetButton=function(h){return new c({press:jQuery.proxy(this._onSeeMoreContentSelect,this),enabled:h.getEnabled(),text:h.getText(),icon:h.getIcon(),tooltip:h.getTooltip(),customData:new a({key:"originalId",value:h.getId()})});};
e.prototype._handleImageNotFoundError=function(){var h=this._getInternalAggregation("_objectImage"),P=this.getParent(),$=P?P.$():this.$();if(this.getShowPlaceholder()){$.find(".sapMImg.sapUxAPObjectPageHeaderObjectImage").hide();$.find(".sapUxAPObjectPageHeaderPlaceholder").removeClass("sapUxAPHidePlaceholder");}else{h.addStyleClass("sapMNoImg");}};
e.prototype._clearImageNotFoundHandler=function(){this._getInternalAggregation("_objectImage").$().off("error");};
e.prototype.onAfterRendering=function(){var $=this._getInternalAggregation("_objectImage").$();this._adaptLayout();this._clearImageNotFoundHandler();$.error(this._handleImageNotFoundError.bind(this));if(!this.getObjectImageURI()){this._handleImageNotFoundError();}if(!this._iResizeId){this._iResizeId=R.register(this,this._onHeaderResize.bind(this));}this._shiftHeaderTitle();this._attachDetachActionButtonsHandler(true);};
e.prototype._onHeaderResize=function(){this._adaptLayout();if(this.getParent()&&typeof this.getParent()._adjustHeaderHeights==="function"){this.getParent()._adjustHeaderHeights();}};
e.prototype._attachDetachActionButtonsHandler=function(h){var i=this.getActions()||[];if(i.length<1){return;}i.forEach(function(j){if(j instanceof c){var k=this._oActionSheetButtonMap[j.getId()];if(h){j.attachEvent("_change",this._adaptLayout,this);if(k){k.attachEvent("_change",this._adaptOverflow,this);}}else{j.detachEvent("_change",this._adaptLayout,this);if(k){k.detachEvent("_change",this._adaptOverflow,this);}}}},this);};
e.prototype._onSeeMoreContentSelect=function(E){var P=E.getSource(),h=sap.ui.getCore().byId(P.data("originalId"));if(h.firePress){h.firePress({overflowButtonId:this._oOverflowButton.getId()});}this._oOverflowActionSheet.close();};
e._actionImportanceMap={"Low":3,"Medium":2,"High":1};
e._sortActionsByImportance=function(h,i){var s=(h instanceof O)?h.getImportance():sap.uxap.Importance.High,j=(i instanceof O)?i.getImportance():sap.uxap.Importance.High,k=e._actionImportanceMap[s]-e._actionImportanceMap[j];if(k===0){return h.position-i.position;}return k;};
e.prototype._hasOneButtonShowText=function(h){var i=false;if(h.length!==1){return i;}if(h[0]instanceof O){i=(!h[0].getHideText()&&h[0].getText()!="");}else if(h[0]instanceof c){i=(h[0].getText()!="");}return i;};
e.prototype._adaptLayout=function(E){var i=this.$("identifierLine").width(),h=this._getActionsWidth(),j=h/i,k=this._iAvailablePercentageForActions*i,$=this._oOverflowButton.$(),m=this.$("actions").find(".sapMBtn").not(".sapUxAPObjectPageHeaderExpandButton");if(j>this._iAvailablePercentageForActions){this._adaptActions(k);}else if(E&&E.getSource()instanceof O){E.getSource()._setInternalVisible(true);}if(sap.ui.Device.system.phone){m.css("visibility","visible");}if(m.filter(":visible").length===m.length){$.hide();}this._adaptObjectPageHeaderIndentifierLine();};
e.prototype._adaptObjectPageHeaderIndentifierLine=function(){var i=this.$("identifierLine").width(),$=this.$("subtitle"),h=this.$("identifierLineContainer"),s,t,j=this.$("actions").width()+this.$().find(".sapUxAPObjectPageHeaderObjectImageContainer").width(),P=this.$().parents().hasClass('sapUiSizeCompact')?7:3;if($.length){if($.hasClass("sapOPHSubtitleBlock")){$.removeClass("sapOPHSubtitleBlock");}s=$.outerHeight()+$.position().top;t=this.$("innerTitle").outerHeight()+this.$("innerTitle").position().top;if(Math.abs(s-t)>P){$.addClass("sapOPHSubtitleBlock");}}h.width((0.95-(j/i))*100+"%");};
e.prototype._adaptActions=function(h){var m=jQuery("html").hasClass("sapUiMedia-Std-Phone")||D.system.phone,v=this._oOverflowButton.$().show().width(),j=this.getActions(),k=j.length,n;for(var i=0;i<k;i++){j[i].position=i;}j.sort(e._sortActionsByImportance);j.forEach(function(q){n=this._oActionSheetButtonMap[q.getId()];if(n){v+=q.$().width();if(h>v&&!m){this._setActionButtonVisibility(q,true);}else{this._setActionButtonVisibility(q,false);}}},this);};
e.prototype._adaptOverflow=function(){var h=this._oOverflowActionSheet.getButtons();var H=h.some(function(i){return i.getVisible();});this._oOverflowButton.$().toggle(H);};
e.prototype._setActionButtonVisibility=function(h,v){var i=this._oActionSheetButtonMap[h.getId()];if(i){if(h.getVisible()){h._setInternalVisible(v);i.setVisible(!v);}else{i.setVisible(false);}}};
e.prototype._getActionsWidth=function(){var w=0;this.getActions().forEach(function(h){if(h instanceof c){h.$().show();if(sap.ui.Device.system.phone){h.$().css("visibility","hidden");}w+=h.$().outerWidth(true);}});return w;};
e.prototype._notifyParentOfChanges=function(){if(this.getParent()&&typeof this.getParent()._headerTitleChangeHandler==="function"){this.getParent()._headerTitleChangeHandler();}};
e.prototype._getActionsPaddingStatus=function(){return this.$("actions").hasClass("sapUxAPObjectPageHeaderIdentifierActionsNoPadding");};
e.prototype._setActionsPaddingStatus=function(s){return this.$("actions").toggleClass("sapUxAPObjectPageHeaderIdentifierActionsNoPadding",s);};
e.prototype.exit=function(){this._clearImageNotFoundHandler();if(this._iResizeId){R.deregister(this._iResizeId);}};
e.prototype.setNavigationBar=function(h){this.setAggregation("navigationBar",h);if(h&&this.mEventRegistry["_adaptableContentChange"]){this.fireEvent("_adaptableContentChange",{"parent":this,"adaptableContent":h});}return this;};
e.prototype._getAdaptableContent=function(){return this.getNavigationBar();};
return e;});
sap.ui.predefine('sap/uxap/ObjectPageHeaderActionButton',["sap/m/Button","./library"],function(B,l){"use strict";
var O=B.extend("sap.uxap.ObjectPageHeaderActionButton",{metadata:{library:"sap.uxap",properties:{hideText:{type:"boolean",defaultValue:true},hideIcon:{type:"boolean",defaultValue:false},importance:{type:"sap.uxap.Importance",group:"Behavior",defaultValue:l.Importance.High}}}});
O.prototype.init=function(){this._bInternalVisible=this.getVisible();};
O.prototype.onAfterRendering=function(){if(!this._getInternalVisible()){this.$().hide();}};
O.prototype.applySettings=function(s,S){if(B.prototype.applySettings){B.prototype.applySettings.call(this,s,S);}this.toggleStyleClass("sapUxAPObjectPageHeaderActionButtonHideText",this.getHideText());this.toggleStyleClass("sapUxAPObjectPageHeaderActionButtonHideIcon",this.getHideIcon());};
O.prototype.setHideText=function(v,i){this.toggleStyleClass("sapUxAPObjectPageHeaderActionButtonHideText",v);return this.setProperty("hideText",v,i);};
O.prototype.setHideIcon=function(v,i){this.toggleStyleClass("sapUxAPObjectPageHeaderActionButtonHideIcon",v);return this.setProperty("hideIcon",v,i);};
O.prototype._setInternalVisible=function(v,i){this.$().toggle(v);if(v!=this._bInternalVisible){this._bInternalVisible=v;if(i){this.invalidate();}}};
O.prototype._getInternalVisible=function(){return this._bInternalVisible;};
return O;});
sap.ui.predefine('sap/uxap/ObjectPageHeaderActionButtonRenderer',["sap/m/ButtonRenderer","sap/ui/core/Renderer"],function(B,R){"use strict";var O=R.extend(B);return O;},true);
sap.ui.predefine('sap/uxap/ObjectPageHeaderContent',["sap/ui/core/Control","./library","sap/m/Button"],function(C,l,B){"use strict";
var O=C.extend("sap.uxap.ObjectPageHeaderContent",{metadata:{library:"sap.uxap",properties:{contentDesign:{type:"sap.uxap.ObjectPageHeaderDesign",group:"Misc",defaultValue:sap.uxap.ObjectPageHeaderDesign.Light}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},_editHeaderButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}}}});
O.prototype.onBeforeRendering=function(){var p=this.getParent(),e=this.getAggregation("_editHeaderButton");if(e){return;}if(p&&(p instanceof l.ObjectPageLayout)&&p.getShowEditHeaderButton()){e=this._getInternalBtnAggregation("_editHeaderButton","EDIT_HEADER","-editHeaderBtn","Transparent");e.attachPress(this._handleEditHeaderButtonPress,this);}};
O.prototype.exit=function(){var e=this.getAggregation("_editHeaderButton");if(e){e.detachPress(this._handleEditHeaderButtonPress,this);}};
O.prototype._handleEditHeaderButtonPress=function(e){this.getParent().fireEditHeaderButtonPress();};
O.prototype._getInternalBtnAggregation=function(a,b,s,c){if(!this.getAggregation(a)){var o=new B({text:l.i18nModel.getResourceBundle().getText(b),type:c,id:this.getId()+s});this.setAggregation(a,o);}return this.getAggregation(a);};
O.prototype._getLayoutDataForControl=function(c){var L=c.getLayoutData();if(!L){return;}else if(L instanceof l.ObjectPageHeaderLayoutData){return L;}else if(L.getMetadata().getName()=="sap.ui.core.VariantLayoutData"){var a=L.getMultipleLayoutData();for(var i=0;i<a.length;i++){var o=a[i];if(o instanceof l.ObjectPageHeaderLayoutData){return o;}}}};
return O;});
sap.ui.predefine('sap/uxap/ObjectPageHeaderContentRenderer',["./ObjectPageHeaderRenderer","./ObjectPageLayout","sap/ui/core/Icon"],function(O,a,I){"use strict";var b={};
b.render=function(r,c){var p=c.getParent(),P=(p instanceof a),h=(p&&P)?p.getHeaderTitle():false,R=(p&&P)?((p instanceof a)&&p.getShowTitleInHeaderContent()):false,d=P&&p.getShowEditHeaderButton()&&c.getContent()&&c.getContent().length>0;if(d){r.write("<div ");r.writeControlData(c);r.addClass("sapUxAPObjectPageHeaderContentFlexBox");r.addClass("sapUxAPObjectPageHeaderContentDesign-"+c.getContentDesign());if(h){r.addClass('sapUxAPObjectPageContentObjectImage-'+h.getObjectImageShape());}r.writeClasses();r.write(">");}r.write("<div ");if(d){r.addClass("sapUxAPObjectPageHeaderContentCellLeft");}else{r.writeControlData(c);r.addClass("sapUxAPObjectPageHeaderContentDesign-"+c.getContentDesign());if(h){r.addClass('sapUxAPObjectPageContentObjectImage-'+h.getObjectImageShape());}}r.addClass("ui-helper-clearfix");r.addClass("sapUxAPObjectPageHeaderContent");if(!c.getVisible()){r.addClass("sapUxAPObjectPageHeaderContentHidden");}r.writeClasses();r.write(">");if(P&&p.getIsChildPage()){r.write("<div");r.addClass('sapUxAPObjectChildPage');r.writeClasses();r.write("></div>");}if(R){this._renderTitleImage(r,h);if(c.getContent().length==0){r.write("<span class=\"sapUxAPObjectPageHeaderContentItem\">");this._renderTitle(r,h);r.write("</span>");}}c.getContent().forEach(function(i,e){this._renderHeaderContent(i,e,r,R,h,c);},this);r.write("</div>");if(d){this._renderEditButton(r,c);r.write("</div>");}};
b._renderHeaderContent=function(h,i,r,R,H,c){var d=false,e=false,l=c._getLayoutDataForControl(h),f=i===0,g=i===(c.getContent().length-1);if(l){d=l.getShowSeparatorBefore();e=l.getShowSeparatorAfter();r.write("<span ");r.addClass("sapUxAPObjectPageHeaderWidthContainer");r.addClass("sapUxAPObjectPageHeaderContentItem");r.addStyle("width",l.getWidth());r.writeStyles();if(e||d){r.addClass("sapUxAPObjectPageHeaderSeparatorContainer");}if(!l.getVisibleL()){r.addClass("sapUxAPObjectPageHeaderLayoutHiddenL");}if(!l.getVisibleM()){r.addClass("sapUxAPObjectPageHeaderLayoutHiddenM");}if(!l.getVisibleS()){r.addClass("sapUxAPObjectPageHeaderLayoutHiddenS");}r.writeClasses();r.write(">");if(d){r.write("<span class=\"sapUxAPObjectPageHeaderSeparatorBefore\"/>");}if(f&&R){this._renderTitle(r,H);}}else{if(f&&R){r.write("<span class=\"sapUxAPObjectPageHeaderContentItem\">");this._renderTitle(r,H);}else{h.addStyleClass("sapUxAPObjectPageHeaderContentItem");}}r.renderControl(h);if(e){r.write("<span class=\"sapUxAPObjectPageHeaderSeparatorAfter\"/>");}if(l||(f&&R)||g){r.write("</span>");}};
b._renderTitleImage=function(r,h){var o=h._getInternalAggregation("_objectImage");if(h.getObjectImageURI()||h.getShowPlaceholder()){r.write("<span");r.addClass("sapUxAPObjectPageHeaderContentImageContainer");r.addClass("sapUxAPObjectPageHeaderObjectImage-"+h.getObjectImageShape());r.writeClasses();r.write(">");O._renderInProperContainer(function(){r.renderControl(o);O._renderPlaceholder(r,h,!(h.getObjectImageShape()||h.getShowPlaceholder()));},o,r);r.write("</span>");}};
b._renderTitle=function(r,h){O._renderObjectPageTitle(r,h,true);};
b._renderEditButton=function(r,h){r.write("<div class=\"sapUxAPObjectPageHeaderContentCellRight\">");r.renderControl(h.getAggregation("_editHeaderButton"));r.write("</div>");};
return b;},true);
sap.ui.predefine('sap/uxap/ObjectPageHeaderLayoutData',["sap/ui/core/LayoutData","./library"],function(L,l){"use strict";
var O=L.extend("sap.uxap.ObjectPageHeaderLayoutData",{metadata:{library:"sap.uxap",properties:{visibleS:{type:"boolean",group:"Misc",defaultValue:true},visibleM:{type:"boolean",group:"Misc",defaultValue:true},visibleL:{type:"boolean",group:"Misc",defaultValue:true},showSeparatorBefore:{type:"boolean",group:"Misc",defaultValue:false},showSeparatorAfter:{type:"boolean",group:"Misc",defaultValue:false},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:'auto'}}}});
return O;});
sap.ui.predefine('sap/uxap/ObjectPageHeaderRenderer',["./ObjectPageLayout","sap/ui/core/Icon"],function(O,I){"use strict";var a={};
a.render=function(r,c){var n=c.getNavigationBar(),t=(c.getIsObjectIconAlwaysVisible()||c.getIsObjectTitleAlwaysVisible()||c.getIsObjectSubtitleAlwaysVisible()||c.getIsActionAreaAlwaysVisible()),p=c.getParent(),e=c.getAggregation("_expandButton"),o=c._getInternalAggregation("_objectImage"),b=sap.ui.Device.system.desktop,d=p&&p instanceof O&&((p.getHeaderContent()&&p.getHeaderContent().length>0&&p.getShowHeaderContent())||(p.getShowHeaderContent()&&p.getShowTitleInHeaderContent()));r.write("<div");r.writeControlData(c);r.addClass('sapUxAPObjectPageHeader');r.addClass('sapUxAPObjectPageHeaderDesign-'+c.getHeaderDesign());r.writeClasses();r.write(">");if(n){r.write("<div");r.addClass('sapUxAPObjectPageHeaderNavigation');r.writeClasses();r.write(">");r.renderControl(n);r.write("</div>");}r.write("<div");r.writeAttributeEscaped("id",c.getId()+"-identifierLine");r.addClass('sapUxAPObjectPageHeaderIdentifier');if(t){r.addClass('sapUxAPObjectPageHeaderIdentifierForce');}r.writeClasses();r.write(">");if(p&&p instanceof O&&p.getIsChildPage()){r.write("<div");r.addClass('sapUxAPObjectChildPage');r.writeClasses();r.write("></div>");}if(c.getObjectImageURI()||c.getShowPlaceholder()){r.write("<span ");r.addClass('sapUxAPObjectPageHeaderObjectImageContainer');r.addClass('sapUxAPObjectPageHeaderObjectImage-'+c.getObjectImageShape());if(c.getIsObjectIconAlwaysVisible()){r.addClass('sapUxAPObjectPageHeaderObjectImageForce');}r.writeClasses();r.write(">");r.write("<span class='sapUxAPObjectPageHeaderObjectImageContainerSub'>");a._renderInProperContainer(function(){r.renderControl(o);a._renderPlaceholder(r,c,!(c.getObjectImageShape()||c.getShowPlaceholder()));},o,r);r.write("</span>");r.write("</span>");}r.write("<span ");r.writeAttributeEscaped("id",c.getId()+"-identifierLineContainer");r.addClass('sapUxAPObjectPageHeaderIdentifierContainer');r.writeClasses();r.write(">");this._renderObjectPageTitle(r,c);r.write("</span>");r.write("<span");r.writeAttributeEscaped("id",c.getId()+"-actions");r.addClass('sapUxAPObjectPageHeaderIdentifierActions');if(c.getIsActionAreaAlwaysVisible()){r.addClass('sapUxAPObjectPageHeaderIdentifierActionsForce');}if(c._getActionsPaddingStatus()){r.addClass("sapUxAPObjectPageHeaderIdentifierActionsNoPadding");}r.writeClasses();r.write(">");if(b&&d){e.addStyleClass("sapUxAPObjectPageHeaderExpandButton");r.renderControl(e);}var A=c.getActions();for(var i=0;i<A.length;i++){var f=A[i];r.renderControl(f);}var g=c.getAggregation("_overflowButton");r.renderControl(g);this._renderSideContentBtn(r,c);r.write("</span>");r.write("</div>");r.write("</div>");};
a._renderInProperContainer=function(r,o,R){if(o instanceof I){R.write("<div");R.addClass("sapUxAPObjectPageHeaderObjectImage");R.addClass("sapUxAPObjectPageHeaderPlaceholder");R.writeClasses();R.write(">");r();R.write("</div>");}else{r();}};
a._renderPlaceholder=function(r,c,v,t){r.write("<div");r.addClass('sapUxAPObjectPageHeaderPlaceholder');r.addClass('sapUxAPObjectPageHeaderObjectImage');if(!v){r.addClass('sapUxAPHidePlaceholder');}r.writeClasses();r.write(">");r.renderControl(c._oPlaceholder);r.write("</div>");};
a._renderObjectPageTitle=function(r,c,t){var o=c.getObjectTitle(),m=(c.getShowMarkers()&&(c.getMarkFavorite()||c.getMarkFlagged())),b=c._getInternalAggregation('_breadCrumbs');if(!t&&b&&b.getLinks().length){r.renderControl(b);}r.write("<h1");r.addClass('sapUxAPObjectPageHeaderIdentifierTitle');if(c.getIsObjectTitleAlwaysVisible()){r.addClass('sapUxAPObjectPageHeaderIdentifierTitleForce');}if(t){r.addClass('sapUxAPObjectPageHeaderIdentifierTitleInContent');}if(c.getShowTitleSelector()){r.addClass('sapUxAPObjectPageHeaderTitleFollowArrow');}r.writeClasses();r.writeAttributeEscaped("id",c.getId()+"-title");r.write(">");r.write("<span");r.addClass("sapUxAPObjectPageHeaderTitleTextWrappable");r.writeClasses();r.writeAttributeEscaped("id",c.getId()+"-innerTitle");r.write(">");if(m||c.getShowTitleSelector()||c.getMarkLocked()||c.getMarkChanges()){var s=o.substr(o.lastIndexOf(" ")+1);var d=o.substr(0,o.lastIndexOf(" ")+1);if(s.length===1){s=o;d='';}r.writeEscaped(d);r.write("</span>");r.write("<span");r.addClass('sapUxAPObjectPageHeaderNowrapMarkers');if(c.getMarkLocked()||c.getMarkChanges()){r.addClass('sapUxAPObjectPageHeaderMarks');}r.writeClasses();r.write(">");r.writeEscaped(s);this._renderMarkers(r,c);if(c.getMarkLocked()){this._renderLock(r,c,t);}else if(c.getMarkChanges()){this._renderMarkChanges(r,c,t);}this._renderSelectTitleArrow(r,c,t);r.write("</span>");}else{r.writeEscaped(o);r.write("</span>");}r.write("</h1>");r.write("<span");r.addClass('sapUxAPObjectPageHeaderIdentifierDescription');if(c.getIsObjectSubtitleAlwaysVisible()&&c.getObjectSubtitle()){r.addClass('sapUxAPObjectPageHeaderIdentifierDescriptionForce');}if(t){r.addClass('sapUxAPObjectPageHeaderIdentifierSubTitleInContent');}r.writeClasses();r.writeAttributeEscaped("id",c.getId()+"-subtitle");r.write(">");r.writeEscaped(c.getObjectSubtitle());r.write("</span>");};
a._renderSelectTitleArrow=function(r,c,t){if(c.getShowTitleSelector()){r.write("<span");r.addClass("sapUxAPObjectPageHeaderTitleArrow");r.writeClasses();r.write(">");if(t){r.renderControl(c._oTitleArrowIconCont);}else{r.renderControl(c._oTitleArrowIcon);}r.write("</span>");}};
a._renderSideContentBtn=function(r,c){var s=c.getSideContentButton();if(s){r.write("<span");r.addClass("sapUxAPObjectPageHeaderSideContentBtn");r.writeClasses();r.write(">");r.write("<span");r.addClass("sapUxAPObjectPageHeaderSeparator");r.writeClasses();r.write("></span>");r.renderControl(s);r.write("</span>");}};
a._renderMarkChanges=function(r,c,t){r.write("<span");r.addClass("sapUxAPObjectPageHeaderChangesBtn");r.addClass("sapUiSizeCompact");r.writeClasses();r.write(">");if(t){r.renderControl(c._oChangesIconCont);}else{r.renderControl(c._oChangesIcon);}r.write("</span>");};
a._renderLock=function(r,c,t){r.write("<span");r.addClass("sapUxAPObjectPageHeaderLockBtn");r.addClass("sapUiSizeCompact");r.writeClasses();r.write(">");if(t){r.renderControl(c._oLockIconCont);}else{r.renderControl(c._oLockIcon);}r.write("</span>");};
a._renderMarkers=function(r,c){var b=[];if(c.getShowMarkers()){b.push(c._oFavIcon);b.push(c._oFlagIcon);this._renderMarkersAria(r,c);r.write("<span");r.addClass("sapMObjStatusMarker");r.writeClasses();r.writeAttributeEscaped("id",c.getId()+"-markers");r.writeAttributeEscaped("aria-describedby",c.getId()+"-markers-aria");r.write(">");for(var i=0;i<b.length;i++){r.renderControl(b[i]);}r.write("</span>");}};
a._renderMarkersAria=function(r,c){var A="";if(c.getMarkFlagged()){A+=(c.oLibraryResourceBundle.getText("ARIA_FLAG_MARK_VALUE")+" ");}if(c.getMarkFavorite()){A+=(c.oLibraryResourceBundle.getText("ARIA_FAVORITE_MARK_VALUE")+" ");}if(A!==""){r.write("<div");r.writeAttributeEscaped("id",c.getId()+"-markers-aria");r.writeAttribute("aria-hidden","false");r.addClass("sapUiHidden");r.writeClasses();r.write(">");r.writeEscaped(A);r.write("</div>");}};
return a;},true);
sap.ui.predefine('sap/uxap/ObjectPageLayout.designtime',[],function(){"use strict";return{aggregations:{sections:{domRef:":sap-domref > .sapUxAPObjectPageWrapper",actions:{move:"moveElements"}}},cloneDomRef:":sap-domref > header"};},false);
sap.ui.predefine('sap/uxap/ObjectPageLayout',["jquery.sap.global","sap/ui/core/ResizeHandler","sap/ui/core/Control","sap/ui/core/CustomData","sap/ui/Device","sap/ui/core/delegate/ScrollEnablement","./ObjectPageSection","./ObjectPageSubSection","./ObjectPageSubSectionLayout","./LazyLoading","./ObjectPageLayoutABHelper","./ThrottledTaskHelper","sap/ui/core/ScrollBar","./library"],function(q,R,C,a,D,S,O,b,c,L,A,T,d,l){"use strict";
var e=C.extend("sap.uxap.ObjectPageLayout",{metadata:{library:"sap.uxap",properties:{showAnchorBar:{type:"boolean",defaultValue:true},showAnchorBarPopover:{type:"boolean",defaultValue:true},upperCaseAnchorBar:{type:"boolean",defaultValue:true},height:{type:"sap.ui.core.CSSSize",defaultValue:"100%"},enableLazyLoading:{type:"boolean",defaultValue:false},subSectionLayout:{type:"sap.uxap.ObjectPageSubSectionLayout",defaultValue:c.TitleOnTop},useIconTabBar:{type:"boolean",group:"Misc",defaultValue:false},showHeaderContent:{type:"boolean",group:"Misc",defaultValue:true},useTwoColumnsForLargeScreen:{type:"boolean",group:"Appearance",defaultValue:false},showTitleInHeaderContent:{type:"boolean",group:"Appearance",defaultValue:false},showOnlyHighImportance:{type:"boolean",group:"Behavior",defaultValue:false},isChildPage:{type:"boolean",group:"Appearance",defaultValue:false},alwaysShowContentHeader:{type:"boolean",group:"Behavior",defaultValue:false},showEditHeaderButton:{type:"boolean",group:"Behavior",defaultValue:false},flexEnabled:{type:"boolean",group:"Misc",defaultValue:false},showFooter:{type:"boolean",group:"Behaviour",defaultValue:false}},defaultAggregation:"sections",aggregations:{sections:{type:"sap.uxap.ObjectPageSection",multiple:true,singularName:"section"},headerTitle:{type:"sap.uxap.ObjectPageHeader",multiple:false},headerContent:{type:"sap.ui.core.Control",multiple:true,singularName:"headerContent"},footer:{type:"sap.m.IBar",multiple:false},_anchorBar:{type:"sap.uxap.AnchorBar",multiple:false,visibility:"hidden"},_iconTabBar:{type:"sap.m.IconTabBar",multiple:false,visibility:"hidden"},_headerContent:{type:"sap.uxap.ObjectPageHeaderContent",multiple:false,visibility:"hidden"},_customScrollBar:{type:"sap.ui.core.ScrollBar",multiple:false,visibility:"hidden"}},events:{toggleAnchorBar:{parameters:{fixed:{type:"boolean"}}},editHeaderButtonPress:{},navigate:{parameters:{section:{type:"sap.uxap.ObjectPageSection"}}}},designTime:true}});
e.HEADER_CALC_DELAY=350;e.DOM_CALC_DELAY=200;e.FOOTER_ANIMATION_DURATION=350;
e.prototype.init=function(){this._bFirstRendering=true;this._bDomReady=false;this._bStickyAnchorBar=false;this._iStoredScrollPosition=0;this._bInternalAnchorBarVisible=true;this._$opWrapper=[];this._$anchorBar=[];this._$headerTitle=[];this._$stickyAnchorBar=[];this._$headerContent=[];this._$stickyHeaderContent=[];this._bMobileScenario=false;this._oSectionInfo={};this._aSectionBases=[];this._sScrolledSectionId="";this._iScrollToSectionDuration=600;this._$spacer=[];this.iHeaderContentHeight=0;this.iStickyHeaderContentHeight=0;this.iHeaderTitleHeight=0;this.iHeaderTitleHeightStickied=0;this.iAnchorBarHeight=0;this.iTotalHeaderSize=0;this._iREMSize=parseInt(q("body").css("font-size"),10);this._iOffset=parseInt(0.25*this._iREMSize,10);this._iScrollBarWidth=q.position.scrollbarWidth();this._iResizeId=R.register(this,this._onUpdateScreenSize.bind(this));this._oLazyLoading=new L(this);this._oABHelper=new A(this);};
e.prototype.onBeforeRendering=function(){if(!this.getVisible()){return;}this._bMobileScenario=l.Utilities.isPhoneScenario();this._bTabletScenario=l.Utilities.isTabletScenario();this._bHContentAlwaysExpanded=this._checkAlwaysShowContentHeader();this._initializeScroller();this._storeScrollLocation();this._getHeaderContent().setContentDesign(this._getHeaderDesign());this._oABHelper._getAnchorBar().setUpperCase(this.getUpperCaseAnchorBar());this._applyUxRules();if(!q.isEmptyObject(this._oSectionInfo)&&this._bFirstRendering){this._preloadSectionsOnBeforeFirstRendering();this._bFirstRendering=false;}this._bStickyAnchorBar=false;var h=this.getHeaderTitle();if(h&&h.getAggregation("_expandButton")){h.getAggregation("_expandButton").attachPress(this._handleExpandButtonPress,this);}};
e.prototype._preloadSectionsOnBeforeFirstRendering=function(){var t;if(!this.getEnableLazyLoading()){t=this.getUseIconTabBar()?[this._oFirstVisibleSection]:this.getSections();}else{var s=this.getUseIconTabBar()?this._grepCurrentTabSectionBases():this._aSectionBases;t=this._oLazyLoading.getSubsectionsToPreload(s);}this._connectModelsForSections(t);};
e.prototype._grepCurrentTabSectionBases=function(){var F=[],s=this._oCurrentTabSection||this._oFirstVisibleSection;if(s){var g=s.getId();this._aSectionBases.forEach(function(o){if(o.getParent().getId()===g){F.push(o);}});}return F;};
e.prototype.onAfterRendering=function(){this._ensureCorrectParentHeight();this._cacheDomElements();this._$opWrapper.on("scroll",this._onScroll.bind(this));if(this._bDomReady&&this.$().parents(":hidden").length===0){this._onAfterRenderingDomReady();}else{q.sap.delayedCall(e.HEADER_CALC_DELAY,this,this._onAfterRenderingDomReady);}};
e.prototype._onAfterRenderingDomReady=function(){var s=this._oStoredSection||this._oFirstVisibleSection;this._bDomReady=true;this._adjustHeaderHeights();if(this.getUseIconTabBar()&&s){this._setSelectedSectionId(s.getId());this._setCurrentTabSection(s);}this._initAnchorBarScroll();if(sap.ui.Device.system.desktop){this._$opWrapper.on("scroll",this.onWrapperScroll.bind(this));}this._registerOnContentResize();this.getHeaderTitle()&&this.getHeaderTitle()._shiftHeaderTitle();this.getFooter()&&this._shiftFooter();this._setSectionsFocusValues();this._restoreScrollPosition();};
e.prototype._shiftFooter=function(){var $=this.$("footerWrapper"),s=this._calculateShiftOffset();$.css(s.sStyleAttribute,s.iMarginalsOffset+"px");};
e.prototype._calculateShiftOffset=function(){var h=0,s=sap.ui.getCore().getConfiguration().getRTL()?"left":"right",H=this._hasVerticalScrollBar(),i=this._iOffset;if(sap.ui.Device.system.desktop){h=this._iScrollBarWidth;if(!H){h=0;i+=this._iScrollBarWidth;}}return{"sStyleAttribute":s,"iActionsOffset":i,"iMarginalsOffset":h};};
e.prototype.exit=function(){if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._iResizeId){R.deregister(this._iResizeId);}if(this._iContentResizeId){R.deregister(this._iContentResizeId);}};
e.prototype._getCustomScrollBar=function(){if(!this.getAggregation("_customScrollBar")){var v=new d(this.getId()+"-vertSB",{vertical:true,size:"100%",scrollPosition:0,scroll:this.onCustomScrollerScroll.bind(this)});this.setAggregation("_customScrollBar",v,true);}return this.getAggregation("_customScrollBar");};
e.prototype.onWrapperScroll=function(E){var s=Math.max(E.target.scrollTop,0);if(this._getCustomScrollBar()){if(this.allowCustomScroll===true){this.allowCustomScroll=false;return;}this.allowInnerDiv=true;this._getCustomScrollBar().setScrollPosition(s);}};
e.prototype.onCustomScrollerScroll=function(E){var s=Math.max(this._getCustomScrollBar().getScrollPosition(),0);if(this.allowInnerDiv===true){this.allowInnerDiv=false;return;}this.allowCustomScroll=true;q(this._$opWrapper).scrollTop(s);};
e.prototype.setShowOnlyHighImportance=function(v){var o=this.getShowOnlyHighImportance();if(o!==v){this.setProperty("showOnlyHighImportance",v,true);this.getSections().forEach(function(s){s._updateImportance();});}return this;};
e.prototype.setIsHeaderContentAlwaysExpanded=function(v){var o=this.getAlwaysShowContentHeader();var s=(D.system.phone||D.system.tablet);if(o!==v){this.setProperty("alwaysShowContentHeader",v,s);}return this;};
e.prototype.setBusy=function(B){var $=this.$("headerTitle"),r=C.prototype.setBusy.call(this,B);$.length>0&&$.toggleClass("sapUxAPObjectPageHeaderTitleBusy",B);return r;};
e.prototype._initializeScroller=function(){if(this._oScroller){return;}this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:false,vertical:true});};
e.prototype._ensureCorrectParentHeight=function(){if(this._bCorrectParentHeightIsSet){return;}if(this.getParent().getHeight&&["","auto"].indexOf(this.getParent().getHeight())!==-1){this.$().parent().css("height","100%");}this._bCorrectParentHeightIsSet=true;};
e.prototype._cacheDomElements=function(){this._$headerTitle=q.sap.byId(this.getId()+"-headerTitle");this._$anchorBar=q.sap.byId(this.getId()+"-anchorBar");this._$stickyAnchorBar=q.sap.byId(this.getId()+"-stickyAnchorBar");this._$opWrapper=q.sap.byId(this.getId()+"-opwrapper");this._$spacer=q.sap.byId(this.getId()+"-spacer");this._$headerContent=q.sap.byId(this.getId()+"-headerContent");this._$stickyHeaderContent=q.sap.byId(this.getId()+"-stickyHeaderContent");this._$contentContainer=q.sap.byId(this.getId()+"-scroll");this._$sectionsContainer=q.sap.byId(this.getId()+"-sectionsContainer");this._bDomElementsCached=true;};
e.prototype._handleExpandButtonPress=function(E){this._expandCollapseHeader(true);};
e.prototype._toggleStickyHeader=function(E){this._bIsHeaderExpanded=E;this._$headerTitle.toggleClass("sapUxAPObjectPageHeaderStickied",!E);};
e.prototype._expandCollapseHeader=function(E){var h=this.getHeaderTitle();if(this._bHContentAlwaysExpanded){return;}if(E&&this._bStickyAnchorBar){if(h&&h.getIsActionAreaAlwaysVisible()&&!h.getIsObjectTitleAlwaysVisible()){h._setActionsPaddingStatus(E);}this._$headerContent.css("height",this.iHeaderContentHeight).children().appendTo(this._$stickyHeaderContent);this._toggleStickyHeader(E);}else if(!E&&this._bIsHeaderExpanded){this._$headerContent.css("height","auto").append(this._$stickyHeaderContent.children());this._$stickyHeaderContent.children().remove();this._toggleStickyHeader(E);}};
e.prototype._updateNavigation=function(){if(this.getShowAnchorBar()){this._oABHelper._buildAnchorBar();}};
e.prototype._applyUxRules=function(i){var s,g,v,V,h,j,k,F,o;s=this.getSections()||[];V=0;j=this.getShowAnchorBar();k=this.getUseIconTabBar();F=null;this._cleanMemory();s.forEach(function(m){if(!m.getVisible()){return true;}this._registerSectionBaseInfo(m);g=m.getSubSections()||[];v=0;o=null;g.forEach(function(n){if(!n.getVisible()){return true;}this._registerSectionBaseInfo(n);h=n.getVisibleBlocksCount();if(h===0){n._setInternalVisible(false,i);q.sap.log.info("ObjectPageLayout :: noVisibleBlock UX rule matched","subSection "+n.getTitle()+" forced to hidden");}else{n._setInternalVisible(true,i);n._setInternalTitleVisible(true,i);v++;if(!o){o=n;}}},this);if(v==0){m._setInternalVisible(false,i);q.sap.log.info("ObjectPageLayout :: noVisibleSubSection UX rule matched","section "+m.getTitle()+" forced to hidden");}else{m._setInternalVisible(true,i);m._setInternalTitleVisible(true,i);if(!F){F=m;}if(this.getSubSectionLayout()===c.TitleOnTop&&v===1&&o.getTitle().trim()!==""){q.sap.log.info("ObjectPageLayout :: TitleOnTop.sectionGetSingleSubSectionTitle UX rule matched","section "+m.getTitle()+" is taking its single subsection title "+o.getTitle());m._setInternalTitle(o.getTitle(),i);o._setInternalTitleVisible(false,i);}else{m._setInternalTitle("",i);}V++;}if(k){m._setInternalTitleVisible(false,i);}},this);if(V<=1){j=false;q.sap.log.info("ObjectPageLayout :: notEnoughVisibleSection UX rule matched","anchorBar forced to hidden");}else if(F&&j){F._setInternalTitleVisible(false,i);q.sap.log.info("ObjectPageLayout :: firstSectionTitleHidden UX rule matched","section "+F.getTitle()+" title forced to hidden");}if(j){this._oABHelper._buildAnchorBar();}this._setInternalAnchorBarVisible(j,i);this._oFirstVisibleSection=F;};
e.prototype.setUseIconTabBar=function(v){var o=this.getUseIconTabBar();if(v!=o){this._applyUxRules();}this.setProperty("useIconTabBar",v);return this;};
e.prototype._setCurrentTabSection=function(s,i){if(!s){return;}var o;if(s instanceof sap.uxap.ObjectPageSubSection){o=s;s=s.getParent();}else{o=this._getFirstVisibleSubSection(s);}if(this._oCurrentTabSection!==s){this._renderSection(s);this._oCurrentTabSection=s;}this._oCurrentTabSubSection=o;};
e.prototype._renderSection=function(s){var $=this.$().find(".sapUxAPObjectPageContainer"),r;if(s&&$.length){r=sap.ui.getCore().createRenderManager();r.renderControl(s);r.flush($[0]);r.destroy();}};
e.prototype.setShowAnchorBarPopover=function(v,s){this._oABHelper._buildAnchorBar();this._oABHelper._getAnchorBar().setShowPopover(v);return this.setProperty("showAnchorBarPopover",v,true);};
e.prototype._getInternalAnchorBarVisible=function(){return this._bInternalAnchorBarVisible;};
e.prototype._setInternalAnchorBarVisible=function(v,i){if(v!=this._bInternalAnchorBarVisible){this._bInternalAnchorBarVisible=v;if(i===true){this.invalidate();}}};
e.prototype._requestAdjustLayout=function(E,i,n){if(!this._oLayoutTask){this._oLayoutTask=new T(this._executeAdjustLayout,e.DOM_CALC_DELAY,this);}if(!i){q.sap.log.debug("ObjectPageLayout :: _requestAdjustLayout","delayed by "+e.DOM_CALC_DELAY+" ms because of dom modifications");}var t=arguments;Array.prototype.splice.call(t,0,2);return this._oLayoutTask.reSchedule(i,t);};
e.prototype._executeAdjustLayout=function(n){var s=this._updateScreenHeightSectionBasesAndSpacer();if(s&&n){this._oLazyLoading.doLazyLoading();}return s;};
e.prototype._adjustLayoutAndUxRules=function(){q.sap.log.debug("ObjectPageLayout :: _requestAdjustLayout","refreshing ux rules");var s=this._getSelectedSectionId(),o=sap.ui.getCore().byId(s),g=false;this._applyUxRules(true);if(!o||!o.getVisible()||!o._getInternalVisible()){o=this._oFirstVisibleSection;s=o&&o.getId();g=true;}if(o){this._setSelectedSectionId(s);if(this.getUseIconTabBar()){this._setCurrentTabSection(o);}this._requestAdjustLayout(null,false,true).then(function(){if(g){this.scrollToSection(s);}}.bind(this));}};
e.prototype._getSelectedSectionId=function(){var o=this.getAggregation("_anchorBar"),s;if(o&&o.getSelectedSection()){s=o.getSelectedSection().getId();}return s;};
e.prototype._setSelectedSectionId=function(s){var o=this.getAggregation("_anchorBar"),g=s&&this._oSectionInfo[s];if(!g){return;}if(o&&g.buttonId){o.setSelectedButton(g.buttonId);}};
e.prototype.isFirstRendering=function(){return this._bFirstRendering;};
e.prototype._cleanMemory=function(){var o=this.getAggregation("_anchorBar");if(o){o._resetControl();}this._oSectionInfo={};this._aSectionBases=[];};
e.prototype._registerSectionBaseInfo=function(s){this._oSectionInfo[s.getId()]={$dom:[],positionTop:0,positionTopMobile:0,buttonId:"",isSection:(s instanceof O),sectionReference:s};this._aSectionBases.push(s);};
e.prototype.scrollToSection=function(i,g,o,I){var s=sap.ui.getCore().byId(i);if(!this.getDomRef()){q.sap.log.warning("scrollToSection can only be used after the ObjectPage is rendered",this);return;}if(this.bIsDestroyed){q.sap.log.debug("ObjectPageLayout :: scrollToSection","scrolling canceled as page is being destroyed");return;}if(this.getUseIconTabBar()){var t=O._getClosestSection(s);if(this._oCurrentTabSection){this._oCurrentTabSection._allowPropagationToLoadedViews(false);}t._allowPropagationToLoadedViews(true);this._setCurrentTabSection(s);this.getAggregation("_anchorBar").setSelectedButton(this._oSectionInfo[t.getId()].buttonId);}if(I){this.fireNavigate({section:O._getClosestSection(s)});}if(this._bIsHeaderExpanded){this._expandCollapseHeader(false);}o=o||0;s._expandSection();this._requestAdjustLayout(null,true);g=this._computeScrollDuration(g,s);var h=this._computeScrollPosition(s);if(this._sCurrentScrollId!=i){this._sCurrentScrollId=i;if(this._iCurrentScrollTimeout){clearTimeout(this._iCurrentScrollTimeout);if(this._$contentContainer){this._$contentContainer.parent().stop(true,false);}}if(this._bDomElementsCached){this._iCurrentScrollTimeout=q.sap.delayedCall(g,this,function(){this._sCurrentScrollId=undefined;this._iCurrentScrollTimeout=undefined;});}this._preloadSectionsOnScroll(s);this.getHeaderTitle()&&this.getHeaderTitle()._shiftHeaderTitle();this._scrollTo(h+o,g);}};
e.prototype._computeScrollDuration=function(i,t){var g=parseInt(i,10);g=g>=0?g:this._iScrollToSectionDuration;if(this.getUseIconTabBar()&&((t instanceof O)||this._isFirstVisibleSectionBase(t))&&this._bStickyAnchorBar){g=0;}return g;};
e.prototype._computeScrollPosition=function(t){var F=t&&(t instanceof O),i=t.getId(),s=this._bMobileScenario||F?this._oSectionInfo[i].positionTopMobile:this._oSectionInfo[i].positionTop,E=!this._bStickyAnchorBar;if(E&&this._isFirstVisibleSectionBase(t)){s-=this.iHeaderContentHeight;}return s;};
e.prototype._preloadSectionsOnScroll=function(t){var i=t.getId(),g;if(!this.getEnableLazyLoading()&&this.getUseIconTabBar()){g=(t instanceof O)?t:t.getParent();this._connectModelsForSections([g]);}if(this.getEnableLazyLoading()){var s=this.getUseIconTabBar()?this._grepCurrentTabSectionBases():this._aSectionBases;g=this._oLazyLoading.getSubsectionsToPreload(s,i);if(D.system.desktop){q.sap.delayedCall(50,this,function(){this._connectModelsForSections(g);});}else{this._connectModelsForSections(g);}}};
e.prototype.getScrollingSectionId=function(){return this._sScrolledSectionId;};
e.prototype.setDirectScrollingToSection=function(s){this.sDirectSectionId=s;};
e.prototype.getDirectScrollingToSection=function(){return this.sDirectSectionId;};
e.prototype.clearDirectScrollingToSection=function(){this.sDirectSectionId=null;};
e.prototype._scrollTo=function(y,t){if(this._oScroller){q.sap.log.debug("ObjectPageLayout :: scrolling to "+y);this._oScroller.scrollTo(0,y,t);}return this;};
e.prototype._updateScreenHeightSectionBasesAndSpacer=function(){var i,o,s,p,P,g;if(!this._bDomReady){return false;}q.sap.log.debug("ObjectPageLayout :: _updateScreenHeightSectionBasesAndSpacer","re-evaluating dom positions");this.iScreenHeight=this.$().height();var h=0;this._aSectionBases.forEach(function(j){var I=this._oSectionInfo[j.getId()],$=j.$(),k,m=false;if(!I||!$.length){return;}if(!I.isSection){h++;}I.$dom=$;var r=$.position().top;var H=(j._getInternalTitleVisible()&&(j.getTitle().trim()!==""));var n=!I.isSection&&j.getAggregation("actions",[]).length>0;if(!I.isSection&&!H&&!n){r=$.find(".sapUiResponsiveMargin.sapUxAPBlockContainer").position().top;}I.positionTop=Math.ceil(r);if(I.isSection){k=j.$("header");}else{k=j.$("headerTitle");}m=k.length===0;if(!m){I.positionTopMobile=Math.ceil(k.position().top)+k.outerHeight();}else{I.positionTopMobile=I.positionTop;}if(!this._bStickyAnchorBar&&!this._bIsHeaderExpanded){I.positionTopMobile-=this.iAnchorBarHeight;I.positionTop-=this.iAnchorBarHeight;}I.sectionReference.toggleStyleClass("sapUxAPObjectPageSubSectionPromoted",m);if(this._bMobileScenario){if(P){this._oSectionInfo[P].positionBottom=I.positionTop;}P=j.getId();o=j;}else{if(I.isSection){if(P){this._oSectionInfo[P].positionBottom=I.positionTop;if(p){this._oSectionInfo[p].positionBottom=I.positionTop;}}P=j.getId();p=null;}else{if(p){this._oSectionInfo[p].positionBottom=I.positionTop;}p=j.getId();o=j;}}},this);if(o){i=this._computeLastVisibleHeight(o);if(this._bMobileScenario&&P){this._oSectionInfo[P].positionBottom=this._oSectionInfo[P].positionTop+i;}else{if(p){this._oSectionInfo[p].positionBottom=this._oSectionInfo[p].positionTop+i;}if(P&&p){this._oSectionInfo[P].positionBottom=this._oSectionInfo[p].positionTop+i;}}g=this._bStickyAnchorBar||(h>1)||this._checkContentBottomRequiresSnap(o);s=this._computeSpacerHeight(o,i,g);this._$spacer.height(s+"px");q.sap.log.debug("ObjectPageLayout :: bottom spacer is now "+s+"px");}this._updateCustomScrollerHeight(g);return true;};
e.prototype._updateCustomScrollerHeight=function(r){if(sap.ui.Device.system.desktop&&this.getAggregation("_customScrollBar")){var s=this._computeScrollableContentSize(r);s+=this._getStickyAreaHeight(r);this._getCustomScrollBar().setContentSize(s+"px");var g=(s>this.iScreenHeight),v=(g!==this._getCustomScrollBar().getVisible());if(v){this._getCustomScrollBar().setVisible(g);this.getHeaderTitle()&&this.getHeaderTitle()._shiftHeaderTitle();}}};
e.prototype._computeScrollableContentSize=function(s){var i=0;if(this._$contentContainer&&this._$contentContainer.length){i=this._$contentContainer[0].scrollHeight;}if(!this._bStickyAnchorBar&&s){i-=this.iAnchorBarHeight;}if(this._bStickyAnchorBar&&!s){i+=this.iAnchorBarHeight;}return i;};
e.prototype._computeLastVisibleHeight=function(o){var i=this._bStickyAnchorBar||this._bIsHeaderExpanded;var g=this._getSectionPositionTop(o,i);return this._$spacer.position().top-g;};
e.prototype._getStickyAreaHeight=function(i){if(this._bHContentAlwaysExpanded){return this.iHeaderTitleHeight;}if(i){return this.iHeaderTitleHeightStickied+this.iAnchorBarHeight;}return this.iHeaderTitleHeight;};
e.prototype._getScrollableViewportHeight=function(i){var s=this.$().height();return s-this._getStickyAreaHeight(i);};
e.prototype._getSectionPositionTop=function(s,g){var p=this._oSectionInfo[s.getId()].positionTop;if(!g){p+=this.iAnchorBarHeight;}return p;};
e.prototype._getSectionPositionBottom=function(s,g){var p=this._oSectionInfo[s.getId()].positionBottom;if(!g){p+=this.iAnchorBarHeight;}return p;};
e.prototype._checkContentBottomRequiresSnap=function(s){var g=false;return this._getSectionPositionBottom(s,g)>=(this._getScrollableViewportHeight(g)+this._getSnapPosition());};
e.prototype._computeSpacerHeight=function(o,i,s){var g,h;h=this._getScrollableViewportHeight(s);if(!s){i=this._getSectionPositionBottom(o,false);}if(i<h){g=h-i;if(this._bMobileScenario){g+=(this._oSectionInfo[o.getId()].positionTopMobile-this._oSectionInfo[o.getId()].positionTop);}}else{g=0;}return g;};
e.prototype._isFirstVisibleSectionBase=function(s){var o=this._oSectionInfo[s.getId()];if(o){return o.positionTop===this.iHeaderContentHeight;}return false;};
e.prototype._getFirstVisibleSubSection=function(s){if(!s){return;}var F;this._aSectionBases.every(function(o){if(o.getParent()&&(o.getParent().getId()===s.getId())){F=o;return false;}return true;});return F;};
e.prototype._initAnchorBarScroll=function(){this._requestAdjustLayout(null,true);this._sScrolledSectionId="";this._onScroll({target:{scrollTop:0}});};
e.prototype._setAsCurrentSection=function(s){var o,g,h;if(this._sScrolledSectionId===s){return;}q.sap.log.debug("ObjectPageLayout :: current section is "+s);this._sScrolledSectionId=s;o=this.getAggregation("_anchorBar");if(o&&this._getInternalAnchorBarVisible()){g=sap.ui.getCore().byId(s);h=g&&g instanceof b&&(g.getTitle().trim()===""||!g._getInternalTitleVisible()||g.getParent()._getIsHidden());if(h){s=g.getParent().getId();q.sap.log.debug("ObjectPageLayout :: current section is a subSection with an empty or hidden title, selecting parent "+s);}if(this._oSectionInfo[s]){o.setSelectedButton(this._oSectionInfo[s].buttonId);this._setSectionsFocusValues(s);}}};
e.prototype._registerOnContentResize=function(){var $=this._$sectionsContainer.length&&this._$sectionsContainer[0];if(!$){return;}if(this._iContentResizeId){R.deregister(this._iContentResizeId);}this._iContentResizeId=R.register($,this._onUpdateContentSize.bind(this));};
e.prototype._onUpdateContentSize=function(E){var s,p,g,h;this._requestAdjustLayout().then(function(){s=this._$opWrapper.scrollTop();p=this.iScreenHeight;g=this._getClosestScrolledSectionId(s,p);h=this._getSelectedSectionId();if(h!==g){this.getAggregation("_anchorBar").setSelectedButton(this._oSectionInfo[g].buttonId);}}.bind(this));};
e.prototype._onUpdateScreenSize=function(E){if(!this._bDomReady){q.sap.log.info("ObjectPageLayout :: cannot _onUpdateScreenSize before dom is ready");return;}this._oLazyLoading.setLazyLoadingParameters();q.sap.delayedCall(e.HEADER_CALC_DELAY,this,function(){this._bMobileScenario=l.Utilities.isPhoneScenario();this._bTabletScenario=l.Utilities.isTabletScenario();if(this._bHContentAlwaysExpanded!=this._checkAlwaysShowContentHeader()){this.invalidate();}this._adjustHeaderHeights();this._requestAdjustLayout(null,true);if(this.getFooter()&&this.getShowFooter()){this._shiftFooter();}this._scrollTo(this._$opWrapper.scrollTop(),0);});};
e.prototype._onScroll=function(E){var s=Math.max(E.target.scrollTop,0),p,h=this.getHeaderTitle(),g=(s>0)&&(s>=this._getSnapPosition()),i,j=false;p=this.iScreenHeight;if(g&&!this._bHContentAlwaysExpanded){p-=(this.iAnchorBarHeight+this.iHeaderTitleHeightStickied);}else{if(g&&this._bHContentAlwaysExpanded){p=p-(this._$stickyAnchorBar.height()+this.iHeaderTitleHeight+this.iStickyHeaderContentHeight);}}if(this._bIsHeaderExpanded){this._expandCollapseHeader(false);}if(!this._bHContentAlwaysExpanded&&((h&&this.getShowHeaderContent())||this.getShowAnchorBar())){this._toggleHeader(g);}else if(s==0&&((h&&this.getShowHeaderContent())||this.getShowAnchorBar())){this._toggleHeader(false);}if(!this._bHContentAlwaysExpanded){this._adjustHeaderTitleBackgroundPosition(s);}q.sap.log.debug("ObjectPageLayout :: lazy loading : Scrolling at "+s,"----------------------------------------");i=this._getClosestScrolledSectionId(s,p);if(i){var k=this.getDirectScrollingToSection();if(i!==this._sScrolledSectionId){q.sap.log.debug("ObjectPageLayout :: closest id "+i,"----------------------------------------");var k=this.getDirectScrollingToSection();if(k&&k!==i){return;}this.clearDirectScrollingToSection();this._setAsCurrentSection(i);}else if(i===this.getDirectScrollingToSection()){this.clearDirectScrollingToSection();}}if(this.getEnableLazyLoading()){this._oLazyLoading.lazyLoadDuringScroll(s,E.timeStamp,p);}if(h&&this.getShowHeaderContent()&&this.getShowTitleInHeaderContent()&&h.getShowTitleSelector()){if(s===0){q.sap.byId(this.getId()+"-scroll").css("z-index","1000");j=false;}else if(!j){j=true;q.sap.byId(this.getId()+"-scroll").css("z-index","0");}}};
e.prototype._getSnapPosition=function(){return(this.iHeaderContentHeight-(this.iHeaderTitleHeightStickied-this.iHeaderTitleHeight));};
e.prototype._getClosestScrolledSectionId=function(s,p){if(this.getUseIconTabBar()&&this._oCurrentTabSection){return this._oCurrentTabSection.getId();}var i=s+p,g;q.each(this._oSectionInfo,function(I,o){if(o.isSection||this._bMobileScenario){if(!g&&(o.sectionReference._getInternalVisible()===true)){g=I;}if(o.positionTop<=i&&s<=o.positionBottom){if(o.positionTop<=s&&o.positionBottom>=s){g=I;return false;}}}}.bind(this));return g;};
e.prototype._toggleHeader=function(s){var h=this.getHeaderTitle();if(!this._bHContentAlwaysExpanded&&!this._bIsHeaderExpanded){this._$headerTitle.toggleClass("sapUxAPObjectPageHeaderStickied",s);}if(h&&h.getIsActionAreaAlwaysVisible()&&!h.getIsObjectTitleAlwaysVisible()){h._setActionsPaddingStatus(!s);}if(!this._bStickyAnchorBar&&s){this._restoreFocusAfter(this._convertHeaderToStickied);h&&h._adaptLayout();this._adjustHeaderHeights();}else if(this._bStickyAnchorBar&&!s){this._restoreFocusAfter(this._convertHeaderToExpanded);h&&h._adaptLayout();this._adjustHeaderHeights();}};
e.prototype._restoreFocusAfter=function(m){var o=sap.ui.getCore(),g=o.byId(o.getCurrentFocusedControlId());m.call(this);if(D.system.phone!==true){if(!o.byId(o.getCurrentFocusedControlId())){g&&g.$().focus();}}return this;};
e.prototype._convertHeaderToStickied=function(){if(!this._bHContentAlwaysExpanded){this._$anchorBar.children().appendTo(this._$stickyAnchorBar);this._toggleHeaderStyleRules(true);if(this.iHeaderTitleHeight!=this.iHeaderTitleHeightStickied){this._adjustHeaderBackgroundSize();}}return this;};
e.prototype._convertHeaderToExpanded=function(){if(!this._bHContentAlwaysExpanded){this._$anchorBar.css("height","auto").append(this._$stickyAnchorBar.children());this._toggleHeaderStyleRules(false);}return this;};
e.prototype._toggleHeaderStyleRules=function(s){s=!!s;var v=s?"hidden":"inherit";this._bStickyAnchorBar=s;this._$headerContent.css("overflow",v);this._$headerContent.toggleClass("sapContrastPlus",!s);this._$headerContent.toggleClass("sapUxAPObjectPageHeaderDetailsHidden",s);this._$anchorBar.css("visibility",v);this.fireToggleAnchorBar({fixed:s});};
e.prototype.getScrollDelegate=function(){return this._oScroller;};
e.prototype.setHeaderTitle=function(h,s){if(h&&typeof h.addEventDelegate==="function"){h.addEventDelegate({onAfterRendering:this._adjustHeaderHeights.bind(this)});}return this.setAggregation("headerTitle",h,s);};
e.prototype._adjustHeaderBackgroundSize=function(){var h=this.getHeaderTitle();if(h&&h.getHeaderDesign()=="Dark"){if(!this._bHContentAlwaysExpanded){this.iTotalHeaderSize=this.iHeaderTitleHeight+this.iHeaderContentHeight;this._$headerContent.css("background-size","100% "+this.iTotalHeaderSize+"px");}else{this.iTotalHeaderSize=this.iHeaderTitleHeight-this._$stickyAnchorBar.height();this._$stickyHeaderContent.css("background-size","100% "+this.iTotalHeaderSize+"px");}h.$().css("background-size","100% "+this.iTotalHeaderSize+"px");this._adjustHeaderTitleBackgroundPosition(0);}};
e.prototype._adjustHeaderTitleBackgroundPosition=function(s){var h=this.getHeaderTitle();if(h&&h.getHeaderDesign()=="Dark"){if(this._bStickyAnchorBar){h.$().css("background-position","0px "+((this.iTotalHeaderSize-this.iHeaderTitleHeightStickied)*-1)+"px");}else{if(this._bHContentAlwaysExpanded){h.$().css("background-position","0px 0px");}else{h.$().css("background-position","0px "+(this.iHeaderTitleHeight+this.iHeaderContentHeight-this.iTotalHeaderSize-s)+"px");}}}};
e.prototype._adjustHeaderHeights=function(){if(this._$headerTitle.length>0){var $=this._$headerTitle.clone();this.iHeaderContentHeight=this._$headerContent.height();this.iStickyHeaderContentHeight=this._$stickyHeaderContent.height();this.iAnchorBarHeight=this._bStickyAnchorBar?this._$stickyAnchorBar.height():this._$anchorBar.height();$.css({left:"-10000px",top:"-10000px",width:this._$headerTitle.width()+"px"});if(this._bStickyAnchorBar){this.iHeaderTitleHeightStickied=this._$headerTitle.height()-this.iAnchorBarHeight;$.removeClass("sapUxAPObjectPageHeaderStickied");$.appendTo(this._$headerTitle.parent());this.iHeaderTitleHeight=$.is(":visible")?$.height()-this.iAnchorBarHeight:0;}else{this.iHeaderTitleHeight=this._$headerTitle.is(":visible")?this._$headerTitle.height():0;$.addClass("sapUxAPObjectPageHeaderStickied");$.appendTo(this._$headerTitle.parent());this.iHeaderTitleHeightStickied=$.height();}$.remove();this._adjustHeaderBackgroundSize();q.sap.log.info("ObjectPageLayout :: adjustHeaderHeight","headerTitleHeight: "+this.iHeaderTitleHeight+" - headerTitleStickiedHeight: "+this.iHeaderTitleHeightStickied+" - headerContentHeight: "+this.iHeaderContentHeight);}else{q.sap.log.debug("ObjectPageLayout :: adjustHeaderHeight","skipped as the objectPageLayout is being rendered");}};
e.prototype._getHeaderDesign=function(){var h=this.getHeaderTitle(),s=l.ObjectPageHeaderDesign.Light;if(h!=null){s=h.getHeaderDesign();}return s;};
e.prototype._getVisibleSections=function(){return this.getSections().filter(function(s){return s.getVisible()&&s._getInternalVisible();});};
e.prototype._setSectionsFocusValues=function(s){var g=this._getVisibleSections()||[],$,F='0',n='-1',t="tabIndex",o,h=g[0];g.forEach(function(i){$=i.$();if(s===i.sId){$.attr(t,F);o=i;i._setSubSectionsFocusValues();}else{$.attr(t,n);i._disableSubSectionsFocus();}});if(!o&&g.length>0){h.$().attr(t,F);h._setSubSectionsFocusValues();o=h;}return o;};
e.prototype.setShowHeaderContent=function(s){var o=this.getShowHeaderContent();if(o!==s){if(o&&this._bIsHeaderExpanded){this._expandCollapseHeader(false);}this.setProperty("showHeaderContent",s);this._getHeaderContent().setProperty("visible",s);}return this;};
e.prototype._headerTitleChangeHandler=function(){if(!this.getShowTitleInHeaderContent()||this._bFirstRendering){return;}var r=sap.ui.getCore().createRenderManager();this.getRenderer()._rerenderHeaderContentArea(r,this);this._getHeaderContent().invalidate();r.destroy();};
e.prototype.getHeaderContent=function(){return this._getHeaderContent().getAggregation("content");};
e.prototype.insertHeaderContent=function(o,i,s){return this._getHeaderContent().insertAggregation("content",o,i,s);};
e.prototype.addHeaderContent=function(o,s){return this._getHeaderContent().addAggregation("content",o,s);};
e.prototype.removeAllHeaderContent=function(s){return this._getHeaderContent().removeAllAggregation("content",s);};
e.prototype.removeHeaderContent=function(o,s){return this._getHeaderContent().removeAggregation("content",o,s);};
e.prototype.destroyHeaderContent=function(s){return this._getHeaderContent().destroyAggregation("content",s);};
e.prototype.indexOfHeaderContent=function(o){return this._getHeaderContent().indexOfAggregation("content",o);};
e.prototype._getHeaderContent=function(){if(!this.getAggregation("_headerContent")){this.setAggregation("_headerContent",new l.ObjectPageHeaderContent({visible:this.getShowHeaderContent(),contentDesign:this._getHeaderDesign(),content:this.getAggregation("headerContent",[])}),true);}return this.getAggregation("_headerContent");};
e.prototype._checkAlwaysShowContentHeader=function(){return!this._bMobileScenario&&!this._bTabletScenario&&this.getShowHeaderContent()&&this.getAlwaysShowContentHeader();};
e.prototype._connectModelsForSections=function(s){s=s||[];s.forEach(function(o){o.connectToModels();});};
e.prototype._getHeightRelatedParameters=function(){return{iHeaderContentHeight:this.iHeaderContentHeight,iScreenHeight:this.iScreenHeight,iAnchorBarHeight:this.iAnchorBarHeight,iHeaderTitleHeightStickied:this.iHeaderTitleHeightStickied,iStickyHeaderContentHeight:this.iStickyHeaderContentHeight,iScrollTop:this._$opWrapper.scrollTop()};};
e.prototype._hasVerticalScrollBar=function(){return(this._getCustomScrollBar().getVisible()===true);};
e.prototype._shiftHeader=function(s,p){this.$().find(".sapUxAPObjectPageHeaderTitle").css("padding-"+s,p);};
e.prototype._isFirstSection=function(s){var g=this._getVisibleSections();if(s===g[0]){return true;}return false;};
e.prototype._restoreScrollPosition=function(){this._scrollTo(this._iStoredScrollPosition,0);};
e.prototype._storeScrollLocation=function(){this._iStoredScrollPosition=this._oScroller.getScrollTop();this._oStoredSection=this._oCurrentTabSubSection||this._oCurrentTabSection;if(this._oStoredSection){var s=this._aSectionBases.map(function(o){return o.getId();});if(s.indexOf(this._oStoredSection.getId())===-1){this._oStoredSection=null;}}this._oCurrentTabSection=null;};
e.prototype.onkeyup=function(E){var F,o,g,h;if(E.which===q.sap.KeyCodes.TAB){F=sap.ui.getCore().getCurrentFocusedControlId();o=F&&sap.ui.getCore().byId(F);if(o&&o.$().length){g=o.$().position().top;h=this.iHeaderTitleHeight+this.iHeaderContentHeight+this.iAnchorBarHeight;if(this._isFirstSection(o)){this._scrollTo(0,0);}else if(g>h){this._scrollTo(g-this.iHeaderTitleHeight-this.iAnchorBarHeight,0);}}}};
e.prototype.setShowFooter=function(s){var r=this.setProperty("showFooter",s,true);this._toggleFooter(s);return r;};
e.prototype._toggleFooter=function(s){var u=sap.ui.getCore().getConfiguration().getAnimation(),F=this.getFooter();if(!f(F)){return;}F.toggleStyleClass("sapUxAPObjectPageFloatingFooterShow",s);F.toggleStyleClass("sapUxAPObjectPageFloatingFooterHide",!s);if(this._iFooterWrapperHideTimeout){q.sap.clearDelayedCall(this._iFooterWrapperHideTimeout);}if(u){if(!s){this._iFooterWrapperHideTimeout=q.sap.delayedCall(e.FOOTER_ANIMATION_DURATION,this,function(){this.$("footerWrapper").toggleClass("sapUiHidden",!s);});}else{this.$("footerWrapper").toggleClass("sapUiHidden",!s);this._iFooterWrapperHideTimeout=null;}q.sap.delayedCall(e.FOOTER_ANIMATION_DURATION,this,function(){F.removeStyleClass("sapUxAPObjectPageFloatingFooterShow");});}};
e.prototype.clone=function(){Object.keys(this.mAggregations).forEach(this._cloneProxiedAggregations,this);return C.prototype.clone.apply(this,arguments);};
e.prototype._cloneProxiedAggregations=function(s){var o=this.mAggregations[s];if(Array.isArray(o)&&o.length===0){o=this["get"+s.charAt(0).toUpperCase()+s.slice(1)]();}this.mAggregations[s]=o;};
function f(o){if(arguments.length===1){return Array.isArray(o)?o.length>0:!!o;}return Array.prototype.slice.call(arguments).every(function(g){return f(g);});}
return e;});
sap.ui.predefine('sap/uxap/ObjectPageLayoutABHelper',["jquery.sap.global","sap/ui/base/Metadata","sap/ui/core/CustomData","./AnchorBar","sap/m/Button","sap/ui/core/IconPool"],function(q,M,C,A,B,I){"use strict";var a=M.createClass("sap.uxap._helpers.AB",{constructor:function(o){this._oObjectPageLayout=o;this._iScrollDuration=o._iScrollToSectionDuration;}});
a.prototype.getObjectPageLayout=function(){return this._oObjectPageLayout;};
a.prototype._getAnchorBar=function(){var o=this.getObjectPageLayout().getAggregation("_anchorBar");if(!o){o=new A({id:this.getObjectPageLayout().getId()+"-anchBar",showPopover:this.getObjectPageLayout().getShowAnchorBarPopover()});this.getObjectPageLayout().setAggregation("_anchorBar",o);}return o;};
a.prototype._buildAnchorBar=function(){var s=this.getObjectPageLayout().getSections()||[],o=this._getAnchorBar();if(o&&this.getObjectPageLayout().getShowAnchorBar()){o._resetControl();s.forEach(function(S){if(!S.getVisible()||!S._getInternalVisible()){return;}var b,c=S.getSubSections()||[];b=this._buildAnchorBarButton(S,true);if(b){o.addContent(b);c.forEach(function(d){if(!d.getVisible()||!d._getInternalVisible()){return;}var e=this._buildAnchorBarButton(d,false);if(e){o.addContent(e);}},this);}},this);}};
a.prototype._focusOnSectionWhenUsingKeyboard=function(e){var s=e.srcControl.data(),S=sap.ui.getCore().byId(s.sectionId),o=this.getObjectPageLayout();if(S&&!s.bHasSubMenu&&!o.getUseIconTabBar()){q.sap.delayedCall(this._iScrollDuration,S.$(),"focus");}};
a.prototype._buildAnchorBarButton=function(s,i){var b=null,o=this.getObjectPageLayout(),c,d=this._getAnchorBar(),e,S=s.getAggregation("subSections"),f=this._focusOnSectionWhenUsingKeyboard.bind(this),E={onsapenter:f,onsapspace:f};if(s.getVisible()&&s._getInternalVisible()){c=s.getCustomAnchorBarButton();if(!c){e=d.getId()+"-"+s.getId()+"-anchor";b=new B({ariaDescribedBy:s,id:e});b.addEventDelegate(E);var t=(s._getInternalTitle()!="")?s._getInternalTitle():s.getTitle();b.setText(t);}else{b=c.clone();}o._oSectionInfo[s.getId()].buttonId=b.getId();b.addCustomData(new C({key:"sectionId",value:s.getId()}));b.addCustomData(new C({key:"bTitleVisible",value:s._getInternalTitleVisible()}));if(!i){b.addCustomData(new C({key:"secondLevel",value:true}));}if(S&&S.length>1){var v=S.filter(function(g){return g.getVisible();}).length;if(v>1){b.addCustomData(new C({key:"bHasSubMenu",value:true}));if(o.getShowAnchorBarPopover()){b.setIcon(I.getIconURI("slim-arrow-down"));b.setIconFirst(false);}}}}return b;};
return a;},false);
sap.ui.predefine('sap/uxap/ObjectPageLayoutRenderer',["sap/ui/core/Renderer","./ObjectPageHeaderRenderer"],function(R,O){"use strict";var a={};
a.render=function(r,c){var s,h=c.getHeaderTitle(),A=null,i=c.getHeaderContent()&&c.getHeaderContent().length>0&&c.getShowHeaderContent(),I=c.getShowTitleInHeaderContent()&&c.getShowHeaderContent(),b=i||I;if(c.getShowAnchorBar()&&c._getInternalAnchorBarVisible()){A=c.getAggregation("_anchorBar");}r.write("<div");r.writeControlData(c);if(h){r.writeAttributeEscaped("aria-label",h.getObjectTitle());}r.addClass("sapUxAPObjectPageLayout");r.writeClasses();r.addStyle("height",c.getHeight());r.writeStyles();r.write(">");if(sap.ui.Device.system.desktop){r.renderControl(c._getCustomScrollBar().addStyleClass("sapUxAPObjectPageCustomScroller"));}r.write("<header ");r.writeAttribute("role","header");r.writeAttributeEscaped("id",c.getId()+"-headerTitle");r.addClass("sapUxAPObjectPageHeaderTitle");r.addClass("sapContrastPlus");r.writeClasses();r.write(">");if(h){r.renderControl(h);}this._renderHeaderContentDOM(r,c,b&&c._bHContentAlwaysExpanded,"-stickyHeaderContent");r.write("<div ");r.writeAttributeEscaped("id",c.getId()+"-stickyAnchorBar");r.addClass("sapUxAPObjectPageStickyAnchorBar");r.addClass("sapUxAPObjectPageNavigation");r.writeClasses();r.write(">");this._renderAnchorBar(r,c,A,c._bHContentAlwaysExpanded);r.write("</div>");r.write("</header>");r.write("<div ");r.writeAttributeEscaped("id",c.getId()+"-opwrapper");r.addClass("sapUxAPObjectPageWrapper");if(!(c.getShowTitleInHeaderContent()&&h.getShowTitleSelector())){r.addClass("sapUxAPObjectPageWrapperTransform");}r.writeClasses();r.write(">");r.write("<div ");r.writeAttributeEscaped("id",c.getId()+"-scroll");r.addClass("sapUxAPObjectPageScroll");r.writeClasses();r.write(">");this._renderHeaderContentDOM(r,c,b&&!c._bHContentAlwaysExpanded,"-headerContent",true);r.write("<section ");r.writeAttributeEscaped("id",c.getId()+"-anchorBar");r.writeAttribute("role","navigation");r.addClass("sapUxAPObjectPageNavigation");r.addClass("sapContrastPlus");r.writeClasses();r.write(">");this._renderAnchorBar(r,c,A,!c._bHContentAlwaysExpanded);r.write("</section>");r.write("<section");r.addClass("sapUxAPObjectPageContainer");r.writeAttributeEscaped("id",c.getId()+"-sectionsContainer");r.addClass("ui-helper-clearfix");if(!A){r.addClass("sapUxAPObjectPageContainerNoBar");}r.writeClasses();r.write(">");s=c.getAggregation("sections");if(jQuery.isArray(s)){jQuery.each(s,function(d,S){r.renderControl(S);});}r.write("</section>");this.renderFooterContent(r,c);r.write("<div");r.writeAttributeEscaped("id",c.getId()+"-spacer");r.write("></div>");r.write("</div>");r.write("</div>");this._renderFooterContentInternal(r,c);r.write("</div>");};
a._renderAnchorBar=function(r,c,A,b){var s=c.getAggregation("sections");if(b){if(c.getIsChildPage()){r.write("<div ");r.writeAttributeEscaped("id",c.getId()+"-childPageBar");if(jQuery.isArray(s)&&s.length>1){r.addClass('sapUxAPObjectChildPage');}r.writeClasses();r.write("></div>");}if(A){r.renderControl(A);}}};
a._renderHeaderContentDOM=function(r,c,b,i,A){r.write("<header ");r.writeAttributeEscaped("id",c.getId()+i);r.addClass("ui-helper-clearfix");r.addClass("sapUxAPObjectPageHeaderDetails");r.addClass("sapUxAPObjectPageHeaderDetailsDesign-"+c._getHeaderDesign());if(A){r.addClass("sapContrastPlus");}r.writeClasses();r.writeAttribute("data-sap-ui-customfastnavgroup",true);r.write(">");if(b){this.renderHeaderContent(r,c);}r.write("</header>");};
a.renderHeaderContent=function(r,c){r.renderControl(c._getHeaderContent());};
a.renderFooterContent=function(r,c){};
a._renderFooterContentInternal=function(r,o){var f=o.getFooter();if(!f){return;}r.write("<footer");r.writeAttributeEscaped("id",o.getId()+"-footerWrapper");r.addClass("sapUxAPObjectPageFooter sapMFooter-CTX sapContrast sapContrastPlus");if(!o.getShowFooter()){r.addClass("sapUiHidden");}r.writeClasses();r.write(">");f.addStyleClass("sapUxAPObjectPageFloatingFooter");r.renderControl(f);r.write("</footer>");};
a._rerenderHeaderContentArea=function(r,c){var h=c._bHContentAlwaysExpanded?"stickyHeaderContent":"headerContent";this.renderHeaderContent(r,c);r.flush(c.$(h)[0]);};
return a;},true);
sap.ui.predefine('sap/uxap/ObjectPageLazyLoader',['./library','sap/ui/core/Element','sap/ui/core/StashedControlSupport'],function(l,E,S){"use strict";
var L=E.extend("sap.uxap.ObjectPageLazyLoader",{metadata:{library:"sap.uxap",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},defaultAggregation:"content"}});
S.mixInto(L);
L.prototype.setParent=function(p){if(!(p===null||p instanceof sap.uxap.ObjectPageSubSection)){}return E.prototype.setParent.apply(this,arguments);};
return L;},true);
sap.ui.predefine('sap/uxap/ObjectPageSection.designtime',[],function(){"use strict";return{actions:{remove:{changeType:"stashControl",getState:function(o){return{control:o,visible:o.getVisible()};},restoreState:function(o,s){s.control.setVisible(s.visible);}}}};},false);
sap.ui.predefine('sap/uxap/ObjectPageSection',["jquery.sap.global","sap/ui/core/InvisibleText","./ObjectPageSectionBase","sap/ui/Device","sap/m/Button","sap/ui/core/StashedControlSupport","./ObjectPageSubSection","./library"],function(q,I,O,D,B,S,a,l){"use strict";
var b=O.extend("sap.uxap.ObjectPageSection",{metadata:{library:"sap.uxap",properties:{showTitle:{type:"boolean",group:"Appearance",defaultValue:true},titleUppercase:{type:"boolean",group:"Appearance",defaultValue:true}},defaultAggregation:"subSections",aggregations:{subSections:{type:"sap.uxap.ObjectPageSubSection",multiple:true,singularName:"subSection"},ariaLabelledBy:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"},_showHideAllButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_showHideButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},associations:{selectedSubSection:{type:"sap.uxap.ObjectPageSubSection",multiple:false}},designTime:true}});
b.MEDIA_RANGE=D.media.RANGESETS.SAP_STANDARD;
b._getClosestSection=function(s){return(s instanceof a)?s.getParent():s;};
b.prototype._expandSection=function(){O.prototype._expandSection.call(this)._updateShowHideAllButton(!this._thereAreHiddenSubSections());};
b.prototype.init=function(){O.prototype.init.call(this);this._sContainerSelector=".sapUxAPObjectPageSectionContainer";D.media.attachHandler(this._updateImportance,this,b.MEDIA_RANGE);};
b.prototype.exit=function(){D.media.detachHandler(this._updateImportance,this,b.MEDIA_RANGE);};
b.prototype._getImportanceLevelToHide=function(c){var o=this._getObjectPageLayout(),m=c||D.media.getCurrentRange(b.MEDIA_RANGE),s=o&&o.getShowOnlyHighImportance();return this._determineTheLowestLevelOfImportanceToShow(m.name,s);};
b.prototype._updateImportance=function(c){var o=this._getObjectPageLayout(),i=this._getImportanceLevelToHide(c);this.getSubSections().forEach(function(s){s._applyImportanceRules(i);});this._applyImportanceRules(i);this._updateShowHideAllButton(false);if(o&&this.getDomRef()){o._requestAdjustLayout();}};
b.prototype._determineTheLowestLevelOfImportanceToShow=function(m,s){if(s||m==="Phone"){return l.Importance.High;}if(m==="Tablet"){return l.Importance.Medium;}return l.Importance.Low;};
b.prototype.connectToModels=function(){this.getSubSections().forEach(function(s){s.connectToModels();});};
b.prototype._allowPropagationToLoadedViews=function(A){this.getSubSections().forEach(function(s){s._allowPropagationToLoadedViews(A);});};
b.prototype.onBeforeRendering=function(){var A="ariaLabelledBy";if(!this.getAggregation(A)){this.setAggregation(A,this._getAriaLabelledBy());}this._updateImportance();};
b.prototype._getAriaLabelledBy=function(){return new I({text:this._getInternalTitle()||this.getTitle()}).toStatic();};
b.prototype._setSubSectionsFocusValues=function(){var s=this.getSubSections()||[],L=this.getSelectedSubSection(),p;if(s.length===0){return this;}if(s.length===1){s[0]._setToFocusable(false);return this;}s.forEach(function(o){if(L===o.sId){o._setToFocusable(true);p=true;}else{o._setToFocusable(false);}});if(!p){s[0]._setToFocusable(true);}return this;};
b.prototype._disableSubSectionsFocus=function(){var s=this.getSubSections()||[];s.forEach(function(o){o._setToFocusable(false);});return this;};
b.prototype._thereAreHiddenSubSections=function(){return this.getSubSections().some(function(s){return s._getIsHidden();});};
b.prototype._updateShowHideSubSections=function(h){this.getSubSections().forEach(function(s){if(h&&s._shouldBeHidden()){s._updateShowHideState(true);}else if(!h){s._updateShowHideState(false);}});};
b.prototype._getShouldDisplayShowHideAllButton=function(){return this.getSubSections().some(function(s){return s._shouldBeHidden();});};
b.prototype._showHideContentAllContent=function(){var s=this._thereAreHiddenSubSections();if(this._getIsHidden()&&s){this._updateShowHideState(false);}this._updateShowHideSubSections(!s);this._updateShowHideAllButton(s);};
b.prototype._updateShowHideState=function(h){this._updateShowHideButton(h);this._getShowHideAllButton().setVisible(this._getShouldDisplayShowHideAllButton());return O.prototype._updateShowHideState.call(this,h);};
b.prototype._updateShowHideAllButton=function(h){this._getShowHideAllButton().setVisible(this._getShouldDisplayShowHideAllButton()).setText(this._getShowHideAllButtonText(h));};
b.prototype._getShowHideAllButton=function(){if(!this.getAggregation("_showHideAllButton")){this.setAggregation("_showHideAllButton",new B({visible:this._getShouldDisplayShowHideAllButton(),text:this._getShowHideAllButtonText(!this._thereAreHiddenSubSections()),press:this._showHideContentAllContent.bind(this),type:sap.m.ButtonType.Transparent}).addStyleClass("sapUxAPSectionShowHideButton"));}return this.getAggregation("_showHideAllButton");};
b.prototype._getShowHideButtonText=function(h){return l.i18nModel.getResourceBundle().getText(h?"HIDE":"SHOW");};
b.prototype._getShowHideAllButtonText=function(h){return l.i18nModel.getResourceBundle().getText(h?"HIDE_ALL":"SHOW_ALL");};
b.prototype._updateShowHideButton=function(h){this._getShowHideButton().setVisible(this._shouldBeHidden()).setText(this._getShowHideButtonText(!h));};
b.prototype._getShowHideButton=function(){if(!this.getAggregation("_showHideButton")){this.setAggregation("_showHideButton",new B({visible:this._shouldBeHidden(),text:this._getShowHideButtonText(!this._getIsHidden()),press:this._showHideContent.bind(this),type:sap.m.ButtonType.Transparent}).addStyleClass("sapUxAPSectionShowHideButton"));}return this.getAggregation("_showHideButton");};
S.mixInto(b);return b;});
sap.ui.predefine('sap/uxap/ObjectPageSectionBase',["jquery.sap.global","sap/ui/core/Control","./library"],function(q,C,l){"use strict";
var O=C.extend("sap.uxap.ObjectPageSectionBase",{metadata:{"abstract":true,library:"sap.uxap",properties:{title:{type:"string",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true},importance:{type:"sap.uxap.Importance",group:"Behavior",defaultValue:l.Importance.High}},aggregations:{customAnchorBarButton:{type:"sap.m.Button",multiple:false}}}});
O.prototype.init=function(){this._bInternalVisible=true;this._bInternalTitleVisible=true;this._sInternalTitle="";this._isHidden=false;this._oParentObjectPageLayout=undefined;this._bRtl=sap.ui.getCore().getConfiguration().getRTL();};
O.prototype.onAfterRendering=function(){if(this._getObjectPageLayout()){this._getObjectPageLayout()._requestAdjustLayout().catch(function(){q.sap.log.debug("ObjectPageSectionBase :: cannot adjustLayout",this);});this._getObjectPageLayout()._setSectionsFocusValues();}};
O.prototype.setCustomAnchorBarButton=function(b){var r=this.setAggregation("customAnchorBarButton",b,true);if(this._getObjectPageLayout()){this._getObjectPageLayout()._updateNavigation();}return r;};
O.prototype._setInternalVisible=function(v,i){if(v!=this._bInternalVisible){this._bInternalVisible=v;if(i){this.invalidate();}}};
O.prototype._getInternalVisible=function(){return this._bInternalVisible;};
O.prototype._setInternalTitleVisible=function(v,i){if(v!=this._bInternalTitleVisible){this._bInternalTitleVisible=v;if(i){this.invalidate();}}};
O.prototype._getInternalTitleVisible=function(){return this._bInternalTitleVisible;};
O.prototype._setInternalTitle=function(v,i){if(v!=this._sInternalTitle){this._sInternalTitle=v;if(i){this.invalidate();}}};
O.prototype._getInternalTitle=function(){return this._sInternalTitle;};
O.prototype._getObjectPageLayout=function(){if(!this._oParentObjectPageLayout){this._oParentObjectPageLayout=l.Utilities.getClosestOPL(this);}return this._oParentObjectPageLayout;};
O.prototype._notifyObjectPageLayout=function(){if(this._getObjectPageLayout()&&this._getObjectPageLayout().$().length){this._getObjectPageLayout()._adjustLayoutAndUxRules();}};
["addAggregation","insertAggregation","removeAllAggregation","removeAggregation","destroyAggregation"].forEach(function(m){O.prototype[m]=function(a,o,i,s){if(["addAggregation","removeAggregation"].indexOf(m)>-1){s=i;}if(["removeAllAggregation","destroyAggregation"].indexOf(m)>-1){s=o;}var r=C.prototype[m].apply(this,arguments);if(s!==true){this._notifyObjectPageLayout();}return r;};});
O.prototype.setVisible=function(v,s){if(!this._getObjectPageLayout()){return this.setProperty("visible",v,s);}this.setProperty("visible",v,true);this._getObjectPageLayout()._adjustLayoutAndUxRules();this.invalidate();return this;};
O.prototype.setTitle=function(v,s){this.setProperty("title",v,s);this._notifyObjectPageLayout();return this;};
O.prototype._shouldBeHidden=function(){return O._importanceMap[this.getImportance()]>O._importanceMap[this._sCurrentLowestImportanceLevelToShow];};
O._importanceMap={"Low":3,"Medium":2,"High":1};
O.prototype._updateShowHideState=function(h){var o=this._getObjectPageLayout();this._isHidden=h;this.$().children(this._sContainerSelector).toggle(!h);if(o){o._requestAdjustLayout();}return this;};
O.prototype._getIsHidden=function(){return this._isHidden;};
O.prototype._expandSection=function(){return this._updateShowHideState(false);};
O.prototype._showHideContent=function(){return this._updateShowHideState(!this._getIsHidden());};
O.prototype._applyImportanceRules=function(c){this._sCurrentLowestImportanceLevelToShow=c;if(this.getDomRef()){this._updateShowHideState(this._shouldBeHidden());}else{this._isHidden=this._shouldBeHidden();}};
O.PAGEUP_AND_PAGEDOWN_JUMP_SIZE=5;
O.prototype.onkeydown=function(e){if(e.keyCode===q.sap.KeyCodes.F7){var s=this.getSubSections(),f=s[0],L;if(s.length===1){L=f._oLastFocusedControlF7;if(L){L.$().focus();}else{f.$().firstFocusableDomRef().focus();}}else{if(f.getActions().length){f.getActions()[0].$().focus();}}}};
O.prototype.onsapdown=function(e){this._handleFocusing(e,e.currentTarget.nextSibling);};
O.prototype._handleFocusing=function(e,E){if(this._targetIsCorrect(e)&&E){e.preventDefault();E.focus();this._scrollParent(q(E).attr("id"));}};
O.prototype._targetIsCorrect=function(e){return e.srcControl===this;};
O.prototype.onsapright=function(e){var m=this._bRtl?"onsapup":"onsapdown";this[m](e);};
O.prototype.onsapup=function(e){this._handleFocusing(e,e.currentTarget.previousSibling);};
O.prototype.onsapleft=function(e){var m=this._bRtl?"onsapdown":"onsapup";this[m](e);};
O.prototype.onsaphome=function(e){this._handleFocusing(e,e.currentTarget.parentElement.firstChild);};
O.prototype.onsapend=function(e){this._handleFocusing(e,e.currentTarget.parentElement.lastChild);};
O.prototype.onsappageup=function(e){if(!this._targetIsCorrect(e)){return;}e.preventDefault();var n;var s=q(e.currentTarget).parent().children();var f;s.each(function(S,o){if(q(o).attr("id")===e.currentTarget.id){n=S-(O.PAGEUP_AND_PAGEDOWN_JUMP_SIZE+1);return;}});if(n&&s[n]){s[n].focus();f=q(s[n]).attr("id");}else if(s[0]){s[0].focus();f=q(s[0]).attr("id");}this._scrollParent(f);};
O.prototype.onsappagedown=function(e){if(!this._targetIsCorrect(e)){return;}e.preventDefault();var n;var s=q(e.currentTarget).parent().children();var f;s.each(function(S,o){if(q(o).attr("id")===e.currentTarget.id){n=S+O.PAGEUP_AND_PAGEDOWN_JUMP_SIZE+1;return;}});if(n&&s[n]){s[n].focus();f=q(s[n]).attr("id");}else if(s[s.length-1]){s[s.length-1].focus();f=q(s[s.length-1]).attr("id");}this._scrollParent(f);};
O.prototype._scrollParent=function(i){if(this._getObjectPageLayout()){this._getObjectPageLayout().scrollToSection(i,0,10);}};
return O;});
sap.ui.predefine('sap/uxap/ObjectPageSectionRenderer',function(){"use strict";var O={};
O.render=function(r,c){if(!c.getVisible()||!c._getInternalVisible()){return;}var t=c._getInternalTitle()?c._getInternalTitle():c.getTitle();r.write("<section ");r.addClass("sapUxAPObjectPageSection");r.writeClasses();r.writeAttribute("role","region");r.writeAttributeEscaped("aria-labelledby",c.getAggregation("ariaLabelledBy").getId());r.writeControlData(c);r.write(">");if(c.getShowTitle()&&c._getInternalTitleVisible()){r.write("<div");r.writeAttribute("role","heading");r.writeAttribute("aria-level","3");r.writeAttributeEscaped("id",c.getId()+"-header");r.addClass("sapUxAPObjectPageSectionHeader");r.writeClasses();r.write(">");r.write("<div");r.writeAttributeEscaped("id",c.getId()+"-title");r.addClass("sapUxAPObjectPageSectionTitle");if(c.getTitleUppercase()){r.addClass("sapUxAPObjectPageSectionTitleUppercase");}r.writeClasses();r.write(">");r.writeEscaped(t);r.write("</div>");r.renderControl(c._getShowHideAllButton());r.renderControl(c._getShowHideButton());r.write("</div>");}r.write("<div");r.addClass("sapUxAPObjectPageSectionContainer");r.writeClasses();if(c._isHidden){r.addStyle("display","none");}r.writeStyles();r.write(">");c.getSubSections().forEach(r.renderControl);r.write("</div>");r.write("</section>");};
return O;},true);
sap.ui.predefine('sap/uxap/ObjectPageSubSection',["sap/ui/core/CustomData","sap/ui/layout/Grid","./ObjectPageSectionBase","./ObjectPageSubSectionLayout","./ObjectPageSubSectionMode","./BlockBase","sap/ui/layout/GridData","sap/m/Button","sap/ui/Device","./ObjectPageLazyLoader","sap/ui/core/StashedControlSupport","./library"],function(C,G,O,a,b,B,c,d,D,e,S,l){"use strict";
var f=O.extend("sap.uxap.ObjectPageSubSection",{metadata:{library:"sap.uxap",properties:{mode:{type:"sap.uxap.ObjectPageSubSectionMode",group:"Appearance",defaultValue:b.Collapsed},titleUppercase:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"blocks",aggregations:{_grid:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},blocks:{type:"sap.ui.core.Control",multiple:true,singularName:"block"},moreBlocks:{type:"sap.ui.core.Control",multiple:true,singularName:"moreBlock"},actions:{type:"sap.ui.core.Control",multiple:true,singularName:"action"}}}});
f.MEDIA_RANGE=D.media.RANGESETS.SAP_STANDARD;
f.prototype.init=function(){O.prototype.init.call(this);this._bRenderedFirstTime=false;this._aAggregationProxy={blocks:[],moreBlocks:[]};this._$spacer=[];this._sContainerSelector=".sapUxAPBlockContainer";this._switchSubSectionMode(this.getMode());};
f.prototype._expandSection=function(){O.prototype._expandSection.call(this);var p=this.getParent();p&&typeof p._expandSection==="function"&&p._expandSection();return this;};
f.prototype._getGrid=function(){if(!this.getAggregation("_grid")){this.setAggregation("_grid",new G({id:this.getId()+"-innerGrid",defaultSpan:"XL12 L12 M12 S12",hSpacing:1,vSpacing:1,width:"100%",containerQuery:true}));}return this.getAggregation("_grid");};
f.prototype._unStashControls=function(){S.getStashedControls(this.getId()).forEach(function(o){o.setStashed(false);});};
f.prototype.connectToModels=function(){var g=this.getBlocks()||[],m=this.getMoreBlocks()||[],s=this.getMode();this._unStashControls();g.forEach(function(o){if(o instanceof B){if(!o.getMode()){o.setMode(s);}o.connectToModels();}});if(m.length>0&&s===b.Expanded){m.forEach(function(M){if(M instanceof B){if(!M.getMode()){M.setMode(s);}M.connectToModels();}});}};
f.prototype._allowPropagationToLoadedViews=function(A){var g=this.getBlocks()||[],m=this.getMoreBlocks()||[];g.forEach(function(o){if(o instanceof B){o._allowPropagationToLoadedViews(A);}});m.forEach(function(M){if(M instanceof B){M._allowPropagationToLoadedViews(A);}});};
sap.uxap.ObjectPageSubSection.prototype.clone=function(){Object.keys(this._aAggregationProxy).forEach(function(A){var o=this.mAggregations[A];if(!o||o.length===0){this.mAggregations[A]=this._aAggregationProxy[A];}},this);return sap.ui.core.Control.prototype.clone.apply(this,arguments);};
f.prototype._cleanProxiedAggregations=function(){var p=this._aAggregationProxy;Object.keys(p).forEach(function(k){p[k].forEach(function(o){o.destroy();});});};
f.prototype.exit=function(){if(this._oSeeMoreButton){this._oSeeMoreButton.destroy();this._oSeeMoreButton=null;}D.media.detachHandler(this._updateImportance,this,f.MEDIA_RANGE);D.media.detachHandler(this._titleOnLeftSynchronizeLayouts,this,f.MEDIA_RANGE);this._cleanProxiedAggregations();if(O.prototype.exit){O.prototype.exit.call(this);}};
f.prototype.onAfterRendering=function(){var o=this._getObjectPageLayout();if(O.prototype.onAfterRendering){O.prototype.onAfterRendering.call(this);}if(!o){return;}if(this._getUseTitleOnTheLeft()){D.media.attachHandler(this._titleOnLeftSynchronizeLayouts,this,f.MEDIA_RANGE);}else{D.media.detachHandler(this._titleOnLeftSynchronizeLayouts,this,f.MEDIA_RANGE);}this._$spacer=jQuery.sap.byId(o.getId()+"-spacer");};
f.prototype.onBeforeRendering=function(){if(O.prototype.onBeforeRendering){O.prototype.onBeforeRendering.call(this);}this._setAggregationProxy();this._getGrid().removeAllContent();this._applyLayout(this._getObjectPageLayout());this.refreshSeeMoreVisibility();};
f.prototype._applyLayout=function(L){var v,g=this._getGrid(),s=this.getMode(),h=L.getSubSectionLayout(),o=this._calculateLayoutConfiguration(h,L),i=this.getBlocks(),A=i.concat(this.getMoreBlocks());this._oLayoutConfig=o;this._resetLayoutData(A);if(s===b.Expanded){v=A;}else{v=i;}this._calcBlockColumnLayout(v,this._oLayoutConfig);try{v.forEach(function(j){this._setBlockMode(j,s);g.addContent(j);},this);}catch(E){jQuery.sap.log.error("ObjectPageSubSection :: error while building layout "+h+": "+E);}return this;};
f.prototype._calculateLayoutConfiguration=function(L,o){var g={M:2,L:3,XL:4},i=g.L,E=g.XL,t=(L===a.TitleOnLeft),u=o.getUseTwoColumnsForLargeScreen();if(t){i-=1;E-=1;}if(u){i-=1;}g.L=i;g.XL=E;return g;};
f.prototype.refreshSeeMoreVisibility=function(){var g=!!this.getMoreBlocks().length,s=this._getSeeMoreButton(),$=s.$(),h=this.$();if(!g){g=this.getBlocks().some(function(o){if(o instanceof B&&o.getVisible()&&o.getShowSubSectionMore()){return true;}});}if(h.length){h.toggleClass("sapUxAPObjectPageSubSectionWithSeeMore",g);}this.toggleStyleClass("sapUxAPObjectPageSubSectionWithSeeMore",g);if($.length){$.toggleClass("sapUxAPSubSectionSeeMoreButtonVisible",g);}s.toggleStyleClass("sapUxAPSubSectionSeeMoreButtonVisible",g);return g;};
f.prototype.setMode=function(m){if(this.getMode()!==m){this._switchSubSectionMode(m);if(this._bRenderedFirstTime){this.rerender();}}return this;};
f.prototype.onkeydown=function(E){if(E.keyCode===jQuery.sap.KeyCodes.F7){E.stopPropagation();var t=sap.ui.getCore().byId(E.target.id);if(t instanceof f){this._handleSubSectionF7();}else{this._handleInteractiveElF7();this._oLastFocusedControlF7=t;}}};
f.prototype._handleInteractiveElF7=function(){if(this.getParent().getSubSections().length>1){this.$().focus();}else{this.getParent().$().focus();}};
f.prototype._handleSubSectionF7=function(E){if(this._oLastFocusedControlF7){this._oLastFocusedControlF7.$().focus();}else{this.$().firstFocusableDomRef().focus();}};
f.prototype._calcBlockColumnLayout=function(g,o){var i=12,v,M,L,X,h;M={iRemaining:o.M,iColumnConfig:o.M};L={iRemaining:o.L,iColumnConfig:o.L};X={iRemaining:o.XL,iColumnConfig:o.XL};h=[X,L,M];v=g.filter(function(j){return j.getVisible&&j.getVisible();});v.forEach(function(j,I){h.forEach(function(k){k.iCalculatedSize=this._calculateBlockSize(j,k.iRemaining,v,I,k.iColumnConfig);},this);j.setLayoutData(new c(j.getId()+"-layoutData",{spanS:i,spanM:M.iCalculatedSize*(i/M.iColumnConfig),spanL:L.iCalculatedSize*(i/L.iColumnConfig),spanXL:X.iCalculatedSize*(i/X.iColumnConfig),linebreakM:(I>0&&M.iRemaining===M.iColumnConfig),linebreakL:(I>0&&L.iRemaining===L.iColumnConfig),linebreakXL:(I>0&&X.iRemaining===X.iColumnConfig)}));h.forEach(function(k){k.iRemaining-=k.iCalculatedSize;if(k.iRemaining<1){k.iRemaining=k.iColumnConfig;}});},this);return v;};
f.prototype._calculateBlockSize=function(o,r,v,i,m){var g,F=m,h;if(!this._hasAutoLayout(o)){return Math.min(m,parseInt(o.getColumnLayout(),10));}for(h=1;h<=F;h++){g=this._calcLayout(v[i+h]);if(g<r){r-=g;}else{break;}}return r;};
f.prototype._calcLayout=function(o){var L=1;if(!o){L=0;}else if(o instanceof B&&o.getColumnLayout()!="auto"){L=parseInt(o.getColumnLayout(),10);}return L;};
f.prototype._hasAutoLayout=function(o){return!(o instanceof B)||o.getColumnLayout()=="auto";};
f.prototype._onDesktopMediaRange=function(o){var m=o||D.media.getCurrentRange(f.MEDIA_RANGE);return["LargeDesktop","Desktop"].indexOf(m.name)>-1;};
f.prototype._titleOnLeftSynchronizeLayouts=function(o){this.$("header").toggleClass("titleOnLeftLayout",this._onDesktopMediaRange(o));};
f.prototype._setAggregationProxy=function(){if(this._bRenderedFirstTime){return;}jQuery.each(this._aAggregationProxy,jQuery.proxy(function(A,v){this._setAggregation(A,this.removeAllAggregation(A,true),true);},this));this._bRenderedFirstTime=true;};
f.prototype.hasProxy=function(A){return this._bRenderedFirstTime&&this._aAggregationProxy.hasOwnProperty(A);};
f.prototype._getAggregation=function(A){return this._aAggregationProxy[A];};
f.prototype._setAggregation=function(A,v,s){this._aAggregationProxy[A]=v;if(s!==true){this._notifyObjectPageLayout();this.invalidate();}return this._aAggregationProxy[A];};
f.prototype.addAggregation=function(A,o,s){var g;if(o instanceof e){o.getContent().forEach(function(h){this.addAggregation(A,h,true);},this);o.removeAllContent();o.destroy();this.invalidate();return this;}if(this.hasProxy(A)){g=this._getAggregation(A);g.push(o);this._setAggregation(A,g,s);if(o instanceof B||o instanceof e){o.setParent(this);}return this;}return O.prototype.addAggregation.apply(this,arguments);};
f.prototype.insertAggregation=function(A,o,i){if(this.hasProxy(A)){jQuery.sap.log.warning("ObjectPageSubSection :: used of insertAggregation for "+A+" is not supported, will use addAggregation instead");return this.addAggregation(A,o);}return O.prototype.insertAggregation.apply(this,arguments);};
f.prototype.removeAllAggregation=function(A,s){var i;if(this.hasProxy(A)){i=this._getAggregation(A);this._setAggregation(A,[],s);return i.slice();}return O.prototype.removeAllAggregation.apply(this,arguments);};
f.prototype.removeAggregation=function(A,o){var r=false,i;if(this.hasProxy(A)){i=this._getAggregation(A);i.forEach(function(g,I){if(g.getId()===o.getId()){i.splice(I,1);this._setAggregation(i);r=true;}return!r;},this);return(r?o:null);}return O.prototype.removeAggregation.apply(this,arguments);};
f.prototype.indexOfAggregation=function(A,o){var i=-1;if(this.hasProxy(A)){this._getAggregation(A).some(function(g,I){if(g.getId()===o.getId()){i=I;return true;}},this);return i;}return O.prototype.indexOfAggregation.apply(this,arguments);};
f.prototype.getAggregation=function(A){if(this.hasProxy(A)){return this._getAggregation(A);}return O.prototype.getAggregation.apply(this,arguments);};
f.prototype.destroyAggregation=function(A){if(this.hasProxy(A)){this._getAggregation(A).forEach(function(o){o.destroy();});this._setAggregation(A,[]);return this;}return O.prototype.destroyAggregation.apply(this,arguments);};
f.prototype._getSeeMoreButton=function(){if(!this._oSeeMoreButton){this._oSeeMoreButton=new d(this.getId()+"--seeMore",{type:sap.m.ButtonType.Transparent,iconFirst:false}).addStyleClass("sapUxAPSubSectionSeeMoreButton").attachPress(this._seeMoreLessControlPressHandler,this);}return this._oSeeMoreButton;};
f.prototype._seeMoreLessControlPressHandler=function(E){var s=this.getMode(),t,m=this.getMoreBlocks()||[];if(s===b.Expanded){t=b.Collapsed;}else{t=b.Expanded;m.forEach(function(o){if(o instanceof B){o.setMode(s);o.connectToModels();}},this);}this._switchSubSectionMode(t);if(this._$spacer.length>0){this._$spacer.height(this._$spacer.height()+this.$().height());}this.rerender();};
f.prototype._switchSubSectionMode=function(s){s=this.validateProperty("mode",s);if(s===b.Collapsed){this.setProperty("mode",b.Collapsed,true);this._getSeeMoreButton().setText(l.i18nModel.getResourceBundle().getText("SEE_MORE"));}else{this.setProperty("mode",b.Expanded,true);this._getSeeMoreButton().setText(l.i18nModel.getResourceBundle().getText("SEE_LESS"));}};
f.prototype._setBlockMode=function(o,m){if(o instanceof B){o.setMode(m);}else{jQuery.sap.log.debug("ObjectPageSubSection :: cannot propagate mode "+m+" to "+o.getMetadata().getName());}};
f.prototype._setToFocusable=function(F){var s='0',n='-1',t="tabIndex";if(F){this.$().attr(t,s);}else{this.$().attr(t,n);}return this;};
f.prototype._getUseTitleOnTheLeft=function(){var o=this._getObjectPageLayout();return o.getSubSectionLayout()===a.TitleOnLeft;};
f.prototype._resetLayoutData=function(g){g.forEach(function(o){if(o.getLayoutData()){o.destroyLayoutData();}},this);};
f.prototype.getVisibleBlocksCount=function(){var v=S.getStashedControls(this.getId()).length;(this.getBlocks()||[]).forEach(function(o){if(o.getVisible&&!o.getVisible()){return true;}v++;});(this.getMoreBlocks()||[]).forEach(function(m){if(m.getVisible&&!m.getVisible()){return true;}v++;});return v;};
return f;});
sap.ui.predefine('sap/uxap/ObjectPageSubSectionRenderer',function(){"use strict";var O={};
O.render=function(r,c){var a,h,H,b,u;if(!c.getVisible()||!c._getInternalVisible()){return;}a=c.getActions()||[];b=a.length>0;h=(c._getInternalTitleVisible()&&(c.getTitle().trim()!==""));H=h||b;r.write("<div ");r.writeAttribute("role","region");r.writeControlData(c);r.addClass("sapUxAPObjectPageSubSection");r.addClass("ui-helper-clearfix");r.writeClasses(c);r.writeClasses();r.write(">");if(H){r.write("<div");r.addClass("sapUxAPObjectPageSubSectionHeader");u=c._getUseTitleOnTheLeft();if(u&&c._onDesktopMediaRange()){r.addClass("titleOnLeftLayout");}r.writeAttributeEscaped("id",c.getId()+"-header");r.writeClasses();r.write(">");r.write("<div");if(h){r.writeAttribute("role","heading");r.writeAttribute("aria-level","4");}r.addClass('sapUxAPObjectPageSubSectionHeaderTitle');if(c.getTitleUppercase()){r.addClass("sapUxAPObjectPageSubSectionHeaderTitleUppercase");}r.writeAttributeEscaped("id",c.getId()+"-headerTitle");r.writeClasses();r.writeAttribute("data-sap-ui-customfastnavgroup",true);if(h){r.writeAttribute("tabindex",0);}r.write(">");if(h){r.writeEscaped(c.getTitle());}r.write("</div>");if(b){r.write("<div");r.addClass('sapUxAPObjectPageSubSectionHeaderActions');r.writeClasses();r.writeAttribute("data-sap-ui-customfastnavgroup",true);r.write(">");a.forEach(r.renderControl);r.write("</div>");}r.write("</div>");}r.write("<div");r.addClass("ui-helper-clearfix");r.addClass("sapUxAPBlockContainer");r.addClass("sapUiResponsiveMargin");r.writeClasses();if(c._isHidden){r.addStyle("display","none");}r.writeStyles();r.write(">");r.renderControl(c._getGrid());r.write("<div");r.addClass("sapUxAPSubSectionSeeMoreContainer");r.writeClasses();r.write(">");r.renderControl(c._getSeeMoreButton());r.write("</div>");r.write("</div>");r.write("</div>");};
return O;},true);
sap.ui.predefine('sap/uxap/ThrottledTaskHelper',["jquery.sap.global",'sap/ui/base/Object'],function(q,B){"use strict";
var T=B.extend("ThrottledTask",{
constructor:function(t,d,c){this._fnTask=t;this._iDelay=d;this._oContext=c;this._oPromise=null;this._fnResolvePromise=null;this._fnRejectPromise=null;this._iTimer=null;this._aTaskArgs=null;},
reSchedule:function(i,t){var r=this._getPromise();if(this._iTimer){q.sap.clearDelayedCall(this._iTimer);this._iTimer=null;}this._aTaskArgs=t;if(i){var s=this._fnTask.apply(this._oContext,this._aTaskArgs);this._completePromise(s);return r;}this._iTimer=q.sap.delayedCall(this._iDelay,this,function(){if(this._oPromise){var s=this._fnTask.apply(this._oContext,this._aTaskArgs);this._completePromise(s);}}.bind(this));return r;},
_getPromise:function(){if(!this._oPromise){this._oPromise=new window.Promise(function(r,a){this._fnResolvePromise=r;this._fnRejectPromise=a;}.bind(this));}return this._oPromise;},
_completePromise:function(s){var c=(s)?this._fnResolvePromise:this._fnRejectPromise;c();this._oPromise=null;this._fnResolvePromise=null;this._fnRejectPromise=null;this._aTaskArgs=null;}
});
return T;},false);
sap.ui.predefine('sap/uxap/component/Component',["sap/uxap/ObjectPageConfigurationMode","sap/ui/core/UIComponent","sap/ui/model/json/JSONModel","sap/ui/core/Component"],function(O,U,J){"use strict";
var C=U.extend("sap.uxap.component.Component",{
metadata:{},
init:function(){this._oModel=null;this._oViewConfig={viewData:{component:this}};switch(this.oComponentData.mode){case O.JsonURL:this._oModel=new U(this.oComponentData.jsonConfigurationURL);this._oViewConfig.viewName="sap.uxap.component.ObjectPageLayoutUXDrivenFactory";this._oViewConfig.type=sap.ui.core.mvc.ViewType.XML;break;case O.JsonModel:this._oViewConfig.viewName="sap.uxap.component.ObjectPageLayoutUXDrivenFactory";this._oViewConfig.type=sap.ui.core.mvc.ViewType.XML;break;default:jQuery.sap.log.error("UxAPComponent :: missing bootstrap information. Expecting one of the following: JsonURL, JsonModel and FacetsAnnotation");}U.prototype.init.call(this);},
createContent:function(){var c;this._oView=sap.ui.view(this._oViewConfig);if(this._oModel){c=this._oView.getController();if(c&&c.connectToComponent){c.connectToComponent(this._oModel);}this._oView.setModel(this._oModel,"objectPageLayoutMetadata");}return this._oView;},
propagateProperties:function(n){if(this.oComponentData.mode===O.JsonModel){var c=this._oView.getController();if(c&&c.connectToComponent){c.connectToComponent(this.getModel("objectPageLayoutMetadata"));}}return U.prototype.propagateProperties.apply(this,arguments);},
destroy:function(){if(this._oView){this._oView.destroy();this._oView=null;}if(this._oModel){this._oModel.destroy();this._oModel=null;}if(U.prototype.destroy){U.prototype.destroy.call(this);}}
});
return C;});
sap.ui.predefine('sap/uxap/component/ObjectPageComponentContainer',['sap/ui/core/ComponentContainer','sap/uxap/ObjectPageConfigurationMode',"sap/ui/core/Component"],function(C,O){"use strict";
var a=C.extend("sap.uxap.component.ObjectPageComponentContainer",{
metadata:{properties:{"jsonConfigurationURL":{type:"string",group:"Behavior"},"mode":{type:"sap.uxap.ObjectPageConfigurationMode",group:"Behavior"}}},
init:function(){this.setPropagateModel(true);this.setName("sap.uxap.component");},
onBeforeRendering:function(){this._oComponent=sap.ui.component("sap.uxap");if(!this._oComponent){this._oComponent=sap.ui.component({name:this.getName(),url:this.getUrl(),componentData:{jsonConfigurationURL:this.getJsonConfigurationURL(),mode:this.getMode()}});this.setComponent(this._oComponent,true);}if(C.prototype.onBeforeRendering){C.prototype.onBeforeRendering.call(this);}},
getObjectPageLayoutInstance:function(){var o=null;if(this._oComponent&&this._oComponent._oView){o=this._oComponent._oView.byId("ObjectPageLayout");}else{jQuery.sap.log.error("ObjectPageComponentContainer :: cannot find children ObjectPageLayout, has it been rendered already?");}return o;},
renderer:"sap.ui.core.ComponentContainerRenderer"
});
return a;});
sap.ui.predefine('sap/uxap/component/ObjectPageLayoutUXDrivenFactory.controller',["sap/ui/layout/GridData","sap/ui/model/BindingMode","sap/uxap/BlockBase","sap/uxap/ModelMapping","sap/ui/model/Context","sap/ui/base/ManagedObject","sap/ui/core/mvc/Controller"],function(G,B,a,M,C,b,c){"use strict";return c.extend("sap.uxap.component.ObjectPageLayoutUXDrivenFactory",{connectToComponent:function(m){var h=jQuery.isEmptyObject(m.getData());m.setDefaultBindingMode(B.OneWay);var H=jQuery.proxy(function(){if(h){m.detachRequestCompleted(H);}var o=new C(m,"/headerTitle"),O=this.getView().byId("ObjectPageLayout");if(o.getProperty("")){try{this._oHeader=this.controlFactory(O.getId(),o);O.setHeaderTitle(this._oHeader);}catch(e){jQuery.sap.log.error("ObjectPageLayoutFactory :: error in header creation from config: "+e);}}},this);if(h){m.attachRequestCompleted(H);}else{H();}},controlFactory:function(p,o){var d=o.getProperty(""),e,f,g;try{jQuery.sap.require(d.Type);f=jQuery.sap.getObject(d.Type);g=f.getMetadata();jQuery.each(g._mAllEvents,jQuery.proxy(function(s,h){if(typeof d[s]=="string"){d[s]=this.convertEventHandler(d[s]);}},this));e=b.create(d);jQuery.each(g._mAllProperties,jQuery.proxy(function(P,h){if(d[P]){e.bindProperty(P,"objectPageLayoutMetadata>"+o.getPath()+"/"+P);}},this));}catch(E){jQuery.sap.log.error("ObjectPageLayoutFactory :: error in control creation from config: "+E);}return e;},convertEventHandler:function(s){var n=window,N=s.split('.');try{jQuery.each(N,function(i,d){n=n[d];});}catch(e){jQuery.sap.log.error("ObjectPageLayoutFactory :: undefined event handler: "+s+". Did you forget to require its static class?");n=undefined;}return n;}});},true);
sap.ui.predefine('sap/uxap/library',["jquery.sap.global","sap/ui/core/Core","sap/ui/core/library","sap/m/library","sap/ui/layout/library"],function(q,C,l){"use strict";sap.ui.getCore().initLibrary({name:"sap.uxap",dependencies:["sap.ui.core","sap.m","sap.ui.layout"],types:["sap.uxap.BlockBaseColumnLayout","sap.uxap.ObjectPageConfigurationMode","sap.uxap.ObjectPageHeaderDesign","sap.uxap.ObjectPageHeaderPictureShape","sap.uxap.ObjectPageSubSectionLayout","sap.uxap.ObjectPageSubSectionMode"],interfaces:[],controls:["sap.uxap.AnchorBar","sap.uxap.BlockBase","sap.uxap.BreadCrumbs","sap.uxap.HierarchicalSelect","sap.uxap.ObjectPageHeader","sap.uxap.ObjectPageHeaderActionButton","sap.uxap.ObjectPageHeaderContent","sap.uxap.ObjectPageLayout","sap.uxap.ObjectPageSection","sap.uxap.ObjectPageSectionBase","sap.uxap.ObjectPageSubSection"],elements:["sap.uxap.ModelMapping","sap.uxap.ObjectPageHeaderLayoutData"],version:"1.42.7",extensions:{flChangeHandlers:{"sap.uxap.ObjectPageLayout":{"moveElements":"default"},"sap.uxap.ObjectPageSection":{"hideControl":"default","unhideControl":"default","stashControl":"default","unstashControl":"default"},"sap.ui.core._StashedControl":{"unstashControl":"default"}}}});sap.uxap.BlockBaseColumnLayout=sap.ui.base.DataType.createType('sap.uxap.BlockBaseColumnLayout',{isValid:function(v){return/^(auto|[1-4]{1})$/.test(v);}},sap.ui.base.DataType.getType('string'));sap.uxap.BlockBaseFormAdjustment={BlockColumns:"BlockColumns",OneColumn:"OneColumn",None:"None"};sap.uxap.ObjectPageConfigurationMode={JsonURL:"JsonURL",JsonModel:"JsonModel"};sap.uxap.ObjectPageHeaderDesign={Light:"Light",Dark:"Dark"};sap.uxap.ObjectPageHeaderPictureShape={Circle:"Circle",Square:"Square"};sap.uxap.ObjectPageSubSectionLayout={TitleOnTop:"TitleOnTop",TitleOnLeft:"TitleOnLeft"};sap.uxap.ObjectPageSubSectionMode={Collapsed:"Collapsed",Expanded:"Expanded"};sap.uxap.Importance={Low:"Low",Medium:"Medium",High:"High"};sap.uxap.i18nModel=(function(){return new sap.ui.model.resource.ResourceModel({bundleUrl:q.sap.getModulePath("sap.uxap.i18n.i18n",".properties")});}());sap.uxap.Utilities={getClosestOPL:function(c){while(c&&c.getMetadata().getName()!=="sap.uxap.ObjectPageLayout"){c=c.getParent();}return c;},isPhoneScenario:function(){if(sap.ui.Device.system.phone){return true;}return sap.uxap.Utilities._isCurrentMediaSize("Phone");},isTabletScenario:function(){if(!sap.ui.Device.system.desktop&&sap.ui.Device.system.tablet){return true;}return sap.uxap.Utilities._isCurrentMediaSize("Tablet");},_isCurrentMediaSize:function(m){if(sap.ui.Device.media.hasRangeSet(sap.ui.Device.media.RANGESETS.SAP_STANDARD_EXTENDED)){var r=sap.ui.Device.media.getCurrentRange(sap.ui.Device.media.RANGESETS.SAP_STANDARD_EXTENDED);if(r&&r.name===m){return true;}}return q("html").hasClass("sapUiMedia-Std-"+m);}};return sap.uxap;},true);
jQuery.sap.registerPreloadedModules({
"name":"sap/uxap/library-preload",
"version":"2.0",
"modules":{
	"sap/uxap/component/ObjectPageLayoutUXDrivenFactory.view.xml":'<core:View xmlns:core="sap.ui.core"\n\t\t   xmlns="sap.uxap"\n\t\t   height="100%"\n\t\t   controllerName="sap.uxap.component.ObjectPageLayoutUXDrivenFactory"\n>\n\t<ObjectPageLayout id="ObjectPageLayout"\n\t\t\t\t\t  subSectionLayout="{objectPageLayoutMetadata>/subSectionLayout}"\n\t\t\t\t\t  showAnchorBar="{objectPageLayoutMetadata>/showAnchorBar}"\n\t\t\t\t\t  height="{objectPageLayoutMetadata>/height}"\n\t\t\t\t\t  enableLazyLoading="{objectPageLayoutMetadata>/enableLazyLoading}"\n\t\t\t\t\t  sections="{objectPageLayoutMetadata>/sections}"\n\t\t\t\t\t  headerContent="{path:\'objectPageLayoutMetadata>/headerContent\', factory:\'.controlFactory\'}"\n\t\t\t\t\t  showAnchorBarPopover="{objectPageLayoutMetadata>/showAnchorBarPopover}"\n\t\t\t\t\t  upperCaseAnchorBar="{objectPageLayoutMetadata>/upperCaseAnchorBar}"\n\t\t\t\t\t  useIconTabBar="{objectPageLayoutMetadata>/useIconTabBar}"\n\t\t\t\t\t  showHeaderContent="{objectPageLayoutMetadata>/showHeaderContent}"\n\t\t\t\t\t  useTwoColumnsForLargeScreen="{objectPageLayoutMetadata>/useTwoColumnsForLargeScreen}"\n\t\t\t\t\t  showTitleInHeaderContent="{objectPageLayoutMetadata>/showTitleInHeaderContent}"\n\t\t\t\t\t  showOnlyHighImportance="{objectPageLayoutMetadata>/showOnlyHighImportance}"\n\t\t\t\t\t  isChildPage="{objectPageLayoutMetadata>/isChildPage}"\n\t\t\t\t\t  alwaysShowContentHeader="{objectPageLayoutMetadata>/alwaysShowContentHeader}"\n\t\t\t\t\t  showEditHeaderButton="{objectPageLayoutMetadata>/showEditHeaderButton}"\n\t>\n\n\t\t<!-- template for objectPageSection -->\n\t\t<sections>\n\t\t\t<ObjectPageSection id="ObjectPageSection"\n\t\t\t\t\t\t\t   title="{objectPageLayoutMetadata>title}"\n\t\t\t\t\t\t\t   importance="{objectPageLayoutMetadata>importance}"\n\t\t\t\t\t\t\t   showTitle="{objectPageLayoutMetadata>showTitle}"\n\t\t\t\t\t\t\t   subSections="{objectPageLayoutMetadata>subSections}"\n\t\t\t\t\t\t\t   visible="{objectPageLayoutMetadata>visible}">\n\n\t\t\t\t<!-- template for objectPageSubSection -->\n\t\t\t\t<subSections>\n\t\t\t\t\t<ObjectPageSubSection id="ObjectPageSubSection"\n\t\t\t\t\t\t\t\t\t\t  title="{objectPageLayoutMetadata>title}"\n\t\t\t\t\t\t\t\t\t\t  visible="{objectPageLayoutMetadata>visible}"\n\t\t\t\t\t\t\t\t\t\t  mode="{objectPageLayoutMetadata>mode}"\n\t\t\t\t\t\t\t\t\t\t  importance="{objectPageLayoutMetadata>importance}"\n\t\t\t\t\t\t\t\t\t\t  actions="{path:\'objectPageLayoutMetadata>actions\', factory:\'.controlFactory\'}"\n\t\t\t\t\t\t\t\t\t\t  blocks="{path:\'objectPageLayoutMetadata>blocks\', factory:\'.controlFactory\'}"\n\t\t\t\t\t\t\t\t\t\t  moreBlocks="{path:\'objectPageLayoutMetadata>moreBlocks\', factory:\'.controlFactory\'}">\n\n\t\t\t\t\t\t<!-- factory for actions, blocks and moreBlocks as the type is coming from the model -->\n\n\t\t\t\t\t</ObjectPageSubSection>\n\t\t\t\t</subSections>\n\t\t\t\t<!-- end template for objectPageSubSection -->\n\n\t\t\t</ObjectPageSection>\n\t\t</sections>\n\t\t<!-- template for objectPageSection -->\n\t</ObjectPageLayout>\n\n</core:View>\n',
	"sap/uxap/manifest.json":'{\n  "_version": "1.2.0",\n  "sap.app": {\n    "_version": "1.2.0",\n    "id": "sap.uxap",\n    "type": "library",\n    "embeds": [\n      "component"\n    ],\n    "applicationVersion": {\n      "version": "1.42.7"\n    },\n    "title": "SAP UxAP",\n    "description": "SAP UxAP",\n    "ach": "CA-UI5-CTR",\n    "resources": "resources.json",\n    "offline": true\n  },\n  "sap.ui": {\n    "_version": "1.1.0",\n    "technology": "UI5",\n    "supportedThemes": [\n      "base",\n      "sap_hcb"\n    ]\n  },\n  "sap.ui5": {\n    "_version": "1.1.0",\n    "dependencies": {\n      "minUI5Version": "1.42",\n      "libs": {\n        "sap.ui.core": {\n          "minVersion": "1.42.7"\n        },\n        "sap.m": {\n          "minVersion": "1.42.7"\n        },\n        "sap.ui.layout": {\n          "minVersion": "1.42.7"\n        }\n      }\n    }\n  }\n}'
}});
