/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

(c) Copyright 2009-2016 SAP SE. All rights reserved
 */
sap.ui.define(['sap/chart/library','sap/viz/ui5/controls/VizFrame','sap/viz/ui5/controls/common/BaseControl','sap/viz/ui5/data/Dataset','sap/viz/ui5/data/FlattenedDataset','sap/viz/ui5/data/DimensionDefinition','sap/viz/ui5/data/MeasureDefinition','sap/chart/data/Dimension','sap/chart/data/TimeDimension','sap/chart/data/Measure','sap/ui/model/analytics/ODataModelAdapter','sap/chart/utils/RoleFitter','sap/chart/utils/ChartUtils','sap/chart/utils/SeriesColorTracker','sap/chart/utils/ChartTypeAdapterUtils','sap/chart/utils/DateFormatUtil','sap/viz/ui5/controls/common/feeds/FeedItem','sap/ui/model/Filter','sap/ui/model/FilterOperator','sap/ui/model/analytics/odata4analytics','sap/ui/model/Sorter','sap/chart/TimeUnitType'],function(l,V,B,D,F,a,M,b,T,c,O,R,C,S,f,g,h,o,q,r,t,u){"use strict";var w=sap.chart.SelectionMode;var x=B.extend("sap.chart.Chart",{metadata:{library:"sap.chart",properties:{chartType:{type:"string",defaultValue:"bar"},uiConfig:{type:"object",group:"Misc"},visibleDimensions:{type:"string[]",defaultValue:[]},inResultDimensions:{type:"string[]",defaultValue:[]},visibleMeasures:{type:"string[]",defaultValue:[]},vizProperties:{type:"object",group:"Misc"},vizScales:{type:"object[]",group:"Misc"},isAnalytical:{type:"boolean"},selectionBehavior:{type:"string",defaultValue:"DATAPOINT"},selectionMode:{type:"string",defaultValue:sap.chart.SelectionMode.Multi},enablePagination:{type:"boolean",defaultValue:false}},aggregations:{data:{type:"sap.ui.core.Element",multiple:true,bindable:"bindable"},_vizFrame:{type:"sap.viz.ui5.controls.VizFrame",multiple:false,visibility:"hidden"},dimensions:{type:"sap.chart.data.Dimension",multiple:true},measures:{type:"sap.chart.data.Measure",multiple:true}},events:{drilledDown:{parameters:{dimensions:{type:"string[]"}}},drilledUp:{parameters:{dimensions:{type:"string[]"}}},renderComplete:{},selectData:{},deselectData:{}}},renderer:function(d,e){d.write("<div");d.writeControlData(e);d.addStyle("width",e.getWidth());d.addStyle("height",e.getHeight());d.writeStyles();d.write(">");d.renderControl(e.getAggregation("_vizFrame"));d.write("</div>");}});x.getMetadata().getAggregation("data")._doesNotRequireFactory=true;function y(v){return v.indexOf("%")!==-1?"100%":v;}x.prototype.setHeight=function(v){this.setProperty("height",v);var d=this._getVizFrame();if(d){d.setHeight(y(this.getProperty("height")));}return this;};x.prototype.setWidth=function(v){this.setProperty("width",v);var d=this._getVizFrame();if(d){d.setWidth(y(this.getProperty("width")));}return this;};x.prototype.setChartType=function(s,d){this.setProperty("chartType",s,d);this._bIsPagingChartType=C.CONFIG.pagingChartTypes.indexOf(s)>-1;if(this._isEnablePaging()){this._initPagination(true);}else{var e=this._getDataset();if(e){e.setPagingOption(null);}}this._invalidateBy({source:this,keys:{vizFrame:true}});this._bNeedToApplyDefaultProperties=true;return this;};x.prototype.removeDimension=function(d){var e=this.removeAggregation("dimensions",d);if(e){var v=this._getVisibleDimensions()||[],i=v.indexOf(e.getName());if(i!==-1){v.splice(i,1);this.setVisibleDimensions(v);}var j=this._getInResultFields()||[];i=j.indexOf(e.getName());if(i!==-1){j.splice(i,1);this.setInResultDimensions(j);}}return e;};x.prototype.removeAllDimensions=function(){var d=this.removeAllAggregation("dimensions");this.setVisibleDimensions([]);this.setInResultDimensions([]);return d;};x.prototype.destroyDimensions=function(){var d=this.destroyAggregation("dimensions");this.setVisibleDimensions([]);return d;};x.prototype.removeMeasure=function(m){var d=this.removeAggregation("measures",m);if(d){var v=this._getVisibleMeasures()||[],i=v.indexOf(d.getName());if(i!==-1){v.splice(i,1);this.setVisibleMeasures(v);}}return d;};x.prototype.removeAllMeasures=function(){var d=this.removeAllAggregation("measures");this.setVisibleMeasures([]);return d;};x.prototype.destroyMeasures=function(){var d=this.destroyAggregation("measures");this.setVisibleMeasures([]);return d;};x.prototype._getVisibleDimensions=function(n){var s=this._getDrillStateTop();var d=s?s.dimensions:this.getProperty("visibleDimensions");return n?this._normalizeDorM(d,true):d;};x.prototype.getVisibleDimensions=function(){var v=this._getVisibleDimensions();return this._aFeeds?v.filter(function(d){return this._aFeeds._unused.indexOf(d)===-1;},this):v;};x.prototype._getVisibleMeasures=function(n){var s=this._getDrillStateTop();var m=s?s.measures:this.getProperty("visibleMeasures");return n?this._normalizeDorM(m):m;};x.prototype.getVisibleMeasures=function(){var v=this._getVisibleMeasures();return this._aFeeds?v.filter(function(d){return this._aFeeds._unused.indexOf(d)===-1;},this):v;};x.prototype.setVisibleDimensions=function(d,s){var m=this._dimensionSanityCheck({visible:d});this.setProperty("visibleDimensions",d,s);this.setProperty("inResultDimensions",m.inResult,s);this._createDrillStack();this._invalidateBy({source:this,keys:{binding:true,dataSet:true,vizFrame:true}});return this;};x.prototype.setInResultDimensions=function(i,s){var m=this._dimensionSanityCheck({inResult:i});this.setProperty("inResultDimensions",i,s);this.setProperty("visibleDimensions",m.visible,s);this._createDrillStack();this._invalidateBy({source:this,keys:{binding:true,dataSet:true,vizFrame:true}});};x.prototype.setVisibleMeasures=function(m,s){this.setProperty("visibleMeasures",m,s);this._createDrillStack();this._invalidateBy({source:this,keys:{binding:true,dataSet:true,vizFrame:true}});return this;};x.prototype.setEnablePagination=function(v,s){if(!this._bSetEnablePagination){this.setProperty("enablePagination",v,s);this._invalidateBy({source:this,keys:{binding:true,dataSet:true,vizFrame:true,drillStack:true}});this._bSetEnablePagination=true;}};x.prototype._dimensionSanityCheck=function(d){var v=d.visible||this.getVisibleDimensions()||[],i=d.inResult||this.getInResultDimensions()||[];var s=[].concat(v).concat(i).reduce(function(m,e){var j=v.indexOf(e)!==-1,k=i.indexOf(e)!==-1;if(j&&k){m.common[e]=true;}else if(j){m.visible[e]=true;}else if(k){m.inResult[e]=true;}return m;},{visible:{},inResult:{},common:{}});s.visible=Object.keys(s.visible);s.inResult=Object.keys(s.inResult);s.common=Object.keys(s.common);return s;};x.prototype._getInResultFields=function(){var d=this,i=this.getInResultDimensions(),m=this._normalizeDorM(this._getVisibleMeasures(),false),U=m.reduce(function(U,e){var j=e.getUnitBinding();if(j&&U.indexOf(j)===-1&&d.getDimensionByName(j)&&i.indexOf(j)===-1){return U.concat(j);}else{return U;}},[]);return i.concat(U);};x.prototype._prepareFeeds=function(){if(!this._aFeeds){var d=this._normalizeDorM(this._getVisibleDimensions(),true),m=this._normalizeDorM(this._getVisibleMeasures(),false),i=this._normalizeDorM(this._getInResultFields(),true);this._sAdapteredChartType=this.getEnablePagination()?this.getChartType():f.adaptChartType(this.getChartType(),d);this._aFeeds=R.fit(this._sAdapteredChartType,d,m,i,"color",this._mDataTypes);if((!this._aFeeds._valid||this._aFeeds._unused.length)&&this._sAdapteredChartType!==this.getChartType()){this._sAdapteredChartType=this.getChartType();this._aFeeds=R.fit(this._sAdapteredChartType,d,m,i,"color",this._mDataTypes);}if(this._sAdapteredChartType!==this.getChartType()){this._bNeedToApplyDefaultProperties=true;}}return this._aFeeds;};x.prototype._normalizeDorM=function(m,i){var d=i?this.getDimensions():this.getMeasures(),L=d.reduce(function(k,p){k[p.getName()]=p;return k;},{}),e=i?b:c;var j=m.reduce(function(j,N){var s;if(typeof N==="string"){s=N;}else if(N instanceof e){s=N.getName();}else{j.errors.push(N);}if(L[s]){j.normalized.push(L[s]);}else{j.errors.push(N);}return j;},{normalized:[],errors:[]});var n=j.normalized;if(j.errors.length>0){n.errors=j.errors;}return n;};x.prototype._redundantsFromSelection=function(){var s=this._getVizFrame().vizSelection();if(!s||s.length===0){return{measureNames:{}};}var m=s.reduce(function(e,i){jQuery.each(i.data,function(k,v){if(!e[k]){e[k]=[];}if(e[k].indexOf(v)===-1){e[k].push(v);}});return e;},{});var d=this._getVisibleDimensions().reduce(function(e,i){var v=m[i];if(v.length===1){e[i]=v[0];}return e;},{});d.measureNames=this._getVisibleMeasures().reduce(function(e,i){if(!m[i]){e[i]=true;}return e;},{});return d;};x.prototype._deriveFilterFromSelection=function(){var v=this._getVisibleDimensions();var d=this;var e=this._getVizFrame().vizSelection().map(function(s){var j=v.reduce(function(k,m){var n=d.getDimensionByName(m);var p;p=s.data[m];if(C.CONFIG.timeChartTypes.indexOf(d._sAdapteredChartType)>-1&&n instanceof T){var K=g.getInstance(n.getTimeUnit());if(K){var L=K.format.bind(K);p=L(new Date(s.data[m]));}}k.filters.push(new o({path:m,operator:q.EQ,value1:p}));k.signature.push(m+"="+s.data[m]);return k;},{filters:[],signature:[]});j.signature=j.signature.join(";");return j;});var U=e.reduce(function(m,j){if(!m[j.signature]&&j.filters.length>0){m[j.signature]=new o(j.filters,true);}return m;},{});var i=Object.keys(U).map(function(k){return U[k];});if(i.length>1){return new sap.ui.model.Filter(i,false);}else if(i.length===1){return i[0];}else{return null;}};x.prototype._checkDrilldownValid=function(i){var v=this._getVisibleDimensions().concat(this._getInResultFields()).reduce(function(e,j){e[j]=true;return e;},{});if(i.some(function(e){return v[e.getName()];})){jQuery.sap.log.error("Drill down not possible, because one of the given dimensions is already drilled down!");return false;}var m=i.reduce(function(e,j){e[j.getName()]=j;return e;},{});function d(e){if(jQuery.isArray(e.aFilters)){return e.aFilters.some(d);}else{return!!m[e.sPath];}}var s=this._getDrillStateTop();if(s&&s.filter&&d(s.filter)){jQuery.sap.log.error("Drill down not possible, because one of the given dimensions is already filtered!");return false;}return true;};x.prototype._createDrillStack=function(){var v=this.getProperty("visibleDimensions")||[],d=this.getProperty("visibleMeasures")||[],s=[{dimensions:[],measures:d,filter:undefined}],e=[];for(var i=0;i<v.length;i++){e.push(v[i]);s.push({dimensions:e.slice(),measures:d,filter:undefined});}this._drillStateStack=s;};x.prototype._invalidateBy=function(d){var s=d.source;if(s===this){jQuery.each(d.keys||{},function(k,v){this._markForUpdate(k,v);}.bind(this));}else if(s instanceof c&&this._getVisibleMeasures().indexOf(s.getName())!==-1){this._markForUpdate("dataSet",true);this._markForUpdate("vizFrame",true);if(d.property==="unitBinding"){this._markForUpdate("binding",true);}}else if(s instanceof b&&this._getVisibleDimensions().indexOf(s.getName())!==-1){this._markForUpdate("dataSet",true);this._markForUpdate("vizFrame",true);if(s.getDisplayText()&&(d.property==="textProperty"||d.property==="displayText")){this._markForUpdate("binding",true);}}this.invalidate(d);};x.prototype._markForUpdate=function(k,n){if(!this._mNeedToUpdate){this._mNeedToUpdate={};}this._mNeedToUpdate[k]=n;var d=this._updaters.onInvalidate[k];if(d){d.call(this);}};x.prototype._updaters=(function(){function d(i,j,k){var s=i.getTextProperty(),m=[{name:i.getName(),grouped:false,inResult:!!j,visible:!k}];if(i.getDisplayText()&&s){m.push({name:s,grouped:false,inResult:!!j,visible:!k});}return m;}function e(m){var U=m.getUnitBinding(),i=[{name:m.getName(),total:false,inResult:false,visible:true}];if(U){i.push({name:U,total:false,inResult:false,visible:true});}return i;}return{onInvalidate:{vizFrame:function(){this._aFeeds=null;}},drillStack:function(){this._createDrillStack();},dataSet:function(){var i=this._getDataset();i.updateData.apply(i,arguments);},binding:function(){var i=this._getDataset().getBinding("data");if(!i){return;}var j=this._getVisibleDimensions(true),m=this._getVisibleMeasures(true);if(i.updateAnalyticalInfo){var k=j.reduce(function(n,p){return n.concat(d(p));},[]).concat(this._normalizeDorM(this._getInResultFields(),true).reduce(function(n,p){return n.concat(d(p,true,true));},[])).concat(m.reduce(function(n,p){return n.concat(e(p));},[]));i.updateAnalyticalInfo(k);}var s=this._getDrillStateTop();if(j.length>0||m.length>0){this._getVizFrame()._pendingDataRequest(true);this.setBusy(true);}i.filter((s&&s.filter)?s.filter:undefined);this._resetPagingOptions();},vizFrame:function(){var i=this,j=this._getDataset(),v=this._getVizFrame(),m=this._mMeasureRange||{};j.removeAllAggregation("dimensions",true);j.removeAllAggregation("measures",true);v.removeAllAggregation("feeds",true);var k=this._prepareFeeds();k._def.dim.forEach(function(n){j.addAggregation("dimensions",n,true);},this);k._def.msr.forEach(function(n){var p=m[n.getIdentity()];if(p){n.setRange([p.min,p.max]);}if(!i.getDimensionByName(n.getUnit())){n.setUnit(null);}j.addAggregation("measures",n,true);},this);k.forEach(function(n){v.addFeed(n);});j.setContext((k._context||[]).map(function(n){return{id:n,showInTooltip:true};}));v.invalidate();j.invalidate();v.setVizType(this._sAdapteredChartType);v.setVizProperties(this._getEffectiveProperties());}};})();x.prototype._getDrillStateTop=function(){return this._drillStateStack?this._drillStateStack[this._drillStateStack.length-1]:null;};x.prototype._getVizFrame=function(){return this.getAggregation("_vizFrame");};x.prototype._getDataset=function(){var v=this._getVizFrame();return v?v.getDataset():null;};x.prototype._bindingChangeListener=function(){var v=this._getVizFrame();v.invalidate();v.setVizProperties(this._getEffectiveProperties());this.setBusy(false);if(this._isEnablePaging()){if(this._bNeedTotal){this._initPagination();this._bNeedTotal=false;}else if(this._bNeedPaging){var d=v._states().plot.transform.translate.position;this._updatePage(d);}}else{this._mMeasureRange={};v._pendingDataRequest(false);v.invalidate();}};x.prototype._initPagination=function(n){var d=this.getBinding("data"),p;if(!d){return;}var i=d.getTotalSize();if(i>=0){this._iTotalSize=i;if(this._iTotalSize>this._iPageSize*2){this._iMaxPageNo=Math.floor(this._iTotalSize/this._iPageSize)-1;this._iRemainingRecords=this._iTotalSize%this._iPageSize;this._bNeedPaging=true;this._iOffset=null;var e=this._iPageSize/this._iTotalSize;p={bEnabled:true,iStartIndex:0,iLength:this._iPageSize,sMode:"reset",thumbRatio:e,iPageNo:0};if(n){this._getVizFrame()._pendingDataRequest(false);}else{this._getVizFrame()._pendingDataRequest(true);this._queryMinMax(this._measureRangeReceivedHandler.bind(this));}}else{this._mMeasureRange={};this._bNeedPaging=false;p={bEnabled:false,iStartIndex:0,iLength:this._iTotalSize};this._getVizFrame()._pendingDataRequest(false);}this._getDataset().setPagingOption(p);}};x.prototype._resetPagingOptions=function(){var d=this.getBinding("data");var e=this._getDataset();if(!e||!d){return;}if(this._isEnablePaging()){var i=this._prepareFeeds();i._order=i._order.filter(function(j){return j!=="MND"&&d.getSortablePropertyNames().indexOf(j)>-1;});if(i._order.length){var s=this._aFeeds._order.map(function(P){return new t(P);});d.sort(s);}this._bNeedTotal=true;var p={bEnabled:false,iStartIndex:0,iLength:this._iPageSize*2,iPageNo:0};e.setPagingOption(p);this._oColorTracker.clear();this._getVizFrame()._runtimeScales(this._oColorTracker.get(),true);}else{e.setPagingOption(null);}this._mMeasureRange={};};x.prototype.addData=function(){jQuery.sap.log.error('Chart manages the "data" aggregation only via data binding. The method "addData" therefore cannot be used programmatically!');};x.prototype.destroyData=function(){jQuery.sap.log.error('Chart manages the "data" aggregation only via data binding. The method "destroyData" therefore cannot be used programmatically!');};x.prototype.getData=function(){jQuery.sap.log.error('Chart manages the "data" aggregation only via data binding. The method "getData" therefore cannot be used programmatically!');};x.prototype.indexOfData=function(){jQuery.sap.log.error('Chart manages the "data" aggregation only via data binding. The method "indexOfData" therefore cannot be used programmatically!');};x.prototype.insertData=function(){jQuery.sap.log.error('Chart manages the "data" aggregation only via data binding. The method "insertData" therefore cannot be used programmatically!');};x.prototype.removeData=function(){jQuery.sap.log.error('Chart manages the "data" aggregation only via data binding. The method "removeData" therefore cannot be used programmatically!');};x.prototype.removeAllData=function(){jQuery.sap.log.error('Chart manages the "data" aggregation only via data binding. The method "removeAllData" therefore cannot be used programmatically!');};x.prototype._getEntitySet=function(p,n){if(!n){n=p.split("/")[1];if(n.indexOf("(")!=-1){n=n.split("(")[0]+"Results";}}return n;};x.prototype._createOData4SAPAnalyticsModel=function(m){var d=null;try{d=new r.Model(new r.Model.ReferenceByModel(m));}catch(e){return undefined;}return d;};x.prototype._setIsAnalyticalProperty=function(d,p,n){if(this.getIsAnalytical()===undefined){this.setIsAnalytical(d.findQueryResultByName(this._getEntitySet(p,n))!==undefined);}};x.prototype.bindAggregation=function(n,d){if(n==="data"){var m=this.getModel(d.model);if(m){var e=this._createOData4SAPAnalyticsModel(m);this._setIsAnalyticalProperty(e,d.path,d.parameters?d.parameters.entitySet:undefined);if(this.getIsAnalytical()){if(d){d.parameters=jQuery.extend(true,{},{analyticalInfo:[{name:""}],useBatchRequests:true,provideGrandTotals:false,provideTotalsResultSize:false,autoexpand:false,reloadSingleUnitMeasures:true,noPaging:true},d.parameters);if(this._isEnablePaging()){var p={noPaging:false};d.parameters=jQuery.extend(true,d.parameters,p);}}O.apply(m);if(e){m.setAnalyticalExtensions(e);}}}}return B.prototype.bindAggregation.apply(this,arguments);};x.prototype._bindAggregation=function(n,d){if(n==="data"){var m=this.getModel(d.model);if(m){var e=this._createOData4SAPAnalyticsModel(m);this._setIsAnalyticalProperty(e,d.path,d.parameters?d.parameters.entitySet:undefined);if(this.getIsAnalytical()){if(d){d.parameters=jQuery.extend(true,{},{analyticalInfo:[{name:""}],useBatchRequests:true,provideGrandTotals:false,provideTotalsResultSize:false,autoexpand:false,reloadSingleUnitMeasures:true,noPaging:true},d.parameters);if(this._isEnablePaging()){var p={noPaging:false};d.parameters=jQuery.extend(true,d.parameters,p);}}O.apply(m);if(e){m.setAnalyticalExtensions(e);}var i=m.getAnalyticalExtensions().findQueryResultByName(this._getEntitySet(d.path,d.parameters?d.parameters.entitySet:undefined));this._initialiseMetaData(i);}}var j=this._getDataset(),k=j.getBinding("data");if(k){k.detachChange(this._bindingChangeListener,this);}j.bindAggregation("data",d);var N=j.getBinding("data");if(N){j.getBinding("data").attachChange(this._bindingChangeListener,this);}this._invalidateBy({source:this,keys:{binding:true,vizFrame:true}});}else{B.prototype._bindAggregation.apply(this,arguments);}};x.prototype.unbindAggregation=function(n,s){if(n==="data"){var d=this._getDataset();if(d){d.unbindAggregation.apply(d,arguments);}s=true;}return B.prototype.unbindAggregation.apply(this,[n,s]);};x.prototype._initialiseMetaData=function(d){var e=this.getAggregation("dimensions");var m=this.getAggregation("measures");if((e===null||e.length===0)&&(m===null||m.length===0)){var s=d.getEntityType().getQName();s=s.slice(s.lastIndexOf(".")+1);var k=d.getEntityType().getSchema().namespace;e=d.getAllDimensions();for(var i in e){var n=e[i].getName();var p=b;var P={name:n,label:"{/#"+s+"/"+n+"/@sap:label}",textProperty:"{/#"+s+"/"+n+"/@sap:text}"};var N='name';var v='namespace';var K="/dataServices/"+"schema/[${"+v+"}==='"+k+"']/entityType/[${"+N+"}==='"+s+"']/property/[${"+N+"}==='"+n+"']/";var U=d.getModel().getODataModel().getMetaModel().getProperty(K);if(U.type==="Edm.DateTime"&&U['sap:display-format']==="Date"){p=T;P.timeUnit=u.Date;}else if(U.type==="Edm.String"&&u[U['sap:semantics']]){p=T;P.timeUnit=U['sap:semantics'];}this.addDimension(new p(P));}m=d.getAllMeasures();for(var j in m){var L=m[j].getName();this.addMeasure(new c({name:L,label:"{/#"+s+"/"+L+"/@sap:label}"}));}}};x.prototype.onBeforeRendering=function(){B.prototype.onBeforeRendering.apply(this,arguments);jQuery.each(this._updaters,function(k,d){if(this._mNeedToUpdate[k]){d.call(this);this._mNeedToUpdate[k]=false;}}.bind(this));};x.prototype.onAfterRendering=function(){this._showLoading(this._bLoading);};x.prototype.exit=function(){this._getDataset().unbindAggregation('data',true);B.prototype.exit.apply(this,arguments);var v=this._getVizFrame();if(this._delegateEventHandlers){this._delegateEventHandlers.forEach(function(d){v["detach"+d.name](d.handler,this);delete d.handler;},this);delete this._delegateEventHandlers;}v.detachRenderComplete(this._vizFrameRenderCompleteHandler,this);};x.prototype.applySettings=function(){sap.ui.core.Control.prototype.applySettings.apply(this,arguments);var d=new F();var e=jQuery.extend(true,{},{'applicationSet':'fiori'},this.getUiConfig());this.setUiConfig(e);this._bNeedToApplyDefaultProperties=true;var v=new V({width:y(this.getWidth()),height:y(this.getHeight()),vizType:this.getChartType(),uiConfig:this.getUiConfig(),vizProperties:jQuery.extend(true,{'title':{'visible':false}},this._getEffectiveProperties())});v.setDataset(d);v.attachRenderComplete(null,this._updateLoadingIndicator.bind(this));this._rendered=false;v.attachEventOnce("renderComplete",function(){this._rendered=true;},this);v._pendingDataRequest(true);this.setAggregation("_vizFrame",v);this._delegateEvents();this._bSetEnablePagination=true;this._bNeedTotal=true;this._bNeedPaging=false;this._iPageSize=500;this._oColorTracker=new S();this._sAdapteredChartType=this.getChartType();};x.prototype.resetLayout=function(){this._invalidateBy({source:this,keys:{binding:true,vizFrame:true,drillStack:true,dataSet:true}});return this;};var _=(function(){function m(k){return k.reduce(function(L,K){L[K]=true;return L;},{});}function d(v,k){var p=m(v);function s(K){return k.reduce(function(P,L){if(K.hasOwnProperty(L)){P[L]=K[L];}return P;},{});}return function(K,L){return K.filter(function(N){return p[N];}).map(function(N){var P=s(L);P[N]="*";return{data:P};});};}function e(v,k){var p=m(v);return function(s){return{index:s._context_row_number,measures:Object.keys(s).filter(function(K){return p[K];})};};}function i(p){var s={data:{}},K=p.measures,L=p.dimensions;if(K){s.data.measureNames=(K instanceof Array)?{"in":K}:K;}jQuery.each(L||{},function(k,v){s.data[k]=(v instanceof Array)?{"in":v}:v;});return s;}function j(p){var s=p.data;return Object.keys(s).reduce(function(K,k){var v=s[k];if(v.in&&v.in instanceof Array){v=v.in;}if(k==="measureNames"){K.measures=v;}else if(!K.dimensions){K.dimensions={};K.dimensions[k]=v;}else{K.dimensions[k]=v;}return K;},{});}function n(v,k,p,s){var K=d(v,k);return s.reduce(function(L,N){var P=p.getContexts(N.index,1);if(P.length>0){L=L.concat(K(N.measures,P[0].getObject()));}return L;},[]);}return{makeLookUp:m,toVizCtx:d,fromVizCtx:e,toVizCSCtx:i,fromVizCSCtx:j,buildSelectionVizCtx:n,match:function(p,v,s){return Object.keys(p).every(function(k){if(s.indexOf(k)!==-1){return v.hasOwnProperty(k);}else{return p[k]===v[k];}});}};})();x.prototype.setSelectedDataPoints=function(d){if(this.getSelectionMode()!==w.None){var e=this.getBinding("data"),v=this._getVizFrame();if(!e||!v||this.getSelectionBehavior().toUpperCase()!=="DATAPOINT"){return this;}v.vizSelection([],{clearSelection:true});var m=this._getVisibleMeasures(),i=this._getVisibleDimensions().concat(this._getInResultFields());v.vizSelection(_.buildSelectionVizCtx(m,i,e,d),{selectionMode:this.getSelectionMode()});}return this;};x.prototype.addSelectedDataPoints=function(d){if(this.getSelectionMode()!==w.None){var e=this.getBinding("data"),v=this._getVizFrame();if(!e||!v||this.getSelectionBehavior().toUpperCase()!=="DATAPOINT"){return this;}v.vizSelection(_.buildSelectionVizCtx(this._getVisibleMeasures(),this._getVisibleDimensions(),e,d),{selectionMode:w.Multi});}return this;};x.prototype.getSelectedDataPoints=function(){var v=this._getVizFrame();if(!v||this.getSelectionBehavior().toUpperCase()!=="DATAPOINT"){return{count:0,dataPoints:[]};}var d=_.fromVizCtx(this._getVisibleMeasures(),this._getVisibleDimensions());var s=v.vizSelection(),m=s.map(function(n){return n.data;}).map(d).reduce(function(i,j){var k=j.index;i[k]=jQuery.extend(true,i[k]||{},_.makeLookUp(j.measures));return i;},{});var e=this._getDataset();return{count:s.length,dataPoints:Object.keys(m).map(function(i){var j=parseInt(i,10);return{index:j,measures:Object.keys(m[i]),context:e.findContext({"_context_row_number":j})};})};};x.prototype.removeSelectedDataPoints=function(d){if(this.getSelectionMode()!==w.None){var e=this.getBinding("data"),v=this._getVizFrame();if(!v||this.getSelectionBehavior().toUpperCase()!=="DATAPOINT"){return this;}var i=this._getVisibleMeasures();var j=this._getVisibleDimensions();var k=_.buildSelectionVizCtx(i,j,e,d);v.vizSelection(k,{deselection:true});}return this;};x.prototype.setSelectedCategories=function(d){if(this.getSelectionMode()!==w.None){var v=this._getVizFrame(),s=this.getSelectionBehavior().toUpperCase();if(!v||s!=="CATEGORY"){return this;}v.vizSelection([],{clearSelection:true});v.vizSelection(d.map(_.toVizCSCtx),{selectionMode:this.getSelectionMode()});}return this;};x.prototype.addSelectedCategories=function(d){if(this.getSelectionMode()!==w.None){var v=this._getVizFrame(),s=this.getSelectionBehavior().toUpperCase();if(!v||s!=="CATEGORY"){return this;}v.vizSelection(d.map(_.toVizCSCtx),{selectionMode:w.Multi});}return this;};x.prototype.removeSelectedCategories=function(d){if(this.getSelectionMode()!==w.None){var v=this._getVizFrame(),s=this.getSelectionBehavior().toUpperCase();if(!v||s!=="CATEGORY"){return this;}v.vizSelection(d.map(_.toVizCSCtx),{deselection:true});}return this;};x.prototype.getSelectedCategories=function(){var v=this._getVizFrame(),s=this.getSelectionBehavior().toUpperCase();if(!v||s!=="CATEGORY"){return{count:0,categories:[]};}else{var d=v.vizSelection();return{count:d.length,categories:(d.category||[]).map(_.fromVizCSCtx)};}};x.prototype.setSelectedSeries=function(s){if(this.getSelectionMode()!==w.None){var v=this._getVizFrame(),d=this.getSelectionBehavior().toUpperCase();if(!v||d!=="SERIES"){return this;}v.vizSelection([],{clearSelection:true});v.vizSelection(s.map(_.toVizCSCtx),{selectionMode:this.getSelectionMode()});}return this;};x.prototype.addSelectedSeries=function(s){if(this.getSelectionMode()!==w.None){var v=this._getVizFrame(),d=this.getSelectionBehavior().toUpperCase();if(!v||d!=="SERIES"){return this;}v.vizSelection(s.map(_.toVizCSCtx),{selectionMode:w.Multi});}return this;};x.prototype.removeSelectedSeries=function(s){if(this.getSelectionMode()!==w.None){var v=this._getVizFrame(),d=this.getSelectionBehavior().toUpperCase();if(!v||d!=="SERIES"){return this;}v.vizSelection(s.map(_.toVizCSCtx),{deselection:true});}return this;};x.prototype.getSelectedSeries=function(){var v=this._getVizFrame(),s=this.getSelectionBehavior().toUpperCase();if(!v||s!=="SERIES"){return{count:0,series:[]};}else{var d=v.vizSelection();return{count:d.length,series:(d.series||[]).map(_.fromVizCSCtx)};}};x.prototype.drillDown=function(d){if(d&&!(d instanceof Array)){d=[d];}var e=this._normalizeDorM(d,true);if(e.length===0){return;}if(!this._checkDrilldownValid(e)){jQuery.sap.log.warning("Drill down not possible for "+e+". Already drilled down.");return;}var s=this._getDrillStateTop(),m=this._redundantsFromSelection(),i=this._deriveFilterFromSelection();var n;if(i){n=!(s&&s.filter)?i:new o([i,s.filter],true);}this._drillStateStack.push({dimensions:s.dimensions.slice().concat(e.map(function(k){return k.getName();})).filter(function(k){return!m[k];}),measures:s.measures.filter(function(k){return!m.measureNames[k];}),filter:n,redundant:m});var j=e.map(function(k){return k.getName();});this.fireDrilledDown({dimensions:j});this._invalidateBy({source:this,keys:{binding:true,vizFrame:true}});};x.prototype.drillUp=function(i){if(arguments.length===0){i=this._drillStateStack.length-2;}var n=this._drillStateStack[i];if(n&&i!=this._drillStateStack.length-1){var p=this._drillStateStack.pop();this._drillStateStack.splice(i+1);this.fireDrilledUp({dimensions:p.dimensions.filter(function(d){return n.dimensions.indexOf(d)===-1;})});this._invalidateBy({source:this,keys:{binding:true,vizFrame:true}});}};x.prototype.getDrillStack=function(){return jQuery.map(this._drillStateStack||[],function(s,i){return{dimension:s.dimensions.slice(),measure:s.measures.slice(),filter:s.filter};});};x.prototype.setUiConfig=function(U){this.setProperty("uiConfig",U);if(this._getVizFrame()){this._getVizFrame().setUiConfig(U);}};var z=(function(){var d=["interaction.selectability.mode","interaction.selectability.behavior"];function e(i,p){var j=i,v;v=p.reduce(function(m,n){if(j.hasOwnProperty(n)){m.push({parent:j,val:j[n],key:n});j=j[n];}return m;},[]);if(v.length!==p.length){return;}var k=v.pop();delete k.parent[k.key];while(v.length>0){k=v.pop();if(Object.keys(k.val).length>0){return;}else{delete k.parent[k.key];}}}function s(v,i){var j=jQuery.extend(true,{},v);d.forEach(function(p){delete j[p];e(j,p.split("."));});return j;}return{sanitize:s,modify:function(p,k,i){var P=k.split("."),n=p;while(P.length>1&&n.hasOwnProperty(P[0])){n=n[P.shift()];}var j=P[0];if(P.length===1&&n.hasOwnProperty(j)){n[j]=i(n[j]);}}};})();x.prototype.setVizProperties=function(v){v=z.sanitize(v);this.setProperty("vizProperties",v);if(this._getVizFrame()){this._getVizFrame().setVizProperties(this._getEffectiveProperties());}};x.prototype.getVizProperties=function(){var d=this._getVizFrame();var e=z.sanitize(d?d.getVizProperties():this.getProperty("vizProperties"));function s(i){var j=sap.viz.api.env.Format.numericFormatter();if(!j||jQuery.type(j.stripUnit)!=="function"){return i;}if(jQuery.type(i)==="string"){return j.stripUnit(i);}else if(jQuery.type(i)==="object"){jQuery.each(i,function(k,v){i[k]=j.stripUnit(v);});return i;}else{return i;}}z.modify(e,"plotArea.dataLabel.formatString",s);z.modify(e,"tooltip.formatString",s);return e;};x.prototype.setVizScales=function(v){this.setProperty("vizScales",v);if(this._getVizFrame()){this._getVizFrame().setVizScales(v);}};x.prototype.getVizScales=function(){var v=this._getVizFrame();return v?v.getVizScales():this.getProperty("vizScales");};x.prototype.getVizUid=function(){return this._getVizFrame().getVizUid();};x.prototype.zoom=function(d){this._getVizFrame().zoom(d);};var A=["selectData","deselectData"];x.prototype._delegateEvents=function(){if(this._delegateEventHandlers){return;}var v=this._getVizFrame();this._delegateEventHandlers=A.map(function(e){var n=e.charAt(0).toUpperCase()+e.slice(1);var d=function(i){var p=i.getParameters();delete p.id;this.fireEvent(e,p);};d=d.bind(this);v["attach"+n](null,d);return{name:n,handler:d};},this);this._vizFrameRenderCompleteHandler=J.bind(this);v.attachRenderComplete(null,this._vizFrameRenderCompleteHandler);v.attachEvent("_scroll",I.bind(this));};x.getChartTypes=sap.chart.api.getChartTypes;x.prototype.getAvailableChartTypes=function(){var d=this._getVisibleDimensions(true),m=this._getVisibleMeasures(true);return C.CONFIG.chartTypes.reduce(function(e,s){var i=R.compatible(s,d,m);if(i.compatible){e.available.push({chart:s});}else{var j={};if(i.error.missing.dim){j.Dimension=i.error.missing.dim;}if(i.error.missing.time){j.DateTimeDimension=i.error.missing.time;}if(i.error.missing.msr){j.Measure=i.error.missing.msr;}e.unavailable.push({chart:s,error:j});}return e;},{available:[],unavailable:[]});};x.prototype._getEffectiveProperties=function(){var d=this.getBinding("data");var v={};if(this._bNeedToApplyDefaultProperties){v=jQuery.extend(true,v,this._getDefaultVizProperties());this._bNeedToApplyDefaultProperties=false;}v=jQuery.extend(true,v,this.getProperty("vizProperties"),this._getHostedVizProperties(),this._getPagingVizProperties());if(this.getIsAnalytical()&&d!==undefined&&d.getTotalSize()!==-1){var e=this.getVisibleDimensions();if(v.plotArea&&v.plotArea.dataPointStyle&&v.plotArea.dataPointStyle.rules){var j=v.plotArea.dataPointStyle.rules;var m=j.length;for(var i=0;i<m;i++){var n=j[i].dataContext;var p=Object.keys(n);if(j[i].displayName===undefined&&p.length===1){var s=p[0];if(n[s].hasOwnProperty("equal")&&e.indexOf(s)!==-1){var K=d.getTotalSize();var L=this.getDimensionByName(s).getTextProperty();var N;for(var k=0;k<K;k++){N=d.getContextByIndex(k).getProperty();if(N[s]===n[s].equal){if(N[L]===null||N[L]===undefined||this.getDimensionByName(s).getDisplayText()===false){j[i].displayName=n[s].equal;break;}else{j[i].displayName=N[L];break;}}}}}}}}return v;};x.prototype._hostedVizProperties={selectionMode:{prop:"interaction.selectability.mode"},selectionBehavior:{prop:"interaction.selectability.behavior"}};x.prototype._getHostedVizProperties=function(){return Object.keys(this._hostedVizProperties).reduce(function(d,p){var s=this._hostedVizProperties[p].prop.split(".").reverse().reduce(function(d,e){var i={};i[e]=d;return i;},this.getProperty(p));return jQuery.extend(true,d,s);}.bind(this),{});};var E="__UI5__ShortIntegerMaxFraction10";var G="__UI5__FloatMaxFraction2";var H="__UI5__ShortIntegerMaxFraction2";x.prototype._getDefaultVizProperties=function(){var d='info/'+(this._sAdapteredChartType||this.getChartType());var i=(d.indexOf("info/100_")===0);var j=(d==="info/pie"||d==="info/donut");var k={interaction:{extraEventInfo:true}};return jQuery.extend(true,k,n({},d,["valueAxis.label.formatString","valueAxis2.label.formatString"],i?'':E),n({},d,["legend.formatString","sizeLegend.formatString"],H),n({},d,["plotArea.dataLabel.formatString"],j?'':H),n({},d,["tooltip.formatString"],i?'':G));function s(e,v,K){if(v.length===0){return K;}e=e||{};var p=e[v[0]];e[v[0]]=s(p,v.slice(1),K);return e;}function m(p,v){if(p==null||v.legnth===0){return p;}var e=p[v[0]];if(e&&e.children){return m(e.children,v.slice(1));}return e;}function n(e,v,K,L){var N=sap.viz.api.metadata.Viz.get(v);if(N){var P=N.properties;K.forEach(function(Q){Q=Q.split(".");var p=m(P,Q);if(p&&p.hasOwnProperty("defaultValue")){s(e,Q,L);}});}return e;}};x.prototype._getPagingVizProperties=function(){if(this._isEnablePaging()){var p={interaction:{zoom:{enablement:false},selectability:{mode:"NONE"}},plotArea:{isFixedDataPointSize:true}};return p;}else{return{};}};x.prototype.setSelectionMode=C.hostVizPropertySetter("selectionMode","interaction.selectability.mode",{convert:function(s){return s?s.toUpperCase():s;},validate:function(s){return[w.Multi,w.Single,w.None].indexOf(s)!==-1&&!this.getEnablePagination();}});x.prototype.getSelectionMode=C.hostVizPropertyGetter("selectionMode","interaction.selectability.mode");x.prototype.setSelectionBehavior=C.hostVizPropertySetter("selectionBehavior","interaction.selectability.behavior",{convert:function(s){return s?s.toUpperCase():s;},validate:function(s){return["DATAPOINT","CATEGORY","SERIES"].indexOf(s)!==-1;}});x.prototype.getSelectionBehavior=C.hostVizPropertyGetter("selectionBehavior","interaction.selectability.behavior");x.prototype.getDimensionByName=function(n){return this.getDimensions().filter(function(d){return d.getName()===n;})[0];};x.prototype.getMeasureByName=function(n){return this.getMeasures().filter(function(m){return m.getName()===n;})[0];};x.prototype.getTimeDimensions=function(){return this.getDimensions().filter(function(d){return d instanceof T;});};function I(e){if(this._isEnablePaging()&&this._bNeedPaging){var d=e.getParameters().position;this._updatePage(d);}}x.prototype._isEnablePaging=function(){this._bMobile=sap.ui.Device.system.tablet||sap.ui.Device.system.phone;var d=this.getEnablePagination()&&this._bIsPagingChartType&&!this._bMobile;return d;};x.prototype._updatePage=function(d){var v=this._getVizFrame();var i=Math.floor(this._iTotalSize*d/this._iPageSize);i=Math.min(i,this._iMaxPageNo);this._iOffset=null;var s=Math.max((i-1)*this._iPageSize,0);var L,e;if(i===0){L=this._iPageSize;e=this._iPageSize;}else if(i===this._iMaxPageNo){L=this._iPageSize*2+this._iRemainingRecords;e=this._iPageSize+this._iRemainingRecords;}else{L=this._iPageSize*2;e=this._iPageSize;}this._iOffset=(this._iTotalSize*d-i*this._iPageSize)/e;var j=this._getDataset();if(j.getRenderedPageNo()===i){var k={plot:{transform:{translate:{translateByPage:{context:this._middleCtx,offset:this._iOffset}}}}};v._states(k);this._showLoading(false);}else{if(this._pagingTimer){jQuery.sap.clearDelayedCall(this._pagingTimer);}this._pagingTimer=jQuery.sap.delayedCall(50,this,function(){var m=this.getBinding("data").getContexts(s,L);var n=m.some(function(K){return K===undefined;});if(n){j.suppressInvalidate();}else{var p={bEnabled:true,iStartIndex:s,iLength:L,sMode:"update",thumbRatio:null,iPageNo:i};j.setPagingOption(p);j.updateData();v.invalidate();this._oColorTracker.add(this._getVizFrame()._runtimeScales());this._getVizFrame()._runtimeScales(this._oColorTracker.get(),true);}});this._sLoadingTimer=this._sLoadingTimer||jQuery.sap.delayedCall(200,this,function(){this._showLoading(true);});}};function J(e){var p=e.getParameters();delete p.id;if(this._isEnablePaging()&&this._bNeedPaging){if(this._sLoadingTimer){jQuery.sap.clearDelayedCall(this._sLoadingTimer);this._sLoadingTimer=null;}var v=this._getVizFrame();var d=this.getBinding("data");var i=this._getDataset();var j=i.getRenderedPageNo();if(j!==0){var m=j*this._iPageSize-1;this._middleCtx=d.getContexts(m,1)[0].getObject();}else{this._middleCtx=null;}if(this._middleCtx||this._iOffset){var k={plot:{transform:{translate:{translateByPage:{context:this._middleCtx,offset:this._iOffset}}}}};v._states(k);}this._showLoading(false);}this.fireEvent("renderComplete",p);}x.prototype._showLoading=function(L){var $=this.$();if(!$){return;}if(!L){if(this._$loadingIndicator){this._$loadingIndicator.remove();}}else{if(!this._$loadingIndicator){this._$loadingIndicator=this._createLoadingIndicator();}this._updateLoadingIndicator();$.append(this._$loadingIndicator);}this._bLoading=L;};x.prototype._createLoadingIndicator=function(){var $=jQuery(sap.ui.core.BusyIndicatorUtils.getElement());var d=jQuery("<p>").attr("class","loading-text").text("Loading");d.css({"position":"absolute","transform":"translateY(-3em)","width":"100%","text-align":"center"});d.insertBefore($.children()[0]);$.css({opacity:1});return $;};x.prototype._updateLoadingIndicator=function(){var $=this.$();if(!$||!this._$loadingIndicator){return;}var s=this._sAdapteredChartType,d=s==="bar"||s.indexOf("horizontal")!==-1;var e=$.find(".v-plot-bound"),i=$.offset(),p={top:i.top,left:i.left,width:$.width(),height:$.height()};if(e.length){var P=e.offset(),j=e[0].getBoundingClientRect();p.top=P.top-1;p.left=P.left;p.width=j.width+1;if(d){p.height=Math.ceil(j.height+1);}else{p.height=Math.floor(j.height+1);}}this._$loadingIndicator.css(p);var k=this._$loadingIndicator.find(".loading-text");k.css({"top":p.height/2,"font-weight":sap.ui.core.theming.Parameters.get("sapUiChartTitleFontWeight"),"font-size":sap.ui.core.theming.Parameters.get("sapUiChartMainTitleFontSize"),"color":sap.ui.core.theming.Parameters.get("sapUiChartMainTitleFontSize")});this._$loadingIndicator.css({"background-color":sap.ui.core.theming.Parameters.get("sapUiExtraLightBG")});};x.prototype._getRequiredDimensions=function(){var v=this._getVisibleDimensions(),i=this._getInResultFields();return this._normalizeDorM(v.concat(i),true);};x.prototype._getRequiredMeasures=function(){return this._getVisibleMeasures(true);};x.prototype._queryMinMax=function(d){var e=this._getRequiredDimensions().map(function(v){return v.getName();}),m=this._getRequiredMeasures().map(function(v){return v.getName();});var i=m.reduce(function(i,v){i[v]={min:{},max:{}};return i;},{});function j(){var v=m.every(function(K){return i[K].min.requested&&i[K].max.requested;});if(v){d(i);}}function k(v,K,L){i[v][K].requested=true;i[v][K].value=parseFloat(L&&L.results[0][v]);j();}function n(v,K,L){i[v][K].requested=true;i[v][K].error=L;j();}var Q=m.reduce(function(Q,v){return Q.concat({urlParameters:{"$select":e.concat(v).join(","),"$top":1,"$orderby":v+" asc"},success:k.bind(null,v,"min"),error:n.bind(null,v,"min")},{urlParameters:{"$select":e.concat(v).join(","),"$top":1,"$orderby":v+" desc"},success:k.bind(null,v,"max"),error:n.bind(null,v,"max")});},[]);var p=this.getBinding("data"),P=p.getPath(),s=p.getModel();Q.forEach(function(v){s.read(P,v);});return Q;};x.prototype._measureRangeReceivedHandler=function(Q){var m={};jQuery.each(Q,function(s,d){m[s]={min:d.min.value,max:d.max.value};});this._mMeasureRange=m;var v=this._getVizFrame();v._pendingDataRequest(false);this._invalidateBy({source:this,keys:{vizFrame:true}});this.setBusy(false);};x.prototype.exportToSVGString=function(d){var s="<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"100%\" height=\"100%\"/>",v=this._getVizFrame();if(v){s=v.exportToSVGString(d);}return s;};return x;});
