/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

(c) Copyright 2009-2016 SAP SE. All rights reserved
 */
sap.ui.define(['sap/viz/ui5/data/DimensionDefinition','sap/viz/ui5/data/MeasureDefinition','sap/viz/ui5/controls/common/feeds/FeedItem','sap/viz/ui5/controls/common/feeds/AnalysisObject','sap/chart/TimeUnitType','sap/chart/utils/DateFormatUtil','sap/chart/utils/ChartUtils','sap/chart/utils/RoleMapper'],function(D,M,F,A,T,c,C,R){"use strict";var s=function(){return sap.viz.vizservices.BVRService.suggestFeeds.apply(null,arguments);};var d=function(a,f){var r=sap.viz.vizservices.FeedService.validate(a,f);if(!r.valid){var b=r.results?r.results.bindings:null;if(b&&Object.keys(b).every(function(i){return b[i].allowMND&&(!b[i].missing||b[i].missing===1)&&!b[i].incorrect;})){return{valid:true};}}return r;};var _=[{"types":"*","toViz":{"category|category2":"categoryAxis","series":"color","axis1|axis2|axis3|axis4":"valueAxis"}},{"types":"column|bar|stacked_bar|stacked_column|line|combination|100_stacked_bar|100_stacked_column|stacked_combination|horizontal_stacked_combination","toViz":{}},{"types":"scatter|bubble|time_bubble|timeseries_scatter|timeseries_bubble","toViz":{"series":"series","category|category2":"@context","axis1":"valueAxis","axis2":"valueAxis2"}},{"types":"bubble|time_bubble","toViz":{"axis3":"bubbleWidth"}},{"types":"pie|donut","toViz":{"category|series|category2":"color","axis1|axis2|axis3|axis4":"size"}},{"types":"bullet|vertical_bullet","toViz":{"axis1":"actualValues","axis2":"targetValues","axis3":"forecastValues","axis4":"additionalValues"}},{"types":"dual_combination|dual_horizontal_combination|dual_stacked_bar|100_dual_stacked_bar|dual_stacked_column|100_dual_stacked_column|dual_bar|dual_column|dual_line|dual_stacked_combination|dual_horizontal_stacked_combination","toViz":{"axis1":"valueAxis","axis2|axis3|axis4":"valueAxis2"}},{"types":"timeseries_line","toViz":{"category":"timeAxis","axis1|axis2|axis3":"valueAxis"}},{"types":"timeseries_scatter","toViz":{"category":R.TimeCategory,"axis2|axis3":false}},{"types":"timeseries_bubble","toViz":{"category":R.TimeCategory,"axis2":false,"axis3":"bubbleWidth"}},{"types":"timeseries_column","toViz":{"category":"timeAxis","series":"timeAxis","axis1|axis2|axis3|axis4":"valueAxis"}},{"types":"timeseries_combination","toViz":{"category":"timeAxis","axis1|axis2|axis3|axis4":"valueAxis"}},{"types":"dual_timeseries_combination","toViz":{"category":"timeAxis","axis1":"valueAxis","axis2|axis3|axis4":"valueAxis2"}},{"types":"heatmap","toViz":{"category":"categoryAxis","category2|series":"categoryAxis2","axis1|axis2|axis3|axis4":"color"}},{"types":"waterfall","toViz":{"series":"waterfallType","axis1|axis2|axis3|axis4":"valueAxis"}},{"types":"horizontal_waterfall","toViz":{"series":"waterfallType","axis1|axis2|axis3|axis4":"valueAxis"}}].reduce(function(m,a){var b=Object.keys(a.toViz).reduce(function(b,f){f.split("|").forEach(function(r){b[r]=a.toViz[f];return b;});return b;},{});a.types.split("|").forEach(function(f){if(!m.hasOwnProperty(f)){m[f]=[];}m[f].push(b);});return m;},{});var e=Object.keys(_).reduce(function(m,a){if(a!=="*"){m[a]=jQuery.extend.apply(null,[true,{}].concat(_["*"].concat(_[a])));}return m;},{});function g(a,k,v){var b=(typeof k==="function")?k:function(o){return o[k];};return a.reduce(function(o,f){var i=b(f),m=(typeof v==="function")?v(f):f;if(i&&!o[i]){o[i]=[m];}else if(i){o[i].push(m);}return o;},{});}function h(a,k){return a.reduce(function(m,b,i){m[k(b)]=i;return m;},{});}function j(m,a){var b=Object.keys(m).reduce(function(b,r){if(typeof m[r]==="function"){b[r]=new m[r]();}else{b[r]=new R(m[r]);}return b;},{});return g(a,function(o){return b[o.getRole()].toFeedingId(o);});}var L={from:F.fromLightWeightFmt,build:function(o){var a=[];jQuery.each(o.dims,function(k,v){a.push({id:k,type:"Dimension",values:v.map(l("Dimension"))});});jQuery.each(o.msrs,function(k,v){a.push({id:k,type:"Measure",values:v.map(l("Measure"))});});return a;}};function l(a){return function(o){var i=o.getName();if(i==="MND"){return{id:"MND",type:"MND"};}var b={id:i,name:i,type:a};if(o instanceof sap.chart.data.TimeDimension){b.dataType="Date";}return b;};}function w(o,a){var n=o.getName(),b=o.getLabel(),f=o.getTextProperty(),i=o.getTextFormatter(),k=o.getDisplayText();var m={identity:n,name:b||n,value:"{"+n+"}"};if(typeof i==="function"){m.displayValue={formatter:i,parts:[{path:n,type:new sap.ui.model.type.String()}]};if(f){m.displayValue.parts.push({path:f,type:new sap.ui.model.type.String()});}}else if(k&&f){m.displayValue="{"+f+"}";}var r=new D(m);if(C.CONFIG.timeChartTypes.indexOf(a)>-1&&o instanceof sap.chart.data.TimeDimension){var v=c.getInstance(o.getTimeUnit());var P=v?v.parse.bind(v):undefined;r.getBindingInfo("value").formatter=P;r.setDataType("Date");}return r;}function p(m){var n=m.getName();var o=new M({identity:n,name:m.getLabel()||n,value:"{"+n+"}"});o.setUnit(m.getUnitBinding());return o;}function q(a,f){var m=sap.viz.api.metadata.Viz.get("info/"+a),b=g(m.bindings,"role"),i=g(f,"id"),k=b["layout.category"]||[],S=b["mark.color"]||[];if(k.length===0){return[];}else{var o=[];jQuery.each(k.concat(S),function(n,r){var v=i[r.id];if(v&&v.length>0){jQuery.each(v[0].values,function(H,V){o.push(V.id);});}});return o;}}function t(a,b,m,S){var r=e[a];var o={dims:j(r,b),msrs:j(r,m)};var f=null;if(o.dims.series){o.dims[S]=o.dims.series;delete o.dims.series;}if(o.dims["@context"]){f=o.dims["@context"];delete o.dims["@context"];}var i=L.build(o);i.contexts=f;return i;}var I=[{chartTypes:"bar,column,line,combination,heatmap,bullet,vertical_bullet,stacked_bar,stacked_column,stacked_combination,horizontal_stacked_combination,dual_bar,dual_column,dual_line,dual_stacked_bar,dual_stacked_column,dual_combination,dual_horizontal_combination,dual_stacked_combination,dual_horizontal_stacked_combination,100_stacked_bar,100_stacked_column,100_dual_stacked_bar,100_dual_stacked_column,waterfall,horizontal_waterfall".split(","),feed:"categoryAxis"},{chartTypes:"donut,pie,scatter,bubble".split(","),feed:"color"}];function u(a,f,b){var i,k;for(i=0;i<I.length;i++){if(I[i].chartTypes.indexOf(a)!==-1){k=I[i].feed;break;}}var H=f.some(function(o){return o.id===k;});if(!H){var m=s("info/"+a,f,[{id:"MND",type:"MND"}]).feedItems;f.splice(0,f.length);m.forEach(function(o){if(o.values.length>0){f.push(o);}});f=z(a,f);}for(i=0;i<f.length;i++){if(f[i].id===k&&f[i].type==="Dimension"){f[i].values=f[i].values.concat(b.map(function(o){return{id:o.getName(),name:o.getName(),type:"Dimension"};}));}}return d("info/"+a,f);}function x(a,b,m,i,S){var k=t(a,b,m,S);var n=k.contexts;var V=d("info/"+a,k);if(!V.valid){k=B(a,V,k,b,m);V=d("info/"+a,k);}if(V.valid&&i&&i.length>0){var r=g(b,function(o){return o.getName();});u(a,k,i.filter(function(o){return!r[o.getName()];}));}var H=k.reduce(function(o,f){f.values.forEach(function(v){o[v.id]=true;});return o;},{});var J=L.from(k);if(n){n.forEach(function(f){H[f.getName()]=true;});J._context=n.map(function(f){return f.getName();});}J._unused=E(k,b,m).filter(function(f){return!H[f];});J._def=G(b,V.valid?i:[],m,H,a);J._order=q(a,k);J._valid=V.valid;return J;}function y(a){return g(sap.viz.api.metadata.Viz.get("info/"+a).bindings,"id");}function z(a,f,b){b=b||y(a);f.forEach(function(o){o.type=b[o.id][0].type;});return f;}function B(f,V,i,m,n){var r=y(f),H=false,J=false;var K=V.results.bindings;Object.keys(K).forEach(function(k){if(!r[k]){return;}if(r[k][0].type==="Measure"){J=true;}if(r[k][0].type==="Dimension"&&!(K[k].allowMND&&(!K[k].missing||K[k].missing===1))){H=true;}});var N=i.filter(function(a){return!((a.type==="Dimension")?H:J);}),O=N.reduce(function(a,b){(b.values||[]).forEach(function(v){a[v.id]=true;});return a;},{});if(i.contexts){i.contexts.forEach(function(a){O[a.getName()]=true;});}var P=m.map(l("Dimension")),Q=n.map(l("Measure")),S=h(m,function(o){return o.getName();}),U=h(n,function(o){return o.getName();});P.sort(function(a,b){return S[a.id]-S[b.id];});Q.sort(function(a,b){return U[a.id]-U[b.id];});var W=s("info/"+f,N,P.concat(Q).filter(function(a){return!O[a.id];})).feedItems;z(f,W,r);return W;}function E(a,b,m){var U=a.reduce(function(i,f){f.values.forEach(function(v){i[v.id]=true;});return i;},{});return b.concat(m).filter(function(n){return!U[n.getName()];}).map(function(n){return n.getName();});}function G(a,i,m,v,b){return{dim:a.reduce(function(V,o){if(v[o.getName()]){V.push(w(o,b));}return V;},[]).concat(i.map(function(o){var f=w(o);f.setInResult(true);return f;})),msr:m.reduce(function(V,o){if(v[o.getName()]){V.push(p(o));}return V;},[])};}return{fit:x,compatible:function(a,b,m){var i="info/"+a,f={used:{},error:null,compatible:true};var n=t(a,b,m,"color"),V=d(i,n);if(!V.valid){n=B(a,V,n,b,m);V=d(i,n);f.needFix=true;}if(V.valid){f.used=g(n,function(o){return o.type;},function(o){return o.values.filter(function(v){return v.type==="Dimension"||v.type==="Measure";}).map(function(v){return v.id;});});jQuery.each(f.used,function(k,v){f.used[k]=v.reduce(function(o,N){return o.concat(N);},[]);});}else{f.compatible=false;var r=sap.viz.api.metadata.Viz.get(i).bindings,H=g(r,"type",function(o){return o.id;}),J={dim:0,msr:0,time:0};jQuery.each(V.results.bindings,function(k,v){if(!v.missing){return;}if(H.Dimension.indexOf(k)!==-1&&!(v.allowMND&&v.missing===1)){J[k==="timeAxis"?"time":"dim"]+=v.missing;}else if(H.Measure.indexOf(k)!==-1){J.msr+=v.missing;}});f.error={missing:J};}return f;}};});
