/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

		(c) Copyright 2009-2015 SAP SE. All rights reserved
	
 */
sap.ui.define(["jquery.sap.global","sap/ui/Device","sap/gantt/GanttChartBase","sap/ui/core/Core","sap/ui/table/TreeTable","sap/ui/table/Row","sap/gantt/misc/Utility","sap/ui/core/theming/Parameters","sap/gantt/shape/SelectedShape","sap/gantt/shape/ext/rls/SelectedRelationship","sap/gantt/drawer/ShapeInRow","sap/gantt/drawer/ShapeCrossRow","sap/gantt/drawer/CursorLine","sap/gantt/drawer/NowLine","sap/gantt/drawer/VerticalLine","sap/gantt/drawer/CalendarPattern","sap/gantt/drawer/ExpandedBackground","sap/gantt/misc/AxisTime","sap/gantt/misc/AxisOrdinal","sap/gantt/misc/Format","sap/ui/thirdparty/d3"],function(q,D,G,C,T,R,U,P,S,a,b,c,e,N,V,f,E,A,h,F){"use strict";var m=G.extend("sap.gantt.GanttChart",{metadata:{aggregations:{_treeTable:{type:"sap.ui.table.TreeTable",multiple:false,visibility:"hidden"}}}});m.prototype.init=function(){G.prototype.init.apply(this,arguments);q.sap.measure.start("GanttChart init","GanttPerf:GanttChart init function");this._oTT=new T(this.getId()+"-table",{visibleRowCountMode:"Auto",minAutoRowCount:1,selectionBehavior:sap.ui.table.SelectionBehavior.RowOnly,selectionMode:sap.ui.table.SelectionMode.MultiToggle,columnHeaderVisible:false});this._oRowStatusMap={};this._oTT._bVariableRowHeightEnabled=true;var t=this;this._oTT._collectRowHeights=function(){t._aHeights=T.prototype._collectRowHeights.apply(this);if(t._aHeights[0]!==undefined&&t._aHeights[0]!==0){t._iInferedBaseRowHeightOnTT=t._aHeights[0];}var B=t.getBaseRowHeight();var d=this.getFirstVisibleRow();var M=B;var s=t._getDrawingData([0,0]);if(s&&s.length>0){M=s[0].rowSpan*B;}for(var i=0;i<t._aHeights.length;i++){var o=this.getContextByIndex(d+i);if(o){var g=o.getObject();var u=g?g.uid:undefined;if(u&&t._oRowStatusMap[u]){t._aHeights[i]=t._oRowStatusMap[u].visibleRowSpan*B;}else{t._aHeights[i]=M;}}else{t._aHeights[i]=B;}}return t._aHeights;};this._oTT.onvscroll=function(o){sap.ui.table.TreeTable.prototype.onvscroll.apply(this,arguments);t._onVSbScroll();};this._oColumn=new sap.ui.table.Column();this._oTT.addColumn(this._oColumn);this.setAggregation("_treeTable",this._oTT);this._oTT.attachEvent("_rowsUpdated",this._onTTRowUpdate.bind(this));this._oTT.attachRowSelectionChange(this._onRowSelectionChange,this);this._oTT.addEventDelegate({onAfterRendering:this._onTTHScrollAfterRendering},this);this._oTT.addEventDelegate({onAfterRendering:this._initialSvgDrawing},this);this._oShapeInRowDrawer=new b();this._oShapeCrossRowDrawer=new c();this._oCursorLineDrawer=new e();this._oCalendarPatternDrawer=new f();this._oExpandedBackgroundDrawer=new E();this._oAxisTime=undefined;this._oAxisOrdinal=undefined;this._aFilteredRowData=undefined;this._aShapeInstance=undefined;this._oShapeInstance=undefined;this._oZoom={base:{}};this._oDataNamePerType={};this._fLeftOffsetRate=0.0;this._oStatusSet=null;this._nLowerRange=0;this._nUpperRange=0;this._aSelectedRelationships=undefined;this._oSelectedShapes={};this._aSelectedShapeUids=undefined;this._aShapeIdsToBeSelected=[];this._bMouseDown=false;this._bDragging=false;this._bDragStart=false;this._oDraggingData=undefined;this._lastHoverRowIndex=undefined;this._oChartSchemesConfigMap={};this._oChartSchemesConfigMap[sap.gantt.config.DEFAULT_CHART_SCHEME_KEY]=sap.gantt.config.DEFAULT_CHART_SCHEME;this._oObjectTypesConfigMap={};this._oObjectTypesConfigMap[sap.gantt.config.DEFAULT_OBJECT_TYPE_KEY]=sap.gantt.config.DEFAULT_OBJECT_TYPE;this._fExtendFactor=0.382;this._calZoomFromTimeAxisConfig(sap.gantt.config.DEFAULT_TIME_AXIS);this._createAxisTime(sap.gantt.config.DEFAULT_TIME_AXIS);this._mTimeouts={};this._bCanApplyTableTransform=true;this._iFirstVisiableRowIndex=undefined;q.sap.measure.end("GanttChart init");};m.prototype.setTimeAxis=function(t){this.setProperty("timeAxis",t,true);this._createAxisTime(t);var l=this._oZoom;this._oZoom={base:{}};this._calZoomFromTimeAxisConfig(t);var z=this.getZoomInfo();if(z&&z.determinedByChartWidth){if(!l.determinedByChartWidth||!U.floatEqual(l.determinedByConfig.fRate,z.determinedByConfig.fRate)||!U.floatEqual(l.determinedByConfig.fMaxRate,z.determinedByConfig.fMaxRate)||!U.floatEqual(l.determinedByChartWidth.fMinRate,z.determinedByChartWidth.fMinRate)){this.fireEvent("_zoomInfoUpdated",{zoomInfo:z});}if(!l.determinedByConfig.fRate||!U.floatEqual(l.determinedByConfig.fRate,z.determinedByConfig.fRate)){this.setTimeZoomRate(z.determinedByConfig.fRate);}}this._oStatusSet=null;this._draw(true);return this;};m.prototype.setLocale=function(l){this.setProperty("locale",l,true);this._oAxisTime.setLocale(l);this._updateLocaleInShapeInstances();this._draw(true);return this;};m.prototype.setChartSchemes=function(d){this.setProperty("chartSchemes",d,true);this._oChartSchemesConfigMap={};if(d){for(var i=0;i<d.length;i++){this._oChartSchemesConfigMap[d[i].getKey()]=d[i];}}this._draw(true);return this;};m.prototype.setObjectTypes=function(o){this.setProperty("objectTypes",o,true);this._oObjectTypesConfigMap={};if(o){for(var i=0;i<o.length;i++){this._oObjectTypesConfigMap[o[i].getKey()]=o[i];}}this._draw(true);return this;};m.prototype.setSelectionMode=function(s){this.setProperty("selectionMode",s,true);if(this._oTT){if(s==sap.gantt.SelectionMode.MultiWithKeyboard){this._oTT.setSelectionMode(sap.ui.table.SelectionMode.MultiToggle);}else if(s==sap.gantt.SelectionMode.Multiple){this._oTT.setSelectionMode(sap.ui.table.SelectionMode.MultiToggle);}else if(s==sap.gantt.SelectionMode.Single){this._oTT.setSelectionMode(sap.ui.table.SelectionMode.Single);}else{this._oTT.setSelectionMode(sap.ui.table.SelectionMode.None);}}return this;};m.prototype._calZoomFromTimeAxisConfig=function(t){if(!t){return;}this._oZoom.base.sGranularity=t.getGranularity();var g=t.getZoomStrategy()[this._oZoom.base.sGranularity];this._oZoom.determinedByConfig={fRate:t.getRate()};var o=t.getZoomStrategy()[t.getFinestGranularity()];var d=t.getZoomStrategy()[t.getCoarsestGranularity()];var s=d3.time.format("%Y%m%d%H%M%S").parse("20000101000000");var B=q.sap.getObject(g.innerInterval.unit).offset(s,g.innerInterval.span);this._oZoom.base.fScale=this._calZoomScale(s,B,g.innerInterval.range);var M=q.sap.getObject(o.innerInterval.unit).offset(s,o.innerInterval.span);var i=this._calZoomScale(s,M,o.innerInterval.range*4);var j=q.sap.getObject(d.innerInterval.unit).offset(s,d.innerInterval.span);var k=this._calZoomScale(s,j,d.innerInterval.range);this._oZoom.determinedByConfig.fMaxRate=this._oZoom.base.fScale/i;this._oZoom.determinedByConfig.fMinRate=this._oZoom.base.fScale/k;};m.prototype._calZoomScale=function(s,o,l){return(o.valueOf()-s.valueOf())/l;};m.prototype._createAxisTime=function(o){var s=o.getZoomStrategy();var H=d3.time.format("%Y%m%d%H%M%S").parse(o.getPlanHorizon().getStartTime());var d=d3.time.format("%Y%m%d%H%M%S").parse(o.getPlanHorizon().getEndTime());var n=d.valueOf()-H.valueOf();var g=s[o.getGranularity()];var i=q.sap.getObject(g.innerInterval.unit).offset(H,g.innerInterval.span).valueOf()-H.valueOf();this._oAxisTime=new A([H,d],[0,Math.ceil(n*g.innerInterval.range/i)],o.getRate(),null,null,this.getLocale(),o.getZoomStrategy());this._oZoom.determinedByConfig.fRate=o.getRate();this._nLowerRange=this._oAxisTime.getViewRange()[0];this._nUpperRange=Math.ceil(this._oAxisTime.getViewRange()[1]);};m.prototype.setShapes=function(s){this.setProperty("shapes",s,true);if(s&&s.length>0){this._oShapesConfigMap={};for(var i=0;i<s.length;i++){this._oShapesConfigMap[s[i].getKey()]=s[i];}this._parseAndSortShape(this._oShapesConfigMap);this._draw(true);}return this;};m.prototype._parseAndSortShape=function(s,t){var r=[];var d,o,g,l,p,n;for(var i in s){d=t?t:i;o={};if(s[i].getShapeClassName()){o=this._instantiateCustomerClass(s[i].getShapeClassName(),i,s[i],d);var u=o.getCategory(null,this._oAxisTime,this._oAxisOrdinal);if(!t){n=s[i].getSelectedClassName();if(!n){if(u==sap.gantt.shape.ShapeCategory.Relationship){n="sap.gantt.shape.ext.rls.SelectedRelationship";g=new a();}else{n="sap.gantt.shape.SelectedShape";}}g=this._instantiateCustomerClass(n,"selected"+i,s[i],d,true);o.setAggregation("selectedShape",g);}if(s[i].getGroupAggregation()&&s[i].getGroupAggregation()instanceof Array){l=this._parseAndSortShape(s[i].getGroupAggregation(),d);for(var k=0;k<l.length;k++){o.addShape(l[k]);}}else if(s[i].getClippathAggregation()&&s[i].getClippathAggregation()instanceof Array){p=this._parseAndSortShape(s[i].getClippathAggregation(),d);for(var j=0;j<p.length;j++){o.addPath(p[j]);}}}r.push(o);}if(t){return r;}else{r.sort(function(w,x){var y=q.isNumeric(w.mShapeConfig.getLevel())?w.mShapeConfig.getLevel():99;var z=q.isNumeric(x.mShapeConfig.getLevel())?x.mShapeConfig.getLevel():99;return z-y;});this._aShapeInstance=r;var v={};q.each(this._aShapeInstance,function(K,w){v[w.mShapeConfig.getKey()]=w;});this._oShapeInstance=v;}};m.prototype._instantiateCustomerClass=function(s,d,o,t,g){var i=q.sap.getObject(s);if(!i){q.sap.require(s);i=q.sap.getObject(s);}var j=new i();var k=t;if(k===undefined){k=d;}this._storeCustomerClassId(d,j.getId(),t,g);j.mLocaleConfig=this.getLocale();j.mShapeConfig=o;j.mChartInstance=this;return j;};m.prototype._updateLocaleInShapeInstances=function(){if(this._aShapeInstance){var l=this.getLocale();q.each(this._aShapeInstance,function(k,v){v.mLocaleConfig=l;});}};m.prototype._storeCustomerClassId=function(s,i,t,d){if(!this._customerClassIds){this._customerClassIds={};}if(this._oShapesConfigMap[s]){this._customerClassIds[s]={"classId":i,"topShapeId":t};}else{var g=t+"_"+s;this._customerClassIds[g]={"classId":i,"topShapeId":d?undefined:t};}};m.prototype._getIdByShapeId=function(s){if(this._customerClassIds&&this._customerClassIds[s]){return this._customerClassIds[s].classId;}return null;};m.prototype._getShapeIdById=function(s){if(this._customerClassIds){for(var d in this._customerClassIds){var o=this._customerClassIds[d];if(o.classId===s){return{"shapeId":d,"topShapeId":o.topShapeId};}}}return null;};m.prototype._genShapeConfig=function(s,p){var o={},d;if(s!==null&&s!==undefined){o.shapeId=s;}if(p.data){o.data=p.data;}if(p.level){o.level=p.level;}if(p.draw){d=p.draw;}else{d=p;}for(var i in d){if(i!=="class"){o[i]=d[i];}}return o;};m.prototype.getZoomInfo=function(){var t=this.getTimeAxis();var p=t.getPlanHorizon();var i=t.getInitHorizon();var d=q("#"+this.getId()+"-svg-ctn");if(!d){return null;}var n=d.width()-((C.getConfiguration().getRTL())?0:this._oTT.$(sap.ui.table.SharedDomRef.VerticalScrollBar).width());if(!n||n<=0){return null;}this._oZoom.determinedByChartWidth={};this._oZoom.determinedByChartWidth.fMinRate=this._oZoom.determinedByConfig.fMinRate;if(p){var M=this._calZoomScale(F.abapTimestampToDate(p.getStartTime()),F.abapTimestampToDate(p.getEndTime()),n);this._oZoom.determinedByChartWidth.fMinRate=this._oZoom.base.fScale/M;var g=(this._oZoom.determinedByChartWidth.fMinRate>this._oZoom.determinedByConfig.fMinRate)?this._oZoom.determinedByChartWidth.fMinRate:this._oZoom.determinedByConfig.fMinRate;this._oZoom.determinedByConfig.fRate=g>this._oZoom.determinedByConfig.fRate?g:this._oZoom.determinedByConfig.fRate;}if(i&&i.getStartTime()&&i.getEndTime()){var s=this._calZoomScale(F.abapTimestampToDate(i.getStartTime()),F.abapTimestampToDate(i.getEndTime()),n);this._oZoom.determinedByChartWidth.fSuitableRate=this._oZoom.base.fScale/s;this._oZoom.determinedByChartWidth.fSuitableRate=this._oZoom.determinedByChartWidth.fMinRate>this._oZoom.determinedByChartWidth.fSuitableRate?this._oZoom.determinedByChartWidth.fMinRate:this._oZoom.determinedByChartWidth.fSuitableRate;}this._oZoom.iChartWidth=n;return this._oZoom;};m.prototype.setTimeZoomRate=function(t){var M=(this._oZoom.determinedByChartWidth&&(this._oZoom.determinedByChartWidth.fMinRate>this._oZoom.determinedByConfig.fMinRate))?this._oZoom.determinedByChartWidth.fMinRate:this._oZoom.determinedByConfig.fMinRate;this._oZoom.determinedByConfig.fRate=M>t?M:t;this.setProperty("timeZoomRate",this._oZoom.determinedByConfig.fRate,true);this._oAxisTime.setZoomRate(this._oZoom.determinedByConfig.fRate);this._oAxisTime.setViewOffset(0);this._oStatusSet=null;this._nLowerRange=this._oAxisTime.getViewRange()[0];this._nUpperRange=Math.ceil(this._oAxisTime.getViewRange()[1]);this._draw(true);return this;};m.prototype.updateRelationships=function(r){var B=this.getBinding("relationships");if(B){var d=B.getContexts(0,0);if(d&&d.length>0){this._aRelationshipsContexts=d;}}this._prepareRelationshipDataFromModel();};m.prototype.addRelationship=function(r){q.sap.log.error("The control manages the relationships aggregation. The method \"addRelationship\" cannot be used programmatically!");};m.prototype.insertRelationship=function(i,r){q.sap.log.error("The control manages the relationships aggregation. The method \"insertRelationship\" cannot be used programmatically!");};m.prototype.removeRelationship=function(r){q.sap.log.error("The control manages the relationships aggregation. The method \"removeRelationship\" cannot be used programmatically!");};m.prototype.getRelationships=function(){q.sap.log.error("The control manages the relationships aggregation. The method \"getRelationships\" cannot be used programmatically!");};m.prototype.destroyRelationships=function(){q.sap.log.error("The control manages the relationships aggregation. The method \"destroyRelationships\" cannot be used programmatically!");};m.prototype.indexOfRelationship=function(r){q.sap.log.error("The control manages the relationships aggregation. The method \"indexOfRelationship\" cannot be used programmatically!");};m.prototype.removeAllRelationships=function(){q.sap.log.error("The control manages the relationships aggregation. The method \"removeAllRelationships\" cannot be used programmatically!");};m.prototype._bindAggregation=function(n,B){if(n=="rows"&&B){var M=this.getModel(B.model);var o=this.getBindingContext(B.model);if(o&&M){B.path=M.resolve(B.path,o);}this._oTT.bindRows(B);}else{return sap.ui.core.Control.prototype._bindAggregation.apply(this,arguments);}};m.prototype.onBeforeRendering=function(){this._bTableReady=false;this._iSvgHeight=0;this._detachEvents();};m.prototype._detachEvents=function(){var d=q("#"+this.getId()+"-svg-ctn");var g=q("#"+this.getId()+"-header");d.unbind("MozMousePixelScroll.sapUiTableMouseWheel",this._onMouseWheel);d.unbind("wheel.sapUiTableMouseWheel",this._onMouseWheel);d.unbind("mouseleave",this._onSvgMouseLeave);d.unbind("mouseenter",this._onSvgMouseEnter);d.unbind("mousedown",this._onSvgMouseDown);d.unbind("mousemove",this._onSvgMouseMove);d.unbind("mouseup",this._onSvgMouseUp);d.unbind("dblclick",this._onSvgDoubleClick);if(D.support.touch){d.unbind("touchstart",this._onSvgTouchstart);d.unbind("touchend",this._onSvgTouchend);d.unbind("touchmove",this._onSvgTouchmove);g.unbind("touchstart",this._onSvgTouchstart);g.unbind("touchend",this._onSvgTouchend);g.unbind("touchmove",this._onSvgTouchmove);}};m.prototype.onAfterRendering=function(){this._attachEvents();};m.prototype._attachEvents=function(){var d=q("#"+this.getId()+"-svg-ctn");var g=q("#"+this.getId()+"-header");if(D.browser.firefox){d.bind("MozMousePixelScroll.sapUiTableMouseWheel",this._onMouseWheel.bind(this));}else{d.bind("wheel.sapUiTableMouseWheel",this._onMouseWheel.bind(this));}d.bind("mouseenter",this._onSvgMouseEnter.bind(this));d.bind("mouseleave",this._onSvgMouseLeave.bind(this));d.bind("mousedown",this._onSvgMouseDown.bind(this));d.bind("mousemove",this._onSvgMouseMove.bind(this));d.bind("mouseup",this._onSvgMouseUp.bind(this));d.bind("dblclick",this._onSvgDoubleClick.bind(this));if(D.support.touch){d.bind("touchstart",this._onSvgTouchstart.bind(this));d.bind("touchend",this._onSvgTouchend.bind(this));d.bind("touchmove",this._onSvgTouchmove.bind(this));g.bind("touchstart",this._onSvgTouchstart.bind(this));g.bind("touchend",this._onSvgTouchend.bind(this));g.bind("touchmove",this._onSvgTouchmove.bind(this));}};m.prototype._getMouseOrTouchPoint=function(o){if(o.targetTouches&&o.targetTouches.length>0){return o.targetTouches[o.targetTouches.length-1];}else if(o.changedTouches&&o.changedTouches.length>0){return o.changedTouches[o.changedTouches.length-1];}return{"pageX":o.pageX,"pageY":o.pageY};};m.prototype._onTouchScrollStart=function(o){if(D.system.combi||D.system.phone||D.system.tablet){this._aTouchStartPosition=null;this._bIsScrollVertical=null;var t=this._getMouseOrTouchPoint(o);this._aTouchStartPosition=[t.pageX,t.pageY];var v=this._oTT.getDomRef(sap.ui.table.SharedDomRef.VerticalScrollBar);if(v){this._iTouchScrollTop=v.scrollTop;}var H=this._oTT.getDomRef(sap.ui.table.SharedDomRef.HorizontalScrollBar);if(H){this._iTouchScrollLeft=H.scrollLeft;}}};m.prototype._onTouchScroll=function(o){if((D.system.combi||D.system.phone||D.system.tablet)&&this._aTouchStartPosition){var t=this._getMouseOrTouchPoint(o);var d=(t.pageX-this._aTouchStartPosition[0]);var i=(t.pageY-this._aTouchStartPosition[1]);if(this._bIsScrollVertical==null){this._bIsScrollVertical=Math.abs(i)>Math.abs(d);}if(this._bIsScrollVertical){var v=sap.ui.table.SharedDomRef.VerticalScrollBar;var g=this._oTT.getDomRef(v);if(g){var s=this._iTouchScrollTop-i;if(s>0&&s<(this._oTT.getDomRef(v+"-content").clientHeight-g.clientHeight)-1){this._preventBubbleAndDefault(o);}g.scrollTop=s;}}else{var H=sap.ui.table.SharedDomRef.HorizontalScrollBar;var j=this._oTT.getDomRef(H);if(j){var k=this._iTouchScrollLeft-d;if(k>0&&k<(this._oTT.getDomRef(H+"-content").clientWidth-j.clientWidth)-1){this._preventBubbleAndDefault(o);}j.scrollLeft=k;}}this._bScrolling=true;}};m.prototype._onMouseWheel=function(o){var O=o.originalEvent;var i=O.shiftKey;var s=0;if(D.browser.firefox){s=O.detail;}else{if(i){if(D.browser.msie||D.browser.edge){s=O.deltaY;}else{s=O.deltaX;}}else{s=O.deltaY;}}if(i){var H=sap.ui.table.SharedDomRef.HorizontalScrollBar;var d=this._oTT.getDomRef(H);if(d){var g=d.scrollLeft+s;if(g>0&&g<(this._oTT.getDomRef(H+"-content").clientWidth-d.clientWidth)-1){this._preventBubbleAndDefault(o);}d.scrollLeft=g;}}else{var v=sap.ui.table.SharedDomRef.VerticalScrollBar;var j=this._oTT.getDomRef(v);if(j){var k=j.scrollTop+s;if(k>0&&k<(this._oTT.getDomRef(v+"-content").clientHeight-j.clientHeight)-1){this._preventBubbleAndDefault(o);}j.scrollTop=k;}}};m.prototype.handleExpandChartChange=function(d,g,s){s=s?s:this._oTT.getSelectedIndices();if(s.length>0){this._updateRowStatusMap(d,g,s);this._oTT.updateRows();}};m.prototype.invertRowExpandStatus=function(s,d){s=s?s:this._oTT.getSelectedIndices();if(s.length>0&&d){for(var i=0;i<s.length;i++){var I=s[i];var g=this._ifRowExpanded(I,d);if(g!==null){this._updateRowStatusMap(!g,d,[I]);}}this._oTT.updateRows();}};m.prototype._ifRowExpanded=function(i,d){var t=this._oTT;var B=t.getBinding();var o=B.getContextByIndex(i);var g=null;if(o){var j=o.getObject();var u=j.uid;var s=this._getRowSpanWithData(j,d),k=s.name;if(u&&this._oRowStatusMap[u]&&this._oRowStatusMap[u][k]){g=true;}else{g=false;}}return g;};m.prototype._updateRowStatusMap=function(d,g,j){var t=this._oTT;var B=t.getBinding();for(var i=0;i<j.length;i++){var I=j[i];var o=B.getContextByIndex(I);if(o){var k=o.getObject();var u=k.uid;if(u){var s=this._getRowSpanWithData(k,g),l=s.name;if(d){if(this._oRowStatusMap[u]){this._oRowStatusMap[u][l]=s;}else{this._oRowStatusMap[u]={};this._oRowStatusMap[u][l]=s;}}else if(!d&&this._oRowStatusMap[u]){delete this._oRowStatusMap[u][l];delete this._oRowStatusMap[u].visibleRowSpan;if(q.isEmptyObject(this._oRowStatusMap[u])){delete this._oRowStatusMap[u];continue;}}this._getDrawingData([I,I]);}}}};m.prototype.isRowExpanded=function(){var r=!q.isEmptyObject(this._oRowStatusMap);return r;};m.prototype._getRowSpanWithData=function(s,d){var r=1,g=null,i=null;for(var k=0;k<d.length;k++){var j=d[k];var M;if(this._oChartSchemesConfigMap[j]&&this._oChartSchemesConfigMap[j].getModeKey()){M=this._oChartSchemesConfigMap[j].getModeKey();}else{M=this.getMode();}if(this._oObjectTypesConfigMap[s.type]&&this._oObjectTypesConfigMap[s.type].getExpandedChartSchemeKeys().length>0){var v=this._oObjectTypesConfigMap[s.type].getExpandedChartSchemeKeys();if($.inArray(j,v)>-1){var o=this._collectDataNameForValidChartScheme(j,M);if(o){i=o.drawData;r+=o.rowSpan;g=j;}}}}return{rowSpan:r,name:g,data:i};};m.prototype._updateTableRowHeights=function(){if(this._aHeights){this._oTT._updateRowHeader(this._aHeights);}};m.prototype.notifySourceChange=function(){this._oTT.setFirstVisibleRow(0);this.resetRowStatusMap();};m.prototype.resetRowStatusMap=function(){this._oRowStatusMap={};};m.prototype._collectDataNameForValidChartScheme=function(s,M){if(this._oChartSchemesConfigMap[s]){var d=[],r;var g=this._oChartSchemesConfigMap[s].getShapeKeys();r=this._oChartSchemesConfigMap[s].getRowSpan();var t=this;q.each(g,function(k,v){if(t._oShapesConfigMap[v]){var i=t._oShapesConfigMap[v].getModeKeys();if((i&&i.length>0&&$.inArray(M,i)>-1)||i.length==0||M==sap.gantt.config.DEFAULT_MODE_KEY){d.push(t._oShapesConfigMap[v].getShapeDataName());}}});if(d.length>0&&r>=1){return{"drawData":d,"rowSpan":r};}}};m.prototype._composeParameterForClickPosition=function(d){var s=q("#"+this.getId()+"-svg");var o=this._getSvgCoodinateByDiv(s[0],d.pageX,d.pageY);var x=d.pageX-s.offset().left||d.offsetX;var y=d.pageY-s.offset().top||d.offsetY;if(!this._oAxisOrdinalOfVisibleRow){return null;}var g=this._oAxisTime.viewToTime(x);var l,L=this._oAxisOrdinalOfVisibleRow.viewToRowIndex(y,this._getVisibleRowCount())+this._oTT.getFirstVisibleRow();var i=this._oTT.getContextByIndex(L);if(i){l=this._getRowById(i.getObject()?i.getObject().id:null);}var j=false;var k=this._oAxisOrdinal.viewToElementIndex(y);var n=this._aFilteredRowData[k];if(n&&n.index&&n.index!==0){j=true;}var p={"startTime":g,"svgPoint":o,"leadingRowNum":L,"leadingRowInfo":l,"rowIndex":k,"rowInfo":n,"isExpandedRow":j};return p;};m.prototype.getAllRowData=function(){var B=this._oTT.getBinding("rows");return this._getDrawingData([0,B.getLength()-1]);};m.prototype.getAllSelections=function(){var s=this.getSelectedRows();var d=this.getSelectedShapes();var g=this.getSelectedRelationships();var i={"rows":s,"shapes":d,"relationships":g};return i;};m.prototype.getSelectedRows=function(){var s=[];var d=this._oTT.getSelectedIndices();var g=this.getAllRowData();var M=[];for(var i=0;i<g.length;i++){if(g[i]&&!g[i].parentId){M.push(g[i]);}}for(var j=0;j<d.length;j++){if(d[j]>-1&&d[j]<M.length&&M[d[j]]){s.push(M[d[j]]);}}return s;};m.prototype.getSelectedShapes=function(){this._setSelectedStatusFromData(this.getShapeDataNames(),this.getAllRowData());return this._oSelectedShapes;};m.prototype.getSelectedRelationships=function(){return this._aSelectedRelationships;};m.prototype.getRowByShapeUid=function(s){return this._getRowByShapeUid(s);};m.prototype.selectShapes=function(I,d){if(!this._aFilteredRowData||!this._aFilteredRowData.length>0){if(d){this._aShapeIdsToBeSelected=[];}this._aShapeIdsToBeSelected=this._aShapeIdsToBeSelected.concat(I);}var i,j,s,o;if(this._aSelectedShapeUids===undefined){this._aSelectedShapeUids=[];}if(!I||I.length<1){this._oSelectedShapes={};this._aSelectedShapeUids=[];}else if(d){this._oSelectedShapes={};this._aSelectedShapeUids=[];for(i=0;i<I.length;i++){s=this._getShapeDataById(I[i],false);for(j=0;j<s.length;j++){o=s[j];if(this._judgeEnableSelection(o)){this._selectShape(o);}}}}else{for(i=0;i<I.length;i++){s=this._getShapeDataById(I[i],false);for(j=0;j<s.length;j++){o=s[j];if(q.inArray(o.uid,this._aSelectedShapeUids)>-1){continue;}else if(this._judgeEnableSelection(o)){this._selectShape(o);}}}}this._drawSelectedShapes();return this;};m.prototype.deselectShapes=function(I){if(!I||I.length<1){this._oSelectedShapes={};this._aSelectedShapeUids=[];this._drawSelectedShapes();return this;}for(var i=0;i<I.length;i++){var s=this._getShapeDataById(I[i]);for(var j=0;j<s.length;j++){this._deselectShape(s[j]);}}this._drawSelectedShapes();return this;};m.prototype.selectRowsAndShapes=function(I,d){if(!I||I.length<1){this.deselectShapes();this.deselectRows();return this;}this.selectRows(I,d);if(d){this._oSelectedShapes={};this._aSelectedShapeUids=[];}if(!this._aSelectedShapeUids){this._aSelectedShapeUids=[];}for(var g in I){var s=I[g];var r=this._getRowById(s);if(r){for(var j in r.data){if(r.data[j]instanceof Array){for(var i=0;i<r.data[j].length;i++){var o=r.data[j][i];if(q.inArray(o.uid,this._aSelectedShapeUids)<0){this._selectShape(o);}}}}}}this._drawSelectedShapes();return this;};m.prototype.selectRelationships=function(I,d){var i,r;if(!this._aSelectedRelationships){this._aSelectedRelationships=[];}if(!I||I.length<1){if(this._aSelectedRelationships.length>0){this._aSelectedRelationships=[];this._drawSelectedShapes();}return this;}if(d){this._aSelectedRelationships=[];for(i=0;i<I.length;i++){r=this._getShapeDataById(I[i],true)[0];if(r&&this._judgeEnableSelection(r)){this._aSelectedRelationships.push(r);}}}else{for(i=0;i<I.length;i++){r=this._getShapeDataById(I[i],true)[0];if(!r||q.inArray(r,this._aSelectedRelationships)>=0){continue;}else if(this._judgeEnableSelection(r)){this._aSelectedRelationships.push(r);}}}this._drawSelectedShapes();return this;};m.prototype.deselectRelationships=function(I){var u=[];if(!I||I.length<1){this._aSelectedRelationships=[];this._drawSelectedShapes();return this;}if(I){for(var i=0;i<I.length;i++){var d=this._getUidById(I[i],true)[0];if(d!==undefined){u.push(d);}}}for(var j in this._aSelectedRelationships){var s=this._aSelectedRelationships[j];if(q.inArray(s.uid,u)>-1){var g=this._aSelectedRelationships.indexOf(s);this._aSelectedRelationships.splice(g,1);}}this._drawSelectedShapes();return this;};m.prototype.selectRows=function(i,I){var B=this.getAllRowData();var s=this._oTT.getSelectedIndices();if(I&&s.length>0){this._oTT.clearSelection();}for(var d=0;d<B.length;d++){if(q.inArray(B[d].id,i)>-1&&q.inArray(d,s)<0){var g=this._oTT.getSelectionMode();if(g===sap.ui.table.SelectionMode.Multi||g===sap.ui.table.SelectionMode.MultiToggle){this._oTT.addSelectionInterval(d,d);}else{this._oTT.setSelectedIndex(d);}}}return this;};m.prototype.deselectRows=function(I){if(!I||I.length<1){this._oTT.clearSelection();return this;}var s=this._oTT.getSelectedIndices();var B=this.getAllRowData();for(var i=0;i<s.length;i++){var d=s[i];if(q.inArray(B[d].id,I)>-1){this._oTT.removeSelectionInterval(d,d);}}return this;};m.prototype.expandToLevel=function(l){this._oTT.expandToLevel(l);return this;};m.prototype._isRelationship=function(s){if(U.getShapeDataNameByUid(s)===sap.gantt.shape.ShapeCategory.Relationship){return true;}return false;};m.prototype._onRowSelectionChange=function(o){this.fireRowSelectionChange({originEvent:o});};m.prototype._selectionChange=function(s,d,g,o){if(this._aSelectedRelationships==undefined){this._aSelectedRelationships=[];}if(this._aSelectedShapeUids==undefined){this._aSelectedShapeUids=[];}var i=false;var r=false;var t=s.uid;var j=this._isRelationship(t);if((d&&this.getSelectionMode()===sap.gantt.SelectionMode.MultiWithKeyboard)||this.getSelectionMode()===sap.gantt.SelectionMode.Multiple){if(!j){if(this._aSelectedShapeUids!==undefined&&q.inArray(t,this._aSelectedShapeUids)>-1){if(!this._bDragging){i=this._deselectShape(s);}}else{i=this._selectShape(s);}}else{if(q.inArray(s,this._aSelectedRelationships)<0){this._aSelectedRelationships.push(s);}else{var k=this._aSelectedRelationships.indexOf(s);this._aSelectedRelationships.splice(k,1);}r=true;}}else if(!j){if((q.inArray(t,this._aSelectedShapeUids)<0||this._aSelectedShapeUids.length>1)&&!this._bDragging){this._oSelectedShapes={};this._aSelectedShapeUids=[];i=true;}if(q.inArray(t,this._aSelectedShapeUids)<0){var u=this._selectShape(s);if(!i&&u){i=true;}}if(this._aSelectedRelationships.length>0){this._aSelectedRelationships=[];r=true;}}else{if((q.inArray(s,this._aSelectedRelationships)<0)||this._aSelectedRelationships.length>1){this._aSelectedRelationships=[];this._aSelectedRelationships.push(s);r=true;}if(this._aSelectedShapeUids!==undefined&&this._aSelectedShapeUids.length>0){this._oSelectedShapes={};this._aSelectedShapeUids=[];i=true;}}if(i||r){this._drawSelectedShapes();}return{shapeSelectionChange:i,relationshipSelectionChange:r};};m.prototype._setSelectedStatusToData=function(){var d=this.getAllRowData();if(d&&d.length>0&&this._aShapeIdsToBeSelected.length>0){for(var k in this._aShapeIdsToBeSelected){var s=this._getShapeDataById(this._aShapeIdsToBeSelected[k],false);for(var l in s){this._selectShape(s[l]);}}}for(var r in d){var o=d[r];for(var g in o.data){var n=o.data[g];if(n instanceof Array){for(var I=0;I<n.length;I++){var p=n[I];if(q.inArray(p.uid,this._aSelectedShapeUids)>-1){p.selected=true;}else{p.selected=false;}}}}}for(var i in this._aRelationships){this._aRelationships[i].selected=false;if(this._aSelectedRelationships!==undefined&&this._aSelectedRelationships.length>0){for(var j in this._aSelectedRelationships){if(this._aRelationships[i].uid===this._aSelectedRelationships[j].uid){this._aRelationships[i].selected=true;}}}}};m.prototype._setSelectedStatusFromData=function(s,d){this._oSelectedShapes=this._oSelectedShapes?this._oSelectedShapes:{};this._aSelectedShapeUids=this._aSelectedShapeUids?this._aSelectedShapeUids:[];this._bSelectedStatusUpdated=true;var u=[];for(var r in d){var o=d[r];for(var g in o.data){var l=o.data[g];if(l instanceof Array&&q.inArray(g,s)>-1){for(var i=0;i<l.length;i++){var n=l[i];if(q.inArray(n.uid,this._aSelectedShapeUids)>-1){for(var k=0;k<this._oSelectedShapes[g].length;k++){if(this._oSelectedShapes[g][k].shapeUid===n.uid){this._oSelectedShapes[g][k].shapeData=n;this._oSelectedShapes[g][k].objectInfoRef=o;u.push(n.uid);break;}}}else if(n.selected){this._oSelectedShapes[g]=this._oSelectedShapes[g]?this._oSelectedShapes[g]:[];this._oSelectedShapes[g].push({"shapeUid":n.uid,"shapeData":n,"objectInfoRef":o});this._aSelectedShapeUids.push(n.uid);u.push(n.uid);}}}}}if(u.length<1){this._oSelectedShapes={};}else{for(var p in this._oSelectedShapes){for(var t=this._oSelectedShapes[p].length-1;t>=0;t--){var v=this._oSelectedShapes[p][t];if(q.inArray(v.shapeUid,u)<0){this._oSelectedShapes[p].splice(t,1);}}}}this._aSelectedShapeUids=u;this._aSelectedRelationships=this._aSelectedRelationships?this._aSelectedRelationships:[];var w=[];for(var j in this._aRelationships){var x=false;for(var I=0;I<this._aSelectedRelationships.length;I++){if(this._aSelectedRelationships[I].uid===this._aRelationships[j].uid){w.push(this._aRelationships[j]);x=true;break;}}if(!x&&this._aRelationships[j].selected){w.push(this._aRelationships[j]);}}this._aSelectedRelationships=w;};m.prototype._syncTTSelection=function(d){q.sap.measure.start("GanttChart syncTTSelection","GanttPerf:GanttChart syncTTSelection function");var t=this._getMouseOrTouchPoint(d);var s=d.shiftKey;var g=d.ctrlKey;var i=q("#"+this.getId()+"-svg")[0];var o=this._getSvgCoodinateByDiv(i,t.pageX,t.pageY);var r=parseInt(this._oAxisOrdinalOfVisibleRow.viewToElementIndex(o.y),10);if(r<0){return false;}var v=this._oTT.getRows();var I,j=d3.select("#"+v[r].getId());if(r<v.length&&j&&j.attr("data-sap-ui-rowindex")){I=this._oTT.getFirstVisibleRow()+parseInt(j.attr("data-sap-ui-rowindex"),10);}var k=this._oTT.getSelectionMode();if(I>=0&&k!==sap.ui.table.SelectionMode.None){if(k===sap.ui.table.SelectionMode.Single){if(!this._oTT.isIndexSelected(I)){this._oTT.setSelectedIndex(I);}else{this._oTT.clearSelection();}}else{g=true;if(s){var l=this._oTT.getSelectedIndex();if(l>=0){if(l<I){this._oTT.addSelectionInterval(l,I);}else{this._oTT.addSelectionInterval(I,l);}}else{this._oTT.setSelectedIndex(I);}}else if(!this._oTT.isIndexSelected(I)){if(g){this._oTT.addSelectionInterval(I,I);}else{this._oTT.setSelectedIndex(I);}}else if(g){this._oTT.removeSelectionInterval(I,I);}else if(this._oTT.getSelectedIndices().length>1){this._oTT.setSelectedIndex(I);}}}q.sap.measure.end("GanttChart syncTTSelection");};m.prototype._setEventStatus=function(s){switch(s){case"dragEnter":this._bDragStart=true;break;case"mouseDown":this._bMouseDown=true;this._bDragging=false;this._bDragStart=false;this._bScrolling=false;break;case"shapeDragStart":this._bDragStart=true;break;case"shapeDragging":if(this._bDragStart){this._bDragging=true;}break;case"mouseUp":this._bMouseDown=false;this._bScrolling=false;break;case"shapeDragEnd":this._bDragging=false;this._bDragStart=false;this._oDraggingData=undefined;break;case"dragLeave":this._bDragging=false;this._bDragStart=false;break;default:break;}};m.prototype._handleShapeDragStart=function(o){var s=q("#"+this.getId()+"-svg");var d=d3.select(o.target).data()[0];var g=o.target.getAttribute("class").split(" ")[0];if(d!==undefined&&this._judgeEnableDnD(d,g)){var r=this._getRowByShapeUid(d.uid);if(r){var x=o.pageX-s.offset().left||o.offsetX;var y=o.pageY-s.offset().top||o.offsetY;var j,k;if(o.target.getAttribute("x")&&o.target.getAttribute("width")){j=parseInt(o.target.getAttribute("x"),10);k=parseInt(o.target.getAttribute("width"),10);}else if(d.startTime){var l=this._oAxisTime.timeToView(F.abapTimestampToDate(d.startTime));var n=this._oAxisTime.timeToView(F.abapTimestampToDate(d.endTime));if(C.getConfiguration().getRTL()){j=n;k=(l-n)>0?(l-n):1;}else{j=l;k=(n-l)>0?(n-l):1;}}else{j=x;k=1;}var p={"x":x,"y":y,"shapeX":j,"shapeWidth":k};var t=[];t.push({"shapeData":d,"objectInfo":r});for(var u in this._oSelectedShapes){var v=this._oSelectedShapes[u];if(v!==undefined){for(var i in v){if(v[i].shapeUid!==d.uid&&this._judgeEnableDnD(v[i].shapeData)){t.push({"shapeData":v[i].shapeData,"objectInfo":v[i].objectInfoRef});}}}}this._oDraggingData={"sourceShapeData":t,"dragStartPoint":p,"sourceSvgId":this.getId(),"targetSvgId":this.getId(),"domObject":this._getDraggingDomObjs(o)};this._setEventStatus("shapeDragStart");q(document.body).unbind("mousemove.ganttChartDragDrop");q(document).unbind("mouseup.ganttChartDragDrop");q(document.body).bind("mousemove.ganttChartDragDrop",this._handleShapeDragging.bind(this));q(document).bind("mouseup.ganttChartDragDrop",this._handleShapeDragEnd.bind(this));}}};m.prototype._getDraggingDomObjs=function(o){var d=d3.select(o.target)[0][0];var s;if(d.parentElement){s=d.parentElement.getAttribute("class");}else if(d.parentNode){s=d.parentNode.getAttribute("class");}if(s){var t=s.split(" ")[0];if(sap.ui.getCore().byId(t)instanceof sap.gantt.shape.Group){return d.parentNode.childNodes;}}return[d];};m.prototype._handleShapeDragging=function(o){if(!D.support.touch&&(o.button!==0||o.buttons===0||o.ctrlKey)){return false;}var s=q("#"+this.getId()+"-svg");var d=Math.abs((o.pageX-s.offset().left||o.offsetX)-this._oDraggingData.dragStartPoint.x);var j=Math.abs((o.pageY-s.offset().top||o.offsetY)-this._oDraggingData.dragStartPoint.y);if(d>3||j>3){var l=d3.select("#dragDropShadow");var n=l[0];if(this._oDraggingData===undefined){if(!l.empty()){l.remove();}}else{var p=this._oDraggingData.dragStartPoint.shapeX;var r=this._oDraggingData.dragStartPoint.x;if(l.empty()||n===null){this._handleDragWithoutSelection(o);var t=this._oDraggingData.sourceShapeData.length;n=d3.select("body").append("div").attr("id","dragDropShadow");n.classed("sapGanttDraggingShadow",true);var u=[];var w=12;var v=10;var x=12;for(var i=0;i<this._oDraggingData.domObject.length;i++){var y=d3.select(this._oDraggingData.domObject[i]);if(!y.empty()){var z=parseInt(y.attr("width"),10);var B=parseInt(y.attr("height"),10);var H=y.attr("transform");w=z>w?z:w;v=B>v?B:v;var I="";if(H){var J=H.split(")");for(var K=0;K<J.length-1;K++){if(J[K].indexOf("translate")<0){I=I+J[K]+") ";}}I.replace("))",")");}var L=d3.select(this._oDraggingData.domObject[i].cloneNode()).classed("shadow",true).attr("fill-opacity","0.5").attr("x",0).attr("y",0).attr("transform",I);u.push(L);}}var g=n.append("svg").attr("id","dragDropShadowSvg").attr("width",w).append("g").attr("id","dragDropShadowSvgGroup");for(var k=0;k<u.length;k++){g.node().appendChild(u[k].node());}g.append("text").attr("x",w/2-x/2).attr("y",v-x/2+4).attr("fill","blue").attr("font-size",x).text(function(){return t;});}var M=p+(o.pageX-r);var O=o.pageY;d3.select("#dragDropShadow").style("left",M+4+"px");d3.select("#dragDropShadow").style("top",O+4+"px");q(document.body).addClass("sapGanttDraggingCursor");this._setEventStatus("shapeDragging");}}};m.prototype._handleDragWithoutSelection=function(o){if(q.inArray(this._oDraggingData.sourceShapeData[0].shapeData.uid,this._aSelectedShapeUids)<0){var r=false;if(this.getSelectionMode()!==sap.gantt.SelectionMode.Multiple){if(this._aSelectedShapeUids&&this._aSelectedShapeUids.length>0){this._aSelectedShapeUids=[];this._oSelectedShapes={};this._oDraggingData.sourceShapeData.splice(1,this._oDraggingData.sourceShapeData.length-1);}if(this._aSelectedRelationships&&this._aSelectedRelationships.length>0){this._aSelectedRelationships=[];r=true;}}this._selectShape(this._oDraggingData.sourceShapeData[0].shapeData);this._drawSelectedShapes();this.fireShapeSelectionChange({originEvent:o});if(r){this.fireRelationshipSelectionChange({originEvent:o});}}};m.prototype._handleShapeDragEnd=function(o){var d=d3.select("#dragDropShadow");if(!d.empty()){d.remove();}if(this._bDragging&&this._oDraggingData!==undefined){var t=this.getId();this._collectDraggingShapeData(this._oDraggingData,o);this.fireShapeDragEnd({originEvent:o,sourceSvgId:this._oDraggingData.sourceSvgId,targetSvgId:t,sourceShapeData:this._oDraggingData.sourceShapeData,targetData:this._oDraggingData.targetData});}q(document.body).unbind("mousemove.ganttChartDragDrop");q(document).unbind("mouseup.ganttChartDragDrop");q(document.body).removeClass("sapGanttDraggingCursor");this._setEventStatus("shapeDragEnd");};m.prototype._collectDraggingShapeData=function(d,o){var s=q("#"+this.getId()+"-svg");var x=o.pageX-s.offset().left||o.offsetX;var g=d.dragStartPoint.x;var i=parseInt(x,10)-parseInt(g,10);var j=parseInt(d.dragStartPoint.shapeX,10)+i;var k=j+parseInt(d.dragStartPoint.shapeWidth,10);var n,l;if(C.getConfiguration().getRTL()===true){n=this._oAxisTime.viewToTime(k).getTime();l=this._oAxisTime.viewToTime(j).getTime();}else{n=this._oAxisTime.viewToTime(j).getTime();l=this._oAxisTime.viewToTime(k).getTime();}var p=this._composeParameterForClickPosition(o);var r=p?p.rowInfo:undefined;d.targetData={"mouseTimestamp":{startTime:n,endTime:l},"mode":this.getMode(),"objectInfo":r};};m.prototype.setDraggingData=function(d){this._oDraggingData=d;if(this._oDraggingData!==undefined){this._oDraggingData.targetSvgId=this.getId();q(document.body).unbind("mousemove.ganttChartDragDrop");q(document).unbind("mouseup.ganttChartDragDrop");q(document.body).bind("mousemove.ganttChartDragDrop",this._handleShapeDragging.bind(this));q(document).bind("mouseup.ganttChartDragDrop",this._handleShapeDragEnd.bind(this));this._setEventStatus("dragEnter");}};m.prototype._onSvgMouseEnter=function(o){if(o.button===0&&o.buttons!==0&&o.target&&!this._bDragging&&(o.target.id===this.getId()+"-svg-ctn"||o.target.id===this.getId()+"-svg"||this._mouseInSvgCtn(o))){this.fireChartDragEnter({originEvent:o});}};m.prototype._onSvgMouseLeave=function(o){if(o.target&&(o.target.id===this.getId()+"-svg-ctn"||o.target.id===this.getId()+"-svg"||!this._mouseInSvgCtn(o))){if(this._bDragStart&&this._oDraggingData!==undefined){this._handleDragLeave(o);}this._destroyCursorLine();this._handleHoverLeave();}};m.prototype._mouseInSvgCtn=function(o){var d=q("#"+this.getId()+"-svg-ctn");var n=d.width()-((C.getConfiguration().getRTL())?0:this._oTT.$(sap.ui.table.SharedDomRef.VerticalScrollBar).width());var g=d.height()-this._oTT.$(sap.ui.table.SharedDomRef.HorizontalScrollBar).height();var s=d.offset();var i=(o.pageX||o.clientX)-s.left;var j=(o.pageY||o.clientY)-s.top;if(j>=0&&j<g-2&&i>=0&&i<n-2){return true;}return false;};m.prototype._onSvgMouseDown=function(o){this._prepareSelection(o);this._prepareDragging(o);};m.prototype._onSvgMouseMove=function(o){this._drawCursorLine(o);this._handleHover(o);};m.prototype._onSvgMouseUp=function(o){if(o.button==2){this._handleRightClick(o);}else if(o.button==0&&!this._bDragging&&this._bMouseDown){this._handleSelectionChange(o);}};m.prototype._onSvgDoubleClick=function(o){if(!this._bDragging&&!o.ctrlKey&&!o.shiftKey){var p=this._composeParameterForClickPosition(o);this.fireChartDoubleClick({objectInfo:p?p.rowInfo:undefined,leadingRowInfo:p?p.leadingRowInfo:undefined,timestamp:p?p.startTime.getTime():undefined,svgId:this.getId()+"-svg",svgCoordinate:p?p.svgPoint:undefined,effectingMode:this.getMode(),originEvent:o});}};m.prototype._onSvgTouchstart=function(o){this._prepareSelection(o);this._onTouchScrollStart(o);};m.prototype._onSvgTouchmove=function(o){this._onTouchScroll(o);};m.prototype._onSvgTouchend=function(o){if(!this._bScrolling){this._handleSelectionChange(o);}else{this._setEventStatus("mouseUp");this._oLastSelectedShape=undefined;}};m.prototype._preventBubbleAndDefault=function(o){o.preventDefault();o.stopPropagation();};m.prototype._prepareSelection=function(o){if(!D.support.touch&&o.button!==0){return false;}if(!this._bDragging){var s=d3.select(o.target).data()[0];var d;if(o.target.getAttribute("class")){d=o.target.getAttribute("class").split(" ")[0];}if(d&&s&&this._judgeEnableSelection(s,d)){this._oLastSelectedShape=s;}this._setEventStatus("mouseDown");}};m.prototype._prepareDragging=function(o){if(o.button==0){var s=d3.select(o.target).data()[0];var d;if(o.target.getAttribute("class")){d=o.target.getAttribute("class").split(" ")[0];}if(d&&s&&this._judgeEnableSelection(s,d)){if(this._bMouseDown){this._handleShapeDragStart(o);}this._preventBubbleAndDefault(o);}}};m.prototype._handleRightClick=function(o){var p=this._composeParameterForClickPosition(o);this.fireChartRightClick({objectInfo:p?p.rowInfo:undefined,leadingRowInfo:p?p.leadingRowInfo:undefined,timestamp:p?p.startTime.getTime():undefined,svgId:this.getId()+"-svg",svgCoordinate:p?p.svgPoint:undefined,effectingMode:this.getMode(),originEvent:o});};m.prototype._handleClick=function(o){var p=this._composeParameterForClickPosition(o);this.fireChartClick({objectInfo:p?p.rowInfo:undefined,leadingRowInfo:p?p.leadingRowInfo:undefined,timestamp:p?p.startTime.getTime():undefined,svgId:this.getId()+"-svg",svgCoordinate:p?p.svgPoint:undefined,effectingMode:this.getMode(),originEvent:o});};m.prototype._drawCursorLine=function(o){if(this.getEnableCursorLine()){var s=q("#"+this.getId()+"-svg");var d=this._getSvgCoodinateByDiv(s[0],o.pageX||o.clientX,o.pageY||o.clientY);this._oCursorLineDrawer.drawSvg(d3.selectAll(".sapGanttChartSvg"),d3.selectAll(".sapGanttChartHeaderSvg"),this.getLocale(),d);}};m.prototype._destroyCursorLine=function(){if(this.getEnableCursorLine()){this._oCursorLineDrawer.destroySvg(d3.selectAll(".sapGanttChartSvg"),d3.selectAll(".sapGanttChartHeaderSvg"));}};m.prototype._handleHover=function(o){var p=this._composeParameterForClickPosition(o);var r=p?p.leadingRowNum-this._oTT.getFirstVisibleRow():-1;r=r<0?-1:r;var d=p?p.isExpandedRow:false;var s=d3.select(o.target).data()[0];if(r>-1&&((s!==undefined&&s.uid!==this._lastHoverShapeUid)||(s===undefined&&this._lastHoverShapeUid!==undefined)||r!==this._lastHoverRowIndex)){this.fireChartMouseOver({objectInfo:p?p.rowInfo:undefined,leadingRowInfo:p?p.leadingRowInfo:undefined,timestamp:p?p.startTime.getTime():undefined,svgId:this.getId()+"-svg",svgCoordinate:p?p.svgPoint:undefined,effectingMode:this.getMode(),originEvent:o});if(s!==undefined){this._lastHoverShapeUid=s.uid;}else{this._lastHoverShapeUid=undefined;}}if(r>-1&&r!==this._lastHoverRowIndex){var t=this._oTT;var H=t.getRows()[r];if(H){t.$().find(".sapUiTableRowHvr").trigger("mouseout");if(!d){H.$().trigger("mouseover");}}}if(r!==this._lastHoverRowIndex){this._lastHoverRowIndex=r;}};m.prototype._handleDragLeave=function(o){this._oDraggingData.targetSvgId=undefined;this._setEventStatus("dragLeave");this.fireChartDragLeave({originEvent:o,draggingSource:this._oDraggingData});};m.prototype._handleHoverLeave=function(){var t=this._oTT;t.$().find(".sapUiTableRowHvr").trigger("mouseleave");this._lastHoverShapeUid=undefined;this._lastHoverRowIndex=-1;};m.prototype._handleSelectionChange=function(o){this._aShapeIdsToBeSelected=[];var s=d3.select(o.target).data()[0];var d;if(o.target.getAttribute("class")){d=o.target.getAttribute("class").split(" ")[0];}var g={};if(s!==undefined&&this._judgeEnableSelection(s,d)&&this._oLastSelectedShape!==undefined&&this._oLastSelectedShape.uid===s.uid){g=this._selectionChange(s,o.ctrlKey,o.shiftKey,o);}else if(this.getSelectionMode()===sap.gantt.SelectionMode.MultiWithKeyboard){var p=this._composeParameterForClickPosition(o);if(p&&!p.isExpandedRow){this._syncTTSelection(o);this._oLastSelectedShape=undefined;}else{return null;}}else{if(this._aSelectedShapeUids!==undefined&&this._aSelectedShapeUids.length>0){this._oSelectedShapes={};this._aSelectedShapeUids=[];g.shapeSelectionChange=true;}if(this._aSelectedRelationships.length>0){this._aSelectedRelationships=[];g.relationshipSelectionChange=true;}if(g.shapeSelectionChange||g.relationshipSelectionChange){this._drawSelectedShapes();}}this._setEventStatus("mouseUp");this._oLastSelectedShape=undefined;if(g.shapeSelectionChange){this.fireShapeSelectionChange({originEvent:o});}if(g.relationshipSelectionChange){this.fireRelationshipSelectionChange({originEvent:o});}this._handleClick(o);};m.prototype._onTTHScrollAfterRendering=function(){this._updateScrollLeft(true);var d=q(this._oTT.getDomRef(sap.ui.table.SharedDomRef.HorizontalScrollBar));d.unbind("scroll.sapUiTableHScroll");d.unbind("scroll.sapUiTableHScrollForGanttChart",this._onHSbScroll);d.bind("scroll.sapUiTableHScrollForGanttChart",q.proxy(this._onHSbScroll,this));};m.prototype._getSvgHeight=function(){return this._oTT.$().find(".sapUiTableCCnt").height();};m.prototype._getRowHeights=function(){return this._aHeights;};m.prototype.setBaseRowHeight=function(n){this.setProperty("baseRowHeight",n);this._oTT.setRowHeight(n);};m.prototype._setInferedBaseRowHeight=function(n){this._iInferedBaseRowHeight=n;};m.prototype.getBaseRowHeight=function(){return this._iInferedBaseRowHeight?this._iInferedBaseRowHeight:this._iInferedBaseRowHeightOnTT;};m.prototype._initialSvgDrawing=function(){if(this.getBaseRowHeight()&&this._iSvgHeight!=this._getSvgHeight()){this._iSvgHeight=this._getSvgHeight();this._bTableReady=true;var o=this._oTT.getContextByIndex(0);var d=o?o.getObject():undefined;var u=d?d.uid:undefined;this._onTTRowUpdate();if(!u){this._oTT.updateRows();}}};m.prototype._onHSbScroll=function(o){var d=this._oTT.$(sap.ui.table.SharedDomRef.HorizontalScrollBar);var n=(C.getConfiguration().getRTL()&&D.browser.firefox)?d.scrollLeftRTL():d.scrollLeft();this.updateLeftOffsetRate(n);this._draw(false);if(this._scrollFlag){delete this._scrollFlag;return;}this.fireHorizontalScroll({scrollSteps:n,leftOffsetRate:this._fLeftOffsetRate});};m.prototype._onVSbScroll=function(){this._bSelectedStatusUpdated=true;if(!this._mTimeouts._drawSvg){this.$().find(".sapGanttChartSvg").css("transform",this._oTT.$().find(".sapUiTableCtrlRowScroll").css("transform"));}this.fireVerticalScroll({scrollSteps:this._oTT.getFirstVisibleRow(),scrollPosition:q(this._oTT.getDomRef(sap.ui.table.SharedDomRef.VerticalScrollBar)).scrollTop()});};m.prototype._hSbScrollLeft=function(n){var d=q("#"+this.getId()+"-svg-ctn");var g=q("#"+this.getId()+"-header");var i;if(C.getConfiguration().getRTL()===true){i=this._oStatusSet.aViewBoundary[1]-g.width()-n;if(i<0){i=0;}}else{i=n;}if(C.getConfiguration().getRTL()===true&&D.browser.firefox){if(Math.abs(d.scrollLeftRTL()-i)>1){d.scrollLeftRTL(i);}if(Math.abs(g.scrollLeftRTL()-i)>1){g.scrollLeftRTL(i);}}else{if(Math.abs(d.scrollLeft()-i)>1){d.scrollLeft(i);}if(Math.abs(g.scrollLeft()-i)>1){g.scrollLeft(i);}}};m.prototype.updateLeftOffsetRate=function(n,d){var H=sap.ui.table.SharedDomRef.HorizontalScrollBar;var g=d?d:parseInt(this._oTT.$(H+"-content").width(),0);var i=q("#"+this.getId()+"-svg-ctn").width()-((C.getConfiguration().getRTL())?0:this._oTT.$(sap.ui.table.SharedDomRef.VerticalScrollBar).width());if(g-i!==0){if(C.getConfiguration().getRTL()===true&&D.browser.msie){this._fLeftOffsetRate=(g-n-i)/(g-i);}else{this._fLeftOffsetRate=n/(g-i);}this._fLeftOffsetRate=this._fLeftOffsetRate<0?0:this._fLeftOffsetRate;this._fLeftOffsetRate=this._fLeftOffsetRate>1?1:this._fLeftOffsetRate;}return this._fLeftOffsetRate;};m.prototype.jumpToPosition=function(v){if(!isNaN(v)&&!(v instanceof Date)&&!(v instanceof Array)){this._fLeftOffsetRate=v;this._updateScrollLeft();return;}if(v instanceof Date){this._oDateToJump=[v];this._draw(false);return;}if(v instanceof Array){this._oDateToJump=v;this._draw(false);return;}this._oDateToJump=[null];this._draw(false);};m.prototype._onTTRowUpdate=function(){if(this._bTableReady){this._syncSvgHeightWithTT();this._syncSvgDataWithTT();if(!q.isEmptyObject(this._oRowStatusMap)){var o=this._oTT.getContextByIndex(0);var d=o?o.getObject():undefined;var u=d?d.uid:undefined;if(!u){this._syncSvgDataWithTT();}}this._draw(true);}};m.prototype._updateDataString=function(){var s=JSON.stringify(this._aFilteredRowData,function(k,v){if(k==="bindingObj"||k==="contextObj"){return undefined;}return v;});if(this._sShapeData&&s===this._sShapeData){this._sShapeData=s;return false;}else{this._sShapeData=s;return true;}};m.prototype._syncSvgHeightWithTT=function(){var d=this.$().find(".sapGanttChartSvgCtn");d.height(this._getSvgHeight());var g=this.$().find(".sapGanttChartSvg");g.height(this._oTT.$().find(".sapUiTableCtrlRowScroll").height());};m.prototype._syncSvgDataWithTT=function(){var B=this._oTT.getBinding("rows");if(!B){return false;}var j=B.getMetadata().getName()==="sap.ui.model.json.JSONTreeBinding";var i=this._oTT.getFirstVisibleRow();var v=this._getVisibleRowCount();this._aFilteredRowData=[];this._aNonVisibleShapeData=[];var _=[];var d=[];var g=[i,i+v-1];var I=this._aRelationshipsContexts&&this._aRelationshipsContexts.length>0;if(j){if(I){B.getContexts(0,0);if(i>0){_=this._getDrawingData([0,i-1]);}d=this._getDrawingData([i+v,B.getLength()-1]);B.getContexts(g[0],g[1]);}this._aFilteredRowData=this._getDrawingData(g);}else{if(I){if(i>0){_=this._createShapeDataFromRowContexts(B.getContexts(0,i));}d=this._createShapeDataFromRowContexts(B.getContexts(i+v,B.getLength()));}var r=B.getContexts(i,v);this._aFilteredRowData=this._createShapeDataFromRowContexts(r);}this._aNonVisibleShapeData=_.concat(d);var s=this.getShapeDataNames();U.generateRowUid(this._aFilteredRowData,this._oObjectTypesConfigMap,s);if(!this._bSelectedStatusUpdated){this._setSelectedStatusFromData(s,this._aFilteredRowData);}var k=this.getBaseRowHeight();if(!k){k=0;}this._oAxisOrdinal=this._createAxisOrdinal(this._aFilteredRowData,k,0);this._cacheObjectPosition(this._aFilteredRowData,this._oAxisOrdinal);this._cacheObjectPosition(_,this._oAxisOrdinal,true);this._cacheObjectPosition(d,this._oAxisOrdinal,false);if(!this._aVisibleRange||this._aVisibleRange[0]!==g[0]||this._aVisibleRange[1]!==g[1]){this._aVisibleRange=g;return true;}return false;};m.prototype._createShapeDataFromRowContexts=function(r){var s=this.getShapeDataNames();var B=this._oTT.getBinding("rows");var M=B.getModel();var d=[];for(var i=0;i<r.length;i++){if(r[i]!=undefined){if(s&&s.length>0){for(var j=0;j<s.length;j++){var g=s[j];var l=r[i].getProperty(g);var o;if(l){for(var k=0;k<l.length;k++){var n=l[k];o=M.getData("/"+n);d.push({"bindingObj":B,"contextObj":r[i],"data":r[i].getObject(),"shapeData":[o],"id":o.id,"shapeName":g,"rowIndex":i});}}}}else{d.push({"bindingObj":B,"contextObj":r[i],"data":r[i].getObject(),"shapeData":[r[i].getObject()],"id":r[i].getObject().id,"shapeName":undefined,"rowIndex":i});}}}return d;};m.prototype._cacheObjectPosition=function(o,d,g){if(o&&o.length>0){if(g===true){for(var i=0;i<o.length;i++){o[i].y=-100;o[i].rowHeight=d.getViewBandWidth();}}else if(g===false){for(var j=0;j<o.length;j++){o[j].y=d.getViewRange()[1]+100;o[j].rowHeight=d.getViewBandWidth();}}else{var v=[];var l=[];for(var k=0;k<o.length;k++){o[k].y=d.elementToView(o[k].uid);if(k>0){o[k-1].rowHeight=o[k].y-o[k-1].y;}if(o[k].visibleRowSpan){o[k].visibleRowHeight=o[k].visibleRowSpan*d.getViewBandWidth();v.push(o[k].uid);l.push(o[k].visibleRowSpan);}}o[o.length-1].rowHeight=d.getViewRange()[1]-o[o.length-1].y;this._oAxisOrdinalOfVisibleRow=new h(v,l,this.getBaseRowHeight(),0);}}};m.prototype._prepareRelationshipDataFromModel=function(){this._aRelationships=[];if(this._aRelationshipsContexts){for(var i=0;i<this._aRelationshipsContexts.length;i++){var r=this._aRelationshipsContexts[i].getObject();if(r!==undefined){this._aRelationships.push(r);}}}U.generateUidByShapeDataName(this._aRelationships,"relationship");};m.prototype._createAxisOrdinal=function(s,B,d){var r=s.map(function(o){return o.uid;});var g=s.map(function(o){if(o.rowSpan){return o.rowSpan;}else{return 1;}});return new h(r,g,B,d);};m.prototype.getFilteredRowData=function(r){return this._aFilteredRowData;};m.prototype._getDrawingData=function(r){var d=function(H,J,K,L){if(!H[J]){H.push({});}if(!H[J][K]){H[J][K]=[];}H[J][K].push(L);};var i,j,k,l,o,s;var B=this._oTT.getBinding("rows");var g=this._oTT.getBindingInfo("rows");var n=[];for(i=r[0];i<=r[1];i++){var p=this._oTT.getContextByIndex(i);if(!p){continue;}else{o=p.getObject();if(!o){continue;}}var t=1;s=this._oObjectTypesConfigMap[o.type]?this._oObjectTypesConfigMap[o.type].getMainChartSchemeKey():sap.gantt.config.DEFAULT_CHART_SCHEME_KEY;if(o.type){var u=this._oChartSchemesConfigMap[s];if(u){t=u.getRowSpan();}}var v={"bindingObj":B,"bindingInfo":g,"contextObj":p,"data":o,"id":o.id,"rowSpan":t,"chartScheme":s,"rowIndex":i,"index":0,"visibleRowSpan":t};n.push(v);var w=p.getObject();var x=w.uid;if(x&&this._oRowStatusMap[x]){for(s in this._oRowStatusMap[x]){var M;if(this._oChartSchemesConfigMap[s]&&this._oChartSchemesConfigMap[s].getModeKey()&&this._oChartSchemesConfigMap[s].getModeKey()!==sap.gantt.config.DEFAULT_MODE_KEY){M=this._oChartSchemesConfigMap[s].getModeKey();}else{M=this.getMode();}var y=this._collectDataNameForValidChartScheme(s,M);if(y&&y.drawData){var z=0;var H=[{}];for(j=0;j<y.drawData.length;j++){if(!o[y.drawData[j]]){continue;}for(k=0;k<o[y.drawData[j]].length;k++){var I=o[y.drawData[j]][k].rowIndex;if(I&&z<I){z=I;}}}if(z>0){for(j=0;j<y.drawData.length;j++){if(!o[y.drawData[j]]){continue;}for(k=0;k<o[y.drawData[j]].length;k++){var J=o[y.drawData[j]][k].rowIndex;if(J){d(H,J,y.drawData[j],o[y.drawData[j]][k]);}else{for(l=1;l<=z;l++){d(H,l,y.drawData[j],o[y.drawData[j]][k]);}}}}for(j=1;j<=z;j++){n.push({"bindingObj":B,"bindingInfo":g,"data":H[j],"id":o.id,"parentId":v.id,"rowSpan":y.rowSpan,"chartScheme":s,"rowIndex":i,"index":j,"icon":this._oChartSchemesConfigMap[s].getIcon(),"closeIcon":"./image/closeChart.png","name":this._oChartSchemesConfigMap[s].getName()});v.visibleRowSpan+=y.rowSpan;}}}}this._oRowStatusMap[x].visibleRowSpan=v.visibleRowSpan;}}return n;};m.prototype._prepareVerticalDrawingRange=function(){var n=this._oTT.getBinding("rows").getLength()-1;if(n<0){return[0,-1];}var d=this._oTT.getFirstVisibleRow();var g=d+this._getVisibleRowCount()-1;var i=d;var j=g<n?g:n;return[i,j];};m.prototype._prepareHorizontalDrawingRange=function(){var n=this._nUpperRange-this._nLowerRange;var d=q("#"+this.getId()+"-svg-ctn").width()-((C.getConfiguration().getRTL())?0:this._oTT.$(sap.ui.table.SharedDomRef.VerticalScrollBar).width());if(!this._oStatusSet){this._updateScrollWidth();}var g=Math.ceil((this._fLeftOffsetRate?this._fLeftOffsetRate:0)*(n-d));if(this._oStatusSet){if((d>=n||(this._oStatusSet.aViewBoundary[0]<=g-this._oStatusSet.nOffset&&this._oStatusSet.aViewBoundary[1]>=g+d-this._oStatusSet.nOffset))){if(!this._mTimeouts._drawSvg){this._scrollSvg();}return false;}}var i=d*(1+this._fExtendFactor*2);var j=g-d*this._fExtendFactor;if(j<this._nLowerRange){i+=j;j=0;}if(j+i>this._nUpperRange){i=this._nUpperRange-j;}this._oAxisTime.setViewOffset(j);this._oStatusSet={nWidth:i,nOffset:j,nScrollLeft:g,aViewBoundary:[0,i],aTimeBoundary:[this._oAxisTime.viewToTime(0),this._oAxisTime.viewToTime(i)],bRTL:C.getConfiguration().getRTL()};return true;};m.prototype._updateZoomAndScrollInfo=function(z){if(!this._oDateToJump){return;}var n=this._nUpperRange-this._nLowerRange;var d=q("#"+this.getId()+"-svg-ctn").width()-((C.getConfiguration().getRTL())?0:this._oTT.$(sap.ui.table.SharedDomRef.VerticalScrollBar).width());var o=this._oDateToJump[0];if(!this._oDateToJump[0]){if(!z.determinedByChartWidth.fSuitableRate){this._oDateToJump=null;return;}z.determinedByConfig.fRate=z.determinedByChartWidth.fSuitableRate;var i=this.getTimeAxis().getInitHorizon();o=F.abapTimestampToDate(i.getStartTime());}else if(this._oDateToJump[1]){var j=this._calZoomScale(this._oDateToJump[0],this._oDateToJump[1],d);var J=z.base.fScale/j;z.determinedByConfig.fRate=z.determinedByChartWidth.fMinRate>J?this._oZoom.determinedByChartWidth.fMinRate:J;o=this._oDateToJump[0];}var g;if(C.getConfiguration().getRTL()===true){if(D.browser.msie){g=n-this._oAxisTime.timeToView(o)-this._oAxisTime.getViewOffset();}else{g=this._oAxisTime.timeToView(o)+this._oAxisTime.getViewOffset()-d;}g=g<0?0:g;}else{g=this._oAxisTime.timeToView(o)+this._oAxisTime.getViewOffset();}this.updateLeftOffsetRate(g,n);this._oDateToJump=null;};m.prototype._draw=function(d){if(!this._bTableReady){return;}var n=this._nUpperRange-this._nLowerRange;if(n<=2){return;}var g=q("#"+this.getId()+"-svg-ctn").width()-((C.getConfiguration().getRTL())?0:this._oTT.$(sap.ui.table.SharedDomRef.VerticalScrollBar).width());if(!g||g<=0||g>document.body.clientWidth){return;}var l=this._oZoom.determinedByConfig.fRate;var L=this._oZoom.determinedByChartWidth;var z=this.getZoomInfo();this._updateZoomAndScrollInfo(z);if(z&&z.determinedByChartWidth){if(!L||!U.floatEqual(l,z.determinedByConfig.fRate)||!U.floatEqual(L.fMinRate,z.determinedByChartWidth.fMinRate)){this.fireEvent("_zoomInfoUpdated",{zoomInfo:z});}if(!l||!U.floatEqual(l,z.determinedByConfig.fRate)||!U.floatEqual(this._oAxisTime.getZoomRate(),z.determinedByConfig.fRate)){this.setTimeZoomRate(z.determinedByConfig.fRate);return;}}if(!this._prepareHorizontalDrawingRange()&&!d){return;}this._updateTableRowHeights();var t=this;this._mTimeouts._drawSvg=this._mTimeouts._drawSvg||window.setTimeout(function(){t._drawSvg();},0);};m.prototype._updateScrollWidth=function(){var n=this._nUpperRange-this._nLowerRange;this._oColumn.setWidth((n-2)+"px");};m.prototype._updateScrollLeft=function(n){var s=sap.ui.table.SharedDomRef.HorizontalScrollBar;var d=this._oTT.$(s);var g=this._oTT.$(s+"-content");var i=parseInt(g.width(),0);var j=q("#"+this.getId()+"-svg-ctn").width()-((C.getConfiguration().getRTL())?0:this._oTT.$(sap.ui.table.SharedDomRef.VerticalScrollBar).width());var k=Math.ceil((this._fLeftOffsetRate?this._fLeftOffsetRate:0)*(i-j));if((C.getConfiguration().getRTL()===true&&D.browser.msie)){k=i-k-j;}if((C.getConfiguration().getRTL()===true&&D.browser.firefox)){if(Math.abs(d.scrollLeftRTL()-k)>1){this._scrollFlag=n?undefined:true;d.scrollLeftRTL(k);}}else if(Math.abs(d.scrollLeft()-k)>1){this._scrollFlag=n?undefined:true;d.scrollLeft(k);}};m.prototype._scrollSvg=function(){var d=q("#"+this.getId()+"-svg");var g=q("#"+this.getId()+"-header-svg");if(Math.abs(this._oStatusSet.nWidth-d.width())>1){d.width(this._oStatusSet.nWidth+((C.getConfiguration().getRTL())?0:this._oTT.$(sap.ui.table.SharedDomRef.VerticalScrollBar).width()));}if(Math.abs(this._oStatusSet.nWidth-g.width())>1){g.width(this._oStatusSet.nWidth+((C.getConfiguration().getRTL())?0:this._oTT.$(sap.ui.table.SharedDomRef.VerticalScrollBar).width()));}var n=this._nUpperRange-this._nLowerRange;var i=q("#"+this.getId()+"-svg-ctn").width()-((C.getConfiguration().getRTL())?0:this._oTT.$(sap.ui.table.SharedDomRef.VerticalScrollBar).width());var j=Math.ceil((this._fLeftOffsetRate?this._fLeftOffsetRate:0)*(n-i));if(C.getConfiguration().getRTL()===true&&!D.browser.msie){this._hSbScrollLeft(this._oStatusSet.nOffset-j+this._oStatusSet.nWidth-i);}else{this._hSbScrollLeft(j-this._oStatusSet.nOffset);}};m.prototype._drawSvg=function(){q.sap.measure.start("GanttChart _drawSvg","GanttPerf:GanttChart _drawSvg function");this._updateScrollLeft();q("#"+this.getId()+"-svg-ctn").css("visibility","hidden");this._scrollSvg();q("#"+this.getId()+"-svg-ctn").css("visibility","visible");this._sUiSizeMode=U.findSapUiSizeClass(this);this._drawCalendarPattern();this._drawHeader();this._drawNowLine();this._drawVerticalLine();this._drawExpandedBackground();this._drawShapes();this._drawSelectedShapes(true);delete this._mTimeouts._drawSvg;this.$().find(".sapGanttChartSvg").css("transform",this._oTT.$().find(".sapUiTableCtrlRowScroll").css("transform"));this._iFirstVisiableRowIndex=this._oTT.getFirstVisibleRow();this._bCanApplyTableTransform=true;this.fireEvent("_shapesUpdated",{aSvg:q("#"+this.getId()+"-svg")});this._bSelectedStatusUpdated=undefined;q.sap.measure.end("GanttChart _drawSvg");};m.prototype._drawHeader=function(){var g=q(this.getDomRef()).find(".sapGanttChartHeader");var n=g.height();var H=d3.select(q(this.getDomRef()).find(".sapGanttChartHeaderSvg").get(0));H.attr("height",n);var j=n/5*2;var k=n/5*4;var l=n/5*4;var L=this.getAxisTime().getTickTimeIntervalLabel(this.getAxisTime().getCurrentTickTimeIntervalKey(),null,[0,this._oStatusSet.nWidth]);H.selectAll("g").remove();var o=H.append("g");o.selectAll("label0").data(L[0]).enter().append("text").classed("sapGanttTimeHeaderSvgText0",true).text(function(d){return d.label;}).attr("x",function(d){return d.value;}).attr("y",function(d){return j;}).attr("text-anchor","start");o.selectAll("label1").data(L[1]).enter().append("text").classed("sapGanttTimeHeaderSvgText1",true).text(function(d){return d.label;}).attr("x",function(d){return d.value+(C.getConfiguration().getRTL()?-5:5);}).attr("y",function(d){return l;});if((D.browser.msie||D.browser.edge)&&C.getConfiguration().getRTL()){d3.selectAll(".sapGanttChartHeader .sapGanttTimeHeaderSvgText0").each(function(d,i){d3.select(this).attr("transform",function(d){var O="translate("+(-U.calculateStringLength(d.label)*parseInt($(".sapGanttTimeHeaderSvgText0").css("font-size"),10)/2)+")";return O;});});d3.selectAll(".sapGanttChartHeader .sapGanttTimeHeaderSvgText1").each(function(d,i){d3.select(this).attr("transform",function(d){var O="translate("+(-U.calculateStringLength(d.label)*parseInt($(".sapGanttTimeHeaderSvgText1").css("font-size"),10)/2)+")";return O;});});}var p="";for(var i=0;i<L[1].length;i++){var r=L[1][i];if(r){p+=" M"+" "+(r.value-1/2)+" "+k+" L"+" "+(r.value-1/2)+" "+n;}}o.append("path").classed("sapGanttTimeHeaderSvgPath",true).attr("d",p);};m.prototype._drawCalendarPattern=function(){var g=d3.select("#"+this.getId()+"-svg");this._oCalendarPatternDrawer.drawSvg(g,this.getId(),this.getCalendarDef(),this._oStatusSet,this.getBaseRowHeight());};m.prototype._drawNowLine=function(){this._oNowlineDrawer=new N(this._oAxisTime);var g=d3.select("#"+this.getId()+"-header-svg"),d=d3.select("#"+this.getId()+"-svg");if(this.getEnableNowLine()){this._oNowlineDrawer.drawSvg(d,g);}else{this._oNowlineDrawer.destroySvg(d,g);}};m.prototype._drawVerticalLine=function(){this._oVerticalLineDrawer=new V(this.getAxisTime());var g=d3.select("#"+this.getId()+"-svg");if(this.getEnableVerticalLine()){this._oVerticalLineDrawer.drawSvg(g);}else{this._oVerticalLineDrawer.destroySvg(g);}};m.prototype._drawExpandedBackground=function(){var s=d3.select("#"+this.getId()+"-svg");if(!this._oTT||!this._oTT.getRows()||this._oTT.getRows().length<=0){return;}if(this._aFilteredRowData){var o=this._composeChartSchemeBackgroundConfig();this._oExpandedBackgroundDrawer.drawSvg(s,this._aFilteredRowData,o);}};m.prototype._composeChartSchemeBackgroundConfig=function(){var o=this._oChartSchemesConfigMap;var B={};if(o){for(var s in o){if(o[s].getHaveBackground()){B[s]=o[s].getBackgroundClass();}}}return B;};m.prototype._drawShapes=function(){var s=d3.select("#"+this.getId()+"-svg");if(this._aFilteredRowData&&this._aShapeInstance&&this._aShapeInstance.length>0){this._collectDataPerShapeId();var r=this._oShapeCrossRowDrawer.generateRelationshipDataSet(s,this._oShapeInstance,this._aNonVisibleShapeData,this.getShapeDataNames(),this._aRelationships,this._oAxisTime,this._oAxisOrdinal);for(var i=0;i<this._aShapeInstance.length;i++){switch(this._aShapeInstance[i].getCategory(null,this._oAxisTime,this._oAxisOrdinal)){case sap.gantt.shape.ShapeCategory.InRowShape:this._oShapeInRowDrawer.drawSvg(s,this._aShapeInstance[i],this._oAxisTime,this._oAxisOrdinal,this._oStatusSet);break;case sap.gantt.shape.ShapeCategory.Relationship:this._aShapeInstance[i].dataSet=this._judgeDisplayableOfRLS(this._aShapeInstance[i])?r:[];this._oShapeCrossRowDrawer.drawSvg(s,this._aShapeInstance[i],this._oAxisTime,this._oAxisOrdinal);break;default:break;}}}};m.prototype._drawSelectedShapes=function(i){var s=d3.select("#"+this.getId()+"-svg");if(!i){this._setSelectedStatusToData();}this._collectSelectedDataPerShapeId();var r=this._oShapeCrossRowDrawer.generateRelationshipDataSet(s,this._oShapeInstance,this._aNonVisibleShapeData,this.getShapeDataNames(),this._aSelectedRelationships,this._oAxisTime,this._oAxisOrdinal);for(var d in this._oShapeInstance){var o=this._oShapeInstance[d].getAggregation("selectedShape");var g=o.getCategory(null,this._oAxisTime,this._oAxisOrdinal);switch(g){case sap.gantt.shape.ShapeCategory.InRowShape:this._oShapeInRowDrawer.drawSvg(s,o,this._oAxisTime,this._oAxisrdinal,this._oStatusSet);break;case sap.gantt.shape.ShapeCategory.Relationship:o.dataSet=r;this._oShapeCrossRowDrawer.drawSvg(s,o,this._oAxisTime,this._oAxisOrdinal);break;default:break;}}};m.prototype._collectDataPerShapeId=function(){var j=(this._oTT.getBinding("rows").getMetadata().getName()==="sap.ui.model.json.JSONTreeBinding");var r,s;for(var d in this._oShapeInstance){var g=this._oShapeInstance[d].mShapeConfig.getShapeDataName();this._oShapeInstance[d].dataSet=[];if(this._oShapeInstance[d]._attributeNameBindingMap){this._oShapeInstance[d]._attributeNameBindingMap=undefined;}for(var i=0;i<this._aFilteredRowData.length;i++){r=this._aFilteredRowData[i];if(r.isBlank){continue;}if(!g){this._oShapeInstance[d].dataSet.push({"objectInfoRef":r,"shapeData":r.data});continue;}if(!this._judgeDisplayableByShapeId(r,d)){continue;}if(j){s=r.data[g];}else if(g==r.shapeName){s=r.shapeData;}else{continue;}if(s){this._oShapeInstance[d].dataSet.push({"objectInfoRef":r,"shapeData":s});}}}};m.prototype._collectSelectedDataPerShapeId=function(){for(var s in this._oShapeInstance){var d=this._oShapeInstance[s].mShapeConfig.getShapeDataName()?this._oShapeInstance[s].mShapeConfig.getShapeDataName():undefined;var o=this._oShapeInstance[s].getAggregation("selectedShape");var g=o.getCategory(null,this._oAxisTime,this._oAxisOrdinal);o.dataSet=[];if(g==sap.gantt.shape.ShapeCategory.Relationship){var k=[];for(var j in this._aSelectedRelationships){var r=this._aSelectedRelationships[j];if(this._getShapeDataById(r.id,true)!==undefined){k.push(r);}}o.dataSet.push({"shapeData":k});}else if(this._oSelectedShapes[d]!==undefined){for(var i in this._oSelectedShapes[d]){var l=this._oSelectedShapes[d][i];var n=this._getVisibleRowByShapeUid(l.shapeUid);if(n!==undefined&&n!==null&&this._judgeDisplayableByShapeId(n,s)){l.objectInfoRef=n;o.dataSet.push({"objectInfoRef":l.objectInfoRef,"shapeData":[l.shapeData]});}}}}};m.prototype._judgeDisplayableByShapeId=function(r,s){var d,o,g,M;if(r.chartScheme){d=r.chartScheme;}else{d=this._oObjectTypesConfigMap[r.data.type]?this._oObjectTypesConfigMap[r.data.type].getMainChartSchemeKey():sap.gantt.config.DEFAULT_CHART_SCHEME_KEY;}o=this._oChartSchemesConfigMap[d];if(o==undefined){return false;}g=o.getShapeKeys();M=o.getModeKey()!==sap.gantt.config.DEFAULT_MODE_KEY?o.getModeKey():this.getMode();if((d!==sap.gantt.config.DEFAULT_CHART_SCHEME_KEY&&g.indexOf(s)<0)||(M!==sap.gantt.config.DEFAULT_MODE_KEY&&this._oShapesConfigMap[s].getModeKeys()&&this._oShapesConfigMap[s].getModeKeys().length>0&&this._oShapesConfigMap[s].getModeKeys().indexOf(M)<0)||!r.data){return false;}return true;};m.prototype._judgeDisplayableOfRLS=function(s){var d=this._oShapesConfigMap[s.mShapeConfig.getKey()]?this._oShapesConfigMap[s.mShapeConfig.getKey()].getModeKeys():[];if(q.inArray(this.getMode(),d)<0&&this.getMode()!==sap.gantt.config.DEFAULT_MODE_KEY){return false;}return true;};m.prototype._getUidById=function(I,r){var u=[];if(r){for(var i in this._aRelationships){var o=this._aRelationships[i];if(o.id==I){u.push(o.uid);break;}}}else{var d=this.getAllRowData();q.each(d,function(k,v){var g=v;for(var s in g.data){if(g.data[s]instanceof Array){for(var i in g.data[s]){if(g.data[s][i].id==I){u.push(g.data[s][i].uid);}}}}});}return u;};m.prototype._getShapeDataByUid=function(u,r){if(r){for(var i in this._aRelationships){var o=this._aRelationships[i];if(o.uid===u){return o;}}}else{var d=this._getRowByShapeUid(u);var s=U.getShapeDataNameByUid(u);if(d!==undefined&&d.data[s]!==undefined){for(var j=0;j<d.data[s].length;j++){var g=d.data[s][j];if(g.uid==u){return g;}}}}return undefined;};m.prototype._getShapeDataById=function(I,r){var s=[];var u=this._getUidById(I,r);for(var i in u){var o=this._getShapeDataByUid(u[i],r);if(o!==undefined){s.push(o);}}return s;};m.prototype._getRowByShapeUid=function(s){var r;var d=U.getShapeDataNameByUid(s);var j=(this._oTT.getBinding("rows").getMetadata().getName()==="sap.ui.model.json.JSONTreeBinding");var g=U.getChartSchemeByShapeUid(s);var l=this.getAllRowData();q.each(l,function(k,v){var n=v;if(g===""||g===n.chartScheme){if(j&&n.data[d]){for(var i=0;i<n.data[d].length;i++){if(n.data[d][i].uid==s){r=n;return false;}}}else if(n.data.uid===s){r=n;return false;}}});return r;};m.prototype._getVisibleRowByShapeUid=function(s){var r;var d=U.getShapeDataNameByUid(s);var j=(this._oTT.getBinding("rows").getMetadata().getName()==="sap.ui.model.json.JSONTreeBinding");var g=U.getChartSchemeByShapeUid(s);q.each(this._aFilteredRowData,function(k,v){var l=v;if(g===""||g===l.chartScheme){if(j&&l.data[d]){for(var i=0;i<l.data[d].length;i++){if(l.data[d][i].uid==s){r=l;return false;}}}else if(l.data.uid===s){r=l;return false;}}});return r;};m.prototype._getRowById=function(r){var d;var g=this.getAllRowData();q.each(g,function(k,v){var i=v;if(i.data.id==r){d=i;return false;}});return d;};m.prototype._getSvgCoodinateByDiv=function(n,x,y){var o=n.createSVGPoint();o.x=x;o.y=y;o=o.matrixTransform(n.getScreenCTM().inverse());o.svgHeight=n.height.baseVal.value;o.svgId=this.getId()+"-svg";return o;};m.prototype._getTopShapeInstance=function(s,d){if(d!==undefined){var o=this._getShapeIdById(d);if(o!==undefined&&o!==null){if(o.topShapeId!==undefined){return this._oShapeInstance[o.topShapeId];}else{return this._oShapeInstance[o.shapeId];}}}else{var g=U.getShapeDataNameByUid(s.uid);for(var i in this._oShapeInstance){var j=this._oShapeInstance[i].mShapeConfig.getShapeDataName();if(g===j){var t=this._customerClassIds[i].topShapeId;if(t!==undefined){return this._oShapeInstance[t];}else{return this._oShapeInstance[i];}}}}return undefined;};m.prototype._judgeEnableSelection=function(s,d){if(s===undefined){return false;}var t=this._getTopShapeInstance(s,d);if(t!==undefined){return t.getEnableSelection(s);}var o=sap.ui.getCore().byId(d);if(o){return o.getEnableSelection(s);}return false;};m.prototype._judgeEnableDnD=function(s,d){if(s===undefined){return false;}var t=this._getTopShapeInstance(s,d);if(t!==undefined){return t.getEnableDnD(s);}var o=sap.ui.getCore().byId(d);if(o){return o.getEnableDnD(s);}return false;};m.prototype._selectShape=function(s){var r=this._getRowByShapeUid(s.uid);if(r==undefined){return false;}if(this._aSelectedShapeUids===undefined){this._aSelectedShapeUids=[];}var d=U.getShapeDataNameByUid(s.uid);if(this._oSelectedShapes[d]!==undefined&&this._oSelectedShapes[d]!==null){var g=this._oSelectedShapes[d];if(q.inArray(s.uid,this._aSelectedShapeUids)>-1){return false;}else{this._aSelectedShapeUids.push(s.uid);g.push({"shapeUid":s.uid,"shapeData":s,"objectInfoRef":r});return true;}}else{this._aSelectedShapeUids.push(s.uid);this._oSelectedShapes[d]=[];this._oSelectedShapes[d].push({"shapeUid":s.uid,"shapeData":s,"objectInfoRef":r});return true;}};m.prototype._deselectShape=function(s){var d=U.getShapeDataNameByUid(s.uid);if(q.inArray(s.uid,this._aSelectedShapeUids)>-1){var I=this._aSelectedShapeUids.indexOf(s.uid);this._aSelectedShapeUids.splice(I,1);var g=this._oSelectedShapes[d];for(var i in g){if(g[i].shapeUid===s.uid){g.splice(i,1);break;}}return true;}return false;};m.prototype.getAxisOrdinal=function(){return this._oAxisOrdinal;};m.prototype.getAxisTime=function(){return this._oAxisTime;};m.prototype.ondblclick=function(o){return null;};m.prototype.onclick=function(o){return null;};m.prototype.getSapUiSizeClass=function(){return this._sUiSizeMode;};m.prototype.setFirstVisibleRow=function(r){this._oTT.setFirstVisibleRow(r);return this;};m.prototype._getVisibleRowCount=function(){return this._oTT.getVisibleRowCount()+1;};m.prototype._setLargeDataScrolling=function(l){if(this._oTT._setLargeDataScrolling){this._oTT._setLargeDataScrolling(!!l);}};m.prototype.exit=function(){this._detachEvents();this._cleanUpTimers();};m.prototype._cleanUpTimers=function(){for(var k in this._mTimeouts){if(this._mTimeouts[k]){clearTimeout(this._mTimeouts[k]);this._mTimeouts[k]=undefined;}}};m.prototype.updateTableSize=function(){if(this._oTT._updateTableSizes){this._oTT._updateTableSizes();}};return m;},true);
