/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

		(c) Copyright 2009-2015 SAP SE. All rights reserved
	
 */
sap.ui.define(["sap/ui/core/Control","sap/ui/layout/Splitter","sap/ui/layout/SplitterLayoutData","sap/ui/core/Orientation","./legend/LegendContainer","./control/Toolbar","./control/AssociateContainer","./config/TimeHorizon","./misc/Utility"],function(C,S,a,O,L,T,A,b,U){"use strict";var G=C.extend("sap.gantt.GanttChartContainer",{metadata:{library:"sap.gantt",properties:{width:{type:"sap.ui.core.CSSSize",defaultValue:"100%"},height:{type:"sap.ui.core.CSSSize",defaultValue:"100%"},enableTimeScrollSync:{type:"boolean",defaultValue:true},enableCursorLine:{type:"boolean",defaultValue:true},enableNowLine:{type:"boolean",defaultValue:true},enableVerticalLine:{type:"boolean",defaultValue:true},svgDefs:{type:"sap.gantt.def.SvgDefs",defaultValue:null},modes:{type:"array",defaultValue:sap.gantt.config.DEFAULT_MODES},toolbarSchemes:{type:"array",defaultValue:sap.gantt.config.DEFAULT_CONTAINER_TOOLBAR_SCHEMES},hierarchies:{type:"array",defaultValue:sap.gantt.config.DEFAULT_HIERARCHYS},containerLayouts:{type:"array",defaultValue:sap.gantt.config.DEFAULT_CONTAINER_LAYOUTS},containerLayoutKey:{type:"string",defaultValue:sap.gantt.config.DEFAULT_CONTAINER_SINGLE_LAYOUT_KEY},sliderStep:{type:"int",defaultValue:10},maxNumOfGanttCharts:{type:"int",defaultValue:3}},aggregations:{legendContainer:{type:"sap.gantt.legend.LegendContainer",multiple:false,visibility:"public"},customToolbarItems:{type:"sap.ui.core.Control",multiple:true,visibility:"public",singularName:"customToolbarItem",bindable:"bindable"},ganttCharts:{type:"sap.gantt.GanttChartBase",multiple:true,visibility:"public",singularName:"ganttChart",bindable:"bindable"},_toolbar:{type:"sap.gantt.control.Toolbar",multiple:false,visibility:"hidden"}},events:{ganttChartChangeRequested:{parameters:{action:{type:"string"},ganttChartIndex:{type:"int"},hierarchyKey:{type:"string"},oldHierarchyKey:{type:"string"},containerLayoutKey:{type:"string"}}},customSettingChange:{parameters:{id:{type:"string"},value:{type:"boolean"}}},treeTableToggleEvent:{parameters:{rowIndex:{type:"int"},rowContext:{type:"object"},expanded:{type:"boolean"}}}}}});G.prototype.init=function(){jQuery.sap.measure.start("GanttChartContainer Init","GanttPerf:GanttChartContainer Init function");this._bInitHorizonApplied=false;this._oToolbar=new T({type:sap.gantt.control.ToolbarType.Global,sourceId:sap.gantt.config.DEFAULT_CONTAINER_SINGLE_LAYOUT_KEY});this._oToolbar.setSliderStep(this.getSliderStep());this.setAggregation("_toolbar",this._oToolbar);this._oToolbar.attachSourceChange(this._onToolbarSourceChange,this);this._oToolbar.attachLayoutChange(this._onToolbarLayoutChange,this);this._oToolbar.attachExpandChartChange(this._onToolbarExpandChartChange,this);this._oToolbar.attachZoomRateChange(this._onToolbarZoomRateChange,this);this._oToolbar.attachSettingsChange(this._onToolbarSettingsChange,this);this._oToolbar.data("holder",this);this._oSplitter=new S({width:"100%",height:"100%",orientation:O.Vertical});this._oSplitter.attachResize(this._onSplitterResize,this);this._oModesConfigMap={};this._oModesConfigMap[sap.gantt.config.DEFAULT_MODE_KEY]=sap.gantt.config.DEFAULT_MODE;this._oToolbarSchemeConfigMap={};this._oToolbarSchemeConfigMap[sap.gantt.config.DEFAULT_CONTAINER_TOOLBAR_SCHEME_KEY]=sap.gantt.config.DEFAULT_CONTAINER_TOOLBAR_SCHEME;this._oToolbarSchemeConfigMap[sap.gantt.config.DEFAULT_GANTTCHART_TOOLBAR_SCHEME_KEY]=sap.gantt.config.DEFAULT_GANTTCHART_TOOLBAR_SCHEME;this._oToolbarSchemeConfigMap[sap.gantt.config.EMPTY_TOOLBAR_SCHEME_KEY]=sap.gantt.config.EMPTY_TOOLBAR_SCHEME;this._oHierarchyConfigMap={};this._oHierarchyConfigMap[sap.gantt.config.DEFAULT_HIERARCHY_KEY]=sap.gantt.config.DEFAULT_HIERARCHY;this._oContainerLayoutConfigMap={};this._oContainerLayoutConfigMap[sap.gantt.config.DEFAULT_CONTAINER_SINGLE_LAYOUT_KEY]=sap.gantt.config.DEFAULT_CONTAINER_SINGLE_LAYOUT;this._oContainerLayoutConfigMap[sap.gantt.config.DEFAULT_CONTAINER_DUAL_LAYOUT_KEY]=sap.gantt.config.DEFAULT_CONTAINER_DUAL_LAYOUT;jQuery.sap.measure.end("GanttChartContainer Init");};G.prototype.applySettings=function(s,o){var r=C.prototype.applySettings.apply(this,arguments);if(this.getContainerLayouts()&&this.getContainerLayoutKey()){this.switchOrientation(null,true);}return r;};G.prototype.setModes=function(m){this.setProperty("modes",m);this._oToolbar.setModes(m);this._oModesConfigMap={};if(m){for(var i=0;i<m.length;i++){this._oModesConfigMap[m[i].getKey()]=m[i];}}return this;};G.prototype.setSliderStep=function(s){this.setProperty("sliderStep",s);this._oToolbar.setSliderStep(s);return this;};G.prototype.setTimeZoomRate=function(t){var g=this.getGanttCharts();var i,o;for(i=0;i<g.length;i++){o=g[i];o.setTimeZoomRate(t);}this._setToolbarZoomInfo();return this;};G.prototype.setToolbarSchemes=function(t){this.setProperty("toolbarSchemes",t);this._oToolbar.setToolbarSchemes(t);this._oToolbarSchemeConfigMap={};if(t){for(var i=0;i<t.length;i++){this._oToolbarSchemeConfigMap[t[i].getKey()]=t[i];}}return this;};G.prototype.setHierarchies=function(h){this.setProperty("hierarchies",h);this._oToolbar.setHierarchies(h);this._oHierarchyConfigMap={};if(h){for(var i=0;i<h.length;i++){this._oHierarchyConfigMap[h[i].getKey()]=h[i];}}return this;};G.prototype.setContainerLayouts=function(c){this.setProperty("containerLayouts",c);this._oToolbar.setContainerLayouts(c);this._oContainerLayoutConfigMap={};if(c){for(var i=0;i<c.length;i++){this._oContainerLayoutConfigMap[c[i].getKey()]=c[i];}}if(this.getContainerLayoutKey()){this.switchOrientation(null,true);}return this;};G.prototype.setEnableCursorLine=function(e){this.setProperty("enableCursorLine",e);var g=this.getGanttCharts();for(var i=0;i<g.length;i++){g[i].setEnableCursorLine(e);}this.getAggregation("_toolbar").setEnableCursorLine(e);return this;};G.prototype.setEnableNowLine=function(e){this.setProperty("enableNowLine",e);var g=this.getGanttCharts();for(var i=0;i<g.length;i++){g[i].setEnableNowLine(e);}this.getAggregation("_toolbar").setEnableNowLine(e);return this;};G.prototype.setEnableVerticalLine=function(e){this.setProperty("enableVerticalLine",e);var g=this.getGanttCharts();for(var i=0;i<g.length;i++){g[i].setEnableVerticalLine(e);}this.getAggregation("_toolbar").setEnableVerticalLine(e);return this;};G.prototype.setEnableTimeScrollSync=function(e){this.setProperty("enableTimeScrollSync",e);var g=this.getGanttCharts();for(var i=0;i<g.length;i++){g[i].detachHorizontalScroll(this._onGanttChartHSBScroll,this);if(e){g[i].attachHorizontalScroll(this._onGanttChartHSBScroll,this);}}this.getAggregation("_toolbar").setEnableTimeScrollSync(e);return this;};G.prototype.setContainerLayoutKey=function(c){if(this.getProperty("containerLayoutKey")===c){return this;}this.setProperty("containerLayoutKey",c);this._oToolbar.setSourceId(c);if(this.getContainerLayouts()){this.switchOrientation(null,true);}return this;};G.prototype.setLegendContainer=function(l){this.setAggregation("legendContainer",l);if(l){this._oToolbar.setLegend(new A({content:l.getId()}));}return this;};G.prototype.addCustomToolbarItem=function(c){this._oToolbar.addCustomToolbarItem(c);};G.prototype.insertCustomToolbarItem=function(c,i){this._oToolbar.insertCustomToolbarItem(c,i);};G.prototype.removeCustomToolbarItem=function(c){this._oToolbar.removeCustomToolbarItem(c);};G.prototype.removeAllCustomToolbarItems=function(){this._oToolbar.removeAllCustomToolbarItems();};G.prototype.addGanttChart=function(g){if(this.getGanttCharts().length<this.getMaxNumOfGanttCharts()){this.addAggregation("ganttCharts",g);this._insertGanttChart(g);}};G.prototype.insertGanttChart=function(g,i){if(this.getGanttCharts().length<this.getMaxNumOfGanttCharts()){this.insertAggregation("ganttCharts",g,i);this._insertGanttChart(g,i);}};G.prototype.removeGanttChart=function(g){this._removeGanttChart(g);this.removeAggregation("ganttCharts",g);};G.prototype.removeAllGanttCharts=function(){var g=this.getGanttCharts();for(var i=0;i<g.length;i++){this._removeGanttChart(g[i]);}this.removeAllAggregation("ganttCharts");};G.prototype._insertGanttChart=function(g,i){jQuery.sap.measure.start("GanttChartContainer _insertGanttChart","GanttPerf:GanttChartContainer _insertGanttChart function");if(!g){return;}var r=true;var s="30%";if(this._oSplitter.getContentAreas().length>0){r=false;var f=this.getGanttCharts()[0]._oSplitter;if(f&&f.getContentAreas().length>0){var l=f.getContentAreas()[0].getLayoutData();s=l?l.getSize():s;}}g.setSelectionPanelSize(s);var o=new A({content:g.getId(),layoutData:new a({size:"auto"})});if(i!==0&&!i){this._oSplitter.addContentArea(o);}else{this._oSplitter.insertContentArea(o,i);}this._adjustSplitterLayoutData(true,r);this._oSplitter.triggerResize(true);if(this.getEnableTimeScrollSync()){g.attachHorizontalScroll(this._onGanttChartHSBScroll,this);}g.attachSplitterResize(this._onViewSplitterResize,this);g.attachGanttChartSwitchRequested(this._onGanttChartSwitchRequested,this);g.attachChartDragEnter(this._onChartDragEnter,this);g.attachChartDragLeave(this._onChartDragLeave,this);g.attachShapeDragEnd(this._onChartDragEnd,this);g.attachTreeTableToggleEvent(this._onTreeTableToggle,this);g.attachEvent("_zoomInfoUpdated",this._onZoomInfoUpdated,this);g.attachEvent("_shapesUpdated",this._onShapesUpdated,this);jQuery.sap.measure.end("GanttChartContainer _insertGanttChart");};G.prototype._onSplitterResize=function(){var g=this.getGanttCharts();if(g){g.forEach(function(o){if(o.updateTableSize){o.updateTableSize();}});}};G.prototype._adjustSplitterLayoutData=function(n,r){if(r){this._setSelectionPanelLayoutByConfiguration();}var c=this._oSplitter.getContentAreas();var t=this;if(c){c.forEach(function(o,i){if(o.getLayoutData()){if(i%2==0){var l=Math.floor(1/c.length*100);var s=o.getLayoutData().getSize();if(r){s=t.getConfiguredGanttChartLayoutSize(t.getGanttCharts()[i]);}else if(n){s=l+"%";}if(s=="auto"||(!r&&(s=="100%"||c.length==1))){o.getLayoutData().setSize(l+"%");}else{o.getLayoutData().setSize(s);}}else{if(o.getLayoutData().getSize()!=="auto"){o.getLayoutData().setSize("auto");}}}});}};G.prototype.getConfiguredGanttChartLayoutSize=function(g){var c=this._oContainerLayoutConfigMap[this.getContainerLayoutKey()];var s="auto";if(c){var d=c.getGanttChartLayouts();if(d){for(var i=0;i<d.length;i++){if(d[i]&&g&&d[i].getHierarchyKey()===g.getHierarchyKey()){s=d[i].getGanttChartSize()?d[i].getGanttChartSize():s;break;}}}}return s;};G.prototype.getConfiguredSelectionPanelLayoutSize=function(){var s="30%";var c=this._oContainerLayoutConfigMap[this.getContainerLayoutKey()];if(c){var d=c.getSelectionPanelSize();s=(d&&d!=="auto")?d:s;}return s;};G.prototype._setSelectionPanelLayoutByConfiguration=function(r){var s=this.getConfiguredSelectionPanelLayoutSize();var g=this.getGanttCharts();if(g&&s){g.forEach(function(o,i){o.setSelectionPanelSize(s);});}};G.prototype._removeGanttChart=function(g){var o=g;if((typeof g)==="number"){o=this.getGanttCharts()[g];}if(o){this._oSplitter.removeContentArea(o._oAC);this._adjustSplitterLayoutData(true);this._oSplitter.triggerResize(true);o.detachHorizontalScroll(this._onGanttChartHSBScroll,this);o.detachSplitterResize(this._onViewSplitterResize,this);o.detachGanttChartSwitchRequested(this._onGanttChartSwitchRequested,this);o.detachChartDragEnter(this._onChartDragEnter,this);o.detachChartDragLeave(this._onChartDragLeave,this);o.detachShapeDragEnd(this._onChartDragEnd,this);o.detachTreeTableToggleEvent(this._onTreeTableToggle,this);}};G.prototype.onBeforeRendering=function(){this._detachEvents();this._oToolbar.setEnableTimeScrollSync(this.getEnableTimeScrollSync());this._oToolbar.setEnableCursorLine(this.getEnableCursorLine());this._oToolbar.setEnableNowLine(this.getEnableNowLine());this._oToolbar.setEnableVerticalLine(this.getEnableVerticalLine());var g=this.getGanttCharts();for(var i=0;i<g.length;i++){var o=g[i];o.setEnableCursorLine(this.getEnableCursorLine());o.setEnableNowLine(this.getEnableNowLine());o.setEnableVerticalLine(this.getEnableVerticalLine());}};G.prototype._detachEvents=function(){};G.prototype.onAfterRendering=function(){this._attachEvents();};G.prototype._attachEvents=function(){};G.prototype._detachToolbarEvents=function(){this._oToolbar.detachSourceChange(this._onToolbarSourceChange,this);this._oToolbar.detachLayoutChange(this._onToolbarLayoutChange,this);this._oToolbar.detachExpandChartChange(this._onToolbarExpandChartChange,this);this._oToolbar.detachZoomRateChange(this._onToolbarZoomRateChange,this);this._oToolbar.detachSettingsChange(this._onToolbarSettingsChange,this);};G.prototype._onGanttChartHSBScroll=function(e){var l=e.getParameters().leftOffsetRate;var g=this.getGanttCharts();for(var i=0;i<g.length;i++){if(e.oSource.getId()===g[i].getId()){continue;}g[i].jumpToPosition(l);}};G.prototype._onViewSplitterResize=function(e){if(this._oSplitter.getOrientation()===O.Vertical){this._syncSelectionPanelSizeBetweenViews(e);}};G.prototype._onShapesUpdated=function(e){var i,g;var c=this.getGanttCharts();if(!this._bInitHorizonApplied){for(i=0;i<c.length;i++){g=c[i];g.jumpToPosition();}this._bInitHorizonApplied=true;}};G.prototype._onZoomInfoUpdated=function(e){var i,g;var c=this.getGanttCharts();var l=this._oToolbar.getZoomRate();var z=e.getParameter("zoomInfo");if(!l||!U.floatEqual(l,z.determinedByConfig.fRate)){for(i=0;i<c.length;i++){if(e.oSource.getId()!==c[i].getId()){g=c[i];g.setTimeZoomRate(z.determinedByConfig.fRate);}}}this._setToolbarZoomInfo(e);};G.prototype._setToolbarZoomInfo=function(e){var z;var g=this.getGanttCharts();for(var i=0;i<g.length;i++){var c;if(e&&e.oSource.getId()===g[i].getId()){c=e.getParameter("zoomInfo");}else{c=g[i].getZoomInfo();}if(!z||(c&&z.determinedByChartWidth.fMinRate<c.determinedByChartWidth.fMinRate)){z=c;}}this._oToolbar.setZoomInfo(z);};G.prototype._syncSelectionPanelSizeBetweenViews=function(e){var g=this.getGanttCharts();for(var i=0;i<g.length;i++){if(e.oSource.getId()===g[i].getId()&&g.length>1){continue;}var s=e.getParameter("newSizes")[0];var c=e.getParameter("newSizes")[1];if(s>0&&(s+c)!==0){var d=(100*s/(s+c)).toFixed(0);g[i].setSelectionPanelSize(d+"%",true);}}};G.prototype._onGanttChartSwitchRequested=function(e){e.getSource().notifySourceChange();this.fireGanttChartChangeRequested({action:"switchGanttChart",hierarchyKey:e.getParameter("hierarchyKey"),oldHierarchyKey:e.getParameter("oldHierarchyKey"),ganttChartIndex:this.getGanttCharts().indexOf(e.getSource())});};G.prototype._onTreeTableToggle=function(e){this.fireTreeTableToggleEvent({rowIndex:e.getParameter("rowIndex"),rowContext:e.getParameter("rowContext"),expanded:e.getParameter("expanded")});};G.prototype._onToolbarLayoutChange=function(e){var E=e.getParameter("id");var o=e.getParameter("value");switch(E){case"orientation":this.switchOrientation(o);break;case"add":this.fireGanttChartChangeRequested({action:"addGanttChart",hierarchyKey:o.hierarchyKey});break;case"less":this.fireGanttChartChangeRequested({action:"lessGanttChart",hierarchyKey:o.hierarchyKey,ganttChartIndex:o.ganttChartIndex});break;default:break;}};G.prototype._onToolbarSourceChange=function(e){var g=this.getGanttCharts();for(var i=0;i<g.length;i++){g[i].notifySourceChange();}this.setContainerLayoutKey(e.getParameter("id"));this.fireGanttChartChangeRequested({action:"switchContainerLayout",containerLayoutKey:e.getParameter("id")});};G.prototype._onToolbarExpandChartChange=function(e){var E=e.getParameter("isExpand"),c=e.getParameter("expandedChartSchemes");var g=this.getGanttCharts();for(var i=0;i<g.length;i++){g[i].handleExpandChartChange(E,c,null);}};G.prototype._onToolbarZoomRateChange=function(e){var g=this.getGanttCharts();var i,o;for(i=0;i<g.length;i++){o=g[i];o.setTimeZoomRate(e.getParameter("zoomRate"));}};G.prototype._onChartDragEnter=function(e){var s=e.getParameter("originEvent");var g=e.getSource();if(s.button==0&&s.buttons!==0&&this._oDraggingSource!==undefined){g.setDraggingData(this._oDraggingSource);this._oDraggingSource=undefined;}else{this._oDraggingSource=undefined;g.setDraggingData(this._oDraggingSource);}};G.prototype._onChartDragLeave=function(e){var p=e.getParameters();if(p.draggingSource!==undefined){this._oDraggingSource=p.draggingSource;}else{this._oDraggingSource=undefined;}};G.prototype._onChartDragEnd=function(e){this._oDraggingSource=undefined;};G.prototype._onToolbarSettingsChange=function(e){var p=e.getParameters();for(var i=0;i<p.length;i++){switch(p[i].id){case sap.gantt.config.SETTING_ITEM_ENABLE_TIME_SCROLL_SYNC_KEY:if(this.getEnableTimeScrollSync()!==p[i].value){this.setEnableTimeScrollSync(p[i].value);}break;case sap.gantt.config.SETTING_ITEM_ENABLE_CURSOR_LINE_KEY:if(this.getEnableCursorLine()!==p[i].value){this.setEnableCursorLine(p[i].value);}break;case sap.gantt.config.SETTING_ITEM_ENABLE_NOW_LINE_KEY:if(this.getEnableNowLine()!==p[i].value){this.setEnableNowLine(p[i].value);}break;case sap.gantt.config.SETTING_ITEM_ENABLE_VERTICAL_LINE_KEY:if(this.getEnableVerticalLine()!==p[i].value){this.setEnableVerticalLine(p[i].value);}break;default:this.fireCustomSettingChange(p[i]);}}};G.prototype.switchOrientation=function(o,r){var s=this._oSplitter.getOrientation()===O.Horizontal?O.Vertical:O.Horizontal;s=o?o:s;if(r){var c=this.getContainerLayoutKey();if(this._oContainerLayoutConfigMap[c]){s=this._oContainerLayoutConfigMap[c].getOrientation();}}this._oSplitter.setOrientation(s);this._adjustSplitterLayoutData(true,r);this._oSplitter.triggerResize(true);return this;};G.prototype.getToolbarSchemeKey=function(){return this._oToolbar.getToolbarSchemeKey();};G.prototype.selectShapes=function(g,I,c){var d=this.getGanttCharts(),r=false,o;if(g!=undefined&&g<d.length){o=d[g];r=o.selectShapes(I,c);}else{for(var i=0;i<d.length;i++){o=d[i];if(o.selectShapes(I,c)){r=true;}}}return r;};G.prototype.deselectShapes=function(g,i){var c=this.getGanttCharts(),r=false,o;if(g!=undefined&&g<this.getGanttCharts().length){o=this.getGanttCharts()[g];r=o.deselectShapes(i);}else{for(var d in c){o=c[d];if(o.deselectShapes(i)){r=true;}}}return r;};G.prototype.selectRelationships=function(g,I,c){var d=this.getGanttCharts(),r=false,o;if(g!=undefined&&g<d.length){o=d[g];r=o.selectRelationships(I,c);}else{for(var i=0;i<d.length;i++){o=d[i];if(o.selectRelationships(I,c)){r=true;}}}return r;};G.prototype.deselectRelationships=function(g,I){var c=this.getGanttCharts(),r=false,o;if(g!=undefined&&g<c.length){o=c[g];r=o.deselectRelationships(I);}else{for(var i=0;i<c.length;i++){o=c[i];if(o.deselectRelationships(I)){r=true;}}}return r;};G.prototype.selectRows=function(g,I,c){var r=false,d=this.getGanttCharts(),o;if(g!=undefined&&g<d.length){o=d[g];r=o.selectRows(I,c);}else{for(var i=0;i<d.length;i++){o=d[i];if(o.selectRows(I,c)){r=true;}}}return r;};G.prototype.deselectRows=function(g,I){var r=false,c=this.getGanttCharts(),o;if(g!=undefined&&g<c.length){o=c[g];r=o.deselectRows(I);}else{for(var i=0;i<c.length;i++){o=c[i];if(o.deselectRows(I)){r=true;}}}return r;};G.prototype.selectRowsAndShapes=function(g,I,c){var r=false,d=this.getGanttCharts(),o;if(g!=undefined&&g<d.length){o=d[g];r=o.selectRowsAndShapes(I,c);}else{for(var i=0;i<d.length;i++){o=d[i];if(o.selectRowsAndShapes(I,c)){r=true;}}}return r;};G.prototype.getSelectedShapes=function(g){var r=[],c=this.getGanttCharts(),o,s;if(g!=undefined&&g<c.length){o=c[g];s=o.getSelectedShapes();if(s!==undefined){r.push({"ganttChartIndex":g,"selectedShapes":s});}}else{for(var i=0;i<c.length;i++){o=c[i];s=o.getSelectedShapes();if(s!==undefined){r.push({"ganttChartIndex":i,"selectedShapes":s});}}}return r;};G.prototype.getSelectedRows=function(g){var r=[],c=this.getGanttCharts(),o,R;if(g!=undefined&&g<c.length){o=c[g];R=o.getSelectedRows();if(R!==undefined&&R.length>0){r.push({"ganttChartIndex":g,"selectedRows":R});}}else{for(var i=0;i<c.length;i++){o=c[i];R=o.getSelectedRows();if(R!==undefined){r.push({"ganttChartIndex":i,"selectedRows":R});}}}return r;};G.prototype.getSelectedRelationships=function(g){var r=[],c=this.getGanttCharts(),o,R;if(g!=undefined&&g<c.length){o=c[g];R=o.getSelectedRelationships();if(R!==undefined){r.push({"ganttChartIndex":g,"selectedRelationships":R});}}else{for(var i=0;i<c.length;i++){o=c[i];R=o.getSelectedRelationships();if(R!==undefined){r.push({"ganttChartIndex":i,"selectedRelationships":R});}}}return r;};G.prototype.getAllSelections=function(g){var r=[],c=this.getGanttCharts(),o,s;if(g!=undefined&&g<c.length){o=c[g];s=o.getAllSelections();if(s!==undefined){r.push({"ganttChartIndex":g,"allSelection":s});}}else{for(var i=0;i<c.length;i++){o=c[i];s=o.getAllSelections();if(s!==undefined){r.push({"ganttChartIndex":i,"allSelection":s});}}}return r;};G.prototype.exit=function(){this._detachEvents();this._oToolbar.destroy();this._oSplitter.destroy();};return G;},true);
