/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

		(c) Copyright 2009-2015 SAP SE. All rights reserved
	
 */
sap.ui.define(["sap/ui/core/Control","./LegendBase","sap/gantt/drawer/Legend"],function(C,L,a){"use strict";var D=L.extend("sap.gantt.legend.DimensionLegend",{metadata:{properties:{shape:{type:"sap.gantt.config.Shape"},xDimension:{type:"string"},yDimension:{type:"string"},xDomain:{type:"array",defaultValue:[]},yDomain:{type:"array",defaultValue:[]},exclude:{type:"array",defaultValue:[]},legendSpace:{type:"number",defaultValue:8}}}});D.prototype.init=function(){L.prototype.init.apply(this,arguments);this._oDimensionLegendDrawer=new a();};D.prototype.applySettings=function(){var r=C.prototype.applySettings.apply(this,arguments);this._modifyDimensionFunction();return r;};D.prototype._modifyDimensionFunction=function(){var x=this.getXDimension(),y=this.getYDimension();this._oShapeInstance._oLegend=this;this._oShapeInstance._sXDimension=x;this._oShapeInstance._sYDimension=y;this._oShapeInstance["get"+this._capitalFirst(x)]=function(d){if(this.mShapeConfig.hasShapeProperty(this._sXDimension)){return this._configFirst(this._sXDimension,d);}if(d.xIndex===-1){return sap.gantt.DIMENSION_LEGEND_NIL;}return this._oLegend.getXDomain()[d.xIndex];};this._oShapeInstance["get"+this._capitalFirst(y)]=function(d){if(this.mShapeConfig.hasShapeProperty(this._sYDimension)){return this._configFirst(this._sYDimension,d);}if(d.yIndex===-1){return sap.gantt.DIMENSION_LEGEND_NIL;}return this._oLegend.getYDomain()[d.yIndex];};};D.prototype._capitalFirst=function(o){return o.charAt(0).toUpperCase()+(o.length>1?o.slice(1):"");};D.prototype.onAfterRendering=function(){if(this._oShapeInstance){var s=d3.select("#"+this.getId()+"-svg");var l=this._drawDimensionLegend(s,this._oShapeInstance);s.attr("width",l.width+"px");s.attr("height",l.height+"px");var p=d3.select("#"+this.getId()+"-dimension-path");var P=this._drawDimensionPath(p,this._oShapeInstance);p.attr("width",l.width+"px");p.attr("height",P.height+"px");p.style("top",l.height+"px");var t=d3.select("#"+this.getId()+"-dimension-text");this._drawDimensionText(t,this._oShapeInstance);t.style(sap.ui.getCore().getConfiguration().getRTL()?"right":"left",l.width+"px");t.attr("height",l.height+P.height+this.getLegendSpace()*2+"px");}};D.prototype.setShape=function(s){this.setProperty("shape",s);if(s){this._oShapeInstance=this._instantShape([s])[0];}return this;};D.prototype._drawDimensionLegend=function(s,S){var x=this.getXDomain();var d=this._prepareData(S);var r=s.selectAll("."+S.getId()+"-row").data(d);r.enter().append("g").classed(S.getId()+"-row",true);r.exit().remove();if(!r.empty()){this._oDimensionLegendDrawer._recursiveDraw(r,S);}var l={};var i=x.length;if(i>0){l.width=this.getScaledLegendWidth()*i+this.getLegendSpace()*(i+1);l.height=this.getScaledLegendHeight()*d.length+this.getLegendSpace()*(d.length+1);}return l;};D.prototype._prepareData=function(s){var r=[],x=this.getXDimension(),y=this.getYDimension(),X=this.getXDomain(),Y=this.getYDomain(),e=this.getExclude();this.aXDimension=[];this.aYDimension=[];var t=this,l;jQuery.each(X,function(i,v){l={};l.xIndex=i;l.yIndex=-1;t.aXDimension.push(s.getLegend(l));});this.aReversedXDimension=jQuery.extend(true,[],this.aXDimension);this.aReversedXDimension.reverse();jQuery.each(Y,function(i,v){l={};l.xIndex=-1;l.yIndex=i;t.aYDimension.push(s.getLegend(l));});jQuery.each(Y,function(b,o){var R=[];jQuery.each(X,function(c,d){var E=false;jQuery.each(e,function(i,f){if((d==f[0])&&(o==f[1])){E=true;return false;}});if(!E){var l={};l.xIndex=c;l.yIndex=b;l[x]=d;l[y]=o;l.xName=t.aXDimension[c];l.yName=t.aYDimension[b];R.push(l);}});if(R.length>0){r.push(R);}});return r;};D.prototype._drawDimensionPath=function(s,S){var x=this.getXDomain(),X=x.length,t=this;var p=s.selectAll(".dimension-path").data(x);p.enter().append("path").attr("d",function(d,i){var w=t.getScaledLegendWidth();var h=t.getScaledLegendHeight();var b=0,c=c=h*(X-1-i)+t.getLegendSpace()*(X-i),e=w*(X-1-i)+t.getLegendSpace()*(X-i);if(sap.ui.getCore().getConfiguration().getRTL()){b=w*(X-1-i)+t.getLegendSpace()*(X-i)+w/2;e=-e;}else{b=w*i+t.getLegendSpace()*(i+1)+w/2;}return"M"+b+" 0 v"+c+" h"+e;}).attr("fill","none");p.exit().remove();var P={};P.height=0;if(X>0){P.height=this.getScaledLegendHeight()*X+this.getLegendSpace()*(X-1);}return P;};D.prototype._drawDimensionText=function(s,S){var b=this.aYDimension.concat(this.aReversedXDimension);var x=this.aYDimension.length;var t=this;var T=s.selectAll(".dimension-text").data(b);T.enter().append("text").attr("x",function(d){if(sap.ui.getCore().getConfiguration().getRTL()){return 200;}return 0;}).attr("y",function(d,i){return t.getScaledLegendHeight()*i+t.getLegendSpace()*(i+1)+parseInt(t.getFontSize(),10)/2+t.getScaledLegendHeight()/2-2;}).text(function(d){return d;}).attr("font-size",t.getFontSize()+"px").attr("font-style",function(d,i){return i<x?"normal":"italic";}).attr("text-anchor",sap.ui.Device.browser.name==="ie"&&sap.ui.getCore().getConfiguration().getRTL()?"end":"start");T.select("title").remove();T.insert("title",":first-child").text(function(d){return d;});T.exit().remove();};return D;},true);
