/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

		(c) Copyright 2009-2015 SAP SE. All rights reserved
	
 */
sap.ui.define(["sap/gantt/misc/Utility","sap/ui/thirdparty/d3"],function(){"use strict";var A=function(a,s,n,b,c,d,e,f){this.elementArray=a;this.scaleArray=s;this.padding=sap.gantt.misc.Utility.assign(f,0);this.zoomRate=sap.gantt.misc.Utility.assign(d,1);this.zoomOrigin=sap.gantt.misc.Utility.assign(e,0);this.viewRangeStart=sap.gantt.misc.Utility.assign(b,0);this.viewBandWidth=n;this.viewRangeEnd=c;this.scale=d3.scale.ordinal();this._createScale();};A.prototype.CONSTANT={C_SEPARATOR:"_@@_",C_MESSAGE:{ARGUMENT_ERROR:"AxisOrdinal: Argument Error!"}};A.prototype._createScale=function(){if(typeof(this.viewBandWidth)!=="undefined"){this.viewRangeEnd=undefined;this.scale.domain(this._calculateInternalValuesByElements()).rangeRoundBands(this._calculateViewRangeByViewBandWidth());}else if(typeof(this.viewRangeEnd)!=="undefined"){this.viewBandWidth=undefined;this.scale.domain(this._calculateInternalValuesByElements()).rangeRoundBands([this.viewRangeStart,this.viewRangeEnd]);}else{}};A.prototype._calculateInternalValuesByElements=function(){var v=[];for(var i=0;i<this.scaleArray.length;i++){var a=this.elementArray[i]+this.CONSTANT.C_SEPARATOR;for(var j=0;j<this.scaleArray[i];j++){v.push(a+j);}}return v;};A.prototype._calculateViewRangeByViewBandWidth=function(){var v=0;for(var i=0;i<this.scaleArray.length;i++){v+=this.scaleArray[i]*this.viewBandWidth;}return[this.viewRangeStart,this.viewRangeStart+v];};A.prototype.elementToView=function(e){return(this.scale(e+this.CONSTANT.C_SEPARATOR+0)+this.padding-this.zoomOrigin)*this.zoomRate;};A.prototype.viewToElement=function(v){var c=v/this.zoomRate+this.zoomOrigin;var h=0;var t=this.elementArray.length-1;while(h<t){var m=Math.ceil((h+t)/2);var a=this.scale(this.elementArray[m]+this.CONSTANT.C_SEPARATOR+0);if(c<a){t=m-1;}else{h=m;}}var r=this.elementArray[h];var b=this.scale(r+this.CONSTANT.C_SEPARATOR+0);if(c<b+this.padding||c>=b+this.scale.rangeBand()*this.scaleArray[h]){return undefined;}return r;};A.prototype.viewToElementIndex=function(v){var c=v/this.zoomRate+this.zoomOrigin;var h=0;var t=this.elementArray.length-1;while(h<t){var m=Math.ceil((h+t)/2);var a=this.scale(this.elementArray[m]+this.CONSTANT.C_SEPARATOR+0);if(c<a){t=m-1;}else{h=m;}}var r=this.elementArray[h];var b=this.scale(r+this.CONSTANT.C_SEPARATOR+0);if(c<b+this.padding||c>=b+this.scale.rangeBand()*this.scaleArray[h]){return-1;}return h;};A.prototype.viewToBandIndex=function(v){var c=v/this.zoomRate+this.zoomOrigin;var i=this._calculateInternalValuesByElements();var h=0;var t=i.length-1;while(h<t){var m=Math.ceil((h+t)/2);var a=this.scale(i[m]);if(c<a){t=m-1;}else{h=m;}}var r=this.scale(i[h]);if(c<r+this.padding||c>=r+this.scale.rangeBand()){return-1;}return h;};A.prototype.viewToRowIndex=function(v,m){var c=v/this.zoomRate+this.zoomOrigin;var h=0;var a=this._calculateViewRangeByViewBandWidth();if(c<=a[1]&&c>=a[0]){return this.viewToElementIndex(v);}else if(jQuery.isNumeric(m)&&m>this.elementArray.length){var b=parseInt((v-a[1]-a[0])/this.viewBandWidth,10);var r=b+this.elementArray.length;h=r;}else{return-1;}return h;};A.prototype.setElements=function(e,s){this.elementArray=e;this.scaleArray=s;this._createScale();return this;};A.prototype.getElementArray=function(){return this.elementArray;};A.prototype.getScaleArray=function(){return this.scaleArray;};A.prototype.setViewRangeStart=function(v){this.viewBandWidth=undefined;this.viewRangeStart=sap.gantt.misc.Utility.assign(v,0);this.scale.rangeRoundBands([this.viewRangeStart,this.viewRangeEnd]);return this;};A.prototype.setViewRangeEnd=function(v){this.viewBandWidth=undefined;this.viewRangeEnd=v;this.scale.rangeRoundBands([this.viewRangeStart,this.viewRangeEnd]);return this;};A.prototype.getViewRange=function(){var v=this.scale.rangeExtent();return[(v[0]-this.zoomOrigin)*this.zoomRate,(v[1]-this.zoomOrigin)*this.zoomRate];};A.prototype.setViewBandWidth=function(v){this.viewRangeEnd=undefined;this.viewBandWidth=v;this.scale.rangeRoundBands(this._calculateViewRangeByViewBandWidth());return this;};A.prototype.getViewBandWidth=function(){return this.scale.rangeBand()*this.zoomRate;};A.prototype.setZoomRate=function(z){this.zoomRate=sap.gantt.misc.Utility.assign(z,1);return this;};A.prototype.getZoomRate=function(){return this.zoomRate;};A.prototype.setZoomOrigin=function(z){this.zoomOrigin=sap.gantt.misc.Utility.assign(z,0);return this;};A.prototype.getZoomOrigin=function(){return this.zoomOrigin;};A.prototype.clone=function(){return new A(this.elementArray.slice(0),this.scaleArray.slice(0),this.viewBandWidth,this.viewRangeStart,this.viewRangeEnd,this.zoomRate,this.zoomOrigin,this.padding);};return A;},true);
