/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

		(c) Copyright 2009-2015 SAP SE. All rights reserved
	
 */
sap.ui.define(["sap/ui/base/Object","sap/ui/core/Core","sap/gantt/misc/Utility","sap/gantt/misc/Format","sap/ui/thirdparty/d3"],function(B,C,U,F){"use strict";var A=function(t,v,z,a,b,l,Z){this.scale=d3.time.scale().domain(t).range(v).clamp(false);this.timeRange=t;this.viewRange=v;this.zoomRate=U.assign(z,1);this.zoomOrigin=U.assign(a,0);this.viewOffset=U.assign(b,0);this.locale=l;if(l&&l.getUtcdiff()){var f=d3.time.format("%Y%m%d%H%M%S");this.timeZoneOffset=Math.round((f.parse("20000101"+l.getUtcdiff()).getTime()-f.parse("20000101000000").getTime())/1000);if(l.getUtcsign()==="-"){this.timeZoneOffset=-this.timeZoneOffset;}}this._oZoomStrategy=Z?Z:sap.gantt.config.DEFAULT_TIME_ZOOM_STRATEGY;};A.prototype.CONSTANT={C_SEPARATOR:"_@@_",C_MESSAGE:{ARGUMENT_ERROR:"AxisOrdinal: Argument Error!"}};A.prototype.timeToView=function(t){if(C.getConfiguration().getRTL()!==true){return Math.round((this.scale(t)-this.zoomOrigin)*this.zoomRate-this.viewOffset);}else{return Math.round(this.viewRange[1]*this.zoomRate-(((this.scale(t)+this.zoomOrigin)*this.zoomRate)+this.viewOffset));}};A.prototype.viewToTime=function(v){if(C.getConfiguration().getRTL()!==true){return this.scale.invert((v+this.viewOffset)/this.zoomRate+this.zoomOrigin);}else{return this.scale.invert(this.viewRange[1]-(v+this.viewOffset)/this.zoomRate-this.zoomOrigin);}};A.prototype.setTimeRange=function(t){this.timeRange=t;this.scale.domain(t);return this;};A.prototype.getTimeRange=function(){return this.scale.domain();};A.prototype.setViewRange=function(v){this.viewRange=v;this.scale.range(v);return this;};A.prototype.getViewRange=function(){var r=this.scale.range();return[Math.round((r[0]-this.zoomOrigin)*this.zoomRate-this.viewOffset),Math.round((r[1]-this.zoomOrigin)*this.zoomRate-this.viewOffset)];};A.prototype.getZoomStrategy=function(){return this._oZoomStrategy;};A.prototype.setZoomRate=function(z){this.zoomRate=U.assign(z,1);return this;};A.prototype.getZoomRate=function(){return this.zoomRate;};A.prototype.setZoomOrigin=function(z){this.zoomOrigin=U.assign(z,0);return this;};A.prototype.getZoomOrigin=function(){return this.zoomOrigin;};A.prototype.setViewOffset=function(v){this.viewOffset=U.assign(v,0);return this;};A.prototype.getViewOffset=function(){return this.viewOffset;};A.prototype.setLocale=function(l){this.locale=l;if(l&&l.getUtcdiff()){var f=d3.time.format("%Y%m%d%H%M%S");this.timeZoneOffset=Math.round((f.parse("20000101"+l.getUtcdiff()).getTime()-f.parse("20000101000000").getTime())/1000);if(l.getUtcsign()==="-"){this.timeZoneOffset=-this.timeZoneOffset;}}return this;};A.prototype.getLocale=function(){return this.locale;};A.prototype.clone=function(){return new A([new Date(this.timeRange[0].valueOf()),new Date(this.timeRange[1].valueOf())],this.viewRange.slice(0),this.zoomRate,this.zoomOrigin,this.viewOffset,this.locale);};A.prototype.getCurrentTickTimeIntervalLevel=function(){var s=d3.time.format("%Y%m%d%H%M%S").parse("20000101000000");var a=this.scale(s);var c=0;for(var i in this._oZoomStrategy){var b=this._oZoomStrategy[i].innerInterval;var e=this.scale(jQuery.sap.getObject(b.unit).offset(s,b.span));var r=Math.ceil((e-a)*this.zoomRate);if(r>=b.range){return c;}c++;}return c-1;};A.prototype.getCurrentTickTimeIntervalKey=function(){var s=d3.time.format("%Y%m%d%H%M%S").parse("20000101000000");var a=this.scale(s);var c,i;for(i in this._oZoomStrategy){var b=this._oZoomStrategy[i].innerInterval;var e=this.scale(jQuery.sap.getObject(b.unit).offset(s,b.span));var r=Math.ceil((e-a)*this.zoomRate);if(r>=b.range){c=i;break;}}return c?c:i;};A.prototype.getNowLabel=function(){var d=new Date();var u=new Date(d.getTime()+(d.getTimezoneOffset()*60000));var v=this.timeToView(u);var l=d3.time.second.offset(u,this.timeZoneOffset);var z=this._oZoomStrategy[this.getCurrentTickTimeIntervalKey()].smallInterval;var a=F.creatTimeLabel(z,l);return[{"date":l,"value":Math.round(v),"label":a}];};A.prototype.getTickTimeIntervalLabel=function(l,t,v){var i;var a=l;if(typeof l==="number"){var c=0;for(i in this._oZoomStrategy){if(c===l){a=i;break;}c++;}}var p,b;var e=null;if(this.locale&&this.locale.getDstHorizons().length>0){e=this.locale.getDstHorizons();}var f=d3.time.format("%Y%m%d%H%M%S");var g=[];if(e){for(i=0;i<e.length;i++){g[i]={};p=e[i].getStartTime();b=e[i].getEndTime();g[i].startDate=f.parse(p);g[i].endDate=f.parse(b);}}var h=this.timeZoneOffset?[d3.time.second.offset(this.timeRange[0],this.timeZoneOffset),d3.time.second.offset(this.timeRange[1],this.timeZoneOffset)]:this.timeRange;var j=new sap.gantt.misc.AxisTime(h,this.viewRange,this.zoomRate,this.zoomOrigin,this.viewOffset,null);var k=null;var m=null;var n=null;var o=null;var q=null;var r=null;var u=null;var w=[];var x=[];var y=null;if(t){r=this.timeZoneOffset?d3.time.second.offset(t[0],this.timeZoneOffset):t[0];u=this.timeZoneOffset?d3.time.second.offset(t[1],this.timeZoneOffset):t[1];k=this.timeZoneOffset?[d3.time.second.offset(t[0],this.timeZoneOffset),d3.time.second.offset(t[1],this.timeZoneOffset)]:t;m=[this.timeToView(t[0]),this.timeToView(t[1])];if(g&&g.length){this._calculateTimeRange(g,r,u,w);}y=this._calculateScale(w,x,k,m,false);}else if(v){r=this.timeZoneOffset?d3.time.second.offset(this.viewToTime(v[0]),this.timeZoneOffset):this.viewToTime(v[0]);u=this.timeZoneOffset?d3.time.second.offset(this.viewToTime(v[1]),this.timeZoneOffset):this.viewToTime(v[1]);k=[r,u];m=v;if(g.length){this._calculateTimeRange(g,r,u,w);}y=this._calculateScale(w,x,k,m,false);}else{r=h[0];u=h[1];k=h;m=this.viewRange;if(g.length){this._calculateTimeRange(g,r,u,w);}y=this._calculateScale(w,x,k,m,h);}x=y.viewRangeSet;n=y.visibleScale;o=y.dstScale;q=y.normalScale;var z=[];var D,E,G,H;var I=this._oZoomStrategy[a].largeInterval;var J=this._oZoomStrategy[a].smallInterval;var K,L;if(I){var M=[];var N=[];var O=[];if(!(n instanceof Array)){M[0]=n.ticks(jQuery.sap.getObject(I.unit).range,I.span);}else{for(K=0;K<o.length;K++){N[K]=o[K].ticks(jQuery.sap.getObject(I.unit).range,I.span);O[K]=q[K].ticks(jQuery.sap.getObject(I.unit).range,I.span);}for(K=0;K<n.length;K++){M[K]=n[K].ticks(jQuery.sap.getObject(I.unit).range,I.span);}}var P=[];if(M[0]!==null){for(K=0;K<M.length;K++){for(L=0;L<M[K].length;L++){D=M[K][L];G=j.timeToView(D);H=F.creatTimeLabel(I,D);P.push({"date":D,"value":Math.round(G),"label":H});}}}if(N[0]!==null){for(K=0;K<N.length;K++){for(L=0;L<N[K].length;L++){D=N[K][L];E=O[K][L];G=j.timeToView(d3.time.second.offset(D.getTime(),-60*60));H=F.creatTimeLabel(I,D);P.push({"date":D,"value":Math.round(G),"label":H});}}}z.push(P);}else{z.push([]);}if(J){var Q=[];var R=[];var S=[];if(!(n instanceof Array)){S[0]=n.ticks(jQuery.sap.getObject(J.unit).range,J.span);}else{for(K=0;K<o.length;K++){Q[K]=o[K].ticks(jQuery.sap.getObject(J.unit).range,J.span);R[K]=q[K].ticks(jQuery.sap.getObject(J.unit).range,J.span);}for(K=0;K<n.length;K++){S[K]=n[K].ticks(jQuery.sap.getObject(J.unit).range,J.span);}}var T=[];if(S[0]){for(K=0;K<S.length;K++){for(L=0;L<S[K].length;L++){D=S[K][L];var V;var W=false;if(g.length){for(var d=0;d<g.length;d++){if(D.getTime()===g[d].startDate.getTime()){V=d3.time.second.offset(D.getTime(),60*60);if((L===S[K].length-1)&&(a==="1hour"||a==="30min"||a==="15min"||a==="10min"||a==="5min")){W=true;}}if((L===S[K].length-1)&&(D.getTime()===d3.time.second.offset(g[d].endDate.getTime(),60*60).getTime())){V=d3.time.second.offset(D.getTime(),-60*60);}}}G=j.timeToView(D);if(W){break;}else if(V){H=F.creatTimeLabel(J,V);V=null;}else{H=F.creatTimeLabel(J,D);}T.push({"date":D,"value":Math.round(G),"label":H});}}}if(Q[0]){for(K=0;K<Q.length;K++){for(L=0;L<Q[K].length;L++){D=Q[K][L];E=R[K][L];var X;var Y=false;if((L===Q[K].length-1)&&(a==="1hour"||a==="30min"||a==="15min"||a==="10min"||a==="5min")){if(w.length>0){for(var Z=0;Z<w.length;Z++){if((!w[Z].haveDST)&&(E.getTime()===w[Z].range[0].getTime())){Y=true;}}}}if(g.length){for(var s=0;s<g.length;s++){if(D.getTime()===g[s].startDate.getTime()){X=d3.time.second.offset(D.getTime(),60*60);}if((L===Q[K].length-1)&&(D.getTime()===d3.time.second.offset(g[s].endDate.getTime(),60*60).getTime())){X=d3.time.second.offset(D.getTime(),-60*60);}}}if(a!=="1hour"&&a!=="30min"&&a!=="15min"&&a!=="10min"&&a!=="5min"){G=j.timeToView(d3.time.second.offset(D.getTime(),-60*60));}else{G=j.timeToView(E);}if(Y){break;}else if(X){H=F.creatTimeLabel(J,X);X=null;}else{H=F.creatTimeLabel(J,D);}T.push({"date":D,"value":Math.round(G),"label":H});}}}z.push(T);}else{z.push([]);}return z;};A.prototype._calculateScale=function(a,v,b,c,l){var d=null;var e=[];var n=[];if(a.length){d=[];var f=0;var g=0;for(var t=0;t<a.length;t++){v[t]=[this.timeToView(a[t].range[0]),this.timeToView(a[t].range[1])];if(a[t].haveDST){e[f]=new sap.gantt.misc.AxisTime(a[t].dstRange,v[t],this.zoomRate,this.zoomOrigin,this.viewOffset,null).scale;n[f]=new sap.gantt.misc.AxisTime(a[t].range,v[t],this.zoomRate,this.zoomOrigin,this.viewOffset,null).scale;f++;}else{d[g]=new sap.gantt.misc.AxisTime(a[t].range,v[t],this.zoomRate,this.zoomOrigin,this.viewOffset,null).scale;g++;}}}else if(l){d=new sap.gantt.misc.AxisTime(l,this.viewRange,this.zoomRate,this.zoomOrigin,this.viewOffset,null).scale;}else{d=new sap.gantt.misc.AxisTime(b,c,this.zoomRate,this.zoomOrigin,this.viewOffset,null).scale;}var r={"viewRangeSet":v,"visibleScale":d,"dstScale":e,"normalScale":n};return r;};A.prototype._calculateTimeRange=function(d,s,e,a){if(d.length){var b=s;var c=e;var f=[];var g=[];var h,i;h=d[0].startDate;i=d[0].endDate;this._calculateRangeItem(h,i,b,c,f,g);if(d.length>1){for(var j=1;j<d.length;j++){if(f.length){var r=[];for(var k in f){r.push(f[k]);}f=[];for(var t=0;t<r.length;t++){h=d[j].startDate;i=d[j].endDate;b=r[t].range[0];c=r[t].range[1];this._calculateRangeItem(h,i,b,c,f,g);}}}}for(var l in g){a.push(g[l]);}for(var m in f){a.push(f[m]);}}};A.prototype._calculateRangeItem=function(d,a,s,e,t,b){var r=null;if(s<d){if(e<a){if(e>d){r={};r.haveDST=false;r.range=[s,d];t.push(r);r={};r.haveDST=true;r.range=[d,e];r.dstRange=[d3.time.second.offset(d.getTime(),60*60),d3.time.second.offset(e,60*60)];b.push(r);}else{r={};r.haveDST=false;r.range=[s,e];t.push(r);}}else{r={};r.haveDST=false;r.range=[s,d];t.push(r);r={};r.haveDST=true;r.range=[d,a];r.dstRange=[d3.time.second.offset(d.getTime(),60*60),d3.time.second.offset(a.getTime(),60*60)];b.push(r);r={};r.haveDST=false;r.range=[a,e];t.push(r);}}else if(s>=d){if(s<a){if(e<=a){r={};r.haveDST=true;r.range=[s,e];r.dstRange=[d3.time.second.offset(s,60*60),d3.time.second.offset(e,60*60)];b.push(r);}else{r={};r.haveDST=true;r.range=[s,a];r.dstRange=[d3.time.second.offset(s,60*60),d3.time.second.offset(a.getTime(),60*60)];b.push(r);r={};r.haveDST=false;r.range=[a,e];t.push(r);}}else{r={};r.haveDST=false;r.range=[s,e];t.push(r);}}};return A;},true);
