/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/core/Renderer','sap/ui/core/IconPool','sap/ui/core/InvisibleText'],function(q,R,I,a){"use strict";var b={};b.render=function(r,c){var i,d,e=c.getItems(),f=c._iconTabHeader,g=true,h,j=sap.ui.getCore().getConfiguration().getRTL(),l=e.length;if(f){g=f._bTextOnly;h=this.checkIconOnly(e);}var o={isTextOnly:g,isIconOnly:h,isRtl:j,length:l,resourceBundle:sap.ui.getCore().getLibraryResourceBundle('sap.m')};r.write("<ul");r.writeAttribute('role','listbox');r.writeControlData(c);r.addClass("sapMITBSelectList");if(g){r.addClass("sapMITBSelectListTextOnly");}r.writeClasses();r.write(">");for(i=0;i<e.length;i++){d=e[i];o.index=i;this.renderItem(r,c,d,o);}r.write("</ul>");};b.checkIconOnly=function(c){var d;for(var i=0;i<c.length;i++){d=c[i];if(d.getText()||d.getCount()){return false;}}return true;};b.renderItem=function(r,c,i,o){if(!i.getVisible()){return;}r.write('<li');r.writeElementData(i);r.writeAttribute('tabindex','-1');r.writeAttribute('role','option');r.writeAttribute('aria-posinset',o.index+1);r.writeAttribute('aria-setsize',o.length);var t=i.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}if(!i.getEnabled()){r.addClass("sapMITBDisabled");r.writeAttribute("aria-disabled",true);}r.addClass("sapMITBSelectItem");if(c.getSelectedItem()==i){r.addClass("sapMITBSelectItemSelected");r.writeAttribute('aria-selected',true);}var d=i.getIconColor();r.addClass("sapMITBFilter"+d);r.writeClasses();var e=i.getId(),f,g=d=='Positive'||d=='Critical'||d=='Negative';var l=' aria-labelledby="';if(!o.isIconOnly){l+=e+'-text ';}if(!o.isTextOnly&&i.getIcon()){l+=e+'-icon ';}if(g){f=new a({text:o.resourceBundle.getText('ICONTABBAR_ICONCOLOR_'+d.toUpperCase())});l+=f.getId();}l+='"';r.write(l+'>');if(f){r.renderControl(f);}if(!o.isTextOnly){this._renderIcon(r,i);}if(!o.isIconOnly){this._renderText(r,i,o.isRtl);}r.write("</li>");};b._renderIcon=function(r,i){var c=i.getIcon();if(c){var d=I.getIconInfo(c);var e=["sapMITBSelectItemIcon"];if(d&&!d.suppressMirroring){e.push("sapUiIconMirrorInRTL");}r.writeIcon(c,e,{id:i.getId()+'-icon',"aria-hidden":true});}else{r.write('<span class="sapUiIcon"></span>');}};b._renderText=function(r,i,c){r.write('<span');r.writeAttribute("id",i.getId()+'-text');r.writeAttribute("dir","ltr");r.addClass("sapMText");r.addClass("sapMTextNoWrap");r.addClass("sapMITBText");r.writeClasses();var t=i.getTextDirection();if(t!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",t.toLowerCase());}var d=R.getTextAlign(sap.ui.core.TextAlign.Begin,t);if(d){r.addStyle("text-align",d);r.writeStyles();}var e=i.getText();var f=i.getCount();if(f){if(c){e='('+f+') '+e;}else{e+=' ('+f+')';}}r.write(">");r.writeEscaped(e);r.write("</span>");};return b;},true);
