/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','./Button','./Dialog','./Text','./TextArea','./Link','./VBox','sap/ui/core/IconPool'],function(q,B,D,T,a,L,V,I){"use strict";var M={};M.Action={OK:"OK",CANCEL:"CANCEL",YES:"YES",NO:"NO",ABORT:"ABORT",RETRY:"RETRY",IGNORE:"IGNORE",CLOSE:"CLOSE",DELETE:"DELETE"};M.Icon={NONE:undefined,INFORMATION:"INFORMATION",WARNING:"WARNING",ERROR:"ERROR",SUCCESS:"SUCCESS",QUESTION:"QUESTION"};(function(){var A=M.Action,b=M.Icon,c={"INFORMATION":"sapMMessageBoxInfo","WARNING":"sapMMessageBoxWarning","ERROR":"sapMMessageBoxError","SUCCESS":"sapMMessageBoxSuccess","QUESTION":"sapMMessageBoxQuestion","STANDARD":"sapMMessageBoxStandard"},m={"INFORMATION":I.getIconURI("message-information"),"WARNING":I.getIconURI("message-warning"),"ERROR":I.getIconURI("message-error"),"SUCCESS":I.getIconURI("message-success"),"QUESTION":I.getIconURI("question-mark")};var _=function(){if(sap.m.MessageBox._rb!==sap.ui.getCore().getLibraryResourceBundle("sap.m")){sap.m.MessageBox._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");}};M.show=function(v,o){var d,e,f,r=null,t=this,g=[],i,s,h,j,C,k,l,n={id:sap.ui.core.ElementMetadata.uid("mbox"),initialFocus:null,textDirection:sap.ui.core.TextDirection.Inherit,verticalScrolling:true,horizontalScrolling:true,details:""};_();if(typeof o==="string"||arguments.length>2){s=arguments[1];h=arguments[2];j=arguments[3];C=arguments[4];k=arguments[5];l=arguments[6];o={icon:s,title:h,actions:j,onClose:C,id:k,styleClass:l};}if(o&&o.hasOwnProperty("details")){n.icon=sap.m.MessageBox.Icon.INFORMATION;n.actions=[A.OK,A.CANCEL];o=q.extend({},n,o);if(typeof o.details=='object'){o.details=JSON.stringify(o.details,null,'\t');}}o=q.extend({},n,o);if(typeof o.actions!=="undefined"&&!q.isArray(o.actions)){o.actions=[o.actions];}if(!o.actions||o.actions.length===0){o.actions=[A.OK];}function p(z){var E;if(M.Action.hasOwnProperty(z)){E=t._rb.getText("MSGBOX_"+z);}var F=new B({id:sap.ui.core.ElementMetadata.uid("mbox-btn-"),text:E||z,press:function(){r=z;d.close();}});return F;}for(i=0;i<o.actions.length;i++){g.push(p(o.actions[i]));}function u(o,e){var z=new a({editable:false,visible:false,rows:3}).setValue(o.details);var E=new L({text:t._rb.getText("MSGBOX_LINK_TITLE"),press:function(){z.setVisible(true);this.setVisible(false);d._setInitialFocus();}});E.addStyleClass("sapMMessageBoxLinkText");z.addStyleClass("sapMMessageBoxDetails");return new V({items:[e,E,z]});}function w(){if(typeof o.onClose==="function"){o.onClose(r);}d.detachAfterClose(w);d.destroy();}function x(){var i=0;var z=null;if(o.initialFocus){if(o.initialFocus instanceof sap.ui.core.Control){z=o.initialFocus;}if(typeof o.initialFocus==="string"){for(i=0;i<g.length;i++){if(M.Action.hasOwnProperty(o.initialFocus)){if(t._rb.getText("MSGBOX_"+o.initialFocus).toLowerCase()===g[i].getText().toLowerCase()){z=g[i];break;}}else{if(o.initialFocus.toLowerCase()===g[i].getText().toLowerCase()){z=g[i];break;}}}}}return z;}if(typeof(v)==="string"){f=new T({textDirection:o.textDirection}).setText(v).addStyleClass("sapMMsgBoxText");e=f;}else if(v instanceof sap.ui.core.Control){f=v.addStyleClass("sapMMsgBoxText");}if(o&&o.hasOwnProperty("details")&&o.details!==""){f=u(o,f);}function y(){if(sap.ui.getCore().getConfiguration().getAccessibility()){d.$().attr("role","alertdialog");}}d=new D({id:o.id,type:sap.m.DialogType.Message,title:o.title,content:f,icon:m[o.icon],initialFocus:x(),verticalScrolling:o.verticalScrolling,horizontalScrolling:o.horizontalScrolling,afterOpen:y,afterClose:w,buttons:g,ariaLabelledBy:e?e.getId():undefined});if(c[o.icon]){d.addStyleClass(c[o.icon]);}else{d.addStyleClass(c.STANDARD);}if(o.styleClass){d.addStyleClass(o.styleClass);}d.open();};M.alert=function(v,o){_();var d={icon:b.NONE,title:this._rb.getText("MSGBOX_TITLE_ALERT"),actions:A.OK,id:sap.ui.core.ElementMetadata.uid("alert"),initialFocus:null},C,t,s,S;if(typeof o==="function"||arguments.length>2){C=arguments[1];t=arguments[2];s=arguments[3];S=arguments[4];o={onClose:C,title:t,id:s,styleClass:S};}o=q.extend({},d,o);return M.show(v,o);};M.confirm=function(v,o){_();var d={icon:b.QUESTION,title:this._rb.getText("MSGBOX_TITLE_CONFIRM"),actions:[A.OK,A.CANCEL],id:sap.ui.core.ElementMetadata.uid("confirm"),initialFocus:null},C,t,s,S;if(typeof o==="function"||arguments.length>2){C=arguments[1];t=arguments[2];s=arguments[3];S=arguments[4];o={onClose:C,title:t,id:s,styleClass:S};}o=q.extend({},d,o);return M.show(v,o);};M.error=function(v,o){_();var d={icon:b.ERROR,title:this._rb.getText("MSGBOX_TITLE_ERROR"),actions:[A.CLOSE],id:sap.ui.core.ElementMetadata.uid("error"),initialFocus:null};o=q.extend({},d,o);return M.show(v,o);};M.information=function(v,o){_();var d={icon:b.INFORMATION,title:this._rb.getText("MSGBOX_TITLE_INFO"),actions:[A.OK],id:sap.ui.core.ElementMetadata.uid("info"),initialFocus:null};o=q.extend({},d,o);return M.show(v,o);};M.warning=function(v,o){_();var d={icon:b.WARNING,title:this._rb.getText("MSGBOX_TITLE_WARNING"),actions:[A.OK],id:sap.ui.core.ElementMetadata.uid("warning"),initialFocus:null};o=q.extend({},d,o);return M.show(v,o);};M.success=function(v,o){_();var d={icon:b.SUCCESS,title:this._rb.getText("MSGBOX_TITLE_SUCCESS"),actions:[A.OK],id:sap.ui.core.ElementMetadata.uid("success"),initialFocus:null};o=q.extend({},d,o);return M.show(v,o);};}());return M;},true);
