/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global'],function(q){"use strict";var S=(function($,d){var a,s,b,l,t=0,m=3000,h=2,c=3,r=1,D={},e={btnStart:"startE2ETrace",selLevel:"logLevelE2ETrace",taContent:"outputE2ETrace",infoText:"Ent-to-End trace is running in the background."+" Navigate to the URL that you would like to trace."+" The result of the trace will be shown in dialog after the trace is terminated.",infoDuration:5000},f={dvLoadedLibs:"LoadedLibs",dvLoadedModules:"LoadedModules"},w;function g(i,v,A,B,C){i.push("<tr class='sapUiSelectable'><td class='sapUiSupportTechInfoBorder sapUiSelectable'><label class='sapUiSupportLabel sapUiSelectable'>",q.sap.encodeHTML(B),"</label><br>");var E=C;if($.isFunction(C)){E=C(i)||"";}i.push($.sap.encodeHTML(E));i.push("</td></tr>");}function j(A,B,C,E,F){g(A,B,C,E,function(A){A.push("<table class='sapMSupportTable' border='0' cellspacing='5' cellpadding='5' width='100%'><tbody>");$.each(F,function(i,v){var G="";if(v!==undefined&&v!==null){if(typeof(v)=="string"||typeof(v)=="boolean"||($.isArray(v)&&v.length==1)){G=v;}else if(($.isArray(v)||$.isPlainObject(v))&&window.JSON){G=window.JSON.stringify(v);}}g(A,false,false,i,""+G);});A.push("</tbody></table>");});}function k(F){D={version:F.commonInformation.version,build:F.commonInformation.buildTime,change:F.commonInformation.lastChange,useragent:F.commonInformation.userAgent,docmode:F.commonInformation.documentMode,debug:F.commonInformation.debugMode,bootconfig:F.configurationBootstrap,config:F.configurationComputed,loadedlibs:F.loadedLibraries,modules:F.loadedModules,uriparams:F.URLParameters,appurl:F.commonInformation.applicationHREF};var A=["<table class='sapUiSelectable' border='0' cellspacing='5' cellpadding='5' width='100%'><tbody class='sapUiSelectable'>"];g(A,true,true,"SAPUI5 Version",function(i){i.push(D.version," (built at ",D.build,", last change ",D.change,")");});g(A,true,true,"User Agent",function(i){i.push(D.useragent,(D.docmode?", Document Mode '"+D.docmode+"'":""));});g(A,true,true,"Debug Sources",function(i){i.push((D.debug?"ON":"OFF"));});g(A,true,true,"Application",D.appurl);j(A,true,true,"Configuration (bootstrap)",D.bootconfig);j(A,true,true,"Configuration (computed)",D.config);j(A,true,true,"URI Parameters",D.uriparams);g(A,true,true,"End-to-End Trace",function(i){i.push("<label class='sapUiSupportLabel'>Trace Level:</label>","<select id='"+n(e.selLevel)+"' class='sapUiSupportTxtFld' >","<option value='low'>LOW</option>","<option value='medium' selected>MEDIUM</option>","<option value='high'>HIGH</option>","</select>");i.push("<button id='"+n(e.btnStart)+"' class='sapUiSupportBtn'>Start</button>");i.push("<div class='sapUiSupportDiv'>");i.push("<label class='sapUiSupportLabel'>XML Output:</label>");i.push("<textarea id='"+n(e.taContent)+"' class='sapUiSupportTxtArea sapUiSelectable' readonly ></textarea>");i.push("</div>");});g(A,true,true,"Loaded Libraries",function(B){B.push("<ul class='sapUiSelectable'>");$.each(D.loadedlibs,function(i,v){if(v&&(typeof(v)==="string"||typeof(v)==="boolean")){B.push("<li class='sapUiSelectable'>",i+" "+v,"</li>");}});B.push("</ul>");});g(A,true,true,"Loaded Modules",function(i){i.push("<div class='sapUiSupportDiv sapUiSelectable' id='"+n(f.dvLoadedModules)+"'></div>");});A.push("</tbody></table>");return new sap.ui.core.HTML({content:A.join("").replace(/\{/g,"&#123;").replace(/\}/g,"&#125;")});}function n(i){return a.getId()+"-"+i;}function o(v,A){var B="Modules";var C=0,E=[];C=A.length;$.each(A.sort(),function(i,G){E.push(new sap.m.Label({text:" - "+G}).addStyleClass("sapUiSupportPnlLbl"));});var F=new sap.m.Panel({expandable:true,expanded:false,headerToolbar:new sap.m.Toolbar({design:sap.m.ToolbarDesign.Transparent,content:[new sap.m.Label({text:B+" ("+C+")",design:sap.m.LabelDesign.Bold})]}),content:E});F.placeAt(n(v),"only");}function p(){if(a.traceXml){a.$(e.taContent).text(a.traceXml);}if(a.e2eLogLevel){a.$(e.selLevel).val(a.e2eLogLevel);}o(f.dvLoadedModules,D.modules);a.$(e.btnStart).one("tap",function(){a.e2eLogLevel=a.$(e.selLevel).val();a.$(e.btnStart).addClass("sapUiSupportRunningTrace").text("Running...");a.traceXml="";a.$(e.taContent).text("");sap.ui.core.support.trace.E2eTraceLib.start(a.e2eLogLevel,function(i){a.traceXml=i;});sap.m.MessageToast.show(e.infoText,{duration:e.infoDuration});a.close();});}function u(){if(a){return a;}$.sap.require("sap.m.Dialog");$.sap.require("sap.m.Button");$.sap.require("sap.ui.core.HTML");$.sap.require("sap.m.MessageToast");$.sap.require("sap.ui.core.support.trace.E2eTraceLib");a=new sap.m.Dialog({title:"Technical Information",horizontalScrolling:true,verticalScrolling:true,stretch:q.device.is.phone,buttons:[new sap.m.Button({text:"Close",press:function(){a.close();}})],afterOpen:function(){S.off();},afterClose:function(){S.on();}}).addStyleClass("sapMSupport");return a;}function x(E){if(E.touches){var i=E.touches.length;if(sap.ui.Device.browser.mobile&&(sap.ui.Device.browser.name===sap.ui.Device.browser.BROWSER.INTERNET_EXPLORER||sap.ui.Device.browser.name===sap.ui.Device.browser.BROWSER.EDGE)){w=i;}if(i>c){d.removeEventListener('touchend',y);return;}switch(i){case h:s=Date.now();d.addEventListener('touchend',y);break;case c:if(s){t=Date.now()-s;l=E.touches[i-1].identifier;}break;}}}function y(E){var i=sap.ui.Device.browser.mobile&&(sap.ui.Device.browser.name===sap.ui.Device.browser.BROWSER.INTERNET_EXPLORER||sap.ui.Device.browser.name===sap.ui.Device.browser.BROWSER.EDGE)&&w==c;d.removeEventListener('touchend',y);if(t>m&&(E.touches.length===h||i)&&E.changedTouches.length===r&&E.changedTouches[0].identifier===l){t=0;s=0;z();}}function z(){sap.ui.require(['sap/ui/core/support/ToolsAPI'],function(T){var i=u();i.removeAllAggregation("content");i.addAggregation("content",k(T.getFrameworkInformation()));a.open();p();});}return({on:function(){if(!b&&"ontouchstart"in d){b=true;d.addEventListener("touchstart",x);}return this;},off:function(){if(b){b=false;d.removeEventListener("touchstart",x);}return this;},open:function(){z();},isEventRegistered:function(){return b;}}).on();}(q,document));return S;},true);
