/*
 * ! UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/m/P13nColumnsItem',['jquery.sap.global','./library','sap/ui/core/Item'],function(q,l,I){"use strict";
var P=I.extend("sap.m.P13nColumnsItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string",group:"Misc"},index:{type:"int",group:"Appearance"},visible:{type:"boolean",group:"Appearance"},width:{type:"string",group:"Misc"},total:{type:"boolean"}}}});
return P;},true);
sap.ui.predefine('sap/m/P13nColumnsPanel',['jquery.sap.global','./ColumnListItem','./P13nPanel','./P13nColumnsItem','./SearchField','./Table','./library','sap/ui/core/Control'],function(q,C,P,c,S,T,l,d){"use strict";
var e=P.extend("sap.m.P13nColumnsPanel",{
metadata:{library:"sap.m",properties:{visibleItemsThreshold:{type:"int",group:"Behavior",defaultValue:-1}},aggregations:{columnsItems:{type:"sap.m.P13nColumnsItem",multiple:true,singularName:"columnsItem",bindable:"bindable"},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"}},events:{addColumnsItem:{parameters:{newItem:{type:"sap.m.P13nColumnsItem"}}},changeColumnsItems:{parameters:{newItems:{type:"sap.m.P13nColumnsItem[]"},existingItems:{type:"sap.m.P13nColumnsItem[]"}}},setData:{}}},
renderer:function(r,o){r.write("<div");r.writeControlData(o);r.addClass("sapMP13nColumnsPanel");r.writeClasses();r.write(">");var a=o.getAggregation("content");if(a){a.forEach(function(b){r.renderControl(b);});}r.write("</div>");}
});
e.prototype._ItemMoveToTop=function(){var o=-1,n=-1,i=null,t=null;if(this._oSelectedItem){t=this._oTable.getItems();i=this._oSelectedItem.data('P13nColumnKey');o=this._getArrayIndexByItemKey(i,t);n=o;if(o>0){n=0;}if(n!=-1&&o!=-1&&o!=n){this._handleItemIndexChanged(this._oSelectedItem,n);this._changeColumnsItemsIndexes(o,n);this._afterMoveItem();}}};
e.prototype._ItemMoveUp=function(){var o=-1,n=-1,i=null,t=null;if(this._oSelectedItem){t=this._oTable.getItems();i=this._oSelectedItem.data('P13nColumnKey');o=this._getArrayIndexByItemKey(i,t);n=o;if(o>0){n=this._getPreviousItemIndex(o);}if(n!=-1&&o!=-1&&o!=n){this._handleItemIndexChanged(this._oSelectedItem,n);this._changeColumnsItemsIndexes(o,n);this._afterMoveItem();}}};
e.prototype._ItemMoveDown=function(){var o=-1,n=-1,i=null,t=null;var a=null;if(this._oSelectedItem){t=this._oTable.getItems();a=t.length;i=this._oSelectedItem.data('P13nColumnKey');o=this._getArrayIndexByItemKey(i,t);n=o;if(o<a-1){n=this._getNextItemIndex(o);}if(n!=-1&&o!=-1&&o!=n){this._handleItemIndexChanged(this._oSelectedItem,n);this._changeColumnsItemsIndexes(o,n);this._afterMoveItem();}}};
e.prototype._ItemMoveToBottom=function(){var o=-1,n=-1,i=null,t=null;var a=null;if(this._oSelectedItem){t=this._oTable.getItems();a=t.length;i=this._oSelectedItem.data('P13nColumnKey');o=this._getArrayIndexByItemKey(i,t);n=o;if(o<a-1){n=a-1;}if(n!=-1&&o!=-1&&o!=n){this._handleItemIndexChanged(this._oSelectedItem,n);this._changeColumnsItemsIndexes(o,n);this._afterMoveItem();}}};
e.prototype._changeColumnsItemsIndexes=function(o,n){var m=null,M=null,s=null,i=null;var a=null,b=null,f=null;if(o!==null&&o!==undefined&&o>-1&&n!==null&&n!==undefined&&n>-1&&o!==n){m=Math.min(o,n);M=Math.max(o,n);i=this._oTable.getItems().length-1;a=this.getColumnsItems();s=this._oSelectedItem.data('P13nColumnKey');a.forEach(function(g){f=g.getColumnKey();if(f!==undefined&&f===s){return;}b=g.getIndex();if(b===undefined||b<0||b<m||b>M){return;}if(o>n){if(b<i){b+=1;}}else{if(b>0){b-=1;}}g.setIndex(b);});}};
e.prototype._afterMoveItem=function(){this._scrollToSelectedItem(this._oSelectedItem);this._calculateMoveButtonAppearance();};
e.prototype._swopShowSelectedButton=function(){var n;this._bShowSelected=!this._bShowSelected;if(this._bShowSelected){n=this._oRb.getText('COLUMNSPANEL_SHOW_ALL');}else{n=this._oRb.getText('COLUMNSPANEL_SHOW_SELECTED');}this._oShowSelectedButton.setText(n);this._changeEnableProperty4SelectAll();this._filterItems();if(this._oSelectedItem&&this._oSelectedItem.getVisible()!==true){this._deactivateSelectedItem();}this._scrollToSelectedItem(this._oSelectedItem);this._calculateMoveButtonAppearance();this._fnHandleResize();};
e.prototype._escapeRegExp=function(t){if(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,'\\$&');}};
e.prototype._filterItems=function(){var s=null,t=null;var L=0,a=0,i=0,j=0;var I=null,o=null;var b,f;var g=null,h=null,r=null;if(this._bShowSelected){s=this._oTable.getSelectedItems();}else{s=this._oTable.getItems();}if(this._bSearchFilterActive){h=this._oSearchField.getValue();if(h){h=h.replace(/(^\s+)|(\s+$)/g,'');}if(h!==null&&h!==undefined){h=this._escapeRegExp(h);h=r=new RegExp(h,'igm');}}t=this._oTable.getItems();L=t.length;for(i=0;i<L;i++){I=t[i];b=true;f=false;if(this._bSearchFilterActive){b=false;g=I.getCells()[0].getText();if(g&&r!==null&&g.match(r)!==null){b=true;}if(b!==true&&I.getTooltip_Text){g=(I.getTooltip()instanceof sap.ui.core.TooltipBase?I.getTooltip().getTooltip_Text():I.getTooltip_Text());if(g&&r!==null&&g.match(r)!==null){b=true;}}}a=s.length;for(j=0;j<a;j++){o=s[j];if(o){if(o.getId()==I.getId()){f=true;break;}}}I.setVisible(f&&b);}};
e.prototype._changeEnableProperty4SelectAll=function(s){var t=sap.ui.getCore().byId(this._oTable.getId()+'-sa');if(t){t.setEnabled(!this._bSearchFilterActive&&!this._bShowSelected);}};
e.prototype._executeSearch=function(){var v=this._oSearchField.getValue();var L=v.length||0;if(L>0){this._bSearchFilterActive=true;}else{this._bSearchFilterActive=false;}this._changeEnableProperty4SelectAll();this._filterItems();if(this._oSelectedItem&&this._oSelectedItem.getVisible()!==true){this._deactivateSelectedItem();}this._calculateMoveButtonAppearance();this._scrollToSelectedItem(this._oSelectedItem);};
e.prototype._getPreviousItemIndex=function(s){var r=-1,i=0;var t=null,o=null;if(s!==null&&s!==undefined&&s>0){if(this._bShowSelected===true){t=this._oTable.getItems();if(t&&t.length>0){for(i=s-1;i>=0;i--){o=t[i];if(o&&o.getSelected()===true){r=i;break;}}}}else{r=s-1;}}return r;};
e.prototype._getNextItemIndex=function(s){var r=-1,i=0,L=null;var t=null,o=null;if(s!==null&&s!==undefined&&s>-1){t=this._oTable.getItems();if(t&&t.length>0){L=t.length;}if(s>=0&&s<L-1){if(this._bShowSelected===true){for(i=s+1;i<L;i++){o=t[i];if(o&&o.getSelected()===true){r=i;break;}}}else{r=s+1;}}}return r;};
e.prototype._updateSelectAllDescription=function(E){var t=this._oTable.getItems().length;var s=this._oTable.getSelectedItems().length;var a=null;var o=this._oTable.getColumns()[0];if(o){a=this._oRb.getText('COLUMNSPANEL_SELECT_ALL');if(s!==null&&s!==undefined&&s>=0){a=this._oRb.getText('COLUMNSPANEL_SELECT_ALL_WITH_COUNTER',[s,t]);}o.getHeader().setText(a);}if(this._bShowSelected){this._filterItems();}};
e.prototype._changeSelectedItem=function(i){var n=null;if(this._oSelectedItem!==null&&this._oSelectedItem!==undefined){this._removeHighLightingFromItem(this._oSelectedItem);}n=i;if(n!=this._oSelectedItem){this._oSelectedItem=n;this._setHighLightingToItem(this._oSelectedItem);}else{this._oSelectedItem=null;}this._calculateMoveButtonAppearance();};
e.prototype._itemPressed=function(E){var n=null;n=E.getParameter('listItem');this._changeSelectedItem(n);};
e.prototype._calculateMoveButtonAppearance=function(){var i=null,t=null;var L=-1,I=-1;var m=false,M=false;if(this._bSearchFilterActive===true){m=M=false;}else if(this._oSelectedItem!==null&&this._oSelectedItem!==undefined){i=this._oSelectedItem.data('P13nColumnKey');if(this._bShowSelected===true){t=this._oTable.getSelectedItems();}else{t=this._oTable.getItems();}I=this._getArrayIndexByItemKey(i,t);if(I!==-1){if(t&&t.length){L=t.length;}if(I===0){M=true;}else if(I===L-1){m=true;}else if(I>0&&I<L-1){M=true;m=true;}}}else{m=M=false;}if(this._oMoveToTopButton.getEnabled()!==m){this._oMoveToTopButton.setEnabled(m);}if(this._oMoveUpButton.getEnabled()!==m){this._oMoveUpButton.setEnabled(m);}if(this._oMoveDownButton.getEnabled()!==M){this._oMoveDownButton.setEnabled(M);}if(this._oMoveToBottomButton.getEnabled()!==M){this._oMoveToBottomButton.setEnabled(M);}};
e.prototype._setHighLightingToItem=function(i){if(i!==null&&i!==undefined&&i.addStyleClass){i.addStyleClass("sapMP13nColumnsPanelItemSelected");}};
e.prototype._removeHighLightingFromItem=function(i){if(i!==null&&i!==undefined&&i.removeStyleClass){i.removeStyleClass("sapMP13nColumnsPanelItemSelected");}};
e.prototype._deactivateSelectedItem=function(){if(this._oSelectedItem){this._removeHighLightingFromItem(this._oSelectedItem);this._oSelectedItem=null;this._calculateMoveButtonAppearance();}};
e.prototype._getArrayIndexByItemKey=function(I,a){var r=-1;var L=0,i=0;var o=null,s=null;if(I!==null&&I!==undefined&&I!==""){if(a&&a.length>0){L=a.length;for(i=0;i<L;i++){s=null;o=a[i];if(o){if(o.getColumnKey){s=o.getColumnKey();}else if(o.columnKey){s=o.columnKey;}else{s=o.data('P13nColumnKey');}if(s!==null&&s!==undefined&&s!==""){if(s===I){r=i;break;}}}}}}return r;};
e.prototype._scrollToSelectedItem=function(i){var f=null;if(i){sap.ui.getCore().applyChanges();if(!!i.getDomRef()){f=document.activeElement;i.focus();if(f&&f.focus){f.focus();}}}};
e.prototype._extractExistingColumnsItems=function(a){var E=null,o=null;if(a&&a.length>0){E=[];a.forEach(function(b){o={columnKey:b.getColumnKey(),index:b.getIndex(),visible:b.getVisible(),width:b.getWidth()};E.push(o);});}return E;};
e.prototype._extractExistingTableItems=function(){var E=null,o=null;var t=this._oTable.getItems();if(t&&t.length>0){E=[];t.forEach(function(a,i){o={columnKey:a.data('P13nColumnKey'),index:i,visible:a.getSelected(),width:a.data('P13nColumnWidth')};E.push(o);});}return E;};
e.prototype._handleItemIndexChanged=function(i,n){var I=null,a=null;var E=[],o=null;var N=[],b=null;var t=this;if(i&&n!==null&&n!==undefined&&n>-1){I=i.data('P13nColumnKey');b=this.getColumnsItems();this._aExistingColumnsItems=this._extractExistingColumnsItems(b);a=this._getArrayIndexByItemKey(I,b);if(a!==null&&a!==undefined&&a!==-1){o=b[a];}if(o===null){o=this._createNewColumnsItem(I);o.setIndex(n);N.push(o);this.fireAddColumnsItem({newItem:o});this._notifyChange();}else{o.setIndex(n);E.push(o);}if(N.length>0||E.length>0){this.aOwnHandledColumnsItems=N;this.fireChangeColumnsItems({newItems:N,existingItems:E});this._notifyChange();}this.fireSetData();if(E&&E.length>0){E.forEach(function(i){t._updateTableItems(i);});this._oTableItemsOrdering.fCheckReOrdering();}}};
e.prototype._handleItemVisibilityChanged=function(i){var t=this;var I=null,a=null;var E=[],o=null;var n=[],b=null;if(i&&i.length>0){b=this.getColumnsItems();this._aExistingColumnsItems=this._extractExistingColumnsItems(b);i.forEach(function(f){o=a=null;I=f.columnKey;a=t._getArrayIndexByItemKey(I,b);if(a!==null&&a!==undefined&&a!==-1){o=b[a];}if(o===null){o=t._createNewColumnsItem(I);o.setVisible(f.visible);n.push(o);t.fireAddColumnsItem({newItem:o});t._notifyChange();}else{o.setVisible(f.visible);if(o.getVisible()===false){o.setIndex(undefined);}E.push(o);}});if(n.length>0||E.length>0){this.aOwnHandledColumnsItems=n;this.fireChangeColumnsItems({newItems:n,existingItems:E});this._notifyChange();}this.fireSetData();if(E&&E.length>0){E.forEach(function(f){t._updateTableItems(f);});this._oTableItemsOrdering.fCheckReOrdering();}}};
e.prototype._createNewColumnsItem=function(i){var n=new sap.m.P13nColumnsItem({"columnKey":i});return n;};
e.prototype._getColumnsItemByKey=function(i){var a=null;var b=-1,o=null;if(i!==null&&i!==undefined&&i!==""){a=this.getColumnsItems();b=this._getArrayIndexByItemKey(i,a);if(b!==null&&b>-1){o=a[b];}}return o;};
e.prototype._updateTableItems=function(o){var t=null,i,a=null;var b=null,s=null;if(o){b=[];b.push(o);}else{b=this.getColumnsItems();}t=this._oTable.getItems();if(t&&t.length>0){b.forEach(function(o){s=o.getColumnKey();i=this._getArrayIndexByItemKey(s,t);if(i!==-1){a=t[i];this._applyColumnsItem2TableItem(o,a);}},this);}};
e.prototype._reOrderExistingTableItems=function(){var E=null,f=null;var i=-1,L=null;var t=this;E=this._oTable.getItems();f=this._oTable.getSelectedItems();if(f&&f.length>0){f.forEach(function(o){i=E.indexOf(o);if(i>-1){E.splice(i,1);}});}if(E&&E.length>0){try{L=sap.ui.getCore().getConfiguration().getLocale().toString();}catch(g){q.sap.log.error("sap.m.P13nColumnsPanel : no available Language/Locale to sort table items");L=null;}if(L){E.sort(function(a,b){var s=a.getCells()[0].getText();var h=b.getCells()[0].getText();return s.localeCompare(h,L,{numeric:true});});}}this._oTable.removeAllItems();f.forEach(function(I){t._oTable.addItem(I);});E.forEach(function(I){t._oTable.addItem(I);});};
e.prototype._addTableItem=function(i){var o=null;var n=null,s=null;if(i){s=i.getColumnKey();o=this._getColumnsItemByKey(s);n=this._createNewTableItemBasedOnP13nItem(i);if(o){if(o.getVisible()!==undefined){n.setSelected(o.getVisible());}if(o.getWidth()!==undefined){n.data('P13nColumnWidth',o.getWidth());}}if(o&&o.getIndex()!==undefined){this._oTable.insertItem(n,o.getIndex());}else{this._oTable.addItem(n);}}};
e.prototype._insertTableItem=function(i,I){var o=null,n=null,s=null;if(I){s=I.getColumnKey();o=this._getColumnsItemByKey(s);n=this._createNewTableItemBasedOnP13nItem(I);if(o){if(o.getVisible()!==undefined){n.setSelected(o.getVisible());}if(o.getWidth()!==undefined){n.data('P13nColumnWidth',o.getWidth());}}if(o&&o.getIndex()!==undefined){this._oTable.insertItem(n,o.getIndex());}else{this._oTable.insertItem(n,i);}}};
e.prototype._createNewTableItemBasedOnP13nItem=function(i){if(!i){return null;}var s=i.getColumnKey();var n=new sap.m.ColumnListItem({cells:[new sap.m.Text({text:i.getText()?i.getText():q.extend(true,{},i.getBindingInfo("text"))})],visible:true,selected:i.getVisible(),tooltip:i.getTooltip(),type:sap.m.ListType.Active});n.data('P13nColumnKey',s);n.data('P13nColumnWidth',i.getWidth());return n;};
e.prototype._applyColumnsItem2TableItem=function(o,t){var a=this._oTable.getItems();var m=0,r=null,i;var s=null,b=null,E=null,I=false;if(o&&t&&a&&a.length>0){s=o.getColumnKey();if(this._aExistingColumnsItems&&this._aExistingColumnsItems.length>0){b=this._getArrayIndexByItemKey(s,this._aExistingColumnsItems);if(b!==-1){E=this._aExistingColumnsItems[b];if(E&&E.index!==undefined&&E.index===o.getIndex()){I=true;}}}if(o.getIndex()!==undefined&&!I){m=a.length;i=a.indexOf(t);if(i!==o.getIndex()&&o.getIndex()<=m){r=this._oTable.removeItem(t);this._oTable.insertItem(r,o.getIndex());}}if(o.getVisible()!==undefined&&t.getSelected()!==o.getVisible()){t.setSelected(o.getVisible());}if(o.getWidth()!==undefined&&t.data('P13nColumnWidth')!==o.getWidth()){t.data('P13nColumnWidth',o.getWidth());}}};
e.prototype._getTableItemsChangeStatus=function(){var t=false,o=null;var a=this._extractExistingTableItems();if(this._aExistingTableItems&&!a){t=true;}else if(a&&!this._aExistingTableItems){t=true;}else if(this._aExistingTableItems&&a){this._aExistingTableItems.forEach(function(E,i){o=null;if(i<a.length){o=a[i];}if(o){if(E.columnKey!==o.columnKey){t=true;}if(E.index!==o.index){t=true;}if(E.visible!==o.visible){t=true;}if(E.width!==o.width){t=true;}}else{t=true;}if(t){return;}});}return t;};
e.prototype.init=function(){var t=this;this._iLiveChangeTimer=0;this._iSearchTimer=0;this._bOnBeforeRenderingFirstTimeExecuted=false;this._bOnAfterRenderingFirstTimeExecuted=false;this._aExistingColumnsItems=null;this._aExistingTableItems=null;this.setType(sap.m.P13nPanelType.columns);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("COLUMSPANEL_TITLE"));this._oTableItemsOrdering={"_bShallBeOrdered":true,"_bShallBeOrderedOnlyFirstTime":true,"_bAreOrdered":false,"fIsOrderingToBeDoneOnlyFirstTime":function(){return this._bShallBeOrderedOnlyFirstTime;},"fOrderOnlyFirstTime":function(){this._bShallBeOrdered=true;},"fIsOrderingToBeDone":function(s){if(s!==undefined&&s!==null){this._bShallBeOrdered=s;}return this._bShallBeOrdered;},"fIsOrderingDone":function(a){if(a!==undefined&&a!==null){this._bAreOrdered=a;}return this._bAreOrdered;},"fCheckReOrdering":function(){if(this.fIsOrderingToBeDone()){this._bAreOrdered=false;}}};this.setVerticalScrolling(false);this._fnHandleResize=function(){var b=false,s,i;if(t.getParent){var p=null,$=null,a,h;p=t.getParent();if(p){$=q("#"+p.getId()+"-cont");if($.children().length>0&&t._oToolbar.$().length>0){s=t._oScrollContainer.$()[0].clientHeight;a=$.children()[0].clientHeight;h=t._oToolbar?t._oToolbar.$()[0].clientHeight:0;i=a-h;if(s!==i){t._oScrollContainer.setHeight(i+'px');b=true;}}}}return b;};this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oMoveToTopButton=new sap.m.OverflowToolbarButton({icon:sap.ui.core.IconPool.getIconURI("collapse-group"),text:this._oRb.getText('COLUMNSPANEL_MOVE_TO_TOP'),tooltip:this._oRb.getText('COLUMNSPANEL_MOVE_TO_TOP'),press:function(){t._ItemMoveToTop();},layoutData:new sap.m.OverflowToolbarLayoutData({"moveToOverflow":true})});this._oMoveUpButton=new sap.m.OverflowToolbarButton({icon:sap.ui.core.IconPool.getIconURI("slim-arrow-up"),text:this._oRb.getText('COLUMNSPANEL_MOVE_UP'),tooltip:this._oRb.getText('COLUMNSPANEL_MOVE_UP'),press:function(){t._ItemMoveUp();},layoutData:new sap.m.OverflowToolbarLayoutData({"moveToOverflow":true})});this._oMoveDownButton=new sap.m.OverflowToolbarButton({icon:sap.ui.core.IconPool.getIconURI("slim-arrow-down"),text:this._oRb.getText('COLUMNSPANEL_MOVE_DOWN'),tooltip:this._oRb.getText('COLUMNSPANEL_MOVE_DOWN'),press:function(){t._ItemMoveDown();},layoutData:new sap.m.OverflowToolbarLayoutData({"moveToOverflow":true})});this._oMoveToBottomButton=new sap.m.OverflowToolbarButton({icon:sap.ui.core.IconPool.getIconURI("expand-group"),text:this._oRb.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),tooltip:this._oRb.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),press:function(){t._ItemMoveToBottom();},layoutData:new sap.m.OverflowToolbarLayoutData({"moveToOverflow":true})});this._oShowSelectedButton=new sap.m.Button({text:this._oRb.getText('COLUMNSPANEL_SHOW_SELECTED'),press:function(){t._swopShowSelectedButton();},layoutData:new sap.m.OverflowToolbarLayoutData({"moveToOverflow":true})});this._bShowSelected=false;this._bSearchFilterActive=false;this._oSearchField=new S(this.getId()+"-searchField",{liveChange:function(E){var v=E.getSource().getValue(),D=(v?300:0);window.clearTimeout(t._iSearchTimer);if(D){t._iSearchTimer=window.setTimeout(function(){t._executeSearch();},D);}else{t._executeSearch();}},search:function(E){t._executeSearch();},layoutData:new sap.m.OverflowToolbarLayoutData({"minWidth":"12.5rem","maxWidth":"23.077rem","shrinkable":true,"moveToOverflow":false,"stayInOverflow":false})});this._oToolbarSpacer=new sap.m.ToolbarSpacer();this._oToolbar=new sap.m.OverflowToolbar({design:sap.m.ToolbarDesign.Solid,content:[this._oToolbarSpacer,this._oSearchField,this._oShowSelectedButton,this._oMoveToTopButton,this._oMoveUpButton,this._oMoveDownButton,this._oMoveToBottomButton]});this.addAggregation("content",this._oToolbar);this._oTable=new T({mode:sap.m.ListMode.MultiSelect,rememberSelections:false,itemPress:function(E){t._itemPressed(E);},selectionChange:function(E){t._updateSelectAllDescription(E);var s=E.getParameter('selected');var a=E.getParameter('listItems');var b=[],o=null;a.forEach(function(f){f.setSelected(s);o={"columnKey":f.data('P13nColumnKey'),"visible":f.getSelected()};b.push(o);});t._handleItemVisibilityChanged(b);var v=t.getValidationExecutor();if(v){v();}if(a.length===1&&s===true){if(a[0]!==t._oSelectedItem){t._changeSelectedItem(a[0]);}}},columns:[new sap.m.Column({header:new sap.m.Text({text:this._oRb.getText('COLUMNSPANEL_SELECT_ALL')})})]});this._oScrollContainer=new sap.m.ScrollContainer({horizontal:false,vertical:true,content:[this._oTable],width:'100%',height:'100%'});this.addAggregation("content",this._oScrollContainer);this._sContainerResizeListener=sap.ui.core.ResizeHandler.register(this._oScrollContainer,this._fnHandleResize);};
e.prototype.reInitialize=function(){this._oTableItemsOrdering.fOrderOnlyFirstTime();this._oTableItemsOrdering.fCheckReOrdering();};
e.prototype.onBeforeRendering=function(){if(!this._bOnBeforeRenderingFirstTimeExecuted){this._bOnBeforeRenderingFirstTimeExecuted=true;if(this._oTableItemsOrdering.fIsOrderingToBeDoneOnlyFirstTime()){this._oTableItemsOrdering.fOrderOnlyFirstTime();}}if(!this._oTableItemsOrdering.fIsOrderingDone()&&this._oTableItemsOrdering.fIsOrderingToBeDone()){this._updateTableItems();this._reOrderExistingTableItems();this._oTableItemsOrdering.fIsOrderingDone(true);if(this._oTableItemsOrdering.fIsOrderingToBeDoneOnlyFirstTime()){this._oTableItemsOrdering.fIsOrderingToBeDone(false);}}if(this._aExistingTableItems===null||this._aExistingTableItems===undefined){this._aExistingTableItems=this._extractExistingTableItems();}this._updateSelectAllDescription();this._calculateMoveButtonAppearance();};
e.prototype.onAfterRendering=function(){var t=this;if(!this._bOnAfterRenderingFirstTimeExecuted){this._bOnAfterRenderingFirstTimeExecuted=true;window.clearTimeout(this._iLiveChangeTimer);this._iLiveChangeTimer=window.setTimeout(function(){t._oToolbar._resetAndInvalidateToolbar();},0);}};
e.prototype.getOkPayload=function(){var p=null,s=[],o=null;var t=this._extractExistingTableItems();if(t&&t.length>0){p={"tableItems":t,"tableItemsChanged":false,"selectedItems":s};t.forEach(function(a){if(a&&a.visible&&a.visible===true){o={"columnKey":a.columnKey};s.push(o);}});p.tableItemsChanged=this._getTableItemsChangeStatus();}return p;};
e.prototype.getResetPayload=function(){var p=null;p={"oPanel":this};return p;};
e.prototype.exit=function(){sap.ui.core.ResizeHandler.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;this._oMoveToTopButton.destroy();this._oMoveToTopButton=null;this._oMoveDownButton.destroy();this._oMoveDownButton=null;this._oMoveUpButton.destroy();this._oMoveUpButton=null;this._oMoveToBottomButton.destroy();this._oMoveToBottomButton=null;this._oSearchField.destroy();this._oSearchField=null;this._oToolbar.destroy();this._oToolbar=null;this._oTable.destroy();this._oTable=null;window.clearTimeout(this._iLiveChangeTimer);window.clearTimeout(this._iSearchTimer);};
e.prototype.addItem=function(i){P.prototype.addItem.apply(this,arguments);this._addTableItem(i);return this;};
e.prototype.insertItem=function(i,I){P.prototype.insertItem.apply(this,arguments);this._insertTableItem(i,I);return this;};
e.prototype.removeItem=function(i){var t=null,I=null,a=null,s=null;i=P.prototype.removeItem.apply(this,arguments);if(i){s=i.getColumnKey();a=this._oTable.getItems();if(a&&a.length>0&&s!==null&&s!==""){I=this._getArrayIndexByItemKey(s,a);if(I!==null&&I!==-1){t=a[I];if(t){this._oTable.removeItem(t);}}}}return i;};
e.prototype.removeAllItems=function(){var i=P.prototype.removeAllItems.apply(this,arguments);if(this._oTable){this._oTable.removeAllItems();}return i;};
e.prototype.destroyItems=function(){P.prototype.destroyItems.apply(this,arguments);if(this._oTable){this._oTable.destroyItems();}return this;};
e.prototype.addColumnsItem=function(o){this.addAggregation("columnsItems",o);this._updateTableItems(o);this._oTableItemsOrdering.fCheckReOrdering();return this;};
e.prototype.insertColumnsItem=function(i,o){this.insertAggregation("columnsItems",o,i);this._updateTableItems(o);this._oTableItemsOrdering.fCheckReOrdering();return this;};
e.prototype.removeColumnsItem=function(o){o=this.removeAggregation("columnsItems",o);this._updateTableItems(o);this._oTableItemsOrdering.fCheckReOrdering();return o;};
e.prototype.removeAllColumnsItems=function(){var a=this.removeAllAggregation("columnsItems");this._oTableItemsOrdering.fCheckReOrdering();return a;};
e.prototype.destroyColumnsItems=function(){this.destroyAggregation("columnsItems");this._oTableItemsOrdering.fCheckReOrdering();return this;};
e.prototype.onBeforeNavigationFrom=function(){var s=this._oTable.getSelectedItems();var v=this.getVisibleItemsThreshold();return!(s&&v!==-1&&s.length>v);};
e.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
return e;},true);
sap.ui.predefine('sap/m/P13nConditionPanel',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/format/DateFormat','sap/ui/core/format/NumberFormat','sap/ui/core/IconPool'],function(q,a,C,D,N,I){"use strict";
var P=C.extend("sap.m.P13nConditionPanel",{
metadata:{library:"sap.m",properties:{maxConditions:{type:"string",group:"Misc",defaultValue:'-1'},exclude:{type:"boolean",group:"Misc",defaultValue:false},containerQuery:{type:"boolean",group:"Misc",defaultValue:false},autoAddNewRow:{type:"boolean",group:"Misc",defaultValue:false},disableFirstRemoveIcon:{type:"boolean",group:"Misc",defaultValue:false},alwaysShowAddIcon:{type:"boolean",group:"Misc",defaultValue:true},usePrevConditionSetting:{type:"boolean",group:"Misc",defaultValue:true},autoReduceKeyFieldItems:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null},showLabel:{type:"boolean",group:"Misc",defaultValue:false},displayFormat:{type:"string",group:"Misc",defaultValue:null},validationExecutor:{type:"object",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"}},events:{dataChange:{}}},
renderer:function(r,c){r.write("<section");r.writeControlData(c);r.addClass("sapMConditionPanel");r.writeClasses();r.writeStyles();r.write(">");r.write("<div");r.addClass("sapMConditionPanelContent");r.addClass("sapMConditionPanelBG");r.writeClasses();r.write(">");var b=c.getAggregation("content");var l=b.length;for(var i=0;i<l;i++){r.renderControl(b[i]);}r.write("</div>");r.write("</section>");}
});
P.prototype.setConditions=function(c){if(!c){q.sap.log.error("sap.m.P13nConditionPanel : aCondition is not defined");}if(this._bIgnoreSetConditions){return;}this._oConditionsMap={};this._aConditionKeys=[];this._iConditions=0;for(var i=0;i<c.length;i++){this._addCondition2Map(c[i]);}this._clearConditions();this._fillConditions();};
P.prototype.removeAllConditions=function(){this._oConditionsMap={};this._aConditionKeys=[];this._iConditions=0;this._clearConditions();this._fillConditions();};
P.prototype.addCondition=function(c){if(this._bIgnoreSetConditions){return;}c.index=this._iConditions;this._addCondition2Map(c);this._addCondition(c);};
P.prototype.insertCondition=function(c,i){if(this._bIgnoreSetConditions){return;}if(i!==undefined){c.index=i;}this._addCondition2Map(c);this._addCondition(c);};
P.prototype.removeCondition=function(c){this._clearConditions();if(typeof(c)=="string"){this._removeConditionFromMap(c);}if(typeof(c)=="object"){this._removeConditionFromMap(c.key);}this._fillConditions();};
P.prototype._addCondition2Map=function(c){if(!c.key){c.key="condition_"+this._iConditions;if(this.getExclude()){c.key="x"+c.key;}}this._iConditions++;this._oConditionsMap[c.key]=c;this._aConditionKeys.push(c.key);};
P.prototype._removeConditionFromMap=function(k){this._iConditions--;delete this._oConditionsMap[k];var i=this._aConditionKeys.indexOf(k);if(i>=0){this._aConditionKeys.splice(i,1);}};
P.prototype.getConditions=function(){var c;var b=[];if(this._oConditionsMap){for(var d in this._oConditionsMap){c=this._oConditionsMap[d];var v=c.value;if(!v){v=this._getFormatedConditionText(c.operation,c.value1,c.value2,c.exclude,c.keyField,c.showIfGrouped);}if(!c._oGrid||c._oGrid.select.getSelected()){b.push({"key":d,"text":v,"exclude":c.exclude,"operation":c.operation,"keyField":c.keyField,"value1":c.value1,"value2":c.operation===sap.m.P13nConditionOperation.BT?c.value2:null,"showIfGrouped":c.showIfGrouped});}}}return b;};
P.prototype.setOperations=function(o,t){t=t||"default";this._oTypeOperations[t]=o;this._updateAllOperations();};
P.prototype.setValues=function(v,t){t=t||"default";this._oTypeValues[t]=v;};
P.prototype.addOperation=function(o,t){t=t||"default";this._oTypeOperations[t].push(o);this._updateAllOperations();};
P.prototype.removeAllOperations=function(t){t=t||"default";this._oTypeOperations[t]=[];this._updateAllOperations();};
P.prototype.getOperations=function(t){t=t||"default";return this._oTypeOperations[t];};
P.prototype.setKeyFields=function(k){this._aKeyFields=k;this._updateKeyFieldItems(this._oConditionsGrid,true);this._updateAllConditionsEnableStates();this._createAndUpdateAllKeyFields();this._updateAllOperations();};
P.prototype.addKeyField=function(k){this._aKeyFields.push(k);this._updateKeyFieldItems(this._oConditionsGrid,true,true);this._updateAllConditionsEnableStates();this._createAndUpdateAllKeyFields();this._updateAllOperations();};
P.prototype.removeAllKeyFields=function(){this._aKeyFields=[];this._updateKeyFieldItems(this._oConditionsGrid,true);};
P.prototype.getKeyFields=function(){return this._aKeyFields;};
P.prototype.setAlwaysShowAddIcon=function(e){this.setProperty("alwaysShowAddIcon",e);if(this._oConditionsGrid){this._oConditionsGrid.toggleStyleClass("conditionRootGrid",this.getLayoutMode()!=="Desktop");}return this;};
P.prototype.setLayoutMode=function(l){this.setProperty("layoutMode",l);if(this._oConditionsGrid){this._oConditionsGrid.toggleStyleClass("conditionRootGrid",l!=="Desktop");}this._updateConditionFieldSpans(l);this._clearConditions();this._fillConditions();return this;};
P.prototype.setContainerQuery=function(e){this._unregisterResizeHandler();this.setProperty("containerQuery",e);this._registerResizeHandler();this._clearConditions();this._fillConditions();return this;};
P.prototype._updateConditionFieldSpans=function(m){if(this._aConditionsFields){var d=m==="Desktop";if(d){this._aConditionsFields[2].SpanFilter="L3 M3 S3";this._aConditionsFields[4].SpanFilter="L2 M2 S2";this._aConditionsFields[5].SpanFilter="L3 M3 S3";this._aConditionsFields[6].SpanFilter="L2 M2 S2";this._aConditionsFields[7].SpanFilter="L1 M1 S1";}var t=m==="Tablet";if(t){this._aConditionsFields[2].SpanFilter="L5 M5 S5";this._aConditionsFields[4].SpanFilter="L5 M5 S5";this._aConditionsFields[5].SpanFilter="L10 M10 S10";this._aConditionsFields[6].SpanFilter="L10 M10 S10";this._aConditionsFields[7].SpanFilter="L1 M1 S1";}}};
P.prototype.init=function(){sap.ui.getCore().loadLibrary("sap.ui.layout");q.sap.require("sap.ui.layout.Grid");sap.ui.layout.Grid.prototype.init.apply(this);this.addStyleClass("sapMConditionPanel");this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._sFromLabelText=this._oRb.getText("CONDITIONPANEL_LABELFROM");this._sToLabelText=this._oRb.getText("CONDITIONPANEL_LABELTO");this._sValueLabelText=this._oRb.getText("CONDITIONPANEL_LABELVALUE");this._sShowIfGroupedLabelText=this._oRb.getText("CONDITIONPANEL_LABELGROUPING");this._sValidationDialogFieldMessage=this._oRb.getText("CONDITIONPANEL_FIELDMESSAGE");this._oTypeOperations={"default":[]};this._oTypeValues={"default":[]};this._aKeyFields=[];this._oConditionsMap={};this._aConditionKeys=[];this._iConditions=0;this._sLayoutMode="Desktop";this._sConditionType="Filter";this._sAddRemoveIconTooltip="FILTER";this._iBreakPointTablet=sap.ui.Device.media._predefinedRangeSets[sap.ui.Device.media.RANGESETS.SAP_STANDARD].points[0];this._iBreakPointDesktop=sap.ui.Device.media._predefinedRangeSets[sap.ui.Device.media.RANGESETS.SAP_STANDARD].points[1];this._oConditionsGrid=new sap.ui.layout.Grid({width:"100%",defaultSpan:"L12 M12 S12",hSpacing:0,vSpacing:0}).toggleStyleClass("conditionRootGrid",this.getLayoutMode()!=="Desktop");this._iFirstConditionIndex=0;this._iConditionPageSize=10;this._oInvisibleTextField=new sap.ui.core.InvisibleText({text:this._oRb.getText("CONDITIONPANEL_FIELD_LABEL")});this._oInvisibleTextOperator=new sap.ui.core.InvisibleText({text:this._oRb.getText("CONDITIONPANEL_OPERATOR_LABEL")});this.addAggregation("content",this._oInvisibleTextField);this.addAggregation("content",this._oInvisibleTextOperator);this.addAggregation("content",this._oConditionsGrid);this._registerResizeHandler();this._aConditionsFields=[{"ID":"select","Label":"","SpanFilter":"L1 M1 S1","SpanSort":"L1 M1 S1","SpanGroup":"L1 M1 S1","Control":"CheckBox","Value":""},{"ID":"keyFieldLabel","Text":"Sort By","SpanFilter":"L1 M1 S1","SpanSort":"L1 M1 S1","SpanGroup":"L1 M1 S1","Control":"Label"},{"ID":"keyField","Label":"","SpanFilter":"L3 M5 S10","SpanSort":"L5 M5 S12","SpanGroup":"L4 M4 S12","Control":"ComboBox"},{"ID":"operationLabel","Text":"Sort Order","SpanFilter":"L1 M1 S1","SpanSort":"L1 M1 S1","SpanGroup":"L1 M1 S1","Control":"Label"},{"ID":"operation","Label":"","SpanFilter":"L2 M5 S10","SpanSort":sap.ui.Device.system.phone?"L5 M5 S8":"L5 M5 S9","SpanGroup":"L2 M5 S10","Control":"ComboBox"},{"ID":"value1","Label":this._sFromLabelText,"SpanFilter":"L3 M10 S10","SpanSort":"L3 M10 S10","SpanGroup":"L3 M10 S10","Control":"TextField","Value":""},{"ID":"value2","Label":this._sToLabelText,"SpanFilter":"L2 M10 S10","SpanSort":"L2 M10 S10","SpanGroup":"L2 M10 S10","Control":"TextField","Value":""},{"ID":"showIfGrouped","Label":this._sShowIfGroupedLabelText,"SpanFilter":"L1 M10 S10","SpanSort":"L1 M10 S10","SpanGroup":"L3 M4 S9","Control":"CheckBox","Value":"false"}];this._oButtonGroupSpan={"SpanFilter":"L1 M2 S2","SpanSort":sap.ui.Device.system.phone?"L2 M2 S4":"L2 M2 S3","SpanGroup":"L2 M2 S3"};this._updateConditionFieldSpans(this.getLayoutMode());this._fillConditions();};
P.prototype._createPaginatorToolbar=function(){this._bPaginatorButtonsVisible=false;var t=this;this._oPrevButton=new sap.m.Button({icon:sap.ui.core.IconPool.getIconURI("navigation-left-arrow"),tooltip:this._oRb.getText("WIZARD_FINISH"),visible:true,press:function(e){t._iFirstConditionIndex=Math.max(0,t._iFirstConditionIndex-t._iConditionPageSize);t._clearConditions();t._fillConditions();},layoutData:new sap.m.OverflowToolbarLayoutData({priority:sap.m.OverflowToolbarPriority.NeverOverflow})});this._oNextButton=new sap.m.Button({icon:sap.ui.core.IconPool.getIconURI("navigation-right-arrow"),tooltip:this._oRb.getText("WIZARD_NEXT"),visible:true,press:function(e){t._iFirstConditionIndex+=t._iConditionPageSize;t._clearConditions();t._fillConditions();},layoutData:new sap.m.OverflowToolbarLayoutData({priority:sap.m.OverflowToolbarPriority.NeverOverflow})});this._oRemoveAllButton=new sap.m.Button({text:this._oRb.getText("CONDITIONPANEL_REMOVE_ALL"),visible:true,press:function(e){t._aConditionKeys.forEach(function(k,i){if(i>=0){this.fireDataChange({key:k,index:i,operation:"remove",newData:null});}},t);this._iFirstConditionIndex=0;t.removeAllConditions();},layoutData:new sap.m.OverflowToolbarLayoutData({priority:sap.m.OverflowToolbarPriority.Low})});this._oAddButton=new sap.m.Button({icon:sap.ui.core.IconPool.getIconURI("add"),tooltip:this._oRb.getText("CONDITIONPANEL_ADD"+(this._sAddRemoveIconTooltipKey?"_"+this._sAddRemoveIconTooltipKey:"")+"_TOOLTIP"),visible:true,press:function(e){var c=t._createConditionRow(t._oConditionsGrid,undefined,null,0);t._changeField(c);setTimeout(function(){c.keyField.focus();});t._updatePaginatorToolbar();},layoutData:new sap.m.OverflowToolbarLayoutData({priority:sap.m.OverflowToolbarPriority.Low})});this._oHeaderText=new sap.m.Text({wrapping:false,layoutData:new sap.m.OverflowToolbarLayoutData({priority:sap.m.OverflowToolbarPriority.NeverOverflow})});this._oPageText=new sap.m.Text({wrapping:false,textAlign:sap.ui.core.TextAlign.Center,layoutData:new sap.m.OverflowToolbarLayoutData({priority:sap.m.OverflowToolbarPriority.NeverOverflow})});this._oFilterField=new sap.m.SearchField({width:"12rem",layoutData:new sap.m.OverflowToolbarLayoutData({priority:sap.m.OverflowToolbarPriority.High})});this._oPaginatorToolbar=new sap.m.OverflowToolbar({height:"3rem",design:sap.m.ToolbarDesign.Transparent,content:[this._oHeaderText,new sap.m.ToolbarSpacer(),this._oFilterField,this._oPrevButton,this._oPageText,this._oNextButton,this._oRemoveAllButton,this._oAddButton]});};
P.prototype._updatePaginatorToolbar=function(){if(this._sConditionType!=="Filter"||this.getMaxConditions()!=="-1"){return;}var i=this._aConditionKeys.length;var p=1+Math.floor(Math.max(0,i-1)/this._iConditionPageSize);var b=1+Math.floor(this._iFirstConditionIndex/this._iConditionPageSize);var o=this.getParent();if(!this._oPaginatorToolbar){if(i>this._iConditionPageSize){this._createPaginatorToolbar();this.insertAggregation("content",this._oPaginatorToolbar,0);this._onGridResize();}else{if(o&&o.setHeaderText){if(this._sOrgHeaderText==undefined){this._sOrgHeaderText=o.getHeaderText();}o.setHeaderText(this._sOrgHeaderText+(i>0?" ("+i+")":""));}return;}}this._oPrevButton.setEnabled(this._iFirstConditionIndex>0);this._oNextButton.setEnabled(this._iFirstConditionIndex+this._iConditionPageSize<i);if(o&&o.setHeaderToolbar){if(!o.getHeaderToolbar()){this.removeAggregation("content",this._oPaginatorToolbar);o.setHeaderToolbar(this._oPaginatorToolbar);o.attachExpand(function(e){this._setToolbarElementVisibility(e.getSource().getExpanded()&&this._bPaginatorButtonsVisible);}.bind(this));}}if(o&&o.setHeaderText){if(this._sOrgHeaderText==undefined){this._sOrgHeaderText=o.getHeaderText();}var h=this._sOrgHeaderText+(i>0?" ("+i+")":"");o.setHeaderText(h);this._oHeaderText.setText(h);}else{this._oHeaderText.setText(i+" Conditions");}this._oPageText.setText(b+"/"+p);this._bPaginatorButtonsVisible=this._bPaginatorButtonsVisible||p>1;this._setToolbarElementVisibility(this._bPaginatorButtonsVisible);if(b>p){this._iFirstConditionIndex-=Math.max(0,this._iConditionPageSize);this._clearConditions();this._fillConditions();}var n=0;this._oConditionsGrid.getContent().forEach(function(g){if(g.select.getSelected()){n++;}},this);if(p==b&&(i-this._iFirstConditionIndex)>n){this._clearConditions();this._fillConditions();}};
P.prototype._setToolbarElementVisibility=function(v){this._oPrevButton.setVisible(v);this._oNextButton.setVisible(v);this._oPageText.setVisible(v);this._oFilterField.setVisible(false);this._oAddButton.setVisible(v);this._oRemoveAllButton.setVisible(v);};
P.prototype.exit=function(){this._unregisterResizeHandler();this._aConditionsFields=null;this._aKeys=null;this._aKeyFields=null;this._oTypeOperations=null;this._oRb=null;this._sFromLabelText=null;this._sToLabelText=null;this._sValueLabelText=null;this._sValidationDialogFieldMessage=null;this._oConditionsMap=null;this._aConditionKeys=[];};
P.prototype._clearConditions=function(){this._oConditionsGrid.removeAllContent();};
P.prototype._fillConditions=function(){var c,s;var i=0,m=this._getMaxConditionsAsNumber(),n=this._aConditionKeys.length;if(this._oConditionsMap){var p=this._sConditionType!=="Filter"||this.getMaxConditions()!=="-1"?9999:this._iConditionPageSize;n=Math.min(n,Math.min(m,this._iFirstConditionIndex+p));for(i=this._iFirstConditionIndex;i<n;i++){s=this._aConditionKeys[i];c=this._oConditionsMap[s];this._createConditionRow(this._oConditionsGrid,c,s);}}this._updatePaginatorToolbar();if((this.getAutoAddNewRow()||this._oConditionsGrid.getContent().length===0)&&this._oConditionsGrid.getContent().length<m){this._createConditionRow(this._oConditionsGrid);}};
P.prototype._addCondition=function(c){var i=0;var m=this._getMaxConditionsAsNumber();if(this._oConditionsMap){for(var b in this._oConditionsMap){if(i<m&&c===this._oConditionsMap[b]){this._createConditionRow(this._oConditionsGrid,c,b,i);}i++;}}this._updatePaginatorToolbar();};
P.prototype._getMaxConditionsAsNumber=function(){return this.getMaxConditions()==="-1"?9999:parseInt(this.getMaxConditions(),10);};
P.prototype.onAfterRendering=function(){if(this.getLayoutMode()){this._sLayoutMode=this.getLayoutMode();return;}};
P.prototype._handleMediaChange=function(p){this._sLayoutMode=p.name;this._updateLayout(p);};
P.prototype._unregisterResizeHandler=function(){if(this._sContainerResizeListener){sap.ui.core.ResizeHandler.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;}sap.ui.Device.media.detachHandler(this._handleMediaChange,this,sap.ui.Device.media.RANGESETS.SAP_STANDARD);};
P.prototype._registerResizeHandler=function(){if(this.getContainerQuery()){this._sContainerResizeListener=sap.ui.core.ResizeHandler.register(this._oConditionsGrid,q.proxy(this._onGridResize,this));this._onGridResize();}else{sap.ui.Device.media.attachHandler(this._handleMediaChange,this,sap.ui.Device.media.RANGESETS.SAP_STANDARD);}};
P.prototype._getKeyFromConditionGrid=function(c){var k=c.data("_key");if(!k){k=this._createConditionKey();}return k;};
P.prototype._createConditionKey=function(){var i=0;var k;do{k="condition_"+i;if(this.getExclude()){k="x"+k;}i++;}while(this._oConditionsMap[k]);return k;};
P.prototype._createConditionRow=function(t,c,k,p){var b=null;var g;var d=this;if(p===undefined){p=t.getContent().length;}var o=new sap.ui.layout.Grid({width:"100%",defaultSpan:"L12 M12 S12",hSpacing:1,vSpacing:0,containerQuery:this.getContainerQuery()}).data("_key",k);for(var f in this._aConditionsFields){var e;var h=this._aConditionsFields[f];switch(h["Control"]){case"CheckBox":e=new sap.m.CheckBox({enabled:false,visible:false,layoutData:new sap.ui.layout.GridData({span:h["Span"+this._sConditionType]})});if(h["ID"]==="showIfGrouped"){e.setEnabled(true);e.setText(h["Label"]);e.attachSelect(function(){d._changeField(o);});e.setSelected(c?c.showIfGrouped:true);}else{if(c){e.setSelected(true);e.setEnabled(true);}}break;case"ComboBox":if(h["ID"]==="keyField"){e=new sap.m.ComboBox({width:"100%",ariaLabelledBy:this._oInvisibleTextField});var O=q.proxy(e.setSelectedKey,e);e.setSelectedKey=function(k){O(k);var m=d.getValidationExecutor();if(m){m();}};var i=q.proxy(e.setSelectedItem,e);e.setSelectedItem=function(m){i(m);var n=d.getValidationExecutor();if(n){n();}};e.setLayoutData(new sap.ui.layout.GridData({span:h["Span"+this._sConditionType]}));this._fillKeyFieldListItems(e,this._aKeyFields);if(e.attachSelectionChange){e.attachSelectionChange(function(E){var m=d.getValidationExecutor();if(m){m();}d._handleSelectionChangeOnKeyField(t,o);});}if(e.attachChange){e.attachChange(function(E){o.keyField.close();d._handleChangeOnKeyField(t,o);});}if(e.setSelectedItem){if(c){e.setSelectedKey(c.keyField);this._aKeyFields.forEach(function(K,m){var n=K.key;if(n===undefined){n=K;}if(c.keyField===n){e.setSelectedItem(e.getItems()[m]);}},this);}else{if(this.getUsePrevConditionSetting()&&!this.getAutoReduceKeyFieldItems()){if(p>0&&!k){g=t.getContent()[p-1];e.setSelectedKey(g.keyField.getSelectedKey());}else{this._aKeyFields.some(function(K,m){if(K.isDefault){e.setSelectedItem(e.getItems()[m]);return true;}if(!e.getSelectedItem()&&K.type!=="boolean"){e.setSelectedItem(e.getItems()[m]);}},this);if(!e.getSelectedItem()&&e.getItems().length>0){e.setSelectedItem(e.getItems()[0]);}}}else{this._aKeyFields.forEach(function(K,m){if(K.isDefault){e.setSelectedItem(e.getItems()[m]);}},this);}}}}if(h["ID"]==="operation"){e=new sap.m.Select({width:"100%",ariaLabelledBy:this._oInvisibleTextOperator,layoutData:new sap.ui.layout.GridData({span:h["Span"+this._sConditionType]})});e.attachChange(function(){d._handleChangeOnOperationField(t,o);});o[h["ID"]]=e;this._updateOperationItems(t,o);if(c){var K=this._getCurrentKeyFieldItem(o.keyField);var j=this._oTypeOperations["default"];if(K){if(K.type&&this._oTypeOperations[K.type]){j=this._oTypeOperations[K.type];}if(K.operations){j=K.operations;}}j.some(function(m,n){if(c.operation===m){e.setSelectedKey(m);return true;}},this);}else{if(this.getUsePrevConditionSetting()){if(p>0&&k===null){var g=t.getContent()[p-1];e.setSelectedKey(g.operation.getSelectedKey());}}}}if(e.getSelectedItem&&e.getSelectedItem()){e.setTooltip(e.getSelectedItem().getTooltip()||e.getSelectedItem().getText());}break;case"TextField":var l=this._getCurrentKeyFieldItem(o.keyField);e=this._createValueField(l,h,o);e.oTargetGrid=t;if(c&&c[h["ID"]]!==undefined){var v=c[h["ID"]];var V;if(e instanceof sap.m.Select){if(typeof v==="string"&&l.type==="boolean"){v=v==="true";}if(typeof v==="boolean"){e.setSelectedIndex(v?2:1);}else{e.setSelectedItem(e.getItemByKey(v.toString()));}}else{if(typeof v==="string"&&o.oFormatter instanceof sap.ui.core.format.NumberFormat){V=parseFloat(v);v=o.oFormatter.format(V);}if(typeof v==="string"&&o.oFormatter){V=o.oFormatter.parse(v);}else{V=v;}if(!isNaN(V)&&V!==null&&o.oFormatter){v=o.oFormatter.format(V);e.setValue(v);}else{if(!V&&v&&o.oFormatter instanceof sap.ui.core.format.DateFormat){V=new Date(v);v=o.oFormatter.format(V);e.setValue(v);}else{e.setValue(V);}}}}break;case"Label":e=new sap.m.Label({text:h["Text"]+":",visible:this.getShowLabel(),layoutData:new sap.ui.layout.GridData({span:h["Span"+this._sConditionType]})}).addStyleClass("conditionLabel");e.oTargetGrid=t;break;}o[h["ID"]]=e;o.addContent(e);}b=new sap.ui.layout.HorizontalLayout({layoutData:new sap.ui.layout.GridData({span:this.getLayoutMode()==="Desktop"?"L2 M2 S2":this._oButtonGroupSpan["Span"+this._sConditionType]})}).addStyleClass("floatRight");o.addContent(b);o["ButtonContainer"]=b;var r=new sap.m.Button({type:sap.m.ButtonType.Transparent,icon:sap.ui.core.IconPool.getIconURI("sys-cancel"),tooltip:this._oRb.getText("CONDITIONPANEL_REMOVE"+(this._sAddRemoveIconTooltipKey?"_"+this._sAddRemoveIconTooltipKey:"")+"_TOOLTIP"),press:function(){d._handleRemoveCondition(this.oTargetGrid,o);},layoutData:new sap.ui.layout.GridData({span:this.getLayoutMode()==="Desktop"?"L1 M1 S1":"L1 M2 S2"})});r.oTargetGrid=t;b.addContent(r);o["remove"]=r;var A=new sap.m.Button({type:sap.m.ButtonType.Transparent,icon:sap.ui.core.IconPool.getIconURI("add"),tooltip:this._oRb.getText("CONDITIONPANEL_ADD"+(this._sAddRemoveIconTooltipKey?"_"+this._sAddRemoveIconTooltipKey:"")+"_TOOLTIP"),press:function(){d._handleAddCondition(this.oTargetGrid,o);},layoutData:new sap.ui.layout.GridData({span:this.getLayoutMode()==="Desktop"?"L1 M1 S1":"L1 M10 S10"})});A.oTargetGrid=t;A.addStyleClass("conditionAddBtnFloatRight");b.addContent(A);o["add"]=A;t.insertContent(o,p);this._updateOperationItems(t,o);this._changeOperationValueFields(t,o);this._updateAllConditionsEnableStates();this._updateConditionButtons(t);if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(t,false);}if(this._sLayoutMode){this._updateLayout({name:this._sLayoutMode});}if(c){var s=this._getFormatedConditionText(c.operation,c.value1,c.value2,c.exclude,c.keyField,c.showIfGrouped);c._oGrid=o;c.value=s;this._oConditionsMap[k]=c;}return o;};
P.prototype._handleRemoveCondition=function(t,c){var i=t.getContent().indexOf(c);this._removeCondition(t,c);if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(t,false);}if(i>=0){i=Math.min(i,t.getContent().length-1);var c=t.getContent()[i];setTimeout(function(){c.remove.focus();});}this._updatePaginatorToolbar();};
P.prototype._handleAddCondition=function(t,s){var p=t.getContent().indexOf(s);var c=this._createConditionRow(t,undefined,null,p+1);this._changeField(c);setTimeout(function(){c.keyField.focus();});this._updatePaginatorToolbar();};
P.prototype._getCurrentKeyFieldItem=function(k){if(k.getSelectedKey&&k.getSelectedKey()){var K=k.getSelectedKey();var i=this._aKeyFields;for(var b in i){var o=i[b];if(o.key===K){return o;}}}return null;};
P.prototype._createValueField=function(c,f,o){var b;var s=c?c.type:"";var t=this;var p={value:f["Value"],width:"100%",placeholder:f["Label"],change:function(e){t._validateFormatFieldValue(e);t._changeField(o);},layoutData:new sap.ui.layout.GridData({span:f["Span"+this._sConditionType]})};switch(s){case"boolean":case"enum":var d=[];var v=c.values||this._oTypeValues[s]||["",false,true];v.forEach(function(V,i){d.push(new sap.ui.core.Item({key:s==="boolean"?(i===v.length-1).toString():V.toString(),text:V.toString()}));});p={width:"100%",items:d,change:function(){t._changeField(o);},layoutData:new sap.ui.layout.GridData({span:f["Span"+this._sConditionType]})};o.oFormatter=null;b=new sap.m.Select(p);break;case"numeric":var F;if(c.precision||c.scale){F={};if(c.precision){F["maxIntegerDigits"]=parseInt(c.precision,10);}if(c.scale){F["maxFractionDigits"]=parseInt(c.scale,10);}}o.oFormatter=N.getFloatInstance(F);b=new sap.m.Input(p);break;case"date":o.oFormatter=D.getDateInstance();b=new sap.m.DatePicker(p);break;case"time":o.oFormatter=D.getTimeInstance();b=new sap.m.TimePicker(p);break;default:o.oFormatter=null;b=new sap.m.Input(p);if(this._fSuggestCallback){var c=this._getCurrentKeyFieldItem(o.keyField);if(c&&c.key){var S=this._fSuggestCallback(b,c.key);if(S){b._oSuggestProvider=S;}}}}if(s!=="boolean"&&s!=="enum"){b.onpaste=function(e){var O;if(window.clipboardData){O=window.clipboardData.getData("Text");}else{O=e.originalEvent.clipboardData.getData('text/plain');}var o=e.srcControl.getParent();var g=O.split(/\r\n|\r|\n/g);if(g){setTimeout(function(){var L=g?g.length:0;if(L>1){var k=t._getCurrentKeyFieldItem(o.keyField);var h=o.operation;for(var i=0;i<L;i++){if(t._aConditionKeys.length>=t._getMaxConditionsAsNumber()){break;}if(g[i]){var j={"key":t._createConditionKey(),"exclude":t.getExclude(),"operation":h.getSelectedKey(),"keyField":k.key,"value1":g[i],"value2":null};t._addCondition2Map(j);t.fireDataChange({key:j.key,index:j.index,operation:"add",newData:j});}}t._clearConditions();t._fillConditions();}},0);}};}if(c&&c.maxLength&&b.setMaxLength){var l=-1;if(typeof c.maxLength==="string"){l=parseInt(c.maxLength,10);}if(typeof c.maxLength==="number"){l=c.maxLength;}if(l>0&&(!b.getShowSuggestion||!b.getShowSuggestion())){b.setMaxLength(l);}}return b;};
P.prototype._fillOperationListItems=function(c,o,t){if(t==="_STRING_"){t="";}if(t==="_TIME_"){t="_DATE_";}if(t==="_BOOLEAN_"){t="";}c.destroyItems();for(var O in o){var T=this._oRb.getText("CONDITIONPANEL_OPTION"+t+o[O]);if(q.sap.startsWith(T,"CONDITIONPANEL_OPTION")){T=this._oRb.getText("CONDITIONPANEL_OPTION"+o[O]);}c.addItem(new sap.ui.core.ListItem({key:o[O],text:T,tooltip:T}));}};
P.prototype._fillKeyFieldListItems=function(c,i){c.destroyItems();for(var b in i){var o=i[b];c.addItem(new sap.ui.core.ListItem({key:o.key,text:o.text,tooltip:o.tooltip?o.tooltip:o.text}));}};
P.prototype._handleChangeOnOperationField=function(t,c){this._changeOperationValueFields(t,c);this._changeField(c);};
P.prototype._handleSelectionChangeOnKeyField=function(t,c){if(this._sConditionType==="Filter"){this._updateOperationItems(t,c);this._createAndUpdateValueFields(t,c);this._changeOperationValueFields(t,c);}this._changeField(c);};
P.prototype._handleChangeOnKeyField=function(t,c){if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(t,false,false,c.keyField);}};
P.prototype._createAndUpdateAllKeyFields=function(){var c=this._oConditionsGrid.getContent();c.forEach(function(o){this._createAndUpdateValueFields(this._oConditionsGrid,o);this._changeOperationValueFields(this._oConditionsGrid,o);},this);};
P.prototype._createAndUpdateValueFields=function(t,c){var o=this._getCurrentKeyFieldItem(c.keyField);var f=function(c,b,i){var O=b.getValue?b.getValue():"";var d=c.indexOfContent(b);c.removeAggregation("content",b,true);if(b._oSuggestProvider){b._oSuggestProvider.destroy();b._oSuggestProvider=null;}b.destroy();var e=this._aConditionsFields[i];b=this._createValueField(o,e,c);c[e["ID"]]=b;c.insertAggregation("content",b,d,true);var v,V;if(c.oFormatter&&O){v=c.oFormatter.parse(O);if(!isNaN(v)&&v!==null){V=c.oFormatter.format(v);b.setValue(V);}}if(!V){b.setValue(O);}};q.proxy(f,this)(c,c.value1,5);q.proxy(f,this)(c,c.value2,6);};
P.prototype._updateAllOperations=function(){var c=this._oConditionsGrid.getContent();c.forEach(function(o){this._updateOperationItems(this._oConditionsGrid,o);this._changeOperationValueFields(this._oConditionsGrid,o);},this);};
P.prototype._updateOperationItems=function(t,c){var T="";var k=this._getCurrentKeyFieldItem(c.keyField);var o=c.operation;var O=this._oTypeOperations["default"];var b=o.getSelectedItem();if(k&&!this.getExclude()){if(k.type&&k.type!==""&&this._oTypeOperations[k.type]){T=k.type;O=this._oTypeOperations[T];}if(k.operations){O=k.operations;}}this._fillOperationListItems(o,O,T?"_"+T.toUpperCase()+"_":"");if(b&&o.getItemByKey(b.getKey())){o.setSelectedKey(b.getKey());}else{o.setSelectedItem(o.getItems()[0]);}this._sConditionType="Filter";if(O[0]===sap.m.P13nConditionOperation.Ascending||O[0]===sap.m.P13nConditionOperation.Descending){this._sConditionType="Sort";}if(O[0]===sap.m.P13nConditionOperation.GroupAscending||O[0]===sap.m.P13nConditionOperation.GroupDescending){this._sConditionType="Group";}this._adjustValue1Span(c);};
P.prototype._updateKeyFieldItems=function(t,f,A,o){var n=t.getContent().length;var i;var u={};if(!f){for(i=0;i<n;i++){var k=t.getContent()[i].keyField;var K=k.getSelectedKey();if(K!=null&&K!==""){u[K]=true;}}}for(i=0;i<n;i++){var k=t.getContent()[i].keyField;var s=t.getContent()[i].select;var O=k.getSelectedKey();var j=0;var b=this._aKeyFields;if(k!==o){if(A){j=b.length-1;}else{k.destroyItems();}for(j;j<b.length;j++){var c=b[j];if(c.key==null||c.key===""||!u[c.key]||c.key===O){k.addItem(new sap.ui.core.ListItem({key:c.key,text:c.text,tooltip:c.tooltip?c.tooltip:c.text}));}}}if(O){k.setSelectedKey(O);}else if(k.getItems().length>0){k.setSelectedItem(k.getItems()[0]);}if(!s.getSelected()){this._aKeyFields.some(function(d,e){if(d.isDefault){k.setSelectedItem(k.getItems()[e]);return true;}if(!k.getSelectedItem()){if(d.type!=="boolean"){k.setSelectedItem(k.getItems()[e]);}}},this);}if(k.getSelectedItem()){k.setTooltip(k.getSelectedItem().getTooltip()||k.getSelectedItem().getText());}}};
P.prototype._changeOperationValueFields=function(t,c){var o=c.operation;var O=o.getSelectedKey();var v=c.value1;var V=c.value2;var s=c.showIfGrouped;if(!O){return;}if(O===sap.m.P13nConditionOperation.BT){if(v.setPlaceholder&&v.getPlaceholder()!==this._sFromLabelText){v.setPlaceholder(this._sFromLabelText);}if(!v.getVisible()){v.setVisible(true);c.insertContent(v,c.getContent().length-1);}if(V.setPlaceholder&&V.getPlaceholder()!==this._sToLabelText){V.setPlaceholder(this._sToLabelText);}if(!V.getVisible()){V.setVisible(true);c.insertContent(V,c.getContent().length-1);}}else{if(O===sap.m.P13nConditionOperation.GroupAscending||O===sap.m.P13nConditionOperation.GroupDescending){if(v.getVisible()){v.setVisible(false);c.removeContent(v);}if(V.getVisible()){V.setVisible(false);c.removeContent(V);}if(o.getVisible()){o.setVisible(false);c.removeContent(o);}s.setVisible(this._getMaxConditionsAsNumber()!=1);}else{if(O===sap.m.P13nConditionOperation.NotEmpty||O===sap.m.P13nConditionOperation.Empty||O===sap.m.P13nConditionOperation.Initial||O===sap.m.P13nConditionOperation.Ascending||O===sap.m.P13nConditionOperation.Descending||O===sap.m.P13nConditionOperation.Total||O===sap.m.P13nConditionOperation.Average||O===sap.m.P13nConditionOperation.Minimum||O===sap.m.P13nConditionOperation.Maximum){if(v.getVisible()){v.setVisible(false);c.removeContent(v);}if(V.getVisible()){V.setVisible(false);c.removeContent(V);}c.removeContent(s);}else{if(v.setPlaceholder&&v.getPlaceholder()!==this._sValueLabelText){v.setPlaceholder(this._sValueLabelText);}if(!v.getVisible()){v.setVisible(true);c.insertContent(v,c.getContent().length-1);}if(V.getVisible()){V.setVisible(false);c.removeContent(V);}}}}this._adjustValue1Span(c);};
P.prototype._adjustValue1Span=function(c){if(this._sConditionType==="Filter"&&c.value1&&c.operation){var o=c.operation;var n=this._aConditionsFields[5]["Span"+this._sConditionType];if(o.getSelectedKey()!=="BT"){n="L5 M10 S10";}var l=c.value1.getLayoutData();if(l.getSpan()!==n){l.setSpan(n);}}};
P.prototype._getIndexOfCondition=function(c){var i=-1;c.getParent().getContent().some(function(g){if(g.select.getSelected()){i++;}return(g===c);},this);return i+this._iFirstConditionIndex;};
P.prototype._makeFieldValid=function(c,v){if(v){c.setValueState(sap.ui.core.ValueState.None);c.setValueStateText("");}else{c.setValueState(sap.ui.core.ValueState.Warning);c.setValueStateText(this._sValidationDialogFieldMessage);}};
P.prototype._validateFormatFieldValue=function(e){var c=e.oSource;var o=c.getParent();var v;if(c.getDateValue&&e){v=e.getParameter("value");var V=e.getParameter("valid");this._makeFieldValid(c,V);return;}else{v=c.getValue&&c.getValue();}if(!o){return;}if(this.getDisplayFormat()==="UpperCase"&&v){v=v.toUpperCase();c.setValue(v);}if(o.oFormatter&&v){var b=o.oFormatter.parse(v);var V=!isNaN(b)&&b!==null;this._makeFieldValid(c,V);if(V){v=o.oFormatter.format(b);c.setValue(v);}}};
P.prototype._changeField=function(c,e){var k=c.keyField.getSelectedKey();if(c.keyField.getSelectedItem()){c.keyField.setTooltip(c.keyField.getSelectedItem().getTooltip()||c.keyField.getSelectedItem().getText());}else{c.keyField.setTooltip(null);}var o=c.operation.getSelectedKey();if(c.operation.getSelectedItem()){c.operation.setTooltip(c.operation.getSelectedItem().getTooltip()||c.operation.getSelectedItem().getText());}else{c.operation.setTooltip(null);}var v=this._getValueTextFromField(c.value1,c.oFormatter);var V=v;if(c.oFormatter&&v){V=c.oFormatter.parse(v);if(isNaN(V)||V===null){v="";}}var s=this._getValueTextFromField(c.value2,c.oFormatter);var b=s;if(c.oFormatter&&s){b=c.oFormatter.parse(s);if(isNaN(b)||b===null){s="";}}var d=this._getCurrentKeyFieldItem(c.keyField);var f=d?d.type:"";if(f==="boolean"){var g=d.values||this._oTypeValues[f]||["",false,true];var t=g[g.length-1].toString();V=v===t;b=null;}var S=c.showIfGrouped.getSelected();var E=this.getExclude();var h=c.select;var i="";var K;if(k===""||k==null){k=null;K=this._getKeyFromConditionGrid(c);this._removeConditionFromMap(K);this._enableCondition(c,false);var j=this._getIndexOfCondition(c);if(h.getSelected()){h.setSelected(false);h.setEnabled(false);this._bIgnoreSetConditions=true;this.fireDataChange({key:K,index:j,operation:"remove",newData:null});this._bIgnoreSetConditions=false;}return;}this._enableCondition(c,true);i=this._getFormatedConditionText(o,v,s,E,k,S);var l={"value":i,"exclude":E,"operation":o,"keyField":k,"value1":V,"value2":o===sap.m.P13nConditionOperation.BT?b:null,"showIfGrouped":S};K=this._getKeyFromConditionGrid(c);if(i!==""){h.setSelected(true);h.setEnabled(true);var o="update";if(!this._oConditionsMap[K]){o="add";}this._oConditionsMap[K]=l;if(o==="add"){this._aConditionKeys.splice(this._getIndexOfCondition(c),0,K);}c.data("_key",K);this.fireDataChange({key:K,index:this._getIndexOfCondition(c),operation:o,newData:l});}else if(this._oConditionsMap[K]!==undefined){this._removeConditionFromMap(K);c.data("_key",null);var j=this._getIndexOfCondition(c);if(h.getSelected()){h.setSelected(false);h.setEnabled(false);this._bIgnoreSetConditions=true;this.fireDataChange({key:K,index:j,operation:"remove",newData:null});this._bIgnoreSetConditions=false;}}this._updatePaginatorToolbar();};
P.prototype._getValueTextFromField=function(c,f){if(c.getDateValue&&c.getDateValue()){return f.format(c.getDateValue());}if(c instanceof sap.m.Select){return c.getSelectedItem()?c.getSelectedItem().getText():"";}return c.getValue();};
P.prototype._updateAllConditionsEnableStates=function(){var c=this._oConditionsGrid.getContent();c.forEach(function(o){var k=this._getCurrentKeyFieldItem(o.keyField);var K=k&&k.key!==undefined?k.key:k;var e=K!==""&&K!==null;this._enableCondition(o,e);},this);};
P.prototype._enableCondition=function(c,e){c.operation.setEnabled(e);c.value1.setEnabled(e);c.value2.setEnabled(e);c.showIfGrouped.setEnabled(e);};
P.prototype._removeCondition=function(t,c){var k=this._getKeyFromConditionGrid(c);var i=-1;if(c.select.getSelected()){i=this._getIndexOfCondition(c);}this._removeConditionFromMap(k);c.destroy();if(t.getContent().length<1){this._createConditionRow(t);}else{this._updateConditionButtons(t);}if(i>=0){this.fireDataChange({key:k,index:i,operation:"remove",newData:null});}};
P.prototype._updateConditionButtons=function(t){var m=this._getMaxConditionsAsNumber();var n=t.getContent().length;for(var i=0;i<n;i++){var A=t.getContent()[i].add;if((this.getAlwaysShowAddIcon()&&(n<m))||(i===n-1&&i<m-1)){A.removeStyleClass("displayNone");}else{A.addStyleClass("displayNone");}var r=t.getContent()[i].remove;if(m===1||(i===0&&n===1&&this.getDisableFirstRemoveIcon())){r.addStyleClass("displayNone");}else{r.removeStyleClass("displayNone");}}};
P.prototype.validateConditions=function(){var t=this;var c=function(g){var v=true;for(var i=0;i<g.length;i++){var G=g[i];var b=t._checkCondition(G,i===g.length-1);v=v&&b;}return v;};return c(this._oConditionsGrid.getContent());};
P.prototype.removeValidationErrors=function(){this._oConditionsGrid.getContent().forEach(function(c){var v=c.value1;var V=c.value2;v.setValueState(sap.ui.core.ValueState.None);v.setValueStateText("");V.setValueState(sap.ui.core.ValueState.None);V.setValueStateText("");},this);};
P.prototype.removeInvalidConditions=function(){var i=[];this._oConditionsGrid.getContent().forEach(function(c){if(c.value1.getValueState()!==sap.ui.core.ValueState.None||c.value2.getValueState()!==sap.ui.core.ValueState.None){i.push(c);}},this);i.forEach(function(c){this._removeCondition(this._oConditionsGrid,c);if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(this._oConditionsGrid,false);}},this);};
P.prototype._checkCondition=function(c,i){var v=true;var b=c.value1;var d=c.value2;var V=b&&(b.getVisible()&&!this._getValueTextFromField(b,c.oFormatter));var e=d&&(d.getVisible()&&!this._getValueTextFromField(d,c.oFormatter));var o=c.operation.getSelectedKey();if(o===sap.m.P13nConditionOperation.BT){if(!V?e:!e){if(V){b.setValueState(sap.ui.core.ValueState.Warning);b.setValueStateText(this._sValidationDialogFieldMessage);}if(e){d.setValueState(sap.ui.core.ValueState.Warning);d.setValueStateText(this._sValidationDialogFieldMessage);}v=false;}else{b.setValueState(sap.ui.core.ValueState.None);b.setValueStateText("");d.setValueState(sap.ui.core.ValueState.None);d.setValueStateText("");}}if((b.getVisible()&&b.getValueState&&b.getValueState()!==sap.ui.core.ValueState.None)||(d.getVisible()&&d.getValueState&&d.getValueState()!==sap.ui.core.ValueState.None)){v=false;}return v;};
P.prototype._getFormatedConditionText=function(o,v,V,e,k,s){var c="";var K=null;if(this._aKeyFields&&this._aKeyFields.length>1){for(var i=0;i<this._aKeyFields.length;i++){var b=this._aKeyFields[i];if(typeof b!=="string"){if(b.key===k&&b.text){K=b.text;}}}}switch(o){case sap.m.P13nConditionOperation.EQ:if(v!==""&&v!==undefined){c="="+v;}break;case sap.m.P13nConditionOperation.GT:if(v!==""&&v!==undefined){c=">"+v;}break;case sap.m.P13nConditionOperation.GE:if(v!==""&&v!==undefined){c=">="+v;}break;case sap.m.P13nConditionOperation.LT:if(v!==""&&v!==undefined){c="<"+v;}break;case sap.m.P13nConditionOperation.LE:if(v!==""&&v!==undefined){c="<="+v;}break;case sap.m.P13nConditionOperation.Contains:if(v!==""&&v!==undefined){c="*"+v+"*";}break;case sap.m.P13nConditionOperation.StartsWith:if(v!==""&&v!==undefined){c=v+"*";}break;case sap.m.P13nConditionOperation.EndsWith:if(v!==""&&v!==undefined){c="*"+v;}break;case sap.m.P13nConditionOperation.BT:if(v!==""&&v!==undefined){if(V!==""){c=v+"..."+V;}}break;case sap.m.P13nConditionOperation.Initial:c="=''";break;case sap.m.P13nConditionOperation.Empty:c="''";break;case sap.m.P13nConditionOperation.NotEmpty:c="!''";break;case sap.m.P13nConditionOperation.Ascending:c="ascending";break;case sap.m.P13nConditionOperation.GroupAscending:c="ascending";c+=" showIfGrouped:"+s;break;case sap.m.P13nConditionOperation.Descending:c="descending";break;case sap.m.P13nConditionOperation.GroupDescending:c="descending";c+=" showIfGrouped:"+s;break;case sap.m.P13nConditionOperation.Total:c="total";break;case sap.m.P13nConditionOperation.Average:c="average";break;case sap.m.P13nConditionOperation.Minimum:c="minimum";break;case sap.m.P13nConditionOperation.Maximum:c="maximum";break;}if(e&&c!==""){c="!("+c+")";}if(K&&c!==""){c=K+": "+c;}return c;};
P.prototype._updateLayout=function(r){if(!this._oConditionsGrid){return;}var g=this._oConditionsGrid.getContent();var n=this._aConditionsFields.length;var b=n;if(r.name==="Tablet"){b=5;}if(r.name==="Phone"){b=3;}if(this._sConditionType==="Filter"){for(var i=0;i<g.length;i++){var c=g[i];c.ButtonContainer.removeStyleClass("floatRight");c.removeContent(c.ButtonContainer);c.insertContent(c.ButtonContainer,b);if(!this.getAlwaysShowAddIcon()){if(b!==n){c.ButtonContainer.removeContent(c.add);c.addContent(c.add);}else{c.removeContent(c.add);c.ButtonContainer.addContent(c.add);}}}}};
P.prototype._onGridResize=function(){if(this._oPaginatorToolbar&&this._oConditionsGrid&&this._oConditionsGrid.getContent().length>0){var g=this._oConditionsGrid.getContent()[0];if(g.remove&&g.remove.$().position()){var w=0;if(this._oPaginatorToolbar.getParent()&&this._oPaginatorToolbar.getParent().getExpandable&&this._oPaginatorToolbar.getParent().getExpandable()){w=48-4;}var t=g.remove.$().position().left-w+g.remove.$().width();this._oPaginatorToolbar.setWidth(t+"px");}}var d=this._oConditionsGrid.getDomRef();if(!d){return;}if(!q(d).is(":visible")){return;}var w=d.clientWidth;var r={};if(w<=this._iBreakPointTablet){r.name="Phone";}else if((w>this._iBreakPointTablet)&&(w<=this._iBreakPointDesktop)){r.name="Tablet";}else{r.name="Desktop";}if(r.name==="Phone"&&this._sLayoutMode!==r.name){this._updateLayout(r);this._sLayoutMode=r.name;}if(r.name==="Tablet"&&this._sLayoutMode!==r.name){this._updateLayout(r);this._sLayoutMode=r.name;}if(r.name==="Desktop"&&this._sLayoutMode!==r.name){this._updateLayout(r);this._sLayoutMode=r.name;}};
sap.m.P13nConditionOperation={BT:"BT",EQ:"EQ",Contains:"Contains",StartsWith:"StartsWith",EndsWith:"EndsWith",LT:"LT",LE:"LE",GT:"GT",GE:"GE",Initial:"Initial",Empty:"Empty",NotEmpty:"NotEmpty",Ascending:"Ascending",Descending:"Descending",GroupAscending:"GroupAscending",GroupDescending:"GroupDescending",Total:"Total",Average:"Average",Minimum:"Minimum",Maximum:"Maximum"};return P;},true);
sap.ui.predefine('sap/m/P13nDialog',['jquery.sap.global','./Dialog','./IconTabBar','./IconTabFilter','./library','sap/ui/core/EnabledPropagator','sap/m/ButtonType','sap/m/DialogRenderer','sap/ui/core/MessageType'],function(q,D,I,a,l,E,B,b,M){"use strict";
var P=D.extend("sap.m.P13nDialog",{
metadata:{library:"sap.m",properties:{initialVisiblePanelType:{type:"string",group:"Misc",defaultValue:null},showReset:{type:"boolean",group:"Appearance",defaultValue:false},showResetEnabled:{type:"boolean",group:"Appearance",defaultValue:false},validationExecutor:{type:"object",group:"Misc",defaultValue:null}},aggregations:{panels:{type:"sap.m.P13nPanel",multiple:true,singularName:"panel",bindable:"bindable"}},events:{ok:{},cancel:{},reset:{}}},
renderer:function(r,c){b.render.apply(this,arguments);var i=c._getVisiblePanelID();var p=c.getVisiblePanel();if(i&&p){r.write("<div");r.writeAttribute("id",i);r.write(">");r.renderControl(p);r.write("</div>");}}
});
E.apply(P.prototype,[true]);
P.prototype.init=function(e){this.addStyleClass("sapMP13nDialog");D.prototype.init.apply(this,arguments);this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oResetButton=null;this._mValidationListener={};this._createDialog();};
P.prototype.setShowReset=function(s){this.setProperty("showReset",s);if(this.getButtons()&&this.getButtons()[2]){this.getButtons()[2].setVisible(s);}return this;};
P.prototype.setShowResetEnabled=function(e){this.setProperty("showResetEnabled",e);if(this.getButtons()&&this.getButtons()[2]){this.getButtons()[2].setEnabled(e);}return this;};
P.prototype.addPanel=function(p){this.addAggregation("panels",p);var n=this._mapPanelToNavigationItem(p);p.data("sapMP13nDialogNavigationItem",n);var N=this._getNavigationControl();if(N){sap.ui.Device.system.phone?N.addItem(n):N.addButton(n);}this._setVisibilityOfPanel(p);this._setDialogTitleFor(p);return this;};
P.prototype.insertPanel=function(p,i){this.insertAggregation("panels",p,i);var n=this._mapPanelToNavigationItem(p);p.data("sapMP13nDialogNavigationItem",n);var N=this._getNavigationControl();if(N){sap.ui.Device.system.phone?N.insertItem(n):N.insertButton(n);}this._setVisibilityOfPanel(p);this._setDialogTitleFor(p);return this;};
P.prototype.removePanel=function(p){p=this.removeAggregation("panels",p);var n=this._getNavigationControl();if(n){sap.ui.Device.system.phone?n.removeItem(p&&this._getNavigationItemByPanel(p)):n.removeButton(p&&this._getNavigationItemByPanel(p));}return p;};
P.prototype.removeAllPanels=function(){var p=this.removeAllAggregation("panels");var n=this._getNavigationControl();if(n){sap.ui.Device.system.phone?n.removeAllItems():n.removeAllButtons();}return p;};
P.prototype.destroyPanels=function(){this.destroyAggregation("panels");var n=this._getNavigationControl();if(n){sap.ui.Device.system.phone?n.destroyItems():n.destroyButtons();}return this;};
P.prototype._createDialog=function(){if(sap.ui.Device.system.phone){var t=this;this.setStretch(true);this.setVerticalScrolling(false);this.setHorizontalScrolling(false);this.setCustomHeader(new sap.m.Bar({contentLeft:new sap.m.Button({visible:false,type:B.Back,press:function(e){t._backToList();}}),contentMiddle:new sap.m.Title({text:this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS"),level:"H1"})}));this.addButton(this._createOKButton());this.addButton(this._createCancelButton());this.addButton(this._createResetButton());}else{this.setHorizontalScrolling(false);this.setContentWidth("65rem");this.setContentHeight("40rem");this.setDraggable(true);this.setResizable(true);this.setTitle(this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS"));this.addButton(this._createOKButton());this.addButton(this._createCancelButton());this.addButton(this._createResetButton());}};
P.prototype._getNavigationControl=function(){if(this.getPanels().length<2){return null;}var t=this;if(sap.ui.Device.system.phone){if(!this.getContent().length){this.addContent(new sap.m.List({mode:sap.m.ListMode.None,itemPress:function(e){if(e){t._switchPanel(e.getParameter("listItem"));}}}));this.getContent()[0].addItem(this._getNavigationItemByPanel(this.getPanels()[0]));}return this.getContent()[0];}else{if(!this.getSubHeader()||!this.getSubHeader().getContentLeft().length){this.setSubHeader(new sap.m.Bar({contentLeft:[new sap.m.SegmentedButton({select:function(e){t._switchPanel(e.getParameter("button"));},width:'100%'})]}));this.getSubHeader().getContentLeft()[0].addButton(this._getNavigationItemByPanel(this.getPanels()[0]));}return this.getSubHeader().getContentLeft()[0];}};
P.prototype._showValidationDialog=function(c,f,v){var w=[];var e=[];this._prepareMessages(f,v,w,e);q.sap.require("sap.m.MessageBox");var m="";if(e.length){e.forEach(function(o,i,d){m=(d.length>1?"• ":"")+o.messageText+"\n"+m;});sap.m.MessageBox.show(m,{icon:sap.m.MessageBox.Icon.ERROR,title:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_TITLE_ERROR"),actions:[sap.m.MessageBox.Action.CLOSE],styleClass:!!this.$().closest(".sapUiSizeCompact").length?"sapUiSizeCompact":""});}else if(w.length){w.forEach(function(o,i,d){m=(d.length>1?"• ":"")+o.messageText+"\n"+m;});m=m+sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_MESSAGE_QUESTION");sap.m.MessageBox.show(m,{icon:sap.m.MessageBox.Icon.WARNING,title:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_TITLE"),actions:[sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_FIX"),sap.m.MessageBox.Action.IGNORE],onClose:function(A){if(A===sap.m.MessageBox.Action.IGNORE){c();}},styleClass:!!this.$().closest(".sapUiSizeCompact").length?"sapUiSizeCompact":""});}};
P.prototype._prepareMessages=function(f,v,w,e){if(!f.length&&!v.length){return;}f.forEach(function(p){switch(p){case sap.m.P13nPanelType.filter:v.push({messageType:M.Warning,messageText:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_MESSAGE")});break;case sap.m.P13nPanelType.columns:v.push({messageType:M.Warning,messageText:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VISIBLE_ITEMS_THRESHOLD_MESSAGE")});break;case sap.m.P13nPanelType.dimeasure:v.push({messageType:M.Error,messageText:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_CHARTTYPE")});break;}});var u=v.filter(function(m,c,d){for(var i=++c;i<d.length;i++){if(m.messageText===d[i].messageText){return false;}}return true;});u.forEach(function(m){if(m.messageType===M.Warning){w.push(m);}else if(m.messageType===M.Error){e.push(m);}});};
P.prototype._mapPanelToNavigationItem=function(p){if(!p){return null;}var n=null;if(sap.ui.Device.system.phone){n=new sap.m.StandardListItem({type:sap.m.ListType.Navigation,title:p.getBindingPath("title")?q.extend(true,{},p.getBindingInfo("title")):p.getTitle()});}else{n=new sap.m.Button({type:B.Default,text:p.getBindingPath("title")?q.extend(true,{},p.getBindingInfo("title")):p.getTitle()});}p.setValidationExecutor(q.proxy(this._callValidationExecutor,this));p.setValidationListener(q.proxy(this._registerValidationListener,this));p.setChangeNotifier(q.proxy(this._callChangeNotifier,this));return n;};
P.prototype._switchPanel=function(n){var p=this._getPanelByNavigationItem(n);this.setVerticalScrolling(p.getVerticalScrolling());if(sap.ui.Device.system.phone){var N=this._getNavigationControl();if(N){N.setVisible(false);p.beforeNavigationTo();p.setVisible(true);this.getCustomHeader().getContentMiddle()[0].setText(p.getTitle());this.getCustomHeader().getContentLeft()[0].setVisible(true);}}else{this.getPanels().forEach(function(o){if(o===p){o.beforeNavigationTo();o.setVisible(true);}else{o.setVisible(false);}},this);}this.invalidate();this.rerender();};
P.prototype._backToList=function(){var n=this._getNavigationControl();if(n){n.setVisible(true);var p=this.getVisiblePanel();p.setVisible(false);this._setDialogTitleFor(p);this.getCustomHeader().getContentLeft()[0].setVisible(false);}};
P.prototype.getVisiblePanel=function(){var p=null;this.getPanels().some(function(o){if(o.getVisible()){p=o;return true;}});return p;};
P.prototype._getPanelByNavigationItem=function(n){for(var i=0,p=this.getPanels(),c=p.length;i<c;i++){if(p[i].data("sapMP13nDialogNavigationItem")===n){return p[i];}}return null;};
P.prototype._getNavigationItemByPanel=function(p){if(!p){return null;}return p.data("sapMP13nDialogNavigationItem");};
P.prototype._setVisibilityOfOtherPanels=function(p,v){for(var i=0,c=this.getPanels(),d=c.length;i<d;i++){if(c[i]===p){continue;}c[i].setVisible(v);}};
P.prototype._setVisibilityOfPanel=function(p){var v;if(sap.ui.Device.system.phone){v=this.getPanels().length===1;if(v){p.beforeNavigationTo();if(!this.getModel()){this.setModel(p.getModel("$sapmP13nPanel"),"$sapmP13nDialog");}}p.setVisible(v);this._setVisibilityOfOtherPanels(p,false);}else{v=this.getInitialVisiblePanelType()===p.getType()||this.getPanels().length===1;if(v){p.beforeNavigationTo();if(!this.getModel()){this.setModel(p.getModel("$sapmP13nPanel"),"$sapmP13nDialog");}}p.setVisible(v);if(v){this._setVisibilityOfOtherPanels(p,false);this.setVerticalScrolling(p.getVerticalScrolling());var o=this._getNavigationItemByPanel(p);var n=this._getNavigationControl();if(n){n.setSelectedButton(o);}}}};
P.prototype.onAfterRendering=function(){D.prototype.onAfterRendering.apply(this,arguments);var c=q(this.getFocusDomRef()).find(".sapMDialogScrollCont");var i=this._getVisiblePanelID();if(i&&c){var p=q.find("#"+i);q(p).appendTo(q(c));}};
P.prototype._getVisiblePanelID=function(){var p=this.getVisiblePanel();if(p){return this.getId()+"-panel_"+p.getId();}return null;};
P.prototype._setDialogTitleFor=function(p){var t;if(this.getPanels().length>1){t=this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS");}else{switch(p.getType()){case sap.m.P13nPanelType.filter:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_FILTER");break;case sap.m.P13nPanelType.sort:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_SORT");break;case sap.m.P13nPanelType.group:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_GROUP");break;case sap.m.P13nPanelType.columns:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_COLUMNS");break;case sap.m.P13nPanelType.dimeasure:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_DIMEASURE");break;default:t=p.getTitleLarge()||this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS");}}if(sap.ui.Device.system.phone){this.getCustomHeader().getContentMiddle()[0].setText(t);}else{this.setTitle(t);}};
P.prototype._registerValidationListener=function(p,c){if(this.getPanels().indexOf(p)&&c&&this._mValidationListener[p.getType()]===undefined){this._mValidationListener[p.getType()]=c;}};
P.prototype._callValidationExecutor=function(){var v=this.getValidationExecutor();if(v&&!q.isEmptyObject(this._mValidationListener)){var r=v(this._getPayloadOfPanels());var R=this._distributeValidationResult(r);for(var t in this._mValidationListener){var c=this._mValidationListener[t];c(R[t]||[]);}}};
P.prototype._callChangeNotifier=function(p){if(this.getShowReset()){this.setShowResetEnabled(true);}};
P.prototype._distributeValidationResult=function(r){var d={};r.forEach(function(R){R.panelTypes.forEach(function(t){if(d[t]===undefined){d[t]=[];}d[t].push({columnKey:R.columnKey,messageType:R.messageType,messageText:R.messageText});});});return d;};
P.prototype._createOKButton=function(){var t=this;return new sap.m.Button({text:this._oResourceBundle.getText("P13NDIALOG_OK"),layoutData:new sap.m.OverflowToolbarLayoutData({priority:sap.m.OverflowToolbarPriority.NeverOverflow}),press:function(){var p=t._getPayloadOfPanels();var f=function(){t.fireOk({payload:p});};var c=function(){t.getPanels().forEach(function(o){if(F.indexOf(o.getType())>-1){o.onAfterNavigationFrom();}});f();};var F=[];var v=[];var V=t.getValidationExecutor();if(V){v=V(p);}t.getPanels().forEach(function(o){if(!o.onBeforeNavigationFrom()){F.push(o.getType());}});if(F.length||v.length){t._showValidationDialog(c,F,v);}else{f();}}});};
P.prototype._createCancelButton=function(){var t=this;return new sap.m.Button({text:this._oResourceBundle.getText("P13NDIALOG_CANCEL"),layoutData:new sap.m.OverflowToolbarLayoutData({priority:sap.m.OverflowToolbarPriority.NeverOverflow}),press:function(){t.fireCancel();}});};
P.prototype._createResetButton=function(){var t=this;return new sap.m.Button({text:this._oResourceBundle.getText("P13NDIALOG_RESET"),layoutData:new sap.m.OverflowToolbarLayoutData({priority:sap.m.OverflowToolbarPriority.NeverOverflow}),visible:this.getShowReset(),enabled:this.getShowResetEnabled(),press:function(){t.setShowResetEnabled(false);var p={};t.getPanels().forEach(function(o){p[o.getType()]=o.getResetPayload();});t.fireReset({payload:p});}});};
P.prototype._getPayloadOfPanels=function(){var p={};this.getPanels().forEach(function(o){p[o.getType()]=o.getOkPayload();});return p;};
P.prototype.exit=function(){D.prototype.exit.apply(this,arguments);};
return P;},true);
sap.ui.predefine('sap/m/P13nDimMeasureItem',['jquery.sap.global','./library','sap/ui/core/Item'],function(q,l,I){"use strict";
var P=I.extend("sap.m.P13nDimMeasureItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string"},index:{type:"int",defaultValue:-1},visible:{type:"boolean"},role:{type:"string"}}}});
return P;},true);
sap.ui.predefine('sap/m/P13nDimMeasurePanel',['jquery.sap.global','./ColumnListItem','./P13nPanel','./P13nDimMeasureItem','./SearchField','./Table','./library','sap/ui/core/Control','sap/ui/model/json/JSONModel'],function(q,C,P,c,S,T,l,d,J){"use strict";
var e=P.extend("sap.m.P13nDimMeasurePanel",{
metadata:{library:"sap.m",properties:{chartTypeKey:{type:"string",defaultValue:""}},aggregations:{dimMeasureItems:{type:"sap.m.P13nDimMeasureItem",multiple:true,singularName:"dimMeasureItem",bindable:"bindable"},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},availableChartTypes:{type:"sap.ui.core.Item",multiple:true,singularName:"availableChartType"}}},
renderer:function(r,o){r.write("<div");r.writeControlData(o);r.addClass("sapMP13nColumnsPanel");r.writeClasses();r.write(">");var a=o.getAggregation("content");if(a){a.forEach(function(b){r.renderControl(b);});}r.write("</div>");}
});
e.prototype.init=function(){var t=this;this._iLiveChangeTimer=0;this._iSearchTimer=0;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._bOnAfterRenderingFirstTimeExecuted=false;this._bOnBeforeRenderingFirstTimeExecuted=false;var m=new J({availableChartTypes:[],selectedChartTypeKey:null,items:[],indexOfMarkedTableItem:-1,markedTableItem:null,isMoveDownButtonEnabled:false,isMoveUpButtonEnabled:false,showOnlySelectedItems:false,countOfSelectedItems:0,countOfItems:0});m.setDefaultBindingMode(sap.ui.model.BindingMode.TwoWay);m.setSizeLimit(1000);this.setModel(m,"$sapmP13nDimMeasurePanel");this.setType(sap.m.P13nPanelType.dimeasure);this.setTitle(this._oRb.getText("CHARTPANEL_TITLE"));this._createTable();this._createToolbar();this.setVerticalScrolling(false);var s=new sap.m.ScrollContainer({horizontal:false,vertical:true,content:[this._oTable],width:'100%',height:'100%'});this._fnHandleResize=function(){var b=false,i,a;if(t.getParent){var $=null,f,h;var p=t.getParent();var o=t._getToolbar();if(p){$=q("#"+p.getId()+"-cont");if($.children().length>0&&o.$().length>0){i=s.$()[0].clientHeight;f=$.children()[0].clientHeight;h=o?o.$()[0].clientHeight:0;a=f-h;if(i!==a){s.setHeight(a+'px');b=true;}}}}return b;};this.addAggregation("content",s);this._sContainerResizeListener=sap.ui.core.ResizeHandler.register(s,this._fnHandleResize);};
e.prototype._moveMarkedTableItem=function(D){var o=this.getModel("$sapmP13nDimMeasurePanel").getData();if(!o.markedTableItem||o.indexOfMarkedTableItem<0){return;}var v=this._getVisibleTableItems();if(v.indexOf(o.markedTableItem)<0){return;}var f=function(){switch(D){case"Down":return o.indexOfMarkedTableItem+1;case"Bottom":return V.length-1;case"Up":return o.indexOfMarkedTableItem-1;case"Top":return 0;}};var V=this._getVisibleModelItems();var m=V[o.indexOfMarkedTableItem];var M=V[f()];if(this._moveModelItems(this._getModelItemIndexByColumnKey(m.columnKey),this._getModelItemIndexByColumnKey(M.columnKey))){this._switchMarkedTableItemTo(v[f()]);}};
e.prototype._filterModelItemsBySearchText=function(){var m=this.getModel("$sapmP13nDimMeasurePanel");var s=this._getSearchText();s=s.replace(/(^\s+)|(\s+$)/g,'');s=s.replace(/[-\/\\^$*+?.()|[\]{}]/g,'\\$&');var r=new RegExp(s,'igm');if(!r){return;}this._getVisibleModelItems().forEach(function(M){M.visible=false;if(M.text&&M.text.match(r)){M.visible=true;}if(M.aggregationRole&&M.aggregationRole.match(r)){M.visible=true;}if(M.role&&M.role.match(r)){M.visible=true;}if(M.tooltip&&M.tooltip.match(r)){M.visible=true;}});m.refresh();};
e.prototype._scrollToSelectedItem=function(i){var f=null;if(i){sap.ui.getCore().applyChanges();if(!!i.getDomRef()){f=document.activeElement;i.focus();if(f&&f.focus){f.focus();}}}};
e.prototype.onBeforeRendering=function(){if(!this._bOnBeforeRenderingFirstTimeExecuted){this._bOnBeforeRenderingFirstTimeExecuted=true;this._syncPanel2Model();}var D=this.getModel("$sapmP13nDimMeasurePanel").getData();if(!D.markedTableItem){var v=this._getVisibleTableItems();this._switchMarkedTableItemTo(v[0]);}};
e.prototype.onAfterRendering=function(){var t=this;if(!this._bOnAfterRenderingFirstTimeExecuted){this._bOnAfterRenderingFirstTimeExecuted=true;window.clearTimeout(this._iLiveChangeTimer);this._iLiveChangeTimer=window.setTimeout(function(){t._fnHandleResize();t._getToolbar()._resetAndInvalidateToolbar();},0);}};
e.prototype.getOkPayload=function(){this._syncModel2Panel();return{dimMeasureItems:this.getDimMeasureItems(),chartTypeKey:this.getChartTypeKey()};};
e.prototype._syncModel2Panel=function(){if(!this._bOnBeforeRenderingFirstTimeExecuted){return;}var D=this.getModel("$sapmP13nDimMeasurePanel").getData();this.setChartTypeKey(D.selectedChartTypeKey);D.items.forEach(function(m){var o=this._getDimMeasureItemByColumnKey(m.columnKey);if(o){if(!this._isDimMeasureItemEqualToModelItem(o,m)){o.setVisible(m.persistentSelected);o.setIndex(m.persistentIndex);o.setRole(m.role);}return;}if(!m.persistentSelected){return;}o=new sap.m.P13nDimMeasureItem({columnKey:m.columnKey,visible:m.persistentSelected,index:m.persistentIndex,role:m.role});this.addAggregation("dimMeasureItems",o,true);},this);};
e.prototype._syncPanel2Model=function(){var m=this.getModel("$sapmP13nDimMeasurePanel");var D=m.getData();this.getDimMeasureItems().forEach(function(o){var M=this._getModelItemByColumnKey(o.getColumnKey());if(!M||this._isDimMeasureItemEqualToModelItem(o,M)){return;}M.persistentIndex=o.getIndex();M.persistentSelected=o.getVisible();M.role=o.getRole();this._sortModelItemsByPersistentIndex(D.items);this._reindexModelItemsByTableIndex(D);},this);m.refresh();};
e.prototype.exit=function(){sap.ui.core.ResizeHandler.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;this._getToolbar().destroy();this._oTable.destroy();this._oTable=null;if(this.getModel("$sapmP13nDimMeasurePanel")){this.getModel("$sapmP13nDimMeasurePanel").destroy();}window.clearTimeout(this._iLiveChangeTimer);window.clearTimeout(this._iSearchTimer);};
e.prototype.setChartTypeKey=function(s){var m=this.getModel("$sapmP13nDimMeasurePanel");this.setProperty("chartTypeKey",s);m.getData().selectedChartTypeKey=s;return this;};
e.prototype.addAvailableChartType=function(i){var m=this.getModel("$sapmP13nDimMeasurePanel");this.addAggregation("availableChartTypes",i);m.getData().availableChartTypes.push({key:i.getKey(),text:i.getText()});return this;};
e.prototype.insertAvailableChartType=function(i,I){var m=this.getModel("$sapmP13nDimMeasurePanel");this.insertAggregation("availableChartTypes",i,I);m.getData().availableChartTypes.splice(I,0,{key:i.getKey(),text:i.getText()});return this;};
e.prototype.removeAvailableChartType=function(i){var I=this.indexOfAvailableChartTypes(i);if(I>-1){var m=this.getModel("$sapmP13nDimMeasurePanel");m.getData().availableChartTypes.splice(I,1);}i=this.removeAggregation("availableChartTypes",i);return i;};
e.prototype.removeAllAvailableChartType=function(){var m=this.getModel("$sapmP13nDimMeasurePanel");var i=this.removeAllAggregation("availableChartTypes");m.getData().availableChartTypes=[];return i;};
e.prototype.destroyAvailableChartType=function(){var m=this.getModel("$sapmP13nDimMeasurePanel");this.destroyAggregation("availableChartTypes");m.getData().availableChartTypes=[];return this;};
e.prototype.addItem=function(i){var m=this.getModel("$sapmP13nDimMeasurePanel");var D=m.getData();this._bOnBeforeRenderingFirstTimeExecuted=false;this.addAggregation("items",i);this._includeModelItem(i,-1);this._sortModelItemsByPersistentIndex(D.items);this._reindexModelItemsByTableIndex(D);return this;};
e.prototype.insertItem=function(i,I){var m=this.getModel("$sapmP13nDimMeasurePanel");var D=m.getData();this._bOnBeforeRenderingFirstTimeExecuted=false;this.insertAggregation("items",i,I);this._includeModelItem(i,I);this._sortModelItemsByPersistentIndex(D.items);this._reindexModelItemsByTableIndex(D);return this;};
e.prototype.removeItem=function(i){var I=this.indexOfItem(i);if(I>-1){var m=this.getModel("$sapmP13nDimMeasurePanel");var D=m.getData();this._bOnBeforeRenderingFirstTimeExecuted=false;m.getData().items.splice(I,1);this._sortModelItemsByPersistentIndex(D.items);this._reindexModelItemsByTableIndex(D);}i=this.removeAggregation("items",i);return i;};
e.prototype.removeAllItems=function(){var m=this.getModel("$sapmP13nDimMeasurePanel");this._bOnBeforeRenderingFirstTimeExecuted=false;var i=this.removeAllAggregation("items");m.getData().items=[];return i;};
e.prototype.destroyItems=function(){var m=this.getModel("$sapmP13nDimMeasurePanel");this._bOnBeforeRenderingFirstTimeExecuted=false;this.destroyAggregation("items");m.getData().items=[];return this;};
e.prototype.addDimMeasureItem=function(D){var m=this.getModel("$sapmP13nDimMeasurePanel");var o=m.getData();this.addAggregation("dimMeasureItems",D);var M=this._getModelItemByColumnKey(D.getColumnKey());if(!M){return;}M.persistentIndex=D.getIndex();M.persistentSelected=D.getVisible();M.role=D.getRole();this._sortModelItemsByPersistentIndex(o.items);this._reindexModelItemsByTableIndex(o);return this;};
e.prototype.insertDimMeasureItem=function(D,i){var m=this.getModel("$sapmP13nDimMeasurePanel");var o=m.getData();this.insertAggregation("dimMeasureItems",D,i);var M=this._getModelItemByColumnKey(D.getColumnKey());if(!M){return;}M.persistentIndex=D.getIndex();M.persistentSelected=D.getVisible();M.role=D.getRole();this._sortModelItemsByPersistentIndex(o.items);this._reindexModelItemsByTableIndex(o);return this;};
e.prototype.removeDimMeasureItem=function(D){var m=this.getModel("$sapmP13nDimMeasurePanel");var o=m.getData();D=this.removeAggregation("dimMeasureItems",D);var M=this._getModelItemByColumnKey(D.getColumnKey());if(!M){return;}M.persistentIndex=-1;M.persistentSelected=undefined;M.role=undefined;this._sortModelItemsByPersistentIndex(o.items);this._reindexModelItemsByTableIndex(o);return D;};
e.prototype.removeAllDimMeasureItems=function(){var m=this.getModel("$sapmP13nDimMeasurePanel");var D=m.getData();this.getDimMeasureItems().forEach(function(o){var M=this._getModelItemByColumnKey(o.getColumnKey());if(!M){return;}M.persistentIndex=-1;M.persistentSelected=undefined;M.role=undefined;},this);this._sortModelItemsByPersistentIndex(D.items);this._reindexModelItemsByTableIndex(D);var a=this.removeAllAggregation("dimMeasureItems");return a;};
e.prototype.destroyDimMeasureItems=function(){var m=this.getModel("$sapmP13nDimMeasurePanel");var D=m.getData();this.getDimMeasureItems().forEach(function(o){var M=this._getModelItemByColumnKey(o.getColumnKey());if(!M){return;}M.persistentIndex=-1;M.persistentSelected=undefined;M.role=undefined;},this);this._sortModelItemsByPersistentIndex(D.items);this._reindexModelItemsByTableIndex(D);this.destroyAggregation("dimMeasureItems");return this;};
e.prototype._includeModelItem=function(i,I){if(I<0){I=this._oTable.getItems().length;}var t=this;var g=function(){if(i.getAggregationRole()==="Dimension"){return[{key:"category",text:t._oRb.getText('COLUMNSPANEL_CHARTROLE_CATEGORY')},{key:"series",text:t._oRb.getText('COLUMNSPANEL_CHARTROLE_SERIES')}];}if(i.getAggregationRole()==="Measure"){return[{key:"axis1",text:t._oRb.getText('COLUMNSPANEL_CHARTROLE_AXIS1')},{key:"axis2",text:t._oRb.getText('COLUMNSPANEL_CHARTROLE_AXIS2')}];}return[];};var m={columnKey:i.getColumnKey(),visible:true,text:i.getText(),tooltip:i.getTooltip(),aggregationRole:i.getAggregationRole(),availableRoleTypes:g(),persistentIndex:-1,persistentSelected:undefined,role:undefined,tableIndex:undefined};var M=this.getModel("$sapmP13nDimMeasurePanel");M.getData().items.splice(I,0,m);};
e.prototype._onItemPressed=function(E){this._switchMarkedTableItemTo(E.getParameter('listItem'));};
e.prototype._onSelectionChange=function(E){var m=this.getModel("$sapmP13nDimMeasurePanel");var D=m.getData();var t=E.getParameter("listItem");this._switchMarkedTableItemTo(t);this._reindexModelItemsByPersistentIndex(D);m.refresh();this._notifyChange();};
e.prototype._onSwitchButtonShowSelected=function(){var D=this.getModel("$sapmP13nDimMeasurePanel").getData();D.showOnlySelectedItems=!D.showOnlySelectedItems;this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._scrollToSelectedItem(D.markedTableItem);this._updateControlLogic();this._fnHandleResize();};
e.prototype._onExecuteSearch=function(){var D=this.getModel("$sapmP13nDimMeasurePanel").getData();this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._scrollToSelectedItem(D.markedTableItem);this._updateControlLogic();};
e.prototype._getDimMeasureItemByColumnKey=function(s){for(var i=0,D=this.getDimMeasureItems(),a=D.length;i<a;i++){if(D[i].getColumnKey()===s){return D[i];}}return null;};
e.prototype._getModelItemIndexByColumnKey=function(s){var i=-1;this.getModel("$sapmP13nDimMeasurePanel").getData().items.some(function(m,I){if(m.columnKey===s){i=I;return true;}});return i;};
e.prototype._getModelItemByColumnKey=function(s){var m=null;this.getModel("$sapmP13nDimMeasurePanel").getData().items.some(function(M){if(M.columnKey===s){m=M;return true;}});return m;};
e.prototype._moveModelItems=function(i,I){var m=this.getModel("$sapmP13nDimMeasurePanel");var D=m.getData();if(i<0||I<0||i>D.items.length-1||I>D.items.length-1){return false;}var M=D.items.splice(i,1);D.items.splice(I,0,M[0]);this._reindexModelItemsByPersistentIndexAndTableIndex(D);m.refresh();return true;};
e.prototype._switchVisibilityOfUnselectedModelItems=function(){var m=this.getModel("$sapmP13nDimMeasurePanel");var s=this._isFilteredByShowSelected();m.getData().items.forEach(function(M){if(M.persistentSelected){M.visible=true;return;}M.visible=!s;});m.refresh();};
e.prototype._getVisibleTableItems=function(){var v=[];this._oTable.getItems().forEach(function(t){if(t.getVisible()){v.push(t);}});return v;};
e.prototype._getVisibleModelItems=function(){var v=[];this.getModel("$sapmP13nDimMeasurePanel").getData().items.forEach(function(m){if(m.visible){v.push(m);}});return v;};
e.prototype._getSelectedModelItems=function(){var s=[];this.getModel("$sapmP13nDimMeasurePanel").getData().items.forEach(function(m){if(m.persistentSelected){s.push(m);}});return s;};
e.prototype._getModelItemByTableItem=function(t){var i=this._getVisibleTableItems().indexOf(t);return this._getVisibleModelItems()[i];};
e.prototype._reindexModelItemsByPersistentIndexAndTableIndex=function(D){var p=-1;D.countOfSelectedItems=0;D.countOfItems=0;D.items.forEach(function(m,t){m.persistentIndex=-1;if(m.persistentSelected){p++;D.countOfSelectedItems++;m.persistentIndex=p;}m.tableIndex=t;D.countOfItems++;});};
e.prototype._reindexModelItemsByPersistentIndex=function(D){var p=-1;D.countOfSelectedItems=0;D.items.forEach(function(m){m.persistentIndex=-1;if(m.persistentSelected){p++;D.countOfSelectedItems++;m.persistentIndex=p;}});};
e.prototype._reindexModelItemsByTableIndex=function(D){D.countOfSelectedItems=0;D.countOfItems=0;D.items.forEach(function(m,t){m.tableIndex=t;D.countOfItems++;if(m.persistentSelected){D.countOfSelectedItems++;}});};
e.prototype._sortModelItemsByPersistentIndex=function(m){m.sort(function(a,b){if(a.persistentSelected===true&&(b.persistentSelected===false||b.persistentSelected===undefined)){return-1;}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&b.persistentSelected===true){return 1;}else if(a.persistentSelected===true&&b.persistentSelected===true){if(a.persistentIndex<b.persistentIndex){return-1;}else if(a.persistentIndex>b.persistentIndex){return 1;}else{return 0;}}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&(b.persistentSelected===false||b.persistentSelected===undefined)){if(a.text<b.text){return-1;}else if(a.text>b.text){return 1;}else{return 0;}}});};
e.prototype._switchMarkedTableItemTo=function(t){var D=this.getModel("$sapmP13nDimMeasurePanel").getData();if(D.markedTableItem===t){return;}if(D.markedTableItem){D.markedTableItem.removeStyleClass("sapMP13nColumnsPanelItemSelected");}D.indexOfMarkedTableItem=this._getVisibleTableItems().indexOf(t);D.markedTableItem=t;if(D.markedTableItem){D.markedTableItem.addStyleClass("sapMP13nColumnsPanelItemSelected");}this._updateControlLogic();};
e.prototype._createTable=function(){var t=this;this._oTable=new T({mode:sap.m.ListMode.MultiSelect,rememberSelections:false,itemPress:q.proxy(this._onItemPressed,this),selectionChange:q.proxy(this._onSelectionChange,this),columns:[new sap.m.Column({header:new sap.m.Text({text:{parts:[{path:'/countOfSelectedItems'},{path:'/countOfItems'}],formatter:function(i,a){return t._oRb.getText('COLUMNSPANEL_SELECT_ALL_WITH_COUNTER',[i,a]);}}})}),new sap.m.Column({header:new sap.m.Text({text:this._oRb.getText('COLUMNSPANEL_COLUMN_TYPE')})}),new sap.m.Column({header:new sap.m.Text({text:this._oRb.getText('COLUMNSPANEL_COLUMN_ROLE')})})],items:{path:"/items",template:new sap.m.ColumnListItem({cells:[new sap.m.Text({text:"{text}"}),new sap.m.Text({text:{path:'',formatter:function(m){if(m.aggregationRole==="Dimension"){return t._oRb.getText('COLUMNSPANEL_TYPE_DIMENSION');}if(m.aggregationRole==="Measure"){return t._oRb.getText('COLUMNSPANEL_TYPE_MEASURE');}}}}),new sap.m.Select({selectedKey:"{role}",items:{path:'availableRoleTypes',factory:function(i,b){var a=b.getObject();return new sap.ui.core.Item({key:a.key,text:a.text});}}})],visible:"{visible}",selected:"{persistentSelected}",tooltip:"{tooltip}",type:sap.m.ListType.Active})}});this._oTable.setModel(this.getModel("$sapmP13nDimMeasurePanel"));};
e.prototype._createToolbar=function(){var m=this.getModel("$sapmP13nDimMeasurePanel");var t=this;var M=new sap.m.OverflowToolbarButton({icon:sap.ui.core.IconPool.getIconURI("slim-arrow-down"),text:this._oRb.getText('COLUMNSPANEL_MOVE_DOWN'),tooltip:this._oRb.getText('COLUMNSPANEL_MOVE_DOWN'),enabled:{path:'/isMoveDownButtonEnabled'},press:function(){t._moveMarkedTableItem("Down");},layoutData:new sap.m.OverflowToolbarLayoutData({moveToOverflow:true,priority:sap.m.OverflowToolbarPriority.High,group:1})});M.setModel(m);var o=new sap.m.OverflowToolbarButton({icon:sap.ui.core.IconPool.getIconURI("slim-arrow-up"),text:this._oRb.getText('COLUMNSPANEL_MOVE_UP'),tooltip:this._oRb.getText('COLUMNSPANEL_MOVE_UP'),enabled:{path:'/isMoveUpButtonEnabled'},press:function(){t._moveMarkedTableItem("Up");},layoutData:new sap.m.OverflowToolbarLayoutData({moveToOverflow:true,priority:sap.m.OverflowToolbarPriority.High,group:1})});o.setModel(m);var a=new sap.m.OverflowToolbarButton({icon:sap.ui.core.IconPool.getIconURI("expand-group"),text:this._oRb.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),tooltip:this._oRb.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),enabled:{path:'/isMoveDownButtonEnabled'},press:function(){t._moveMarkedTableItem("Bottom");},layoutData:new sap.m.OverflowToolbarLayoutData({moveToOverflow:true,priority:sap.m.OverflowToolbarPriority.Low,group:2})});a.setModel(m);var b=new sap.m.OverflowToolbarButton({icon:sap.ui.core.IconPool.getIconURI("collapse-group"),text:this._oRb.getText('COLUMNSPANEL_MOVE_TO_TOP'),tooltip:this._oRb.getText('COLUMNSPANEL_MOVE_TO_TOP'),enabled:{path:'/isMoveUpButtonEnabled'},press:function(){t._moveMarkedTableItem("Top");},layoutData:new sap.m.OverflowToolbarLayoutData({moveToOverflow:true,priority:sap.m.OverflowToolbarPriority.Low,group:2})});b.setModel(m);var s=new sap.m.Button({text:{path:'/showOnlySelectedItems',formatter:function(j){return j?t._oRb.getText('COLUMNSPANEL_SHOW_ALL'):t._oRb.getText('COLUMNSPANEL_SHOW_SELECTED');}},press:q.proxy(this._onSwitchButtonShowSelected,this),layoutData:new sap.m.OverflowToolbarLayoutData({moveToOverflow:true,priority:sap.m.OverflowToolbarPriority.High})});s.setModel(m);var f=new S(this.getId()+"-searchField",{liveChange:function(E){var v=E.getSource().getValue(),D=(v?300:0);window.clearTimeout(t._iSearchTimer);if(D){t._iSearchTimer=window.setTimeout(function(){t._onExecuteSearch();},D);}else{t._onExecuteSearch();}},search:q.proxy(this._onExecuteSearch,this),layoutData:new sap.m.OverflowToolbarLayoutData({minWidth:"12.5rem",maxWidth:"23.077rem",shrinkable:true,moveToOverflow:true,priority:sap.m.OverflowToolbarPriority.High})});var i=new sap.ui.core.InvisibleText({text:t._oRb.getText('COLUMNSPANEL_CHARTTYPE')});var g=new sap.m.ComboBox({selectedKey:{path:'/selectedChartTypeKey'},ariaLabelledBy:i,items:{path:'/availableChartTypes',template:new sap.ui.core.Item({key:"{key}",text:"{text}"})},layoutData:new sap.m.OverflowToolbarLayoutData({moveToOverflow:false,stayInOverflow:false})});g.setModel(m);var h=new sap.m.OverflowToolbar(this.getId()+"-toolbar",{design:sap.m.ToolbarDesign.Solid,content:[i,g,new sap.m.ToolbarSpacer(),f,s,b,o,M,a]});this.addAggregation("content",h);};
e.prototype._getToolbar=function(){return sap.ui.getCore().byId(this.getId()+"-toolbar")||null;};
e.prototype._getSearchField=function(){return sap.ui.getCore().byId(this.getId()+"-searchField")||null;};
e.prototype._getSearchText=function(){var s=this._getSearchField();return s?s.getValue():"";};
e.prototype._isFilteredBySearchText=function(){return!!this._getSearchText().length;};
e.prototype._isFilteredByShowSelected=function(){return this.getModel("$sapmP13nDimMeasurePanel").getData().showOnlySelectedItems;};
e.prototype._isDimMeasureItemEqualToModelItem=function(D,m){return m.persistentIndex===D.getIndex()&&m.persistentSelected===D.getVisible()&&m.role===D.getRole();};
e.prototype._updateControlLogic=function(){var m=this.getModel("$sapmP13nDimMeasurePanel");var D=m.getData();var i=this._isFilteredBySearchText();var s=this._isFilteredByShowSelected();var v=this._getVisibleTableItems();D.isMoveUpButtonEnabled=v.indexOf(D.markedTableItem)>-1&&D.indexOfMarkedTableItem>0;D.isMoveDownButtonEnabled=v.indexOf(D.markedTableItem)>-1&&D.indexOfMarkedTableItem<v.length-1&&D.indexOfMarkedTableItem>-1;var t=sap.ui.getCore().byId(this._oTable.getId()+'-sa');if(t){t.setEnabled(!i&&!s);}m.refresh();};
e.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
e.prototype._showAll=function(){q.sap.log.info("ModelItems: visible tableIndex isPersistent        TableItems: current");q.sap.log.info("--------------------------------------------------------------");var D=this.getModel("$sapmP13nDimMeasurePanel").getData();var t=this._oTable.getItems();var L=Math.max(D.items.length,this._oTable.getItems().length);for(var i=0;i<L;i++){var m=D.items[i];var o=t[i];q.sap.log.info(m.columnKey+": "+m.visible+" "+m.tableIndex+" "+m.persistentSelected+"_"+m.persistentIndex+";    "+o.getId()+" "+o.getCells()[0].getText()+": "+o.getSelected()+" "+o.getCells()[1].getText());}};
e.prototype.onBeforeNavigationFrom=function(){var s=this.getChartTypeKey();var D=[];var m=[];this.getDimMeasureItems().forEach(function(o){var M=this._getModelItemByColumnKey(o.getColumnKey());if(!M){return;}if(M.aggregationRole==="Dimension"){D.push(o);}else if(M.aggregationRole==="Measure"){m.push(o);}},this);D=D.filter(function(i){return i.getVisible();}).map(function(i){return{name:i.getColumnKey()};});m=m.filter(function(i){return i.getVisible();}).map(function(i){return{name:i.getColumnKey()};});sap.ui.getCore().loadLibrary("sap.chart");var r;try{r=sap.chart.api.getChartTypeLayout(s,D,m);}catch(E){return false;}return r.errors.length===0;};
return e;},true);
sap.ui.predefine('sap/m/P13nFilterItem',['jquery.sap.global','./library','sap/ui/core/Item'],function(q,l,I){"use strict";
var P=I.extend("sap.m.P13nFilterItem",{metadata:{library:"sap.m",properties:{operation:{type:"string",group:"Misc",defaultValue:null},value1:{type:"string",group:"Misc",defaultValue:null},value2:{type:"string",group:"Misc",defaultValue:null},columnKey:{type:"string",group:"Misc",defaultValue:null},exclude:{type:"boolean",group:"Misc",defaultValue:false}}}});
P.prototype.setOperation=function(o){return this.setProperty("operation",o,true);};
P.prototype.setColumnKey=function(k){return this.setProperty("columnKey",k,true);};
P.prototype.setValue1=function(k){return this.setProperty("value1",k,true);};
P.prototype.setValue2=function(k){return this.setProperty("value2",k,true);};
P.prototype.setExclude=function(k){return this.setProperty("exclude",k,true);};
return P;},true);
sap.ui.predefine('sap/m/P13nFilterPanel',['jquery.sap.global','./P13nConditionPanel','./P13nPanel','./library','sap/ui/core/Control'],function(q,P,a,l,C){"use strict";
var b=a.extend("sap.m.P13nFilterPanel",{
metadata:{library:"sap.m",properties:{maxIncludes:{type:"string",group:"Misc",defaultValue:'-1'},maxExcludes:{type:"string",group:"Misc",defaultValue:'-1'},containerQuery:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},filterItems:{type:"sap.m.P13nFilterItem",multiple:true,singularName:"filterItem",bindable:"bindable"}},events:{addFilterItem:{},removeFilterItem:{},updateFilterItem:{}}},
renderer:function(r,c){r.write("<section");r.writeControlData(c);r.addClass("sapMFilterPanel");r.writeClasses();r.writeStyles();r.write(">");r.write("<div");r.addClass("sapMFilterPanelContent");r.addClass("sapMFilterPanelBG");r.writeClasses();r.write(">");var d=c.getAggregation("content");var L=d.length;for(var i=0;i<L;i++){r.renderControl(d[i]);}r.write("</div>");r.write("</section>");}
});
b.prototype.setConditions=function(c){var I=[];var e=[];if(c.length){for(var i=0;i<c.length;i++){var o=c[i];if(!o.exclude){I.push(o);}else{e.push(o);}}}this._oIncludeFilterPanel.setConditions(I);this._oExcludeFilterPanel.setConditions(e);if(e.length>0){this._oExcludePanel.setExpanded(true);}return this;};
b.prototype.getConditions=function(){var i=this._oIncludeFilterPanel.getConditions();var e=this._oExcludeFilterPanel.getConditions();return i.concat(e);};
b.prototype.setContainerQuery=function(c){this.setProperty("containerQuery",c);this._oIncludeFilterPanel.setContainerQuery(c);this._oExcludeFilterPanel.setContainerQuery(c);return this;};
b.prototype.setLayoutMode=function(m){this.setProperty("layoutMode",m);this._oIncludeFilterPanel.setLayoutMode(m);this._oExcludeFilterPanel.setLayoutMode(m);return this;};
b.prototype.validateConditions=function(){return this._oIncludeFilterPanel.validateConditions()&&this._oExcludeFilterPanel.validateConditions();};
b.prototype.removeInvalidConditions=function(){this._oIncludeFilterPanel.removeInvalidConditions();this._oExcludeFilterPanel.removeInvalidConditions();};
b.prototype.removeValidationErrors=function(){this._oIncludeFilterPanel.removeValidationErrors();this._oExcludeFilterPanel.removeValidationErrors();};
b.prototype.onBeforeNavigationFrom=function(){return this.validateConditions();};
b.prototype.onAfterNavigationFrom=function(){return this.removeInvalidConditions();};
b.prototype.setIncludeOperations=function(o,t){t=t||"default";this._aIncludeOperations[t]=o;if(this._oIncludeFilterPanel){this._oIncludeFilterPanel.setOperations(this._aIncludeOperations[t],t);}};
b.prototype.getIncludeOperations=function(t){if(this._oIncludeFilterPanel){return this._oIncludeFilterPanel.getOperations(t);}};
b.prototype.setExcludeOperations=function(o,t){t=t||"default";this._aExcludeOperations[t]=o;if(this._oExcludeFilterPanel){this._oExcludeFilterPanel.setOperations(this._aExcludeOperations[t],t);}};
b.prototype.getExcludeOperations=function(t){if(this._oExcludeFilterPanel){return this._oExcludeFilterPanel.getOperations(t);}};
b.prototype.setKeyFields=function(k){this._aKeyFields=k;if(this._oIncludeFilterPanel){this._oIncludeFilterPanel.setKeyFields(this._aKeyFields);}if(this._oExcludeFilterPanel){this._oExcludeFilterPanel.setKeyFields(this._aKeyFields);}};
b.prototype.getKeyFields=function(){return this._aKeyFields;};
b.prototype.setMaxIncludes=function(m){this.setProperty("maxIncludes",m);if(this._oIncludeFilterPanel){this._oIncludeFilterPanel.setMaxConditions(m);}this._updatePanel();return this;};
b.prototype.setMaxExcludes=function(m){this.setProperty("maxExcludes",m);if(this._oExcludeFilterPanel){this._oExcludeFilterPanel.setMaxConditions(m);}this._updatePanel();return this;};
b.prototype._updatePanel=function(){var m=this.getMaxIncludes()==="-1"?1000:parseInt(this.getMaxIncludes(),10);var M=this.getMaxExcludes()==="-1"?1000:parseInt(this.getMaxExcludes(),10);if(m>0){if(M<=0){this._oIncludePanel.setHeaderText(null);this._oIncludePanel.setExpandable(false);this._oIncludePanel.addStyleClass("panelTopMargin");this._oIncludePanel.addStyleClass("panelNoHeader");}}if(M===0){this._oExcludePanel.setHeaderText(null);this._oExcludePanel.setExpandable(false);this._oExcludePanel.addStyleClass("panelNoHeader");}};
b.prototype.init=function(){this.setType(sap.m.P13nPanelType.filter);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("FILTERPANEL_TITLE"));sap.ui.getCore().loadLibrary("sap.ui.layout");q.sap.require("sap.ui.layout.Grid");sap.ui.layout.Grid.prototype.init.apply(this);this._aKeyFields=[];this.addStyleClass("sapMFilterPanel");this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._aIncludeOperations={};if(!this._aIncludeOperations["default"]){this.setIncludeOperations([sap.m.P13nConditionOperation.EQ,sap.m.P13nConditionOperation.BT,sap.m.P13nConditionOperation.LT,sap.m.P13nConditionOperation.LE,sap.m.P13nConditionOperation.GT,sap.m.P13nConditionOperation.GE]);}if(!this._aIncludeOperations["string"]){this.setIncludeOperations([sap.m.P13nConditionOperation.Contains,sap.m.P13nConditionOperation.EQ,sap.m.P13nConditionOperation.BT,sap.m.P13nConditionOperation.StartsWith,sap.m.P13nConditionOperation.EndsWith,sap.m.P13nConditionOperation.LT,sap.m.P13nConditionOperation.LE,sap.m.P13nConditionOperation.GT,sap.m.P13nConditionOperation.GE],"string");}if(!this._aIncludeOperations["date"]){this.setIncludeOperations([sap.m.P13nConditionOperation.EQ,sap.m.P13nConditionOperation.BT,sap.m.P13nConditionOperation.LT,sap.m.P13nConditionOperation.LE,sap.m.P13nConditionOperation.GT,sap.m.P13nConditionOperation.GE],"date");}if(!this._aIncludeOperations["time"]){this.setIncludeOperations([sap.m.P13nConditionOperation.EQ,sap.m.P13nConditionOperation.BT,sap.m.P13nConditionOperation.LT,sap.m.P13nConditionOperation.LE,sap.m.P13nConditionOperation.GT,sap.m.P13nConditionOperation.GE],"time");}if(!this._aIncludeOperations["numeric"]){this.setIncludeOperations([sap.m.P13nConditionOperation.EQ,sap.m.P13nConditionOperation.BT,sap.m.P13nConditionOperation.LT,sap.m.P13nConditionOperation.LE,sap.m.P13nConditionOperation.GT,sap.m.P13nConditionOperation.GE],"numeric");}if(!this._aIncludeOperations["boolean"]){this.setIncludeOperations([sap.m.P13nConditionOperation.EQ],"boolean");}this._aExcludeOperations={};if(!this._aExcludeOperations["default"]){this.setExcludeOperations([sap.m.P13nConditionOperation.EQ]);}this._oIncludePanel=new sap.m.Panel({expanded:true,expandable:true,headerText:this._oRb.getText("FILTERPANEL_INCLUDES"),width:"auto"}).addStyleClass("sapMFilterPadding");this._oIncludeFilterPanel=new P({maxConditions:this.getMaxIncludes(),alwaysShowAddIcon:false,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange()});this._oIncludeFilterPanel._sAddRemoveIconTooltipKey="FILTER";for(var t in this._aIncludeOperations){this._oIncludeFilterPanel.setOperations(this._aIncludeOperations[t],t);}this._oIncludePanel.addContent(this._oIncludeFilterPanel);this.addAggregation("content",this._oIncludePanel);this._oExcludePanel=new sap.m.Panel({expanded:false,expandable:true,headerText:this._oRb.getText("FILTERPANEL_EXCLUDES"),width:"auto"}).addStyleClass("sapMFilterPadding");this._oExcludeFilterPanel=new P({exclude:true,maxConditions:this.getMaxExcludes(),alwaysShowAddIcon:false,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange()});this._oExcludeFilterPanel._sAddRemoveIconTooltipKey="FILTER";for(var t in this._aExcludeOperations){this._oExcludeFilterPanel.setOperations(this._aExcludeOperations[t],t);}this._oExcludePanel.addContent(this._oExcludeFilterPanel);this.addAggregation("content",this._oExcludePanel);this._updatePanel();};
b.prototype.exit=function(){var d=function(o){if(o&&o.destroy){o.destroy();}return null;};this._aKeyFields=d(this._aKeyFields);this._aIncludeOperations=d(this._aIncludeOperations);this._aExcludeOperations=d(this._aExcludeOperations);this._oRb=d(this._oRb);};
b.prototype.onBeforeRendering=function(){if(this._bUpdateRequired){this._bUpdateRequired=false;var k=[];var m=(this.getBindingInfo("items")||{}).model;var g=function(n,o,i){var B=i.getBinding(n);if(B&&o){return o.getObject()[B.getPath()];}return i.getMetadata().getProperty(n)?i.getProperty(n):i.getAggregation(n);};this.getItems().forEach(function(i){var o=i.getBindingContext(m);if(i.getBinding("key")){o.getObject()[i.getBinding("key").getPath()]=i.getKey();}k.push({key:i.getColumnKey(),text:g("text",o,i),tooltip:g("tooltip",o,i),maxLength:g("maxLength",o,i),type:g("type",o,i),precision:g("precision",o,i),scale:g("scale",o,i),isDefault:g("isDefault",o,i),values:g("values",o,i)});var n=k.length;if(k[n-1].maxLength===1||k[n-1].maxLength==="1"){k[n-1].operations=[sap.m.P13nConditionOperation.EQ,sap.m.P13nConditionOperation.BT,sap.m.P13nConditionOperation.LT,sap.m.P13nConditionOperation.LE,sap.m.P13nConditionOperation.GT,sap.m.P13nConditionOperation.GE];}});this.setKeyFields(k);var c=[];m=(this.getBindingInfo("filterItems")||{}).model;this.getFilterItems().forEach(function(f){var o=f.getBindingContext(m);if(f.getBinding("key")&&o){o.getObject()[f.getBinding("key").getPath()]=f.getKey();}c.push({key:f.getKey(),keyField:g("columnKey",o,f),operation:g("operation",o,f),value1:g("value1",o,f),value2:g("value2",o,f),exclude:g("exclude",o,f)});});this.setConditions(c);}};
b.prototype.addItem=function(i){a.prototype.addItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}};
b.prototype.removeItem=function(i){a.prototype.removeItem.apply(this,arguments);this._bUpdateRequired=true;};
b.prototype.destroyItems=function(){this.destroyAggregation("items");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
b.prototype.addFilterItem=function(f){this.addAggregation("filterItems",f,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}};
b.prototype.insertFilterItem=function(f,i){this.insertAggregation("filterItems",f,i,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
b.prototype.updateFilterItems=function(r){this.updateAggregation("filterItems");if(r=="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;}};
b.prototype.removeFilterItem=function(f){f=this.removeAggregation("filterItems",f,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return f;};
b.prototype.removeAllFilterItems=function(){var f=this.removeAllAggregation("filterItems",true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return f;};
b.prototype.destroyFilterItems=function(){this.destroyAggregation("filterItems");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
b.prototype._handleDataChange=function(){var t=this;return function(e){var n=e.getParameter("newData");var o=e.getParameter("operation");var k=e.getParameter("key");var c=e.getParameter("index");var f;var I=-1;var E=e.getSource()===t._oExcludeFilterPanel;t.getFilterItems().some(function(d,i){if((!d.getExclude()&&!E)||(d.getExclude()&&E)){c--;}I=i;return c<0;},this);if(o==="update"){f=t.getFilterItems()[I];if(f){f.setExclude(n.exclude);f.setColumnKey(n.keyField);f.setOperation(n.operation);f.setValue1(n.value1);f.setValue2(n.value2);}t.fireUpdateFilterItem({key:k,index:I,filterItemData:f});t._notifyChange();}if(o==="add"){if(c>=0){I++;}f=new sap.m.P13nFilterItem({key:k,columnKey:n.keyField,exclude:n.exclude,operation:n.operation,value1:n.value1,value2:n.value2});t._bIgnoreBindCalls=true;t.fireAddFilterItem({key:k,index:I,filterItemData:f});t._bIgnoreBindCalls=false;t._notifyChange();}if(o==="remove"){t._bIgnoreBindCalls=true;t.fireRemoveFilterItem({key:k,index:I});t._bIgnoreBindCalls=false;t._notifyChange();}};};
b.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
return b;},true);
sap.ui.predefine('sap/m/P13nGroupItem',['jquery.sap.global','./library','sap/ui/core/Item'],function(q,l,I){"use strict";
var P=I.extend("sap.m.P13nGroupItem",{metadata:{library:"sap.m",properties:{operation:{type:"string",group:"Misc",defaultValue:null},columnKey:{type:"string",group:"Misc",defaultValue:null},showIfGrouped:{type:"boolean",group:"Misc",defaultValue:false}}}});
P.prototype.setColumnKey=function(v){return this.setProperty("columnKey",v,true);};
P.prototype.setOperation=function(v){return this.setProperty("operation",v,true);};
P.prototype.setShowIfGrouped=function(v){return this.setProperty("showIfGrouped",v,true);};
return P;},true);
sap.ui.predefine('sap/m/P13nGroupPanel',['jquery.sap.global','./P13nConditionPanel','./P13nPanel','./library','sap/ui/core/Control'],function(q,P,a,l,C){"use strict";
var c=a.extend("sap.m.P13nGroupPanel",{
metadata:{library:"sap.m",properties:{maxGroups:{type:"string",group:"Misc",defaultValue:'-1'},containerQuery:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},groupItems:{type:"sap.m.P13nGroupItem",multiple:true,singularName:"groupItem",bindable:"bindable"}},events:{addGroupItem:{parameters:{}},removeGroupItem:{},updateGroupItem:{}}},
renderer:function(r,o){r.write("<section");r.writeControlData(o);r.addClass("sapMGroupPanel");r.writeClasses();r.writeStyles();r.write(">");r.write("<div");r.addClass("sapMGroupPanelContent");r.addClass("sapMGroupPanelBG");r.writeClasses();r.write(">");var b=o.getAggregation("content");var L=b.length;for(var i=0;i<L;i++){r.renderControl(b[i]);}r.write("</div>");r.write("</section>");}
});
c.prototype.setMaxGroups=function(m){this.setProperty("maxGroups",m);if(this._oGroupPanel){this._oGroupPanel.setMaxConditions(m);}};
c.prototype._getConditions=function(){return this._oGroupPanel.getConditions();};
c.prototype.setContainerQuery=function(b){this.setProperty("containerQuery",b);this._oGroupPanel.setContainerQuery(b);};
c.prototype.setLayoutMode=function(m){this.setProperty("layoutMode",m);this._oGroupPanel.setLayoutMode(m);};
c.prototype.validateConditions=function(){return this._oGroupPanel.validateConditions();};
c.prototype.removeInvalidConditions=function(){this._oGroupPanel.removeInvalidConditions();};
c.prototype.removeValidationErrors=function(){this._oGroupPanel.removeValidationErrors();};
c.prototype.onBeforeNavigationFrom=function(){return this.validateConditions();};
c.prototype.onAfterNavigationFrom=function(){return this.removeInvalidConditions();};
c.prototype.setOperations=function(o){this._aOperations=o;if(this._oGroupPanel){this._oGroupPanel.setOperations(this._aOperations);}};
c.prototype.init=function(){this.setType(sap.m.P13nPanelType.group);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("GROUPPANEL_TITLE"));sap.ui.getCore().loadLibrary("sap.ui.layout");q.sap.require("sap.ui.layout.Grid");sap.ui.layout.Grid.prototype.init.apply(this);this._aKeyFields=[];this.addStyleClass("sapMGroupPanel");if(!this._aOperations){this.setOperations([sap.m.P13nConditionOperation.GroupAscending,sap.m.P13nConditionOperation.GroupDescending]);}this._oGroupPanel=new P({maxConditions:this.getMaxGroups(),autoReduceKeyFieldItems:true,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange(),validationExecutor:q.proxy(this._callValidationExecutor,this)});this._oGroupPanel.setOperations(this._aOperations);this._oGroupPanel._sAddRemoveIconTooltipKey="GROUP";this.addAggregation("content",this._oGroupPanel);};
c.prototype.exit=function(){var d=function(o){if(o&&o.destroy){o.destroy();}return null;};this._aKeyFields=d(this._aKeyFields);this._aOperations=d(this._aOperations);};
c.prototype.onBeforeRendering=function(){if(this._bUpdateRequired){this._bUpdateRequired=false;var k=[];var m=(this.getBindingInfo("items")||{}).model;var g=function(n,o,i){var B=i.getBinding(n);if(B&&o){return o.getObject()[B.getPath()];}return i.getMetadata().getProperty(n)?i.getProperty(n):i.getAggregation(n);};this.getItems().forEach(function(i){var o=i.getBindingContext(m);if(i.getBinding("key")){o.getObject()[i.getBinding("key").getPath()]=i.getKey();}k.push({key:i.getColumnKey(),text:g("text",o,i),tooltip:g("tooltip",o,i)});});k.splice(0,0,{key:null,text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_SELECTION_NONE")});this._oGroupPanel.setKeyFields(k);var b=[];m=(this.getBindingInfo("groupItems")||{}).model;this.getGroupItems().forEach(function(G){var o=G.getBindingContext(m);if(G.getBinding("key")){o.getObject()[G.getBinding("key").getPath()]=G.getKey();}b.push({key:G.getKey(),keyField:g("columnKey",o,G),operation:g("operation",o,G),showIfGrouped:g("showIfGrouped",o,G)});});this._oGroupPanel.setConditions(b);}};
c.prototype.addItem=function(i){a.prototype.addItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}};
c.prototype.removeItem=function(i){a.prototype.removeItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}};
c.prototype.destroyItems=function(){this.destroyAggregation("items");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
c.prototype.addGroupItem=function(g){this.addAggregation("groupItems",g,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}};
c.prototype.insertGroupItem=function(g,i){this.insertAggregation("groupItems",g,i,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
c.prototype.updateGroupItems=function(r){this.updateAggregation("groupItems");if(r=="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;}};
c.prototype.removeGroupItem=function(g){g=this.removeAggregation("groupItems",g,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return g;};
c.prototype.removeAllGroupItems=function(){var g=this.removeAllAggregation("groupItems",true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return g;};
c.prototype.destroyGroupItems=function(){this.destroyAggregation("groupItems");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
c.prototype._handleDataChange=function(){var t=this;return function(e){var n=e.getParameter("newData");var o=e.getParameter("operation");var k=e.getParameter("key");var i=e.getParameter("index");var g;if(o==="update"){g=t.getGroupItems()[i];if(g){g.setColumnKey(n.keyField);g.setOperation(n.operation);g.setShowIfGrouped(n.showIfGrouped);}t.fireUpdateGroupItem({key:k,index:i,groupItemData:g});t._notifyChange();}if(o==="add"){g=new sap.m.P13nGroupItem({key:k,columnKey:n.keyField,operation:n.operation,showIfGrouped:n.showIfGrouped});t._bIgnoreBindCalls=true;t.fireAddGroupItem({key:k,index:i,groupItemData:g});t._bIgnoreBindCalls=false;t._notifyChange();}if(o==="remove"){t._bIgnoreBindCalls=true;t.fireRemoveGroupItem({key:k,index:i});t._bIgnoreBindCalls=false;t._notifyChange();}};};
c.prototype.getOkPayload=function(){if(!this.getModel()){return null;}var s=[];this._oGroupPanel._oConditionsGrid.getContent().forEach(function(o){var b=o.keyField;s.push(b.getSelectedKey());});return{selectedColumnKeys:s};};
c.prototype._callValidationExecutor=function(){var v=this.getValidationExecutor();if(v){v();}};
c.prototype._updateValidationResult=function(v){this._oGroupPanel._oConditionsGrid.getContent().forEach(function(o){var b=o.keyField;b.setValueStateText("");b.setValueState("None");var s=b.getSelectedKey();v.forEach(function(r){if(r.columnKey===s){b.setValueStateText(r.messageText);b.setValueState(r.messageType);}});});};
c.prototype.setValidationListener=function(L){this.setProperty("validationListener",L);if(L){L(this,q.proxy(this._updateValidationResult,this));}};
c.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
return c;},true);
sap.ui.predefine('sap/m/P13nItem',['jquery.sap.global','./library','sap/ui/core/Element'],function(q,l,E){"use strict";
var P=E.extend("sap.m.P13nItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string",group:"Data",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:""},visible:{type:"boolean",group:"Misc",defaultValue:null},type:{type:"string",group:"Misc",defaultValue:"text"},precision:{type:"string",group:"Misc",defaultValue:null},scale:{type:"string",group:"Misc",defaultValue:null},maxLength:{type:"string",group:"Misc",defaultValue:null},width:{type:"string",group:"Misc",defaultValue:null},isDefault:{type:"boolean",group:"Misc",defaultValue:false},values:{type:"string[]",group:"Misc",defaultValue:null},role:{type:"string",defaultValue:null},aggregationRole:{type:"string",defaultValue:null}}}});
return P;},true);
sap.ui.predefine('sap/m/P13nPanel',['jquery.sap.global','./library','sap/ui/core/Control'],function(q,l,C){"use strict";
var P=C.extend("sap.m.P13nPanel",{
metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},titleLarge:{type:"string",group:"Appearance",defaultValue:null},type:{type:"string",group:"Misc",defaultValue:null},verticalScrolling:{type:"boolean",group:"Misc",defaultValue:true},validationExecutor:{type:"object",group:"Misc",defaultValue:null},validationListener:{type:"object",group:"Misc",defaultValue:null},changeNotifier:{type:"object",group:"Misc",defaultValue:null}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.P13nItem",multiple:true,singularName:"item",bindable:"bindable"}},events:{beforeNavigationTo:{}}},
renderer:function(r,c){r.write("<span");r.writeControlData(c);r.addClass("sapMP13nPanel");r.writeClasses();r.write(">");r.write("</span>");}
});
P.prototype.getOkPayload=function(){return{};};
P.prototype.getResetPayload=function(){return{};};
P.prototype.beforeNavigationTo=function(){this.fireBeforeNavigationTo();};
P.prototype.onBeforeNavigationFrom=function(){return true;};
P.prototype.onAfterNavigationFrom=function(){return;};
return P;},true);
sap.ui.predefine('sap/m/P13nSortItem',['jquery.sap.global','./library','sap/ui/core/Item'],function(q,l,I){"use strict";
var P=I.extend("sap.m.P13nSortItem",{metadata:{library:"sap.m",properties:{operation:{type:"string",group:"Misc",defaultValue:null},columnKey:{type:"string",group:"Misc",defaultValue:null}}}});
P.prototype.setColumnKey=function(v){return this.setProperty("columnKey",v,true);};
P.prototype.setOperation=function(v){return this.setProperty("operation",v,true);};
return P;},true);
sap.ui.predefine('sap/m/P13nSortPanel',['jquery.sap.global','./P13nConditionPanel','./P13nPanel','./library','sap/ui/core/Control'],function(q,P,a,l,C){"use strict";
var c=a.extend("sap.m.P13nSortPanel",{
metadata:{library:"sap.m",properties:{containerQuery:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},sortItems:{type:"sap.m.P13nSortItem",multiple:true,singularName:"sortItem",bindable:"bindable"}},events:{addSortItem:{},removeSortItem:{},updateSortItem:{}}},
renderer:function(r,o){if(!o.getVisible()){return;}r.write("<section");r.writeControlData(o);r.addClass("sapMSortPanel");r.writeClasses();r.writeStyles();r.write(">");r.write("<div");r.addClass("sapMSortPanelContent");r.addClass("sapMSortPanelBG");r.writeClasses();r.write(">");var b=o.getAggregation("content");var L=b.length;for(var i=0;i<L;i++){r.renderControl(b[i]);}r.write("</div>");r.write("</section>");}
});
c.prototype._getConditions=function(){return this._oSortPanel.getConditions();};
c.prototype.setContainerQuery=function(b){this.setProperty("containerQuery",b);this._oSortPanel.setContainerQuery(b);return this;};
c.prototype.setLayoutMode=function(m){this.setProperty("layoutMode",m);this._oSortPanel.setLayoutMode(m);return this;};
c.prototype.validateConditions=function(){return this._oSortPanel.validateConditions();};
c.prototype.removeInvalidConditions=function(){this._oSortPanel.removeInvalidConditions();};
c.prototype.removeValidationErrors=function(){this._oSortPanel.removeValidationErrors();};
c.prototype.onBeforeNavigationFrom=function(){return this.validateConditions();};
c.prototype.onAfterNavigationFrom=function(){return this.removeInvalidConditions();};
c.prototype.setOperations=function(o){this._aOperations=o;if(this._oSortPanel){this._oSortPanel.setOperations(this._aOperations);}return this;};
c.prototype.init=function(){this.setType(sap.m.P13nPanelType.sort);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SORTPANEL_TITLE"));sap.ui.getCore().loadLibrary("sap.ui.layout");q.sap.require("sap.ui.layout.Grid");sap.ui.layout.Grid.prototype.init.apply(this);this._aKeyFields=[];this.addStyleClass("sapMSortPanel");if(!this._aOperations){this.setOperations([sap.m.P13nConditionOperation.Ascending,sap.m.P13nConditionOperation.Descending]);}this._oSortPanel=new P({autoReduceKeyFieldItems:true,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange()});this._oSortPanel.setOperations(this._aOperations);this._oSortPanel._sAddRemoveIconTooltipKey="SORT";this.addAggregation("content",this._oSortPanel);};
c.prototype.exit=function(){var d=function(o){if(o&&o.destroy){o.destroy();}return null;};this._aKeyFields=d(this._aKeyFields);this._aOperations=d(this._aOperations);};
c.prototype.onBeforeRendering=function(){if(this._bUpdateRequired){this._bUpdateRequired=false;var k=[];var m=(this.getBindingInfo("items")||{}).model;var g=function(n,o,i){var B=i.getBinding(n);if(B&&o){return o.getObject()[B.getPath()];}return i.getMetadata().getProperty(n)?i.getProperty(n):i.getAggregation(n);};this.getItems().forEach(function(i){var o=i.getBindingContext(m);if(i.getBinding("key")){o.getObject()[i.getBinding("key").getPath()]=i.getKey();}k.push({key:i.getColumnKey(),text:g("text",o,i),tooltip:g("tooltip",o,i)});});k.splice(0,0,{key:null,text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_SELECTION_NONE")});this._oSortPanel.setKeyFields(k);var b=[];m=(this.getBindingInfo("sortItems")||{}).model;this.getSortItems().forEach(function(s){var o=s.getBindingContext(m);if(s.getBinding("key")){o.getObject()[s.getBinding("key").getPath()]=s.getKey();}b.push({key:s.getKey(),keyField:g("columnKey",o,s),operation:g("operation",o,s)});});this._oSortPanel.setConditions(b);}};
c.prototype.addItem=function(i){a.prototype.addItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}};
c.prototype.removeItem=function(i){a.prototype.removeItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}};
c.prototype.destroyItems=function(){this.destroyAggregation("items");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
c.prototype.addSortItem=function(s){this.addAggregation("sortItems",s,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}};
c.prototype.insertSortItem=function(s,i){this.insertAggregation("sortItems",s,i,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
c.prototype.updateSortItems=function(r){this.updateAggregation("sortItems");if(r=="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;}};
c.prototype.removeSortItem=function(s){s=this.removeAggregation("sortItems",s,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return s;};
c.prototype.removeAllSortItems=function(){var s=this.removeAllAggregation("sortItems",true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return s;};
c.prototype.destroySortItems=function(){this.destroyAggregation("sortItems");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
c.prototype._handleDataChange=function(){var t=this;return function(e){var n=e.getParameter("newData");var o=e.getParameter("operation");var k=e.getParameter("key");var i=e.getParameter("index");var s;if(o==="update"){s=t.getSortItems()[i];if(s){s.setColumnKey(n.keyField);s.setOperation(n.operation);}t.fireUpdateSortItem({key:k,index:i,sortItemData:s});t._notifyChange();}if(o==="add"){s=new sap.m.P13nSortItem({key:k,columnKey:n.keyField,operation:n.operation});t._bIgnoreBindCalls=true;t.fireAddSortItem({key:k,index:i,sortItemData:s});t._bIgnoreBindCalls=false;t._notifyChange();}if(o==="remove"){t._bIgnoreBindCalls=true;t.fireRemoveSortItem({key:k,index:i});t._bIgnoreBindCalls=false;t._notifyChange();}};};
c.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
return c;},true);
sap.ui.predefine('sap/m/QuickView',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool','./QuickViewBase','./ResponsivePopover','./NavContainer','./PlacementType','./Page','./Bar','./Button'],function(q,l,C,I,Q,R,N,P,a,B,b){"use strict";
var c=Q.extend("sap.m.QuickView",{metadata:{library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Misc",defaultValue:P.Right},width:{type:'sap.ui.core.CSSSize',group:'Dimension',defaultValue:'320px'}},aggregations:{},events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}},beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}}}}});
c.prototype.init=function(){var n={pages:[new a()],navigate:this._navigate.bind(this),afterNavigate:this._afterNavigate.bind(this)};this._oNavContainer=new N(n);var t=this;this._oPopover=new R(this.getId()+'-quickView',{placement:this.getPlacement(),content:[this._oNavContainer],contentWidth:this.getWidth(),showHeader:false,showCloseButton:false,afterOpen:function(e){t._afterOpen(e);t.fireAfterOpen({openBy:e.getParameter("openBy")});},afterClose:function(e){t.fireAfterClose({openBy:e.getParameter("openBy"),origin:t.getCloseButton()});},beforeOpen:function(e){t.fireBeforeOpen({openBy:e.getParameter("openBy")});},beforeClose:function(e){t.fireBeforeClose({openBy:e.getParameter("openBy"),origin:t.getCloseButton()});}});this._oPopover.addStyleClass('sapMQuickView');var p=this._oPopover.getAggregation("_popup");p.addEventDelegate({onBeforeRendering:this.onBeforeRenderingPopover,onAfterRendering:this._setLinkWidth,onkeydown:this._onPopupKeyDown},this);var t=this;var s=p._fnAdjustPositionAndArrow;if(s){p._fnAdjustPositionAndArrow=function(){s.apply(p,arguments);t._adjustContainerHeight();};}this._bItemsChanged=true;this._oPopover.addStyleClass("sapMQuickView");};
c.prototype.onBeforeRenderingPopover=function(){this._bRendered=true;if(this._bItemsChanged){this._clearContainerHeight();this._initPages();var p=this.getAggregation("pages");if(!p&&sap.ui.Device.system.phone){this._addEmptyPage();}this._bItemsChanged=false;}};
c.prototype.exit=function(){this._bRendered=false;this._bItemsChanged=true;if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}};
c.prototype._createPage=function(o){return o._createPage();};
c.prototype._onPopupKeyDown=function(e){this._processKeyboard(e);};
c.prototype._afterOpen=function(e){if(sap.ui.Device.system.phone){this._restoreFocus();}};
c.prototype._addEmptyPage=function(){var p=new a({customHeader:new B().addStyleClass("sapMQuickViewHeader")});var t=this;var o=p.getCustomHeader();o.addContentRight(new b({icon:I.getIconURI("decline"),press:function(){t._oPopover.close();}}));p.addStyleClass('sapMQuickViewPage');this._oNavContainer.addPage(p);};
c.prototype._clearContainerHeight=function(){var p=this._oPopover.getAggregation("_popup");var $=p.$().find('.sapMPopoverCont');if($[0]&&$[0].style.height){$[0].style.height='';}};
c.prototype._adjustContainerHeight=function(){var p=this._oPopover.getAggregation("_popup");var $=p.$().find('.sapMPopoverCont');if($[0]&&!$[0].style.height){$[0].style.height=$.height()+'px';}};
c.prototype._setLinkWidth=function(){this._oPopover.$().find(".sapMLnk").css("width","auto");};
c.prototype.getCloseButton=function(){if(!sap.ui.Device.system.phone){return undefined;}var p=this._oNavContainer.getCurrentPage();var o=p.getCustomHeader().getContentRight()[0];return o;};
c.prototype.setPlacement=function(p){this.setProperty("placement",p,true);this._oPopover.setPlacement(p);return this;};
c.prototype.setWidth=function(w){if(this._oPopover){this._oPopover.setContentWidth(w);this.setProperty('width',w,true);}return this;};
c.prototype.openBy=function(o){this._bItemsChanged=true;this._oPopover.openBy(o);return this;};
c.prototype.getDomRef=function(s){return this._oPopover&&this._oPopover.getAggregation("_popup").getDomRef(s);};
["addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass","getBusyIndicatorDelay","setBusyIndicatorDelay","getVisible","setVisible","getFieldGroupIds","setFieldGroupIds","getBusy","setBusy","setTooltip","getTooltip"].forEach(function(n){c.prototype[n]=function(){if(this._oPopover&&this._oPopover[n]){var r=this._oPopover.getAggregation("_popup")[n].apply(this._oPopover.getAggregation("_popup"),arguments);return r===this._oPopover.getAggregation("_popup")?this:r;}};});["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(f){c.prototype["_"+f+"Old"]=c.prototype[f];c.prototype[f]=function(){var r=c.prototype["_"+f+"Old"].apply(this,arguments);this._bItemsChanged=true;if(this._oPopover){if(arguments[0]!="pages"){this._oPopover[f].apply(this._oPopover,arguments);}if(this._bRendered){this._oPopover.invalidate();}}if(["removeAggregation","removeAllAggregation"].indexOf(f)!==-1){return r;}return this;};});return c;},true);
sap.ui.predefine('sap/m/QuickViewBase',['jquery.sap.global','./library','sap/ui/core/Control','jquery.sap.dom'],function(q,l,C){"use strict";
var Q=C.extend("sap.m.QuickViewBase",{metadata:{library:"sap.m",properties:{},defaultAggregation:"pages",aggregations:{pages:{type:"sap.m.QuickViewPage",multiple:true,singularName:"page",bindable:"bindable"}},events:{navigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"},isTopPage:{type:"boolean"}}}}}});
Q.prototype.navigateBack=function(){if(!this._oNavContainer.currentPageIsTopPage()){this._oNavContainer.back();}};
Q.prototype.getNavContainer=function(){return this._oNavContainer;};
Q.prototype._initPages=function(){var n=this._oNavContainer;n.destroyPages();n.init();var p=this.getAggregation("pages");if(!p){return;}var I=this.getId();for(var i=0;i<p.length;i++){var o=p[i];o._oPage=null;var N={hasBackButton:i>0,popover:this._oPopover,navContainer:n,quickViewId:I,quickView:this};o.setNavContext(N);var P=this._createPage(o);this._oNavContainer.addPage(P);}};
Q.prototype._processKeyboard=function(e){if(e.shiftKey&&e.which===q.sap.KeyCodes.ENTER){this.navigateBack();e.preventDefault();}};
Q.prototype._createPage=function(o){return o;};
Q.prototype._navigate=function(e){var t=e.getParameter('to');var f=e.getParameter('from');var T=e.getParameter('toId');var F=e.getParameter('fromId');var i=q.sap.byId(F).index();var a=q.sap.byId(T).index();if(a==-1||a>i){t.addStyleClass('sapMNavItemOffset');}else{f.addStyleClass('sapMNavItemOffset');}f.$().parents('.sapMPanelContent').scrollTop(0);this.fireNavigate(e.getParameters());};
Q.prototype._afterNavigate=function(e){var t=e.getParameter('to');var f=e.getParameter('from');var T=e.getParameter('toId');var F=e.getParameter('fromId');var i=q.sap.byId(F).index();var a=q.sap.byId(T).index();if(a>i){t.removeStyleClass('sapMNavItemOffset');}else{f.removeStyleClass('sapMNavItemOffset');}var p=e.getParameters();p.isTopPage=this._oNavContainer.currentPageIsTopPage();this.fireAfterNavigate(p);this._setLinkWidth();q.sap.delayedCall(0,this,this._restoreFocus);};
Q.prototype._restoreFocus=function(){var p=this._oNavContainer.getCurrentPage();var f=this._oNavContainer._mFocusObject[p.getId()];if(!f){var c=p.getContent();if(c&&c.length>1){f=c[1].$().firstFocusableDomRef();}}if(f){q.sap.focus(f);}};
Q.prototype._setLinkWidth=function(){};
return Q;},true);
sap.ui.predefine('sap/m/QuickViewCard',['jquery.sap.global','./library','sap/ui/core/Control','./QuickViewBase','./NavContainer','./Page','./ScrollContainer'],function(q,l,C,Q,N,P,S){"use strict";
var a=Q.extend("sap.m.QuickViewCard",{metadata:{library:"sap.m",properties:{showVerticalScrollBar:{type:"boolean",group:"Behavior",defaultValue:true}}}});
a.prototype.init=function(){var n={pages:[new P()],navigate:this._navigate.bind(this),afterNavigate:this._afterNavigate.bind(this)};this._oNavContainer=new N(n);};
a.prototype.onBeforeRendering=function(){this._initPages();};
a.prototype.onAfterRendering=function(){this._setLinkWidth();};
a.prototype.exit=function(){if(this._oNavContainer){this._oNavContainer.destroy();}};
a.prototype.onkeydown=function(e){this._processKeyboard(e);};
a.prototype._createPage=function(o){var c=o._createPageContent();o._mPageContent=null;var b=new S(this.getId()+'-'+o.getPageId(),{horizontal:false,vertical:false});if(c.header){b.addContent(c.header);}b.addContent(c.form);b.addStyleClass('sapMQuickViewPage');return b;};
a.prototype._setLinkWidth=function(){this.$().find(".sapMLnk").css("width","auto");};
return a;},true);
sap.ui.predefine('sap/m/QuickViewGroupElement',['jquery.sap.global','./library','sap/ui/core/Element','./QuickViewGroupElementType','./Link','./Text','sap/ui/core/CustomData'],function(q,l,E,G,L,T,C){"use strict";
var a=E.extend("sap.m.QuickViewGroupElement",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true},label:{type:"string",group:"Misc",defaultValue:""},value:{type:"string",group:"Misc",defaultValue:""},url:{type:"string",group:"Misc",defaultValue:""},target:{type:"string",group:"Misc",defaultValue:"_blank"},type:{type:"sap.m.QuickViewGroupElementType",group:"Misc",defaultValue:G.text},pageLinkId:{type:"string",group:"Misc",defaultValue:""},emailSubject:{type:"string",group:"Misc",defaultValue:""}}}});
a.prototype._getGroupElementValue=function(Q){if(!this.getValue()){return null;}switch(this.getType()){case G.email:var h="mailto:"+this.getValue();var s=this.getEmailSubject();if(s){h+='?subject='+s;}return new L({href:h,text:this.getValue()});case G.phone:case G.mobile:return new L({href:"tel:"+this.getValue(),text:this.getValue()});case G.link:return new L({href:this.getUrl(),text:this.getValue(),target:this.getTarget()});case G.pageLink:var b=this.getPageLinkId();if(Q){b=Q+'-'+b;}return new L({href:"#",text:this.getValue(),customData:[new C({key:"pageNumber",value:b})]});default:return new T({text:this.getValue()});}};
a.prototype.setProperty=function(){E.prototype.setProperty.apply(this,arguments);var g=this.getParent();if(!g){return;}var p=g.getParent();if(p){p._updatePage();}};
return a;},true);
sap.ui.predefine('sap/m/QuickViewPage',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/layout/form/SimpleForm','sap/ui/layout/VerticalLayout','sap/ui/layout/HorizontalLayout','./Page','./Button','./ButtonType','./Bar','./Title','./Image','./Link','./Text','./QuickViewGroupElementType','./Label','./HBox','sap/ui/core/Icon','sap/ui/core/Title','sap/ui/core/TitleLevel','sap/ui/core/CustomData','sap/ui/layout/form/SimpleFormLayout'],function(q,l,C,I,S,V,H,P,B,a,b,T,c,L,d,Q,f,g,h,i,m,n,o){"use strict";
var p=C.extend("sap.m.QuickViewPage",{metadata:{library:"sap.m",properties:{pageId:{type:"string",group:"Misc",defaultValue:""},header:{type:"string",group:"Misc",defaultValue:""},title:{type:"string",group:"Misc",defaultValue:""},titleUrl:{type:"string",group:"Misc",defaultValue:""},crossAppNavCallback:{type:"object",group:"Misc"},description:{type:"string",group:"Misc",defaultValue:""},icon:{type:"string",group:"Misc",defaultValue:""}},defaultAggregation:"groups",aggregations:{groups:{type:"sap.m.QuickViewGroup",multiple:true,singularName:"group",bindable:"bindable"}}}});
p.prototype.init=function(){this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle('sap.m');var G=sap.ushell&&sap.ushell.Container&&sap.ushell.Container.getService;if(G){this.oCrossAppNavigator=G("CrossApplicationNavigation");}};
p.prototype.setNavContext=function(e){this._mNavContext=e;};
p.prototype.getNavContext=function(){return this._mNavContext;};
p.prototype.setPageTitleControl=function(t){this._oPageTitle=t;};
p.prototype.getPageTitleControl=function(){return this._oPageTitle;};
p.prototype._createPage=function(){var e=this._createPageContent();var N=this.getNavContext();var j;if(this._oPage){j=this._oPage;j.destroyContent();j.setCustomHeader(new b());}else{j=this._oPage=new P(N.quickViewId+'-'+this.getPageId(),{customHeader:new b()});j.addEventDelegate({onAfterRendering:this.onAfterRenderingPage},this);}if(e.header){j.addContent(e.header);}j.addContent(e.form);var k=j.getCustomHeader();k.addContentMiddle(new T({text:this.getHeader()}).addStyleClass("sapMQuickViewTitle"));if(N.hasBackButton){k.addContentLeft(new B({type:a.Back,tooltip:this._oResourceBundle.getText("PAGE_NAVBUTTON_TEXT"),press:function(){if(N.navContainer){N.navContainer.back();}}}));}if(N.popover&&sap.ui.Device.system.phone){k.addContentRight(new B({icon:I.getIconURI("decline"),press:function(){N.popover.close();}}));}j.addStyleClass('sapMQuickViewPage');return j;};
p.prototype.onAfterRenderingPage=function(){if(this._bItemsChanged){var N=this.getNavContext();if(N){N.quickView._restoreFocus();}this._bItemsChanged=false;}};
p.prototype._createPageContent=function(){var F=this._createForm();var e=this._getPageHeaderContent();var j=this.getPageTitleControl();if(e&&j){F.addAriaLabelledBy(j);}this._mPageContent={form:F,header:e};return this._mPageContent;};
p.prototype._createForm=function(){var G=this.getAggregation("groups"),F=new S({maxContainerCols:1,editable:false,layout:o.ResponsiveGridLayout});if(G){for(var j=0;j<G.length;j++){if(G[j].getVisible()){this._renderGroup(G[j],F);}}}return F;};
p.prototype._getPageHeaderContent=function(){var e,v=new V(),j=new H();var s=this.getIcon();var t=this.getTitle();var D=this.getDescription();if(!s&&!t&&!D){return null;}if(s){if(this.getIcon().indexOf("sap-icon")==0){e=new h({src:s,useIconTooltip:false,tooltip:t});}else{e=new c({src:s,decorative:false,tooltip:t}).addStyleClass("sapUiIcon");}e.addStyleClass("sapMQuickViewThumbnail");if(this.getTitleUrl()){e.attachPress(this._crossApplicationNavigation(this));}j.addContent(e);}var k;if(this.getTitleUrl()){k=new L({text:t,href:this.getTitleUrl(),target:"_blank"});}else if(this.getCrossAppNavCallback()){k=new L({text:t});k.attachPress(this._crossApplicationNavigation(this));}else{k=new T({text:t,level:m.H1});}this.setPageTitleControl(k);var r=new d({text:D});v.addContent(k);v.addContent(r);j.addContent(v);return j;};
p.prototype._renderGroup=function(G,F){var e=G.getAggregation("elements");var j,r,s;if(G.getHeading()){F.addContent(new i({text:G.getHeading(),level:m.H2}));}if(!e){return;}var N=this.getNavContext();for(var k=0;k<e.length;k++){j=e[k];if(!j.getVisible()){continue;}s=new f({text:j.getLabel()});var t;if(N){t=N.quickViewId;}r=j._getGroupElementValue(t);F.addContent(s);if(!r){F.addContent(new sap.m.Text({text:""}));continue;}if(r instanceof L){r.addAriaLabelledBy(r);}s.setLabelFor(r.getId());if(j.getType()==Q.pageLink){r.attachPress(this._attachPressLink(this));}if(j.getType()==Q.mobile&&!sap.ui.Device.system.desktop){var u=new h({src:I.getIconURI("post"),tooltip:this._oResourceBundle.getText("QUICKVIEW_SEND_SMS"),decorative:false,customData:[new n({key:"phoneNumber",value:j.getValue()})],press:this._mobilePress});var v=new g({items:[r,u]});F.addContent(v);}else{F.addContent(r);}}};
p.prototype._crossApplicationNavigation=function(t){return function(){if(t.getCrossAppNavCallback()&&t.oCrossAppNavigator){var e=t.getCrossAppNavCallback();if(typeof e=="function"){var j=e();var k=t.oCrossAppNavigator.hrefForExternal({target:{semanticObject:j.target.semanticObject,action:j.target.action},params:j.params});sap.m.URLHelper.redirect(k);}}else if(t.getTitleUrl()){window.open(t.getTitleUrl(),"_blank");}};};
p.prototype._destroyPageContent=function(){if(!this._mPageContent){return;}if(this._mPageContent.form){this._mPageContent.form.destroy();}if(this._mPageContent.header){this._mPageContent.header.destroy();}this._mPageContent=null;};
p.prototype.exit=function(){this._oResourceBundle=null;if(this._oPage){this._oPage.destroy();this._oPage=null;}else{this._destroyPageContent();}this._mNavContext=null;};
p.prototype._attachPressLink=function(t){var N=t.getNavContext();return function(e){e.preventDefault();var s=this.getCustomData()[0].getValue();if(N.navContainer&&s){N.navContainer.to(s);}};};
p.prototype._mobilePress=function(){var s="sms://"+q.sap.encodeURL(this.getCustomData()[0].getValue());window.location.replace(s);};
p.prototype._updatePage=function(){var N=this.getNavContext();if(N&&N.quickView._bRendered){this._bItemsChanged=true;N.popover.focus();N.quickView._clearContainerHeight();this._createPage();N.popover.$().css('display','block');N.quickView._restoreFocus();}};
["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(F){p.prototype["_"+F+"Old"]=p.prototype[F];p.prototype[F]=function(){var r=p.prototype["_"+F+"Old"].apply(this,arguments);this._updatePage();if(["removeAggregation","removeAllAggregation"].indexOf(F)!==-1){return r;}return this;};});
p.prototype.setProperty=function(){C.prototype.setProperty.apply(this,arguments);this._updatePage();};
return p;},true);
/*!
 * @copyright@
 */
sap.ui.predefine('sap/m/NumericContentRenderer',[],function(){"use strict";var N={};
N.render=function(r,c){var v=c.getValue();var i=c.getIndicator();var s=c.getScale();var S=c.getState();var I=sap.m.DeviationIndicator.None!==i&&v!=="";var w=c.getWithMargin();var W;if(w){W="";}else{W="WithoutMargin";}if(c.getFormatterValue()){var f=c._parseFormattedValue(v);s=f.scale;v=f.value;}var b=s&&v;r.write("<div");r.writeControlData(c);var t=c.getTooltip_AsString();if(typeof t!=="string"){t="";}r.writeAttributeEscaped("aria-label",t);r.writeAttribute("role","image");if(S==sap.m.LoadState.Failed||S==sap.m.LoadState.Loading){r.writeAttribute("aria-disabled","true");}if(c.getAnimateTextChange()){r.addStyle("opacity","0.25");}if(c.getWidth()){r.addStyle("width",c.getWidth());}r.writeStyles();r.addClass("sapMNC");r.addClass(W);if(c.hasListeners("press")){r.writeAttribute("tabindex","0");r.addClass("sapMPointer");}r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMNCInner");r.addClass(W);r.writeClasses();r.write(">");if(w){this._renderScaleAndIndicator(r,c,I,b,W,i,s);this._renderValue(r,c,W,v);}else{this._renderValue(r,c,W,v);this._renderScaleAndIndicator(r,c,I,b,W,i,s);}r.write("</div>");r.write("</div>");};
N._prepareAndRenderIcon=function(r,c,i){if(i){var s,l=sap.m.LoadState,C=c.getState();for(s in l){if(l.hasOwnProperty(s)&&s!==C){i.removeStyleClass(s);}else if(l.hasOwnProperty(s)&&s===C){i.addStyleClass(s);}}i.addStyleClass("sapMNCIconImage");r.renderControl(i);}};
N._renderScaleAndIndicator=function(r,c,i,a,w,t,b){if(i||a){var s=c.getState();var C=c.getValueColor();r.write("<div");r.addClass("sapMNCIndScale");r.addClass(w);r.addClass(s);r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",c.getId()+"-indicator");r.addClass("sapMNCIndicator");r.addClass(t);r.addClass(s);r.addClass(C);r.writeClasses();r.write("/>");if(a){r.write("<div");r.writeAttribute("id",c.getId()+"-scale");r.addClass("sapMNCScale");r.addClass(s);r.addClass(C);r.writeClasses();r.write(">");r.writeEscaped(b.substring(0,3));r.write("</div>");}r.write("</div>");}};
N._renderValue=function(r,c,w,v){var e;if(c.getNullifyValue()){e="0";}else{e="";}r.write("<div");r.writeAttribute("id",c.getId()+"-value");r.addClass("sapMNCValue");r.addClass(w);r.addClass(c.getValueColor());r.addClass(c.getState());r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",c.getId()+"-value-scr");r.addClass("sapMNCValueScr");r.addClass(w);r.writeClasses();r.write(">");this._prepareAndRenderIcon(r,c,c._oIcon);var C=c.getTruncateValueTo();if(v.length>=C&&(v[C-1]==="."||v[C-1]===",")){r.writeEscaped(v.substring(0,C-1));}else{if(v){r.writeEscaped(v.substring(0,C));}else{r.writeEscaped(e);}}r.write("</div>");r.write("</div>");};
return N;},true);
/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/m/AccButton',['jquery.sap.global','./Button'],function(q,B){"use strict";
var A=B.extend("sap.m.AccButton",{metadata:{library:"sap.m",properties:{"tabIndex":{type:"string",defaultValue:null,bindable:"bindable"},"ariaHidden":{type:"string",defaultValue:null,bindable:"bindable"}}}});
return A;},false);
sap.ui.predefine('sap/m/AccButtonRenderer',['jquery.sap.global','./ButtonRenderer','sap/ui/core/Renderer'],function(q,B,R){"use strict";var A=R.extend(B);
A.renderAccessibilityAttributes=function(r,c){if(c.getTabIndex()){r.writeAttribute("tabindex",c.getTabIndex());}if(c.getAriaHidden()){r.writeAttribute("aria-hidden",c.getAriaHidden());}};
return A;},true);
sap.ui.predefine('sap/m/ActionListItem',['jquery.sap.global','./ListItemBase','./library','sap/ui/core/EnabledPropagator'],function(q,L,l,E){"use strict";
var A=L.extend("sap.m.ActionListItem",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
A.prototype.init=function(){this.setType(sap.m.ListType.Active);L.prototype.init.apply(this,arguments);};
A.prototype.getMode=function(){return sap.m.ListMode.None;};
A.prototype.onsapspace=A.prototype.onsapenter;return A;},true);
sap.ui.predefine('sap/m/ActionListItemRenderer',['jquery.sap.global','./ListItemBaseRenderer','sap/ui/core/Renderer'],function(q,L,R){"use strict";var A=R.extend(L);
A.renderLIAttributes=function(r,l){r.addClass("sapMALI");};
A.renderLIContent=function(r,l){var i=l.getText();if(i){r.write("<div class='sapMALIText'>");r.writeEscaped(i);r.write("</div>");}};
A.getAriaDescribedBy=function(l){var d=this.getAriaAnnouncement("active"),b=L.getAriaDescribedBy.call(this,l)||"";return d+" "+b;};
return A;},true);
sap.ui.predefine('sap/m/ActionSelect',['jquery.sap.global','./Select','./library'],function(q,S,l){"use strict";
var A=S.extend("sap.m.ActionSelect",{metadata:{library:"sap.m",associations:{buttons:{type:"sap.m.Button",multiple:true,singularName:"button"}}}});
A.prototype.init=function(){S.prototype.init.call(this);this.getList().addEventDelegate({onfocusin:this.onfocusinList},this);};
A.prototype.hasContent=function(){return S.prototype.hasContent.call(this)||!!this.getButtons().length;};
A.prototype.addContent=function(){var c=sap.ui.getCore(),p=this.getPicker();this.getButtons().forEach(function(b){p.addContent(c.byId(b));});};
A.prototype.onAfterRenderingPicker=function(){S.prototype.onAfterRenderingPicker.call(this);var p=this.getPicker(),r=this.getRenderer();p.addStyleClass(r.CSS_CLASS+"Picker");p.addStyleClass(r.ACTION_SELECT_CSS_CLASS+"Picker");p.addStyleClass(r.ACTION_SELECT_CSS_CLASS+"Picker-CTX");};
A.prototype.createPickerCloseButton=function(){};
A.prototype.removeButton=function(b){var p=this.getPicker();if(p){if(typeof b==="number"){b=this.getButtons()[b];}p.removeContent(b);}return this.removeAssociation("buttons",b);};
A.prototype.removeAllButtons=function(){var p=this.getPicker();if(p){this.getButtons().forEach(function(b){p.removeContent(b);});}return this.removeAllAssociation("buttons");};
A.prototype.onsaptabprevious=function(e){var b=this.getButtons(),p=this.getPicker(),i;if(e.isMarked()||!this.getEnabled()){return;}e.setMarked();if(p&&p.isOpen()&&b.length>0){for(i=b.length-1;i>=0;i--){if(sap.ui.getCore().byId(b[i]).getEnabled()){sap.ui.getCore().byId(b[i]).focus();e.preventDefault();break;}}}};
A.prototype.onsaptabnext=function(e){var b=this.getButtons(),p=this.getPicker(),i;if(e.isMarked()||!this.getEnabled()){return;}e.setMarked();if(p&&p.isOpen()&&b.length>0){for(i=0;i<b.length;i++){if(sap.ui.getCore().byId(b[i]).getEnabled()){sap.ui.getCore().byId(b[i]).focus();e.preventDefault();break;}}}};
A.prototype.onsapfocusleave=function(e){var b=this.getButtons();var k=(b.indexOf(e.relatedControlId)==-1);if(k){S.prototype.onsapfocusleave.apply(this,arguments);}};
A.prototype.onfocusinList=function(e){if(document.activeElement!==this.getList().getDomRef()){this.focus();}};
return A;},true);
sap.ui.predefine('sap/m/ActionSelectRenderer',['jquery.sap.global','sap/ui/core/Renderer','./SelectRenderer'],function(q,R,S){"use strict";var A=R.extend(S);A.ACTION_SELECT_CSS_CLASS="sapMActionSelect";
A.addClass=function(r,a){r.addClass(A.ACTION_SELECT_CSS_CLASS);};
return A;},true);
sap.ui.predefine('sap/m/ActionSheet',['jquery.sap.global','./Dialog','./Popover','./library','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation','sap/ui/core/InvisibleText'],function(q,D,P,l,C,I,a){"use strict";
var A=C.extend("sap.m.ActionSheet",{metadata:{library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Appearance",defaultValue:sap.m.PlacementType.Bottom},showCancelButton:{type:"boolean",group:"Appearance",defaultValue:true},cancelButtonText:{type:"string",group:"Appearance",defaultValue:null},title:{type:"string",group:"Appearance",defaultValue:null}},aggregations:{buttons:{type:"sap.m.Button",multiple:true,singularName:"button"},_cancelButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_invisibleAriaTexts:{type:"sap.ui.core.InvisibleText",multiple:true,visibility:"hidden"}},events:{cancelButtonTap:{deprecated:true},beforeOpen:{},afterOpen:{},beforeClose:{origin:{type:"sap.m.Button"}},afterClose:{origin:{type:"sap.m.Button"}},cancelButtonPress:{}}}});
A.prototype.init=function(){this._fnOrientationChange=this._orientationChange.bind(this);};
A.prototype.exit=function(){sap.ui.Device.resize.detachHandler(this._fnOrientationChange);if(this._parent){this._parent.destroy();this._parent=null;}if(this._oCancelButton){this._oCancelButton.destroy();this._oCancelButton=null;}this._clearItemNavigation();};
A.prototype._clearItemNavigation=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
A.prototype._setItemNavigation=function(){var b=this._getAllButtons(),d=[],o=this.getDomRef();if(o){this._oItemNavigation.setRootDomRef(o);for(var i=0;i<b.length;i++){if(b[i].getEnabled()&&b[i].getVisible()){d.push(b[i].getFocusDomRef());}}if(this._oCancelButton){d.push(this._oCancelButton.getFocusDomRef());}this._oItemNavigation.setItemDomRefs(d);this._oItemNavigation.setSelectedIndex(0);this._oItemNavigation.setPageSize(5);}};
A.prototype.onBeforeRendering=function(){this._clearItemNavigation();};
A.prototype.onAfterRendering=function(){this._oItemNavigation=new I();this._oItemNavigation.setCycling(false);this.addDelegate(this._oItemNavigation);this._setItemNavigation();};
A.prototype.sapfocusleave=function(){this.close();};
A.prototype.openBy=function(c){var t=this;if(!this._parent){var o=this.getParent();if(o){this.setParent(null);}if(!sap.ui.Device.system.phone){this._parent=new P({placement:this.getPlacement(),showHeader:false,content:[this],beforeOpen:function(){t.fireBeforeOpen();},afterOpen:function(){t.focus();t.fireAfterOpen();},beforeClose:function(){t.fireBeforeClose();},afterClose:function(){if(t.getShowCancelButton()){t.fireCancelButtonTap();t.fireCancelButtonPress();}t.fireAfterClose();}}).addStyleClass("sapMActionSheetPopover");if(sap.ui.Device.browser.internet_explorer){this._parent._fnAdjustPositionAndArrow=q.proxy(function(){P.prototype._adjustPositionAndArrow.apply(this);var $=this.$(),f=$.children(".sapMPopoverCont")[0].getBoundingClientRect().width;q.each($.find(".sapMActionSheet > .sapMBtn"),function(i,b){var d=q(b),B;d.css("width","");B=b.getBoundingClientRect().width;if(B<=f){d.css("width","100%");}});},this._parent);}}else{this._parent=new D({title:this.getTitle(),type:sap.m.DialogType.Standard,content:[this],beforeOpen:function(){t.fireBeforeOpen();},afterOpen:function(){t.focus();t.fireAfterOpen();},beforeClose:function(e){t.fireBeforeClose({origin:e.getParameter("origin")});},afterClose:function(e){t.fireAfterClose({origin:e.getParameter("origin")});sap.ui.Device.resize.detachHandler(t._fnOrientationChange);}}).addStyleClass("sapMActionSheetDialog");if(this.getTitle()){this._parent.addStyleClass("sapMActionSheetDialogWithTitle");}if(!sap.ui.Device.system.phone){this._parent.setBeginButton(this._getCancelButton());}if(sap.ui.Device.system.phone){this._parent.oPopup.setModal(true);this._parent._setDimensions=function(){sap.m.Dialog.prototype._setDimensions.apply(this);this.$("cont").css("max-height","");};this._parent._adjustScrollingPane=function(){var h=this.$().height();this.$("cont").css("max-height",h);if(this._oScroller){this._oScroller.refresh();}};}}if(o){o.addDependent(this._parent);}}if(!sap.ui.Device.system.phone){this._parent.openBy(c);}else{this._parent.open();sap.ui.Device.resize.attachHandler(this._fnOrientationChange);}};
A.prototype.close=function(c){if(this._parent){this._parent.close();}};
A.prototype.isOpen=function(c){return!!this._parent&&this._parent.isOpen();};
A.prototype._createCancelButton=function(){if(!this._oCancelButton){var c=(this.getCancelButtonText())?this.getCancelButtonText():sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACTIONSHEET_CANCELBUTTON_TEXT"),t=this;this._oCancelButton=new sap.m.Button(this.getId()+'-cancelBtn',{text:c,type:sap.m.ButtonType.Reject,press:function(){if(sap.ui.Device.system.phone&&t._parent){t._parent._oCloseTrigger=this;}t.close();t.fireCancelButtonTap();t.fireCancelButtonPress();}}).addStyleClass("sapMActionSheetButton sapMActionSheetCancelButton sapMBtnTransparent sapMBtnInverted");if(sap.ui.Device.system.phone){this.setAggregation("_cancelButton",this._oCancelButton,true);}}return this;};
A.prototype._getCancelButton=function(){if(sap.ui.Device.system.phone&&this.getShowCancelButton()){this._createCancelButton();return this._oCancelButton;}return null;};
A.prototype.setCancelButtonText=function(t){this.setProperty("cancelButtonText",t,true);if(this._oCancelButton){this._oCancelButton.setText(t);}return this;};
A.prototype._preProcessActionButton=function(b){var t=b.getType();if(t!==sap.m.ButtonType.Accept&&t!==sap.m.ButtonType.Reject){b.setType(sap.m.ButtonType.Transparent);}b.addStyleClass("sapMBtnInverted");this._parent&&this._parent.invalidate();return this;};
A.prototype.setShowCancelButton=function(v){if(this._parent){if(sap.ui.Device.system.phone){this.setProperty("showCancelButton",v,false);}}else{this.setProperty("showCancelButton",v,true);}return this;};
A.prototype.setTitle=function(t){this.setProperty("title",t,true);if(this._parent&&sap.ui.Device.system.phone){this._parent.setTitle(t);this._parent.toggleStyleClass("sapMDialog-NoHeader",!t);}if(this._parent){if(t){this._parent.addStyleClass("sapMActionSheetDialogWithTitle");}else{this._parent.removeStyleClass("sapMActionSheetDialogWithTitle");}}return this;};
A.prototype.setPlacement=function(p){this.setProperty("placement",p,true);if(!sap.ui.Device.system.phone){if(this._parent){this._parent.setPlacement(p);}}return this;};
A.prototype._buttonSelected=function(){if(sap.ui.Device.system.phone&&this._parent){this._parent._oCloseTrigger=this;}this.close();};
A.prototype._orientationChange=function(){this._parent._adjustScrollingPane();};
A.prototype._addAriaHiddenTexts=function(b){var B=b.getId();if(sap.ui.getCore().getConfiguration().getAccessibility()){var i=new a(B+"-actionSheetHiddenText");this.addAggregation("_invisibleAriaTexts",i,false);if(b.getAriaLabelledBy().indexOf(B)===-1){b.addAriaLabelledBy(B);}b.addAriaLabelledBy(i.getId());}};
A.prototype._removeAriaHiddenTexts=function(b){b.getAriaLabelledBy().forEach(function(i){var c=sap.ui.getCore().byId(i);if(c instanceof a&&i.indexOf("actionSheetHiddenText")>-1){this.removeAggregation("_invisibleAriaTexts",c,false);b.removeAriaLabelledBy(c);c.destroy();}},this);};
A.prototype.addButton=function(b){this.addAggregation("buttons",b,false);this._addAriaHiddenTexts(b);this._preProcessActionButton(b);b.attachPress(this._buttonSelected,this);return this;};
A.prototype.insertButton=function(b,i){this.insertAggregation("buttons",b,i,false);this._addAriaHiddenTexts(b);this._preProcessActionButton(b);b.attachPress(this._buttonSelected,this);return this;};
A.prototype.removeButton=function(b){var r=this.removeAggregation("buttons",b,false);if(r){r.detachPress(this._buttonSelected,this);this._removeAriaHiddenTexts(r);}return r;};
A.prototype.removeAllButtons=function(){var r=this.removeAllAggregation("buttons",false),t=this;q.each(r,function(i,b){b.detachPress(t._buttonSelected,t);t._removeAriaHiddenTexts(b);});return r;};
A.prototype.clone=function(){var b=this.getButtons();for(var i=0;i<b.length;i++){b[i].detachPress(this._buttonSelected,this);}var c=C.prototype.clone.apply(this,arguments);for(var j=0;j<b.length;j++){b[j].attachPress(this._buttonSelected,this);}return c;};
A.prototype._getAllButtons=function(){return this.getButtons();};
return A;},true);
sap.ui.predefine('sap/m/ActionSheetRenderer',['jquery.sap.global'],function(q){"use strict";var A={};
A.render=function(r,c){var a=c._getAllButtons(),I=c.getAggregation("_invisibleAriaTexts"),R=sap.ui.getCore().getLibraryResourceBundle('sap.m'),b=a.length,v=a.filter(function(B){return B.getVisible();}).length,i,m,B,V=1;for(i=0;i<b;i++){B=a[i];B.removeStyleClass("sapMActionSheetButtonNoIcon");if(B.getIcon()&&B.getVisible()){m=true;}else{B.addStyleClass("sapMActionSheetButtonNoIcon");}}r.write("<div");r.writeControlData(c);r.addClass("sapMActionSheet");if(m){r.addClass("sapMActionSheetMixedButtons");}r.writeClasses();var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.write(">");for(i=0;i<b;i++){B=a[i];r.renderControl(a[i].addStyleClass("sapMActionSheetButton"));if(B.getVisible()&&sap.ui.getCore().getConfiguration().getAccessibility()){I[i].setText(R.getText('ACTIONSHEET_BUTTON_INDEX',[V,v]));V++;r.renderControl(I[i]);}else{I[i].setText("");}}if(sap.ui.Device.system.phone&&c.getShowCancelButton()){r.renderControl(c._getCancelButton());}r.write("</div>");};
return A;},true);
sap.ui.predefine('sap/m/App',['jquery.sap.global','./NavContainer','./library'],function(q,N,l){"use strict";
var A=N.extend("sap.m.App",{metadata:{library:"sap.m",properties:{homeIcon:{type:"any",group:"Misc",defaultValue:null},backgroundColor:{type:"string",group:"Appearance",defaultValue:null},backgroundImage:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},backgroundRepeat:{type:"boolean",group:"Appearance",defaultValue:false},backgroundOpacity:{type:"float",group:"Appearance",defaultValue:1}},events:{orientationChange:{deprecated:true,parameters:{landscape:{type:"boolean"}}}}}});
A.prototype.init=function(){N.prototype.init.apply(this,arguments);this.addStyleClass("sapMApp");q.sap.initMobile({viewport:!this._debugZoomAndScroll,statusBar:"default",hideBrowser:true,preventScroll:!this._debugZoomAndScroll,rootId:this.getId()});q(window).bind("resize",q.proxy(this._handleOrientationChange,this));};
A.prototype.onBeforeRendering=function(){if(N.prototype.onBeforeRendering){N.prototype.onBeforeRendering.apply(this,arguments);}q.sap.initMobile({homeIcon:this.getHomeIcon()});};
A.prototype.onAfterRendering=function(){if(N.prototype.onAfterRendering){N.prototype.onAfterRendering.apply(this,arguments);}var r=this.getDomRef().parentNode;while(r&&r!==document.documentElement){var $=q(r);if($.attr("data-sap-ui-root-content")){break;}if(!r.style.height){r.style.height="100%";}r=r.parentNode;}};
A.prototype.exit=function(){q(window).unbind("resize",this._handleOrientationChange);if(this._sInitTimer){q.sap.clearDelayedCall(this._sInitTimer);}};
A.prototype._handleOrientationChange=function(){var $=q(window);var i=$.width()>$.height();if(this._oldIsLandscape!==i){this.fireOrientationChange({landscape:i});this._oldIsLandscape=i;}};
A.prototype.setBackgroundOpacity=function(o){if(o>1||o<0){q.sap.log.warning("Invalid value "+o+" for App.setBackgroundOpacity() ignored. Valid values are: floats between 0 and 1.");return this;}this.$("BG").css("opacity",o);return this.setProperty("backgroundOpacity",o,true);};
return A;},true);
sap.ui.predefine('sap/m/AppRenderer',['jquery.sap.global','./NavContainerRenderer','sap/ui/core/Renderer'],function(q,N,R){"use strict";var A={};var A=R.extend(N);
A.renderAttributes=function(r,c){sap.m.BackgroundHelper.addBackgroundColorStyles(r,c.getBackgroundColor(),c.getBackgroundImage());};
A.renderBeforeContent=function(r,c){sap.m.BackgroundHelper.renderBackgroundImageTag(r,c,"sapMAppBG",c.getBackgroundImage(),c.getBackgroundRepeat(),c.getBackgroundOpacity());};
return A;},true);
sap.ui.predefine('sap/m/AssociativeOverflowToolbar',['./OverflowToolbar','./OverflowToolbarRenderer','./Toolbar'],function(O,a,T){"use strict";
var A=O.extend("sap.m.AssociativeOverflowToolbar",{
metadata:{associations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}}},
renderer:a
});
A.prototype.getContent=function(){var b=this.getAssociation("content")||[];return b.map(function(c){return sap.ui.getCore().byId(c);});};
A.prototype.exit=function(){O.prototype.exit.apply(this,arguments);return this._callToolbarMethod('destroyContent',[true]);};
A.prototype.indexOfContent=function(c){var b=this.getAssociation("content")||[];return b.indexOf(c.getId());};
A.prototype._callToolbarMethod=function(f,b){switch(f){case'addContent':return this.addAssociation("content",b[0]);case'getContent':return this.getContent();case'insertContent':return this.addAssociation("content",b[0],b[3]);case'removeContent':return sap.ui.getCore().byId(this.removeAssociation("content",b[0],b[1],b[2]))||null;case'destroyContent':var c=this.removeAllAssociation("content",b[0]).map(function(d){return sap.ui.getCore().byId(d);});c.forEach(function(d){if(d){d.destroy();}});return this;case'removeAllContent':return this.removeAllAssociation("content",b[0]).map(function(d){return sap.ui.getCore().byId(d);});default:return T.prototype[f].apply(this,b);}};
return A;},false);
sap.ui.predefine('sap/m/Bar.designtime',[],function(){"use strict";return{aggregations:{contentLeft:{domRef:":sap-domref > .sapMBarLeft"},contentMiddle:{domRef:":sap-domref > .sapMBarMiddle > .sapMBarPH"},contentRight:{domRef:":sap-domref > .sapMBarRight"}}};},false);
sap.ui.predefine('sap/m/Bar',['jquery.sap.global','./BarInPageEnabler','./library','sap/ui/core/Control'],function(q,B,l,C){"use strict";
var a=C.extend("sap.m.Bar",{metadata:{interfaces:["sap.m.IBar"],library:"sap.m",properties:{enableFlexBox:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},translucent:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},design:{type:"sap.m.BarDesign",group:"Appearance",defaultValue:sap.m.BarDesign.Auto}},aggregations:{contentLeft:{type:"sap.ui.core.Control",multiple:true,singularName:"contentLeft"},contentMiddle:{type:"sap.ui.core.Control",multiple:true,singularName:"contentMiddle"},contentRight:{type:"sap.ui.core.Control",multiple:true,singularName:"contentRight"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},designTime:true}});
a.prototype.onBeforeRendering=function(){this._removeAllListeners();};
a.prototype.onAfterRendering=function(){this._handleResize();};
a.prototype.init=function(){this.data("sap-ui-fastnavgroup","true",true);};
a.prototype.exit=function(){this._removeAllListeners();if(this._oflexBox){this._oflexBox.destroy();this._oflexBox=null;}this._$MidBarPlaceHolder=null;this._$RightBar=null;this._$LeftBar=null;};
a._aResizeHandlers=["_sResizeListenerId","_sResizeListenerIdMid","_sResizeListenerIdRight","_sResizeListenerIdLeft"];
a.prototype._removeAllListeners=function(){var t=this;a._aResizeHandlers.forEach(function(i){t._removeListenerFailsave(i);});};
a.prototype._removeListenerFailsave=function(L){if(this[L]){sap.ui.core.ResizeHandler.deregister(this[L]);this[L]=null;}};
a.prototype._handleResize=function(){this._removeAllListeners();var c=!!this.getContentLeft().length,d=!!this.getContentMiddle().length,e=!!this.getContentRight().length;if(!this.getVisible()){return;}if(!c&&!d&&!e){return;}this._$LeftBar=this.$("BarLeft");this._$RightBar=this.$("BarRight");this._$MidBarPlaceHolder=this.$("BarPH");this._updatePosition(c,d,e);this._sResizeListenerId=sap.ui.core.ResizeHandler.register(this.getDomRef(),q.proxy(this._handleResize,this));if(this.getEnableFlexBox()){return;}if(c){this._sResizeListenerIdLeft=sap.ui.core.ResizeHandler.register(this._$LeftBar[0],q.proxy(this._handleResize,this));}if(d){this._sResizeListenerIdMid=sap.ui.core.ResizeHandler.register(this._$MidBarPlaceHolder[0],q.proxy(this._handleResize,this));}if(e){this._sResizeListenerIdRight=sap.ui.core.ResizeHandler.register(this._$RightBar[0],q.proxy(this._handleResize,this));}};
a.prototype._updatePosition=function(c,d,e){if(!c&&!e&&d){return;}if(c&&!d&&!e){return;}if(!c&&!d&&e){return;}var i=this.$().outerWidth(true);this._$RightBar.css({width:""});this._$LeftBar.css({width:""});this._$MidBarPlaceHolder.css({position:"",width:"",visibility:'hidden'});var r=this._$RightBar.outerWidth(true);if(r>i){if(c){this._$LeftBar.css({width:"0px"});}if(d){this._$MidBarPlaceHolder.css({width:"0px"});}this._$RightBar.css({width:i+"px"});return;}var L=this._getBarContainerWidth(this._$LeftBar);if(i<(L+r)){L=i-r;this._$LeftBar.css({width:L+"px"});this._$MidBarPlaceHolder.css({width:"0px"});return;}this._$MidBarPlaceHolder.css(this._getMidBarCss(r,i,L));};
a.prototype._getMidBarCss=function(r,i,L){var m=this._$MidBarPlaceHolder.outerWidth(true),R=sap.ui.getCore().getConfiguration().getRTL(),s=R?"right":"left",M={visibility:""};if(this.getEnableFlexBox()){m=i-L-r-parseInt(this._$MidBarPlaceHolder.css('margin-left'),10)-parseInt(this._$MidBarPlaceHolder.css('margin-right'),10);M.position="absolute";M.width=m+"px";M[s]=L;return M;}var S=i-L-r,c=(i/2)-(m/2),d=L>c,e=(i/2)+(m/2),f=(i-r)<e;if(S>0&&(d||f)){M.position="absolute";M.width=S+"px";M.left=R?r:L;}return M;};
a.prototype._getBarContainerWidth=function(c){var i,d=0,e=c.children(),f=0;if(sap.ui.Device.browser.webkit||sap.ui.Device.browser.firefox||sap.ui.Device.browser.edge){for(i=0;i<e.length;i++){f+=q(e[i]).outerWidth(true);}d=c.outerWidth(true);}else{var o;for(i=0;i<e.length;i++){o=window.getComputedStyle(e[i]);if(o.width=="auto"){f+=q(e[i]).width()+1;}else{f+=parseFloat(o.width);}f+=parseFloat(o.marginLeft);f+=parseFloat(o.marginRight);f+=parseFloat(o.paddingLeft);f+=parseFloat(o.paddingRight);}var g=window.getComputedStyle(c[0]);d+=parseFloat(g.width);d+=parseFloat(g.marginLeft);d+=parseFloat(g.marginRight);d+=parseFloat(g.paddingLeft);d+=parseFloat(g.paddingRight);}if(d<f){d=f;}return d;};
var b=B.extend("sap.m.BarInAnyContentEnabler",{});
b.mContexts={dialogFooter:{contextClass:"sapMFooter-CTX",tag:"Footer",internalAriaLabel:"BAR_ARIA_DESCRIPTION_FOOTER"}};
b.prototype.getContext=function(){var p=B.prototype.getContext.call();for(var k in b.mContexts){p[k]=b.mContexts[k];}return p;};
a.prototype.getContext=b.prototype.getContext;a.prototype.isContextSensitive=b.prototype.isContextSensitive;a.prototype.setHTMLTag=b.prototype.setHTMLTag;a.prototype.getHTMLTag=b.prototype.getHTMLTag;a.prototype.applyTagAndContextClassFor=b.prototype.applyTagAndContextClassFor;a.prototype._setLandmarkInfo=b.prototype._setLandmarkInfo;a.prototype._writeLandmarkInfo=b.prototype._writeLandmarkInfo;return a;},true);
sap.ui.predefine('sap/m/BarInPageEnabler',['sap/ui/base/Object','./PageAccessibleLandmarkInfo','sap/ui/core/InvisibleText'],function(O,P,I){"use strict";var c={footer:{contextClass:"sapMFooter-CTX sapContrast sapContrastPlus",tag:"Footer",internalAriaLabel:"BAR_ARIA_DESCRIPTION_FOOTER"},header:{contextClass:"sapMHeader-CTX",tag:"Header",internalAriaLabel:"BAR_ARIA_DESCRIPTION_HEADER"},subheader:{contextClass:"sapMSubHeader-CTX",tag:"Header",internalAriaLabel:"BAR_ARIA_DESCRIPTION_SUBHEADER"}};var a="sapMIBar";var _={},b=sap.ui.getCore().getLibraryResourceBundle("sap.m");var d=function(t,T){if(typeof _[t]==="undefined"){_[t]=new I({text:T}).toStatic().getId();}return _[t];};
var B=O.extend("sap.m.BarInPageEnabler",{
isContextSensitive:function(){return this.getDesign&&this.getDesign()==="Auto";},
setHTMLTag:function(n){if(n===this.sTag){return this;}this.sTag=n;return this;},
getHTMLTag:function(){if(!this.hasOwnProperty("sTag")){this.sTag=sap.m.IBarHTMLTag.Div;}return this.sTag;},
getContext:function(){return c;},
applyTagAndContextClassFor:function(C){var o;if(this.getContext){o=this.getContext();}else{o=c;}var e=o[C];if(!e){jQuery.sap.log.error("The context "+C+" is not known",this);return this;}if(!this.isContextSensitive||!this.setHTMLTag){jQuery.sap.log.error("The bar control you are using does not implement all the members of the IBar interface",this);return this;}if(!this.getRenderer().shouldAddIBarContext()){this.addStyleClass(a+"-CTX");}this.setHTMLTag(e.tag);if(e.internalAriaLabel){this._sInternalAriaLabelId=d(e.tag,b.getText(e.internalAriaLabel));}if(this.isContextSensitive()){this.addStyleClass(e.contextClass);}return this;},
_setLandmarkInfo:function(h,C){this._bHasLandmarkInfo=h;if(h){this._sLandmarkContext=C;}else{this._sLandmarkContext=null;}},
_writeLandmarkInfo:function(r,C){var e;if(C._bHasLandmarkInfo){P._writeLandmarkInfo(r,C.getParent(),C._sLandmarkContext);}else{e=sap.m.Dialog&&C.getParent()instanceof sap.m.Dialog?"heading":"toolbar";r.writeAccessibilityState(C,{role:e});}},
render:function(r,C){var t=C.getHTMLTag().toLowerCase();r.write("<"+t);r.addClass(a);if(C._sInternalAriaLabelId){r.writeAccessibilityState(C,{"labelledby":{value:C._sInternalAriaLabelId,append:true}});}if(this.shouldAddIBarContext(C)){r.addClass(a+"-CTX");}r.writeControlData(C);B.renderTooltip(r,C);this.decorateRootElement(r,C);r.writeClasses();r.writeStyles();r.write(">");this.renderBarContent(r,C);r.write("</"+t+">");}
});
B.renderTooltip=function(r,C){var t=C.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}};
B.addChildClassTo=function(C){C.addStyleClass("sapMBarChild");};
return B;},true);
sap.ui.predefine('sap/m/BarRenderer',['jquery.sap.global','./BarInPageEnabler'],function(q,B){"use strict";var a={};a.render=B.prototype.render;
a.decorateRootElement=function(r,c){r.addClass("sapMBar");r.addClass(this.getContext(c));c._writeLandmarkInfo(r,c);if(c.getTranslucent()&&(sap.ui.Device.support.touch||q.sap.simulateMobileOnDesktop)){r.addClass("sapMBarTranslucent");}r.addClass("sapMBar-CTX");};
a.shouldAddIBarContext=function(){return true;};
a.renderBarContent=function(r,c){var C="</div>";r.write("<div id='"+c.getId()+"-BarLeft' ");r.addClass('sapMBarLeft');r.addClass('sapMBarContainer');r.writeClasses();w("left",r,c);r.write(">");this.renderAllControls(c.getContentLeft(),r,c);r.write(C);r.write("<div id='"+c.getId()+"-BarMiddle' ");r.addClass('sapMBarMiddle');r.writeClasses();r.write(">");if(c.getEnableFlexBox()){c._oflexBox=c._oflexBox||new sap.m.HBox(c.getId()+"-BarPH",{alignItems:"Center"}).addStyleClass("sapMBarPH").setParent(c,null,true);var b=!!c.getContentLeft().length,d=!!c.getContentMiddle().length,e=!!c.getContentRight().length;if(d&&!b&&!e){c._oflexBox.addStyleClass("sapMBarFlexBoxWidth100");}c.getContentMiddle().forEach(function(m){c._oflexBox.addItem(m);});r.renderControl(c._oflexBox);}else{r.write("<div id='"+c.getId()+"-BarPH' ");r.addClass('sapMBarPH');r.addClass('sapMBarContainer');w("middle",r,c);r.writeClasses();r.write(">");this.renderAllControls(c.getContentMiddle(),r,c);r.write(C);}r.write(C);r.write("<div id='"+c.getId()+"-BarRight'");r.addClass('sapMBarRight');r.addClass('sapMBarContainer');if(sap.ui.getCore().getConfiguration().getRTL()){r.addClass("sapMRTL");}r.writeClasses();w("right",r,c);r.write(">");this.renderAllControls(c.getContentRight(),r,c);r.write(C);};
a.renderAllControls=function(c,r,b){c.forEach(function(C){sap.m.BarInPageEnabler.addChildClassTo(C,b);r.renderControl(C);});};
a._mContexts={Header:"sapMHeader-CTX",SubHeader:"sapMSubHeader-CTX",Footer:"sapMFooter-CTX",Default:"sapMContent-CTX"};
a.getContext=function(c){var d=c.getDesign(),C=a._mContexts;return C[d]||C.Default;};
function w(A,r,c){var C=!!c.getContentLeft().length,b=!!c.getContentMiddle().length,d=!!c.getContentRight().length;function e(){r.addStyle("width","100%");r.writeStyles();}switch(A.toLowerCase()){case"left":if(C&&!b&&!d){e();}break;case"middle":if(b&&!C&&!d){e();}break;case"right":if(d&&!C&&!b){e();}break;default:q.sap.log.error("Cannot determine which of the three content aggregations is alone");}}
return a;},true);
sap.ui.predefine('sap/m/Breadcrumbs',["sap/ui/core/Control","sap/m/Text","sap/m/Link","sap/m/Select","sap/ui/core/Item","sap/ui/core/delegate/ItemNavigation","sap/ui/core/ResizeHandler","sap/ui/core/IconPool","sap/ui/Device"],function(C,T,L,S,I,a,R,b,D){"use strict";
var B=C.extend("sap.m.Breadcrumbs",{metadata:{library:"sap.m",properties:{currentLocationText:{type:"string",group:"Behavior",defaultValue:null}},aggregations:{links:{type:"sap.m.Link",multiple:true,singularName:"link"},_currentLocation:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_select:{type:"sap.m.Select",multiple:false,visibility:"hidden"}},defaultAggregation:"links"}});
B.prototype.onBeforeRendering=function(){if(this._bControlsInfoCached){this._updateSelect(true);}};
B.prototype.onAfterRendering=function(){if(!this._bControlsInfoCached){this._updateSelect(true);return;}this._configureKeyboardHandling();};
B.prototype.onThemeChanged=function(){this._resetControl();};
B.prototype.exit=function(){this._resetControl();this._destroyItemNavigation();};
B.PAGEUP_AND_PAGEDOWN_JUMP_SIZE=5;
B._getResourceBundle=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m");};
B.prototype._getAugmentedId=function(s){return this.getId()+"-"+s;};
B.prototype._getSelect=function(){if(!this.getAggregation("_select")){this.setAggregation("_select",this._decorateSelect(new S({id:this._getAugmentedId("select"),change:this._selectChangeHandler.bind(this),forceSelection:false,autoAdjustWidth:true,icon:b.getIconURI("slim-arrow-down"),type:sap.m.SelectType.IconOnly})));}return this.getAggregation("_select");};
B.prototype._getCurrentLocation=function(){if(!this.getAggregation("_currentLocation")){this.setAggregation("_currentLocation",new T({id:this._getAugmentedId("currentText"),text:this.getCurrentLocationText(),wrapping:false}).addStyleClass("sapMBreadcrumbsCurrentLocation"));}return this.getAggregation("_currentLocation");};
function c(A,d){var e=Array.prototype.slice.apply(d);e.unshift(A);return e;}
B.prototype.insertLink=function(l,i){var r=this.insertAggregation.apply(this,c("links",arguments));this._registerControlListener(l);this._resetControl();return r;};
B.prototype.addLink=function(l){var r=this.addAggregation.apply(this,c("links",arguments));this._registerControlListener(l);this._resetControl();return r;};
B.prototype.removeLink=function(o){var r=this.removeAggregation.apply(this,c("links",arguments));this._deregisterControlListener(r);this._resetControl();return r;};
B.prototype.removeAllLinks=function(){var l=this.getAggregation("links");var r=this.removeAllAggregation.apply(this,c("links",arguments));l.forEach(this._deregisterControlListener,this);this._resetControl();return r;};
B.prototype.destroyLinks=function(){var l=this.getAggregation("links");var r=this.destroyAggregation.apply(this,c("links",arguments));l.forEach(this._deregisterControlListener,this);this._resetControl();return r;};
B.prototype._decorateSelect=function(s){s.getPicker().attachAfterOpen(this._removeItemNavigation,this).attachBeforeClose(this._restoreItemNavigation,this);s._onBeforeOpenDialog=this._onSelectBeforeOpenDialog.bind(this);s._onBeforeOpenPopover=this._onSelectBeforeOpenPopover.bind(this);s.onsapescape=this._onSelectEscPress.bind(this);return s;};
B.prototype._removeItemNavigation=function(){this.removeDelegate(this._getItemNavigation());};
B.prototype._onSelectBeforeOpenDialog=function(){var s=this._getSelect();if(this.getCurrentLocationText()&&D.system.phone){s.setSelectedIndex(0);}else{s.setSelectedItem(null);}S.prototype._onBeforeOpenDialog.call(s);this._removeItemNavigation();};
B.prototype._onSelectBeforeOpenPopover=function(){this._getSelect().setSelectedItem(null);this._removeItemNavigation();};
B.prototype._restoreItemNavigation=function(){this.addDelegate(this._getItemNavigation());};
B.prototype._onSelectEscPress=function(){this._getSelect().close();};
B.prototype._createSelectItem=function(i){return new I({key:i.getId(),text:i.getText()});};
B.prototype._selectChangeHandler=function(e){var l,s,d,o=e.getParameter("selectedItem");if(!o){return;}if(!this._getSelect().isOpen()){return;}l=sap.ui.getCore().byId(o.getKey());if(!(l instanceof L)){return;}s=l.getHref();d=l.getTarget();l.firePress();if(s){if(d){window.open(s,d);}else{window.location.href=s;}}};
B.prototype._getItemsForMobile=function(){var i=this.getLinks();if(this.getCurrentLocationText()){i.push(this._getCurrentLocation());}return i;};
B.prototype._updateSelect=function(i){var s=this._getSelect(),d,o=this._getControlDistribution();if(!this._bControlDistributionCached||i){s.removeAllItems();d=D.system.phone?this._getItemsForMobile():o.aControlsForSelect;d.map(this._createSelectItem).reverse().forEach(s.insertItem,s);this._bControlDistributionCached=true;this.invalidate(this);}s.setVisible(!!o.aControlsForSelect.length);if(!this._sResizeListenerId){this._sResizeListenerId=R.register(this,this._handleScreenResize.bind(this));}};
B.prototype._getControlsForBreadcrumbTrail=function(){var v;if(this._bControlDistributionCached&&this._oDistributedControls){return this._oDistributedControls.aControlsForBreadcrumbTrail;}v=this.getLinks().filter(function(l){return l.getVisible();});if(this.getCurrentLocationText()){return v.concat([this._getCurrentLocation()]);}return v;};
B.prototype._getControlInfo=function(o){return{id:o.getId(),control:o,width:o.$().parent().outerWidth(true),bCanOverflow:o instanceof L};};
B.prototype._getControlDistribution=function(m){m=m||this._iContainerSize;this._iContainerSize=m;this._oDistributedControls=this._determineControlDistribution(m);return this._oDistributedControls;};
B.prototype._determineControlDistribution=function(m){var i,o,d=this._getControlsInfo().aControlInfo,s=this._iSelectWidth,e=[],f=[],u=s;for(i=d.length-1;i>=0;i--){o=d[i];u+=o.width;if(d.length-1===i){f.push(o.control);continue;}if(i===0){u-=s;}if(u>m&&o.bCanOverflow){e.unshift(o.control);}else{f.unshift(o.control);}}return{aControlsForBreadcrumbTrail:f,aControlsForSelect:e};};
B.prototype._getControlsInfo=function(){if(!this._bControlsInfoCached){this._iSelectWidth=this._getSelect().$().parent().outerWidth(true)||0;this._aControlInfo=this._getControlsForBreadcrumbTrail().map(this._getControlInfo);this._iContainerSize=this.$().outerWidth(true);this._bControlsInfoCached=true;}return{aControlInfo:this._aControlInfo,iSelectWidth:this._iSelectWidth,iContentSize:this._iContainerSize};};
B.prototype._handleScreenResize=function(e){var i=this._oDistributedControls.aControlsForBreadcrumbTrail.length,o=this._getControlDistribution(e.size.width),d=o.aControlsForBreadcrumbTrail.length;if(i!==d){this._updateSelect(true);}return this;};
B.prototype._getItemsToNavigate=function(){var i=this._getControlsForBreadcrumbTrail().slice(),s=this._getSelect();if(s.getVisible()){i.unshift(s);}return i;};
B.prototype._getItemNavigation=function(){if(!this._itemNavigation){this._itemNavigation=new a();}return this._itemNavigation;};
B.prototype._destroyItemNavigation=function(){if(this._itemNavigation){this.removeEventDelegate(this._itemNavigation);this._itemNavigation.destroy();this._itemNavigation=null;}};
B.prototype._configureKeyboardHandling=function(){var i=this._getItemNavigation(),s=-1,d=this._getItemsToNavigate(),n=[];d.forEach(function(o,e){if(e===0){o.$().attr("tabIndex","0");}o.$().attr("tabIndex","-1");n.push(o.getDomRef());});this.addDelegate(i);i.setCycling(false);i.setPageSize(B.PAGEUP_AND_PAGEDOWN_JUMP_SIZE);i.setRootDomRef(this.getDomRef());i.setItemDomRefs(n);i.setSelectedIndex(s);return this;};
B.prototype._registerControlListener=function(o){if(o){o.attachEvent("_change",this._resetControl,this);}};
B.prototype._deregisterControlListener=function(o){if(o){o.detachEvent("_change",this._resetControl,this);}};
B.prototype.setCurrentLocationText=function(t){var o=this._getCurrentLocation(),r=this.setProperty("currentLocationText",t,true);if(o.getText()!==t){o.setText(t);this._resetControl();}return r;};
B.prototype._resetControl=function(){this._aControlInfo=null;this._iContainerSize=null;this._bControlsInfoCached=null;this._bControlDistributionCached=null;this._oDistributedControls=null;if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this.removeDelegate(this._getItemNavigation());this.invalidate(this);return this;};
return B;},true);
sap.ui.predefine('sap/m/BreadcrumbsRenderer',["sap/m/Breadcrumbs","sap/m/Text"],function(C,T){"use strict";var B={};
B.render=function(r,c){var a=c._getControlsForBreadcrumbTrail(),s=c._getSelect();r.write("<ul");r.writeControlData(c);r.addClass("sapMBreadcrumbs");r.writeClasses();r.writeAttribute("role","navigation");r.writeAttributeEscaped("aria-label",C._getResourceBundle().getText("BREADCRUMB_LABEL"));r.write(">");if(s.getVisible()){this._renderControlInListItem(r,s,false,"sapMBreadcrumbsSelectItem");}a.forEach(function(o){this._renderControlInListItem(r,o,o instanceof T);},this);r.write("</ul>");};
B._renderControlInListItem=function(r,c,s,a){r.write("<li");r.writeAttribute("role","presentation");r.writeAttribute("aria-hidden","true");r.addClass("sapMBreadcrumbsItem");r.addClass(a);r.writeClasses();r.write(">");r.renderControl(c);if(!s){r.write("<span");r.addClass("sapMBreadcrumbsSeparator");r.writeClasses();r.write(">/</span>");}r.write("</li>");};
return B;},true);
sap.ui.predefine('sap/m/BusyDialog',['jquery.sap.global','./library','sap/ui/core/Control','sap/m/Dialog','sap/m/BusyIndicator','sap/m/Label','sap/m/Button'],function(q,l,C,D,B,L,a,P,b){"use strict";
var c=C.extend("sap.m.BusyDialog",{
metadata:{library:"sap.m",properties:{text:{type:"string",group:"Appearance",defaultValue:''},title:{type:"string",group:"Appearance",defaultValue:''},customIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:''},customIconRotationSpeed:{type:"int",group:"Appearance",defaultValue:1000},customIconDensityAware:{type:"boolean",defaultValue:true},customIconWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},customIconHeight:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},cancelButtonText:{type:"string",group:"Misc",defaultValue:''},showCancelButton:{type:"boolean",group:"Appearance",defaultValue:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{close:{parameters:{cancelPressed:{type:"boolean"}}}}},
renderer:function(r,o){}
});
c.prototype.init=function(){this._busyIndicator=new B(this.getId()+'-busyInd',{visible:true});function o(){if(sap.ui.getCore().getConfiguration().getAccessibility()){this._$content.attr('role','application');}}this._oDialog=new D(this.getId()+'-Dialog',{content:this._busyIndicator,showHeader:false,afterOpen:o,initialFocus:this._busyIndicator}).addStyleClass('sapMBusyDialog');this._oDialog.addEventDelegate({onBeforeRendering:function(){var t=this.getText();var d=this.getTitle();var s=this.getShowCancelButton()||this.getCancelButtonText();if(!t&&!d&&!s){this._oDialog.addStyleClass('sapMBusyDialog-Light');}else{this._oDialog.removeStyleClass('sapMBusyDialog-Light');}}},this);this._oDialog.oPopup.onsapescape=function(e){this.close(true);}.bind(this);};
c.prototype.exit=function(){this._busyIndicator.destroy();this._busyIndicator=null;if(this._cancelButton){this._cancelButton.destroy();this._cancelButton=null;}if(this._oLabel){this._oLabel.destroy();this._oLabel=null;}this._oDialog.destroy();this._oDialog=null;};
c.prototype.open=function(){q.sap.log.debug("sap.m.BusyDialog.open called at "+new Date().getTime());if(this.getAriaLabelledBy()&&!this._oDialog._$dialog){var t=this;this.getAriaLabelledBy().forEach(function(i){t._oDialog.addAriaLabelledBy(i);});}if(!document.body||!sap.ui.getCore().isInitialized()){setTimeout(function(){this.open();}.bind(this),50);}else{this._oDialog.open();}return this;};
c.prototype.close=function(i){this.fireClose({cancelPressed:i||false});this._oDialog.close();return this;};
c.prototype.setTitle=function(t){this.setProperty('title',t,true);this._oDialog.setTitle(t).setShowHeader(!!t);return this;};
c.prototype.setTooltip=function(t){this._oDialog.setTooltip(t);return this;};
c.prototype.getTooltip=function(){this._oDialog.getTooltip();return this;};
c.prototype.setText=function(t){this.setProperty('text',t,true);if(!this._oLabel){if(t){this._oLabel=new L(this.getId()+'-TextLabel',{text:t}).addStyleClass('sapMBusyDialogLabel');this._oDialog.insertAggregation('content',this._oLabel,0);this._oDialog.addAriaLabelledBy(this._oLabel.getId());}}else{if(t){this._oLabel.setText(t).setVisible(true);}else{this._oLabel.setVisible(false);}}return this;};
c.prototype.setCustomIcon=function(i){this.setProperty("customIcon",i,true);this._busyIndicator.setCustomIcon(i);return this;};
c.prototype.setCustomIconRotationSpeed=function(s){this.setProperty("customIconRotationSpeed",s,true);this._busyIndicator.setCustomIconRotationSpeed(s);return this;};
c.prototype.setCustomIconDensityAware=function(i){this.setProperty("customIconDensityAware",i,true);this._busyIndicator.setCustomIconDensityAware(i);return this;};
c.prototype.setCustomIconWidth=function(w){this.setProperty("customIconWidth",w,true);this._busyIndicator.setCustomIconWidth(w);return this;};
c.prototype.setCustomIconHeight=function(h){this.setProperty("customIconHeight",h,true);this._busyIndicator.setCustomIconHeight(h);return this;};
c.prototype.setShowCancelButton=function(i){this.setProperty("showCancelButton",i,false);if(i){this._oDialog.setEndButton(this._getCancelButton());}else{this._destroyTheCancelButton();}return this;};
c.prototype.setCancelButtonText=function(t){this.setProperty("cancelButtonText",t,false);if(t){this._getCancelButton().setText(t);this._oDialog.setEndButton(this._getCancelButton());}else{this._destroyTheCancelButton();}return this;};
c.prototype.getDomRef=function(){return this._oDialog&&this._oDialog.getDomRef();};
c.prototype._destroyTheCancelButton=function(){this._oDialog.destroyEndButton();this._cancelButton=null;};
c.prototype._getCancelButton=function(){var d=this.getCancelButtonText();d=d?d:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("BUSYDIALOG_CANCELBUTTON_TEXT");return this._cancelButton?this._cancelButton:this._cancelButton=new a(this.getId()+'busyCancelBtn',{text:d,press:function(){this.close(true);}.bind(this)});};
return c;},true);
sap.ui.predefine('sap/m/BusyIndicator',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/theming/Parameters'],function(q,l,C,P){"use strict";
var B=C.extend("sap.m.BusyIndicator",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Data",defaultValue:""},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},customIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:""},customIconRotationSpeed:{type:"int",group:"Appearance",defaultValue:1000},customIconDensityAware:{type:"boolean",defaultValue:true},customIconWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},customIconHeight:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},size:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:"1rem"},design:{type:"string",group:"Appearance",defaultValue:"auto"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}}});
B.prototype.init=function(){this.setBusyIndicatorDelay(0);};
B.prototype.setText=function(t){this.setProperty("text",t,true);this._createLabel("setText",t);return this;};
B.prototype.setTextDirection=function(d){this.setProperty("textDirection",d,true);this._createLabel("setTextDirection",d);return this;};
B.prototype.setCustomIcon=function(s){this.setProperty("customIcon",s,false);this._createCustomIcon("setSrc",s);return this;};
B.prototype.setCustomIconRotationSpeed=function(s){if(isNaN(s)||s<0){s=0;}if(s!==this.getCustomIconRotationSpeed()){this.setProperty("customIconRotationSpeed",s,true);this._setRotationSpeed();}return this;};
B.prototype.setCustomIconDensityAware=function(a){this.setProperty("customIconDensityAware",a,true);this._createCustomIcon("setDensityAware",a);return this;};
B.prototype.setCustomIconWidth=function(w){this.setProperty("customIconWidth",w,true);this._createCustomIcon("setWidth",w);return this;};
B.prototype.setCustomIconHeight=function(h){this.setProperty("customIconHeight",h,true);this._createCustomIcon("setHeight",h);return this;};
B.prototype.setSize=function(s){this.setProperty("size",s,true);var d=this.getDomRef();if(d){d.style.fontSize=s;}return this;};
B.prototype.onBeforeRendering=function(){if(this.getCustomIcon()){this.setBusy(false);}else{this.setBusy(true,"busy-area");}};
B.prototype.exit=function(){if(this._iconImage){this._iconImage.destroy();this._iconImage=null;}if(this._busyLabel){this._busyLabel.destroy();this._busyLabel=null;}};
B.prototype._createCustomIcon=function(n,v){if(!this._iconImage){this._iconImage=new sap.m.Image(this.getId()+"-icon",{width:"44px",height:"44px"}).addStyleClass("sapMBsyIndIcon");this._iconImage.addEventDelegate({onAfterRendering:function(){this._setRotationSpeed();}},this);}this._iconImage[n](v);this._setRotationSpeed();};
B.prototype._createLabel=function(n,v){if(!this._busyLabel){this._busyLabel=new sap.m.Label(this.getId()+"-label",{labelFor:this.getId(),textAlign:"Center"});}this._busyLabel[n](v);};
B.prototype._setRotationSpeed=function(){if(!this._iconImage){return;}if(q.support.cssAnimations){var $=this._iconImage.$();var r=this.getCustomIconRotationSpeed()+"ms";$.css("-webkit-animation-duration",r).css("animation-duration",r);$.css("display","none");setTimeout(function(){$.css("display","inline");},0);}else{this._rotateCustomIcon();}};
B.prototype._rotateCustomIcon=function(){if(!this._iconImage){return;}var $=this._iconImage.$();if(!$[0]||!$[0].offsetWidth){return;}var r=this.getCustomIconRotationSpeed();if(!r){return;}if(!this._fnRotateCustomIcon){this._fnRotateCustomIcon=q.proxy(this._rotateCustomIcon,this);}var R=this._fnRotateCustomIcon;if(!this._$CustomRotator){this._$CustomRotator=q({deg:0});}var a=this._$CustomRotator;if(a.running){return;}a[0].deg=0;a.animate({deg:360},{duration:r,easing:"linear",step:function(n){a.running=true;$.css("-ms-transform",'rotate('+n+'deg)');},complete:function(){a.running=false;window.setTimeout(R,10);}});};
return B;},true);
sap.ui.predefine('sap/m/BusyIndicatorRenderer',['jquery.sap.global'],function(q){"use strict";var B={};
B.render=function(r,b){this.startBusyIndicator(r,b);this.renderBusyIndication(r,b);this.renderLabel(r,b);this.endBusyIndicator(r);};
B.startBusyIndicator=function(r,b){var a={role:"progressbar",valuemin:"0",valuemax:"100"};r.write("<div tabindex='0' ");r.writeControlData(b);r.addClass("sapMBusyIndicator");r.writeClasses();r.addStyle("font-size",b.getSize());r.writeStyles();r.writeAccessibilityState(b,a);this.renderTooltip(r,b.getTooltip_AsString());r.write(">");};
B.renderTooltip=function(r,t){if(t){r.writeAttributeEscaped("title",t);}};
B.renderBusyIndication=function(r,b){if(b.getCustomIcon()){r.renderControl(b._iconImage);}else{r.write("<div class='sapMBusyIndicatorBusyArea'");r.writeAttribute("id",b.getId()+"-busy-area");r.write("></div>");}};
B.renderLabel=function(r,b){if(b.getText()){r.renderControl(b._busyLabel);}};
B.endBusyIndicator=function(r){r.write("</div>");};
return B;},true);
sap.ui.predefine('sap/m/Button',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/Device'],function(q,l,C,E,I,D){"use strict";
var B=C.extend("sap.m.Button",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null},type:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:sap.m.ButtonType.Default},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},iconFirst:{type:"boolean",group:"Appearance",defaultValue:true},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{tap:{deprecated:true},press:{}}}});
E.call(B.prototype);
B.prototype.exit=function(){if(this._image){this._image.destroy();}if(this._iconBtn){this._iconBtn.destroy();}};
B.prototype.onBeforeRendering=function(){this._bRenderActive=this._bActive;};
B.prototype.onAfterRendering=function(){if(this._bRenderActive){this._activeButton();this._bRenderActive=this._bActive;}};
B.prototype.ontouchstart=function(e){e.setMarked();if(this._bRenderActive){delete this._bRenderActive;}if(e.targetTouches.length===1){this._activeButton();}if(this.getEnabled()&&this.getVisible()){if(D.browser.safari&&(e.originalEvent&&e.originalEvent.type==="mousedown")){e.preventDefault();}}};
B.prototype.ontouchend=function(e){this._inactiveButton();if(this._bRenderActive){delete this._bRenderActive;if(e.originalEvent&&e.originalEvent.type in{mouseup:1,touchend:1}){this.ontap(e);}}};
B.prototype.ontouchcancel=function(){this._inactiveButton();};
B.prototype.ontap=function(e){e.setMarked();if(this.getEnabled()&&this.getVisible()){if((e.originalEvent&&e.originalEvent.type==="touchend")||D.browser.safari){this.focus();}this.fireTap({});this.firePress({});}};
B.prototype.onkeydown=function(e){if(e.which===q.sap.KeyCodes.SPACE||e.which===q.sap.KeyCodes.ENTER){e.setMarked();this._activeButton();}};
B.prototype.onkeyup=function(e){if(e.which===q.sap.KeyCodes.SPACE||e.which===q.sap.KeyCodes.ENTER){e.setMarked();this._inactiveButton();this.firePress({});}};
B.prototype.onfocusout=function(){this._inactiveButton();};
B.prototype._activeButton=function(){if(!this._isUnstyled()){this.$("inner").addClass("sapMBtnActive");}this._bActive=this.getEnabled();if(this._bActive){if(this.getIcon()&&this.getActiveIcon()&&this._image){this._image.setSrc(this.getActiveIcon());}}};
B.prototype._inactiveButton=function(){if(!this._isUnstyled()){this.$("inner").removeClass("sapMBtnActive");}this._bActive=false;if(this.getEnabled()){if(this.getIcon()&&this.getActiveIcon()&&this._image){this._image.setSrc(this.getIcon());}}};
B.prototype._isHoverable=function(){return this.getEnabled()&&D.system.desktop;};
B.prototype._getImage=function(i,s,a,b){if(this._image&&(this._image.getSrc()!==s)){this._image.destroy();this._image=undefined;}var o=this._image;var c=this.getIconFirst();if(!!o){o.setSrc(s);if(o instanceof sap.m.Image){o.setActiveSrc(a);o.setDensityAware(b);}}else{o=I.createControlByURI({id:i,src:s,activeSrc:a,densityAware:b,useIconTooltip:false},sap.m.Image).addStyleClass("sapMBtnCustomIcon").setParent(this,null,true);}o.addStyleClass("sapMBtnIcon");o.toggleStyleClass("sapMBtnIconLeft",c);o.toggleStyleClass("sapMBtnIconRight",!c);this._image=o;return this._image;};
B.prototype._getInternalIconBtn=function(i,s){var o=this._iconBtn;if(o){o.setSrc(s);}else{o=I.createControlByURI({id:i,src:s,useIconTooltip:false},sap.m.Image).setParent(this,null,true);}o.addStyleClass("sapMBtnIcon");o.addStyleClass("sapMBtnIconLeft");this._iconBtn=o;return this._iconBtn;};
B.prototype._isUnstyled=function(){var u=false;if(this.getType()===sap.m.ButtonType.Unstyled){u=true;}return u;};
B.prototype.setText=function(t){var v=this.getText();if(t===null||t===undefined){t="";}if(v!==t){var d=this.getDomRef("content");var s=!!d;this.setProperty("text",t,s);if(s){t=this.getText();d.innerHTML=q.sap.encodeHTML(t);this.$("inner").toggleClass("sapMBtnText",!!t);}}return this;};
B.prototype.setIcon=function(i){var v=this.getIcon()||"";i=i||"";if(v!==i){var s=!!v&&!!i&&I.isIconURI(i)===I.isIconURI(v);this.setProperty("icon",i,s);if(s&&this._image){this._image.setSrc(i);}}return this;};
B.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("inner");};
B.prototype._getText=function(){return this.getText();};
B.prototype._getTooltip=function(){var t=this.getTooltip_AsString();if(!t&&!this.getText()){var i=sap.ui.core.IconPool.getIconInfo(this.getIcon());if(i&&i.text){t=i.text;}}return t;};
B.prototype.setType=function(t){this.setProperty("type",t);var T="";var r;switch(t){case sap.m.ButtonType.Accept:if(!sap.m.Button._oStaticAcceptText){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");T=r.getText("BUTTON_ARIA_TYPE_ACCEPT");sap.m.Button._oStaticAcceptText=new sap.ui.core.InvisibleText({text:T});sap.m.Button._oStaticAcceptText.toStatic();}break;case sap.m.ButtonType.Reject:if(!sap.m.Button._oStaticRejectText){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");T=r.getText("BUTTON_ARIA_TYPE_REJECT");sap.m.Button._oStaticRejectText=new sap.ui.core.InvisibleText({text:T});sap.m.Button._oStaticRejectText.toStatic();}break;case sap.m.ButtonType.Emphasized:if(!sap.m.Button._oStaticEmphasizedText){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");T=r.getText("BUTTON_ARIA_TYPE_EMPHASIZED");sap.m.Button._oStaticEmphasizedText=new sap.ui.core.InvisibleText({text:T});sap.m.Button._oStaticEmphasizedText.toStatic();}break;default:break;}return this;};
B.prototype.getAccessibilityInfo=function(){var d=this.getText()||this.getTooltip_AsString();if(!d&&this.getIcon()){var i=sap.ui.core.IconPool.getIconInfo(this.getIcon());if(i){d=i.text||i.name;}}return{role:"button",type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_BUTTON"),description:d,focusable:this.getEnabled(),enabled:this.getEnabled()};};
return B;},true);
sap.ui.predefine('sap/m/ButtonRenderer',['jquery.sap.global'],function(q){"use strict";var B={};
B.render=function(R,b){var t=b.getType();var e=b.getEnabled();var w=b.getWidth();var T=b._getTooltip();var s=b._getText();var a=b.getTextDirection();var i=sap.ui.Device.browser.internet_explorer||sap.ui.Device.browser.edge;var c=sap.ui.core.IconPool.getIconURI("nav-back");R.write("<button");R.writeControlData(b);R.addClass("sapMBtnBase");if(!b._isUnstyled()){R.addClass("sapMBtn");if((t===sap.m.ButtonType.Back||t===sap.m.ButtonType.Up)&&b.getIcon()&&!s){R.addClass("sapMBtnBack");}}var A={};var d="";switch(t){case sap.m.ButtonType.Accept:d=sap.m.Button._oStaticAcceptText.getId();break;case sap.m.ButtonType.Reject:d=sap.m.Button._oStaticRejectText.getId();break;case sap.m.ButtonType.Emphasized:d=sap.m.Button._oStaticEmphasizedText.getId();break;default:break;}if(d){A["describedby"]={value:d,append:true};}if(b.getAriaLabelledBy()&&b.getAriaLabelledBy().length>0){A["labelledby"]={value:b.getId(),append:true};}if(this.renderAccessibilityAttributes){this.renderAccessibilityAttributes(R,b,A);}R.writeAccessibilityState(b,A);if(!e){R.writeAttribute("disabled","disabled");if(!b._isUnstyled()){R.addClass("sapMBtnDisabled");}}else{switch(t){case sap.m.ButtonType.Accept:case sap.m.ButtonType.Reject:case sap.m.ButtonType.Emphasized:R.addClass("sapMBtnInverted");break;default:break;}}if(T){R.writeAttributeEscaped("title",T);}R.writeClasses();if(w!=""||w.toLowerCase()==="auto"){R.addStyle("width",w);R.writeStyles();}r(b,R);R.write(">");R.write("<span");R.writeAttribute("id",b.getId()+"-inner");if(!b._isUnstyled()){R.addClass("sapMBtnInner");}if(b._isHoverable()){R.addClass("sapMBtnHoverable");}if(e){R.addClass("sapMFocusable");if(i){R.addClass("sapMIE");}}if(!b._isUnstyled()){if(s){R.addClass("sapMBtnText");}if(t===sap.m.ButtonType.Back||t===sap.m.ButtonType.Up){R.addClass("sapMBtnBack");}if(b.getIcon()){if(b.getIconFirst()){R.addClass("sapMBtnIconFirst");}else{R.addClass("sapMBtnIconLast");}}}if(this.renderButtonAttributes){this.renderButtonAttributes(R,b);}if(!b._isUnstyled()&&t!==""){R.addClass("sapMBtn"+q.sap.encodeHTML(t));}R.writeClasses();r(b,R);R.write(">");if(t===sap.m.ButtonType.Back||t===sap.m.ButtonType.Up){this.writeInternalIconPoolHtml(R,b,c);}if(b.getIcon()){this.writeImgHtml(R,b);}if(s){R.write("<span");R.addClass("sapMBtnContent");if(a!==sap.ui.core.TextDirection.Inherit){R.writeAttribute("dir",a.toLowerCase());}R.writeClasses();R.writeAttribute("id",b.getId()+"-content");R.write(">");R.writeEscaped(s);R.write("</span>");}if(i&&e){R.write('<span class="sapMBtnFocusDiv"></span>');}R.write("</span>");R.write("</button>");};
B.writeImgHtml=function(R,b){R.renderControl(b._getImage((b.getId()+"-img"),b.getIcon(),b.getActiveIcon(),b.getIconDensityAware()));};
B.writeInternalIconPoolHtml=function(R,b,u){R.renderControl(b._getInternalIconBtn((b.getId()+"-iconBtn"),u));};
function r(b,R){if(b._bExcludeFromTabChain){R.writeAttribute("tabindex",-1);}}
return B;},true);
sap.ui.predefine('sap/m/Carousel',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/thirdparty/mobify-carousel'],function(q,l,C,m){"use strict";
var a=C.extend("sap.m.Carousel",{metadata:{library:"sap.m",properties:{height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},loop:{type:"boolean",group:"Misc",defaultValue:false},showPageIndicator:{type:"boolean",group:"Appearance",defaultValue:true},pageIndicatorPlacement:{type:"sap.m.PlacementType",group:"Appearance",defaultValue:sap.m.PlacementType.Bottom},showBusyIndicator:{type:"boolean",group:"Appearance",defaultValue:true,deprecated:true},busyIndicatorSize:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'6em',deprecated:true},arrowsPlacement:{type:"sap.m.CarouselArrowsPlacement",group:"Appearance",defaultValue:sap.m.CarouselArrowsPlacement.Content}},defaultAggregation:"pages",aggregations:{pages:{type:"sap.ui.core.Control",multiple:true,singularName:"page"}},associations:{activePage:{type:"sap.ui.core.Control",multiple:false}},events:{loadPage:{deprecated:true,parameters:{pageId:{type:"string"}}},unloadPage:{deprecated:true,parameters:{pageId:{type:"string"}}},pageChanged:{parameters:{oldActivePageId:{type:"string"},newActivePageId:{type:"string"}}}}}});
a._INNER_SELECTOR=".sapMCrslInner";a._PAGE_INDICATOR_SELECTOR=".sapMCrslBulleted";a._PAGE_INDICATOR_ARROWS_SELECTOR=".sapMCrslIndicatorArrow";a._CONTROLS=".sapMCrslControls";a._ITEM_SELECTOR=".sapMCrslItem";a._LEFTMOST_CLASS="sapMCrslLeftmost";a._RIGHTMOST_CLASS="sapMCrslRightmost";a._LATERAL_CLASSES="sapMCrslLeftmost sapMCrslRightmost";a._bIE9=(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<10);a._MODIFIERNUMBERFORKEYBOARDHANDLING=10;a._BULLETS_TO_NUMBERS_THRESHOLD=9;
a.prototype.init=function(){this._aScrollContainers=[];this._fnAdjustAfterResize=q.proxy(function(){var $=this.$().find(a._INNER_SELECTOR);this._oMobifyCarousel.resize($);},this);this.data("sap-ui-fastnavgroup","true",true);};
a.prototype.exit=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.destroy();delete this._oMobifyCarousel;}if(this._oArrowLeft){this._oArrowLeft.destroy();delete this._oArrowLeft;}if(this._oArrowRight){this._oArrowRight.destroy();delete this._oArrowRight;}if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this.$().off('afterSlide');this._cleanUpScrollContainer();this._fnAdjustAfterResize=null;this._aScrollContainers=null;this._$InnerDiv=null;};
a.prototype._cleanUpScrollContainer=function(){var s;while(this.length>0){s=this._aScrollContainers.pop();s.removeAllContent();if(s&&typeof s.destroy==='function'){s.destroy();}}};
a.prototype.ontouchstart=function(e){if(this._oMobifyCarousel){this._oMobifyCarousel.touchstart(e);}};
a.prototype.ontouchmove=function(e){if(this._oMobifyCarousel){this._oMobifyCarousel.touchmove(e);}};
a.prototype.ontouchend=function(e){if(this._oMobifyCarousel){this._oMobifyCarousel.touchend(e);}};
a.prototype.onBeforeRendering=function(){var A=this.getActivePage();if(!A&&this.getPages().length>0){this.setAssociation("activePage",this.getPages()[0].getId(),true);}if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}return this;};
a.prototype.onAfterRendering=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.unbind();}this.$().carousel();this._oMobifyCarousel=this.getDomRef()._carousel;this._oMobifyCarousel.setLoop(this.getLoop());this._oMobifyCarousel.setRTL(sap.ui.getCore().getConfiguration().getRTL());var A=this.getActivePage();if(A){var i=this._getPageNumber(A);if(isNaN(i)||i==0){if(this.getPages().length>0){this.setAssociation("activePage",this.getPages()[0].getId(),true);this._adjustHUDVisibility(1);}}else{var c=sap.ui.getCore();if(c.isThemeApplied()){this._moveToPage(i+1);}else{c.attachThemeChanged(this._handleThemeLoad,this);}if(sap.zen&&sap.zen.commons&&this.getParent()instanceof sap.zen.commons.layout.PositionContainer){if(this._isCarouselUsedWithCommonsLayout===undefined){q.sap.delayedCall(0,this,"invalidate");this._isCarouselUsedWithCommonsLayout=true;}}}}this.$().on('afterSlide',q.proxy(function(e,P,n){if(e.target!==this.getDomRef()){return;}if(n>0){this._changePage(n);}},this));this._$InnerDiv=this.$().find(a._INNER_SELECTOR)[0];this._sResizeListenerId=sap.ui.core.ResizeHandler.register(this._$InnerDiv,this._fnAdjustAfterResize);this.$().find('.sapMCrslItemTableCell').focus(function(e){e.preventDefault();q(e.target).parents('.sapMCrsl').focus();return false;});var s='sap.m.IconTabBar';var p=this.getParent();while(p){if(p.getMetadata().getName()==s){var t=this;p.attachExpand(function(e){var E=e.getParameter('expand');if(E&&i>0){t._moveToPage(i+1);}});break;}p=p.getParent();}};
a.prototype._handleThemeLoad=function(){var c,A=this.getActivePage();if(A){var i=this._getPageNumber(A);if(i>0){this._moveToPage(i+1);}}c=sap.ui.getCore();c.detachThemeChanged(this._handleThemeLoad,this);};
a.prototype._moveToPage=function(i){this._oMobifyCarousel.changeAnimation('sapMCrslNoTransition');this._oMobifyCarousel.move(i);this._changePage(i);};
a.prototype._changePage=function(n){this._adjustHUDVisibility(n);var o=this.getActivePage();var N=this.getPages()[n-1].getId();this.setAssociation("activePage",N,true);var t=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("CAROUSEL_PAGE_INDICATOR_TEXT");var i=this.getId()+'-'+'slide-number';var s=n+' '+t+' '+this.getPages().length;q.sap.log.debug("sap.m.Carousel: firing pageChanged event: old page: "+o+", new page: "+N);this.firePageChanged({oldActivePageId:o,newActivePageId:N});if(document.getElementById(i)){document.getElementById(i).innerHTML=s;}};
a.prototype._adjustHUDVisibility=function(n){if(sap.ui.Device.system.desktop&&!this.getLoop()&&this.getPages().length>1){var h=this.$('hud');h.removeClass(a._LATERAL_CLASSES);if(n===1){h.addClass(a._LEFTMOST_CLASS);}else if(n===this.getPages().length){h.addClass(a._RIGHTMOST_CLASS);}}};
a.prototype.setActivePage=function(p){var P=null;if(typeof(p)=='string'){P=p;}else if(p instanceof C){P=p.getId();}if(P){if(P===this.getActivePage()){return this;}var i=this._getPageNumber(P);if(!isNaN(i)){if(this._oMobifyCarousel){this._oMobifyCarousel.move(i+1);}}}this.setAssociation("activePage",P,true);return this;};
a.prototype.setHeight=function(h){this.setProperty("height",h,true);this.$().css("height",h);return this;};
a.prototype.setWidth=function(w){this.setProperty("width",w,true);this.$().css("width",w);return this;};
a.prototype.setLoop=function(L){this.setProperty("loop",L,true);if(this._oMobifyCarousel){this._oMobifyCarousel.setLoop(L);}return this;};
a.prototype._getNavigationArrow=function(n){q.sap.require("sap.ui.core.IconPool");var p={src:"sap-icon://slim-arrow-"+n,useIconTooltip:false};if(n==="left"){if(!this._oArrowLeft){this._oArrowLeft=sap.m.ImageHelper.getImageControl(this.getId()+"-arrowScrollLeft",this._oArrowLeft,this,p);}return this._oArrowLeft;}else if(n==="right"){if(!this._oArrowRight){this._oArrowRight=sap.m.ImageHelper.getImageControl(this.getId()+"-arrowScrollRight",this._oArrowRight,this,p);}return this._oArrowRight;}};
a.prototype._createScrollContainer=function(p){var i;var s=sap.ui.Device.system.desktop&&this.getArrowsPlacement()===sap.m.CarouselArrowsPlacement.PageIndicator;if(s){i="sapMCrslImg";}else{i="sapMCrslImgNoArrows";}var c=p instanceof sap.m.Image?"sapMCrslItemTableCell "+i:"sapMCrslItemTableCell",o=new sap.ui.core.HTML({content:"<div class='sapMCrslItemTable'>"+"<div class='"+c+"'></div>"+"</div>",afterRendering:function(e){var r=sap.ui.getCore().createRenderManager();r.render(p,this.getDomRef().firstChild);r.destroy();}});var S=new sap.m.ScrollContainer({horizontal:false,vertical:false,content:[o],width:'100%',height:'100%'});S.setParent(this,null,true);this._aScrollContainers.push(S);return S;};
a.prototype.previous=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.prev();}else{q.sap.log.warning("Unable to execute sap.m.Carousel.previous: carousel must be rendered first.");}return this;};
a.prototype.next=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.next();}else{q.sap.log.warning("Unable to execute sap.m.Carousel.next: carousel must be rendered first.");}return this;};
a.prototype._getPageNumber=function(p){var i,r;for(i=0;i<this.getPages().length;i++){if(this.getPages()[i].getId()==p){r=i;break;}}return r;};
a.prototype.onsaptabprevious=function(e){this._bDirection=false;this._fnOnTabPress(e);};
a.prototype.onsaptabnext=function(e){this._bDirection=true;this._fnOnTabPress(e);};
a.prototype.onfocusin=function(e){this.saveLastFocusReference(e);this._bDirection=undefined;};
a.prototype.onsapskipforward=function(e){e.preventDefault();this._handleGroupNavigation(e,false);};
a.prototype.onsapskipback=function(e){e.preventDefault();this._handleGroupNavigation(e,true);};
a.prototype.onkeydown=function(e){if(e.keyCode==q.sap.KeyCodes.F7){this._handleF7Key(e);return;}if(e.target!=this.getDomRef()){return;}switch(e.keyCode){case 189:case q.sap.KeyCodes.NUMPAD_MINUS:this._fnSkipToIndex(e,-1);break;case q.sap.KeyCodes.PLUS:case q.sap.KeyCodes.NUMPAD_PLUS:this._fnSkipToIndex(e,1);break;}};
a.prototype.onsapescape=function(e){var b;if(e.target===this.$()[0]&&this._lastActivePageNumber){b=this._lastActivePageNumber+1;this._oMobifyCarousel.move(b);this._changePage(b);}};
a.prototype.onsapright=function(e){this._fnSkipToIndex(e,1);};
a.prototype.onsapup=function(e){this._fnSkipToIndex(e,-1);};
a.prototype.onsapleft=function(e){this._fnSkipToIndex(e,-1);};
a.prototype.onsapdown=function(e){this._fnSkipToIndex(e,1);};
a.prototype.onsaphome=function(e){this._fnSkipToIndex(e,0);};
a.prototype.onsapend=function(e){this._fnSkipToIndex(e,this.getPages().length);};
a.prototype.onsaprightmodifiers=function(e){if(e.ctrlKey){this._fnSkipToIndex(e,a._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
a.prototype.onsapupmodifiers=function(e){if(e.ctrlKey){this._fnSkipToIndex(e,a._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
a.prototype.onsappageup=function(e){this._fnSkipToIndex(e,a._MODIFIERNUMBERFORKEYBOARDHANDLING);};
a.prototype.onsapleftmodifiers=function(e){if(e.ctrlKey){this._fnSkipToIndex(e,-a._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
a.prototype.onsapdownmodifiers=function(e){if(e.ctrlKey){this._fnSkipToIndex(e,-a._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
a.prototype.onsappagedown=function(e){this._fnSkipToIndex(e,-a._MODIFIERNUMBERFORKEYBOARDHANDLING);};
a.prototype._fnOnTabPress=function(e){if(e.target===this.$()[0]){this._lastActivePageNumber=this._getPageNumber(this.getActivePage());}};
a.prototype._handleGroupNavigation=function(e,s){var E=q.Event("keydown");e.preventDefault();this.$().focus();E.target=e.target;E.keyCode=q.sap.KeyCodes.F6;E.shiftKey=s;q.sap.handleF6GroupNavigation(E);};
a.prototype.saveLastFocusReference=function(e){if(this._bDirection===undefined){return;}if(this._lastFocusablePageElement===undefined){this._lastFocusablePageElement={};}this._lastFocusablePageElement[this.getActivePage()]=e.target;};
a.prototype._getActivePageLastFocusedElement=function(){if(this._lastFocusablePageElement){return this._lastFocusablePageElement[this.getActivePage()];}};
a.prototype._fnSkipToIndex=function(e,n){var b=n;if(e.target!==this.getDomRef()){return;}e.preventDefault();if(n!==0){b=this._getPageNumber(this.getActivePage())+1+n;}this._oMobifyCarousel.move(b);};
a.prototype._handleF7Key=function(e){var A;e.preventDefault();A=this._getActivePageLastFocusedElement();if(e.target===this.$()[0]&&A){A.focus();}else{this.$().focus();}};
a.prototype.setShowBusyIndicator=function(){q.sap.log.warning("sap.m.Carousel: Deprecated function 'setShowBusyIndicator' called. Does nothing.");return this;};
a.prototype.getShowBusyIndicator=function(){q.sap.log.warning("sap.m.Carousel: Deprecated function 'getShowBusyIndicator' called. Does nothing.");return false;};
a.prototype.setBusyIndicatorSize=function(){q.sap.log.warning("sap.m.Carousel: Deprecated function 'setBusyIndicatorSize' called. Does nothing.");return this;};
a.prototype.getBusyIndicatorSize=function(){q.sap.log.warning("sap.m.Carousel: Deprecated function 'getBusyIndicatorSize' called. Does nothing.");return"";};
return a;},true);
sap.ui.predefine('sap/m/CarouselRenderer',['jquery.sap.global'],function(q){"use strict";var C={};
C.render=function(r,c){var p=c.getPages(),P=p.length,s=c.getPageIndicatorPlacement(),a=c.getArrowsPlacement(),i=c.getId(),b=sap.m.Carousel._BULLETS_TO_NUMBERS_THRESHOLD,I=c._getPageNumber(c.getActivePage());this._renderOpeningDiv(r,c);if(s===sap.m.PlacementType.Top){this._renderPageIndicatorAndArrows({rm:r,iPageCount:P,sId:i,iIndex:I,iBulletsToNumbersThreshold:b,sArrowsPlacement:a,bBottom:false,bShowPageIndicator:c.getShowPageIndicator()},c);}this._renderInnerDiv(r,c,p,s);if(sap.ui.Device.system.desktop&&P>1&&a===sap.m.CarouselArrowsPlacement.Content){this._renderHudArrows(r,c);}if(s===sap.m.PlacementType.Bottom){this._renderPageIndicatorAndArrows({rm:r,iPageCount:P,sId:i,iIndex:I,iBulletsToNumbersThreshold:b,sArrowsPlacement:a,bBottom:true,bShowPageIndicator:c.getShowPageIndicator()},c);}this._renderClosingDiv(r);};
C._renderOpeningDiv=function(r,c){var t=c.getTooltip_AsString();r.write("<div");r.writeControlData(c);r.writeAttribute("data-sap-ui-customfastnavgroup","true");r.addStyle("width",c.getWidth());r.addStyle("height",c.getHeight());r.writeStyles();r.addClass("sapMCrsl");r.addClass("sapMCrslFluid");r.writeClasses();if(t){r.writeAttributeEscaped("title",t);}r.writeAttributeEscaped("tabindex","0");r.writeAccessibilityState(c,{role:"list"});r.write(">");};
C._renderInnerDiv=function(r,c,p,P){r.write("<div class='sapMCrslInner");c._cleanUpScrollContainer();if(p.length>1&&(c.getShowPageIndicator()||c.getArrowsPlacement()===sap.m.CarouselArrowsPlacement.PageIndicator)){if(P===sap.m.PlacementType.Bottom){r.write(" sapMCrslBottomOffset");if(c.getArrowsPlacement()===sap.m.CarouselArrowsPlacement.PageIndicator){r.write(" sapMCrslBottomArrowsOffset");}}else{r.write(" sapMCrslTopOffset");if(c.getArrowsPlacement()===sap.m.CarouselArrowsPlacement.PageIndicator){r.write(" sapMCrslTopArrowsOffset");}}}r.write("'>");var R=function(o,i,a){r.write("<div class='sapMCrslItem");r.write("' id='"+c.sId+"-"+o.sId+"-slide'");r.writeAccessibilityState(o,{role:"listitem",posinset:i+1,setsize:a.length});r.write(">");r.renderControl(c._createScrollContainer(o,i));r.write("</div>");};p.forEach(R);r.write("</div>");};
C._renderClosingDiv=function(r){r.write('</div>');};
C._renderPageIndicatorAndArrows=function(s,c){var r=s.rm,p=s.iPageCount,S=sap.ui.Device.system.desktop&&s.sArrowsPlacement===sap.m.CarouselArrowsPlacement.PageIndicator,b=s.bBottom,I=s.sId,a=s.iIndex,B=s.iBulletsToNumbersThreshold,d=s.bShowPageIndicator,P=d?'':'opacity: 0',R=sap.ui.getCore().getLibraryResourceBundle('sap.m'),o="",t=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("CAROUSEL_PAGE_INDICATOR_TEXT");if(p<=1){return;}if(!d&&!S){return;}if(b){o+=" sapMCrslControlsBottom";}else{o+=" sapMCrslControlsTop";}if(S){r.write('<div');r.addClass("sapMCrslControls");r.addClass(o);r.writeClasses();r.write('>');r.write('<div class="sapMCrslControlsContainer'+o+'">');}else{r.write('<div class="sapMCrslControlsNoArrows'+o+'">');}if(S){this._renderPrevArrow(r,c);}var e=I+'-pageIndicator';r.write('<div id="'+e+'" style="'+P+'"');if(p<B){r.write(' class="sapMCrslBulleted">');for(var i=1;i<=p;i++){r.write("<span role='img' data-slide="+i+" aria-label='"+R.getText('CAROUSEL_POSITION',[i,p])+"'>"+i+"</span>");}}else{r.write(' class="sapMCrslNumeric">');r.write('<span id='+I+'-'+'slide-number>'+(a+1)+' '+t+' '+p+'</span>');}r.write('</div>');if(S){this._renderNextArrow(r,c);}if(!S){r.write('</div>');}if(S){r.write('</div>');r.write('</div>');}};
C._renderHudArrows=function(r,c){var a;if(c.getShowPageIndicator()){if(c.getPageIndicatorPlacement()===sap.m.PlacementType.Top){a="sapMCrslHudTop";}else if(c.getPageIndicatorPlacement()===sap.m.PlacementType.Bottom){a="sapMCrslHudBottom";}}else{a="sapMCrslHudMiddle";}var h=c.getId()+'-hud';r.write('<div id="'+h+'" class="sapMCrslHud '+a+'">');this._renderPrevArrow(r,c);this._renderNextArrow(r,c);r.write("</div>");};
C._renderPrevArrow=function(r,c){r.write("<a class='sapMCrslPrev' href='#' data-slide='prev' tabindex='-1'><div class='sapMCrslArrowInner'>");r.renderControl(c._getNavigationArrow('left'));r.write("</div></a>");};
C._renderNextArrow=function(r,c){r.write("<a class='sapMCrslNext' href='#' data-slide='next' tabindex='-1'><div class='sapMCrslArrowInner'>");r.renderControl(c._getNavigationArrow('right'));r.write("</div></a>");};
return C;},true);
sap.ui.predefine('sap/m/CheckBox',['jquery.sap.global','./Label','./library','sap/ui/Device','sap/ui/core/Control',"sap/ui/core/IconPool",'sap/ui/core/EnabledPropagator'],function(q,L,l,D,C,I,E){"use strict";
var a=C.extend("sap.m.CheckBox",{metadata:{library:"sap.m",properties:{selected:{type:"boolean",group:"Data",defaultValue:false},enabled:{type:"boolean",group:"Behavior",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Appearance",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:sap.ui.core.TextAlign.Begin},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},activeHandling:{type:"boolean",group:"Misc",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:sap.ui.core.ValueState.None}},aggregations:{_label:{type:"sap.m.Label",group:"Behavior",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{parameters:{selected:{type:"boolean"}}}}}});
E.call(a.prototype);
a.prototype.init=function(){this.addActiveState(this);I.insertFontFaceStyle();};
a.prototype.onAfterRendering=function(){if(!this.getText()&&!this.$().attr("aria-labelledby")){this.$().attr("aria-label"," ");}};
a.prototype.exit=function(){this._oLabel=null;delete this._iTabIndex;};
a.prototype.setSelected=function(s){s=!!s;if(s==this.getSelected()){return this;}this.$("CbBg").toggleClass("sapMCbMarkChecked",s);this.$().attr("aria-checked",s);var c=this.getDomRef("CB");if(c){s?c.setAttribute('checked','checked'):c.removeAttribute('checked');}this.setProperty("selected",s,true);return this;};
a.prototype.setText=function(t){var o=this._getLabel(),h=!!t;this.setProperty("text",t,true);o.setText(t);this.$().toggleClass("sapMCbHasLabel",h);return this;};
a.prototype.setWidth=function(w){var o=this._getLabel();this.setProperty("width",w,true);o.setWidth(w);return this;};
a.prototype.setTextDirection=function(d){var o=this._getLabel();this.setProperty("textDirection",d,true);o.setTextDirection(d);return this;};
a.prototype.setTextAlign=function(A){var o=this._getLabel();this.setProperty("textAlign",A,true);o.setTextAlign(A);return this;};
a.prototype.addActiveState=function(c){if(D.os.blackberry){c.addDelegate({ontouchstart:function(e){q(c.getDomRef()).addClass("sapMActive");},ontouchend:function(e){q(c.getDomRef()).removeClass("sapMActive");}});}};
a.prototype.ontouchstart=function(e){e.originalEvent._sapui_handledByControl=true;};
a.prototype.ontap=function(e){if(this.getEnabled()&&this.getEditable()){this.$().focus();var s=!this.getSelected();this.setSelected(s);this.fireSelect({selected:s});e&&e.setMarked();}};
a.prototype.onsapspace=function(e){this.ontap(e);if(e){e.preventDefault();e.stopPropagation();}};
a.prototype.onsapenter=function(e){this.ontap(e);};
a.prototype.setTabIndex=function(t){this._iTabIndex=t;this.$("CbBg").attr("tabindex",t);return this;};
a.prototype.getTabIndex=function(){if(this.hasOwnProperty("_iTabIndex")){return this._iTabIndex;}return this.getEnabled()?0:-1;};
a.prototype._getLabel=function(){if(!this._oLabel){this._oLabel=new L(this.getId()+"-label",{labelFor:this.getId()}).addStyleClass("sapMCbLabel");this.setAggregation("_label",this._oLabel,true);}return this.getAggregation("_label");};
a.prototype.getAccessibilityInfo=function(){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");return{role:"checkbox",type:b.getText("ACC_CTR_TYPE_CHECKBOX"),description:(this.getText()||"")+(this.getSelected()?(" "+b.getText("ACC_CTR_STATE_CHECKED")):""),focusable:this.getEnabled(),enabled:this.getEnabled(),editable:this.getEditable()};};
return a;},true);
sap.ui.predefine('sap/m/CheckBoxRenderer',['jquery.sap.global','sap/ui/core/ValueState','sap/ui/core/ValueStateSupport'],function(q,V,a){"use strict";var C={};
C.render=function(r,c){var i=c.getId(),e=c.getEnabled(),E=c.getEditable(),o=c.getAggregation("_label"),I=V.Error===c.getValueState(),b=V.Warning===c.getValueState();r.write("<div");r.addClass("sapMCb");if(!E){r.addClass("sapMCbRo");}if(!e){r.addClass("sapMCbBgDis");}if(I){r.addClass("sapMCbErr");}else if(b){r.addClass("sapMCbWarn");}if(c.getText()){r.addClass("sapMCbHasLabel");}r.writeControlData(c);r.writeClasses();var t=a.enrichTooltip(c,c.getTooltip_AsString());if(t){r.writeAttributeEscaped("title",t);}if(e){r.writeAttribute("tabindex",c.getTabIndex());}r.writeAccessibilityState(c,{role:"checkbox",selected:null,checked:c.getSelected(),describedby:t?i+"-Descr":undefined});r.write(">");r.write("<div id='");r.write(c.getId()+"-CbBg'");r.addClass("sapMCbBg");if(e&&E&&sap.ui.Device.system.desktop){r.addClass("sapMCbHoverable");}if(!c.getActiveHandling()){r.addClass("sapMCbActiveStateOff");}r.addClass("sapMCbMark");if(c.getSelected()){r.addClass("sapMCbMarkChecked");}r.writeClasses();r.write(">");r.write("<input type='CheckBox' id='");r.write(c.getId()+"-CB'");if(c.getSelected()){r.writeAttribute("checked","checked");}if(c.getName()){r.writeAttributeEscaped('name',c.getName());}if(!e){r.write(" disabled=\"disabled\"");}if(!E){r.write(" readonly=\"readonly\"");}r.write(" /></div>");r.renderControl(o);if(t&&sap.ui.getCore().getConfiguration().getAccessibility()){r.write("<span id=\""+i+"-Descr\" class=\"sapUiHidden\">");r.writeEscaped(t);r.write("</span>");}r.write("</div>");};
return C;},true);
sap.ui.predefine('sap/m/Column',['jquery.sap.global','./library','sap/ui/core/Element','sap/ui/core/Renderer'],function(q,l,E,R){"use strict";
var C=E.extend("sap.m.Column",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},hAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:sap.ui.core.TextAlign.Begin},vAlign:{type:"sap.ui.core.VerticalAlign",group:"Appearance",defaultValue:sap.ui.core.VerticalAlign.Inherit},styleClass:{type:"string",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true},minScreenWidth:{type:"string",group:"Behavior",defaultValue:null},demandPopin:{type:"boolean",group:"Behavior",defaultValue:false},popinHAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:sap.ui.core.TextAlign.Begin,deprecated:true},popinDisplay:{type:"sap.m.PopinDisplay",group:"Appearance",defaultValue:sap.m.PopinDisplay.Block},mergeDuplicates:{type:"boolean",group:"Behavior",defaultValue:false},mergeFunctionName:{type:"string",group:"Misc",defaultValue:'getText'}},defaultAggregation:"header",aggregations:{header:{type:"sap.ui.core.Control",multiple:false},footer:{type:"sap.ui.core.Control",multiple:false}}}});
C.prototype._index=-1;C.prototype._screen="";C.prototype._media=null;
C.prototype.exit=function(){this._clearMedia();};
C.prototype._clearMedia=function(){if(this._media&&this._minWidth){sap.ui.Device.media.removeRangeSet(this.getId());this._media=null;}};
C.prototype._addMedia=function(){if(this._minWidth){sap.ui.Device.media.initRangeSet(this.getId(),[parseFloat(this._minWidth)]);sap.ui.Device.media.attachHandler(this._notifyResize,this,this.getId());this._media=sap.ui.Device.media.getCurrentRange(this.getId());if(this._media){this._media.triggered=false;this._media.matches=!!this._media.from;}}};
C.prototype._notifyResize=function(m){if(!this._media.triggered){this._media.triggered=true;return;}this._media=m;this._media.triggered=true;this._media.matches=!!m.from;q.sap.delayedCall(0,this,function(){var p=this.getParent();this.fireEvent("media",this);if(p&&p.onColumnResize){p.onColumnResize(this);}});};
C.prototype._validateMinWidth=function(w){if(!w){return;}if(Object.prototype.toString.call(w)!="[object String]"){throw new Error('expected string for property "minScreenWidth" of '+this);}if(Object.keys(sap.m.ScreenSizes).indexOf(w.toLowerCase())!=-1){return;}if(!/^\d+(\.\d+)?(px|em|rem)$/i.test(w)){throw new Error('invalid CSS size("px", "em", "rem" required) or sap.m.ScreenSize enumeration for property "minScreenWidth" of '+this);}};
C.prototype._isWidthPredefined=function(w){var t=this,u=w.replace(/[^a-z]/ig,""),b=parseFloat(sap.m.BaseFontSize)||16;q.each(sap.m.ScreenSizes,function(s,a){if(u!="px"){a/=b;}if(a+u==w){t._minWidth=this+"px";t._screen=s;return false;}});if(this._minWidth){return true;}if(u=="px"){this._minWidth=w;}else{this._minWidth=parseFloat(w)*b+"px";}};
C.prototype.applyAlignTo=function(c,a){a=a||this.getHAlign();if(a===sap.ui.core.TextAlign.Initial||!c.getMetadata().getProperties().textAlign||c.getTextAlign()===a){return c;}c.setProperty("textAlign",a,true);var d=c.getDomRef();a=this.getCssAlign(a);if(d&&a){d.style.textAlign=a;}return c;};
C.prototype.getCssAlign=function(a){a=a||this.getHAlign();var t=sap.ui.core.TextAlign;if(a===t.Begin||a===t.End||a===t.Initial){a=R.getTextAlign(a);}return a.toLowerCase();};
C.prototype.getStyleClass=function(r){var c=this.getProperty("styleClass");if(!r){return c;}if(this._screen&&(!this.getDemandPopin()||!window.matchMedia)){c+=" sapMSize-"+this._screen;}else if(this._media&&!this._media.matches){c+=" sapMListTblNone";}return c.trim();};
C.prototype.setIndex=function(n){this._index=+n;};
C.prototype.setOrder=function(n){this._order=+n;};
C.prototype.getOrder=function(){return this.hasOwnProperty("_order")?this._order:this.getInitialOrder();};
C.prototype.setInitialOrder=function(n){this._initialOrder=+n;};
C.prototype.getInitialOrder=function(){if(this.hasOwnProperty("_initialOrder")){return this._initialOrder;}var p=this.getParent();if(p&&p.indexOfColumn){return p.indexOfColumn(this);}return-1;};
C.prototype.setDisplay=function(t,d){if(!t||this._index<0){return;}var i=this._index+1,p=this.getParent(),a=d?"table-cell":"none",h=t.querySelector("tr > th:nth-child("+i+")"),c=t.querySelectorAll("tr > td:nth-child("+i+")"),b=c.length;h.style.display=a;h.setAttribute("aria-hidden",!d);for(i=0;i<b;i++){c[i].style.display=a;c[i].setAttribute("aria-hidden",!d);}if(p&&p.setTableHeaderVisibility){setTimeout(function(){p.setTableHeaderVisibility(d);},0);}};
C.prototype.setDisplayViaMedia=function(t){var p=this.getParent(),d=this._media&&this._media.matches;if(!this.getDemandPopin()&&this._screen&&p&&p.setTableHeaderVisibility){setTimeout(function(){p.setTableHeaderVisibility(d);},0);}else{this.setDisplay(t,d);}};
C.prototype.setVisible=function(v){if(v==this.getVisible()){return this;}var p=this.getParent(),t=p&&p.getTableDomRef&&p.getTableDomRef(),s=t&&this._index>=0;this.setProperty("visible",v,s);if(s){this.setDisplay(t,v);}return this;};
C.prototype.setMinScreenWidth=function(w){if(w==this.getMinScreenWidth()){return this;}this._validateMinWidth(w);this._clearMedia();this._minWidth=0;this._screen="";if(w){w=w.toLowerCase();var a=sap.m.ScreenSizes[w];if(a){this._screen=w;this._minWidth=a+"px";}else{this._isWidthPredefined(w);}this._addMedia();}return this.setProperty("minScreenWidth",w);};
C.prototype.setDemandPopin=function(v){if(v==this.getDemandPopin()){return this;}if(!this.getMinScreenWidth()){return this.setProperty("demandPopin",v,true);}return this.setProperty("demandPopin",v);};
C.prototype.isPopin=function(){if(!this.getDemandPopin()){return false;}if(this._media){return!this._media.matches;}return false;};
C.prototype.isHidden=function(){if(this._media){return!this._media.matches;}if(this._screen&&this._minWidth){return parseFloat(this._minWidth)>window.innerWidth;}return false;};
C.prototype.setLastValue=function(v){if(this.getMergeDuplicates()){this._lastValue=v;}return this;};
C.prototype.clearLastValue=function(){return this.setLastValue(NaN);};
C.prototype.getLastValue=function(){return this._lastValue;};
C.prototype.onItemsRemoved=function(){this.clearLastValue();};
return C;},true);
sap.ui.predefine('sap/m/ColumnListItem',['jquery.sap.global','sap/ui/core/Element','./ListItemBase','./library'],function(q,E,L,l){"use strict";
var C=L.extend("sap.m.ColumnListItem",{metadata:{library:"sap.m",properties:{vAlign:{type:"sap.ui.core.VerticalAlign",group:"Appearance",defaultValue:sap.ui.core.VerticalAlign.Inherit}},defaultAggregation:"cells",aggregations:{cells:{type:"sap.ui.core.Control",multiple:true,singularName:"cell",bindable:"bindable"}}}});
var T=E.extend("sap.m.TablePopin",{onfocusin:function(e){if(e.srcControl===this||!q(e.target).is(":sapFocusable")){this.getParent().focus();}}});
C.prototype.init=function(){L.prototype.init.call(this);this._bNeedsTypeColumn=false;this._aClonedHeaders=[];};
C.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.call(this);this._checkTypeColumn();};
C.prototype.exit=function(){L.prototype.exit.call(this);this._checkTypeColumn(false);this._destroyClonedHeaders();if(this._oPopin){this._oPopin.destroy(true);this._oPopin=null;}};
C.prototype.setVisible=function(v){L.prototype.setVisible.call(this,v);if(!v&&this.hasPopin()){this.removePopin();}return this;};
C.prototype.getTable=function(){var p=this.getParent();if(p instanceof sap.m.Table){return p;}if(p&&p.getMetadata().getName()=="sap.m.Table"){return p;}};
C.prototype.getPopin=function(){if(!this._oPopin){this._oPopin=new T({id:this.getId()+"-sub"}).addEventDelegate({ontouchstart:this.ontouchstart,ontouchmove:this.ontouchmove,ontap:this.ontap,ontouchend:this.ontouchend,ontouchcancel:this.ontouchcancel,onsaptabnext:this.onsaptabnext,onsaptabprevious:this.onsaptabprevious,onsapup:this.onsapup,onsapdown:this.onsapdown},this).setParent(this,null,true);}return this._oPopin;};
C.prototype.$Popin=function(){return this.$("sub");};
C.prototype.hasPopin=function(){return!!(this._oPopin&&this.getTable().hasPopin());};
C.prototype.removePopin=function(){this._oPopin&&this.$Popin().remove();};
C.prototype.getTabbables=function(){return this.$().add(this.$Popin()).find(":sapTabbable");};
C.prototype.updateSelectedDOM=function(s,t){L.prototype.updateSelectedDOM.apply(this,arguments);t.children().attr("aria-selected",s);if(this.hasPopin()){this.$Popin().attr("aria-selected",s);this.$("subcell").attr("aria-selected",s);}};
C.prototype._checkTypeColumn=function(n){if(n==undefined){n=this._needsTypeColumn();}if(this._bNeedsTypeColumn!=n){this._bNeedsTypeColumn=n;this.informList("TypeColumnChange",n);}};
C.prototype._needsTypeColumn=function(){var t=this.getType(),m=sap.m.ListType;return this.getVisible()&&(t==m.Detail||t==m.Navigation||t==m.DetailAndActive);};
sap.m.ColumnListItem.prototype._addClonedHeader=function(h){return this._aClonedHeaders.push(h);};
sap.m.ColumnListItem.prototype._destroyClonedHeaders=function(){if(this._aClonedHeaders.length){this._aClonedHeaders.forEach(function(c){c.destroy("KeepDom");});this._aClonedHeaders=[];}};
C.prototype._activeHandlingInheritor=function(){this._toggleActiveClass(true);};
C.prototype._inactiveHandlingInheritor=function(){this._toggleActiveClass(false);};
C.prototype._toggleActiveClass=function(s){if(this.hasPopin()){this.$Popin().toggleClass("sapMLIBActive",s);}};
return C;},true);
sap.ui.predefine('sap/m/ColumnListItemRenderer',['jquery.sap.global','./ListItemBaseRenderer','./ListRenderer','sap/ui/core/Renderer'],function(q,L,a,R){"use strict";var C=R.extend(L);
C.isTextualControl=function(c){var m=[sap.m.Text,sap.m.Label,sap.m.Link,sap.m.Title];return m.some(function(f){return f&&c instanceof f;});};
C.render=function(r,l){var t=l.getTable();if(!t){return;}L.render.apply(this,arguments);if(l.getVisible()&&t.hasPopin()){this.renderPopin(r,l,t);}};
C.openItemTag=function(r,l){r.write("<tr");};
C.closeItemTag=function(r,l){r.write("</tr>");};
C.handleNoFlex=function(r,l){};
C.renderType=function(r,l){r.write('<td role="gridcell" class="sapMListTblNavCol"');this.writeAriaSelected(r,l);if(!l._needsTypeColumn()){r.writeAttribute("aria-hidden","true");}r.write('>');L.renderType.apply(this,arguments);r.write('</td>');};
C.renderModeContent=function(r,l){r.write('<td role="gridcell" class="sapMListTblSelCol"');this.writeAriaSelected(r,l);r.write('>');L.renderModeContent.apply(this,arguments);r.write('</td>');};
C.renderCounter=function(r,l){};
C.getAriaRole=function(l){return"row";};
C.getAriaLabelledBy=function(l){var t=l.getTable(),A=L.getAriaLabelledBy.call(this,l)||"";if(!t||!t.hasPopin()){return A;}var i=l.getId();if(!A){A=i;}else if(A.indexOf(i)==-1){A=i+" "+A;}return A+" "+i+"-sub";};
C.writeAriaSelected=function(r,l){if(l.isSelectable()){r.writeAttribute("aria-selected",l.getProperty("selected"));}};
C.renderLIAttributes=function(r,l){r.addClass("sapMListTblRow");var A=l.getVAlign();if(A!=sap.ui.core.VerticalAlign.Inherit){r.addClass("sapMListTblRow"+A);}};
C.renderLIContentWrapper=function(r,l){var t=l.getTable();if(!t){return;}var c=t.getColumns(true),b=l.getCells(),s=l.isSelectable(),S=l.getProperty("selected");l._destroyClonedHeaders();c.forEach(function(o,i){var d,h,e=true,f=b[o.getInitialOrder()];if(!f||!o.getVisible()||o.isPopin()){o.setIndex(-1);return;}r.write("<td");r.addClass("sapMListTblCell");r.writeAttribute("id",l.getId()+"_cell"+i);r.writeAttribute("role","gridcell");if(s){r.writeAttribute("aria-selected",S);}if(o){d=o.getStyleClass(true);d&&r.addClass(q.sap.encodeHTML(d));h=o.getHeader();if(h){r.writeAttribute("aria-describedby",h.getId());}if(!t.hasPopin()&&o.getMergeDuplicates()){var F=o.getMergeFunctionName(),g=F.split("#"),j=g[1],k=g[0];if(typeof f[k]!="function"){q.sap.log.warning("mergeFunctionName property is defined on "+o+" but this is not function of "+f);}else{var m=o.getLastValue(),n=f[k](j);if(m===n){e=sap.ui.getCore().getConfiguration().getAccessibility();f.addStyleClass("sapMListTblCellDupCnt");r.addClass("sapMListTblCellDup");}else{o.setLastValue(n);}}}o.getVAlign()!="Inherit"&&r.addStyle("vertical-align",o.getVAlign().toLowerCase());var A=o.getCssAlign();if(A){r.addStyle("text-align",A);}r.writeStyles();}r.writeClasses();r.write(">");if(e){this.applyAriaLabelledBy(h,f);r.renderControl(o.applyAlignTo(f));}r.write("</td>");},this);};
C.applyAriaLabelledBy=function(h,c){if(c){c.removeAssociation("ariaLabelledBy",c.data("ariaLabelledBy")||undefined,true);}if(h&&c.getAriaLabelledBy&&this.isTextualControl(h)&&c.getAriaLabelledBy().indexOf(h.getId())==-1){c.addAssociation("ariaLabelledBy",h,true);c.data("ariaLabelledBy",h.getId());}};
C.renderPopin=function(r,l,t){var s=l.getProperty("selected"),S=l.isSelectable();l.removePopin();r.write("<tr");r.addClass("sapMListTblSubRow");r.writeElementData(l.getPopin());r.writeAttribute("role","row");r.writeAttribute("tabindex","-1");if(S){r.writeAttribute("aria-selected",s);}r.writeAttribute("aria-owns",l.getId());r.writeClasses();r.write(">");r.write("<td");r.writeAttribute("id",l.getId()+"-subcell");r.writeAttribute("role","gridcell");r.writeAttribute("colspan",t.getColCount());if(S){r.writeAttribute("aria-selected",S);}r.write("><div class='sapMListTblSubCnt'>");var c=l.getCells(),b=t.getColumns(true);b.forEach(function(o){if(!o.getVisible()||!o.isPopin()){return;}var d=c[o.getInitialOrder()],h=o.getHeader();if(!h&&!d){return;}var e=o.getStyleClass(),p=o.getPopinDisplay();r.write("<div");r.addClass("sapMListTblSubCntRow");e&&r.addClass(q.sap.encodeHTML(e));r.writeClasses();r.write(">");if(h&&p!=sap.m.PopinDisplay.WithoutHeader){r.write("<div");r.addClass("sapMListTblSubCntHdr");r.writeClasses();r.write(">");h=h.clone();o.addDependent(h);l._addClonedHeader(h);o.applyAlignTo(h,"Begin");r.renderControl(h);r.write("</div>");r.write("<div class='sapMListTblSubCntSpr'>:</div>");}if(d){r.write("<div");r.addClass("sapMListTblSubCntVal");r.addClass("sapMListTblSubCntVal"+p);r.writeClasses();r.write(">");o.applyAlignTo(d,"Begin");this.applyAriaLabelledBy(h,d);r.renderControl(d);r.write("</div>");}r.write("</div>");},this);r.write("</div></td></tr>");};
C.addLegacyOutlineClass=function(r,l){if(sap.ui.Device.browser.msie){r.addClass("sapMLIBNativeOutline");}};
return C;},true);
sap.ui.predefine('sap/m/ComboBox',['jquery.sap.global','./ComboBoxTextField','./ComboBoxBase','./ComboBoxRenderer','./Popover','./SelectList','./Dialog','./Toolbar','./Button','./library','sap/ui/Device'],function(q,C,a,b,P,S,D,T,B,l,c){"use strict";
var d=a.extend("sap.m.ComboBox",{metadata:{library:"sap.m",properties:{selectedKey:{type:"string",group:"Data",defaultValue:""},selectedItemId:{type:"string",group:"Misc",defaultValue:""},showSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false}},events:{selectionChange:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}}}});
function h(o,i){if(!i){return;}var e=o.getFocusDomRef(),g=e.selectionStart,j=e.selectionEnd,I=g!==j,t=e.value.substring(0,e.selectionStart),k=this.getSelectedItem();if(i!==k){o.updateDomValue(i.getText());this.setSelection(i);this.fireSelectionChange({selectedItem:i});i=this.getSelectedItem();if(!q.sap.startsWithIgnoreCase(i.getText(),t)||!I){g=0;}o.selectText(g,e.value.length);}this.scrollToItem(i);}
function s(i,e){if(document.activeElement===this.getFocusDomRef()){this.selectText(i,e);}}
function f(i){var I=this.getSelectedItem(),o=I&&I.getDomRef(),e=I&&o.offsetTop,g=I&&o.offsetHeight,p=this.getPicker(),j=p.getDomRef("cont"),k=j.clientHeight;if(I&&((e+g)>(k))){if(!i){this.getList().$().css("visibility","hidden");}else{j.scrollTop=e-g/2;this.getList().$().css("visibility","visible");}}}
d.prototype._handleAriaActiveDescendant=function(i){var o=this.getFocusDomRef(),A="aria-activedescendant";if(o){if(i&&i.getDomRef()&&this.isOpen()){o.setAttribute(A,i.getId());}else{o.removeAttribute(A);}}};
d.prototype._getSelectedItemText=function(i){i=i||this.getSelectedItem();if(!i){i=this.getDefaultSelectedItem();}if(i){return i.getText();}return"";};
d.prototype._callMethodInControl=function(F,A){var L=this.getList();if(A[0]==="items"){if(L){return S.prototype[F].apply(L,A);}}else{return a.prototype[F].apply(this,A);}};
d.prototype._setItemVisibility=function(i,v){var o=i&&i.$(),e="sapMSelectListItemBaseInvisible";if(v){i.bVisible=true;o.length&&o.removeClass(e);}else{i.bVisible=false;o.length&&o.addClass(e);}};
d.prototype.setSelectedIndex=function(i,_){var I;_=_||this.getItems();i=(i>_.length-1)?_.length-1:Math.max(0,i);I=_[i];if(I){this.setSelection(I);}};
d.prototype.createDropdown=function(){var t=this;var p=new P({showHeader:false,placement:sap.m.PlacementType.VerticalPreferredBottom,offsetX:0,offsetY:0,initialFocus:this,bounce:false,showArrow:false});p.open=function(){return this.openBy(t);};return p;};
d.prototype.createPickerTextField=function(){var t=new C({width:"100%",showButton:false}).addEventDelegate({onsapenter:function(){this.updateDomValue(t.getValue());this.onChange();}},this);return t;};
d.prototype.init=function(){a.prototype.init.apply(this,arguments);this.bOpenValueStateMessage=true;this._sValueBeforeOpen="";this._oSelectedItemBeforeOpen=null;};
d.prototype.onBeforeRendering=function(){a.prototype.onBeforeRendering.apply(this,arguments);this.synchronizeSelection();};
d.prototype.exit=function(){a.prototype.exit.apply(this,arguments);this._oSelectedItemBeforeOpen=null;};
d.prototype.onBeforeRenderingPicker=function(){var o=this["onBeforeRendering"+this.getPickerType()];o&&o.call(this);};
d.prototype.onBeforeRenderingDropdown=function(){var p=this.getPicker(),w=(this.$().outerWidth()/parseFloat(sap.m.BaseFontSize))+"rem";if(p){p.setContentMinWidth(w);}};
d.prototype.onBeforeRenderingList=function(){if(this.bProcessingLoadItemsEvent){var L=this.getList(),F=this.getFocusDomRef();if(L){L.setBusy(true);}if(F){F.setAttribute("aria-busy","true");}}};
d.prototype.onAfterRenderingPicker=function(){var o=this["onAfterRendering"+this.getPickerType()];o&&o.call(this);f.call(this,false);};
d.prototype.onAfterRenderingList=function(){if(this.bProcessingLoadItemsEvent&&(this.getItems().length===0)){return;}var L=this.getList(),F=this.getFocusDomRef();if(L){L.setBusy(false);}if(F){F.removeAttribute("aria-busy");}};
d.prototype.onBeforeOpenDialog=function(){var p=this.getPickerTextField();this._oSelectedItemBeforeOpen=this.getSelectedItem();this._sValueBeforeOpen=this.getValue();if(this.getSelectedItem()){this.filterItems({property:"text",value:""});}p.setValue(this._sValueBeforeOpen);};
d.prototype.revertSelection=function(){var p,o=this.getPickerTextField();this.setSelectedItem(this._oSelectedItemBeforeOpen);this.setValue(this._sValueBeforeOpen);if(this.getSelectedItem()===null){p=this._sValueBeforeOpen;}else{p=this._oSelectedItemBeforeOpen.getText();}o&&o.setValue(p);};
d.prototype.oninput=function(e){a.prototype.oninput.apply(this,arguments);if(e.isMarked("invalid")){return;}var t=(this.getPickerType()==="Dropdown");this.loadItems(function(){var o=this.getSelectedItem(),v=e.target.value,E=v==="",g=e.srcControl,V;if(E&&!this.bOpenedByKeyboardOrButton){V=this.getItems();}else{V=this.filterItems({property:"text",value:v});}var i=!!V.length;var F=V[0];if(!E&&F&&F.getEnabled()){if(g._bDoTypeAhead){g.updateDomValue(F.getText());}this.setSelection(F);if(o!==this.getSelectedItem()){this.fireSelectionChange({selectedItem:this.getSelectedItem()});}if(g._bDoTypeAhead){setTimeout(s.bind(g,v.length,g.getValue().length),0);}}if(E||!i){this.setSelection(null);if(o!==this.getSelectedItem()){this.fireSelectionChange({selectedItem:this.getSelectedItem()});}}if(i){if(E&&!this.bOpenedByKeyboardOrButton){this.close();}else if(t){this.open();this.scrollToItem(this.getSelectedItem());}}else if(this.isOpen()){if(t){this.close();}}else{this.clearFilter();}},{name:"input",busyIndicator:false});if(this.bProcessingLoadItemsEvent&&t){this.open();}};
d.prototype.filterItems=function(o,I){var p=o.property,v=o.value,e=v==="",m=false,M="get"+p.charAt(0).toUpperCase()+p.slice(1),F=[],g=null;I=I||this.getItems();for(var i=0;i<I.length;i++){g=I[i];m=q.sap.startsWithIgnoreCase(g[M](),v)||e;if(m){F.push(g);}this._setItemVisibility(g,m);}return F;};
d.prototype.onSelectionChange=function(o){var i=o.getParameter("selectedItem"),t=c.system.tablet;this.setSelection(i);this.fireSelectionChange({selectedItem:this.getSelectedItem()});if(this.getPickerType()==="Dialog"||t){this.onChange();}};
d.prototype.onItemPress=function(o){var i=o.getParameter("item");this.close();this.updateDomValue(i.getText());this.setProperty("value",i.getText(),true);setTimeout(this.selectText.bind(this,this.getValue().length,this.getValue().length),0);};
d.prototype.onkeydown=function(e){var o=e.srcControl;a.prototype.onkeydown.apply(o,arguments);if(!o.getEnabled()||!o.getEditable()){return;}var k=q.sap.KeyCodes;o._bDoTypeAhead=(e.which!==k.BACKSPACE)&&(e.which!==k.DELETE);};
d.prototype.oncut=function(e){var o=e.srcControl;a.prototype.oncut.apply(o,arguments);o._bDoTypeAhead=false;};
d.prototype.onsapenter=function(e){var o=e.srcControl;a.prototype.onsapenter.apply(o,arguments);if(!o.getEnabled()||!o.getEditable()){return;}if(o.isOpen()){o.close();}};
d.prototype.onsapdown=function(e){var o=e.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}e.setMarked();e.preventDefault();this.loadItems(function navigateToNextSelectableItem(){var g=this.getSelectableItems();var n=g[g.indexOf(this.getSelectedItem())+1];h.call(this,o,n);});};
d.prototype.onsapup=function(e){var o=e.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}e.setMarked();e.preventDefault();this.loadItems(function navigateToPrevSelectableItem(){var g=this.getSelectableItems();var p=g[g.indexOf(this.getSelectedItem())-1];h.call(this,o,p);});};
d.prototype.onsaphome=function(e){var o=e.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}e.setMarked();e.preventDefault();this.loadItems(function navigateToFirstSelectableItem(){var F=this.getSelectableItems()[0];h.call(this,o,F);});};
d.prototype.onsapend=function(e){var o=e.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}e.setMarked();e.preventDefault();this.loadItems(function navigateToLastSelectableItem(){var L=this.findLastEnabledItem(this.getSelectableItems());h.call(this,o,L);});};
d.prototype.onsappagedown=function(e){var o=e.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}e.setMarked();e.preventDefault();this.loadItems(function(){var g=this.getSelectableItems(),i=g.indexOf(this.getSelectedItem())+10,I;i=(i>g.length-1)?g.length-1:Math.max(0,i);I=g[i];h.call(this,o,I);});};
d.prototype.onsappageup=function(e){var o=e.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}e.setMarked();e.preventDefault();this.loadItems(function(){var g=this.getSelectableItems(),i=g.indexOf(this.getSelectedItem())-10,I;i=(i>g.length-1)?g.length-1:Math.max(0,i);I=g[i];h.call(this,o,I);});};
d.prototype.onfocusin=function(e){var g=this.getPickerType()==="Dropdown";if(e.target===this.getOpenArea()){this.bOpenValueStateMessage=false;if(g){this.focus();}}else{if(g){setTimeout(function(){if(document.activeElement===this.getFocusDomRef()&&!this.bFocusoutDueRendering&&!this.getSelectedText()){this.selectText(0,this.getValue().length);}}.bind(this),0);}if(!this.isOpen()&&this.bOpenValueStateMessage&&this.shouldValueStateMessageBeOpened()){this.openValueStateMessage();}this.bOpenValueStateMessage=true;}this.$().addClass("sapMFocus");};
d.prototype.onsapfocusleave=function(e){var t,p,r,F,n;a.prototype.onsapfocusleave.apply(this,arguments);if(this.getPickerType()==="Dialog"){return;}p=this.getAggregation("picker");if(!e.relatedControlId||!p){return;}n=!c.system.combi;t=c.system.tablet&&n;r=sap.ui.getCore().byId(e.relatedControlId);F=r&&r.getFocusDomRef();if(q.sap.containsOrEquals(p.getFocusDomRef(),F)&&!t){this.focus();}};
d.prototype.setSelection=function(i){var L=this.getList(),k;if(L){L.setSelection(i);}this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",(i instanceof sap.ui.core.Item)?i.getId():i,true);if(typeof i==="string"){i=sap.ui.getCore().byId(i);}k=i?i.getKey():"";this.setProperty("selectedKey",k,true);this._handleAriaActiveDescendant(i);};
d.prototype.isSelectionSynchronized=function(){var i=this.getSelectedItem();return this.getSelectedKey()===(i&&i.getKey());};
d.prototype.synchronizeSelection=function(){if(this.isSelectionSynchronized()){return;}var k=this.getSelectedKey(),i=this.getItemByKey(""+k);if(i&&(k!=="")){this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",i.getId(),true);if(this._sValue===this.getValue()){this.setValue(i.getText());}}};
d.prototype.isFiltered=function(){var L=this.getList();return L&&(L.getVisibleItems().length!==L.getItems().length);};
d.prototype.isItemVisible=function(i){return i&&(i.bVisible===undefined||i.bVisible);};
d.prototype.createPicker=function(p){var o=this.getAggregation("picker");if(o){return o;}o=this["create"+p]();this.setAggregation("picker",o,true);var e=this.getRenderer().CSS_CLASS_COMBOBOXBASE;o.setHorizontalScrolling(false).addStyleClass(e+"Picker").addStyleClass(e+"Picker-CTX").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachBeforeClose(this.onBeforeClose,this).attachAfterClose(this.onAfterClose,this).addEventDelegate({onBeforeRendering:this.onBeforeRenderingPicker,onAfterRendering:this.onAfterRenderingPicker},this).addContent(this.createList());return o;};
d.prototype.createList=function(){var r=this.getRenderer();this._oList=new S({width:"100%",busyIndicatorDelay:0}).addStyleClass(r.CSS_CLASS_COMBOBOXBASE+"List").addStyleClass(r.CSS_CLASS_COMBOBOX+"List").addEventDelegate({ontap:function(e){this.close();},onBeforeRendering:this.onBeforeRenderingList,onAfterRendering:this.onAfterRenderingList},this).attachSelectionChange(this.onSelectionChange,this).attachItemPress(this.onItemPress,this);return this._oList;};
d.prototype.onBeforeOpen=function(){var p=this["onBeforeOpen"+this.getPickerType()],o=this.getFocusDomRef();if(this.hasLoadItemsEventListeners()&&!this.bProcessingLoadItemsEvent){this.loadItems();}this.addStyleClass(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Pressed");if(o){o.setAttribute("aria-owns",this.getList().getId());}this.addContent();p&&p.call(this);};
d.prototype.onBeforeOpenDropdown=function(){};
d.prototype.onAfterOpen=function(){var o=this.getFocusDomRef(),i=this.getSelectedItem();if(o){o.setAttribute("aria-expanded","true");i&&o.setAttribute("aria-activedescendant",i.getId());}f.call(this,true);};
d.prototype.onBeforeClose=function(){a.prototype.onBeforeClose.apply(this,arguments);var o=this.getFocusDomRef();if(o){o.removeAttribute("aria-owns");o.removeAttribute("aria-activedescendant");if(this.shouldValueStateMessageBeOpened()&&(document.activeElement===o)){this.openValueStateMessage();}}this.removeStyleClass(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Pressed");};
d.prototype.onAfterClose=function(){var o=this.getFocusDomRef();if(o){o.setAttribute("aria-expanded","false");}this.clearFilter();};
d.prototype.isItemSelected=function(i){return i&&(i.getId()===this.getAssociation("selectedItem"));};
d.prototype.getDefaultSelectedItem=function(){return null;};
d.prototype.clearSelection=function(){this.setSelection(null);};
d.prototype.onPropertyChange=function(o,e){var n=o.getParameter("newValue"),p=o.getParameter("name"),m="set"+p.charAt(0).toUpperCase()+p.slice(1),g=(e&&e.srcControl)||this.getPickerTextField();if(/\bvalue\b|\benabled\b|\bname\b|\bplaceholder\b|\beditable\b|\btextAlign\b|\btextDirection\b/.test(p)&&g&&(typeof g[m]==="function")){g[m](n);}};
d.prototype.onItemChange=function(o){var e=this.getAssociation("selectedItem"),n=o.getParameter("newValue"),p=o.getParameter("name");if(e===o.getParameter("id")){switch(p){case"text":if(!this.isBound("value")){this.setValue(n);}break;case"key":if(!this.isBound("selectedKey")){this.setSelectedKey(n);}break;}}};
d.prototype.selectText=function(i,e){a.prototype.selectText.apply(this,arguments);this.textSelectionStart=i;this.textSelectionEnd=e;return this;};
d.prototype.addAggregation=function(A,o,e){this._callMethodInControl("addAggregation",arguments);if(A==="items"&&!e&&!this.isInvalidateSuppressed()){this.invalidate(o);}return this;};
d.prototype.getAggregation=function(){return this._callMethodInControl("getAggregation",arguments);};
d.prototype.setAssociation=function(A,i,e){var L=this.getList();if(L&&(A==="selectedItem")){S.prototype.setAssociation.apply(L,arguments);}return a.prototype.setAssociation.apply(this,arguments);};
d.prototype.indexOfAggregation=function(){return this._callMethodInControl("indexOfAggregation",arguments);};
d.prototype.insertAggregation=function(){this._callMethodInControl("insertAggregation",arguments);return this;};
d.prototype.removeAggregation=function(){return this._callMethodInControl("removeAggregation",arguments);};
d.prototype.removeAllAggregation=function(){return this._callMethodInControl("removeAllAggregation",arguments);};
d.prototype.destroyAggregation=function(A,e){this._callMethodInControl("destroyAggregation",arguments);return this;};
d.prototype.setProperty=function(p,v,e){var L=this.getList();if(/selectedKey|selectedItemId/.test(p)){L&&S.prototype.setProperty.apply(L,arguments);}return a.prototype.setProperty.apply(this,arguments);};
d.prototype.removeAllAssociation=function(A,e){var L=this.getList();if(L&&(A==="selectedItem")){S.prototype.removeAllAssociation.apply(L,arguments);}return a.prototype.removeAllAssociation.apply(this,arguments);};
d.prototype.clone=function(I){var o=a.prototype.clone.apply(this,arguments),L=this.getList();if(!this.isBound("items")&&L){for(var i=0,e=L.getItems();i<e.length;i++){o.addItem(e[i].clone());}o.setSelectedIndex(this.indexOfItem(this.getSelectedItem()));}return o;};
d.prototype.findAggregatedObjects=function(){var L=this.getList();if(L){return S.prototype.findAggregatedObjects.apply(L,arguments);}return[];};
d.prototype.setShowSecondaryValues=function(A){this.setProperty("showSecondaryValues",A,true);var L=this.getList();if(L){L.setShowSecondaryValues(A);}return this;};
d.prototype.getItems=function(){var L=this.getList();return L?L.getItems():[];};
d.prototype.setSelectedItem=function(i){if(typeof i==="string"){this.setAssociation("selectedItem",i,true);i=sap.ui.getCore().byId(i);}if(!(i instanceof sap.ui.core.Item)&&i!==null){return this;}if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);this.setValue(this._getSelectedItemText(i));return this;};
d.prototype.setSelectedItemId=function(i){i=this.validateProperty("selectedItemId",i);if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);i=this.getSelectedItem();this.setValue(this._getSelectedItemText(i));return this;};
d.prototype.setSelectedKey=function(k){k=this.validateProperty("selectedKey",k);var e=(k==="");if(e){this.setSelection(null);this.setValue("");return this;}var i=this.getItemByKey(k);if(i){this.setSelection(i);this.setValue(this._getSelectedItemText(i));return this;}this._sValue=this.getValue();return this.setProperty("selectedKey",k);};
d.prototype.getSelectedItem=function(){var v=this.getAssociation("selectedItem");return(v===null)?null:sap.ui.getCore().byId(v)||null;};
d.prototype.removeItem=function(i){i=a.prototype.removeItem.apply(this,arguments);var I;if(this.isBound("items")&&!this.bItemsUpdated){return i;}var v=this.getValue();if(this.getItems().length===0){this.clearSelection();}else if(this.isItemSelected(i)){I=this.getDefaultSelectedItem();this.setSelection(I);this.setValue(v);}return i;};
return d;},true);
sap.ui.predefine('sap/m/ComboBoxBase',['jquery.sap.global','./Dialog','./ComboBoxTextField','./Toolbar','./Button','./Bar','./Title','./SelectList','./Popover','sap/ui/core/IconPool','./library'],function(q,D,C,T,B,a,b,S,P,I,l){"use strict";
var c=C.extend("sap.m.ComboBoxBase",{metadata:{library:"sap.m",defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable"},picker:{type:"sap.ui.core.PopupInterface",multiple:false,visibility:"hidden"}},events:{loadItems:{}}}});
c.prototype.updateItems=function(r){this.bItemsUpdated=false;this.destroyItems();this.updateAggregation("items");this.bItemsUpdated=true;if(this.hasLoadItemsEventListeners()){this.onItemsLoaded();}};
c.prototype.refreshItems=function(){this.bItemsUpdated=false;this.refreshAggregation("items");};
c.prototype.getList=function(){if(this.bIsDestroyed){return null;}return this._oList;};
c.prototype.loadItems=function(f,o){var d=typeof f==="function";if(this.hasLoadItemsEventListeners()&&(this.getItems().length===0)){this._bOnItemsLoadedScheduled=false;if(d){o=q.extend({action:f,busyIndicator:true,busyIndicatorDelay:300},o);this.aMessageQueue.push(o);if((this.iLoadItemsEventInitialProcessingTimeoutID===-1)&&(o.busyIndicator)){this.iLoadItemsEventInitialProcessingTimeoutID=setTimeout(function onItemsNotLoadedAfterDelay(){this.setInternalBusyIndicatorDelay(0);this.setInternalBusyIndicator(true);}.bind(this),o.busyIndicatorDelay);}}if(!this.bProcessingLoadItemsEvent){this.bProcessingLoadItemsEvent=true;this.fireLoadItems();}}else if(d){f.call(this);}};
c.prototype.onItemsLoaded=function(){this.bProcessingLoadItemsEvent=false;clearTimeout(this.iLoadItemsEventInitialProcessingTimeoutID);if(this.bInitialBusyIndicatorState!==this.getBusy()){this.setInternalBusyIndicator(this.bInitialBusyIndicatorState);}if(this.iInitialBusyIndicatorDelay!==this.getBusyIndicatorDelay()){this.setInternalBusyIndicatorDelay(this.iInitialBusyIndicatorDelay);}for(var i=0,m,n,d;i<this.aMessageQueue.length;i++){m=this.aMessageQueue.shift();i--;d=(i+1)===this.aMessageQueue.length;n=d?null:this.aMessageQueue[i+1];if(typeof m.action==="function"){if((m.name==="input")&&!d&&(n.name==="input")){continue;}m.action.call(this);}}};
c.prototype.hasLoadItemsEventListeners=function(){return this.hasListeners("loadItems");};
c.prototype._scheduleOnItemsLoadedOnce=function(){if(!this._bOnItemsLoadedScheduled&&!this.isBound("items")&&this.hasLoadItemsEventListeners()&&this.bProcessingLoadItemsEvent){this._bOnItemsLoadedScheduled=true;setTimeout(this.onItemsLoaded.bind(this),0);}};
c.prototype.init=function(){C.prototype.init.apply(this,arguments);this.setPickerType(sap.ui.Device.system.phone?"Dialog":"Dropdown");if(sap.ui.Device.system.phone){this.attachEvent("_change",this.onPropertyChange,this);}this.createPicker(this.getPickerType());this.bItemsUpdated=false;this.bOpenedByKeyboardOrButton=false;this.bProcessingLoadItemsEvent=false;this.iLoadItemsEventInitialProcessingTimeoutID=-1;this.aMessageQueue=[];this.bInitialBusyIndicatorState=this.getBusy();this.iInitialBusyIndicatorDelay=this.getBusyIndicatorDelay();this._bOnItemsLoadedScheduled=false;this._bDoTypeAhead=true;};
c.prototype.exit=function(){C.prototype.exit.apply(this,arguments);if(this.getList()){this.getList().destroy();this._oList=null;}clearTimeout(this.iLoadItemsEventInitialProcessingTimeoutID);this.aMessageQueue=null;};
c.prototype.ontouchstart=function(e){if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();if(this.isOpenArea(e.target)){this.addStyleClass(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Pressed");}};
c.prototype.ontouchend=function(e){if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();if(!this.isOpen()&&this.isOpenArea(e.target)){this.removeStyleClass(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Pressed");}};
c.prototype.ontap=function(e){C.prototype.ontap.apply(this,arguments);var d=this.getRenderer().CSS_CLASS_COMBOBOXBASE,o=e.srcControl;if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();if(o.isOpenArea&&o.isOpenArea(e.target)){if(this.isOpen()){this.close();this.removeStyleClass(d+"Pressed");return;}this.bOpenedByKeyboardOrButton=true;this.loadItems();this.open();}if(this.isOpen()){this.addStyleClass(d+"Pressed");}};
c.prototype.onsapshow=function(e){if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();if(e.keyCode===q.sap.KeyCodes.F4){e.preventDefault();}if(this.isOpen()){this.close();return;}this.selectText(0,this.getValue().length);this.loadItems();this.bOpenedByKeyboardOrButton=true;this.open();};
c.prototype.onsapescape=function(e){if(this.getEnabled()&&this.getEditable()&&this.isOpen()){e.setMarked();e.preventDefault();this.close();}else{C.prototype.onsapescape.apply(this,arguments);}};
c.prototype.onsaphide=c.prototype.onsapshow;
c.prototype.onsapfocusleave=function(e){if(!e.relatedControlId){C.prototype.onsapfocusleave.apply(this,arguments);return;}var r=sap.ui.getCore().byId(e.relatedControlId);if(r===this){return;}var p=this.getAggregation("picker"),f=r&&r.getFocusDomRef();if(p&&q.sap.containsOrEquals(p.getFocusDomRef(),f)){return;}C.prototype.onsapfocusleave.apply(this,arguments);};
c.prototype.getPopupAnchorDomRef=function(){return this.getDomRef();};
c.prototype.addContent=function(p){};
c.prototype.setPickerType=function(p){this._sPickerType=p;};
c.prototype.getPickerType=function(){return this._sPickerType;};
c.prototype.isPickerDialog=function(){return this.getPickerType()==="Dialog";};
c.prototype.createPicker=function(p){};
c.prototype.onBeforeClose=function(){this.bOpenedByKeyboardOrButton=false;};
c.prototype.getPicker=function(){if(this.bIsDestroyed){return null;}return this.createPicker(this.getPickerType());};
c.prototype.getPickerTextField=function(){var p=this.getPicker(),s=p.getSubHeader();return s&&s.getContent()[0]||null;};
c.prototype.getPickerTitle=function(){var p=this.getPicker(),h=p&&p.getCustomHeader();if(this.isPickerDialog()&&h){return h.getContentMiddle()[0];}return null;};
c.prototype.createDialog=function(){var t=this,o=this.createPickerTextField(),d=o._handleEvent;o._handleEvent=function(e){d.apply(this,arguments);if(/keydown|sapdown|sapup|saphome|sapend|sappagedown|sappageup|input/.test(e.type)){t._handleEvent(e);}};return new D({stretch:true,customHeader:t.createPickerHeader(),buttons:this.createPickerCloseButton(),subHeader:new T({content:o}),beforeOpen:function(){t.updatePickerHeaderTitle();}});};
c.prototype.createPickerHeader=function(){var t=this,i=I.getIconURI("decline");return new a({contentMiddle:new b(),contentRight:new B({icon:i,press:function(){t.close();t.revertSelection();}})});};
c.prototype.revertSelection=function(){};
c.prototype.updatePickerHeaderTitle=function(){var p=this.getPicker(),r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),L,d;if(!p){return;}d=this.getLabels();if(d.length){L=d[0];if(L&&(typeof L.getText==="function")){this.getPickerTitle().setText(L.getText());}}else{this.getPickerTitle().setText(r.getText("COMBOBOX_PICKER_TITLE"));}};
c.prototype.createPickerCloseButton=function(){var t=this,o,r=sap.ui.getCore().getLibraryResourceBundle("sap.m");return new B({text:r.getText("COMBOBOX_CLOSE_BUTTON"),press:function(){o=t.getPickerTextField();t.updateDomValue(o.getValue());t.onChange();t.close();}});};
c.prototype.hasContent=function(){return this.getItems().length>0;};
c.prototype.findFirstEnabledItem=function(i){var L=this.getList();return L?L.findFirstEnabledItem(i):null;};
c.prototype.findLastEnabledItem=function(i){var L=this.getList();return L?L.findLastEnabledItem(i):null;};
c.prototype.open=function(){var p=this.getPicker();if(p){p.open();}return this;};
c.prototype.getVisibleItems=function(){var L=this.getList();return L?L.getVisibleItems():[];};
c.prototype.isItemSelected=function(){};
c.prototype.getKeys=function(d){d=d||this.getItems();for(var i=0,k=[];i<d.length;i++){k[i]=d[i].getKey();}return k;};
c.prototype.getSelectableItems=function(){var L=this.getList();return L?L.getSelectableItems():[];};
c.prototype.findItem=function(p,v){var L=this.getList();return L?L.findItem(p,v):null;};
c.prototype.getItemByText=function(t){return this.findItem("text",t);};
c.prototype.scrollToItem=function(i){var p=this.getPicker(),o=p.getDomRef("cont"),d=i&&i.getDomRef();if(!p||!o||!d){return;}var e=o.scrollTop,f=d.offsetTop,g=o.clientHeight,h=d.offsetHeight;if(e>f){o.scrollTop=f;}else if((f+h)>(e+g)){o.scrollTop=Math.ceil(f+h-g);}};
c.prototype.clearFilter=function(){for(var i=0,d=this.getItems();i<d.length;i++){d[i].bVisible=true;}};
c.prototype.onItemChange=function(o){};
c.prototype.clearSelection=function(){};
c.prototype.setInternalBusyIndicator=function(d){this.bInitialBusyIndicatorState=this.getBusy();return this.setBusy.apply(this,arguments);};
c.prototype.setInternalBusyIndicatorDelay=function(d){this.iInitialBusyIndicatorDelay=this.getBusyIndicatorDelay();return this.setBusyIndicatorDelay.apply(this,arguments);};
c.prototype.addItem=function(i){this.addAggregation("items",i);if(i){i.attachEvent("_change",this.onItemChange,this);}this._scheduleOnItemsLoadedOnce();return this;};
c.prototype.insertItem=function(i,d){this.insertAggregation("items",i,d,true);if(i){i.attachEvent("_change",this.onItemChange,this);}this._scheduleOnItemsLoadedOnce();return this;};
c.prototype.getItemAt=function(i){return this.getItems()[+i]||null;};
c.prototype.getFirstItem=function(){return this.getItems()[0]||null;};
c.prototype.getLastItem=function(){var i=this.getItems();return i[i.length-1]||null;};
c.prototype.getEnabledItems=function(i){var L=this.getList();return L?L.getEnabledItems(i):[];};
c.prototype.getItemByKey=function(k){var L=this.getList();return L?L.getItemByKey(k):null;};
c.prototype.isOpen=function(){var p=this.getAggregation("picker");return!!(p&&p.isOpen());};
c.prototype.close=function(){var p=this.getAggregation("picker");if(p){p.close();}return this;};
c.prototype.removeItem=function(i){var L=this.getList();i=L?L.removeItem(i):null;if(i){i.detachEvent("_change",this.onItemChange,this);}return i;};
c.prototype.removeAllItems=function(){var L=this.getList(),d=L?L.removeAllItems():[];this.clearSelection();for(var i=0;i<d.length;i++){d[i].detachEvent("_change",this.onItemChange,this);}return d;};
c.prototype.destroyItems=function(){var L=this.getList();if(L){L.destroyItems();}return this;};
return c;},true);
sap.ui.predefine('sap/m/ComboBoxBaseRenderer',['jquery.sap.global','./ComboBoxTextFieldRenderer','sap/ui/core/Renderer'],function(q,C,R){"use strict";var a=R.extend(C);a.CSS_CLASS_COMBOBOXBASE="sapMComboBoxBase";
a.getAccessibilityState=function(c){var A=C.getAccessibilityState.call(this,c);A.expanded=c.isOpen();return A;};
a.addOuterClasses=function(r,c){C.addOuterClasses.apply(this,arguments);var b=a.CSS_CLASS_COMBOBOXBASE;r.addClass(b);if(!c.getEnabled()){r.addClass(b+"Disabled");}if(!c.getEditable()){r.addClass(b+"Readonly");}};
a.addButtonClasses=function(r,c){C.addButtonClasses.apply(this,arguments);r.addClass(a.CSS_CLASS_COMBOBOXBASE+"Arrow");};
return a;},true);
sap.ui.predefine('sap/m/ComboBoxRenderer',['jquery.sap.global','./ComboBoxBaseRenderer','sap/ui/core/Renderer'],function(q,C,R){"use strict";var a=R.extend(C);a.CSS_CLASS_COMBOBOX="sapMComboBox";
a.addOuterClasses=function(r,c){C.addOuterClasses.apply(this,arguments);r.addClass(a.CSS_CLASS_COMBOBOX);};
a.addInnerClasses=function(r,c){C.addInnerClasses.apply(this,arguments);r.addClass(a.CSS_CLASS_COMBOBOX+"Inner");};
a.addButtonClasses=function(r,c){C.addButtonClasses.apply(this,arguments);r.addClass(a.CSS_CLASS_COMBOBOX+"Arrow");};
a.addPlaceholderClasses=function(r,c){C.addPlaceholderClasses.apply(this,arguments);r.addClass(a.CSS_CLASS_COMBOBOX+"Placeholder");};
return a;},true);
sap.ui.predefine('sap/m/ComboBoxTextField',['jquery.sap.global','./InputBase','./library','sap/ui/core/InvisibleText'],function(q,I,l,a){"use strict";
var C=I.extend("sap.m.ComboBoxTextField",{metadata:{library:"sap.m",properties:{maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},showButton:{type:"boolean",group:"Appearance",defaultValue:true}},aggregations:{_buttonLabelText:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"}}}});
C.prototype.init=function(){I.prototype.init.apply(this,arguments);var r,A;if(sap.ui.getCore().getConfiguration().getAccessibility()){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");A=new a({text:r.getText("COMBOBOX_BUTTON")});this.setAggregation("_buttonLabelText",A,true);}};
C.prototype.updateValueStateClasses=function(v,o){I.prototype.updateValueStateClasses.apply(this,arguments);var V=sap.ui.core.ValueState,b=this.getRenderer().CSS_CLASS_COMBOBOXTEXTFIELD,d=this.$();if(o!==V.None){d.removeClass(b+"State "+b+o);}if(v!==V.None){d.addClass(b+"State "+b+v);}};
C.prototype.getOpenArea=function(){return this.getDomRef("arrow");};
C.prototype.isOpenArea=function(d){var o=this.getOpenArea();return o&&o.contains(d);};
C.prototype.onsapenter=function(e){I.prototype.onsapenter.apply(this,arguments);if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();var v=this.getValue(),V=v.length;this.setValue(v);this.selectText(V,V);};
C.prototype.bShowLabelAsPlaceholder=sap.ui.Device.browser.msie;
C.prototype.getValue=function(){var d=this.getFocusDomRef();if(d){return d.value;}return this.getProperty("value");};
C.prototype.getLabels=function(){var L=this.getAriaLabelledBy().map(function(s){return sap.ui.getCore().byId(s);});var o=sap.ui.require("sap/ui/core/LabelEnablement");if(o){L=L.concat(o.getReferencingLabels(this).map(function(s){return sap.ui.getCore().byId(s);}));}return L;};
C.prototype.getDomRefForValueStateMessage=function(){return this.getDomRef();};
C.prototype.getAccessibilityInfo=function(){var i=I.prototype.getAccessibilityInfo.apply(this,arguments);i.type=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_COMBO");return i;};
return C;},true);
sap.ui.predefine('sap/m/ComboBoxTextFieldRenderer',['jquery.sap.global','./InputBaseRenderer','sap/ui/core/Renderer'],function(q,I,R){"use strict";var C=R.extend(I);C.CSS_CLASS_COMBOBOXTEXTFIELD="sapMComboBoxTextField";
C.writeInnerAttributes=function(r,c){r.writeAttribute("autocomplete","off");r.writeAttribute("autocorrect","off");r.writeAttribute("autocapitalize","off");r.writeAttribute("type","text");};
C.writeOuterAttributes=function(r,c){if(sap.ui.getCore().getConfiguration().getAccessibility()){r.writeAttribute("role","combobox");}};
C.getAriaRole=function(){};
C.getAccessibilityState=function(c){var a=I.getAccessibilityState.call(this,c);a.autocomplete="both";return a;};
C.addOuterStyles=function(r,c){r.addStyle("max-width",c.getMaxWidth());};
C.addOuterClasses=function(r,c){var a=C.CSS_CLASS_COMBOBOXTEXTFIELD;r.addClass(a);if(!c.getEnabled()){r.addClass(a+"Disabled");}if(!c.getEditable()){r.addClass(a+"Readonly");}};
C.addPaddingClass=q.noop;
C.addInnerClasses=function(r,c){var a=C.CSS_CLASS_COMBOBOXTEXTFIELD;r.addClass(a+"Inner");if(!c.getEditable()){r.addClass(a+"InnerReadonly");}if(c.getShowButton()){r.addClass(a+"InnerWidthExtraPadding");}};
C.addValueStateClasses=function(r,c){var a=C.CSS_CLASS_COMBOBOXTEXTFIELD;r.addClass(a+"State");r.addClass(a+c.getValueState());};
C.writeInnerContent=function(r,c){if(c.getShowButton()){this.renderButton(r,c);}};
C.renderButton=function(r,c){var i=c.getId(),b=i+"-arrow",a=sap.ui.getCore().getConfiguration().getAccessibility(),A=c.getAggregation("_buttonLabelText");r.write('<span tabindex="-1" ');r.writeAttribute("id",b);if(a){r.writeAttribute("role","button");r.writeAttribute("aria-labelledby",A.getId());}this.addButtonClasses(r,c);r.writeClasses();r.write(">");a&&r.renderControl(A);r.write("</span>");};
C.addButtonClasses=function(r,c){r.addClass(C.CSS_CLASS_COMBOBOXTEXTFIELD+"Arrow");};
return C;},true);
sap.ui.predefine('sap/m/CustomListItem.designtime',[],function(){"use strict";return{aggregations:{content:{domRef:":sap-domref"}}};},false);
sap.ui.predefine('sap/m/CustomListItem',['jquery.sap.global','./ListItemBase','./library'],function(q,L,l){"use strict";
var C=L.extend("sap.m.CustomListItem",{metadata:{library:"sap.m",defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",bindable:"bindable"}},designTime:true}});
return C;},true);
sap.ui.predefine('sap/m/CustomListItemRenderer',['jquery.sap.global','./ListItemBaseRenderer','sap/ui/core/Renderer'],function(q,L,R){"use strict";var C=R.extend(L);
C.renderLIAttributes=function(r,l){r.addClass("sapMCLI");};
C.renderLIContent=function(r,l){var c=l.getContent();var a=c.length;for(var i=0;i<a;i++){r.renderControl(c[i]);}};
return C;},true);
sap.ui.predefine('sap/m/CustomTile.designtime',[],function(){"use strict";return{aggregations:{content:{domRef:":sap-domref"}}};},false);
sap.ui.predefine('sap/m/CustomTile',['jquery.sap.global','./Tile','./library'],function(q,T,l){"use strict";
var C=T.extend("sap.m.CustomTile",{metadata:{library:"sap.m",defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:false}},designTime:true}});
return C;},true);
sap.ui.predefine('sap/m/CustomTileRenderer',['jquery.sap.global','./TileRenderer'],function(q,T){"use strict";var C=sap.ui.core.Renderer.extend(T);
C.render=function(r,c){r.write("<div tabindex=\"0\"");r.writeControlData(c);r.addClass("sapMCustomTile");r.writeClasses();if(c._invisible){r.addStyle("visibility","hidden");r.writeStyles();}if(c.getParent()instanceof sap.m.TileContainer){r.writeAccessibilityState({role:"option",posinset:c._getTileIndex(),setsize:c._getTilesCount()});}r.write(">");r.write("<div id=\""+c.getId()+"-remove\" class=\"sapMTCRemove\"></div>");r.write("<div class=\"sapMCustomTileContent\">");this._renderContent(r,c);r.write("</div></div>");};
C._renderContent=function(r,t){r.renderControl(t.getContent());};
return C;},true);
sap.ui.predefine('sap/m/DatePicker',['jquery.sap.global','sap/ui/Device','./InputBase','sap/ui/model/type/Date','sap/ui/core/date/UniversalDate','./library'],function(q,D,I,a,U,l){"use strict";
var b=I.extend("sap.m.DatePicker",{metadata:{library:"sap.m",properties:{displayFormat:{type:"string",group:"Appearance",defaultValue:null},valueFormat:{type:"string",group:"Data",defaultValue:null},dateValue:{type:"object",group:"Data",defaultValue:null},displayFormatType:{type:"string",group:"Appearance",defaultValue:""},secondaryCalendarType:{type:"sap.ui.core.CalendarType",group:"Appearance",defaultValue:null},minDate:{type:"object",group:"Misc",defaultValue:null},maxDate:{type:"object",group:"Misc",defaultValue:null}},aggregations:{specialDates:{type:"sap.ui.core.Element",multiple:true,singularName:"specialDate"}},associations:{legend:{type:"sap.ui.core.Control",multiple:false}}}});
b.prototype.init=function(){I.prototype.init.apply(this,arguments);this._bIntervalSelection=false;this._bOnlyCalendar=true;this._bValid=true;this._oMinDate=new Date(1,0,1);this._oMinDate.setFullYear(1);this._oMaxDate=new Date(9999,11,31,23,59,59,99);};
b.prototype.exit=function(){I.prototype.exit.apply(this,arguments);if(this._oPopup){if(this._oPopup.isOpen()){this._oPopup.close();}delete this._oPopup;}if(this._oCalendar){this._oCalendar.destroy();delete this._oCalendar;}this._sUsedDisplayPattern=undefined;this._sUsedDisplayCalendarType=undefined;this._oDisplayFormat=undefined;this._sUsedValuePattern=undefined;this._sUsedValueCalendarType=undefined;this._oValueFormat=undefined;};
b.prototype.invalidate=function(o){if(!o||o!=this._oCalendar){sap.ui.core.Control.prototype.invalidate.apply(this,arguments);}};
b.prototype.onBeforeRendering=function(){I.prototype.onBeforeRendering.apply(this,arguments);this._checkMinMaxDate();};
b.prototype.setWidth=function(w){return I.prototype.setWidth.call(this,w||"100%");};
b.prototype.getWidth=function(w){return this.getProperty("width")||"100%";};
b.prototype.applyFocusInfo=function(F){this._bFocusNoPopup=true;I.prototype.applyFocusInfo.apply(this,arguments);};
b.prototype.onfocusin=function(E){if(!q(E.target).hasClass("sapUiIcon")){I.prototype.onfocusin.apply(this,arguments);}this._bFocusNoPopup=undefined;};
b.prototype.onsapshow=function(E){c.call(this);E.preventDefault();};
b.prototype.onsaphide=b.prototype.onsapshow;
b.prototype.onsappageup=function(E){e.call(this,1,"day");E.preventDefault();};
b.prototype.onsappageupmodifiers=function(E){if(!E.ctrlKey&&E.shiftKey){e.call(this,1,"month");}else{e.call(this,1,"year");}E.preventDefault();};
b.prototype.onsappagedown=function(E){e.call(this,-1,"day");E.preventDefault();};
b.prototype.onsappagedownmodifiers=function(E){if(!E.ctrlKey&&E.shiftKey){e.call(this,-1,"month");}else{e.call(this,-1,"year");}E.preventDefault();};
b.prototype.onkeypress=function(E){if(!E.charCode||E.metaKey||E.ctrlKey){return;}var F=h.call(this,true);var C=String.fromCharCode(E.charCode);if(C&&F.sAllowedCharacters&&F.sAllowedCharacters.indexOf(C)<0){E.preventDefault();}};
b.prototype.onclick=function(E){if(q(E.target).hasClass("sapUiIcon")){c.call(this);}};
b.prototype.setValue=function(v){v=this.validateProperty("value",v);var o=this.getValue();if(v==o){return this;}else{this._lastValue=v;}this.setProperty("value",v,true);this._bValid=true;var k;if(v){k=this._parseValue(v);if(!k||k.getTime()<this._oMinDate.getTime()||k.getTime()>this._oMaxDate.getTime()){this._bValid=false;q.sap.log.warning("Value can not be converted to a valid date",this);this._oWantedDate=k;}}if(this._bValid){this.setProperty("dateValue",k,true);this._oWantedDate=undefined;}if(this.getDomRef()){var O;if(k){O=this._formatValue(k);}else{O=v;}if(this._$input.val()!==O){this._$input.val(O);this._setLabelVisibility();this._curpos=this._$input.cursorPos();}}return this;};
b.prototype.setDateValue=function(o){if(o&&!(o instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}if(q.sap.equal(this.getDateValue(),o)){return this;}if(o&&(o.getTime()<this._oMinDate.getTime()||o.getTime()>this._oMaxDate.getTime())){this._bValid=false;this._oWantedDate=o;o=undefined;}else{this._bValid=true;this.setProperty("dateValue",o,true);this._oWantedDate=undefined;}var v=this._formatValue(o,true);if(v!==this.getValue()){this._lastValue=v;}this.setProperty("value",v,true);if(this.getDomRef()){var O=this._formatValue(o);if(this._$input.val()!==O){this._$input.val(O);this._setLabelVisibility();this._curpos=this._$input.cursorPos();}}return this;};
b.prototype.setMinDate=function(o){if(o&&!(o instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}if(q.sap.equal(this.getMinDate(),o)){return this;}if(o){var y=o.getFullYear();if(y<1||y>9999){throw new Error("Date must be between 0001-01-01 and 9999-12-31; "+this);}this._oMinDate=new Date(o.getTime());var k=this.getDateValue();if(k&&k.getTime()<o.getTime()){q.sap.log.warning("DateValue not in valid date -> changed to minDate",this);this.setDateValue(new Date(o.getTime()));}}else{this._oMinDate=new Date(1,0,1);this._oMinDate.setFullYear(1);}this.setProperty("minDate",o,false);if(this._oCalendar){this._oCalendar.setMinDate(o);}return this;};
b.prototype.setMaxDate=function(o){if(o&&!(o instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}if(q.sap.equal(this.getMaxDate(),o)){return this;}if(o){var y=o.getFullYear();if(y<1||y>9999){throw new Error("Date must be between 0001-01-01 and 9999-12-31; "+this);}this._oMaxDate=new Date(o.getTime());var k=this.getDateValue();if(k&&k.getTime()>o.getTime()){q.sap.log.warning("DateValue not in valid date -> changed to maxDate",this);this.setDateValue(new Date(o.getTime()));}}else{this._oMaxDate=new Date(9999,11,31,23,59,59,99);}this.setProperty("maxDate",o,false);if(this._oCalendar){this._oCalendar.setMaxDate(o);}return this;};
b.prototype._checkMinMaxDate=function(){if(this._oMinDate.getTime()>this._oMaxDate.getTime()){q.sap.log.warning("minDate > MaxDate -> dates switched",this);var m=new Date(this._oMinDate.getTime());var M=new Date(this._oMaxDate.getTime());this._oMinDate=new Date(M.getTime());this._oMaxDate=new Date(m.getTime());this.setProperty("minDate",M,true);this.setProperty("maxDate",m,true);if(this._oCalendar){this._oCalendar.setMinDate(M);this._oCalendar.setMaxDate(m);}}if(this._oWantedDate&&this._oWantedDate.getTime()>=this._oMinDate.getTime()&&this._oWantedDate.getTime()<=this._oMaxDate.getTime()){this.setDateValue(this._oWantedDate);}};
b.prototype.setValueFormat=function(v){this.setProperty("valueFormat",v,true);var V=this.getValue();if(V){var o=this._parseValue(V);if(!o||o.getTime()<this._oMinDate.getTime()||o.getTime()>this._oMaxDate.getTime()){this._bValid=false;q.sap.log.warning("Value can not be converted to a valid date",this);}else{this._bValid=true;this.setProperty("dateValue",o,true);}}return this;};
b.prototype.setDisplayFormat=function(s){this.setProperty("displayFormat",s,true);var o=this._formatValue(this.getDateValue());if(this.getDomRef()&&(this._$input.val()!==o)){this._$input.val(o);this._curpos=this._$input.cursorPos();}return this;};
b.prototype.setDisplayFormatType=function(s){if(s){var F=false;for(var t in sap.ui.core.CalendarType){if(t==s){F=true;break;}}if(!F){throw new Error(s+" is not a valid calendar type"+this);}}this.setProperty("displayFormatType",s,true);this.setDisplayFormat(this.getDisplayFormat());return this;};
b.prototype.setSecondaryCalendarType=function(C){this._bSecondaryCalendarTypeSet=true;this.setProperty("secondaryCalendarType",C,true);if(this._oCalendar){this._oCalendar.setSecondaryCalendarType(C);}return this;};
b.prototype.addSpecialDate=function(s){i.call(this,s);this.addAggregation("specialDates",s,true);j.call(this);return this;};
b.prototype.insertSpecialDate=function(s,k){i.call(this,s);this.insertAggregation("specialDates",s,k,true);j.call(this);return this;};
b.prototype.removeSpecialDate=function(s){var r=this.removeAggregation("specialDates",s,true);j.call(this);return r;};
b.prototype.removeAllSpecialDates=function(){var r=this.removeAllAggregation("specialDates",true);j.call(this);return r;};
b.prototype.destroySpecialDates=function(){this.destroyAggregation("specialDates",true);j.call(this);return this;};
b.prototype.setLegend=function(L){this.setAssociation("legend",L,true);var s=this.getLegend();if(s){if(!sap.ui.unified.CalendarLegend){sap.ui.getCore().loadLibrary("sap.ui.unified");q.sap.require("sap.ui.unified.library");}L=sap.ui.getCore().byId(s);if(L&&!(L instanceof sap.ui.unified.CalendarLegend)){throw new Error(L+" is not a sap.ui.unified.CalendarLegend. "+this);}}if(this._oCalendar){this._oCalendar.setLegend(s);}return this;};
b.prototype.onChange=function(E){if(!this.getEditable()||!this.getEnabled()){return;}var v=this._$input.val();var o=this._formatValue(this.getDateValue());if(v==o&&this._bValid){return;}var k;this._oWantedDate=undefined;this._bValid=true;if(v!=""){k=this._parseValue(v,true);if(!k||k.getTime()<this._oMinDate.getTime()||k.getTime()>this._oMaxDate.getTime()){this._bValid=false;k=undefined;}else{v=this._formatValue(k);}}if(this.getDomRef()&&(this._$input.val()!==v)){this._$input.val(v);this._curpos=this._$input.cursorPos();if(this.bShowLabelAsPlaceholder){this.$("placeholder").css("display",v?"none":"inline");}}if(k){v=this._formatValue(k,true);}if(this._lastValue!==v||(k&&this.getDateValue()&&k.getFullYear()!==this.getDateValue().getFullYear())){this._lastValue=v;this.setProperty("value",v,true);var n=this.getValue();if(this._bValid&&v==n){this.setProperty("dateValue",k,true);}v=n;if(this._oPopup&&this._oPopup.isOpen()){if(this._bValid){k=this.getDateValue();}this._oCalendar.focusDate(k);var s=this._oDateRange.getStartDate();if((!s&&k)||(s&&k&&s.getTime()!=k.getTime())){this._oDateRange.setStartDate(new Date(k.getTime()));}else if(s&&!k){this._oDateRange.setStartDate(undefined);}}this.fireChangeEvent(v,{valid:this._bValid});}};
b.prototype._getInputValue=function(v){v=(typeof v=="undefined")?this._$input.val():v.toString();var o=this._parseValue(v,true);v=this._formatValue(o,true);return v;};
b.prototype.updateDomValue=function(v){this._bCheckDomValue=true;v=(typeof v=="undefined")?this._$input.val():v.toString();this._curpos=this._$input.cursorPos();var o=this._parseValue(v,true);v=this._formatValue(o);if(this.isActive()&&(this._$input.val()!==v)){this._$input.val(v);this._$input.cursorPos(this._curpos);}this._setLabelVisibility();return this;};
b.prototype._parseValue=function(v,k){var F=h.call(this,k);var o=F.parse(v);return o;};
b.prototype._formatValue=function(o,v){var V="";if(o){var F=h.call(this,!v);V=F.format(o);}return V;};
b.prototype._getPlaceholder=function(){var p=this.getPlaceholder();if(!p){var B=this.getBinding("value");if(B&&B.oType&&(B.oType instanceof a)){p=B.oType.getOutputPattern();}else{p=this.getDisplayFormat();}if(!p){p="medium";}if(this._checkStyle(p)){var L=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();var o=sap.ui.core.LocaleData.getInstance(L);p=this._getPlaceholderPattern(o,p);}}return p;};
b.prototype._getPlaceholderPattern=function(L,p){return L.getDatePattern(p);};
function _(){this._createPopup();this._createPopupContent();var C;var B=this.getBinding("value");if(B&&B.oType&&(B.oType instanceof a)){C=B.oType.oOutputFormat.oFormatOptions.calendarType;}if(!C){C=this.getDisplayFormatType();}if(C){this._oCalendar.setPrimaryCalendarType(C);}var v=this._bValid?this._formatValue(this.getDateValue()):this.getValue();if(v!=this._$input.val()){this.onChange();}this._fillDateRange();this._openPopup();}
b.prototype._createPopup=function(){if(!this._oPopup){q.sap.require("sap.ui.core.Popup");this._oPopup=new sap.ui.core.Popup();this._oPopup.setAutoClose(true);this._oPopup.setDurations(0,0);this._oPopup.attachOpened(f,this);}};
b.prototype._openPopup=function(){if(!this._oPopup){return;}this._oPopup.setAutoCloseAreas([this.getDomRef()]);var k=sap.ui.core.Popup.Dock;var A;if(this.getTextAlign()==sap.ui.core.TextAlign.End){A=k.EndBottom+"-4";this._oPopup.open(0,k.EndTop,A,this,null,"fit",true);}else{A=k.BeginBottom+"-4";this._oPopup.open(0,k.BeginTop,A,this,null,"fit",true);}};
b.prototype._createPopupContent=function(){if(!this._oCalendar){sap.ui.getCore().loadLibrary("sap.ui.unified");q.sap.require("sap.ui.unified.library");this._oCalendar=new sap.ui.unified.Calendar(this.getId()+"-cal",{intervalSelection:this._bIntervalSelection,minDate:this.getMinDate(),maxDate:this.getMaxDate(),legend:this.getLegend()});this._oDateRange=new sap.ui.unified.DateRange();this._oCalendar.addSelectedDate(this._oDateRange);if(this.$().closest(".sapUiSizeCompact").length>0){this._oCalendar.addStyleClass("sapUiSizeCompact");}if(this._bSecondaryCalendarTypeSet){this._oCalendar.setSecondaryCalendarType(this.getSecondaryCalendarType());}if(this._bOnlyCalendar){this._oCalendar.attachSelect(this._selectDate,this);this._oCalendar.attachCancel(d,this);this._oCalendar.attachEvent("_renderMonth",g,this);this._oCalendar.setPopupMode(true);this._oCalendar.setParent(this,undefined,true);this._oPopup.setContent(this._oCalendar);}}};
b.prototype._fillDateRange=function(){var o=this.getDateValue();if(o){this._oCalendar.focusDate(new Date(o.getTime()));if(!this._oDateRange.getStartDate()||this._oDateRange.getStartDate().getTime()!=o.getTime()){this._oDateRange.setStartDate(new Date(o.getTime()));}}else{var F=new Date();var m=this._oMaxDate.getTime()+86400000;if(F.getTime()<this._oMinDate.getTime()||F.getTime()>m){F=this._oMinDate;}this._oCalendar.focusDate(F);if(this._oDateRange.getStartDate()){this._oDateRange.setStartDate(undefined);}}};
b.prototype._getFormatInstance=function(A,k){return sap.ui.core.format.DateFormat.getInstance(A);};
b.prototype._checkStyle=function(p){if(p=="short"||p=="medium"||p=="long"||p=="full"){return true;}else{return false;}};
b.prototype.getAccessibilityInfo=function(){var r=this.getRenderer();var o=I.prototype.getAccessibilityInfo.apply(this,arguments);var v=this.getValue()||"";if(this._bValid){var k=this.getDateValue();if(k){v=this._formatValue(k);}}o.type=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_DATEINPUT");o.description=[v,r.getLabelledByAnnouncement(this),r.getDescribedByAnnouncement(this)].join(" ").trim();return o;};
function c(){if(this.getEditable()&&this.getEnabled()){if(!this._oPopup||!this._oPopup.isOpen()){_.call(this);}else{d.call(this);}}}
b.prototype._selectDate=function(E){var o=this.getDateValue();var k=this._getSelectedDate();var v="";if(!q.sap.equal(k,o)){this.setDateValue(new Date(k.getTime()));v=this.getValue();this.fireChangeEvent(v,{valid:true});if(this.getDomRef()&&!D.support.touch&&!q.sap.simulateMobileOnDesktop){this._curpos=this._$input.val().length;this._$input.cursorPos(this._curpos);}}else if(!this._bValid){v=this._formatValue(k);if(v!=this._$input.val()){this._bValid=true;if(this.getDomRef()){this._$input.val(v);this._lastValue=v;}this.setProperty("value",v,true);this.fireChangeEvent(v,{valid:true});}}this._oPopup.close();};
b.prototype._getSelectedDate=function(){var s=this._oCalendar.getSelectedDates();var o;if(s.length>0){o=s[0].getStartDate();}return o;};
function d(E){if(this._oPopup&&this._oPopup.isOpen()){this._oPopup.close();if(!D.support.touch&&!q.sap.simulateMobileOnDesktop){this.focus();}}}
function e(n,u){var o=this.getDateValue();var C=this._$input.cursorPos();if(o&&this.getEditable()&&this.getEnabled()){var s;var B=this.getBinding("value");if(B&&B.oType&&(B.oType instanceof a)){s=B.oType.oOutputFormat.oFormatOptions.calendarType;}if(!s){s=this.getDisplayFormatType();}var k=U.getInstance(new Date(o.getTime()),s);o=U.getInstance(new Date(o.getTime()),s);switch(u){case"day":k.setDate(k.getDate()+n);break;case"month":k.setMonth(k.getMonth()+n);var m=(o.getMonth()+n)%12;if(m<0){m=12+m;}while(k.getMonth()!=m){k.setDate(k.getDate()-1);}break;case"year":k.setFullYear(k.getFullYear()+n);while(k.getMonth()!=o.getMonth()){k.setDate(k.getDate()-1);}break;default:break;}if(k.getTime()<this._oMinDate.getTime()){k=new U(this._oMinDate.getTime());}else if(k.getTime()>this._oMaxDate.getTime()){k=new U(this._oMaxDate.getTime());}if(!q.sap.equal(this.getDateValue(),k.getJSDate())){this.setDateValue(new Date(k.getTime()));this._curpos=C;this._$input.cursorPos(this._curpos);var v=this.getValue();this.fireChangeEvent(v,{valid:true});}}}
function f(E){this._renderedDays=this._oCalendar.$("-Month0-days").find(".sapUiCalItem").length;}
function g(E){var k=E.getParameter("days");if(k>this._renderedDays){this._renderedDays=k;this._oPopup._applyPosition(this._oPopup._oLastPosition);}}
function h(k){var p="";var r=false;var F;var B=this.getBinding("value");var C;if(B&&B.oType&&(B.oType instanceof a)){p=B.oType.getOutputPattern();r=!!B.oType.oOutputFormat.oFormatOptions.relative;C=B.oType.oOutputFormat.oFormatOptions.calendarType;}if(!p){if(k){p=(this.getDisplayFormat()||"medium");C=this.getDisplayFormatType();}else{p=(this.getValueFormat()||"short");C=sap.ui.core.CalendarType.Gregorian;}}if(!C){C=sap.ui.getCore().getConfiguration().getCalendarType();}if(k){if(p==this._sUsedDisplayPattern&&C==this._sUsedDisplayCalendarType){F=this._oDisplayFormat;}}else{if(p==this._sUsedValuePattern&&C==this._sUsedValueCalendarType){F=this._oValueFormat;}}if(!F){if(this._checkStyle(p)){F=this._getFormatInstance({style:p,strictParsing:true,relative:r,calendarType:C},k);}else{F=this._getFormatInstance({pattern:p,strictParsing:true,relative:r,calendarType:C},k);}if(k){this._sUsedDisplayPattern=p;this._sUsedDisplayCalendarType=C;this._oDisplayFormat=F;}else{this._sUsedValuePattern=p;this._sUsedValueCalendarType=C;this._oValueFormat=F;}}return F;}
function i(s){if(!sap.ui.unified.DateTypeRange){sap.ui.getCore().loadLibrary("sap.ui.unified");q.sap.require("sap.ui.unified.library");}if(s&&!(s instanceof sap.ui.unified.DateTypeRange)){throw new Error(s+"is not valid for aggregation \"specialDates\" of "+this);}}
function j(){if(this._oPopup&&this._oPopup.isOpen()){this._oCalendar._bDateRangeChanged=true;this._oCalendar.invalidate();}}
return b;},true);
sap.ui.predefine('sap/m/DatePickerRenderer',['jquery.sap.global','sap/ui/core/Renderer','./InputBaseRenderer'],function(q,R,I){"use strict";var D=R.extend(I);
D.addOuterClasses=function(r,d){r.addClass("sapMDP");if(d.getEnabled()&&d.getEditable()){r.addClass("sapMInputVH");}};
D.writeInnerContent=function(r,d){if(d.getEnabled()&&d.getEditable()){var c=["sapMInputValHelpInner"];var a={};a["id"]=d.getId()+"-icon";a["tabindex"]="-1";a["title"]=null;r.write('<div class="sapMInputValHelp">');r.writeIcon(this._getIcon(),c,a);r.write("</div>");}};
D._getIcon=function(){return"sap-icon://appointment-2";};
D.writeInnerValue=function(r,d){if(d._bValid){r.writeAttributeEscaped("value",d._formatValue(d.getDateValue()));}else{r.writeAttributeEscaped("value",d.getValue());}};
D.writeInnerAttributes=function(r,d){if(d._bMobile){r.writeAttribute("readonly","readonly");}};
D.getAriaRole=function(d){return"combobox";};
D.getDescribedByAnnouncement=function(d){var b=I.getDescribedByAnnouncement.apply(this,arguments);return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("DATEPICKER_DATE_TYPE")+" "+b;};
D.getAccessibilityState=function(d){var a=I.getAccessibilityState.apply(this,arguments);a["multiline"]=false;a["autocomplete"]="none";a["haspopup"]=true;a["owns"]=d.getId()+"-cal";if(d._bMobile&&d.getEnabled()&&d.getEditable()){a["readonly"]=false;}return a;};
return D;},true);
sap.ui.predefine('sap/m/DateRangeSelection',['jquery.sap.global','sap/ui/Device','./DatePicker','./library'],function(q,D,a,l){"use strict";
var b=a.extend("sap.m.DateRangeSelection",{metadata:{library:"sap.m",properties:{delimiter:{type:"string",group:"Misc",defaultValue:'-'},secondDateValue:{type:"object",group:"Data",defaultValue:null},from:{type:"object",group:"Misc",defaultValue:null,deprecated:true},to:{type:"object",group:"Misc",defaultValue:null,deprecated:true}}}});
b.prototype.init=function(){a.prototype.init.apply(this,arguments);this._bIntervalSelection=true;};
b.prototype.onkeypress=function(E){if(!E.charCode||E.metaKey||E.ctrlKey){return;}var f=e.call(this);var s=d.call(this);var A=f.sAllowedCharacters+s+" ";var C=String.fromCharCode(E.charCode);if(C&&f.sAllowedCharacters&&A.indexOf(C)<0){E.preventDefault();}};
b.prototype._getPlaceholder=function(){var p=this.getPlaceholder();if(!p){p=this.getDisplayFormat();if(!p){p="medium";}if(this._checkStyle(p)){var L=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();var o=sap.ui.core.LocaleData.getInstance(L);p=o.getDatePattern(p);}var s=d.call(this);if(s&&s!==""){p=p+" "+s+" "+p;}}return p;};
b.prototype.setValue=function(v){if(v!==this.getValue()){this._lastValue=v;}else{return this;}this.setProperty("value",v,true);this._bValid=true;var f=[undefined,undefined];if(v){f=this._parseValue(v);this._oWantedDate=f[0];this._oWantedSecondDate=f[1];f=c.call(this,f[0],f[1]);if(!f[0]){this._bValid=false;q.sap.log.warning("Value can not be converted to a valid dates",this);}}if(this._bValid){this.setProperty("dateValue",f[0],true);this.setProperty("secondDateValue",f[1],true);this._oWantedDate=undefined;this._oWantedSecondDate=undefined;}if(this.getDomRef()){var o=this._formatValue(f[0],f[1]);if(this._$input.val()!==o){this._$input.val(o);this._setLabelVisibility();this._curpos=this._$input.cursorPos();}}return this;};
b.prototype.setValueFormat=function(v){this.setProperty("valueFormat",v,true);q.sap.log.warning("Property valueFormat is not supported in sap.m.DateRangeSelection control.",this);return this;};
b.prototype.setDisplayFormat=function(s){this.setProperty("displayFormat",s,true);var o=this._formatValue(this.getDateValue(),this.getSecondDateValue());this.setProperty("value",o,true);if(this.getDomRef()&&(this._$input.val()!==o)){this._$input.val(o);this._curpos=this._$input.cursorPos();}return this;};
b.prototype.setFrom=function(f){this.setDateValue(f);return this;};
b.prototype.getFrom=function(){return this.getDateValue();};
b.prototype.setTo=function(t){this.setSecondDateValue(t);return this;};
b.prototype.getTo=function(){return this.getSecondDateValue();};
b.prototype.setDateValue=function(o){if(o&&!(o instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}if(q.sap.equal(this.getDateValue(),o)){return this;}if(o&&(o.getTime()<this._oMinDate.getTime()||o.getTime()>this._oMaxDate.getTime())){this._bValid=false;this._oWantedDate=o;o=undefined;}else{this._bValid=true;this.setProperty("dateValue",o,true);this._oWantedDate=undefined;}var s=this.getSecondDateValue();var v=this._formatValue(o,s);if(v!==this.getValue()){this._lastValue=v;}this.setProperty("value",v,true);if(this.getDomRef()){var O=this._formatValue(o,s);if(this._$input.val()!==O){this._$input.val(O);this._setLabelVisibility();this._curpos=this._$input.cursorPos();}}return this;};
b.prototype.setSecondDateValue=function(s){if(s&&!(s instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}if(q.sap.equal(this.getSecondDateValue(),s)){return this;}if(s&&(s.getTime()<this._oMinDate.getTime()||s.getTime()>this._oMaxDate.getTime())){this._bValid=false;this._oWantedSecondDate=s;s=undefined;}else{this._bValid=true;this.setProperty("secondDateValue",s,true);this._oWantedSecondDate=undefined;}var o=this.getDateValue();var v=this._formatValue(o,s);if(v!==this.getValue()){this._lastValue=v;}this.setProperty("value",v,true);if(this.getDomRef()){var O=this._formatValue(o,s);if(this._$input.val()!==O){this._$input.val(O);this._setLabelVisibility();this._curpos=this._$input.cursorPos();}}return this;};
b.prototype.setMinDate=function(o){a.prototype.setMinDate.apply(this,arguments);if(o){var s=this.getSecondDateValue();if(s&&s.getTime()<this._oMinDate.getTime()){q.sap.log.warning("SecondDateValue not in valid date -> changed to minDate",this);this.setSecondDateValue(new Date(this._oMinDate.getTime()));}}return this;};
b.prototype.setMaxDate=function(o){a.prototype.setMaxDate.apply(this,arguments);if(o){var s=this.getSecondDateValue();if(s&&s.getTime()>this._oMaxDate.getTime()){q.sap.log.warning("SecondDateValue not in valid date -> changed to maxDate",this);this.setSecondDateValue(new Date(this._oMaxDate.getTime()));}}return this;};
b.prototype._checkMinMaxDate=function(){a.prototype._checkMinMaxDate.apply(this,arguments);if(this._oWantedSecondDate&&this._oWantedSecondDate.getTime()>=this._oMinDate.getTime()&&this._oWantedSecondDate.getTime()<=this._oMaxDate.getTime()){this.setSecondDateValue(this._oWantedSecondDate);}};
b.prototype._parseValue=function(v){var f;var g=[];var o,h;var s=d.call(this);if((s&&s!=="")&&v){g=v.split(s);if(g.length===2){if(g[0].slice(g[0].length-1,g[0].length)==" "){g[0]=g[0].slice(0,g[0].length-1);}if(g[1].slice(0,1)==" "){g[1]=g[1].slice(1);}}else{g=v.split(" "+s+" ");}if(g.length<2){var i=v.split(" ");if(i.length===2){g=i;}}}if(v&&g.length<=2){f=e.call(this);if((!s||s==="")||g.length===1){o=f.parse(v);}else if(g.length===2){o=f.parse(g[0]);h=f.parse(g[1]);if(!o||!h){o=undefined;h=undefined;}}}return[o,h];};
b.prototype._formatValue=function(o,s){var v="";var f=d.call(this);if(o){var F;F=e.call(this);if(f&&f!==""&&s){v=F.format(o)+" "+f+" "+F.format(s);}else{v=F.format(o);}}return v;};
b.prototype.onChange=function(){if(!this.getEditable()||!this.getEnabled()){return;}var v=this._$input.val();var f=[undefined,undefined];this._oWantedDate=undefined;this._oWantedSecondDate=undefined;this._bValid=true;if(v!=""){f=this._parseValue(v);f=c.call(this,f[0],f[1]);if(f[0]){v=this._formatValue(f[0],f[1]);}else{this._bValid=false;}}if(v!==this._lastValue){if(this.getDomRef()&&(this._$input.val()!==v)){this._$input.val(v);this._curpos=this._$input.cursorPos();}this._lastValue=v;this.setProperty("value",v,true);if(this._bValid){this.setProperty("dateValue",f[0],true);this.setProperty("secondDateValue",f[1],true);}this._setLabelVisibility();if(this._oPopup&&this._oPopup.isOpen()){var s=this.getDateValue();if(s){if(!this._oDateRange.getStartDate()||this._oDateRange.getStartDate().getTime()!==s.getTime()){this._oDateRange.setStartDate(new Date(s.getTime()));this._oCalendar.focusDate(s);}}else{if(this._oDateRange.getStartDate()){this._oDateRange.setStartDate(undefined);}}var E=this.getSecondDateValue();if(E){if(!this._oDateRange.getEndDate()||this._oDateRange.getEndDate().getTime()!==E.getTime()){this._oDateRange.setEndDate(new Date(E.getTime()));this._oCalendar.focusDate(E);}}else{if(this._oDateRange.getEndDate()){this._oDateRange.setEndDate(undefined);}}}_.call(this,this._bValid);}};
b.prototype._getInputValue=function(v){v=(typeof v=="undefined")?this._$input.val():v.toString();var f=this._parseValue(v);v=this._formatValue(f[0],f[1]);return v;};
b.prototype.updateDomValue=function(v){this._bCheckDomValue=true;v=(typeof v=="undefined")?this._$input.val():v.toString();this._curpos=this._$input.cursorPos();var f=this._parseValue(v);v=this._formatValue(f[0],f[1]);if(this.isActive()&&(this._$input.val()!==v)){this._$input.val(v);this._$input.cursorPos(this._curpos);}this._setLabelVisibility();return this;};
b.prototype.onsappageup=function(){};
b.prototype.onsappageupmodifiers=function(){};
b.prototype.onsappagedown=function(){};
b.prototype.onsappagedownmodifiers=function(){};
b.prototype._fillDateRange=function(){a.prototype._fillDateRange.apply(this,arguments);var E=this.getSecondDateValue();if(E){if(!this._oDateRange.getEndDate()||this._oDateRange.getEndDate().getTime()!==E.getTime()){this._oDateRange.setEndDate(new Date(E.getTime()));}}else{if(this._oDateRange.getEndDate()){this._oDateRange.setEndDate(undefined);}}};
b.prototype._selectDate=function(E){var s=this._oCalendar.getSelectedDates();if(s.length>0){var o=s[0].getStartDate();var f=s[0].getEndDate();if(o&&f){var g=this.getDateValue();var h=this.getSecondDateValue();var v;if(!q.sap.equal(o,g)||!q.sap.equal(f,h)){if(q.sap.equal(f,h)){this.setDateValue(o);}else{this.setProperty("dateValue",o,true);this.setSecondDateValue(f);}v=this.getValue();_.call(this,true);if(!D.support.touch&&!q.sap.simulateMobileOnDesktop){this._curpos=v.length;this._$input.cursorPos(this._curpos);}}else if(!this._bValid){v=this._formatValue(o,f);if(v!=this._$input.val()){this._bValid=true;if(this.getDomRef()){this._$input.val(v);}_.call(this,true);}}this._oPopup.close();}}};
b.prototype.getAccessibilityInfo=function(){var r=this.getRenderer();var i=a.prototype.getAccessibilityInfo.apply(this,arguments);var v=this.getValue()||"";if(this._bValid){var o=this.getDateValue();if(o){v=this._formatValue(o,this.getSecondDateValue());}}i.description=[v,r.getLabelledByAnnouncement(this),r.getDescribedByAnnouncement(this)].join(" ").trim();return i;};
function _(v){this.fireChangeEvent(this.getValue(),{from:this.getDateValue(),to:this.getSecondDateValue(),valid:v});}
function c(o,s){if(o&&s&&o.getTime()>s.getTime()){var t=o;o=s;s=t;}if((o&&(o.getTime()<this._oMinDate.getTime()||o.getTime()>this._oMaxDate.getTime()))||(s&&(s.getTime()<this._oMinDate.getTime()||s.getTime()>this._oMaxDate.getTime()))){return[undefined,undefined];}else{return[o,s];}}
function d(){var s=this.getDelimiter();if(!s){if(!this._sLocaleDelimiter){var L=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();var o=sap.ui.core.LocaleData.getInstance(L);var p=o.getIntervalPattern();var i=p.indexOf("{0}")+3;var I=p.indexOf("{1}");s=p.slice(i,I);if(s.length>1){if(s.slice(0,1)==" "){s=s.slice(1);}if(s.slice(s.length-1,s.length)==" "){s=s.slice(0,s.length-1);}}this._sLocaleDelimiter=s;}else{s=this._sLocaleDelimiter;}}return s;}
function e(){var p=(this.getDisplayFormat()||"medium");var f;var C=this.getDisplayFormatType();if(p==this._sUsedDisplayPattern&&C==this._sUsedDisplayCalendarType){f=this._oDisplayFormat;}else{if(this._checkStyle(p)){f=sap.ui.core.format.DateFormat.getInstance({style:p,strictParsing:true,calendarType:C});}else{f=sap.ui.core.format.DateFormat.getInstance({pattern:p,strictParsing:true,calendarType:C});}this._sUsedDisplayPattern=p;this._sUsedDisplayCalendarType=C;this._oDisplayFormat=f;}return f;}
return b;},true);
sap.ui.predefine('sap/m/DateRangeSelectionRenderer',['jquery.sap.global','sap/ui/core/Renderer','./DatePickerRenderer'],function(q,R,D){"use strict";var a=R.extend(D);
a.writeInnerValue=function(r,c){if(c._bValid){r.writeAttributeEscaped("value",c._formatValue(c.getDateValue(),c.getSecondDateValue()));}else{r.writeAttributeEscaped("value",c.getValue());}};
return a;},true);
sap.ui.predefine('sap/m/DateTimeInput',['jquery.sap.global','sap/ui/core/Control','./library','sap/ui/model/type/Date'],function(q,C,l,D){"use strict";
var a=C.extend("sap.m.DateTimeInput",{metadata:{library:"sap.m",properties:{value:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},enabled:{type:"boolean",group:"Behavior",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:sap.ui.core.ValueState.None},valueStateText:{type:"string",group:"Misc",defaultValue:null},showValueStateMessage:{type:"boolean",group:"Misc",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:null},placeholder:{type:"string",group:"Misc",defaultValue:null},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:sap.ui.core.TextAlign.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},type:{type:"sap.m.DateTimeInputType",group:"Data",defaultValue:sap.m.DateTimeInputType.Date},displayFormat:{type:"string",group:"Appearance",defaultValue:null},valueFormat:{type:"string",group:"Data",defaultValue:null},dateValue:{type:"object",group:"Data",defaultValue:null}},aggregations:{_picker:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"string"},dateValue:{type:"object"},valid:{type:"boolean"}}}}}});
!(function(p,$,d){var o=sap.m.getLocaleData();$.extend(p,{_types:{Date:{valueFormat:o.getDatePattern("short"),displayFormat:o.getDatePattern("medium")},Time:{valueFormat:o.getTimePattern("short"),displayFormat:o.getTimePattern("short")},DateTime:{valueFormat:o.getDateTimePattern("short"),displayFormat:o.getDateTimePattern("short")}}});["Time","Date"].forEach(function(t,n){["valueFormat","displayFormat"].forEach(function(f){var T=p._types;T.DateTime[f]=T.DateTime[f].replace("{"+n+"}",T[t][f]);});});}(a.prototype,q,sap.ui.Device));
a.prototype.init=function(){this.setType(sap.m.DateTimeInputType.Date);};
a.prototype.onBeforeRendering=function(){b.call(this);};
a.prototype.getFocusDomRef=function(){var p=_.call(this);return p.getFocusDomRef();};
a.prototype.getIdForLabel=function(){var p=_.call(this);return p.getIdForLabel();};
a.prototype.setType=function(t){if(t==this.getType()&&_.call(this)){return this;}this.destroyAggregation("_picker");var p;switch(t){case sap.m.DateTimeInputType.DateTime:q.sap.require("sap.m.DateTimePicker");p=new sap.m.DateTimePicker(this.getId()+"-Picker");break;case sap.m.DateTimeInputType.Time:q.sap.require("sap.m.TimePicker");p=new sap.m.TimePicker(this.getId()+"-Picker",{localeId:sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString()});break;default:q.sap.require("sap.m.DatePicker");p=new sap.m.DatePicker(this.getId()+"-Picker");break;}p.setDisplayFormat(this.getDisplayFormat()||this._types[t].displayFormat);p.setValueFormat(this.getValueFormat()||this._types[t].valueFormat);if(this.getDateValue()){p.setDateValue(this.getDateValue());}p.setEnabled(this.getEnabled());p.setEditable(this.getEditable());p.setValueState(this.getValueState());p.setValueStateText(this.getValueStateText());p.setShowValueStateMessage(this.getShowValueStateMessage());p.setName(this.getName());p.setPlaceholder(this.getPlaceholder());p.setTextAlign(this.getTextAlign());p.setTextDirection(this.getTextDirection());p.setWidth("100%");p.attachChange(c,this);var A=this.getAriaLabelledBy();for(var i=0;i<A.length;i++){p.addAriaLabelledBy(A[i]);}this.setAggregation("_picker",p);this.setProperty("type",t);return this;};
a.prototype.setWidth=function(w){this.setProperty("width",w);if(this.getDomRef()){w=this.getWidth();this.$().css("width",w);}return this;};
a.prototype.setValue=function(v){b.call(this);v=this.validateProperty("value",v);if(v.toLowerCase()=="now"){return this.setDateValue(new Date());}if(v===this.getValue()){return this;}this.setProperty("value",v,true);var p=_.call(this);p.setValue(v);var d=p.getDateValue();this.setProperty("dateValue",d,true);return this;};
a.prototype.setDateValue=function(d){if(d&&!(d instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}b.call(this);this.setProperty("dateValue",d,true);var p=_.call(this);p.setDateValue(d);var v=p.getValue();this.setProperty("value",v,true);return this;};
a.prototype.setDisplayFormat=function(d){this.setProperty("displayFormat",d,true);var p=_.call(this);p.setDisplayFormat(d||this._types[this.getType()].displayFormat);return this;};
a.prototype.setValueFormat=function(v){this.setProperty("valueFormat",v,true);var p=_.call(this);p.setValueFormat(v||this._types[this.getType()].ValueFormat);return this;};
a.prototype.setEnabled=function(e){this.setProperty("enabled",e,true);var p=_.call(this);p.setEnabled(e);return this;};
a.prototype.setEditable=function(e){this.setProperty("editable",e,true);var p=_.call(this);p.setEditable(e);return this;};
a.prototype.setValueState=function(v){this.setProperty("valueState",v,true);var p=_.call(this);p.setValueState(v);return this;};
a.prototype.setValueStateText=function(v){this.setProperty("valueStateText",v,true);var p=_.call(this);p.setValueStateText(v);return this;};
a.prototype.setShowValueStateMessage=function(s){this.setProperty("showValueStateMessage",s,true);var p=_.call(this);p.setShowValueStateMessage(s);return this;};
a.prototype.setName=function(n){this.setProperty("name",n,true);var p=_.call(this);p.setName(n);return this;};
a.prototype.setPlaceholder=function(p){this.setProperty("placeholder",p,true);var P=_.call(this);P.setPlaceholder(p);return this;};
a.prototype.setTextAlign=function(t){this.setProperty("textAlign",t,true);var p=_.call(this);p.setTextAlign(t);return this;};
a.prototype.setTextDirection=function(t){this.setProperty("textDirection",t,true);var p=_.call(this);p.setTextDirection(t);return this;};
a.prototype.addAriaLabelledBy=function(i){this.addAssociation("ariaLabelledBy",i,true);var p=_.call(this);p.addAriaLabelledBy(i);return this;};
a.prototype.removeAriaLabelledBy=function(i){this.removeAssociation("ariaLabelledBy",i,true);var p=_.call(this);p.removeAriaLabelledBy(i);return this;};
a.prototype.removeAllAriaLabelledBy=function(){this.removeAssociation("ariaLabelledBy",true);var p=_.call(this);p.removeAllAriaLabelledBy();return this;};
a.prototype.getAccessibilityInfo=function(){var p=_.call(this);return p&&p.getAccessibilityInfo?p.getAccessibilityInfo():null;};
function _(){return this.getAggregation("_picker");}
function b(){var B=this.getBinding("value");if(B&&B.oType&&(B.oType instanceof D)){var p=B.oType.getOutputPattern();var P=_.call(this);if(P.getValueFormat()!=p){P.setValueFormat(p);}if(P.getDisplayFormat()!=p){P.setDisplayFormat(p);}}}
function c(e){var v=e.getParameter("value");var d;var V=e.getParameter("valid");this.setProperty("value",v,true);if(V){d=e.oSource.getDateValue();this.setProperty("dateValue",d,true);}this.fireChange({value:v,newValue:v,valid:V,dateValue:d,newDateValue:d});}
return a;},true);
sap.ui.predefine('sap/m/DateTimeInputRenderer',['jquery.sap.global','sap/ui/core/Renderer'],function(q,R){"use strict";var D={};
D.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMDTI");var w=c.getWidth();if(w){r.addStyle("width",w);}r.writeStyles();r.writeClasses();r.write(">");var p=c.getAggregation("_picker");if(p){r.renderControl(p);}r.write("</div>");};
return D;},true);
sap.ui.predefine('sap/m/DateTimePicker',['jquery.sap.global','./DatePicker','sap/ui/model/type/Date','./library'],function(q,D,a,l){"use strict";
var b=D.extend("sap.m.DateTimePicker",{metadata:{library:"sap.m",aggregations:{_popup:{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"}}}});
var P=sap.ui.core.Control.extend("DateTimePickerPopup",{
metadata:{aggregations:{_switcher:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},calendar:{type:"sap.ui.core.Control",multiple:false},timeSliders:{type:"sap.ui.core.Control",multiple:false}}},
renderer:function(r,p){r.write("<div");r.writeControlData(p);r.addClass("sapMDateTimePopupCont");r.addClass("sapMTimePickerDropDown");r.writeClasses();r.write(">");var s=p.getAggregation("_switcher");if(s&&s.getVisible()){r.write("<div");r.addClass("sapMTimePickerSwitch");r.writeClasses();r.write(">");r.renderControl(s);r.write("</div>");}var C=p.getCalendar();if(C){r.renderControl(C);}r.write("<div");r.addClass("sapMTimePickerSep");r.writeClasses();r.write(">");r.write("</div>");var S=p.getTimeSliders();if(S){r.renderControl(S);}r.write("</div>");},
init:function(){},
onBeforeRendering:function(){var s=this.getAggregation("_switcher");if(sap.ui.Device.system.phone||q('html').hasClass("sapUiMedia-Std-Phone")){if(!s){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");var i=r.getText("DATETIMEPICKER_DATE");var t=r.getText("DATETIMEPICKER_TIME");s=new sap.m.SegmentedButton(this.getId()+"-Switch",{selectedKey:"Cal",items:[new sap.m.SegmentedButtonItem(this.getId()+"-Switch-Cal",{key:"Cal",text:i}),new sap.m.SegmentedButtonItem(this.getId()+"-Switch-Sli",{key:"Sli",text:t})]});s.attachSelect(this._handleSelect,this);this.setAggregation("_switcher",s,true);}else{s.setVisible(true);s.setSelectedKey("Cal");}}else if(s){s.setVisible(false);}},
onAfterRendering:function(){if(sap.ui.Device.system.phone||q('html').hasClass("sapUiMedia-Std-Phone")){var s=this.getAggregation("_switcher");var k=s.getSelectedKey();this._switchVisibility(k);if(sap.ui.Device.system.phone){this._adjustTimePickerHeightOnPhone();}}},
_adjustTimePickerHeightOnPhone:function(){var s=this.getAggregation("_switcher"),S=s.$().children(0).css("height").replace('px','');this.$().css("height",(document.documentElement.clientHeight-parseInt(S,10))+"px");},
_handleSelect:function(E){this._switchVisibility(E.getParameter("key"));},
_switchVisibility:function(k){var C=this.getCalendar();var s=this.getTimeSliders();if(!C||!s){return;}if(k=="Cal"){C.$().css("display","");s.$().css("display","none");C.focus();}else{C.$().css("display","none");s.$().css("display","");s.updateSlidersValues();s._onOrientationChanged();s._initFocus();}},
switchToTime:function(){var s=this.getAggregation("_switcher");if(s&&s.getVisible()){s.setSelectedKey("Sli");this._switchVisibility("Sli");}},
getSpecialDates:function(){return this._oDateTimePicker.getSpecialDates();}
});
b.prototype.init=function(){D.prototype.init.apply(this,arguments);this._bOnlyCalendar=false;};
b.prototype.exit=function(){D.prototype.exit.apply(this,arguments);if(this._oSliders){this._oSliders.destroy();delete this._oSliders;}this._oPopupContent=undefined;};
b.prototype.setDisplayFormat=function(s){D.prototype.setDisplayFormat.apply(this,arguments);if(this._oSliders){this._oSliders.setFormat(g.call(this));}return this;};
b.prototype._getFormatInstance=function(A,i){var m=q.extend({},A);var s=-1;if(m.style){s=m.style.indexOf("/");}if(i){var o=q.extend({},m);if(s>0){o.style=o.style.substr(0,s);}this._oDisplayFormatDate=sap.ui.core.format.DateFormat.getInstance(o);}return sap.ui.core.format.DateFormat.getDateTimeInstance(m);};
b.prototype._checkStyle=function(p){if(D.prototype._checkStyle.apply(this,arguments)){return true;}else if(p.indexOf("/")>0){var s=["short","medium","long","full"];var S=false;for(var i=0;i<s.length;i++){var k=s[i];for(var j=0;j<s.length;j++){var m=s[j];if(p==k+"/"+m){S=true;break;}}if(S){break;}}return S;}return false;};
b.prototype._parseValue=function(v,i){var o=D.prototype._parseValue.apply(this,arguments);if(i&&!o){o=this._oDisplayFormatDate.parse(v);if(o){var O=this.getDateValue();if(!O){O=new Date();}o.setHours(O.getHours());o.setMinutes(O.getMinutes());o.setSeconds(O.getSeconds());o.setMilliseconds(O.getMilliseconds());}}return o;};
b.prototype._getPlaceholderPattern=function(L,p){var s=p.indexOf("/");if(s>0){return L.getCombinedDateTimePattern(p.substr(0,s),p.substr(s+1));}else{return L.getCombinedDateTimePattern(p,p);}};
b.prototype._createPopup=function(){if(!this._oPopup){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");var o=r.getText("TIMEPICKER_SET");var C=r.getText("TIMEPICKER_CANCEL");this._oPopupContent=new P(this.getId()+"-PC");this._oPopupContent._oDateTimePicker=this;this._oPopup=new sap.m.ResponsivePopover(this.getId()+"-RP",{showCloseButton:false,showHeader:false,placement:sap.m.PlacementType.VerticalPreferedBottom,beginButton:new sap.m.Button(this.getId()+"-OK",{text:o,press:q.proxy(_,this)}),endButton:new sap.m.Button(this.getId()+"-Cancel",{text:C,press:q.proxy(c,this)}),content:this._oPopupContent});this._oPopup.addStyleClass("sapMDateTimePopup");var p=this._oPopup.getAggregation("_popup");if(p.setShowArrow){p.setShowArrow(false);}this._oPopup.attachBeforeOpen(d,this);this._oPopup.attachAfterOpen(e,this);this._oPopup.attachAfterClose(f,this);if(sap.ui.Device.system.desktop){this._oPopoverKeydownEventDelegate={onkeydown:function(E){var k=q.sap.KeyCodes,K=E.which||E.keyCode,A=E.altKey;if((A&&(K===k.ARROW_UP||K===k.ARROW_DOWN))||K===k.F4){_.call(this,E);this.focus();E.preventDefault();}}};this._oPopup.addEventDelegate(this._oPopoverKeydownEventDelegate,this);}this.setAggregation("_popup",this._oPopup,true);}};
b.prototype._openPopup=function(){if(!this._oPopup){return;}var p=this._oPopup.getAggregation("_popup");p.oPopup.setAutoCloseAreas([this.getDomRef()]);this._oPopup.openBy(this);var s=this._oPopup.getContent()[0]&&this._oPopup.getContent()[0].getTimeSliders();if(s){q.sap.delayedCall(0,s,s.updateSlidersValues);}};
b.prototype._createPopupContent=function(){var n=!this._oCalendar;D.prototype._createPopupContent.apply(this,arguments);if(n){this._oPopupContent.setCalendar(this._oCalendar);this._oCalendar.attachSelect(h,this);}if(!this._oSliders){q.sap.require("sap.m.TimePickerSliders");this._oSliders=new sap.m.TimePickerSliders(this.getId()+"-Sliders",{format:g.call(this),invokedBy:this.getId()});this._oPopupContent.setTimeSliders(this._oSliders);}};
b.prototype._fillDateRange=function(){var o=this.getDateValue();if(o){o=new Date(o.getTime());}else{o=new Date();}this._oCalendar.focusDate(o);if(!this._oDateRange.getStartDate()||this._oDateRange.getStartDate().getTime()!=o.getTime()){this._oDateRange.setStartDate(o);}this._oSliders.setTimeValues(o);};
b.prototype._getSelectedDate=function(){var o=D.prototype._getSelectedDate.apply(this,arguments);if(o){var i=this._oSliders.getTimeValues();var p=this._oSliders.getFormat();if(p.search("h")>=0||p.search("H")>=0){o.setHours(i.getHours());}if(p.search("m")>=0){o.setMinutes(i.getMinutes());}if(p.search("s")>=0){o.setSeconds(i.getSeconds());}if(o.getTime()<this._oMinDate.getTime()){o=new Date(this._oMinDate.getTime());}else if(o.getTime()>this._oMaxDate.getTime()){o=new Date(this._oMaxDate.getTime());}}return o;};
b.prototype.getLocaleId=function(){return sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();};
b.prototype.getAccessibilityInfo=function(){var i=D.prototype.getAccessibilityInfo.apply(this,arguments);i.type=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_DATETIMEINPUT");return i;};
function _(E){this._selectDate();}
function c(E){this.onsaphide(E);}
function d(E){}
function e(E){this._oCalendar.focus();this._oSliders._onOrientationChanged();}
function f(E){}
function g(){var s=this.getDisplayFormat();var t;var B=this.getBinding("value");if(B&&B.oType&&(B.oType instanceof a)){s=B.oType.getOutputPattern();}else{s=this.getDisplayFormat();}if(!s){s="medium";}var S=s.indexOf("/");if(S>0&&this._checkStyle(s)){s=s.substr(S+1);}if(s=="short"||s=="medium"||s=="long"||s=="full"){var L=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();var o=sap.ui.core.LocaleData.getInstance(L);t=o.getTimePattern(s);}else{t=s;}return t;}
function h(E){this._oPopupContent.switchToTime();}
return b;},true);
sap.ui.predefine('sap/m/DateTimePickerRenderer',['jquery.sap.global','sap/ui/core/Renderer','./DatePickerRenderer','./InputBaseRenderer'],function(q,R,D,I){"use strict";var a=R.extend(D);
a._getIcon=function(){return"sap-icon://date-time";};
a.getDescribedByAnnouncement=function(d){var b=I.getDescribedByAnnouncement.apply(this,arguments);return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("DATETIMEPICKER_TYPE")+" "+b;};
return a;},true);
sap.ui.predefine('sap/m/Dialog',['jquery.sap.global','./Bar','./InstanceManager','./AssociativeOverflowToolbar','./ToolbarSpacer','./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/Popup','sap/ui/core/delegate/ScrollEnablement','sap/ui/core/theming/Parameters','sap/ui/core/RenderManager','sap/ui/core/InvisibleText','sap/ui/core/ResizeHandler','sap/ui/Device'],function(q,B,I,A,T,l,C,a,P,S,b,R,c,d,D){"use strict";var V=sap.ui.core.ValueState;var f=D.browser.internet_explorer&&(D.browser.version<10);
var g=C.extend("sap.m.Dialog",{metadata:{interfaces:["sap.ui.core.PopupInterface"],library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},title:{type:"string",group:"Appearance",defaultValue:null},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},type:{type:"sap.m.DialogType",group:"Appearance",defaultValue:sap.m.DialogType.Standard},state:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:V.None},stretchOnPhone:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},stretch:{type:"boolean",group:"Appearance",defaultValue:false},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},horizontalScrolling:{type:"boolean",group:"Behavior",defaultValue:true},verticalScrolling:{type:"boolean",group:"Behavior",defaultValue:true},resizable:{type:"boolean",group:"Behavior",defaultValue:false},draggable:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},subHeader:{type:"sap.m.IBar",multiple:false},customHeader:{type:"sap.m.IBar",multiple:false},beginButton:{type:"sap.m.Button",multiple:false},endButton:{type:"sap.m.Button",multiple:false},buttons:{type:"sap.m.Button",multiple:true,singularName:"button"},_header:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_title:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_icon:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_toolbar:{type:"sap.m.OverflowToolbar",multiple:false,visibility:"hidden"},_valueState:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"}},associations:{leftButton:{type:"sap.m.Button",multiple:false,deprecated:true},rightButton:{type:"sap.m.Button",multiple:false,deprecated:true},initialFocus:{type:"sap.ui.core.Control",multiple:false},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{beforeOpen:{},afterOpen:{},beforeClose:{parameters:{origin:{type:"sap.m.Button"}}},afterClose:{parameters:{origin:{type:"sap.m.Button"}}}}}});
g._bPaddingByDefault=(sap.ui.getCore().getConfiguration().getCompatibilityVersion("sapMDialogWithPadding").compareTo("1.16")<0);g._mStateClasses={};g._mStateClasses[V.None]="";g._mStateClasses[V.Success]="sapMDialogSuccess";g._mStateClasses[V.Warning]="sapMDialogWarning";g._mStateClasses[V.Error]="sapMDialogError";g._mIcons={};g._mIcons[V.Success]=a.getIconURI("message-success");g._mIcons[V.Warning]=a.getIconURI("message-warning");g._mIcons[V.Error]=a.getIconURI("message-error");
g.prototype.init=function(){var t=this;this._externalIcon=undefined;this._oManuallySetSize=null;this._oManuallySetPosition=null;this._bRTL=sap.ui.getCore().getConfiguration().getRTL();this._scrollContentList=["NavContainer","Page","ScrollContainer","SplitContainer"];this.oPopup=new P();this.oPopup.setShadow(true);this.oPopup.setNavigationMode("SCOPE");if(q.device.is.iphone&&!this._bMessageType){this.oPopup.setModal(true,"sapMDialogTransparentBlk");}else{this.oPopup.setModal(true,"sapMDialogBlockLayerInit");}this.oPopup.setAnimations(q.proxy(this._openAnimation,this),q.proxy(this._closeAnimation,this));this.oPopup.onsapescape=q.proxy(function(e){if(e.originalEvent&&e.originalEvent._sapui_handledByControl){return;}this.close();e.stopPropagation();},this);this.oPopup._applyPosition=function(p,F){t._setDimensions();t._adjustScrollingPane();p.at={};if(t._oManuallySetPosition){p.at.left=t._oManuallySetPosition.x;p.at.top=t._oManuallySetPosition.y;}else{p.at.top='50%';if(t._bRTL){p.at.left='auto';}else{p.at.left='50%';}}t._deregisterContentResizeHandler();P.prototype._applyPosition.call(this,p);t._registerContentResizeHandler();};if(g._bPaddingByDefault){this.addStyleClass("sapUiPopupWithPadding");}};
g.prototype.onBeforeRendering=function(){if(this._hasSingleScrollableContent()){this.setProperty("verticalScrolling",false);this.setProperty("horizontalScrolling",false);q.sap.log.info("VerticalScrolling and horizontalScrolling in sap.m.Dialog with ID "+this.getId()+" has been disabled because there's scrollable content inside");}else if(!this._oScroller){this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:this.getHorizontalScrolling(),vertical:this.getVerticalScrolling()});}this._createToolbarButtons();if(sap.ui.getCore().getConfiguration().getAccessibility()&&this.getState()!=V.None){var v=new c({text:this.getValueStateString(this.getState())});this.setAggregation("_valueState",v);this.addAriaLabelledBy(v.getId());}};
g.prototype.onAfterRendering=function(){this._$scrollPane=this.$("scroll");this._$content=this.$("cont");this._$dialog=this.$();if(this.isOpen()){this._setInitialFocus();}if(this.getType()===sap.m.DialogType.Message||(D.system.phone&&!this.getStretch())){this.$("footer").removeClass("sapContrast sapContrastPlus");}};
g.prototype.exit=function(){I.removeDialogInstance(this);this._deregisterContentResizeHandler();this._deregisterResizeHandler();if(this.oPopup){this.oPopup.detachOpened(this._handleOpened,this);this.oPopup.detachClosed(this._handleClosed,this);this.oPopup.destroy();this.oPopup=null;}if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._header){this._header.destroy();this._header=null;}if(this._headerTitle){this._headerTitle.destroy();this._headerTitle=null;}if(this._iconImage){this._iconImage.destroy();this._iconImage=null;}};
g.prototype.open=function(){var p=this.oPopup;p.setInitialFocusId(this.getId());if(p.isOpen()){return this;}this._oCloseTrigger=null;this.fireBeforeOpen();p.attachOpened(this._handleOpened,this);p.setContent(this);p.open();this._registerResizeHandler();I.addDialogInstance(this);return this;};
g.prototype.close=function(){this.$().removeClass('sapDialogDisableTransition');this._deregisterResizeHandler();var p=this.oPopup;var e=this.oPopup.getOpenState();if(!(e===sap.ui.core.OpenState.CLOSED||e===sap.ui.core.OpenState.CLOSING)){sap.m.closeKeyboard();this.fireBeforeClose({origin:this._oCloseTrigger});p.attachClosed(this._handleClosed,this);this._bDisableRepositioning=false;this._oManuallySetPosition=null;this._oManuallySetSize=null;p.close();this._deregisterContentResizeHandler();}return this;};
g.prototype.isOpen=function(){return this.oPopup&&this.oPopup.isOpen();};
g.prototype._handleOpened=function(){this.oPopup.detachOpened(this._handleOpened,this);this._setInitialFocus();this.fireAfterOpen();};
g.prototype._handleClosed=function(){if(!this.oPopup){return;}this.oPopup.detachClosed(this._handleClosed,this);if(this.getDomRef()){R.preserveContent(this.getDomRef());this.$().remove();}I.removeDialogInstance(this);this.fireAfterClose({origin:this._oCloseTrigger});};
g.prototype.onfocusin=function(e){var s=e.target;if(s.id===this.getId()+"-firstfe"){var L=this.$("footer").lastFocusableDomRef()||this.$("cont").lastFocusableDomRef()||(this.getSubHeader()&&this.getSubHeader().$().firstFocusableDomRef())||(this._getAnyHeader()&&this._getAnyHeader().$().lastFocusableDomRef());if(L){q.sap.focus(L);}}else if(s.id===this.getId()+"-lastfe"){var F=(this._getAnyHeader()&&this._getAnyHeader().$().firstFocusableDomRef())||(this.getSubHeader()&&this.getSubHeader().$().firstFocusableDomRef())||this.$("cont").firstFocusableDomRef()||this.$("footer").firstFocusableDomRef();if(F){q.sap.focus(F);}}};
g.prototype._openAnimation=function(r,i,o){r.addClass("sapMDialogOpen");if(f){r.fadeIn(200,o);}else{r.css("display","block");setTimeout(o,210);}};
g.prototype._closeAnimation=function(r,i,e){r.removeClass("sapMDialogOpen");if(f){r.fadeOut(200,e);}else{setTimeout(e,210);}};
g.prototype._setDimensions=function(){var $=this.$(),s=this.getStretch(),e=this.getStretchOnPhone()&&D.system.phone,m=this._bMessageType,o={};if(!s){if(!this._oManuallySetSize){o.width=this.getContentWidth()||undefined;o.height=this.getContentHeight()||undefined;}else{o.width=this._oManuallySetSize.width;o.height=this._oManuallySetSize.height;}}if(o.width=='auto'){o.width=undefined;}if(o.height=='auto'){o.height=undefined;}if((s&&!m)||(e)){this.$().addClass('sapMDialogStretched');}$.css(o);if(!s&&!this._oManuallySetSize&&!this._bDisableRepositioning){this._applyCustomTranslate();}if(window.navigator.userAgent.toLowerCase().indexOf("chrome")!==-1&&this.getStretch()){$.find('> footer').css({bottom:'0.001px'});}};
g.prototype._adjustScrollingPane=function(){if(this._oScroller){this._oScroller.refresh();}};
g.prototype._reposition=function(){};
g.prototype._repositionAfterOpen=function(){};
g.prototype._reapplyPosition=function(){this._adjustScrollingPane();};
g.prototype._onResize=function(){var $=this.$(),e=this.$('cont'),s=this.getContentHeight(),i,j,k;if(this._oManuallySetSize){return;}if(!s||s=='auto'){e.css({height:'auto'});i=parseFloat($.height());j=parseFloat($.css("border-top-width"));k=parseFloat($.css("border-bottom-width"));e.height(Math.round(i+j+k));}if(!this.getStretch()&&!this._oManuallySetSize&&!this._bDisableRepositioning){this._applyCustomTranslate();}if(D.browser.chrome){var F=this.$("footer");F.css("height","auto");setTimeout(function(){F.css("height","");},10);}};
g.prototype._applyCustomTranslate=function(){var $=this.$(),t,s,i=$.innerWidth(),e=$.innerHeight();if(D.system.desktop&&(i%2!==0||e%2!==0)){if(!this._bRTL){t='-'+Math.floor(i/2)+"px";}else{t=Math.floor(i/2)+"px";}s='-'+Math.floor(e/2)+"px";$.css('transform','translate('+t+','+s+') scale(1)');}else{$.css('transform','');}};
g.prototype._createHeader=function(){if(!this._header){this._header=new B(this.getId()+"-header").addStyleClass("sapMDialogTitle");this.setAggregation("_header",this._header,false);}};
g.prototype._hasSingleScrollableContent=function(){var e=this.getContent(),i;while(e.length===1&&e[0]instanceof sap.ui.core.mvc.View){e=e[0].getContent();}if(e.length===1){for(i=0;i<this._scrollContentList.length;i++){if(e[0]instanceof sap.m[this._scrollContentList[i]]){return true;}}}return false;};
g.prototype._initBlockLayerAnimation=function(){this.oPopup._hideBlockLayer=function(){var $=q("#sap-ui-blocklayer-popup");$.removeClass("sapMDialogTransparentBlk");P.prototype._hideBlockLayer.call(this);};};
g.prototype._clearBlockLayerAnimation=function(){if(q.device.is.iphone&&!this._bMessageType){delete this.oPopup._showBlockLayer;this.oPopup._hideBlockLayer=function(){var $=q("#sap-ui-blocklayer-popup");$.removeClass("sapMDialogTransparentBlk");P.prototype._hideBlockLayer.call(this);};}};
g.prototype._getFocusId=function(){return this.getInitialFocus()||this._getFirstFocusableContentSubHeader()||this._getFirstFocusableContentElementId()||this._getFirstVisibleButtonId()||this.getId();};
g.prototype._getFirstVisibleButtonId=function(){var o=this.getBeginButton(),e=this.getEndButton(),j=this.getButtons(),s="";if(o&&o.getVisible()){s=o.getId();}else if(e&&e.getVisible()){s=e.getId();}else if(j&&j.length>0){for(var i=0;i<j.length;i++){if(j[i].getVisible()){s=j[i].getId();break;}}}return s;};
g.prototype._getFirstFocusableContentSubHeader=function(){var $=this.$().find('.sapMDialogSubHeader');var r;var F=$.firstFocusableDomRef();if(F){r=F.id;}return r;};
g.prototype._getFirstFocusableContentElementId=function(){var r="";var $=this.$("cont");var F=$.firstFocusableDomRef();if(F){r=F.id;}return r;};
g.prototype._setInitialFocus=function(){var F=this._getFocusId();var o=sap.ui.getCore().byId(F);var e;if(o){if(o.getVisible&&!o.getVisible()){this.focus();return;}e=o.getFocusDomRef();}e=e||q.sap.domById(F);if(!e){this.setInitialFocus("");e=sap.ui.getCore().byId(this._getFocusId());}if(!this.getInitialFocus()){this.setAssociation('initialFocus',e?e.id:this.getId(),true);}if(D.system.desktop||(e&&!/input|textarea|select/i.test(e.tagName))){q.sap.focus(e);}else{this.focus();}};
g.prototype.getScrollDelegate=function(){return this._oScroller;};
g.prototype._composeAggreNameInHeader=function(p){var H;if(p==="Begin"){H="contentLeft";}else if(p==="End"){H="contentRight";}else{H="content"+p;}return H;};
g.prototype._isToolbarEmpty=function(){var e=this._oToolbar.getContent().filter(function(i){return i.getMetadata().getName()!=='sap.m.ToolbarSpacer';});return e.length===0;};
g.prototype._setButton=function(o,p,s){return this;};
g.prototype._getButton=function(p){var s=p.toLowerCase()+"Button",e="_o"+this._firstLetterUpperCase(p)+"Button";if(D.system.phone){return this.getAggregation(s,null,true);}else{return this[e];}};
g.prototype._getButtonFromHeader=function(p){if(this._header){var H=this._composeAggreNameInHeader(this._firstLetterUpperCase(p)),e=this._header.getAggregation(H);return e&&e[0];}else{return null;}};
g.prototype._firstLetterUpperCase=function(v){return v.charAt(0).toUpperCase()+v.slice(1);};
g.prototype._getAnyHeader=function(){var o=this.getCustomHeader();if(o){return o;}else{var s=this.getShowHeader();if(!s){return null;}this._createHeader();return this._header;}};
g.prototype._deregisterResizeHandler=function(){if(this._resizeListenerId){d.deregister(this._resizeListenerId);this._resizeListenerId=null;}D.resize.detachHandler(this._onResize,this);};
g.prototype._registerResizeHandler=function(){var _=this.$("scroll");this._resizeListenerId=d.register(_.get(0),q.proxy(this._onResize,this));D.resize.attachHandler(this._onResize,this);this._onResize();};
g.prototype._deregisterContentResizeHandler=function(){if(this._sContentResizeListenerId){d.deregister(this._sContentResizeListenerId);this._sContentResizeListenerId=null;}};
g.prototype._registerContentResizeHandler=function(){if(!this._sContentResizeListenerId){this._sContentResizeListenerId=d.register(this.getDomRef("scrollCont"),q.proxy(this._onResize,this));}this._onResize();};
g.prototype._attachHandler=function(o){var t=this;if(!this._oButtonDelegate){this._oButtonDelegate={ontap:function(){t._oCloseTrigger=this;}};}if(o){o.addDelegate(this._oButtonDelegate,true,o);}};
g.prototype._createToolbarButtons=function(){var t=this._getToolbar();var e=this.getButtons();var i=this.getBeginButton();var j=this.getEndButton(),k=this,m=[i,j];m.forEach(function(o){if(o&&k._oButtonDelegate){o.removeDelegate(k._oButtonDelegate);}});t.removeAllContent();t.addContent(new T());m.forEach(function(o){k._attachHandler(o);});if(e&&e.length){e.forEach(function(n){t.addContent(n);});}else{if(i){t.addContent(i);}if(j){t.addContent(j);}}};
g.prototype._getToolbar=function(){if(!this._oToolbar){this._oToolbar=new A(this.getId()+"-footer").addStyleClass("sapMTBNoBorders").applyTagAndContextClassFor("footer");this._oToolbar._isControlsInfoCached=function(){return false;};this.setAggregation("_toolbar",this._oToolbar);}return this._oToolbar;};
g.prototype.getValueStateString=function(v){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");switch(v){case(sap.ui.core.ValueState.Success):return r.getText("LIST_ITEM_STATE_SUCCESS");case(sap.ui.core.ValueState.Warning):return r.getText("LIST_ITEM_STATE_WARNING");case(sap.ui.core.ValueState.Error):return r.getText("LIST_ITEM_STATE_ERROR");default:return"";}};
g.prototype.setSubHeader=function(o){this.setAggregation("subHeader",o);if(o){o.setVisible=function(i){this.$().toggleClass('sapMDialogWithSubHeader',i);o.setProperty("visible",i);}.bind(this);}return o;};
g.prototype.setLeftButton=function(v){if(!(v instanceof sap.m.Button)){v=sap.ui.getCore().byId(v);}this.setBeginButton(v);return this.setAssociation("leftButton",v);};
g.prototype.setRightButton=function(v){if(!(v instanceof sap.m.Button)){v=sap.ui.getCore().byId(v);}this.setEndButton(v);return this.setAssociation("rightButton",v);};
g.prototype.getLeftButton=function(){var o=this.getBeginButton();return o?o.getId():null;};
g.prototype.getRightButton=function(){var e=this.getEndButton();return e?e.getId():null;};
g.prototype.getAggregation=function(s,o,p){var e=C.prototype.getAggregation.apply(this,Array.prototype.slice.call(arguments,0,2));if(s==='buttons'&&e.length===0){this.getBeginButton()&&e.push(this.getBeginButton());this.getEndButton()&&e.push(this.getEndButton());}return e;};
g.prototype.getAriaLabelledBy=function(){var e=this._getAnyHeader(),i=this.getAssociation("ariaLabelledBy",[]).slice();var s=this.getSubHeader();if(s){i.unshift(s.getId());}if(e){i.unshift(e.getId());}return i;};
g.prototype.setTitle=function(t){this.setProperty("title",t,true);if(this._headerTitle){this._headerTitle.setText(t);}else{this._headerTitle=new sap.m.Title(this.getId()+"-title",{text:t,level:"H1"}).addStyleClass("sapMDialogTitle");this._createHeader();this._header.addContentMiddle(this._headerTitle);}return this;};
g.prototype.setCustomHeader=function(o){if(o){o.addStyleClass("sapMDialogTitle");}this.setAggregation("customHeader",o);};
g.prototype.setState=function(s){var F={},$=this.$(),n;F[s]=true;this.setProperty("state",s,true);for(n in g._mStateClasses){$.toggleClass(g._mStateClasses[n],!!F[n]);}this.setIcon(g._mIcons[s],true);return this;};
g.prototype.setIcon=function(i,e){if(!e){this._externalIcon=i;}else{if(this._externalIcon){i=this._externalIcon;}}if(i){if(i!==this.getIcon()){if(this._iconImage){this._iconImage.setSrc(i);}else{this._iconImage=a.createControlByURI({id:this.getId()+"-icon",src:i,useIconTooltip:false},sap.m.Image).addStyleClass("sapMDialogIcon");this._createHeader();this._header.insertAggregation("contentMiddle",this._iconImage,0);}}}else{var s=this.getState();if(!e&&s!==V.None){if(this._iconImage){this._iconImage.setSrc(g._mIcons[s]);}}else{if(this._iconImage){this._iconImage.destroy();this._iconImage=null;}}}this.setProperty("icon",i,true);return this;};
g.prototype.setType=function(t){var o=this.getType();if(o===t){return this;}this._bMessageType=(t===sap.m.DialogType.Message);return this.setProperty("type",t,false);};
g.prototype.setStretch=function(s){this._bStretchSet=true;return this.setProperty("stretch",s);};
g.prototype.setStretchOnPhone=function(s){if(this._bStretchSet){q.sap.log.warning("sap.m.Dialog: stretchOnPhone property is deprecated. Setting stretchOnPhone property is ignored when there's already stretch property set.");return this;}this.setProperty("stretchOnPhone",s);return this.setProperty("stretch",s&&D.system.phone);};
g.prototype.setVerticalScrolling=function(v){var o=this.getVerticalScrolling(),H=this._hasSingleScrollableContent();if(H){q.sap.log.warning("sap.m.Dialog: property verticalScrolling automatically reset to false. See documentation.");v=false;}if(o===v){return this;}this.$().toggleClass("sapMDialogVerScrollDisabled",!v);this.setProperty("verticalScrolling",v);if(this._oScroller){this._oScroller.setVertical(v);}return this;};
g.prototype.setHorizontalScrolling=function(v){var o=this.getHorizontalScrolling(),H=this._hasSingleScrollableContent();if(H){q.sap.log.warning("sap.m.Dialog: property horizontalScrolling automatically reset to false. See documentation.");v=false;}if(o===v){return this;}this.$().toggleClass("sapMDialogHorScrollDisabled",!v);this.setProperty("horizontalScrolling",v);if(this._oScroller){this._oScroller.setHorizontal(v);}return this;};
g.prototype.setInitialFocus=function(i){return this.setAssociation("initialFocus",i,true);};
g.prototype.forceInvalidate=C.prototype.invalidate;
g.prototype.invalidate=function(o){if(this.isOpen()){this.forceInvalidate(o);}};
function h(e){var $=q(e);var o=$.control(0);if(!o||o.getMetadata().getInterfaces().indexOf("sap.m.IBar")>-1){return true;}return $.hasClass('sapMDialogTitle');}
if(D.system.desktop){g.prototype.ondblclick=function(e){if(h(e.target)){this._bDisableRepositioning=false;this._oManuallySetPosition=null;this._oManuallySetSize=null;this.oPopup&&this.oPopup._applyPosition(this.oPopup._oLastPosition,true);this._$dialog.removeClass('sapMDialogTouched');}};g.prototype.onmousedown=function(e){if(e.which===3){return;}if(this.getStretch()||(!this.getDraggable()&&!this.getResizable())){return;}var t;var i=this;var $=q(document);var j=q(e.target);var r=j.hasClass('sapMDialogResizeHandler')&&this.getResizable();var m=function(v){t=t?clearTimeout(t):setTimeout(function(){v();},0);};var k=30;var w=window.innerWidth;var n=window.innerHeight;var o={x:e.pageX,y:e.pageY,width:i._$dialog.width(),height:i._$dialog.height(),offset:{x:e.offsetX?e.offsetX:e.originalEvent.layerX,y:e.offsetY?e.offsetY:e.originalEvent.layerY},position:{x:i._$dialog.offset().left,y:i._$dialog.offset().top}};if((h(e.target)&&this.getDraggable())||r){i._bDisableRepositioning=true;i._$dialog.addClass('sapDialogDisableTransition');i._$dialog.addClass('sapMDialogTouched');i._oManuallySetPosition={x:o.position.x,y:o.position.y};i._$dialog.css({left:Math.min(Math.max(0,i._oManuallySetPosition.x),w-k),top:Math.min(Math.max(0,i._oManuallySetPosition.y),n-k),transform:""});}if(h(e.target)&&this.getDraggable()){$.on("mousemove.sapMDialog",function(e){m(function(){i._bDisableRepositioning=true;i._oManuallySetPosition={x:e.pageX-o.offset.x,y:e.pageY-o.offset.y};i._$dialog.css({left:Math.min(Math.max(0,i._oManuallySetPosition.x),w-k),top:Math.min(Math.max(0,i._oManuallySetPosition.y),n-k),transform:""});});});}else if(r){i._$dialog.addClass('sapMDialogResizing');var s={};var p=parseInt(i._$dialog.css('min-width'),10);var u=o.x+o.width-p;i.$('cont').height('');$.on("mousemove.sapMDialog",function(e){m(function(){i._bDisableRepositioning=true;i._oManuallySetSize={width:o.width+e.pageX-o.x,height:o.height+e.pageY-o.y};if(i._bRTL){s.left=Math.min(Math.max(e.pageX,0),u);s.transform="";i._oManuallySetSize.width=o.width+o.x-Math.max(e.pageX,0);}s.width=i._oManuallySetSize.width;s.height=i._oManuallySetSize.height;i._$dialog.css(s);});});}else{return;}$.on("mouseup.sapMDialog",function(){var v=i.$(),x=i.$('cont');$.off("mouseup.sapMDialog, mousemove.sapMDialog");if(r){i._$dialog.removeClass('sapMDialogResizing');x.height(parseInt(v.height(),10)+parseInt(v.css("border-top-width"),10)+parseInt(v.css("border-bottom-width"),10));}});e.preventDefault();e.stopPropagation();};}return g;},true);
sap.ui.predefine('sap/m/DialogRenderer',['jquery.sap.global','./BarRenderer'],function(q,B){"use strict";var D={};
D.render=function(r,c){var a=c.getId(),t=c.getType(),h=c._getAnyHeader(),s=c.getSubHeader(),m=(t===sap.m.DialogType.Message),l=c.getBeginButton(),R=c.getEndButton(),H=c.getHorizontalScrolling(),v=c.getVerticalScrolling(),S=c.getState(),b=c.getStretch(),d=c.getStretchOnPhone()&&sap.ui.Device.system.phone,e=c.getResizable(),f=c.getDraggable(),V=c.getAggregation("_valueState");if(h){h.applyTagAndContextClassFor("header");}if(s){s.applyTagAndContextClassFor("subheader");}var g=c.getContentWidth()&&c.getContentWidth()!='auto'?' width: '+c.getContentWidth()+';':'';var j=c.getContentHeight()&&c.getContentHeight()!='auto'?' height: '+c.getContentHeight()+';':'';var k="style='"+g+j+"'";r.write('<div '+k);r.writeControlData(c);r.addClass("sapMDialog");r.addClass("sapMDialog-CTX");r.addClass("sapMPopup-CTX");if(c.isOpen()){r.addClass("sapMDialogOpen");}if(window.devicePixelRatio>1){r.addClass("sapMDialogHighPixelDensity");}if(c._bDisableRepositioning){r.addClass("sapMDialogTouched");}if(b||(d)){r.addClass("sapMDialogStretched");}r.addClass(sap.m.Dialog._mStateClasses[S]);var n=!c._oToolbar&&!l&&!R;var o=c._oToolbar&&c._isToolbarEmpty()&&!l&&!R;if(n||o){r.addClass("sapMDialog-NoFooter");}if(!h){r.addClass("sapMDialog-NoHeader");}if(S==="Error"||S==="Warning"){r.writeAccessibilityState(c,{role:"alertdialog"});}else{r.writeAccessibilityState(c,{role:"dialog"});}if(c._forceDisableScrolling){r.addClass("sapMDialogWithScrollCont");}if(s&&s.getVisible()){r.addClass("sapMDialogWithSubHeader");}if(m){r.addClass("sapMMessageDialog");}if(!v){r.addClass("sapMDialogVerScrollDisabled");}if(!H){r.addClass("sapMDialogHorScrollDisabled");}if(sap.ui.Device.system.phone){r.addClass("sapMDialogPhone");}if(f&&!b){r.addClass("sapMDialogDraggable");}if(sap.m._bSizeCompact){r.addClass("sapUiSizeCompact");}r.writeClasses();var T=c.getTooltip_AsString();if(T){r.writeAttributeEscaped("title",T);}r.writeAttribute("tabindex","-1");r.write(">");if(sap.ui.Device.system.desktop){if(e&&!b){r.writeIcon("sap-icon://resize-corner",["sapMDialogResizeHandler"],{"title":""});}r.write('<span id="'+c.getId()+'-firstfe" tabindex="0"/>');}if(h){r.renderControl(h);}if(s){s.addStyleClass("sapMDialogSubHeader");r.renderControl(s);}if(V){r.renderControl(V);}r.write('<section id="'+a+'-cont" class="sapMDialogSection">');r.write('<div id="'+a+'-scroll" class="sapMDialogScroll">');r.write('<div id="'+a+'-scrollCont" class="sapMDialogScrollCont');if(c.getStretch()||j){r.write(' sapMDialogStretchContent');}r.write('">');var C=c.getContent();for(var i=0;i<C.length;i++){r.renderControl(C[i]);}r.write("</div>");r.write("</div>");r.write("</section>");if(!(n||o)){r.renderControl(c._oToolbar);}if(sap.ui.Device.system.desktop){r.write('<span id="'+c.getId()+'-lastfe" tabindex="0"/>');}r.write("</div>");};
return D;},true);
sap.ui.predefine('sap/m/DisplayListItem',['jquery.sap.global','./ListItemBase','./library'],function(q,L,l){"use strict";
var D=L.extend("sap.m.DisplayListItem",{metadata:{library:"sap.m",properties:{label:{type:"string",group:"Misc",defaultValue:null},value:{type:"string",group:"Data",defaultValue:null},valueTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}}}});
return D;},true);
sap.ui.predefine('sap/m/DisplayListItemRenderer',['jquery.sap.global','./ListItemBaseRenderer','sap/ui/core/Renderer'],function(q,L,R){"use strict";var D=R.extend(L);
D.renderLIAttributes=function(r,l){r.addClass("sapMDLI");};
D.renderLIContent=function(r,l){var i=l.getLabel();if(i){r.write("<label for='"+l.getId()+"-value' class='sapMDLILabel'>");r.writeEscaped(l.getLabel());r.write("</label>");}var a=l.getValue();var v=l.getValueTextDirection();if(a){r.write("<div id='"+l.getId()+"-value' class='sapMDLIValue'");if(v!=sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",v.toLowerCase());}r.write(">");r.writeEscaped(l.getValue());r.write("</div>");}};
return D;},true);
sap.ui.predefine('sap/m/DraftIndicator',["sap/ui/core/Control","sap/m/Label"],function(C,L){"use strict";
var D=C.extend("sap.m.DraftIndicator",{metadata:{properties:{state:{type:"sap.m.DraftIndicatorState",group:"Behavior",defaultValue:sap.m.DraftIndicatorState.Clear},minDisplayTime:{type:"int",group:"Behavior",defaultValue:1500}},aggregations:{_label:{type:"sap.m.Label",multiple:false,visibility:"hidden"}}}});
var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");D._oTEXTS={};D._oTEXTS[sap.m.DraftIndicatorState.Saving]=b.getText("DRAFT_INDICATOR_SAVING_DRAFT");D._oTEXTS[sap.m.DraftIndicatorState.Saved]=b.getText("DRAFT_INDICATOR_DRAFT_SAVED");D._oTEXTS[sap.m.DraftIndicatorState.Clear]="";
D.prototype.init=function(){this.aQueue=[];this.iDelayedCallId=null;};
D.prototype.setState=function(s){this.setProperty("state",s);this._addToQueue(s);if(s===sap.m.DraftIndicatorState.Saving){this._addToQueue(sap.m.DraftIndicatorState.Clear);}return this;};
D.prototype._getLabel=function(){var c=this.getAggregation('_label');if(!c){var c=new sap.m.Label({id:this.getId()+"-label"});this.setAggregation('_label',c,true);c=this.getAggregation('_label');}return c;};
D.prototype.showDraftSaving=function(){this._addToQueue(sap.m.DraftIndicatorState.Saving);this._addToQueue(sap.m.DraftIndicatorState.Clear);};
D.prototype.showDraftSaved=function(){this._addToQueue(sap.m.DraftIndicatorState.Saved);};
D.prototype.clearDraftState=function(){this._addToQueue(sap.m.DraftIndicatorState.Clear);};
D.prototype._addToQueue=function(s){this.aQueue.push(s);this._processQueue();};
D.prototype._processQueue=function(){if(this.iDelayedCallId){return;}var n=this.aQueue.shift();var t=this.getMinDisplayTime();if(!n){return;}this._applyState(n);if(n===sap.m.DraftIndicatorState.Clear){this._proceed();return;}this.iDelayedCallId=jQuery.sap.delayedCall(t,this,this._proceed);};
D.prototype._proceed=function(){this._resetDraftTimer();this._processQueue();};
D.prototype._applyState=function(s){this._getLabel().setText(D._oTEXTS[s]);};
D.prototype._resetDraftTimer=function(){jQuery.sap.clearDelayedCall(this.iDelayedCallId);this.iDelayedCallId=null;};
return D;},true);
sap.ui.predefine('sap/m/DraftIndicatorRenderer',['jquery.sap.global'],function(q){"use strict";var D={};
D.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMDraftIndicator");r.writeClasses();r.write(">");var l=c._getLabel();r.renderControl(l);r.write("</div>");};
return D;},true);
sap.ui.predefine('sap/m/FacetFilter',['jquery.sap.global','./NavContainer','./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/delegate/ItemNavigation'],function(q,N,l,C,I,a){"use strict";
var F=C.extend("sap.m.FacetFilter",{metadata:{interfaces:["sap.ui.core.IShrinkable"],library:"sap.m",properties:{showPersonalization:{type:"boolean",group:"Appearance",defaultValue:false},type:{type:"sap.m.FacetFilterType",group:"Appearance",defaultValue:sap.m.FacetFilterType.Simple},liveSearch:{type:"boolean",group:"Behavior",defaultValue:true},showSummaryBar:{type:"boolean",group:"Behavior",defaultValue:false},showReset:{type:"boolean",group:"Behavior",defaultValue:true},showPopoverOKButton:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"lists",aggregations:{lists:{type:"sap.m.FacetFilterList",multiple:true,singularName:"list"},buttons:{type:"sap.m.Button",multiple:true,singularName:"button",visibility:"hidden"},removeFacetIcons:{type:"sap.ui.core.Icon",multiple:true,singularName:"removeFacetIcon",visibility:"hidden"},popover:{type:"sap.m.Popover",multiple:false,visibility:"hidden"},addFacetButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},dialog:{type:"sap.m.Dialog",multiple:false,visibility:"hidden"},summaryBar:{type:"sap.m.Toolbar",multiple:false,visibility:"hidden"},resetButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},arrowLeft:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},arrowRight:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},events:{reset:{},confirm:{}}}});
F.SCROLL_STEP=264;
F.prototype.setType=function(t){var s=this.getAggregation("summaryBar");if(sap.ui.Device.system.phone){this.setProperty("type",sap.m.FacetFilterType.Light);s.setActive(true);}else{this.setProperty("type",t);s.setActive(t===sap.m.FacetFilterType.Light);}if(t===sap.m.FacetFilterType.Light){if(this.getShowReset()){this._addResetToSummary(s);}else{this._removeResetFromSummary(s);}}return this;};
F.prototype.setShowReset=function(v){this.setProperty("showReset",v);var s=this.getAggregation("summaryBar");if(v){if(this.getShowSummaryBar()||this.getType()===sap.m.FacetFilterType.Light){this._addResetToSummary(s);}}else{if(this.getShowSummaryBar()||this.getType()===sap.m.FacetFilterType.Light){this._removeResetFromSummary(s);}}return this;};
F.prototype.setShowSummaryBar=function(v){this.setProperty("showSummaryBar",v);if(v){var s=this.getAggregation("summaryBar");if(this.getShowReset()){this._addResetToSummary(s);}else{this._removeResetFromSummary(s);}s.setActive(this.getType()===sap.m.FacetFilterType.Light);}return this;};
F.prototype.setLiveSearch=function(v){this.setProperty("liveSearch",v);if(this._displayedList){var L=this._displayedList;var s=sap.ui.getCore().byId(L.getAssociation("search"));s.detachLiveChange(L._handleSearchEvent,L);if(v){s.attachLiveChange(L._handleSearchEvent,L);}}return this;};
F.prototype.getLists=function(){var L=this.getAggregation("lists");if(!L){L=[];}if(this._displayedList){L.splice(this._listAggrIndex,0,this._displayedList);}return L;};
F.prototype.removeList=function(o){var L=sap.ui.base.ManagedObject.prototype.removeAggregation.call(this,"lists",o);this._removeList(L);return L;};
F.prototype.removeAggregation=function(){var L=sap.ui.base.ManagedObject.prototype.removeAggregation.apply(this,arguments);if(arguments[0]==="lists"){this._removeList(L);}return L;};
F.prototype.openFilterDialog=function(){var d=this._getFacetDialog();var n=this._getFacetDialogNavContainer();d.addContent(n);this.getLists().forEach(function(L){L._preserveOriginalActiveState();});d.setInitialFocus(n.getPages()[0].getContent()[0].getItems()[0]);d.open();return this;};
F.prototype.init=function(){this._pageSize=5;this._addDelegateFlag=false;this._invalidateFlag=false;this._closePopoverFlag=false;this._lastCategoryFocusIndex=0;this._aDomRefs=null;this._previousTarget=null;this._addTarget=null;this._aRows=null;this._bundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.data("sap-ui-fastnavgroup","true",true);this._buttons={};this._removeFacetIcons={};this._listAggrIndex=-1;this._displayedList=null;this._lastScrolling=false;this._bPreviousScrollForward=false;this._bPreviousScrollBack=false;this._getAddFacetButton();this._getSummaryBar();this.setAggregation("resetButton",this._createResetButton());if(q.sap.touchEventMode==="ON"&&!sap.ui.Device.system.phone){this._enableTouchSupport();}if(sap.ui.Device.system.phone){this.setType(sap.m.FacetFilterType.Light);}};
F.prototype.exit=function(){sap.ui.getCore().detachIntervalTimer(this._checkOverflow,this);if(this.oItemNavigation){this.removeDelegate(this.oItemNavigation);this.oItemNavigation.destroy();}};
F.prototype.onBeforeRendering=function(){if(this.getShowSummaryBar()||this.getType()===sap.m.FacetFilterType.Light){var s=this.getAggregation("summaryBar");var t=s.getContent()[0];t.setText(this._getSummaryText());t.setTooltip(this._getSummaryText());}sap.ui.getCore().detachIntervalTimer(this._checkOverflow,this);};
F.prototype.onAfterRendering=function(){if(this.getType()!==sap.m.FacetFilterType.Light&&!sap.ui.Device.system.phone){sap.ui.getCore().attachIntervalTimer(this._checkOverflow,this);}this._startItemNavigation();};
F.prototype._startItemNavigation=function(){var f=this.getDomRef(),r=f.getElementsByClassName("sapMFFHead"),d=[];if(r.length>0){for(var i=0;i<r[0].childNodes.length;i++){if(r[0].childNodes[i].id.indexOf("ff")<0&&r[0].childNodes[i].id.indexOf("icon")<0&&r[0].childNodes[i].id.indexOf("add")<0){d.push(r[0].childNodes[i]);}if(r[0].childNodes[i].id.indexOf("add")>=0){d.push(r[0].childNodes[i]);}}}if(d!=""){this._aDomRefs=d;}if((!this.oItemNavigation)||this._addDelegateFlag==true){this.oItemNavigation=new a();this.addDelegate(this.oItemNavigation);this._addDelegateFlag=false;}this._aRows=r;for(var i=0;i<this.$().find(":sapTabbable").length;i++){if(this.$().find(":sapTabbable")[i].id.indexOf("add")>=0){this._addTarget=this.$().find(":sapTabbable")[i];break;}}this.oItemNavigation.setRootDomRef(f);this.oItemNavigation.setItemDomRefs(d);this.oItemNavigation.setCycling(false);this.oItemNavigation.setPageSize(this._pageSize);};
F.prototype.onsapdelete=function(e){var b,L;if(!this.getShowPersonalization()){return;}b=sap.ui.getCore().byId(e.target.id);if(!b){return;}L=sap.ui.getCore().byId(b.getAssociation("list"));if(!L){return;}if(!L.getShowRemoveFacetIcon()){return;}L.removeSelections(true);L.setSelectedKeys();L.setProperty("active",false,true);this.invalidate();var t=this.$().find(":sapTabbable");q(t[t.length-1]).focus();var n=this.oItemNavigation.getFocusedIndex();q(e.target).blur();this.oItemNavigation.setFocusedIndex(n+1);this.focus();if(this.oItemNavigation.getFocusedIndex()==0){for(var k=0;k<this.$().find(":sapTabbable").length-1;k++){if(t[k].id.indexOf("add")>=0){q(t[k]).focus();}}}};
F.prototype.onsaptabnext=function(e){this._previousTarget=e.target;if(e.target.parentNode.className=="sapMFFHead"){for(var i=0;i<this.$().find(":sapTabbable").length;i++){if(this.$().find(":sapTabbable")[i].parentNode.className=="sapMFFResetDiv"){q(this.$().find(":sapTabbable")[i]).focus();e.preventDefault();e.setMarked();return;}}}this._lastCategoryFocusIndex=this.oItemNavigation.getFocusedIndex();if(this._invalidateFlag==true){this.oItemNavigation.setFocusedIndex(-1);this.focus();this._invalidateFlag=false;}if(this._closePopoverFlag==true){this.oItemNavigation.setFocusedIndex(-1);this.focus();this._closePopoverFlag=false;}};
F.prototype.onsaptabprevious=function(e){if(e.target.parentNode.className=="sapMFFResetDiv"&&this._previousTarget==null){q(this.$().find(":sapTabbable")[0]).focus();e.preventDefault();e.setMarked();return;}if(e.target.parentNode.className=="sapMFFResetDiv"&&this._previousTarget!=null&&this._previousTarget.id!=e.target.id){q(this._previousTarget).focus();e.preventDefault();e.setMarked();return;}if(e.target.id.indexOf("add")>=0||e.target.parentNode.className=="sapMFFHead"){this._previousTarget=e.target;q(this.$().find(":sapTabbable")[0]).focus();}};
F.prototype.onsapend=function(e){if(this._addTarget!=null){q(this._addTarget).focus();e.preventDefault();e.setMarked();}else{q(this._aRows[this._aRows.length-1]).focus();e.preventDefault();e.setMarked();}this._previousTarget=e.target;};
F.prototype.onsaphome=function(e){q(this._aRows[0]).focus();e.preventDefault();e.setMarked();this._previousTarget=e.target;};
F.prototype.onsappageup=function(e){this._previousTarget=e.target;};
F.prototype.onsappagedown=function(e){this._previousTarget=e.target;};
F.prototype.onsapincreasemodifiers=function(e){if(e.which==q.sap.KeyCodes.ARROW_RIGHT){this._previousTarget=e.target;var c=this.oItemNavigation.getFocusedIndex()-1;var n=c+this._pageSize;q(e.target).blur();this.oItemNavigation.setFocusedIndex(n);this.focus();}};
F.prototype.onsapdecreasemodifiers=function(e){var c=0;if(e.which==q.sap.KeyCodes.ARROW_LEFT){this._previousTarget=e.target;c=this.oItemNavigation.getFocusedIndex()+1;var n=c-this._pageSize;q(e.target).blur();this.oItemNavigation.setFocusedIndex(n);this.focus();}};
F.prototype.onsapdownmodifiers=function(e){this._previousTarget=e.target;var c=0;c=this.oItemNavigation.getFocusedIndex()-1;var n=c+this._pageSize;q(e.target).blur();this.oItemNavigation.setFocusedIndex(n);this.focus();};
F.prototype.onsapupmodifiers=function(e){this._previousTarget=e.target;var c=0;c=this.oItemNavigation.getFocusedIndex();if(c!=0){c=c+1;}var n=c-this._pageSize;q(e.target).blur();this.oItemNavigation.setFocusedIndex(n);this.focus();};
F.prototype.onsapexpand=function(e){this._previousTarget=e.target;var n=this.oItemNavigation.getFocusedIndex()+1;q(e.target).blur();this.oItemNavigation.setFocusedIndex(n);this.focus();};
F.prototype.onsapcollapse=function(e){this._previousTarget=e.target;var n=this.oItemNavigation.getFocusedIndex()-1;q(e.target).blur();this.oItemNavigation.setFocusedIndex(n);this.focus();};
F.prototype.onsapdown=function(e){this._previousTarget=e.target;if(e.target.parentNode.className=="sapMFFResetDiv"){q(e.target).focus();e.preventDefault();e.setMarked();return;}};
F.prototype.onsapup=function(e){this._previousTarget=e.target;if(e.target.parentNode.className=="sapMFFResetDiv"){q(e.target).focus();e.preventDefault();e.setMarked();}};
F.prototype.onsapleft=function(e){this._previousTarget=e.target;if(e.target.parentNode.className=="sapMFFResetDiv"){q(e.target).focus();e.preventDefault();e.setMarked();}};
F.prototype.onsapright=function(e){this._previousTarget=e.target;if(e.target.parentNode.className=="sapMFFResetDiv"){q(e.target).focus();e.preventDefault();e.setMarked();}};
F.prototype.onsapescape=function(e){if(e.target.parentNode.className=="sapMFFResetDiv"){return;}var n=this._lastCategoryFocusIndex;q(e.target).blur();this.oItemNavigation.setFocusedIndex(n);this.focus();};
F.prototype._getPopover=function(){var p=this.getAggregation("popover");if(!p){var t=this;p=new sap.m.Popover({placement:sap.m.PlacementType.Bottom,beforeOpen:function(e){if(t._displayedList){t._displayedList._setSearchValue("");}this.setCustomHeader(t._createFilterItemsSearchFieldBar(t._displayedList));var s=this.getSubHeader();if(!s){this.setSubHeader(t._createSelectAllCheckboxBar(t._displayedList));}c(t._displayedList);},afterClose:function(e){t._addDelegateFlag=true;t._closePopoverFlag=true;if(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<10){q.sap.delayedCall(100,t,t._handlePopoverAfterClose);}else{t._handlePopoverAfterClose();}},horizontalScrolling:false});this.setAggregation("popover",p,true);p.setContentWidth("30%");if(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<10){p.setContentWidth("30%");}p.addStyleClass("sapMFFPop");var c=function(L){if(!L){return;}var i=t._getFacetRemoveIcon(L);if(i){i._bTouchStarted=false;}};}if(this.getShowPopoverOKButton()){this._addOKButtonToPopover(p);}else{p.destroyAggregation("footer");}return p;};
F.prototype._handlePopoverAfterClose=function(){var p=this.getAggregation("popover"),L=this._displayedList;if(!p){return;}var i=this._getFacetRemoveIcon(L);if(i&&i._bTouchStarted){return;}this._restoreListFromDisplayContainer(p);this._displayRemoveIcon(false,L);L._fireListCloseEvent();this._fireConfirmEvent();this.destroyAggregation("popover");if(this._oOpenPopoverDeferred){q.sap.delayedCall(0,this,function(){this._oOpenPopoverDeferred.resolve();this._oOpenPopoverDeferred=undefined;});}};
F.prototype._fireConfirmEvent=function(){this.fireEvent('confirm');};
F.prototype._openPopover=function(p,c){if(!p.isOpen()){var L=sap.ui.getCore().byId(c.getAssociation("list"));L.fireListOpen({});this._moveListToDisplayContainer(L,p);p.openBy(c);if(L.getShowRemoveFacetIcon()){this._displayRemoveIcon(true,L);}if(L.getWordWrap()){p.setContentWidth("30%");}L._applySearch();}return this;};
F.prototype._getAddFacetButton=function(){var b=this.getAggregation("addFacetButton");if(!b){var t=this;var b=new sap.m.Button(this.getId()+"-add",{icon:I.getIconURI("add-filter"),type:sap.m.ButtonType.Transparent,tooltip:this._bundle.getText("FACETFILTER_ADDFACET"),press:function(e){t.openFilterDialog();}});this.setAggregation("addFacetButton",b,true);}return b;};
F.prototype._getButtonForList=function(L){if(this._buttons[L.getId()]){this._setButtonText(L);return this._buttons[L.getId()];}var t=this;var b=new sap.m.Button({type:sap.m.ButtonType.Transparent,press:function(e){var T=this;var o=function(){var p=t._getPopover();t._openPopover(p,T);};L._preserveOriginalActiveState();if(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<10){q.sap.delayedCall(100,this,o);}else{var p=t._getPopover();if(p.isOpen()){q.sap.delayedCall(100,this,function(){if(p.isOpen()){return;}t._oOpenPopoverDeferred=q.Deferred();t._oOpenPopoverDeferred.promise().done(o);});}else{q.sap.delayedCall(100,this,o);}}}});this._buttons[L.getId()]=b;this.addAggregation("buttons",b);b.setAssociation("list",L.getId(),true);this._setButtonText(L);return b;};
F.prototype._setButtonText=function(L){var b=this._buttons[L.getId()];if(b){var t="";var s=Object.getOwnPropertyNames(L._oSelectedKeys);var i=s.length;if(i===1){var S=L._oSelectedKeys[s[0]];t=this._bundle.getText("FACETFILTER_ITEM_SELECTION",[L.getTitle(),S]);}else if(i>0&&i===L._getNonGroupItems().length){t=this._bundle.getText("FACETFILTER_ALL_SELECTED",[L.getTitle()]);}else if(i>0){t=this._bundle.getText("FACETFILTER_ITEM_SELECTION",[L.getTitle(),i]);}else{t=L.getTitle();}b.setText(t);b.setTooltip(t);}};
F.prototype._getFacetRemoveIcon=function(L){var t=this,i=this._removeFacetIcons[L.getId()];if(!i){i=new sap.ui.core.Icon({src:I.getIconURI("sys-cancel"),tooltip:this._bundle.getText("FACETFILTER_REMOVE"),press:function(){i._bPressed=true;}});i.addDelegate({ontouchstart:function(){i._bTouchStarted=true;i._bPressed=false;},ontouchend:function(){t._displayRemoveIcon(false,L);i._bTouchStarted=false;q.sap.delayedCall(100,this,p);}},true);var p=function(){if(i._bPressed){L.removeSelections(true);L.setSelectedKeys();L.setProperty("active",false,true);}t._handlePopoverAfterClose();};i.setAssociation("list",L.getId(),true);i.addStyleClass("sapMFFLRemoveIcon");this._removeFacetIcons[L.getId()]=i;this.addAggregation("removeFacetIcons",i);this._displayRemoveIcon(false,L);}return i;};
F.prototype._displayRemoveIcon=function(d,L){if(this.getShowPersonalization()){var i=this._removeFacetIcons[L.getId()];if(d){i.removeStyleClass("sapMFFLHiddenRemoveIcon");i.addStyleClass("sapMFFLVisibleRemoveIcon");}else{i.removeStyleClass("sapMFFLVisibleRemoveIcon");i.addStyleClass("sapMFFLHiddenRemoveIcon");}}};
F.prototype._getFacetDialogNavContainer=function(){var n=new N({autoFocus:false});var f=this._createFacetPage();n.addPage(f);n.setInitialPage(f);var t=this;n.attachAfterNavigate(function(e){var T=e.getParameters()["to"];var o=e.getParameters()['from'];if(o===f){var b=T.getContent(0)[1].getItems()[0];if(b){b.focus();}}if(T===f){o.destroySubHeader();o.destroyContent();t._selectedFacetItem.invalidate();T.invalidate();q.sap.focus(t._selectedFacetItem);t._selectedFacetItem=null;}});return n;};
F.prototype._createFacetPage=function(){var f=this._createFacetList();var o=new sap.m.SearchField({width:"100%",tooltip:this._bundle.getText("FACETFILTER_SEARCH"),liveChange:function(e){var b=f.getBinding("items");if(b){var c=new sap.ui.model.Filter("text",sap.ui.model.FilterOperator.Contains,e.getParameters()["newValue"]);b.filter([c]);}}});var p=new sap.m.Page({enableScrolling:true,title:this._bundle.getText("FACETFILTER_TITLE"),subHeader:new sap.m.Bar({contentMiddle:o}),content:[f]});return p;};
F.prototype._createFilterItemsPage=function(){var t=this;var p=new sap.m.Page({showNavButton:true,enableScrolling:true,navButtonPress:function(e){var n=e.getSource().getParent();t._navFromFilterItemsPage(n);}});return p;};
F.prototype._getFilterItemsPage=function(n){var o=n.getPages()[1];if(o){n.removePage(o);o.destroy();}var p=this._createFilterItemsPage();n.addPage(p);return p;};
F.prototype._createFilterItemsSearchFieldBar=function(L){var t=this;var s=true;if(L.getDataType()!=sap.m.FacetFilterListDataType.String){s=false;}var S=new sap.m.SearchField({value:L._getSearchValue(),width:"100%",enabled:s,tooltip:this._bundle.getText("FACETFILTER_SEARCH"),search:function(e){t._displayedList._handleSearchEvent(e);}});if(this.getLiveSearch()){S.attachLiveChange(L._handleSearchEvent,L);}var b=new sap.m.Bar({contentMiddle:S});L.setAssociation("search",S);return b;};
F.prototype._getFacetDialog=function(){var d=this.getAggregation("dialog");if(!d){var t=this;d=new sap.m.Dialog({showHeader:false,stretch:sap.ui.Device.system.phone?true:false,afterClose:function(){t._addDelegateFlag=true;t._invalidateFlag=true;var n=this.getContent()[0];var f=n.getPages()[1];if(n.getCurrentPage()===f){var L=t._restoreListFromDisplayContainer(f);L._updateActiveState();L._fireListCloseEvent();}this.destroyAggregation("content",true);t.invalidate();},beginButton:new sap.m.Button({text:this._bundle.getText("FACETFILTER_ACCEPT"),tooltip:this._bundle.getText("FACETFILTER_ACCEPT"),press:function(){t._closeDialog();}}),contentHeight:"500px"});d.addStyleClass("sapMFFDialog");d.onsapentermodifiers=function(e){if(e.shiftKey&&!e.ctrlKey&&!e.altKey){var n=this.getContent()[0];t._navFromFilterItemsPage(n);}};this.setAggregation("dialog",d,true);}return d;};
F.prototype._closeDialog=function(){var d=this.getAggregation("dialog");if(d&&d.isOpen()){d.close();this._fireConfirmEvent();}};
F.prototype._closePopover=function(){var p=this.getAggregation("popover");if(p&&p.isOpen()){p.close();}};
F.prototype._createFacetList=function(){var f=new sap.m.List({mode:sap.m.ListMode.None,items:{path:"/items",template:new sap.m.StandardListItem({title:"{text}",tooltip:"{text}",counter:"{count}",type:sap.m.ListType.Navigation,customData:[new sap.ui.core.CustomData({key:"index",value:"{index}"})]})}});var b=[];for(var i=0;i<this.getLists().length;i++){var L=this.getLists()[i];b.push({text:L.getTitle(),tooltip:L.getTitle(),count:L.getAllCount(),index:i});}var m=new sap.ui.model.json.JSONModel({items:b});var t=this;f.attachUpdateFinished(function(){for(var i=0;i<f.getItems().length;i++){var o=this.getItems()[i];o.detachPress(t._handleFacetListItemPress,t);o.attachPress(t._handleFacetListItemPress,t);}});f.setModel(m);return f;};
F.prototype._createSelectAllCheckboxBar=function(L){if(!L.getMultiSelect()){return null;}var s=L.getActive()&&L.getItems().length>0&&Object.getOwnPropertyNames(L._oSelectedKeys).length===L.getItems().length;var c=new sap.m.CheckBox(L.getId()+"-selectAll",{text:this._bundle.getText("FACETFILTER_CHECKBOX_ALL"),tooltip:this._bundle.getText("FACETFILTER_CHECKBOX_ALL"),selected:s,select:function(e){c.setSelected(e.getParameter("selected"));L._handleSelectAllClick(e.getParameter("selected"));}});L.setAssociation("allcheckbox",c);var b=new sap.m.Bar();b.addEventDelegate({ontap:function(e){if(e.srcControl===this){L._handleSelectAllClick(c.getSelected());}}},b);b.addContentLeft(c);b.addStyleClass("sapMFFCheckbar");return b;};
F.prototype._handleFacetListItemPress=function(e){this._navToFilterItemsPage(e.getSource());};
F.prototype._navToFilterItemsPage=function(f){this._selectedFacetItem=f;var n=this.getAggregation("dialog").getContent()[0];var c=f.getCustomData();var i=c[0].getValue();var o=this.getLists()[i];this._listIndexAgg=this.indexOfAggregation("lists",o);if(this._listIndexAgg==i){var b=this._getFilterItemsPage(n);o.fireListOpen({});this._moveListToDisplayContainer(o,b);b.setSubHeader(this._createFilterItemsSearchFieldBar(o));var d=this._createSelectAllCheckboxBar(o);if(d){b.insertContent(d,0);}b.setTitle(o.getTitle());n.to(b);}};
F.prototype._navFromFilterItemsPage=function(n){var f=n.getPages()[1];var L=this._restoreListFromDisplayContainer(f);L._updateActiveState();L._fireListCloseEvent();this._selectedFacetItem.setCounter(L.getAllCount());n.backToTop();};
F.prototype._moveListToDisplayContainer=function(L,c){this._listAggrIndex=this.indexOfAggregation("lists",L);sap.ui.base.ManagedObject.prototype.removeAggregation.call(this,"lists",L,true);c.addAggregation("content",L,false);L.setAssociation("facetFilter",this,true);this._displayedList=L;};
F.prototype._restoreListFromDisplayContainer=function(c){var L=c.removeAggregation("content",this._displayedList,true);this.insertAggregation("lists",L,this._listAggrIndex,L.getActive());this._listAggrIndex=-1;this._displayedList=null;return L;};
F.prototype._getSequencedLists=function(){var m=-1;var s=[];var L=this.getLists();if(L.length>0){for(var i=0;i<L.length;i++){if(L[i].getActive()){if(L[i].getSequence()<-1){L[i].setSequence(-1);}else if(L[i].getSequence()>m){m=L[i].getSequence();}s.push(L[i]);}else if(!L[i].getRetainListSequence()){L[i].setSequence(-1);}}for(var j=0;j<s.length;j++){if(s[j].getSequence()<=-1){m+=1;s[j].setSequence(m);}}if(s.length>1){s.sort(function(b,c){return b.getSequence()-c.getSequence();});}}return s;};
F.prototype._getSummaryBar=function(){var s=this.getAggregation("summaryBar");if(!s){var t=new sap.m.Text({maxLines:1});var b=this;s=new sap.m.Toolbar({content:[t],active:this.getType()===sap.m.FacetFilterType.Light?true:false,design:sap.m.ToolbarDesign.Info,press:function(e){b.openFilterDialog();}});this.setAggregation("summaryBar",s);}return s;};
F.prototype._createResetButton=function(){var t=this;var b=new sap.m.Button({type:sap.m.ButtonType.Transparent,icon:I.getIconURI("undo"),tooltip:this._bundle.getText("FACETFILTER_RESET"),press:function(e){t._addDelegateFlag=true;t._invalidateFlag=true;t.fireReset();var L=t.getLists();for(var i=0;i<L.length;i++){L[i]._searchValue="";L[i]._applySearch();q.sap.focus(L[i].getItems()[0]);}t.invalidate();}});return b;};
F.prototype._addOKButtonToPopover=function(p){var b=p.getFooter();if(!b){var t=this;var b=new sap.m.Button({text:this._bundle.getText("FACETFILTER_ACCEPT"),tooltip:this._bundle.getText("FACETFILTER_ACCEPT"),width:"100%",press:function(){t._closePopover();}});p.setFooter(b);}return b;};
F.prototype._getSummaryText=function(){var b=", ";var S=" ";var f="";var c=true;var L=this.getLists();if(L.length>0){for(var i=0;i<L.length;i++){var o=L[i];if(o.getActive()){var d=this._getSelectedItemsText(o);var t="";for(var j=0;j<d.length;j++){t=t+d[j]+b;}if(t){t=t.substring(0,t.lastIndexOf(b)).trim();if(c){f=this._bundle.getText("FACETFILTER_INFOBAR_FILTERED_BY",[o.getTitle(),t]);c=false;}else{f=f+S+this._bundle.getText("FACETFILTER_INFOBAR_AND")+S+this._bundle.getText("FACETFILTER_INFOBAR_AFTER_AND",[o.getTitle(),t]);}}}}}if(!f){f=this._bundle.getText("FACETFILTER_INFOBAR_NO_FILTERS");}return f;};
F.prototype._getSelectedItemsText=function(L){var t=L.getSelectedItems().map(function(v){return v.getText();});L._oSelectedKeys&&Object.getOwnPropertyNames(L._oSelectedKeys).forEach(function(v){t.indexOf(L._oSelectedKeys[v])===-1&&t.push(L._oSelectedKeys[v]);});return t;};
F.prototype._addResetToSummary=function(s){if(s.getContent().length===1){s.addContent(new sap.m.ToolbarSpacer({width:""}));var b=this._createResetButton();s.addContent(b);b.addStyleClass("sapMFFRefresh");b.addStyleClass("sapMFFBtnHoverable");}};
F.prototype._removeResetFromSummary=function(s){if(s.getContent().length===3){var S=s.removeAggregation("content",1);S.destroy();var b=s.removeAggregation("content",1);b.destroy();}};
F.prototype._removeList=function(L){if(L){var b=this._buttons[L.getId()];if(b){this.removeAggregation("buttons",b);b.destroy();}var r=this._removeFacetIcons[L.getId()];if(r){this.removeAggregation("removeIcons",r);r.destroy();}delete this._buttons[L.getId()];delete this._removeFacetIcons[L.getId()];}};
F.prototype._getScrollingArrow=function(n){var A=null;var p={src:"sap-icon://navigation-"+n+"-arrow"};if(n==="left"){A=this.getAggregation("arrowLeft");if(!A){p.id=this.getId()+"-arrowScrollLeft";A=I.createControlByURI(p);var c=["sapMPointer","sapMFFArrowScroll","sapMFFArrowScrollLeft"];for(var i=0;i<c.length;i++){A.addStyleClass(c[i]);A.setTooltip(this._bundle.getText("FACETFILTER_PREVIOUS"));}this.setAggregation("arrowLeft",A);}}else if(n==="right"){A=this.getAggregation("arrowRight");if(!A){p.id=this.getId()+"-arrowScrollRight";A=I.createControlByURI(p);var b=["sapMPointer","sapMFFArrowScroll","sapMFFArrowScrollRight"];for(var i=0;i<b.length;i++){A.addStyleClass(b[i]);A.setTooltip(this._bundle.getText("FACETFILTER_NEXT"));}this.setAggregation("arrowRight",A);}}else{q.sap.log.error("Scrolling arrow name "+n+" is not valid");}return A;};
F.prototype._checkOverflow=function(){var b=this.getDomRef("head"),L=q(b),B=this.$(),s=false,S=false,c=false,i=null,d=null,e=null;if(b){i=b.scrollLeft;d=b.scrollWidth;e=b.clientWidth;if(d>e){if(d-e==1){d=e;}else{c=true;}}B.toggleClass("sapMFFScrolling",c);B.toggleClass("sapMFFNoScrolling",!c);this._lastScrolling=c;if(!this._bRtl){s=i>0;S=(d>e)&&(d>i+e);}else{S=L.scrollLeftRTL()>0;s=L.scrollRightRTL()>0;}if((S!=this._bPreviousScrollForward)||(s!=this._bPreviousScrollBack)){B.toggleClass("sapMFFNoScrollBack",!s);B.toggleClass("sapMFFNoScrollForward",!S);}}};
F.prototype.onclick=function(e){var t=e.target.id;if(t){var i=this.getId();e.preventDefault();if(t==i+"-arrowScrollLeft"){this._scroll(-F.SCROLL_STEP,500);}else if(t==i+"-arrowScrollRight"){this._scroll(F.SCROLL_STEP,500);}}};
F.prototype._scroll=function(d,D){var o=this.getDomRef("head");var s=o.scrollLeft;if(!sap.ui.Device.browser.internet_explorer&&this._bRtl){d=-d;}var S=s+d;q(o).stop(true,true).animate({scrollLeft:S},D);};
F.prototype._enableTouchSupport=function(){var t=this;var T=function(e){e.preventDefault();if(t._iInertiaIntervalId){window.clearInterval(t._iInertiaIntervalId);}t.startScrollX=t.getDomRef("head").scrollLeft;t.startTouchX=e.touches[0].pageX;t._bTouchNotMoved=true;t._lastMoveTime=new Date().getTime();};var f=function(e){var d=e.touches[0].pageX-t.startTouchX;var L=t.getDomRef("head");var o=L.scrollLeft;var n=t.startScrollX-d;L.scrollLeft=n;t._bTouchNotMoved=false;var c=new Date().getTime()-t._lastMoveTime;t._lastMoveTime=new Date().getTime();if(c>0){t._velocity=(n-o)/c;}e.preventDefault();};var b=function(e){if(t._bTouchNotMoved===false){e.preventDefault();var L=t.getDomRef("head");var d=50;var c=Math.abs(t._velocity/10);t._iInertiaIntervalId=window.setInterval(function(){t._velocity=t._velocity*0.80;var g=t._velocity*d;L.scrollLeft=L.scrollLeft+g;if(Math.abs(t._velocity)<c){window.clearInterval(t._iInertiaIntervalId);t._iInertiaIntervalId=undefined;}},d);}else if(t._bTouchNotMoved===true){t.onclick(e);e.preventDefault();}t._bTouchNotMoved=undefined;t._lastMoveTime=undefined;};this.addEventDelegate({ontouchstart:T},this);this.addEventDelegate({ontouchend:b},this);this.addEventDelegate({ontouchmove:f},this);};
return F;},true);
sap.ui.predefine('sap/m/FacetFilterItem',['jquery.sap.global','./ListItemBase','./library'],function(q,L,l){"use strict";
var F=L.extend("sap.m.FacetFilterItem",{metadata:{library:"sap.m",properties:{key:{type:"string",group:"Data",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},count:{type:"int",group:"Misc",defaultValue:null,deprecated:true}}}});
F.prototype.setCount=function(c){this.setProperty("count",c);this.setProperty("counter",c);return this;};
F.prototype.setCounter=function(c){this.setProperty("count",c);this.setProperty("counter",c);return this;};
F.prototype.init=function(){L.prototype.init.apply(this);this.addStyleClass("sapMFFLI");};
return F;},true);
sap.ui.predefine('sap/m/FacetFilterItemRenderer',['jquery.sap.global','./ListItemBaseRenderer','sap/ui/core/Renderer'],function(q,L,R){"use strict";var F=R.extend(L);
F.renderLIContent=function(r,c){r.write("<div");if(c.getParent()&&c.getParent().getWordWrap()){r.addClass("sapMFFLITitleWrap");}else{r.addClass("sapMFFLITitle");}r.writeClasses();r.write(">");r.writeEscaped(c.getText());r.write("</div>");};
return F;},true);
sap.ui.predefine('sap/m/FacetFilterList',['jquery.sap.global','./List','./library'],function(q,L,l){"use strict";
var F=L.extend("sap.m.FacetFilterList",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},wordWrap:{type:"boolean",group:"Appearance",defaultValue:false},multiSelect:{type:"boolean",group:"Behavior",defaultValue:true,deprecated:true},active:{type:"boolean",group:"Behavior",defaultValue:true},enableCaseInsensitiveSearch:{type:"boolean",group:"Behavior",defaultValue:false,deprecated:false},allCount:{type:"int",group:"Appearance",defaultValue:null},sequence:{type:"int",group:"Behavior",defaultValue:-1},key:{type:"string",group:"Identification",defaultValue:null},showRemoveFacetIcon:{type:"boolean",group:"Misc",defaultValue:true},retainListSequence:{type:"boolean",group:"Misc",defaultValue:false},dataType:{type:"sap.m.FacetFilterListDataType",group:"Misc",defaultValue:sap.m.FacetFilterListDataType.String}},events:{listOpen:{},listClose:{parameters:{selectedItems:{type:"sap.m.FacetFilterItem[]"},allSelected:{type:"boolean"},selectedKeys:{type:"object"}}}}}});
F.prototype.setTitle=function(t){this.setProperty("title",t,true);if(this.getParent()&&this.getParent()._setButtonText){this.getParent()._setButtonText(this);}return this;};
F.prototype.setMultiSelect=function(v){this.setProperty("multiSelect",v,true);var m=v?sap.m.ListMode.MultiSelect:sap.m.ListMode.SingleSelectMaster;this.setMode(m);return this;};
F.prototype.setMode=function(m){if(m===sap.m.ListMode.MultiSelect||m===sap.m.ListMode.SingleSelectMaster){L.prototype.setMode.call(this,m);this.setProperty("multiSelect",m===sap.m.ListMode.MultiSelect?true:false,true);}return this;};
F.prototype._applySearch=function(){var s=this._getSearchValue();if(s!=null){this._search(s,true);this._updateSelectAllCheckBox();}};
F.prototype.getSelectedItems=function(){var s=[];var c={};var C=sap.m.ListBase.prototype.getSelectedItems.apply(this,arguments);C.forEach(function(i){s.push(new sap.m.FacetFilterItem({text:i.getText(),key:i.getKey(),selected:true}));c[i.getKey()]=true;});var S=this.getSelectedKeys();var a=Object.getOwnPropertyNames(S);if(C.length<a.length){a.forEach(function(k){if(!c[k]){s.push(new sap.m.FacetFilterItem({text:S[k],key:k,selected:true}));}});}return s;};
F.prototype.getSelectedItem=function(){var i=sap.m.ListBase.prototype.getSelectedItem.apply(this,arguments);var s=Object.getOwnPropertyNames(this.getSelectedKeys());if(!i&&s.length>0){i=new sap.m.FacetFilterItem({text:this.getSelectedKeys()[s[0]],key:s[0],selected:true});}return i;};
F.prototype.removeSelections=function(a){if(this._allowRemoveSelections){a?this.setSelectedKeys():sap.m.ListBase.prototype.removeSelections.call(this,a);}return this;};
F.prototype.getSelectedKeys=function(){var r={};var k=this._oSelectedKeys;Object.getOwnPropertyNames(k).forEach(function(a){r[a]=k[a];});return r;};
F.prototype.setSelectedKeys=function(k){this._oSelectedKeys={};var K=false;k&&Object.getOwnPropertyNames(k).forEach(function(a){this._addSelectedKey(a,k[a]);K=true;},this);if(K){this.setActive(true);this._selectItemsByKeys();}else{sap.m.ListBase.prototype.removeSelections.call(this);}};
F.prototype._getNonGroupItems=function(){var i=[];this.getItems().forEach(function(I){if(I.getMode()!==sap.m.ListMode.None){i.push(I);}});return i;};
F.prototype.removeSelectedKey=function(k,t){if(this._removeSelectedKey(k,t)){this._getNonGroupItems().forEach(function(i){var I=i.getKey()||i.getText();k===I&&i.setSelected(false);});}};
F.prototype.removeSelectedKeys=function(){this._oSelectedKeys={};sap.m.ListBase.prototype.removeSelections.call(this,true);};
F.prototype.removeItem=function(i){var I=sap.m.ListBase.prototype.removeItem.apply(this,arguments);if(!this._filtering){I&&I.getSelected()&&this.removeSelectedKey(I.getKey(),I.getText());return I;}};
F.prototype.init=function(){this._firstTime=true;this._saveBindInfo;this._oSelectedKeys={};L.prototype.init.call(this);this.setMode(sap.m.ListMode.MultiSelect);this.setIncludeItemInSelection(true);this.setGrowing(true);this.setRememberSelections(false);this._searchValue=null;this.attachUpdateFinished(function(e){var u=e.getParameter("reason");if(u){u=u.toLowerCase();if(u!==sap.ui.model.ChangeReason.Filter.toLowerCase()){this._selectItemsByKeys();}}else{this._selectItemsByKeys();}});this._allowRemoveSelections=true;this._bOriginalActiveState;};
F.prototype._resetItemsBinding=function(){if(this.isBound("items")){this._searchValue=null;this._allowRemoveSelections=false;sap.m.ListBase.prototype._resetItemsBinding.apply(this,arguments);this._allowRemoveSelections=true;}};
F.prototype._fireListCloseEvent=function(){var s=this.getSelectedItems();var S=this.getSelectedKeys();var a=s.length===0;this._firstTime=true;this.fireListClose({selectedItems:s,selectedKeys:S,allSelected:a});};
F.prototype._updateActiveState=function(){var c=sap.ui.getCore().byId(this.getAssociation("allcheckbox"));if(Object.getOwnPropertyNames(this._oSelectedKeys).length>0||(c&&c.getSelected())){this.setActive(true);}};
F.prototype._handleSearchEvent=function(e){var s=e.getParameters()["query"];if(s===undefined){s=e.getParameters()["newValue"];}this._search(s);this._updateSelectAllCheckBox();};
F.prototype._search=function(s,f){var b;var n=0;function i(m){return m instanceof sap.ui.model.odata.ODataModel||m instanceof sap.ui.model.odata.v2.ODataModel;}if(f||(s!==this._searchValue)){this._searchValue=s;var B=this.getBinding("items");var o=this.getBindingInfo("items");if(o&&o.binding){b=o.binding.aFilters;if(b.length>0){n=b[0].aFilters.length;if(this._firstTime){this._saveBindInfo=b[0].aFilters[0];this._firstTime=false;}}}if(B){if(s||n>0){var p=this.getBindingInfo("items").template.getBindingInfo("text").parts[0].path;if(p){var u=new sap.ui.model.Filter(p,sap.ui.model.FilterOperator.Contains,s);if(this.getEnableCaseInsensitiveSearch()&&i(B.getModel())){var e="'"+String(s).replace(/'/g,"''")+"'";e=e.toLowerCase();u=new sap.ui.model.Filter("tolower("+p+")",sap.ui.model.FilterOperator.Contains,e);}if(n>1){var a=new sap.ui.model.Filter([u,this._saveBindInfo],true);}else{if(this._saveBindInfo>""&&u.sPath!=this._saveBindInfo.sPath){var a=new sap.ui.model.Filter([u,this._saveBindInfo],true);}else{if(s==""){var a=[];}else{var a=new sap.ui.model.Filter([u],true);}}}B.filter(a,sap.ui.model.FilterType.Control);}}else{B.filter([],sap.ui.model.FilterType.Control);}}else{q.sap.log.warning("No filtering performed","The list must be defined with a binding for search to work",this);}}};
F.prototype._getSearchValue=function(){return this._searchValue;};
F.prototype._updateSelectAllCheckBox=function(){var i=this._getNonGroupItems(),I=i.length,c,a,s;function b(o){return o.getSelected();}if(this.getMultiSelect()){c=sap.ui.getCore().byId(this.getAssociation("allcheckbox"));a=I>0&&I===i.filter(b).length;s=this.getActive()&&a;c&&c.setSelected(s);}};
F.prototype._addSelectedKey=function(k,t){if(!k&&!t){q.sap.log.error("Both sKey and sText are not defined. At least one must be defined.");return;}if(this.getMode()===sap.m.ListMode.SingleSelectMaster){this.removeSelectedKeys();}if(!k){k=t;}this._oSelectedKeys[k]=t||k;};
F.prototype._removeSelectedKey=function(k,t){if(!k&&!t){q.sap.log.error("Both sKey and sText are not defined. At least one must be defined.");return false;}if(!k){k=t;}delete this._oSelectedKeys[k];return true;};
F.prototype._setSearchValue=function(v){this._searchValue=v;};
F.prototype._isItemSelected=function(i){return!!(this._oSelectedKeys[i&&(i.getKey()||i.getText())]);};
F.prototype._selectItemsByKeys=function(){this._getNonGroupItems().forEach(function(i){i.setSelected(this._isItemSelected(i));},this);};
F.prototype._handleSelectAllClick=function(s){var a;this._getNonGroupItems().forEach(function(i){if(s){this._addSelectedKey(i.getKey(),i.getText());}else{this._removeSelectedKey(i.getKey(),i.getText());}i.setSelected(s,true);},this);a=this._getOriginalActiveState()||s;this.setActive(a);q.sap.delayedCall(0,this,this._updateSelectAllCheckBox);};
F.prototype.onItemSelectedChange=function(i,s){var a;if(s){this._addSelectedKey(i.getKey(),i.getText());}else{this._removeSelectedKey(i.getKey(),i.getText());}sap.m.ListBase.prototype.onItemSelectedChange.apply(this,arguments);a=this._getOriginalActiveState()||s||this.getSelectedItems().length>1;this.setActive(a);!this.getDomRef()&&this.getParent()&&this.getParent().getDomRef()&&this.getParent().invalidate();q.sap.delayedCall(0,this,this._updateSelectAllCheckBox);};
F.prototype.updateItems=function(r){this._filtering=r===sap.ui.model.ChangeReason.Filter;sap.m.ListBase.prototype.updateItems.apply(this,arguments);this._filtering=false;if(!this.getGrowing()||r===sap.ui.model.ChangeReason.Filter){this._selectItemsByKeys();}};
F.prototype._getOriginalActiveState=function(){return this._bOriginalActiveState;};
F.prototype._preserveOriginalActiveState=function(){this._bOriginalActiveState=this.getActive();};
return F;},true);
sap.ui.predefine('sap/m/FacetFilterListRenderer',['jquery.sap.global','./ListRenderer','sap/ui/core/Renderer'],function(q,L,R){"use strict";var F=R.extend(L);return F;},true);
sap.ui.predefine('sap/m/FacetFilterRenderer',['jquery.sap.global'],function(q){"use strict";var F={};var a={};
F.render=function(r,c){switch(c.getType()){case sap.m.FacetFilterType.Simple:F.renderSimpleFlow(r,c);break;case sap.m.FacetFilterType.Light:F.renderSummaryBar(r,c);break;}};
F.renderSimpleFlow=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMFF");if(c.getShowSummaryBar()){r.write(">");F.renderSummaryBar(r,c);}else{if(c._lastScrolling){r.addClass("sapMFFScrolling");}else{r.addClass("sapMFFNoScrolling");}if(c.getShowReset()){r.addClass("sapMFFResetSpacer");}r.writeClasses();r.write(">");if(sap.ui.Device.system.desktop){r.renderControl(c._getScrollingArrow("left"));}r.write("<div");r.writeAttribute("id",c.getId()+"-head");r.addClass("sapMFFHead");r.writeClasses();r.write(">");F.renderFacetFilterListButtons(c,r);if(c.getShowPersonalization()){r.renderControl(c.getAggregation("addFacetButton"));}r.write("</div>");if(sap.ui.Device.system.desktop){r.renderControl(c._getScrollingArrow("right"));}if(c.getShowReset()){r.write("<div");r.addClass("sapMFFResetDiv");r.writeClasses();r.write(">");r.renderControl(c.getAggregation("resetButton"));r.write("</div>");}}r.write("</div>");};
F.renderSummaryBar=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMFF");r.writeClasses();r.write(">");var s=c.getAggregation("summaryBar");s._writeLandmarkInfo=function(r,c){var f=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("FACETFILTER_ARIA_FACET_FILTER");r.writeAccessibilityState(c,{role:"button",labelledby:new sap.ui.core.InvisibleText({text:f}).toStatic().getId()});};r.renderControl(s);r.write("</div>");};
F.getAriaAnnouncement=function(k,b){if(a[k]){return a[k];}b=b||"FACETFILTER_"+k.toUpperCase();a[k]=new sap.ui.core.InvisibleText({text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText(b)}).toStatic().getId();return a[k];};
F.getAriaDescribedBy=function(c){var d=[];if(c.getShowPersonalization()){d.push(this.getAriaAnnouncement("ARIA_REMOVE"));}d=d.concat(c._aAriaPositionTextIds);return d.join(" ");};
F.getAccessibilityState=function(c){return{describedby:{value:this.getAriaDescribedBy(c),append:true}};};
F.renderFacetFilterListButtons=function(c,r){var l=c._getSequencedLists(),L=l.length,b,i,p,A,o=[],n=[],f=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("FACETFILTER_ARIA_FACET_FILTER"),R=this.getAriaAnnouncement("ARIA_REMOVE");for(i=0;i<L;i++){b=c._getButtonForList(l[i]);o=b.removeAllAriaDescribedBy();o.forEach(d);p=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("FACETFILTERLIST_ARIA_POSITION",[(i+1),L]);A=new sap.ui.core.InvisibleText({text:f+" "+p}).toStatic();b.addAriaDescribedBy(A);n.push(A.getId());if(c.getShowPersonalization()){b.addAriaDescribedBy(F.getAriaAnnouncement("ARIA_REMOVE"));}r.renderControl(b);if(c.getShowPersonalization()){r.renderControl(c._getFacetRemoveIcon(l[i]));}}c._aAriaPositionTextIds=n;function d(I){if(R!==I){var e=sap.ui.getCore().byId(I);if(e){e.destroy();}}}};
return F;},true);
sap.ui.predefine('sap/m/FeedContent',['jquery.sap.global','./library','sap/ui/core/Control','sap/m/Text'],function(q,l,C,T){"use strict";
var F=C.extend("sap.m.FeedContent",{metadata:{library:"sap.m",properties:{"size":{type:"sap.m.Size",group:"Misc",defaultValue:sap.m.Size.Auto},"contentText":{type:"string",group:"Misc",defaultValue:null},"subheader":{type:"string",group:"Misc",defaultValue:null},"value":{type:"string",group:"Misc",defaultValue:null},"valueColor":{type:"sap.m.ValueColor",group:"Misc",defaultValue:null},"truncateValueTo":{type:"int",group:"Misc",defaultValue:4}},aggregations:{"contentTextAgr":{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{"press":{}}}});
F.prototype.init=function(){this._oContentText=new sap.m.Text(this.getId()+"-content-text",{maxLines:2});this._oContentText.cacheLineHeight=false;this.setAggregation("contentTextAgr",this._oContentText);this.setTooltip("{AltText}");};
F.prototype.onBeforeRendering=function(){this.$().unbind("mouseenter",this._addTooltip);this.$().unbind("mouseleave",this._removeTooltip);};
F.prototype.onAfterRendering=function(){this.$().bind("mouseenter",this._addTooltip.bind(this));this.$().bind("mouseleave",this._removeTooltip.bind(this));};
F.prototype._addTooltip=function(){this.$().attr("title",this.getTooltip_AsString());};
F.prototype._removeTooltip=function(){this.$().attr("title",null);};
F.prototype.getAltText=function(){var a="";var i=true;if(this.getAggregation("contentTextAgr").getText()){a+=this.getAggregation("contentTextAgr").getText();i=false;}if(this.getSubheader()){if(i){a+=""+this.getSubheader();}else{a+="\n"+this.getSubheader();}i=false;}if(this.getValue()){if(i){a+=""+this.getValue();}else{a+="\n"+this.getValue();}}return a;};
F.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var s=this.getAltText();if(typeof t==="string"||t instanceof String){s=t.split("{AltText}").join(s).split("((AltText))").join(s);return s;}if(t){return t;}else{return"";}};
F.prototype.setContentText=function(t){this._oContentText.setText(t);return this;};
F.prototype.ontap=function(e){if(sap.ui.Device.browser.internet_explorer){this.$().focus();}this.firePress();};
F.prototype.onkeydown=function(e){if(e.which===q.sap.KeyCodes.ENTER||e.which===q.sap.KeyCodes.SPACE){this.firePress();e.preventDefault();}};
F.prototype.attachEvent=function(e,d,f,a){sap.ui.core.Control.prototype.attachEvent.call(this,e,d,f,a);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");}return this;};
F.prototype.detachEvent=function(e,f,a){sap.ui.core.Control.prototype.detachEvent.call(this,e,f,a);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");}return this;};
return F;},true);
sap.ui.predefine('sap/m/FeedContentRenderer',[],function(){"use strict";var F={};
F.render=function(r,c){var s=c.getSubheader();var v=c.getValue();var t=c.getTooltip_AsString();if(typeof t!=="string"){t="";}r.write("<div");r.writeControlData(c);r.writeAttribute("id",c.getId()+"-feed-content");r.writeAttribute("role","presentation");r.writeAttributeEscaped("aria-label",t);r.addClass("sapMFC");if(c.hasListeners("press")){r.writeAttribute("tabindex","0");r.addClass("sapMPointer");}r.writeClasses();r.write(">");if(v){r.write("<div");r.writeAttribute("id",c.getId()+"-value");r.addClass("sapMFCValue");r.addClass(c.getValueColor());r.writeClasses();r.write(">");var C=c.getTruncateValueTo();if(v.length>=C&&(v[C-1]==="."||v[C-1]===",")){r.writeEscaped(v.substring(0,C-1));}else if(v){r.writeEscaped(v.substring(0,C));}else{r.writeEscaped("");}r.write("</div>");}r.write("<div");r.addClass("sapMFCCTxt");r.writeClasses();r.write(">");r.renderControl(c._oContentText);r.write("</div>");r.write("<div");r.writeAttribute("id",c.getId()+"-subheader");r.addClass("sapMFCSbh");r.writeClasses();r.write(">");r.writeEscaped(s);r.write("</div>");r.write("</div>");};
return F;},true);
sap.ui.predefine('sap/m/FeedInput',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/HTML','sap/ui/core/IconPool'],function(q,l,C,H,I){"use strict";
var F=C.extend("sap.m.FeedInput",{metadata:{library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},maxLength:{type:"int",group:"Behavior",defaultValue:0},placeholder:{type:"string",group:"Appearance",defaultValue:"Post something here"},value:{type:"string",group:"Data",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},showIcon:{type:"boolean",group:"Behavior",defaultValue:true},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true},buttonTooltip:{type:"sap.ui.core.TooltipBase",group:"Accessibility",defaultValue:"Submit"},ariaLabelForPicture:{type:"string",group:"Accessibility",defaultValue:null}},events:{post:{parameters:{value:{type:"string"}}}}}});
F.prototype.init=function(){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setProperty("placeholder",b.getText("FEEDINPUT_PLACEHOLDER"),true);this.setProperty("buttonTooltip",b.getText("FEEDINPUT_SUBMIT"),true);};
F.prototype.exit=function(){if(this._oTextArea){this._oTextArea.destroy();}if(this._oButton){this._oButton.destroy();}if(this._oImageControl){this._oImageControl.destroy();}};
F.prototype.setIconDensityAware=function(i){this.setProperty("iconDensityAware",i,true);if(this._getImageControl()instanceof sap.m.Image){this._getImageControl().setDensityAware(i);}return this;};
F.prototype.setMaxLength=function(m){this.setProperty("maxLength",m,true);this._getTextArea().setMaxLength(m);return this;};
F.prototype.setValue=function(v){this.setProperty("value",v,true);this._getTextArea().setValue(v);this._enablePostButton();return this;};
F.prototype.setPlaceholder=function(v){this.setProperty("placeholder",v,true);this._getTextArea().setPlaceholder(v);return this;};
F.prototype.setEnabled=function(e){this.setProperty("enabled",e,true);this._getTextArea().setEnabled(e);this._enablePostButton();return this;};
F.prototype.setButtonTooltip=function(b){this.setProperty("buttonTooltip",b,true);this._getPostButton().setTooltip(b);return this;};
F.prototype._getTextArea=function(){if(!this._oTextArea){this._oTextArea=new sap.m.TextArea(this.getId()+"-textArea",{rows:1,value:null,maxLength:this.getMaxLength(),placeholder:this.getPlaceholder(),liveChange:q.proxy(function(e){var v=e.getParameter("value");this.setProperty("value",v,true);this._enablePostButton();},this)});this._oTextArea.setParent(this);}return this._oTextArea;};
F.prototype._getPostButton=function(){if(!this._oButton){this._oButton=new sap.m.Button(this.getId()+"-button",{enabled:false,type:sap.m.ButtonType.Default,icon:"sap-icon://feeder-arrow",tooltip:this.getButtonTooltip(),press:q.proxy(function(e){this._oTextArea.focus();this.firePost({value:this.getValue()});this.setValue(null);},this)});this._oButton.setParent(this);}return this._oButton;};
F.prototype._enablePostButton=function(){var v=this.getProperty("value");var i=this.getProperty("enabled");var p=(i&&!!v&&v.trim().length>0);var b=this._getPostButton();b.setEnabled(p);};
F.prototype._getImageControl=function(){var i=this.getIcon()||I.getIconURI("person-placeholder"),s=this.getId()+'-icon',p={src:i,alt:this.getAriaLabelForPicture(),densityAware:this.getIconDensityAware(),decorative:false,useIconTooltip:false},c=['sapMFeedInImage'];this._oImageControl=sap.m.ImageHelper.getImageControl(s,this._oImageControl,this,p,c);return this._oImageControl;};
return F;},true);
sap.ui.predefine('sap/m/FeedInputRenderer',['jquery.sap.global'],function(q){"use strict";var F={};
F.render=function(r,c){var m=c.getId();r.write("<div");r.writeControlData(c);r.addClass("sapMFeedIn");if(!c.getShowIcon()){r.addClass("sapMFeedInNoIcon");}r.writeClasses();r.write(">");if(!!c.getShowIcon()){this._addImage(r,c,m);}r.write('<div id="'+m+'-container"');r.addClass("sapMFeedInContainer");r.writeClasses();r.write(">");var t=c._getTextArea();r.renderControl(t);r.renderControl(c._getPostButton());r.write("</div>");r.write("</div>");};
F._addImage=function(r,c,m){r.write('<figure id="'+m+'-figure" class ="sapMFeedInFigure');if(!!c.getIcon()){r.write('">');}else{r.write(' sapMFeedListItemIsDefaultIcon">');}r.renderControl(c._getImageControl());r.write('</figure>');};
return F;},true);
sap.ui.predefine('sap/m/FeedListItem',['jquery.sap.global','./ListItemBase','./library','./FormattedText'],function(q,L,l,F){"use strict";
var a=L.extend("sap.m.FeedListItem",{metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},sender:{type:"string",group:"Data",defaultValue:null},text:{type:"string",group:"Data",defaultValue:null},info:{type:"string",group:"Data",defaultValue:null},timestamp:{type:"string",group:"Data",defaultValue:null},senderActive:{type:"boolean",group:"Behavior",defaultValue:true},iconActive:{type:"boolean",group:"Behavior",defaultValue:true},iconDensityAware:{type:"boolean",defaultValue:true},showIcon:{type:"boolean",group:"Behavior",defaultValue:true},maxCharacters:{type:"int",group:"Behavior",defaultValue:null}},defaultAggregation:"_text",aggregations:{"_text":{type:"sap.m.FormattedText",multiple:false,visibility:"hidden"}},events:{senderPress:{parameters:{domRef:{type:"string"},getDomRef:{type:"function"}}},iconPress:{parameters:{domRef:{type:"string"},getDomRef:{type:"function"}}}}}});
a._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");a._nMaxCharactersMobile=300;a._nMaxCharactersDesktop=500;a._sTextShowMore=a._oRb.getText("TEXT_SHOW_MORE");a._sTextShowLess=a._oRb.getText("TEXT_SHOW_LESS");
a.prototype.init=function(){L.prototype.init.apply(this);this.setAggregation("_text",new F(this.getId()+"-formattedText"),true);};
a.prototype.onBeforeRendering=function(){this.getAggregation("_text").setHtmlText(this.getText());this._sFullText=this.getAggregation("_text").getHtmlText();this._sShortText=this._getCollapsedText();};
a.prototype.onAfterRendering=function(){if(this._checkTextIsExpandable()){var i="#"+this.getId()+"-realtext",r;do{r=q(i+" *:empty").remove();}while(r.length>0);this._sShortText=q(i).html();}};
a.prototype.exit=function(){if(this._oLinkControl){this._oLinkControl.destroy();}if(this._oImageControl){this._oImageControl.destroy();}if(this._oLinkExpandCollapse){this._oLinkExpandCollapse.destroy();}L.prototype.exit.apply(this);};
a.prototype.ontap=function(e){if(e.srcControl){if((!this.getIconActive()&&this._oImageControl&&e.srcControl.getId()===this._oImageControl.getId())||(!this.getSenderActive()&&this._oLinkControl&&e.srcControl.getId()===this._oLinkControl.getId())||(!this._oImageControl||(e.srcControl.getId()!==this._oImageControl.getId())&&(!this._oLinkControl||(e.srcControl.getId()!==this._oLinkControl.getId()))&&(!this._oLinkExpandCollapse||(e.srcControl.getId()!==this._oLinkExpandCollapse.getId())))){L.prototype.ontap.apply(this,[e]);}}};
a.prototype.onfocusin=function(e){if(this._oImageControl){var $=this.$("icon");if(e.target.id===this.getId()){$.removeAttr("alt");}else{$.attr("alt"," ");}}};
a.prototype._getImageControl=function(){var i=this.getIcon();var I=i?i:sap.ui.core.IconPool.getIconURI("person-placeholder");var s=this.getId()+'-icon';var p={src:I,alt:this.getSender(),densityAware:this.getIconDensityAware(),decorative:false,useIconTooltip:false};var c;if(this.getIconActive()){c=['sapMFeedListItemImage'];}else{c=['sapMFeedListItemImageInactive'];}var t=this;this._oImageControl=sap.m.ImageHelper.getImageControl(s,this._oImageControl,this,p,c);if(this.getIconActive()){this._oImageControl.attachPress(function(){t.fireIconPress({domRef:this.getDomRef(),getDomRef:this.getDomRef.bind(this)});});}return this._oImageControl;};
a.prototype._getLinkSender=function(w){if(!this._oLinkControl){q.sap.require("sap.m.Link");var t=this;this._oLinkControl=new sap.m.Link({press:function(){t.fireSenderPress({domRef:this.getDomRef(),getDomRef:this.getDomRef.bind(this)});}});this._oLinkControl.setParent(this,null,true);}if(w){this._oLinkControl.setProperty("text",this.getSender()+a._oRb.getText("COLON"),true);}else{this._oLinkControl.setProperty("text",this.getSender(),true);}this._oLinkControl.setProperty("enabled",this.getSenderActive(),true);return this._oLinkControl;};
a.prototype._activeHandlingInheritor=function(){var A=this.getActiveIcon();if(this._oImageControl&&A){this._oImageControl.setSrc(A);}};
a.prototype._inactiveHandlingInheritor=function(){var s=this.getIcon()?this.getIcon():sap.ui.core.IconPool.getIconURI("person-placeholder");if(this._oImageControl){this._oImageControl.setSrc(s);}};
a.prototype._getCollapsedText=function(){this._nMaxCollapsedLength=this.getMaxCharacters();if(this._nMaxCollapsedLength===0){if(sap.ui.Device.system.phone){this._nMaxCollapsedLength=a._nMaxCharactersMobile;}else{this._nMaxCollapsedLength=a._nMaxCharactersDesktop;}}var p=this._convertHtmlToPlainText(this._sFullText);var t=null;if(p&&p.length>this._nMaxCollapsedLength){var c=p.substring(0,this._nMaxCollapsedLength);var n=c.lastIndexOf(" ");if(n>0){c=c.substr(0,n);}if(p.length===this._sFullText.length){t=c;}else{t=this._convertPlainToHtmlText(c);}}return t;};
a.prototype._toggleTextExpanded=function(){var $=this.$("realtext");var b=this.$("threeDots");if(this._bTextExpanded){$.html(this._sShortText.replace(/&#xa;/g,"<br>"));b.text(" ... ");this._oLinkExpandCollapse.setText(a._sTextShowMore);this._bTextExpanded=false;}else{$.html(this._sFullText.replace(/&#xa;/g,"<br>"));b.text("  ");this._oLinkExpandCollapse.setText(a._sTextShowLess);this._bTextExpanded=true;}};
a.prototype._getLinkExpandCollapse=function(){if(!this._oLinkExpandCollapse){q.sap.require("sap.m.Link");this._oLinkExpandCollapse=new sap.m.Link({text:a._sTextShowMore,press:q.proxy(function(){this._toggleTextExpanded();},this)});this._bTextExpanded=false;this._oLinkExpandCollapse.setParent(this,null,true);}return this._oLinkExpandCollapse;};
a.prototype._convertHtmlToPlainText=function(h){var r=/(<([^>]+)>)/ig;return h.replace(r,"");};
a.prototype._convertPlainToHtmlText=function(b){var f=this._sFullText;var r=/(<([^>]+)>)/ig;var e=f.split(r);var t="";for(var i=0;i<e.length;i++){if(e[i].length===0){continue;}if(b.length>0&&e[i].indexOf(b.trim())!==-1){e[i]=b;}if(/^<.+>$/.test(e[i])){t=t+e[i];e[i+1]="";continue;}if(b.indexOf(e[i].trim())===-1){continue;}else{b=b.replace(e[i],"");}t=t+e[i];}return t;};
a.prototype._checkTextIsExpandable=function(){return this._sShortText!==null;};
sap.m.FeedListItem.prototype.setType=function(t){if(t===sap.m.ListType.Navigation){this.setProperty("type",sap.m.ListType.Active);}else{this.setProperty("type",t);}return this;};
a.prototype.setUnread=function(v){this.setProperty("unread",false);return this;};
return a;},true);
sap.ui.predefine('sap/m/FeedListItemRenderer',['jquery.sap.global','./ListItemBaseRenderer','sap/ui/core/Renderer'],function(q,L,R){"use strict";var F=R.extend(L);
F.renderLIAttributes=function(r,f){r.addClass("sapMFeedListItemTitleDiv");r.addClass("sapMFeedListShowSeparatorsAll");};
F.renderLIContent=function(r,f){var m=f.getId(),i=sap.ui.Device.system.phone;r.write('<div');r.addClass('sapMFeedListItem');r.writeClasses();r.write('>');if(!!f.getShowIcon()){this._writeImageControl(r,f,m);}if(i){r.write('<div class= "sapMFeedListItemHeader sapUiSelectable ');if(!!f.getShowIcon()){r.write('sapMFeedListItemHasFigure ');}if(!!f.getSender()&&!!f.getTimestamp()){r.write('sapMFeedListItemFullHeight');}r.write('" >');if(!!f.getSender()){r.write('<p id="'+m+'-name" class="sapMFeedListItemTextName sapUiSelectable">');r.renderControl(f._getLinkSender(false));r.write('</p>');}if(!!f.getTimestamp()){r.write('<p class="sapMFeedListItemTimestamp sapUiSelectable">');r.writeEscaped(f.getTimestamp());r.write('</p>');}r.write('</div>');r.write('<div class="sapMFeedListItemText sapUiSelectable">');r.write('<span id="'+m+'-realtext" class="sapMFeedListItemText sapUiSelectable">');if(!!f._checkTextIsExpandable()){this._writeCollapsedText(r,f,m);}else{r.write(f._sFullText);r.write('</span>');}r.write('</div>');if(!!f.getInfo()){r.write('<p class="sapMFeedListItemFooter sapUiSelectable">');if(!!f.getInfo()){r.write('<span id="'+m+'-info" class="sapMFeedListItemInfo sapUiSelectable">');r.writeEscaped(f.getInfo());r.write('</span>');}r.write('</p>');}}else{r.write('<div class= "sapMFeedListItemText ');if(!!f.getShowIcon()){r.write('sapMFeedListItemHasFigure');}r.write('" >');r.write('<div id="'+m+'-text" class="sapMFeedListItemTextText sapUiSelectable">');if(!!f.getSender()){r.write('<span id="'+m+'-name" class="sapMFeedListItemTextName sapUiSelectable">');r.renderControl(f._getLinkSender(true));r.write(' ');r.write('</span>');}r.write('<span id="'+m+'-realtext" class="sapMFeedListItemTextString sapUiSelectable">');if(!!f._checkTextIsExpandable()){this._writeCollapsedText(r,f,m);}else{r.write(f._sFullText);r.write('</span>');}r.write('</div>');if(!!f.getInfo()||!!f.getTimestamp()){r.write('<p class="sapMFeedListItemFooter sapUiSelectable">');if(!sap.ui.getCore().getConfiguration().getRTL()){if(!!f.getInfo()){this._writeInfo(r,f,m);if(!!f.getTimestamp()){r.write("<span>&#160&#160&#x00B7&#160&#160</span>");}}if(!!f.getTimestamp()){this._writeTimestamp(r,f,m);}}else{if(!!f.getTimestamp()){this._writeTimestamp(r,f,m);}if(!!f.getInfo()){if(!!f.getTimestamp()){r.write("<span>&#160&#160&#x00B7&#160&#160</span>");}this._writeInfo(r,f,m);}}r.write('</p>');}r.write('</div>');}r.write('</div>');};
F._writeImageControl=function(r,f,m){r.write('<figure id="'+m+'-figure"');r.addClass('sapMFeedListItemFigure');if(!f.getIcon()){r.addClass('sapMFeedListItemIsDefaultIcon');}r.writeClasses();r.write('>');r.renderControl(f._getImageControl());r.write('</figure>');};
F._writeCollapsedText=function(r,f,m){if(f._bTextExpanded){r.write(f._sFullText);r.write('</span>');r.write('<span id="'+m+'-threeDots" class ="sapMFeedListItemTextString">');r.write("&#32");r.write('</span>');}else{r.write(f._sShortText);r.write('</span>');r.write('<span id="'+m+'-threeDots" class ="sapMFeedListItemTextString">');r.write("&#32&#46&#46&#46&#32");r.write('</span>');}var l=f._getLinkExpandCollapse();l.addStyleClass("sapMFeedListItemLinkExpandCollapse");r.renderControl(l);};
F._writeTimestamp=function(r,f,m){r.write('<span id="'+m+'-timestamp" class="sapMFeedListItemTimestampText sapUiSelectable">');r.writeEscaped(f.getTimestamp());r.write('</span>');};
F._writeInfo=function(r,f,m){r.write('<span id="'+m+'-info" class="sapMFeedListItemInfoText sapUiSelectable">');r.writeEscaped(f.getInfo());r.write('</span>');};
return F;},true);
sap.ui.predefine('sap/m/Fiori20Adapter',['jquery.sap.global','sap/ui/base/Object','sap/ui/base/EventProvider'],function(q,O,E){"use strict";var e=new E(),a,c;
var H=O.extend("HeaderAdapter",{constructor:function(h,A){if(!h||!A){q.sap.log.error("Cannot initialize: Invalid arguments.");return;}this._oHeader=h;this._oStyledPage=null;this._oTitleInfo=null;this._oSubTitleInfo=null;this._oBackButton=null;this._oAdaptOptions=A;}});
H.prototype.adapt=function(){var s=this._oAdaptOptions.bStylePage,C=this._oAdaptOptions.bCollapseHeader;if(s){this._adaptStyle("sapF2Adapted");}this._adaptTitle();this._adaptBackButton();if(C){this._collapseHeader();}return this.getAdaptedContent();};
H.prototype.getAdaptedContent=function(){return{oTitleInfo:this._oTitleInfo,oSubTitleInfo:this._oSubTitleInfo,oBackButton:this._oBackButton,oStyledPage:this._oStyledPage};};
H.prototype._adaptTitle=function(){if(!H._isAdaptableHeader(this._oHeader)||this._oAdaptOptions.bMoveTitle!==true){return false;}this._oTitleInfo=this._detectTitle();this._oSubTitleInfo=this._detectSubTitle();var s=!!this._oTitleInfo||!!this._oSubTitleInfo;if(this._oTitleInfo){this._oTitleInfo.oControl.addStyleClass("sapF2AdaptedTitle");}return s;};
H.prototype._adaptBackButton=function(){if(!H._isAdaptableHeader(this._oHeader)||this._oAdaptOptions.bHideBackButton!==true){return false;}var B=false;this._oBackButton=this._detectBackButton();if(this._oBackButton){this._oBackButton.addStyleClass("sapF2AdaptedNavigation");B=true;}return B;};
H.prototype._adaptStyle=function(C){var p=this._oHeader.getParent();if(p){p.addStyleClass(C,true);this._oStyledPage=p;}};
H._isAdaptableHeader=function(h){if(!h||!b(h,"sap/m/Bar")){return false;}var p=h.getParent();return p&&(b(p,"sap/m/Page")||b(p,"sap/uxap/ObjectPageHeader"));};
H.prototype._detectTitle=function(){var t;if(H._isAdaptableHeader(this._oHeader)){var m=this._oHeader.getContentMiddle();if(m.length===1&&i(m[0])){var T=m[0];t={id:T.getId(),text:T.getText(),oControl:T,sChangeEventId:"_change"};}}return t;};
H.prototype._detectSubTitle=function(p){if(b(p,"sap/uxap/ObjectPageHeader")){var h=p.getHeaderTitle();if(h){return{id:h.getId(),text:h.getObjectTitle(),oControl:h,sChangeEventId:"_titleChange"};}}};
H.prototype._detectBackButton=function(){if(H._isAdaptableHeader(this._oHeader)){var B=this._oHeader.getContentLeft();if(B.length>0&&b(B[0],"sap/m/Button")&&(B[0].getType()==="Back"||B[0].getType()==="Up"||B[0].getIcon()==="sap-icon://nav-back")){return B[0];}}};
H.prototype._collapseHeader=function(){var t=this._oTitleInfo,B=this._oBackButton;if(H._isAdaptableHeader(this._oHeader)){var f=this._oHeader.getContentLeft();var m=this._oHeader.getContentMiddle();var g=this._oHeader.getContentRight();if((f.length===0||(f.length===1&&B))&&(m.length===0||(m.length===1&&t))&&(g.length===0)){this._adaptStyle("sapF2CollapsedHeader");}}};
var F=O.extend("sap.m.Fiori20Adapter",{});
F.attachViewChange=function(l,L){e.attachEvent("adaptedViewChange",l,L);};
F.detachViewChange=function(l,L){e.detachEvent("adaptedViewChange",l,L);};
F.traverse=function(C,A){a={aViewTitles:{},aViewSubTitles:{},aViewBackButtons:{},aChangeListeners:{}};c=[];this._doBFS([{oNode:C,oAdaptOptions:A}]);};
F._doBFS=function(Q){var n=Q.shift();if(!n){return;}var N=n.oNode,A=n.oAdaptOptions,s=A.iSearchDepth;A=this._applyRules(A,N);if(!N||!this._isAdaptationRequired(A)||(s<=0)){return;}var I=N.getParent()&&b(N.getParent(),"sap/m/NavContainer");if(I){c.push(N.getId());}var o=this._processNode(N,A);var C=this._getNodeChildren(N),f=q.extend({},A,{iSearchDepth:this._updateSearchDepth(s,N)});if(o){var t=!!a.oTitleInfo,B=!!a.oBackButton,p=!!a.oStyledPage;f=q.extend(f,{bMoveTitle:A.bMoveTitle&&!t,bHideBackButton:A.bHideBackButton&&!B,bStylePage:A.bStylePage&&!p});}C.forEach(function(g){if(g){Q.push({oNode:g,oAdaptOptions:f});}});this._doBFS(Q);if(I){c.pop();if(c.length===0){this._fireViewChange(N.getId(),A);}}};
F._processNode=function(C,A){this._attachDefferedAdaptationListeners(C,A);if(H._isAdaptableHeader(C)){return this._adaptHeader(C,A);}if(C.getParent()&&b(C.getParent(),"sap/m/NavContainer")){return this._getCachedAdaptationResult(C.getId());}};
F._attachDefferedAdaptationListeners=function(C,A){this._attachAdaptableContentChange(C,A);this._attachNavigablePageChange(C,A);if(b(C,"sap/m/Page")){this._attachModifyAggregation(C,"content",A);}if((A.bLateAdaptation===true)&&b(C,"sap/m/Bar")){this._attachModifyAggregation(C,"contentLeft",A,C);this._attachModifyAggregation(C,"contentMiddle",A,C);this._attachModifyAggregation(C,"contentRight",A,C);}if(b(C,"sap/ui/core/ComponentContainer")){var o=C.getComponentInstance();if(!o&&C.getName()&&!C.getDomRef()){var t=this;var D={onBeforeRendering:function(){C.removeEventDelegate(D);t._doBFS([{oNode:C.getComponentInstance(),oAdaptOptions:A}]);}};C.addEventDelegate(D,this);}}};
F._checkHasListener=function(k){return a.aChangeListeners[k];};
F._setHasListener=function(k,v){a.aChangeListeners[k]=v;};
F._attachAdaptableContentChange=function(C,A){if(!C._getAdaptableContent||!q.isFunction(C._getAdaptableContent)){return;}var k=C.getId()+"_adaptableContentChange";if(this._checkHasListener(k)){return;}var o=this._getCurrentTopViewId();var f=function(g){var h=g.getParameter("adaptableContent");var I=(this._getCurrentTopViewId()===undefined);if(I){c.push(o);this._doBFS([{oNode:h,oAdaptOptions:A}]);c.pop();this._fireViewChange(o,A);}}.bind(this);C.attachEvent("_adaptableContentChange",f);this._setHasListener(k);};
F._attachNavigablePageChange=function(C,A){if(!b(C,"sap/m/NavContainer")){return;}var k=C.getId()+"navigate";if(this._checkHasListener(k)){return;}C.attachNavigate(function(o){this._doBFS([{oNode:o.getParameter("to"),oAdaptOptions:A}]);}.bind(this));this._setHasListener(k);};
F._attachModifyAggregation=function(C,A,o,f){if(!C._attachModifyAggregation||!q.isFunction(C._attachModifyAggregation)){return;}var k=C.getId()+A;if(this._checkHasListener(k)){return;}var g=this._getCurrentTopViewId();var h=function(j){var t=j.getParameter("type"),l=j.getParameter("object");if((t==="add")||(t==="insert")){var I=(this._getCurrentTopViewId()===undefined);if(I){c.push(g);this._doBFS([{oNode:f?f:l,oAdaptOptions:o}]);c.pop();this._fireViewChange(g,o);}}}.bind(this);C._attachModifyAggregation(A,o,h);this._setHasListener(k,h);};
F._getNodeChildren=function(C){if(C._getAdaptableContent&&q.isFunction(C._getAdaptableContent)){var f=[C._getAdaptableContent()];if(b(C,"sap/m/Page")){f=f.concat(C.getContent());}return f;}if(b(C,"sap/m/SplitContainer")){return[].concat(C.getAggregation("_navMaster"),C.getAggregation("_navDetail"));}if(b(C,"sap/uxap/ObjectPageLayout")){return[C.getHeaderTitle()];}if(b(C,"sap/ui/core/ComponentContainer")){return[C.getComponentInstance()];}if(b(C,"sap/ui/core/Component")){return[C.getAggregation("rootControl")];}return C.findAggregatedObjects(false,d);};
F._updateSearchDepth=function(s,C){if(b(C,"sap/ui/core/mvc/View")||b(C,"sap/ui/core/Component")||b(C,"sap/ui/core/ComponentContainer")){return s;}return s-1;};
F._getCachedAdaptationResult=function(v){return{oTitleInfo:a.aViewTitles[v],oSubTitleInfo:a.aViewSubTitles[v],oBackButton:a.aViewBackButtons[v]};};
F._applyRules=function(A,C){var p=C.getParent();if(b(p,"sap/m/SplitContainer")){var I=sap.ui.Device.system.phone,m=A.bMoveTitle,f;if(m){m=I;}var f=A.bHideBackButton;if(f&&!sap.ui.Device.system.phone){f='initialPage';}return q.extend({},A,{bMoveTitle:m,bHideBackButton:f});}if(b(p,"sap/m/NavContainer")){if(A.bHideBackButton==='initialPage'){var g=p._getActualInitialPage()&&(p._getActualInitialPage().getId()===C.getId());return q.extend({},A,{bHideBackButton:g});}}if((A.bMoveTitle===false)||(A.bHideBackButton===false)){return q.extend({},A,{bCollapseHeader:false});}return A;};
F._getCurrentTopViewId=function(){if(c&&(c.length>0)){return c[0];}};
F._adaptHeader=function(h,A){if(!h||!A){return;}var o=new H(h,A),f=o.adapt();var t=this._getCurrentTopViewId();if(f.oTitleInfo){a.aViewTitles[t]=f.oTitleInfo;this._registerChangeListener(a.aViewTitles,t,A);}if(f.oSubTitleInfo){a.aViewSubTitles[t]=f.oSubTitleInfo;this._registerChangeListener(a.aViewSubTitles,t,A);}if(f.oBackButton){a.aViewBackButtons[t]=f.oBackButton;}return f;};
F._registerChangeListener=function(t,v,A){var T=t[v];if(T&&T.oControl&&T.sChangeEventId&&!a.aChangeListeners[T.id]){var C=function(o){var T=t[v];T.text=o.getParameter("newValue");this._fireViewChange(v,A);}.bind(this);T.oControl.attachEvent(T.sChangeEventId,C);a.aChangeListeners[T.id]=C;}};
F._fireViewChange=function(v,A){var a=this._getCachedAdaptationResult(v);a.sViewId=v;a.oAdaptOptions=A;e.fireEvent("adaptedViewChange",a);};
F._isAdaptationRequired=function(A){for(var o in A){if(A.hasOwnProperty(o)&&((A[o]===true)||(A[o]==="initialPage"))){return true;}}return false;};
function i(C){if(!C){return false;}return b(C,"sap/m/Label")||b(C,"sap/m/Text")||b(C,"sap/m/Title");}
function b(C,t){var T=sap.ui.require(t);return T&&(C instanceof T);}
function d(o){return o&&(o.sParentAggregationName!=="dependents");}
return F;},false);
sap.ui.predefine('sap/m/FlexBox',['jquery.sap.global','./FlexBoxStylingHelper','./FlexItemData','./FlexDirection','./FlexRendertype','./library','sap/ui/core/Control'],function(q,F,a,b,c,l,C){"use strict";
var d=C.extend("sap.m.FlexBox",{metadata:{library:"sap.m",properties:{height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},displayInline:{type:"boolean",group:"Appearance",defaultValue:false},direction:{type:"sap.m.FlexDirection",group:"Appearance",defaultValue:sap.m.FlexDirection.Row},fitContainer:{type:"boolean",group:"Appearance",defaultValue:false},renderType:{type:"sap.m.FlexRendertype",group:"Misc",defaultValue:sap.m.FlexRendertype.Div},justifyContent:{type:"sap.m.FlexJustifyContent",group:"Appearance",defaultValue:sap.m.FlexJustifyContent.Start},alignItems:{type:"sap.m.FlexAlignItems",group:"Appearance",defaultValue:sap.m.FlexAlignItems.Stretch},wrap:{type:"sap.m.FlexWrap",group:"Appearance",defaultValue:sap.m.FlexWrap.NoWrap},alignContent:{type:"sap.m.FlexAlignContent",group:"Appearance",defaultValue:sap.m.FlexAlignContent.Stretch},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:sap.m.BackgroundDesign.Transparent}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Control",multiple:true,singularName:"item"}}}});
d.prototype.init=function(){if(this instanceof sap.m.HBox&&(this.getDirection()!==sap.m.FlexDirection.Row||this.getDirection()!==b.RowReverse)){this.setDirection('Row');}if(this instanceof sap.m.VBox&&(this.getDirection()!==sap.m.FlexDirection.Column||this.getDirection()!==b.ColumnReverse)){this.setDirection('Column');}this._oItemDelegate={onAfterRendering:this._onAfterItemRendering};};
d.prototype.addItem=function(i){this.addAggregation("items",i);this._onItemInserted(i);return this;};
d.prototype.insertItem=function(i,I){this.insertAggregation("items",i,I);this._onItemInserted(i);return this;};
d.prototype.removeItem=function(i){var I=this.removeAggregation("items",i,true);if(I&&!(I instanceof sap.m.FlexBox)){if(I instanceof sap.m.FlexBox){I.$().remove();}else{I.$().parent().remove();}}this._onItemRemoved(I);return I;};
d.prototype.removeAllItems=function(){var I=this.getItems();for(var i=0;i<I.length;i++){this._onItemRemoved(I[i]);}return this.removeAllAggregation("items");};
d.prototype._onItemInserted=function(i){if(i&&!(i instanceof sap.m.FlexBox)){i.attachEvent("_change",this._onItemChange,this);if(this.getRenderType()===c.Bare){i.addEventDelegate(this._oItemDelegate,i);}}};
d.prototype._onItemRemoved=function(i){if(i&&!(i instanceof sap.m.FlexBox)){i.detachEvent("_change",this._onItemChange,this);if(this.getRenderType()===c.Bare){i.removeEventDelegate(this._oItemDelegate,i);}}};
d.prototype._onItemChange=function(o){if(o.getParameter("name")!=="visible"||(this.getRenderType()!==c.List&&this.getRenderType()!==c.Div)){return;}var i=sap.ui.getCore().byId(o.getParameter("id")),w=null;if(i.getLayoutData()){w=q.sap.byId(i.getLayoutData().getId());}else{w=q.sap.byId(sap.ui.core.RenderManager.createInvisiblePlaceholderId(i)).parent();}if(o.getParameter("newValue")){w.removeClass("sapUiHiddenPlaceholder").removeAttr("aria-hidden");}else{w.addClass("sapUiHiddenPlaceholder").attr("aria-hidden","true");}};
d.prototype._onAfterItemRendering=function(){var L=this.getLayoutData();if(L instanceof a){F.setFlexItemStyles(null,L);}};
d.prototype.setRenderType=function(v){var o=this.getRenderType(),i=this.getItems();if(v===o){return this;}this.setProperty("renderType",v);if(o==="Bare"){i.forEach(this._onItemRemoved,this);}if(v==="Bare"){i.forEach(this._onItemInserted,this);}return this;};
d.prototype.setDisplayInline=function(i){this.setProperty("displayInline",i,true);this.$().toggleClass("sapMFlexBoxInline",this.getDisplayInline());return this;};
d.prototype.setDirection=function(v){this.setProperty("direction",v,true);if(this.getDirection()===b.Column||this.getDirection()===b.ColumnReverse){this.$().removeClass("sapMHBox").addClass("sapMVBox");}else{this.$().removeClass("sapMVBox").addClass("sapMHBox");}if(this.getDirection()===b.RowReverse||this.getDirection()===b.ColumnReverse){this.$().addClass("sapMFlexBoxReverse");}else{this.$().removeClass("sapMFlexBoxReverse");}return this;};
d.prototype.setFitContainer=function(v){this.setProperty("fitContainer",v,true);this.$().toggleClass("sapMFlexBoxFit",this.getFitContainer());return this;};
d.prototype.setWrap=function(v){var o=this.getWrap();this.setProperty("wrap",v,true);this.$().removeClass("sapMFlexBoxWrap"+o).addClass("sapMFlexBoxWrap"+this.getWrap());return this;};
d.prototype.setJustifyContent=function(v){var o=this.getJustifyContent();this.setProperty("justifyContent",v,true);this.$().removeClass("sapMFlexBoxJustify"+o).addClass("sapMFlexBoxJustify"+this.getJustifyContent());return this;};
d.prototype.setAlignItems=function(v){var o=this.getAlignItems();this.setProperty("alignItems",v,true);this.$().removeClass("sapMFlexBoxAlignItems"+o).addClass("sapMFlexBoxAlignItems"+this.getAlignItems());return this;};
d.prototype.setAlignContent=function(v){var o=this.getAlignContent();this.setProperty("alignContent",v,true);this.$().removeClass("sapMFlexBoxAlignContent"+o).addClass("sapMFlexBoxAlignContent"+this.getAlignContent());return this;};
d.prototype.setHeight=function(v){this.setProperty("height",v,true);this.$().css("height",this.getHeight());return this;};
d.prototype.setWidth=function(v){this.setProperty("width",v,true);this.$().css("width",this.getWidth());return this;};
d.prototype.setBackgroundDesign=function(v){var o=this.getBackgroundDesign();this.setProperty("backgroundDesign",v,true);this.$().removeClass("sapMFlexBoxBG"+o).addClass("sapMFlexBoxBG"+this.getBackgroundDesign());return this;};
d.prototype.getAccessibilityInfo=function(){var e=this.getItems();var f=[];for(var i=0;i<e.length;i++){if(e[i].getAccessibilityInfo){var I=e[i].getAccessibilityInfo();if(I){f.push(I);}}}return{children:f};};
return d;},true);
sap.ui.predefine('sap/m/FlexBoxCssPropertyMap',['jquery.sap.global'],function(q){"use strict";var F={'spec0907':{'order':{'<number>':{'box-ordinal-group':'<integer>'}},'flex-grow':{'<number>':{'box-flex':'<number>'}},'flex-shrink':null,'flex-basis':null},'specie10':{'order':{'<number>':{'flex-order':'<number>'}},'flex-grow':{'<number>':{'flex-positive':'<number>','flex-preferred-size':'auto'}},'flex-shrink':{'<number>':{'flex-negative':'<number>'}},'flex-basis':{'<number>':{'flex-preferred-size':'<number>'}}}};return F;},true);
sap.ui.predefine('sap/m/FlexBoxRenderer',['jquery.sap.global','./FlexBoxStylingHelper'],function(q,F){"use strict";if(!q.support.flexBoxLayout&&!q.support.newFlexBoxLayout&&!q.support.ie10FlexBoxLayout){q.sap.log.warning("This browser does not support flexible box layouts natively.");}var a={};
a.render=function(r,c){if(c.getRenderType()===sap.m.FlexRendertype.List){r.write('<ul');}else{r.write('<div');}r.writeControlData(c);var p=c.getParent();if(c.getParent()instanceof sap.m.FlexBox){r.addClass("sapMFlexItem");var l=c.getLayoutData();if(l instanceof sap.m.FlexItemData){F.setFlexItemStyles(r,l);}if(p.getRenderType()===sap.m.FlexRendertype.List){r.write('<li');}}else if(c.getFitContainer()){r.addClass("sapMFlexBoxFit");}r.addClass("sapMFlexBox");if(c.getDisplayInline()){r.addClass("sapMFlexBoxInline");}if(c.getDirection()===sap.m.FlexDirection.Column||c.getDirection()===sap.m.FlexDirection.ColumnReverse){r.addClass("sapMVBox");}else{r.addClass("sapMHBox");}if(c.getDirection()===sap.m.FlexDirection.RowReverse||c.getDirection()===sap.m.FlexDirection.ColumnReverse){r.addClass("sapMFlexBoxReverse");}r.addClass("sapMFlexBoxJustify"+c.getJustifyContent());r.addClass("sapMFlexBoxAlignItems"+c.getAlignItems());r.addClass("sapMFlexBoxWrap"+c.getWrap());r.addClass("sapMFlexBoxAlignContent"+c.getAlignContent());r.addClass("sapMFlexBoxBG"+c.getBackgroundDesign());r.writeClasses();if(c.getHeight()){r.addStyle("height",c.getHeight());}if(c.getWidth()){r.addStyle("width",c.getWidth());}r.writeStyles();var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.write(">");a.renderItems(c,r);if(c.getRenderType()===sap.m.FlexRendertype.List){r.write("</ul>");}else{r.write("</div>");}};
a.renderItems=function(c,r){var C=c.getItems(),w='';for(var i=0;i<C.length;i++){if(C[i]instanceof sap.m.FlexBox||c.getRenderType()===sap.m.FlexRendertype.Bare){w="";}else if(c.getRenderType()===sap.m.FlexRendertype.List){w="li";}else{w="div";}a.renderItem(C[i],w,r);}};
a.renderItem=function(i,w,r){if(w){r.write('<'+w);if(i instanceof sap.m.ScrollContainer){r.addClass("sapMFlexBoxScroll");}if(!i.getVisible()){r.addClass("sapUiHiddenPlaceholder");}}var l=i.getLayoutData();if(w&&!l){i.setAggregation("layoutData",new sap.m.FlexItemData(),true);l=i.getLayoutData();}if(!(l instanceof sap.m.FlexItemData)){q.sap.log.warning(l+" set on "+i+" is not of type sap.m.FlexItemData");}else{if(w&&l.getId()){r.writeAttributeEscaped("id",l.getId());}if(l.getStyleClass()){a.addItemClass(q.sap.encodeHTML(l.getStyleClass()),i,w,r);}a.addItemClass("sapMFlexItemAlign"+l.getAlignSelf(),i,w,r);a.addItemClass("sapMFlexBoxBG"+l.getBackgroundDesign(),i,w,r);if(w){F.setFlexItemStyles(r,l);}}a.addItemClass("sapMFlexItem",i,w,r);if(w){r.writeStyles();r.writeClasses();r.write(">");}r.renderControl(i);if(w){r.write('</'+w+'>');}};
a.addItemClass=function(c,i,w,r){if(w){r.addClass(c);}else{i.addStyleClass(c);}};
return a;},true);
sap.ui.predefine('sap/m/FlexBoxStylingHelper',['jquery.sap.global','./FlexBoxCssPropertyMap'],function(q,F){"use strict";var a={};
a.setFlexItemStyles=function(r,l){r=r||null;var o=l.getOrder(),g=l.getGrowFactor(),s=l.getShrinkFactor(),b=l.getBaseSize().toLowerCase(),m=l.getMinHeight(),M=l.getMaxHeight(),c=l.getMinWidth(),d=l.getMaxWidth();if(o){a.setStyle(r,l,"order",o);}if(g!=undefined){a.setStyle(r,l,"flex-grow",g);}if(q.support.newFlexBoxLayout||q.support.ie10FlexBoxLayout){if(s!==1){a.setStyle(r,l,"flex-shrink",s);}if(b!=undefined){a.setStyle(r,l,"flex-basis",b);}}if(m!=undefined){a.setStyle(r,l,"min-height",m);}if(M!=undefined){a.setStyle(r,l,"max-height",M);}if(c!=undefined){a.setStyle(r,l,"min-width",c);}if(d!=undefined){a.setStyle(r,l,"max-width",d);}};
a.setStyle=function(r,l,p,v){if(typeof(v)==="string"){v=v.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase();}if(q.support.flexBoxPrefixed){if(sap.ui.Device.browser.webkit){this.sVendorPrefix="-webkit-";}else if(sap.ui.Device.browser.mozilla){this.sVendorPrefix="-moz-";}else if(sap.ui.Device.browser.internet_explorer){this.sVendorPrefix="-ms-";}}else{this.sVendorPrefix="";}if(q.support.newFlexBoxLayout||["min-height","max-height","min-width","max-width"].indexOf(p)!==-1){a.writeStyle(r,l,p,v);}else if(q.support.flexBoxLayout||q.support.ie10FlexBoxLayout){a.setOldSpecStyle(r,l,p,v);}};
a.setOldSpecStyle=function(r,l,p,v){var s="";if(this.sVendorPrefix=="-ms-"){s="specie10";}else{s="spec0907";}if(F[s][p]!==null&&F[s][p]!=="<idem>"){var L=null;if(typeof(F[s][p])==="object"){if(F[s][p]["<number>"]){L={};for(var k in F[s][p]["<number>"]){if(F[s][p]["<number>"][k]==="<number>"){L[k]=v;}else{L[k]=F[s][p]["<number>"][k];}}}else{L=F[s][p][v];}}else{L=F[s][p][v];}if(L!==null&&L!=="<idem>"){if(typeof(L)==="object"){for(var b in L){a.writeStyle(r,l,b,L[b]);}}}}};
a.writeStyle=function(r,l,p,v){var P="";var V="";if(p!=="display"){P=this.sVendorPrefix;}else{V=this.sVendorPrefix;}if(sap.ui.Device.browser.internet_explorer&&(p==="flex-basis"||p==="flex-preferred-size")){P="";if(l.getParent()){if(l.getParent().getParent().getDirection().indexOf("Row")>-1){p="width";}else{p="height";}}}if(r){if(v===0||v){r.addStyle(P+p,V+v);}}else{if(l.$().length){if(v!==0&&!v){l.$().css(P+p,null);}else{l.$().css(P+p,V+v);}}else{if(l.getParent()){if(v!==0&&!v){l.getParent().$().css(P+p,null);}else{l.getParent().$().css(P+p,V+v);}}}}};
return a;},true);
sap.ui.predefine('sap/m/FlexItemData',['jquery.sap.global','./FlexBoxStylingHelper','./library','sap/ui/core/LayoutData'],function(q,F,l,L){"use strict";
var a=L.extend("sap.m.FlexItemData",{metadata:{library:"sap.m",properties:{alignSelf:{type:"sap.m.FlexAlignSelf",group:"Misc",defaultValue:sap.m.FlexAlignSelf.Auto},order:{type:"int",group:"Misc",defaultValue:0},growFactor:{type:"float",group:"Misc",defaultValue:0},shrinkFactor:{type:"float",group:"Misc",defaultValue:1},baseSize:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:"auto"},minHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},maxHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},minWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},styleClass:{type:"string",group:"Misc",defaultValue:''},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:sap.m.BackgroundDesign.Transparent}}}});
a.prototype.setAlignSelf=function(v){var o=this.getAlignSelf();this.setProperty("alignSelf",v,true);this.$().removeClass("sapMFlexItemAlign"+o).addClass("sapMFlexItemAlign"+this.getAlignSelf());return this;};
a.prototype.setOrder=function(v){this.setProperty("order",v,true);F.setStyle(null,this,"order",this.getOrder());return this;};
a.prototype.setGrowFactor=function(v){this.setProperty("growFactor",v,true);F.setStyle(null,this,"flex-grow",this.getGrowFactor());return this;};
a.prototype.setShrinkFactor=function(v){this.setProperty("shrinkFactor",v,true);F.setStyle(null,this,"flex-shrink",this.getShrinkFactor());return this;};
a.prototype.setBaseSize=function(v){this.setProperty("baseSize",v,true);F.setStyle(null,this,"flex-basis",this.getBaseSize());return this;};
a.prototype.setMinHeight=function(v){this.setProperty("minHeight",v,true);this.$().css("min-height",this.getMinHeight());return this;};
a.prototype.setMaxHeight=function(v){this.setProperty("maxHeight",v,true);this.$().css("max-height",this.getMaxHeight());return this;};
a.prototype.setMinWidth=function(v){this.setProperty("minWidth",v,true);this.$().css("min-width",this.getMinWidth());return this;};
a.prototype.setMaxWidth=function(v){this.setProperty("maxWidth",v,true);this.$().css("max-width",this.getMaxWidth());return this;};
a.prototype.setBackgroundDesign=function(v){var o=this.getBackgroundDesign();this.setProperty("backgroundDesign",v,true);this.$().removeClass("sapMFlexBoxBG"+o).addClass("sapMFlexBoxBG"+this.getBackgroundDesign());return this;};
a.prototype.setStyleClass=function(v){var o=this.getStyleClass();this.setProperty("styleClass",v,true);this.$().removeClass(o).addClass(this.getStyleClass());return this;};
return a;},true);
sap.ui.predefine('sap/m/FormattedText',['jquery.sap.global','./library','sap/ui/core/Control'],function(q,l,C){"use strict";
var F=C.extend("sap.m.FormattedText",{metadata:{library:"sap.m",properties:{htmlText:{type:"string",group:"Misc",defaultValue:""},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null}}}});
var _={};_.ATTRIBS={'style':1,'class':1,'a::href':1,'a::target':1};_.ELEMENTS={'a':{cssClass:'sapMLink'},'abbr':1,'blockquote':1,'br':1,'cite':1,'code':1,'em':1,'h1':{cssClass:'sapMTitle sapMTitleStyleH1'},'h2':{cssClass:'sapMTitle sapMTitleStyleH2'},'h3':{cssClass:'sapMTitle sapMTitleStyleH3'},'h4':{cssClass:'sapMTitle sapMTitleStyleH4'},'h5':{cssClass:'sapMTitle sapMTitleStyleH5'},'h6':{cssClass:'sapMTitle sapMTitleStyleH6'},'p':1,'pre':1,'strong':1,'span':1,'u':1,'dl':1,'dt':1,'dd':1,'ol':1,'ul':1,'li':1};
F.prototype.init=function(){};
function s(t,a){var w;var b,v,c=t==="a";var d=_.ELEMENTS[t].cssClass||"";for(var i=0;i<a.length;i+=2){b=a[i];v=a[i+1];if(!_.ATTRIBS[b]&&!_.ATTRIBS[t+"::"+b]){w='FormattedText: <'+t+'> with attribute ['+b+'="'+v+'"] is not allowed';q.sap.log.warning(w,this);a[i+1]=null;continue;}if(b=="href"){if(!q.sap.validateUrl(v)){q.sap.log.warning("FormattedText: incorrect href attribute:"+v,this);a[i+1]="#";c=false;}}if(b=="target"){c=false;}if(d&&b.toLowerCase()=="class"){a[i+1]=d+" "+v;d="";}}if(c){a.push("target");a.push("_blank");}if(d){a.push("class");a.push(d);}return a;}
function p(t,a){if(_.ELEMENTS[t]){return s(t,a);}else{var w='<'+t+'> is not allowed';q.sap.log.warning(w,this);}}
function o(e){var n=window.open();n.opener=null;n.location=e.currentTarget.href;e.preventDefault();}
F.prototype.onAfterRendering=function(){this.$().find('a[target="_blank"]').on("click",o);};
F.prototype.setHtmlText=function(t){var S="";function u(U){if(q.sap.validateUrl(U)){return U;}}S=q.sap._sanitizeHTML(t,{tagPolicy:p,uriRewriter:u});return this.setProperty("htmlText",S);};
return F;},true);
sap.ui.predefine('sap/m/FormattedTextRenderer',['jquery.sap.global'],function(q){"use strict";var F={};
F.render=function(r,c){var h=c.getHtmlText();r.write("<div");r.writeControlData(c);r.addClass("sapMFT");r.writeClasses();if(c.getTooltip_AsString()){r.writeAttributeEscaped("title",c.getTooltip_AsString());}r.addStyle("width",c.getWidth()||null);r.addStyle("height",c.getHeight()||null);r.writeStyles();r.write(">");r.write(h);r.write("</div>");};
return F;},true);
sap.ui.predefine('sap/m/GenericTile',['jquery.sap.global','./library','sap/ui/core/Control','sap/m/Text','sap/ui/core/HTML','sap/ui/core/Icon','sap/ui/core/IconPool'],function(q,l,C,T,H,I){"use strict";
var G=C.extend("sap.m.GenericTile",{metadata:{library:"sap.m",properties:{"mode":{type:"sap.m.GenericTileMode",group:"Appearance",defaultValue:l.GenericTileMode.ContentMode},"header":{type:"string",group:"Appearance",defaultValue:null},"subheader":{type:"string",group:"Appearance",defaultValue:null},"failedText":{type:"string",group:"Appearance",defaultValue:null},"size":{type:"sap.m.Size",group:"Misc",defaultValue:sap.m.Size.Auto},"frameType":{type:"sap.m.FrameType",group:"Misc",defaultValue:l.FrameType.OneByOne},"backgroundImage":{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},"headerImage":{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},"state":{type:"sap.m.LoadState",group:"Misc",defaultValue:sap.m.LoadState.Loaded},"imageDescription":{type:"string",group:"Misc",defaultValue:null}},aggregations:{"tileContent":{type:"sap.m.TileContent",multiple:true},"icon":{type:"sap.ui.core.Control",multiple:false},"_titleText":{type:"sap.m.Text",multiple:false,visibility:"hidden"},"_failedMessageText":{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{"press":{}}}});
G.prototype.init=function(){this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTitle=new T(this.getId()+"-title");this._oTitle.addStyleClass("sapMGTTitle");this._oTitle.cacheLineHeight=false;this.setAggregation("_titleText",this._oTitle,true);this._sFailedToLoad=this._rb.getText("INFOTILE_CANNOT_LOAD_TILE");this._sLoading=this._rb.getText("INFOTILE_LOADING");this._oFailedText=new T(this.getId()+"-failed-txt",{maxLines:2});this._oFailedText.cacheLineHeight=false;this._oFailedText.addStyleClass("sapMGTFailed");this.setAggregation("_failedMessageText",this._oFailedText,true);this._oWarningIcon=new I(this.getId()+"-warn-icon",{src:"sap-icon://notification",size:"1.37rem"});this._oWarningIcon.addStyleClass("sapMGTFtrFldIcnMrk");this._oBusy=new H(this.getId()+"-overlay");this._oBusy.addStyleClass("sapMGenericTileLoading");this._oBusy.setBusyIndicatorDelay(0);};
G.prototype.onBeforeRendering=function(){var s=this.getSubheader()?true:false;if(this.getMode()===l.GenericTileMode.HeaderMode){this._applyHeaderMode(s);}else{this._applyContentMode(s);}var t=this.getTileContent().length;for(var i=0;i<t;i++){this.getTileContent()[i].setDisabled(this.getState()==sap.m.LoadState.Disabled);}this._generateFailedText();this.$().unbind("mouseenter",this._updateAriaAndTitle);this.$().unbind("mouseleave",this._removeTooltipFromControl);};
G.prototype.onAfterRendering=function(){this.$().bind("mouseenter",this._updateAriaAndTitle.bind(this));this.$().bind("mouseleave",this._removeTooltipFromControl.bind(this));if(this.getMode()===l.GenericTileMode.HeaderMode&&this._aTileContentContent){var t=this.getTileContent();for(var i=0;i<t.length;i++){t[i].setAggregation("content",this._aTileContentContent[i],true);}delete this._aTileContentContent;}};
G.prototype.exit=function(){this._oWarningIcon.destroy();if(this._oImage){this._oImage.destroy();}this._oBusy.destroy();};
G.prototype.ontouchstart=function(){if(this.$("hover-overlay").length>0){this.$("hover-overlay").addClass("sapMGTPressActive");}if(sap.ui.Device.browser.internet_explorer&&this.getState()!==sap.m.LoadState.Disabled){this.$().focus();}};
G.prototype.ontouchcancel=function(){if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}};
G.prototype.ontouchend=function(){if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}if(sap.ui.Device.browser.internet_explorer&&this.getState()!==sap.m.LoadState.Disabled){this.$().focus();}};
G.prototype.ontap=function(e){if(this.getState()!==sap.m.LoadState.Disabled){if(sap.ui.Device.browser.internet_explorer){this.$().focus();}this.firePress();e.preventDefault();}};
G.prototype.onkeydown=function(e){if(q.sap.PseudoEvents.sapselect.fnCheck(e)&&this.getState()!==sap.m.LoadState.Disabled){if(this.$("hover-overlay").length>0){this.$("hover-overlay").addClass("sapMGTPressActive");}e.preventDefault();}};
G.prototype.onkeyup=function(e){if(q.sap.PseudoEvents.sapselect.fnCheck(e)&&this.getState()!==sap.m.LoadState.Disabled){if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}this.firePress();e.preventDefault();}};
G.prototype.getHeader=function(){return this._oTitle.getText();};
G.prototype.setHeader=function(t){this._oTitle.setText(t);return this;};
G.prototype.setHeaderImage=function(u){var v=!q.sap.equal(this.getHeaderImage(),u);if(v){if(this._oImage){this._oImage.destroy();this._oImage=undefined;}if(u){this._oImage=sap.ui.core.IconPool.createControlByURI({id:this.getId()+"-icon-image",src:u},sap.m.Image);this._oImage.addStyleClass("sapMGTHdrIconImage");}}return this.setProperty("headerImage",u);};
G.prototype._applyHeaderMode=function(s){if(s){this._oTitle.setMaxLines(4);}else{this._oTitle.setMaxLines(5);}var t=this.getTileContent();if(t.length>0){this._aTileContentContent=[];for(var i=0;i<t.length;i++){if(t[i].getContent()){this._aTileContentContent[i]=t[i].removeAllAggregation("content",true);this._aTileContentContent[i].setParent(null);}}}};
G.prototype._applyContentMode=function(s){if(s){this._oTitle.setMaxLines(2);}else{this._oTitle.setMaxLines(3);}};
G.prototype._getHeaderAriaAndTooltipText=function(){var t="";var i=true;if(this.getHeader()){t+=this.getHeader();i=false;}if(this.getSubheader()){t+=(i?"":"\n")+this.getSubheader();i=false;}if(this.getImageDescription()){t+=(i?"":"\n")+this.getImageDescription();}return t;};
G.prototype._getContentAriaAndTooltipText=function(){var t="";var b=true;var a=this.getTileContent();for(var i=0;i<a.length;i++){if(q.isFunction(a[i]._getAriaAndTooltipText)){t+=(b?"":"\n")+a[i]._getAriaAndTooltipText();}else if(a[i].getTooltip_AsString()){t+=(b?"":"\n")+a[i].getTooltip_AsString();}b=false;}return t;};
G.prototype._getAriaAndTooltipText=function(){var a=(this.getTooltip_AsString()&&!this._isTooltipSuppressed())?this.getTooltip_AsString():(this._getHeaderAriaAndTooltipText()+"\n"+this._getContentAriaAndTooltipText());switch(this.getState()){case sap.m.LoadState.Disabled:return"";case sap.m.LoadState.Loading:return a+"\n"+this._sLoading;case sap.m.LoadState.Failed:return a+"\n"+this._oFailedText.getText();default:if(q.trim(a).length===0){return"";}else{return a;}}};
G.prototype._getAriaText=function(){var a=this.getTooltip_Text();if(!a||this._isTooltipSuppressed()){a=this._getAriaAndTooltipText();}return a;};
G.prototype._getTooltipText=function(){var t=this.getTooltip_Text();if(this._isTooltipSuppressed()===true){t=null;}return t;};
G.prototype._checkFooter=function(t,c){if(c.getProperty("state")===sap.m.LoadState.Failed){t.setRenderFooter(false);}else{t.setRenderFooter(true);}};
G.prototype._generateFailedText=function(){var c=this.getFailedText();var f=c?c:this._sFailedToLoad;this._oFailedText.setText(f);this._oFailedText.setTooltip(f);};
G.prototype._isTooltipSuppressed=function(){var t=this.getTooltip_Text();if(t&&t.length>0&&q.trim(t).length===0){return true;}else{return false;}};
G.prototype._isHeaderTextTruncated=function(){var d,m;d=this.getAggregation("_titleText").getDomRef("inner");m=this.getAggregation("_titleText").getClampHeight(d);if(d&&m<d.scrollHeight){return true;}else{return false;}};
G.prototype._isSubheaderTextTruncated=function(){var s=this.$("subHdr-text");if(s&&s.length&&s[0].offsetWidth<s[0].scrollWidth){return true;}else{return false;}};
G.prototype._setTooltipFromControl=function(){var c,t="";var b=true;var a=this.getTileContent();if(this._isHeaderTextTruncated()){t=this._oTitle.getText();b=false;}if(this._isSubheaderTextTruncated()){t+=(b?"":"\n")+this.getSubheader();b=false;}for(var i=0;i<a.length;i++){c=a[i].getContent();if(c&&c.getMetadata().getLibraryName()==="sap.suite.ui.microchart"){t+=(b?"":"\n")+c.getTooltip_AsString();}b=false;}if(t&&!this._getTooltipText()&&!this._isTooltipSuppressed()){this.$().attr("title",t);this._bTooltipFromControl=true;}};
G.prototype._updateAriaAndTitle=function(){var a=this._getAriaAndTooltipText();var A=this._getAriaText();var t=this.$();if(t.attr("title")!==a){t.attr("aria-label",A);}t.find('*').removeAttr("aria-label").removeAttr("title").unbind("mouseenter");this._setTooltipFromControl();};
G.prototype._removeTooltipFromControl=function(){if(this._bTooltipFromControl){this.$().removeAttr("title");this._bTooltipFromControl=false;}};
return G;},true);
sap.ui.predefine('sap/m/GenericTileRenderer',[],function(){"use strict";var G={};
G.render=function(r,c){var t=c._getTooltipText();var a=c._getAriaText();var h=c.getHeaderImage();var H=c.hasListeners("press");r.write("<div");r.writeControlData(c);if(t){r.writeAttributeEscaped("title",t);}r.addClass("sapMGT");r.addClass(c.getFrameType());if(H){r.writeAttribute("role","button");}else{r.writeAttribute("role","presentation");}r.writeAttributeEscaped("aria-label",a);if(c.getState()!==sap.m.LoadState.Disabled){r.addClass("sapMPointer");r.writeAttribute("tabindex","0");}if(c.getBackgroundImage()){r.write(" style='background-image:url(");r.writeEscaped(c.getBackgroundImage());r.write(");'");r.addClass("sapMGTBackgroundImage");}if(c.getMode()===sap.m.GenericTileMode.HeaderMode){r.addClass("sapMGTHeaderMode");}r.writeClasses();r.write(">");if(c.getState()!==sap.m.LoadState.Loaded){this._renderStateOverlay(r,c,t);}else{this._renderHoverOverlay(r,c);}this._renderFocusDiv(r,c);r.write("<div");r.addClass("sapMGTHdrContent");r.addClass(c.getFrameType());if(t){r.writeAttributeEscaped("title",t);}r.writeClasses();r.write(">");if(h){r.renderControl(c._oImage);}this._renderHeader(r,c);if(c.getSubheader()){this._renderSubheader(r,c);}r.write("</div>");r.write("<div");r.addClass("sapMGTContent");r.writeClasses();r.writeAttribute("id",c.getId()+"-content");r.write(">");var T=c.getTileContent();var l=T.length;for(var i=0;i<l;i++){c._checkFooter(T[i],c);r.renderControl(T[i]);}r.write("</div>");r.write("</div>");};
G._renderFocusDiv=function(r,c){r.write("<div");r.addClass("sapMGTFocusDiv");r.writeClasses();r.writeAttribute("id",c.getId()+"-focus");r.write(">");r.write("</div>");};
G._renderStateOverlay=function(r,c,t){var s=c.getState();r.write("<div");r.addClass("sapMGTOverlay");r.writeClasses();r.writeAttribute("id",c.getId()+"-overlay");if(t){r.writeAttributeEscaped("title",t);}r.write(">");switch(s){case sap.m.LoadState.Loading:c._oBusy.setBusy(s==sap.m.LoadState.Loading);r.renderControl(c._oBusy);break;case sap.m.LoadState.Failed:r.write("<div");r.writeAttribute("id",c.getId()+"-failed-ftr");r.addClass("sapMGenericTileFtrFld");r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",c.getId()+"-failed-icon");r.addClass("sapMGenericTileFtrFldIcn");r.writeClasses();r.write(">");r.renderControl(c._oWarningIcon);r.write("</div>");r.write("<div");r.writeAttribute("id",c.getId()+"-failed-text");r.addClass("sapMGenericTileFtrFldTxt");r.writeClasses();r.write(">");r.renderControl(c.getAggregation("_failedMessageText"));r.write("</div>");r.write("</div>");break;default:}r.write("</div>");};
G._renderHoverOverlay=function(r,c){r.write("<div");if(c.getBackgroundImage()){r.addClass("sapMGTWithImageHoverOverlay");}else{r.addClass("sapMGTWithoutImageHoverOverlay");}r.writeClasses();r.writeAttribute("id",c.getId()+"-hover-overlay");r.write(">");r.write("</div>");};
G._renderHeader=function(r,c){r.write("<div");r.addClass("sapMGTHdrTxt");r.writeClasses();r.writeAttribute("id",c.getId()+"-hdr-text");r.write(">");r.renderControl(c._oTitle);r.write("</div>");};
G._renderSubheader=function(r,c){r.write("<div");r.addClass("sapMGTSubHdrTxt");r.writeClasses();r.writeAttribute("id",c.getId()+"-subHdr-text");r.write(">");r.writeEscaped(c.getSubheader());r.write("</div>");};
return G;},true);
sap.ui.predefine('sap/m/GroupHeaderListItem',['jquery.sap.global','./ListItemBase','./library'],function(q,L,l){"use strict";
var G=L.extend("sap.m.GroupHeaderListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Data",defaultValue:null},count:{type:"string",group:"Data",defaultValue:null},upperCase:{type:"boolean",group:"Appearance",defaultValue:false},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}}}});
G.prototype.getMode=function(){return sap.m.ListMode.None;};
G.prototype.shouldClearLastValue=function(){return true;};
G.prototype.getTable=function(){var p=this.getParent();if(p instanceof sap.m.Table){return p;}if(p&&p.getMetadata().getName()=="sap.m.Table"){return p;}};
G.prototype.onBeforeRendering=function(){var p=this.getParent();if(p&&sap.m.Table&&p instanceof sap.m.Table){p.getColumns().forEach(function(c){c.clearLastValue();});}};
return G;},true);
sap.ui.predefine('sap/m/GroupHeaderListItemRenderer',['jquery.sap.global','./ListItemBaseRenderer','sap/ui/core/Renderer'],function(q,L,R){"use strict";var G=R.extend(L);
G.openItemTag=function(r,l){r.write(l.getTable()?"<tr":"<li");};
G.closeItemTag=function(r,l){r.write(l.getTable()?"</tr>":"</li>");};
G.renderType=function(r,l){var t=l.getTable();t&&r.write('<td role="gridcell" class="sapMListTblNavCol">');L.renderType.apply(this,arguments);t&&r.write('</td>');};
G.handleNoFlex=function(r,l){};
G.renderCounter=function(r,l){};
G.getAriaRole=function(l){return l.getTable()?"row":"option";};
G.getAriaDescribedBy=function(l){var d=this.getAriaAnnouncement("group_header"),b=L.getAriaDescribedBy.call(this,l)||"";return d+" "+b;};
G.renderLIAttributes=function(r,l){r.addClass("sapMGHLI");if(l.getUpperCase()){r.addClass("sapMGHLIUpperCase");}};
G.renderLIContentWrapper=function(r,l){var t=l.getTable();if(t){r.write('<td class="sapMGHLICell" role="gridcell"');r.writeAttribute("colspan",t.getColSpan());r.write(">");}L.renderLIContentWrapper.apply(this,arguments);if(t){r.write("</td>");}};
G.renderLIContent=function(r,l){var t=l.getTitleTextDirection();r.write("<span class='sapMGHLITitle'");if(t!=sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",t.toLowerCase());}r.write(">");r.writeEscaped(l.getTitle());r.write("</span>");var c=l.getCount()||l.getCounter();if(c){r.write("<span class='sapMGHLICounter'>");r.writeEscaped(" ("+c+")");r.write("</span>");}};
G.addLegacyOutlineClass=function(r,l){if(!l.getTable()){L.addLegacyOutlineClass.apply(this,arguments);}};
return G;},true);
sap.ui.predefine('sap/m/GrowingEnablement',['jquery.sap.global','sap/ui/base/Object','sap/ui/core/format/NumberFormat'],function(q,B,N){"use strict";
var G=B.extend("sap.m.GrowingEnablement",{
constructor:function(c){B.apply(this);this._oControl=c;this._oControl.bUseExtendedChangeDetection=true;this._oControl.addDelegate(this);var r=this._oControl.getItems(true).length;this._iRenderedDataItems=r;this._iLimit=r;this._bLoading=false;this._sGroupingPath="";this._bDataRequested=false;this._oContainerDomRef=null;this._iTriggerTimer=0;this._aChunk=[];this._oRM=null;},
destroy:function(){if(this._oTrigger){this._oTrigger.destroy();this._oTrigger=null;}if(this._oScrollDelegate){this._oScrollDelegate.setGrowingList(null);this._oScrollDelegate=null;}if(this._oRM){this._oRM.destroy();this._oRM=null;}this._oControl.$("triggerList").remove();this._oControl.bUseExtendedChangeDetection=false;this._oControl.removeDelegate(this);this._oContainerDomRef=null;this._oControl=null;},
render:function(r){r.write("<ul");r.addClass("sapMListUl");r.addClass("sapMGrowingList");r.writeAttribute("id",this._oControl.getId()+"-triggerList");r.addStyle("display","none");r.writeClasses();r.writeStyles();r.write(">");r.renderControl(this._getTrigger());r.write("</ul>");},
onAfterRendering:function(){var c=this._oControl;if(c.getGrowingScrollToLoad()){var s=sap.m.getScrollDelegate(c);if(s){this._oScrollDelegate=s;s.setGrowingList(this.onScrollToLoad.bind(this),c.getGrowingDirection());}}else if(this._oScrollDelegate){this._oScrollDelegate.setGrowingList(null);this._oScrollDelegate=null;}this._updateTriggerDelayed(false);},
setTriggerText:function(t){this._oControl.$("triggerText").text(t);},
reset:function(){this._iLimit=0;},
shouldReset:function(c){var C=sap.ui.model.ChangeReason;return c==C.Sort||c==C.Filter||c==C.Context;},
getInfo:function(){return{total:this._oControl.getMaxItemsCount(),actual:this._iRenderedDataItems};},
onScrollToLoad:function(){if(!this._bLoading&&this._oControl.getGrowingDirection()==sap.m.ListGrowingDirection.Upwards){var s=this._oScrollDelegate;this._oScrollPosition={left:s.getScrollLeft(),bottom:s.getScrollHeight()-Math.max(s.getScrollTop(),0)};}this.requestNewPage();},
requestNewPage:function(){if(!this._oControl||this._bLoading){return;}var b=this._oControl.getBinding("items");if(b&&!b.isLengthFinal()||this._iLimit<this._oControl.getMaxItemsCount()){this._iLimit+=this._oControl.getGrowingThreshold();this._updateTriggerDelayed(true);this.updateItems("Growing");}},
_onBeforePageLoaded:function(c){this._bLoading=true;this._oControl.onBeforePageLoaded(this.getInfo(),c);},
_onAfterPageLoaded:function(c){this._bLoading=false;this._updateTriggerDelayed(false);this._oControl.onAfterPageLoaded(this.getInfo(),c);},
_getTrigger:function(){var t=this._oControl.getId()+"-trigger",T=this._oControl.getGrowingTriggerText();T=T||sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LOAD_MORE_DATA");this._oControl.addNavSection(t);if(this._oTrigger){this.setTriggerText(T);return this._oTrigger;}this._oTrigger=new sap.m.CustomListItem({id:t,busyIndicatorDelay:0,type:sap.m.ListType.Active,content:new sap.ui.core.HTML({content:'<div class="sapMGrowingListTrigger">'+'<div class="sapMSLITitleDiv sapMGrowingListTriggerText">'+'<h1 class="sapMSLITitle" id="'+t+'Text">'+q.sap.encodeHTML(T)+'</h1>'+'</div>'+'<div class="sapMGrowingListDescription sapMSLIDescription" id="'+t+'Info"></div>'+'</div>'})}).setParent(this._oControl,null,true).attachPress(this.requestNewPage,this).addEventDelegate({onsapenter:function(e){this.requestNewPage();e.preventDefault();},onsapspace:function(e){this.requestNewPage();e.preventDefault();},onAfterRendering:function(e){this._oTrigger.$().attr({"tabindex":0,"role":"button","aria-live":"polite"});}},this);this._oTrigger.getList=function(){};return this._oTrigger;},
_getListItemInfo:function(){return("[ "+this._iRenderedDataItems+" / "+N.getFloatInstance().format(this._oControl.getMaxItemsCount())+" ]");},
_getGroupingPath:function(b){var s=b.aSorters||[];var S=s[0]||{};return(S.fnGroup)?S.sPath||"":"";},
_getDomIndex:function(i){if(typeof i!="number"){return i;}if(this._oControl.hasPopin&&this._oControl.hasPopin()){return(i*2);}return i;},
_getHasScrollbars:function(){if(!this._oScrollDelegate){return false;}if(this._iRenderedDataItems>=40){return true;}return this._oScrollDelegate.getMaxScrollTop()>this._oControl.$("triggerList").outerHeight();},
destroyListItems:function(s){this._oControl.destroyItems(s);this._iRenderedDataItems=0;this._aChunk=[];},
addListItem:function(c,b,s){var C=this._oControl,o=b.binding,i=this.createListItem(c,b);if(o.isGrouped()){var I=C.getItems(true),l=I[I.length-1],m=b.model,g=o.getGroup(i.getBindingContext(m));if(l&&l.isGroupHeader()){C.removeAggregation("items",l,true);this._fnAppendGroupItem=this.appendGroupItem.bind(this,g,l,s);l=I[I.length-1];}if(!l||g.key!==o.getGroup(l.getBindingContext(m)).key){var a=(b.groupHeaderFactory)?b.groupHeaderFactory(g):null;if(C.getGrowingDirection()==sap.m.ListGrowingDirection.Upwards){this.applyPendingGroupItem();this._fnAppendGroupItem=this.appendGroupItem.bind(this,g,a,s);}else{this.appendGroupItem(g,a,s);}}}C.addAggregation("items",i,s);if(s){this._aChunk.push(i);}},
applyPendingGroupItem:function(){if(this._fnAppendGroupItem){this._fnAppendGroupItem();this._fnAppendGroupItem=undefined;}},
appendGroupItem:function(g,o,s){o=this._oControl.addItemGroup(g,o,s);if(s){this._aChunk.push(o);}},
createListItem:function(c,b){this._iRenderedDataItems++;var i=b.factory("",c);return i.setBindingContext(c,b.model);},
updateItemsBindingContext:function(C,m){if(!C.length){return;}var I=this._oControl.getItems(true);for(var i=0,c=0,o;i<I.length;i++){o=I[i];if(!o.isGroupHeader()){o.setBindingContext(C[c++],m);}}},
applyChunk:function(I,d){this.applyPendingGroupItem();var l=this._aChunk.length;if(!l){return;}if(this._oControl.getGrowingDirection()==sap.m.ListGrowingDirection.Upwards){this._aChunk.reverse();if(I===true){I=0;}else if(typeof I=="number"){I=this._iRenderedDataItems-l-I;}}d=d||this._oContainerDomRef;this._oRM=this._oRM||sap.ui.getCore().createRenderManager();for(var i=0;i<l;i++){this._oRM.renderControl(this._aChunk[i]);}this._oRM.flush(d,false,this._getDomIndex(I));this._aChunk=[];},
addListItems:function(c,b,s){for(var i=0;i<c.length;i++){this.addListItem(c[i],b,s);}},
rebuildListItems:function(c,b,s){this.destroyListItems(s);this.addListItems(c,b,s);if(s){var h=this._oContainerDomRef.contains(document.activeElement);this.applyChunk(false);h&&this._oControl.focus();}else{this.applyPendingGroupItem();}},
insertListItem:function(c,b,i){var I=this.createListItem(c,b);this._oControl.insertAggregation("items",I,i,true);this._aChunk.push(I);},
deleteListItem:function(i){this._oControl.getItems(true)[i].destroy(true);this._iRenderedDataItems--;},
refreshItems:function(c){if(!this._bDataRequested){this._bDataRequested=true;this._onBeforePageLoaded(c);}if(!this._iLimit||this.shouldReset(c)||!this._oControl.getItems(true).length){this._iLimit=this._oControl.getGrowingThreshold();}this._oControl.getBinding("items").getContexts(0,this._iLimit);},
updateItems:function(c){var C=this._oControl,b=C.getBinding("items"),o=C.getBindingInfo("items"),I=C.getItems(true);if(!this._iLimit||this.shouldReset(c)||!I.length){this._iLimit=C.getGrowingThreshold();}if(this._bDataRequested){this._bDataRequested=false;}else{this._onBeforePageLoaded(c);}var a=b.getContexts(0,this._iLimit)||[];if(a.dataRequested){this._bDataRequested=true;if(a.diff&&!a.diff.length){return;}}this._oContainerDomRef=C.getItemsContainerDomRef();var d=a.diff,f=false,v;if(!a.length){this.destroyListItems();}else if(!this._oContainerDomRef){this.rebuildListItems(a,o);}else if(!d||!I.length&&d.length){this.rebuildListItems(a,o,true);}else if(b.isGrouped()||C.checkGrowingFromScratch()){if(this._sGroupingPath!=this._getGroupingPath(b)){f=true;}else{for(var i=0;i<d.length;i++){var D=d[i],e=a[D.index];if(D.type=="delete"){f=true;break;}else if(D.index!=this._iRenderedDataItems){f=true;break;}else{this.addListItem(e,o,true);v=true;}}}}else{if(this._sGroupingPath){C.removeGroupHeaders(true);}v=-1;var l=-1;for(var i=0;i<d.length;i++){var D=d[i],g=D.index,e=a[g];if(D.type=="delete"){if(v!=-1){this.applyChunk(v);l=-1;v=-1;}this.deleteListItem(g);}else{if(v==-1){v=g;}else if(l>-1&&g!=l+1){this.applyChunk(v);v=g;}this.insertListItem(e,o,g);l=g;}}}if(f){this.rebuildListItems(a,o,true);}else if(this._oContainerDomRef&&d&&d.length){this.updateItemsBindingContext(a,o.model);this.applyChunk(v);}this._oContainerDomRef=null;this._sGroupingPath=this._getGroupingPath(b);if(!this._bDataRequested){this._onAfterPageLoaded(c);}},
_updateTriggerDelayed:function(l){if(this._oControl.getGrowingScrollToLoad()){this._iTriggerTimer&&q.sap.clearDelayedCall(this._iTriggerTimer);this._iTriggerTimer=q.sap.delayedCall(0,this,"_updateTrigger",[l]);}else{this._updateTrigger(l);}},
_updateTrigger:function(l){var t=this._oTrigger,c=this._oControl;if(!t||!c){return;}var b=c.getBinding("items");if(!b){return;}t.setBusy(l);t.$().toggleClass("sapMGrowingListBusyIndicatorVisible",l);if(l){t.setActive(false);c.$("triggerList").css("display","");}else{var i=c.getItems(true),I=i.length,a=b.getLength()||0,L=b.isLengthFinal(),h=c.getGrowingScrollToLoad();if(!I||!this._iLimit||(L&&this._iLimit>=a)||(h&&this._getHasScrollbars())){c.$("triggerList").css("display","none");if(document.activeElement===t.getDomRef()){c.$().focus();}}else{if(L){c.$("triggerInfo").css("display","block").text(this._getListItemInfo());}t.$().removeClass("sapMGrowingListBusyIndicatorVisible");c.$("triggerList").css("display","");}if(h&&this._oScrollPosition===undefined&&c.getGrowingDirection()==sap.m.ListGrowingDirection.Upwards){this._oScrollPosition={left:0,bottom:0};}if(I>0&&this._oScrollPosition){var s=this._oScrollDelegate,S=this._oScrollPosition;s.scrollTo(S.left,s.getScrollHeight()-S.bottom);this._oScrollPosition=null;}}}
});
return G;},true);
sap.ui.predefine('sap/m/GrowingList',['jquery.sap.global','./List','./library'],function(q,L,l){"use strict";
var G=L.extend("sap.m.GrowingList",{metadata:{deprecated:true,library:"sap.m",properties:{threshold:{type:"int",group:"Misc",defaultValue:20},triggerText:{type:"string",group:"Appearance",defaultValue:null},scrollToLoad:{type:"boolean",group:"Behavior",defaultValue:false}}}});
G.prototype._isIncompatible=function(){return sap.ui.getCore().getConfiguration().getCompatibilityVersion("sapMGrowingList").compareTo("1.16")>=0;};
G.prototype.init=function(){sap.m.ListBase.prototype.init.call(this);if(!this._isIncompatible()){this.setGrowing();}};
G.prototype.setGrowing=function(){return sap.m.ListBase.prototype.setGrowing.call(this,true);};
!(function(g,o){["Threshold","TriggerText","ScrollToLoad"].forEach(function(p){g["set"+p]=o["setGrowing"+p];g["get"+p]=o["getGrowing"+p];});}(G.prototype,sap.m.ListBase.prototype));return G;},true);
sap.ui.predefine('sap/m/GrowingListRenderer',['jquery.sap.global','./ListRenderer','sap/ui/core/Renderer'],function(q,L,R){"use strict";var G=R.extend(L);
G.render=function(r,c){if(c._isIncompatible()){q.sap.log.warning("Does not render sap.m.GrowingList#"+c.getId()+" when compatibility version is 1.16 or higher. Instead use sap.m.List/Table control with growing feature!");}else{L.render.call(this,r,c);}};
return G;},true);
sap.ui.predefine('sap/m/HBox',['jquery.sap.global','./FlexBox','./library'],function(q,F,l){"use strict";
var H=F.extend("sap.m.HBox",{metadata:{library:"sap.m"}});
return H;},true);
sap.ui.predefine('sap/m/HBoxRenderer',['jquery.sap.global','./FlexBoxRenderer'],function(q,F){"use strict";var H={};
H.render=function(r,c){F.render.apply(this,[r,c]);};
return H;},true);
sap.ui.predefine('sap/m/IconTabBar',['jquery.sap.global','./library','sap/ui/core/Control'],function(q,l,C){"use strict";
var I=C.extend("sap.m.IconTabBar",{metadata:{interfaces:["sap.m.ObjectHeaderContainer"],library:"sap.m",properties:{showSelection:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},expandable:{type:"boolean",group:"Misc",defaultValue:true},expanded:{type:"boolean",group:"Misc",defaultValue:true},selectedKey:{type:"string",group:"Data",defaultValue:null},upperCase:{type:"boolean",group:"Appearance",defaultValue:false},stretchContentHeight:{type:"boolean",group:"Appearance",defaultValue:false},applyContentPadding:{type:"boolean",group:"Appearance",defaultValue:true},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:sap.m.BackgroundDesign.Solid},headerMode:{type:"sap.m.IconTabHeaderMode",group:"Appearance",defaultValue:sap.m.IconTabHeaderMode.Standard},showOverflowSelectList:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{items:{type:"sap.m.IconTab",multiple:true,singularName:"item"},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},_header:{type:"sap.m.IconTabHeader",multiple:false,visibility:"hidden"}},events:{select:{parameters:{item:{type:"sap.m.IconTabFilter"},key:{type:"string"},selectedItem:{type:"sap.m.IconTabFilter"},selectedKey:{type:"string"}}},expand:{parameters:{expand:{type:"boolean"},collapse:{type:"boolean"}}}}}});
I.prototype.clone=function(){var c=C.prototype.clone.apply(this,arguments);var i=this._getIconTabHeader();c.setAggregation("_header",i.clone(),true);return c;};
I.prototype.setExpanded=function(e){this.setProperty("expanded",e,true);if(this.$().length){this._toggleExpandCollapse(e);}return this;};
I.prototype.setExpandable=function(e){this.setProperty("expandable",e,true);return this;};
I.prototype.setHeaderMode=function(m){this.setProperty("headerMode",m,true);this._getIconTabHeader().setMode(m);return this;};
I.prototype.setShowOverflowSelectList=function(v){this.setProperty("showOverflowSelectList",v,true);this._getIconTabHeader().setShowOverflowSelectList(v);return this;};
I.prototype._rerenderContent=function(c){var $=this.$("content");if(c&&($.length>0)){var r=sap.ui.getCore().createRenderManager();for(var i=0;i<c.length;i++){r.renderControl(c[i]);}r.flush($[0]);r.destroy();}};
I.prototype._toggleExpandCollapse=function(e){var $=this.$("content");var s=this._getIconTabHeader().oSelectedItem;if(e===undefined){e=!this.getExpanded();}if(s){s.$().toggleClass("sapMITBSelected",e);s.$().attr({'aria-expanded':e});if(e){s.$().attr({'aria-selected':e});}else{s.$().removeAttr('aria-selected');}}this._iAnimationCounter=(this._iAnimationCounter===undefined?1:++this._iAnimationCounter);if(e){if(s){if(this.$("content").children().length===0){var S=s.getContent();if(S.length>0){this._rerenderContent(S);}else{this._rerenderContent(this.getContent());}}$.stop(true,true).slideDown('400',q.proxy(this.onTransitionEnded,this,e));this.$("containerContent").toggleClass("sapMITBContentClosed",!e);}}else{this.$("contentArrow").hide();$.stop(true,true).slideUp('400',q.proxy(this.onTransitionEnded,this,e));}if(!e||s){this.setProperty("expanded",e,true);}this.fireExpand({expand:e,collapse:!e});return this;};
I.prototype.onTransitionEnded=function(e){var $=this.$("content"),a=this.$("containerContent"),b=this.$("contentArrow");if(this._iAnimationCounter===1){a.toggleClass("sapMITBContentClosed",!e);if(e){b.show();$.css("display","block");}else{b.hide();$.css("display","none");}}this._iAnimationCounter=(this._iAnimationCounter>0?--this._iAnimationCounter:0);return this;};
I.prototype._getIconTabHeader=function(){var c=this.getAggregation("_header");if(!c){c=new sap.m.IconTabHeader(this.getId()+"--header",{});this.setAggregation("_header",c,true);}return c;};
I.prototype.setShowSelection=function(v){this._getIconTabHeader().setShowSelection(v);return this;};
I.prototype.getShowSelection=function(){return this._getIconTabHeader().getShowSelection();};
I.prototype.setSelectedKey=function(v){this._getIconTabHeader().setSelectedKey(v);return this;};
I.prototype.getSelectedKey=function(){return this._getIconTabHeader().getSelectedKey();};
I.prototype.setSelectedItem=function(i,a){return this._getIconTabHeader().setSelectedItem(i,a);};
I.prototype._callMethodInManagedObject=function(f,a){var A=Array.prototype.slice.call(arguments),h;if(a==="items"){h=this._getIconTabHeader();return h[f].apply(h,A.slice(1));}else{return sap.ui.base.ManagedObject.prototype[f].apply(this,A.slice(1));}};
I.prototype.bindAggregation=function(){var a=Array.prototype.slice.call(arguments);this._callMethodInManagedObject.apply(this,["bindAggregation"].concat(a));return this;};
I.prototype.validateAggregation=function(a,o,m){return this._callMethodInManagedObject("validateAggregation",a,o,m);};
I.prototype.setAggregation=function(a,o,s){this._callMethodInManagedObject("setAggregation",a,o,s);return this;};
I.prototype.getAggregation=function(a,d){return this._callMethodInManagedObject("getAggregation",a,d);};
I.prototype.indexOfAggregation=function(a,o){return this._callMethodInManagedObject("indexOfAggregation",a,o);};
I.prototype.insertAggregation=function(a,o,i,s){this._callMethodInManagedObject("insertAggregation",a,o,i,s);return this;};
I.prototype.addAggregation=function(a,o,s){this._callMethodInManagedObject("addAggregation",a,o,s);return this;};
I.prototype.removeAggregation=function(a,o,s){return this._callMethodInManagedObject("removeAggregation",a,o,s);};
I.prototype.removeAllAggregation=function(a,s){return this._callMethodInManagedObject("removeAllAggregation",a,s);};
I.prototype.destroyAggregation=function(a,s){this._callMethodInManagedObject("destroyAggregation",a,s);return this;};
I.prototype.getBinding=function(a){return this._callMethodInManagedObject("getBinding",a);};
I.prototype.getBindingInfo=function(a){return this._callMethodInManagedObject("getBindingInfo",a);};
I.prototype.getBindingPath=function(a){return this._callMethodInManagedObject("getBindingPath",a);};
return I;},true);
sap.ui.predefine('sap/m/IconTabBarRenderer',['jquery.sap.global','sap/ui/core/IconPool'],function(q,I){"use strict";var a={};a._aAllIconColors=['sapMITBFilterCritical','sapMITBFilterPositive','sapMITBFilterNegative','sapMITBFilterDefault'];
a.render=function(r,c){var C=c.getContent(),h=c._getIconTabHeader();r.write("<div ");r.writeControlData(c);r.addClass("sapMITB");if(c.getStretchContentHeight()){r.addClass("sapMITBStretch");}if(!c.getApplyContentPadding()){r.addClass("sapMITBNoContentPadding");}r.addClass("sapMITBBackgroundDesign"+c.getBackgroundDesign());r.writeClasses();r.write(">");if(!c._bHideHeader){r.renderControl(h);}r.write("<div id='"+c.getId()+"-containerContent' ");r.addClass("sapMITBContainerContent");if(!c.getExpanded()){r.addClass("sapMITBContentClosed");}r.writeClasses();r.write(">");r.write("<div id='"+c.getId()+"-content' class='sapMITBContent' role='tabpanel' ");if(!c.getExpanded()){r.write("style='display: none'");}r.write(">");if(c.getExpanded()){if(h.oSelectedItem&&h.oSelectedItem.getContent()){var o=h.oSelectedItem.getContent();if(o.length>0){C=o;}}if(C.length>0){for(var i=0;i<C.length;i++){r.renderControl(C[i]);}}}r.write("</div>");r.write("</div>");r.write("</div>");};
return a;},true);
sap.ui.predefine('sap/m/IconTabBarSelectList',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation'],function(q,l,C,I){"use strict";
var a=C.extend("sap.m.IconTabBarSelectList",{metadata:{library:"sap.m",aggregations:{items:{type:"sap.m.IconTabFilter",multiple:true,singularName:"item"}},events:{selectionChange:{parameters:{selectedItem:{type:"sap.m.IconTabFilter"}}}}}});
a.prototype.init=function(){this._itemNavigation=new I();this._itemNavigation.setCycling(false);this.addEventDelegate(this._itemNavigation);this._itemNavigation.setPageSize(10);};
a.prototype.exit=function(){if(this._itemNavigation){this._itemNavigation.destroy();this._itemNavigation=null;}};
a.prototype.onAfterRendering=function(){var b,c=this.getItems(),d=[];for(var i=0;i<c.length;i++){b=c[i];d.push(b.getDomRef());}this._itemNavigation.setRootDomRef(this.getDomRef());this._itemNavigation.setItemDomRefs(d);};
a.prototype.setSelectedItem=function(i){if(this._selectedItem){this._deselectItem(this._selectedItem);}if(i){this._selectItem(i);}this._selectedItem=i;};
a.prototype.getSelectedItem=function(){return this._selectedItem;};
a.prototype._deselectItem=function(i){var $=i.$();if($){$.removeClass('sapMITBSelectItemSelected');$.removeAttr('aria-selected');}};
a.prototype._selectItem=function(i){var $=i.$();if($){$.addClass('sapMITBSelectItemSelected');$.attr('aria-selected',true);}};
a.prototype.ontap=function(e){var $=q(e.target);if(!$.hasClass('sapMITBSelectItem')){$=$.parent(".sapMITBSelectItem");}var s=sap.ui.getCore().byId($[0].id);if(s&&s.getEnabled()){e.preventDefault();if(s!=this.getSelectedItem()){this._selectItem(s);this.fireSelectionChange({selectedItem:s});}}if(this._iconTabHeader){this._iconTabHeader._closeOverflow();}};
a.prototype.onsapenter=a.prototype.ontap;a.prototype.onsapspace=a.prototype.ontap;return a;},true);
sap.ui.predefine('sap/m/IconTabBarSelectListRenderer',['jquery.sap.global','sap/ui/core/Renderer','sap/ui/core/IconPool','sap/ui/core/InvisibleText'],function(q,R,I,a){"use strict";var b={};
b.render=function(r,c){var i,d,e=c.getItems(),f=c._iconTabHeader,g=true,h,j=sap.ui.getCore().getConfiguration().getRTL(),l=e.length;if(f){g=f._bTextOnly;h=this.checkIconOnly(e);}var o={isTextOnly:g,isIconOnly:h,isRtl:j,length:l,resourceBundle:sap.ui.getCore().getLibraryResourceBundle('sap.m')};r.write("<ul");r.writeAttribute('role','listbox');r.writeControlData(c);r.addClass("sapMITBSelectList");if(g){r.addClass("sapMITBSelectListTextOnly");}r.writeClasses();r.write(">");for(i=0;i<e.length;i++){d=e[i];o.index=i;this.renderItem(r,c,d,o);}r.write("</ul>");};
b.checkIconOnly=function(c){var d;for(var i=0;i<c.length;i++){d=c[i];if(d.getText()||d.getCount()){return false;}}return true;};
b.renderItem=function(r,c,i,o){if(!i.getVisible()){return;}r.write('<li');r.writeElementData(i);r.writeAttribute('tabindex','-1');r.writeAttribute('role','option');r.writeAttribute('aria-posinset',o.index+1);r.writeAttribute('aria-setsize',o.length);var t=i.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}if(!i.getEnabled()){r.addClass("sapMITBDisabled");r.writeAttribute("aria-disabled",true);}r.addClass("sapMITBSelectItem");if(c.getSelectedItem()==i){r.addClass("sapMITBSelectItemSelected");r.writeAttribute('aria-selected',true);}var d=i.getIconColor();r.addClass("sapMITBFilter"+d);r.writeClasses();var e=i.getId(),f,g=d=='Positive'||d=='Critical'||d=='Negative';var l=' aria-labelledby="';if(!o.isIconOnly){l+=e+'-text ';}if(!o.isTextOnly&&i.getIcon()){l+=e+'-icon ';}if(g){f=new a({text:o.resourceBundle.getText('ICONTABBAR_ICONCOLOR_'+d.toUpperCase())});l+=f.getId();}l+='"';r.write(l+'>');if(f){r.renderControl(f);}if(!o.isTextOnly){this._renderIcon(r,i);}if(!o.isIconOnly){this._renderText(r,i,o.isRtl);}r.write("</li>");};
b._renderIcon=function(r,i){var c=i.getIcon();if(c){var d=I.getIconInfo(c);var e=["sapMITBSelectItemIcon"];if(d&&!d.suppressMirroring){e.push("sapUiIconMirrorInRTL");}r.writeIcon(c,e,{id:i.getId()+'-icon',"aria-hidden":true});}else{r.write('<span class="sapUiIcon"></span>');}};
b._renderText=function(r,i,c){r.write('<span');r.writeAttribute("id",i.getId()+'-text');r.writeAttribute("dir","ltr");r.addClass("sapMText");r.addClass("sapMTextNoWrap");r.addClass("sapMITBText");r.writeClasses();var t=i.getTextDirection();if(t!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",t.toLowerCase());}var d=R.getTextAlign(sap.ui.core.TextAlign.Begin,t);if(d){r.addStyle("text-align",d);r.writeStyles();}var e=i.getText();var f=i.getCount();if(f){if(c){e='('+f+') '+e;}else{e+=' ('+f+')';}}r.write(">");r.writeEscaped(e);r.write("</span>");};
return b;},true);
sap.ui.predefine('sap/m/IconTabFilter',['jquery.sap.global','./library','sap/ui/core/Item'],function(q,l,I){"use strict";
var a=I.extend("sap.m.IconTabFilter",{metadata:{interfaces:["sap.m.IconTab","sap.ui.core.PopupInterface"],library:"sap.m",properties:{count:{type:"string",group:"Data",defaultValue:''},showAll:{type:"boolean",group:"Misc",defaultValue:false},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:''},iconColor:{type:"sap.ui.core.IconColor",group:"Appearance",defaultValue:sap.ui.core.IconColor.Default},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true},visible:{type:"boolean",group:"Behavior",defaultValue:true},design:{type:"sap.m.IconTabFilterDesign",group:"Appearance",defaultValue:sap.m.IconTabFilterDesign.Vertical}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}}}});
a.prototype._getImageControl=function(c,p,C){var P={src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};if(P.src){this._oImageControl=sap.m.ImageHelper.getImageControl(this.getId()+"-icon",this._oImageControl,p,P,c,C);}else if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=null;}return this._oImageControl;};
a.prototype.exit=function(e){if(this._oImageControl){this._oImageControl.destroy();}if(I.prototype.exit){I.prototype.exit.call(this,e);}};
a.prototype.invalidate=function(){var i=this.getParent(),o;if(i instanceof sap.m.IconTabHeader&&i.getParent()instanceof sap.m.IconTabBar){o=i.getParent();if(o.getParent()instanceof sap.m.ObjectHeader){var O=o.getParent();O.invalidate();}else{o.invalidate();}}};
a.prototype.setProperty=function(p,v,s){switch(p){case'text':case'count':case'showAll':case'icon':case'iconColor':case'iconDensityAware':case'design':if(this.getProperty(p)===v){return this;}sap.ui.core.Control.prototype.setProperty.call(this,p,v,true);if(!s){var i=this.getParent();if(i instanceof sap.m.IconTabHeader){i.invalidate();}}break;default:sap.ui.core.Control.prototype.setProperty.apply(this,arguments);break;}return this;};
a.prototype._getNonEmptyKey=function(){var k=this.getKey();if(k){return k;}return this.getId();};
return a;},true);
sap.ui.predefine('sap/m/IconTabHeader',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/delegate/ItemNavigation','sap/ui/core/IconPool','sap/ui/core/delegate/ScrollEnablement','./IconTabBarSelectList','./Button','./ResponsivePopover','./IconTabFilter'],function(q,l,C,E,I,a,S,b,B,R,c){"use strict";
var d=C.extend("sap.m.IconTabHeader",{metadata:{library:"sap.m",properties:{showSelection:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},selectedKey:{type:"string",group:"Data",defaultValue:null},visible:{type:"boolean",group:"Behavior",defaultValue:true},mode:{type:"sap.m.IconTabHeaderMode",group:"Appearance",defaultValue:sap.m.IconTabHeaderMode.Standard},showOverflowSelectList:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{items:{type:"sap.m.IconTab",multiple:true,singularName:"item"}},events:{select:{parameters:{item:{type:"sap.m.IconTabFilter"},key:{type:"string"}}}}}});
E.apply(d.prototype,[true]);d.SCROLL_STEP=264;
d.prototype.init=function(){this._bPreviousScrollForward=false;this._bPreviousScrollBack=false;this._iCurrentScrollLeft=0;this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this.startScrollX=0;this.startTouchX=0;this._scrollable=null;this._aTabKeys=[];this._oItemNavigation=new I().setCycling(false);this._oItemNavigation.attachEvent(I.Events.FocusLeave,this._onItemNavigationFocusLeave,this);this._oItemNavigation.attachEvent(I.Events.AfterFocus,this._onItemNavigationAfterFocus,this);this.addDelegate(this._oItemNavigation);this._oScroller=new S(this,this.getId()+"-head",{horizontal:true,vertical:false,nonTouchScrolling:true});};
d.prototype._getSelectList=function(){var t=this;if(!this._oSelectList){this._oSelectList=new b({selectionChange:function(e){var T=e.getParameter('selectedItem');t.setSelectedItem(T._tabFilter);}});this._oSelectList._iconTabHeader=this;}return this._oSelectList;};
d.prototype._getOverflowButton=function(){if(!this._oOverflowButton){this._oOverflowButton=new B({id:this.getId()+'-overflow',icon:"sap-icon://overflow",type:sap.m.ButtonType.Transparent,press:this._overflowButtonPress.bind(this)});}return this._oOverflowButton;};
d.prototype._overflowButtonPress=function(e){if(!this._oPopover){this._oPopover=new R({showArrow:false,showHeader:false,placement:sap.m.PlacementType.Vertical,offsetX:0,offsetY:0}).addStyleClass('sapMITBPopover');if(sap.ui.Device.system.phone){this._oPopover._oControl.addButton(this._createPopoverCloseButton());}}var s=this._getSelectList();this._oPopover.removeAllContent();this._oPopover.addContent(s);this._oPopover.setInitialFocus(s.getSelectedItem());this._oPopover.openBy(this._getOverflowButton());};
d.prototype._createPopoverCloseButton=function(){var t=this;var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");return new B({text:r.getText("SELECT_CANCEL_BUTTON"),press:function(){t._closeOverflow();}});};
d.prototype._closeOverflow=function(){if(!sap.ui.Device.system.desktop){this._oPopover.close();}if(this.oSelectedItem){this.oSelectedItem.$().focus();}};
d.prototype._setSelectListItems=function(){if(!this.getShowOverflowSelectList()){return;}var s,t,o=this._getSelectList(),T=this.getTabFilters();o.removeAllItems();for(var i=0;i<T.length;i++){t=T[i];s=new c({visible:t.getVisible(),enabled:t.getEnabled(),icon:t.getIcon(),text:t.getText(),count:t.getCount(),iconColor:t.getIconColor(),iconDensityAware:t.getIconDensityAware(),textDirection:t.getTextDirection(),tooltip:t.getTooltip()});s._tabFilter=t;o.addItem(s);if(t==this.oSelectedItem){o.setSelectedItem(s);}}};
d.prototype._findSelectItem=function(t){var s=this._getSelectList(),e=s.getItems(),o;for(var i=0;i<e.length;i++){o=e[i];if(o._tabFilter==t){return o;}}};
d.prototype._onItemNavigationFocusLeave=function(){if(!this.oSelectedItem){return;}var e=this.getItems();var f=-1;var o;for(var i=0;i<e.length;i++){o=e[i];if(o instanceof sap.m.IconTabFilter==false){continue;}f++;if(this.oSelectedItem==o){break;}}this._oItemNavigation.setFocusedIndex(f);};
d.prototype._onItemNavigationAfterFocus=function(e){var h=this.getDomRef("head"),i=e.getParameter("index"),$=e.getParameter('event');if($.keyCode===undefined){return;}this._iCurrentScrollLeft=h.scrollLeft;this._checkOverflow();if(i!==null&&i!==undefined){this._scrollIntoView(this.getTabFilters()[i],0);}};
d.prototype.getTabFilters=function(){var i=this.getItems();var t=[];i.forEach(function(o){if(o instanceof sap.m.IconTabFilter){t.push(o);}});return t;};
d.prototype.exit=function(){if(this._oArrowLeft){this._oArrowLeft.destroy();}if(this._oArrowRight){this._oArrowRight.destroy();}if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this._aTabKeys){this._aTabKeys=null;}if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}if(this._oOverflowButton){this._oOverflowButton.destroy();this._oOverflowButton=null;}};
d.prototype.onBeforeRendering=function(){var e=this.getItems(),s=this.getSelectedKey(),i=0;if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(e.length>0){if(!this.oSelectedItem||s&&s!==this.oSelectedItem._getNonEmptyKey()){if(s){for(;i<e.length;i++){if(!(e[i]instanceof sap.m.IconTabSeparator)&&e[i]._getNonEmptyKey()===s){this.oSelectedItem=e[i];break;}}}if(!this.oSelectedItem){for(i=0;i<e.length;i++){if(!(e[i]instanceof sap.m.IconTabSeparator)&&e[i].getVisible()){this.oSelectedItem=e[i];break;}}}}if(this.oSelectedItem&&!this.oSelectedItem.getVisible()){for(i=0;i<e.length;i++){if(!(e[i]instanceof sap.m.IconTabSeparator)&&e[i].getVisible()){this.oSelectedItem=e[i];break;}}}if(this.oSelectedItem){this.setProperty("selectedKey",this.oSelectedItem._getNonEmptyKey(),true);}}this._setSelectListItems();if(this._sResizeListenerNoFlexboxSupportId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerNoFlexboxSupportId);this._sResizeListenerNoFlexboxSupportId=null;}};
d.prototype.setSelectedKey=function(k){var e=this.getTabFilters(),i=0;if(e.length>0){k=k||e[0]._getNonEmptyKey();}if(this.$().length){for(;i<e.length;i++){if(e[i]._getNonEmptyKey()===k){this.setSelectedItem(e[i],true);break;}}}this.setProperty("selectedKey",k,true);return this;};
d.prototype.setSelectedItem=function(i,A){if(!i||!i.getEnabled()){return this;}if(this.getShowOverflowSelectList()){var s=this._findSelectItem(i);if(s){this._getSelectList().setSelectedItem(s);}}var p=this.getParent();var e=p instanceof sap.m.IconTabBar;var f=false;if(i.getContent().length===0&&this.oSelectedItem&&this.oSelectedItem.getContent().length===0){f=true;}if(this.oSelectedItem&&this.oSelectedItem.getVisible()&&(e&&p.getExpandable()||this.oSelectedItem!==i)){this.oSelectedItem.$().removeClass("sapMITBSelected").attr('aria-selected',false).removeAttr('aria-expanded');}if(i.getVisible()){if(this.oSelectedItem===i){if(!A&&e&&p.getExpandable()){p._toggleExpandCollapse();}}else{if(e){p.$("content").attr('aria-labelledby',i.sId);}this.oSelectedItem=i;this.setProperty("selectedKey",this.oSelectedItem._getNonEmptyKey(),true);if(!e){this.oSelectedItem.$().addClass("sapMITBSelected").attr({'aria-selected':true});}if(e&&(p.getExpandable()||p.getExpanded())){this.oSelectedItem.$().addClass("sapMITBSelected").attr({'aria-selected':true});var o=this.oSelectedItem.getContent();if(o.length>0){p._rerenderContent(o);}else{if(!f){p._rerenderContent(p.getContent());}}if(!A&&p.getExpandable()&&!p.getExpanded()){p._toggleExpandCollapse(true);}}}if(this.oSelectedItem.$().length>0){this._scrollIntoView(i,500);}else{this._scrollAfterRendering=true;}}var g=this.oSelectedItem._getNonEmptyKey();this.oSelectedItem=i;this.setProperty("selectedKey",g,true);if(e){p.setProperty("selectedKey",g,true);}if(!A){if(e){p.fireSelect({selectedItem:this.oSelectedItem,selectedKey:g,item:this.oSelectedItem,key:g});}else{this.fireSelect({selectedItem:this.oSelectedItem,selectedKey:g,item:this.oSelectedItem,key:g});}}return this;};
d.prototype._getFirstVisibleItem=function(e){for(var i=0;i<e.length;i++){if(e[i].getVisible()){return e[i];}}return null;};
d.prototype.onAfterRendering=function(){var h=this.getDomRef("head");if(this._oScroller){this._oScroller.setIconTabBar(this,q.proxy(this._afterIscroll,this),q.proxy(this._scrollPreparation,this));}var p=this.getParent();var i=p instanceof sap.m.IconTabBar;if(this.oSelectedItem&&(!i||i&&p.getExpanded())){this.oSelectedItem.$().addClass("sapMITBSelected").attr({'aria-selected':true});}q.sap.delayedCall(350,this,"_checkOverflow");if(this.oSelectedItem){if(!this._bDoThisOnlyOnce){q.sap.delayedCall(1000,this,"_scrollIntoView",[this.oSelectedItem,0]);this._bDoThisOnlyOnce=true;}else if(this._scrollAfterRendering){this._scrollIntoView(this.oSelectedItem,500);this._scrollAfterRendering=false;}}var e=this.getItems();var t=[];var s=-1;var f=this;e.forEach(function(o){if(o instanceof sap.m.IconTabFilter){var g=f.getFocusDomRef(o);q(g).attr("tabindex","-1");t.push(g);if(o===f.oSelectedItem){s=t.indexOf(o);}}});if(!this._oItemNavigation){this._oItemNavigation=new I();this._oItemNavigation.attachEvent(I.Events.FocusLeave,this._onItemNavigationFocusLeave,this);this._oItemNavigation.attachEvent(I.Events.AfterFocus,this._onItemNavigationAfterFocus,this);this.addDelegate(this._oItemNavigation);}this._oItemNavigation.setRootDomRef(h);this._oItemNavigation.setItemDomRefs(t);this._oItemNavigation.setSelectedIndex(s);if(this.getShowOverflowSelectList()){this.$('overflow').attr('tabindex',-1);}this._sResizeListenerId=sap.ui.core.ResizeHandler.register(this.getDomRef(),q.proxy(this._fnResize,this));if(!q.support.newFlexBoxLayout&&i&&p.getStretchContentHeight()){this._sResizeListenerNoFlexboxSupportId=sap.ui.core.ResizeHandler.register(p.getDomRef(),q.proxy(this._fnResizeNoFlexboxSupport,this));this._fnResizeNoFlexboxSupport();}};
d.prototype.destroyItems=function(){this.oSelectedItem=null;this._aTabKeys=[];this.destroyAggregation("items");};
d.prototype.addItem=function(i){if(!(i instanceof sap.m.IconTabSeparator)){var k=i.getKey();if(this._aTabKeys.indexOf(k)!==-1){q.sap.log.warning("sap.m.IconTabHeader: duplicate key '"+k+"' inside the IconTabFilter. Please use unique keys.");}this._aTabKeys.push(k);}this.addAggregation("items",i);};
d.prototype.insertItem=function(i,e){if(!(i instanceof sap.m.IconTabSeparator)){var k=i.getKey();if(this._aTabKeys.indexOf(k)!==-1){q.sap.log.warning("sap.m.IconTabHeader: duplicate key '"+k+"' inside the IconTabFilter. Please use unique keys.");}this._aTabKeys.push(k);}this.insertAggregation("items",i,e);};
d.prototype.removeAllItems=function(){this._aTabKeys=[];this.removeAllAggregation("items");};
d.prototype.removeItem=function(i){i=this.removeAggregation("items",i);if(i&&!(i instanceof sap.m.IconTabSeparator)){var k=i.getKey();this._aTabKeys.splice(this._aTabKeys.indexOf(k),1);}return i;};
d.prototype.removeAggregation=function(A,o,s){var i=this.getTabFilters();var e=C.prototype.removeAggregation.apply(this,arguments);if(e&&e==this.oSelectedItem&&A=='items'){var f=q.inArray(e,i);i=this.getTabFilters();f=Math.max(0,Math.min(f,i.length-1));var g=i[f];if(g){this.setSelectedItem(g,true);}else{var h=this.getParent();if(h instanceof sap.m.IconTabBar&&h.getExpanded()){h.$("content").children().remove();}}}return e;};
d.prototype.removeAllAggregation=function(A,s){if(A=='items'){var i=this.getParent();if(i instanceof sap.m.IconTabBar&&i.getExpanded()){i.$("content").children().remove();}}return C.prototype.removeAllAggregation.apply(this,arguments);};
d.prototype._getDisplayText=function(i){var t=i.getText();if(this.isInlineMode()){var s=i.getCount();if(s){if(this._bRtl){t='('+s+') '+t;}else{t+=' ('+s+')';}}}return t;};
d.prototype.isInlineMode=function(){return this._bTextOnly&&this.getMode()==sap.m.IconTabHeaderMode.Inline;};
d.prototype._checkTextOnly=function(e){if(e.length>0){for(var i=0;i<e.length;i++){if(!(e[i]instanceof sap.m.IconTabSeparator)){if(e[i].getIcon()){this._bTextOnly=false;return false;}}}}this._bTextOnly=true;return true;};
d.prototype._checkNoText=function(e){if(e.length>0){for(var i=0;i<e.length;i++){if(!(e[i]instanceof sap.m.IconTabSeparator)){if(e[i].getText().length>0){return false;}}}}return true;};
d.prototype._checkInLine=function(e){var o;if(e.length>0){for(var i=0;i<e.length;i++){o=e[i];if(!(o instanceof sap.m.IconTabSeparator)){if(o.getIcon()||o.getCount()){this._bInLine=false;return false;}}}}this._bInLine=true;return true;};
d.prototype._checkScrolling=function(h){var $=this.$();var s=false;var e=this.getDomRef("scrollContainer");var f=this.getDomRef("head");if(f&&e){if(f.offsetWidth>e.offsetWidth){s=true;}}if(this._scrollable!==s){$.toggleClass("sapMITBScrollable",s);$.toggleClass("sapMITBNotScrollable",!s);this._scrollable=s;}return s;};
d.prototype._getScrollingArrow=function(n){var s=a.getIconURI("slim-arrow-"+n);var p={src:s,useIconTooltip:false};var e=this._bTextOnly?"TextOnly":"";var L="sapMITBArrowScrollLeft"+e;var r="sapMITBArrowScrollRight"+e;var f=["sapMITBArrowScroll",L];var g=["sapMITBArrowScroll",r];if(this._bInLine){f.push('sapMITBArrowScrollLeftInLine');g.push('sapMITBArrowScrollRightInLine');}if(n==="left"){if(!this._oArrowLeft){this._oArrowLeft=sap.m.ImageHelper.getImageControl(this.getId()+"-arrowScrollLeft",this._oArrowLeft,this,p,f);}return this._oArrowLeft;}if(n==="right"){if(!this._oArrowRight){this._oArrowRight=sap.m.ImageHelper.getImageControl(this.getId()+"-arrowScrollRight",this._oArrowRight,this,p,g);}return this._oArrowRight;}};
d.prototype._checkOverflow=function(){var o=this.getDomRef("head");var $=this.$();if(this._checkScrolling(o)&&o){var s=false;var e=false;var f=this.getDomRef("scrollContainer");var g=this.getDomRef("head");if(this._oScroller.getScrollLeft()>0){s=true;}if((this._oScroller.getScrollLeft()+f.offsetWidth)<g.offsetWidth){e=true;}if((e!=this._bPreviousScrollForward)||(s!=this._bPreviousScrollBack)){this._bPreviousScrollForward=e;this._bPreviousScrollBack=s;$.toggleClass("sapMITBScrollBack",s);$.toggleClass("sapMITBNoScrollBack",!s);$.toggleClass("sapMITBScrollForward",e);$.toggleClass("sapMITBNoScrollForward",!e);}}else{this._bPreviousScrollForward=false;this._bPreviousScrollBack=false;}};
d.prototype._handleActivation=function(e){var t=e.target.id,o=e.srcControl,s;if(o instanceof B){return;}var $=q.sap.byId(t);if(q.inArray(this.$("content")[0],$.parents())>-1){}else{if(t){var i=this.getId();e.preventDefault();if(t==i+"-arrowScrollLeft"&&sap.ui.Device.system.desktop){var f=this._oScroller.getScrollLeft()-d.SCROLL_STEP;if(f<0){f=0;}this._scrollPreparation();q.sap.delayedCall(0,this._oScroller,"scrollTo",[f,0,500]);q.sap.delayedCall(500,this,"_afterIscroll");}else if(t==i+"-arrowScrollRight"&&sap.ui.Device.system.desktop){var f=this._oScroller.getScrollLeft()+d.SCROLL_STEP;var g=this.$("scrollContainer").width();var h=this.$("head").width();if(f>(h-g)){f=h-g;}this._scrollPreparation();q.sap.delayedCall(0,this._oScroller,"scrollTo",[f,0,500]);q.sap.delayedCall(500,this,"_afterIscroll");}else{if(o instanceof sap.ui.core.Icon||o instanceof sap.m.Image){s=e.srcControl.getId().replace(/-icon$/,"");o=sap.ui.getCore().byId(s);if(o.getMetadata().isInstanceOf("sap.m.IconTab")&&!(o instanceof sap.m.IconTabSeparator)){this.setSelectedItem(o);}}else if(o.getMetadata().isInstanceOf("sap.m.IconTab")&&!(o instanceof sap.m.IconTabSeparator)){this.setSelectedItem(o);}}}else{if(o.getMetadata().isInstanceOf("sap.m.IconTab")&&!(o instanceof sap.m.IconTabSeparator)){this.setSelectedItem(o);}}}};
d.prototype._scrollIntoView=function(i,D){var $=i.$(),s,n,e;if($.length>0){var f=this.$('head');var h=f.innerWidth()-f.width();var g=$.outerWidth(true);var j=$.position().left-h/2;s=this._oScroller.getScrollLeft();e=this.$("scrollContainer").width();n=0;if(j-s<0||j-s>e-g){if(j-s<0){n+=j;}else{n+=j+g-e;}this._scrollPreparation();this._iCurrentScrollLeft=n;q.sap.delayedCall(0,this._oScroller,"scrollTo",[n,0,D]);q.sap.delayedCall(D,this,"_afterIscroll");}}return this;};
d.prototype._scroll=function(D,i){this._scrollPreparation();var o=this.getDomRef("head");var s=o.scrollLeft;var e=sap.ui.Device.browser.internet_explorer||sap.ui.Device.browser.edge;if(!e&&this._bRtl){D=-D;}var f=s+D;q(o).stop(true,true).animate({scrollLeft:f},i,q.proxy(this._adjustAndShowArrow,this));this._iCurrentScrollLeft=f;};
d.prototype._adjustAndShowArrow=function(){this._$bar&&this._$bar.toggleClass("sapMITBScrolling",false);this._$bar=null;if(sap.ui.Device.system.desktop){this._checkOverflow();}};
d.prototype._scrollPreparation=function(){if(!this._$bar){this._$bar=this.$().toggleClass("sapMITBScrolling",true);}};
d.prototype._afterIscroll=function(){this._checkOverflow();this._adjustAndShowArrow();};
d.prototype._fnResize=function(){this._checkOverflow();};
sap.m.IconTabHeader.prototype._fnResizeNoFlexboxSupport=function(){var $=this.getParent().$("containerContent"),D=$.outerHeight(true)-$.height();$.height(this.getParent().$().height()-$.position().top-D);};
sap.m.IconTabHeader.prototype.onExit=function(){if(this._sResizeListenerNoFlexboxSupportId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerNoFlexboxSupportId);this._sResizeListenerNoFlexboxSupportId=null;}};
d.prototype.getFocusDomRef=function(f){var t=f||this.oSelectedItem;if(!t){return null;}return t.getDomRef();};
d.prototype.applyFocusInfo=function(f){if(f.focusDomRef){q(f.focusDomRef).focus();}};
d.prototype.ontouchstart=function(e){var t=e.targetTouches[0];this._iActiveTouch=t.identifier;this._iTouchStartPageX=t.pageX;this._iTouchDragX=0;var $=q(e.target);if($.hasClass('sapMITBArrowScroll')){e.preventDefault();}if(sap.ui.Device.browser.internet_explorer){if($.hasClass('sapMITBFilterIcon')||$.hasClass('sapMITBCount')||$.hasClass('sapMITBText')||$.hasClass('sapMITBTab')||$.hasClass('sapMITBContentArrow')||$.hasClass('sapMITBSep')||$.hasClass('sapMITBSepIcon')){e.preventDefault();}}};
d.prototype.ontouchmove=function(e){if(this._iActiveTouch===undefined){return;}var t=sap.m.touch.find(e.changedTouches,this._iActiveTouch);if(!t||t.pageX===this._iTouchStartPageX){return;}this._iTouchDragX+=Math.abs(this._iTouchStartPageX-t.pageX);this._iTouchStartPageX=t.pageX;};
d.prototype.ontouchend=function(e){if(this._iActiveTouch===undefined){return;}if(this._scrollable&&this._iTouchDragX>(sap.ui.Device.system.desktop?5:15)){return;}var M=0;var L=1;var f;if(e.which===f||e.which===M||e.which===L){this._handleActivation(e);}this._iActiveTouch=undefined;};
d.prototype.ontouchcancel=d.prototype.ontouchend;
d.prototype.onsapselect=function(e){this._handleActivation(e);};
return d;},true);
sap.ui.predefine('sap/m/IconTabHeaderRenderer',['jquery.sap.global','sap/ui/core/IconPool'],function(q,I){"use strict";var a={};a._aAllIconColors=['sapMITBFilterCritical','sapMITBFilterPositive','sapMITBFilterNegative','sapMITBFilterDefault','sapMITBFilterNeutral'];
a.render=function(r,c){if(!c.getVisible()){return;}var i=c.getItems(),t=c._checkTextOnly(i),n=c._checkNoText(i),b=c._checkInLine(i)||c.isInlineMode(),R=sap.ui.getCore().getLibraryResourceBundle('sap.m'),s=c.getShowOverflowSelectList(),d,h;var o=c.getParent();var u=o&&o instanceof sap.m.IconTabBar&&o.getUpperCase();r.write("<div role='tablist' ");r.addClass("sapMITH");r.addClass("sapContrastPlus");if(s){r.addClass("sapMITHOverflowList");}if(c._scrollable){r.addClass("sapMITBScrollable");if(c._bPreviousScrollForward){r.addClass("sapMITBScrollForward");}else{r.addClass("sapMITBNoScrollForward");}if(c._bPreviousScrollBack){r.addClass("sapMITBScrollBack");}else{r.addClass("sapMITBNoScrollBack");}}else{r.addClass("sapMITBNotScrollable");}if(u){r.addClass("sapMITBTextUpperCase");}r.writeControlData(c);r.writeClasses();r.write(">");r.renderControl(c._getScrollingArrow("left"));r.write("<div id='"+c.getId()+"-scrollContainer' class='sapMITBScrollContainer'>");r.write("<div id='"+c.getId()+"-head'");r.addClass("sapMITBHead");if(t){r.addClass("sapMITBTextOnly");}if(n){r.addClass("sapMITBNoText");}if(b){r.addClass("sapMITBInLine");}r.writeClasses();r.write(">");q.each(i,function(e,f){if(!(f instanceof sap.m.IconTabSeparator)&&!f.getVisible()){return;}var T='';if(f instanceof sap.m.IconTabSeparator){if(f.getIcon()){T+='role="img" aria-label="'+R.getText("ICONTABBAR_NEXTSTEP")+'"';}else{T+='role="separator"';}}else{T+='role="tab"';if(o instanceof sap.m.IconTabBar){T+=' aria-controls="'+o.sId+'-content" ';}if(f){var g=f.getIconColor();var j=g==='Positive'||g==='Critical'||g==='Negative';if(f.getText().length||f.getCount()!==""||f.getIcon()){T+='aria-labelledby="';var k=[];if(f.getText().length){k.push(f.getId()+'-text');}if(f.getCount()!==""){k.push(f.getId()+'-count');}if(f.getIcon()){k.push(f.getId()+'-icon');}if(j){k.push(f.getId()+'-iconColor');}T+=k.join(' ');T+='"';}}}r.write('<div '+T+' ');r.writeElementData(f);r.addClass("sapMITBItem");if(!(f instanceof sap.m.IconTabSeparator)&&!this.getCount()){r.addClass("sapMITBItemNoCount");}if(f instanceof sap.m.IconTabFilter){d=f.getDesign()===sap.m.IconTabFilterDesign.Horizontal;if(d){h=true;}if(f.getDesign()===sap.m.IconTabFilterDesign.Vertical){r.addClass("sapMITBVertical");}else if(d){r.addClass("sapMITBHorizontal");}if(f.getShowAll()){r.addClass("sapMITBAll");}else{r.addClass("sapMITBFilter");r.addClass("sapMITBFilter"+f.getIconColor());}if(!f.getEnabled()){r.addClass("sapMITBDisabled");r.writeAttribute("aria-disabled",true);}r.writeAttribute("aria-selected",false);var l=f.getTooltip_AsString();if(l){r.writeAttributeEscaped("title",l);}r.writeClasses();r.write(">");if(!b){r.write("<div id='"+f.getId()+"-tab' class='sapMITBTab'>");if(!f.getShowAll()||!f.getIcon()){if(j){r.write('<div id="'+f.getId()+'-iconColor" style="display: none;">'+R.getText('ICONTABBAR_ICONCOLOR_'+g.toUpperCase())+'</div>');}r.renderControl(f._getImageControl(['sapMITBFilterIcon','sapMITBFilter'+f.getIconColor()],c,a._aAllIconColors));}if(!f.getShowAll()&&!f.getIcon()&&!t){r.write("<span class='sapMITBFilterNoIcon'> </span>");}if(d&&!f.getShowAll()){r.write("</div>");r.write("<div class='sapMITBHorizontalWrapper'>");}r.write("<span id='"+f.getId()+"-count' ");r.addClass("sapMITBCount");r.writeClasses();r.write(">");if((f.getCount()==="")&&d){r.write("&nbsp;");}else{r.writeEscaped(f.getCount());}r.write("</span>");if(f.getDesign()===sap.m.IconTabFilterDesign.Vertical){r.write("</div>");}}if(f.getText().length){r.write("<div id='"+f.getId()+"-text' ");r.addClass("sapMITBText");if(u){r.addClass("sapMITBTextUpperCase");}if(b){r.writeAttribute("dir","ltr");}r.writeClasses();r.write(">");r.writeEscaped(c._getDisplayText(f));r.write("</div>");}if(!b){if(d){r.write("</div>");}}r.write("<div class='sapMITBContentArrow'></div>");}else{r.addClass("sapMITBSep");if(!f.getIcon()){r.addClass("sapMITBSepLine");}r.writeClasses();r.write(">");if(f.getIcon()){r.renderControl(f._getImageControl(['sapMITBSepIcon'],c));}}r.write("</div>");});r.write("</div>");r.write("</div>");r.renderControl(c._getScrollingArrow("right"));if(s){var O=c._getOverflowButton();if(b){O.addStyleClass('sapMBtnInline');}else if(t){O.addStyleClass('sapMBtnTextOnly');}else if(n||h){O.addStyleClass('sapMBtnNoText');}r.renderControl(O);}r.write("</div>");};
return a;},true);
sap.ui.predefine('sap/m/IconTabSeparator',['jquery.sap.global','./library','sap/ui/core/Element'],function(q,l,E){"use strict";
var I=E.extend("sap.m.IconTabSeparator",{metadata:{interfaces:["sap.m.IconTab"],library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:''},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true}}}});
I.prototype._getImageControl=function(c,p){var P={src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};this._oImageControl=sap.m.ImageHelper.getImageControl(this.getId()+"-icon",this._oImageControl,p,P,c);return this._oImageControl;};
I.prototype.exit=function(e){if(this._oImageControl){this._oImageControl.destroy();}if(sap.ui.core.Item.prototype.exit){sap.ui.core.Item.prototype.exit.call(this,e);}};
return I;},true);
sap.ui.predefine('sap/m/Image',['jquery.sap.global','./library','sap/ui/core/Control'],function(q,l,C){"use strict";
var I=C.extend("sap.m.Image",{metadata:{library:"sap.m",properties:{src:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},decorative:{type:"boolean",group:"Accessibility",defaultValue:true},alt:{type:"string",group:"Accessibility",defaultValue:null},useMap:{type:"string",group:"Misc",defaultValue:null},densityAware:{type:"boolean",group:"Misc",defaultValue:true},activeSrc:{type:"sap.ui.core.URI",group:"Data",defaultValue:""},mode:{type:"sap.m.ImageMode",group:"Misc",defaultValue:"Image"},backgroundSize:{type:"string",group:"Appearance",defaultValue:"cover"},backgroundPosition:{type:"string",group:"Appearance",defaultValue:"initial"},backgroundRepeat:{type:"string",group:"Appearance",defaultValue:"no-repeat"}},events:{tap:{},press:{},load:{},error:{}}}});
I._currentDevicePixelRatio=(function(){var r=(window.devicePixelRatio===undefined?1:window.devicePixelRatio);if(r<=1){r=1;}else{r*=2;r=Math.round(r);r/=2;}if(r>2){r=2;}return r;}());
I.prototype.onload=function(e){if(!this._defaultEventTriggered){this._defaultEventTriggered=true;}this._bVersion2Tried=false;var d=this.$(),D=d[0];if(this.getMode()===sap.m.ImageMode.Background){d.css("background-image","url("+this._oImage.src+")");}if(!this._isWidthOrHeightSet()){if(this._iLoadImageDensity>1){if((d.width()===D.naturalWidth)&&(d.height()===D.naturalHeight)){d.width(d.width()/this._iLoadImageDensity);}}}d.removeClass("sapMNoImg");this.fireLoad();};
I.prototype.onerror=function(e){if(!this._defaultEventTriggered){this._defaultEventTriggered=true;}var D=this.$(),m=this.getMode(),s=(m===sap.m.ImageMode.Image)?D.attr("src"):this._oImage.src,d=I._currentDevicePixelRatio,c=this._isActiveState?this.getActiveSrc():this.getSrc();D.addClass("sapMNoImg");if(!s||this._iLoadImageDensity===1){D.removeClass("sapMNoImg");this.fireError();return;}if(d===2||d<1){this._iLoadImageDensity=1;this._updateDomSrc(this._generateSrcByDensity(c,1));}else if(d===1.5){if(this._bVersion2Tried){setTimeout(q.proxy(function(){this._iLoadImageDensity=1;this._updateDomSrc(this._generateSrcByDensity(c,1));},this),0);}else{setTimeout(q.proxy(function(){this._iLoadImageDensity=2;this._updateDomSrc(this._generateSrcByDensity(c,2));this._bVersion2Tried=true;},this),0);}}};
I.prototype.onBeforeRendering=function(){this._defaultEventTriggered=false;};
I.prototype.onAfterRendering=function(){var d=this.$(),D=d[0],m=this.getMode();if(m===sap.m.ImageMode.Image){d.on("load",q.proxy(this.onload,this));d.on("error",q.proxy(this.onerror,this));if(D&&D.complete&&!this._defaultEventTriggered){if(D.naturalWidth>0){this.onload({});}else{this.onerror({});}}}};
I.prototype.exit=function(){if(this._oImage){q(this._oImage).off("load",this.onload).off("error",this.onerror);this._oImage=null;}else{this.$().off("load",this.onload).off("error",this.onerror);}};
I.prototype.ontouchstart=function(e){if(e.srcControl.mEventRegistry["press"]||e.srcControl.mEventRegistry["tap"]){e.setMarked();}if(e.targetTouches.length===1&&this.getActiveSrc()){this._updateDomSrc(this._getDensityAwareActiveSrc());this._isActiveState=true;}};
I.prototype.ontouchend=function(e){if(e.targetTouches.length===0&&this.getActiveSrc()){this._isActiveState=false;this._updateDomSrc(this._getDensityAwareSrc());this.$().removeClass("sapMNoImg");}};
I.prototype.setSrc=function(s){if(s===this.getSrc()){return this;}this.setProperty("src",s,true);var d=this.getDomRef();if(d){this._updateDomSrc(this._getDensityAwareSrc());}return this;};
I.prototype.setActiveSrc=function(a){if(!a){a="";}return this.setProperty("activeSrc",a,true);};
I.prototype.attachPress=function(){Array.prototype.unshift.apply(arguments,["press"]);sap.ui.core.Control.prototype.attachEvent.apply(this,arguments);if(this.hasListeners("press")){this.$().attr("tabindex","0");this.$().attr("role","button");}return this;};
I.prototype.detachPress=function(){Array.prototype.unshift.apply(arguments,["press"]);sap.ui.core.Control.prototype.detachEvent.apply(this,arguments);if(!this.hasListeners("press")){this.$().removeAttr("tabindex");if(this.getDecorative()){this.$().attr("role","presentation");}else{this.$().removeAttr("role");}}return this;};
I.prototype.ontap=function(e){this.fireTap({});this.firePress({});};
I.prototype.onkeyup=function(e){if(e.which===q.sap.KeyCodes.SPACE||e.which===q.sap.KeyCodes.ENTER){this.firePress({});e.stopPropagation();}};
I.prototype._updateDomSrc=function(s){var d=this.$(),m=this.getMode();if(d.length){if(m===sap.m.ImageMode.Image){d.attr("src",s);}else{d.addClass("sapMNoImg");q(this._oImage).attr("src",s);}}};
I.prototype._preLoadImage=function(s){if(this.getMode()!==sap.m.ImageMode.Background){return;}var i=q(this._oImage);if(!this._oImage){this._oImage=new window.Image();i=q(this._oImage);i.on("load",q.proxy(this.onload,this)).on("error",q.proxy(this.onerror,this));}this._oImage.src=s;if(this._oImage.complete){i.trigger(this._oImage.naturalWidth>0?"load":"error");}};
I.prototype._isWidthOrHeightSet=function(){return(this.getWidth()&&this.getWidth()!=='')||(this.getHeight()&&this.getHeight()!=='');};
I.prototype._getDensityAwareSrc=function(){var s=this.getSrc(),D=this.getDensityAware(),d=D?I._currentDevicePixelRatio:1;this._iLoadImageDensity=d;if(d===1){return s;}return this._generateSrcByDensity(s,d);};
I.prototype._getDensityAwareActiveSrc=function(){var a=this.getActiveSrc(),D=this.getDensityAware(),d=D?I._currentDevicePixelRatio:1;this._iLoadImageDensity=d;if(d===1){return a;}return this._generateSrcByDensity(a,d);};
I.prototype._generateSrcByDensity=function(s,d){if(!s){return"";}if(this._isDataUri(s)){this._iLoadImageDensity=1;return s;}if(d===1){return s;}var L=s.lastIndexOf("."),i=s.lastIndexOf("/"),n=s.substring(0,L),e=s.substring(L);if(L===-1||(i>L)){return s+"@"+d;}n=n+"@"+d;return n+e;};
I.prototype._isDataUri=function(s){return s?s.indexOf("data:")===0:false;};
I.prototype.getAccessibilityInfo=function(){var h=this.hasListeners("press");if(this.getDecorative()&&!this.getUseMap()&&!h){return null;}return{role:h?"button":"img",type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText(h?"ACC_CTR_TYPE_BUTTON":"ACC_CTR_TYPE_IMAGE"),description:this.getAlt()||this.getTooltip_AsString()||"",focusable:h};};
return I;},true);
sap.ui.predefine('sap/m/ImageContent',['jquery.sap.global','./library','sap/ui/core/Control','sap/m/Image','sap/ui/core/IconPool'],function(q,l,C,I,a){"use strict";
var b=C.extend("sap.m.ImageContent",{metadata:{library:"sap.m",properties:{"src":{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},"description":{type:"string",group:"Accessibility",defaultValue:null}},aggregations:{"_content":{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{"press":{}}}});
b.prototype.onBeforeRendering=function(){var i,u,d;i=this.getAggregation("_content");u=this.getSrc();d=this.getDescription();if(!i||u!==i.getSrc()||d!==i.getAlt()){if(i){i.destroy();i=null;}i=a.createControlByURI({id:this.getId()+"-icon-image",src:u,alt:d,decorative:false},I);this.setAggregation("_content",i,true);this._setPointerOnImage();}if(d){this.setTooltip(d.trim());}};
b.prototype._setPointerOnImage=function(){var i=this.getAggregation("_content");if(i&&this.hasListeners("press")){i.addStyleClass("sapMPointer");}else if(i&&i.hasStyleClass("sapMPointer")){i.removeStyleClass("sapMPointer");}};
b.prototype.ontap=function(e){if(sap.ui.Device.browser.internet_explorer){this.$().focus();}this.firePress();};
b.prototype.onkeydown=function(e){if(e.which===q.sap.KeyCodes.ENTER||e.which===q.sap.KeyCodes.SPACE){this.firePress();e.preventDefault();}};
b.prototype.attachEvent=function(e,d,f,c){sap.ui.core.Control.prototype.attachEvent.call(this,e,d,f,c);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");this._setPointerOnImage();}return this;};
b.prototype.detachEvent=function(e,f,c){sap.ui.core.Control.prototype.detachEvent.call(this,e,f,c);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");this._setPointerOnImage();}return this;};
b.prototype.getAltText=function(){var c=this.getAggregation("_content");if(c&&c.getAlt()!==""){return c.getAlt();}else if(c){return c.getAccessibilityInfo().description;}};
return b;});
sap.ui.predefine('sap/m/ImageContentRenderer',[],function(){"use strict";var I={};
I.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMImageContent");var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}if(c.hasListeners("press")){r.addClass("sapMPointer");r.writeAttribute("tabindex","0");}r.writeClasses();r.write(">");var C=c.getAggregation("_content");if(C){C.addStyleClass("sapMImageContentImageIcon");r.renderControl(C);}r.write("</div>");};
return I;},true);
sap.ui.predefine('sap/m/ImageRenderer',['jquery.sap.global'],function(q){"use strict";var I={};
I.render=function(r,i){var m=i.getMode(),a=i.getAlt(),t=i.getTooltip_AsString(),h=i.hasListeners("press");r.write(m===sap.m.ImageMode.Image?"<img":"<span");r.writeControlData(i);if(m===sap.m.ImageMode.Image){r.writeAttributeEscaped("src",i._getDensityAwareSrc());}else{i._preLoadImage(i._getDensityAwareSrc());r.addStyle("background-size",q.sap.encodeHTML(i.getBackgroundSize()));r.addStyle("background-position",q.sap.encodeHTML(i.getBackgroundPosition()));r.addStyle("background-repeat",q.sap.encodeHTML(i.getBackgroundRepeat()));}r.addClass("sapMImg");if(i.hasListeners("press")||i.hasListeners("tap")){r.addClass("sapMPointer");}if(i.getUseMap()||!i.getDecorative()){r.addClass("sapMImgFocusable");}r.writeClasses();var u=i.getUseMap();if(u){if(!(q.sap.startsWith(u,"#"))){u="#"+u;}r.writeAttributeEscaped("useMap",u);}if(i.getDecorative()&&!u&&!h){r.writeAttribute("role","presentation");r.writeAttribute("aria-hidden","true");r.write(" alt=''");}else{if(a||t){r.writeAttributeEscaped("alt",a||t);}}if(a||t){r.writeAttributeEscaped("aria-label",a||t);}if(t){r.writeAttributeEscaped("title",t);}if(h){r.writeAttribute("role","button");r.writeAttribute("tabIndex",0);}if(i.getWidth()&&i.getWidth()!=''){r.addStyle("width",i.getWidth());}if(i.getHeight()&&i.getHeight()!=''){r.addStyle("height",i.getHeight());}r.writeStyles();r.write(" />");};
return I;},true);
sap.ui.predefine('sap/m/Input',['jquery.sap.global','./Bar','./Dialog','./InputBase','./List','./Popover','./StandardListItem','./Table','./Toolbar','./ToolbarSpacer','./library','sap/ui/core/IconPool','jquery.sap.strings'],function(q,B,D,I,L,P,S,T,a,b,l,c){"use strict";
var d=I.extend("sap.m.Input",{metadata:{library:"sap.m",properties:{type:{type:"sap.m.InputType",group:"Data",defaultValue:sap.m.InputType.Text},maxLength:{type:"int",group:"Behavior",defaultValue:0},dateFormat:{type:"string",group:"Misc",defaultValue:'YYYY-MM-dd',deprecated:true},showValueHelp:{type:"boolean",group:"Behavior",defaultValue:false},showSuggestion:{type:"boolean",group:"Behavior",defaultValue:false},valueHelpOnly:{type:"boolean",group:"Behavior",defaultValue:false},filterSuggests:{type:"boolean",group:"Behavior",defaultValue:true},maxSuggestionWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},startSuggestion:{type:"int",group:"Behavior",defaultValue:1},showTableSuggestionValueHelp:{type:"boolean",group:"Behavior",defaultValue:true},description:{type:"string",group:"Misc",defaultValue:null},fieldWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'50%'},valueLiveUpdate:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"suggestionItems",aggregations:{suggestionItems:{type:"sap.ui.core.Item",multiple:true,singularName:"suggestionItem"},suggestionColumns:{type:"sap.m.Column",multiple:true,singularName:"suggestionColumn",bindable:"bindable"},suggestionRows:{type:"sap.m.ColumnListItem",multiple:true,singularName:"suggestionRow",bindable:"bindable"}},events:{liveChange:{parameters:{value:{type:"string"}}},valueHelpRequest:{parameters:{fromSuggestions:{type:"boolean"}}},suggest:{parameters:{suggestValue:{type:"string"},suggestionColumns:{type:"sap.m.ListBase"}}},suggestionItemSelected:{parameters:{selectedItem:{type:"sap.ui.core.Item"},selectedRow:{type:"sap.m.ColumnListItem"}}},submit:{parameters:{value:{type:"string"}}}}}});
c.insertFontFaceStyle();
d._DEFAULTFILTER=function(v,i){return q.sap.startsWithIgnoreCase(i.getText(),v);};
d._DEFAULTFILTER_TABULAR=function(v,C){var e=C.getCells(),i=0;for(;i<e.length;i++){if(e[i].getText){return q.sap.startsWithIgnoreCase(e[i].getText(),v);}}return false;};
d._DEFAULTRESULT_TABULAR=function(C){var e=C.getCells(),i=0;for(;i<e.length;i++){if(e[i].getText){return e[i].getText();}}return"";};
d.prototype.init=function(){I.prototype.init.call(this);this._fnFilter=d._DEFAULTFILTER;this._bUseDialog=sap.ui.Device.system.phone;this._bFullScreen=sap.ui.Device.system.phone;this._iSetCount=0;};
d.prototype.exit=function(){this._deregisterEvents();this.cancelPendingSuggest();if(this._iRefreshListTimeout){q.sap.clearDelayedCall(this._iRefreshListTimeout);this._iRefreshListTimeout=null;}if(this._oSuggestionPopup){this._oSuggestionPopup.destroy();this._oSuggestionPopup=null;}if(this._oList){this._oList.destroy();this._oList=null;}if(this._oValueHelpIcon){this._oValueHelpIcon.destroy();this._oValueHelpIcon=null;}if(this._oSuggestionTable){this._oSuggestionTable.destroy();this._oSuggestionTable=null;}if(this._oButtonToolbar){this._oButtonToolbar.destroy();this._oButtonToolbar=null;}if(this._oShowMoreButton){this._oShowMoreButton.destroy();this._oShowMoreButton=null;}};
d.prototype._resizePopup=function(){var t=this;if(this._oList&&this._oSuggestionPopup){if(this.getMaxSuggestionWidth()){this._oSuggestionPopup.setContentWidth(this.getMaxSuggestionWidth());}else{this._oSuggestionPopup.setContentWidth((this.$().outerWidth())+"px");}setTimeout(function(){if(t._oSuggestionPopup&&t._oSuggestionPopup.isOpen()&&t._oSuggestionPopup.$().outerWidth()<t.$().outerWidth()){t._oSuggestionPopup.setContentWidth((t.$().outerWidth())+"px");}},0);}};
d.prototype.onBeforeRendering=function(){I.prototype.onBeforeRendering.call(this);this._deregisterEvents();};
d.prototype.onAfterRendering=function(){var t=this;I.prototype.onAfterRendering.call(this);if(!this._bFullScreen){this._resizePopup();this._sPopupResizeHandler=sap.ui.core.ResizeHandler.register(this.getDomRef(),function(){t._resizePopup();});}if(this._bUseDialog&&this.getEditable()){this.$().on("click",q.proxy(function(e){if(this.getShowSuggestion()&&this._oSuggestionPopup&&e.target.id!=this.getId()+"__vhi"){this._oSuggestionPopup.open();}},this));}};
d.prototype.setSelectionItem=function(i){var C=this._iSetCount,n;this.fireSuggestionItemSelected({selectedItem:i});if(C!==this._iSetCount){n=this.getValue();}else{n=i.getText();}if(this._bUseDialog){this._oPopupInput.setValue(n);this._oPopupInput._doSelect();}else{this._$input.val(this._getInputValue(n));this.onChange();}this._iPopupListSelectedIndex=-1;if(!(this._bUseDialog&&this instanceof sap.m.MultiInput&&this._isMultiLineMode)){this._closeSuggestionPopup();}if(!sap.ui.Device.support.touch){this._doSelect();}};
d.prototype.setSelectionRow=function(o){var C=this._iSetCount,n;this.fireSuggestionItemSelected({selectedRow:o});if(C!==this._iSetCount){n=this.getValue();}else{n=this._fnRowResultFilter(o);}if(this._bUseDialog){this._oPopupInput.setValue(n);this._oPopupInput._doSelect();}else{this._$input.val(this._getInputValue(n));this.onChange();}this._iPopupListSelectedIndex=-1;if(!(this._bUseDialog&&this instanceof sap.m.MultiInput&&this._isMultiLineMode)){this._closeSuggestionPopup();}if(!sap.ui.Device.support.touch){this._doSelect();}};
d.prototype._getValueHelpIcon=function(){var t=this;if(!this._oValueHelpIcon){var u=c.getIconURI("value-help");this._oValueHelpIcon=c.createControlByURI({id:this.getId()+"__vhi",src:u,useIconTooltip:false,noTabStop:true});this._oValueHelpIcon.addStyleClass("sapMInputValHelpInner");this._oValueHelpIcon.attachPress(function(e){if(!t.getValueHelpOnly()){t.fireValueHelpRequest({fromSuggestions:false});}});}return this._oValueHelpIcon;};
d.prototype._fireValueHelpRequestForValueHelpOnly=function(){if(this.getEnabled()&&this.getEditable()&&this.getShowValueHelp()&&this.getValueHelpOnly()){this.fireValueHelpRequest({fromSuggestions:false});}};
d.prototype.ontap=function(e){I.prototype.ontap.call(this,e);this._fireValueHelpRequestForValueHelpOnly();};
d.prototype.setWidth=function(w){return I.prototype.setWidth.call(this,w||"100%");};
d.prototype.getWidth=function(){return this.getProperty("width")||"100%";};
d.prototype.setFilterFunction=function(f){if(f===null||f===undefined){this._fnFilter=d._DEFAULTFILTER;return this;}this._fnFilter=f;return this;};
d.prototype.setRowResultFunction=function(f){if(f===null||f===undefined){this._fnRowResultFilter=d._DEFAULTRESULT_TABULAR;return this;}this._fnRowResultFilter=f;return this;};
d.prototype.setShowValueHelp=function(s){this.setProperty("showValueHelp",s);if(s&&!d.prototype._sAriaValueHelpLabelId){d.prototype._sAriaValueHelpLabelId=new sap.ui.core.InvisibleText({text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("INPUT_VALUEHELP")}).toStatic().getId();}return this;};
d.prototype.setValueHelpOnly=function(v){this.setProperty("valueHelpOnly",v);if(v&&!d.prototype._sAriaInputDisabledLabelId){d.prototype._sAriaInputDisabledLabelId=new sap.ui.core.InvisibleText({text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("INPUT_DISABLED")}).toStatic().getId();}return this;};
d.prototype._doSelect=function(s,e){if(sap.ui.Device.support.touch){return;}var o=this._$input[0];if(o){var r=this._$input;o.focus();r.selectText(s?s:0,e?e:r.val().length);}return this;};
d.prototype._scrollToItem=function(i){var p=this._oSuggestionPopup,o=this._oList,s,e,f,t,g;if(!(p instanceof P)||!o){return;}s=p.getScrollDelegate();if(!s){return;}var h=o.getItems()[i],j=h&&h.getDomRef();if(!j){return;}e=p.getDomRef("cont").getBoundingClientRect();f=j.getBoundingClientRect();t=e.top-f.top;g=f.bottom-e.bottom;if(t>0){s.scrollTo(s._scrollX,Math.max(s._scrollY-t,0));}else if(g>0){s.scrollTo(s._scrollX,s._scrollY+g);}};
d.prototype._isSuggestionItemSelectable=function(i){return i.getVisible()&&(this._hasTabularSuggestions()||i.getType()!==sap.m.ListType.Inactive);};
d.prototype._onsaparrowkey=function(e,s,i){if(!this.getEnabled()||!this.getEditable()){return;}if(!this._oSuggestionPopup||!this._oSuggestionPopup.isOpen()){return;}if(s!=="up"&&s!=="down"){return;}e.preventDefault();e.stopPropagation();var f=false,o=this._oList,g=this.getSuggestionItems(),h=o.getItems(),j=this._iPopupListSelectedIndex,n,O=j;if(s==="up"&&j===0){return;}if(s=="down"&&j===h.length-1){return;}var k;if(i>1){if(s=="down"&&j+i>=h.length){s="up";i=1;h[j].setSelected(false);k=j;j=h.length-1;f=true;}else if(s=="up"&&j-i<0){s="down";i=1;h[j].setSelected(false);k=j;j=0;f=true;}}if(j===-1){j=0;if(this._isSuggestionItemSelectable(h[j])){O=j;f=true;}else{s="down";}}if(s==="down"){while(j<h.length-1&&(!f||!this._isSuggestionItemSelectable(h[j]))){h[j].setSelected(false);j=j+i;f=true;i=1;if(k===j){break;}}}else{while(j>0&&(!f||!h[j].getVisible()||!this._isSuggestionItemSelectable(h[j]))){h[j].setSelected(false);j=j-i;f=true;i=1;if(k===j){break;}}}if(!this._isSuggestionItemSelectable(h[j])){if(O>=0){h[O].setSelected(true).updateAccessibilityState();this.$("inner").attr("aria-activedescendant",h[O].getId());}return;}else{h[j].setSelected(true).updateAccessibilityState();this.$("inner").attr("aria-activedescendant",h[j].getId());}if(sap.ui.Device.system.desktop){this._scrollToItem(j);}if(sap.m.ColumnListItem&&h[j]instanceof sap.m.ColumnListItem){n=this._getInputValue(this._fnRowResultFilter(h[j]));}else{var m=(g[0]instanceof sap.ui.core.ListItem?true:false);if(m){n=this._getInputValue(h[j].getLabel());}else{n=this._getInputValue(h[j].getTitle());}}this._$input.val(n);this._sSelectedSuggViaKeyboard=n;this._doSelect();this._iPopupListSelectedIndex=j;};
d.prototype.onsapup=function(e){this._onsaparrowkey(e,"up",1);};
d.prototype.onsapdown=function(e){this._onsaparrowkey(e,"down",1);};
d.prototype.onsappageup=function(e){this._onsaparrowkey(e,"up",5);};
d.prototype.onsappagedown=function(e){this._onsaparrowkey(e,"down",5);};
d.prototype.onsaphome=function(e){if(this._oList){this._onsaparrowkey(e,"up",this._oList.getItems().length);}};
d.prototype.onsapend=function(e){if(this._oList){this._onsaparrowkey(e,"down",this._oList.getItems().length);}};
d.prototype.onsapescape=function(e){var f;if(this._oSuggestionPopup&&this._oSuggestionPopup.isOpen()){e.originalEvent._sapui_handledByControl=true;this._iPopupListSelectedIndex=-1;this._closeSuggestionPopup();if(this._sBeforeSuggest!==undefined){if(this._sBeforeSuggest!==this.getValue()){f=this._lastValue;this.setValue(this._sBeforeSuggest);this._lastValue=f;}this._sBeforeSuggest=undefined;}return;}if(I.prototype.onsapescape){I.prototype.onsapescape.apply(this,arguments);}};
d.prototype.onsapenter=function(e){if(I.prototype.onsapenter){I.prototype.onsapenter.apply(this,arguments);}this.cancelPendingSuggest();if(this._oSuggestionPopup&&this._oSuggestionPopup.isOpen()){var s=this._oList.getSelectedItem();if(s){if(this._hasTabularSuggestions()){this.setSelectionRow(s,true);}else{this.setSelectionItem(s._oItem,true);}}else{if(this._iPopupListSelectedIndex>=0){this._fireSuggestionItemSelectedEvent();this._doSelect();this._iPopupListSelectedIndex=-1;}this._closeSuggestionPopup();}}if(this.getEnabled()&&this.getEditable()&&!(this.getValueHelpOnly()&&this.getShowValueHelp())){this.fireSubmit({value:this.getValue()});}};
d.prototype.onsapfocusleave=function(e){var p=this._oSuggestionPopup;if(p instanceof P){if(e.relatedControlId&&q.sap.containsOrEquals(p.getDomRef(),sap.ui.getCore().byId(e.relatedControlId).getFocusDomRef())){this._bPopupHasFocus=true;this.focus();}else{if(this._$input.val()===this._sSelectedSuggViaKeyboard){this._sSelectedSuggViaKeyboard=null;}}}var f=sap.ui.getCore().byId(e.relatedControlId);if(!(p&&f&&q.sap.containsOrEquals(p.getDomRef(),f.getFocusDomRef()))){I.prototype.onsapfocusleave.apply(this,arguments);}};
d.prototype.onmousedown=function(e){var p=this._oSuggestionPopup;if((p instanceof P)&&p.isOpen()){e.stopPropagation();}};
d.prototype._deregisterEvents=function(){if(this._sPopupResizeHandler){sap.ui.core.ResizeHandler.deregister(this._sPopupResizeHandler);this._sPopupResizeHandler=null;}if(this._bUseDialog&&this._oSuggestionPopup){this.$().off("click");}};
d.prototype.updateSuggestionItems=function(){this.updateAggregation("suggestionItems");this._bShouldRefreshListItems=true;this._refreshItemsDelayed();return this;};
d.prototype.cancelPendingSuggest=function(){if(this._iSuggestDelay){q.sap.clearDelayedCall(this._iSuggestDelay);this._iSuggestDelay=null;}};
d.prototype._triggerSuggest=function(v){this.cancelPendingSuggest();this._bShouldRefreshListItems=true;if(!v){v="";}if(v.length>=this.getStartSuggestion()){this._iSuggestDelay=q.sap.delayedCall(300,this,function(){this._bBindingUpdated=false;this.fireSuggest({suggestValue:v});if(!this._bBindingUpdated){this._refreshItemsDelayed();}});}else if(this._bUseDialog){if(this._oList instanceof T){this._oList.addStyleClass("sapMInputSuggestionTableHidden");}else if(this._oList&&this._oList.destroyItems){this._oList.destroyItems();}}else if(this._oSuggestionPopup&&this._oSuggestionPopup.isOpen()){this._iPopupListSelectedIndex=-1;this._closeSuggestionPopup();}};
(function(){
d.prototype.setShowSuggestion=function(v){this.setProperty("showSuggestion",v,true);this._iPopupListSelectedIndex=-1;if(v){this._lazyInitializeSuggestionPopup(this);}else{g(this);}return this;};
d.prototype.setShowTableSuggestionValueHelp=function(v){this.setProperty("showTableSuggestionValueHelp",v,true);if(!this._oSuggestionPopup){return this;}if(v){this._addShowMoreButton();}else{this._removeShowMoreButton();}return this;};
d.prototype._getShowMoreButton=function(){var t=this,m=sap.ui.getCore().getLibraryResourceBundle("sap.m");return this._oShowMoreButton||(this._oShowMoreButton=new sap.m.Button({text:m.getText("INPUT_SUGGESTIONS_SHOW_ALL"),press:function(){if(t.getShowTableSuggestionValueHelp()){t.fireValueHelpRequest({fromSuggestions:true});t._iPopupListSelectedIndex=-1;t._closeSuggestionPopup();}}}));};
d.prototype._getButtonToolbar=function(){var s=this._getShowMoreButton();return this._oButtonToolbar||(this._oButtonToolbar=new a({content:[new b(),s]}));};
d.prototype._addShowMoreButton=function(t){if(!this._oSuggestionPopup||!t&&!this._hasTabularSuggestions()){return;}if(this._oSuggestionPopup instanceof D){var s=this._getShowMoreButton();this._oSuggestionPopup.setEndButton(s);}else{var h=this._getButtonToolbar();this._oSuggestionPopup.setFooter(h);}};
d.prototype._removeShowMoreButton=function(){if(!this._oSuggestionPopup||!this._hasTabularSuggestions()){return;}if(this._oSuggestionPopup instanceof D){this._oSuggestionPopup.setEndButton(null);}else{this._oSuggestionPopup.setFooter(null);}};
d.prototype.oninput=function(E){I.prototype.oninput.call(this,E);if(E.isMarked("invalid")){return;}var v=this._$input.val();if(this.getValueLiveUpdate()){this.setProperty("value",v,true);}this.fireLiveChange({value:v,newValue:v});if(this.getShowSuggestion()&&!this._bUseDialog){this._triggerSuggest(v);}};
d.prototype.getValue=function(){return this.getDomRef("inner")&&this._$input?this._$input.val():this.getProperty("value");};
d.prototype._refreshItemsDelayed=function(){q.sap.clearDelayedCall(this._iRefreshListTimeout);this._iRefreshListTimeout=q.sap.delayedCall(0,this,r,[this]);};
d.prototype.addSuggestionItem=function(i){this.addAggregation("suggestionItems",i,true);this._bShouldRefreshListItems=true;this._refreshItemsDelayed();f(this);return this;};
d.prototype.insertSuggestionItem=function(i,h){this.insertAggregation("suggestionItems",h,i,true);this._bShouldRefreshListItems=true;this._refreshItemsDelayed();f(this);return this;};
d.prototype.removeSuggestionItem=function(i){var h=this.removeAggregation("suggestionItems",i,true);this._bShouldRefreshListItems=true;this._refreshItemsDelayed();return h;};
d.prototype.removeAllSuggestionItems=function(){var h=this.removeAllAggregation("suggestionItems",true);this._bShouldRefreshListItems=true;this._refreshItemsDelayed();return h;};
d.prototype.destroySuggestionItems=function(){this.destroyAggregation("suggestionItems",true);this._bShouldRefreshListItems=true;this._refreshItemsDelayed();return this;};
d.prototype.addSuggestionRow=function(i){i.setType(sap.m.ListType.Active);this.addAggregation("suggestionRows",i);this._bShouldRefreshListItems=true;this._refreshItemsDelayed();f(this);return this;};
d.prototype.insertSuggestionRow=function(i,h){i.setType(sap.m.ListType.Active);this.insertAggregation("suggestionRows",h,i);this._bShouldRefreshListItems=true;this._refreshItemsDelayed();f(this);return this;};
d.prototype.removeSuggestionRow=function(i){var h=this.removeAggregation("suggestionRows",i);this._bShouldRefreshListItems=true;this._refreshItemsDelayed();return h;};
d.prototype.removeAllSuggestionRows=function(){var h=this.removeAllAggregation("suggestionRows");this._bShouldRefreshListItems=true;this._refreshItemsDelayed();return h;};
d.prototype.destroySuggestionRows=function(){this.destroyAggregation("suggestionRows");this._bShouldRefreshListItems=true;this._refreshItemsDelayed();return this;};
d.prototype.bindAggregation=function(){var h=Array.prototype.slice.call(arguments);if(h[0]==="suggestionRows"||h[0]==="suggestionColumns"||h[0]==="suggestionItems"){f(this,h[0]==="suggestionRows"||h[0]==="suggestionColumns");this._bBindingUpdated=true;}this._callMethodInManagedObject.apply(this,["bindAggregation"].concat(h));return this;};
d.prototype._lazyInitializeSuggestionPopup=function(){if(!this._oSuggestionPopup){e(this);}};
d.prototype._closeSuggestionPopup=function(){if(this._oSuggestionPopup){this._bShouldRefreshListItems=false;this.cancelPendingSuggest();this._oSuggestionPopup.close();this.$("SuggDescr").text("");this.$("inner").removeAttr("aria-haspopup");this.$("inner").removeAttr("aria-activedescendant");}};
function e(i){var m=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(i._bUseDialog){i._oPopupInput=new d(i.getId()+"-popup-input",{width:"100%",valueLiveUpdate:true,showValueHelp:i.getShowValueHelp(),valueHelpRequest:function(E){i.fireValueHelpRequest({fromSuggestions:true});i._iPopupListSelectedIndex=-1;i._closeSuggestionPopup();},liveChange:function(E){var v=E.getParameter("newValue");i._$input.val(i._getInputValue(i._oPopupInput.getValue()));i._triggerSuggest(v);i.fireLiveChange({value:v,newValue:v});}}).addStyleClass("sapMInputSuggInDialog");}i._oSuggestionPopup=!i._bUseDialog?(new P(i.getId()+"-popup",{showArrow:false,showHeader:false,placement:sap.m.PlacementType.Vertical,initialFocus:i}).attachAfterClose(function(){if(i._iPopupListSelectedIndex>=0){i._fireSuggestionItemSelectedEvent();}if(i._oList instanceof T){i._oList.removeSelections(true);}else{i._oList.destroyItems();}}).attachBeforeOpen(function(){i._sBeforeSuggest=i.getValue();})):(new D(i.getId()+"-popup",{beginButton:new sap.m.Button(i.getId()+"-popup-closeButton",{text:m.getText("MSGBOX_CLOSE"),press:function(){i._closeSuggestionPopup();}}),stretch:i._bFullScreen,contentHeight:i._bFullScreen?undefined:"20rem",customHeader:new B(i.getId()+"-popup-header",{contentMiddle:i._oPopupInput.addEventDelegate({onsapenter:function(){if(!(sap.m.MultiInput&&i instanceof sap.m.MultiInput)){i._closeSuggestionPopup();}}},this)}),horizontalScrolling:false,initialFocus:i._oPopupInput}).attachBeforeOpen(function(){i._oPopupInput.setPlaceholder(i.getPlaceholder());i._oPopupInput.setMaxLength(i.getMaxLength());}).attachBeforeClose(function(){i._$input.val(i._getInputValue(i._oPopupInput.getValue()));i.onChange();if(i instanceof sap.m.MultiInput&&i._bUseDialog){i._onDialogClose();}}).attachAfterClose(function(){if(i instanceof sap.m.MultiInput&&i._isMultiLineMode){i._showIndicator();setTimeout(function(){i._setContainerSizes();},0);}if(i._oList){if(T&&!(i._oList instanceof T)){i._oList.destroyItems();}else{i._oList.removeSelections(true);}}}).attachAfterOpen(function(){var v=i.getValue();i._oPopupInput.setValue(v);i._triggerSuggest(v);r(i);}));i._oSuggestionPopup.addStyleClass("sapMInputSuggestionPopup");i.addDependent(i._oSuggestionPopup);if(!i._bUseDialog){o(i._oSuggestionPopup,i);}if(i._oList){i._oSuggestionPopup.addContent(i._oList);}if(i.getShowTableSuggestionValueHelp()){i._addShowMoreButton();}}
function f(i,t){if(i._oList){return;}if(!i._hasTabularSuggestions()&&!t){i._oList=new L(i.getId()+"-popup-list",{width:"100%",showNoData:false,mode:sap.m.ListMode.SingleSelectMaster,rememberSelections:false,itemPress:function(E){var j=E.getParameter("listItem");i.setSelectionItem(j._oItem);}});}else{if(i._fnFilter===d._DEFAULTFILTER){i._fnFilter=d._DEFAULTFILTER_TABULAR;}if(!i._fnRowResultFilter){i._fnRowResultFilter=d._DEFAULTRESULT_TABULAR;}i._oList=i._getSuggestionsTable();if(i.getShowTableSuggestionValueHelp()){i._addShowMoreButton(t);}}if(i._oSuggestionPopup){if(i._bUseDialog){i._oSuggestionPopup.addAggregation("content",i._oList,true);var R=i._oSuggestionPopup.$("scrollCont")[0];if(R){var h=sap.ui.getCore().createRenderManager();h.renderControl(i._oList);h.flush(R);h.destroy();}}else{i._oSuggestionPopup.addContent(i._oList);}}}
function g(i){if(i._oSuggestionPopup){if(i._oList instanceof T){i._oSuggestionPopup.removeAllContent();i._removeShowMoreButton();}i._oSuggestionPopup.destroy();i._oSuggestionPopup=null;}if(i._oList instanceof L){i._oList.destroy();i._oList=null;}}
function o(p,i){p.open=function(){this.openBy(i,false,true);};p.oPopup.setAnimations(function(R,h,O){O();},function(R,h,C){C();});}
function r(h){var s=h.getShowSuggestion();h._iPopupListSelectedIndex=-1;if(!s||!h._bShouldRefreshListItems||!h.getDomRef()||(!h._bUseDialog&&!h.$().hasClass("sapMInputFocused"))){return false;}var j,k=h.getSuggestionItems(),t=h.getSuggestionRows(),m=h._$input.val()||"",n=h._oList,F=h.getFilterSuggests(),H=[],p=0,u=h._oSuggestionPopup,v={ontouchstart:function(E){(E.originalEvent||E)._sapui_cancelAutoClose=true;}},w,i;if(h._oList){if(h._oList instanceof T){n.removeSelections(true);}else{n.destroyItems();}}if(m.length<h.getStartSuggestion()){if(!h._bUseDialog){h._iPopupListSelectedIndex=-1;this.cancelPendingSuggest();u.close();}else{if(h._hasTabularSuggestions()&&h._oList){h._oList.addStyleClass("sapMInputSuggestionTableHidden");}}h.$("SuggDescr").text("");h.$("inner").removeAttr("aria-haspopup");h.$("inner").removeAttr("aria-activedescendant");return false;}if(h._hasTabularSuggestions()){if(h._bUseDialog&&h._oList){h._oList.removeStyleClass("sapMInputSuggestionTableHidden");}for(i=0;i<t.length;i++){if(!F||h._fnFilter(m,t[i])){t[i].setVisible(true);H.push(t[i]);}else{t[i].setVisible(false);}}}else{var x=(k[0]instanceof sap.ui.core.ListItem?true:false);for(i=0;i<k.length;i++){j=k[i];if(!F||h._fnFilter(m,j)){if(x){w=new sap.m.DisplayListItem(j.getId()+"-dli");w.setLabel(j.getText());w.setValue(j.getAdditionalText());}else{w=new S(j.getId()+"-sli");w.setTitle(j.getText());}w.setType(j.getEnabled()?sap.m.ListType.Active:sap.m.ListType.Inactive);w._oItem=j;w.addEventDelegate(v);H.push(w);}}}p=H.length;var A="";if(p>0){if(p==1){A=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("INPUT_SUGGESTIONS_ONE_HIT");}else{A=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("INPUT_SUGGESTIONS_MORE_HITS",p);}h.$("inner").attr("aria-haspopup","true");if(!h._hasTabularSuggestions()){for(i=0;i<p;i++){n.addItem(H[i]);}}if(!h._bUseDialog){if(h._sCloseTimer){clearTimeout(h._sCloseTimer);h._sCloseTimer=null;}if(!u.isOpen()&&!h._sOpenTimer&&(this.getValue().length>=this.getStartSuggestion())){h._sOpenTimer=setTimeout(function(){h._resizePopup();h._sOpenTimer=null;u.open();},0);}}}else{A=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("INPUT_SUGGESTIONS_NO_HIT");h.$("inner").removeAttr("aria-haspopup");h.$("inner").removeAttr("aria-activedescendant");if(!h._bUseDialog){if(u.isOpen()){h._sCloseTimer=setTimeout(function(){h._iPopupListSelectedIndex=-1;h.cancelPendingSuggest();u.close();},0);}}else{if(h._hasTabularSuggestions()&&h._oList){h._oList.addStyleClass("sapMInputSuggestionTableHidden");}}}h.$("SuggDescr").text(A);}
})();
d.prototype.onfocusin=function(e){I.prototype.onfocusin.apply(this,arguments);this.$().addClass("sapMInputFocused");if(!this._bPopupHasFocus&&!this.getStartSuggestion()&&!this.getValue()){this._triggerSuggest(this.getValue());}this._bPopupHasFocus=undefined;};
d.prototype.onsapshow=function(e){if(!this.getEnabled()||!this.getEditable()||!this.getShowValueHelp()){return;}this.fireValueHelpRequest({fromSuggestions:false});e.preventDefault();e.stopPropagation();};
d.prototype.onsaphide=d.prototype.onsapshow;
d.prototype.onsapselect=function(e){this._fireValueHelpRequestForValueHelpOnly();};
d.prototype.onfocusout=function(e){I.prototype.onfocusout.apply(this,arguments);this.$().removeClass("sapMInputFocused");this.closeValueStateMessage(this);};
d.prototype._hasTabularSuggestions=function(){return!!(this.getAggregation("suggestionColumns")&&this.getAggregation("suggestionColumns").length);};
d.prototype._getSuggestionsTable=function(){var t=this;if(!this._oSuggestionTable){this._oSuggestionTable=new T(this.getId()+"-popup-table",{mode:sap.m.ListMode.SingleSelectMaster,showNoData:false,showSeparators:"All",width:"100%",enableBusyIndicator:false,rememberSelections:false,selectionChange:function(e){var s=e.getParameter("listItem");t.setSelectionRow(s);}});if(this._bUseDialog){this._oSuggestionTable.addStyleClass("sapMInputSuggestionTableHidden");}this._oSuggestionTable.updateItems=function(){T.prototype.updateItems.apply(this,arguments);t._refreshItemsDelayed();return this;};}return this._oSuggestionTable;};
d.prototype._fireSuggestionItemSelectedEvent=function(){if(this._iPopupListSelectedIndex>=0){var s=this._oList.getItems()[this._iPopupListSelectedIndex];if(s){if(sap.m.ColumnListItem&&s instanceof sap.m.ColumnListItem){this.fireSuggestionItemSelected({selectedRow:s});}else{this.fireSuggestionItemSelected({selectedItem:s._oItem});}}this._iPopupListSelectedIndex=-1;}};
d.prototype._callMethodInManagedObject=function(f,A){var e=Array.prototype.slice.call(arguments),s;if(A==="suggestionColumns"){s=this._getSuggestionsTable();return s[f].apply(s,["columns"].concat(e.slice(2)));}else if(A==="suggestionRows"){s=this._getSuggestionsTable();return s[f].apply(s,["items"].concat(e.slice(2)));}else{return sap.ui.core.Control.prototype[f].apply(this,e.slice(1));}};
d.prototype.validateAggregation=function(A,o,m){return this._callMethodInManagedObject("validateAggregation",A,o,m);};
d.prototype.setAggregation=function(A,o,s){this._callMethodInManagedObject("setAggregation",A,o,s);return this;};
d.prototype.getAggregation=function(A,o){return this._callMethodInManagedObject("getAggregation",A,o);};
d.prototype.indexOfAggregation=function(A,o){return this._callMethodInManagedObject("indexOfAggregation",A,o);};
d.prototype.insertAggregation=function(A,o,i,s){this._callMethodInManagedObject("insertAggregation",A,o,i,s);return this;};
d.prototype.addAggregation=function(A,o,s){this._callMethodInManagedObject("addAggregation",A,o,s);return this;};
d.prototype.removeAggregation=function(A,o,s){return this._callMethodInManagedObject("removeAggregation",A,o,s);};
d.prototype.removeAllAggregation=function(A,s){return this._callMethodInManagedObject("removeAllAggregation",A,s);};
d.prototype.destroyAggregation=function(A,s){this._callMethodInManagedObject("destroyAggregation",A,s);return this;};
d.prototype.getBinding=function(A){return this._callMethodInManagedObject("getBinding",A);};
d.prototype.getBindingInfo=function(A){return this._callMethodInManagedObject("getBindingInfo",A);};
d.prototype.getBindingPath=function(A){return this._callMethodInManagedObject("getBindingPath",A);};
d.prototype.clone=function(){var i=sap.ui.core.Control.prototype.clone.apply(this,arguments),e;e=this.getBindingInfo("suggestionColumns");if(e){i.bindAggregation("suggestionColumns",q.extend({},e));}else{this.getSuggestionColumns().forEach(function(C){i.addSuggestionColumn(C.clone(),true);});}e=this.getBindingInfo("suggestionRows");if(e){i.bindAggregation("suggestionRows",q.extend({},e));}else{this.getSuggestionRows().forEach(function(r){i.addSuggestionRow(r.clone(),true);});}return i;};
d.prototype.setValue=function(v){this._iSetCount++;I.prototype.setValue.call(this,v);return this;};
d.prototype.getAccessibilityInfo=function(){var i=I.prototype.getAccessibilityInfo.apply(this,arguments);i.description=((i.description||"")+" "+this.getDescription()).trim();return i;};
return d;},true);
sap.ui.predefine('sap/m/InputBase',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/Popup','./delegate/ValueStateMessage'],function(q,l,C,E,I,P,V){"use strict";
var a=C.extend("sap.m.InputBase",{metadata:{library:"sap.m",properties:{value:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:sap.ui.core.ValueState.None},name:{type:"string",group:"Misc",defaultValue:null},placeholder:{type:"string",group:"Misc",defaultValue:null},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueStateText:{type:"string",group:"Misc",defaultValue:null},showValueStateMessage:{type:"boolean",group:"Misc",defaultValue:true},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:sap.ui.core.TextAlign.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},required:{type:"boolean",group:"Misc",defaultValue:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"string"}}}}}});
E.call(a.prototype);I.insertFontFaceStyle();a.prototype.bShowLabelAsPlaceholder=!sap.ui.Device.support.input.placeholder;
a.prototype._getPlaceholder=function(){return this.getPlaceholder();};
a.prototype._setLabelVisibility=function(){if(!this.bShowLabelAsPlaceholder){return;}var v=this.$("inner").val();this.$("placeholder").css("display",v?"none":"inline");};
a.prototype._getInputValue=function(v){v=(v===undefined)?this.$("inner").val()||"":v.toString();if(this.getMaxLength&&this.getMaxLength()>0){v=v.substring(0,this.getMaxLength());}return v;};
a.prototype._triggerInputEvent=function(p){p=p||{};var e=new q.Event("input",p);e.originalEvent=p;e.setMark("synthetic",true);q.sap.delayedCall(0,this,function(){this.$("inner").trigger(e);});};
a.prototype._getInputElementTagName=function(){if(!this._sInputTagElementName){this._sInputTagElementName=this._$input&&this._$input.get(0)&&this._$input.get(0).tagName;}return this._sInputTagElementName;};
a.prototype.init=function(){this._lastValue="";this.bRenderingPhase=false;this.bFocusoutDueRendering=false;this._oValueStateMessage=new V(this);};
a.prototype.onBeforeRendering=function(){if(this._bCheckDomValue&&!this.bRenderingPhase){this._sDomValue=this._getInputValue();}this.bRenderingPhase=true;};
a.prototype.onAfterRendering=function(){if(this._bCheckDomValue&&this._sDomValue!==this._getInputValue()){this.$("inner").val(this._sDomValue);}this._bCheckDomValue=false;this._setLabelVisibility();this.bRenderingPhase=false;};
a.prototype.exit=function(){if(this._oValueStateMessage){this._oValueStateMessage.destroy();}this._oValueStateMessage=null;};
a.prototype.ontouchstart=function(e){e.setMarked();};
a.prototype.onfocusin=function(e){this._bIgnoreNextInput=!this.bShowLabelAsPlaceholder&&sap.ui.Device.browser.msie&&sap.ui.Device.browser.version>9&&!!this.getPlaceholder()&&!this._getInputValue()&&this._getInputElementTagName()==="INPUT";this.$().toggleClass("sapMFocus",true);if(this.shouldValueStateMessageBeOpened()){this.openValueStateMessage();}};
a.prototype.onfocusout=function(e){this.bFocusoutDueRendering=this.bRenderingPhase;this.$().toggleClass("sapMFocus",false);if(this.bRenderingPhase){return;}this.closeValueStateMessage();};
a.prototype.onsapfocusleave=function(e){if(this.bFocusoutDueRendering){return;}this.onChange(e);};
a.prototype.ontap=function(e){if(this.getEnabled()&&this.getEditable()&&this.bShowLabelAsPlaceholder&&e.target.id===this.getId()+"-placeholder"){this.focus();}};
a.prototype.onChange=function(e){if(!this.getEditable()||!this.getEnabled()){return;}var v=this._getInputValue();if(v!==this._lastValue){this.setValue(v);v=this.getValue();this._lastValue=v;this.fireChangeEvent(v);return true;}else{this._bCheckDomValue=false;}};
a.prototype.fireChangeEvent=function(v,p){var c=q.extend({value:v,newValue:v},p);this.fireChange(c);};
a.prototype.onValueRevertedByEscape=function(v){this.fireEvent("liveChange",{value:v,newValue:v});};
a.prototype.onsapenter=function(e){this.onChange(e);};
a.prototype.onsapescape=function(e){var v=this._getInputValue();if(v!==this._lastValue){e.setMarked();e.preventDefault();this.updateDomValue(this._lastValue);this.onValueRevertedByEscape(this._lastValue);}};
a.prototype.oninput=function(e){if(this._bIgnoreNextInput){this._bIgnoreNextInput=false;e.setMarked("invalid");return;}if(!this.getEditable()){e.setMarked("invalid");return;}if(document.activeElement!==e.target&&sap.ui.Device.browser.msie&&this.getValue()===this._lastValue){e.setMarked("invalid");return;}this._bCheckDomValue=true;this._setLabelVisibility();};
a.prototype.onkeydown=function(e){var k=q.sap.KeyCodes;var b=sap.ui.Device.browser;e.setMark("inputBase");if((b.msie&&b.version<10)&&(e.which===k.DELETE||e.which===k.BACKSPACE)){this._triggerInputEvent();}};
a.prototype.oncut=function(e){var b=sap.ui.Device.browser;if(b.msie&&b.version<10){this._triggerInputEvent();}};
a.prototype.selectText=function(s,S){this.$("inner").selectText(s,S);return this;};
a.prototype.getSelectedText=function(){return this.$("inner").getSelectedText();};
a.prototype.setProperty=function(p,v,s){if(p=="value"){this._bCheckDomValue=false;}return C.prototype.setProperty.apply(this,arguments);};
a.prototype.getFocusInfo=function(){var f=C.prototype.getFocusInfo.call(this),F=this.getFocusDomRef();q.extend(f,{cursorPos:0,selectionStart:0,selectionEnd:0});if(F){f.cursorPos=q(F).cursorPos();try{f.selectionStart=F.selectionStart;f.selectionEnd=F.selectionEnd;}catch(e){}}return f;};
a.prototype.applyFocusInfo=function(f){C.prototype.applyFocusInfo.call(this,f);this.$("inner").cursorPos(f.cursorPos);this.selectText(f.selectionStart,f.selectionEnd);return this;};
a.prototype.bindToInputEvent=function(c){if(this._oInputEventDelegate){this.removeEventDelegate(this._oInputEventDelegate);}this._oInputEventDelegate={oninput:c};return this.addEventDelegate(this._oInputEventDelegate);};
a.prototype.updateDomValue=function(v){if(!this.isActive()){return this;}v=this._getInputValue(v);if(this._getInputValue()!==v){this.$("inner").val(v);this._bCheckDomValue=true;}this._setLabelVisibility();return this;};
a.prototype.closeValueStateMessage=function(){if(this._oValueStateMessage){this._oValueStateMessage.close();}};
a.prototype.getDomRefForValueStateMessage=function(){return this.getFocusDomRef();};
a.prototype.iOpenMessagePopupDuration=0;
a.prototype.getValueStateMessageId=function(){return this.getId()+"-message";};
a.prototype.openValueStateMessage=function(){if(this._oValueStateMessage){this._oValueStateMessage.open();}};
a.prototype.updateValueStateClasses=function(v,o){var t=this.$(),i=this.$("inner"),m=sap.ui.core.ValueState;if(o!==m.None){t.removeClass("sapMInputBaseState sapMInputBase"+o);i.removeClass("sapMInputBaseStateInner sapMInputBase"+o+"Inner");}if(v!==m.None){t.addClass("sapMInputBaseState sapMInputBase"+v);i.addClass("sapMInputBaseStateInner sapMInputBase"+v+"Inner");}};
a.prototype.shouldValueStateMessageBeOpened=function(){return((this.getValueState()!==sap.ui.core.ValueState.None)&&this.getEditable()&&this.getEnabled()&&this.getShowValueStateMessage());};
a.prototype.setValueState=function(v){var o=this.getValueState();this.setProperty("valueState",v,true);v=this.getValueState();if(v===o){return this;}var d=this.getDomRef();if(!d){return this;}var i=this.$("inner"),m=sap.ui.core.ValueState;if(v===m.Error){i.attr("aria-invalid","true");}else{i.removeAttr("aria-invalid");}this.updateValueStateClasses(v,o);if(i[0]===document.activeElement){if(v===m.None){this.closeValueStateMessage();}else if(this.shouldValueStateMessageBeOpened()){this.openValueStateMessage();}}return this;};
a.prototype.setValueStateText=function(t){this.setProperty("valueStateText",t,true);this.$("message").text(this.getValueStateText());return this;};
a.prototype.setValue=function(v){v=this.validateProperty("value",v);v=this._getInputValue(v);this.updateDomValue(v);if(v!==this.getProperty("value")){this._lastValue=v;}this.setProperty("value",v,true);return this;};
a.prototype.getFocusDomRef=function(){return this.getDomRef("inner");};
a.prototype.getIdForLabel=function(){return this.getId()+"-inner";};
a.prototype.propagateMessages=function(n,m){if(m&&m.length>0){this.setValueState(m[0].type);this.setValueStateText(m[0].message);}else{this.setValueState(sap.ui.core.ValueState.None);this.setValueStateText('');}};
a.prototype.setTooltip=function(t){var d=this.getDomRef();this._refreshTooltipBaseDelegate(t);this.setAggregation("tooltip",t,true);if(!d){return this;}var T=this.getTooltip_AsString();if(T){d.setAttribute("title",T);}else{d.removeAttribute("title");}if(sap.ui.getCore().getConfiguration().getAccessibility()){var D=this.getDomRef("describedby"),A=this.getRenderer().getDescribedByAnnouncement(this),s=this.getId()+"-describedby",b="aria-describedby",f=this.getFocusDomRef(),c=f.getAttribute(b);if(!D&&A){D=document.createElement("span");D.id=s;D.setAttribute("aria-hidden","true");D.className="sapUiInvisibleText";if(this.getAriaDescribedBy){f.setAttribute(b,(this.getAriaDescribedBy().join(" ")+" "+s).trim());}else{f.setAttribute(b,s);}d.appendChild(D);}else if(D&&!A){d.removeChild(D);var e=D.id;if(c&&e){f.setAttribute(b,c.replace(e,"").trim());}}if(D){D.textContent=A;}}return this;};
a.prototype.refreshDataState=function(n,d){if(d.getChanges().messages){this.propagateMessages(n,d.getMessages());}};
a.prototype.getAccessibilityInfo=function(){var r=this.getRenderer();return{role:r.getAriaRole(this),type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_INPUT"),description:[this.getValue()||"",r.getLabelledByAnnouncement(this),r.getDescribedByAnnouncement(this)].join(" ").trim(),focusable:this.getEnabled(),enabled:this.getEnabled(),editable:this.getEnabled()&&this.getEditable()};};
Object.defineProperty(a.prototype,"_$input",{get:function(){return this.$("inner");}});return a;},true);
sap.ui.predefine('sap/m/InputBaseRenderer',['jquery.sap.global','sap/ui/core/Renderer','sap/ui/core/ValueStateSupport'],function(q,R,V){"use strict";var I={};
I.render=function(r,c){var v=c.getValueState(),t=c.getTextDirection(),T=R.getTextAlign(c.getTextAlign(),t),a=sap.ui.getCore().getConfiguration().getAccessibility();r.write("<div");r.writeControlData(c);this.addOuterStyles(r,c);this.addControlWidth(r,c);r.writeStyles();r.addClass("sapMInputBase");this.addPaddingClass(r,c);this.addCursorClass(r,c);this.addOuterClasses(r,c);if(!c.getEnabled()){r.addClass("sapMInputBaseDisabled");}if(!c.getEditable()){r.addClass("sapMInputBaseReadonly");}if(v!==sap.ui.core.ValueState.None){this.addValueStateClasses(r,c);}r.writeClasses();this.writeOuterAttributes(r,c);var s=c.getTooltip_AsString();if(s){r.writeAttributeEscaped("title",s);}r.write(">");this.prependInnerContent(r,c);if(c.bShowLabelAsPlaceholder){r.write("<label");r.writeAttribute("id",c.getId()+"-placeholder");if(T){r.addStyle("text-align",T);}this.addPlaceholderClasses(r,c);this.addPlaceholderStyles(r,c);r.writeClasses();r.writeStyles();r.write(">");r.writeEscaped(c._getPlaceholder());r.write("</label>");}this.openInputTag(r,c);this.writeInnerId(r,c);if(c.getName()){r.writeAttributeEscaped("name",c.getName());}if(!c.bShowLabelAsPlaceholder&&c._getPlaceholder()){r.writeAttributeEscaped("placeholder",c._getPlaceholder());}if(c.getMaxLength&&c.getMaxLength()>0){r.writeAttribute("maxlength",c.getMaxLength());}if(!c.getEnabled()){r.writeAttribute("disabled","disabled");r.addClass("sapMInputBaseDisabledInner");}else if(!c.getEditable()){r.writeAttribute("readonly","readonly");r.addClass("sapMInputBaseReadonlyInner");}if(t!=sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",t.toLowerCase());}this.writeInnerValue(r,c);if(a){this.writeAccessibilityState(r,c);}if(sap.ui.Device.browser.mozilla){if(s){r.writeAttributeEscaped("x-moz-errormessage",s);}else{r.writeAttribute("x-moz-errormessage"," ");}}this.writeInnerAttributes(r,c);r.addClass("sapMInputBaseInner");if(v!==sap.ui.core.ValueState.None){this.addValueStateInnerClasses(r,c);}this.addInnerClasses(r,c);r.writeClasses();if(T){r.addStyle("text-align",T);}this.addInnerStyles(r,c);r.writeStyles();r.write(">");this.writeInnerContent(r,c);this.closeInputTag(r,c);if(a){this.renderAriaLabelledBy(r,c);this.renderAriaDescribedBy(r,c);}r.write("</div>");};
I.getAriaRole=function(c){return"textbox";};
I.getAriaLabelledBy=function(c){if(this.getLabelledByAnnouncement(c)){return c.getId()+"-labelledby";}};
I.getLabelledByAnnouncement=function(c){return c._getPlaceholder()||"";};
I.renderAriaLabelledBy=function(r,c){var a=this.getLabelledByAnnouncement(c);if(a){r.write("<label");r.writeAttribute("id",c.getId()+"-labelledby");r.writeAttribute("aria-hidden","true");r.addClass("sapUiInvisibleText");r.writeClasses();r.write(">");r.writeEscaped(a.trim());r.write("</label>");}};
I.getAriaDescribedBy=function(c){if(this.getDescribedByAnnouncement(c)){return c.getId()+"-describedby";}};
I.getDescribedByAnnouncement=function(c){return c.getTooltip_AsString()||"";};
I.renderAriaDescribedBy=function(r,c){var a=this.getDescribedByAnnouncement(c);if(a){r.write("<span");r.writeAttribute("id",c.getId()+"-describedby");r.writeAttribute("aria-hidden","true");r.addClass("sapUiInvisibleText");r.writeClasses();r.write(">");r.writeEscaped(a.trim());r.write("</span>");}};
I.getAccessibilityState=function(c){var a=this.getAriaLabelledBy(c),A=this.getAriaDescribedBy(c),r=this.getAriaRole(c),m={};if(r){m.role=r;}if(c.getValueState()===sap.ui.core.ValueState.Error){m.invalid=true;}if(a){m.labelledby={value:a.trim(),append:true};}if(A){m.describedby={value:A.trim(),append:true};}return m;};
I.writeAccessibilityState=function(r,c){r.writeAccessibilityState(c,this.getAccessibilityState(c));};
I.openInputTag=function(r,c){r.write("<input");};
I.writeInnerValue=function(r,c){r.writeAttributeEscaped("value",c.getValue());};
I.addCursorClass=function(r,c){};
I.addPaddingClass=function(r,c){r.addClass("sapMInputBaseWidthPadding");};
I.addOuterStyles=function(r,c){};
I.addControlWidth=function(r,c){if(c.getWidth()){r.addStyle("width",c.getWidth());}};
I.addOuterClasses=function(r,c){};
I.writeOuterAttributes=function(r,c){};
I.addInnerStyles=function(r,c){};
I.addInnerClasses=function(r,c){};
I.writeInnerAttributes=function(r,c){};
I.prependInnerContent=function(r,c){};
I.writeInnerContent=function(r,c){};
I.closeInputTag=function(r,c){};
I.addPlaceholderStyles=function(r,c){};
I.addPlaceholderClasses=function(r,c){r.addClass("sapMInputBasePlaceholder");};
I.addValueStateInnerClasses=function(r,c){r.addClass("sapMInputBaseStateInner");r.addClass("sapMInputBase"+c.getValueState()+"Inner");};
I.addValueStateClasses=function(r,c){r.addClass("sapMInputBaseState");r.addClass("sapMInputBase"+c.getValueState());};
I.writeInnerId=function(r,c){r.writeAttribute("id",c.getId()+"-inner");};
return I;},true);
sap.ui.predefine('sap/m/InputListItem.designtime',[],function(){"use strict";return{aggregations:{content:{domRef:":sap-domref"}}};},false);
sap.ui.predefine('sap/m/InputListItem',['jquery.sap.global','./ListItemBase','./library'],function(q,L,l){"use strict";
var I=L.extend("sap.m.InputListItem",{metadata:{library:"sap.m",properties:{label:{type:"string",group:"Misc",defaultValue:null},labelTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",bindable:"bindable"}},designTime:true}});
return I;},true);
sap.ui.predefine('sap/m/InputListItemRenderer',['jquery.sap.global','./ListItemBaseRenderer','sap/ui/core/Renderer'],function(q,L,R){"use strict";var I=R.extend(L);
I.renderLIAttributes=function(r,l){r.addClass("sapMILI");};
I.renderLIContent=function(r,l){var s=l.getLabel();if(s){var a=l.getId()+"-label",b=l.getLabelTextDirection();r.write('<label id="'+a+'" class="sapMILILabel"');if(b!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",b.toLowerCase());}r.write('>');r.writeEscaped(s);r.write('</label>');}r.write('<div class="sapMILIDiv sapMILI-CTX">');l.getContent().forEach(function(c){if(a&&c.addAriaLabelledBy&&c.getAriaLabelledBy().indexOf(a)==-1){c.addAriaLabelledBy(a);}r.renderControl(c);});r.write('</div>');};
return I;},true);
sap.ui.predefine('sap/m/InputRenderer',['jquery.sap.global','sap/ui/core/Renderer','./InputBaseRenderer'],function(q,R,I){"use strict";var a=R.extend(I);
a.addOuterClasses=function(r,c){r.addClass("sapMInput");if(c.getShowValueHelp()&&c.getEnabled()&&c.getEditable()){r.addClass("sapMInputVH");if(c.getValueHelpOnly()){r.addClass("sapMInputVHO");}}if(c.getDescription()){r.addClass("sapMInputDescription");}};
a.addOuterStyles=function(r,c){};
a.writeInnerAttributes=function(r,c){r.writeAttribute("type",c.getType().toLowerCase());if((!c.getEnabled()&&c.getType()=="Password")||(c.getShowSuggestion()&&c._bUseDialog)||(c.getValueHelpOnly()&&c.getEnabled()&&c.getEditable()&&c.getShowValueHelp())){r.writeAttribute("readonly","readonly");}};
a.addInnerClasses=function(r,c){};
a.addInnerStyles=function(r,c){if(c.getDescription()){r.addStyle("width",c.getFieldWidth()||"50%");}};
a.writeInnerContent=function(r,c){var i=c.getId(),d=c.getDescription();if(!d){this.writeValueHelpIcon(r,c);}else{r.write("<span id=\""+c.getId()+"-Descr\">");this.writeValueHelpIcon(r,c);r.writeEscaped(d);r.write("</span>");}if(sap.ui.getCore().getConfiguration().getAccessibility()){if(c.getShowSuggestion()&&c.getEnabled()&&c.getEditable()){r.write("<span id=\""+i+"-SuggDescr\" class=\"sapUiInvisibleText\" role=\"status\" aria-live=\"polite\"></span>");}}};
a.writeValueHelpIcon=function(r,c){if(c.getShowValueHelp()&&c.getEnabled()&&c.getEditable()){r.write('<div class="sapMInputValHelp" tabindex="-1">');r.renderControl(c._getValueHelpIcon());r.write("</div>");}};
a.addPlaceholderStyles=function(r,c){if(c.getDescription()){r.addStyle("width",c.getFieldWidth()||"50%");}};
a.getAriaLabelledBy=function(c){var b=I.getAriaLabelledBy.call(this,c)||"";if(c.getDescription()){b=b+" "+c.getId()+"-Descr";}return b;};
a.getAriaDescribedBy=function(c){var A=I.getAriaDescribedBy.apply(this,arguments);if(c.getShowValueHelp()&&c.getEnabled()&&c.getEditable()){if(A){A=A+" "+c._sAriaValueHelpLabelId;}else{A=c._sAriaValueHelpLabelId;}if(c.getValueHelpOnly()){A=A+" "+c._sAriaInputDisabledLabelId;}}if(c.getShowSuggestion()&&c.getEnabled()&&c.getEditable()){if(A){A=A+" "+c.getId()+"-SuggDescr";}else{A=c.getId()+"-SuggDescr";}}return A;};
a.getAriaRole=function(c){return"";};
a.getAccessibilityState=function(c){var A=I.getAccessibilityState.apply(this,arguments);if(c.getShowSuggestion()&&c.getEnabled()&&c.getEditable()){A.autocomplete="list";}return A;};
return a;},true);
sap.ui.predefine('sap/m/InstanceManager',['jquery.sap.global'],function(q){"use strict";var I={};(function(){var r={},e=[];var p="_POPOVER_",d="_DIALOG_";
I.addInstance=function(c,i){if(!r[c]){r[c]=[];}if(r[c].indexOf(i)===-1){r[c].push(i);}return this;};
I.removeInstance=function(c,o){var C=r[c],i;if(!C){q.sap.log.warning("Can't remove control from a non-managed category id: "+c);return null;}i=C.indexOf(o);return(i===-1)?null:C.splice(i,1);};
I.getInstancesByCategoryId=function(c){return r[c]||e;};
I.isInstanceManaged=function(c,i){var C=r[c];if(!C||!i){return false;}return C.indexOf(i)!==-1;};
I.isCategoryEmpty=function(c){var C=r[c];return!C||C.length===0;};
I.addPopoverInstance=function(P){if(typeof P.close==="function"){I.addInstance(p,P);}else{q.sap.log.warning("In method addPopoverInstance: the parameter doesn't have a close method and can't be managed.");}return this;};
I.addDialogInstance=function(D){if(typeof D.close==="function"){I.addInstance(d,D);}else{q.sap.log.warning("In method addDialogInstance: the parameter doesn't have a close method and can't be managed.");}return this;};
I.removePopoverInstance=function(P){return I.removeInstance(p,P);};
I.removeDialogInstance=function(D){return I.removeInstance(d,D);};
I.hasOpenPopover=function(){return!I.isCategoryEmpty(p);};
I.hasOpenDialog=function(){return!I.isCategoryEmpty(d);};
I.isDialogOpen=function(D){return I.isInstanceManaged(d,D);};
I.isPopoverOpen=function(P){return I.isInstanceManaged(p,P);};
I.getOpenPopovers=function(){return I.getInstancesByCategoryId(p);};
I.getOpenDialogs=function(){return I.getInstancesByCategoryId(d);};
I.closeAllPopovers=function(){var a=I.getOpenPopovers(),i;for(i=0;i<a.length;i++){a[i].close();}return this;};
I.closeAllDialogs=function(c){var D,a=[],b=I.getOpenDialogs(),f,i;for(i=0;i<b.length;i++){f=b[i];if(c){D=new q.Deferred().done();a.push(D);f.attachEvent("afterClose",(function(g){return function(){g.resolve();};}(D)));}f.close();}if(c){q.when.apply(this,a).then(c);}return this;};
}());return I;},true);
sap.ui.predefine('sap/m/Label',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/LabelEnablement'],function(q,l,C,L){"use strict";
var a=C.extend("sap.m.Label",{metadata:{interfaces:["sap.ui.core.Label","sap.ui.core.IShrinkable"],library:"sap.m",properties:{design:{type:"sap.m.LabelDesign",group:"Appearance",defaultValue:sap.m.LabelDesign.Standard},text:{type:"string",group:"Misc",defaultValue:null},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:sap.ui.core.TextAlign.Begin},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},required:{type:"boolean",group:"Misc",defaultValue:false}},associations:{labelFor:{type:"sap.ui.core.Control",multiple:false}}}});
a.prototype.setText=function(t){var v=this.getText();if(v!==t){this.setProperty("text",t,true);this.$().html(q.sap.encodeHTML(this.getProperty("text")));if(t){this.$().removeClass("sapMLabelNoText");}else{this.$().addClass("sapMLabelNoText");}}return this;};
a.prototype.setTooltip=function(t){var v=this.getTooltip();if(v!==t){this.setAggregation("tooltip",t,true);this.$().attr("title",this.getTooltip());}return this;};
a.prototype.getAccessibilityInfo=function(){return{description:this.getText()};};
L.enrich(a.prototype);return a;},true);
sap.ui.predefine('sap/m/LabelRenderer',['jquery.sap.global','sap/ui/core/Renderer'],function(q,R){"use strict";var L={};
L.render=function(a,l){var r=L;a.write("<label");a.writeControlData(l);a.addClass("sapMLabel");a.addClass("sapUiSelectable");if(l.getDesign()==sap.m.LabelDesign.Bold){a.addStyle("font-weight","bold");}if(l.getRequired()){a.addClass("sapMLabelRequired");}if(l.getLabelForRendering()){sap.ui.core.LabelEnablement.writeLabelForAttribute(a,l);}else if(l.getParent()instanceof sap.m.Toolbar){a.addClass("sapMLabelTBHeader");}var t=l.getTextDirection();if(t!==sap.ui.core.TextDirection.Inherit){a.writeAttribute("dir",t.toLowerCase());}var w=l.getWidth();if(w){a.addStyle("width",w);}else{a.addClass("sapMLabelMaxWidth");}var T=l.getTextAlign();if(T){var T=r.getTextAlign(T,t);if(T){a.addStyle("text-align",T);}}var s=l.getText();if(s==""){a.addClass("sapMLabelNoText");}a.writeStyles();a.writeClasses();var b=l.getTooltip_AsString();if(b){a.writeAttributeEscaped("title",b);}a.write(">");if(s){a.writeEscaped(s);}a.write("</label>");};
L.getTextAlign=R.getTextAlign;return L;},true);
sap.ui.predefine('sap/m/LightBox',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/Popup','sap/m/Text','sap/m/Button','sap/m/Image','sap/ui/core/ResizeHandler','sap/ui/Device','sap/m/MessagePage','sap/ui/core/Icon','sap/ui/layout/VerticalLayout'],function(q,l,C,P,T,B,I,R,D,M,a,V){'use strict';
var L=C.extend('sap.m.LightBox',{metadata:{interfaces:['sap.ui.core.PopupInterface'],library:'sap.m',aggregations:{imageContent:{type:'sap.m.LightBoxItem',multiple:true,bindable:"bindable"},_closeButton:{type:'sap.m.Button',multiple:false,visibility:'hidden'},_errorIcon:{type:'sap.ui.core.Icon',multiple:false,visibility:'hidden'},_errorTitle:{type:'sap.m.Text',multiple:false,visibility:'hidden'},_errorSubtitle:{type:'sap.m.Text',multiple:false,visibility:'hidden'},_verticalLayout:{type:'sap.ui.layout.VerticalLayout',multiple:false,visibility:'hidden'}},events:{}}});
L.prototype.init=function(){this._createPopup();this._width=0;this._height=0;this._isRendering=true;this._resizeListenerId=null;this._$lightBox=null;this._closeButtonText=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LIGHTBOX_CLOSE_BUTTON");};
L.prototype.onBeforeRendering=function(){var i=this._getImageContent(),n=i._getNativeImage(),s=i._getImageState();this._createErrorControls();n.src=i.getImageSrc();if(this._resizeListenerId){D.resize.detachHandler(this._onResize);R.deregister(this._resizeListenerId);this._resizeListenerId=null;}switch(s){case sap.m.LightBoxLoadingStates.Loading:this._timeoutId=setTimeout(function(){i._setImageState(sap.m.LightBoxLoadingStates.TimeOutError);},10000);break;case sap.m.LightBoxLoadingStates.Loaded:clearTimeout(this._timeoutId);this._calculateSizes(n);break;case sap.m.LightBoxLoadingStates.Error:clearTimeout(this._timeoutId);break;default:break;}this._isRendering=true;};
L.prototype.onAfterRendering=function(){this._isRendering=false;this._$lightBox=this.$();if(!this._resizeListenerId){D.resize.attachHandler(this._onResize.bind(this));this._resizeListenerId=R.register(this,this._onResize.bind(this));}};
L.prototype.forceInvalidate=C.prototype.invalidate;
L.prototype.invalidate=function(o){var i=this._getImageContent();if(this.isOpen()){if(i&&i.getImageSrc()){this.forceInvalidate(o);}else{this.close();}}return this;};
L.prototype.exit=function(){if(this._oPopup){this._oPopup.detachOpened(this._fnOpened,this);this._oPopup.detachClosed(this._fnClosed,this);this._oPopup.destroy();this._oPopup=null;}if(this._resizeListenerId){D.resize.detachHandler(this._onResize);R.deregister(this._resizeListenerId);this._resizeListenerId=null;}};
L.prototype.open=function(){var i=this._getImageContent();this._oPopup.setContent(this);if(i&&i.getImageSrc()){this._oPopup.open(300,'center center','center center',document.body,null);}return this;};
L.prototype.isOpen=function(){if(this._oPopup&&this._oPopup.isOpen()){return true;}return false;};
L.prototype.close=function(){if(this._resizeListenerId){D.resize.detachHandler(this._onResize);R.deregister(this._resizeListenerId);this._resizeListenerId=null;}this._oPopup.close();return this;};
L.prototype._getCloseButton=function(){var b=this.getAggregation('_closeButton');if(!b){b=new B({id:this.getId()+'-closeButton',text:this._closeButtonText,type:sap.m.ButtonType.Transparent,press:function(){this.close();}.bind(this)});this.setAggregation('_closeButton',b,true);}return b;};
L.prototype._imageStateChanged=function(n){if((n===sap.m.LightBoxLoadingStates.Loaded||n===sap.m.LightBoxLoadingStates.Error)&&!this._isRendering){this.rerender();}};
L.prototype._createPopup=function(){this._oPopup=new P(this,true,true);this._oPopup.attachOpened(this._fnOpened,this);this._oPopup.attachClosed(this._fnClosed,this);};
L.prototype._fnOpened=function(){var t=this;q('#sap-ui-blocklayer-popup').on("click",function(){t.close();});};
L.prototype._fnClosed=function(){q('#sap-ui-blocklayer-popup').off("click");};
L.prototype._createErrorControls=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");var e;var b;if(this._getImageContent()._getImageState()===sap.m.LightBoxLoadingStates.TimeOutError){e=r.getText('LIGHTBOX_IMAGE_TIMED_OUT');b=r.getText('LIGHTBOX_IMAGE_TIMED_OUT_DETAILS');}else{e=r.getText('LIGHTBOX_IMAGE_ERROR');b=r.getText('LIGHTBOX_IMAGE_ERROR_DETAILS');}var d=new T({text:e,textAlign:sap.ui.core.TextAlign.Center}).addStyleClass("sapMLightBoxErrorTitle"),f=new T({text:b,textAlign:sap.ui.core.TextAlign.Center}).addStyleClass("sapMLightBoxErrorSubtitle"),g=new a({src:"sap-icon://picture"}).addStyleClass("sapMLightBoxErrorIcon");this.setAggregation('_errorIcon',g);this.setAggregation('_verticalLayout',new V({content:[g,d,f]}).addStyleClass('sapMLightBoxVerticalLayout'));};
L.prototype._onResize=function(){var m=c()/2+'px',t=m,b=m,d='',e='',i=this._getImageContent(),f=this.getDomRef(),g,h,j=c(),k=2;if(i._getImageState()===sap.m.LightBoxLoadingStates.Loaded){this._calculateSizes(i._getNativeImage());g=this._width;h=this._height;this._$lightBox.width(g);this._$lightBox.height(h);}else{g=f.clientWidth;h=f.clientHeight;}if(window.innerWidth>g+j){b='50%';e=Math.round(-g/2);}if(window.innerHeight>h+j){t='50%';d=Math.round(-h/2);}if(sap.ui.getCore().getConfiguration().getTheme()==='sap_hcb'){d-=k;e-=k;}this._$lightBox.css({'top':t,'margin-top':d,'left':b,'margin-left':e});};
L.prototype._calculateSizes=function(i){var f=this._calculateFooterHeightInPx(),b=288-f,d=this._getImageContent().getAggregation("_image"),h;this._setImageSize(d,i.naturalWidth,i.naturalHeight);this._calculateAndSetLightBoxSize(d);h=this._pxToNumber(d.getHeight());this.toggleStyleClass('sapMLightBoxMinSize',(h<b));this._isBusy=false;};
L.prototype._calculateFooterHeightInPx=function(i){var b=this.$().parents().hasClass('sapUiSizeCompact');var s=this._getImageContent().getSubtitle();var f=2.5;if(!b){f+=0.5;}if(s){f+=1.5;}return f*16;};
L.prototype._calculateAndSetLightBoxSize=function(i){var b,d=(20*16),e=(18*16),f=this._calculateFooterHeightInPx();b=this._pxToNumber(i.getHeight());this._width=Math.max(d,this._pxToNumber(i.getWidth()));this._height=Math.max(e,b+f);};
L.prototype._setImageSize=function(i,b,d){var f=this._calculateFooterHeightInPx(),e=this._getDimensions(b,d,f);i.setWidth(e.width+'px');i.setHeight(e.height+'px');};
L.prototype._getDimensions=function(i,b,f){var d=20*16,e=18*16,$=q(window),w=$.height(),g=$.width(),m=c(),h=Math.max(g-m,d),j=Math.max(w-m,e),s;j-=f;if(b<=j){if(i<=h){}else{b*=h/i;i=h;}}else{if(i<=h){i*=j/b;b=j;}else{s=Math.max(i/h,b/j);i/=s;b/=s;}}return{width:Math.round(i),height:Math.round(b)};};
L.prototype._pxToNumber=function(s){return(s.substring(0,(s.length-2)))*1;};
L.prototype._getImageContent=function(){var r=this.getAggregation('imageContent');return r&&r[0];};
function c(){var s=sap.ui.Device.system;if(s.desktop){return 4*16;}if(s.tablet){return 2*16;}return 0;}
return L;},true);
sap.ui.predefine('sap/m/LightBoxItem',['jquery.sap.global','./library','sap/ui/core/Element','./Image','./Text'],function(q,l,E,I,T){"use strict";
var L=E.extend("sap.m.LightBoxItem",{metadata:{library:"sap.m",properties:{imageSrc:{type:'sap.ui.core.URI',group:'Appearance',multiple:false,defaultValue:''},alt:{type:'string',group:'Appearance',multiple:false,defaultValue:''},title:{type:'string',group:'Appearance',multiple:false,defaultValue:''},subtitle:{type:'string',group:'Appearance',multiple:false,defaultValue:''}},aggregations:{_image:{type:'sap.m.Image',multiple:false,visibility:'hidden'},_title:{type:'sap.m.Text',multiple:false,visibility:'hidden'},_subtitle:{type:'sap.m.Text',multiple:false,visibility:'hidden'}}}});
L.prototype.init=function(){this._createNativeImage();this.setAggregation('_image',new I({decorative:false,densityAware:false}),true);this.setAggregation('_title',new T({wrapping:false}),true);this.setAggregation('_subtitle',new T({wrapping:false}),true);};
L.prototype._createNativeImage=function(){var t=this;this._imageState=sap.m.LightBoxLoadingStates.Loading;this._oImage=new window.Image();this._oImage.onload=function(e){if(this.complete&&t._imageState===sap.m.LightBoxLoadingStates.Loading){t._setImageState(sap.m.LightBoxLoadingStates.Loaded);}};this._oImage.onerror=function(e){t._setImageState(sap.m.LightBoxLoadingStates.Error);};};
L.prototype.exit=function(){this._oImage=null;};
L.prototype._setImageState=function(i){if(i!==this._imageState){this._imageState=i;if(this.getParent()){this.getParent()._imageStateChanged(i);}}};
L.prototype._getImageState=function(){return this._imageState;};
L.prototype._getNativeImage=function(){return this._oImage;};
L.prototype.setImageSrc=function(i){var o=this.getAggregation("_image"),a=this.getParent();if(this.getImageSrc()===i){return this;}this._imageState=sap.m.LightBoxLoadingStates.Loading;if(a&&a._oPopup.getOpenState()===sap.ui.core.OpenState.OPEN){this._oImage.src=i;}this.setProperty("imageSrc",i,false);o.setSrc(i);return this;};
L.prototype.setAlt=function(a){var i=this.getAggregation("_image");this.setProperty("alt",a,false);i.setAlt(a);return this;};
L.prototype.setTitle=function(t){var o=this.getAggregation("_title");this.setProperty("title",t,false);o.setText(t);return this;};
L.prototype.setSubtitle=function(s){var S=this.getAggregation("_subtitle");this.setProperty("subtitle",s,false);S.setText(s);return this;};
return L;},true);
sap.ui.predefine('sap/m/LightBoxRenderer',['jquery.sap.global'],function(q){'use strict';var L={};var c='sapMLightBox';var a='sapMLightBoxTwoLines';var b='sapMLightBoxImageContainer';var d='sapMLightBoxImageContainerTwoHeaders';var e='sapMLightBoxError';var f='sapMLightBoxErrorContainer';var g='sapMLightBoxErrorContainerTwoHeaders';var h='sapMLightBoxFooter';var i='sapContrast';var j='sapContrastPlus';var k='sapMLightBoxTitleSection';var l='sapMLightBoxTitle';var m='sapMLightBoxSubtitle';var n='sapMLightBoxFooterTwoLines';
L.render=function(r,C){var o=C._getImageContent();var p=o._getImageState();r.write('<div');r.writeControlData(C);r.addClass(c);if(o.getSubtitle()){r.addClass(a);}if(p!==sap.m.LightBoxLoadingStates.Error){r.addStyle('width',C._width+'px');r.addStyle('height',C._height+'px');}else{r.addClass(e);}r.writeClasses();r.writeStyles();r.write('>');if(p===sap.m.LightBoxLoadingStates.Loading){this.renderBusyState(r,C);}else if(p===sap.m.LightBoxLoadingStates.TimeOutError||p===sap.m.LightBoxLoadingStates.Error){this.renderError(r,C);}else{this.renderImage(r,C);}this.renderFooter(r,C,o);r.write('</div>');C._isRendering=false;};
L.renderImage=function(r,C){var o=C._getImageContent();if(o.getSubtitle()){r.write('<div class="'+d+'">');}else{r.write('<div class="'+b+'">');}r.renderControl(o.getAggregation('_image'));r.write('</div>');};
L.renderError=function(r,C){var o=C._getImageContent(),v=C.getAggregation('_verticalLayout');if(o.getSubtitle()){r.write('<div class="'+g+'">');}else{r.write('<div class="'+f+'">');}r.renderControl(v);r.write('</div>');};
L.renderBusyState=function(r,C){r.renderControl(new sap.m.BusyIndicator());};
L.renderFooter=function(r,C,I){var t=I.getAggregation("_title"),s=I.getAggregation("_subtitle");r.write('<div');r.addClass(h);r.addClass(i);r.addClass(j);if(I.getSubtitle()){r.addClass(n);}r.writeClasses();r.write('>');r.write('<div class="'+k+'">');if(t){r.renderControl(t.addStyleClass(l));}if(s&&s.getText()){r.renderControl(s.addStyleClass(m));}r.write('</div>');r.renderControl(C._getCloseButton());r.write('</div>');};
return L;},true);
sap.ui.predefine('sap/m/Link',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/InvisibleText','sap/ui/core/EnabledPropagator','sap/ui/core/LabelEnablement'],function(q,l,C,I,E,L){"use strict";
var a=C.extend("sap.m.Link",{metadata:{interfaces:["sap.ui.core.IShrinkable"],library:"sap.m",properties:{text:{type:"string",group:"Data",defaultValue:''},enabled:{type:"boolean",group:"Behavior",defaultValue:true},target:{type:"string",group:"Behavior",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},href:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},wrapping:{type:"boolean",group:"Appearance",defaultValue:false},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:sap.ui.core.TextAlign.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},subtle:{type:"boolean",group:"Behavior",defaultValue:false},emphasized:{type:"boolean",group:"Behavior",defaultValue:false}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{allowPreventDefault:true}}}});
E.call(a.prototype);
a.prototype.onBeforeRendering=function(){this.removeAssociation("ariaLabelledBy",this.getId(),true);if(this.getAriaLabelledBy().length>0||L.getReferencingLabels(this).length>0){this.addAssociation("ariaLabelledBy",this.getId(),true);}};
a.prototype.onsapspace=function(e){this._handlePress(e);if(this.getHref()&&!e.isDefaultPrevented()){e.preventDefault();e.setMarked();var c=document.createEvent('MouseEvents');c.initEvent('click',false,true);this.getDomRef().dispatchEvent(c);}};
a.prototype._handlePress=function(e){if(this.getEnabled()){e.setMarked();if(!this.firePress()||!this.getHref()){e.preventDefault();}}else{e.preventDefault();}};
if(sap.ui.Device.support.touch){a.prototype.ontap=a.prototype._handlePress;}else{a.prototype.onclick=a.prototype._handlePress;}
a.prototype.ontouchstart=function(e){if(this.getEnabled()){e.setMarked();}};
a.prototype.setText=function(t){this.setProperty("text",t,true);t=this.getProperty("text");this.$().text(t);return this;};
a.prototype.setHref=function(u){this.setProperty("href",u,true);if(this.getEnabled()){u=this.getProperty("href");this.$().attr("href",u);}return this;};
a.prototype.setSubtle=function(s){this.setProperty("subtle",s,true);var $=this.$();if($.length){$.toggleClass("sapMLnkSubtle",s);if(s){a._addToDescribedBy($,this._sAriaLinkSubtleId);}else{a._removeFromDescribedBy($,this._sAriaLinkSubtleId);}}if(s&&!a.prototype._sAriaLinkSubtleId){a.prototype._sAriaLinkSubtleId=a._getARIAInvisibleTextId("LINK_SUBTLE");}return this;};
a.prototype.setEmphasized=function(e){this.setProperty("emphasized",e,true);var $=this.$();if($.length){$.toggleClass("sapMLnkEmphasized",e);if(e){a._addToDescribedBy($,this._sAriaLinkEmphasizedId);}else{a._removeFromDescribedBy($,this._sAriaLinkEmphasizedId);}}if(e&&!a.prototype._sAriaLinkEmphasizedId){a.prototype._sAriaLinkEmphasizedId=a._getARIAInvisibleTextId("LINK_EMPHASIZED");}return this;};
a.prototype.setWrapping=function(w){this.setProperty("wrapping",w,true);this.$().toggleClass("sapMLnkWrapping",w);return this;};
a.prototype.setEnabled=function(e){if(e!==this.getProperty("enabled")){this.setProperty("enabled",e,true);var $=this.$();$.toggleClass("sapMLnkDsbl",!e);if(e){$.attr("disabled",false);$.attr("tabindex","0");$.removeAttr("aria-disabled");if(this.getHref()){$.attr("href",this.getHref());}}else{$.attr("disabled",true);$.attr("tabindex","-1");$.attr("aria-disabled",true);$.attr("href","javascript:void(0);");}}return this;};
a.prototype.setWidth=function(w){this.setProperty("width",w,true);this.$().toggleClass("sapMLnkMaxWidth",!w);this.$().css("width",w);return this;};
a.prototype.setTarget=function(t){this.setProperty("target",t,true);if(!t){this.$().removeAttr("target");}else{this.$().attr("target",t);}return this;};
a._getResourceBundle=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m");};
a._getARIAInvisibleTextId=function(r){var R=a._getResourceBundle();return new I({text:R.getText(r)}).toStatic().getId();};
a._addToDescribedBy=function($,i){var A=$.attr("aria-describedby");if(A){$.attr("aria-describedby",A+" "+i);}else{$.attr("aria-describedby",i);}};
a._removeFromDescribedBy=function($,i){var A=$.attr("aria-describedby");if(A&&A.indexOf(i)!==-1){A=A.replace(i,'');if(A.length>1){$.attr("aria-describedby",A);}else{$.removeAttr("aria-describedby");}}};
a.prototype.getAccessibilityInfo=function(){return{role:"link",type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_LINK"),description:this.getText()||this.getHref()||"",focusable:this.getEnabled(),enabled:this.getEnabled()};};
return a;},true);
sap.ui.predefine('sap/m/LinkRenderer',['jquery.sap.global','sap/ui/core/Renderer'],function(q,R){"use strict";var L={};
L.render=function(r,c){var t=c.getTextDirection(),T=R.getTextAlign(c.getTextAlign(),t),a={role:'link'};r.write("<a");r.writeControlData(c);r.addClass("sapMLnk");if(c.getSubtle()){r.addClass("sapMLnkSubtle");if(a.describedby){a.describedby+=" "+c._sAriaLinkSubtleId;}else{a.describedby=c._sAriaLinkSubtleId;}}if(c.getEmphasized()){r.addClass("sapMLnkEmphasized");if(a.describedby){a.describedby+=" "+c._sAriaLinkEmphasizedId;}else{a.describedby=c._sAriaLinkEmphasizedId;}}if(!c.getEnabled()){r.addClass("sapMLnkDsbl");r.writeAttribute("disabled","true");r.writeAttribute("tabIndex","-1");}else{r.writeAttribute("tabIndex","0");}if(c.getWrapping()){r.addClass("sapMLnkWrapping");}if(c.getTooltip_AsString()){r.writeAttributeEscaped("title",c.getTooltip_AsString());}if(c.getHref()&&c.getEnabled()){r.writeAttributeEscaped("href",c.getHref());}else{r.writeAttribute("href","javascript:void(0);");}if(c.getTarget()){r.writeAttributeEscaped("target",c.getTarget());}if(c.getWidth()){r.addStyle("width",c.getWidth());}else{r.addClass("sapMLnkMaxWidth");}if(T){r.addStyle("text-align",T);}if(t!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",t.toLowerCase());}r.writeAccessibilityState(c,a);r.writeClasses();r.writeStyles();r.write(">");this.renderText(r,c);r.write("</a>");};
L.renderText=function(r,c){r.writeEscaped(c.getText());};
return L;},true);
sap.ui.predefine('sap/m/List',['jquery.sap.global','./ListBase','./library'],function(q,L,l){"use strict";
var a=L.extend("sap.m.List",{metadata:{library:"sap.m",properties:{backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:sap.m.BackgroundDesign.Solid}},aggregations:{columns:{type:"sap.m.Column",multiple:true,singularName:"column",deprecated:true}}}});
a.prototype.onBeforeRendering=function(){if(L.prototype.onBeforeRendering){L.prototype.onBeforeRendering.call(this);}if(!this.getColumns().length||this._isColumnsIncompatible()){return;}q.sap.require("sap.m.Table");var p=sap.m.Table.prototype;Object.keys(p).forEach(function(k){this[k]=p[k];},this);if(!this.mProperties.hasOwnProperty("backgroundDesign")){this.setBackgroundDesign("Translucent");}};
a.prototype._isColumnsIncompatible=function(){return sap.ui.getCore().getConfiguration().getCompatibilityVersion("sapMListAsTable").compareTo("1.16")>=0;};
return a;},true);
sap.ui.predefine('sap/m/ListBase',['jquery.sap.global','./GroupHeaderListItem','./library','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation','sap/ui/core/theming/Parameters'],function(q,G,l,C,I,P){"use strict";
var L=C.extend("sap.m.ListBase",{metadata:{library:"sap.m",properties:{inset:{type:"boolean",group:"Appearance",defaultValue:false},headerText:{type:"string",group:"Misc",defaultValue:null},headerDesign:{type:"sap.m.ListHeaderDesign",group:"Appearance",defaultValue:sap.m.ListHeaderDesign.Standard,deprecated:true},footerText:{type:"string",group:"Misc",defaultValue:null},mode:{type:"sap.m.ListMode",group:"Behavior",defaultValue:sap.m.ListMode.None},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},includeItemInSelection:{type:"boolean",group:"Behavior",defaultValue:false},showUnread:{type:"boolean",group:"Misc",defaultValue:false},noDataText:{type:"string",group:"Misc",defaultValue:null},showNoData:{type:"boolean",group:"Misc",defaultValue:true},enableBusyIndicator:{type:"boolean",group:"Behavior",defaultValue:true},modeAnimationOn:{type:"boolean",group:"Misc",defaultValue:true},showSeparators:{type:"sap.m.ListSeparators",group:"Appearance",defaultValue:sap.m.ListSeparators.All},swipeDirection:{type:"sap.m.SwipeDirection",group:"Misc",defaultValue:sap.m.SwipeDirection.Both},growing:{type:"boolean",group:"Behavior",defaultValue:false},growingThreshold:{type:"int",group:"Misc",defaultValue:20},growingTriggerText:{type:"string",group:"Appearance",defaultValue:null},growingScrollToLoad:{type:"boolean",group:"Behavior",defaultValue:false},growingDirection:{type:"sap.m.ListGrowingDirection",group:"Behavior",defaultValue:sap.m.ListGrowingDirection.Downwards},rememberSelections:{type:"boolean",group:"Behavior",defaultValue:true},keyboardMode:{type:"sap.m.ListKeyboardMode",group:"Behavior",defaultValue:sap.m.ListKeyboardMode.Navigation}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.ListItemBase",multiple:true,singularName:"item",bindable:"bindable"},swipeContent:{type:"sap.ui.core.Control",multiple:false},headerToolbar:{type:"sap.m.Toolbar",multiple:false},infoToolbar:{type:"sap.m.Toolbar",multiple:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{deprecated:true,parameters:{listItem:{type:"sap.m.ListItemBase"}}},selectionChange:{parameters:{listItem:{type:"sap.m.ListItemBase"},listItems:{type:"sap.m.ListItemBase[]"},selected:{type:"boolean"}}},"delete":{parameters:{listItem:{type:"sap.m.ListItemBase"}}},swipe:{allowPreventDefault:true,parameters:{listItem:{type:"sap.m.ListItemBase"},swipeContent:{type:"sap.ui.core.Control"},srcControl:{type:"sap.ui.core.Control"}}},growingStarted:{deprecated:true,parameters:{actual:{type:"int"},total:{type:"int"}}},growingFinished:{deprecated:true,parameters:{actual:{type:"int"},total:{type:"int"}}},updateStarted:{parameters:{reason:{type:"string"},actual:{type:"int"},total:{type:"int"}}},updateFinished:{parameters:{reason:{type:"string"},actual:{type:"int"},total:{type:"int"}}},itemPress:{parameters:{listItem:{type:"sap.m.ListItemBase"},srcControl:{type:"sap.ui.core.Control"}}}}}});
L.prototype.sNavItemClass="sapMLIB";
L.prototype.init=function(){this._oGrowingDelegate=null;this._bSelectionMode=false;this._bReceivingData=false;this._oSelectedItem=null;this._aSelectedPaths=[];this._aNavSections=[];this._bUpdating=false;this._bRendering=false;this._bActiveItem=false;this.data("sap-ui-fastnavgroup","true",true);};
L.prototype.onBeforeRendering=function(){this._bRendering=true;this._bActiveItem=false;this._aNavSections=[];this._removeSwipeContent();};
L.prototype.onAfterRendering=function(){this._bRendering=false;this._sLastMode=this.getMode();if(sap.ui.Device.system.desktop){this._bItemNavigationInvalidated=true;}};
L.prototype.exit=function(){this._oSelectedItem=null;this._aNavSections=[];this._aSelectedPaths=[];this._destroyGrowingDelegate();this._destroyItemNavigation();};
L.prototype.refreshItems=function(r){this._showBusyIndicator();if(this._oGrowingDelegate){this._oGrowingDelegate.refreshItems(r);}else{if(!this._bReceivingData){this._updateStarted(r);this._bReceivingData=true;}this.refreshAggregation("items");}};
L.prototype.updateItems=function(r){if(this._oGrowingDelegate){this._oGrowingDelegate.updateItems(r);}else{if(this._bReceivingData){this._bReceivingData=false;}else{this._updateStarted(r);}this.updateAggregation("items");this._updateFinished();}};
L.prototype.setBindingContext=function(){this._resetItemsBinding();return C.prototype.setBindingContext.apply(this,arguments);};
L.prototype._bindAggregation=function(n){n=="items"&&this._resetItemsBinding();return C.prototype._bindAggregation.apply(this,arguments);};
L.prototype.destroyItems=function(s){if(!this.getItems(true).length){return this;}this._oSelectedItem=null;this.destroyAggregation("items","KeepDom");if(!s){this.invalidate();}return this;};
L.prototype.removeAllItems=function(a){this._oSelectedItem=null;return this.removeAllAggregation("items");};
L.prototype.removeItem=function(i){var o=this.removeAggregation("items",i);if(o&&o===this._oSelectedItem){this._oSelectedItem=null;}return o;};
L.prototype.getItems=function(r){if(r){return this.mAggregations["items"]||[];}return this.getAggregation("items",[]);};
L.prototype.getId=function(s){var i=this.sId;return s?i+"-"+s:i;};
L.prototype.setGrowing=function(g){g=!!g;if(this.getGrowing()!=g){this.setProperty("growing",g,!g);if(g){q.sap.require("sap.m.GrowingEnablement");this._oGrowingDelegate=new sap.m.GrowingEnablement(this);}else if(this._oGrowingDelegate){this._oGrowingDelegate.destroy();this._oGrowingDelegate=null;}}return this;};
L.prototype.setGrowingThreshold=function(t){return this.setProperty("growingThreshold",t,true);};
L.prototype.setEnableBusyIndicator=function(e){this.setProperty("enableBusyIndicator",e,true);if(!this.getEnableBusyIndicator()){this._hideBusyIndicator();}return this;};
L.prototype.setNoDataText=function(n){this.setProperty("noDataText",n,true);this.$("nodata-text").text(this.getNoDataText());return this;};
L.prototype.getNoDataText=function(c){if(c&&this._bBusy){return"";}var n=this.getProperty("noDataText");n=n||sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LIST_NO_DATA");return n;};
L.prototype.getSelectedItem=function(){var a=this.getItems(true);for(var i=0;i<a.length;i++){if(a[i].getSelected()){return a[i];}}return null;};
L.prototype.setSelectedItem=function(o,s,f){if(this.indexOfItem(o)<0){q.sap.log.warning("setSelectedItem is called without valid ListItem parameter on "+this);return;}if(this._bSelectionMode){o.setSelected((s===undefined)?true:!!s);f&&this._fireSelectionChangeEvent([o]);}};
L.prototype.getSelectedItems=function(){return this.getItems(true).filter(function(i){return i.getSelected();});};
L.prototype.setSelectedItemById=function(i,s){var o=sap.ui.getCore().byId(i);return this.setSelectedItem(o,s);};
L.prototype.getSelectedContexts=function(a){var b=this.getBindingInfo("items"),m=(b||{}).model,M=this.getModel(m);if(!b||!M){return[];}if(a&&this.getRememberSelections()){return this._aSelectedPaths.map(function(p){return M.getContext(p);});}return this.getSelectedItems().map(function(i){return i.getBindingContext(m);});};
L.prototype.removeSelections=function(a,f,d){var c=[];this._oSelectedItem=null;a&&(this._aSelectedPaths=[]);this.getItems(true).forEach(function(i){if(!i.getSelected()){return;}if(d&&i.isSelectedBoundTwoWay()){return;}i.setSelected(false,true);c.push(i);!a&&this._updateSelectedPaths(i);},this);if(f&&c.length){this._fireSelectionChangeEvent(c);}return this;};
L.prototype.selectAll=function(f){if(this.getMode()!="MultiSelect"){return this;}var c=[];this.getItems(true).forEach(function(i){if(!i.getSelected()){i.setSelected(true,true);c.push(i);this._updateSelectedPaths(i);}},this);if(f&&c.length){this._fireSelectionChangeEvent(c);}return this;};
sap.m.ListBase.prototype.getLastMode=function(m){return this._sLastMode;};
L.prototype.setMode=function(m){m=this.validateProperty("mode",m);var o=this.getMode();if(o==m){return this;}this._bSelectionMode=m.indexOf("Select")>-1;if(!this._bSelectionMode){this.removeSelections(true);}else{var s=this.getSelectedItems();if(s.length>1){this.removeSelections(true);}else if(o===sap.m.ListMode.MultiSelect){this._oSelectedItem=s[0];}}return this.setProperty("mode",m);};
L.prototype.getGrowingInfo=function(){return this._oGrowingDelegate?this._oGrowingDelegate.getInfo():null;};
L.prototype.setRememberSelections=function(r){this.setProperty("rememberSelections",r,true);!this.getRememberSelections()&&(this._aSelectedPaths=[]);return this;};
sap.m.ListBase.prototype.setSelectedContextPaths=function(s){this._aSelectedPaths=s||[];};
sap.m.ListBase.prototype.getSelectedContextPaths=function(){return this._aSelectedPaths.slice(0);};
L.prototype.isAllSelectableSelected=function(){var i=this.getItems(true),s=this.getSelectedItems().length,S=i.filter(function(o){return o.isSelectable();}).length;return i.length>0&&s==S;};
L.prototype.getVisibleItems=function(){return this.getItems(true).filter(function(i){return i.getVisible();});};
L.prototype.getActiveItem=function(){return this._bActiveItem;};
L.prototype.onItemDOMUpdate=function(o){if(!this._bRendering&&this.bOutput){this._startItemNavigation(true);}};
L.prototype.onItemActiveChange=function(o,a){this._bActiveItem=a;};
L.prototype.onItemSelectedChange=function(o,s){if(this.getMode()==sap.m.ListMode.MultiSelect){this._updateSelectedPaths(o,s);return;}if(s){this._aSelectedPaths=[];this._oSelectedItem&&this._oSelectedItem.setSelected(false,true);this._oSelectedItem=o;}else if(this._oSelectedItem===o){this._oSelectedItem=null;}this._updateSelectedPaths(o,s);};
L.prototype.getItemsContainerDomRef=function(){return this.getDomRef("listUl");};
L.prototype.checkGrowingFromScratch=function(){};
L.prototype.onBeforePageLoaded=function(g,c){this._fireUpdateStarted(c,g);this.fireGrowingStarted(g);};
L.prototype.onAfterPageLoaded=function(g,c){this._fireUpdateFinished(g);this.fireGrowingFinished(g);};
L.prototype.addNavSection=function(i){this._aNavSections.push(i);return i;};
L.prototype.getMaxItemsCount=function(){var b=this.getBinding("items");if(b&&b.getLength){return b.getLength()||0;}return this.getItems(true).length;};
L.prototype.shouldRenderItems=function(){return true;};
L.prototype._resetItemsBinding=function(){if(this.isBound("items")){this._bUpdating=false;this._bReceivingData=false;this.removeSelections(true,false,true);this._oGrowingDelegate&&this._oGrowingDelegate.reset();this._hideBusyIndicator();if(this._oItemNavigation){this._oItemNavigation.iFocusedIndex=-1;}}};
L.prototype._updateStarted=function(r){if(!this._bReceivingData&&!this._bUpdating){this._bUpdating=true;this._fireUpdateStarted(r);}};
L.prototype._fireUpdateStarted=function(r,i){this._sUpdateReason=q.sap.charToUpperCase(r||"Refresh");this.fireUpdateStarted({reason:this._sUpdateReason,actual:i?i.actual:this.getItems(true).length,total:i?i.total:this.getMaxItemsCount()});};
L.prototype._updateFinished=function(){if(!this._bReceivingData&&this._bUpdating){this._fireUpdateFinished();this._bUpdating=false;}};
L.prototype._fireUpdateFinished=function(i){this._hideBusyIndicator();q.sap.delayedCall(0,this,function(){this._bItemNavigationInvalidated=true;this.fireUpdateFinished({reason:this._sUpdateReason,actual:i?i.actual:this.getItems(true).length,total:i?i.total:this.getMaxItemsCount()});});};
L.prototype._showBusyIndicator=function(){if(this.getEnableBusyIndicator()&&!this.getBusy()&&!this._bBusy){this._bBusy=true;this._sBusyTimer=q.sap.delayedCall(this.getBusyIndicatorDelay(),this,function(){this.$("nodata-text").text("");});this.setBusy(true,"listUl");}};
L.prototype._hideBusyIndicator=function(){if(this._bBusy){this._bBusy=false;this.setBusy(false,"listUl");q.sap.clearDelayedCall(this._sBusyTimer);if(!this.getItems(true).length){this.$("nodata-text").text(this.getNoDataText());}}};
L.prototype.onItemBindingContextSet=function(i){if(!this._bSelectionMode||!this.getRememberSelections()||!this.isBound("items")){return;}if(i.isSelectedBoundTwoWay()){return;}var p=i.getBindingContextPath();if(p){var s=(this._aSelectedPaths.indexOf(p)>-1);i.setSelected(s);}};
L.prototype.onItemInserted=function(i,s){if(s){this.onItemSelectedChange(i,true);}if(!this._bSelectionMode||!this._aSelectedPaths.length||!this.getRememberSelections()||!this.isBound("items")||i.isSelectedBoundTwoWay()||i.getSelected()){return;}var p=i.getBindingContextPath();if(p&&this._aSelectedPaths.indexOf(p)>-1){i.setSelected(true);}};
L.prototype.onItemSelect=function(o,s){if(this.getMode()==sap.m.ListMode.MultiSelect){this._fireSelectionChangeEvent([o]);}else if(this._bSelectionMode&&s){this._fireSelectionChangeEvent([o]);}};
L.prototype._fireSelectionChangeEvent=function(a){var o=a&&a[0];if(!o){return;}this.fireSelectionChange({listItem:o,listItems:a,selected:o.getSelected()});this.fireSelect({listItem:o});};
L.prototype.onItemDelete=function(o){this.fireDelete({listItem:o});};
L.prototype.onItemPress=function(o,s){if(o.getType()==sap.m.ListType.Inactive){return;}q.sap.delayedCall(0,this,function(){this.fireItemPress({listItem:o,srcControl:s});});};
L.prototype._updateSelectedPaths=function(i,s){if(!this.getRememberSelections()||!this.isBound("items")){return;}var p=i.getBindingContextPath();if(!p){return;}s=(s===undefined)?i.getSelected():s;var a=this._aSelectedPaths.indexOf(p);if(s){a<0&&this._aSelectedPaths.push(p);}else{a>-1&&this._aSelectedPaths.splice(a,1);}};
L.prototype._destroyGrowingDelegate=function(){if(this._oGrowingDelegate){this._oGrowingDelegate.destroy();this._oGrowingDelegate=null;}};
L.prototype._destroyItemNavigation=function(){if(this._oItemNavigation){this.removeEventDelegate(this._oItemNavigation);this._oItemNavigation.destroy();this._oItemNavigation=null;}};
L.prototype._getTouchBlocker=function(){return this.$().children();};
L.prototype._getSwipeContainer=function(){return this._$swipeContainer||(q.sap.require("sap.m.InstanceManager"),this._$swipeContainer=q("<div>",{"id":this.getId("swp"),"class":"sapMListSwp"}));};
L.prototype._setSwipePosition=function(){if(this._isSwipeActive){return this._getSwipeContainer().css("top",this._swipedItem.$().position().top);}};
L.prototype._renderSwipeContent=function(){var $=this._swipedItem.$(),a=this._getSwipeContainer();this.$().prepend(a.css({top:$.position().top,height:$.outerHeight(true)}));if(this._bRerenderSwipeContent){this._bRerenderSwipeContent=false;var r=sap.ui.getCore().createRenderManager();r.render(this.getSwipeContent(),a.empty()[0]);r.destroy();}return this;};
L.prototype._swipeIn=function(){var t=this,$=t._getTouchBlocker(),a=t._getSwipeContainer();t._isSwipeActive=true;t._renderSwipeContent();sap.m.InstanceManager.addDialogInstance(t);window.document.activeElement.blur();q(window).on("resize.swp",function(){t._setSwipePosition();});$.css("pointer-events","none").on("touchstart.swp mousedown.swp",function(e){if(!a[0].firstChild.contains(e.target)){e.preventDefault();e.stopPropagation();}});a.bind("webkitAnimationEnd animationend",function(){q(this).unbind("webkitAnimationEnd animationend");a.css("opacity",1).focus();$.parent().on("touchend.swp touchcancel.swp mouseup.swp",function(e){if(!a[0].firstChild.contains(e.target)){t.swipeOut();}});}).removeClass("sapMListSwpOutAnim").addClass("sapMListSwpInAnim");};
L.prototype._onSwipeOut=function(c){this._getSwipeContainer().css("opacity",0).remove();q(window).off("resize.swp");this._getTouchBlocker().css("pointer-events","auto").off("touchstart.swp mousedown.swp");if(typeof c=="function"){c.call(this,this._swipedItem,this.getSwipeContent());}this._isSwipeActive=false;sap.m.InstanceManager.removeDialogInstance(this);};
L.prototype.swipeOut=function(c){if(!this._isSwipeActive){return this;}var t=this,$=this._getSwipeContainer();this._getTouchBlocker().parent().off("touchend.swp touchend.swp touchcancel.swp mouseup.swp");$.bind("webkitAnimationEnd animationend",function(){q(this).unbind("webkitAnimationEnd animationend");t._onSwipeOut(c);}).removeClass("sapMListSwpInAnim").addClass("sapMListSwpOutAnim");return this;};
L.prototype._removeSwipeContent=function(){if(this._isSwipeActive){this.swipeOut()._onSwipeOut();}};
L.prototype.close=L.prototype._removeSwipeContent;
L.prototype._onSwipe=function(e){var c=this.getSwipeContent(),s=e.srcControl;if(c&&s&&!this._isSwipeActive&&this!==s&&!this._eventHandledByControl&&(sap.ui.Device.support.touch||(sap.ui.Device.os.windows&&sap.ui.Device.os.version>=8))){for(var a=s;a&&!(a instanceof sap.m.ListItemBase);a=a.oParent);if(a instanceof sap.m.ListItemBase){this._swipedItem=a;this.fireSwipe({listItem:this._swipedItem,swipeContent:c,srcControl:s},true)&&this._swipeIn();}}};
L.prototype.ontouchstart=function(e){this._eventHandledByControl=e.isMarked();};
L.prototype.onswipeleft=function(e){var a=sap.ui.getCore().getConfiguration().getRTL()?"RightToLeft":"LeftToRight";if(this.getSwipeDirection()!=a){this._onSwipe(e);}};
L.prototype.onswiperight=function(e){var a=sap.ui.getCore().getConfiguration().getRTL()?"LeftToRight":"RightToLeft";if(this.getSwipeDirection()!=a){this._onSwipe(e);}};
L.prototype.setSwipeDirection=function(d){return this.setProperty("swipeDirection",d,true);};
L.prototype.getSwipedItem=function(){return(this._isSwipeActive?this._swipedItem:null);};
L.prototype.setSwipeContent=function(c){this._bRerenderSwipeContent=true;this.toggleStyleClass("sapMListSwipable",!!c);return this.setAggregation("swipeContent",c,!this._isSwipeActive);};
L.prototype.invalidate=function(o){if(o&&o===this.getSwipeContent()){this._bRerenderSwipeContent=true;this._isSwipeActive&&this._renderSwipeContent();return this;}C.prototype.invalidate.apply(this,arguments);return this;};
L.prototype.addItemGroup=function(g,h,s){h=h||new G({title:g.text||g.key});h._bGroupHeader=true;this.addAggregation("items",h,s);return h;};
L.prototype.removeGroupHeaders=function(s){this.getItems(true).forEach(function(i){if(i.isGroupHeader()){i.destroy(s);}});};
L.prototype.getRole=function(){var m=this.getMode(),M=sap.m.ListMode;return(m==M.None||m==M.Delete)?"list":"listbox";};
L.prototype.onNavigationItemFocus=function(e){var i=e.getParameter("index"),a=this._oItemNavigation.getItemDomRefs(),o=a[i],s=a.length,b=this.getBinding("items");if(this.getGrowing()&&this.getGrowingScrollToLoad()&&b&&b.isLengthFinal()){s=b.getLength();if(b.isGrouped()){s+=this.getItems(true).filter(function(c){return c.isGroupHeader()&&c.getVisible();}).length;}}this.getNavigationRoot().setAttribute("aria-activedescendant",o.id);o.setAttribute("aria-posinset",i+1);o.setAttribute("aria-setsize",s);};
L.prototype.getNavigationRoot=function(){return this.getDomRef("listUl");};
L.prototype.getFocusDomRef=function(){return this.getNavigationRoot();};
L.prototype._startItemNavigation=function(i){if(!sap.ui.Device.system.desktop){return;}var k=this.getKeyboardMode(),K=sap.m.ListKeyboardMode;if(k==K.Edit&&!this.getItems(true).length){return;}if(i&&!this.getNavigationRoot().contains(document.activeElement)){this._bItemNavigationInvalidated=true;return;}if(!this._oItemNavigation){this._oItemNavigation=new I();this._oItemNavigation.setCycling(false);this.addEventDelegate(this._oItemNavigation);var t=(k==K.Edit)?-1:0;this._setItemNavigationTabIndex(t);this._oItemNavigation.setTableMode(true,true).setColumns(1);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});this._oItemNavigation.attachEvent(I.Events.BeforeFocus,this.onNavigationItemFocus,this);}this._oItemNavigation.setPageSize(this.getGrowingThreshold());var n=this.getNavigationRoot();this._oItemNavigation.setRootDomRef(n);this.setNavigationItems(this._oItemNavigation,n);this._bItemNavigationInvalidated=false;};
L.prototype.setNavigationItems=function(i,n){var N=q(n).children(".sapMLIB").get();i.setItemDomRefs(N);if(i.getFocusedIndex()==-1){if(this.getGrowing()&&this.getGrowingDirection()==sap.m.ListGrowingDirection.Upwards){i.setFocusedIndex(N.length-1);}else{i.setFocusedIndex(0);}}};
L.prototype.getItemNavigation=function(){return this._oItemNavigation;};
L.prototype._setItemNavigationTabIndex=function(t){if(this._oItemNavigation){this._oItemNavigation.iActiveTabIndex=t;this._oItemNavigation.iTabIndex=t;}};
L.prototype.setKeyboardMode=function(k){this.setProperty("keyboardMode",k,true);if(this.isActive()){var t=(k==sap.m.ListKeyboardMode.Edit)?-1:0;this.$("listUl").prop("tabIndex",t);this.$("after").prop("tabIndex",t);this._setItemNavigationTabIndex(t);}return this;};
L.prototype.setItemFocusable=function(o){if(!this._oItemNavigation){return;}var i=this._oItemNavigation.getItemDomRefs();var a=i.indexOf(o.getDomRef());if(a>=0){this._oItemNavigation.setFocusedIndex(a);}};
L.prototype.forwardTab=function(f){this._bIgnoreFocusIn=true;this.$(f?"after":"before").focus();};
L.prototype.onsaptabnext=function(e){if(e.isMarked()||this.getKeyboardMode()==sap.m.ListKeyboardMode.Edit){return;}if(e.target.id==this.getId("nodata")){this.forwardTab(true);e.setMarked();}};
L.prototype.onsaptabprevious=function(e){if(e.isMarked()||this.getKeyboardMode()==sap.m.ListKeyboardMode.Edit){return;}var t=e.target.id;if(t==this.getId("nodata")){this.forwardTab(false);}else if(t==this.getId("trigger")){this.focusPrevious();e.preventDefault();}};
L.prototype._navToSection=function(f){var t;var i=0;var s=f?1:-1;var a=this._aNavSections.length;this._aNavSections.some(function(S,b){var d=q.sap.domById(S);if(d&&d.contains(document.activeElement)){i=b;return true;}});var o=this.getItemsContainerDomRef();var c=q.sap.byId(this._aNavSections[i]);if(c[0]===o&&this._oItemNavigation){c.data("redirect",this._oItemNavigation.getFocusedIndex());}this._aNavSections.some(function(){i=(i+s+a)%a;t=q.sap.byId(this._aNavSections[i]);if(t[0]===o&&this._oItemNavigation){var r=t.data("redirect");var b=this._oItemNavigation.getItemDomRefs();var T=b[r]||o.children[0];t=q(T);}if(t.is(":focusable")){t.focus();return true;}},this);return t;};
L.prototype.onsapshow=function(e){if(e.isMarked()||e.which==q.sap.KeyCodes.F4||e.target.id!=this.getId("trigger")&&!q(e.target).hasClass(this.sNavItemClass)){return;}if(this._navToSection(true)){e.preventDefault();e.setMarked();}};
L.prototype.onsaphide=function(e){if(e.isMarked()||e.target.id!=this.getId("trigger")&&!q(e.target).hasClass(this.sNavItemClass)){return;}if(this._navToSection(false)){e.preventDefault();e.setMarked();}};
L.prototype.onkeydown=function(e){var c=(e.which==q.sap.KeyCodes.A)&&(e.metaKey||e.ctrlKey);if(e.isMarked()||!c||!q(e.target).hasClass(this.sNavItemClass)){return;}e.preventDefault();if(this.getMode()!==sap.m.ListMode.MultiSelect){return;}if(this.isAllSelectableSelected()){this.removeSelections(false,true);}else{this.selectAll(true);}e.setMarked();};
L.prototype.onmousedown=function(e){if(this._bItemNavigationInvalidated){this._startItemNavigation();}};
L.prototype.focusPrevious=function(){if(!this._oItemNavigation){return;}var n=this._oItemNavigation.getItemDomRefs();var i=this._oItemNavigation.getFocusedIndex();var $=q(n[i]);var r=$.control(0)||{};var t=r.getTabbables?r.getTabbables():$.find(":sapTabbable");var f=t.eq(-1).add($).eq(-1);f.focus();};
L.prototype.onfocusin=function(e){if(this._bIgnoreFocusIn){this._bIgnoreFocusIn=false;e.stopImmediatePropagation(true);return;}if(this._bItemNavigationInvalidated){this._startItemNavigation();}if(e.isMarked()||!this._oItemNavigation||this.getKeyboardMode()==sap.m.ListKeyboardMode.Edit||e.target.id!=this.getId("after")){return;}this.focusPrevious();e.setMarked();};
L.prototype.onItemArrowUpDown=function(o,e){var i=this.getItems(true),a=i.indexOf(o)+(e.type=="sapup"?-1:1),b=i[a];if(b.isGroupHeader()){b=i[a+(e.type=="sapup"?-1:1)];}if(!b){return;}var t=b.getTabbables(),f=o.getTabbables().index(e.target),E=t.eq(t[f]?f:-1);E[0]?E.focus():b.focus();e.preventDefault();e.setMarked();};
return L;},true);
sap.ui.predefine('sap/m/ListBaseRenderer',['jquery.sap.global','sap/ui/core/theming/Parameters','./ListItemBaseRenderer'],function(q,P,L){"use strict";var a={};a.ModeOrder={None:0,Delete:1,MultiSelect:-1,SingleSelect:1,SingleSelectLeft:-1,SingleSelectMaster:0};
a.render=function(r,c){r.write("<div");r.addClass("sapMList");r.writeControlData(c);r.writeAttribute("tabindex","-1");if(c.getInset()){r.addClass("sapMListInsetBG");}if(c.getWidth()){r.addStyle("width",c.getWidth());}if(c.getBackgroundDesign){r.addClass("sapMListBG"+c.getBackgroundDesign());}var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}this.renderContainerAttributes(r,c);r.writeStyles();r.writeClasses();r.write(">");var h=c.getHeaderText();var H=c.getHeaderToolbar();if(H){H.setDesign(sap.m.ToolbarDesign.Transparent,true);H.addStyleClass("sapMListHdrTBar");r.renderControl(H);}else if(h){r.write("<header class='sapMListHdr'");r.writeAttribute("id",c.getId("header"));r.write(">");r.writeEscaped(h);r.write("</header>");}var I=c.getInfoToolbar();if(I){I.setDesign(sap.m.ToolbarDesign.Info,true);I.addStyleClass("sapMListInfoTBar");r.renderControl(I);}var b=c.getItems(),s=c.getShowNoData(),R=c.shouldRenderItems()&&b.length,T=c.getKeyboardMode()==sap.m.ListKeyboardMode.Edit?-1:0,u=c.getGrowingDirection()==sap.m.ListGrowingDirection.Upwards&&c.getGrowing();if(u){this.renderGrowing(r,c);}if(R||s){this.renderDummyArea(r,c,"before",-1);}this.renderListStartAttributes(r,c);r.writeAccessibilityState(c,this.getAccessibilityState(c));r.addClass("sapMListUl");r.writeAttribute("id",c.getId("listUl"));if(R||s){r.writeAttribute("tabindex",T);}r.addClass("sapMListShowSeparators"+c.getShowSeparators());r.addClass("sapMListMode"+c.getMode());c.getInset()&&r.addClass("sapMListInset");r.writeClasses();r.writeStyles();r.write(">");this.renderListHeadAttributes(r,c);if(R){if(u){b.reverse();}for(var i=0;i<b.length;i++){r.renderControl(b[i]);}}if(!R&&s){this.renderNoData(r,c);}this.renderListEndAttributes(r,c);if(R||s){this.renderDummyArea(r,c,"after",T);}if(!u){this.renderGrowing(r,c);}if(c.getFooterText()){r.write("<footer class='sapMListFtr'");r.writeAttribute("id",c.getId("footer"));r.write(">");r.writeEscaped(c.getFooterText());r.write("</footer>");}r.write("</div>");};
a.renderContainerAttributes=function(r,c){};
a.renderListHeadAttributes=function(r,c){};
a.renderListStartAttributes=function(r,c){r.write("<ul");c.addNavSection(c.getId("listUl"));};
a.getAriaRole=function(c){return"listbox";};
a.getAriaLabelledBy=function(c){var h=c.getHeaderToolbar();if(h){return h.getTitleId();}if(c.getHeaderText()){return c.getId("header");}};
a.getAriaDescribedBy=function(c){if(c.getFooterText()){return c.getId("footer");}};
a.getAccessibilityState=function(c){var m=sap.m.ListMode,M=c.getMode(),b;if(M==m.MultiSelect){b=true;}else if(M!=m.None&&M!=m.Delete){b=false;}return{role:this.getAriaRole(c),multiselectable:b,labelledby:{value:this.getAriaLabelledBy(c),append:true},describedby:{value:this.getAriaDescribedBy(c),append:true}};};
a.renderListEndAttributes=function(r,c){r.write("</ul>");};
a.renderNoData=function(r,c){r.write("<li");r.writeAttribute("tabindex",c.getKeyboardMode()==sap.m.ListKeyboardMode.Navigation?-1:0);r.writeAttribute("id",c.getId("nodata"));r.addClass("sapMLIB sapMListNoData sapMLIBTypeInactive");L.addFocusableClasses.call(L,r);r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMListNoDataText");r.writeAttribute("id",c.getId("nodata-text"));r.writeClasses();r.write(">");r.writeEscaped(c.getNoDataText(true));r.write("</div>");r.write("</li>");};
a.renderDummyArea=function(r,c,A,t){r.write("<div");r.writeAttribute("id",c.getId(A));r.writeAttribute("tabindex",t);if(sap.ui.Device.browser.msie){r.addClass("sapMListDummyArea").writeClasses();}r.write("></div>");};
a.renderGrowing=function(r,c){var g=c._oGrowingDelegate;if(!g){return;}g.render(r);};
return a;},true);
sap.ui.predefine('sap/m/ListItemBase',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/Icon'],function(q,l,C,I,a){"use strict";
var L=C.extend("sap.m.ListItemBase",{metadata:{library:"sap.m",properties:{type:{type:"sap.m.ListType",group:"Misc",defaultValue:sap.m.ListType.Inactive},visible:{type:"boolean",group:"Appearance",defaultValue:true},unread:{type:"boolean",group:"Misc",defaultValue:false},selected:{type:"boolean",defaultValue:false},counter:{type:"int",group:"Misc",defaultValue:null}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{tap:{deprecated:true},detailTap:{deprecated:true},press:{},detailPress:{}}}});
L.prototype.DetailIconURI=I.getIconURI("edit");L.prototype.DeleteIconURI=I.getIconURI("sys-cancel");L.prototype.NavigationIconURI=I.getIconURI("slim-arrow-right");
L.prototype.init=function(){this._active=false;this._bGroupHeader=false;};
L.prototype.onAfterRendering=function(){this.informList("DOMUpdate",true);};
L.prototype.getBindingContextPath=function(m){var o=this.getList();if(o&&!m){m=(o.getBindingInfo("items")||{}).model;}var c=this.getBindingContext(m);if(c){return c.getPath();}};
L.prototype.isSelectedBoundTwoWay=function(){var b=this.getBinding("selected");if(b&&b.getBindingMode()==sap.ui.model.BindingMode.TwoWay){return true;}};
L.prototype.getList=function(){var p=this.getParent();if(p instanceof sap.m.ListBase){return p;}};
L.prototype.getListProperty=function(p,f){var o=this.getList();if(o){p=q.sap.charToUpperCase(p);return o["get"+p]();}return f;};
L.prototype.informList=function(e,p,P){var o=this.getList();if(o){var m="onItem"+e;if(o[m]){o[m](this,p,P);}}};
L.prototype.informSelectedChange=function(s){var o=this.getList();if(o){o.onItemSelectedChange(this,s);this.bSelectedDelayed=undefined;}else{this.bSelectedDelayed=s;}};
L.prototype.getMode=function(){return this.getListProperty("mode","");};
L.prototype.updateAccessibilityState=function(A){var t=this.$();if(!t.length){return;}var i=t.parent().children(".sapMLIB");t.attr(q.extend({"aria-setsize":i.length,"aria-posinset":i.index(t)+1},A));};
L.prototype.getDeleteControl=function(){if(this._oDeleteControl){return this._oDeleteControl;}this._oDeleteControl=new a({id:this.getId()+"-imgDel",src:this.DeleteIconURI,useIconTooltip:false,noTabStop:true}).setParent(this,null,true).addStyleClass("sapMLIBIconDel").attachPress(function(e){this.informList("Delete");},this);return this._oDeleteControl;};
L.prototype.getDetailControl=function(){if(this._oDetailControl){return this._oDetailControl;}this._oDetailControl=new a({id:this.getId()+"-imgDet",src:this.DetailIconURI,useIconTooltip:false,noTabStop:true}).setParent(this,null,true).attachPress(function(){this.fireDetailTap();this.fireDetailPress();},this).addStyleClass("sapMLIBType sapMLIBIconDet");return this._oDetailControl;};
L.prototype.getNavigationControl=function(){if(this._oNavigationControl){return this._oNavigationControl;}this._oNavigationControl=new a({id:this.getId()+"-imgNav",src:this.NavigationIconURI,useIconTooltip:false,noTabStop:true}).setParent(this,null,true).addStyleClass("sapMLIBType sapMLIBImgNav");return this._oNavigationControl;};
L.prototype.getSingleSelectControl=function(){if(this._oSingleSelectControl){return this._oSingleSelectControl;}this._oSingleSelectControl=new sap.m.RadioButton({id:this.getId()+"-selectSingle",groupName:this.getListProperty("id")+"_selectGroup",activeHandling:false,selected:this.getSelected()}).setParent(this,null,true).setTabIndex(-1).attachSelect(function(e){var s=e.getParameter("selected");this.setSelected(s);this.informList("Select",s);},this);return this._oSingleSelectControl;};
L.prototype.getMultiSelectControl=function(){if(this._oMultiSelectControl){return this._oMultiSelectControl;}this._oMultiSelectControl=new sap.m.CheckBox({id:this.getId()+"-selectMulti",activeHandling:false,selected:this.getSelected()}).setParent(this,null,true).setTabIndex(-1).attachSelect(function(e){var s=e.getParameter("selected");this.setSelected(s);this.informList("Select",s);},this);return this._oMultiSelectControl;};
L.prototype.getModeControl=function(u){var m=this.getMode(),b=sap.m.ListMode;if(!m||m==b.None){return;}if(m==b.Delete){return this.getDeleteControl();}var s=null;if(m==b.MultiSelect){s=this.getMultiSelectControl();}else{s=this.getSingleSelectControl();}if(s&&u){s.setSelected(this.getSelected());}return s;};
L.prototype.getTypeControl=function(){var t=this.getType(),T=sap.m.ListType;if(t==T.Detail||t==T.DetailAndActive){return this.getDetailControl();}if(t==T.Navigation){return this.getNavigationControl();}};
L.prototype.destroyControls=function(c){c.forEach(function(s){s="_o"+s+"Control";if(this[s]){this[s].destroy("KeepDom");this[s]=null;}},this);};
L.prototype.isActionable=function(){return this.getListProperty("includeItemInSelection")||this.getMode()==sap.m.ListMode.SingleSelectMaster||(this.getType()!=sap.m.ListType.Inactive&&this.getType()!=sap.m.ListType.Detail);};
L.prototype.exit=function(){this._oLastFocused=null;this.setActive(false);this.destroyControls(["Delete","SingleSelect","MultiSelect","Detail","Navigation"]);};
L.prototype.isSelectable=function(){var m=this.getMode();return!(m==sap.m.ListMode.None||m==sap.m.ListMode.Delete);};
L.prototype.getSelected=function(){if(this.isSelectable()){return this.getProperty("selected");}return false;};
L.prototype.isSelected=L.prototype.getSelected;
L.prototype.setSelected=function(s,d){s=this.validateProperty("selected",s);if(!this.isSelectable()||s==this.getSelected()){return this;}if(!d){this.informSelectedChange(s);}var S=this.getModeControl();if(S){S.setSelected(s);}this.updateSelectedDOM(s,this.$());this.setProperty("selected",s,true);return this;};
L.prototype.updateSelectedDOM=function(s,t){t.toggleClass("sapMLIBSelected",s);t.attr("aria-selected",s);};
L.prototype.setParent=function(p){C.prototype.setParent.apply(this,arguments);if(!p){this._bGroupHeader=false;return;}this.informList("Inserted",this.bSelectedDelayed);return this;};
L.prototype.setBindingContext=function(){C.prototype.setBindingContext.apply(this,arguments);this.informList("BindingContextSet");return this;};
L.prototype.isGroupHeader=function(){return this._bGroupHeader;};
L.prototype.isIncludedIntoSelection=function(){var m=this.getMode(),M=sap.m.ListMode;return(m==M.SingleSelectMaster||(this.getListProperty("includeItemInSelection")&&(m==M.SingleSelectLeft||m==M.SingleSelect||m==M.MultiSelect)));};
L.prototype.hasActiveType=function(){var t=sap.m.ListType,T=this.getType();return(T==t.Active||T==t.Navigation||T==t.DetailAndActive);};
L.prototype.setActive=function(A){if(A==this._active){return this;}if(A&&this.getListProperty("activeItem")){return this;}var t=this.$();this._active=A;this._activeHandling(t);if(this.getType()==sap.m.ListType.Navigation){this._activeHandlingNav(t);}if(A){this._activeHandlingInheritor(t);}else{this._inactiveHandlingInheritor(t);}this.informList("ActiveChange",A);};
L.prototype.ontap=function(e){if(this._eventHandledByControl){return;}if(this.isIncludedIntoSelection()){if(this.getMode()==sap.m.ListMode.MultiSelect){this.setSelected(!this.getSelected());this.informList("Select",this.getSelected());}else if(!this.getSelected()){this.setSelected(true);this.informList("Select",true);}}else if(this.hasActiveType()){window.clearTimeout(this._timeoutIdStart);window.clearTimeout(this._timeoutIdEnd);this.setActive(true);q.sap.delayedCall(180,this,function(){this.setActive(false);});q.sap.delayedCall(0,this,function(){this.fireTap();this.firePress();});}this.informList("Press",e.srcControl);};
L.prototype.ontouchstart=function(e){this._eventHandledByControl=e.isMarked();var t=e.targetTouches[0];this._touchedY=t.clientY;this._touchedX=t.clientX;if(this._eventHandledByControl||e.touches.length!=1||!this.hasActiveType()){return;}this._timeoutIdStart=q.sap.delayedCall(100,this,function(){this.setActive(true);e.setMarked();});};
L.prototype.ontouchmove=function(e){if((this._active||this._timeoutIdStart)&&(Math.abs(this._touchedY-e.targetTouches[0].clientY)>10||Math.abs(this._touchedX-e.targetTouches[0].clientX)>10)){clearTimeout(this._timeoutIdStart);this._timeoutIdStart=null;this._timeoutIdEnd=null;this.setActive(false);}};
L.prototype.ontouchend=function(e){if(e.targetTouches.length==0&&this.hasActiveType()){this._timeoutIdEnd=q.sap.delayedCall(100,this,function(){this.setActive(false);});}};
L.prototype.ontouchcancel=L.prototype.ontouchend;
L.prototype._activeHandlingNav=function(){};
L.prototype._activeHandlingInheritor=function(){};
L.prototype._inactiveHandlingInheritor=function(){};
L.prototype._activeHandling=function(t){t.toggleClass("sapMLIBActive",this._active);if(this.isActionable()){t.toggleClass("sapMLIBHoverable",!this._active);}};
L.prototype.onsapspace=function(e){if(e.srcControl!==this){return;}e.preventDefault();if(e.isMarked()||!this.isSelectable()){return;}if(this.getMode()==sap.m.ListMode.MultiSelect){this.setSelected(!this.getSelected());this.informList("Select",this.getSelected());}else if(!this.getSelected()){this.setSelected(true);this.informList("Select",true);}e.setMarked();};
L.prototype.onsapenter=function(e){var o=this.getList();if(e.isMarked()||!o){return;}var k=sap.m.ListKeyboardMode;if(e.srcControl!==this&&o.getKeyboardMode()==k.Edit){o.setKeyboardMode(k.Navigation);this._switchFocus(e);return;}if(e.srcControl!==this){return;}if(this.isIncludedIntoSelection()){this.onsapspace(e);}else if(this.hasActiveType()){e.setMarked();this.setActive(true);q.sap.delayedCall(180,this,function(){this.setActive(false);});q.sap.delayedCall(0,this,function(){this.fireTap();this.firePress();});}o.onItemPress(this,e.srcControl);};
L.prototype.onsapdelete=function(e){if(e.isMarked()||e.srcControl!==this||this.getMode()!=sap.m.ListMode.Delete){return;}this.informList("Delete");e.preventDefault();e.setMarked();};
L.prototype._switchFocus=function(e){var o=this.getList();if(!o){return;}var t=this.getTabbables();if(e.srcControl!==this){o._iLastFocusPosOfItem=t.index(e.target);this.focus();}else if(t.length){var f=o._iLastFocusPosOfItem||0;f=t[f]?f:-1;t.eq(f).focus();}e.preventDefault();e.setMarked();};
L.prototype.onkeydown=function(e){if(e.isMarked()){return;}var k=q.sap.KeyCodes;if(e.which==k.F7){this._switchFocus(e);return;}if(e.which==k.F2){if(e.srcControl===this&&this.getType().indexOf("Detail")==0&&this.hasListeners("detailPress")||this.hasListeners("detailTap")){this.fireDetailTap();this.fireDetailPress();e.preventDefault();e.setMarked();}else{var o=this.getList();if(o){this.$().prop("tabIndex",-1);var K=sap.m.ListKeyboardMode;o.setKeyboardMode(o.getKeyboardMode()==K.Edit?K.Navigation:K.Edit);this._switchFocus(e);}}}};
L.prototype.getTabbables=function(){return this.$().find(":sapTabbable");};
L.prototype.onsaptabnext=function(e){var o=this.getList();if(!o||e.isMarked()||o.getKeyboardMode()==sap.m.ListKeyboardMode.Edit){return;}var b=this.getTabbables().get(-1)||this.getDomRef();if(e.target===b){o.forwardTab(true);e.setMarked();}};
L.prototype.onsaptabprevious=function(e){var o=this.getList();if(!o||e.isMarked()||o.getKeyboardMode()==sap.m.ListKeyboardMode.Edit){return;}if(e.target===this.getDomRef()){o.forwardTab(false);e.setMarked();}};
L.prototype.onfocusin=function(e){var o=this.getList();if(!o||e.isMarked()||o.getKeyboardMode()==sap.m.ListKeyboardMode.Edit||e.srcControl===this||!q(e.target).is(":sapFocusable")){return;}q.sap.delayedCall(0,o,"setItemFocusable",[this]);e.setMarked();};
L.prototype.onsapup=function(e){if(e.isMarked()||e.srcControl===this||this.getListProperty("keyboardMode")===sap.m.ListKeyboardMode.Navigation){return;}this.informList("ArrowUpDown",e);};
L.prototype.onsapdown=L.prototype.onsapup;return L;},true);
sap.ui.predefine('sap/m/ListItemBaseRenderer',['jquery.sap.global','sap/ui/core/IconPool','sap/ui/core/theming/Parameters'],function(q,I,P){"use strict";var L={};var a={};
L.renderInvisible=function(r,l){this.openItemTag(r,l);r.writeInvisiblePlaceholderData(l);r.write(">");this.closeItemTag(r,l);};
L.isModeMatched=function(m,o){var O=(sap.m.ListBaseRenderer||{}).ModeOrder||{};return(O[m]==o);};
L.renderMode=function(r,l,o){var m=l.getMode();if(!this.isModeMatched(m,o)){return;}var M=l.getModeControl(true);if(M){this.renderModeContent(r,l,M);}};
L.renderModeContent=function(r,l,m){var M=l.getMode(),b={Delete:"D",MultiSelect:"M",SingleSelect:"S",SingleSelectLeft:"SL"};r.write("<div");r.writeAttribute("id",l.getId()+"-mode");r.addClass("sapMLIBSelect"+b[M]);this.decorateMode(r,l);r.writeClasses();r.writeStyles();r.write(">");r.renderControl(m);r.write("</div>");};
L.decorateMode=function(r,l){if(!sap.ui.getCore().getConfiguration().getAnimation()||!l.getListProperty("modeAnimationOn")){return;}var m=l.getMode(),s=l.getListProperty("lastMode");if(!s||s==m){return;}if(m==sap.m.ListMode.None){r.addClass("sapMLIBUnselectAnimation");}else{r.addClass("sapMLIBSelectAnimation");}};
L.renderCounter=function(r,l){var c=l.getCounter();if(c){this.renderCounterContent(r,l,c);}};
L.renderCounterContent=function(r,l,c){r.write("<div");r.writeAttribute("id",l.getId()+"-counter");var A=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LIST_ITEM_COUNTER",c);r.writeAttribute("aria-label",A);r.addClass("sapMLIBCounter");r.writeClasses();r.write(">");r.write(c);r.write("</div>");};
L.renderType=function(r,l){var t=l.getTypeControl();if(t){r.renderControl(t);}};
L.openItemTag=function(r,l){r.write("<li");};
L.closeItemTag=function(r,l){r.write("</li>");};
L.handleNoFlex=function(r,l){return!q.support.hasFlexBoxSupport;};
L.renderTabIndex=function(r,l){r.writeAttribute("tabindex","-1");};
L.renderTooltip=function(r,l){var t=l.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}};
L.addFocusableClasses=function(r,l){if(sap.ui.Device.system.desktop){r.addClass("sapMLIBFocusable");this.addLegacyOutlineClass(r,l);}};
L.addLegacyOutlineClass=function(r,l){if(sap.ui.Device.browser.msie){r.addClass("sapMLIBLegacyOutline");}};
L.getAriaAnnouncement=function(k,b){if(a[k]){return a[k];}b=b||"LIST_ITEM_"+k.toUpperCase();a[k]=new sap.ui.core.InvisibleText({text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText(b)}).toStatic().getId();return a[k];};
L.getAriaRole=function(l){return"option";};
L.getAriaLabelledBy=function(l){if(l.getAriaLabelledBy().length){return l.getId();}};
L.getAriaDescribedBy=function(l){var d=[],t=l.getType(),T=sap.m.ListType;if(l.getListProperty("showUnread")&&l.getUnread()){d.push(this.getAriaAnnouncement("unread"));}if(l.getMode()==sap.m.ListMode.Delete){d.push(this.getAriaAnnouncement("deletable"));}if(t==T.Navigation){d.push(this.getAriaAnnouncement("navigation"));}else{if(t==T.Detail||t==T.DetailAndActive){d.push(this.getAriaAnnouncement("detail"));}if(t==T.Active||t==T.DetailAndActive){d.push(this.getAriaAnnouncement("active"));}}return d.join(" ");};
L.getAccessibilityState=function(l){var A=this.getAriaLabelledBy(l),s=this.getAriaDescribedBy(l),m={role:this.getAriaRole(l)};if(l.isSelectable()){m.selected=l.getProperty("selected");}if(A){m.labelledby={value:A.trim(),append:true};}if(s){m.describedby={value:s.trim(),append:true};}return m;};
L.renderLIContent=function(r,l){};
L.renderLIAttributes=function(r,l){};
L.renderContentFormer=function(r,l){this.renderMode(r,l,-1);};
L.renderContentLatter=function(r,l){this.renderCounter(r,l);this.renderType(r,l);this.renderMode(r,l,1);};
L.renderLIContentWrapper=function(r,l){r.write('<div class="sapMLIBContent"');r.writeAttribute("id",l.getId()+"-content");r.write(">");if(this.handleNoFlex()){r.write('<div class="sapMLIBContentNF">');}this.renderLIContent(r,l);if(this.handleNoFlex()){r.write('</div>');}r.write('</div>');};
L.render=function(r,l){if(!l.getVisible()){this.renderInvisible(r,l);return false;}this.openItemTag(r,l);r.writeControlData(l);r.addClass("sapMLIB");r.addClass("sapMLIB-CTX");r.addClass("sapMLIBShowSeparator");r.addClass("sapMLIBType"+l.getType());if(sap.ui.Device.system.desktop&&l.isActionable()){r.addClass("sapMLIBActionable");r.addClass("sapMLIBHoverable");}if(l.getSelected()){r.addClass("sapMLIBSelected");}if(this.handleNoFlex()){r.addClass("sapMLIBNoFlex");}if(l.getListProperty("showUnread")&&l.getUnread()){r.addClass("sapMLIBUnread");}this.addFocusableClasses(r,l);this.renderTooltip(r,l);this.renderTabIndex(r,l);if(sap.ui.getCore().getConfiguration().getAccessibility()){r.writeAccessibilityState(l,this.getAccessibilityState(l));}this.renderLIAttributes(r,l);r.writeClasses();r.writeStyles();r.write(">");this.renderContentFormer(r,l);this.renderLIContentWrapper(r,l);this.renderContentLatter(r,l);this.closeItemTag(r,l);};
return L;},true);
sap.ui.predefine('sap/m/ListRenderer',['jquery.sap.global','sap/ui/core/Renderer','./ListBaseRenderer'],function(q,R,L){"use strict";var a=R.extend(L);
a.render=function(r,c){if(!c.getColumns().length){L.render.call(this,r,c);return;}if(c._isColumnsIncompatible()){q.sap.log.warning("Does not render sap.m.List#"+c.getId()+" with columns aggregation when compatibility version is 1.16 or higher. Instead use sap.m.Table control!");return;}q.sap.require("sap.m.TableRenderer");var o=q.extend({},this,sap.m.TableRenderer);L.render.call(o,r,c);};
return a;},true);
sap.ui.predefine('sap/m/MaskInput',['jquery.sap.global','./InputBase','./MaskInputRule','sap/ui/core/Control'],function(q,I,M,C){"use strict";
var a=I.extend("sap.m.MaskInput",{metadata:{library:"sap.m",properties:{placeholderSymbol:{type:"string",group:"Misc",defaultValue:"_"},mask:{type:"string",group:"Misc",defaultValue:null}},aggregations:{rules:{type:"sap.m.MaskInputRule",multiple:true,singularName:"rule"}}}});
var E='^';
a.prototype.init=function(){I.prototype.init.call(this);this._iCaretTimeoutId=null;this._iUserInputStartPosition=null;this._iMaskLength=null;this._sOldInputValue=null;this._oRules=null;this._oTempValue=null;this._bSkipSetupMaskVariables=null;this._setDefaultRules();};
a.prototype.exit=function(){this._iCaretTimeoutId=null;this._iUserInputStartPosition=null;this._iMaskLength=null;this._sOldInputValue=null;this._oRules=null;this._oTempValue=null;this._bSkipSetupMaskVariables=null;};
a.prototype.onBeforeRendering=function(){var v=this._validateDependencies();if(v){q.sap.log.warning("Invalid mask input: "+v);}I.prototype.onBeforeRendering.apply(this,arguments);};
a.prototype.onAfterRendering=function(){I.prototype.onAfterRendering.apply(this,arguments);};
a.prototype.onfocusin=function(e){this._sOldInputValue=this._getInputValue();I.prototype.onfocusin.apply(this,arguments);if(!this._oTempValue.differsFromOriginal()||!this._isValidInput(this._sOldInputValue)){this._applyMask();}this._positionCaret(true);};
a.prototype.onfocusout=function(e){this.bFocusoutDueRendering=this.bRenderingPhase;this.$().toggleClass("sapMFocus",false);q(document).off('.sapMIBtouchstart');if(this.bRenderingPhase){return;}this.closeValueStateMessage();this._inputCompletedHandler();};
a.prototype.oninput=function(e){I.prototype.oninput.apply(this,arguments);this._applyMask();this._positionCaret(false);};
a.prototype.onkeypress=function(e){this._keyPressHandler(e);};
a.prototype.onkeydown=function(e){var k=this._parseKeyBoardEvent(e),B=sap.ui.Device.browser,i;i=(k.bBackspace||k.bDelete)&&B.msie&&B.version<10;if(!i){I.prototype.onkeydown.apply(this,arguments);}this._keyDownHandler(e,k);};
a.prototype.onsapenter=function(e){};
a.prototype.onsapfocusleave=function(e){};
a.prototype.setValue=function(v){v=this.validateProperty('value',v);I.prototype.setValue.call(this,v);this._sOldInputValue=v;if(!this._oTempValue){this._setupMaskVariables();}if(this._oTempValue._aInitial.join('')!==v&&v.length){this._applyRules(v);}return this;};
a.prototype.addAggregation=function(A,o,s){if(A==="rules"){if(!this._validateRegexAgainstPlaceHolderSymbol(o)){return this;}this._removeRuleWithSymbol(o.getMaskFormatSymbol());C.prototype.addAggregation.apply(this,arguments);if(!this._bSkipSetupMaskVariables){this._setupMaskVariables();}return this;}return C.prototype.addAggregation.apply(this,arguments);};
a.prototype.insertAggregation=function(A,o,i,s){if(A==="rules"){if(!this._validateRegexAgainstPlaceHolderSymbol(o)){return this;}this._removeRuleWithSymbol(o.getMaskFormatSymbol());C.prototype.insertAggregation.apply(this,arguments);this._setupMaskVariables();return this;}return C.prototype.insertAggregation.apply(this,arguments);};
a.prototype._validateRegexAgainstPlaceHolderSymbol=function(r){if(new RegExp(r.getRegex()).test(this.getPlaceholderSymbol())){q.sap.log.error("Rejecting input mask rule because it includes the currently set placeholder symbol.");return false;}return true;};
a.prototype.setPlaceholderSymbol=function(s){var S;if(!/^.$/i.test(s)){q.sap.log.error("Invalid placeholder symbol string given");return this;}S=this.getRules().some(function(r){return new RegExp(r.getRegex()).test(s);});if(S){q.sap.log.error("Rejecting placeholder symbol because it is included as a regex in an existing mask input rule.");}else{this.setProperty("placeholderSymbol",s);this._setupMaskVariables();}return this;};
a.prototype.setMask=function(m){if(!m){var e="Setting an empty mask is pointless. Make sure you set it with a non-empty value.";q.sap.log.warning(e);return this;}this.setProperty("mask",m,true);this._setupMaskVariables();return this;};
a.prototype._isCharAllowed=function(c,i){return this._oRules.applyCharAt(c,i);};
a.prototype._feedReplaceChar=function(c,p,s){return c;};
var b=function(c){this._aInitial=c.slice(0);this._aContent=c;};
b.prototype.setCharAt=function(c,p){this._aContent[p]=c;};
b.prototype.charAt=function(p){return this._aContent[p];};
b.prototype.toString=function(){return this._aContent.join('');};
b.prototype.differsFromOriginal=function(){return this.differsFrom(this._aInitial);};
b.prototype.differsFrom=function(v){var i=0;if(v.length!==this._aContent.length){return true;}for(;i<v.length;i++){if(v[i]!==this._aContent[i]){return true;}}return false;};
b.prototype.getSize=function(){return this._aContent.length;};
var T=function(r){this._aRules=r;};
T.prototype.nextTo=function(c){if(typeof c==="undefined"){c=-1;}do{c++;}while(c<this._aRules.length&&!this._aRules[c]);return c;};
T.prototype.previousTo=function(c){do{c--;}while(!this._aRules[c]&&c>0);return c;};
T.prototype.hasRuleAt=function(i){return!!this._aRules[i];};
T.prototype.applyCharAt=function(c,i){return this._aRules[i].test(c);};
a.prototype._setDefaultRules=function(){this._bSkipSetupMaskVariables=true;this.addRule(new sap.m.MaskInputRule({maskFormatSymbol:"a",regex:"[A-Za-z]"}),true);this.addRule(new sap.m.MaskInputRule({maskFormatSymbol:"9",regex:"[0-9]"}),true);this._bSkipSetupMaskVariables=false;};
a.prototype._validateDependencies=function(){var p=this.getPlaceholderSymbol(),r=this.getRules(),m=[],e=[];if(!this.getMask()){e.push("Empty mask");}if(r.length){m=[];r.every(function(R){var s=R.getMaskFormatSymbol(),c=s!==p,d;d=!m.some(function(S){return s===S;});m.push(s);if(!c){e.push("Placeholder symbol is the  same as the existing rule's mask format symbol");}if(!d){e.push("Duplicated rule's maskFormatSymbol ["+s+"]");}return c&&d;});}return e.length?e.join(". "):null;};
a.prototype._removeRuleWithSymbol=function(s){var S=this._findRuleBySymbol(s,this.getRules());if(S){this.removeAggregation('rules',S.oRule);}};
a.prototype._findRuleBySymbol=function(m,r){var R=null;if(typeof m!=="string"||m.length!==1){q.sap.log.error(m+" is not a valid mask rule symbol");return null;}q.each(r,function(i,o){if(o.getMaskFormatSymbol()===m){R={oRule:o,iIndex:i};return false;}});return R;};
a.prototype._getTextSelection=function(){var _=q(this.getFocusDomRef());if(!_&&(_.length===0||_.is(":hidden"))){return;}return{iFrom:_[0].selectionStart,iTo:_[0].selectionEnd,bHasSelection:(_[0].selectionEnd-_[0].selectionStart!==0)};};
a.prototype._setCursorPosition=function(p){return q(this.getFocusDomRef()).cursorPos(p);};
a.prototype._getCursorPosition=function(){return q(this.getFocusDomRef()).cursorPos();};
a.prototype._setupMaskVariables=function(){var r=this.getRules(),m=this.getMask(),s=this._getSkipIndexes(m),c=this._getMaskArray(m,s),p=this.getPlaceholderSymbol(),i=this._buildMaskValueArray(c,p,r,s),t=this._buildRules(c,r,s);this._oTempValue=new b(i);this._iMaskLength=t.length;this._oRules=new T(t);this._iUserInputStartPosition=this._oRules.nextTo();};
a.prototype._getMaskArray=function(m,s){var l=Array.isArray(s)?s.length:0,c=(m)?m.split(""):[],i;for(i=0;i<l;i++){c.splice(s[i],1);}return c;};
a.prototype._getSkipIndexes=function(m){var l=(m)?m.length:0,i,s=[],p=0,L=false;for(i=0;i<l;i++){if(m[i]===E&&!L){s.push(i-p);L=true;p++;}else{L=false;}}return s;};
a.prototype._applyMask=function(){var m=this._getInputValue();if(!this.getEditable()){return;}this._applyAndUpdate(m);};
a.prototype._resetTempValue=function(f,t){var i,p=this.getPlaceholderSymbol();if(typeof f==="undefined"||f===null){f=0;t=this._oTempValue.getSize()-1;}for(i=f;i<=t;i++){if(this._oRules.hasRuleAt(i)){this._oTempValue.setCharAt(p,i);}}};
a.prototype._applyAndUpdate=function(m){this._applyRules(m);this.updateDomValue(this._oTempValue.toString());};
a.prototype._findFirstPlaceholderPosition=function(){return this._oTempValue.toString().indexOf(this.getPlaceholderSymbol());};
a.prototype._applyRules=function(i){var c,d=0,m,p=this.getPlaceholderSymbol(),e;for(m=0;m<this._iMaskLength;m++){if(this._oRules.hasRuleAt(m)){this._oTempValue.setCharAt(p,m);e=false;if(i.length){do{c=i.charAt(d);d++;if(this._oRules.applyCharAt(c,m)){this._oTempValue.setCharAt(c,m);e=true;}}while(!e&&(d<i.length));}if(!e){this._resetTempValue(m+1,this._iMaskLength-1);break;}}else{if(this._oTempValue.charAt(m)===i.charAt(d)){d++;}}}};
a.prototype._keyPressHandler=function(e){if(!this.getEditable()){return;}var s=this._getTextSelection(),p,c,k=this._parseKeyBoardEvent(e);if(k.bCtrlKey||k.bAltKey||k.bMetaKey||k.bBeforeSpace){return;}if(!k.bEnter&&!k.bShiftLeftOrRightArrow&&!k.bHome&&!k.bEnd&&!(k.bShift&&k.bDelete)&&!(k.bCtrlKey&&k.bInsert)&&!(k.bShift&&k.bInsert)){if(s.bHasSelection){this._resetTempValue(s.iFrom,s.iTo-1);this.updateDomValue(this._oTempValue.toString());this._setCursorPosition(Math.max(this._iUserInputStartPosition,s.iFrom));}p=this._oRules.nextTo(s.iFrom-1);if(p<this._iMaskLength){c=this._feedReplaceChar(k.sChar,p,this._getInputValue());this._feedNextString(c,p);}e.preventDefault();}};
a.prototype.oncut=function(e){var s=this._getTextSelection(),m=this._getMinBrowserDelay(),B=s.iFrom,i=s.iTo;I.prototype.oncut(e);if(!s.bHasSelection){return;}i=i-1;this._resetTempValue(B,i);q.sap.delayedCall(m,this,function updateDomAndCursor(v,p,o){this._oTempValue._aContent=o;this.updateDomValue(v);q.sap.delayedCall(m,this,this._setCursorPosition,[p]);},[this._oTempValue.toString(),Math.max(this._iUserInputStartPosition,B),this._oTempValue._aContent.slice(0)]);};
a.prototype._keyDownHandler=function(e,k){var d,s,B,i,c,n,k=k||this._parseKeyBoardEvent(e);if(!this.getEditable()){return;}if(!k.bShift&&(k.bArrowRight||k.bArrowLeft)){c=this._getCursorPosition();s=this._getTextSelection();d=this._determineArrowKeyDirection(k,s);if(this._isRtlMode()&&s.bHasSelection){n=this._determineRtlCaretPositionFromSelection(d);}else{n=this._oRules[d](c);}if(this._isWebkitProblematicCase()){n=this._fixWebkitBorderPositions(n,d);}this._setCursorPosition(n);e.preventDefault();}else if(k.bEscape){this._applyAndUpdate(this._sOldInputValue);this._positionCaret(true);e.preventDefault();}else if(k.bEnter){this._inputCompletedHandler(e);}else if((k.bCtrlKey&&k.bInsert)||(k.bShift&&k.bInsert)){I.prototype.onkeydown.apply(this,arguments);}else if((!k.bShift&&k.bDelete)||k.bBackspace){s=this._getTextSelection();B=s.iFrom;i=s.iTo;if(!s.bHasSelection){if(k.bBackspace){B=this._oRules.previousTo(B);}}if(k.bBackspace||(k.bDelete&&s.bHasSelection)){i=i-1;}this._resetTempValue(B,i);this.updateDomValue(this._oTempValue.toString());this._setCursorPosition(Math.max(this._iUserInputStartPosition,B));e.preventDefault();}};
a.prototype._feedNextString=function(n,p){var N,A=false,c=n.split(""),s;while(c.length){s=c.splice(0,1)[0];if(this._oRules.applyCharAt(s,p)){A=true;this._oTempValue.setCharAt(s,p);p=this._oRules.nextTo(p);}}if(A){N=p;this.updateDomValue(this._oTempValue.toString());this._setCursorPosition(N);}};
a.prototype._inputCompletedHandler=function(){var n=this._getInputValue(),t,v,e,c;if(this._oTempValue.differsFrom(n)){this._applyAndUpdate(n);}t=this._oTempValue.differsFromOriginal();v=t?this._oTempValue.toString():"";e=!this._sOldInputValue;c=!n;if(e&&(c||!t)){this.updateDomValue("");return;}if(this._sOldInputValue!==this._oTempValue.toString()){I.prototype.setValue.call(this,v);this._sOldInputValue=v;if(this.onChange&&!this.onChange({value:v})){this.fireChangeEvent(v);}}};
a.prototype._buildMaskValueArray=function(m,p,r,s){return m.map(function(c,i){var n=s.indexOf(i)===-1,R=this._findRuleBySymbol(c,r);return(n&&R)?p:c;},this);};
a.prototype._buildRules=function(m,r,s){var t=[],S,l=m.length,i=0;for(;i<l;i++){if(s.indexOf(i)===-1){S=this._findRuleBySymbol(m[i],r);t.push(S?new RegExp(S.oRule.getRegex()):null);}else{t.push(null);}}return t;};
a.prototype._parseKeyBoardEvent=function(e){var p=e.which||e.keyCode,k=q.sap.KeyCodes,A=p===k.ARROW_RIGHT,c=p===k.ARROW_LEFT,s=e.shiftKey;return{iCode:p,sChar:String.fromCharCode(p),bCtrlKey:e.ctrlKey,bAltKey:e.altKey,bMetaKey:e.metaKey,bShift:s,bInsert:p===q.sap.KeyCodes.INSERT,bBackspace:p===k.BACKSPACE,bDelete:p===k.DELETE,bEscape:p===k.ESCAPE,bEnter:p===k.ENTER,bIphoneEscape:(sap.ui.Device.system.phone&&sap.ui.Device.os.ios&&p===127),bArrowRight:A,bArrowLeft:c,bHome:p===q.sap.KeyCodes.HOME,bEnd:p===q.sap.KeyCodes.END,bShiftLeftOrRightArrow:s&&(c||A),bBeforeSpace:p<k.SPACE};};
a.prototype._positionCaret=function(s){var m=this.getMask(),i=this._getMinBrowserDelay(),e;clearTimeout(this._iCaretTimeoutId);e=this._findFirstPlaceholderPosition();if(e<0){e=m.length;}this._iCaretTimeoutId=q.sap.delayedCall(i,this,function(){if(this.getFocusDomRef()!==document.activeElement){return;}if(s&&(e===(m.length))){this.selectText(0,e);}else{this._setCursorPosition(e);}});};
a.prototype._getMinBrowserDelay=function(){return!sap.ui.Device.browser.msie?4:50;};
a.prototype._isValidInput=function(s){var l=s.length,i=0,c;for(;i<l;i++){c=s[i];if(this._oRules.hasRuleAt(i)&&(!this._oRules.applyCharAt(c,i)&&c!==this.getPlaceholderSymbol())){return false;}if(!this._oRules.hasRuleAt(i)&&c!==this._oTempValue.charAt(i)){return false;}}return true;};
a.prototype._isRtlChar=function(s){var l='A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02B8\u0300-\u0590\u0800-\u1FFF'+'\u2C00-\uFB1C\uFDFE-\uFE6F\uFEFD-\uFFFF',r='\u0591-\u07FF\uFB1D-\uFDFD\uFE70-\uFEFC',c=new RegExp('^[^'+l+']*['+r+']');return c.test(s);};
a.prototype._fixWebkitBorderPositions=function(c,d){var t=this._oTempValue.toString().length;if(d==='nextTo'){if(c===0||c===t||c===1){c=0;}else if(c===t+1){c=1;}}else{if(c===0||c===t-1){c=t;}else if(c===-1||c===t){c=t-1;}}return c;};
a.prototype._containsRtlChars=function(){var t=this._oTempValue.toString(),c=false;for(var i=0;i<t.length;i++){c=this._isRtlChar(t[i]);}return c;};
a.prototype._isRtlMode=function(){return sap.ui.getCore().getConfiguration().getRTL()||(this.getTextDirection()===sap.ui.core.TextDirection.RTL);};
a.prototype._isWebkitProblematicCase=function(){return(sap.ui.Device.browser.webkit&&this._isRtlMode()&&!this._containsRtlChars());};
a.prototype._determineArrowKeyDirection=function(k,s){var d;if(!this._isRtlMode()||!this._containsRtlChars()||s.bHasSelection){if(k.bArrowRight){d='nextTo';}else{d='previousTo';}}else{if(k.bArrowRight){d='previousTo';}else{d='nextTo';}}return d;};
a.prototype._determineRtlCaretPositionFromSelection=function(d,w){var n,s=this._getTextSelection();if(w){if(d==='nextTo'){if(!this._containsRtlChars()){n=s.iFrom;}else{n=s.iTo;}}else{if(!this._containsRtlChars()){n=s.iTo;}else{n=s.iFrom;}}}else{if(d==='nextTo'){if(!this._containsRtlChars()){n=s.iTo;}else{n=s.iFrom;}}else{if(!this._containsRtlChars()){n=s.iFrom;}else{n=s.iTo;}}}return n;};
return a;},true);
sap.ui.predefine('sap/m/MaskInputRenderer',['sap/ui/core/Renderer','./InputBaseRenderer'],function(R,I){"use strict";var M=R.extend(I);
M.getLabelledByAnnouncement=function(c){var m=c.getMask(),p=c.getPlaceholder()||"",t=c.getTooltip_AsString()||"",r,s,a="";if(m&&m.length){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");s=r.getText("MASKINPUT_SCREENREADER_TAG");if(t){t=" "+t+" ";}if(p){p=" "+p+" ";}a=s+p+t;return a;}return I.getLabelledByAnnouncement.apply(this,arguments);};
M.getDescribedByAnnouncement=function(c){var m=c.getMask(),s=c.getPlaceholderSymbol(),r,a="";if(m.length&&s){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");a=r.getText("MASKINPUT_SCREENREADER_DESCRIPTION",[s,m]);return jQuery.trim(a);}return I.getDescribedByAnnouncement.apply(this,arguments);};
return M;},true);
sap.ui.predefine('sap/m/MaskInputRule',['jquery.sap.global','sap/ui/core/Element'],function(q,E){"use strict";
var M=E.extend("sap.m.MaskInputRule",{metadata:{library:"sap.m",properties:{maskFormatSymbol:{type:"string",group:"Misc",defaultValue:"*"},regex:{type:"string",group:"Misc",defaultValue:"[a-zA-Z0-9]"}}}});
M.prototype.setMaskFormatSymbol=function(n){var i=v.call(this,n);if(i){this.setProperty("maskFormatSymbol",n);}return this;};
M.prototype.setRegex=function(n){var i=a.call(this,n);if(i){this.setProperty("regex",n);}return this;};
M.prototype.toString=function(){return this.getMaskFormatSymbol()+":"+this.getRegex();};
function v(n){if(/^.$/i.test(n)){return true;}q.sap.log.error("The mask format symbol '"+n+"' is not valid");return false;}
function a(r){if(/.+/i.test(r)){return true;}q.sap.log.error("The regex value '"+r+"' is not valid");return false;}
return M;},true);
sap.ui.predefine('sap/m/Menu',['jquery.sap.global','./library','sap/ui/core/Control','./Button','./Dialog','./NavContainer','./List','./Page','./MenuListItem','sap/ui/unified/Menu','sap/ui/Device','sap/ui/core/EnabledPropagator'],function(q,l,C,B,D,N,L,P,M,U,a,E){"use strict";
var b=C.extend("sap.m.Menu",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MenuItem",multiple:true,singularName:"item",bindable:"bindable"},_dialog:{type:"sap.m.Dialog",multiple:false,visibility:"hidden"},_menu:{type:"sap.ui.unified.Menu",multiple:false,visibility:"hidden"}},events:{itemSelected:{parameters:{item:{type:"sap.m.MenuItem"}}},closed:{}}}});
E.call(b.prototype);b.UNIFIED_MENU_ITEMS_ID_SUFFIX='-unifiedmenu';b.LIST_ITEMS_ID_SUFFIX='-menuinnerlist';
b.prototype.init=function(){if(a.system.phone){this._initDialog();}this._bIsInitialized=false;};
b.prototype.exit=function(){if(this._navContainerId){this._navContainerId=null;}if(this._bIsInitialized){this._bIsInitialized=null;}if(this._getMenu()&&this._getMenu().getPopup()){this._getMenu().getPopup().detachClosed(this._menuClosed,this);}};
b.prototype.invalidate=function(){};
b.prototype.setTitle=function(t){var n=this._getNavContainer();this.setProperty("title",t,true);if(n&&n.getPages().length){n.getPages()[0].setTitle(t);}return this;};
b.prototype.openBy=function(o,w){if(a.system.phone){if(!this._bIsInitialized){this._initAllPages();this._bIsInitialized=true;}this._getNavContainer().to(this._getNavContainer().getPages()[0]);this._getDialog().open();}else{if(!this._bIsInitialized){this._initAllMenuItems();this._bIsInitialized=true;}var e=sap.ui.core.Popup.Dock;this._getMenu().open(w,o,e.BeginTop,e.BeginBottom,o,"0 -2");}};
b.prototype.close=function(){if(sap.ui.Device.system.phone){this._getDialog().close();}else{this._getVisualParent().close();}};
b.prototype._initDialog=function(){var d=new D({showHeader:false,stretch:true,content:this._initNavContainer(),buttons:[this._initCloseButton()]});d.addStyleClass("sapMRespMenuDialog");this.setAggregation("_dialog",d,true);};
b.prototype._getDialog=function(){return this.getAggregation("_dialog");};
b.prototype._initAllMenuItems=function(){this._initMenuForItems(this.getItems());};
b.prototype._initMenuForItems=function(i,p){var m=new U();m.isCozy=this._isMenuCozy.bind(this,m);m.addStyleClass('sapMMenu');i.forEach(function(I){this._addVisualMenuItemFromItem(I,m);}.bind(this));if(p){p.setSubmenu(m);}else{m.getPopup().attachClosed(this._menuClosed,this);this.setAggregation('_menu',m,true);}m.attachItemSelect(this._handleMenuItemSelect,this);};
b.prototype._menuClosed=function(){this.fireClosed();};
b.prototype._getMenu=function(){return this.getAggregation("_menu");};
b.prototype._initCloseButton=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");return new B({text:r.getText("MENU_CLOSE"),press:f.bind(this)});};
function f(){this._getDialog().close();}
b.prototype._initNavContainer=function(){var n=new N();this._navContainerId=n.getId();return n;};
b.prototype._getNavContainer=function(){return sap.ui.getCore().byId(this._navContainerId);};
b.prototype._initAllPages=function(){this._initPageForParent(this);};
b.prototype._initPageForParent=function(p){var i=p.getItems(),d=p instanceof sap.m.Menu,s=d?p.getTitle():p.getText(),o=new L({mode:sap.m.ListMode.None}),e=new P({title:s,showNavButton:!d,content:o});if(!d){this._setBackButtonTooltipForPageWithParent(p,e);}e.attachNavButtonPress(function(){this._getNavContainer().back();},this);this._getNavContainer().addPage(e);i.forEach(function(I){this._addListItemFromItem(I,e);},this);this._updateListInset(o);o.attachEvent("itemPress",this._handleListItemPress,this);return e;};
b.prototype._handleListItemPress=function(e){var o=e.getParameter("listItem"),m=sap.ui.getCore().byId(o.getMenuItem()),p=m._getVisualChild();if(p){this._getNavContainer().to(p);}else{this._getDialog().close();this.fireItemSelected({item:m});}};
b.prototype._setBackButtonTooltipForPageWithParent=function(p,o){var d=p.getParent(),r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s;s=d instanceof sap.m.Menu?d.getTitle():d.getText();s=r.getText("MENU_PAGE_BACK_BUTTON")+" "+s;o.setNavButtonTooltip(s);};
b.prototype._createMenuListItemFromItem=function(i){return new M({id:this._generateListItemId(i.getId()),type:sap.m.ListType.Active,icon:i.getIcon(),title:i.getText(),startsSection:i.getStartsSection(),menuItem:i,tooltip:i.getTooltip()});};
b.prototype._createVisualMenuItemFromItem=function(i){return new sap.ui.unified.MenuItem({id:this._generateUnifiedMenuItemId(i.getId()),icon:i.getIcon(),text:i.getText(),startsSection:i.getStartsSection(),tooltip:i.getTooltip(),visible:i.getVisible(),enabled:i.getEnabled()});};
b.prototype._addVisualMenuItemFromItem=function(i,m,I){var o=this._createVisualMenuItemFromItem(i);i._setVisualParent(m);i._setVisualControl(o);var e=['aggregationChanged','propertyChanged'];e.forEach(function(s){var d='_on'+s.slice(0,1).toUpperCase()+s.slice(1);i.attachEvent(s,this[d],this);},this);if(i.getItems().length!==0){this._initMenuForItems(i.getItems(),o);i._setVisualChild(i.getItems()[0]._getVisualParent());}if(I===undefined){m.addItem(o);}else{m.insertItem(o,I);}};
b.prototype._addListItemFromItem=function(i,p,I){var m=this._createMenuListItemFromItem(i),o=p.getContent()[0];i._setVisualParent(p);i._setVisualControl(m);var e=['aggregationChanged','propertyChanged'];e.forEach(function(s){var d='_on'+s.slice(0,1).toUpperCase()+s.slice(1);i.attachEvent(s,this[d],this);},this);if(i.getItems().length!==0){this._initPageForParent(i);i._setVisualChild(i.getItems()[0]._getVisualParent());}if(I===undefined){o.addItem(m);}else{o.insertItem(m,I);}o.rerender();};
b.prototype._addVisualItemFromItem=function(i,o,I){if(!o){return;}if(a.system.phone){this._addListItemFromItem(i,o,I);var d=o.getContent()[0];this._updateListInset(d);}else{this._addVisualMenuItemFromItem(i,o,I);}};
b.prototype._updateListInset=function(o){var h=false,I="sapMListIcons",d=o.getItems();for(var i=0;i<d.length;i++){if(d[i].getIcon()){h=true;break;}}if(h){o.addStyleClass(I);}else{o.removeStyleClass(I);}};
b.prototype._handleMenuItemSelect=function(e){var u=e.getParameter("item"),m;if(!u){return;}m=this._findMenuItemByUnfdMenuItem(u);if(m&&!m.getItems().length){this.fireItemSelected({item:m});}};
b.prototype._generateListItemId=function(m){return m+b.LIST_ITEMS_ID_SUFFIX;};
b.prototype._generateUnifiedMenuItemId=function(m){return m+b.UNIFIED_MENU_ITEMS_ID_SUFFIX;};
b.prototype._findMenuItemByUnfdMenuItem=function(u){var d=[],o=u,I,e,i;do{d.push(o.getId());o=o.getParent().getParent();}while(o instanceof sap.ui.unified.MenuItem);I=this.getItems();do{e=d.pop();for(i=0;i<I.length;i++){if(I[i]._getVisualControl()===e){if(d.length===0){return I[i];}else{I=I[i].getItems();break;}}}}while(d.length);return null;};
b.prototype._isMenuCozy=function(m){if(!m.bCozySupported){return false;}if(m.hasStyleClass("sapUiSizeCozy")){return true;}if(c(m.oOpenerRef)){return true;}return false;};
function c(r){if(!r){return false;}r=r.$?r.$():q(r);var $=r.closest(".sapUiSizeCompact,.sapUiSizeCondensed,.sapUiSizeCozy");return(!$.hasClass("sapUiSizeCompact")&&!$.hasClass("sapUiSizeCondensed"))||$.hasClass("sapUiSizeCozy");}
b.prototype.addAggregation=function(A,o,s){C.prototype.addAggregation.apply(this,arguments);if(A==="items"){this._addVisualItemFromItem(o,this._getVisualParent());}return this;};
b.prototype.insertAggregation=function(A,o,i,s){C.prototype.insertAggregation.apply(this,arguments);if(A==="items"){this._addVisualItemFromItem(o,this._getVisualParent(),i);}return this;};
b.prototype.removeAggregation=function(A,o,s){var i=C.prototype.removeAggregation.apply(this,arguments);if(A==="items"){this._removeVisualItem(i);}return i;};
b.prototype.removeAllAggregation=function(A,s){var I=C.prototype.removeAllAggregation.apply(this,arguments);if(A==="items"){for(var i=0;i<I.length;i++){this._removeVisualItem(I[i]);}}return I;};
b.prototype._removeVisualItem=function(i,p){var v=sap.ui.getCore().byId(i._getVisualControl()),m,o;if(v){m=v.getParent();m.removeItem(v);if(a.system.phone){this._removeSubPageForItem(i);if(m.getItems().length===0){o=sap.ui.getCore().byId(i._getVisualParent());this._getNavContainer().removePage(o);o.destroy();if(p){p._setVisualChild(null);sap.ui.getCore().byId(p._getVisualControl()).rerender();}}if(m){m.rerender();}}v.destroy();}};
b.prototype.destroyAggregation=function(A,s){if(A==="items"){for(var i=0;i<this.getItems().length;i++){this._removeVisualItem(this.getItems()[i]);}}return C.prototype.destroyAggregation.apply(this,arguments);};
b.prototype._removeSubPageForItem=function(I,s){var S;if(!s){for(var i=0;i<I.getItems().length;i++){this._removeSubPageForItem(I.getItems()[i]);}}if(I._getVisualChild()){S=sap.ui.getCore().byId(I._getVisualChild());if(this._getNavContainer()&&S){this._getNavContainer().removePage(S);}!!S&&S.destroy();}};
b.prototype._getVisualParent=function(){var n=this._getNavContainer(),m=this._getMenu();if(n&&n.getPages().length){return n.getPages()[0];}else{return m;}};
b.prototype._onPropertyChanged=function(e){var p=e.getParameter("propertyKey"),o=e.getParameter("propertyValue");if(a.system.phone){if(p==='text'){p='title';}var s=this._generateListItemId(e.getSource().getId());!!s&&sap.ui.getCore().byId(s).setProperty(p,o);if(this._getDialog().isOpen()){this._getDialog().close();}}else{var u=this._generateUnifiedMenuItemId(e.getSource().getId());!!u&&sap.ui.getCore().byId(u).setProperty(p,o);}};
b.prototype._onAggregationChanged=function(e){var A=e.getParameter("aggregationName");switch(A){case'items':this._onItemsAggregationChanged(e);break;}};
b.prototype._onItemsAggregationChanged=function(e){var I=e.getSource(),m=e.getParameter("methodName"),d=e.getParameter("methodParams"),g;if(m==="add"||m==="insert"){if(m==="insert"){g=d.index;}this._addOrInsertItem(I,d.item,g);}if(m==="remove"){this._removeVisualItem(d.item,I);}if(m==="removeall"){for(var i=0;i<d.items.length;i++){this._removeVisualItem(d.items[i],I);}}if(m==="destroy"){this._destroyItem(I);}};
b.prototype._addOrInsertItem=function(p,n,i){var o;if(p._getVisualChild()){this._addVisualItemFromItem(n,sap.ui.getCore().byId(p._getVisualChild()),i);}else{if(a.system.phone){this._initPageForParent(p);p._setVisualChild(p.getItems()[0]._getVisualParent());o=sap.ui.getCore().byId(p._getVisualControl());o.rerender();}else{this._initMenuForItems(p.getItems(),sap.ui.getCore().byId(p._getVisualControl()));p._setVisualChild(p.getItems()[0]._getVisualParent());}}};
b.prototype._destroyItem=function(i){var v=sap.ui.getCore().byId(i._getVisualControl());if(v&&v.setMenuItem){v.setMenuItem(null);}this._removeSubPageForItem(i,true);i._setVisualChild(null);if(v&&v.setMenuItem){v.rerender();v.setMenuItem(i);}};
b.prototype.getDomRefId=function(){if(a.system.phone){return this._getDialog().getId();}else{return this._getMenu().getId();}};
return b;},true);
sap.ui.predefine('sap/m/MenuButton',['jquery.sap.global','./library','sap/ui/core/Control','./Button','./SplitButton','./Dialog','sap/ui/Device','sap/ui/core/EnabledPropagator'],function(q,l,C,B,S,D,a,E){"use strict";
var M=C.extend("sap.m.MenuButton",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null},type:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:sap.m.ButtonType.Default},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},buttonMode:{type:"sap.m.MenuButtonMode",group:"Misc",defaultValue:sap.m.MenuButtonMode.Regular},useDefaultActionOnly:{type:"Boolean",group:"Behavior",defaultValue:false}},aggregations:{menu:{type:"sap.m.Menu",multiple:false,singularName:"menu",bindable:"bindable"},_button:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{defaultAction:{}},defaultAggregation:"menu"}});
E.call(M.prototype);
M.prototype.init=function(){this._initButtonControl();};
M.prototype.exit=function(){if(this._sDefaultText){this._sDefaultText=null;}if(this._sDefaultIcon){this._sDefaultIcon=null;}if(this._iInitialWidth){this._iInitialWidth=null;}if(this._lastActionItemId){this._lastActionItemId=null;}if(this.getMenu()){this.getMenu().detachClosed(this._menuClosed,this);}};
M.prototype.onBeforeRendering=function(){if(!this._sDefaultText){this._sDefaultText=this.getText();}if(!this._sDefaultIcon){this._sDefaultIcon=this.getIcon();}this._updateButtonControl();this._attachMenuEvents();};
M.prototype.onAfterRendering=function(){q.sap.delayedCall(0,this,"_setInitialBtnWidth");this._setAriaHasPopup();};
M.prototype._setInitialBtnWidth=function(){if(this._isSplitButton()&&!this._iInitialWidth){this._iInitialWidth=this.$().outerWidth()+1;}};
M.prototype._setAriaHasPopup=function(){if(this._isSplitButton()){this._getButtonControl()._getArrowButton().$().attr("aria-haspopup","true");}else{this._getButtonControl().$().attr("aria-haspopup","true");}};
M.prototype.setButtonMode=function(m){var t=this.getTooltip();C.prototype.setProperty.call(this,"buttonMode",m,true);this._getButtonControl().destroy();this._initButtonControl();for(var k in this.mProperties){if(this.mProperties.hasOwnProperty(k)&&k!=="buttonMode"&&k!=="useDefaultActionOnly"&&k!=="width"){this._getButtonControl().setProperty(k,this.mProperties[k],true);}}if(t){this._getButtonControl().setTooltip(t);}if(!this._isSplitButton()&&this._sDefaultText){this.setText(this._sDefaultText);}else if(!this.getUseDefaultActionOnly()&&this._getLastSelectedItem()){this.setText(sap.ui.getCore().byId(this._getLastSelectedItem()).getText());}if(!this._isSplitButton()&&this._sDefaultIcon){this.setIcon(this._sDefaultIcon);}else if(!this.getUseDefaultActionOnly()&&this._getLastSelectedItem()){this.setIcon(sap.ui.getCore().byId(this._getLastSelectedItem()).getIcon());}this.invalidate();return this;};
M.prototype._initButton=function(){var b=new B({width:"100%"});b.attachPress(this._handleButtonPress,this);return b;};
M.prototype._initSplitButton=function(){var b=new S({width:"100%"});b.attachPress(this._handleActionPress,this);b.attachArrowPress(this._handleButtonPress,this);return b;};
M.prototype._initButtonControl=function(){var b;if(this._isSplitButton()){b=this._initSplitButton();}else{b=this._initButton();}this.setAggregation("_button",b,true);};
M.prototype._updateButtonControl=function(){this._getButtonControl().setText(this.getText());};
M.prototype._getButtonControl=function(){return this.getAggregation("_button");};
M.prototype._handleButtonPress=function(w){var m=this.getMenu();if(!m){return;}if(!m.getTitle()){m.setTitle(this.getText());}m.openBy(this,w);this._writeAriaAttributes();if(this._isSplitButton()&&!a.system.phone){this._getButtonControl().setArrowState(true);}};
M.prototype._handleActionPress=function(){var L=this._getLastSelectedItem(),o;if(!this.getUseDefaultActionOnly()&&L){o=sap.ui.getCore().byId(L);this.getMenu().fireItemSelected({item:o});}else{this.fireDefaultAction();}};
M.prototype._menuClosed=function(){if(this._isSplitButton()){this._getButtonControl().setArrowState(false);}};
M.prototype._menuItemSelected=function(e){var m=e.getParameter("item");if(!this._isSplitButton()||this.getUseDefaultActionOnly()||!m){return;}this._lastActionItemId=m.getId();!!this._sDefaultText&&this.setText(m.getText());!!this._sDefaultIcon&&this.setIcon(m.getIcon());};
M.prototype._getLastSelectedItem=function(){return this._lastActionItemId;};
M.prototype._attachMenuEvents=function(){if(this.getMenu()){this.getMenu().attachClosed(this._menuClosed,this);this.getMenu().attachItemSelected(this._menuItemSelected,this);}};
M.prototype._isSplitButton=function(){return this.getButtonMode()===sap.m.MenuButtonMode.Split;};
M.prototype.setProperty=function(p,v,s){function i(t){var T=[sap.m.ButtonType.Up,sap.m.ButtonType.Back,sap.m.ButtonType.Unstyled];return T.indexOf(t)!==-1;}if(p==="type"&&i(v)){return this;}if(p==='text'){this._sDefaultText=v;}switch(p){case'activeIcon':case'iconDensityAware':case'textDirection':this._getButtonControl().setProperty(p,v);break;}return C.prototype.setProperty.apply(this,arguments);};
M.prototype.setTooltip=function(t){this._getButtonControl().setTooltip(t);return C.prototype.setTooltip.apply(this,arguments);};
M.prototype.setText=function(v){B.prototype.setProperty.call(this,'text',v);this._getButtonControl().setText(v);return this;};
M.prototype.setType=function(v){B.prototype.setProperty.call(this,'type',v);this._getButtonControl().setType(v);return this;};
M.prototype.setIcon=function(v){B.prototype.setProperty.call(this,'icon',v);this._getButtonControl().setIcon(v);return this;};
M.prototype.getFocusDomRef=function(){return this._getButtonControl().getDomRef();};
M.prototype.onsapup=function(e){this.openMenuByKeyboard();};
M.prototype.onsapdown=function(e){this.openMenuByKeyboard();};
M.prototype.onsapupmodifiers=function(e){this.openMenuByKeyboard();};
M.prototype.onsapdownmodifiers=function(e){this.openMenuByKeyboard();};
M.prototype.onsapshow=function(e){this.openMenuByKeyboard();!!e&&e.preventDefault();};
M.prototype.openMenuByKeyboard=function(){if(!this._isSplitButton()){this._handleButtonPress(true);}};
M.prototype._writeAriaAttributes=function(){if(this.getMenu()){this.$().attr("aria-controls",this.getMenu().getDomRefId());}};
return M;},true);
sap.ui.predefine('sap/m/MenuButtonRenderer',['jquery.sap.global'],function(q){"use strict";var M={};M.CSS_CLASS="sapMMenuBtn";
M.render=function(r,m){var w=m.getWidth();r.write("<div");r.writeControlData(m);this.writeAriaAttributes(r,m);r.addClass(M.CSS_CLASS);r.addClass(M.CSS_CLASS+m.getButtonMode());r.writeClasses();if(w!=""||w.toLowerCase()==="auto"){r.addStyle("width",w);}else if(m._isSplitButton()&&m._iInitialWidth){r.addStyle("width",m._iInitialWidth+"px");}r.writeStyles();r.write(">");r.renderControl(m._getButtonControl());r.write("</div>");};
M.writeAriaAttributes=function(r,m){r.writeAttribute("aria-haspopup","true");};
return M;},true);
sap.ui.predefine('sap/m/MenuItem',['jquery.sap.global','./library','sap/ui/core/Item'],function(q,l,I){"use strict";
var M=I.extend("sap.m.MenuItem",{metadata:{library:"sap.m",properties:{icon:{type:"string",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true},startsSection:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MenuItem",multiple:true,singularName:"item",bindable:"bindable"}},events:{press:{},propertyChanged:{parameters:{propertyKey:{type:"string"},propertyValue:{type:"mixed"}}},aggregationChanged:{parameters:{aggregationName:{type:"String"},methodName:{type:"String"},methodParams:{type:"Object"}}}}}});
M.prototype.exit=function(){if(this._sVisualChild){this._sVisualChild=null;}if(this._sVisualParent){this._sVisualParent=null;}if(this._sVisualControl){this._sVisualControl=null;}};
M.prototype.setProperty=function(p,P){I.prototype.setProperty.apply(this,arguments);this.fireEvent("propertyChanged",{propertyKey:p,propertyValue:P});};
M.prototype.addAggregation=function(a,o,s){I.prototype.addAggregation.apply(this,arguments);this.fireEvent("aggregationChanged",{aggregationName:a,methodName:"add",methodParams:{item:o}});return this;};
M.prototype.insertAggregation=function(a,o,i,s){I.prototype.insertAggregation.apply(this,arguments);this.fireEvent("aggregationChanged",{aggregationName:a,methodName:"insert",methodParams:{item:o,index:i}});return this;};
M.prototype.removeAggregation=function(a,o,s){var O=I.prototype.removeAggregation.apply(this,arguments);this.fireEvent("aggregationChanged",{aggregationName:a,methodName:"remove",methodParams:{item:O}});return O;};
M.prototype.removeAllAggregation=function(a,s){var o=I.prototype.removeAllAggregation.apply(this,arguments);this.fireEvent("aggregationChanged",{aggregationName:a,methodName:"removeall",methodParams:{items:o}});return o;};
M.prototype.destroyAggregation=function(a,s){this.fireEvent("aggregationChanged",{aggregationName:a,methodName:"destroy"});return I.prototype.destroyAggregation.apply(this,arguments);};
M.prototype._setVisualChild=function(c){this._setInternalRef(c,"_sVisualChild");};
M.prototype._setVisualParent=function(c){this._setInternalRef(c,"_sVisualParent");};
M.prototype._setVisualControl=function(c){this._setInternalRef(c,"_sVisualControl");};
M.prototype._setInternalRef=function(c,i){if(!c||typeof c==="string"){this[i]=c;}else if(c.getId){this[i]=c.getId();}};
M.prototype._getVisualChild=function(){return this._sVisualChild;};
M.prototype._getVisualParent=function(){return this._sVisualParent;};
M.prototype._getVisualControl=function(){return this._sVisualControl;};
return M;},true);
sap.ui.predefine('sap/m/MenuListItem',['jquery.sap.global','./ListItemBase','./library','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool'],function(q,L,l,E,I){"use strict";
var M=L.extend("sap.m.MenuListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},startsSection:{type:"boolean",group:"Behavior",defaultValue:false}},associations:{menuItem:{type:"sap.m.MenuItem",multiple:false}}}});
M.prototype.exit=function(){if(this._image){this._image.destroy();}if(this._imageRightArrow){this._imageRightArrow.destroy();}L.prototype.exit.apply(this,arguments);};
M.prototype._getImage=function(i,s,S,b){var o=this._image;if(o){o.setSrc(S);if(o instanceof sap.m.Image){o.setDensityAware(b);}}else{o=I.createControlByURI({id:i,src:S,densityAware:b,useIconTooltip:false},sap.m.Image).setParent(this,null,true);}if(o instanceof sap.m.Image){o.addStyleClass(s,true);}else{o.addStyleClass(s+"Icon",true);}this._image=o;return this._image;};
M.prototype._getIconArrowRight=function(){if(!this._imageRightArrow){this._imageRightArrow=I.createControlByURI({id:this.getId()+"-arrowRight",src:"sap-icon://slim-arrow-right",useIconTooltip:false},sap.m.Image).setParent(this,null,true);this._imageRightArrow.addStyleClass("sapMMenuLIArrowRightIcon",true);}return this._imageRightArrow;};
M.prototype._hasSubItems=function(){return!!(this.getMenuItem()&&sap.ui.getCore().byId(this.getMenuItem()).getItems().length);};
return M;},false);
sap.ui.predefine('sap/m/MenuListItemRenderer',['jquery.sap.global','./ListItemBaseRenderer','sap/ui/core/Renderer'],function(q,L,R){"use strict";var M=R.extend(L);
M.openItemTag=function(r,l){if(l.getStartsSection()){r.write("<li ");r.write("role=\"separator\" ");r.write("class=\"sapUiMnuDiv\"><div class=\"sapUiMnuDivL\"></div><hr><div class=\"sapUiMnuDivR\"></div></li>");}L.openItemTag(r,l);};
M.renderLIAttributes=function(r,l){r.addClass("sapMSLI");if(l.getIcon()){r.addClass("sapMSLIIcon");}if(l.getType()==sap.m.ListType.Detail||l.getType()==sap.m.ListType.DetailAndActive){r.addClass("sapMSLIDetail");}if(l._hasSubItems()){r.addClass("sapMMenuLIHasChildren");}};
M.renderLIContent=function(r,l){var t=l.getTitleTextDirection();if(l.getIcon()){r.renderControl(l._getImage((l.getId()+"-img"),"sapMMenuLIImgThumb",l.getIcon(),l.getIconDensityAware()));}r.write("<div");r.addClass("sapMSLIDiv");r.addClass("sapMSLITitleDiv");r.writeClasses();r.write(">");if(l._bNoFlex){r.write('<div class="sapMLIBNoFlex">');}r.write("<div");r.addClass("sapMSLITitleOnly");r.writeClasses();if(t!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",t.toLowerCase());}r.write(">");r.writeEscaped(l.getTitle());r.write("</div>");if(l._bNoFlex){r.write('</div>');}r.write("</div>");if(l._hasSubItems()){r.renderControl(l._getIconArrowRight());}};
return M;},true);
sap.ui.predefine('sap/m/MessageBox',['jquery.sap.global','./Button','./Dialog','./Text','./TextArea','./Link','./VBox','sap/ui/core/IconPool'],function(q,B,D,T,a,L,V,I){"use strict";var M={};M.Action={OK:"OK",CANCEL:"CANCEL",YES:"YES",NO:"NO",ABORT:"ABORT",RETRY:"RETRY",IGNORE:"IGNORE",CLOSE:"CLOSE",DELETE:"DELETE"};M.Icon={NONE:undefined,INFORMATION:"INFORMATION",WARNING:"WARNING",ERROR:"ERROR",SUCCESS:"SUCCESS",QUESTION:"QUESTION"};(function(){var A=M.Action,b=M.Icon,c={"INFORMATION":"sapMMessageBoxInfo","WARNING":"sapMMessageBoxWarning","ERROR":"sapMMessageBoxError","SUCCESS":"sapMMessageBoxSuccess","QUESTION":"sapMMessageBoxQuestion","STANDARD":"sapMMessageBoxStandard"},m={"INFORMATION":I.getIconURI("message-information"),"WARNING":I.getIconURI("message-warning"),"ERROR":I.getIconURI("message-error"),"SUCCESS":I.getIconURI("message-success"),"QUESTION":I.getIconURI("question-mark")};var _=function(){if(sap.m.MessageBox._rb!==sap.ui.getCore().getLibraryResourceBundle("sap.m")){sap.m.MessageBox._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");}};
M.show=function(v,o){var d,e,f,r=null,t=this,g=[],i,s,h,j,C,k,l,n={id:sap.ui.core.ElementMetadata.uid("mbox"),initialFocus:null,textDirection:sap.ui.core.TextDirection.Inherit,verticalScrolling:true,horizontalScrolling:true,details:""};_();if(typeof o==="string"||arguments.length>2){s=arguments[1];h=arguments[2];j=arguments[3];C=arguments[4];k=arguments[5];l=arguments[6];o={icon:s,title:h,actions:j,onClose:C,id:k,styleClass:l};}if(o&&o.hasOwnProperty("details")){n.icon=sap.m.MessageBox.Icon.INFORMATION;n.actions=[A.OK,A.CANCEL];o=q.extend({},n,o);if(typeof o.details=='object'){o.details=JSON.stringify(o.details,null,'\t');}}o=q.extend({},n,o);if(typeof o.actions!=="undefined"&&!q.isArray(o.actions)){o.actions=[o.actions];}if(!o.actions||o.actions.length===0){o.actions=[A.OK];}function p(z){var E;if(M.Action.hasOwnProperty(z)){E=t._rb.getText("MSGBOX_"+z);}var F=new B({id:sap.ui.core.ElementMetadata.uid("mbox-btn-"),text:E||z,press:function(){r=z;d.close();}});return F;}for(i=0;i<o.actions.length;i++){g.push(p(o.actions[i]));}function u(o,e){var z=new a({editable:false,visible:false,rows:3}).setValue(o.details);var E=new L({text:t._rb.getText("MSGBOX_LINK_TITLE"),press:function(){z.setVisible(true);this.setVisible(false);d._setInitialFocus();}});E.addStyleClass("sapMMessageBoxLinkText");z.addStyleClass("sapMMessageBoxDetails");return new V({items:[e,E,z]});}function w(){if(typeof o.onClose==="function"){o.onClose(r);}d.detachAfterClose(w);d.destroy();}function x(){var i=0;var z=null;if(o.initialFocus){if(o.initialFocus instanceof sap.ui.core.Control){z=o.initialFocus;}if(typeof o.initialFocus==="string"){for(i=0;i<g.length;i++){if(M.Action.hasOwnProperty(o.initialFocus)){if(t._rb.getText("MSGBOX_"+o.initialFocus).toLowerCase()===g[i].getText().toLowerCase()){z=g[i];break;}}else{if(o.initialFocus.toLowerCase()===g[i].getText().toLowerCase()){z=g[i];break;}}}}}return z;}if(typeof(v)==="string"){f=new T({textDirection:o.textDirection}).setText(v).addStyleClass("sapMMsgBoxText");e=f;}else if(v instanceof sap.ui.core.Control){f=v.addStyleClass("sapMMsgBoxText");}if(o&&o.hasOwnProperty("details")&&o.details!==""){f=u(o,f);}function y(){if(sap.ui.getCore().getConfiguration().getAccessibility()){d.$().attr("role","alertdialog");}}d=new D({id:o.id,type:sap.m.DialogType.Message,title:o.title,content:f,icon:m[o.icon],initialFocus:x(),verticalScrolling:o.verticalScrolling,horizontalScrolling:o.horizontalScrolling,afterOpen:y,afterClose:w,buttons:g,ariaLabelledBy:e?e.getId():undefined});if(c[o.icon]){d.addStyleClass(c[o.icon]);}else{d.addStyleClass(c.STANDARD);}if(o.styleClass){d.addStyleClass(o.styleClass);}d.open();};
M.alert=function(v,o){_();var d={icon:b.NONE,title:this._rb.getText("MSGBOX_TITLE_ALERT"),actions:A.OK,id:sap.ui.core.ElementMetadata.uid("alert"),initialFocus:null},C,t,s,S;if(typeof o==="function"||arguments.length>2){C=arguments[1];t=arguments[2];s=arguments[3];S=arguments[4];o={onClose:C,title:t,id:s,styleClass:S};}o=q.extend({},d,o);return M.show(v,o);};
M.confirm=function(v,o){_();var d={icon:b.QUESTION,title:this._rb.getText("MSGBOX_TITLE_CONFIRM"),actions:[A.OK,A.CANCEL],id:sap.ui.core.ElementMetadata.uid("confirm"),initialFocus:null},C,t,s,S;if(typeof o==="function"||arguments.length>2){C=arguments[1];t=arguments[2];s=arguments[3];S=arguments[4];o={onClose:C,title:t,id:s,styleClass:S};}o=q.extend({},d,o);return M.show(v,o);};
M.error=function(v,o){_();var d={icon:b.ERROR,title:this._rb.getText("MSGBOX_TITLE_ERROR"),actions:[A.CLOSE],id:sap.ui.core.ElementMetadata.uid("error"),initialFocus:null};o=q.extend({},d,o);return M.show(v,o);};
M.information=function(v,o){_();var d={icon:b.INFORMATION,title:this._rb.getText("MSGBOX_TITLE_INFO"),actions:[A.OK],id:sap.ui.core.ElementMetadata.uid("info"),initialFocus:null};o=q.extend({},d,o);return M.show(v,o);};
M.warning=function(v,o){_();var d={icon:b.WARNING,title:this._rb.getText("MSGBOX_TITLE_WARNING"),actions:[A.OK],id:sap.ui.core.ElementMetadata.uid("warning"),initialFocus:null};o=q.extend({},d,o);return M.show(v,o);};
M.success=function(v,o){_();var d={icon:b.SUCCESS,title:this._rb.getText("MSGBOX_TITLE_SUCCESS"),actions:[A.OK],id:sap.ui.core.ElementMetadata.uid("success"),initialFocus:null};o=q.extend({},d,o);return M.show(v,o);};
}());return M;},true);
sap.ui.predefine('sap/m/MessagePage',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool'],function(q,l,C,I){"use strict";
var M=C.extend("sap.m.MessagePage",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:"No matching items found."},description:{type:"string",group:"Misc",defaultValue:"Check the filter settings."},title:{type:"string",group:"Misc",defaultValue:null},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},showNavButton:{type:"boolean",group:"Appearance",defaultValue:false},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:"sap-icon://documents"},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}},aggregations:{customText:{type:"sap.m.Link",multiple:false},customDescription:{type:"sap.m.Link",multiple:false},_page:{type:"sap.m.Page",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{navButtonPress:{}}}});
M.prototype.init=function(){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setAggregation("_page",new sap.m.Page({id:this.getId()+"-page",showHeader:this.getShowHeader(),navButtonPress:q.proxy(function(){this.fireNavButtonPress();},this)}));this.setProperty("text",b.getText("MESSAGE_PAGE_TEXT"),true);this.setProperty("description",b.getText("MESSAGE_PAGE_DESCRIPTION"),true);};
M.prototype.onBeforeRendering=function(){if(!(this._oText&&this._oDescription)){this._addPageContent();}};
M.prototype.exit=function(){var p=this.getAggregation("_page");if(p){p.destroy();p=null;}if(this._oText){this._oText=null;}if(this._oDescription){this._oDescription=null;}if(this._oIconControl){this._oIconControl=null;}};
M.prototype.setTitle=function(t){this.setProperty("title",t,true);this.getAggregation("_page").setTitle(t);return this;};
M.prototype.setText=function(t){this.setProperty("text",t,true);this._oText&&this._oText.setText(t);return this;};
M.prototype.setDescription=function(d){this.setProperty("description",d,true);this._oDescription&&this._oDescription.setText(d);return this;};
M.prototype.setShowHeader=function(s){this.setProperty("showHeader",s,true);this.getAggregation("_page").setShowHeader(s);return this;};
M.prototype.setShowNavButton=function(s){this.setProperty("showNavButton",s,true);this.getAggregation("_page").setShowNavButton(s);return this;};
M.prototype.setTextDirection=function(t){this.setProperty("textDirection",t,true);this._oText&&this._oText.setTextDirection(t);this._oDescription&&this._oDescription.setTextDirection(t);return this;};
M.prototype.setIcon=function(i){var o=this.getIcon();this.setProperty("icon",i,true);if(this._oIconControl){if(o!==i&&I.isIconURI(o)!=I.isIconURI(i)){var p=this.getAggregation("_page");p.removeContent(this._oIconControl);this._oIconControl.destroy();p.insertContent(this._getIconControl(),0);}else{this._oIconControl.setSrc(i);}}return this;};
M.prototype._addPageContent=function(){var p=this.getAggregation("_page");if(this.getAggregation("customText")){this._oText=this.getAggregation("customText");}else{this._oText=new sap.m.Text({id:this.getId()+"-customText",text:this.getText(),textAlign:sap.ui.core.TextAlign.Center,textDirection:this.getTextDirection()});}if(this.getAggregation("customDescription")){this._oDescription=this.getAggregation("customDescription");}else{this._oDescription=new sap.m.Text({id:this.getId()+"-customDescription",text:this.getDescription(),textAlign:sap.ui.core.TextAlign.Center,textDirection:this.getTextDirection()});}p.addContent(this._getIconControl());p.addContent(this._oText.addStyleClass("sapMMessagePageMainText"));p.addContent(this._oDescription.addStyleClass("sapMMessagePageDescription"));};
M.prototype._getIconControl=function(){this._oIconControl=I.createControlByURI({id:this.getId()+"-pageIcon",src:this.getIcon(),height:"8rem",useIconTooltip:true,decorative:false},sap.m.Image).addStyleClass("sapMMessagePageIcon");return this._oIconControl;};
M.prototype._getAnyHeader=function(){return this._getInternalHeader();};
M.prototype._getInternalHeader=function(){return this.getAggregation("_page").getAggregation("_internalHeader");};
return M;},true);
sap.ui.predefine('sap/m/MessagePageRenderer',['jquery.sap.global'],function(q){"use strict";var M={};
M.render=function(r,m){r.write("<div");r.writeControlData(m);r.addClass("sapMMessagePage");r.writeClasses();r.write(">");r.renderControl(m.getAggregation("_page"));r.write("</div>");};
return M;},true);
sap.ui.predefine('sap/m/MessagePopover',["jquery.sap.global","./ResponsivePopover","./Button","./Toolbar","./ToolbarSpacer","./Bar","./List","./StandardListItem","./ListType","./library","sap/ui/core/Control","./PlacementType","sap/ui/core/IconPool","sap/ui/core/HTML","./Text","sap/ui/core/Icon","./SegmentedButton","./Page","./NavContainer","./semantic/SemanticPage","./Link","./Popover","./MessagePopoverItem","jquery.sap.dom"],function(q,R,B,T,a,b,L,S,c,l,C,P,I,H,d,e,f,g,N,h,j,k,M){"use strict";
var m=C.extend("sap.m.MessagePopover",{metadata:{library:"sap.m",properties:{asyncDescriptionHandler:{type:"any",group:"Behavior",defaultValue:null},asyncURLHandler:{type:"any",group:"Behavior",defaultValue:null},placement:{type:"sap.m.VerticalPlacementType",group:"Behavior",defaultValue:"Vertical"},initiallyExpanded:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MessagePopoverItem",multiple:true,singularName:"item"},headerButton:{type:"sap.m.Button",multiple:false}},events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},itemSelect:{parameters:{item:{type:"sap.m.MessagePopoverItem"},messageTypeFilter:{type:"sap.ui.core.MessageType"}}},listSelect:{parameters:{messageTypeFilter:{type:"sap.ui.core.MessageType"}}},longtextLoaded:{},urlValidated:{}}}});
var n="sapMMsgPopover",o={back:I.getIconURI("nav-back"),close:I.getIconURI("decline"),information:I.getIconURI("message-information"),warning:I.getIconURI("message-warning"),error:I.getIconURI("message-error"),success:I.getIconURI("message-success")},p=["all","error","warning","success","information"],A=["asyncDescriptionHandler","asyncURLHandler"],D={asyncDescriptionHandler:function(i){var s=i.item.getLongtextUrl();if(s){q.ajax({type:"GET",url:s,success:function(r){i.item.setDescription(r);i.promise.resolve();},error:function(){var E="A request has failed for long text data. URL: "+s;q.sap.log.error(E);i.promise.reject(E);}});}}};
m.setDefaultHandlers=function(i){A.forEach(function(F){if(i.hasOwnProperty(F)){D[F]=i[F];}});};
m.prototype.init=function(){var t=this;var i;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oPopover=new R(this.getId()+"-messagePopover",{showHeader:false,contentWidth:"440px",placement:this.getPlacement(),showCloseButton:false,modal:false,afterOpen:function(E){t.fireAfterOpen({openBy:E.getParameter("openBy")});},afterClose:function(E){t._navContainer.backToTop();t.fireAfterClose({openBy:E.getParameter("openBy")});},beforeOpen:function(E){t.fireBeforeOpen({openBy:E.getParameter("openBy")});},beforeClose:function(E){t.fireBeforeClose({openBy:E.getParameter("openBy")});}}).addStyleClass(n);this._createNavigationPages();this._createLists();i=this._oPopover.getAggregation("_popup");i.oPopup.setAutoClose(false);i.addEventDelegate({onBeforeRendering:this.onBeforeRenderingPopover,onkeypress:this._onkeypress},this);if(sap.ui.Device.system.phone){this._oPopover.setBeginButton(new B({text:this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE"),press:this.close.bind(this)}));}A.forEach(function(F){if(D.hasOwnProperty(F)){t.setProperty(F,D[F]);}});};
m.prototype.exit=function(){this._oResourceBundle=null;this._oListHeader=null;this._oDetailsHeader=null;this._oSegmentedButton=null;this._oBackButton=null;this._navContainer=null;this._listPage=null;this._detailsPage=null;this._sCurrentList=null;if(this._oLists){this._destroyLists();}if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}};
m.prototype.onBeforeRenderingPopover=function(){var i=this.getHeaderButton();if(i){this._oListHeader.insertContent(i,2);}if(!this.getBindingInfo("items")&&!this.getItems().length){this._makeAutomaticBinding();}if(this._bItemsChanged){this._clearLists();this._fillLists(this.getItems());this._clearSegmentedButton();this._fillSegmentedButton();this._bItemsChanged=false;}this._setInitialFocus();};
m.prototype._makeAutomaticBinding=function(){this.setModel(sap.ui.getCore().getMessageManager().getMessageModel(),"message");this.bindAggregation("items",{path:"message>/",template:new M({type:"{message>type}",title:"{message>message}",description:"{message>description}",longtextUrl:"{message>longtextUrl}"})});};
m.prototype._onkeypress=function(E){if(E.shiftKey&&E.keyCode==q.sap.KeyCodes.ENTER){this._fnHandleBackPress();}};
m.prototype._getListHeader=function(){return this._oListHeader||this._createListHeader();};
m.prototype._getDetailsHeader=function(){return this._oDetailsHeader||this._createDetailsHeader();};
m.prototype._createListHeader=function(){var s=this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE");var i=this.getId()+"-CloseBtnDescr";var r=new H(i,{content:"<span id=\""+i+"\" style=\"display: none;\">"+s+"</span>"});var t=this._oResourceBundle.getText("MESSAGEPOPOVER_ARIA_HEADING");var u=this.getId()+"-HeadingDescr";var v=new H(u,{content:"<span id=\""+u+"\" style=\"display: none;\" role=\"heading\">"+t+"</span>"});this._oPopover.addAssociation("ariaLabelledBy",u,true);var w=new B({icon:o["close"],visible:!sap.ui.Device.system.phone,ariaLabelledBy:r,tooltip:s,press:this.close.bind(this)}).addStyleClass(n+"CloseBtn");this._oSegmentedButton=new f(this.getId()+"-segmented",{}).addStyleClass("sapMSegmentedButtonNoAutoWidth");this._oListHeader=new T({content:[this._oSegmentedButton,new a(),w,r,v]});return this._oListHeader;};
m.prototype._createDetailsHeader=function(){var s=this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE");var i=this.getId()+"-CloseBtnDetDescr";var r=new H(i,{content:"<span id=\""+i+"\" style=\"display: none;\">"+s+"</span>"});var t=this._oResourceBundle.getText("MESSAGEPOPOVER_ARIA_BACK_BUTTON_TOOLTIP");var u=this._oResourceBundle.getText("MESSAGEPOPOVER_ARIA_BACK_BUTTON");var v=this.getId()+"-BackBtnDetDescr";var w=new H(v,{content:"<span id=\""+v+"\" style=\"display: none;\">"+u+"</span>"});var x=new B({icon:o["close"],visible:!sap.ui.Device.system.phone,ariaLabelledBy:r,tooltip:s,press:this.close.bind(this)}).addStyleClass(n+"CloseBtn");this._oBackButton=new B({icon:o["back"],press:this._fnHandleBackPress.bind(this),ariaLabelledBy:w,tooltip:t}).addStyleClass(n+"BackBtn");this._oDetailsHeader=new T({content:[this._oBackButton,new a(),x,r,w]});return this._oDetailsHeader;};
m.prototype._createNavigationPages=function(){this._listPage=new g(this.getId()+"listPage",{customHeader:this._getListHeader()});this._detailsPage=new g(this.getId()+"-detailsPage",{customHeader:this._getDetailsHeader()});this._detailsPage.addEventDelegate({onclick:function(E){var t=E.target;if(t.nodeName.toUpperCase()==='A'&&(t.className.indexOf('sapMMsgPopoverItemDisabledLink')!==-1||t.className.indexOf('sapMMsgPopoverItemPendingLink')!==-1)){E.preventDefault();}}});this._navContainer=new N(this.getId()+"-navContainer",{initialPage:this.getId()+"listPage",pages:[this._listPage,this._detailsPage],navigate:this._navigate.bind(this),afterNavigate:this._afterNavigate.bind(this)});this._oPopover.addContent(this._navContainer);return this;};
m.prototype._createLists=function(){this._oLists={};p.forEach(function(s){this._oLists[s]=new L({itemPress:this._fnHandleItemPress.bind(this),visible:false});this._listPage.addAggregation("content",this._oLists[s],true);},this);return this;};
m.prototype._clearLists=function(){p.forEach(function(s){if(this._oLists[s]){this._oLists[s].destroyAggregation("items",true);}},this);return this;};
m.prototype._destroyLists=function(){p.forEach(function(s){this._oLists[s]=null;},this);this._oLists=null;};
m.prototype._fillLists=function(i){i.forEach(function(r){var s=this._mapItemToListItem(r),t=this._mapItemToListItem(r);this._oLists["all"].addAggregation("items",s,true);this._oLists[r.getType().toLowerCase()].addAggregation("items",t,true);},this);};
m.prototype._mapItemToListItem=function(i){if(!i){return null;}var t=i.getType(),r=this._getItemType(i),s=new S({title:i.getTitle(),description:i.getSubtitle(),counter:i.getCounter(),icon:this._mapIcon(t),infoState:this._mapInfoState(t),info:"\r",type:r}).addStyleClass(n+"Item").addStyleClass(n+"Item"+t);if(r!==c.Navigation){s.addEventDelegate({onAfterRendering:function(){var u=this.getDomRef().querySelector(".sapMSLITitleDiv > div");if(u.offsetWidth<u.scrollWidth){this.setType(c.Navigation);}}},s);}s._oMessagePopoverItem=i;return s;};
m.prototype._mapInfoState=function(t){if(!t){return null;}var i=sap.ui.core.MessageType,V=sap.ui.core.ValueState;switch(t){case i.Warning:return V.Warning;case i.Error:return V.Error;case i.Success:return V.Success;case i.Information:case i.None:return V.None;default:q.sap.log.warning("The provided MessageType is not mapped to a specific ValueState",t);return null;}};
m.prototype._mapIcon=function(i){if(!i){return null;}return o[i.toLowerCase()];};
m.prototype._getItemType=function(i){return(i.getDescription()||i.getMarkupDescription()||i.getLongtextUrl())?c.Navigation:c.Inactive;};
m.prototype._clearSegmentedButton=function(){if(this._oSegmentedButton){this._oSegmentedButton.destroyAggregation("buttons",true);}return this;};
m.prototype._fillSegmentedButton=function(){var t=this;var i=function(s){return function(){t._fnFilterList(s);};};p.forEach(function(s){var r=this._oLists[s],u=r.getItems().length,v;if(u>0){v=new B(this.getId()+"-"+s,{text:s=="all"?this._oResourceBundle.getText("MESSAGEPOPOVER_ALL"):u,icon:o[s],press:i(s)}).addStyleClass(n+"Btn"+s.charAt(0).toUpperCase()+s.slice(1));this._oSegmentedButton.addButton(v,true);}},this);return this;};
m.prototype._setIcon=function(i,r){this._previousIconTypeClass=n+"DescIcon"+i.getType();this._oMessageIcon=new e({src:r.getIcon()}).addStyleClass(n+"DescIcon").addStyleClass(this._previousIconTypeClass);this._detailsPage.addContent(this._oMessageIcon);};
m.prototype._setTitle=function(i){this._oMessageTitleText=new d(this.getId()+'MessageTitleText',{text:i.getTitle()}).addStyleClass('sapMMsgPopoverTitleText');this._detailsPage.addAggregation("content",this._oMessageTitleText);};
m.prototype._setDescription=function(i){var r=i.getLink();this._oLastSelectedItem=i;if(i.getMarkupDescription()){this._oMessageDescriptionText=new H(this.getId()+'MarkupDescription',{content:"<div class='sapMMsgPopoverDescriptionText'>"+i.getDescription()+"</div>"});}else{this._oMessageDescriptionText=new d(this.getId()+'MessageDescriptionText',{text:i.getDescription()}).addStyleClass('sapMMsgPopoverDescriptionText');}this._detailsPage.addContent(this._oMessageDescriptionText);if(r){this._detailsPage.addContent(r);r.addStyleClass("sapMMsgPopoverDescriptionLink");}};
m.prototype._iNextValidationTaskId=0;
m.prototype._validateURL=function(u){if(q.sap.validateUrl(u)){return u;}q.sap.log.warning("You have entered invalid URL");return'';};
m.prototype._queueValidation=function(i){var r=this.getAsyncURLHandler();var v=++this._iNextValidationTaskId;var s={};var t=new window.Promise(function(u,w){s.resolve=u;s.reject=w;var x={url:i,id:v,promise:s};r(x);});t.id=v;return t;};
m.prototype._getTagPolicy=function(){var t=this,i;var r=html.makeTagPolicy(this._validateURL());return function customTagPolicy(s,u){var v,w=false;if(s.toUpperCase()==="A"){for(i=0;i<u.length;){if(u[i]==="href"){w=true;v=u[i+1];u.splice(0,2);continue;}i+=2;}}u=r(s,u);if(w&&typeof t.getAsyncURLHandler()==="function"){u=u||[];var x=false;for(i=0;i<u.length;i+=2){if(u[i]==="class"){u[i+1]+="sapMMsgPopoverItemDisabledLink sapMMsgPopoverItemPendingLink";x=true;break;}}var y=u.indexOf("id");if(y>-1){u.splice(y+1,1);u.splice(y,1);}if(!x){u.unshift("sapMMsgPopoverItemDisabledLink sapMMsgPopoverItemPendingLink");u.unshift("class");}var V=t._queueValidation(v);u.push("href");u.push(v);u.push("target");u.push("_blank");u.push("id");u.push("sap-ui-"+t.getId()+"-link-under-validation-"+V.id);V.then(function(z){var $=q.sap.byId("sap-ui-"+t.getId()+"-link-under-validation-"+z.id);if(z.allowed){q.sap.log.info("Allow link "+v);}else{q.sap.log.info("Disallow link "+v);}$.removeClass('sapMMsgPopoverItemPendingLink');$.toggleClass('sapMMsgPopoverItemDisabledLink',!z.allowed);t.fireUrlValidated();}).catch(function(){q.sap.log.warning("Async URL validation could not be performed.");});}return u;};};
m.prototype._sanitizeDescription=function(i){q.sap.require("jquery.sap.encoder");q.sap.require("sap.ui.thirdparty.caja-html-sanitizer");var s=i.getDescription();if(i.getMarkupDescription()){var t=this._getTagPolicy();s=html.sanitizeWithPolicy(s,t);}i.setDescription(s);this._setDescription(i);};
m.prototype._fnHandleItemPress=function(E){var i=E.getParameter("listItem"),r=i._oMessagePopoverItem,s=this._detailsPage.getContent()||[];var t=this.getAsyncDescriptionHandler();var u=function(y){this._setTitle(r);this._sanitizeDescription(r);this._setIcon(r,i);this.fireLongtextLoaded();if(!y){this._navContainer.to(this._detailsPage);}}.bind(this);this._previousIconTypeClass=this._previousIconTypeClass||'';this.fireItemSelect({item:r,messageTypeFilter:this._getCurrentMessageTypeFilter()});s.forEach(function(y){if(y instanceof j){this._oLastSelectedItem.setLink(y);y.removeAllAriaLabelledBy();}else{y.destroy();}},this);if(typeof t==="function"&&!!r.getLongtextUrl()){r.setMarkupDescription(true);var v={};var w=new window.Promise(function(y,z){v.resolve=y;v.reject=z;});var x=function(){this._detailsPage.setBusy(false);u(true);}.bind(this);w.then(function(){x();}).catch(function(){q.sap.log.warning("Async description loading could not be performed.");x();});this._navContainer.to(this._detailsPage);this._detailsPage.setBusy(true);t({promise:v,item:r});}else{u();}this._listPage.$().attr("aria-hidden","true");};
m.prototype._fnHandleBackPress=function(){this._listPage.$().removeAttr("aria-hidden");this._navContainer.back();};
m.prototype._fnFilterList=function(s){p.forEach(function(i){if(i!=s&&this._oLists[i].getVisible()){this._oLists[i].setVisible(false);}},this);this._sCurrentList=s;this._oLists[s].setVisible(true);this._expandMsgPopover();this.fireListSelect({messageTypeFilter:this._getCurrentMessageTypeFilter()});};
m.prototype._getCurrentMessageTypeFilter=function(){return this._sCurrentList=="all"?"":this._sCurrentList;};
m.prototype._navigate=function(){if(this._isListPage()){this._oRestoreFocus=q(document.activeElement);}};
m.prototype._afterNavigate=function(){q.sap.delayedCall(0,this,this._restoreFocus);};
m.prototype._isListPage=function(){return(this._navContainer.getCurrentPage()==this._listPage);};
m.prototype._setInitialFocus=function(){if(this._isListPage()){this._oPopover.setInitialFocus(this._oLists[this._sCurrentList]);}};
m.prototype._restoreFocus=function(){if(this._isListPage()){var r=this._oRestoreFocus&&this._oRestoreFocus.control(0);if(r){r.focus();}}else{this._oBackButton.focus();}};
m.prototype._restoreExpansionDefaults=function(){if(this.getInitiallyExpanded()){this._fnFilterList("all");this._oSegmentedButton.setSelectedButton(null);}else{this._collapseMsgPopover();}};
m.prototype._expandMsgPopover=function(){var s=this._oPopover.getContentWidth();if(this.getInitiallyExpanded()){s=this._oPopover.$("cont").css("height")||s;}this._oPopover.setContentHeight(s).removeStyleClass(n+"-init");};
m.prototype._collapseMsgPopover=function(){p.forEach(function(s){this._oLists[s].setVisible(false);},this);this._oPopover.addStyleClass(n+"-init").setContentHeight("auto");this._oSegmentedButton.setSelectedButton("none");};
m.prototype.openBy=function(i){var r=this._oPopover.getAggregation("_popup"),s=i.getParent();if(r instanceof k){if((s instanceof T||s instanceof b||s instanceof h)){r.setShowArrow(false);r.setResizable(true);}else{r.setShowArrow(true);}}if(this._oPopover){this._restoreExpansionDefaults();this._oPopover.openBy(i);}return this;};
m.prototype.close=function(){if(this._oPopover){this._oPopover.close();}return this;};
m.prototype.isOpen=function(){return this._oPopover.isOpen();};
m.prototype.toggle=function(i){if(this.isOpen()){this.close();}else{this.openBy(i);}return this;};
m.prototype.setPlacement=function(s){this.setProperty("placement",s,true);this._oPopover.setPlacement(s);return this;};
m.prototype.getDomRef=function(s){return this._oPopover&&this._oPopover.getAggregation("_popup").getDomRef(s);};
["addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass","getBusyIndicatorDelay","setBusyIndicatorDelay","getVisible","setVisible","getBusy","setBusy"].forEach(function(s){m.prototype[s]=function(){if(this._oPopover&&this._oPopover[s]){var i=this._oPopover;var r=i[s].apply(i,arguments);return r===i?this:r;}};});["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(F){m.prototype["_"+F+"Old"]=m.prototype[F];m.prototype[F]=function(){var r=m.prototype["_"+F+"Old"].apply(this,arguments);this._bItemsChanged=true;if(this._oPopover){this._oPopover.invalidate();}if(["removeAggregation","removeAllAggregation"].indexOf(F)!==-1){return r;}return this;};});return m;},true);
sap.ui.predefine('sap/m/MessagePopoverItem',["jquery.sap.global","./library","sap/ui/core/Item"],function(q,l,I){"use strict";
var M=I.extend("sap.m.MessagePopoverItem",{metadata:{library:"sap.m",properties:{type:{type:"sap.ui.core.MessageType",group:"Appearance",defaultValue:sap.ui.core.MessageType.Error},title:{type:"string",group:"Appearance",defaultValue:""},subtitle:{type:"string",group:"Misc",defaultValue:null},description:{type:"string",group:"Appearance",defaultValue:""},markupDescription:{type:"boolean",group:"Appearance",defaultValue:false},longtextUrl:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},counter:{type:"int",group:"Misc",defaultValue:null}},defaultAggregation:"link",aggregations:{link:{type:"sap.m.Link",multiple:false,singularName:"link"}}}});
M.prototype.setProperty=function(p,v,s){var P=this.getParent(),t=this.getType().toLowerCase(),a=["description","type"],u=function(n,i){if(i._oMessagePopoverItem.getId()===this.getId()&&i.getMetadata().getProperty(n)){i.setProperty(n,v);}};if(a.indexOf(p)===-1&&P&&("_bItemsChanged"in P)&&!P._bItemsChanged){P._oLists&&P._oLists.all&&P._oLists.all.getItems&&P._oLists.all.getItems().forEach(u.bind(this,p));P._oLists&&P._oLists[t]&&P._oLists[t].getItems&&P._oLists[t].getItems().forEach(u.bind(this,p));}return I.prototype.setProperty.apply(this,arguments);};
M.prototype.setDescription=function(d){if(typeof d==='undefined'){d='';}if(this.getMarkupDescription()){d=q.sap._sanitizeHTML(d);}this.setProperty("description",d,true);return this;};
M.prototype.setType=function(t){if(t===sap.ui.core.MessageType.None){t=sap.ui.core.MessageType.Information;q.sap.log.warning("The provided None type is handled and rendered as Information type");}return this.setProperty("type",t,true);};
return M;},true);
sap.ui.predefine('sap/m/MessagePopoverRenderer',["jquery.sap.global"],function(q){"use strict";var M={};
M.render=function(r,c){};
return M;},true);
sap.ui.predefine('sap/m/MessageStrip',["jquery.sap.global","./library","sap/ui/core/Control","./MessageStripUtilities","./Text","./Link"],function(q,l,C,M,T,L){"use strict";
var a=C.extend("sap.m.MessageStrip",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Appearance",defaultValue:""},type:{type:"sap.ui.core.MessageType",group:"Appearance",defaultValue:sap.ui.core.MessageType.Information},customIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},showIcon:{type:"boolean",group:"Appearance",defaultValue:false},showCloseButton:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"link",aggregations:{link:{type:"sap.m.Link",multiple:false,singularName:"link"},_text:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{close:{}}}});
a.prototype.init=function(){this.data("sap-ui-fastnavgroup","true",true);this.setAggregation("_text",new T());};
a.prototype.setText=function(t){this.getAggregation("_text").setText(t);return this.setProperty("text",t,true);};
a.prototype.setType=function(t){if(t===sap.ui.core.MessageType.None){q.sap.log.warning(M.MESSAGES.TYPE_NOT_SUPPORTED);t=sap.ui.core.MessageType.Information;}return this.setProperty("type",t);};
a.prototype.setAggregation=function(n,c,s){if(n==="link"&&c instanceof L){c.addAriaLabelledBy(this.getId());}C.prototype.setAggregation.call(this,n,c,s);return this;};
a.prototype.ontap=M.handleMSCloseButtonInteraction;a.prototype.onsapenter=M.handleMSCloseButtonInteraction;a.prototype.onsapspace=M.handleMSCloseButtonInteraction;
a.prototype.ontouchmove=function(e){e.setMarked();};
a.prototype.close=function(){var c=function(){this.fireClose();this.setVisible(false);}.bind(this);if(!sap.ui.getCore().getConfiguration().getAnimation()){c();return;}if(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<10){M.closeTransitionWithJavascript.call(this,c);}else{M.closeTransitionWithCSS.call(this,c);}};
return a;},true);
sap.ui.predefine('sap/m/MessageStripRenderer',["./MessageStripUtilities"],function(M){"use strict";var a={};
a.render=function(r,c){this.startMessageStrip(r,c);this.renderAriaTypeText(r,c);if(c.getShowIcon()){this.renderIcon(r,c);}this.renderTextAndLink(r,c);if(c.getShowCloseButton()){this.renderCloseButton(r);}this.endMessageStrip(r);};
a.startMessageStrip=function(r,c){r.write("<div");r.addClass(M.CLASSES.ROOT);r.addClass(M.CLASSES.ROOT+c.getType());r.writeControlData(c);r.writeClasses();r.writeAttribute(M.ATTRIBUTES.CLOSABLE,c.getShowCloseButton());r.writeAccessibilityState(c,M.getAccessibilityState.call(c));r.write(">");};
a.renderAriaTypeText=function(r,c){r.write("<span class='sapUiPseudoInvisibleText'>");r.write(M.getAriaTypeText.call(c));r.write("</span>");};
a.renderIcon=function(r,c){r.write("<div class='"+M.CLASSES.ICON+"'>");r.writeIcon(M.getIconURI.call(c),null,{"title":null});r.write("</div>");};
a.renderTextAndLink=function(r,c){r.write("<div class='"+M.CLASSES.MESSAGE+"'>");r.renderControl(c.getAggregation("_text"));r.renderControl(c.getLink());r.write("</div>");};
a.renderCloseButton=function(r){r.write("<button");r.writeAttribute("class",M.CLASSES.CLOSE_BUTTON);r.writeAttribute("aria-label",M.RESOURCE_BUNDLE.getText("CLOSE"));r.write("></button>");};
a.endMessageStrip=function(r){r.write("</div>");};
return a;},true);
sap.ui.predefine('sap/m/MessageStripUtilities',function(){"use strict";var M={};M.MESSAGES={TYPE_NOT_SUPPORTED:"Value 'sap.ui.core.MessageType.None' for property 'type' is not supported."+"Defaulting to 'sap.ui.core.MessageType.Information'"};M.CLASSES={ROOT:"sapMMsgStrip",ICON:"sapMMsgStripIcon",MESSAGE:"sapMMsgStripMessage",CLOSE_BUTTON:"sapMMsgStripCloseButton",CLOSING_TRANSITION:"sapMMsgStripClosing"};M.ATTRIBUTES={CLOSABLE:"data-sap-ui-ms-closable"};M.RESOURCE_BUNDLE=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core");
M.getIconURI=function(){var t=this.getType(),c=this.getCustomIcon(),i="sap-icon://message-"+t.toLowerCase();return c||i;};
M.getAriaTypeText=function(){var b="MESSAGE_STRIP_"+this.getType().toUpperCase(),a=M.RESOURCE_BUNDLE.getText(b);if(this.getShowCloseButton()){a+=" "+M.RESOURCE_BUNDLE.getText("MESSAGE_STRIP_CLOSABLE");}return a;};
M.handleMSCloseButtonInteraction=function(e){if(M.isMSCloseButtonPressed(e.target)){this.close();}};
M.isMSCloseButtonPressed=function(t){return t.className.indexOf(M.CLASSES.CLOSE_BUTTON)!==-1||t.parentNode.className.indexOf(M.CLASSES.CLOSE_BUTTON)!==-1;};
M.closeTransitionWithJavascript=function(c){this.$().animate({opacity:0},{duration:200,complete:c});};
M.closeTransitionWithCSS=function(c){this.$().addClass(M.CLASSES.CLOSING_TRANSITION).one("webkitTransitionEnd transitionend",c);};
M.getAccessibilityState=function(){return{role:"note",live:"assertive",labelledby:this.getId()};};
return M;});
sap.ui.predefine('sap/m/MessageToast',['jquery.sap.global','./InstanceManager','sap/ui/core/Popup'],function(q,I,P){"use strict";var M={};var O="0 -64",C="sapMMessageToast",E="sapUiSelectable",B="sapContrast",a="sapContrastPlus";M._mSettings={duration:3000,width:"15em",my:"center bottom",at:"center bottom",of:document.defaultView,offset:"0 0",collision:"fit fit",onClose:null,animationTimingFunction:"ease",animationDuration:1000,autoClose:true,closeOnBrowserNavigation:true};M._aPopups=[];M._iOpenedPopups=0;M._bBoundedEvents=false;
M._validateSettings=function(s){this._isFiniteInteger(s.duration);this._validateWidth(s.width);this._validateDockPosition(s.my);this._validateDockPosition(s.at);this._validateOf(s.of);this._validateOffset(s.offset);this._validateCollision(s.collision);this._validateOnClose(s.onClose);this._validateAutoClose(s.autoClose);this._validateAnimationTimingFunction(s.animationTimingFunction);this._isFiniteInteger(s.animationDuration);};
M._isFiniteInteger=function(N){if(typeof N!=="number"||!isFinite(N)||!(Math.floor(N)===N)||N<=0){q.sap.log.error('"iNumber" needs to be a finite positive nonzero integer on '+this+"._isFiniteInteger");}};
M._validateWidth=function(w){if(!sap.ui.core.CSSSize.isValid(w)){q.sap.log.error(w+' is not of type '+'"sap.ui.core.CSSSize" for property "width" on '+this+"._validateWidth");}};
M._validateDockPosition=function(d){if(!sap.ui.core.Dock.isValid(d)){q.sap.log.error('"'+d+'"'+' is not of type '+'"sap.ui.core.Popup.Dock" on '+this+"._validateDockPosition");}};
M._validateOf=function(e){if(!(e instanceof q)&&!(e&&e.nodeType===1)&&!(e instanceof sap.ui.core.Control)&&e!==window){q.sap.log.error('"of" needs to be an instance of sap.ui.core.Control or an Element or a jQuery object or the window on '+this+"._validateOf");}};
M._validateOffset=function(o){if(typeof o!=="string"){q.sap.log.error(o+' is of type '+typeof o+', expected "string" for property "offset" on '+this+"._validateOffset");}};
M._validateCollision=function(s){var r=/^(fit|flip|none|flipfit|flipflip|flip flip|flip fit|fitflip|fitfit|fit fit|fit flip)$/i;if(!r.test(s)){q.sap.log.error('"collision" needs to be a single value “fit”, “flip”, or “none”, or a pair for horizontal and vertical e.g. "fit flip”, "fit none", "flipfit" on '+this+"._validateOffset");}};
M._validateOnClose=function(f){if(typeof f!=="function"&&f!==null){q.sap.log.error('"onClose" should be a function or null on '+this+"._validateOnClose");}};
M._validateAutoClose=function(b){if(typeof b!=="boolean"){q.sap.log.error('"autoClose" should be a boolean on '+this+"._validateAutoClose");}};
M._validateAnimationTimingFunction=function(t){var r=/^(ease|linear|ease-in|ease-out|ease-in-out)$/i;if(!r.test(t)){q.sap.log.error('"animationTimingFunction" should be a string, expected values: '+"ease, linear, ease-in, ease-out, ease-in-out on "+this+"._validateAnimationTimingFunction");}};
function h(o){for(var p=["my","at","of","offset"],i=0;i<p.length;i++){if(o[p[i]]!==undefined){return false;}}return true;}
function c(s){var m=document.createElement("div");m.style.width=s.width;m.className=C+" "+E+" "+B+" "+a;m.setAttribute("role","alert");m.appendChild(document.createTextNode(s.message));return m;}
function n(o){if(o){if(h(o)){o.offset=O;}if(o.of&&o.of.nodeType===9){o.of=document.defaultView;}}else{o={offset:O};}return o;}
M._handleResizeEvent=function(){if(sap.ui.Device.system.phone||sap.ui.Device.system.tablet){this._resetPosition(this._aPopups);}q.sap.delayedCall(0,this,"_applyPositions",[this._aPopups]);};
M._handleMouseDownEvent=function(e){var i=e.target.hasAttribute("class")&&e.target.getAttribute("class").indexOf(C)!==-1;if(i||e.isMarked("delayedMouseEvent")){return;}this._aPopups.forEach(function(p){p&&p.__bAutoClose&&p.close();});};
M._resetPosition=function(p){for(var i=0,m;i<p.length;i++){m=p[i]&&p[i].getContent();if(m){m.style.visibility="hidden";m.style.left=0;}}};
M._applyPositions=function(p){for(var i=0,o,m;i<p.length;i++){o=p[i];if(o){m=o._oPosition;if(sap.ui.Device.system.phone||sap.ui.Device.system.tablet){q.sap.delayedCall(0,this,"_applyPosition",[o,m]);}else{o.setPosition(m.my,m.at,m.of,m.offset);}}}};
M._applyPosition=function(p,m){var m=m||p._oPosition,o=p.getContent();p.setPosition(m.my,m.at,m.of,m.offset);o.style.visibility="visible";};
M._setCloseAnimation=function(m,d,f,s){var b="opacity "+s.animationTimingFunction+" "+s.animationDuration+"ms",t="webkitTransitionEnd."+C+" transitionend."+C;if(sap.ui.getCore().getConfiguration().getAnimation()&&s.animationDuration>0){m[0].style.webkitTransition=b;m[0].style.transition=b;m[0].style.opacity=0;m.on(t,function handleMTTransitionEnd(){m.off(t);f();});}else{f();}};
M.show=function(m,o){var t=this,s=q.extend({},this._mSettings,{message:m}),p=new P(),i,b,d="mousedown."+C+" touchstart."+C,e,f;o=n(o);q.extend(s,o);this._validateSettings(s);b=c(s);i=this._aPopups.push(p)-1;p.setContent(b);p.setPosition(s.my,s.at,s.of,s.offset,s.collision);if(q.support.cssTransitions){p.setAnimations(function fnMessageToastOpen($,D,k){k();},function fnMessageToastClose($,D,k){t._setCloseAnimation($,D,k,s);});}p.setShadow(false);p.__bAutoClose=s.autoClose;if(s.closeOnBrowserNavigation){I.addPopoverInstance(p);}if(!this._bBoundedEvents){q(window).on("resize."+C,this._handleResizeEvent.bind(this));q(document).on(d,this._handleMouseDownEvent.bind(this));this._bBoundedEvents=true;}p.open();this._iOpenedPopups++;function g(){I.removePopoverInstance(t._aPopups[i]);q(t._aPopups[i].getContent()).remove();t._aPopups[i].detachClosed(g);t._aPopups[i].destroy();t._aPopups[i]=null;t._iOpenedPopups--;if(t._iOpenedPopups===0){t._aPopups=[];q(window).off("resize."+C);q(document).off(d);t._bBoundedEvents=false;}if(typeof s.onClose==="function"){s.onClose.call(t);}}p.attachClosed(g);e=q.sap.delayedCall(s.duration,p,"close");function j(){q.sap.clearDelayedCall(e);e=null;function k(){f=q.sap.delayedCall(s.duration,p,"close");p.getContent().removeEventListener("mouseleave",k);}p.getContent().addEventListener("mouseleave",k);q.sap.clearDelayedCall(f);f=null;}p.getContent().addEventListener("touchstart",j);p.getContent().addEventListener("mouseover",j);if(sap.ui.Device.system.desktop){p.getContent().addEventListener("mouseleave",function(){e=q.sap.delayedCall(s.duration,p,"close");});}};
M.toString=function(){return"sap.m.MessageToast";};
return M;},true);
sap.ui.predefine('sap/m/MultiComboBox',['jquery.sap.global','./Bar','./InputBase','./ComboBoxTextField','./ComboBoxBase','./Dialog','./MultiInput','./Input','./ToggleButton','./List','./MultiComboBoxRenderer','./Popover','./library','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','jquery.sap.xml'],function(q,B,I,C,a,D,M,b,T,L,c,P,l,E,d){"use strict";
var e=a.extend("sap.m.MultiComboBox",{metadata:{library:"sap.m",properties:{selectedKeys:{type:"string[]",group:"Data",defaultValue:[]}},associations:{selectedItems:{type:"sap.ui.core.Item",multiple:true,singularName:"selectedItem"}},events:{selectionChange:{parameters:{changedItem:{type:"sap.ui.core.Item"},selected:{type:"boolean"}}},selectionFinish:{parameters:{selectedItems:{type:"sap.ui.core.Item[]"}}}}}});
d.insertFontFaceStyle();E.apply(e.prototype,[true]);
e.prototype.onsapend=function(o){sap.m.Tokenizer.prototype.onsapend.apply(this._oTokenizer,arguments);};
e.prototype.onsaphome=function(o){sap.m.Tokenizer.prototype.onsaphome.apply(this._oTokenizer,arguments);};
e.prototype.onsapdown=function(o){if(!this.getEnabled()||!this.getEditable()){return;}o.setMarked();o.preventDefault();var i=this.getSelectableItems();var f=i[0];if(f&&this.isOpen()){this.getListItem(f).focus();return;}if(this._oTokenizer.getSelectedTokens().length){return;}this._oTraversalItem=this._getNextTraversalItem();if(this._oTraversalItem){this.updateDomValue(this._oTraversalItem.getText());this.selectText(0,this.getValue().length);}this._setContainerSizes();};
e.prototype.onsapup=function(o){if(!this.getEnabled()||!this.getEditable()){return;}o.setMarked();o.preventDefault();if(this._oTokenizer.getSelectedTokens().length){return;}this._oTraversalItem=this._getPreviousTraversalItem();if(this._oTraversalItem){this.updateDomValue(this._oTraversalItem.getText());this.selectText(0,this.getValue().length);}this._setContainerSizes();};
e.prototype._selectItemByKey=function(o){var v,p,f,i,g,h=this.isOpen();if(!this.getEnabled()||!this.getEditable()){return;}if(o){o.setMarked();}v=this._getUnselectedItems(h?"":this.getValue());for(i=0;i<v.length;i++){if(v[i].getText().toUpperCase()===this.getValue().toUpperCase()){f=v[i];g=true;break;}}if(g){p={item:f,id:f.getId(),key:f.getKey(),fireChangeEvent:true,fireFinishEvent:true,suppressInvalidate:true,listItemUpdated:false};this._bPreventValueRemove=false;if(this.getValue()===""||q.sap.startsWithIgnoreCase(f.getText(),this.getValue())){if(this.getListItem(f).isSelected()){this.setValue('');}else{this.setSelection(p);}}}else{this._bPreventValueRemove=true;this._showWrongValueVisualEffect();}if(o){this.close();}};
e.prototype.onsapenter=function(o){I.prototype.onsapenter.apply(this,arguments);this._selectItemByKey(o);};
e.prototype.onsaptabnext=function(o){var i=this.getValue();if(i){var s=this._getUnselectedItemsStartingText(i);if(s.length===1){this._selectItemByKey(o);}else{this._showWrongValueVisualEffect();this.setValue(null);}}};
e.prototype.onsapfocusleave=function(o){var p=this.getAggregation("picker");var f=sap.ui.getCore().byId(o.relatedControlId);var F=f&&f.getFocusDomRef();if(!p||!p.getFocusDomRef()||!F||!q.contains(p.getFocusDomRef(),F)){this.setValue(null);}if(p&&F){if(q.sap.equal(p.getFocusDomRef(),F)){this.focus();}}this._setContainerSizes();};
e.prototype.onfocusin=function(o){this.addStyleClass("sapMFocus");if(o.target===this.getOpenArea()){this.focus();}if(!this.isOpen()&&this.shouldValueStateMessageBeOpened()){this.openValueStateMessage();}};
e.prototype.onsapescape=function(o){a.prototype.onsapescape.apply(this,arguments);this._setContainerSizes();};
e.prototype._handleItemTap=function(o){if(o.target.childElementCount===0||o.target.childElementCount===2){if(this.isOpen()&&!this._isListInSuggestMode()){this.close();}}};
e.prototype._handleItemPress=function(o){if(this.isOpen()&&this._isListInSuggestMode()&&this.getPicker().oPopup.getOpenState()!==sap.ui.core.OpenState.CLOSING){this.clearFilter();var i=this._getLastSelectedItem();if(i){this.getListItem(i).focus();}}};
e.prototype._handleSelectionLiveChange=function(o){var f=o.getParameter("listItem");var i=o.getParameter("selected");var n=this._getItemByListItem(f);if(f.getType()==="Inactive"){return;}if(!n){return;}var p={item:n,id:n.getId(),key:n.getKey(),fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:true};if(i){this.fireChangeEvent(n.getText());this.setSelection(p);}else{this.fireChangeEvent(n.getText());this.removeSelection(p);}this.setValue(this._sOldValue);if(this.isOpen()&&this.getPicker().oPopup.getOpenState()!==sap.ui.core.OpenState.CLOSING){f.focus();}};
e.prototype.onkeydown=function(o){a.prototype.onkeydown.apply(this,arguments);if(!this.getEnabled()||!this.getEditable()){return;}this._bIsPasteEvent=(o.ctrlKey||o.metaKey)&&(o.which===q.sap.KeyCodes.V);if(this.getValue().length===0&&(o.ctrlKey||o.metaKey)&&(o.which===q.sap.KeyCodes.A)&&this._hasTokens()){this._oTokenizer.focus();this._oTokenizer.selectAllTokens(true);o.preventDefault();}if(this.isPickerDialog()){this._sOldValue=this.getPickerTextField().getValue();this._iOldCursorPos=q(this.getFocusDomRef()).cursorPos();}};
e.prototype.oninput=function(o){a.prototype.oninput.apply(this,arguments);var v=o.target.value,i,r,f,V,g=o.srcControl;if(!this.getEnabled()||!this.getEditable()){return;}if(this._bIsPasteEvent){g.updateDomValue(this._sOldValue||"");return;}f=this._getItemsStartingText(v);V=!!f.length;if(!V&&v!==""){g.updateDomValue(this._sOldValue||"");if(this._iOldCursorPos){q(g.getFocusDomRef()).cursorPos(this._iOldCursorPos);}this._showWrongValueVisualEffect();return;}i=this.getSelectableItems();r=this._sOldInput&&this._sOldInput.length>v.length;if(r&&(this.isPickerDialog()&&this._getFilterSelectedButton().getPressed())){i=this.getSelectedItems();}else if(r){i=this.getItems();}this.filterItems(i,v);this._setContainerSizes();if((!this.getValue()||!V)&&!this.bOpenedByKeyboardOrButton&&!this.isPickerDialog()){this.close();}else{this.open();}this._sOldInput=v;};
e.prototype.filterItems=function(i,v){i.forEach(function(o){var m=q.sap.startsWithIgnoreCase(o.getText(),v);if(v===""){m=true;if(!this.bOpenedByKeyboardOrButton){return;}}var f=this.getListItem(o);if(f){f.setVisible(m);}},this);};
e.prototype.onkeyup=function(o){if(!this.getEnabled()||!this.getEditable()){return;}this._sOldValue=this.getValue();this._iOldCursorPos=q(this.getFocusDomRef()).cursorPos();};
e.prototype._showWrongValueVisualEffect=function(){var o=this.getValueState();if(o===sap.ui.core.ValueState.Error){return;}if(this.isPickerDialog()){this.getPickerTextField().setValueState(sap.ui.core.ValueState.Error);q.sap.delayedCall(1000,this.getPickerTextField(),"setValueState",[o]);}else{this.setValueState(sap.ui.core.ValueState.Error);q.sap.delayedCall(1000,this,"setValueState",[o]);}};
e.prototype.createPicker=function(p){var o=this.getAggregation("picker");if(o){return o;}o=this["create"+p]();this.setAggregation("picker",o,true);var r=this.getRenderer(),f=r.CSS_CLASS_MULTICOMBOBOX;o.setHorizontalScrolling(false).addStyleClass(r.CSS_CLASS_COMBOBOXBASE+"Picker").addStyleClass(f+"Picker").addStyleClass(f+"Picker-CTX").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachBeforeClose(this.onBeforeClose,this).attachAfterClose(this.onAfterClose,this).addEventDelegate({onBeforeRendering:this.onBeforeRenderingPicker,onAfterRendering:this.onAfterRenderingPicker},this).addContent(this.getList());return o;};
e.prototype.createPickerTextField=function(){return new b();};
e.prototype.onBeforeRendering=function(){a.prototype.onBeforeRendering.apply(this,arguments);var i=this.getItems();var o=this.getList();if(o){this._synchronizeSelectedItemAndKey(i);o.destroyItems();this._clearTokenizer();this._fillList(i);if(o.getItemNavigation()){this._iFocusedIndex=o.getItemNavigation().getFocusedIndex();}this.setEditable(this.getEditable());}};
e.prototype.onBeforeRenderingPicker=function(){var o=this["_onBeforeRendering"+this.getPickerType()];if(o){o.call(this);}};
e.prototype.onAfterRenderingPicker=function(){var o=this["_onAfterRendering"+this.getPickerType()];if(o){o.call(this);}};
e.prototype.onBeforeOpen=function(){var p=this["_onBeforeOpen"+this.getPickerType()];this.addStyleClass(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Pressed");this._resetCurrentItem();this.addContent();this._aInitiallySelectedItems=this.getSelectedItems();if(p){p.call(this);}};
e.prototype.onAfterOpen=function(){this.closeValueStateMessage();};
e.prototype.onBeforeClose=function(){a.prototype.onBeforeClose.apply(this,arguments);};
e.prototype.onAfterClose=function(){this.removeStyleClass(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Pressed");this.clearFilter();!this._bPreventValueRemove&&this.setValue("");this._sOldValue="";if(this.isPickerDialog()){this.getPickerTextField().setValue("");this._getFilterSelectedButton().setPressed(false);}this.fireSelectionFinish({selectedItems:this.getSelectedItems()});};
e.prototype._onBeforeOpenDialog=function(){};
e.prototype._onBeforeOpenPopover=function(){var p=this.getPicker(),o=this.getDomRef(),w;if(o&&p){w=(o.offsetWidth/parseFloat(sap.m.BaseFontSize))+"rem";p.setContentMinWidth(w);}};
e.prototype._decoratePopover=function(p){var t=this;p.open=function(){return this.openBy(t);};};
e.prototype.createPopover=function(){var p=new P({showArrow:false,showHeader:false,placement:sap.m.PlacementType.Vertical,offsetX:0,offsetY:0,initialFocus:this,bounce:false});this._decoratePopover(p);return p;};
e.prototype.createDialog=function(){var o=a.prototype.createDialog.apply(this,arguments),s=this._createFilterSelectedButton();o.getSubHeader().addContent(s);return o;};
e.prototype._createFilterSelectedButton=function(){var i=d.getIconURI("multiselect-all"),r=this.getRenderer(),t=this;return new T({icon:i,press:t._filterSelectedItems.bind(this)}).addStyleClass(r.CSS_CLASS_MULTICOMBOBOX+"ToggleButton");};
e.prototype._getFilterSelectedButton=function(){return this.getPicker().getSubHeader().getContent()[1];};
e.prototype._filterSelectedItems=function(o){var f=o.oSource,g,m,v=this.getPickerTextField().getValue(),p=f.getPressed(),V=this.getVisibleItems(),i=this.getItems(),s=this.getSelectedItems();if(p){V.forEach(function(h){m=s.indexOf(h)>-1?true:false;g=this.getListItem(h);if(g){g.setVisible(m);}},this);}else{this.filterItems(i,v);}};
e.prototype.revertSelection=function(){this.setSelectedItems(this._aInitiallySelectedItems);};
e.prototype.createList=function(){var r=this.getRenderer();this._oList=new L({width:"100%",mode:sap.m.ListMode.MultiSelect,includeItemInSelection:true,rememberSelections:false}).addStyleClass(r.CSS_CLASS_COMBOBOXBASE+"List").addStyleClass(r.CSS_CLASS_MULTICOMBOBOX+"List").attachBrowserEvent("tap",this._handleItemTap,this).attachSelectionChange(this._handleSelectionLiveChange,this).attachItemPress(this._handleItemPress,this);this._oList.addEventDelegate({onAfterRendering:this.onAfterRenderingList},this);};
e.prototype.setSelection=function(o){if(o.item&&this.isItemSelected(o.item)){return;}if(!o.item){return;}this.addAssociation("selectedItems",o.item,o.suppressInvalidate);var s=this.getKeys(this.getSelectedItems());this.setProperty("selectedKeys",s,o.suppressInvalidate);if(!o.listItemUpdated&&this.getListItem(o.item)){this.getList().setSelectedItem(this.getListItem(o.item),true);}var t=new sap.m.Token({key:o.key});t.setText(o.item.getText());t.setTooltip(o.item.getText());o.item.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Token",t);this._oTokenizer.addToken(t);this.$().toggleClass("sapMMultiComboBoxHasToken",this._hasTokens());this.setValue('');if(o.fireChangeEvent){this.fireSelectionChange({changedItem:o.item,selected:true});}if(o.fireFinishEvent){if(!this.isOpen()){this.fireSelectionFinish({selectedItems:this.getSelectedItems()});}}};
e.prototype.removeSelection=function(o){if(o.item&&!this.isItemSelected(o.item)){return;}if(!o.item){return;}this.removeAssociation("selectedItems",o.item,o.suppressInvalidate);var s=this.getKeys(this.getSelectedItems());this.setProperty("selectedKeys",s,o.suppressInvalidate);if(!o.listItemUpdated&&this.getListItem(o.item)){this.getList().setSelectedItem(this.getListItem(o.item),false);}if(!o.tokenUpdated){var t=this._getTokenByItem(o.item);o.item.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Token",null);this._oTokenizer.removeToken(t);}this.$().toggleClass("sapMMultiComboBoxHasToken",this._hasTokens());if(o.fireChangeEvent){this.fireSelectionChange({changedItem:o.item,selected:false});}if(o.fireFinishEvent){if(!this.isOpen()){this.fireSelectionFinish({selectedItems:this.getSelectedItems()});}}};
e.prototype._synchronizeSelectedItemAndKey=function(f){if(!f.length){q.sap.log.info("Info: _synchronizeSelectedItemAndKey() the MultiComboBox control does not contain any item on ",this);return;}var s=this.getSelectedKeys()||this._aCustomerKeys;var k=this.getKeys(this.getSelectedItems());if(s.length){for(var i=0,K=null,o=null,g=null,h=s.length;i<h;i++){K=s[i];if(k.indexOf(K)>-1){if(this._aCustomerKeys.length&&(g=this._aCustomerKeys.indexOf(K))>-1){this._aCustomerKeys.splice(g,1);}continue;}o=this.getItemByKey(""+K);if(o){if(this._aCustomerKeys.length&&(g=this._aCustomerKeys.indexOf(K))>-1){this._aCustomerKeys.splice(g,1);}this.setSelection({item:o,id:o.getId(),key:o.getKey(),fireChangeEvent:false,suppressInvalidate:true,listItemUpdated:false});}}return;}};
e.prototype._setContainerSizes=function(){var m=this.$(),h=!!this._oTokenizer.getTokens().length;if(!m.length){return;}var f=this.getRenderer().DOT_CSS_CLASS_MULTICOMBOBOX,i=m.find(f+"InputContainer"),s=m.children(f+"ShadowDiv"),A=this.$().find(".sapMMultiComboBoxBorder").width();s.text(this.getValue());var g=q(this.getOpenArea()).outerWidth(true),j=s.outerWidth()+g,k=A-j,g=q(this.getOpenArea()).outerWidth(true),t=(this._oTokenizer.getScrollWidth()/parseFloat(sap.m.BaseFontSize))+"rem",n=((k>0?j:A)/parseFloat(sap.m.BaseFontSize))+"rem",o=this.isPickerDialog()?"3rem":n;this._oTokenizer.$().css("width","calc(100% - "+o+")");i.css("width","calc(100% - "+(h?t:"0px")+")");i.css("min-width",o);};
e.prototype._getTokenByItem=function(i){return i?i.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Token"):null;};
e.prototype.updateItems=function(r){var k,i,K=this.getSelectedKeys();var u=a.prototype.updateItems.apply(this,arguments);i=this.getSelectedItems();k=(i.length===K.length)&&i.every(function(o){return o&&o.getKey&&K.indexOf(o.getKey())>-1;});if(!k){i=K.map(this.getItemByKey,this);this.setSelectedItems(i);}return u;};
e.prototype._getSelectedItemsOf=function(f){for(var i=0,g=f.length,s=[];i<g;i++){if(this.getListItem(f[i]).isSelected()){s.push(f[i]);}}return s;};
e.prototype._getLastSelectedItem=function(){var t=this._oTokenizer.getTokens();var o=t.length?t[t.length-1]:null;if(!o){return null;}return this._getItemByToken(o);};
e.prototype._getOrderedSelectedItems=function(){var f=[];for(var i=0,t=this._oTokenizer.getTokens(),g=t.length;i<g;i++){f[i]=this._getItemByToken(t[i]);}return f;};
e.prototype._getFocusedListItem=function(){if(!document.activeElement){return null;}var f=sap.ui.getCore().byId(document.activeElement.id);if(this.getList()&&q.sap.containsOrEquals(this.getList().getFocusDomRef(),f.getFocusDomRef())){return f;}return null;};
e.prototype._getFocusedItem=function(){var o=this._getFocusedListItem();return this._getItemByListItem(o);};
e.prototype._isRangeSelectionSet=function(o){var $=o.getDomRef();return $.indexOf(this.getRenderer().CSS_CLASS_MULTICOMBOBOX+"ItemRangeSelection")>-1?true:false;};
e.prototype._hasTokens=function(){return this._oTokenizer.getTokens().length>0;};
e.prototype._getCurrentItem=function(){if(!this._oCurrentItem){return this._getFocusedItem();}return this._oCurrentItem;};
e.prototype._setCurrentItem=function(i){this._oCurrentItem=i;};
e.prototype._resetCurrentItem=function(){this._oCurrentItem=null;};
e.prototype._decorateListItem=function(o){o.addDelegate({onkeyup:function(f){var i=null;if(f.which==q.sap.KeyCodes.SPACE&&this.isOpen()&&this._isListInSuggestMode()){this.open();i=this._getLastSelectedItem();if(i){this.getListItem(i).focus();}return;}},onkeydown:function(f){var i=null,g=null;if(f.shiftKey&&f.which==q.sap.KeyCodes.ARROW_DOWN){g=this._getCurrentItem();i=this._getNextVisibleItemOf(g);}if(f.shiftKey&&f.which==q.sap.KeyCodes.ARROW_UP){g=this._getCurrentItem();i=this._getPreviousVisibleItemOf(g);}if(f.shiftKey&&f.which===q.sap.KeyCodes.SPACE){g=this._getCurrentItem();this._selectPreviousItemsOf(g);}if(i&&i!==g){if(this.getListItem(g).isSelected()){this.setSelection({item:i,id:i.getId(),key:i.getKey(),fireChangeEvent:true,suppressInvalidate:true});this._setCurrentItem(i);}else{this.removeSelection({item:i,id:i.getId(),key:i.getKey(),fireChangeEvent:true,suppressInvalidate:true});this._setCurrentItem(i);}return;}this._resetCurrentItem();if((f.ctrlKey||f.metaKey)&&f.which==q.sap.KeyCodes.A){f.setMarked();f.preventDefault();var v=this.getSelectableItems();var s=this._getSelectedItemsOf(v);if(s.length!==v.length){v.forEach(function(i){this.setSelection({item:i,id:i.getId(),key:i.getKey(),fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:false});},this);}else{v.forEach(function(i){this.removeSelection({item:i,id:i.getId(),key:i.getKey(),fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:false});},this);}}}},true,this);o.addEventDelegate({onsapbackspace:function(f){f.preventDefault();},onsapshow:function(f){f.setMarked();if(f.keyCode===q.sap.KeyCodes.F4){f.preventDefault();}if(this.isOpen()){this.close();return;}if(this.hasContent()){this.open();}},onsaphide:function(f){this.onsapshow(f);},onsapenter:function(f){f.setMarked();this.close();},onsaphome:function(f){f.setMarked();f.preventDefault();var v=this.getSelectableItems();var i=v[0];this.getListItem(i).focus();},onsapend:function(f){f.setMarked();f.preventDefault();var v=this.getSelectableItems();var i=v[v.length-1];this.getListItem(i).focus();},onsapup:function(f){f.setMarked();f.preventDefault();var v=this.getSelectableItems();var i=v[0];var g=q(document.activeElement).control()[0];if(g===this.getListItem(i)){this.focus();f.stopPropagation(true);}},onfocusin:function(f){this.addStyleClass(this.getRenderer().CSS_CLASS_MULTICOMBOBOX+"Focused");},onfocusout:function(f){this.removeStyleClass(this.getRenderer().CSS_CLASS_MULTICOMBOBOX+"Focused");},onsapfocusleave:function(f){var p=this.getAggregation("picker");var g=sap.ui.getCore().byId(f.relatedControlId);if(p&&g&&q.sap.equal(p.getFocusDomRef(),g.getFocusDomRef())){if(f.srcControl){f.srcControl.focus();}}}},this);if(sap.ui.Device.support.touch){o.addEventDelegate({ontouchstart:function(f){f.setMark("cancelAutoClose");}});}};
e.prototype._createTokenizer=function(){var t=new sap.m.Tokenizer({tokens:[]}).attachTokenChange(this._handleTokenChange,this);t.setParent(this);t.addEventDelegate({onAfterRendering:this._onAfterRenderingTokenizer},this);return t;};
e.prototype._handleTokenChange=function(o){var t=o.getParameter("type");var f=o.getParameter("token");var i=null;if(t!==sap.m.Tokenizer.TokenChangeType.Removed&&t!==sap.m.Tokenizer.TokenChangeType.Added){return;}if(t===sap.m.Tokenizer.TokenChangeType.Removed){i=(f&&this._getItemByToken(f));if(i&&this.isItemSelected(i)){this.removeSelection({item:i,id:i.getId(),key:i.getKey(),tokenUpdated:true,fireChangeEvent:true,fireFinishEvent:true,suppressInvalidate:true});!this.isPickerDialog()&&this.focus();this.fireChangeEvent("");}}};
e.prototype._onAfterRenderingTokenizer=function(){this._setContainerSizes();};
e.prototype.onAfterRenderingList=function(){var o=this.getList();if(this._iFocusedIndex!=null&&o.getItems().length>this._iFocusedIndex){o.getItems()[this._iFocusedIndex].focus();this._iFocusedIndex=null;}};
e.prototype.onAfterRendering=function(){a.prototype.onAfterRendering.apply(this,arguments);var p=this.getPicker();var o=q(this.getDomRef());var f=o.find(this.getRenderer().DOT_CSS_CLASS_MULTICOMBOBOX+"Border");p._oOpenBy=f[0];};
e.prototype.onfocusout=function(o){this.removeStyleClass("sapMFocus");a.prototype.onfocusout.apply(this,arguments);};
e.prototype.onpaste=function(o){var O;if(window.clipboardData){O=window.clipboardData.getData("Text");}else{O=o.originalEvent.clipboardData.getData('text/plain');}var s=this._oTokenizer._parseString(O);if(s&&s.length>0){this.getSelectableItems().forEach(function(i){if(q.inArray(i.getText(),s)>-1){this.setSelection({item:i,id:i.getId(),key:i.getKey(),fireChangeEvent:true,fireFinishEvent:true,suppressInvalidate:true,listItemUpdated:false});}},this);}};
e.prototype.onsapbackspace=function(o){if(!this.getEnabled()||!this.getEditable()){o.preventDefault();return;}if(this.getCursorPosition()>0||this.getValue().length>0){return;}sap.m.Tokenizer.prototype.onsapbackspace.apply(this._oTokenizer,arguments);o.preventDefault();};
e.prototype.onsapdelete=function(o){if(!this.getEnabled()||!this.getEditable()){return;}if(this.getValue()&&!this._isCompleteTextSelected()){return;}sap.m.Tokenizer.prototype.onsapdelete.apply(this._oTokenizer,arguments);};
e.prototype.onsapnext=function(o){if(o.isMarked()){return;}var f=q(document.activeElement).control()[0];if(!f){return;}if(f===this._oTokenizer||this._oTokenizer.$().find(f.$()).length>0&&this.getEditable()){this.focus();}};
e.prototype.onsapprevious=function(o){if(this.getCursorPosition()===0&&!this._isCompleteTextSelected()){if(o.srcControl===this){sap.m.Tokenizer.prototype.onsapprevious.apply(this._oTokenizer,arguments);}}};
e.prototype.getOpenArea=function(){if(this.isPickerDialog()){return this.getDomRef();}else{return a.prototype.getOpenArea.apply(this,arguments);}};
e.prototype._getItemsStartingText=function(t){var i=[];this.getSelectableItems().forEach(function(o){if(q.sap.startsWithIgnoreCase(o.getText(),t)){i.push(o);}},this);return i;};
e.prototype._getUnselectedItemsStartingText=function(t){var i=[];this._getUnselectedItems().forEach(function(o){if(q.sap.startsWithIgnoreCase(o.getText(),t)){i.push(o);}},this);return i;};
e.prototype.getCursorPosition=function(){return this._$input.cursorPos();};
e.prototype._isCompleteTextSelected=function(){if(!this.getValue().length){return false;}var i=this._$input[0];if(i.selectionStart!==0||i.selectionEnd!==this.getValue().length){return false;}return true;};
e.prototype._selectPreviousItemsOf=function(i){var f;do{f=true;var p=this._getPreviousVisibleItemOf(i);if(p){var o=this.getListItem(p);if(o){f=this.getListItem(p).getSelected();}}this.setSelection({item:i,id:i.getId(),key:i.getKey(),fireChangeEvent:true,suppressInvalidate:true});i=p;}while(!f);};
e.prototype._getNextVisibleItemOf=function(i){var f=this.getSelectableItems();var g=f.indexOf(i)+1;if(g<=0||g>f.length-1){return null;}return f[g];};
e.prototype._getPreviousVisibleItemOf=function(i){var f=this.getSelectableItems();var g=f.indexOf(i)-1;if(g<0){return null;}return f[g];};
e.prototype._getNextUnselectedItemOf=function(i){var f=this._getUnselectedItems();var g=f.indexOf(i)+1;if(g<=0||g>f.length-1){return null;}return f[g];};
e.prototype._getPreviousUnselectedItemOf=function(i){var f=this._getUnselectedItems();var g=f.indexOf(i)-1;if(g<0){return null;}return f[g];};
e.prototype._getNextTraversalItem=function(){var i=this._getItemsStartingText(this.getValue());var s=this._getUnselectedItems();if(i.indexOf(this._oTraversalItem)>-1&&this._oTraversalItem.getText()===this.getValue()){return this._getNextUnselectedItemOf(this._oTraversalItem);}if(i.length&&i[0].getText()===this.getValue()){return this._getNextUnselectedItemOf(i[0]);}return i.length?i[0]:s[0];};
e.prototype._getPreviousTraversalItem=function(){var i=this._getItemsStartingText(this.getValue());if(i.indexOf(this._oTraversalItem)>-1&&this._oTraversalItem.getText()===this.getValue()){return this._getPreviousUnselectedItemOf(this._oTraversalItem);}if(i.length&&i[i.length-1].getText()===this.getValue()){return this._getPreviousUnselectedItemOf(i[i.length-1]);}if(i.length){return i[i.length-1];}else{var s=this._getUnselectedItems();if(s.length>0){return s[s.length-1];}else{return null;}}};
e.prototype.findFirstEnabledItem=function(f){f=f||this.getItems();for(var i=0;i<f.length;i++){if(f[i].getEnabled()){return f[i];}}return null;};
e.prototype.getVisibleItems=function(){for(var i=0,o,f=this.getItems(),v=[];i<f.length;i++){o=this.getListItem(f[i]);if(o&&o.getVisible()){v.push(f[i]);}}return v;};
e.prototype.findLastEnabledItem=function(i){i=i||this.getItems();return this.findFirstEnabledItem(i.reverse());};
e.prototype.setSelectedItems=function(i){this.removeAllSelectedItems();if(!i||!i.length){return this;}if(!q.isArray(i)){q.sap.log.warning("Warning: setSelectedItems() has to be an array of sap.ui.core.Item instances or of valid sap.ui.core.Item IDs",this);return this;}i.forEach(function(o){if(!(o instanceof sap.ui.core.Item)&&(typeof o!=="string")){q.sap.log.warning("Warning: setSelectedItems() has to be an array of sap.ui.core.Item instances or of valid sap.ui.core.Item IDs",this);return;}if(typeof o==="string"){o=sap.ui.getCore().byId(o);}this.setSelection({item:o?o:null,id:o?o.getId():"",key:o?o.getKey():"",suppressInvalidate:true});},this);return this;};
e.prototype.addSelectedItem=function(i){if(!i){return this;}if(typeof i==="string"){i=sap.ui.getCore().byId(i);}this.setSelection({item:i?i:null,id:i?i.getId():"",key:i?i.getKey():"",fireChangeEvent:false,suppressInvalidate:true});return this;};
e.prototype.removeSelectedItem=function(i){if(!i){return null;}if(typeof i==="string"){i=sap.ui.getCore().byId(i);}if(!this.isItemSelected(i)){return null;}this.removeSelection({item:i,id:i.getId(),key:i.getKey(),fireChangeEvent:false,suppressInvalidate:true});return i;};
e.prototype.removeAllSelectedItems=function(){var i=[];var f=this.getAssociation("selectedItems",[]);f.forEach(function(o){var g=this.removeSelectedItem(o);if(g){i.push(g.getId());}},this);return i;};
e.prototype.removeSelectedKeys=function(k){var i=[],f;if(!k||!k.length||!q.isArray(k)){return i;}var o;k.forEach(function(K){o=this.getItemByKey(K);if(o){this.removeSelection({item:o?o:null,id:o?o.getId():"",key:o?o.getKey():"",fireChangeEvent:false,suppressInvalidate:true});i.push(o);}if(this._aCustomerKeys.length&&(f=this._aCustomerKeys.indexOf(K))>-1){this._aCustomerKeys.splice(f,1);}},this);return i;};
e.prototype.setSelectedKeys=function(k){this.removeAllSelectedItems();this._aCustomerKeys=[];this.addSelectedKeys(k);return this;};
e.prototype.addSelectedKeys=function(k){k=this.validateProperty("selectedKeys",k);k.forEach(function(K){var i=this.getItemByKey(K);if(i){this.addSelectedItem(i);}else if(K!=null){this._aCustomerKeys.push(K);}},this);return this;};
e.prototype.getSelectedKeys=function(){var i=this.getSelectedItems()||[],k=[];i.forEach(function(o){k.push(o.getKey());},this);if(this._aCustomerKeys.length){k=k.concat(this._aCustomerKeys);}return k;};
e.prototype._getUnselectedItems=function(){return q(this.getSelectableItems()).not(this.getSelectedItems()).get();};
e.prototype.getSelectedItems=function(){var i=[],f=this.getAssociation("selectedItems")||[];f.forEach(function(s){var o=sap.ui.getCore().byId(s);if(o){i.push(o);}},this);return i;};
e.prototype.getSelectableItems=function(){return this.getEnabledItems(this.getVisibleItems());};
e.prototype.getWidth=function(){return this.getProperty("width")||"100%";};
e.prototype.setEditable=function(f){a.prototype.setEditable.apply(this,arguments);this._oTokenizer.setEditable(f);return this;};
e.prototype.clearFilter=function(){this.getItems().forEach(function(i){this.getListItem(i).setVisible(i.getEnabled()&&this.getSelectable(i));},this);};
e.prototype._isListInSuggestMode=function(){return this.getList().getItems().some(function(o){return!o.getVisible()&&this._getItemByListItem(o).getEnabled();},this);};
e.prototype._mapItemToListItem=function(i){if(!i){return null;}var s=this.getRenderer().CSS_CLASS_MULTICOMBOBOX+"Item";var f=(this.isItemSelected(i))?s+"Selected":"";var o=new sap.m.StandardListItem({type:sap.m.ListType.Active,visible:i.getEnabled()}).addStyleClass(s+" "+f);o.setTooltip(i.getTooltip());i.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"ListItem",o);o.setTitle(i.getText());if(f){var t=new sap.m.Token({key:i.getKey()});t.setText(i.getText());t.setTooltip(i.getText());i.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Token",t);this._oTokenizer.addToken(t);}this.setSelectable(i,i.getEnabled());this._decorateListItem(o);return o;};
e.prototype._findMappedItem=function(o,f){for(var i=0,f=f||this.getItems(),g=f.length;i<g;i++){if(this.getListItem(f[i])===o){return f[i];}}return null;};
e.prototype.setSelectable=function(i,s){if(this.indexOfItem(i)<0){return;}i._bSelectable=s;var o=this.getListItem(i);if(o){o.setVisible(s);}var t=this._getTokenByItem(i);if(t){t.setVisible(s);}};
e.prototype.getSelectable=function(i){return i._bSelectable;};
e.prototype._fillList=function(f){if(!f){return null;}if(!this._oListItemEnterEventDelegate){this._oListItemEnterEventDelegate={onsapenter:function(h){if(h.srcControl.isSelected()){h.setMarked();}}};}for(var i=0,o,g=f.length;i<g;i++){o=this._mapItemToListItem(f[i]);o.removeEventDelegate(this._oListItemEnterEventDelegate);o.addDelegate(this._oListItemEnterEventDelegate,true,this,true);this.getList().addAggregation("items",o,true);if(this.isItemSelected(f[i])){this.getList().setSelectedItem(o,true);}}};
e.prototype.init=function(){C.prototype.init.apply(this,arguments);this.createList();this.bItemsUpdated=false;this._bPreventValueRemove=false;this.setPickerType(sap.ui.Device.system.phone?"Dialog":"Popover");this._oTokenizer=this._createTokenizer();this._aCustomerKeys=[];this._aInitiallySelectedItems=[];};
e.prototype.clearSelection=function(){this.removeAllSelectedItems();};
e.prototype.addItem=function(i){this.addAggregation("items",i);if(i){i.attachEvent("_change",this.onItemChange,this);}if(this.getList()){this.getList().addItem(this._mapItemToListItem(i));}return this;};
e.prototype.insertItem=function(i,f){this.insertAggregation("items",i,f,true);if(i){i.attachEvent("_change",this.onItemChange,this);}if(this.getList()){this.getList().insertItem(this._mapItemToListItem(i),f);}return this;};
e.prototype.getEnabledItems=function(i){i=i||this.getItems();return i.filter(function(o){return o.getEnabled();});};
e.prototype.getItemByKey=function(k){return this.findItem("key",k);};
e.prototype.removeItem=function(i){i=this.removeAggregation("items",i);if(this.getList()){this.getList().removeItem(i&&this.getListItem(i));}this.removeSelection({item:i,id:i?i.getId():"",key:i?i.getKey():"",fireChangeEvent:false,suppressInvalidate:true,listItemUpdated:true});return i;};
e.prototype.isItemSelected=function(i){return this.getSelectedItems().indexOf(i)>-1;};
e.prototype.findItem=function(p,v){var m="get"+p.charAt(0).toUpperCase()+p.slice(1);for(var i=0,f=this.getItems();i<f.length;i++){if(f[i][m]()===v){return f[i];}}return null;};
e.prototype._clearTokenizer=function(){this._oTokenizer.destroyAggregation("tokens",true);};
e.prototype.getList=function(){return this._oList;};
e.prototype.exit=function(){a.prototype.exit.apply(this,arguments);if(this.getList()){this.getList().destroy();this._oList=null;}if(this._oTokenizer){this._oTokenizer.destroy();this._oTokenizer=null;}};
e.prototype.destroyItems=function(){this.destroyAggregation("items");if(this.getList()){this.getList().destroyItems();}this._oTokenizer.destroyTokens();return this;};
e.prototype.removeAllItems=function(){var i=this.removeAllAggregation("items");this.removeAllSelectedItems();if(this.getList()){this.getList().removeAllItems();}return i;};
e.prototype._getItemByListItem=function(o){return this._getItemBy(o,"ListItem");};
e.prototype._getItemByToken=function(t){return this._getItemBy(t,"Token");};
e.prototype._getItemBy=function(o,s){s=this.getRenderer().CSS_CLASS_COMBOBOXBASE+s;for(var i=0,f=this.getItems(),g=f.length;i<g;i++){if(f[i].data(s)===o){return f[i];}}return null;};
e.prototype.getListItem=function(i){return i?i.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"ListItem"):null;};
e.prototype.getAccessibilityInfo=function(){var t=this.getSelectedItems().map(function(o){return o.getText();}).join(" ");var i=a.prototype.getAccessibilityInfo.apply(this,arguments);i.type=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_MULTICOMBO");i.description=((i.description||"")+" "+t).trim();return i;};
return e;},true);
sap.ui.predefine('sap/m/MultiComboBoxRenderer',['jquery.sap.global','./ComboBoxBaseRenderer','sap/ui/core/Renderer','sap/ui/core/ValueStateSupport'],function(q,C,R,V){"use strict";var M=R.extend(sap.m.ComboBoxBaseRenderer);M.CSS_CLASS_MULTICOMBOBOX="sapMMultiComboBox";M.DOT_CSS_CLASS_MULTICOMBOBOX=".sapMMultiComboBox";
M.addOuterClasses=function(r,c){sap.m.ComboBoxBaseRenderer.addOuterClasses.apply(this,arguments);r.addClass(M.CSS_CLASS_MULTICOMBOBOX);if(c._hasTokens()){r.addClass("sapMMultiComboBoxHasToken");}};
M.addInnerClasses=function(r,c){C.addInnerClasses.apply(this,arguments);r.addClass(M.CSS_CLASS_MULTICOMBOBOX+"InputInner");};
M.addButtonClasses=function(r,c){C.addButtonClasses.apply(this,arguments);r.addClass(M.CSS_CLASS_MULTICOMBOBOX+"Arrow");};
M.openInputTag=function(r,c){r.write('<div class="sapMMultiComboBoxBorder"');r.writeAttribute("id",c.getId()+"-border");r.write(">");r.renderControl(c._oTokenizer);r.write("<div class=\"sapMMultiComboBoxInputContainer\">");C.openInputTag.call(this,r,c);};
M.closeInputTag=function(r,c){C.closeInputTag.call(this,r,c);r.write("</div>");r.write("</div>");r.write("<div class=\"sapMMultiComboBoxShadowDiv\"></div>");};
return M;},true);
sap.ui.predefine('sap/m/MultiInput',['jquery.sap.global','./Input','./Tokenizer','./Token','./library'],function(q,I,T,a,l){"use strict";
var M=I.extend("sap.m.MultiInput",{metadata:{library:"sap.m",properties:{enableMultiLineMode:{type:"boolean",group:"Behavior",defaultValue:false},maxTokens:{type:"int",group:"Behavior"}},aggregations:{tokens:{type:"sap.m.Token",multiple:true,singularName:"token"},tokenizer:{type:"sap.m.Tokenizer",multiple:false,visibility:"hidden"}},events:{tokenChange:{parameters:{type:{type:"string"},token:{type:"sap.m.Token"},tokens:{type:"sap.m.Token[]"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}},tokenUpdate:{type:{type:"string"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");M.prototype._sAriaMultiInputContainTokenId=new sap.ui.core.InvisibleText({text:r.getText("MULTIINPUT_ARIA_CONTAIN_TOKEN")}).toStatic().getId();
M.prototype.init=function(){var t=this,c=sap.ui.getCore();this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");I.prototype.init.call(this);c.attachThemeChanged(this._handleThemeChanged,this);this._bIsValidating=false;this._tokenizer=new T();this.setAggregation("tokenizer",this._tokenizer);this._tokenizer.attachTokenChange(this._onTokenChange,this);this._tokenizer.attachTokenUpdate(this._onTokenUpdate,this);this.setShowValueHelp(true);this.setShowSuggestion(true);this.attachSuggestionItemSelected(this._onSuggestionItemSelected,this);this.attachLiveChange(this._onLiveChange,this);sap.ui.Device.orientation.attachHandler(this._onOrientationChange,this);this._sResizeHandlerId=sap.ui.core.ResizeHandler.register(this,function(){t._setContainerSizes();});if(!(this._bUseDialog&&this._oSuggestionPopup)){this.attachSuggestionItemSelected(function(){setTimeout(function(){t._tokenizer.scrollToEnd();},0);});}};
M.prototype._onTokenChange=function(b){var t=this.getTokens(),L=t.length;this.fireTokenChange(b.getParameters());this.invalidate();if(this._bUseDialog&&this._tokenizer.getParent()instanceof sap.m.Dialog){this._showAllTokens();return;}var f=q.sap.containsOrEquals(this.getDomRef(),document.activeElement);if(b.getParameter("type")==="tokensChanged"&&b.getParameter("removedTokens").length>0&&f){this.focus();}if(b.getParameter("type")==="added"&&L>1&&this.getEditable()&&this._isMultiLineMode&&!this.$("border").hasClass("sapMMultiInputMultiModeBorder")){this._showIndicator();}if(b.getParameter("type")==="removed"&&this._isMultiLineMode){if(L<2){this._removeIndicator();}}};
M.prototype._onTokenUpdate=function(b){this.fireTokenUpdate(b.getParameters());this.invalidate();};
M.prototype._onSuggestionItemSelected=function(e){var i=null,t=null,b=this,o=this._tokenizer.getTokens().length;if(this.getMaxTokens()&&o>=this.getMaxTokens()){return;}if(this._hasTabularSuggestions()){i=e.getParameter("selectedRow");}else{i=e.getParameter("selectedItem");if(i){t=new a({text:i.getText(),key:i.getKey()});}}if(i){var c=this.getValue();this._tokenizer._addValidateToken({text:c,token:t,suggestionObject:i,validationCallback:function(v){if(v){b.setValue("");}}});}if(this._bUseDialog&&this._tokenizer.getParent()instanceof sap.m.Dialog){var n=this._tokenizer.getTokens().length;if(o<n){this.setValue("");}if(this._tokenizer.getVisible()===false){this._tokenizer.setVisible(true);}if(this._oList instanceof sap.m.Table){this._oList.addStyleClass("sapMInputSuggestionTableHidden");}else{this._oList.destroyItems();}var s=this._oSuggestionPopup.getScrollDelegate();if(s){s.scrollTo(0,0,0);}this._oPopupInput.focus();}};
M.prototype._onLiveChange=function(e){this._tokenizer._removeSelectedTokens();if(this._bUseDialog&&this._isMultiLineMode){var v=e.getParameter("newValue");if(this._oSuggestionPopup&&this._oSuggestionPopup.getContent().length>1&&v.length>0){this._tokenizer.setVisible(false);}else{this._tokenizer.setVisible(true);}}};
M.prototype._showIndicator=function(){var t=this.getTokens(),i=t.length;this._tokenizer.setVisible(true);if(i>1){if(this.$().find(".sapMMultiInputIndicator").length!==0){this._removeIndicator();}var m=sap.ui.getCore().getLibraryResourceBundle("sap.m");var s="<span class=\"sapMMultiInputIndicator\">"+m.getText("MULTIINPUT_SHOW_MORE_TOKENS",i-1)+"</span>";this.$().find(".sapMTokenizer").after(s);this._setValueInvisible();}this._bShowIndicator=true;};
M.prototype._setValueInvisible=function(){this.$("inner").css("opacity","0");};
M.prototype._setValueVisible=function(){this.$("inner").css("opacity","1");};
M.prototype._showAllTokens=function(){this._tokenizer.setVisible(true);this._removeIndicator();};
M.prototype._removeIndicator=function(){this.$().find(".sapMMultiInputIndicator").remove();this._bShowIndicator=false;};
M.prototype.setEnableMultiLineMode=function(m){this.setProperty("enableMultiLineMode",m,true);if(m){this.$().addClass("sapMMultiInputMultiLine");}else{this.$().removeClass("sapMMultiInputMultiLine");}this.closeMultiLine();var t=this;if(this._bUseDialog){m=true;}if(m){if(this.getEditable()){this._showIndicator();}this._isMultiLineMode=true;if(this.getDomRef()){setTimeout(function(){t._setContainerSizes();t._tokenizer.scrollToEnd();},0);}}else{this._isMultiLineMode=false;this._showAllTokens();this._setValueVisible();if(this.getDomRef()){setTimeout(function(){t._setContainerSizes();t._tokenizer.scrollToEnd();},0);}}return this;};
M.prototype._openMultiLineOnPhone=function(){var t=this;this._oSuggestionPopup.open();this._oSuggestionPopup.insertContent(this._tokenizer,0);this._tokenizer.setReverseTokens(true);var v=this._oPopupInput.getValue();if(this._oSuggestionPopup&&this._oSuggestionPopup.getContent().length>1&&v.length>0){this._tokenizer.setVisible(false);}else{this._tokenizer.setVisible(true);}this._tokenizer._oScroller.setHorizontal(false);this._tokenizer.addStyleClass("sapMTokenizerMultiLine");if(this._oSuggestionTable.getItems().length===0){this._oPopupInput.onsapenter=function(e){t._validateCurrentText();t._setValueInvisible();};}};
M.prototype._openMultiLineOnDesktop=function(){var t=this;this._setValueVisible();this.$("border").addClass("sapMMultiInputMultiModeBorder");if(this._$input){this._$input.parent().addClass("sapMMultiInputMultiModeInputContainer");}this.$().find(".sapMInputValHelp").attr("tabindex","-1");var p=this.getParent();this._originalOverflow=null;if(p&&p.$&&p.$().css("overflow")==="hidden"){this._originalOverflow=p.$().css("overflow");p.$().css("overflow","visible");}var P;if(this.$().closest('.sapUiVlt').length!==0){P=this.$().closest('.sapUiVlt');}else if(this.$().parent('[class*="sapUiRespGridSpan"]').length!==0){P=this.$().parent('[class*="sapUiRespGridSpan"]');}else if(this.$().parents(".sapUiRFLContainer").length!==0){P=this.$().parents(".sapUiRFLContainer");}if(P&&P.length>0&&P.css("overflow")==="hidden"){P.css("overflow","visible");}setTimeout(function(){t._showAllTokens();t._setContainerSizes();t._tokenizer.scrollToStart();},0);};
M.prototype.openMultiLine=function(){var t=this.getTokens();if(!this.getEditable()){return;}if(this._bUseDialog){this._openMultiLineOnPhone();return;}if(this.getEnableMultiLineMode()&&t.length>0){this._openMultiLineOnDesktop();}};
M.prototype.closeMultiLine=function(){if(!this.getEditable()){return;}if(this._bUseDialog){this._oSuggestionPopup.close();this._tokenizer.setVisible(true);}else{this.$("border").removeClass("sapMMultiInputMultiModeBorder");if(this._$input){this._$input.parent().removeClass("sapMMultiInputMultiModeInputContainer");}this.$().find(".sapMInputValHelp").removeAttr("tabindex");if(this._originalOverflow){var p=this.getParent();p.$().css("overflow",this._originalOverflow);}}};
M.prototype._onOrientationChange=function(){this._setContainerSizes();};
M.prototype.getScrollDelegate=function(){return this._tokenizer._oScroller;};
M.prototype.exit=function(){if(this._sResizeHandlerId){sap.ui.core.ResizeHandler.deregister(this._sResizeHandlerId);delete this._sResizeHandlerId;}var c=sap.ui.getCore();c.detachThemeChanged(this._handleThemeChanged,this);I.prototype.exit.apply(this,arguments);};
M.prototype._setContainerSizes=function(){var t=this.getDomRef(),$=this.$(),b=this.$().find(".sapMMultiInputBorder"),c,d,e=3*16,f,g,h,j=this.getTokens(),i;if(!t){return;}if(this.getTokens().length>0){b.addClass("sapMMultiInputNarrowBorder");}else{b.removeClass("sapMMultiInputNarrowBorder");}this.$("inner").css("width","");this._tokenizer.$().css("width","");c=b.width();d=b.find(".sapMMultiInputIndicator");g=d.width();f=this._tokenizer.getScrollWidth();h=$.find(".sapMInputValHelp").outerWidth(true);if(g&&this._isMultiLineMode&&this._bShowIndicator){e=g;}if(!this._bUseDialog&&this.getEditable()&&this._isMultiLineMode&&!this._bShowIndicator&&b.length>0){f=c-h;if(j.length===0){this._tokenizer.$().css("width",0);}if(this._tokenizer._oScroller){this._tokenizer._oScroller.refresh();}for(i=0;i<j.length;i++){var k=j[i].getDomRef();if(k&&k.offsetWidth>f){k.style.width=f+"px";k.classList.add("sapMTokenTruncate");}}this.$("inner").css("width",f+"px");this._tokenizer.setPixelWidth(f);}else{f=Math.min(f,c-h-e);q($.find(".sapMInputBaseInner")[0]).css("width",(c-f-h)+"px");if(!(this._bUseDialog&&this._oSuggestionPopup&&this._oSuggestionPopup.isOpen())){this._tokenizer.setPixelWidth(f);}}if(this.getPlaceholder()){this._sPlaceholder=this.getPlaceholder();}if(this.getTokens().length>0){this.setPlaceholder("");}else{this.setPlaceholder(this._sPlaceholder);}if(this._bUseDialog&&this._isMultiLineMode&&this._oSuggestionPopup&&this._oSuggestionPopup.isOpen()&&this._tokenizer.getTokens().length>0){var p=this._tokenizer.getTokens().length,L=this._tokenizer.getTokens()[p-1],m=L.$(),n=L.$().outerWidth(),P=this._oSuggestionPopup.$().find(".sapMDialogScrollCont").width(),B=parseFloat(sap.m.BaseFontSize)||16,o=P-2*B;if(o<n){m.outerWidth(o,true);m.css("overflow","hidden");m.css("text-overflow","ellipsis");m.css("white-space","nowrap");}}};
M.prototype.onAfterRendering=function(){var c=sap.ui.getCore();I.prototype.onAfterRendering.apply(this,arguments);if(c.isThemeApplied()){this._setContainerSizes();}};
M.prototype._handleThemeChanged=function(){this._setContainerSizes();};
M.prototype.addValidator=function(v){this._tokenizer.addValidator(v);};
M.prototype.removeValidator=function(v){this._tokenizer.removeValidator(v);};
M.prototype.removeAllValidators=function(){this._tokenizer.removeAllValidators();};
M.prototype.onsapnext=function(e){if(e.isMarked()){return;}var f=q(document.activeElement).control()[0];if(!f){return;}if(this._tokenizer===f||this._tokenizer.$().find(f.$()).length>0){this._scrollAndFocus();}};
M.prototype.onsapbackspace=function(e){if(this.getCursorPosition()>0||!this.getEditable()||this.getValue().length>0){return;}T.prototype.onsapbackspace.apply(this._tokenizer,arguments);e.preventDefault();e.stopPropagation();};
M.prototype.onsapdelete=function(e){if(!this.getEditable()){return;}if(this.getValue()&&!this._completeTextIsSelected()){return;}T.prototype.onsapdelete.apply(this._tokenizer,arguments);};
M.prototype.onkeydown=function(e){if(e.ctrlKey||e.metaKey){if(e.which===q.sap.KeyCodes.A){var v=this.getValue();if(document.activeElement===this._$input[0]){if(this._$input.getSelectedText()!==v){this.selectText(0,v.length);}else if(this._tokenizer){if(!v&&this._tokenizer.getTokens().length){this._tokenizer.focus();}this._tokenizer.selectAllTokens(true);}}else if(document.activeElement===this._tokenizer.$()[0]){if(this._tokenizer._iSelectedToken===this._tokenizer.getTokens().length){this.selectText(0,v.length);}}e.preventDefault();}}};
M.prototype.onpaste=function(e){var o,i,v=[],A=[];if(this.getValueHelpOnly()){return;}if(window.clipboardData){o=window.clipboardData.getData("Text");}else{o=e.originalEvent.clipboardData.getData('text/plain');}var s=this._tokenizer._parseString(o);setTimeout(function(){if(s){if(this.fireEvent("_validateOnPaste",{texts:s},true)){this.updateDomValue("");for(i=0;i<s.length;i++){if(s[i]){var t=this._convertTextToToken(s[i]);if(t){v.push(t);}}}for(i=0;i<v.length;i++){if(this._tokenizer._addUniqueToken(v[i])){A.push(v[i]);}}if(A.length>0){this.fireTokenUpdate({addedTokens:A,removedTokens:[],type:T.TokenUpdateType.Added});}}this.cancelPendingSuggest();}}.bind(this),0);};
M.prototype._convertTextToToken=function(t){var b=null,i=null,c=null,o=this._tokenizer.getTokens().length;if(!this.getEditable()){return null;}t=t.trim();if(!t){return null;}if(this._getIsSuggestionPopupOpen()){if(this._hasTabularSuggestions()){i=this._oSuggestionTable._oSelectedItem;}else{i=this._getSuggestionItem(t);}}if(i&&i.getText&&i.getKey){c=new a({text:i.getText(),key:i.getKey()});}var d=this;b=this._tokenizer._validateToken({text:t,token:c,suggestionObject:i,validationCallback:function(v){d._bIsValidating=false;if(v){d.setValue("");if(d._bUseDialog&&d._isMultiLineMode&&d._oSuggestionTable.getItems().length===0){var n=d._tokenizer.getTokens().length;if(o<n){d._oPopupInput.setValue("");}if(d._tokenizer.getVisible()===false){d._tokenizer.setVisible(true);}d._setAllTokenVisible();}}}});return b;};
M.prototype.onsapprevious=function(e){if(this._getIsSuggestionPopupOpen()){return;}if(this.getCursorPosition()===0){if(e.srcControl===this){T.prototype.onsapprevious.apply(this._tokenizer,arguments);e.preventDefault();}}};
M.prototype._scrollAndFocus=function(){this._tokenizer.scrollToEnd();this.$().find("input").focus();};
M.prototype.onsaphome=function(e){T.prototype.onsaphome.apply(this._tokenizer,arguments);};
M.prototype.onsapend=function(e){T.prototype.onsapend.apply(this._tokenizer,arguments);e.preventDefault();};
M.prototype.onsapenter=function(e){var v=true;if(this._oSuggestionPopup&&this._oSuggestionPopup.isOpen()){if(this._hasTabularSuggestions()){v=!this._oSuggestionTable.getSelectedItem();}else{v=!this._oList.getSelectedItem();}}if(v){this._validateCurrentText();}if(I.prototype.onsapenter){I.prototype.onsapenter.apply(this,arguments);}this.focus();};
M.prototype._checkFocus=function(){return this.getDomRef()&&q.sap.containsOrEquals(this.getDomRef(),document.activeElement);};
M.prototype.onsapfocusleave=function(e){var p=this._oSuggestionPopup,n=false,N=false,b=this._checkFocus(),R;if(p instanceof sap.m.Popover){if(e.relatedControlId){R=sap.ui.getCore().byId(e.relatedControlId).getFocusDomRef();n=q.sap.containsOrEquals(p.getFocusDomRef(),R);N=q.sap.containsOrEquals(this._tokenizer.getFocusDomRef(),R);}}if(!N&&!n&&!this._isMultiLineMode){this._setContainerSizes();this._tokenizer.scrollToEnd();}I.prototype.onsapfocusleave.apply(this,arguments);if(this._bIsValidating){return;}if(!this._bUseDialog&&this._isMultiLineMode&&!this._bShowIndicator&&this.getEditable()){if(b||n){return;}this.closeMultiLine();this._showIndicator();q.sap.delayedCall(0,this,function(){this._setContainerSizes();});}T.prototype.onsapfocusleave.apply(this._tokenizer,arguments);if(!this._bUseDialog&&this._isMultiLineMode&&this._bShowIndicator){var $=this.$().find(".sapMMultiInputBorder");$.scrollTop(0);}};
M.prototype._onDialogClose=function(){this._tokenizer._oScroller.setHorizontal(true);this._tokenizer.removeStyleClass("sapMTokenizerMultiLine");this.setAggregation("tokenizer",this._tokenizer);this._tokenizer.setReverseTokens(false);this._tokenizer.invalidate();};
M.prototype.ontap=function(e){if(document.activeElement===this._$input[0]){this._tokenizer.selectAllTokens(false);}I.prototype.ontap.apply(this,arguments);};
M.prototype.onfocusin=function(e){if(this.getEditable()&&(this.getEnableMultiLineMode()||this._bUseDialog)){this.openMultiLine();}if(e.target===this.getFocusDomRef()){I.prototype.onfocusin.apply(this,arguments);}};
M.prototype.onsapescape=function(e){this._tokenizer.selectAllTokens(false);this.selectText(0,0);I.prototype.onsapescape.apply(this,arguments);};
M.prototype._validateCurrentText=function(e){var o=this._tokenizer.getTokens().length;var t=this.getValue();if(!t||!this.getEditable()){return;}t=t.trim();if(!t){return;}var i=null;if(e||this._getIsSuggestionPopupOpen()){if(this._hasTabularSuggestions()){i=this._oSuggestionTable._oSelectedItem;}else{i=this._getSuggestionItem(t,e);}}var b=null;if(i&&i.getText&&i.getKey){b=new a({text:i.getText(),key:i.getKey()});}var c=this;if(!this.getMaxTokens()||this.getTokens().length<this.getMaxTokens()){this._bIsValidating=true;this._tokenizer._addValidateToken({text:t,token:b,suggestionObject:i,validationCallback:function(v){c._bIsValidating=false;if(v){c.setValue("");if(c._bUseDialog&&c._isMultiLineMode&&c._oSuggestionTable.getItems().length===0){var n=c._tokenizer.getTokens().length;if(o<n){c._oPopupInput.setValue("");}if(c._tokenizer.getVisible()===false){c._tokenizer.setVisible(true);}}}}});}};
M.prototype.getCursorPosition=function(){return this._$input.cursorPos();};
M.prototype._completeTextIsSelected=function(){var i=this._$input[0];if(i.selectionStart!==0){return false;}if(i.selectionEnd!==this.getValue().length){return false;}return true;};
M.prototype._getIsSuggestionPopupOpen=function(){return this._oSuggestionPopup&&this._oSuggestionPopup.isOpen();};
M.prototype.setEditable=function(e){e=this.validateProperty("editable",e);if(e===this.getEditable()){return this;}if(e&&(this.getEnableMultiLineMode()||this._bUseDialog)){this._bShowIndicator=true;}else{this._bShowIndicator=false;}if(I.prototype.setEditable){I.prototype.setEditable.apply(this,arguments);}this._tokenizer.setEditable(e);return this;};
M.prototype._findItem=function(t,b,e,g){if(!t){return;}if(!(b&&b.length)){return;}t=t.toLowerCase();var c=b.length;for(var i=0;i<c;i++){var d=b[i];var f=g(d);if(!f){continue;}f=f.toLowerCase();if(f===t){return d;}if(!e&&f.indexOf(t)===0){return d;}}};
M.prototype._getSuggestionItem=function(t,e){var b=null;var c=null;if(this._hasTabularSuggestions()){b=this.getSuggestionRows();c=this._findItem(t,b,e,function(R){var d=R.getCells();var f=null;if(d){var i;for(i=0;i<d.length;i++){if(d[i].getText){f=d[i].getText();break;}}}return f;});}else{b=this.getSuggestionItems();c=this._findItem(t,b,e,function(c){return c.getText();});}return c;};
M.prototype.addToken=function(t){this._tokenizer.addToken(t);return this;};
M.prototype.removeToken=function(t){return this._tokenizer.removeToken(t);};
M.prototype.removeAllTokens=function(){return this._tokenizer.removeAllTokens();};
M.prototype.getTokens=function(){return this._tokenizer.getTokens();};
M.prototype.insertToken=function(t,i){this._tokenizer.insertToken(t,i);return this;};
M.prototype.indexOfToken=function(t){return this._tokenizer.indexOfToken(t);};
M.prototype.destroyTokens=function(){this._tokenizer.destroyTokens();return this;};
M.prototype.getAggregation=function(A,d){var t;if(A==="tokens"){t=this.getTokens();if(t.length===0){t=d||null;}return t;}else{return I.prototype.getAggregation.apply(this,arguments);}};
M.prototype.clone=function(){var c,t;this._tokenizer.detachTokenChange(this._onTokenChange,this);this.detachSuggestionItemSelected(this._onSuggestionItemSelected,this);this.detachLiveChange(this._onLiveChange,this);c=I.prototype.clone.apply(this,arguments);t=this._tokenizer.clone();c._tokenizer=t;c.setAggregation("tokenizer",t,true);this._tokenizer.attachTokenChange(this._onTokenChange,this);this.attachSuggestionItemSelected(this._onSuggestionItemSelected,this);this.attachLiveChange(this._onLiveChange,this);return c;};
M.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("border");};
M.prototype.setTokens=function(t){var v,V=[],i;if(Array.isArray(t)){for(i=0;i<t.length;i++){v=this.validateAggregation("tokens",t[i],true);V.push(v);}this._tokenizer.setTokens(V);}else{throw new Error("\""+t+"\" is of type "+typeof t+", expected array for aggregation tokens of "+this);}return this;};
M.TokenChangeType={Added:"added",Removed:"removed",RemovedAll:"removedAll",TokensChanged:"tokensChanged"};M.WaitForAsyncValidation="sap.m.Tokenizer.WaitForAsyncValidation";M.prototype.getDomRefForValueStateMessage=M.prototype.getPopupAnchorDomRef;
M.prototype.getAccessibilityInfo=function(){var t=this.getTokens().map(function(o){return o.getText();}).join(" ");var i=I.prototype.getAccessibilityInfo.apply(this,arguments);i.type=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_MULTIINPUT");i.description=((i.description||"")+" "+t).trim();return i;};
return M;},true);
sap.ui.predefine('sap/m/MultiInputRenderer',['jquery.sap.global','./InputRenderer','sap/ui/core/Renderer'],function(q,I,R){"use strict";var M=R.extend(I);
M.addOuterClasses=function(r,c){I.addOuterClasses.call(this,r,c);r.addClass("sapMMultiInput");if(c.getEnableMultiLineMode()){r.addClass("sapMMultiInputMultiLine");}};
M.getAriaDescribedBy=function(c){var a=I.getAriaDescribedBy.apply(this,arguments);if(a){a=a+" "+c._sAriaMultiInputContainTokenId;}else{a=c._sAriaMultiInputContainTokenId;}return a;};
M.openInputTag=function(r,c){r.write('<div id="'+c.getId()+'-border"');r.addClass('sapMMultiInputBorder');if(c.getEnableMultiLineMode()||c._bUseDialog){c._isMultiLineMode=true;if(c.getEditable()){c._showIndicator();}else{c._showAllTokens();}}r.writeClasses();r.write('>');M._renderTokens(r,c);M._renderInput(r,c);};
M._renderTokens=function(r,c){r.renderControl(c.getAggregation("tokenizer"));};
M._renderInput=function(r,c){if(c._isMultiLineMode&&c._bShowIndicator===false){r.write("<div class=\"sapMMultiInputInputContainer sapMMultiInputMultiModeInputContainer\">");}else{if(c._isMultiLineMode&&c._bShowIndicator===true){var t=c.getTokens().length;r.write("<span class=\"sapMMultiInputIndicator\">");if(t>1){var m=sap.ui.getCore().getLibraryResourceBundle("sap.m");r.write(m.getText("MULTIINPUT_SHOW_MORE_TOKENS",t-1));}r.write("</span>");}r.write("<div class=\"sapMMultiInputInputContainer\">");}I.openInputTag.call(this,r,c);};
M.closeInputTag=function(r,c){I.closeInputTag.call(this,r,c);r.write("</div>");r.write("</div>");r.write("<div class=\"sapMMultiInputShadowDiv\"></div>");};
M.addInnerStyles=function(r,c){if(c._isMultiLineMode&&c._bShowIndicator===true&&c.getTokens().length>1){r.addStyle("opacity",0);}};
M.addControlWidth=function(r,c){if(!c.getWidth()||c.getWidth()==="auto"){r.addStyle("width","100%");}else{I.addControlWidth.call(this,r,c);}};
return M;},true);
sap.ui.predefine('sap/m/NavContainer',['jquery.sap.global','./library','sap/ui/core/Control'],function(q,a,C){"use strict";
var N=C.extend("sap.m.NavContainer",{metadata:{library:"sap.m",properties:{autoFocus:{type:"boolean",group:"Behavior",defaultValue:true},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},visible:{type:"boolean",group:"Appearance",defaultValue:true},defaultTransitionName:{type:"string",group:"Appearance",defaultValue:"slide"}},defaultAggregation:"pages",aggregations:{pages:{type:"sap.ui.core.Control",multiple:true,singularName:"page"}},associations:{initialPage:{type:"sap.ui.core.Control",multiple:false}},events:{navigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}}}}});
var u=sap.ui.getCore().getConfiguration().getAnimation(),g=function(d){return u?d:0;};
N.prototype.init=function(){this._pageStack=[];this._aQueue=[];this._mVisitedPages={};this._mFocusObject={};this._iTransitionsCompleted=0;this._bNeverRendered=true;this._bNavigating=false;this._bRenderingInProgress=false;};
N.prototype.exit=function(){this._mFocusObject=null;};
N.prototype.onBeforeRendering=function(){var p=this.getCurrentPage();if(this._bNeverRendered&&p){var b=p.getId();if(!this._mVisitedPages[b]){this._mVisitedPages[b]=true;var n={from:null,fromId:null,to:p,toId:b,firstTime:true,isTo:false,isBack:false,isBackToPage:false,isBackToTop:false,direction:"initial"};var e=q.Event("BeforeFirstShow",n);e.srcControl=this;e.data=this._oToDataBeforeRendering||{};e.backData={};p._handleEvent(e);e=q.Event("BeforeShow",n);e.srcControl=this;e.data=this._oToDataBeforeRendering||{};e.backData={};p._handleEvent(e);}}};
N.prototype.onAfterRendering=function(){var p=this.getCurrentPage(),f,n,b,e;if(this._bNeverRendered&&p){this._bNeverRendered=false;delete this._bNeverRendered;b=p.getId();if(!this._isInsideAPopup()&&this.getAutoFocus()){f=N._applyAutoFocusTo(b);if(f){this._mFocusObject[b]=f;}}n={from:null,fromId:null,to:p,toId:b,firstTime:true,isTo:false,isBack:false,isBackToTop:false,isBackToPage:false,direction:"initial"};e=q.Event("AfterShow",n);e.srcControl=this;e.data=this._oToDataBeforeRendering||{};e.backData={};p._handleEvent(e);}};
N.prototype._getActualInitialPage=function(){var p=this.getInitialPage();if(p){var b=sap.ui.getCore().byId(p);if(b){return b;}else{q.sap.log.error("NavContainer: control with ID '"+p+"' was set as 'initialPage' but was not found as a DIRECT child of this NavContainer (number of current children: "+this.getPages().length+").");}}var c=this.getPages();return(c.length>0?c[0]:null);};
N.prototype.getPage=function(p){var P=this.getPages();for(var i=0;i<P.length;i++){if(P[i]&&(P[i].getId()==p)){return P[i];}}return null;};
N.prototype._ensurePageStackInitialized=function(d){if(this._pageStack.length===0){var p=this._getActualInitialPage();if(p){this._pageStack.push({id:p.getId(),mode:"initial",data:d||{}});}}return this._pageStack;};
N.prototype.getCurrentPage=function(){var s=this._ensurePageStackInitialized();if(s.length>=1){return this.getPage(s[s.length-1].id);}else{q.sap.log.warning(this+": page stack is empty but should have been initialized - application failed to provide a page to display");return undefined;}};
N.prototype.getPreviousPage=function(){var s=this._ensurePageStackInitialized();if(s.length>1){return this.getPage(s[s.length-2].id);}else if(s.length==1){return undefined;}else{q.sap.log.warning(this+": page stack is empty but should have been initialized - application failed to provide a page to display");}};
N.prototype.currentPageIsTopPage=function(){var s=this._ensurePageStackInitialized();return(s.length===1);};
N.prototype.insertPreviousPage=function(p,t,d){var s=this._ensurePageStackInitialized();if(this._pageStack.length>0){var i=s.length-1;var b={id:p,mode:t,data:d};if(i===0){b.mode="initial";delete s[s.length-1].mode;}s.splice(i,0,b);}else{q.sap.log.warning(this+": insertPreviousPage called with empty page stack; ignoring");}return this;};
N._applyAutoFocusTo=function(i){var f=q.sap.byId(i).firstFocusableDomRef();if(f){q.sap.focus(f);}return f;};
N.prototype._applyAutoFocus=function(n){var p=n.toId,d,A=this.getAutoFocus(),b=n.isBack||n.isBackToPage||n.isBackToTop;if(b){d=this._mFocusObject!=null?this._mFocusObject[p]:null;if(d){q.sap.focus(d);}else if(A){N._applyAutoFocusTo(p);}}else if(n.isTo&&A){N._applyAutoFocusTo(p);}};
N.prototype._afterTransitionCallback=function(n,d,b){var e=q.Event("AfterShow",n);e.data=d||{};e.backData=b||{};e.srcControl=this;n.to._handleEvent(e);e=q.Event("AfterHide",n);e.srcControl=this;n.from._handleEvent(e);this._iTransitionsCompleted++;this._bNavigating=false;this._applyAutoFocus(n);this.fireAfterNavigate(n);q.sap.log.info(this+": _afterTransitionCallback called, to: "+n.toId);if(n.to.hasStyleClass("sapMNavItemHidden")){q.sap.log.warning(this.toString()+": target page '"+n.toId+"' still has CSS class 'sapMNavItemHidden' after transition. This should not be the case, please check the preceding log statements.");n.to.removeStyleClass("sapMNavItemHidden");}if(this._aQueue.length>0){var f=this._aQueue.shift();f();}};
N.prototype.to=function(p,t,d,T,f){if(p instanceof C){p=p.getId();}if(typeof(t)!=="string"){T=d;d=t;}t=t||this.getDefaultTransitionName();T=T||{};d=d||{};this._ensurePageStackInitialized(d);if(this._bNavigating){q.sap.log.info(this.toString()+": Cannot navigate to page "+p+" because another navigation is already in progress. - navigation will be executed after the previous one");this._aQueue.push(q.proxy(function(){this.to(p,t,d,T,true);},this));return this;}if(this._bNeverRendered){this._oToDataBeforeRendering=d;}var F=this.getCurrentPage();if(F&&(F.getId()===p)){q.sap.log.warning(this.toString()+": Cannot navigate to page "+p+" because this is the current page.");if(f){this._aQueue.shift();}return this;}var o=this.getPage(p);if(o){if(!F){q.sap.log.warning("Navigation triggered to page with ID '"+p+"', but the current page is not known/aggregated by "+this);return this;}this._mFocusObject[F.getId()]=document.activeElement;var n={from:F,fromId:F.getId(),to:o,toId:p,firstTime:!this._mVisitedPages[p],isTo:true,isBack:false,isBackToTop:false,isBackToPage:false,direction:"to"};var c=this.fireNavigate(n);if(c){sap.m.closeKeyboard();var e=q.Event("BeforeHide",n);e.srcControl=this;F._handleEvent(e);if(!this._mVisitedPages[p]){e=q.Event("BeforeFirstShow",n);e.srcControl=this;e.data=d||{};e.backData={};o._handleEvent(e);}e=q.Event("BeforeShow",n);e.srcControl=this;e.data=d||{};e.backData={};o._handleEvent(e);this._pageStack.push({id:p,mode:t,data:d});q.sap.log.info(this.toString()+": navigating to page '"+p+"': "+o.toString());this._mVisitedPages[p]=true;if(!this.getDomRef()){q.sap.log.info("'Hidden' 'to' navigation in not-rendered NavContainer "+this.toString());if(this._bRenderingInProgress){q.sap.delayedCall(0,this,this.invalidate);}return this;}var b;if(!(b=o.getDomRef())||b.parentNode!=this.getDomRef()||sap.ui.core.RenderManager.isPreservedContent(b)){o.addStyleClass("sapMNavItemRendering");q.sap.log.debug("Rendering 'to' page '"+o.toString()+"' for 'to' navigation");var r=sap.ui.getCore().createRenderManager();r.render(o,this.getDomRef());r.destroy();o.addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemRendering");}var h=N.transitions[t]||N.transitions["slide"];var i=this._iTransitionsCompleted;var j=this;window.setTimeout(function(){if(j&&(j._iTransitionsCompleted<i+1)){q.sap.log.warning("Transition '"+t+"' 'to' was triggered five seconds ago, but has not yet invoked the end-of-transition callback.");}},g(5000));this._bNavigating=true;h.to.call(this,F,o,q.proxy(function(){this._afterTransitionCallback(n,d);},this),T);}else{q.sap.log.info("Navigation to page with ID '"+p+"' has been aborted by the application");}}else{q.sap.log.warning("Navigation triggered to page with ID '"+p+"', but this page is not known/aggregated by "+this);}return this;};
N.prototype.back=function(b,t){this._backTo("back",b,t);return this;};
N.prototype.backToPage=function(p,b,t){this._backTo("backToPage",b,t,p);return this;};
N.prototype.backToTop=function(b,t){this._backTo("backToTop",b,t);return this;};
N.prototype._backTo=function(t,b,T,r){if(this._bNavigating){q.sap.log.warning(this.toString()+": Cannot navigate back because another navigation is already in progress. - navigation will be executed after the previous one");this._aQueue.push(q.proxy(function(){this._backTo(t,b,T,r);},this));return this;}if(this._pageStack.length<=1){if(this._pageStack.length===1&&this._pageStack[0].mode!="initial"){throw new Error("Initial page not found on the stack. How did this happen?");}return this;}else{if(r instanceof C){r=r.getId();}var f=this._pageStack[this._pageStack.length-1];var m=f.mode;var F=this.getPage(f.id);var o;var c;if(t==="backToTop"){o=this._getActualInitialPage();c=null;}else if(t==="backToPage"){var i=this._findClosestPreviousPageInfo(r);if(!i){q.sap.log.error(this.toString()+": Cannot navigate backToPage('"+r+"') because target page was not found among the previous pages.");return this;}o=sap.ui.getCore().byId(i.id);if(!o){q.sap.log.error(this.toString()+": Cannot navigate backToPage('"+r+"') because target page does not exist anymore.");return this;}c=i.data;}else{o=this.getPreviousPage();c=this._pageStack[this._pageStack.length-2].data;}if(!o){q.sap.log.error("NavContainer back navigation: target page is not defined or not aggregated by this NavContainer. Aborting navigation.");return;}var d=o.getId();b=b||{};T=T||{};var n={from:F,fromId:F.getId(),to:o,toId:d,firstTime:!this._mVisitedPages[d],isTo:false,isBack:(t==="back"),isBackToPage:(t==="backToPage"),isBackToTop:(t==="backToTop"),direction:t};var e=this.fireNavigate(n);if(e){sap.m.closeKeyboard();var E=q.Event("BeforeHide",n);E.srcControl=this;F._handleEvent(E);if(!this._mVisitedPages[d]){E=q.Event("BeforeFirstShow",n);E.srcControl=this;E.backData=b||{};E.data={};o._handleEvent(E);}E=q.Event("BeforeShow",n);E.srcControl=this;E.backData=b||{};E.data=c||{};o._handleEvent(E);this._pageStack.pop();q.sap.log.info(this.toString()+": navigating back to page "+o.toString());this._mVisitedPages[d]=true;if(t==="backToTop"){this._pageStack=[];q.sap.log.info(this.toString()+": navigating back to top");this.getCurrentPage();}else if(t==="backToPage"){var p=[],h;while(this._pageStack[this._pageStack.length-1].id!==r){h=this._pageStack.pop();p.push(h.id);}q.sap.log.info(this.toString()+": navigating back to specific page "+o.toString()+" across the pages: "+p.join(", "));}if(!this.getDomRef()){q.sap.log.info("'Hidden' back navigation in not-rendered NavContainer "+this.toString());return this;}var j=N.transitions[m]||N.transitions["slide"];var k=this._iTransitionsCompleted;var l=this;window.setTimeout(function(){if(l&&(l._iTransitionsCompleted<k+1)){q.sap.log.warning("Transition '"+m+"' 'back' was triggered five seconds ago, but has not yet invoked the end-of-transition callback.");}},g(5000));this._bNavigating=true;var s;if(!(s=o.getDomRef())||s.parentNode!=this.getDomRef()||sap.ui.core.RenderManager.isPreservedContent(s)){o.addStyleClass("sapMNavItemRendering");q.sap.log.debug("Rendering 'to' page '"+o.toString()+"' for back navigation");var v=sap.ui.getCore().createRenderManager();var w=this.$().children().index(F.getDomRef());v.renderControl(o);v.flush(this.getDomRef(),false,w);v.destroy();o.addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemRendering");}if(F.getId()===o.getId()){q.sap.log.info("Transition is skipped when navigating back to the same page instance"+o.toString());this._afterTransitionCallback(n,c,b);return this;}j.back.call(this,F,o,q.proxy(function(){this._afterTransitionCallback(n,c,b);},this),T);}}return this;};
N.prototype._findClosestPreviousPageInfo=function(r){for(var i=this._pageStack.length-2;i>=0;i--){var b=this._pageStack[i];if(b.id===r){return b;}}return null;};
N.transitions=N.transitions||{};N.transitions["show"]={to:function(f,t,c){t.removeStyleClass("sapMNavItemHidden");f&&f.addStyleClass("sapMNavItemHidden");c();},back:function(f,t,c){t.removeStyleClass("sapMNavItemHidden");f&&f.addStyleClass("sapMNavItemHidden");c();}};if(q.support.cssTransitions){N.transitions["slide"]={to:function(f,t,c){f.addStyleClass("sapMNavItemCenter");window.setTimeout(function(){t.addStyleClass("sapMNavItemRight");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).unbind("webkitTransitionEnd transitionend");if(!o){o=true;}else{T=false;t.removeStyleClass("sapMNavItemSliding").removeStyleClass("sapMNavItemCenter");f.removeStyleClass("sapMNavItemSliding").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemLeft");c();}};f.$().bind("webkitTransitionEnd transitionend",A);t.$().bind("webkitTransitionEnd transitionend",A);t.addStyleClass("sapMNavItemSliding").addStyleClass("sapMNavItemCenter").removeStyleClass("sapMNavItemRight");f.addStyleClass("sapMNavItemSliding").removeStyleClass("sapMNavItemCenter").addStyleClass("sapMNavItemLeft");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(400));},g(60));},0);},back:function(f,t,c){t.addStyleClass("sapMNavItemLeft");t.removeStyleClass("sapMNavItemHidden");f.addStyleClass("sapMNavItemCenter");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).unbind("webkitTransitionEnd transitionend");if(!o){o=true;}else{T=false;t.removeStyleClass("sapMNavItemSliding").removeStyleClass("sapMNavItemCenter");f.removeStyleClass("sapMNavItemSliding").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemRight");c();}};f.$().bind("webkitTransitionEnd transitionend",A);t.$().bind("webkitTransitionEnd transitionend",A);if(sap.ui.Device.browser.webkit){window.setTimeout(function(){t.$().css("box-shadow","0em 1px 0em rgba(128, 128, 1280, 0.1)");window.setTimeout(function(){t.$().css("box-shadow","");},g(50));},0);}t.addStyleClass("sapMNavItemSliding").addStyleClass("sapMNavItemCenter").removeStyleClass("sapMNavItemLeft");f.addStyleClass("sapMNavItemSliding").removeStyleClass("sapMNavItemCenter").addStyleClass("sapMNavItemRight");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(400));},g(100));}};}else{N.transitions["slide"]={to:function(f,t,c){var T=t.$();T.css("left","100%");t.removeStyleClass("sapMNavItemHidden");T.animate({left:"0%"},g(300));var F=f.$();F.animate({left:"-100%"},g(300),function(){f.addStyleClass("sapMNavItemHidden");F.css("left","0");c();});},back:function(f,t,c){var T=t.$();T.css("left","-100%");t.removeStyleClass("sapMNavItemHidden");T.animate({left:"0%"},g(300));var F=f.$();F.animate({left:"100%"},g(300),function(){f.addStyleClass("sapMNavItemHidden");F.css("left","0");c();});}};}if(q.support.cssTransitions){N.transitions["fade"]={to:function(f,t,c){t.addStyleClass("sapMNavItemTransparent");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var A=null;var T=true;A=function(){q(this).unbind("webkitTransitionEnd transitionend");T=false;f.addStyleClass("sapMNavItemHidden");t.removeStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemOpaque");c();};t.$().bind("webkitTransitionEnd transitionend",A);t.addStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemTransparent").addStyleClass("sapMNavItemOpaque");window.setTimeout(function(){if(T){A.apply(t.$());}},g(600));},g(10));},back:function(f,t,c){f.addStyleClass("sapMNavItemOpaque");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var A=null;var T=true;A=function(){q(this).unbind("webkitTransitionEnd transitionend");T=false;f.removeStyleClass("sapMNavItemFading").addStyleClass("sapMNavItemHidden");f.removeStyleClass("sapMNavItemTransparent");c();};f.$().bind("webkitTransitionEnd transitionend",A);f.addStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemOpaque");f.addStyleClass("sapMNavItemTransparent");window.setTimeout(function(){if(T){A.apply(t.$());}},g(600));},g(10));}};}else{N.transitions["fade"]={to:function(f,t,c){var T=t.$();T.css("opacity","0");t.removeStyleClass("sapMNavItemHidden");T.animate({opacity:"1"},g(500),function(){f.addStyleClass("sapMNavItemHidden");c();});},back:function(f,t,c){var F=f.$();t.removeStyleClass("sapMNavItemHidden");F.animate({opacity:"0"},g(500),function(){f.addStyleClass("sapMNavItemHidden");F.css("opacity","1");c();});}};}if(q.support.cssTransitions){N.transitions["flip"]={to:function(f,t,c){var b=this;window.setTimeout(function(){b.$().addClass("sapMNavFlip");t.addStyleClass("sapMNavItemFlipNext");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).unbind("webkitTransitionEnd transitionend");if(!o){o=true;}else{T=false;t.removeStyleClass("sapMNavItemFlipping");f.removeStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemFlipPrevious");b.$().removeClass("sapMNavFlip");c();}};f.$().bind("webkitTransitionEnd transitionend",A);t.$().bind("webkitTransitionEnd transitionend",A);t.addStyleClass("sapMNavItemFlipping").removeStyleClass("sapMNavItemFlipNext");f.addStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemFlipPrevious");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(600));},g(60));},0);},back:function(f,t,c){var b=this;b.$().addClass("sapMNavFlip");t.addStyleClass("sapMNavItemFlipPrevious");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).unbind("webkitTransitionEnd transitionend");if(!o){o=true;}else{T=false;t.removeStyleClass("sapMNavItemFlipping");f.removeStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemFlipNext");b.$().removeClass("sapMNavFlip");c();}};f.$().bind("webkitTransitionEnd transitionend",A);t.$().bind("webkitTransitionEnd transitionend",A);t.addStyleClass("sapMNavItemFlipping").removeStyleClass("sapMNavItemFlipPrevious");f.addStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemFlipNext");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(600));},g(60));}};}else{N.transitions["flip"]=N.transitions["slide"];}if(q.support.cssTransitions){N.transitions["door"]={to:function(f,t,c){var b=this;window.setTimeout(function(){b.$().addClass("sapMNavDoor");t.addStyleClass("sapMNavItemDoorInNext");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).unbind("webkitAnimationEnd animationend");if(!o){o=true;}else{T=false;t.removeStyleClass("sapMNavItemDooring").removeStyleClass("sapMNavItemDoorInNext");f.removeStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemDoorInPrevious");b.$().removeClass("sapMNavDoor");c();}};f.$().bind("webkitAnimationEnd animationend",A);t.$().bind("webkitAnimationEnd animationend",A);t.addStyleClass("sapMNavItemDooring");f.addStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemDoorInPrevious");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(1000));},g(60));},0);},back:function(f,t,c){var b=this;b.$().addClass("sapMNavDoor");t.addStyleClass("sapMNavItemDoorOutNext");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).unbind("webkitAnimationEnd animationend");if(!o){o=true;}else{T=false;t.removeStyleClass("sapMNavItemDooring").removeStyleClass("sapMNavItemDoorOutNext");f.removeStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemDoorOutPrevious");b.$().removeClass("sapMNavDoor");c();}};f.$().bind("webkitAnimationEnd animationend",A);t.$().bind("webkitAnimationEnd animationend",A);t.addStyleClass("sapMNavItemDooring");f.addStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemDoorOutPrevious");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(1000));},g(60));}};}else{N.transitions["door"]=N.transitions["slide"];}
N.prototype.addCustomTransition=function(n,t,b){if(N.transitions[n]){q.sap.log.warning("Transition with name "+n+" already exists in "+this+". It is now being replaced by custom transition.");}N.transitions[n]={to:t,back:b};return this;};
N.addCustomTransition=N.prototype.addCustomTransition;N.prototype.forceInvalidation=N.prototype.invalidate;
N.prototype.invalidate=function(s){if(s==this){}else if(!s){this.forceInvalidation();}else if(s instanceof C){var I=false,p=this.getPages(),l=p.length;for(var i=0;i<l;i++){if(p[i]===s){I=true;break;}}if((!I||s===this.getCurrentPage())&&!this._isInsideAPopup()){this.forceInvalidation();}}else{this.forceInvalidation();}};
N.prototype._isInsideAPopup=function(){var s;s=function(c){if(!c){return false;}if(c.getMetadata().isInstanceOf("sap.ui.core.PopupInterface")){return true;}return s(c.getParent());};return s(this);};
N.prototype.removePage=function(p){p=this.removeAggregation("pages",p,p!==this.getCurrentPage());this._onPageRemoved(p);return p;};
N.prototype._onPageRemoved=function(p){if(!p){return;}p.$().remove();p.removeStyleClass("sapMNavItemHidden");p.removeStyleClass("sapMNavItem");var s=this._ensurePageStackInitialized();this._pageStack=s.filter(function(P){return p.getId()!==P.id;});};
N.prototype.removeAllPages=function(){var p=this.getPages();if(!p){return[];}for(var i=0;i<p.length;i++){this._onPageRemoved(p[i]);}return this.removeAllAggregation("pages");};
N.prototype.addPage=function(p){var P=this.getPages();if(q.inArray(p,P)>-1){return this;}this.addAggregation("pages",p,true);p.addStyleClass("sapMNavItem");var i=P.length;if(i===0&&this.getPages().length===1&&this.getDomRef()){this._ensurePageStackInitialized();this.rerender();this._fireAdaptableContentChange(p);}return this;};
N.prototype.insertPage=function(p,i){var P=this.getPages().length;this.insertAggregation("pages",p,i,true);p.addStyleClass("sapMNavItem");if(P===0&&this.getPages().length===1&&this.getDomRef()){this._ensurePageStackInitialized();this.rerender();this._fireAdaptableContentChange(p);}return this;};
N.prototype._getAdaptableContent=function(){return this.getCurrentPage();};
N.prototype._fireAdaptableContentChange=function(p){if(p&&this.mEventRegistry["_adaptableContentChange"]){this.fireEvent("_adaptableContentChange",{"parent":this,"adaptableContent":p});}};
return N;},true);
sap.ui.predefine('sap/m/NavContainerRenderer',['jquery.sap.global'],function(q){"use strict";var N={};
N.render=function(r,c){c._bRenderingInProgress=true;if(!c.getVisible()){return;}r.write("<div");r.writeControlData(c);r.addClass("sapMNav");if(c.getWidth()){r.addStyle("width",c.getWidth());}var h=c.getHeight();if(h&&h!="100%"){r.addStyle("height",h);}if(this.renderAttributes){this.renderAttributes(r,c);}r.writeClasses();r.writeStyles();var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.write(">");if(this.renderBeforeContent){this.renderBeforeContent(r,c);}var C=c.getCurrentPage();if(C){C.removeStyleClass("sapMNavItemHidden");r.renderControl(C);}r.write("</div>");c._bRenderingInProgress=false;};
return N;},true);
sap.ui.predefine('sap/m/NewsContent',['jquery.sap.global','./library','sap/ui/core/Control','sap/m/Text'],function(q,l,C,T){"use strict";
var N=C.extend("sap.m.NewsContent",{metadata:{library:"sap.m",properties:{"size":{type:"sap.m.Size",group:"Misc",defaultValue:sap.m.Size.Auto},"contentText":{type:"string",group:"Misc",defaultValue:null},"subheader":{type:"string",group:"Misc",defaultValue:null}},aggregations:{"_contentText":{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{"press":{}}}});
N.prototype.init=function(){this._oContentText=new T(this.getId()+"-content-text",{maxLines:2});this._oContentText.cacheLineHeight=false;this.setAggregation("_contentText",this._oContentText,true);this.setTooltip("{AltText}");};
N.prototype.onBeforeRendering=function(){this._setPointerOnContentText();this.$().unbind("mouseenter",this._addTooltip);this.$().unbind("mouseleave",this._removeTooltip);};
N.prototype.onAfterRendering=function(){this.$().bind("mouseenter",this._addTooltip.bind(this));this.$().bind("mouseleave",this._removeTooltip.bind(this));};
N.prototype._addTooltip=function(){this.$().attr("title",this.getTooltip_AsString());};
N.prototype._removeTooltip=function(){this.$().attr("title",null);};
N.prototype._setPointerOnContentText=function(){var t=this.getAggregation("_contentText");if(t&&this.hasListeners("press")){t.addStyleClass("sapMPointer");}else if(t&&t.hasStyleClass("sapMPointer")){t.removeStyleClass("sapMPointer");}};
N.prototype.getAltText=function(){var a="";var i=true;if(this.getAggregation("_contentText").getText()){a+=this.getAggregation("_contentText").getText();i=false;}if(this.getSubheader()){if(i){a+=""+this.getSubheader();}else{a+="\n"+this.getSubheader();}}return a;};
N.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var s=this.getAltText();if(typeof t==="string"||t instanceof String){s=t.split("{AltText}").join(s).split("((AltText))").join(s);return s;}if(t){return t;}else{return"";}};
N.prototype.setContentText=function(t){this._oContentText.setText(t);return this;};
N.prototype.ontap=function(e){if(sap.ui.Device.browser.internet_explorer){this.$().focus();}this.firePress();};
N.prototype.onkeydown=function(e){if(e.which===q.sap.KeyCodes.ENTER||e.which===q.sap.KeyCodes.SPACE){this.firePress();e.preventDefault();}};
N.prototype.attachEvent=function(e,d,f,a){sap.ui.core.Control.prototype.attachEvent.call(this,e,d,f,a);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");this._setPointerOnContentText();}return this;};
N.prototype.detachEvent=function(e,f,a){sap.ui.core.Control.prototype.detachEvent.call(this,e,f,a);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");this._setPointerOnContentText();}return this;};
return N;},true);
sap.ui.predefine('sap/m/NewsContentRenderer',[],function(){"use strict";var N={};
N.render=function(r,c){var s=c.getSubheader();var t=c.getTooltip_AsString();if(typeof t!=="string"){t="";}r.write("<div");r.writeControlData(c);r.writeAttribute("id",c.getId()+"-news-content");r.writeAttribute("role","presentation");r.writeAttributeEscaped("aria-label",t);r.addClass("sapMNwC");if(c.hasListeners("press")){r.addClass("sapMPointer");r.writeAttribute("tabindex","0");}r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMNwCCTxt");r.writeClasses();r.write(">");r.renderControl(c._oContentText);r.write("</div>");r.write("<div");r.writeAttribute("id",c.getId()+"-subheader");r.addClass("sapMNwCSbh");r.writeClasses();r.write(">");r.writeEscaped(s);r.write("</div>");r.write("</div>");};
return N;},true);
sap.ui.predefine('sap/m/NotificationListBase',['jquery.sap.global','./library','sap/ui/core/Control','./ListItemBase','./Text','./Image','./OverflowToolbar','sap/ui/core/Icon'],function(q,l,C,L,T,I,O,a){'use strict';
var N=L.extend('sap.m.NotificationListBase',{metadata:{library:'sap.m',properties:{priority:{type:'sap.ui.core.Priority',group:'Appearance',defaultValue:sap.ui.core.Priority.None},title:{type:'string',group:'Appearance',defaultValue:''},datetime:{type:'string',group:'Appearance',defaultValue:''},showButtons:{type:'boolean',group:'Behavior',defaultValue:true},showCloseButton:{type:'boolean',group:'Behavior',defaultValue:true},authorName:{type:'string',group:'Appearance',defaultValue:''},authorPicture:{type:'sap.ui.core.URI',multiple:false}},aggregations:{buttons:{type:'sap.m.Button',multiple:true},_headerTitle:{type:'sap.m.Text',multiple:false,visibility:"hidden"},_dateTime:{type:'sap.m.Text',multiple:false,visibility:'hidden'},_authorName:{type:'sap.m.Text',multiple:false,visibility:"hidden"},_authorImage:{type:'sap.ui.core.Control',multiple:false,visibility:"hidden"},_overflowToolbar:{type:'sap.m.OverflowToolbar',multiple:false,visibility:"hidden"},_closeButton:{type:'sap.m.Button',multiple:false,visibility:"hidden"},_collapseButton:{type:'sap.m.Button',multiple:false,visibility:"hidden"}},events:{close:{}}}});
N.prototype.init=function(){this.setAggregation('_overflowToolbar',new O());};
N.prototype.setTitle=function(t){var r=this.setProperty('title',t);this._getHeaderTitle().setText(t);return r;};
N.prototype.setDatetime=function(d){var r=this.setProperty('datetime',d);this._getDateTimeText().setText(d);return r;};
N.prototype.setAuthorName=function(b){var r=this.setProperty('authorName',b);this._getAuthorName().setText(b);return r;};
N.prototype.clone=function(){var c=C.prototype.clone.apply(this,arguments);var o=this.getAggregation('_overflowToolbar');c.setAggregation("_overflowToolbar",o.clone(),true);return c;};
N.prototype.close=function(){var p=this.getParent();this.fireClose();if(p&&p instanceof sap.ui.core.Element){var d={onAfterRendering:function(){p.getDomRef().focus();p.removeEventDelegate(d);}};p.addEventDelegate(d);}};
N.prototype.bindAggregation=function(b,c){if(b=='buttons'){this.getAggregation('_overflowToolbar').bindAggregation('content',c);return this;}else{return sap.ui.core.Control.prototype.bindAggregation.call(this,b,c);}};
N.prototype.validateAggregation=function(b,o,m){if(b=='buttons'){this.getAggregation('_overflowToolbar').validateAggregation('content',o,m);return this;}else{return sap.ui.core.Control.prototype.validateAggregation.call(this,b,o,m);}};
N.prototype.setAggregation=function(b,o,s){if(b=='buttons'){this.getAggregation('_overflowToolbar').setAggregation('content',o,s);return this;}else{return sap.ui.core.Control.prototype.setAggregation.call(this,b,o,s);}};
N.prototype.getAggregation=function(b,d){if(b=='buttons'){var t=this.getAggregation('_overflowToolbar');return t.getContent().filter(function(c){return c instanceof sap.m.Button;});}else{return sap.ui.core.Control.prototype.getAggregation.call(this,b,d);}};
N.prototype.indexOfAggregation=function(b,o){if(b=='buttons'){return this.getAggregation('_overflowToolbar').indexOfAggregation('content',o);}else{return sap.ui.core.Control.prototype.indexOfAggregation.call(this,b,o);}};
N.prototype.insertAggregation=function(b,o,c,s){if(b=='buttons'){this.getAggregation('_overflowToolbar').insertAggregation('content',o,c,s);return this;}else{return sap.ui.core.Control.prototype.insertAggregation.call(this,o,c,s);}};
N.prototype.addAggregation=function(b,o,s){if(b=='buttons'){var t=this.getAggregation('_overflowToolbar');return t.addAggregation('content',o,s);}else{return sap.ui.core.Control.prototype.addAggregation.call(this,b,o,s);}};
N.prototype.removeAggregation=function(b,o,s){if(b=='buttons'){return this.getAggregation('_overflowToolbar').removeAggregation('content',o,s);}else{return sap.ui.core.Control.prototype.removeAggregation.call(this,b,o,s);}};
N.prototype.removeAllAggregation=function(b,s){if(b=='buttons'){return this.getAggregation('_overflowToolbar').removeAllAggregation('content',s);}else{return sap.ui.core.Control.prototype.removeAllAggregation.call(this,b,s);}};
N.prototype.destroyAggregation=function(b,s){if(b=='buttons'){return this.getAggregation('_overflowToolbar').destroyAggregation('content',s);}else{return sap.ui.core.Control.prototype.destroyAggregation.call(this,b,s);}};
N.prototype.getBinding=function(b){if(b=='buttons'){return this.getAggregation('_overflowToolbar').getBinding('content');}else{return sap.ui.core.Control.prototype.getBinding.call(this,b);}};
N.prototype.getBindingInfo=function(b){if(b=='buttons'){return this.getAggregation('_overflowToolbar').getBindingInfo('content');}else{return sap.ui.core.Control.prototype.getBindingInfo.call(this,b);}};
N.prototype.getBindingPath=function(b){if(b=='buttons'){return this.getAggregation('_overflowToolbar').getBindingPath('content');}else{return sap.ui.core.Control.prototype.getBindingPath.call(this,b);}};
N.prototype._getHeaderTitle=function(){var t=this.getAggregation("_headerTitle");if(!t){t=new T({id:this.getId()+'-title',text:this.getTitle(),maxLines:2});this.setAggregation("_headerTitle",t,true);}return t;};
N.prototype._getDateTimeText=function(){var d=this.getAggregation('_dateTime');if(!d){d=new sap.m.Text({id:this.getId()+'-datetime',text:this.getDatetime()}).addStyleClass('sapMNLI-Datetime');this.setAggregation('_dateTime',d,true);}return d;};
N.prototype._getAuthorName=function(){var b=this.getAggregation('_authorName');if(!b){b=new T({text:this.getAuthorName()}).addStyleClass('sapMNLI-Text');this.setAggregation('_authorName',b,true);}return b;};
N.prototype._getAuthorImage=function(){var b=this.getAggregation('_authorImage');if(!b){var c=this.getAuthorPicture();var d=this.getAuthorName();if(i(c)){b=new a({src:c,alt:d});}else{b=new I({src:c,alt:d});}this.setAggregation('_authorImage',b,true);}return b;};
N.prototype._getToolbar=function(){var t=this.getAggregation("_overflowToolbar");if(!t){t=new O();this.setAggregation("_overflowToolbar",t,true);}return t;};
function i(s){if(!s){return false;}var r=window.URI.parse(s);return(r.protocol&&r.protocol=='sap-icon');}
return N;},true);
sap.ui.predefine('sap/m/NotificationListGroup',['jquery.sap.global','./library','sap/ui/core/Control','./NotificationListBase'],function(q,l,C,N){'use strict';
var a=N.extend('sap.m.NotificationListGroup',{metadata:{library:'sap.m',properties:{collapsed:{type:'boolean',group:'Behavior',defaultValue:false},autoPriority:{type:'boolean',group:'Behavior',defaultValue:true},showEmptyGroup:{type:'boolean',group:'Behavior',defaultValue:false}},aggregations:{items:{type:'sap.m.NotificationListItem',multiple:true,singularName:'item'}}}});
a.prototype.init=function(){sap.m.NotificationListBase.prototype.init.call(this);var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');this._closeText=r.getText('NOTIFICATION_LIST_BASE_CLOSE');var _=new sap.m.Button(this.getId()+'-closeButton',{type:sap.m.ButtonType.Transparent,icon:sap.ui.core.IconPool.getIconURI('decline'),tooltip:this._closeText,press:function(){this.close();}.bind(this)});this.setAggregation("_closeButton",_,true);var b=new sap.m.Button({type:sap.m.ButtonType.Transparent,press:function(){this.setCollapsed(!this.getCollapsed());}.bind(this)});this.setAggregation("_collapseButton",b,true);};
a.prototype.setCollapsed=function(b){this._toggleCollapsed();return this.setProperty('collapsed',b,true);};
a.prototype.getPriority=function(){if(!this.getAutoPriority()){return this.getProperty('priority');}var n=this.getAggregation('items');var p=sap.ui.core.Priority.None;if(n){n.forEach(function(i){p=c(p,i.getPriority());});}else{p=this.getProperty('priority');}return p;};
a.prototype.getUnread=function(){var n=this.getAggregation('items');if(n){return n.some(function(i){return i.getUnread();});}return this.getProperty('unread');};
a.prototype.onBeforeRendering=function(){var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');var e=r.getText('NOTIFICATION_LIST_GROUP_EXPAND');var b=r.getText('NOTIFICATION_LIST_GROUP_COLLAPSE');var d=this.getShowEmptyGroup()&&(this._getVisibleItemsCount()===0);this.getAggregation('_collapseButton').setText(this.getCollapsed()?e:b).setEnabled(!d);};
a.prototype.clone=function(){return N.prototype.clone.apply(this,arguments);};
a.prototype._getHeaderTitle=function(){var t=sap.m.NotificationListBase.prototype._getHeaderTitle.call(this);t.addStyleClass('sapMNLG-Title');if(this.getUnread()){t.addStyleClass('sapMNLGTitleUnread');}return t;};
a.prototype._getDateTimeText=function(){var d=sap.m.NotificationListBase.prototype._getDateTimeText.call(this);d.setTextAlign('End');return d;};
a.prototype._toggleCollapsed=function(){var n=!this.getCollapsed();var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');var e=r.getText('NOTIFICATION_LIST_GROUP_EXPAND');var b=r.getText('NOTIFICATION_LIST_GROUP_COLLAPSE');this.getAggregation('_collapseButton').setText(n?e:b,true);this.$().toggleClass('sapMNLG-Collapsed',n);};
function c(f,s){if(f==s){return f;}if((f=='None')){return s;}if((f=='Low')&&(s!='None')){return s;}if((f=='Medium')&&(s!='None'&&s!='Low')){return s;}return f;}
a.prototype._getVisibleItemsCount=function(){var i=this.getItems(),r=0;i.forEach(function(b){if(b.getVisible()){r++;}});return r;};
return a;},true);
sap.ui.predefine('sap/m/NotificationListGroupRenderer',[],function(){'use strict';var N={};var c='sapMNLG';var a='sapMNLB';var b='sapMLIB';var d='sapMNLB-AuthorPicture';var e='sapMNLB-Header';var f='sapMNLG-Header';var g='sapMNLG-Body';var h='sapMNLB-Footer';var i='sapMNLG-Footer';var j='sapMNLB-CloseButton';var k='sapMNLB-Priority';var l='sapMNLG-Details';var m='sapMNLB-Bullet';var n='sapMNLG-Description';var o='sapMNLG-Collapsed';var p='sapMNLGNoHdrFooter';
N.render=function(r,C){if(C.getVisible()){var _=C.getShowEmptyGroup()||(C._getVisibleItemsCount()>0);r.write('<li');r.addClass(c);r.addClass(a);r.addClass(b);if(!_){r.addClass(p);}if(C.getCollapsed()){r.addClass(o);}r.writeClasses();r.writeControlData(C);r.writeAttribute('tabindex','0');r.writeAccessibilityState(C,{labelledby:C._getHeaderTitle().getId()});r.write('>');if(_){this.renderHeader(r,C);this.renderBody(r,C);this.renderFooter(r,C);}r.write('</li>');}else{this.renderInvisibleItem(r,C);}};
N.renderHeader=function(r,C){r.write('<div');r.addClass(e);r.addClass(f);r.writeClasses();r.write('>');this.renderPriorityArea(r,C);this.renderCloseButton(r,C);this.renderTitle(r,C);this.renderDetails(r,C);r.write('</div>');};
N.renderTitle=function(r,C){r.renderControl(C._getHeaderTitle());};
N.renderCloseButton=function(r,C){if(C.getShowCloseButton()){r.renderControl(C.getAggregation('_closeButton').addStyleClass(j));}};
N.renderAuthorPicture=function(r,C){if(!C.getAuthorPicture()){return;}r.write('<div');r.addClass(d);r.writeClasses();r.write('>');r.renderControl(C._getAuthorImage());r.write('</div>');};
N.renderDetails=function(r,C){r.write('<div class="'+l+'">');this.renderAuthorPicture(r,C);r.write('<div class="'+n+'">');this.renderAuthorName(r,C);if(C.getAuthorName()!=""&&C.getDatetime()!=""){r.write('<span class="'+m+'">&#x00B7</span>');}this.renderDatetime(r,C);r.write('</div></div>');};
N.renderAuthorName=function(r,C){r.renderControl(C._getAuthorName());};
N.renderBody=function(r,C){r.write('<ul class='+g+'>');this.renderNotifications(r,C);r.write('</ul>');};
N.renderDatetime=function(r,C){r.renderControl(C._getDateTimeText());};
N.renderNotifications=function(r,C){var q=C.getAggregation('items');if(q){q.forEach(function(s){r.renderControl(s);});}};
N.renderFooter=function(r,C){var q=C.getButtons();r.write('<div');r.addClass(i);r.addClass(h);r.writeClasses();r.write('>');this.renderPriorityArea(r,C);this.renderCollapseGroupButton(r,C);if(q&&q.length&&C.getShowButtons()){r.renderControl(C.getAggregation('_overflowToolbar'));}r.write('</div>');};
N.renderPriorityArea=function(r,C){r.write('<div');var q='';var s=C.getPriority();switch(s){case(sap.ui.core.Priority.Low):q='sapMNLB-Low';break;case(sap.ui.core.Priority.Medium):q='sapMNLB-Medium';break;case(sap.ui.core.Priority.High):q='sapMNLB-High';break;default:q='sapMNLB-None';break;}r.addClass(k);r.addClass(q);r.writeClasses();r.write('>');r.write('</div>');};
N.renderCollapseGroupButton=function(r,C){r.renderControl(C.getAggregation('_collapseButton'));};
N.renderInvisibleItem=function(r,C){r.write("<li");r.writeInvisiblePlaceholderData(C);r.write(">");r.write("</li>");};
return N;},true);
sap.ui.predefine('sap/m/NotificationListItem',['jquery.sap.global','./library','sap/ui/core/Control','./NotificationListBase','sap/ui/core/InvisibleText'],function(q,l,C,N,I){'use strict';
var a=N.extend('sap.m.NotificationListItem',{metadata:{library:'sap.m',properties:{description:{type:'string',group:'Appearance',defaultValue:''},truncate:{type:'boolean',group:'Appearance',defaultValue:true},hideShowMoreButton:{type:'boolean',group:'Appearance',defaultValue:false}},aggregations:{_bodyText:{type:'sap.m.Text',multiple:false,visibility:"hidden"}}}});
a.prototype.init=function(){sap.m.NotificationListBase.prototype.init.call(this);var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');this._expandText=r.getText('NOTIFICATION_LIST_ITEM_SHOW_MORE');this._collapseText=r.getText('NOTIFICATION_LIST_ITEM_SHOW_LESS');this._closeText=r.getText('NOTIFICATION_LIST_BASE_CLOSE');this.setType('Active');var _=new sap.m.Button(this.getId()+'-closeButton',{type:sap.m.ButtonType.Transparent,icon:sap.ui.core.IconPool.getIconURI('decline'),tooltip:this._closeText,press:function(){this.close();}.bind(this)});this.setAggregation("_closeButton",_,true);var b=new sap.m.Button({type:sap.m.ButtonType.Transparent,text:this.getTruncate()?this._expandText:this._collapseText,id:this.getId()+'-expandCollapseButton',press:function(){this._deregisterResize();this.setProperty("truncate",!this.getTruncate(),true);b.setText(this.getTruncate()?this._expandText:this._collapseText);this.$().find('.sapMNLI-Header').toggleClass('sapMNLI-TitleWrapper--is-expanded');this.$().find('.sapMNLI-TextWrapper').toggleClass('sapMNLI-TextWrapper--is-expanded',this.getDescription());this._registerResize();}.bind(this)});this.setAggregation("_collapseButton",b,true);this._ariaDetailsText=new I({id:this.getId()+'-info'}).toStatic();};
a.prototype.setDescription=function(d){var r=this.setProperty('description',d);this._getDescriptionText().setText(d);return r;};
a.prototype.setDatetime=function(d){var r=sap.m.NotificationListBase.prototype.setDatetime.call(this,d);this._updateAriaAdditionalInfo();return r;};
a.prototype.setUnread=function(u){var r=this.setProperty('unread',u,true);var t=this.getAggregation("_headerTitle");if(t){t.toggleStyleClass('sapMNLI-Unread',this.getUnread());}return r;};
a.prototype.setPriority=function(p,s){var r=this.setProperty('priority',p,s);this._updateAriaAdditionalInfo();return r;};
a.prototype.setAuthorPicture=function(b,s){var r=this.setProperty('authorPicture',b,s);this._getAuthorImage().setSrc(b);return r;};
a.prototype.clone=function(){return N.prototype.clone.apply(this,arguments);};
a.prototype.onBeforeRendering=function(){this._deregisterResize();};
a.prototype.onAfterRendering=function(){this._registerResize();};
a.prototype.exit=function(){this._deregisterResize();if(this._ariaDetailsText){this._ariaDetailsText.destroy();this._ariaDetailsText=null;}};
a.prototype._getDescriptionText=function(){var b=this.getAggregation('_bodyText');if(!b){b=new sap.m.Text({id:this.getId()+'-body',text:this.getDescription(),maxLines:2}).addStyleClass('sapMNLI-Text');this.setAggregation("_bodyText",b,true);}return b;};
a.prototype._activeHandling=function(){this.$().toggleClass("sapMNLIActive",this._active);};
a.prototype._updateAriaAdditionalInfo=function(){var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');var b=this.getUnread()?r.getText('NOTIFICATION_LIST_ITEM_UNREAD'):r.getText('NOTIFICATION_LIST_ITEM_READ');var d=r.getText('NOTIFICATION_LIST_ITEM_DATETIME_PRIORITY',[this.getDatetime(),this.getPriority()]);this._ariaDetailsText.setText(b+' '+d);};
a.prototype._canTruncate=function(){var t=this.getDomRef('title').offsetHeight;var b=this.getDomRef('title').parentElement.offsetHeight;var c;var d;if(this._getDescriptionText().getText()){c=this.getDomRef("body").offsetHeight;d=this.getDomRef("body").parentElement.offsetHeight;}return c>d||t>b;};
a.prototype._showHideTruncateButton=function(){var n=this.getDomRef();if(this._canTruncate()&&(!this.getHideShowMoreButton())){this.getDomRef('expandCollapseButton').classList.remove('sapMNLI-CollapseButtonHide');if(this.getTruncate()){this.getAggregation('_collapseButton').setText(this._expandText);n.querySelector('.sapMNLI-Header').classList.remove('sapMNLI-TitleWrapper--is-expanded');if(this.getDescription()){n.querySelector('.sapMNLI-TextWrapper').classList.remove('sapMNLI-TextWrapper--is-expanded');}}else{this.getAggregation('_collapseButton').setText(this._collapseText);this.$().find('.sapMNLI-TextWrapper').toggleClass('sapMNLI-TextWrapper--is-expanded',this.getDescription());n.querySelector('.sapMNLI-Header').classList.add('sapMNLI-TitleWrapper--is-expanded');}}else{this.getDomRef('expandCollapseButton').classList.add('sapMNLI-CollapseButtonHide');}if(this.getDescription()){n.querySelector('.sapMNLI-TextWrapper').classList.remove('sapMNLI-TextWrapper--initial-overwrite');}if(this.getTitle()){n.querySelector('.sapMNLI-Header').classList.remove('sapMNLI-TitleWrapper--initial-overwrite');}};
a.prototype._deregisterResize=function(){if(this._sNotificationResizeHandler){sap.ui.core.ResizeHandler.deregister(this._sNotificationResizeHandler);this._sNotificationResizeHandler=null;}};
a.prototype._registerResize=function(){var t=this;var n=this.getDomRef();if(!n){return;}t._resizeNotification();this._sNotificationResizeHandler=sap.ui.core.ResizeHandler.register(n,function(){t._resizeNotification();});};
a.prototype._resizeNotification=function(){var n=this.getDomRef();var c=sap.ui.getCore();if(n.offsetWidth>=640){n.classList.add('sapMNLI-LSize');}else{n.classList.remove('sapMNLI-LSize');}if(this._getDescriptionText().getText()){n.querySelector('.sapMNLI-TextWrapper').classList.remove('sapMNLI-TextWrapper--is-expanded');n.querySelector('.sapMNLI-TextWrapper').classList.add('sapMNLI-TextWrapper--initial-overwrite');}n.querySelector('.sapMNLI-Header').classList.remove('sapMNLI-TitleWrapper--is-expanded');n.querySelector('.sapMNLI-Header').classList.add('sapMNLI-TitleWrapper--initial-overwrite');if(c.isThemeApplied()){this._showHideTruncateButton();}else{c.attachThemeChanged(this._showHideTruncateButton,this);}};
return a;},true);
sap.ui.predefine('sap/m/NotificationListItemRenderer',[],function(){'use strict';var N={};var c='sapMNLI';var a='sapMNLB';var b='sapMNLI-TextWrapper';var d='sapMLIB';var e='sapMNLB-AuthorPicture';var f='sapMNLB-Priority';var g='sapMNLB-Header';var h='sapMNLI-Header';var i='sapMNLI-Body';var j='sapMNLI-Description';var k='sapMNLI-Details';var l='sapMNLB-Bullet';var m='sapMNLB-Footer';var n='sapMNLI-Footer';var o='sapMNLI-No-Footer';var p='sapMNLB-CloseButton';var q='sapMNLI-CollapseButton';var r='sapMNLI-TitleWrapper--initial-overwrite';var s='sapMNLI-TextWrapper--initial-overwrite';
N.render=function(R,C){if(C.getVisible()){var u=C.getId();R.write('<li');R.addClass(c);R.addClass(a);R.addClass(d);R.writeControlData(C);R.writeAttribute('tabindex','0');R.writeAccessibilityState(C,{role:"listitem",labelledby:u+'-title',describedby:(u+'-body')+' '+(u+'-info')});R.writeClasses();R.write('>');this.renderPriorityArea(R,C);this.renderHeader(R,C);this.renderBody(R,C);this.renderFooter(R,C);R.write('</li>');}else{this.renderInvisibleItem(R,C);}};
N.renderPriorityArea=function(R,C){R.write('<div');var u='';switch(C.getPriority()){case(sap.ui.core.Priority.Low):u='sapMNLB-Low';break;case(sap.ui.core.Priority.Medium):u='sapMNLB-Medium';break;case(sap.ui.core.Priority.High):u='sapMNLB-High';break;default:u='sapMNLB-None';break;}R.addClass(f);R.addClass(u);R.writeClasses();R.write('>');R.write('</div>');};
N.renderAuthorPicture=function(R,C){if(!C.getAuthorPicture()){return;}R.write('<div');R.addClass(e);R.writeClasses();R.write('>');R.renderControl(C._getAuthorImage());R.write('</div>');};
N.renderCloseButton=function(R,C){if(C.getShowCloseButton()){R.renderControl(C.getAggregation('_closeButton').addStyleClass(p));}};
N.renderCollapseButton=function(R,C){R.renderControl(C.getAggregation('_collapseButton').addStyleClass(q));};
N.renderHeader=function(R,C){R.write('<div');R.addClass(g);R.addClass(h);R.addClass(r);if(t(C)){R.addClass(o);}R.writeClasses();R.write('>');this.renderCloseButton(R,C);this.renderTitle(R,C);R.write('</div>');};
N.renderTitle=function(R,C){R.renderControl(C._getHeaderTitle());};
N.renderBody=function(R,C){if(!C._getDescriptionText().getText()&&!C.getAuthorName()&&!C.getDatetime()&&!C.getAuthorPicture()){return;}R.write('<div');R.addClass(i);if(t(C)){R.addClass(o);}R.writeClasses();R.write('>');this.renderAuthorPicture(R,C);R.write('<div class='+j+'>');this.renderDescription(R,C);this.renderDetails(R,C);R.write('</div>');this.renderAriaText(R,C);R.write('</div>');};
N.renderDescription=function(R,C){if(!C._getDescriptionText().getText()){return;}R.write('<div');R.addClass(b);R.addClass(s);R.writeClasses();R.write('>');R.renderControl(C._getDescriptionText());R.write('</div>');};
N.renderDetails=function(R,C){if(!C.getAuthorName()&&!C.getDatetime()){return;}R.write('<div class="'+k+'">');this.renderAuthorName(R,C);if(C.getAuthorName()){R.write('<span class="'+l+'">&#x00B7</span>');}this.renderDatetime(R,C);R.write('</div>');};
N.renderDatetime=function(R,C){R.renderControl(C._getDateTimeText());};
N.renderAuthorName=function(R,C){R.renderControl(C._getAuthorName());};
N.renderAriaText=function(R,C){R.renderControl(C._ariaDetailsText);};
N.renderFooter=function(R,C){var B=C.getButtons();R.write('<div');R.addClass(n);R.addClass(m);R.writeClasses();R.write('>');this.renderCollapseButton(R,C);if(B&&B.length&&C.getShowButtons()){R.renderControl(C.getAggregation('_overflowToolbar'));}R.write('</div>');};
N.renderInvisibleItem=function(R,C){R.write("<li");R.writeInvisiblePlaceholderData(C);R.write(">");R.write("</li>");};
function t(C){return C.getHideShowMoreButton()&&(!C.getShowButtons()||!C.getButtons());}
return N;},true);
sap.ui.predefine('sap/m/NumericContent',['jquery.sap.global','./library','sap/ui/core/Control','sap/m/Text','sap/ui/core/HTML','sap/ui/core/Icon','sap/ui/core/IconPool'],function(q,l,C,T,H,I){"use strict";
var N=C.extend("sap.m.NumericContent",{metadata:{library:"sap.m",properties:{"animateTextChange":{type:"boolean",group:"Misc",defaultValue:true},"formatterValue":{type:"boolean",group:"Misc",defaultValue:false},"icon":{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},"iconDescription":{type:"string",group:"Misc",defaultValue:null},"indicator":{type:"sap.m.DeviationIndicator",group:"Misc",defaultValue:sap.m.DeviationIndicator.None},"nullifyValue":{type:"boolean",group:"Misc",defaultValue:true},"scale":{type:"string",group:"Misc",defaultValue:null},"size":{type:"sap.m.Size",group:"Misc",defaultValue:sap.m.Size.Auto},"truncateValueTo":{type:"int",group:"Misc",defaultValue:4},"value":{type:"string",group:"Misc",defaultValue:null},"valueColor":{type:"sap.m.ValueColor",group:"Misc",defaultValue:sap.m.ValueColor.Neutral},"width":{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},"withMargin":{type:"boolean",group:"Appearance",defaultValue:true},"state":{type:"sap.m.LoadState",group:"Misc",defaultValue:sap.m.LoadState.Loaded}},events:{"press":{}}}});
N.prototype.init=function(){this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setTooltip("{AltText}");};
N.prototype.onBeforeRendering=function(){this.$().unbind("mouseenter",this._addTooltip);this.$().unbind("mouseleave",this._removeTooltip);};
N.prototype.onAfterRendering=function(){this.$().bind("mouseenter",this._addTooltip.bind(this));this.$().bind("mouseleave",this._removeTooltip.bind(this));if(sap.m.LoadState.Loaded==this.getState()||this.getAnimateTextChange()){q.sap.byId(this.getId()).animate({opacity:"1"},1000);}};
N.prototype._addTooltip=function(){this.$().attr("title",this.getTooltip_AsString());};
N.prototype._removeTooltip=function(){this.$().attr("title",null);};
N.prototype.exit=function(){if(this._oIcon){this._oIcon.destroy();}};
N.prototype.getAltText=function(){var v=this.getValue();var s=this.getScale();var e;var m=this._rb.getText(("SEMANTIC_COLOR_"+this.getValueColor()).toUpperCase());var a="";if(this.getNullifyValue()){e="0";}else{e="";}if(this.getIconDescription()){a=a.concat(this.getIconDescription());a=a.concat("\n");}if(v){a=a.concat(v+s);}else{a=a.concat(e);}a=a.concat("\n");if(this.getIndicator()&&this.getIndicator()!=sap.m.DeviationIndicator.None){a=a.concat(this._rb.getText(("NUMERICCONTENT_DEVIATION_"+this.getIndicator()).toUpperCase()));a=a.concat("\n");}a=a.concat(m);return a;};
N.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var s=this.getAltText();if(typeof t==="string"||t instanceof String){s=t.split("{AltText}").join(s).split("((AltText))").join(s);return s;}if(t){return t;}else{return"";}};
N.prototype.setIcon=function(u){var v=!q.sap.equal(this.getIcon(),u);if(v){if(this._oIcon){this._oIcon.destroy();this._oIcon=undefined;}if(u){this._oIcon=sap.ui.core.IconPool.createControlByURI({id:this.getId()+"-icon-image",src:u},sap.m.Image);}}this._setPointerOnIcon();return this.setProperty("icon",u);};
N.prototype._setPointerOnIcon=function(){if(this._oIcon&&this.hasListeners("press")){this._oIcon.addStyleClass("sapMPointer");}else if(this._oIcon&&this._oIcon.hasStyleClass("sapMPointer")){this._oIcon.removeStyleClass("sapMPointer");}};
N.prototype.ontap=function(e){if(sap.ui.Device.browser.internet_explorer){this.$().focus();}this.firePress();};
N.prototype.onkeyup=function(e){if(e.which===q.sap.KeyCodes.ENTER||e.which===q.sap.KeyCodes.SPACE){this.firePress();e.preventDefault();}};
N.prototype.onkeydown=function(e){if(e.which===q.sap.KeyCodes.SPACE){e.preventDefault();}};
N.prototype.attachEvent=function(e,d,f,a){sap.ui.core.Control.prototype.attachEvent.call(this,e,d,f,a);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");this._setPointerOnIcon();}return this;};
N.prototype.detachEvent=function(e,f,a){sap.ui.core.Control.prototype.detachEvent.call(this,e,f,a);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");this._setPointerOnIcon();}return this;};
N.prototype._parseFormattedValue=function(v){var t=v.replace(String.fromCharCode(8206),"").replace(String.fromCharCode(8207),"");return{scale:t.replace(/[+-., \d]*(.*)$/g,"$1").trim().replace(/\.$/,""),value:t.replace(/([+-., \d]*).*$/g,"$1").trim()};};
return N;},true);
sap.ui.predefine('sap/m/ObjectAttribute',['jquery.sap.global','./library','sap/ui/core/Control'],function(q,l,C){"use strict";
var O=C.extend("sap.m.ObjectAttribute",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},active:{type:"boolean",group:"Misc",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}},aggregations:{customContent:{type:"sap.ui.core.Control",multiple:false},_textControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{press:{parameters:{domRef:{type:"string"}}}}}});
O.MAX_LINES={SINGLE_LINE:1,MULTI_LINE:2};
O.prototype.init=function(){this.setAggregation('_textControl',new sap.m.Text());};
O.prototype._getUpdatedTextControl=function(){var a=this.getAggregation('customContent')||this.getAggregation('_textControl'),t=this.getTitle(),T=this.getAggregation('customContent')?this.getAggregation('customContent').getText():this.getText(),s=this.getTextDirection(),p=this.getParent(),P=sap.ui.getCore().getConfiguration().getRTL(),m=O.MAX_LINES.MULTI_LINE,w=true,o='';if(s===sap.ui.core.TextDirection.LTR&&P){o='\u200e';}if(s===sap.ui.core.TextDirection.RTL&&!P){o='\u200f';}T=o+T+o;if(t){T=t+": "+T;}a.setProperty('text',T,true);if(p instanceof sap.m.ObjectListItem){w=false;m=O.MAX_LINES.SINGLE_LINE;}this._setControlWrapping(a,w,m);return a;};
O.prototype._setControlWrapping=function(a,w,m){if(a instanceof sap.m.Link){a.setProperty('wrapping',w,true);}if(a instanceof sap.m.Text){a.setProperty('maxLines',m,true);}};
O.prototype.ontap=function(e){if(this._isSimulatedLink()&&(e.target.id!=this.getId())){this.firePress({domRef:this.getDomRef()});}};
sap.m.ObjectAttribute.prototype.onsapenter=function(e){if(this._isSimulatedLink()){this.firePress({domRef:this.getDomRef()});e.setMarked();}};
sap.m.ObjectAttribute.prototype.onsapspace=function(e){this.onsapenter(e);};
O.prototype._isEmpty=function(){if(this.getAggregation('customContent')&&!(this.getAggregation('customContent')instanceof sap.m.Link||this.getAggregation('customContent')instanceof sap.m.Text)){q.sap.log.warning("Only sap.m.Link or sap.m.Text are allowed in \"sap.m.ObjectAttribute.customContent\" aggregation");return true;}return!(this.getText().trim()||this.getTitle().trim());};
O.prototype.ontouchstart=function(e){if(this._isSimulatedLink()){e.originalEvent._sapui_handledByControl=true;}};
O.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("text");};
O.prototype._isSimulatedLink=function(){return this.getActive()&&!this.getAggregation('customContent');};
return O;},true);
sap.ui.predefine('sap/m/ObjectAttributeRenderer',['jquery.sap.global'],function(q){"use strict";var O={};
O.render=function(r,o){var p=o.getParent(),t=o.getTooltip_AsString();if(o._isEmpty()){return;}r.write("<div");r.writeControlData(o);r.addClass("sapMObjectAttributeDiv");if(o._isSimulatedLink()){r.addClass("sapMObjectAttributeActive");r.writeAttribute("tabindex","0");}r.writeClasses();if(t){r.writeAttributeEscaped("title",t);}if(o.getActive()&&!o.getAggregation("customContent")){r.writeAccessibilityState(o,{role:"link"});}r.write(">");if(p&&(p instanceof sap.m.ObjectHeader)){this.renderTitleInObjectHeader(r,o);this.renderTextInObjectHeader(r,o);}else{r.renderControl(o._getUpdatedTextControl());}r.write("</div>");};
O.renderTitleInObjectHeader=function(r,o){if(!o.getProperty("title")){return;}r.write("<span id=\""+o.getId()+"-title\"");r.addClass("sapMObjectAttributeTitle");r.writeClasses();r.write(">");r.writeEscaped(o.getProperty("title"));r.write("</span>");r.write("<span id=\""+o.getId()+"-colon\"");r.addClass("sapMObjectAttributeColon");r.writeClasses();r.write(">");r.write(":&nbsp;");r.write("</span>");};
O.renderTextInObjectHeader=function(r,o){var t=o.getTextDirection(),a=o.getAggregation("customContent");r.write("<span id=\""+o.getId()+"-text\"");r.addClass("sapMObjectAttributeText");if(t&&t!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",t.toLowerCase());}r.writeClasses();r.write(">");if(a){if(!o.getParent().getResponsive()){o._setControlWrapping(a,true,sap.m.ObjectAttribute.MAX_LINES.MULTI_LINE);}else{o._setControlWrapping(a,false,sap.m.ObjectAttribute.MAX_LINES.SINGLE_LINE);}r.renderControl(a);}else{r.writeEscaped(o.getProperty("text"));}r.write("</span>");};
return O;},true);
sap.ui.predefine('sap/m/ObjectHeader',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool'],function(q,l,C,I){"use strict";
var O=C.extend("sap.m.ObjectHeader",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null},intro:{type:"string",group:"Misc",defaultValue:null},introActive:{type:"boolean",group:"Misc",defaultValue:null},titleActive:{type:"boolean",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconActive:{type:"boolean",group:"Misc",defaultValue:null},iconAlt:{type:"string",group:"Accessibility",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},markFavorite:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},markFlagged:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},showMarkers:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},showTitleSelector:{type:"boolean",group:"Misc",defaultValue:false},numberState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:sap.ui.core.ValueState.None},condensed:{type:"boolean",group:"Appearance",defaultValue:false},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance"},responsive:{type:"boolean",group:"Behavior",defaultValue:false},fullScreenOptimized:{type:"boolean",group:"Appearance",defaultValue:false},titleHref:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},titleTarget:{type:"string",group:"Behavior",defaultValue:null},introHref:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},introTarget:{type:"string",group:"Behavior",defaultValue:null},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},introTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},numberTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},titleSelectorTooltip:{type:"string",group:"Misc",defaultValue:"Options"},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:sap.ui.core.TitleLevel.H1}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,singularName:"attribute"},firstStatus:{type:"sap.m.ObjectStatus",multiple:false,deprecated:true},secondStatus:{type:"sap.m.ObjectStatus",multiple:false,deprecated:true},statuses:{type:"sap.ui.core.Control",multiple:true,singularName:"status"},_objectNumber:{type:"sap.m.ObjectNumber",multiple:false,visibility:"hidden"},additionalNumbers:{type:"sap.m.ObjectNumber",multiple:true,singularName:"additionalNumber"},headerContainer:{type:"sap.m.ObjectHeaderContainer",multiple:false},markers:{type:"sap.m.ObjectMarker",multiple:true,singularName:"marker"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{titlePress:{parameters:{domRef:{type:"object"}}},introPress:{parameters:{domRef:{type:"object"}}},iconPress:{parameters:{domRef:{type:"object"}}},titleSelectorPress:{parameters:{domRef:{type:"object"}}}}}});
O.prototype.init=function(){var L=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTitleArrowIcon=I.createControlByURI({id:this.getId()+"-titleArrow",src:I.getIconURI("arrow-down"),decorative:false,visible:false,tooltip:L.getText("OH_SELECT_ARROW_TOOLTIP"),size:"1.375rem",press:function(e){}});this._fNumberWidth=undefined;this._titleText=new sap.m.Text(this.getId()+"-titleText");this._titleText.setMaxLines(3);};
O.prototype.insertAttribute=function(a,i){var r=this.insertAggregation("attributes",a,i);this._registerControlListener(a);return r;};
O.prototype.addAttribute=function(a){var r=this.addAggregation("attributes",a);this._registerControlListener(a);return r;};
O.prototype.removeAttribute=function(a){var r=this.removeAggregation("attributes",a);this._deregisterControlListener(r);return r;};
O.prototype.removeAllAttributes=function(){var a=this.removeAllAggregation("attributes");a.forEach(this._deregisterControlListener,this);return a;};
O.prototype.destroyAttributes=function(){var a=this.getAggregation("attributes");if(a!==null){a.forEach(this._deregisterControlListener,this);}return this.destroyAggregation("attributes");};
O.prototype.insertStatus=function(s,i){var r=this.insertAggregation("statuses",s,i);this._registerControlListener(s);return r;};
O.prototype.addStatus=function(s){var r=this.addAggregation("statuses",s);this._registerControlListener(s);return r;};
O.prototype.removeStatus=function(s){var r=this.removeAggregation("statuses",s);this._deregisterControlListener(r);return r;};
O.prototype.removeAllStatuses=function(){var s=this.removeAllAggregation("statuses");s.forEach(this._deregisterControlListener,this);return s;};
O.prototype.destroyStatuses=function(){var s=this.getAggregation("statuses");if(s!==null){s.forEach(this._deregisterControlListener,this);}return this.destroyAggregation("statuses");};
O.prototype._registerControlListener=function(c){if(c){c.attachEvent("_change",this.invalidate,this);}};
O.prototype._deregisterControlListener=function(c){if(c){c.detachEvent("_change",this.invalidate,this);}};
O.prototype.setCondensed=function(c){this.setProperty("condensed",c);if(this.getCondensed()){this._oTitleArrowIcon.setSize("1rem");}else{this._oTitleArrowIcon.setSize("1.375rem");}return this;};
O.prototype.setNumber=function(n){this.setProperty("number",n);this._getObjectNumber().setNumber(n);return this;};
O.prototype.setNumberUnit=function(u){this.setProperty("numberUnit",u);this._getObjectNumber().setUnit(u);return this;};
O.prototype.setNumberState=function(s){this.setProperty("numberState",s,true);this._getObjectNumber().setState(s);return this;};
O.prototype.setTitleSelectorTooltip=function(t){this.setProperty("titleSelectorTooltip",t,false);this._oTitleArrowIcon.setTooltip(t);return this;};
O.prototype.setMarkFavorite=function(m){return this._setOldMarkers(sap.m.ObjectMarkerType.Favorite,m);};
O.prototype.setMarkFlagged=function(m){return this._setOldMarkers(sap.m.ObjectMarkerType.Flagged,m);};
O.prototype.setShowMarkers=function(m){var M,a=this.getMarkers(),i;this.setProperty("showMarkers",m,false);for(i=0;i<a.length;i++){M=a[i].getType();if((M===sap.m.ObjectMarkerType.Flagged&&this.getMarkFlagged())||(M===sap.m.ObjectMarkerType.Favorite&&this.getMarkFavorite())){a[i].setVisible(m);}}return this;};
O.prototype._setOldMarkers=function(m,M){var a=this.getMarkers(),h=false,i,o={Flagged:"-flag",Favorite:"-favorite"};this.setProperty("mark"+m,M,false);if(!this.getShowMarkers()){M=false;}for(i=0;i<a.length;i++){if(a[i].getType()===m){h=true;a[i].setVisible(M);break;}}if(!h){this.insertAggregation("markers",new sap.m.ObjectMarker({id:this.getId()+o[m],type:m,visible:M}));}return this;};
O.prototype._getVisibleMarkers=function(){var a=this.getMarkers(),v=[],i;for(i=0;i<a.length;i++){if(a[i].getVisible()){v.push(a[i]);}}return v;};
O.prototype._getObjectNumber=function(){var c=this.getAggregation("_objectNumber");if(!c){c=new sap.m.ObjectNumber(this.getId()+"-number",{emphasized:false});this.setAggregation("_objectNumber",c,true);}return c;};
O.prototype.getFocusDomRef=function(){if(this.getResponsive()){return this.$("txt");}else{return this.$("title");}};
O.prototype.ontap=function(e){var s=e.target.id;if(this.getIntroActive()&&s===this.getId()+"-intro"){if(!this.getIntroHref()){this.fireIntroPress({domRef:q.sap.domById(s)});}}else if(!this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-title"||q(e.target).parent().attr('id')===this.getId()+"-title"||s===this.getId()+"-titleText-inner")){if(!this.getTitleHref()){e.preventDefault();s=this.getId()+"-title";this.fireTitlePress({domRef:q.sap.domById(s)});}}else if(this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-txt"||q(e.target).parent().attr('id')===this.getId()+"-txt")){if(!this.getTitleHref()){e.preventDefault();s=this.getId()+"-txt";this.fireTitlePress({domRef:q.sap.domById(s)});}}else if(this.getIconActive()&&(s===this.getId()+"-img"||s===this.getId()+"-icon")){this.fireIconPress({domRef:q.sap.domById(s)});}else if(s===this.getId()+"-titleArrow"){this.fireTitleSelectorPress({domRef:q.sap.domById(s)});}};
O.prototype._handleSpaceOrEnter=function(e){var s=e.target.id;e.setMarked();if(!this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-title"||q(e.target).parent().attr('id')===this.getId()+"-title"||s===this.getId()+"-titleText-inner")){if(e.type==="sapspace"){e.preventDefault();}s=this.getId()+"-title";if(!this.getTitleHref()){e.preventDefault();this.fireTitlePress({domRef:q.sap.domById(s)});}else{if(e.type==="sapspace"){this._linkClick(e,s);}}}else if(this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-txt"||q(e.target).parent().attr('id')===this.getId()+"-txt")){if(e.type==="sapspace"){e.preventDefault();}s=this.getId()+"-txt";if(!this.getTitleHref()){e.preventDefault();this.fireTitlePress({domRef:q.sap.domById(s)});}else{if(e.type==="sapspace"){this._linkClick(e,s);}}}else if(this.getIntroActive()&&s===this.getId()+"-intro"){if(e.type==="sapspace"){e.preventDefault();}if(!this.getIntroHref()){this.fireIntroPress({domRef:q.sap.domById(s)});}}else if(this.getIconActive()&&q(e.target).hasClass('sapMOHIcon')){if(e.type==="sapspace"){e.preventDefault();}var i=q.sap.domById(this.getId()+"-icon");if(!i){i=q.sap.domById(this.getId()+"-img");}this.fireIconPress({domRef:i});}else if(s===this.getId()+"-titleArrow"){if(e.type==="sapspace"){e.preventDefault();}this.fireTitleSelectorPress({domRef:q.sap.domById(s)});}};
O.prototype.onsapspace=O.prototype._handleSpaceOrEnter;O.prototype.onsapenter=O.prototype._handleSpaceOrEnter;
O.prototype._linkClick=function(e,s){e.setMarked();var c=document.createEvent('MouseEvents');c.initEvent('click',false,true);q.sap.domById(s).dispatchEvent(c);};
O.prototype._onOrientationChange=function(){var i=this.getId();if(sap.ui.Device.system.tablet&&this.getFullScreenOptimized()&&(this._hasAttributes()||this._hasStatus())){this._rerenderStates();}if(sap.ui.Device.system.phone){if(sap.ui.Device.orientation.portrait){if(this.getTitle().length>50){this._rerenderTitle(50);}if(this.getIcon()){q.sap.byId(i+"-titlediv").removeClass("sapMOHRTitleIcon");q.sap.byId(i+"-titleIcon").addClass("sapMOHRHideIcon");}}else{if(sap.ui.Device.orientation.landscape){if(this.getTitle().length>80){this._rerenderTitle(80);}if(this.getIcon()){q.sap.byId(i+"-titlediv").addClass("sapMOHRTitleIcon");q.sap.byId(i+"-titleIcon").removeClass("sapMOHRHideIcon");}}}this._adjustNumberDiv();}this._adjustIntroDiv();};
O.prototype._rerenderTitle=function(n){var r=sap.ui.getCore().createRenderManager();this.getRenderer()._rerenderTitle(r,this,n);r.destroy();};
O.prototype._rerenderStates=function(){var r=sap.ui.getCore().createRenderManager();this.getRenderer()._rerenderResponsiveStates(r,this);r.destroy();};
O.prototype.exit=function(){if(sap.ui.Device.system.desktop){sap.ui.Device.media.detachHandler(this._rerenderOHR,this,sap.ui.Device.media.RANGESETS.SAP_STANDARD);}if(sap.ui.Device.system.tablet||sap.ui.Device.system.phone){sap.ui.Device.orientation.detachHandler(this._onOrientationChange,this);}if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=undefined;}if(this._oTitleArrowIcon){this._oTitleArrowIcon.destroy();this._oTitleArrowIcon=undefined;}if(this._titleText){this._titleText.destroy();this._titleText=undefined;}if(this._introText){this._introText.destroy();this._introText=undefined;}};
O.prototype._getImageControl=function(){var i=this.getId()+"-img";var s="2.5rem";var p=q.extend({src:this.getIcon(),alt:this.getIconAlt(),useIconTooltip:false,densityAware:this.getIconDensityAware()},I.isIconURI(this.getIcon())?{size:s}:{});this._oImageControl=sap.m.ImageHelper.getImageControl(i,this._oImageControl,this,p);return this._oImageControl;};
O.prototype.onBeforeRendering=function(){if(sap.ui.Device.system.tablet||sap.ui.Device.system.phone){sap.ui.Device.orientation.detachHandler(this._onOrientationChange,this);}if(sap.ui.Device.system.desktop){sap.ui.Device.media.detachHandler(this._rerenderOHR,this,sap.ui.Device.media.RANGESETS.SAP_STANDARD);}if(this._introText){this._introText.destroy();this._introText=undefined;}};
O.prototype.onAfterRendering=function(){var o=this.getAggregation("_objectNumber");var p=sap.ui.getCore().getConfiguration().getRTL();var $=this.$("titleArrow");$.attr("role","button");if(this.getResponsive()){this._adjustIntroDiv();if(o&&o.getNumber()){if(sap.ui.Device.system.desktop&&q('html').hasClass("sapUiMedia-Std-Desktop")&&this.getFullScreenOptimized()&&this._iCountVisAttrStat>=1&&this._iCountVisAttrStat<=3){o.setTextAlign(p?sap.ui.core.TextAlign.Right:sap.ui.core.TextAlign.Left);}else{o.setTextAlign(p?sap.ui.core.TextAlign.Left:sap.ui.core.TextAlign.Right);}}this._adjustNumberDiv();if(sap.ui.Device.system.tablet||sap.ui.Device.system.phone){sap.ui.Device.orientation.attachHandler(this._onOrientationChange,this);}if(sap.ui.Device.system.desktop){sap.ui.Device.media.attachHandler(this._rerenderOHR,this,sap.ui.Device.media.RANGESETS.SAP_STANDARD);}}else{var t=p?sap.ui.core.TextAlign.Left:sap.ui.core.TextAlign.Right;if(o&&o.getNumber()){o.setTextAlign(t);}if(this.getAdditionalNumbers()){this._setTextAlignANum(t);}}};
O.prototype._rerenderOHR=function(){this.invalidate();};
O.prototype._adjustNumberDiv=function(){var i=this.getId();var o=this.getAggregation("_objectNumber");var p=sap.ui.getCore().getConfiguration().getRTL();if(o&&o.getNumber()){var $=q.sap.byId(i+"-number");var a=q.sap.byId(i+"-titlediv");if(sap.ui.Device.system.phone||(sap.ui.Device.system.desktop&&q('html').hasClass("sapUiMedia-Std-Phone"))){if($.hasClass("sapMObjectNumberBelowTitle")){o.setTextAlign(p?sap.ui.core.TextAlign.Left:sap.ui.core.TextAlign.Right);$.removeClass("sapMObjectNumberBelowTitle");a.removeClass("sapMOHRTitleDivFull");}var n=$.parent().width()*0.4;if($.outerWidth()>n){o.setTextAlign(p?sap.ui.core.TextAlign.Right:sap.ui.core.TextAlign.Left);$.addClass("sapMObjectNumberBelowTitle");a.addClass("sapMOHRTitleDivFull");}}}};
O.prototype._adjustIntroDiv=function(){var i=this.getId();var $=q.sap.byId(i+"-txt");var a=q.sap.byId(i+"-titleArrow");var b=q.sap.byId(i+"-intro");if(b.parent().hasClass("sapMOHRIntroMargin")){b.parent().removeClass("sapMOHRIntroMargin");}if(a.height()!==null&&($.height()<a.height())){b.parent().addClass("sapMOHRIntroMargin");}};
O._escapeId=function(i){return i?"#"+i.replace(/(:|\.)/g,'\\$1'):"";};
O.prototype._hasBottomContent=function(){return(this._hasAttributes()||this._hasStatus()||this.getShowMarkers());};
O.prototype._hasIcon=function(){return!!this.getIcon().trim();};
O.prototype._hasAttributes=function(){var a=this.getAttributes();if(a&&a.length>0){for(var i=0;i<a.length;i++){if(!a[i]._isEmpty()){return true;}}}return false;};
O.prototype._hasStatus=function(){var h=((this.getFirstStatus()&&!this.getFirstStatus()._isEmpty())||(this.getSecondStatus()&&!this.getSecondStatus()._isEmpty()));if(!h&&this.getStatuses()&&this.getStatuses().length>0){var s=this.getStatuses();for(var i=0;i<s.length;i++){if(s[i]instanceof sap.m.ObjectStatus&&!s[i]._isEmpty()){h=true;break;}else if(s[i]instanceof sap.m.ProgressIndicator){h=true;break;}}}return h;};
O.prototype._getDefaultBackgroundDesign=function(){if(this.getCondensed()){return sap.m.BackgroundDesign.Solid;}else{if(this.getResponsive()){return sap.m.BackgroundDesign.Translucent;}else{return sap.m.BackgroundDesign.Transparent;}}};
O.prototype._getBackground=function(){if(this.getBackgroundDesign()===undefined){return this._getDefaultBackgroundDesign();}else{return this.getBackgroundDesign();}};
O.prototype._setTextAlignANum=function(t){var n=this.getAdditionalNumbers();for(var i=0;i<n.length;i++){n[i].setTextAlign(t);}};
return O;},true);
sap.ui.predefine('sap/m/ObjectHeaderRenderer',['jquery.sap.global','sap/ui/core/IconPool'],function(q,I){"use strict";var O={};
O._isEmptyObject=function(o){if(!o){return true;}if((!o._isEmpty||!o._isEmpty())&&(!o.getVisible||o.getVisible())){return false;}return true;};
O._isEmptyArray=function(a){if(a){for(var i=0;i<a.length;i++){if(!O._isEmptyObject(a[i])){return false;}}}return true;};
O._isEmptyRow=function(l,r){return O._isEmptyObject(l)&&O._isEmptyArray(r);};
O._renderObjects=function(r,o,a){for(var i=0;i<o.length;i++){if(o[i]instanceof sap.ui.core.Control){this._renderChildControl(r,a,o[i]);}}};
O._computeChildControlsToBeRendered=function(o){o.__controlsToBeRendered={};var c=o.getAttributes();for(var i=0;i<c.length;i++){o.__controlsToBeRendered[c[i].getId()]=c[i];}c=o.getStatuses();for(var i=0;i<c.length;i++){o.__controlsToBeRendered[c[i].getId()]=c[i];}var C=o.getFirstStatus();if(C){o.__controlsToBeRendered[C.getId()]=C;}C=o.getSecondStatus();if(C){o.__controlsToBeRendered[C.getId()]=C;}C=o.getAggregation("_objectNumber");if(C){o.__controlsToBeRendered[C.getId()]=C;}};
O._cleanupNotRenderedChildControls=function(r,o){for(var i in o.__controlsToBeRendered){r.cleanupControlWithoutRendering(o.__controlsToBeRendered[i]);}delete o.__controlsToBeRendered;};
O._getMarkers=function(o){return o._getVisibleMarkers();};
O._renderIntro=function(r,o,i,s){if(o.getIntroActive()){o._introText=new sap.m.Link(o.getId()+"-intro");o._introText.setText(o.getIntro());o._introText.setHref(o.getIntroHref());o._introText.setTarget(o.getIntroTarget());o._introText.press=o.introPress;}else{o._introText=new sap.m.Text(o.getId()+"-intro");o._introText.setText(o.getIntro());o._introText.setMaxLines(3);}o._introText.setTextDirection(o.getIntroTextDirection());r.write("<div");r.addClass(i);if(o.getIntroActive()){r.addClass(s);}r.writeClasses();r.write(">");this._renderChildControl(r,o,o._introText);r.write("</div>");};
O._renderAttribute=function(r,o,a,f){r.write("<div");r.addClass("sapMOHAttr");r.writeClasses();if(f){r.addStyle("width","100%");r.writeStyles();}r.write(">");this._renderChildControl(r,o,a);r.write("</div>");};
O._getVisibleStatuses=function(o){var v=[];if(o.getFirstStatus()&&o.getFirstStatus().getVisible()){v.push([o.getFirstStatus()]);}if(o.getSecondStatus()&&o.getSecondStatus().getVisible()){v.push([o.getSecondStatus()]);}if(o.getStatuses()){var s=o.getStatuses();for(var i=0;i<s.length;i++){if(!s[i].getVisible||s[i].getVisible()){if(s[i]instanceof sap.m.ObjectStatus||s[i]instanceof sap.m.ProgressIndicator){v.push([s[i]]);}else{q.sap.log.warning("Only sap.m.ObjectStatus or sap.m.ProgressIndicator are allowed in \"sap.m.ObjectHeader.statuses\" aggregation."+" Current object is "+s[i].constructor.getMetadata().getName()+" with id \""+s[i].getId()+"\"");}}}}return v;};
O._getVisibleAttribsAndStatuses=function(o){var r=[],a=o.getAttributes(),v=[];for(var j=0;j<a.length;j++){if(a[j].getVisible()){v.push(a[j]);}}var V=this._getVisibleStatuses(o);r[0]=v;r[1]=V;return r;};
O._renderRow=function(r,o,l,R){if(O._isEmptyRow(l,R)){return;}r.write("<div");r.addClass("sapMOHAttrRow");r.writeClasses();r.write(">");if(!O._isEmptyObject(l)){this._renderAttribute(r,o,l,O._isEmptyArray(R));}else if(O._isEmptyObject(l)&&!O._isEmptyArray(R)){if(R[0]instanceof sap.m.ProgressIndicator){r.write("<div");r.addClass("sapMOHAttr");r.writeClasses();r.write(">");r.write("</div>");}}if(!O._isEmptyArray(R)){r.write("<div");if(R[0]instanceof sap.m.ProgressIndicator){r.addClass("sapMOHStatusFixedWidth");}else if(R[0]instanceof sap.m.ObjectMarker){r.addClass("sapMOHStatusFixedWidth");r.addClass("sapMObjStatusMarker");}else{r.addClass("sapMOHStatus");}r.writeClasses();r.write(">");O._renderObjects(r,R,o);r.write("</div>");}r.write("</div>");};
O._renderAttributesAndStatuses=function(r,o){var a=o.getAttributes();var v=[];for(var j=0;j<a.length;j++){if(a[j].getVisible()){v.push(a[j]);}}var A=v.length;var m=[];var M=O._getMarkers(o);if(!o.getResponsive()&&!O._isEmptyArray(M)){m.push(M);}var V=this._getVisibleStatuses(o);m=m.concat(V);var i=m.length;var n=A>i?A:i;if(!o.getResponsive()){for(var c=0;c<n;c++){this._renderRow(r,o,v[c],m[c]);}}};
O._renderNumber=function(r,o){var n=o.getAdditionalNumbers();if(!o.getNumber()&&(n&&!n.length)){return;}r.write("<div");r.writeAttribute("id",o.getId()+"-numberdiv");r.addClass("sapMOHNumberDiv");r.writeClasses();r.write(">");var a=o.getAggregation("_objectNumber");if(a&&a.getNumber()){a.setTextDirection(o.getNumberTextDirection());this._renderChildControl(r,o,a);}r.write("</div>");if(!o.getCondensed()){this._renderAdditionalNumbers(r,o);}};
O._renderAdditionalNumbers=function(r,o){var n=o.getAdditionalNumbers();if(n&&!n.length){return;}if(n.length===1){r.write("<div");r.addClass("additionalOHNumberSeparatorDiv");r.writeClasses();r.write("></div>");}for(var i=0;i<n.length;i++){r.write("<div");r.writeAttribute("id",o.getId()+"-additionalNumber"+i);r.addClass("sapMOHNumberDiv additionalOHNumberDiv");if(n.length===1){r.addClass("sapMOHOnlyANumber");}r.writeClasses();r.write(">");n[i].setTextDirection(o.getNumberTextDirection());this._renderChildControl(r,o,n[i]);r.write("</div>");}};
O._renderTitle=function(r,o){o._oTitleArrowIcon.setVisible(o.getShowTitleSelector());if(o.getShowTitleSelector()&&o._oTitleArrowIcon.getVisible()){r.write("<div");r.addClass("sapMOHTitleAndArrow");r.writeClasses();r.write(">");}if(o.getTitle()){var t=(o.getTitleLevel()===sap.ui.core.TitleLevel.Auto)?sap.ui.core.TitleLevel.H1:o.getTitleLevel();o._titleText.setText(o.getTitle());o._titleText.setTextDirection(o.getTitleTextDirection());if(o.getTitleActive()){r.write("<a");if(o.getTitleHref()){r.writeAttributeEscaped("href",o.getTitleHref());if(o.getTitleTarget()){r.writeAttributeEscaped("target",o.getTitleTarget());}}else{r.writeAttribute("href","javascript:void(0);");}r.writeAccessibilityState({role:"link",haspopup:!o.getTitleHref()});}else{r.write("<span");}r.writeAttribute("id",o.getId()+"-title");r.addClass("sapMOHTitle");if(o.getTitleActive()){r.writeAttribute("tabindex","0");r.addClass("sapMOHTitleActive");}if(o.getShowTitleSelector()){r.addClass("sapMOHTitleFollowArrow");}r.writeClasses();r.write(">");r.write("<"+t+">");this._renderChildControl(r,o,o._titleText);r.write("</"+t+">");if(o.getTitleActive()){r.write("</a>");}else{r.write("</span>");}}if(o.getShowTitleSelector()){r.write("<span");r.addClass("sapMOHTitleArrow");r.writeClasses();r.write(">");this._renderChildControl(r,o,o._oTitleArrowIcon);r.write("</span>");}if(o.getShowTitleSelector()&&o._oTitleArrowIcon.getVisible()){r.write("</div>");}};
O._renderFullTitle=function(r,o){var n=o.getAdditionalNumbers();if(!o.getNumber()&&(n&&!n.length)){r.addClass("sapMOHTitleDivFull");}};
O._renderFullOH=function(r,o){var l=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(o.getIntro()){this._renderIntro(r,o,"sapMOHIntro","sapMOHIntroActive");}r.write("<div");r.addClass("sapMOHTopRow");r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",o.getId()+"-titlediv");r.addClass("sapMOHTitleDiv");if(o._hasIcon()){r.addClass("sapMOHTitleIcon");}this._renderFullTitle(r,o);r.writeClasses();r.write(">");if(o._hasIcon()){r.write("<div");r.addClass("sapMOHIcon");if(o.getIconActive()){r.writeAttribute("tabindex","0");r.addClass("sapMPointer");r.writeAccessibilityState({role:"link",haspopup:true,label:l.getText("OH_ARIA_ICON")});}r.writeClasses();r.write(">");this._renderChildControl(r,o,o._getImageControl());r.write("</div>");}this._renderTitle(r,o);r.write("</div>");this._renderNumber(r,o);r.write("<div class=\"sapMOHDivider\"></div>");r.write("</div>");if(o._hasBottomContent()){r.write("<div");r.addClass("sapMOHBottomRow");r.writeClasses();r.write(">");this._renderAttributesAndStatuses(r,o);r.write("<div class=\"sapMOHDivider\"></div>");r.write("</div>");}};
O._renderCondensedOH=function(r,o){r.write("<div");r.writeAttribute("id",o.getId()+"-titlediv");r.addClass("sapMOHTitleDiv");this._renderFullTitle(r,o);r.writeClasses();r.write(">");this._renderTitle(r,o);r.write("</div>");this._renderNumber(r,o);var f=o.getAttributes()[0];if(f&&!f._isEmpty()){this._renderAttribute(r,o,f);}};
O.render=function(r,o){if(o.getResponsive()){this._renderResponsive(r,o);return;}this._computeChildControlsToBeRendered(o);var c=o.getCondensed();r.write("<div");r.writeControlData(o);r.addClass("sapMOH");if(o._getBackground()!==sap.m.BackgroundDesign.Transparent){r.addClass("sapContrastPlus");}if(c){r.addClass("sapMOHC");}r.addClass("sapMOHBg"+o._getBackground());r.writeClasses();var t=o.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.writeAccessibilityState({role:"region",labelledby:{value:o.getId()+"-titleText-inner",append:true}});r.write(">");if(c){this._renderCondensedOH(r,o);}else{this._renderFullOH(r,o);}r.write("<div class=\"sapMOHLastDivider\"></div>");r.write("</div>");this._cleanupNotRenderedChildControls(r,o);};
O._renderChildControl=function(r,o,c){r.renderControl(c);if(!o.getResponsive()&&o.__controlsToBeRendered){o.__controlsToBeRendered[c.getId()]=undefined;}};
O._renderResponsive=function(r,o){var s=this._hasResponsiveStates(o),t=this._hasResponsiveTabs(o),h=o.getHeaderContainer();r.write("<div");r.addClass("sapMOHROuter");r.writeClasses();r.writeAccessibilityState({role:"region",labelledby:{value:o.getId()+"-txt",append:true}});r.writeControlData(o);r.write(">");r.write("<div");r.addClass("sapMOHR");if(o._getBackground()!==sap.m.BackgroundDesign.Transparent){r.addClass("sapContrastPlus");}if(t){r.addClass("sapMOHRNoBorder");}r.addClass("sapMOHRBg"+o._getBackground());r.writeClasses();r.write(">");r.write("<div");if(sap.ui.Device.system.desktop&&q('html').hasClass("sapUiMedia-Std-Desktop")&&o.getFullScreenOptimized()&&o._iCountVisAttrStat>=1&&o._iCountVisAttrStat<=3){r.addClass("sapMOHRStatesOneOrThree");}r.writeClasses();r.write(">");this._renderResponsiveTitleBlock(r,o);if(s){this._renderResponsiveStates(r,o);}r.write("</div>");if(t){this._renderResponsiveTabs(r,o);}r.write("</div>");if(h&&h instanceof sap.m.IconTabBar){this._renderChildControl(r,o,h);}r.write("</div>");if(!o.getTitle()){if(!o.getBinding("title")){q.sap.log.warning("The title shouldn't be empty!");}}};
O._renderResponsiveTitleBlock=function(r,c){var l=sap.ui.getCore().getLibraryResourceBundle("sap.m");r.write("<div");r.writeAttribute("id",c.getId()+"-titlenumdiv");r.addClass("sapMOHRTitleNumberDiv");r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",c.getId()+"-titlediv");r.addClass("sapMOHRTitleDiv");if(c._hasIcon()){if(sap.ui.Device.system.phone||q('html').hasClass("sapUiMedia-Std-Phone")){if(sap.ui.Device.orientation.landscape||(q('html').hasClass("sapUiMedia-Std-Phone")&&!sap.ui.Device.system.phone)){r.addClass("sapMOHRTitleIcon");}}else{r.addClass("sapMOHRTitleIcon");}}if(!c.getNumber()){r.addClass("sapMOHRTitleDivFull");}r.writeClasses();r.write(">");this._renderResponsiveTitle(r,c);if(c._hasIcon()){r.write("<div");r.writeAttribute("id",c.getId()+"-titleIcon");r.addClass("sapMOHRIcon");if((sap.ui.Device.system.phone&&sap.ui.Device.orientation.portrait)){r.addClass("sapMOHRHideIcon");}if(c.getIconActive()){r.addClass("sapMPointer");r.writeAttribute("tabindex","0");r.writeAccessibilityState({role:"link",haspopup:true,label:l.getText("OH_ARIA_ICON")});}r.writeClasses();r.write(">");this._renderChildControl(r,c,c._getImageControl());r.write("</div>");}r.write("</div>");this._renderResponsiveNumber(r,c);r.write("</div>");};
O._renderResponsiveStates=function(r,c){r.write("<div");r.writeAttribute("id",c.getId()+"-states");r.addClass("sapMOHRStates");r.writeClasses();r.write(">");this._renderResponsiveRow(r,c);r.write("</div>");};
O._renderResponsiveRow=function(r,o){var v=[];v=this._getVisibleAttribsAndStatuses(o);var V=v[0].concat(v[1]),c=v[0].length,C=V.length,R=1,s='';if(C===0){return;}if(sap.ui.Device.system.desktop){if(!o.getFullScreenOptimized()){if(C>=1&&C<=4){R=2;s='sapMOHRTwoCols';}if(C>=5){R=3;s='sapMOHRThreeCols';}}else{if(C>=1&&C<=3){R=1;s='sapMOHROneCols';}if(C>=4){R=4;s='sapMOHRFourCols';}}}if(sap.ui.Device.system.tablet||(sap.ui.Device.system.desktop&&q('html').hasClass("sapUiMedia-Std-Tablet"))){if(!o.getFullScreenOptimized()||(sap.ui.Device.orientation.portrait&&o.getFullScreenOptimized())){R=2;s='sapMOHRTwoCols';}else{if(o.getFullScreenOptimized()&&(sap.ui.Device.orientation.landscape||(sap.ui.Device.system.desktop&&q('html').hasClass("sapUiMedia-Std-Tablet")))){if(C>=1&&C<=2){R=2;s='sapMOHRTwoCols';}if(C>=3){R=3;s='sapMOHRThreeCols';}}}}if(sap.ui.Device.system.phone||(sap.ui.Device.system.desktop&&q('html').hasClass("sapUiMedia-Std-Phone"))){R=1;s='sapMOHROneCols';}this._renderResponsiveStatesColumn(r,o,R,V,c,s);};
O._renderResponsiveStatesColumn=function(r,o,R,v,c,C){var a=Math.floor(v.length/R);var b=v.length%R;var d=0;var e=1;for(var i=0;i<v.length;i++){if(d==0){r.write("<div");r.addClass("sapMOHRStatesCont"+e);r.addClass(C);r.writeClasses();r.write(">");}if(i<c){this._renderResponsiveAttribute(r,o,v[i]);}else{this._renderResponsiveStatus(r,o,v[i]);}d++;if((d==a&&e>b)||(d==(a+1)&&e<=b)||i==v.length-1){r.write("</div>");d=0;e++;}}};
O._renderResponsiveAttribute=function(r,o,a){r.write("<div");r.addClass("sapMOHRAttr");r.writeClasses();r.write(">");this._renderChildControl(r,o,a);r.write("</div>");};
O._renderResponsiveStatus=function(r,o,s){r.write("<div");r.addClass("sapMOHRStatus");r.writeClasses();r.write(">");this._renderChildControl(r,o,s[0]);r.write("</div>");};
O._renderResponsiveMarkers=function(r,c){var m=[],t=c.getTitleTextDirection(),p=sap.ui.getCore().getConfiguration().getRTL();m=c._getVisibleMarkers();r.write("<span");r.addClass("sapMObjStatusMarker");if((t===sap.ui.core.TextDirection.LTR&&p)||(t===sap.ui.core.TextDirection.RTL&&!p)){r.addClass("sapMObjStatusMarkerOpposite");}r.writeClasses();r.writeAttribute("id",c.getId()+"-markers");r.write(">");for(var i=0;i<m.length;i++){this._renderChildControl(r,c,m[i]);}r.write("</span>");};
O._renderResponsiveNumber=function(r,c){var o=c.getAggregation("_objectNumber");if(o&&o.getNumber()){o.setTextDirection(c.getNumberTextDirection());this._renderChildControl(r,c,o);}};
O._hasResponsiveStates=function(c){var a=c.getAttributes(),v=[];if(!(c._hasAttributes()||c._hasStatus())){c._iCountVisAttrStat=0;return false;}for(var j=0;j<a.length;j++){if(a[j].getVisible()){v.push(a[j]);}}var V=this._getVisibleStatuses(c);c._iCountVisAttrStat=v.length+V.length;return!!(v.length+V.length);};
O._hasResponsiveTabs=function(c){var h=c.getHeaderContainer(),i;if(h){if(h instanceof sap.m.IconTabBar){i=h._getIconTabHeader();if(i.getVisible()){c._iCountVisTabs=i.getItems().length;return!!i.getItems().length;}}else if(h.getMetadata().getName()==="sap.suite.ui.commons.HeaderContainer"){return!!h.getItems().length;}}return false;};
O._renderResponsiveTabs=function(r,c){var h=c.getHeaderContainer(),i;r.write("<div class=\"sapMOHRTabs"+(h instanceof sap.m.IconTabBar?" sapMOHRTabsITB":"")+"\">");if(h){if(h instanceof sap.m.IconTabBar){i=h._getIconTabHeader();this._renderChildControl(r,c,i);h._bHideHeader=true;}else if(h.getMetadata().getName()==="sap.suite.ui.commons.HeaderContainer"){this._renderChildControl(r,c,h);}else{q.sap.log.warning("The control "+h+" is not supported for aggregation \"headerContainer\"");}}r.write("</div>");};
O._renderResponsiveTitle=function(r,o){var n;o._oTitleArrowIcon.setVisible(o.getShowTitleSelector());r.write("<div");r.writeAttribute("id",o.getId()+"-title");r.addClass("sapMOHRTitle");if(o.getTitle().length&&o.getTitleActive()){r.addClass("sapMOHRTitleActive");}if(o.getShowTitleSelector()){r.addClass("sapMOHRTitleFollowArrow");}r.writeClasses();r.write(">");if((sap.ui.Device.system.phone&&sap.ui.Device.orientation.portrait)){n=50;}else{n=80;}r.write("<span");r.writeAttribute("id",o.getId()+"-title-arrow");r.write(">");this._renderResponsiveTitleAndArrow(r,o,n);r.write("</span>");if(o.getIntro()){this._renderIntro(r,o,"sapMOHRIntro","sapMOHRIntroActive");}r.write("</div>");};
O._rerenderTitle=function(r,o,n){var i=o.getId();this._renderResponsiveTitleAndArrow(r,o,n);r.flush(q.sap.byId(i+"-title-arrow"));};
O._renderResponsiveTitleAndArrow=function(r,o,n){var s,e='',t=o.getTitleTextDirection();var m=!!o._getVisibleMarkers().length;var T=(o.getTitleLevel()===sap.ui.core.TitleLevel.Auto)?sap.ui.core.TitleLevel.H1:o.getTitleLevel();r.write("<"+T+">");r.write("<span");r.addClass("sapMOHRTitleTextContainer");r.writeClasses();if(t!=sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",t.toLowerCase());}r.write(">");if(o.getTitle().length&&o.getTitleActive()){r.write("<a");if(o.getTitleHref()){r.writeAttributeEscaped("href",o.getTitleHref());if(o.getTitleTarget()){r.writeAttributeEscaped("target",o.getTitleTarget());}}else{r.writeAttribute("href","javascript:void(0);");}r.writeAttribute("tabindex","0");r.writeAccessibilityState({role:"link",haspopup:!o.getTitleHref()});}else{r.write("<span");}r.writeAttribute("id",o.getId()+"-txt");r.addClass("sapMOHRTitleText");r.writeClasses();r.write(">");r.write("<span");r.addClass("sapMOHRTitleTextWrappable");r.writeClasses();r.write(">");if(o.getTitle().length>n){s=o.getTitle().substr(0,n).trim();e='...';}else{s=o.getTitle();}if(m){var a=s.substr(s.lastIndexOf(" ")+1);var b=s.substr(0,s.lastIndexOf(" ")+1);if(a.length===1){a=s;b='';}r.writeEscaped(b);r.write("</span>");r.writeEscaped(a);r.write(e);if(o.getTitleActive()){r.write("</a>");}else{r.write("</span>");}this._renderResponsiveMarkers(r,o);r.write("</span>");}else{if(!e){r.writeEscaped(s);}else{r.writeEscaped(s+e);}if(o.getTitleActive()){r.write("</span></a></span>");}else{r.write("</span></span></span>");}}if(o.getShowTitleSelector()){r.write("<span");r.addClass("sapMOHRTitleArrow");r.writeClasses();r.write(">");this._renderChildControl(r,o,o._oTitleArrowIcon);r.write("</span>");}r.write("</"+T+">");};
O._rerenderResponsiveStates=function(r,o){var i=o.getId(),v=this._getVisibleAttribsAndStatuses(o),V=v[0].concat(v[1]),c=v[0].length,C=V.length,R=1,s='';if(C===0){return;}if(sap.ui.Device.orientation.portrait){R=2;s='sapMOHRTwoCols';}else{if(C>=1&&C<=2){R=2;s='sapMOHRTwoCols';}if(C>=3){R=3;s='sapMOHRThreeCols';}}this._renderResponsiveStatesColumn(r,o,R,V,c,s);r.flush(q.sap.byId(i+"-states")[0]);};
return O;},true);
sap.ui.predefine('sap/m/ObjectIdentifier',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool'],function(q,l,C,I){"use strict";
var O=C.extend("sap.m.ObjectIdentifier",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},badgeNotes:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},badgePeople:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},badgeAttachments:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},visible:{type:"boolean",group:"Appearance",defaultValue:true},titleActive:{type:"boolean",group:"Misc",defaultValue:false},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}},aggregations:{_titleControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_textControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{titlePress:{parameters:{domRef:{type:"object"}}}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}}});
O.prototype.exit=function(){if(this._attachmentsIcon){this._attachmentsIcon.destroy();this._attachmentsIcon=null;}if(this._peopleIcon){this._peopleIcon.destroy();this._peopleIcon=null;}if(this._notesIcon){this._notesIcon.destroy();this._notesIcon=null;}if(this._oAriaInfoTextControl){this._oAriaInfoTextControl.destroy();this._oAriaInfoTextControl=null;}};
O.prototype._getAttachmentsIcon=function(){if(!this._attachmentsIcon){this._attachmentsIcon=this._getIcon(I.getIconURI("attachment"),this.getId()+"-attachments");}return this._attachmentsIcon;};
O.prototype._getPeopleIcon=function(){if(!this._peopleIcon){this._peopleIcon=this._getIcon(I.getIconURI("group"),this.getId()+"-people");}return this._peopleIcon;};
O.prototype._getNotesIcon=function(){if(!this._notesIcon){this._notesIcon=this._getIcon(I.getIconURI("notes"),this.getId()+"-notes");}return this._notesIcon;};
O.prototype._getIcon=function(u,i){var s=sap.ui.Device.system.phone?"1em":"1em";var o;o=this._icon||I.createControlByURI({src:u,id:i+"-icon",size:s,useIconTooltip:false},sap.m.Image);o.setSrc(u);return o;};
O.prototype._getTitleControl=function(){var t=this.getAggregation("_titleControl"),i;if(!t){this._createAriaInfoTextControl();if(this.getProperty("titleActive")){t=new sap.m.Link({text:this.getProperty("title"),ariaLabelledBy:this._oAriaInfoTextControl});}else{t=new sap.m.Text({text:this.getProperty("title")});}this.setAggregation("_titleControl",t);}else{i=this.getProperty("titleActive");if(i&&t instanceof sap.m.Text){this.destroyAggregation("_titleControl",true);t=new sap.m.Link({text:this.getProperty("title"),ariaLabelledBy:this._oAriaInfoTextControl});this.setAggregation("_titleControl",t);}else if(!i&&t instanceof sap.m.Link){this.destroyAggregation("_titleControl",true);t=new sap.m.Text({text:this.getProperty("title")});this.setAggregation("_titleControl",t);}}t.setVisible(!!this.getTitle());return t;};
O.prototype._getTextControl=function(){var t=this.getAggregation("_textControl");if(!t){t=new sap.m.Text({text:this.getProperty("text")});this.setAggregation("_textControl",t,true);}t.setTextDirection(this.getTextDirection());t.setVisible(!!this.getText());return t;};
O.prototype._rerenderTitle=function(){var t=this._getTitleControl();t.setProperty("text",this.getProperty("title"),true);var r=sap.ui.getCore().createRenderManager();r.renderControl(t);r.flush(this.$("title")[0]);r.destroy();};
O.prototype.setTitle=function(t){var T=this._getTitleControl();T.setProperty("text",t,false);T.setVisible(!!t);this.setProperty("title",t,true);this.$("text").toggleClass("sapMObjectIdentifierTextBellow",!!this.getProperty("text")&&!!this.getProperty("title"));return this;};
O.prototype.setText=function(t){this.setProperty("text",t,true);var T=this._getTextControl();T.setProperty("text",t,false);this.$("text").toggleClass("sapMObjectIdentifierTextBellow",!!this.getProperty("text")&&!!this.getProperty("title"));return this;};
O.prototype.setTitleActive=function(v){var p=this.getProperty("titleActive");if(p!=v){this.setProperty("titleActive",v,true);if(this.$("title").children().length>0){this._rerenderTitle();}}return this;};
O.prototype._handlePress=function(e){var c=e.target;if(this.getTitleActive()&&this.$("title")[0].firstChild==c){this.fireTitlePress({domRef:c});e.setMarked();}};
O.prototype.onsapenter=function(e){O.prototype._handlePress.apply(this,arguments);};
O.prototype.onsapspace=function(e){O.prototype._handlePress.apply(this,arguments);};
O.prototype.ontap=function(e){O.prototype._handlePress.apply(this,arguments);};
O.prototype._createAriaInfoTextControl=function(){var a;var A=this.getAssociation("ariaLabelledBy");if(A&&A instanceof Array&&A.length>0){var r=[];var R=[];A.forEach(function(i){var c=sap.ui.getCore().byId(i);if(c){r.push(i);var s=c.getText();if(s){R.push(s);}}});a=new sap.m.Text(this.getId()+"-sapSRH",{text:"Object Identifier "+R.join(" ")}).addStyleClass("sapUiInvisibleText");}else{a=new sap.m.Text(this.getId()+"-sapSRH",{text:"Object Identifier"}).addStyleClass("sapUiInvisibleText");}this._oAriaInfoTextControl=a;return a;};
return O;},true);
sap.ui.predefine('sap/m/ObjectIdentifierRenderer',['jquery.sap.global'],function(q){"use strict";var O={};
O.render=function(r,o){var t;if(!o.getVisible()){return;}r.write("<div");r.writeControlData(o);r.writeAccessibilityState(o);r.addClass("sapMObjectIdentifier");r.writeClasses();t=o.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.write(">");r.write("<div");r.addClass("sapMObjectIdentifierTopRow");r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMObjectIdentifierIcons");r.writeClasses();r.write(">");if(o.getBadgeAttachments()){r.write("<span");r.addClass("sapMObjectIdentifierIconSpan");r.writeClasses();r.write(">");r.renderControl(o._getAttachmentsIcon());r.write("</span>");}if(o.getBadgeNotes()){r.write("<span");r.addClass("sapMObjectIdentifierIconSpan");r.writeClasses();r.write(">");r.renderControl(o._getNotesIcon());r.write("</span>");}if(o.getBadgePeople()){r.write("<span");r.addClass("sapMObjectIdentifierIconSpan");r.writeClasses();r.write(">");r.renderControl(o._getPeopleIcon());r.write("</span>");}r.write("</div>");r.write("<div id='"+o.getId()+"-title'");r.addClass("sapMObjectIdentifierTitle");r.writeClasses();r.write(">");r.renderControl(o._getTitleControl());if(o.getProperty("titleActive")){r.renderControl(o._oAriaInfoTextControl);}r.write("</div>");r.write("</div>");r.write("<div id='"+o.getId()+"-text'");r.addClass("sapMObjectIdentifierText");if(!!o.getProperty("text")&&!!o.getProperty("title")){r.addClass("sapMObjectIdentifierTextBellow");}r.writeClasses();r.write(">");r.renderControl(o._getTextControl());r.write("</div>");r.write("</div>");};
return O;},true);
sap.ui.predefine('sap/m/ObjectListItem.designtime',[],function(){"use strict";return{aggregations:{firstStatus:{domRef:":sap-domref .sapMObjLStatus1DivEmpty"},secondStatus:{domRef:":sap-domref .sapMObjLStatus2DivEmpty"},attributes:{domRef:":sap-domref .sapMObjLAttrDivEmpty"}}};},false);
sap.ui.predefine('sap/m/ObjectListItem',['jquery.sap.global','./ListItemBase','./library','sap/ui/core/IconPool'],function(q,L,l,I){"use strict";
var O=L.extend("sap.m.ObjectListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null},intro:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},markFavorite:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},markFlagged:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},showMarkers:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},numberState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:sap.ui.core.ValueState.None},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},introTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},numberTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},markLocked:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,singularName:"attribute"},firstStatus:{type:"sap.m.ObjectStatus",multiple:false},secondStatus:{type:"sap.m.ObjectStatus",multiple:false},markers:{type:"sap.m.ObjectMarker",multiple:true,singularName:"marker"}},designTime:true}});
O.prototype.exit=function(e){if(this._oImageControl){this._oImageControl.destroy();}if(this._oTitleText){this._oTitleText.destroy();this._oTitleText=undefined;}L.prototype.exit.apply(this);};
O.prototype._hasAttributes=function(){var a=this.getAttributes();if(a.length>0){for(var i=0;i<a.length;i++){if(!a[i]._isEmpty()){return true;}}}return false;};
O.prototype._hasStatus=function(){return((this.getFirstStatus()&&!this.getFirstStatus()._isEmpty())||(this.getSecondStatus()&&!this.getSecondStatus()._isEmpty()));};
O.prototype._hasBottomContent=function(){return(this._hasAttributes()||this._hasStatus()||this.getShowMarkers()||this.getMarkLocked()||this._getVisibleMarkers().length>0);};
O.prototype._getVisibleAttributes=function(){var a=this.getAttributes();var v=[];for(var i=0;i<a.length;i++){if(a[i].getVisible()){v.push(a[i]);}}return v;};
O.prototype._getVisibleMarkers=function(){var a=this.getMarkers();var v=[];for(var i=0;i<a.length;i++){if(a[i].getVisible()){v.push(a[i]);}}return v;};
O.prototype._getImageControl=function(){var i=this.getId()+'-img';var s="2.5rem";var p;if(I.isIconURI(this.getIcon())){p={src:this.getIcon(),height:s,width:s,size:s,useIconTooltip:false,densityAware:this.getIconDensityAware()};}else{p={src:this.getIcon(),useIconTooltip:false,densityAware:this.getIconDensityAware()};}var c=['sapMObjLIcon'];this._oImageControl=sap.m.ImageHelper.getImageControl(i,this._oImageControl,this,p,c);return this._oImageControl;};
O.prototype._activeHandlingInheritor=function(){var a=this.getActiveIcon();if(!!this._oImageControl&&!!a){this._oImageControl.setSrc(a);}};
O.prototype._inactiveHandlingInheritor=function(){var s=this.getIcon();if(!!this._oImageControl){this._oImageControl.setSrc(s);}};
O.prototype.setMarkFavorite=function(m){return this._setOldMarkers(sap.m.ObjectMarkerType.Favorite,m);};
O.prototype.setMarkFlagged=function(m){return this._setOldMarkers(sap.m.ObjectMarkerType.Flagged,m);};
O.prototype.setMarkLocked=function(m){return this._setOldMarkers(sap.m.ObjectMarkerType.Locked,m);};
O.prototype.setShowMarkers=function(m){var M;var a=this.getMarkers();this.setProperty("showMarkers",m,false);for(var i=0;i<a.length;i++){M=a[i].getType();if((M===sap.m.ObjectMarkerType.Flagged&&this.getMarkFlagged())||(M===sap.m.ObjectMarkerType.Favorite&&this.getMarkFavorite())||(M===sap.m.ObjectMarkerType.Locked&&this.getMarkLocked())){a[i].setVisible(m);}}return this;};
O.prototype._setOldMarkers=function(m,M){var a=this.getMarkers();var h=false;var o={Flagged:"-flag",Favorite:"-favorite",Locked:"-lock"};this.setProperty("mark"+m,M,false);if(!this.getShowMarkers()){M=false;}for(var i=0;i<a.length;i++){if(a[i].getType()===m){h=true;a[i].setVisible(M);break;}}if(!h){this.insertAggregation("markers",new sap.m.ObjectMarker({id:this.getId()+o[m],type:m,visible:M}));}return this;};
O.prototype._getTitleText=function(){if(!this._oTitleText){this._oTitleText=new sap.m.Text(this.getId()+"-titleText",{maxLines:2});this._oTitleText.setParent(this,null,true);}return this._oTitleText;};
return O;},true);
sap.ui.predefine('sap/m/ObjectListItemRenderer',['jquery.sap.global','./ListItemBaseRenderer','sap/ui/core/Renderer'],function(q,L,R){"use strict";var O=R.extend(L);
O.renderAttributeStatus=function(r,l,a,s){if(!a&&!s||(a&&a._isEmpty()&&s&&s._isEmpty())){return;}r.write("<div");r.addClass("sapMObjLAttrRow");r.writeClasses();r.write(">");if(a&&!a._isEmpty()){r.write("<div");r.addClass("sapMObjLAttrDiv");if(s&&(!s._isEmpty())){if(s instanceof Array){r.addClass("sapMObjAttrWithMarker");}}r.writeClasses();if(!s||s._isEmpty()){r.addStyle("width","100%");r.writeStyles();}r.write(">");r.renderControl(a);r.write("</div>");}if(s&&!s._isEmpty()){r.write("<div");r.addClass("sapMObjLStatusDiv");if(s instanceof Array&&s.length>0){r.addClass("sapMObjStatusMarker");}r.writeClasses();if(!a||a._isEmpty()){r.addStyle("width","100%");r.writeStyles();}r.write(">");if(s instanceof Array){while(s.length>0){r.renderControl(s.shift());}}else{r.renderControl(s);}r.write("</div>");}r.write("</div>");};
O.renderLIAttributes=function(r,l){r.addClass("sapMObjLItem");r.addClass("sapMObjLListModeDiv");};
O.renderLIContent=function(r,l){var t=l.getTitleTextDirection(),i=l.getIntroTextDirection(),n=l.getNumberTextDirection();if(l.getIntro()){r.write("<div");r.addClass("sapMObjLIntro");r.writeClasses();r.writeAttribute("id",l.getId()+"-intro");r.write(">");r.write("<span");if(i!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",i.toLowerCase());}r.write(">");r.writeEscaped(l.getIntro());r.write("</span>");r.write("</div>");}r.write("<div");r.addClass("sapMObjLTopRow");r.writeClasses();r.write(">");if(!!l.getIcon()){r.write("<div");r.addClass("sapMObjLIconDiv");r.writeClasses();r.write(">");r.renderControl(l._getImageControl());r.write("</div>");}r.write("<div");r.addClass("sapMObjLNumberDiv");r.writeClasses();r.write(">");if(l.getNumber()){r.write("<div");r.writeAttribute("id",l.getId()+"-number");r.addClass("sapMObjLNumber");r.addClass("sapMObjLNumberState"+l.getNumberState());r.writeClasses();if(n!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",n.toLowerCase());}r.write(">");r.writeEscaped(l.getNumber());r.write("</div>");if(l.getNumberUnit()){r.write("<div");r.writeAttribute("id",l.getId()+"-numberUnit");r.addClass("sapMObjLNumberUnit");r.addClass("sapMObjLNumberState"+l.getNumberState());r.writeClasses();r.write(">");r.writeEscaped(l.getNumberUnit());r.write("</div>");}}r.write("</div>");r.write("<div");r.addStyle("display","-webkit-box");r.addStyle("overflow","hidden");r.writeStyles();r.write(">");var T=l._getTitleText();if(T){T.setTextDirection(t);T.setText(l.getTitle());T.addStyleClass("sapMObjLTitle");r.renderControl(T);}r.write("</div>");r.write("</div>");if(!(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<10)){r.write("<div style=\"clear: both;\"></div>");}if(l._hasBottomContent()){r.write("<div");r.addClass("sapMObjLBottomRow");r.writeClasses();r.write(">");var a=l._getVisibleAttributes();var s=[];var m=l._getVisibleMarkers();m._isEmpty=function(){return!(m.length);};if(!m._isEmpty()){s.push(m);}s.push(l.getFirstStatus());s.push(l.getSecondStatus());while(a.length>0){this.renderAttributeStatus(r,l,a.shift(),s.shift());}while(s.length>0){this.renderAttributeStatus(r,l,null,s.shift());}r.write("</div>");}};
O.getAriaLabelledBy=function(l){var a=[];if(l.getIntro()){a.push(l.getId()+"-intro");}if(l.getTitle()){a.push(l.getId()+"-titleText");}if(l.getNumber()){a.push(l.getId()+"-number");}if(l.getNumberUnit()){a.push(l.getId()+"-numberUnit");}if(l.getAttributes()){l.getAttributes().forEach(function(b){a.push(b.getId());});}if(l.getFirstStatus()){a.push(l.getFirstStatus().getId());}if(l.getSecondStatus()){a.push(l.getSecondStatus().getId());}if(l.getMarkers()){l.getMarkers().forEach(function(m){a.push(m.getId()+"-text");});}return a.join(" ");};
return O;},true);
sap.ui.predefine('sap/m/ObjectMarker',['jquery.sap.global',"sap/ui/core/Control",'sap/ui/core/Renderer'],function(q,C,R){"use strict";
var O=C.extend("sap.m.ObjectMarker",{metadata:{library:"sap.m",properties:{type:{type:"sap.m.ObjectMarkerType",group:"Misc"},visibility:{type:"sap.m.ObjectMarkerVisibility",group:"Misc"},additionalInfo:{type:"string",group:"Misc",defaultValue:""}},aggregations:{_innerControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{press:{type:{type:"sap.m.ObjectMarkerType"}}}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");O.M_PREDEFINED_TYPES={Flagged:{icon:{src:"sap-icon://flag",visibility:{small:true,large:true}},text:{value:r.getText("OM_FLAG"),visibility:{small:false,large:false}}},Favorite:{icon:{src:"sap-icon://favorite",visibility:{small:true,large:true}},text:{value:r.getText("OM_FAVORITE"),visibility:{small:false,large:false}}},Draft:{icon:{src:"sap-icon://request",visibility:{small:false,large:false}},text:{value:r.getText("OM_DRAFT"),visibility:{small:true,large:true}}},Locked:{icon:{src:"sap-icon://private",visibility:{small:true,large:true}},text:{value:r.getText("OM_LOCKED"),visibility:{small:false,large:true}}},Unsaved:{icon:{src:"sap-icon://user-edit",visibility:{small:true,large:true}},text:{value:r.getText("OM_UNSAVED"),visibility:{small:false,large:true}}},LockedBy:{icon:{src:"sap-icon://private",visibility:{small:true,large:true}},text:{value:r.getText("OM_LOCKED_BY"),visibility:{small:false,large:true}}},UnsavedBy:{icon:{src:"sap-icon://user-edit",visibility:{small:true,large:true}},text:{value:r.getText("OM_UNSAVED_BY"),visibility:{small:false,large:true}}}};
O.prototype.init=function(){sap.ui.Device.media.initRangeSet("DeviceSet",[600],"px",["small","large"]);};
O.prototype.onAfterRendering=function(){sap.ui.Device.media.attachHandler(this._handleMediaChange,this,"DeviceSet");};
O.prototype.onBeforeRendering=function(){this._cleanup();};
O.prototype.exit=function(){this._cleanup();};
O.prototype.attachPress=function(){var i=this._getInnerControl();Array.prototype.unshift.apply(arguments,["press"]);C.prototype.attachEvent.apply(this,arguments);if(this.hasListeners("press")&&i&&i instanceof b){i.destroy();this.setAggregation("_innerControl",this._createCustomLink(),true);this._adjustControl();}return this;};
O.prototype.detachPress=function(){var i=this._getInnerControl();Array.prototype.unshift.apply(arguments,["press"]);C.prototype.detachEvent.apply(this,arguments);if(!this.hasListeners("press")&&i&&i instanceof d){i.destroy();this.setAggregation("_innerControl",this._createCustomText(),true);this._adjustControl();}return this;};
O.prototype.setVisibility=function(v){this.setProperty("visibility",v);this._adjustControl();return this;};
O.prototype.setType=function(t){this.setProperty("type",t);this._adjustControl();return this;};
O.prototype.setAdditionalInfo=function(t){this.setProperty("additionalInfo",t);this._adjustControl();return this;};
O.prototype._cleanup=function(){sap.ui.Device.media.detachHandler(this._handleMediaChange,this,"DeviceSet");};
O.prototype._handleMediaChange=function(){this._adjustControl();};
O.prototype._adjustControl=function(){var t=O.M_PREDEFINED_TYPES[this.getType()],i=this._getInnerControl(),A=this.getAdditionalInfo(),T=this.getType(),s;if(!i){return false;}if(t){s=this._getMarkerText(t,T,A);}if(this._isIconVisible()){i.setIcon(t.icon.src);this.addStyleClass("sapMObjectMarkerIcon");}else{i.setIcon(null);this.removeStyleClass("sapMObjectMarkerIcon");}if(this._isTextVisible()){i.setTooltip(null);i.setText(s);this.addStyleClass("sapMObjectMarkerText");}else{if(i.getIcon()){i.setTooltip(s);}i.setText(null);this.removeStyleClass("sapMObjectMarkerText");}return true;};
O.prototype._getMarkerText=function(t,T,A){switch(T){case"LockedBy":return(A==="")?r.getText('OM_LOCKED_BY_ANOTHER_USER'):r.getText('OM_LOCKED_BY',[A]);case"UnsavedBy":return(A==="")?r.getText('OM_UNSAVED_BY_ANOTHER_USER'):r.getText('OM_UNSAVED_BY',[A]);default:return(A==="")?t.text.value:t.text.value+" "+A;}};
O.prototype._isIconVisible=function(){var t=O.M_PREDEFINED_TYPES[this.getType()],v=this.getVisibility(),D=this._getDeviceType(),T=t&&t.icon.visibility[D]||false;return v===sap.m.ObjectMarkerVisibility.IconOnly||v===sap.m.ObjectMarkerVisibility.IconAndText||(v!==sap.m.ObjectMarkerVisibility.TextOnly&&T);};
O.prototype._isTextVisible=function(){var t=O.M_PREDEFINED_TYPES[this.getType()],v=this.getVisibility(),D=this._getDeviceType(),T=t&&t.text.visibility[D]||false;return v===sap.m.ObjectMarkerVisibility.TextOnly||v===sap.m.ObjectMarkerVisibility.IconAndText||(v!==sap.m.ObjectMarkerVisibility.IconOnly&&T);};
O.prototype._getDeviceType=function(){return sap.ui.Device.media.getCurrentRange("DeviceSet").name.toLowerCase();};
O.prototype._getInnerControl=function(){var i=this.getAggregation("_innerControl");if(!i&&this.getType()){i=this._createInnerControl();this.setAggregation("_innerControl",i,true);this._adjustControl();}return i;};
O.prototype._createInnerControl=function(){if(this.hasListeners("press")){return this._createCustomLink();}else{return this._createCustomText();}};
O.prototype._createCustomLink=function(){var o=new d(this.getId()+"-link",{wrapping:true});o.attachPress(function(e){this.firePress({type:this.getType()});},this);return o;};
O.prototype._createCustomText=function(){return new b(this.getId()+"-text",{textAlign:sap.ui.core.TextAlign.Initial});};
var a=R.extend(sap.m.TextRenderer);
a.renderText=function(o,e){o.renderControl(e._getIconAggregation());sap.m.TextRenderer.renderText(o,e);};
var b=sap.m.Text.extend("CustomText",{
metadata:{properties:{icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null}},aggregations:{_iconControl:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}}},
renderer:a
});
b.prototype.setIcon=function(i){var I=this._getIconAggregation();this.setProperty("icon",i,false);I.setSrc(i);};
b.prototype._getIconAggregation=function(){var i=this.getAggregation("_iconControl");if(!i){i=new sap.ui.core.Icon();this.setAggregation("_iconControl",i);}return i;};
b.prototype.setText=function(t){this.setProperty("text",t,true);};
var c=R.extend(sap.m.LinkRenderer);
c.renderText=function(o,e){o.renderControl(e._getIconAggregation());sap.m.LinkRenderer.renderText(o,e);};
var d=sap.m.Link.extend("CustomLink",{
metadata:{properties:{icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null}},aggregations:{_iconControl:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}}},
renderer:c
});
d.prototype.setIcon=function(i){var I=this._getIconAggregation();this.setProperty("icon",i,false);I.setSrc(i);};
d.prototype._getIconAggregation=function(){var i=this.getAggregation("_iconControl");if(!i){i=new sap.ui.core.Icon();this.setAggregation("_iconControl",i);}return i;};
d.prototype.setText=function(t){this.setProperty("text",t,true);};
return O;},true);
sap.ui.predefine('sap/m/ObjectMarkerRenderer',['jquery.sap.global','sap/ui/core/Renderer'],function(q,R){"use strict";var O={};
O.render=function(r,c){r.write("<span ");r.writeControlData(c);r.addClass("sapMObjectMarker");if(c._isIconVisible()){r.addClass("sapMObjectMarkerIcon");}if(c._isTextVisible()){r.addClass("sapMObjectMarkerText");}r.writeClasses();r.write(">");r.renderControl(c._getInnerControl());r.write("</span>");};
return O;},true);
sap.ui.predefine('sap/m/ObjectNumber',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/Renderer'],function(q,l,C,R){"use strict";
var O=C.extend("sap.m.ObjectNumber",{metadata:{library:"sap.m",properties:{number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null,deprecated:true},emphasized:{type:"boolean",group:"Appearance",defaultValue:true},state:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:sap.ui.core.ValueState.None},unit:{type:"string",group:"Misc",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:sap.ui.core.TextAlign.Begin}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}}}});
O.prototype._sCSSPrefixObjNumberStatus='sapMObjectNumberStatus';
O.prototype.setState=function(s){this.$().removeClass(this._sCSSPrefixObjNumberStatus+this.getState());this.setProperty("state",s,true);this.$().addClass(this._sCSSPrefixObjNumberStatus+this.getState());return this;};
O.prototype.setTextAlign=function(a){var A=R.getTextAlign(a,this.getTextDirection());this.setProperty("textAlign",a,true);A=A||a;this.$().css("text-align",a);return this;};
return O;},true);
sap.ui.predefine('sap/m/ObjectNumberRenderer',['jquery.sap.global','sap/ui/core/Renderer'],function(q,R){"use strict";var O={};
O.render=function(r,o){var t=o.getTooltip_AsString(),T=o.getTextDirection(),s=o.getTextAlign();r.write("<div");r.writeControlData(o);r.addClass("sapMObjectNumber");r.addClass(o._sCSSPrefixObjNumberStatus+o.getState());if(o.getEmphasized()){r.addClass("sapMObjectNumberEmph");}if(t){r.writeAttributeEscaped("title",t);}if(T!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",T.toLowerCase());}s=R.getTextAlign(s,T);if(s){r.addStyle("text-align",s);}r.writeClasses();r.writeStyles();if(o.getState()!==sap.ui.core.ValueState.None){r.writeAccessibilityState({labelledby:o.getId()+"-state"});}r.write(">");this.renderText(r,o);r.write("  ");this.renderUnit(r,o);this.renderHiddenARIAElement(r,o);r.write("</div>");};
O.renderText=function(r,o){r.write("<span");r.addClass("sapMObjectNumberText");r.writeClasses();r.write(">");r.writeEscaped(o.getNumber());r.write("</span>");};
O.renderUnit=function(r,o){var u=o.getUnit()||o.getNumberUnit();r.write("<span");r.addClass("sapMObjectNumberUnit");r.writeClasses();r.write(">");r.writeEscaped(u);r.write("</span>");};
O.renderHiddenARIAElement=function(r,o){var a="",b=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(o.getState()==sap.ui.core.ValueState.None){return;}r.write("<span id='"+o.getId()+"-state' class='sapUiInvisibleText' aria-hidden='true'>");switch(o.getState()){case sap.ui.core.ValueState.Error:a=b.getText("OBJECTNUMBER_ARIA_VALUE_STATE_ERROR");break;case sap.ui.core.ValueState.Warning:a=b.getText("OBJECTNUMBER_ARIA_VALUE_STATE_WARNING");break;case sap.ui.core.ValueState.Success:a=b.getText("OBJECTNUMBER_ARIA_VALUE_STATE_SUCCESS");break;}r.write(a);r.write("</span>");};
return O;},true);
sap.ui.predefine('sap/m/ObjectStatus',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/ValueStateSupport'],function(q,l,C,I,V){"use strict";
var O=C.extend("sap.m.ObjectStatus",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},state:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:sap.ui.core.ValueState.None},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}}}});
O.prototype.exit=function(){if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=null;}};
O.prototype._getImageControl=function(){var i=this.getId()+'-icon';var p={src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};this._oImageControl=sap.m.ImageHelper.getImageControl(i,this._oImageControl,this,p);return this._oImageControl;};
O.prototype.setTitle=function(t){var T=this.$().children(".sapMObjStatusTitle"),s=!!T.length&&!!this.validateProperty("title",t).trim();this.setProperty("title",t,s);if(s){T.text(this.getTitle()+":");}return this;};
O.prototype.setText=function(t){var T=this.$().children(".sapMObjStatusText"),s=!!T.length&&!!this.validateProperty("text",t).trim();this.setProperty("text",t,s);if(s){T.text(this.getText());}return this;};
O.prototype._isEmpty=function(){return!(this.getText().trim()||this.getIcon().trim()||this.getTitle().trim());};
O.prototype.getAccessibilityInfo=function(){var s=this.getState()!=sap.ui.core.ValueState.None?V.getAdditionalText(this.getState()):"";return{description:((this.getTitle()||"")+" "+(this.getText()||"")+" "+s).trim()};};
return O;},true);
sap.ui.predefine('sap/m/ObjectStatusRenderer',['jquery.sap.global','sap/ui/core/ValueStateSupport'],function(q,V){"use strict";var O={};
O.render=function(r,o){if(!o._isEmpty()){var s=o.getState();var t=o.getTextDirection();var T=t;r.write("<div");r.writeControlData(o);var a=o.getTooltip_AsString();if(a){r.writeAttributeEscaped("title",a);}r.addClass("sapMObjStatus");r.addClass("sapMObjStatus"+s);r.writeClasses();if(s!=sap.ui.core.ValueState.None){r.writeAccessibilityState(o,{describedby:{value:o.getId()+"sapSRH",append:true}});}r.write(">");if(o.getTitle()){var p=sap.ui.getCore().getConfiguration().getRTL();if(T===sap.ui.core.TextDirection.Inherit){T=p?sap.ui.core.TextDirection.RTL:sap.ui.core.TextDirection.LTR;}r.write("<span");r.writeAttributeEscaped("id",o.getId()+"-title");r.addClass("sapMObjStatusTitle");if(T){r.writeAttribute("dir",T.toLowerCase());}r.writeClasses();r.write(">");r.writeEscaped(o.getTitle()+":");r.write("</span>");}if(o.getIcon()){r.write("<span");r.writeAttributeEscaped("id",o.getId()+"-icon");r.addClass("sapMObjStatusIcon");r.writeClasses();r.write(">");r.renderControl(o._getImageControl());r.write("</span>");}if(o.getText()){r.write("<span");r.writeAttributeEscaped("id",o.getId()+"-text");r.addClass("sapMObjStatusText");if(t&&t!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",t.toLowerCase());}r.writeClasses();r.write(">");r.writeEscaped(o.getText());r.write("</span>");}if(s!=sap.ui.core.ValueState.None){r.write("<span");r.writeAttributeEscaped("id",o.getId()+"sapSRH");r.addClass("sapUiInvisibleText");r.writeClasses();r.writeAccessibilityState({hidden:false});r.write(">");r.writeEscaped(V.getAdditionalText(s));r.write("</span>");}r.write("</div>");}};
return O;},true);
sap.ui.predefine('sap/m/OverflowToolbar',["jquery.sap.global","./library","sap/m/ToggleButton","sap/ui/core/InvisibleText","sap/m/Toolbar","sap/m/ToolbarSpacer","sap/m/OverflowToolbarLayoutData","sap/m/OverflowToolbarAssociativePopover","sap/m/OverflowToolbarAssociativePopoverControls","sap/m/OverflowToolbarPriority","sap/ui/core/IconPool","sap/m/SearchField"],function(q,l,T,I,a,b,O,c,d,e,f,S){"use strict";
var g=a.extend("sap.m.OverflowToolbar",{metadata:{aggregations:{_overflowButton:{type:"sap.m.ToggleButton",multiple:false,visibility:"hidden"},_popover:{type:"sap.m.Popover",multiple:false,visibility:"hidden"}}}});
g.prototype._callToolbarMethod=function(F,A){return a.prototype[F].apply(this,A);};
g.prototype.init=function(){this._callToolbarMethod("init",arguments);this._iPreviousToolbarWidth=null;this._bOverflowButtonNeeded=false;this._bListenForControlPropertyChanges=false;this._bControlsInfoCached=false;this._bSkipOptimization=false;if(!g._sAriaOverflowButtonLabelId){var C=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core");g._sAriaOverflowButtonLabelId=new I({text:C.getText("Icon.overflow")}).toStatic().getId();}this._aControlSizes={};};
g.prototype.exit=function(){var p=this.getAggregation("_popover");if(p){p.destroy();}};
g.prototype.onAfterRendering=function(){if(this._bControlWasFocused){this._getOverflowButton().focus();this._bControlWasFocused=false;}if(this._bOverflowButtonWasFocused&&!this._getOverflowButtonNeeded()){this.$().lastFocusableDomRef().focus();this._bOverflowButtonWasFocused=false;}this._getOverflowButton().$().attr("aria-haspopup","true");this._doLayout();};
g.prototype._doLayout=function(){var w=this.$().width();this._bListenForControlPropertyChanges=false;this._deregisterToolbarResize();this._polyfillFlexboxSupport();if(w>0){if(!this._isControlsInfoCached()){this._cacheControlsInfo();}if(this._iPreviousToolbarWidth!==w){this._iPreviousToolbarWidth=w;this._setControlsOverflowAndShrinking(w);}}this._registerToolbarResize();this._bListenForControlPropertyChanges=true;};
g.prototype._polyfillFlexboxSupport=function(){if(a.hasNewFlexBoxSupport){return;}if(a.hasFlexBoxSupport){var t=this.$();var D=t[0]||{};t.removeClass("sapMTBOverflow");var o=D.scrollWidth>D.clientWidth;o&&t.addClass("sapMTBOverflow");}else{a.flexie(this.$());}};
g.prototype._cacheControlsInfo=function(){var p,C,A;this._aMovableControls=[];this._aToolbarOnlyControls=[];this._aActionSheetOnlyControls=[];this._iContentSize=0;this.getContent().forEach(function(o){p=g._getControlPriority(o);C=p!==e.NeverOverflow;A=p===e.AlwaysOverflow;var i=g._getOptimalControlWidth(o,this._aControlSizes[o.getId()]);this._aControlSizes[o.getId()]=i;if(d.supportsControl(o)&&A){this._aActionSheetOnlyControls.push(o);}else{this._iContentSize+=i;if(d.supportsControl(o)&&C){this._aMovableControls.push(o);}else{this._aToolbarOnlyControls.push(o);}}},this);if(sap.ui.Device.system.phone){this._iContentSize-=1;}this._bControlsInfoCached=true;};
g.prototype._isControlsInfoCached=function(){return this._bControlsInfoCached;};
g.prototype._setControlsOverflowAndShrinking=function(t){var C=this._iContentSize,B=[],s,i,A,F=function(o){o.forEach(function(p){this._moveButtonToActionSheet(p);},this);},h=function(H){if(typeof H==="undefined"||this._getPopover()._getContentIdsHash()!==H){this.invalidate();if(this._getControlsIds().indexOf(sap.ui.getCore().getCurrentFocusedControlId())!==-1){this._bControlWasFocused=true;}if(sap.ui.getCore().getCurrentFocusedControlId()===this._getOverflowButton().getId()){this._bOverflowButtonWasFocused=true;}}},j=function(C){if(!this._getOverflowButtonNeeded()){C+=this._getOverflowButtonSize();this._setOverflowButtonNeeded(true);}return C;},k=function(M){var G={},o=[];M.forEach(function(p){var r=g._getControlGroup(p),P=g._oPriorityOrder,u,v,w;if(r){u=g._getControlPriority(p);v=this._getControlIndex(p);G[r]=G[r]||[];w=G[r];w.push(p);if(!w._priority||P[w._priority]<P[u]){w._priority=u;}if(!w._index||w._index<v){w._index=v;}}else{o.push(p);}},this);Object.keys(G).forEach(function(p){o.push(G[p]);});return o;},E=function(M){if(M.length){M.forEach(n,this);}else{n.call(this,M);}if(C<=t){return true;}},m=function(v,o){var p=g._oPriorityOrder,r=g._getControlPriority(v),u=g._getControlPriority(o),P=p[r]-p[u];if(P!==0){return P;}else{return this._getControlIndex(o)-this._getControlIndex(v);}},n=function(o){B.unshift(o);C-=this._aControlSizes[o.getId()];};if(this._bSkipOptimization){this._bSkipOptimization=false;}else{s=this._getPopover()._getContentIdsHash();}this._resetToolbar();if(this._aActionSheetOnlyControls.length){for(i=this._aActionSheetOnlyControls.length-1;i>=0;i--){if(this._aActionSheetOnlyControls[i].getVisible()){B.unshift(this._aActionSheetOnlyControls[i]);}}if(B.length>0){C=j.call(this,C);}}if(C<=t){F.call(this,B);h.call(this,s);return;}if(this._aMovableControls.length){C=j.call(this,C);A=k.call(this,this._aMovableControls);A.sort(m.bind(this));A.some(E,this);}F.call(this,B);if(C>t){this._checkContents();}h.call(this,s);};
g.prototype._resetToolbar=function(){this._getPopover().close();this._getPopover()._getAllContent().forEach(function(B){this._restoreButtonInToolbar(B);},this);this._setOverflowButtonNeeded(false);this.getContent().forEach(function(C){C.removeStyleClass(a.shrinkClass);});};
g.prototype._moveButtonToActionSheet=function(B){this._getPopover().addAssociatedContent(B);};
g.prototype._restoreButtonInToolbar=function(B){if(typeof B==="object"){B=B.getId();}this._getPopover().removeAssociatedContent(B);};
g.prototype._resetAndInvalidateToolbar=function(h){this._resetToolbar();this._bControlsInfoCached=false;this._iPreviousToolbarWidth=null;if(h){this._bSkipOptimization=true;}this.invalidate();};
g.prototype._getVisibleContent=function(){var t=this.getContent(),A=this._getPopover()._getAllContent();return t.filter(function(C){return A.indexOf(C)===-1;});};
g.prototype._getOverflowButton=function(){var o;if(!this.getAggregation("_overflowButton")){o=new T({id:this.getId()+"-overflowButton",icon:f.getIconURI("overflow"),press:this._overflowButtonPressed.bind(this),ariaLabelledBy:this._sAriaOverflowButtonLabelId,type:sap.m.ButtonType.Transparent});this.setAggregation("_overflowButton",o,true);}return this.getAggregation("_overflowButton");};
g.prototype._overflowButtonPressed=function(E){var p=this._getPopover(),B=this._getBestActionSheetPlacement();if(p.getPlacement()!==B){p.setPlacement(B);}if(p.isOpen()){p.close();}else{p.openBy(E.getSource());}};
g.prototype._getPopover=function(){var p;if(!this.getAggregation("_popover")){p=new c(this.getId()+"-popover",{showHeader:false,showArrow:false,modal:false,horizontalScrolling:sap.ui.Device.system.phone?false:true,contentWidth:sap.ui.Device.system.phone?"100%":"auto",offsetY:this._detireminePopoverVerticalOffset()});p._adaptPositionParams=function(){c.prototype._adaptPositionParams.call(this);this._myPositions=["end top","begin center","end bottom","end center"];this._atPositions=["end bottom","end center","end top","begin center"];};if(sap.ui.Device.system.phone){p.attachBeforeOpen(this._shiftPopupShadow,this);}p.attachAfterClose(this._popOverClosedHandler,this);this.setAggregation("_popover",p,true);}return this.getAggregation("_popover");};
g.prototype._shiftPopupShadow=function(){var p=this._getPopover(),P=p.getCurrentPosition();if(P===sap.m.PlacementType.Bottom){p.addStyleClass("sapMOTAPopoverNoShadowTop");p.removeStyleClass("sapMOTAPopoverNoShadowBottom");}else if(P===sap.m.PlacementType.Top){p.addStyleClass("sapMOTAPopoverNoShadowBottom");p.removeStyleClass("sapMOTAPopoverNoShadowTop");}};
g.prototype._popOverClosedHandler=function(){this._getOverflowButton().setPressed(false);this._getOverflowButton().$().focus();this._getOverflowButton().setEnabled(false);q.sap.delayedCall(0,this,function(){this._getOverflowButton().setEnabled(true);q.sap.delayedCall(0,this,function(){this._getOverflowButton().$().focus();});});};
g.prototype._getOverflowButtonNeeded=function(){return this._bOverflowButtonNeeded;};
g.prototype._setOverflowButtonNeeded=function(v){if(this._bOverflowButtonNeeded!==v){this._bOverflowButtonNeeded=v;}return this;};
g.prototype.onLayoutDataChange=function(){this._resetAndInvalidateToolbar(true);};
g.prototype.addContent=function(C){this._registerControlListener(C);this._preProcessControl(C);this._resetAndInvalidateToolbar(false);return this._callToolbarMethod("addContent",arguments);};
g.prototype.insertContent=function(C,i){this._registerControlListener(C);this._preProcessControl(C);this._resetAndInvalidateToolbar(false);return this._callToolbarMethod("insertContent",arguments);};
g.prototype.removeContent=function(C){var v=this._callToolbarMethod("removeContent",arguments);if(v){this._getPopover().removeAssociatedContent(v.getId());}this._resetAndInvalidateToolbar(false);this._postProcessControl(v);this._deregisterControlListener(v);return v;};
g.prototype.removeAllContent=function(){var C=this._callToolbarMethod("removeAllContent",arguments);C.forEach(function(o){this._deregisterControlListener(o);this._postProcessControl(o);},this);this._resetAndInvalidateToolbar(false);return C;};
g.prototype.destroyContent=function(){this._resetAndInvalidateToolbar(false);q.sap.delayedCall(0,this,function(){this._resetAndInvalidateToolbar(false);});return this._callToolbarMethod("destroyContent",arguments);};
g.prototype._registerControlListener=function(C){if(C){C.attachEvent("_change",this._onContentPropertyChangedOverflowToolbar,this);}};
g.prototype._deregisterControlListener=function(C){if(C){C.detachEvent("_change",this._onContentPropertyChangedOverflowToolbar,this);}};
g.prototype._onContentPropertyChangedOverflowToolbar=function(E){if(!this._bListenForControlPropertyChanges){return;}var s=E.getSource();var C=d.getControlConfig(s);var p=E.getParameter("name");if(typeof C!=="undefined"&&C.noInvalidationProps.indexOf(p)!==-1){return;}this._resetAndInvalidateToolbar(true);};
g.prototype._getOverflowButtonSize=function(){var B=parseInt(sap.m.BaseFontSize,10),C=this.$().parents().hasClass('sapUiSizeCompact')?2.5:3;return parseInt(B*C,10);};
g.prototype._getBestActionSheetPlacement=function(){var h=this.getHTMLTag();if(h==="Footer"){return sap.m.PlacementType.Top;}else if(h==="Header"){return sap.m.PlacementType.Bottom;}return sap.m.PlacementType.Vertical;};
g.prototype._getControlsIds=function(){return this.getContent().map(function(i){return i.getId();});};
g.prototype._preProcessControl=function(C){if(!(C instanceof S)){return;}if(C.getSelectOnFocus()){C.setProperty("selectOnFocus",false,true);C._origSelectOnFocus=true;}};
g.prototype._postProcessControl=function(C){if(!(C instanceof S)){return;}if(typeof C._origSelectOnFocus!=="undefined"){C.setProperty("selectOnFocus",C._origSelectOnFocus,true);delete C._origSelectOnFocus;}};
g.prototype._getControlIndex=function(C){return C.length?C._index:this.indexOfContent(C);};
g._getOptimalControlWidth=function(C,o){var i;if(C instanceof b){i=parseInt(C.$().css('min-width'),10)||0+C.$().outerWidth(true)-C.$().outerWidth();}else{i=C.getVisible()?C.$().outerWidth(true):0;}if(i===null){i=typeof o!=="undefined"?o:0;}return i;};
g._getControlPriority=function(C){if(C.length){return C._priority;}var L=C.getLayoutData&&C.getLayoutData();if(L&&L instanceof O){if(L.getMoveToOverflow()===false){return e.NeverOverflow;}if(L.getStayInOverflow()===true){return e.AlwaysOverflow;}return L.getPriority();}return e.High;};
g._getControlGroup=function(C){var L=C.getLayoutData();if(L instanceof O){return L.getGroup();}};
g._oPriorityOrder=(function(){var p={};p[e.Disappear]=1;p[e.Low]=2;p[e.High]=3;return p;})();
g.prototype._detireminePopoverVerticalOffset=function(){return this.$().parents().hasClass('sapUiSizeCompact')?2:3;};
g.prototype.onThemeChanged=function(){this._resetAndInvalidateToolbar();};
g.prototype.closeOverflow=function(){this._getPopover().close();};
return g;},true);
sap.ui.predefine('sap/m/OverflowToolbarAssociativePopover',['./Popover','./PopoverRenderer','./OverflowToolbarAssociativePopoverControls','./OverflowToolbarLayoutData'],function(P,a,O,b){"use strict";
var c=P.extend("sap.m._overflowToolbarHelpers.OverflowToolbarAssociativePopover",{
metadata:{associations:{associatedContent:{type:"sap.ui.core.Control",multiple:true}}},
renderer:a.render
});
c.prototype.init=function(){P.prototype.init.apply(this,arguments);this.oControlsManager=new O();};
c.prototype.onBeforeRendering=function(){P.prototype.onBeforeRendering.apply(this,arguments);this.addStyleClass("sapMOTAPopover");var h=this._getAllContent().some(function(o){return o.hasStyleClass("sapMOTAPButtonWithIcon");});if(h){this.addStyleClass("sapMOTAPButtonsWithIcons");}else{this.removeStyleClass("sapMOTAPButtonsWithIcons");}};
c.prototype.addAssociatedContent=function(o){this.addAssociation("associatedContent",o,true);this._preProcessControl(o);return this;};
c.prototype.removeAssociatedContent=function(o){var r=this.removeAssociation("associatedContent",o,true),d;if(r){d=sap.ui.getCore().byId(r);if(d){this._postProcessControl(d);}}return r;};
c.prototype._preProcessControl=function(o){var s=O.getControlClass(o),d=O.getControlConfig(o),A,p;d.listenForEvents.forEach(function(e){A="attach"+C(e);o[A](this._closeOnInteraction.bind(this,o));},this);p="_preProcess"+s.split(".").map(C).join("");if(typeof this.oControlsManager[p]==="function"){this.oControlsManager[p](o);}var l=o.getLayoutData();if(l instanceof b&&l.getPriority()===sap.m.OverflowToolbarPriority.Disappear){o.addStyleClass("sapMOTAPHidden");}return this;};
c.prototype._postProcessControl=function(o){var s=O.getControlClass(o),d=O.getControlConfig(o),D,p;d.listenForEvents.forEach(function(e){D="detach"+C(e);o[D](this._closeOnInteraction,this);},this);p="_postProcess"+s.split(".").map(C).join("");if(typeof this.oControlsManager[p]==="function"){this.oControlsManager[p](o);}o.removeStyleClass("sapMOTAPHidden");o.$().remove();return this;};
c.prototype._closeOnInteraction=function(o){var l=o.getLayoutData();if(!l||!(l instanceof b)||l.getCloseOverflowOnInteraction()){this.close();}};
c.prototype._getContentIdsHash=function(){return this._getAllContent().join(".");};
c.prototype._getAllContent=function(){var A=this.getAssociatedContent().map(function(i){return sap.ui.getCore().byId(i);});if(this.getPlacement()===sap.m.PlacementType.Top){A.reverse();}return this.getContent().concat(A);};
c.prototype.getCurrentPosition=function(){if(!this._oCalcedPos){this._calcPlacement();}return this._oCalcedPos;};
function C(n){return n.substring(0,1).toUpperCase()+n.substring(1);}
return c;},false);
sap.ui.predefine('sap/m/OverflowToolbarAssociativePopoverControls',['jquery.sap.global','sap/ui/base/Metadata','./OverflowToolbarButton','./ToggleButton','./Button'],function(q,M,O,T,B){"use strict";var a=M.createClass("sap.m._overflowToolbarHelpers.OverflowToolbarAssociativePopoverControls",{constructor:function(){this._mControlsCache={};}});
a.prototype._preProcessSapMButton=function(c){var b=c.getType();this._mControlsCache[c.getId()]={buttonType:b};if(b===sap.m.ButtonType.Default){c.setProperty("type",sap.m.ButtonType.Transparent,true);}if(c.getIcon()){c.addStyleClass("sapMOTAPButtonWithIcon");}else{c.addStyleClass("sapMOTAPButtonNoIcon");}c.attachEvent("_change",this._onSapMButtonUpdated,this);};
a.prototype._postProcessSapMButton=function(c){var p=this._mControlsCache[c.getId()];if(c.getType()!==p.buttonType){c.setProperty("type",p.buttonType,true);}c.removeStyleClass("sapMOTAPButtonNoIcon");c.removeStyleClass("sapMOTAPButtonWithIcon");c.detachEvent("_change",this._onSapMButtonUpdated,this);};
a.prototype._onSapMButtonUpdated=function(e){var p=e.getParameter("name"),b=e.getSource(),s=b.getId();if(typeof this._mControlsCache[s]==="undefined"){return;}if(p==="type"){this._mControlsCache[s]["buttonType"]=b.getType();}};
a.prototype._preProcessSapMOverflowToolbarButton=function(c){this._preProcessSapMButton(c);c._bInOverflow=true;};
a.prototype._postProcessSapMOverflowToolbarButton=function(c){delete c._bInOverflow;this._postProcessSapMButton(c);};
a.prototype._preProcessSapMToggleButton=function(c){this._preProcessSapMButton(c);};
a.prototype._postProcessSapMToggleButton=function(c){this._postProcessSapMButton(c);};
a.prototype._preProcessSapMSegmentedButton=function(c){c._toSelectMode();};
a.prototype._postProcessSapMSegmentedButton=function(c){c._toNormalMode();};
a.prototype._preProcessSapMSelect=function(c){this._mControlsCache[c.getId()]={selectType:c.getType()};if(c.getType()!==sap.m.SelectType.Default){c.setProperty("type",sap.m.SelectType.Default,true);}};
a.prototype._postProcessSapMSelect=function(c){var p=this._mControlsCache[c.getId()];if(c.getType()!==p.selectType){c.setProperty("type",p.selectType,true);}};
a._mSupportedControls={"sap.m.Button":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","type"]},"sap.m.OverflowToolbarButton":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","type"]},"sap.m.CheckBox":{canOverflow:true,listenForEvents:["select"],noInvalidationProps:["enabled","selected"]},"sap.m.ToggleButton":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","pressed"]},"sap.m.Select":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","selectedItemId","selectedKey"]},"sap.m.ComboBox":{canOverflow:true,listenForEvents:[],noInvalidationProps:["enabled","value","selectedItemId","selectedKey"]},"sap.m.SearchField":{canOverflow:true,listenForEvents:["search"],noInvalidationProps:["enabled","value","selectOnFocus"]},"sap.m.SegmentedButton":{canOverflow:true,listenForEvents:["select"],noInvalidationProps:["enabled","selectedKey"]},"sap.m.Input":{canOverflow:true,listenForEvents:[],noInvalidationProps:["enabled","value"]},"sap.m.DateTimeInput":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue"]},"sap.m.DatePicker":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue","displayFormat","valueFormat","displayFormatType","secondaryCalendarType","minDate","maxDate"]},"sap.m.DateTimePicker":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue","displayFormat","valueFormat","displayFormatType","secondaryCalendarType","minDate","maxDate"]},"sap.m.TimePicker":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue","displayFormat","valueFormat"]},"sap.m.RadioButton":{canOverflow:false,listenForEvents:[],noInvalidationProps:["enabled","selected"]},"sap.m.Slider":{canOverflow:false,listenForEvents:[],noInvalidationProps:["enabled","value"]},"sap.ui.comp.smartfield.SmartField":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","valueState","showValueHelp","contextEditable","clientSideMandatoryCheck","mandatory","name","placeholder","showSuggestion","tooltipLabel"]},"sap.ui.comp.smartfield.SmartLabel":{canOverflow:true,listenForEvents:[],noInvalidationProps:["enabled"]}};
a.getControlConfig=function(c){var C=a.getControlClass(c);return a._mSupportedControls[C];};
a.supportsControl=function(c){var C=a.getControlClass(c);var o=a._mSupportedControls[C];return typeof o!=="undefined"&&o.canOverflow;};
a.getControlClass=function(c){if(c instanceof O){return"sap.m.OverflowToolbarButton";}else if(c instanceof T){return"sap.m.ToggleButton";}else if(c instanceof B){return"sap.m.Button";}return c.getMetadata().getName();};
return a;},false);
sap.ui.predefine('sap/m/OverflowToolbarButton',['sap/m/Button','sap/m/ButtonRenderer'],function(B,a){"use strict";
var O=B.extend("sap.m.OverflowToolbarButton",{renderer:a.render});
O.prototype._getText=function(){if(this._bInOverflow){return B.prototype._getText.call(this);}return"";};
return O;},true);
sap.ui.predefine('sap/m/OverflowToolbarLayoutData',['sap/m/ToolbarLayoutData','sap/m/OverflowToolbarPriority'],function(T,O){"use strict";
var a=T.extend("sap.m.OverflowToolbarLayoutData",{metadata:{properties:{moveToOverflow:{type:"boolean",defaultValue:true,deprecated:true},stayInOverflow:{type:"boolean",defaultValue:false,deprecated:true},priority:{type:"sap.m.OverflowToolbarPriority",group:"Behavior",defaultValue:sap.m.OverflowToolbarPriority.High},group:{type:"int",group:"Behavior",defaultValue:0},closeOverflowOnInteraction:{type:"boolean",group:"Behavior",defaultValue:true}}}});
a.prototype.invalidate=function(){var c=this.getPriority(),i=c===O.AlwaysOverflow||c===O.NeverOverflow;if(this.getGroup()&&i){jQuery.sap.log.error("It is not allowed to set AlwaysOverflow or NeverOverflow to a group items.");}return T.prototype.invalidate.call(this);};
return a;},true);
sap.ui.predefine('sap/m/OverflowToolbarRenderer',['sap/ui/core/Renderer','./ToolbarRenderer'],function(R,T){"use strict";var O=R.extend(T);
O.renderBarContent=function(r,t){t._getVisibleContent().forEach(function(c){sap.m.BarInPageEnabler.addChildClassTo(c,t);r.renderControl(c);});if(t._getOverflowButtonNeeded()){O.renderOverflowButton(r,t);}};
O.renderOverflowButton=function(r,t){var o=t._getOverflowButton();sap.m.BarInPageEnabler.addChildClassTo(o,t);r.renderControl(o);};
return O;},true);
sap.ui.predefine('sap/m/Page.designtime',[],function(){"use strict";return{aggregations:{headerContent:{domRef:":sap-domref .sapMBarRight"},subHeader:{domRef:":sap-domref .sapMPageSubHeader"},customHeader:{domRef:":sap-domref .sapMPageHeader"},content:{domRef:":sap-domref > section"},footer:{domRef:":sap-domref .sapMPageFooter"},landmarkInfo:{ignore:true}}};},false);
sap.ui.predefine('sap/m/Page',["jquery.sap.global","./library","sap/ui/core/Control","sap/ui/core/delegate/ScrollEnablement","sap/m/Title","sap/m/Button","sap/m/Bar"],function(q,l,C,S,T,B,a){"use strict";
var P=C.extend("sap.m.Page",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Data",defaultValue:null},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:sap.ui.core.TitleLevel.Auto},showNavButton:{type:"boolean",group:"Appearance",defaultValue:false},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},showSubHeader:{type:"boolean",group:"Appearance",defaultValue:true},navButtonText:{type:"string",group:"Misc",defaultValue:null,deprecated:true},navButtonTooltip:{type:"string",group:"Misc",defaultValue:null},enableScrolling:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null,deprecated:true},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:sap.m.PageBackgroundDesign.Standard},navButtonType:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:sap.m.ButtonType.Back,deprecated:true},showFooter:{type:"boolean",group:"Appearance",defaultValue:true},contentOnlyBusy:{type:"boolean",group:"Appearance",defaultValue:false},floatingFooter:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},customHeader:{type:"sap.m.IBar",multiple:false},footer:{type:"sap.m.IBar",multiple:false},subHeader:{type:"sap.m.IBar",multiple:false},headerContent:{type:"sap.ui.core.Control",multiple:true,singularName:"headerContent"},landmarkInfo:{type:"sap.m.PageAccessibleLandmarkInfo",multiple:false},_internalHeader:{type:"sap.m.IBar",multiple:false,visibility:"hidden"}},events:{navButtonTap:{deprecated:true},navButtonPress:{}},designTime:true}});
P.FOOTER_ANIMATION_DURATION=350;
P.prototype._hasScrolling=function(){return this.getEnableScrolling();};
P.prototype.onBeforeRendering=function(){if(this._oScroller&&!this._hasScrolling()){this._oScroller.destroy();this._oScroller=null;}else if(this._hasScrolling()&&!this._oScroller){this._oScroller=new S(this,null,{scrollContainerId:this.getId()+"-cont",horizontal:false,vertical:true});}if(this._headerTitle){this._headerTitle.setLevel(this.getTitleLevel());}};
P.prototype.onAfterRendering=function(){q.sap.delayedCall(10,this,this._adjustFooterWidth);};
P.prototype.exit=function(){if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._headerTitle){this._headerTitle.destroy();this._headerTitle=null;}if(this._navBtn){this._navBtn.destroy();this._navBtn=null;}if(this._appIcon){this._appIcon.destroy();this._appIcon=null;}};
P.prototype.setBackgroundDesign=function(b){var s=this.getBackgroundDesign();this.setProperty("backgroundDesign",b,true);this.$().removeClass("sapMPageBg"+s).addClass("sapMPageBg"+this.getBackgroundDesign());return this;};
P.prototype.setTitle=function(t){var w=!this._headerTitle;this._headerTitle=this._headerTitle||new T(this.getId()+"-title",{text:t,level:this.getTitleLevel()});this._headerTitle.setText(t);if(w){this._updateHeaderContent(this._headerTitle,"middle",0);}this.setProperty("title",t,true);return this;};
P.prototype._ensureNavButton=function(){var b=this.getNavButtonTooltip()||sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("PAGE_NAVBUTTON_TEXT");if(!this._navBtn){var n=this.getNavButtonType();this._navBtn=new B(this.getId()+"-navButton",{press:q.proxy(function(){this.fireNavButtonPress();this.fireNavButtonTap();},this)});if(sap.ui.Device.os.android&&n==sap.m.ButtonType.Back){this._navBtn.setType(sap.m.ButtonType.Up);}else{this._navBtn.setType(n);}}this._navBtn.setTooltip(b);};
P.prototype.setShowNavButton=function(s){var o=!!this.getShowNavButton();if(s===o){return this;}this.setProperty("showNavButton",s,true);if(s){this._ensureNavButton();if(this._appIcon){this._updateHeaderContent(this._appIcon,"left",-1);}this._updateHeaderContent(this._navBtn,"left",0);}else if(this._navBtn){this._updateHeaderContent(this._navBtn,"left",-1);}return this;};
P.prototype.setShowFooter=function(s){(s)?this.addStyleClass("sapMPageWithFooter",true):this.removeStyleClass("sapMPageWithFooter",true);var $=q(this.getDomRef()).find(".sapMPageFooter").last(),u=sap.ui.getCore().getConfiguration().getAnimation();if(!this.getFloatingFooter()){this.setProperty("showFooter",s);return this;}this.setProperty("showFooter",s,true);$.toggleClass("sapMPageFooterControlShow",s);$.toggleClass("sapMPageFooterControlHide",!s);if(s){return this;}if(u){q.sap.delayedCall(P.FOOTER_ANIMATION_DURATION,this,function(){$.toggleClass("sapUiHidden",s);});}else{$.toggleClass("sapUiHidden",s);}return this;};
P.prototype.setNavButtonType=function(n){this._ensureNavButton();if(!sap.ui.Device.os.ios&&n==sap.m.ButtonType.Back){this._navBtn.setType(sap.m.ButtonType.Up);}else{this._navBtn.setType(n);}this.setProperty("navButtonType",n,true);return this;};
P.prototype.setNavButtonText=function(t){this._ensureNavButton();this.setProperty("navButtonText",t,true);return this;};
P.prototype.setNavButtonTooltip=function(t){this.setProperty("navButtonTooltip",t,true);this._ensureNavButton();return this;};
P.prototype.setIcon=function(i){var o=this.getIcon();if(o===i){return this;}this.setProperty("icon",i,true);return this;};
P.prototype._adjustFooterWidth=function(){if(!this.getShowFooter()||!this.getFloatingFooter()||!this.getFooter()){return;}var $=q(this.getDomRef()).find(".sapMPageFooter").last();if(this._contentHasScroll()){$.css("right",q.position.scrollbarWidth()+"px");$.css("width","initial");}else{$.css("right",0);$.css("width","");}};
P.prototype._contentHasScroll=function(){var $=q(this.getDomRef()).find("#"+this.getId()+"-cont");return $[0].scrollHeight>$.innerHeight();};
P.prototype._updateHeaderContent=function(c,s,i){var I=this._getInternalHeader();if(I){switch(s){case"left":if(i==-1){if(I.getContentLeft()){I.removeContentLeft(c);}}else{if(I.indexOfContentLeft(c)!=i){I.insertContentLeft(c,i);I.invalidate();}}break;case"middle":if(i==-1){if(I.getContentMiddle()){I.removeContentMiddle(c);}}else{if(I.indexOfContentMiddle(c)!=i){I.insertContentMiddle(c,i);I.invalidate();}}break;case"right":if(i==-1){if(I.getContentRight()){I.removeContentRight(c);}}else{if(I.indexOfContentRight(c)!=i){I.insertContentRight(c,i);I.invalidate();}}break;default:break;}}};
P.prototype._getInternalHeader=function(){var i=this.getAggregation("_internalHeader");if(!i){this.setAggregation("_internalHeader",new a(this.getId()+"-intHeader"),true);i=this.getAggregation("_internalHeader");if(this.getShowNavButton()&&this._navBtn){this._updateHeaderContent(this._navBtn,"left",0);}if(this.getTitle()&&this._headerTitle){this._updateHeaderContent(this._headerTitle,"middle",0);}}return i;};
P.prototype._getAnyHeader=function(){var c=this.getCustomHeader();if(c){return c.addStyleClass("sapMPageHeader");}return this._getInternalHeader().addStyleClass("sapMPageHeader");};
P.prototype.getScrollDelegate=function(){return this._oScroller;};
P.prototype.scrollTo=function(y,t){if(this._oScroller){this._oScroller.scrollTo(0,y,t);}return this;};
P.prototype.scrollToElement=function(e,t){if(e instanceof sap.ui.core.Element){e=e.getDomRef();}if(this._oScroller){this._oScroller.scrollToElement(e,t);}return this;};
P.prototype.setContentOnlyBusy=function(c){this.setProperty("contentOnlyBusy",c,true);this.$().toggleClass("sapMPageBusyCoversAll",!c);return this;};
P.prototype.getHeaderContent=function(){return this._getInternalHeader().getContentRight();};
P.prototype.indexOfHeaderContent=function(c){return this._getInternalHeader().indexOfContentRight(c);};
P.prototype.insertHeaderContent=function(c,i){return this._getInternalHeader().insertContentRight(c,i);};
P.prototype.addHeaderContent=function(c){return this._getInternalHeader().addContentRight(c);};
P.prototype.removeHeaderContent=function(c){return this._getInternalHeader().removeContentRight(c);};
P.prototype.removeAllHeaderContent=function(){return this._getInternalHeader().removeAllContentRight();};
P.prototype.destroyHeaderContent=function(){return this._getInternalHeader().destroyContentRight();};
P.prototype.setCustomHeader=function(h){this.setAggregation("customHeader",h);if(h&&this.mEventRegistry["_adaptableContentChange"]){this.fireEvent("_adaptableContentChange",{"parent":this,"adaptableContent":h});}return this;};
P.prototype._getAdaptableContent=function(){return this._getAnyHeader();};
return P;},true);
sap.ui.predefine('sap/m/PageAccessibleLandmarkInfo',['sap/ui/core/Element','./library'],function(E,l){"use strict";
var P=E.extend("sap.m.PageAccessibleLandmarkInfo",{metadata:{library:"sap.m",properties:{rootRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Region"},rootLabel:{type:"string",defaultValue:null},contentRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Main"},contentLabel:{type:"string",defaultValue:null},headerRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Region"},headerLabel:{type:"string",defaultValue:null},subHeaderRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:null},subHeaderLabel:{type:"string",defaultValue:null},footerRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Region"},footerLabel:{type:"string",defaultValue:null}}}});
P._getLandmarkInfo=function(i,a){if(!i){return null;}var r=null;var t=null;var p=i.getMetadata().getProperty(a+"Role");if(p){r=i[p._sGetter]();}if(!r){return null;}p=i.getMetadata().getProperty(a+"Label");if(p){t=i[p._sGetter]();}return[r.toLowerCase(),t];};
P._writeLandmarkInfo=function(r,p,a){if(!sap.ui.getCore().getConfiguration().getAccessibility()){return;}var i=P._getLandmarkInfo(p.getLandmarkInfo(),a);if(!i){return;}var L={role:i[0]};if(i[1]){L["label"]=i[1];}r.writeAccessibilityState(p,L);};
return P;});
sap.ui.predefine('sap/m/PageRenderer',['sap/m/PageAccessibleLandmarkInfo'],function(P){"use strict";var a={};
a.render=function(r,p){var h=null,f=null,s=null,e=p.getEnableScrolling()?" sapMPageScrollEnabled":"",L=this._isLightHeader(p);if(p.getShowHeader()){h=p._getAnyHeader();}if(p.getShowSubHeader()){s=p.getSubHeader();}if(p.getShowFooter()){f=p.getFooter();}r.write("<div");r.writeControlData(p);r.addClass("sapMPage");r.addClass("sapMPageBg"+p.getBackgroundDesign());if(h){r.addClass("sapMPageWithHeader");}if(s){r.addClass("sapMPageWithSubHeader");}if(f){r.addClass("sapMPageWithFooter");}if(!p.getContentOnlyBusy()){r.addClass("sapMPageBusyCoversAll");}var t=sap.ui.getCore().getConfiguration().getTheme();if(p.getFloatingFooter()&&p.getShowFooter()&&t!=='sap_hcb'){r.addClass("sapMPageFloatingFooter");}r.writeClasses();var T=p.getTooltip_AsString();if(T){r.writeAttributeEscaped("title",T);}P._writeLandmarkInfo(r,p,"root");r.write(">");this.renderBarControl(r,p,h,{context:"header",styleClass:"sapMPageHeader"+(L?"":" sapContrastPlus")});this.renderBarControl(r,p,s,{context:"subHeader",styleClass:"sapMPageSubHeader"+(L?"":" sapContrastPlus")});r.write('<section id="'+p.getId()+'-cont"');P._writeLandmarkInfo(r,p,"content");r.write('>');if(p._bUseScrollDiv){r.write('<div id="'+p.getId()+'-scroll" class="sapMPageScroll'+e+'">');}var c=p.getContent();var l=c.length;for(var i=0;i<l;i++){r.renderControl(c[i]);}if(p._bUseScrollDiv){r.write("</div>");}r.write("</section>");this.renderBarControl(r,p,f,{context:"footer",styleClass:"sapMPageFooter"});r.write("</div>");};
a.renderBarControl=function(r,p,b,o){if(!b){return;}b.applyTagAndContextClassFor(o.context.toLowerCase());b._setLandmarkInfo(p.getLandmarkInfo(),o.context);b.addStyleClass(o.styleClass);r.renderControl(b);};
a._isLightHeader=function(p){var c=p,o=p.getParent(),s,C;while(o){s=(o&&o.getMetadata().getName())||"";C=c.getMetadata().getName();if((s==="sap.m.Popover"||s==="sap.m.Dialog")&&C==="sap.m.NavContainer"){return true;}if(o&&["sap.m.SplitApp","sap.m.SplitContainer"].indexOf(s)>-1&&C==="sap.m.NavContainer"&&/\-Master$/.test(c.getId())){return true;}c=o;o=c.getParent();}return false;};
return a;},true);
sap.ui.predefine('sap/m/PagingButton',['jquery.sap.global','./Button','sap/ui/core/Control','sap/ui/core/IconPool'],function(q,B,C,I){"use strict";
var P=C.extend("sap.m.PagingButton",{metadata:{library:"sap.m",properties:{count:{type:"int",group:"Data",defaultValue:1},position:{type:"int",group:"Data",defaultValue:1},nextButtonTooltip:{type:"string",group:"Appearance",defaultValue:""},previousButtonTooltip:{type:"string",group:"Appearance",defaultValue:""}},aggregations:{previousButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},nextButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{positionChange:{parameters:{newPosition:{type:"int"},oldPosition:{type:"int"}}}}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
P.prototype.init=function(){this._attachPressEvents();};
P.prototype.onBeforeRendering=function(){this._enforceValidPosition(this.getPosition());this._updateButtonState();};
P.prototype._getNextButton=function(){if(!this.getAggregation("nextButton")){this.setAggregation("nextButton",new sap.m.Button({tooltip:this.getNextButtonTooltip()||r.getText("PAGINGBUTTON_NEXT"),icon:I.getIconURI("slim-arrow-down"),enabled:false,id:this.getId()+"-nextButton"}));}return this.getAggregation("nextButton");};
P.prototype._getPreviousButton=function(){if(!this.getAggregation("previousButton")){this.setAggregation("previousButton",new sap.m.Button({tooltip:this.getPreviousButtonTooltip()||r.getText("PAGINGBUTTON_PREVIOUS"),icon:I.getIconURI("slim-arrow-up"),enabled:false,id:this.getId()+"-previousButton"}));}return this.getAggregation("previousButton");};
P.prototype._attachPressEvents=function(){this._getPreviousButton().attachPress(this._handlePositionChange.bind(this,false));this._getNextButton().attachPress(this._handlePositionChange.bind(this,true));};
P.prototype._handlePositionChange=function(i){var o=this.getPosition(),n=i?o+1:o-1;this.setPosition(n);this.firePositionChange({newPosition:n,oldPosition:o});this._updateButtonState();return this;};
P.prototype._updateButtonState=function(){var t=this.getCount(),c=this.getPosition();this._getPreviousButton().setEnabled(c>1);this._getNextButton().setEnabled(c<t);return this;};
P.prototype.setPosition=function(p){return this._validateProperty("position",p);};
P.prototype.setCount=function(c){return this._validateProperty("count",c);};
P.prototype.setPreviousButtonTooltip=function(t){this._getPreviousButton().setTooltip(t);return this.setProperty("previousButtonTooltip",t,true);};
P.prototype.setNextButtonTooltip=function(t){this._getNextButton().setTooltip(t);return this.setProperty("nextButtonTooltip",t,true);};
P.prototype._validateProperty=function(p,v){if(v<1){q.sap.log.warning("Property '"+p+"' must be greater or equal to 1",this);return this;}return this.setProperty(p,v);};
P.prototype._enforceValidPosition=function(p){var c=this.getCount();if(p>c){q.sap.log.warning("Property position must be less or equal to the total count");this.setPosition(c);}return this;};
return P;},true);
sap.ui.predefine('sap/m/PagingButtonRenderer',['jquery.sap.global'],function(q){"use strict";var P={};
P.render=function(r,c){var n=c._getNextButton(),p=c._getPreviousButton();r.write("<div");r.writeControlData(c);r.addClass("sapMPagingButton");r.writeClasses();r.write(">");r.renderControl(p);r.renderControl(n);r.write("</div>");};
return P;},true);
sap.ui.predefine('sap/m/Panel.designtime',[],function(){"use strict";return{aggregations:{headerToolbar:{domRef:":sap-domref > .sapMPanelHdr, :sap-domref > .sapUiDtEmptyHeader"},infoToolbar:{domRef:":sap-domref > .sapUiDtEmptyInfoToolbar"},content:{domRef:".sapMPanelContent",show:function(){this.setExpanded(true);}}}};},false);
sap.ui.predefine('sap/m/Panel',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool'],function(q,l,C,I){"use strict";
var P=C.extend("sap.m.Panel",{metadata:{library:"sap.m",properties:{headerText:{type:"string",group:"Data",defaultValue:""},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"100%"},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"auto"},expandable:{type:"boolean",group:"Appearance",defaultValue:false},expanded:{type:"boolean",group:"Appearance",defaultValue:false},expandAnimation:{type:"boolean",group:"Behavior",defaultValue:true},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:sap.m.BackgroundDesign.Translucent}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},headerToolbar:{type:"sap.m.Toolbar",multiple:false},infoToolbar:{type:"sap.m.Toolbar",multiple:false}},events:{expand:{parameters:{expand:{type:"boolean"}}}},designTime:true}});
P.prototype.init=function(){this.data("sap-ui-fastnavgroup","true",true);};
P.prototype.setWidth=function(w){this.setProperty("width",w,true);var d=this.getDomRef();if(d){d.style.width=w;}return this;};
P.prototype.setHeight=function(h){this.setProperty("height",h,true);var d=this.getDomRef();if(d){d.style.height=h;if(parseFloat(h)!=0){d.querySelector(".sapMPanelContent").style.height=h;}this._setContentHeight();}return this;};
P.prototype.onThemeChanged=function(){this._setContentHeight();};
P.prototype.setExpandable=function(e){this.setProperty("expandable",e,false);if(e&&!this.oIconCollapsed){this.oIconCollapsed=this._createIcon();}return this;};
P.prototype.setExpanded=function(e){if(e===this.getExpanded()){return this;}this.setProperty("expanded",e,true);if(!this.getExpandable()){return this;}this._getIcon().$().attr("aria-expanded",this.getExpanded());this._toggleExpandCollapse();this._toggleCssClasses();this.fireExpand({expand:e});return this;};
P.prototype.onBeforeRendering=function(){this._updateIconAriaLabelledBy();};
P.prototype.onAfterRendering=function(){var $=this.$(),a;this._setContentHeight();if(this.getExpandable()){a=this.oIconCollapsed.$();if(this.getExpanded()){a.attr("aria-expanded","true");}else{$.children(".sapMPanelExpandablePart").hide();a.attr("aria-expanded","false");}}};
P.prototype.exit=function(){if(this.oIconCollapsed){this.oIconCollapsed.destroy();this.oIconCollapsed=null;}};
P.prototype._createIcon=function(){var t=this,c=I.getIconURI("navigation-right-arrow");return I.createControlByURI({id:t.getId()+"-CollapsedImg",src:c,decorative:false,useIconTooltip:false,press:function(){t.setExpanded(!t.getExpanded());}}).addStyleClass("sapMPanelExpandableIcon");};
P.prototype._getIcon=function(){return this.oIconCollapsed;};
P.prototype._setContentHeight=function(){var a,t=this.getDomRef(),p=t&&t.querySelector(".sapMPanelContent");if(this.getHeight()==="auto"||!p){return;}a=t.clientHeight-p.offsetTop;p.style.height=a+'px';};
P.prototype._toggleExpandCollapse=function(){var o={};if(!this.getExpandAnimation()){o.duration=0;}this.$().children(".sapMPanelExpandablePart").slideToggle(o);};
P.prototype._toggleCssClasses=function(){var $=this.$();$.children(".sapMPanelWrappingDiv").toggleClass("sapMPanelWrappingDivExpanded");$.children(".sapMPanelWrappingDivTb").toggleClass("sapMPanelWrappingDivTbExpanded");$.find(".sapMPanelExpandableIcon").first().toggleClass("sapMPanelExpandableIconExpanded");};
P.prototype._updateIconAriaLabelledBy=function(){var L,a;if(!this.oIconCollapsed){return;}L=this._getLabellingElementId();a=this.oIconCollapsed.getAriaLabelledBy();if(a.indexOf(L)===-1){this.oIconCollapsed.removeAllAssociation("ariaLabelledBy");this.oIconCollapsed.addAriaLabelledBy(L);}};
P.prototype._getLabellingElementId=function(){var h=this.getHeaderToolbar(),i;if(h){i=h.getTitleId();}else{i=this.getId()+"-header";}return i;};
return P;},true);
sap.ui.predefine('sap/m/PanelRenderer',['jquery.sap.global'],function(q){"use strict";var P={};
P.render=function(r,c){this.startPanel(r,c);this.renderHeader(r,c);this.renderContent(r,c);this.endPanel(r);};
P.startPanel=function(r,c){r.write("<section");r.addClass("sapMPanel");r.addStyle("width",c.getWidth());r.addStyle("height",c.getHeight());r.writeAccessibilityState(c,{role:"form",labelledby:c._getLabellingElementId()});r.writeControlData(c);r.writeClasses();r.writeStyles();r.write(">");};
P.renderHeader=function(r,c){var i=c.getExpandable(),I=c.getExpanded(),h=c.getHeaderToolbar(),H;if(i){r.write("<header");if(h){H="sapMPanelWrappingDivTb";}else{H="sapMPanelWrappingDiv";}r.addClass(H);if(I){r.addClass(H+"Expanded");}r.writeClasses();r.write(">");var o=c._getIcon();if(I){o.addStyleClass("sapMPanelExpandableIconExpanded");}else{o.removeStyleClass("sapMPanelExpandableIconExpanded");}r.renderControl(o);}var s=c.getHeaderText();if(h){h.setDesign(sap.m.ToolbarDesign.Transparent,true);r.renderControl(h);}else if(s||i){r.write("<h1");r.addClass("sapMPanelHdr");r.writeClasses();r.writeAttribute("id",c.getId()+"-header");r.write(">");r.writeEscaped(s);r.write("</h1>");}if(i){r.write("</header>");}var a=c.getInfoToolbar();if(a){if(i){a.addStyleClass("sapMPanelExpandablePart");}a.setDesign(sap.m.ToolbarDesign.Info,true);r.renderControl(a);}};
P.renderContent=function(r,c){this.startContent(r,c);this.renderChildren(r,c.getContent());this.endContent(r);};
P.startContent=function(r,c){r.write("<div");r.addClass("sapMPanelContent");r.addClass("sapMPanelBG"+c.getBackgroundDesign());if(c.getExpandable()){r.addClass("sapMPanelExpandablePart");}r.writeClasses();r.write(">");};
P.renderChildren=function(r,c){c.forEach(r.renderControl);};
P.endContent=function(r){r.write("</div>");};
P.endPanel=function(r){r.write("</section>");};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendar',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','./PlanningCalendarRow','./library','sap/ui/unified/library','sap/ui/unified/calendar/CalendarUtils'],function(q,C,L,P,l,u,a){"use strict";
var b=C.extend("sap.m.PlanningCalendar",{metadata:{library:"sap.m",properties:{startDate:{type:"object",group:"Data"},viewKey:{type:"string",group:"Appearance",defaultValue:sap.ui.unified.CalendarIntervalType.Hour},singleSelection:{type:"boolean",group:"Misc",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},showIntervalHeaders:{type:"boolean",group:"Appearance",defaultValue:true},showEmptyIntervalHeaders:{type:"boolean",group:"Appearance",defaultValue:true},showRowHeaders:{type:"boolean",group:"Appearance",defaultValue:true},noDataText:{type:"string",group:"Misc",defaultValue:null},appointmentsReducedHeight:{type:"boolean",group:"Appearance",defaultValue:false},appointmentsVisualization:{type:"sap.ui.unified.CalendarAppointmentVisualization",group:"Appearance",defaultValue:sap.ui.unified.CalendarAppointmentVisualization.Standard},minDate:{type:"object",group:"Misc",defaultValue:null},maxDate:{type:"object",group:"Misc",defaultValue:null}},aggregations:{rows:{type:"sap.m.PlanningCalendarRow",multiple:true,singularName:"row"},views:{type:"sap.m.PlanningCalendarView",multiple:true,singularName:"view"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},toolbarContent:{type:"sap.ui.core.Control",multiple:true,singularName:"toolbarContent"},table:{type:"sap.m.Table",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.ui.unified.CalendarLegend",multiple:false}},events:{appointmentSelect:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"},multiSelect:{type:"boolean"}}},intervalSelect:{parameters:{startDate:{type:"object"},endDate:{type:"object"},subInterval:{type:"boolean"},row:{type:"sap.m.PlanningCalendarRow"}}},rowSelectionChange:{parameters:{rows:{type:"sap.m.PlanningCalendarRow[]"}}},startDateChange:{},viewChange:{}}}});
var c=sap.ui.core.Control.extend("CalendarHeader",{
metadata:{aggregations:{"toolbar":{type:"sap.m.Toolbar",multiple:false},"allCheckBox":{type:"sap.m.CheckBox",multiple:false}}},
renderer:function(R,H){R.write("<div");R.writeControlData(H);R.addClass("sapMPlanCalHead");R.writeClasses();R.write(">");var T=H.getToolbar();if(T){R.renderControl(T);}var i=H.getAllCheckBox();if(i){R.renderControl(i);}R.write("</div>");}
});
b.prototype.init=function(){this._iBreakPointTablet=sap.ui.Device.media._predefinedRangeSets[sap.ui.Device.media.RANGESETS.SAP_STANDARD_EXTENDED].points[0];this._iBreakPointDesktop=sap.ui.Device.media._predefinedRangeSets[sap.ui.Device.media.RANGESETS.SAP_STANDARD_EXTENDED].points[1];this._iBreakPointLargeDesktop=sap.ui.Device.media._predefinedRangeSets[sap.ui.Device.media.RANGESETS.SAP_STANDARD_EXTENDED].points[2];if(sap.ui.Device.system.phone||q('html').hasClass("sapUiMedia-Std-Phone")){this._iSize=0;this._iSizeScreen=0;}else if(sap.ui.Device.system.tablet||q('html').hasClass("sapUiMedia-Std-Tablet")){this._iSize=1;this._iSizeScreen=1;}else{this._iSize=2;this._iSizeScreen=2;}this._oRB=sap.ui.getCore().getLibraryResourceBundle("sap.m");var i=this.getId();this._oIntervalTypeSelect=new sap.m.Select(i+"-IntType",{maxWidth:"15rem",ariaLabelledBy:i+"-SelDescr"});this._oIntervalTypeSelect.attachEvent("change",_,this);this._oTodayButton=new sap.m.Button(i+"-Today",{text:this._oRB.getText("PLANNINGCALENDAR_TODAY"),type:sap.m.ButtonType.Transparent});this._oTodayButton.attachEvent("press",d,this);this._oHeaderToolbar=new sap.m.Toolbar(i+"-HeaderToolbar",{design:sap.m.ToolbarDesign.Transparent,content:[this._oIntervalTypeSelect,this._oTodayButton]});this._oCalendarHeader=new c(i+"-CalHead",{toolbar:this._oHeaderToolbar});this._oInfoToolbar=new sap.m.Toolbar(i+"-InfoToolbar",{height:"auto",design:sap.m.ToolbarDesign.Transparent,content:[this._oCalendarHeader,this._oTimeInterval]});var T=new sap.m.Table(i+"-Table",{infoToolbar:this._oInfoToolbar,mode:sap.m.ListMode.SingleSelectMaster,columns:[new sap.m.Column({styleClass:"sapMPlanCalRowHead"}),new sap.m.Column({width:"80%",styleClass:"sapMPlanCalAppRow",minScreenWidth:sap.m.ScreenSize.Desktop,demandPopin:true})],ariaLabelledBy:i+"-Descr"});T.attachEvent("selectionChange",n,this);this.setAggregation("table",T,true);this.setStartDate(new Date());this._resizeProxy=q.proxy(h,this);};
b.prototype.exit=function(){if(this._sResizeListener){sap.ui.core.ResizeHandler.deregister(this._sResizeListener);this._sResizeListener=undefined;}if(this._sUpdateCurrentTime){q.sap.clearDelayedCall(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}var T=this.getAggregation("table");T.removeAllItems();if(this._oTimeInterval){this._oTimeInterval._oPlanningCalendar=undefined;this._oTimeInterval.destroy();this._oTimeInterval=undefined;}if(this._oDateInterval){this._oDateInterval._oPlanningCalendar=undefined;this._oDateInterval.destroy();this._oDateInterval=undefined;}if(this._oMonthInterval){this._oMonthInterval._oPlanningCalendar=undefined;this._oMonthInterval.destroy();this._oMonthInterval=undefined;}if(this._aViews){for(var i=0;i<this._aViews.length;i++){this._aViews[i].destroy();}}if(this._oSelectAllCheckBox){this._oSelectAllCheckBox.destroy();}if(this.getToolbarContent().length==0&&this._oToolbar){this._oToolbar.destroy();this._oToolbar=undefined;}};
b.prototype.onBeforeRendering=function(){this._bBeforeRendering=true;if((!this._oTimeInterval&&!this._oDateInterval&&!this._oMonthInterval)||this._bCheckView){this.setViewKey(this.getViewKey());this._bCheckView=undefined;}t.call(this);if(this._sUpdateCurrentTime){q.sap.clearDelayedCall(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}this._bBeforeRendering=undefined;};
b.prototype.onAfterRendering=function(E){E.size={width:this.getDomRef().offsetWidth};h.call(this,E,true);if(!this._sResizeListener){this._sResizeListener=sap.ui.core.ResizeHandler.register(this,this._resizeProxy);}k.call(this,false);};
b.prototype.setStartDate=function(S){if(!S){S=new Date();}if(q.sap.equal(S,this.getStartDate())){return this;}if(!(S instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var Y=S.getFullYear();if(Y<1||Y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}var M=this.getMinDate();if(M&&M.getTime()>S.getTime()){q.sap.log.warning("StartDate < minDate -> StartDate set to minDate",this);S=new Date(M.getTime());}else{var j=this.getMaxDate();if(j&&j.getTime()<S.getTime()){q.sap.log.warning("StartDate > maxDate -> StartDate set to minDate",this);if(M){S=new Date(M.getTime());}else{S=new Date(1,0,1);S.setFullYear(1);}}}this.setProperty("startDate",S,true);if(this._oTimeInterval){this._oTimeInterval.setStartDate(new Date(S.getTime()));}if(this._oDateInterval){this._oDateInterval.setStartDate(new Date(S.getTime()));}if(this._oMonthInterval){this._oMonthInterval.setStartDate(new Date(S.getTime()));}var R=this.getRows();for(var i=0;i<R.length;i++){var D=R[i];D.getCalendarRow().setStartDate(new Date(S.getTime()));}if(this.getDomRef()){k.call(this,false);}return this;};
b.prototype.setMinDate=function(D){if(q.sap.equal(D,this.getMinDate())){return this;}var M=this.getMaxDate();if(D){if(!(D instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var Y=D.getFullYear();if(Y<1||Y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}this.setProperty("minDate",D,true);this._bNoStartDateChange=true;if(this._oTimeInterval){this._oTimeInterval.setMinDate(new Date(D.getTime()));}if(this._oDateInterval){this._oDateInterval.setMinDate(new Date(D.getTime()));}if(this._oMonthInterval){this._oMonthInterval.setMinDate(new Date(D.getTime()));}if(M&&M.getTime()<D.getTime()){q.sap.log.warning("minDate > maxDate -> maxDate set to end of the month",this);M=new Date(D.getTime());M.setMonth(M.getMonth()+1,0);M.setHours(23);M.setMinutes(59);M.setSeconds(59);M.setMilliseconds(0);this.setMaxDate(M);}this._bNoStartDateChange=undefined;var S=this.getStartDate();if(S&&S.getTime()<D.getTime()){q.sap.log.warning("StartDate < minDate -> StartDate set to minDate",this);S=new Date(D.getTime());this.setStartDate(S);}}else{this.setProperty("minDate",undefined,true);if(this._oTimeInterval){this._oTimeInterval.setMinDate();}if(this._oDateInterval){this._oDateInterval.setMinDate();}if(this._oMonthInterval){this._oMonthInterval.setMinDate();}}var T=new Date();if(D&&T.getTime()<D.getTime()){this._oTodayButton.setVisible(false);}else if(!M||T.getTime()<M.getTime()){this._oTodayButton.setVisible(true);}return this;};
b.prototype.setMaxDate=function(D){if(q.sap.equal(D,this.getMaxDate())){return this;}var M=this.getMinDate();if(D){if(!(D instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var Y=D.getFullYear();if(Y<1||Y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}this.setProperty("maxDate",D,true);this._bNoStartDateChange=true;if(this._oTimeInterval){this._oTimeInterval.setMaxDate(new Date(D.getTime()));}if(this._oDateInterval){this._oDateInterval.setMaxDate(new Date(D.getTime()));}if(this._oMonthInterval){this._oMonthInterval.setMaxDate(new Date(D.getTime()));}if(M&&M.getTime()>D.getTime()){q.sap.log.warning("maxDate < minDate -> maxDate set to begin of the month",this);M=new Date(D.getTime());M.setUTCDate(1);M.setHours(0);M.setMinutes(0);M.setSeconds(0);M.setMilliseconds(0);this.setMinDate(M);}this._bNoStartDateChange=undefined;var S=this.getStartDate();if(S&&S.getTime()>D.getTime()){q.sap.log.warning("StartDate > maxDate -> StartDate set to minDate",this);if(M){S=new Date(M.getTime());}else{S=new Date(1,0,1);S.setFullYear(1);}this.setStartDate(S);}}else{this.setProperty("maxDate",undefined,true);if(this._oTimeInterval){this._oTimeInterval.setMaxDate();}if(this._oDateInterval){this._oDateInterval.setMaxDate();}if(this._oMonthInterval){this._oMonthInterval.setMaxDate();}}var T=new Date();if(D&&T.getTime()>D.getTime()){this._oTodayButton.setVisible(false);}else if(!M||T.getTime()>M.getTime()){this._oTodayButton.setVisible(true);}return this;};
b.prototype.setViewKey=function(K){this.setProperty("viewKey",K,true);this._oIntervalTypeSelect.setSelectedKey(K);if(this._oInfoToolbar.getContent().length>1){this._oInfoToolbar.removeContent(1);}var S=this.getStartDate();var M=this.getMinDate();var j=this.getMaxDate();var V=s.call(this,K,!this._bBeforeRendering);if(!V){this._bCheckView=true;this.invalidate();}else{var I=V.getIntervalType();var D=v.call(this,V);this._bCheckView=false;switch(I){case sap.ui.unified.CalendarIntervalType.Hour:if(!this._oTimeInterval){this._oTimeInterval=new sap.ui.unified.CalendarTimeInterval(this.getId()+"-TimeInt",{startDate:new Date(S.getTime()),items:D,pickerPopup:true});this._oTimeInterval.attachEvent("startDateChange",e,this);this._oTimeInterval.attachEvent("select",f,this);this._oTimeInterval._oPlanningCalendar=this;this._oTimeInterval.getSpecialDates=function(){return this._oPlanningCalendar.getSpecialDates();};if(M){this._oTimeInterval.setMinDate(new Date(M.getTime()));}if(j){this._oTimeInterval.setMaxDate(new Date(j.getTime()));}}else if(this._oTimeInterval.getItems()!=D){this._oTimeInterval.setItems(D);}this._oInfoToolbar.addContent(this._oTimeInterval);break;case sap.ui.unified.CalendarIntervalType.Day:if(!this._oDateInterval){this._oDateInterval=new sap.ui.unified.CalendarDateInterval(this.getId()+"-DateInt",{startDate:new Date(S.getTime()),days:D,showDayNamesLine:false,pickerPopup:true});this._oDateInterval.attachEvent("startDateChange",e,this);this._oDateInterval.attachEvent("select",f,this);this._oDateInterval._oPlanningCalendar=this;this._oDateInterval.getSpecialDates=function(){return this._oPlanningCalendar.getSpecialDates();};if(M){this._oDateInterval.setMinDate(new Date(M.getTime()));}if(j){this._oDateInterval.setMaxDate(new Date(j.getTime()));}}else if(this._oDateInterval.getDays()!=D){this._oDateInterval.setDays(D);}this._oInfoToolbar.addContent(this._oDateInterval);break;case sap.ui.unified.CalendarIntervalType.Month:if(!this._oMonthInterval){this._oMonthInterval=new sap.ui.unified.CalendarMonthInterval(this.getId()+"-MonthInt",{startDate:new Date(S.getTime()),months:D,pickerPopup:true});this._oMonthInterval.attachEvent("startDateChange",e,this);this._oMonthInterval.attachEvent("select",f,this);this._oMonthInterval._oPlanningCalendar=this;this._oMonthInterval.getSpecialDates=function(){return this._oPlanningCalendar.getSpecialDates();};if(M){this._oMonthInterval.setMinDate(new Date(M.getTime()));}if(j){this._oMonthInterval.setMaxDate(new Date(j.getTime()));}}else if(this._oMonthInterval.setMonths()!=D){this._oMonthInterval.setMonths(D);}this._oInfoToolbar.addContent(this._oMonthInterval);break;default:throw new Error("Unknown IntervalType: "+I+"; "+this);}var R=this.getRows();for(var i=0;i<R.length;i++){var E=R[i];var F=E.getCalendarRow();F.setIntervalType(I);F.setIntervals(D);F.setShowSubIntervals(V.getShowSubIntervals());}if(this.getDomRef()){k.call(this,false);}}return this;};
b.prototype.setShowIntervalHeaders=function(S){this.setProperty("showIntervalHeaders",S,true);var R=this.getRows();for(var i=0;i<R.length;i++){var j=R[i];j.getCalendarRow().setShowIntervalHeaders(S);}return this;};
b.prototype.setShowEmptyIntervalHeaders=function(S){this.setProperty("showEmptyIntervalHeaders",S,true);var R=this.getRows();for(var i=0;i<R.length;i++){var j=R[i];j.getCalendarRow().setShowEmptyIntervalHeaders(S);}return this;};
b.prototype.setAppointmentsReducedHeight=function(j){this.setProperty("appointmentsReducedHeight",j,true);var R=this.getRows();for(var i=0;i<R.length;i++){var D=R[i];D.getCalendarRow().setAppointmentsReducedHeight(j);}return this;};
b.prototype.setAppointmentsVisualization=function(j){this.setProperty("appointmentsVisualization",j,true);var R=this.getRows();for(var i=0;i<R.length;i++){var D=R[i];D.getCalendarRow().setAppointmentsVisualization(j);}return this;};
b.prototype.setShowRowHeaders=function(S){this.setProperty("showRowHeaders",S,true);var T=this.getAggregation("table");T.getColumns()[0].setVisible(S);this.$().toggleClass("sapMPlanCalNoHead",!S);z.call(this);B.call(this);return this;};
b.prototype.addRow=function(R){this.addAggregation("rows",R,true);R.attachEvent("_change",A,this);var T=this.getAggregation("table");T.addItem(R.getColumnListItem());var i=R.getCalendarRow();i.setStartDate(this.getStartDate());i.setShowIntervalHeaders(this.getShowIntervalHeaders());i.setShowEmptyIntervalHeaders(this.getShowEmptyIntervalHeaders());i.setAppointmentsReducedHeight(this.getAppointmentsReducedHeight());i.setLegend(this.getLegend());i.setAppointmentsVisualization(this.getAppointmentsVisualization());i.attachEvent("select",m,this);i.attachEvent("startDateChange",e,this);i.attachEvent("leaveRow",x,this);i.attachEvent("intervalSelect",g,this);y.call(this);if(this._oTimeInterval||this._oDateInterval||this._oMonthInterval){var K=this.getViewKey();var V=s.call(this,K);var I=V.getIntervalType();var j=v.call(this,V);i.setIntervalType(I);i.setIntervals(j);i.setShowSubIntervals(V.getShowSubIntervals());}B.call(this);return this;};
b.prototype.insertRow=function(R,i){this.insertAggregation("rows",R,i);R.attachEvent("_change",A,this);var T=this.getAggregation("table");T.insertItem(R.getColumnListItem(),i,true);var j=R.getCalendarRow();j.setStartDate(this.getStartDate());j.setShowIntervalHeaders(this.getShowIntervalHeaders());j.setShowEmptyIntervalHeaders(this.getShowEmptyIntervalHeaders());j.setAppointmentsReducedHeight(this.getAppointmentsReducedHeight());j.setLegend(this.getLegend());j.setAppointmentsVisualization(this.getAppointmentsVisualization());j.attachEvent("select",m,this);j.attachEvent("startDateChange",e,this);j.attachEvent("leaveRow",x,this);j.attachEvent("intervalSelect",g,this);y.call(this);if(this._oTimeInterval||this._oDateInterval||this._oMonthInterval){var K=this.getViewKey();var V=s.call(this,K);var I=V.getIntervalType();var D=v.call(this,V);j.setIntervalType(I);j.setIntervals(D);j.setShowSubIntervals(V.getShowSubIntervals());}B.call(this);return this;};
b.prototype.removeRow=function(O){var R=this.removeAggregation("rows",O,true);R.detachEvent("_change",A,this);var T=this.getAggregation("table");T.removeItem(R.getColumnListItem(),true);var i=R.getCalendarRow();i.detachEvent("select",m,this);i.detachEvent("startDateChange",e,this);i.detachEvent("leaveRow",x,this);i.detachEvent("intervalSelect",g,this);y.call(this);B.call(this);return R;};
b.prototype.removeAllRows=function(){var R=this.removeAllAggregation("rows",true);var T=this.getAggregation("table");T.removeAllItems(true);for(var i=0;i<R.length;i++){var j=R[i];j.detachEvent("_change",A,this);var D=j.getCalendarRow();D.detachEvent("select",m,this);D.detachEvent("startDateChange",e,this);D.detachEvent("leaveRow",x,this);D.detachEvent("intervalSelect",g,this);}y.call(this);B.call(this);return R;};
b.prototype.destroyRows=function(){var i=this.destroyAggregation("rows",true);var T=this.getAggregation("table");T.destroyItems(true);y.call(this);B.call(this);return i;};
b.prototype.addToolbarContent=function(i){this.addAggregation("toolbarContent",i,true);o.call(this);return this;};
b.prototype.insertToolbarContent=function(i,I){this.insertAggregation("toolbarContent",i,I);o.call(this);return this;};
b.prototype.removeToolbarContent=function(O){var R=this.removeAggregation("toolbarContent",O,true);o.call(this);return R;};
b.prototype.removeAllToolbarContent=function(){var R=this.removeAllAggregation("toolbarContent",true);o.call(this);return R;};
b.prototype.destroyToolbarContent=function(){var i=this.destroyAggregation("toolbarContent",true);o.call(this);return i;};
b.prototype.indexOfContent=function(i){return this.indexOfToolbarContent(i);};
b.prototype.setSingleSelection=function(S){this.setProperty("singleSelection",S,true);z.call(this);B.call(this);if(S){this.selectAllRows(false);}else{y.call(this);}this.$().toggleClass("sapMPlanCalMultiSel",!S);return this;};
b.prototype.setNoDataText=function(N){this.setProperty("noDataText",N,true);var T=this.getAggregation("table");T.setNoDataText(N);return this;};
b.prototype.setLegend=function(j){this.setAssociation("legend",j,true);var R=this.getRows();for(var i=0;i<R.length;i++){var D=R[i];D.getCalendarRow().setLegend(j);}return this;};
b.prototype.addAriaLabelledBy=function(i){this.addAssociation("ariaLabelledBy",i,true);var T=this.getAggregation("table");T.addAriaLabelledBy(i);return this;};
b.prototype.removeAriaLabelledBy=function(O){this.removeAssociation("ariaLabelledBy",O,true);var T=this.getAggregation("table");T.removeAriaLabelledBy(O);return this;};
b.prototype.removeAllAriaLabelledBy=function(){this.removeAllAssociation("ariaLabelledBy",true);var T=this.getAggregation("table");T.removeAllAriaLabelledBy();T.addAriaLabelledBy(this.getId()+"-Descr");return this;};
b.prototype.invalidate=function(O){if(this._bDateRangeChanged||(O&&O instanceof sap.ui.unified.DateRange)){if(this.getDomRef()){var K=this.getViewKey();var V=s.call(this,K);var i=V.getIntervalType();switch(i){case sap.ui.unified.CalendarIntervalType.Hour:if(this._oTimeInterval){this._oTimeInterval.invalidate(arguments);}break;case sap.ui.unified.CalendarIntervalType.Day:if(this._oDateInterval){this._oDateInterval.invalidate(arguments);}break;case sap.ui.unified.CalendarIntervalType.Month:if(this._oMonthInterval){this._oMonthInterval.invalidate(arguments);}break;default:throw new Error("Unknown IntervalType: "+i+"; "+this);}}this._bDateRangeChanged=undefined;}else{if(O&&O instanceof sap.m.PlanningCalendarView){this._bCheckView=true;}C.prototype.invalidate.apply(this,arguments);}};
b.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=true;var R=this.removeAllAggregation("specialDates");return R;};
b.prototype.destroySpecialDates=function(){this._bDateRangeChanged=true;var D=this.destroyAggregation("specialDates");return D;};
b.prototype.removeAllViews=function(){this._bCheckView=true;var R=this.removeAllAggregation("views");return R;};
b.prototype.destroyViews=function(){this._bCheckView=true;var D=this.destroyAggregation("views");return D;};
b.prototype.getSelectedRows=function(){return this.getRows().filter(function(R){return R.getSelected();});};
b.prototype.selectAllRows=function(S){var R=this.getRows();if(!(S&&this.getSingleSelection())){for(var i=0;i<R.length;i++){var j=R[i];j.setSelected(S);}if(this._oSelectAllCheckBox){this._oSelectAllCheckBox.setSelected(S);}}return this;};
b.prototype.onsaphomemodifiers=function(E){if((E.metaKey||E.ctrlKey)&&!E.altKey&&!E.shiftKey){var R=this.getRows();var i=R[0];var N=new q.Event("saphome");N._bPlanningCalendar=true;i.getCalendarRow().onsaphome(N);E.preventDefault();E.stopPropagation();}};
b.prototype.onsapendmodifiers=function(E){if((E.metaKey||E.ctrlKey)&&!E.altKey&&!E.shiftKey){var R=this.getRows();var i=R[R.length-1];var N=new q.Event("sapend");N._bPlanningCalendar=true;i.getCalendarRow().onsapend(N);E.preventDefault();E.stopPropagation();}};
function _(E){this.setViewKey(E.getParameter("selectedItem").getKey());this.fireViewChange();}
function d(E){this.setStartDate(new Date());this.fireStartDateChange();}
function e(E){if(this._bNoStartDateChange){return;}var S=E.oSource.getStartDate();this.setStartDate(new Date(S.getTime()));this.fireStartDateChange();}
function f(E){var S=E.oSource.getSelectedDates();var i=new Date(S[0].getStartDate());S[0].setStartDate();var j=a._createUniversalUTCDate(i,undefined,true);var K=this.getViewKey();var V=s.call(this,K);var I=V.getIntervalType();switch(I){case sap.ui.unified.CalendarIntervalType.Hour:j.setUTCHours(j.getUTCHours()+1);break;case sap.ui.unified.CalendarIntervalType.Day:j.setUTCDate(j.getUTCDate()+1);break;case sap.ui.unified.CalendarIntervalType.Month:j.setUTCMonth(j.getUTCMonth()+1);break;default:throw new Error("Unknown IntervalType: "+I+"; "+this);}j.setUTCMilliseconds(j.getUTCMilliseconds()-1);j=a._createLocalDate(j,true);this.fireIntervalSelect({startDate:i,endDate:j,subInterval:false,row:undefined});}
function g(E){var S=E.getParameter("startDate");var i=E.getParameter("endDate");var j=E.getParameter("subInterval");var R=E.oSource._oPlanningCalendarRow;this.fireIntervalSelect({startDate:S,endDate:i,subInterval:j,row:R});}
function h(E,N){if(E.size.width<=0){return;}var R=this.getRows();var j;var i=0;var O=this._iSize;p.call(this,E.size.width);if(O!=this._iSize){var K=this.getViewKey();var V=s.call(this,K);var I=V.getIntervalType();var D=v.call(this,V);for(i=0;i<R.length;i++){j=R[i];var F=j.getCalendarRow();if(D!=F.getIntervals()){F.setIntervals(D);}else{F.handleResize();}}switch(I){case sap.ui.unified.CalendarIntervalType.Hour:if(this._oTimeInterval&&this._oTimeInterval.getItems()!=D){this._oTimeInterval.setItems(D);}break;case sap.ui.unified.CalendarIntervalType.Day:if(this._oDateInterval&&this._oDateInterval.getDays()!=D){this._oDateInterval.setDays(D);}break;case sap.ui.unified.CalendarIntervalType.Month:if(this._oMonthInterval&&this._oMonthInterval.getMonths()!=D){this._oMonthInterval.setMonths(D);}break;default:throw new Error("Unknown IntervalType: "+I+"; "+this);}z.call(this);}else if(!N){for(i=0;i<R.length;i++){j=R[i];j.getCalendarRow().handleResize();}}}
function k(U){if(this._sUpdateCurrentTime){q.sap.clearDelayedCall(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}if(U){var R=this.getRows();for(var i=0;i<R.length;i++){var j=R[i];j.getCalendarRow().updateCurrentTimeVisualization();}}var N=new Date();var S=this.getStartDate();var K=this.getViewKey();var V=s.call(this,K);var I=V.getIntervalType();var D=v.call(this,V);var T=0;var E=0;var F=0;switch(I){case sap.ui.unified.CalendarIntervalType.Hour:T=60000;E=S.getTime()-3600000;F=S.getTime()+D*3600000;break;case sap.ui.unified.CalendarIntervalType.Day:T=1800000;E=S.getTime()-3600000;F=S.getTime()+D*86400000;break;default:T=-1;break;}if(N.getTime()<=F&&N.getTime()>=E&&T>0){this._sUpdateCurrentTime=q.sap.delayedCall(T,this,k,[true]);}}
function m(E){var D=E.getParameter("appointment");var M=E.getParameter("multiSelect");var F=E.getParameter("appointments");if(!M){var R=this.getRows();for(var i=0;i<R.length;i++){var G=R[i];var H=G.getCalendarRow();if(E.oSource!=H){var I=G.getAppointments();for(var j=0;j<I.length;j++){var J=I[j];J.setSelected(false);}}}}this.fireAppointmentSelect({appointment:D,appointments:F,multiSelect:M});}
function n(E){var j=[];var R=this.getRows();for(var i=0;i<R.length;i++){var D=R[i];var F=D.getColumnListItem();var S=F.getSelected();if(D.getSelected()!=S){D.setProperty("selected",S,true);j.push(D);}}if(!this.getSingleSelection()){y.call(this);}if(j.length>0){this.fireRowSelectionChange({rows:j});}}
function o(){var T=this.getAggregation("table");if(this.getToolbarContent().length>0){if(!this._oToolbar){this._oToolbar=new sap.m.OverflowToolbar(this.getId()+"-Toolbar",{design:sap.m.ToolbarDesign.Transpaent});this._oToolbar._oPlanningCalendar=this;this._oToolbar.getContent=function(){return this._oPlanningCalendar.getToolbarContent();};}if(!T.getHeaderToolbar()){T.setHeaderToolbar(this._oToolbar);}}else if(T.getHeaderToolbar()){T.setHeaderToolbar();}this._oToolbar.invalidate();}
function p(W){if(W<this._iBreakPointTablet){this._iSize=0;}else if(W<this._iBreakPointDesktop){this._iSize=1;}else{this._iSize=2;}if(q('html').hasClass("sapUiMedia-Std-Phone")){this._iSizeScreen=0;}else if(q('html').hasClass("sapUiMedia-Std-Tablet")){this._iSizeScreen=1;}else{this._iSizeScreen=2;}}
function r(){var V=this.getViews();if(V.length==0){if(!this._aViews){this._aViews=[];var i=new sap.m.PlanningCalendarView(this.getId()+"-HourView",{key:sap.ui.unified.CalendarIntervalType.Hour,intervalType:sap.ui.unified.CalendarIntervalType.Hour,description:this._oRB.getText("PLANNINGCALENDAR_HOURS"),intervalsS:6,intervalsM:6,intervalsL:12});this._aViews.push(i);var j=new sap.m.PlanningCalendarView(this.getId()+"-DayView",{key:sap.ui.unified.CalendarIntervalType.Day,intervalType:sap.ui.unified.CalendarIntervalType.Day,description:this._oRB.getText("PLANNINGCALENDAR_DAYS"),intervalsS:7,intervalsM:7,intervalsL:14});this._aViews.push(j);var D=new sap.m.PlanningCalendarView(this.getId()+"-MonthView",{key:sap.ui.unified.CalendarIntervalType.Month,intervalType:sap.ui.unified.CalendarIntervalType.Month,description:this._oRB.getText("PLANNINGCALENDAR_MONTHS"),intervalsS:3,intervalsM:6,intervalsL:12});this._aViews.push(D);}V=this._aViews;}return V;}
function s(K,N){var V=r.call(this);var j;for(var i=0;i<V.length;i++){j=V[i];if(j.getKey()!=K){j=undefined;}else{break;}}if(!j&&!N){throw new Error("PlanningCalendarView with key "+K+"not assigned "+this);}return j;}
function t(){var V=r.call(this);var I=this._oIntervalTypeSelect.getItems();var i=0;var j;if(V.length<I.length){for(i=V.length;i<I.length;i++){j=I[i];this._oIntervalTypeSelect.removeItem(j);j.destroy();}}for(i=0;i<V.length;i++){var D=V[i];j=I[i];if(j){if(j.getKey()!=D.getKey()||j.getText()!=D.getDescription()){j.setKey(D.getKey());j.setText(D.getDescription());j.setTooltip(D.getTooltip());}}else{j=new sap.ui.core.Item(this.getId()+"-"+i,{key:D.getKey(),text:D.getDescription(),tooltip:D.getTooltip()});this._oIntervalTypeSelect.addItem(j);}}}
function v(V){var i=0;switch(this._iSize){case 0:i=V.getIntervalsS();break;case 1:i=V.getIntervalsM();break;default:i=V.getIntervalsL();break;}return i;}
function w(E){var i=E.getParameter("selected");var R=this.getRows();if(i){R=this.getRows().filter(function(j){return!j.getSelected();});}this.selectAllRows(i);this.fireRowSelectionChange({rows:R});}
function x(E){var j=E.oSource;var T=E.getParameter("type");var R=this.getRows();var D;var N;var F;var G;var i=0;var I=0;var H;for(i=0;i<R.length;i++){D=R[i];if(D.getCalendarRow()==j){I=i;break;}}switch(T){case"sapup":F=j.getFocusedAppointment();G=F.getStartDate();if(I>0){I--;}N=R[I];N.getCalendarRow().focusNearestAppointment(G);break;case"sapdown":F=j.getFocusedAppointment();G=F.getStartDate();if(I<R.length-1){I++;}N=R[I];N.getCalendarRow().focusNearestAppointment(G);break;case"saphome":if(I>0){N=R[0];H=new q.Event(T);H._bPlanningCalendar=true;N.getCalendarRow().onsaphome(H);}break;case"sapend":if(I<R.length-1){N=R[R.length-1];H=new q.Event(T);H._bPlanningCalendar=true;N.getCalendarRow().onsapend(H);}break;default:break;}}
function y(){if(this._oSelectAllCheckBox){var R=this.getRows();var S=this.getSelectedRows();if(R.length==S.length&&S.length>0){this._oSelectAllCheckBox.setSelected(true);}else{this._oSelectAllCheckBox.setSelected(false);}}}
function z(){if(this.getSingleSelection()){if(this._oCalendarHeader.getAllCheckBox()){this._oCalendarHeader.setAllCheckBox();}else if(this._oInfoToolbar.getContent().length>2){this._oInfoToolbar.removeContent(this._oSelectAllCheckBox);}}else{if(!this._oSelectAllCheckBox){this._oSelectAllCheckBox=new sap.m.CheckBox(this.getId()+"-All",{text:this._oRB.getText("COLUMNSPANEL_SELECT_ALL")});this._oSelectAllCheckBox.attachEvent("select",w,this);}if(this._iSizeScreen<2||!this.getShowRowHeaders()){var i=this._oInfoToolbar.indexOfContent(this._oSelectAllCheckBox);if(this._iSizeScreen<2){if(i<this._oInfoToolbar.getContent().length-1){this._oInfoToolbar.addContent(this._oSelectAllCheckBox);}}else if(i<0||i>1){if(i>1){this._oInfoToolbar.removeContent(this._oSelectAllCheckBox);}this._oInfoToolbar.insertContent(this._oSelectAllCheckBox,1);}}else{this._oCalendarHeader.setAllCheckBox(this._oSelectAllCheckBox);}}}
function A(E){if(E.getParameter("name")=="selected"){y.call(this);}}
function B(){var T=this.getAggregation("table");var M=T.getMode();var i;if(this.getSingleSelection()){if(!this.getShowRowHeaders()&&this.getRows().length==1){i=sap.m.ListMode.None;}else{i=sap.m.ListMode.SingleSelectMaster;}}else{i=sap.m.ListMode.MultiSelect;}if(M!=i){T.setMode(i);}}
return b;},true);
sap.ui.predefine('sap/m/PlanningCalendarRenderer',['jquery.sap.global'],function(q){"use strict";var P={};
P.render=function(r,p){var i=p.getId();var t=p.getTooltip_AsString();r.write("<div");r.writeControlData(p);r.addClass("sapMPlanCal");if(!p.getSingleSelection()){r.addClass("sapMPlanCalMultiSel");}if(!p.getShowRowHeaders()){r.addClass("sapMPlanCalNoHead");}if(t){r.writeAttributeEscaped('title',t);}var w=p.getWidth();if(w){r.addStyle("width",w);}var h=p.getHeight();if(h){r.addStyle("height",h);}r.writeAccessibilityState(p);r.writeClasses();r.writeStyles();r.write(">");var T=p.getAggregation("table");r.renderControl(T);var a=p._oRB.getText("PLANNINGCALENDAR");r.write("<span id=\""+i+"-Descr\" class=\"sapUiInvisibleText\">"+a+"</span>");a=p._oRB.getText("PLANNINGCALENDAR_VIEW");r.write("<span id=\""+i+"-SelDescr\" class=\"sapUiInvisibleText\">"+a+"</span>");r.write("</div>");};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendarRow',['jquery.sap.global','sap/ui/core/Element','./StandardListItem','./StandardListItemRenderer','sap/ui/core/Renderer','./library','sap/ui/unified/library'],function(q,E,S,a,R,l,u){"use strict";
var P=E.extend("sap.m.PlanningCalendarRow",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Data"},text:{type:"string",group:"Data"},icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},nonWorkingDays:{type:"int[]",group:"Misc",defaultValue:null},nonWorkingHours:{type:"int[]",group:"Misc",defaultValue:null},selected:{type:"boolean",group:"Data",defaultValue:false},key:{type:"string",group:"Data",defaultValue:null}},aggregations:{appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment"},intervalHeaders:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"intervalHeader"}}}});
var C=S.extend("CalenderRowHeader",{
metadata:{associations:{parentRow:{type:"sap.m.PlanningCalendarRow",multiple:false}}},
setParentRow:function(i){this.setAssociation("parentRow",i,true);if(!i){this._oRow=undefined;}else if(typeof i=="string"){this._oRow=sap.ui.getCore().byId(i);}else{this._oRow=i;}return this;},
renderer:R.extend(a)
});
CalenderRowHeaderRenderer.openItemTag=function(r,L){r.write("<div");};
CalenderRowHeaderRenderer.closeItemTag=function(r,L){r.write("</div>");};
CalenderRowHeaderRenderer.renderTabIndex=function(r,L){};
P.prototype.init=function(){var i=this.getId();var c=new C(i+"-Head",{parentRow:this});var o=new sap.ui.unified.CalendarRow(i+"-CalRow",{checkResize:false,updateCurrentTime:false,ariaLabelledBy:i+"-Head"});o._oPlanningCalendarRow=this;o.getAppointments=function(){if(this._oPlanningCalendarRow){return this._oPlanningCalendarRow.getAppointments();}else{return[];}};o.getIntervalHeaders=function(){if(this._oPlanningCalendarRow){return this._oPlanningCalendarRow.getIntervalHeaders();}else{return[];}};this._oColumnListItem=new sap.m.ColumnListItem(this.getId()+"-CLI",{cells:[c,o]});};
P.prototype.exit=function(){this._oColumnListItem.destroy();this._oColumnListItem=undefined;};
P.prototype.setTooltip=function(t){this.setAggregation("tooltip",t,true);this._oColumnListItem.getCells()[0].setTooltip(t);return this;};
P.prototype.setTitle=function(t){this.setProperty("title",t,true);this._oColumnListItem.getCells()[0].setTitle(t);return this;};
P.prototype.setText=function(t){this.setProperty("text",t,true);this._oColumnListItem.getCells()[0].setDescription(t);if(t){this._oColumnListItem.getCells()[1].addStyleClass("sapMPlanCalRowLarge");}else{this._oColumnListItem.getCells()[1].removeStyleClass("sapMPlanCalRowLarge");}return this;};
P.prototype.setIcon=function(i){this.setProperty("icon",i,true);this._oColumnListItem.getCells()[0].setIcon(i);return this;};
P.prototype.setNonWorkingDays=function(n){this.setProperty("nonWorkingDays",n,true);this.getCalendarRow().setNonWorkingDays(n);return this;};
P.prototype.setNonWorkingHours=function(n){this.setProperty("nonWorkingHours",n,true);this.getCalendarRow().setNonWorkingHours(n);return this;};
P.prototype.invalidate=function(o){if(!o||!(o instanceof sap.ui.unified.CalendarAppointment)){E.prototype.invalidate.apply(this,arguments);}else if(this._oColumnListItem){this.getCalendarRow().invalidate(o);}};
P.prototype.removeAppointment=function(o){var r=this.removeAggregation("appointments",o,true);this.getCalendarRow().invalidate();return r;};
P.prototype.removeAllAppointments=function(){var r=this.removeAllAggregation("appointments",true);this.getCalendarRow().invalidate();return r;};
P.prototype.destroyAppointments=function(){var d=this.destroyAggregation("appointments",true);this.getCalendarRow().invalidate();return d;};
P.prototype.removeIntervalHeader=function(o){var r=this.removeAggregation("intervalHeaders",o,true);this.getCalendarRow().invalidate();return r;};
P.prototype.removeAllIntervalHeaders=function(){var r=this.removeAllAggregation("intervalHeaders",true);this.getCalendarRow().invalidate();return r;};
P.prototype.destroyIntervalHeaders=function(){var d=this.destroyAggregation("intervalHeaders",true);this.getCalendarRow().invalidate();return d;};
P.prototype.setSelected=function(s){this.setProperty("selected",s,true);this._oColumnListItem.setSelected(s);return this;};
P.prototype.getColumnListItem=function(){return this._oColumnListItem;};
P.prototype.getCalendarRow=function(){return this._oColumnListItem.getCells()[1];};
P.prototype.applyFocusInfo=function(f){this.getCalendarRow().applyFocusInfo(f);return this;};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendarView',['jquery.sap.global','sap/ui/core/Element','./StandardListItem','./StandardListItemRenderer','sap/ui/core/Renderer','./library','sap/ui/unified/library'],function(q,E,S,a,R,l,u){"use strict";
var P=E.extend("sap.m.PlanningCalendarView",{metadata:{library:"sap.m",properties:{key:{type:"string",group:"Data",defaultValue:null},intervalType:{type:"sap.ui.unified.CalendarIntervalType",group:"Appearance",defaultValue:sap.ui.unified.CalendarIntervalType.Hour},description:{type:"string",group:"Data"},intervalsS:{type:"int",group:"Appearance",defaultValue:6},intervalsM:{type:"int",group:"Appearance",defaultValue:8},intervalsL:{type:"int",group:"Appearance",defaultValue:12},showSubIntervals:{type:"boolean",group:"Appearance",defaultValue:false}}}});
return P;},true);
sap.ui.predefine('sap/m/Popover',['jquery.sap.global','./Bar','./Button','./InstanceManager','./library','sap/ui/core/Control','sap/ui/core/Popup','sap/ui/core/delegate/ScrollEnablement','sap/ui/core/theming/Parameters','sap/ui/Device'],function(q,B,a,I,l,C,P,S,b,D){"use strict";
var c=C.extend("sap.m.Popover",{metadata:{interfaces:["sap.ui.core.PopupInterface"],library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Behavior",defaultValue:sap.m.PlacementType.Right},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},title:{type:"string",group:"Appearance",defaultValue:null},modal:{type:"boolean",group:"Behavior",defaultValue:false},offsetX:{type:"int",group:"Appearance",defaultValue:0},offsetY:{type:"int",group:"Appearance",defaultValue:0},showArrow:{type:"boolean",group:"Appearance",defaultValue:true},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},contentMinWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:""},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},enableScrolling:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},verticalScrolling:{type:"boolean",group:"Misc",defaultValue:true},horizontalScrolling:{type:"boolean",group:"Misc",defaultValue:true},bounce:{type:"boolean",group:"Behavior",defaultValue:null},resizable:{type:"boolean",group:"Dimension",defaultValue:false}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},customHeader:{type:"sap.ui.core.Control",multiple:false},subHeader:{type:"sap.ui.core.Control",multiple:false},footer:{type:"sap.ui.core.Control",multiple:false},_internalHeader:{type:"sap.m.Bar",multiple:false,visibility:"hidden"},beginButton:{type:"sap.ui.core.Control",multiple:false},endButton:{type:"sap.ui.core.Control",multiple:false}},associations:{leftButton:{type:"sap.m.Button",multiple:false,deprecated:true},rightButton:{type:"sap.m.Button",multiple:false,deprecated:true},initialFocus:{type:"sap.ui.core.Control",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}}}}});
c._bIE9=(D.browser.internet_explorer&&D.browser.version<10);c._bIOS7=D.os.ios&&D.os.version>=7&&D.os.version<8&&D.browser.name==="sf";
c.prototype.init=function(){this._arrowOffsetThreshold=4;this._marginTopInit=false;this._marginTop=48;this._marginLeft=10;this._marginRight=10;this._marginBottom=10;this._$window=q(window);this._initialWindowDimensions={width:this._$window.width(),height:this._$window.height()};this.oPopup=new P();this.oPopup.setShadow(true);this.oPopup.setAutoClose(true);this.oPopup.setAnimations(q.proxy(this._openAnimation,this),q.proxy(this._closeAnimation,this));this._placements=[sap.m.PlacementType.Top,sap.m.PlacementType.Right,sap.m.PlacementType.Bottom,sap.m.PlacementType.Left,sap.m.PlacementType.Vertical,sap.m.PlacementType.Horizontal,sap.m.PlacementType.Auto,sap.m.PlacementType.VerticalPreferedTop,sap.m.PlacementType.VerticalPreferedBottom,sap.m.PlacementType.HorizontalPreferedLeft,sap.m.PlacementType.HorizontalPreferedRight,sap.m.PlacementType.VerticalPreferredTop,sap.m.PlacementType.VerticalPreferredBottom,sap.m.PlacementType.HorizontalPreferredLeft,sap.m.PlacementType.HorizontalPreferredRight,sap.m.PlacementType.PreferredRightOrFlip,sap.m.PlacementType.PreferredLeftOrFlip,sap.m.PlacementType.PreferredTopOrFlip,sap.m.PlacementType.PreferredBottomOrFlip];this._myPositions=["center bottom","begin center","center top","end center"];this._atPositions=["center top","end center","center bottom","begin center"];this._offsets=["0 -18","18 0","0 18","-18 0"];this._arrowOffset=18;this._followOfTolerance=32;this._scrollContentList=[sap.m.NavContainer,sap.m.Page,sap.m.ScrollContainer];this._fnAdjustPositionAndArrow=q.proxy(this._adjustPositionAndArrow,this);this._fnOrientationChange=q.proxy(this._onOrientationChange,this);this._fnFollowOf=q.proxy(function(i){var L=i.lastOfRect,r=i.currentOfRect;if(!D.system.desktop||(Math.abs(L.top-r.top)<=this._followOfTolerance&&Math.abs(L.left-r.left)<=this._followOfTolerance)||(Math.abs(L.top+L.height-r.top-r.height)<=this._followOfTolerance&&Math.abs(L.left+L.width-r.left-r.width)<=this._followOfTolerance)){this.oPopup._applyPosition(this.oPopup._oLastPosition,true);}else{this.close();}},this);this.setFollowOf(true);this._oRestoreFocusDelegate={onBeforeRendering:function(){var A=q(document.activeElement),o=A.control(0);this._sFocusControlId=o&&o.getId();},onAfterRendering:function(){if(this._sFocusControlId&&!q.sap.containsOrEquals(this.getDomRef(),document.activeElement)){sap.ui.getCore().byId(this._sFocusControlId).focus();}}};var t=this;this.oPopup._applyPosition=function(p,f){var e=this.getOpenState(),o;if(e===sap.ui.core.OpenState.CLOSING||e===sap.ui.core.OpenState.CLOSED){return;}if(f){t._storeScrollPosition();}t._clearCSSStyles();var i=q.inArray(t.getPlacement(),t._placements);if(i>3&&!t._bPosCalced){t._calcPlacement();return;}t._bPosCalced=false;if(t._oOpenBy instanceof sap.ui.core.Element){p.of=t._getOpenByDomRef();}if(!p.of){q.sap.log.warning("sap.m.Popover: in function applyPosition, the openBy element doesn't have any DOM output. "+t);return;}if(!q.sap.containsOrEquals(document.documentElement,p.of)&&p.of.id){o=q.sap.byId(p.of.id);if(o){p.of=o;}else{q.sap.log.warning("sap.m.Popover: in function applyPosition, the openBy element's DOM is already detached from DOM tree and can't be found again by the same id. "+t);return;}}var r=q(p.of).rect();if(f&&t._$window.height()==t._initialWindowDimensions.height&&(r.top+r.height<=0||r.top>=t._$window.height()||r.left+r.width<=0||r.left>=t._$window.width())){t.close();return;}var s=t.getDomRef("scroll");if(!D.system.desktop){q(window).scrollLeft(0);}t._deregisterContentResizeHandler();P.prototype._applyPosition.call(this,p);t._fnAdjustPositionAndArrow();t._restoreScrollPosition();t._registerContentResizeHandler(s);};this.oPopup.close=function(d){var e=typeof d==="boolean";if(d!==true&&(this.touchEnabled||!this._isFocusInsidePopup())&&this.isOpen()){t.fireBeforeClose({openBy:t._oOpenBy});}t._deregisterContentResizeHandler();P.prototype.close.apply(this,e?[]:arguments);t.removeDelegate(t._oRestoreFocusDelegate);if(document.activeElement&&!this.restoreFocus&&!this._bModal&&!D.system.tablet){document.activeElement.blur();}};};
c.prototype.onBeforeRendering=function(){var n,p;if(!this._bVScrollingEnabled&&!this._bHScrollingEnabled&&this._hasSingleScrollableContent()){this._forceDisableScrolling=true;q.sap.log.info("VerticalScrolling and horizontalScrolling in sap.m.Popover with ID "+this.getId()+" has been disabled because there's scrollable content inside");}else{this._forceDisableScrolling=false;}if(!this._forceDisableScrolling){if(!this._oScroller){this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:this.getHorizontalScrolling(),vertical:this.getVerticalScrolling()});}}if(this._bContentChanged){this._bContentChanged=false;n=this._getSingleNavContent();p=this._getSinglePageContent();if(n&&!this.getModal()&&!D.support.touch&&!q.sap.simulateMobileOnDesktop){n.attachEvent("afterNavigate",function(e){q.sap.focus(this.getDomRef());},this);}if(n||p){p=p||n.getCurrentPage();if(p&&p._getAnyHeader){this.addStyleClass("sapMPopoverWithHeaderCont");}if(n){n.attachEvent("navigate",function(e){var o=e.getParameter("to");if(o instanceof sap.m.Page){this.$().toggleClass("sapMPopoverWithHeaderCont",!!o._getAnyHeader());}},this);}}}};
c.prototype.onAfterRendering=function(){var $,d,e;if(!this._marginTopInit&&this.getShowArrow()){this._marginTop=2;if(this._oOpenBy){$=q(this._getOpenByDomRef());if(!($.closest("header.sapMIBar").length>0)){d=$.closest(".sapMPage");if(d.length>0){e=d.children("header.sapMIBar");if(e.length>0){this._marginTop+=e.outerHeight();}}}this._marginTopInit=true;}}};
c.prototype.exit=function(){this._deregisterContentResizeHandler();D.resize.detachHandler(this._fnOrientationChange);I.removePopoverInstance(this);this.removeDelegate(this._oRestoreFocusDelegate);this._oRestoreFocusDelegate=null;if(this.oPopup){this.oPopup.detachClosed(this._handleClosed,this);this.oPopup.destroy();this.oPopup=null;}if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._internalHeader){this._internalHeader.destroy();this._internalHeader=null;}if(this._headerTitle){this._headerTitle.destroy();this._headerTitle=null;}};
c.prototype.openBy=function(o,s){var p=this.oPopup,e=this.oPopup.getOpenState(),f=this._getInitialFocusId(),d,i,F,g;d=(o.getDomRef&&o.getDomRef())||o;g=q(d).closest(".sapUiSizeCompact");F=b.get("sapMPopoverForceCompactArrowOffset")==="true";this._bSizeCompact=sap.m._bSizeCompact||!!g.length||this.hasStyleClass("sapUiSizeCompact");this._bUseCompactArrow=this._bSizeCompact||F;this._adaptPositionParams();if(e===sap.ui.core.OpenState.OPEN||e===sap.ui.core.OpenState.OPENING){if(this._oOpenBy===o){return this;}else{var h=function(){p.detachClosed(h,this);this.openBy(o);};p.attachClosed(h,this);this.close();return this;}}if(!o){return this;}if(D.support.touch){D.resize.attachHandler(this._fnOrientationChange);}if(!this._oOpenBy||o!==this._oOpenBy){this._oOpenBy=o;}this.fireBeforeOpen({openBy:this._oOpenBy});p.attachOpened(this._handleOpened,this);p.attachClosed(this._handleClosed,this);p.setInitialFocusId(f);i=q.inArray(this.getPlacement(),this._placements);if(i>-1){d=this._getOpenByDomRef();if(!d){q.sap.log.error("sap.m.Popover id = "+this.getId()+": is opened by a control which isn't rendered yet.");return this;}p.setAutoCloseAreas([d]);p.setContent(this);if(i<=3){p.setPosition(this._myPositions[i],this._atPositions[i],d,this._calcOffset(this._offsets[i]),"fit");}else{p._oPosition.of=d;}var t=this;var j=function(){if(p.getOpenState()===sap.ui.core.OpenState.CLOSING){if(t._sOpenTimeout){clearTimeout(t._sOpenTimeout);t._sOpenTimeout=null;}t._sOpenTimeout=setTimeout(j,150);}else{t._oPreviousFocus=P.getCurrentFocusInfo();p.open();t.addDelegate(t._oRestoreFocusDelegate,t);if(!s){I.addPopoverInstance(t);}}};j();}else{q.sap.log.error(this.getPlacement()+"is not a valid value! It can only be top, right, bottom or left");}return this;};
c.prototype.close=function(){var e=this.oPopup.getOpenState(),s;if(e===sap.ui.core.OpenState.CLOSED||e===sap.ui.core.OpenState.CLOSING){return this;}this.fireBeforeClose({openBy:this._oOpenBy});this.oPopup.close(true);if(this._oPreviousFocus){s=(this._oPreviousFocus.sFocusId===sap.ui.getCore().getCurrentFocusedControlId())||(this._oPreviousFocus.sFocusId===document.activeElement.id);if(!s&&this.oPopup.restoreFocus){P.applyFocusInfo(this._oPreviousFocus);this._oPreviousFocus=null;}}return this;};
c.prototype.isOpen=function(){return this.oPopup&&this.oPopup.isOpen();};
c.prototype.setFollowOf=function(v){if(v){this.oPopup.setFollowOf(this._fnFollowOf);}else{this.oPopup.setFollowOf(false);}return this;};
c.prototype._clearCSSStyles=function(){var s=this.getDomRef().style,$=this.$("cont"),d=$.children(".sapMPopoverScroll"),o=$[0].style,e=d[0].style,f=this.getContentWidth(),g=this.getContentHeight(),h=this.$("arrow"),w,W;if(f.indexOf("%")>0){w=this._$window.width();f=sap.m.PopupHelper.calcPercentageSize(f,w);}if(g.indexOf("%")>0){W=this._$window.height();g=sap.m.PopupHelper.calcPercentageSize(g,W);}o.width=f||"";o.height=g||"";o.maxWidth="";o.maxHeight="";s.left="";s.right="";s.top="";s.bottom="";s.width="";s.height="";e.width="";e.display="";h.removeClass("sapMPopoverArrRight sapMPopoverArrLeft sapMPopoverArrDown sapMPopoverArrUp sapMPopoverCrossArr sapMPopoverFooterAlignArr sapMPopoverHeaderAlignArr sapContrast sapContrastPlus");h.css({left:"",top:""});};
c.prototype._onOrientationChange=function(){var e=this.oPopup.getOpenState();if(!(e===sap.ui.core.OpenState.OPEN||e===sap.ui.core.OpenState.OPENING)){return;}this.oPopup._applyPosition(this.oPopup._oLastPosition,true);};
c.prototype._handleOpened=function(){var t=this;this.oPopup.detachOpened(this._handleOpened,this);if(!D.support.touch){setTimeout(function(){D.resize.attachHandler(t._fnOrientationChange);},0);}var f=this._getInitialFocusId(),o=sap.ui.getCore().byId(f);q.sap.focus(o?o.getFocusDomRef():q.sap.domById(f));this.fireAfterOpen({openBy:this._oOpenBy});};
c.prototype._handleClosed=function(){this.oPopup.detachClosed(this._handleClosed,this);D.resize.detachHandler(this._fnOrientationChange);I.removePopoverInstance(this);this.fireAfterClose({openBy:this._oOpenBy});};
c.prototype.onfocusin=function(e){var s=e.target,$=this.$();if(s.id===this.getId()+"-firstfe"){var L=$.lastFocusableDomRef();q.sap.focus(L);}else if(s.id===this.getId()+"-lastfe"){var f=$.firstFocusableDomRef();q.sap.focus(f);}};
c.prototype.onkeydown=function(e){var k=q.sap.KeyCodes,K=e.which||e.keyCode,A=e.altKey;if(K===k.ESCAPE||(A&&K===k.F4)){if(e.originalEvent&&e.originalEvent._sapui_handledByControl){return;}this.close();e.stopPropagation();e.preventDefault();}};
c.prototype.onmousedown=function(E){var m={width:400,height:128};var r=sap.ui.getCore().getConfiguration().getRTL();if(!E.target.classList.contains("sapMPopoverResizeHandle")){return;}var $=q(document);var d=this.$();var t=this;d.addClass('sapMPopoverResizing');E.preventDefault();E.stopPropagation();var i={x:E.pageX,y:E.pageY,width:d.width(),height:d.height()};$.on("mousemove.sapMPopover",function(e){var w,h;if(r){w=i.width+i.x-e.pageX;h=i.height+(i.y-e.pageY);}else{w=i.width+e.pageX-i.x;h=i.height+(i.y-e.pageY);}t.setContentWidth(Math.max(w,m.width)+'px');t.setContentHeight(Math.max(h,m.height)+'px');});$.on("mouseup.sapMPopover",function(){d.removeClass("sapMPopoverResizing");$.off("mouseup.sapMPopover, mousemove.sapMPopover");});};
c.prototype._hasSingleNavContent=function(){return!!this._getSingleNavContent();};
c.prototype._getSingleNavContent=function(){var d=this._getAllContent();while(d.length===1&&d[0]instanceof sap.ui.core.mvc.View){d=d[0].getContent();}if(d.length===1&&d[0]instanceof sap.m.NavContainer){return d[0];}else{return null;}};
c.prototype._getSinglePageContent=function(){var d=this._getAllContent();while(d.length===1&&d[0]instanceof sap.ui.core.mvc.View){d=d[0].getContent();}if(d.length===1&&d[0]instanceof sap.m.Page){return d[0];}else{return null;}};
c.prototype._hasSinglePageContent=function(){var d=this._getAllContent();while(d.length===1&&d[0]instanceof sap.ui.core.mvc.View){d=d[0].getContent();}if(d.length===1&&d[0]instanceof sap.m.Page){return true;}else{return false;}};
c.prototype._hasSingleScrollableContent=function(){var d=this._getAllContent(),i;while(d.length===1&&d[0]instanceof sap.ui.core.mvc.View){d=d[0].getContent();}if(d.length===1){for(i=0;i<this._scrollContentList.length;i++){if(d[0]instanceof this._scrollContentList[i]){return true;}}return false;}else{return false;}};
c.prototype._getOffsetX=function(){var f=this.getPlacement(),F=0;if(this._bHorizontalFlip){var p=this._getOpenByDomRef();var h=p!==undefined;var i=h?p.getBoundingClientRect().width:0;F=f==="PreferredRightOrFlip"?Math.abs(i):-Math.abs(i);}var r=sap.ui.getCore().getConfiguration().getRTL();return F*(r?-1:1)+this.getOffsetX()*(r?-1:1);};
c.prototype._getOffsetY=function(){var f=this.getPlacement(),F=0;if(this._bVerticalFlip){var p=this._getOpenByDomRef();var h=p!==undefined;var i=h?p.getBoundingClientRect().height:0;F=f==="PreferredTopOrFlip"?-Math.abs(i):Math.abs(i);}return F+this.getOffsetY();};
c.prototype._calcOffset=function(o){var O=this._getOffsetX(),i=this._getOffsetY();var p=o.split(" ");return(parseInt(p[0],10)+O)+" "+(parseInt(p[1],10)+i);};
c.prototype._calcPlacement=function(){var p=this.getPlacement();var o=this._getOpenByDomRef();switch(p){case sap.m.PlacementType.Auto:this._calcAuto();break;case sap.m.PlacementType.Vertical:case sap.m.PlacementType.VerticalPreferedTop:case sap.m.PlacementType.VerticalPreferredTop:case sap.m.PlacementType.VerticalPreferedBottom:case sap.m.PlacementType.VerticalPreferredBottom:case sap.m.PlacementType.PreferredTopOrFlip:case sap.m.PlacementType.PreferredBottomOrFlip:this._calcVertical();break;case sap.m.PlacementType.Horizontal:case sap.m.PlacementType.HorizontalPreferedLeft:case sap.m.PlacementType.HorizontalPreferredLeft:case sap.m.PlacementType.HorizontalPreferedRight:case sap.m.PlacementType.HorizontalPreferredRight:case sap.m.PlacementType.PreferredRightOrFlip:case sap.m.PlacementType.PreferredLeftOrFlip:this._calcHorizontal();break;}this._bPosCalced=true;var i=q.inArray(this._oCalcedPos,this._placements);this.oPopup.setPosition(this._myPositions[i],this._atPositions[i],o,this._calcOffset(this._offsets[i]),"fit");};
c.prototype._getDocHeight=function(){var d=document.body,h=document.documentElement;return Math.max(d.scrollHeight,d.offsetHeight,h.clientHeight,h.scrollHeight,h.offsetHeight);};
c.prototype._calcVertical=function(){var $=q(this._getOpenByDomRef());var h=$[0]!==undefined;var p=this.getPlacement()===sap.m.PlacementType.VerticalPreferedTop||this.getPlacement()===sap.m.PlacementType.VerticalPreferredTop;var d=this.getPlacement()===sap.m.PlacementType.VerticalPreferedBottom||this.getPlacement()===sap.m.PlacementType.VerticalPreferredBottom;var e=this.getPlacement()===sap.m.PlacementType.PreferredTopOrFlip;var f=this.getPlacement()===sap.m.PlacementType.PreferredBottomOrFlip;var i=h?$[0].getBoundingClientRect().top:0;var g=h?$[0].getBoundingClientRect().height:0;var o=this._getOffsetY();var t=i-this._marginTop+o;var j=this.$().outerHeight();var k=this._getDocHeight()-($.offset().top+g+this._marginBottom+o);if(p&&t>j+this._arrowOffset){this._bVerticalFlip=false;this._oCalcedPos=sap.m.PlacementType.Top;}else if(e){if(t>j+this._arrowOffset){this._bVerticalFlip=false;this._oCalcedPos=sap.m.PlacementType.Top;}else{this._bVerticalFlip=true;this._oCalcedPos=sap.m.PlacementType.Bottom;}}else if(d&&k>j+this._arrowOffset){this._oCalcedPos=sap.m.PlacementType.Bottom;this._bVerticalFlip=false;}else if(f){if(k>j+this._arrowOffset){this._bVerticalFlip=false;this._oCalcedPos=sap.m.PlacementType.Bottom;}else{this._bVerticalFlip=true;this._oCalcedPos=sap.m.PlacementType.Top;}}else if(t>k){this._oCalcedPos=sap.m.PlacementType.Top;}else{this._oCalcedPos=sap.m.PlacementType.Bottom;}};
c.prototype._calcHorizontal=function(){var $=q(this._getOpenByDomRef());var h=$[0]!==undefined;var p=this.getPlacement()===sap.m.PlacementType.HorizontalPreferedLeft||this.getPlacement()===sap.m.PlacementType.HorizontalPreferredLeft;var d=this.getPlacement()===sap.m.PlacementType.HorizontalPreferedRight||this.getPlacement()===sap.m.PlacementType.HorizontalPreferredRight;var i=h?$[0].getBoundingClientRect().left:0;var e=h?$[0].getBoundingClientRect().width:0;var o=this._getOffsetX();var L=i-this._marginLeft+o;var f=i+e;var r=this._$window.width()-f-this._marginRight-o;var g=this.$().outerWidth();var j=this.getPlacement()===sap.m.PlacementType.PreferredLeftOrFlip;var k=this.getPlacement()===sap.m.PlacementType.PreferredRightOrFlip;var R=sap.ui.getCore().getConfiguration().getRTL();if(p&&L>g+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=R?sap.m.PlacementType.Right:sap.m.PlacementType.Left;}else if(j){if(L>g+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=R?sap.m.PlacementType.Right:sap.m.PlacementType.Left;}else{this._bHorizontalFlip=true;this._oCalcedPos=R?sap.m.PlacementType.Left:sap.m.PlacementType.Right;}}else if(d&&r>g+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=R?sap.m.PlacementType.Left:sap.m.PlacementType.Right;}else if(k){if(r>g+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=R?sap.m.PlacementType.Left:sap.m.PlacementType.Right;}else{this._bHorizontalFlip=true;this._oCalcedPos=R?sap.m.PlacementType.Right:sap.m.PlacementType.Left;}}else if(L>r){this._oCalcedPos=R?sap.m.PlacementType.Right:sap.m.PlacementType.Left;}else{this._oCalcedPos=R?sap.m.PlacementType.Left:sap.m.PlacementType.Right;}};
c.prototype._calcAuto=function(){if(this._$window.width()>this._$window.height()){if(this._checkHorizontal()){this._calcHorizontal();}else if(this._checkVertical()){this._calcVertical();}else{this._calcBestPos();}}else{if(this._checkVertical()){this._calcVertical();}else if(this._checkHorizontal()){this._calcHorizontal();}else{this._calcBestPos();}}};
c.prototype._checkHorizontal=function(){var $=q(this._getOpenByDomRef());var h=$[0]!==undefined;var p=h?$[0].getBoundingClientRect().left:0;var i=h?$[0].getBoundingClientRect().width:0;var o=this._getOffsetX();var L=p-this._marginLeft+o;var d=p+i;var r=this._$window.width()-d-this._marginRight-o;var e=this.$();var w=e.outerWidth()+this._arrowOffset;if((w<=L)||(w<=r)){return true;}};
c.prototype._checkVertical=function(){var $=q(this._getOpenByDomRef());var h=$[0]!==undefined;var p=h?$[0].getBoundingClientRect().top:0;var i=h?$[0].getBoundingClientRect().height:0;var o=this._getOffsetY();var t=p-this._marginTop+o;var d=this._getDocHeight()-$.offset().top-i-this._marginBottom-o;var e=this.$();var H=e.outerHeight()+this._arrowOffset;if((H<=t)||(H<=d)){return true;}};
c.prototype._calcBestPos=function(){var $=this.$();var h=$.outerHeight();var w=$.outerWidth();var r=sap.ui.getCore().getConfiguration().getRTL();var d=q(this._getOpenByDomRef());var H=d[0]!==undefined;var p=H?d[0].getBoundingClientRect().left:0;var i=H?d[0].getBoundingClientRect().top:0;var e=H?d[0].getBoundingClientRect().width:0;var f=H?d[0].getBoundingClientRect().height:0;var o=this._getOffsetX();var O=this._getOffsetY();var t=i-this._marginTop+O;var g=this._getDocHeight()-d.offset().top-f-this._marginBottom-O;var L=p-this._marginLeft+o;var j=p+e;var R=this._$window.width()-j-this._marginRight-o;var k=h*w;var A;var m;if((this._$window.height()-this._marginTop-this._marginBottom)>=h){A=h;}else{A=this._$window.height()-this._marginTop-this._marginBottom;}if((this._$window.width()-this._marginLeft-this._marginRight)>=w){m=w;}else{m=this._$window.width()-this._marginLeft-this._marginRight;}var n=(A*(L))/k;var s=(A*(R))/k;var T=(m*(t))/k;var u=(m*(g))/k;var M=Math.max(n,s);var v=Math.max(T,u);if(M>v){if(M===n){this._oCalcedPos=r?sap.m.PlacementType.Right:sap.m.PlacementType.Left;}else if(M===s){this._oCalcedPos=r?sap.m.PlacementType.Left:sap.m.PlacementType.Right;}}else if(v>M){if(v===T){this._oCalcedPos=sap.m.PlacementType.Top;}else if(v===u){this._oCalcedPos=sap.m.PlacementType.Bottom;}}else if(v===M){if(this._$window.height()>this._$window.width()){if(v===T){this._oCalcedPos=sap.m.PlacementType.Top;}else if(v===u){this._oCalcedPos=sap.m.PlacementType.Bottom;}}else{if(M===n){this._oCalcedPos=r?sap.m.PlacementType.Right:sap.m.PlacementType.Left;}else if(M===s){this._oCalcedPos=r?sap.m.PlacementType.Left:sap.m.PlacementType.Right;}}}};
c.outerWidth=function(e,i){if(typeof window.SVGElement!=="undefined"&&e instanceof window.SVGElement){return e.getBoundingClientRect().width;}return q(e).outerWidth(!!i);};
c.outerHeight=function(e,i){if(typeof window.SVGElement!=="undefined"&&e instanceof window.SVGElement){return e.getBoundingClientRect().height;}return q(e).outerHeight(!!i);};
c.prototype._getPositionParams=function($,d,e,f){var o=window.getComputedStyle($[0]),g=window.getComputedStyle(e[0]),p={};p._$popover=$;p._$parent=q(this._getOpenByDomRef());p._$arrow=d;p._$content=e;p._$scrollArea=f;p._$header=$.children(".sapMPopoverHeader");p._$subHeader=$.children(".sapMPopoverSubHeader");p._$footer=$.children(".sapMPopoverFooter");p._fWindowTop=this._$window.scrollTop();p._fWindowRight=this._$window.width();p._fWindowBottom=(c._bIOS7&&D.orientation.landscape&&window.innerHeight)?window.innerHeight:this._$window.height();p._fWindowLeft=this._$window.scrollLeft();p._fDocumentWidth=p._fWindowLeft+p._fWindowRight;p._fDocumentHeight=p._fWindowTop+p._fWindowBottom;p._fArrowHeight=d.outerHeight(true);p._fWidth=c.outerWidth($[0]);p._fHeight=c.outerHeight($[0]);p._fHeaderHeight=p._$header.length>0?p._$header.outerHeight(true):0;p._fSubHeaderHeight=p._$subHeader.length>0?p._$subHeader.outerHeight(true):0;p._fFooterHeight=p._$footer.length>0?p._$footer.outerHeight(true):0;p._fOffset=$.offset();p._fOffsetX=this._getOffsetX();p._fOffsetY=this._getOffsetY();p._fMarginTop=p._fWindowTop+this._marginTop;p._fMarginRight=this._marginRight;p._fMarginBottom=this._marginBottom;p._fMarginLeft=p._fWindowLeft+this._marginLeft;p._fPopoverBorderTop=parseFloat(o.borderTopWidth);p._fPopoverBorderRight=parseFloat(o.borderRightWidth);p._fPopoverBorderBottom=parseFloat(o.borderBottomWidth);p._fPopoverBorderLeft=parseFloat(o.borderLeftWidth);p._fContentMarginTop=parseFloat(g.marginTop);p._fContentMarginBottom=parseFloat(g.marginBottom);return p;};
c.prototype._recalculateMargins=function(s,p){var r=sap.ui.getCore().getConfiguration().getRTL();switch(s){case sap.m.PlacementType.Left:if(r){p._fMarginLeft=p._$parent.offset().left+c.outerWidth(p._$parent[0],false)+this._arrowOffset-p._fOffsetX;}else{p._fMarginRight=p._fDocumentWidth-p._$parent.offset().left+this._arrowOffset-p._fOffsetX;}break;case sap.m.PlacementType.Right:if(r){p._fMarginRight=p._fDocumentWidth-p._$parent.offset().left+this._arrowOffset-p._fOffsetX;}else{p._fMarginLeft=p._$parent.offset().left+c.outerWidth(p._$parent[0],false)+this._arrowOffset+p._fOffsetX;}break;case sap.m.PlacementType.Top:p._fMarginBottom=p._fDocumentHeight-p._$parent.offset().top+this._arrowOffset-p._fOffsetY;break;case sap.m.PlacementType.Bottom:p._fMarginTop=p._$parent.offset().top+c.outerHeight(p._$parent[0],false)+this._arrowOffset+p._fOffsetY;break;}};
c.prototype._getPopoverPositionCss=function(p){var L,r,t,i,d=p._fDocumentWidth-p._fOffset.left-p._fWidth,e=p._fDocumentHeight-p._fOffset.top-p._fHeight,E=(p._fDocumentWidth-p._fMarginRight-p._fMarginLeft)<p._fWidth,f=(p._fDocumentHeight-p._fMarginTop-p._fMarginBottom)<p._fHeight,o=p._fOffset.left<p._fMarginLeft,O=d<p._fMarginRight,g=p._fOffset.top<p._fMarginTop,h=e<p._fMarginBottom,R=sap.ui.getCore().getConfiguration().getRTL();if(E){L=p._fMarginLeft;r=p._fMarginRight;}else{if(o){L=p._fMarginLeft;if(R){r="";}}else if(O){r=p._fMarginRight;L="";}}if(f){t=p._fMarginTop;i=p._fMarginBottom;}else{if(g){t=p._fMarginTop;}else if(h){i=p._fMarginBottom;t="";}}return{top:t,bottom:i-p._fWindowTop,left:L,right:typeof r==="number"?r-p._fWindowLeft:r};};
c.prototype._getContentDimensionsCss=function(p){var o={},A=p._$content.height(),m=this._getMaxContentWidth(p),M=this._getMaxContentHeight(p);M=Math.max(M,0);o["max-width"]=m+"px";if(this.getContentHeight()||(A>M)){o["height"]=Math.min(M,A)+"px";}else{o["height"]="";o["max-height"]=M+"px";}return o;};
c.prototype._getMaxContentWidth=function(p){return p._fDocumentWidth-p._fMarginLeft-p._fMarginRight-p._fPopoverBorderLeft-p._fPopoverBorderRight;};
c.prototype._getMaxContentHeight=function(p){return p._fDocumentHeight-p._fMarginTop-p._fMarginBottom-p._fHeaderHeight-p._fSubHeaderHeight-p._fFooterHeight-p._fContentMarginTop-p._fContentMarginBottom-p._fPopoverBorderTop-p._fPopoverBorderBottom;};
c.prototype._isHorizontalScrollbarNeeded=function(p){return this.getHorizontalScrolling()&&(p._$scrollArea.outerWidth(true)<=p._$content.width());};
c.prototype._getArrowOffsetCss=function(s,p){var i,r=sap.ui.getCore().getConfiguration().getRTL();p._fWidth=p._$popover.outerWidth();p._fHeight=p._$popover.outerHeight();if(s===sap.m.PlacementType.Left||s===sap.m.PlacementType.Right){i=p._$parent.offset().top-p._$popover.offset().top-p._fPopoverBorderTop+p._fOffsetY+0.5*(c.outerHeight(p._$parent[0],false)-p._$arrow.outerHeight(false));i=Math.max(i,this._arrowOffsetThreshold);i=Math.min(i,p._fHeight-this._arrowOffsetThreshold-p._$arrow.outerHeight());return{"top":i};}else if(s===sap.m.PlacementType.Top||s===sap.m.PlacementType.Bottom){if(r){i=p._$popover.offset().left+c.outerWidth(p._$popover[0],false)-(p._$parent.offset().left+c.outerWidth(p._$parent[0],false))+p._fPopoverBorderRight+p._fOffsetX+0.5*(c.outerWidth(p._$parent[0],false)-p._$arrow.outerWidth(false));i=Math.max(i,this._arrowOffsetThreshold);i=Math.min(i,p._fWidth-this._arrowOffsetThreshold-p._$arrow.outerWidth(false));return{"right":i};}else{i=p._$parent.offset().left-p._$popover.offset().left-p._fPopoverBorderLeft+p._fOffsetX+0.5*(c.outerWidth(p._$parent[0],false)-p._$arrow.outerWidth(false));i=Math.max(i,this._arrowOffsetThreshold);i=Math.min(i,p._fWidth-this._arrowOffsetThreshold-p._$arrow.outerWidth(false));return{"left":i};}}};
c.prototype._getArrowPositionCssClass=function(s){switch(s){case sap.m.PlacementType.Left:return"sapMPopoverArrRight";case sap.m.PlacementType.Right:return"sapMPopoverArrLeft";case sap.m.PlacementType.Top:return"sapMPopoverArrDown";case sap.m.PlacementType.Bottom:return"sapMPopoverArrUp";}};
c.prototype._getArrowStyleCssClass=function(p){var A=p._$arrow.position(),f=p._$footer.position(),n=this._getSingleNavContent(),o=this._getSinglePageContent(),i=0;if(n||o){o=o||n.getCurrentPage();if(o){i=o._getAnyHeader().$().outerHeight();}}if((A.top+p._fArrowHeight)<(p._fHeaderHeight+p._fSubHeaderHeight)||((A.top+p._fArrowHeight)<i)){return"sapMPopoverHeaderAlignArr";}else if((A.top<(p._fHeaderHeight+p._fSubHeaderHeight))||(A.top<i)||(p._$footer.length&&((A.top+p._fArrowHeight)>f.top)&&(A.top<f.top))){return"sapMPopoverCrossArr";}else if(p._$footer.length&&(A.top>f.top)){return"sapMPopoverFooterAlignArr";}};
c.prototype._getCalculatedPlacement=function(){return this._oCalcedPos||this.getPlacement();};
c.prototype._adjustPositionAndArrow=function(){var e=this.oPopup.getOpenState();if(!(e===sap.ui.core.OpenState.OPEN||e===sap.ui.core.OpenState.OPENING)){return;}var $=this.$(),d=this.$("arrow"),f=this.$("cont"),g=this.$("scroll"),s=this._getCalculatedPlacement(),p=this._getPositionParams($,d,f,g);this._recalculateMargins(s,p);var o=this._getPopoverPositionCss(p),h=this._getContentDimensionsCss(p),H=this._isHorizontalScrollbarNeeded(p);$.css(o);f.css(h);if(H){g.css("display","block");}if(this.getShowArrow()){var A=this._getArrowOffsetCss(s,p),i=this._getArrowPositionCssClass(s),j,u;d.removeAttr("style");d.css(A);d.addClass(i);if(s===sap.m.PlacementType.Top&&p._$footer&&p._$footer.size()){u=true;}if(s===sap.m.PlacementType.Left||s===sap.m.PlacementType.Right){j=this._getArrowStyleCssClass(p);if(j){d.addClass(j);if(j==="sapMPopoverFooterAlignArr"){u=true;}}}if(u){d.addClass("sapContrast sapContrastPlus");}$.css("overflow","visible");}this._afterAdjustPositionAndArrowHook();};
c.prototype._adaptPositionParams=function(){if(this.getShowArrow()){this._marginLeft=10;this._marginRight=10;this._marginBottom=10;this._arrowOffset=18;this._offsets=["0 -18","18 0","0 18","-18 0"];if(this._bUseCompactArrow){this._arrowOffset=9;this._offsets=["0 -9","9 0","0 9","-9 0"];}this._myPositions=["center bottom","begin center","center top","end center"];this._atPositions=["center top","end center","center bottom","begin center"];}else{this._marginTop=0;this._marginLeft=0;this._marginRight=0;this._marginBottom=0;this._arrowOffset=0;this._offsets=["0 0","0 0","0 0","0 0"];this._myPositions=["begin bottom","begin center","begin top","end center"];this._atPositions=["begin top","end center","begin bottom","begin center"];}};
c.prototype._afterAdjustPositionAndArrowHook=function(){};
c.prototype._isPopupElement=function(d){var p=this._getOpenByDomRef();return!!(q(d).closest(sap.ui.getCore().getStaticAreaRef()).length)||!!(q(d).closest(p).length);};
c.prototype._getAnyHeader=function(){if(this.getCustomHeader()){return this.getCustomHeader();}else{if(this.getShowHeader()){this._createInternalHeader();return this._internalHeader;}}};
c.prototype._createInternalHeader=function(){if(!this._internalHeader){var t=this;this._internalHeader=new B(this.getId()+"-intHeader");this.setAggregation("_internalHeader",this._internalHeader);this._internalHeader.addEventDelegate({onAfterRendering:function(){t._restoreFocus();}});return true;}else{return false;}};
c.prototype._openAnimation=function(r,R,o){var t=this;if(c._bIE9){o();}else{var O=false,T=function(){if(O||!t.oPopup||t.oPopup.getOpenState()!==sap.ui.core.OpenState.OPENING){return;}r.unbind("webkitTransitionEnd transitionend");o();O=true;};setTimeout(function(){r.addClass("sapMPopoverTransparent");r.css("display","block");setTimeout(function(){r.bind("webkitTransitionEnd transitionend",T);r.removeClass("sapMPopoverTransparent");setTimeout(function(){T();},300);},D.browser.firefox?50:0);},0);}};
c.prototype._closeAnimation=function(r,R,f){if(c._bIE9){f();}else{var d=false,t=function(){if(d){return;}r.unbind("webkitTransitionEnd transitionend");setTimeout(function(){f();d=true;r.removeClass("sapMPopoverTransparent");},0);};r.bind("webkitTransitionEnd transitionend",t).addClass("sapMPopoverTransparent");setTimeout(function(){t();},300);}};
c.prototype._getInitialFocusId=function(){return this.getInitialFocus()||this._getFirstVisibleButtonId()||this._getFirstFocusableContentElementId()||this.getId();};
c.prototype._getFirstVisibleButtonId=function(){var o=this.getBeginButton(),e=this.getEndButton(),s="";if(o&&o.getVisible()){s=o.getId();}else if(e&&e.getVisible()){s=e.getId();}return s;};
c.prototype._getFirstFocusableContentElementId=function(){var r="";var $=this.$("cont");var f=$.firstFocusableDomRef();if(f){r=f.id;}return r;};
c.prototype._restoreFocus=function(){if(this.isOpen()){var f=this._getInitialFocusId(),o=sap.ui.getCore().byId(f);q.sap.focus(o?o.getFocusDomRef():q.sap.domById(f));}};
c.prototype._registerContentResizeHandler=function(s){if(!this._sResizeListenerId){this._sResizeListenerId=sap.ui.core.ResizeHandler.register(s||this.getDomRef("scroll"),this._fnOrientationChange);}};
c.prototype._deregisterContentResizeHandler=function(){if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
c.prototype._storeScrollPosition=function(){var $=this.$("cont");if($.length>0){this._oScrollPosDesktop={x:$.scrollLeft(),y:$.scrollTop()};}};
c.prototype._restoreScrollPosition=function(){if(!this._oScrollPosDesktop){return;}var $=this.$("cont");if($.length>0){$.scrollLeft(this._oScrollPosDesktop.x).scrollTop(this._oScrollPosDesktop.y);this._oScrollPosDesktop=null;}};
c.prototype._repositionOffset=function(){var e=this.oPopup.getOpenState(),L,p;if(!(e===sap.ui.core.OpenState.OPEN)){return this;}L=this.oPopup._oLastPosition;p=q.inArray(this.getPlacement(),this._placements);if(p===-1){return this;}if(p<4){L.offset=this._calcOffset(this._offsets[p]);this.oPopup._applyPosition(L);}else{this._calcPlacement();}return this;};
c.prototype._getOpenByDomRef=function(){if(!this._oOpenBy){return null;}if(this._oOpenBy instanceof sap.ui.core.Element){return(this._oOpenBy.getPopupAnchorDomRef&&this._oOpenBy.getPopupAnchorDomRef())||this._oOpenBy.getFocusDomRef();}else{return this._oOpenBy;}};
c.prototype._getAccessibilityOptions=function(){var A,m={};m.role="dialog";if(this.getShowHeader()&&this._getAnyHeader()){A=Array.prototype.concat(this._getAnyHeader().getId(),this.getAssociation("ariaLabelledBy",[]));m.labelledby=A.join(' ');}return m;};
c.prototype.setPlacement=function(p){this.setProperty("placement",p,true);this._bVerticalFlip=false;this._bHorizontalFlip=false;var i=q.inArray(p,this._placements);if(i<=3){this._oCalcedPos=p;}return this;};
c.prototype.setTitle=function(t){if(t){this.setProperty("title",t,true);if(this._headerTitle){this._headerTitle.setText(t);}else{this._headerTitle=new sap.m.Title(this.getId()+"-title",{text:this.getTitle(),level:"H1"});this._createInternalHeader();this._internalHeader.addContentMiddle(this._headerTitle);}}return this;};
c.prototype.setBeginButton=function(o){var O=this.getBeginButton();if(O===o){return this;}this._createInternalHeader();this._beginButton=o;if(o){if(O){this._internalHeader.removeAggregation("contentLeft",O,true);}this._internalHeader.addAggregation("contentLeft",o);}else{this._internalHeader.removeContentLeft(O);}return this;};
c.prototype.setEndButton=function(o){var O=this.getEndButton();if(O===o){return this;}this._createInternalHeader();this._endButton=o;if(o){if(O){this._internalHeader.removeAggregation("contentRight",O,true);}this._internalHeader.insertAggregation("contentRight",o,1,true);this._internalHeader.invalidate();}else{this._internalHeader.removeContentRight(O);}return this;};
c.prototype.setLeftButton=function(v){if(!(v instanceof a)){v=sap.ui.getCore().byId(v);}this.setBeginButton(v);return this.setAssociation("leftButton",v);};
c.prototype.setRightButton=function(v){if(!(v instanceof a)){v=sap.ui.getCore().byId(v);}this.setEndButton(v);return this.setAssociation("rightButton",v);};
c.prototype.setShowHeader=function(v){if(v===this.getShowHeader()||this.getCustomHeader()){return this;}if(v){if(this._internalHeader){this._internalHeader.$().show();}}else{if(this._internalHeader){this._internalHeader.$().hide();}}this.setProperty("showHeader",v,true);return this;};
c.prototype.setModal=function(m,M){if(m===this.getModal()){return this;}this.oPopup.setModal(m,q.trim("sapMPopoverBLayer "+M||""));this.setProperty("modal",m,true);return this;};
c.prototype.setOffsetX=function(v){this.setProperty("offsetX",v,true);return this._repositionOffset();};
c.prototype.setOffsetY=function(v){this.setProperty("offsetY",v,true);return this._repositionOffset();};
c.prototype.setEnableScrolling=function(v){this.setHorizontalScrolling(v);this.setVerticalScrolling(v);var o=this.getEnableScrolling();if(o===v){return this;}this.setProperty("enableScrolling",v,true);return this;};
c.prototype.setVerticalScrolling=function(v){this._bVScrollingEnabled=v;var o=this.getVerticalScrolling();if(o===v){return this;}this.$().toggleClass("sapMPopoverVerScrollDisabled",!v);this.setProperty("verticalScrolling",v,true);if(this._oScroller){this._oScroller.setVertical(v);}return this;};
c.prototype.setHorizontalScrolling=function(v){this._bHScrollingEnabled=v;var o=this.getHorizontalScrolling();if(o===v){return this;}this.$().toggleClass("sapMPopoverHorScrollDisabled",!v);this.setProperty("horizontalScrolling",v,true);if(this._oScroller){this._oScroller.setHorizontal(v);}return this;};
c.prototype.setResizable=function(v){if(!D.system.desktop){v=false;}return this.setProperty("resizable",v,true);};
c.prototype.getScrollDelegate=function(){return this._oScroller;};
c.prototype.setAggregation=function(A,o,s){if(A==="beginButton"||A==="endButton"){var f="set"+A.charAt(0).toUpperCase()+A.slice(1);return this[f](o);}else{return C.prototype.setAggregation.apply(this,arguments);}};
c.prototype.getAggregation=function(A,d){if(A==="beginButton"||A==="endButton"){var s=this["_"+A];return s||d||null;}else{return C.prototype.getAggregation.apply(this,arguments);}};
c.prototype.destroyAggregation=function(A,s){var o=q(document.activeElement).control(0);if(A==="beginButton"||A==="endButton"){var d=this["_"+A];if(d){d.destroy();this["_"+A]=null;}}else{C.prototype.destroyAggregation.apply(this,arguments);}o&&o.getDomRef()?o.focus():this.focus();return this;};
c.prototype.invalidate=function(o){if(this.isOpen()){C.prototype.invalidate.apply(this,arguments);}return this;};
c.prototype.addAggregation=function(A,o,s){if(A==="content"){this._bContentChanged=true;}C.prototype.addAggregation.apply(this,arguments);};
c.prototype._getAllContent=function(){return this.getContent();};
return c;},true);
sap.ui.predefine('sap/m/PopoverRenderer',['jquery.sap.global'],function(q){"use strict";var P={};
P.render=function(r,c){var C;r.write("<div");r.writeControlData(c);C=this.generateRootClasses(c);C.forEach(function(s,i){r.addClass(s);});r.writeClasses();var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.writeAttribute("tabindex","-1");r.writeAccessibilityState(c,c._getAccessibilityOptions());r.write(">");if(c.getResizable()){r.writeIcon("sap-icon://resize-corner",["sapMPopoverResizeHandle"],{"title":""});}this.renderContent(r,c);r.write("</div>");};
P.isButtonFooter=function(f){if(f instanceof sap.m.Bar){var c=f.getContentLeft(),C=f.getContentRight(),a=f.getContentMiddle(),l=(!c||c.length===0),r=(!C||C.length===0),m=false;if(a&&a.length===2){if((a[0]instanceof sap.m.Button)&&(a[1]instanceof sap.m.Button)){m=true;}}return l&&r&&m;}else{return false;}};
P.renderContent=function(r,c){var h,I=c.getId(),i=0,a=c._getAllContent(),f=c.getFooter(),s=c.getSubHeader(),C=c.getContentWidth(),b=c.getContentMinWidth(),d=c.getContentHeight(),F="sapMPopoverFooter ";if(c.getShowHeader()){h=c._getAnyHeader();}if(sap.ui.Device.system.desktop){r.write("<span class='sapMPopoverHiddenFocusable' id='"+c.getId()+"-firstfe' tabindex='0'></span>");}if(h){if(h.applyTagAndContextClassFor){h.applyTagAndContextClassFor("header");}h.addStyleClass("sapMPopoverHeader");r.renderControl(h);}if(s){if(s.applyTagAndContextClassFor){s.applyTagAndContextClassFor("subheader");}s.addStyleClass("sapMPopoverSubHeader");r.renderControl(s);}r.write("<div");r.writeAttribute("id",I+"-cont");if(C){r.addStyle("width",C);}if(b){r.addStyle("min-width",b);}if(d){r.addStyle("height",d);}r.writeStyles();r.addClass("sapMPopoverCont");r.writeClasses();if(sap.ui.getCore().getConfiguration().getAccessibility()){r.writeAttribute("role","application");}r.write(">");r.write('<div class="sapMPopoverScroll"');r.writeAttribute("id",c.getId()+"-scroll");if(!c.getHorizontalScrolling()){r.addStyle(sap.ui.getCore().getConfiguration().getRTL()?"margin-left":"margin-right",q.sap.scrollbarSize().width+"px");}r.writeStyles();r.write(">");for(i=0;i<a.length;i++){r.renderControl(a[i]);}r.write("</div>");r.write("</div>");if(f){if(f.applyTagAndContextClassFor){f.applyTagAndContextClassFor("footer");f.addStyleClass("sapMTBNoBorders");}if(this.isButtonFooter(f)){F+="sapMPopoverSpecialFooter";}r.renderControl(f.addStyleClass(F));}if(c.getShowArrow()){r.write("<span");r.writeAttribute("id",I+"-arrow");r.addClass("sapMPopoverArr");r.writeClasses();r.write("></span>");}if(sap.ui.Device.system.desktop){r.write("<span class='sapMPopoverHiddenFocusable' id='"+c.getId()+"-lastfe' tabindex='0'></span>");}};
P.generateRootClasses=function(c){var C=["sapMPopover"],s=c.getSubHeader(),f=c.getFooter(),v=c.getVerticalScrolling()&&!c._forceDisableScrolling,h=c.getHorizontalScrolling()&&!c._forceDisableScrolling,H;if(c.getShowHeader()){H=c._getAnyHeader();}if(H){C.push("sapMPopoverWithBar");}else{C.push("sapMPopoverWithoutBar");}if(s){C.push("sapMPopoverWithSubHeader");}else{C.push("sapMPopoverWithoutSubHeader");}if(c._hasSingleNavContent()){C.push("sapMPopoverNav");}if(c._hasSinglePageContent()){C.push("sapMPopoverPage");}if(f){C.push("sapMPopoverWithFooter");}else{C.push("sapMPopoverWithoutFooter");}if(c.getPlacement()===sap.m.PlacementType.Top){C.push("sapMPopoverPlacedTop");}if(!v){C.push("sapMPopoverVerScrollDisabled");}if(!h){C.push("sapMPopoverHorScrollDisabled");}C.push("sapMPopup-CTX");if(c._bSizeCompact){C.push("sapUiSizeCompact");}return C.concat(c.aCustomStyleClasses);};
P.rerenderContentOnly=function(c){var p=c.$(),o=c.getDomRef(),C,r;if(!o){return;}p.removeClass();C=this.generateRootClasses(c);p.addClass(C.join(" "));r=sap.ui.getCore().createRenderManager();this.renderContent(r,c);r.flush(o,true);r.destroy();c._onOrientationChange();};
return P;},true);
sap.ui.predefine('sap/m/ProgressIndicator',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/ValueStateSupport'],function(q,l,C,V){"use strict";
var P=C.extend("sap.m.ProgressIndicator",{metadata:{library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},state:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:sap.ui.core.ValueState.None},displayValue:{type:"string",group:"Appearance",defaultValue:null},percentValue:{type:"float",group:"Data",defaultValue:0},showValue:{type:"boolean",group:"Appearance",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}}}});
P.prototype.setPercentValue=function(p){var t=this,$,a=this.$(),A;if(!i(p)){p=0;q.sap.log.warning(this+": percentValue ("+p+") is not correct! Setting the default percentValue:0.");}if(this.getPercentValue()!==p){this.setProperty("percentValue",p,true);if(!a.length){return this;}["sapMPIValueMax","sapMPIValueMin","sapMPIValueNormal","sapMPIValueGreaterHalf"].forEach(function(c){a.removeClass(c);});a.addClass(this._getCSSClassByPercentValue(p));a.addClass("sapMPIAnimate").attr("aria-valuenow",p).attr("aria-valuetext",this._getAriaValueText({fPercent:p}));A=Math.abs(t.getPercentValue()-p)*20;$=this.$("bar");$.animate({width:p+"%"},A,"linear",function(){t._setText.apply(t);t.$().removeClass("sapMPIAnimate");});}return this;};
P.prototype._setText=function(){this.$().toggleClass("sapMPIValueGreaterHalf",this.getPercentValue()>50);return this;};
P.prototype.setDisplayValue=function(d){this.setProperty("displayValue",d,true);var $=this.$("textLeft");var a=this.$("textRight");$.text(d);a.text(d);this.$().attr("aria-valuetext",this._getAriaValueText({sText:d}));return this;};
P.prototype._getCSSClassByPercentValue=function(p){if(p===100){return"sapMPIValueMax sapMPIValueGreaterHalf";}if(p===0){return"sapMPIValueMin";}if(p<=50){return"sapMPIValueNormal";}return"sapMPIValueNormal sapMPIValueGreaterHalf";};
P.prototype._getAriaValueText=function(p){p.sText=p.sText||this.getDisplayValue();p.fPercent=p.fPercent||this.getPercentValue();p.sStateText=p.sStateText||this._getStateText();var a=p.sText||p.fPercent+"%";if(p.sStateText){a+=" "+p.sStateText;}return a;};
P.prototype._getStateText=function(){return V.getAdditionalText(this.getState());};
P.prototype.getAccessibilityInfo=function(){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");return{role:"progressbar",type:b.getText("ACC_CTR_TYPE_PROGRESS"),description:b.getText("ACC_CTR_STATE_PROGRESS",[this.getPercentValue()]),focusable:this.getEnabled(),enabled:this.getEnabled()};};
function i(v){return(typeof(v)==='number')&&!isNaN(v)&&v>=0&&v<=100;}
return P;},true);
sap.ui.predefine('sap/m/ProgressIndicatorRenderer',['jquery.sap.global'],function(q){"use strict";var P={};
P.render=function(r,c){var p=c.getPercentValue(),w=c.getWidth(),h=c.getHeight(),s=c._getCSSClassByPercentValue(p),t=c.getDisplayValue(),S=c.getShowValue(),a=c.getState(),T=c.getTextDirection().toLowerCase(),C=c.getId();r.write("<div");r.writeControlData(c);r.addClass("sapMPI");r.addClass(s);r.addStyle("width",w);if(h){r.addStyle("height",h);}if(c.getEnabled()){r.writeAttribute('tabIndex','-1');}else{r.addClass("sapMPIBarDisabled");}r.writeClasses();r.writeStyles();r.writeAccessibilityState(c,{role:"progressbar",valuemin:0,valuenow:p,valuemax:100,valuetext:c._getAriaValueText({sText:t,fPercent:p})});if(c.getTooltip_AsString()){r.writeAttributeEscaped("title",c.getTooltip_AsString());}r.write(">");r.write("<div");r.addClass("sapMPIBar");switch(a){case sap.ui.core.ValueState.Warning:r.addClass("sapMPIBarCritical");break;case sap.ui.core.ValueState.Error:r.addClass("sapMPIBarNegative");break;case sap.ui.core.ValueState.Success:r.addClass("sapMPIBarPositive");break;default:r.addClass("sapMPIBarNeutral");break;}r.writeClasses();r.writeAttribute("id",C+"-bar");r.writeAttribute("style","width:"+p+"%");r.write(">");P._renderDisplayText(r,T,"Left",C);if(S){r.writeEscaped(t);}r.write("</span>");r.write("</div>");r.write("<div");r.addClass("sapMPIBarRemaining");r.writeAttribute("id",C+"-remainingBar");r.writeClasses();r.write(">");P._renderDisplayText(r,T,"Right",C);if(S){r.writeEscaped(t);}r.write("</span>");r.write("</div>");r.write("</div>");};
P._renderDisplayText=function(r,t,T,c){r.write("<span class='sapMPIText sapMPIText"+T+"' id='"+c+"-text"+T+"'");if(t!=="inherit"){r.writeAttribute("dir",t);}r.write('>');};
return P;},true);
sap.ui.predefine('sap/m/PullToRefresh',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/theming/Parameters'],function(q,l,C,P){"use strict";
var a=C.extend("sap.m.PullToRefresh",{metadata:{library:"sap.m",properties:{description:{type:"string",group:"Misc",defaultValue:null},showIcon:{type:"boolean",group:"Appearance",defaultValue:false},customIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true}},events:{refresh:{}}}});
a.prototype.init=function(){this._bTouchMode=sap.ui.Device.support.touch&&!sap.ui.Device.system.combi||q.sap.simulateMobileOnDesktop;this._iState=0;this.oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");};
a.prototype._loadBI=function(){if(this.getVisible()&&!this._oBusyIndicator){q.sap.require("sap.m.BusyIndicator");this._oBusyIndicator=new sap.m.BusyIndicator({size:"1.7rem",design:"auto"});this._oBusyIndicator.setParent(this);}};
a.prototype.onBeforeRendering=function(){this._loadBI();if(this._bTouchMode){q(window).off("resize.sapMP2R",this.calculateTopTrigger);var p=this.getParent();this._oScroller=p&&p.getScrollDelegate?p.getScrollDelegate():null;if(this._oScroller){this._oScroller.setBounce(true);this._oScroller.setPullDown(this.getVisible()?this:null);}}};
a.prototype.calculateTopTrigger=function(){this._iTopTrigger=1;if(this._oDomRef&&this._oDomRef.parentNode&&this._oDomRef.parentNode.parentNode&&this._oDomRef.parentNode.parentNode.offsetHeight<this._oDomRef.offsetHeight*1.5){this._iTopTrigger=this.getDomRef("T").offsetTop;}};
a.prototype.onAfterRendering=function(){this._oDomRef=this.getDomRef();if(this._bTouchMode){if(this._oScroller){this._oScroller.refresh();}if(this.getVisible()&&this._oScroller&&this._oScroller._bIScroll){q(window).on("resize.sapMP2R",q.proxy(this.calculateTopTrigger,this));this.calculateTopTrigger();}}};
a.prototype.exit=function(){if(this._bTouchMode&&this._oScroller&&this._oScroller._bIScroll){q(window).off("resize.sapMP2R",this.calculateTopTrigger);}if(this._oScroller){this._oScroller.setPullDown(null);this._oScroller=null;}if(this._oCustomImage){this._oCustomImage.destroy();this._oCustomImage=null;}if(this._oBusyIndicator){this._oBusyIndicator.destroy();this._oBusyIndicator=null;}};
a.prototype.doScrollMove=function(){if(!this._oScroller){return;}var d=this._oDomRef;var _=this._oScroller._scroller;if(_.y>-this._iTopTrigger&&this._iState<1){this.setState(1);_.minScrollY=0;}else if(_.y<-this._iTopTrigger&&this._iState==1){this.setState(0);_.minScrollY=-d.offsetHeight;}};
a.prototype.doPull=function(p){if(this._bTouchMode&&this._iState<2){this.setState(p>=-1?1:0);}};
a.prototype.doRefresh=function(){this.setState(0);};
a.prototype.doScrollEnd=function(){if(this._iState==1){this.setState(2);this.fireRefresh();}};
a.prototype.setState=function(s){if(this._iState==s){return;}this._iState=s;if(!this._oDomRef){return;}var $=this.$();var b=$.find(".sapMPullDownText");switch(s){case 0:$.toggleClass("sapMFlip",false).toggleClass("sapMLoading",false);b.html(this.oRb.getText(this._bTouchMode?"PULL2REFRESH_PULLDOWN":"PULL2REFRESH_REFRESH"));$.removeAttr("aria-live");$.find(".sapMPullDownInfo").html(q.sap.encodeHTML(this.getDescription()));break;case 1:$.toggleClass("sapMFlip",true);b.html(this.oRb.getText("PULL2REFRESH_RELEASE"));$.removeAttr("aria-live");break;case 2:$.toggleClass("sapMFlip",false).toggleClass("sapMLoading",true);this._oBusyIndicator.setVisible(true);b.html(this.oRb.getText("PULL2REFRESH_LOADING"));$.attr("aria-live","assertive");$.find(".sapMPullDownInfo").html(this._bTouchMode?this.oRb.getText("PULL2REFRESH_LOADING_LONG"):"");break;}};
a.prototype.setDescription=function(d){if(this._oDomRef){this.$().find(".sapMPullDownInfo").html(q.sap.encodeHTML(d));}return this.setProperty("description",d,true);};
a.prototype.getCustomIconImage=function(){var p={src:this.getCustomIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};var c=['sapMPullDownCIImg'];this._oCustomImage=sap.m.ImageHelper.getImageControl(null,this._oCustomImage,this,p,c);return this._oCustomImage;};
a.prototype.onclick=function(){if(!this._bTouchMode){this.setState(2);this.fireRefresh();}};
a.prototype.onkeydown=function(e){if(e.which==q.sap.KeyCodes.F5){this.onclick();e.stopPropagation();e.preventDefault();}};
a.prototype.onsapenter=function(e){if(this._iState<1){this.setState(2);this.fireRefresh();}};
a.prototype.onsapspace=function(e){e.preventDefault();if(this._iState<1){this.setState(2);this.fireRefresh();}};
a.prototype.hide=function(){this.setState(0);if(this._oScroller){this._oScroller.refresh();}};
a.prototype.setVisible=function(v){if(this.getVisible()==v){return this;}if(this._oDomRef&&this._oScroller&&this._oScroller._oControl){this._oScroller._oControl.invalidate();}return this.setProperty("visible",v);};
return a;},true);
sap.ui.predefine('sap/m/PullToRefreshRenderer',['jquery.sap.global','sap/ui/core/IconPool'],function(q,I){"use strict";I.insertFontFaceStyle();var P={};
P.render=function(r,c){var s=c.getShowIcon();var C=c.getCustomIcon();var t=c.getTooltip_AsString();r.write("<div");r.writeControlData(c);r.addClass("sapMPullDown");if(!c._bTouchMode){r.addClass("sapMPullDownNontouch");}else{r.addClass("sapMPullDownTouch");}if(s&&!C){r.addClass("sapMPullDownLogo");}r.writeClasses();if(t){r.writeAttributeEscaped("title",t);}r.write(" tabindex=\"0\"");r.write(" role='button' aria-controls='"+c.getParent().sId+"-cont'>");if(s&&C){var o=c.getCustomIconImage();if(o){r.write("<div class=\"sapMPullDownCI\">");r.renderControl(o);r.write("</div>");}}r.write("<span class=\"sapMPullDownIcon\"></span>");r.write("<span class=\"sapMPullDownBusy\">");r.renderControl(c._oBusyIndicator);r.write("</span>");r.write("<span id="+c.getId()+"-T class=\"sapMPullDownText\">");r.writeEscaped(c.oRb.getText(c._bTouchMode?"PULL2REFRESH_PULLDOWN":"PULL2REFRESH_REFRESH"));r.write("</span>");r.write("<span id="+c.getId()+"-I class=\"sapMPullDownInfo\">");r.writeEscaped(c.getDescription());r.write("</span>");r.write("</div>");};
return P;},true);
sap.ui.predefine('sap/m/QuickViewCardRenderer',['jquery.sap.global'],function(q){"use strict";var Q={};
Q.render=function(r,o){var c=o.getNavContainer();r.write("<div");r.addClass("sapMQuickViewCard");if(!o.getShowVerticalScrollBar()){r.addClass("sapMQuickViewCardNoScroll");}r.writeControlData(o);r.writeClasses();r.write(">");r.renderControl(c);r.write("</div>");};
return Q;},true);
sap.ui.predefine('sap/m/QuickViewGroup',['jquery.sap.global','./library','sap/ui/core/Element'],function(q,l,E){"use strict";
var G=E.extend("sap.m.QuickViewGroup",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true},heading:{type:"string",group:"Misc",defaultValue:""}},defaultAggregation:"elements",aggregations:{elements:{type:"sap.m.QuickViewGroupElement",multiple:true,singularName:"element",bindable:"bindable"}}}});
["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(f){G.prototype["_"+f+"Old"]=G.prototype[f];G.prototype[f]=function(){var r=G.prototype["_"+f+"Old"].apply(this,arguments);var p=this.getParent();if(p){p._updatePage();}if(["removeAggregation","removeAllAggregation"].indexOf(f)!==-1){return r;}return this;};});
G.prototype.setProperty=function(){E.prototype.setProperty.apply(this,arguments);var p=this.getParent();if(p){p._updatePage();}};
return G;},true);
sap.ui.predefine('sap/m/QuickViewPageRenderer',['jquery.sap.global'],function(q){"use strict";var Q={};
Q.render=function(r,o){var p=o._createPageContent();r.write("<div");r.addClass("sapMQuickViewPage");r.writeControlData(o);r.writeClasses();r.write(">");if(p.header){r.renderControl(p.header);}r.renderControl(p.form);r.write("</div>");};
return Q;},true);
sap.ui.predefine('sap/m/QuickViewRenderer',['jquery.sap.global'],function(q){"use strict";var Q={};
Q.render=function(r,c){};
return Q;},true);
sap.ui.predefine('sap/m/RadioButton',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator'],function(q,l,C,E){"use strict";
var R=C.extend("sap.m.RadioButton",{metadata:{library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},selected:{type:"boolean",group:"Data",defaultValue:false},groupName:{type:"string",group:"Behavior",defaultValue:'sapMRbDefaultGroup'},text:{type:"string",group:"Appearance",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},useEntireWidth:{type:"boolean",group:"Appearance",defaultValue:false},activeHandling:{type:"boolean",group:"Appearance",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:sap.ui.core.ValueState.None},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:sap.ui.core.TextAlign.Begin}},events:{select:{parameters:{selected:{type:"boolean"}}}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}}});
E.call(R.prototype);R.prototype._groupNames={};
R.prototype.ontap=function(e){if(!this.getEnabled()||!this.getEditable()){return;}e&&e.setMarked();this.applyFocusInfo();if(!this.getSelected()){this.setSelected(true);var t=this;setTimeout(function(){t.fireSelect({selected:true});},0);}};
R.prototype.ontouchstart=function(e){e.originalEvent._sapui_handledByControl=true;if(this.getEnabled()&&this.getActiveHandling()){this.$().toggleClass("sapMRbBTouched",true);}};
R.prototype.ontouchend=function(e){this.$().toggleClass("sapMRbBTouched",false);};
R.prototype.onsapnext=function(e){this._arrowsHandler("next");e.setMarked();return this;};
R.prototype.onsapprevious=function(e){this._arrowsHandler();e.setMarked();return this;};
R.prototype._arrowsHandler=function(p){if(this.getParent()instanceof sap.m.RadioButtonGroup){return;}var v=this._groupNames[this.getGroupName()].filter(function(r){return(r.getDomRef()&&r.getEnabled());});var b=v.indexOf(this);if(p==="next"){var n=(b+1)%v.length;v[n].focus();}else{b=b-1;var P=b<0?v.length-1:b;v[P].focus();}};
R.prototype.onsapselect=function(e){e.preventDefault();this.ontap(e);};
R.prototype.setSelected=function(s){var c,S=this.getSelected(),g=this.getGroupName(),a=this._groupNames[g],L=a&&a.length;this.setProperty("selected",s,true);this._changeGroupName(this.getGroupName());if(!!s&&g&&g!==""){for(var i=0;i<L;i++){c=a[i];if(c instanceof R&&c!==this&&c.getSelected()){c.fireSelect({selected:false});c.setSelected(false);}}}if((S!==!!s)&&this.getDomRef()){this.$().toggleClass("sapMRbSel",s);if(s){this.getDomRef().setAttribute("aria-checked","true");this.getDomRef("RB").checked=true;this.getDomRef("RB").setAttribute("checked","checked");}else{this.getDomRef().removeAttribute("aria-checked");this.getDomRef("RB").checked=false;this.getDomRef("RB").removeAttribute("checked");}}return this;};
R.prototype.setText=function(t){this.setProperty("text",t,true);if(this._oLabel){this._oLabel.setText(this.getText());}else{this._createLabel("text",this.getText());}this.addStyleClass("sapMRbHasLabel");return this;};
R.prototype._setWidth=function(u){if(!u){this._setLableWidth();}else{this._setLableWidth("auto");}};
R.prototype._setLableWidth=function(w){w=w||this.getWidth();if(this._oLabel){this._oLabel.setWidth(w);}else{this._createLabel("width",w);}};
R.prototype.setTextDirection=function(d){this.setProperty("textDirection",d,true);if(this._oLabel){this._oLabel.setTextDirection(this.getTextDirection());}else{this._createLabel("textDirection",this.getTextDirection());}return this;};
R.prototype.setGroupName=function(g){this._changeGroupName(g,this.getGroupName());return this.setProperty("groupName",g,true);};
R.prototype.onBeforeRendering=function(){this._setWidth(this.getUseEntireWidth());return this._changeGroupName(this.getGroupName());};
R.prototype.exit=function(){var g=this.getGroupName(),c=this._groupNames[g],G=c&&c.indexOf(this);this._iTabIndex=null;if(this._oLabel){this._oLabel.destroy();}if(G>=-1){c.splice(G,1);}};
R.prototype._createLabel=function(p,v){this._oLabel=new sap.m.Label(this.getId()+"-label").addStyleClass("sapMRbBLabel").setParent(this,null,true);this._oLabel.setProperty(p,v,false);};
R.prototype.setTabIndex=function(t){var f=this.getFocusDomRef();this._iTabIndex=t;if(f){f.setAttribute("tabindex",t);}return this;};
R.prototype.setTextAlign=function(a){this.setProperty("textAlign",a,true);if(this._oLabel){this._oLabel.setTextAlign(this.getTextAlign());}else{this._createLabel("textAlign",this.getTextAlign());}return this;};
R.prototype._changeGroupName=function(n,o){var N=this._groupNames[n],O=this._groupNames[o];if(O&&O.indexOf(this)!==-1){O.splice(O.indexOf(this),1);}if(!N){N=this._groupNames[n]=[];}if(N.indexOf(this)===-1){N.push(this);}};
return R;},true);
sap.ui.predefine('sap/m/RadioButtonGroup',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation'],function(q,l,C,I){"use strict";
var R=C.extend("sap.m.RadioButtonGroup",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},columns:{type:"int",group:"Appearance",defaultValue:1},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:sap.ui.core.ValueState.None},selectedIndex:{type:"int",group:"Data",defaultValue:0},enabled:{type:"boolean",group:"Behavior",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}},defaultAggregation:"buttons",aggregations:{buttons:{type:"sap.m.RadioButton",multiple:true,singularName:"button",bindable:"bindable"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{parameters:{selectedIndex:{type:"int"}}}}}});
R.prototype.exit=function(){this.destroyButtons();if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
R.prototype.onBeforeRendering=function(){if(this.getSelectedIndex()>this.getButtons().length){q.sap.log.warning("Invalid index, set to 0");this.setSelectedIndex(0);}};
R.prototype.onAfterRendering=function(){this._initItemNavigation();var v=this.aRBs.filter(function(b){return b.getVisible();});for(var i=0;i<v.length;i++){var r=v[i].getDomRef();r.setAttribute("aria-posinset",i+1);r.setAttribute("aria-setsize",v.length);}};
R.prototype._initItemNavigation=function(){var d=[];var h=false;var r=this.getEnabled();for(var i=0;i<this.aRBs.length;i++){d.push(this.aRBs[i].getDomRef());h=h||this.aRBs[i].getEnabled();}if(!h||!r){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}return;}if(!this._oItemNavigation){this._oItemNavigation=new I();this._oItemNavigation.attachEvent(I.Events.AfterFocus,this._handleAfterFocus,this);this.addDelegate(this._oItemNavigation);}this._oItemNavigation.setRootDomRef(this.getDomRef());this._oItemNavigation.setItemDomRefs(d);this._oItemNavigation.setCycling(true);this._oItemNavigation.setColumns(this.getColumns());this._oItemNavigation.setSelectedIndex(this.getSelectedIndex());this._oItemNavigation.setFocusedIndex(this.getSelectedIndex());};
R.prototype.setSelectedIndex=function(s){var i=this.getSelectedIndex();var h=document.activeElement&&document.activeElement.parentNode&&document.activeElement.parentNode.parentNode===this.getDomRef();var a=!!(this.aRBs&&this.aRBs[s]);if(s<-1){q.sap.log.warning("Invalid index, will not be changed");return this;}this.setProperty("selectedIndex",s,true);if(!isNaN(i)&&this.aRBs&&this.aRBs[i]){this.aRBs[i].setSelected(false);}if(this.aRBs&&this.aRBs[s]){this.aRBs[s].setSelected(true);}if(this._oItemNavigation){this._oItemNavigation.setSelectedIndex(s);this._oItemNavigation.setFocusedIndex(s);}if(a&&h){this.aRBs[s].getDomRef().focus();}return this;};
R.prototype.setSelectedButton=function(s){var b=this.getButtons();if(s){if(b){for(var i=0;i<b.length;i++){if(s.getId()==b[i].getId()){this.setSelectedIndex(i);break;}}}}else{this.setSelectedIndex(-1);}return this;};
R.prototype.getSelectedButton=function(){return this.getButtons()[this.getSelectedIndex()];};
R.prototype.addButton=function(b){if(!this._bUpdateButtons&&this.getSelectedIndex()===undefined){this.setSelectedIndex(0);}if(!this.aRBs){this.aRBs=[];}var i=this.aRBs.length;this.aRBs[i]=this._createRadioButton(b,i);this.addAggregation("buttons",this.aRBs[i]);this.aRBs[i].attachEvent("_change",this._handleItemChanged,this);return this;};
R.prototype.insertButton=function(b,a){if(!this.aRBs){this.aRBs=[];}var L=this.aRBs.length;if(!this._bUpdateButtons){if(this.getSelectedIndex()===undefined||L==0){this.setSelectedIndex(0);}else if(this.getSelectedIndex()>=a){this.setProperty("selectedIndex",this.getSelectedIndex()+1,true);}}if(a>=L){this.aRBs[a]=this._createRadioButton(b,a);}else{for(var i=(L);i>a;i--){this.aRBs[i]=this.aRBs[i-1];if((i-1)==a){this.aRBs[i-1]=this._createRadioButton(b,a);}}}this.insertAggregation("buttons",b,a);b.attachEvent("_change",this._handleItemChanged,this);return this;};
R.prototype._createRadioButton=function(b,i){if(this.iIDCount==undefined){this.iIDCount=0;}else{this.iIDCount++;}b.setEnabled(this.getEnabled()&&b.getEnabled());b.setTextDirection(b.getTextDirection());b.setEditable(this.getEditable()&&b.getEditable());b.setVisible(this.getVisible()&&b.getVisible());b.setValueState(this.getValueState());b.setGroupName(this.getId());if(i==this.getSelectedIndex()){b.setSelected(true);}b.attachEvent("select",this._handleRBSelect,this);return b;};
R.prototype.removeButton=function(e){var i=e;if(typeof(e)=="string"){e=sap.ui.getCore().byId(e);}if(typeof(e)=="object"){i=this.indexOfButton(e);}var b=this.removeAggregation("buttons",i);b.detachEvent("_change",this._handleItemChanged,this);if(!this.aRBs){this.aRBs=[];}if(!this.aRBs[i]){return null;}this.aRBs[i].destroy();this.aRBs.splice(i,1);if(!this._bUpdateButtons){if(this.aRBs.length==0){this.setSelectedIndex(-1);}else if(this.getSelectedIndex()==i){this.setSelectedIndex(0);}else{if(this.getSelectedIndex()>i){this.setProperty("selectedIndex",this.getSelectedIndex()-1,true);}}}return b;};
R.prototype.removeAllButtons=function(){var b=this.removeAllAggregation("buttons");for(var i=0;i<b.length;i++){b[i].detachEvent("_change",this._handleItemChanged,this);}if(!this._bUpdateButtons){this.setSelectedIndex(-1);}if(this.aRBs){while(this.aRBs.length>0){this.aRBs[0].destroy();this.aRBs.splice(0,1);}return b;}else{return null;}};
R.prototype.destroyButtons=function(){var b=this.getButtons();for(var i=0;i<b.length;i++){b[i].detachEvent("_change",this._handleItemChanged,this);}this.destroyAggregation("buttons");if(!this._bUpdateButtons){this.setSelectedIndex(-1);}if(this.aRBs){while(this.aRBs.length>0){this.aRBs[0].destroy();this.aRBs.splice(0,1);}}return this;};
R.prototype.updateButtons=function(){var s=this.getSelectedIndex();this._bUpdateButtons=true;this.updateAggregation("buttons");this._bUpdateButtons=undefined;var b=this.getButtons();if(b.length>0){this.setSelectedIndex(0);}else if(s>=0&&b.length==0){this.setSelectedIndex(-1);}else if(s>=b.length){this.setSelectedIndex(b.length-1);}};
R.prototype.clone=function(){var b=this.getButtons();var i=0;for(i=0;i<b.length;i++){b[i].detachEvent("_change",this._handleItemChanged,this);}var c=C.prototype.clone.apply(this,arguments);for(i=0;i<b.length;i++){b[i].attachEvent("_change",this._handleItemChanged,this);}return c;};
R.prototype._handleRBSelect=function(c){for(var i=0;i<this.aRBs.length;i++){if(this.aRBs[i].getId()==c.getParameter("id")&&c.getParameter("selected")){this.setSelectedIndex(i);this.fireSelect({selectedIndex:i});break;}}};
R.prototype.setEditable=function(e){this.setProperty("editable",e,false);if(this.aRBs){for(var i=0;i<this.aRBs.length;i++){this.aRBs[i].setEditable(e);}}return this;};
R.prototype.setEnabled=function(e){this.setProperty("enabled",e,false);if(this.aRBs){for(var i=0;i<this.aRBs.length;i++){this.aRBs[i].setEnabled(e);}}return this;};
R.prototype.setValueState=function(v){this.setProperty("valueState",v,false);if(this.aRBs){for(var i=0;i<this.aRBs.length;i++){this.aRBs[i].setValueState(v);}}return this;};
R.prototype._handleAfterFocus=function(c){var i=c.getParameter("index");var e=c.getParameter("event");if(e.keyCode===undefined){return;}if(i!=this.getSelectedIndex()&&!(e.ctrlKey||e.metaKey)&&this.aRBs[i].getEditable()&&this.aRBs[i].getEnabled()){this.setSelectedIndex(i);this.fireSelect({selectedIndex:i});}};
R.prototype._handleItemChanged=function(e){var b=e.oSource;var p=e.getParameter("name");var n=e.getParameter("newValue");var B=this.getButtons();var r;for(var i=0;i<B.length;i++){if(B[i]==b){if(this.aRBs[i]){r=this.aRBs[i];}break;}}switch(p){case"enabled":if(this.getEnabled()){r.setEnabled(n);}break;case"selected":r.setSelected(n);break;case"groupName":r.setGroupName(n);break;case"text":r.setText(n);break;case"textDirection":r.setTextDirection(n);break;case"width":r.setWidth(n);break;case"activeHandling":r.setActiveHandling(n);break;case"editable":r.setEditable(n);break;case"tooltip":r.setTooltip(n);break;case"valueState":r.setValueState(n);break;case"textAlign":r.setTextAlign(n);break;default:break;}};
return R;},true);
sap.ui.predefine('sap/m/RadioButtonGroupRenderer',[],function(){"use strict";var R={};
R.render=function(r,o){var a=r;if(!o.aRBs){return;}var v=o.aRBs.filter(function(B){return B.getVisible();});var C=o.getColumns();var e=o.getEnabled();var s=o.getTextDirection();var g=sap.ui.getCore().getConfiguration().getRTL();if(e){var b=o.getButtons();e=false;for(var i=0;i<b.length;i++){if(b[i].getEnabled()){e=true;break;}}}a.write("<div");a.writeControlData(o);a.addClass("sapMRbG");if(C>1){if(C==v.length){a.addClass("sapMRbG1Row");}else{a.addClass("sapMRbGTab");}}if(o.getWidth()&&o.getWidth()!=""){a.addStyle("width",o.getWidth());}if(o.getTooltip_AsString()){a.writeAttributeEscaped("title",o.getTooltip_AsString());}if(!g&&s!=sap.ui.core.TextDirection.Inherit){a.writeAttribute("dir",s.toLowerCase());}a.writeAccessibilityState(o,{role:"radiogroup"});a.writeClasses();a.writeStyles();a.write(">");for(var c=0;c<C;c++){if(C>1&&C!=v.length){a.write("<div");a.addClass("sapMRbGCol");a.writeClasses();a.write(">");}for(var i=c;i<v.length;i=i+C){a.renderControl(v[i]);}if(C>1&&C!=v.length){a.write("</div>");}}if(C>1&&C!=v.length){a.write('<div class="sapMRbGDummy"> </div>');}a.write("</div>");};
return R;},true);
sap.ui.predefine('sap/m/RadioButtonRenderer',['jquery.sap.global','sap/ui/core/ValueStateSupport'],function(q,V){"use strict";var R={};
R.render=function(r,o){var i=o.getId();var e=o.getEnabled();var E=o.getEditable();var b=!e||!E;var I=sap.ui.core.ValueState.Error==o.getValueState();var a=sap.ui.core.ValueState.Warning==o.getValueState();var u=o.getUseEntireWidth();r.addClass("sapMRb");r.write("<div");r.writeControlData(o);if(u){r.addStyle("width",o.getWidth());r.writeStyles();}var t=V.enrichTooltip(o,o.getTooltip_AsString());if(t){r.writeAttributeEscaped("title",t);}r.writeAccessibilityState(o,{role:"radio",selected:null,checked:o.getSelected()===true?true:undefined,disabled:!o.getEditable()?true:undefined,labelledby:{value:i+"-label",append:true},describedby:{value:(t?i+"-Descr":undefined),append:true}});if(o.getSelected()){r.addClass("sapMRbSel");}if(!e){r.addClass("sapMRbDis");}if(!E){r.addClass("sapMRbRo");}if(I){r.addClass("sapMRbErr");}if(a){r.addClass("sapMRbWarn");}r.writeClasses();if(e){r.writeAttribute("tabindex",o.hasOwnProperty("_iTabIndex")?o._iTabIndex:0);}r.write(">");r.write("<div class='sapMRbB'");r.write(">");r.write("<div");r.addClass("sapMRbBOut");r.writeAttribute("id",i+"-Button");if(!b&&sap.ui.Device.system.desktop){r.addClass("sapMRbHoverable");}r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMRbBInn");r.writeClasses();r.write(">");r.write("<input type='radio' tabindex='-1'");r.writeAttribute("id",i+"-RB");r.writeAttributeEscaped("name",o.getGroupName());if(o.getSelected()){r.writeAttribute("checked","checked");}if(b){r.writeAttribute("readonly","readonly");r.writeAttribute("disabled","disabled");}r.write(" />");r.write("</div></div>");r.write("</div>");r.renderControl(o._oLabel);if(t&&sap.ui.getCore().getConfiguration().getAccessibility()){r.write("<span id=\""+i+"-Descr\" style=\"display: none;\">");r.writeEscaped(t);r.write("</span>");}r.write("</div>");};
return R;},true);
sap.ui.predefine('sap/m/RangeSlider',["jquery.sap.global","./Slider","./Input","sap/ui/core/InvisibleText"],function(q,S,I,a){"use strict";
var R=S.extend("sap.m.RangeSlider",{metadata:{library:"sap.m",properties:{value2:{type:"float",group:"Data",defaultValue:100},range:{type:"float[]",group:"Data",defaultValue:[0,100]}}}});
var _={RANGE_MOVEMENT_THRESHOLD:32,CHARACTER_WIDTH_PX:8,INPUT_STATE_NONE:"None",INPUT_STATE_ERROR:"Error"};
R.prototype.init=function(){var s,e;S.prototype.init.call(this,arguments);this._bRTL=sap.ui.getCore().getConfiguration().getRTL();this._aInitialFocusRange=this.getRange();this._iLongestRangeTextWidth=0;this._fTooltipHalfWidthPercent=0;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle('sap.m');this._ariaUpdateDelay=[];s=new a({text:this._oResourceBundle.getText("RANGE_SLIDER_LEFT_HANDLE")});e=new a({text:this._oResourceBundle.getText("RANGE_SLIDER_RIGHT_HANDLE")});this._mHandleTooltip={start:{handle:null,tooltip:null,label:s},end:{handle:null,tooltip:null,label:e}};};
R.prototype.exit=function(){this._oResourceBundle=null;this._aInitialFocusRange=null;if(this._oRangeLabel){this._oRangeLabel.destroy();}this._oRangeLabel=null;if(this.getInputsAsTooltips()){if(this._mHandleTooltip.start.tooltip){this._mHandleTooltip.start.tooltip.destroy();}if(this._mHandleTooltip.end.tooltip){this._mHandleTooltip.end.tooltip.destroy();}}if(this._mHandleTooltip.start.label){this._mHandleTooltip.start.label.destroy();}if(this._mHandleTooltip.end.label){this._mHandleTooltip.end.label.destroy();}this._mHandleTooltip.start.handle=null;this._mHandleTooltip.start.tooltip=null;this._mHandleTooltip.start.label=null;this._mHandleTooltip.end.handle=null;this._mHandleTooltip.end.tooltip=null;this._mHandleTooltip.end.label=null;this._ariaUpdateDelay=null;this._iDecimalPrecision=null;};
R.prototype.onBeforeRendering=function(){var A=[Math.abs(this.getMin()),Math.abs(this.getMax())],r=A[0]>A[1]?0:1,i=!!this.getInputsAsTooltips();this._oRangeLabel=new a({text:this._oResourceBundle.getText("RANGE_SLIDER_RANGE_HANDLE")});this._validateProperties();this._iLongestRangeTextWidth=((A[r].toString()).length+this.getDecimalPrecisionOfNumber(this.getStep())+1)*_.CHARACTER_WIDTH_PX;if(!this._mHandleTooltip.start.tooltip){this._mHandleTooltip.start.tooltip=i?this._createInputField("LeftTooltip",this._mHandleTooltip.start.label):null;}if(!this._mHandleTooltip.end.tooltip){this._mHandleTooltip.end.tooltip=i?this._createInputField("RightTooltip",this._mHandleTooltip.end.label):null;}this._iDecimalPrecision=this.getDecimalPrecisionOfNumber(this.getStep());};
R.prototype.onAfterRendering=function(){var r=this.getRange(),m=this.getMin(),M=this.getMax(),b=r.reduce(function(c,v){return c||v<m||v>M;});this._mHandleTooltip.start.handle=this.getDomRef("handle1");this._mHandleTooltip.end.handle=this.getDomRef("handle2");if(!this.getInputsAsTooltips()){this._mHandleTooltip.start.tooltip=this.$("LeftTooltip");this._mHandleTooltip.end.tooltip=this.$("RightTooltip");}this._recalculateStyles();if(b){q.sap.log.warning("Warning: "+"Property wrong range: ["+r+"] not in the range: ["+m+","+M+"]",this);}this.$("TooltipsContainer").css("min-width",(this._fTooltipHalfWidthPercent*4)+"%");this._updateHandle(this._mHandleTooltip.start.handle,r[0]);this._updateHandle(this._mHandleTooltip.end.handle,r[1]);};
R.prototype._recalculateRange=function(){var h,s,e,p,b=this._bRTL?"right":"left";h=[parseFloat(this._mHandleTooltip.start.handle.style[b]),parseFloat(this._mHandleTooltip.end.handle.style[b])];s=Math.min.apply(Math,h)+"%";e=(100-Math.max.apply(Math,h))+"%";p=this.getDomRef("progress");if(this._bRTL){p.style.left=e;p.style.right=s;}else{p.style.left=s;p.style.right=e;}};
R.prototype.getClosestHandleDomRef=function(e){var h=this._mHandleTooltip.start.handle,H=this._mHandleTooltip.end.handle,p=Math.abs(e.pageX-h.offsetLeft-this._fSliderPaddingLeft-this._fSliderOffsetLeft),c=Math.abs(e.clientX-H.offsetLeft-this._fSliderPaddingLeft-this._fSliderOffsetLeft);return p>c?H:h;};
R.prototype._getIndexOfHandle=function(h){if(h&&h.getAttribute&&h.getAttribute("data-range-val")==="start"){return 0;}else if(h&&h.getAttribute&&h.getAttribute("data-range-val")==="end"){return 1;}else{return-1;}};
R.prototype._updateHandle=function(h,v){var t=(this._mHandleTooltip.start.handle===h)?this._mHandleTooltip.start.tooltip:this._mHandleTooltip.end.tooltip,r=this.getRange(),i=this._getIndexOfHandle(h),p=this._getPercentOfValue(v);r[i]=v;this._updateRangePropertyDependencies(r);this._updateHandleDom(h,r,i,v,p);this._updateTooltipContent(t,v);this._adjustTooltipsContainer(p);this._recalculateRange();};
R.prototype._updateHandleDom=function(h,r,i,v,p){var m,c=this.getRenderer().CSS_CLASS,f=this.getDomRef("input");if(!!this.getName()){f.setAttribute(h.getAttribute("data-range-val"),r[i]);f.setAttribute("value",this.getValue());}if(this._bRTL){h.style.right=p+"%";}else{h.style.left=p+"%";}if(this.getShowHandleTooltip()){h.title=v;}m=r[0]===r[1];this.$("handle1").toggleClass(c+"HandleOverlap",m);this.$("handle2").toggleClass(c+"HandleOverlap",m);q.sap.clearDelayedCall(this._ariaUpdateDelay[i]);this._ariaUpdateDelay[i]=q.sap.delayedCall(100,this,"_updateHandleAria",[h,v]);};
R.prototype._updateHandleAria=function(h,v){var r=this.getRange(),p=this.getDomRef("progress");this._updateHandlesAriaLabels();h.setAttribute("aria-valuenow",v);if(p){p.setAttribute("aria-valuenow",r.join("-"));p.setAttribute("aria-valuetext",this._oResourceBundle.getText('RANGE_SLIDER_RANGE_ANNOUNCEMENT',r));}};
R.prototype._updateHandlesAriaLabels=function(){var r=this.getRange(),t=this._mHandleTooltip.start.label;if((r[0]>r[1]&&!this._mHandleTooltip.bAriaHandlesSwapped)||(r[0]<r[1]&&this._mHandleTooltip.bAriaHandlesSwapped)){this._mHandleTooltip.start.label=this._mHandleTooltip.end.label;this._mHandleTooltip.end.label=t;this._mHandleTooltip.start.handle.setAttribute("aria-labelledby",this._mHandleTooltip.start.label.getId());this._mHandleTooltip.end.handle.setAttribute("aria-labelledby",this._mHandleTooltip.end.label.getId());this._mHandleTooltip.bAriaHandlesSwapped=!this._mHandleTooltip.bAriaHandlesSwapped;}};
R.prototype._updateTooltipContent=function(t,n){var i=this.getInputsAsTooltips(),N=this.toFixed(n,this._iDecimalPrecision);if(!i){t.text(N);}else if(i&&t.getValue()!==N){t.setValueState(_.INPUT_STATE_NONE);t.setValue(N);t.$("inner").attr("value",N);}};
R.prototype._swapTooltips=function(r){var t=this._mHandleTooltip.start.tooltip;if((r[0]>=r[1]&&!this._mHandleTooltip.bTooltipsSwapped)||(r[0]<=r[1]&&this._mHandleTooltip.bTooltipsSwapped)){this._mHandleTooltip.start.tooltip=this._mHandleTooltip.end.tooltip;this._mHandleTooltip.end.tooltip=t;this._updateTooltipContent(this._mHandleTooltip.start.tooltip,r[0]);this._updateTooltipContent(this._mHandleTooltip.end.tooltip,r[1]);if(this.getInputsAsTooltips()){this._mHandleTooltip.start.handle.setAttribute("aria-controls",this._mHandleTooltip.start.tooltip.getId());this._mHandleTooltip.end.handle.setAttribute("aria-controls",this._mHandleTooltip.end.tooltip.getId());}this._mHandleTooltip.bTooltipsSwapped=!this._mHandleTooltip.bTooltipsSwapped;}};
R.prototype._adjustTooltipsContainer=function(){var t=this.getDomRef("TooltipsContainer"),A=this._bRTL?"right":"left",s=this._bRTL?"left":"right",r=this.getRange(),f=this._getPercentOfValue(r[0]>r[1]?r[1]:r[0]),e=this._getPercentOfValue(r[0]>r[1]?r[0]:r[1]);if(f<=this._fTooltipHalfWidthPercent){t.style[A]=0+"%";}else if(f>=(100-3*this._fTooltipHalfWidthPercent)){t.style[A]=(100-4*this._fTooltipHalfWidthPercent)+"%";}else{t.style[A]=f-this._fTooltipHalfWidthPercent+"%";}if(e>=(100-this._fTooltipHalfWidthPercent)){t.style[s]=0+"%";}else{t.style[s]=(100-e-this._fTooltipHalfWidthPercent)+"%";}this._swapTooltips(r);};
R.prototype._handleInputChange=function(i,e){var h,A,t=this._mHandleTooltip.bTooltipsSwapped,n=Number(e.getParameter("value"));if(isNaN(n)||n<this.getMin()||n>this.getMax()){i.setValueState(_.INPUT_STATE_ERROR);return;}n=this._adjustRangeValue(n);i.setValueState(_.INPUT_STATE_NONE);h=this._mHandleTooltip.start.tooltip===i?this._mHandleTooltip.start.handle:this._mHandleTooltip.end.handle;this._updateHandle(h,n);if(t!==this._mHandleTooltip.bTooltipsSwapped){A=this._mHandleTooltip.start.tooltip!==i?this._mHandleTooltip.start.tooltip:this._mHandleTooltip.end.tooltip;A.focus();}this._fireChangeAndLiveChange({range:this.getRange()});};
R.prototype._updateDOMAfterSetters=function(v,r,h){var p,H;if(this.getDomRef()){p=this._getPercentOfValue(v);H=h===1?this._mHandleTooltip.end:this._mHandleTooltip.start;this._updateHandleDom(H.handle,r,h,v,p);this._updateTooltipContent(H.tooltip,v);return true;}return false;};
R.prototype.setRange=function(r){r=r.map(this._adjustRangeValue,this);this._updateRangePropertyDependencies(r);if(this._updateDOMAfterSetters(r[0],r,0)&&this._updateDOMAfterSetters(r[1],r,1)){this._recalculateRange();}return this;};
R.prototype.setValue=function(v){var r=this.getRange();v=this._adjustRangeValue(v);r[0]=v;this._updateRangePropertyDependencies(r);if(this._updateDOMAfterSetters(r[0],r,0)){this._recalculateRange();}return this;};
R.prototype.setValue2=function(v){var r=this.getRange();v=this._adjustRangeValue(v);r[1]=v;this._updateRangePropertyDependencies(r);if(this._updateDOMAfterSetters(r[1],r,1)){this._recalculateRange();}return this;};
R.prototype._updateRangePropertyDependencies=function(r){var b=Array.isArray(r)?r.slice():[];if(this.getProperty("value")!==b[0]){this.setProperty("value",b[0],true);}if(this.getProperty("value2")!==b[1]){this.setProperty("value2",b[1],true);}this.setProperty("range",b,true);};
R.prototype._calculateHandlePosition=function(v){var m=this.getMax(),M=this.getMin(),n;n=((v-this._fSliderPaddingLeft-this._fSliderOffsetLeft)/this._fSliderWidth)*(m-M)+M;if(this._bRTL){n=this._convertValueToRtlMode(n);}return this._adjustRangeValue(n);};
R.prototype._adjustRangeValue=function(v){var m=this.getMax(),M=this.getMin(),s=this.getStep(),f;f=Math.abs((v-M)%s);if(f!==0){v=f*2>=s?v+s-f:v-f;}if(v<M){v=M;}else if(v>m){v=m;}return v;};
R.prototype.ontouchstart=function(e){var t=e.targetTouches[0],C=this.getRenderer().CSS_CLASS,E="."+C,v,h,r,H,f,F;if(!this.getEnabled()){return;}e.setMarked();this._recalculateStyles();if(["number","text"].indexOf(e.target.type)>-1){return;}v=this._calculateHandlePosition(t.pageX);r=this.getRange();h=[this._mHandleTooltip.start.handle,this._mHandleTooltip.end.handle];H=this._getIndexOfHandle(e.target);f=h.reduce(function(A,o){return Math.abs(A-o.offsetLeft);},0);if(v<Math.min.apply(Math,r)||v>Math.max.apply(Math,r)||f<=_.RANGE_MOVEMENT_THRESHOLD){h=[this.getClosestHandleDomRef(t)];this._updateHandle(h[0],v);}else if(H!==-1){h=[this.getDomRef(H===0?"handle1":"handle2")];}q(document).on("touchend"+E+" touchcancel"+E+" mouseup"+E,this._ontouchend.bind(this,h)).on("touchmove"+E+(e.originalEvent.type!=="touchstart"?" mousemove"+E:""),this._ontouchmove.bind(this,v,this.getRange(),h));h.map(function(o){if(o.className.indexOf(C+"HandlePressed")===-1){o.className+=" "+C+"HandlePressed";}});F=h.length===1?h[0]:this.getDomRef("progress");q.sap.delayedCall(0,F,"focus");};
R.prototype._ontouchmove=function(i,b,h,e){var o,c,m,M,p=e.targetTouches?e.targetTouches[0].pageX:e.pageX;e.preventDefault();e.setMarked();if(e.isMarked("delayedMouseEvent")||!this.getEnabled()||e.button){return;}m=this.getMax();M=this.getMin();o=this._calculateHandlePosition(p)-i;c=b.every(function(r){var f=r+o;if(h.length===1){return m>=f||f>=M;}else{return m>=f&&f>=M;}});c&&h.map(function(H){this._updateHandle(H,b[this._getIndexOfHandle(H)]+o);},this);this.fireLiveChange({range:this.getRange()});};
R.prototype._ontouchend=function(h,e){var n=this.getRange(),c=this.getRenderer().CSS_CLASS;e.setMarked();h&&h.map(function(H){H.className=H.className.replace(new RegExp(" ?"+c+"HandlePressed","gi"),"");});q(document).off("."+c);this._recalculateRange();if(this._aInitialFocusRange[0]!==n[0]||this._aInitialFocusRange[1]!==n[1]){this._aInitialFocusRange=Array.prototype.slice.call(n);this.fireChange({range:n});}this._updateTooltipContent(this._mHandleTooltip.start.tooltip,n[0]);this._updateTooltipContent(this._mHandleTooltip.end.tooltip,n[1]);};
R.prototype.onfocusin=function(e){var c=this.getRenderer().CSS_CLASS;this.$("TooltipsContainer").addClass(c+"HandleTooltipsShow");if(!this._hasFocus()){this._aInitialFocusRange=this.getRange();}};
R.prototype._updateSliderValues=function(o,h){var r=this.getRange(),m=this.getMax(),M=this.getMin(),f=Math.max.apply(null,r),b=Math.min.apply(null,r),i=this._getIndexOfHandle(h),O=o<0?-1:1,H=i>-1?[h]:[this._mHandleTooltip.start.handle,this._mHandleTooltip.end.handle];if(H.length===1){b=f=r[i];}if(f+o>m){o=O*(Math.abs(m)-Math.abs(f));}else if(b+o<M){o=O*(Math.abs(b)-Math.abs(M));}H.map(function(c){this._updateHandle(c,r[this._getIndexOfHandle(c)]+o);},this);};
R.prototype.onsapincrease=function(e){if(["number","text"].indexOf(e.target.type)>-1){return;}e.preventDefault();e.setMarked();if(this.getEnabled()){this._updateSliderValues(this.getStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
R.prototype.onsapplus=R.prototype.onsapincrease;
R.prototype.onsapincreasemodifiers=function(e){if(["number","text"].indexOf(e.target.type)>-1){return;}e.preventDefault();e.setMarked();if(this.getEnabled()){this._updateSliderValues(this._getLongStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
R.prototype.onsappageup=R.prototype.onsapincreasemodifiers;
R.prototype.onsapdecrease=function(e){if(["number","text"].indexOf(e.target.type)>-1){return;}e.preventDefault();e.setMarked();if(this.getEnabled()){this._updateSliderValues(-1*this.getStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
R.prototype.onsapminus=R.prototype.onsapdecrease;
R.prototype.onsapdecreasemodifiers=function(e){if(["number","text"].indexOf(e.target.type)>-1){return;}e.preventDefault();e.setMarked();if(this.getEnabled()){this._updateSliderValues(-1*this._getLongStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
R.prototype.onsappagedown=R.prototype.onsapdecreasemodifiers;
R.prototype.onsaphome=function(e){if(["number","text"].indexOf(e.target.type)>-1){return;}e.setMarked();e.preventDefault();if(this.getEnabled()){this._updateSliderValues(this.getMin(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
R.prototype.onsapend=function(e){if(["number","text"].indexOf(e.target.type)>-1){return;}e.setMarked();e.preventDefault();if(this.getEnabled()){this._updateSliderValues(this.getMax(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
R.prototype.onsapescape=function(){this.setRange(this._aInitialFocusRange);this._fireChangeAndLiveChange({range:this.getRange()});};
return R;},true);
sap.ui.predefine('sap/m/RangeSliderRenderer',["sap/ui/core/Renderer","./SliderRenderer"],function(R,S){"use strict";var a=R.extend(S);
a.renderHandles=function(r,c){this.renderHandle(r,c,{id:c.getId()+"-handle1",position:"start"});this.renderHandle(r,c,{id:c.getId()+"-handle2",position:"end"});this.renderTooltips(r,c);r.renderControl(c._mHandleTooltip.start.label);r.renderControl(c._mHandleTooltip.end.label);r.renderControl(c._oRangeLabel);};
a.renderTooltips=function(r,c){r.write("<div");r.writeAttribute("id",c.getId()+"-TooltipsContainer");r.addClass(S.CSS_CLASS+"TooltipContainer");r.addStyle("left","0%");r.addStyle("right","0%");r.addStyle("min-width","0%");r.writeClasses();r.writeStyles();r.write(">");this.renderTooltip(r,c,c.getInputsAsTooltips(),"Left");this.renderTooltip(r,c,c.getInputsAsTooltips(),"Right");r.write("</div>");};
a.renderTooltip=function(r,c,i,p){if(i){if(p==="Left"){r.renderControl(c._mHandleTooltip.start.tooltip);}else{r.renderControl(c._mHandleTooltip.end.tooltip);}}else{r.write("<span");r.addClass(S.CSS_CLASS+"HandleTooltip");r.addStyle("width",c._iLongestRangeTextWidth+"px");r.writeAttribute("id",c.getId()+"-"+p+"Tooltip");r.writeClasses();r.writeStyles();r.write(">");r.write("</span>");}};
a.renderHandle=function(r,c,o){var v,b=c.getRange(),e=c.getEnabled(),d=sap.ui.getCore().getConfiguration().getRTL();r.write("<span");if(o&&(o.id!==undefined)){r.writeAttributeEscaped("id",o.id);}if(o&&(o.position!==undefined)){v=b[o.position==="start"?0:1];r.writeAttribute("data-range-val",o.position);r.writeAttribute("aria-labelledby",c._mHandleTooltip[o.position].label.getId());if(c.getInputsAsTooltips()){r.writeAttribute("aria-controls",c._mHandleTooltip[o.position].tooltip.getId());}}if(c.getShowHandleTooltip()){this.writeHandleTooltip(r,c);}r.addClass(S.CSS_CLASS+"Handle");if(o&&(o.id!==undefined)&&o.id===(c.getId()+"-handle1")){r.addStyle(d?"right":"left",b[0]);}if(o&&(o.id!==undefined)&&o.id===(c.getId()+"-handle2")){r.addStyle(d?"right":"left",b[1]);}this.writeAccessibilityState(r,c,v);r.writeClasses();r.writeStyles();if(e){r.writeAttribute("tabindex","0");}r.write("></span>");};
a.writeAccessibilityState=function(r,s,v){r.writeAccessibilityState(s,{role:"slider",orientation:"horizontal",valuemin:s.toFixed(s.getMin()),valuemax:s.toFixed(s.getMax()),valuenow:v});};
a.renderStartLabel=function(r,c){r.write("<div");r.addClass(S.CSS_CLASS+"Label");r.writeClasses();r.write(">");r.write(c.getMin());r.write("</div>");};
a.renderEndLabel=function(r,c){r.write("<div");r.addClass(S.CSS_CLASS+"Label");r.writeClasses();r.write(">");r.write(c.getMax());r.write("</div>");};
a.renderLabels=function(r,c){r.write("<div");r.addClass();r.addClass(S.CSS_CLASS+"Labels");r.writeClasses();r.write(">");this.renderStartLabel(r,c);this.renderEndLabel(r,c);r.write("</div>");};
a.renderProgressIndicator=function(r,s){var b=s.getRange();r.write("<div");r.writeAttribute("id",s.getId()+"-progress");if(s.getEnabled()){r.writeAttribute("tabindex","0");}this.addProgressIndicatorClass(r,s);r.addStyle("width",s._sProgressValue);r.writeClasses();r.writeStyles();r.writeAccessibilityState(s,{role:"slider",orientation:"horizontal",valuemin:s.toFixed(s.getMin()),valuemax:s.toFixed(s.getMax()),valuenow:b.join("-"),valuetext:s._oResourceBundle.getText('RANGE_SLIDER_RANGE_ANNOUNCEMENT',b),labelledby:s._oRangeLabel.getId()});r.write('></div>');};
return a;},true);
sap.ui.predefine('sap/m/RatingIndicator',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/theming/Parameters'],function(q,l,C,I,P){"use strict";
var R=C.extend("sap.m.RatingIndicator",{metadata:{library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},maxValue:{type:"int",group:"Behavior",defaultValue:5},value:{type:"float",group:"Behavior",defaultValue:0,bindable:"bindable"},iconSize:{type:"sap.ui.core.CSSSize",group:"Behavior",defaultValue:null},iconSelected:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},iconUnselected:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},iconHovered:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},visualMode:{type:"sap.m.RatingIndicatorVisualMode",group:"Behavior",defaultValue:sap.m.RatingIndicatorVisualMode.Half}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"int"}}},liveChange:{parameters:{value:{type:"float"}}}}}});
R.prototype.init=function(){this.allowTextSelection(false);this._iIconCounter=0;this._fHoverValue=0;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle('sap.m');};
R.prototype.setValue=function(v){v=this.validateProperty("value",v);if(v<0){return this;}if(isNaN(v)){q.sap.log.warning('Ignored new rating value "'+v+'" because it is NAN');}else if(this.$().length&&(v>this.getMaxValue())){q.sap.log.warning('Ignored new rating value "'+v+'" because it is out  of range (0-'+this.getMaxValue()+')');}else{v=this._roundValueToVisualMode(v);this.setProperty("value",v,true);this._fHoverValue=v;if(this.$().length){this._updateUI(v);}}return this;};
R.prototype.setIconSize=function(i){if(this.$().length){this._iPxIconSize=this._toPx(i)||16;}this.setProperty("iconSize",i,false);return this;};
R.prototype.onThemeChanged=function(e){this.invalidate();};
R.prototype.onBeforeRendering=function(){var v=this.getValue(),m=this.getMaxValue();if(v>m){this.setValue(m);q.sap.log.warning("Set value to maxValue because value is > maxValue ("+v+" > "+m+").");}else if(v<0){this.setValue(0);q.sap.log.warning("Set value to 0 because value is < 0 ("+v+" < 0).");}this._iPxIconSize=this._toPx(this.getIconSize())||16;this._iPxPaddingSize=this._toPx(P.get("sapUiRIIconPadding"))||4;};
R.prototype.onAfterRendering=function(){this._updateAriaValues();};
R.prototype.exit=function(){this._iIconCounter=null;this._fStartValue=null;this._iPxIconSize=null;this._iPxPaddingSize=null;this._fHoverValue=null;this._oResourceBundle=null;};
R.prototype._toPx=function(c){var s=Math.round(c),a;if(isNaN(s)){if(RegExp("^(auto|0)$|^[+-]?[0-9].?([0-9]+)?(px|em|rem|ex|%|in|cm|mm|pt|pc)$").test(c)){a=q('<div style="display: none; width: '+c+'; margin: 0; padding:0; height: auto; line-height: 1; font-size: 1; border:0; overflow: hidden">&nbsp;</div>').appendTo(sap.ui.getCore().getStaticAreaRef());s=a.width();a.remove();}else{return false;}}return Math.round(s);};
R.prototype._updateUI=function(v,h){var s=this.$("sel"),u=this.$("unsel-wrapper"),H=this.$("hov"),i=this._iPxIconSize,f=this._iPxPaddingSize,a="px",S=this.getMaxValue(),b=v*i+(Math.round(v)-1)*f,w=S*(i+f)-f;this._fHoverValue=v;if(b<0){b=0;}this._updateAriaValues(v);u.width((w-b)+a);if(h){H.width(b+a);s.hide();H.show();}else{s.width(b+a);H.hide();s.show();}q.sap.log.debug("Updated rating UI with value "+v+" and hover mode "+h);};
R.prototype._updateAriaValues=function(n){var $=this.$();var v;if(n===undefined){v=this.getValue();}else{v=n;}var m=this.getMaxValue();$.attr("aria-valuenow",v);$.attr("aria-valuemax",m);var V=this._oResourceBundle.getText("RATING_VALUEARIATEXT",[v,m]);$.attr("aria-valuetext",V);};
R.prototype._calculateSelectedValue=function(e){var s=-1.0,p=0.0,c=this.$(),f=(c.innerWidth()-c.width())/2,E,r=sap.ui.getCore().getConfiguration().getRTL();if(e.targetTouches){E=e.targetTouches[0];}else{E=e;}if(!E||!E.pageX){E=e;if((!E||!E.pageX)&&e.changedTouches){E=e.changedTouches[0];}}if(!E.pageX){return parseFloat(s);}if(E.pageX<c.offset().left){s=0;}else if((E.pageX-c.offset().left)>c.innerWidth()-f){s=this.getMaxValue();}else{p=(E.pageX-c.offset().left-f)/c.width();s=p*this.getMaxValue();}if(r){s=this.getMaxValue()-s;}return this._roundValueToVisualMode(s,true);};
R.prototype._roundValueToVisualMode=function(v,i){if(i){if(v<0.25){v=0;}else if(v<this.getMaxValue()-0.25){v+=0.25;}v=Math.round(v);}else{if(this.getVisualMode()===sap.m.RatingIndicatorVisualMode.Full){v=Math.round(v);}else if(this.getVisualMode()===sap.m.RatingIndicatorVisualMode.Half){v=Math.round(v*2)/2;}}return parseFloat(v);};
R.prototype.ontouchstart=function(e){if(e.which==2||e.which==3||!this.getEnabled()){return;}e.setMarked();if(!this._touchEndProxy){this._touchEndProxy=q.proxy(this._ontouchend,this);}if(!this._touchMoveProxy){this._touchMoveProxy=q.proxy(this._ontouchmove,this);}q(document).on("touchend.sapMRI touchcancel.sapMRI mouseup.sapMRI",this._touchEndProxy);q(document).on("touchmove.sapMRI mousemove.sapMRI",this._touchMoveProxy);this._fStartValue=this.getValue();var v=this._calculateSelectedValue(e);if(v>=0&&v<=this.getMaxValue()){this._updateUI(v,true);if(this._fStartValue!==v){this.fireLiveChange({value:v});}}};
R.prototype._ontouchmove=function(e){if(e.isMarked("delayedMouseEvent")){return;}e.preventDefault();if(this.getEnabled()){var v=this._calculateSelectedValue(e);if(v>=0&&v<=this.getMaxValue()){this._updateUI(v,true);if(this._fStartValue!==v){this.fireLiveChange({value:v});}}}};
R.prototype._ontouchend=function(e){if(e.isMarked("delayedMouseEvent")){return;}if(this.getEnabled()){var v=this._calculateSelectedValue(e);this.setProperty("value",v,true);this._updateUI(v,false);if(this._fStartValue!==v){this.fireLiveChange({value:v});this.fireChange({value:v});}q(document).off("touchend.sapMRI touchcancel.sapMRI mouseup.sapMRI",this._touchEndProxy);q(document).off("touchmove.sapMRI mousemove.sapMRI",this._touchMoveProxy);delete this._fStartValue;}};
R.prototype.ontouchcancel=R.prototype.ontouchend;
R.prototype.onsapincrease=function(e){var v=this.getValue(),o=this.getValue(),m=this.getMaxValue();if(!this.getEnabled()){return false;}if(this.getVisualMode()===sap.m.RatingIndicatorVisualMode.Full){v+=1;}else if(this.getVisualMode()===sap.m.RatingIndicatorVisualMode.Half){v+=0.5;}if(v>m){v=m;}this.setValue(v);if(v!==o){this.fireLiveChange({value:v});this.fireChange({value:v});}if(e){e.preventDefault();e.stopPropagation();}};
R.prototype.onsapdecrease=function(e){var v=this.getValue(),o=this.getValue();if(!this.getEnabled()){return false;}if(this.getVisualMode()===sap.m.RatingIndicatorVisualMode.Full){v-=1;}else if(this.getVisualMode()===sap.m.RatingIndicatorVisualMode.Half){v-=0.5;}if(v<0){v=0;}this.setValue(v);if(v!==o){this.fireLiveChange({value:v});this.fireChange({value:v});}if(e){e.preventDefault();e.stopPropagation();}};
R.prototype.onsaphome=function(e){var v=0,o=this.getValue();if(!this.getEnabled()){return false;}this.setValue(v);if(v!==o){this.fireLiveChange({value:v});this.fireChange({value:v});}if(e){e.preventDefault();e.stopPropagation();}};
R.prototype.onsapend=function(e){var v=this.getMaxValue(),o=this.getValue();if(!this.getEnabled()){return false;}this.setValue(v);if(v!==o){this.fireLiveChange({value:v});this.fireChange({value:v});}if(e){e.preventDefault();e.stopPropagation();}};
R.prototype.onsapselect=function(e){var v=this.getValue(),m=this.getMaxValue(),o=this.getValue();if(!this.getEnabled()){return false;}if(v===m){v=0;}else if(this.getVisualMode()===sap.m.RatingIndicatorVisualMode.Full){v+=1;}else if(this.getVisualMode()===sap.m.RatingIndicatorVisualMode.Half){v+=0.5;}if(v>m){v=m;}this.setValue(v);if(v!==o){this.fireLiveChange({value:v});this.fireChange({value:v});}if(e){e.preventDefault();e.stopPropagation();}};
R.prototype.onkeyup=function(e){var m=this.getMaxValue();if(!this.getEnabled()){return false;}switch(e.which){case q.sap.KeyCodes.DIGIT_0:case q.sap.KeyCodes.NUMPAD_0:this.setValue(0);break;case q.sap.KeyCodes.DIGIT_1:case q.sap.KeyCodes.NUMPAD_1:this.setValue(1);break;case q.sap.KeyCodes.DIGIT_2:case q.sap.KeyCodes.NUMPAD_2:this.setValue(Math.min(2,m));break;case q.sap.KeyCodes.DIGIT_3:case q.sap.KeyCodes.NUMPAD_3:this.setValue(Math.min(3,m));break;case q.sap.KeyCodes.DIGIT_4:case q.sap.KeyCodes.NUMPAD_4:this.setValue(Math.min(4,m));break;case q.sap.KeyCodes.DIGIT_5:case q.sap.KeyCodes.NUMPAD_5:this.setValue(Math.min(5,m));break;case q.sap.KeyCodes.DIGIT_6:case q.sap.KeyCodes.NUMPAD_6:this.setValue(Math.min(6,m));break;case q.sap.KeyCodes.DIGIT_7:case q.sap.KeyCodes.NUMPAD_7:this.setValue(Math.min(7,m));break;case q.sap.KeyCodes.DIGIT_8:case q.sap.KeyCodes.NUMPAD_8:this.setValue(Math.min(8,m));break;case q.sap.KeyCodes.DIGIT_9:case q.sap.KeyCodes.NUMPAD_9:this.setValue(Math.min(9,m));break;}};
R.prototype.getAccessibilityInfo=function(){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");return{role:"slider",type:b.getText("ACC_CTR_TYPE_RATING"),description:b.getText("ACC_CTR_STATE_RATING",[this.getValue(),this.getMaxValue()]),focusable:this.getEnabled(),enabled:this.getEnabled()};};
return R;},true);
sap.ui.predefine('sap/m/RatingIndicatorRenderer',['jquery.sap.global','sap/ui/core/IconPool'],function(q,I){"use strict";var R={},s='px';
R.render=function(r,c){var t=this;this.initSharedState(c);this.renderControlContainer(r,c,function(){t.renderAriaLabel(r,c);t.renderSelectedItems(r,c);t.renderUnselectedItems(r,c);t.renderHoverItems(r,c);t.renderSelectorDiv(r,c);});};
R.renderControlContainer=function(r,c,i){r.write("<div");r.writeControlData(c);r.writeAttribute("style","width: "+this._iWidth+"px");c.getEnabled()?r.writeAttribute("tabindex","0"):r.writeAttribute("tabindex","-1");c.getEnabled()?r.addClass("sapMPointer"):r.addClass("sapMRIDisabled");r.addClass("sapMRI");r.writeClasses();this.writeTooltip(r,c);this.writeAccessibility(r,c);r.write(">");i();r.write("</div>");};
R.initSharedState=function(c){var r=c._roundValueToVisualMode(c.getValue()),i=c._iPxIconSize,f=c._iPxPaddingSize,S=r*i+(Math.round(r)-1)*f;if(S<0){S=0;}this._bUseGradient=sap.ui.Device.browser.chrome||sap.ui.Device.browser.safari;this._sLabelID=c.getId()+"-ariaLabel";this._iSymbolCount=c.getMaxValue();this._iWidth=this._iSymbolCount*(i+f)-f;this._iSelectedWidth=S;this._fIconSize=i;};
R.writeTooltip=function(r,c){var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}};
R.writeAccessibility=function(r,c){r.writeAccessibilityState(c,{"role":"slider","orientation":"horizontal","live":"assertive","valuemin":0,"disabled":!c.getEnabled(),"labelledby":{value:this._sLabelID,append:true}});};
R.renderAriaLabel=function(r,c){r.write("<label id='"+this._sLabelID+"' class='sapMRIAriaLabel' aria-hidden='true'>"+c._oResourceBundle.getText("RATING_ARIA_NAME")+"</label>");};
R.renderSelectedItems=function(r,c){r.write("<div class='sapMRISel");if(this._bUseGradient){r.write(" sapMRIGrd");}r.write("'");r.writeAttribute("id",c.getId()+"-sel");r.writeAttribute("style","width: "+this._iSelectedWidth+s);r.write(">");for(var i=0;i<this._iSymbolCount;i++){this.renderIcon("SELECTED",r,c);}r.write("</div>");};
R.renderUnselectedItems=function(r,c){r.write("<div class='sapMRIUnselWrapper'");r.writeAttribute("id",c.getId()+"-unsel-wrapper");r.writeAttribute("style","width: "+(this._iWidth-this._iSelectedWidth)+s);r.write(">");r.write("<div class='sapMRIUnsel");if(this._bUseGradient&&c.getEnabled()){r.write(" sapMRIGrd");}r.write("' id='"+c.getId()+"-unsel'>");for(var i=0;i<this._iSymbolCount;i++){this.renderIcon("UNSELECTED",r,c);}r.write("</div>");r.write("</div>");};
R.renderHoverItems=function(r,c){if(c.getEnabled()){r.write("<div class='sapMRIHov' id='"+c.getId()+"-hov'>");for(var i=0;i<this._iSymbolCount;i++){this.renderIcon("HOVERED",r,c);}r.write("</div>");}};
R.renderSelectorDiv=function(r,c){r.write("<div class='sapMRISelector' id='"+c.getId()+"-selector'>");r.write("</div>");};
R.renderIcon=function(i,r,c){var a=this.getIconURI(i,c),t=this.getIconTag(a),b=sap.ui.core.IconPool.isIconURI(a),d=this._fIconSize+s;r.write("<"+t+" ");r.write("class='sapUiIcon "+this.getIconClass(i)+"' ");var e="";e+="width:"+d+";";e+="height:"+d+";";e+="line-height:"+d+";";e+="font-size:"+d+";";r.writeAttribute("style",e);if(!b){r.writeAttributeEscaped("src",a);}r.write(">");if(b){r.writeEscaped(I.getIconInfo(a).content);}r.write("</"+t+">");};
R.getIconClass=function(i){switch(i){case"SELECTED":return"sapMRIIconSel";case"UNSELECTED":return"sapMRIIconUnsel";case"HOVERED":return"sapMRIIconHov";}};
R.getIconURI=function(S,c){if(sap.ui.getCore().getConfiguration().getTheme()==="sap_hcb"){if(S=="UNSELECTED"&&c.getEnabled()){return I.getIconURI("unfavorite");}return I.getIconURI('favorite');}switch(S){case"SELECTED":return c.getIconSelected()||I.getIconURI("favorite");case"UNSELECTED":return c.getIconUnselected()||I.getIconURI("favorite");case"HOVERED":return c.getIconHovered()||I.getIconURI("favorite");}};
R.getIconTag=function(i){if(sap.ui.core.IconPool.isIconURI(i)){return"span";}return"img";};
return R;},true);
sap.ui.predefine('sap/m/ResponsivePopover',['jquery.sap.global','./Dialog','./Popover','./library','sap/ui/core/Control','sap/ui/core/IconPool'],function(q,D,P,l,C,I){"use strict";
var R=C.extend("sap.m.ResponsivePopover",{metadata:{library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Misc",defaultValue:sap.m.PlacementType.Right},showHeader:{type:"boolean",group:"Misc",defaultValue:true},title:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},modal:{type:"boolean",group:"Misc",defaultValue:null},offsetX:{type:"int",group:"Misc",defaultValue:null},offsetY:{type:"int",group:"Misc",defaultValue:null},showArrow:{type:"boolean",group:"Appearance",defaultValue:true},contentWidth:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},contentHeight:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},horizontalScrolling:{type:"boolean",group:"Misc",defaultValue:true},verticalScrolling:{type:"boolean",group:"Misc",defaultValue:true},showCloseButton:{type:"boolean",group:"Misc",defaultValue:true},resizable:{type:"boolean",group:"Dimension",defaultValue:false}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},customHeader:{type:"sap.m.IBar",multiple:false},subHeader:{type:"sap.m.IBar",multiple:false},beginButton:{type:"sap.m.Button",multiple:false},endButton:{type:"sap.m.Button",multiple:false},_popup:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{initialFocus:{type:"sap.ui.core.Control",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}}}}});
R.prototype.init=function(){var t=this;this._bAppendedToUIArea=false;var s={resizable:t.getResizable(),beforeOpen:function(e){t.fireBeforeOpen({openBy:e.getParameter('openBy')});},afterOpen:function(e){t.fireAfterOpen({openBy:e.getParameter('openBy')});},beforeClose:function(e){t.fireBeforeClose({openBy:e.getParameter('openBy'),origin:e.getParameter('origin')});},afterClose:function(e){t.fireAfterClose({openBy:e.getParameter('openBy'),origin:e.getParameter('origin')});}};if(sap.ui.Device.system.phone){this._aNotSupportedProperties=["placement","modal","offsetX","offsetY","showCloseButton"];s.stretch=true;s.type=sap.m.DialogType.Standard;this._oControl=new D(this.getId()+"-dialog",s);}else{this._aNotSupportedProperties=["icon","showCloseButton"];this._oControl=new P(this.getId()+"-popover",s);}this.setAggregation("_popup",this._oControl);this._oControl.addStyleClass("sapMResponsivePopover");this._oDelegate={onBeforeRendering:function(){var S=this.getShowCloseButton(),h=this._oControl._getAnyHeader(),n,p,r;if(!S||!sap.ui.Device.system.phone){this._removeCloseButton(h);return;}if(!this._bContentChanged){return;}this._bContentChanged=false;if(h){this._insertCloseButton(h);}else{n=this._getSingleNavContent();if(!n){return;}p=n.getCurrentPage();r=this._getRealPage(p);if(r&&(h=r._getAnyHeader())){this._insertCloseButton(h);}n.attachEvent("navigate",this._fnOnNavigate,this);}}};this._oPageDelegate={onAfterShow:function(){var r=t._getRealPage(this),h;if(r&&(h=r._getAnyHeader())){t._insertCloseButton(h);}}};this._fnOnNavigate=function(e){var p=e.getParameter("to");if(p){p.addEventDelegate(this._oPageDelegate,p);}};this._oControl.addEventDelegate(this._oDelegate,this);this._oControl._removeChild=function(c,a,S){var p,i;if((a==="content")&&(c instanceof sap.m.NavContainer)){p=c.getPages();for(i=0;i<p.length;i++){p[i].removeEventDelegate(t._oPageDelegate);}c.detachEvent("navigate",t._fnOnNavigate,t);}C.prototype._removeChild.apply(this,arguments);};};
R.prototype.openBy=function(p){if(!this._bAppendedToUIArea&&!this.getParent()){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.addContent(this,true);this._bAppendedToUIArea=true;}if(sap.ui.Device.system.phone){return this._oControl.open();}else{return this._oControl.openBy(p);}};
R.prototype.exit=function(){if(this._oCloseButton){this._oCloseButton.destroy();this._oCloseButton=null;}if(this._oControl){this._oControl.removeEventDelegate(this._oDelegate);this._oControl.destroy();this._oControl=null;}};
R.prototype._getCloseButton=function(){if(!this._oCloseButton){var t=this;this._oCloseButton=new sap.m.Button(this.getId()+"-closeButton",{icon:I.getIconURI("decline"),press:function(){t._oControl._oCloseTrigger=this;t.close();}});}return this._oCloseButton;};
R.prototype.addContent=function(c){this._bContentChanged=true;this.addAggregation("content",c);};
R.prototype.clone=function(){var c=C.prototype.clone.apply(this,arguments),a=this.getAggregation('_popup').getContent();for(var i=0;i<a.length;i++){c.addContent(a[i].clone());}return c;};
R.prototype._getSingleNavContent=function(){var c=this.getContent();while(c.length===1&&c[0]instanceof sap.ui.core.mvc.View){c=c[0].getContent();}if(c.length===1&&c[0]instanceof sap.m.NavContainer){return c[0];}else{return null;}};
R.prototype._getRealPage=function(p){var r=p,c;while(r){if(r instanceof sap.m.Page){return r;}if(r instanceof sap.ui.core.mvc.View){c=r.getContent();if(c.length===1){r=c[0];continue;}}r=null;}return r;};
R.prototype._insertCloseButton=function(h){var c=this._getCloseButton(),i;if(h){i=h.getAggregation("contentRight",[]).length;h.insertAggregation("contentRight",c,i);}};
R.prototype._removeCloseButton=function(h){var c=this._getCloseButton();if(h){h.removeAggregation("contentRight",c);}};
R.prototype._firstLetterUpperCase=function(v){return v.charAt(0).toUpperCase()+v.slice(1);};
R.prototype._lastIndexOfUpperCaseLetter=function(v){var i,c;for(i=v.length-1;i>=0;i--){c=v.charAt(i);if(c===c.toUpperCase()){return i;}}return-1;};
R.prototype._oldSetProperty=R.prototype.setProperty;
R.prototype.setProperty=function(p,v,s){this._oldSetProperty(p,v,true);var S="set"+this._firstLetterUpperCase(p);if(q.inArray(p,this._aNotSupportedProperties)===-1&&S in this._oControl){this._oControl[S](v);}return this;};
R.prototype._oldSetModel=R.prototype.setModel;
R.prototype.setModel=function(m,n){this._oControl.setModel(m,n);return this._oldSetModel(m,n);};
R.prototype._createButtonFooter=function(){if(this._oFooter){return this._oFooter;}this._oFooter=new sap.m.Toolbar(this.getId()+"-footer",{content:[new sap.m.ToolbarSpacer()]});return this._oFooter;};
R.prototype._setButton=function(p,b){if(this._oControl instanceof P){var g="get"+this._firstLetterUpperCase(p)+"Button",o=this[g](),f=this._createButtonFooter(),s="_o"+this._firstLetterUpperCase(p)+"Button",i=(p.toLowerCase()==="begin"?0:1),O=(p.toLowerCase()==="begin"?"getEndButton":"getBeginButton");if(o){f.removeContent(o);}if(b){if(!f.getParent()){this._oControl.setFooter(f);}f.insertContent(b,i+1);}else{var a=this[O]();if(!a){f.destroy();this._oFooter=null;}}this[s]=b;return this;}else{var A=p.toLowerCase()+"Button";return this.setAggregation(A,b);}};
R.prototype._getButton=function(p){if(this._oControl instanceof P){var s="_o"+this._firstLetterUpperCase(p)+"Button";return this[s];}else{var g="get"+this._firstLetterUpperCase(p)+"Button";return this._oControl[g]();}};
R.prototype.setBeginButton=function(b){if(b){b.setType(sap.m.ButtonType.Transparent);}this._oControl.setBeginButton(b);return this._setButton("begin",b);};
R.prototype.setEndButton=function(b){if(b){b.setType(sap.m.ButtonType.Transparent);}this._oControl.setEndButton(b);return this._setButton("end",b);};
R.prototype.setShowCloseButton=function(s){var h=this._oControl._getAnyHeader();if(s){this._insertCloseButton(h);}else{this._removeCloseButton(h);}this.setProperty("showCloseButton",s,true);return this;};
R.prototype.getBeginButton=function(){return this._getButton("begin");};
R.prototype.getEndButton=function(){return this._getButton("end");};
["bindAggregation","validateAggregation","setAggregation","getAggregation","indexOfAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation","setAssociation","getAssociation","addAssociation","removeAssociation","removeAllAssociation"].forEach(function(n){R.prototype[n]=function(){var L=this._lastIndexOfUpperCaseLetter(n),m,r;if(q.type(arguments[0])==="string"){if(L!==-1){m=n.substring(0,L)+this._firstLetterUpperCase(arguments[0]);if(this._oControl&&this._oControl[m]){r=this._oControl[m].apply(this._oControl,Array.prototype.slice.call(arguments,1));return r===this._oControl?this:r;}else{return C.prototype[n].apply(this,arguments);}}}r=this._oControl[n].apply(this._oControl,arguments);return r===this._oControl?this:r;};});["invalidate","close","isOpen","addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass","getDomRef","setBusy","getBusy","setBusyIndicatorDelay","getBusyIndicatorDelay"].forEach(function(n){R.prototype[n]=function(){if(this._oControl&&this._oControl[n]){var r=this._oControl[n].apply(this._oControl,arguments);return r===this._oControl?this:r;}};});return R;},true);
sap.ui.predefine('sap/m/ResponsivePopoverRenderer',['jquery.sap.global'],function(q){"use strict";var R={};
R.render=function(r,c){};
return R;},true);
sap.ui.predefine('sap/m/ScrollContainer',["jquery.sap.global","./library","sap/ui/core/Control","sap/ui/core/delegate/ScrollEnablement"],function(q,l,C,S){"use strict";
var a=C.extend("sap.m.ScrollContainer",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},horizontal:{type:"boolean",group:"Behavior",defaultValue:true},vertical:{type:"boolean",group:"Behavior",defaultValue:false},focusable:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}}}});
a.prototype.init=function(){this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:true,vertical:false});};
a.prototype.onBeforeRendering=function(){this._oScroller.setHorizontal(this.getHorizontal());this._oScroller.setVertical(this.getVertical());};
a.prototype.exit=function(){if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}};
a.prototype.getScrollDelegate=function(){return this._oScroller;};
a.prototype.scrollTo=function(x,y,t){if(this._oScroller){var d=this.getDomRef();if(d){if(sap.ui.getCore().getConfiguration().getRTL()){x=q.sap.denormalizeScrollBeginRTL(x,d);}this._oScroller.scrollTo(x,y,t);}else{this._oScroller._scrollX=x;this._oScroller._scrollY=y;}}return this;};
a.prototype.scrollToElement=function(e,t){if(e instanceof sap.ui.core.Element){e=e.getDomRef();}if(this._oScroller){this._oScroller.scrollToElement(e,t);}return this;};
a.prototype.setHorizontal=function(h){this._oScroller.setHorizontal(h);return this.setProperty("horizontal",h,true);};
a.prototype.setVertical=function(v){this._oScroller.setVertical(v);return this.setProperty("vertical",v,true);};
return a;},true);
sap.ui.predefine('sap/m/ScrollContainerRenderer',['jquery.sap.global'],function(q){"use strict";var S={};
S.render=function(r,c){r.write("<div");r.writeControlData(c);var w=c.getWidth(),h=c.getHeight();if(w){r.addStyle("width",w);}if(h){r.addStyle("height",h);}r.writeStyles();if(c.getVertical()){if(!c.getHorizontal()){r.addClass("sapMScrollContV");}else{r.addClass("sapMScrollContVH");}}else if(c.getHorizontal()){r.addClass("sapMScrollContH");}r.addClass("sapMScrollCont");r.writeClasses();var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}if(c.getFocusable()){r.writeAttributeEscaped("tabindex","0");}r.write("><div id='"+c.getId()+"-scroll' class='sapMScrollContScroll'>");var C=c.getContent(),l=C.length;for(var i=0;i<l;i++){r.renderControl(C[i]);}r.write("</div></div>");};
return S;},true);
sap.ui.predefine('sap/m/SearchField',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/InvisibleText','./Suggest'],function(q,l,C,E,I,a,S){"use strict";
var b=C.extend("sap.m.SearchField",{metadata:{library:"sap.m",properties:{value:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},visible:{type:"boolean",group:"Appearance",defaultValue:true},maxLength:{type:"int",group:"Behavior",defaultValue:0},placeholder:{type:"string",group:"Misc",defaultValue:null},showMagnifier:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},showRefreshButton:{type:"boolean",group:"Behavior",defaultValue:false},refreshButtonTooltip:{type:"string",group:"Misc",defaultValue:null},showSearchButton:{type:"boolean",group:"Behavior",defaultValue:true},enableSuggestions:{type:"boolean",group:"Behavior",defaultValue:false},selectOnFocus:{type:"boolean",group:"Behavior",defaultValue:true,deprecated:true}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},defaultAggregation:"suggestionItems",aggregations:{suggestionItems:{type:"sap.m.SuggestionItem",multiple:true,singularName:"suggestionItem"}},events:{search:{parameters:{query:{type:"string"},suggestionItem:{type:"sap.m.SuggestionItem"},refreshButtonPressed:{type:"boolean"},clearButtonPressed:{type:"boolean"}}},liveChange:{parameters:{newValue:{type:"string"}}},suggest:{parameters:{suggestValue:{type:"string"}}}}}});
E.call(b.prototype);I.insertFontFaceStyle();
b.prototype.init=function(){this._inputEvent=sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<10?"keyup":"input";var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setProperty("placeholder",r.getText("FACETFILTER_SEARCH"),true);this._sAriaF5Label=new sap.ui.core.InvisibleText({text:r.getText("SEARCHFIELD_ARIA_F5")}).toStatic();};
b.prototype.getFocusDomRef=function(){return this._inputElement;};
b.prototype.getFocusInfo=function(){var f=C.prototype.getFocusInfo.call(this),i=this.getDomRef("I");if(i){q.extend(f,{cursorPos:q(i).cursorPos()});}return f;};
b.prototype.applyFocusInfo=function(f){C.prototype.applyFocusInfo.call(this,f);if("cursorPos"in f){this.$("I").cursorPos(f.cursorPos);}return this;};
b.prototype.getWidth=function(){return this.getProperty("width")||"100%";};
b.prototype._hasPlacehoder=(function(){return"placeholder"in document.createElement("input");}());
b.prototype.onBeforeRendering=function(){if(this._inputElement){this.$().find(".sapMSFB").off();this.$().off();q(this._inputElement).off();this._inputElement=null;}};
b.prototype.onAfterRendering=function(){this._inputElement=this.getDomRef("I");this._resetElement=this.getDomRef("reset");q(this._inputElement).on(this._inputEvent,this.onInput.bind(this)).on("search",this.onSearch.bind(this)).on("focus",this.onFocus.bind(this)).on("blur",this.onBlur.bind(this));if(sap.ui.Device.system.desktop||sap.ui.Device.system.combi){this.$().on("touchstart mousedown",this.onButtonPress.bind(this));if(sap.ui.Device.browser.firefox){this.$().find(".sapMSFB").on("mouseup mouseout",function(f){q(f.target).removeClass("sapMSFBA");});}}else if(window.PointerEvent){q(this._resetElement).on("touchstart",function(){this._active=document.activeElement;}.bind(this));}};
b.prototype.clear=function(O){var v=O&&O.value||"";if(!this._inputElement||this.getValue()===v){return;}this.setValue(v);u(this);this.fireLiveChange({newValue:v});this.fireSearch({query:v,refreshButtonPressed:false,clearButtonPressed:!!(O&&O.clearButton)});};
b.prototype.exit=function(){if(this._oSuggest){this._oSuggest.destroy(true);this._oSuggest=null;}if(this._sAriaF5Label){this._sAriaF5Label.destroy();this._sAriaF5Label=null;}};
b.prototype.onButtonPress=function(f){if(f.originalEvent.button===2){return;}if(document.activeElement===this._inputElement&&f.target!==this._inputElement){f.preventDefault();}if(sap.ui.Device.browser.firefox){var g=q(f.target);if(g.hasClass("sapMSFB")){g.addClass("sapMSFBA");}}};
b.prototype.ontouchend=function(f){if(f.originalEvent.button===2){return;}var g=f.target;if(g.id==this.getId()+"-reset"){c(this);this._bSuggestionSuppressed=true;var h=!this.getValue();this.clear({clearButton:true});var i=document.activeElement;if((sap.ui.Device.system.desktop||h||/(INPUT|TEXTAREA)/i.test(i.tagName)||i===this._resetElement&&this._active===this._inputElement)&&(i!==this._inputElement)){this._inputElement.focus();}}else if(g.id==this.getId()+"-search"){c(this);if(sap.ui.Device.system.desktop&&!this.getShowRefreshButton()&&(document.activeElement!==this._inputElement)){this._inputElement.focus();}this.fireSearch({query:this.getValue(),refreshButtonPressed:!!(this.getShowRefreshButton()&&!this.$().hasClass("sapMFocus")),clearButtonPressed:false});}else{this.onmouseup(f);}};
b.prototype.onmouseup=function(f){if(this.getEnabled()&&f.target.tagName=="FORM"){this._inputElement.focus();}};
b.prototype.onSearch=function(f){var v=this._inputElement.value;this.setValue(v);this.fireSearch({query:v,refreshButtonPressed:false,clearButtonPressed:false});if(!sap.ui.Device.system.desktop){this._blur();}};
b.prototype._blur=function(){var t=this;window.setTimeout(function(){if(t._inputElement){t._inputElement.blur();}},13);};
b.prototype.onChange=function(f){this.setValue(this._inputElement.value);};
b.prototype.onInput=function(f){var v=this._inputElement.value;if(v!=this.getValue()){this.setValue(v);this.fireLiveChange({newValue:v});if(this.getEnableSuggestions()){this.fireSuggest({suggestValue:v});u(this);}}};
b.prototype.onkeydown=function(f){var v;if(f.which===q.sap.KeyCodes.F5||f.which===q.sap.KeyCodes.ENTER){this.$("search").toggleClass("sapMSFBA",true);f.stopPropagation();f.preventDefault();}if(f.which===q.sap.KeyCodes.ESCAPE){if(d(this)){c(this);f.setMarked();}else{v=this.getValue();if(v===this._sOriginalValue){this._sOriginalValue="";}this.clear({value:this._sOriginalValue});if(v!==this.getValue()){f.setMarked();}}f.preventDefault();}};
b.prototype.onkeyup=function(f){var g;var h;if(f.which===q.sap.KeyCodes.F5||f.which===q.sap.KeyCodes.ENTER){this.$("search").toggleClass("sapMSFBA",false);if(d(this)){c(this);if((g=this._oSuggest.getSelected())>=0){h=this.getSuggestionItems()[g];this.setValue(h.getSuggestionText());}}this.fireSearch({query:this.getValue(),suggestionItem:h,refreshButtonPressed:this.getShowRefreshButton()&&f.which===q.sap.KeyCodes.F5,clearButtonPressed:false});}};
b.prototype.onFocus=function(f){if(sap.ui.Device.browser.internet_explorer&&!document.hasFocus()){return;}this.$().toggleClass("sapMFocus",true);if(this.getShowRefreshButton()){this.$("search").removeAttr("title");}this._sOriginalValue=this.getValue();if(this.getEnableSuggestions()){if(!this._bSuggestionSuppressed){this.fireSuggest({suggestValue:this.getValue()});}else{this._bSuggestionSuppressed=false;}}};
b.prototype.onBlur=function(f){var t;this.$().toggleClass("sapMFocus",false);if(this._bSuggestionSuppressed){this._bSuggestionSuppressed=false;}if(this.getShowRefreshButton()){t=this.getRefreshButtonTooltip();if(t){this.$("search").attr("title",t);}}};
b.prototype.setValue=function(v){v=v||"";if(this._inputElement){if(this._inputElement.value!==v){this._inputElement.value=v;}var $=this.$();if($.hasClass("sapMSFVal")==!v){$.toggleClass("sapMSFVal",!!v);}}this.setProperty("value",v,true);return this;};
b.prototype.onsapshow=function(f){if(this.getEnableSuggestions()){if(d(this)){c(this);}else{this.fireSuggest({suggestValue:this.getValue()});}}};
b.prototype.onsaphide=function(f){this.suggest(false);};
function s(f,g,i,r){var h;if(d(f)){h=f._oSuggest.setSelected(i,r);if(h>=0){f.setValue(f.getSuggestionItems()[h].getSuggestionText());}g.preventDefault();}}
b.prototype.onsapdown=function(f){s(this,f,1,true);};
b.prototype.onsapup=function(f){s(this,f,-1,true);};
b.prototype.onsaphome=function(f){s(this,f,0,false);};
b.prototype.onsapend=function(f){s(this,f,-1,false);};
b.prototype.onsappagedown=function(f){s(this,f,10,true);};
b.prototype.onsappageup=function(f){s(this,f,-10,true);};
b.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("F");};
function c(f){f._oSuggest&&f._oSuggest.close();}
function o(f){if(f.getEnableSuggestions()){if(!f._oSuggest){f._oSuggest=new S(f);}f._oSuggest.open();}}
function d(f){return f._oSuggest&&f._oSuggest.isOpen();}
b.prototype.suggest=function(f){if(this.getEnableSuggestions()){f=f===undefined||!!f;if(f&&(this.getSuggestionItems().length||sap.ui.Device.system.phone)){o(this);}else{c(this);}}return this;};
function u(f){f._oSuggest&&f._oSuggest.update();}
var e="suggestionItems";
b.prototype.insertSuggestionItem=function(O,i,f){u(this);return C.prototype.insertAggregation.call(this,e,O,i,true);};
b.prototype.addSuggestionItem=function(O,f){u(this);return C.prototype.addAggregation.call(this,e,O,true);};
b.prototype.removeSuggestionItem=function(O,f){u(this);return C.prototype.removeAggregation.call(this,e,O,true);};
b.prototype.removeAllSuggestionItems=function(f){u(this);return C.prototype.removeAllAggregation.call(this,e,true);};
return b;},true);
sap.ui.predefine('sap/m/SearchFieldRenderer',['jquery.sap.global'],function(q){"use strict";var S={};
S.render=function(r,s){if(!s.getVisible()){return;}var p=s.getPlaceholder(),v=s.getValue(),w=s.getProperty("width"),i=s.getId(),b=s.getShowRefreshButton(),a=s.getShowSearchButton(),A={};r.write("<div");r.writeControlData(s);if(w){r.writeAttribute("style","width:"+w+";");}r.addClass("sapMSF");if(v){r.addClass("sapMSFVal");}if(!s.getEnabled()){r.addClass("sapMSFDisabled");}r.writeClasses();var t=s.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.write(">");r.write('<form method="post" action="javascript:void(0);"');r.writeAttribute("id",i+"-F");r.addClass('sapMSFF');if(!a){r.addClass("sapMSFNS");}else if(b){r.addClass('sapMSFReload');}r.writeClasses();r.write('>');if(!s._hasPlacehoder&&p){r.write("<label ");r.writeAttribute("id",i+"-P");r.writeAttribute("for",i+"-I");r.addClass("sapMSFPlaceholder");r.writeClasses();r.write(">");r.writeEscaped(p);r.write("</label>");}r.write('<input type="search" autocorrect="off" autocomplete="off"');r.writeAttribute("id",s.getId()+"-I");r.addClass("sapMSFI");if(sap.ui.Device.os.android&&sap.ui.Device.os.version>=4&&sap.ui.Device.os.version<4.1){r.addClass("sapMSFIA4");}r.writeClasses();if(s.getEnableSuggestions()&&sap.ui.Device.system.phone){r.writeAttribute("readonly","readonly");}if(!s.getEnabled()){r.writeAttribute("disabled","disabled");}if(p){r.writeAttributeEscaped("placeholder",p);}if(s.getMaxLength()){r.writeAttribute("maxLength",s.getMaxLength());}if(v){r.writeAttributeEscaped("value",v);}if(s.getEnabled()&&b&&s._sAriaF5Label){A.describedby={value:s._sAriaF5Label.getId(),append:true};}r.writeAccessibilityState(s,A);r.write(">");if(s.getEnabled()){r.write("<div");r.writeAttribute("id",s.getId()+"-reset");r.addClass("sapMSFR");r.addClass("sapMSFB");if(sap.ui.Device.browser.firefox){r.addClass("sapMSFBF");}if(!a){r.addClass("sapMSFNS");}r.writeClasses();r.write("></div>");if(a){r.write("<div");r.writeAttribute("id",s.getId()+"-search");r.addClass("sapMSFS");r.addClass("sapMSFB");if(sap.ui.Device.browser.firefox){r.addClass("sapMSFBF");}r.writeClasses();if(s.getRefreshButtonTooltip()){r.writeAttributeEscaped("title",s.getRefreshButtonTooltip());}r.write("></div>");}}r.write("</form>");r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/m/SegmentedButton',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/delegate/ItemNavigation','sap/ui/core/ResizeHandler'],function(q,l,C,E,I,R){"use strict";
var S=C.extend("sap.m.SegmentedButton",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},selectedKey:{type:"string",group:"Data",defaultValue:"",bindable:"bindable"}},defaultAggregation:"buttons",aggregations:{buttons:{type:"sap.m.Button",multiple:true,singularName:"button"},items:{type:"sap.m.SegmentedButtonItem",multiple:true,singularName:"item",bindable:"bindable"},_select:{type:"sap.m.Select",multiple:false,visibility:"hidden"}},associations:{selectedButton:{type:"sap.m.Button",multiple:false},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{parameters:{button:{type:"sap.m.Button"},id:{type:"string"},key:{type:"string"}}}}}});
E.call(S.prototype);
S.prototype.init=function(){this._aWidths=[];this._oItemNavigation=new I();this._oItemNavigation.setCycling(false);this.addDelegate(this._oItemNavigation);this.removeButton=function(b){S.prototype.removeButton.call(this,b);this.setSelectedButton(this.getButtons()[0]);};};
S.prototype.onBeforeRendering=function(){var b=this._getVisibleButtons();this._bCustomButtonWidth=b.some(function(B){return B.getWidth();});if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this.setSelectedKey(this.getProperty("selectedKey"));if(!this.getSelectedButton()){this._selectDefaultButton();}};
S.prototype.onAfterRendering=function(){var b=this._getVisibleButtons(),p;if(!this._sResizeListenerId){p=this.getDomRef().parentNode;if(p){this._sResizeListenerId=R.register(p,this._handleContainerResize.bind(this));}}this._setItemNavigation();this._aWidths=this._getRenderedButtonWidths(b);this._updateWidth();};
S.prototype._handleContainerResize=function(){var b=this._getVisibleButtons();this._clearAutoWidthAppliedToControl();this._aWidths=this._getRenderedButtonWidths(b);this._updateWidth();};
S.prototype._clearAutoWidthAppliedToControl=function(){var b=this._getVisibleButtons(),B=b.length,o,i=0;if(!this.getWidth()){this.$().css("width","");}while(i<B){o=b[i];if(!o.getWidth()){o.$().css("width","");}i++;}};
S.prototype._getRenderedButtonWidths=function(b){return b.map(function(B){return B.$().outerWidth();});};
S.prototype._getButtonWidth=function(b){var B=b.length,w,n=0,s=0,a=0,p,P,i=0;if(this._bCustomButtonWidth){while(i<B){w=b[i].getWidth();if(w){if(w.indexOf("%")!==-1){s+=parseInt(w.slice(0,-1),10);}else{a+=parseInt(w.slice(0,-2),10);}}else{n++;}i++;}if(n===0){return false;}p=(100-s)/n;P=(a/n);if(p<0){p=0;}if(P<0){P=0;}if(P>0){return"calc("+p+"% - "+P+"px)";}else{return p+"%";}}else{return(100/B)+"%";}};
S.prototype._updateWidth=function(){if(this.$().length===0||this.hasStyleClass("sapMSegmentedButtonNoAutoWidth")){return;}var c=this.getWidth(),b=this._getVisibleButtons(),B=b.length,m=(this._aWidths.length>0)?Math.max.apply(Math,this._aWidths):0,a=(100/B),p=this.$().parent().innerWidth(),w=this._getButtonWidth(b),o,i;if(!c){if((m*B)>p){this.$().css("width","100%");}else if(m>0){this.$().width((m*B)+1);}i=0;while(i<B){o=b[i];o.$().css("width",o.getWidth()?o.getWidth():w);i++;}}else if(c&&!this._bCustomButtonWidth){i=0;while(i<B){b[i].$().css("width",a+"%");i++;}}};
S.prototype.exit=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}this._bCustomButtonWidth=null;this._aWidths=null;};
S.prototype._setItemNavigation=function(){var b,d=this.getDomRef();if(d){this._oItemNavigation.setRootDomRef(d);b=this.$().find(".sapMSegBBtn:not(.sapMSegBBtnDis)");this._oItemNavigation.setItemDomRefs(b);this._focusSelectedButton();}};
S.prototype.createButton=function(t,u,e,T){var b=new sap.m.Button();if(t!==null){b.setText(t);}if(u!==null){b.setIcon(u);}if(e||e===undefined){b.setEnabled(true);}else{b.setEnabled(false);}if(T){b.setTextDirection(T);}this.addButton(b);return b;};
S.prototype._createButtonFromItem=function(i){var b=new sap.m.Button(i.getId()+"-button",{text:i.getText(),icon:i.getIcon(),enabled:i.getEnabled(),textDirection:i.getTextDirection(),width:i.getWidth(),tooltip:i.getTooltip(),visible:i.getVisible(),press:function(){i.firePress();}});i.oButton=b;this.addButton(b);};
(function(){
S.prototype.addButton=function(b){if(b){p(b,this);this.addAggregation('buttons',b);this._syncSelect();return this;}};
S.prototype.insertButton=function(b,i){if(b){p(b,this);this.insertAggregation('buttons',b,i);this._syncSelect();return this;}};
function p(b,P){b.attachPress(function(e){P._buttonPressed(e);});b.attachEvent("_change",P._syncSelect,P);b.attachEvent("_change",P._forwardChangeEvent,P);var o=sap.m.Button.prototype.setEnabled;b.setEnabled=function(e){b.$().toggleClass("sapMSegBBtnDis",!e).toggleClass("sapMFocusable",e);o.apply(b,arguments);};b.setVisible=function(v){sap.m.Button.prototype.setVisible.apply(this,arguments);P.invalidate();};}
})();
S.prototype.updateItems=function(r){var b=this.getButtons(),a,u,i;if(r!==undefined){this.updateAggregation("items");}a=this.getAggregation("items");if(a&&b.length!==0){for(i=0;i<b.length;i++){this.removeButton(b[i]);b[i].destroy();b[i]=null;}u=true;}a=a||[];for(i=0;i<a.length;i++){this._createButtonFromItem(a[i]);}if(u){this._updateWidth();}};
S.prototype.getSelectedKey=function(){var b=this.getButtons(),a=this.getItems(),s=this.getSelectedButton(),i=0;if(a.length>0){for(;i<b.length;i++){if(b[i]&&b[i].getId()===s){this.setProperty("selectedKey",a[i].getKey(),true);return a[i].getKey();}}}return"";};
S.prototype.setSelectedKey=function(k){var b=this.getButtons(),a=this.getItems(),i=0;if(b.length===0&&a.length>0){this.updateItems();b=this.getButtons();}if(a.length>0&&b.length>0){for(;i<a.length;i++){if(a[i]&&a[i].getKey()===k){this.setSelectedButton(b[i]);break;}}}this.setProperty("selectedKey",k,true);return this;};
S.prototype.removeButton=function(b){var r=this.removeAggregation("buttons",b);if(r){delete r.setEnabled;r.detachEvent("_change",this._syncSelect,this);r.detachEvent("_change",this._forwardChangeEvent,this);this._syncSelect();}};
S.prototype.removeAllButtons=function(){var b=this.getButtons();if(b){for(var i=0;i<b.length;i++){var B=b[i];if(B){delete B.setEnabled;this.removeAggregation("buttons",B);B.detachEvent("_change",this._syncSelect,this);B.detachEvent("_change",this._forwardChangeEvent,this);}}this._syncSelect();}};
S.prototype._buttonPressed=function(e){var b=e.getSource();if(this.getSelectedButton()!==b.getId()){this.getButtons().forEach(function(B){B.$().removeClass("sapMSegBBtnSel");B.$().attr("aria-checked",false);});b.$().addClass("sapMSegBBtnSel");b.$().attr("aria-checked",true);this.setAssociation('selectedButton',b,true);this.setProperty("selectedKey",this.getSelectedKey(),true);this.fireSelect({button:b,id:b.getId(),key:this.getSelectedKey()});}};
S.prototype._selectDefaultButton=function(){var b=this._getVisibleButtons();if(b.length>0){this.setAssociation('selectedButton',b[0],true);}};
S.prototype.setSelectedButton=function(b){var s=this.getSelectedButton(),o;this.setAssociation("selectedButton",b,true);if(s!==this.getSelectedButton()){if(this.$().length){if(!this.getSelectedButton()){this._selectDefaultButton();}o=sap.ui.getCore().byId(this.getSelectedButton());this.getButtons().forEach(function(B){B.$().removeClass("sapMSegBBtnSel");B.$().attr("aria-checked",false);});if(o){o.$().addClass("sapMSegBBtnSel");o.$().attr("aria-checked",true);}this._focusSelectedButton();}}this._syncSelect();return this;};
S.prototype._focusSelectedButton=function(){var b=this.getButtons(),s=this.getSelectedButton(),i=0;for(;i<b.length;i++){if(b[i]&&b[i].getId()===s){this._oItemNavigation.setFocusedIndex(i);break;}}};
S.prototype.onsappagedown=function(e){this._oItemNavigation.onsapend(e);};
S.prototype.onsappageup=function(e){this._oItemNavigation.onsaphome(e);};
S.prototype._lazyLoadSelectForm=function(){var s=this.getAggregation("_select");if(!s){s=new sap.m.Select(this.getId()+"-select");s.attachChange(this._selectChangeHandler,this);s.addStyleClass("sapMSegBSelectWrapper");this.setAggregation("_select",s,true);}};
S.prototype._selectChangeHandler=function(e){var s=e.getParameter("selectedItem"),n=parseInt(s.getKey(),10),b=this.getButtons()[n],B=b.getId();b.firePress();this.setSelectedButton(B);this.fireSelect({button:b,id:B,key:n});};
S.prototype._forwardChangeEvent=function(){this.fireEvent("_change");};
S.prototype._syncSelect=function(){var k=0,s=0,b,o=this.getAggregation("_select");if(!o){return;}o.destroyItems();this._getVisibleButtons().forEach(function(B){b=B.getText();o.addItem(new sap.ui.core.Item({key:k.toString(),text:b?b:B.getTooltip_AsString(),enabled:B.getEnabled()}));if(B.getId()===this.getSelectedButton()){s=k;}k++;},this);o.setSelectedKey(s.toString());};
S.prototype._toSelectMode=function(){this._bInOverflow=true;this.addStyleClass("sapMSegBSelectWrapper");this._lazyLoadSelectForm();this._syncSelect();};
S.prototype._toNormalMode=function(){delete this._bInOverflow;this.removeStyleClass("sapMSegBSelectWrapper");this.getAggregation("_select").removeAllItems();this.destroyAggregation("_select");};
S.prototype._overwriteImageOnload=function(i){var t=this;if(i.onload===sap.m.Image.prototype.onload){i.onload=function(){if(sap.m.Image.prototype.onload){sap.m.Image.prototype.onload.apply(this,arguments);}window.setTimeout(function(){t._updateWidth();},20);};}};
S.prototype._getIconAriaLabel=function(i){var o=sap.ui.core.IconPool.getIconInfo(i.getSrc()),r="";if(o&&o.name){r=o.name;}return r;};
S.prototype._getVisibleButtons=function(){return this.getButtons().filter(function(b){return b.getVisible();});};
return S;},true);
sap.ui.predefine('sap/m/SegmentedButtonItem',['jquery.sap.global','./library','sap/ui/core/Item'],function(q,l,I){"use strict";
var S=I.extend("sap.m.SegmentedButtonItem",{metadata:{library:"sap.m",properties:{icon:{type:"string",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},events:{press:{}}}});
S.prototype.setText=function(v){this.setProperty("text",v,true);if(this.oButton){this.oButton.setText(this.getText());}return this;};
S.prototype.setIcon=function(v){this.setProperty("icon",v,true);if(this.oButton){this.oButton.setIcon(this.getIcon());}return this;};
S.prototype.setEnabled=function(v){this.setProperty("enabled",v,true);if(this.oButton){this.oButton.setEnabled(this.getEnabled());}return this;};
S.prototype.setTextDirection=function(v){this.setProperty("textDirection",v,true);if(this.oButton){this.oButton.setTextDirection(this.getTextDirection());}return this;};
S.prototype.setVisible=function(v){this.setProperty("visible",v,true);if(this.oButton){this.oButton.setVisible(v);}return this;};
S.prototype.setWidth=function(v){this.setProperty("width",v,true);if(this.oButton){this.oButton.setWidth(this.getWidth());}return this;};
S.prototype.setTooltip=function(v){this.setAggregation("tooltip",v,true);if(this.oButton){this.oButton.setTooltip(v);}return this;};
return S;},true);
sap.ui.predefine('sap/m/SegmentedButtonRenderer',['jquery.sap.global'],function(q){"use strict";var S={};
S.render=function(r,c){var b=c.getButtons(),s=c.getSelectedButton(),B,t,a,d;if(c._bInOverflow){r.write("<div");r.writeControlData(c);r.writeClasses();r.write(">");r.renderControl(c.getAggregation("_select"));r.write("</div>");return;}r.write("<ul");if(S._addAllIconsClass(b)){r.addClass("sapMSegBIcons");}r.addClass("sapMSegB");r.writeClasses();if(c.getWidth()&&c.getWidth()!==''){r.addStyle('width',c.getWidth());}r.writeStyles();r.writeControlData(c);t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.writeAccessibilityState(c,{role:"radiogroup"});r.write(">");for(var i=0;i<b.length;i++){B=b[i];r.write("<li");if(B.getVisible()){var e=B.getText(),o=B.getIcon(),I="",f;if(o){f=B._getImage((B.getId()+"-img"),o);if(f instanceof sap.m.Image){c._overwriteImageOnload(f);}else if(!B.getTooltip()){I=c._getIconAriaLabel(f);}}r.writeControlData(B);r.writeAttribute("aria-posinset",i+1);r.writeAttribute("aria-setsize",b.length);r.addClass("sapMSegBBtn");if(B.aCustomStyleClasses!==undefined&&B.aCustomStyleClasses instanceof Array){for(var j=0;j<B.aCustomStyleClasses.length;j++){r.addClass(B.aCustomStyleClasses[j]);}}if(B.getEnabled()){r.addClass("sapMSegBBtnFocusable");}else{r.addClass("sapMSegBBtnDis");}if(s===B.getId()){r.addClass("sapMSegBBtnSel");}if(o&&e!==''){r.addClass("sapMSegBBtnMixed");}r.writeClasses();a=B.getWidth();if(a){r.addStyle('width',a);r.writeStyles();}t=B.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.writeAttribute("tabindex",B.getEnabled()?"0":"-1");d=B.getTextDirection();if(d!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",d.toLowerCase());}r.writeAccessibilityState(B,{role:"radio",checked:s===B.getId()});if(f&&I!==""){if(e!==""){I+=" "+e;}else{r.writeAttributeEscaped("title",I);}r.writeAttributeEscaped("aria-label",I);}r.write('>');if(o&&f){r.renderControl(f);}if(e!==''){r.writeEscaped(e,false);}}else{r.writeInvisiblePlaceholderData(B);r.write('>');}r.write("</li>");}r.write("</ul>");};
S._addAllIconsClass=function(b){for(var i=0;i<b.length;i++){if(!b[i].getIcon()){return false;}}return true;};
return S;},true);
sap.ui.predefine('sap/m/Select.designtime',[],function(){"use strict";return{aggregations:{items:{domRef:":sap-domref"}}};},false);
sap.ui.predefine('sap/m/Select',['jquery.sap.global','./Dialog','./Popover','./SelectList','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','./Button','./delegate/ValueStateMessage'],function(q,D,P,S,l,C,E,I,B,V){"use strict";
var a=C.extend("sap.m.Select",{metadata:{library:"sap.m",properties:{name:{type:"string",group:"Misc",defaultValue:""},enabled:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},selectedKey:{type:"string",group:"Data",defaultValue:""},selectedItemId:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},type:{type:"sap.m.SelectType",group:"Appearance",defaultValue:sap.m.SelectType.Default},autoAdjustWidth:{type:"boolean",group:"Appearance",defaultValue:false},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:sap.ui.core.TextAlign.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:sap.ui.core.ValueState.None},valueStateText:{type:"string",group:"Misc",defaultValue:""},showSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false},forceSelection:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable"},picker:{type:"sap.ui.core.PopupInterface",multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}},designTime:true}});
I.insertFontFaceStyle();E.apply(a.prototype,[true]);
function h(i){if(i){this.setSelection(i);this.setValue(i.getText());this.scrollToItem(i);}}
a.prototype._handleFocusout=function(){this._bFocusoutDueRendering=this.bRenderingPhase;if(this._bFocusoutDueRendering){this._bProcessChange=false;return;}if(this._bProcessChange){this._checkSelectionChange();this._bProcessChange=false;}else{this._bProcessChange=true;}};
a.prototype._checkSelectionChange=function(){var i=this.getSelectedItem();if(this._oSelectionOnFocus!==i){this.fireChange({selectedItem:i});}};
a.prototype._getSelectedItemText=function(i){i=i||this.getSelectedItem();if(!i){i=this.getDefaultSelectedItem();}if(i){return i.getText();}return"";};
a.prototype._callMethodInControl=function(f,A){var L=this.getList();if(A[0]==="items"){if(L){return S.prototype[f].apply(L,A);}}else{return C.prototype[f].apply(this,A);}};
a.prototype.findFirstEnabledItem=function(i){var L=this.getList();return L?L.findFirstEnabledItem(i):null;};
a.prototype.findLastEnabledItem=function(i){var L=this.getList();return L?L.findLastEnabledItem(i):null;};
a.prototype.setSelectedIndex=function(i,_){var o;_=_||this.getItems();i=(i>_.length-1)?_.length-1:Math.max(0,i);o=_[i];if(o){this.setSelection(o);}};
a.prototype.scrollToItem=function(i){var p=this.getPicker(),o=p.getDomRef("cont"),b=i&&i.getDomRef();if(!p||!o||!b){return;}var c=o.scrollTop,d=b.offsetTop,e=o.clientHeight,f=b.offsetHeight;if(c>d){o.scrollTop=d;}else if((d+f)>(c+e)){o.scrollTop=Math.ceil(d+f-e);}};
a.prototype.setValue=function(v){this.$("label").text(v);};
a.prototype._isShadowListRequired=function(){if(this.getAutoAdjustWidth()){return false;}else if(this.getWidth()==="auto"){return true;}return false;};
a.prototype._handleAriaActiveDescendant=function(i){var d=this.getDomRef(),o=i&&i.getDomRef(),A="aria-activedescendant";if(!d){return;}if(o&&this.isOpen()){d.setAttribute(A,i.getId());}else{d.removeAttribute(A);}};
a.prototype.getList=function(){if(this.bIsDestroyed){return null;}return this._oList;};
a.prototype.updateItems=function(r){S.prototype.updateItems.apply(this,arguments);this._oSelectionOnFocus=this.getSelectedItem();};
a.prototype.refreshItems=function(){S.prototype.refreshItems.apply(this,arguments);};
a.prototype.onBeforeOpen=function(c){var p=this["_onBeforeOpen"+this.getPickerType()];this.addStyleClass(this.getRenderer().CSS_CLASS+"Pressed");this.closeValueStateMessage();this.addContent();p&&p.call(this);};
a.prototype.onAfterOpen=function(c){var d=this.getFocusDomRef(),i=null;if(!d){return;}i=this.getSelectedItem();d.setAttribute("aria-expanded","true");d.setAttribute("aria-owns",this.getList().getId());if(i){d.setAttribute("aria-activedescendant",i.getId());this.scrollToItem(i);}};
a.prototype.onBeforeClose=function(c){var d=this.getFocusDomRef();if(d){d.removeAttribute("aria-owns");d.removeAttribute("aria-activedescendant");if(this.shouldValueStateMessageBeOpened()&&(document.activeElement===d)){this.openValueStateMessage();}}this.removeStyleClass(this.getRenderer().CSS_CLASS+"Pressed");};
a.prototype.onAfterClose=function(c){var d=this.getFocusDomRef();if(d){d.setAttribute("aria-expanded","false");}};
a.prototype.getPicker=function(){if(this.bIsDestroyed){return null;}return this.createPicker(this.getPickerType());};
a.prototype.setPickerType=function(p){this._sPickerType=p;};
a.prototype.getPickerType=function(){return this._sPickerType;};
a.prototype._createPopover=function(){var t=this;var p=new P({showArrow:false,showHeader:false,placement:sap.m.PlacementType.VerticalPreferredBottom,offsetX:0,offsetY:0,initialFocus:this,bounce:false});p.addEventDelegate({ontouchstart:function(e){var o=this.getDomRef("cont");if((e.target===o)||(e.srcControl instanceof sap.ui.core.Item)){t._bProcessChange=false;}}},p);this._decoratePopover(p);return p;};
a.prototype._decoratePopover=function(p){var t=this;p.open=function(){return this.openBy(t);};};
a.prototype._onBeforeRenderingPopover=function(){var p=this.getPicker(),w=(this.$().outerWidth()/parseFloat(sap.m.BaseFontSize))+"rem";if(p){p.setContentMinWidth(w);}};
a.prototype._createDialog=function(){var t=this;return new D({stretch:true,showHeader:false,buttons:[this.createPickerCloseButton()],beforeOpen:function(){t.updatePickerHeaderTitle();}});};
a.prototype.createPickerCloseButton=function(){var t=this;var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");return new B({text:r.getText("SELECT_CANCEL_BUTTON"),press:function(){t.close();}});};
a.prototype.updatePickerHeaderTitle=function(){var p=this.getPicker();if(!p){return;}var L=this.getLabels();if(L.length){var o=L[0];if(o&&(typeof o.getText==="function")){p.setShowHeader(true);p.setTitle(o.getText());}}else{p.setShowHeader(false);}};
a.prototype._onBeforeOpenDialog=function(){};
a.prototype.init=function(){this.setPickerType(sap.ui.Device.system.phone?"Dialog":"Popover");this.createPicker(this.getPickerType());this._oSelectionOnFocus=null;this.bRenderingPhase=false;this._bFocusoutDueRendering=false;this._bProcessChange=false;this.sTypedChars="";this.iTypingTimeoutID=-1;this._oValueStateMessage=new V(this);};
a.prototype.onBeforeRendering=function(){this.bRenderingPhase=true;if(sap.ui.Device.browser.firefox&&(this.getFocusDomRef()===document.activeElement)){this._handleFocusout();}this.synchronizeSelection();};
a.prototype.onAfterRendering=function(){this.bRenderingPhase=false;};
a.prototype.exit=function(){var v=this.getValueStateMessage();this._oSelectionOnFocus=null;if(v){this.closeValueStateMessage();v.destroy();}this._oValueStateMessage=null;};
a.prototype.ontouchstart=function(e){e.setMarked();if(this.getEnabled()&&this.isOpenArea(e.target)){this.addStyleClass(this.getRenderer().CSS_CLASS+"Pressed");}};
a.prototype.ontouchend=function(e){e.setMarked();if(this.getEnabled()&&!this.isOpen()&&this.isOpenArea(e.target)){this.removeStyleClass(this.getRenderer().CSS_CLASS+"Pressed");}};
a.prototype.ontap=function(e){var b=this.getRenderer().CSS_CLASS;e.setMarked();if(!this.getEnabled()){return;}if(this.isOpenArea(e.target)){if(this.isOpen()){this.close();this.removeStyleClass(b+"Pressed");return;}this.open();}if(this.isOpen()){this.addStyleClass(b+"Pressed");}};
a.prototype.onSelectionChange=function(c){var i=c.getParameter("selectedItem");this.close();this.setSelection(i);this.fireChange({selectedItem:i});this.setValue(this._getSelectedItemText());};
a.prototype.onkeypress=function(e){if(!this.getEnabled()){return;}e.setMarked();var t=String.fromCharCode(e.which),s=this.getSelectedItem(),T=t,i=null;this.sTypedChars+=t;if((s&&q.sap.startsWithIgnoreCase(s.getText(),this.sTypedChars))||((this.sTypedChars.length===1)||((this.sTypedChars.length>1)&&(this.sTypedChars.charAt(0)!==this.sTypedChars.charAt(1))))){T=this.sTypedChars;}i=this.searchNextItemByText(T);clearTimeout(this.iTypingTimeoutID);this.iTypingTimeoutID=setTimeout(function(){this.sTypedChars="";this.iTypingTimeoutID=-1;}.bind(this),1000);h.call(this,i);};
a.prototype.onsapshow=function(e){if(!this.getEnabled()){return;}e.setMarked();if(e.which===q.sap.KeyCodes.F4){e.preventDefault();}this.toggleOpenState();};
a.prototype.onsaphide=a.prototype.onsapshow;
a.prototype.onsapescape=function(e){if(!this.getEnabled()){return;}if(this.isOpen()){e.setMarked();this.close();this._checkSelectionChange();}};
a.prototype.onsapenter=function(e){if(!this.getEnabled()){return;}e.setMarked();this.close();this._checkSelectionChange();};
a.prototype.onsapspace=function(e){if(!this.getEnabled()){return;}e.setMarked();e.preventDefault();if(this.isOpen()){this._checkSelectionChange();}this.toggleOpenState();};
a.prototype.onsapdown=function(e){if(!this.getEnabled()){return;}e.setMarked();e.preventDefault();var n,s=this.getSelectableItems();n=s[s.indexOf(this.getSelectedItem())+1];h.call(this,n);};
a.prototype.onsapup=function(e){if(!this.getEnabled()){return;}e.setMarked();e.preventDefault();var p,s=this.getSelectableItems();p=s[s.indexOf(this.getSelectedItem())-1];h.call(this,p);};
a.prototype.onsaphome=function(e){if(!this.getEnabled()){return;}e.setMarked();e.preventDefault();var f=this.getSelectableItems()[0];h.call(this,f);};
a.prototype.onsapend=function(e){if(!this.getEnabled()){return;}e.setMarked();e.preventDefault();var L=this.findLastEnabledItem(this.getSelectableItems());h.call(this,L);};
a.prototype.onsappagedown=function(e){if(!this.getEnabled()){return;}e.setMarked();e.preventDefault();var s=this.getSelectableItems(),o=this.getSelectedItem();this.setSelectedIndex(s.indexOf(o)+10,s);o=this.getSelectedItem();if(o){this.setValue(o.getText());}this.scrollToItem(o);};
a.prototype.onsappageup=function(e){if(!this.getEnabled()){return;}e.setMarked();e.preventDefault();var s=this.getSelectableItems(),o=this.getSelectedItem();this.setSelectedIndex(s.indexOf(o)-10,s);o=this.getSelectedItem();if(o){this.setValue(o.getText());}this.scrollToItem(o);};
a.prototype.onfocusin=function(e){if(!this._bFocusoutDueRendering&&!this._bProcessChange){this._oSelectionOnFocus=this.getSelectedItem();}this._bProcessChange=true;setTimeout(function(){if(!this.isOpen()&&this.shouldValueStateMessageBeOpened()&&(document.activeElement===this.getFocusDomRef())){this.openValueStateMessage();}}.bind(this),100);if(e.target!==this.getFocusDomRef()){this.focus();}};
a.prototype.onfocusout=function(e){this._handleFocusout();if(this.bRenderingPhase){return;}this.closeValueStateMessage();};
a.prototype.onsapfocusleave=function(e){var p=this.getAggregation("picker");if(!e.relatedControlId||!p){return;}var c=sap.ui.getCore().byId(e.relatedControlId),f=c&&c.getFocusDomRef();if(sap.ui.Device.system.desktop&&q.sap.containsOrEquals(p.getFocusDomRef(),f)){this.focus();}};
a.prototype.setSelection=function(i){var L=this.getList(),k;if(L){L.setSelection(i);}this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",(i instanceof sap.ui.core.Item)?i.getId():i,true);if(typeof i==="string"){i=sap.ui.getCore().byId(i);}k=i?i.getKey():"";this.setProperty("selectedKey",k,true);this._handleAriaActiveDescendant(i);};
a.prototype.isSelectionSynchronized=function(){var i=this.getSelectedItem();return this.getSelectedKey()===(i&&i.getKey());};
a.prototype.synchronizeSelection=function(){S.prototype.synchronizeSelection.apply(this,arguments);};
a.prototype.addContent=function(p){};
a.prototype.createPicker=function(p){var o=this.getAggregation("picker"),b=this.getRenderer().CSS_CLASS;if(o){return o;}o=this["_create"+p]();this.setAggregation("picker",o,true);o.setHorizontalScrolling(false).addStyleClass(b+"Picker").addStyleClass(b+"Picker-CTX").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachBeforeClose(this.onBeforeClose,this).attachAfterClose(this.onAfterClose,this).addEventDelegate({onBeforeRendering:this.onBeforeRenderingPicker,onAfterRendering:this.onAfterRenderingPicker},this).addContent(this.createList());return o;};
a.prototype.searchNextItemByText=function(t){var b=this.getItems(),s=this.getSelectedIndex(),c=b.splice(s+1,b.length-s),d=b.splice(0,b.length-1);b=c.concat(d);for(var i=0,o;i<b.length;i++){o=b[i];if(o.getEnabled()&&!(o instanceof sap.ui.core.SeparatorItem)&&q.sap.startsWithIgnoreCase(o.getText(),t)){return o;}}return null;};
a.prototype.createList=function(){var L=sap.m.SelectListKeyboardNavigationMode,k=sap.ui.Device.system.phone?L.Delimited:L.None;this._oList=new S({width:"100%",keyboardNavigationMode:k}).addStyleClass(this.getRenderer().CSS_CLASS+"List-CTX").addEventDelegate({ontap:function(e){this.close();}},this).attachSelectionChange(this.onSelectionChange,this);return this._oList;};
a.prototype.hasContent=function(){return this.getItems().length>0;};
a.prototype.onBeforeRenderingPicker=function(){var o=this["_onBeforeRendering"+this.getPickerType()];o&&o.call(this);};
a.prototype.onAfterRenderingPicker=function(){var o=this["_onAfterRendering"+this.getPickerType()];o&&o.call(this);};
a.prototype.open=function(){var p=this.getPicker();if(p){p.open();}return this;};
a.prototype.toggleOpenState=function(){if(this.isOpen()){this.close();}else{this.open();}return this;};
a.prototype.getVisibleItems=function(){var L=this.getList();return L?L.getVisibleItems():[];};
a.prototype.isItemSelected=function(i){return i&&(i.getId()===this.getAssociation("selectedItem"));};
a.prototype.getSelectedIndex=function(){var s=this.getSelectedItem();return s?this.indexOfItem(this.getSelectedItem()):-1;};
a.prototype.getDefaultSelectedItem=function(i){return this.getForceSelection()?this.findFirstEnabledItem():null;};
a.prototype.getSelectableItems=function(){var L=this.getList();return L?L.getSelectableItems():[];};
a.prototype.getOpenArea=function(){return this.getDomRef();};
a.prototype.isOpenArea=function(d){var o=this.getOpenArea();return o&&o.contains(d);};
a.prototype.findItem=function(p,v){var L=this.getList();return L?L.findItem(p,v):null;};
a.prototype.clearSelection=function(){this.setSelection(null);};
a.prototype.onItemChange=function(c){var s=this.getAssociation("selectedItem"),n=c.getParameter("newValue"),p=c.getParameter("name");if(s===c.getParameter("id")){switch(p){case"text":this.setValue(n);break;case"key":if(!this.isBound("selectedKey")){this.setSelectedKey(n);}break;}}};
a.prototype.fireChange=function(p){this._oSelectionOnFocus=p.selectedItem;return this.fireEvent("change",p);};
a.prototype.addAggregation=function(A,o,s){this._callMethodInControl("addAggregation",arguments);if(A==="items"&&!s&&!this.isInvalidateSuppressed()){this.invalidate(o);}return this;};
a.prototype.getAggregation=function(){return this._callMethodInControl("getAggregation",arguments);};
a.prototype.setAssociation=function(A,i,s){var L=this.getList();if(L&&(A==="selectedItem")){S.prototype.setAssociation.apply(L,arguments);}return C.prototype.setAssociation.apply(this,arguments);};
a.prototype.indexOfAggregation=function(){return this._callMethodInControl("indexOfAggregation",arguments);};
a.prototype.insertAggregation=function(){this._callMethodInControl("insertAggregation",arguments);return this;};
a.prototype.removeAggregation=function(){return this._callMethodInControl("removeAggregation",arguments);};
a.prototype.removeAllAggregation=function(){return this._callMethodInControl("removeAllAggregation",arguments);};
a.prototype.destroyAggregation=function(A,s){this._callMethodInControl("destroyAggregation",arguments);if(!s&&!this.isInvalidateSuppressed()){this.invalidate();}return this;};
a.prototype.setProperty=function(p,v,s){var L=this.getList();if((p==="selectedKey")||(p==="selectedItemId")){L&&S.prototype.setProperty.apply(L,arguments);}return C.prototype.setProperty.apply(this,arguments);};
a.prototype.removeAllAssociation=function(A,s){var L=this.getList();if(L&&(A==="selectedItem")){S.prototype.removeAllAssociation.apply(L,arguments);}return C.prototype.removeAllAssociation.apply(this,arguments);};
a.prototype.clone=function(){var s=C.prototype.clone.apply(this,arguments),L=this.getList(),o=this.getSelectedItem(),b=this.getSelectedKey();if(!this.isBound("items")&&L){for(var i=0,c=L.getItems();i<c.length;i++){s.addItem(c[i].clone());}}if(!this.isBound("selectedKey")&&!s.isSelectionSynchronized()){if(o&&(b==="")){s.setSelectedIndex(this.indexOfItem(o));}else{s.setSelectedKey(b);}}return s;};
a.prototype.updateValueStateClasses=function(v,o){var t=this.$(),L=this.$("label"),A=this.$("arrow"),m=sap.ui.core.ValueState,b=this.getRenderer().CSS_CLASS;if(o!==m.None){t.removeClass(b+"State");t.removeClass(b+o);L.removeClass(b+"LabelState");L.removeClass(b+"Label"+o);A.removeClass(b+"ArrowState");}if(v!==m.None){t.addClass(b+"State");t.addClass(b+v);L.addClass(b+"LabelState");L.addClass(b+"Label"+v);A.addClass(b+"ArrowState");}};
a.prototype.getLabels=function(){var L=this.getAriaLabelledBy().map(function(s){return sap.ui.getCore().byId(s);});var o=sap.ui.require("sap/ui/core/LabelEnablement");if(o){L=L.concat(o.getReferencingLabels(this).map(function(s){return sap.ui.getCore().byId(s);}));}return L;};
a.prototype.getDomRefForValueStateMessage=function(){return this.getDomRef();};
a.prototype.getValueStateMessageId=function(){return this.getId()+"-message";};
a.prototype.getValueStateMessage=function(){return this._oValueStateMessage;};
a.prototype.openValueStateMessage=function(){var v=this.getValueStateMessage();if(v){v.open();}};
a.prototype.closeValueStateMessage=function(){var v=this.getValueStateMessage();if(v){v.close();}};
a.prototype.shouldValueStateMessageBeOpened=function(){return((this.getValueState()!==sap.ui.core.ValueState.None)&&this.getEnabled());};
a.prototype.setShowSecondaryValues=function(A){var s=!this._isShadowListRequired();this.setProperty("showSecondaryValues",A,s);var L=this.getList();if(L){L.setShowSecondaryValues(A);}return this;};
a.prototype.addItem=function(i){this.addAggregation("items",i);if(i){i.attachEvent("_change",this.onItemChange,this);}return this;};
a.prototype.insertItem=function(i,b){this.insertAggregation("items",i,b);if(i){i.attachEvent("_change",this.onItemChange,this);}return this;};
a.prototype.findAggregatedObjects=function(){var L=this.getList();if(L){return S.prototype.findAggregatedObjects.apply(L,arguments);}return[];};
a.prototype.getItems=function(){var L=this.getList();return L?L.getItems():[];};
a.prototype.setSelectedItem=function(i){if(typeof i==="string"){this.setAssociation("selectedItem",i,true);i=sap.ui.getCore().byId(i);}if(!(i instanceof sap.ui.core.Item)&&i!==null){return this;}if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);this.setValue(this._getSelectedItemText(i));return this;};
a.prototype.setSelectedItemId=function(i){i=this.validateProperty("selectedItemId",i);if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);this.setValue(this._getSelectedItemText());return this;};
a.prototype.setSelectedKey=function(k){k=this.validateProperty("selectedKey",k);var d=(k==="");if(!this.getForceSelection()&&d){this.setSelection(null);this.setValue("");return this;}var i=this.getItemByKey(k);if(i||d){if(!i&&d){i=this.getDefaultSelectedItem();}this.setSelection(i);this.setValue(this._getSelectedItemText(i));return this;}return this.setProperty("selectedKey",k);};
a.prototype.setValueState=function(v){var o=this.getValueState();this.setProperty("valueState",v,true);v=this.getValueState();if(v===o){return this;}var d=this.getDomRefForValueState();if(!d){return this;}var m=sap.ui.core.ValueState;if(v===m.Error){d.setAttribute("aria-invalid",true);}else{d.removeAttribute("aria-invalid");}this.updateValueStateClasses(v,o);return this;};
a.prototype.getItemAt=function(i){return this.getItems()[+i]||null;};
a.prototype.getSelectedItem=function(){var s=this.getAssociation("selectedItem");return(s===null)?null:sap.ui.getCore().byId(s)||null;};
a.prototype.getFirstItem=function(){return this.getItems()[0]||null;};
a.prototype.getLastItem=function(){var i=this.getItems();return i[i.length-1]||null;};
a.prototype.getEnabledItems=function(i){var L=this.getList();return L?L.getEnabledItems(i):[];};
a.prototype.getItemByKey=function(k){var L=this.getList();return L?L.getItemByKey(k):null;};
a.prototype.removeItem=function(i){var L=this.getList(),o;i=L?L.removeItem(i):null;if(this.getItems().length===0){this.clearSelection();}else if(this.isItemSelected(i)){o=this.findFirstEnabledItem();if(o){this.setSelection(o);}}this.setValue(this._getSelectedItemText());if(i){i.detachEvent("_change",this.onItemChange,this);}return i;};
a.prototype.removeAllItems=function(){var L=this.getList(),b=L?L.removeAllItems():[];this.setValue("");if(this._isShadowListRequired()){this.$().children(".sapMSelectListItemBase").remove();}for(var i=0;i<b.length;i++){b[i].detachEvent("_change",this.onItemChange,this);}return b;};
a.prototype.destroyItems=function(){var L=this.getList();if(L){L.destroyItems();}this.setValue("");if(this._isShadowListRequired()){this.$().children(".sapMSelectListItemBase").remove();}return this;};
a.prototype.isOpen=function(){var p=this.getAggregation("picker");return!!(p&&p.isOpen());};
a.prototype.close=function(){var p=this.getAggregation("picker");if(p){p.close();}return this;};
a.prototype.getDomRefForValueState=function(){return this.getDomRef();};
a.prototype.getAccessibilityInfo=function(){var i={role:this.getRenderer().getAriaRole(this),focusable:this.getEnabled(),enabled:this.getEnabled()};if(this.getType()==="IconOnly"){var d=this.getTooltip_AsString();if(!d){var o=I.getIconInfo(this.getIcon());d=o&&o.text?o.text:"";}i.type=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_BUTTON");i.description=d;}else if(this.getType()==="Default"){i.type=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_COMBO");i.description=this._getSelectedItemText();}return i;};
a.prototype.propagateMessages=function(n,m){if(m&&m.length>0){this.setValueState(m[0].type);this.setValueStateText(m[0].message);}else{this.setValueState(sap.ui.core.ValueState.None);this.setValueStateText("");}};
a.prototype.refreshDataState=function(n,d){if(d.getChanges().messages){this.propagateMessages(n,d.getMessages());}};
return a;},true);
sap.ui.predefine('sap/m/SelectDialog',['jquery.sap.global','./Button','./Dialog','./List','./SearchField','./library','sap/ui/core/Control'],function(q,B,D,L,S,l,C){"use strict";
var a=C.extend("sap.m.SelectDialog",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},noDataText:{type:"string",group:"Appearance",defaultValue:null},multiSelect:{type:"boolean",group:"Dimension",defaultValue:false},growingThreshold:{type:"int",group:"Misc",defaultValue:null},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},rememberSelections:{type:"boolean",group:"Behavior",defaultValue:false},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.ListItemBase",multiple:true,singularName:"item"},_dialog:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{confirm:{parameters:{selectedItem:{type:"sap.m.StandardListItem"},selectedItems:{type:"sap.m.StandardListItem[]"},selectedContexts:{type:"string"}}},search:{parameters:{value:{type:"string"},itemsBinding:{type:"any"}}},liveChange:{parameters:{value:{type:"string"},itemsBinding:{type:"any"}}},cancel:{}}}});
a.prototype.init=function(){var t=this,i=0,r=null,d=null;r=function(){t._oSelectedItem=t._oList.getSelectedItem();t._aSelectedItems=t._oList.getSelectedItems();t._oDialog.detachAfterClose(r);t._fireConfirmAndUpdateSelection();};this._bAppendedToUIArea=false;this._bInitBusy=false;this._bFirstRender=true;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oList=new L(this.getId()+"-list",{growing:true,growingScrollToLoad:true,mode:sap.m.ListMode.SingleSelectMaster,infoToolbar:new sap.m.Toolbar({visible:false,active:false,content:[new sap.m.Label({text:this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[0])})]}),selectionChange:function(e){if(t._oDialog){if(!t.getMultiSelect()){t._oDialog.attachAfterClose(r);t._oDialog.close();}else{t._updateSelectionIndicator();}}}});this._oList.getInfoToolbar().addEventDelegate({onAfterRendering:function(){t._oList.getInfoToolbar().$().attr('aria-live','polite');}});this._list=this._oList;this._oList.attachUpdateStarted(this._updateStarted,this);this._oList.attachUpdateFinished(this._updateFinished,this);this._oBusyIndicator=new sap.m.BusyIndicator(this.getId()+"-busyIndicator").addStyleClass("sapMSelectDialogBusyIndicator",true);this._oSearchField=new S(this.getId()+"-searchField",{width:"100%",liveChange:function(e){var v=e.getSource().getValue(),b=(v?300:0);clearTimeout(i);if(b){i=setTimeout(function(){t._executeSearch(v,"liveChange");},b);}else{t._executeSearch(v,"liveChange");}},search:function(e){t._executeSearch(e.getSource().getValue(),"search");}});this._searchField=this._oSearchField;this._oSubHeader=new sap.m.Bar(this.getId()+"-subHeader",{contentMiddle:[this._oSearchField]});this._oDialog=new D(this.getId()+"-dialog",{title:this.getTitle(),stretch:sap.ui.Device.system.phone,contentHeight:"2000px",subHeader:this._oSubHeader,content:[this._oBusyIndicator,this._oList],leftButton:this._getCancelButton(),initialFocus:(sap.ui.Device.system.desktop?this._oSearchField:null)}).addStyleClass("sapMSelectDialog",true);this._dialog=this._oDialog;this.setAggregation("_dialog",this._oDialog);d=this._oDialog.onsapescape;this._oDialog.onsapescape=function(e){if(d){d.call(t._oDialog,e);}t._onCancel();};this._oDialog._iVMargin=8*(parseInt(sap.ui.core.theming.Parameters.get("sapUiFontSize"),10)||16);this._sSearchFieldValue="";this._bFirstRequest=true;this._bLiveChange=false;this._iListUpdateRequested=0;};
a.prototype.setBusy=function(){this._oDialog.setBusy.apply(this._oDialog,arguments);return this;};
a.prototype.getBusy=function(){return this._oDialog.getBusy.apply(this._oDialog,arguments);};
a.prototype.exit=function(){this._oList=null;this._oSearchField=null;this._oSubHeader=null;this._oBusyIndicator=null;this._sSearchFieldValue=null;this._iListUpdateRequested=0;this._bFirstRequest=false;this._bInitBusy=false;this._bFirstRender=false;this._bFirstRequest=false;if(this._bAppendedToUIArea){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.removeContent(this,true);}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}if(this._oOkButton){this._oOkButton.destroy();this._oOkButton=null;}this._oSelectedItem=null;this._aSelectedItems=null;this._list=null;this._searchField=null;this._dialog=null;};
a.prototype.onAfterRendering=function(){if(this._bInitBusy&&this._bFirstRender){this._setBusy(true);this._bInitBusy=false;}return this;};
a.prototype.invalidate=function(){if(this._oDialog&&(!arguments[0]||arguments[0]&&arguments[0].getId()!==this.getId()+"-dialog")){this._oDialog.invalidate(arguments);}else{C.prototype.invalidate.apply(this,arguments);}return this;};
a.prototype.open=function(s){if((!this.getParent()||!this.getUIArea())&&!this._bAppendedToUIArea){var o=sap.ui.getCore().getStaticAreaRef();o=sap.ui.getCore().getUIArea(o);o.addContent(this,true);this._bAppendedToUIArea=true;}this._bFirstRequest=true;this._oSearchField.setValue(s);this._oDialog.open();if(this._bInitBusy){this._setBusy(true);}this._updateSelectionIndicator();this._aInitiallySelectedContextPaths=this._oList.getSelectedContextPaths();return this;};
a.prototype.setGrowingThreshold=function(v){this._oList.setGrowingThreshold(v);this.setProperty("growingThreshold",v,true);return this;};
a.prototype.setMultiSelect=function(m){this.setProperty("multiSelect",m,true);if(m){this._oList.setMode(sap.m.ListMode.MultiSelect);this._oList.setIncludeItemInSelection(true);this._oDialog.setEndButton(this._getCancelButton());this._oDialog.setBeginButton(this._getOkButton());}else{this._oList.setMode(sap.m.ListMode.SingleSelectMaster);this._oDialog.setBeginButton(this._getCancelButton());}return this;};
a.prototype.setTitle=function(t){this._oDialog.setTitle(t);this.setProperty("title",t,true);return this;};
a.prototype.setNoDataText=function(n){this._oList.setNoDataText(n);return this;};
a.prototype.getNoDataText=function(){return this._oList.getNoDataText();};
a.prototype.getContentWidth=function(){return this._oDialog.getContentWidth();};
a.prototype.setContentWidth=function(w){this._oDialog.setContentWidth(w);return this;};
a.prototype.getContentHeight=function(){return this._oDialog.getContentHeight();};
a.prototype.setContentHeight=function(h){this._oDialog.setContentHeight(h);return this;};
a.prototype.addStyleClass=function(){this._oDialog.addStyleClass.apply(this._oDialog,arguments);return this;};
a.prototype.removeStyleClass=function(){this._oDialog.removeStyleClass.apply(this._oDialog,arguments);return this;};
a.prototype.toggleStyleClass=function(){this._oDialog.toggleStyleClass.apply(this._oDialog,arguments);return this;};
a.prototype.hasStyleClass=function(){return this._oDialog.hasStyleClass.apply(this._oDialog,arguments);};
a.prototype.getDomRef=function(){if(this._oDialog){return this._oDialog.getDomRef.apply(this._oDialog,arguments);}else{return null;}};
a.prototype._setModel=a.prototype.setModel;
a.prototype.setModel=function(m,M){var A=Array.prototype.slice.call(arguments);this._setBusy(false);this._bInitBusy=false;this._iListUpdateRequested+=1;this._oList.setModel(m,M);a.prototype._setModel.apply(this,A);this._updateSelectionIndicator();return this;};
a.prototype._callMethodInManagedObject=function(f,A){var b=Array.prototype.slice.call(arguments);if(A==="items"){return this._oList[f].apply(this._oList,b.slice(1));}else{return sap.ui.base.ManagedObject.prototype[f].apply(this,b.slice(1));}};
a.prototype.bindAggregation=function(){var b=Array.prototype.slice.call(arguments);this._callMethodInManagedObject.apply(this,["bindAggregation"].concat(b));return this;};
a.prototype.validateAggregation=function(A,o,m){return this._callMethodInManagedObject("validateAggregation",A,o,m);};
a.prototype.setAggregation=function(A,o,s){this._callMethodInManagedObject("setAggregation",A,o,s);return this;};
a.prototype.getAggregation=function(A,d){return this._callMethodInManagedObject("getAggregation",A,d);};
a.prototype.indexOfAggregation=function(A,o){return this._callMethodInManagedObject("indexOfAggregation",A,o);};
a.prototype.insertAggregation=function(A,o,i,s){this._callMethodInManagedObject("insertAggregation",A,o,i,s);return this;};
a.prototype.addAggregation=function(A,o,s){this._callMethodInManagedObject("addAggregation",A,o,s);return this;};
a.prototype.removeAggregation=function(A,o,s){return this._callMethodInManagedObject("removeAggregation",A,o,s);};
a.prototype.removeAllAggregation=function(A,s){return this._callMethodInManagedObject("removeAllAggregation",A,s);};
a.prototype.destroyAggregation=function(A,s){this._callMethodInManagedObject("destroyAggregation",A,s);return this;};
a.prototype.getBinding=function(A){return this._callMethodInManagedObject("getBinding",A);};
a.prototype.getBindingInfo=function(A){return this._callMethodInManagedObject("getBindingInfo",A);};
a.prototype.getBindingPath=function(A){return this._callMethodInManagedObject("getBindingPath",A);};
a.prototype.getBindingContext=function(m){return this._oList&&this._oList.getBindingContext(m);};
a.prototype._setBindingContext=a.prototype.setBindingContext;
a.prototype.setBindingContext=function(c,m){var b=Array.prototype.slice.call(arguments);this._oList.setBindingContext(c,m);a.prototype._setBindingContext.apply(this,b);return this;};
a.prototype._executeSearch=function(v,e){var o=this._oList,b=(o?o.getBinding("items"):undefined),s=(this._sSearchFieldValue!==v);if(e==="liveChange"){this._bLiveChange=true;}if(this._oDialog.isOpen()&&((s&&e==="liveChange")||e==="search")){this._sSearchFieldValue=v;if(b){this._iListUpdateRequested+=1;if(e==="search"){this.fireSearch({value:v,itemsBinding:b});}else if(e==="liveChange"){this.fireLiveChange({value:v,itemsBinding:b});}}else{if(e==="search"){this.fireSearch({value:v});}else if(e==="liveChange"){this.fireLiveChange({value:v});}}}return this;};
a.prototype._setBusy=function(b){if(this._iListUpdateRequested){if(b){this._oList.addStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','inline-block');}else{this._oList.removeStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','none');}}};
a.prototype._updateStarted=function(e){if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){if(this._oDialog.isOpen()&&this._iListUpdateRequested){this._setBusy(true);}else{this._bInitBusy=true;}}};
a.prototype._updateFinished=function(e){this._updateSelectionIndicator();if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){this._setBusy(false);this._bInitBusy=false;}if(sap.ui.Device.system.desktop){if(this._oList.getItems()[0]){this._oDialog.setInitialFocus(this._oList.getItems()[0]);}else{this._oDialog.setInitialFocus(this._oSearchField);}if(this._bFirstRequest&&!this._bLiveChange){var f=this._oList.getItems()[0];if(!f){f=this._oSearchField;}if(f.getFocusDomRef()){f.getFocusDomRef().focus();}}}this._bFirstRequest=false;this._iListUpdateRequested=0;};
a.prototype._getOkButton=function(){var t=this,o=null;o=function(){t._oSelectedItem=t._oList.getSelectedItem();t._aSelectedItems=t._oList.getSelectedItems();t._oDialog.detachAfterClose(o);t._fireConfirmAndUpdateSelection();};if(!this._oOkButton){this._oOkButton=new B(this.getId()+"-ok",{text:this._oRb.getText("MSGBOX_OK"),press:function(){t._oDialog.attachAfterClose(o);t._oDialog.close();}});}return this._oOkButton;};
a.prototype._getCancelButton=function(){var t=this;if(!this._oCancelButton){this._oCancelButton=new B(this.getId()+"-cancel",{text:this._oRb.getText("MSGBOX_CANCEL"),press:function(e){t._onCancel();}});}return this._oCancelButton;};
a.prototype._onCancel=function(e){var t=this,A=null;A=function(){t._oSelectedItem=null;t._aSelectedItems=[];t._sSearchFieldValue=null;t._oDialog.detachAfterClose(A);t._resetSelection();t.fireCancel();};this._oDialog.attachAfterClose(A);this._oDialog.close();};
a.prototype._updateSelectionIndicator=function(){var s=this._oList.getSelectedContexts(true).length,i=this._oList.getInfoToolbar();i.setVisible(!!s&&this.getMultiSelect());i.getContent()[0].setText(this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[s]));};
a.prototype._fireConfirmAndUpdateSelection=function(){this.fireConfirm({selectedItem:this._oSelectedItem,selectedItems:this._aSelectedItems,selectedContexts:this._oList.getSelectedContexts(true)});this._updateSelection();};
a.prototype._updateSelection=function(){if(!this.getRememberSelections()&&!this.bIsDestroyed){this._oList.removeSelections(true);delete this._oSelectedItem;delete this._aSelectedItems;}};
a.prototype._resetSelection=function(){if(!this.bIsDestroyed){this._oList.removeSelections(true);this._oList.setSelectedContextPaths(this._aInitiallySelectedContextPaths);this._oList.getItems().forEach(function(i){var p=i.getBindingContextPath();if(p&&this._aInitiallySelectedContextPaths.indexOf(p)>-1){i.setSelected(true);}},this);}};
return a;},true);
sap.ui.predefine('sap/m/SelectDialogRenderer',['jquery.sap.global'],function(q){"use strict";var S={};
S.render=function(r,c){};
return S;},true);
sap.ui.predefine('sap/m/SelectList',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation'],function(q,l,C,I){"use strict";
var S=C.extend("sap.m.SelectList",{metadata:{library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},selectedKey:{type:"string",group:"Data",defaultValue:""},selectedItemId:{type:"string",group:"Misc",defaultValue:""},showSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false},keyboardNavigationMode:{type:"sap.m.SelectListKeyboardNavigationMode",group:"Behavior",defaultValue:sap.m.SelectListKeyboardNavigationMode.Delimited}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{selectionChange:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}},itemPress:{parameters:{item:{type:"sap.ui.core.Item"}}}}}});
S.prototype._setSelectedIndex=function(i,_){var o;_=_||this.getItems();i=(i>_.length-1)?_.length-1:Math.max(0,i);o=_[i];if(o){this.setSelection(o);}};
S.prototype.updateItems=function(r){this.bItemsUpdated=false;this.destroyItems();this.updateAggregation("items");this.bItemsUpdated=true;this.synchronizeSelection({forceSelection:false});setTimeout(this.synchronizeSelection.bind(this),0);};
S.prototype.refreshItems=function(){this.bItemsUpdated=false;this.refreshAggregation("items");};
S.prototype._activateItem=function(i){if(i instanceof sap.ui.core.Item&&i&&i.getEnabled()){this.fireItemPress({item:i});if(this.getSelectedItem()!==i){this.setSelection(i);this.fireSelectionChange({selectedItem:i});}}};
S.prototype._queryEnabledItemsDomRefs=function(d){var a="."+this.getRenderer().CSS_CLASS+"ItemBase";d=d||this.getDomRef();return d?Array.prototype.slice.call(d.querySelectorAll(a+":not("+a+"Disabled)")):[];};
S.prototype._handleARIAActivedescendant=function(){var a=q(document.activeElement).control(0),d=this.getDomRef();if(a&&d){d.setAttribute("aria-activedescendant",a.getId());}};
S.prototype.init=function(){this._iStartTimeout=0;this._iActiveTouchId=0;this._fStartX=0;this._fStartY=0;this._oItemNavigation=null;this._$ItemPressed=null;};
S.prototype.onBeforeRendering=function(){this.synchronizeSelection();};
S.prototype.onAfterRendering=function(){if(this.getKeyboardNavigationMode()===sap.m.SelectListKeyboardNavigationMode.None){this.destroyItemNavigation();}else{this.createItemNavigation();}};
S.prototype.exit=function(){this.destroyItemNavigation();this._$ItemPressed=null;};
S.prototype.ontouchstart=function(e){if(sap.m.touch.countContained(e.touches,this.getId())>1||!this.getEnabled()){return;}e.setMarked();var t=e.targetTouches[0];this._iActiveTouchId=t.identifier;this._fStartX=t.pageX;this._fStartY=t.pageY;this._iStartTimeout=setTimeout(function(){var i=e.srcControl.$();if(i){i.addClass(this.getRenderer().CSS_CLASS+"ItemBasePressed");this._$ItemPressed=i;}}.bind(this),100);};
S.prototype.ontouchmove=function(e){var t=null;if(!this.getEnabled()){return;}t=sap.m.touch.find(e.changedTouches,this._iActiveTouchId);if(t&&((Math.abs(t.pageX-this._fStartX)>10)||(Math.abs(t.pageY-this._fStartY)>10))){clearTimeout(this._iStartTimeout);if(this._$ItemPressed){this._$ItemPressed.removeClass(this.getRenderer().CSS_CLASS+"ItemBasePressed");this._$ItemPressed=null;}}};
S.prototype.ontouchend=function(e){var t=null;if(!this.getEnabled()){return;}e.setMarked();t=sap.m.touch.find(e.changedTouches,this._iActiveTouchId);if(t){setTimeout(function(){if(this._$ItemPressed){this._$ItemPressed.removeClass(this.getRenderer().CSS_CLASS+"ItemBasePressed");this._$ItemPressed=null;}this._iStartTimeout=null;}.bind(this),100);}};
S.prototype.ontouchcancel=S.prototype.ontouchend;
S.prototype.ontap=function(e){if(this.getEnabled()){e.setMarked();this._activateItem(e.srcControl);}};
S.prototype.onsapselect=function(e){if(this.getEnabled()){e.setMarked();e.preventDefault();this._activateItem(e.srcControl);}};
S.prototype.onAfterFocus=function(c){this._handleARIAActivedescendant();};
S.prototype.findFirstEnabledItem=function(a){a=a||this.getItems();for(var i=0;i<a.length;i++){if(a[i].getEnabled()){return a[i];}}return null;};
S.prototype.setSelection=function(i){var s=this.getSelectedItem(),a=this.getRenderer().CSS_CLASS;this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",(i instanceof sap.ui.core.Item)?i.getId():i,true);if(typeof i==="string"){i=sap.ui.getCore().byId(i);}this.setProperty("selectedKey",i?i.getKey():"",true);if(s){s.$().removeClass(a+"ItemBaseSelected").attr("aria-selected","false");}s=this.getSelectedItem();if(s){s.$().addClass(a+"ItemBaseSelected").attr("aria-selected","true");}};
S.prototype.synchronizeSelection=function(o){if(this.isSelectionSynchronized()){return;}var f=true;if(o){f=!!o.forceSelection;}var k=this.getSelectedKey(),i=this.getItemByKey(""+k);if(i&&(k!=="")){this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",i.getId(),true);}else if(f&&this.getDefaultSelectedItem()&&(!this.isBound("items")||this.bItemsUpdated)){this.setSelection(this.getDefaultSelectedItem());}};
S.prototype.isSelectionSynchronized=function(){var i=this.getSelectedItem();return this.getSelectedKey()===(i&&i.getKey());};
S.prototype.findLastEnabledItem=function(i){i=i||this.getItems();return this.findFirstEnabledItem(i.reverse());};
S.prototype.getVisibleItems=function(){for(var i=0,o,a=this.getItems(),v=[];i<a.length;i++){o=a[i];if(o.bVisible||(o.bVisible===undefined)){v.push(o);}}return v;};
S.prototype.getSelectableItems=function(){return this.getEnabledItems(this.getVisibleItems());};
S.prototype.findItem=function(p,v){var m="get"+p.charAt(0).toUpperCase()+p.slice(1);for(var i=0,a=this.getItems();i<a.length;i++){if(a[i][m]()===v){return a[i];}}return null;};
S.prototype.getItemByText=function(t){return this.findItem("text",t);};
S.prototype.isItemSelected=function(i){return i&&(i.getId()===this.getAssociation("selectedItem"));};
S.prototype.getDefaultSelectedItem=function(i){return null;};
S.prototype.clearSelection=function(){this.setSelection(null);};
S.prototype.createItemNavigation=function(){var d;if(!this._oItemNavigation){this._oItemNavigation=new I(null,null,!this.getEnabled());this._oItemNavigation.attachEvent(I.Events.AfterFocus,this.onAfterFocus,this);this.addEventDelegate(this._oItemNavigation);}d=this.getDomRef();this._oItemNavigation.setRootDomRef(d);this._oItemNavigation.setItemDomRefs(this._queryEnabledItemsDomRefs(d));this._oItemNavigation.setCycling(false);this._oItemNavigation.setSelectedIndex(this.indexOfItem(this.getSelectedItem()));this._oItemNavigation.setPageSize(10);};
S.prototype.destroyItemNavigation=function(){if(this._oItemNavigation){this.removeEventDelegate(this._oItemNavigation);this._oItemNavigation.destroy();this._oItemNavigation=null;}};
S.prototype.getItemNavigation=function(){return this._oItemNavigation;};
S.prototype.setSelectedItem=function(i){if(typeof i==="string"){this.setAssociation("selectedItem",i,true);i=sap.ui.getCore().byId(i);}if(!(i instanceof sap.ui.core.Item)&&i!==null){return this;}if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);return this;};
S.prototype.setSelectedItemId=function(i){i=this.validateProperty("selectedItemId",i);this.setSelection(i);return this;};
S.prototype.setSelectedKey=function(k){k=this.validateProperty("selectedKey",k);var i=this.getItemByKey(k);if(i||(k==="")){if(!i&&k===""){i=this.getDefaultSelectedItem();}this.setSelection(i);return this;}return this.setProperty("selectedKey",k);};
S.prototype.getSelectedItem=function(){var s=this.getAssociation("selectedItem");return(s===null)?null:sap.ui.getCore().byId(s)||null;};
S.prototype.getItemAt=function(i){return this.getItems()[+i]||null;};
S.prototype.getFirstItem=function(){return this.getItems()[0]||null;};
S.prototype.getLastItem=function(){var i=this.getItems();return i[i.length-1]||null;};
S.prototype.getEnabledItems=function(i){i=i||this.getItems();return i.filter(function(o){return o.getEnabled();});};
S.prototype.getItemByKey=function(k){return this.findItem("key",k);};
S.prototype.removeItem=function(i){i=this.removeAggregation("items",i);if(this.getItems().length===0){this.clearSelection();}else if(this.isItemSelected(i)){this.setSelection(this.getDefaultSelectedItem());}return i;};
S.prototype.removeAllItems=function(){var i=this.removeAllAggregation("items",true);this.$().children("li").remove();return i;};
S.prototype.destroyItems=function(){this.destroyAggregation("items",true);return this;};
S.prototype.setNoDataText=q.noop;return S;},true);
sap.ui.predefine('sap/m/SelectListRenderer',['jquery.sap.global'],function(q){"use strict";var S={};S.CSS_CLASS="sapMSelectList";
S.render=function(r,l){var C=S.CSS_CLASS;r.write("<ul");r.writeControlData(l);r.addClass(C);if(l.getShowSecondaryValues()){r.addClass(C+"TableLayout");}if(!l.getEnabled()){r.addClass(C+"Disabled");}r.addStyle("width",l.getWidth());r.addStyle("max-width",l.getMaxWidth());r.writeStyles();r.writeClasses();this.writeAccessibilityState(r,l);r.write(">");this.renderItems(r,l);r.write("</ul>");};
S.renderItems=function(r,l){var s=l.getItems().length,o=l.getSelectedItem();for(var i=0,I=l.getItems();i<I.length;i++){this.renderItem(r,l,I[i],{selected:o===I[i],setsize:s,posinset:i+1});}};
S.renderItem=function(r,l,i,s){if(!(i instanceof sap.ui.core.Element)){return;}var e=i.getEnabled(),o=l.getSelectedItem(),C=S.CSS_CLASS,t=i.getTooltip_AsString(),b=l.getShowSecondaryValues();r.write("<li");r.writeElementData(i);if(i instanceof sap.ui.core.SeparatorItem){r.addClass(C+"SeparatorItem");if(b){r.addClass(C+"Row");}}else{r.addClass(C+"ItemBase");if(b){r.addClass(C+"Row");}else{r.addClass(C+"Item");}if(i.bVisible===false){r.addClass(C+"ItemBaseInvisible");}if(!e){r.addClass(C+"ItemBaseDisabled");}if(e&&sap.ui.Device.system.desktop){r.addClass(C+"ItemBaseHoverable");}if(i===o){r.addClass(C+"ItemBaseSelected");}if(e){r.writeAttribute("tabindex","0");}}r.writeClasses();if(t){r.writeAttributeEscaped("title",t);}this.writeItemAccessibilityState.apply(this,arguments);r.write(">");if(b){r.write("<span");r.addClass(C+"Cell");r.addClass(C+"FirstCell");r.writeClasses();r.write(">");r.writeEscaped(i.getText());r.write("</span>");r.write("<span");r.addClass(C+"Cell");r.addClass(C+"LastCell");r.writeClasses();r.write(">");if(typeof i.getAdditionalText==="function"){r.writeEscaped(i.getAdditionalText());}r.write("</span>");}else{r.writeEscaped(i.getText());}r.write("</li>");};
S.writeAccessibilityState=function(r,l){r.writeAccessibilityState({role:"listbox"});};
S.writeItemAccessibilityState=function(r,l,i,s){var R=(i instanceof sap.ui.core.SeparatorItem)?"separator":"option";r.writeAccessibilityState(i,{role:R,selected:s.selected,setsize:s.setsize,posinset:s.posinset});};
return S;},true);
sap.ui.predefine('sap/m/SelectRenderer',['jquery.sap.global','sap/ui/core/Renderer','sap/ui/core/ValueStateSupport','sap/ui/core/IconPool'],function(q,R,V,I){"use strict";var S={};S.CSS_CLASS="sapMSlt";
S.render=function(r,s){var t=V.enrichTooltip(s,s.getTooltip_AsString()),T=s.getType(),a=s.getAutoAdjustWidth(),e=s.getEnabled(),C=S.CSS_CLASS;r.write("<div");this.addClass(r,s);r.addClass(C);r.addClass(C+s.getType());if(!e){r.addClass(C+"Disabled");}if(a){r.addClass(C+"AutoAdjustedWidth");}else{r.addStyle("width",s.getWidth());}if(s.getIcon()){r.addClass(C+"WithIcon");}if(e&&sap.ui.Device.system.desktop){r.addClass(C+"Hoverable");}r.addClass(C+"WithArrow");if(s.getValueState()!==sap.ui.core.ValueState.None){this.addValueStateClasses(r,s);}r.addStyle("max-width",s.getMaxWidth());r.writeControlData(s);r.writeStyles();r.writeClasses();this.writeAccessibilityState(r,s);if(t){r.writeAttributeEscaped("title",t);}else if(T===sap.m.SelectType.IconOnly){var i=I.getIconInfo(s.getIcon());if(i){r.writeAttributeEscaped("title",i.text);}}if(e){r.writeAttribute("tabindex","0");}r.write(">");this.renderLabel(r,s);switch(T){case sap.m.SelectType.Default:this.renderArrow(r,s);break;case sap.m.SelectType.IconOnly:this.renderIcon(r,s);break;}var l=s.getList();if(s._isShadowListRequired()&&l){r.renderControl(l);}if(s.getName()){this.renderInput(r,s);}r.write("</div>");};
S.renderLabel=function(r,s){var o=s.getSelectedItem(),t=s.getTextDirection(),T=R.getTextAlign(s.getTextAlign(),t),C=S.CSS_CLASS;r.write("<label");r.writeAttribute("id",s.getId()+"-label");r.writeAttribute("for",s.getId());r.addClass(C+"Label");if(s.getValueState()!==sap.ui.core.ValueState.None){r.addClass(C+"LabelState");r.addClass(C+"Label"+s.getValueState());}if(s.getType()===sap.m.SelectType.IconOnly){r.addClass("sapUiPseudoInvisibleText");}if(t!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",t.toLowerCase());}if(T){r.addStyle("text-align",T);}r.writeStyles();r.writeClasses();r.write(">");r.writeEscaped(o?o.getText():"");r.write('</label>');};
S.renderArrow=function(r,s){var C=S.CSS_CLASS;r.write("<span");r.addClass(C+"Arrow");if(s.getValueState()!==sap.ui.core.ValueState.None){r.addClass(C+"ArrowState");}r.writeAttribute("id",s.getId()+"-arrow");r.writeClasses();r.write("></span>");};
S.renderIcon=function(r,s){r.writeIcon(s.getIcon(),S.CSS_CLASS+"Icon",{id:s.getId()+"-icon",title:null});};
S.renderInput=function(r,s){r.write("<input hidden");r.writeAttribute("id",s.getId()+"-input");r.addClass(S.CSS_CLASS+"Input");r.writeAttribute("aria-hidden","true");r.writeAttribute("tabindex","-1");if(!s.getEnabled()){r.write("disabled");}r.writeClasses();r.writeAttributeEscaped("name",s.getName());r.writeAttributeEscaped("value",s.getSelectedKey());r.write("/>");};
S.addClass=function(r,s){};
S.addValueStateClasses=function(r,s){r.addClass(S.CSS_CLASS+"State");r.addClass(S.CSS_CLASS+s.getValueState());};
S.getAriaRole=function(s){switch(s.getType()){case sap.m.SelectType.Default:return"combobox";case sap.m.SelectType.IconOnly:return"button";}};
S.writeAccessibilityState=function(r,s){r.writeAccessibilityState(s,{role:this.getAriaRole(s),expanded:s.isOpen(),live:"polite",invalid:(s.getValueState()===sap.ui.core.ValueState.Error)?true:undefined,labelledby:{value:s.getId()+"-label",append:true}});};
return S;},true);
sap.ui.predefine('sap/m/Shell',['jquery.sap.global','./library','sap/ui/core/Control'],function(q,l,C){"use strict";
var S=C.extend("sap.m.Shell",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},logo:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},showLogout:{type:"boolean",group:"Behavior",defaultValue:true},headerRightText:{type:"string",group:"Data",defaultValue:null},appWidthLimited:{type:"boolean",group:"Appearance",defaultValue:true},backgroundColor:{type:"sap.ui.core.CSSColor",group:"Appearance",defaultValue:null},backgroundImage:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},backgroundRepeat:{type:"boolean",group:"Appearance",defaultValue:false},backgroundOpacity:{type:"float",group:"Appearance",defaultValue:1},homeIcon:{type:"object",group:"Misc",defaultValue:null}},defaultAggregation:"app",aggregations:{app:{type:"sap.ui.core.Control",multiple:false}},events:{logout:{}}}});
S.prototype.init=function(){sap.ui.getCore().attachThemeChanged(q.proxy(function(){var $=this.$("hdr");if($.length){$.find(".sapMShellLogo").remove();var h=sap.m.ShellRenderer.getLogoImageHtml(this);$.prepend(q(h));}},this));q.sap.initMobile({statusBar:"default",hideBrowser:true});};
S.prototype.onAfterRendering=function(){var r=this.getDomRef().parentNode,$;if(r&&!r._sapui5_heightFixed){r._sapui5_heightFixed=true;while(r&&r!==document.documentElement){$=q(r);if($.attr("data-sap-ui-root-content")){break;}if(!r.style.height){r.style.height="100%";}r=r.parentNode;}}this.$("content").css("height","");};
S.prototype.ontap=function(e){if(e.target.className&&e.target.className.indexOf&&e.target.className.indexOf("sapMShellHeaderLogout")>-1){this.fireLogout();}};
S.prototype.setTitle=function(t){this.$("hdrTxt").text(t);this.setProperty("title",t,true);return this;};
S.prototype.setHeaderRightText=function(t){this.setProperty("headerRightText",t,true);if(!t){t="";}this.$("hdrRightTxt").text(t).css("display",(!!t?"inline":"none"));return this;};
S.prototype.setAppWidthLimited=function(L){this.$().toggleClass("sapMShellAppWidthLimited",L);this.setProperty("appWidthLimited",L,true);return this;};
S.prototype.setBackgroundOpacity=function(o){if(o>1||o<0){q.sap.log.warning("Invalid value "+o+" for Shell.setBackgroundOpacity() ignored. Valid values are: floats between 0 and 1.");return this;}this.$("BG").css("opacity",o);return this.setProperty("backgroundOpacity",o,true);};
S.prototype.setHomeIcon=function(i){this.setProperty("homeIcon",i,true);q.sap.setIcons(i);return this;};
return S;},true);
sap.ui.predefine('sap/m/ShellRenderer',['jquery.sap.global'],function(q){"use strict";var S={};
S.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMShell");if(c.getAppWidthLimited()){r.addClass("sapMShellAppWidthLimited");}sap.m.BackgroundHelper.addBackgroundColorStyles(r,c.getBackgroundColor(),c.getBackgroundImage(),"sapMShellGlobalOuterBackground");r.writeClasses();r.writeStyles();var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.write(">");sap.m.BackgroundHelper.renderBackgroundImageTag(r,c,["sapContrastPlus","sapMShellBG","sapUiGlobalBackgroundImageForce"],c.getBackgroundImage(),c.getBackgroundRepeat(),c.getBackgroundOpacity());r.write("<div class='sapMShellBrandingBar'></div>");r.write("<div class='sapMShellCentralBox'>");var e="",a="";if(!c.getBackgroundImage()){e="sapMShellBackgroundColorOnlyIfDefault";a="sapUiGlobalBackgroundImageOnlyIfDefault";}r.write("<header class='sapMShellHeader "+e+"' id='"+c.getId()+"-hdr'>");r.write("<div class='"+a+"'></div>");r.write(S.getLogoImageHtml(c));r.write("<h1 id='"+c.getId()+"-hdrTxt' class='sapMShellHeaderText'>");r.writeEscaped(c.getTitle());r.write("</h1>");r.write("<span class='sapMShellHeaderRight'>");r.write("<span id='"+c.getId()+"-hdrRightTxt' ");if(!c.getHeaderRightText()){r.writeAttribute("style","display:none;");}r.write("class='sapMShellHeaderRightText'>"+q.sap.encodeHTML(c.getHeaderRightText())+"</span>");if(c.getShowLogout()){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");r.write("<a id='"+c.getId()+"-logout' tabindex='0' role='button' class='sapMShellHeaderLogout'>"+b.getText("SHELL_LOGOUT")+"</a>");}r.write("</span></header>");r.write("<section class='sapMShellContent sapMShellGlobalInnerBackground' id='"+c.getId()+"-content' data-sap-ui-root-content='true'>");r.renderControl(c.getApp());r.write("</section></div></div>");};
S.getLogoImageHtml=function(c){var i=c.getLogo();if(!i){q.sap.require("sap.ui.core.theming.Parameters");i=sap.ui.core.theming.Parameters._getThemeImage();}var r="";if(i){var R=sap.ui.getCore().getLibraryResourceBundle("sap.m");r="<div class='sapMShellLogo'>";if(sap.ui.Device.browser.msie){r+="<span class='sapMShellLogoImgAligner'></span>";}r+="<img id='"+c.getId()+"-logo' class='sapMShellLogoImg' src='";r+=q.sap.encodeHTML(i);r+="' alt='";r+=R.getText("SHELL_ARIA_LOGO");r+="' /></div>";}return r;};
return S;},true);
sap.ui.predefine('sap/m/SlideTile',['jquery.sap.global','./library','sap/ui/core/Control','sap/m/GenericTile'],function(q,l,C,G){"use strict";
var S=C.extend("sap.m.SlideTile",{metadata:{library:"sap.m",properties:{"displayTime":{type:"int",group:"Appearance",defaultValue:5000},"transitionTime":{type:"int",group:"Appearance",defaultValue:500}},aggregations:{"tiles":{type:"sap.m.GenericTile",multiple:true,singularName:"tile"},"_pausePlayIcon":{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}}}});
S.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setAggregation("_pausePlayIcon",new sap.ui.core.Icon({id:this.getId()+"-pause-play-icon",src:"sap-icon://media-pause",color:"#ffffff",size:"0.95rem",noTabStop:true}),true);};
S.prototype.onBeforeRendering=function(){this._stopAnimation();this._sWidth=this._sHeight=undefined;this._iCurrentTile=this._iPreviousTile=undefined;};
S.prototype.onAfterRendering=function(){var c=this.getTiles().length;this._removeGTFocus();this._iCurrAnimationTime=0;this._bAnimationPause=false;this._scrollToNextTile();if(c>1){this._startAnimation();}};
S.prototype.exit=function(){this._stopAnimation();};
S.prototype.ontap=function(e){if(sap.ui.Device.browser.internet_explorer){this.$().focus();}};
S.prototype.ontouchstart=function(e){if(q(e.target).hasClass("sapMSTIconClickTapArea")){this.addStyleClass("sapMSTIconPressed");}else{this.addStyleClass("sapMSTHvr");}};
S.prototype.ontouchend=function(e){this.removeStyleClass("sapMSTHvr");};
S.prototype.ontouchcancel=function(e){if(this.hasStyleClass("sapMSTIconPressed")){this.removeStyleClass("sapMSTIconPressed");}else{this.removeStyleClass("sapMSTHvr");}};
S.prototype.onkeydown=function(e){if(q.sap.PseudoEvents.sapenter.fnCheck(e)){var g=this.getTiles()[this._iCurrentTile];g.onkeydown(e);}};
S.prototype.onkeyup=function(e){if(q.sap.PseudoEvents.sapenter.fnCheck(e)){var g=this.getTiles()[this._iCurrentTile];g.onkeyup(e);return;}if(q.sap.PseudoEvents.sapspace.fnCheck(e)){this._toggleAnimation();}if(e.which===q.sap.KeyCodes.B&&this._bAnimationPause){this._scrollToNextTile(true,true);}if(e.which===q.sap.KeyCodes.F&&this._bAnimationPause){this._scrollToNextTile(true,false);}};
S.prototype.onmouseup=function(e){if(this.hasStyleClass("sapMSTIconPressed")){this._toggleAnimation();this.removeStyleClass("sapMSTIconPressed");}else if(sap.ui.Device.system.desktop){e.preventDefault();this.getTiles()[this._iCurrentTile].firePress();}};
S.prototype.onmousedown=function(e){if(q(e.target).hasClass("sapMSTIconClickTapArea")){this.addStyleClass("sapMSTIconPressed");}};
S.prototype.onfocusout=function(e){if(this.getTiles().length>1&&!this._isFocusInsideST()){this._startAnimation();this._updatePausePlayIcon();}};
S.prototype._isFocusInsideST=function(){return this.$()[0]===document.activeElement||this.$().find(document.activeElement).length;};
S.prototype._removeGTFocus=function(){for(var i=0;i<this.getTiles().length;i++){this.getTiles()[i].$().removeAttr("tabindex");}};
S.prototype._toggleAnimation=function(){if(this.getTiles().length>1){if(this._bAnimationPause){this._startAnimation();}else{this._stopAnimation();}}this._updatePausePlayIcon();};
S.prototype._stopAnimation=function(){this._iCurrAnimationTime+=Date.now()-this._iStartTime;clearTimeout(this._sTimerId);if(this._iCurrentTile!=undefined){var w=this.$("wrapper-"+this._iCurrentTile);w.stop();}if(this._iPreviousTile!=undefined){var W=this.$("wrapper-"+this._iPreviousTile);W.stop();}if(this._iCurrAnimationTime>this.getDisplayTime()){this._scrollToNextTile(true);}this._bAnimationPause=true;};
S.prototype._startAnimation=function(){var d=this.getDisplayTime()-this._iCurrAnimationTime;clearTimeout(this._sTimerId);this._sTimerId=setTimeout(function(){this._scrollToNextTile();}.bind(this),d);this._iStartTime=Date.now();this._bAnimationPause=false;};
S.prototype._scrollToNextTile=function(p,b){var t=this._iCurrAnimationTime-this.getDisplayTime(),f,n,w,W,s,a,c,d,D,o;t=this.getTransitionTime()-(t>0?t:0);f=t===this.getTransitionTime();if(f){if(b){n=this._getPreviousTileIndex(this._iCurrentTile);}else{n=this._getNextTileIndex(this._iCurrentTile);}this._iPreviousTile=this._iCurrentTile;this._iCurrentTile=n;}W=this.$("wrapper-"+this._iCurrentTile);D=sap.ui.getCore().getConfiguration().getRTL()?"right":"left";if(q.isNumeric(this._iPreviousTile)){w=this.$("wrapper-"+this._iPreviousTile);s=w.css("width");a=parseFloat(W.css("width"));c=parseFloat(s);d=c<a;if(d){this._changeSizeTo(this._iCurrentTile);}if(f){W.css(D,s);}o={};if(b){o[D]=s;}else{o[D]="-"+s;}w.animate(o,{duration:t,done:function(){if(!d){this._changeSizeTo(this._iCurrentTile);}w.css(D,"");}.bind(this)});if(b){o[D]="-"+s;W.animate(o,0);}o[D]="0rem";W.animate(o,{duration:t,done:function(){this._iCurrAnimationTime=0;if(!p){this._startAnimation();}}.bind(this)});}else{this._changeSizeTo(this._iCurrentTile);W.css(D,"0rem");}if(this.getTiles()[this._iCurrentTile]){this._setAriaDescriptor();}this._updateTilesIndicator();};
S.prototype._setAriaDescriptor=function(){var t=this._oRb.getText("SLIDETILE_TOGGLE_SLIDING"),T=this.getTiles()[this._iCurrentTile]._getAriaText().replace(/\s/g," ");if(this.getTiles().length>1){T=T+"\n"+t;}this.$().attr("aria-label",T);};
S.prototype._changeSizeTo=function(t){var T=this.getTiles()[t];if(!T){return;}if(this._sFrameType){this.$().removeClass(this._sFrameType);}if(this._sSize){this.$().removeClass(this._sSize);}this.$().addClass(T.getFrameType()).addClass(T.getSize());this._sFrameType=T.getFrameType();this._sSize=T.getSize();};
S.prototype._getPreviousTileIndex=function(t){if(t>0){return t-1;}else{return this.getTiles().length-1;}};
S.prototype._getNextTileIndex=function(t){if(t+1<this.getTiles().length){return t+1;}else{return 0;}};
S.prototype._updateTilesIndicator=function(){var $;for(var i=0;i<this.getTiles().length;i++){$=this.$("tileIndicator-"+i);if(i===this._iCurrentTile){$.addClass("sapMSTActive");}else{$.removeClass("sapMSTActive");}}};
S.prototype._updatePausePlayIcon=function(){if(this._bAnimationPause){this.getAggregation("_pausePlayIcon").setSrc("sap-icon://media-play");this.$().removeClass("sapMSTPauseIcon");}else{this.getAggregation("_pausePlayIcon").setSrc("sap-icon://media-pause");this.$().addClass("sapMSTPauseIcon");}};
return S;},true);
sap.ui.predefine('sap/m/SlideTileRenderer',[],function(){"use strict";var S={};
S.render=function(r,c){var t=c.getTooltip_AsString(),l;r.write("<div");r.writeControlData(c);r.addClass("sapMST");if(!this._bAnimationPause){r.addClass("sapMSTPauseIcon");}r.writeClasses();if(t){r.writeAttributeEscaped("title",t);}r.writeAttribute("tabindex","0");r.writeAttribute("role","presentation");r.write(">");this._renderPausePlayIcon(r,c);l=c.getTiles().length;if(l>1){this._renderTilesIndicator(r,c);}for(var i=0;i<l;i++){r.write("<div");r.writeAttribute("id",c.getId()+"-wrapper-"+i);r.addClass("sapMSTWrapper");r.writeClasses();r.write(">");r.renderControl(c.getTiles()[i]);r.write("</div>");}r.write("<div");r.addClass("sapMSTFocusDiv");r.writeClasses();r.writeAttribute("id",c.getId()+"-focus");r.write(">");r.write("</div>");r.write("</div>");};
S._renderTilesIndicator=function(r,c){var p=c.getTiles().length;r.write("<div");r.writeAttribute("id",c.getId()+"-tilesIndicator");r.addClass("sapMSTBulleted");r.writeClasses();r.write(">");for(var i=0;i<p;i++){r.write("<span");r.writeAttribute("id",c.getId()+"-tileIndicator-"+i);r.write(">");r.write("</span>");}r.write("</div>");};
S._renderPausePlayIcon=function(r,c){if(c.getTiles().length>1){r.write("<div");r.addClass("sapMSTIconClickTapArea");r.writeClasses();r.write(">");r.write("</div>");r.write("<div");r.addClass("sapMSTIconDisplayArea");r.writeClasses();r.write(">");r.write("</div>");r.write("<div");r.addClass("sapMSTIconNestedArea");r.writeClasses();r.write(">");r.renderControl(c.getAggregation("_pausePlayIcon"));r.write("</div>");}};
return S;},true);
sap.ui.predefine('sap/m/Slider',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','./Input','sap/ui/core/InvisibleText'],function(q,l,C,E,I,a){"use strict";
var S=C.extend("sap.m.Slider",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"100%"},enabled:{type:"boolean",group:"Behavior",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:""},min:{type:"float",group:"Data",defaultValue:0},max:{type:"float",group:"Data",defaultValue:100},step:{type:"float",group:"Data",defaultValue:1},progress:{type:"boolean",group:"Misc",defaultValue:true},value:{type:"float",group:"Data",defaultValue:0},showHandleTooltip:{type:"boolean",group:"Appearance",defaultValue:true},showAdvancedTooltip:{type:"boolean",group:"Appearance",defaultValue:false},inputsAsTooltips:{type:"boolean",group:"Appearance",defaultValue:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"float"}}},liveChange:{parameters:{value:{type:"float"}}}}}});
S.prototype._CONSTANTS={CHARACTER_WIDTH_PX:8};E.apply(S.prototype,[true]);
S.prototype._convertValueToRtlMode=function(v){return this.getMax()-v+this.getMin();};
S.prototype._recalculateStyles=function(){var s=this.$();this._fSliderWidth=s.width();this._fSliderPaddingLeft=parseFloat(s.css("padding-left"));this._fSliderOffsetLeft=s.offset().left;this._fHandleWidth=this.$("handle").width();this._fTooltipHalfWidthPercent=((this._fSliderWidth-(this._fSliderWidth-(this._iLongestRangeTextWidth/2+this._CONSTANTS.CHARACTER_WIDTH_PX)))/this._fSliderWidth)*100;};
S.prototype._validateProperties=function(){var m=this.getMin(),M=this.getMax(),s=this.getStep(),b=false,e=false;if(m>=M){b=true;e=true;q.sap.log.warning("Warning: "+"Property wrong min: "+m+" >= max: "+M+" on ",this);}if(s<=0){q.sap.log.warning("Warning: "+"The step could not be negative on ",this);}if(s>(M-m)&&!b){e=true;q.sap.log.warning("Warning: "+"Property wrong step: "+s+" > max: "+M+" - "+"min: "+m+" on ",this);}return e;};
S.prototype._getPercentOfValue=function(v){var m=this.getMin();return(((v-m)/(this.getMax()-m))*100);};
S.prototype._validateStep=function(s){if(typeof s==="undefined"){return 1;}if(typeof s!=="number"){q.sap.log.warning('Warning: "iStep" needs to be a number',this);return 0;}if((Math.floor(s)===s)&&isFinite(s)){return s;}q.sap.log.warning('Warning: "iStep" needs to be a finite interger',this);return 0;};
S.prototype.getDecimalPrecisionOfNumber=function(v){if(Math.floor(v)===v){return 0;}var V=v.toString(),i=V.indexOf("."),b=V.indexOf("e-"),c=b!==-1,d=i!==-1;if(c){var e=+V.slice(b+2);if(d){return e+V.slice(i+1,b).length;}return e;}if(d){return V.length-i-1;}return 0;};
S.prototype.toFixed=function(n,d){if(d===undefined){d=this.getDecimalPrecisionOfNumber(n);}if(d>20){d=20;}else if(d<0){d=0;}return n.toFixed(d)+"";};
S.prototype.setDomValue=function(n){var d=this.getDomRef();if(!d){return;}var p=Math.max(this._getPercentOfValue(+n),0)+"%",h=this.getDomRef("handle");if(!!this.getName()){this.getDomRef("input").setAttribute("value",n);}if(this.getProgress()){this.getDomRef("progress").style.width=p;}h.style[this._bRTL?"right":"left"]=p;if(this.getShowAdvancedTooltip()){this._updateAdvancedTooltipDom(n);}if(this.getShowHandleTooltip()&&!this.getShowAdvancedTooltip()){h.title=n;}h.setAttribute("aria-valuenow",n);};
S.prototype._updateAdvancedTooltipDom=function(n){var i=this.getInputsAsTooltips(),t=this.getDomRef("TooltipsContainer"),T=i&&this._oInputTooltip?this._oInputTooltip.tooltip:this.getDomRef("Tooltip"),A=this._bRTL?"right":"left";if(!i){T.innerHTML=n;}else if(i&&T.getValue()!==n){T.setValue(n);T.$("inner").attr("value",n);}t.style[A]=this._getTooltipPosition(n);};
S.prototype._getTooltipPosition=function(n){var p=this._getPercentOfValue(+n);if(p<this._fTooltipHalfWidthPercent){return 0+"%";}else if(p>100-this._fTooltipHalfWidthPercent){return(100-this._fTooltipHalfWidthPercent*2)+"%";}else{return p-this._fTooltipHalfWidthPercent+"%";}};
S.prototype.getClosestHandleDomRef=function(){return this.getDomRef("handle");};
S.prototype._increaseValueBy=function(i){var v,n;if(this.getEnabled()){v=this.getValue();this.setValue(v+(i||1));n=this.getValue();if(v<n){this._fireChangeAndLiveChange({value:n});}}};
S.prototype._decreaseValueBy=function(d){var v,n;if(this.getEnabled()){v=this.getValue();this.setValue(v-(d||1));n=this.getValue();if(v>n){this._fireChangeAndLiveChange({value:n});}}};
S.prototype._getLongStep=function(){var m=this.getMin(),M=this.getMax(),s=this.getStep(),L=(M-m)/10,i=(M-m)/s;return i>10?L:s;};
S.prototype._fireChangeAndLiveChange=function(p){this.fireChange(p);this.fireLiveChange(p);};
S.prototype._hasFocus=function(){return document.activeElement===this.getFocusDomRef();};
S.prototype._createInputField=function(s,A){var i=new I(this.getId()+"-"+s,{value:this.getMin(),width:this._iLongestRangeTextWidth+(2*this._CONSTANTS.CHARACTER_WIDTH_PX)+"px",type:"Number",textAlign:sap.ui.core.TextAlign.Center,ariaLabelledBy:A});i.attachChange(this._handleInputChange.bind(this,i));i.addEventDelegate({onfocusout:function(e){e.srcControl.fireChange({value:e.target.value});}});return i;};
S.prototype._handleInputChange=function(i,e){var n=parseFloat(e.getParameter("value"),10);if(isNaN(n)||n<this.getMin()||n>this.getMax()){i.setValueState("Error");return;}i.setValueState("None");this.setValue(n);i.focus();this._fireChangeAndLiveChange({value:this.getValue()});};
S.prototype.init=function(){this._iActiveTouchId=-1;this._bSetValueFirstCall=true;this._bRTL=sap.ui.getCore().getConfiguration().getRTL();this._iLongestRangeTextWidth=0;this._fTooltipHalfWidthPercent=0;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle('sap.m');this._ariaUpdateDelay=[];};
S.prototype.exit=function(){if(this._oInputTooltip){this._oInputTooltip.label.destroy();this._oInputTooltip.label=null;this._oInputTooltip.tooltip.destroy();this._oInputTooltip.tooltip=null;this._oInputTooltip=null;}};
S.prototype.onBeforeRendering=function(){var e=this._validateProperties(),A=[Math.abs(this.getMin()),Math.abs(this.getMax())],r=A[0]>A[1]?0:1;if(!e){this.setValue(this.getValue());this._sProgressValue=Math.max(this._getPercentOfValue(this.getValue()),0)+"%";}if(!this._hasFocus()){this._fInitialFocusValue=this.getValue();}if(this.getShowAdvancedTooltip()){this._iLongestRangeTextWidth=((A[r].toString()).length+1)*this._CONSTANTS.CHARACTER_WIDTH_PX;}if(this.getInputsAsTooltips()&&!this._oInputTooltip){var s=new a({text:this._oResourceBundle.getText("SLIDER_HANDLE")});this._oInputTooltip={tooltip:this._createInputField("Tooltip",s),label:s};}};
S.prototype.onAfterRendering=function(){if(this.getShowAdvancedTooltip()){this._recalculateStyles();this._updateAdvancedTooltipDom(this.getValue());}};
S.prototype.ontouchstart=function(e){var m=this.getMin(),t=e.targetTouches[0],n,b=this.getRenderer().CSS_CLASS,s="."+b;e.setMarked();if(["number","text"].indexOf(e.target.type)>-1){return;}if(sap.m.touch.countContained(e.touches,this.getId())>1||!this.getEnabled()||e.button){return;}this._iActiveTouchId=t.identifier;q(document).on("touchend"+s+" touchcancel"+s+" mouseup"+s,this._ontouchend.bind(this)).on(e.originalEvent.type==="touchstart"?"touchmove"+s:"touchmove"+s+" mousemove"+s,this._ontouchmove.bind(this));var N=this.getClosestHandleDomRef();if(t.target!==N){q.sap.delayedCall(0,N,"focus");}if(!this._hasFocus()){this._fInitialFocusValue=this.getValue();}this._recalculateStyles();this._fDiffX=this._fSliderPaddingLeft;this._fInitialValue=this.getValue();this.$("inner").addClass(b+"Pressed");if(t.target===this.getDomRef("handle")){this._fDiffX=(t.pageX-q(N).offset().left)+this._fSliderPaddingLeft-(this._fHandleWidth/2);}else{n=(((t.pageX-this._fSliderPaddingLeft-this._fSliderOffsetLeft)/this._fSliderWidth)*(this.getMax()-m))+m;if(this._bRTL){n=this._convertValueToRtlMode(n);}this.setValue(n);n=this.getValue();if(this._fInitialValue!==n){this.fireLiveChange({value:n});}}};
S.prototype._ontouchmove=function(e){e.setMarked();e.preventDefault();if(e.isMarked("delayedMouseEvent")||!this.getEnabled()||e.button){return;}var m=this.getMin(),v=this.getValue(),t=sap.m.touch.find(e.changedTouches,this._iActiveTouchId),p=t?t.pageX:e.pageX,n=(((p-this._fDiffX-this._fSliderOffsetLeft)/this._fSliderWidth)*(this.getMax()-m))+m;if(this._bRTL){n=this._convertValueToRtlMode(n);}this.setValue(n);n=this.getValue();if(v!==n){this.fireLiveChange({value:n});}};
S.prototype._ontouchend=function(e){var b=this.getRenderer().CSS_CLASS,s="."+b;e.setMarked();if(e.isMarked("delayedMouseEvent")||!this.getEnabled()||e.button){return;}q(document).off(s);var v=this.getValue();this.$("inner").removeClass(b+"Pressed");if(this._fInitialValue!==v){this.fireChange({value:v});}};
S.prototype.onfocusin=function(e){var c=this.getRenderer().CSS_CLASS;this.$("TooltipsContainer").addClass(c+"HandleTooltipsShow");if(!this._hasFocus()){this._fInitialFocusValue=this.getValue();}};
S.prototype.onfocusout=function(e){var c=this.getRenderer().CSS_CLASS,i=this.getInputsAsTooltips();if(i&&q.contains(this.getDomRef(),e.relatedTarget)){return;}this.$("TooltipsContainer").removeClass(c+"HandleTooltipsShow");};
S.prototype.onsapincrease=function(e){var v,n;if(["number","text"].indexOf(e.target.type)>-1){return;}e.preventDefault();e.setMarked();if(this.getEnabled()){v=this.getValue();this.stepUp(1);n=this.getValue();if(v<n){this._fireChangeAndLiveChange({value:n});}}};
S.prototype.onsapincreasemodifiers=function(e){if(["number","text"].indexOf(e.target.type)>-1){return;}e.preventDefault();e.setMarked();this._increaseValueBy(this._getLongStep());};
S.prototype.onsapdecrease=function(e){var v,n;if(["number","text"].indexOf(e.target.type)>-1){return;}e.preventDefault();e.setMarked();if(this.getEnabled()){v=this.getValue();this.stepDown(1);n=this.getValue();if(v>n){this._fireChangeAndLiveChange({value:n});}}};
S.prototype.onsapdecreasemodifiers=function(e){if(["number","text"].indexOf(e.target.type)>-1){return;}e.preventDefault();e.setMarked();this._decreaseValueBy(this._getLongStep());};
S.prototype.onsapplus=function(e){var v,n;if(["number","text"].indexOf(e.target.type)>-1){return;}e.setMarked();if(this.getEnabled()){v=this.getValue();this.stepUp(1);n=this.getValue();if(v<n){this._fireChangeAndLiveChange({value:n});}}};
S.prototype.onsapminus=function(e){var v,n;if(["number","text"].indexOf(e.target.type)>-1){return;}e.setMarked();if(this.getEnabled()){v=this.getValue();this.stepDown(1);n=this.getValue();if(v>n){this._fireChangeAndLiveChange({value:n});}}};
S.prototype.onsappageup=S.prototype.onsapincreasemodifiers;S.prototype.onsappagedown=S.prototype.onsapdecreasemodifiers;
S.prototype.onsaphome=function(e){if(["number","text"].indexOf(e.target.type)>-1){return;}e.setMarked();var m=this.getMin();e.preventDefault();if(this.getEnabled()&&this.getValue()>m){this.setValue(m);this._fireChangeAndLiveChange({value:m});}};
S.prototype.onsapend=function(e){if(["number","text"].indexOf(e.target.type)>-1){return;}e.setMarked();var m=this.getMax();e.preventDefault();if(this.getEnabled()&&this.getValue()<m){this.setValue(m);this._fireChangeAndLiveChange({value:m});}};
S.prototype.onsaptabnext=function(){this._fInitialFocusValue=this.getValue();};
S.prototype.onsaptabprevious=function(){this._fInitialFocusValue=this.getValue();};
S.prototype.onsapescape=function(){this.setValue(this._fInitialFocusValue);};
S.prototype.getFocusDomRef=function(){return this.getDomRef("handle");};
S.prototype.stepUp=function(s){return this.setValue(this.getValue()+(this._validateStep(s)*this.getStep()),{snapValue:false});};
S.prototype.stepDown=function(s){return this.setValue(this.getValue()-(this._validateStep(s)*this.getStep()),{snapValue:false});};
S.prototype.setValue=function(n,o){if(this._bSetValueFirstCall){this._bSetValueFirstCall=false;return this.setProperty("value",n,true);}var m=this.getMin(),M=this.getMax(),s=this.getStep(),v=this.getValue(),N,b=true,f;if(o){b=!!o.snapValue;}if(typeof n!=="number"||!isFinite(n)){q.sap.log.error("Error:",'"fNewValue" needs to be a finite number on ',this);return this;}f=Math.abs((n-m)%s);if(b&&(f!==0)){n=f*2>=s?n+s-f:n-f;}if(n<m){n=m;}else if(n>M){n=M;}N=this.toFixed(n,this.getDecimalPrecisionOfNumber(s));n=Number(N);this.setProperty("value",n,true);if(v!==this.getValue()){this.setDomValue(N);}return this;};
return S;},true);
sap.ui.predefine('sap/m/SliderRenderer',['jquery.sap.global'],function(q){"use strict";var S={};S.CSS_CLASS="sapMSlider";
S.render=function(r,s){var e=s.getEnabled(),t=s.getTooltip_AsString(),C=S.CSS_CLASS;r.write("<div");this.addClass(r,s);if(!e){r.addClass(C+"Disabled");}r.addStyle("width",s.getWidth());r.writeClasses();r.writeStyles();r.writeControlData(s);if(t&&s.getShowHandleTooltip()){r.writeAttributeEscaped("title",t);}r.write(">");r.write('<div');r.writeAttribute("id",s.getId()+"-inner");this.addInnerClass(r,s);if(!e){r.addClass(C+"InnerDisabled");}r.writeClasses();r.writeStyles();r.write(">");if(s.getProgress()){this.renderProgressIndicator(r,s);}this.renderHandles(r,s);r.write("</div>");this.renderLabels(r,s);if(s.getName()){this.renderInput(r,s);}r.write("</div>");};
S.renderProgressIndicator=function(r,s){r.write("<div");r.writeAttribute("id",s.getId()+"-progress");this.addProgressIndicatorClass(r,s);r.addStyle("width",s._sProgressValue);r.writeClasses();r.writeStyles();r.write(' aria-hidden="true"></div>');};
S.renderHandles=function(r,s){this.renderHandle(r,s,{id:s.getId()+"-handle"});if(s.getShowAdvancedTooltip()){this.renderTooltips(r,s);}};
S.renderHandle=function(r,s,o){var e=s.getEnabled();r.write("<span");if(o&&(o.id!==undefined)){r.writeAttributeEscaped("id",o.id);}if(s.getShowHandleTooltip()&&!s.getShowAdvancedTooltip()){this.writeHandleTooltip(r,s);}this.addHandleClass(r,s);r.addStyle(sap.ui.getCore().getConfiguration().getRTL()?"right":"left",s._sProgressValue);this.writeAccessibilityState(r,s);r.writeClasses();r.writeStyles();if(e){r.writeAttribute("tabindex","0");}r.write("></span>");};
S.renderTooltips=function(r,s){r.write("<div");r.writeAttribute("id",s.getId()+"-TooltipsContainer");r.addClass(S.CSS_CLASS+"TooltipContainer");r.addStyle("left","0%");r.addStyle("right","0%");r.addStyle("min-width","0%");r.writeClasses();r.writeStyles();r.write(">");this.renderTooltip(r,s,s.getInputsAsTooltips());r.write("</div>");};
S.renderTooltip=function(r,s,i){if(i&&s._oInputTooltip){r.renderControl(s._oInputTooltip.tooltip);}else{r.write("<span");r.addClass(S.CSS_CLASS+"HandleTooltip");r.addStyle("width",s._iLongestRangeTextWidth+"px");r.writeAttribute("id",s.getId()+"-Tooltip");r.writeClasses();r.writeStyles();r.write(">");r.write("</span>");}};
S.writeHandleTooltip=function(r,s){r.writeAttribute("title",s.toFixed(s.getValue()));};
S.renderInput=function(r,s){r.write('<input type="text"');r.writeAttribute("id",s.getId()+"-input");r.addClass(S.CSS_CLASS+"Input");if(!s.getEnabled()){r.write("disabled");}r.writeClasses();r.writeAttributeEscaped("name",s.getName());r.writeAttribute("value",s.toFixed(s.getValue()));r.write("/>");};
S.writeAccessibilityState=function(r,s){r.writeAccessibilityState(s,{role:"slider",orientation:"horizontal",valuemin:s.toFixed(s.getMin()),valuemax:s.toFixed(s.getMax()),valuenow:s.toFixed(s.getValue())});};
S.addClass=function(r,s){r.addClass(S.CSS_CLASS);};
S.addInnerClass=function(r,s){r.addClass(S.CSS_CLASS+"Inner");};
S.addProgressIndicatorClass=function(r,s){r.addClass(S.CSS_CLASS+"Progress");};
S.addHandleClass=function(r,s){r.addClass(S.CSS_CLASS+"Handle");};
S.renderLabels=function(r,s){};
return S;},true);
sap.ui.predefine('sap/m/SplitApp',['jquery.sap.global','./SplitContainer','./library'],function(q,S,l){"use strict";
var a=S.extend("sap.m.SplitApp",{metadata:{library:"sap.m",properties:{homeIcon:{type:"any",group:"Misc",defaultValue:null}},events:{orientationChange:{parameters:{landscape:{type:"boolean"}}}}}});
a.prototype.init=function(){if(S.prototype.init){S.prototype.init.apply(this,arguments);}this.addStyleClass("sapMSplitApp");q.sap.initMobile({viewport:!this._debugZoomAndScroll,statusBar:"default",hideBrowser:true,preventScroll:!this._debugZoomAndScroll,rootId:this.getId()});};
a.prototype.onBeforeRendering=function(){if(S.prototype.onBeforeRendering){S.prototype.onBeforeRendering.apply(this,arguments);}q.sap.initMobile({homeIcon:this.getHomeIcon()});};
a.prototype.onAfterRendering=function(){if(S.prototype.onAfterRendering){S.prototype.onAfterRendering.apply(this,arguments);}var r=this.getDomRef().parentNode;if(r&&!r._sapui5_heightFixed){r._sapui5_heightFixed=true;while(r&&r!==document.documentElement){var $=q(r);if($.attr("data-sap-ui-root-content")){break;}if(!r.style.height){r.style.height="100%";}r=r.parentNode;}}};
a.prototype._onOrientationChange=function(){this.fireOrientationChange({landscape:sap.ui.Device.orientation.landscape});};
return a;},true);
sap.ui.predefine('sap/m/SplitAppRenderer',['jquery.sap.global','./SplitContainerRenderer','sap/ui/core/Renderer'],function(q,S,R){"use strict";var a={};var a=R.extend(S);
a.renderAttributes=function(r,c){sap.m.BackgroundHelper.addBackgroundColorStyles(r,c.getBackgroundColor(),c.getBackgroundImage());};
a.renderBeforeContent=function(r,c){sap.m.BackgroundHelper.renderBackgroundImageTag(r,c,"sapMSplitContainerBG",c.getBackgroundImage(),c.getBackgroundRepeat(),c.getBackgroundOpacity());};
return a;},true);
sap.ui.predefine('sap/m/SplitButton',['jquery.sap.global','./library','sap/ui/core/Control','./Button','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool'],function(q,l,C,B,E,I){"use strict";
var S=C.extend("sap.m.SplitButton",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null},type:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:sap.m.ButtonType.Default},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}},aggregations:{_textButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_arrowButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{},arrowPress:{}}}});
E.call(S.prototype);
S.prototype.exit=function(){if(this._oInvisibleTooltipInfoLabel){this._oInvisibleTooltipInfoLabel.destroy();this._oInvisibleTooltipInfoLabel=null;}};
S.prototype.onAfterRendering=function(){var $=this._getTextButton().$(),a=this._getArrowButton().$();$.attr("tabindex","-1");a.attr("tabindex","-1");$.removeAttr("title");a.removeAttr("title");$.removeAttr("aria-describedby");a.removeAttr("aria-describedby");};
S.prototype._handleAction=function(i){if(i){this.fireArrowPress();}else{this.firePress();}};
S.prototype.setArrowState=function(i){var a=this.getAggregation("_arrowButton");if(!a){return;}if(i){a.$().addClass('sapMSBActive');}else{a.$().removeClass('sapMSBActive');}};
S.prototype._getTextButton=function(){var c=this.getAggregation("_textButton");if(!c){c=new B({width:'100%',icon:this.getIcon(),text:this.getText(),press:this._handleAction.bind(this,false)}).addStyleClass('sapMSBText');if(sap.ui.Device.browser.msie){c.addStyleClass('sapMSBTextIE');}this.setAggregation("_textButton",c);}return c;};
S.prototype._getArrowButton=function(){var c=this.getAggregation("_arrowButton");if(!c){c=new B({icon:"sap-icon://slim-arrow-down",press:this._handleAction.bind(this,true)}).addStyleClass("sapMSBArrow");this.setAggregation("_arrowButton",c);}return c;};
S.prototype.setTooltip=function(t){var T;C.prototype.setTooltip.apply(this,arguments);T=this.getTooltip_AsString();this.getTooltipInfoLabel(T);return this;};
S.prototype.setProperty=function(p,v,s){if(p==="type"&&(v===sap.m.ButtonType.Up||v===sap.m.ButtonType.Back||v===sap.m.ButtonType.Unstyled)){return this;}var r=C.prototype.setProperty.apply(this,arguments);if(p==="activeIcon"||p==="iconDensityAware"||p==="textDirection"){B.prototype.setProperty.apply(this._getTextButton(),arguments);}else if(p==="text"||p==="type"||p==="icon"){var a="set"+_(p);B.prototype[a].call(this._getTextButton(),v);if(p==="type"){B.prototype[a].call(this._getArrowButton(),v);}}return r;};
function _(t){return t.charAt(0).toUpperCase()+t.slice(1);}
S.prototype.onsapenter=function(e){this._getTextButton().firePress();};
S.prototype.onsapspace=function(e){this._getTextButton().firePress();};
S.prototype.onsapup=function(e){this._getArrowButton().firePress();};
S.prototype.onsapdown=function(e){this._getArrowButton().firePress();};
S.prototype.onsapupmodifiers=function(e){this._getArrowButton().firePress();};
S.prototype.onsapdownmodifiers=function(e){this._getArrowButton().firePress();};
S.prototype.onsapshow=function(e){this._getArrowButton().firePress();e.preventDefault();};
S.prototype.getSplitButtonAriaLabel=function(){var r,t;if(!sap.m.SplitButton._oStaticSplitButtonAriaLabel){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");t=r.getText("SPLIT_BUTTON_DESCRIPTION");sap.m.SplitButton._oStaticSplitButtonAriaLabel=new sap.ui.core.InvisibleText({text:t});sap.m.SplitButton._oStaticSplitButtonAriaLabel.toStatic();}return sap.m.SplitButton._oStaticSplitButtonAriaLabel;};
S.prototype.getKeyboardDescriptionAriaLabel=function(){var r,t;if(!sap.m.SplitButton._oStaticSplitButtonDescription){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");t=r.getText("SPLIT_BUTTON_KEYBOARD_HINT");sap.m.SplitButton._oStaticSplitButtonDescription=new sap.ui.core.InvisibleText({text:t});sap.m.SplitButton._oStaticSplitButtonDescription.toStatic();}return sap.m.SplitButton._oStaticSplitButtonDescription;};
S.prototype.getButtonTypeAriaLabel=function(){var t,b=this._getTextButton().getType();switch(b){case sap.m.ButtonType.Accept:t=sap.m.Button._oStaticAcceptText;break;case sap.m.ButtonType.Reject:t=sap.m.Button._oStaticRejectText;break;case sap.m.ButtonType.Emphasized:t=sap.m.Button._oStaticEmphasizedText;break;}return t;};
S.prototype.getTooltipInfoLabel=function(t){if(!this._oInvisibleTooltipInfoLabel){this._oInvisibleTooltipInfoLabel=new sap.ui.core.InvisibleText();this._oInvisibleTooltipInfoLabel.toStatic();}this._oInvisibleTooltipInfoLabel.setText(t);return this._oInvisibleTooltipInfoLabel;};
S.prototype.getTitleAttributeValue=function(){var t=this.getTooltip_AsString(),i=I.getIconInfo(this.getIcon()),r;if(t||(i&&i.text&&!this.getText())){r=t||i.text;}return r;};
return S;},false);
sap.ui.predefine('sap/m/SplitButtonRenderer',['jquery.sap.global'],function(q){"use strict";var S={};S.CSS_CLASS="sapMSB";
S.render=function(r,b){var w=b.getWidth(),t=b.getType(),T=b.getTitleAttributeValue();r.write("<div");r.writeControlData(b);r.addClass(S.CSS_CLASS);if(b.getIcon()){r.addClass(S.CSS_CLASS+"HasIcon");}if(t===sap.m.ButtonType.Accept||t===sap.m.ButtonType.Reject||t===sap.m.ButtonType.Emphasized||t===sap.m.ButtonType.Transparent){r.addClass(S.CSS_CLASS+t);}r.writeClasses();this.writeAriaAttributes(r,b);r.writeAttribute("tabindex","0");if(T){r.writeAttributeEscaped("title",T);}if(w!=""||w.toLowerCase()==="auto"){r.addStyle("width",w);r.writeStyles();}r.write(">");r.write("<div");r.addClass("sapMSBInner");r.writeClasses();r.write(">");r.renderControl(b._getTextButton());r.renderControl(b._getArrowButton());r.write("</div>");r.write("</div>");};
S.writeAriaAttributes=function(r,b){var a={};this.writeAriaRole(b,a);this.writeAriaLabelledBy(b,a);r.writeAccessibilityState(b,a);};
S.writeAriaRole=function(b,a){a["role"]="group";};
S.writeAriaLabelledBy=function(b,a){var A="",t=b.getTitleAttributeValue(),B=b.getButtonTypeAriaLabel();if(t){A+=b.getTooltipInfoLabel(t).getId();A+=" ";}if(b.getText()){A+=b._getTextButton().getId()+"-content";A+=" ";}if(B){A+=B.getId();A+=" ";}A+=b.getSplitButtonAriaLabel().getId();A+=" "+b.getKeyboardDescriptionAriaLabel().getId();a["labelledby"]={value:A,append:true};};
return S;},true);
sap.ui.predefine('sap/m/SplitContainer.designtime',[],function(){"use strict";return{aggregations:{masterPages:{domRef:":sap-domref > .sapMSplitContainerMaster, :sap-domref > .sapMSplitContainerMobile"},detailPages:{domRef:":sap-domref > .sapMSplitContainerDetail"}}};},false);
sap.ui.predefine('sap/m/SplitContainer',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/theming/Parameters','sap/m/semantic/SemanticPage'],function(q,l,C,I,P,S){"use strict";
var a=C.extend("sap.m.SplitContainer",{metadata:{library:"sap.m",properties:{defaultTransitionNameDetail:{type:"string",group:"Appearance",defaultValue:"slide"},defaultTransitionNameMaster:{type:"string",group:"Appearance",defaultValue:"slide"},mode:{type:"sap.m.SplitAppMode",group:"Appearance",defaultValue:sap.m.SplitAppMode.ShowHideMode},masterButtonText:{type:"string",group:"Appearance",defaultValue:null},backgroundColor:{type:"string",group:"Appearance",defaultValue:null},backgroundImage:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},backgroundRepeat:{type:"boolean",group:"Appearance",defaultValue:false},backgroundOpacity:{type:"float",group:"Appearance",defaultValue:1}},aggregations:{masterPages:{type:"sap.ui.core.Control",multiple:true,singularName:"masterPage"},detailPages:{type:"sap.ui.core.Control",multiple:true,singularName:"detailPage"},_navMaster:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"},_navDetail:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"},_navPopover:{type:"sap.m.Popover",multiple:false,visibility:"hidden"}},associations:{initialDetail:{type:"sap.ui.core.Control",multiple:false},initialMaster:{type:"sap.ui.core.Control",multiple:false}},events:{masterNavigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterMasterNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},masterButton:{},beforeMasterOpen:{},afterMasterOpen:{},beforeMasterClose:{},afterMasterClose:{},detailNavigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterDetailNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}}},designTime:true}});
a.prototype.init=function(){var t=this;this._isMie9=false;if(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<10){this._isMie9=true;}this._aMasterPages=[];this._aDetailPages=[];if(!sap.ui.Device.system.phone){this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oMasterNav=new sap.m.NavContainer(this.getId()+"-Master",{width:"",navigate:function(e){t._handleNavigationEvent(e,false,true);},afterNavigate:function(e){t._handleNavigationEvent(e,true,true);}});this._oDetailNav=new sap.m.NavContainer(this.getId()+"-Detail",{width:"",navigate:function(e){t._handleNavigationEvent(e,false,false);},afterNavigate:function(e){t._handleNavigationEvent(e,true,false);}});this.setAggregation("_navMaster",this._oMasterNav,true);this.setAggregation("_navDetail",this._oDetailNav,true);this._createShowMasterButton();this._oPopOver=new sap.m.Popover(this.getId()+"-Popover",{placement:sap.m.PlacementType.Bottom,showHeader:false,contentWidth:"320px",contentHeight:"600px",beforeOpen:function(){t.fireBeforeMasterOpen();},beforeClose:function(){t.fireBeforeMasterClose();},afterOpen:function(){t.fireAfterMasterOpen();t._bMasterisOpen=true;},afterClose:function(){t._afterHideMasterAnimation();}}).addStyleClass("sapMSplitContainerPopover");this.setAggregation("_navPopover",this._oPopOver,true);}else{this._oMasterNav=this._oDetailNav=new sap.m.NavContainer({width:"",navigate:function(e){t._handleNavigationEvent(e,false,true);},afterNavigate:function(e){t._handleNavigationEvent(e,true,true);}});this.setAggregation("_navMaster",this._oMasterNav,true);}this._oldIsLandscape=sap.ui.Device.orientation.landscape;this._bMasterisOpen=false;var t=this;var p=function(r,n,s){return function(c,A,b){r.apply(t[n],arguments);if(A==="pages"&&q.inArray(c,t[s])!==-1){t._removePageFromArray(t[s],c);}};};var m=this._oMasterNav._removeChild;this._oMasterNav._removeChild=p(m,"_oMasterNav","_aMasterPages");if(this._oDetailNav){var d=this._oDetailNav._removeChild;this._oDetailNav._removeChild=p(d,"_oDetailNav","_aDetailPages");}};
a.prototype.onBeforeRendering=function(){if(this._fnResize){sap.ui.Device.resize.detachHandler(this._fnResize);}if(this._bMasterisOpen&&(this._portraitHide()||this._hideMode())){this._oShowMasterBtn.removeStyleClass("sapMSplitContainerMasterBtnHidden");this._bMasterisOpen=false;}};
a.prototype.exit=function(){if(this._fnResize){sap.ui.Device.resize.detachHandler(this._fnResize);}delete this._aMasterPages;delete this._aDetailPages;if(this._oShowMasterBtn){this._oShowMasterBtn.destroy();this._oShowMasterBtn=null;}};
a.prototype.onAfterRendering=function(){if(!sap.ui.Device.system.phone&&this._oPopOver&&this._oPopOver.isOpen()){this._oPopOver.close();}if(!this._fnResize){this._fnResize=q.proxy(this._handleResize,this);}sap.ui.Device.resize.attachHandler(this._fnResize);if(sap.ui.Device.os.windows&&sap.ui.Device.browser.internet_explorer){this._oMasterNav.$().append('<iframe class="sapMSplitContainerMasterBlindLayer" src="about:blank"></iframe>');}};
a.prototype.ontouchstart=function(e){if(!sap.ui.Device.system.phone){this._bIgnoreSwipe=(e.originalEvent&&e.originalEvent._sapui_handledByControl);}};
a.prototype.onswiperight=function(e){if(sap.ui.Device.support.touch===false){return;}if((sap.ui.Device.system.tablet||(sap.ui.Device.os.windows&&sap.ui.Device.os.version>=8))&&(this._portraitHide()||this._hideMode())&&!this._bIgnoreSwipe&&!this._bDetailNavButton){this.showMaster();}};
a.prototype.ontap=function(e){if(sap.ui.Device.system.phone){return;}var i=true;if(q(e.target).closest(".sapMSplitContainerDetail").length>0){i=false;}if(((!this._oldIsLandscape&&this.getMode()=="ShowHideMode")||this.getMode()=="HideMode")&&!i&&!q.sap.containsOrEquals(this._oShowMasterBtn.getDomRef(),e.target)){this.hideMaster();}};
a.prototype.onswipeleft=function(e){if((sap.ui.Device.system.tablet||(sap.ui.Device.os.windows&&sap.ui.Device.os.version>=8))&&(this._portraitHide()||this._hideMode())&&!this._bIgnoreSwipe){this.hideMaster();}};
a.prototype._onMasterButtonTap=function(e){if(sap.ui.Device.system.phone){return;}if(!this._oldIsLandscape){if(this.getMode()=="PopoverMode"){if(!this._oPopOver.isOpen()){this._oPopOver.openBy(this._oShowMasterBtn,true);}else{this._oPopOver.close();}}else{this.showMaster();}}else{if(this.getMode()==="HideMode"){this.showMaster();}}};
a.prototype.to=function(p,t,d,T){if(this._oMasterNav.getPage(p)){this._oMasterNav.to(p,t,d,T);}else{this._oDetailNav.to(p,t,d,T);}};
a.prototype.backToPage=function(p,b,t){if(this._oMasterNav.getPage(p)){this._oMasterNav.backToPage(p,b,t);}else{this._oDetailNav.backToPage(p,b,t);}};
a.prototype.insertPreviousPage=function(p,t,d){if(this._oMasterNav.getPage(p)){this._oMasterNav.insertPreviousPage(p,t,d);}else{this._oDetailNav.insertPreviousPage(p,t,d);}return this;};
a.prototype.toMaster=function(p,t,d,T){this._oMasterNav.to(p,t,d,T);};
a.prototype.backMaster=function(b,t){this._oMasterNav.back(b,t);};
a.prototype.backMasterToPage=function(p,b,t){this._oMasterNav.backToPage(p,b,t);};
a.prototype.toDetail=function(p,t,d,T){this._oDetailNav.to(p,t,d,T);};
a.prototype.backDetail=function(b,t){this._oDetailNav.back(b,t);};
a.prototype.backDetailToPage=function(p,b,t){this._oDetailNav.backToPage(p,b,t);};
a.prototype.backToTopMaster=function(b,t){this._oMasterNav.backToTop(b,t);};
a.prototype.backToTopDetail=function(b,t){this._oDetailNav.backToTop(b,t);};
a.prototype.addMasterPage=function(p){if(this._hasPageInArray(this._aMasterPages,p)){return;}if(this._oMasterNav===this._oDetailNav&&q.inArray(p,this._oDetailNav.getPages())!==-1){this._removePageFromArray(this._aDetailPages,p);}this._oMasterNav.addPage(p);this._aMasterPages.push(p);return this;};
a.prototype.addDetailPage=function(p){var t=this,r=this._getRealPage(p);if(this._hasPageInArray(this._aDetailPages,p)){return;}p.addDelegate({onBeforeShow:function(){if(r){if(!sap.ui.Device.system.phone){if(t._needShowMasterButton()){t._setMasterButton(r);}}}}});if(r){r.addDelegate({onBeforeRendering:function(){if(!sap.ui.Device.system.phone&&(t._oDetailNav.getCurrentPage()===r)){if(!r.getShowNavButton()&&t._needShowMasterButton()){t._setMasterButton(r,true);}else{t._removeMasterButton(r);}}}});if(!sap.ui.Device.system.phone){if(!r._setCustomHeaderInSC){r._setCustomHeaderInSC=r.setCustomHeader;}r.setCustomHeader=function(h){this._setCustomHeaderInSC.apply(this,arguments);if(h&&t._needShowMasterButton()){t._setMasterButton(r);}return this;};if(!r._setShowNavButtonInSC){r._setShowNavButtonInSC=r.setShowNavButton;}r.setShowNavButton=function(s){this._setShowNavButtonInSC.apply(this,arguments);if(!s&&t._needShowMasterButton()){t._setMasterButton(r);}else{t._removeMasterButton(r,true);}return this;};}}if(this._oMasterNav===this._oDetailNav&&q.inArray(p,this._oMasterNav.getPages())!==-1){this._removePageFromArray(this._aMasterPages,p);}this._oDetailNav.addPage(p);this._aDetailPages.push(p);return this;};
a.prototype.getMasterPages=function(){return this._aMasterPages;};
a.prototype.getDetailPages=function(){return this._aDetailPages;};
a.prototype.indexOfMasterPage=function(p){return this._indexOfMasterPage(p);};
a.prototype.indexOfDetailPage=function(p){return this._indexOfDetailPage(p);};
a.prototype.insertMasterPage=function(p,i,s){return this._insertPage(this._aMasterPages,"masterPages",p,i,s);};
a.prototype.removeMasterPage=function(p,s){return this._removePage(this._aMasterPages,"masterPages",p,s);};
a.prototype.removeAllMasterPages=function(s){this._aMasterPages=[];return this.removeAllAggregation("masterPages",s);};
a.prototype.insertDetailPage=function(p,i,s){return this._insertPage(this._aDetailPages,"detailPages",p,i,s);};
a.prototype._restoreMethodsInPage=function(p){if(sap.ui.Device.system.phone){return;}var r=this._getRealPage(p);if(r){if(r._setCustomHeaderInSC){r.setCustomHeader=r._setCustomHeaderInSC;delete r._setCustomHeaderInSC;}if(r._setShowNavButtonInSC){r.setShowNavButton=r._setShowNavButtonInSC;delete r._setShowNavButtonInSC;}}};
a.prototype.removeDetailPage=function(p,s){this._restoreMethodsInPage(p);return this._removePage(this._aDetailPages,"detailPages",p,s);};
a.prototype.removeAllDetailPages=function(s){var p=this.getDetailPages();for(var i=0;i<p.length;i++){this._restoreMethodsInPage(p[i]);}this._aDetailPages=[];return this.removeAllAggregation("detailPages",s);};
a.prototype.addPage=function(p,m){if(m){return this.addMasterPage(p);}else{return this.addDetailPage(p);}};
a.prototype.showMaster=function(){var _=this._oMasterNav.$(),t=this,A=q.proxy(this._afterShowMasterAnimation,this),b=this._getRealPage(this._oDetailNav.getCurrentPage());function c(){this._oPopOver.detachAfterOpen(c,this);this._bMasterOpening=false;this._bMasterisOpen=true;this.fireAfterMasterOpen();}if(this._portraitPopover()){if(!this._oPopOver.isOpen()){this._oPopOver.attachAfterOpen(c,this);this.fireBeforeMasterOpen();this._oPopOver.openBy(this._oShowMasterBtn,true);this._bMasterOpening=true;}}else{if((this._portraitHide()||this._hideMode())&&(!this._bMasterisOpen||this._bMasterClosing)){if(this._isMie9){this._oMasterNav.$().css("width","320px");_.animate({left:"+=320"},{duration:300,complete:A});this._bMasterisOpen=true;t._bMasterOpening=false;this._removeMasterButton(b);}else{_.bind("webkitTransitionEnd transitionend",A);}this.fireBeforeMasterOpen();this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",true);this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",false);this._bMasterOpening=true;t._removeMasterButton(b);if(sap.ui.Device.browser.webkit){var m=this._oMasterNav;window.setTimeout(function(){m.$().css("box-shadow","none");window.setTimeout(function(){m.$().css("box-shadow","");},50);},0);}}}return this;};
a.prototype.hideMaster=function(){var _=this._oMasterNav.$(),A=q.proxy(this._afterHideMasterAnimation,this);if(this._portraitPopover()){if(this._oPopOver.isOpen()){this._oPopOver.close();this._bMasterClosing=true;}}else{if((this._portraitHide()||this._hideMode())&&(this._bMasterisOpen||this._oMasterNav.$().hasClass("sapMSplitContainerMasterVisible"))){if(this._isMie9){_.animate({left:"-=320"},{duration:300,complete:A});}else{_.bind("webkitTransitionEnd transitionend",A);}this.fireBeforeMasterClose();this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",false);this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",true);this._bMasterClosing=true;}}return this;};
a.prototype._afterShowMasterAnimation=function(){if(this._portraitHide()||this._hideMode()){if(!this._isMie9){var m=this._oMasterNav.$();m.unbind("webkitTransitionEnd transitionend",this._afterShowMasterAnimation);}this._bMasterOpening=false;this._bMasterisOpen=true;this.fireAfterMasterOpen();}};
a.prototype._afterHideMasterAnimation=function(){if(this._portraitHide()||this._hideMode()){if(!this._isMie9){var m=this._oMasterNav.$();m.unbind("webkitTransitionEnd transitionend",this._afterHideMasterAnimation);}}var c=this._getRealPage(this._oDetailNav.getCurrentPage());this._setMasterButton(c);this._bMasterClosing=false;this._bMasterisOpen=false;if(q.sap.containsOrEquals(this._oMasterNav.getDomRef(),document.activeElement)){document.activeElement.blur();}this.fireAfterMasterClose();};
a.prototype.getCurrentMasterPage=function(){return this._oMasterNav.getCurrentPage();};
a.prototype.getCurrentDetailPage=function(){return this._oDetailNav.getCurrentPage();};
a.prototype.getCurrentPage=function(m){if(m){return this.getCurrentMasterPage();}else{return this.getCurrentDetailPage();}};
a.prototype.getPreviousPage=function(m){if(m){return this._oMasterNav.getPreviousPage();}else{return this._oDetailNav.getPreviousPage();}};
a.prototype.getMasterPage=function(p){return this._oMasterNav.getPage(p);};
a.prototype.getDetailPage=function(p){return this._oDetailNav.getPage(p);};
a.prototype.getPage=function(p,m){if(m){return this.getMasterPage(p);}else{return this.getDetailPage(p);}};
a.prototype.isMasterShown=function(){if(sap.ui.Device.system.phone){var c=this._oMasterNav.getCurrentPage();return this._indexOfMasterPage(c)!==-1;}else{var m=this.getMode();switch(m){case sap.m.SplitAppMode.StretchCompressMode:return true;case sap.m.SplitAppMode.HideMode:return this._bMasterisOpen;case sap.m.SplitAppMode.PopoverMode:case sap.m.SplitAppMode.ShowHideMode:return sap.ui.Device.orientation.landscape||this._bMasterisOpen;default:return false;}}};
a.prototype.setInitialMaster=function(p){this._oMasterNav.setInitialPage(p);this.setAssociation('initialMaster',p,true);return this;};
a.prototype.setInitialDetail=function(p){if(!sap.ui.Device.system.phone){this._oDetailNav.setInitialPage(p);}this.setAssociation('initialDetail',p,true);return this;};
a.prototype.setDefaultTransitionNameDetail=function(t){this.setProperty("defaultTransitionNameDetail",t,true);this._oDetailNav.setDefaultTransitionName(t);return this;};
a.prototype.setDefaultTransitionNameMaster=function(t){this.setProperty("defaultTransitionNameMaster",t,true);this._oMasterNav.setDefaultTransitionName(t);return this;};
a.prototype.setMasterButtonText=function(t){if(!sap.ui.Device.system.phone){if(!t){t=this._rb.getText("SplitContainer_NAVBUTTON_TEXT");}this._oShowMasterBtn.setText(t);}this.setProperty("masterButtonText",t,true);return this;};
a.prototype.setMode=function(m){var o=this.getMode();if(o===m){return this;}this.setProperty("mode",m,true);if(!sap.ui.Device.system.phone&&this.getDomRef()){if(o==="HideMode"&&this._oldIsLandscape){this._removeMasterButton(this._oDetailNav.getCurrentPage());if(this._isMie9){this._oMasterNav.$().css({left:0,width:""});}}if(m!=="PopoverMode"&&this._oPopOver.getContent().length>0){this._updateMasterPosition("landscape");}else if(m=="PopoverMode"){if(!this._oldIsLandscape){if(this._oPopOver.getContent().length===0){this._updateMasterPosition("popover");}this._setMasterButton(this._oDetailNav.getCurrentPage());}this.toggleStyleClass("sapMSplitContainerShowHide",false);this.toggleStyleClass("sapMSplitContainerStretchCompress",false);this.toggleStyleClass("sapMSplitContainerHideMode",false);this.toggleStyleClass("sapMSplitContainerPopover",true);}if(m=="StretchCompressMode"){this.toggleStyleClass("sapMSplitContainerShowHide",false);this.toggleStyleClass("sapMSplitContainerPopover",false);this.toggleStyleClass("sapMSplitContainerHideMode",false);this.toggleStyleClass("sapMSplitContainerStretchCompress",true);this._removeMasterButton(this._oDetailNav.getCurrentPage());}if(m=="ShowHideMode"){this.toggleStyleClass("sapMSplitContainerPopover",false);this.toggleStyleClass("sapMSplitContainerStretchCompress",false);this.toggleStyleClass("sapMSplitContainerHideMode",false);this.toggleStyleClass("sapMSplitContainerShowHide",true);if(!sap.ui.Device.orientation.landscape){this._setMasterButton(this._oDetailNav.getCurrentPage());}}if(m==="HideMode"){this.toggleStyleClass("sapMSplitContainerPopover",false);this.toggleStyleClass("sapMSplitContainerStretchCompress",false);this.toggleStyleClass("sapMSplitContainerShowHide",false);this.toggleStyleClass("sapMSplitContainerHideMode",true);this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",false);this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",true);this._bMasterisOpen=false;this._setMasterButton(this._oDetailNav.getCurrentPage());if(this._isMie9){this._oMasterNav.$().css({left:"",width:"auto"});}}}return this;};
a.prototype.setBackgroundOpacity=function(o){if(o>1||o<0){q.sap.log.warning("Invalid value "+o+" for SplitContainer.setBackgroundOpacity() ignored. Valid values are: floats between 0 and 1.");return this;}this.$("BG").css("opacity",o);return this.setProperty("backgroundOpacity",o,true);};
a.prototype._indexOfMasterPage=function(p){return q.inArray(p,this._aMasterPages);};
a.prototype._indexOfDetailPage=function(p){return q.inArray(p,this._aDetailPages);};
a.prototype._insertPage=function(p,A,o,b,s){this.insertAggregation(A,o,b,s);var i;if(b<0){i=0;}else if(b>p.length){i=p.length;}else{i=b;}var O=q.inArray(o,p);p.splice(i,0,o);if(O!=-1){this._removePageFromArray(p,o);}return this;};
a.prototype._removePage=function(p,A,o,s){var r=this.removeAggregation(A,o,s);if(r){this._removePageFromArray(p,r);}return r;};
a.prototype._removePageFromArray=function(p,o){var i=q.inArray(o,p);if(i!=-1){p.splice(i,1);if(p===this._aDetailPages){this._restoreMethodsInPage(o);}}};
a.prototype._handleNavigationEvent=function(e,A,m){var E=(A?"After":"")+(m?"Master":"Detail")+"Navigate",c;E=E.charAt(0).toLowerCase()+E.slice(1);c=this.fireEvent(E,e.mParameters,true);if(!c){e.preventDefault();}};
a.prototype._handleResize=function(){var i=sap.ui.Device.orientation.landscape,_=this._oDetailNav.getCurrentPage(),m=this.getMode();if(this._oldIsLandscape!==i){this._oldIsLandscape=i;if(!sap.ui.Device.system.phone){this.toggleStyleClass("sapMSplitContainerPortrait",!i);if(m==="HideMode"){return;}if(m==="ShowHideMode"){if(i){this.fireBeforeMasterOpen();}else{this.fireBeforeMasterClose();}}if(this._isMie9){if(i){this._oMasterNav.$().css({left:0,width:""});}else{if(m==="ShowHideMode"||m==="PopoverMode"){this._oMasterNav.$().css({left:-320,width:"auto"});}}}if(m==="ShowHideMode"||m==="PopoverMode"){this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",i);this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",!i);}if(m==="ShowHideMode"){if(i){this._bMasterisOpen=true;this.fireAfterMasterOpen();}else{this._bMasterisOpen=false;this.fireAfterMasterClose();}}if(m=="PopoverMode"){if(this._oPopOver.isOpen()){this._oPopOver.attachAfterClose(this._handlePopClose,this);this._oPopOver.close();}else{this._handlePopClose();}}_=this._getRealPage(_);if(!this._oldIsLandscape&&m!="StretchCompressMode"){this._setMasterButton(_);}else{this._removeMasterButton(_);}}if(this._onOrientationChange){this._onOrientationChange();}}};
a.prototype._handlePopClose=function(e){this._oPopOver.detachAfterClose(this._handlePopClose,this);if(this._oldIsLandscape){this._updateMasterPosition("landscape");}else{this._updateMasterPosition("popover");}};
a.prototype._getRealPage=function(p){var r=p,c;while(r){if(r instanceof sap.m.Page){return r;}if(r instanceof sap.m.MessagePage){return r;}if(r instanceof S){return r;}if(r instanceof sap.ui.core.mvc.View){c=r.getContent();if(c.length===1){r=c[0];continue;}}else if(r instanceof sap.m.NavContainer){r=r.getCurrentPage();continue;}r=null;}return r;};
a.prototype._updateMasterPosition=function(p){var t=this;if(p=="popover"){this.removeAggregation("_navMaster",this._oMasterNav,true);this._oMasterNav.$().remove();this._oPopOver.addContent(this._oMasterNav);this._bMasterisOpen=false;}if(p=="landscape"){var r=function(){t._oPopOver.removeAggregation("content",t._oMasterNav,false);t.setAggregation("_navMaster",t._oMasterNav,true);var $=t.$();if($[0]){var b=sap.ui.getCore().createRenderManager();b.renderControl(t._oMasterNav.addStyleClass("sapMSplitContainerMaster"));b.flush($[0],false,(t.$("BG")[0])?1:0);b.destroy();}};if(this._oPopOver.isOpen()){var A=function(){this._oPopOver.detachAfterClose(A,this);this._bMasterisOpen=false;r();};this._oPopOver.attachAfterClose(A,this);this._oPopOver.close();}else{r();}}};
a.prototype._portraitHide=function(){if(!this._oldIsLandscape&&!sap.ui.Device.system.phone&&this.getMode()==="ShowHideMode"){return true;}else{return false;}};
a.prototype._portraitPopover=function(){if(!this._oldIsLandscape&&!sap.ui.Device.system.phone&&this.getMode()==="PopoverMode"){return true;}else{return false;}};
a.prototype._hideMode=function(){return this.getMode()==="HideMode"&&!sap.ui.Device.system.phone;};
a.prototype._needShowMasterButton=function(){return(this._portraitHide()||this._hideMode()||this._portraitPopover())&&(!this._bMasterisOpen||this._bMasterClosing);};
a.prototype._createShowMasterButton=function(){if(this._oShowMasterBtn&&!this._oShowMasterBtn.bIsDestroyed){return;}this._oShowMasterBtn=new sap.m.Button(this.getId()+"-MasterBtn",{icon:I.getIconURI("menu2"),type:sap.m.ButtonType.Default,press:q.proxy(this._onMasterButtonTap,this)}).addStyleClass("sapMSplitContainerMasterBtn");};
a.prototype._setMasterButton=function(p,c,s){if(!p){return;}if(typeof c==='boolean'){s=c;c=undefined;}p=this._getRealPage(p);var h=a._getHeaderButtonAggregation(p),H=h.sAggregationName,b=h.aAggregationContent;for(var i=0;i<b.length;i++){if(b[i]instanceof sap.m.Button&&b[i].getVisible()&&(b[i].getType()==sap.m.ButtonType.Back||(b[i].getType()==sap.m.ButtonType.Up&&b[i]!==this._oShowMasterBtn))){this._bDetailNavButton=true;return;}}this._bDetailNavButton=false;var o=p._getAnyHeader();var d=false;for(var i=0;i<b.length;i++){if(b[i]===this._oShowMasterBtn){d=true;}}if(!d){this._createShowMasterButton();this._oShowMasterBtn.removeStyleClass("sapMSplitContainerMasterBtnHidden");if(o){o.insertAggregation(H,this._oShowMasterBtn,0,s);}}else{if(this._isMie9){this._oShowMasterBtn.$().fadeIn();}this._oShowMasterBtn.$().parent().toggleClass("sapMSplitContainerMasterBtnHide",false);this._oShowMasterBtn.removeStyleClass("sapMSplitContainerMasterBtnHidden");this._oShowMasterBtn.$().parent().toggleClass("sapMSplitContainerMasterBtnShow",true);}if(c){c(p);}this.fireMasterButton({show:true});};
a._getHeaderButtonAggregation=function(p){var h=p._getAnyHeader(),A,s;if(!h){return;}if(h.getContentLeft){A=h.getContentLeft();s="contentLeft";}if(h.getContent){A=h.getContent();s="content";}return{aAggregationContent:A,sAggregationName:s};};
a.prototype._removeMasterButton=function(p,c,n){if(!p){return;}var t=this,h=this._oShowMasterBtn.$().is(":hidden"),H;if(typeof c==="boolean"){n=c;c=undefined;}if(!h&&!n){p=this._getRealPage(p);if(!p){return;}H=p._getAnyHeader();if(H){var b=a._getHeaderButtonAggregation(p).aAggregationContent;for(var i=0;i<b.length;i++){if(b[i]===this._oShowMasterBtn){if(this._isMie9){this._oShowMasterBtn.$().fadeOut();if(c){c(p);}}this._oShowMasterBtn.$().parent().toggleClass("sapMSplitContainerMasterBtnShow",false);this._oShowMasterBtn.$().parent().toggleClass("sapMSplitContainerMasterBtnHide",true);this._oShowMasterBtn.$().parent().bind("webkitAnimationEnd animationend",function(){q(this).unbind("webkitAnimationEnd animationend");t._oShowMasterBtn.addStyleClass("sapMSplitContainerMasterBtnHidden");if(c){c(p);}});return;}}}this.fireMasterButton({show:false});}else{this._oShowMasterBtn.addStyleClass("sapMSplitContainerMasterBtnHidden");if(c){c(p);}if(!h){this.fireMasterButton({show:false});}}};
a.prototype._callMethodInManagedObject=function(f,A){var b=Array.prototype.slice.call(arguments);if(A==="masterPages"){if(f==="indexOfAggregation"){return this._indexOfMasterPage.apply(this,b.slice(2));}else{return this._callNavContainerMethod(f,this._oMasterNav,b);}}else if(A==="detailPages"){if(f==="indexOfAggregation"){return this._indexOfDetailPage.apply(this,b.slice(2));}else{return this._callNavContainerMethod(f,this._oDetailNav,b);}}else{return sap.ui.base.ManagedObject.prototype[f].apply(this,b.slice(1));}};
a.prototype._callNavContainerMethod=function(f,n,A){A[1]="pages";A=A.slice(1);var r=a._mFunctionMapping[f];if(r){A.shift();f=r;}return n[f].apply(n,A);};
a.prototype._hasPageInArray=function(b,p){return b.some(function(A){return p&&(p===A);});};
a.prototype.validateAggregation=function(A,o,m){return this._callMethodInManagedObject("validateAggregation",A,o,m);};
a.prototype.setAggregation=function(A,o,s){this._callMethodInManagedObject("setAggregation",A,o,s);return this;};
a.prototype.getAggregation=function(A,d){return this._callMethodInManagedObject("getAggregation",A,d);};
a.prototype.indexOfAggregation=function(A,o){return this._callMethodInManagedObject("indexOfAggregation",A,o);};
a.prototype.insertAggregation=function(A,o,i,s){this._callMethodInManagedObject("insertAggregation",A,o,i,s);return this;};
a.prototype.addAggregation=function(A,o,s){this._callMethodInManagedObject("addAggregation",A,o,s);return this;};
a.prototype.removeAggregation=function(A,o,s){return this._callMethodInManagedObject("removeAggregation",A,o,s);};
a.prototype.removeAllAggregation=function(A,s){return this._callMethodInManagedObject("removeAllAggregation",A,s);};
a.prototype.destroyAggregation=function(A,s){this._callMethodInManagedObject("destroyAggregation",A,s);return this;};
a._mFunctionMapping={"getAggregation":"getPage","addAggregation":"addPage","insertAggregation":"insertPage","removeAggregation":"removePage","removeAllAggregation":"removeAllPages"};return a;},true);
sap.ui.predefine('sap/m/SplitContainerRenderer',['jquery.sap.global'],function(q){"use strict";var S={};
S.render=function(r,c){var m=c.getMode();r.write("<div");r.writeControlData(c);r.addClass("sapMSplitContainer");if(this.renderAttributes){this.renderAttributes(r,c);}if(!sap.ui.Device.system.phone){if(sap.ui.Device.orientation.portrait){c.addStyleClass("sapMSplitContainerPortrait");}switch(m){case"ShowHideMode":c.addStyleClass("sapMSplitContainerShowHide");break;case"StretchCompress":c.addStyleClass("sapMSplitContainerStretchCompress");break;case"PopoverMode":c.addStyleClass("sapMSplitContainerPopover");break;case"HideMode":c.addStyleClass("sapMSplitContainerHideMode");break;}}r.writeClasses(c);r.writeStyles();var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.write(">");if(this.renderBeforeContent){this.renderBeforeContent(r,c);}if(!sap.ui.Device.system.phone){c._bMasterisOpen=false;if((sap.ui.Device.orientation.landscape&&(m!=="HideMode"))||sap.ui.Device.orientation.portrait&&(m==="StretchCompress")){c._oMasterNav.addStyleClass("sapMSplitContainerMasterVisible");c._bMasterisOpen=true;}else{c._oMasterNav.addStyleClass("sapMSplitContainerMasterHidden");}if(c.getMode()==="PopoverMode"&&sap.ui.Device.orientation.portrait){c._oDetailNav.addStyleClass("sapMSplitContainerDetail");r.renderControl(c._oDetailNav);if(c._oPopOver.getContent().length===0){c._oPopOver.addAggregation("content",c._oMasterNav,true);}}else{c._oMasterNav.addStyleClass("sapMSplitContainerMaster");r.renderControl(c._oMasterNav);c._oDetailNav.addStyleClass("sapMSplitContainerDetail");r.renderControl(c._oDetailNav);}}else{c._oMasterNav.addStyleClass("sapMSplitContainerMobile");r.renderControl(c._oMasterNav);}r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/m/StandardListItem',['jquery.sap.global','./ListItemBase','./library','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool'],function(q,L,l,E,I){"use strict";
var S=L.extend("sap.m.StandardListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},description:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconInset:{type:"boolean",group:"Appearance",defaultValue:true},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},info:{type:"string",group:"Misc",defaultValue:null},infoState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:sap.ui.core.ValueState.None},adaptTitleSize:{type:"boolean",group:"Appearance",defaultValue:true},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},infoTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}}}});
S.prototype.exit=function(){if(this._oImage){this._oImage.destroy("KeepDom");}L.prototype.exit.apply(this,arguments);};
S.prototype.setIcon=function(i){var o=this.getIcon();this.setProperty("icon",i);if(this._oImage&&(!i||I.isIconURI(i)!=I.isIconURI(o))){this._oImage.destroy("KeepDom");this._oImage=undefined;}return this;};
S.prototype._getImage=function(){var i=this._oImage;if(i){i.setSrc(this.getIcon());if(i instanceof sap.m.Image){i.setDensityAware(this.getIconDensityAware());}}else{i=I.createControlByURI({id:this.getId()+"-img",src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false},sap.m.Image).setParent(this,null,true);}var s=this.getIconInset()?"sapMSLIImg":"sapMSLIImgThumb";i.addStyleClass(i instanceof sap.m.Image?s:s+"Icon",true);this._oImage=i;return this._oImage;};
S.prototype._activeHandlingInheritor=function(){if(this._oImage){var a=this.getActiveIcon();a&&this._oImage.setSrc(a);}};
S.prototype._inactiveHandlingInheritor=function(){if(this._oImage){this._oImage.setSrc(this.getIcon());}};
return S;},true);
sap.ui.predefine('sap/m/StandardListItemRenderer',['jquery.sap.global','./ListItemBaseRenderer','sap/ui/core/Renderer'],function(q,L,R){"use strict";var S=R.extend(L);
S.renderLIAttributes=function(r,l){r.addClass("sapMSLI");if(l.getIcon()){r.addClass("sapMSLIIcon");}if(!l.getIconInset()){r.addClass("sapMSLIIconThumb");}if((l.getDescription()||!l.getAdaptTitleSize())&&l.getIcon()&&l.getIconInset()){r.addClass("sapMSLIDescIcon");}if((l.getDescription()||!l.getAdaptTitleSize())&&!l.getIcon()){r.addClass("sapMSLIDescNoIcon");}if(!l.getDescription()&&l.getIcon()){r.addClass("sapMSLINoDescIcon");}if(l.getType()==sap.m.ListType.Detail||l.getType()==sap.m.ListType.DetailAndActive){r.addClass("sapMSLIDetail");}};
S.renderLIContent=function(r,l){var i=l.getInfo(),I=l.getInfoTextDirection(),t=l.getTitleTextDirection(),d=l.getTitle()&&(l.getDescription()||!l.getAdaptTitleSize());if(l.getIcon()){r.renderControl(l._getImage());}if(d){r.write('<div class="sapMSLIDiv">');}r.write("<div");if(!d){r.addClass("sapMSLIDiv");}r.addClass("sapMSLITitleDiv");r.writeClasses();r.write(">");r.write("<div");r.addClass(d?"sapMSLITitle":"sapMSLITitleOnly");r.writeClasses();if(t!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",t.toLowerCase());}r.write(">");r.writeEscaped(l.getTitle());r.write("</div>");if(i&&!d){r.write("<div");r.writeAttribute("id",l.getId()+"-info");r.addClass("sapMSLIInfo");r.addClass("sapMSLIInfo"+l.getInfoState());r.writeClasses();if(I!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",I.toLowerCase());}r.write(">");r.writeEscaped(i);r.write("</div>");}r.write("</div>");r.write('<div class="sapMSLIDescriptionDiv">');if(d){r.write('<div class="sapMSLIDescription">');if(l.getDescription()){r.writeEscaped(l.getDescription());}else{r.write("&nbsp;");}r.write("</div>");}if(i&&d){r.write("<div");r.writeAttribute("id",l.getId()+"-info");r.addClass("sapMSLIInfo");r.addClass("sapMSLIInfo"+l.getInfoState());r.writeClasses();if(I!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",I.toLowerCase());}r.write(">");r.writeEscaped(i);r.write("</div>");}r.write("</div>");if(d){r.write("</div>");}};
S.getAriaDescribedBy=function(l){var b=L.getAriaDescribedBy.call(this,l)||"",i=l.getInfoState();if(i==sap.ui.core.ValueState.None||!l.getInfo()){return b;}var d=this.getAriaAnnouncement("STATE_"+i.toUpperCase());return d+" "+b;};
S.getAccessibilityState=function(l){var a=L.getAccessibilityState.call(this,l);if(l.getInfoState()==sap.ui.core.ValueState.Error&&l.getInfo()){a.invalid=true;}return a;};
return S;},true);
sap.ui.predefine('sap/m/StandardTile',['jquery.sap.global','./Tile','./library','sap/ui/core/IconPool'],function(q,T,l,I){"use strict";
var S=T.extend("sap.m.StandardTile",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},info:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null},infoState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:sap.ui.core.ValueState.None},type:{type:"sap.m.StandardTileType",group:"Misc",defaultValue:sap.m.StandardTileType.None},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}}}});
S.prototype.exit=function(){if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=null;}};
S.prototype.getIcon=function(){if(!this.getProperty("icon")&&this.getType()==="Create"){return I.getIconURI("add");}else{return this.getProperty("icon");}};
S.prototype._getImage=function(){var i=this.getId()+"-img";var s=sap.ui.Device.system.phone?"1.3rem":"2rem";var p={src:this.getIcon(),height:s,width:s,size:s,densityAware:this.getIconDensityAware(),useIconTooltip:false};this._oImageControl=sap.m.ImageHelper.getImageControl(i,this._oImageControl,this,p);return this._oImageControl;};
return S;},true);
sap.ui.predefine('sap/m/StandardTileRenderer',['jquery.sap.global','./TileRenderer','sap/ui/core/ValueStateSupport'],function(q,T,V){"use strict";var S=sap.ui.core.Renderer.extend(T);
S._renderContent=function(r,t){var i=t.getInfoState();r.write("<div");r.addClass("sapMStdTileTopRow");r.writeClasses();r.write(">");if(t.getIcon()){r.write("<div");r.addClass("sapMStdTileIconDiv");switch(t.getType()){case sap.m.StandardTileType.Monitor:r.addClass("sapMStdIconMonitor");break;case sap.m.StandardTileType.Create:r.addClass("sapMStdIconCreate");break;}r.writeClasses();r.write(">");r.renderControl(t._getImage());r.write("</div>");}if(t.getNumber()){r.write("<div");r.addClass("sapMStdTileNumDiv");r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",t.getId()+"-number");var n=t.getNumber().length;if(n<5){r.addClass("sapMStdTileNum");}else if(n<8){r.addClass("sapMStdTileNumM");}else{r.addClass("sapMStdTileNumS");}r.writeClasses();r.write(">");r.writeEscaped(t.getNumber());r.write("</div>");if(t.getNumberUnit()){r.write("<div");r.writeAttribute("id",t.getId()+"-numberUnit");r.addClass("sapMStdTileNumUnit");r.writeClasses();r.write(">");r.writeEscaped(t.getNumberUnit());r.write("</div>");}r.write("</div>");}r.write("</div>");r.write("<div");r.addClass("sapMStdTileBottomRow");if(t.getType()===sap.m.StandardTileType.Monitor){r.addClass("sapMStdTileMonitorType");}r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",t.getId()+"-title");r.addClass("sapMStdTileTitle");r.writeClasses();r.write(">");if(t.getTitle()){r.writeEscaped(t.getTitle());}r.write("</div>");if(t.getInfo()){r.write("<div");r.writeAttribute("id",t.getId()+"-info");r.addClass("sapMStdTileInfo");r.addClass("sapMStdTileInfo"+i);r.writeClasses();if(i!=sap.ui.core.ValueState.None){r.writeAccessibilityState(t,{ariaDescribedBy:{value:t.getId()+"-sapSRH",append:true}});}r.write(">");if(t.getInfo()){r.writeEscaped(t.getInfo());}r.write("</div>");}if(i!=sap.ui.core.ValueState.None){r.write("<span");r.writeAttributeEscaped("id",t.getId()+"-sapSRH");r.addClass("sapUiInvisibleText");r.writeClasses();r.writeAccessibilityState({hidden:false});r.write(">");r.writeEscaped(V.getAdditionalText(i));r.write("</span>");}r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/m/StandardTreeItem',['jquery.sap.global','./TreeItemBase','./library','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/Icon','./StandardListItem'],function(q,T,l,E,I,a,S){"use strict";
var b=T.extend("sap.m.StandardTreeItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null}}}});
b.prototype._getIconControl=function(){var u=this.getIcon();if(this._oIconControl){this._oIconControl.setSrc(u);return this._oIconControl;}this._oIconControl=I.createControlByURI({id:this.getId()+"-icon",src:u,useIconTooltip:false,noTabStop:true},sap.m.Image).setParent(this,null,true).addStyleClass("sapMSTIIcon");return this._oIconControl;};
b.prototype.exit=function(){T.prototype.exit.apply(this,arguments);this.destroyControls(["Icon"]);};
return b;},true);
sap.ui.predefine('sap/m/StandardTreeItemRenderer',['./TreeItemBaseRenderer','sap/ui/core/Renderer'],function(T,R){"use strict";var S=R.extend(T);
S.renderLIContent=function(r,l){if(l.getIcon()){r.renderControl(l._getIconControl());}r.writeEscaped(l.getTitle());};
return S;},true);
sap.ui.predefine('sap/m/StepInput',["jquery.sap.global","./Button","./Input","sap/ui/core/Control","sap/ui/core/IconPool"],function(q,B,I,C,a){"use strict";
var S=C.extend("sap.m.StepInput",{metadata:{library:"sap.m",properties:{min:{type:"Number",group:"Data"},max:{type:"Number",group:"Data"},step:{type:"Number",group:"Data",defaultValue:1},largerStep:{type:"Number",group:"Data",defaultValue:2},value:{type:"Number",group:"Data",defaultValue:0},width:{type:"sap.ui.core.CSSSize",group:"Dimension"},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:sap.ui.core.ValueState.None},editable:{type:"boolean",group:"Behavior",defaultValue:true},enabled:{type:"boolean",group:"Behavior",defaultValue:true}},aggregations:{_incrementButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_decrementButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_input:{type:"sap.m.Input",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{change:{parameters:{value:{type:"string"}}}}}});
var l=sap.ui.getCore().getLibraryResourceBundle("sap.m");S.STEP_INPUT_INCREASE_BTN_TOOLTIP=l.getText("STEP_INPUT_INCREASE_BTN");S.STEP_INPUT_DECREASE_BTN_TOOLTIP=l.getText("STEP_INPUT_DECREASE_BTN");
S.prototype.init=function(){this._attachPressEvents();this._attachLiveChange();this._attachChange();};
S.prototype.onBeforeRendering=function(){var m=this._getIntOrFloat(this.getMin()),M=this._getIntOrFloat(this.getMax()),v=this._getIntOrFloat(this.getValue());this._getInput().setValue(v);if(i(m)&&(m>v)){this.setValue(m);}if(i(M)&&(M<v)){this.setValue(M);}this._disableButtons(v,M,m);};
S.prototype._getIntOrFloat=function(n){return this.isInteger(n)?parseInt(n,10):parseFloat(n,10);};
S.prototype.onAfterRendering=function(){this._writeAccessibilityState();this._getIncrementButton().$().attr('tabindex','-1');this._getDecrementButton().$().attr('tabindex','-1');};
S.prototype.setProperty=function(p,v,s){this._writeAccessibilityState(p,v);if(["enabled","editable"].indexOf(p)>-1){this._getInput().setProperty(p,v,s);}return C.prototype.setProperty.apply(this,arguments);};
S.prototype.setMin=function(n){return this.setProperty("min",n,true);};
S.prototype.setMax=function(n){return this.setProperty("max",n,true);};
S.prototype._getIncrementButton=function(){if(!this.getAggregation("_incrementButton")){var b=new B({icon:a.getIconURI("add"),id:this.getId()+"-incrementButton",tooltip:S.STEP_INPUT_INCREASE_BTN_TOOLTIP,type:sap.m.ButtonType.Transparent});b._bExcludeFromTabChain=true;this.setAggregation("_incrementButton",b);}return this.getAggregation("_incrementButton");};
S.prototype._getDecrementButton=function(){if(!this.getAggregation("_decrementButton")){var b=new B({icon:a.getIconURI("less"),id:this.getId()+"-decrementButton",tooltip:S.STEP_INPUT_DECREASE_BTN_TOOLTIP,type:sap.m.ButtonType.Transparent});b._bExcludeFromTabChain=true;this.setAggregation("_decrementButton",b);}return this.getAggregation("_decrementButton");};
S.prototype._getInput=function(){if(!this.getAggregation("_input")){this.setAggregation("_input",new I({width:this.getWidth(),id:this.getId()+"-input",textAlign:sap.ui.core.TextAlign.End,type:sap.m.InputType.Number,editable:this.getEditable(),enabled:this.getEnabled()}));}return this.getAggregation("_input");};
S.prototype._attachPressEvents=function(){this._getIncrementButton().attachPress(this._handleButtonPress.bind(this,true));this._getDecrementButton().attachPress(this._handleButtonPress.bind(this,false));};
S.prototype._handleButtonPress=function(b){var v=this._calculateValue(1,b),m=this._getIntOrFloat(this.getMin()),M=this._getIntOrFloat(this.getMax()),c=this._getInput().getValueState();if(c==sap.ui.core.ValueState.Error&&(v==m||v==M)){this.setValueState(sap.ui.core.ValueState.None);}this._disableButtons(this._getIntOrFloat(v));this.setValue(v);if(this._iChangeEventTimer){q.sap.clearDelayedCall(this._iChangeEventTimer);}if(this._sOldValue!==this.getValue()){this.fireChange({value:this.getValue()});}this.$().focus();return this;};
S.prototype._disableButtons=function(v,m,b){if(b<v&&v<m){this._getDecrementButton().setEnabled(true);this._getIncrementButton().setEnabled(true);return this;}if(v==b){this._getDecrementButton().setEnabled(false);}if(v==m){this._getIncrementButton().setEnabled(false);}return this;};
S.prototype.onfocusout=function(){this._handleIncorrectValues();if(this.getValue()==""){if(i(this.getMin())&&this.getMin()>0){this.setValue(this.getMin());}else if(i(this.getMax())&&this.getMax()<0){this.setValue(this.getMax());}else{this.setValue(0);}}};
S.prototype._handleIncorrectValues=function(){var m=this._getIntOrFloat(this.getMin()),b=this._getIntOrFloat(this.getMax()),v=this._getIntOrFloat(this._getInput().getValue()),c=true,d=true;if(v>b||v<m){this.setValueState(sap.ui.core.ValueState.Error);}else{this.setValueState(sap.ui.core.ValueState.None);}if(v>=b){c=false;}if(v<=m){d=false;}this._getIncrementButton().setEnabled(c);this._getDecrementButton().setEnabled(d);};
S.prototype.setValue=function(v){var r;this._sOldValue=this.getValue();this._getInput().setValue(v);r=this.setProperty("value",v,true);return r;};
S.prototype.onsappageup=function(e){this._applyValue(this._calculateValue(this.getLargerStep(),true));this._handleIncorrectValues();};
S.prototype.onsappagedown=function(e){this._applyValue(this._calculateValue(this.getLargerStep(),false));this._handleIncorrectValues();};
S.prototype.onsappageupmodifiers=function(e){if(i(this.getMax())&&!(e.ctrlKey||e.metaKey||e.altKey)&&e.shiftKey){this._applyValue(this.getMax());}};
function i(n){return!isNaN(n)&&n!==null;}
S.prototype.onsappagedownmodifiers=function(e){if(i(this.getMin())&&!(e.ctrlKey||e.metaKey||e.altKey)&&e.shiftKey){this._applyValue(this.getMin());}};
S.prototype.onsapup=function(e){e.preventDefault();this._applyValue(this._calculateValue(1,true));this._handleIncorrectValues();};
S.prototype.onsapdown=function(e){e.preventDefault();this._applyValue(this._calculateValue(1,false));this._handleIncorrectValues();};
S.prototype.onkeydown=function(e){if(e.which===q.sap.KeyCodes.ARROW_UP&&!e.altKey&&e.shiftKey&&(e.ctrlKey||e.metaKey)){this._applyValue(this.getMax());}if(e.which===q.sap.KeyCodes.ARROW_DOWN&&!e.altKey&&e.shiftKey&&(e.ctrlKey||e.metaKey)){this._applyValue(this.getMin());}if(e.which===q.sap.KeyCodes.ARROW_UP&&!(e.ctrlKey||e.metaKey||e.altKey)&&e.shiftKey){e.preventDefault();this._applyValue(this._calculateValue(this.getLargerStep(),true));}if(e.which===q.sap.KeyCodes.ARROW_DOWN&&!(e.ctrlKey||e.metaKey||e.altKey)&&e.shiftKey){e.preventDefault();this._applyValue(this._calculateValue(this.getLargerStep(),false));}this._handleIncorrectValues();};
S.prototype.onsapescape=function(e){this.getAggregation("_input").onsapescape(e);};
S.prototype._attachLiveChange=function(){this._getInput().attachLiveChange(this._liveChange,this);};
S.prototype._attachChange=function(){this._getInput().attachChange(this._change,this);};
S.prototype._liveChange=function(){this._handleIncorrectValues();};
S.prototype._change=function(e){this._sOldValue=this.getValue();this.setProperty("value",this._getInput().getValue(),true);if(this._iChangeEventTimer){q.sap.clearDelayedCall(this._iChangeEventTimer);}this._iChangeEventTimer=q.sap.delayedCall(100,this,function(){if(this._sOldValue!==this.getValue()){this.fireChange({value:this.getValue()});}});};
S.prototype._applyValue=function(n){if(!this.getEditable()||!this.getEnabled()){return;}this.getAggregation("_input")._$input.val(n);};
S.prototype._calculateValue=function(s,b){var v,V,c,d=this.isInteger(this.getValue()),e=this.isInteger(this.getStep()),f=this._getIntOrFloat(this._getInput().getValue()),g=this._getIntOrFloat(this.getStep()),m=this._getIntOrFloat(this.getStep()*s),h=b?1:-1;v=f+g>=this.getMax();V=f-g<=this.getMin();c=f+h*m;if(b&&i(this.getMax())&&v){return this.getMax();}if(!b&&i(this.getMin())&&V){return this.getMin();}if(!e||!d){return c.toFixed(1);}else{return c;}return this.getValue();};
S.prototype.setValueState=function(v){var e=false,w=false;if(v==sap.ui.core.ValueState.Error){this._getInput().setValueState(sap.ui.core.ValueState.Error);e=true;}if(v==sap.ui.core.ValueState.Warning){this._getInput().setValueState(sap.ui.core.ValueState.Warning);w=true;}if(v==sap.ui.core.ValueState.None){this._getInput().setValueState(sap.ui.core.ValueState.None);e=false;w=false;}q.sap.delayedCall(0,this,function(){this.$().toggleClass("sapMStepInputError",e).toggleClass("sapMStepInputWarning",w);});return this;};
S.prototype.isInteger=function(v){return v%1===0;};
S.prototype.setEditable=function(e){var b=Array.prototype.slice.call(arguments);e=this.validateProperty('editable',e);if(!e){this._getInput().setTextAlign(sap.ui.core.TextAlign.Begin);this.removeAggregation("_decrementButton",false);this.removeAggregation("_incrementButton");}return S.prototype.setProperty.apply(this,["editable"].concat(b));};
S.prototype._writeAccessibilityState=function(p,v){var m,M,L,d,$=this.getDomRef("input-inner"),A=[],n={"min":"aria-valuemin","max":"aria-valuemax","value":"aria-valuenow"};if(!$){return;}if(p&&n[p]){A=[{aria:n[p],value:v}];}else if(!p){m=this.getMin();M=this.getMax();L=this.getAriaLabelledBy().join(" ");d=this.getAriaDescribedBy().join(" ");A=[{aria:"role",value:"spinbutton"},{aria:"aria-valuenow",value:this.getValue()}];if(typeof m=="number"){A.push({aria:"aria-valuemin",value:m});}if(typeof M=="number"){A.push({aria:"aria-valuemax",value:M});}if(L){A.push({aria:"aria-labelledby",value:L});}if(d){A.push({aria:"aria-describedby",value:d});}}A.forEach(function(o){$.setAttribute(o.aria,o.value);});};
return S;},true);
sap.ui.predefine('sap/m/StepInputRenderer',[],function(){"use strict";var S={};
S.render=function(r,c){var i=c._getIncrementButton(),d=c._getDecrementButton(),I=c._getInput(),w=c.getWidth(),e=c.getEnabled(),E=c.getEditable();r.write("<div");e&&E&&r.write(" tabindex='-1'");r.addStyle("width",w);r.writeStyles();r.writeControlData(c);r.writeAccessibilityState(c);r.addClass("sapMStepInput");r.addClass("sapMStepInput-CTX");!e&&r.addClass("sapMStepInputReadOnly");!E&&r.addClass("sapMStepInputDisabled");r.writeClasses();r.write(">");if(E){this.wrapButtons(r,d,["sapMStepInputBtnDecrease"]);}r.renderControl(I);if(E){this.wrapButtons(r,i,["sapMStepInputBtnIncrease"]);}r.write("</div>");};
S.wrapButtons=function(r,c,C){r.write("<div tabindex='-1'");r.addClass("sapMStepInputBtnWrapper");C.forEach(function(s){r.addClass(s);});r.writeClasses();r.write(">");r.renderControl(c);r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/m/Suggest',['jquery.sap.global','./Bar','./Button','./SuggestionsList','./SuggestionItem'],function(q,B,a,S,b){"use strict";
function c(i){var p=i,d,l,e,u=sap.ui.Device.system.phone,s=this;q.sap.require(u?"sap.m.Dialog":"sap.m.Popover");function o(E){var k=E.srcControl;var v;if(k instanceof b){v=k.getSuggestionText();d.close();window.setTimeout(function(){i.setValue(v);i.fireSearch({query:v,suggestionItem:k,refreshButtonPressed:false,clearButtonPressed:false});},0);}}function f(){var k,m,n,r,t;n=new(sap.ui.require('sap/m/SearchField'))({liveChange:function(E){var v=E.getParameter("newValue");i.setValue(v);i.fireLiveChange({newValue:v});i.fireSuggest({suggestValue:v});s.update();},search:function(E){if(!E.getParameter("clearButtonPressed")){k.close();}}});r=new B({contentLeft:n});t=new a({text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("MSGBOX_CANCEL"),press:function(){k._oCloseTrigger=true;k.close();}});k=new(sap.ui.require('sap/m/Dialog'))({stretch:true,customHeader:r,content:h(),beginButton:t,beforeOpen:function(){m=i.getValue();n.setValue(m);},beforeClose:function(E){if(E.getParameter("origin")){i.setValue(m);}else{i.setValue(n.getValue());}},afterClose:function(E){if(!E.getParameter("origin")){i.fireSearch({query:i.getValue(),refreshButtonPressed:false,clearButtonPressed:false});}}});k.addEventDelegate({ontap:o},i);return k;}function g(){var k=new(sap.ui.require('sap/m/Popover'))({showArrow:false,showHeader:false,horizontalScrolling:false,placement:sap.m.PlacementType.Vertical,offsetX:0,offsetY:0,initialFocus:p,bounce:false,afterOpen:function(){i.$("I").attr("aria-autocomplete","list").attr("aria-haspopup","true");},beforeClose:function(){i.$("I").attr("aria-haspopup","false").removeAttr("aria-activedecendant");},content:h()}).addStyleClass("sapMSltPicker").addStyleClass("sapMSltPicker-CTX");k.open=function(){return this.openBy(p);};function m(){var w=(i.$().outerWidth()/parseFloat(sap.m.BaseFontSize))+"rem";k.getDomRef().style.minWidth=w;}k.addEventDelegate({onAfterRendering:m,ontap:o},i);return k;}function h(){if(!l){l=new S({parentInput:p});}return l;}function j(){if(d===undefined){d=u?f():g();}return d;}this.destroy=function(){if(d){d.close();d.destroy();d=null;}if(l){l.destroy();l=null;}};this.close=function(){if(!u&&this.isOpen()){d.close();}};this.open=function(){if(!this.isOpen()){this.setSelected(-1);j().open();}};this.update=function(){var l=h();window.clearTimeout(e);if(this.isOpen()){e=window.setTimeout(l.update.bind(l),50);}};this.isOpen=function(){return!!d&&d.isOpen();};this.getSelected=function(){return h().getSelectedItemIndex();};this.setSelected=function(k,r){return h().selectByIndex(k,r);};}
return c;},true);
sap.ui.predefine('sap/m/SuggestionItem',['jquery.sap.global','./library','sap/ui/core/Item','sap/ui/core/IconPool'],function(q,l,I,a){"use strict";
var S=I.extend("sap.m.SuggestionItem",{metadata:{library:"sap.m",properties:{icon:{type:"string",group:"Appearance",defaultValue:""},description:{type:"string",group:"Data",defaultValue:""}}}});
a.insertFontFaceStyle();
function r(R,t,s){var i;if(t){i=t.toUpperCase().indexOf(s.toUpperCase());if(i>-1){R.writeEscaped(t.slice(0,i));R.write("<b>");R.writeEscaped(t.slice(i,i+s.length));R.write("</b>");t=t.substring(i+s.length);}R.writeEscaped(t);}}
S.prototype.render=function(R,i,s,b){var c=R;var t=i.getText();var d=i.getIcon();var e="";var f=i.getDescription();var p=i.getParent();var g=p&&p.getSuggestionItems&&p.getSuggestionItems()||[];var h=g.indexOf(i);s=s||"";c.write("<li");c.writeElementData(i);c.addClass("sapMSuLI");c.addClass("sapMSelectListItem");c.addClass("sapMSelectListItemBase");c.addClass("sapMSelectListItemBaseHoverable");c.writeAttribute("role","option");c.writeAttribute("aria-posinset",h+1);c.writeAttribute("aria-setsize",g.length);if(b){c.addClass("sapMSelectListItemBaseSelected");c.writeAttribute("aria-selected","true");if(p){p.$("I").attr("aria-activedecendant",i.getId());}}c.writeClasses();c.write(">");if(d){c.writeIcon(d,"sapMSuggestionItemIcon",{});}if(t){r(c,t,s);e=" ";}if(f){c.write(e+"<i>");r(c,f,s);c.write("</i>");}c.write("</li>");};
S.prototype.getSuggestionText=function(){return this.getText();};
S.prototype.invalidate=function(){return undefined;};
return S;},true);
sap.ui.predefine('sap/m/SuggestionsList',['./library'],function(l){"use strict";
var S=sap.ui.core.Control.extend("sap.m.SuggestionsList",{
metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"}},associations:{parentInput:{type:"sap.ui.core.Control",multiple:false,singularName:"parentInput"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}},
renderer:{render:function(r,L){r.write("<ul");r.writeControlData(L);r.addClass("sapMSuL");r.addClass("sapMSelectList");r.writeClasses();r.writeAccessibilityState({role:"listbox","multiselectable":"false"});r.addStyle("width",L.getWidth());r.addStyle("max-width",L.getMaxWidth());r.writeStyles();r.write(">");this.renderItems(r,L);r.write("</ul>");},renderItems:function(r,L){var s;var a=L.getSelectedItemIndex();try{s=sap.ui.getCore().byId(L.getParentInput()).getValue();}catch(e){s="";}L.getItems().forEach(function(i,b){i.render(r,i,s,b===a);});}}
});
S.prototype.init=function(){this._iSelectedItem=-1;};
S.prototype.onBeforeRendering=function(){this.$().off();};
S.prototype.onAfterRendering=function(){this.$().on("mousedown",function(e){e.preventDefault();});};
S.prototype.getItems=function(){try{return sap.ui.getCore().byId(this.getParentInput()).getSuggestionItems();}catch(e){return[];}};
S.prototype.update=function(){var r;var d=this.getDomRef();if(d){r=sap.ui.getCore().createRenderManager();this.getRenderer().renderItems(r,this);r.flush(d);r.destroy();}return this;};
S.prototype.selectByIndex=function(i,r){var a=this.getItems();var b;var c;var d;var p=sap.ui.getCore().byId(this.getParentInput());var e="aria-activedecendant";if(isNaN(parseInt(i,10))){i=-1;r=false;}if((!a.length)||(r&&i===0)||(!r&&i<0)){b=-1;}else{if(r){if(this._iSelectedItem<0){b=(i<0?a.length:-1)+i;}else{b=this._iSelectedItem+i;}}else{b=i;}b=Math.min(Math.max(b,0),a.length-1);}this._iSelectedItem=b;if(a.length){this.$().children("li").removeClass("sapMSelectListItemBaseSelected").attr("aria-selected","false").eq(b).addClass("sapMSelectListItemBaseSelected").attr("aria-selected","true");}if(p){if(b>=0){c=p.getSuggestionItems()[b];d=c&&c.getId();}if(d){p.$("I").attr(e,d);}else{p.$("I").removeAttr(e);}}return this._iSelectedItem;};
S.prototype.getSelectedItemIndex=function(){return this._iSelectedItem;};
return S;},true);
sap.ui.predefine('sap/m/Support',['jquery.sap.global'],function(q){"use strict";var S=(function($,d){var a,s,b,l,t=0,m=3000,h=2,c=3,r=1,D={},e={btnStart:"startE2ETrace",selLevel:"logLevelE2ETrace",taContent:"outputE2ETrace",infoText:"Ent-to-End trace is running in the background."+" Navigate to the URL that you would like to trace."+" The result of the trace will be shown in dialog after the trace is terminated.",infoDuration:5000},f={dvLoadedLibs:"LoadedLibs",dvLoadedModules:"LoadedModules"},w;function g(i,v,A,B,C){i.push("<tr class='sapUiSelectable'><td class='sapUiSupportTechInfoBorder sapUiSelectable'><label class='sapUiSupportLabel sapUiSelectable'>",q.sap.encodeHTML(B),"</label><br>");var E=C;if($.isFunction(C)){E=C(i)||"";}i.push($.sap.encodeHTML(E));i.push("</td></tr>");}function j(A,B,C,E,F){g(A,B,C,E,function(A){A.push("<table class='sapMSupportTable' border='0' cellspacing='5' cellpadding='5' width='100%'><tbody>");$.each(F,function(i,v){var G="";if(v!==undefined&&v!==null){if(typeof(v)=="string"||typeof(v)=="boolean"||($.isArray(v)&&v.length==1)){G=v;}else if(($.isArray(v)||$.isPlainObject(v))&&window.JSON){G=window.JSON.stringify(v);}}g(A,false,false,i,""+G);});A.push("</tbody></table>");});}function k(F){D={version:F.commonInformation.version,build:F.commonInformation.buildTime,change:F.commonInformation.lastChange,useragent:F.commonInformation.userAgent,docmode:F.commonInformation.documentMode,debug:F.commonInformation.debugMode,bootconfig:F.configurationBootstrap,config:F.configurationComputed,loadedlibs:F.loadedLibraries,modules:F.loadedModules,uriparams:F.URLParameters,appurl:F.commonInformation.applicationHREF};var A=["<table class='sapUiSelectable' border='0' cellspacing='5' cellpadding='5' width='100%'><tbody class='sapUiSelectable'>"];g(A,true,true,"SAPUI5 Version",function(i){i.push(D.version," (built at ",D.build,", last change ",D.change,")");});g(A,true,true,"User Agent",function(i){i.push(D.useragent,(D.docmode?", Document Mode '"+D.docmode+"'":""));});g(A,true,true,"Debug Sources",function(i){i.push((D.debug?"ON":"OFF"));});g(A,true,true,"Application",D.appurl);j(A,true,true,"Configuration (bootstrap)",D.bootconfig);j(A,true,true,"Configuration (computed)",D.config);j(A,true,true,"URI Parameters",D.uriparams);g(A,true,true,"End-to-End Trace",function(i){i.push("<label class='sapUiSupportLabel'>Trace Level:</label>","<select id='"+n(e.selLevel)+"' class='sapUiSupportTxtFld' >","<option value='low'>LOW</option>","<option value='medium' selected>MEDIUM</option>","<option value='high'>HIGH</option>","</select>");i.push("<button id='"+n(e.btnStart)+"' class='sapUiSupportBtn'>Start</button>");i.push("<div class='sapUiSupportDiv'>");i.push("<label class='sapUiSupportLabel'>XML Output:</label>");i.push("<textarea id='"+n(e.taContent)+"' class='sapUiSupportTxtArea sapUiSelectable' readonly ></textarea>");i.push("</div>");});g(A,true,true,"Loaded Libraries",function(B){B.push("<ul class='sapUiSelectable'>");$.each(D.loadedlibs,function(i,v){if(v&&(typeof(v)==="string"||typeof(v)==="boolean")){B.push("<li class='sapUiSelectable'>",i+" "+v,"</li>");}});B.push("</ul>");});g(A,true,true,"Loaded Modules",function(i){i.push("<div class='sapUiSupportDiv sapUiSelectable' id='"+n(f.dvLoadedModules)+"'></div>");});A.push("</tbody></table>");return new sap.ui.core.HTML({content:A.join("").replace(/\{/g,"&#123;").replace(/\}/g,"&#125;")});}function n(i){return a.getId()+"-"+i;}function o(v,A){var B="Modules";var C=0,E=[];C=A.length;$.each(A.sort(),function(i,G){E.push(new sap.m.Label({text:" - "+G}).addStyleClass("sapUiSupportPnlLbl"));});var F=new sap.m.Panel({expandable:true,expanded:false,headerToolbar:new sap.m.Toolbar({design:sap.m.ToolbarDesign.Transparent,content:[new sap.m.Label({text:B+" ("+C+")",design:sap.m.LabelDesign.Bold})]}),content:E});F.placeAt(n(v),"only");}function p(){if(a.traceXml){a.$(e.taContent).text(a.traceXml);}if(a.e2eLogLevel){a.$(e.selLevel).val(a.e2eLogLevel);}o(f.dvLoadedModules,D.modules);a.$(e.btnStart).one("tap",function(){a.e2eLogLevel=a.$(e.selLevel).val();a.$(e.btnStart).addClass("sapUiSupportRunningTrace").text("Running...");a.traceXml="";a.$(e.taContent).text("");sap.ui.core.support.trace.E2eTraceLib.start(a.e2eLogLevel,function(i){a.traceXml=i;});sap.m.MessageToast.show(e.infoText,{duration:e.infoDuration});a.close();});}function u(){if(a){return a;}$.sap.require("sap.m.Dialog");$.sap.require("sap.m.Button");$.sap.require("sap.ui.core.HTML");$.sap.require("sap.m.MessageToast");$.sap.require("sap.ui.core.support.trace.E2eTraceLib");a=new sap.m.Dialog({title:"Technical Information",horizontalScrolling:true,verticalScrolling:true,stretch:q.device.is.phone,buttons:[new sap.m.Button({text:"Close",press:function(){a.close();}})],afterOpen:function(){S.off();},afterClose:function(){S.on();}}).addStyleClass("sapMSupport");return a;}function x(E){if(E.touches){var i=E.touches.length;if(sap.ui.Device.browser.mobile&&(sap.ui.Device.browser.name===sap.ui.Device.browser.BROWSER.INTERNET_EXPLORER||sap.ui.Device.browser.name===sap.ui.Device.browser.BROWSER.EDGE)){w=i;}if(i>c){d.removeEventListener('touchend',y);return;}switch(i){case h:s=Date.now();d.addEventListener('touchend',y);break;case c:if(s){t=Date.now()-s;l=E.touches[i-1].identifier;}break;}}}function y(E){var i=sap.ui.Device.browser.mobile&&(sap.ui.Device.browser.name===sap.ui.Device.browser.BROWSER.INTERNET_EXPLORER||sap.ui.Device.browser.name===sap.ui.Device.browser.BROWSER.EDGE)&&w==c;d.removeEventListener('touchend',y);if(t>m&&(E.touches.length===h||i)&&E.changedTouches.length===r&&E.changedTouches[0].identifier===l){t=0;s=0;z();}}function z(){sap.ui.require(['sap/ui/core/support/ToolsAPI'],function(T){var i=u();i.removeAllAggregation("content");i.addAggregation("content",k(T.getFrameworkInformation()));a.open();p();});}return({on:function(){if(!b&&"ontouchstart"in d){b=true;d.addEventListener("touchstart",x);}return this;},off:function(){if(b){b=false;d.removeEventListener("touchstart",x);}return this;},open:function(){z();},isEventRegistered:function(){return b;}}).on();}(q,document));return S;},true);
sap.ui.predefine('sap/m/Switch',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/theming/Parameters'],function(q,l,C,E,I,P){"use strict";
var S=C.extend("sap.m.Switch",{metadata:{library:"sap.m",properties:{state:{type:"boolean",group:"Misc",defaultValue:false},customTextOn:{type:"string",group:"Misc",defaultValue:""},customTextOff:{type:"string",group:"Misc",defaultValue:""},enabled:{type:"boolean",group:"Data",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:""},type:{type:"sap.m.SwitchType",group:"Appearance",defaultValue:sap.m.SwitchType.Default}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{state:{type:"boolean"}}}}}});
I.insertFontFaceStyle();E.apply(S.prototype,[true]);
S.prototype._slide=function(p){if(p>S._OFFPOSITION){p=S._OFFPOSITION;}else if(p<S._ONPOSITION){p=S._ONPOSITION;}if(this._iCurrentPosition===p){return;}this._iCurrentPosition=p;this.getDomRef("inner").style[sap.ui.getCore().getConfiguration().getRTL()?"right":"left"]=p+"px";this._setTempState(Math.abs(p)<S._SWAPPOINT);};
S.prototype._setTempState=function(b){if(this._bTempState===b){return;}this._bTempState=b;this.getDomRef("handle").setAttribute("data-sap-ui-swt",b?this._sOn:this._sOff);};
S.prototype._setDomState=function(s){var a=this.getRenderer().CSS_CLASS,b=s?this._sOn:this._sOff,d=this.getDomRef();if(!d){return;}var $=this.$("switch"),o=this.getDomRef("inner"),h=this.getDomRef("handle"),c=null;if(this.getName()){c=this.getDomRef("input");c.setAttribute("checked",s);c.setAttribute("value",b);}h.setAttribute("data-sap-ui-swt",b);if(s){$.removeClass(a+"Off").addClass(a+"On");d.setAttribute("aria-checked","true");}else{$.removeClass(a+"On").addClass(a+"Off");d.setAttribute("aria-checked","false");}if(sap.ui.getCore().getConfiguration().getAnimation()){$.addClass(a+"Trans");}o.style.cssText="";};
S.prototype.getInvisibleElementId=function(){return this.getId()+"-invisible";};
S.prototype.getInvisibleElementText=function(){var t="";switch(this.getType()){case sap.m.SwitchType.Default:t=this.getCustomTextOn()||"SWITCH_ON";break;case sap.m.SwitchType.AcceptReject:t="SWITCH_ARIA_ACCEPT";break;}return t;};
S._TRANSITIONTIME=Number(P.get("sapMSwitch-TRANSITIONTIME"))||0;S._ONPOSITION=Number(P.get("sapMSwitch-ONPOSITION"));S._OFFPOSITION=Number(P.get("sapMSwitch-OFFPOSITION"));S._SWAPPOINT=Math.abs((S._ONPOSITION-S._OFFPOSITION)/2);S._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");
S.prototype.onBeforeRendering=function(){var a=S;this._sOn=this.getCustomTextOn()||a._oRb.getText("SWITCH_ON");this._sOff=this.getCustomTextOff()||a._oRb.getText("SWITCH_OFF");};
S.prototype.ontouchstart=function(e){var t=e.targetTouches[0],a=this.getRenderer().CSS_CLASS,s=this.$("inner");e.setMarked();if(sap.m.touch.countContained(e.touches,this.getId())>1||!this.getEnabled()||e.button){return;}this._iActiveTouchId=t.identifier;this._bTempState=this.getState();this._iStartPressPosX=t.pageX;this._iPosition=s.position().left;this._bDragging=false;q.sap.delayedCall(0,this,"focus");this.$("switch").addClass(a+"Pressed").removeClass(a+"Trans");};
S.prototype.ontouchmove=function(e){e.setMarked();e.preventDefault();var t,p,T=sap.m.touch;if(!this.getEnabled()||e.button){return;}t=T.find(e.changedTouches,this._iActiveTouchId);if(!t||t.pageX===this._iStartPressPosX){return;}this._bDragging=true;p=((this._iStartPressPosX-t.pageX)*-1)+this._iPosition;if(sap.ui.getCore().getConfiguration().getRTL()){p=-p;}this._slide(p);};
S.prototype.ontouchend=function(e){e.setMarked();var t,T=sap.m.touch,a=q.sap.assert;if(!this.getEnabled()||e.button){return;}a(this._iActiveTouchId!==undefined,"expect to already be touching");t=T.find(e.changedTouches,this._iActiveTouchId);if(t){a(!T.find(e.touches,this._iActiveTouchId),"touchend still active");this.$("switch").removeClass(this.getRenderer().CSS_CLASS+"Pressed");this._setDomState(this._bDragging?this._bTempState:!this.getState());q.sap.delayedCall(S._TRANSITIONTIME,this,function(){var s=this.getState();this.setState(this._bDragging?this._bTempState:!s);if(s!==this.getState()){this.fireChange({state:this.getState()});}});}};
S.prototype.ontouchcancel=S.prototype.ontouchend;
S.prototype.onsapselect=function(e){var s;if(this.getEnabled()){e.setMarked();e.preventDefault();this.setState(!this.getState());s=this.getState();q.sap.delayedCall(S._TRANSITIONTIME,this,function(){this.fireChange({state:s});});}};
S.prototype.setState=function(s){this.setProperty("state",s,true);this._setDomState(this.getState());return this;};
S.prototype.getAccessibilityInfo=function(){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");var d="";if(this.getState()){d=b.getText("ACC_CTR_STATE_CHECKED")+" "+b.getText(this.getInvisibleElementText());}return{role:"checkbox",type:b.getText("ACC_CTR_TYPE_CHECKBOX"),description:d.trim(),focusable:this.getEnabled(),enabled:this.getEnabled()};};
return S;},true);
sap.ui.predefine('sap/m/SwitchRenderer',[],function(){"use strict";var S={};S.CSS_CLASS="sapMSwt";
S.render=function(r,s){var b=s.getState(),a=b?s._sOn:s._sOff,t=s.getTooltip_AsString(),e=s.getEnabled(),n=s.getName(),A=sap.ui.getCore().getConfiguration().getAccessibility(),R=sap.ui.getCore().getLibraryResourceBundle("sap.m"),C=S.CSS_CLASS;r.write("<div");r.addClass(C+"Cont");if(!e){r.addClass(C+"ContDisabled");}r.writeClasses();r.writeStyles();r.writeControlData(s);if(e){r.writeAttribute("tabindex","0");}if(t){r.writeAttributeEscaped("title",t);}if(A){this.writeAccessibilityState(r,s);}r.write("><div");r.writeAttribute("id",s.getId()+"-switch");r.writeAttribute("aria-hidden","true");r.addClass(C);r.addClass(b?C+"On":C+"Off");r.addClass(C+s.getType());if(sap.ui.Device.system.desktop&&e){r.addClass(C+"Hoverable");}if(!e){r.addClass(C+"Disabled");}r.writeClasses();r.write("><div");r.addClass(C+"Inner");r.writeAttribute("id",s.getId()+"-inner");r.writeClasses();r.write(">");this.renderText(r,s);this.renderHandle(r,s,a);r.write("</div>");r.write("</div>");if(n){this.renderCheckbox(r,s,a);}if(A){this.renderInvisibleElement(r,s,{id:s.getInvisibleElementId(),text:R.getText(s.getInvisibleElementText())});}r.write("</div>");};
S.renderText=function(r,s){var C=S.CSS_CLASS,d=s.getType()===sap.m.SwitchType.Default;r.write("<div");r.addClass(C+"Text");r.addClass(C+"TextOn");r.writeAttribute("id",s.getId()+"-texton");r.writeClasses();r.write(">");r.write("<span");r.addClass(C+"Label");r.addClass(C+"LabelOn");r.writeClasses();r.write(">");if(d){r.writeEscaped(s._sOn);}r.write("</span>");r.write("</div>");r.write("<div");r.addClass(C+"Text");r.addClass(C+"TextOff");r.writeAttribute("id",s.getId()+"-textoff");r.writeClasses();r.write(">");r.write("<span");r.addClass(C+"Label");r.addClass(C+"LabelOff");r.writeClasses();r.write(">");if(d){r.writeEscaped(s._sOff);}r.write("</span>");r.write("</div>");};
S.renderHandle=function(r,s,a){var C=S.CSS_CLASS;r.write("<div");r.writeAttribute("id",s.getId()+"-handle");r.writeAttributeEscaped("data-sap-ui-swt",a);r.addClass(C+"Handle");r.writeClasses();r.write("></div>");};
S.renderCheckbox=function(r,s,a){r.write('<input type="checkbox"');r.writeAttribute("id",s.getId()+"-input");r.writeAttributeEscaped("name",s.getName());r.writeAttributeEscaped("value",a);if(s.getState()){r.writeAttribute("checked","checked");}if(!s.getEnabled()){r.writeAttribute("disabled","disabled");}r.write(">");};
S.writeAccessibilityState=function(r,s){var a=s.getAriaLabelledBy(),A;if(a){a={value:s.getInvisibleElementId(),append:true};}A={role:"checkbox",checked:s.getState(),labelledby:a};r.writeAccessibilityState(s,A);};
S.renderInvisibleElement=function(r,s,o){r.write("<span");r.writeAttribute("id",o.id);r.writeAttribute("aria-hidden","true");r.addClass("sapUiInvisibleText");r.writeClasses();r.write(">");r.writeEscaped(o.text);r.write("</span>");};
return S;},true);
sap.ui.predefine('sap/m/TabContainer',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool'],function(q,l,C,I){"use strict";
var T=C.extend("sap.m.TabContainer",{
metadata:{library:"sap.m",properties:{showAddNewButton:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{items:{type:"sap.m.TabContainerItem",multiple:true,singularName:"item",bindable:"bindable"},_addNewButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_tabStrip:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:"sap.m.TabContainerItem",multiple:false}},events:{itemClose:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabContainerItem"}}},itemSelect:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabContainerItem"}}},addNewButtonPress:{}}},
constructor:function(i,s){var S=[];if(!s&&typeof i==='object'){s=i;}if(s&&Array.isArray(s['items'])){S=s['items'];delete s['items'];}sap.ui.base.ManagedObject.prototype.constructor.apply(this,arguments);var c=new sap.m.TabStrip(this.getId()+"--tabstrip",{hasSelect:true,itemSelect:function(e){var o=e.getParameter("item"),a=this._fromTabStripItem(o);this.setSelectedItem(a,e);}.bind(this),itemClose:function(e){var o=e.getParameter("item"),r=this._fromTabStripItem(o);e.preventDefault();if(this.fireItemClose({item:r})){this.removeItem(r);}}.bind(this)});this.setAggregation("_tabStrip",c,true);if(s&&s['showAddNewButton']){this.setShowAddNewButton(true);}S.forEach(function(o){this.addItem(o);},this);}
});
var t={"name":"text","modified":"modified"};
T.prototype.onBeforeRendering=function(){if(this.getSelectedItem()){return;}this._setDefaultTab();};
T.prototype._getAddNewTabButton=function(){var c=this.getAggregation("_addNewButton");var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(!c){c=new sap.m.Button({type:sap.m.ButtonType.Transparent,tooltip:r.getText("TABCONTAINER_ADD_NEW_TAB"),icon:I.getIconURI("add"),press:function(){this.getParent().getParent().fireAddNewButtonPress();}});c.addStyleClass("sapMTSAddNewTabBtn");this.setAggregation("_addNewButton",c,true);}return c;};
T.prototype._getTabStrip=function(){return this.getAggregation("_tabStrip");};
T.prototype._fromTabStripItem=function(i){var a=this.getItems()||[],b=a.length,c=0;for(;c<b;c++){if(a[c].getId()===i.getKey()){return a[c];}}return null;};
T.prototype._toTabStripItem=function(i){var a=0,k=i,o,b,c=this._getTabStrip();if(!c){return null;}o=c.getItems();b=o.length;if(typeof i==="object"){k=i.getId();}for(;a<b;a++){if(o[a].getKey()===k){return o[a];}}return null;};
T.prototype._getSelectedItemContent=function(){var o=this._getTabStrip(),s=this.getSelectedItem(),S=sap.ui.getCore().byId(s),a=this._toTabStripItem(S);if(o){o.setSelectedItem(a);}return S?S.getContent():null;};
T.prototype._moveToNextItem=function(s){var i=this.getItems().length,c=this._getTabStrip()._oItemNavigation.getFocusedIndex(),n=i===c?--c:c,N=this.getItems()[n],f=function(){this._getTabStrip()._oItemNavigation.focusItem(n);};if(s){this.setSelectedItem(N);this.fireItemSelect({item:N});}q.sap.delayedCall(0,this,f);};
T.prototype.removeItem=function(i){var b;if(!i){return null;}b=i.getId()===this.getSelectedItem();i=this.removeAggregation("items",i);this._getTabStrip().removeItem(this._toTabStripItem(i));this._moveToNextItem(b);return i;};
T.prototype.addAggregation=function(a,o,s){var b,p;if(a==='items'){o.attachItemPropertyChanged(function(e){p=e['mParameters'].propertyKey;if(t[p]){p=t[p];b=this._toTabStripItem(e.getSource());b&&b.setProperty(p,e['mParameters'].propertyValue,false);}}.bind(this));}return C.prototype.addAggregation.call(this,a,o,s);};
T.prototype.addItem=function(i){this.addAggregation("items",i,false);this._getTabStrip().addItem(new sap.m.TabStripItem({key:i.getId(),text:i.getName(),modified:i.getModified()}));return i;};
T.prototype.destroyItems=function(){this._getTabStrip().destroyItems();this.setAssociation("selectedItem",null);return this.destroyAggregation("items");};
T.prototype.insertItem=function(i,a){this._getTabStrip().insertItem(new sap.m.TabStripItem({key:i.getId(),text:i.getName(),modified:i.getModified()}),a);return this.insertAggregation("items",i,a);};
T.prototype.removeAllItems=function(){this._getTabStrip().removeAllItems();this.setSelectedItem(null);return this.removeAllAggregation("items");};
T.prototype.setAddButton=function(b){return this._getTabStrip().setAddButton(b);};
T.prototype.getAddButton=function(){return this._getTabStrip().getAddButton();};
T.prototype.setShowAddNewButton=function(s){this.setProperty("showAddNewButton",s,true);var o=this._getTabStrip();if(o){o.setAddButton(s?this._getAddNewTabButton():null);}return this;};
T.prototype.setSelectedItem=function(s,e){if(this.fireItemSelect({item:s})){var o=this._getTabStrip();if(s&&o){o.setSelectedItem(this._toTabStripItem(s));this._rerenderContent(s.getContent());}T.prototype.setAssociation.call(this,"selectedItem",s,true);return this;}if(e){e.preventDefault();}return this;};
T.prototype._rerenderContent=function(c){var $=this.$("content"),r;if(!c||($.length<=0)){return;}r=sap.ui.getCore().createRenderManager();for(var i=0;i<c.length;i++){r.renderControl(c[i]);}r.flush($[0]);r.destroy();};
T.prototype._setDefaultTab=function(){var f=this.getItems()[0]||null;this.setSelectedItem(f);return f;};
return T;},true);
sap.ui.predefine('sap/m/TabContainerItem',['sap/ui/core/Element','sap/ui/core/Control'],function(E,C){"use strict";
var T=E.extend("sap.m.TabContainerItem",{metadata:{library:"sap.ui.core",properties:{name:{type:"string",group:"Misc",defaultValue:""},key:{type:"string",group:"Data",defaultValue:null},modified:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,defaultValue:null}},events:{itemPropertyChanged:{parameters:{itemChanged:{type:"sap.m.TabContainerItem"},propertyKey:{type:"string"},propertyValue:{type:"mixed"}}}}}});
T.prototype.setProperty=function(n,v,s){if(n==="modified"){s=true;}this.fireItemPropertyChanged({itemChanged:this,propertyKey:n,propertyValue:v});return E.prototype.setProperty.call(this,n,v,s);};
return T;});
sap.ui.predefine('sap/m/TabContainerRenderer',['jquery.sap.global'],function(q){"use strict";var T={};
T.render=function(r,c){var t=c._getTabStrip(),s=c._getSelectedItemContent();r.write("<div ");r.writeControlData(c);r.addClass("sapMTabContainer");r.addClass("sapContrastPlus");r.writeClasses();r.write(">");if(t){r.renderControl(t);}r.write("<div id='"+c.getId()+"-containerContent' ");r.addClass("sapMTabContainerContent");r.writeClasses();r.write(">");r.write("<div id='"+this.getContentDomId(c)+"' class='sapMTabContainerInnerContent'");r.writeAccessibilityState(c,this.getTabContentAccAttributes(c));r.write(">");if(s){s.forEach(function(C){r.renderControl(C);});}r.write("</div>");r.write("</div>");r.write("</div>");};
T.getTabContentAccAttributes=function(c){var s=c.getSelectedItem(),t,a={role:"tabpanel"};if(s){t=c._toTabStripItem(s);if(t){a["aria-labelledby"]=t.getId();}}return a;};
T.getContentDomId=function(c){return c.getId()+"-content";};
return T;},true);
sap.ui.predefine('sap/m/TabStrip',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/delegate/ItemNavigation','sap/ui/base/ManagedObject','sap/ui/core/delegate/ScrollEnablement','sap/ui/core/InvisibleText','./AccButton','./TabStripItem','./TabStripSelect','sap/ui/Device'],function(q,C,I,a,M,S,b,A,T,c,D){"use strict";
var d=C.extend("sap.m.TabStrip",{
metadata:{library:"sap.m",properties:{hasSelect:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{items:{type:"sap.m.TabStripItem",multiple:true,singularName:"item"},addButton:{type:"sap.m.Button",multiple:false,singularName:"addButton"},_select:{type:'sap.m.TabStripSelect',multiple:false,visibility:"hidden"},_rightArrowButton:{type:'sap.m.AccButton',multiple:false,visibility:"hidden"},_leftArrowButton:{type:'sap.m.AccButton',multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:'sap.m.TabStripItem',group:"Misc"}},events:{itemClose:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabStripItem"}}},itemPress:{parameters:{item:{type:"sap.m.TabStripItem"}}},itemSelect:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabContainerItem"}}}}},
constructor:function(i,s){var h=false;if(!s&&typeof i==='object'){s=i;}if(s){h=s['hasSelect'];delete s['hasSelect'];}sap.ui.base.ManagedObject.prototype.constructor.apply(this,arguments);this.setProperty('hasSelect',h,true);}
});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");d.ICON_BUTTONS={LeftArrowButton:"slim-arrow-left",RightArrowButton:"slim-arrow-right",DownArrowButton:"slim-arrow-down",AddButton:"add"};d.SELECT_ITEMS_ID_SUFFIX='-SelectItem';d.SCROLL_SIZE=320;d.MIN_DRAG_OFFSET=sap.ui.Device.support.touch?15:5;d.SCROLL_ANIMATION_DURATION=sap.ui.getCore().getConfiguration().getAnimation()?500:0;d.ARIA_STATIC_TEXTS={closable:new b({text:r.getText("TABSTRIP_ITEM_CLOSABLE")}).toStatic(),modified:new b({text:r.getText("TABSTRIP_ITEM_MODIFIED")}).toStatic(),notModified:new b({text:r.getText("TABSTRIP_ITEM_NOT_MODIFIED")}).toStatic()};
d.prototype.init=function(){this._bDoScroll=!sap.ui.Device.system.phone;this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._iCurrentScrollLeft=0;this._iMaxOffsetLeft=null;this._scrollable=null;this._oTouchStartX=null;if(!sap.ui.Device.system.phone){this._oScroller=new S(this,this.getId()+"-tabs",{horizontal:true,vertical:false,nonTouchScrolling:true});}};
d.prototype.exit=function(){this._bRtl=null;this._iCurrentScrollLeft=null;this._iMaxOffsetLeft=null;this._scrollable=null;this._oTouchStartX=null;if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._removeItemNavigation();};
d.prototype.onBeforeRendering=function(){if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
d.prototype.onAfterRendering=function(){if(this._oScroller){this._oScroller.setIconTabBar(this,q.proxy(this._handleOverflowButtons,this),null);}this._addItemNavigation();if(!sap.ui.Device.system.phone){this._adjustScrolling();this._sResizeListenerId=sap.ui.core.ResizeHandler.register(this.getDomRef(),q.proxy(this._adjustScrolling,this));}};
d.prototype.getFocusDomRef=function(){var t=sap.ui.getCore().byId(this.getSelectedItem());if(!t){return null;}return t.getDomRef();};
d.prototype.applyFocusInfo=function(f){if(f.focusDomRef){q(f.focusDomRef).focus();}};
d.prototype._addItemNavigation=function(){var h=this.getDomRef("tabsContainer"),i=this.getItems(),t=[];i.forEach(function(o){var e=o.getDomRef();q(e).attr("tabindex","-1");t.push(e);});if(!this._oItemNavigation){this._oItemNavigation=new a();}this._oItemNavigation.setRootDomRef(h);this._oItemNavigation.setItemDomRefs(t);this._oItemNavigation.setCycling(false);this._oItemNavigation.setPageSize(5);this.addDelegate(this._oItemNavigation);};
d.prototype._checkScrolling=function(){var t=this.getDomRef("tabs"),s=t&&(t.scrollWidth>this.getDomRef("tabsContainer").clientWidth);this.$().toggleClass("sapMTSScrollable",s);return s;};
d.prototype._handleOverflowButtons=function(){var t=this.getDomRef("tabs"),o=this.getDomRef("tabsContainer"),s,e,f,g=false,h=false,i=this._checkScrolling();if(i&&!this.getAggregation("_rightArrowButton")&&!this.getAggregation("_leftArrowButton")){this._getLeftArrowButton();this._getRightArrowButton();var R=sap.ui.getCore().createRenderManager();this.getRenderer().renderRightOverflowButtons(R,this,true);this.getRenderer().renderLeftOverflowButtons(R,this,true);R.destroy();}if(i&&t&&o){if(this._bRtl&&D.browser.firefox){s=-o.scrollLeft;}else{s=o.scrollLeft;}e=t.scrollWidth;f=o.clientWidth;if(Math.abs(e-f)===1){e=f;}if(s>0){if(this._bRtl&&D.browser.webkit){h=true;}else{g=true;}}if((e>f)&&(s+f<e)){if(this._bRtl&&D.browser.webkit){g=true;}else{h=true;}}this.$().toggleClass("sapMTSScrollBack",g).toggleClass("sapMTSScrollForward",h);}else{this.$().toggleClass("sapMTSScrollBack",false).toggleClass("sapMTSScrollForward",false);}};
d.prototype._adjustScrolling=function(){this._iMaxOffsetLeft=Math.abs(this.$("tabsContainer").width()-this.$("tabs").width());this._handleOverflowButtons();};
d.prototype._getLeftArrowButton=function(){return this._getArrowButton("_leftArrowButton",r.getText("TABSTRIP_SCROLL_BACK"),d.ICON_BUTTONS.LeftArrowButton,-d.SCROLL_SIZE);};
d.prototype._getRightArrowButton=function(){return this._getArrowButton("_rightArrowButton",r.getText("TABSTRIP_SCROLL_FORWARD"),d.ICON_BUTTONS.RightArrowButton,d.SCROLL_SIZE);};
d.prototype._getArrowButton=function(B,t,i,e){var o=this.getAggregation(B),f=this;if(!o){o=new A({type:sap.m.ButtonType.Transparent,icon:I.getIconURI(i),tooltip:t,tabIndex:"-1",ariaHidden:"true",press:function(E){f._scroll(e,d.SCROLL_ANIMATION_DURATION);}});this.setAggregation(B,o,true);}return o;};
d.prototype._removeItemNavigation=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
d.prototype._scroll=function(i,e){var s=this.getDomRef("tabsContainer").scrollLeft,f=D.browser.internet_explorer||D.browser.edge,g;if(this._bRtl&&!f){g=s-i;if(D.browser.firefox){if(g<-this._iMaxOffsetLeft){g=-this._iMaxOffsetLeft;}if(g>0){g=0;}}}else{g=s+i;if(g<0){g=0;}if(g>this._iMaxOffsetLeft){g=this._iMaxOffsetLeft;}}this._oScroller.scrollTo(g,0,e);this._iCurrentScrollLeft=g;};
d.prototype._scrollIntoView=function(i,e){var $=this.$("tabs"),f=i.$(),t=$.innerWidth()-$.width(),g=f.outerWidth(true),h=f.position().left-t/2,o=this.getDomRef("tabsContainer"),s=o.scrollLeft,j=this.$("tabsContainer").width(),n=s;if(h<0||h>j-g){if(this._bRtl&&D.browser.firefox){if(h<0){n+=h+g-j;}else{n+=h;}}else{if(h<0){n+=h;}else{n+=h+g-j;}}this._iCurrentScrollLeft=n;this._oScroller.scrollTo(n,0,e);}};
d.prototype._createSelect=function(t){var s,o,e,f={type:sap.m.SelectType.IconOnly,autoAdjustWidth:true,icon:I.getIconURI(d.ICON_BUTTONS.DownArrowButton),tooltip:r.getText("TABSTRIP_OPENED_TABS"),change:function(E){o=E.getParameters()['selectedItem'];e=this._findTabStripItemFromSelectItem(o);this._activateItem(e,E);}.bind(this)};s=new c(f);this._addItemsToSelect(s,t);return s;};
d.prototype.onsapselect=function(e){e.setMarked();e.preventDefault();this._activateItem(e.srcControl,e);};
d.prototype.onsapdelete=function(e){var i=q("#"+e.target.id).control(0),s=i.getId()===this.getSelectedItem(),f=function(){this._moveToNextItem(s);};this._removeItem(i,f);};
d.prototype._moveToNextItem=function(s){var i=this.getItems().length,e=this._oItemNavigation.getFocusedIndex(),n=i===e?--e:e,N=this.getItems()[n],f=function(){this._oItemNavigation.focusItem(n);};if(s){this.setSelectedItem(N);this.fireItemPress({item:N});}q.sap.delayedCall(0,this,f);};
d.prototype._activateItem=function(i,e){if(this.fireItemSelect({item:i})){if(i&&i instanceof sap.m.TabStripItem){if(!this.getSelectedItem()||this.getSelectedItem()!==i.getId()){this.setSelectedItem(i);}this.fireItemPress({item:i});}}else if(e&&!e.isDefaultPrevented()){e.preventDefault();}};
d.prototype.addAggregation=function(s,o,e){if(s==='items'){this._handleItemsAggregation(['addAggregation',o,e],true);}return C.prototype.addAggregation.call(this,s,o,e);};
d.prototype.insertAggregation=function(s,o,i,e){if(s==='items'){this._handleItemsAggregation(['insertAggregation',o,i,e],true);}return C.prototype.insertAggregation.call(this,s,o,i,e);};
d.prototype.removeAggregation=function(s,o,e){if(s==='items'){this._handleItemsAggregation(['removeAggregation',o,e]);}return C.prototype.removeAggregation.call(this,s,o,e);};
d.prototype.removeAllAggregation=function(s,e){if(s==='items'){this._handleItemsAggregation(['removeAllAggregation',null,e]);}return C.prototype.removeAllAggregation.call(this,s,e);};
d.prototype.destroyAggregation=function(s,e){if(s==='items'){this._handleItemsAggregation(['destroyAggregation',e]);}return C.prototype.destroyAggregation.call(this,s,e);};
d.prototype.setSelectedItem=function(s){if(!s){return;}if(s.$().length>0){this._scrollIntoView(s,500);}this._updateAriaSelectedAttributes(this.getItems(),s);this._updateSelectedItemClasses(s.getId());if(this.getHasSelect()){var o=this._findSelectItemFromTabStripItem(s);this.getAggregation('_select').setSelectedItem(o);}return d.prototype.setAssociation.call(this,"selectedItem",s,true);};
d.prototype.setProperty=function(p,v,s){var R;R=C.prototype.setProperty.call(this,p,v,s);if(p==='hasSelect'){if(v){if(!this.getAggregation('_select')){R=this.setAggregation('_select',this._createSelect(this.getItems()));}}else{R=this.destroyAggregation('_select');}}return R;};
d.prototype._attachItemEventListeners=function(o){if(o instanceof T){var e=['itemClosePressed','itemPropertyChanged'];e.forEach(function(E){E=E.charAt(0).toUpperCase()+E.slice(1);o['detach'+E](this['_handle'+E]);o['attach'+E](this['_handle'+E].bind(this));},this);}};
d.prototype._detachItemEventListeners=function(o){if(!o||typeof o!=='object'||!(o instanceof T)){var i=this.getItems();i.forEach(function(e){if(typeof e!=='object'||!(e instanceof T)){return;}return this._detachItemEventListeners(e);}.bind(this));}};
d.prototype._handleItemPropertyChanged=function(e){var s=this._findSelectItemFromTabStripItem(e.getSource());s.setProperty(e['mParameters'].propertyKey,e['mParameters'].propertyValue);};
d.prototype._handleItemClosePressed=function(e){this._removeItem(e.getSource());};
d.prototype._removeItem=function(i,f){var t;if(!(i instanceof T)){q.sap.log.error('Expecting instance of a TabStripSelectItem, given: ',i);}if(i.getId().indexOf(d.SELECT_ITEMS_ID_SUFFIX)!==-1){t=this._findTabStripItemFromSelectItem(i);}else{t=i;}if(this.fireItemClose({item:t})){this.removeAggregation('items',t);this._moveToNextItem(i.getId()===this.getSelectedItem());if(f){f.call(this);}}};
d.prototype._handleItemsAggregation=function(e,i){var s='items',f=e[0],o=e[1],n=[s];e.forEach(function(g,h){if(h>0){n.push(g);}});if(i){this._attachItemEventListeners(o);}else{this._detachItemEventListeners(o);}if(s!=="items"){return this;}if(this.getHasSelect()){this._handleSelectItemsAggregation(n,i,f,o);}return this;};
d.prototype._handleSelectItemsAggregation=function(e,i,f,o){var s=this.getAggregation('_select'),g;if(f==='destroyAggregation'&&!s){return;}if(o===null||typeof o!=='object'){return s[f]['apply'](s,e);}if(i){g=this._createSelectItemFromTabStripItem(o);}else{g=this._findSelectItemFromTabStripItem(o);}e.forEach(function(h,j){if(typeof h==='object'){e[j]=g;}});return s[f]['apply'](s,e);};
d.prototype._addItemsToSelect=function(s,i){i.forEach(function(o){var e=this._createSelectItemFromTabStripItem(o);s.addAggregation('items',e);if(o.getId()===this.getSelectedItem()){s.setSelectedItem(e);}},this);};
d.prototype._createSelectItemFromTabStripItem=function(t){var s;if(!t&&!(t instanceof sap.m.TabContainerItem)){q.sap.log.error('Expecting instance of "sap.m.TabContainerItem": instead of '+t+' given.');return;}s=new sap.m.TabStripItem({id:t.getId()+d.SELECT_ITEMS_ID_SUFFIX,text:t.getText(),modified:t.getModified(),itemClosePressed:function(e){this._handleItemClosePressed(e);}.bind(this)}).addEventDelegate({ontap:function(e){var o=e.srcControl;if(o instanceof A){o.fireItemClosePressed({item:o});}else if(o instanceof sap.ui.core.Icon){o=o.getParent&&o.getParent().getParent&&o.getParent().getParent();o.fireItemClosePressed({item:o});}}});return s;};
d.prototype._findTabStripItemFromSelectItem=function(t){var i,s=t.getId().replace(d.SELECT_ITEMS_ID_SUFFIX,''),e=this.getItems();for(i=0;i<e.length;i++){if(e[i].getId()===s){return e[i];}}};
d.prototype._findSelectItemFromTabStripItem=function(t){var i,s,e=t.getId()+d.SELECT_ITEMS_ID_SUFFIX;if(this.getHasSelect()){s=this.getAggregation('_select').getItems();for(i=0;i<s.length;i++){if(s[i].getId()===e){return s[i];}}}};
d.prototype._updateAriaSelectedAttributes=function(i,s){var e="false";i.forEach(function(o){if(o.$()){if(s&&s.getId()===o.getId()){e="true";}o.$().attr("aria-selected",e);}});};
d.prototype._updateSelectedItemClasses=function(s){if(this.$("tabs")){this.$("tabs").children(".sapMTabStripItemSelected").removeClass("sapMTabStripItemSelected");q("#"+s).addClass("sapMTabStripItemSelected");}};
d.prototype.changeItemState=function(i,s){var $;var e=this.getItems();e.forEach(function(o){if(i===o.getId()){$=q(o.$());if(s===true&&!$.hasClass(T.CSS_CLASS_MODIFIED)){$.addClass(T.CSS_CLASS_MODIFIED);}else{$.removeClass(T.CSS_CLASS_MODIFIED);}}});};
d.prototype.ontouchstart=function(e){var t=q(e.target).control(0);if(t instanceof T||t instanceof A||t instanceof sap.ui.core.Icon||t instanceof c){this._oTouchStartX=e.changedTouches[0].pageX;}};
d.prototype.ontouchend=function(e){var t,i;if(!this._oTouchStartX){return;}t=q(e.target).control(0);i=Math.abs(e.changedTouches[0].pageX-this._oTouchStartX);if(i<d.MIN_DRAG_OFFSET){if(t instanceof T){this._activateItem(t,e);}else if(t instanceof sap.m.AccButton){if(t&&t.getParent&&t.getParent()instanceof T){t=t.getParent();this._removeItem(t);}}else if(t instanceof sap.ui.core.Icon){if(t&&t.getParent&&t.getParent().getParent&&t.getParent().getParent()instanceof T){t=t.getParent().getParent();this._removeItem(t);}}this._oTouchStartX=null;}};
d.prototype.destroyItems=function(){this.setAssociation("selectedItem",null);return this.destroyAggregation("items");};
return d;},false);
sap.ui.predefine('sap/m/TabStripItem',["jquery.sap.global","./library","sap/ui/core/Item","sap/ui/base/ManagedObject",'sap/ui/core/IconPool','./AccButton'],function(q,l,I,M,a,A){"use strict";
var T=I.extend("sap.m.TabStripItem",{metadata:{library:"sap.m",properties:{modified:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{_closeButton:{type:"sap.m.Button",multiple:false}},events:{itemClosePressed:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabStripItem"}}},itemPropertyChanged:{parameters:{itemChanged:{type:'sap.m.TabStripItem'},propertyKey:{type:"string"},propertyValue:{type:"mixed"}}}}}});
T.DISPLAY_TEXT_MAX_LENGTH=25;T.CSS_CLASS="sapMTabStripItem";T.CSS_CLASS_LABEL="sapMTabStripItemLabel";T.CSS_CLASS_BUTTON="sapMTabStripItemButton";T.CSS_CLASS_MODIFIED="sapMTabStripItemModified";T.CSS_CLASS_SELECTED="sapMTabStripItemSelected";T.CSS_CLASS_STATE="sapMTabStripSelectListItemModified";T.CSS_CLASS_STATE_INVISIBLE="sapMTabStripSelectListItemModifiedInvisible";T.CSS_CLASS_CLOSE_BUTTON='sapMTabStripSelectListItemCloseBtn';T.CSS_CLASS_CLOSE_BUTTON_INVISIBLE='sapMTabStripSelectListItemCloseBtnInvisible';
T.prototype.init=function(){var b=new A({type:sap.m.ButtonType.Transparent,icon:a.getIconURI("decline"),tabIndex:"-1",ariaHidden:"true"}).addStyleClass(T.CSS_CLASS_CLOSE_BUTTON);this.setAggregation('_closeButton',b);};
T.prototype.setProperty=function(n,v,s){if(n==='modified'){s=true;}M.prototype.setProperty.call(this,n,v,s);if(this.getParent()&&this.getParent().changeItemState){this.getParent().changeItemState(this.getId(),v);}this.fireItemPropertyChanged({itemChanged:this,propertyKey:n,propertyValue:v});return this;};
return T;},false);
sap.ui.predefine('sap/m/TabStripRenderer',['jquery.sap.global','./TabStripItem','./TabStrip'],function(q,T,a){"use strict";var b={};b.LEFT_OVERRFLOW_BTN_CLASS_NAME="sapMTSLeftOverflowButtons";b.RIGHT_OVERRFLOW_BTN_CLASS_NAME="sapMTSRightOverflowButtons";
b.render=function(r,C){if(!C.getVisible()){return;}this.beginTabStrip(r,C);if(sap.ui.Device.system.phone===true){this.renderTouchArea(r,C);}else{r.write("<div id='"+C.getId()+"-leftOverflowButtons' class='"+this.LEFT_OVERRFLOW_BTN_CLASS_NAME+"'>");if(C.getAggregation("_leftArrowButton")){this.renderLeftOverflowButtons(r,C,false);}r.write("</div>");this.beginTabsContainer(r,C);this.renderItems(r,C);this.endTabsContainer(r);r.write("<div id='"+C.getId()+"-rightOverflowButtons' class='"+this.RIGHT_OVERRFLOW_BTN_CLASS_NAME+"'>");if(C.getAggregation("_rightArrowButton")){this.renderRightOverflowButtons(r,C,false);}r.write("</div>");this.renderTouchArea(r,C);}this.endTabStrip(r);};
b.renderItems=function(r,C){var i=C.getItems(),s=C.getSelectedItem();i.forEach(function(I){var d=s&&s===I.getId();this.renderItem(r,C,I,d);},this);};
b.renderItem=function(r,C,i,s){r.write("<div id='"+i.getId()+"'");r.addClass(T.CSS_CLASS);if(i.getModified()){r.addClass(T.CSS_CLASS_MODIFIED);}if(s){r.addClass(T.CSS_CLASS_SELECTED);}r.writeClasses();r.writeElementData(i);r.writeAccessibilityState(i,c(i,C.getParent(),sap.ui.getCore().byId(C.getSelectedItem())));r.write(">");r.write("<span id='"+g(i)+"' class='"+T.CSS_CLASS_LABEL+"'>");this.renderItemText(r,i);r.write("</span>");this.renderItemCloseButton(r,i);r.write("</div>");};
b.renderItemText=function(r,i){var I=i.getText();if(I.length>T.DISPLAY_TEXT_MAX_LENGTH){r.writeEscaped(I.slice(0,T.DISPLAY_TEXT_MAX_LENGTH));r.write('...');}else{r.writeEscaped(I);}};
b.renderItemCloseButton=function(r,i){r.write("<div class='sapMTSItemCloseBtnCnt'>");r.renderControl(i.getAggregation("_closeButton"));r.write("</div>");};
b.beginTabStrip=function(r,C){r.write("<div");r.addClass("sapMTabStrip");r.writeControlData(C);r.writeClasses();r.write(">");};
b.endTabStrip=function(r){r.write("</div>");};
b.beginTabsContainer=function(r,C){r.write("<div id='"+C.getId()+"-tabsContainer' class='sapMTSTabsContainer'>");r.write("<div id='"+C.getId()+"-tabs'  class='sapMTSTabs'");r.writeAccessibilityState(C,{role:"tablist"});r.write(">");};
b.endTabsContainer=function(r){r.write("</div>");r.write("</div>");};
b.renderLeftOverflowButtons=function(r,C,f){r.renderControl(C.getAggregation("_leftArrowButton"));if(f){r.flush(C.$("leftOverflowButtons")[0]);}};
b.renderRightOverflowButtons=function(r,C,f){r.renderControl(C.getAggregation("_rightArrowButton"));if(f){r.flush(C.$("rightOverflowButtons")[0]);}};
b.renderTouchArea=function(r,C){r.write("<div id='"+C.getId()+"-touchArea'  class='sapMTSTouchArea'>");r.renderControl(C.getAggregation('_select'));r.renderControl(C.getAddButton());r.write("</div>");};
function g(i){return i.getId()+"-label";}
function c(i,t,s){var A={role:"tab"},d=a.ARIA_STATIC_TEXTS.closable.getId()+" ";d+=i.getModified()?a.ARIA_STATIC_TEXTS.modified.getId():a.ARIA_STATIC_TEXTS.notModified.getId();A["describedby"]=d;A["labelledby"]=g(i);if(t&&t.getRenderer&&t.getRenderer().getContentDomId){A["controls"]=t.getRenderer().getContentDomId(t);}if(s&&s.getId()===i.getId()){A["selected"]="true";}else{A["selected"]="false";}return A;}
return b;},true);
sap.ui.predefine('sap/m/TabStripSelect',['jquery.sap.global','./Popover','./TabStripSelectList','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/m/Select','sap/m/TabStripItem'],function(q,P,T,l,C,E,I,S,a){"use strict";
var b=S.extend("sap.m.TabStripSelect",{metadata:{library:"sap.m"}});
b.CSS_CLASS='sapMTSSlt';b.CSS_CLASS_INVISIBLE='sapMSltInvisible';
b.prototype.init=function(){b.SPACE_BETWEEN_SELECT_BUTTON_AND_POPOVER=this.$().parents().hasClass('sapUiSizeCompact')?2:3;this.setPickerType(sap.ui.Device.system.phone?"Dialog":"Popover");this.createPicker(this.getPickerType());this._oSelectionOnFocus=null;this.bRenderingPhase=false;this._bFocusoutDueRendering=false;this._bProcessChange=false;};
b.prototype.createList=function(){this._oList=new T({width:"100%"}).attachSelectionChange(this.onSelectionChange,this).addEventDelegate({ontap:function(e){this.close();}},this);return this._oList;};
b.prototype._callMethodInControl=function(f,A){var r,L;if(A[0]==="items"){L=this.getList();if(L){r=T.prototype[f].apply(L,A);}if(f==='removeAggregation'&&this.isOpen()){this.getPicker().rerender();}}else{r=C.prototype[f].apply(this,A);}return r;};
b.prototype._createPopover=function(){var t=this,p=new P({showArrow:false,showHeader:false,placement:sap.m.PlacementType.Vertical,offsetX:0,offsetY:b.SPACE_BETWEEN_SELECT_BUTTON_AND_POPOVER,initialFocus:this,bounce:false});p.addEventDelegate({ontouchstart:function(e){var o=this.getDomRef("cont");if(e.target===o){t._bProcessChange=false;}}},p);p.addStyleClass("sapContrastPlus");this._decoratePopover(p);return p;};
b.prototype._createDialog=function(){var c=this.getRenderer().CSS_CLASS;var d=new sap.m.Dialog({stretch:true,customHeader:new sap.m.Bar({contentLeft:new sap.m.InputBase({width:"100%",editable:false}).addStyleClass(b.CSS_CLASS+"Input").addStyleClass(c+"Input")}).addStyleClass(b.CSS_CLASS+"Bar").addStyleClass(c+"Bar")}).addStyleClass(b.CSS_CLASS+"Dialog");d.getAggregation("customHeader").attachBrowserEvent("tap",function(){d.close();},this);return d;};
b.prototype._onBeforeOpenDialog=function(){var i=this.getPicker().getCustomHeader().getContentLeft()[0],s=this.getSelectedItem();if(s){i.setValue(s.getText());i.setTextDirection(this.getTextDirection());i.setTextAlign(this.getTextAlign());}};
b.prototype.onAfterRenderingPicker=function(){var p,c=sap.ui.getCore().getConfiguration().getRTL();S.prototype.onAfterRenderingPicker.call(this);if(c){p=this.$().width()-this.getPicker().$().width();}else{p=this.getPicker().$().width()-this.$().width();}if(this.getPicker()instanceof sap.m.Popover===true){this.getPicker().setOffsetX(-p);this.getPicker().setOffsetY(this.$().parents().hasClass('sapUiSizeCompact')?2:3);this.getPicker()._calcPlacement();}};
b.prototype.exit=function(){S.prototype.exit.call(this);this._oList.destroy();this._oList=null;};
b.prototype.ontouchstart=function(e){e.setMarked();if(this.getEnabled()&&this.isOpenArea(e.target)){this.addStyleClass(this.getRenderer().CSS_CLASS+"Pressed");}};
b.prototype.ontouchend=function(e){e.setMarked();if(this.getEnabled()&&(!this.isOpen()||!this.hasContent())&&this.isOpenArea(e.target)){this.removeStyleClass(this.getRenderer().CSS_CLASS+"Pressed");}};
b.prototype.onBeforeClose=function(){var d=this.getFocusDomRef();if(d){d.removeAttribute("aria-owns");d.removeAttribute("aria-activedescendant");}this.removeStyleClass(this.getRenderer().CSS_CLASS+"Pressed");};
b.prototype.onAfterClose=function(){var d=this.getFocusDomRef();if(d){d.setAttribute("aria-expanded","false");d.removeAttribute("aria-owns");}};
b.prototype.getDefaultSelectedItem=function(i){if(sap.ui.Device.system.phone){return S.prototype.getDefaultSelectedItem.apply(this,arguments);}return null;};
b.prototype.setValue=function(v){var m=this.$().find(".sapMTabStripSelectListItemModified").eq(0),s;S.prototype.setValue.apply(this,arguments);s=this.getSelectedItem();if(s&&s.getProperty('modified')){m.removeClass(a.CSS_CLASS_STATE_INVISIBLE);}else{m.addClass(a.CSS_CLASS_STATE_INVISIBLE);}return this;};
b.prototype.onSelectionChange=function(e){var i=e.getParameter("selectedItem");if(this.fireChange({selectedItem:i})){this.close();this.setSelection(i);this.setValue(this._getSelectedItemText());}else{e.preventDefault();}};
b.prototype.fireChange=function(p){this._oSelectionOnFocus=p.selectedItem;var A=true;return this.fireEvent("change",p,A);};
return b;},false);
sap.ui.predefine('sap/m/TabStripSelectList',['jquery.sap.global','./library','sap/ui/core/Control','sap/m/SelectList','sap/m/TabStripItem'],function(q,l,C,S,T){"use strict";
var a=S.extend("sap.m.TabStripSelectList",{metadata:{library:"sap.m"}});
a.CSS_CLASS_SELECTLIST='sapMSelectList';a.CSS_CLASS_TABSTRIPSELECTLIST='sapMTabStripSelectList';
a.prototype.init=function(){S.prototype.init.call(this);this.addStyleClass(a.CSS_CLASS_SELECTLIST);this.addStyleClass(a.CSS_CLASS_TABSTRIPSELECTLIST);};
a.prototype.onAfterRendering=function(){S.prototype.onAfterRendering.apply(this,arguments);var d=this.getDomRef();d.addEventListener("mouseenter",q.proxy(a.prototype.mouseenter,this),true);d.addEventListener("mouseleave",q.proxy(a.prototype.mouseleave,this),true);};
a.prototype.mouseenter=function(e){var c=q(e.target).control(0);if(sap.ui.Device.system.desktop&&c instanceof sap.m.TabStripItem&&this.getSelectedItem()!==c){c.getAggregation('_closeButton').$().removeClass(T.CSS_CLASS_CLOSE_BUTTON_INVISIBLE);}};
a.prototype.mouseleave=function(e){var c=q(e.target).control(0);if(sap.ui.Device.system.desktop&&c instanceof sap.m.TabStripItem&&q(e.target).hasClass('sapMSelectListItem')&&this.getSelectedItem()!==c){c.getAggregation('_closeButton').$().addClass(T.CSS_CLASS_CLOSE_BUTTON_INVISIBLE);}};
a.prototype._activateItem=function(i){if(i instanceof sap.ui.core.Item&&i&&i.getEnabled()){this.fireItemPress({item:i});if(this.fireSelectionChange({selectedItem:i})){var p=this.getSelectedItem();if(p&&p!==i){if(sap.ui.Device.system.desktop){p.getAggregation('_closeButton').addStyleClass(T.CSS_CLASS_CLOSE_BUTTON_INVISIBLE);}}this.setSelection(i);}}};
a.prototype.changeItemState=function(i,s){var $;var I=this.getItems();I.forEach(function(o){if(i===o.getId()){$=q(o.$().children('.'+T.CSS_CLASS_STATE)[0]);if(s===true){$.removeClass(T.CSS_CLASS_STATE_INVISIBLE);}else if(!$.hasClass(T.CSS_CLASS_STATE_INVISIBLE)){$.addClass(T.CSS_CLASS_STATE_INVISIBLE);}}});};
a.prototype.fireSelectionChange=function(p){var A=true;return this.fireEvent("selectionChange",p,A);};
return a;},true);
sap.ui.predefine('sap/m/TabStripSelectListRenderer',['jquery.sap.global','sap/ui/core/Renderer','sap/m/SelectListRenderer','sap/m/TabStripSelectList','sap/m/TabStripItem'],function(q,R,S,T,a){"use strict";var b=R.extend(S);
b.renderItem=function(r,l,i,s){if(!(i instanceof sap.ui.core.Element)){return;}var e=i.getEnabled(),o=l.getSelectedItem(),C=S.CSS_CLASS,t=i.getTooltip_AsString(),c=' ',d;d=i.getAggregation('_closeButton');if(sap.ui.Device.system.desktop){d.addStyleClass(a.CSS_CLASS_CLOSE_BUTTON_INVISIBLE);}r.write("<li");r.writeElementData(i);if(i instanceof sap.ui.core.SeparatorItem){r.addClass(C+"SeparatorItem");}else{r.addClass(C+"ItemBase");r.addClass(C+"Item");if(i.bVisible===false){r.addClass(C+"ItemBaseInvisible");}if(!e){r.addClass(C+"ItemBaseDisabled");}if(e){r.writeAttribute("tabindex","0");}if(e&&sap.ui.Device.system.desktop){r.addClass(C+"ItemBaseHoverable");}if(i===o){r.addClass(C+"ItemBaseSelected");i.getAggregation('_closeButton').removeStyleClass(a.CSS_CLASS_CLOSE_BUTTON_INVISIBLE);}}r.writeClasses();if(t){r.writeAttributeEscaped("title",t);}this.writeItemAccessibilityState.apply(this,arguments);r.write(">");r.write('<p');r.writeAttribute('class','sapMSelectListItemText');r.write('>');r.writeEscaped(i.getText().slice(0,(sap.ui.Device.system.phone?i.getText().length:a.DISPLAY_TEXT_MAX_LENGTH)));if(!sap.ui.Device.system.phone&&i.getText().length>a.DISPLAY_TEXT_MAX_LENGTH){r.write('...');}r.write('</p>');if(!i.getProperty('modified')){c+=a.CSS_CLASS_STATE_INVISIBLE;}r.write("<p class=\"sapMTabStripSelectListItemModified"+c+"\">*</p>");r.renderControl(d);r.write("</li>");};
return b;},true);
sap.ui.predefine('sap/m/TabStripSelectRenderer',['jquery.sap.global','sap/ui/core/Renderer','sap/m/SelectRenderer','sap/ui/core/ValueStateSupport','sap/m/TabStripSelect','sap/m/TabStripItem'],function(q,R,S,V,T,a){"use strict";var b=R.extend(S);
b.render=function(r,s){var t=V.enrichTooltip(s,s.getTooltip_AsString()),e=s.getEnabled(),C=S.CSS_CLASS;r.write("<button");r.addClass(T.CSS_CLASS);if(!s.getVisible()){r.addClass(T.CSS_CLASS_INVISIBLE);}this.addClass(r,s);r.addClass(C);r.addClass(C+s.getType());if(!e){r.addClass(C+"Disabled");}r.addClass(C+"WithArrow");r.addStyle("max-width",s.getMaxWidth());r.writeControlData(s);r.writeStyles();r.writeClasses();this.writeAccessibilityState(r,s);if(t){r.writeAttributeEscaped("title",t);}r.writeAttribute("tabindex","-1");r.write(">");r.write("<div");r.addClass("sapMSltInner");if(e&&sap.ui.Device.system.desktop){r.addClass(C+"Hoverable");}r.writeClasses();r.write(">");if(sap.ui.Device.system.phone){this.renderLabel(r,s);}this.renderIcon(r);var l=s.getList();if(s._isShadowListRequired()&&l){r.renderControl(l);}r.write("</div>");r.write("</button>");};
b.renderLabel=function(r,s){var o=s.getSelectedItem(),t=s.getTextDirection(),c=R.getTextAlign(s.getTextAlign(),t),d=' ';r.write("<label");r.writeAttribute("id",s.getId()+"-label");r.writeAttribute("for",s.getId());r.addClass(S.CSS_CLASS+"Label");if(t!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",t.toLowerCase());}if(c){r.addStyle("text-align",c);}r.writeStyles();r.writeClasses();r.write(">");r.writeEscaped(o?o.getText():"");if(!o.getProperty('modified')){d+=a.CSS_CLASS_STATE_INVISIBLE;}r.write('</label>');r.write('<span style="position: absolute" class="sapMTabStripSelectListItemModified'+d+'">*</span>');};
b.renderIcon=function(r){r.write("<span");r.addClass("sapMSltIcon");r.addClass("sapUiIcon");r.addClass("sapUiIconMirrorInRTL");r.writeClasses();r.write(">");r.write("</span");};
return b;},true);
sap.ui.predefine('sap/m/Table',['jquery.sap.global','./ListBase','./library'],function(q,L,l){"use strict";
var T=L.extend("sap.m.Table",{metadata:{library:"sap.m",properties:{backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:sap.m.BackgroundDesign.Translucent},fixedLayout:{type:"boolean",group:"Behavior",defaultValue:true},showOverlay:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{columns:{type:"sap.m.Column",multiple:true,singularName:"column"}}}});
T.prototype.sNavItemClass="sapMListTblRow";
T.prototype.init=function(){this._hasPopin=false;this._iItemNeedsColumn=0;this._selectAllCheckBox=null;L.prototype.init.call(this);};
T.prototype.onBeforeRendering=function(){L.prototype.onBeforeRendering.call(this);this._notifyColumns("ItemsRemoved");};
T.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.call(this);this.updateSelectAllCheckbox();this._renderOverlay();};
T.prototype._renderOverlay=function(){var $=this.$(),a=$.find(".sapMTableOverlay"),s=this.getShowOverlay();if(s&&a.length===0){a=q("<div>").addClass("sapUiOverlay sapMTableOverlay").css("z-index","1");$.append(a);}else if(!s){a.remove();}};
T.prototype.setShowOverlay=function(s){this.setProperty("showOverlay",s,true);this._renderOverlay();return this;};
T.prototype.exit=function(){L.prototype.exit.call(this);if(this._selectAllCheckBox){this._selectAllCheckBox.destroy();this._selectAllCheckBox=null;}};
T.prototype.destroyItems=function(){this._notifyColumns("ItemsRemoved");return L.prototype.destroyItems.apply(this,arguments);};
T.prototype.removeAllItems=function(){this._notifyColumns("ItemsRemoved");return L.prototype.removeAllItems.apply(this,arguments);};
T.prototype.removeSelections=function(){L.prototype.removeSelections.apply(this,arguments);this.updateSelectAllCheckbox();return this;};
T.prototype.selectAll=function(){L.prototype.selectAll.apply(this,arguments);this.updateSelectAllCheckbox();return this;};
T.prototype.getColumns=function(s){var c=this.getAggregation("columns",[]);if(s){c.sort(function(a,b){return a.getOrder()-b.getOrder();});}return c;};
T.prototype.onAfterPageLoaded=function(){this.updateSelectAllCheckbox();L.prototype.onAfterPageLoaded.apply(this,arguments);};
T.prototype.shouldRenderItems=function(){var h=this.getColumns().some(function(c){return c.getVisible();});if(!h){q.sap.log.warning("No visible columns found in "+this);}return h;};
T.prototype.onItemTypeColumnChange=function(i,n){this._iItemNeedsColumn+=(n?1:-1);if(this._iItemNeedsColumn==1&&n){this._setTypeColumnVisibility(true);}else if(this._iItemNeedsColumn==0){this._setTypeColumnVisibility(false);}};
T.prototype.onItemSelectedChange=function(i,s){L.prototype.onItemSelectedChange.apply(this,arguments);q.sap.delayedCall(0,this,function(){this.updateSelectAllCheckbox();});};
T.prototype.getTableDomRef=function(){return this.getDomRef("listUl");};
T.prototype.getItemsContainerDomRef=function(){return this.getDomRef("tblBody");};
T.prototype.setNavigationItems=function(i){var h=this.$("tblHeader");var f=this.$("tblFooter");var r=this.$("tblBody").children(".sapMLIB");var I=h.add(r).add(f).get();i.setItemDomRefs(I);if(i.getFocusedIndex()==-1){if(this.getGrowing()&&this.getGrowingDirection()==sap.m.ListGrowingDirection.Upwards){i.setFocusedIndex(I.length-1);}else{i.setFocusedIndex(h[0]?1:0);}}};
T.prototype.checkGrowingFromScratch=function(){if(this.hasPopin()){return false;}return this.getColumns().some(function(c){return c.getVisible()&&c.getMergeDuplicates();});};
T.prototype.onColumnResize=function(c){if(!this.hasPopin()&&!this._mutex){var h=this.getColumns().some(function(b){return b.isPopin();});if(!h){c.setDisplayViaMedia(this.getTableDomRef());return;}}this._dirty=window.innerWidth;if(!this._mutex){var a=window.innerWidth;this._mutex=true;this.rerender();q.sap.delayedCall(200,this,function(){if(this._dirty!=a){this._dirty=0;this.rerender();}this._mutex=false;});}};
T.prototype.setTableHeaderVisibility=function(c){if(!this.getDomRef()){return;}var $=q(this.getTableDomRef()),a=$.find("thead > tr"),h=!a.hasClass("sapMListTblHeaderNone"),v=a.find(".sapMListTblCell").filter(":visible"),b=v.eq(0);if(v.length==1){b.width("");}else{v.each(function(){this.style.width=this.getAttribute("data-sap-width")||"";});}$.find(".sapMGHLICell").attr("colspan",v.length+!!sap.m.ListBaseRenderer.ModeOrder[this.getMode()]);if(!c&&h){a[0].className="sapMListTblRow sapMListTblHeader";this._headerHidden=false;}else if(c&&!h&&!v.length){a[0].className="sapMListTblHeaderNone";this._headerHidden=true;}};
T.prototype._setTypeColumnVisibility=function(v){var t=q(this.getTableDomRef()),$=this.$("tblHeadNav"),i=$.index()+1,a=t.find("tr > td:nth-child("+i+")");t.toggleClass("sapMListTblHasNav",v);$.attr("aria-hidden",!v);a.attr("aria-hidden",!v);};
T.prototype._notifyColumns=function(a,p,P){this.getColumns().forEach(function(c){c["on"+a](p,P);});};
T.prototype._getSelectAllCheckbox=function(){return this._selectAllCheckBox||(this._selectAllCheckBox=new sap.m.CheckBox({id:this.getId("sa"),activeHandling:false}).setParent(this,null,true).attachSelect(function(){if(this._selectAllCheckBox.getSelected()){this.selectAll(true);}else{this.removeSelections(false,true);}},this).setTabIndex(-1).addEventDelegate({onAfterRendering:function(){this._selectAllCheckBox.getFocusDomRef().setAttribute("aria-hidden","true");}},this));};
T.prototype.updateSelectAllCheckbox=function(){if(this._selectAllCheckBox&&this.getMode()==="MultiSelect"){var i=this.getItems(),s=this.getSelectedItems().length,S=i.filter(function(I){return I.isSelectable();}).length;this._selectAllCheckBox.setSelected(i.length>0&&s==S);}};
T.prototype.getColSpan=function(){return(this._colCount||1)-1;};
T.prototype.getColCount=function(){return(this._colCount||0);};
T.prototype.hasPopin=function(){return!!this._hasPopin;};
T.prototype.isHeaderRowEvent=function(e){var h=this.$("tblHeader");return!!q(e.target).closest(h,this.getTableDomRef()).length;};
T.prototype.isFooterRowEvent=function(e){var f=this.$("tblFooter");return!!q(e.target).closest(f,this.getTableDomRef()).length;};
T.prototype.onNavigationItemFocus=function(e){var i=this._oItemNavigation.getItemDomRefs(),I=i[e.getParameter("index")];this.getNavigationRoot().setAttribute("aria-activedescendant",I.id);};
T.prototype.onsapspace=function(e){if(e.isMarked()){return;}if(this._selectAllCheckBox&&e.target===this.getDomRef("tblHeader")){this._selectAllCheckBox.setSelected(!this._selectAllCheckBox.getSelected()).fireSelect();e.preventDefault();e.setMarked();}};
T.prototype.onsaptabnext=function(e){if(e.isMarked()||this.getKeyboardMode()==sap.m.ListKeyboardMode.Edit){return;}var r=q();if(e.target.id==this.getId("nodata")){r=this.$("nodata");}else if(this.isHeaderRowEvent(e)){r=this.$("tblHeader");}else if(this.isFooterRowEvent(e)){r=this.$("tblFooter");}var o=r.find(":sapTabbable").get(-1)||r[0];if(e.target===o){this.forwardTab(true);e.setMarked();}};
T.prototype.onsaptabprevious=function(e){if(e.isMarked()||this.getKeyboardMode()==sap.m.ListKeyboardMode.Edit){return;}var t=e.target.id;if(t==this.getId("nodata")||t==this.getId("tblHeader")||t==this.getId("tblFooter")){this.forwardTab(false);}else if(t==this.getId("trigger")){this.focusPrevious();e.preventDefault();}};
return T;},true);
sap.ui.predefine('sap/m/TablePersoController',['jquery.sap.global','./TablePersoDialog','sap/ui/base/ManagedObject'],function(q,T,M){"use strict";
var d=M.extend("sap.m.TablePersoController",{
constructor:function(i,s){M.apply(this,arguments);},
metadata:{properties:{"contentWidth":{type:"sap.ui.core.CSSSize"},"contentHeight":{type:"sap.ui.core.CSSSize",defaultValue:"20rem",since:"1.22"},"componentName":{type:"string",since:"1.20.2"},"hasGrouping":{type:"boolean",defaultValue:false,since:"1.22"},"showSelectAll":{type:"boolean",defaultValue:true,since:"1.22"},"showResetAll":{type:"boolean",defaultValue:true,since:"1.22"}},aggregations:{"_tablePersoDialog":{type:"sap.m.TablePersoDialog",multiple:false,visibility:"hidden"},"persoService":{type:"Object",multiple:false}},associations:{"table":{type:"sap.m.Table",multiple:false},"tables":{type:"sap.m.Table",multiple:true}},events:{personalizationsDone:{}},library:"sap.m"}
});
d.prototype.init=function(){this._schemaProperty="_persoSchemaVersion";this._schemaVersion="1.0";this._oPersonalizations=null;this._mDelegateMap={};this._mTablePersMap={};this._mInitialTableStateMap={};this._triggersPersDoneEvent=true;};
d.prototype.exit=function(){this._callFunctionForAllTables(q.proxy(function(t){t.removeDelegate(this._mDelegateMap[t]);},this));delete this._mDelegateMap;delete this._mTablePersMap;delete this._mInitialTableStateMap;};
d.prototype.activate=function(){this._callFunctionForAllTables(this._rememberInitialTableStates);this._callFunctionForAllTables(this._createAndAddDelegateForTable);return this;};
d.prototype.getTablePersoDialog=function(){return this.getAggregation("_tablePersoDialog");};
d.prototype.applyPersonalizations=function(t){var r=this.getPersoService().getPersData();var a=this;r.done(function(p){if(!!p){a._adjustTable(p,t);}});r.fail(function(){q.sap.log.error("Problem reading persisted personalization data.");});};
d.prototype._createAndAddDelegateForTable=function(t){if(!this._mDelegateMap[t]){var o={onBeforeRendering:q.proxy(function(){this.applyPersonalizations(t);if(!this.getAggregation("_tablePersoDialog")){this._createTablePersoDialog(t);}},this)};t.addDelegate(o);this._mDelegateMap[t]=o;}};
d.prototype._createTablePersoDialog=function(t){var o=new T({persoDialogFor:t,persoMap:this._getPersoColumnMap(t),columnInfoCallback:this._tableColumnInfo.bind(this),initialColumnState:this._mInitialTableStateMap[t],contentWidth:this.getContentWidth(),contentHeight:this.getContentHeight(),hasGrouping:this.getHasGrouping(),showSelectAll:this.getShowSelectAll(),showResetAll:this.getShowResetAll()});this.setAggregation("_tablePersoDialog",o);o.attachConfirm(q.proxy(function(){this._oPersonalizations=o.retrievePersonalizations();this._callFunctionForAllTables(this._personalizeTable);this.savePersonalizations();this.firePersonalizationsDone();},this));};
d.prototype._adjustTable=function(D,t){if(D&&D.hasOwnProperty(this._schemaProperty)&&D[this._schemaProperty]===this._schemaVersion){this._oPersonalizations=D;if(!!t){this._personalizeTable(t);}else{this._callFunctionForAllTables(this._personalizeTable);}}};
d.prototype._personalizeTable=function(t){var p=this._getPersoColumnMap(t);if(!!p&&!!this._oPersonalizations){var D=false;for(var c=0,a=this._oPersonalizations.aColumns.length;c<a;c++){var n=this._oPersonalizations.aColumns[c];var o=p[n.id];if(!o){o=sap.ui.getCore().byId(n.id);if(!!o){q.sap.log.info("Migrating personalization persistence id of column "+n.id);n.id=p[o];D=true;}}if(o){o.setVisible(n.visible);o.setOrder(n.order);}else{q.sap.log.warning("Personalization could not be applied to column "+n.id+" - not found!");}}if(D){this.savePersonalizations();}t.invalidate();}};
d.prototype.savePersonalizations=function(){var b=this._oPersonalizations;b[this._schemaProperty]=this._schemaVersion;var w=this.getPersoService().setPersData(b);w.done(function(){});w.fail(function(){q.sap.log.error("Problem persisting personalization data.");});};
d.prototype.refresh=function(){var r=function(o){this._mTablePersMap={};o.invalidate();};this._callFunctionForAllTables(r);var t=this.getAggregation("_tablePersoDialog");if(!!t){t.setPersoMap(this._getPersoColumnMap(sap.ui.getCore().byId(t.getPersoDialogFor())));}};
d.prototype.openDialog=function(){var t=this.getAggregation("_tablePersoDialog");if(!!t){q.sap.syncStyleClass("sapUiSizeCompact",t.getPersoDialogFor(),t._oDialog);t.open();}else{q.sap.log.warning("sap.m.TablePersoController: trying to open TablePersoDialog before TablePersoService has been activated.");}};
d.prototype.setContentWidth=function(w){this.setProperty("contentWidth",w,true);var t=this.getAggregation("_tablePersoDialog");if(!!t){t.setContentWidth(w);}return this;};
d.prototype.setContentHeight=function(h){this.setProperty("contentHeight",h,true);var t=this.getAggregation("_tablePersoDialog");if(!!t){t.setContentHeight(h);}return this;};
d.prototype.setHasGrouping=function(h){this.setProperty("hasGrouping",h,true);var t=this.getAggregation("_tablePersoDialog");if(!!t){t.setHasGrouping(h);}return this;};
d.prototype.setShowSelectAll=function(s){this.setProperty("showSelectAll",s,true);var t=this.getAggregation("_tablePersoDialog");if(!!t){t.setShowSelectAll(s);}return this;};
d.prototype.setShowResetAll=function(s){this.setProperty("showResetAll",s,true);var t=this.getAggregation("_tablePersoDialog");if(!!t){t.setShowResetAll(s);}return this;};
d.prototype.setComponentName=function(c){this.setProperty("componentName",c,true);return this;};
d.prototype._getMyComponentName=function(c){if(this.getComponentName()){return this.getComponentName();}if(c===null){return"empty_component";}var m=c.getMetadata();if(c.getMetadata().getStereotype()==="component"){return m._sComponentName;}return this._getMyComponentName(c.getParent());};
d.prototype._callFunctionForAllTables=function(t){var o=sap.ui.getCore().byId(this.getAssociation("table"));if(!!o){t.call(this,o);}var a=this.getAssociation("tables");if(a){for(var i=0,l=this.getAssociation("tables").length;i<l;i++){o=sap.ui.getCore().byId(this.getAssociation("tables")[i]);t.call(this,o);}}};
d.prototype._isStatic=function(i){var u=sap.ui.getCore().getConfiguration().getUIDPrefix();var r=new RegExp("^"+u);return!r.test(i);};
d.prototype._getPersoColumnMap=function(t){var r=this._mTablePersMap[t];if(!r){r={};var e=function(i){var l=i.lastIndexOf("-");return i.substring(l+1);};var s=e.call(this,t.getId());if(!this._isStatic(s)){q.sap.log.error("Table "+t.getId()+" must have a static id suffix. Otherwise personalization can not be persisted.");r=null;return null;}var n;var c=this._getMyComponentName(t);var a=this;t.getColumns().forEach(function(N){if(!!r){var b=N.getId();var f=e.call(a,b);if(!a._isStatic(f)){q.sap.log.error("Suffix "+f+" of table column "+b+" must be static. Otherwise personalization can not be persisted for its table.");r=null;return null;}n=c+"-"+s+"-"+f;r[N]=n;r[n]=N;}});this._mTablePersMap[t]=r;}return r;};
d.prototype._rememberInitialTableStates=function(t){this._mInitialTableStateMap[t]=this._tableColumnInfo(t,this._getPersoColumnMap(t));};
d.prototype._tableColumnInfo=function(t,p){if(!!p){var c=t.getColumns(),C=[],P=this.getPersoService();c.forEach(function(o){var s=null;if(P.getCaption){s=P.getCaption(o);}var g=null;if(P.getGroup){g=P.getGroup(o);}if(!s){var a=o.getHeader();if(a.getText&&a.getText()){s=a.getText();}else if(a.getTitle&&a.getTitle()){s=a.getTitle();}if(!s){s=o.getId();q.sap.log.warning("Please 'getCaption' callback implentation in your TablePersoProvider for column "+o+". Table personalization uses column id as fallback value.");}}C.push({text:s,order:o.getOrder(),visible:o.getVisible(),id:p[o],group:g});});C.sort(function(a,b){return a.order-b.order;});return C;}return null;};
return d;},true);
sap.ui.predefine('sap/m/TablePersoDialog',['jquery.sap.global','./Button','./Dialog','./InputListItem','./List','./Toolbar','sap/ui/base/ManagedObject'],function(q,B,D,I,L,T,M){"use strict";
var a=M.extend("sap.m.TablePersoDialog",{
constructor:function(i,s){M.apply(this,arguments);},
metadata:{properties:{"contentWidth":{type:"sap.ui.core.CSSSize"},"contentHeight":{type:"sap.ui.core.CSSSize",since:"1.22"},"persoMap":{type:"object"},"columnInfoCallback":{type:"object",since:"1.22"},"initialColumnState":{type:"object",since:"1.22"},"hasGrouping":{type:"boolean",since:"1.22"},"showSelectAll":{type:"boolean",since:"1.22"},"showResetAll":{type:"boolean",since:"1.22"}},aggregations:{"persoService":{type:"Object",multiple:false,deprecated:true}},associations:{"persoDialogFor":"sap.m.Table"},events:{confirm:{},cancel:{}},library:"sap.m"}
});
a.prototype.init=function(){var t=this,l=0;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oP13nModel=new sap.ui.model.json.JSONModel();this._oP13nModel.setSizeLimit(Number.MAX_VALUE);this._fnUpdateCheckBoxes=q.proxy(function(e){var s=e.getParameter('selected'),d=this._oP13nModel.getData();if(e.getSource().getId()===this._getSelectAllCheckboxId()){d.aColumns.forEach(function(c){c.visible=s;});}else{var S=!d.aColumns.some(function(c){return!c.visible;});d.oHeader.visible=S;}this._oP13nModel.setData(d);},this);this._oColumnItemTemplate=new I({label:"{Personalization>text}",content:new sap.m.CheckBox({selected:"{Personalization>visible}",select:this._fnUpdateCheckBoxes})}).addStyleClass("sapMPersoDialogLI");this._oButtonUp=new B({icon:"sap-icon://arrow-top",enabled:false,tooltip:t._oRb.getText('PERSODIALOG_UP'),press:function(){t._moveItem(-1);}});this._oButtonDown=new B({icon:"sap-icon://arrow-bottom",enabled:false,tooltip:t._oRb.getText('PERSODIALOG_DOWN'),press:function(){t._moveItem(1);}});this._fnHandleResize=function(){if(t._oDialog){var $=t._oDialog.$("cont");var b=t._oDialog.$("scroll");if($.children().length>0){var c=$.children()[0].clientHeight;var p=b[0].clientHeight-c;var h=t.getShowSelectAll()?t._oSelectAllToolbar.$().outerHeight():0;t._oScrollContainer.setHeight((c-h-p)+'px');}}};this._fnUpdateArrowButtons=function(){var b=true,c=true,v=t._oSearchField.getValue(),i=t._oList.getItems().length;if(!!v||t._oList.getSelectedItems().length===0){c=false;b=false;}else{if(t._oList.getItems()[0].getSelected()){c=false;q.sap.focus(t._oButtonDown.getDomRef());}if(t._oList.getItems()[i-1].getSelected()){b=false;q.sap.focus(t._oButtonUp.getDomRef());}}t._oButtonUp.setEnabled(c);t._oButtonDown.setEnabled(b);};this._fnListUpdateFinished=function(){var b=t._oList.$().find('.sapMCb'),c=b.length;for(var i=0;i<c;i++){var $=q(b[i]).parent(),s=$.siblings(),d=s.length==1?q(s[0]):null;if(d){$=$.detach();$[0].className='sapMLIBSelectM';$.insertBefore(d);}}if(t._sLastSelectedItemId){var f=function(o){var r=(o.getBindingContext('Personalization')&&o.getBindingContext('Personalization').getProperty('id')===t._sLastSelectedItemId);if(r){t._oList.setSelectedItem(o);}return r;};t._oList.getItems().some(f);t._sLastSelectedItemId=null;if(t._fnUpdateArrowButtons){t._fnUpdateArrowButtons.call(this);}}};this._fnAfterDialogOpen=function(){t._fnUpdateArrowButtons.call(t);};this._fnAfterScrollContainerRendering=function(){t._oScrollContainer.$().attr('tabindex','-1');};this._oList=new L({includeItemInSelection:true,noDataText:this._oRb.getText('PERSODIALOG_NO_DATA'),mode:sap.m.ListMode.SingleSelectMaster,selectionChange:this._fnUpdateArrowButtons,updateFinished:this._fnListUpdateFinished});this._oList.addDelegate({onAfterRendering:this._fnListUpdateFinished});this._oSearchField=new sap.m.SearchField(this.getId()+"-searchField",{width:"100%",liveChange:function(e){var v=e.getSource().getValue(),d=(v?300:0);clearTimeout(l);if(d){l=setTimeout(function(){t._executeSearch();},d);}else{t._executeSearch();}},search:function(){t._executeSearch();}});this._oScrollContainer=new sap.m.ScrollContainer({horizontal:false,vertical:true,content:[this._oList],width:'100%'});this._oScrollContainer.addDelegate({onAfterRendering:this._fnAfterScrollContainerRendering});this._resetAllButton=new B({icon:"sap-icon://undo",tooltip:this._oRb.getText('PERSODIALOG_UNDO'),press:function(){this._resetAll();}.bind(this)}).addStyleClass("sapMPersoDialogResetBtn");this._oSelectAllCheckbox=new sap.m.CheckBox(this._getSelectAllCheckboxId(),{selected:"{Personalization>/oHeader/visible}",select:this._fnUpdateCheckBoxes,text:"{Personalization>/oHeader/text}"}).addStyleClass("sapMPersoDialogSelectAllCb");this._oSelectAllToolbar=new T({active:false,design:sap.m.ToolbarDesign.Transparent,content:[this._oSelectAllCheckbox,this._resetAllButton]}).addStyleClass("sapMPersoDialogFixedBar");this._oDialog=new D({title:this._oRb.getText("PERSODIALOG_COLUMNS_TITLE"),stretch:sap.ui.Device.system.phone,horizontalScrolling:false,verticalScrolling:false,initialFocus:(sap.ui.Device.system.desktop?this._oList:null),content:[this._oSelectAllToolbar,this._oScrollContainer],subHeader:new T({active:false,content:[this._oButtonUp,this._oButtonDown,this._oSearchField]}),leftButton:new B({text:this._oRb.getText("PERSODIALOG_OK"),press:function(){t._oDialog.close();t._oSearchField.setValue("");t._oSelectAllToolbar.setVisible(true);sap.ui.Device.resize.detachHandler(t._fnHandleResize);t.fireConfirm();}}),rightButton:new B({text:this._oRb.getText("PERSODIALOG_CANCEL"),press:function(){t._oDialog.close();t._oSearchField.setValue("");t._oSelectAllToolbar.setVisible(true);sap.ui.Device.resize.detachHandler(t._fnHandleResize);t.fireCancel();}}),afterOpen:this._fnAfterDialogOpen}).addStyleClass("sapMPersoDialog");};
a.prototype.retrievePersonalizations=function(){return this._oP13nModel.getData();};
a.prototype.open=function(){var s=null;if(this.getHasGrouping()){s=[new sap.ui.model.Sorter('group',false,true)];}this._readCurrentSettingsFromTable();this._oDialog.setModel(this._oP13nModel,"Personalization");this._oList.bindAggregation("items",{path:"Personalization>/aColumns",sorter:s,template:this._oColumnItemTemplate});if(!this._oList.getSelectedItem()){var i=this._oList.getItems();if(this.getHasGrouping()){i=i.filter(function(o){return o.getMetadata().getName()!="sap.m.GroupHeaderListItem";});}if(i.length>0){this._sLastSelectedItemId=i[0].getBindingContext('Personalization').getProperty('id');}}this._fnUpdateArrowButtons.call(this);this._oDialog.open();this._fnHandleResize.call(this);sap.ui.Device.resize.attachHandler(this._fnHandleResize);};
a.prototype.setContentHeight=function(h){this.setProperty("contentHeight",h,true);this._oDialog.setContentHeight(h);return this;};
a.prototype.setContentWidth=function(w){this.setProperty("contentWidth",w,true);this._oDialog.setContentWidth(w);return this;};
a.prototype.exit=function(){this._oRb=null;this._oP13nModel=null;if(this._oColumnItemTemplate){this._oColumnItemTemplate.destroy();this._oColumnItemTemplate=null;}if(this._oSelectAllToolbar){this._oSelectAllToolbar.destroy();this._oSelectAllToolbar=null;}if(this._oList){this._oList.destroy();this._oList=null;}if(this._oSearchField){this._oSearchField.destroy();this._oSearchField=null;}if(this._oScrollContainer){this._oScrollContainer.destroy();this._oScrollContainer=null;}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}if(this._oButtonDown){this._oButtonDown.destroy();this._oButtonDown=null;}if(this._oButtonUp){this._oButtonUp.destroy();this._oButtonUp=null;}};
a.prototype._resetAll=function(){if(this.getInitialColumnState()){var i=q.extend(true,[],this.getInitialColumnState()),t=this;var l=this._oList.getSelectedItem();this._sLastSelectedItemId=l&&l.getBindingContext('Personalization')&&l.getBindingContext('Personalization').getProperty('id');if(!!this._mColumnCaptions){i.forEach(function(c){c.text=t._mColumnCaptions[c.id];});}this._oP13nModel.getData().aColumns=i;this._oP13nModel.getData().oHeader.visible=!this.getInitialColumnState().some(function(c){return!c.visible;});this._oP13nModel.updateBindings();sap.ui.getCore().applyChanges();}};
a.prototype._moveItem=function(d){var s=this._oList.getSelectedItem();if(!s){return;}var o=this._oP13nModel.getData();var i=s.getBindingContext("Personalization").getPath().split("/").pop()*1;var b=i+d;if(b<0||b>=o.aColumns.length){return;}var t=o.aColumns[b];o.aColumns[b]=o.aColumns[i];o.aColumns[b].order=b;o.aColumns[i]=t;o.aColumns[i].order=i;this._oList.removeSelections(true);this._oP13nModel.updateBindings();var S=this._oList.getItems()[b];this._oList.setSelectedItem(S,true);sap.ui.getCore().applyChanges();if(!!S.getDomRef()){var e=S.$().position().top,m=18,v=this._oScrollContainer.$().height(),V=this._oScrollContainer.$().offset().top-this._oList.$().offset().top,c=V+v;if(e<V){this._oScrollContainer.scrollTo(0,Math.max(0,V-v+m));}else if(e+m>c){this._oScrollContainer.scrollTo(0,e);}}this._fnUpdateArrowButtons.call(this);};
a.prototype._readCurrentSettingsFromTable=function(){var t=sap.ui.getCore().byId(this.getPersoDialogFor()),b=this,c=this.getColumnInfoCallback().call(this,t,this.getPersoMap());this._oP13nModel.setData({aColumns:c,oHeader:{text:this._oRb.getText("PERSODIALOG_SELECT_ALL"),visible:!c.some(function(C){return!C.visible;}),id:this._getSelectAllCheckboxId()}});this._mColumnCaptions={};c.forEach(function(C){b._mColumnCaptions[C.id]=C.text;});};
a.prototype._getSelectAllCheckboxId=function(){return this.getId()+'_SelectAll';};
a.prototype._executeSearch=function(){var v=this._oSearchField.getValue(),f=new sap.ui.model.Filter("text",sap.ui.model.FilterOperator.Contains,v),b=this._oList.getBinding("items");this._oSelectAllToolbar.setVisible(!v&&this.getShowSelectAll());b.filter([f]);this._fnUpdateArrowButtons.call(this);return this;};
a.prototype.setHasGrouping=function(h){this.setProperty("hasGrouping",h,true);var b=this._oDialog.getSubHeader();if(!h){if(b.getContent().length===1){b.insertContent(this._oButtonDown,0);b.insertContent(this._oButtonUp,0);}}else{b.removeContent(this._oButtonUp);b.removeContent(this._oButtonDown);}return this;};
a.prototype.setShowSelectAll=function(s){this.setProperty("showSelectAll",s,true);this._oSelectAllToolbar.setVisible(s);this._fnHandleResize.call(this);return this;};
a.prototype.setShowResetAll=function(s){this.setProperty("showResetAll",s,true);this._resetAllButton.setVisible(s);return this;};
return a;},true);
sap.ui.predefine('sap/m/TablePersoProvider',['jquery.sap.global','sap/ui/base/ManagedObject'],function(q,M){"use strict";
var T=M.extend("sap.m.TablePersoProvider",{
constructor:function(i,s){M.apply(this,arguments);},
metadata:{"abstract":true,library:"sap.m"}
});
T.prototype.init=function(){q.sap.log.warning("This is the abstract base class for a TablePersoProvider. Do not create instances of this class, but use a concrete sub class instead.");q.sap.log.debug("TablePersoProvider init");};
T.prototype.getPersData=function(){q.sap.log.debug("TablePersoProvider getPersData");};
T.prototype.setPersData=function(b){q.sap.log.debug("TablePersoProvider setPersData");};
T.prototype.delPersData=function(){q.sap.log.debug("TablePersoProvider delPersData");};
T.prototype.getCaption=function(c){return null;};
T.prototype.getGroup=function(c){return null;};
T.prototype.resetPersData=function(){q.sap.log.debug("TablePersoProvider resetPersData");};
return T;},true);
sap.ui.predefine('sap/m/TableRenderer',['jquery.sap.global','sap/ui/core/Renderer','./ListBaseRenderer','./ColumnListItemRenderer'],function(q,R,L,C){"use strict";var T=R.extend(L);
T.renderColumns=function(r,t,a){var i=0,h=0,b=false,c=false,m=t.getMode(),M=L.ModeOrder[m],d="sapMListTbl",e=t.getId("tbl"),f=(a=="Head")?"th":"td",g=(a=="Head")?"columnheader":"gridcell",j="t"+a.toLowerCase(),k=t.getColumns(),l=(a=="Head")&&k.every(function(p){return!p.getHeader()||!p.getHeader().getVisible()||!p.getVisible()||p.isPopin()||p.isHidden();}),n=(a=="Head")&&k.filter(function(p){return p.getVisible()&&!p.isPopin()&&!p.isHidden();}).length==1,o=function(p,s,A){r.write("<");r.write(f);r.writeAttribute("role",g);A&&r.writeAttribute("aria-hidden","true");s&&r.writeAttribute("id",e+s);r.addClass(d+p);r.writeClasses();r.write("></");r.write(f);r.write(">");i++;};r.write("<"+j+">");r.write("<tr");r.writeAttribute("tabindex",-1);r.writeAttribute("role","row");r.writeAttribute("id",t.addNavSection(e+a+"er"));if(l){r.addClass("sapMListTblHeaderNone");}else{r.addClass("sapMListTblRow sapMLIBFocusable sapMListTbl"+a+"er");C.addLegacyOutlineClass.call(C,r);}r.writeClasses();r.write(">");if(M==-1){if(m=="MultiSelect"&&a=="Head"&&!l){r.write("<th role='columnheader' class='"+d+"SelCol'>");r.write("<div class='sapMLIBSelectM'>");r.renderControl(t._getSelectAllCheckbox());r.write("</div></th>");i++;}else{o("SelCol");}}k.forEach(function(p,s){p.setIndex(-1);p.setInitialOrder(s);});t.getColumns(true).forEach(function(p,s){if(!p.getVisible()){return;}if(p.isPopin()){b=true;return;}if(p.isHidden()){h++;}var u=p["get"+a+"er"](),w=n?"":p.getWidth(),v=p.getStyleClass(true),x=p.getCssAlign();r.write("<"+f);v&&r.addClass(q.sap.encodeHTML(v));r.addClass(d+"Cell");r.addClass(d+a+"erCell");r.writeAttribute("id",e+a+i);r.writeAttribute("data-sap-width",p.getWidth());r.writeAttribute("role",g);w&&r.addStyle("width",w);if(x){r.addStyle("text-align",x);}r.writeClasses();r.writeStyles();r.write(">");if(u){p.applyAlignTo(u);r.renderControl(u);}if(a=="Head"&&!c){c=!!p.getFooter();}r.write("</"+f+">");p.setIndex(i++);});o("NavCol",a+"Nav",!t._iItemNeedsColumn);if(M==1){o("SelCol");}r.write("</tr></"+j+">");if(a=="Head"){t._hasPopin=b;t._colCount=i-h;t._hasFooter=c;t._headerHidden=l;}};
T.renderContainerAttributes=function(r,c){r.addClass("sapMListTblCnt");};
T.renderListStartAttributes=function(r,c){r.write("<div");r.writeAttribute("id",c.getId()+"-labelledby");r.writeAttribute("aria-hidden","true");r.addClass("sapUiInvisibleText");r.writeClasses();r.write(">");r.writeEscaped(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LIST_VIEW"));r.write("</div>");r.write("<table");r.addClass("sapMListTbl");if(c.getFixedLayout()===false){r.addStyle("table-layout","auto");}if(c._iItemNeedsColumn){r.addClass("sapMListTblHasNav");}};
T.getAriaRole=function(c){return"grid";};
T.getAriaLabelledBy=function(c){var a=c.getId()+"-labelledby",b=L.getAriaLabelledBy.call(this,c);return b?(a+" "+b):a;};
T.renderListHeadAttributes=function(r,c){this.renderColumns(r,c,"Head");r.write("<tbody");r.writeAttribute("id",c.addNavSection(c.getId("tblBody")));r.write(">");};
T.renderListEndAttributes=function(r,c){r.write("</tbody>");c._hasFooter&&this.renderColumns(r,c,"Foot");r.write("</table>");};
T.renderNoData=function(r,c){r.write("<tr");r.writeAttribute("role","row");r.writeAttribute("tabindex",c.getKeyboardMode()==sap.m.ListKeyboardMode.Navigation?-1:0);r.writeAttribute("id",c.getId("nodata"));r.addClass("sapMLIB sapMListTblRow sapMLIBTypeInactive");C.addFocusableClasses.call(C,r);if(!c._headerHidden||(!c.getHeaderText()&&!c.getHeaderToolbar())){r.addClass("sapMLIBShowSeparator");}r.writeClasses();r.write(">");r.write("<td");r.writeAttribute("role","gridcell");r.writeAttribute("id",c.getId("nodata-text"));r.writeAttribute("colspan",c.getColCount());r.addClass("sapMListTblCell sapMListTblCellNoData");r.writeClasses();r.write(">");r.writeEscaped(c.getNoDataText(true));r.write("</td>");r.write("</tr>");};
return T;},true);
sap.ui.predefine('sap/m/TableSelectDialog',['jquery.sap.global','./Button','./Dialog','./SearchField','./Table','./library','sap/ui/core/Control'],function(q,B,D,S,T,l,C){"use strict";
var a=C.extend("sap.m.TableSelectDialog",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},noDataText:{type:"string",group:"Appearance",defaultValue:null},multiSelect:{type:"boolean",group:"Dimension",defaultValue:false},growingThreshold:{type:"int",group:"Misc",defaultValue:null},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},rememberSelections:{type:"boolean",group:"Behavior",defaultValue:false},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.ColumnListItem",multiple:true,singularName:"item",bindable:"bindable"},_dialog:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},columns:{type:"sap.m.Column",multiple:true,singularName:"column",bindable:"bindable"}},events:{confirm:{parameters:{selectedItem:{type:"sap.m.StandardListItem"},selectedItems:{type:"sap.m.StandardListItem[]"},selectedContexts:{type:"string"}}},search:{parameters:{value:{type:"string"},itemsBinding:{type:"any"}}},liveChange:{parameters:{value:{type:"string"},itemsBinding:{type:"any"}}},cancel:{}}}});
a.prototype.init=function(){var t=this,L=0,r=null;r=function(){t._oSelectedItem=t._oTable.getSelectedItem();t._aSelectedItems=t._oTable.getSelectedItems();t._oDialog.detachAfterClose(r);t._fireConfirmAndUpdateSelection();};this._bAppendedToUIArea=false;this._bInitBusy=false;this._bFirstRender=true;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTable=new T(this.getId()+"-table",{growing:true,growingScrollToLoad:true,mode:sap.m.ListMode.SingleSelectMaster,infoToolbar:new sap.m.Toolbar({visible:false,active:false,content:[new sap.m.Label({text:this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[0])})]}),selectionChange:function(e){if(t._oDialog){if(!t.getMultiSelect()){t._oDialog.attachAfterClose(r);t._oDialog.close();}else{t._updateSelectionIndicator();}}}});this._oTable.getInfoToolbar().addEventDelegate({onAfterRendering:function(){t._oTable.getInfoToolbar().$().attr('aria-live','polite');}});this._table=this._oTable;this._oBusyIndicator=new sap.m.BusyIndicator(this.getId()+"-busyIndicator").addStyleClass("sapMTableSelectDialogBusyIndicator",true);this._oSearchField=new S(this.getId()+"-searchField",{width:"100%",liveChange:function(e){var v=e.getSource().getValue(),i=(v?300:0);clearTimeout(L);if(i){L=setTimeout(function(){t._executeSearch(v,"liveChange");},i);}else{t._executeSearch(v,"liveChange");}},search:function(e){t._executeSearch(e.getSource().getValue(),"search");}});this._searchField=this._oSearchField;this._oSubHeader=new sap.m.Bar(this.getId()+"-subHeader",{contentMiddle:[this._searchField]});this._oDialog=new D(this.getId()+"-dialog",{stretch:sap.ui.Device.system.phone,contentHeight:"2000px",subHeader:this._oSubHeader,content:[this._oBusyIndicator,this._oTable],leftButton:this._getCancelButton(),initialFocus:((sap.ui.Device.system.desktop&&this._oSearchField)?this._oSearchField:null)});this._dialog=this._oDialog;this.setAggregation("_dialog",this._oDialog);var d=this._oDialog.onsapescape;this._oDialog.onsapescape=function(e){if(d){d.call(t._oDialog,e);}t._onCancel();};this._oDialog._iVMargin=8*(parseInt(sap.ui.core.theming.Parameters.get("sapUiFontSize"),10)||16);this._sSearchFieldValue="";this._bFirstRequest=true;this._iTableUpdateRequested=0;};
a.prototype.exit=function(){this._oTable=null;this._oSearchField=null;this._oSubHeader=null;this._oBusyIndicator=null;this._sSearchFieldValue=null;this._iTableUpdateRequested=null;this._bFirstRequest=false;this._bInitBusy=false;this._bFirstRender=false;if(this._bAppendedToUIArea){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.removeContent(this,true);}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}if(this._oOkButton){this._oOkButton.destroy();this._oOkButton=null;}this._oSelectedItem=null;this._aSelectedItems=null;this._aInitiallySelectedItems=null;this._table=null;this._searchField=null;this._dialog=null;};
a.prototype.onAfterRendering=function(){if(this._bInitBusy&&this._bFirstRender){this._setBusy(true);this._bInitBusy=false;this._bFirstRender=false;}return this;};
a.prototype.invalidate=function(){if(this._oDialog&&(!arguments[0]||arguments[0]&&arguments[0].getId()!==this.getId()+"-dialog")){this._oDialog.invalidate(arguments);}else{C.prototype.invalidate.apply(this,arguments);}return this;};
a.prototype.open=function(s){if(!this.getParent()&&!this._bAppendedToUIArea){var o=sap.ui.getCore().getStaticAreaRef();o=sap.ui.getCore().getUIArea(o);o.addContent(this,true);this._bAppendedToUIArea=true;}this._bFirstRequest=true;this._oSearchField.setValue(s);this._oDialog.open();if(this._bInitBusy){this._setBusy(true);}this._aInitiallySelectedItems=this._oTable.getSelectedItems();this._updateSelectionIndicator();return this;};
a.prototype.setGrowingThreshold=function(v){this._oTable.setGrowingThreshold(v);this.setProperty("growingThreshold",v,true);return this;};
a.prototype.setBusyIndicatorDelay=function(v){this._oTable.setBusyIndicatorDelay(v);this.setProperty("busyIndicatorDelay",v,true);return this;};
a.prototype.setMultiSelect=function(m){this.setProperty("multiSelect",m,true);if(m){this._oTable.setMode(sap.m.ListMode.MultiSelect);this._oTable.setIncludeItemInSelection(true);this._oDialog.setRightButton(this._getCancelButton());this._oDialog.setLeftButton(this._getOkButton());}else{this._oTable.setMode(sap.m.ListMode.SingleSelectMaster);this._oDialog.setLeftButton(this._getCancelButton());}return this;};
a.prototype.setTitle=function(t){this.setProperty("title",t,true);this._oDialog.setTitle(t);return this;};
a.prototype.setNoDataText=function(n){this._oTable.setNoDataText(n);return this;};
a.prototype.getNoDataText=function(){return this._oTable.getNoDataText();};
a.prototype.getContentWidth=function(){return this._oDialog.getContentWidth();};
a.prototype.setContentWidth=function(w){this._oDialog.setContentWidth(w);return this;};
a.prototype.getContentHeight=function(){return this._oDialog.getContentHeight();};
a.prototype.setContentHeight=function(h){this._oDialog.setContentHeight(h);return this;};
a.prototype.addStyleClass=function(){this._oDialog.addStyleClass.apply(this._oDialog,arguments);return this;};
a.prototype.removeStyleClass=function(){this._oDialog.removeStyleClass.apply(this._oDialog,arguments);return this;};
a.prototype.toggleStyleClass=function(){this._oDialog.toggleStyleClass.apply(this._oDialog,arguments);return this;};
a.prototype.hasStyleClass=function(){return this._oDialog.hasStyleClass.apply(this._oDialog,arguments);};
a.prototype.getDomRef=function(){if(this._oDialog){return this._oDialog.getDomRef.apply(this._oDialog,arguments);}else{return null;}};
a.prototype._setModel=a.prototype.setModel;
a.prototype.setModel=function(m,M){var A=Array.prototype.slice.call(arguments);this._setBusy(false);this._bInitBusy=false;this._iTableUpdateRequested+=1;this._oTable.attachUpdateStarted(this._updateStarted,this);this._oTable.attachUpdateFinished(this._updateFinished,this);this._oTable.setModel(m,M);a.prototype._setModel.apply(this,A);this._updateSelectionIndicator();return this;};
a.prototype._callMethodInManagedObject=function(f,A){var b=Array.prototype.slice.call(arguments);if(A==="items"){return this._oTable[f].apply(this._oTable,b.slice(1));}else if(A==="columns"){return this._oTable[f].apply(this._oTable,b.slice(1));}else{return sap.ui.base.ManagedObject.prototype[f].apply(this,b.slice(1));}};
a.prototype.bindAggregation=function(){var b=Array.prototype.slice.call(arguments);this._callMethodInManagedObject.apply(this,["bindAggregation"].concat(b));return this;};
a.prototype.validateAggregation=function(A,o,m){return this._callMethodInManagedObject("validateAggregation",A,o,m);};
a.prototype.setAggregation=function(A,o,s){this._callMethodInManagedObject("setAggregation",A,o,s);return this;};
a.prototype.getAggregation=function(A,d){return this._callMethodInManagedObject("getAggregation",A,d);};
a.prototype.indexOfAggregation=function(A,o){return this._callMethodInManagedObject("indexOfAggregation",A,o);};
a.prototype.insertAggregation=function(A,o,i,s){this._callMethodInManagedObject("insertAggregation",A,o,i,s);return this;};
a.prototype.addAggregation=function(A,o,s){this._callMethodInManagedObject("addAggregation",A,o,s);return this;};
a.prototype.removeAggregation=function(A,o,s){this._callMethodInManagedObject("removeAggregation",A,o,s);return this;};
a.prototype.removeAllAggregation=function(A,s){return this._callMethodInManagedObject("removeAllAggregation",A,s);};
a.prototype.destroyAggregation=function(A,s){this._callMethodInManagedObject("destroyAggregation",A,s);return this;};
a.prototype.getBinding=function(A){return this._callMethodInManagedObject("getBinding",A);};
a.prototype.getBindingInfo=function(A){return this._callMethodInManagedObject("getBindingInfo",A);};
a.prototype.getBindingPath=function(A){return this._callMethodInManagedObject("getBindingPath",A);};
a.prototype.getBindingContext=function(m){return this._oTable&&this._oTable.getBindingContext(m);};
a.prototype._setBindingContext=a.prototype.setBindingContext;
a.prototype.setBindingContext=function(c,m){var b=Array.prototype.slice.call(arguments);this._oTable.setBindingContext(c,m);a.prototype._setBindingContext.apply(this,b);return this;};
a.prototype._executeSearch=function(v,e){var t=this._oTable,b=(t?t.getBinding("items"):undefined),s=(this._sSearchFieldValue!==v);if(this._oDialog.isOpen()&&((s&&e==="liveChange")||e==="search")){this._sSearchFieldValue=v;if(b){this._iTableUpdateRequested+=1;if(e==="search"){this.fireSearch({value:v,itemsBinding:b});}else if(e==="liveChange"){this.fireLiveChange({value:v,itemsBinding:b});}}else{if(e==="search"){this.fireSearch({value:v});}else if(e==="liveChange"){this.fireLiveChange({value:v});}}}return this;};
a.prototype._setBusy=function(b){if(this._iTableUpdateRequested){if(b){if(this._bFirstRequest){this._oSubHeader.$().css('display','none');}this._oTable.addStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','inline-block');}else{if(this._bFirstRequest){this._oSubHeader.$().css('display','block');}this._oTable.removeStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','none');}}};
a.prototype._updateStarted=function(e){if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){if(this._oDialog.isOpen()&&this._iTableUpdateRequested){this._setBusy(true);}else{this._bInitBusy=true;}}};
a.prototype._updateFinished=function(e){this._updateSelectionIndicator();if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){this._setBusy(false);this._bInitBusy=false;}if(sap.ui.Device.system.desktop){if(this._oTable.getItems()[0]){this._oDialog.setInitialFocus(this._oTable.getItems()[0]);}else{this._oDialog.setInitialFocus(this._oSearchField);}if(this._bFirstRequest){var f=this._oTable.getItems()[0];if(!f){f=this._oSearchField;}if(f.getFocusDomRef()){f.getFocusDomRef().focus();}}}this._bFirstRequest=false;this._iTableUpdateRequested=0;};
a.prototype._getOkButton=function(){var t=this,o=null;o=function(){t._oSelectedItem=t._oTable.getSelectedItem();t._aSelectedItems=t._oTable.getSelectedItems();t._oDialog.detachAfterClose(o);t._fireConfirmAndUpdateSelection();};if(!this._oOkButton){this._oOkButton=new B(this.getId()+"-ok",{text:this._oRb.getText("MSGBOX_OK"),press:function(){t._oDialog.attachAfterClose(o);t._oDialog.close();}});}return this._oOkButton;};
a.prototype._getCancelButton=function(){var t=this;if(!this._oCancelButton){this._oCancelButton=new B(this.getId()+"-cancel",{text:this._oRb.getText("MSGBOX_CANCEL"),press:function(){t._onCancel();}});}return this._oCancelButton;};
a.prototype._onCancel=function(e){var t=this,A=null;A=function(){t._oSelectedItem=null;t._aSelectedItems=[];t._sSearchFieldValue=null;t._oDialog.detachAfterClose(A);t._resetSelection();t.fireCancel();};this._oDialog.attachAfterClose(A);this._oDialog.close();};
a.prototype._updateSelectionIndicator=function(){var s=this._oTable.getSelectedContexts(true).length,i=this._oTable.getInfoToolbar();i.setVisible(!!s);i.getContent()[0].setText(this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[s]));};
a.prototype._fireConfirmAndUpdateSelection=function(){this.fireConfirm({selectedItem:this._oSelectedItem,selectedItems:this._aSelectedItems,selectedContexts:this._oTable.getSelectedContexts(true)});this._updateSelection();};
a.prototype._updateSelection=function(){if(!this.getRememberSelections()&&!this.bIsDestroyed){this._oTable.removeSelections(true);delete this._oSelectedItem;delete this._aSelectedItems;}};
a.prototype._resetSelection=function(){var i=0;if(!this.bIsDestroyed){this._oTable.removeSelections();for(;i<this._aInitiallySelectedItems.length;i++){this._oTable.setSelectedItem(this._aInitiallySelectedItems[i]);}}};
return a;},true);
sap.ui.predefine('sap/m/TableSelectDialogRenderer',['jquery.sap.global'],function(q){"use strict";var T={};
T.render=function(r,c){};
return T;},true);
sap.ui.predefine('sap/m/Text',['jquery.sap.global','./library','sap/ui/core/Control'],function(q,l,C){"use strict";
var T=C.extend("sap.m.Text",{metadata:{interfaces:["sap.ui.core.IShrinkable"],library:"sap.m",properties:{text:{type:"string",defaultValue:'',bindable:"bindable"},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit},wrapping:{type:"boolean",group:"Appearance",defaultValue:true},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:sap.ui.core.TextAlign.Begin},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},maxLines:{type:"int",group:"Appearance",defaultValue:null}}}});
T.prototype.normalLineHeight=1.2;T.prototype.cacheLineHeight=true;T.prototype.ellipsis='…';T.hasNativeLineClamp=(function(){return(typeof document.documentElement.style.webkitLineClamp!="undefined");})();
T.setNodeValue=function(d,n){n=n||"";var c=d.childNodes;if(c.length===1&&c[0].nodeType===window.Node.TEXT_NODE){c[0].nodeValue=n;}else{d.textContent=n;}};
T.prototype.setText=function(t){this.setProperty("text",t,true);var d=this.getTextDomRef();if(d){T.setNodeValue(d,this.getText(true));if(this.getWrapping()){if(t&&!/\s/.test(t)){this.$().addClass("sapMTextBreakWord");}else{this.$().removeClass("sapMTextBreakWord");}}}return this;};
T.prototype.getText=function(n){var t=this.getProperty("text");if(n){return t.replace(/\\r\\n|\\n/g,"\n");}return t;};
T.prototype.onAfterRendering=function(){if(this.getVisible()&&this.hasMaxLines()&&!this.canUseNativeLineClamp()){this.clampHeight();}};
T.prototype.hasMaxLines=function(){return(this.getWrapping()&&this.getMaxLines()>1);};
T.prototype.getTextDomRef=function(){if(!this.getVisible()){return null;}if(this.hasMaxLines()){return this.getDomRef("inner");}return this.getDomRef();};
T.prototype.canUseNativeLineClamp=function(){if(!T.hasNativeLineClamp){return false;}var d=sap.ui.core.TextDirection;if(this.getTextDirection()==d.RTL){return false;}if(this.getTextDirection()==d.Inherit&&sap.ui.getCore().getConfiguration().getRTL()){return false;}return true;};
T.prototype.getLineHeight=function(d){if(this.cacheLineHeight&&this._fLineHeight){return this._fLineHeight;}d=d||this.getTextDomRef();if(!d){return 0;}var s=window.getComputedStyle(d),L=s.lineHeight,f;if(/px$/i.test(L)){f=parseFloat(L);}else if(/^normal$/i.test(L)){f=parseFloat(s.fontSize)*this.normalLineHeight;}else{f=parseFloat(s.fontSize)*parseFloat(L);}if(!sap.ui.Device.browser.firefox){f=Math.floor(f);}if(this.cacheLineHeight&&f){this._fLineHeight=f;}return f;};
T.prototype.getClampHeight=function(d){d=d||this.getTextDomRef();return this.getMaxLines()*this.getLineHeight(d);};
T.prototype.clampHeight=function(d){d=d||this.getTextDomRef();if(!d){return 0;}var m=this.getClampHeight(d);if(m){d.style.maxHeight=m+"px";}return m;};
T.prototype.clampText=function(d,s,e){d=d||this.getTextDomRef();if(!d){return;}var E;var t=this.getText(true);var m=this.getClampHeight(d);s=s||0;e=e||t.length;T.setNodeValue(d,t.slice(0,e));if(d.scrollHeight>m){var S=d.style,h=S.height,a=this.ellipsis,i=a.length;S.height=m+"px";while((e-s)>i){E=(s+e)>>1;T.setNodeValue(d,t.slice(0,E-i)+a);if(d.scrollHeight>m){e=E;}else{s=E;}}if(d.scrollHeight>m&&s>0){E=s;d.textContent=t.slice(0,E-i)+a;}S.height=h;}return E;};
T.prototype.getAccessibilityInfo=function(){return{description:this.getText()};};
return T;},true);
sap.ui.predefine('sap/m/TextArea',['jquery.sap.global','./InputBase','./library'],function(q,I,l){"use strict";
var T=I.extend("sap.m.TextArea",{metadata:{library:"sap.m",properties:{rows:{type:"int",group:"Appearance",defaultValue:2},cols:{type:"int",group:"Appearance",defaultValue:20},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},maxLength:{type:"int",group:"Behavior",defaultValue:0},wrapping:{type:"sap.ui.core.Wrapping",group:"Behavior",defaultValue:sap.ui.core.Wrapping.None},valueLiveUpdate:{type:"boolean",group:"Behavior",defaultValue:false},growing:{type:"boolean",group:"Behavior",defaultValue:false},growingMaxLines:{type:"int",group:"Behavior",defaultValue:0}},events:{liveChange:{parameters:{value:{type:"string"}}}}}});
T.prototype.exit=function(){I.prototype.exit.call(this);q(window).off("resize.sapMTextAreaGrowing");};
T.prototype.onAfterRendering=function(){I.prototype.onAfterRendering.call(this);if(this.getGrowing()){var t=this.getFocusDomRef();if(this.getGrowingMaxLines()>0){var s=window.getComputedStyle(t),m=parseFloat(s.lineHeight)*this.getGrowingMaxLines()+parseFloat(s.paddingTop)+parseFloat(s.borderTopWidth)+parseFloat(s.borderBottomWidth);if(sap.ui.Device.browser.firefox){m+=parseFloat(s.paddingBottom);}t.style.maxHeight=m+"px";}this._adjustHeight(t);}if(!sap.ui.Device.support.touch){return;}var $=this.$("inner");if(this._behaviour.INSIDE_SCROLLABLE_WITHOUT_FOCUS){$.on("touchstart",q.proxy(this._onTouchStart,this));$.on("touchmove",q.proxy(this._onTouchMove,this));}else if(this._behaviour.PAGE_NON_SCROLLABLE_AFTER_FOCUS){$.on("touchmove",function(e){if($.is(":focus")){e.stopPropagation();}});}};
T.prototype.onsapenter=function(e){e.setMarked();};
T.prototype.onValueRevertedByEscape=function(v){if(this.getValueLiveUpdate()){this.setProperty("value",v,true);v=this.getValue();}this.fireLiveChange({value:v,newValue:v});};
T.prototype.getValue=function(){var t=this.getFocusDomRef();return t?t.value:this.getProperty("value");};
T.prototype.onsapnext=function(e){e.setMarked();};
T.prototype.onsapprevious=function(e){e.setMarked();};
T.prototype.oninput=function(e){I.prototype.oninput.call(this,e);if(e.isMarked("invalid")){return;}var t=this.getFocusDomRef(),v=t.value,m=this.getMaxLength();if(m>0&&v.length>m){v=v.substring(0,m);t.value=v;}if(this.getValueLiveUpdate()){this.setProperty("value",v,true);v=this.getValue();}if(this.getGrowing()){this._adjustHeight(t);}this.fireLiveChange({value:v,newValue:v});};
T.prototype.setGrowing=function(g){this.setProperty("growing",g);if(this.getGrowing()){q(window).on("resize.sapMTextAreaGrowing",this._updateOverflow.bind(this));}else{q(window).off("resize.sapMTextAreaGrowing");}return this;};
T.prototype._adjustHeight=function(t){t.style.height=sap.ui.Device.browser.firefox?"0px":"auto";t.style.height=t.scrollHeight+t.offsetHeight-t.clientHeight-1+"px";this._updateOverflow();};
T.prototype._updateOverflow=function(){var t=this.getFocusDomRef();var m=parseFloat(window.getComputedStyle(t)["max-height"]);t.style.overflowY=(t.scrollHeight>m)?"auto":"";};
T.prototype._getInputValue=function(v){v=I.prototype._getInputValue.call(this,v);return v.replace(/\r\n/g,"\n");};
T.prototype._behaviour=(function(d){return{INSIDE_SCROLLABLE_WITHOUT_FOCUS:d.os.ios||d.os.blackberry||d.browser.chrome,PAGE_NON_SCROLLABLE_AFTER_FOCUS:d.os.android&&d.os.version>=4.1};}(sap.ui.Device));
T.prototype._onTouchStart=function(e){var t=e.touches[0];this._iStartY=t.pageY;this._iStartX=t.pageX;this._bHorizontalScroll=undefined;e.setMarked("swipestartHandled");};
T.prototype._onTouchMove=function(e){var t=this.getFocusDomRef(),p=e.touches[0].pageY,s=t.scrollTop,b=s<=0,B=s+t.clientHeight>=t.scrollHeight,g=this._iStartY>p,G=this._iStartY<p,o=b&&G||B&&g;if(this._bHorizontalScroll===undefined){this._bHorizontalScroll=Math.abs(this._iStartY-p)<Math.abs(this._iStartX-e.touches[0].pageX);}if(this._bHorizontalScroll||!o){e.setMarked();}};
var _=sap.ui.Device.os.windows_phone&&(/MSAppHost/i).test(navigator.appVersion);
T.prototype.onfocusin=function(e){var s,$=this.$();I.prototype.onfocusin.apply(this,arguments);function a(){q(window).scrollTop(0);s.scrollTop($.offset().top-s.offset().top+s.scrollTop());}if(_&&$.height()+$.offset().top>260){for(s=$.parent();s[0];s=s.parent()){if(s.css("overflow-y")=="auto"){s.children().last().css("padding-bottom",q(window).height()+"px");window.setTimeout(a,100);return;}}}};
return T;},true);
sap.ui.predefine('sap/m/TextAreaRenderer',['jquery.sap.global','sap/ui/core/Renderer','./InputBaseRenderer'],function(q,R,I){"use strict";var T={};var T=R.extend(I);
T.addOuterClasses=function(r,c){r.addClass("sapMTextArea");};
T.addOuterStyles=function(r,c){c.getHeight()&&r.addStyle("height",c.getHeight());};
T.openInputTag=function(r,c){r.write("<textarea");};
T.closeInputTag=function(r,c){r.write("</textarea>");};
T.writeInnerValue=function(){};
T.writeInnerContent=function(r,c){var v=c.getValue();v=q.sap.encodeHTML(v);if(sap.ui.Device.browser.msie&&sap.ui.Device.browser.version<11){v=v.replace(/&#xd;&#xa;|&#xd;|&#xa;/g,"&#13;");}else{v=v.replace(/&#xd;&#xa;|&#xd;|&#xa;/g,"&#13;&#10;");}r.write(v);};
T.addInnerClasses=function(r,c){r.addClass("sapMTextAreaInner");if(c.getGrowing()){r.addClass("sapMTextAreaGrow");}};
T.getAriaRole=function(c){return"";};
T.writeInnerAttributes=function(r,c){if(c.getWrapping()!=sap.ui.core.Wrapping.None){r.writeAttribute("wrap",c.getWrapping());}r.writeAttribute("rows",c.getRows());r.writeAttribute("cols",c.getCols());};
return T;},true);
sap.ui.predefine('sap/m/TextRenderer',['jquery.sap.global','sap/ui/core/Renderer'],function(q,R){"use strict";var T={};
T.render=function(r,t){var w=t.getWidth(),s=t.getText(true),a=t.getTextDirection(),b=t.getTooltip_AsString(),n=t.getMaxLines(),W=t.getWrapping(),c=t.getTextAlign();r.write("<span");r.writeControlData(t);r.addClass("sapMText");r.addClass("sapUiSelectable");if(!W||n==1){r.addClass("sapMTextNoWrap");}else if(W){if(s&&s.length>0&&!/\s/.test(s)){r.addClass("sapMTextBreakWord");}}w?r.addStyle("width",w):r.addClass("sapMTextMaxWidth");if(a!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",a.toLowerCase());}b&&r.writeAttributeEscaped("title",b);if(c){c=R.getTextAlign(c,a);if(c){r.addStyle("text-align",c);}}r.writeClasses();r.writeStyles();r.write(">");if(t.hasMaxLines()){this.renderMaxLines(r,t);}else{this.renderText(r,t);}r.write("</span>");};
T.renderMaxLines=function(r,t){r.write("<span");r.writeAttribute("id",t.getId()+"-inner");r.addClass("sapMTextMaxLine");if(t.canUseNativeLineClamp()){r.addClass("sapMTextLineClamp");r.addStyle("-webkit-line-clamp",t.getMaxLines());}r.writeClasses();r.writeStyles();r.write(">");this.renderText(r,t);r.write("</span>");};
T.renderText=function(r,t){var s=t.getText(true);r.writeEscaped(s);};
return T;},true);
sap.ui.predefine('sap/m/Tile',['jquery.sap.global','./library','sap/ui/core/InvisibleText','sap/ui/core/Control'],function(q,l,I,C){"use strict";
var T=C.extend("sap.m.Tile",{metadata:{library:"sap.m",properties:{removable:{type:"boolean",group:"Misc",defaultValue:true}},events:{press:{}}}});
var a;
T.prototype.init=function(){if(sap.ui.Device.system.desktop){var o=q.proxy(function(e){if(e.srcControl===this&&!e.isMarked()){this.ontap();e.stopPropagation();}},this);this.onsapspace=o;this.onsapenter=o;}};
T.prototype.onAfterRendering=function(){if(this._rendered&&!this._bIsDragged&&this.getParent()instanceof sap.m.TileContainer){this.setPos(this._posX,this._posY);}this._rendered=true;};
T.prototype.setPos=function(x,y){this._posX=x=Math.floor(x);this._posY=y=Math.floor(y);if(!this._rendered){return;}var o=this.getDomRef();if("webkitTransform"in o.style){this.$().css('-webkit-transform','translate3d('+x+'px,'+y+'px,0)');}else if("transform"in o.style){this.$().css('transform','translate3d('+x+'px,'+y+'px,0)');}else if("msTransform"in o.style){this.$().css('msTransform','translate('+x+'px,'+y+'px)');}else if("MozTransform"in o.style){this.$().css('-moz-transform','translate3d('+x+'px,'+y+'px,0)');}if(this._invisible){this.$().css("visibility","");delete this._invisible;}};
T.prototype.setSize=function(w,h){this._width=w;this._height=h;};
T.prototype.isEditable=function(i){var o=this._bIsEditable;if(i===true||i===false){this._bIsEditable=i;}if(o!=i&&this.$()){this.$().attr("aria-describedBy",i?this._getAriaDescribedByDeleteLabel().getId():null);}return this._bIsEditable;};
T.prototype.isDragged=function(i){if(!this._bIsEditable){return;}if(i===true||i===false){var o=this.$();o.toggleClass("sapMTileDrag",i);this._bIsDragged=i;}return this._bIsDragged;};
T.prototype.ontouchstart=function(e){if(!this.isEditable()&&!this._parentPreventsTapEvent){this.$().toggleClass("sapMTileActive sapMTileActive-CTX",true);this._clientX=e.clientX;this._clientY=e.clientY;}};
T.prototype.ontouchend=function(){if(!this.isEditable()){this.$().toggleClass("sapMTileActive sapMTileActive-CTX",false);}};
Object.defineProperty(T.prototype,"_parentPreventsTapEvent",{get:function(){var p=this.getParent();while(p){if(p._bAvoidChildTapEvent||(p instanceof T&&p.isEditable())){return true;}p=p.getParent();}return false;}});
T.prototype.ontouchmove=function(e){if(!this.isEditable()&&!this._parentPreventsTapEvent){if(Math.abs(e.clientX-this._clientX)>30||Math.abs(e.clientY-this._clientY)>10){this.$().toggleClass("sapMTileActive sapMTileActive-CTX",false);}}};
T.prototype.ontap=function(){if(!this.isEditable()&&!this._parentPreventsTapEvent){this.firePress({});}};
T.prototype.setVisible=function(v){this.setProperty("visible",v);if(this.getParent()&&this.getParent()instanceof sap.m.TileContainer){this.getParent().invalidate();}return this;};
T.prototype._setVisible=function(v){this._invisible=!v;return this;};
T.prototype._getTileIndex=function(){var t=this.getParent(),i=null;if(t&&t instanceof sap.m.TileContainer){i=t.indexOfAggregation("tiles",this)+1;}return i;};
T.prototype._getTilesCount=function(){var t=this.getParent(),i=null;if(t&&t instanceof sap.m.TileContainer){i=t.getTiles().length;}return i;};
T.prototype._updateAriaPosition=function(){this.$().attr('aria-posinset',this._getTileIndex());return this;};
T.prototype._getAriaDescribedByDeleteLabel=function(){if(!a){a=new I({text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("TILE_REMOVE_BY_DEL_KEY")}).toStatic();}return a;};
return T;},true);
sap.ui.predefine('sap/m/TileContainer',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool'],function(q,l,C,I){"use strict";
var T=C.extend("sap.m.TileContainer",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},editable:{type:"boolean",group:"Misc",defaultValue:null},allowAdd:{type:"boolean",group:"Misc",defaultValue:null}},defaultAggregation:"tiles",aggregations:{tiles:{type:"sap.m.Tile",multiple:true,singularName:"tile"}},events:{tileMove:{parameters:{tile:{type:"sap.m.Tile"},newIndex:{type:"int"}}},tileDelete:{parameters:{tile:{type:"sap.m.Tile"}}},tileAdd:{}}}});
I.insertFontFaceStyle();T.prototype._bRtl=sap.ui.getCore().getConfiguration().getRTL();
T.prototype.init=function(){this._iCurrentTileStartIndex=0;this._iCurrentPage=0;this._iPages=0;this._iScrollLeft=0;this._iScrollGap=0;if(!sap.ui.Device.system.desktop){this._iScrollGap=0;}this.bAllowTextSelection=false;this._oDragSession=null;this._oTouchSession=null;this._bAvoidChildTapEvent=false;this._iEdgeShowStart=sap.ui.Device.system.phone?10:20;if(sap.ui.Device.system.phone){this._iTriggerScrollOffset=10;}else if(sap.ui.Device.system.desktop){this._iTriggerScrollOffset=-40;}else{this._iTriggerScrollOffset=20;}this._iCurrentFocusIndex=-1;if(sap.ui.Device.system.desktop||sap.ui.Device.system.combi){var o=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var r=this._iCurrentFocusIndex-this._iCurrentFocusIndex%this._iMaxTilesX;var F=this._iCurrentTileStartIndex===this._iCurrentFocusIndex?0:this._iCurrentTileStartIndex;var t=E.ctrlKey?F:r;var k=this._getVisibleTiles()[t];if(!!k){this._findTile(k.$()).focus();E.stopPropagation();}this._handleAriaActiveDescendant();}},this),O=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var t=this._getVisibleTiles();var r=this._iCurrentFocusIndex-this._iCurrentFocusIndex%this._iMaxTilesX;var R=r+this._iMaxTilesX<t.length?r+this._iMaxTilesX-1:t.length-1;var L=this._iCurrentTileStartIndex+this._iMaxTiles<t.length?this._iCurrentTileStartIndex+this._iMaxTiles-1:t.length-1;var k=L===this._iCurrentFocusIndex?t.length-1:L;var m=E.ctrlKey?k:R;if(t.length>0){this._findTile(t[m].$()).focus();E.stopPropagation();}this._handleAriaActiveDescendant();}},this),f=q.proxy(function(E){var t=this._getVisibleTiles();if(t.length>0){var n=this._iCurrentFocusIndex-this._iMaxTiles>=0?this._iCurrentFocusIndex-this._iMaxTiles:0;var N=t[n];if(!!N){this._findTile(N.$()).focus();E.stopPropagation();}this._handleAriaActiveDescendant();}},this),c=q.proxy(function(E){var t=this._getVisibleTiles();var k=t.length;if(k>0){var n=this._iCurrentFocusIndex+this._iMaxTiles<k?this._iCurrentFocusIndex+this._iMaxTiles:k-1;var N=t[n];if(!!N){this._findTile(N.$()).focus();E.stopPropagation();}this._handleAriaActiveDescendant();}},this),d=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var t=this._getVisibleTiles();var n=this._iCurrentFocusIndex+1<t.length?this._iCurrentFocusIndex+1:this._iCurrentFocusIndex;if(!E.ctrlKey){var N=t[n];if(!!N){if(n<this._iCurrentTileStartIndex+this._iMaxTiles){this._findTile(N.$()).focus();}else{this.scrollIntoView(N,true);var k=this;setTimeout(function(){k._findTile(N.$()).focus();},400);}}}else if(this.getEditable()){var m=t[this._iCurrentFocusIndex];this.moveTile(m,n);m.$().focus();}this._handleAriaActiveDescendant();E.stopPropagation();}},this),e=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var t=this._getVisibleTiles();var n=this._iCurrentFocusIndex-1>=0?this._iCurrentFocusIndex-1:this._iCurrentFocusIndex;if(!E.ctrlKey){var N=t[n];if(!!N){if(n>=this._iCurrentTileStartIndex){this._findTile(N.$()).focus();}else{this.scrollIntoView(N,true);var k=this;setTimeout(function(){k._findTile(N.$()).focus();},400);}}}else if(this.getEditable()){var m=t[this._iCurrentFocusIndex];this.moveTile(m,n);m.$().focus();}this._handleAriaActiveDescendant();E.stopPropagation();}},this),g=q.proxy(function(E){var t=this._getVisibleTiles();if(this._iCurrentFocusIndex>=0){var m=this._iCurrentFocusIndex%this._iMaxTiles,n=this._iCurrentFocusIndex+this._iMaxTilesX,M=n%this._iMaxTiles;if(!E.ctrlKey){var N=t[n];if((M>m)&&!!N){this._findTile(N.$()).focus();}}else if(this.getEditable()){var k=t[this._iCurrentFocusIndex];this.moveTile(k,n);k.$().focus();}this._handleAriaActiveDescendant();E.stopPropagation();}},this),i=q.proxy(function(E){var t=this._getVisibleTiles();if(this._iCurrentFocusIndex>=0){var m=this._iCurrentFocusIndex%this._iMaxTiles,n=this._iCurrentFocusIndex-this._iMaxTilesX,M=n%this._iMaxTiles;if(!E.ctrlKey){var N=t[n];if((M<m)&&!!N){this._findTile(N.$()).focus();}}else if(this.getEditable()){var k=t[this._iCurrentFocusIndex];this.moveTile(k,n);k.$().focus();}this._handleAriaActiveDescendant();E.stopPropagation();}},this),j=q.proxy(function(E){var t=this._getVisibleTiles();if(this._iCurrentFocusIndex>=0&&this.getEditable()){var k=t[this._iCurrentFocusIndex];if(k.getRemovable()){this.deleteTile(k);if(this._iCurrentFocusIndex===t.length){if(t.length!==0){t[this._iCurrentFocusIndex-1].$().focus();}else{this._findNextTabbable().focus();}}else{t[this._iCurrentFocusIndex].$().focus();}this._handleAriaActiveDescendant();}E.stopPropagation();}},this);this.onsaphome=o;this.onsaphomemodifiers=o;this.onsapend=O;this.onsapendmodifiers=O;this.onsapright=this._bRtl?e:d;this.onsaprightmodifiers=this._bRtl?e:d;this.onsapleft=this._bRtl?d:e;this.onsapleftmodifiers=this._bRtl?d:e;this.onsapup=i;this.onsapupmodifiers=i;this.onsapdown=g;this.onsapdownmodifiers=g;this.onsappageup=f;this.onsappagedown=c;this.onsapdelete=j;this.data("sap-ui-fastnavgroup","true",true);}if(sap.ui.Device.system.tablet||sap.ui.Device.system.phone){this._fnOrientationChange=function(E){if(this.getDomRef()){this._oTileDimensionCalculator.calc();}}.bind(this);}this._oTileDimensionCalculator=new a(this);};
T.prototype._findNextTabbable=function(){var r=this.$();var t=q.merge(q.merge(r.nextAll(),r.parents().nextAll()).find(':sapTabbable').addBack(':sapTabbable'),q.merge(r.parents().prevAll(),r.prevAll()).find(':sapTabbable').addBack(':sapTabbable'));return t.first();};
T.prototype.onBeforeRendering=function(){if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
T.prototype.onAfterRendering=function(){this._sResizeListenerId=sap.ui.core.ResizeHandler.register(this.getDomRef().parentElement,q.proxy(this._resize,this));this._applyDimension();this.$().toggleClass("sapMTCEditable",this.getEditable()===true);this._update(true);if(sap.ui.Device.system.desktop||sap.ui.Device.system.combi){var t=this._getVisibleTiles();if(t.length>0&&this._mFocusables&&this._mFocusables[t[0].getId()]){this._mFocusables[t[0].getId()].eq(0).attr('tabindex','0');}}if(sap.ui.Device.system.tablet||sap.ui.Device.system.phone){sap.ui.Device.orientation.attachHandler(this._fnOrientationChange,this);}};
T.prototype.setEditable=function(v){var t=this._getVisibleTiles();this.setProperty("editable",v,true);var e=this.getEditable();this.$().toggleClass("sapMTCEditable",e);for(var i=0;i<t.length;i++){var o=t[i];if(o instanceof sap.m.Tile){o.isEditable(e);}}return this;};
T.prototype.updateTiles=function(r){this.destroyTiles();this.updateAggregation('tiles');};
T.prototype._applyDimension=function(){var d=this._getContainerDimension(),$=this.$(),t,o=10,c=this.$("scrl"),s,e,p=this.$("pager").outerHeight();c.css({width:d.outerwidth+"px",height:(d.outerheight-p)+"px"});t=$.position();s=c.position();e=c.outerHeight();if(sap.ui.Device.system.phone){o=2;}else if(sap.ui.Device.system.desktop){o=0;}this.$("blind").css({top:(s.top+o)+"px",left:(s.left+o)+"px",right:"auto",width:(c.outerWidth()-o)+"px",height:(e-o)+"px"});this.$("rightedge").css({top:(t.top+o)+"px",right:o+"px",left:"auto",height:(e-o)+"px"});this.$("leftedge").css({top:(t.top+o)+"px",left:(t.left+o)+"px",right:"auto",height:(e-o)+"px"});};
T.prototype._resize=function(){if(this._oDragSession){return;}setTimeout(q.proxy(function(){this._update(true);},this),0);};
T.prototype.exit=function(){if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(sap.ui.Device.system.tablet||sap.ui.Device.system.phone){sap.ui.Device.orientation.detachHandler(this._fnOrientationChange,this);}};
T.prototype._update=function(A){if(!this.getDomRef()){return;}if(!this.$().is(":visible")){return;}this._oTileDimensionCalculator.calc();this._updateTilePositions();if(!this._oDragSession){this.scrollIntoView(this._iCurrentTileStartIndex||0,A);}};
T.prototype.getPageFirstTileIndex=function(){return this._iCurrentTileStartIndex||0;};
T.prototype.moveTile=function(t,n){if(!isNaN(t)){t=this._getVisibleTiles()[t];}if(!t){q.sap.log.info("No Tile to move");return this;}this.deleteTile(t);this.insertTile(t,n);return this;};
T.prototype.addTile=function(t){this.insertTile(t,this.getTiles().length);};
T.prototype.insertTile=function(t,i){var c=this;if(sap.ui.Device.system.desktop||sap.ui.Device.system.combi){t.addEventDelegate({"onAfterRendering":function(){if(!c._mFocusables){c._mFocusables={};}c._mFocusables[this.getId()]=this.$().find("[tabindex!='-1']").addBack().filter(c._isFocusable);c._mFocusables[this.getId()].attr('tabindex','-1');}},t);var o=function(e){var i=c.indexOfAggregation("tiles",this),E=Math.floor(i/c._iMaxTiles),p=E-c._iCurrentPage;var P=c._iCurrentFocusIndex>=0?c._iCurrentFocusIndex:0;var f=c._getVisibleTiles()[P];if(f){c._mFocusables[f.getId()].attr("tabindex","-1");c._mFocusables[this.getId()].attr("tabindex","0");}if(p!=0){c.scrollIntoView(i);c._resize();}c._handleAriaActiveDescendant();c._iCurrentFocusIndex=i;};t.addEventDelegate({"onfocusin":o},t);}if(this.getDomRef()){this.insertAggregation("tiles",t,i,true);if(!this._oDragSession){var r=sap.ui.getCore().createRenderManager(),d=this.$("cnt")[0];r.renderControl(t);r.flush(d,false,i);r.destroy();}this._update(false);if(sap.ui.Device.system.desktop||sap.ui.Device.system.combi){this._updateTilesTabIndex();}}else{this.insertAggregation("tiles",t,i);}b.call(this,i,this._getVisibleTiles().length);h.call(this);return this;};
T.prototype._updateTilesTabIndex=function(){var t=this._getVisibleTiles();if(t.length&&t.length>0){for(var i=0;i<t.length;i++){if(t[i].$().attr("tabindex")==="0"){return;}}}t[0].$().attr("tabindex","0");};
T.prototype._isFocusable=function(i,e){var c=!isNaN(q(e).attr("tabindex"));var n=e.nodeName.toLowerCase();if(n==="area"){var m=e.parentNode,d=m.name,f;if(!e.href||!d||m.nodeName.toLowerCase()!=="map"){return false;}f=q("img[usemap='#"+d+"']")[0];return!!f;}return(/input|select|textarea|button|object/.test(n)?!e.disabled:n=="a"?e.href||c:c);};
T.prototype.deleteTile=function(t){var i=this.indexOfAggregation("tiles",t);if(this.getDomRef()){this.removeAggregation("tiles",t,true);if(!this._oDragSession){t.getDomRef().parentNode.removeChild(t.getDomRef());if(sap.ui.Device.system.desktop||sap.ui.Device.system.combi){if(this._mFocusables&&this._mFocusables[t.getId()]){delete this._mFocusables[t.getId()];}}}this._update(false);}else{this.removeAggregation("tiles",t,false);}b.call(this,i,this._getVisibleTiles().length);h.call(this);return this;};
T.prototype.removeTile=T.prototype.deleteTile;
T.prototype.removeAllTiles=function(){var t=this.getTiles().length-1;for(var i=t;i>=0;i--){var o=this.getTiles()[i];this.deleteTile(o);}return this;};
T.prototype.destroyTiles=function(){if(this.getDomRef()){var t=this.getTiles();this.removeAllAggregation("tiles",true);this._update();for(var i=0;i<t.length;i++){var c=t[i];c.destroy();}}else{this.destroyAggregation("tiles",false);}return this;};
T.prototype.rerender=function(){if(!this._oDragSession||this._oDragSession.bDropped){C.prototype.rerender.apply(this);}};
T.prototype.scrollLeft=function(){if(this._bRtl){this.scrollIntoView(this._iCurrentTileStartIndex+this._iMaxTiles);}else{this.scrollIntoView(this._iCurrentTileStartIndex-this._iMaxTiles);}};
T.prototype.scrollRight=function(){if(this._bRtl){this.scrollIntoView(this._iCurrentTileStartIndex-this._iMaxTiles);}else{this.scrollIntoView(this._iCurrentTileStartIndex+this._iMaxTiles);}};
T.prototype.scrollIntoView=function(t,A){var c=this._getContentDimension().outerwidth,i=t;if(isNaN(t)){i=this.indexOfAggregation("tiles",t);}if(!this.getTiles()[i]||!this.getTiles()[i].getVisible()){return;}this._applyPageStartIndex(i);this._iCurrentPage=Math.floor(this._iCurrentTileStartIndex/this._iMaxTiles);if(this._bRtl){this._scrollTo((this._iPages-this._iCurrentPage)*c,A);}else{this._scrollTo(this._iCurrentPage*c,A);}this._updatePager();};
T.prototype._updateTilePositions=function(){var c=this._getContainerDimension();if(c.height===0){return;}if(this._getVisibleTiles().length===0){this._iPages=0;this._updatePager();return;}this._applyPageStartIndex(this._iCurrentTileStartIndex);this._applyDimension();var t=this._getVisibleTiles(),c=this._getContentDimension();this._iPages=Math.ceil(t.length/this._iMaxTiles);var o=this._oTileDimensionCalculator.getLastCalculatedDimension();for(var i=0;i<t.length;i++){if(t[i].isDragged()){continue;}var p=Math.floor(i/this._iMaxTiles),d=t[i],L=(p*c.outerwidth)+this._iOffsetX+i%this._iMaxTilesX*o.width,e=this._iOffsetY+Math.floor(i/this._iMaxTilesX)*o.height-(p*this._iMaxTilesY*o.height);if(this._bRtl){L=(this._iPages-p)*c.outerwidth-this._iOffsetX-(i%this._iMaxTilesX+1)*o.width;}d.setPos(L,e);d.setSize(o.width,o.height);}};
T.prototype._findTile=function($){if($.hasClass('sapMTile')||$.hasClass('sapMCustomTile')){return $;}else{return $.find('.sapMTile')||$.find('.sapMCustomTile');}};
T.prototype._updatePager=function(){var p=this.$("pager")[0],s=this.$("leftscroller")[0],S=this.$("rightscroller")[0];if(this._iPages>1){var H=[""];for(var i=0;i<this._iPages;i++){H.push("");}p.innerHTML=H.join("<span></span>");p.style.display="block";p.childNodes[this._iCurrentPage].className="sapMTCActive";if(sap.ui.Device.system.desktop){var c={r:this._iCurrentPage==this._iPages-1,l:this._iCurrentPage==0};if(this._bRtl){var t=c.r;c.r=c.l;c.l=t;S.style.left="auto";s.style.right="auto";}S.style.right=c.r?"-100px":"1rem";s.style.left=c.l?"-100px":"1rem";s.style.display="block";S.style.display="block";if(c.r){S.style.display="none";}if(c.l){s.style.display="none";}}}else{p.innerHTML="";S.style.right="-100px";s.style.left="-100px";s.style.display="none";S.style.display="none";}};
T.prototype._getContentDimension=function(){if(!this.getDomRef()){return;}var s=this.$("scrl");return{width:s.width(),height:s.height()-20,outerheight:s.outerHeight()-20,outerwidth:s.outerWidth()};};
T.prototype._getContainerDimension=function(){var d=this.$();if(!d){return;}return{width:d.width(),height:d.height(),outerheight:d.outerHeight(),outerwidth:d.outerWidth()};};
T.prototype._calculatePositions=function(){if(this._getVisibleTiles().length===0){return;}var c=this._getContainerDimension(),t=this._getVisibleTiles().length,p=this.$("pager")[0].offsetHeight;if(c.height===0){return;}if(sap.ui.Device.system.desktop){c.width-=45*2;}var o=this._oTileDimensionCalculator.getLastCalculatedDimension(),m=Math.max(Math.floor(c.width/o.width),1),M=Math.max(Math.floor((c.height-p)/o.height),1),n=(t<m)?t:m,N=(t/n<M)?Math.ceil(t/n):M;this._iMaxTiles=m*M;this._iMaxTilesX=m;this._iMaxTilesY=M;this._iOffsetX=Math.floor((c.width-(o.width*n))/2);if(sap.ui.Device.system.desktop){this._iOffsetX+=45;}this._iOffsetY=Math.floor((c.height-p-(o.height*N))/2);};
T.prototype._getTilesFromPosition=function(x,y){if(!this._getVisibleTiles().length){return[];}x=x+this._iScrollLeft;var t=this._getVisibleTiles(),r=[];for(var i=0;i<t.length;i++){var o=t[i],R={top:o._posY,left:o._posX,width:o._width,height:o._height};if(!t[i].isDragged()&&y>R.top&&y<R.top+R.height&&x>R.left&&x<R.left+R.width){r.push(t[i]);}}return r;};
T.prototype._applyPageStartIndex=function(i){var c=this._getContainerDimension();if(c.height===0){return;}this._calculatePositions();var L=this._getVisibleTiles().length;if(i<0){i=0;}else if(i>L-1){i=L-1;}var d=Math.floor(i/this._iMaxTiles||0);this._iCurrentTileStartIndex=d*(this._iMaxTiles||0);q.sap.log.info("current index "+this._iCurrentTileStartIndex);};
T.prototype._scrollTo=function(s,A){if(A!==false){A=true;}this._applyTranslate(this.$("cnt"),-s,0,A);if(this._bRtl){this._iScrollLeft=s-this._getContentDimension().outerwidth;}else{this._iScrollLeft=s;}};
T.prototype._applyTranslate=function(c,x,y,A){var o=c[0];this.$("cnt").toggleClass("sapMTCAnim",A);if("webkitTransform"in o.style){c.css('-webkit-transform','translate3d('+x+'px,'+y+'px,0)');}else if("MozTransform"in o.style){c.css('-moz-transform','translate('+x+'px,'+y+'px)');}else if("transform"in o.style){c.css('transform','translate3d('+x+'px,'+y+'px,0)');}else if("msTransform"in o.style){c.css('-ms-transform','translate('+x+'px,'+y+'px)');}};
T.prototype._initTouchSession=function(e){if(e.type=="touchstart"){var t=e.targetTouches[0];this._oTouchSession={dStartTime:new Date(),fStartX:t.pageX,fStartY:t.pageY,fDiffX:0,fDiffY:0,oControl:e.srcControl,iOffsetX:t.pageX-e.target.offsetLeft};}else{this._oTouchSession={dStartTime:new Date(),fStartX:e.pageX,fStartY:e.pageY,fDiffX:0,fDiffY:0,oControl:e.srcControl,iOffsetX:e.pageX-e.target.offsetLeft};}};
T.prototype._initDragSession=function(e){while(e.srcControl&&e.srcControl.getParent()!=this){e.srcControl=e.srcControl.getParent();}var i=this.indexOfAggregation("tiles",e.srcControl);if(e.type=="touchstart"){this._oDragSession={oTile:e.srcControl,oTileElement:e.srcControl.$()[0],iOffsetLeft:e.targetTouches[0].pageX-e.srcControl._posX+this._iScrollLeft,iOffsetTop:e.targetTouches[0].pageY-e.srcControl._posY,iIndex:i,iOldIndex:i,iDiffX:e.targetTouches[0].pageX,iDiffY:e.targetTouches[0].pageY};}else{this._oDragSession={oTile:e.srcControl,oTileElement:e.srcControl.$()[0],iOffsetLeft:e.pageX-e.srcControl._posX+this._iScrollLeft,iOffsetTop:e.pageY-e.srcControl._posY,iIndex:i,iOldIndex:i,iDiffX:e.pageX,iDiffY:e.pageY};}};
T.prototype.onclick=function(e){var p=this.$("pager")[0];if(e.target.id==this.getId()+"-leftscroller"||e.target.parentNode.id==this.getId()+"-leftscroller"){this.scrollLeft();}else if(e.target.id==this.getId()+"-rightscroller"||e.target.parentNode.id==this.getId()+"-rightscroller"){this.scrollRight();}else if(e.target==p&&sap.ui.Device.system.desktop){if(e.offsetX<p.offsetWidth/2){this.scrollLeft();}else{this.scrollRight();}}};
T.prototype.ontouchstart=function(e){e.setMarked();if(e.targetTouches.length>1||this._oTouchSession){return;}while(e.srcControl&&e.srcControl.getParent()!=this){e.srcControl=e.srcControl.getParent();}if(e.srcControl instanceof sap.m.Tile&&this.getEditable()){if(e.target.className!="sapMTCRemove"){this._initDragSession(e);this._initTouchSession(e);this._oDragSession.oTile.isDragged(true);}else{this._initTouchSession(e);}this._bAvoidChildTapEvent=true;}else{this._initTouchSession(e);}q(document).on("touchmove mousemove",q.proxy(this._onmove,this));q(document).on("touchend touchcancel mouseup",q.proxy(this._onend,this));};
T.prototype._onmove=function(e){if(document.selection&&document.selection.clear){document.selection.clear();}if(e.isMarked("delayedMouseEvent")){return;}if(e.targetTouches&&e.targetTouches.length>1){return;}if(!e.targetTouches){e.targetTouches=[{pageX:e.pageX,pageY:e.pageY}];}var t=this._oTouchSession;t.fDiffX=t.fStartX-e.targetTouches[0].pageX;t.fDiffY=t.fStartY-e.targetTouches[0].pageY;if(this._oDragSession){if(Math.abs(t.fDiffX)>5){if(!this._oDragSession.bStarted){this._oDragSession.bStarted=true;this._onDragStart(e);}else{this._onDrag(e);}this._bAvoidChildTapEvent=true;}}else if(t){var c=this._getContentDimension().outerwidth;var n=-this._iScrollLeft-t.fDiffX;if(n>this._iScrollGap){return;}else if(n<-(((this._iPages-1)*c)+this._iScrollGap)){return;}if(this._bRtl){n=n-c;}this._applyTranslate(this.$("cnt"),n,0,false);}};
T.prototype._onend=function(e){if(e.isMarked("delayedMouseEvent")){return;}q(document).off("touchend touchcancel mouseup",this._onend);q(document).off("touchmove mousemove",this._onmove);if(this._oDragSession){this._onDrop(e);delete this._oTouchSession;return;}if(!this._oTouchSession){return;}var t=this._oTouchSession,d=new Date(),f=(d-t.dStartTime<600),r=this._bRtl?-1:1;if(f){var p=this.$("pager")[0];if(Math.abs(t.fDiffX)>30){this._applyPageStartIndex(this._iCurrentTileStartIndex+((t.fDiffX*r>0?1:-1)*this._iMaxTiles));this._bAvoidChildTapEvent=true;}else if(e.target==p&&!sap.ui.Device.system.desktop){if((t.iOffsetX-p.offsetWidth/2)*r<0){this.scrollLeft();}else{this.scrollRight();}this._bAvoidChildTapEvent=true;}else if(e.target.className=="sapMTCRemove"){if(e.type==="touchend"||(e.type==="mouseup"&&e.button===0)){this.fireTileDelete({tile:t.oControl});}}}else{var c=this._getContentDimension();if(Math.abs(t.fDiffX)>c.outerwidth/2){this._applyPageStartIndex(this._iCurrentTileStartIndex+((t.fDiffX*r>0?1:-1)*this._iMaxTiles));this._bAvoidChildTapEvent=true;}}this._update();delete this._oDragSession;delete this._oTouchSession;var g=this;setTimeout(function(){g._bAvoidChildTapEvent=false;},100);};
T.prototype._onDragStart=function(e){this.$().append(this._oDragSession.oTileElement);this._oDragSession.iDiffX=this._oTouchSession.fStartX-this._oTouchSession.fDiffX;this._oDragSession.iDiffY=this._oTouchSession.fStartY-this._oTouchSession.fDiffY;this._oDragSession.oTile.setPos(this._oDragSession.iDiffX-this._oDragSession.iOffsetLeft,this._oDragSession.iDiffY-this._oDragSession.iOffsetTop);this.$("blind").css("display","block");};
T.prototype._onDrag=function(e){if(!this._oTouchSession){clearTimeout(this.iScrollTimer);this._oDragSession=null;this.iScrollTimer=null;this._bTriggerScroll=false;return;}this._oDragSession.iDiffX=this._oTouchSession.fStartX-this._oTouchSession.fDiffX;this._oDragSession.iDiffY=this._oTouchSession.fStartY-this._oTouchSession.fDiffY;var c=this._getContentDimension(),t=this._oDragSession.iDiffY-this._oDragSession.iOffsetTop,L=this._oDragSession.iDiffX-this._oDragSession.iOffsetLeft,m=t+(this._oDragSession.oTileElement.offsetHeight/2),i=L+(this._oDragSession.oTileElement.offsetWidth/2),s=L+this._oDragSession.oTileElement.offsetWidth-this._iTriggerScrollOffset>c.width,S=L<-this._iTriggerScrollOffset,n=c.width-(L+this._oDragSession.oTileElement.offsetWidth),N=L;this._oDragSession.oTile.setPos(L,t);this._oDragSession.oTile.$().css("clip","auto");var r=this.$("rightedge")[0];if(L+this._oDragSession.oTile._width>r.offsetLeft+r.offsetWidth&&this._iCurrentPage<this._iPages-1){var d=r.offsetLeft+r.offsetWidth-L-((this._oDragSession.oTile._width-this._oDragSession.oTile.$().outerWidth(false))/2)-2;this._oDragSession.oTile.$().css("clip","rect(-25px,"+d+"px,"+(this._oDragSession.oTile._height+20)+"px,-25px)");}var o=this.$("leftedge")[0];if(L<o.offsetLeft+2+((this._oDragSession.oTile._width-this._oDragSession.oTile.$().outerWidth(false))/2)&&this._iCurrentPage>0){var f=o.offsetLeft+4-L-((this._oDragSession.oTile._width-this._oDragSession.oTile.$().outerWidth(false))/2);this._oDragSession.oTile.$().css("clip","rect(-25px,"+this._oDragSession.oTile._width+"px,"+(this._oDragSession.oTile._height+20)+"px,"+f+"px)");}if(n<this._iEdgeShowStart&&this._iCurrentPage<this._iPages-1){var O=(this._iEdgeShowStart-n)/(this._iEdgeShowStart+this._iTriggerScrollOffset);this.$("rightedge").css("opacity",""+O);}else{this.$("rightedge").css("opacity","0.01");}if(N<this._iEdgeShowStart&&this._iCurrentPage>0){var O=(this._iEdgeShowStart-N)/(this._iEdgeShowStart+this._iTriggerScrollOffset);this.$("leftedge").css("opacity",""+O);}else{this.$("leftedge").css("opacity","0.01");}var g;if(this._bRtl){g=s&&this._iCurrentPage>0||S&&this._iCurrentPage<this._iPages-1;}else{g=S&&this._iCurrentPage>0||s&&this._iCurrentPage<this._iPages-1;}if(g){if(this._bTriggerScroll){S?this.scrollLeft():this.scrollRight();}else{var j=this;if(!this.iScrollTimer){this.iScrollTimer=setInterval(function(){j._bTriggerScroll=true;j._onDrag(e);j._bTriggerScroll=false;},1000);}}return;}else{if(this.iScrollTimer){clearTimeout(this.iScrollTimer);this._bTriggerScroll=false;this.iScrollTimer=null;}}var H=this._getTilesFromPosition(i,m);if(H&&H.length>0){var k=H[0],R={top:k._posY,left:k._posX,width:k._width,height:k._height};var p=this.indexOfAggregation("tiles",k);if(i+this._iScrollLeft<((R.left+R.width)/2)&&(p%this._iMaxTilesX)!=0){p--;}this._oDragSession.iIndex=p;this.moveTile(this._oDragSession.oTile,this._oDragSession.iIndex);}else if(this._iCurrentPage==this._iPages-1){var u=this._getVisibleTiles(),v=u[u.length-1];if(v&&i>v._posX-this._iScrollLeft&&m>v._posY){this._oDragSession.iIndex=u.length-1;this.moveTile(this._oDragSession.oTile,this._oDragSession.iIndex);}}};
T.prototype._onDrop=function(e){if(this._oDragSession){var t=this._oDragSession.oTile,i=this._oDragSession.iIndex;this._oDragSession.oTile.isDragged(false);if(this._oDragSession.iOldIndex!=this._oDragSession.iIndex){this.fireTileMove({tile:t,newIndex:i});}this.$("blind").css("display","block");if(this._oDragSession.bStarted){this._oDragSession.oTile.setPos(this._oDragSession.oTile._posX+this._iScrollLeft,this._oDragSession.oTile._posY);}this._oDragSession.oTile.$().css("clip","auto");this.$("rightedge").css("opacity","0.01");this.$("leftedge").css("opacity","0.01");this.$("cnt").append(this._oDragSession.oTileElement);delete this._oDragSession;this.moveTile(t,i);this.scrollIntoView(t,false);if(sap.ui.Device.system.desktop||sap.ui.Device.system.combi){this._findTile(t.$()).focus();}this._handleAriaActiveDescendant();this.$("blind").css("display","none");}};
T.prototype._handleAriaActiveDescendant=function(){var A=q(document.activeElement).control(0);if(A instanceof sap.m.Tile&&A.getParent()===this){this.getDomRef().setAttribute("aria-activedescendant",A.getId());}};
T.prototype.onThemeChanged=function(){if(this.getDomRef()){this.invalidate();}};
var a=function(t){this._oDimension=null;this._oTileContainer=t;};
a.prototype.calc=function(){var v,t;if(!this._oTileContainer.getDomRef()){return;}if(this._oTileContainer._getVisibleTiles().length){v=this._oTileContainer._getVisibleTiles();if(v.length){t=v[0];this._oDimension={width:Math.round(t.$().outerWidth(true)),height:Math.round(t.$().outerHeight(true))};}}return this._oDimension;};
a.prototype.getLastCalculatedDimension=function(){return this._oDimension;};
function h(){var t=this._getVisibleTiles().length,d=null;this._getVisibleTiles().forEach(function(o){d=o.getDomRef();if(d){d.setAttribute("aria-setsize",t);}});}
function b(s,e){var t=this._getVisibleTiles(),i,o=null;for(var i=s;i<e;i++){o=t[i];if(o){o._updateAriaPosition();}}}
T.prototype._getVisibleTiles=function(){return this.getTiles().filter(function(t){return t.getVisible();});};
return T;},true);
sap.ui.predefine('sap/m/TileContainerRenderer',['jquery.sap.global'],function(q){"use strict";var T={};
T.render=function(r,c){var a=c.getId();r.write("<div tabindex=\"-1\"");r.writeControlData(c);r.addStyle("height",c.getHeight());r.addStyle("width",c.getWidth());r.writeStyles();r.addClass("sapMTC");r.addClass("sapContrastPlus");r.writeClasses();r.writeAccessibilityState(c,{role:"listbox",multiSelectable:false,activeDescendant:c.getTiles().length>0?c.getTiles()[0].getId():""});r.write(" >");r.write("<div id=\""+a+"-scrl\" class=\"sapMTCScrl\" style=\"height:0px;");if(!c.bRtl){r.write(" overflow: hidden;");}r.write("\">");r.write("<div id=\""+a+"-blind\" class=\"sapMTCBlind\"></div>");r.write("<div id=\""+a+"-cnt\" class=\"sapMTCCnt sapMTCAnim\" style=\"height:0px; width:0px;\" role=\"group\">");var t=c.getTiles();for(var i=0;i<t.length;i++){t[i]._setVisible(false);r.renderControl(t[i]);}r.write("</div>");r.write("</div>");r.write("<div id=\""+a+"-pager\" class=\"sapMTCPager\">");r.write("</div>");r.write("<div id=\""+a+"-leftedge\" class=\"sapMTCEdgeLeft\"></div>");r.write("<div id=\""+a+"-rightedge\" class=\"sapMTCEdgeRight\"></div>");r.write("<div id=\""+a+"-leftscroller\" class=\"sapMTCScroller sapMTCLeft\" tabindex=\"-1\"><div class=\"sapMTCInner\" ></div></div>");r.write("<div id=\""+a+"-rightscroller\" class=\"sapMTCScroller sapMTCRight\" tabindex=\"-1\"><div class=\"sapMTCInner\" ></div></div>");r.write("</div>");};
return T;},true);
sap.ui.predefine('sap/m/TileContent',['jquery.sap.global','./library','sap/ui/core/Control'],function(q,l,C){"use strict";
var T=C.extend("sap.m.TileContent",{metadata:{library:"sap.m",properties:{"footer":{type:"string",group:"Appearance",defaultValue:null},"size":{type:"sap.m.Size",group:"Misc",defaultValue:"Auto"},"unit":{type:"string",group:"Misc",defaultValue:null},"disabled":{type:"boolean",group:"Misc",defaultValue:false},"frameType":{type:"sap.m.FrameType",group:"Appearance",defaultValue:sap.m.FrameType.Auto}},aggregations:{"content":{type:"sap.ui.core.Control",multiple:false}}}});
T.prototype.init=function(){this._bRenderFooter=true;};
T.prototype.onBeforeRendering=function(){if(this.getContent()&&this._oDelegate){if(this.getDisabled()){this.getContent().addDelegate(this._oDelegate);}else{this.getContent().removeDelegate(this._oDelegate);}}};
T.prototype.onAfterRendering=function(){var c=this.getContent();if(c){var t=this.$();if(!t.attr("title")){var s=c.getTooltip_AsString();var a=t.find("*");a.removeAttr("title");if(s&&s.trim().length!==0){if(this._getFooterText().trim()!==0){s=s+"\n"+this._getFooterText();}t.attr("title",s);}}}};
T.prototype._getContentType=function(){if(this.getContent()){var c=this.getContent().getMetadata().getName();if(c==="sap.m.NewsContent"||c==="sap.suite.ui.commons.NewsContent"){return"News";}}};
T.prototype._getFooterText=function(){var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');var f=this.getFooter();var u=this.getUnit();if(u){if(f){if(sap.ui.getCore().getConfiguration().getRTL()){return r.getText('TILECONTENT_FOOTER_TEXT',[f,u]);}else{return r.getText('TILECONTENT_FOOTER_TEXT',[u,f]);}}else{return u;}}else{return f;}};
sap.m.TileContent.prototype.getAltText=function(){var a="";var i=true;var c=this.getContent();if(c){if(c.getAltText){a+=c.getAltText();i=false;}else if(c.getTooltip_AsString()){a+=c.getTooltip_AsString();i=false;}}if(this.getUnit()){a+=(i?"":"\n")+this.getUnit();i=false;}if(this.getFooter()){a+=(i?"":"\n")+this.getFooter();}return a;};
T.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var a="";if(typeof t==="string"||t instanceof String){return t;}a=this.getAltText();return a?a:"";};
T.prototype.setRenderFooter=function(v){this._bRenderFooter=v;return this;};
return T;},true);
sap.ui.predefine('sap/m/TileContentRenderer',['jquery.sap.global','sap/ui/core/Renderer'],function(q,R){"use strict";var T={};
T.render=function(r,c){var t=c.getTooltip_AsString();r.write("<div");r.writeControlData(c);r.addClass("sapMTileCnt");r.addClass(c._getContentType());r.addClass("ft-"+c.getFrameType());if(t.trim()){r.writeAttributeEscaped("title",t);}r.writeClasses();r.write(">");this._renderContent(r,c);this._renderFooter(r,c);r.write("</div>");};
T._renderContent=function(r,c){var C=c.getContent();if(C){r.write("<div");r.addClass("sapMTileCntContent");r.writeClasses();r.writeAttribute("id",c.getId()+"-content");r.write(">");if(!C.hasStyleClass("sapMTcInnerMarker")){C.addStyleClass("sapMTcInnerMarker");}r.renderControl(C);r.write("</div>");}};
T._renderFooter=function(r,c){if(!c._bRenderFooter){return;}var t=c.getTooltip_AsString();var f=c._getFooterText(r,c);r.write("<div");r.addClass("sapMTileCntFtrTxt");r.writeClasses();r.writeAttribute("id",c.getId()+"-footer-text");if(t.trim()){r.writeAttributeEscaped("title",t);}r.write(">");r.writeEscaped(f);r.write("</div>");};
return T;},true);
sap.ui.predefine('sap/m/TileRenderer',['jquery.sap.global','sap/ui/core/Renderer'],function(q,R){"use strict";var T={};
T.render=function(r,c){r.write("<div tabindex=\"0\"");r.writeControlData(c);r.addClass("sapMTile");r.addClass("sapMPointer");r.addClass("sapContrastPlus");r.writeClasses();if(c._invisible){r.addStyle("visibility","hidden");r.writeStyles();}var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}if(c.getParent()instanceof sap.m.TileContainer){r.writeAccessibilityState(c,{role:"option",posinset:c._getTileIndex(),setsize:c._getTilesCount()});}r.write(">");if(c.getRemovable()){r.write("<div id=\""+c.getId()+"-remove\" class=\"sapMTCRemove\"></div>");}else{r.write("<div id=\""+c.getId()+"-remove\" class=\"sapMTCNoRemove\"></div>");}r.write("<div class=\"sapMTileContent\">");this._renderContent(r,c);r.write("</div></div>");};
T._renderContent=function(r,c){};
return T;},true);
sap.ui.predefine('sap/m/TimePicker',['jquery.sap.global','./InputBase','./MaskInput','./MaskInputRule','./ResponsivePopover','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/model/type/Time','./TimePickerSliders'],function(q,I,M,a,R,E,b,T,c){"use strict";
var d=M.extend("sap.m.TimePicker",{metadata:{library:"sap.m",properties:{displayFormat:{type:"string",group:"Appearance",defaultValue:null},valueFormat:{type:"string",group:"Data",defaultValue:null},localeId:{type:"string",group:"Data"},dateValue:{type:"object",group:"Data",defaultValue:null},title:{type:"string",group:"Misc",defaultValue:null},minutesStep:{type:"int",group:"Misc",defaultValue:1},secondsStep:{type:"int",group:"Misc",defaultValue:1}},aggregations:{_picker:{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"}}}});
b.insertFontFaceStyle();E.call(d.prototype,true);var e={Short:"short",Medium:"medium",Long:"long"},f={Hour:"hour",Minute:"minute",Second:"second"},P='-';
d.prototype.init=function(){M.prototype.init.apply(this,arguments);this.setDisplayFormat(h());this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._bValid=false;this._sUsedDisplayPattern=null;this._sUsedValuePattern=null;this._oDisplayFormat=null;this._sValueFormat=null;this._oPopoverKeydownEventDelegate=null;this._rPlaceholderRegEx=new RegExp(P,'g');this._sLastChangeValue=null;};
d.prototype.exit=function(){if(this._oTimeSemanticMaskHelper){this._oTimeSemanticMaskHelper.destroy();}M.prototype.exit.apply(this,arguments);this._removePickerEvents();this._oResourceBundle=null;this._bValid=false;this._sUsedDisplayPattern=null;this._oDisplayFormat=null;this._oPopoverKeydownEventDelegate=null;this._sUsedValuePattern=null;this._sValueFormat=null;this._sLastChangeValue=null;};
d.prototype.onBeforeRendering=function(){M.prototype.onBeforeRendering.apply(this,arguments);};
d.prototype.ontap=function(o){var i,p;if(!(this.getEditable()&&this.getEnabled())){return;}i=q(o.target).hasClass("sapUiIcon");p=this._getPicker()&&this._getPicker().isOpen();if(!p&&i){this._openPicker();}else if(i&&!sap.ui.Device.system.phone){this._closePicker();}};
d.prototype.onfocusin=function(o){var p=this._getPicker();var i=q(o.target).hasClass("sapUiIcon");M.prototype.onfocusin.apply(this,arguments);if(p&&p.isOpen()&&!i){this._closePicker();}};
d.prototype.oninput=function(o){M.prototype.oninput.apply(this,arguments);};
d.prototype.onfocusout=function(o){M.prototype.onfocusout.apply(this,arguments);};
d.prototype.onBeforeOpen=function(){var s=this._getSliders();s.setTimeValues(this.getDateValue());s.collapseAll();this.$().addClass("sapMTPInputActive");};
d.prototype.onAfterOpen=function(){var s=this._getSliders();if(s){s._initFocus();this._handleAriaOnExpandCollapse();}};
d.prototype.onAfterClose=function(){this.$().removeClass("sapMTPInputActive");this._handleAriaOnExpandCollapse();};
d.prototype._handleInputChange=function(v){var D;v=v||this._$input.val();this._bValid=true;if(v!==""){D=this._parseValue(v,true);if(!D){this._bValid=false;}else{v=this._formatValue(D);}}if(this.isActive()&&(this._$input.val()!==v)){this.updateDomValue(v);if(this.bShowLabelAsPlaceholder){this.$("placeholder").css("display",v?"none":"inline");}}if(D){v=this._formatValue(D,true);}this.setProperty("value",v,true);if(this._bValid){this.setProperty("dateValue",D,true);}this.fireChangeEvent(v,{valid:this._bValid});return true;};
d.prototype.onChange=function(o){var v=o?o.value:null;if(this.getEditable()&&this.getEnabled()){return this._handleInputChange(v);}return false;};
d.prototype.setMinutesStep=function(s){var S=this._getSliders();if(S){S.setMinutesStep(s);}return this.setProperty("minutesStep",s,true);};
d.prototype.setSecondsStep=function(s){var S=this._getSliders();if(S){S.setSecondsStep(s);}return this.setProperty("secondsStep",s,true);};
d.prototype.setTitle=function(t){var s=this._getSliders();if(s){s.setLabelText(t);}this.setProperty("title",t,true);return this;};
d.prototype.setValueFormat=function(v){var V=this.getValue(),D;this.setProperty("valueFormat",v,true);if(V){D=this._parseValue(V);if(!D){this._bValid=false;q.sap.log.warning("Value can not be converted to a valid date",this);}else{this._bValid=true;this.setProperty("dateValue",D,true);V=this._formatValue(D);if(this.isActive()){this._synchronizeInput(V);}else{this.setProperty("value",V,true);this._sLastChangeValue=V;}}}return this;};
d.prototype.setDisplayFormat=function(D){var o,i;this.setProperty("displayFormat",D,true);this._initMask();i=this.getDateValue();if(!i){return this;}o=this._formatValue(i);if(this.isActive()){this._synchronizeInput(o);}return this;};
d.prototype.setValue=function(v){var D,o;v=this.validateProperty('value',v);this._initMask();M.prototype.setValue.call(this,v);this._sLastChangeValue=v;this._bValid=true;if(v){D=this._parseValue(v);if(!D){this._bValid=false;q.sap.log.warning("Value can not be converted to a valid date",this);}}if(this._bValid){this.setProperty("dateValue",D,true);}if(D){o=this._formatValue(D);}else{o=v;}if(this.isActive()){this._synchronizeInput(o);}return this;};
d.prototype.setDateValue=function(D){var v;if(D&&!(D instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}if(q.sap.equal(this.getDateValue(),D)){return this;}this._bValid=true;this.setProperty("dateValue",D,true);v=this._formatValue(D,true);this.setProperty("value",v,true);this._sLastChangeValue=v;if(this.isActive()){v=this._formatValue(D);if(this._$input.val()!==v){this.updateDomValue(v);}}return this;};
d.prototype.setLocaleId=function(l){var C=this.getValue();this.setProperty("localeId",l,true);this._initMask();this._oDisplayFormat=null;this._sValueFormat=null;if(C){this.setValue(C);}return this;};
d.prototype.getPlaceholder=function(){var p=this.getProperty("placeholder");if(!p){p=this._getFormat();}return p;};
d.prototype._getFormat=function(){var F=this._getDisplayFormatPattern();if(!F){F=e.Medium;}if(Object.keys(e).indexOf(F)!==-1){F=h();}return F;};
d.prototype.onsappageup=function(o){this._increaseTime(1,f.Hour);o.preventDefault();};
d.prototype.onsappageupmodifiers=function(o){if(!(o.ctrlKey||o.metaKey||o.altKey)&&o.shiftKey){this._increaseTime(1,f.Minute);}if(!o.altKey&&o.shiftKey&&(o.ctrlKey||o.metaKey)){this._increaseTime(1,f.Second);}o.preventDefault();};
d.prototype.onsappagedown=function(o){this._increaseTime(-1,f.Hour);o.preventDefault();};
d.prototype.onsappagedownmodifiers=function(o){if(!(o.ctrlKey||o.metaKey||o.altKey)&&o.shiftKey){this._increaseTime(-1,f.Minute);}if(!o.altKey&&o.shiftKey&&(o.ctrlKey||o.metaKey)){this._increaseTime(-1,f.Second);}o.preventDefault();};
d.prototype.onkeydown=function(o){var k=q.sap.KeyCodes,K=o.which||o.keyCode,A=o.altKey,p;if(K===k.F4||(A&&(K===k.ARROW_UP||K===k.ARROW_DOWN))){p=this._getPicker()&&this._getPicker().isOpen();if(!p){this._openPicker();}else{this._closePicker();}o.preventDefault();}else{M.prototype.onkeydown.call(this,o);}};
d.prototype._getPicker=function(){return this.getAggregation("_picker");};
d.prototype._removePickerEvents=function(){var p,o=this._getPicker();if(o){p=o.getAggregation("_popup");if(typeof this._oPopoverKeydownEventDelegate==='function'){p.removeEventDelegate(this._oPopoverKeydownEventDelegate);}}};
d.prototype._openPicker=function(){var p=this._getPicker(),s;if(!p){p=this._createPicker(this._getDisplayFormatPattern());}p.open();s=this._getSliders();q.sap.delayedCall(0,s,s.updateSlidersValues);return p;};
d.prototype._closePicker=function(){var p=this._getPicker();if(p){p.close();}else{q.sap.log.warning("There is no picker to close.");}return p;};
d.prototype._synchronizeInput=function(v){if((this._$input.val()!==v)){this.updateDomValue(v);}};
d.prototype._createPicker=function(F){var t=this,p,o,r,O,C,s;r=sap.ui.getCore().getLibraryResourceBundle("sap.m");O=r.getText("TIMEPICKER_SET");C=r.getText("TIMEPICKER_CANCEL");s=this.getTitle();o=new R(t.getId()+"-RP",{showCloseButton:false,showHeader:false,horizontalScrolling:false,verticalScrolling:false,placement:sap.m.PlacementType.VerticalPreferedBottom,beginButton:new sap.m.Button({text:O,press:q.proxy(this._handleOkPress,this)}),endButton:new sap.m.Button({text:C,press:q.proxy(this._handleCancelPress,this)}),content:[new c(this.getId()+"-sliders",{format:F,labelText:s?s:"",invokedBy:t.getId(),minutesStep:this.getMinutesStep(),secondsStep:this.getSecondsStep()})],contentHeight:d._PICKER_CONTENT_HEIGHT});p=o.getAggregation("_popup");if(p.setShowArrow){p.setShowArrow(false);}p.oPopup.setAutoCloseAreas([this.getDomRef("icon")]);o.addStyleClass(this.getRenderer().CSS_CLASS+"DropDown").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachAfterClose(this.onAfterClose,this);o.open=function(){return this.openBy(t);};if(sap.ui.Device.system.desktop){this._oPopoverKeydownEventDelegate={onkeydown:function(i){var k=q.sap.KeyCodes,K=i.which||i.keyCode,A=i.altKey;if((A&&(K===k.ARROW_UP||K===k.ARROW_DOWN))||K===k.F4){this._handleOkPress(i);this.focus();i.preventDefault();}}};p.addEventDelegate(this._oPopoverKeydownEventDelegate,this);p._afterAdjustPositionAndArrowHook=function(){t._getSliders()._onOrientationChanged();};}this.setAggregation("_picker",o,true);return o;};
d.prototype._getSliders=function(){var p=this._getPicker();if(!p){return null;}return p.getContent()[0];};
d.prototype._handleOkPress=function(o){var D=this._getSliders().getTimeValues(),v=this._formatValue(D);this.updateDomValue(v);this._handleInputChange();this._closePicker();};
d.prototype._handleCancelPress=function(o){this._closePicker();};
d.prototype._parseValue=function(v,D){var F=this._getFormatter(D);if(D){v=this._oTimeSemanticMaskHelper.stripValueOfLeadingSpaces(v);v=v.replace(this._rPlaceholderRegEx,'');}return F.parse(v);};
d.prototype._formatValue=function(D,v){var V="",F;if(D){F=this._getFormatter(!v);V=F.format(D);if(!v&&this._oTimeSemanticMaskHelper){V=this._oTimeSemanticMaskHelper.formatValueWithLeadingTrailingSpaces(V);}}return V;};
d.prototype._handleAriaOnExpandCollapse=function(){this.getFocusDomRef().setAttribute("aria-expanded",this._getPicker().isOpen());};
d.prototype._increaseTime=function(n,u){var o=this.getDateValue(),D,m;if(o&&this.getEditable()&&this.getEnabled()){D=new Date(o.getTime());switch(u){case f.Hour:D.setHours(D.getHours()+n);m=60*60*1000;break;case f.Minute:D.setMinutes(D.getMinutes()+n);m=60*1000;break;case f.Second:m=1000;D.setSeconds(D.getSeconds()+n);}if(n<0&&D.getTime()-o.getTime()!==n*m){D=new Date(o.getTime()+n*m);}this.setDateValue(D);this.fireChangeEvent(this.getValue(),{valid:true});}};
d.prototype._getFormatter=function(D){var p="",r=false,F,B=this.getBinding("value");if(B&&B.oType&&(B.oType instanceof T)){p=B.oType.getOutputPattern();r=!!B.oType.oOutputFormat.oFormatOptions.relative;}if(!p){if(D){p=(this.getDisplayFormat()||e.Medium);}else{p=(this.getValueFormat()||e.Medium);}}if(D){if(p===this._sUsedDisplayPattern){F=this._oDisplayFormat;}}else{if(p===this._sUsedValuePattern){F=this._sValueFormat;}}if(F){return F;}if(p===e.Short||p===e.Medium||p===e.Long){F=sap.ui.core.format.DateFormat.getTimeInstance({style:p,strictParsing:true,relative:r},new sap.ui.core.Locale(this.getLocaleId()));}else{F=sap.ui.core.format.DateFormat.getTimeInstance({pattern:p,strictParsing:true,relative:r},new sap.ui.core.Locale(this.getLocaleId()));}if(D){this._sUsedDisplayPattern=p;this._oDisplayFormat=F;}else{this._sUsedValuePattern=p;this._sValueFormat=F;}return F;};
d.prototype._initMask=function(){this._oTimeSemanticMaskHelper=new g(this);};
d.prototype.fireChangeEvent=function(v,p){if(v){v=v.trim();}if(v!==this._sLastChangeValue){this._sLastChangeValue=v;I.prototype.fireChangeEvent.call(this,v,p);}};
var g=function(t){var D=t._getDisplayFormatPattern(),m=D,A,l=t.getLocaleId()||sap.ui.getCore().getConfiguration().getFormatLocale(),L=new sap.ui.core.Locale(l),i;t.setProperty("localeId",l,true);this._oTimePicker=t;this.aOriginalAmPmValues=sap.ui.core.LocaleData.getInstance(L).getDayPeriods("abbreviated");this.aAmPmValues=this.aOriginalAmPmValues.slice(0);this.iAmPmValueMaxLength=Math.max(this.aAmPmValues[0].length,this.aAmPmValues[1].length);for(i=0;i<this.aAmPmValues.length;i++){while(this.aAmPmValues[i].length<this.iAmPmValueMaxLength){this.aAmPmValues[i]+=" ";}}this.b24H=D.indexOf("H")!==-1;this.bLeadingZero=D.indexOf("HH")!==-1||D.indexOf("hh")!==-1;this.sLeadingChar=this.bLeadingZero?"0":" ";this.sAlternativeLeadingChar=this.bLeadingZero?" ":"0";this.sLeadingRegexChar=this.bLeadingZero?"0":"\\s";t.setPlaceholderSymbol(P);m=m.replace(/hh/ig,"h").replace(/h/ig,"h9");if(this.b24H){A="["+this.sLeadingRegexChar+"012]";}else{A="["+this.sLeadingRegexChar+"1]";}this._maskRuleHours=new a({maskFormatSymbol:"h",regex:A});t.addRule(this._maskRuleHours);this.iHourNumber1Index=m.indexOf("h9");this.iHourNumber2Index=this.iHourNumber1Index!==-1?this.iHourNumber1Index+1:-1;this.iMinuteNumber1Index=m.indexOf("mm");m=m.replace(/mm/g,"59");this.iSecondNumber1Index=m.indexOf("ss");m=m.replace(/ss/g,"59");this._maskRuleMinSec=new a({maskFormatSymbol:"5",regex:"[0-5]"});t.addRule(this._maskRuleMinSec);this.aAllowedHours=p.call(this,this.b24H,this.sLeadingChar);this.aAllowedMinutesAndSeconds=r.call(this);this.iAmPmChar1Index=m.indexOf("a");this.iAfterAmPmValueIndex=-1;if(this.iAmPmChar1Index!==-1){this.iAfterAmPmValueIndex=this.iAmPmChar1Index+this.iAmPmValueMaxLength;var C=this.iAmPmValueMaxLength-"a".length;this.shiftIndexes(C);var j=65;var s="";var k="";var n="";for(i=0;i<this.iAmPmValueMaxLength;i++){k="[";if(this.aAmPmValues[0][i]){k+=this.aAmPmValues[0][i];}else{k+="\\s";}if(this.aAmPmValues[1][i]!==this.aAmPmValues[0][i]){if(this.aAmPmValues[1][i]){k+=this.aAmPmValues[1][i];}else{k+="\\s";}}k+="]";n=String.fromCharCode(j++);s+=n;this._maskRuleChars=new a({maskFormatSymbol:n,regex:k});t.addRule(this._maskRuleChars);}m=m.replace(/a/g,s);}t.setMask(m);function o(S,u,v){var w=[],x,i;for(i=S;i<=u;i++){x=i.toString();if(i<10){x=v+x;}w.push(x);}return w;}function p(u,v){var S=u?0:1,w=u?23:12;return o(S,w,v);}function r(){return o(0,59,"0");}};
g.prototype.replaceChar=function(C,p,s){var A=p-this.iAmPmChar1Index,j,k,l,S,m,n,i;if(p===this.iHourNumber1Index&&this.sAlternativeLeadingChar===C){if(this.aAllowedHours.indexOf(this.sLeadingChar+C)!==-1){return this.sLeadingChar+C;}else{return this.sLeadingChar;}}else if(p===this.iHourNumber1Index&&!this._oTimePicker._isCharAllowed(C,p)&&this.aAllowedHours.indexOf(this.sLeadingChar+C)!==-1){return this.sLeadingChar+C;}else if(p===this.iHourNumber2Index&&this.aAllowedHours.indexOf(s[this.iHourNumber1Index]+C)===-1){return"";}else if((p===this.iMinuteNumber1Index||p===this.iSecondNumber1Index)&&!this._oTimePicker._isCharAllowed(C,p)&&this.aAllowedMinutesAndSeconds.indexOf("0"+C)!==-1){return"0"+C;}else if(A>=0&&p<this.iAfterAmPmValueIndex){j=s.slice(this.iAmPmChar1Index,p);k=this.aAmPmValues[0].slice(0,A);l=this.aAmPmValues[1].slice(0,A);m=this.aAmPmValues[0].slice(A,this.iAfterAmPmValueIndex);n=this.aAmPmValues[1].slice(A,this.iAfterAmPmValueIndex);S=(k===l);var o="";for(i=A;i<this.iAmPmValueMaxLength;i++){if(this.aAmPmValues[0][i]===this.aAmPmValues[1][i]){o+=this.aAmPmValues[0][i];}else{break;}}if(i===this.iAmPmValueMaxLength||i!==A){return o;}else{if(!S){if(j===k){return m;}else if(j===l){return n;}else{return C;}}else{if(this.aAmPmValues[0][A].toLowerCase()===C.toLowerCase()&&this.aAmPmValues[0]===j+m){return m;}else if(this.aAmPmValues[1][A].toLowerCase()===C.toLowerCase()&&this.aAmPmValues[1]===j+n){return n;}else{return C;}}}}else{return C;}};
g.prototype.formatValueWithLeadingTrailingSpaces=function(v){var m=this._oTimePicker.getMask().length;if(this.aOriginalAmPmValues[0]!==this.aAmPmValues[0]){v=v.replace(this.aOriginalAmPmValues[0],this.aAmPmValues[0]);}if(this.aOriginalAmPmValues[1]!==this.aAmPmValues[1]){v=v.replace(this.aOriginalAmPmValues[1],this.aAmPmValues[1]);}while(m>v.length){v=[v.slice(0,this.iHourNumber1Index)," ",v.slice(this.iHourNumber1Index)].join('');}return v;};
g.prototype.stripValueOfLeadingSpaces=function(v){if(v[this.iHourNumber1Index]===" "){v=[v.slice(0,this.iHourNumber1Index),v.slice(this.iHourNumber1Index+1)].join('');}return v;};
g.prototype.shiftIndexes=function(s){if(this.iAmPmChar1Index<this.iHourNumber1Index){this.iHourNumber1Index+=s;this.iHourNumber2Index+=s;}if(this.iAmPmChar1Index<this.iMinuteNumber1Index){this.iMinuteNumber1Index+=s;}if(this.iAmPmChar1Index<this.iSecondNumber1Index){this.iSecondNumber1Index+=s;}};
g.prototype.destroy=function(){if(this._maskRuleHours){this._maskRuleHours.destroy();this._maskRuleHours=null;}if(this._maskRuleMinSec){this._maskRuleMinSec.destroy();this._maskRuleMinSec=null;}if(this._maskRuleChars){this._maskRuleChars.destroy();this._maskRuleChars=null;}};
d.prototype._feedReplaceChar=function(C,p,s){return this._oTimeSemanticMaskHelper.replaceChar(C,p,s);};
d.prototype.getAccessibilityInfo=function(){var r=this.getRenderer();var i=M.prototype.getAccessibilityInfo.apply(this,arguments);var v=this.getValue()||"";if(this._bValid){var D=this.getDateValue();if(D){v=this._formatValue(D);}}i.role="combobox";i.type=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_TIMEINPUT");i.description=[v,r.getLabelledByAnnouncement(this),r.getDescribedByAnnouncement(this)].join(" ").trim();return i;};
function h(){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),L=sap.ui.core.LocaleData.getInstance(l);return L.getTimePattern(e.Medium);}
d.prototype._getDisplayFormatPattern=function(){var B=this.getBinding("value");if(B&&B.oType&&(B.oType instanceof T)){return B.oType.getOutputPattern();}return this.getDisplayFormat();};
d._PICKER_CONTENT_HEIGHT="25rem";return d;},true);
sap.ui.predefine('sap/m/TimePickerRenderer',['jquery.sap.global','sap/ui/core/Renderer','./InputBaseRenderer','sap/ui/core/ValueStateSupport','sap/ui/core/LabelEnablement'],function(q,R,I,V,L){"use strict";var T=R.extend(I);T.CSS_CLASS="sapMTimePicker";var a="sapMInputVH",b="sapMInputValHelpInner",c="sapMInputValHelp";
T.addOuterClasses=function(r,C){r.addClass(T.CSS_CLASS);if(C.getEnabled()&&C.getEditable()){r.addClass(a);}};
T.writeInnerContent=function(r,C){var d,A,o,t="",s;if(C.getEnabled()&&C.getEditable()){d=[b];A={};A.id=C.getId()+"-icon";A.tabindex="-1";A.title=null;r.write('<div class="'+c+'">');r.writeIcon("sap-icon://time-entry-request",d,A);r.write("</div>");}o=C._oResourceBundle;if(!C.getProperty("placeholder")&&this._hasLabelReferencing(C)){t=o.getText("TIMEPICKER_WITH_PH_SCREENREADER_TAG",C._getFormat());}else{t=o.getText("TIMEPICKER_SCREENREADER_TAG");}s=V.enrichTooltip(C,C.getTooltip_AsString());if(s){t=s+". "+t;}r.write('<span id="'+C.getId()+'-descr" style="visibility: hidden; display: none;">');r.writeEscaped(t);r.write('</span>');};
T.writeInnerValue=function(r,C){r.writeAttributeEscaped("value",C._formatValue(C.getDateValue()));};
T.writeAccessibilityState=function(r,C){var A=this.getAriaLabelledBy(C),p={role:"combobox",multiline:false,autocomplete:"none",expanded:false,haspopup:true,owns:C.getId()+"-sliders",describedby:{value:C.getId()+"-descr",append:true}};if(A&&this._hasLabelReferencing(C)&&C.getProperty("placeholder")){p.labelledby={value:A.trim(),append:true};}if(C.getValueState()==sap.ui.core.ValueState.Error){p.invalid=true;}r.writeAccessibilityState(C,p);};
T.renderAriaLabelledBy=function(r,C){if(this._hasLabelReferencing(C)&&C.getProperty("placeholder")){I.renderAriaLabelledBy(r,C);}};
T._hasLabelReferencing=function(C){return L.getReferencingLabels(C).length>0;};
return T;},true);
sap.ui.predefine('sap/m/TimePickerSlider',['jquery.sap.global','sap/ui/core/Control','./TimePickerSliderRenderer','sap/ui/core/IconPool'],function(q,C,T,I){"use strict";
var a=C.extend("sap.m.TimePickerSlider",{
metadata:{library:"sap.m",properties:{selectedValue:{type:"string",defaultValue:null},isCyclic:{type:"boolean",defaultValue:true},label:{type:"string",defaultValue:null},isExpanded:{type:"boolean",defaultValue:false}},aggregations:{items:{type:"sap.m.VisibleItem",multiple:true,singularName:"item"},_arrowUp:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_arrowDown:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{expanded:{}}},
renderer:T.render
});
var S=sap.ui.getCore().getConfiguration().getAnimation()?200:0;var M=50;
a.prototype.init=function(){this._bIsDrag=null;this._selectionOffset=0;this._mousedown=false;this._dragSession=null;this._iSelectedItemIndex=-1;this._animatingSnap=false;this._iSelectedIndex=-1;this._animating=false;this._intervalId=null;this._maxScrollTop=null;this._minScrollTop=null;this._marginTop=null;this._marginBottom=null;this._bOneTimeValueSelectionAnimation=false;if(sap.ui.Device.system.desktop){this._fnHandleTypeValues=t.call(this);}this._initArrows();};
a.prototype.onAfterRendering=function(){if(sap.ui.Device.system.phone){q.sap.delayedCall(0,this,this._afterExpandCollapse);}else{this._afterExpandCollapse();}this._attachEvents();};
a.prototype.onThemeChanged=function(e){this.invalidate();};
a.prototype.fireTap=function(e){var s,i,g;if(!this.getIsExpanded()){if(sap.ui.Device.system.desktop){this.focus();}else{this.setIsExpanded(true);}}else{s=e.srcElement||e.originalTarget;if(s&&s.tagName.toLowerCase()==="li"){i=q(s).text();g=F.call(this,i);this._bOneTimeValueSelectionAnimation=true;this.setSelectedValue(g);}else{this._addSelectionStyle();this.focus();}}};
a.prototype.setSelectedValue=function(v){var i=b(this._getVisibleItems(),function(E){return E.getKey()===v;}),e=this,g,s,h,j;if(i===-1){return this;}if(this.getDomRef()){s=this._getSliderContainerDomRef();h=this._getItemHeightInPx();j=this._getContentRepeat();if(i*h>=this._selectionOffset){g=this._getVisibleItems().length*Math.floor(j/2)+i;}else{g=this._getVisibleItems().length*Math.ceil(j/2)+i;}if(this._bOneTimeValueSelectionAnimation){this._animatingSnap=true;s.animate({scrollTop:g*h-this._selectionOffset},S,'linear',function(){s.clearQueue();e._animatingSnap=false;e._bOneTimeValueSelectionAnimation=false;});}else{s.scrollTop(g*h-this._selectionOffset);}this._removeSelectionStyle();this._iSelectedItemIndex=g;this._addSelectionStyle();}return this.setProperty("selectedValue",v,true);};
a.prototype.setIsExpanded=function(v,s){this.setProperty("isExpanded",v,true);if(!this.getDomRef()){return this;}var $=this.$();if(v){$.addClass("sapMTPSliderExpanded");if(sap.ui.Device.system.phone){q.sap.delayedCall(0,this,function(){this._updateDynamicLayout(v);if(!s){this.fireExpanded({ctrl:this});}});}else{this._updateDynamicLayout(v);if(!s){this.fireExpanded({ctrl:this});}}}else{this._stopAnimation();if(this._animatingSnap===true){this._animatingSnap=false;this._getSliderContainerDomRef().stop(true);this._scrollerSnapped(this._iSelectedIndex);}$.removeClass("sapMTPSliderExpanded");this._updateMargins(v);if(sap.ui.Device.system.phone){q.sap.delayedCall(0,this,this._afterExpandCollapse);}else{this._afterExpandCollapse();}}return this;};
a.prototype.setIsCyclic=function(v){if(this.getDomRef()){if(v){this.$().removeClass("sapMTimePickerSliderShort");}else{this.$().addClass("sapMTimePickerSliderShort");}}return this.setProperty("isCyclic",v,false);};
a.prototype.onfocusin=function(e){if(sap.ui.Device.system.desktop&&!this.getIsExpanded()){this.setIsExpanded(true);}};
a.prototype.onfocusout=function(e){var s=e.relatedTarget?e.relatedTarget.id:null,A=[this.getAggregation("_arrowUp").getId(),this.getAggregation("_arrowDown").getId()];if(s&&A.indexOf(s)!==-1){return;}if(sap.ui.Device.system.desktop&&this.getIsExpanded()){this.setIsExpanded(false);}};
a.prototype._onmousewheel=function(e){e.preventDefault();e.stopPropagation();if(!this.getIsExpanded()){return false;}var O=e.originalEvent,D=O.detail?(-O.detail>0):(O.wheelDelta>0),r=D?Math.ceil:Math.floor,w=O.detail?(-O.detail/3):(O.wheelDelta/120),g=this,R;if(!w){return false;}if(!this._aWheelDeltas){this._aWheelDeltas=[];}g._aWheelDeltas.push(w);if(!this._bWheelScrolling){this._bWheelScrolling=true;this._intervalId=setInterval(function(){if(!g._aWheelDeltas.length){clearInterval(g._intervalId);g._bWheelScrolling=false;}else{R=g._aWheelDeltas[0];g._aWheelDeltas=[];R=r(R);if(R){g._offsetSlider(R);}}},150);}return false;};
a.prototype.onsappageup=function(e){if(this.getIsExpanded()){var i=this._getVisibleItems()[0];this.setSelectedValue(i.getKey());}};
a.prototype.onsappagedown=function(e){if(this.getIsExpanded()){var l=this._getVisibleItems()[this._getVisibleItems().length-1];this.setSelectedValue(l.getKey());}};
a.prototype.onsapup=function(e){if(this.getIsExpanded()){this._offsetValue(-1);}};
a.prototype.onsapdown=function(e){if(this.getIsExpanded()){this._offsetValue(1);}};
a.prototype.onkeydown=function(e){var k=e.which||e.keyCode,K=q.sap.KeyCodes;if((k>=K.A&&k<=K.Z)||(k>=K.DIGIT_0&&k<=K.DIGIT_9)){this._fnHandleTypeValues(e.timeStamp,k);}};
a.prototype._getSliderContainerDomRef=function(){return this.$().find(".sapMTimePickerSlider");};
a.prototype._getContentRepeat=function(){var i;if(this.getIsCyclic()){i=Math.ceil(M/this._getVisibleItems().length);i=Math.max(i,3);}else{i=1;}return i;};
a.prototype._getItemHeightInPx=function(){return this.$("content").find("li:not(.TPSliderItemHidden)").outerHeight();};
a.prototype._updateSelectionFrameLayout=function(){var $,i,e,s,g;if(this.getDomRef()){g=this._getItemHeightInPx();$=this.$().find(".sapMTPPickerSelectionFrame");if(sap.ui.Device.system.phone){s=this.$().offset().top;i=(this.$().height()-g)/2+s;}else{e=this.$().parents(".sapUiSizeCompact").length>0?8:16;i=(this.$().height()-g)/2+e;}$.css("top",i);if(sap.ui.Device.system.phone){q.sap.delayedCall(0,this,this._afterExpandCollapse);}else{this._afterExpandCollapse();}}};
a.prototype._updateStepAndValue=function(n,s){var v=0,$,i;for(i=0;i<this.getItems().length;i++){if(i%s!==0&&i!==n){this.getItems()[i].setVisible(false);}else{this.getItems()[i].setVisible(true);v++;}}if(v>2&&v<13&&this.getDomRef()){$=this.$().find(".sapMTimePickerSlider");$.className="";q($).addClass("sapMTimePickerSlider SliderValues"+v.toString());}this.setIsCyclic(v>2);this.setSelectedValue(n.toString());};
a.prototype._updateMargins=function(i){var e,m,g,h,$;if(this.getDomRef()){e=this._getItemHeightInPx();$=this.$().find(".SliderValues3,.SliderValues4,.SliderValues5,.SliderValues6,.SliderValues7,.SliderValues8,.SliderValues9,.SliderValues10,.SliderValues11,.SliderValues12");if(!$.length){return;}if(i){m=(this.$().height()-this._getVisibleItems().length*e)/2;g=m;q.each($.prevAll().filter(f),function(j,k){g-=q(k).height();});g=Math.max(g,0);h=m;q.each($.nextAll().filter(f),function(j,k){h-=q(k).height();});h=Math.max(h,0);if(h===0&&g===0){return;}}else{g=0;h=0;}$.css("margin-top",g);$.css("margin-bottom",h);}};
a.prototype._updateDynamicLayout=function(i){this._updateMargins(i);this._updateSelectionFrameLayout();};
function f(){return q(this).css("display")!=="none";}
a.prototype._getSelectionFrameTopOffset=function(){var $=this._getSliderContainerDomRef().find(".sapMTPPickerSelectionFrame"),e=$.offset();return e.top;};
a.prototype._animateScroll=function(s){var $=this._getSliderContainerDomRef(),p=$.scrollTop(),e=25,g=$.height(),h=this.$("content").height(),D=200,i=g+D,j=this._getContentRepeat(),k=this.getIsCyclic(),l=0.9,m=0.05,n=this;this._intervalId=setInterval(function(){n._animating=true;p=p-s*e;if(k){p=n._getUpdatedCycleScrollTop(g,h,p,i,j);}else{if(p>n._maxScrollTop){p=n._maxScrollTop;s=0;}if(p<n._minScrollTop){p=n._minScrollTop;s=0;}}$.scrollTop(p);s*=l;if(Math.abs(s)<m){var r=n._getItemHeightInPx();var O=n._selectionOffset?(n._selectionOffset%r):0;var u=Math.round((p+O)/r)*r-O;clearInterval(n._intervalId);n._animating=null;n._iSelectedIndex=Math.round((p+n._selectionOffset)/r);n._animatingSnap=true;$.animate({scrollTop:u},S,'linear',function(){$.clearQueue();n._animatingSnap=false;n._scrollerSnapped(n._iSelectedIndex);});}},e);};
a.prototype._stopAnimation=function(){if(this._animating){clearInterval(this._intervalId);this._animating=null;}};
a.prototype._startDrag=function(p){if(!this._dragSession){this._dragSession={};this._dragSession.positions=[];}this._dragSession.pageY=p;this._dragSession.startTop=this._getSliderContainerDomRef().scrollTop();};
a.prototype._doDrag=function(p,e){if(this._dragSession){this._dragSession.offsetY=p-this._dragSession.pageY;this._dragSession.positions.push({pageY:p,timeStamp:e});if(this._dragSession.positions.length>20){this._dragSession.positions.splice(0,10);}if(this._bIsDrag){this._getSliderContainerDomRef().scrollTop(this._dragSession.startTop-this._dragSession.offsetY);}}};
a.prototype._endDrag=function(p,e){if(this._dragSession){var O,g;for(var i=this._dragSession.positions.length-1;i>=0;i--){O=e-this._dragSession.positions[i].timeStamp;g=p-this._dragSession.positions[i].pageY;if(O>100){break;}}var s=(g/O);if(this._animating){clearInterval(this._intervalId);this._intervalId=null;this._animating=null;}this._dragSession=null;this._animateScroll(s);}};
a.prototype._afterExpandCollapse=function(){var s=this.getSelectedValue(),e=this._getSelectionFrameTopOffset(),$=this._getSliderContainerDomRef(),g=$.offset(),i,l,L,h;this._selectionOffset=e-g.top;if(!this.getIsCyclic()){l=q("#"+this.getId()+"-content");h=this._getItemHeightInPx();L=this.$().height();if(this.getIsExpanded()){this._minScrollTop=0;this._marginTop=e-g.top;this._maxScrollTop=h*(this._getVisibleItems().length-1);i=$.height();this._marginBottom=i-this._marginTop-h;if(this._marginBottom<0){this._marginBottom=L-this._marginTop-h;}l.css("margin-top",this._marginTop);l.css("margin-bottom",this._marginBottom);}else{this._marginBottom=L-h;l.css("margin-top",0);l.css("margin-bottom",this._marginBottom);}this._selectionOffset=0;}if(!this.getIsExpanded()){this._selectionOffset=0;}this.$().attr('aria-expanded',this.getIsExpanded());this.setSelectedValue(s);};
a.prototype._getUpdatedCycleScrollTop=function(i,e,g,D,h){var j=e-g-i;while(j<D){g=g-e/h;j=e-g-i;}while(g<D){g=g+e/h;}return g;};
a.prototype._scrollerSnapped=function(i){var s=i,e=this._getVisibleItems().length,n;while(s>=e){s=s-e;}if(!this.getIsCyclic()){s=i;}n=this._getVisibleItems()[s].getKey();this.setSelectedValue(n);};
a.prototype._updateScroll=function(){var s=this.getSelectedValue();if(s!==this._getVisibleItems()[0].getKey()&&this._getSliderContainerDomRef().scrollTop()+(this._selectionOffset?this._selectionOffset:0)===0){this.setSelectedValue(s);}};
a.prototype._addSelectionStyle=function(){var $=this.$("content").find("li:not(.TPSliderItemHidden)"),s=$.eq(this._iSelectedItemIndex).text(),A;if(!s){return;}A=F.call(this,s);$.eq(this._iSelectedItemIndex).addClass("sapMTimePickerItemSelected");document.getElementById(this.getId()+"-valDescription").innerHTML=A;};
a.prototype._removeSelectionStyle=function(){var $=this.$("content").find("li:not(.TPSliderItemHidden)");$.eq(this._iSelectedItemIndex).removeClass("sapMTimePickerItemSelected").attr("aria-selected","false");};
a.prototype._attachEvents=function(){var e=this._getSliderContainerDomRef()[0],D=sap.ui.Device;if(D.system.combi){e.addEventListener("touchstart",q.proxy(o,this),false);e.addEventListener("touchmove",q.proxy(c,this),false);document.addEventListener("touchend",q.proxy(d,this),false);e.addEventListener("mousedown",q.proxy(o,this),false);document.addEventListener("mousemove",q.proxy(c,this),false);document.addEventListener("mouseup",q.proxy(d,this),false);}else{if(D.system.phone||D.system.tablet){e.addEventListener("touchstart",q.proxy(o,this),false);e.addEventListener("touchmove",q.proxy(c,this),false);document.addEventListener("touchend",q.proxy(d,this),false);}else{e.addEventListener("mousedown",q.proxy(o,this),false);document.addEventListener("mousemove",q.proxy(c,this),false);document.addEventListener("mouseup",q.proxy(d,this),false);}}};
a.prototype._detachEvents=function(){var e=this.getDomRef(),D=sap.ui.Device;if(D.system.combi){e.removeEventListener("touchstart",q.proxy(o,this),false);e.removeEventListener("touchmove",q.proxy(c,this),false);document.removeEventListener("touchend",q.proxy(d,this),false);e.removeEventListener("mousedown",q.proxy(o,this),false);document.removeEventListener("mousemove",q.proxy(c,this),false);document.removeEventListener("mouseup",q.proxy(d,this),false);}else{if(D.system.phone||D.system.tablet){e.removeEventListener("touchstart",q.proxy(o,this),false);e.removeEventListener("touchmove",q.proxy(c,this),false);document.removeEventListener("touchend",q.proxy(d,this),false);}else{e.removeEventListener("mousedown",q.proxy(o,this),false);document.removeEventListener("mousemove",q.proxy(c,this),false);document.removeEventListener("mouseup",q.proxy(d,this),false);}}};
a.prototype._offsetValue=function(i){var s=this._getSliderContainerDomRef(),e=s.scrollTop(),g=this._getItemHeightInPx(),h=e+i*g,j=this.getIsCyclic(),k=this,l=this._iSelectedItemIndex+i;if(!j){if(l<0||l>=this._getVisibleItems().length){return;}if(h>this._maxScrollTop){h=this._maxScrollTop;}if(h<this._minScrollTop){h=this._minScrollTop;}}this._animatingSnap=true;s.animate({scrollTop:h},S,'linear',function(){s.clearQueue();k._animatingSnap=false;k._scrollerSnapped(l);});};
a.prototype._offsetSlider=function(O){var s=this._getSliderContainerDomRef().scrollTop(),e=this,$=e._getSliderContainerDomRef().height(),g=e.$("content").height(),D=200,i=$+D,h=e._getContentRepeat(),j=e.getIsCyclic(),k=e._getItemHeightInPx();s=s-O*k;if(j){s=e._getUpdatedCycleScrollTop($,g,s,i,h);}else{if(s>e._maxScrollTop){s=e._maxScrollTop;}if(s<e._minScrollTop){s=e._minScrollTop;}}e._getSliderContainerDomRef().scrollTop(s);e._iSelectedIndex=Math.round((s+e._selectionOffset)/k);e._scrollerSnapped(e._iSelectedIndex);};
a.prototype._initArrows=function(){var e=this,A,g;A=new sap.m.Button({icon:I.getIconURI("slim-arrow-up"),press:function(E){e._offsetValue(-1);},type:'Transparent'});A.addEventDelegate({onAfterRendering:function(){A.$().attr("tabindex",-1);}});this.setAggregation("_arrowUp",A);g=new sap.m.Button({icon:I.getIconURI("slim-arrow-down"),press:function(E){e._offsetValue(1);},type:'Transparent'});g.addStyleClass("sapMTimePickerItemArrowDown");g.addEventDelegate({onAfterRendering:function(){g.$().attr("tabindex",-1);}});this.setAggregation("_arrowDown",g);};
function b(A,p){if(A==null){throw new TypeError('findIndex called with null or undefined array');}if(typeof p!=='function'){throw new TypeError('predicate must be a function');}var l=A.length;var e=arguments[1];var v;for(var i=0;i<l;i++){v=A[i];if(p.call(e,v,i,A)){return i;}}return-1;}
var o=function(e){var p=e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;this._bIsDrag=false;if(!this.getIsExpanded()){return;}this._stopAnimation();this._startDrag(p);e.preventDefault();this._mousedown=true;};var c=function(e){var p=e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;if(!this._mousedown||!this.getIsExpanded()){return;}if(!this._bIsDrag&&this._dragSession&&this._dragSession.positions.length){var g=this._dragSession.positions.some(function(h){return Math.abs(h.pageY-p)>5;});if(g){this._bIsDrag=true;}}this._doDrag(p,e.timeStamp);this._mousedown=true;};var d=function(e){var p=e.changedTouches&&e.changedTouches.length?e.changedTouches[0].pageY:e.pageY;if(this._bIsDrag===false){this.fireTap(e);this._dragSession=null;}this._bIsDrag=true;if(!this.getIsExpanded()){this._dragSession=null;return;}this._endDrag(p,e.timeStamp);this._mousedown=false;};var F=function(s){var i=this._getVisibleItems();var e=b(i,function(g){return g.getText()===s;});return i[e].getKey();};var t=function(){var l=-1,L=-1,w=1000,s="",e=function(i,k){var m;if(l+w<i){s="";}else{if(L!==-1){q.sap.clearDelayedCall(L);L=-1;}}s+=String.fromCharCode(k).toLowerCase();m=this._getVisibleItems().filter(function(g){return g.getKey().indexOf(s)===0;});if(m.length>1){L=q.sap.delayedCall(w,this,function(){this.setSelectedValue(s);s="";L=-1;});}else if(m.length===1){this.setSelectedValue(m[0].getKey());s="";}l=i;};return e;};
a.prototype._getVisibleItems=function(){return this.getItems().filter(function(i){return i.getVisible();});};
return a;},false);
sap.ui.predefine('sap/m/TimePickerSliderRenderer',['jquery.sap.global'],function(q){"use strict";var T={};
T.render=function(r,c){var i,R,n=c._getContentRepeat(),I=c.getItems(),C=c.getLabel();r.write("<div");r.writeControlData(c);r.writeAttribute("tabindex","0");r.addClass("sapMTPColumn");if(c.getIsExpanded()){r.addClass("sapMTPSliderExpanded");}if(!c.getIsCyclic()){r.addClass("sapMTimePickerSliderShort");}r.writeClasses();r.writeAccessibilityState(c,{role:"list",labelledby:{value:c.getId()+"-label",append:true},describedby:{value:c.getId()+"-valDescription",append:true}});r.write(">");r.write("<div");r.writeAttribute("id",c.getId()+"-label");r.addClass("sapMTimePickerLabel");r.writeClasses();r.writeAttribute('aria-expanded',c.getIsExpanded());r.write(">");r.writeEscaped(C);r.write("</div>");r.write("<div");r.writeAttribute("id",c.getId()+"-valDescription");r.writeAttribute('aria-hidden','false');r.writeAttribute('aria-live','assertive');r.addClass("sapUiInvisibleText");r.writeClasses();r.write("></div>");r.write("<div class='sapMTimePickerItemArrows'>");r.renderControl(c.getAggregation("_arrowUp"));r.write("</div>");r.write("<div");r.addClass("sapMTimePickerSlider");T.addItemValuesCssClass(r,c);r.writeClasses();r.writeAttribute("unselectable","on");r.writeStyles();r.write(">");r.write("<div class=\"sapMTPPickerSelectionFrame\"></div>");r.write("<ul");r.writeAttribute("id",c.getId()+"-content");r.writeAttribute("unselectable","on");r.write(">");for(R=1;R<=n;R++){for(i=0;i<I.length;i++){r.write("<li");r.addClass("sapMTimePickerItem");if(!I[i].getVisible()){r.addClass("TPSliderItemHidden");}r.writeClasses();r.writeAccessibilityState(c,{role:"listitem"});r.writeAttribute("unselectable","on");r.write(">");r.writeEscaped(I[i].getText());r.write("</li>");}}r.write("</ul>");r.write("</div>");r.write("<div class='sapMTimePickerItemArrows'>");r.renderControl(c.getAggregation("_arrowDown"));r.write("</div>");r.write("</div>");};
T.addItemValuesCssClass=function(r,c){var v=c.getItems().filter(function(i){return i.getVisible();}).length;if(v>2&&v<13){r.addClass("SliderValues"+v.toString());}};
return T;},false);
sap.ui.predefine('sap/m/TimePickerSliders',['jquery.sap.global','sap/ui/core/Control','./TimePickerSlidersRenderer','./TimePickerSlider','./VisibleItem'],function(q,C,S,T,V){"use strict";
var a=C.extend("sap.m.TimePickerSliders",{
metadata:{library:"sap.m",properties:{format:{name:"format",type:"string"},labelText:{name:"labelText",type:"string"},minutesStep:{type:"int",group:"Misc",defaultValue:1},secondsStep:{type:"int",group:"Misc",defaultValue:1}},aggregations:{_columns:{type:"sap.m.TimePickerSlider",multiple:true,visibility:"hidden"}},associations:{invokedBy:{type:"sap.m.TimePicker",multiple:false}}},
renderer:S.render
});
a.prototype.init=function(){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),p=sap.ui.core.LocaleData.getInstance(l).getDayPeriods("abbreviated");this._fnLayoutChanged=q.proxy(this._onOrientationChanged,this);sap.ui.Device.resize.attachHandler(this._fnLayoutChanged);this._sAM=p[0];this._sPM=p[1];};
a.prototype.exit=function(){this.$().off(!!sap.ui.Device.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);sap.ui.Device.resize.detachHandler(this._fnOrientationChanged);};
a.prototype.onAfterRendering=function(){this.$().off(!!sap.ui.Device.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);this.$().on(!!sap.ui.Device.browser.firefox?"DOMMouseScroll":"mousewheel",q.proxy(this._onmousewheel,this));if(!sap.ui.Device.browser.msie){this._initFocus(true);}};
a.prototype.setInvokedBy=function(i){var l,p,c;this.setAssociation("invokedBy",i);if(sap.ui.getCore().byId(i)){l=new sap.ui.core.Locale(sap.ui.getCore().byId(i).getLocaleId());p=sap.ui.core.LocaleData.getInstance(l).getDayPeriods("abbreviated");this._sAM=p[0];this._sPM=p[1];c=this.getAggregation("_columns");if(c){this.destroyAggregation("_columns");}this._setupLists(this.getFormat());}return this;};
a.prototype.setLabelText=function(l){var c;this.setProperty("labelText",l,true);if(!sap.ui.Device.system.desktop){c=q(this.getDomRef("label"));if(c){c.html(l);}}return this;};
a.prototype.setFormat=function(f){this.setProperty("format",f,true);var c=this.getAggregation("_columns");if(c){this.destroyAggregation("_columns");}this._setupLists(f);return this;};
a.prototype.setMinutesStep=function(v){this.setProperty("minutesStep",v,true);var c=this.getAggregation("_columns");if(c){this.destroyAggregation("_columns");}this._setupLists(this.getFormat());return this;};
a.prototype.setSecondsStep=function(v){this.setProperty("secondsStep",v,true);var c=this.getAggregation("_columns");if(c){this.destroyAggregation("_columns");}this._setupLists(this.getFormat());return this;};
a.prototype.getTimeValues=function(){var c=sap.ui.getCore(),l=c.byId(this.getId()+"-listHours"),L=c.byId(this.getId()+"-listMins"),o=c.byId(this.getId()+"-listSecs"),b=c.byId(this.getId()+"-listFormat"),h=null,A=null,d=new Date();if(l){h=parseInt(l.getSelectedValue(),10);}if(b){A=b.getSelectedValue();}if(A==="am"&&h===12){h=0;}else if(A==="pm"&&h!==12){h+=12;}if(h!==null){d.setHours(h.toString());}if(L){d.setMinutes(L.getSelectedValue());}if(o){d.setSeconds(o.getSelectedValue());}return d;};
a.prototype.setTimeValues=function(d){var c=sap.ui.getCore(),l=c.byId(this.getId()+"-listHours"),L=c.byId(this.getId()+"-listMins"),o=c.byId(this.getId()+"-listSecs"),b=c.byId(this.getId()+"-listFormat"),h,A=null;d=d||new Date();h=d.getHours();if(b){A=h>=12?"pm":"am";h=(h>12)?h-12:h;h=(h===0?12:h);}l&&l.setSelectedValue(h.toString());L&&L._updateStepAndValue(d.getMinutes(),this.getMinutesStep());o&&o._updateStepAndValue(d.getSeconds(),this.getSecondsStep());b&&b.setSelectedValue(A);};
a.prototype.collapseAll=function(){var s=this.getAggregation("_columns");if(s){for(var i=0;i<s.length;i++){if(s[i].getIsExpanded()){s[i].setIsExpanded(false);}}}};
a.prototype.updateSlidersValues=function(){var s=this.getAggregation("_columns");if(s){for(var i=0;i<s.length;i++){s[i]._updateScroll();}}};
a.prototype.onsaphome=function(e){var c=this._getCurrentSlider();if(c&&document.activeElement===c.getDomRef()){this.getAggregation("_columns")[0].focus();}};
a.prototype.onsapend=function(e){var c=this._getCurrentSlider();if(c&&document.activeElement===c.getDomRef()){var s=this.getAggregation("_columns");s[s.length-1].focus();}};
a.prototype.onsapleft=function(e){var c=this._getCurrentSlider(),i=-1,n=-1,s=this.getAggregation("_columns");if(c&&document.activeElement===c.getDomRef()){i=s.indexOf(c);n=i>0?i-1:s.length-1;s[n].focus();}};
a.prototype.onsapright=function(e){var c=this._getCurrentSlider(),i=-1,n=-1,s=this.getAggregation("_columns");if(c&&document.activeElement===c.getDomRef()){i=s.indexOf(c);n=i<s.length-1?i+1:0;s[n].focus();}};
a.prototype._onmousewheel=function(e){var c=this._getCurrentSlider();if(c){c._onmousewheel(e);}};
a.prototype._onOrientationChanged=function(){var s=this.getAggregation("_columns");if(!s){return;}for(var i=0;i<s.length;i++){if(s[i].getIsExpanded()){s[i]._updateSelectionFrameLayout();}}};
a.prototype._initFocus=function(s){if(sap.ui.Device.system.desktop&&!s){this.getAggregation("_columns")[0].focus();}else{this.getAggregation("_columns")[0].setIsExpanded(true);}};
a.prototype._generatePickerListValues=function(f,t,s,l){var v=[],b;for(var i=f;i<=t;i+=1){if(i<10&&l){b="0"+i.toString();}else{b=i.toString();}var I=new V({key:i.toString(),text:b});if(i%s!==0){I.setVisible(false);}v.push(I);}return v;};
a.prototype._setupLists=function(f){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),l=r.getText("TIMEPICKER_LBL_HOURS"),L=r.getText("TIMEPICKER_LBL_MINUTES"),s=r.getText("TIMEPICKER_LBL_SECONDS"),b=r.getText("TIMEPICKER_LBL_AMPM"),m=this.getMinutesStep(),c=this.getSecondsStep();if(f===undefined){return;}var h=false,H=false,F,t;if(f.indexOf("HH")!==-1){h=true;F=0;t=23;H=true;}else if(f.indexOf("H")!==-1){h=true;F=0;t=23;}else if(f.indexOf("hh")!==-1){h=true;F=1;t=12;H=true;}else if(f.indexOf("h")!==-1){h=true;F=1;t=12;}if(h){this.addAggregation("_columns",new T(this.getId()+"-listHours",{items:this._generatePickerListValues(F,t,1,H),expanded:q.proxy(o,this),label:l}));}if(f.indexOf("m")!==-1){var v=this._generatePickerListValues(0,59,m,true);this.addAggregation("_columns",new T(this.getId()+"-listMins",{items:v,expanded:q.proxy(o,this),label:L}));}if(f.indexOf("s")!==-1){var v=this._generatePickerListValues(0,59,c,true);this.addAggregation("_columns",new T(this.getId()+"-listSecs",{items:v,expanded:q.proxy(o,this),label:s}));}if(f.indexOf("a")!==-1){this.addAggregation("_columns",new T(this.getId()+"-listFormat",{items:[{key:"am",text:this._sAM},{key:"pm",text:this._sPM}],expanded:q.proxy(o,this),label:b,isCyclic:false}).addStyleClass("sapMTimePickerSliderShort"));}this.getAggregation("_columns")[0].setIsExpanded(true);function o(e){var d=this.getAggregation("_columns");for(var i=0;i<d.length;i++){if(d[i]!==e.oSource&&d[i].getIsExpanded()){d[i].setIsExpanded(false);}}}};
a.prototype._getCurrentSlider=function(){var s=this.getAggregation("_columns");if(s){for(var i=0;i<s.length;i++){if(s[i].getIsExpanded()){return s[i];}}}return null;};
return a;},false);
sap.ui.predefine('sap/m/TimePickerSlidersRenderer',['jquery.sap.global'],function(q){"use strict";var T={};
T.render=function(r,c){var s=c.getAggregation("_columns"),l=c.getLabelText()||"",R=sap.ui.getCore().getLibraryResourceBundle("sap.m"),S,b=sap.ui.getCore().getConfiguration().getRTL();r.write("<div onselectstart=\"return false;\"");r.writeControlData(c);r.addClass("sapMTimePickerContainer");r.writeClasses();r.writeAccessibilityState(c,{label:(l+" "+R.getText("TIMEPICKER_SCREENREADER_TAG")).trim()});r.write(">");if(!sap.ui.Device.system.desktop){r.write("<div id=\""+c.getId()+"-label"+"\"");r.addClass("sapMTimePickerContainerLabel");r.writeClasses();r.write(">");r.addStyle("display","block");r.writeEscaped(l);r.write("</div>");}if(b){for(S=s.length-1;S>=0;S--){r.renderControl(s[S]);}}else{for(S=0;S<s.length;S++){r.renderControl(s[S]);}}r.write("</div>");};
return T;},false);
sap.ui.predefine('sap/m/Title',['jquery.sap.global','sap/ui/core/Control','sap/ui/Device','./library'],function(q,C,D,l){"use strict";
var T=C.extend("sap.m.Title",{metadata:{library:"sap.m",interfaces:["sap.ui.core.IShrinkable"],properties:{text:{type:"string",group:"Appearance",defaultValue:null},level:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:sap.ui.core.TitleLevel.Auto},titleStyle:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:sap.ui.core.TitleLevel.Auto},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:sap.ui.core.TextAlign.Initial}},associations:{title:{type:"sap.ui.core.Title",multiple:false}}}});
T.prototype.setText=function(t){var r=this.getDomRef("inner");var p=r&&!this._getTitle();this.setProperty("text",t,p);if(p){r.innerHTML=q.sap.encodeHTML(this.getText()||"");}return this;};
T.prototype._getTitle=function(){var t=this.getTitle();if(t){var o=sap.ui.getCore().byId(t);if(o&&o instanceof sap.ui.core.Title){return o;}}return null;};
T.prototype._onTitleChanged=function(){this.invalidate();};
T.prototype.setTitle=function(t){var a=this;var o=this._getTitle();if(o){o.invalidate=o.__sapui5_title_originvalidate;o.exit=o.__sapui5_title_origexit;delete o.__sapui5_title_origexit;delete o.__sapui5_title_originvalidate;}this.setAssociation("title",t);var n=this._getTitle();if(n){n.__sapui5_title_originvalidate=n.invalidate;n.__sapui5_title_origexit=n.exit;n.exit=function(){a._onTitleChanged();if(this.__sapui5_title_origexit){this.__sapui5_title_origexit.apply(this,arguments);}};n.invalidate=function(){a._onTitleChanged();this.__sapui5_title_originvalidate.apply(this,arguments);};}return this;};
T.prototype.getAccessibilityInfo=function(){var t=this._getTitle()||this;return{role:"heading",description:t.getText(),focusable:false};};
return T;},true);
sap.ui.predefine('sap/m/TitleRenderer',['jquery.sap.global','sap/ui/Device'],function(q,D){"use strict";var T={};
T.render=function(r,t){var a=t._getTitle(),l=(a?a.getLevel():t.getLevel())||sap.ui.core.TitleLevel.Auto,A=l==sap.ui.core.TitleLevel.Auto,s=A?"div":l;r.write("<",s);r.writeControlData(t);r.addClass("sapMTitle");r.addClass("sapMTitleStyle"+(t.getTitleStyle()||sap.ui.core.TitleLevel.Auto));r.addClass("sapMTitleNoWrap");r.addClass("sapUiSelectable");var w=t.getWidth();if(!w){r.addClass("sapMTitleMaxWidth");}else{r.addStyle("width",w);}var b=t.getTextAlign();if(b&&b!=sap.ui.core.TextAlign.Initial){r.addClass("sapMTitleAlign"+b);}if(t.getParent()instanceof sap.m.Toolbar){r.addClass("sapMTitleTB");}var c=a?a.getTooltip_AsString():t.getTooltip_AsString();if(c){r.writeAttributeEscaped("title",c);}if(A){r.writeAttribute("role","heading");}r.writeClasses();r.writeStyles();r.write("><span");r.writeAttribute("id",t.getId()+"-inner");r.write(">");r.writeEscaped(a?a.getText():t.getText());r.write("</span></",s,">");};
return T;},true);
sap.ui.predefine('sap/m/ToggleButton',['jquery.sap.global','./Button','./library','sap/ui/core/EnabledPropagator'],function(q,B,l,E){"use strict";
var T=B.extend("sap.m.ToggleButton",{metadata:{library:"sap.m",properties:{pressed:{type:"boolean",group:"Data",defaultValue:false}}}});
E.call(T.prototype);
T.prototype.ontap=function(e){e.setMarked();if(this.getEnabled()){this.setPressed(!this.getPressed());this.firePress({pressed:this.getPressed()});}};
T.prototype.setPressed=function(p){p=!!p;if(p!=this.getPressed()){this.setProperty("pressed",p,true);this.$().attr("aria-pressed",p);this.$("inner").toggleClass("sapMToggleBtnPressed",p&&!this._isUnstyled());}return this;};
T.prototype.onkeydown=function(e){if(e.which===q.sap.KeyCodes.SPACE||e.which===q.sap.KeyCodes.ENTER){this.ontap(e);}};
T.prototype.onkeyup=function(e){if(e.which===q.sap.KeyCodes.SPACE||e.which===q.sap.KeyCodes.ENTER){e.setMarked();}};
T.prototype.getAccessibilityInfo=function(){var i=B.prototype.getAccessibilityInfo.apply(this,arguments);if(this.getPressed()){i.description=((i.description||"")+" "+sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_STATE_PRESSED")).trim();}return i;};
return T;},true);
sap.ui.predefine('sap/m/ToggleButtonRenderer',['jquery.sap.global','./ButtonRenderer','sap/ui/core/Renderer'],function(q,B,R){"use strict";var T=R.extend(B);
T.renderAccessibilityAttributes=function(r,t,a){a["pressed"]=t.getPressed();};
T.renderButtonAttributes=function(r,t){if(t.getPressed()&&!t._isUnstyled()){r.addClass("sapMToggleBtnPressed");}};
return T;},true);
sap.ui.predefine('sap/m/Token',['jquery.sap.global','./library','sap/ui/core/Control','./Tokenizer'],function(q,l,C,T){"use strict";
var a=C.extend("sap.m.Token",{metadata:{library:"sap.m",properties:{selected:{type:"boolean",group:"Misc",defaultValue:false},key:{type:"string",group:"Misc",defaultValue:""},text:{type:"string",group:"Misc",defaultValue:""},editable:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}},aggregations:{deleteIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{"delete":{},press:{},select:{},deselect:{}}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");a.prototype._sAriaTokenLabelId=new sap.ui.core.InvisibleText({text:r.getText("TOKEN_ARIA_LABEL")}).toStatic().getId();a.prototype._sAriaTokenDeletableId=new sap.ui.core.InvisibleText({text:r.getText("TOKEN_ARIA_DELETABLE")}).toStatic().getId();
a.prototype.init=function(){var t=this;this._deleteIcon=new sap.ui.core.Icon({id:t.getId()+"-icon",src:"sap-icon://sys-cancel",noTabStop:true,press:function(e){var p=t.getParent();if(p instanceof T){p._onTokenDelete(t);}t.fireDelete();e.preventDefault();}});this._deleteIcon.addStyleClass("sapMTokenIcon");this.setAggregation("deleteIcon",this._deleteIcon);this._deleteIcon.setUseIconTooltip(false);};
a.prototype.ontouchstart=function(e){e.preventDefault();};
a.prototype.setSelected=function(s){if(this.getSelected()===s){return this;}var $=this.$();if($){$.toggleClass("sapMTokenSelected",s);$.attr('aria-selected',s);}this.setProperty("selected",s,true);return this;};
a.prototype.setEditable=function(e){var p=this.getParent();this.setProperty("editable",e,true);this.$().toggleClass("sapMTokenReadOnly",!e);if(p instanceof T){p.invalidate();}return this;};
a.prototype._onTokenPress=function(e){var s=this.getSelected(),c=e.ctrlKey||e.metaKey,S=e.shiftKey,n=true,p;if(c){n=!s;}this.setSelected(n);this.firePress();if(s!=n){if(n){this.fireSelect();}else{this.fireDeselect();}}p=this.getParent();if(p instanceof T){p._onTokenSelect(this,c,S);}if(this.getSelected()){this.focus();}};
a.prototype._changeSelection=function(s){if(this.getSelected()==s){return;}this.setSelected(s);if(s){this.fireSelect();}else{this.fireDeselect();}};
a.prototype.ontap=function(e){this._onTokenPress(e);};
a.prototype.onsapfocusleave=function(e){if(this.getParent()instanceof T){return;}this.setSelected(false);};
a.prototype.onsapbackspace=function(e){this._deleteToken(e);};
a.prototype.onsapdelete=function(e){this._deleteToken(e);};
a.prototype._deleteToken=function(e){if(this.getParent()instanceof T){return;}if(this.getEditable()){this.fireDelete();}e.preventDefault();};
a.prototype.onsapspace=function(e){this._onTokenPress(e);if(e){e.preventDefault();e.stopPropagation();}};
a.prototype.onkeydown=function(e){if((e.ctrlKey||e.metaKey)&&e.which===q.sap.KeyCodes.SPACE){this.onsapspace(e);e.preventDefault();}};
return a;},true);
sap.ui.predefine('sap/m/TokenRenderer',['jquery.sap.global'],function(q){"use strict";var T={};
T.render=function(r,c){r.write("<div tabindex=\"-1\"");r.writeControlData(c);r.addClass("sapMToken");r.writeAttribute("role","listitem");r.writeAttribute("aria-readonly",!c.getEditable());r.writeAttribute("aria-selected",c.getSelected());if(c.getSelected()){r.addClass("sapMTokenSelected");}if(!c.getEditable()){r.addClass("sapMTokenReadOnly");}r.writeClasses();var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}var a={};a.describedby={value:c._sAriaTokenLabelId,append:true};if(c.getEditable()){a.describedby={value:c._sAriaTokenDeletableId,append:true};}r.writeAccessibilityState(c,a);r.write(">");T._renderInnerControl(r,c);if(c.getEditable()){r.renderControl(c._deleteIcon);}r.write("</div>");};
T._renderInnerControl=function(r,c){var t=c.getTextDirection();r.write("<span");r.addClass("sapMTokenText");r.writeClasses();if(t!==sap.ui.core.TextDirection.Inherit){r.writeAttribute("dir",t.toLowerCase());}r.write(">");var a=c.getText();if(a){r.writeEscaped(a);}r.write("</span>");};
return T;},true);
sap.ui.predefine('sap/m/Tokenizer',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/delegate/ScrollEnablement'],function(q,l,C,S){"use strict";
var T=C.extend("sap.m.Tokenizer",{metadata:{library:"sap.m",properties:{editable:{type:"boolean",group:"Misc",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},defaultAggregation:"tokens",aggregations:{tokens:{type:"sap.m.Token",multiple:true,singularName:"token"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{tokenChange:{parameters:{type:{type:"string"},token:{type:"sap.m.Token"},tokens:{type:"sap.m.Token[]"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}},tokenUpdate:{type:{type:"string"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");T.prototype._sAriaTokenizerLabelId=new sap.ui.core.InvisibleText({text:r.getText("TOKENIZER_ARIA_LABEL")}).toStatic().getId();
T.prototype.init=function(){this._bScrollToEndIsActive=false;this._aTokenValidators=[];this._oScroller=new S(this,this.getId()+"-scrollContainer",{horizontal:true,vertical:false,nonTouchScrolling:true});};
T.prototype.getScrollDelegate=function(){return this._oScroller;};
T.prototype.scrollToEnd=function(){if(!this._bScrollToEndIsActive){this._bScrollToEndIsActive=true;var t=this;var d=this.getDomRef();if(d){this._sResizeHandlerId=sap.ui.core.ResizeHandler.register(d,function(){t._doScrollToEnd();});}}this._doScrollToEnd();};
T.prototype.setWidth=function(w){this.setProperty("width",w,true);this.$().css("width",this.getWidth());return this;};
T.prototype.setPixelWidth=function(n){this._truncateLastToken(n);var w=(n/parseFloat(sap.m.BaseFontSize))+"rem";this.$().css("width",w);if(this._oScroller){this._oScroller.refresh();}};
T.prototype._truncateLastToken=function(n){var a=this._removeLastTokensTruncation();if(a===null){return;}var t=this;var L=a.$();var s=null;s=function(){a.removeStyleClass("sapMTokenTruncate");this.$().removeAttr("style");this.detachSelect(s);t.scrollToEnd();};var w=L.width();if(!a.getSelected()&&n>=0&&w>=0&&n<w){L.outerWidth(n,true);a.addStyleClass("sapMTokenTruncate");a.attachSelect(s);}else{a.detachSelect(s);}this.scrollToEnd();};
T.prototype._doScrollToEnd=function(){var t=this.getDomRef();if(!t){return;}var $=this.$();var s=$.find(".sapMTokenizerScrollContainer")[0];$[0].scrollLeft=s.scrollWidth;};
T.prototype.scrollToStart=function(){this._deactivateScrollToEnd();var t=this.getDomRef();if(!t){return;}var m=q(t);m[0].scrollLeft=0;};
T.prototype._deactivateScrollToEnd=function(){this._deregisterResizeHandler();this._bScrollToEndIsActive=false;};
T.prototype._removeLastTokensTruncation=function(){var t=this.getTokens();var L=null;if(t.length>0){L=t[t.length-1];var $=L.$();if($.length>0){$[0].style.cssText="";}}return L;};
T.prototype.getScrollWidth=function(){if(!this.getDomRef()){return 0;}this._removeLastTokensTruncation();return this.$().children(".sapMTokenizerScrollContainer")[0].scrollWidth;};
T.prototype.onBeforeRendering=function(){this._deregisterResizeHandler();};
T.prototype.onAfterRendering=function(){if(C.prototype.onAfterRendering){C.prototype.onAfterRendering.apply(this,arguments);}var t=this;if(this._bScrollToEndIsActive){this._sResizeHandlerId=sap.ui.core.ResizeHandler.register(this.getDomRef(),function(){t._doScrollToEnd();});}if(this._bCopyToClipboardSupport){this.$().on("copy",function(e){t.oncopy(e);});}};
T.prototype.invalidate=function(o){var p=this.getParent();if(p instanceof sap.m.MultiInput){p.invalidate(o);}else{C.prototype.invalidate.call(this,o);}};
T.prototype.oncopy=function(e){var s=this.getSelectedTokens();var a="";for(var i=0;i<s.length;i++){a=a+(i>0?"\r\n":"")+s[i].getText();}if(!a){return;}if(window.clipboardData){window.clipboardData.setData("text",a);}else{e.originalEvent.clipboardData.setData('text/plain',a);}e.preventDefault();};
T.prototype.onsapfocusleave=function(e){if(document.activeElement==this.getDomRef()||!this._checkFocus()){this._changeAllTokensSelection(false);this._oSelectionOrigin=null;}};
T.prototype.saptabnext=function(e){this._changeAllTokensSelection(false);};
T.prototype.isAllTokenSelected=function(){if(this.getTokens().length===this.getSelectedTokens().length){return true;}return false;};
T.prototype.onkeydown=function(e){if(e.which===q.sap.KeyCodes.TAB){this._changeAllTokensSelection(false);}if((e.ctrlKey||e.metaKey)&&e.which===q.sap.KeyCodes.A){this._iSelectedToken=this.getSelectedTokens().length;if(this.getTokens().length>0){this.focus();this._changeAllTokensSelection(true);e.preventDefault();}}};
T.prototype.onsapbackspace=function(e){if(this.getSelectedTokens().length===0){this.onsapprevious(e);}else if(this.getEditable()){this._removeSelectedTokens();}e.preventDefault();e.stopPropagation();};
T.prototype.onsapdelete=function(e){if(this.getEditable()){this._removeSelectedTokens();}};
T.prototype._ensureTokenVisible=function(t){var i=this.$().offset().left,a=t.$().offset().left;if(a<i){this.$().scrollLeft(this.$().scrollLeft()-i+a);}};
T.prototype.onsapprevious=function(e){if(e.which===q.sap.KeyCodes.ARROW_UP){return;}var L=this.getTokens().length;if(L===0){return;}var f=q(document.activeElement).control()[0];if(f===this){return;}var i=f?this.getTokens().indexOf(f):-1;if(i==0){return;}if(i>0){var p=this.getTokens()[i-1];this._changeAllTokensSelection(false,p);p._changeSelection(true);p.focus();}else{var t=this.getTokens()[this.getTokens().length-1];t._changeSelection(true);t.focus();}this._deactivateScrollToEnd();e.setMarked();};
T.prototype.onsapnext=function(e){if(e.which===q.sap.KeyCodes.ARROW_DOWN){return;}var L=this.getTokens().length;if(L===0){return;}var f=q(document.activeElement).control()[0];if(f===this){return;}var i=f?this.getTokens().indexOf(f):-1;if(i<L-1){var n=this.getTokens()[i+1];this._changeAllTokensSelection(false,n);n._changeSelection(true);n.focus();}else{return;}this._deactivateScrollToEnd();e.setMarked();};
T.prototype.addValidator=function(v){if(typeof(v)==="function"){this._aTokenValidators.push(v);}};
T.prototype.removeValidator=function(v){var i=this._aTokenValidators.indexOf(v);if(i!==-1){this._aTokenValidators.splice(i,1);}};
T.prototype.removeAllValidators=function(){this._aTokenValidators=[];};
T.prototype._validateToken=function(p,v){var t=p.token;var s;if(t&&t.getText()){s=t.getText();}else{s=p.text;}var V=p.validationCallback;var o=p.suggestionObject;var i,a,b;if(!v){v=this._aTokenValidators;}b=v.length;if(b===0){if(!t&&V){V(false);}return t;}for(i=0;i<b;i++){a=v[i];t=a({text:s,suggestedToken:t,suggestionObject:o,asyncCallback:this._getAsyncValidationCallback(v,i,s,o,V)});if(!t){if(V){V(false);}return null;}if(t===T.WaitForAsyncValidation){return null;}}return t;};
T.prototype._getAsyncValidationCallback=function(v,V,i,s,f){var t=this,a;return function(o){if(o){v=v.slice(V+1);o=t._validateToken({text:i,token:o,suggestionObject:s,validationCallback:f},v);a=t._addUniqueToken(o,f);if(a){t.fireTokenUpdate({addedTokens:[o],removedTokens:[],type:T.TokenUpdateType.Added});}}else{if(f){f(false);}}};};
T.prototype.addValidateToken=function(p){var t=this._validateToken(p);this._addUniqueToken(t,p.validationCallback);};
T.prototype._addValidateToken=function(p){var t=this._validateToken(p),a=this._addUniqueToken(t,p.validationCallback);if(a){this.fireTokenUpdate({addedTokens:[t],removedTokens:[],type:T.TokenUpdateType.Added});}};
T.prototype._addUniqueToken=function(t,v){if(!t){return false;}var a=this._tokenExists(t);if(a){return false;}this.addToken(t);if(v){v(true);}this.fireTokenChange({addedTokens:[t],removedTokens:[],type:T.TokenChangeType.TokensChanged});return true;};
T.prototype._parseString=function(s){return s.split(/\r\n|\r|\n/g);};
T.prototype._checkFocus=function(){return this.getDomRef()&&q.sap.containsOrEquals(this.getDomRef(),document.activeElement);};
T.prototype._tokenExists=function(t){var a=this.getTokens();if(!(a&&a.length)){return false;}var k=t.getKey();if(!k){return false;}var b=a.length;for(var i=0;i<b;i++){var c=a[i];var d=c.getKey();if(d===k){return true;}}return false;};
T.prototype.addToken=function(t,s){var p=this.getParent();if(p instanceof sap.m.MultiInput){if(p.getMaxTokens()!==undefined&&p.getTokens().length>=p.getMaxTokens()){return this;}}this.addAggregation("tokens",t,s);this._bScrollToEndIsActive=true;this.fireTokenChange({token:t,type:T.TokenChangeType.Added});return this;};
T.prototype.removeToken=function(t){t=this.removeAggregation("tokens",t);this._bScrollToEndIsActive=true;this.fireTokenChange({token:t,type:T.TokenChangeType.Removed});return t;};
T.prototype.setTokens=function(t){var o=this.getTokens();this.removeAllTokens(false);var i;for(i=0;i<t.length;i++){this.addToken(t[i],true);}this.invalidate();this._bScrollToEndIsActive=true;this.fireTokenChange({addedTokens:t,removedTokens:o,type:T.TokenChangeType.TokensChanged});};
T.prototype.removeAllTokens=function(f){var t=this.getTokens();this.removeAllAggregation("tokens");if(typeof(f)==="boolean"&&!f){return;}this.fireTokenChange({addedTokens:[],removedTokens:t,type:T.TokenChangeType.TokensChanged});this.fireTokenChange({tokens:t,type:T.TokenChangeType.RemovedAll});};
T.prototype._removeSelectedTokens=function(){var t=this.getSelectedTokens();var a,i,b;b=t.length;if(b===0){return this;}for(i=0;i<b;i++){a=t[i];if(a.getEditable()){this.removeToken(a);}}this.scrollToEnd();this.fireTokenChange({addedTokens:[],removedTokens:t,type:T.TokenChangeType.TokensChanged});this.fireTokenUpdate({addedTokens:[],removedTokens:t,type:T.TokenUpdateType.Removed});this._doSelect();return this;};
T.prototype.selectAllTokens=function(s){if(s===undefined){s=true;}var t=this.getTokens(),a=t.length,i;for(i=0;i<a;i++){t[i].setSelected(s);}this._doSelect();return this;};
T.prototype._changeAllTokensSelection=function(s,a){var t=this.getTokens(),b=t.length,c,i;for(i=0;i<b;i++){c=t[i];if(c!==a){c._changeSelection(s);}}this._doSelect();return this;};
T.prototype.getSelectedTokens=function(){var s=[],t=this.getTokens(),i,a,b=t.length;for(i=0;i<b;i++){a=t[i];if(a.getSelected()){s.push(a);}}return s;};
T.prototype._onTokenDelete=function(t){if(t&&this.getEditable()){t.destroy();this.fireTokenChange({addedTokens:[],removedTokens:[t],type:T.TokenChangeType.TokensChanged});this.fireTokenUpdate({addedTokens:[],removedTokens:[t],type:T.TokenUpdateType.Removed});}};
T.prototype._onTokenSelect=function(t,c,s){var a=this.getTokens(),o,i;if(s){var f=this._getFocusedToken();if(!f){this._oSelectionOrigin=null;return;}if(this._oSelectionOrigin){f=this._oSelectionOrigin;}else{this._oSelectionOrigin=f;}var F=this.indexOfToken(f),I=this.indexOfToken(t),m=Math.min(F,I),M=Math.max(F,I);for(i=0;i<a.length;i++){o=a[i];if(i>=m&&i<=M){o._changeSelection(true);}else if(!c){o._changeSelection(false);}}return;}this._oSelectionOrigin=null;if(c){return;}this._oSelectionOrigin=false;for(i=0;i<a.length;i++){o=a[i];if(o!==t){o._changeSelection(false);}}};
T.prototype._getFocusedToken=function(){var f=sap.ui.getCore().byId(document.activeElement.id);if(!f||!(f instanceof sap.m.Token)||this.indexOfToken(f)==-1){return null;}return f;};
T.prototype.setEditable=function(e){this.$().toggleClass("sapMTokenizerReadonly",!e);return this.setProperty("editable",e,true);};
T.prototype.onsaphome=function(e){this.scrollToStart();};
T.prototype.onsapend=function(e){this.scrollToEnd();};
T.prototype.exit=function(){this._deregisterResizeHandler();};
T.prototype._deregisterResizeHandler=function(){if(this._sResizeHandlerId){sap.ui.core.ResizeHandler.deregister(this._sResizeHandlerId);delete this._sResizeHandlerId;}};
T.prototype._doSelect=function(){if(this._checkFocus()&&this._bCopyToClipboardSupport){var f=document.activeElement;var s=window.getSelection();s.removeAllRanges();if(this.getSelectedTokens().length){var R=document.createRange();R.selectNodeContents(this.getDomRef("clip"));s.addRange(R);}if(window.clipboardData&&document.activeElement.id==this.getId()+"-clip"){q.sap.focus(f.id==this.getId()+"-clip"?this.getDomRef():f);}}};
T.prototype.getReverseTokens=function(){return!!this._reverseTokens;};
T.prototype.setReverseTokens=function(R){this._reverseTokens=R;};
T.TokenChangeType={Added:"added",Removed:"removed",RemovedAll:"removedAll",TokensChanged:"tokensChanged"};T.TokenUpdateType={Added:"added",Removed:"removed"};T.WaitForAsyncValidation="sap.m.Tokenizer.WaitForAsyncValidation";return T;},true);
sap.ui.predefine('sap/m/TokenizerRenderer',['jquery.sap.global','sap/ui/Device'],function(q,D){"use strict";var T={};
T.render=function(r,c){if(c.getParent()&&(c.getParent()instanceof sap.m.MultiInput||c.getParent()instanceof sap.m.MultiComboBox)){r.write("<div ");}else{r.write("<div tabindex=\"0\"");}r.writeControlData(c);r.addClass("sapMTokenizer");if(!c.getEditable()){r.addClass("sapMTokenizerReadonly");}var t=c.getTokens();if(!t.length){r.addClass("sapMTokenizerEmpty");}var p=c.getWidth();if(p){r.addStyle("width",p);r.writeStyles();}r.writeClasses();r.writeAttribute("role","list");var a={};a.labelledby={value:c._sAriaTokenizerLabelId,append:true};r.writeAccessibilityState(c,a);r.write(">");c._bCopyToClipboardSupport=false;if((D.system.desktop||D.system.combi)&&t.length){r.write("<div id='"+c.getId()+"-clip' class='sapMTokenizerClip'");if(window.clipboardData){r.writeAttribute("contenteditable","true");r.writeAttribute("tabindex","-1");}r.write(">&nbsp;</div>");c._bCopyToClipboardSupport=true;}var C="class=\"sapMTokenizerScrollContainer\">";var s=" ";var i="id="+c.getId()+"-scrollContainer";r.write("<div"+s+i+s+C);T._renderTokens(r,c);r.write("</div>");r.write("</div>");};
T._renderTokens=function(r,c){var i=0,t=c.getTokens(),l=t.length;if(c.getReverseTokens()){for(i=l-1;i>-1;i--){r.renderControl(t[i]);}}else{for(i=0;i<l;i++){r.renderControl(t[i]);}}};
return T;},true);
sap.ui.predefine('sap/m/Toolbar.designtime',[],function(){"use strict";return{aggregations:{content:{domRef:":sap-domref"}}};},false);
sap.ui.predefine('sap/m/Toolbar',['jquery.sap.global','./BarInPageEnabler','./ToolbarLayoutData','./ToolbarSpacer','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/ResizeHandler'],function(q,B,T,a,l,C,E,R){"use strict";var b=sap.m.ToolbarDesign;
var c=C.extend("sap.m.Toolbar",{metadata:{interfaces:["sap.ui.core.Toolbar","sap.m.IBar"],library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},active:{type:"boolean",group:"Behavior",defaultValue:false},enabled:{type:"boolean",group:"Behavior",defaultValue:true},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:''},design:{type:"sap.m.ToolbarDesign",group:"Appearance",defaultValue:b.Auto}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{parameters:{srcControl:{type:"sap.ui.core.Control"}}}},designTime:true}});
E.call(c.prototype);c.shrinkClass="sapMTBShrinkItem";
c.isRelativeWidth=function(w){return/^([-+]?\d+%|auto|inherit|)$/i.test(w);};
c.checkOverflow=function(e){if(!e||!e.length){return false;}e.children().each(function(){this.style.width=c.getOrigWidth(this.id);});return e[0].scrollWidth>e[0].clientWidth;};
c.getOrigWidth=function(i){var o=sap.ui.getCore().byId(i);if(!o||!o.getWidth){return"";}return o.getWidth();};
c.checkShrinkable=function(o,s){if(o instanceof a){return this.isRelativeWidth(o.getWidth());}s=s||this.shrinkClass;o.removeStyleClass(s);var w=this.getOrigWidth(o.getId());if(!this.isRelativeWidth(w)){return;}var L=o.getLayoutData();if(L instanceof T){return L.getShrinkable()&&o.addStyleClass(s);}if(w.indexOf("%")>0||o.getMetadata().isInstanceOf("sap.ui.core.IShrinkable")){return o.addStyleClass(s);}var d=o.getDomRef();if(d&&(d.firstChild||{}).nodeType==3){return o.addStyleClass(s);}};
c.flexie=function(e,f,s){if(!e||!e.length||!e.width()){return;}s=s||this.shrinkClass;f=f||a.flexClass;var t=0,F=[],S=[],i=0,I=e.width(),$=e.children(),o=this.checkOverflow(e),d=function(w){return!w||w=="auto"||w=="inherit";},g=function(j){i+=j.outerWidth(true);},p=function(j){var k=parseFloat(j.css("width"))||0;var m=parseFloat(j.css("min-width"))||0;if(k==m){g(j);return;}var n=0;var w=j.width();var P=(w*100)/I;t+=P;i+=j.outerWidth(true)-w;if(j.css("box-sizing")=="border-box"){n=j.outerWidth()-w;}var M=j.css("max-width");var u=parseFloat(M);if(M.indexOf("%")>0){u=Math.ceil((u*e.outerWidth())/100);}S.push({boxSizing:n,maxWidth:u,minWidth:m,percent:P,el:j[0]});},h=function(j){var k=0;S.forEach(function(m,n){var u=Math.min(100,(m.percent*100)/t);var v=Math.floor((j*u)/100);var w=m.boxSizing+v;if(w<m.minWidth){m.el.style.width=m.minWidth+"px";j-=(m.minWidth-m.boxSizing);t-=m.percent;delete S[n];}if(m.maxWidth&&m.maxWidth>m.minWidth&&w>m.maxWidth){m.el.style.width=m.maxWidth+"px";j+=(w-m.maxWidth);t-=m.percent;delete S[n];}});S.forEach(function(m){var n=Math.min(100,(m.percent*100)/t);var u=(j*n)/100;var v=m.boxSizing+u;m.el.style.width=v+"px";k+=v;});j-=k;if(j>1){F.forEach(function(m){var w=j/F.length;m.style.width=w+"px";});}};$.each(function(){var j=q(this);var A=d(this.style.width);if(A&&j.hasClass(f)){F.push(this);this.style.width="0px";}else if(j.is(":hidden")){return;}else if(o&&j.hasClass(s)){p(j);}else{g(j);}});var r=I-i;h(Math.max(r,0));};
c.hasFlexBoxSupport=q.support.hasFlexBoxSupport;c.hasNewFlexBoxSupport=(function(){var s=document.documentElement.style;return(s.flex!==undefined||s.msFlex!==undefined||s.webkitFlexShrink!==undefined);}());
c.prototype.init=function(){this.data("sap-ui-fastnavgroup","true",true);this._oContentDelegate={onAfterRendering:this._onAfterContentRendering};};
c.prototype.onBeforeRendering=function(){this._cleanup();};
c.prototype.onAfterRendering=function(){if(!this._checkContents()){return;}this._doLayout();};
c.prototype.exit=function(){this._cleanup();};
c.prototype.onLayoutDataChange=function(){this.rerender();};
c.prototype.addContent=function(o){this.addAggregation("content",o);this._onContentInserted(o);return this;};
c.prototype.insertContent=function(o,i){this.insertAggregation("content",o,i);this._onContentInserted(o);return this;};
c.prototype.removeContent=function(v){v=this.removeAggregation("content",v);this._onContentRemoved(v);return v;};
c.prototype.removeAllContent=function(){var d=this.removeAllAggregation("content")||[];d.forEach(this._onContentRemoved,this);return d;};
c.prototype.ontap=function(e){if(this.getActive()&&!e.isMarked()){e.setMarked();this.firePress({srcControl:e.srcControl});}};
c.prototype.onsapenter=function(e){if(this.getActive()&&e.srcControl===this&&!e.isMarked()){e.setMarked();this.firePress({srcControl:this});}};
c.prototype.onsapspace=c.prototype.onsapenter;
c.prototype.ontouchstart=function(e){this.getActive()&&e.setMarked();};
c.prototype._checkContents=function(){var s=0;this.getContent().forEach(function(o){if(c.checkShrinkable(o)){s++;}});return s;};
c.prototype._doLayout=function(){if(c.hasNewFlexBoxSupport){return;}if(c.hasFlexBoxSupport){this._resetOverflow();}else{this._reflexie();}};
c.prototype._resetOverflow=function(){this._deregisterResize();var t=this.$();var d=t[0]||{};t.removeClass("sapMTBOverflow");var o=d.scrollWidth>d.clientWidth;o&&t.addClass("sapMTBOverflow");this._iEndPoint=this._getEndPoint();this._registerResize();};
c.prototype._reflexie=function(){this._deregisterResize();c.flexie(this.$());this._iEndPoint=this._getEndPoint();this._registerResize();};
c.prototype._onContentInserted=function(o){if(o){o.attachEvent("_change",this._onContentPropertyChanged,this);o.addEventDelegate(this._oContentDelegate,o);}};
c.prototype._onContentRemoved=function(o){if(o){o.detachEvent("_change",this._onContentPropertyChanged,this);o.removeEventDelegate(this._oContentDelegate,o);}};
c.prototype._onAfterContentRendering=function(){var L=this.getLayoutData();if(L instanceof T){L.applyProperties();}};
c.prototype._onContentPropertyChanged=function(e){if(e.getParameter("name")!="width"){return;}var o=e.getSource();var p=o.getWidth().indexOf("%")>0;o.toggleStyleClass(c.shrinkClass,p);};
c.prototype._registerContentResize=function(){sap.ui.getCore().attachIntervalTimer(this._handleContentResize,this);};
c.prototype._deregisterContentResize=function(){sap.ui.getCore().detachIntervalTimer(this._handleContentResize,this);};
c.prototype._registerToolbarResize=function(){if(c.isRelativeWidth(this.getWidth())){var r=q.proxy(this._handleToolbarResize,this);this._sResizeListenerId=R.register(this,r);}};
c.prototype._deregisterToolbarResize=function(){sap.ui.getCore().detachIntervalTimer(this._handleContentResize,this);if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId="";}};
c.prototype._registerResize=function(){this._registerToolbarResize();this._registerContentResize();};
c.prototype._deregisterResize=function(){this._deregisterToolbarResize();this._deregisterContentResize();};
c.prototype._cleanup=function(){this._deregisterResize();};
c.prototype._getEndPoint=function(){var L=(this.getDomRef()||{}).lastElementChild;if(L){var e=L.offsetLeft;if(!sap.ui.getCore().getConfiguration().getRTL()){e+=L.offsetWidth;}}return e||0;};
c.prototype._handleToolbarResize=function(){this._handleResize(false);};
c.prototype._handleContentResize=function(){this._handleResize(true);};
c.prototype._handleResize=function(d){if(d&&this._iEndPoint==this._getEndPoint()){return;}this._doLayout();};
c.prototype.setDesign=function(d,s){if(!s){return this.setProperty("design",d);}this._sAutoDesign=this.validateProperty("design",d);return this;};
c.prototype.getActiveDesign=function(){var d=this.getDesign();if(d!=b.Auto){return d;}return this._sAutoDesign||d;};
c.prototype.getTitleId=function(){if(!sap.m.Title){return"";}var d=this.getContent();for(var i=0;i<d.length;i++){var o=d[i];if(o instanceof sap.m.Title){return o.getId();}}return"";};
c.prototype.isContextSensitive=B.prototype.isContextSensitive;c.prototype.setHTMLTag=B.prototype.setHTMLTag;c.prototype.getHTMLTag=B.prototype.getHTMLTag;c.prototype.applyTagAndContextClassFor=B.prototype.applyTagAndContextClassFor;c.prototype._setLandmarkInfo=B.prototype._setLandmarkInfo;c.prototype._writeLandmarkInfo=B.prototype._writeLandmarkInfo;return c;},true);
sap.ui.predefine('sap/m/ToolbarLayoutData',['jquery.sap.global','./library','sap/ui/core/LayoutData'],function(q,l,L){"use strict";
var T=L.extend("sap.m.ToolbarLayoutData",{metadata:{library:"sap.m",properties:{shrinkable:{type:"boolean",group:"Behavior",defaultValue:false},minWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}}}});
T.prototype.getParentStyle=function(){var p=this.getParent();if(!p||!p.getDomRef){return{};}var d=p.getDomRef();return d?d.style:{};};
T.prototype.applyProperties=function(){var s=this.getParentStyle();s.minWidth=this.getMinWidth();s.maxWidth=this.getMaxWidth();return this;};
return T;},true);
sap.ui.predefine('sap/m/ToolbarRenderer',['jquery.sap.global','./BarInPageEnabler'],function(q,B){"use strict";var T={};T.render=B.prototype.render;
T.decorateRootElement=function(r,t){r.addClass("sapMTB");var c=t.getContent();if(t.getActive()&&(!c||c.length===0)){r.writeAccessibilityState(t,{role:"button"});}else{t._writeLandmarkInfo(r,t);}if(!sap.m.Toolbar.hasFlexBoxSupport){r.addClass("sapMTBNoFlex");}else if(!sap.m.Toolbar.hasNewFlexBoxSupport){r.addClass("sapMTBOldFlex");}else{r.addClass("sapMTBNewFlex");}if(t.getActive()){r.addClass("sapMTBActive");r.writeAttribute("tabindex","0");}else{r.addClass("sapMTBInactive");}r.addClass("sapMTB-"+t.getActiveDesign()+"-CTX");var w=t.getWidth();var h=t.getHeight();w&&r.addStyle("width",w);h&&r.addStyle("height",h);};
T.renderBarContent=function(r,t){t.getContent().forEach(function(c){sap.m.BarInPageEnabler.addChildClassTo(c,t);r.renderControl(c);});};
T.shouldAddIBarContext=function(c){return false;};
return T;},true);
sap.ui.predefine('sap/m/ToolbarSeparator',['jquery.sap.global','./library','sap/ui/core/Control'],function(q,l,C){"use strict";
var T=C.extend("sap.m.ToolbarSeparator",{metadata:{library:"sap.m"}});
return T;},true);
sap.ui.predefine('sap/m/ToolbarSeparatorRenderer',['jquery.sap.global','sap/ui/core/Renderer'],function(q,R){"use strict";var T={};
T.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMTBSeparator");r.writeAccessibilityState(c,{role:"separator"});r.writeClasses();r.write("></div>");};
return T;},true);
sap.ui.predefine('sap/m/ToolbarSpacer',['jquery.sap.global','./library','sap/ui/core/Control'],function(q,l,C){"use strict";
var T=C.extend("sap.m.ToolbarSpacer",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:''}}}});
T.flexClass="sapMTBSpacerFlex";return T;},true);
sap.ui.predefine('sap/m/ToolbarSpacerRenderer',['jquery.sap.global','sap/ui/core/Renderer'],function(q,R){"use strict";var T={};
T.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMTBSpacer");var w=c.getWidth();if(w){r.addStyle("width",w);}else{r.addClass(sap.m.ToolbarSpacer.flexClass);}r.writeStyles();r.writeClasses();r.write("></div>");};
return T;},true);
sap.ui.predefine('sap/m/Tree',['jquery.sap.global','./ListBase','./TreeItemBase','./library','sap/ui/core/Element','sap/ui/model/ClientTreeBindingAdapter','sap/ui/model/TreeBindingCompatibilityAdapter','sap/ui/base/ManagedObjectMetadata','sap/ui/model/odata/ODataTreeBinding','sap/ui/model/odata/v2/ODataTreeBinding','sap/ui/model/ClientTreeBinding'],function(q,L,T,l,E,C,a,M,O,V,b){"use strict";
var c=L.extend("sap.m.Tree",{metadata:{library:"sap.m"}});
c.prototype.isTreeBinding=function(n){return(n=="items");};
c.prototype.getBinding=function(n){n=n||"items";var B=L.prototype.getBinding.call(this,n);if(B&&n==="items"&&!B.getLength){if(O&&B instanceof O){a(B,this);}else if(V&&B instanceof V){B.applyAdapterInterface();}else if(b&&B instanceof b){C.apply(B);}else{q.sap.log.error("TreeBinding is not supported for the control "+this);}}return B;};
c.prototype.updateItems=function(r){var B=this.getBindingInfo("items"),o=this.getBinding("items"),f=B.factory,d;function u(e,d){var g=e.getItems()||[],h,j;if(g.length>d.length){for(var i=d.length;i<g.length;i++){e.removeItem(g[i]);g[i].destroy("KeepDom");}}for(var i=0;i<d.length;i++){h=d[i];j=g[i];if(j){j.setBindingContext(h,B.model);}else{j=f(e.getId()+"-"+i,h);j.setBindingContext(h,B.model);e.addItem(j);}}}d=o.getContexts(0,Number.MAX_VALUE);if(!B.template){this.destroyItems();}u(this,d);};
c.prototype.validateAggregation=function(A,o,m){var r=L.prototype.validateAggregation.apply(this,arguments);if(A==="items"&&!(o instanceof T)){throw new Error(o+" is not a valid items aggregation of "+this+". Items aggregation in Tree control only supports TreeItemBase-based objects, e.g. StandardTreeItem.");}return r;};
c.prototype.onItemExpanderPressed=function(i,e){var I=this.indexOfItem(i);var B=this.getBindingInfo("items");if(B&&i&&i.getBindingContext(B.model)){if(e==undefined){this.getBinding("items").toggleIndex(I);}else if(e){this.getBinding("items").expand(I);}else{this.getBinding("items").collapse(I);}}};
return c;},true);
sap.ui.predefine('sap/m/TreeItemBase',['jquery.sap.global','./ListItemBase','./library','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/Icon'],function(q,L,l,E,I,a){"use strict";
var T=L.extend("sap.m.TreeItemBase",{metadata:{library:"sap.m"}});
T.prototype.ExpandedIconURI=I.getIconURI("navigation-down-arrow");T.prototype.CollapsedIconURI=I.getIconURI("navigation-right-arrow");
T.prototype.getTree=function(){var p=this.getParent();if(p instanceof sap.m.Tree){return p;}};
T.prototype.getList=T.prototype.getTree;T.prototype.informTree=T.prototype.informList;
T.prototype.getItemNodeContext=function(){var t=this.getTree();var c=null;var b=null;if(t){b=t.getBinding("items");c=b.getNodeByIndex(t.indexOfItem(this));}return c;};
T.prototype.getParentNode=function(){if(this.isTopLevel()){return;}var t=this.getTree(),n=this.getLevel(),p=null,i=t.indexOfItem(this)-1,b=t.getItems(),c;while(i>=0){c=b[i].getLevel();if(c===n-1){p=b[i];break;}i--;}return p;};
T.prototype.getParentNodeContext=function(){return this.getItemNodeContext().parent;};
T.prototype.isLeaf=function(){return(this.getItemNodeContext()||{}).isLeaf;};
T.prototype.isTopLevel=function(){return(this.getLevel()===0);};
T.prototype.getLevel=function(){return(this.getItemNodeContext()||{}).level;};
T.prototype.getExpanded=function(){var e=false;if(this.getItemNodeContext()&&this.getItemNodeContext().nodeState){e=this.getItemNodeContext().nodeState.expanded;}return e;};
T.prototype.setSelected=function(s){L.prototype.setSelected.apply(this,arguments);var t=this.getTree();var b=null;var i=-1;if(t){b=t.getBinding("items");i=t.indexOfItem(this);if(t.getMode()===sap.m.ListMode.SingleSelect){b.setSelectedIndex(i);}if(t.getMode()===sap.m.ListMode.MultiSelect){if(s){b.addSelectionInterval(i,i);}else{b.removeSelectionInterval(i,i);}}}return this;};
T.prototype._getExpanderControl=function(){var s="";if(!this.isLeaf()){s=this.getExpanded()?this.ExpandedIconURI:this.CollapsedIconURI;}if(this._oExpanderControl){this._oExpanderControl.setSrc(s);return this._oExpanderControl;}this._oExpanderControl=new a({id:this.getId()+"-expander",src:s,useIconTooltip:false,noTabStop:true}).setParent(this,null,true).addStyleClass("sapMTreeItemBaseExpander").attachPress(function(e){this.informTree("ExpanderPressed");},this);return this._oExpanderControl;};
T.prototype._getLevelIndentCSS=function(){return this.getLevel();};
T.prototype.onsapplus=function(e){this.informTree("ExpanderPressed",true);};
T.prototype.onsapminus=function(e){this.informTree("ExpanderPressed",false);};
T.prototype.onsapright=function(e){if(this.isLeaf()){return;}if(!this.getExpanded()){this.informTree("ExpanderPressed",true);}else{e.keyCode=q.sap.KeyCodes.ARROW_DOWN;}};
T.prototype.onsapleft=function(e){if(this.isTopLevel()&&!this.getExpanded()){return;}if(!this.isLeaf()){if(this.getExpanded()){this.informTree("ExpanderPressed",false);}else{this.getParentNode().focus();}}else{this.getParentNode().focus();}};
T.prototype.onsapbackspace=function(e){if(!this.isTopLevel()){this.getParentNode().focus();}};
T.prototype.exit=function(){L.prototype.exit.apply(this,arguments);this.destroyControls(["Expander"]);};
return T;},true);
sap.ui.predefine('sap/m/TreeItemBaseRenderer',['jquery.sap.global','./ListItemBaseRenderer','sap/ui/core/Renderer'],function(q,L,R){"use strict";var T=R.extend(L);
T.renderLIAttributes=function(r,l){r.addClass("sapMTreeItemBase");if(!l.isTopLevel()){r.addClass("sapMTreeItemBaseChildren");}var i=l._getLevelIndentCSS();if(sap.ui.getCore().getConfiguration().getRTL()){r.addStyle("padding-right",i+"rem");}else{r.addStyle("padding-left",i+"rem");}};
T.renderContentFormer=function(r,l){this.renderExpander(r,l);L.renderContentFormer.call(this,r,l);};
T.renderExpander=function(r,l){var e=l._getExpanderControl();if(e){r.renderControl(e);}};
T.getAriaRole=function(l){return"treeitem";};
T.getAccessibilityState=function(l){var a=L.getAccessibilityState.call(this,l);a.level=l.getLevel();a.expanded=l.getExpanded();return a;};
return T;},true);
sap.ui.predefine('sap/m/TreeRenderer',['sap/ui/core/Renderer','./ListBaseRenderer'],function(R,L){"use strict";var T=R.extend(L);
T.getAriaRole=function(c){return"tree";};
return T;},true);
sap.ui.predefine('sap/m/UploadCollection',['jquery.sap.global','./MessageBox','./Dialog','./library','sap/ui/core/Control','sap/ui/unified/FileUploaderParameter',"sap/ui/unified/FileUploader",'sap/ui/core/format/FileSizeFormat','sap/m/Link','sap/m/OverflowToolbar','./ObjectAttribute','./ObjectStatus',"./UploadCollectionItem","sap/ui/core/HTML","./BusyIndicator","./CustomListItem","sap/ui/core/ResizeHandler","sap/ui/Device","./CustomListItemRenderer","sap/ui/core/HTMLRenderer","./LinkRenderer","./ObjectAttributeRenderer","./ObjectStatusRenderer","./ObjectMarkerRenderer","./TextRenderer","./DialogRenderer"],function(q,M,D,L,C,F,a,b,c,O,d,f,U,H,B,g,R,h){"use strict";
var k=C.extend("sap.m.UploadCollection",{
constructor:function(i,s){var I;if(s&&s.instantUpload===false){I=s.instantUpload;delete s.instantUpload;}else if(i&&i.instantUpload===false){I=i.instantUpload;delete i.instantUpload;}if(s&&s.mode===sap.m.ListMode.MultiSelect&&I===false){s.mode=sap.m.ListMode.None;q.sap.log.info("sap.m.ListMode.MultiSelect is not supported by UploadCollection for Upload Pending scenario. Value has been resetted to 'None'");}else if(i&&i.mode===sap.m.ListMode.MultiSelect&&I===false){i.mode=sap.m.ListMode.None;q.sap.log.info("sap.m.ListMode.MultiSelect is not supported by UploadCollection for Upload Pending scenario. Value has been resetted to 'None'");}try{C.apply(this,arguments);if(I===false){this.bInstantUpload=I;this._oFormatDecimal=b.getInstance({binaryFilesize:false,maxFractionDigits:1,maxIntegerDigits:3});}}catch(e){this.destroy();throw e;}},
metadata:{library:"sap.m",properties:{fileType:{type:"string[]",group:"Data",defaultValue:null},maximumFilenameLength:{type:"int",group:"Data",defaultValue:null},maximumFileSize:{type:"float",group:"Data",defaultValue:null},mimeType:{type:"string[]",group:"Data",defaultValue:null},multiple:{type:"boolean",group:"Behavior",defaultValue:false},noDataText:{type:"string",group:"Behavior",defaultValue:null},sameFilenameAllowed:{type:"boolean",group:"Behavior",defaultValue:false},showSeparators:{type:"sap.m.ListSeparators",group:"Appearance",defaultValue:sap.m.ListSeparators.All},uploadEnabled:{type:"boolean",group:"Behavior",defaultValue:true},uploadUrl:{type:"string",group:"Data",defaultValue:"../../../upload"},instantUpload:{type:"boolean",group:"Behavior",defaultValue:true},numberOfAttachmentsText:{type:"string",group:"Appearance",defaultValue:null},mode:{type:"sap.m.ListMode",group:"Behavior",defaultValue:"None"},uploadButtonInvisible:{type:"boolean",group:"Appearance",defaultValue:false},terminationEnabled:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.UploadCollectionItem",multiple:true,singularName:"item",bindable:"bindable"},headerParameters:{type:"sap.m.UploadCollectionParameter",multiple:true,singularName:"headerParameter"},parameters:{type:"sap.m.UploadCollectionParameter",multiple:true,singularName:"parameter"},toolbar:{type:"sap.m.OverflowToolbar",multiple:false},_list:{type:"sap.m.List",multiple:false,visibility:"hidden"}},events:{change:{parameters:{documentId:{type:"string"},files:{type:"object[]"}}},fileDeleted:{parameters:{documentId:{type:"string"},item:{type:"sap.m.UploadCollectionItem"}}},filenameLengthExceed:{parameters:{documentId:{type:"string"},files:{type:"object[]"}}},fileRenamed:{parameters:{documentId:{type:"string"},fileName:{type:"string"},item:{type:"sap.m.UploadCollectionItem"}}},fileSizeExceed:{parameters:{documentId:{type:"string"},fileSize:{type:"string"},files:{type:"object[]"}}},typeMissmatch:{parameters:{documentId:{type:"string"},fileType:{type:"string"},mimeType:{type:"string"},files:{type:"object[]"}}},uploadComplete:{parameters:{readyStateXHR:{type:"string"},response:{type:"string"},status:{type:"string"},files:{type:"object[]"}}},uploadTerminated:{parameters:{fileName:{type:"string"},getHeaderParameter:{type:"function",parameters:{headerParameterName:{type:"string"}}}}},beforeUploadStarts:{parameters:{fileName:{type:"string"},addHeaderParameter:{type:"function",parameters:{headerParameter:{type:"sap.m.UploadCollectionParameter"}}},getHeaderParameter:{type:"function",parameters:{headerParameterName:{type:"string"}}}}},selectionChange:{parameters:{selectedItem:{type:"sap.m.UploadCollectionItem"},selectedItems:{type:"sap.m.UploadCollectionItem[]"},selected:{type:"boolean"}}}}}
});
k._uploadingStatus="uploading";k._displayStatus="display";k._toBeDeletedStatus="toBeDeleted";k._pendingUploadStatus="pendingUploadStatus";k._placeholderCamera='sap-icon://camera';k._markerMargin=8;if(h.system.phone){k._resizeTimeoutInterval=500;}else{k._resizeTimeoutInterval=100;}
k.prototype.init=function(){k.prototype._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._headerParamConst={requestIdName:"requestId"+q.now(),fileNameRequestIdName:"fileNameRequestId"+q.now()};this._requestIdValue=0;this._iFUCounter=0;this._oList=new sap.m.List(this.getId()+"-list");this.setAggregation("_list",this._oList,true);this._oList.addStyleClass("sapMUCList");this._iUploadStartCallCounter=0;this.aItems=[];this._aDeletedItemForPendingUpload=[];this._aFileUploadersForPendingUpload=[];this._iFileUploaderPH=null;this._oListEventDelegate=null;this._oItemToUpdate=null;this._sReziseHandlerId=null;};
k.prototype.setFileType=function(e){if(!e){return this;}if(!this.getInstantUpload()){q.sap.log.info("As property instantUpload is false it is not allowed to change fileType at runtime.");}else{var j=e.length;for(var i=0;i<j;i++){e[i]=e[i].toLowerCase();}this.setProperty("fileType",e);if(this._getFileUploader().getFileType()!==e){this._getFileUploader().setFileType(e);}}return this;};
k.prototype.setMaximumFilenameLength=function(m){if(!this.getInstantUpload()){q.sap.log.info("As property instantUpload is false it is not allowed to change maximumFilenameLength at runtime.");}else{this.setProperty("maximumFilenameLength",m,true);if(this._getFileUploader().getMaximumFilenameLength()!==m){this._getFileUploader().setMaximumFilenameLength(m);}}return this;};
k.prototype.setMaximumFileSize=function(m){if(!this.getInstantUpload()){q.sap.log.info("As property instantUpload is false it is not allowed to change maximumFileSize at runtime.");}else{this.setProperty("maximumFileSize",m,true);if(this._getFileUploader().getMaximumFileSize()!==m){this._getFileUploader().setMaximumFileSize(m);}}return this;};
k.prototype.setMimeType=function(m){if(!this.getInstantUpload()){q.sap.log.info("As property instantUpload is false it is not allowed to change mimeType at runtime.");}else{this.setProperty("mimeType",m);if(this._getFileUploader().getMimeType()!==m){this._getFileUploader().setMimeType(m);}return this;}};
k.prototype.setMultiple=function(m){if(!this.getInstantUpload()){q.sap.log.info("As property instantUpload is false it is not allowed to change multiple at runtime.");}else{this.setProperty("multiple",m);if(this._getFileUploader().getMultiple()!==m){this._getFileUploader().setMultiple(m);}return this;}};
k.prototype.setNoDataText=function(n){this.setProperty("noDataText",n);if(this._oList.getNoDataText()!==n){this._oList.setNoDataText(n);}return this;};
k.prototype.setShowSeparators=function(s){this.setProperty("showSeparators",s);if(this._oList.getShowSeparators()!==s){this._oList.setShowSeparators(s);}return this;};
k.prototype.setUploadEnabled=function(u){if(!this.getInstantUpload()){q.sap.log.info("As property instantUpload is false it is not allowed to change uploadEnabled at runtime.");}else{this.setProperty("uploadEnabled",u);if(this._getFileUploader().getEnabled()!==u){this._getFileUploader().setEnabled(u);}}return this;};
k.prototype.setUploadUrl=function(u){if(!this.getInstantUpload()){q.sap.log.info("As property instantUpload is false it is not allowed to change uploadUrl at runtime.");}else{this.setProperty("uploadUrl",u);if(this._getFileUploader().getUploadUrl()!==u){this._getFileUploader().setUploadUrl(u);}}return this;};
k.prototype.setInstantUpload=function(){q.sap.log.error("It is not supported to change the behavior at runtime.");return this;};
k.prototype.setMode=function(m){if(m===sap.m.ListMode.Delete){this._oList.setMode(sap.m.ListMode.None);q.sap.log.info("sap.m.ListMode.Delete is not supported by UploadCollection. Value has been resetted to 'None'");}else if(m===sap.m.ListMode.MultiSelect&&!this.getInstantUpload()){this._oList.setMode(sap.m.ListMode.None);q.sap.log.info("sap.m.ListMode.MultiSelect is not supported by UploadCollection for Pending Upload. Value has been resetted to 'None'");}else{this._oList.setMode(m);}return this;};
k.prototype.getMode=function(){return this._oList.getMode();};
k.prototype.getToolbar=function(){return this._oHeaderToolbar;};
k.prototype.setUploadButtonInvisible=function(u){if(this.getUploadButtonInvisible()===u){return this;}this.setProperty("uploadButtonInvisible",u,true);if(this.getInstantUpload()){this._getFileUploader().setVisible(!u);}else{this._setFileUploaderVisibility(u);}return this;};
k.prototype.upload=function(){if(this.getInstantUpload()){q.sap.log.error("Not a valid API call. 'instantUpload' should be set to 'false'.");}var e=this._aFileUploadersForPendingUpload.length;for(var i=0;i<e;i++){this._iUploadStartCallCounter=0;this._aFileUploadersForPendingUpload[i].upload();}};
k.prototype.getSelectedItems=function(){var s=this._oList.getSelectedItems();return this._getUploadCollectionItemsByListItems(s);};
k.prototype.getSelectedItem=function(){var s=this._oList.getSelectedItem();if(s){return this._getUploadCollectionItemByListItem(s);}};
k.prototype.setSelectedItemById=function(i,s){this._oList.setSelectedItemById(i+"-cli",s);this._setSelectedForItems([this._getUploadCollectionItemById(i)],s);return this;};
k.prototype.setSelectedItem=function(u,s){this.setSelectedItemById(u.getId(),s);return this;};
k.prototype.selectAll=function(){var s=this._oList.selectAll();if(s.getItems().length!==this.getItems().length){q.sap.log.info("Internal 'List' and external 'UploadCollection' are not in sync.");}this._setSelectedForItems(this.getItems(),true);return this;};
k.prototype.downloadItem=function(u,e){if(!this.getInstantUpload()){q.sap.log.info("Download is not possible on Pending Upload mode");return false;}else{return u.download(e);}};
k.prototype.openFileDialog=function(i){if(this._oFileUploader){if(i){if(!this._oFileUploader.getMultiple()){this._oItemToUpdate=i;this._oFileUploader.$().find("input[type=file]").trigger("click");}else{q.sap.log.warning("Version Upload cannot be used in multiple upload mode");}}else{this._oFileUploader.$().find("input[type=file]").trigger("click");}}return this;};
k.prototype.removeAggregation=function(A,o,s){if(!this.getInstantUpload()&&A==="items"&&o){this._aDeletedItemForPendingUpload.push(o);}if(C.prototype.removeAggregation){return C.prototype.removeAggregation.apply(this,arguments);}};
k.prototype.removeAllAggregation=function(A,s){if(!this.getInstantUpload()&&A==="items"){if(this._aFileUploadersForPendingUpload){for(var i=0;i<this._aFileUploadersForPendingUpload.length;i++){this._aFileUploadersForPendingUpload[i].destroy();this._aFileUploadersForPendingUpload[i]=null;}this._aFileUploadersForPendingUpload=[];}}if(C.prototype.removeAllAggregation){return C.prototype.removeAllAggregation.apply(this,arguments);}};
k.prototype.onBeforeRendering=function(){this._RenderManager=this._RenderManager||sap.ui.getCore().createRenderManager();var i,e;if(this._oListEventDelegate){this._oList.removeEventDelegate(this._oListEventDelegate);this._oListEventDelegate=null;}this._deregisterSizeHandler();j.bind(this)();if(!this.getInstantUpload()){this.aItems=this.getItems();this._getListHeader(this.aItems.length);this._clearList();this._fillList(this.aItems);this._oList.setHeaderToolbar(this._oHeaderToolbar);return;}if(this.aItems.length>0){e=this.aItems.length;var u=[];for(i=0;i<e;i++){if(this.aItems[i]&&this.aItems[i]._status===k._uploadingStatus){u.push(this.aItems[i]);}else if(this.aItems[i]&&this.aItems[i]._status!==k._uploadingStatus&&this.aItems[i]._percentUploaded===100&&this.getItems().length===0){u.push(this.aItems[i]);}}if(u.length!==0){this.aItems=[];this.aItems=this.getItems();this.aItems=u.concat(this.aItems);}else{this.aItems=this.getItems();}}else{this.aItems=this.getItems();}this._getListHeader(this.aItems.length);this._clearList();this._fillList(this.aItems);this._oList.setAggregation("headerToolbar",this._oHeaderToolbar,true);if((h.browser.msie&&h.browser.version<=9)&&this.aItems.length>0&&this.aItems[0]._status===k._uploadingStatus){this._oFileUploader.setEnabled(false);}else{if(this.sErrorState!=="Error"){if(this.getUploadEnabled()!==this._oFileUploader.getEnabled()){this._oFileUploader.setEnabled(this.getUploadEnabled());}}else{this._oFileUploader.setEnabled(false);}}if(this.sDeletedItemId){q(document.activeElement).blur();}function j(){if(this.bInstantUpload===false){this.setProperty("instantUpload",this.bInstantUpload,true);delete this.bInstantUpload;}}};
k.prototype.onAfterRendering=function(){var t=this;if(this.getInstantUpload()){if(this.aItems||(this.aItems===this.getItems())){if(this.editModeItem){var $=q.sap.byId(this.editModeItem+"-ta_editFileName-inner");if($){var i=this.editModeItem;if(!h.os.ios){$.focus(function(){$.selectText(0,$.val().length);});}$.focus();this._oListEventDelegate={onclick:function(e){sap.m.UploadCollection.prototype._handleClick(e,t,i);}};this._oList.addDelegate(this._oListEventDelegate);}}else if(this.sFocusId){sap.m.UploadCollection.prototype._setFocus2LineItem(this.sFocusId);this.sFocusId=null;}else if(this.sDeletedItemId){sap.m.UploadCollection.prototype._setFocusAfterDeletion(this.sDeletedItemId,t);}}}else{if(this.sFocusId){sap.m.UploadCollection.prototype._setFocus2LineItem(this.sFocusId);this.sFocusId=null;}}};
k.prototype.exit=function(){var i,p;if(this._oFileUploader){this._oFileUploader.destroy();this._oFileUploader=null;}if(this._oHeaderToolbar){this._oHeaderToolbar.destroy();this._oHeaderToolbar=null;}if(this._oNumberOfAttachmentsTitle){this._oNumberOfAttachmentsTitle.destroy();this._oNumberOfAttachmentsTitle=null;}if(this._RenderManager){this._RenderManager.destroy();}if(this._aFileUploadersForPendingUpload){p=this._aFileUploadersForPendingUpload.length;for(i=0;i<p;i++){this._aFileUploadersForPendingUpload[i].destroy();this._aFileUploadersForPendingUpload[i]=null;}this._aFileUploadersForPendingUpload=null;}this._deregisterSizeHandler();};
k.prototype._deregisterSizeHandler=function(){h.orientation.detachHandler(this._onResize,this);R.deregister(this._sReziseHandlerId);};
k.prototype._hideFileUploaders=function(){var t,i;if(!this.getInstantUpload()){t=this._oHeaderToolbar.getContent().length;if(this._aFileUploadersForPendingUpload.length){for(i=0;i<t;i++){if(this._oHeaderToolbar.getContent()[i]instanceof sap.ui.unified.FileUploader){if(i===this._iFileUploaderPH&&this._bFocusFileUploader){this._oHeaderToolbar.getContent()[i].$().find("button").focus();}else{this._oHeaderToolbar.getContent()[i].$().hide();}}}}return;}};
k.prototype._truncateFileName=function(I){if(I._status==="Edit"){var s=I.getId()+"-cli";this.$().find("#"+s).find(".sapMUCObjectMarkerContainer").attr("style","display: none");return;}var m=0;var e=I.getMarkers();var S;for(var i=0;i<e.length;i++){m=m+e[i].$().width()+k._markerMargin;}if(m>0){var $=this.$().find("#"+I.getId()+"-ta_filenameHL");if($){S="max-width: calc(100% - "+m+"px)";if($.attr("style")!==S){$.attr("style",S);}}}};
k.prototype._getListHeader=function(I){var o,i;this._setNumberOfAttachmentsTitle(I);if(!this._oHeaderToolbar){if(!!this._oFileUploader&&!this.getInstantUpload()){this._oFileUploader.destroy();}o=this._getFileUploader();this._oHeaderToolbar=this.getAggregation("toolbar");if(!this._oHeaderToolbar){this._oHeaderToolbar=new sap.m.OverflowToolbar(this.getId()+"-toolbar",{content:[this._oNumberOfAttachmentsTitle,new sap.m.ToolbarSpacer(),o]}).addEventDelegate({onAfterRendering:this._hideFileUploaders},this);this._iFileUploaderPH=2;}else{this._oHeaderToolbar.addEventDelegate({onAfterRendering:this._hideFileUploaders},this);this._iFileUploaderPH=this._getFileUploaderPlaceHolderPosition(this._oHeaderToolbar);if(this._oHeaderToolbar&&this._iFileUploaderPH>-1){this._setFileUploaderInToolbar(o);}else{q.sap.log.info("A place holder of type 'sap.m.UploadCollectionPlaceholder' needs to be provided.");}}}else if(!this.getInstantUpload()){var p=this._aFileUploadersForPendingUpload.length;for(i=p-1;i>=0;i--){if(this._aFileUploadersForPendingUpload[i].getId()==this._oFileUploader.getId()){o=this._getFileUploader();this._oHeaderToolbar.insertAggregation("content",o,this._iFileUploaderPH,true);break;}}}};
k.prototype._getFileUploaderPlaceHolderPosition=function(t){for(var i=0;i<t.getContent().length;i++){if(t.getContent()[i]instanceof sap.m.UploadCollectionToolbarPlaceholder){return i;}}return-1;};
k.prototype._setFileUploaderInToolbar=function(o){this._oHeaderToolbar.getContent()[this._iFileUploaderPH].setVisible(false);this._oHeaderToolbar.insertContent(o,this._iFileUploaderPH);};
k.prototype._mapItemToListItem=function(i){if(!i||(this._oItemToUpdate&&i.getId()===this._oItemToUpdate.getId())){return null;}var I,s,e,o,l,j,$,m,n,t=this;I=i.getId();s=i._status;e=i.getFileName();if(s===k._uploadingStatus){o=new sap.m.BusyIndicator(I+"-ia_indicator",{visible:true}).addStyleClass("sapMUCloadingIcon");}else{n=this._createIcon(i,I,e,t);}j=I+"-container";$=q.sap.byId(j);if(!!$){$.remove();$=null;}m=new sap.ui.core.HTML({content:"<span id="+j+" class= sapMUCTextButtonContainer> </span>",afterRendering:function(){t._renderContent(i,j,t);}});l=new sap.m.CustomListItem(I+"-cli",{content:[o,n,m],selected:i.getSelected()});l._oUploadCollectionItem=i;l._status=s;l.addStyleClass("sapMUCItem");return l;};
k.prototype._renderContent=function(I,s,t){var e,i,A,S,m,p,j,l,r,n,o;p=I._percentUploaded;j=I.getAllAttributes();l=I.getStatuses();o=I.getMarkers();e=I.getId();A=j.length;S=l.length;m=o.length;n=I._status;r=t._RenderManager;r.write('<div class="sapMUCTextContainer ');if(n==="Edit"){r.write('sapMUCEditMode ');}r.write('" >');r.renderControl(this._getFileNameControl(I,t));if(n===k._uploadingStatus&&!(h.browser.msie&&h.browser.version<=9)){r.renderControl(this._createProgressLabel(e,p));}else{if(m>0){r.write('<div class="sapMUCObjectMarkerContainer">');for(i=0;i<m;i++){r.renderControl(o[i].addStyleClass("sapMUCObjectMarker"));}r.write('</div>');}if(A>0){r.write('<div class="sapMUCAttrContainer">');for(i=0;i<A;i++){j[i].addStyleClass("sapMUCAttr");r.renderControl(j[i]);if((i+1)<A){r.write('<div class="sapMUCSeparator">&nbsp&#x00B7&#160</div>');}}r.write('</div>');}if(S>0){r.write('<div class="sapMUCStatusContainer">');for(i=0;i<S;i++){l[i].detachBrowserEvent("hover");r.renderControl(l[i]);if((i+1)<S){r.write('<div class="sapMUCSeparator">&nbsp&#x00B7&#160</div>');}}r.write('</div>');}}r.write('</div>');this._renderButtons(r,I,n,e,t);r.flush(q.sap.byId(s)[0],true);this._truncateFileName(I);this._sReziseHandlerId=R.register(this,this._onResize.bind(this));h.orientation.attachHandler(this._onResize,this);};
k.prototype._renderButtons=function(r,I,s,e,t){var j,l;j=this._getButtons(I,s,e,t);if(!!j){l=j.length;}if(l>0){r.write('<div class="sapMUCButtonContainer">');for(var i=0;i<l;i++){if((i+1)<l){j[i].addStyleClass("sapMUCFirstButton");}r.renderControl(j[i]);}r.write('</div>');}};
k.prototype._getFileNameControl=function(i,t){var e,o,j,s,l,I,S,m,v,n,p,V;l=i.getFileName();I=i.getId();S=i._status;if(S!=="Edit"){e=true;if(this.sErrorState==="Error"||!q.trim(i.getUrl())){e=false;}o=sap.ui.getCore().byId(I+"-ta_filenameHL");if(!o){o=new sap.m.Link(I+"-ta_filenameHL",{enabled:e,press:function(E){this._triggerLink(E,t);}.bind(this)}).addStyleClass("sapMUCFileName");o.setModel(i.getModel());o.setText(l);}else{o.setModel(i.getModel());o.setText(l);o.setEnabled(e);}return o;}else{j=t._splitFilename(l);m=t.getMaximumFilenameLength();v="None";n=false;s=j.name;if(i.errorState==="Error"){n=true;v="Error";s=i.changedFileName;if(s.length===0){V=this._oRb.getText("UPLOADCOLLECTION_TYPE_FILENAME");}else{V=this._oRb.getText("UPLOADCOLLECTION_EXISTS");}}p=sap.ui.getCore().byId(I+"-ta_editFileName");if(!p){p=new sap.m.Input(I+"-ta_editFileName",{type:sap.m.InputType.Text,fieldWidth:"75%",valueState:v,valueStateText:V,showValueStateMessage:n,description:j.extension}).addStyleClass("sapMUCEditBox");p.setModel(i.getModel());p.setValue(s);}else{p.setModel(i.getModel());p.setValueState(v);p.setFieldWidth("75%");p.setValueStateText(V);p.setValue(s);p.setDescription(j.extension);p.setShowValueStateMessage(n);}if((m-j.extension.length)>0){p.setProperty("maxLength",m-j.extension.length,true);}return p;}};
k.prototype._createProgressLabel=function(i,p){var P;P=sap.ui.getCore().byId(i+"-ta_progress");if(!P){P=new sap.m.Label(i+"-ta_progress",{text:this._oRb.getText("UPLOADCOLLECTION_UPLOADING",[p])}).addStyleClass("sapMUCProgress");}else{P.setText(this._oRb.getText("UPLOADCOLLECTION_UPLOADING",[p]));}return P;};
k.prototype._createIcon=function(i,I,s,t){var T,e,o;T=i.getThumbnailUrl();if(T){o=new sap.m.Image(I+"-ia_imageHL",{src:sap.m.UploadCollection.prototype._getThumbnail(T,s),decorative:false,alt:this._getAriaLabelForPicture(i)}).addStyleClass("sapMUCItemImage");}else{e=sap.m.UploadCollection.prototype._getThumbnail(undefined,s);var S;o=new sap.ui.core.Icon(I+"-ia_iconHL",{src:e,decorative:false,useIconTooltip:false,alt:this._getAriaLabelForPicture(i)});if(this.sErrorState!=="Error"&&q.trim(i.getProperty("url"))){S="sapMUCItemIcon";}else{S="sapMUCItemIconInactive";}if(e===k._placeholderCamera){if(this.sErrorState!=="Error"&&q.trim(i.getProperty("url"))){S=S+" sapMUCItemPlaceholder";}else{S=S+" sapMUCItemPlaceholderInactive";}}o.addStyleClass(S);}if(this.sErrorState!=="Error"&&q.trim(i.getProperty("url"))){o.attachPress(function(E){sap.m.UploadCollection.prototype._triggerLink(E,t);});}return o;};
k.prototype._getButtons=function(i,s,I,t){var e,o,j,l,m,E,n;e=[];if(!this.getInstantUpload()){l="deleteButton";m=this._createDeleteButton(I,l,i,this.sErrorState,t);e.push(m);return e;}if(s==="Edit"){o=sap.ui.getCore().byId(I+"-okButton");if(!o){o=new sap.m.Button({id:I+"-okButton",text:this._oRb.getText("UPLOADCOLLECTION_OKBUTTON_TEXT"),type:sap.m.ButtonType.Transparent}).addStyleClass("sapMUCOkBtn");}j=sap.ui.getCore().byId(I+"-cancelButton");if(!j){j=new sap.m.Button({id:I+"-cancelButton",text:this._oRb.getText("UPLOADCOLLECTION_CANCELBUTTON_TEXT"),type:sap.m.ButtonType.Transparent}).addStyleClass("sapMUCCancelBtn");}e.push(o);e.push(j);return e;}else if(s===k._uploadingStatus&&!(h.browser.msie&&h.browser.version<=9)){l="terminateButton";m=this._createDeleteButton(I,l,i,this.sErrorState,t);e.push(m);return e;}else{E=i.getEnableEdit();if(this.sErrorState==="Error"){E=false;}n=sap.ui.getCore().byId(I+"-editButton");if(!n){if(i.getVisibleEdit()){n=new sap.m.Button({id:I+"-editButton",icon:"sap-icon://edit",type:sap.m.ButtonType.Standard,enabled:E,visible:i.getVisibleEdit(),tooltip:this._oRb.getText("UPLOADCOLLECTION_EDITBUTTON_TEXT"),press:[i,this._handleEdit,this]}).addStyleClass("sapMUCEditBtn");e.push(n);}}else if(!i.getVisibleEdit()){n.destroy();n=null;}else{n.setEnabled(E);n.setVisible(i.getVisibleEdit());e.push(n);}l="deleteButton";if(i.getVisibleDelete()){m=this._createDeleteButton(I,l,i,this.sErrorState,t);e.push(m);}else{m=sap.ui.getCore().byId(I+"-"+l);if(!!m){m.destroy();m=null;}}return e;}};
k.prototype._createDeleteButton=function(i,s,I,e,t){var E,o,j;E=I.getEnableDelete();if(e==="Error"){E=false;}o=sap.ui.getCore().byId(i+"-"+s);if(!o){o=new sap.m.Button({id:i+"-"+s,icon:"sap-icon://sys-cancel",type:sap.m.ButtonType.Standard,enabled:E,tooltip:this._oRb.getText("UPLOADCOLLECTION_TERMINATEBUTTON_TEXT"),visible:I.getVisibleDelete()}).addStyleClass("sapMUCDeleteBtn");if(s==="deleteButton"){o.setTooltip(this._oRb.getText("UPLOADCOLLECTION_DELETEBUTTON_TEXT"));o.attachPress(function(l){this._handleDelete(l,t);}.bind(t));}else if(s==="terminateButton"){if(!this.getTerminationEnabled()){o.setVisible(false);}o.attachPress(function(l){this._handleTerminate.bind(this)(l,I);}.bind(t));}}else{o.setEnabled(E);j=I.getVisibleDelete();if(s==="terminateButton"){j=j&&this.getTerminationEnabled();}o.setVisible(j);}return o;};
k.prototype._fillList=function(i){var t=this;var m=i.length-1;q.each(i,function(I,o){if(!o._status){o._status=k._displayStatus;}else if(t.getInstantUpload()&&t._oItemForDelete&&t._oItemForDelete._status===k._toBeDeletedStatus&&o.getDocumentId()===t._oItemForDelete.documentId){return false;}if(!o._percentUploaded&&o._status===k._uploadingStatus){o._percentUploaded=0;}var l=t._mapItemToListItem(o);if(l){if(I===0&&m===0){l.addStyleClass("sapMUCListSingleItem");}else if(I===0){l.addStyleClass("sapMUCListFirstItem");}else if(I===m){l.addStyleClass("sapMUCListLastItem");}else{l.addStyleClass("sapMUCListItem");}t._oList.addAggregation("items",l,true);o.attachEvent("selected",t._handleItemSetSelected,t);}});t._oList.attachSelectionChange(t._handleSelectionChange,t);};
k.prototype._clearList=function(){if(this._oList){this._oList.destroyAggregation("items",true);}};
k.prototype._setNumberOfAttachmentsTitle=function(i){var n=i||0;var t;if(this._oItemToUpdate){n--;}if(this.getNumberOfAttachmentsText()){t=this.getNumberOfAttachmentsText();}else{t=this._oRb.getText("UPLOADCOLLECTION_ATTACHMENTS",[n]);}if(!this._oNumberOfAttachmentsTitle){this._oNumberOfAttachmentsTitle=new sap.m.Title(this.getId()+"-numberOfAttachmentsTitle",{text:t});}else{this._oNumberOfAttachmentsTitle.setText(t);}};
k.prototype._setFileUploaderVisibility=function(u){var t=this._oHeaderToolbar.getContent();if(t){var p=t[this._iFileUploaderPH];if(p instanceof sap.ui.unified.FileUploader){p.setVisible(!u);}}};
k.prototype._handleDelete=function(e,o){var p=e.getParameters();var I=o.getItems();var s=p.id.split("-deleteButton")[0];var j;var l;var m="";var n;var r;o.sDeletedItemId=s;for(var i=0;i<I.length;i++){if(I[i].sId===s){l=i;j={documentId:I[i].getDocumentId(),_iLineNumber:l};break;}}if(q.sap.byId(o.sId).hasClass("sapUiSizeCompact")){m="sapUiSizeCompact";}if(o.editModeItem){sap.m.UploadCollection.prototype._handleOk(e,o,o.editModeItem,true);if(o.sErrorState==="Error"){return this;}}if(I[l]&&I[l].getEnableDelete()){n=I[l].getFileName();if(!n){r=this._oRb.getText("UPLOADCOLLECTION_DELETE_WITHOUT_FILENAME_TEXT");}else{r=this._oRb.getText("UPLOADCOLLECTION_DELETE_TEXT",n);}o._oItemForDelete=j;sap.m.MessageBox.show(r,{title:this._oRb.getText("UPLOADCOLLECTION_DELETE_TITLE"),actions:[sap.m.MessageBox.Action.OK,sap.m.MessageBox.Action.CANCEL],onClose:o._onCloseMessageBoxDeleteItem.bind(o),dialogId:"messageBoxDeleteFile",styleClass:m});}};
k.prototype._onCloseMessageBoxDeleteItem=function(A){var I=this.getItems();var o;if(this.getInstantUpload()){for(var i=0;i<I.length;i++){if(I[i].getDocumentId()===this._oItemForDelete.documentId){o=I[i];}}}else{o=I[this._oItemForDelete._iLineNumber];}if(A===sap.m.MessageBox.Action.OK){this._oItemForDelete._status=k._toBeDeletedStatus;if(this.getInstantUpload()){this.fireFileDeleted({documentId:this._oItemForDelete.documentId,item:o});}else{if(this.aItems.length===1){this.sFocusId=this._oFileUploader.$().find(":button")[0].id;}else{if(this._oItemForDelete._iLineNumber<this.aItems.length-1){this.sFocusId=this.aItems[this._oItemForDelete._iLineNumber+1].getId()+"-cli";}else{this.sFocusId=this.aItems[0].getId()+"-cli";}}this._aDeletedItemForPendingUpload.push(o);this.aItems.splice(this._oItemForDelete._iLineNumber,1);this.removeAggregation("items",o,false);}}};
k.prototype._handleTerminate=function(e,I){var o,j;o=new sap.m.List({items:[new sap.m.StandardListItem({title:I.getFileName(),icon:this._getIconFromFilename(I.getFileName())})]});j=new sap.m.Dialog({id:this.getId()+"deleteDialog",title:this._oRb.getText("UPLOADCOLLECTION_TERMINATE_TITLE"),content:[new sap.m.Text({text:this._oRb.getText("UPLOADCOLLECTION_TERMINATE_TEXT")}),o],buttons:[new sap.m.Button({text:this._oRb.getText("UPLOADCOLLECTION_OKBUTTON_TEXT"),press:[l,this]}),new sap.m.Button({text:this._oRb.getText("UPLOADCOLLECTION_CANCELBUTTON_TEXT"),press:function(){j.close();}})],afterClose:function(){j.destroy();}}).open();function l(){var A=false;for(var i=0;i<this.aItems.length;i++){if(this.aItems[i]._status===k._uploadingStatus&&this.aItems[i]._requestIdName===I._requestIdName){A=true;break;}else if(I.getFileName()===this.aItems[i].getFileName()&&this.aItems[i]._status===k._displayStatus){this.aItems[i]._status=k._toBeDeletedStatus;this.fireFileDeleted({documentId:this.aItems[i].getDocumentId(),item:this.aItems[i]});break;}}if(A){this._getFileUploader().abort(this._headerParamConst.fileNameRequestIdName,this._encodeToAscii(I.getFileName())+this.aItems[i]._requestIdName);}j.close();this.invalidate();}};
k.prototype._handleEdit=function(e,I){var i,s=I.getId(),j=this.aItems.length;if(this.editModeItem){sap.m.UploadCollection.prototype._handleOk(e,this,this.editModeItem,false);}if(this.sErrorState!=="Error"){for(i=0;i<j;i++){if(this.aItems[i].getId()===s){this.aItems[i]._status="Edit";break;}}I._status="Edit";this.editModeItem=e.getSource().getId().split("-editButton")[0];this.invalidate();}};
k.prototype._handleClick=function(e,o,s){if(e.target.id.lastIndexOf("editButton")<0){if(e.target.id.lastIndexOf("cancelButton")>0){sap.m.UploadCollection.prototype._handleCancel(e,o,s);}else if(e.target.id.lastIndexOf("ia_imageHL")<0&&e.target.id.lastIndexOf("ia_iconHL")<0&&e.target.id.lastIndexOf("deleteButton")<0&&e.target.id.lastIndexOf("ta_editFileName-inner")<0){if(e.target.id.lastIndexOf("cli")>0){o.sFocusId=e.target.id;}sap.m.UploadCollection.prototype._handleOk(e,o,s,true);}}};
k.prototype._handleOk=function(e,o,s,t){var E=document.getElementById(s+"-ta_editFileName-inner");var n;var S=k._findById(s,o.aItems);var i=S.getProperty("fileName");var j=k.prototype._splitFilename(i);var I=sap.ui.getCore().byId(s+"-ta_editFileName");var l=S.errorState;var m=S.changedFileName;if(E!==null){n=E.value.replace(/^\s+/,"");}var p=e.srcControl?e.srcControl.getId().split("-"):e.oSource.getId().split("-");p=p.slice(0,5);o.sFocusId=p.join("-")+"-cli";if(!n||n.length===0){if(E!==null){this._setErrorStateOnItem(o,S,n,m,l);}return;}S._status=k._displayStatus;if(j.name===n){this._removeErrorStateFromItem(o,S);if(t){o.invalidate();}return;}if(o.getSameFilenameAllowed()){this._removeErrorStateFromItem(o,S);o._oItemForRename=S;o._onEditItemOk.bind(o)(n+j.extension);return;}if(sap.m.UploadCollection.prototype._checkDoubleFileName(n+j.extension,o.aItems)){I.setProperty("valueState","Error",true);this._setErrorStateOnItem(o,S,n,m,l);}else{I.setProperty("valueState","None",true);S.changedFileName=null;this._removeErrorStateFromItem(o,S);if(t){o.invalidate();}o._oItemForRename=S;o._onEditItemOk.bind(o)(n+j.extension);}};
k.prototype._setErrorStateOnItem=function(o,s,n,e,E){s._status="Edit";s.errorState="Error";o.sErrorState="Error";s.changedFileName=n;if(E!=="Error"||e!==n){o.invalidate();}};
k.prototype._removeErrorStateFromItem=function(o,s){s.errorState=null;o.sErrorState=null;o.editModeItem=null;};
k.prototype._onEditItemOk=function(n){if(this._oItemForRename){this._oItemForRename.setFileName(n);this.fireFileRenamed({documentId:this._oItemForRename.getProperty("documentId"),fileName:n,item:this._oItemForRename});}delete this._oItemForRename;};
k.prototype._handleCancel=function(e,o,s){var S=k._findById(s,o.aItems);S._status=k._displayStatus;S.errorState=null;S.changedFileName=sap.ui.getCore().byId(s+"-ta_editFileName").getProperty("value");o.sFocusId=o.editModeItem+"-cli";o.sErrorState=null;o.editModeItem=null;o.invalidate();};
k.prototype._onChange=function(e){if(e){var t=this;var r,j,i,s,I,S,l,A;if(h.browser.msie&&h.browser.version<=9){var n=e.getParameter("newValue");if(!n){return;}s=n.split(/\" "/)[0];if(s.length===0){return;}}else{j=e.getParameter("files").length;if(j===0){return;}this._oFileUploader.removeAllAggregation("headerParameters",true);this.removeAllAggregation("headerParameters",true);}this._oFileUploader.removeAllAggregation("parameters",true);this.removeAllAggregation("parameters",true);if(h.browser.msie&&h.browser.version<=9){var o={name:e.getParameter("newValue")};var p={files:[o]};this.fireChange({getParameter:function(u){if(u==="files"){return[o];}},getParameters:function(){return p;},mParameters:p,files:[o]});}else{this.fireChange({getParameter:function(u){if(u){return e.getParameter(u);}},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:e.getParameter("files")});}var P=this.getAggregation("parameters");if(P){q.each(P,function(u,v){var w=new sap.ui.unified.FileUploaderParameter({name:v.getProperty("name"),value:v.getProperty("value")});t._oFileUploader.addParameter(w);});}if(!this.getInstantUpload()){this._bFocusFileUploader=true;S=k._pendingUploadStatus;}else{S=k._uploadingStatus;}if(h.browser.msie&&h.browser.version<=9){I=new sap.m.UploadCollectionItem({fileName:s});I._status=S;I._internalFileIndexWithinFileUploader=1;if(!this.getInstantUpload()){I.setAssociation("fileUploader",this._oFileUploader,true);this.insertItem(I);this._aFileUploadersForPendingUpload.push(this._oFileUploader);}else{I._percentUploaded=0;}this.aItems.unshift(I);}else{this._requestIdValue=this._requestIdValue+1;r=this._requestIdValue.toString();var m=this.getAggregation("headerParameters");if(!this.getInstantUpload()){this._aFileUploadersForPendingUpload.push(this._oFileUploader);}for(i=0;i<j;i++){I=new L.UploadCollectionItem({fileName:e.getParameter("files")[i].name});I._status=S;I._internalFileIndexWithinFileUploader=i+1;I._requestIdName=r;if(!this.getInstantUpload()){I.setAssociation("fileUploader",this._oFileUploader,true);l=this._oFormatDecimal.format(e.getParameter("files")[i].size);A=new d({text:l});I.insertAggregation("attributes",A,true);this.insertItem(I);}else{I._percentUploaded=0;}this.aItems.unshift(I);}if(m){q.each(m,function(u,v){t._oFileUploader.addHeaderParameter(new sap.ui.unified.FileUploaderParameter({name:v.getProperty("name"),value:v.getProperty("value")}));});}t._oFileUploader.addHeaderParameter(new sap.ui.unified.FileUploaderParameter({name:this._headerParamConst.requestIdName,value:r}));}}};
k.prototype._onFilenameLengthExceed=function(e){var o={name:e.getParameter("fileName")};var i=[o];this.fireFilenameLengthExceed({getParameter:function(p){if(p){return e.getParameter(p);}},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:i});};
k.prototype._onFileSizeExceed=function(e){var o;if(h.browser.msie&&h.browser.version<=9){var s=e.getParameter("newValue");o={name:s};var p={newValue:s,files:[o]};this.fireFileSizeExceed({getParameter:function(P){if(P==="files"){return[o];}else if(P==="newValue"){return s;}},getParameters:function(){return p;},mParameters:p,files:[o]});}else{o={name:e.getParameter("fileName"),fileSize:e.getParameter("fileSize")};this.fireFileSizeExceed({getParameter:function(P){if(P){return e.getParameter(P);}},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:[o]});}};
k.prototype._onTypeMissmatch=function(e){var o={name:e.getParameter("fileName"),fileType:e.getParameter("fileType"),mimeType:e.getParameter("mimeType")};var i=[o];this.fireTypeMissmatch({getParameter:function(p){if(p){return e.getParameter(p);}},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:i});};
k.prototype._onUploadTerminated=function(e){var i;var r=this._getRequestId(e);var s=e.getParameter("fileName");var j=this.aItems.length;for(i=0;i<j;i++){if(this.aItems[i]&&this.aItems[i].getFileName()===s&&this.aItems[i]._requestIdName===r&&this.aItems[i]._status===k._uploadingStatus){this.aItems.splice(i,1);this.removeItem(i);break;}}this.fireUploadTerminated({fileName:s,getHeaderParameter:this._getHeaderParameterWithinEvent.bind(e)});};
k.prototype._onUploadComplete=function(e){if(e){var i,r,u,j,l=n();r=this._getRequestId(e);u=e.getParameter("fileName");if(!u){var m=(e.getSource().getProperty("value")).split(/\" "/);u=m[0];}j=this.aItems.length;for(i=0;i<j;i++){if(!r){if(this.aItems[i].getProperty("fileName")===u&&this.aItems[i]._status===k._uploadingStatus&&l){this.aItems[i]._percentUploaded=100;this.aItems[i]._status=k._displayStatus;this._oItemToUpdate=null;break;}else if(this.aItems[i].getProperty("fileName")===u&&this.aItems[i]._status===k._uploadingStatus){this.aItems.splice(i,1);this._oItemToUpdate=null;break;}}else if(this.aItems[i].getProperty("fileName")===u&&this.aItems[i]._requestIdName===r&&this.aItems[i]._status===k._uploadingStatus&&l){this.aItems[i]._percentUploaded=100;this.aItems[i]._status=k._displayStatus;this._oItemToUpdate=null;break;}else if(this.aItems[i].getProperty("fileName")===u&&this.aItems[i]._requestIdName===r&&this.aItems[i]._status===k._uploadingStatus||this.aItems[i]._status===k._pendingUploadStatus){this.aItems.splice(i,1);this._oItemToUpdate=null;break;}}this.fireUploadComplete({getParameter:e.getParameter,getParameters:e.getParameters,mParameters:e.getParameters(),files:[{fileName:e.getParameter("fileName")||u,responseRaw:e.getParameter("responseRaw"),reponse:e.getParameter("response"),status:e.getParameter("status"),headers:e.getParameter("headers")}]});}this.invalidate();function n(){var s=e.getParameter("status").toString()||"200";if(s[0]==="2"||s[0]==="3"){return true;}else{return false;}}};
k.prototype._onUploadProgress=function(e){if(e){var i,u,p,P,r,j,o,I,$;u=e.getParameter("fileName");r=this._getRequestId(e);P=Math.round(e.getParameter("loaded")/e.getParameter("total")*100);if(P===100){p=this._oRb.getText("UPLOADCOLLECTION_UPLOAD_COMPLETED");}else{p=this._oRb.getText("UPLOADCOLLECTION_UPLOADING",[P]);}j=this.aItems.length;for(i=0;i<j;i++){if(this.aItems[i].getProperty("fileName")===u&&this.aItems[i]._requestIdName==r&&this.aItems[i]._status===k._uploadingStatus){o=sap.ui.getCore().byId(this.aItems[i].getId()+"-ta_progress");if(!!o){o.setText(p);this.aItems[i]._percentUploaded=P;I=this.aItems[i].getId();$=q.sap.byId(I+"-ia_indicator");if(P===100){$.attr("aria-label",p);}else{$.attr("aria-valuenow",P);}break;}}}}};
k.prototype._getRequestId=function(e){var o;o=e.getParameter("requestHeaders");if(!o){return null;}for(var j=0;j<o.length;j++){if(o[j].name===this._headerParamConst.requestIdName){return o[j].value;}}};
k.prototype._getFileUploader=function(){var t=this,u=this.getInstantUpload();if(!u||!this._oFileUploader){var s=(h.browser.msie&&h.browser.version<=9)?false:true;this._iFUCounter=this._iFUCounter+1;this._oFileUploader=new sap.ui.unified.FileUploader(this.getId()+"-"+this._iFUCounter+"-uploader",{buttonOnly:true,buttonText:" ",tooltip:this.getInstantUpload()?this._oRb.getText("UPLOADCOLLECTION_UPLOAD"):this._oRb.getText("UPLOADCOLLECTION_ADD"),iconOnly:true,enabled:this.getUploadEnabled(),fileType:this.getFileType(),icon:"sap-icon://add",iconFirst:false,style:"Transparent",maximumFilenameLength:this.getMaximumFilenameLength(),maximumFileSize:this.getMaximumFileSize(),mimeType:this.getMimeType(),multiple:this.getMultiple(),name:"uploadCollection",uploadOnChange:u,sameFilenameAllowed:true,uploadUrl:this.getUploadUrl(),useMultipart:false,sendXHR:s,change:function(e){t._onChange(e);},filenameLengthExceed:function(e){t._onFilenameLengthExceed(e);},fileSizeExceed:function(e){t._onFileSizeExceed(e);},typeMissmatch:function(e){t._onTypeMissmatch(e);},uploadAborted:function(e){t._onUploadTerminated(e);},uploadComplete:function(e){t._onUploadComplete(e);},uploadProgress:function(e){if(t.getInstantUpload()){t._onUploadProgress(e);}},uploadStart:function(e){t._onUploadStart(e);},visible:!this.getUploadButtonInvisible()});}return this._oFileUploader;};
k.prototype._onUploadStart=function(e){var r={},i,s,p,j,G;this._iUploadStartCallCounter++;p=e.getParameter("requestHeaders").length;for(i=0;i<p;i++){if(e.getParameter("requestHeaders")[i].name===this._headerParamConst.requestIdName){s=e.getParameter("requestHeaders")[i].value;break;}}j=e.getParameter("fileName");r={name:this._headerParamConst.fileNameRequestIdName,value:this._encodeToAscii(j)+s};e.getParameter("requestHeaders").push(r);for(i=0;i<this._aDeletedItemForPendingUpload.length;i++){if(this._aDeletedItemForPendingUpload[i].getAssociation("fileUploader")===e.oSource.sId&&this._aDeletedItemForPendingUpload[i].getFileName()===j&&this._aDeletedItemForPendingUpload[i]._internalFileIndexWithinFileUploader===this._iUploadStartCallCounter){e.getSource().abort(this._headerParamConst.fileNameRequestIdName,this._encodeToAscii(j)+s);return;}}this.fireBeforeUploadStarts({fileName:j,addHeaderParameter:l,getHeaderParameter:m.bind(this)});if(q.isArray(G)){for(i=0;i<G.length;i++){if(e.getParameter("requestHeaders")[i].name===G[i].getName()){e.getParameter("requestHeaders")[i].value=G[i].getValue();}}}else if(G instanceof sap.m.UploadCollectionParameter){for(i=0;i<e.getParameter("requestHeaders").length;i++){if(e.getParameter("requestHeaders")[i].name===G.getName()){e.getParameter("requestHeaders")[i].value=G.getValue();break;}}}function l(u){var r={name:u.getName(),value:u.getValue()};e.getParameter("requestHeaders").push(r);}function m(n){G=this._getHeaderParameterWithinEvent.bind(e)(n);return G;}};
k.prototype._getIconFromFilename=function(s){var e=this._splitFilename(s).extension;if(q.type(e)==="string"){e=e.toLowerCase();}switch(e){case'.bmp':case'.jpg':case'.jpeg':case'.png':return k._placeholderCamera;case'.csv':case'.xls':case'.xlsx':return'sap-icon://excel-attachment';case'.doc':case'.docx':case'.odt':return'sap-icon://doc-attachment';case'.pdf':return'sap-icon://pdf-attachment';case'.ppt':case'.pptx':return'sap-icon://ppt-attachment';case'.txt':return'sap-icon://document-text';default:return'sap-icon://document';}};
k.prototype._getThumbnail=function(t,s){if(t){return t;}else{return this._getIconFromFilename(s);}};
k.prototype._triggerLink=function(e,o){var l=null;var i;if(o.editModeItem){sap.m.UploadCollection.prototype._handleOk(e,o,o.editModeItem,true);if(o.sErrorState==="Error"){return this;}o.sFocusId=e.getParameter("id");}i=e.oSource.getId().split("-");l=i[i.length-2];sap.m.URLHelper.redirect(o.aItems[l].getProperty("url"),true);};
k.prototype.onkeydown=function(e){switch(e.keyCode){case q.sap.KeyCodes.F2:sap.m.UploadCollection.prototype._handleF2(e,this);break;case q.sap.KeyCodes.ESCAPE:sap.m.UploadCollection.prototype._handleESC(e,this);break;case q.sap.KeyCodes.DELETE:sap.m.UploadCollection.prototype._handleDEL(e,this);break;case q.sap.KeyCodes.ENTER:sap.m.UploadCollection.prototype._handleENTER(e,this);break;default:return;}e.setMarked();};
k.prototype._setFocusAfterDeletion=function(e,o){if(!e){return;}var l=o.aItems.length;var s=null;if(l===0){var i=q.sap.byId(o._oFileUploader.sId);var j=i.find(":button");q.sap.focus(j);}else{var m=e.split("-").pop();if((l-1)>=m){s=e+"-cli";}else{s=o.aItems.pop().sId+"-cli";}sap.m.UploadCollection.prototype._setFocus2LineItem(s);this.sDeletedItemId=null;}};
k.prototype._setFocus2LineItem=function(s){q.sap.byId(s).focus();};
k.prototype._handleENTER=function(e,o){var t;var l;var i;if(o.editModeItem){t=e.target.id.split(o.editModeItem).pop();}else{t=e.target.id.split("-").pop();}switch(t){case"-ta_editFileName-inner":case"-okButton":sap.m.UploadCollection.prototype._handleOk(e,o,o.editModeItem,true);break;case"-cancelButton":e.preventDefault();sap.m.UploadCollection.prototype._handleCancel(e,o,o.editModeItem);break;case"-ia_iconHL":case"-ia_imageHL":var j=o.editModeItem.split("-").pop();sap.m.URLHelper.redirect(o.aItems[j].getProperty("url"),true);break;case"ia_iconHL":case"ia_imageHL":case"cli":l=e.target.id.split(t)[0]+"ta_filenameHL";i=sap.ui.getCore().byId(l);if(i.getEnabled()){j=e.target.id.split("-")[2];sap.m.URLHelper.redirect(o.aItems[j].getProperty("url"),true);}break;default:return;}};
k.prototype._handleDEL=function(e,o){if(!o.editModeItem){var i=q.sap.byId(e.target.id);var j=i.find("[id$='-deleteButton']");var l=sap.ui.getCore().byId(j[0].id);l.firePress();}};
k.prototype._handleESC=function(e,o){if(o.editModeItem){o.sFocusId=o.editModeItem+"-cli";o.aItems[o.editModeItem.split("-").pop()]._status=k._displayStatus;sap.m.UploadCollection.prototype._handleCancel(e,o,o.editModeItem);}};
k.prototype._handleF2=function(e,o){var i=sap.ui.getCore().byId(e.target.id);if(i!==undefined){if(i._status===k._displayStatus){var j=q.sap.byId(e.target.id);var l=j.find("[id$='-editButton']");var E=sap.ui.getCore().byId(l[0].id);if(E.getEnabled()){if(o.editModeItem){sap.m.UploadCollection.prototype._handleClick(e,o,o.editModeItem);}if(o.sErrorState!=="Error"){E.firePress();}}}else{sap.m.UploadCollection.prototype._handleClick(e,o,o.editModeItem);}}else if(e.target.id.search(o.editModeItem)===0){sap.m.UploadCollection.prototype._handleOk(e,o,o.editModeItem,true);}};
k.prototype._getFileNames=function(s){if(this.getMultiple()&&!(h.browser.msie&&h.browser.version<=9)){return s.substring(1,s.length-2).split(/\" "/);}else{return s.split(/\" "/);}};
k.prototype._checkDoubleFileName=function(s,I){if(I.length===0||!s){return false;}var l=I.length;s=s.replace(/^\s+/,"");for(var i=0;i<l;i++){if(s===I[i].getProperty("fileName")){return true;}}return false;};
k.prototype._splitFilename=function(s){var r={};var n=s.split(".");if(n.length==1){r.extension="";r.name=n.pop();return r;}r.extension="."+n.pop();r.name=n.join(".");return r;};
k.prototype._getAriaLabelForPicture=function(i){var t;t=(i.getAriaLabelForPicture()||i.getFileName());return t;};
k.prototype._getHeaderParameterWithinEvent=function(s){var u=[];var r=this.getParameter("requestHeaders");var p=r.length;var i;if(r&&s){for(i=0;i<p;i++){if(r[i].name===s){return new sap.m.UploadCollectionParameter({name:r[i].name,value:r[i].value});}}}else{if(r){for(i=0;i<p;i++){u.push(new sap.m.UploadCollectionParameter({name:r[i].name,value:r[i].value}));}}return u;}};
k.prototype._encodeToAscii=function(v){var e="";for(var i=0;i<v.length;i++){e=e+v.charCodeAt(i);}return e;};
k.prototype._onResize=function(){var l=this._oList.getItems();for(var i=0;i<l.length;i++){q.sap.delayedCall(k._resizeTimeoutInterval,this,this._truncateFileName.bind(this),[l[i]._oUploadCollectionItem]);}};
k.prototype._getUploadCollectionItemByListItem=function(l){var A=this.getItems();for(var i=0;i<A.length;i++){if(A[i].getId()===l.getId().replace("-cli","")){return A[i];}}return null;};
k.prototype._getUploadCollectionItemById=function(u){var A=this.getItems();for(var i=0;i<A.length;i++){if(A[i].getId()===u){return A[i];}}return null;};
k.prototype._getUploadCollectionItemsByListItems=function(l){var u=[];var e=this.getItems();if(l){for(var i=0;i<l.length;i++){for(var j=0;j<e.length;j++){if(l[i].getId().replace("-cli","")===e[j].getId()){u.push(e[j]);break;}}}return u;}return null;};
k.prototype._setSelectedForItems=function(u,s){if(this.getMode()!==sap.m.ListMode.MultiSelect&&s){var e=this.getItems();for(var j=0;j<e.length;j++){e[j].setSelected(false);}}for(var i=0;i<u.length;i++){u[i].setSelected(s);}};
k.prototype._handleItemSetSelected=function(e){var i=e.getSource();if(i instanceof sap.m.UploadCollectionItem){var l=this._getListItemById(i.getId()+"-cli");if(l){l.setSelected(i.getSelected());}}};
k.prototype._handleSelectionChange=function(e){var l=e.getParameter("listItem");var s=e.getParameter("selected");var u=this._getUploadCollectionItemsByListItems(e.getParameter("listItems"));var o=this._getUploadCollectionItemByListItem(l);if(o&&l&&u){this.fireSelectionChange({selectedItem:o,selectedItems:u,selected:s});o.setSelected(l.getSelected());}};
k.prototype._getListItemById=function(l){var e=this._oList.getItems();return k._findById(l,e);};
k._findById=function(l,e){for(var i=0;i<e.length;i++){if(e[i].getId()===l){return e[i];}}return null;};
return k;},true);
sap.ui.predefine('sap/m/UploadCollectionItem',['jquery.sap.global','./library','sap/ui/core/Element','sap/m/ObjectAttribute','sap/m/ObjectStatus','sap/m/ObjectMarker','sap/ui/core/util/File'],function(q,l,E,O,a,b,F){"use strict";
var U=E.extend("sap.m.UploadCollectionItem",{metadata:{library:"sap.m",properties:{contributor:{type:"string",group:"Data",defaultValue:null},documentId:{type:"string",group:"Misc",defaultValue:null},fileName:{type:"string",group:"Misc",defaultValue:null},fileSize:{type:"float",group:"Misc",defaultValue:null},mimeType:{type:"string",group:"Misc",defaultValue:null},thumbnailUrl:{type:"string",group:"Misc",defaultValue:null},uploadedDate:{type:"string",group:"Misc",defaultValue:null},url:{type:"string",group:"Misc",defaultValue:null},enableEdit:{type:"boolean",group:"Behavior",defaultValue:true},enableDelete:{type:"boolean",group:"Behavior",defaultValue:true},visibleEdit:{type:"boolean",group:"Behavior",defaultValue:true},visibleDelete:{type:"boolean",group:"Behavior",defaultValue:true},ariaLabelForPicture:{type:"string",group:"Accessibility",defaultValue:null},selected:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,bindable:"bindable"},_propertyAttributes:{type:"sap.m.ObjectAttribute",multiple:true,visibility:"hidden"},statuses:{type:"sap.m.ObjectStatus",multiple:true,bindable:"bindable"},markers:{type:"sap.m.ObjectMarker",multiple:true,bindable:"bindable"}},associations:{fileUploader:{type:"sap.ui.unified.FileUploader",group:"misc",multiple:false}}}});
U.prototype.init=function(){this._mDeprecatedProperties={};};
U.prototype.setContributor=function(c){this.setProperty("contributor",c,false);this._updateDeprecatedProperties();return this;};
U.prototype.setUploadedDate=function(u){this.setProperty("uploadedDate",u,false);this._updateDeprecatedProperties();return this;};
U.prototype.setFileSize=function(f){this.setProperty("fileSize",f,false);this._updateDeprecatedProperties();return this;};
U.prototype.setSelected=function(s){if(s!==this.getSelected()){this.setProperty("selected",s,true);this.fireEvent("selected");}return this;};
U.prototype.download=function(c){if(sap.ui.Device.browser.name==="sf"){c=false;}if(!this.getUrl()){q.sap.log.warning("Items to download do not have an URL.");return false;}else if(c){var B=null;var x=new window.XMLHttpRequest();x.open("GET",this.getUrl());x.responseType="blob";x.onload=function(){var f=this.getFileName();var o=this._splitFileName(f,false);var s=o.extension;f=o.name;B=x.response;F.save(B,f,s,this.getMimeType(),'utf-8');}.bind(this);x.send();return true;}else{l.URLHelper.redirect(this.getUrl(),true);return true;}};
U.prototype._splitFileName=function(f,w){var r={};var R=/(?:\.([^.]+))?$/;var c=R.exec(f);r.name=f.slice(0,f.indexOf(c[0]));if(w){r.extension=c[0];}else{r.extension=c[1];}return r;};
U.prototype._updateDeprecatedProperties=function(){var p=["uploadedDate","contributor","fileSize"];this.removeAllAggregation("_propertyAttributes",true);q.each(p,function(i,n){var v=this.getProperty(n),A=this._mDeprecatedProperties[n];if(q.type(v)==="number"&&!!v||!!v){if(!A){A=new O({active:false});this._mDeprecatedProperties[n]=A;this.addAggregation("_propertyAttributes",A,true);A.setText(v);}else{A.setText(v);this.addAggregation("_propertyAttributes",A,true);}}else if(A){A.destroy();delete this._mDeprecatedProperties[n];}}.bind(this));this.invalidate();};
U.prototype.getAllAttributes=function(){return this.getAggregation("_propertyAttributes",[]).concat(this.getAttributes());};
return U;},true);
sap.ui.predefine('sap/m/UploadCollectionParameter',['jquery.sap.global','./library','sap/ui/core/Element'],function(q,l,E){"use strict";
var U=E.extend("sap.m.UploadCollectionParameter",{metadata:{library:"sap.m",properties:{name:{type:"string",group:"Data",defaultValue:null},value:{type:"string",group:"Data",defaultValue:null}}}});
return U;},true);
sap.ui.predefine('sap/m/UploadCollectionRenderer',['jquery.sap.global'],function(q){"use strict";var U={};
U.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMUC");r.writeClasses();r.write(">");r.renderControl(c._oList);r.write("</div>");};
return U;},true);
sap.ui.predefine('sap/m/UploadCollectionToolbarPlaceholder',['jquery.sap.global','./library','sap/ui/core/Control'],function(q,l,C){"use strict";
var U=C.extend("sap.m.UploadCollectionToolbarPlaceholder",{metadata:{library:"sap.m",properties:{}}});
return U;},true);
sap.ui.predefine('sap/m/VBox',['jquery.sap.global','./FlexBox','./library'],function(q,F,l){"use strict";
var V=F.extend("sap.m.VBox",{metadata:{library:"sap.m"}});
return V;},true);
sap.ui.predefine('sap/m/VBoxRenderer',['jquery.sap.global','./FlexBoxRenderer'],function(q,F){"use strict";var V={};
V.render=function(r,c){F.render.apply(this,[r,c]);};
return V;},true);
sap.ui.predefine('sap/m/ViewSettingsCustomItem',['jquery.sap.global','./ViewSettingsItem','sap/ui/base/ManagedObject','./library'],function(q,V,M,l){"use strict";
var a=V.extend("sap.m.ViewSettingsCustomItem",{metadata:{library:"sap.m",properties:{filterCount:{type:"int",group:"Behavior",defaultValue:0}},aggregations:{customControl:{type:"sap.ui.core.Control",multiple:false}}}});
a.prototype.exit=function(){if(this._control&&!this._control.getParent()){this._control.destroy();delete this._control;}};
a.prototype.setCustomControl=function(c){this._control=c;return this;};
a.prototype.getCustomControl=function(){return this._control;};
a.prototype.setFilterCount=function(v){this.setProperty("filterCount",v,true);return this;};
a.prototype.setSelected=function(v){this.setProperty("selected",v,true);return this;};
a.prototype.clone=function(i,L,o){var c=M.prototype.clone.apply(this,arguments);c._control=this._control.clone();return c;};
return a;},true);
sap.ui.predefine('sap/m/ViewSettingsCustomTab',['jquery.sap.global','./library','sap/ui/core/Item','sap/ui/core/IconPool'],function(q,l,I){"use strict";
var V=I.extend("sap.m.ViewSettingsCustomTab",{metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:"sap-icon://competitor"},title:{type:"string",defaultValue:""}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}}}});
V.prototype.init=function(){this._oTabButton=null;this._aTabContents=[];};
V.prototype.exit=function(){if(this._oTabButton){this._oTabButton.destroy();delete this._oTabButton;}this._aTabContents.forEach(function(c,i){c.destroy();delete this._aTabContents[i];},this);};
V.prototype.getTabButton=function(o){if(this._oTabButton===null){o=o||{};var i=o['idPrefix']||'custom-tab-';this._oTabButton=new sap.m.Button({id:i+this.getId(),icon:this.getIcon(),tooltip:this.getTooltip()});}return this._oTabButton;};
return V;},true);
sap.ui.predefine('sap/m/ViewSettingsDialog',['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/IconPool','./Toolbar','./CheckBox','./SearchField','./List','./StandardListItem'],function(q,l,C,I,T,a,S,L,b){"use strict";var c="-list-item";
var V=C.extend("sap.m.ViewSettingsDialog",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Behavior",defaultValue:null},sortDescending:{type:"boolean",group:"Behavior",defaultValue:false},groupDescending:{type:"boolean",group:"Behavior",defaultValue:false},filterSearchOperator:{type:"sap.m.StringFilterOperator",group:"Behavior",defaultValue:sap.m.StringFilterOperator.StartsWith}},aggregations:{sortItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"sortItem",bindable:"bindable"},groupItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"groupItem",bindable:"bindable"},filterItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"filterItem",bindable:"bindable"},presetFilterItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"presetFilterItem",bindable:"bindable"},customTabs:{type:"sap.m.ViewSettingsCustomTab",multiple:true,singularName:"customTab",bindable:"bindable"}},associations:{selectedSortItem:{type:"sap.m.ViewSettingsItem",multiple:false},selectedGroupItem:{type:"sap.m.ViewSettingsItem",multiple:false},selectedPresetFilterItem:{type:"sap.m.ViewSettingsItem",multiple:false}},events:{confirm:{parameters:{sortItem:{type:"sap.m.ViewSettingsItem"},sortDescending:{type:"boolean"},groupItem:{type:"sap.m.ViewSettingsItem"},groupDescending:{type:"boolean"},presetFilterItem:{type:"sap.m.ViewSettingsItem"},filterItems:{type:"sap.m.ViewSettingsItem[]"},filterKeys:{type:"object",deprecated:true},filterCompoundKeys:{type:"object"},filterString:{type:"string"}}},cancel:{},resetFilters:{},filterDetailPageOpened:{parameters:{parentFilterItem:{type:"sap.m.ViewSettingsFilterItem"}}}}}});
V.prototype.init=function(){this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._sDialogWidth="350px";this._sDialogHeight="434px";this._bAppendedToUIArea=false;this._showSubHeader=false;this._filterDetailList=undefined;this._vContentPage=-1;this._oContentItem=null;this._oPreviousState={};this._sCustomTabsButtonsIdPrefix='-custom-button-';this._aggregationToListItems("sortItems",{text:{listProp:"title"},selected:{}},{type:sap.m.ListType.Active},{mode:sap.m.ListMode.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(o){var j=o.getParameter('listItem'),k=this.getSortItems(),n=this._getVSItem(j),i;n.setProperty('selected',o.getParameter('selected'),true,false);this.setAssociation('selectedSortItem',n,true);for(i=0;i<k.length;i++){if(n!==k[i]){k[i].setProperty('selected',false,true,false);}}}.bind(this)});};
V.prototype.exit=function(){this._rb=null;this._sDialogWidth=null;this._sDialogHeight=null;this._bAppendedToUIArea=null;this._showSubHeader=null;this._vContentPage=null;this._oContentItem=null;this._oPreviousState=null;this._sortContent=null;this._groupContent=null;this._filterContent=null;this._sCustomTabsButtonsIdPrefix=null;this._fnFilterSearchCallback=null;if(this._bAppendedToUIArea){var o=sap.ui.getCore().getStaticAreaRef();o=sap.ui.getCore().getUIArea(o);o.removeContent(this,true);}if(this._dialog){this._dialog.destroy();this._dialog=null;}if(this._navContainer){this._navContainer.destroy();this._navContainer=null;}if(this._titleLabel){this._titleLabel.destroy();this._titleLabel=null;}if(this._page1){this._page1.destroy();this._page1=null;}if(this._header){this._header.destroy();this._header=null;}if(this._resetButton){this._resetButton.destroy();this._resetButton=null;}if(this._subHeader){this._subHeader.destroy();this._subHeader=null;}if(this._segmentedButton){this._segmentedButton.destroy();this._segmentedButton=null;}if(this._sortButton){this._sortButton.destroy();this._sortButton=null;}if(this._groupButton){this._groupButton.destroy();this._groupButton=null;}if(this._filterButton){this._filterButton.destroy();this._filterButton=null;}if(this._sortList){this._sortList.destroy();this._sortList=null;}if(this._ariaSortListInvisibleText){this._ariaSortListInvisibleText.destroy();this._ariaSortListInvisibleText=null;}if(this._sortOrderList){this._sortOrderList.destroy();this._sortOrderList=null;this._ariaSortOrderInvisibleText.destroy();this._ariaSortOrderInvisibleText=null;}if(this._oGroupingNoneItem){this._oGroupingNoneItem.destroy();this._oGroupingNoneItem=null;}if(this._groupList){this._groupList.destroy();this._groupList=null;this._ariaGroupListInvisibleText.destroy();this._ariaGroupListInvisibleText=null;}if(this._groupOrderList){this._groupOrderList.destroy();this._groupOrderList=null;this._ariaGroupOrderInvisibleText.destroy();this._ariaGroupOrderInvisibleText=null;}if(this._presetFilterList){this._presetFilterList.destroy();this._presetFilterList=null;}if(this._filterList){this._filterList.destroy();this._filterList=null;}if(this._page2){this._page2.destroy();this._page2=null;}if(this._detailTitleLabel){this._detailTitleLabel.destroy();this._detailTitleLabel=null;}if(this._filterDetailList){this._filterDetailList.destroy();this._filterDetailList=null;}if(this._oStringFilter){this._oStringFilter=null;}};
V.prototype._aggregationToListItems=function(i,o,j,k){var t=this._getListType(i),n="_"+t+"List";if(!this.mToList){this.mToList={};}this.mToList[t]={"itemPropertyMap":o,"listItemOptions":j,"listOptions":k,"listName":n};};
V.prototype._getListType=function(i){return i.replace('Items','');};
V.prototype._createList=function(t){var i=this.getId()+"-"+t+"list",o=new L(i,this.mToList[t].listOptions);this[this.mToList[t].listName]=o;return o;};
V.prototype._getList=function(t){if(!this.mToList||!this.mToList[t]){return;}return this[this.mToList[t].listName];};
V.prototype._createListItem=function(t,o){var O=this.mToList[t].listItemOptions,i=this.mToList[t].itemPropertyMap,j;for(var p in i){if(i.hasOwnProperty(p)){j=i[p].listProp||p;O[j]=this._createListItemPropertyValue(t,p,o);}}return new b(O).data('item',o);};
V.prototype._createListItemPropertyValue=function(t,p,o){var i=o.getMetadata().getAllProperties()[p].get(o),j=this.mToList[t].itemPropertyMap[p].fn;return j?j(i):i;};
V.prototype._getListItem=function(t,o){var i=this._getList(t).getItems().filter(function(j){return j.data('item')===o;});return i.length?i[0]:null;};
V.prototype._getVSItem=function(o){return o.data('item');};
V.prototype.addCustomTab=function(o){var i=o.getId();if(i==='sort'||i==='filter'||i==='group'){throw'Id "'+i+'" is reserved and cannot be used as custom tab id.';}this.addAggregation('customTabs',o);return this;};
V.prototype.invalidate=function(){if(this._dialog&&(!arguments[0]||arguments[0]&&arguments[0].getId()!==this.getId()+"-dialog")){this._dialog.invalidate(arguments);}else{C.prototype.invalidate.apply(this,arguments);}};
V.prototype.addStyleClass=function(){var D=this._getDialog();D.addStyleClass.apply(D,arguments);return this;};
V.prototype.removeStyleClass=function(){var D=this._getDialog();D.removeStyleClass.apply(D,arguments);return this;};
V.prototype.toggleStyleClass=function(){var D=this._getDialog();D.toggleStyleClass.apply(D,arguments);return this;};
V.prototype.hasStyleClass=function(){var D=this._getDialog();return D.hasStyleClass.apply(D,arguments);};
V.prototype.getDomRef=function(){if(this._dialog){return this._dialog.getDomRef.apply(this._dialog,arguments);}else{return null;}};
V.prototype.setTitle=function(t){this._getTitleLabel().setText(t);this.setProperty("title",t,true);return this;};
V.prototype.addAggregation=function(i,o,j){C.prototype.addAggregation.apply(this,arguments);var t=this._getListType(i);if(this.mToList[t]){var k=this._createListItem(t,o);var n=this._getList(t);if(!n){n=this._createList(t);}n.addItem(k);this._attachItemPropertyChange(t,o);}else{this._attachItemEventHandlers(i,o);}return this;};
V.prototype.insertAggregation=function(i,o,j,k){C.prototype.insertAggregation.apply(this,arguments);var t=this._getListType(i);if(this.mToList[t]){var n=this._createListItem(t,o);var p=this._getList(t);if(!p){p=this._createList(t);}p.insertItem(n,j);this._attachItemPropertyChange(t,o);}else{this._attachItemEventHandlers(i,o);}return this;};
V.prototype.removeAggregation=function(i,o,j){d.call(this,i,o);var R=C.prototype.removeAggregation.apply(this,arguments);var t=this._getListType(i);if(this.mToList[t]){var k=this._getListItem(t,R);var n=this._getList(t);var p=n.removeItem(k);p.destroy();this._detachItemPropertyChange(R);}return R;};
V.prototype.removeAllAggregation=function(i,j){d.call(this);var R=C.prototype.removeAllAggregation.apply(this,arguments);var t=this._getListType(i);if(this.mToList[t]){var o=this._getList(t);var k=o.removeAllItems();k.forEach(function(n){n.destroy();});R.forEach(function(n){this._detachItemPropertyChange(n);},this);}return R;};
V.prototype.destroyAggregation=function(i,j){d.call(this);C.prototype.destroyAggregation.apply(this,arguments);var t=this._getListType(i);if(this.mToList[t]){var o=this._getList(t);if(o){o.destroyItems();}}return this;};
V.prototype._detachItemPropertyChange=function(o){delete sap.ui.base.EventProvider.getEventList(o)["itemPropertyChanged"];};
V.prototype._attachItemPropertyChange=function(t,o){o.attachEvent('itemPropertyChanged',function fnHandleItemPropertyChanged(i){var j,p,k,n,u,w;j=this._getListItem(t,o);p=i.getParameter('propertyKey');if(!this.mToList[t].itemPropertyMap[p]){return;}k=this.mToList[t].itemPropertyMap[p].listProp||p;n=i.getParameter('propertyValue');u=this.mToList[t].itemPropertyMap[p].fn;w=u?u(n):n;j.getMetadata().getAllProperties()[k].set(j,w);},this);};
V.prototype._attachItemEventHandlers=function(i,o){if(i!=='groupItems'&&i!=='filterItems'){return this;}var t=i.replace('Items','');t=t.charAt(0).toUpperCase()+t.slice(1);o.attachEvent('itemPropertyChanged',function(i,j){if(i==='filterItems'&&j.getParameter('changedItem').getParent().getMetadata().getName()==='sap.m.ViewSettingsFilterItem'){if(j.getParameter('propertyKey')!=='selected'){if(this._vContentPage===3&&this._oContentItem){this._setFilterDetailTitle(this._oContentItem);this._initFilterDetailItems(this._oContentItem);}}else{if(this._filterDetailList){var k=this._filterDetailList.getItems();k.forEach(function(n){if(n.data('item').getId()===j.getParameter('changedItem').getId()){n.setSelected(j.getParameter('propertyValue'));}});this._updateSelectAllCheckBoxState();}}}else{if(typeof this['_init'+t+'Content']==='function'){this['_init'+t+'Content']();}if(typeof this['_init'+t+'Items']==='function'){this['_init'+t+'Items']();}}}.bind(this,i));o.attachEvent('filterDetailItemsAggregationChange',function(j){if(this._vContentPage===3&&this._oContentItem){this._setFilterDetailTitle(this._oContentItem);this._initFilterDetailItems(this._oContentItem);}}.bind(this));return this;};
V.prototype._setFilterDetailTitle=function(i){this._getDetailTitleLabel().setText(this._rb.getText("VIEWSETTINGS_TITLE_FILTERBY")+" "+i.getText());};
V.prototype.updateAggregation=function(i){C.prototype.updateAggregation.apply(this,arguments);if(i!=='groupItems'&&i!=='filterItems'){return this;}var t=i.replace('Items','');t=t.charAt(0).toUpperCase()+t.slice(1);if(typeof this['_init'+t+'Content']==='function'){this['_init'+t+'Content']();}if(typeof this['_init'+t+'Items']==='function'){this['_init'+t+'Items']();}};
V.prototype.addSortItem=function(i){this.addAggregation("sortItems",i);if(i.getSelected()){this.setSelectedSortItem(i);}return this;};
V.prototype.addGroupItem=function(i){this.addAggregation("groupItems",i);if(i.getSelected()){this.setSelectedGroupItem(i);}return this;};
V.prototype.addPresetFilterItem=function(i){this.addAggregation("presetFilterItems",i);if(i.getSelected()){this.setSelectedPresetFilterItem(i);}return this;};
V.prototype.setSelectedSortItem=function(j){var k=this.getSortItems(),i=0,o=f(j,k,"Could not set selected sort item. Item is not found: '"+j+"'");if(v(o)){for(i=0;i<k.length;i++){if(k[i].getId()!==o.getId()){k[i].setProperty('selected',false,true);}}if(o.getProperty('selected')!==true){o.setProperty('selected',true,true);}if(this._getDialog().isOpen()){this._updateListSelection(this._sortList,o);}this.setAssociation("selectedSortItem",o,true);}return this;};
V.prototype.setSelectedGroupItem=function(j){var k=this.getGroupItems(),i=0,o=f(j,k,"Could not set selected group item. Item is not found: '"+j+"'");if(v(o)){for(i=0;i<k.length;i++){k[i].setProperty('selected',false,true);}o.setProperty('selected',true,true);if(this._getDialog().isOpen()){this._updateListSelection(this._groupList,o);}this.setAssociation("selectedGroupItem",o,true);}return this;};
V.prototype.setSelectedPresetFilterItem=function(j){var k=this.getPresetFilterItems(),i=0,o=f(j,k,"Could not set selected preset filter item. Item is not found: '"+j+"'");if(v(o)){for(i=0;i<k.length;i++){k[i].setProperty('selected',false,true);}o.setProperty('selected',true,true);this._clearSelectedFilters();this.setAssociation("selectedPresetFilterItem",o,true);}return this;};
V.prototype.open=function(p){if(!this.getParent()&&!this._bAppendedToUIArea){var o=sap.ui.getCore().getStaticAreaRef();o=sap.ui.getCore().getUIArea(o);o.addContent(this,true);this._bAppendedToUIArea=true;}if(p&&this._vContentPage===3){q.sap.delayedCall(0,this._getNavContainer(),"to",[this._getPage1().getId(),"show"]);}this._initDialogContent(p);this._oPreviousState={sortItem:sap.ui.getCore().byId(this.getSelectedSortItem()),sortDescending:this.getSortDescending(),groupItem:sap.ui.getCore().byId(this.getSelectedGroupItem()),groupDescending:this.getGroupDescending(),presetFilterItem:sap.ui.getCore().byId(this.getSelectedPresetFilterItem()),filterKeys:this.getSelectedFilterKeys(),filterCompoundKeys:this.getSelectedFilterCompoundKeys(),navPage:this._getNavContainer().getCurrentPage(),contentPage:this._vContentPage,contentItem:this._oContentItem};if(sap.ui.Device.system.desktop){this._getDialog().attachEventOnce("afterOpen",function(){var i=this._getNavContainer().getCurrentPage(),$;if(i){$=i.$("cont").firstFocusableDomRef();if($){if(q($).hasClass('sapMListUl')){var j=q($).find('.sapMLIB');j.length&&j[0].focus();return;}$.focus();}}},this);}this._getDialog().open();return this;};
V.prototype.getSelectedFilterItems=function(){var k=[],F=this.getFilterItems(),n,M=true,i=0,j;for(;i<F.length;i++){if(F[i]instanceof sap.m.ViewSettingsCustomItem){if(F[i].getSelected()){k.push(F[i]);}}else if(F[i]instanceof sap.m.ViewSettingsFilterItem){n=F[i].getItems();M=F[i].getMultiSelect();for(j=0;j<n.length;j++){if(n[j].getSelected()){k.push(n[j]);if(!M){break;}}}}}return k;};
V.prototype.getSelectedFilterString=function(){var F="",k,p=this.getSelectedPresetFilterItem(),n=this.getFilterItems(),o,M=true,i=0,j;if(p){F=this._rb.getText("VIEWSETTINGS_FILTERTEXT").concat(" "+sap.ui.getCore().byId(p).getText());}else{for(;i<n.length;i++){if(n[i]instanceof sap.m.ViewSettingsCustomItem){if(n[i].getSelected()){F+=n[i].getText()+", ";}}else if(n[i]instanceof sap.m.ViewSettingsFilterItem){o=n[i].getItems();M=n[i].getMultiSelect();k="";for(j=0;j<o.length;j++){if(o[j].getSelected()){k+=o[j].getText()+", ";if(!M){break;}}}k=k.substring(0,k.length-2);if(k){k=" ("+k+")";F+=n[i].getText()+k+", ";}}}F=F.substring(0,F.length-2);if(F){F=this._rb.getText("VIEWSETTINGS_FILTERTEXT").concat(" "+F);}}return F;};
V.prototype.getSelectedFilterKeys=function(){var o={},j=this.getSelectedFilterItems(),i=0;for(;i<j.length;i++){o[j[i].getKey()]=j[i].getSelected();}return o;};
V.prototype.getSelectedFilterCompoundKeys=function(){var o={},j=this.getSelectedFilterItems(),i,k,p,F;for(i=0;i<j.length;i++){F=j[i];if(F instanceof sap.m.ViewSettingsCustomItem){k=F.getKey();o[k]=F.getSelected();}else{k=F.getKey();p=F.getParent().getKey();if(!o[p]){o[p]={};}o[p][k]=F.getSelected();}}return o;};
V.prototype.setSelectedFilterKeys=function(o){var F=this.getFilterItems(),n={},p,M,i,j,k;if(Object.keys(o).length){this._clearPresetFilter();}for(var K in o){p=null;if(o.hasOwnProperty(K)){for(i=0;i<F.length;i++){if(F[i]instanceof sap.m.ViewSettingsCustomItem){if(F[i].getKey()===K){p=F[i];F[i].setProperty('selected',o[K],true);}}else if(F[i]instanceof sap.m.ViewSettingsFilterItem){n=F[i].getItems();M=F[i].getMultiSelect();for(j=0;j<n.length;j++){if(n[j].getKey()===K){p=n[j];if(!M){for(k=0;k<n.length;k++){n[k].setProperty('selected',false,true);}}break;}}}if(p){break;}}if(p===null){q.sap.log.warning('Cannot set state for key "'+K+'" because there is no filter with these keys');continue;}p.setProperty('selected',o[K],true);}}return this;};
V.prototype.setSelectedFilterCompoundKeys=function(o){var F=this.getFilterItems();var G=function(F,t,k){if(!t.hasOwnProperty(k)){return;}var n=g(F,k);return n;};if(Object.keys(o).length){this._clearPresetFilter();}for(var p in o){var P=G(F,o,p);if(!P){q.sap.log.warning('No filter with key "'+p);continue;}if(P instanceof sap.m.ViewSettingsCustomItem){P.setProperty('selected',o[p],true);}else if(P instanceof sap.m.ViewSettingsFilterItem){var i=o[p];var j=P.getItems();var M=P.getMultiSelect();for(var k in i){var n=G(j,i,k);if(!n){q.sap.log.warning('No filter with key "'+k);continue;}if(!M){j.forEach(function(t){t.setProperty('selected',false,true);});}n.setProperty('selected',i[k],true);}}}return this;};
V.prototype._getDialog=function(){var t=this;if(this._dialog===undefined){this._dialog=new sap.m.Dialog(this.getId()+"-dialog",{showHeader:false,stretch:sap.ui.Device.system.phone,verticalScrolling:true,horizontalScrolling:false,contentWidth:this._sDialogWidth,contentHeight:this._sDialogHeight,content:this._getNavContainer(),beginButton:new sap.m.Button(this.getId()+"-acceptbutton",{text:this._rb.getText("VIEWSETTINGS_ACCEPT")}).attachPress(this._onConfirm,this),endButton:new sap.m.Button(this.getId()+"-cancelbutton",{text:this._rb.getText("VIEWSETTINGS_CANCEL")}).attachPress(this._onCancel,this)}).addStyleClass("sapMVSD");this.addDependent(this._dialog);var D=this._dialog.onsapescape;this._dialog.onsapescape=function(o){if(D){D.call(t._dialog,o);}t._onCancel();};this._dialog.onsapentermodifiers=function(o){if(o.shiftKey&&!o.ctrlKey&&!o.altKey){t._pressBackButton();}};}return this._dialog;};
V.prototype._getNavContainer=function(){if(this._navContainer===undefined){this._navContainer=new sap.m.NavContainer(this.getId()+'-navcontainer',{pages:[]});}return this._navContainer;};
V.prototype._getTitleLabel=function(){if(this._titleLabel===undefined){this._titleLabel=new sap.m.Label(this.getId()+"-title",{text:this._rb.getText("VIEWSETTINGS_TITLE")}).addStyleClass("sapMVSDTitle");}return this._titleLabel;};
V.prototype._getResetButton=function(){var t=this;if(this._resetButton===undefined){this._resetButton=new sap.m.Button(this.getId()+"-resetbutton",{icon:I.getIconURI("refresh"),press:function(){t._onClearFilters();},tooltip:this._rb.getText("VIEWSETTINGS_CLEAR_FILTER_TOOLTIP")});}return this._resetButton;};
V.prototype._getDetailTitleLabel=function(){if(this._detailTitleLabel===undefined){this._detailTitleLabel=new sap.m.Label(this.getId()+"-detailtitle",{text:this._rb.getText("VIEWSETTINGS_TITLE_FILTERBY")}).addStyleClass("sapMVSDTitle");}return this._detailTitleLabel;};
V.prototype._getHeader=function(){if(this._header===undefined){this._header=new sap.m.Bar({contentMiddle:[this._getTitleLabel()]}).addStyleClass("sapMVSDBar");}return this._header;};
V.prototype._getSubHeader=function(){if(this._subHeader===undefined){this._subHeader=new sap.m.Bar({contentLeft:[this._getSegmentedButton()]}).addStyleClass("sapMVSDBar");}return this._subHeader;};
V.prototype._getSegmentedButton=function(){var t=this,j=this.getCustomTabs(),k=j.length,i=0;if(this._segmentedButton===undefined){this._segmentedButton=new sap.m.SegmentedButton({select:function(o){var n=o.getParameter('id');if(n===t.getId()+"-sortbutton"){t._switchToPage(0);}else if(n===t.getId()+"-groupbutton"){t._switchToPage(1);}else if(n===t.getId()+"-filterbutton"){t._switchToPage(2);}else{for(i=0;i<k;i++){var p=j[i];if(!t._isEmptyTab(p)&&n===p.getTabButton().getId()){t._switchToPage(p.getId());break;}}}q.sap.log.info('press event segmented: '+o.getParameter('id'));}}).addStyleClass("sapMVSDSeg");this._segmentedButton._bPreventWidthRecalculationOnAfterRendering=true;}return this._segmentedButton;};
V.prototype._getSortButton=function(){if(this._sortButton===undefined){this._sortButton=new sap.m.Button(this.getId()+"-sortbutton",{icon:I.getIconURI("sort"),tooltip:this._rb.getText("VIEWSETTINGS_TITLE_SORT")});}return this._sortButton;};
V.prototype._getGroupButton=function(){if(this._groupButton===undefined){this._groupButton=new sap.m.Button(this.getId()+"-groupbutton",{icon:I.getIconURI("group-2"),tooltip:this._rb.getText("VIEWSETTINGS_TITLE_GROUP")});}return this._groupButton;};
V.prototype._getFilterButton=function(){if(this._filterButton===undefined){this._filterButton=new sap.m.Button(this.getId()+"-filterbutton",{icon:I.getIconURI("filter"),tooltip:this._rb.getText("VIEWSETTINGS_TITLE_FILTER")});}return this._filterButton;};
V.prototype._getPage1=function(i){if(this._page1===undefined&&!i){this._page1=new sap.m.Page(this.getId()+'-page1',{title:this._rb.getText("VIEWSETTINGS_TITLE"),customHeader:this._getHeader()});this._getNavContainer().addPage(this._page1);}return this._page1;};
V.prototype._getPage2=function(){var t=this,D,B,o;if(this._page2===undefined){B=new sap.m.Button(this.getId()+"-backbutton",{icon:I.getIconURI("nav-back"),press:[this._pressBackButton,this]});o=new sap.m.Button(this.getId()+"-detailresetbutton",{icon:I.getIconURI("refresh"),press:function(){t._onClearFilters();},tooltip:this._rb.getText("VIEWSETTINGS_CLEAR_FILTER_TOOLTIP")});D=new sap.m.Bar({contentLeft:[B],contentMiddle:[this._getDetailTitleLabel()],contentRight:[o]}).addStyleClass("sapMVSDBar");this._page2=new sap.m.Page(this.getId()+'-page2',{title:this._rb.getText("VIEWSETTINGS_TITLE_FILTERBY"),customHeader:D});this._getNavContainer().addPage(this._page2);}return this._page2;};
V.prototype._initFilterDetailItems=function(o){var k;var M=o.getMultiSelect();var n=o.getItems();var t=this;if(this._filterDetailList){this._filterDetailList.destroy();}this._getPage2().removeAllAggregation('content');this._filterDetailList=new sap.m.List({mode:(M?sap.m.ListMode.MultiSelect:sap.m.ListMode.SingleSelectLeft),includeItemInSelection:true,selectionChange:function(p){var u,w=p.getParameter("listItems"),x,i=0,N;t._clearPresetFilter();if(M){this._updateSelectAllCheckBoxState();}if(w.length>1&&M){x=o.getItems();for(;i<x.length;i++){for(var j=0;j<w.length;j++){if(x[i].getKey()===w[j].getCustomData()[0].getValue().getKey()){x[i].setProperty('selected',w[j].getSelected(),true);}}}}else{u=p.getParameter("listItem").data("item");if(!o.getMultiSelect()){x=o.getItems();for(;i<x.length;i++){if(x[i].getId()!==u.getId()){x[i].setProperty('selected',false,true);}}}N=p.getParameter("listItem").getSelected();if(u.getProperty('selected')!==N){u.setProperty('selected',N,true);}}}.bind(this)});for(var i=0;i<n.length;i++){k=new sap.m.StandardListItem({title:n[i].getText(),type:sap.m.ListType.Active,selected:n[i].getSelected()}).data("item",n[i]);this._filterDetailList.addItem(k);}if(M){this._filterSearchField=this._getFilterSearchField(this._filterDetailList);this._selectAllCheckBox=this._createSelectAllCheckbox(n,this._filterDetailList);this._getPage2().addContent(this._filterSearchField.addStyleClass('sapMVSDFilterSearchField'));this._getPage2().getCustomHeader().addStyleClass('sapMVSDBarWithSearch');this._filterDetailList.setHeaderToolbar(new T({content:[this._selectAllCheckBox]}).addStyleClass('sapMVSDFilterHeaderToolbar'));}this._getPage2().addContent(this._filterDetailList);};
V.prototype._initSortContent=function(){var t=this;if(this._sortContent){return;}this._vContentPage=-1;this._ariaSortOrderInvisibleText=new sap.ui.core.InvisibleText(this.getId()+"-sortOrderLabel",{text:this._rb.getText("VIEWSETTINGS_SORT_DIRECTION").concat(":")});this._sortOrderList=new sap.m.List(this.getId()+"-sortorderlist",{mode:sap.m.ListMode.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(o){t.setProperty('sortDescending',o.getParameter("listItem").data("item"),true);},ariaLabelledBy:this._ariaSortOrderInvisibleText}).addStyleClass("sapMVSDUpperList");this._sortOrderList.addItem(new sap.m.StandardListItem({title:this._rb.getText("VIEWSETTINGS_ASCENDING_ITEM")}).data("item",false).setSelected(true));this._sortOrderList.addItem(new sap.m.StandardListItem({title:this._rb.getText("VIEWSETTINGS_DESCENDING_ITEM")}).data("item",true));this._ariaSortListInvisibleText=new sap.ui.core.InvisibleText(this.getId()+"-sortListLabel",{text:this._rb.getText("VIEWSETTINGS_TITLE_SORT").concat(":")});this._sortList.addAriaLabelledBy(this._ariaSortListInvisibleText);this._sortContent=[this._ariaSortOrderInvisibleText,this._sortOrderList,this._ariaSortListInvisibleText,this._sortList];};
V.prototype._initGroupItems=function(){var o,H,G=this.getGroupItems();this._groupList.destroyItems();if(!!G.length){G.forEach(function(i){o=new sap.m.StandardListItem({id:i.getId()+c,title:i.getText(),type:sap.m.ListType.Active,selected:i.getSelected()}).data("item",i);this._groupList.addItem(o);},this);if(!this._oGroupingNoneItem||this._oGroupingNoneItem.bIsDestroyed){H=!!this.getSelectedGroupItem();this._oGroupingNoneItem=new sap.m.ViewSettingsItem({text:this._rb.getText("VIEWSETTINGS_NONE_ITEM"),selected:!H,itemPropertyChanged:function(){this._initGroupContent();this._initGroupItems();}.bind(this)});!H&&this.setAssociation("selectedGroupItem",this._oGroupingNoneItem,true);}o=new sap.m.StandardListItem({id:this._oGroupingNoneItem.getId()+c,title:this._oGroupingNoneItem.getText(),type:sap.m.ListType.Active,selected:this._oGroupingNoneItem.getSelected()}).data("item",this._oGroupingNoneItem);this._groupList.addItem(o);}};
V.prototype._initGroupContent=function(){var t=this;if(this._groupContent){return;}this._vContentPage=-1;this._ariaGroupOrderInvisibleText=new sap.ui.core.InvisibleText(this.getId()+"-groupOrderLabel",{text:this._rb.getText("VIEWSETTINGS_GROUP_DIRECTION").concat(":")});this._groupOrderList=new sap.m.List(this.getId()+"-grouporderlist",{mode:sap.m.ListMode.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(o){t.setProperty('groupDescending',o.getParameter("listItem").data("item"),true);},ariaLabelledBy:this._ariaGroupOrderInvisibleText}).addStyleClass("sapMVSDUpperList");this._groupOrderList.addItem(new sap.m.StandardListItem({title:this._rb.getText("VIEWSETTINGS_ASCENDING_ITEM")}).data("item",false).setSelected(true));this._groupOrderList.addItem(new sap.m.StandardListItem({title:this._rb.getText("VIEWSETTINGS_DESCENDING_ITEM")}).data("item",true));this._ariaGroupListInvisibleText=new sap.ui.core.InvisibleText(this.getId()+"-groupListLabel",{text:this._rb.getText("VIEWSETTINGS_TITLE_GROUP").concat(":")});this._groupList=new sap.m.List(this.getId()+"-grouplist",{mode:sap.m.ListMode.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(o){var i=o.getParameter("listItem").data("item");t.setSelectedGroupItem(i);},ariaLabelledBy:this._ariaGroupListInvisibleText});this._groupContent=[this._ariaGroupOrderInvisibleText,this._groupOrderList,this._ariaGroupListInvisibleText,this._groupList];};
V.prototype._initFilterItems=function(){var p,F,o,t=this;this._presetFilterList.destroyItems();p=this.getPresetFilterItems();if(p.length){p.forEach(function(i){o=new sap.m.StandardListItem({id:i.getId()+c,title:i.getText(),type:sap.m.ListType.Active,selected:i.getSelected()}).data("item",i);this._presetFilterList.addItem(o);},this);}if(p.length){o=new sap.m.StandardListItem({id:"none"+c,title:this._rb.getText("VIEWSETTINGS_NONE_ITEM"),selected:!!this.getSelectedPresetFilterItem()});this._presetFilterList.addItem(o);}this._filterList.destroyItems();F=this.getFilterItems();if(F.length){F.forEach(function(i){o=new sap.m.StandardListItem({id:i.getId()+c,title:i.getText(),type:sap.m.ListType.Active,press:(function(i){return function(j){if(t._navContainer.getCurrentPage().getId()!==t.getId()+'-page2'){t._switchToPage(3,i);t._prevSelectedFilterItem=this;q.sap.delayedCall(0,t._navContainer,"to",[t.getId()+'-page2',"slide"]);}if(sap.ui.Device.system.desktop&&t._filterDetailList&&t._filterDetailList.getItems()[0]){t._getNavContainer().attachEventOnce("afterNavigate",function(){t._filterDetailList.getItems()[0].focus();});}};}(i))}).data("item",i);this._filterList.addItem(o);},this);}};
V.prototype._initFilterContent=function(){var t=this;if(this._filterContent){return;}this._vContentPage=-1;this._presetFilterList=new sap.m.List(this.getId()+"-predefinedfilterlist",{mode:sap.m.ListMode.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(o){var i=o.getParameter("listItem").data("item");if(i){i.setProperty('selected',o.getParameter("listItem").getSelected(),true);}t.setAssociation("selectedPresetFilterItem",i,true);t._clearSelectedFilters();}}).addStyleClass("sapMVSDUpperList");this._filterList=new sap.m.List(this.getId()+"-filterlist",{});this._filterContent=[this._presetFilterList,this._filterList];};
V.prototype._initDialogContent=function(p){var i=!!this.getSortItems().length,G=!!this.getGroupItems().length,P=!!this.getPresetFilterItems().length,F=!!this.getFilterItems().length;if(i){this._initSortContent();}if(G){this._initGroupContent();this._initGroupItems();}if(P||F){this._initFilterContent();this._initFilterItems();}this._updateDialogState(p);this._updateListSelections();};
V.prototype._updateDialogState=function(p){var i=!!this.getSortItems().length,G=!!this.getGroupItems().length,P=!!this.getPresetFilterItems().length,F=!!this.getFilterItems().length,j=!!this.getCustomTabs().length,o=this._getSegmentedButton(),k=null,n=false,D={"sort":0,"group":1,"filter":2};o.removeAllButtons();if(this._filterContent){this._presetFilterList.setVisible(true);this._filterList.setVisible(true);}if(i){o.addButton(this._getSortButton());}if(P||F){o.addButton(this._getFilterButton());if(!P){this._presetFilterList.setVisible(false);this._presetFilterList.addStyleClass("sapMVSDUpperList");}if(!F){this._filterList.setVisible(false);this._presetFilterList.removeStyleClass("sapMVSDUpperList");}}if(G){o.addButton(this._getGroupButton());}if(j){this.getCustomTabs().forEach(function(u){if(!this._isEmptyTab(u)){var B=u.getTabButton({'idPrefix':this.getId()+this._sCustomTabsButtonsIdPrefix});o.addButton(B);}}.bind(this));}this._showSubHeader=this._hasSubHeader();if(p===undefined&&this._vContentPage!==-1){p=this._vContentPage;switch(p){case 0:p='sort';break;case 1:p='group';break;case 2:p='filter';break;}}if(p===this._vContentPage&&this._vContentPage===3){this._vContentPage=-1;this._switchToPage(3,this._oContentItem);}else{p=this._determineValidPageId(p);for(var t in D){if(p===t){n=true;k=this.getId()+'-'+p+'button';p=D[t];break;}}if(!n){k=this.getId()+this._sCustomTabsButtonsIdPrefix+p;}this._getSegmentedButton().setSelectedButton(k);this._switchToPage(p);if(this._getNavContainer().getCurrentPage()!==this._getPage1()){this._getNavContainer().to(this._getPage1().getId());}}};
V.prototype._determineValidPageId=function(p){var D='sort',H=false,i=[];i=this._fetchValidPagesIds();if(i.length){D=i[0];}else{q.sap.log.warning('No available pages to load - missing items.');}if(!p){p=D;}else{i.filter(function(j){if(j===p){H=true;return false;}return true;});if(!H){p=D;}}return p;};
V.prototype._fetchValidPagesIds=function(){var i,j=this.getCustomTabs(),k=j.length,n=[];var p=['sort','filter','group'];p.forEach(function(P){if(this._isValidPredefinedPageId(P)){n.push(P);}},this);for(i=0;i<k;i++){var o=j[i];if(!this._isEmptyTab(o)){n.push(o.getId());}}return n;};
V.prototype._isEmptyTab=function(o){return!(o.getContent().length||this._vContentPage===o.getId()&&this._getPage1().getContent().length);};
V.prototype._isValidPredefinedPageId=function(n){if(!n){q.sap.log.warning('Missing mandatory parameter.');return false;}var H=false;switch(n){case'sort':H=!!this.getSortItems().length;break;case'filter':H=!!this.getFilterItems().length||!!this.getPresetFilterItems().length;break;case'group':H=!!this.getGroupItems().length;break;}return H;};
sap.m.ViewSettingsDialog.prototype._pressBackButton=function(){var t=this;if(this._vContentPage===3){this._updateFilterCounters();this._getNavContainer().attachEvent("afterNavigate",function(){if(t._prevSelectedFilterItem){t._prevSelectedFilterItem.focus();}});q.sap.delayedCall(0,this._getNavContainer(),'back');this._switchToPage(2);this._segmentedButton.setSelectedButton(this._filterButton);}};
V.prototype.setModel=function(M,n){if(this._vContentPage===3&&this._oContentItem){r.call(this);}return sap.ui.base.ManagedObject.prototype.setModel.call(this,M,n);};
V.prototype.removeFilterItem=function(F){var i="";if(this._vContentPage===3&&this._oContentItem){if(typeof(F)==="object"){i=F.getId();}else if(typeof(F)==="string"){i=F;}else if(typeof(F)==="number"){i=this.getFilterItems()[F].getId();}if(this._oContentItem.getId()===i){r.call(this);}}return this.removeAggregation('filterItems',F);};
V.prototype.removeAllFilterItems=function(){if(this._vContentPage===3&&this._oContentItem){r.call(this);}return this.removeAllAggregation('filterItems');};
V.prototype.setFilterSearchCallback=function(t){this._fnFilterSearchCallback=t;return this;};
V.prototype._switchToPage=function(w,o){var i=0,t=this._getTitleLabel(),R=this._getResetButton(),H=this._getHeader(),j=this._getSubHeader();if(this._vContentPage===w&&w!==3){if(H.getContentRight().length===0&&j.getContentRight().length===0){this._addResetButtonToPage1();}return false;}this._getPage2().getCustomHeader().removeStyleClass('sapMVSDBarWithSearch');if(e.call(this)){d.call(this);}H.removeAllContentRight();j.removeAllContentRight();this._vContentPage=w;this._oContentItem=o;if(w!==3){this._getPage1().removeAllAggregation("content",true);this._addResetButtonToPage1();}else if(w===3){this._getPage2().removeAllAggregation("content",true);}if(this.getTitle()){t.setText(this.getTitle());}else{t.setText(this._rb.getText("VIEWSETTINGS_TITLE"));}switch(w){case 1:R.setVisible(false);if(!this._showSubHeader&&!this.getTitle()){t.setText(this._rb.getText("VIEWSETTINGS_TITLE_GROUP"));}for(;i<this._groupContent.length;i++){this._getPage1().addContent(this._groupContent[i]);}break;case 2:R.setVisible(!!this.getFilterItems().length);if(!this._showSubHeader&&!this.getTitle()){t.setText(this._rb.getText("VIEWSETTINGS_TITLE_FILTER"));}this._updateListSelection(this._presetFilterList,sap.ui.getCore().byId(this.getSelectedPresetFilterItem()));this._updateFilterCounters();for(;i<this._filterContent.length;i++){this._getPage1().addContent(this._filterContent[i]);}break;case 3:this._setFilterDetailTitle(o);if(o instanceof sap.m.ViewSettingsCustomItem&&o.getCustomControl()){this._clearPresetFilter();this._getPage2().addContent(o.getCustomControl());}else if(o instanceof sap.m.ViewSettingsFilterItem&&o.getItems()){this._initFilterDetailItems(o);}break;case 0:R.setVisible(false);if(!this._getPage1().getSubHeader()&&!this.getTitle()){t.setText(this._rb.getText("VIEWSETTINGS_TITLE_SORT"));}if(this._sortContent){for(;i<this._sortContent.length;i++){this._getPage1().addContent(this._sortContent[i]);}}break;default:R.setVisible(false);this._getPage1().removeAllAggregation("content",true);var k="VIEWSETTINGS_TITLE";var n=this.getCustomTabs();if(n.length<2){k=n[0].getTitle();}if(!this._getPage1().getSubHeader()&&!this.getTitle()){t.setText(k);}n.forEach(function(p){if(p.getId()===w){p.getContent().forEach(function(u){this._getPage1().addContent(u);},this);}},this);break;}if(w===3){this.fireFilterDetailPageOpened({parentFilterItem:o});}};
V.prototype._createSelectAllCheckbox=function(F,o){var i=false;if(F&&F.length!==0){i=F.every(function(k){return k.getSelected();});}var j=new a({text:this._rb.getText("COLUMNSPANEL_SELECT_ALL"),selected:i,select:function(k){var n=k.getParameter('selected');o.getItems().filter(function(p){return p.getVisible();}).forEach(function(p){var t=p.data("item");t.setSelected(n);});}});return j;};
V.prototype._updateSelectAllCheckBoxState=function(){var i=false,j=this._filterDetailList.getItems(),k=[];if(!this._selectAllCheckBox){return;}if(j&&j.length!==0){k=j.filter(function(o){return o.getVisible();});}if(k.length!==0){i=k.every(function(o){return o.getSelected();});}this._selectAllCheckBox.setSelected(i);};
V.prototype._getFilterSearchField=function(F){var t=this,o=new S({liveChange:function(i){var Q=i.getParameter('newValue'),j=t._getStringFilter();F.getItems().forEach(function(k){var n=j(Q,k.getTitle());k.setVisible(n);});t._updateSelectAllCheckBoxState();}});return o;};
V.prototype._getStringFilter=function(){if(this._fnFilterSearchCallback){return this._fnFilterSearchCallback;}if(!this._oStringFilter||this._oStringFilter.sOperator!==this.getFilterSearchOperator()){this._oStringFilter=new h(this.getFilterSearchOperator());}return this._oStringFilter.filter.bind(this._oStringFilter);};
V.prototype._updateListSelections=function(){this._updateListSelection(this._sortList,sap.ui.getCore().byId(this.getSelectedSortItem()));this._updateListSelection(this._sortOrderList,this.getSortDescending());this._updateListSelection(this._groupList,sap.ui.getCore().byId(this.getSelectedGroupItem()));this._updateListSelection(this._groupOrderList,this.getGroupDescending());this._updateListSelection(this._presetFilterList,sap.ui.getCore().byId(this.getSelectedPresetFilterItem()));this._updateFilterCounters();};
V.prototype._updateListSelection=function(o,j){var k,i=0;if(!o){return false;}k=o.getItems();o.removeSelections();for(;i<k.length;i++){if(k[i].data("item")===j||k[i].data("item")===null){o.setSelectedItem(k[i],(j&&j.getSelected?j.getSelected():true));return true;}}return false;};
V.prototype._updateFilterCounters=function(){var k=(this._filterList?this._filterList.getItems():[]),o,n,F=0,i=0,j;for(;i<k.length;i++){o=k[i].data("item");F=0;if(o){if(o instanceof sap.m.ViewSettingsCustomItem){F=o.getFilterCount();}else if(o instanceof sap.m.ViewSettingsFilterItem){F=0;n=o.getItems();for(j=0;j<n.length;j++){if(n[j].getSelected()){F++;}}}}k[i].setCounter(F);}};
V.prototype._clearSelectedFilters=function(){var k=this.getFilterItems(),n,i=0,j;for(;i<k.length;i++){if(k[i]instanceof sap.m.ViewSettingsFilterItem){n=k[i].getItems();for(j=0;j<n.length;j++){n[j].setProperty('selected',false,true);}}k[i].setProperty('selected',false,true);}if(this._vContentPage===2&&this._getDialog().isOpen()){this._updateFilterCounters();}};
V.prototype._clearPresetFilter=function(){if(this.getSelectedPresetFilterItem()){this.setSelectedPresetFilterItem(null);}};
V.prototype._calculateNumberOfPages=function(){var i=0,j=!!this.getSortItems().length,G=!!this.getGroupItems().length,p=!!this.getPresetFilterItems().length,F=!!this.getFilterItems().length;if(j){i++;}if(p||F){i++;}if(G){i++;}this.getCustomTabs().forEach(function(o){if(!this._isEmptyTab(o)){i++;}},this);return i;};
V.prototype._hasSubHeader=function(){return!(this._calculateNumberOfPages()<2);};
function r(){this._vContentPage=2;this._oContentItem=null;this._navContainer.to(this._getPage1().getId(),"show");}
function g(j,k){var i,o;for(i=0;i<j.length;i++){if(j[i].getKey()===k){o=j[i];break;}}return o;}
function f(i,j,k){var o;if(typeof i==="string"){o=g(j,i);if(!o){q.sap.log.error(k);}}else{o=i;}return o;}
function v(i){return i&&i instanceof sap.m.ViewSettingsItem;}
V.prototype._onConfirm=function(o){var D=this._getDialog(),t=this,i=function(){var j,G,k=t.getSelectedGroupItem();if(!t._oGroupingNoneItem||k!=t._oGroupingNoneItem.getId()){G=sap.ui.getCore().byId(k);}j={sortItem:sap.ui.getCore().byId(t.getSelectedSortItem()),sortDescending:t.getSortDescending(),groupItem:G,groupDescending:t.getGroupDescending(),presetFilterItem:sap.ui.getCore().byId(t.getSelectedPresetFilterItem()),filterItems:t.getSelectedFilterItems(),filterKeys:t.getSelectedFilterKeys(),filterCompoundKeys:t.getSelectedFilterCompoundKeys(),filterString:t.getSelectedFilterString()};t._dialog.detachAfterClose(i);t.fireConfirm(j);};D.attachAfterClose(i);D.close();};
V.prototype._onCancel=function(o){var t=this,D=this._getDialog(),i=function(){t.setSelectedSortItem(t._oPreviousState.sortItem);t.setSortDescending(t._oPreviousState.sortDescending);t.setSelectedGroupItem(t._oPreviousState.groupItem);t.setGroupDescending(t._oPreviousState.groupDescending);t.setSelectedPresetFilterItem(t._oPreviousState.presetFilterItem);t._clearSelectedFilters();t.setSelectedFilterCompoundKeys(t._oPreviousState.filterCompoundKeys);if(t._navContainer.getCurrentPage()!==t._oPreviousState.navPage){q.sap.delayedCall(0,t._navContainer,"to",[t._oPreviousState.navPage.getId(),"show"]);}t._switchToPage(t._oPreviousState.contentPage,t._oPreviousState.contentItem);t._dialog.detachAfterClose(i);t.fireCancel();};D.attachAfterClose(i);D.close();};
V.prototype._onClearFilters=function(){this._clearSelectedFilters();this._clearPresetFilter();this.fireResetFilters();this._updateFilterCounters();if(this._vContentPage===3){q.sap.delayedCall(0,this._getNavContainer(),'to',[this._getPage1().getId()]);this._switchToPage(2);this._getSegmentedButton().setSelectedButton(this._getFilterButton());}this._updateListSelection(this._presetFilterList,sap.ui.getCore().byId(this.getSelectedPresetFilterItem()));};
V.prototype._addResetButtonToPage1=function(){var H=this._getHeader(),o=this._getSubHeader(),R=this._getResetButton();if(this._showSubHeader){if(!this._getPage1().getSubHeader()){this._getPage1().setSubHeader(o);}o.addContentRight(R);}else{if(this._getPage1().getSubHeader()){this._getPage1().setSubHeader();}H.addContentRight(R);}};
function d(i,o){if(!this._getPage1(true)){return;}if(i==='customTabs'&&o){if(o.getMetadata().getName()===this.getMetadata().getManagedAggregation(i).type&&this._vContentPage===o.getId()){var p=this._getPage1().getContent();p.forEach(function(j){o.addAggregation('content',j,true);});}}else if(!i&&!o){var p=this._getPage1().getContent();this.getCustomTabs().forEach(function(o){if(this._vContentPage===o.getId()){p.forEach(function(j){o.addAggregation('content',j,true);});}},this);}}
function e(){var p=[-1,0,1,2,3];return(this._getPage1().getContent().length&&p.indexOf(this._vContentPage)===-1);}
V.prototype.setBusy=function(B){this._getDialog().setBusy(B);return this;};
var h=function(o){this.sOperator=o||sap.m.StringFilterOperator.StartsWith;switch(this.sOperator){case sap.m.StringFilterOperator.Equals:this.fnOperator=E;break;case sap.m.StringFilterOperator.Contains:this.fnOperator=m;break;case sap.m.StringFilterOperator.StartsWith:this.fnOperator=s;break;case sap.m.StringFilterOperator.AnyWordStartsWith:this.fnOperator=A;break;default:q.sap.log.warning("Unknown string compare operator. Use values from sap.m.StringFilterOperator. Default operator should be used.");this.fnOperator=m;break;}};
h.prototype.filter=function(Q,i){if(!Q){return true;}if(!i){return false;}i=i.toLowerCase();Q=Q.toLowerCase();return this.fnOperator(Q,i);};
function E(Q,i){return i===Q;}
function m(Q,i){return i.indexOf(Q)>-1;}
function s(Q,i){return i.indexOf(Q)===0;}
function A(Q,i){var j=new RegExp(".*\\b"+Q+".*");return j.test(i);}
return V;},true);
sap.ui.predefine('sap/m/ViewSettingsDialogRenderer',['jquery.sap.global'],function(q){"use strict";var V={};
V.render=function(r,c){};
return V;},true);
sap.ui.predefine('sap/m/ViewSettingsFilterItem',['jquery.sap.global','./ViewSettingsItem','./library'],function(q,V,l){"use strict";
var a=V.extend("sap.m.ViewSettingsFilterItem",{metadata:{library:"sap.m",properties:{multiSelect:{type:"boolean",group:"Behavior",defaultValue:true}},aggregations:{items:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"item",bindable:"bindable"}},events:{filterDetailItemsAggregationChange:{}}}});
a.prototype._handleNewAggregationEvents=function(o){o.attachEvent('itemPropertyChanged',function(e){this.fireItemPropertyChanged({changedItem:e.getParameter('changedItem'),propertyKey:e.getParameter('propertyKey'),propertyValue:e.getParameter('propertyValue')});}.bind(this));this.fireFilterDetailItemsAggregationChange({item:o});};
a.prototype.addAggregation=function(A,o,s){sap.ui.base.ManagedObject.prototype.addAggregation.apply(this,arguments);this._handleNewAggregationEvents(o);return this;};
a.prototype.insertAggregation=function(A,o,i,s){sap.ui.base.ManagedObject.prototype.insertAggregation.apply(this,arguments);this._handleNewAggregationEvents(o);return this;};
a.prototype.removeAggregation=function(A,o,s){sap.ui.base.ManagedObject.prototype.removeAggregation.apply(this,arguments);this.fireFilterDetailItemsAggregationChange();return this;};
a.prototype.removeAllAggregation=function(A,s){sap.ui.base.ManagedObject.prototype.removeAllAggregation.apply(this,arguments);this.fireFilterDetailItemsAggregationChange();return this;};
a.prototype.destroyAggregation=function(A,s){sap.ui.base.ManagedObject.prototype.destroyAggregation.apply(this,arguments);this.fireFilterDetailItemsAggregationChange();return this;};
return a;},true);
sap.ui.predefine('sap/m/ViewSettingsItem',['jquery.sap.global','./library','sap/ui/core/Item'],function(q,l,I){"use strict";
var V=I.extend("sap.m.ViewSettingsItem",{metadata:{library:"sap.m",properties:{selected:{type:"boolean",group:"Behavior",defaultValue:false}},events:{itemPropertyChanged:{parameters:{changedItem:{type:'sap.m.ViewSettingsItem'},propertyKey:{type:"string"},propertyValue:{type:"mixed"}}}}}});
V.prototype.setProperty=function(n,v,s,f){sap.ui.base.ManagedObject.prototype.setProperty.apply(this,arguments);f=f===undefined?true:f;if(f){this.fireItemPropertyChanged({changedItem:this,propertyKey:n,propertyValue:v});}};
return V;},true);
sap.ui.predefine('sap/m/ViewSettingsPopover',["jquery.sap.global","./ResponsivePopover","./Button","./Toolbar","./ToolbarSpacer","./Bar","./List","./StandardListItem","./library","sap/ui/core/Control","sap/ui/core/IconPool","./Text","sap/ui/core/Icon","./SegmentedButton","./Page","./NavContainer","./Popover","./ViewSettingsItem","sap/ui/base/ManagedObject"],function(q,R,B,T,a,b,L,S,l,C,I,c,d,e,P,N,f,V,M){"use strict";var g='-toolbar';var h='-segmented';var j='-listitem';var k='-group';var m='-filter';var n='-sort';var F='-filterdetailItem';var o='-navContainer';var p='-mainPage';var D='-detailspage';var r='-backbutton';var s='-title';var t='-searchfield';var u='-selectall';
var v=C.extend("sap.m.ViewSettingsPopover",{
metadata:{library:"sap.m",aggregations:{sortItems:{type:"sap.ui.core.Item",multiple:true,singularName:"sortItem"},filterItems:{type:"sap.ui.core.Item",multiple:true,singularName:"filterItem"},filterDetailItems:{type:"sap.ui.core.Item",multiple:true,singularName:"filterDetailItem"},groupItems:{type:"sap.ui.core.Item",multiple:true,singularName:"groupItem"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},sortSelected:{allowPreventDefault:true,parameters:{items:{type:"array"}}},filterSelected:{allowPreventDefault:true,parameters:{items:{type:"array"}}},groupSelected:{allowPreventDefault:true,parameters:{items:{type:"array"}}},afterFilterDetailPageOpened:{parameters:{parentFilterItem:{type:"sap.m.ViewSettingsFilterItem"}}}}},
constructor:function(i,w){this._stashedItems={};if(!w&&i&&typeof i==='object'){w=i;}this._stashItems(w);if(w&&Array.isArray(w['sortItems'])){w['sortItems']=null;}if(w&&Array.isArray(w['filterItems'])){w['filterItems']=null;}if(w&&Array.isArray(w['groupItems'])){w['groupItems']=null;}M.prototype.constructor.apply(this,arguments);this._getPopover().addContent(this._getNavContainer());this._addStashedItems();}
});
v.prototype.init=function(){this._tabMap={sort:'sort',filter:'filter',filterDetail:'filterDetail',group:'group'};};
v.prototype.openBy=function(i){this._getPopover(i).openBy(i);if(sap.ui.Device.system.phone){this._showContentFor(this._determinePageToOpen());}else{this._removeSegmentedButtonSelection();this._adjustInitialWidth();}this._initialHeight=this._getPopover().getContentHeight();if(this._getSegmentedButton().getItems()&&this._getSegmentedButton().getItems().length===1){this._showContentFor(this._determinePageToOpen());}};
v.prototype._removeSegmentedButtonSelection=function(){this._getSegmentedButton().setProperty('selectedKey','',true).removeAllAssociation('selectedButton',true);this._getSegmentedButton().getButtons().forEach(function(i){i.$().removeClass("sapMSegBBtnSel").attr("aria-checked",false);});};
v.prototype.toggle=function(i){if(this.isOpen()){this.close();}else{this.openBy(i);}return this;};
v.prototype.isOpen=function(){return this._getPopover().isOpen();};
v.prototype.close=function(){this._getPopover().close();this._cleanAfterClose();return this;};
v.prototype._determinePageToOpen=function(){var i,w,x;for(i in this._tabMap){w=this._tabMap[i];w=w.slice(0,1).toUpperCase()+w.slice(1);x=this['_get'+w+'List']().getItems();if(x.length){return this._tabMap[i];}}return this._tabMap['sort'];};
v.prototype._removeFooter=function(){if(this._getPopover()._oFooter){this._getPopover()._oFooter.destroy();this._getPopover()._oFooter=null;}this._getPopover().destroyAggregation('beginButton');this._getPopover().destroyAggregation('endButton');};
v.prototype._showContentFor=function(i,w,x){this._getPopover().setContentHeight('300px');this._getPopover().setContentWidth('300px');this._removePageContents(i);this._addPageContents(i);if(i===this._tabMap['filterDetail']){this._updateTitleText(this._getText('VIEWSETTINGS_TITLE_FILTERBY')+w.getTitle(),true);this._goToDetailsPage(w,x);}else{this._updateTitleText(i);if(i===this._tabMap['filter']){this._updateFilterListItemsCount();}this._goToMainPage();}this._getSegmentedButton().setSelectedKey(i);this._currentPageId=i;};
v.prototype._updateTitleText=function(i,w){var x,y=i;if(!w){x=i;if(x=='filterDetail'){x='filter';}x="VIEWSETTINGS_TITLE_"+x.toUpperCase();y=this._getText(x);}if(w&&this._getDetailsPage().getHeaderContent()[0].getContentMiddle()){this._getDetailsPage().getHeaderContent()[0].getContentMiddle()[0].setText(y);}else{this._getTitle().setText(y);}};
v.prototype._goToDetailsPage=function(i,w){var x=this._findViewSettingsItemFromListItem(i).getMultiSelect();if(x){this._getSearchField().setValue('');this._getDetailsPage().insertAggregation('content',new T({content:[this._getSearchField().addStyleClass('sapMVSDFilterSearchField'),this._getShowSelectedOnlyButton()]}),0);this._getFilterDetailList().setHeaderToolbar(new T({content:[this._getSelectAllCheckbox(this._findViewSettingsItemFromListItem(i).getItems(),this._getFilterDetailList())]}).addStyleClass('sapMVSDFilterHeaderToolbar'));}else{this._getFilterDetailList().removeAllAggregation('headerToolbar');}this._updateFilterDetailListFor(i);this._navigateToPage('Details',w);this._addFooterButtons();this._updateSelectAllCheckBoxState();if(sap.ui.Device.system.phone){this._hideToolbarButtons();}this._lastViewedFilterParent=i;this._oPreviousSelectedFilters={selectedItemIds:this._getFilterDetailList().getSelectedItems().map(function(y){return y.getId();})};this.fireAfterFilterDetailPageOpened({parentFilterItem:i});};
v.prototype._getShowSelectedOnlyButton=function(){var i=false;if(!this._oShowSelectedOnlyButton){this._oShowSelectedOnlyButton=new sap.m.Button({icon:I.getIconURI("multiselect-all"),tooltip:this._getText('SHOW_SELECTED_ONLY'),press:function(E){i=!i;if(i){E.getSource().$("inner").addClass('sapMBtnActive');}this._getFilterDetailList().getItems().forEach(function(w){if(i){if(!w.getSelected()){w.setVisible(false);}}else if(!i){this._filterItemsBy(this._getSearchField().getValue());}},this);this._updateSelectAllCheckBoxState();}.bind(this)});}return this._oShowSelectedOnlyButton;};
v.prototype._updateSelectAllCheckBoxState=function(){var w=sap.ui.getCore().byId(this.getId()+u),x=this._getFilterDetailList().getItems()||[],A=true,y=0,i;for(i=0;i<x.length;i++){if(x[i].getVisible()){y++;if(!x[i].getSelected()){A=false;}}}if(w){w.setSelected(A&&y);}};
v.prototype._addFooterButtons=function(){var i=new B({text:this._getText("VIEWSETTINGS_ACCEPT"),press:this._confirmFilterDetail.bind(this)}),w=new B({text:this._getText("VIEWSETTINGS_CANCEL"),press:this._cancel.bind(this)});this._getPopover().setBeginButton(i);this._getPopover().setEndButton(w);};
v.prototype._confirmFilterDetail=function(){var i=this._getFilterDetailList().getItems().filter(function(w){return w.getSelected();});this.fireFilterSelected({items:i.map(function(w){return this._findViewSettingsItemFromListItem(w);}.bind(this))});this.close();};
v.prototype._cancel=function(){this._restorePreviousState();this._updateFilterListItemsCount();this.close();};
v.prototype._restorePreviousState=function(){var w;if(this._oPreviousSelectedFilters){w=function(x,y,z){var i;for(i=0;i<x.length;i++){if(y.getId()===x[i]){z.setProperty('selected',true,true);break;}}};this._getFilterDetailList().getItems().forEach(function(i){var x=this._findViewSettingsItemFromListItem(i);x.setProperty('selected',false,true);w(this._oPreviousSelectedFilters.selectedItemIds,i,x);},this);this._updateSelectAllCheckBoxState();}};
v.prototype._hideToolbarButtons=function(){this._getPopover().setShowHeader(false);q.sap.delayedCall(0,this,function(){if(this._getPopover().getAggregation('_popup')._internalHeader){this._getPopover().getAggregation('_popup')._internalHeader.$().hide();}});};
v.prototype._goToMainPage=function(){this._getPopover().setShowHeader(true);this._getPopover().setCustomHeader(this._getToolbar());this._oPreviousSelectedFilters=null;this._navigateToPage('Main');};
v.prototype._adjustInitialWidth=function(){var i,w,x,y,z=this._getSegmentedButton(),A=z&&z.getButtons();if(!A||!A[0]){return;}i=A[0].$().width();w=parseInt(A[0].$().css('margin-right'),10);x=A.length;if(sap.m._bSizeCompact||!!document.querySelector('.sapUiSizeCompact')){i=i*2;}y=(i+w)*(x+1.6);this._getPopover().setContentWidth(y+"px");};
v.prototype._navigateToPage=function(i,w){var x;if(this._getNavContainer().getCurrentPage().getId()!==this['_get'+i+'PageId']()){if(i==='Details'){if(w){this._getNavContainer().to(this['_get'+i+'Page'](),'show');x=sap.ui.getCore().byId(this.getId()+r);x&&x.destroy();x=null;}else{q.sap.delayedCall(0,this._getNavContainer(),"to",[this['_get'+i+'Page'](),"slide"]);}}else{q.sap.delayedCall(0,this._getNavContainer(),'back');}}this._getNavContainer().attachEventOnce("afterNavigate",function(){if(this._currentPageId!==this._tabMap['filterDetail']){this._removeFooter();if(sap.ui.Device.system.desktop&&this._lastViewedFilterParent&&this._lastViewedFilterParent.getFocusDomRef()){this._lastViewedFilterParent.getFocusDomRef().focus();}}else{if(sap.ui.Device.system.desktop&&this._getFilterDetailList().getItems()[0]&&this._getFilterDetailList().getItems()[0].getFocusDomRef()){this._getFilterDetailList().getItems()[0].getFocusDomRef().focus();}}}.bind(this));};
v.prototype._updateFilterListItemsCount=function(){var i,w,x=this._getFilterList().getItems();x.forEach(function(y){if(y.getId().indexOf('nofiltering')===-1){w=this._findViewSettingsItemFromListItem(y);if(w instanceof sap.m.ViewSettingsCustomItem){i=w.getFilterCount();}else if(w instanceof sap.m.ViewSettingsFilterItem){i=w.getItems().filter(function(z){return z.getSelected();}).length;}y.setCounter(i);}},this);};
v.prototype._updateFilterDetailListFor=function(i){var w=this._findViewSettingsItemFromListItem(i).getMultiSelect();var x=sap.ui.getCore().byId(i.getId().split(j).shift());var y=x&&x.getItems()||[];var z=this._getFilterDetailList();z.destroyAggregation("items");if(w){z.setIncludeItemInSelection(true);z.setMode(sap.m.ListMode.MultiSelect);}else{z.setMode(sap.m.ListMode.SingleSelectLeft);}y.forEach(function(A){z.addItem(new S({id:A.getId()+F,title:A.getText(),type:sap.m.ListType.Active,selected:A.getSelected()}));},this);};
v.prototype._removePageContents=function(i){var w,x,y,G='_getMainPage';if(i==='filterDetail'){G='_getDetailsPage';}y=this[G]().getContent()[0];for(w in this._tabMap){x=this._tabMap[w];if(y){if(y.getId()===x+'list'){this['_'+x+'List']=y;}}}this[G]().removeAllContent();};
v.prototype._addPageContents=function(i){var w,x,y,G='_getMainPage';if(i==='filterDetail'){G='_getDetailsPage';}for(w in this._tabMap){x=this._tabMap[w];if(x===i){x=x.slice(0,1).toUpperCase()+x.slice(1);y=this['_get'+x+'List']();this[G]().addContent(y);}}};
v.prototype._stashItems=function(i){var w=['sort','filter','group'];w.forEach(function(x){if(i&&Array.isArray(i[x+'Items'])){this._stashedItems[x]=i[x+'Items'];}},this);};
v.prototype._addStashedItems=function(i){var w,x,y,z;for(w in this._tabMap){var z=this._tabMap[w];x=this._stashedItems[z];for(y in x){var A=x[y];this.addAggregation(z+'Items',A);}}};
v.prototype._handleBack=function(E){if(this._currentPageId==='filterDetail'){this._showContentFor('filter');}};
v.prototype._getSelectAllCheckbox=function(i,w){var x=sap.ui.getCore().byId(this.getId()+u);if(x){return x;}return new sap.m.CheckBox({id:this.getId()+u,text:'Select All',selected:i&&i.every(function(y){return y&&y.getSelected();}),select:function(E){var y=E.getParameter('selected');w.getItems().filter(function(z){return z.getVisible();}).forEach(function(z){var A=this._findViewSettingsItemFromListItem(z);A.setProperty('selected',y,true);}.bind(this));this._toggleRemoveFilterItem();}.bind(this)});};
v.prototype._createList=function(i){var w=new L({id:this.getId()+'-'+i+'list',selectionChange:function(E){this._updateSelectAllCheckBoxState();var x=this._findViewSettingsItemFromListItem(E.getParameter('listItem'));var y;var z;var A=[];x.setProperty('selected',E.getParameter('selected'),true);if(w.getMode()!==sap.m.ListMode.MultiSelect){y=this.getFilterItems();if(y){y.forEach(function(H){z=H.getItems();if(z){A=A.concat(z);}});}A.forEach(function(H){if(H.getParent().getId()===x.getParent().getId()&&H.getSelected(true)&&H.getId()!==x.getId()){H.setProperty('selected',false,true);}});}var G=i.slice(0,1).toUpperCase()+i.slice(1);if(i==='filterDetail'){G='Filter';}else{this['fire'+G+'Selected']({items:[x]});this.close();}switch(i){case'group':this._getGroupList().addItem(this._getRemoveGroupingItem());break;}}.bind(this)});if(i!=='filter'){w.setMode(sap.m.ListMode.SingleSelectMaster);}this['_'+i+'List']=w;};
v.prototype._getRemoveGroupingItem=function(){if(!this._removeGroupingItem){this._removeGroupingItem=new S({id:this.getId()+'-nogrouping',title:this._getText('NO_GROUPING'),type:sap.m.ListType.Active});}return this._removeGroupingItem;};
v.prototype._getRemoveFilterItem=function(){if(!this._removeFilteringItem){this._removeFilteringItem=new S({id:this.getId()+'-nofiltering',title:this._getText('REMOVE_FILTER'),type:sap.m.ListType.Active,press:function(){this.getFilterItems().forEach(function(i){i.getItems().forEach(function(w){w.setProperty('selected',false,true);});});this.close();this._removeFilteringItem.destroy();this._removeFilteringItem=null;}.bind(this)});}return this._removeFilteringItem;};
v.prototype._addTab=function(i){var w=this._tabMap[i];switch(w){case'group':w=w+'-2';break;}var x=new sap.m.SegmentedButtonItem({key:i,icon:I.getIconURI(w),tooltip:this._getText("VIEWSETTINGS_TITLE_"+i.toUpperCase()),press:function onTabPress(E){var y=E.getSource().getProperty('key');var z=this['get'+y.slice(0,1).toUpperCase()+y.slice(1)+'Items']();if(this._currentPageId===y||this._currentPageId===this._tabMap['filterDetail']&&z&&z.length>1){if(sap.ui.Device.system.phone){this._cancel();}else{this._hideContent();}}else{if(z&&z.length===1){if(y!=='filter'){z.forEach(function(A){A.setSelected(!A.getSelected());});this['fire'+y.slice(0,1).toUpperCase()+y.slice(1)+'Selected']({items:z});this.close();}else{this._showContentFor('filterDetail',this._findListItemFromViewSettingsItem(z[0]),true);}}else{this._showContentFor(y);}}}.bind(this)});switch(i){case'sort':this._getSegmentedButton().insertAggregation('items',x,0);break;case'filter':this._getSegmentedButton().insertAggregation('items',x,1);break;case'group':this._getSegmentedButton().addItem(x);break;}this._getSegmentedButton().updateItems();};
v.prototype._hideContent=function(){this._removeSegmentedButtonSelection();this._cleanAfterClose();q.sap.delayedCall(0,this,'_adjustInitialWidth');};
v.prototype._cleanAfterClose=function(){this._removePageContents(this._currentPageId);this._getPopover().setContentHeight(this._initialHeight);this._removeFooter();this._navigateToPage('Main');this._currentPageId=null;};
v.prototype._removeTab=function(i){var w=this._getSegmentedButton().getItems();w.forEach(function(x){if(x.getKey()===i.toLowerCase()){this._getSegmentedButton().removeItem(x);}},this);if(this._currentPageId===i.toLowerCase()){this._showContentFor(this._determinePageToOpen());}};
v.prototype._getPopoverAriaLabel=function(){var i=this.getAssociation("ariaLabelledBy");if(!i){i=new sap.ui.core.InvisibleText({text:this._getText("ARIA_LABELLED_BY_POPOVER")}).toStatic().getId();this.setAssociation("ariaLabelledBy",i,true);}return i;};
v.prototype._isItemsAggregation=function(A){var i=[];var w;for(w in this._tabMap){i.push(w+'Items');}if(i.indexOf(A)===-1){return false;}return true;};
v.prototype.addAggregation=function(A,O,i){if(this._isItemsAggregation(A)){(!this.getAggregation(A)||this.getAggregation(A).length===0)&&this._addTab(A.replace('Items',''));this._handleItemsAggregation.call(this,['addAggregation',A,O,i],true);}return C.prototype.addAggregation.call(this,A,O,i);};
v.prototype.insertAggregation=function(A,O,i,w){if(this._isItemsAggregation(A)){(!this.getAggregation(A)||this.getAggregation(A).length===0)&&this._addTab(A.replace('Items',''));this._handleItemsAggregation.call(this,['insertAggregation',A,O,i,w],true);}return C.prototype.insertAggregation.call(this,A,O,i,w);};
v.prototype.removeAggregation=function(A,O,i){if(this._isItemsAggregation(A)){this._handleItemsAggregation.call(this,['removeAggregation',A,O,i]);if(!this['getAggregation'](A)){this._removeTab(A.replace('Items',''));}}return C.prototype.removeAggregation.call(this,A,O,i);};
v.prototype.removeAllAggregation=function(A,i){if(this._isItemsAggregation(A)){this._handleItemsAggregation.call(this,['removeAllAggregation',A,null,i]);this._removeTab(A.replace('Items',''));}return C.prototype.removeAllAggregation.call(this,A,i);};
v.prototype.destroyAggregation=function(A,i){if(this._isItemsAggregation(A)){var w=A.replace('Items','');this._handleItemsAggregation.call(this,['destroyAggregation',A,i]);this._removeTab(w.slice(0,1).toUpperCase()+w.slice(1));}return C.prototype.destroyAggregation.call(this,A,i);};
v.prototype._handleItemsAggregation=function(A,i){var w=A[0],x=A[1],O=A[2],y=A.slice(1);if(!this._isItemsAggregation(x)){return this;}if(i){this._attachItemEventListeners(O);}else{this._detachItemEventListeners(O);}this._handleListItemsAggregation(y,i,w,O);return this;};
v.prototype._handleListItemsAggregation=function(A,i,w,O){var x,y,z,E,G,H=A[0],J=false;switch(H){case'sortItems':x=this._getSortList();break;case'groupItems':x=this._getGroupList();break;case'filterItems':x=this._getFilterList();break;}if(w==='destroyAggregation'&&!x){return;}if(O===null||typeof O!=='object'){return x[w]['apply'](x,A);}if(i){J=H==='filterItems'&&O.getItems;z=this._createListItemFromViewSettingsItem(O,H.replace("Items",""),J);}else{z=this._findListItemFromViewSettingsItem(O);}A.forEach(function(K,Q){if(K&&typeof K==='object'){A[Q]=z;}});for(E in this._tabMap){G=this._tabMap[E];A[0]=A[0].replace(G+'I','i');}y=x[w].apply(x,A);if(w=='removeAggregation'){y.destroy();}switch(H){case'filterItems':this._toggleRemoveFilterItem();break;}return y;};
v.prototype._toggleRemoveFilterItem=function(){var H=false;this.getFilterItems().forEach(function(i){if(i.getItems){i.getItems().forEach(function(w){if(w.getSelected()){H=true;}});}});if(H){if(!this._getRemoveFilterItem().getParent()){this._getFilterList().addItem(this._getRemoveFilterItem());}}else{if(this._removeFilteringItem){this._removeFilteringItem.destroy();this._removeFilteringItem=null;}}};
v.prototype._attachItemEventListeners=function(O){if(O instanceof V&&O.getId().indexOf('nogrouping')===-1){O.detachItemPropertyChanged(this._handleViewSettingsItemPropertyChanged.bind(this));O.attachItemPropertyChanged(this._handleViewSettingsItemPropertyChanged.bind(this));}if(O instanceof sap.m.ViewSettingsFilterItem){O.detachFilterDetailItemsAggregationChange(this._handleFilterDetailItemsAggregationChange.bind(this));O.attachFilterDetailItemsAggregationChange(this._handleFilterDetailItemsAggregationChange.bind(this));}};
v.prototype._handleViewSettingsItemPropertyChanged=function(E){var i=E.getParameter('changedItem');var w=this._findListItemFromViewSettingsItem(i);var x=E.getParameter('propertyKey');var y=E.getParameter('propertyValue');if(x==='text'){x='title';}if(w&&['key','multiSelect'].indexOf(x)==-1){w.setProperty(x,y);}};
v.prototype._handleFilterDetailItemsAggregationChange=function(E){var i=E.getParameters(),w=i.item||i.changedItem;if(w&&w.getParent&&w.getParent()instanceof V){this._updateFilterDetailListFor(w.getParent());}};
v.prototype._detachItemEventListeners=function(O){};
v.prototype._createListItemFromViewSettingsItem=function(i,w,H){var x,y=j;if(!i&&!(i instanceof sap.m.ViewSettingsItem)){q.sap.log.error('Expecting instance of "sap.m.ViewSettingsItem": instead of '+i+' given.');return;}switch(w){case"group":y+=k;break;case"filter":y+=m;break;case"sort":y+=n;break;}x=new sap.m.StandardListItem({id:i.getId()+y,title:i.getText(),type:sap.m.ListType.Active});H&&x.attachPress(this._showContentFor.bind(this,'filterDetail',x,false))&&x.setType(sap.m.ListType.Navigation);return x;};
v.prototype._findViewSettingsItemFromListItem=function(i){var w=j;if(i.getId().indexOf('filterdetail')!==-1){w=F;}return sap.ui.getCore().byId(i.getId().split(w).shift());};
v.prototype._findListItemFromViewSettingsItem=function(i){var w=i.getId()+j,x=sap.ui.getCore().byId(w+k)||sap.ui.getCore().byId(w+m)||sap.ui.getCore().byId(w+n);if(!x){x=sap.ui.getCore().byId(i.getId()+F);}return x;};
v.prototype._getMainPage=function(){if(!this._mainPage){this._mainPage=new P({showHeader:true,id:this._getMainPageId()});this._getMainPage().addHeaderContent(new sap.m.Bar({contentMiddle:this._getTitle()}).addStyleClass('sapMVSDBar').addStyleClass("sapMVSPCompactHeaderBar"));}return this._mainPage;};
v.prototype._getDetailsPage=function(){var i,w;if(!this._detailsPage){this._detailsPage=new P({showHeader:true,id:this._getDetailsPageId()});var x=new sap.m.Label({text:this._getText("VIEWSETTINGS_TITLE")}).addStyleClass("sapMVSDTitle");w=new sap.m.Bar({contentMiddle:[x]}).addStyleClass("sapMVSPCompactHeaderBar");this._getDetailsPage().addHeaderContent(w);i=new sap.m.Button(this.getId()+r,{icon:I.getIconURI("nav-back"),press:this._handleBack.bind(this)});w.addContentLeft(i);}return this._detailsPage;};
v.prototype._getMainPageId=function(){return this.getId()+p;};
v.prototype._getDetailsPageId=function(){return this.getId()+D;};
v.prototype._getPopover=function(O){if(!this._popover){this._popover=new R({showHeader:true,contentWidth:"300px",placement:sap.m.VerticalPlacementType.Vertical,showCloseButton:false,modal:false,afterOpen:function(E){this.fireAfterOpen({openBy:E.getParameter("openBy")});this.$().attr("aria-labelledby",this._getPopoverAriaLabel());this._getSegmentedButton().getFocusDomRef().focus();}.bind(this),afterClose:function(E){this._cleanAfterClose();this.fireAfterClose({openBy:E.getParameter("openBy")});}.bind(this),beforeOpen:function(E){this.fireBeforeOpen({openBy:E.getParameter("openBy")});}.bind(this),beforeClose:function(E){this.fireBeforeClose({openBy:E.getParameter("openBy")});}.bind(this)}).addStyleClass('sapMVSPopover');this._popover.setCustomHeader(this._getToolbar());if(this._popover.getAggregation('_popup').setShowArrow){this._popover.getAggregation('_popup').setShowArrow(false);}}if(O&&O.$()){this._popover.setOffsetY(-O.$().height());}return this._popover;};
v.prototype._getNavContainer=function(){if(!this._navContainer){this._navContainer=new N(this.getId()+o,{initialPage:this._getMainPageId(),pages:[this._getMainPage(),this._getDetailsPage()]});}return this._navContainer;};
v.prototype._getSortList=function(){if(!this._sortList){this._createList('sort');}return this._sortList;};
v.prototype._getGroupList=function(){if(!this._groupList){this._createList('group');}return this._groupList;};
v.prototype._getFilterList=function(){if(!this._filterList){this._createList('filter');}return this._filterList;};
v.prototype._getFilterDetailList=function(){if(!this._filterDetailList){this._createList('filterDetail');this._filterDetailList.attachEvent('selectionChange',function(){this._toggleRemoveFilterItem();}.bind(this));}return this._filterDetailList;};
v.prototype._getToolbar=function(){if(!this._toolbar){var i;this._toolbar=new sap.m.Toolbar({id:this.getId()+g});this._oCloseBtnARIAInvText=new sap.ui.core.InvisibleText({text:this._getText("MESSAGEPOPOVER_CLOSE")});i=new B({icon:I.getIconURI("decline"),ariaLabelledBy:this._oCloseBtnARIAInvText.toStatic().getId(),press:this._cancel.bind(this)}).addStyleClass('sapMVSPCloseBtn');this._toolbar.addContent(this._getSegmentedButton());this._toolbar.addContent(new a());this._toolbar.addContent(i);}return this._toolbar;};
v.prototype._getTitle=function(){if(!this._title){this._title=new sap.m.Label(this.getId()+"-title",{id:this.getId()+s,text:this._getText("VIEWSETTINGS_TITLE")}).addStyleClass("sapMVSDTitle");}return this._title;};
v.prototype._getSearchField=function(){if(!this._filterSearchField){this._filterSearchField=new sap.m.SearchField({id:this.getId()+t,liveChange:function(E){this._filterItemsBy(E.getParameter('newValue').toLowerCase());}.bind(this)});this._updateSelectAllCheckBoxState();}return this._filterSearchField;};
v.prototype._filterItemsBy=function(Q){this._getFilterDetailList().getItems().forEach(function(i){var w=i.getTitle().toLowerCase().indexOf(Q)===0;i.setVisible(w);});this._updateSelectAllCheckBoxState();};
v.prototype._getSegmentedButton=function(){if(!this._segmentedButton){this._segmentedButton=new e(this.getId()+h);}return this._segmentedButton;};
v.prototype._getText=function(K){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText(K);};
v.prototype.getDomRef=function(i){return this._popover&&this._popover.getAggregation("_popup").getDomRef(i);};
["invalidate","close","isOpen","addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass","setBindingContext","getBindingContext","getBinding","getBindingInfo","getBindingPath","setBusy","getBusy","setBusyIndicatorDelay","getBusyIndicatorDelay"].forEach(function(i){v.prototype[i]=function(){if(this._getPopover()[i]){var w=this._getPopover()[i].apply(this._getPopover(),arguments);return w===this._getPopover()?this:w;}};});
v.prototype.exit=function(){if(this._sortList){this._sortList.destroy();this._sortList=null;}if(this._filterList){this._filterList.destroy();this._filterList=null;}if(this._filterDetailList){this._filterDetailList.destroy();this._filterDetailList=null;}if(this._groupList){this._groupList.destroy();this._groupList=null;}this._popover.destroy();this._popover=null;this._oCloseBtnARIAInvText.destroy();this._oCloseBtnARIAInvText=null;this._title=null;this._navContainer=null;this._mainPage=null;this._detailsPage=null;this._toolbar=null;this._segmentedButton=null;this._currentPageId=null;this._tabMap=null;this._oPreviousSelectedFilters=null;var i=sap.ui.getCore().byId(this.getAssociation("ariaLabelledBy"));if(i&&i.destroy&&!i.bIsDestroyed){i.destroy();i=null;}if(this._removeFilteringItem){this._removeFilteringItem.destroy();this._removeFilteringItem=null;}};
return v;},false);
sap.ui.predefine('sap/m/ViewSettingsPopoverRenderer',["jquery.sap.global"],function(q){"use strict";var V={};
V.render=function(r,c){};
return V;},true);
sap.ui.predefine('sap/m/VisibleItem',['jquery.sap.global','./library','sap/ui/core/Item'],function(q,l,I){"use strict";
var V=I.extend("sap.m.VisibleItem",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Behavior",defaultValue:true}}}});
V.prototype._getRefs=function(){var p=this.getParent(),$,t=this;if(p&&p.$("content")){$=p.$("content").find("li").filter(function(){return q(this).html()===t.getText();});}return $;};
V.prototype.setVisible=function(v){if(this.getVisible()===v){return;}var $=this._getRefs();if($){if(v){$.removeClass('TPSliderItemHidden');}else{$.addClass('TPSliderItemHidden');}}return this.setProperty('visible',v,true);};
return V;},false);
sap.ui.predefine('sap/m/Wizard',["jquery.sap.global","./library","sap/ui/core/Control","sap/ui/core/delegate/ScrollEnablement","./WizardStep","./WizardProgressNavigator","./Button"],function(q,l,C,S,W,a,B){"use strict";
var b=C.extend("sap.m.Wizard",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"auto"},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"100%"},showNextButton:{type:"boolean",group:"Behavior",defaultValue:true},finishButtonText:{type:"string",group:"Appearance",defaultValue:"Review"},enableBranching:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"steps",aggregations:{steps:{type:"sap.m.WizardStep",multiple:true,singularName:"step"},_progressNavigator:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_nextButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{stepActivate:{parameters:{index:{type:"int"}}},complete:{parameters:{}}}}});
b.CONSTANTS={MINIMUM_STEPS:3,MAXIMUM_STEPS:8,ANIMATION_TIME:300,LOCK_TIME:450,SCROLL_OFFSET:65};
b.prototype.init=function(){this._stepCount=0;this._stepPath=[];this._scrollLocked=false;this._scroller=this._initScrollEnablement();this._resourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._initProgressNavigator();};
b.prototype.onBeforeRendering=function(){if(!this._isMinStepCountReached()||this._isMaxStepCountExceeded()){q.sap.log.error("The Wizard is supposed to handle from 3 to 8 steps.");}this._initNextButton();this._saveInitialValidatedState();var s=this._getStartingStep();if(this._stepPath.indexOf(s)<0){this._activateStep(s);this._updateProgressNavigator();this._setNextButtonPosition();}};
b.prototype.onAfterRendering=function(){this._attachScrollHandler();};
b.prototype.exit=function(){this._scroller.destroy();this._scroller=null;this._stepPath=null;this._stepCount=null;this._scrollLocked=null;this._resourceBundle=null;};
b.prototype.validateStep=function(s){if(!this._containsStep(s)){q.sap.log.error("The wizard does not contain this step");return this;}s.setProperty("validated",true,true);this._updateNextButtonState();return this;};
b.prototype.invalidateStep=function(s){if(!this._containsStep(s)){q.sap.log.error("The wizard does not contain this step");return this;}s.setProperty("validated",false,true);this._updateNextButtonState();return this;};
b.prototype.nextStep=function(){var c=this._getProgressNavigator().getProgress()-1;var d=this._stepPath[c];this.validateStep(d);this._handleNextButtonPress();return this;};
b.prototype.previousStep=function(){var p=this._getProgressNavigator().getProgress()-2;if(p>=0){this.discardProgress(this._stepPath[p]);}return this;};
b.prototype.getProgress=function(){return this._getProgressNavigator().getProgress();};
b.prototype.getProgressStep=function(){return this._stepPath[this.getProgress()-1];};
b.prototype.goToStep=function(s,f){if(this._scrollLocked||!this.getVisible()){return;}this._scrollLocked=true;this._scroller.scrollTo(0,this._getStepScrollOffset(s),b.CONSTANTS.ANIMATION_TIME);q.sap.delayedCall(b.CONSTANTS.LOCK_TIME,this,function(){var p=this._getProgressNavigator();if(!p){this._scrollLocked=false;return;}p._updateCurrentStep(this._stepPath.indexOf(s)+1);this._scrollLocked=false;if(f||f===undefined){this._focusFirstStepElement(s);}});return this;};
b.prototype.discardProgress=function(s){var p=this.getProgress(),c=this._stepPath,d=this._stepPath.indexOf(s)+1;if(d>p||d<=0){q.sap.log.warning("The given step is either not yet reached, or is not present in the wizard control.");return;}this._getProgressNavigator().discardProgress(d);this._updateNextButtonState();this._setNextButtonPosition();this._restoreInitialValidatedState(d);this._stepPath[d-1]._markAsLast();for(var i=d;i<c.length;i++){c[i]._deactivate();if(c[i].getSubsequentSteps().length>1){c[i].setNextStep(null);}}if(s.getSubsequentSteps().length>1){s.setNextStep(null);}c.splice(d);this._updateProgressNavigator();return this;};
b.prototype.setShowNextButton=function(v){this.setProperty("showNextButton",v,true);if(this._getNextButton()){this._getNextButton().setVisible(v);}return this;};
b.prototype.setFinishButtonText=function(v){this.setProperty("finishButtonText",v,true);this._updateNextButtonState();return this;};
b.prototype.getFinishButtonText=function(){if(this.getProperty("finishButtonText")==="Review"){return this._resourceBundle.getText("WIZARD_FINISH");}else{return this.getProperty("finishButtonText");}};
b.prototype.addStep=function(w){if(this._isMaxStepCountExceeded()){q.sap.log.error("The Wizard is supposed to handle up to 8 steps.");return this;}this._incrementStepCount();return this.addAggregation("steps",w);};
b.prototype.insertStep=function(w,i){throw new Error("Dynamic step insertion is not yet supported.");};
b.prototype.removeStep=function(w){throw new Error("Dynamic step removal is not yet supported.");};
b.prototype.removeAllSteps=function(){this._resetStepCount();return this.removeAllAggregation("steps");};
b.prototype.destroySteps=function(){this._resetStepCount();this._getProgressNavigator().setStepCount(this._getStepCount());return this.destroyAggregations("steps");};
b.prototype._initScrollEnablement=function(){return new S(this,null,{scrollContainerId:this.getId()+"-step-container",horizontal:false,vertical:true});};
b.prototype._initProgressNavigator=function(){var t=this,p=new a(this.getId()+"-progressNavigator",{stepChanged:this._handleStepChanged.bind(this),stepActivated:this._handleStepActivated.bind(this)});p._setOnEnter(function(e,s){var c=t._stepPath[s];q.sap.delayedCall(b.CONSTANTS.ANIMATION_TIME,t,function(){this._focusFirstStepElement(c);});});this.setAggregation("_progressNavigator",p);};
b.prototype._initNextButton=function(){if(this._getNextButton()){return;}this.setAggregation("_nextButton",this._createNextButton());this._setNextButtonPosition();};
b.prototype._createNextButton=function(){var f=this._getStartingStep(),i=(f)?f.getValidated():true,n=new B(this.getId()+"-nextButton",{text:this._resourceBundle.getText("WIZARD_STEP")+" "+2,type:sap.m.ButtonType.Emphasized,enabled:i,press:this._handleNextButtonPress.bind(this),visible:this.getShowNextButton()});n.addStyleClass("sapMWizardNextButton");n.addEventDelegate({onAfterRendering:this._toggleNextButtonVisibility},this);this._nextButton=n;return n;};
b.prototype._handleNextButtonPress=function(){var i,p=this._getProgressNavigator(),c=this._stepPath[this._stepPath.length-1],d=p.getProgress(),s=p.getStepCount();if(this.getEnableBranching()){i=c._isLeaf();}else{i=d===s;}if(i){this.fireComplete();}else{if(d===s){p.setStepCount(s+1);p.rerender();}p.incrementProgress();}this._updateNextButtonState();};
b.prototype._toggleNextButtonVisibility=function(){q.sap.delayedCall(0,this,function(){if(this._getNextButton().getEnabled()){this._getNextButton().addStyleClass("sapMWizardNextButtonVisible");}else{this._getNextButton().removeStyleClass("sapMWizardNextButtonVisible");}});};
b.prototype._getStepScrollOffset=function(s){var c=s.$().position().top,d=this._scroller.getScrollTop(),p=this._stepPath[this.getProgress()-1],e=0;if(!sap.ui.Device.system.phone&&!q.sap.containsOrEquals(p.getDomRef(),this._nextButton.getDomRef())){e=this._nextButton.$().outerHeight();}return(d+c)-(b.CONSTANTS.SCROLL_OFFSET+e);};
b.prototype._focusFirstStepElement=function(s){var $=s.$();if($.firstFocusableDomRef()){$.firstFocusableDomRef().focus();}};
b.prototype._handleStepChanged=function(e){if(this._scrollLocked){return;}var p=e.getParameter("current")-2;var c=this._stepPath[p];var s=this._getNextStep(c,p);var f=sap.ui.Device.system.desktop?true:false;this.goToStep(s,f);};
b.prototype._handleStepActivated=function(e){var i=e.getParameter("index"),p=i-2,c=this._stepPath[p];c._complete();var n=this._getNextStep(c,p);this._activateStep(n);this._updateProgressNavigator();this.fireStepActivate({index:i});this._setNextButtonPosition();};
b.prototype._isMaxStepCountExceeded=function(){if(this.getEnableBranching()){return false;}var s=this._getStepCount();return s>=b.CONSTANTS.MAXIMUM_STEPS;};
b.prototype._isMinStepCountReached=function(){var s=this._getStepCount();return s>=b.CONSTANTS.MINIMUM_STEPS;};
b.prototype._getStepCount=function(){return this._stepCount;};
b.prototype._incrementStepCount=function(){this._stepCount+=1;this._getProgressNavigator().setStepCount(this._getStepCount());};
b.prototype._decrementStepCount=function(){this._stepCount-=1;this._getProgressNavigator().setStepCount(this._getStepCount());};
b.prototype._resetStepCount=function(){this._stepCount=0;this._getProgressNavigator().setStepCount(this._getStepCount());};
b.prototype._getProgressNavigator=function(){return this.getAggregation("_progressNavigator");};
b.prototype._saveInitialValidatedState=function(){if(this._initialValidatedState){return;}this._initialValidatedState=this.getSteps().map(function(s){return s.getValidated();});};
b.prototype._restoreInitialValidatedState=function(c){var s=this._stepPath,d=this.getSteps();for(var i=c;i<s.length;i++){var e=s[i];var f=d.indexOf(e);var g=this._initialValidatedState[f];e.setValidated(g);}};
b.prototype._getNextStep=function(s,p){if(!this.getEnableBranching()){return this.getSteps()[p+1];}if(p<0){return this._getStartingStep();}var n=s._getNextStepReference();if(n===null){throw new Error("The wizard is in branching mode, and no next step is defined for "+"the current step, please set one.");}if(!this._containsStep(n)){throw new Error("The next step that you have defined is not part of the wizard steps aggregation."+"Please add it to the wizard control.");}var c=s.getSubsequentSteps();if(c.length>0&&!s._containsSubsequentStep(n.getId())){throw new Error("The next step that you have defined is not contained inside the subsequentSteps"+" association of the current step.");}return n;};
b.prototype._setNextButtonPosition=function(){if(sap.ui.Device.system.phone){return;}var c=this._getNextButton(),p=this._getProgressNavigator().getProgress(),d=this._stepPath[p-1];if(d){d.addContent(c);}};
b.prototype._updateNextButtonState=function(){if(!this._getNextButton()){return;}var i,s=this._getStepCount(),n=this._getNextButton(),p=this.getProgress(),c=this._stepPath[p-1].getValidated();if(this.getEnableBranching()){i=this._stepPath[p-1]._isLeaf();}else{i=p===s;}n.setEnabled(c);if(i){n.setText(this.getFinishButtonText());}else{n.setText(this._resourceBundle.getText("WIZARD_STEP")+" "+(p+1));}};
b.prototype._getNextButton=function(){return this._nextButton;};
b.prototype._updateProgressNavigator=function(){var p=this._getProgressNavigator(),c=this._getStartingStep(),d=this.getSteps(),s=[c.getTitle()],e=[c.getIcon()],f=1;if(this.getEnableBranching()){while(!c._isLeaf()&&c._getNextStepReference()!==null){f++;c=c._getNextStepReference();s.push(c.getTitle());e.push(c.getIcon());}p.setVaryingStepCount(c._isBranched());p.setStepCount(f);}else{s=d.map(function(g){return g.getTitle();});e=d.map(function(g){return g.getIcon();});}p.setStepTitles(s);p.setStepIcons(e);};
b.prototype._getStartingStep=function(){return this.getSteps()[0];};
b.prototype._attachScrollHandler=function(){var c=this.getDomRef("step-container");c.onscroll=this._scrollHandler.bind(this);};
b.prototype._scrollHandler=function(e){if(this._scrollLocked){return;}var s=e.target.scrollTop,p=this._getProgressNavigator(),c=this._stepPath[p.getCurrentStep()-1].getDomRef(),d=c.clientHeight,f=c.offsetTop,g=100;this._scrollLocked=true;if(s+g>=f+d){p.nextStep();}if(s+g<=f){p.previousStep();}this._scrollLocked=false;};
b.prototype._containsStep=function(s){return this.getSteps().some(function(o){return o===s;});};
b.prototype._activateStep=function(s){if(this._stepPath.indexOf(s)>=0){throw new Error("The step that you are trying to activate has already been visited. You are creating "+"a loop inside the wizard.");}this._stepPath.push(s);s._activate();};
return b;},true);
sap.ui.predefine('sap/m/WizardProgressNavigator',["./library","sap/ui/core/Control","sap/ui/core/ResizeHandler","sap/ui/core/delegate/ItemNavigation","sap/ui/Device","jquery.sap.global"],function(l,C,R,I,D,q){"use strict";
var W=C.extend("sap.m.WizardProgressNavigator",{metadata:{properties:{stepCount:{type:"int",group:"Data",defaultValue:3},stepTitles:{type:"string[]",group:"Appearance",defaultValue:[]},stepIcons:{type:"sap.ui.core.URI[]",group:"Appearance",defaultValue:[]},varyingStepCount:{type:"boolean",group:"Appearance",defaultValue:false}},events:{stepChanged:{parameters:{previous:{type:"int"},current:{type:"int"}}},stepActivated:{parameters:{index:{type:"int"}}}}}});
W.CONSTANTS={MINIMUM_STEPS:3,MAXIMUM_STEPS:8,MIN_STEP_WIDTH_NO_TITLE:64,MIN_STEP_WIDTH_WITH_TITLE:200};W.CLASSES={NAVIGATION:"sapMWizardProgressNav",LIST:"sapMWizardProgressNavList",LIST_VARYING:"sapMWizardProgressNavListVarying",LIST_NO_TITLES:"sapMWizardProgressNavListNoTitles",STEP:"sapMWizardProgressNavStep",ANCHOR:"sapMWizardProgressNavAnchor",ANCHOR_CIRCLE:"sapMWizardProgressNavAnchorCircle",ANCHOR_TITLE:"sapMWizardProgressNavAnchorTitle",ANCHOR_ICON:"sapMWizardProgressNavAnchorIcon"};W.ATTRIBUTES={STEP:"data-sap-ui-wpn-step",STEP_COUNT:"data-sap-ui-wpn-step-count",CURRENT_STEP:"data-sap-ui-wpn-step-current",ACTIVE_STEP:"data-sap-ui-wpn-step-active",OPEN_STEP:"data-sap-ui-wpn-step-open",OPEN_STEP_PREV:"data-sap-ui-wpn-step-open-prev",OPEN_STEP_NEXT:"data-sap-ui-wpn-step-open-next",ARIA_LABEL:"aria-label",ARIA_DISABLED:"aria-disabled"};W.TEXT={SELECTED:"WIZARD_PROG_NAV_SELECTED",PROCESSED:"WIZARD_PROG_NAV_PROCESSED",STEP:"WIZARD_PROG_NAV_STEP_TITLE"};
W.prototype.init=function(){this._currentStep=1;this._activeStep=1;this._cachedSteps=[];this._resourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._actionSheet=new sap.m.ActionSheet().addStyleClass("sapUiSizeCompact");this._createAnchorNavigation();};
W.prototype.onBeforeRendering=function(){if(this.getStepCount()!==this.getStepIcons().filter(String).length){this.setStepIcons([]);}if(this.getStepCount()!==this.getStepTitles().filter(String).length){this.setStepTitles([]);}};
W.prototype.onAfterRendering=function(){var p,z=this._activeStep-1,a=this._currentStep-1;this._cacheDOMElements();this._updateStepZIndex();this._updateAnchorNavigation(z);this._updateStepActiveAttribute(z);this._removeAnchorAriaDisabledAttribute(z);this._updateStepCurrentAttribute(a);this._updateAnchorAriaLabelAttribute(a);this._updateOpenSteps();R.register(this.getDomRef(),this._updateOpenSteps.bind(this));if(D.os.name===D.os.OS.IOS){p=this.$().find(".sapMWizardProgressNavStep").css("display","block");q.sap.delayedCall(0,p,"css",["display",""]);}};
W.prototype.getCurrentStep=function(){return this._currentStep;};
W.prototype.previousStep=function(){var c=this.getCurrentStep();if(c<2){return this;}return this._moveToStep(c-1);};
W.prototype.nextStep=function(){return this._moveToStep(this.getCurrentStep()+1);};
W.prototype.incrementProgress=function(){return this._moveToStep(this.getProgress()+1);};
W.prototype.getProgress=function(){return this._activeStep;};
W.prototype.discardProgress=function(i){if(i<=0||i>this._activeStep){return this;}this._updateCurrentStep(i,this._currentStep);this._updateStepActiveAttribute(i-1,this._activeStep-1);this._addAnchorAriaDisabledAttribute(i-1);this._updateAnchorNavigation(i-1);this._currentStep=i;this._activeStep=i;};
W.prototype._setOnEnter=function(c){this._onEnter=c;};
W.prototype.ontap=function(e){if(this._isGroupAtStart(e.target)){return this._showActionSheet(e.target,true);}if(this._isGroupAtEnd(e.target)){return this._showActionSheet(e.target,false);}if(!this._isAnchor(e.target)||!this._isOpenStep(e.target)||!this._isActiveStep(this._getStepNumber(e.target))){return;}this._updateCurrentStep(this._getStepNumber(e.target));};
W.prototype.onsapspace=function(e){if(this._onEnter){this._onEnter(e,this._anchorNavigation.getFocusedIndex());}this.ontap(e);};
W.prototype.onsapenter=W.prototype.onsapspace;
W.prototype.exit=function(){R.deregisterAllForControl(this.getId());this.removeDelegate(this._anchorNavigation);this._anchorNavigation.destroy();this._anchorNavigation=null;this._actionSheet.destroy();this._actionSheet=null;this._currentStep=null;this._activeStep=null;this._cachedSteps=null;};
W.prototype._createAnchorNavigation=function(){var t=this;this._anchorNavigation=new I();this._anchorNavigation.setCycling(false);this._anchorNavigation.attachEvent("AfterFocus",function(p){var e=p.mParameters.event;if(!e||!e.relatedTarget||q(e.relatedTarget).hasClass(W.CLASSES.ANCHOR)){return;}t._anchorNavigation.focusItem(t._currentStep-1);});this.addDelegate(this._anchorNavigation);};
W.prototype._cacheDOMElements=function(){var d=this.getDomRef();this._cachedSteps=d.querySelectorAll("."+W.CLASSES.STEP);};
W.prototype._updateStepZIndex=function(){var z=this._currentStep-1,s=this._cachedSteps.length,a=W.CONSTANTS.MAXIMUM_STEPS;for(var i=0;i<s;i++){if(i<=z){this._cachedSteps[i].style.zIndex=0;}else{this._cachedSteps[i].style.zIndex=a;a-=1;}}};
W.prototype._updateAnchorNavigation=function(a){var n=this.getDomRef(),f=[];for(var i=0;i<=a;i++){f.push(this._cachedSteps[i].children[0]);}this._anchorNavigation.setRootDomRef(n);this._anchorNavigation.setItemDomRefs(f);this._anchorNavigation.setPageSize(a);this._anchorNavigation.setFocusedIndex(a);};
W.prototype._updateStepActiveAttribute=function(n,o){if(o!==undefined){this._cachedSteps[o].removeAttribute(W.ATTRIBUTES.ACTIVE_STEP);}this._cachedSteps[n].setAttribute(W.ATTRIBUTES.ACTIVE_STEP,true);};
W.prototype._updateStepCurrentAttribute=function(n,o){if(o!==undefined){this._cachedSteps[o].removeAttribute(W.ATTRIBUTES.CURRENT_STEP);}this._cachedSteps[n].setAttribute(W.ATTRIBUTES.CURRENT_STEP,true);};
W.prototype._addAnchorAriaDisabledAttribute=function(a){var s=this._cachedSteps.length,b;for(var i=a+1;i<s;i++){b=this._cachedSteps[i].children[0];b.setAttribute(W.ATTRIBUTES.ARIA_DISABLED,true);b.removeAttribute(W.ATTRIBUTES.ARIA_LABEL);}};
W.prototype._removeAnchorAriaDisabledAttribute=function(i){this._cachedSteps[i].children[0].removeAttribute(W.ATTRIBUTES.ARIA_DISABLED);};
W.prototype._updateAnchorAriaLabelAttribute=function(n,o){if(o!==undefined){this._cachedSteps[o].children[0].setAttribute(W.ATTRIBUTES.ARIA_LABEL,this._resourceBundle.getText(W.TEXT.PROCESSED));}this._cachedSteps[n].children[0].setAttribute(W.ATTRIBUTES.ARIA_LABEL,this._resourceBundle.getText(W.TEXT.SELECTED));};
W.prototype._moveToStep=function(n){var s=this.getStepCount(),o=this.getCurrentStep();if(n>s){return this;}if(n>this._activeStep){this._updateActiveStep(n);}return this._updateCurrentStep(n,o);};
W.prototype._updateActiveStep=function(n,o){var z=n-1,a=(o||this._activeStep)-1;this._activeStep=n;this._updateAnchorNavigation(z);this._removeAnchorAriaDisabledAttribute(z);this._updateStepActiveAttribute(z,a);return this.fireStepActivated({index:n});};
W.prototype._updateCurrentStep=function(n,o){var z=n-1,a=(o||this.getCurrentStep())-1;this._currentStep=n;this._updateStepZIndex();this._updateOpenSteps();this._updateStepCurrentAttribute(z,a);this._updateAnchorAriaLabelAttribute(z,a);return this.fireStepChanged({previous:o,current:n});};
W.prototype._updateOpenSteps=function(){var w=this.$().width(),c=this._currentStep-1,a=0,b=true,s=this.getStepTitles().length?Math.floor(w/W.CONSTANTS.MIN_STEP_WIDTH_WITH_TITLE):Math.floor(w/W.CONSTANTS.MIN_STEP_WIDTH_NO_TITLE);[].forEach.call(this._cachedSteps,function(d){d.setAttribute(W.ATTRIBUTES.OPEN_STEP,false);d.setAttribute(W.ATTRIBUTES.OPEN_STEP_PREV,false);d.setAttribute(W.ATTRIBUTES.OPEN_STEP_NEXT,false);});this._cachedSteps[c].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);for(var i=1;i<s;i++){if(b){a+=1;}if(b&&this._cachedSteps[c+a]){this._cachedSteps[c+a].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);b=!b;}else if(!b&&this._cachedSteps[c-a]){this._cachedSteps[c-a].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);b=!b;}else if(this._cachedSteps[c+a+1]){a+=1;this._cachedSteps[c+a].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);b=true;}else if(this._cachedSteps[c-a]){this._cachedSteps[c-a].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);a+=1;b=false;}}for(i=0;i<this._cachedSteps.length;i++){if(this._cachedSteps[i].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="true"&&this._cachedSteps[i-1]&&this._cachedSteps[i-1].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="false"){this._cachedSteps[i-1].setAttribute(W.ATTRIBUTES.OPEN_STEP_PREV,true);}if(this._cachedSteps[i].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="false"&&this._cachedSteps[i-1]&&this._cachedSteps[i-1].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="true"){this._cachedSteps[i].setAttribute(W.ATTRIBUTES.OPEN_STEP_NEXT,true);break;}}};
W.prototype._isGroupAtStart=function(d){var s=q(d).closest("."+W.CLASSES.STEP);var a=this._getStepNumber(s);return s.attr(W.ATTRIBUTES.OPEN_STEP_PREV)==="true"&&a>1;};
W.prototype._isGroupAtEnd=function(d){var s=q(d).closest("."+W.CLASSES.STEP);var a=this._getStepNumber(s);return s.attr(W.ATTRIBUTES.OPEN_STEP_NEXT)==="true"&&a<this._cachedSteps.length;};
W.prototype._showActionSheet=function(d,a){var f=a?0:this._getStepNumber(d)-1;var t=a?this._getStepNumber(d):this._cachedSteps.length;var b,c;this._actionSheet.removeAllButtons();for(var i=f;i<t;i++){b=this.getStepIcons()[i];c=this._cachedSteps[i].childNodes[0].getAttribute("title");c=b?c:(i+1)+". "+c;this._actionSheet.addButton(new sap.m.Button({width:"200px",text:c,icon:b,enabled:this._activeStep>=(i+1),press:function(s){this._moveToStep(s);}.bind(this,i+1)}));}this._actionSheet.openBy(d);};
W.prototype._isAnchor=function(d){return d.className.indexOf(W.CLASSES.ANCHOR)!==-1;};
W.prototype._isOpenStep=function(d){var s=q(d).closest("."+W.CLASSES.STEP);return s.attr(W.ATTRIBUTES.OPEN_STEP)==="true"||(s.attr(W.ATTRIBUTES.OPEN_STEP)==="false"&&s.attr(W.ATTRIBUTES.OPEN_STEP_PREV)==="true")||(s.attr(W.ATTRIBUTES.OPEN_STEP)==="false"&&s.attr(W.ATTRIBUTES.OPEN_STEP_NEXT)==="true");};
W.prototype._isActiveStep=function(s){return s<=this._activeStep;};
W.prototype._getStepNumber=function(d){var s=q(d).closest("."+W.CLASSES.STEP).attr(W.ATTRIBUTES.STEP);return parseInt(s,10);};
return W;});
sap.ui.predefine('sap/m/WizardProgressNavigatorRenderer',["./WizardProgressNavigator"],function(W){"use strict";var C=W.CLASSES,A=W.ATTRIBUTES,a={};
a.render=function(r,c){this.startNavigator(r,c);this.renderList(r,c);this.endNavigator(r);};
a.startNavigator=function(r,c){var w=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("WIZARD_LABEL");r.write("<nav");r.writeControlData(c);r.writeAttribute("class",C.NAVIGATION+" sapContrastPlus");r.writeAttribute(A.STEP_COUNT,c.getStepCount());r.writeAccessibilityState({"role":"navigation","label":w});r.write(">");};
a.renderList=function(r,c){this.startList(r,c);this.renderSteps(r,c);this.endList(r);};
a.startList=function(r,c){var s=c.getStepTitles();r.write("<ul");if(c.getVaryingStepCount()){r.addClass(C.LIST_VARYING);}else{r.addClass(C.LIST);}if(!s.length){r.addClass(C.LIST_NO_TITLES);}r.writeAccessibilityState({"role":"list"});r.writeClasses();r.write(">");};
a.renderSteps=function(r,c){var s=c.getStepCount(),S=c.getStepTitles(),b=c.getStepIcons();for(var i=1;i<=s;i++){this.startStep(r,i);this.renderAnchor(r,c,i,S[i-1],b[i-1]);this.endStep(r);}};
a.startStep=function(r,s){r.write("<li");r.writeAttribute("class",C.STEP);r.writeAttribute(A.STEP,s);r.writeAccessibilityState({"role":"listitem"});r.write(">");};
a.renderAnchor=function(r,c,s,S,i){var b=c._cachedSteps,o=b[s],d=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("WIZARD_PROG_NAV_STEP_TITLE");r.write("<a tabindex='-1' ");if(!o||!!parseInt(o.style.zIndex,10)){r.write("aria-disabled='true'");}r.writeAttribute("class",C.ANCHOR);if(S){r.writeAttributeEscaped("title",s+". "+S);}else{r.writeAttributeEscaped("title",d+" "+s);}r.write(">");r.write("<span");r.writeAttribute("class",C.ANCHOR_CIRCLE);r.write(">");if(i){r.writeIcon(i,[C.ANCHOR_ICON],{title:null});}else{r.write(s);}r.write("</span>");if(S){r.write("<span");r.writeAttribute("class",C.ANCHOR_TITLE);r.write(">");r.writeEscaped(S);r.write("</span>");}r.write("</a>");};
a.endStep=function(r){r.write("</li>");};
a.endList=function(r){r.write("</ul>");};
a.endNavigator=function(r){r.write("</nav>");};
return a;},true);
sap.ui.predefine('sap/m/WizardRenderer',[],function(){"use strict";var W={};
W.render=function(r,w){this.startWizard(r,w);this.renderProgressNavigator(r,w);this.renderWizardSteps(r,w);this.renderNextButton(r,w);this.endWizard(r);};
W.startWizard=function(r,w){var s=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("WIZARD_LABEL");r.write("<article");r.writeControlData(w);r.addClass("sapMWizard");r.writeClasses();r.addStyle("width",w.getWidth());r.addStyle("height",w.getHeight());r.writeAccessibilityState({"label":s});r.writeStyles();r.write(">");};
W.renderProgressNavigator=function(r,w){r.write("<header class='sapMWizardHeader'>");r.renderControl(w.getAggregation("_progressNavigator"));r.write("</header>");};
W.renderWizardSteps=function(r,w){r.write("<section class='sapMWizardStepContainer'");r.writeAttribute("id",w.getId()+"-step-container");r.write(">");w.getSteps().forEach(r.renderControl);r.write("</section>");};
W.renderNextButton=function(r,w){r.renderControl(w.getAggregation("_nextButton"));};
W.endWizard=function(r){r.write("</article>");};
return W;},true);
sap.ui.predefine('sap/m/WizardStep',["./library","sap/ui/core/Control"],function(l,C){"use strict";
var W=C.extend("sap.m.WizardStep",{metadata:{properties:{title:{type:"string",group:"appearance",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},validated:{type:"boolean",group:"Behavior",defaultValue:true}},events:{complete:{parameters:{}},activate:{parameters:{}}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},associations:{subsequentSteps:{type:"sap.m.WizardStep",multiple:true,singularName:"subsequentStep"},nextStep:{type:"sap.m.WizardStep",multiple:false}}}});
W.prototype.setValidated=function(v){this.setProperty("validated",v,true);var p=this._getWizardParent();if(p===null){return this;}if(v){p.validateStep(this);}else{p.invalidateStep(this);}return this;};
W.prototype._isLeaf=function(){if(this.getNextStep()===null&&this.getSubsequentSteps().length===0){return true;}return false;};
W.prototype._isBranched=function(){return this.getSubsequentSteps().length>1;};
W.prototype._getNextStepReference=function(){if(this.getNextStep()!==null){return sap.ui.getCore().byId(this.getNextStep());}if(this.getSubsequentSteps().length===1){return sap.ui.getCore().byId(this.getSubsequentSteps[0]);}return null;};
W.prototype._containsSubsequentStep=function(s){return this.getSubsequentSteps().some(function(a){return a===s;});};
W.prototype._getWizardParent=function(){var p=this.getParent();while(!(p instanceof sap.m.Wizard)){if(p===null){return null;}p=p.getParent();}return p;};
W.prototype._markAsLast=function(){this.addStyleClass("sapMWizardLastActivatedStep");};
W.prototype._unMarkAsLast=function(){this.removeStyleClass("sapMWizardLastActivatedStep");};
W.prototype._activate=function(){if(this.hasStyleClass("sapMWizardStepActivated")){return;}this._markAsLast();this.addStyleClass("sapMWizardStepActivated");this.fireActivate();};
W.prototype._deactivate=function(){this.removeStyleClass("sapMWizardStepActivated");};
W.prototype._complete=function(){this._unMarkAsLast();this.fireComplete();};
return W;},true);
sap.ui.predefine('sap/m/WizardStepRenderer',function(){"use strict";var W={};
W.render=function(r,s){this.startWizardStep(r,s);this.renderWizardStepTitle(r,s);this.renderContent(r,s.getContent());this.endWizardStep(r);};
W.startWizardStep=function(r,s){r.write("<article");r.writeAccessibilityState(s,{"labelledby":this.getTitleId(s),"role":"region"});r.writeControlData(s);r.addClass("sapMWizardStep");r.writeClasses();r.write(">");};
W.renderWizardStepTitle=function(r,s){r.write("<h3 class='sapMWizardStepTitle' id='"+this.getTitleId(s)+"'>");r.writeEscaped(s.getTitle());r.write("</h3>");};
W.getTitleId=function(s){return s.getId()+"-Title";};
W.renderContent=function(r,c){c.forEach(r.renderControl);};
W.endWizardStep=function(r){r.write("</article>");};
return W;},true);
sap.ui.predefine('sap/m/delegate/ValueStateMessage',['jquery.sap.global','sap/ui/Device','sap/ui/base/Object','sap/ui/core/ValueStateSupport','sap/ui/core/Popup'],function(q,D,B,V,P){"use strict";
var a=B.extend("sap.m.delegate.ValueState",{constructor:function(c){B.apply(this,arguments);this._oControl=c;this._oPopup=null;}});
a.prototype.open=function(){var c=this._oControl,p=this.getPopup(),m=this.createDom(),d=P.Dock,C=q(c.getDomRefForValueStateMessage());if(!c||!p||!m){return;}p.setContent(m);p.close(0);if(p.getContent()){p.getContent().style.maxWidth=c.getDomRef().offsetWidth+"px";}else{p.getContent().style.maxWidth="";}p.open(this.getOpenDuration(),d.BeginTop,d.BeginBottom,c.getDomRefForValueStateMessage(),null,null,D.system.phone?true:P.CLOSE_ON_SCROLL);var $=q(m);if(C.offset().top<$.offset().top){$.addClass("sapMValueStateMessageBottom");}else{$.addClass("sapMValueStateMessageTop");}C.addAriaDescribedBy(this.getId());};
a.prototype.close=function(){var c=this._oControl,p=this.getPopup();if(p){p.close(0);}if(c){q(c.getFocusDomRef()).removeAriaDescribedBy(this.getId());}};
a.prototype.getId=function(){var c=this._oControl;if(!c){return"";}return(typeof c.getValueStateMessageId==="function")?c.getValueStateMessageId():c.getId()+"-message";};
a.prototype.getOpenDuration=function(){var c=this._oControl;if(!c){return 0;}return(c.iOpenMessagePopupDuration===undefined)?0:c.iOpenMessagePopupDuration;};
a.prototype.createPopup=function(i){i=i||this.getId();if(this._oPopup){return this._oPopup;}this._oPopup=new P(document.createElement("span"),false,false,false);this._oPopup.attachClosed(function(){q.sap.byId(i).remove();});return this._oPopup;};
a.prototype.getPopup=function(){if(!this._oControl){return null;}return this.createPopup();};
a.prototype.createDom=function(){var c=this._oControl;if(!c){return null;}var s=c.getValueState(),t=c.getValueStateText()||sap.ui.core.ValueStateSupport.getAdditionalText(c),C="sapMValueStateMessage sapMValueStateMessage"+s,r=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(s===sap.ui.core.ValueState.Success){C="sapUiInvisibleText";t="";}var i=this.getId();var m=document.createElement("div");m.id=i;m.className=C;m.setAttribute("role","tooltip");m.setAttribute("aria-live","assertive");var A=document.createElement("span");A.id=i+"hidden";A.className="sapUiHidden";A.setAttribute("aria-hidden","true");A.appendChild(document.createTextNode(r.getText("INPUTBASE_VALUE_STATE_"+s.toUpperCase())));m.appendChild(A);m.appendChild(document.createTextNode(t));return m;};
a.prototype.destroy=function(){if(this._oPopup){this._oPopup.destroy();this._oPopup=null;}this._oControl=null;};
return a;});
sap.ui.predefine('sap/m/ios7',['jquery.sap.global'],function(q){"use strict";
sap.ui.base.EventProvider.extend("sap.m._Ios7",{constructor:function(){var I=sap.ui.Device.os.ios&&sap.ui.Device.os.version>=7&&sap.ui.Device.os.version<8&&sap.ui.Device.browser.name==="sf";sap.ui.base.EventProvider.apply(this);if(!I){return;}this._bIntervallAttached=false;this._bInputIsOpen=false;this._bNavigationBarEventFired=false;var b=window.orientation===90||window.orientation===-90;if(b){this._attachNavigationBarPolling();}sap.ui.Device.orientation.attachHandler(this._onOrientationChange,this);this._onFocusin=q.proxy(this._onFocusin,this);document.addEventListener("focusin",this._onFocusin,true);this._onFocusout=q.proxy(this._onFocusout,this);document.addEventListener("focusout",this._onFocusout,true);}});
sap.m._Ios7.prototype.getNavigationBarHeight=function(){if(!this._bNavigationBarEventFired){return 0;}return this._iNavigationBarHeight;};
sap.m._Ios7.prototype._attachNavigationBarPolling=function(){if(!sap.ui.Device.system.phone||this._bIntervallAttached){return;}sap.ui.getCore().attachIntervalTimer(this._detectNavigationBar,this);this._bIntervallAttached=true;};
sap.m._Ios7.prototype._detachNavigationBarPolling=function(){if(!sap.ui.Device.system.phone||!this._bIntervallAttached){return;}sap.ui.getCore().detachIntervalTimer(this._detectNavigationBar,this);this._bIntervallAttached=false;};
sap.m._Ios7.prototype._detectNavigationBar=function(){var h=window.outerHeight-window.innerHeight;if(h===0||this._bInputIsOpen||this._bNavigationBarEventFired){this._iPreviousHeight=null;return;}if(this._iPreviousHeight===window.innerHeight){window.scrollTo(0,0);var n=window.outerHeight-window.innerHeight;if(h!==n){return;}this._iNavigationBarHeight=h;this._bNavigationBarEventFired=true;this.fireEvent("navigationBarShownInLandscape",{barHeight:h});this._detachNavigationBarPolling();this._iPreviousHeight=null;}else{this._iPreviousHeight=window.innerHeight;}};
sap.m._Ios7.prototype.destroy=function(){sap.ui.base.EventProvider.prototype.destroy.apply(this,arguments);document.removeEventListener("focusin",this._onFocusin,true);document.removeEventListener("focusout",this._onFocusout,true);};
sap.m._Ios7.prototype._onFocusin=function(e){var t=e.target.tagName;if(!sap.m._Ios7._rTagRegex.test(t)){return;}this._inputTarget=e.target;this._detachNavigationBarPolling();this._bInputIsOpen=true;this.fireEvent("inputOpened");};
sap.m._Ios7._rTagRegex=/INPUT|TEXTAREA|SELECT/;
sap.m._Ios7.prototype._onFocusout=function(e){var t=e.srcElement.tagName,r=e.relatedTarget,R=(r&&(r.getAttribute("readonly")===null)&&(r.getAttribute("disabled")===null))?r.tagName:"";if(sap.m._Ios7._rTagRegex.test(t)&&!sap.m._Ios7._rTagRegex.test(R)){window.scrollTo(0,0);if(window.orientation===90||window.orientation===-90){this._attachNavigationBarPolling();}this._bInputIsOpen=false;this.fireEvent("inputClosed");}};
sap.m._Ios7.prototype._onOrientationChange=function(e){var I=e.landscape;window.scrollTo(0,0);this._bNavigationBarEventFired=false;if(this._bInputIsOpen&&this._inputTarget&&this._inputTarget.blur){this._inputTarget.blur();}else if(I){this._attachNavigationBarPolling();}else if(!I){this._detachNavigationBarPolling();}};
var i=new sap.m._Ios7();return i;},true);
sap.ui.predefine('sap/m/library',['jquery.sap.global','sap/ui/Device','sap/ui/base/DataType','sap/ui/core/library','jquery.sap.mobile','./Support'],function(q,D,a){"use strict";sap.ui.getCore().initLibrary({name:"sap.m",version:"1.42.7",dependencies:["sap.ui.core"],types:["sap.m.BackgroundDesign","sap.m.BarDesign","sap.m.ButtonType","sap.m.CarouselArrowsAlign","sap.m.DateTimeInputType","sap.m.DialogType","sap.m.DeviationIndicator","sap.m.DraftIndicatorState","sap.m.FacetFilterListDataType","sap.m.FacetFilterType","sap.m.FlexAlignItems","sap.m.FlexAlignSelf","sap.m.FlexDirection","sap.m.FlexJustifyContent","sap.m.FlexRendertype","sap.m.FrameType","sap.m.GenericTileMode","sap.m.HeaderLevel","sap.m.IBarHTMLTag","sap.m.IconTabFilterDesign","sap.m.ImageMode","sap.m.Size","sap.m.ValueColor","sap.m.ValueCSSColor","sap.m.InputType","sap.m.LabelDesign","sap.m.ListGrowingDirection","sap.m.ListHeaderDesign","sap.m.ListKeyboardMode","sap.m.ListMode","sap.m.ListSeparators","sap.m.ListType","sap.m.LoadState","sap.m.MenuButtonMode","sap.m.OverflowToolbarPriority","sap.m.P13nPanelType","sap.m.PageBackgroundDesign","sap.m.PlacementType","sap.m.PopinDisplay","sap.m.QuickViewGroupElementType","sap.m.RatingIndicatorVisualMode","sap.m.ScreenSize","sap.m.SelectListKeyboardNavigationMode","sap.m.SelectType","sap.m.SplitAppMode","sap.m.StandardTileType","sap.m.StringFilterOperator","sap.m.SwipeDirection","sap.m.SwitchType","sap.m.ToolbarDesign","sap.m.VerticalPlacementType"],interfaces:["sap.m.IBar","sap.m.IconTab","sap.m.semantic.IGroup","sap.m.semantic.IFilter","sap.m.semantic.ISort","sap.m.ObjectHeaderContainer"],controls:["sap.m.ActionListItem","sap.m.ActionSelect","sap.m.ActionSheet","sap.m.App","sap.m.Bar","sap.m.BusyDialog","sap.m.BusyIndicator","sap.m.Button","sap.m.Breadcrumbs","sap.m.Carousel","sap.m.CheckBox","sap.m.ColumnListItem","sap.m.ComboBox","sap.m.ComboBoxTextField","sap.m.ComboBoxBase","sap.m.CustomListItem","sap.m.CustomTile","sap.m.DatePicker","sap.m.DateRangeSelection","sap.m.DateTimeInput","sap.m.DateTimePicker","sap.m.Dialog","sap.m.DisplayListItem","sap.m.DraftIndicator","sap.m.FacetFilter","sap.m.FacetFilterItem","sap.m.FacetFilterList","sap.m.FeedContent","sap.m.FeedInput","sap.m.FeedListItem","sap.m.FlexBox","sap.m.FormattedText","sap.m.GenericTile","sap.m.GroupHeaderListItem","sap.m.GrowingList","sap.m.HBox","sap.m.IconTabBar","sap.m.IconTabBarSelectList","sap.m.IconTabHeader","sap.m.Image","sap.m.ImageContent","sap.m.Input","sap.m.InputBase","sap.m.InputListItem","sap.m.Label","sap.m.LightBox","sap.m.Link","sap.m.List","sap.m.ListBase","sap.m.ListItemBase","sap.m.MaskInput","sap.m.Menu","sap.m.MenuButton","sap.m.MessagePage","sap.m.MessagePopover","sap.m.MessageStrip","sap.m.MultiComboBox","sap.m.MultiInput","sap.m.NavContainer","sap.m.NewsContent","sap.m.NumericContent","sap.m.NotificationListBase","sap.m.NotificationListItem","sap.m.NotificationListGroup","sap.m.PagingButton","sap.m.ObjectAttribute","sap.m.ObjectHeader","sap.m.ObjectIdentifier","sap.m.ObjectListItem","sap.m.ObjectMarker","sap.m.ObjectNumber","sap.m.ObjectStatus","sap.m.OverflowToolbar","sap.m.OverflowToolbarButton","sap.m.P13nColumnsItem","sap.m.P13nDimMeasureItem","sap.m.P13nColumnsPanel","sap.m.P13nDimMeasurePanel","sap.m.P13nConditionPanel","sap.m.P13nDialog","sap.m.P13nFilterPanel","sap.m.P13nPanel","sap.m.P13nSortPanel","sap.m.Page","sap.m.Panel","sap.m.PlanningCalendar","sap.m.Popover","sap.m.ProgressIndicator","sap.m.PullToRefresh","sap.m.QuickView","sap.m.QuickViewCard","sap.m.QuickViewPage","sap.m.QuickViewGroup","sap.m.QuickViewGroupElement","sap.m.RadioButton","sap.m.RadioButtonGroup","sap.m.RangeSlider","sap.m.RatingIndicator","sap.m.ResponsivePopover","sap.m.ScrollContainer","sap.m.SearchField","sap.m.SegmentedButton","sap.m.Select","sap.m.SelectDialog","sap.m.SelectList","sap.m.Shell","sap.m.Slider","sap.m.SlideTile","sap.m.StepInput","sap.m.SplitApp","sap.m.SplitContainer","sap.m.StandardListItem","sap.m.StandardTreeItem","sap.m.StandardTile","sap.m.Switch","sap.m.Table","sap.m.TableSelectDialog","sap.m.TabContainer","sap.m.TabStrip","sap.m.TabStripSelect","sap.m.TabStripSelectList","sap.m.TabStripItem","sap.m.Text","sap.m.TextArea","sap.m.Tile","sap.m.TileContainer","sap.m.TileContent","sap.m.TimePicker","sap.m.Title","sap.m.ToggleButton","sap.m.Token","sap.m.Tokenizer","sap.m.Toolbar","sap.m.ToolbarSpacer","sap.m.ToolbarSeparator","sap.m.Tree","sap.m.TreeItemBase","sap.m.UploadCollection","sap.m.UploadCollectionToolbarPlaceholder","sap.m.VBox","sap.m.ViewSettingsDialog","sap.m.ViewSettingsPopover","sap.m.semantic.DetailPage","sap.m.semantic.FullscreenPage","sap.m.semantic.MasterPage","sap.m.Wizard","sap.m.WizardStep"],elements:["sap.m.Column","sap.m.FlexItemData","sap.m.IconTabFilter","sap.m.IconTabSeparator","sap.m.LightBoxItem","sap.m.OverflowToolbarLayoutData","sap.m.MaskInputRule","sap.m.MenuItem","sap.m.MessagePopoverItem","sap.m.PageAccessibleLandmarkInfo","sap.m.P13nFilterItem","sap.m.P13nItem","sap.m.PlanningCalendarRow","sap.m.PlanningCalendarView","sap.m.P13nSortItem","sap.m.SegmentedButtonItem","sap.m.SuggestionItem","sap.m.TabContainerItem","sap.m.ToolbarLayoutData","sap.m.UploadCollectionItem","sap.m.UploadCollectionParameter","sap.m.ViewSettingsCustomItem","sap.m.ViewSettingsCustomTab","sap.m.ViewSettingsFilterItem","sap.m.ViewSettingsItem","sap.m.semantic.SemanticButton","sap.m.semantic.SemanticSelect"]});sap.m.BackgroundDesign={Solid:"Solid",Transparent:"Transparent",Translucent:"Translucent"};sap.m.BarDesign={Auto:"Auto",Header:"Header",SubHeader:"SubHeader",Footer:"Footer"};sap.m.ButtonType={Default:"Default",Back:"Back",Accept:"Accept",Reject:"Reject",Transparent:"Transparent",Up:"Up",Unstyled:"Unstyled",Emphasized:"Emphasized"};sap.m.CarouselArrowsPlacement={Content:"Content",PageIndicator:"PageIndicator"};sap.m.DateTimeInputType={Date:"Date",DateTime:"DateTime",Time:"Time"};sap.m.DialogType={Standard:"Standard",Message:"Message"};sap.m.DeviationIndicator={Up:"Up",Down:"Down",None:"None"};sap.m.DraftIndicatorState={Clear:"Clear",Saving:"Saving",Saved:"Saved"};sap.m.FacetFilterListDataType={Date:"Date",DateTime:"DateTime",Time:"Time",Integer:"Integer",Float:"Float",String:"String",Boolean:"Boolean"};sap.m.FacetFilterType={Simple:"Simple",Light:"Light"};sap.m.FlexAlignItems={Start:"Start",End:"End",Center:"Center",Baseline:"Baseline",Stretch:"Stretch",Inherit:"Inherit"};sap.m.FlexAlignSelf={Auto:"Auto",Start:"Start",End:"End",Center:"Center",Baseline:"Baseline",Stretch:"Stretch",Inherit:"Inherit"};sap.m.FlexDirection={Row:"Row",Column:"Column",RowReverse:"RowReverse",ColumnReverse:"ColumnReverse",Inherit:"Inherit"};sap.m.FlexJustifyContent={Start:"Start",End:"End",Center:"Center",SpaceBetween:"SpaceBetween",SpaceAround:"SpaceAround",Inherit:"Inherit"};sap.m.FlexWrap={NoWrap:"NoWrap",Wrap:"Wrap",WrapReverse:"WrapReverse"};sap.m.FlexAlignContent={Start:"Start",End:"End",Center:"Center",SpaceBetween:"SpaceBetween",SpaceAround:"SpaceAround",Stretch:"Stretch",Inherit:"Inherit"};sap.m.FlexRendertype={Div:"Div",List:"List",Bare:"Bare"};sap.m.FrameType={OneByOne:"OneByOne",TwoByOne:"TwoByOne",TwoThirds:"TwoThirds",Auto:"Auto"};sap.m.GenericTileMode={ContentMode:"ContentMode",HeaderMode:"HeaderMode"};sap.m.HeaderLevel={H1:"H1",H2:"H2",H3:"H3",H4:"H4",H5:"H5",H6:"H6"};sap.m.IBarHTMLTag={Div:"Div",Header:"Header",Footer:"Footer"};sap.m.IconTabHeaderMode={Standard:"Standard",Inline:"Inline"};sap.m.IconTabFilterDesign={Horizontal:"Horizontal",Vertical:"Vertical"};sap.m.ImageMode={Image:"Image",Background:"Background"};sap.m.Size={XS:"XS",S:"S",M:"M",L:"L",Auto:"Auto"};sap.m.ValueColor={Neutral:"Neutral",Good:"Good",Critical:"Critical",Error:"Error"};sap.m.ValueCSSColor=a.createType('sap.m.ValueCSSColor',{isValid:function(v){return/^(#([0-9a-fA-F]{3}|[0-9a-fA-F]{6})|rgb\(\s*((1?[0-9]?[0-9]|2([0-4][0-9]|5[0-5]))|([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*(,\s*((1?[0-9]?[0-9]|2([0-4][0-9]|5[0-5]))|([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*){2}\)|rgba\((\s*((1?[0-9]?[0-9]|2([0-4][0-9]|5[0-5]))|([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*,){3}\s*(0(\.[0-9]+)?|1(\.0+)?)\s*\)|hsl\(\s*([0-2]?[0-9]?[0-9]|3([0-5][0-9]|60))\s*(,\s*(([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*){2}\)|hsla\(\s*([0-2]?[0-9]?[0-9]|3([0-5][0-9]|60))\s*,(\s*(([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*,){2}\s*(0(\.[0-9]+)?|1(\.0+)?)\s*\)|aliceblue|antiquewhite|aqua|aquamarine|azure|beige|bisque|black|blanchedalmond|blue|blueviolet|brown|burlywood|cadetblue|chartreuse|chocolate|coralcornflowerblue|cornsilk|crimson|cyan|darkblue|darkcyan|darkgoldenrod|darkgray|darkgreen|darkkhaki|darkmagenta|darkolivegreen|darkorange|darkorchid|darkred|darksalmon|darkseagreen|darkslateblue|darkslategray|darkturquoise|darkviolet|deeppink|deepskyblue|dimgray|dodgerblue|firebrick|floralwhite|forestgreen|fuchsia|gainsboro|ghostwhite|gold|goldenrod|gray|green|greenyellow|honeydew|hotpink|indianred|indigo|ivory|khaki|lavender|lavenderblush|lawngreen|lemonchiffon|lightblue|lightcoral|lightcyan|lightgoldenrodyellow|lightgray|lightgreen|lightpink|lightsalmon|lightseagreen|lightskyblue|lightslategray|lightsteelblue|lightyellow|lime|limegreen|linen|magenta|maroon|mediumaquamarine|mediumblue|mediumorchid|mediumpurple|mediumseagreen|mediumslateblue|mediumspringgreen|mediumturquoise|mediumvioletred|midnightblue|mintcream|mistyrose|moccasin|navajowhite|navy|oldlace|olive|olivedrab|orange|orangered|orchid|palegoldenrod|palegreen|paleturquoise|palevioletred|papayawhip|peachpuff|peru|pink|plum|powderblue|purple|red|rosybrown|royalblue|saddlebrown|salmon|sandybrown|seagreen|seashell|sienna|silverskyblue|slateblue|slategray|snow|springgreen|steelblue|tan|teal|thistle|tomato|turquoise|violet|wheat|white|whitesmoke|yellow|yellowgreen|transparent|inherit|Neutral|Good|Critical|Error|)$/.test(v);}},a.getType('string'));sap.m.InputType={Text:"Text",Date:"Date",Datetime:"Datetime",DatetimeLocale:"DatetimeLocale",Email:"Email",Month:"Month",Number:"Number",Tel:"Tel",Time:"Time",Url:"Url",Week:"Week",Password:"Password"};sap.m.LabelDesign={Bold:"Bold",Standard:"Standard"};sap.m.ListHeaderDesign={Standard:"Standard",Plain:"Plain"};sap.m.ListMode={None:"None",SingleSelect:"SingleSelect",SingleSelectLeft:"SingleSelectLeft",SingleSelectMaster:"SingleSelectMaster",MultiSelect:"MultiSelect",Delete:"Delete"};sap.m.ListKeyboardMode={Navigation:"Navigation",Edit:"Edit"};sap.m.ListGrowingDirection={Downwards:"Downwards",Upwards:"Upwards"};sap.m.ListSeparators={All:"All",Inner:"Inner",None:"None"};sap.m.ListType={Inactive:"Inactive",Detail:"Detail",Navigation:"Navigation",Active:"Active",DetailAndActive:"DetailAndActive"};sap.m.SelectListKeyboardNavigationMode={None:"None",Delimited:"Delimited"};sap.m.LoadState={Loading:"Loading",Loaded:"Loaded",Failed:"Failed",Disabled:"Disabled"};sap.m.MenuButtonMode={Regular:"Regular",Split:"Split"};sap.m.OverflowToolbarPriority={NeverOverflow:"Never",High:"High",Low:"Low",Disappear:"Disappear",AlwaysOverflow:"Always"};sap.m.P13nPanelType={sort:"sort",filter:"filter",group:"group",columns:"columns",dimeasure:"dimeasure"};sap.m.PageBackgroundDesign={Standard:"Standard",List:"List",Solid:"Solid",Transparent:"Transparent"};sap.m.PlacementType={Left:"Left",Right:"Right",Top:"Top",Bottom:"Bottom",Vertical:"Vertical",VerticalPreferedTop:"VerticalPreferedTop",VerticalPreferredTop:"VerticalPreferredTop",VerticalPreferedBottom:"VerticalPreferedBottom",VerticalPreferredBottom:"VerticalPreferredBottom",Horizontal:"Horizontal",HorizontalPreferedRight:"HorizontalPreferedRight",HorizontalPreferredRight:"HorizontalPreferredRight",HorizontalPreferedLeft:"HorizontalPreferedLeft",HorizontalPreferredLeft:"HorizontalPreferredLeft",PreferredLeftOrFlip:"PreferredLeftOrFlip",PreferredRightOrFlip:"PreferredRightOrFlip",PreferredTopOrFlip:"PreferredTopOrFlip",PreferredBottomOrFlip:"PreferredBottomOrFlip",Auto:"Auto"};sap.m.QuickViewGroupElementType={phone:"phone",mobile:"mobile",email:"email",link:"link",text:"text",pageLink:"pageLink"};sap.m.VerticalPlacementType={Top:"Top",Bottom:"Bottom",Vertical:"Vertical"};sap.m.PopinDisplay={Block:"Block",Inline:"Inline",WithoutHeader:"WithoutHeader"};sap.m.RatingIndicatorVisualMode={Full:"Full",Half:"Half"};sap.m.ScreenSize={Phone:"Phone",Tablet:"Tablet",Desktop:"Desktop",XXSmall:"XXSmall",XSmall:"XSmall",Small:"Small",Medium:"Medium",Large:"Large",XLarge:"XLarge",XXLarge:"XXLarge"};sap.m.SelectType={Default:"Default",IconOnly:"IconOnly"};sap.m.SplitAppMode={ShowHideMode:"ShowHideMode",StretchCompressMode:"StretchCompressMode",PopoverMode:"PopoverMode",HideMode:"HideMode"};sap.m.StandardTileType={Create:"Create",Monitor:"Monitor",None:"None"};sap.m.ObjectMarkerType={Flagged:"Flagged",Favorite:"Favorite",Draft:"Draft",Locked:"Locked",Unsaved:"Unsaved",LockedBy:"LockedBy",UnsavedBy:"UnsavedBy"};sap.m.ObjectMarkerVisibility={IconOnly:"IconOnly",TextOnly:"TextOnly",IconAndText:"IconAndText"};sap.m.SwipeDirection={LeftToRight:"LeftToRight",RightToLeft:"RightToLeft",Both:"Both"};sap.m.SwitchType={Default:"Default",AcceptReject:"AcceptReject"};sap.m.ToolbarDesign={Auto:"Auto",Transparent:"Transparent",Info:"Info",Solid:"Solid"};sap.m.StringFilterOperator={Equals:"Equals",Contains:"Contains",StartsWith:"StartsWith",AnyWordStartsWith:"AnyWordStartsWith"};sap.m.LightBoxLoadingStates={Loading:"LOADING",Loaded:"LOADED",TimeOutError:"TIME_OUT_ERROR",Error:"ERROR"};sap.ui.lazyRequire("sap.m.MessageToast","show");sap.ui.lazyRequire("sap.m.routing.RouteMatchedHandler");sap.ui.lazyRequire("sap.m.routing.Router");sap.ui.lazyRequire("sap.m.routing.Target");sap.ui.lazyRequire("sap.m.routing.TargetHandler");sap.ui.lazyRequire("sap.m.routing.Targets");if(D.os.ios&&D.os.version>=7&&D.os.version<8&&D.browser.name==="sf"){q.sap.require("sap.m.ios7");}if(/sap-ui-xx-formfactor=compact/.test(location.search)){q("html").addClass("sapUiSizeCompact");sap.m._bSizeCompact=true;}if(/sap-ui-xx-formfactor=condensed/.test(location.search)){q("html").addClass("sapUiSizeCondensed");sap.m._bSizeCondensed=true;}!(function(l){l.getInvalidDate=function(){return null;};l.getLocale=function(){var c=sap.ui.getCore().getConfiguration(),L=c.getFormatSettings().getFormatLocale().toString(),o=new sap.ui.core.Locale(L);c=L=null;l.getLocale=function(){return o;};return o;};l.getLocaleData=function(){q.sap.require("sap.ui.model.type.Date");var L=sap.ui.core.LocaleData.getInstance(l.getLocale());l.getLocaleData=function(){return L;};return L;};l.isDate=function(v){return v&&Object.prototype.toString.call(v)=="[object Date]"&&!isNaN(v);};l.getIScroll=function(c){if(typeof window.iScroll!="function"||!(c instanceof sap.ui.core.Control)){return;}var p,s;for(p=c;p=p.oParent;){s=p.getScrollDelegate?p.getScrollDelegate()._scroller:null;if(s&&s instanceof window.iScroll){return s;}}};l.getScrollDelegate=function(c){if(!(c instanceof sap.ui.core.Control)){return;}for(var p=c;p=p.oParent;){if(typeof p.getScrollDelegate=="function"){return p.getScrollDelegate();}}};l.ScreenSizes={phone:240,tablet:600,desktop:1024,xxsmall:240,xsmall:320,small:480,medium:560,large:768,xlarge:960,xxlarge:1120};l.BaseFontSize=q(document.documentElement).css("font-size");l.closeKeyboard=function(){var b=document.activeElement;if(!D.system.desktop&&b&&/(INPUT|TEXTAREA)/i.test(b.tagName)){b.blur();}};}(sap.m));if(sap.m&&!sap.m.touch){sap.m.touch={};}
sap.m.touch.find=function(t,T){var i,b;if(!t){return;}if(T&&typeof T.identifier!=="undefined"){T=T.identifier;}else if(typeof T!=="number"){return;}b=t.length;for(i=0;i<b;i++){if(t[i].identifier===T){return t[i];}}};
sap.m.touch.countContained=function(t,e){var i,T=0,b,E,$;if(!t){return 0;}if(e instanceof Element){e=q(e);}else if(typeof e==="string"){e=q.sap.byId(e);}else if(!(e instanceof q)){return 0;}E=e.children().length;b=t.length;for(i=0;i<b;i++){$=q(t[i].target);if((E===0&&$.is(e))||(e[0].contains($[0]))){T++;}}return T;};
sap.m.URLHelper=(function($,w){function i(v){return v&&Object.prototype.toString.call(v)=="[object String]";}function f(t){if(!i(t)){return"";}return t.replace(/[^0-9\+\*#]/g,"");}function b(t){if(!i(t)){return"";}t=t.split(/\r\n|\r|\n/g).join("\r\n");return w.encodeURIComponent(t);}return $.extend(new sap.ui.base.EventProvider(),{normalizeTel:function(t){return"tel:"+f(t);},normalizeSms:function(t){return"sms:"+f(t);},normalizeEmail:function(e,s,B,c,d){var p=[],u="mailto:",g=w.encodeURIComponent;i(e)&&(u+=g($.trim(e)));i(s)&&p.push("subject="+g(s));i(B)&&p.push("body="+b(B));i(d)&&p.push("bcc="+g($.trim(d)));i(c)&&p.push("cc="+g($.trim(c)));if(p.length){u+="?"+p.join("&");}return u;},redirect:function(u,n){this.fireEvent("redirect",u);if(!n){w.location.href=u;}else{var W=w.open(u,"_blank");if(!W){$.sap.log.error(this+"#redirect: Could not open "+u);if(D.os.windows_phone||(D.browser.edge&&D.browser.mobile)){q.sap.log.warning("URL will be enforced to open in the same window as a fallback from a known Windows Phone system restriction. Check the documentation for more information.");w.location.href=u;}}}},attachRedirect:function(F,l){return this.attachEvent("redirect",F,l);},detachRedirect:function(F,l){return this.detachEvent("redirect",F,l);},triggerTel:function(t){this.redirect(this.normalizeTel(t));},triggerSms:function(t){this.redirect(this.normalizeSms(t));},triggerEmail:function(e,s,B,c,d){this.redirect(this.normalizeEmail.apply(0,arguments));},toString:function(){return"sap.m.URLHelper";}});}(q,window));sap.m.BackgroundHelper=(function($,w){return{addBackgroundColorStyles:function(r,b,B,c){r.addClass(c||"sapUiGlobalBackgroundColor");if(b||B){r.addStyle("background-image","none");r.addStyle("filter","none");}if(b){r.addStyle("background-color",q.sap.encodeHTML(b));}},renderBackgroundImageTag:function(r,c,C,b,R,o){r.write("<div id='"+c.getId()+"-BG' ");if(q.isArray(C)){for(var i=0;i<C.length;i++){r.addClass(C[i]);}}else{r.addClass(C);}r.addClass("sapUiGlobalBackgroundImage");if(b){r.addStyle("display","block");r.addStyle("background-image","url("+q.sap.encodeHTML(b)+")");r.addStyle("background-repeat",R?"repeat":"no-repeat");if(!R){r.addStyle("background-size","cover");r.addStyle("background-position","center");}else{r.addStyle("background-position","left top");}}if(o!==1){if(o>1){o=1;}r.addStyle("opacity",o);}r.writeClasses(false);r.writeStyles();r.write("></div>");}};}(q,window));sap.m.ImageHelper=(function($,w){function c(C,p,v){if(v!==undefined){var s=C['set'+q.sap.charToUpperCase(p)];if(typeof(s)==="function"){s.call(C,v);return true;}}return false;}return{getImageControl:function(i,I,p,P,C,b){if(I&&(I.getSrc()!=P['src'])){I.destroy();I=undefined;}var o=I;if(!!o&&(o instanceof sap.m.Image||o instanceof sap.ui.core.Icon)){for(var d in P){c(o,d,P[d]);}}else{if(!sap.m.Image){q.sap.require("sap.m.Image");}var s=P;s['id']=i;o=sap.ui.core.IconPool.createControlByURI(s,sap.m.Image);o.setParent(p,null,true);}if(!!b){for(var l=0,r=b.length;l!==r;l++){o.removeStyleClass(b[l]);}}if(!!C){for(var k=0,e=C.length;k!==e;k++){o.addStyleClass(C[k]);}}I=o;return I;}};}(q,window));sap.m.PopupHelper=(function(){return{calcPercentageSize:function(p,b){if(typeof p!=="string"){q.sap.log.warning("sap.m.PopupHelper: calcPercentageSize, the first parameter"+p+"isn't with type string");return null;}if(p.indexOf("%")<=0){q.sap.log.warning("sap.m.PopupHelper: calcPercentageSize, the first parameter"+p+"is not a percentage string (for example '25%')");return null;}var P=parseFloat(p)/100,f=parseFloat(b);return Math.floor(P*f)+"px";}};}());sap.m.InputODataSuggestProvider=(function(){var _=function(e){var c=e.getSource();var v=c.data(c.getId()+"-#valueListAnnotation");var m=c.getModel();var i=c.getBinding("value");var I=m.resolve(i.getPath(),i.getContext());if(!v){return;}var r=e.getParameter("selectedRow");q.each(r.getCells(),function(d,C){var o=C.getBinding("text");q.each(v.outParameters,function(k,O){if(!O.displayOnly&&O.value==o.getPath()){var V=o.getValue();var s=m.resolve(k,i.getContext());if(V&&s!==I){m.setProperty(s,V);}}});});return true;};var b=function(c,r){var M=c.getModel();var o=M.oMetadata;var p=M.resolve(c.getBindingPath("value"),c.getBindingContext());var v={};v.searchSupported=false;v.collectionPath="";v.outParameters={};v.inParameters={};v.selection=[];var A=M.getProperty(p+"/#com.sap.vocabularies.Common.v1.ValueList");if(!A){return false;}var P=p.substr(p.lastIndexOf('/')+1);v.inProperty=P;q.each(A.record,function(i,d){q.each(d,function(j,e){if(e.property==="SearchSupported"&&e.bool){v.searchSupported=true;}if(e.property==="CollectionPath"){v.collectionPath=e.string;}if(e.property==="Parameters"){q.each(e.collection.record,function(k,R){if(R.type==="com.sap.vocabularies.Common.v1.ValueListParameterIn"){var l;q.each(R.propertyValue,function(m,f){if(f.property==="LocalDataProperty"){l=f.propertyPath;}});q.each(R.propertyValue,function(m,f){if(f.property==="ValueListProperty"){v.inParameters[l]={value:f.string};}});}else if(R.type==="com.sap.vocabularies.Common.v1.ValueListParameterInOut"){var l;q.each(R.propertyValue,function(m,f){if(f.property==="LocalDataProperty"){l=f.propertyPath;}});q.each(R.propertyValue,function(m,f){if(f.property==="ValueListProperty"){v.outParameters[l]={value:f.string};v.inParameters[l]={value:f.string};}});}else if(R.type==="com.sap.vocabularies.Common.v1.ValueListParameterOut"){var l;q.each(R.propertyValue,function(m,f){if(f.property==="LocalDataProperty"){l=f.propertyPath;}});q.each(R.propertyValue,function(m,f){if(f.property==="ValueListProperty"){v.outParameters[l]={value:f.string};}});}else if(R.type==="com.sap.vocabularies.Common.v1.ValueListParameterDisplayOnly"){var l;q.each(R.propertyValue,function(m,f){if(f.property==="ValueListProperty"){v.outParameters[f.string]={value:f.string,displayOnly:true};}});}});}});});v.resultEntity=o._getEntityTypeByPath("/"+v.collectionPath);v.listItem=new sap.m.ColumnListItem();q.each(v.outParameters,function(k,O){v.listItem.addCell(new sap.m.Text({text:"{"+O.value+"}",wrapping:false}));c.addSuggestionColumn(new sap.m.Column({header:new sap.m.Text({text:"{/#"+v.resultEntity.name+"/"+O.value+"/@sap:label}",wrapping:false})}));v.selection.push(O.value);});c.data(c.getId()+"-#valueListAnnotation",v);if(r){c.attachSuggestionItemSelected(_);}};return{suggest:function(e,r,R,l){var v,c=e.getSource();r=r===undefined?true:r;R=R===undefined?true:R;if(!c.data(c.getId()+"-#valueListAnnotation")){b(c,R);}v=c.data(c.getId()+"-#valueListAnnotation");if(!v){return;}var d=function(e){var B=this.getLength();if(B&&B<=l){c.setShowTableSuggestionValueHelp(false);}else{c.setShowTableSuggestionValueHelp(true);}};if(v.searchSupported){var f=[];var s,C={};if(r){q.each(v.inParameters,function(k,o){if(k==v.inProperty){s=o.value;}else if(r){var V=c.getModel().getProperty(k,c.getBinding("value").getContext());if(V){f.push(new sap.ui.model.Filter(o.value,sap.ui.model.FilterOperator.StartsWith,V));}}});}C.search=e.getParameter("suggestValue");if(v.inParameters.length){if(s){C["search-focus"]=s;}else{}}c.bindAggregation("suggestionRows",{path:"/"+v.collectionPath,length:l,filters:f,parameters:{select:v.selection.join(','),custom:C},events:{dataReceived:d},template:v.listItem});}else{var f=[];q.each(v.inParameters,function(k,o){if(k==v.inProperty){f.push(new sap.ui.model.Filter(o.value,sap.ui.model.FilterOperator.StartsWith,e.getParameter("suggestValue")));}else if(r){var V=c.getModel().getProperty(k,c.getBinding("value").getContext());if(V){f.push(new sap.ui.model.Filter(o.value,sap.ui.model.FilterOperator.StartsWith,V));}}});c.bindAggregation("suggestionRows",{path:"/"+v.collectionPath,filters:f,template:v.listItem,length:l,parameters:{select:v.selection.join(',')},events:{dataReceived:d}});}}};}());q.sap.setObject("sap.ui.layout.form.FormHelper",{createLabel:function(t){return new sap.m.Label({text:t});},createButton:function(i,p){var b=new sap.m.Button(i,{type:sap.m.ButtonType.Transparent});b.attachEvent('press',p,this);return b;},setButtonContent:function(b,t,T,i,I){b.setText(t);b.setTooltip(T);b.setIcon(i);b.setActiveIcon(I);},addFormClass:function(){return"sapUiFormM";},setToolbar:function(t){var o=this.getToolbar();if(o&&o.setDesign){o.setDesign(o.getDesign(),true);}if(t&&t.setDesign){t.setDesign(sap.m.ToolbarDesign.Transparent,true);}return t;},bArrowKeySupport:false,bFinal:true});q.sap.setObject("sap.ui.unified.FileUploaderHelper",{createTextField:function(i){var t=new sap.m.Input(i);return t;},setTextFieldContent:function(t,w){t.setWidth(w);},createButton:function(){var b=new sap.m.Button();return b;},addFormClass:function(){return"sapUiFUM";},bFinal:true});q.sap.setObject("sap.ui.table.TableHelper",{createLabel:function(c){return new sap.m.Label(c);},createTextView:function(c){return new sap.m.Label(c);},createTextField:function(c){return new sap.m.Input(c);},createImage:function(c){var i=new sap.m.Image(c);i.setDensityAware(false);return i;},addTableClass:function(){return"sapUiTableM";},bFinal:true});if(sap.ui.Device.os.blackberry||sap.ui.Device.os.android&&sap.ui.Device.os.version>=4){q(window).on("resize",function(){var A=document.activeElement;var t=A?A.tagName:"";if(t=="INPUT"||t=="TEXTAREA"){window.setTimeout(function(){A.scrollIntoViewIfNeeded();},0);}});}return sap.m;});
sap.ui.predefine('sap/m/routing/RouteMatchedHandler',['jquery.sap.global','sap/ui/base/Object','sap/ui/core/routing/History','sap/ui/core/routing/Router','./TargetHandler','./Router'],function(q,B,H,R,T,M){"use strict";
var a=B.extend("sap.m.routing.RouteMatchedHandler",{constructor:function(r,c){if(r instanceof M){q.sap.log.warning("A sap.m.routing.Router is used together with a sap.m.routing.RouteMatchedHandler (deprecated)."+"The RoutematchedHandler is not taking over triggering the navigations, the Router will do it.",this);return;}this._oTargetHandler=new T(c);r._oTargetHandler=this._oTargetHandler;r.attachRouteMatched(this._onHandleRouteMatched,this);r.attachRoutePatternMatched(this._handleRoutePatternMatched,this);this._oTargets=r.getTargets();if(this._oTargets){this._oTargets.attachDisplay(this._onHandleDisplay,this);}this._oRouter=r;}});
a.prototype.destroy=function(){if(this._oRouter){this._oRouter.detachRouteMatched(this._onHandleRouteMatched,this);this._oRouter.detachRoutePatternMatched(this._handleRoutePatternMatched,this);this._oRouter=null;}if(this._oTargets){this._oTargets.detachDisplay(this._onHandleRouteMatched,this);this._oTargets=null;}return this;};
a.prototype.setCloseDialogs=function(c){this._oTargetHandler.setCloseDialogs(c);return this;};
a.prototype.getCloseDialogs=function(){return this._oTargetHandler.getCloseDialogs();};
a.prototype._handleRoutePatternMatched=function(e){var t=+e.getParameter("config").viewLevel;this._oTargetHandler.navigate({viewLevel:t,navigationIdentifier:e.getParameter("name"),askHistory:true});};
a.prototype._onHandleRouteMatched=function(e){var p=e.getParameters(),c=p.config;if(!this._oRouter.getRoute(p.name)._oTarget){return;}this._oTargetHandler.addNavigation({targetControl:p.targetControl,eventData:p.arguments,view:p.view,navigationIdentifier:p.name,transition:c.transition,transitionParameters:c.transitionParameters,preservePageInSplitContainer:c.preservePageInSplitContainer});};
a.prototype._onHandleDisplay=function(e){var p=e.getParameters(),c=p.config;this._oTargetHandler.addNavigation({targetControl:p.control,eventData:p.data,view:p.view,navigationIdentifier:p.name,transition:c.transition,transitionParameters:c.transitionParameters,preservePageInSplitContainer:c.preservePageInSplitContainer});};
return a;},true);
sap.ui.predefine('sap/m/routing/Router',['sap/ui/core/routing/Router','./TargetHandler','./Targets'],function(R,T,a){"use strict";
var M=R.extend("sap.m.routing.Router",{
constructor:function(){this._oTargetHandler=new T();R.prototype.constructor.apply(this,arguments);},
destroy:function(){R.prototype.destroy.apply(this,arguments);this._oTargetHandler.destroy();this._oTargetHandler=null;},
getTargetHandler:function(){return this._oTargetHandler;},
_createTargets:function(c,t){return new a({views:this._oViews,config:c,targets:t,targetHandler:this._oTargetHandler});},
fireRouteMatched:function(A){var r=this.getRoute(A.name),t;if(r._oTarget){t=r._oTarget._oOptions;this._oTargetHandler.addNavigation({navigationIdentifier:A.name,transition:t.transition,transitionParameters:t.transitionParameters,eventData:A.arguments,targetControl:A.targetControl,view:A.view,preservePageInSplitContainer:t.preservePageInSplitContainer});}return R.prototype.fireRouteMatched.apply(this,arguments);},
fireRoutePatternMatched:function(A){var r=A.name,v;if(this._oTargets&&this._oTargets._oLastDisplayedTarget){v=this._oTargets._getViewLevel(this._oTargets._oLastDisplayedTarget);}this._oTargetHandler.navigate({navigationIdentifier:r,viewLevel:v,askHistory:true});return R.prototype.fireRoutePatternMatched.apply(this,arguments);}
});
return M;},true);
sap.ui.predefine('sap/m/routing/Target',['sap/ui/core/routing/Target','./async/Target','./sync/Target'],function(T,a,s){"use strict";
var M=T.extend("sap.m.routing.Target",{constructor:function(o,v,p,t){this._oTargetHandler=t;function c(){if(jQuery.sap.getUriParameters().get("sap-ui-xx-asyncRouting")==="true"){jQuery.sap.log.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","MobileTarget");return true;}return false;}if(o._async===undefined){o._async=c();}T.prototype.constructor.apply(this,arguments);var b=o._async?a:s;this._super={};for(var f in b){this._super[f]=this[f];this[f]=b[f];}}});
return M;},true);
sap.ui.predefine('sap/m/routing/TargetHandler',['jquery.sap.global','sap/m/InstanceManager','sap/m/NavContainer','sap/m/SplitContainer','sap/ui/base/Object','sap/ui/core/routing/History','sap/ui/core/routing/Router'],function($,I,N,S,B,H,R){"use strict";
var T=B.extend("sap.m.routing.TargetHandler",{constructor:function(c){this._aQueue=[];this._oNavigationOrderPromise=Promise.resolve();if(c===undefined){this._bCloseDialogs=true;}else{this._bCloseDialogs=!!c;}}});
T.prototype.setCloseDialogs=function(c){this._bCloseDialogs=!!c;return this;};
T.prototype.getCloseDialogs=function(){return this._bCloseDialogs;};
T.prototype.addNavigation=function(p){this._aQueue.push(p);};
T.prototype.navigate=function(d){var r=this._createResultingNavigations(d.navigationIdentifier),c=false,b=this._getDirection(d),n;while(r.length){n=this._applyNavigationResult(r.shift().oParams,b);c=c||n;}if(c){this._closeDialogs();}};
T.prototype._chainNavigation=function(n){this._oNavigationOrderPromise=this._oNavigationOrderPromise.then(n);return this._oNavigationOrderPromise;};
T.prototype._getDirection=function(d){var t=d.viewLevel,h=H.getInstance(),b=false;if(d.direction==="Backwards"){b=true;}else if(isNaN(t)||isNaN(this._iCurrentViewLevel)||t===this._iCurrentViewLevel){if(d.askHistory){b=h.getDirection()==="Backwards";}}else{b=t<this._iCurrentViewLevel;}this._iCurrentViewLevel=t;return b;};
T.prototype._createResultingNavigations=function(n){var i,f,c,C,o,r=[],v,b,a,p,d;while(this._aQueue.length){f=false;c=this._aQueue.shift();C=c.targetControl;b=C instanceof S;a=C instanceof N;v=c.view;o={oContainer:C,oParams:c,bIsMasterPage:(b&&!!C.getMasterPage(v.getId()))};p=b&&c.preservePageInSplitContainer&&C.getCurrentPage(o.bIsMasterPage)&&n!==c.navigationIdentifier;if(!(a||b)||!v){continue;}for(i=0;i<r.length;i++){d=r[i];if(d.oContainer!==C){continue;}if(a||sap.ui.Device.system.phone){r.splice(i,1);r.push(o);f=true;break;}if(d.bIsMasterPage===o.bIsMasterPage){if(p){break;}r.splice(i,1);r.push(o);f=true;break;}}if(C instanceof S&&!sap.ui.Device.system.phone){o.bIsMasterPage=!!C.getMasterPage(v.getId());}if(!f){if(!!C.getCurrentPage(o.bIsMasterPage)&&p){continue;}r.push(o);}}return r;};
T.prototype._applyNavigationResult=function(p,b){var t=p.targetControl,P,a=p.eventData,s=p.transition||"",o=p.transitionParameters,v=p.view.getId(),n=t instanceof S&&!!t.getMasterPage(v);if(t.getDomRef()&&t.getCurrentPage(n).getId()===v){$.sap.log.info("navigation to view with id: "+v+" is skipped since it already is displayed by its targetControl","sap.m.routing.TargetHandler");return false;}$.sap.log.info("navigation to view with id: "+v+" the targetControl is "+t.getId()+" backwards is "+b);if(b){P=t.getPreviousPage(n);if(!P||P.getId()!==v){t.insertPreviousPage(v,s,a);}t.backToPage(v,a,o);}else{t.to(v,s,a,o);}return true;};
T.prototype._closeDialogs=function(){if(!this._bCloseDialogs){return;}if(I.hasOpenPopover()){I.closeAllPopovers();}if(I.hasOpenDialog()){I.closeAllDialogs();}};
return T;},true);
sap.ui.predefine('sap/m/routing/Targets',['sap/ui/core/routing/Targets','./TargetHandler','./Target','./async/Targets','./sync/Targets'],function(T,a,b,c,s){"use strict";
var M=T.extend("sap.m.routing.Targets",{
constructor:function(o){if(!o.config){o.config={_async:false};}function d(){if(jQuery.sap.getUriParameters().get("sap-ui-xx-asyncRouting")==="true"){jQuery.sap.log.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","MobileTargets");return true;}return false;}if(o.config._async===undefined){o.config._async=(o.config.async===undefined)?d():o.config.async;}if(o.targetHandler){this._oTargetHandler=o.targetHandler;}else{this._oTargetHandler=new a();this._bHasOwnTargetHandler=true;}T.prototype.constructor.apply(this,arguments);var e=o.config._async?c:s;this._super={};for(var f in e){this._super[f]=this[f];this[f]=e[f];}},
destroy:function(){T.prototype.destroy.apply(this,arguments);if(this._bHasOwnTargetHandler){this._oTargetHandler.destroy();}this._oTargetHandler=null;},
getTargetHandler:function(){return this._oTargetHandler;},
_constructTarget:function(o,p){return new b(o,this._oViews,p,this._oTargetHandler);},
_getViewLevel:function(t){var v;do{v=t._oOptions.viewLevel;if(v!==undefined){return v;}t=t._oParent;}while(t);return v;}
});
return M;},true);
sap.ui.predefine('sap/m/routing/async/Target',[],function(){"use strict";return{_place:function(d){var p=this._super._place.apply(this,arguments),t=this;return this._oTargetHandler._chainNavigation(function(){return p.then(function(v){t._oTargetHandler.addNavigation({navigationIdentifier:t._oOptions.name,transition:t._oOptions.transition,transitionParameters:t._oOptions.transitionParameters,eventData:d,targetControl:v.control,view:v.view,preservePageInSplitContainer:t._oOptions.preservePageInSplitContainer});return v;});});}};},true);
sap.ui.predefine('sap/m/routing/async/Targets',[],function(){"use strict";return{display:function(){var v,n;this._oLastDisplayedTarget=null;var p=this._super.display.apply(this,arguments);return p.then(function(V){if(this._oLastDisplayedTarget){v=this._getViewLevel(this._oLastDisplayedTarget);n=this._oLastDisplayedTarget._oOptions.name;}this._oTargetHandler.navigate({viewLevel:v,navigationIdentifier:n});return V;}.bind(this));},_displaySingleTarget:function(n){var t=this.getTarget(n);return this._super._displaySingleTarget.apply(this,arguments).then(function(v){if(t){this._oLastDisplayedTarget=t;}return v;}.bind(this));}};},true);
sap.ui.predefine('sap/m/routing/sync/Target',[],function(){"use strict";return{_place:function(p,d){var r=this._super._place.apply(this,arguments);this._oTargetHandler.addNavigation({navigationIdentifier:this._oOptions.name,transition:this._oOptions.transition,transitionParameters:this._oOptions.transitionParameters,eventData:d,targetControl:r.oTargetControl,view:r.oTargetParent,preservePageInSplitContainer:this._oOptions.preservePageInSplitContainer});return r;}};},true);
sap.ui.predefine('sap/m/routing/sync/Targets',[],function(){"use strict";return{display:function(){var v,n;this._oLastDisplayedTarget=null;var r=this._super.display.apply(this,arguments);if(this._oLastDisplayedTarget){v=this._getViewLevel(this._oLastDisplayedTarget);n=this._oLastDisplayedTarget._oOptions.name;}this._oTargetHandler.navigate({viewLevel:v,navigationIdentifier:n});return r;},_displaySingleTarget:function(n){var t=this.getTarget(n);if(t){this._oLastDisplayedTarget=t;}return this._super._displaySingleTarget.apply(this,arguments);}};},true);
sap.ui.predefine('sap/m/semantic/AddAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var A=S.extend("sap.m.semantic.AddAction",{metadata:{library:"sap.m"}});
return A;},true);
sap.ui.predefine('sap/m/semantic/CancelAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var C=S.extend("sap.m.semantic.CancelAction",{metadata:{library:"sap.m"}});
return C;},true);
sap.ui.predefine('sap/m/semantic/DeleteAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var D=S.extend("sap.m.semantic.DeleteAction",{metadata:{library:"sap.m"}});
return D;},true);
sap.ui.predefine('sap/m/semantic/DetailPage.designtime',[],function(){"use strict";return{aggregations:{content:{domRef:":sap-domref > .sapMPage > section"}}};},false);
sap.ui.predefine('sap/m/semantic/DetailPage',["sap/m/semantic/ShareMenuPage","sap/m/semantic/SemanticConfiguration","sap/m/semantic/SemanticPageRenderer","sap/m/PagingButton"],function(S,a,b,P){"use strict";
var D=S.extend("sap.m.semantic.DetailPage",{
metadata:{library:"sap.m",aggregations:{addAction:{type:"sap.m.semantic.AddAction",multiple:false},mainAction:{type:"sap.m.semantic.MainAction",multiple:false},positiveAction:{type:"sap.m.semantic.PositiveAction",multiple:false},negativeAction:{type:"sap.m.semantic.NegativeAction",multiple:false},forwardAction:{type:"sap.m.semantic.ForwardAction",multiple:false},editAction:{type:"sap.m.semantic.EditAction",multiple:false},saveAction:{type:"sap.m.semantic.SaveAction",multiple:false},deleteAction:{type:"sap.m.semantic.DeleteAction",multiple:false},cancelAction:{type:"sap.m.semantic.CancelAction",multiple:false},flagAction:{type:"sap.m.semantic.FlagAction",multiple:false},favoriteAction:{type:"sap.m.semantic.FavoriteAction",multiple:false},openInAction:{type:"sap.m.semantic.OpenInAction",multiple:false},discussInJamAction:{type:"sap.m.semantic.DiscussInJamAction",multiple:false},shareInJamAction:{type:"sap.m.semantic.ShareInJamAction",multiple:false},sendEmailAction:{type:"sap.m.semantic.SendEmailAction",multiple:false},sendMessageAction:{type:"sap.m.semantic.SendMessageAction",multiple:false},printAction:{type:"sap.m.semantic.PrintAction",multiple:false},messagesIndicator:{type:"sap.m.semantic.MessagesIndicator",multiple:false},saveAsTileAction:{type:"sap.m.Button",multiple:false},pagingAction:{type:"sap.m.PagingButton",multiple:false},draftIndicator:{type:"sap.m.DraftIndicator",multiple:false}},designTime:true},
renderer:b.render
});
D.prototype.init=function(){S.prototype.init.call(this);this._getPage().getLandmarkInfo().setRootLabel(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SEMANTIC_DETAIL_PAGE_TITLE"));};
D.prototype.setAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(o){this._addToInnerAggregation(o,a.getPositionInPage(A),a.getSequenceOrderIndex(A),s);this[p]=o;}else{if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p]=null;}}return this;}return S.prototype.setAggregation.call(this,A,o,s);};
D.prototype.getAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){return this['_'+A];}return S.prototype.getAggregation.call(this,A,o,s);};
D.prototype.destroyAggregation=function(A,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p].destroy();this[p]=null;}return this;}return S.prototype.destroyAggregation.call(this,A,s);};
return D;},true);
sap.ui.predefine('sap/m/semantic/DiscussInJamAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var D=S.extend("sap.m.semantic.DiscussInJamAction",{metadata:{library:"sap.m"}});
return D;},true);
sap.ui.predefine('sap/m/semantic/EditAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var E=S.extend("sap.m.semantic.EditAction",{metadata:{library:"sap.m"}});
return E;},true);
sap.ui.predefine('sap/m/semantic/FavoriteAction',['sap/m/semantic/SemanticToggleButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FavoriteAction",{metadata:{library:"sap.m"}});
return F;},true);
sap.ui.predefine('sap/m/semantic/FilterAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FilterAction",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IFilter"]}});
return F;},true);
sap.ui.predefine('sap/m/semantic/FilterSelect',['sap/m/semantic/SemanticSelect'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FilterSelect",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IFilter"]}});
return F;},true);
sap.ui.predefine('sap/m/semantic/FlagAction',['sap/m/semantic/SemanticToggleButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FlagAction",{metadata:{library:"sap.m"}});
return F;},true);
sap.ui.predefine('sap/m/semantic/ForwardAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.ForwardAction",{metadata:{library:"sap.m"}});
return F;},true);
sap.ui.predefine('sap/m/semantic/FullscreenPage',["sap/m/semantic/ShareMenuPage","sap/m/semantic/SemanticConfiguration","sap/m/semantic/SemanticPageRenderer","sap/m/PagingButton"],function(S,a,b,P){"use strict";
var F=S.extend("sap.m.semantic.FullscreenPage",{
metadata:{library:"sap.m",aggregations:{addAction:{type:"sap.m.semantic.AddAction",multiple:false},mainAction:{type:"sap.m.semantic.MainAction",multiple:false},positiveAction:{type:"sap.m.semantic.PositiveAction",multiple:false},negativeAction:{type:"sap.m.semantic.NegativeAction",multiple:false},forwardAction:{type:"sap.m.semantic.ForwardAction",multiple:false},editAction:{type:"sap.m.semantic.EditAction",multiple:false},saveAction:{type:"sap.m.semantic.SaveAction",multiple:false},deleteAction:{type:"sap.m.semantic.DeleteAction",multiple:false},cancelAction:{type:"sap.m.semantic.CancelAction",multiple:false},flagAction:{type:"sap.m.semantic.FlagAction",multiple:false},favoriteAction:{type:"sap.m.semantic.FavoriteAction",multiple:false},openInAction:{type:"sap.m.semantic.OpenInAction",multiple:false},discussInJamAction:{type:"sap.m.semantic.DiscussInJamAction",multiple:false},shareInJamAction:{type:"sap.m.semantic.ShareInJamAction",multiple:false},sendEmailAction:{type:"sap.m.semantic.SendEmailAction",multiple:false},sendMessageAction:{type:"sap.m.semantic.SendMessageAction",multiple:false},printAction:{type:"sap.m.semantic.PrintAction",multiple:false},messagesIndicator:{type:"sap.m.semantic.MessagesIndicator",multiple:false},saveAsTileAction:{type:"sap.m.Button",multiple:false},pagingAction:{type:"sap.m.PagingButton",multiple:false},draftIndicator:{type:"sap.m.DraftIndicator",multiple:false}}},
renderer:b.render
});
F.prototype.setAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(o){this._addToInnerAggregation(o,a.getPositionInPage(A),a.getSequenceOrderIndex(A),s);this[p]=o;}else{if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p]=null;}}return;}S.prototype.setAggregation.call(this,A,o,s);};
F.prototype.getAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){return this['_'+A];}return S.prototype.getAggregation.call(this,A,o,s);};
F.prototype.destroyAggregation=function(A,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p].destroy();this[p]=null;}return this;}return S.prototype.destroyAggregation.call(this,A,s);};
return F;},true);
sap.ui.predefine('sap/m/semantic/GroupAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var G=S.extend("sap.m.semantic.GroupAction",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IGroup"]}});
return G;},true);
sap.ui.predefine('sap/m/semantic/GroupSelect',['sap/m/semantic/SemanticSelect'],function(S){"use strict";
var G=S.extend("sap.m.semantic.GroupSelect",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IGroup"]}});
return G;},true);
sap.ui.predefine('sap/m/semantic/MainAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var M=S.extend("sap.m.semantic.MainAction",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return M;},true);
sap.ui.predefine('sap/m/semantic/MasterPage',['jquery.sap.global',"sap/m/semantic/SemanticPage","sap/m/semantic/SemanticPageRenderer","sap/m/semantic/MultiSelectAction"],function(q,S,a,M){"use strict";
var b=S.extend("sap.m.semantic.MasterPage",{
metadata:{library:"sap.m",aggregations:{addAction:{type:"sap.m.semantic.AddAction",multiple:false},mainAction:{type:"sap.m.semantic.MainAction",multiple:false},positiveAction:{type:"sap.m.semantic.PositiveAction",multiple:false},negativeAction:{type:"sap.m.semantic.NegativeAction",multiple:false},multiSelectAction:{type:"sap.m.semantic.MultiSelectAction",multiple:false},forwardAction:{type:"sap.m.semantic.ForwardAction",multiple:false},editAction:{type:"sap.m.semantic.EditAction",multiple:false},saveAction:{type:"sap.m.semantic.SaveAction",multiple:false},deleteAction:{type:"sap.m.semantic.DeleteAction",multiple:false},cancelAction:{type:"sap.m.semantic.CancelAction",multiple:false},sort:{type:"sap.m.semantic.ISort",multiple:false},filter:{type:"sap.m.semantic.IFilter",multiple:false},group:{type:"sap.m.semantic.IGroup",multiple:false},messagesIndicator:{type:"sap.m.semantic.MessagesIndicator",multiple:false}}},
renderer:a.render
});
b.prototype.init=function(){S.prototype.init.call(this);this._getPage().getLandmarkInfo().setRootLabel(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SEMANTIC_MASTER_PAGE_TITLE"));};
return b;},true);
sap.ui.predefine('sap/m/semantic/MessagesIndicator',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var M=S.extend("sap.m.semantic.MessagesIndicator",{metadata:{library:"sap.m"}});
return M;},true);
sap.ui.predefine('sap/m/semantic/MultiSelectAction',['sap/m/semantic/SemanticToggleButton','sap/m/semantic/SemanticConfiguration'],function(S,a){"use strict";
var M=S.extend("sap.m.semantic.MultiSelectAction",{metadata:{library:"sap.m"}});
var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");M._PRESSED_STATE_TO_ICON_MAP={"true":"sap-icon://sys-cancel","false":"sap-icon://multi-select"};M._ACC_TOOLTIP_TO_ICON_MAP={"true":b.getText("SEMANTIC_CONTROL_MULTI_SELECT_CANCEL"),"false":b.getText("SEMANTIC_CONTROL_MULTI_SELECT")};
M.prototype._setPressed=function(p,s){var i=M._PRESSED_STATE_TO_ICON_MAP[p];var I=M._ACC_TOOLTIP_TO_ICON_MAP[p];this._getControl().setIcon(i);this._getControl().setTooltip(I);};
return M;},true);
sap.ui.predefine('sap/m/semantic/NegativeAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var N=S.extend("sap.m.semantic.NegativeAction",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return N;},true);
sap.ui.predefine('sap/m/semantic/OpenInAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var O=S.extend("sap.m.semantic.OpenInAction",{metadata:{library:"sap.m"}});
return O;},true);
sap.ui.predefine('sap/m/semantic/PositiveAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var P=S.extend("sap.m.semantic.PositiveAction",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return P;},true);
sap.ui.predefine('sap/m/semantic/PrintAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var P=S.extend("sap.m.semantic.PrintAction",{metadata:{library:"sap.m"}});
return P;},true);
sap.ui.predefine('sap/m/semantic/SaveAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SaveAction",{metadata:{library:"sap.m"}});
return a;},true);
sap.ui.predefine('sap/m/semantic/Segment',['jquery.sap.global','sap/ui/base/Metadata'],function(q,M){"use strict";var S=M.createClass("sap.m.semantic.Segment",{constructor:function(C,o,s,f){if(!o){q.sap.log.error("missing argumment: constructor expects a container reference",this);return;}C||(C=[]);this._aContent=C;this._oContainer=o;this._sContainerAggregationName=s;this._fnSortFunction=f;}});
S.prototype.getStartIndex=function(){return 0;};
S.prototype.getEndIndex=function(){return this.getStartIndex()+this._aContent.length;};
S.prototype.getContent=function(){return this._aContent;};
S.prototype.indexOfContent=function(C){return q.inArray(C,this._aContent);};
S.prototype.addContent=function(C,s){if(this._fnSortFunction){var i=this._matchSortToInsertIndex(C);if(typeof i!=='undefined'){this._insertContent(C,i,s);return C;}}var a=this.getEndIndex(),l=this._aContent.length,A="insert"+c(this._sContainerAggregationName);this._oContainer[A](C,a,s);this._aContent.splice(l,0,C);return C;};
S.prototype.insertContent=function(C,i,s){if(this._fnSortFunction){var I=this._matchSortToInsertIndex(C);if(typeof I!=='undefined'){this._insertContent(C,I,s);return C;}}return this._insertContent(C,i,s);};
S.prototype.removeContent=function(C,s){var l=q.inArray(C,this._aContent),a="remove"+c(this._sContainerAggregationName);if(l>-1){this._aContent.splice(l,1);return this._oContainer[a](C,s);}};
S.prototype.removeAllContent=function(s){var r=[],g=this._oContainer.getAggregation(this._sContainerAggregationName),a=this.getStartIndex(),e=this.getEndIndex(),A="remove"+c(this._sContainerAggregationName);for(var i=a;i<e;i++){var I=this._oContainer[A](g[i],s);if(I){r.push(I);}}this._aContent=[];return r;};
S.prototype.destroy=function(s){var r=this.removeAllContent(s);for(var i=0;i<r.length;i++){r[i].destroy(s);}};
S.prototype._insertContent=function(C,i,s){var I=Math.min(this.getStartIndex()+i,this.getEndIndex()),a="insert"+c(this._sContainerAggregationName);I=Math.max(I,0);this._oContainer[a](C,I,s);this._aContent.splice(i,0,C);return C;};
S.prototype._matchSortToInsertIndex=function(C){for(var i=0;i<this._aContent.length;i++){if(this._fnSortFunction(C,this._aContent[i])<=0){return i;}}};
function c(n){return n.charAt(0).toUpperCase()+n.substring(1);}
return S;},false);
sap.ui.predefine('sap/m/semantic/SegmentedContainer',['jquery.sap.global','sap/m/semantic/Segment','sap/ui/base/Metadata'],function(q,S,M){"use strict";var a=M.createClass("sap.m.semantic.SegmentedContainer",{constructor:function(c,C){if(!c){q.sap.log.error("missing argumment: constructor expects a container reference",this);return;}this._oContainer=c;C||(C="content");this._sContainerAggregationName=C;this._aSegments=[];}});
a.prototype.addSection=function(o){if(!o||!o.sTag){q.sap.log.error("missing argumment: section options expected",this);return;}if(o.aContent){var c=o.aContent;var l=c.length;for(var i=0;i<l;i++){this._oContainer.addAggregation(this._sContainerAggregationName,c[i]);}}var s=new S(c,this._oContainer,this._sContainerAggregationName,o.fnSortFunction);s.sTag=o.sTag;var b=this._aSegments;s.getStartIndex=function(){var d=0;var e=q.inArray(this,b);if(e>0){var p=e-1;while(p>=0){d+=b[p].getContent().length;p--;}}return d;};this._aSegments.push(s);};
a.prototype.getSection=function(t){var s;this._aSegments.forEach(function(b){if(b.sTag===t){s=b;}});return s;};
a.prototype.destroy=function(s){this._oContainer.destroy(s);this.aSegments=null;};
return a;},false);
sap.ui.predefine('sap/m/semantic/SemanticButton',['sap/m/semantic/SemanticControl','sap/m/Button','sap/m/semantic/SemanticOverflowToolbarButton'],function(S,B,a){"use strict";
var b=S.extend("sap.m.semantic.SemanticButton",{metadata:{library:"sap.m","abstract":true,properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true}},events:{press:{}}}});
b.prototype._getControl=function(){var c=this.getAggregation('_control');if(!c){var C=this._getConfiguration()&&this._getConfiguration().constraints==="IconOnly"?a:B;var n=this._createInstance(C);n.applySettings(this._getConfiguration().getSettings());if(typeof this._getConfiguration().getEventDelegates==="function"){n.addEventDelegate(this._getConfiguration().getEventDelegates(n));}this.setAggregation('_control',n,true);c=this.getAggregation('_control');}return c;};
b.prototype._createInstance=function(c){return new c({id:this.getId()+"-button",press:jQuery.proxy(this.firePress,this)});};
return b;},true);
sap.ui.predefine('sap/m/semantic/SemanticConfiguration',['jquery.sap.global','sap/ui/base/Metadata',"sap/m/OverflowToolbarLayoutData","sap/ui/core/InvisibleText","sap/ui/core/IconPool"],function(q,M,O,I,a){"use strict";var S=M.createClass("sap.m.semantic.SemanticConfiguration",{});S.prototype._PositionInPage={headerLeft:"headerLeft",headerRight:"headerRight",headerMiddle:"headerMiddle",footerLeft:"footerLeft",footerRight_IconOnly:"footerRight_IconOnly",footerRight_TextOnly:"footerRight_TextOnly",shareMenu:"shareMenu"};S._PageMode={display:"display",edit:"edit",multimode:"multimode"};
S.isKnownSemanticType=function(t){return S.getConfiguration(t)!=undefined;};
S.getConfiguration=function(t){return S._oTypeConfigs[t];};
S.getSettings=function(t){return S._oTypeConfigs[t].getSettings();};
S.getPositionInPage=function(t){return S._oTypeConfigs[t].position;};
S.getSequenceOrderIndex=function(t){return S._oTypeConfigs[t].order;};
S.getAriaId=function(t){return S._oTypeConfigs[t].getSettings().ariaLabelledBy;};
S._oTypeConfigs=(function(){var t={},b=sap.ui.getCore().getLibraryResourceBundle("sap.m");t["sap.m.semantic.MultiSelectAction"]={position:S.prototype._PositionInPage.headerRight,getSettings:function(){return{icon:a.getIconURI("multi-select"),tooltip:b.getText("SEMANTIC_CONTROL_MULTI_SELECT")};}};t["sap.m.semantic.MainAction"]={position:S.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{type:sap.m.ButtonType.Emphasized,layoutData:new O({moveToOverflow:false,stayInOverflow:false})};},order:0};t["sap.m.semantic.EditAction"]={position:S.prototype._PositionInPage.footerRight_TextOnly,triggers:S._PageMode.edit,getSettings:function(){return{text:b.getText("SEMANTIC_CONTROL_EDIT"),type:sap.m.ButtonType.Emphasized,layoutData:new O({moveToOverflow:false,stayInOverflow:false})};},order:1};t["sap.m.semantic.SaveAction"]={position:S.prototype._PositionInPage.footerRight_TextOnly,triggers:S._PageMode.display,getSettings:function(){return{text:b.getText("SEMANTIC_CONTROL_SAVE"),type:sap.m.ButtonType.Emphasized,layoutData:new O({moveToOverflow:false,stayInOverflow:false})};},order:3};t["sap.m.semantic.DeleteAction"]={position:S.prototype._PositionInPage.footerRight_TextOnly,triggers:S._PageMode.display,getSettings:function(){return{text:b.getText("SEMANTIC_CONTROL_DELETE"),layoutData:new O({moveToOverflow:false,stayInOverflow:false})};},order:4};t["sap.m.semantic.PositiveAction"]={position:S.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{type:sap.m.ButtonType.Accept,layoutData:new O({moveToOverflow:false,stayInOverflow:false})};},order:5};t["sap.m.semantic.NegativeAction"]={position:S.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{type:sap.m.ButtonType.Reject,layoutData:new O({moveToOverflow:false,stayInOverflow:false})};},order:6};t["sap.m.semantic.CancelAction"]={position:S.prototype._PositionInPage.footerRight_TextOnly,triggers:S._PageMode.display,getSettings:function(){return{text:b.getText("SEMANTIC_CONTROL_CANCEL")};},order:7};t["sap.m.semantic.ForwardAction"]={position:S.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{text:b.getText("SEMANTIC_CONTROL_FORWARD"),layoutData:new O({moveToOverflow:true,stayInOverflow:false})};},order:8};t["sap.m.semantic.OpenInAction"]={position:S.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{text:b.getText("SEMANTIC_CONTROL_OPEN_IN")};},order:9};t["sap.m.semantic.AddAction"]={position:S.prototype._PositionInPage.footerRight_IconOnly,triggers:S._PageMode.edit,getSettings:function(){return{icon:a.getIconURI("add"),text:b.getText("SEMANTIC_CONTROL_ADD"),tooltip:b.getText("SEMANTIC_CONTROL_ADD")};},order:0,constraints:"IconOnly"};t["sap.m.semantic.FavoriteAction"]={position:S.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:a.getIconURI("favorite"),text:b.getText("SEMANTIC_CONTROL_FAVORITE"),tooltip:b.getText("SEMANTIC_CONTROL_FAVORITE")};},order:1,constraints:"IconOnly"};t["sap.m.semantic.FlagAction"]={position:S.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:a.getIconURI("flag"),text:b.getText("SEMANTIC_CONTROL_FLAG"),tooltip:b.getText("SEMANTIC_CONTROL_FLAG")};},order:2,constraints:"IconOnly"};t["sap.m.semantic.ISort"]={position:S.prototype._PositionInPage.footerRight_IconOnly,order:3};t["sap.m.semantic.IFilter"]={position:S.prototype._PositionInPage.footerRight_IconOnly,order:4};t["sap.m.semantic.IGroup"]={position:S.prototype._PositionInPage.footerRight_IconOnly,order:5};t["sap.m.semantic.SortAction"]={position:S.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:a.getIconURI("sort"),text:b.getText("SEMANTIC_CONTROL_SORT"),tooltip:b.getText("SEMANTIC_CONTROL_SORT"),layoutData:new O({moveToOverflow:true,stayInOverflow:false})};},constraints:"IconOnly"};t["sap.m.semantic.SortSelect"]={position:S.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:a.getIconURI("sort"),type:"IconOnly",autoAdjustWidth:true,tooltip:b.getText("SEMANTIC_CONTROL_SORT"),layoutData:new O({moveToOverflow:true,stayInOverflow:false})};},getEventDelegates:function(c){return{onAfterRendering:function(){this.$().attr({"aria-haspopup":true,"role":""});}.bind(c)};},constraints:"IconOnly"};t["sap.m.semantic.FilterAction"]={position:S.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:a.getIconURI("filter"),text:b.getText("SEMANTIC_CONTROL_FILTER"),tooltip:b.getText("SEMANTIC_CONTROL_FILTER"),layoutData:new O({moveToOverflow:true,stayInOverflow:false})};},constraints:"IconOnly"};t["sap.m.semantic.FilterSelect"]={position:S.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:a.getIconURI("filter"),type:"IconOnly",autoAdjustWidth:true,tooltip:b.getText("SEMANTIC_CONTROL_FILTER"),layoutData:new O({moveToOverflow:true,stayInOverflow:false})};},constraints:"IconOnly"};t["sap.m.semantic.GroupAction"]={position:S.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:a.getIconURI("group-2"),text:b.getText("SEMANTIC_CONTROL_GROUP"),tooltip:b.getText("SEMANTIC_CONTROL_GROUP"),layoutData:new O({moveToOverflow:true,stayInOverflow:false})};},constraints:"IconOnly"};t["sap.m.semantic.GroupSelect"]={position:S.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:a.getIconURI("group-2"),type:"IconOnly",autoAdjustWidth:true,layoutData:new O({moveToOverflow:true,stayInOverflow:false})};},getEventDelegates:function(c){return{onAfterRendering:function(){this.$().attr({"aria-haspopup":true,"role":""});}.bind(c)};},constraints:"IconOnly"};t["saveAsTileAction"]={position:S.prototype._PositionInPage.shareMenu,order:0,constraints:"IconOnly"};t["pagingAction"]={position:S.prototype._PositionInPage.headerRight};t["sap.m.semantic.DiscussInJamAction"]={position:S.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:a.getIconURI("discussion-2"),text:b.getText("SEMANTIC_CONTROL_DISCUSS_IN_JAM")};},order:1,constraints:"IconOnly"};t["sap.m.semantic.ShareInJamAction"]={position:S.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:a.getIconURI("share-2"),text:b.getText("SEMANTIC_CONTROL_SHARE_IN_JAM")};},order:2,constraints:"IconOnly"};t["sap.m.semantic.SendMessageAction"]={position:S.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:a.getIconURI("discussion"),text:b.getText("SEMANTIC_CONTROL_SEND_MESSAGE")};},order:3,constraints:"IconOnly"};t["sap.m.semantic.SendEmailAction"]={position:S.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:a.getIconURI("email"),text:b.getText("SEMANTIC_CONTROL_SEND_EMAIL")};},order:4,constraints:"IconOnly"};t["sap.m.semantic.PrintAction"]={position:S.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:a.getIconURI("print"),text:b.getText("SEMANTIC_CONTROL_PRINT")};},order:5,constraints:"IconOnly"};t["sap.m.semantic.MessagesIndicator"]={position:S.prototype._PositionInPage.footerLeft,getSettings:function(){return{icon:a.getIconURI("message-popup"),text:{path:"message>/",formatter:function(m){return m.length||0;}},tooltip:b.getText("SEMANTIC_CONTROL_MESSAGES_INDICATOR"),type:sap.m.ButtonType.Emphasized,visible:{path:"message>/",formatter:function(m){return m&&m.length>0;}},models:{message:sap.ui.getCore().getMessageManager().getMessageModel()},layoutData:new O({moveToOverflow:false,stayInOverflow:false})};}};t["draftIndicator"]={position:S.prototype._PositionInPage.footerLeft,getSettings:function(){return{layoutData:new sap.m.OverflowToolbarLayoutData({shrinkable:false})};},order:1};return t;})();return S;},false);
sap.ui.predefine('sap/m/semantic/SemanticControl',['jquery.sap.global',"sap/m/semantic/SemanticConfiguration","sap/ui/base/ManagedObject","sap/ui/core/Element"],function(q,S,M,E){"use strict";
var a=E.extend("sap.m.semantic.SemanticControl",{metadata:{library:"sap.m","abstract":true,properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true}},aggregations:{_control:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}}}});
a.prototype.setProperty=function(k,v,s){M.prototype.setProperty.call(this,k,v,true);this._applyProperty(k,v,s);return this;};
a.prototype.updateAggregation=function(n){this._getControl().updateAggregation(n);};
a.prototype.refreshAggregation=function(n){this._getControl().refreshAggregation(n);};
a.prototype.setAggregation=function(A,o,s){if(A==='_control'){return M.prototype.setAggregation.call(this,A,o,s);}return this._getControl().setAggregation(A,o,s);};
a.prototype.getAggregation=function(A,d){if(A==='_control'){return M.prototype.getAggregation.call(this,A,d);}return this._getControl().getAggregation(A,d);};
a.prototype.indexOfAggregation=function(A,o){return this._getControl().indexOfAggregation(A,o);};
a.prototype.insertAggregation=function(A,o,i,s){return this._getControl().insertAggregation(A,o,i,s);};
a.prototype.addAggregation=function(A,o,s){return this._getControl().addAggregation(A,o,s);};
a.prototype.removeAggregation=function(A,o,s){return this._getControl().removeAggregation(A,o,s);};
a.prototype.removeAllAggregation=function(A,s){return this._getControl().removeAllAggregation(A,s);};
a.prototype.destroyAggregation=function(A,s){return this._getControl().destroyAggregation(A,s);};
a.prototype.bindAggregation=function(n,b){return this._getControl().bindAggregation(n,b);};
a.prototype.unbindAggregation=function(n,s){return this._getControl().unbindAggregation(n,s);};
a.prototype.clone=function(i,l){var c=E.prototype.clone.apply(this,arguments);var p=this._getControl().clone(i,l);c.setAggregation('_control',p);return c;};
a.prototype.destroy=function(){var r=E.prototype.destroy.apply(this,arguments);if(this.getAggregation("_control")){this.getAggregation("_control").destroy();}return r;};
a.prototype.getPopupAnchorDomRef=function(){return this._getControl().getDomRef();};
a.prototype.getDomRef=function(s){return this._getControl().getDomRef(s);};
a.prototype.addEventDelegate=function(d,t){q.each(d,function(e,c){if(typeof c==='function'){var p=function(o){o.srcControl=this;c.call(t,o);}.bind(this);d[e]=p;}}.bind(this));this._getControl().addEventDelegate(d,t);return this;};
a.prototype.removeEventDelegate=function(d){this._getControl().removeEventDelegate(d);return this;};
a.prototype._getConfiguration=function(){return S.getConfiguration(this.getMetadata().getName());};
a.prototype._onPageStateChanged=function(e){this._updateState(e.sId);};
a.prototype._updateState=function(s){if(this._getConfiguration()&&this._getControl()){var o=this._getConfiguration().states[s];if(o){this._getControl().applySettings(o);}}};
a.prototype._applyProperty=function(k,v,s){var b="set"+this._capitalize(k);this._getControl()[b](v,s);};
a.prototype._capitalize=function(n){return n.charAt(0).toUpperCase()+n.slice(1);};
return a;},false);
sap.ui.predefine('sap/m/semantic/SemanticOverflowToolbarButton',['sap/m/OverflowToolbarButton','sap/m/ButtonRenderer'],function(O,B){"use strict";
var S=O.extend("sap.m.semantic.SemanticOverflowToolbarButton",{renderer:B.render});
S.prototype._getTooltip=function(){var t=O.prototype._getTooltip.call(this);if(!t&&!this._bInOverflow&&this.getText()){t=this.getText();}return t;};
return S;},false);
sap.ui.predefine('sap/m/semantic/SemanticPage.designtime',[],function(){"use strict";return{aggregations:{content:{domRef:":sap-domref > .sapMPage > section"}}};},false);
sap.ui.predefine('sap/m/semantic/SemanticPage',['jquery.sap.global','sap/m/semantic/SegmentedContainer','sap/m/semantic/SemanticConfiguration','sap/m/Button','sap/m/Title','sap/m/ActionSheet','sap/m/Page','sap/m/OverflowToolbar','sap/m/OverflowToolbarButton','sap/m/OverflowToolbarLayoutData','sap/m/ToolbarSpacer','sap/m/Bar','sap/ui/core/CustomData','sap/ui/base/ManagedObject','sap/ui/core/AccessibleLandmarkRole','sap/m/PageAccessibleLandmarkInfo'],function(q,S,a,B,T,A,P,O,b,c,d,e,C,M,f,g){"use strict";
var h=sap.ui.core.Control.extend("sap.m.semantic.SemanticPage",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:sap.ui.core.TitleLevel.Auto},showNavButton:{type:"boolean",group:"Appearance",defaultValue:false},showSubHeader:{type:"boolean",group:"Appearance",defaultValue:true},enableScrolling:{type:"boolean",group:"Behavior",defaultValue:true},showFooter:{type:"boolean",group:"Appearance",defaultValue:true},floatingFooter:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"content",aggregations:{subHeader:{type:"sap.m.IBar",multiple:false},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},customHeaderContent:{type:"sap.m.Button",multiple:true,singularName:"customHeaderContent"},customFooterContent:{type:"sap.m.Button",multiple:true,singularName:"customFooterContent"},landmarkInfo:{type:"sap.m.PageAccessibleLandmarkInfo",multiple:false},_page:{type:"sap.m.Page",multiple:false,visibility:"hidden"}},events:{navButtonPress:{}},designTime:true}});
h.prototype.init=function(){this._currentMode=a._PageMode.display;this._getPage().setCustomHeader(this._getInternalHeader());this._getPage().setFooter(new O(this.getId()+"-footer"));this._getPage().setLandmarkInfo(new g());};
h.prototype.exit=function(){if(this._oInternalHeader){this._oInternalHeader.destroy();this._oInternalHeader=null;}if(this._oWrappedFooter){this._oWrappedFooter.destroy();this._oWrappedFooter=null;}if(this._oTitle){this._oTitle.destroy();this._oTitle=null;}if(this._oNavButton){this._oNavButton.destroy();this._oNavButton=null;}this._oPositionsMap=null;};
h.prototype.setSubHeader=function(o,j){this._getPage().setSubHeader(o,j);return this;};
h.prototype.getSubHeader=function(){return this._getPage().getSubHeader();};
h.prototype.destroySubHeader=function(j){this._getPage().destroySubHeader(j);return this;};
h.prototype.getShowSubHeader=function(){return this._getPage().getShowSubHeader();};
h.prototype.setShowSubHeader=function(j,k){this._getPage().setShowSubHeader(j,k);this.setProperty("showSubHeader",j,true);return this;};
h.prototype.getShowFooter=function(){return this._getPage().getShowFooter();};
h.prototype.setShowFooter=function(j,k){this._getPage().setShowFooter(j,k);this.setProperty("showFooter",j,true);return this;};
h.prototype.setFloatingFooter=function(F,j){this._getPage().setFloatingFooter(F,j);this.setProperty("floatingFooter",F,true);return this;};
h.prototype.getContent=function(){return this._getPage().getContent();};
h.prototype.addContent=function(o,j){this._getPage().addContent(o,j);return this;};
h.prototype.indexOfContent=function(o){return this._getPage().indexOfContent(o);};
h.prototype.insertContent=function(o,I,j){this._getPage().insertContent(o,I,j);return this;};
h.prototype.removeContent=function(o,j){return this._getPage().removeContent(o,j);};
h.prototype.removeAllContent=function(j){return this._getPage().removeAllContent(j);};
h.prototype.destroyContent=function(j){this._getPage().destroyContent(j);return this;};
h.prototype.setTitle=function(t){var o=this._getTitle();if(o){o.setText(t);if(!o.getParent()){this._getInternalHeader().addContentMiddle(o);}}this.setProperty("title",t,true);return this;};
h.prototype.setTitleLevel=function(t){this.setProperty("titleLevel",t,true);this._getTitle().setLevel(t);return this;};
h.prototype.setShowNavButton=function(j){var o=this._getNavButton();if(o){o.setVisible(j);if(!o.getParent()){this._getInternalHeader().addContentLeft(o);}}this.setProperty("showNavButton",j,true);return this;};
h.prototype.setEnableScrolling=function(E){this._getPage().setEnableScrolling(E);this.setProperty("enableScrolling",E,true);return this;};
h.prototype.setLandmarkInfo=function(l){return this._getPage().setLandmarkInfo(l);};
h.prototype.getLandmarkInfo=function(){return this._getPage().getLandmarkInfo();};
h.prototype.destroyLandmarkInfo=function(){return this._getPage().destroyLandmarkInfo();};
h.prototype.getCustomFooterContent=function(){return this._getSegmentedFooter().getSection("customRight").getContent();};
h.prototype.addCustomFooterContent=function(o,j){this._getSegmentedFooter().getSection("customRight").addContent(o,j);return this;};
h.prototype.indexOfCustomFooterContent=function(o){return this._getSegmentedFooter().getSection("customRight").indexOfContent(o);};
h.prototype.insertCustomFooterContent=function(o,I,j){this._getSegmentedFooter().getSection("customRight").insertContent(o,I,j);return this;};
h.prototype.removeCustomFooterContent=function(o,j){return this._getSegmentedFooter().getSection("customRight").removeContent(o,j);};
h.prototype.removeAllCustomFooterContent=function(j){return this._getSegmentedFooter().getSection("customRight").removeAllContent(j);};
h.prototype.destroyCustomFooterContent=function(j){var k=this.getCustomFooterContent();if(!k){return this;}if(j){this.iSuppressInvalidate++;}this._getSegmentedFooter().getSection("customRight").destroy(j);if(!this.isInvalidateSuppressed()){this.invalidate();}if(j){this.iSuppressInvalidate--;}return this;};
h.prototype.getCustomHeaderContent=function(){return this._getSegmentedHeader().getSection("customRight").getContent();};
h.prototype.addCustomHeaderContent=function(o,j){this._getSegmentedHeader().getSection("customRight").addContent(o,j);return this;};
h.prototype.indexOfCustomHeaderContent=function(o){return this._getSegmentedHeader().getSection("customRight").indexOfContent(o);};
h.prototype.insertCustomHeaderContent=function(o,I,j){this._getSegmentedHeader().getSection("customRight").insertContent(o,I,j);return this;};
h.prototype.removeCustomHeaderContent=function(o,j){return this._getSegmentedHeader().getSection("customRight").removeContent(o,j);};
h.prototype.removeAllCustomHeaderContent=function(j){return this._getSegmentedHeader().getSection("customRight").removeAllContent(j);};
h.prototype.destroyCustomHeaderContent=function(j){var k=this.getCustomHeaderContent();if(!k){return this;}if(j){this.iSuppressInvalidate++;}this._getSegmentedHeader().getSection("customRight").destroy(j);if(!this.isInvalidateSuppressed()){this.invalidate();}if(j){this.iSuppressInvalidate--;}return this;};
h.prototype.setAggregation=function(j,o,k){var l=this.mAggregations[j];if(l===o){return this;}o=this.validateAggregation(j,o,false);var t=this.getMetadata().getManagedAggregation(j).type;if(a.isKnownSemanticType(t)){if(l){this._stopMonitor(l);this._removeFromInnerAggregation(l._getControl(),a.getPositionInPage(t),k);}if(o){this._initMonitor(o);this._addToInnerAggregation(o._getControl(),a.getPositionInPage(t),a.getSequenceOrderIndex(t),k);}return M.prototype.setAggregation.call(this,j,o,true);}return M.prototype.setAggregation.call(this,j,o,k);};
h.prototype.destroyAggregation=function(j,k){var o=this.getMetadata().getAggregations()[j];if(o&&a.isKnownSemanticType(o.type)){var l=M.prototype.getAggregation.call(this,j);if(l){this._stopMonitor(l);if(!l._getControl().bIsDestroyed){this._removeFromInnerAggregation(l._getControl(),a.getPositionInPage(o.type),k);}}}return M.prototype.destroyAggregation.call(this,j,l,k);};
h.prototype._getTitle=function(){if(!this._oTitle){this._oTitle=new T(this.getId()+"-title",{text:this.getTitle()});}return this._oTitle;};
h.prototype._getNavButton=function(){if(!this._oNavButton){this._oNavButton=new B(this.getId()+"-navButton",{type:sap.m.ButtonType.Up,tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("PAGE_NAVBUTTON_TEXT"),press:q.proxy(this.fireNavButtonPress,this)});}return this._oNavButton;};
h.prototype._initMonitor=function(o){var j=o._getConfiguration();if(j.triggers){o.attachEvent("press",this._updateCurrentMode,this);}var k=j.states,t=this;if(k){q.each(a._PageMode,function(l,v){if(k[l]){t.attachEvent(l,o._onPageStateChanged,o);}});}};
h.prototype._stopMonitor=function(o){o.detachEvent("press",this._updateCurrentMode,this);var j=o._getConfiguration();var k=j.states,t=this;if(k){q.each(a._PageMode,function(l,v){if(k[l]){t.detachEvent(l,o._onPageStateChanged,o);}});}};
h.prototype._updateCurrentMode=function(E){var o=E.oSource._getConfiguration();if(typeof o.triggers==='string'){this._currentMode=o.triggers;}else{var l=o.triggers.length;if(l&&l>0){for(var I=0;I<l;I++){var t=o.triggers[I];if(t&&(t.inState===this._currentMode)){this._currentMode=t.triggers;break;}}}}this.fireEvent(this._currentMode);};
h.prototype._removeFromInnerAggregation=function(o,p,j){var k=this._getSemanticPositionsMap()[p];if(k&&k.oContainer&&k.sAggregation){k.oContainer["remove"+i(k.sAggregation)](o,j);}};
h.prototype._addToInnerAggregation=function(o,p,j,k){if(!o||!p){return;}var l=this._getSemanticPositionsMap()[p];if(!l||!l.oContainer||!l.sAggregation){return;}if(typeof j!=='undefined'){o.addCustomData(new C({key:"sortIndex",value:j}));}return l.oContainer["add"+i(l.sAggregation)](o,k);};
h.prototype._getSemanticPositionsMap=function(o,j){if(!this._oPositionsMap){this._oPositionsMap={};this._oPositionsMap[a.prototype._PositionInPage.headerLeft]={oContainer:this._getInternalHeader(),sAggregation:"contentLeft"};this._oPositionsMap[a.prototype._PositionInPage.headerRight]={oContainer:this._getSegmentedHeader().getSection("semanticRight"),sAggregation:"content"};this._oPositionsMap[a.prototype._PositionInPage.headerMiddle]={oContainer:this._getInternalHeader(),sAggregation:"contentMiddle"};this._oPositionsMap[a.prototype._PositionInPage.footerLeft]={oContainer:this._getSegmentedFooter().getSection("semanticLeft"),sAggregation:"content"};this._oPositionsMap[a.prototype._PositionInPage.footerRight_IconOnly]={oContainer:this._getSegmentedFooter().getSection("semanticRight_IconOnly"),sAggregation:"content"};this._oPositionsMap[a.prototype._PositionInPage.footerRight_TextOnly]={oContainer:this._getSegmentedFooter().getSection("semanticRight_TextOnly"),sAggregation:"content"};}return this._oPositionsMap;};
h.prototype._getPage=function(){var p=this.getAggregation("_page");if(!p){this.setAggregation("_page",new P(this.getId()+"-page"));p=this.getAggregation("_page");}return p;};
h.prototype._getInternalHeader=function(){if(!this._oInternalHeader){this._oInternalHeader=new e(this.getId()+"-intHeader");}return this._oInternalHeader;};
h.prototype._getAnyHeader=function(){return this._getInternalHeader();};
h.prototype._getSegmentedHeader=function(){if(!this._oWrappedHeader){var H=this._getInternalHeader();if(!H){q.sap.log.error("missing page header",this);return null;}this._oWrappedHeader=new S(H,"contentRight");this._oWrappedHeader.addSection({sTag:"customRight"});this._oWrappedHeader.addSection({sTag:"semanticRight"});}return this._oWrappedHeader;};
h.prototype._getSegmentedFooter=function(){if(!this._oWrappedFooter){var F=this._getPage().getFooter();if(!F){q.sap.log.error("missing page footer",this);return null;}this._oWrappedFooter=new S(F);this._oWrappedFooter.addSection({sTag:"semanticLeft"});this._oWrappedFooter.addSection({sTag:"spacer",aContent:[new d()]});this._oWrappedFooter.addSection({sTag:"semanticRight_TextOnly",fnSortFunction:s});this._oWrappedFooter.addSection({sTag:"customRight"});this._oWrappedFooter.addSection({sTag:"semanticRight_IconOnly",fnSortFunction:s});}return this._oWrappedFooter;};
function i(n){return n.substring(0,1).toUpperCase()+n.substring(1);}
function s(o,j){var k=o.data("sortIndex");var l=j.data("sortIndex");if((typeof k==='undefined')||(typeof l==='undefined')){q.sap.log.warning("sortIndex missing",this);return null;}return(k-l);}
return h;},false);
sap.ui.predefine("sap/m/semantic/SemanticPageRenderer",[],function(){"use strict";var S={};
S.render=function(r,o){r.write("<div");r.writeControlData(o);r.addClass("sapMSemanticPage");r.writeClasses();r.write(">");r.renderControl(o._getPage());r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/m/semantic/SemanticSelect',['sap/m/semantic/SemanticControl','sap/m/Select'],function(S,a){"use strict";
var b=S.extend("sap.m.semantic.SemanticSelect",{metadata:{library:"sap.m","abstract":true,properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},selectedKey:{type:"string",group:"Data",defaultValue:""}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false}},events:{change:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}}}});
b.prototype.setProperty=function(p,v,s){if(!this.getMetadata().getProperties()[p]&&!b.getMetadata().getProperties()[p]&&!S.getMetadata().getProperties()[p]){jQuery.sap.log.error("unknown property: "+p,this);return this;}S.prototype.setProperty.call(this,p,v,s);};
b.prototype.getSelectedItem=function(){return this._getControl().getSelectedItem();};
b.prototype.setSelectedItem=function(i){this._getControl().setSelectedItem(i);this.setSelectedKey(this._getControl().getSelectedKey());return this;};
b.prototype.getItemAt=function(i){return this._getControl().getItemAt(i);};
b.prototype._getControl=function(){var c=this.getAggregation('_control');if(!c){this.setAggregation('_control',new a({id:this.getId()+"-select",change:this._onInnerSelectChange.bind(this)}),true);c=this.getAggregation('_control');c.applySettings(this._getConfiguration().getSettings());if(typeof this._getConfiguration().getEventDelegates==="function"){c.addEventDelegate(this._getConfiguration().getEventDelegates(c));}}return c;};
b.prototype._onInnerSelectChange=function(e){var s=e.getSource().getSelectedItem();this.setSelectedItem(s);this.fireChange({selectedItem:s});};
return b;},true);
sap.ui.predefine('sap/m/semantic/SemanticToggleButton',['sap/m/semantic/SemanticButton','sap/m/semantic/SemanticControl','sap/m/ButtonType','sap/ui/base/ManagedObject'],function(S,a,B,M){"use strict";
var b=S.extend("sap.m.semantic.SemanticToggleButton",{metadata:{library:"sap.m",properties:{pressed:{type:"boolean",group:"Data",defaultValue:false}}}});
b.prototype._onTap=function(e){e.setMarked();if(this.getEnabled()){this.setPressed(!this.getPressed());this.firePress({pressed:this.getPressed()});}};
b.prototype._onKeydown=function(e){if(e.which===jQuery.sap.KeyCodes.SPACE||e.which===jQuery.sap.KeyCodes.ENTER){this._onTap(e);}};
b.prototype._applyProperty=function(p,v,s){if(p==='pressed'){this._setPressed(v,s);}else{S.prototype._applyProperty.apply(this,arguments);}};
b.prototype._setPressed=function(p,s){var o=p?B.Emphasized:B.Default;this._getControl().setType(o,s);};
b.prototype._createInstance=function(c){var i=new c({id:this.getId()+"-toggleButton"});i.addEventDelegate({ontap:this._onTap,onkeydown:this._onKeydown},this);return i;};
return b;},true);
sap.ui.predefine('sap/m/semantic/SendEmailAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SendEmailAction",{metadata:{library:"sap.m"}});
return a;},true);
sap.ui.predefine('sap/m/semantic/SendMessageAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SendMessageAction",{metadata:{library:"sap.m"}});
return a;},true);
sap.ui.predefine('sap/m/semantic/ShareInJamAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.ShareInJamAction",{metadata:{library:"sap.m"}});
return a;},true);
sap.ui.predefine('sap/m/semantic/ShareMenu',['jquery.sap.global','sap/ui/base/Metadata','sap/m/Button','sap/m/OverflowToolbarLayoutData','sap/ui/core/IconPool','sap/m/OverflowToolbarButton'],function(q,M,B,O,I,a){"use strict";var S=M.createClass("sap.m.semantic.ShareMenu",{constructor:function(A){if(!A){q.sap.log.error("missing argumment: constructor expects an actionsheet reference",this);return;}this._oActionSheet=A;this._setMode(S._Mode.initial);}});S._Mode={initial:"initial",button:"button",actionSheet:"actionSheet"};
S.prototype.getBaseButton=function(){return this._oBaseButton;};
S.prototype.getAggregation=function(n){if(n==="content"){return this.getContent();}};
S.prototype.addAggregation=function(n,b,s){if(n==="content"){return this.addContent(b,s);}};
S.prototype.insertAggregation=function(n,b,i,s){if(n==="content"){return this.insertContent(b,i,s);}};
S.prototype.indexOfAggregation=function(n,b){if(n==="content"){return this.indexOfContent(b);}};
S.prototype.removeAggregation=function(n,b,s){if(n==="content"){return this.removeContent(b,s);}};
S.prototype.removeAllAggregation=function(n,s){if(n==="content"){return this.removeAllContent(s);}};
S.prototype.getContent=function(){if(this._getMode()===S._Mode.initial){return[];}else if(this._getMode()===S._Mode.button){return[this._oBaseButton];}else{return this._oActionSheet.getAggregation("buttons");}};
S.prototype.addContent=function(b,s){if(this._getMode()===S._Mode.initial){this._setMode(S._Mode.button,s,b);return this;}if(this._getMode()===S._Mode.button){this._setMode(S._Mode.actionSheet,s);}this._preProcessOverflowToolbarButton(b);this._oActionSheet.addButton(b,s);return this;};
S.prototype.insertContent=function(b,i,s){if(this._getMode()===S._Mode.initial){this._setMode(S._Mode.button,s,b);return this;}if(this._getMode()===S._Mode.button){this._setMode(S._Mode.actionSheet,s);}this._preProcessOverflowToolbarButton(b);this._oActionSheet.insertButton(b,i,s);return this;};
S.prototype.indexOfContent=function(b){if((this._getMode()===S._Mode.button)&&(b===this._oBaseButton)){return 0;}if(this._getMode()===S._Mode.actionSheet){return this._oActionSheet.indexOfAggregation("buttons",b);}return-1;};
S.prototype.removeContent=function(b,s){var r;if(this._getMode()===S._Mode.actionSheet){r=this._oActionSheet.removeButton(b,s);this._postProcessOverflowToolbarButton(b);if(r){if(this._oActionSheet.getAggregation("buttons").length===1){this._setMode(S._Mode.button,s);}}return r;}if(this._getMode()===S._Mode.button){var l=this._oBaseButton;this._setMode(S._Mode.initial,s);return l;}return r;};
S.prototype.removeAllContent=function(s){var r;if(this._getMode()===S._Mode.actionSheet){r=this._oActionSheet.removeAllButtons(s);r.forEach(this._postProcessOverflowToolbarButton,this);}else if(this._getMode()===S._Mode.button){r=[this._oBaseButton];}this._setMode(S._Mode.initial,s);return r;};
S.prototype.destroy=function(s){this._oActionSheet.destroy(s);if(this._oShareMenuBtn){this._oShareMenuBtn.destroy(s);this._oShareMenuBtn=null;}};
S.prototype._setBaseButton=function(b,s){if(this._oBaseButton===b){return this;}var o=this._oBaseButton;this._oBaseButton=b;if(o){var p=o.getParent(),P=o.sParentAggregationName;if(p){p.removeAggregation(P,o,s);p.addAggregation(P,this._oBaseButton,s);}}return this;};
S.prototype._getMode=function(){return this._mode;};
S.prototype._setMode=function(m,s,b){if(!S._Mode[m]){q.sap.log.error("unknown shareMenu mode "+m,this);return this;}if(this._mode===m){return this;}if(S._Mode.initial===m){this._setBaseButton(this._getShareMenuButton().applySettings({visible:false}));this._mode=S._Mode.initial;return this;}if(m===S._Mode.button){if(this._mode===S._Mode.initial){this._setBaseButton(b);}else if(this._mode===S._Mode.actionSheet){var l=this._oActionSheet.getAggregation("buttons")[0];this._oActionSheet.removeButton(l,s);this._postProcessOverflowToolbarButton(l);this._setBaseButton(l);}this._mode=S._Mode.button;return this;}if(m===S._Mode.actionSheet){var o=this._oBaseButton;this._setBaseButton(this._getShareMenuButton().applySettings({visible:true}));if(o){this._preProcessOverflowToolbarButton(o);this._oActionSheet.addButton(o,s);}this._mode=S._Mode.actionSheet;}return this;};
S.prototype._getShareMenuButton=function(){if(!this._oShareMenuBtn){var t=this;this._oShareMenuBtn=new sap.m.Button(this._oActionSheet.getParent().getId()+"-shareButton",{icon:I.getIconURI("action"),tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SEMANTIC_CONTROL_ACTION_SHARE"),layoutData:new O({moveToOverflow:false,stayInOverflow:false}),press:function(){t._oActionSheet.openBy(t._oShareMenuBtn);}});this._oShareMenuBtn.addEventDelegate({onAfterRendering:function(){t._oShareMenuBtn.$().attr("aria-haspopup",true);}});}return this._oShareMenuBtn;};
S.prototype._preProcessOverflowToolbarButton=function(b){if(b instanceof a){b._bInOverflow=true;}};
S.prototype._postProcessOverflowToolbarButton=function(b){if(b instanceof a){delete b._bInOverflow;}};
return S;},false);
sap.ui.predefine('sap/m/semantic/ShareMenuPage.designtime',[],function(){"use strict";return{aggregations:{content:{domRef:":sap-domref > .sapMPage > section"}}};},false);
sap.ui.predefine('sap/m/semantic/ShareMenuPage',['jquery.sap.global',"sap/m/semantic/SemanticPage","sap/m/semantic/SemanticConfiguration","sap/m/semantic/SemanticPageRenderer","sap/m/semantic/SegmentedContainer","sap/m/semantic/ShareMenu","sap/m/ActionSheet","sap/m/Button"],function(q,S,a,b,c,d,A,B){"use strict";
var e=S.extend("sap.m.semantic.ShareMenuPage",{
metadata:{library:"sap.m",aggregations:{customShareMenuContent:{type:"sap.m.Button",multiple:true,singularName:"customShareMenuContent"},_actionSheet:{type:"sap.m.ActionSheet",multiple:false,visibility:"hidden"}},designTime:true},
renderer:b.render
});
e.prototype._getSemanticPositionsMap=function(C,o){if(!this._oPositionsMap){this._oPositionsMap=S.prototype._getSemanticPositionsMap.apply(this,arguments);this._oPositionsMap[a.prototype._PositionInPage.shareMenu]={oContainer:this._getSegmentedShareMenu().getSection("semantic"),sAggregation:"content"};}return this._oPositionsMap;};
e.prototype.exit=function(){S.prototype.exit.apply(this,arguments);if(this._oSegmentedShareMenu){this._oSegmentedShareMenu.destroy();this._oSegmentedShareMenu=null;}};
e.prototype.getCustomShareMenuContent=function(){return this._getSegmentedShareMenu().getSection("custom").getContent();};
e.prototype.addCustomShareMenuContent=function(o,s){this._getSegmentedShareMenu().getSection("custom").addContent(o,s);return this;};
e.prototype.indexOfCustomShareMenuContent=function(o){return this._getSegmentedShareMenu().getSection("custom").indexOfContent(o);};
e.prototype.insertCustomShareMenuContent=function(o,i,s){this._getSegmentedShareMenu().getSection("custom").insertContent(o,i,s);return this;};
e.prototype.removeCustomShareMenuContent=function(o,s){return this._getSegmentedShareMenu().getSection("custom").removeContent(o,s);};
e.prototype.removeAllCustomShareMenuContent=function(s){return this._getSegmentedShareMenu().getSection("custom").removeAllContent(s);};
e.prototype.destroyCustomShareMenuContent=function(s){var C=this.getCustomShareMenuContent();if(!C){return this;}if(s){this.iSuppressInvalidate++;}this._getSegmentedShareMenu().getSection("custom").destroy();if(!this.isInvalidateSuppressed()){this.invalidate();}if(s){this.iSuppressInvalidate--;}return this;};
e.prototype._getActionSheet=function(){var o=this.getAggregation("_actionSheet");if(!o){this.setAggregation("_actionSheet",new A({placement:sap.m.PlacementType.Top}),true);o=this.getAggregation("_actionSheet");}return o;};
e.prototype._getSegmentedShareMenu=function(){if(!this._oSegmentedShareMenu){var s=new d(this._getActionSheet());var o=s.getBaseButton();if(s&&o){this._oSegmentedShareMenu=new c(s);this._oSegmentedShareMenu.addSection({sTag:"custom"});this._oSegmentedShareMenu.addSection({sTag:"semantic"});this._getSegmentedFooter().addSection({sTag:"shareMenu",aContent:[o]});}}return this._oSegmentedShareMenu;};
return e;},false);
sap.ui.predefine('sap/m/semantic/SortAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SortAction",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.ISort"]}});
return a;},true);
sap.ui.predefine('sap/m/semantic/SortSelect',['sap/m/semantic/SemanticSelect'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SortSelect",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.ISort"]}});
return a;},true);
jQuery.sap.registerPreloadedModules({
"name":"sap/m/library-preload",
"version":"2.0",
"modules":{
	"sap/m/manifest.json":'{\n  "_version": "1.2.0",\n  "sap.app": {\n    "_version": "1.2.0",\n    "id": "sap.m",\n    "type": "library",\n    "embeds": [],\n    "applicationVersion": {\n      "version": "1.42.7"\n    },\n    "title": "The main UI5 control library, with responsive controls that can be used in touch devices as well as desktop browsers.",\n    "description": "The main UI5 control library, with responsive controls that can be used in touch devices as well as desktop browsers.",\n    "ach": "CA-UI5-CTR",\n    "resources": "resources.json",\n    "offline": true\n  },\n  "sap.ui": {\n    "_version": "1.1.0",\n    "technology": "UI5",\n    "supportedThemes": [\n      "base",\n      "sap_hcb"\n    ]\n  },\n  "sap.ui5": {\n    "_version": "1.1.0",\n    "dependencies": {\n      "minUI5Version": "1.42",\n      "libs": {\n        "sap.ui.core": {\n          "minVersion": "1.42.7"\n        }\n      }\n    }\n  }\n}'
}});
