/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

        (c) Copyright 2009-2016 SAP SE. All rights reserved
    
 */
sap.ui.define(['jquery.sap.global','./Calendar','./CalendarDate','./library','sap/ui/core/Control','sap/ui/core/theming/Parameters','sap/ui/core/date/UniversalDate'],function(q,C,a,c,d,P,U){"use strict";var O=d.extend("sap.me.OverlapCalendar",{metadata:{library:"sap.me",properties:{startDate:{type:"string",group:"Data",defaultValue:null},weeksPerRow:{type:"int",group:"Appearance",defaultValue:2},firstDayOffset:{type:"int",group:"Appearance",defaultValue:0},showOverlapIndicator:{type:"boolean",group:"Appearance",defaultValue:false},visible:{type:"boolean",group:"Appearance",defaultValue:true},swipeToNavigate:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'}},aggregations:{calendarEvents:{type:"sap.me.OverlapCalendarEvent",multiple:true,singularName:"calendarEvent"},calendar:{type:"sap.me.Calendar",multiple:false,visibility:"hidden"},typeLabels:{type:"sap.m.Label",multiple:true,singularName:"typeLabel",visibility:"hidden"},nameLabels:{type:"sap.m.Label",multiple:true,singularName:"nameLabel",visibility:"hidden"}},events:{endOfData:{parameters:{before:{type:"boolean"}}},changeDate:{parameters:{firstDate:{type:"object"},lastDate:{type:"object"}}}}}});O.prototype.init=function(){this.setAggregation("calendar",new C({singleRow:true,weeksPerRow:this.getWeeksPerRow(),monthsPerRow:1,monthsToDisplay:1,dayWidth:48,dayHeight:48,swipeToNavigate:this.getSwipeToNavigate()}));this.getCalendar().attachChangeCurrentDate(this.onCurrentDateChanged,this);this._typeWithBgImages=["04","07"];this._oDaysOverlap={};this._bRtl=sap.ui.getCore().getConfiguration().getRTL();};O.prototype.onswiperight=function(e){if(this.getSwipeToNavigate()){this.getCalendar().onswiperight(e);}};O.prototype.onswipeleft=function(e){if(this.getSwipeToNavigate()){this.getCalendar().onswipeleft(e);}};O.prototype.setSwipeToNavigate=function(s){this.getCalendar().setSwipeToNavigate(s);this.setProperty("swipeToNavigate",s,true);};O.prototype._getFirstDateDisplayed=function(){var f=this.getCalendar().getFirstDayOffset();var b=this._createDateInDays(this.getStartDate());var i=b.getDate();var e=b.getDay();b.setDate(1);var D=e+1-f;b.setDate(i-D+1);return b;};O.prototype._getLastDateDisplayed=function(){var w=this.getCalendar().getDays();var W=w.length;var i=this.getCalendar().getWeeksPerRow();var D=i*W;var b=this._getFirstDateDisplayed();var t=this._createDateInDays(b.getTime());t.setDate(t.getDate()+D-1);return t;};O.prototype.setWeeksPerRow=function(w){this.getCalendar().setWeeksPerRow(w);this.setProperty("weeksPerRow",w);};O.prototype.getCalendar=function(){return this.getAggregation("calendar");};O._ctorSafeDate=function(b){var s=b;if(b instanceof U){s=b.getTime();}return s;};O._getJSDate=function(b){var j=b;if(b instanceof U){j=new Date(b.getTime());}return j;};O.prototype.setStartDate=function(D){var s=O._ctorSafeDate(D);this.getCalendar().setFirstDayOffset(0);this.getCalendar().setCurrentDate(s);this.setProperty("startDate",s);var o=this._getDaysOffset(this._createDateInDays(s),this._getFirstDateDisplayed());this.getCalendar().setFirstDayOffset(o);};O.prototype.onCurrentDateChanged=function(e){this.setProperty("startDate",e.getParameter("currentDate"),true);this.getCalendar().invalidate();this._renderCalendarEvents();this.fireChangeDate({firstDate:O._getJSDate(this._getFirstDateDisplayed()),endDate:O._getJSDate(this._getLastDateDisplayed())});};O.prototype.onBeforeRendering=function(){this._cleanUp();this._aRows=[];this._lastDate=null;this._firstDate=null;var b=this.getCalendarEvents();q.each(b,q.proxy(this._parseCalendarEvent,this));};O.prototype.onAfterRendering=function(){this._renderCalendarEvents();sap.ui.Device.resize.attachHandler(this._onResize,this);};O.prototype._onResize=function(){if(this._sDelayedResize){q.sap.clearIntervalCall(this._sDelayedResize);}this._sDelayedResize=q.sap.delayedCall(200,this,this._fireRecomputeElementsSizes);};O.prototype.exit=function(){this._cleanUp();};O.prototype._cleanUp=function(){sap.ui.Device.resize.detachHandler(this._onResize,this);};O.prototype._fireRecomputeElementsSizes=function(){var o=this.$();var e=o.find(".sapMeOverlapCalendarHalfDay");q.merge(e,o.find(".sapMeOverlapCalendarRowLabels"));this._sizeElementsToParent(e);};O.prototype._getDayId=function(b){var e=this._createDateInDays(this._getFirstDateDisplayed());return this._getDaysOffset(e,this._createDateInDays(b));};O.prototype._cleanUpDivs=function(){var o=this.$();o.find(".sapMeOverlapCalendarDay").removeClass().addClass("sapMeOverlapCalendarDay");o.find(".sapMeOverlapCalendarHalfDay").remove();o.find(".sapMeOverlapCalendarDay.sapMeOverlapCalendarDayWithHalf").removeClass(".sapMeOverlapCalendarDayWithHalf");o.find(".sapMeOverlapCalendarOverlap").css("background-color","transparent").css("border","none");o.find(".sapMeOverlapCalendarTypeLbl").remove();};O.prototype._renderCalendarEvents=function(){var i;this._mHalfDays={};this._cleanUpDivs();this._oDaysOverlap={};var b=this.getCalendarEvents();q.each(b,q.proxy(this._renderCalendarEvent,this));q.each(this._mHalfDays,q.proxy(this._renderHalfDayCalendarEvent,this));if(this.getShowOverlapIndicator()){for(i in this._oDaysOverlap){if(this._oDaysOverlap[i]!=undefined&&this._oDaysOverlap[i]>1){var $=q.sap.byId(this._provideId("overlap",i));$.css("background-color",P.get("sapMeOverlapCalendarIndicator"));$.css("border-right","1px solid "+P.get("sapMeOverlapCalendarIndicator"));}}}if(this._firstDate&&this._lastDate){var e=this._getFirstDateDisplayed();e.setDate(e.getDate()+7);var f=this._getLastDateDisplayed();f.setDate(f.getDate()-7);if((this._dayIsBefore(this._lastDate,e))){this.fireEndOfData({before:false});}else if(this._dayIsAfter(this._firstDate,f)){this.fireEndOfData({before:true});}}};O.prototype._provideId=function(){var s=q.makeArray(arguments).join("-");return this.getId()+"-"+s;};O.prototype._addToDayOverlap=function(b){if(this._oDaysOverlap[b]==undefined){this._oDaysOverlap[b]=0;}this._oDaysOverlap[b]++;};O.prototype._getDaysOffset=function(f,s){return Math.abs(this._getRawDaysDifference(f,s));};O.prototype._getDaysDifference=function(f,s){return this._getRawDaysDifference(f,s);};O.prototype._getRawDaysDifference=function(f,s){var b=86400000;var e=f.getTime();var g=s.getTime();var h=e-g;return Math.round(h/b);};O.prototype._dayIsAfter=function(b,e){return(this._getDaysDifference(b,e)>0);};O.prototype._dayIsBefore=function(b,e){return(this._getDaysDifference(b,e)<0);};O.prototype._createDateInDays=function(b){var e=O._ctorSafeDate(b);var f=new Date(e);return a.createDate(f.getUTCFullYear(),f.getUTCMonth(),f.getUTCDate());};O.prototype._sizeElementsToParent=function(e){var b=(e!==null&&e.length)?e.length:0;var $,f;var i,w,h;for(i=0;i<b;i++){$=q(e[i]);if($){f=$.parent();w=f.width();h=f.height();$.width(w).height(h);}}};O.prototype._renderHalfDayCalendarEvent=function(k,h){var e=h[0];var $=q.sap.byId(k);var t=e.getType();var b=(q.inArray(t,this._typeWithBgImages)>-1);$.addClass("sapMeOverlapCalendarDayWithHalf");var f=q("<div/>");f.addClass("sapMeOverlapCalendarHalfDay").addClass("sapMeOverlapCalendarType"+t+"HalfDayStart");$.append(f);var g=null;if(h.length>1){var i=h[1];var j=i.getType();g=q("<div/>");g.addClass("sapMeOverlapCalendarHalfDay").addClass("sapMeOverlapCalendarType"+j+"HalfDayEnd");}else if(b){g=q("<div/>");g.addClass("sapMeOverlapCalendarHalfDay").addClass("sapMeOverlapCalendarTypeHalfDayEnd");}if(g!==null){$.append(g);}this._sizeElementsToParent([f,g]);};O.prototype._defineFirstAndLastDates=function(s,e){if(this._lastDate==undefined){this._lastDate=e;}if(this._dayIsAfter(e,this._lastDate)){this._lastDate=e;}if(this._firstDate==undefined){this._firstDate=s;}if(this._dayIsBefore(s,this._firstDate)){this._firstDate=s;}};O.prototype._renderCalendarEvent=function(i,o){var s=this._createDateInDays(o.getStartDay());var e=this._createDateInDays(o.getEndDay());this._defineFirstAndLastDates(s,e);var b=this._getFirstDateDisplayed();var l=this._getLastDateDisplayed();if((!this._dayIsBefore(e,b))&&(!this._dayIsAfter(s,l))){var r=o.getRow();var f=this._dayIsAfter(s,b)?s:b;e=this._dayIsAfter(e,l)?l:e;var n=this._getDaysOffset(f,e)+1;var g=this._getDaysOffset(b,f);var h="sapMeOverlapCalendarType"+o.getType();var $;var j;if(o.getHalfDay()===true){j=this._getDayId(f);var k=this._provideId(r,j);if(this._mHalfDays[k]==undefined){this._mHalfDays[k]=[];$=q.sap.byId(k);}this._mHalfDays[k].push(o);}else{while(!this._dayIsAfter(f,e)){j=this._getDayId(f);this._addToDayOverlap(j);$=q.sap.byId(this._provideId(r,j));$.addClass(h);f.setDate(f.getDate()+1);}}if($!=undefined){this._createEventLabel(o,f,n,g);}}};O.prototype._createEventLabel=function(o,b,n,e){var t=o.getTypeName();if(t&&t.length>0){var r=o.getRow();var l=this._provideId(r,this._getDayId(b));var f=this._provideId("row",r,"lbls");var $=q.sap.byId(f);$.width(q.sap.byId(this.getId()).width());var g=this._provideId("lbl",l);if(q.sap.byId(g).length===0){var h=q("<label dir='Inherit' id='"+g+"'>"+t+"</label>");$.append(h);h.addClass("sapMeOverlapCalendarTypeLbl sapMLabel");this._modifyLabel(h,n,e);}}};O.prototype._modifyLabel=function($,n,b){var e=(100/(this.getCalendar().getWeeksPerRow()*7));var w=(n*e);$.width(w+"%");var o=(b*e);var m=(b==0)?1:0.5;var l=o+"%";if(this._bRtl){$.css("right",l);$.css("padding-right",m+"rem");$.css("text-align","right");}else{$.css("left",l);$.css("padding-left",m+"rem");}};O.prototype._parseCalendarEvent=function(i,o){var r=o.getRow();if(r!=-1){if(o.getName()!=undefined){if(this._aRows[r]==undefined&&o.getName()!=""){this._aRows[r]=o.getName();}}else{q.sap.log.debug("Calendar event has no name");}}else{q.sap.log.debug("Invalid calendar event row");}};O.prototype._getLabelForRow=function(i){return this._getLabel(this._aRows[i],"nameLabels").addStyleClass("sapMeOverlapCalendarNameLbl");};O.prototype._getLabel=function(t,A){var l=new sap.m.Label({text:t});this.addAggregation(A,l,true);return l;};return O;},true);
