/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

		(c) Copyright 2009-2016 SAP SE. All rights reserved
	
 */
sap.ui.define(["jquery.sap.global","sap/rules/ui/library","sap/ui/core/Control","sap/ui/layout/form/SimpleForm","sap/m/Label","sap/m/Switch","sap/m/Select","sap/m/Table","sap/m/Text","sap/m/CheckBox","sap/m/Input","sap/rules/ui/ExpressionAdvanced","sap/rules/ui/Formatter","sap/m/MessageStrip","sap/ui/layout/VerticalLayout"],function(q,l,C,S,L,a,b,T,c,d,I,E,F,M,V){"use strict";var D=C.extend("sap.rules.ui.DecisionTableSettings",{metadata:{library:"sap.rules.ui",properties:{hitPolicies:{type:"sap.rules.ui.RuleHitPolicy[]",defaultValue:[sap.rules.ui.RuleHitPolicy.FirstMatch,sap.rules.ui.RuleHitPolicy.AllMatch]},modelName:{type:"string",defaultValue:""},newDecisionTable:{type:"boolean",defaultValue:false}},aggregations:{mainLayout:{type:"sap.ui.layout.VerticalLayout",multiple:false}},defaultAggregation:"mainLayout",associations:{expressionLanguage:{type:"sap.rules.ui.services.ExpressionLanguage",multiple:false,singularName:"expressionLanguage"}},events:{},publicMethods:[]}});sap.rules.ui.DecisionTableSettings.prototype.init=function(){this.oBundle=sap.ui.getCore().getLibraryResourceBundle("sap.rules.ui.i18n");this.needCreateLayout=true;this.firstLoad=true;this.onsapescape=function(e){e.stopPropagation();};this.setBusyIndicatorDelay(0);};sap.rules.ui.DecisionTableSettings.prototype.onBeforeRendering=function(){if(this.firstLoad){this._initSettingsModel();if(this.getProperty("newDecisionTable")===true){this._prepareNewRuleWorkaround();}this.firstLoad=false;}if(this.needCreateLayout){var e=this.getAggregation("mainLayout");if(e){e.destroy();}e=this._createLayout();this.setAggregation("mainLayout",e,true);this.needCreateLayout=false;}};sap.rules.ui.DecisionTableSettings.prototype._prepareNewRule=function(){var m=this._getModel();var o=this.getBindingContext();var r=sap.rules.ui.RuleFormat.Advanced;m.setProperty("Type",sap.rules.ui.RuleType.DecisionTable,o,true);m.setProperty("RuleFormat",r,o,true);var e={ruleId:o.getProperty("Id"),version:o.getProperty("Version")};var p={};this._createDecisionTable(e,p);e.colId=1;e.expression="";this._createCondition(e,p);e.colId=2;var f=this._createResult(e,p);e.rowId=1;e.columnsNumber=1+f;this._createRow(e,p);};sap.rules.ui.DecisionTableSettings.prototype._createDecisionTable=function(o,p){var m=this._getModel();var e=this.getBindingContext();var h=this.getHitPolicies()[0];if(e.getProperty("DecisionTable")){m.setProperty("DecisionTable/HitPolicy",h,e,true);}else{var f={RuleId:o.ruleId,Version:o.version,HitPolicy:h};p=p?p:{};p.properties=f;m.createEntry("/DecisionTables",p);}};sap.rules.ui.DecisionTableSettings.prototype._createRow=function(o,p){p=p?p:{};var m=this._getModel();var r={RuleId:o.ruleId,Version:o.version,Id:o.rowId};p.properties=r;m.createEntry("/DecisionTableRows",p);this._createCellsForNewRow(o,p);};sap.rules.ui.DecisionTableSettings.prototype._createCondition=function(o,p){p=p?p:{};var m=this._getModel();var e={RuleId:o.ruleId,Version:o.version,Id:o.colId,Type:sap.rules.ui.DecisionTableColumn.Condition};p.properties=e;m.createEntry("/DecisionTableColumns",p);var f={RuleId:o.ruleId,Version:o.version,Id:o.colId,Expression:o.expression,ValueOnly:false,FixedOperator:"",Description:""};p.properties=f;m.createEntry("/DecisionTableColumnConditions",p);};sap.rules.ui.DecisionTableSettings.prototype._createCellsForNewColumn=function(o,p){p=p?p:{};var m=this._getModel();var e=this.getBindingContext();var r=m.getProperty("DecisionTable/DecisionTableRows",e);for(var i=0;i<r.length;i++){var f=m.getProperty("/"+r[i]).Id;var g={RuleId:o.ruleId,Version:o.version,RowId:f,ColId:o.colId,Content:""};p.properties=g;m.createEntry("/DecisionTableRowCells",p);}};sap.rules.ui.DecisionTableSettings.prototype._createCellsForNewRow=function(o,p){p=p?p:{};var m=this._getModel();for(var e=1;e<=o.columnsNumber;e++){var f={RuleId:o.ruleId,Version:o.version,RowId:o.rowId,ColId:e,Content:""};p.properties=f;m.createEntry("/DecisionTableRowCells",p);}};sap.rules.ui.DecisionTableSettings.prototype._createResult=function(o,p){var e=this.getBindingContext();var r=e.getProperty("ResultDataObjectName");var f=sap.ui.getCore().byId(this.getExpressionLanguage());var g=f.getResultInfo(r);var h=g?g.requiredParams:[];var j=h.length;var k=o.colId;for(var i=0;i<j;i++){o.colId=k+i;o.resultParameterData=h[i];this._createResultParameter(o,p);}return j;};sap.rules.ui.DecisionTableSettings.prototype._createResultParameter=function(o,p){p=p?p:{};var m=this._getModel();var e={RuleId:o.ruleId,Version:o.version,Id:o.colId,Type:sap.rules.ui.DecisionTableColumn.Result};p.properties=e;m.createEntry("/DecisionTableColumns",p);var r={RuleId:o.ruleId,Version:o.version,Id:o.colId,DataObjectAttributeName:o.resultParameterData.name,DataObjectAttributeId:o.resultParameterData.paramId,BusinessDataType:o.resultParameterData.businessDataType};p.properties=r;m.createEntry("/DecisionTableColumnResults",p);};sap.rules.ui.DecisionTableSettings.prototype._removeColumn=function(o,p){var m=this._getModel();var e=o.getPath();m.remove(e,p);this._internalModel.setProperty("/tableData",{},true);};sap.rules.ui.DecisionTableSettings.prototype._removeCellsForColumn=function(o,p){var m=this._getModel();var e=this.getBindingContext();var r=m.getProperty("DecisionTable/DecisionTableRows",e);var f=o.colId-1;for(var i=0;i<r.length;i++){var g=m.getProperty("/"+r[i]+"/Cells");var h="/"+g[f];m.remove(h,p);}};sap.rules.ui.DecisionTableSettings.prototype._createTable=function(){var f=[new sap.ui.model.Filter("Type","EQ",sap.rules.ui.DecisionTableColumn.Condition)];this.conditionsTable=new T({backgroundDesign:sap.m.BackgroundDesign.Translucent,showSeparators:sap.m.ListSeparators.None,fixedLayout:true,layoutData:new sap.ui.layout.form.GridContainerData({halfGrid:false}),columns:[new sap.m.Column({width:"50%",header:new sap.m.Label({text:this.oBundle.getText("colOfDecisionTable"),design:sap.m.LabelDesign.Bold}).setTooltip(this.oBundle.getText("colOfDecisionTable"))}),new sap.m.Column({width:"30%",header:new sap.m.Label({text:this.oBundle.getText("fixedOperator"),design:sap.m.LabelDesign.Bold}).setTooltip(this.oBundle.getText("fixedOperator"))}),new sap.m.Column({width:"20%"})]}).data("hrf-id","columnsTable",true);this.conditionsTable.addStyleClass("sapRULTDecisionTableSettings sapThemeHighlight-asBackgroundColor");this.conditionsTable.bindItems({path:"DecisionTable/DecisionTableColumns",factory:this._tableColumnsFactory.bind(this),filters:f,parameters:{expand:"Condition"}});return this.conditionsTable;};sap.rules.ui.DecisionTableSettings.prototype._createLayout=function(){var w=new M({text:this.oBundle.getText("decisionTableSettingsWarningMsg"),showCloseButton:true,showIcon:true,type:sap.ui.core.MessageType.Warning,visible:!this.getProperty("newDecisionTable")}).addStyleClass("sapUiTinyMargin");var f=new S({editable:true,layout:"ResponsiveGridLayout",maxContainerCols:1,columnsL:1,columnsM:1,labelSpanM:1,content:[new L({text:this.oBundle.getText("hitPolicy")}).setTooltip(this.oBundle.getText("hitPolicy")),new b({width:"25%",enabled:"{settingsModel>/hitPolicy/enabled}",items:{path:"settingsModel>/hitPolicy/hitPolicyEnumration",template:new sap.ui.core.Item({key:"{settingsModel>key}",text:"{settingsModel>text}"})},selectedKey:"{DecisionTable/HitPolicy}"}),new L(),this._createTable(),new L({text:this.oBundle.getText("ouput")}).setTooltip(this.oBundle.getText("ouput")),new c({width:"25%",text:"{ResultDataObjectName}"})]});var m=new V("Layout1",{content:[w,f]});return m;};sap.rules.ui.DecisionTableSettings.prototype._setFixedOperatorOnExpressionChange=function(o){var e=o.getProperty("Id");var f=o.getProperty("Condition/Expression");var g=this._getFixedOperatorDataForExpression(f);this._internalModel.setProperty("/tableData/"+e,g,true);this._updateRemoveRowEnabled();};sap.rules.ui.DecisionTableSettings.prototype._getColumnControlObject=function(){var m=this._internalModel.getProperty("/advancedMode/current");if(m===sap.rules.ui.RuleFormat.Advanced){var e=sap.ui.getCore().byId(this.getExpressionLanguage());return new E({expressionLanguage:e,placeholder:this.oBundle.getText("expressionPlaceHolder"),validateOnLoad:true,type:sap.rules.ui.ExpressionType.NonComparison,value:{path:"Condition/Expression",events:{change:function(o){var s=o.getSource();var f=s.getContext();this._setFixedOperatorOnExpressionChange(f);}.bind(this)}},enabled:true,change:function(o){var s=o.getSource();var f=s.getBindingContext();this._setFixedOperatorOnExpressionChange(f);var g=f.getProperty("Condition/Expression");if(!g){var h=f.getModel();h.setProperty(f.getPath()+"/Condition/FixedOperator","");}}.bind(this)});}else{return new b({width:"100%",items:{path:"",template:new sap.ui.core.Item({key:"",text:""})},selectedKey:"{Condition/Expression}",enabled:true,change:function(o){}});}};sap.rules.ui.DecisionTableSettings.prototype._tableColumnsFactory=function(i,o){var r=o.getProperty("RuleId");var v=o.getProperty("Version");var e=o.getProperty("Id");return new sap.m.ColumnListItem({cells:[this._getColumnControlObject(),new sap.m.Select({width:"100%",items:{path:"settingsModel>/tableData/"+e+"/fixOperatorEnumration",template:new sap.ui.core.Item({key:"{settingsModel>key}",text:"{settingsModel>value}"})},selectedKey:"{Condition/FixedOperator}",enabled:"{settingsModel>/tableData/"+e+"/fixOperatorEnabled}"}),new sap.m.HBox({items:[new sap.m.Button({type:sap.m.ButtonType.Transparent,icon:sap.ui.core.IconPool.getIconURI("sys-cancel"),visible:"{settingsModel>/removeRowEnabled}",press:function(f){var g=f.getSource().getBindingContext();var p={};this._removeColumnWorkaround(g,p);}.bind(this)}).setTooltip(this.oBundle.getText("removeColumn")),new sap.m.Button({type:sap.m.ButtonType.Transparent,icon:sap.ui.core.IconPool.getIconURI("add"),press:function(f){var g={ruleId:r,version:v,colId:e+1,expression:""};var p={};this._addConditionWorkaround(g,p);}.bind(this)}).setTooltip(this.oBundle.getText("addColumn"))],height:"1em"})]});};sap.rules.ui.DecisionTableSettings.prototype._prepareNewRuleWorkaround=function(){this._beforeSaveWorkaround();this._prepareNewRule();this._saveWorkaround({success:this._reloadDataWorkaround.bind(this),error:this._reloadDataWorkaround.bind(this)});};sap.rules.ui.DecisionTableSettings.prototype._addConditionWorkaround=function(o,p){this._beforeSaveWorkaround();this._createCondition(o,p);this._saveWorkaround({success:this._reloadDataWorkaround.bind(this),error:this._reloadDataWorkaround.bind(this)});};sap.rules.ui.DecisionTableSettings.prototype._removeColumnWorkaround=function(o,p){var m=this._getModel();this._beforeSaveWorkaround();if(m.hasPendingChanges()){this._saveWorkaround({success:function(){this._removeColumn(o,p);this._reloadDataWorkaround();}.bind(this),error:this._reloadDataWorkaround.bind(this)});}else{this._removeColumn(o,p);this._reloadDataWorkaround();}};sap.rules.ui.DecisionTableSettings.prototype._saveWorkaround=function(p){var m=this._getModel();m.submitChanges(p);};sap.rules.ui.DecisionTableSettings.prototype._beforeSaveWorkaround=function(){var m=this._getModel();m.setRefreshAfterChange(false);this.setBusy(true);};sap.rules.ui.DecisionTableSettings.prototype._afterSaveWorkaround=function(){var m=this._getModel();m.setRefreshAfterChange(true);this.setBusy(false);};sap.rules.ui.DecisionTableSettings.prototype._reloadDataWorkaround=function(){var m=this._getModel();var e=this.getBindingContext();var r=e.getPath();m.read(r,{urlParameters:{"$expand":"DecisionTable/DecisionTableColumns/Condition,"+"DecisionTable/DecisionTableColumns/Result,"+"DecisionTable/DecisionTableRows/Cells"},success:function(){this._afterSaveWorkaround();}.bind(this),error:function(){this._afterSaveWorkaround();}.bind(this)});};sap.rules.ui.DecisionTableSettings.prototype._getModel=function(){var m=this.getModelName();if(m){return this.getModel(m);}return this.getModel();};sap.rules.ui.DecisionTableSettings.prototype._getBindModelName=function(){var p="";var m=this.getModelName();if(m){p=m+">";}return p;};sap.rules.ui.DecisionTableSettings.prototype._initSettingsModel=function(){var i={};i.advancedMode=this._getAdvancedModeData();i.hitPolicy=this._getHitPoliciesData();i.tableData={};i.removeRowEnabled=false;this._internalModel=new sap.ui.model.json.JSONModel(i);this.setModel(this._internalModel,"settingsModel");};sap.rules.ui.DecisionTableSettings.prototype._getAdvancedModeData=function(){var m;var e={};var o=this.getBindingContext();var r=o.getProperty("RuleFormat");if(r===sap.rules.ui.RuleFormat.Advanced){m=sap.rules.ui.RuleFormat.Advanced;}else{m=sap.rules.ui.RuleFormat.Advanced;}switch(m){case sap.rules.ui.RuleFormat.All:e={current:sap.rules.ui.RuleFormat.Basic,enabled:true,visible:true};break;case sap.rules.ui.RuleFormat.Basic:e={current:sap.rules.ui.RuleFormat.Basic,enabled:false,visible:false};break;case sap.rules.ui.RuleFormat.Advanced:e={current:sap.rules.ui.RuleFormat.Advanced,enabled:false,visible:true};break;default:}return e;};sap.rules.ui.DecisionTableSettings.prototype._getHitPoliciesData=function(){var h=this.getProperty("hitPolicies");var e=h.length;var H={hitPolicyEnumration:[]};for(var i=0;i<e;i++){H.hitPolicyEnumration.push({key:h[i],text:this.oBundle.getText(h[i])});}H.enabled=e>1?true:false;return H;};sap.rules.ui.DecisionTableSettings.prototype._getFixedOperatorDataForExpression=function(e){var f=e?true:false;var g={fixOperatorEnumration:[{key:"",value:this.oBundle.getText("fixOperatorDefaultValue")}],fixOperatorEnabled:f};if(f){var s=[];var o=sap.ui.getCore().byId(this.getExpressionLanguage());var h=[{tokenType:sap.rules.ui.ExpressionTokenType.reservedWord,tokenCategory:sap.rules.ui.ExpressionCategory.comparisonOp},{tokenType:sap.rules.ui.ExpressionTokenType.reservedWord,tokenCategory:sap.rules.ui.ExpressionCategory.comparisonBetweenOp},{tokenType:sap.rules.ui.ExpressionTokenType.reservedWord,tokenCategory:sap.rules.ui.ExpressionCategory.comparisonExistOp}];s=o.getSuggestionsByCategories(e,h);for(var i=0;i<s.length;i++){g.fixOperatorEnumration.push({key:s[i].text,value:s[i].text});}}return g;};sap.rules.ui.DecisionTableSettings.prototype._setAdvancedMode=function(o){var A=o.getParameter("selected");var r=A?sap.rules.ui.RuleFormat.Advanced:sap.rules.ui.RuleFormat.Basic;var R=this._getModel();var e=this.getBindingContext().getPath();R.setProperty(e+"/RuleFormat",r);this.needCreateLayout=true;this.invalidate();};sap.rules.ui.DecisionTableSettings.prototype._updateRemoveRowEnabled=function(){var t=this._internalModel.getProperty("/tableData");var e=Object.keys(t).length;var f=e>1;this._internalModel.setProperty("/removeRowEnabled",f,null,true);};return D;},true);
