/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

		(c) Copyright 2009-2016 SAP SE. All rights reserved
	
 */
sap.ui.define(["sap/ui/core/Control","sap/m/Button","sap/m/TextArea","sap/m/Text","sap/m/MessageBox","sap/ui/layout/HorizontalLayout","sap/rules/ui/Utils","sap/ui/core/Popup","jquery.sap.global","sap/rules/ui/codemirror/lib/codemirror","sap/rules/ui/codemirror/addon/hint/show-hint","sap/rules/ui/codemirror/mode/hdf/hdf","sap/rules/ui/codemirror/addon/display/placeholder","sap/rules/ui/codemirror/addon/mh/mark-selection","sap/rules/ui/codemirror/addon/hint/hdf-hint","sap/rules/ui/codemirror/addon/closeBrackets/closebrackets","sap/rules/ui/codemirror/addon/search/search","sap/rules/ui/codemirror/addon/search/searchcursor"],function(C,B,a,b,M,H,U,P,q){"use strict";var E=C.extend("sap.rules.ui.ExpressionAdvanced",{metadata:{properties:{value:{type:"string",defaultValue:"",bindable:"bindable"},type:{type:"sap.rules.ui.ExpressionType",defaultValue:sap.rules.ui.ExpressionType.All,bindable:"bindable"},collection:{type:"boolean",defaultValue:false},placeholder:{type:"string",defaultValue:null},editable:{type:"boolean",defaultValue:true},validateOnLoad:{type:"boolean",defaultValue:false},focusOnLoad:{type:"boolean",defaultValue:false},valueStateText:{type:"string",defaultValue:null,bindable:"bindable"}},aggregations:{_expressionArea:{type:"sap.m.TextArea",multiple:false,visibility:"hidden"}},associations:{expressionLanguage:{type:"sap.rules.ui.services.ExpressionLanguage",multiple:false,singularName:"expressionLanguage"}},events:{"change":{},"liveChange":{}},publicMethods:["validate"]}});E.prototype.init=function(){var c=jQuery.sap.getModulePath("sap.rules.ui.codemirror.lib")+"/codemirror.css";var s=jQuery.sap.getModulePath("sap.rules.ui.codemirror.addon.hint")+"/show-hint.css";jQuery.sap.includeStyleSheet(c);jQuery.sap.includeStyleSheet(s);this.pop=new P(q('<span></span>')[0],false,false,false);this.errorWidgets=[];this.expressionTokens=[];this.oBundle=sap.ui.getCore().getLibraryResourceBundle("sap.rules.ui.i18n");this.dataModel=this.initControlDataModel();this.oTextArea=new a({width:"100%"});this.setAggregation("_expressionArea",this.oTextArea,true);};E.prototype.validateExpression=function(I){for(var i=0;i<this.errorWidgets.length;i++){this.codeMirror.removeLineWidget(this.errorWidgets[i]);}this.errorWidgets=[];var e=this.codeMirror?this.codeMirror.getValue():this.getValue();var r={};var c={};if(sap.ui.getCore().byId(this.getExpressionLanguage())){c=sap.ui.getCore().byId(this.getExpressionLanguage()).validateExpression(I?I:e,this.getProperty("type"),this.getCollection());if(this.isActive()){r=c;if(typeof(c)!=='object'){r=JSON.parse(c);}if(r.status===sap.rules.ui.ValidationStatus.Error){var m=U.parseUTFToString(r.errorDetails);m=m.replace(/\r\n/g," ").replace(/\r/g," ").replace(/\n/g," ");this.errorCursorPosition=r.cursorPosition;this.setValueStateText(m);}else{this.oTextArea.setValueState("None");this.oTextArea.setValueStateText("");this.setValueStateText("");jQuery(this.codeMirror.getWrapperElement()).removeClass('sapMInputBaseStateInner sapMInputBaseErrorInner');}}}return c;};E.prototype._showPopUp=function(){var e="Error";var c=this.getProperty("valueStateText");var t=this.getId()+'-message';var p=this.pop;p.attachClosed(function(){q.sap.byId(t).remove();});var d=P.Dock;var f='sapMInputBaseMessage'+e+' sapMFocus';var T='sapMInputBaseMessageText sapMText';var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');if(e===sap.ui.core.ValueState.Success){f='sapUiInvisibleText';c='';}var $=q('<div>',{'id':t,'class':f,'role':'tooltip','aria-live':'assertive'}).append(q('<span>',{'aria-hidden':true,'class':'sapUiHidden','text':r.getText('INPUTBASE_VALUE_STATE_'+e.toUpperCase())})).append(q('<span>',{'id':t+'-text','class':T,'text':c}));p.setContent($[0]);p.close(0);p.open(0,d.BeginTop,d.BeginBottom,jQuery(this.codeMirror.getWrapperElement()),null,null);};E.prototype._closePopUp=function(){if(this.pop){this.pop.close(0);}};E.prototype._showErrorMessage=function(){if(this.getValueStateText()){this._setExpressionErrorStyle();}};E.prototype.initControlDataModel=function(){var d=new sap.ui.model.json.JSONModel();var c={};d.setData(c);return d;};E.prototype.setExpressionTokens=function(t){var m=0,n=false;this.expressionTokens=[];if(t instanceof Array){for(var i=0;i<t.length;i++){var c=t[i];var d=/\n/;if(d.test(c.token)){m=c.start+c.token.lastIndexOf('\n')+1;n=true;continue;}if(n){c.start=c.start-m;c.end=c.end-m+1;}else{c.end=c.end+1;}this.expressionTokens.push(c);}}};E.prototype.getExpressionTokens=function(){return this.expressionTokens;};E.prototype.getValue=function(){if(this.codeMirror!==undefined){return this.codeMirror.getValue();}return this.getProperty("value");};E.prototype.setValue=function(v){if(v===undefined){v="";}this.oTextArea.setValue(v);if(this.getProperty("value")===v){return;}this.setProperty("value",v,true);if(this.codeMirror!==undefined){this.codeMirror.setValue(v);}};E.prototype.setPlaceholder=function(v){this.setProperty("placeholder",v);var m=(this.getEditable())?v:"";this.dataModel.setProperty("/placeholder",m);};E.prototype.getPlaceholder=function(){return this.dataModel.getProperty("/placeholder");};E.prototype.setValueStateText=function(m){this.setProperty("valueStateText",m,true);this._showErrorMessage(m);};E.prototype.setEditable=function(v){this.setProperty("editable",v);if(this.codeMirror){jQuery(this.codeMirror.getWrapperElement()).addClass('CodeMirror-rules-Not-Editable');}var _=(v)?this.getProperty("placeholder"):"";this.dataModel.setProperty("/placeholder",_);this.invalidate();};E.prototype.setType=function(t){this.setProperty("type",t);if(this.codeMirror){this.codeMirror.options.returnType=t;}};E.prototype.setCollection=function(i){this.setProperty("collection",i,true);if(this.codeMirror){this.codeMirror.options.collection=i;}};E.prototype.validate=function(){return this.validateExpression();};E.prototype.setFocusOnLoad=function(v){this.dataModel.setProperty("/focus",v);this.setProperty("focusOnLoad",v,true);};E.prototype.focus=function(){if(this.codeMirror){var l=this.codeMirror.getLine(this.codeMirror.lastLine());var c=l.length;this.codeMirror.setCursor({line:this.codeMirror.lastLine(),ch:c});this.codeMirror.focus();}};E.prototype.onAliasLinkPress=function(c){var e=sap.ui.getCore().byId(this.getExpressionLanguage());if(e){e.onAliasLinkPress(c);e.attachEvent("aliasDialogClosed",this.aliasClickCancel,this);}};E.prototype.onCreateAliasLinkForText=function(t){var e=sap.ui.getCore().byId(this.getExpressionLanguage());if(e){e.attachEvent("aliasDialogClosed",this.replaceTextWithAlias,this);e.onCreateAliasLinkForText(t);}};E.prototype.replaceTextWithAlias=function(e){if(e.getParameter("isSave")){this.codeMirror.replaceSelection(e.getParameter("savedAliasName"));}};E.prototype.aliasClickCancel=function(e){this.codeMirror.focus();this.codeMirror.execCommand("goLineEnd");this.fireDialog({dialogStatus:sap.rules.ui.ValueListDialogMode.Close});};E.prototype.onAfterRendering=function(){this.timer=null;this.needAutoComplete=false;this.endCompletion=false;this._setCodeMirror();this._setEditorStyle();this._handleMousedown();this._handleChange();this._handleFocusLeave();this._handleEndCodeCompletion();this._handleKeyPress();this._handleEditableProperty();this._handleOnLoadValidation();this._refreshOnNavigationEnd();this._handleFocus();this._handleValueListSelect();};E.prototype._handleValueListSelect=function(){};E.prototype.onEnumLinkPress=function(e,c){this.blurEvent=false;var d=sap.ui.getCore().byId(this.getExpressionLanguage());var f=jQuery.extend(true,{},this.codeMirror.getCursor());var g=this._createSearchCursor(e);if(g.find(e)||e===sap.rules.ui.VocabularyEnum.SelectValueList){var h=this._selectDialogCallback();this.oSelectDialog=new sap.m.SelectDialog({title:this.oBundle.getText('ENUM_SELECT_DIALOG_TITLE'),noDataText:this.oBundle.getText('ENUM_SELECT_DIALOG_MESSAGE'),contentHeight:"15rem",contentWidth:"10rem",search:h.searchFn,liveChange:h.searchFn});this.oSelectDialog.attachConfirm({cmCursor:g,enumText:e,cursorPos:f},h.confirm,this);d.vocabularyProxy.getEnumList(c,this._setSelectDialogModel,this);this.oSelectDialog.open();}};E.prototype._setSelectDialogModel=function(i){var l=new sap.m.StandardListItem({title:"{}"});var d=new sap.ui.model.json.JSONModel();d.setJSON(JSON.stringify(i));this.oSelectDialog.setModel(d);this.oSelectDialog.bindAggregation("items","/",l);};E.prototype._createSearchCursor=function(e){var c=this.codeMirror;c.getCursor().ch=c.getCursor().ch+e.length;var d=c.getSearchCursor(e,c.getCursor(),typeof e=="string"&&e==e.toLowerCase());return d;};E.prototype._selectDialogCallback=function(){var f={};f.searchFn=function(e){var F=[],s=e.getParameter("value"),i=e.getParameter("itemsBinding");if(s!==undefined&&s.length>0){F.push(new sap.ui.model.Filter('',sap.ui.model.FilterOperator.Contains,s));}i.filter(F,"Application");};f.confirm=function(e,d){if(e.getParameter('selectedItem')){var s=e.getParameter('selectedItem').getTitle();if(d.enumText!==sap.rules.ui.VocabularyEnum.SelectValueList){d.cmCursor.replace(s);}else{var c=d.cursorPos;this.codeMirror.replaceRange(s,c);c=this.codeMirror.findPosH(c,s.length,"char",true);this.codeMirror.setCursor(c);}this.oSelectDialog.destroy();this.oSelectDialog=null;this.codeMirror.focus();this.blurEvent=true;this.fireDialog({dialogStatus:sap.rules.ui.ValueListDialogMode.Close});}};return f;};E.prototype._setCodeMirror=function(){var e=this.getEditable();function c(j,l,m){var A=j.options.expressionEditor;if((A.getEditable()!==false)&&sap.ui.getCore().byId(A.getExpressionLanguage())){window.clearTimeout(A.timer);A.timer=window.setTimeout(function(){j.execCommand(l);},m);return window.CodeMirror.Pass;}return null;}function o(j){var A=j.options.expressionEditor;if(A.getEditable()!==false){window.clearTimeout(A.timer);A.needAutoComplete=true;A.timer=window.setTimeout(function(){if(A.needAutoComplete&&sap.ui.getCore().byId(A.getExpressionLanguage())){j.execCommand("autocomplete");}},500);return window.CodeMirror.Pass;}return null;}function d(j){return c(j,"enterAutocomplete",500);}function f(j){return c(j,"colonAutocomplete",500);}function g(j){c(j,"autocomplete",0);}function s(j){return c(j,"autocomplete",500);}this.keyMap={"Tab":false,"Shift-Tab":false,"Ctrl-Space":g,"Backspace":o,"Enter":d,"':'":f,"'+'":o,"'-'":o,"'*'":o,"'/'":o,"'_'":o,"'o'":o,"'q'":o,"'w'":o,"'e'":o,"'r'":o,"'t'":o,"'y'":o,"'u'":o,"'i'":o,"'p'":o,"'.'":o,"'a'":o,"'s'":o,"'d'":o,"'f'":o,"'g'":o,"'h'":o,"'j'":o,"'k'":o,"'l'":o,"'z'":o,"'x'":o,"'c'":o,"'v'":o,"'b'":o,"'n'":o,"'m'":o,"'O'":o,"'Q'":o,"'W'":o,"'E'":o,"'R'":o,"'T'":o,"'Y'":o,"'U'":o,"'I'":o,"'P'":o,"'A'":o,"'S'":o,"'D'":o,"'F'":o,"'G'":o,"'H'":o,"'J'":o,"'K'":o,"'L'":o,"'Z'":o,"'X'":o,"'C'":o,"'V'":o,"'B'":o,"'N'":o,"'M'":o,"'0'":false,"'1'":false,"'2'":false,"'3'":false,"'4'":false,"'5'":false,"'6'":false,"'7'":false,"'8'":false,"'9'":false,"' '":s};function k(A){return A.keyMap;}if(this.expressionTokens.length===0){if(sap.ui.getCore().byId(this.getExpressionLanguage())){this.setExpressionTokens(sap.ui.getCore().byId(this.getExpressionLanguage()).getExpressionMetadata(this.getProperty("value")).tokens);}}var h=k(this);var t=this.oTextArea.getId()+'-inner';var i=(U.msieversion()>=0);if(i){jQuery('#'+t).attr('placeholder',this.getProperty('placeholder'));}this.codeMirror=window.CodeMirror.fromTextArea(document.getElementById(t),{mode:"text/hdf",lineNumbers:false,lineWrapping:true,matchBrackets:e===true?true:false,highlightSelectionMatches:e===true?{showToken:/\w/}:{},relDelegate:sap.ui.getCore().byId(this.getExpressionLanguage()),returnType:this.getProperty("type"),collection:this.getProperty("collection"),expressionEditor:this,stillNeedShowHint:true,shouldValidate:true,styleSelectedText:true,smartIndent:true,autoCloseBrackets:true,indentUnit:6});this.codeMirror.addKeyMap(h,true);};E.prototype._setEditorStyle=function(){if(this.getValueStateText()){jQuery(this.codeMirror.getWrapperElement()).addClass('CodeMirror-error');jQuery(this.codeMirror.getWrapperElement()).addClass('sapMInputBaseStateInner sapMInputBaseErrorInner');jQuery('#'+this.oTextArea.getId()).addClass('sapMInputBaseError');}jQuery('#'+this.oTextArea.getId()).removeClass().addClass('sapMInput');jQuery(this.codeMirror.getWrapperElement()).addClass('sapMInputBaseInner CodeMirror-rules');if(!this.getEditable()){jQuery(this.codeMirror.getWrapperElement()).addClass('CodeMirror-rules-Not-Editable');}if(this.codeMirror){this.codeMirror.refresh();}};E.prototype._handleOnLoadValidation=function(){if(this.getValidateOnLoad()){this.validateExpression();this.setValidateOnLoad(false);}};E.prototype._handleEditableProperty=function(){if(this.getEditable()===false){this.codeMirror.setOption("readOnly","true");this.codeMirror.setOption("theme","read-only");}};E.prototype._handleFocus=function(){var c=this.codeMirror;if(this.getFocusOnLoad()){this.focus();}this.codeMirror.on("focus",function(d,e){var f=d.options.expressionEditor.getProperty("valueStateText");if((f)){d.options.expressionEditor._showPopUp();}d.options.stillNeedShowHint=true;jQuery('#'+d.options.expressionEditor.oTextArea.getId()).addClass('sapMInputFocused');jQuery(d.getWrapperElement()).removeClass('CodeMirror-errorBackground');});if(this.dataModel.getProperty("/focus")===true){window.setTimeout(function(){var l=c.getLine(c.lastLine());var d=l.length;c.setCursor({line:c.lastLine(),ch:d});},10);}};E.prototype._refreshOnNavigationEnd=function(){jQuery(".sapMNav").on('webkitTransitionEnd oTransitionEnd transitionend msTransitionEnd',function(){if(this.codeMirror){this.codeMirror.refresh();}});};E.prototype._handleKeyPress=function(){this.codeMirror.on("keyHandled",function(c,k,e){if(e.keyCode===27&&this.endCompletion===true){e.stopPropagation();this.endCompletion=false;}});};E.prototype._handleEndCodeCompletion=function(){this.codeMirror.on("endCompletion",function(c){c.options.expressionEditor.needAutoComplete=false;c.options.expressionEditor.endCompletion=!c.options.expressionEditor.endCompletion;});};E.prototype._handleMousedown=function(){this.codeMirror.on("mousedown",function(c,e){e.stopPropagation();});};E.prototype._handleChange=function(){this.codeMirror.on("change",function(c,d){var A=c.options.expressionEditor;if(A.codeMirror.state.completionActive&&A.keyMap["'"+d.text[0]+"'"]===false){A.codeMirror.state.completionActive.close();}jQuery(A.codeMirror.getWrapperElement()).removeClass('CodeMirror-error');jQuery(A.codeMirror.getWrapperElement()).removeClass('sapMInputBaseStateInner sapMInputBaseErrorInner');A.setProperty("value",c.getValue(),true);if(sap.ui.getCore().byId(A.getExpressionLanguage())){A.setExpressionTokens(sap.ui.getCore().byId(A.getExpressionLanguage()).getExpressionMetadata(A.getProperty("value")).tokens);}A.codeMirror.options.shouldValidate=true;A.fireLiveChange({newValue:c.getValue()});if(d.origin!=="+delete"){c.operation(function(){for(var l=0,e=c.lineCount();l<e;++l){c.indentLine(l,"smart");}});}});};E.prototype._handleFocusLeave=function(){this.codeMirror.on("blur",function(c){var A=c.options.expressionEditor;A._closePopUp();A.codeMirror.options.stillNeedShowHint=false;A.setValue(A.codeMirror.getValue());if(A.codeMirror.options.shouldValidate){A.validate();A._closePopUp();A.fireChange({newValue:c.getValue()});A.codeMirror.options.shouldValidate=false;}jQuery('#'+A.oTextArea.getId()).removeClass('sapMInputFocused');A.dataModel.setProperty("/focus",false);});};E.prototype._setExpressionErrorStyle=function(){var e=this.getProperty("valueStateText");if(e!==""&&e!==undefined&&this.codeMirror){jQuery(this.codeMirror.getWrapperElement()).addClass('CodeMirror-error');jQuery(this.codeMirror.getWrapperElement()).addClass('sapMInputBaseStateInner sapMInputBaseErrorInner');jQuery('#'+this.oTextArea.getId()).addClass('sapMInputBaseError');var c;if(this.errorCursorPosition<0){var l=this.codeMirror.getLine(this.codeMirror.lastLine());c=l.length;jQuery(this.codeMirror.getWrapperElement()).addClass('CodeMirror-errorBackground');}else{var i=e.lastIndexOf("'");if(i>0){var o=e.substring(0,i);i=o.lastIndexOf("'");if(i>0){o=o.substring(i+1);}var f=false;for(var d=this.codeMirror.lastLine();!f&&d>=0;d--){var g=this.codeMirror.getLine(d);c=g.lastIndexOf(o);if(c>=0){f=true;this.codeMirror.setSelection({line:d,ch:c},{line:d,ch:c+o.length});}}}}}};E.prototype.getSelectedText=function(){return this.codeMirror.getSelection();};return E;},true);
