/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','../Device','./Control','./IconPool','./InvisibleText','./library'],function(q,D,C,I,a,l){"use strict";var b=l.IconColor;var c=C.extend("sap.ui.core.Icon",{metadata:{library:"sap.ui.core",properties:{src:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},size:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},color:{type:"string",group:"Appearance",defaultValue:null},hoverColor:{type:"string",group:"Appearance",defaultValue:null},activeColor:{type:"string",group:"Appearance",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},backgroundColor:{type:"string",group:"Appearance",defaultValue:null},hoverBackgroundColor:{type:"string",group:"Appearance",defaultValue:null},activeBackgroundColor:{type:"string",group:"Appearance",defaultValue:null},decorative:{type:"boolean",group:"Accessibility",defaultValue:true},useIconTooltip:{type:"boolean",group:"Accessibility",defaultValue:true},alt:{type:"string",group:"Accessibility",defaultValue:null},noTabStop:{type:"boolean",group:"Accessibility",defaultValue:false}},aggregations:{_invisibleText:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{}}}});c.prototype[D.support.touch?"ontouchstart":"onmousedown"]=function(e){if(this.hasListeners("press")||this.hasListeners("tap")){e.setMarked();}var A=this.getActiveColor(),s=this.getActiveBackgroundColor(),i;if(A||s){if(!e.targetTouches||(e.targetTouches&&e.targetTouches.length===1)){i=this.$();i.addClass("sapUiIconActive");if(A){this._addColorClass(A,"color");}if(s){this._addColorClass(s,"background-color");}}}};c.prototype[D.support.touch?"ontouchend":"onmouseup"]=function(e){if(!e.targetTouches||(e.targetTouches&&e.targetTouches.length===0)){this.$().removeClass("sapUiIconActive");this._restoreColors();}};c.prototype.onmouseover=function(){var h=this.getHoverColor(),H=this.getHoverBackgroundColor();if(h){this._addColorClass(h,"color");}if(H){this._addColorClass(H,"background-color");}};c.prototype.onmouseout=function(){this._restoreColors();};c.prototype[D.support.touch&&!D.system.desktop?"ontap":"onclick"]=function(){this.firePress({});};c.prototype.onkeydown=function(e){if(e.which===q.sap.KeyCodes.SPACE||e.which===q.sap.KeyCodes.ENTER){e.preventDefault();var i=this.$(),A=this.getActiveColor(),s=this.getActiveBackgroundColor();i.addClass("sapUiIconActive");if(A){this._addColorClass(A,"color");}if(s){this._addColorClass(s,"background-color");}}};c.prototype.onkeyup=function(e){if(e.which===q.sap.KeyCodes.SPACE||e.which===q.sap.KeyCodes.ENTER){this.$().removeClass("sapUiIconActive");this._restoreColors();this.firePress({});}};c.prototype._restoreColors=function(){this._addColorClass(this.getColor()||"","color");this._addColorClass(this.getBackgroundColor()||"","background-color");};c.prototype.setSrc=function(s){var i=I.getIconInfo(s),$=this.$(),o,d,t,u,L,e;this.setProperty("src",s,!!i);if(i&&$.length){$.css("font-family",i.fontFamily);$.attr("data-sap-ui-icon-content",i.content);$.toggleClass("sapUiIconMirrorInRTL",!i.suppressMirroring);t=this.getTooltip_AsString();L=this.getAriaLabelledBy();u=this.getUseIconTooltip();o=this._shouldOutputIconLabel();d=this._getIconLabel();if(t||(u&&i.text)){$.attr("title",t||i.text);}else{$.attr("title",null);}if(L.length===0){if(o){$.attr("aria-label",d);}else{$.attr("aria-label",null);}}else{e=this.getAggregation("_invisibleText");if(e){e.setText(d);}}}return this;};c.prototype.setWidth=function(w){this.setProperty("width",w,true);this.$().css("width",w);return this;};c.prototype.setHeight=function(h){this.setProperty("height",h,true);this.$().css({"height":h,"line-height":h});return this;};c.prototype.setSize=function(s){this.setProperty("size",s,true);this.$().css("font-size",s);return this;};c.prototype.setColor=function(s){this.setProperty("color",s,true);this._addColorClass(s,"color");return this;};c.prototype._addColorClass=function(s,d){var i=this.$(),t=this;var e="";if(d==="color"){e="sapUiIconColor";}else if(d==="background-color"){e="sapUiIconBGColor";}else{return;}q.each(b,function(p,P){t.removeStyleClass(e+P);});if(s in b){i.css(d,"");this.addStyleClass(e+s);}else{i.css(d,s);}};c.prototype.setActiveColor=function(s){return this.setProperty("activeColor",s,true);};c.prototype.setHoverColor=function(s){return this.setProperty("hoverColor",s,true);};c.prototype.setBackgroundColor=function(s){this.setProperty("backgroundColor",s,true);this._addColorClass(s,"background-color");return this;};c.prototype.setActiveBackgroundColor=function(s){return this.setProperty("activeBackgroundColor",s,true);};c.prototype.setHoverBackgroundColor=function(s){return this.setProperty("hoverBackgroundColor",s,true);};c.prototype.attachPress=function(){var m=Array.prototype.slice.apply(arguments);m.unshift("press");C.prototype.attachEvent.apply(this,m);if(this.hasListeners("press")){this.$().toggleClass("sapUiIconPointer",true).attr({role:"button",tabindex:this.getNoTabStop()?undefined:0});}return this;};c.prototype.detachPress=function(){var m=Array.prototype.slice.apply(arguments);m.unshift("press");C.prototype.detachEvent.apply(this,m);if(!this.hasListeners("press")){this.$().toggleClass("sapUiIconPointer",false).attr({role:this.getDecorative()?"presentation":"img"}).removeAttr("tabindex");}return this;};c.prototype._shouldOutputIconLabel=function(){var i=I.getIconInfo(this.getSrc()),A=this.getAlt(),t=this.getTooltip_AsString(),u=this.getUseIconTooltip();return!!(A||t||(u&&i));};c.prototype._getIconLabel=function(){var i=I.getIconInfo(this.getSrc()),A=this.getAlt(),t=this.getTooltip_AsString();return A||t||i.text||i.name;};c.prototype._createInvisibleText=function(t){var i=this.getAggregation("_invisibleText");if(!i){i=new a(this.getId()+"-label",{text:t});this.setAggregation("_invisibleText",i,true);}else{i.setProperty("text",t,true);}return i;};c.prototype._getAccessibilityAttributes=function(){var L=this.getAriaLabelledBy(),A={},o=this._shouldOutputIconLabel(),i,s;if(this.getDecorative()){A.role="presentation";A.hidden="true";}else{if(this.hasListeners("press")){A.role="button";}else{A.role="img";}}if(o){s=this._getIconLabel();}if(L.length>0){if(o){i=this._createInvisibleText(s);L.push(i.getId());}A.labelledby=L.join(" ");}else if(o){A.label=s;}return A;};c.prototype.getAccessibilityInfo=function(){if(this.getDecorative()){return null;}var h=this.hasListeners("press");var i=I.getIconInfo(this.getSrc());return{role:h?"button":"img",type:sap.ui.getCore().getLibraryResourceBundle("sap.ui.core").getText(h?"ACC_CTR_TYPE_BUTTON":"ACC_CTR_TYPE_IMAGE"),description:this.getAlt()||this.getTooltip_AsString()||(i?i.text||i.name:""),focusable:h};};return c;});
