/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/base/EventProvider','sap/ui/base/ManagedObject'],function(q,E,M){"use strict";var r={};var C=E.extend("sap.ui.core.mvc.Controller",{constructor:function(n){var t=null;if(typeof(n)=="string"){if(!r[n]){q.sap.require({modName:n,type:"controller"});if(!r[n]){throw new Error("Controller type "+n+" is still undefined after trying to load it.");}}t=r[n];}E.apply(this,arguments);if(t){q.extend(this,r[n]);}}});var c={"onInit":true,"onExit":false,"onBeforeRendering":false,"onAfterRendering":true};function m(o,a){for(var b in a){if(c[b]!==undefined){var O=o[b];if(O&&typeof O==="function"){(function(f,O,d){o[b]=function(){if(d){O.apply(o,arguments);f.apply(o,arguments);}else{f.apply(o,arguments);O.apply(o,arguments);}};})(a[b],O,c[b]);}else{o[b]=a[b];}}else{o[b]=a[b];}}}C.extendIfRequired=function(o,n,a){var b;var d=sap.ui.require('sap/ui/core/CustomizingConfiguration');if(d){var e=d.getControllerExtension(n,M._sOwnerId);if(e){var s=typeof e==="string"?e:e.controllerName;var f=e.controllerNames||[];if(s){s&&f.unshift(s);}for(var i=0,l=f.length;i<l;i++){var g=f[i];if(typeof g==="string"){q.sap.log.info("Customizing: Controller '"+n+"' is now extended by '"+g+"'");if(!r[g]&&!q.sap.getObject(g)){q.sap.require({modName:g,type:"controller"});}if(!r[g]&&!q.sap.getObject(g)){q.sap.log.error("Attempt to load Extension Controller "+g+" was not successful - is the Controller correctly defined in its file?");}if((b=r[g])!==undefined){m(o,b);}}}}else{q.sap.log.debug("Customizing: no Controller extension found for Controller '"+n+"'.");}}if(C._sExtensionProvider){q.sap.require(C._sExtensionProvider);var h=q.sap.getObject(C._sExtensionProvider);if(h){q.sap.log.info("Customizing: Controller '"+n+"' is now extended by Controller Extension Provider '"+C._sExtensionProvider+"'");var j=new h();var k=j.getControllerExtensions(n,M._sOwnerId,a);if(k instanceof Promise){return k.then(function(p){if(p&&p.length){for(var i=0,l=p.length;i<l;i++){m(o,p[i]);}}return o;},function(p){q.sap.log.error("Controller Extension Provider: Error '"+p+"' thrown in "+C._sExtensionProvider+"; extension provider ignored.");return o;});}else{if(k&&k.length){for(var i=0,l=k.length;i<l;i++){m(o,k[i]);}}}}else{q.sap.log.error("Controller Extension Provider: Extension Provider "+C._sExtensionProvider+" could not be found");}}return o;};sap.ui.controller=function(n,o){if(!n){throw new Error("Controller name ('sName' parameter) is required");}var e=true;if(typeof o==="boolean"){e=!o;o=undefined;}if(!o){if(!r[n]&&!q.sap.getObject(n)){q.sap.require({modName:n,type:"controller"});}if(r[n]){var a=new C(n);if(e){C.extendIfRequired(a,n);}return a;}else{var b=q.sap.getObject(n);if(typeof b==="function"&&b.prototype instanceof C){var a=new b();if(e){C.extendIfRequired(a,n);}return a;}}throw new Error("Controller "+n+" couldn't be instantiated");}else{r[n]=o;}};C.prototype.getView=function(){return this.oView;};C.prototype.byId=function(i){return this.oView?this.oView.byId(i):undefined;};C.prototype.createId=function(i){return this.oView?this.oView.createId(i):undefined;};C.prototype.getOwnerComponent=function(){var a=sap.ui.requireSync("sap/ui/core/Component");return a.getOwnerComponentFor(this.getView());};C.prototype.connectToView=function(v){this.oView=v;if(this.onInit){v.attachAfterInit(this.onInit,this);}if(this.onExit){v.attachBeforeExit(this.onExit,this);}if(this.onAfterRendering){v.attachAfterRendering(this.onAfterRendering,this);}if(this.onBeforeRendering){v.attachBeforeRendering(this.onBeforeRendering,this);}};C._sExtensionProvider=null;C.registerExtensionProvider=function(e){C._sExtensionProvider=e;};return C;});
