/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/core/XMLTemplateProcessor','sap/ui/core/library','./View','sap/ui/model/resource/ResourceModel','sap/ui/base/ManagedObject','sap/ui/core/Control','sap/ui/core/RenderManager','sap/ui/core/cache/CacheManager','jquery.sap.xml','jquery.sap.script'],function(q,X,l,V,R,M,C,a,b){"use strict";var c=a.RenderPrefixes,d=l.mvc.ViewType;var f=V.extend("sap.ui.core.mvc.XMLView",{metadata:{library:"sap.ui.core",specialSettings:{containingView:{type:'sap.ui.core.mvc.XMLView',visibility:'hidden'},xmlNode:{type:'Element',visibility:'hidden'},cache:'Object'},designTime:true}});sap.ui.xmlview=function(i,e){return sap.ui.view(i,e,d.XML);};f._sType=d.XML;f.asyncSupport=true;function v(e){if(e.parseError.errorCode!==0){var P=e.parseError;throw new Error("The following problem occurred: XML parse Error for "+P.url+" code: "+P.errorCode+" reason: "+P.reason+" src: "+P.srcText+" line: "+P.line+" linepos: "+P.linepos+" filepos: "+P.filepos);}}function g(o,S){if(!S){throw new Error("mSettings must be given");}else if(S.viewName&&S.viewContent){throw new Error("View name and view content are given. There is no point in doing this, so please decide.");}else if((S.viewName||S.viewContent)&&S.xmlNode){throw new Error("View name/content AND an XML node are given. There is no point in doing this, so please decide.");}else if(!(S.viewName||S.viewContent)&&!S.xmlNode){throw new Error("Neither view name/content nor an XML node is given. One of them is required.");}else if(S.cache&&!(S.cache.keys&&S.cache.keys.length)){throw new Error("No cache keys provided. At least one is required.");}}function h(o,S){o.mProperties["viewContent"]=S.viewContent;var e=q.sap.parseXML(S.viewContent);v(e);return e.documentElement;}function s(o,S){if((o._resourceBundleName||o._resourceBundleUrl)&&(!S.models||!S.models[o._resourceBundleAlias])){var e=new R({bundleName:o._resourceBundleName,bundleUrl:o._resourceBundleUrl,bundleLocale:o._resourceBundleLocale});o.setModel(e,o._resourceBundleAlias);}}function j(o){o.oAfterRenderingNotifier=new y();o.oAfterRenderingNotifier.addDelegate({onAfterRendering:function(){o.onAfterRenderingBeforeChildren();}});}function k(S){var e=sap.ui.require("sap/ui/core/Component"),o;while(S&&e){var i=e.getOwnerComponentFor(S);if(i){S=o=i;}else{if(S instanceof e){o=S;}S=S.getParent&&S.getParent();}}return o;}function m(o,e){var i=k(o),z=i?JSON.stringify(i.getManifest()):null,F=r(o,i);F=F.concat(u(),t(o),e.keys);return p(o,F).then(function(K){return{key:K+"("+q.sap.hashCode(z||"")+")",componentManifest:z,additionalData:e.additionalData};});}function n(K){return K;}function p(o,F){return Promise.all(F).then(function(K){if(K.every(n)){return K.join('_');}else{var e=new Error("Provided cache keys may not be empty or undefined.");o.oAsyncState.complete(e);throw e;}});}function r(o,e){var i=e&&e.getMetadata().getName();return[i||window.location.host+window.location.pathname,o.getId(),sap.ui.getCore().getConfiguration().getLanguageTag()];}function t(e){var P=V._mPreprocessors["XML"],i=e.getPreprocessorInfo(true),F=[];function z(o){if(o.preprocessor.getCacheKey){F.push(o.preprocessor.getCacheKey(i));}}for(var T in P){P[T].forEach(z);}return F;}function u(){return sap.ui.getVersionInfo({async:true}).then(function(i){return i.buildTimestamp;});}function w(e,i){var K=e.key;delete e.key;e.xml=q.sap.serializeXML(i);return b.set(K,e);}function x(e){return b.get(e.key).then(function(i){if(i&&i.componentManifest==e.componentManifest){i.xml=q.sap.parseXML(i.xml,"application/xml").documentElement;if(i.additionalData){q.extend(true,e.additionalData,i.additionalData);}return i;}});}f.prototype.initViewSettings=function(S){var e=this,_;function i(E){e._xContent=E;if(V._supportInfo){V._supportInfo({context:e._xContent,env:{caller:"view",viewinfo:q.extend(true,{},e),settings:q.extend(true,{},S||{}),type:"xmlview"}});}if(!e.isSubView()){X.parseViewAttributes(E,e,S);}else{delete S.controller;}s(e,S);j(e);}function o(E,F){if(e.hasPreprocessor("viewxml")){X.enrichTemplateIds(E,e);return e.runPreprocessor("viewxml",E,!F);}return E;}function z(E){return e.runPreprocessor("xml",E).then(function(E){return o(E,true);});}function A(D){return q.sap.loadResource(D,{async:true}).then(function(E){return E.documentElement;});}function B(D,E){return m(e,E).then(function(F){return x(F).then(function(G){if(!G){return A(D).then(z).then(function(H){w(F,H);return H;});}else{return G.xml;}});});}this._oContainingView=S.containingView||this;if(this.oAsyncState){this.oAsyncState.suppressPreserve=true;}g(this,S);if(S.viewName){var D=q.sap.getResourceName(S.viewName,".view.xml");if(S.async){if(S.cache){return B(D,S.cache).then(i);}else{return A(D).then(z).then(i);}}else{_=q.sap.loadResource(D).documentElement;}}else if(S.viewContent){_=h(this,S);}else if(S.xmlNode){_=S.xmlNode;}if(S.async){return z(_).then(i);}else{_=this.runPreprocessor("xml",_,true);_=o(_);i(_);}};f.prototype.exit=function(){if(this.oAfterRenderingNotifier){this.oAfterRenderingNotifier.destroy();}V.prototype.exit.apply(this,arguments);};f.prototype.onControllerConnected=function(o){var e=this;M.runWithPreprocessors(function(){e._aParsedContent=X.parseTemplate(e._xContent,e);if(e.oAsyncState){delete e.oAsyncState.suppressPreserve;}},{settings:this._fnSettingsPreprocessor});};f.prototype.getControllerName=function(){return this._controllerName;};f.prototype.isSubView=function(){return this._oContainingView!=this;};f.prototype.onAfterRenderingBeforeChildren=function(){if(this._$oldContent.length!==0){var e=this.getAggregation("content");if(e){for(var i=0;i<e.length;i++){var o=e[i].getDomRef()||q.sap.domById(c.Invisible+e[i].getId());if(o){q.sap.byId(c.Dummy+e[i].getId(),this._$oldContent).replaceWith(o);}}}q.sap.byId(c.Dummy+this.getId()).replaceWith(this._$oldContent);}this._$oldContent=undefined;};f.prototype._onChildRerenderedEmpty=function(o,e){q(e).replaceWith('<div id="'+c.Dummy+o.getId()+'" class="sapUiHidden"/>');return true;};f.registerPreprocessor=function(T,P,S,o,e){T=T.toUpperCase();if(f.PreprocessorType[T]){V.registerPreprocessor(f.PreprocessorType[T],P,this.getMetadata().getClass()._sType,S,o,e);}else{q.sap.log.error("Preprocessor could not be registered due to unknown sType \""+T+"\"",this.getMetadata().getName());}};f.PreprocessorType={XML:"xml",VIEWXML:"viewxml",CONTROLS:"controls"};var y=C.extend("sap.ui.core.mvc.XMLAfterRenderingNotifier",{metadata:{library:"sap.ui.core"},renderer:function(o,e){o.write("");}});f.registerPreprocessor("xml","sap.ui.core.util.XMLPreprocessor",true,true);return f;});
