/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/base/EventProvider','./Plugin','sap/ui/Device','jquery.sap.dom','jquery.sap.encoder','jquery.sap.script'],function(q,E,P,D){"use strict";var S=E.extend("sap.ui.core.support.Support",{constructor:function(T){if(!_){throw Error();}E.apply(this);var d=this;this._sType=T;this._sLocalOrigin=window.location.protocol+"//"+window.location.host;var h=q.proxy(this._receiveEvent,this);if(window.addEventListener){window.addEventListener("message",h,false);}else{window.attachEvent("onmessage",h);}switch(T){case t.APPLICATION:this._isOpen=false;this.attachEvent(m.TEAR_DOWN,function(e){d._isOpen=false;if(D.browser.msie){q.sap.byId(I+"-frame").remove();}else{c(d._oRemoteWindow);}d._oRemoteWindow=null;S.exitPlugins(d,false);});this.attachEvent(m.SETUP,function(e){d._isOpen=true;S.initPlugins(d,false);});break;case t.IFRAME:this._oRemoteWindow=window.parent;this._sRemoteOrigin=q.sap.getUriParameters().get("sap-ui-xx-support-origin");this.openSupportTool();q(window).bind("unload",function(e){c(d._oOpenedWindow);});break;case t.TOOL:this._oRemoteWindow=window.opener;this._sRemoteOrigin=q.sap.getUriParameters().get("sap-ui-xx-support-origin");q(window).bind("unload",function(e){d.sendEvent(m.TEAR_DOWN);S.exitPlugins(d,true);});q(function(){S.initPlugins(d,true).then(function(){d.sendEvent(m.SETUP);});});break;}}});var t={APPLICATION:"APPLICATION",IFRAME:"IFRAME",TOOL:"TOOL"};var m={SETUP:"sapUiSupportSetup",TEAR_DOWN:"sapUiSupportTeardown"};S.StubType=t;S.EventType=m;S.TOOL_SIDE_PLUGINS=["sap.ui.core.support.plugins.TechInfo","sap.ui.core.support.plugins.ControlTree","sap.ui.core.support.plugins.ViewInfo","sap.ui.core.support.plugins.Debugging","sap.ui.core.support.plugins.Trace","sap.ui.core.support.plugins.Performance","sap.ui.core.support.plugins.MessageTest","sap.ui.core.support.plugins.Interaction"];S.APP_SIDE_PLUGINS=["sap.ui.core.support.plugins.TechInfo","sap.ui.core.support.plugins.ControlTree","sap.ui.core.support.plugins.Trace","sap.ui.core.support.plugins.Performance","sap.ui.core.support.plugins.Selector","sap.ui.core.support.plugins.Breakpoint","sap.ui.core.support.plugins.LocalStorage","sap.ui.core.support.plugins.Interaction"];S.getStub=function(T){if(a){return a;}if(T!=t.APPLICATION&&T!=t.IFRAME&&T!=t.TOOL){T=t.APPLICATION;}_=true;a=new S(T);_=false;return a;};S.prototype.getType=function(){return this._sType;};S.prototype._receiveEvent=function(e){var d=e.data;if(typeof d==="string"&&d.indexOf("SAPUI5SupportTool*")===0){d=d.substr(18);}else{return;}if(e.source!=this._oRemoteWindow){return;}this._oRemoteOrigin=e.origin;if(this._sType===t.IFRAME){var f=this;setTimeout(function(){f._oOpenedWindow.sap.ui.core.support.Support.getStub(t.TOOL)._receiveEvent({source:window,data:e.data,origin:f._sLocalOrigin});},0);}else{var o=JSON.parse(d);var s=o.eventId;var p=o.params;this.fireEvent(s,p);}};S.prototype.sendEvent=function(e,p){if(!this._oRemoteWindow){return;}p=p?p:{};if(D.browser.msie&&this._sType===t.TOOL){this._oRemoteWindow.sap.ui.core.support.Support.getStub(t.IFRAME).sendEvent(e,p);}else{var d=p;if(D.browser.msie){d={};q.extend(true,d,p);}var o={"eventId":e,"params":d};var s="SAPUI5SupportTool*"+JSON.stringify(o);this._oRemoteWindow.postMessage(s,this._sRemoteOrigin);}};S.prototype.openSupportTool=function(){var T=q.sap.getModulePath("sap.ui.core.support","/support.html");var p="?sap-ui-xx-noless=true&sap-ui-xx-support-origin="+q.sap.encodeURL(this._sLocalOrigin);var B;if(this._sType===t.APPLICATION){var o=q.sap.domById("sap-ui-bootstrap");if(o){var r=q.sap.getModulePath('./');var s=o.getAttribute('src');if(typeof s==='string'&&s.indexOf(r)===0){B=s.substr(r.length);}}}else if(this._sType===t.IFRAME){B=q.sap.getUriParameters().get("sap-ui-xx-support-bootstrap");}if(B&&B!=='sap-ui-core.js'&&B.indexOf('/')===-1){p+="&sap-ui-xx-support-bootstrap="+q.sap.encodeURL(B);}function d(u){return(u.indexOf(".")==0||u.indexOf("/")==0||u.indexOf("://")<0);}if(this._sType===t.APPLICATION){if(!this._isOpen){if(D.browser.msie){var i=q.sap.getModulePath("sap.ui.core.support","/msiebridge.html");g().html("").append("<iframe id=\""+I+"-frame\" src=\""+i+p+"\" onload=\"sap.ui.core.support.Support._onSupportIFrameLoaded();\"></iframe>");this._sRemoteOrigin=d(i)?this._sLocalOrigin:i;}else{this._oRemoteWindow=b(T+p);this._sRemoteOrigin=d(T)?this._sLocalOrigin:T;}}}else if(this._sType===t.IFRAME){this._oOpenedWindow=b(T+p);}};S._onSupportIFrameLoaded=function(){a._oRemoteWindow=q.sap.byId(I+"-frame")[0].contentWindow;};S.prototype.toString=function(){return"sap.ui.core.support.Support";};var _=false;var a;var I="sap-ui-support";function g(){var $=q.sap.byId(I);if($.length===0){$=q("<DIV/>",{id:I}).addClass("sapUiHidden").appendTo(document.body);}return $;}function b(u){return window.open(u,"sapUiSupportTool","width=800,height=700,status=no,toolbar=no,menubar=no,resizable=yes,location=no,directories=no,scrollbars=yes");}function c(W){if(!W){return;}try{W.close();}catch(e){}}S.initPlugins=function(s,T){return new Promise(function(r,d){var p=T?S.TOOL_SIDE_PLUGINS:S.APP_SIDE_PLUGINS;var e=[],f=[],i;for(i=0;i<p.length;i++){if(typeof p[i]==="string"){e.push(q.sap.getResourceName(p[i],''));f.push(i);}}sap.ui.require(e,function(){var i,j,F;for(var j=0;j<arguments.length;j++){F=arguments[j];i=f[j];p[i]=new F(s);if(s.getType()===t.TOOL){w(p[i]);}}for(i=0;i<p.length;i++){if(p[i]instanceof P){p[i].init(s);}}r();});});};S.exitPlugins=function(s,T){var p=T?S.TOOL_SIDE_PLUGINS:S.APP_SIDE_PLUGINS;for(var i=0;i<p.length;i++){if(p[i]instanceof P){p[i].exit(s,T);}}};function w(p){p.$().replaceWith("<div  id='"+p.getId()+"-Panel' class='sapUiSupportPnl'><h2 id='"+p.getId()+"-PanelHeader' class='sapUiSupportPnlHdr'>"+p.getTitle()+"<div id='"+p.getId()+"-PanelHandle' class='sapUiSupportPnlHdrHdl sapUiSupportPnlHdrHdlClosed'></div></h2><div id='"+p.getId()+"-PanelContent' class='sapUiSupportPnlCntnt sapUiSupportHidden'><div id='"+p.getId()+"' class='sapUiSupportPlugin'></div></div></div>");p.$("PanelHeader").click(function(){var h=p.$("PanelHandle");if(h.hasClass("sapUiSupportPnlHdrHdlClosed")){h.removeClass("sapUiSupportPnlHdrHdlClosed");p.$("PanelContent").removeClass("sapUiSupportHidden");}else{h.addClass("sapUiSupportPnlHdrHdlClosed");p.$("PanelContent").addClass("sapUiSupportHidden");}});}S.initializeSupportMode=function(s){if(s.indexOf("true")>-1||s.indexOf("viewinfo")>-1){S.initializeSupportInfo();}};S.initializeSupportInfo=function(){var s=[],d=[],e=[],f="support:data",h="support",j="http://schemas.sap.com/sapui5/extension/sap.ui.core.support.Support.info/1",k={};function l(){if(window.localStorage){window.localStorage.setItem("sap-ui-support.aSupportInfosBreakpoints/"+window.document.location.href,JSON.stringify(d));}}function p(){if(window.localStorage){window.localStorage.setItem("sap-ui-support.aSupportXMLModifications/"+window.document.location.href,JSON.stringify(e));}}if(window.localStorage){var v=window.localStorage.getItem("sap-ui-support.aSupportInfosBreakpoints/"+window.document.location.href);if(v){d=JSON.parse(v);}var v=window.localStorage.getItem("sap-ui-support.aSupportXMLModifications/"+window.document.location.href);if(v){e=JSON.parse(v);}}S.info=function(i){i._idx=s.length;if(i._idx>0&&!i.context){i.context=s[s.length-1].context;}if(!i.context){q.sap.log.debug("Support Info does not have a context and is ignored");return i;}if(i.context&&i.context.ownerDocument&&i.context.nodeType===1){var v=i._idx+"";if(!i.context.hasAttributeNS(j,"data")){i.context.setAttribute("xmlns:"+h,j);}else{v=i.context.getAttributeNS(j,"data")+","+v;}i.context.setAttributeNS(j,f,v);}s.push(i);if(d.indexOf(i._idx)>-1){q.sap.log.info(i);q.sap.log.info("To remove this breakpoint execute:","\nsap.ui.core.support.Support.info.removeBreakpointAt("+i._idx+")");debugger;}return i._idx;};S.info.getAll=function(C){if(C===undefined){return s;}else{return s.filter(function(o){return(o.env&&o.env.caller===C);});}};S.info.getInfos=function(n){if(n&&typeof n==="string"){n=n.split(",");}else{n=[];}var r=[];for(var i=0;i<n.length;i++){if(s[n[i]]){r.push(s[n[i]]);}}return r;};S.info.byIndex=function(i){return s[i];};S.info.getAllBreakpoints=function(){return d;};S.info.hasBreakpointAt=function(i){return d.indexOf(i)>-1;};S.info.addBreakpointAt=function(i){if(d.indexOf(i)>-1){return;}d.push(i);l();};S.info.removeBreakpointAt=function(i){var n=d.indexOf(i);if(n>-1){d.splice(n,1);l();}};S.info.removeAllBreakpoints=function(){d=[];l();};S.info.addSupportInfo=function(i,n){if(i&&n){if(k[i]){k[i]+=","+n;}else{k[i]=n;}}};S.info.byId=function(i){return k[i]||null;};S.info.getIds=function(i){var o=[];for(var n in k){var r=k[n];if(r&&r.indexOf(i)>-1){o.push(n);}}return o;};S.info.getElements=function(i){var C=[];for(var n in k){var o=k[n];if(o&&o.indexOf(i)===0){var r=sap.ui.getCore().byId(n);if(r){C.push(sap.ui.getCore().byId(n));}}}return C;};S.info.getAllXMLModifications=function(){return e;};S.info.hasXMLModifications=function(){return e.length>0;};S.info.addXMLModification=function(i,n,C){e.push({id:i,idx:n,change:C});p();};S.info.removeXMLModification=function(i){var n=e.indexOf(i);if(n>-1){e.splice(n,1);p();}};S.info.removeAllXMLModification=function(){e=[];p();};S.info.modifyXML=function(n,x){if(!S.info.hasXMLModifications()){return;}var N=x;if(!N||!N.nodeType||!(N.nodeType==1||N.nodeType==9)){return;}if(N.nodeType===9){N=N.firstChild;}var o=N.querySelectorAll("*");var r=[N];for(var i=0;i<o.length;i++){r.push(o[i]);}for(var i=0;i<e.length;i++){var M=e[i],C=M.change;if(M.id===n){var u=r[M.idx];if(u.nodeType===1&&C.setAttribute){var O=u.getAttribute(C.setAttribute[0]);u.setAttribute(C.setAttribute[0],C.setAttribute[1]);if(!u._modified){u._modified=[];}u._modified.push(C.setAttribute[0]);if(!u._oldValues){u._oldValues=[];}u._oldValues.push(O);}}}};S.info._breakAtProperty=function(K){return function(o){if(o.getParameter("name")===K){debugger;}};};S.info._breakAtMethod=function(i){return function(){debugger;return i.apply(this,arguments);};};q.sap.require("sap.ui.core.mvc.View");sap.ui.core.mvc.View._supportInfo=sap.ui.core.support.Support.info;q.sap.require("sap.ui.base.ManagedObject");sap.ui.base.ManagedObject._supportInfo=sap.ui.core.support.Support.info;q.sap.require("sap.ui.core.XMLTemplateProcessor");sap.ui.core.XMLTemplateProcessor._supportInfo=sap.ui.core.support.Support.info;q.sap.require("sap.ui.thirdparty.datajs");if(window.datajs){window.datajs._sap={_supportInfo:sap.ui.core.support.Support.info};}q.sap.log.info("sap.ui.core.support.Support.info initialized.");};return S;});
