/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/thirdparty/URI','../Element'],function(q,U,E){"use strict";var P={};var p=null;var t=null;var a=[];var r=/url[\s]*\('?"?([^\'")]*)'?"?\)/;function b(){p=null;}function c(u,T){var M=r.exec(u);if(M){var o=new U(M[1]);if(o.is("relative")){var N=o.absoluteTo(T).normalize().path();u="url('"+N+"')";}}return u;}function m(C,N,T){for(var s in N){if(typeof C[s]==="undefined"){C[s]=c(N[s],T);}}return C;}function d(N,T){if(typeof N["default"]!=="object"){N={"default":N,"scopes":{}};}p=p||{};p["default"]=p["default"]||{};p["scopes"]=p["scopes"]||{};m(p["default"],N["default"],T);if(typeof N["scopes"]==="object"){for(var s in N["scopes"]){p["scopes"][s]=p["scopes"][s]||{};m(p["scopes"][s],N["scopes"][s],T);}}}function f(C){q("link[id^=sap-ui-theme-]").each(function(){C(this.getAttribute("id"),this.href);});if(q.sap._mIEStyleSheets){for(var i in q.sap._mIEStyleSheets){if(i.indexOf("sap-ui-theme-")===0){var s=q.sap._mIEStyleSheets[i];if(typeof s.href==="string"){C(i,s.href);}}}}}function l(i,s){var T=new U(s).filename("").query("").toString();var $=q.sap.byId(i);if($.length>0&&q.sap.getUriParameters().get("sap-ui-xx-no-inline-theming-parameters")!=="true"){var D=$.css("background-image");var k=/\(["']data:text\/plain;utf-8,(.*)["']\)$/i.exec(D);if(k&&k.length>=2){var o=k[1];if(o.charAt(0)!=="{"&&o.charAt(o.length-1)!=="}"){try{o=decodeURI(o);}catch(u){q.sap.log.warning("Could not decode theme parameters URI from "+x);}}try{var v=q.parseJSON(o);d(v,T);return;}catch(u){q.sap.log.warning("Could not parse theme parameters from "+x+". Loading library-parameters.json as fallback solution.");}}}var R,w;var x=s.replace(/\/library([^\/.]*)\.(?:css|less)($|[?#])/,function(y,z,A){return"/library-parameters.json"+(A?A:"");});R=q.sap.sjax({url:x,dataType:'json'});if(R.success){w=R.data;if(q.isArray(w)){for(var j=0;j<w.length;j++){var v=w[j];d(v,T);}}else{d(w,T);}}else{q.sap.log.error("Could not load theme parameters from: "+x,R.error);}}function g(){if(!p){d({},"");t=sap.ui.getCore().getConfiguration().getTheme();f(l);}return p;}function e(){a.forEach(function(i){l("sap-ui-theme-"+i.id,i.url);});a=[];}P._addLibraryTheme=function(T,C){if(p){a.push({id:T,url:C});}};function h(o){var i=g();if(o.scopeName){i=i["scopes"][o.scopeName];}else{i=i["default"];}var s=i[o.parameterName];if(typeof s==="undefined"&&typeof o.parameterName==="string"){var I=o.parameterName.indexOf(":");if(I!==-1){o.parameterName=o.parameterName.substr(I+1);}s=i[o.parameterName];}if(o.loadPendingParameters&&typeof s==="undefined"){e();s=h({parameterName:o.parameterName,scopeName:o.scopeName,loadPendingParameters:false});}return s;}function n(s,S){for(var i=0;i<S.length;i++){var C=S[i];for(var k=0;k<C.length;k++){var j=C[k];var o=h({parameterName:s,scopeName:j});if(o){return o;}}}return h({parameterName:s});}P._getScopes=function(A){if(A&&!p){return;}var o=g();var s=Object.keys(o["scopes"]);return s;};P.getActiveScopesFor=function(o){var s=[];if(o instanceof E){var i=o.getDomRef();e();var S=this._getScopes();if(i){var N=function(j){var k=i.classList;return k&&k.contains(j);};while(i){var F=S.filter(N);if(F.length>0){s.push(F);}i=i.parentNode;}}else{var C=function(j){return typeof o.hasStyleClass==="function"&&o.hasStyleClass(j);};while(o){var F=S.filter(C);if(F.length>0){s.push(F);}o=typeof o.getParent==="function"&&o.getParent();}}}return s;};P.get=function(N,o){var s;if(arguments.length===0){e();var k=g();return q.extend({},k["default"]);}if(!N){return undefined;}if(o instanceof E){e();var S=this.getActiveScopesFor(o);if(typeof N==="string"){return n(N,S);}else if(Array.isArray(N)){var u={};for(var j=0;j<N.length;j++){var v=N[j];u[v]=n(v,S);}return u;}}else{if(typeof N==="string"){s=h({parameterName:N,loadPendingParameters:true});return s;}else if(Array.isArray(N)){var u={};for(var i=0;i<N.length;i++){var v=N[i];u[v]=P.get(v);}return u;}}};P._setOrLoadParameters=function(L){p={"default":{},"scopes":{}};t=sap.ui.getCore().getConfiguration().getTheme();f(function(i,H){var s=i.substr(13);if(L[s]){q.extend(p["default"],L[s]);}else{l(i,H);}});};P.reset=function(){var o=arguments[0]===true;if(!o||sap.ui.getCore().getConfiguration().getTheme()!==t){b();}};P._getThemeImage=function(s,F){s=s||"sapUiGlobalLogo";var i=P.get(s);if(i){var j=r.exec(i);if(j){i=j[1];}else if(i==="''"||i==="none"){i=null;}}if(!!F&&!i){return sap.ui.resource('sap.ui.core','themes/base/img/1x1.gif');}return i;};return P;},true);
