/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/base/BindingParser','sap/ui/base/ManagedObject','sap/ui/core/XMLTemplateProcessor','sap/ui/Device','sap/ui/model/BindingMode','sap/ui/model/CompositeBinding','sap/ui/model/Context'],function(q,B,M,X,D,a,C,b){'use strict';var u={},N="http://schemas.sap.com/sapui5/extension/sap.ui.core.template/1",x="sap.ui.core.util.XMLPreprocessor",p=[x],P=x+"/insertFragment",s=x+"/getResolvedBinding",c=x+".process",v={},W=M.extend("sap.ui.core.util._with",{metadata:{properties:{any:"any"},aggregations:{child:{multiple:false,type:"sap.ui.core.util._with"}}}}),R=W.extend("sap.ui.core.util._repeat",{metadata:{aggregations:{list:{multiple:true,type:"n/a",_doesNotRequireFactory:true}}},updateList:function(){}});function d(w,S,i,j){function k(n){if(!j){j=w.getBinding("any");if(j instanceof C){j=j.getBindings();if(i!==undefined){j=j[i];}}}return Array.isArray(j)?j[n]:j;}function m(o){return o instanceof b?o.getPath():o.getModel().resolve(o.getPath(),o.getContext());}return{getInterface:function(n,o){var t,y,z;if(typeof n==="string"){o=n;n=undefined;}k();if(Array.isArray(j)){if(n>=0&&n<j.length){y=j[n];}else{throw new Error("Invalid index of part: "+n);}}else if(n!==undefined){throw new Error("Not the root formatter of a composite binding");}else if(o){y=j;}else{throw new Error("Missing path");}if(o){z=y.getModel();if(o.charAt(0)!=='/'){t=y instanceof b?y:z.createBindingContext(y.getPath(),y.getContext());}y=z.createBindingContext(o,t);if(!y){throw new Error("Model could not create binding context synchronously: "+z);}}return d(null,S,undefined,y);},getModel:function(n){var o=k(n);return o&&o.getModel();},getPath:function(n){var o=k(n);return o&&m(o);},getSetting:function(n){if(n==="bindingContexts"||n==="models"){throw new Error("Illegal argument: "+n);}return S[n];}};}function g(w,o,S){function j(I,i){var F=I.formatter;I.mode=a.OneTime;if(F&&F.requiresIContext===true){I.formatter=F.bind(null,d(w,S,i));}}try{j(o);if(o.parts){o.parts.forEach(j);}w.bindProperty("any",o);return w.getBinding("any")?w.getAny():u;}finally{w.unbindProperty("any",true);}}function e(E,L){return E.namespaceURI===N&&l(E)===L;}function l(E){return E.localName||E.baseName;}function r(E){var m=E.getAttribute("template:require");if(m){q.sap.require.apply(q.sap,m.split(" "));}}function f(E){var A,o=E.attributes,t="<"+E.nodeName,i,n;for(i=0,n=o.length;i<n;i+=1){A=o.item(i);t+=" "+A.name+'="'+A.value+'"';}return t+(E.childNodes.length?">":"/>");}function h(E,i){i.visitNode(E);}return{plugIn:function(V,n,L){var o=v[n];if(V!==null&&typeof V!=="function"||V===h){throw new Error("Invalid visitor: "+V);}if(!n||n===N||n==="sap.ui.core"||n.indexOf(" ")>=0){throw new Error("Invalid namespace: "+n);}q.sap.log.debug("Plug-in visitor for namespace '"+n+"', local name '"+L+"'",V,x);if(L){n=n+" "+L;o=v[n]||o;}v[n]=V;return o||h;},visitNodeWrapper:h,process:function(o,V,S){var j=V.caller,k=q.sap.log.isLoggable(q.sap.log.Level.DEBUG),m=k,t=V.name,F={},w,y=0,z={},A=V._supportInfo,E=q.sap.log.isLoggable(q.sap.log.Level.WARNING);function G(i){return{getContext:function(n){var i1,j1,k1;n=n||"";if(n[0]==="{"){throw new Error("Must be a simple path, not a binding: "+n);}i1=B.simpleParser("{"+n+"}");j1=i.getModel(i1.model);if(!j1){throw new Error("Unknown model '"+i1.model+"': "+n);}k1=j1.resolve(i1.path,i.getBindingContext(i1.model));if(!k1){throw new Error("Cannot resolve path: "+n);}return j1.createBindingContext(k1);},getResult:function(n,i1){var j1=Q(n,i1,i,true);if(j1===u){throw new Error("Binding not ready: "+n);}return j1;},getSettings:function(){return S;},getViewInfo:function(){return q.extend(true,{},V);},insertFragment:function(n,i1){T(n,i1,i);},visitAttributes:function(n){e1(n,i);},visitChildNodes:function(n){f1(n,i);},visitNode:function(n){g1(n,i);},"with":function(n,i1){var j1,k1=false,w,l1=new W();if(!i1){i.setChild(l1);}for(w in n){j1=n[w];k1=true;l1.setModel(j1.getModel(),w);l1.bindObject({model:w,path:j1.getPath()});}return k1||i1?G(l1):this;}};}function H(i){if(k){q.sap.log.debug(L()+Array.prototype.slice.call(arguments,1).join(" "),i&&f(i),x);}}function I(i){if(k){q.sap.log.debug(L()+"Finished","</"+i.nodeName+">",x);}}function J(i,n){i=i+f(n);q.sap.log.error(i,j,x);throw new Error(j+": "+i);}function K(i1){var j1=i1.childNodes,k1,l1=[],i,n,m1=false;for(i=0,n=j1.length;i<n;i+=1){k1=j1.item(i);if(k1.nodeType===1){l1.push(k1);}}if(!l1.length||!e(l1[0],"then")){return null;}for(i=1,n=l1.length;i<n;i+=1){k1=l1[i];if(m1){J("Expected </"+i1.prefix+":if>, but instead saw ",k1);}if(e(k1,"else")){m1=true;}else if(!e(k1,"elseif")){J("Expected <"+i1.prefix+":elseif> or <"+i1.prefix+":else>, but instead saw ",l1[i]);}}return l1;}function L(){return(y<10?"[ ":"[")+y+"] ";}function O(w){return w&&w.charAt(0)==="."?q.sap.getObject(w.slice(1),undefined,z):q.sap.getObject(w);}function Q(i,n,i1,j1,k1){var l1;q.sap.measure.average(s,"",p);l1=B.complexParser(i,z,j1,true,true)||i;if(l1.functionsNotFound){if(j1){h1(n,'Function name(s)',l1.functionsNotFound.join(", "),'not found');}q.sap.measure.end(s);return u;}if(typeof l1==="object"){l1=g(i1,l1,S);if(j1&&l1===u){h1(n,'Binding not ready');}}else if(k1){k1();}q.sap.measure.end(s);return l1;}function T(i,n,i1){var j1,k1=t;i1.$mFragmentContexts=i1.$mFragmentContexts||{};if(i1.$mFragmentContexts[i]){J("Cyclic reference to fragment '"+i+"' ",n);}y++;H(n,"fragmentName =",i);i1.$mFragmentContexts[i]=true;t=i;q.sap.measure.average(P,"",p);j1=F[i];if(!j1){j1=X.loadTemplate(i,"fragment");F[i]=j1;}j1=n.ownerDocument.importNode(j1,true);q.sap.measure.end(P);r(j1);if(j1.namespaceURI==="sap.ui.core"&&l(j1)==="FragmentDefinition"){U(j1,i1,n);}else{n.parentNode.insertBefore(j1,n);g1(j1,i1);}n.parentNode.removeChild(n);t=k1;i1.$mFragmentContexts[i]=false;I(n);y--;}function U(i,n,i1){var j1;i1=i1||i;f1(i,n);while((j1=i.firstChild)){i1.parentNode.insertBefore(j1,i1);}}function Y(i,n){var i1=h1.bind(null,i,'Constant test condition'),j1,k1=i.getAttribute("test"),l1;try{l1=Q(k1,i,n,true,i1);if(l1===u){l1=false;}}catch(ex){h1(i,'Error in formatter:',ex);l1=undefined;}j1=!!l1&&l1!=="false";if(k){if(typeof l1==="string"){l1=JSON.stringify(l1);}else if(l1===undefined){l1="undefined";}else if(Array.isArray(l1)){l1="[object Array]";}H(i,"test ==",l1,"-->",j1);}return j1;}function Z(i,n,i1){var j1=n.value,k1;try{k1=Q(j1,i,i1,false);if(k1===u){H(i,'Binding not ready for attribute',n.name);}else if(k1===undefined){H(i,"Removed attribute",n.name);i.removeAttribute(n.name);}else{if(k&&k1!==n.value){H(i,n.name,"=",k1);}n.value=k1;}}catch(ex){H(i,'Error in formatter:',ex);}}function $(i,n){var w=i.getAttribute("name"),i1,j1,k1=i.getAttribute("value");if(!w||w.length<=1||w.lastIndexOf(".")!==0){J("Missing proper relative name in ",i);}w=w.slice(1);i1=O(k1);if(!i1){J("Invalid value in ",i);}j1=z[w];z[w]=i1;U(i,n);i.parentNode.removeChild(i);z[w]=j1;}function _(i,n){var w=i.getAttribute("name"),i1=u,j1;try{i1=Q(w,i,n,true);if(i1!==u&&i1!==w){H(i,"name =",i1);}}catch(ex){h1(i,'Error in formatter:',ex);}var l1=sap.ui.require("sap/ui/core/CustomizingConfiguration");if(i1!==u&&l1){j1=l1.getViewExtension(t,i1,V.componentId);if(j1&&j1.className==="sap.ui.core.Fragment"&&j1.type==="XML"){T(j1.fragmentName,i,n);return true;}}return false;}function a1(i,n){var i1=i.getAttribute("fragmentName"),j1;try{j1=Q(i1,i,n,true);}catch(ex){h1(i,'Error in formatter:',ex);return;}if(j1!==u){T(j1,i,n);}}function b1(i,n){var i1=K(i),j1,k1;y++;if(i1){k1=i;j1=i1.shift();do{if(Y(k1,n)){break;}k1=j1=i1.shift();}while(k1&&l(k1)==="elseif");}else if(Y(i,n)){j1=i;}if(j1){U(j1,n,i);}i.parentNode.removeChild(i);I(i);y--;}function c1(n,i1){var j1=n.getAttribute("list")||"",k1=B.complexParser(j1,z,false,true,true),l1,m1,n1,o1,p1=n.getAttribute("var");if(p1===""){J("Missing variable name for ",n);}if(!k1){J("Missing binding for ",n);}if(k1.functionsNotFound){h1(n,'Function name(s)',k1.functionsNotFound.join(", "),'not found');}o1=new R();i1.setChild(o1);k1.mode=a.OneTime;o1.bindAggregation("list",k1);m1=o1.getBinding("list");o1.unbindAggregation("list",true);n1=k1.model;if(!m1){J("Missing model '"+n1+"' in ",n);}l1=m1.getContexts(k1.startIndex,k1.length);p1=p1||n1;o1.setModel(m1.getModel(),p1);y++;H(n,"Starting");l1.forEach(function(q1,i){var r1=(i===l1.length-1)?n:n.cloneNode(true);o1.setBindingContext(q1,p1);H(n,p1,"=",q1.getPath());U(r1,o1,n);});I(n);y--;n.parentNode.removeChild(n);}function d1(i,n){var i1,j1,k1,l1,m1=i.getAttribute("helper"),n1,o1=i.getAttribute("path"),p1,q1=i.getAttribute("var");if(q1===""){J("Missing variable name for ",i);}k1=new W();n.setChild(k1);i1=B.simpleParser("{"+o1+"}");q1=q1||i1.model;if(m1||q1){j1=n.getModel(i1.model);if(!j1){J("Missing model '"+i1.model+"' in ",i);}p1=j1.resolve(i1.path,n.getBindingContext(i1.model));if(!p1){J("Cannot resolve path for ",i);}if(m1){l1=O(m1);if(typeof l1!=="function"){J("Cannot resolve helper for ",i);}n1=l1(j1.createBindingContext(p1));if(n1 instanceof b){j1=n1.getModel();p1=n1.getPath();}else if(n1!==undefined){if(typeof n1!=="string"||n1===""){J("Illegal helper result '"+n1+"' in ",i);}p1=n1;}}k1.setModel(j1,q1);k1.bindObject({model:q1,path:p1});}else{k1.bindObject(o1);}y++;H(i,q1,"=",p1);if(k1.getBindingContext(q1)===n.getBindingContext(q1)){h1(i,'Set unchanged path:',p1);k1=n;}U(i,k1);i.parentNode.removeChild(i);I(i);y--;}function e1(n,i1){var i,j1=n.attributes;for(i=j1.length-1;i>=0;i-=1){if(A){A({context:undefined,env:{caller:"visitAttributes",before:{name:j1.item(i).name,value:j1.item(i).value}}});}Z(n,j1.item(i),i1);if(A){A({context:undefined,env:{caller:"visitAttributes",after:{name:j1.item(i).name,value:j1.item(i).value}}});}}}function f1(i1,j1){var i,k1=i1.childNodes,n=k1.length,l1=new Array(n);for(i=0;i<n;i+=1){l1[i]=k1.item(i);}k1=null;for(i=0;i<n;i+=1){g1(l1[i],j1);}}function g1(n,i){var i1,j1;if(n.nodeType!==1){return;}if(A){A({context:n,env:{caller:"visitNode",before:{name:n.tagName}}});}if(n.namespaceURI===N){switch(l(n)){case"alias":$(n,i);return;case"if":b1(n,i);return;case"repeat":c1(n,i);return;case"with":d1(n,i);return;default:J("Unexpected tag ",n);}}else if(n.namespaceURI==="sap.ui.core"){switch(l(n)){case"ExtensionPoint":if(_(n,i)){return;}break;case"Fragment":if(n.getAttribute("type")==="XML"){a1(n,i);return;}break;}}else{i1=v[n.namespaceURI+" "+l(n)]||v[n.namespaceURI];if(i1){y++;H(n,"Calling visitor");j1=i1(n,G(i));if(j1!==undefined){J("Unexpected return value from visitor for ",n);}I(n);y--;return;}}e1(n,i);f1(n,i);if(A){A({context:n,env:{caller:"visitNode",after:{name:n.tagName}}});}}function h1(i){if(E){if(!m){m=true;q.sap.log.warning("Warning(s) during processing of "+j,null,x);}q.sap.log.warning(L()+Array.prototype.slice.call(arguments,1).join(" "),i&&f(i),x);}}q.sap.measure.average(c,"",p);S=S||{};if(k){H(undefined,"Start processing",j);if(S.bindingContexts instanceof b){H(undefined,"undefined =",S.bindingContexts);}else{for(w in S.bindingContexts){H(undefined,w,"=",S.bindingContexts[w]);}}}if(A){A({context:o,env:{caller:"view",viewinfo:q.extend(true,{},V),settings:q.extend(true,{},S),clone:o.cloneNode(true),type:"template"}});}r(o);g1(o,new W({models:S.models,bindingContexts:S.bindingContexts}));H(undefined,"Finished processing",j);q.sap.measure.end(c);return o;}};},true);
