/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define('sap/ui/debug/TechnicalInfo',['jquery.sap.global','sap/ui/Device','sap/ui/Global','sap/ui/core/Popup','jquery.sap.strings'],function(q,D,G,P){"use strict";var T={open:function(c){function s(o){if(o&&window.JSON){return window.JSON.stringify(o);}if(o===""){return'""';}return""+o+(o?"???":"");}function l(o,p){p=p||'';if(!p){j.push("<table border='0' cellspacing='0' cellpadding='0'>");}q.each(o,function(i,v){if(!v||typeof v==='string'||typeof v==='number'||v instanceof Date){j.push("<tr><td>",p,"<b>",q.sap.encodeHTML(s(i)),"</b></td><td>",q.sap.encodeHTML(s(v)),"</td></tr>");}else{j.push("<tr><td>",p,"<b>",q.sap.encodeHTML(s(i)),"</b></td><td></td></tr>");l(v,p+"&nbsp;&nbsp;");}});if(!p){j.push("</table>");}}if(this._oPopup&&this._oPopup.isOpen()){return;}var a=this._ojQSData=c()||{};var C=false,L=false,e=true;var b=sap.ui.require("sap/ui/debug/DebugEnv");if(b){C=b.getInstance().isControlTreeShown();L=b.getInstance().isTraceWindowShown();e=b.getInstance().isRunningEmbedded();}var d="/sapui5-internal/download/index.jsp";var f=q.sap.syncHead(d);var O="/sapui5-sdk-dist/optimize-module-set";var g=q.sap.syncHead(O);if(!g){O="/demokit/optimize-module-set";g=q.sap.syncHead(O);}var h=window["sap-ui-debug"];var u=q.sap.statistics();var j=[];j.push("<div id='sap-ui-techinfo' class='sapUiTInf sapUiDlg' style='width:800px; position: relative;'>");j.push("<table border='0' cellpadding='3'>");try{var V=G.getVersionInfo();var k="<a href='"+sap.ui.resource("","sap-ui-version.json")+"' target='_blank' title='Open Version Info'>"+V.version+"</a>";j.push("<tr><td align='right' valign='top'><b>SAPUI5 Version</b></td><td>",k," (built at ",V.buildTimestamp,", last change ",V.scmRevision,")</td></tr>");}catch(m){j.push("<tr><td align='right' valign='top'><b>SAPUI5 Version</b></td><td>not available</td></tr>");}j.push("<tr><td align='right' valign='top'><b>Core Version</b></td><td>",G.version," (built at ",G.buildinfo.buildtime,", last change ",G.buildinfo.lastchange,")</td></tr>");j.push("<tr><td align='right' valign='top'><b>Loaded jQuery Version</b></td><td>",q.fn.jquery,"</td></tr>");j.push("<tr><td align='right' valign='top'><b>User Agent</b></td><td>",q.sap.encodeHTML(navigator.userAgent),(document.documentMode?", Document Mode '"+document.documentMode+"'":""),"</td></tr>");j.push("<tr><td align='right' valign='top'><b>Configuration</b></td><td><div class='sapUiTInfCfg'>");l(a.config);j.push("</div></td></tr>");j.push("<tr><td align='right' valign='top'><b>Loaded Modules</b></td><td><div id='sap-ui-techinfo-modules' class='sapUiTInfMList'>");this._renderModules(j,20);j.push("</div></td></tr>");if(f){j.push("<tr><td></td><td><a id=\"sap-ui-techinfo-customModule\" href=\""+d+"\">Create Custom Bootstrap Module</a></td></tr>");}if(g){j.push("<tr><td></td><td><a id=\"sap-ui-techinfo-optimizeModuleSet\" href=\""+O+"\">Calculate Optimized Module Set URL</a></td></tr>");}j.push("<tr><td align='right' valign='top' rowSpan='8'><b>Debug Tools</b></td>");j.push("<td><input id='sap-ui-techinfo-useDbgSources' type='checkbox'",h?" checked='checked'":"",'>Use <span id="sap-ui-techinfo-cfgDbgSources" class="sapUiTInfPCfg" title="Click to select packages / modules with debug sources">Debug Sources</span> (requires page reload)</td></tr>');j.push("<tr><td>Boot app with different UI5 version on next reload:</td></tr>");j.push("<tr><td style='padding-left: 2rem'><select id='sap-ui-techinfo-reboot-select' style='width: 100%;'>","<option value='none'>Disabled (no custom reboot URL)</option>","<option value='other' id='sap-ui-techinfo-reboot-other'>Other (enter URL to sap-ui-core.js below):</option>","</select></td></tr>");j.push("<tr><td style='padding-left: 2rem'><input type='text' id='sap-ui-techinfo-reboot-input' style='width: 357px;' disabled='disabled'/>","<button id='sap-ui-techinfo-reboot'>Activate Reboot URL</button></td></tr>");j.push("<tr><td><input id='sap-ui-techinfo-showControls' type='checkbox'",C?" checked='checked'":"",e?"":" readonly='readonly'","/><span ",e?"":" style='color:grey'",">Show UIAreas, Controls and Properties</span></td></tr>");j.push("<tr><td><input id='sap-ui-techinfo-showLogViewer' type='checkbox' ",L?" checked='checked'":"",e?"":" readonly='readonly' style='color:grey'","/><span ",e?"":" style='color:grey'",">Show Log Viewer</span></td></tr>");j.push("<tr><td><input id='sap-ui-techinfo-useStatistics' type='checkbox' ",u?" checked='checked'":"","/><span ",">Enable SAP-statistics for oData calls</span></td></tr>");j.push("<tr><td colspan='2' align='center' valign='bottom' height='40'><button id='sap-ui-techinfo-close' class='sapUiBtn sapUiBtnS sapUiBtnNorm sapUiBtnStd'>Close</button></td></tr>");j.push("</table>");if(f){j.push("<form id=\"sap-ui-techinfo-submit\" target=\"_blank\" method=\"post\" action=\""+d+"\">");j.push("<input type=\"hidden\" name=\"modules\"/>");j.push("</form>");}if(g){j.push("<form id=\"sap-ui-techinfo-optimize-submit\" target=\"_blank\" method=\"post\" action=\""+O+"\">");j.push("<input type=\"hidden\" name=\"version\"/>");j.push("<input type=\"hidden\" name=\"libs\"/>");j.push("<input type=\"hidden\" name=\"modules\"/>");j.push("</form>");}j.push("</div>");this._$Ref=q(j.join(""));this._$Ref.find('#sap-ui-techinfo-useDbgSources').click(this.onUseDbgSources.bind(this));this._$Ref.find('#sap-ui-techinfo-cfgDbgSources').click(this.onConfigDbgSources.bind(this));this._$Ref.find('#sap-ui-techinfo-reboot').click(this.onUseOtherUI5Version.bind(this));this._$Ref.find('#sap-ui-techinfo-reboot-select').on("change",this.onUI5VersionDropdownChanged);this._$Ref.find('#sap-ui-techinfo-showControls').click(this.onShowControls.bind(this));this._$Ref.find('#sap-ui-techinfo-showLogViewer').click(this.onShowLogViewer.bind(this));this._$Ref.find('#sap-ui-techinfo-more').click(this.onShowAllModules.bind(this));this._$Ref.find('#sap-ui-techinfo-close').click(this.close.bind(this));this._$Ref.find('#sap-ui-techinfo-customModule').click(this.onCreateCustomModule.bind(this));this._$Ref.find('#sap-ui-techinfo-optimizeModuleSet').click(this.onOptimizeModuleSet.bind(this));this._$Ref.find('#sap-ui-techinfo-useStatistics').click(this.onUseStatistics.bind(this));this._oPopup=new P(this._$Ref.get(0),true,true,false);this._oPopup.attachOpened(function(E){this._$().css("z-index","1000000");});this._oPopup.open(400);this.populateRebootUrls();},close:function(){this._oPopup.destroy();this._oPopup=undefined;this._$Ref.remove();this._$Ref=undefined;this._ojQSData=undefined;},_renderModules:function(h,l){var C={"5":" sapUiTInfMFail"};var m=this._ojQSData.modules;var c=[];q.each(m,function(n,o){if(o.state>0){c.push(n);}});c.sort();var M=(l&&c.length>l)?c.length-l:0;if(M){c.sort(function(a,b){if(a===b){return 0;}var i=m[a].url?1:0;var d=m[b].url?1:0;if(i!=d){return d-i;}return a<b?-1:1;});c=c.slice(0,l);}q.each(c,function(i,v){var a=m[v];h.push("<span"," title='",a.url?q.sap.encodeHTML(a.url):("embedded in "+a.parent),"'"," class='sapUiTInfM",C[a.state]||"","'>",v,",</span> ");});if(M){h.push("<span id='sap-ui-techinfo-more' title='Show all modules' class='sapUiTInfMMore'>...("+M+" more)</span>");}},onShowAllModules:function(e){var h=[];this._renderModules(h,0);this._$Ref.find("[id=sap-ui-techinfo-modules]").html(h.join(""));},onCreateCustomModule:function(e){e.preventDefault();e.stopPropagation();var m=[];q.each(this._ojQSData.modules,function(i,v){m.push(i);});m.sort();q("input[name='modules']",this._$Ref).attr("value",m.join(","));q("form",this._$Ref)[0].submit();},onOptimizeModuleSet:function(e){e.preventDefault();e.stopPropagation();var l=[];q.each(sap.ui.getCore().getLoadedLibraries(),function(i,v){l.push(i);});var m=[];q.each(this._ojQSData.modules,function(n,M){if(M.state>=0){m.push(n);}});m.sort();var f=q("#sap-ui-techinfo-optimize-submit",this._$Ref);q("input[name='version']",f).attr("value","2.0");q("input[name='libs']",f).attr("value",l.join(","));q("input[name='modules']",f).attr("value",m.join(","));f[0].submit();},ensureDebugEnv:function(s){if(!this._DebugEnv){try{this._DebugEnv=sap.ui.requireSync("sap/ui/debug/DebugEnv");if(!s){this._DebugEnv.getInstance().hideControlTree();this._DebugEnv.getInstance().hidePropertyList();}}catch(e){return false;}}return true;},onShowControls:function(e){if(e.target.readOnly){e.preventDefault();e.stopPropagation();return;}if(this.ensureDebugEnv(true)){if(e.target.checked){this._DebugEnv.getInstance().showControlTree();this._DebugEnv.getInstance().showPropertyList();}else{this._DebugEnv.getInstance().hideControlTree();this._DebugEnv.getInstance().hidePropertyList();}}},onShowLogViewer:function(e){if(e.target.readOnly){e.preventDefault();e.stopPropagation();return;}if(this.ensureDebugEnv(false)){if(e.target.checked){this._DebugEnv.getInstance().showTraceWindow();}else{this._DebugEnv.getInstance().hideTraceWindow();}}},onUseDbgSources:function(e){var d=window["sap-ui-debug"]=!!e.target.checked;q.sap.debug(d);},onConfigDbgSources:function(e){var n={};function s(N,v){N=N==='/'?'':N;var o=n,a=N.split('/'),l=a.length,i;if(l>0){for(i=0;o&&i<l-1;i++){if(!o[a[i]]){o[a[i]]={};}o=o[a[i]];}o[a[l-1]]=v;}}function g(N){N=N==='/'?'':N;var o=n,a=N.split('/'),l=a.length,i;if(l>0){for(i=0;o&&i<l-1;i++){if(!o[a[i]]){return;}o=o[a[i]];}return o[a[l-1]];}}function t(a){function b(N,B,o){var C,i;if(typeof o==='object'){if(o['']){F.push(N+'/');return;}C=Object.keys(o);i=C.length;}if(i){C.forEach(function(j){if(j===''){return;}if(o[j]===true){F.push((N?N+'/':'')+j);}else if(typeof o[j]==='object'){b((N?N+'/':'')+j,j,o[j]);}});}}if(g('/')){return true;}var F=[];b('','',n);return F.join(a||',');}function m(a){if(!/\/\*\*\/$/.test(a)){a=a.replace(/\/$/,'/**/');}return a.replace(/\*\*\/|\*|[[\]{}()+?.\\^$|]/g,function(M){switch(M){case'**/':return'(?:[^/]+/)*';case'*':return'[^/]*';default:return'\\'+M;}});}var c=this._ojQSData.modules;q.each(c,function(N,M){s(N,false);});var d=window["sap-ui-debug"];if(d===true){s('/',true);}else if(d&&typeof d==='string'){d.split(/,/).forEach(function(a){if(/\*/.test(a)){var b=new RegExp("^(?:"+m(a)+")");q.each(c,function(N,M){if(b.test(N)){s(N,true);}});}else{s(a,true);}});}var h=[];h.push('<div class="sapUiTInfPDiag">');h.push('<h1>Select packages/modules that should be loaded as debug sources:</h1>');h.push('<div id="sap-ui-techinfo-packages" class="sapUiTInfPList">');function r(N,B,o){var C,i,j;if(typeof o==='object'){C=Object.keys(o);i=C.length;}j=N+(i?"/":"");h.push('<div class="',i?'package':'module',g(j)?' selected':'','" data-sap-ui-package="',q.sap.encodeHTML(j),'">');if(i){h.push('<span class="expander">&gt;</span>');}h.push('<span class="name">',q.sap.encodeHTML(B),'</span>');if(i){h.push('<div class="children packages">');C.sort(function(a,b){var k=typeof o[a]==='object';var l=typeof o[b]==='object';if(k!==l){return k?-1:1;}if(a!==b){return a<b?-1:1;}return 0;}).forEach(function(a){if(a===''){return;}r((N?N+'/':'')+a,a,o[a]);});h.push('</div>');}h.push('</div>');}r('','(all)',n);h.push('</div>');h.push('<div class="result"><strong>sap-ui-debug = </strong><span id="sap-ui-techinfo-packages-result">',q.sap.encodeHTML(String(d||'')),'</span></div>');h.push('<div class="footer">');h.push("<button id='sap-ui-techinfo-pdiag-close' class='sapUiBtn sapUiBtnS sapUiBtnNorm sapUiBtnStd'>Ok</button>");h.push("<button id='sap-ui-techinfo-pdiag-cancel' class='sapUiBtn sapUiBtnS sapUiBtnNorm sapUiBtnStd'>Cancel</button>");h.push("<span></span>");h.push("<button id='sap-ui-techinfo-pdiag-reset' class='sapUiBtn sapUiBtnS sapUiBtnNorm sapUiBtnStd'>Reset</button>");h.push('</div>');h.push('</div>');var p=q(h.join(""));this._oPopupModules=new P(p[0],true,true,false);this._oPopupModules.attachOpened(function(E){this._$().css("z-index","1000100");});this._oPopupModules.open(400);function u(){p.find("#sap-ui-techinfo-packages-result").text(t(", "));}function f(){this._oPopupModules.destroy();this._oPopupModules=undefined;p.remove();}p.find("#sap-ui-techinfo-pdiag-reset").click(function(e){q(".selected",this._oPopupModules._$()).each(function(){s(q(this).attr("data-sap-ui-package"),false);}).removeClass("selected");u();}.bind(this));p.find("#sap-ui-techinfo-pdiag-cancel").click(function(e){f.call(this);}.bind(this));p.find("#sap-ui-techinfo-pdiag-close").click(function(e){d=t();f.call(this);q.sap.debug(d);window["sap-ui-debug"]=d;this._$Ref.find('#sap-ui-techinfo-useDbgSources').prop('checked',!!d);}.bind(this));p.find("#sap-ui-techinfo-packages").click(function(e){var $=q(e.target);if($.hasClass("expander")){var a=q(e.target.nextElementSibling.nextElementSibling);if(a.hasClass("none")){a.removeClass("none");if(a.children(".package").length>0){a.addClass("packages");$.text(">");}else{a.addClass("all");$.text(">>");}}else if(a.hasClass("packages")){a.removeClass("packages");a.addClass("all");$.text(">>");}else if(a.hasClass("all")){a.removeClass("all");a.addClass("none");$.text("+");}}else if($.hasClass("name")){var b=q(e.target.parentNode);b.toggleClass("selected");s(b.attr('data-sap-ui-package'),b.hasClass("selected"));u();}});},populateRebootUrls:function(){var u,U,m=this.mRebootUrls={"https://openui5.hana.ondemand.com/resources/sap-ui-core.js":"OpenUI5 latest stable version","https://openui5beta.hana.ondemand.com/resources/sap-ui-core.js":"OpenUI5 PREVIEW version","https://openui5.hana.ondemand.com/1.32.9/resources/sap-ui-core.js":"OpenUI5 1.32.9","https://openui5.hana.ondemand.com/1.30.11/resources/sap-ui-core.js":"OpenUI5 1.30.11","https://openui5.hana.ondemand.com/1.28.24/resources/sap-ui-core.js":"OpenUI5 1.28.24","https://sapui5.hana.ondemand.com/sdk/resources/sap-ui-core.js":"SAPUI5 latest stable version","https://sapui5.hana.ondemand.com/1.32.8/resources/sap-ui-core.js":"SAPUI5 1.32.8","https://sapui5.hana.ondemand.com/1.30.10/resources/sap-ui-core.js":"SAPUI5 1.30.10","https://sapui5.hana.ondemand.com/1.28.23/resources/sap-ui-core.js":"SAPUI5 1.28.23","http://localhost:8080/testsuite/resources/sap-ui-core.js":"Localhost (port 8080), /testsuite ('grunt serve' URL)","http://localhost:8080/sapui5/resources/sap-ui-core.js":"Localhost (port 8080), /sapui5 (maven URL)"};try{u=window.localStorage.getItem("sap-ui-reboot-URLs");U=u.split(" ");}catch(e){}for(var i in U){var s=U[i];if(!m[s]){m[s]=q.sap.encodeHTML(s);}}var o=q("#sap-ui-techinfo-reboot-other");function c(s){return function(){var h="<option value='"+s+"'>"+m[s]+"</option>";o.before(h);};}for(var s in m){q.ajax({type:"HEAD",async:true,url:s,success:c(s)});}},onUI5VersionDropdownChanged:function(){var r=q("#sap-ui-techinfo-reboot-select").val(),i=q("#sap-ui-techinfo-reboot-input");if(r==="other"){i.removeAttr("disabled");}else{i.attr("disabled","disabled");if(r==="none"){i.val("");}else{i.val(r);}}},onUseOtherUI5Version:function(){var r=q("#sap-ui-techinfo-reboot-select").val();if(r==="other"){r=q("#sap-ui-techinfo-reboot-input").val();}if(!r||r==="none"){q.sap.setReboot(null);alert("Reboot URL cleared. App will start normally.");}else{q.sap.setReboot(r);if(!this.mRebootUrls[r]){try{var u=window.localStorage.getItem("sap-ui-reboot-URLs");var U=u?u.split(" "):[];if(q.inArray(r,U)===-1){U.push(r.replace(/ /g,"%20"));window.localStorage.setItem("sap-ui-reboot-URLs",U.join(" "));}}catch(e){q.sap.log.error("sgsrg");}}}},onUseStatistics:function(e){q.sap.statistics(!!e.target.checked);}};return T;},true);
