/*
 * ! UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/base/ManagedObject','sap/ui/dt/ElementUtil'],function(M,E){"use strict";var a=M.extend("sap.ui.dt.ManagedObjectObserver",{metadata:{"abstract":true,library:"sap.ui.dt",properties:{},associations:{target:{type:"sap.ui.base.ManagedObject"}},events:{modified:{parameters:{type:"string",name:"string",value:"any",oldValue:"any",target:"sap.ui.core.Element"}},destroyed:{}}}});a.prototype.init=function(){var t=this;this._fnFireModified=function(){t.fireModified();};};a.prototype.exit=function(){this.unobserve();delete this._fnFireModified;};a.prototype.setTarget=function(t){this.unobserve();this.setAssociation("target",t);var T=this.getTargetInstance();if(T){this.observe(T);}return this;};a.prototype.observe=function(t){var b=this;t.attachEvent("_change",this._fnFireModified,this);var o=this._fnOriginalDestroy=t.destroy;var d=false;t.destroy=function(){if(d){return;}b.unobserve();var O=o.apply(this,arguments);b.fireDestroyed();return O;};this._fnOriginalBindProperty=t.bindProperty;t.bindProperty=function(){var O=b._fnOriginalBindProperty.apply(this,arguments);b.fireModified();return O;};this._fnOriginalUnBindProperty=t.unbindProperty;t.unbindProperty=function(){var O=b._fnOriginalUnBindProperty.apply(this,arguments);b.fireModified();return O;};this._fnOriginalBindAggregation=t.bindAggregation;t.bindAggregation=function(s){var O=b._fnOriginalBindAggregation.apply(this,arguments);b.fireModified();return O;};this._fnOriginalUnBindAggregation=t.unbindAggregation;t.unbindAggregation=function(s){var O=b._fnOriginalUnBindAggregation.apply(this,arguments);b.fireModified();return O;};this._fnOriginalSetParent=t.setParent;t.setParent=function(p,s,S){var f=false;if(!this._bInSetParent){f=true;this._bInSetParent=true;}var c=this.getParent();var O=b._fnOriginalSetParent.apply(this,arguments);if(f&&!this.__bSapUiDtSupressParentChangeEvent){this._bInSetParent=false;if(c!==p){b.fireModified({type:"setParent",value:p,oldValue:c,target:this});}}return O;};this._fnOriginalAddAggregation=t.addAggregation;t.addAggregation=function(s,O,S){b._bAddOrSetAggregationCall=true;var v=b._fnOriginalAddAggregation.apply(this,arguments);b.fireModified({type:"addOrSetAggregation",name:s,value:O,target:this});return v;};this._fnOriginalSetAggregation=t.setAggregation;t.setAggregation=function(s,O,S){b._bAddOrSetAggregationCall=true;var v=b._fnOriginalSetAggregation.apply(this,arguments);b.fireModified({type:"addOrSetAggregation",name:s,value:O,target:this});return v;};this._fnOriginalRemoveAggregation=t.removeAggregation;t.removeAggregation=function(s,O,S){b._bRemoveAggregationCall=true;var v=b._fnOriginalRemoveAggregation.apply(this,arguments);b.fireModified({type:"removeAggregation",name:s,value:O,target:this});return v;};this._fnOriginalInsertAggregation=t.insertAggregation;t.insertAggregation=function(s,O,i,S){b._bInsertAggregationCall=true;var v=b._fnOriginalInsertAggregation.apply(this,arguments);b.fireModified({type:"insertAggregation",name:s,value:O,target:this});return v;};this._fnOriginalRemoveAllAggregation=t.removeAllAggregation;t.removeAllAggregation=function(s,S){b._bRemoveAllAggregationCall=true;var r=this.getAggregation(s);var O=b._fnOriginalRemoveAllAggregation.apply(this,arguments);b.fireModified({type:"removeAllAggregation",name:s,value:r,target:this});return O;};this._fnOriginalDestroyAggregation=t.destroyAggregation;t.destroyAggregation=function(s,S){b._bDestroyAggregationCall=true;var r=this.getAggregation(s);var O=b._fnOriginalDestroyAggregation.apply(this,arguments);b.fireModified({type:"destroyAggregation",name:s,value:r,target:this});return O;};b._aOriginalAddMutators={};b._aOriginalInsertMutators={};b._aOriginalRemoveMutators={};b._aOriginalRemoveAllMutators={};b._aOriginalDestructors={};var A=t.getMetadata().getAllAggregations();Object.keys(A).forEach(function(s){var c=A[s];var _=t[c._sMutator];b._aOriginalAddMutators[c.name]=_;t[c._sMutator]=function(O){b._bAddOrSetAggregationCall=false;var v;v=_.apply(this,arguments);if(!b._bAddOrSetAggregationCall){b.fireModified({type:"addOrSetAggregation",name:c.name,value:O,target:this});}return v;};var e=t[c._sInsertMutator];b._aOriginalInsertMutators[c.name]=e;t[c._sInsertMutator]=function(O,i){b._bInsertAggregationCall=false;var v;v=e.apply(this,arguments);if(!b._bInsertAggregationCall){b.fireModified({type:"insertAggregation",name:c.name,value:O,target:this});}return v;};var f=t[c._sRemoveMutator];b._aOriginalRemoveMutators[c.name]=f;t[c._sRemoveMutator]=function(O,S){b._bRemoveAggregationCall=false;var v=f.apply(this,arguments);if(!b._bRemoveAggregationCall){b.fireModified({type:"removeAggregation",name:c.name,value:O,target:this});}return v;};var g=t[c._sRemoveAllMutator];b._aOriginalRemoveAllMutators[c.name]=g;t[c._sRemoveAllMutator]=function(S){b._bRemoveAllAggregationCall=false;var r=this.getAggregation(s);var O=g.apply(this,arguments);if(!b._bRemoveAllAggregationCall){b.fireModified({type:"removeAllAggregation",name:c.name,value:r,target:this});}return O;};var h=t[c._sDestructor];b._aOriginalDestructors[c.name]=h;t[c._sDestructor]=function(S){b._bDestroyAggregationCall=false;var r=this.getAggregation(s);var O=h.apply(this,arguments);if(!b._bDestroyAggregationCall){b.fireModified({type:"destroyAggregation",name:c.name,value:r,target:this});}return O;};});};a.prototype.unobserve=function(){var t=this;var T=this.getTargetInstance();if(T){T.destroy=this._fnOriginalDestroy;T.bindProperty=this._fnOriginalBindProperty;T.unbindProperty=this._fnOriginalUnBindProperty;T.bindAggregation=this._fnOriginalBindAggregation;T.unbindAggregation=this._fnOriginalUnBindAggregation;T.setParent=this._fnOriginalSetParent;T.addAggregation=this._fnOriginalAddAggregation;T.removeAggregation=this._fnOriginalRemoveAggregation;T.insertAggregation=this._fnOriginalInsertAggregation;T.setAggregation=this._fnOriginalSetAggregation;T.removeAllAggregation=this._fnOriginalRemoveAllAggregation;T.destroyAggregation=this._fnOriginalDestroyAggregation;var A=T.getMetadata().getAllAggregations();Object.keys(A).forEach(function(s){var o=A[s];T[o._sMutator]=t._aOriginalAddMutators[o.name];T[o._sInsertMutator]=t._aOriginalInsertMutators[o.name];T[o._sRemoveMutator]=t._aOriginalRemoveMutators[o.name];T[o._sRemoveAllMutator]=t._aOriginalRemoveAllMutators[o.name];T[o._sDestructor]=t._aOriginalDestructors[o.name];});T.detachEvent("_change",this._fnFireModified,this);}delete this._fnOriginalDestroy;delete this._fnOriginalBindProperty;delete this._fnOriginalUnBindProperty;delete this._fnOriginalBindAggregation;delete this._fnOriginalUnBindAggregation;delete this._fnOriginalSetParent;delete this._fnOriginalAddAggregation;delete this._fnOriginalRemoveAggregation;delete this._fnOriginalInsertAggregation;delete this._fnOriginalSetAggregation;delete this._fnOriginalRemoveAllAggregations;delete this._fnOriginalDestroyAggregation;delete this._aOriginalAddMutators;delete this._aOriginalInsertMutators;delete this._aOriginalRemoveMutators;delete this._aOriginalRemoveAllMutators;delete this._aOriginalDestructors;};a.prototype.getTargetInstance=function(){return sap.ui.getCore().byId(this.getTarget());};return a;},true);
