/*
 * ! UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/dt/Plugin','sap/ui/dt/plugin/ElementMover','sap/ui/dt/OverlayUtil'],function(P,E,O){"use strict";var C=P.extend("sap.ui.dt.plugin.CutPaste",{metadata:{library:"sap.ui.dt",properties:{movableTypes:{type:"string[]",defaultValue:["sap.ui.core.Element"]},elementMover:{type:"sap.ui.dt.plugin.ElementMover"}},associations:{},events:{elementMoved:{}}}});C.prototype.init=function(){this.setElementMover(new E());};C.prototype.registerElementOverlay=function(o){var e=o.getElementInstance();o.attachBrowserEvent("keydown",this._onKeyDown,this);if(this.getElementMover().isMovableType(e)&&this.getElementMover().checkMovable(o)){o.setMovable(true);}if(this.getElementMover().getMovedOverlay()){this.getElementMover().activateTargetZonesFor(this.getElementMover().getMovedOverlay());}};C.prototype.deregisterElementOverlay=function(o){o.setMovable(false);o.detachBrowserEvent("keydown",this._onKeyDown,this);if(this.getElementMover().getMovedOverlay()){this.getElementMover().deactivateTargetZonesFor(this.getElementMover().getMovedOverlay());}};C.prototype.setMovableTypes=function(m){this.getElementMover().setMovableTypes(m);return this.setProperty("movableTypes",m);};C.prototype.setElementMover=function(e){e.setMovableTypes(this.getMovableTypes());return this.setProperty("elementMover",e);};C.prototype.getCuttedOverlay=function(){return this.getElementMover().getMovedOverlay();};C.prototype.isElementPasteable=function(t){var T=this._getTargetZoneAggregation(t);if((T)||(O.isInTargetZoneAggregation(t))){return true;}else{return false;}};C.prototype._onKeyDown=function(e){var o=sap.ui.getCore().byId(e.currentTarget.id);if((e.keyCode===jQuery.sap.KeyCodes.X)&&(e.shiftKey===false)&&(e.altKey===false)&&(e.ctrlKey===true)){this.cut(o);e.stopPropagation();}else if((e.keyCode===jQuery.sap.KeyCodes.V)&&(e.shiftKey===false)&&(e.altKey===false)&&(e.ctrlKey===true)){this.paste(o);e.stopPropagation();}else if(e.keyCode===jQuery.sap.KeyCodes.ESCAPE){this.stopCutAndPaste();e.stopPropagation();}};C.prototype.cut=function(o){this.stopCutAndPaste();if(o.isMovable()){this.getElementMover().setMovedOverlay(o);o.addStyleClass("sapUiDtOverlayCutted");this.getElementMover().activateAllValidTargetZones(this.getDesignTime());}};C.prototype.paste=function(t){var c=this.getElementMover().getMovedOverlay();if(!c){return;}if(!this._isForSameElement(c,t)){var T=this._getTargetZoneAggregation(t);if(T){this.getElementMover().insertInto(c,T);}else if(O.isInTargetZoneAggregation(t)){this.getElementMover().repositionOn(c,t);}else{return;}this.fireElementModified({"command":this.getElementMover().buildMoveEvent()});}setTimeout(function(){c.focus();},0);this.stopCutAndPaste();};C.prototype.stopCutAndPaste=function(){var c=this.getElementMover().getMovedOverlay();if(c){c.removeStyleClass("sapUiDtOverlayCutted");this.getElementMover().setMovedOverlay(null);this.getElementMover().deactivateAllTargetZones(this.getDesignTime());}};C.prototype._isForSameElement=function(c,t){return t.getElementInstance()===c.getElementInstance();};C.prototype._getTargetZoneAggregation=function(t){var a=t.getAggregationOverlays();var p=a.filter(function(A){return A.isTargetZone();});if(p.length>0){return p[0];}else{return null;}};return C;},true);
