/*
 * SAP UI development toolkit for HTML5 (SAPUI5)

        (c) Copyright 2009-2016 SAP SE. All rights reserved
    
 */
sap.ui.define(["jquery.sap.global","./transaction/BaseController","./transaction/TransactionController","sap/ui/generic/app/util/ModelUtil"],function(q,B,T,M){"use strict";var A=B.extend("sap.ui.generic.app.ApplicationController",{constructor:function(m,v){B.apply(this,[m]);this._oGroupChanges={};this.sName="sap.ui.generic.app.ApplicationController";this._initModel(m);this.registerView(v);}});A.prototype.propertyChanged=function(e,p,b,c){var t=this,f,P={batchGroupId:"Changes",changeSetId:"Changes",binding:b,onlyIfPending:true,noShowResponse:true,noBlockUI:true,draftSave:true};f=c.getInnerControls()[0].getFieldGroupIds();if(f){f.forEach(function(i){t.registerGroupChange(i);});}return new Promise(function(r,a){setTimeout(function(){t.triggerSubmitChanges(P).then(function(R){r(R);},function(E){a(E);});});});};A.prototype.registerGroupChange=function(g){this._oGroupChanges[g]=true;};A.prototype.registerView=function(v){var t=this;if(v){this._oView=v;this._fnAttachValidateFieldGroup=function(e){var I,o,l,i,a=[];var b=this.getBindingContext();if(!b){return false;}if(!t.getTransactionController().getDraftController().getDraftContext().hasDraft(b)){this.detachValidateFieldGroup(t._fnAttachValidateFieldGroup);return false;}if(e.mParameters.fieldGroupIds){l=e.mParameters.fieldGroupIds.length;}for(i=0;i<l;i++){I=e.mParameters.fieldGroupIds[i];o=t._oView.data(I);if(o){a.push({uuid:I,objid:o});}}t._onValidateFieldGroup(a);};v.attachValidateFieldGroup(this._fnAttachValidateFieldGroup);}};A.prototype._initModel=function(m){m.setDefaultBindingMode(sap.ui.model.BindingMode.TwoWay);m.setRefreshAfterChange(false);m.setDeferredBatchGroups(["Changes"]);m.setChangeBatchGroups({"*":{batchGroupId:"Changes",changeSetId:"Changes",single:false}});};A.prototype._onValidateFieldGroup=function(g){var i,l=g.length,r,R={bGlobal:false,aRequests:[]};for(i=0;i<l;i++){this._executeFieldGroup(g[i],R);}l=R.aRequests.length;for(i=0;i<l;i++){r=R.aRequests[i];r(R.bGlobal);}if(R.bGlobal){this._oModel.refresh(true,false,"Changes");}var p=this.triggerSubmitChanges({batchGroupId:"Changes",changeSetId:"Changes",noShowSuccessToast:true,forceSubmit:true,noBlockUI:true,urlParameters:{},draftSave:this._oModel.hasPendingChanges()});this.fireEvent("beforeSideEffectExecution",{promise:p,valueChange:R.bValueChange,validationMessage:R.bValidationMessage,fieldControl:R.bFieldControl});return p;};A.prototype._executeFieldGroup=function(g,r){var c,s,p={batchGroupId:"Changes",changeSetId:"Changes",noShowSuccessToast:true,forceSubmit:true,noBlockUI:true,urlParameters:{}};p.urlParameters.SideEffectsQualifier=g.objid.name.replace("com.sap.vocabularies.Common.v1.SideEffects","");if(p.urlParameters.SideEffectsQualifier.indexOf("#")===0){p.urlParameters.SideEffectsQualifier=p.urlParameters.SideEffectsQualifier.replace("#","");}c=this._oModel.getContext(g.objid.context);s=this._getSideEffect(g.objid);if(this._hasClientErrors(g.uuid)){return false;}if(!this._oGroupChanges[g.uuid]&&!this._oModel.hasPendingChanges()){return false;}this._oGroupChanges[g.uuid]=false;this._executeSideEffects(s,c,p,r);return true;};A.prototype._executeSideEffectsForActions=function(s,c){var r;var C="_it/";var R={bGlobal:false,aRequests:[]};var p={batchGroupId:"Changes",changeSetId:"Changes",noShowSuccessToast:true,forceSubmit:true,noBlockUI:true,urlParameters:{}};if(s.TargetEntities&&s.TargetEntities.length){for(var i=0;i<s.TargetEntities.length;i++){if(s.TargetEntities[i].NavigationPropertyPath.indexOf(C)===0){s.TargetEntities[i].NavigationPropertyPath=s.TargetEntities[i].NavigationPropertyPath.substr(4);}}}if(s.TargetProperties&&s.TargetProperties.length){for(var i=0;i<s.TargetProperties.length;i++){if(s.TargetProperties[i].PropertyPath.indexOf(C)===0){s.TargetProperties[i].PropertyPath=s.TargetProperties[i].PropertyPath.substr(4);}}}for(var i=0;i<c.length;i++){this._executeSideEffects(s,c[i],p,R);if(R.aRequests[0]){r=R.aRequests[0];r(R.bGlobal);R.aRequests=[];}}if(R.bGlobal){this._oModel.refresh(true,false,"Changes");}};A.prototype._executeSideEffects=function(s,c,p,r){var t=this,f,m,a={"ValidationMessage":"validateDraft","ValueChange":"prepareDraft"};if(!s.EffectTypes||!s.EffectTypes.EnumMember){s.EffectTypes={EnumMember:"ValueChange"};}if(t.getTransactionController().getDraftController().getDraftContext().hasDraft(c)){m=a[s.EffectTypes.EnumMember];}r.bValueChange=s.EffectTypes.EnumMember==="ValueChange"?true:r.bValueChange;r.bValidationMessage=s.EffectTypes.EnumMember==="ValidationMessage"?true:r.bValidationMessage;r.bFieldControl=s.EffectTypes.EnumMember==="FieldControlChange"?true:r.bFieldControl;this._setSelect(s,p,r,c);f=function(g){if(m){t.getTransactionController().getDraftController()[m](c,p);}if(!g){t._read(c.getPath(),p);}};r.aRequests.push(f);};A.prototype._hasClientErrors=function(g){var i,l,c,C;C=this._oView.getControlsByFieldGroupId(g);if(C){l=C.length;for(i=0;i<l;i++){c=C[i];if(c&&c.getParent){c=c.getParent();if(c&&c.checkClientError&&c.checkClientError()){return true;}}}}return false;};A.prototype._setSelect=function(s,p,r,c){var i,l=0,t,S=[],e=[],a=[],n;if(!r.bGlobal){if((!s.TargetEntities||s.TargetEntities.length===0)&&(!s.TargetProperties||s.TargetProperties.length===0)){r.bGlobal=true;return;}if(s.TargetEntities){l=s.TargetEntities.length;if(l>0){for(i=0;i<l;i++){t=s.TargetEntities[i];if(t.NavigationPropertyPath===""){S.push('*');}else{S.push(t.NavigationPropertyPath);if(e.indexOf(t.NavigationPropertyPath)===-1){e.push(t.NavigationPropertyPath);}}a.push(t.NavigationPropertyPath);}}}if(s.TargetProperties){l=s.TargetProperties.length;if(l>0){for(i=0;i<l;i++){t=s.TargetProperties[i];n="";if(t.PropertyPath.indexOf("/")!==-1){var E=M.getEntitySetFromContext(c);var m=this._oModel.getMetaModel();var b=m.getODataEntitySet(E).entityType;var o=m.getODataEntityType(b);var P=t.PropertyPath.split("/");var d;if(P.length>1){for(var j=0;j<(P.length-1);j++){d=m.getODataAssociationEnd(o,P[j]);if(d){o=m.getODataEntityType(d.type);if(n){n=n+"/";}n=n+P[j];}else{break;}}}}if(a.indexOf(n)===-1){if(n&&e.indexOf(n)===-1){e.push(n);}S.push(t.PropertyPath);}}}}}if(S.length>0){p.readParameters=["$select="+S.join(",")];if(e.length>0){p.readParameters.push("$expand="+e.join(','));}}};A.prototype._getSideEffect=function(i){var m,r,s,f;m=this._oModel.getMetaModel();s="getOData"+i.originType.substring(0,1).toUpperCase()+i.originType.substring(1);if(i.originNamespace){f=i.originNamespace+"."+i.originName;}else{f=i.originName;}if(m[s]){r=m[s](f);if(r){return r[i.name];}}throw"Unknown SideEffect originType: "+i.originType;};A.prototype.getTransactionController=function(){if(!this._oTransaction){this._oTransaction=new T(this._oModel,this._oQueue,{noBatchGroups:true});}return this._oTransaction;};A.prototype.invokeActions=function(f,c,P){var C,i,l,a,b=[],s;P=P||{};l=c.length;a=this._getChangeSetFunc(f,c,P.operationGrouping);if(l===0){b.push(this._invokeAction(f,null,null,P));}else{for(i=0;i<l;i++){b.push(this._invokeAction(f,c[i],a(i),P));}}var F=this._oModel.getMetaModel().getODataFunctionImport(f);for(var p in F){if(q.sap.startsWith(p,"com.sap.vocabularies.Common.v1.SideEffects")){s=F[p];break;}}if(s){this._executeSideEffectsForActions(s,c);}P={batchGroupId:"Changes",changeSetId:"Changes"+a(i+1),successMsg:"Call of action succeeded",failedMsg:"Call of action failed",forceSubmit:true,context:C};b.push(this.triggerSubmitChanges(P));return this._newPromiseAll(b).then(function(r){if(r&&r.length>c.length){r.pop();}var i,d=false;if(c.length<=r.length){var i;for(i=0;i<c.length;i++){r[i].actionContext=c[i];if(!r[i].error){d=true;}}if(c.length===0){for(i=0;i<r.length;i++){if(!r[i].error){d=true;}}}}if(d){return r;}else{return Promise.reject(r);}});};A.prototype.executeSideEffects=function(c,s,S){var o,n,P,e,r,Q;var g=!s&&!S;var R={bGlobal:false,aRequests:[]};var m={batchGroupId:"Changes",changeSetId:"Changes",noShowSuccessToast:true,forceSubmit:true,noBlockUI:true,urlParameters:{}};var E=M.getEntitySetFromContext(c);var a=c.getModel().getMetaModel();var b=a.getODataEntitySet(E).entityType;var d=a.getODataEntityType(b);S=S||[];s=s||[];var f=function(o){if(Q){m.urlParameters.SideEffectsQualifier=Q;}else{delete m.urlParameters.SideEffectsQualifier;}this._executeSideEffects(o,c,m,R);if(R.aRequests[0]){r=R.aRequests[0];r(R.bGlobal);R.aRequests=[];}}.bind(this);for(var p in d){if(q.sap.startsWith(p,"com.sap.vocabularies.Common.v1.SideEffects")){o=d[p];e=false;Q=p.replace("com.sap.vocabularies.Common.v1.SideEffects","");if(Q.indexOf("#")===0){Q=Q.replace("#","");}if(g){if(!o.SourceProperties&&!o.SourceEntities){f(o);e=true;break;}}else{if(o.SourceEntities&&o.SourceEntities.length){for(var i=0;i<o.SourceEntities.length;i++){n=o.SourceEntities[i].NavigationPropertyPath;if(S.indexOf(n)!==-1){e=true;}}}if(!e&&o.SourceProperties&&o.SourceProperties.length){for(var i=0;i<o.SourceProperties.length;i++){P=o.SourceProperties[i].PropertyPath;if(s.indexOf(P)!==-1){e=true;}}}if(e){f(o);}}}}if(R.bGlobal||(g&&!e)){if(g){f({});}this._oModel.refresh(true,false,"Changes");}var h=this.triggerSubmitChanges({batchGroupId:"Changes",changeSetId:"Changes",noShowSuccessToast:true,forceSubmit:true,noBlockUI:true,urlParameters:{},draftSave:this._oModel.hasPendingChanges()});this.fireEvent("beforeSideEffectExecution",{promise:h,valueChange:R.bValueChange,validationMessage:R.bValidationMessage,fieldControl:R.bFieldControl});return h;};A.prototype._newPromiseAll=function(p){var r=[];var R=Promise.resolve(null);p.forEach(function(P){R=R.then(function(){return P;}).then(function(o){r.push({response:o});},function(e){r.push({error:e});});});return R.then(function(){return Promise.resolve(r);});};A.prototype._getChangeSetFunc=function(f,c,o){var l=c.length;var s=function(){return"Changes";};if(l===1){return s;}if(o==="com.sap.vocabularies.UI.v1.OperationGroupingType/ChangeSet"){return s;}return function(i){return"Changes"+i;};};A.prototype.getNewActionContext=function(f,e,p){var t=this;p=q.extend({batchGroupId:"Changes",changeSetId:"SingleAction",successMsg:"Call of action succeeded",failedMsg:"Call of action failed",forceSubmit:true,context:e,functionImport:this._oMeta.getODataFunctionImport(f.split("/")[1])},p);var F=this._createFunctionContext(e,p);F.result=F.result.then(function(r){return t._normalizeResponse(r,true);},function(r){var o=t._normalizeError(r);throw o;});return F;};A.prototype.submitActionContext=function(a,f){var s;var F=this._oModel.getMetaModel().getODataFunctionImport(f);for(var p in F){if(q.sap.startsWith(p,"com.sap.vocabularies.Common.v1.SideEffects")){s=F[p];break;}}if(s){this._executeSideEffectsForActions(s,[a]);}this.triggerSubmitChanges({batchGroupId:"Changes",changeSetId:"SingleAction",successMsg:"Call of action succeeded",failedMsg:"Call of action failed",forceSubmit:true,context:a});};A.prototype._invokeAction=function(f,c,C,p){var t=this,p={batchGroupId:"Changes",changeSetId:C,successMsg:"Call of action succeeded",failedMsg:"Call of action failed",urlParameters:p.urlParameters,forceSubmit:true,context:c};return this._callAction(f,c,p).then(function(r){return t._normalizeResponse(r,true);},function(r){var o=t._normalizeError(r);throw o;});};A.prototype.destroy=function(){B.prototype.destroy.apply(this,[]);if(this._oTransaction){this._oTransaction.destroy();}this._oView=null;this._oModel=null;this._oTransaction=null;this._oGroupChanges=null;};return A;},true);
