/*
 * ! SAP UI development toolkit for HTML5 (SAPUI5)

        (c) Copyright 2009-2016 SAP SE. All rights reserved
    
 */
sap.ui.define(["jquery.sap.global","sap/ui/base/ManagedObject","sap/m/MessageBox","sap/ui/layout/form/SimpleForm","sap/ui/comp/smartform/Group","sap/ui/comp/smartform/GroupElement","sap/ui/comp/smartfield/SmartField","sap/ui/comp/smartfield/SmartLabel","sap/m/Dialog","sap/ui/generic/app/util/ModelUtil","sap/m/VBox","sap/m/Text"],function(q,M,a,S,G,b,c,d,D,e,V,T){"use strict";var A=M.extend("sap.ui.generic.app.util.ActionUtil",{metadata:{properties:{controller:{type:"object",group:"Misc",defaultValue:null},applicationController:{type:"object",group:"Misc",defaultValue:null},contexts:{type:"object",group:"Misc",defaultValue:null},successCallback:{type:"function",group:"Misc",defaultValue:null},operationGrouping:{type:"string",group:"Misc",defaultValue:null}}}});A.prototype.call=function(f,F){var t=this;return new Promise(function(r,g){var m;t._oActionPromiseCallback={resolve:r,reject:g};t._sFunctionImportPath=f;var C=t.getController();if(!C){throw new Error("Controller not provided");}t._oMetaModel=C.getView().getModel().getMetaModel();var s=f.split('/')[1];t._oFunctionImport=t._oMetaModel.getODataFunctionImport(s);t._sFunctionImportLabel=F||s;if(!t._oFunctionImport){throw new Error("Unknown Function Import "+s);}if(t._isActionCritical()){var h=sap.ui.getCore().getLibraryResourceBundle("sap.ui.generic.app").getText("ACTION_CONFIRM");h=q.sap.formatMessage(h,t._sFunctionImportLabel);a.confirm(h,{title:t._sFunctionImportLabel,onClose:function(o){if(o==="OK"){m=t._prepareParameters();t._initiateCall(m);}else if(o==="CANCEL"){t._oActionPromiseCallback.resolve(null);}},sClass:t._getCompactModeStyleClass()});}else{m=t._prepareParameters();t._initiateCall(m);}});};A.prototype._getCompactModeStyleClass=function(){if(this.getController().getView().$().closest(".sapUiSizeCompact").length){return"sapUiSizeCompact";}return"";};A.prototype._isActionCritical=function(){var C=this._oFunctionImport["com.sap.vocabularies.Common.v1.IsActionCritical"];if(!C){return false;}if(C.Bool===undefined){return true;}return this._toBoolean(C.Bool);};A.prototype._toBoolean=function(p){if(typeof p==="string"){var v=p.toLowerCase();return!(v=="false"||v==""||v==" ");}return!!p;};A.prototype._prepareParameters=function(){var s;if(q.isArray(this.getContexts())&&this.getContexts().length!=1){return;}else{s=this.getContexts()[0];}this._oContextObject=s.getObject();var E=this._getEntityType(s);var k=this._getPropertyKeys(E);var p;var m={parameterData:{},additionalParameters:[]};if(this._oFunctionImport.parameter){for(var i=0;i<this._oFunctionImport.parameter.length;i++){var P=this._oFunctionImport.parameter[i];this._addParameterLabel(P,E);var f=P.name;var I=!!k[f];p=undefined;if(this._oContextObject.hasOwnProperty(f)){p=this._oContextObject[f];}else if(I){q.sap.log.error("Key parameter of action not found in current context: "+f);throw new Error("Key parameter of action not found in current context: "+f);}m.parameterData[f]=p;if(!I&&P.mode.toUpperCase()=="IN"){m.additionalParameters.push(P);}}}return m;};A.prototype._getPropertyKeys=function(E){var k={};if(E&&E.key&&E.key.propertyRef){for(var i=0;i<E.key.propertyRef.length;i++){var K=E.key.propertyRef[i].name;k[K]=true;}}return k;};A.prototype._getEntityType=function(C){var E=null;if(C&&C.getPath()){var s=e.getEntitySetFromContext(C);var o=this._oMetaModel.getODataEntitySet(s,false);E=this._oMetaModel.getODataEntityType(o.entityType,false);}return E;};A.prototype._initiateCall=function(m){if(m!=undefined&&m.additionalParameters.length==0){this._call(m.parameterData);}else if(m!=undefined&&m.additionalParameters.length>0){var t=this;var p={urlParameters:{}};var E=this.getContexts()[0];var f=this.getApplicationController().getNewActionContext(this._sFunctionImportPath,E,p);f.context.then(function(o){var P=t._buildParametersForm(m,o);for(var k in m.parameterData){o.oModel.getData(o.sPath)[k]=m.parameterData[k];}var g=false;var h=new D({title:t._sFunctionImportLabel,content:[P.form],beginButton:new sap.m.Button({text:t._sFunctionImportLabel,press:function(j){if(P.hasNoClientErrors()){if(P.getEmptyMandatoryFields().length==0){h.close();g=true;f.result.then(function(R){t._bExecutedSuccessfully=true;t._oActionPromiseCallback.resolve(R);},function(l){t._bExecutedSuccessfully=false;t._oActionPromiseCallback.reject(l);});t.getApplicationController().submitActionContext(o,this._sFunctionImportName);}else{var C=new V();var r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.generic.app").getText("ACTION_MISSING_MANDATORY");for(var i=0;i<P.getEmptyMandatoryFields().length;i++){var s=q.sap.formatMessage(r,P.getEmptyMandatoryFields()[i].getTextLabel());C.addItem(new T({text:s}));}a.error(C,{sClass:t._getCompactModeStyleClass()});}}}}),endButton:new sap.m.Button({text:sap.ui.getCore().getLibraryResourceBundle("sap.ui.generic.app").getText("ACTION_CANCEL"),press:function(){h.close();t._oActionPromiseCallback.resolve();g=true;}}),afterClose:function(C){h.destroy();if(!g){t._oActionPromiseCallback.resolve();}}}).addStyleClass("sapUiNoContentPadding");h.addStyleClass(t._getCompactModeStyleClass());h.setModel(o.oModel);h.open();});}else{this._call();}};A.prototype._call=function(u){var C=this.getContexts();var p={urlParameters:u,operationGrouping:this.getOperationGrouping()};var o=this.getController();var f=this.getApplicationController()||o.getApplicationController();var t=this;f.invokeActions(this._sFunctionImportPath,C,p).then(function(r){t._bExecutedSuccessfully=true;t._oActionPromiseCallback.resolve(r);},function(E){t._bExecutedSuccessfully=false;t._oActionPromiseCallback.reject(E);});};A.prototype._getActionParameterData=function(p){var m=[];var r=p.getObject('/');var P={};for(var i=0;i<this._oFunctionImport.parameter.length;i++){var o=this._oFunctionImport.parameter[i];var s=o.name;if(r.hasOwnProperty(s)){var v=r[s];if(v===undefined){if(!this._toBoolean(o.nullable)){if(o.type==='Edm.Boolean'){P[s]=false;}else{m.push(o);}}}else{P[s]=v;}}else{throw new Error("Unknown parameter: "+s);}}return{preparedParameterData:P,missingMandatoryParameters:m};};A.prototype._buildParametersForm=function(p,C){var f=new S({editable:true});f.setBindingContext(C);var F;var g=[];var l;for(var i=0;i<p.additionalParameters.length;i++){var P=p.additionalParameters[i];F=new c({value:'{'+P.name+'}',textLabel:this._getParameterName(P)});F.data("configdata",{"configdata":{isInnerControl:false,path:P.name,entitySetObject:{},annotations:{valuelist:P["com.sap.vocabularies.Common.v1.ValueList"]},modelObject:C.oModel,entityType:P.type,property:{property:P,typePath:P.name}}});if(P.nullable=="false"){F.setMandatory(true);}g.push(F);l=new d();l.setLabelFor(F);f.addContent(l);f.addContent(F);}var h=function(){var n=true;for(var i=0;i<g.length;i++){if(g[i].getValueState()!="None"){n=false;break;}}return n;};var j=function(){var m=q.grep(g,function(F){return(F.getMandatory()==true&&F.getValue()==""&&F.getDataType()!="Edm.Boolean");});return m;};return{form:f,hasNoClientErrors:h,getEmptyMandatoryFields:j};};A.prototype._getParameterName=function(p){return p["com.sap.vocabularies.Common.v1.Label"]?p["com.sap.vocabularies.Common.v1.Label"].String:p.name;};A.prototype._addParameterLabel=function(p,E){if(E&&p&&!p["com.sap.vocabularies.Common.v1.Label"]){var P=this._oMetaModel.getODataProperty(E,p.name,false);if(P&&P["com.sap.vocabularies.Common.v1.Label"]){p["com.sap.vocabularies.Common.v1.Label"]=P["com.sap.vocabularies.Common.v1.Label"];}}};A.prototype.getFunctionImportLabel=function(){return this._sFunctionImportLabel;};A.prototype.getExecutedSuccessfully=function(){return this._bExecutedSuccessfully;};return A;},true);
