/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global'],function(q){"use strict";var G={};G.render=function(r,c){var I=/^([X][L](?:[0-9]|1[0-1]))? ?([L](?:[0-9]|1[0-1]))? ?([M](?:[0-9]|1[0-1]))? ?([S](?:[0-9]|1[0-1]))?$/i;var S=/^([X][L](?:[1-9]|1[0-2]))? ?([L](?:[1-9]|1[0-2]))? ?([M](?:[1-9]|1[0-2]))? ?([S](?:[1-9]|1[0-2]))?$/i;r.write("<div");r.writeControlData(c);r.addClass("sapUiRespGrid");var M=sap.ui.Device.media.getCurrentRange(sap.ui.Device.media.RANGESETS.SAP_STANDARD_EXTENDED).name;r.addClass("sapUiRespGridMedia-Std-"+M);var h=c.getHSpacing();if(h==0.5){h="05";}else if((h!==0)&&(h!==1)&&(h!==2)){h=1;}r.addClass("sapUiRespGridHSpace"+h);var v=c.getVSpacing();if(v==0.5){v="05";}else if((v!==0)&&(v!==1)&&(v!==2)){v=1;}r.addClass("sapUiRespGridVSpace"+v);var p=c.getPosition();if(p){p=p.toUpperCase();if(p===sap.ui.layout.GridPosition.Center.toUpperCase()){r.addClass("sapUiRespGridPosCenter");}else if(p===sap.ui.layout.GridPosition.Right.toUpperCase()){r.addClass("sapUiRespGridPosRight");}}r.writeClasses();var w=c.getWidth();if(w!=="100%"&&w!=="auto"&&w!=="inherit"){if(h==0){w="width: "+w;}else{w="width: -webkit-calc("+w+" - "+h+"rem); width: calc("+w+" - "+h+"rem); ";}r.writeAttribute("style",w);}var R=c._getAccessibleRole();var a;if(R){a={role:R};}r.writeAccessibilityState(c,a);r.write(">");var b=c.getContent();var d=c.getDefaultSpan();var e=["","XL3","L3","M6","S12"];var f=["","XL0","L0","M0","S0"];var D=S.exec(d);var g=c._getSpanXLChanged();var k=c._getIndentXLChanged();var n=c.getDefaultIndent();var o=I.exec(n);for(var i=0;i<b.length;i++){r.write("<div");var L=c._getLayoutDataForControl(b[i]);var C=false;if(L){var B=false;if(L.getLinebreak()===true){r.addClass("sapUiRespGridBreak");}else{if(L.getLinebreakXL()===true){B=true;r.addClass("sapUiRespGridBreakXL");}if(L.getLinebreakL()===true){if(!B&&!L._getLinebreakXLChanged()){r.addClass("sapUiRespGridBreakXL");}r.addClass("sapUiRespGridBreakL");}if(L.getLinebreakM()===true){r.addClass("sapUiRespGridBreakM");}if(L.getLinebreakS()===true){r.addClass("sapUiRespGridBreakS");}}var t;var u;var x=L.getSpan();if(!x||!x.lenght==0){t=D;}else{t=S.exec(x);if(/XL/gi.test(x)){C=true;}}if(t){for(var j=1;j<t.length;j++){var y=t[j];if(!y){y=D[j];if(!y){y=e[j];}}if(y.substr(0,1)==="L"){u=y.substr(1,2);}var z=L.getSpanXL();var A=L.getSpanL();var E=L.getSpanM();var F=L.getSpanS();y=y.toUpperCase();if((y.substr(0,2)==="XL")&&(z>0)&&(z<13)){r.addClass("sapUiRespGridSpanXL"+z);C=true;}else if((y.substr(0,1)==="L")&&(A>0)&&(A<13)){r.addClass("sapUiRespGridSpanL"+A);u=A;}else if((y.substr(0,1)==="M")&&(E>0)&&(E<13)){r.addClass("sapUiRespGridSpanM"+E);}else if((y.substr(0,1)==="S")&&(F>0)&&(F<13)){r.addClass("sapUiRespGridSpanS"+F);}else{if((y.substr(0,2)!=="XL")||g||C){r.addClass("sapUiRespGridSpan"+y);}}}if(!g&&!C){r.addClass("sapUiRespGridSpanXL"+u);}}var H;var J;var K=L.getIndent();if(!K||K.length==0){H=o;}else{H=I.exec(K);if(/XL/gi.test(K)){k=true;}}if(!H){H=o;if(!H){H=undefined;}}var N=L.getIndentXL();var O=L.getIndentL();var P=L.getIndentM();var Q=L.getIndentS();if(H){for(var j=1;j<H.length;j++){var T=H[j];if(!T){if(o&&o[j]){T=o[j];}else{T=f[j];}}if(T){T=T.toUpperCase();if(T.substr(0,1)==="L"){J=T.substr(1,2);}if((T.substr(0,2)==="XL")&&(N>0)&&(N<12)){r.addClass("sapUiRespGridIndentXL"+N);k=true;}else if((T.substr(0,1)==="L")&&(O>0)&&(O<12)){r.addClass("sapUiRespGridIndentL"+O);J=O;}else if((T.substr(0,1)==="M")&&(P>0)&&(P<12)){r.addClass("sapUiRespGridIndentM"+P);}else if((T.substr(0,1)==="S")&&(Q>0)&&(Q<12)){r.addClass("sapUiRespGridIndentS"+Q);}else{if(!(/^(XL0)? ?(L0)? ?(M0)? ?(S0)?$/.exec(T))){r.addClass("sapUiRespGridIndent"+T);}}}}if(!k){if(J&&J>0){r.addClass("sapUiRespGridIndentXL"+J);}}}var l=L.getVisibleL(),m=L.getVisibleM(),s=L.getVisibleS();if(!l&&m&&s){r.addClass("sapUiRespGridHiddenL");r.addClass("sapUiRespGridHiddenXL");}else if(!l&&!m&&s){r.addClass("sapUiRespGridVisibleS");}else if(l&&!m&&!s){r.addClass("sapUiRespGridVisibleL");r.addClass("sapUiRespGridVisibleXL");}else if(!l&&m&&!s){r.addClass("sapUiRespGridVisibleM");}else if(l&&!m&&s){r.addClass("sapUiRespGridHiddenM");}else if(l&&m&&!s){r.addClass("sapUiRespGridHiddenS");}var U=L.getMoveBackwards();if(U&&U.length>0){var V=I.exec(U);if(V){for(var j=1;j<V.length;j++){var W=V[j];if(W){r.addClass("sapUiRespGridBwd"+W.toUpperCase());}}}}var X=L.getMoveForward();if(X&&X.length>0){var Y=I.exec(X);if(Y){for(var j=1;j<Y.length;j++){var Z=Y[j];if(Z){r.addClass("sapUiRespGridFwd"+Z.toUpperCase());}}}}if(L._sStylesInternal){r.addClass(L._sStylesInternal);}}if(!L){var y="";if(D){for(var j=1;j<D.length;j++){y=D[j];if(!y){if((j==1)&&(D[j+1])){y="X"+D[j+1];}else{y=e[j];}}r.addClass("sapUiRespGridSpan"+y.toUpperCase());}}else{for(var j=1;j<e.length;j++){y=e[j];r.addClass("sapUiRespGridSpan"+y.toUpperCase());}}var T="";if(o){for(var j=1;j<o.length;j++){T=o[j];if(!T){if((j==1)&&(o[j+1])){T="X"+o[j+1];}else{T=f[j];}}if(((T.substr(0,1)!=="X")&&(T.substr(1,1)!=="0"))||((T.substr(0,1)=="X")&&(T.substr(2,1)!=="0"))){r.addClass("sapUiRespGridIndent"+T.toUpperCase());}}}}r.writeClasses();r.write(">");r.renderControl(b[i]);r.write("</div>");}r.write("</div>");};return G;},true);
