/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/Device'],function(q,D){"use strict";var a={EnumMember:true,Path:true,PropertyPath:true,NavigationPropertyPath:true,AnnotationPath:true};var t={Binary:true,Bool:true,Date:true,DateTimeOffset:true,Decimal:true,Duration:true,Float:true,Guid:true,Int:true,String:true,TimeOfDay:true,LabelElementReference:true,EnumMember:true,Path:true,PropertyPath:true,NavigationPropertyPath:true,AnnotationPath:true};var m={And:true,Or:true,Eq:true,Ne:true,Gt:true,Ge:true,Lt:true,Le:true,If:true,Collection:true};var A={parse:function(M,x){var b={},s,c,d,T,e,f,g,h,l,n,o,p,r,u,v,w,y,z,B,C,E,F,G,i,H;this._parserData={};this._oXPath=this.getXPath();this._parserData.metadataInstance=M;this._parserData.serviceMetadata=M.getServiceMetadata();this._parserData.xmlDocument=this._oXPath.setNameSpace(x);this._parserData.schema={};this._parserData.aliases={};s=this._oXPath.selectNodes("//d:Schema",this._parserData.xmlDocument);for(i=0;i<s.length;i+=1){c=this._oXPath.nextNode(s,i);this._parserData.schema.Alias=c.getAttribute("Alias");this._parserData.schema.Namespace=c.getAttribute("Namespace");}var I={};var J=this._parseReferences(I);if(J){b.annotationReferences=I;b.aliasDefinitions=this._parserData.aliases;}d=this._oXPath.selectNodes("//d:Term",this._parserData.xmlDocument);if(d.length>0){T={};for(H=0;H<d.length;H+=1){e=this._oXPath.nextNode(d,H);f=this.replaceWithAlias(e.getAttribute("Type"));T["@"+this._parserData.schema.Alias+"."+e.getAttribute("Name")]=f;}b.termDefinitions=T;}this._parserData.metadataProperties=this.getAllPropertiesMetadata(this._parserData.serviceMetadata);if(this._parserData.metadataProperties.extensions){b.propertyExtensions=this._parserData.metadataProperties.extensions;}g=this._oXPath.selectNodes("//d:Annotations ",this._parserData.xmlDocument);for(H=0;H<g.length;H+=1){h=this._oXPath.nextNode(g,H);if(h.hasChildNodes()===false){continue;}l=h.getAttribute("Target");n=l.split(".")[0];if(n&&this._parserData.aliases[n]){l=l.replace(new RegExp(n,""),this._parserData.aliases[n]);}o=l;p=null;var K=null;if(l.indexOf("/")>0){o=l.split("/")[0];var S=this._parserData.serviceMetadata.dataServices&&this._parserData.serviceMetadata.dataServices.schema&&this._parserData.serviceMetadata.dataServices.schema.length;if(S){for(var j=this._parserData.serviceMetadata.dataServices.schema.length-1;j>=0;j--){var L=this._parserData.serviceMetadata.dataServices.schema[j];if(L.entityContainer){var N=o.split('.');for(var k=L.entityContainer.length-1;k>=0;k--){if(L.entityContainer[k].name===N[N.length-1]){K=l.replace(o+"/","");break;}}}}}if(!K){p=l.replace(o+"/","");}}if(p){if(!b.propertyAnnotations){b.propertyAnnotations={};}if(!b.propertyAnnotations[o]){b.propertyAnnotations[o]={};}if(!b.propertyAnnotations[o][p]){b.propertyAnnotations[o][p]={};}r=this._oXPath.selectNodes("./d:Annotation",h);for(var O=0;O<r.length;O+=1){u=this._oXPath.nextNode(r,O);v=this.replaceWithAlias(u.getAttribute("Term"));var Q=h.getAttribute("Qualifier")||u.getAttribute("Qualifier");if(Q){v+="#"+Q;}if(u.hasChildNodes()===false){b.propertyAnnotations[o][p][v]=this.enrichFromPropertyValueAttributes({},u);}else{b.propertyAnnotations[o][p][v]=this.getPropertyValue(u);}}}else{var P;if(K){if(!b["EntityContainer"]){b["EntityContainer"]={};}if(!b["EntityContainer"][o]){b["EntityContainer"][o]={};}P=b["EntityContainer"][o];}else{if(!b[o]){b[o]={};}P=b[o];}w=o.replace(this._parserData.aliases[n],n);r=this._oXPath.selectNodes("./d:Annotation",h);for(var R=0;R<r.length;R+=1){u=this._oXPath.nextNode(r,R);var U=this._parseAnnotation(o,h,u);y=U.key;z=U.value;if(!K){P[y]=z;}else{if(!P[K]){P[K]={};}P[K][y]=z;}}B=this._oXPath.selectNodes("//d:Annotations[contains(@Target, '"+w+"')]//d:PropertyValue[contains(@Path, '/')]//@Path",this._parserData.xmlDocument);for(i=0;i<B.length;i+=1){C=this._oXPath.nextNode(B,i);E=C.value;if(b.propertyAnnotations){if(b.propertyAnnotations[o]){if(b.propertyAnnotations[o][E]){continue;}}}F=E.split('/');if(!!this.findNavProperty(o,F[0])){if(!b.expand){b.expand={};}if(!b.expand[o]){b.expand[o]={};}b.expand[o][F[0]]=F[0];}}G=this._oXPath.selectNodes("//d:Annotations[contains(@Target, '"+w+"')]//d:Path[contains(., '/')]",this._parserData.xmlDocument);for(i=0;i<G.length;i+=1){C=this._oXPath.nextNode(G,i);E=this._oXPath.getNodeText(C);if(b.propertyAnnotations&&b.propertyAnnotations[o]&&b.propertyAnnotations[o][E]){continue;}if(!b.expand){b.expand={};}if(!b.expand[o]){b.expand[o]={};}F=E.split('/');if(!!this.findNavProperty(o,F[0])){if(!b.expand){b.expand={};}if(!b.expand[o]){b.expand[o]={};}b.expand[o][F[0]]=F[0];}}}}this._parserData=null;return b;},_parseAnnotation:function(s,o,b){var Q=o.getAttribute("Qualifier")||b.getAttribute("Qualifier");var T=this.replaceWithAlias(b.getAttribute("Term"),this._parserData.aliases);if(Q){T+="#"+Q;}var v=this.getPropertyValue(b,this._parserData.aliases,s);v=this.setEdmTypes(v,this._parserData.metadataProperties.types,s,this._parserData.schema);return{key:T,value:v};},_parseReferences:function(b){var f=false;var n,i;var x=this._oXPath;var s="//edmx:Reference/edmx:Include[@Namespace and @Alias]";var o=x.selectNodes(s,this._parserData.xmlDocument);for(i=0;i<o.length;++i){f=true;n=x.nextNode(o,i);this._parserData.aliases[n.getAttribute("Alias")]=n.getAttribute("Namespace");}var r="//edmx:Reference[@Uri]/edmx:IncludeAnnotations[@TermNamespace]";var R=x.selectNodes(r,this._parserData.xmlDocument);for(i=0;i<R.length;++i){f=true;n=x.nextNode(R,i);var T=n.getAttribute("TermNamespace");var c=n.getAttribute("TargetNamespace");var d=n.parentNode.getAttribute("Uri");if(c){if(!b[c]){b[c]={};}b[c][T]=d;}else{b[T]=d;}}return f;},getAllPropertiesMetadata:function(M){var o={},P={},b={},c=false,n,e,C,E={},d={},f={},g=false,h,r,s,T,u,R={types:P};if(!M.dataServices.schema){return R;}for(var i=M.dataServices.schema.length-1;i>=0;i-=1){o=M.dataServices.schema[i];if(o.entityType){n=o.namespace;e=o.entityType;C=o.complexType;for(var j in e){E=e[j];f={};d={};if(E.hasStream&&E.hasStream==="true"){continue;}for(var k in E.property){h=E.property[k];if(h.type.substring(0,n.length)===n){for(var l in C){if(C[l].name===h.type.substring(n.length+1)){for(k in C[l].property){r=C[l].property[k];d[C[l].name+"/"+r.name]=r.type;}}}}else{s=h.name;T=h.type;for(var p in h.extensions){u=h.extensions[p];if((u.name==="display-format")&&(u.value==="Date")){T="Edm.Date";}else{g=true;if(!f[s]){f[s]={};}if(u.namespace&&!f[s][u.namespace]){f[s][u.namespace]={};}f[s][u.namespace][u.name]=u.value;}}d[s]=T;}}if(!P[n+"."+E.name]){P[n+"."+E.name]={};}P[n+"."+E.name]=d;if(g){if(!b[n+"."+E.name]){c=true;}b[n+"."+E.name]={};b[n+"."+E.name]=f;}}}}if(c){R={types:P,extensions:b};}return R;},setEdmTypes:function(p,P,T,s){var o,e='';for(var b in p){if(p[b]){o=p[b];if(o.Value&&o.Value.Path){e=this.getEdmType(o.Value.Path,P,T,s);if(e){p[b].EdmType=e;}continue;}if(o.Path){e=this.getEdmType(o.Path,P,T,s);if(e){p[b].EdmType=e;}continue;}if(o.Facets){p[b].Facets=this.setEdmTypes(o.Facets,P,T,s);continue;}if(o.Data){p[b].Data=this.setEdmTypes(o.Data,P,T,s);continue;}if(b==="Data"){p.Data=this.setEdmTypes(o,P,T,s);continue;}if(o.Value&&o.Value.Apply){p[b].Value.Apply.Parameters=this.setEdmTypes(o.Value.Apply.Parameters,P,T,s);continue;}if(o.Value&&o.Type&&(o.Type==="Path")){e=this.getEdmType(o.Value,P,T,s);if(e){p[b].EdmType=e;}}}}return p;},getEdmType:function(p,P,T,s){var i=p.indexOf("/");if(i>-1){var b=p.substr(0,i);var n=this.findNavProperty(T,b);if(n){var c=this._parserData.metadataInstance._getEntityTypeByNavPropertyObject(n);if(c){T=c.entityType;p=p.substr(i+1);}}}if((p.charAt(0)==="@")&&(p.indexOf(s.Alias)===1)){p=p.slice(s.Alias.length+2);}if(p.indexOf("/")>=0){if(P[p.slice(0,p.indexOf("/"))]){T=p.slice(0,p.indexOf("/"));p=p.slice(p.indexOf("/")+1);}}for(var d in P[T]){if(p===d){return P[T][d];}}},enrichFromPropertyValueAttributes:function(b,n){var I={"Property":true,"Term":true,"Qualifier":true};var r=function(v){return this.replaceWithAlias(v);}.bind(this);for(var i=0;i<n.attributes.length;i+=1){if(!I[n.attributes[i].name]){var N=n.attributes[i].name;var v=n.attributes[i].value;if(N==="EnumMember"&&v.indexOf(" ")>-1){var V=v.split(" ");b[N]=V.map(r).join(" ");}else{b[N]=this.replaceWithAlias(v);}}}return b;},_getRecordValues:function(n){var N=[];var x=this._oXPath;for(var i=0;i<n.length;++i){var o=x.nextNode(n,i);var v=this.getPropertyValues(o);var T=o.getAttribute("Type");if(T){v["RecordType"]=this.replaceWithAlias(T);}N.push(v);}return N;},_getTextValues:function(n){var N=[];var x=this._oXPath;for(var i=0;i<n.length;i+=1){var o=x.nextNode(n,i);var v={};var T=x.getNodeText(o);v[o.nodeName]=this._parserData.aliases?this.replaceWithAlias(T):T;N.push(v);}return N;},_getTextValue:function(n){var x=this._oXPath;var v="";if(n.nodeName in a){v=this.replaceWithAlias(x.getNodeText(n));}else{v=x.getNodeText(n);}if(n.nodeName!=="String"){v=v.trim();}return v;},getPropertyValue:function(d,s){var i;var x=this._oXPath;var p=d.nodeName==="Collection"?[]:{};if(d.hasChildNodes()){var r=x.selectNodes("./d:Record",d);var R=this._getRecordValues(r);var c=x.selectNodes("./d:Collection/d:Record | ./d:Collection/d:If/d:Record",d);var C=this._getRecordValues(c);var P=R.concat(C);if(P.length>0){if(c.length===0&&r.length>0){p=P[0];}else{p=P;}}else{var o=x.selectNodes("./d:Collection/d:AnnotationPath | ./d:Collection/d:PropertyPath",d);if(o.length>0){p=this._getTextValues(o);}else{var b=x.selectNodes("./d:*[not(local-name() = \"Annotation\")]",d);if(b.length>0){for(i=0;i<b.length;i++){var e=x.nextNode(b,i);var v;var n=e.nodeName;var f=e.parentNode.nodeName;if(n==="Apply"){v=this.getApplyFunctions(e);}else{v=this.getPropertyValue(e);}if(m[f]){if(!Array.isArray(p)){p=[];}var V={};V[n]=v;p.push(V);}else if(n==="Collection"){p=v;}else{if(p[n]){q.sap.log.warning("Annotation contained multiple "+n+" values. Only the last "+"one will be stored: "+x.getPath(e));}p[n]=v;}}}else if(d.nodeName in t){p=this._getTextValue(d);}this.enrichFromPropertyValueAttributes(p,d);}}var N=x.selectNodes("./d:Annotation",d);if(N.length>0){for(i=0;i<N.length;i++){var g=x.nextNode(N,i);var h=this._parseAnnotation(s,d,g);p[h.key]=h.value;}}}else if(d.nodeName in t){p=this._getTextValue(d);}else if(d.nodeName.toLowerCase()==="null"){p=null;}else{this.enrichFromPropertyValueAttributes(p,d);}return p;},getPropertyValues:function(p){var P={},i;var x=this._oXPath;var o=x.selectNodes("./d:Annotation",p);var b=x.selectNodes("./d:PropertyValue",p);if(o.length===0&&b.length===0){P=this.getPropertyValue(p);}else{for(i=0;i<o.length;i++){var c=x.nextNode(o,i);var T=this.replaceWithAlias(c.getAttribute("Term"));P[T]=this.getPropertyValue(c);}for(i=0;i<b.length;i++){var d=x.nextNode(b,i);var s=d.getAttribute("Property");P[s]=this.getPropertyValue(d);var e=x.selectNodes("./d:Apply",d);for(var n=0;n<e.length;n+=1){var f=x.nextNode(e,n);P[s]={};P[s]['Apply']=this.getApplyFunctions(f);}}}return P;},getApplyFunctions:function(b){var x=this._oXPath;var c={Name:b.getAttribute('Function'),Parameters:[]};var p=x.selectNodes("./d:*",b);for(var i=0;i<p.length;i+=1){var P=x.nextNode(p,i);var d={Type:P.nodeName};if(P.nodeName==="Apply"){d.Value=this.getApplyFunctions(P);}else if(P.nodeName==="LabeledElement"){d.Value=this.getPropertyValue(P);d.Name=d.Value.Name;delete d.Value.Name;}else if(m[P.nodeName]){d.Value=this.getPropertyValue(P);}else{d.Value=x.getNodeText(P);}c.Parameters.push(d);}return c;},findNavProperty:function(e,p){var M=this._parserData.serviceMetadata;for(var i=M.dataServices.schema.length-1;i>=0;i-=1){var o=M.dataServices.schema[i];if(o.entityType){var n=o.namespace+".";var E=o.entityType;for(var k=E.length-1;k>=0;k-=1){if(n+E[k].name===e&&E[k].navigationProperty){for(var j=0;j<E[k].navigationProperty.length;j+=1){if(E[k].navigationProperty[j].name===p){return E[k].navigationProperty[j];}}}}}}return null;},replaceWithAlias:function(v,r){if(r===undefined){r=1;}for(var s in this._parserData.aliases){if(v.indexOf(s+".")>=0&&v.indexOf("."+s+".")<0){v=v.replace(s+".",this._parserData.aliases[s]+".");r--;if(r===0){return v;}}}return v;},getXPath:function(){var x={};var p=this._parserData;if(D.browser.internet_explorer){x={setNameSpace:function(o){o.setProperty("SelectionNamespaces",'xmlns:edmx="http://docs.oasis-open.org/odata/ns/edmx" xmlns:d="http://docs.oasis-open.org/odata/ns/edm"');o.setProperty("SelectionLanguage","XPath");return o;},selectNodes:function(x,i){return i.selectNodes(x);},nextNode:function(n){return n.nextNode();},getNodeText:function(n){return n.text;}};}else{x={setNameSpace:function(o){return o;},nsResolver:function(b){var n={"edmx":"http://docs.oasis-open.org/odata/ns/edmx","d":"http://docs.oasis-open.org/odata/ns/edm"};return n[b]||null;},selectNodes:function(P,i){var b=p.xmlDocument.evaluate(P,i,this.nsResolver,7,null);b.length=b.snapshotLength;return b;},nextNode:function(n,i){return n.snapshotItem(i);},getNodeText:function(n){return n.textContent;}};}x.getPath=function(n){var P="";var I="getAttribute"in n?n.getAttribute("id"):"";var T=n.tagName?n.tagName:"";if(I){P='id("'+I+'")';}else if(n instanceof Document){P="/";}else if(T.toLowerCase()==="body"){P=T;}else if(n.parentNode){var b=1;for(var i=0;i<n.parentNode.childNodes.length;++i){if(n.parentNode.childNodes[i]===n){P=x.getPath(n.parentNode)+"/"+T+"["+b+"]";break;}else if(n.parentNode.childNodes[i].nodeType===1&&n.parentNode.childNodes[i].tagName===T){++b;}}}else{q.sap.log.error("Wrong Input node - cannot find XPath to it: "+T);}return P;};return x;}};return A;});
