/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["jquery.sap.global","sap/ui/model/BindingMode","sap/ui/model/ChangeReason","sap/ui/model/PropertyBinding","./_ODataHelper","./lib/_Cache"],function(q,B,C,P,_,a){"use strict";var c="sap.ui.model.odata.v4.ODataPropertyBinding",s={AggregatedDataStateChange:true,change:true,dataReceived:true,dataRequested:true};var O=P.extend(c,{constructor:function(m,p,o,b){var d;P.call(this,m,p,o);if(!p||p.slice(-1)==="/"){throw new Error("Invalid path: "+p);}this.oCache=undefined;this.sGroupId=undefined;this.sRefreshGroupId=undefined;this.sUpdateGroupId=undefined;if(!this.bRelative){this.oCache=a.createSingle(m.oRequestor,p.slice(1),_.buildQueryOptions(m.mUriParameters,b),true);d=_.buildBindingParameters(b,["$$groupId","$$updateGroupId"]);this.sGroupId=d.$$groupId;this.sUpdateGroupId=d.$$updateGroupId;}else if(b){throw new Error("Bindings with a relative path do not support parameters");}this.bInitial=true;this.bRequestTypeFailed=false;this.vValue=undefined;m.bindingCreated(this);},metadata:{publicMethods:[]}});O.prototype.attachEvent=function(e){if(!(e in s)){throw new Error("Unsupported event '"+e+"': v4.ODataPropertyBinding#attachEvent");}return P.prototype.attachEvent.apply(this,arguments);};O.prototype.checkUpdate=function(f,b){var o={reason:b||C.Change},d=false,F=false,g,p,e,h=[],r,R=this.oModel.resolve(this.sPath,this.oContext),t=this;if(!R){e=Promise.resolve();if(t.vValue!==undefined){e=e.then(function(){t._fireChange(o);});}t.vValue=undefined;return e;}if(!this.bRequestTypeFailed&&!this.oType){h.push(this.oModel.getMetaModel().requestUI5Type(R).then(function(T){t.setType(T,t.sInternalType);})["catch"](function(E){t.bRequestTypeFailed=true;q.sap.log.warning(E.message,R,c);}));}if(this.isRelative()){r=this.oContext.fetchValue(this.sPath,this);}else{g=this.sRefreshGroupId||this.getGroupId();this.sRefreshGroupId=undefined;r=this.oCache.read(g,undefined,function(){d=true;t.oModel.addedRequestToGroup(g,t.fireDataRequested.bind(t));},this);}h.push(r.then(function(v){if(v&&typeof v==="object"){q.sap.log.error("Accessed value is not primitive",R,c);v=undefined;}F=t.vValue!==v;t.vValue=v;})["catch"](function(E){if(!E.canceled){if(d){t.oModel.reportError("Failed to read path "+R,c,E);}F=t.vValue!==undefined;p={error:E};}t.vValue=undefined;}));return Promise.all(h).then(function(){t.bInitial=false;if(f||F){t._fireChange(o);}if(d){t.fireDataReceived(p);}});};O.prototype.destroy=function(){if(this.oCache){this.oCache.deregisterChange(undefined,this);}else if(this.oContext){this.oContext.deregisterChange(this.sPath,this);}this.oModel.bindingDestroyed(this);P.prototype.destroy.apply(this,arguments);};O.prototype.getGroupId=function(){return this.sGroupId||(this.bRelative&&this.oContext&&this.oContext.getGroupId())||this.oModel.getGroupId();};O.prototype.getUpdateGroupId=function(){return this.sUpdateGroupId||(this.bRelative&&this.oContext&&this.oContext.getUpdateGroupId())||this.oModel.getUpdateGroupId();};O.prototype.getValue=function(){return this.vValue;};O.prototype.hasPendingChanges=function(){if(this.oCache){return this.oCache.hasPendingChanges("");}if(this.oContext){return this.oContext.hasPendingChanges(this.sPath);}return false;};O.prototype.isInitial=function(){throw new Error("Unsupported operation: v4.ODataPropertyBinding#isInitial");};O.prototype.onChange=function(v){this.vValue=v;this._fireChange({reason:C.Change});};O.prototype.refresh=function(g){if(!this.oCache){throw new Error("Refresh on this binding is not supported");}_.checkGroupId(g);this.sRefreshGroupId=g;this.oCache.refresh();this.checkUpdate(true,C.Refresh);};O.prototype.resume=function(){throw new Error("Unsupported operation: v4.ODataPropertyBinding#resume");};O.prototype.setContext=function(o){if(this.oContext!==o){if(this.oContext&&this.bRelative){this.oContext.deregisterChange(this.sPath,this);}this.oContext=o;if(this.bRelative){this.checkUpdate(false,C.Context);}}};O.prototype.setType=function(t){var o=this.oType;if(t&&t.getName()==="sap.ui.model.odata.type.DateTimeOffset"){t.setV4();}P.prototype.setType.apply(this,arguments);if(!this.bInitial&&o!==t){this._fireChange({reason:C.Change});}};O.prototype.setValue=function(v,g){var t=this;if(typeof v==="function"||typeof v==="object"){throw new Error("Not a primitive value");}_.checkGroupId(g);if(this.vValue!==v){if(this.bRelative){if(this.oContext){this.oContext.updateValue(g,this.sPath,v)["catch"](function(e){if(!e.canceled){t.oModel.reportError("Failed to update path "+t.oModel.resolve(t.sPath,t.oContext),c,e);}});}else{q.sap.log.warning("Cannot set value on relative binding without context",this.sPath,c);return;}}else{q.sap.log.error("Cannot set value on absolute binding",this.sPath,c);return;}}};O.prototype.suspend=function(){throw new Error("Unsupported operation: v4.ODataPropertyBinding#suspend");};O.prototype.toString=function(){return c+": "+(this.bRelative?this.oContext+"|":"")+this.sPath;};return O;},true);
