/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["./_Helper"],function(_){"use strict";var M,r=/^Collection\((.*)\)$/,a={"AnnotationPath":{__postProcessor:w},"Binary":{__postProcessor:w},"Bool":{__postProcessor:w},"Date":{__postProcessor:w},"DateTimeOffset":{__postProcessor:w},"Decimal":{__postProcessor:w},"Duration":{__postProcessor:w},"EnumMember":{__postProcessor:w},"Float":{__postProcessor:w},"Guid":{__postProcessor:w},"Int":{__postProcessor:w},"LabeledElementReference":{__postProcessor:v},"NavigationPropertyPath":{__postProcessor:w},"Path":{__postProcessor:w},"PropertyPath":{__postProcessor:w},"String":{__postProcessor:w},"TimeOfDay":{__postProcessor:w}},e=[a],A={"Annotation":{__processor:K,__postProcessor:p,__include:e}},b=[a,A],o={__processor:I,__postProcessor:C,__include:b},c={"And":o,"Apply":{__processor:I,__postProcessor:n,__include:b},"Cast":{__processor:I,__postProcessor:q,__include:b},"Collection":{__postProcessor:t,__include:e},"Eq":o,"Ge":o,"Gt":o,"If":o,"IsOf":{__processor:I,__postProcessor:q,__include:b},"LabeledElement":{__processor:I,__postProcessor:u,__include:b},"Le":o,"Lt":o,"Ne":o,"Null":{__processor:I,__postProcessor:y,__include:[A]},"Not":{__processor:I,__postProcessor:x,__include:b},"Or":o,"Record":{__processor:I,__postProcessor:B,__include:[A],"PropertyValue":{__processor:$,__postProcessor:z,__include:b}},"UrlRef":{__postProcessor:D,__include:e}},d={"Reference":{"Include":{__processor:H}},"DataServices":{"Schema":{__processor:H}}},s={"Property":{__processor:l1,__include:[A]},"NavigationProperty":{__processor:i1,__include:[A],"OnDelete":{__processor:j1,__include:[A]},"ReferentialConstraint":{__processor:k1,__include:[A]}}},E={"NavigationPropertyBinding":{__processor:Y}},f={"Parameter":{__processor:Z,__include:[A]},"ReturnType":{__processor:b1,__include:[A]}},F={__processor:O,"Reference":{__processor:a1,__include:[A],"Include":{__processor:W},"IncludeAnnotations":{__processor:X}},"DataServices":{"Schema":{__processor:c1,__include:[A],"Action":{__processor:G,__include:[f,A]},"Annotations":{__processor:J,__include:[A]},"Function":{__processor:G,__include:[f,A]},"EntityType":{__processor:R,__include:[s,A],"Key":{"PropertyRef":{__processor:S}}},"ComplexType":{__processor:N,__include:[s,A]},"EntityContainer":{__processor:P,__include:[A],"ActionImport":{__processor:V.bind(null,"Action"),__include:[A]},"EntitySet":{__processor:Q,__include:[E,A]},"FunctionImport":{__processor:V.bind(null,"Function"),__include:[A]},"Singleton":{__processor:d1,__include:[E,A]}},"EnumType":{__processor:T,__include:[A],"Member":{__processor:U,__include:[A]}},"Term":{__processor:e1,__include:[A]},"TypeDefinition":{__processor:h1,__include:[A]}}}};e.push(c);b.push(c);A.Annotation.Annotation=A.Annotation;function g(i,j,r1,s1){var t1,u1,v1;if(typeof j==="string"){t1=i.annotatable;j=_.buildPath(t1.path,j);v1=j;u1=i.schema.$Annotations;if(u1&&u1[j]){j=u1[j];}}i.annotatable={parent:i.annotatable,path:v1,prefix:r1||"",qualifier:s1,target:j};}function h(i,j){var r1=i[j];if(!r1){r1=i[j]=[];}return r1;}function k(i,j){var r1=i[j];if(!r1){r1=i[j]={};}return r1;}function l(j,r1,s1){var i,t1,u1;switch(j){case"AnnotationPath":case"NavigationPropertyPath":case"Path":case"PropertyPath":r1=M.resolveAliasInPath(r1,s1);case"Binary":case"Date":case"DateTimeOffset":case"Decimal":case"Duration":case"Guid":case"TimeOfDay":case"UrlRef":t1={};t1["$"+j]=r1;return t1;case"Bool":return r1==="true";case"EnumMember":u1=r1.trim().replace(/ +/g," ").split(" ");for(i=0;i<u1.length;i++){u1[i]=M.resolveAliasInPath(u1[i],s1);}return{$EnumMember:u1.join(" ")};case"Float":if(r1==="NaN"||r1==="INF"||r1==="-INF"){return{$Float:r1};}return parseFloat(r1);case"Int":t1=parseInt(r1,10);return _.isSafeInteger(t1)?t1:{$Int:r1};case"String":return r1;default:return undefined;}}function m(j,r1){var s1,t1=j.attributes,i,u1;for(i=t1.length-1;i>=0;i--){s1=t1.item(i);u1=l(s1.name,s1.value,r1);if(u1!==undefined){return u1;}}return true;}function p(i,j,r1){var s1=r1.annotatable.parent;s1.target[s1.qualifiedName]=j.length?j[0]:m(i,r1);}function n(i,j,r1){var s1=r1.annotatable.target;s1.$Apply=j;s1.$Function=M.resolveAlias(i.getAttribute("Function"),r1);return s1;}function q(i,j,r1){var s1=i.localName,t1=r1.annotatable.target;t1["$"+s1]=j[0];g1(i.getAttribute("Type"),t1,r1);M.processFacetAttributes(i,t1);return t1;}function t(i,j,r1){return j;}function u(i,j,r1){var s1=r1.annotatable.target;s1.$LabeledElement=j.length?j[0]:m(i,r1);s1.$Name=i.getAttribute("Name");return s1;}function v(i,j,r1){return{"$LabeledElementReference":M.resolveAlias(i.textContent,r1)};}function w(i,j,r1){return l(i.localName,i.textContent,r1);}function x(i,j,r1){var s1=r1.annotatable.target;s1.$Not=j[0];return s1;}function y(i,j,r1){var s1=r1.annotatable,t1=null;if(s1.qualifiedName){t1=s1.target;t1.$Null=null;}return t1;}function z(i,j,r1){return{property:i.getAttribute("Property"),value:j.length?j[0]:m(i,r1)};}function B(j,r1,s1){var i,t1,u1=s1.annotatable.target,v1=j.getAttribute("Type");if(v1){u1.$Type=M.resolveAlias(v1,s1);}for(i=0;i<r1.length;i++){t1=r1[i];u1[t1.property]=t1.value;}return u1;}function C(i,j,r1){var s1=r1.annotatable.target;s1["$"+i.localName]=j;return s1;}function D(i,j){return{$UrlRef:j[0]};}function G(i,j){var r1=i.localName,s1=j.namespace+i.getAttribute("Name"),t1={$kind:r1};L(i,t1,{"IsBound":o1,"EntitySetPath":q1,"IsComposable":o1});h(j.result,s1).push(t1);j.actionOrFunction=t1;g(j,t1);}function H(i,j){var r1=i.getAttribute("Alias");if(r1){j.aliases[r1]=i.getAttribute("Namespace")+".";}}function I(i,j){g(j,{});}function J(i,j){g(j,M.resolveAliasInPath(i.getAttribute("Target"),j),undefined,i.getAttribute("Qualifier"));}function K(i,j){var r1=j.annotatable,s1,t1=r1.prefix+"@"+M.resolveAlias(i.getAttribute("Term"),j),u1=r1.qualifier||i.getAttribute("Qualifier");if(u1){t1+="#"+u1;}if(typeof r1.target==="string"){s1=k(j.schema,"$Annotations");r1.target=s1[r1.target]={};}r1.qualifiedName=t1;r1.target[t1]=true;g(j,r1.target,t1);}function L(i,j,r1){var s1;for(s1 in r1){var t1=r1[s1](i.getAttribute(s1));if(t1!==undefined&&t1!==null){j["$"+s1]=t1;}}}function N(i,j){f1(i,j,{"$kind":"ComplexType"});}function O(i,j){L(i,j.result,{"Version":q1});}function P(i,j){var r1=j.namespace+i.getAttribute("Name");j.result[r1]=j.entityContainer={"$kind":"EntityContainer"};j.result.$EntityContainer=r1;g(j,r1);}function Q(i,j){var r1=i.getAttribute("Name");j.entityContainer[r1]=j.entitySet={$kind:"EntitySet",$Type:M.resolveAlias(i.getAttribute("EntityType"),j)};L(i,j.entitySet,{"IncludeInServiceDocument":n1});g(j,r1);}function R(i,j){f1(i,j,{$kind:"EntityType"});}function S(i,j){var r1=i.getAttribute("Alias"),s1,t1=i.getAttribute("Name");if(r1){s1={};s1[r1]=t1;}else{s1=t1;}h(j.type,"$Key").push(s1);}function T(i,j){var r1=j.namespace+i.getAttribute("Name"),s1={"$kind":"EnumType"};L(i,s1,{"IsFlags":o1,"UnderlyingType":function(t1){return t1!=="Edm.Int32"?t1:undefined;}});j.result[r1]=j.enumType=s1;j.enumTypeMemberCounter=0;g(j,r1);}function U(i,j){var r1=i.getAttribute("Name"),s1=i.getAttribute("Value"),t1;if(s1){t1=parseInt(s1,10);if(!_.isSafeInteger(t1)){t1=s1;}}else{t1=j.enumTypeMemberCounter;j.enumTypeMemberCounter++;}j.enumType[r1]=t1;g(j,r1);}function V(i,j,r1){var s1={$kind:i+"Import"},t1=j.getAttribute("Name");s1["$"+i]=M.resolveAlias(j.getAttribute(i),r1);L(j,s1,{"EntitySet":function(u1){return m1(u1,r1);},"IncludeInServiceDocument":o1});r1.entityContainer[t1]=s1;g(r1,t1);}function W(i,j){var r1=h(j.reference,"$Include");r1.push(i.getAttribute("Namespace")+".");}function X(i,j){var r1=j.reference,s1={"$TermNamespace":i.getAttribute("TermNamespace")+"."},t1=h(r1,"$IncludeAnnotations");L(i,s1,{"TargetNamespace":function q1(u1){return u1?u1+".":u1;},"Qualifier":q1});t1.push(s1);}function Y(i,j){var r1=k(j.entitySet,"$NavigationPropertyBinding");r1[i.getAttribute("Path")]=m1(i.getAttribute("Target"),j);}function Z(i,j){var r1=j.actionOrFunction,s1={};g1(i.getAttribute("Type"),s1,j);L(i,s1,{"Name":q1,"Nullable":n1});M.processFacetAttributes(i,s1);h(r1,"$Parameter").push(s1);g(j,s1);}function $(i,j){g(j,j.annotatable.target,i.getAttribute("Property"));}function a1(i,j){var r1=k(j.result,"$Reference");j.reference=r1[i.getAttribute("Uri")]={};g(j,j.reference);}function b1(i,j){var r1=j.actionOrFunction,s1={};g1(i.getAttribute("Type"),s1,j);L(i,s1,{"Nullable":n1});M.processFacetAttributes(i,s1);r1.$ReturnType=s1;g(j,s1);}function c1(i,j){j.namespace=i.getAttribute("Namespace")+".";j.result[j.namespace]=j.schema={"$kind":"Schema"};g(j,j.schema);}function d1(i,j){var r1=i.getAttribute("Name");j.entityContainer[r1]=j.entitySet={$kind:"Singleton",$Type:M.resolveAlias(i.getAttribute("Type"),j)};g(j,r1);}function e1(i,j){var r1=j.namespace+i.getAttribute("Name"),s1={$kind:"Term"};g1(i.getAttribute("Type"),s1,j);L(i,s1,{"Nullable":n1,"BaseTerm":function(t1){return t1?M.resolveAlias(t1,j):undefined;}});M.processFacetAttributes(i,s1);j.result[r1]=s1;g(j,r1);}function f1(i,j,r1){var s1=j.namespace+i.getAttribute("Name");L(i,r1,{"OpenType":o1,"HasStream":o1,"Abstract":o1,"BaseType":q1});j.result[s1]=j.type=r1;g(j,s1);}function g1(i,j,r1){var s1=r.exec(i);if(s1){j.$isCollection=true;i=s1[1];}j.$Type=M.resolveAlias(i,r1);}function h1(i,j){var r1=j.namespace+i.getAttribute("Name"),s1={"$kind":"TypeDefinition","$UnderlyingType":i.getAttribute("UnderlyingType")};j.result[r1]=s1;M.processFacetAttributes(i,s1);g(j,r1);}function i1(i,j){var r1=i.getAttribute("Name"),s1={$kind:"NavigationProperty"};g1(i.getAttribute("Type"),s1,j);L(i,s1,{"Nullable":n1,"Partner":q1,"ContainsTarget":o1});j.type[r1]=j.navigationProperty=s1;g(j,r1);}function j1(i,j){j.navigationProperty.$OnDelete=i.getAttribute("Action");g(j,j.navigationProperty,"$OnDelete");}function k1(i,j){var r1=i.getAttribute("Property"),s1=k(j.navigationProperty,"$ReferentialConstraint");s1[r1]=i.getAttribute("ReferencedProperty");g(j,s1,r1);}function l1(i,j){var r1=i.getAttribute("Name"),s1={"$kind":"Property"};g1(i.getAttribute("Type"),s1,j);L(i,s1,{"Nullable":n1,"DefaultValue":q1});M.processFacetAttributes(i,s1);j.type[r1]=s1;g(j,r1);}function m1(i,j){var r1;if(!i){return i;}i=M.resolveAliasInPath(i,j);r1=i.indexOf("/");if(r1>=0&&i.indexOf("/",r1+1)<0){if(i.slice(0,r1)===j.result.$EntityContainer){return i.slice(r1+1);}}return i;}function n1(i){return i==="false"?false:undefined;}function o1(i){return i==="true"?true:undefined;}function p1(i){return i?parseInt(i,10):undefined;}function q1(i){return i;}M={convertXMLMetadata:function(i){var j,r1;jQuery.sap.measure.average("convertXMLMetadata","","sap.ui.model.odata.v4.lib._MetadataConverter");j={"actionOrFunction":null,"aliases":{},"annotatable":null,"entityContainer":null,"entitySet":null,"enumType":null,"enumTypeMemberCounter":0,"namespace":null,"navigationProperty":null,"reference":null,"schema":null,"type":null,"result":{}};r1=i.documentElement;M.traverse(r1,j,d);M.traverse(r1,j,F);jQuery.sap.measure.end("convertXMLMetadata");return j.result;},processFacetAttributes:function(i,j){L(i,j,{"MaxLength":p1,"Precision":p1,"Scale":function(r1){return r1==="variable"?r1:p1(r1);},"SRID":q1,"Unicode":n1});},resolveAlias:function(i,j){var r1=i.indexOf("."),s1;if(r1>=0&&i.indexOf(".",r1+1)<0){s1=j.aliases[i.slice(0,r1)];if(s1){return s1+i.slice(r1+1);}}return i;},resolveAliasInPath:function(j,r1){var s1,i,t1,u1="";if(j.indexOf(".")<0){return j;}s1=j.indexOf("@");if(s1>=0){u1="@"+M.resolveAlias(j.slice(s1+1),r1);j=j.slice(0,s1);}t1=j.split("/");for(i=0;i<t1.length;i++){t1[i]=M.resolveAlias(t1[i],r1);}return t1.join("/")+u1;},traverse:function(r1,s1,t1){var u1=s1.annotatable,v1,w1=r1.childNodes,x1,y1,i,z1,j,A1,B1,C1=[];if(t1.__processor){t1.__processor(r1,s1);}for(i=0;i<w1.length;i++){x1=w1.item(i);if(x1.nodeType===1){A1=x1.localName;v1=t1[A1];if(!v1&&t1.__include){z1=t1.__include;for(j=0;j<z1.length;j++){v1=z1[j][A1];if(v1){break;}}}if(v1){y1=M.traverse(x1,s1,v1);if(y1!==undefined&&t1.__postProcessor){C1.push(y1);}}}}if(t1.__postProcessor){B1=t1.__postProcessor(r1,C1,s1);}s1.annotatable=u1;return B1;}};return M;},false);
