/*
 * ! SAP UI development toolkit for HTML5 (SAPUI5)

(c) Copyright 2009-2016 SAP SE. All rights reserved
 */
sap.ui.define(['jquery.sap.global','sap/ui/base/ManagedObject','sap/ui/rta/ui/ToolsMenu','sap/ui/dt/ElementUtil','sap/ui/dt/DesignTime','sap/ui/dt/OverlayRegistry','sap/ui/dt/Overlay','sap/ui/rta/command/Stack','sap/ui/rta/command/CommandFactory','sap/ui/rta/plugin/Rename','sap/ui/rta/plugin/DragDrop','sap/ui/rta/plugin/RTAElementMover','sap/ui/dt/plugin/CutPaste','sap/ui/rta/plugin/Remove','sap/ui/rta/plugin/Selection','sap/ui/rta/plugin/MultiSelection','sap/ui/dt/plugin/ContextMenu','sap/ui/dt/plugin/TabHandling','sap/ui/fl/FlexControllerFactory','sap/ui/rta/ui/SettingsDialog','sap/ui/rta/ui/AddElementsDialog','./Utils','sap/ui/fl/transport/Transports','sap/ui/fl/transport/TransportSelection','sap/ui/fl/Utils','sap/ui/fl/registry/Settings','sap/m/MessageBox','sap/m/MessageToast','sap/ui/rta/controlAnalyzer/ControlAnalyzerFactory'],function(q,M,T,E,D,O,a,C,b,R,c,d,e,f,S,g,h,j,F,k,A,U,l,m,n,o,p,r,s){"use strict";var t=M.extend("sap.ui.rta.RuntimeAuthoring",{metadata:{library:"sap.ui.rta",associations:{"rootControl":{type:"sap.ui.core.Control"}},properties:{"customFieldUrl":"string","showCreateCustomField":"boolean","showToolbars":{type:"boolean",defaultValue:true},"showSettingsDialog":{type:"boolean",defaultValue:true},"showWindowUnloadDialog":{type:"boolean",defaultValue:true},"commandStack":{type:"sap.ui.rta.command.Stack"}},events:{"start":{},"stop":{},"failed":{},"selectionChange":{parameters:{selection:{type:"sap.ui.dt.Overlay[]"}}},"undoRedoStackModified":{}}},_sAppTitle:null});t.prototype.init=function(){this._onCommandStackModified=this._adaptUndoRedoButtons.bind(this);};t.prototype.start=function(){var i=["sap.ui.comp.smartform.Group","sap.ui.comp.smartform.GroupElement","sap.ui.table.Column","sap.uxap.ObjectPageSection","sap.ui.layout.form.FormElement","sap.ui.layout.form.FormContainer"];var N=this;this._aPopups=[];this._oTextResources=sap.ui.getCore().getLibraryResourceBundle("sap.ui.rta");this._aSupportedControls=["sap.ui.comp.smartform.Group","sap.uxap.ObjectPageSection","sap.uxap.ObjectPageLayout"];if(!this._oDesignTime){this._oRootControl=sap.ui.getCore().byId(this.getRootControl());this._oRTAElementMover=new d({movableTypes:i});this._oRTAElementMover.setCommandFactory(b);this._oRTADragDropPlugin=new c({draggableTypes:i,elementMover:this._oRTAElementMover,commandFactory:b}).attachElementModified(this._handleElementModified,this);this._oRTADragDropPlugin.attachDragStarted(this._handleStopCutPaste,this);this._oCutPastePlugin=new e({movableTypes:i,elementMover:this._oRTAElementMover,commandFactory:b}).attachElementModified(this._handleElementModified,this);this._oRemovePlugin=new f({commandFactory:b}).attachElementModified(this._handleElementModified,this);this._oRenamePlugin=new R({commandStack:this.getCommandStack()});this._oRenamePlugin.attachEditable(this._handleStopCutPaste,this);this._oSelectionPlugin=new S();this._oMultiSelectionPlugin=new g({multiSelectionTypes:["sap.ui.comp.smartform.GroupElement"]});this._oContextMenuPlugin=new h();this._oTabHandlingPlugin=new j();this._buildContextMenu();q.sap.measure.start("rta.dt.startup","Measurement of RTA: DesignTime start up");this._oDesignTime=new D({rootElements:[this._oRootControl],plugins:[this._oRTADragDropPlugin,this._oCutPastePlugin,this._oRemovePlugin,this._oRenamePlugin,this._oSelectionPlugin,this._oMultiSelectionPlugin,this._oContextMenuPlugin,this._oTabHandlingPlugin]});q(a.getOverlayContainer()).addClass("sapUiRta");this._oDesignTime.attachSelectionChange(function(Q){N.fireSelectionChange({selection:Q.getParameter("selection")});},this);this._oDesignTime.attachEventOnce("synced",function(){N.fireStart();q.sap.measure.end("rta.dt.startup","Measurement of RTA: DesignTime start up");});this._oDesignTime.attachEventOnce("syncFailed",function(){N.fireFailed();});}if(this.getShowToolbars()){this._createToolsMenu();var P={"onAfterRendering":function(){this._oToolsMenu._oToolBar.focus();this._oToolsMenu._oToolBar.removeEventDelegate(P,this);}};this._oToolsMenu._oToolBar.addEventDelegate(P,this);this._oToolsMenu.show();}this._oldUnloadHandler=window.onbeforeunload;window.onbeforeunload=this._onUnload.bind(this);};t.prototype.setCommandStack=function(i){var N=this.getProperty("commandStack");if(N){N.detachModified(this._onCommandStackModified);}if(this._oInternalCommandStack){this._oInternalCommandStack.destroy();delete this._oInternalCommandStack;}var P=this.setProperty("commandStack",i);if(i){i.attachModified(this._onCommandStackModified);}if(this._oRenamePlugin){this._oRenamePlugin.setCommandStack(i);}return P;};t.prototype.getCommandStack=function(){var i=this.getProperty("commandStack");if(!i){i=new C();this._oInternalCommandStack=i;}this.setCommandStack(i);return i;};t.prototype._adaptUndoRedoButtons=function(){var i=this.getCommandStack();this._oToolsMenu.adaptUndoRedoEnablement(i.canUndo(),i.canRedo());this.fireUndoRedoStackModified();};t.prototype.closeToolBars=function(){this._oToolsMenu.hide();};t.prototype.getSelection=function(){if(this._oDesignTime){return this._oDesignTime.getSelection();}else{return[];}};t.prototype.stop=function(){var i=this;return this._serializeToLrep().then(function(){i.exit();i.fireStop();});};t.prototype.restore=function(){this._onRestore();};t.prototype.transport=function(){this._onTransport();};t.prototype.undo=function(){this._onUndo();};t.prototype.redo=function(){this._onRedo();};t.prototype.canUndo=function(){return this.getCommandStack().canUndo();};t.prototype.canRedo=function(){return this.getCommandStack().canRedo();};t.prototype._onUnload=function(){var i=this.getCommandStack();var N=i.canUndo()||i.canRedo();if(N&&this.getShowWindowUnloadDialog()){var P=this._oTextResources.getText("MSG_UNSAVED_CHANGES");return P;}else{window.onbeforeunload=this._oldUnloadHandler;}};t.prototype._serializeToLrep=function(){var N=this.getCommandStack();var P=F.createForControl(this._oRootControl);var Q=N.getSerializableCommands();Q.forEach(function(W,i){var X=W.getElement();var Y=W.getPreparedActionData();if(Y){P.addPreparedChange(Y.change||Y,X);}else{P.addChange(W.serialize(),X);}});var V=this;return P.saveAll().then(function(){q.sap.log.info("Runtime adaptation successfully transfered changes to layered repository");V.getCommandStack().removeAllCommands();},function(i){var W=i.message||i.status||i;q.sap.log.error("Failed to transfer runtime adaptation changes to layered repository",W);q.sap.require("sap.m.MessageBox");var X=V._oTextResources.getText("MSG_LREP_TRANSFER_ERROR")+"\n"+V._oTextResources.getText("MSG_ERROR_REASON",W);sap.m.MessageBox.error(X);});};t.prototype._onUndo=function(){this._handleStopCutPaste();this.getCommandStack().undo();};t.prototype._onRedo=function(){this._handleStopCutPaste();this.getCommandStack().redo();};t.prototype._createToolsMenu=function(){var i=this;if(!this._oToolsMenu){this._sAppTitle=this._getApplicationTitle();this._oToolsMenu=new T();this._oToolsMenu.createToolbar();this._oToolsMenu.setTitle(this._sAppTitle);this._oToolsMenu.setRootControl(this._oRootControl);this._oToolsMenu._checkTransportAvailable().then(function(N){i._bATOTransportEnabled=N;});this._oToolsMenu.attachToolbarClose(this.closeToolBars,this);this._oToolsMenu.attachClose(this.stop,this);this._oToolsMenu.attachTransport(this._onTransport,this);this._oToolsMenu.attachRestore(this._onRestore,this);this._oToolsMenu.attachUndo(this._onUndo,this);this._oToolsMenu.attachRedo(this._onRedo,this);}};t.prototype.exit=function(){if(this._oDesignTime){q(a.getOverlayContainer()).removeClass("sapUiRta");this._oDesignTime.destroy();this._oDesignTime=null;}if(this._oToolsMenu){this._oToolsMenu.destroy();this._oToolsMenu=null;}this.setCommandStack(null);window.onbeforeunload=this._oldUnloadHandler;};t.prototype._onTransport=function(){var i=this;var N=F.createForControl(this._oRootControl);function P(W){n.log.error("Changes could not be applied or saved: "+W);return i._showMessage(p.Icon.ERROR,"HEADER_TRANSPORT_APPLYSAVE_ERROR","MSG_TRANSPORT_APPLYSAVE_ERROR",W).then(function(){throw new Error('createAndApply failed');});}function Q(W){if(W.message==='createAndApply failed'){return;}n.log.error("transport error"+W);return i._showMessage(p.Icon.ERROR,"HEADER_TRANSPORT_ERROR","MSG_TRANSPORT_ERROR",W);}this._handleStopCutPaste();var V=new m();return this._serializeToLrep().then(function(){return N.getComponentChanges().then(function(W){if(W.length>0){return i._createAndApplyChanges(W,N);}})['catch'](P).then(function(){return N.getComponentChanges();}).then(function(W){return!!W.length;}).then(function(W){if(W){return V.openTransportSelection(null,i._oRootControl);}else{i._showMessageToast("MSG_TRANSPORT_SUCCESS");}}).then(function(W){if(W&&W.transport&&W.packageName!=="$TMP"){return i._transportAllLocalChanges(W,N);}})['catch'](Q);});};t.prototype._createAndApplyChanges=function(i,N){var P=this;return Promise.resolve().then(function(){function V(Q){return Q&&Q.selector&&Q.selector.id;}i.filter(V).forEach(function(Q){var W=sap.ui.getCore().byId(Q.selector.id);N.createAndApplyChange(Q,W);});})['catch'](function(Q){n.log.error("Create and apply error: "+Q);return Q;}).then(function(Q){return N.saveAll().then(function(){if(Q){throw Q;}});})['catch'](function(Q){n.log.error("Create and apply and/or save error: "+Q);return P._showMessage(p.Icon.ERROR,"HEADER_TRANSPORT_APPLYSAVE_ERROR","MSG_TRANSPORT_APPLYSAVE_ERROR",Q);});};t.prototype._deleteChanges=function(){var i=this;var N=new m();var P=F.createForControl(this._oRootControl);P.getComponentChanges().then(function(Q){return o.getInstance(n.getComponentClassName(i._oRootControl)).then(function(V){if(!V.isProductiveSystem()&&!V.hasMergeErrorOccured()){return N.setTransports(Q,i._oRootControl);}}).then(function(){return P.discardChanges(Q);}).then(function(){return window.location.reload();});})["catch"](function(Q){return i._showMessage(p.Icon.ERROR,"HEADER_RESTORE_FAILED","MSG_RESTORE_FAILED",Q);});};t.prototype._showMessage=function(i,N,P,Q){if(Q){var V=this._oTextResources.getText(P,[Q.message||Q]);}else{var V=this._oTextResources.getText(P);}var W=this._oTextResources.getText(N);return new Promise(function(X){p.show(V,{icon:i,title:W,onClose:X});});};t.prototype._showMessageToast=function(i){var N=this._oTextResources.getText(i);r.show(N);};t.needsRestart=function(){var i=!!window.localStorage.getItem("sap.ui.rta.restart");return i;};t.enableRestart=function(){window.localStorage.setItem("sap.ui.rta.restart",true);};t.disableRestart=function(){window.localStorage.removeItem("sap.ui.rta.restart");};t.prototype._onRestore=function(){var i=this;var N=this._oTextResources.getText("FORM_PERS_RESET_MESSAGE");var P=this._oTextResources.getText("FORM_PERS_RESET_TITLE");this._handleStopCutPaste();function Q(V){if(V==="OK"){i.getCommandStack().removeAllCommands();t.enableRestart();i._deleteChanges();}}p.confirm(N,{icon:p.Icon.WARNING,title:P,onClose:Q});};t.prototype._transportAllLocalChanges=function(i,N){var P=this;return N.getComponentChanges().then(function(Q){var V=new l();var W=V._convertToChangeTransportData(Q);var X={};X.transportId=i.transport;X.changeIds=W;return V.makeChangesTransportable(X).then(function(){Q.forEach(function(Y){if(Y.getPackage()==='$TMP'){var Z=Y.getDefinition();Z.packageName='';Y.setResponse(Z);}});}).then(function(){P._showMessageToast("MSG_TRANSPORT_SUCCESS");});});};t.prototype._isEqualParentInfo=function(i,N){var P=!!i&&!!N;if(P&&(i.parent&&N.parent)){P=i.parent.getId()===N.parent.getId();}if(P&&(i.index||N.index)){P=i.index===N.index;}if(P&&(i.aggregation||N.aggregation)){P=i.aggregation===N.aggregation;}return P;};t.prototype._handleElementModified=function(i){this._handleStopCutPaste();var N=i.getParameter("command");if(N instanceof sap.ui.rta.command.BaseCommand){this.getCommandStack().pushAndExecute(N);}};t.prototype._handleRemoveElement=function(i){this._oRemovePlugin.removeElement(i);};t.prototype._openSettingsDialog=function(i){var N=(i.mParameters)?i.getParameter("selectedOverlays"):i;var P=N[0].getElementInstance();this._handleStopCutPaste();if(!this._oSettingsDialog){this._oSettingsDialog=new k();}this._oSettingsDialog.setCommandStack(this.getCommandStack());this._oSettingsDialog.open(P);};var u=function(i){return this._oDesignTime.getSelection().length<2;};var H=function(i){var N=i.getElementInstance();return s.getControlAnalyzerFor(N).hasParentStableId(i);};var I=function(i){return i.getMovable();};var v=function(i){return i.getElementInstance().getMetadata().getName()==="sap.ui.comp.smartform.GroupElement";};var w=function(i){return i.getElementInstance().getMetadata().getName()==="sap.ui.comp.smartform.Group";};var x=function(i){var N=i.getElementInstance();var P=s.getControlAnalyzerFor(N);if(P._getSimpleFormContainer){return!!P._getSimpleFormContainer(N);}else{return false;}};var y=function(i){return i.getElementInstance().getMetadata().getName()==="sap.ui.comp.smartform.SmartForm";};var z=function(i){var N=i.getElementInstance();return N.getMetadata().getName()==="sap.uxap.ObjectPageSection";};var B=function(i){var N=i.getElementInstance();return N.getMetadata().getName()==="sap.uxap.ObjectPageLayout";};var G=function(i){return this._oRemovePlugin.isRemoveAvailable(i);};var J=function(i){return this._oRemovePlugin.isRemoveEnabled(i);};var K=function(i){return this._oRenamePlugin.isRenameAvailable(i);};var L=function(i){return this._oRenamePlugin.isRenameEnabled(i);};t.prototype._buildContextMenu=function(){var i=this;this._oContextMenuPlugin.addMenuItem({id:"CTX_RENAME_LABEL",text:i._oTextResources.getText("CTX_RENAME"),handler:this._handleRename.bind(this),available:K.bind(this),enabled:function(N){return(u.call(i,N)&&L.call(i,N));}});this._oContextMenuPlugin.addMenuItem({id:"CTX_ADD_FORM_FIELD",text:i._oTextResources.getText("CTX_ADD_FIELD"),handler:this._handleAddElement.bind(this),available:function(N){var P=N.getElementInstance();return x(N)&&((E.isInstanceOf(P,"sap.ui.layout.form.FormElement"))||(E.isInstanceOf(P,"sap.ui.layout.form.FormContainer")&&P.getTitle()!==null)||(E.isInstanceOf(P,"sap.ui.layout.form.FormContainer")&&P.getToolbar()!==null));},enabled:H});this._oContextMenuPlugin.addMenuItem({id:"CTX_ADD_FIELD",text:i._oTextResources.getText("CTX_ADD_FIELD"),handler:this._handleAddElement.bind(this),available:function(N){return w(N)||v(N);},enabled:function(N){return u.call(i,N)&&(w(N)||H(N));}});this._oContextMenuPlugin.addMenuItem({id:"CTX_ADD_FORM_GROUP",text:i._oTextResources.getText("CTX_ADD_GROUP"),handler:this._handleAddGroup.bind(this),available:function(N){var P=N.getElementInstance();return x(N)&&!E.isInstanceOf(P,"sap.ui.layout.form.FormElement");},enabled:H});this._oContextMenuPlugin.addMenuItem({id:"CTX_ADD_GROUP",text:i._oTextResources.getText("CTX_ADD_GROUP"),handler:this._handleAddGroup.bind(this),available:function(N){return w(N)||y(N);},enabled:function(N){return y(N)||(w(N)&&H(N));}});this._oContextMenuPlugin.addMenuItem({id:"CTX_ADD_SECTION",text:i._oTextResources.getText("CTX_ADD_SECTION"),handler:this._handleAddElement.bind(this),available:function(N){return z(N)||B(N);},enabled:function(N){return U.hasObjectPageLayoutInvisibleSections.bind(U)&&(B(N)||H(N));}});this._oContextMenuPlugin.addMenuItem({id:"CTX_REMOVE",text:i._oTextResources.getText("CTX_REMOVE"),handler:this._handleRemoveElement.bind(this),available:G.bind(this),enabled:J.bind(this)});this._oContextMenuPlugin.addMenuItem({id:"CTX_CUT",text:i._oTextResources.getText("CTX_CUT"),handler:this._handleCutElement.bind(this),available:I});this._oContextMenuPlugin.addMenuItem({id:"CTX_PASTE",text:i._oTextResources.getText("CTX_PASTE"),handler:this._handlePasteElement.bind(this),available:I,enabled:function(N){return i._oCutPastePlugin.isElementPasteable(N);}});this._oContextMenuPlugin.addMenuItem({id:"CTX_GROUP_FIELDS",text:i._oTextResources.getText("CTX_GROUP_FIELDS"),handler:this._handleGroupElements.bind(this),available:function(){var N=i._oDesignTime.getSelection();return(N.length>1);},enabled:function(){var N=true;var P=[];var Q=i._oDesignTime.getSelection();Q.forEach(function(V){var W=V.getElementInstance();P=P.concat(W.getFields());});if(Q.length>3||P.length>3){return false;}Q.some(function(V){var W=V.getElementInstance();if(U.hasGroupElementUnBoundFields(W)){N=false;return true;}});return N;}});this._oContextMenuPlugin.addMenuItem({id:"CTX_UNGROUP_FIELDS",text:i._oTextResources.getText("CTX_UNGROUP_FIELDS"),handler:this._handleUngroupElements.bind(this),available:function(N){var P=N.getElementInstance();var Q=i._oDesignTime.getSelection();return v(N)&&P.getFields().length>1&&Q.length<2;},enabled:function(N){var P=N.getElementInstance();return!U.hasGroupElementUnBoundFields(P);}});this._oContextMenuPlugin.addMenuItem({id:"CTX_SETTINGS",text:"Settings",handler:this._openSettingsDialog.bind(this),available:function(N){var P=N.getElementInstance();if(n.isVendorLayer()&&i.getShowSettingsDialog()){var Q=["sap.ui.comp.smartfilterbar.SmartFilterBar","sap.ui.comp.smarttable.SmartTable","sap.ui.comp.smartform.SmartForm","sap.uxap.ObjectPageLayout","sap.uxap.ObjectPageSection","sap.uxap.ObjectPageHeaderActionButton","sap.uxap.ObjectPageHeader","sap.ui.table.Column"];return Q.some(function(V){return E.isInstanceOf(P,V);});}}});};t.prototype._handleRename=function(i){var N=i[0];this._oRenamePlugin.startEdit(N);};t.prototype._handleAddElement=function(i){this._handleStopCutPaste();var N=i[0].getElementInstance();if(!this._oAddElementsDialog){this._oAddElementsDialog=new A({rootControl:this._oRootControl});}this._oAddElementsDialog.setCommandStack(this.getCommandStack());this._oAddElementsDialog.open(N);};t.prototype._handleCutElement=function(i){var N=i[0];this._oCutPastePlugin.cut(N);};t.prototype._handlePasteElement=function(i){var N=i[0];this._oCutPastePlugin.paste(N);};t.prototype._handleStopCutPaste=function(){this._oCutPastePlugin.stopCutAndPaste();};t.prototype._handleGroupElements=function(){this._handleStopCutPaste();var N=this._oDesignTime.getSelection();var P=this._oContextMenuPlugin.getContextElement();var Q=U.getClosestTypeForControl(P,"sap.ui.comp.smartform.Group");var V=Q.getGroupElements().indexOf(P);var W=U.findSupportedBlock(P,this._aSupportedControls);var X=U.getClosestTypeForControl(P,"sap.ui.comp.smartform.SmartForm");var Y=[];for(var i=0;i<N.length;i++){var Z=N[i].getElementInstance();Y.push(Z);}var $=b.getCommandFor(W,"Group",{source:P,index:V,groupFields:Y,smartForm:X});this.getCommandStack().pushAndExecute($);};t.prototype._handleUngroupElements=function(){this._handleStopCutPaste();var i=this._oContextMenuPlugin.getContextElement();var N=U.getClosestTypeForControl(i,"sap.ui.comp.smartform.SmartForm");var P=b.getCommandFor(i,"Ungroup",{smartForm:N});this.getCommandStack().pushAndExecute(P);};t.prototype._handleAddGroup=function(i){this._handleStopCutPaste();var N=this;var P=i[0].getElementInstance();var V=n.getViewForControl(P);var Q=s.getControlAnalyzerFor(P);var W=Q.getClosestType(P);var X=0;X=Q._determineGroupIndex(P);var Y=b.getCommandFor(W,"Add",{newControlId:V.createId(q.sap.uid()),labels:["New Group"],index:X});this.getCommandStack().pushAndExecute(Y);var Z;if(Y._getParentElementId){Z=O.getOverlay(Y._getParentElementId());}else{Z=O.getOverlay(Y.getNewControlId());}Z.setSelected(true);var $={"onAfterRendering":function(){setTimeout(function(){N._oRenamePlugin.startEdit(Z);},0);Z.removeEventDelegate($);}};Z.addEventDelegate($);};t.prototype._getSmartFormForElement=function(i){while(i&&!E.isInstanceOf(i,"sap.ui.comp.smartform.SmartForm")){i=i.getParent();}return i;};t.prototype._getApplicationTitle=function(){var i="";var N=sap.ui.core.Component.getOwnerComponentFor(this._oRootControl);if(N){i=N.getMetadata().getManifestEntry("sap.app").title;}return i;};return t;},true);
