/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

(c) Copyright 2009-2016 SAP SE. All rights reserved
 */
sap.ui.define(['jquery.sap.global','sap/ui/fl/Utils','sap/ui/dt/OverlayUtil','sap/ui/comp/odata/FieldSelectorModelConverter','sap/ui/fl/registry/Settings','sap/ui/comp/smartform/GroupElement','sap/ui/comp/smartform/Group','sap/ui/comp/smartfield/SmartField','sap/uxap/ObjectPageSection','sap/uxap/ObjectPageLayout','sap/ui/core/StashedControlSupport','sap/m/MessageBox','sap/ui/comp/odata/MetadataAnalyser','sap/ui/rta/model/ElementPreprocessor'],function(q,F,O,a,S,G,b,c,d,e,f,M,g,E){"use strict";var U={};U.RESOLVED_PROMISE=Promise.resolve(true);U._sFocusableOverlayClass=".sapUiDtOverlaySelectable";U.isExtensibilityEnabledInSystem=function(C){var s=F.getComponentClassName(C);if(!s||s==""){return Promise.resolve(false);}return S.getInstance(s).then(function(o){if(o.isModelS){return o.isModelS();}return false;});};U.isServiceUpToDate=function(C){return this.isExtensibilityEnabledInSystem(C).then(function(h){if(h){q.sap.require("sap.ui.fl.fieldExt.Access");var m=C.getModel();if(m){var s=sap.ui.fl.fieldExt.Access.isServiceOutdated(m.sServiceUrl);if(s){sap.ui.fl.fieldExt.Access.setServiceValid(m.sServiceUrl);sap.ui.getCore().getEventBus().publish("sap.ui.core.UnrecoverableClientStateCorruption","RequestReload",{});return false;}}}return true;});};U.isCustomFieldAvailable=function(C){var t=this;return this.isExtensibilityEnabledInSystem(C).then(function(s){if(!s){return false;}else{var o=new a(C.getModel());var m=o.getMetaDataAnalyzer();var h=t.getBoundEntityType(C);try{q.sap.require("sap.ui.fl.fieldExt.Access");var j=sap.ui.fl.fieldExt.Access.getBusinessContexts(m.oModel.sServiceUrl,h);return Promise.resolve(j).then(function(r){if(r){if(r.BusinessContexts){if(r.BusinessContexts.length>0){r.EntityType=h;return r;}}}}).catch(function(k){if(k){if(q.isArray(k.errorMessages)){for(var i=0;i<k.errorMessages.length;i++){q.sap.log.error(k.errorMessages[i].text);}}}return false;});}catch(k){q.sap.log.error("exception occured in sap.ui.fl.fieldExt.Access.getBusinessContexts",k);return Promise.resolve();}}});};U.openRemoveConfirmationDialog=function(o,t){var T=sap.ui.getCore().getLibraryResourceBundle("sap.ui.rta");var s;return new Promise(function(r,h){s=T.getText("CTX_REMOVE_TITLE");var i={messageText:t,titleText:s,icon:"sap-icon://question-mark",removeText:T.getText("BTN_FREP_REMOVE"),cancelText:T.getText("BTN_FREP_CANCEL")};var m=new sap.ui.model.json.JSONModel();m.setData(i);var j;var C=function(){if(j){j.close();j.destroy();j=null;}};var k={removeField:function(){C();r(true);},closeDialog:function(){C();r(false);}};if(!j){j=sap.ui.xmlfragment("sap.ui.rta.view.RemoveElementDialog",k);j.setModel(m);}j.open();});};U.isMandatorySmartField=function(o){return(o instanceof c)&&o.getMandatory();};U.isOverlaySelectable=function(o){return o.isSelectable()&&o.$().is(":visible");};U.getPropertyValue=function(o,p){var m=o.getMetadata().getPropertyLikeSetting(p);var P=m._sGetter;return o[P]();};U.getOverlayInstanceForDom=function(D){var i=q(D).attr("id");if(i){return sap.ui.getCore().byId(i);}};U.getFocusedOverlay=function(){if(document.activeElement){var o=sap.ui.getCore().byId(document.activeElement.id);if(o instanceof sap.ui.dt.ElementOverlay){return o;}}};U.getFirstFocusableChildOverlay=function(o){var h=O.getFirstChildOverlay(o);while(h&&!this.isOverlaySelectable(h)){h=O.getNextSiblingOverlay(h);}return h;};U.getNextFocusableSiblingOverlay=function(o){var n=O.getNextSiblingOverlay(o);while(n&&!this.isOverlaySelectable(n)){n=O.getNextSiblingOverlay(n);}return n;};U.getPreviousFocusableSiblingOverlay=function(o){var p=O.getPreviousSiblingOverlay(o);while(p&&!this.isOverlaySelectable(p)){p=O.getPreviousSiblingOverlay(p);}return p;};U.getClosestTypeForControl=function(C,t){if(C&&C.getMetadata().getName()!==t){return this.getClosestTypeForControl(C.getParent(),t);}return C;};U._checkIsSupportedControl=function(C,s){for(var i=0;i<s.length;i++){if(C.getMetadata().getName()===s[i]){return true;}}};U.hasGroupUnBoundFields=function(o){var h=o.getGroupElements();for(var j=0;j<h.length;j++){var i=h[j];if(!this.hasGroupElementBoundFields(i)){return true;}}return false;};U.hasGroupElementBoundFields=function(o){var h=o.getFields();if(h.length===0||!o.getVisible()){return true;}for(var j=0;j<h.length;j++){var i=h[j];if(!i.getDomRef()){continue;}if(this._isElementBound(i)){return true;}}return false;};U.hasGroupElementUnBoundFields=function(o){var h=o.getFields();if(h.length===0){return true;}for(var j=0;j<h.length;j++){var i=h[j];if(!i.getDomRef()){continue;}if(!this._isElementBound(i)){return true;}}return false;};U.getGroupMandatoryElements=function(o){var r=[];if(o instanceof b){var h=o.getGroupElements();for(var i=0;i<h.length;i++){var k=h[i];var l=k.getFields();for(var j=0;j<l.length;j++){var m=l[j];if(!m.getDomRef()){continue;}if(this.isMandatorySmartField(m)){r.push(k);break;}}}}return r;};U.getObjectPageSections=function(o){var h;var s=[];var i=[];if(o.getMetadata().getName()==="sap.uxap.ObjectPageSection"){h=o.getParent();}else if(o.getMetadata().getName()==="sap.uxap.ObjectPageLayout"){h=o;}s=h.getAggregation("sections");i=f.getStashedControls(h.getId());s=s.concat(i);return s;};U.hasObjectPageLayoutInvisibleSections=function(o){var s=U.getObjectPageSections(o);if(s.length===0){return false;}for(var i=0;i<s.length;i++){if((s[i].getVisible&&s[i].getVisible()===false)||(s[i].getStashed&&s[i].getStashed()===true)){return true;}}return false;};U._isElementBound=function(o){var B=o.mBindingInfos;if(Object.keys(B).length===0){return false;}else{for(var p in B){var P=B[p].parts;for(var i=0;i<P.length;i++){if(P[i].model){var m=o.getModel(P[i].model).getMetadata().getName();if(m==="sap.ui.model.odata.ODataModel"||m==="sap.ui.model.odata.v2.ODataModel"){return true;}}else{var m=o.getModel().getMetadata().getName();if(m==="sap.ui.model.odata.ODataModel"||m==="sap.ui.model.odata.v2.ODataModel"){return true;}}}}}};U.determineTargetIndex=function(s,o,C,i){var h=o.getMetadata().getClass();var t=(s instanceof h)?C.length-i:C.indexOf(s)+1;return t;};U.findSupportedBlock=function(C,s){if(this._checkIsSupportedControl(C,s)){return C;}else{C=C.getParent();while(C){if(this._checkIsSupportedControl(C,s)){return C;}C=C.getParent();}}};U.createFieldLabelId=function(o,s,B){var C=o.getId()+"_"+s+"_"+B;C=C.replace("/","_");return C;};U.getLabelForElement=function(o){var s=o.getLabelText?o.getLabelText():undefined;if(!s){s=o.getLabel?o.getLabel():undefined;}if(!s){s=o.getText?o.getText():undefined;}return(typeof s)==="string"?s:undefined;};U.getPathFromBindingInfo=function(i,B){var p=B[i]?B[i]:undefined;if(p){if((p.parts instanceof Array)&&p.parts.length>0){p=p.parts[0]?p.parts[0]:undefined;}p=((typeof p.path)==="string")?p.path:p;}if((typeof p)==="string"){p=p;}else{p=undefined;}return p;};U.getBoundEntityType=function(o,m){var _=m?m:o.getModel();var B=o.getBindingContext();var h=_.oMetadata._getEntityTypeByPath(B.getPath());return h.name;};U.openNewWindow=function(u){window.open(u,"_blank");};U.fetchODataPropertiesFor=function(m){var t=this;if(!m){return new Promise(function(r,h){h();});}var o=m.getMetaModel();return o.loaded().then(function(){t._oMetadataAnalyzer=new g(m);var h=new E(t._oMetadataAnalyzer);var i=t._oMetadataAnalyzer.getAllEntityTypeNames();var A={};i.forEach(function(s){A[s]=t._oMetadataAnalyzer.getFieldsByEntityTypeName(s);});Object.keys(A).forEach(function(s){A[s]=h._updateAndFilterFields(A[s]);});return A;},function(r){q.sap.log.error("MetadataModel could not be loaded",r);});};U.getElementBindingPaths=function(o){var p={};if(o.mBindingInfos){for(var i in o.mBindingInfos){var P=o.mBindingInfos[i].parts[0].path?o.mBindingInfos[i].parts[0].path:"";P=P.split("/")[P.split("/").length-1];p[P]={valueProperty:i};}}return p;};U.findFieldBindingPathInFieldsArray=function(p,h){var P=Object.keys(p);var D=Object.keys(h);var s="";P.forEach(function(i){if(D.indexOf(i)>=0){s=D[D.indexOf(i)];}});return s;};U.createNewAddFieldsCommand=function(s,o,i,j,l,v,h){q.sap.require("sap.ui.rta.command.CommandFactory");var A=sap.ui.rta.command.CommandFactory.getCommandFor(o,"Add",{newControlId:U.createNewSmartFormGroupElementId(s,h),index:i,jsTypes:j,labels:l,fieldValues:h,valuePropertys:v});return A;};U.createNewSmartFormGroupElementId=function(p,P){var s="";var t=P.slice();var h=t.sort();for(var i=0;i<h.length;i++){var j=h[i].replace("/","_");s=s+"__"+j;}return p.getId()+s;};return U;},true);
