/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

(c) Copyright 2009-2016 SAP SE. All rights reserved
 */
sap.ui.define(['jquery.sap.global','sap/ui/dt/Plugin','sap/ui/dt/ElementUtil','sap/ui/dt/OverlayUtil','sap/ui/dt/OverlayRegistry','sap/ui/rta/Utils','sap/ui/rta/command/Stack','sap/ui/rta/command/CommandFactory','sap/ui/dt/DOMUtil'],function(q,P,E,O,a,U,C,b,D){"use strict";var R=P.extend("sap.ui.rta.plugin.Rename",{metadata:{library:"sap.ui.rta",properties:{commandStack:{type:"sap.ui.rta.commandStack"},oldValue:"string"},associations:{},events:{"editable":{},"nonEditable":{}}}});R.prototype.exit=function(){P.prototype.exit.apply(this,arguments);if(this._$oEditableControlDomRef){this._stopEdit();}clearTimeout(this._iStopTimeout);};R.prototype.setDesignTime=function(d){this._aSelection=[];var o=this.getDesignTime();if(o){o.detachSelectionChange(this._onDesignTimeSelectionChange,this);}P.prototype.setDesignTime.apply(this,arguments);if(d){d.attachSelectionChange(this._onDesignTimeSelectionChange,this);this._aSelection=d.getSelection();}};R.prototype._getEffectiveDesignTimeMetadata=function(o){var d;if(o.isInHiddenTree()){var p=o.getPublicParentAggregationOverlay();if(p){d=p.getDesignTimeMetadata();}}else{d=o.getDesignTimeMetadata();}return d;};R.prototype._getRenameAction=function(o){var d=this._getEffectiveDesignTimeMetadata(o);if(d&&d.getAction){return d.getAction("rename",o.getElementInstance());}else{return;}};R.prototype.isRenameAvailable=function(o){var r=this._getRenameAction(o);if(r){return true;}else{return false;}};R.prototype.isRenameEnabled=function(o){var A=this._getRenameAction(o);if(!A){return false;}if(typeof A.isEnabled!=="undefined"){if(typeof A.isEnabled==="function"){return A.isEnabled(o.getElementInstance());}else{return A.isEnabled;}}return true;};R.prototype.registerElementOverlay=function(o){o.attachEvent("editableChange",this._manageClickEvent,this);if(this.isRenameAvailable(o)){o.setEditable(true);}};R.prototype.deregisterElementOverlay=function(o){o.detachEvent("editableChange",this._manageClickEvent,this);o.detachBrowserEvent("click",this._onClick,this);};R.prototype._onClick=function(e){var o=sap.ui.getCore().byId(e.currentTarget.id);if(this.isRenameEnabled(o)){this.startEdit(o);e.preventDefault();}};R.prototype._onDesignTimeSelectionChange=function(e){var t=this;var s=e.getParameter("selection");s.forEach(function(o){if(t._aSelection.indexOf(o)===-1){t._aSelection.push(o);}});t._aSelection.forEach(this._manageClickEvent,this);};R.prototype._manageClickEvent=function(e){var o=e.getSource?e.getSource():e;if(o.isSelected()&&this.isRenameAvailable(o)){o.attachBrowserEvent("click",this._onClick,this);}else{o.detachBrowserEvent("click",this._onClick,this);}};R.prototype.startEdit=function(o){this._oEditedOverlay=o;var e=o.getElementInstance();var d=this._getEffectiveDesignTimeMetadata(this._oEditedOverlay);var c=d.getAction("rename",e).domRef(e);this._$oEditableControlDomRef=q(c);var f=sap.ui.dt.OverlayRegistry.getOverlay(c.id)||o;var w=q("<div class='sapUiRtaEditableField'></div>").appendTo(f.$());this._$editableField=q("<div contentEditable='true'></div>").appendTo(w);if(this._$oEditableControlDomRef.text()===""){this._$oEditableControlDomRef.text("_?_");this._$editableField.text("");}else{this._$editableField.text(this._$oEditableControlDomRef.text());}D.copyComputedStyles(this._$oEditableControlDomRef,this._$editableField);this._$editableField.children().remove();this._$editableField.css({"-moz-user-modify":"read-write","-webkit-user-modify":"read-write","-ms-user-modify":"read-write","user-modify":"read-write","text-overflow":"clip","margin-top":parseInt(this._$editableField.css("margin-top"),10)-1+"px","margin-left":parseInt(this._$editableField.css("margin-left"),10)-1+"px"});this._$oEditableControlDomRef.css("visibility","hidden");this._$editableField.one("focus",this._onEditableFieldFocus.bind(this));this._$editableField.on("blur",this._onEditableFieldBlur.bind(this));this._$editableField.on("keydown",this._onEditableFieldKeydown.bind(this));this._$editableField.on("dragstart",this._stopPropagation.bind(this));this._$editableField.on("drag",this._stopPropagation.bind(this));this._$editableField.on("dragend",this._stopPropagation.bind(this));this._$editableField.on("click",this._stopPropagation.bind(this));this._$editableField.on("mousedown",this._stopPropagation.bind(this));this._$editableField.focus();this.setOldValue(this._getCurrentEditableFieldText());};R.prototype._stopPropagation=function(e){e.stopPropagation();};R.prototype._onEditableFieldFocus=function(e){this._oEditedOverlay.setSelected(false);var c=e.target;var r=document.createRange();r.selectNodeContents(c);var s=window.getSelection();s.removeAllRanges();s.addRange(r);};R.prototype._stopEdit=function(r){if(this._$oEditableControlDomRef.text()==="_?_"){this._$oEditableControlDomRef.text("");}this._oEditedOverlay.$().find(".sapUiRtaEditableField").remove();this._$oEditableControlDomRef.css("visibility","visible");if(r){var o=this._oEditedOverlay;this._iStopTimeout=setTimeout(function(){o.setSelected(true);o.focus();},0);}delete this._$editableField;delete this._$oEditableControlDomRef;delete this._oEditedOverlay;};R.prototype._onEditableFieldBlur=function(e){this._emitLabelChangeEvent();this._stopEdit();};R.prototype._onEditableFieldKeydown=function(e){if(e.keyCode===q.sap.KeyCodes.ENTER){e.preventDefault();this._emitLabelChangeEvent();this._stopEdit(true);}else if(e.keyCode===q.sap.KeyCodes.ESCAPE){e.preventDefault();this._stopEdit(true);}};R.prototype._emitLabelChangeEvent=function(){var t=this._getCurrentEditableFieldText();if(this.getOldValue()!==t){this._$oEditableControlDomRef.text(t);try{var r;var e;var o=this._oEditedOverlay.getElementInstance();if(this._oEditedOverlay.isInHiddenTree()){e=this._oEditedOverlay.getPublicParentElementOverlay().getElementInstance();}else{e=o;}r=b.getCommandFor(e,"Rename",{renamedElement:o,newValue:t},this._getRenameAction(this._oEditedOverlay));this.getCommandStack().pushAndExecute(r);}catch(c){q.sap.log.error("Error during rename : ",c);}}};R.prototype._getCurrentEditableFieldText=function(){return this._$editableField.text();};return R;},true);
