/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/Device','./_LogCollector','./_ParameterValidator'],function($,D,_,a){"use strict";var l=$.sap.log.getLogger("sap.ui.test.Opa",_.DEFAULT_LEVEL_FOR_OPA_LOGGERS),L=_.getInstance(),q=[],c={},t=-1,i,d,v=new a({errorPrefix:"sap.ui.test.Opa#waitFor"});function b(C,o,d){if(window["sap-ui-debug"]){o.timeout=300;}var j=new Date();k();function k(){var r;L.getAndClearLog();try{r=C();}catch(m){d.reject(o,m);throw m;}if(r.result){e(d);return;}var n=new Date()-j;n/=1000;var p=Math.round(n%60);if(o.timeout>p){t=setTimeout(k,o.pollingInterval);return;}if(o.error){try{o.error(o,r.arguments);}finally{d.reject(o);}return;}d.reject(o);}}function e(j){if(q.length===0){j.resolve();return true;}var k=q.shift();t=setTimeout(function(){b(k.callback,k.options,j);},O.config.executionDelay);}function f(w,n){var N=w.get();if(N){var j=q.splice(q.length-N,N);j.forEach(function(k){k.options._nestedIn=n;});q=j.concat(q);}}function g(j){j=(j||0)+2;if(D.browser.mozilla){j=j-1;}var o=new Error(),k=o.stack;if(!k){try{throw o();}catch(m){k=m.stack;}}if(!k){return"";}k=k.split("\n");k.splice(0,j);return k.join("\n");}function h(o){var r="\nCallstack:\n";if(o._stack){r+=o._stack;delete o._stack;}else{r+="Unknown";}if(o._nestedIn){r+=h(o._nestedIn);delete o._nestedIn;}return r;}var O=function(j){this.and=this;$.extend(this,j);};O.config={};O.extendConfig=function(o){["actions","assertions","arrangements"].forEach(function(A){if(!o[A]){return;}Object.keys(O.config[A]).forEach(function(k){if(!o[A][k]){o[A][k]=O.config[A][k];}});});O.config=$.extend(O.config,o);};var E,s=$.sap.getUriParameters().get("opaExecutionDelay");if(s){E=parseInt(s,10);}if(!E){if(D.browser.msie){E=50;}else{E=0;}}O.resetConfig=function(){O.config={arrangements:new O(),actions:new O(),assertions:new O(),executionDelay:E,timeout:15,pollingInterval:400,_stackDropCount:0};};O.getContext=function(){return c;};O.emptyQueue=function emptyQueue(){d=$.Deferred();i=false;e(d);return d.promise().fail(function(o,j){q=[];var S,k;if(i){k=o.stoppedManually?"Queue was stopped manually":"QUnit timeout";S={_stack:g(1)};}else if(!o.errorMessage&&!j){k="Opa timeout";}else if(j){var m=j.toString();if(j.stack){m+="\n"+j.stack;}k="Exception thrown by the testcode:'"+m+"'";}if(!S){S=o;}var n=L.getAndClearLog();if(n){k+="\nThis is what Opa logged:\n"+n;}if(!(j&&j.stack)){k+=h(S);}l.error(k,"Opa");o.errorMessage=k;}).always(function(){t=-1;d=null;});};O.stopQueue=function stopQueue(){O._stopQueue(true);};O._stopQueue=function(S){q=[];if(!d){l.warning("stopQueue was called before emptyQueue, queued tests have never been executed","Opa");}else{if(t!==-1){clearTimeout(t);}i=true;d.reject({stoppedManually:S});}};O.resetConfig();O.prototype={getContext:O.getContext,waitFor:function(o){var j=$.Deferred(),F=O._createFilteredConfig(O._aConfigValuesForWaitFor);o=$.extend({},F,o);this._validateWaitFor(o);o._stack=g(1+o._stackDropCount);delete o._stackDropCount;j.promise(this);q.push({callback:function(){var r=true;if(o.check){try{r=o.check.apply(this,arguments);}catch(k){j.reject(o,k);throw k;}}if(i){return{result:true,arguments:arguments};}if(r){if(o.success){var w=O._getWaitForCounter();try{o.success.apply(this,arguments);}finally{f(w,o);}}j.resolve();return{result:true,arguments:arguments};}return{result:false,arguments:arguments};}.bind(this),options:o});return this;},extendConfig:O.extendConfig,emptyQueue:O.emptyQueue,_validateWaitFor:function(p){v.validate({validationInfo:O._validationInfo,inputToValidate:p});}};O._createFilteredOptions=function(A,S){var F={};A.forEach(function(k){var C=S[k];if(C===undefined){return;}F[k]=C;});return F;};O._createFilteredConfig=function(A){return O._createFilteredOptions(A,O.config);};O._getWaitForCounter=function(){var Q=q.length;return{get:function(){var j=q.length-Q;return Math.max(j,0);}};};O._aConfigValuesForWaitFor=["errorMessage","timeout","pollingInterval","_stackDropCount"];O._validationInfo={error:"func",check:"func",success:"func",timeout:"numeric",pollingInterval:"numeric",_stackDropCount:"numeric",errorMessage:"string"};return O;},true);
