/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','./Opa','./OpaPlugin','./PageObjectFactory','sap/ui/base/Object','sap/ui/Device','./launchers/iFrameLauncher','./launchers/componentLauncher','sap/ui/core/routing/HashChanger','./matchers/Matcher','./matchers/AggregationFilled','./matchers/PropertyStrictEquals','./pipelines/MatcherPipeline','./pipelines/ActionPipeline','./_ParameterValidator','./_LogCollector'],function($,O,a,P,U,D,f,c,H,M,A,b,d,e,_,g){"use strict";var l=$.sap.log.getLogger("sap.ui.test.Opa5",g.DEFAULT_LEVEL_FOR_OPA_LOGGERS),p=new a(f._sLogPrefix),o=new e(),F="OpaFrame",v=new _({errorPrefix:"sap.ui.test.Opa5#waitFor"}),C=["visible","viewNamespace","viewName","autoWait"].concat(O._aConfigValuesForWaitFor),h=["check","error","success"].concat(O._aConfigValuesForWaitFor);var i=U.extend("sap.ui.test.Opa5",$.extend({},O.prototype,{constructor:function(){O.apply(this,arguments);}}));function s(S,T){this.waitFor({viewName:null,controlType:null,id:null,searchOpenDialogs:false,success:function(){j(S);}});var m=k();m.check=f.hasLaunched;m.timeout=T||80;m.errorMessage="unable to load the IFrame with the url: "+S;return this.waitFor(m);}i.prototype.iStartMyUIComponent=function iStartMyUIComponent(m){var n=false;m=m||{};var q=k();q.success=function(){var u=jQuery.sap.getModulePath("sap.ui.test.OpaCss",".css");$.sap.includeStyleSheet(u);H.getInstance().setHash(m.hash||"");c.start(m.componentConfig).then(function(){n=true;});};this.waitFor(q);var r=k();r.errorMessage="Unable to load the component with the name: "+m.name;r.check=function(){return n;};if(m.timeout){r.timeout=m.timeout;}return this.waitFor(r);};i.prototype.iTeardownMyUIComponent=function iTeardownMyUIComponent(){var m=k();m.success=function(){c.teardown();};return this.waitFor(m);};i.prototype.iTeardownMyApp=function(){var m=k();m.success=function(){if(f.hasLaunched()){this.iTeardownMyAppFrame();}else if(c.hasLaunched()){this.iTeardownMyUIComponent();}else{var E="A teardown was called but there was nothing to tear down use iStartMyComponent or iStartMyAppInAFrame";l.error(E,"Opa");throw new Error(E);}}.bind(this);return this.waitFor(m);};i.iStartMyAppInAFrame=s;i.prototype.iStartMyAppInAFrame=s;function t(){return this.waitFor({success:function(){f.teardown();}});}i.iTeardownMyAppFrame=t;i.prototype.iTeardownMyAppFrame=t;i.prototype.waitFor=function(m){var n=m.actions,q=O._createFilteredConfig(C),r;m=$.extend({},q,m);m.actions=n;v.validate({validationInfo:i._validationInfo,inputToValidate:m});var u=m.check,w=null,x=m.success,R,y;r=O._createFilteredOptions(h,m);r.check=function(){var p=i.getPlugin();R=p.getFilterdControls(m,w);if(f.hasLaunched()&&$.isArray(R)){var z=[];R.forEach(function(B){z.push(B);});R=z;}if(R===a.FILTER_FOUND_NO_CONTROLS){return false;}if(u){return this._executeCheck(u,R);}return true;};r.success=function(){var W=O._getWaitForCounter();if(n&&(R||!y)){o.process({actions:n,control:R});}if(!x){return;}var z=[];if(R){z.push(R);}if(W.get()===0){x.apply(this,z);return;}var B=k();B.success=function(){x.apply(this,z);};this.waitFor(B);};return O.prototype.waitFor.call(this,r);};i.getPlugin=function(){return f.getPlugin()||p;};i.getJQuery=function(){return f.getJQuery();};i.getWindow=function(){return f.getWindow();};i.getUtils=function(){return f.getUtils();};i.getHashChanger=function(){return f.getHashChanger();};i.extendConfig=O.extendConfig;i.resetConfig=function(){O.resetConfig();O.extendConfig({viewNamespace:"",arrangements:new i(),actions:new i(),assertions:new i(),visible:true,autoWait:false,_stackDropCount:1});};i.emptyQueue=O.emptyQueue;i.stopQueue=O.stopQueue;i.getContext=O.getContext;i.matchers={};i.matchers.Matcher=M;i.matchers.AggregationFilled=A;i.matchers.PropertyStrictEquals=b;i.createPageObjects=function(m){return P.create(m,i);};i.prototype._executeCheck=function(m,n){var q=[];n&&q.push(n);l.debug("Opa is executing the check: "+m);var r=m.apply(this,q);l.debug("Opa check was "+r);return r;};i.resetConfig();function j(S){var I=$.sap.getModulePath("sap.ui.test.OpaCss",".css");$.sap.includeStyleSheet(I);return f.launch({frameId:F,source:S});}function k(){return{viewName:null,controlType:null,id:null,searchOpenDialogs:false};}$(function(){if($("#"+F).length){j();}$("body").addClass("sapUiBody");$("html").height("100%");});i._validationInfo=$.extend({_stack:"string",viewName:"string",viewNamespace:"string",visible:"bool",matchers:"any",actions:"any",id:"any",controlType:"any",searchOpenDialogs:"bool",autoWait:"bool"},O._validationInfo);return i;},true);
