/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
(function(g){"use strict";var o;if(g.module){o=g.module;g.module=undefined;}sap.ui.define(['jquery.sap.global','sap/ui/core/routing/HashChanger','sap/ui/base/Object','sap/ui/core/mvc/View','./matchers/Ancestor','./matchers/Interactable','./matchers/Visible','./pipelines/MatcherPipeline','./_XHRCounter'],function($,H,U,V,A,I,a,M,_){var m=new M(),i=new I(),v=new a(),c=["id","viewName","controlType","searchOpenDialogs"];var O=U.extend("sap.ui.test.OpaPlugin",{constructor:function(l){var t=this;l=l||"sap.ui.test.OpaPlugin";this._oLogger=$.sap.log.getLogger(l);sap.ui.getCore().registerPlugin({startPlugin:function(C){t.oCore=C;},stopPlugin:function(){t.oCore=undefined;}});},getAllControls:function(C){var b,p,r=[],d=this._getCoreElements();for(p in d){if(!d.hasOwnProperty(p)){continue;}b=d[p];if(this._checkControlType(b,C)){r.push(b);}}return r;},getView:function(s){var b=this.getAllControls(V);return b.filter(function(d){return d.getViewName()===s;})[0];},getControlInView:function(b){var s=(b.viewNamespace||"")+b.viewName,d=this.getView(s),r=[],C,e=typeof b.id==="string",f;if(!d){this._oLogger.debug("Found no view with the name: '"+s+"'");if(e){return null;}return[];}if($.isArray(b.id)){$.each(b.id,function(j,k){C=d.byId(k);if(C){r.push(C);}});return r;}if(e){var E=d.byId(b.id);if(!E){this._oLogger.debug("Found no control with the id: '"+b.id+"' in the view: '"+s+"'");return null;}return E;}var h=this.getAllControlsWithTheParent(d,b.controlType);if($.type(b.id)==="regexp"){f=d.getId();h=h.filter(function(C){var u=C.getId().replace(f,"");return b.id.test(u);});}return h;},getAllControlsWithTheParent:function(p,C){var b=new A(p);return this._filterUniqueControlsByCondition(this.getAllControls(C),b);},getAllControlsInContainer:function(C,f){return this._filterUniqueControlsByCondition(C.find("*").control(),function(b){return this._checkControlType(b,f);}.bind(this));},getMatchingControls:function(b){var r=null;b=b||{};var h=this._modifyControlType(b);if(!h){return typeof b.id==="string"?r:[];}if(b.searchOpenDialogs){r=this.getAllControlsInContainer($("#sap-ui-static"),b.controlType);}else if(b.viewName){r=this.getControlInView(b);}else if(b.id){r=this.getControlByGlobalId(b);}else if(b.controlType){r=this.getAllControls(b.controlType);}else{r=this.getAllControls();}if(!r||b.visible===false){return r;}var d=[];if(b.interactable){d.push(i);}else{d.push(v);}var p=m.process({control:r,matchers:d});if(!p){if($.isArray(r)){return[];}if(r){return null;}return r;}return p;},getFilterdControls:function(b){var p=$.extend({},b,{interactable:!!b.actions||b.autoWait}),P=this._isLookingForAControl(p);var C=null,r=null;if(P){C=this.getMatchingControls(p);}else if(b.autoWait&&_.hasPendingRequests()){return O.FILTER_FOUND_NO_CONTROLS;}if(typeof b.id==="string"&&!C){return O.FILTER_FOUND_NO_CONTROLS;}if(!b.id&&(b.viewName||b.searchOpenDialogs)&&C.length===0){this._oLogger.debug("found no controls in view: "+b.viewName+" with controlType "+b.sOriginalControlType,"","Opa");return O.FILTER_FOUND_NO_CONTROLS;}if($.type(b.id)==="regexp"&&!C.length){this._oLogger.debug("found no control with the id regex"+b.id);return O.FILTER_FOUND_NO_CONTROLS;}if($.isArray(b.id)&&(!C||C.length!==b.id.length)){if(C&&C.length){this._oLogger.debug("found not all controls with the ids "+b.id+" onlyFound the controls: "+C.map(function(d){return d.sId;}));}else{this._oLogger.debug("found no control with the id  "+b.id);}return O.FILTER_FOUND_NO_CONTROLS;}if(b.controlType&&$.isArray(C)&&!C.length){this._oLogger.debug("found no controls with the type  "+b.sOriginalControlType,"","Opa");return O.FILTER_FOUND_NO_CONTROLS;}if((C||!P)&&b.matchers){r=m.process({matchers:b.matchers,control:C});if(!r){return O.FILTER_FOUND_NO_CONTROLS;}}else{r=C;}return r;},getControlByGlobalId:function(b){var t=this,s=b.id,C=[],d=[],e=this._getCoreElements();if(typeof s==="string"){C=e[s];if(!C){this._oLogger.debug("Found no control with the global id: '"+s+"'");return null;}if(!this._checkControlType(C,b.controlType)){this._oLogger.error("An id: '"+b.id+"' was passed together with the controlType '"+b.sOriginalControlType+"' but the type does not match the control retrieved: '"+C+"' - null is returned");return null;}return C;}if($.type(s)==="regexp"){for(var p in e){if(!e.hasOwnProperty(p)){continue;}if(!s.test(p)){continue;}d.push(p);}}else if($.isArray(s)){d=s;}return d.map(function(f){return e[f];}).filter(function(f){return t._checkControlType(f,b.controlType)&&f&&!f.bIsDestroyed;});},getControlConstructor:function(C){if(sap.ui.lazyRequire._isStub(C)){this._oLogger.debug("The control type "+C+" is currently a lazy stub.");return null;}var f=$.sap.getObject(C);if(!f){this._oLogger.debug("The control type "+C+" is undefined.");return null;}return f;},_isLookingForAControl:function(b){return Object.keys(b).some(function(k){return c.indexOf(k)!==-1&&!!b[k];});},_filterUniqueControlsByCondition:function(C,f){return C.filter(function(b,p,d){var k=!!f(b);return k&&d.indexOf(b)===p;});},_getCoreElements:function(){var e={};if(!this.oCore){return e;}return this.oCore.mElements||e;},_checkControlType:function(C,f){if(f){return C instanceof f;}else{return true;}},_modifyControlType:function(b){var C=b.controlType;if(typeof C!=="string"){if(C&&C._sapUiLazyLoader){this._oLogger.debug("The control type is currently a lazy stub");return false;}return true;}var f=this.getControlConstructor(C);if(!f){return false;}b.sOriginalControlType=C;b.controlType=f;return true;}});O.FILTER_FOUND_NO_CONTROLS="FILTER_FOUND_NO_CONTROL";return O;},true);if(o){g.module=o;}})(window);
