/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/core/delegate/ItemNavigation','sap/ui/unified/library'],function(q,C,L,I,l){"use strict";var M=C.extend("sap.ui.unified.calendar.MonthPicker",{metadata:{library:"sap.ui.unified",properties:{month:{type:"int",group:"Data",defaultValue:0},months:{type:"int",group:"Appearance",defaultValue:12},columns:{type:"int",group:"Appearance",defaultValue:3},primaryCalendarType:{type:"sap.ui.core.CalendarType",group:"Appearance"}},events:{select:{},pageChange:{}}}});M.prototype.init=function(){var s=sap.ui.getCore().getConfiguration().getCalendarType();this.setProperty("primaryCalendarType",s);this._iMinMonth=0;this._iMaxMonth=11;};M.prototype.onAfterRendering=function(){_.call(this);g.call(this);};M.prototype.setMonth=function(m){this.setProperty("month",m,true);m=this.getProperty("month");if(m<0||m>11){throw new Error("Property month must be between 0 and 11; "+this);}if(this.getDomRef()){if(this.getMonths()<12){var s=this.getStartMonth();if(m>=s&&m<=s+this.getMonths()-1){f.call(this,m,true);this._oItemNavigation.focusItem(m-s);}else{h.call(this,m);}}else{f.call(this,m,true);this._oItemNavigation.focusItem(m);}}};M.prototype._getLocale=function(){var p=this.getParent();if(p&&p._getLocale){return p._getLocale();}else if(!this._sLocale){this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();}return this._sLocale;};M.prototype._getLocaleData=function(){var p=this.getParent();if(p&&p._getLocaleData){return p._getLocaleData();}else if(!this._oLocaleData){var s=this._getLocale();var o=new sap.ui.core.Locale(s);this._oLocaleData=L.getInstance(o);}return this._oLocaleData;};M.prototype.onsapspace=function(E){E.preventDefault();};M.prototype.onsapselect=function(E){var i=this._oItemNavigation.getFocusedIndex();var m=i+this.getStartMonth();if(m>=this._iMinMonth&&m<=this._iMaxMonth){f.call(this,m);this.fireSelect();}};M.prototype.onmouseup=function(E){if(this._bMousedownChange){this._bMousedownChange=false;this.fireSelect();}};M.prototype.onThemeChanged=function(){if(this._bNoThemeChange){return;}this._bNamesLengthChecked=undefined;var m=this._oItemNavigation.getItemDomRefs();this._bLongMonth=false;var o=this._getLocaleData();var b=o.getMonthsStandAlone("wide",this.getPrimaryCalendarType());for(var i=0;i<m.length;i++){var $=q(m[i]);$.text(b[i]);}g.call(this);};M.prototype.nextPage=function(){var s=this.getStartMonth();var i=this._oItemNavigation.getFocusedIndex();var m=i+s;var b=this.getMonths();m=m+b;if(m>11){m=11;}h.call(this,m);return this;};M.prototype.previousPage=function(){var s=this.getStartMonth();var i=this._oItemNavigation.getFocusedIndex();var m=i+s;var b=this.getMonths();m=m-b;if(m<0){m=0;}h.call(this,m);return this;};M.prototype.setMinMax=function(m,b){if(m==this._iMinMonth&&b==this._iMaxMonth){return this;}m=parseInt(m,10);if(isNaN(m)||m<0||m>11){m=0;}b=parseInt(b,10);if(isNaN(b)||b<0||b>11){b=11;}if(m<=b){this._iMinMonth=m;this._iMaxMonth=b;}else{this._iMaxMonth=m;this._iMinMonth=b;}if(this.getDomRef()){var j=this._oItemNavigation.getItemDomRefs();var k=this.getId().length+2;for(var i=0;i<j.length;i++){var D=q(j[i]);var n=parseInt(D.attr("id").slice(k),10);if(n<this._iMinMonth||n>this._iMaxMonth){D.addClass("sapUiCalItemDsbl");D.attr("aria-disabled",true);}else{D.removeClass("sapUiCalItemDsbl");D.removeAttr("aria-disabled");}}}return this;};M.prototype.getStartMonth=function(){if(this.getMonths()<12){var F=this._oItemNavigation.getItemDomRefs()[0];return parseInt(F.id.slice(this.getId().length+2),10);}else{return 0;}};function _(){var r=this.getDomRef();var D=this.$().find(".sapUiCalItem");var i=this.getColumns();var m=this.getMonths();var b=true;if(m<12){b=false;}if(!this._oItemNavigation){this._oItemNavigation=new I();this._oItemNavigation.attachEvent(I.Events.AfterFocus,a,this);this._oItemNavigation.attachEvent(I.Events.FocusAgain,c,this);this._oItemNavigation.attachEvent(I.Events.BorderReached,e,this);this.addDelegate(this._oItemNavigation);this._oItemNavigation.setHomeEndColumnMode(true,true);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"],saphome:["alt"],sapend:["alt"]});}this._oItemNavigation.setRootDomRef(r);this._oItemNavigation.setItemDomRefs(D);this._oItemNavigation.setCycling(b);this._oItemNavigation.setColumns(i,!b);var j=this.getMonth()-this.getStartMonth();this._oItemNavigation.setFocusedIndex(j);this._oItemNavigation.setPageSize(D.length);}function a(o){var i=o.getParameter("index");var E=o.getParameter("event");if(!E){return;}if(E.type=="mousedown"){d.call(this,E,i);}}function c(o){var i=o.getParameter("index");var E=o.getParameter("event");if(!E){return;}if(E.type=="mousedown"){d.call(this,E,i);}}function d(E,i){if(E.button){return;}var m=i+this.getStartMonth();if(m>=this._iMinMonth&&m<=this._iMaxMonth){f.call(this,m);this._bMousedownChange=true;}E.preventDefault();E.setMark("cancelAutoClose");}function e(o){var E=o.getParameter("event");if(E.type){var s=this.getStartMonth();var i=this._oItemNavigation.getFocusedIndex();var m=i+s;var b=this.getMonths();switch(E.type){case"sapnext":case"sapnextmodifiers":if(m<11){m++;h.call(this,m,true);}break;case"sapprevious":case"sappreviousmodifiers":if(m>0){m--;h.call(this,m,true);}break;case"sappagedown":if(m<12-b){m=m+b;h.call(this,m,true);}break;case"sappageup":if(m>b){m=m-b;h.call(this,m,true);}break;default:break;}}}function f(m,n){var D=this._oItemNavigation.getItemDomRefs();var $;var s=this.getId()+"-m"+m;for(var i=0;i<D.length;i++){$=q(D[i]);if($.attr("id")==s){$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");}else{$.removeClass("sapUiCalItemSel");$.attr("aria-selected","false");}}if(!n){this.setProperty("month",m,true);}}function g(){if(!this._bNamesLengthChecked){var i=0;var m=this._oItemNavigation.getItemDomRefs();var t=false;var j=this.getMonths();var B=Math.ceil(12/j);var k=j-1;for(var b=0;b<B;b++){if(j<12){h.call(this,k);k=k+j;if(k>11){k=11;}}for(i=0;i<m.length;i++){var o=m[i];if(Math.abs(o.clientWidth-o.scrollWidth)>1){t=true;break;}}if(t){break;}}if(j<12){k=this.getMonth();h.call(this,k);}if(t){this._bLongMonth=false;var n=this._getLocaleData();var s=this.getPrimaryCalendarType();var p=n.getMonthsStandAlone("abbreviated",s);var r=n.getMonthsStandAlone("wide",s);for(i=0;i<m.length;i++){var $=q(m[i]);$.text(p[i]);$.attr("aria-label",r[i]);}}else{this._bLongMonth=true;}this._bNamesLengthChecked=true;}}function h(m,F){var b=this._oItemNavigation.getItemDomRefs();if(b.legth>11){return;}var j=b.length;var s=Math.floor(m/j)*j;if(s+j>12){s=12-j;}var o=this._getLocaleData();var k=[];var n=[];var p=this.getPrimaryCalendarType();if(this._bLongMonth||!this._bNamesLengthChecked){k=o.getMonthsStandAlone("wide",p);}else{k=o.getMonthsStandAlone("abbreviated",p);n=o.getMonthsStandAlone("wide",p);}var S=this.getMonth();for(var i=0;i<b.length;i++){var r=i+s;var D=q(b[i]);D.text(k[i+s]);D.attr("id",this.getId()+"-m"+(i+s));if(!this._bLongMonth){D.attr("aria-label",n[i+s]);}if(r==S){D.addClass("sapUiCalItemSel");D.attr("aria-selected","true");}else{D.removeClass("sapUiCalItemSel");D.attr("aria-selected","false");}if(r<this._iMinMonth||r>this._iMaxMonth){D.addClass("sapUiCalItemDsbl");D.attr("aria-disabled",true);}else{D.removeClass("sapUiCalItemDsbl");D.removeAttr("aria-disabled");}}this._oItemNavigation.focusItem(m-s);if(F){this.firePageChange();}}return M;},true);
