/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate'],function(q,C,U){"use strict";var M={};M.render=function(r,m){var d=m._getStartDate();var t=m.getTooltip_AsString();var i=m.getId();var a={value:i+"-Descr",append:true};r.write("<div");r.writeControlData(m);r.addClass("sapUiCalMonthsRow");r.addClass("sapUiCalRow");r.writeClasses();if(t){r.writeAttributeEscaped("title",t);}if(m._getShowHeader()){a.value=a.value+" "+i+"-Head";}r.writeAccessibilityState(m,{role:"grid",readonly:"true",multiselectable:!m.getSingleSelection()||m.getIntervalSelection(),labelledby:a});r.write(">");r.write("<span id=\""+i+"-Descr\" style=\"display: none;\">"+m._rb.getText("CALENDAR_DIALOG")+"</span>");if(m.getIntervalSelection()){r.write("<span id=\""+i+"-Start\" style=\"display: none;\">"+m._rb.getText("CALENDAR_START_MONTH")+"</span>");r.write("<span id=\""+i+"-End\" style=\"display: none;\">"+m._rb.getText("CALENDAR_END_MONTH")+"</span>");}this.renderRow(r,m,d);r.write("</div>");};M.renderRow=function(r,m,d){var i=m.getId();this.renderHeader(r,m,d);r.write("<div id=\""+i+"-months\" class=\"sapUiCalItems\">");this.renderMonths(r,m,d);r.write("</div>");};M.renderHeader=function(r,m,d){if(m._getShowHeader()){var l=m._getLocaleData();var i=m.getId();r.write("<div id=\""+i+"-Head\">");this.renderHeaderLine(r,m,l,d);r.write("</div>");}};M.renderHeaderLine=function(r,m,l,d){var I=m.getId();var a=m.getMonths();var o=new U(d.getTime());var w="";var y=0;var Y=[];var i=0;for(i=0;i<a;i++){y=o.getUTCFullYear();if(Y.length>0&&Y[Y.length-1].iYear==y){Y[Y.length-1].iMonths++;}else{Y.push({iYear:y,iMonths:1});}o.setUTCMonth(o.getUTCMonth()+1);}for(i=0;i<Y.length;i++){var b=Y[i];w=(100/a*b.iMonths)+"%";r.write("<div id=\""+I+"-Head"+i+"\"class=\"sapUiCalHeadText\" style=\"width:"+w+"\">");r.write(b.iYear);r.write("</div>");}};M.renderMonths=function(r,m,d){var h=this.getHelper(m,d);var a=m.getMonths();var w=(100/a)+"%";var o=new U(d.getTime());o.setUTCDate(1);for(var i=0;i<a;i++){this.renderMonth(r,m,o,h,w);o.setUTCMonth(o.getUTCMonth()+1);}};M.getHelper=function(m,d){var h={};h.sLocale=m._getLocale();h.oLocaleData=m._getLocaleData();h.oToday=C._createUniversalUTCDate(new Date());h.sCurrentMonth=m._rb.getText("CALENDAR_CURRENT_MONTH");h.sId=m.getId();h.oFormatLong=m._getFormatLong();if(m._bLongMonth||!m._bNamesLengthChecked){h.aMonthNames=h.oLocaleData.getMonthsStandAlone("wide");}else{h.aMonthNames=h.oLocaleData.getMonthsStandAlone("abbreviated");h.aMonthNamesWide=h.oLocaleData.getMonthsStandAlone("wide");}var l=m.getLegend();if(l){var L=sap.ui.getCore().byId(l);if(L){if(!(L instanceof sap.ui.unified.CalendarLegend)){throw new Error(L+" is not a sap.ui.unified.CalendarLegend. "+m);}h.aTypes=L.getItems();}else{q.sap.log.warning("CalendarLegend "+l+" does not exist!",m);}}else{h.aTypes=[];}return h;};M.renderMonth=function(r,m,d,h,w){var a={role:"gridcell",selected:false,label:"",describedby:""};if(!m._bLongMonth&&m._bNamesLengthChecked){a["label"]=h.aMonthNamesWide[d.getUTCMonth()];}var y=m._oFormatYyyymm.format(d.getJSDate(),true);var s=m._checkDateSelected(d);var t=m._getDateType(d);var e=m._checkMonthEnabled(d);r.write("<div");r.writeAttribute("id",h.sId+"-"+y);r.addClass("sapUiCalItem");if(w){r.addStyle("width",w);}if(d.getUTCMonth()==h.oToday.getMonth()&&d.getUTCFullYear()==h.oToday.getFullYear()){r.addClass("sapUiCalItemNow");a["label"]=h.sCurrentMonth+" ";}if(s>0){r.addClass("sapUiCalItemSel");a["selected"]=true;}if(s==2){r.addClass("sapUiCalItemSelStart");a["describedby"]=a["describedby"]+" "+h.sId+"-Start";}else if(s==3){r.addClass("sapUiCalItemSelEnd");a["describedby"]=a["describedby"]+" "+h.sId+"-End";}else if(s==4){r.addClass("sapUiCalItemSelBetween");}else if(s==5){r.addClass("sapUiCalItemSelStart");r.addClass("sapUiCalItemSelEnd");a["describedby"]=a["describedby"]+" "+h.sId+"-Start";a["describedby"]=a["describedby"]+" "+h.sId+"-End";}if(t&&t.type!=sap.ui.unified.CalendarDayType.None){r.addClass("sapUiCalItem"+t.type);if(t.tooltip){r.writeAttributeEscaped('title',t.tooltip);}}if(!e){r.addClass("sapUiCalItemDsbl");a["disabled"]=true;}r.writeAttribute("tabindex","-1");r.writeAttribute("data-sap-month",y);a["label"]=a["label"]+h.oFormatLong.format(d,true);if(t&&t.type!=sap.ui.unified.CalendarDayType.None){for(var i=0;i<h.aTypes.length;i++){var l=h.aTypes[i];if(l.getType()==t.type){a["label"]=a["label"]+"; "+l.getText();break;}}}r.writeAccessibilityState(null,a);r.writeClasses();r.writeStyles();r.write(">");r.write("<span");r.addClass("sapUiCalItemText");r.writeClasses();r.write(">");r.write(h.aMonthNames[d.getUTCMonth()]);r.write("</span>");r.write("</div>");};return M;},true);
