/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate'],function(q,C,U){"use strict";var T={};T.render=function(r,t){var d=t._getStartDate();var s=t.getTooltip_AsString();var i=t.getId();var a={value:i+"-Descr",append:true};r.write("<div");r.writeControlData(t);r.addClass("sapUiCalTimesRow");r.addClass("sapUiCalRow");r.writeClasses();if(s){r.writeAttributeEscaped("title",s);}if(t._getShowHeader()){a.value=a.value+" "+i+"-Head";}r.writeAccessibilityState(t,{role:"grid",readonly:"true",multiselectable:!t.getSingleSelection()||t.getIntervalSelection(),labelledby:a});r.write(">");r.write("<span id=\""+i+"-Descr\" style=\"display: none;\">"+t._rb.getText("CALENDAR_DIALOG")+"</span>");if(t.getIntervalSelection()){r.write("<span id=\""+i+"-Start\" style=\"display: none;\">"+t._rb.getText("CALENDAR_START_TIME")+"</span>");r.write("<span id=\""+i+"-End\" style=\"display: none;\">"+t._rb.getText("CALENDAR_END_TIME")+"</span>");}this.renderRow(r,t,d);r.write("</div>");};T.renderRow=function(r,t,d){var i=t.getId();this.renderHeader(r,t,d);r.write("<div id=\""+i+"-times\" class=\"sapUiCalItems\">");this.renderTimes(r,t,d);r.write("</div>");};T.renderHeader=function(r,t,d){if(t._getShowHeader()){var l=t._getLocaleData();var i=t.getId();r.write("<div id=\""+i+"-Head\">");this.renderHeaderLine(r,t,l,d);r.write("</div>");}};T.renderHeaderLine=function(r,t,l,d){var f=t._getFormatDate();var I=t.getId();var a=t.getItems();var o=t._getIntervalStart(d);var m=t.getIntervalMinutes();var w="";var D=0;var b=[];var i=0;for(i=0;i<a;i++){D=f.format(o,true);if(b.length>0&&b[b.length-1].sDay==D){b[b.length-1].iItems++;}else{b.push({sDay:D,iItems:1});}o.setUTCMinutes(o.getUTCMinutes()+m);}for(i=0;i<b.length;i++){var c=b[i];w=(100/a*c.iItems)+"%";r.write("<div id=\""+I+"-Head"+i+"\"class=\"sapUiCalHeadText\" style=\"width:"+w+"\">");r.write(c.sDay);r.write("</div>");}};T.renderTimes=function(r,t,d){var h=this.getHelper(t,d);var I=t.getItems();var w=(100/I)+"%";var o=t._getIntervalStart(d);var O="";var a="";for(var i=0;i<I;i++){if(h.oFormatTimeAmPm){a=h.oFormatTimeAmPm.format(o,true);if(O==a){a="";}else{O=a;}}this.renderTime(r,t,o,h,w,a);o.setUTCMinutes(o.getUTCMinutes()+h.iMinutes);}};T.getHelper=function(t,d){var h={};h.sLocale=t._getLocale();h.oLocaleData=t._getLocaleData();h.oNow=C._createUniversalUTCDate(new Date(),undefined,true);h.sCurrentTime=t._rb.getText("CALENDAR_CURRENT_TIME");h.sId=t.getId();h.oFormatLong=t._getFormatLong();h.oFormatTime=t._getFormatTime();h.oFormatTimeAmPm=t._oFormatTimeAmPm;h.iMinutes=t.getIntervalMinutes();var l=t.getLegend();if(l){var L=sap.ui.getCore().byId(l);if(L){if(!(L instanceof sap.ui.unified.CalendarLegend)){throw new Error(L+" is not a sap.ui.unified.CalendarLegend. "+t);}h.aTypes=L.getItems();}else{q.sap.log.warning("CalendarLegend "+l+" does not exist!",t);}}else{h.aTypes=[];}return h;};T.renderTime=function(r,t,d,h,w,a){var A={role:"gridcell",selected:false,label:"",describedby:""};var y=t._oFormatYyyyMMddHHmm.format(d.getJSDate(),true);var s=t._checkDateSelected(d);var o=t._getDateType(d);var e=t._checkTimeEnabled(d);r.write("<div");r.writeAttribute("id",h.sId+"-"+y);r.addClass("sapUiCalItem");if(w){r.addStyle("width",w);}var n=new U(d.getTime());n.setUTCMinutes(n.getUTCMinutes()+h.iMinutes);if(d.getTime()<=h.oNow.getTime()&&n.getTime()>h.oNow.getTime()){r.addClass("sapUiCalItemNow");A["label"]=h.sCurrentTime+" ";}if(s>0){r.addClass("sapUiCalItemSel");A["selected"]=true;}if(s==2){r.addClass("sapUiCalItemSelStart");A["describedby"]=A["describedby"]+" "+h.sId+"-Start";}else if(s==3){r.addClass("sapUiCalItemSelEnd");A["describedby"]=A["describedby"]+" "+h.sId+"-End";}else if(s==4){r.addClass("sapUiCalItemSelBetween");}else if(s==5){r.addClass("sapUiCalItemSelStart");r.addClass("sapUiCalItemSelEnd");A["describedby"]=A["describedby"]+" "+h.sId+"-Start";A["describedby"]=A["describedby"]+" "+h.sId+"-End";}if(o&&o.type!=sap.ui.unified.CalendarDayType.None){r.addClass("sapUiCalItem"+o.type);if(o.tooltip){r.writeAttributeEscaped('title',o.tooltip);}}if(!e){r.addClass("sapUiCalItemDsbl");A["disabled"]=true;}r.writeAttribute("tabindex","-1");r.writeAttribute("data-sap-time",y);A["label"]=A["label"]+h.oFormatLong.format(d,true);if(o&&o.type!=sap.ui.unified.CalendarDayType.None){for(var i=0;i<h.aTypes.length;i++){var l=h.aTypes[i];if(l.getType()==o.type){A["label"]=A["label"]+"; "+l.getText();break;}}}r.writeAccessibilityState(null,A);r.writeClasses();r.writeStyles();r.write(">");r.write("<span");r.addClass("sapUiCalItemText");r.writeClasses();r.write(">");r.write(h.oFormatTime.format(d,true));if(a){r.write("<span");r.addClass("sapUiCalItemTextAmPm");r.writeClasses();r.write(">");r.write(a);r.write("</span>");}r.write("</span>");r.write("</div>");};return T;},true);
