/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/ui/unified/Calendar',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/model/type/Date','sap/ui/unified/calendar/CalendarUtils','./calendar/Header','./calendar/Month','./calendar/MonthPicker','./calendar/YearPicker','sap/ui/core/date/UniversalDate','./library'],function(q,C,L,D,a,H,M,b,Y,U,l){"use strict";
var c=C.extend("sap.ui.unified.Calendar",{metadata:{library:"sap.ui.unified",properties:{intervalSelection:{type:"boolean",group:"Behavior",defaultValue:false},singleSelection:{type:"boolean",group:"Behavior",defaultValue:true},months:{type:"int",group:"Appearance",defaultValue:1},firstDayOfWeek:{type:"int",group:"Appearance",defaultValue:-1},nonWorkingDays:{type:"int[]",group:"Appearance",defaultValue:null},primaryCalendarType:{type:"sap.ui.core.CalendarType",group:"Appearance",defaultValue:null},secondaryCalendarType:{type:"sap.ui.core.CalendarType",group:"Appearance",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},minDate:{type:"object",group:"Misc",defaultValue:null},maxDate:{type:"object",group:"Misc",defaultValue:null}},aggregations:{selectedDates:{type:"sap.ui.unified.DateRange",multiple:true,singularName:"selectedDate"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},disabledDates:{type:"sap.ui.unified.DateRange",multiple:true,singularName:"disabledDate"},header:{type:"sap.ui.unified.calendar.Header",multiple:false,visibility:"hidden"},month:{type:"sap.ui.unified.calendar.Month",multiple:true,visibility:"hidden"},monthPicker:{type:"sap.ui.unified.calendar.MonthPicker",multiple:false,visibility:"hidden"},yearPicker:{type:"sap.ui.unified.calendar.YearPicker",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.ui.unified.CalendarLegend",multiple:false}},events:{select:{},cancel:{},startDateChange:{}}}});
c.prototype.init=function(){this._iBreakPointTablet=sap.ui.Device.media._predefinedRangeSets[sap.ui.Device.media.RANGESETS.SAP_STANDARD_EXTENDED].points[0];this._iBreakPointDesktop=sap.ui.Device.media._predefinedRangeSets[sap.ui.Device.media.RANGESETS.SAP_STANDARD_EXTENDED].points[1];this._iBreakPointLargeDesktop=sap.ui.Device.media._predefinedRangeSets[sap.ui.Device.media.RANGESETS.SAP_STANDARD_EXTENDED].points[2];var i=sap.ui.getCore().getConfiguration().getCalendarType();this.setProperty("primaryCalendarType",i);this.setProperty("secondaryCalendarType",i);this._iMode=0;this._oYearFormat=sap.ui.core.format.DateFormat.getDateInstance({format:"y",calendarType:i});this.data("sap-ui-fastnavgroup","true",true);this._oMinDate=this._newUniversalDate(new Date(Date.UTC(1,0,1)));this._oMinDate.getJSDate().setUTCFullYear(1);this._oMaxDate=this._newUniversalDate(new Date(Date.UTC(9999,11,31)));var E=new H(this.getId()+"--Head");E.attachEvent("pressPrevious",this._handlePrevious,this);E.attachEvent("pressNext",this._handleNext,this);E.attachEvent("pressButton1",p,this);E.attachEvent("pressButton2",r,this);this.setAggregation("header",E);var F=this._createMonth(this.getId()+"--Month0");F.attachEvent("focus",u,this);F.attachEvent("select",t,this);F.attachEvent("_renderMonth",s,this);F.attachEvent("_bindMousemove",v,this);F.attachEvent("_unbindMousemove",w,this);F._bNoThemeChange=true;this.addAggregation("month",F);var G=new b(this.getId()+"--MP");G.attachEvent("select",x,this);G._bNoThemeChange=true;this.setAggregation("monthPicker",G);var I=new Y(this.getId()+"--YP");I.attachEvent("select",y,this);this.setAggregation("yearPicker",I);this._resizeProxy=q.proxy(A,this);};
c.prototype.exit=function(){if(this._sInvalidateMonth){q.sap.clearDelayedCall(this._sInvalidateMonth);}if(this._sResizeListener){sap.ui.core.ResizeHandler.deregister(this._sResizeListener);this._sResizeListener=undefined;}};
c.prototype._createMonth=function(i){var E=new M(i,{width:"100%"});return E;};
c.prototype.onBeforeRendering=function(){var E=this.getAggregation("month");var F;var G=E[0].getDate();var I=this._getFocusedDate();if(E.length>1&&G){F=a._createUniversalUTCDate(G,this.getPrimaryCalendarType());}else if(E.length>1){F=B.call(this,this._getFocusedDate());}else{F=I;}for(var i=0;i<E.length;i++){G=this._newUniversalDate(F);if(i>0){G.setUTCDate(1);G.setUTCMonth(G.getUTCMonth()+i);}var J=G;if(I.getUTCFullYear()==G.getUTCFullYear()&&I.getUTCMonth()==G.getUTCMonth()){J=I;}E[i].displayDate(a._createLocalDate(J));}this._updateHeader(F);this._iSize=0;};
c.prototype.onAfterRendering=function(E){j.call(this);if(o.call(this)>1||this._bInitMonth){E.size={width:this.getDomRef().offsetWidth};A.call(this,E,true);if(!this._sResizeListener){this._sResizeListener=sap.ui.core.ResizeHandler.register(this,this._resizeProxy);}this._bInitMonth=undefined;}};
c.prototype.invalidate=function(O){if(!this._bDateRangeChanged&&(!O||!(O instanceof sap.ui.unified.DateRange))){C.prototype.invalidate.apply(this,arguments);}else if(this.getDomRef()&&this._iMode==0&&!this._sInvalidateMonth){this._sInvalidateMonth=q.sap.delayedCall(0,this,z,[this]);}};
c.prototype.removeAllSelectedDates=function(){this._bDateRangeChanged=true;var R=this.removeAllAggregation("selectedDates");return R;};
c.prototype.destroySelectedDates=function(){this._bDateRangeChanged=true;var i=this.destroyAggregation("selectedDates");return i;};
c.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=true;var R=this.removeAllAggregation("specialDates");return R;};
c.prototype.destroySpecialDates=function(){this._bDateRangeChanged=true;var i=this.destroyAggregation("specialDates");return i;};
c.prototype.getSpecialDates=function(){var P=this.getParent();if(P&&P.getSpecialDates){return P.getSpecialDates();}else{return this.getAggregation("specialDates",[]);}};
c.prototype.removeAllDisabledDates=function(){this._bDateRangeChanged=true;var R=this.removeAllAggregation("disabledDates");return R;};
c.prototype.destroyDisabledDates=function(){this._bDateRangeChanged=true;var i=this.destroyAggregation("disabledDates");return i;};
c.prototype.setLocale=function(i){if(this._sLocale!=i){this._sLocale=i;this._oLocaleData=undefined;this.invalidate();}return this;};
c.prototype.getLocale=function(){if(!this._sLocale){this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();}return this._sLocale;};
c.prototype._getFocusedDate=function(){if(!this._oFocusedDate){d.call(this);}return this._oFocusedDate;};
c.prototype._setFocusedDate=function(i){if(!(i instanceof U)){throw new Error("Date must be a UniversalDate object "+this);}this._oFocusedDate=this._newUniversalDate(i);};
c.prototype.focusDate=function(i){n.call(this,i,false);return this;};
c.prototype.displayDate=function(i){n.call(this,i,true);return this;};
c.prototype.getStartDate=function(){var S;if(this.getDomRef()){var i=this.getAggregation("month");S=a._createUniversalUTCDate(i[0].getDate(),this.getPrimaryCalendarType());}else{S=this._newUniversalDate(this._getFocusedDate());}S.setUTCDate(1);return a._createLocalDate(S);};
c.prototype.setPopupMode=function(P){this._bPoupupMode=P;return this;};
c.prototype.setMonths=function(E){this._bDateRangeChanged=undefined;this.setProperty("months",E,false);E=o.call(this);var F=this.getAggregation("month");var i=0;var G;if(F.length<E){for(i=F.length;i<E;i++){G=this._createMonth(this.getId()+"--Month"+i);G.attachEvent("focus",u,this);G.attachEvent("select",t,this);G.attachEvent("_renderMonth",s,this);G.attachEvent("_bindMousemove",v,this);G.attachEvent("_unbindMousemove",w,this);G._bNoThemeChange=true;this.addAggregation("month",G);}}else if(F.length>E){for(i=F.length;i>E;i--){G=this.removeAggregation("month",i-1);G.destroy();}if(E==1){this._bInitMonth=true;}}if(E>1&&F[0].getDate()){F[0].setProperty("date",null,true);}return this;};
c.prototype.setPrimaryCalendarType=function(E){var F=this.getAggregation("month");var R=false;if(F.length>1){R=true;}this.setProperty("primaryCalendarType",E,!R);this._oYearFormat=sap.ui.core.format.DateFormat.getDateInstance({format:"y",calendarType:E});if(this._oFocusedDate){this._oFocusedDate=U.getInstance(this._oFocusedDate.getJSDate(),E);}this._oMinDate=U.getInstance(this._oMinDate.getJSDate(),E);this._oMaxDate=U.getInstance(this._oMaxDate.getJSDate(),E);for(var i=0;i<F.length;i++){var G=F[i];G.setPrimaryCalendarType(E);}var I=this.getAggregation("monthPicker");I.setPrimaryCalendarType(E);var J=this.getAggregation("yearPicker");J.setPrimaryCalendarType(E);if(this.getDomRef()){this._updateHeader(this._oFocusedDate);if(this.iMode!=1&&I.getDomRef()){I.$().remove();}if(this.iMode!=2&&J.getDomRef()){J.$().remove();}}return this;};
c.prototype._newUniversalDate=function(i){var J;if((i instanceof U)){J=new Date(i.getJSDate().getTime());}else{J=new Date(i.getTime());}return U.getInstance(J,this.getPrimaryCalendarType());};
c.prototype.setSecondaryCalendarType=function(E){this._bSecondaryCalendarTypeSet=true;this.setProperty("secondaryCalendarType",E,true);this._oYearFormatSecondary=sap.ui.core.format.DateFormat.getDateInstance({format:"y",calendarType:E});var F=this.getAggregation("month");for(var i=0;i<F.length;i++){var G=F[i];G.setSecondaryCalendarType(E);}if(this.getDomRef()){this._updateHeader(this._getFocusedDate());this.$().toggleClass("sapUiCalSecType",!!this._getSecondaryCalendarType());}return this;};
c.prototype._getSecondaryCalendarType=function(){var S;if(this._bSecondaryCalendarTypeSet){S=this.getSecondaryCalendarType();var P=this.getPrimaryCalendarType();if(S==P){S=undefined;}}return S;};
c.prototype.setMinDate=function(i){if(q.sap.equal(i,this.getMinDate())){return this;}if(!i){this._oMinDate.getJSDate().setUTCFullYear(1);this._oMinDate.getJSDate().setUTCMonth(0);this._oMinDate.getJSDate().setUTCDate(1);}else{if(!(i instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}this._oMinDate=a._createUniversalUTCDate(i,this.getPrimaryCalendarType());var E=this._oMinDate.getUTCFullYear();if(E<1||E>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}if(this._oMaxDate.getTime()<this._oMinDate.getTime()){q.sap.log.warning("minDate > maxDate -> maxDate set to end of the month",this);this._oMaxDate=a._createUniversalUTCDate(i,this.getPrimaryCalendarType());this._oMaxDate.setUTCMonth(this._oMaxDate.getUTCMonth()+1,0);this.setProperty("maxDate",a._createLocalDate(this._oMaxDate),true);}this._setMinMaxDateExtend(i);}this.setProperty("minDate",i,false);var F=this.getAggregation("yearPicker");F._oMinDate.setUTCFullYear(this._oMinDate.getUTCFullYear());return this;};
c.prototype.setMaxDate=function(i){if(q.sap.equal(i,this.getMaxDate())){return this;}if(!i){this._oMaxDate.getJSDate().setUTCFullYear(9999);this._oMaxDate.getJSDate().setUTCMonth(11);this._oMaxDate.getJSDate().setUTCDate(31);}else{if(!(i instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}this._oMaxDate=a._createUniversalUTCDate(i,this.getPrimaryCalendarType());var E=this._oMaxDate.getUTCFullYear();if(E<1||E>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}if(this._oMinDate.getTime()>this._oMaxDate.getTime()){q.sap.log.warning("maxDate < minDate -> minDate set to begin of the month",this);this._oMinDate=a._createUniversalUTCDate(i,this.getPrimaryCalendarType());this._oMinDate.setUTCDate(1);this.setProperty("minDate",a._createLocalDate(this._oMinDate),true);}this._setMinMaxDateExtend(i);}this.setProperty("maxDate",i,false);var F=this.getAggregation("yearPicker");F._oMaxDate.setUTCFullYear(this._oMaxDate.getUTCFullYear());return this;};
c.prototype._setMinMaxDateExtend=function(i){if(this._oFocusedDate){if(this._oFocusedDate.getTime()<this._oMinDate.getTime()){q.sap.log.warning("focused date < minDate -> minDate focused",this);this.focusDate(i);}else if(this._oFocusedDate.getTime()>this._oMaxDate.getTime()){q.sap.log.warning("focused date > maxDate -> maxDate focused",this);this.focusDate(i);}}};
c.prototype._getLocaleData=function(){if(!this._oLocaleData){var i=this.getLocale();var E=new sap.ui.core.Locale(i);this._oLocaleData=L.getInstance(E);}return this._oLocaleData;};
c.prototype._getShowMonthHeader=function(){var i=o.call(this);if(i>2){return true;}else{return false;}};
c.prototype.setWidth=function(W){this.setProperty("width",W,true);if(this.getDomRef()){W=this.getWidth();this.$().css("width",W);if(W){this.$().addClass("sapUiCalWidth");}else{this.$().removeClass("sapUiCalWidth");}}return this;};
c.prototype.onclick=function(E){if(E.isMarked("delayedMouseEvent")){return;}if(E.target.id==this.getId()+"-cancel"){this.onsapescape(E);}};
c.prototype.onmousedown=function(E){E.preventDefault();E.setMark("cancelAutoClose");};
c.prototype.onsapescape=function(E){if(this._iMode==0){this.fireCancel();}this._closedPickers();};
c.prototype.onsapshow=function(E){if(this._bPoupupMode){this._closedPickers();this.fireCancel();E.preventDefault();}};
c.prototype.onsaphide=c.prototype.onsapshow;
c.prototype.onsaptabnext=function(E){var F=this.getAggregation("header");if(q.sap.containsOrEquals(this.getDomRef("content"),E.target)){q.sap.focus(F.getDomRef("B1"));if(!this._bPoupupMode){var G=this.getAggregation("month");var I=this.getAggregation("monthPicker");var J=this.getAggregation("yearPicker");for(var i=0;i<G.length;i++){var K=G[i];q(K._oItemNavigation.getItemDomRefs()[K._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}if(I.getDomRef()){q(I._oItemNavigation.getItemDomRefs()[I._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}if(J.getDomRef()){q(J._oItemNavigation.getItemDomRefs()[J._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}}E.preventDefault();}else if(E.target.id==F.getId()+"-B1"){q.sap.focus(F.getDomRef("B2"));E.preventDefault();}};
c.prototype.onsaptabprevious=function(E){var F=this.getAggregation("header");if(q.sap.containsOrEquals(this.getDomRef("content"),E.target)){if(this._bPoupupMode){q.sap.focus(F.getDomRef("B2"));E.preventDefault();}}else if(E.target.id==F.getId()+"-B1"){var G=this.getAggregation("month");var I=this.getAggregation("monthPicker");var J=this.getAggregation("yearPicker");var K;switch(this._iMode){case 0:K=this._getFocusedDate();for(var i=0;i<G.length;i++){var N=G[i];var O=a._createUniversalUTCDate(N.getDate(),this.getPrimaryCalendarType());if(K.getTime()==O.getTime()){N._oItemNavigation.focusItem(N._oItemNavigation.getFocusedIndex());}else{q(N._oItemNavigation.getItemDomRefs()[N._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");}}break;case 1:I._oItemNavigation.focusItem(I._oItemNavigation.getFocusedIndex());break;case 2:J._oItemNavigation.focusItem(J._oItemNavigation.getFocusedIndex());break;}E.preventDefault();}else if(E.target.id==F.getId()+"-B2"){q.sap.focus(F.getDomRef("B1"));E.preventDefault();}};
c.prototype.onfocusin=function(E){if(E.target.id==this.getId()+"-end"){var F=this.getAggregation("header");var G=this.getAggregation("month");var I=this.getAggregation("monthPicker");var J=this.getAggregation("yearPicker");q.sap.focus(F.getDomRef("B2"));if(!this._bPoupupMode){for(var i=0;i<G.length;i++){var K=G[i];q(K._oItemNavigation.getItemDomRefs()[K._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}if(I.getDomRef()){q(I._oItemNavigation.getItemDomRefs()[I._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}if(J.getDomRef()){q(J._oItemNavigation.getItemDomRefs()[J._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}}}this.$("end").attr("tabindex","-1");};
c.prototype.onsapfocusleave=function(E){if(!E.relatedControlId||!q.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(E.relatedControlId).getFocusDomRef())){this.$("end").attr("tabindex","0");if(!this._bPoupupMode){var F=this.getAggregation("month");var G=this.getAggregation("monthPicker");var I=this.getAggregation("yearPicker");switch(this._iMode){case 0:for(var i=0;i<F.length;i++){var J=F[i];q(J._oItemNavigation.getItemDomRefs()[J._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");}break;case 1:q(G._oItemNavigation.getItemDomRefs()[G._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");break;case 2:q(I._oItemNavigation.getItemDomRefs()[I._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");break;}}}};
c.prototype.getFocusDomRef=function(){var i=this.getAggregation("month");var E=i[0];return E._oItemNavigation.getItemDomRefs()[E._oItemNavigation.getFocusedIndex()];};
c.prototype.onThemeChanged=function(){if(!this.getDomRef()){return;}this._bNamesLengthChecked=undefined;var E=this.getAggregation("monthPicker");e.call(this,true);E._bNoThemeChange=false;E.onThemeChanged(arguments);E._bNoThemeChange=true;this._bLongMonth=E._bLongMonth;f.call(this,true);var F=this.getAggregation("month");for(var i=0;i<F.length;i++){var G=F[i];G._bNoThemeChange=false;G.onThemeChanged(arguments);G._bNoThemeChange=true;}var I;if(F.length>1){I=a._createUniversalUTCDate(F[0].getDate(),this.getPrimaryCalendarType());}else{I=this._getFocusedDate();}m.call(this,I);j.call(this);};
c.prototype._updateHeader=function(i){m.call(this,i);this._togglePrevNext(i,true);};
c.prototype._togglePrevNext=function(i,E){var F=this._oMaxDate.getJSDate().getUTCFullYear();var G=this._oMinDate.getJSDate().getUTCFullYear();var I=this._oMaxDate.getJSDate().getUTCMonth();var J=this._oMinDate.getJSDate().getUTCMonth();var K=this.getAggregation("header");var N=o.call(this);var O=this._newUniversalDate(i);if(this._iMode==0&&N>1){O=B.call(this,i);O.setUTCMonth(O.getUTCMonth()+N,0);}else{O.setUTCMonth(O.getUTCMonth()+1,0);}var P=O.getJSDate().getUTCFullYear();var Q=O.getJSDate().getUTCMonth();if(P>F||(P==F&&(!E||Q>=I))||(this._iMode==1&&this.getPickerPopup&&this.getPickerPopup())){K.setEnabledNext(false);}else{K.setEnabledNext(true);}if(this._iMode==0&&N>1){O.setUTCMonth(O.getUTCMonth()-N+1,1);}else{O.setUTCDate(1);}P=O.getJSDate().getUTCFullYear();Q=O.getJSDate().getUTCMonth();if(P<G||(P==G&&(!E||Q<=J))||(this._iMode==1&&this.getPickerPopup&&this.getPickerPopup())){K.setEnabledPrevious(false);}else{K.setEnabledPrevious(true);}};
c.prototype._togglePrevNexYearPicker=function(){var i=this.getAggregation("yearPicker");var E=i.getYears();var F=a._createUniversalUTCDate(i.getFirstRenderedDate());F.setUTCFullYear(F.getUTCFullYear()+Math.floor(E/2));var G=this.getAggregation("header");var I=this._newUniversalDate(this._oMaxDate);I.setUTCFullYear(I.getUTCFullYear()-Math.ceil(E/2));I.setUTCMonth(11,31);var J=this._newUniversalDate(this._oMinDate);J.setUTCFullYear(J.getUTCFullYear()+Math.floor(E/2)+1);J.setUTCMonth(0,1);if(F.getTime()>I.getTime()){G.setEnabledNext(false);}else{G.setEnabledNext(true);}if(F.getTime()<J.getTime()){G.setEnabledPrevious(false);}else{G.setEnabledPrevious(true);}};
c.prototype._handlePrevious=function(E){var F=this._getFocusedDate();var i=this.getAggregation("header");var G=this.getAggregation("yearPicker");var I=o.call(this);var J;var K;var N=false;switch(this._iMode){case 0:if(I>1){J=a._createUniversalUTCDate(this.getAggregation("month")[0].getDate(),this.getPrimaryCalendarType());J.setUTCDate(1);this._setFocusedDate(J);F=this._getFocusedDate();}else{F.setUTCDate(1);}F.setUTCDate(F.getUTCDate()-1);_.call(this,N,true);break;case 1:F.setUTCFullYear(F.getUTCFullYear()-1);i.setTextButton2(this._oYearFormat.format(F,true));var S=this._getSecondaryCalendarType();if(S){K=U.getInstance(new Date(F.getJSDate()),S);K.setUTCMonth(0,1);i.setAdditionalTextButton2(this._oYearFormatSecondary.format(K,true));}else{i.setAdditionalTextButton2();}this._togglePrevNext(F);this._setDisabledMonths(F.getUTCFullYear());break;case 2:G.previousPage();this._togglePrevNexYearPicker();break;}};
c.prototype._handleNext=function(E){var F=this._getFocusedDate();var i=this.getAggregation("header");var G=this.getAggregation("yearPicker");var I=o.call(this);var J;var K;switch(this._iMode){case 0:if(I>1){J=a._createUniversalUTCDate(this.getAggregation("month")[0].getDate(),this.getPrimaryCalendarType());this._setFocusedDate(J);F=this._getFocusedDate();}F.setUTCMonth(F.getUTCMonth()+I,1);_.call(this);break;case 1:F.setUTCFullYear(F.getUTCFullYear()+1);i.setTextButton2(this._oYearFormat.format(F,true));var S=this._getSecondaryCalendarType();if(S){K=U.getInstance(new Date(F.getJSDate()),S);K.setUTCMonth(0,1);i.setAdditionalTextButton2(this._oYearFormatSecondary.format(K,true));}else{i.setAdditionalTextButton2();}this._togglePrevNext(F);this._setDisabledMonths(F.getUTCFullYear());break;case 2:G.nextPage();this._togglePrevNexYearPicker();break;}};
c.prototype._getDisplayedMonths=function(E){var F=[];var G=E.getUTCMonth();var I=o.call(this);if(I>1){for(var i=0;i<I;i++){F.push((G+i)%12);}}else{F.push(G);}return F;};
c.prototype._getDisplayedSecondaryMonths=function(P,S){var i=this.getAggregation("month");var F=a._createUniversalUTCDate(i[0].getDate(),P);F.setUTCDate(1);F=U.getInstance(F.getJSDate(),S);var E=F.getUTCMonth();var G=a._createUniversalUTCDate(i[i.length-1].getDate(),P);G.setUTCMonth(G.getUTCMonth()+1,0);G=U.getInstance(G.getJSDate(),S);var I=G.getUTCMonth();return{start:E,end:I};};
c.prototype._closedPickers=function(){switch(this._iMode){case 0:break;case 1:f.call(this);break;case 2:h.call(this);break;}};
c.prototype._setDisabledMonths=function(i,E){var F=0;var G=11;if(i==this._oMinDate.getUTCFullYear()){F=this._oMinDate.getUTCMonth();}if(i==this._oMaxDate.getUTCFullYear()){G=this._oMaxDate.getUTCMonth();}if(!E){E=this.getAggregation("monthPicker");}E.setMinMax(F,G);};
function _(N,I,E){var F=this._getFocusedDate();var G=this.getAggregation("month");var J=false;var K;var O;var P;var i=0;for(i=0;i<G.length;i++){K=G[i];if(K.checkDateFocusable(a._createLocalDate(F))){J=true;}if(J||G.length==1){if(!N){K.setDate(a._createLocalDate(F));}else{K.displayDate(a._createLocalDate(F));}break;}}if(!J){P=this._newUniversalDate(F);if(G.length>1){P=B.call(this,P);for(i=0;i<G.length;i++){K=G[i];O=this._newUniversalDate(P);O.setUTCMonth(P.getUTCMonth()+i);if(!N&&O.getUTCFullYear()==F.getUTCFullYear()&&O.getUTCMonth()==F.getUTCMonth()){K.setDate(a._createLocalDate(F));}else{K.displayDate(a._createLocalDate(O));}}}this._updateHeader(P);if(!E){this.fireStartDateChange();}}}
function d(){var S=this.getSelectedDates();var i=this.getPrimaryCalendarType();if(S&&S[0]&&S[0].getStartDate()){this._oFocusedDate=a._createUniversalUTCDate(S[0].getStartDate(),i);}else{var N=new Date();this._oFocusedDate=a._createUniversalUTCDate(N,i);}if(this._oFocusedDate.getTime()<this._oMinDate.getTime()){this._oFocusedDate=this._newUniversalDate(this._oMinDate);}else if(this._oFocusedDate.getTime()>this._oMaxDate.getTime()){this._oFocusedDate=this._newUniversalDate(this._oMaxDate);}}
function e(N){if(this._iMode==2){h.call(this,true);}var E=this._getFocusedDate();var F=this.getAggregation("monthPicker");if(!this.getPickerPopup||!this.getPickerPopup()){if(F.getDomRef()){F.$().css("display","");}else{var R=sap.ui.getCore().createRenderManager();var $=this.$("content");R.renderControl(F);R.flush($[0],false,true);R.destroy();}}else{this._openPickerPopup(F);}this.$("contentOver").css("display","");if(!N){F.setMonth(E.getUTCMonth());this._setDisabledMonths(E.getUTCFullYear(),F);if(this._iMode==0){var G=this.getAggregation("month");for(var i=0;i<G.length;i++){var I=G[i];q(I._oItemNavigation.getItemDomRefs()[I._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}}}this._iMode=1;this._togglePrevNext(E,false);}
function f(N){this._iMode=0;if(!this.getPickerPopup||!this.getPickerPopup()){var E=this.getAggregation("monthPicker");E.$().css("display","none");}else if(this._oPopup.isOpen()){this._oPopup.close();}this.$("contentOver").css("display","none");if(!N){_.call(this);if(o.call(this)>1){var F=this.getAggregation("month");for(var i=0;i<F.length;i++){var G=F[i];q(G._oItemNavigation.getItemDomRefs()[G._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");}}}this._togglePrevNext(this._getFocusedDate(),true);}
function g(){if(this._iMode==1){f.call(this,true);}var E=this._getFocusedDate();var F=this.getAggregation("yearPicker");if(!this.getPickerPopup||!this.getPickerPopup()){if(F.getDomRef()){F.$().css("display","");}else{var R=sap.ui.getCore().createRenderManager();var $=this.$("content");R.renderControl(F);R.flush($[0],false,true);R.destroy();}}else{this._openPickerPopup(F);}this.$("contentOver").css("display","");F.setDate(E.getJSDate());var G;if(o.call(this)==1){G=this.getAggregation("month")[0];var I=G.$("days").find(".sapUiCalItem");if(I.length==28){F.$().addClass("sapUiCalYearNoTop");}else{F.$().removeClass("sapUiCalYearNoTop");}}if(this._iMode==0){var J=this.getAggregation("month");for(var i=0;i<J.length;i++){G=J[i];q(G._oItemNavigation.getItemDomRefs()[G._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}}this._togglePrevNexYearPicker();this._iMode=2;}
function h(N){this._iMode=0;if(!this.getPickerPopup||!this.getPickerPopup()){var E=this.getAggregation("yearPicker");E.$().css("display","none");}else if(this._oPopup.isOpen()){this._oPopup.close();}this.$("contentOver").css("display","none");if(!N){_.call(this);if(o.call(this)>1){var F=this.getAggregation("month");for(var i=0;i<F.length;i++){var G=F[i];q(G._oItemNavigation.getItemDomRefs()[G._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");}}}this._togglePrevNext(this._getFocusedDate(),true);}
function j(){if(!this._bNamesLengthChecked){e.call(this,true);f.call(this,true);var i=this.getAggregation("monthPicker");this._bLongMonth=i._bLongMonth;this._bNamesLengthChecked=true;if(!this._bLongMonth){var E=this.getAggregation("month");var F;if(E.length>1){F=a._createUniversalUTCDate(E[0].getDate(),this.getPrimaryCalendarType());}else{F=this._getFocusedDate();}m.call(this,F);}}else if(o.call(this)>1){k.call(this,this._getFocusedDate(),true,true);}}
function k(i,O,N){var F;var E=false;var G=false;if(i.getTime()<this._oMinDate.getTime()){F=this._oMinDate;E=true;}else if(i.getTime()>this._oMaxDate.getTime()){F=this._oMaxDate;E=true;}else{F=i;}if(this._focusDateExtend){G=this._focusDateExtend(i,O,N);}var I=F.getTime()<this._getFocusedDate().getTime();this._setFocusedDate(F);if(E||O){_.call(this,false,I,N);}if(G){this.fireStartDateChange();}}
function m(i){var E=this.getAggregation("header");var F=this._getLocaleData();var G=[];var I=[];var J=[];var K;var S=false;var T;var P;var N=this.getPrimaryCalendarType();var O=this._getSecondaryCalendarType();if(this._bLongMonth||!this._bNamesLengthChecked){G=F.getMonthsStandAlone("wide",N);}else{S=true;G=F.getMonthsStandAlone("abbreviated",N);I=F.getMonthsStandAlone("wide",N);}if(O){J=F.getMonthsStandAlone("abbreviated",O);var Q=this._getDisplayedSecondaryMonths(N,O);if(Q.start==Q.end){T=J[Q.start];}else{P=F.getIntervalPattern();T=P.replace(/\{0\}/,J[Q.start]).replace(/\{1\}/,J[Q.end]);}}E.setAdditionalTextButton1(T);var R=this._getDisplayedMonths(i);if(R.length>1){if(!P){P=F.getIntervalPattern();}T=P.replace(/\{0\}/,G[R[0]]).replace(/\{1\}/,G[R[R.length-1]]);if(S){K=P.replace(/\{0\}/,I[R[0]]).replace(/\{1\}/,I[R[R.length-1]]);}}else{T=G[R[0]];if(S){K=I[R[0]];}}E.setTextButton1(T);if(S){E.setAriaLabelButton1(K);}var V=this._newUniversalDate(i);V.setUTCDate(1);E.setTextButton2(this._oYearFormat.format(V,true));if(O){V=U.getInstance(V.getJSDate(),O);E.setAdditionalTextButton2(this._oYearFormatSecondary.format(V,true));}else{E.setAdditionalTextButton2();}}
function n(i,N){if(i&&(!this._oFocusedDate||this._oFocusedDate.getTime()!=i.getTime())){if(!(i instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}i=a._createUniversalUTCDate(i,this.getPrimaryCalendarType());var E=i.getUTCFullYear();if(E<1||E>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}if(i.getTime()<this._oMinDate.getTime()||i.getTime()>this._oMaxDate.getTime()){throw new Error("Date must not be in valid range (minDate and maxDate); "+this);}this._setFocusedDate(i);if(this.getDomRef()&&this._iMode==0){_.call(this,N,false,true);}}}
function o(){if(sap.ui.Device.system.phone){return 1;}else{return this.getMonths();}}
function p(E){if(this._iMode!=1){e.call(this);}else{f.call(this);}}
function r(E){if(this._iMode!=2){g.call(this);}else{h.call(this);}}
function s(E){this.fireEvent("_renderMonth",{days:E.getParameter("days")});}
function t(E){if(o.call(this)>1){var F=this.getAggregation("month");for(var i=0;i<F.length;i++){var G=F[i];if(G.getId()!=E.oSource.getId()){G._updateSelection();}}}this.fireSelect();}
function u(E){var i=a._createUniversalUTCDate(E.getParameter("date"),this.getPrimaryCalendarType());var O=E.getParameter("otherMonth");var R=E.getParameter("restoreOldDate");if(R){if(!q.sap.equal(this._getFocusedDate(),i)){_.call(this,false,false,true);}}else{k.call(this,i,O);}}
function v(E){if(o.call(this)>1){var F=this.getAggregation("month");for(var i=0;i<F.length;i++){var G=F[i];if(G.getId()!=E.oSource.getId()){G._bindMousemove();}}}}
function w(E){if(o.call(this)>1){var F=this.getAggregation("month");for(var i=0;i<F.length;i++){var G=F[i];if(G.getId()!=E.oSource.getId()){G._unbindMousemove();}}}}
function x(E){var F=this._newUniversalDate(this._getFocusedDate());var i=this.getAggregation("monthPicker");var G=i.getMonth();F.setUTCMonth(G);if(G!=F.getUTCMonth()){F.setUTCDate(0);}k.call(this,F,true);f.call(this);}
function y(E){var F=this._newUniversalDate(this._getFocusedDate());var i=this.getAggregation("yearPicker");var G=a._createUniversalUTCDate(i.getDate(),this.getPrimaryCalendarType());G.setUTCMonth(F.getUTCMonth(),F.getUTCDate());F=G;k.call(this,F,true);h.call(this);}
function z(){this._sInvalidateMonth=undefined;var E=this.getAggregation("month");for(var i=0;i<E.length;i++){var F=E[i];F._bDateRangeChanged=true;F._bInvalidateSync=true;if(E.length>1){F._bNoFocus=true;}F.invalidate();F._bInvalidateSync=undefined;}if(E.length>1){k.call(this,this._getFocusedDate(),true,true);}this._bDateRangeChanged=undefined;}
function A(E){var W=E.size.width;if(W<=0){return;}var O=this._iSize;if(W<this._iBreakPointTablet){this._iSize=0;}else if(W<this._iBreakPointDesktop){this._iSize=1;}else if(W<this._iBreakPointLargeDesktop){this._iSize=2;}else{this._iSize=3;}var F=o.call(this);var G;if(O!=this._iSize||this._bInitMonth){switch(this._iSize){case 1:G=2;break;case 2:G=3;break;case 3:G=4;break;default:G=1;break;}if(F<G){G=F;}if(G>2&&F>G){var I=G;var J=0.0;var K=G;while(I>=2){var N=F%I;if(N==0){K=I;break;}else{var P=N/I;if(P>J){J=P;K=I;}}I--;}G=K;}var Q;var R=this.getAggregation("month");if(G>1){Q=100/G+"%";this.$("content").removeClass("sapUiCalContentSingle");}else{Q="100%";this.$("content").addClass("sapUiCalContentSingle");}for(var i=0;i<R.length;i++){var S=R[i];S.setWidth(Q);}}}
function B(i){var F=this._newUniversalDate(i);F.setUTCDate(1);var E=o.call(this);if(E<=12){var G=i.getUTCMonth();G=G-G%E;if(12%E>0&&G+E>11){G=12-E;}F.setUTCMonth(G);}return F;}
return c;},true);
sap.ui.predefine('sap/ui/unified/CalendarAppointment',['jquery.sap.global','./DateTypeRange','./library'],function(q,D,l){"use strict";
var C=D.extend("sap.ui.unified.CalendarAppointment",{metadata:{library:"sap.ui.unified",properties:{title:{type:"string",group:"Data"},text:{type:"string",group:"Data"},icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},tentative:{type:"boolean",group:"Data",defaultValue:false},selected:{type:"boolean",group:"Data",defaultValue:false},key:{type:"string",group:"Data",defaultValue:null}}}});
C.prototype.applyFocusInfo=function(f){var p=this.getParent();if(p){p.applyFocusInfo(f);}return this;};
return C;},true);
sap.ui.predefine('sap/ui/unified/CalendarDateInterval',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/model/type/Date','sap/ui/unified/calendar/CalendarUtils','./Calendar','./calendar/Header','./calendar/Month','./calendar/DatesRow','./calendar/MonthPicker','./calendar/YearPicker','sap/ui/core/date/UniversalDate','./library'],function(q,C,L,D,a,b,H,M,c,d,Y,U,l){"use strict";
var e=b.extend("sap.ui.unified.CalendarDateInterval",{metadata:{library:"sap.ui.unified",properties:{startDate:{type:"object",group:"Data"},days:{type:"int",group:"Appearance",defaultValue:7},showDayNamesLine:{type:"boolean",group:"Appearance",defaultValue:true},pickerPopup:{type:"boolean",group:"Appearance",defaultValue:false}}}});
e.prototype.init=function(){b.prototype.init.apply(this,arguments);var m=this.getAggregation("monthPicker");m.setColumns(0);m.setMonths(3);m.attachEvent("pageChange",h,this);var y=this.getAggregation("yearPicker");y.setColumns(0);y.setYears(3);y.attachEvent("pageChange",i,this);this._iDaysLarge=10;this._iDaysMonthHead=35;};
e.prototype._createMonth=function(I){var m=new c(I);return m;};
e.prototype.setStartDate=function(s){if(!(s instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}if(q.sap.equal(this.getStartDate(),s)){return this;}var y=s.getFullYear();if(y<1||y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}if(s.getTime()<this._oMinDate.getTime()||s.getTime()>this._oMaxDate.getTime()){throw new Error("Date must not be in valid range (minDate and maxDate); "+this);}var m=this.getMinDate();if(m&&s.getTime()<m.getTime()){q.sap.log.warning("startDate < minDate -> minDate as startDate set",this);s=new Date(m);}var o=this.getMaxDate();if(o&&s.getTime()>o.getTime()){q.sap.log.warning("startDate > maxDate -> maxDate as startDate set",this);s=new Date(o);}var u=a._createUniversalUTCDate(s,this.getPrimaryCalendarType());this.setProperty("startDate",s,true);this._oUTCStartDate=u;var j=this.getAggregation("month")[0];j.setStartDate(s);this._updateHeader(u);var k=a._createLocalDate(this._getFocusedDate(true));if(!j.checkDateFocusable(k)){this._setFocusedDate(u);j.displayDate(s);}return this;};
e.prototype.getStartDate=function(){return this.getProperty("startDate");};
e.prototype.setDays=function(j){this.setProperty("days",j,true);j=this._getDays();var o=this.getAggregation("month")[0];o.setDays(j);if(!this.getPickerPopup()){var m=this.getAggregation("monthPicker");var k=Math.ceil(j/3);if(k>12){k=12;}m.setMonths(k);var y=this.getAggregation("yearPicker");var n=Math.floor(j/2);if(n>20){n=20;}y.setYears(n);}var s=f.call(this);this._updateHeader(s);if(this.getDomRef()){if(j>this._iDaysLarge){this.$().addClass("sapUiCalIntLarge");}else{this.$().removeClass("sapUiCalIntLarge");}if(j>this._iDaysMonthHead){this.$().addClass("sapUiCalIntHead");}else{this.$().removeClass("sapUiCalIntHead");}}return this;};
e.prototype._getDays=function(){var j=this.getDays();if(sap.ui.Device.system.phone&&j>8){return 8;}else{return j;}};
e.prototype.setShowDayNamesLine=function(s){this.setProperty("showDayNamesLine",s,true);var o=this.getAggregation("month")[0];o.setShowDayNamesLine(s);return this;};
e.prototype._getShowMonthHeader=function(){var j=this._getDays();if(j>this._iDaysMonthHead){return true;}else{return false;}};
e.prototype._getFocusedDate=function(F){if(!this._oFocusedDate||F){this._oFocusedDate=null;b.prototype._getFocusedDate.apply(this,arguments);var s=this.getStartDate();var o=this.getAggregation("month")[0];if(!s){_.call(this,this._oFocusedDate,false,true);}else if(!o.checkDateFocusable(a._createLocalDate(this._oFocusedDate))){this._oFocusedDate=a._createUniversalUTCDate(s,this.getPrimaryCalendarType());}}return this._oFocusedDate;};
e.prototype.setMonths=function(m){if(m==1){this.setProperty("months",m,false);}else{throw new Error("Property months not supported "+this);}};
e.prototype.setFirstDayOfWeek=function(F){if(F==-1){this.setProperty("firstDayOfWeek",F,false);}else{throw new Error("Property firstDayOfWeek not supported "+this);}};
e.prototype.focusDate=function(o){var j=this.getAggregation("month")[0];if(!j.checkDateFocusable(o)){var u=a._createUniversalUTCDate(o,this.getPrimaryCalendarType());this._focusDateExtend(u,true,true);}b.prototype.focusDate.apply(this,arguments);return this;};
e.prototype._focusDateExtend=function(o,O,n){if(O){var j=this._getFocusedDate();var s=f.call(this);var k=Math.ceil((j.getTime()-s.getTime())/(1000*3600*24));s=this._newUniversalDate(o);s.setUTCDate(s.getUTCDate()-k);_.call(this,s,false,true);if(!n){return true;}}return false;};
e.prototype._setMinMaxDateExtend=function(o){if(this._oUTCStartDate){if(this._oUTCStartDate.getTime()<this._oMinDate.getTime()){q.sap.log.warning("start date < minDate -> minDate will be start date",this);_.call(this,this._newUniversalDate(this._oMinDate),true,true);}else{var E=new U(this._oUTCStartDate.getTime());E.setUTCDate(E.getUTCDate()+this._getDays()-1);if(E.getTime()>this._oMaxDate.getTime()){q.sap.log.warning("end date > maxDate -> start date will be changed",this);var s=new U(this._oMaxDate.getTime());s.setUTCDate(s.getUTCDate()-this._getDays()+1);_.call(this,s,true,true);}}}};
e.prototype.setPickerPopup=function(p){this.setProperty("pickerPopup",p,true);var m=this.getAggregation("monthPicker");var y=this.getAggregation("yearPicker");if(p){m.setColumns(3);m.setMonths(12);y.setColumns(4);y.setYears(20);}else{m.setColumns(0);m.setMonths(6);y.setColumns(0);y.setYears(6);}};
e.prototype._togglePrevNext=function(o,j){if(this._iMode>1||(this._iMode==1&&this.getPickerPopup())){return b.prototype._togglePrevNext.apply(this,arguments);}var y=this._oMaxDate.getJSDate().getUTCFullYear();var k=this._oMinDate.getJSDate().getUTCFullYear();var m=this._oMaxDate.getJSDate().getUTCMonth();var n=this._oMinDate.getJSDate().getUTCMonth();var p=this._oMinDate.getJSDate().getUTCDate();var r=this._oMaxDate.getJSDate().getUTCDate();var s=this.getAggregation("header");var t=this._getDays();var u;if(this._iMode==1&&!j){var v=this.getAggregation("monthPicker");var w=v.getMonths();var S=v.getStartMonth();var E=S+w-1;u=o.getJSDate().getUTCFullYear();if(S==0||(u==k&&S<=n)){s.setEnabledPrevious(false);}else{s.setEnabledPrevious(true);}if(E>10||(u==y&&E>=m)){s.setEnabledNext(false);}else{s.setEnabledNext(true);}return;}var x=f.call(this);var z=this._newUniversalDate(x);z.setUTCDate(z.getUTCDate()+t-1);if(o.getTime()<x.getTime()||o.getTime()>z.getTime()){x=this._newUniversalDate(o);z=this._newUniversalDate(x);z.setUTCDate(z.getUTCDate()+t-1);}u=x.getJSDate().getUTCFullYear();var A=x.getJSDate().getUTCMonth();var B=x.getJSDate().getUTCDate();if(u<k||(u==k&&(!j||A<n||(A==n&&B<=p)))){s.setEnabledPrevious(false);}else{s.setEnabledPrevious(true);}u=z.getJSDate().getUTCFullYear();A=z.getJSDate().getUTCMonth();B=z.getJSDate().getUTCDate();if(u>y||(u==y&&(!j||A>m||(A==m&&B>=r)))){s.setEnabledNext(false);}else{s.setEnabledNext(true);}};
e.prototype._handlePrevious=function(E){var F=this._newUniversalDate(this._getFocusedDate());var m=this.getAggregation("monthPicker");var y=this.getAggregation("yearPicker");var s=this._newUniversalDate(f.call(this));var j=this._getDays();switch(this._iMode){case 0:s.setUTCDate(s.getUTCDate()-j);F.setUTCDate(F.getUTCDate()-j);this._setFocusedDate(F);_.call(this,s,true);break;case 1:if(m.getMonths()<12){m.previousPage();this._togglePrevNext(F);}else{F.setUTCFullYear(F.getUTCFullYear()-1);var k=this._focusDateExtend(F,true,false);this._setFocusedDate(F);this._updateHeader(F);this._setDisabledMonths(F.getUTCFullYear());if(k){this.fireStartDateChange();}}break;case 2:y.previousPage();this._togglePrevNexYearPicker();break;}};
e.prototype._handleNext=function(E){var F=this._newUniversalDate(this._getFocusedDate());var m=this.getAggregation("monthPicker");var y=this.getAggregation("yearPicker");var s=this._newUniversalDate(f.call(this));var j=this._getDays();switch(this._iMode){case 0:s.setUTCDate(s.getUTCDate()+j);F.setUTCDate(F.getUTCDate()+j);this._setFocusedDate(F);_.call(this,s,true);break;case 1:if(m.getMonths()<12){m.nextPage();this._togglePrevNext(F);}else{F.setUTCFullYear(F.getUTCFullYear()+1);var k=this._focusDateExtend(F,true,false);this._setFocusedDate(F);this._updateHeader(F);this._setDisabledMonths(F.getUTCFullYear());if(k){this.fireStartDateChange();}}break;case 2:y.nextPage();this._togglePrevNexYearPicker();break;}};
e.prototype._getDisplayedMonths=function(o){var m=[];var j=o.getUTCMonth();var k=this._getDays();m.push(j);if(k>this._iDaysLarge){var E=this._newUniversalDate(o);E.setUTCDate(E.getUTCDate()+k-1);var n=E.getUTCMonth();while(j!=n){j=(j+1)%12;m.push(j);}}return m;};
e.prototype._getDisplayedSecondaryMonths=function(p,s){var j=this._getDays();var S=f.call(this);S=U.getInstance(S.getJSDate(),s);var k=S.getUTCMonth();var E=this._newUniversalDate(S);E.setUTCDate(E.getUTCDate()+j-1);E=U.getInstance(E.getJSDate(),s);var m=E.getUTCMonth();return{start:k,end:m};};
e.prototype._openPickerPopup=function(p){if(!this._oPopup){q.sap.require("sap.ui.core.Popup");this._oPopup=new sap.ui.core.Popup();this._oPopup.setAutoClose(true);this._oPopup.setAutoCloseAreas([this.getDomRef()]);this._oPopup.setDurations(0,0);this._oPopup._oCalendar=this;this._oPopup.attachClosed(g,this);this._oPopup.onsapescape=function(E){this._oCalendar.onsapescape(E);};}this._oPopup.setContent(p);var o=this.getAggregation("header");var j=sap.ui.core.Popup.Dock;this._oPopup.open(0,j.CenterTop,j.CenterBottom,o,null,"flipfit",true);};
function _(s,S,n){var m=this._newUniversalDate(this._oMaxDate);m.setUTCDate(m.getUTCDate()-this._getDays()+1);if(m.getTime()<this._oMinDate.getTime()){m=new U(this._oMinDate.getTime());m.setUTCDate(m.getUTCDate()+this._getDays()-1);}if(s.getTime()<this._oMinDate.getTime()){s=this._newUniversalDate(this._oMinDate);}else if(s.getTime()>m.getTime()){s=m;}var o=a._createLocalDate(s);this.setProperty("startDate",o,true);this._oUTCStartDate=s;var j=this.getAggregation("month")[0];j.setStartDate(o);this._updateHeader(s);if(S){var k=a._createLocalDate(this._getFocusedDate());if(!j.checkDateFocusable(k)){this._setFocusedDate(s);j.setDate(o);}else{j.setDate(k);}}if(!n){this.fireStartDateChange();}}
function f(){if(!this._oUTCStartDate){this._oUTCStartDate=this._getFocusedDate();}return this._oUTCStartDate;}
function g(E){this._closedPickers();}
function h(E){var F=this._newUniversalDate(this._getFocusedDate());this._togglePrevNext(F);}
function i(E){this._togglePrevNexYearPicker();}
return e;},true);
sap.ui.predefine('sap/ui/unified/CalendarDateIntervalRenderer',['jquery.sap.global','sap/ui/core/Renderer','./CalendarRenderer'],function(q,R,C){"use strict";var a=R.extend(C);
a.addAttributes=function(r,c){r.addClass("sapUiCalInt");r.addClass("sapUiCalDateInt");var d=c._getDays();if(d>c._iDaysLarge){r.addClass("sapUiCalIntLarge");}if(d>c._iDaysMonthHead){r.addClass("sapUiCalIntHead");}};
return a;},true);
sap.ui.predefine('sap/ui/unified/CalendarLegend',['jquery.sap.global','sap/ui/core/Control','./library'],function(q,C,l){"use strict";
var a=C.extend("sap.ui.unified.CalendarLegend",{metadata:{library:"sap.ui.unified",properties:{columnWidth:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:'120px'}},aggregations:{items:{type:"sap.ui.unified.CalendarLegendItem",multiple:true,singularName:"item"},standardItems:{type:"sap.ui.unified.CalendarLegendItem",multiple:true,visibility:"hidden"}}}});
a.prototype.init=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");var i=this.getId();var I=new sap.ui.unified.CalendarLegendItem(i+"-Today",{text:r.getText("LEGEND_TODAY")});this.addAggregation("standardItems",I);I=new sap.ui.unified.CalendarLegendItem(i+"-Selected",{text:r.getText("LEGEND_SELECTED")});this.addAggregation("standardItems",I);I=new sap.ui.unified.CalendarLegendItem(i+"-NormalDay",{text:r.getText("LEGEND_NORMAL_DAY")});this.addAggregation("standardItems",I);I=new sap.ui.unified.CalendarLegendItem(i+"-NonWorkingDay",{text:r.getText("LEGEND_NON_WORKING_DAY")});this.addAggregation("standardItems",I);};
a.prototype.onAfterRendering=function(){if(sap.ui.Device.browser.msie){if(sap.ui.Device.browser.version<10){q(".sapUiUnifiedLegendItem").css("width",this.getColumnWidth()+4+"px").css("display","inline-block");}}};
return a;},true);
sap.ui.predefine('sap/ui/unified/CalendarLegendItem',['jquery.sap.global','sap/ui/core/Element','./library'],function(q,E,l){"use strict";
var C=E.extend("sap.ui.unified.CalendarLegendItem",{metadata:{library:"sap.ui.unified",properties:{text:{type:"string",group:"Misc",defaultValue:null},type:{type:"sap.ui.unified.CalendarDayType",group:"Appearance",defaultValue:sap.ui.unified.CalendarDayType.None}}}});
return C;},true);
sap.ui.predefine('sap/ui/unified/CalendarLegendRenderer',['jquery.sap.global'],function(q){"use strict";var C={};
C.render=function(r,l){var s=l.getAggregation("standardItems");var c=l.getItems();var i=0;r.write("<div");r.writeControlData(l);r.addClass("sapUiUnifiedLegend");r.writeClasses();var a=l.getColumnWidth();r.writeAttribute("style","column-width:"+a+";-moz-column-width:"+a+";-webkit-column-width:"+a+";");r.writeStyles();r.write(">");var I=l.getId().length+1;for(i=0;i<s.length;i++){var b="sapUiUnifiedLegend"+s[i].getId().slice(I);this.renderLegendItem(r,b,s[i]);}if(c&&c.length>0){var f=q.extend({},sap.ui.unified.CalendarDayType);delete f[sap.ui.unified.CalendarDayType.None];var t="";var T=0;for(t in f){T++;}for(i=0;i<c.length;i++){t=c[i].getType();if(t&&t!=sap.ui.unified.CalendarDayType.None&&f[t]){delete f[t];}}var F=[];for(t in f){F.push(t);}for(i=0;i<c.length;i++){t=c[i].getType();if(!t||t==sap.ui.unified.CalendarDayType.None){if(F[0]){t=F[0];F.splice(0,1);}else{T++;t="Type"+T;}}this.renderLegendItem(r,"sapUiCalLegDayType"+t.slice(4),c[i]);}}r.write("</div>");};
C.renderLegendItem=function(r,c,i){var t=i.getText();var T=i.getTooltip_AsString();r.write("<div");r.writeElementData(i);if(T){r.writeAttributeEscaped('title',T);}r.addClass("sapUiUnifiedLegendItem");r.addClass(c);r.writeClasses();r.write(">");r.write("<div");r.addClass("sapUiUnifiedLegendSquare");r.writeClasses();r.write(">");r.write("<div");r.addClass("sapUiUnifiedLegendSquareColor");r.writeClasses();r.write("></div></div>");r.write("<div");r.addClass("sapUiUnifiedLegendDescription");r.writeClasses();r.write(">");r.writeEscaped(t);r.write("</div></div>");};
return C;},true);
sap.ui.predefine('sap/ui/unified/CalendarMonthInterval',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/model/type/Date','sap/ui/unified/calendar/CalendarUtils','./calendar/Header','./calendar/MonthsRow','./calendar/MonthPicker','./calendar/YearPicker','sap/ui/core/date/UniversalDate','./library'],function(q,C,L,D,a,H,M,b,Y,U,l){"use strict";
var c=C.extend("sap.ui.unified.CalendarMonthInterval",{metadata:{library:"sap.ui.unified",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},startDate:{type:"object",group:"Data"},intervalSelection:{type:"boolean",group:"Behavior",defaultValue:false},singleSelection:{type:"boolean",group:"Behavior",defaultValue:true},months:{type:"int",group:"Appearance",defaultValue:12},pickerPopup:{type:"boolean",group:"Appearance",defaultValue:false},minDate:{type:"object",group:"Misc",defaultValue:null},maxDate:{type:"object",group:"Misc",defaultValue:null}},aggregations:{selectedDates:{type:"sap.ui.unified.DateRange",multiple:true,singularName:"selectedDate"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},header:{type:"sap.ui.unified.calendar.Header",multiple:false,visibility:"hidden"},monthsRow:{type:"sap.ui.unified.calendar.MonthsRow",multiple:false,visibility:"hidden"},yearPicker:{type:"sap.ui.unified.calendar.YearPicker",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.ui.unified.CalendarLegend",multiple:false}},events:{select:{},cancel:{},startDateChange:{}}}});
c.prototype.init=function(){this._iMode=0;this.data("sap-ui-fastnavgroup","true",true);this._oYearFormat=sap.ui.core.format.DateFormat.getDateInstance({format:"y"});this._oMinDate=new U(new Date(Date.UTC(1,0,1)));this._oMinDate.getJSDate().setUTCFullYear(1);this._oMaxDate=new U(new Date(Date.UTC(9999,11,31)));var z=new H(this.getId()+"--Head",{visibleButton0:false,visibleButton1:false,visibleButton2:true});z.attachEvent("pressPrevious",this._handlePrevious,this);z.attachEvent("pressNext",this._handleNext,this);z.attachEvent("pressButton2",p,this);this.setAggregation("header",z);var A=new M(this.getId()+"--MonthsRow");A.attachEvent("focus",s,this);A.attachEvent("select",r,this);A._bNoThemeChange=true;this.setAggregation("monthsRow",A);var B=new Y(this.getId()+"--YP",{columns:0,years:6});B.attachEvent("select",t,this);B.attachEvent("pageChange",y,this);this.setAggregation("yearPicker",B);this._iDaysMonthsHead=15;};
c.prototype.exit=function(){if(this._sInvalidateContent){q.sap.clearDelayedCall(this._sInvalidateContent);}};
c.prototype.onBeforeRendering=function(){var z=this.getAggregation("monthsRow");var A=this._getFocusedDate();i.call(this);z.setDate(a._createLocalDate(A));};
c.prototype.setStartDate=function(S){if(!(S instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}if(q.sap.equal(this.getStartDate(),S)){return this;}var z=S.getFullYear();if(z<1||z>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}var A=a._createUniversalUTCDate(S);this.setProperty("startDate",S,true);this._oUTCStartDate=A;this._oUTCStartDate.setUTCDate(1);var B=this.getAggregation("monthsRow");B.setStartDate(S);i.call(this);var E=a._createLocalDate(this._getFocusedDate());if(!B.checkDateFocusable(E)){this._setFocusedDate(this._oUTCStartDate);B.displayDate(S);}return this;};
c.prototype.invalidate=function(O){if(!this._bDateRangeChanged&&(!O||!(O instanceof sap.ui.unified.DateRange))){C.prototype.invalidate.apply(this,arguments);}else if(this.getDomRef()&&this._iMode==0&&!this._sInvalidateContent){this._sInvalidateContent=q.sap.delayedCall(0,this,u);}};
c.prototype.removeAllSelectedDates=function(){this._bDateRangeChanged=true;var R=this.removeAllAggregation("selectedDates");return R;};
c.prototype.destroySelectedDates=function(){this._bDateRangeChanged=true;var z=this.destroyAggregation("selectedDates");return z;};
c.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=true;var R=this.removeAllAggregation("specialDates");return R;};
c.prototype.destroySpecialDates=function(){this._bDateRangeChanged=true;var z=this.destroyAggregation("specialDates");return z;};
c.prototype.setLocale=function(z){if(this._sLocale!=z){this._sLocale=z;this._oLocaleData=undefined;this.invalidate();}return this;};
c.prototype.getLocale=function(){if(!this._sLocale){this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();}return this._sLocale;};
c.prototype._getFocusedDate=function(){if(!this._oFocusedDate){f.call(this);}return this._oFocusedDate;};
c.prototype._setFocusedDate=function(z){if(!(z instanceof U)){throw new Error("Date must be a UniversalDate object "+this);}this._oFocusedDate=new U(z.getTime());};
c.prototype.focusDate=function(z){var F=false;var A=this.getAggregation("monthsRow");if(!A.checkDateFocusable(z)){var B=a._createUniversalUTCDate(z);v.call(this,B);F=true;}o.call(this,z,false);if(F){this.fireStartDateChange();}return this;};
c.prototype.displayDate=function(z){o.call(this,z,true);return this;};
c.prototype.setMonths=function(z){this.setProperty("months",z,true);z=this._getMonths();var A=this.getAggregation("monthsRow");A.setMonths(z);var B=a._createLocalDate(this._getFocusedDate());if(!A.checkDateFocusable(B)){var S=d.call(this);this._setFocusedDate(this._oUTCStartDate);A.setDate(a._createLocalDate(S));}if(!this.getPickerPopup()){var E=this.getAggregation("yearPicker");var F=Math.floor(z/2);if(F>20){F=20;}E.setYears(F);}i.call(this);if(this.getDomRef()){if(this._getShowItemHeader()){this.$().addClass("sapUiCalIntHead");}else{this.$().removeClass("sapUiCalIntHead");}}};
c.prototype._getMonths=function(){var z=this.getMonths();if(sap.ui.Device.system.phone&&z>6){return 6;}else{return z;}};
c.prototype._getLocaleData=function(){if(!this._oLocaleData){var z=this.getLocale();var A=new sap.ui.core.Locale(z);this._oLocaleData=L.getInstance(A);}return this._oLocaleData;};
c.prototype.setPickerPopup=function(P){this.setProperty("pickerPopup",P,true);var z=this.getAggregation("yearPicker");if(P){z.setColumns(4);z.setYears(20);}else{z.setColumns(0);z.setYears(6);}};
c.prototype.setMinDate=function(z){if(q.sap.equal(z,this.getMinDate())){return this;}if(!z){this._oMinDate.getJSDate().setUTCFullYear(1);this._oMinDate.getJSDate().setUTCMonth(0);this._oMinDate.getJSDate().setUTCDate(1);}else{if(!(z instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}this._oMinDate=a._createUniversalUTCDate(z);this._oMinDate.setDate(1);var A=this._oMinDate.getUTCFullYear();if(A<1||A>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}if(this._oMaxDate.getTime()<this._oMinDate.getTime()){q.sap.log.warning("minDate > maxDate -> maxDate set to end of the month",this);this._oMaxDate=a._createUniversalUTCDate(z);this._oMaxDate.setUTCMonth(this._oMaxDate.getUTCMonth()+1,0);this.setProperty("maxDate",a._createLocalDate(this._oMaxDate),true);}if(this._oFocusedDate){if(this._oFocusedDate.getTime()<this._oMinDate.getTime()){q.sap.log.warning("focused date < minDate -> minDate focused",this);this.focusDate(z);}}if(this._oUTCStartDate&&this._oUTCStartDate.getTime()<this._oMinDate.getTime()){q.sap.log.warning("start date < minDate -> minDate set as start date",this);_.call(this,new U(this._oMinDate.getTime()),true,true);}}this.setProperty("minDate",z,false);var B=this.getAggregation("yearPicker");B._oMinDate.setUTCFullYear(this._oMinDate.getUTCFullYear());return this;};
c.prototype.setMaxDate=function(z){if(q.sap.equal(z,this.getMaxDate())){return this;}if(!z){this._oMaxDate.getJSDate().setUTCFullYear(9999);this._oMaxDate.getJSDate().setUTCMonth(11);this._oMaxDate.getJSDate().setUTCDate(31);}else{if(!(z instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}this._oMaxDate=a._createUniversalUTCDate(z);this._oMaxDate.setUTCMonth(this._oMaxDate.getUTCMonth()+1,0);var A=this._oMaxDate.getUTCFullYear();if(A<1||A>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}if(this._oMinDate.getTime()>this._oMaxDate.getTime()){q.sap.log.warning("maxDate < minDate -> minDate set to begin of the month",this);this._oMinDate=a._createUniversalUTCDate(z);this._oMinDate.setUTCDate(1);this.setProperty("minDate",a._createLocalDate(this._oMinDate),true);}if(this._oFocusedDate){if(this._oFocusedDate.getTime()>this._oMaxDate.getTime()){q.sap.log.warning("focused date > maxDate -> maxDate focused",this);this.focusDate(z);}}if(this._oUTCStartDate){var E=new U(this._oUTCStartDate.getTime());E.setUTCDate(1);E.setUTCMonth(E.getUTCMonth()+this._getMonths());E.setUTCDate(0);if(E.getTime()>this._oMaxDate.getTime()){var S=new U(this._oMaxDate.getTime());S.setUTCDate(1);S.setUTCMonth(S.getUTCMonth()-this._getMonths()+1);if(S.getTime()>=this._oMinDate.getTime()){q.sap.log.warning("end date > maxDate -> maxDate set as end date",this);_.call(this,S,true,true);}}}}this.setProperty("maxDate",z,false);var B=this.getAggregation("yearPicker");B._oMaxDate.setUTCFullYear(this._oMaxDate.getUTCFullYear());return this;};
c.prototype.onclick=function(E){if(E.isMarked("delayedMouseEvent")){return;}if(E.target.id==this.getId()+"-cancel"){this.onsapescape(E);}};
c.prototype.onmousedown=function(E){E.preventDefault();E.setMark("cancelAutoClose");};
c.prototype.onsapescape=function(E){switch(this._iMode){case 0:this.fireCancel();break;case 1:h.call(this);break;}};
c.prototype.onsaptabnext=function(E){var z=this.getAggregation("header");if(q.sap.containsOrEquals(this.getDomRef("content"),E.target)){q.sap.focus(z.getDomRef("B2"));if(!this._bPoupupMode){var A=this.getAggregation("monthsRow");var B=this.getAggregation("yearPicker");q(A._oItemNavigation.getItemDomRefs()[A._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");if(B.getDomRef()){q(B._oItemNavigation.getItemDomRefs()[B._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}}E.preventDefault();}};
c.prototype.onsaptabprevious=function(E){var z=this.getAggregation("header");if(q.sap.containsOrEquals(this.getDomRef("content"),E.target)){if(this._bPoupupMode){q.sap.focus(z.getDomRef("B2"));E.preventDefault();}}else if(E.target.id==z.getId()+"-B2"){var A=this.getAggregation("monthsRow");var B=this.getAggregation("yearPicker");switch(this._iMode){case 0:A._oItemNavigation.focusItem(A._oItemNavigation.getFocusedIndex());break;case 1:B._oItemNavigation.focusItem(B._oItemNavigation.getFocusedIndex());break;}E.preventDefault();}};
c.prototype.onfocusin=function(E){if(E.target.id==this.getId()+"-end"){var z=this.getAggregation("header");var A=this.getAggregation("monthsRow");var B=this.getAggregation("yearPicker");q.sap.focus(z.getDomRef("B2"));if(!this._bPoupupMode){q(A._oItemNavigation.getItemDomRefs()[A._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");if(B.getDomRef()){q(B._oItemNavigation.getItemDomRefs()[B._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}}}this.$("end").attr("tabindex","-1");};
c.prototype.onsapfocusleave=function(E){if(!E.relatedControlId||!q.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(E.relatedControlId).getFocusDomRef())){this.$("end").attr("tabindex","0");if(!this._bPoupupMode){var z=this.getAggregation("monthsRow");var A=this.getAggregation("yearPicker");switch(this._iMode){case 0:q(z._oItemNavigation.getItemDomRefs()[z._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");break;case 1:q(A._oItemNavigation.getItemDomRefs()[A._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");break;}}}};
c.prototype._handlePrevious=function(E){var F=this._getFocusedDate();var z=this.getAggregation("yearPicker");var A=this._getMonths();var S=new U(d.call(this).getTime());switch(this._iMode){case 0:S.setUTCMonth(S.getUTCMonth()-A);F.setUTCMonth(F.getUTCMonth()-A);this._setFocusedDate(F);_.call(this,S,true);break;case 1:z.previousPage();k.call(this);break;}};
c.prototype._handleNext=function(E){var F=this._getFocusedDate();var z=this.getAggregation("yearPicker");var A=this._getMonths();var S=new U(d.call(this).getTime());switch(this._iMode){case 0:S.setUTCMonth(S.getUTCMonth()+A);F.setUTCMonth(F.getUTCMonth()+A);this._setFocusedDate(F);_.call(this,S,true);break;case 1:z.nextPage();k.call(this);break;}};
c.prototype._getShowItemHeader=function(){var z=this.getMonths();if(z>this._iDaysMonthsHead){return true;}else{return false;}};
function _(S,z,N){var A=new U(this._oMaxDate.getTime());A.setUTCDate(1);A.setUTCMonth(A.getUTCMonth()-this._getMonths()+1);if(A.getTime()<this._oMinDate.getTime()){A=new U(this._oMinDate.getTime());A.setUTCMonth(A.getUTCMonth()+this._getMonths()-1);}if(S.getTime()<this._oMinDate.getTime()){S=new U(this._oMinDate.getTime());}else if(S.getTime()>A.getTime()){S=A;}S.setUTCDate(1);var B=a._createLocalDate(S);this.setProperty("startDate",B,true);this._oUTCStartDate=S;var E=this.getAggregation("monthsRow");E.setStartDate(B);i.call(this);if(z){var F=a._createLocalDate(this._getFocusedDate());if(!E.checkDateFocusable(F)){this._setFocusedDate(S);E.setDate(B);}else{E.setDate(F);}}if(!N){this.fireStartDateChange();}}
function d(){if(!this._oUTCStartDate){this._oUTCStartDate=this._getFocusedDate();this._oUTCStartDate.setUTCDate(1);}return this._oUTCStartDate;}
function e(N){var z=this._getFocusedDate();var A=this.getAggregation("monthsRow");if(!N){A.setDate(a._createLocalDate(z));}else{A.displayDate(a._createLocalDate(z));}i.call(this);}
function f(){var S=this.getSelectedDates();if(S&&S[0]&&S[0].getStartDate()){this._oFocusedDate=a._createUniversalUTCDate(S[0].getStartDate());this._oFocusedDate.setUTCDate(1);}else{var N=new Date();this._oFocusedDate=a._createUniversalUTCDate(N);this._oFocusedDate.setUTCDate(1);}if(this._oFocusedDate.getTime()<this._oMinDate.getTime()){this._oFocusedDate=new U(this._oMinDate.getTime());}else if(this._oFocusedDate.getTime()>this._oMaxDate.getTime()){this._oFocusedDate=new U(this._oMaxDate.getTime());}}
function g(){var z=this._getFocusedDate();var A=this.getAggregation("yearPicker");if(!this.getPickerPopup()){if(A.getDomRef()){A.$().css("display","");}else{var R=sap.ui.getCore().createRenderManager();var $=this.$("content");R.renderControl(A);R.flush($[0],false,true);R.destroy();}}else{w.call(this,A);}this.$("contentOver").css("display","");A.setDate(z.getJSDate());if(this._iMode==0){var B=this.getAggregation("monthsRow");q(B._oItemNavigation.getItemDomRefs()[B._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}k.call(this);this._iMode=1;}
function h(N){this._iMode=0;if(!this.getPickerPopup()){var z=this.getAggregation("yearPicker");z.$().css("display","none");}else if(this._oPopup.isOpen()){this._oPopup.close();}this.$("contentOver").css("display","none");if(!N){e.call(this);var A=this.getAggregation("monthsRow");q(A._oItemNavigation.getItemDomRefs()[A._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");}}
function i(){m.call(this);j.call(this);}
function j(){var z=new U(d.call(this).getTime());var A=this._getMonths();var B=z.getJSDate().getUTCFullYear();var E=this._oMaxDate.getJSDate().getUTCFullYear();var F=this._oMinDate.getJSDate().getUTCFullYear();var G=z.getJSDate().getUTCMonth();var I=this._oMaxDate.getJSDate().getUTCMonth();var J=this._oMinDate.getJSDate().getUTCMonth();var K=this.getAggregation("header");if(B<F||(B==F&&G<=J)){K.setEnabledPrevious(false);}else{K.setEnabledPrevious(true);}z.setUTCMonth(z.getUTCMonth()+A-1);B=z.getJSDate().getUTCFullYear();G=z.getJSDate().getUTCMonth();if(B>E||(B==E&&G>=I)){K.setEnabledNext(false);}else{K.setEnabledNext(true);}}
function k(){var z=this.getAggregation("yearPicker");var A=z.getYears();var B=a._createUniversalUTCDate(z.getFirstRenderedDate());B.setUTCFullYear(B.getUTCFullYear()+Math.floor(A/2));var E=this.getAggregation("header");var F=new U(this._oMaxDate);F.setUTCFullYear(F.getUTCFullYear()-Math.ceil(A/2));F.setUTCMonth(11,31);var G=new U(this._oMinDate);G.setUTCFullYear(G.getUTCFullYear()+Math.floor(A/2)+1);G.setUTCMonth(0,1);if(B.getTime()>F.getTime()){E.setEnabledNext(false);}else{E.setEnabledNext(true);}if(B.getTime()<G.getTime()){E.setEnabledPrevious(false);}else{E.setEnabledPrevious(true);}}
function m(){var T;var S=d.call(this);var z=this._oYearFormat.format(S,true);var E=new U(S.getTime());E.setUTCMonth(E.getUTCMonth()+this._getMonths()-1);var A=this._oYearFormat.format(E,true);if(z!=A){var B=this._getLocaleData();var P=B.getIntervalPattern();T=P.replace(/\{0\}/,z).replace(/\{1\}/,A);}else{T=z;}var F=this.getAggregation("header");F.setTextButton2(T);}
function n(z,N){var F;var A=false;if(z.getTime()<this._oMinDate.getTime()){F=this._oMinDate;A=true;}else if(z.getTime()>this._oMaxDate.getTime()){F=this._oMaxDate;A=true;}else{F=z;}this._setFocusedDate(F);if(A||N){v.call(this,F);e.call(this,false);this.fireStartDateChange();}}
function o(z,N){if(z&&(!this._oFocusedDate||this._oFocusedDate.getTime()!=z.getTime())){if(!(z instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}z=a._createUniversalUTCDate(z);var A=z.getUTCFullYear();if(A<1||A>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}if(z.getTime()<this._oMinDate.getTime()||z.getTime()>this._oMaxDate.getTime()){throw new Error("Date must not be in valid range (minDate and maxDate); "+this);}this._setFocusedDate(z);if(this.getDomRef()&&this._iMode==0){e.call(this,N);}}}
function p(E){if(this._iMode!=1){g.call(this);}else{h.call(this);}}
function r(E){this.fireSelect();}
function s(E){var z=a._createUniversalUTCDate(E.getParameter("date"));var N=E.getParameter("notVisible");n.call(this,z,N);}
function t(E){var F=new U(this._getFocusedDate().getTime());var z=this.getAggregation("yearPicker");var A=a._createUniversalUTCDate(z.getDate());A.setUTCMonth(F.getUTCMonth(),F.getUTCDate());F=A;n.call(this,F,true);h.call(this);}
function u(){this._sInvalidateContent=undefined;var z=this.getAggregation("monthsRow");z._bDateRangeChanged=true;z._bInvalidateSync=true;z.invalidate();z._bInvalidateSync=undefined;this._bDateRangeChanged=undefined;}
function v(z){var A=this.getAggregation("monthsRow");var S=d.call(this);var B=A._oItemNavigation.getFocusedIndex();S=new U(z.getTime());S.setUTCMonth(S.getUTCMonth()-B);_.call(this,S,false,true);}
function w(P){if(!this._oPopup){q.sap.require("sap.ui.core.Popup");this._oPopup=new sap.ui.core.Popup();this._oPopup.setAutoClose(true);this._oPopup.setAutoCloseAreas([this.getDomRef()]);this._oPopup.setDurations(0,0);this._oPopup._oCalendar=this;this._oPopup.attachClosed(x,this);this._oPopup.onsapescape=function(E){this._oCalendar.onsapescape(E);};}this._oPopup.setContent(P);var z=this.getAggregation("header");var A=sap.ui.core.Popup.Dock;this._oPopup.open(0,A.CenterTop,A.CenterBottom,z,null,"flipfit",true);}
function x(E){switch(this._iMode){case 0:break;case 1:h.call(this);break;}}
function y(E){k.call(this);}
return c;},true);
sap.ui.predefine('sap/ui/unified/CalendarMonthIntervalRenderer',['jquery.sap.global'],function(q){"use strict";var C={};
C.render=function(r,c){c._iMode=0;var i=c.getId();var t=c.getTooltip_AsString();var m=c.getAggregation("monthsRow");r.write("<div");r.writeControlData(c);r.addClass("sapUiCal");r.addClass("sapUiCalInt");r.addClass("sapUiCalMonthInt");if(c._getShowItemHeader()){r.addClass("sapUiCalIntHead");}r.writeAttribute("tabindex","-1");var a=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");var A={labelledby:{value:"",append:false}};if(c._bPoupupMode){A["role"]="dialog";}r.writeAccessibilityState(c,A);if(t){r.writeAttributeEscaped('title',t);}var w=c.getWidth();if(w&&w!=''){r.addStyle("width",w);r.writeStyles();}r.writeClasses();r.write(">");var h=c.getAggregation("header");r.renderControl(h);r.write("<div id=\""+i+"-content\" class=\"sapUiCalContent\">");r.renderControl(m);r.write("<div id=\""+i+"-contentOver\" class=\"sapUiCalContentOver\" style=\"display:none;\"></div>");r.write("</div>");r.write("<button id=\""+i+"-cancel\" class=\"sapUiCalCancel\" tabindex=\"-1\">");r.write(a.getText("CALENDAR_CANCEL"));r.write("</button>");r.write("<div id=\""+i+"-end\" tabindex=\"0\" style=\"width:0;height:0;position:absolute;right:0;bottom:0;\"></div>");r.write("</div>");};
return C;},true);
sap.ui.predefine('sap/ui/unified/CalendarRenderer',['jquery.sap.global'],function(q){"use strict";var C={};
C.render=function(r,c){c._iMode=0;var I=c.getId();var t=c.getTooltip_AsString();var m=c.getAggregation("month");var w=c.getWidth();r.write("<div");r.writeControlData(c);r.addClass("sapUiCal");if(m.length>1){r.addClass("sapUiCalMulti");}r.writeAttribute("tabindex","-1");var a=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");var A={labelledby:{value:"",append:false}};if(c._bPoupupMode){A["role"]="dialog";}r.writeAccessibilityState(c,A);if(t){r.writeAttributeEscaped('title',t);}if(w){r.addClass("sapUiCalWidth");r.addStyle("width",w);r.writeStyles();}if(c._getSecondaryCalendarType()){r.addClass("sapUiCalSecType");}if(this.addAttributes){this.addAttributes(r,c);}r.writeClasses();r.write(">");var h=c.getAggregation("header");r.renderControl(h);r.write("<div id=\""+I+"-content\" class=\"sapUiCalContent\">");for(var i=0;i<m.length;i++){var M=m[i];r.renderControl(M);}r.write("<div id=\""+I+"-contentOver\" class=\"sapUiCalContentOver\" style=\"display:none;\"></div>");if(!c._bNamesLengthChecked){var o=c.getAggregation("monthPicker");r.renderControl(o);}r.write("</div>");r.write("<button id=\""+I+"-cancel\" class=\"sapUiCalCancel\" tabindex=\"-1\">");r.write(a.getText("CALENDAR_CANCEL"));r.write("</button>");r.write("<div id=\""+I+"-end\" tabindex=\"0\" style=\"width:0;height:0;position:absolute;right:0;bottom:0;\"></div>");r.write("</div>");};
return C;},true);
sap.ui.predefine('sap/ui/unified/CalendarRow',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/model/type/Date','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate','./library'],function(q,C,L,D,a,U,l){"use strict";
var b=C.extend("sap.ui.unified.CalendarRow",{metadata:{library:"sap.ui.unified",properties:{startDate:{type:"object",group:"Data"},intervals:{type:"int",group:"Appearance",defaultValue:12},intervalType:{type:"sap.ui.unified.CalendarIntervalType",group:"Appearance",defaultValue:sap.ui.unified.CalendarIntervalType.Hour},showSubIntervals:{type:"boolean",group:"Appearance",defaultValue:false},showIntervalHeaders:{type:"boolean",group:"Appearance",defaultValue:true},showEmptyIntervalHeaders:{type:"boolean",group:"Appearance",defaultValue:true},nonWorkingDays:{type:"int[]",group:"Misc",defaultValue:null},nonWorkingHours:{type:"int[]",group:"Misc",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},checkResize:{type:"boolean",group:"Behavior",defaultValue:true},updateCurrentTime:{type:"boolean",group:"Behavior",defaultValue:true},appointmentsReducedHeight:{type:"boolean",group:"Appearance",defaultValue:false},appointmentsVisualization:{type:"sap.ui.unified.CalendarAppointmentVisualization",group:"Appearance",defaultValue:sap.ui.unified.CalendarAppointmentVisualization.Standard}},aggregations:{appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment"},intervalHeaders:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"intervalHeader"},groupAppointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"groupAppointment",visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.ui.unified.CalendarLegend",multiple:false}},events:{select:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"},multiSelect:{type:"boolean"}}},startDateChange:{},leaveRow:{parameters:{type:{type:"string"}}},intervalSelect:{parameters:{startDate:{type:"object"},endDate:{type:"object"},subInterval:{type:"boolean"}}}}}});
b.prototype.init=function(){this._bRTL=sap.ui.getCore().getConfiguration().getRTL();this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");if(!sap.ui.unified.CalendarRow._oStaticAppointmentText){sap.ui.unified.CalendarRow._oStaticAppointmentText=new sap.ui.core.InvisibleText({text:this._oRb.getText("APPOINTMENT")});sap.ui.unified.CalendarRow._oStaticAppointmentText.toStatic();sap.ui.unified.CalendarRow._oStaticTentativeText=new sap.ui.core.InvisibleText({text:this._oRb.getText("APPOINTMENT_TENTATIVE")});sap.ui.unified.CalendarRow._oStaticTentativeText.toStatic();}this._oFormatAria=sap.ui.core.format.DateFormat.getDateTimeInstance({style:"long/short"});this._iHoursMinDelta=1;this._iDaysMinDelta=30;this._iMonthsMinDelta=720;this._aVisibleAppointments=[];this._aVisibleIntervalHeaders=[];this.setStartDate(new Date());this._resizeProxy=q.proxy(this.handleResize,this);};
b.prototype.exit=function(){if(this._sResizeListener){sap.ui.core.ResizeHandler.deregister(this._sResizeListener);this._sResizeListener=undefined;}if(this._sUpdateCurrentTime){q.sap.clearDelayedCall(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}};
b.prototype.onBeforeRendering=function(){d.call(this);f.call(this);n.call(this);if(this._sUpdateCurrentTime){q.sap.clearDelayedCall(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}};
b.prototype.onAfterRendering=function(){o.call(this);this.updateCurrentTimeVisualization();if(this.getCheckResize()&&!this._sResizeListener){this._sResizeListener=sap.ui.core.ResizeHandler.register(this,this._resizeProxy);}};
b.prototype.onThemeChanged=function(E){if(this.getDomRef()){for(var i=0;i<this._aVisibleAppointments.length;i++){var A=this._aVisibleAppointments[i];A.level=-1;}this.handleResize(E);}};
b.prototype.invalidate=function(O){if(O&&O instanceof sap.ui.unified.CalendarAppointment){var F=false;for(var i=0;i<this._aVisibleAppointments.length;i++){if(this._aVisibleAppointments[i].appointment==O){F=true;break;}}if(F){this._aVisibleAppointments=[];}}C.prototype.invalidate.apply(this,arguments);};
b.prototype.setStartDate=function(S){if(!S){S=new Date();}if(!(S instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var y=S.getFullYear();if(y<1||y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}this.setProperty("startDate",S);return this;};
b.prototype._getStartDate=function(){if(!this._oUTCStartDate){this._oUTCStartDate=a._createUniversalUTCDate(this.getStartDate(),undefined,true);}return this._oUTCStartDate;};
b.prototype.setIntervalType=function(i){this.setProperty("intervalType",i);this._aVisibleAppointments=[];return this;};
b.prototype.setAppointmentsReducedHeight=function(A){this.setProperty("appointmentsReducedHeight",A);this._aVisibleAppointments=[];return this;};
b.prototype._getAppointmentReducedHeight=function(A){var R=false;if(!sap.ui.Device.system.phone&&this.getAppointmentsReducedHeight()&&!A.getText()){R=true;}return R;};
b.prototype.onfocusin=function(E){if(q(E.target).hasClass("sapUiCalendarApp")){t.call(this,E.target.id);}else{var V=this._getVisibleAppointments();var F=false;var A;for(var i=0;i<V.length;i++){A=V[i].appointment;if(q.sap.containsOrEquals(A.getDomRef(),E.target)){F=true;A.focus();break;}}if(!F){A=this.getFocusedAppointment();if(A){A.focus();}}}};
b.prototype.applyFocusInfo=function(F){if(this._sFocusedAppointmentId){this.getFocusedAppointment().focus();}return this;};
b.prototype.onsapleft=function(E){if(q(E.target).hasClass("sapUiCalendarApp")){u.call(this,this._bRTL,1);}E.preventDefault();E.stopPropagation();};
b.prototype.onsapright=function(E){if(q(E.target).hasClass("sapUiCalendarApp")){u.call(this,!this._bRTL,1);}E.preventDefault();E.stopPropagation();};
b.prototype.onsapup=function(E){this.fireLeaveRow({type:E.type});};
b.prototype.onsapdown=function(E){this.fireLeaveRow({type:E.type});};
b.prototype.onsaphome=function(E){v.call(this,E);E.preventDefault();E.stopPropagation();};
b.prototype.onsapend=function(E){v.call(this,E);E.preventDefault();E.stopPropagation();};
b.prototype.onsapselect=function(E){var V=this._getVisibleAppointments();for(var i=0;i<V.length;i++){var A=V[i].appointment;if(q.sap.containsOrEquals(A.getDomRef(),E.target)){p.call(this,A,!E.ctrlKey);break;}}E.stopPropagation();E.preventDefault();};
b.prototype.onclick=function(E){var i=this.$("Apps").children(".sapUiCalendarRowAppsInt");var I=0;var j=false;for(I=0;I<i.length;I++){var k=i[I];if(q.sap.containsOrEquals(k,E.target)){j=true;break;}}if(j){w.call(this,I,E.target);}else{this.onsapselect(E);}};
b.prototype.onsapselectmodifiers=function(E){this.onsapselect(E);};
b.prototype.handleResize=function(E){if(E&&E.size&&E.size.width<=0){return this;}var $=this.$("DummyApp");$.css("display","");o.call(this);return this;};
b.prototype.updateCurrentTimeVisualization=function(){var N=this.$("Now");var i=a._createUniversalUTCDate(new Date(),undefined,true);var I=this.getIntervals();var j=this.getIntervalType();var S=this._getStartDate();var k=S.getTime();var E=this._oUTCEndDate;var x=E.getTime();this._sUpdateCurrentTime=undefined;if(i.getTime()<=x&&i.getTime()>=k){var B=h.call(this,j,I,S,E,k,i);var T=0;if(this._bRTL){N.css("right",B+"%");}else{N.css("left",B+"%");}N.css("display","");if(this.getUpdateCurrentTime()){switch(j){case sap.ui.unified.CalendarIntervalType.Hour:T=60000;break;case sap.ui.unified.CalendarIntervalType.Day:T=1800000;break;default:T=-1;break;}if(T>0){this._sUpdateCurrentTime=q.sap.delayedCall(T,this,this.updateCurrentTimeVisualization);}}}else{N.css("display","none");}return this;};
b.prototype.getFocusedAppointment=function(){var A=r.call(this);var G=this.getAggregation("groupAppointments",[]);var j;var i=0;for(i=0;i<G.length;i++){if(G[i].getId()==this._sFocusedAppointmentId){j=G[i];break;}}if(!j){for(i=0;i<A.length;i++){if(A[i].getId()==this._sFocusedAppointmentId){j=A[i];break;}}}return j;};
b.prototype.focusAppointment=function(A){if(!A||!(A instanceof sap.ui.unified.CalendarAppointment)){throw new Error("Appointment must be a CalendarAppointment; "+this);}var i=A.getId();if(this._sFocusedAppointmentId!=i){t.call(this,i);}else{A.focus();}return this;};
b.prototype.focusNearestAppointment=function(j){if(!j||!(j instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var A=r.call(this);var N;var P;var k;for(var i=0;i<A.length;i++){N=A[i];if(N.getStartDate()>j){if(i>0){P=A[i-1];}else{P=N;}break;}}if(N){if(P&&Math.abs(N.getStartDate()-j)>=Math.abs(P.getStartDate()-j)){k=P;}else{k=N;}this.focusAppointment(k);}return this;};
b.prototype._getVisibleAppointments=function(){return this._aVisibleAppointments;};
b.prototype._getVisibleIntervalHeaders=function(){return this._aVisibleIntervalHeaders;};
b.prototype._getNonWorkingDays=function(){var N=this.getNonWorkingDays();if(!N){var j=c.call(this);var W=j.getWeekendStart();var k=j.getWeekendEnd();N=[];for(var i=0;i<=6;i++){if((W<=k&&i>=W&&i<=k)||(W>k&&(i>=W||i<=k))){N.push(i);}}}else if(!q.isArray(N)){N=[];}return N;};
function _(){if(!this._sLocale){this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();}return this._sLocale;}
function c(){if(!this._oLocaleData){var i=_.call(this);var j=new sap.ui.core.Locale(i);this._oLocaleData=L.getInstance(j);}return this._oLocaleData;}
function d(){var S=this.getStartDate();var E;var i=this.getIntervals();var I=this.getIntervalType();this._oUTCStartDate=e.call(this,S);switch(I){case sap.ui.unified.CalendarIntervalType.Hour:E=new U(this._oUTCStartDate.getTime());E.setUTCHours(E.getUTCHours()+i);this._iMinDelta=this._iHoursMinDelta;break;case sap.ui.unified.CalendarIntervalType.Day:E=new U(this._oUTCStartDate.getTime());E.setUTCDate(E.getUTCDate()+i);this._iMinDelta=this._iDaysMinDelta;break;case sap.ui.unified.CalendarIntervalType.Month:E=new U(this._oUTCStartDate.getTime());E.setUTCMonth(E.getUTCMonth()+i);this._iMinDelta=this._iMonthsMinDelta;break;default:throw new Error("Unknown IntervalType: "+I+"; "+this);}E.setUTCMilliseconds(-1);this._iRowSize=E.getTime()-this._oUTCStartDate.getTime();this._iIntervalSize=Math.floor(this._iRowSize/i);this._oUTCEndDate=E;}
function e(i){var I=this.getIntervalType();var j=a._createUniversalUTCDate(i,undefined,true);switch(I){case sap.ui.unified.CalendarIntervalType.Hour:j.setUTCMinutes(0);j.setUTCSeconds(0);j.setUTCMilliseconds(0);break;case sap.ui.unified.CalendarIntervalType.Day:j.setUTCHours(0);j.setUTCMinutes(0);j.setUTCSeconds(0);j.setUTCMilliseconds(0);break;case sap.ui.unified.CalendarIntervalType.Month:j.setUTCDate(1);j.setUTCHours(0);j.setUTCMinutes(0);j.setUTCSeconds(0);j.setUTCMilliseconds(0);break;default:throw new Error("Unknown IntervalType: "+I+"; "+this);}return j;}
function f(){var O=this._aVisibleAppointments||[];var A=r.call(this);var x;var G;var y;var I=this.getIntervals();var z=this.getIntervalType();var S=this._getStartDate();var B=S.getTime();var E=this._oUTCEndDate;var F=E.getTime();var V=[];var H=false;var i=0;var j=0;this.destroyAggregation("groupAppointments",true);for(i=0;i<A.length;i++){x=A[i];var J=a._createUniversalUTCDate(x.getStartDate(),undefined,true);J.setUTCSeconds(0);J.setUTCMilliseconds(0);var K=a._createUniversalUTCDate(x.getEndDate(),undefined,true);K.setUTCSeconds(0);K.setUTCMilliseconds(0);var M=false;if(J.getTime()<B&&K.getTime()>=B){J=new U(B);M=true;}if(K.getTime()>F&&J.getTime()<=F){K=new U(F);M=true;}var N=J.getUTCHours()*60+J.getUTCMinutes();J.setUTCMinutes(J.getUTCMinutes()-(N%this._iMinDelta));var P=(K.getTime()-J.getTime())/60000;if(M&&P==0){continue;}var Q=0;var R=0;var T=-1;G=undefined;y=undefined;if(J&&J.getTime()<=F&&K&&K.getTime()>=B){if(z==sap.ui.unified.CalendarIntervalType.Month&&K.getTime()-J.getTime()<604800000){G=g.call(this,J,x,z,I,S,E,B,V);var W=a._createUniversalUTCDate(G.getEndDate(),undefined,true);if(K.getTime()>W.getTime()){y=g.call(this,K,x,z,I,S,E,B,V);}}Q=h.call(this,z,I,S,E,B,J);R=m.call(this,z,I,S,E,B,K);for(j=0;j<O.length;j++){var X=O[j];if(x==X.appointment){T=X.level;}}if(G){G._iBegin=Q;G._iEnd=R;G._iLevel=T;if(y){y._iBegin=Q;y._iEnd=R;y._iLevel=T;}continue;}V.push({appointment:x,begin:Q,end:R,calculatedEnd:R,level:T});if(this._sFocusedAppointmentId&&this._sFocusedAppointmentId==x.getId()){H=true;}}}var Y=this.getAggregation("groupAppointments",[]);if(Y.length>0){for(i=0;i<V.length;i++){x=V[i];if(x.appointment._aAppointments&&x.appointment._aAppointments.length<=1){G=x.appointment;var Z=false;if(G._aAppointments.length==0){Z=true;}else{for(j=0;j<V.length;j++){if(V[j].appointment==G._aAppointments[0]){Z=true;break;}}}if(!Z){for(j=0;j<Y.length;j++){y=Y[j];if(G!=y){for(var k=0;k<y._aAppointments.length;k++){if(G._aAppointments[0]==y._aAppointments[k]){y._aAppointments.splice(k,1);if(y._aAppointments.length==1){this.removeAggregation("groupAppointments",y);y.destroy();Y=this.getAggregation("groupAppointments",[]);}else{y.setProperty("title",y._aAppointments.length,true);}break;}}}}x.begin=G._iBegin;x.end=G._iEnd;x.calculatedEnd=G._iEnd;x.level=G._iLevel;x.appointment=G._aAppointments[0];}else{V.splice(i,1);i--;}this.removeAggregation("groupAppointments",G);G.destroy();Y=this.getAggregation("groupAppointments",[]);}}}if(!H){if(V.length>0){this._sFocusedAppointmentId=V[0].appointment.getId();}else{this._sFocusedAppointmentId=undefined;}}this._aVisibleAppointments=V;return this._aVisibleAppointments;}
function g(i,A,I,k,S,E,x,V){var G=this.getAggregation("groupAppointments",[]);var y;var z=c.call(this);var F=z.getFirstDayOfWeek();var B=i.getDay();var H=new U(i.getTime());H.setUTCHours(0);H.setUTCMinutes(0);H.setUTCSeconds(0);H.setUTCMilliseconds(0);if(F<=B){H.setDate(H.getDate()-(B-F));}else{H.setDate(H.getDate()-(7-B-F));}for(var j=0;j<G.length;j++){y=G[j];var J=a._createUniversalUTCDate(y.getStartDate(),undefined,true);if(J.getTime()==H.getTime()){break;}y=undefined;}if(!y){var K=new U(H.getTime());K.setDate(K.getDate()+7);K.setMilliseconds(-1);y=new sap.ui.unified.CalendarAppointment(this.getId()+"-Group"+G.length,{type:A.getType(),startDate:a._createLocalDate(new Date(H.getTime()),true),endDate:a._createLocalDate(new Date(K.getTime()),true)});y._aAppointments=[];this.addAggregation("groupAppointments",y,true);var M=h.call(this,I,k,S,E,x,H);var N=m.call(this,I,k,S,E,x,K);V.push({appointment:y,begin:M,end:N,calculatedEnd:N,level:-1});}y._aAppointments.push(A);if(y.getType()!=sap.ui.unified.CalendarDayType.None&&y.getType()!=A.getType()){y.setType(sap.ui.unified.CalendarDayType.None);}y.setProperty("title",y._aAppointments.length,true);return y;}
function h(i,I,S,E,j,A){var B=0;if(i!=sap.ui.unified.CalendarIntervalType.Month){B=100*(A.getTime()-j)/this._iRowSize;}else{var M=new U(A.getTime());M.setUTCDate(1);M.setUTCHours(0);M.setUTCMinutes(0);M.setUTCSeconds(0);M.setUTCMilliseconds(0);var k=new U(M.getTime());k.setUTCMonth(k.getUTCMonth()+1);k.setMilliseconds(-1);var x=k.getTime()-M.getTime();var y=(M.getUTCFullYear()-S.getUTCFullYear())*12+M.getUTCMonth()-S.getUTCMonth();B=(100*y/I)+(100*(A.getTime()-M.getTime())/x)/I;}if(B<0){B=0;}B=Math.round(B*100000)/100000;return B;}
function m(i,I,S,E,j,A){var k=0;if(i!=sap.ui.unified.CalendarIntervalType.Month){k=100-(100*(A.getTime()-j)/this._iRowSize);}else{var M=new U(A.getTime());M.setUTCDate(1);M.setUTCHours(0);M.setUTCMinutes(0);M.setUTCSeconds(0);M.setUTCMilliseconds(0);var x=new U(M.getTime());x.setUTCMonth(x.getUTCMonth()+1);x.setMilliseconds(-1);var y=x.getTime()-M.getTime();var z=(M.getUTCFullYear()-S.getUTCFullYear())*12+M.getUTCMonth()-S.getUTCMonth();k=100-((100*z/I)+(100*(A.getTime()-M.getTime())/y)/I);}if(k<0){k=0;}k=Math.round(k*100000)/100000;return k;}
function n(){var V=[];if(this.getShowIntervalHeaders()){var A=this.getIntervalHeaders();var k;var I=this.getIntervals();var x=this.getIntervalType();var S=this._getStartDate();var y=S.getTime();var E=this._oUTCEndDate;var z=E.getTime();var i=0;var j=0;for(i=0;i<A.length;i++){k=A[i];var B=a._createUniversalUTCDate(k.getStartDate(),undefined,true);B.setUTCSeconds(0);B.setUTCMilliseconds(0);var F=a._createUniversalUTCDate(k.getEndDate(),undefined,true);F.setUTCSeconds(0);F.setUTCMilliseconds(0);if(B&&B.getTime()<=z&&F&&F.getTime()>=y){var G=new U(S.getTime());var H=new U(S.getTime());H.setUTCMinutes(H.getUTCMinutes()-1);var J=-1;var K=-1;for(j=0;j<I;j++){switch(x){case sap.ui.unified.CalendarIntervalType.Hour:H.setUTCHours(H.getUTCHours()+1);if(j>0){G.setUTCHours(G.getUTCHours()+1);}break;case sap.ui.unified.CalendarIntervalType.Day:H.setUTCDate(H.getUTCDate()+1);if(j>0){G.setUTCDate(G.getUTCDate()+1);}break;case sap.ui.unified.CalendarIntervalType.Month:H.setUTCDate(1);H.setUTCMonth(H.getUTCMonth()+2);H.setUTCDate(0);if(j>0){G.setUTCMonth(G.getUTCMonth()+1);}break;default:throw new Error("Unknown IntervalType: "+x+"; "+this);}if(B&&B.getTime()<=G.getTime()&&F&&F.getTime()>=H.getTime()){if(J<0){J=j;}K=j;}}if(J>=0){V.push({interval:J,appointment:k,last:K});}}}}this._aVisibleIntervalHeaders=V;return this._aVisibleIntervalHeaders;}
function o(){var A=this.$("Apps");var R=A.innerWidth();if(R<=0){return;}var $=this.$("DummyApp");var H=$.outerHeight(true);if(H<=0){return;}var M=$.outerWidth();var k=M/R*100;var x=Math.ceil(1000*k)/1000;var y;var z;var S=0;var B=0;var i=0;var E=!sap.ui.Device.system.phone&&this.getAppointmentsReducedHeight();if(this.getShowIntervalHeaders()&&(this.getShowEmptyIntervalHeaders()||this._getVisibleIntervalHeaders().length>0)){S=q(this.$("AppsInt0").children(".sapUiCalendarRowAppsIntHead")[0]).outerHeight(true);}for(i=0;i<this._aVisibleAppointments.length;i++){y=this._aVisibleAppointments[i];z=y.appointment.$();var P=Math.floor(1000*(100-y.calculatedEnd-y.begin))/1000;var F=false;if(P<x){y.end=100-y.begin-k;if(y.end<0){y.end=0;}y.level=-1;F=true;z.addClass("sapUiCalendarAppSmall");}else if(z.hasClass("sapUiCalendarAppSmall")){y.end=y.calculatedEnd;F=true;z.removeClass("sapUiCalendarAppSmall");}if(F){if(this._bRTL){z.css("left",y.end+"%");}else{z.css("right",y.end+"%");}}}for(i=0;i<this._aVisibleAppointments.length;i++){y=this._aVisibleAppointments[i];z=y.appointment.$();var G={};var T=E&&!this._getAppointmentReducedHeight(y.appointment);if(y.level<0){for(var j=0;j<this._aVisibleAppointments.length;j++){var V=this._aVisibleAppointments[j];if(y!=V&&y.begin<(Math.floor(1000*(100-V.end))/1000)&&(Math.floor(1000*(100-y.end))/1000)>V.begin&&V.level>=0){if(G[V.level]){G[V.level]++;}else{G[V.level]=1;}if(E&&!this._getAppointmentReducedHeight(V.appointment)){if(G[V.level+1]){G[V.level+1]++;}else{G[V.level+1]=1;}}}}y.level=0;while(G[y.level]||(T&&G[y.level+1])){y.level++;}z.attr("data-sap-level",y.level);}z.css("top",(H*y.level+S)+"px");var I=y.level;if(T){I++;}if(B<I){B=I;}}B++;H=H*B+S;if(!this.getHeight()){A.outerHeight(H);}else{var J=this.$("Apps").children(".sapUiCalendarRowAppsInt");for(i=0;i<J.length;i++){var K=q(J[i]);K.outerHeight(H);}}$.css("display","none");}
function p(A,R){var i=0;var O;if(R){var j=this.getAppointments();var G=this.getAggregation("groupAppointments",[]);q.merge(j,G);for(i=0;i<j.length;i++){O=j[i];if(O.getSelected()){O.setProperty("selected",false,true);O.$().removeClass("sapUiCalendarAppSel");}}}A.setProperty("selected",true,true);A.$().addClass("sapUiCalendarAppSel");if(A._aAppointments){for(i=0;i<A._aAppointments.length;i++){O=A._aAppointments[i];O.setProperty("selected",true,true);}this.fireSelect({appointments:A._aAppointments,multiSelect:!R});}else{this.fireSelect({appointment:A,multiSelect:!R});}}
function r(){var A=this.getAppointments();A.sort(function(i,j){var R=i.getStartDate()-j.getStartDate();if(R==0){R=j.getEndDate()-i.getEndDate();}return R;});return A;}
function s(I){var G=this.getAggregation("groupAppointments",[]);var k;var F=false;for(var i=0;i<G.length;i++){var x=G[i]._aAppointments;for(var j=0;j<x.length;j++){if(x[j].getId()==I){k=G[i];F=true;break;}}if(F){break;}}return k;}
function t(I){if(this._sFocusedAppointmentId!=I){var A=r.call(this);var V=this._aVisibleAppointments;var j;var i=0;j=s.call(this,I);if(j){I=j.getId();j=undefined;}for(i=0;i<V.length;i++){if(V[i].appointment.getId()==I){j=V[i].appointment;break;}}if(j){var O=this.getFocusedAppointment().$();var $=j.$();this._sFocusedAppointmentId=j.getId();O.attr("tabindex","-1");$.attr("tabindex","0");$.focus();}else{for(i=0;i<A.length;i++){if(A[i].getId()==I){j=A[i];break;}}if(j){this._sFocusedAppointmentId=j.getId();var k=e.call(this,j.getStartDate());this.setStartDate(a._createLocalDate(k,true));if(!q.sap.containsOrEquals(this.getDomRef(),document.activeElement)){q.sap.delayedCall(0,this,function(){this.getFocusedAppointment().focus();});}this.fireStartDateChange();}}}}
function u(F,S){var I=this._sFocusedAppointmentId;var A=r.call(this);var G=this.getAggregation("groupAppointments",[]);var j;var k=0;var i=0;for(i=0;i<G.length;i++){if(G[i].getId()==I){var x=G[i]._aAppointments;if(F){I=x[x.length-1].getId();}else{I=x[0].getId();}break;}}for(i=0;i<A.length;i++){if(A[i].getId()==I){k=i;break;}}if(F){k=k+S;}else{k=k-S;}if(k<0){k=0;}else if(k>=A.length){k=A.length-1;}j=A[k];t.call(this,j.getId());}
function v(E){var A=r.call(this);var j;var S=new U(this._getStartDate());var k=new U(this._oUTCEndDate);var I=this.getIntervalType();var x;var G;S.setUTCHours(0);k.setUTCHours(0);k.setUTCMinutes(0);k.setUTCSeconds(0);switch(I){case sap.ui.unified.CalendarIntervalType.Hour:k.setUTCDate(k.getUTCDate()+1);k.setUTCMilliseconds(-1);break;case sap.ui.unified.CalendarIntervalType.Day:S.setUTCDate(1);k.setUTCMonth(k.getUTCMonth()+1);k.setUTCDate(1);k.setUTCMilliseconds(-1);break;case sap.ui.unified.CalendarIntervalType.Month:S.setUTCMonth(0);S.setUTCDate(1);k.setUTCFullYear(k.getUTCFullYear()+1);k.setUTCMonth(1);k.setUTCDate(1);k.setUTCMilliseconds(-1);break;default:throw new Error("Unknown IntervalType: "+I+"; "+this);}var y=a._createLocalDate(S,true);var z=a._createLocalDate(k,true);for(var i=0;i<A.length;i++){if(A[i].getStartDate()>=y&&A[i].getStartDate()<=z){j=A[i];x=j.getId();if(E.type=="saphome"){break;}}else if(A[i].getStartDate()>z){break;}}G=s.call(this,x);if(G){j=G;x=j.getId();}if(x&&x!=this._sFocusedAppointmentId){t.call(this,x);}else if(E._bPlanningCalendar&&j){j.focus();}else{this.fireLeaveRow({type:E.type});}}
function w(i,j){var I=this.getIntervalType();var S=this._getStartDate();var k=new U(S.getTime());var x;var y=false;var z=0;var A=0;if(q(j).hasClass("sapUiCalendarRowAppsSubInt")){y=true;var B=q(q(j).parent()).children(".sapUiCalendarRowAppsSubInt");A=B.length;for(z=0;z<A;z++){var E=B[z];if(E==j){break;}}}switch(I){case sap.ui.unified.CalendarIntervalType.Hour:k.setUTCHours(k.getUTCHours()+i);if(y){k.setUTCMinutes(k.getUTCMinutes()+z*60/A);x=new U(k.getTime());x.setUTCMinutes(x.getUTCMinutes()+60/A);}else{x=new U(k.getTime());x.setUTCHours(x.getUTCHours()+1);}break;case sap.ui.unified.CalendarIntervalType.Day:k.setUTCDate(k.getUTCDate()+i);if(y){k.setUTCHours(k.getUTCHours()+z*24/A);x=new U(k.getTime());x.setUTCHours(x.getUTCHours()+24/A);}else{x=new U(k.getTime());x.setUTCDate(x.getUTCDate()+1);}break;case sap.ui.unified.CalendarIntervalType.Month:k.setUTCMonth(k.getUTCMonth()+i);if(y){k.setUTCDate(k.getUTCDate()+z);x=new U(k.getTime());x.setUTCDate(x.getUTCDate()+1);}else{x=new U(k.getTime());x.setUTCMonth(x.getUTCMonth()+1);}break;default:throw new Error("Unknown IntervalType: "+I+"; "+this);}x.setUTCMilliseconds(x.getUTCMilliseconds()-1);k=a._createLocalDate(k,true);x=a._createLocalDate(x,true);this.fireIntervalSelect({startDate:k,endDate:x,subInterval:y});}
return b;},true);
sap.ui.predefine('sap/ui/unified/CalendarRowRenderer',['jquery.sap.global','sap/ui/core/date/UniversalDate'],function(q,U){"use strict";var C={};
C.render=function(r,R){var t=R.getTooltip_AsString();var v=R.getAppointmentsVisualization();var l=R.getLegend();var T=[];if(l){var L=sap.ui.getCore().byId(l);if(L){T=L.getItems();}else{q.sap.log.warning("CalendarLegend "+l+" does not exist!",R);}}r.write("<div");r.writeControlData(R);r.addClass("sapUiCalendarRow");if(!sap.ui.Device.system.phone&&R.getAppointmentsReducedHeight()){r.addClass("sapUiCalendarRowAppsRedHeight");}if(v!=sap.ui.unified.CalendarAppointmentVisualization.Standard){r.addClass("sapUiCalendarRowVis"+v);}if(R._sFocusedAppointmentId){r.writeAttribute("tabindex","-1");}else{r.writeAttribute("tabindex","0");}if(t){r.writeAttributeEscaped("title",t);}var w=R.getWidth();if(w){r.addStyle("width",w);}var h=R.getHeight();if(h){r.addStyle("height",h);}r.writeAccessibilityState(R);r.writeClasses();r.writeStyles();r.write(">");this.renderAppointmentsRow(r,R,T);r.write("</div>");};
C.renderAppointmentsRow=function(r,R,t){var i=R.getId();r.write("<div id=\""+i+"-Apps\" class=\"sapUiCalendarRowApps\">");this.renderAppointments(r,R,t);r.write("</div>");};
C.renderAppointments=function(r,R,t){var a=R._getVisibleAppointments();var I=R._getVisibleIntervalHeaders();var s=R._getStartDate();var n=[];var S=0;var N=0;var b=[];var c=0;var d=0;var e=R.getIntervals();var f=R.getIntervalType();var w=100/e;var i=0;var o=new U(s);var F=false;var l=false;switch(f){case sap.ui.unified.CalendarIntervalType.Hour:n=R.getNonWorkingHours()||[];S=s.getUTCHours();N=24;break;case sap.ui.unified.CalendarIntervalType.Day:n=R._getNonWorkingDays();S=s.getUTCDay();N=7;b=R.getNonWorkingHours()||[];c=s.getUTCHours();d=24;break;case sap.ui.unified.CalendarIntervalType.Month:b=R._getNonWorkingDays();c=s.getUTCDay();d=7;break;default:break;}for(i=0;i<e;i++){if(l){F=true;}else{F=false;}l=false;switch(f){case sap.ui.unified.CalendarIntervalType.Hour:o.setUTCHours(o.getUTCHours()+1);if(o.getUTCHours()==0){l=true;}break;case sap.ui.unified.CalendarIntervalType.Day:o.setUTCDate(o.getUTCDate()+1);if(o.getUTCDate()==1){l=true;}break;case sap.ui.unified.CalendarIntervalType.Month:o.setUTCMonth(o.getUTCMonth()+1);if(o.getUTCMonth()==0){l=true;}break;default:break;}this.renderInterval(r,R,i,w,I,n,S,N,b,c,d,F,l);}this.renderIntervalHeaders(r,R,w,I,e);r.write("<div id=\""+R.getId()+"-Now\" class=\"sapUiCalendarRowNow\"></div>");for(i=0;i<a.length;i++){var A=a[i];this.renderAppointment(r,R,A,t);}r.write("<div id=\""+R.getId()+"-DummyApp\" class=\"sapUiCalendarApp sapUiCalendarAppTitleOnly sapUiCalendarAppDummy\"></div>");};
C.renderInterval=function(r,R,I,w,a,n,s,N,b,S,c,f,l){var d=R.getId()+"-AppsInt"+I;var i=0;var e=R.getShowIntervalHeaders()&&(R.getShowEmptyIntervalHeaders()||a.length>0);r.write("<div id=\""+d+"\"");r.addClass("sapUiCalendarRowAppsInt");r.addStyle("width",w+"%");for(i=0;i<n.length;i++){if((I+s)%N==n[i]){r.addClass("sapUiCalendarRowAppsNoWork");break;}}if(!e){r.addClass("sapUiCalendarRowAppsIntNoHead");}if(f){r.addClass("sapUiCalendarRowAppsIntFirst");}if(l){r.addClass("sapUiCalendarRowAppsIntLast");}r.writeClasses();r.writeStyles();r.write(">");if(e){r.write("<div");r.addClass("sapUiCalendarRowAppsIntHead");r.writeClasses();r.write(">");r.write("</div>");}if(R.getShowSubIntervals()){var g=R.getIntervalType();var h=0;switch(g){case sap.ui.unified.CalendarIntervalType.Hour:h=4;break;case sap.ui.unified.CalendarIntervalType.Day:h=24;break;case sap.ui.unified.CalendarIntervalType.Month:var o=R._getStartDate();var k=new U(o);k.setUTCMonth(k.getUTCMonth()+I+1,0);h=k.getUTCDate();k.setUTCDate(1);s=k.getUTCDay();break;default:break;}var m=100/h;for(i=0;i<h;i++){r.write("<div");r.addClass("sapUiCalendarRowAppsSubInt");r.addStyle("width",m+"%");for(var j=0;j<b.length;j++){if((i+S)%c==b[j]){r.addClass("sapUiCalendarRowAppsNoWork");break;}}r.writeStyles();r.writeClasses();r.write(">");r.write("</div>");}}r.write("</div>");};
C.renderIntervalHeaders=function(r,R,w,I,a){var s=R.getShowIntervalHeaders()&&(R.getShowEmptyIntervalHeaders()||I.length>0);if(s){for(var i=0;i<I.length;i++){var o=I[i];r.write("<div");r.addClass("sapUiCalendarRowAppsIntHead");if(R._bRTL){r.addStyle("right",w*o.interval+"%");r.addStyle("left",w*(a-o.last-1)+"%");}else{r.addStyle("left",w*o.interval+"%");r.addStyle("right",w*(a-o.last-1)+"%");}r.writeElementData(o.appointment);var b=o.appointment.getId();r.addClass("sapUiCalendarRowAppsIntHeadFirst");if(o.appointment.getSelected()){r.addClass("sapUiCalendarRowAppsIntHeadSel");}if(o.appointment.getTentative()){r.addClass("sapUiCalendarRowAppsIntHeadTent");}var t=o.appointment.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}var T=o.appointment.getType();if(T&&T!=sap.ui.unified.CalendarDayType.None){r.addClass("sapUiCalendarRowAppsIntHead"+T);}r.writeStyles();r.writeClasses();r.write(">");var c=o.appointment.getIcon();if(c){var d=["sapUiCalendarRowAppsIntHeadIcon"];var A={};A["id"]=b+"-Icon";A["title"]=null;r.writeIcon(c,d,A);}var e=o.appointment.getTitle();if(e){r.write("<span");r.writeAttribute("id",b+"-Title");r.addClass("sapUiCalendarRowAppsIntHeadTitle");r.writeClasses();r.write(">");r.writeEscaped(e,true);r.write("</span>");}var f=o.appointment.getText();if(f){r.write("<span");r.writeAttribute("id",b+"-Text");r.addClass("sapUiCalendarRowAppsIntHeadText");r.writeClasses();r.write(">");r.writeEscaped(f,true);r.write("</span>");}r.write("</div>");}}};
C.renderAppointment=function(r,R,a,t){var A=a.appointment;var T=A.getTooltip_AsString();var s=A.getType();var b=A.getTitle();var c=A.getText();var I=A.getIcon();var d=A.getId();var m={labelledby:{value:sap.ui.unified.CalendarRow._oStaticAppointmentText.getId()+" "+d+"-Descr",append:true}};var e=R.getAriaLabelledBy();if(e.length>0){m["labelledby"].value=m["labelledby"].value+" "+e.join(" ");}if(b){m["labelledby"].value=m["labelledby"].value+" "+d+"-Title";}if(c){m["labelledby"].value=m["labelledby"].value+" "+d+"-Text";}r.write("<div");r.writeElementData(A);r.addClass("sapUiCalendarApp");if(A.getSelected()){r.addClass("sapUiCalendarAppSel");m["selected"]=true;}if(A.getTentative()){r.addClass("sapUiCalendarAppTent");m["labelledby"].value=m["labelledby"].value+" "+sap.ui.unified.CalendarRow._oStaticTentativeText.getId();}if(!c){r.addClass("sapUiCalendarAppTitleOnly");}if(I){r.addClass("sapUiCalendarAppWithIcon");}if(R._bRTL){r.addStyle("right",a.begin+"%");r.addStyle("left",a.end+"%");}else{r.addStyle("left",a.begin+"%");r.addStyle("right",a.end+"%");}r.writeAttribute("data-sap-level",a.level);if(R._sFocusedAppointmentId==d){r.writeAttribute("tabindex","0");}else{r.writeAttribute("tabindex","-1");}if(T){r.writeAttributeEscaped("title",T);}if(s&&s!=sap.ui.unified.CalendarDayType.None){r.addClass("sapUiCalendarApp"+s);}r.writeAccessibilityState(A,m);r.writeClasses();r.writeStyles();r.write(">");r.write("<div");r.addClass("sapUiCalendarAppCont");r.writeClasses();r.write(">");if(I){var f=["sapUiCalendarAppIcon"];var g={};g["id"]=d+"-Icon";g["title"]=null;r.writeIcon(I,f,g);}if(b){r.write("<span");r.writeAttribute("id",d+"-Title");r.addClass("sapUiCalendarAppTitle");r.writeClasses();r.write(">");r.writeEscaped(b,true);r.write("</span>");}if(c){r.write("<span");r.writeAttribute("id",d+"-Text");r.addClass("sapUiCalendarAppText");r.writeClasses();r.write(">");r.writeEscaped(c,true);r.write("</span>");}var h=R._oRb.getText("CALENDAR_START_TIME")+": "+R._oFormatAria.format(A.getStartDate());h=h+"; "+R._oRb.getText("CALENDAR_END_TIME")+": "+R._oFormatAria.format(A.getEndDate());if(T){h=h+"; "+T;}if(s&&s!=sap.ui.unified.CalendarDayType.None){for(var i=0;i<t.length;i++){var o=t[i];if(o.getType()==s){h=h+"; "+o.getText();break;}}}r.write("<span id=\""+d+"-Descr\" class=\"sapUiInvisibleText\">"+h+"</span>");r.write("</div>");r.write("</div>");};
return C;},true);
sap.ui.predefine('sap/ui/unified/CalendarTimeInterval',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/model/type/Date','sap/ui/unified/calendar/CalendarUtils','./calendar/Header','./calendar/TimesRow','./calendar/DatesRow','./calendar/MonthPicker','./calendar/YearPicker','sap/ui/core/date/UniversalDate','./library'],function(q,C,L,D,a,H,T,b,M,Y,U,l){"use strict";
var c=C.extend("sap.ui.unified.CalendarTimeInterval",{metadata:{library:"sap.ui.unified",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},startDate:{type:"object",group:"Data"},intervalSelection:{type:"boolean",group:"Behavior",defaultValue:false},singleSelection:{type:"boolean",group:"Behavior",defaultValue:true},items:{type:"int",group:"Appearance",defaultValue:12},intervalMinutes:{type:"int",group:"Appearance",defaultValue:60},pickerPopup:{type:"boolean",group:"Appearance",defaultValue:false},minDate:{type:"object",group:"Misc",defaultValue:null},maxDate:{type:"object",group:"Misc",defaultValue:null}},aggregations:{selectedDates:{type:"sap.ui.unified.DateRange",multiple:true,singularName:"selectedDate"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},header:{type:"sap.ui.unified.calendar.Header",multiple:false,visibility:"hidden"},timesRow:{type:"sap.ui.unified.calendar.TimesRow",multiple:false,visibility:"hidden"},datesRow:{type:"sap.ui.unified.calendar.Month",multiple:false,visibility:"hidden"},monthPicker:{type:"sap.ui.unified.calendar.MonthPicker",multiple:false,visibility:"hidden"},yearPicker:{type:"sap.ui.unified.calendar.YearPicker",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.ui.unified.CalendarLegend",multiple:false}},events:{select:{},cancel:{},startDateChange:{}}}});
c.prototype.init=function(){this._iMode=0;this._oYearFormat=sap.ui.core.format.DateFormat.getDateInstance({format:"y"});this.data("sap-ui-fastnavgroup","true",true);this._oMinDate=new U(new Date(Date.UTC(1,0,1)));this._oMinDate.getJSDate().setUTCFullYear(1);this._oMaxDate=new U(new Date(Date.UTC(9999,11,31,23,59,59)));var Q=new H(this.getId()+"--Head",{visibleButton0:true,visibleButton1:true,visibleButton2:true});Q.attachEvent("pressPrevious",this._handlePrevious,this);Q.attachEvent("pressNext",this._handleNext,this);Q.attachEvent("pressButton0",u,this);Q.attachEvent("pressButton1",v,this);Q.attachEvent("pressButton2",w,this);this.setAggregation("header",Q);var R=new T(this.getId()+"--TimesRow");R.attachEvent("focus",y,this);R.attachEvent("select",x,this);R._bNoThemeChange=true;this.setAggregation("timesRow",R);var S=new M(this.getId()+"--MP",{columns:0,months:6});S.attachEvent("select",B,this);S._bNoThemeChange=true;S.attachEvent("pageChange",O,this);this.setAggregation("monthPicker",S);var V=new Y(this.getId()+"--YP",{columns:0,years:6});V.attachEvent("select",E,this);V.attachEvent("pageChange",P,this);this.setAggregation("yearPicker",V);this.setPickerPopup(false);this._iItemsHead=15;};
c.prototype.exit=function(){if(this._sInvalidateContent){q.sap.clearDelayedCall(this._sInvalidateContent);}};
c.prototype.onBeforeRendering=function(){var Q=this.getAggregation("timesRow");var R=this._getFocusedDate();n.call(this);Q.setDate(a._createLocalDate(R,true));};
c.prototype.setStartDate=function(S){if(!(S instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}if(q.sap.equal(this.getStartDate(),S)){return this;}var Q=S.getFullYear();if(Q<1||Q>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}var R=this.getMinDate();if(R&&S.getTime()<R.getTime()){q.sap.log.warning("startDate < minDate -> minDate as startDate set",this);S=new Date(R);}var V=this.getMaxDate();if(V&&S.getTime()>V.getTime()){q.sap.log.warning("startDate > maxDate -> maxDate as startDate set",this);S=new Date(V);}this.setProperty("startDate",S,true);var W=this.getAggregation("timesRow");W.setStartDate(S);this._oUTCStartDate=new U(W._getStartDate().getTime());n.call(this);var X=a._createLocalDate(this._getFocusedDate(),true);if(!W.checkDateFocusable(X)){this._setFocusedDate(this._oUTCStartDate);W.displayDate(S);}return this;};
c.prototype.invalidate=function(Q){if(!this._bDateRangeChanged&&(!Q||!(Q instanceof sap.ui.unified.DateRange))){if(!Q||(!(Q instanceof sap.ui.unified.calendar.DatesRow||Q instanceof sap.ui.unified.calendar.MonthPicker||Q instanceof sap.ui.unified.calendar.YearPicker||Q instanceof sap.ui.unified.calendar.Header))){C.prototype.invalidate.apply(this,arguments);}}else if(this.getDomRef()&&this._iMode==0&&!this._sInvalidateContent){this._sInvalidateContent=q.sap.delayedCall(0,this,F);}};
c.prototype.removeAllSelectedDates=function(){this._bDateRangeChanged=true;var R=this.removeAllAggregation("selectedDates");return R;};
c.prototype.destroySelectedDates=function(){this._bDateRangeChanged=true;var Q=this.destroyAggregation("selectedDates");return Q;};
c.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=true;var R=this.removeAllAggregation("specialDates");return R;};
c.prototype.destroySpecialDates=function(){this._bDateRangeChanged=true;var Q=this.destroyAggregation("specialDates");return Q;};
c.prototype.setIntervalMinutes=function(Q){if(Q>=720){throw new Error("Only intervals < 720 minutes are allowed; "+this);}if(1440%Q>0){throw new Error("A day must be divisible by the interval size; "+this);}this.setProperty("intervalMinutes",Q,false);var R=this.getAggregation("timesRow");var S=a._createLocalDate(this._getFocusedDate(),true);if(!R.checkDateFocusable(S)){var V=d.call(this);this._setFocusedDate(V);R.setDate(a._createLocalDate(V,true));}return this;};
c.prototype.setLocale=function(Q){if(this._sLocale!=Q){this._sLocale=Q;this._oLocaleData=undefined;this.invalidate();}return this;};
c.prototype.getLocale=function(){if(!this._sLocale){this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();}return this._sLocale;};
c.prototype._getFocusedDate=function(){if(!this._oFocusedDate){f.call(this);}return this._oFocusedDate;};
c.prototype._setFocusedDate=function(Q){if(!(Q instanceof U)){throw new Error("Date must be a UniversalDate object "+this);}this._oFocusedDate=new U(Q.getTime());};
c.prototype.focusDate=function(Q){var R=false;var S=this.getAggregation("timesRow");if(!S.checkDateFocusable(Q)){var V=a._createUniversalUTCDate(Q,undefined,true);G.call(this,V);R=true;}t.call(this,Q,false);if(R){this.fireStartDateChange();}return this;};
c.prototype.displayDate=function(Q){t.call(this,Q,true);return this;};
c.prototype.setItems=function(Q){this.setProperty("items",Q,true);Q=this._getItems();var R=this.getAggregation("timesRow");R.setItems(Q);var S=a._createLocalDate(this._getFocusedDate(),true);if(!R.checkDateFocusable(S)){var V=d.call(this);this._setFocusedDate(V);R.setDate(a._createLocalDate(V,true));}if(!this.getPickerPopup()){var W=this.getAggregation("datesRow");var X=Math.floor(Q*1.5);if(X>31){X=31;}W.setDays(X);var Z=this.getAggregation("monthPicker");var $=Math.floor(Q/2);if($>12){$=12;}Z.setMonths($);var a1=this.getAggregation("yearPicker");var b1=Math.floor(Q/2);if(b1>20){b1=20;}a1.setYears(b1);}n.call(this);if(this.getDomRef()){if(this._getShowItemHeader()){this.$().addClass("sapUiCalIntHead");}else{this.$().removeClass("sapUiCalIntHead");}}};
c.prototype._getItems=function(){var Q=this.getItems();if(sap.ui.Device.system.phone&&Q>6){return 6;}else{return Q;}};
c.prototype._getLocaleData=function(){if(!this._oLocaleData){var Q=this.getLocale();var R=new sap.ui.core.Locale(Q);this._oLocaleData=L.getInstance(R);}return this._oLocaleData;};
c.prototype.setPickerPopup=function(Q){this.setProperty("pickerPopup",Q,true);var R=this.getAggregation("datesRow");var S=this.getAggregation("monthPicker");var V=this.getAggregation("yearPicker");if(R){R.destroy();}if(Q){R=new sap.ui.unified.calendar.Month(this.getId()+"--DatesRow",{selectedDates:[new sap.ui.unified.DateRange(this.getId()+"--Range")]});this.setAggregation("datesRow",R);S.setColumns(3);S.setMonths(12);V.setColumns(4);V.setYears(20);}else{R=new b(this.getId()+"--DatesRow",{days:18,selectedDates:[new sap.ui.unified.DateRange(this.getId()+"--Range")]});this.setAggregation("datesRow",R);S.setColumns(0);S.setMonths(6);V.setColumns(0);V.setYears(6);}R.attachEvent("focus",A,this);R.attachEvent("select",z,this);R._bNoThemeChange=true;R.getIntervalSelection=function(){return this.getProperty("intervalSelection");};R.getSingleSelection=function(){return this.getProperty("singleSelection");};R.getSelectedDates=function(){return this.getAggregation("selectedDates",[]);};R.getSpecialDates=function(){return this.getAggregation("specialDates",[]);};R.getAriaLabelledBy=function(){return this.getAssociation("ariaLabelledBy",[]);};};
c.prototype.setMinDate=function(Q){if(q.sap.equal(Q,this.getMinDate())){return this;}if(!Q){this._oMinDate.getJSDate().setUTCFullYear(1);this._oMinDate.getJSDate().setUTCMonth(0);this._oMinDate.getJSDate().setUTCDate(1);this._oMinDate.getJSDate().setUTCHours(0);this._oMinDate.getJSDate().setUTCMinutes(0);this._oMinDate.getJSDate().setUTCSeconds(0);this._oMinDate.getJSDate().setUTCMilliseconds(0);}else{if(!(Q instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}this._oMinDate=a._createUniversalUTCDate(Q,undefined,true);var R=this.getAggregation("timesRow");this._oMinDate=R._getIntervalStart(this._oMinDate);var S=this._oMinDate.getUTCFullYear();if(S<1||S>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}if(this._oMaxDate.getTime()<this._oMinDate.getTime()){q.sap.log.warning("minDate > maxDate -> maxDate set to end of the month",this);this._oMaxDate=a._createUniversalUTCDate(Q,undefined,true);this._oMaxDate.setUTCMonth(this._oMaxDate.getUTCMonth()+1,0);this._oMaxDate.setUTCHours(23);this._oMaxDate.setUTCMinutes(59);this._oMaxDate.setUTCSeconds(59);this._oMaxDate.setUTCMilliseconds(0);this.setProperty("maxDate",a._createLocalDate(this._oMaxDate,true),true);}if(this._oFocusedDate){if(this._oFocusedDate.getTime()<this._oMinDate.getTime()){q.sap.log.warning("focused date < minDate -> minDate focused",this);this.focusDate(Q);}}if(this._oUTCStartDate&&this._oUTCStartDate.getTime()<this._oMinDate.getTime()){q.sap.log.warning("start date < minDate -> minDate set as start date",this);_.call(this,new U(this._oMinDate.getTime()),true,true);}}this.setProperty("minDate",Q,false);var V=this.getAggregation("yearPicker");V._oMinDate.setUTCFullYear(this._oMinDate.getUTCFullYear());return this;};
c.prototype.setMaxDate=function(Q){if(q.sap.equal(Q,this.getMaxDate())){return this;}if(!Q){this._oMaxDate.getJSDate().setUTCFullYear(9999);this._oMaxDate.getJSDate().setUTCMonth(11);this._oMaxDate.getJSDate().setUTCDate(31);this._oMaxDate.getJSDate().setUTCHours(23);this._oMaxDate.getJSDate().setUTCMinutes(59);this._oMaxDate.getJSDate().setUTCSeconds(59);this._oMaxDate.getJSDate().setUTCMilliseconds(0);}else{if(!(Q instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}this._oMaxDate=a._createUniversalUTCDate(Q,undefined,true);var R=this.getAggregation("timesRow");this._oMaxDate=R._getIntervalStart(this._oMaxDate);this._oMaxDate.setUTCMinutes(this._oMaxDate.getUTCMinutes()+this.getIntervalMinutes());this._oMaxDate.setUTCMilliseconds(-1);var S=this._oMaxDate.getUTCFullYear();if(S<1||S>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}if(this._oMinDate.getTime()>this._oMaxDate.getTime()){q.sap.log.warning("maxDate < minDate -> minDate set to begin of the month",this);this._oMinDate=a._createUniversalUTCDate(Q,undefined,true);this._oMinDate.setUTCDate(1);this._oMinDate.setUTCHours(0);this._oMinDate.setUTCMinutes(0);this._oMinDate.setUTCSeconds(0);this._oMinDate.setUTCMilliseconds(0);this.setProperty("minDate",a._createLocalDate(this._oMinDate,true),true);}if(this._oFocusedDate){if(this._oFocusedDate.getTime()>this._oMaxDate.getTime()){q.sap.log.warning("focused date > maxDate -> maxDate focused",this);this.focusDate(Q);}}if(this._oUTCStartDate){var V=new U(this._oUTCStartDate.getTime());V.setUTCMinutes(V.getUTCMinutes()+this.getIntervalMinutes()*(this._getItems()-1));if(V.getTime()>this._oMaxDate.getTime()){var W=new U(this._oMaxDate.getTime());W.setUTCMinutes(W.getUTCMinutes()-this.getIntervalMinutes()*(this._getItems()-1));if(W.getTime()>=this._oMinDate.getTime()){q.sap.log.warning("end date > maxDate -> maxDate set as end date",this);_.call(this,W,true,true);}}}}this.setProperty("maxDate",Q,false);var X=this.getAggregation("yearPicker");X._oMaxDate.setUTCFullYear(this._oMaxDate.getUTCFullYear());return this;};
c.prototype.onclick=function(Q){if(Q.isMarked("delayedMouseEvent")){return;}if(Q.target.id==this.getId()+"-cancel"){this.onsapescape(Q);}};
c.prototype.onmousedown=function(Q){Q.preventDefault();Q.setMark("cancelAutoClose");};
c.prototype.onsapescape=function(Q){switch(this._iMode){case 0:this.fireCancel();break;case 1:h.call(this);break;case 2:j.call(this);break;case 3:m.call(this);break;}};
c.prototype.onsaptabnext=function(Q){var R=this.getAggregation("header");if(q.sap.containsOrEquals(this.getDomRef("content"),Q.target)){q.sap.focus(R.getDomRef("B0"));if(!this._bPoupupMode){var S=this.getAggregation("timesRow");var V=this.getAggregation("monthPicker");var W=this.getAggregation("yearPicker");q(S._oItemNavigation.getItemDomRefs()[S._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");if(V.getDomRef()){q(V._oItemNavigation.getItemDomRefs()[V._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}if(W.getDomRef()){q(W._oItemNavigation.getItemDomRefs()[W._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}}Q.preventDefault();}else if(Q.target.id==R.getId()+"-B0"){q.sap.focus(R.getDomRef("B1"));Q.preventDefault();}else if(Q.target.id==R.getId()+"-B1"){q.sap.focus(R.getDomRef("B2"));Q.preventDefault();}};
c.prototype.onsaptabprevious=function(Q){var R=this.getAggregation("header");if(q.sap.containsOrEquals(this.getDomRef("content"),Q.target)){if(this._bPoupupMode){q.sap.focus(R.getDomRef("B2"));Q.preventDefault();}}else if(Q.target.id==R.getId()+"-B0"){var S=this.getAggregation("timesRow");var V=this.getAggregation("monthPicker");var W=this.getAggregation("yearPicker");switch(this._iMode){case 0:S._oItemNavigation.focusItem(S._oItemNavigation.getFocusedIndex());break;case 2:V._oItemNavigation.focusItem(V._oItemNavigation.getFocusedIndex());break;case 3:W._oItemNavigation.focusItem(W._oItemNavigation.getFocusedIndex());break;}Q.preventDefault();}else if(Q.target.id==R.getId()+"-B2"){q.sap.focus(R.getDomRef("B1"));Q.preventDefault();}else if(Q.target.id==R.getId()+"-B1"){q.sap.focus(R.getDomRef("B0"));Q.preventDefault();}};
c.prototype.onfocusin=function(Q){if(Q.target.id==this.getId()+"-end"){var R=this.getAggregation("header");var S=this.getAggregation("timesRow");var V=this.getAggregation("monthPicker");var W=this.getAggregation("yearPicker");q.sap.focus(R.getDomRef("B2"));if(!this._bPoupupMode){q(S._oItemNavigation.getItemDomRefs()[S._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");if(V.getDomRef()){q(V._oItemNavigation.getItemDomRefs()[V._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}if(W.getDomRef()){q(W._oItemNavigation.getItemDomRefs()[W._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}}}this.$("end").attr("tabindex","-1");};
c.prototype.onsapfocusleave=function(Q){if(!Q.relatedControlId||!q.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(Q.relatedControlId).getFocusDomRef())){this.$("end").attr("tabindex","0");if(!this._bPoupupMode){var R=this.getAggregation("timesRow");var S=this.getAggregation("monthPicker");var V=this.getAggregation("yearPicker");switch(this._iMode){case 0:q(R._oItemNavigation.getItemDomRefs()[R._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");break;case 2:q(S._oItemNavigation.getItemDomRefs()[S._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");break;case 3:q(V._oItemNavigation.getItemDomRefs()[V._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");break;}}}};
c.prototype._handlePrevious=function(Q){var R=this._getFocusedDate();switch(this._iMode){case 0:var S=this._getItems();var V=new U(d.call(this).getTime());var W=this.getIntervalMinutes();V.setUTCMinutes(V.getUTCMinutes()-S*W);R.setUTCMinutes(R.getUTCMinutes()-S*W);this._setFocusedDate(R);_.call(this,V,true);break;case 1:var X=this.getAggregation("datesRow");var Z=a._createUniversalUTCDate(X.getDate());var $=X.getDays();if(Z.getUTCDate()<=$){Z.setUTCDate(1);}else{Z.setUTCDate(Z.getUTCDate()-$);}I.call(this,Z);break;case 2:var a1=this.getAggregation("monthPicker");if(a1.getMonths()<12){a1.previousPage();o.call(this);}else{R.setUTCFullYear(R.getUTCFullYear()-1);G.call(this,R);this._setFocusedDate(R);n.call(this);N.call(this,R.getUTCFullYear(),a1);this.fireStartDateChange();}break;case 3:var b1=this.getAggregation("yearPicker");b1.previousPage();p.call(this);break;}};
c.prototype._handleNext=function(Q){var R=this._getFocusedDate();switch(this._iMode){case 0:var S=this._getItems();var V=new U(d.call(this).getTime());var W=this.getIntervalMinutes();V.setUTCMinutes(V.getUTCMinutes()+S*W);R.setUTCMinutes(R.getUTCMinutes()+S*W);this._setFocusedDate(R);_.call(this,V,true);break;case 1:var X=this.getAggregation("datesRow");var Z=a._createUniversalUTCDate(X.getDate());var $=new U(Z.getTime());$.setUTCDate(1);$.setUTCMonth($.getUTCMonth()+1);$.setUTCDate(0);var a1=X.getDays();if(Z.getUTCDate()+a1>$.getUTCDate()){Z.setUTCDate($.getUTCDate());}else{Z.setUTCDate(Z.getUTCDate()+a1);}I.call(this,Z);break;case 2:var b1=this.getAggregation("monthPicker");if(b1.getMonths()<12){b1.nextPage();o.call(this);}else{R.setUTCFullYear(R.getUTCFullYear()+1);G.call(this,R);this._setFocusedDate(R);n.call(this);N.call(this,R.getUTCFullYear(),b1);this.fireStartDateChange();}break;case 3:var c1=this.getAggregation("yearPicker");c1.nextPage();p.call(this);break;}};
c.prototype._getShowItemHeader=function(){var Q=this.getItems();if(Q>this._iItemsHead){return true;}else{return false;}};
function _(S,Q,R){var V=new U(this._oMaxDate.getTime());V.setUTCMinutes(V.getUTCMinutes()-this.getIntervalMinutes()*(this._getItems()-1));if(V.getTime()<this._oMinDate.getTime()){V=new U(this._oMinDate.getTime());V.setUTCMinutes(V.getUTCMinutes()+this.getIntervalMinutes()*(this._getItems()-1));}if(S.getTime()<this._oMinDate.getTime()){S=new U(this._oMinDate.getTime());}else if(S.getTime()>V.getTime()){S=V;}var W=this.getAggregation("timesRow");var X=a._createLocalDate(S,true);W.setStartDate(X);this._oUTCStartDate=new U(W._getStartDate().getTime());X=a._createLocalDate(this._oUTCStartDate,true);this.setProperty("startDate",X,true);n.call(this);if(Q){var Z=a._createLocalDate(this._getFocusedDate(),true);if(!W.checkDateFocusable(Z)){this._setFocusedDate(S);W.setDate(X);}else{W.setDate(Z);}}if(!R){this.fireStartDateChange();}}
function d(){if(!this._oUTCStartDate){var Q=this.getAggregation("timesRow");Q.setStartDate(a._createLocalDate(this._getFocusedDate(),true));this._oUTCStartDate=new U(Q._getStartDate().getTime());this._setFocusedDate(this._oUTCStartDate);}return this._oUTCStartDate;}
function e(Q){var R=this._getFocusedDate();var S=this.getAggregation("timesRow");if(!Q){S.setDate(a._createLocalDate(R,true));}else{S.displayDate(a._createLocalDate(R,true));}n.call(this);}
function f(){var S=this.getSelectedDates();if(S&&S[0]&&S[0].getStartDate()){this._oFocusedDate=a._createUniversalUTCDate(S[0].getStartDate(),undefined,true);}else{var Q=new Date();this._oFocusedDate=a._createUniversalUTCDate(Q,undefined,true);}if(this._oFocusedDate.getTime()<this._oMinDate.getTime()){this._oFocusedDate=new U(this._oMinDate.getTime());}else if(this._oFocusedDate.getTime()>this._oMaxDate.getTime()){this._oFocusedDate=new U(this._oMaxDate.getTime());}}
function g(){if(this._iMode==3){m.call(this,true);}else if(this._iMode==2){j.call(this,true);}var Q=this._getFocusedDate();var R=this._getItems();var S=this.getAggregation("datesRow");var V=S.getSelectedDates()[0];V.setStartDate(a._createLocalDate(Q,true));if(!this.getPickerPopup()){var W=new U(Q.getTime());W.setUTCDate(1);W.setUTCMonth(W.getUTCMonth()+1);W.setUTCDate(0);var X=W.getUTCDate();var Z=Math.floor(R*1.5);if(Z>X){Z=X;}S.setDays(Z);if(S.getDomRef()){S.$().css("display","");}else{var $=sap.ui.getCore().createRenderManager();var a1=this.$("content");$.renderControl(S);$.flush(a1[0],false,true);$.destroy();}}else{J.call(this,S);}this.$("contentOver").css("display","");I.call(this,Q);if(this._iMode==0){var b1=this.getAggregation("timesRow");q(b1._oItemNavigation.getItemDomRefs()[b1._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}this._iMode=1;}
function h(Q){this._iMode=0;if(!this.getPickerPopup()){var R=this.getAggregation("datesRow");R.$().css("display","none");}else if(this._oPopup.isOpen()){this._oPopup.close();}this.$("contentOver").css("display","none");if(!Q){e.call(this);var S=this.getAggregation("timesRow");q(S._oItemNavigation.getItemDomRefs()[S._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");}}
function i(){if(this._iMode==1){h.call(this,true);}else if(this._iMode==3){m.call(this,true);}var Q=this._getFocusedDate();var R=this.getAggregation("monthPicker");if(!this.getPickerPopup()){if(R.getDomRef()){R.$().css("display","");}else{var S=sap.ui.getCore().createRenderManager();var $=this.$("content");S.renderControl(R);S.flush($[0],false,true);S.destroy();}}else{J.call(this,R);}this.$("contentOver").css("display","");R.setMonth(Q.getUTCMonth());N.call(this,Q.getUTCFullYear(),R);if(this._iMode==0){var V=this.getAggregation("timesRow");q(V._oItemNavigation.getItemDomRefs()[V._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}this._iMode=2;o.call(this);}
function j(Q){this._iMode=0;if(!this.getPickerPopup()){var R=this.getAggregation("monthPicker");R.$().css("display","none");}else if(this._oPopup.isOpen()){this._oPopup.close();}this.$("contentOver").css("display","none");if(!Q){e.call(this);var S=this.getAggregation("timesRow");q(S._oItemNavigation.getItemDomRefs()[S._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");}}
function k(){if(this._iMode==1){h.call(this,true);}else if(this._iMode==2){j.call(this,true);}var Q=this._getFocusedDate();var R=this.getAggregation("yearPicker");if(!this.getPickerPopup()){if(R.getDomRef()){R.$().css("display","");}else{var S=sap.ui.getCore().createRenderManager();var $=this.$("content");S.renderControl(R);S.flush($[0],false,true);S.destroy();}}else{J.call(this,R);}this.$("contentOver").css("display","");R.setDate(Q.getJSDate());if(this._iMode==0){var V=this.getAggregation("timesRow");q(V._oItemNavigation.getItemDomRefs()[V._oItemNavigation.getFocusedIndex()]).attr("tabindex","-1");}p.call(this);this._iMode=3;}
function m(Q){this._iMode=0;if(!this.getPickerPopup()){var R=this.getAggregation("yearPicker");R.$().css("display","none");}else if(this._oPopup.isOpen()){this._oPopup.close();}this.$("contentOver").css("display","none");if(!Q){e.call(this);var S=this.getAggregation("timesRow");q(S._oItemNavigation.getItemDomRefs()[S._oItemNavigation.getFocusedIndex()]).attr("tabindex","0");}}
function n(){r.call(this);o.call(this,true);}
function o(Q){var R=new U(d.call(this).getTime());var S=this._getItems();var V=R.getJSDate().getUTCFullYear();var W=this._oMaxDate.getJSDate().getUTCFullYear();var X=this._oMinDate.getJSDate().getUTCFullYear();var Z=R.getJSDate().getUTCMonth();var $=this._oMaxDate.getJSDate().getUTCMonth();var a1=this._oMinDate.getJSDate().getUTCMonth();var b1=R.getJSDate().getUTCDate();var c1=this._oMaxDate.getJSDate().getUTCDate();var d1=this._oMinDate.getJSDate().getUTCDate();var e1=R.getJSDate().getUTCHours();var f1=this._oMaxDate.getJSDate().getUTCHours();var g1=this._oMinDate.getJSDate().getUTCHours();var h1=R.getJSDate().getUTCMinutes();var i1=this._oMaxDate.getJSDate().getUTCMinutes();var j1=this._oMinDate.getJSDate().getUTCMinutes();var k1=this.getAggregation("header");if(this._iMode==2&&!Q){var l1=this.getAggregation("monthPicker");var m1=l1.getMonths();var n1=l1.getStartMonth();var o1=n1+m1-1;if(n1==0||(V==X&&n1<=a1)){k1.setEnabledPrevious(false);}else{k1.setEnabledPrevious(true);}if(o1>10||(V==W&&o1>=$)){k1.setEnabledNext(false);}else{k1.setEnabledNext(true);}return;}if((V<X||(V==X&&(!Q||(Z<a1||(Z==a1&&(b1<d1||(b1==d1&&(e1<g1||(e1==g1&&h1<=j1)))))))))||((this._iMode==1||this._iMode==2)&&this.getPickerPopup())){k1.setEnabledPrevious(false);}else{k1.setEnabledPrevious(true);}R.setUTCMinutes(R.getUTCMinutes()+(S)*this.getIntervalMinutes()-1);V=R.getJSDate().getUTCFullYear();Z=R.getJSDate().getUTCMonth();b1=R.getJSDate().getUTCDate();e1=R.getJSDate().getUTCHours();h1=R.getJSDate().getUTCMinutes();if((V>W||(V==W&&(!Q||(Z>$||(Z==$&&(b1>c1||(b1==c1&&(e1>f1||(e1==f1&&h1>=i1)))))))))||((this._iMode==1||this._iMode==2)&&this.getPickerPopup())){k1.setEnabledNext(false);}else{k1.setEnabledNext(true);}}
function p(){var Q=this.getAggregation("yearPicker");var R=Q.getYears();var S=a._createUniversalUTCDate(Q.getFirstRenderedDate());S.setUTCFullYear(S.getUTCFullYear()+Math.floor(R/2));var V=this.getAggregation("header");var W=new U(this._oMaxDate);W.setUTCFullYear(W.getUTCFullYear()-Math.ceil(R/2));W.setUTCMonth(11,31);var X=new U(this._oMinDate);X.setUTCFullYear(X.getUTCFullYear()+Math.floor(R/2)+1);X.setUTCMonth(0,1);if(S.getTime()>W.getTime()){V.setEnabledNext(false);}else{V.setEnabledNext(true);}if(S.getTime()<X.getTime()){V.setEnabledPrevious(false);}else{V.setEnabledPrevious(true);}}
function r(){var Q=this.getAggregation("header");var R;var S=d.call(this);Q.setTextButton0((S.getUTCDate()).toString());var V=this._getLocaleData();var W=[];var X=[];var Z;var $=false;if(this._bLongMonth||!this._bNamesLengthChecked){W=V.getMonthsStandAlone("wide");}else{$=true;W=V.getMonthsStandAlone("abbreviated");X=V.getMonthsStandAlone("wide");}var a1=S.getUTCMonth();R=W[a1];if($){Z=X[W[a1]];}Q.setTextButton1(R);if($){Q.setAriaLabelButton1(Z);}Q.setTextButton2(this._oYearFormat.format(S,true));}
function s(Q,R){var S;var V=false;if(Q.getTime()<this._oMinDate.getTime()){S=this._oMinDate;V=true;}else if(Q.getTime()>this._oMaxDate.getTime()){S=this._oMaxDate;V=true;}else{S=Q;}this._setFocusedDate(S);if(V||R){G.call(this,S);e.call(this,false);this.fireStartDateChange();}}
function t(Q,R){if(Q&&(!this._oFocusedDate||this._oFocusedDate.getTime()!=Q.getTime())){if(!(Q instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}Q=a._createUniversalUTCDate(Q,undefined,true);var S=Q.getUTCFullYear();if(S<1||S>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}if(Q.getTime()<this._oMinDate.getTime()||Q.getTime()>this._oMaxDate.getTime()){throw new Error("Date must not be in valid range (minDate and maxDate); "+this);}this._setFocusedDate(Q);if(this.getDomRef()&&this._iMode==0){e.call(this,R);}}}
function u(Q){if(this._iMode!=1){g.call(this);}else{h.call(this);}}
function v(Q){if(this._iMode!=2){i.call(this);}else{j.call(this);}}
function w(Q){if(this._iMode!=3){k.call(this);}else{m.call(this);}}
function x(Q){this.fireSelect();}
function y(Q){var R=a._createUniversalUTCDate(Q.getParameter("date"),undefined,true);var S=Q.getParameter("notVisible");s.call(this,R,S);}
function z(Q){var R=new U(this._getFocusedDate().getTime());var S=Q.oSource;var V=S.getSelectedDates()[0];var W=a._createUniversalUTCDate(V.getStartDate());if(!this.getPickerPopup()||W.getUTCMonth()==R.getUTCMonth()){R.setUTCDate(W.getUTCDate());R.setUTCMonth(W.getUTCMonth());R.setUTCFullYear(W.getUTCFullYear());s.call(this,R,true);h.call(this);}}
function A(Q){var R=new U(this._getFocusedDate().getTime());var S=a._createUniversalUTCDate(Q.getParameter("date"),undefined,true);var V=Q.getParameter("otherMonth");if(V&&S.getUTCMonth()==R.getUTCMonth()&&S.getUTCFullYear()==R.getUTCFullYear()){I.call(this,S);}}
function B(Q){var R=new U(this._getFocusedDate().getTime());var S=this.getAggregation("monthPicker");var V=S.getMonth();R.setUTCMonth(V);if(V!=R.getUTCMonth()){R.setUTCDate(0);}s.call(this,R,true);j.call(this);}
function E(Q){var R=new U(this._getFocusedDate().getTime());var S=this.getAggregation("yearPicker");var V=a._createUniversalUTCDate(S.getDate());var W=R.getUTCMonth();V.setUTCMonth(R.getUTCMonth(),R.getUTCDate());V.setUTCHours(R.getUTCHours());V.setUTCMinutes(R.getUTCMinutes());R=V;if(W!=R.getUTCMonth()){R.setUTCDate(0);}s.call(this,R,true);m.call(this);}
function F(){this._sInvalidateContent=undefined;var Q=this.getAggregation("timesRow");Q._bDateRangeChanged=true;Q._bInvalidateSync=true;Q.invalidate();Q._bInvalidateSync=undefined;this._bDateRangeChanged=undefined;}
function G(Q){var R=this.getAggregation("timesRow");var S=d.call(this);var V=R._oItemNavigation.getFocusedIndex();S=new U(Q.getTime());S.setUTCMinutes(S.getUTCMinutes()-V*this.getIntervalMinutes());_.call(this,S,false,true);}
function I(Q){var R=this.getAggregation("datesRow");var S=this.getAggregation("header");if(!this.getPickerPopup()){var V=new U(Q.getTime());V.setUTCDate(1);V.setUTCMonth(V.getUTCMonth()+1);V.setUTCDate(0);var W=R.getDays();var X=new U(Q.getTime());X.setUTCDate(1+(Math.ceil(Q.getUTCDate()/W)-1)*W);if(V.getUTCDate()-X.getUTCDate()<W){X.setUTCDate(V.getUTCDate()-W+1);}R.setStartDate(a._createLocalDate(X,true));var Z=X.getJSDate().getUTCFullYear();var $=this._oMaxDate.getJSDate().getUTCFullYear();var a1=this._oMinDate.getJSDate().getUTCFullYear();var b1=X.getJSDate().getUTCMonth();var c1=this._oMaxDate.getJSDate().getUTCMonth();var d1=this._oMinDate.getJSDate().getUTCMonth();var e1=X.getJSDate().getUTCDate();var f1=this._oMaxDate.getJSDate().getUTCDate();var g1=this._oMinDate.getJSDate().getUTCDate();if(e1<=1||(Z==a1&&b1==d1&&e1<=g1)){S.setEnabledPrevious(false);}else{S.setEnabledPrevious(true);}if((e1+W)>=V.getUTCDate()||(Z==$&&b1==c1&&e1>=f1)){S.setEnabledNext(false);}else{S.setEnabledNext(true);}}else{S.setEnabledPrevious(false);S.setEnabledNext(false);}R.setDate(a._createLocalDate(Q,true));}
function J(Q){if(!this._oPopup){q.sap.require("sap.ui.core.Popup");this._oPopup=new sap.ui.core.Popup();this._oPopup.setAutoClose(true);this._oPopup.setAutoCloseAreas([this.getDomRef()]);this._oPopup.setDurations(0,0);this._oPopup._oCalendar=this;this._oPopup.attachClosed(K,this);this._oPopup.onsapescape=function(V){this._oCalendar.onsapescape(V);};}this._oPopup.setContent(Q);var R=this.getAggregation("header");var S=sap.ui.core.Popup.Dock;this._oPopup.open(0,S.CenterTop,S.CenterBottom,R,null,"flipfit",true);}
function K(Q){switch(this._iMode){case 0:break;case 1:h.call(this);break;case 2:j.call(this);break;case 3:m.call(this);break;}}
function N(Q,R){var S=0;var V=11;if(Q==this._oMinDate.getUTCFullYear()){S=this._oMinDate.getUTCMonth();}if(Q==this._oMaxDate.getUTCFullYear()){V=this._oMaxDate.getUTCMonth();}R.setMinMax(S,V);}
function O(Q){o.call(this);}
function P(Q){p.call(this);}
return c;},true);
sap.ui.predefine('sap/ui/unified/CalendarTimeIntervalRenderer',['jquery.sap.global'],function(q){"use strict";var C={};
C.render=function(r,c){c._iMode=0;var i=c.getId();var t=c.getTooltip_AsString();var T=c.getAggregation("timesRow");r.write("<div");r.writeControlData(c);r.addClass("sapUiCal");r.addClass("sapUiCalInt");r.addClass("sapUiCalTimeInt");if(c._getShowItemHeader()){r.addClass("sapUiCalIntHead");}r.writeAttribute("tabindex","-1");var a=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");var A={labelledby:{value:"",append:false}};if(c._bPoupupMode){A["role"]="dialog";}r.writeAccessibilityState(c,A);if(t){r.writeAttributeEscaped('title',t);}var w=c.getWidth();if(w&&w!=''){r.addStyle("width",w);r.writeStyles();}r.writeClasses();r.write(">");var h=c.getAggregation("header");r.renderControl(h);r.write("<div id=\""+i+"-content\" class=\"sapUiCalContent\">");r.renderControl(T);r.write("<div id=\""+i+"-contentOver\" class=\"sapUiCalContentOver\" style=\"display:none;\"></div>");r.write("</div>");r.write("<button id=\""+i+"-cancel\" class=\"sapUiCalCancel\" tabindex=\"-1\">");r.write(a.getText("CALENDAR_CANCEL"));r.write("</button>");r.write("<div id=\""+i+"-end\" tabindex=\"0\" style=\"width:0;height:0;position:absolute;right:0;bottom:0;\"></div>");r.write("</div>");};
return C;},true);
sap.ui.predefine('sap/ui/unified/ContentSwitcher',['jquery.sap.global','sap/ui/core/Control','./library'],function(q,C,l){"use strict";
var a=C.extend("sap.ui.unified.ContentSwitcher",{metadata:{deprecated:true,library:"sap.ui.unified",properties:{animation:{type:"string",group:"Appearance",defaultValue:'None'},activeContent:{type:"int",group:"Behavior",defaultValue:1}},aggregations:{content1:{type:"sap.ui.core.Control",multiple:true,singularName:"content1"},content2:{type:"sap.ui.core.Control",multiple:true,singularName:"content2"}}}});
(function(w){
a.prototype.init=function(){};
a.prototype.switchContent=function(){this.setActiveContent(this.getActiveContent()==1?2:1);return this;};
a.prototype.onAfterRendering=function(){this._$Contents=[this.$("content1"),this.$("content2")];};
a.prototype._showActiveContent=function(n){this._$Contents[0].toggleClass("sapUiUfdCSwitcherVisible",n===1);this._$Contents[1].toggleClass("sapUiUfdCSwitcherVisible",n===2);};
a.prototype.setActiveContent=function(n){n=parseInt(n,10);if(isNaN(n)||n<1){n=1;q.sap.log.warning("setActiveContent argument must be either 1 or 2. Active content set to 1.");}else if(n>2){n=2;q.sap.log.warning("setActiveContent argument must be either 1 or 2. Active content set to 2.");}this.setProperty("activeContent",n,true);this._showActiveContent(n);return this;};
a.prototype.setAnimation=function(A,s){if(typeof(A)!=="string"){A=sap.ui.unified.ContentSwitcherAnimation.None;q.sap.log.warning("setAnimation argument must be a string. Animation was set to \""+sap.ui.unified.ContentSwitcherAnimation.None+"\".");}A=A.replace(/[^a-zA-Z0-9]/g,"");var c=this.getProperty("animation");if(A===c){return;}var d=this.$();if(d[0]){d.toggleClass("sapUiUfdCSwitcherAnimation"+c,false);d.toggleClass("sapUiUfdCSwitcherAnimation"+A,true);}this.setProperty("animation",A,s);return this;};
})(window);return a;},true);
sap.ui.predefine('sap/ui/unified/ContentSwitcherRenderer',['jquery.sap.global'],function(q){"use strict";var C={};
C.render=function(r,c){var i=c.getId();var a=c.getAnimation();if(!sap.ui.getCore().getConfiguration().getAnimation()){a=sap.ui.unified.ContentSwitcherAnimation.None;}var A=c.getActiveContent();r.write("<div");r.writeControlData(c);r.addClass("sapUiUfdCSwitcher");r.addClass("sapUiUfdCSwitcherAnimation"+q.sap.encodeHTML(a));r.writeClasses();r.write(">");r.write("<section id=\""+i+"-content1\" class=\"sapUiUfdCSwitcherContent sapUiUfdCSwitcherContent1"+(A==1?" sapUiUfdCSwitcherVisible":"")+"\">");this.renderContent(r,c.getContent1());r.write("</section>");r.write("<section id=\""+i+"-content2\" class=\"sapUiUfdCSwitcherContent sapUiUfdCSwitcherContent2"+(A==2?" sapUiUfdCSwitcherVisible":"")+"\">");this.renderContent(r,c.getContent2());r.write("</section>");r.write("</div>");};
C.renderContent=function(r,c){for(var i=0;i<c.length;++i){r.renderControl(c[i]);}};
return C;},true);
sap.ui.predefine('sap/ui/unified/Currency',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/core/format/NumberFormat'],function(q,C,L,N){"use strict";
var a=C.extend("sap.ui.unified.Currency",{metadata:{library:"sap.ui.unified",properties:{value:{type:"float",group:"Appearance",defaultValue:0},currency:{type:"string",group:"Appearance",defaultValue:null},maxPrecision:{type:"int",group:"Appearance",defaultValue:3},useSymbol:{type:"boolean",group:"Appearance",defaultValue:true}}}});
a.FIGURE_SPACE='\u2007';a.PUNCTUATION_SPACE='\u2008';
a.prototype.init=function(){this._oFormat=N.getCurrencyInstance({showMeasure:false});};
a.prototype.exit=function(){this._oFormat=null;this._$Value=null;this._$Currency=null;this._sLastCurrency=null;this._iLastCurrencyDigits=null;this._bRenderNoValClass=null;};
a.prototype.onAfterRendering=function(){if(this.$()){this._$Value=this.$().find(".sapUiUfdCurrencyValue");this._$Currency=this.$().find(".sapUiUfdCurrencyCurrency");}};
a.prototype.setValue=function(v){if(this.isBound("value")){this._bRenderNoValClass=v==null;if(this.$()){this.$().toggleClass("sapUiUfdCurrencyNoVal",this._bRenderNoValClass);}}this.setProperty("value",v,true);this._renderValue();return this;};
a.prototype.unbindProperty=function(p){C.prototype.unbindProperty.apply(this,arguments);if(p==="value"){this._bRenderNoValClass=false;if(this.$()){this.$().toggleClass("sapUiUfdCurrencyNoVal",false);}}};
a.prototype.setCurrency=function(v){var c,r;this.setProperty("currency",v,true);this._renderCurrency();c=this._oFormat.oLocaleData.getCurrencyDigits(v);if(q.isNumeric(this._iLastCurrencyDigits)&&this._iLastCurrencyDigits!==c){r=true;}this._iLastCurrencyDigits=c;if(this._sLastCurrency==="*"||v==="*"){r=true;}this._sLastCurrency=v;if(r){this._renderValue();if(v==="*"&&this.$()){this._bRenderNoValClass=false;this.$().toggleClass("sapUiUfdCurrencyNoVal",false);}}return this;};
a.prototype.setUseSymbol=function(v){this.setProperty("useSymbol",v,true);this._renderCurrency();return this;};
a.prototype.setMaxPrecision=function(v){this.setProperty("maxPrecision",v,true);this._renderValue();return this;};
a.prototype._renderValue=function(){if(this._$Value){this._$Value.text(this.getFormattedValue());}};
a.prototype._renderCurrency=function(){if(this._$Currency){this._$Currency.text(this._getCurrency());}};
a.prototype._getCurrency=function(){return this.getUseSymbol()?this.getCurrencySymbol():this.getCurrency();};
a.prototype.getFormattedValue=function(){var c=this.getCurrency(),m,p,i,f;if(c==="*"){return"";}i=this._oFormat.oLocaleData.getCurrencyDigits(c);m=this.getMaxPrecision();m=(m<=0&&i>0?m-1:m);p=m-i;f=this._oFormat.format(this.getValue(),c);if(p==m&&m>0){f+=a.PUNCTUATION_SPACE;}if(p>0){f=q.sap.padRight(f,a.FIGURE_SPACE,f.length+p);}else if(p<0){f=f.substr(0,f.length+p);}return f;};
a.prototype.getCurrencySymbol=function(){return this._oFormat.oLocaleData.getCurrencySymbol(this.getCurrency());};
a.prototype.getAccessibilityInfo=function(){if(this._bRenderNoValClass){return{};}return{description:(this.getFormattedValue()||"")+" "+(this.getCurrency()||"").trim()};};
return a;},true);
sap.ui.predefine('sap/ui/unified/CurrencyRenderer',['jquery.sap.global'],function(q){"use strict";var C={};
C.render=function(r,c){var t=c.getTooltip_AsString();r.write("<div");r.writeControlData(c);if(t){r.writeAttributeEscaped("title",t);}r.addClass("sapUiUfdCurrency");if(c._bRenderNoValClass){r.addClass("sapUiUfdCurrencyNoVal");}r.writeClasses();r.write(">");r.write("<div");r.addClass("sapUiUfdCurrencyAlign");r.writeClasses();r.write(">");r.write("<span");r.writeAttribute("dir","ltr");r.addClass("sapUiUfdCurrencyValue");r.writeClasses();r.write(">");r.writeEscaped(c.getFormattedValue());r.write("</span>");r.write("<span");r.addClass("sapUiUfdCurrencyCurrency");r.writeClasses();r.write(">");r.writeEscaped(c._getCurrency());r.write("</span>");r.write("</div>");r.write("</div>");};
return C;},true);
sap.ui.predefine('sap/ui/unified/DateRange',['jquery.sap.global','sap/ui/core/Element','./library'],function(q,E,l){"use strict";
var D=E.extend("sap.ui.unified.DateRange",{metadata:{library:"sap.ui.unified",properties:{startDate:{type:"object",group:"Misc",defaultValue:null},endDate:{type:"object",group:"Misc",defaultValue:null}}}});
D.prototype.setStartDate=function(d){if(d){if(!(d instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var y=d.getFullYear();if(y<1||y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}}this.setProperty("startDate",d);return this;};
D.prototype.setEndDate=function(d){if(d){if(!(d instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var y=d.getFullYear();if(y<1||y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}}this.setProperty("endDate",d);return this;};
return D;},true);
sap.ui.predefine('sap/ui/unified/DateTypeRange',['jquery.sap.global','./DateRange','./library'],function(q,D,l){"use strict";
var a=D.extend("sap.ui.unified.DateTypeRange",{metadata:{library:"sap.ui.unified",properties:{type:{type:"sap.ui.unified.CalendarDayType",group:"Appearance",defaultValue:sap.ui.unified.CalendarDayType.Type01}}}});
return a;},true);
sap.ui.predefine('sap/ui/unified/FileUploader',['jquery.sap.global','sap/ui/core/Control','./library','sap/ui/core/LabelEnablement'],function(q,C,a,L){"use strict";
var F=C.extend("sap.ui.unified.FileUploader",{metadata:{library:"sap.ui.unified",properties:{value:{type:"string",group:"Data",defaultValue:''},enabled:{type:"boolean",group:"Behavior",defaultValue:true},uploadUrl:{type:"sap.ui.core.URI",group:"Data",defaultValue:''},name:{type:"string",group:"Data",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:''},uploadOnChange:{type:"boolean",group:"Behavior",defaultValue:false},additionalData:{type:"string",group:"Data",defaultValue:null},sameFilenameAllowed:{type:"boolean",group:"Behavior",defaultValue:false},buttonText:{type:"string",group:"Misc",defaultValue:null},fileType:{type:"string[]",group:"Data",defaultValue:null},multiple:{type:"boolean",group:"Behavior",defaultValue:false},maximumFileSize:{type:"float",group:"Data",defaultValue:null},mimeType:{type:"string[]",group:"Data",defaultValue:null},sendXHR:{type:"boolean",group:"Behavior",defaultValue:false},placeholder:{type:"string",group:"Appearance",defaultValue:null},style:{type:"string",group:"Appearance",defaultValue:null},buttonOnly:{type:"boolean",group:"Appearance",defaultValue:false},useMultipart:{type:"boolean",group:"Behavior",defaultValue:true},maximumFilenameLength:{type:"int",group:"Data",defaultValue:null},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:sap.ui.core.ValueState.None},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:''},iconHovered:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:''},iconSelected:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:''},iconFirst:{type:"boolean",group:"Appearance",defaultValue:true},iconOnly:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{parameters:{type:"sap.ui.unified.FileUploaderParameter",multiple:true,singularName:"parameter"},headerParameters:{type:"sap.ui.unified.FileUploaderParameter",multiple:true,singularName:"headerParameter"}},events:{change:{parameters:{newValue:{type:"string"},files:{type:"object[]"}}},uploadComplete:{parameters:{fileName:{type:"string"},response:{type:"string"},readyStateXHR:{type:"string"},status:{type:"string"},responseRaw:{type:"string"},headers:{type:"object"},requestHeaders:{type:"object[]"}}},typeMissmatch:{parameters:{fileName:{type:"string"},fileType:{type:"string"},mimeType:{type:"string"}}},fileSizeExceed:{parameters:{fileName:{type:"string"},fileSize:{type:"string"}}},fileAllowed:{},uploadProgress:{parameters:{lengthComputable:{type:"boolean"},loaded:{type:"float"},total:{type:"float"},fileName:{type:"string"},requestHeaders:{type:"object[]"}}},uploadAborted:{parameters:{fileName:{type:"string"},requestHeaders:{type:"object[]"}}},filenameLengthExceed:{parameters:{fileName:{type:"string"}}},uploadStart:{parameters:{fileName:{type:"string"},requestHeaders:{type:"object[]"}}}}}});
F.prototype.init=function(){this.oFilePath=sap.ui.unified.FileUploaderHelper.createTextField(this.getId()+"-fu_input");this.oBrowse=sap.ui.unified.FileUploaderHelper.createButton();this.oFilePath.setParent(this);this.oBrowse.setParent(this);this.oFileUpload=null;this.bMobileLib=this.oBrowse.getMetadata().getName()=="sap.m.Button";if(!this.getIconOnly()){this.oBrowse.setText(this.getBrowseText());}else{this.oBrowse.setTooltip(this.getBrowseText());}if(sap.ui.getCore().getConfiguration().getAccessibility()){if(!F.prototype._sAccText){var r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");F.prototype._sAccText=r.getText("FILEUPLOAD_ACC");}if(this.oBrowse.addAriaDescribedBy){this.oBrowse.addAriaDescribedBy(this.getId()+"-AccDescr");}}};
F.prototype.setButtonText=function(t){this.setProperty("buttonText",t,false);if(!this.getIconOnly()){this.oBrowse.setText(t||this.getBrowseText());}else{this.oBrowse.setTooltip(t||this.getBrowseText());}return this;};
F.prototype.setIcon=function(i){this.oBrowse.setIcon(i);this.setProperty("icon",i,false);return this;};
F.prototype.setIconHovered=function(i){this.setProperty("iconHovered",i,false);if(this.oBrowse.setIconHovered){this.oBrowse.setIconHovered(i);}return this;};
F.prototype.setIconSelected=function(i){this.setProperty("iconSelected",i,false);if(this.oBrowse.setIconSelected){this.oBrowse.setIconSelected(i);}else{this.oBrowse.setActiveIcon(i);}return this;};
F.prototype.setIconFirst=function(i){this.oBrowse.setIconFirst(i);this.setProperty("iconFirst",i,false);return this;};
F.prototype.setIconOnly=function(i){this.setProperty("iconOnly",i,false);if(i){this.oBrowse.setText("");this.oBrowse.setTooltip(this.getButtonText()||this.getBrowseText());}else{this.oBrowse.setText(this.getButtonText()||this.getBrowseText());this.oBrowse.setTooltip("");}return this;};
F.prototype.getIdForLabel=function(){return this.oBrowse.getId();};
F.prototype.setFileType=function(t){var T=this._convertTypesToArray(t);this.setProperty("fileType",T,false);return this;};
F.prototype.setMimeType=function(t){var T=this._convertTypesToArray(t);this.setProperty("mimeType",T,false);return this;};
F.prototype.setTooltip=function(t){this._refreshTooltipBaseDelegate(t);this.setAggregation("tooltip",t,true);if(this.oFileUpload){if(typeof t==="string"){q(this.oFileUpload).attr("title",q.sap.encodeHTML(t));}}return this;};
F.prototype._convertTypesToArray=function(t){if(typeof t==="string"){if(t===""){return[];}else{return t.split(",");}}return t;};
F.prototype.exit=function(){this.oFilePath.destroy();this.oBrowse.destroy();if(this.oIFrameRef){q(this.oIFrameRef).unbind();sap.ui.getCore().getStaticAreaRef().removeChild(this.oIFrameRef);this.oIFrameRef=null;}};
F.prototype.onBeforeRendering=function(){var s=sap.ui.getCore().getStaticAreaRef();q(this.oFileUpload).appendTo(s);q(this.oFileUpload).unbind();};
F.prototype.onAfterRendering=function(){this.prepareFileUploadAndIFrame();this._cacheDOMEls();q(this.oFileUpload).change(q.proxy(this.handlechange,this));if(!this.bMobileLib){this.oFilePath.$().attr("tabindex","-1");}else{this.oFilePath.$().find('input').attr("tabindex","-1");}if((!!sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version==9)){this.oBrowse.$().attr("tabindex","-1");}if(L.isRequired(this)){this.oBrowse.$().attr("aria-required","true");}q.sap.delayedCall(0,this,this._recalculateWidth);this.oFilePath.$().find('input').removeAttr("role").attr("aria-live","polite");if(this.getValueState()==sap.ui.core.ValueState.Error){this.oBrowse.$().attr("aria-invalid","true");}};
F.prototype._cacheDOMEls=function(){this.FUEl=this.getDomRef("fu");this.FUDataEl=this.getDomRef("fu_data");};
F.prototype.onfocusin=function(e){if(!this.oFilePath.shouldValueStateMessageBeOpened||this.oFilePath.shouldValueStateMessageBeOpened()){this.openValueStateMessage();}};
F.prototype.onsapfocusleave=function(e){if(!e.relatedControlId||!q.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(e.relatedControlId).getFocusDomRef())){this.closeValueStateMessage();}};
F.prototype._recalculateWidth=function(){if(this.getWidth()){if(this.getButtonOnly()&&this.oBrowse.getDomRef()){this.oBrowse.getDomRef().style.width=this.getWidth();}this._resizeDomElements();}};
F.prototype.getFocusDomRef=function(){return this.$("fu").get(0);};
F.prototype._resizeDomElements=function(){var i=this.getId();this._oBrowseDomRef=this.oBrowse.getDomRef();var $=q(this._oBrowseDomRef);var _=$.parent().outerWidth(true);this._oFilePathDomRef=this.oFilePath.getDomRef();var d=this._oFilePathDomRef;var w=this.getWidth();if(w.substr(-1)=="%"&&d){while(d.id!=i){d.style.width="100%";d=d.parentNode;}d.style.width=w;}else{if(d){d.style.width=w;var b=q(this._oFilePathDomRef);var c=b.outerWidth()-_;if(c<0){this.oFilePath.getDomRef().style.width="0px";if(!sap.ui.Device.browser.internet_explorer){this.oFileUpload.style.width=$.outerWidth(true);}}else{this.oFilePath.getDomRef().style.width=c+"px";}}}};
F.prototype.onresize=function(){this._recalculateWidth();};
F.prototype.onThemeChanged=function(){this._recalculateWidth();};
F.prototype.setEnabled=function(e){this.setProperty("enabled",e,true);this.oFilePath.setEnabled(e);this.oBrowse.setEnabled(e);if(e){q(this.oFileUpload).removeAttr('disabled');}else{q(this.oFileUpload).attr('disabled','disabled');}return this;};
F.prototype.setValueState=function(v){this.setProperty("valueState",v,true);if(this.oFilePath.setValueState){this.oFilePath.setValueState(v);}if(this.oBrowse.getDomRef()){if(v==sap.ui.core.ValueState.Error){this.oBrowse.$().attr("aria-invalid","true");}else{this.oBrowse.$().removeAttr("aria-invalid");}}if(q.sap.containsOrEquals(this.getDomRef(),document.activeElement)){switch(v){case sap.ui.core.ValueState.Error:case sap.ui.core.ValueState.Warning:case sap.ui.core.ValueState.Success:this.openValueStateMessage();break;default:this.closeValueStateMessage();}}return this;};
F.prototype.setUploadUrl=function(v,f){this.setProperty("uploadUrl",v,true);var $=this.$("fu_form");$.attr("action",this.getUploadUrl());return this;};
F.prototype.setPlaceholder=function(p){this.setProperty("placeholder",p,true);this.oFilePath.setPlaceholder(p);return this;};
F.prototype.setStyle=function(s){this.setProperty("style",s,true);if(s=="Transparent"){if(this.oBrowse.setLite){this.oBrowse.setLite(true);}else{this.oBrowse.setType("Transparent");}}else{if(this.oBrowse.setType){this.oBrowse.setType(s);}else{if(s=="Emphasized"){s="Emph";}this.oBrowse.setStyle(s);}}return this;};
F.prototype.setValue=function(v,f,s){var o=this.getValue();var b;if((o!=v)||this.getSameFilenameAllowed()){var u=this.getUploadOnChange()&&v;this.setProperty("value",v,u);if(this.oFilePath){this.oFilePath.setValue(v);if(this.oBrowse.getDomRef()&&!s&&q.sap.containsOrEquals(this.getDomRef(),document.activeElement)){this.oBrowse.focus();}}var c=this.getDomRef("fu_form"),d=this.getDomRef("fu_input-inner");if(this.oFileUpload&&c&&!v){c.reset();this.getDomRef("fu_input").value="";if(d){d.value="";}q(this.FUDataEl).val(this.getAdditionalData());}if(f){if(window.File){b=this.FUEl.files;}if(!this.getSameFilenameAllowed()||v){this.fireChange({id:this.getId(),newValue:v,files:b});}}if(u){this.upload();}}return this;};
F.prototype.clear=function(){var u=this.getDomRef("fu_form");if(u){u.reset();}return this.setValue("",false,true);};
F.prototype.onmousedown=function(e){if(!this.bMobileLib){this.oBrowse.onmousedown(e);}};
F.prototype.onmouseup=function(e){if(!this.bMobileLib){this.oBrowse.onmouseup(e);}};
F.prototype.onmouseover=function(e){if(!this.bMobileLib){q(this.oBrowse.getDomRef()).addClass('sapUiBtnStdHover');this.oBrowse.onmouseover(e);}};
F.prototype.onmouseout=function(e){if(!this.bMobileLib){q(this.oBrowse.getDomRef()).removeClass('sapUiBtnStdHover');this.oBrowse.onmouseout(e);}};
F.prototype.setAdditionalData=function(A){this.setProperty("additionalData",A,true);var o=this.FUDataEl;if(o){A=this.getAdditionalData()||"";o.value=A;}return this;};
F.prototype.sendFiles=function(x,I){var t=this;var A=true;for(var i=0;i<x.length;i++){if(!x[i].bPosted){A=false;break;}}if(A){if(this.getSameFilenameAllowed()&&this.getUploadOnChange()){t.setValue("",true);}return;}var X=x[I];var f=X.file.name?X.file.name:"MultipartFile";if((sap.ui.Device.browser.edge||sap.ui.Device.browser.internet_explorer)&&X.file.type&&X.xhr.readyState==1){var c=X.file.type;X.xhr.setRequestHeader("Content-Type",c);X.requestHeaders.push({name:"Content-Type",value:c});}var r=X.requestHeaders;var p=function(P){var o={lengthComputable:!!P.lengthComputable,loaded:P.loaded,total:P.total};t.fireUploadProgress({"lengthComputable":o.lengthComputable,"loaded":o.loaded,"total":o.total,"fileName":f,"requestHeaders":r});};X.xhr.upload.addEventListener("progress",p);X.xhr.onreadystatechange=function(){var R;var s;var h={};var P;var H;var b;var d;d=X.xhr.readyState;var S=X.xhr.status;if(X.xhr.readyState==4){if(X.xhr.responseXML){R=X.xhr.responseXML.documentElement.textContent;}s=X.xhr.response;P=X.xhr.getAllResponseHeaders();if(P){H=P.split("\u000d\u000a");for(var i=0;i<H.length;i++){if(H[i]){b=H[i].indexOf("\u003a\u0020");h[H[i].substring(0,b)]=H[i].substring(b+2);}}}t.fireUploadComplete({"fileName":f,"headers":h,"response":R,"responseRaw":s,"readyStateXHR":d,"status":S,"requestHeaders":r});}t._bUploading=false;};if(X.xhr.readyState===0||X.bPosted){I++;t.sendFiles(x,I);}else{X.xhr.send(X.file);X.bPosted=true;I++;t.sendFiles(x,I);}};
F.prototype.upload=function(){if(!this.getEnabled()){return;}var u=this.getDomRef("fu_form");var f,h,v,x;try{this._bUploading=true;if(this.getSendXHR()&&window.File){var b=this.FUEl.files;if(b.length>0){if(this.getUseMultipart()){f=1;}else{f=b.length;}this._aXhr=this._aXhr||[];for(var j=0;j<f;j++){this._uploadXHR=new window.XMLHttpRequest();x={xhr:this._uploadXHR,requestHeaders:[]};this._aXhr.push(x);x.xhr.open("POST",this.getUploadUrl(),true);if(this.getHeaderParameters()){var H=this.getHeaderParameters();for(var i=0;i<H.length;i++){h=H[i].getName();v=H[i].getValue();x.requestHeaders.push({name:h,value:v});}}var s=b[j].name;var r=x.requestHeaders;x.fileName=s;x.file=b[j];this.fireUploadStart({"fileName":s,"requestHeaders":r});for(var k=0;k<r.length;k++){if(x.xhr.readyState===0){break;}h=r[k].name;v=r[k].value;x.xhr.setRequestHeader(h,v);}}if(this.getUseMultipart()){var c=new window.FormData();var n=this.FUEl.name;for(var l=0;l<b.length;l++){c.append(n,b[l]);}c.append("_charset_","UTF-8");var d=this.FUDataEl.name;if(this.getAdditionalData()){var D=this.getAdditionalData();c.append(d,D);}else{c.append(d,"");}if(this.getParameters()){var p=this.getParameters();for(var m=0;m<p.length;m++){var N=p[m].getName();v=p[m].getValue();c.append(N,v);}}x.file=c;this.sendFiles(this._aXhr,0);}else{this.sendFiles(this._aXhr,0);}this._bUploading=false;this._resetValueAfterUploadStart();}}else if(u){u.submit();this._resetValueAfterUploadStart();}}catch(e){q.sap.log.error("File upload failed:\n"+e.message);}};
F.prototype.abort=function(h,v){if(!this.getUseMultipart()){for(var i=0;i<this._aXhr.length;i++){if(h&&v){for(var j=0;j<this._aXhr[i].requestHeaders.length;j++){var H=this._aXhr[i].requestHeaders[j].name;var V=this._aXhr[i].requestHeaders[j].value;if(H==h&&V==v){this._aXhr[i].xhr.abort();this.fireUploadAborted({"fileName":this._aXhr[i].fileName,"requestHeaders":this._aXhr[i].requestHeaders});this._aXhr.splice(i,1);q.sap.log.info("File upload aborted.");break;}}}else{this._aXhr[i].xhr.abort();this.fireUploadAborted({"fileName":this._aXhr[i].fileName,"requestHeaders":this._aXhr[i].requestHeaders});this._aXhr.splice(i,1);q.sap.log.info("File upload aborted.");}}}else if(this._uploadXHR&&this._uploadXHR.abort){this._uploadXHR.abort();this.fireUploadAborted({"fileName":null,"requestHeaders":null});q.sap.log.info("File upload aborted.");}};
F.prototype.onkeypress=function(e){this.onkeydown(e);};
F.prototype.onclick=function(e){if(this.getSameFilenameAllowed()){this.setValue("",true);}if(this.oBrowse.getDomRef()&&q.sap.containsOrEquals(this.getDomRef(),document.activeElement)){this.oBrowse.focus();}};
F.prototype.onkeydown=function(e){if(!this.getEnabled()){return;}if(this.getSameFilenameAllowed()&&this.getUploadOnChange()){this.setValue("",true);}var k=e.keyCode,b=q.sap.KeyCodes;if(k==b.DELETE||k==b.BACKSPACE){if(this.oFileUpload){this.setValue("",true);}}else if(k==b.SPACE||k==b.ENTER){if(!(!!sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<=9)&&this.oFileUpload){this.oFileUpload.click();e.preventDefault();e.stopPropagation();}}else if(k!=b.TAB&&k!=b.SHIFT&&k!=b.F6&&k!=b.PAGE_UP&&k!=b.PAGE_DOWN&&k!=b.END&&k!=b.HOME&&k!=b.ARROW_LEFT&&k!=b.ARROW_UP&&k!=b.ARROW_RIGHT&&k!=b.ARROW_DOWN){e.preventDefault();e.stopPropagation();}};
F.prototype._isFilenameTooLong=function(f){var m=this.getMaximumFilenameLength();if(m!==0&&f.length>m){q.sap.log.info("The filename of "+f+" ("+f.length+" characters)  is longer than the maximum of "+m+" characters.");return true;}return false;};
F.prototype.handlechange=function(e){if(this.oFileUpload&&this.getEnabled()){var m=this.getMaximumFileSize();var f=this.getFileType();var M=this.getMimeType();var s='';var w,n,I,b;var u=this.getDomRef("fu_form");if(window.File){var c=e.target.files;for(var i=0;i<c.length;i++){n=c[i].name;var t=c[i].type;if(!t){t="unknown";}var S=((c[i].size/1024)/1024);if(m&&(S>m)){q.sap.log.info("File: "+n+" is of size "+S+" MB which exceeds the file size limit of "+m+" MB.");this.fireFileSizeExceed({fileName:n,fileSize:S});u.reset();this.setValue("",true,true);return;}if(this._isFilenameTooLong(n)){this.fireFilenameLengthExceed({fileName:n});u.reset();this.setValue("",true,true);return;}if(M&&M.length>0){var W=true;for(var j=0;j<M.length;j++){if(t==M[j]||M[j]=="*/*"||t.match(M[j])){W=false;}}if(W){q.sap.log.info("File: "+n+" is of type "+t+". Allowed types are: "+M+".");this.fireTypeMissmatch({fileName:n,mimeType:t});u.reset();this.setValue("",true,true);return;}}if(f&&f.length>0){w=true;I=n.lastIndexOf(".");b=n.substring(I+1);for(var k=0;k<f.length;k++){if(b.toLowerCase()==f[k].toLowerCase()){w=false;}}if(w){q.sap.log.info("File: "+n+" is of type "+b+". Allowed types are: "+f+".");this.fireTypeMissmatch({fileName:n,fileType:b});u.reset();this.setValue("",true,true);return;}}s=s+'"'+c[i].name+'" ';}if(s){this.fireFileAllowed();}}else if(f&&f.length>0){w=true;n=this.oFileUpload.value||"";I=n.lastIndexOf(".");b=n.substring(I+1);for(var l=0;l<f.length;l++){if(b==f[l]){w=false;}}if(w){q.sap.log.info("File: "+n+" is of type "+b+". Allowed types are: "+f+".");this.fireTypeMissmatch({fileName:n,fileType:b});u.reset();this.setValue("",true,true);return;}if(this._isFilenameTooLong(n)){this.fireFilenameLengthExceed({fileName:n});u.reset();this.setValue("",true,true);return;}if(n){this.fireFileAllowed();}}var v=this.oFileUpload.value||"";var d=v.lastIndexOf("\\");if(d>=0){v=v.substring(d+1);}if(this.getMultiple()){if(!(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<=9)){v=s;}}if(v||sap.ui.Device.browser.chrome){this.setValue(v,true);}}};
F.prototype.getBrowseText=function(){if(!F.prototype._sBrowseText){var r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");F.prototype._sBrowseText=r.getText("FILEUPLOAD_BROWSE");}return F.prototype._sBrowseText?F.prototype._sBrowseText:"Browse...";};
F.prototype.getShortenValue=function(){return this.getValue();};
F.prototype.prepareFileUploadAndIFrame=function(){if(!this.oFileUpload){var f=[];f.push('<input ');f.push('type="file" ');f.push('aria-hidden="true" ');if(this.getName()){if(this.getMultiple()){if(!(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<=9)){f.push('name="'+this.getName()+'[]" ');}}else{f.push('name="'+this.getName()+'" ');}}else{if(this.getMultiple()){if(!(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<=9)){f.push('name="'+this.getId()+'[]" ');}}else{f.push('name="'+this.getId()+'" ');}}f.push('id="'+this.getId()+'-fu" ');if(!(!!sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version==9)){f.push('tabindex="-1" ');}f.push('size="1" ');if(this.getTooltip_AsString()){f.push('title="'+q.sap.encodeHTML(this.getTooltip_AsString())+'" ');}else if(this.getValue()!==""){f.push('title="'+q.sap.encodeHTML(this.getValue())+'" ');}if(!this.getEnabled()){f.push('disabled="disabled" ');}if(this.getMultiple()){if(!(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<=9)){f.push('multiple ');}}if(this.getMimeType()&&window.File){var m=this.getMimeType();var M=m.join(",");f.push('accept="'+M+'" ');}f.push('>');this.oFileUpload=q(f.join("")).prependTo(this.$().find(".sapUiFupInputMask")).get(0);}else{q(this.oFileUpload).prependTo(this.$().find(".sapUiFupInputMask"));}if(!this.oIFrameRef){var i=document.createElement("iframe");i.style.display="none";i.id=this.sId+"-frame";sap.ui.getCore().getStaticAreaRef().appendChild(i);i.contentWindow.name=this.sId+"-frame";var t=this;this._bUploading=false;q(i).load(function(e){if(t._bUploading){q.sap.log.info("File uploaded to "+t.getUploadUrl());var r;try{r=t.oIFrameRef.contentDocument.body.innerHTML;}catch(b){}t.fireUploadComplete({"response":r});t._bUploading=false;}});this.oIFrameRef=i;}};
F.prototype.openValueStateMessage=function(){if(this.oFilePath.openValueStateMessage){this.oFilePath.openValueStateMessage();this.oBrowse.$().addAriaDescribedBy(this.oFilePath.getId()+"-message");}};
F.prototype.closeValueStateMessage=function(){if(this.oFilePath.closeValueStateMessage){this.oFilePath.closeValueStateMessage();this.oBrowse.$().removeAriaDescribedBy(this.oFilePath.getId()+"-message");}};
F.prototype._resetValueAfterUploadStart=function(){q.sap.log.info("File uploading to "+this.getUploadUrl());if(this.getSameFilenameAllowed()&&this.getUploadOnChange()&&this.getUseMultipart()){this.setValue("",true);}};
return F;},true);
sap.ui.predefine('sap/ui/unified/FileUploaderParameter',['jquery.sap.global','sap/ui/core/Element','./library'],function(q,E,l){"use strict";
var F=E.extend("sap.ui.unified.FileUploaderParameter",{metadata:{library:"sap.ui.unified",properties:{name:{type:"string",group:"Data",defaultValue:null},value:{type:"string",group:"Data",defaultValue:null}}}});
return F;},true);
sap.ui.predefine('sap/ui/unified/FileUploaderRenderer',['jquery.sap.global'],function(q){"use strict";var F=function(){};
F.render=function(r,f){var a=r;var b=sap.ui.getCore().getConfiguration().getAccessibility();a.write('<div');a.writeControlData(f);a.addClass("sapUiFup");var c=sap.ui.unified.FileUploaderHelper.addFormClass();if(c){a.addClass(c);}a.writeClasses();a.write('>');a.write('<form style="display:inline-block" encType="multipart/form-data" method="post"');a.writeAttribute('id',f.getId()+'-fu_form');a.writeAttributeEscaped('action',f.getUploadUrl());a.writeAttribute('target',f.getId()+'-frame');a.write('>');a.write('<div ');if(!f.bMobileLib){a.write('class="sapUiFupInp"');}if(b){a.writeAttribute("role","textbox");a.writeAttribute("aria-readonly","true");}a.write('>');if(!f.getButtonOnly()){a.write('<div class="sapUiFupGroup" border="0" cellPadding="0" cellSpacing="0"><div><div>');}else{a.write('<div class="sapUiFupGroup" border="0" cellPadding="0" cellSpacing="0"><div><div style="display:none">');}a.renderControl(f.oFilePath);a.write('</div><div>');a.renderControl(f.oBrowse);var A;var t="";if(f.getTooltip()){t=f.getTooltip_AsString();}var p="";if(f.getPlaceholder()){p=f.getPlaceholder();}var v="";if(f.getValue()){v=f.getValue();}var B="";if(f.getButtonText()){B=f.getButtonText();}else{B=f.getBrowseText();}if(!v){A=t+" "+p+" "+B;}else{A=t+" "+v+" "+B;}a.write('<span id="'+f.getId()+'-AccDescr" class="sapUiInvisibleText" aria-hidden="true">');a.writeEscaped(A+" "+f._sAccText);a.write('</span>');a.write('</div></div></div>');var n=f.getName()||f.getId();a.write('<div class="sapUiFupInputMask">');a.write('<input type="hidden" name="_charset_" aria-hidden="true">');a.write('<input type="hidden" id="'+f.getId()+'-fu_data" aria-hidden="true"');a.writeAttributeEscaped('name',n+'-data');a.writeAttributeEscaped('value',f.getAdditionalData()||"");a.write('>');q.each(f.getParameters(),function(i,P){a.write('<input type="hidden" aria-hidden="true" ');a.writeAttributeEscaped('name',P.getName()||"");a.writeAttributeEscaped('value',P.getValue()||"");a.write('>');});a.write('</div>');a.write('</div>');a.write('</form>');a.write('</div>');};
return F;},true);
sap.ui.predefine('sap/ui/unified/MenuItem',['jquery.sap.global','sap/ui/core/IconPool','./MenuItemBase','./library'],function(q,I,M,l){"use strict";
var a=M.extend("sap.ui.unified.MenuItem",{metadata:{library:"sap.ui.unified",properties:{text:{type:"string",group:"Appearance",defaultValue:''},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:''}}}});
I.getIconInfo("","");
a.prototype.render=function(r,i,m,o){var b=r;var s=i.getSubmenu();b.write("<li ");var c="sapUiMnuItm";if(o.iItemNo==1){c+=" sapUiMnuItmFirst";}else if(o.iItemNo==o.iTotalItems){c+=" sapUiMnuItmLast";}if(!m.checkEnabled(i)){c+=" sapUiMnuItmDsbl";}if(i.getStartsSection()){c+=" sapUiMnuItmSepBefore";}b.writeAttribute("class",c);if(i.getTooltip_AsString()){b.writeAttributeEscaped("title",i.getTooltip_AsString());}b.writeElementData(i);if(o.bAccessible){b.writeAccessibilityState(i,{role:"menuitem",disabled:!m.checkEnabled(i),posinset:o.iItemNo,setsize:o.iTotalItems,labelledby:{value:this.getId()+"-txt "+this.getId()+"-scuttxt",append:true}});if(s){b.writeAttribute("aria-haspopup",true);b.writeAttribute("aria-owns",s.getId());}}b.write("><div class=\"sapUiMnuItmL\"></div>");b.write("<div class=\"sapUiMnuItmIco\">");if(i.getIcon()){b.writeIcon(i.getIcon(),null,{title:null});}b.write("</div>");b.write("<div id=\""+this.getId()+"-txt\" class=\"sapUiMnuItmTxt\">");b.writeEscaped(i.getText());b.write("</div>");b.write("<div id=\""+this.getId()+"-scuttxt\" class=\"sapUiMnuItmSCut\"></div>");b.write("<div class=\"sapUiMnuItmSbMnu\">");if(s){b.write("<div class=\"sapUiIconMirrorInRTL\"></div>");}b.write("</div>");b.write("<div class=\"sapUiMnuItmR\"></div>");b.write("</li>");};
a.prototype.hover=function(h,m){this.$().toggleClass("sapUiMnuItmHov",h);};
return a;},true);
sap.ui.predefine('sap/ui/unified/MenuItemBase',['jquery.sap.global','sap/ui/core/Element','./library'],function(q,E,l){"use strict";
var M=E.extend("sap.ui.unified.MenuItemBase",{metadata:{library:"sap.ui.unified",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},visible:{type:"boolean",group:"Behavior",defaultValue:true},startsSection:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"submenu",aggregations:{submenu:{type:"sap.ui.unified.Menu",multiple:false}},events:{select:{parameters:{item:{type:"sap.ui.unified.MenuItemBase"}}}}}});
M.prototype.init=function(){};
M.prototype.render=function(r,i,m){var a=r;a.write("<li");a.writeElementData(i);a.write("><div style=\"white-space:nowrap;display:inline-block;padding:1px;color:black;\" id=\""+this.getId()+"-txt\">");a.write(i.getId());if(this.getSubmenu()){a.write("&nbsp;&nbsp;->");}a.write("</div></li>");};
M.prototype.hover=function(h,m){this.$("txt").attr("style",h?"white-space:nowrap;display:inline-block;padding:1px;color:red;":"white-space:nowrap;display:inline-block;padding:1px;color:black;");};
M.prototype.onSubmenuToggle=function(o){this.$().toggleClass("sapUiMnuItmSubMnuOpen",o);};
M.prototype.onAfterRendering=function(){};
M.prototype.onmouseover=function(e){var p=this.getParent();if(p&&p instanceof sap.ui.unified.Menu&&this.getTooltip()instanceof sap.ui.core.TooltipBase){p.onmouseover(e);}};
return M;},true);
sap.ui.predefine('sap/ui/unified/MenuRenderer',['jquery.sap.global'],function(q){"use strict";var M={};
M.render=function(r,m){if(m.oHoveredItem&&m.indexOfItem(m.oHoveredItem)<0){m.oHoveredItem=null;}r.write("<div tabindex=\"-1\" hideFocus=\"true\"");if(m.getTooltip_AsString()){r.writeAttributeEscaped("title",m.getTooltip_AsString());}var a=sap.ui.getCore().getConfiguration().getAccessibility();if(a){r.writeAccessibilityState(m,{role:"menu",disabled:null,labelledby:{value:m.getId()+"-label",append:true}});if(m.oHoveredItem){r.writeAttribute("aria-activedescendant",m.oHoveredItem.getId());}}r.addClass("sapUiMnu");var R=m.getRootMenu();if(R.bUseTopStyle){r.addClass("sapUiMnuTop");}if(R.isCozy()){r.addClass("sapUiSizeCozy");}if(m.bCozySupported){r.addClass("sapUiMnuCozySupport");}r.writeClasses();r.writeControlData(m);r.write(">");M.renderItems(r,m);if(a){r.write("<span id='",m.getId(),"-label' class='sapUiInvisibleText' aria-hidden='true'>");r.writeEscaped(m.getAriaDescription()?m.getAriaDescription():"");r.write("</span>");}r.write("</div>");};
M.renderItems=function(r,m){var I=m.getItems();var a=sap.ui.getCore().getConfiguration().getAccessibility();r.write("<ul class=\"sapUiMnuLst");var h=false;var H=false;for(var b=0;b<I.length;b++){if(I[b].getIcon&&I[b].getIcon()){h=true;}if(I[b].getSubmenu()){H=true;}}if(!h){r.write(" sapUiMnuNoIco");}if(!H){r.write(" sapUiMnuNoSbMnu");}r.write("\">");var n=0;for(var i=0;i<I.length;i++){if(I[i].getVisible()&&I[i].render){n++;}}var c=0;for(var i=0;i<I.length;i++){var o=I[i];if(o.getVisible()&&o.render){c++;if(o.getStartsSection()){r.write("<li ");if(a){r.write("role=\"separator\" ");}r.write("class=\"sapUiMnuDiv\"><div class=\"sapUiMnuDivL\"></div><hr><div class=\"sapUiMnuDivR\"></div></li>");}o.render(r,o,m,{bAccessible:a,iItemNo:c,iTotalItems:n});}}r.write("</ul>");};
return M;},true);
sap.ui.predefine('sap/ui/unified/MenuTextFieldItem',['jquery.sap.global','sap/ui/core/ValueStateSupport','./MenuItemBase','./library'],function(q,V,M,l){"use strict";
var a=M.extend("sap.ui.unified.MenuTextFieldItem",{metadata:{library:"sap.ui.unified",properties:{label:{type:"string",group:"Appearance",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},value:{type:"string",group:"Misc",defaultValue:null},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:sap.ui.core.ValueState.None}}}});
(function(){
a.prototype.render=function(r,i,m,I){var b=r,c=m.checkEnabled(i),d=i.getId();var C="sapUiMnuItm sapUiMnuTfItm";if(I.iItemNo==1){C+=" sapUiMnuItmFirst";}else if(I.iItemNo==I.iTotalItems){C+=" sapUiMnuItmLast";}if(!m.checkEnabled(i)){C+=" sapUiMnuItmDsbl";}if(i.getStartsSection()){C+=" sapUiMnuItmSepBefore";}b.write("<li ");b.writeAttribute("class",C);b.writeElementData(i);if(I.bAccessible){b.writeAttribute("role","menuitem");b.writeAttribute("aria-disabled",!c);b.writeAttribute("aria-posinset",I.iItemNo);b.writeAttribute("aria-setsize",I.iTotalItems);}b.write("><div class=\"sapUiMnuItmL\"></div>");b.write("<div class=\"sapUiMnuItmIco\">");if(i.getIcon()){b.writeIcon(i.getIcon(),null,{title:null});}b.write("</div>");b.write("<div id=\""+d+"-txt\" class=\"sapUiMnuItmTxt\">");b.write("<label id=\""+d+"-lbl\" class=\"sapUiMnuTfItemLbl\">");b.writeEscaped(i.getLabel()||"");b.write("</label>");b.write("<div id=\""+d+"-str\" class=\"sapUiMnuTfItmStretch\"></div>");b.write("<div class=\"sapUiMnuTfItemWrppr\">");b.write("<input id=\""+d+"-tf\" tabindex=\"-1\"");b.writeAttributeEscaped("value",i.getValue()||"");b.writeAttribute("class",c?"sapUiMnuTfItemTf sapUiMnuTfItemTfEnbl":"sapUiMnuTfItemTf sapUiMnuTfItemTfDsbl");if(!c){b.writeAttribute("disabled","disabled");}if(I.bAccessible){b.writeAccessibilityState(i,{role:"textbox",disabled:!c,multiline:false,autocomplete:"none",labelledby:{value:d+"-lbl",append:true}});}b.write("/></div></div>");b.write("<div class=\"sapUiMnuItmR\"></div>");b.write("</li>");};
a.prototype.hover=function(h,m){this.$().toggleClass("sapUiMnuItmHov",h);if(h&&m.checkEnabled(this)){m.closeSubmenu(false,true);this.$("tf").focus();}};
a.prototype.onAfterRendering=function(){this._adaptSizes();this.setValueState(this.getValueState());};
a.prototype.onsapup=function(e){this.getParent().focus();this.getParent().onsapprevious(e);};
a.prototype.onsapdown=function(e){this.getParent().focus();this.getParent().onsapnext(e);};
a.prototype.onsaphome=function(e){if(this._checkCursorPosForNav(false)){this.getParent().focus();this.getParent().onsaphome(e);}};
a.prototype.onsapend=function(e){if(this._checkCursorPosForNav(true)){this.getParent().focus();this.getParent().onsapend(e);}};
a.prototype.onsappageup=function(e){this.getParent().focus();this.getParent().onsappageup(e);};
a.prototype.onsappagedown=function(e){this.getParent().focus();this.getParent().onsappagedown(e);};
a.prototype.onsapescape=function(e){this.getParent().onsapescape(e);};
a.prototype.onkeydown=function(e){e.stopPropagation();};
a.prototype.onclick=function(e){this.getParent().closeSubmenu(false,true);if(!sap.ui.Device.system.desktop&&this.getParent().checkEnabled(this)){this.focus();}e.stopPropagation();};
a.prototype.onsapenter=function(e){var v=this.$("tf").val();this.setValue(v);this.getParent().selectItem(this);e.preventDefault();e.stopPropagation();};
a.prototype.setSubmenu=function(m){q.sap.log.warning("The aggregation 'submenu' is not supported for this type of menu item.","","sap.ui.unified.MenuTextFieldItem");return this;};
a.prototype.setLabel=function(L){this.setProperty("label",L,true);this.$("lbl").text(L);this._adaptSizes();return this;};
a.prototype.setValue=function(v){this.setProperty("value",v,true);this.$("tf").val(v);return this;};
a.prototype.setValueState=function(v){this.setProperty("valueState",v,true);var $=this.$("tf");$.toggleClass("sapUiMnuTfItemTfErr",v==sap.ui.core.ValueState.Error);$.toggleClass("sapUiMnuTfItemTfWarn",v==sap.ui.core.ValueState.Warning);var t=V.enrichTooltip(this,this.getTooltip_AsString());this.$().attr("title",t?t:"");return this;};
a.prototype.getFocusDomRef=function(){var f=this.$("tf");return f.length?f.get(0):null;};
a.prototype._adaptSizes=function(){var $=this.$("tf");var b=this.$("lbl");var o=b.length?b.get(0).offsetLeft:0;if(sap.ui.getCore().getConfiguration().getRTL()){$.parent().css({"width":"auto","right":(this.$().outerWidth(true)-o+(b.outerWidth(true)-b.outerWidth()))+"px"});}else{$.parent().css({"width":"auto","left":(o+b.outerWidth(true))+"px"});}};
a.prototype._checkCursorPosForNav=function(f){var r=sap.ui.getCore().getConfiguration().getRTL();var b=f?r:!r;var $=this.$("tf");var p=$.cursorPos();var L=$.val().length;if(r){p=L-p;}if((!b&&p!=L)||(b&&p!=0)){return false;}return true;};
}());return a;},true);
sap.ui.predefine('sap/ui/unified/Shell',['jquery.sap.global','./ShellHeader','./ShellLayout','./library'],function(q,S,a,l){"use strict";
var b=a.extend("sap.ui.unified.Shell",{metadata:{library:"sap.ui.unified",properties:{icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},showCurtain:{type:"boolean",group:"Appearance",defaultValue:null,deprecated:true},showCurtainPane:{type:"boolean",group:"Appearance",defaultValue:null,deprecated:true},searchVisible:{type:"boolean",group:"Appearance",defaultValue:true}},aggregations:{curtainContent:{type:"sap.ui.core.Control",multiple:true,singularName:"curtainContent"},curtainPaneContent:{type:"sap.ui.core.Control",multiple:true,singularName:"curtainPaneContent"},headItems:{type:"sap.ui.unified.ShellHeadItem",multiple:true,singularName:"headItem"},headEndItems:{type:"sap.ui.unified.ShellHeadItem",multiple:true,singularName:"headEndItem"},search:{type:"sap.ui.core.Control",multiple:false},user:{type:"sap.ui.unified.ShellHeadUserItem",multiple:false}}}});
b.prototype.init=function(){a.prototype.init.apply(this,arguments);this._header=new S(this.getId()+"-header");this.setHeader(this._header);};
b.prototype.exit=function(){a.prototype.exit.apply(this,arguments);this._header.destroy();delete this._header;};
b.prototype._getSearchWidth=function(){if(this._header===this.getHeader()&&this._header.getDomRef()){var s=this._header.$("hdr-center").children();if(s.length){return s.width();}}return-1;};
b.prototype.setIcon=function(i){this.setProperty("icon",i,true);this._header.setLogo(i);return this;};
b.prototype.getIcon=function(){return this._header.getLogo();};
b.prototype.setSearchVisible=function(s){this.setProperty("searchVisible",s,true);this._header.setSearchVisible(s);return this;};
b.prototype.getSearchVisible=function(){return this._header.getSearchVisible();};
b.prototype.setSearch=function(s){this._header.setSearch(s);return this;};
b.prototype.getSearch=function(){return this._header.getSearch();};
b.prototype.setUser=function(u){this._header.setUser(u);return this;};
b.prototype.getUser=function(){return this._header.getUser();};
b.prototype.getHeadItems=function(){return this._header.getHeadItems();};
b.prototype.insertHeadItem=function(h,i){this._header.insertHeadItem(h,i);return this;};
b.prototype.addHeadItem=function(h){this._header.addHeadItem(h);return this;};
b.prototype.removeHeadItem=function(i){return this._header.removeHeadItem(i);};
b.prototype.removeAllHeadItems=function(){return this._header.removeAllHeadItems();};
b.prototype.destroyHeadItems=function(){this._header.destroyHeadItems();return this;};
b.prototype.indexOfHeadtem=function(h){return this._header.indexOfHeadItem(h);};
b.prototype.getHeadEndItems=function(){return this._header.getHeadEndItems();};
b.prototype.insertHeadEndItem=function(h,i){this._header.insertHeadEndItem(h,i);return this;};
b.prototype.addHeadEndItem=function(h){this._header.addHeadEndItem(h);return this;};
b.prototype.removeHeadEndItem=function(i){return this._header.removeHeadEndItem(i);};
b.prototype.removeAllHeadEndItems=function(){return this._header.removeAllHeadEndItems();};
b.prototype.destroyHeadEndItems=function(){this._header.destroyHeadEndItems();return this;};
b.prototype.indexOfHeadEndItem=function(h){return this._header.indexOfHeadEndItem(h);};
b.prototype.setHeader=function(h){return a.prototype.setHeader.apply(this,[h?h:this._header]);};
b.prototype.destroyHeader=function(){if(this.getHeader()===this._header){return this;}return a.prototype.destroyHeader.apply(this,[]);};
return b;},true);
sap.ui.predefine('sap/ui/unified/ShellHeadItem',['jquery.sap.global','sap/ui/core/Element','sap/ui/core/IconPool','./library'],function(q,E,I,l){"use strict";
var S=E.extend("sap.ui.unified.ShellHeadItem",{metadata:{library:"sap.ui.unified",properties:{startsSection:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},showSeparator:{type:"boolean",group:"Appearance",defaultValue:true},selected:{type:"boolean",group:"Appearance",defaultValue:false},toggleEnabled:{type:"boolean",group:"Appearance",defaultValue:true},showMarker:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{}}}});
S.prototype.onclick=function(e){this.firePress();e.preventDefault();};
S.prototype.onsapspace=S.prototype.onclick;
S.prototype.setStartsSection=function(s){s=!!s;this.setProperty("startsSection",s,true);this.$().toggleClass("sapUiUfdShellHeadItmDelim",s);return this;};
S.prototype.setShowSeparator=function(s){s=!!s;this.setProperty("showSeparator",s,true);this.$().toggleClass("sapUiUfdShellHeadItmSep",s);return this;};
function _(){var t=this.$(),T=this.getToggleEnabled(),s=this.getSelected();if(!t.length){return;}if(T){t.toggleClass("sapUiUfdShellHeadItmSel",s);t.attr("aria-pressed",s);}else{t.removeClass("sapUiUfdShellHeadItmSel");t.removeAttr("aria-pressed");}}
S.prototype.setToggleEnabled=function(e){this.setProperty("toggleEnabled",!!e,true);_.apply(this);return this;};
S.prototype.setSelected=function(s){this.setProperty("selected",!!s,true);_.apply(this);return this;};
S.prototype.setVisible=function(v){this.setProperty("visible",!!v);return this;};
S.prototype.setShowMarker=function(m){m=!!m;this.setProperty("showMarker",m,true);this.$().toggleClass("sapUiUfdShellHeadItmMark",m);return this;};
S.prototype.setIcon=function(i){this.setProperty("icon",i,true);if(this.getDomRef()){this._refreshIcon();}return this;};
S.prototype._refreshIcon=function(){var i=q(this.$().children()[0]);var s=this.getIcon();if(I.isIconURI(s)){var o=I.getIconInfo(s);i.html("").css("style","");if(o){i.text(o.content).attr("role","presentation").attr("aria-label",o.text||o.name).css("font-family","'"+o.fontFamily+"'");}}else{var $=this.$("img-inner");if($.length==0||$.attr("src")!=s){i.css("style","").attr("aria-label",null).html("<img role='presentation' id='"+this.getId()+"-img-inner' src='"+q.sap.encodeHTML(s)+"'/>");}}};
return S;},true);
sap.ui.predefine('sap/ui/unified/ShellHeadUserItem',['jquery.sap.global','sap/ui/core/Element','sap/ui/core/IconPool','./library'],function(q,E,I,l){"use strict";
var S=E.extend("sap.ui.unified.ShellHeadUserItem",{metadata:{library:"sap.ui.unified",properties:{username:{type:"string",group:"Appearance",defaultValue:''},showPopupIndicator:{type:"boolean",group:"Accessibility",defaultValue:true},image:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{}}}});
I.getIconInfo("","");
S.prototype.onclick=function(e){this.firePress();e.preventDefault();};
S.prototype.onsapspace=S.prototype.onclick;
S.prototype.setImage=function(i){this.setProperty("image",i,true);if(this.getDomRef()){this._refreshImage();}return this;};
S.prototype._refreshImage=function(){var i=this.$("img");var s=this.getImage();if(!s){i.html("").css("style","").css("display","none");}else if(I.isIconURI(s)){var o=I.getIconInfo(s);i.html("").css("style","");if(o){i.text(o.content).attr("role","presentation").attr("aria-label",o.text||o.name).css("font-family","'"+o.fontFamily+"'");}}else{var $=this.$("img-inner");if($.length==0||$.attr("src")!=s){i.css("style","").attr("aria-label",null).html("<img role='presentation' id='"+this.getId()+"-img-inner' src='"+q.sap.encodeHTML(s)+"'/>");}}};
S.prototype._checkAndAdaptWidth=function(s){if(!this.getDomRef()){return false;}var r=this.$(),n=this.$("name");var b=r.width();r.toggleClass("sapUiUfdShellHeadUsrItmLimit",false);var m=240;if(s){m=Math.min(m,0.5*document.documentElement.clientWidth-225);}if(m<n.width()){r.toggleClass("sapUiUfdShellHeadUsrItmLimit",true);}return b!=r.width();};
return S;},true);
sap.ui.predefine('sap/ui/unified/ShellHeader',['jquery.sap.global','./library'],function(q,l){"use strict";
var S=sap.ui.core.Control.extend("sap.ui.unified.ShellHeader",{
metadata:{properties:{logo:{type:"sap.ui.core.URI",defaultValue:""},searchVisible:{type:"boolean",defaultValue:true}},aggregations:{headItems:{type:"sap.ui.unified.ShellHeadItem",multiple:true},headEndItems:{type:"sap.ui.unified.ShellHeadItem",multiple:true},search:{type:"sap.ui.core.Control",multiple:false},user:{type:"sap.ui.unified.ShellHeadUserItem",multiple:false}}},
renderer:{render:function(r,h){var i=h.getId();r.write("<div");r.writeControlData(h);r.writeAttribute("class","sapUiUfdShellHeader");if(sap.ui.getCore().getConfiguration().getAccessibility()){r.writeAttribute("role","toolbar");}r.write(">");r.write("<div id='",i,"-hdr-begin' class='sapUiUfdShellHeadBegin'>");this.renderHeaderItems(r,h,true);r.write("</div>");r.write("<div id='",i,"-hdr-center' class='sapUiUfdShellHeadCenter'>");this.renderSearch(r,h);r.write("</div>");r.write("<div id='",i,"-hdr-end' class='sapUiUfdShellHeadEnd'>");this.renderHeaderItems(r,h,false);r.write("</div>");r.write("</div>");},renderSearch:function(r,h){var s=h.getSearch();r.write("<div id='",h.getId(),"-hdr-search'");if(sap.ui.getCore().getConfiguration().getAccessibility()){r.writeAttribute("role","search");}r.writeAttribute("class","sapUiUfdShellSearch"+(h.getSearchVisible()?"":" sapUiUfdShellHidden"));r.write("><div>");if(s){r.renderControl(s);}r.write("</div></div>");},renderHeaderItems:function(r,h,b){r.write("<div class='sapUiUfdShellHeadContainer'>");var I=b?h.getHeadItems():h.getHeadEndItems();for(var i=0;i<I.length;i++){r.write("<a tabindex='0' href='javascript:void(0);'");r.writeElementData(I[i]);r.addClass("sapUiUfdShellHeadItm");if(I[i].getStartsSection()){r.addClass("sapUiUfdShellHeadItmDelim");}if(I[i].getShowSeparator()){r.addClass("sapUiUfdShellHeadItmSep");}if(!I[i].getVisible()){r.addClass("sapUiUfdShellHidden");}if(I[i].getSelected()&&I[i].getToggleEnabled()){r.addClass("sapUiUfdShellHeadItmSel");}if(I[i].getShowMarker()){r.addClass("sapUiUfdShellHeadItmMark");}r.writeClasses();var t=I[i].getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}if(sap.ui.getCore().getConfiguration().getAccessibility()){r.writeAccessibilityState(I[i],{role:"button",selected:null,pressed:I[i].getToggleEnabled()?I[i].getSelected():null});}r.write("><span></span><div class='sapUiUfdShellHeadItmMarker'><div></div></div></a>");}var u=h.getUser();if(!b&&u){r.write("<a tabindex='0' href='javascript:void(0);'");r.writeElementData(u);r.addClass("sapUiUfdShellHeadUsrItm");if(!u.getShowPopupIndicator()){r.addClass("sapUiUfdShellHeadUsrItmWithoutPopup");}r.writeClasses();var t=u.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}if(sap.ui.getCore().getConfiguration().getAccessibility()){r.writeAccessibilityState(u,{role:"button"});if(u.getShowPopupIndicator()){r.writeAttribute("aria-haspopup","true");}}r.write("><span id='",u.getId(),"-img' aria-hidden='true' class='sapUiUfdShellHeadUsrItmImg'></span>");r.write("<span id='"+u.getId()+"-name' class='sapUiUfdShellHeadUsrItmName'");var U=u.getUsername()||"";r.writeAttributeEscaped("title",U);r.write(">");r.writeEscaped(U);r.write("</span><span class='sapUiUfdShellHeadUsrItmExp' aria-hidden='true'></span></a>");}r.write("</div>");if(b){this._renderLogo(r,h);}},_renderLogo:function(r,h){var a=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified"),L=a.getText("SHELL_LOGO_TOOLTIP"),i=h._getLogo();r.write("<div class='sapUiUfdShellIco'>");r.write("<img id='",h.getId(),"-icon'");r.writeAttributeEscaped("title",L);r.writeAttributeEscaped("alt",L);r.write("src='");r.writeEscaped(i);r.write("' style='",i?"":"display:none;","'/>");r.write("</div>");}}
});
S.prototype.init=function(){var t=this;this._rtl=sap.ui.getCore().getConfiguration().getRTL();this._handleMediaChange=function(p){if(!t.getDomRef()){return;}t._refresh();};sap.ui.Device.media.attachHandler(this._handleMediaChange,this,sap.ui.Device.media.RANGESETS.SAP_STANDARD);this._handleResizeChange=function(p){if(!t.getDomRef()||!t.getUser()){return;}var u=this.getUser();var c=u._checkAndAdaptWidth(!t.$("hdr-search").hasClass("sapUiUfdShellHidden")&&!!t.getSearch());if(c){t._refresh();}};sap.ui.Device.resize.attachHandler(this._handleResizeChange,this);this.data("sap-ui-fastnavgroup","true",true);};
S.prototype.exit=function(){sap.ui.Device.media.detachHandler(this._handleMediaChange,this,sap.ui.Device.media.RANGESETS.SAP_STANDARD);delete this._handleMediaChange;sap.ui.Device.resize.detachHandler(this._handleResizeChange,this);delete this._handleResizeChange;};
S.prototype.onAfterRendering=function(){this._refresh();this.$("hdr-center").toggleClass("sapUiUfdShellAnim",!this._noHeadCenterAnim);};
S.prototype.onThemeChanged=function(){if(this.getDomRef()){this.invalidate();}};
S.prototype._getLogo=function(){var i=this.getLogo();if(!i){q.sap.require("sap.ui.core.theming.Parameters");i=sap.ui.core.theming.Parameters._getThemeImage(null,true);}return i;};
S.prototype._refresh=function(){function u(I){for(var i=0;i<I.length;i++){I[i]._refreshIcon();}}u(this.getHeadItems());u(this.getHeadEndItems());var U=this.getUser(),a=q("html").hasClass("sapUiMedia-Std-Phone"),s=!this.$("hdr-search").hasClass("sapUiUfdShellHidden"),$=this.$("icon");if(U){U._refreshImage();U._checkAndAdaptWidth(s&&!!this.getSearch());}$.parent().toggleClass("sapUiUfdShellHidden",a&&s&&!!this.getSearch());var w=this.$("hdr-end").outerWidth(),b=this.$("hdr-begin").outerWidth(),c=Math.max(w,b),d=(a&&s?b:c)+"px",e=(a&&s?w:c)+"px";this.$("hdr-center").css({"left":this._rtl?e:d,"right":this._rtl?d:e});};
return S;},true);
sap.ui.predefine('sap/ui/unified/ShellLayout',['jquery.sap.global','sap/ui/Device','sap/ui/core/Control','sap/ui/core/Popup','sap/ui/core/theming/Parameters','./SplitContainer','./library','jquery.sap.dom','jquery.sap.script'],function(q,D,C,P,a,S,l){"use strict";
var b=C.extend("sap.ui.unified.ShellLayout",{metadata:{library:"sap.ui.unified",properties:{showPane:{type:"boolean",group:"Appearance",defaultValue:false},headerHiding:{type:"boolean",group:"Appearance",defaultValue:false},headerVisible:{type:"boolean",group:"Appearance",defaultValue:true}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},paneContent:{type:"sap.ui.core.Control",multiple:true,singularName:"paneContent"},header:{type:"sap.ui.core.Control",multiple:false},canvasSplitContainer:{type:"sap.ui.unified.SplitContainer",multiple:false,visibility:"hidden"},curtainSplitContainer:{type:"sap.ui.unified.SplitContainer",multiple:false,visibility:"hidden"}}}});
b._SIDEPANE_WIDTH_PHONE=208;b._SIDEPANE_WIDTH_TABLET=208;b._SIDEPANE_WIDTH_DESKTOP=240;b._HEADER_ALWAYS_VISIBLE=true;b._HEADER_AUTO_CLOSE=true;b._HEADER_TOUCH_TRESHOLD=15;if(D.browser.chrome&&D.browser.version<36){b._HEADER_TOUCH_TRESHOLD=10;}
b.prototype.init=function(){this._rtl=sap.ui.getCore().getConfiguration().getRTL();this._animation=sap.ui.getCore().getConfiguration().getAnimation();this._showHeader=true;this._showCurtain=false;this._iHeaderHidingDelay=3000;this._useStrongBG=false;this._cont=new S(this.getId()+"-container");this._cont._bRootContent=true;if(sap.ui.getCore().getConfiguration().getAccessibility()){var t=this;this._cont.addEventDelegate({onAfterRendering:function(){t._cont.$("canvas").attr("role","main");t._cont.$("pane").attr("role","complementary");}});}this.setAggregation("canvasSplitContainer",this._cont,true);this._curtCont=new S(this.getId()+"-curt-container");this._curtCont._bRootContent=true;this.setAggregation("curtainSplitContainer",this._curtCont,true);this._setSidePaneWidth();D.media.attachHandler(this._handleMediaChange,this,D.media.RANGESETS.SAP_STANDARD);D.resize.attachHandler(this._handleResizeChange,this);};
b.prototype.exit=function(){D.media.detachHandler(this._handleMediaChange,this,D.media.RANGESETS.SAP_STANDARD);D.resize.detachHandler(this._handleResizeChange,this);delete this._cont;delete this._curtCont;};
b.prototype.onAfterRendering=function(){var t=this;function h(B){var e=q.event.fix(B);if(q.sap.containsOrEquals(t.getDomRef("hdr"),e.target)){t._timedHideHeader(e.type==="focus");}}if(window.addEventListener&&!b._HEADER_ALWAYS_VISIBLE){var H=this.getDomRef("hdr");H.addEventListener("focus",h,true);H.addEventListener("blur",h,true);}this._refreshAfterRendering();};
b.prototype.onThemeChanged=function(){this._refreshAfterRendering();};
b.prototype.onfocusin=function(e){var i=this.getId();if(e.target.id===i+"-curt-focusDummyOut"){q.sap.focus(this.$("hdrcntnt").firstFocusableDomRef());}else if(e.target.id===i+"-main-focusDummyOut"){q.sap.focus(this.$("curtcntnt").firstFocusableDomRef());}};
(function(){
function _(s){if(s._startY===undefined||s._currY===undefined){return;}var y=s._currY-s._startY;if(Math.abs(y)>b._HEADER_TOUCH_TRESHOLD){s._doShowHeader(y>0);s._startY=s._currY;}}
if(D.support.touch){b._HEADER_ALWAYS_VISIBLE=false;b.prototype.ontouchstart=function(e){this._startY=e.touches[0].pageY;if(this._startY>2*48){this._startY=undefined;}this._currY=this._startY;};b.prototype.ontouchend=function(e){_(this);this._startY=undefined;this._currY=undefined;};b.prototype.ontouchcancel=b.prototype.ontouchend;b.prototype.ontouchmove=function(e){this._currY=e.touches[0].pageY;_(this);};}})();
b.prototype.setHeaderHiding=function(e){e=!!e;return this._mod(function(r){return this.setProperty("headerHiding",e,r);},function(){this._doShowHeader(!e?true:this._showHeader);});};
b.prototype.setHeaderHidingDelay=function(d){this._iHeaderHidingDelay=d;return this;};
b.prototype.getHeaderHidingDelay=function(){return this._iHeaderHidingDelay;};
b.prototype.getShowPane=function(){return this._cont.getShowSecondaryContent();};
b.prototype.setShowPane=function(s){this._cont.setShowSecondaryContent(s);this.setProperty("showPane",!!s,true);return this;};
b.prototype.setShowCurtainPane=function(s){this._curtCont.setShowSecondaryContent(s);return this;};
b.prototype.getShowCurtainPane=function(){return this._curtCont.getShowSecondaryContent();};
b.prototype.setHeaderVisible=function(h){h=!!h;this.setProperty("headerVisible",h,true);this.$().toggleClass("sapUiUfdShellNoHead",!h);return this;};
b.prototype.setShowCurtain=function(s){s=!!s;return this._mod(function(r){this._showCurtain=s;return this;},function(){this.$("main-focusDummyOut").attr("tabindex",s?0:-1);this.$().toggleClass("sapUiUfdShellCurtainHidden",!s).toggleClass("sapUiUfdShellCurtainVisible",s);if(s){var z=P.getNextZIndex();this.$("curt").css("z-index",z+1);this.$("hdr").css("z-index",z+3);this.$("brand").css("z-index",z+7);this.$().toggleClass("sapUiUfdShellCurtainClosed",false);}this._timedCurtainClosed(s);this._doShowHeader(true);});};
b.prototype.getShowCurtain=function(){return this._showCurtain;};
b.prototype.getContent=function(){return this._cont.getContent();};
b.prototype.insertContent=function(c,i){this._cont.insertContent(c,i);return this;};
b.prototype.addContent=function(c){this._cont.addContent(c);return this;};
b.prototype.removeContent=function(i){return this._cont.removeContent(i);};
b.prototype.removeAllContent=function(){return this._cont.removeAllContent();};
b.prototype.destroyContent=function(){this._cont.destroyContent();return this;};
b.prototype.indexOfContent=function(c){return this._cont.indexOfContent(c);};
b.prototype.getPaneContent=function(){return this._cont.getSecondaryContent();};
b.prototype.insertPaneContent=function(c,i){this._cont.insertSecondaryContent(c,i);return this;};
b.prototype.addPaneContent=function(c){this._cont.addSecondaryContent(c);return this;};
b.prototype.removePaneContent=function(i){return this._cont.removeSecondaryContent(i);};
b.prototype.removeAllPaneContent=function(){return this._cont.removeAllSecondaryContent();};
b.prototype.destroyPaneContent=function(){this._cont.destroySecondaryContent();return this;};
b.prototype.indexOfPaneContent=function(c){return this._cont.indexOfSecondaryContent(c);};
b.prototype.setHeader=function(h){this.setAggregation("header",h,true);h=this.getHeader();if(this.getDomRef()){if(!h){this.$("hdrcntnt").html("");}else{var r=sap.ui.getCore().createRenderManager();r.renderControl(h);r.flush(this.getDomRef("hdrcntnt"));r.destroy();}}return this;};
b.prototype.destroyHeader=function(){this.destroyAggregation("header",true);this.$("hdrcntnt").html("");return this;};
b.prototype.getCurtainContent=function(){return this._curtCont.getContent();};
b.prototype.insertCurtainContent=function(c,i){this._curtCont.insertContent(c,i);return this;};
b.prototype.addCurtainContent=function(c){this._curtCont.addContent(c);return this;};
b.prototype.removeCurtainContent=function(i){return this._curtCont.removeContent(i);};
b.prototype.removeAllCurtainContent=function(){return this._curtCont.removeAllContent();};
b.prototype.destroyCurtainContent=function(){this._curtCont.destroyContent();return this;};
b.prototype.indexOfCurtainContent=function(c){return this._curtCont.indexOfCurtainContent(c);};
b.prototype.getCurtainPaneContent=function(){return this._curtCont.getSecondaryContent();};
b.prototype.insertCurtainPaneContent=function(c,i){this._curtCont.insertSecondaryContent(c,i);return this;};
b.prototype.addCurtainPaneContent=function(c){this._curtCont.addSecondaryContent(c);return this;};
b.prototype.removeCurtainPaneContent=function(i){return this._curtCont.removeSecondaryContent(i);};
b.prototype.removeAllCurtainPaneContent=function(){return this._curtCont.removeAllSecondaryContent();};
b.prototype.destroyCurtainPaneContent=function(){this._curtCont.destroySecondaryContent();return this;};
b.prototype.indexOfCurtainPaneContent=function(c){return this._curtCont.indexOfSecondaryContent(c);};
b.prototype._setStrongBackground=function(u){this._useStrongBG=!!u;this.$("strgbg").toggleClass("sapUiStrongBackgroundColor",this._useStrongBG);};
b.prototype._mod=function(m,d){var r=!!this.getDomRef();var c=m.apply(this,[r]);if(r&&d){if(d instanceof sap.ui.unified._ContentRenderer){d.render();}else{d.apply(this);}}return c;};
b.prototype._doShowHeader=function(s){var w=this._showHeader;this._showHeader=this._isHeaderHidingActive()?!!s:true;this.$().toggleClass("sapUiUfdShellHeadHidden",!this._showHeader).toggleClass("sapUiUfdShellHeadVisible",this._showHeader);if(this._showHeader){this._timedHideHeader();}if(w!=this._showHeader&&this._isHeaderHidingActive()){q.sap.delayedCall(500,this,function(){try{var r=document.createEvent("UIEvents");r.initUIEvent("resize",true,false,window,0);window.dispatchEvent(r);}catch(e){q.sap.log.error(e);}});}};
b.prototype._timedHideHeader=function(c){if(this._headerHidingTimer){q.sap.clearDelayedCall(this._headerHidingTimer);this._headerHidingTimer=null;}if(c||!b._HEADER_AUTO_CLOSE||!this._isHeaderHidingActive()||this._iHeaderHidingDelay<=0){return;}this._headerHidingTimer=q.sap.delayedCall(this._iHeaderHidingDelay,this,function(){if(this._isHeaderHidingActive()&&this._iHeaderHidingDelay>0&&!q.sap.containsOrEquals(this.getDomRef("hdr"),document.activeElement)){this._doShowHeader(false);}});};
b.prototype._timedCurtainClosed=function(c){if(this._curtainClosedTimer){q.sap.clearDelayedCall(this._curtainClosedTimer);this._curtainClosedTimer=null;}if(c){return;}var d=parseInt(a.get("sapUiUfdShellAnimDuration"),10);if(!this._animation||(D.browser.internet_explorer&&D.browser.version<10)){d=0;}this._curtainClosedTimer=q.sap.delayedCall(d,this,function(){this._curtainClosedTimer=null;this.$("curt").css("z-index","");this.$("hdr").css("z-index","");this.$("brand").css("z-index","");this.$().toggleClass("sapUiUfdShellCurtainClosed",true);});};
b.prototype._isHeaderHidingActive=function(){if(b._HEADER_ALWAYS_VISIBLE||this.getShowCurtain()||!this.getHeaderHiding()||sap.ui.unified._iNumberOfOpenedShellOverlays>0||!this.getHeaderVisible()){return false;}return true;};
b.prototype._refreshCSSWorkaround=function(){if(!D.browser.webkit||!D.support.touch){return;}if(this._cssWorkaroundTimer){q.sap.clearDelayedCall(this._cssWorkaroundTimer);this._cssWorkaroundTimer=null;}this.$("css").remove();this._cssWorkaroundTimer=q.sap.delayedCall(10,this,function(){this._cssWorkaroundTimer=null;q.sap.log.debug("sap.ui.unified.ShellLayout: CSS Workaround applied.");q("head").append("<link type='text/css' rel='stylesheet' id='"+this.getId()+"-css' href='data:text/css;base64,LnNhcFVpVWZkU2hlbGxDaHJvbWVSZXBhaW50e291dGxpbmUtY29sb3I6aW5pdGlhbDt9'/>");this._cssWorkaroundTimer=q.sap.delayedCall(100,this,function(){this.$("css").remove();});});};
b.prototype._setSidePaneWidth=function(r){if(!r){r=D.media.getCurrentRange(D.media.RANGESETS.SAP_STANDARD).name;}var w=b["_SIDEPANE_WIDTH_"+r.toUpperCase()]+"px";this._cont.setSecondaryContentSize(w);this._curtCont.setSecondaryContentSize(w);};
b.prototype._handleMediaChange=function(p){if(!this.getDomRef()){return false;}this._setSidePaneWidth(p.name);};
b.prototype._handleResizeChange=function(p){};
b.prototype._refreshAfterRendering=function(){var d=this.getDomRef();if(!d){return false;}this._repaint(d);this._timedHideHeader();return true;};
b.prototype._repaint=function(d){if(D.browser.webkit){var c=d.style.display;d.style.display="none";d.offsetHeight;d.style.display=c;this._refreshCSSWorkaround();}};
b.prototype._getSearchWidth=function(){return-1;};
return b;},true);
sap.ui.predefine('sap/ui/unified/ShellLayoutRenderer',['jquery.sap.global'],function(q){"use strict";var S={};
S.render=function(r,s){var i=s.getId();r.write("<div");r.writeControlData(s);r.addClass("sapUiUfdShell");if(s._animation){r.addClass("sapUiUfdShellAnim");}if(!s.getHeaderVisible()){r.addClass("sapUiUfdShellNoHead");}r.addClass("sapUiUfdShellHead"+(s._showHeader?"Visible":"Hidden"));if(s.getShowCurtain()){r.addClass("sapUiUfdShellCurtainVisible");}else{r.addClass("sapUiUfdShellCurtainHidden");r.addClass("sapUiUfdShellCurtainClosed");}r.writeClasses();r.write(">");r.write("<hr id='",i,"-brand' class='sapUiUfdShellBrand'/>");r.write("<header id='",i,"-hdr'  class='sapUiUfdShellHead'");if(sap.ui.getCore().getConfiguration().getAccessibility()){r.writeAttribute("role","banner");}r.write("><div><div id='",i,"-hdrcntnt' class='sapUiUfdShellCntnt'>");if(s.getHeader()){r.renderControl(s.getHeader());}r.write("</div>","</div>","</header>");r.write("<section id='",i,"-curt' class='sapUiUfdShellCntnt sapUiUfdShellCurtain'>");r.write("<div id='",i,"-curtcntnt' class='sapUiUfdShellCntnt'>");r.renderControl(s._curtCont);r.write("</div>");r.write("<span id='",i,"-curt-focusDummyOut' tabindex='0'></span>");r.write("</section>");r.write("<div id='",i,"-cntnt' class='sapUiUfdShellCntnt sapUiUfdShellCanvas sapUiGlobalBackgroundColor sapUiGlobalBackgroundColorForce'>");r.write("<div id='",i,"-strgbg' class='sapUiUfdShellBG"+(s._useStrongBG?" sapUiStrongBackgroundColor":"")+"'></div>");r.write("<div class='sapUiGlobalBackgroundImage sapUiGlobalBackgroundImageForce sapUiUfdShellBG'></div>");r.renderControl(s._cont);r.write("</div>");r.write("<span id='",i,"-main-focusDummyOut' tabindex='"+(s.getShowCurtain()?0:-1)+"'></span>");r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/ui/unified/ShellOverlay',['jquery.sap.global','sap/ui/Device','sap/ui/core/Control','sap/ui/core/Popup','./Shell','./library','jquery.sap.script'],function(q,D,C,P,S,l){"use strict";
var a=C.extend("sap.ui.unified.ShellOverlay",{metadata:{library:"sap.ui.unified",defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},search:{type:"sap.ui.core.Control",multiple:false}},associations:{shell:{type:"sap.ui.unified.ShellLayout",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{closed:{}}}});
a.prototype.open=function(){if(this._getPopup().isOpen()){return;}this._opening=true;this._forceShellHeaderVisible();this._getPopup().setModal(true,P.blStack.length==0&&this._getAnimActive()?"sapUiUfdShellOvrlyBly sapUiUfdShellOvrlyBlyTp":"");this._getPopup().open(0,P.Dock.BeginTop,P.Dock.BeginTop,window,"0 0","none");var s=this.getSearch();if(s){s.focus();}this._opening=false;if(this._getAnimActive()){q.sap.delayedCall(50,this,function(){q.sap.byId("sap-ui-blocklayer-popup").toggleClass("sapUiUfdShellOvrlyBlyTp",false);});}q.sap.delayedCall(this._getAnimDuration(true),this,function(){this.$().toggleClass("sapUiUfdShellOvrlyOpening",false);});};
a.prototype.close=function(){if(!this._getPopup().isOpen()){return;}this.$().toggleClass("sapUiUfdShellOvrlyCntntHidden",true).toggleClass("sapUiUfdShellOvrlyClosing",true);this._setSearchWidth();q.sap.delayedCall(Math.max(this._getAnimDuration(false)-this._getBLAnimDuration(),0),this,function(){var b=q.sap.byId("sap-ui-blocklayer-popup");if(P.blStack.length==1&&this._getAnimActive()&&b.hasClass("sapUiUfdShellOvrlyBly")){b.toggleClass("sapUiUfdShellOvrlyBlyTp",true);}});q.sap.delayedCall(this._getAnimDuration(false),this,function(){this._getPopup().close(0);this.$().remove();this._forceShellHeaderVisible();this.fireClosed();});};
a.prototype.setShell=function(s){return this.setAssociation("shell",s,true);};
a.prototype.setSearch=function(s){this.setAggregation("search",s,true);if(!!this.getDomRef()){this._headRenderer.render();}return this;};
a.prototype.insertContent=function(c,i){var r=this.insertAggregation("content",c,i,true);if(!!this.getDomRef()){this._contentRenderer.render();}return r;};
a.prototype.addContent=function(c){var r=this.addAggregation("content",c,true);if(!!this.getDomRef()){this._contentRenderer.render();}return r;};
a.prototype.removeContent=function(i){var r=this.removeAggregation("content",i,true);if(!!this.getDomRef()){this._contentRenderer.render();}return r;};
a.prototype.removeAllContent=function(){var r=this.removeAllAggregation("content",true);if(!!this.getDomRef()){this._contentRenderer.render();}return r;};
a.prototype.destroyContent=function(){var r=this.destroyAggregation("content",true);if(!!this.getDomRef()){this._contentRenderer.render();}return r;};
a.prototype.init=function(){this._animOpenDuration=-1;this._animCloseDuration=-1;this._animBlockLayerDuration=-1;this._animation=sap.ui.getCore().getConfiguration().getAnimation();this._opening=false;var t=this;this._headRenderer=new sap.ui.unified._ContentRenderer(this,this.getId()+"-hdr-center",function(r){sap.ui.unified.ShellOverlayRenderer.renderSearch(r,t);});this._contentRenderer=new sap.ui.unified._ContentRenderer(this,this.getId()+"-cntnt",function(r){sap.ui.unified.ShellOverlayRenderer.renderContent(r,t);});};
a.prototype.exit=function(){if(this._popup){this._popup.close(0);this._popup.destroy();this._popup=null;}this._getPopup=function(){return null;};this._headRenderer.destroy();delete this._headRenderer;this._contentRenderer.destroy();delete this._contentRenderer;};
a.prototype.onAfterRendering=function(){if(this._opening){this._setSearchWidth();}q.sap.delayedCall(10,this,function(){this.$().toggleClass("sapUiUfdShellOvrlyCntntHidden",false);this.$("search").css("width","");});};
a.prototype.onclick=function(e){if(q(e.target).attr("id")===this.getId()+"-close"){this.close();e.preventDefault();}};
a.prototype.onsapspace=a.prototype.onclick;
a.prototype.onThemeChanged=function(){this._animOpenDuration=-1;this._animCloseDuration=-1;this._animBlockLayerDuration=-1;};
a.prototype.onfocusin=function(e){var f,d;if(e.target.id==this.getId()+"-focfirst"){f=q(":sapTabbable",this.$("inner"));d=f.get(f.length-1);}else if(e.target.id==this.getId()+"-foclast"){f=q(":sapTabbable",this.$("inner"));d=f.get(0);}if(d){q.sap.focus(d);}};
a.prototype._getAnimDurationThemeParam=function(p,c){var v=parseInt(sap.ui.core.theming.Parameters.get(p),10);if(!this._getAnimActive()&&c){v=0;}return v;};
a.prototype._getAnimDuration=function(o){if((o&&this._animOpenDuration==-1)||(!o&&this._animCloseDuration==-1)){var t=o?"Open":"Close";this["_anim"+t+"Duration"]=this._getAnimDurationThemeParam("sapUiUfdShellOvrly"+t+"AnimOverAll",true);}return o?this._animOpenDuration:this._animCloseDuration;};
a.prototype._getBLAnimDuration=function(){if(this._animBlockLayerDuration==-1){this._animBlockLayerDuration=this._getAnimDurationThemeParam("sapUiUfdShellOvrlyBlockLayerAnimDuration",true);}return this._animBlockLayerDuration;};
a.prototype._getAnimActive=function(){if(!this._animation||(D.browser.internet_explorer&&D.browser.version<10)){return false;}return true;};
a.prototype._getPopup=function(){if(!this._popup){this._popup=new P(this,true,false,false);this._popup._applyPosition=function(p){this._$().css("left","0").css("top","0");this._oLastPosition=p;this._oLastOfRect=q(window).rect();};this._popup.attachOpened(function(){sap.ui.unified._iNumberOfOpenedShellOverlays++;});this._popup.attachClosed(function(){sap.ui.unified._iNumberOfOpenedShellOverlays--;});}return this._popup;};
a.prototype._getShell=function(){var i=this.getShell();if(!i){return;}var s=sap.ui.getCore().byId(i);if(!s||!(s instanceof sap.ui.unified.ShellLayout)){return;}return s;};
a.prototype._forceShellHeaderVisible=function(){var s=this._getShell();if(s){s._doShowHeader(true);}};
a.prototype._getSearchWidth=function(){var s=this._getShell();return s?s._getSearchWidth():-1;};
a.prototype._setSearchWidth=function(){var w=this._getSearchWidth();if(w<=0){return;}var W=w+"px";if(D.browser.safari){var t=this.$("hdr-center").width();if(t>w){W=Math.round((w*100)/t)+"%";}else{W="100%";}}this.$("search").css("width",W);};
return a;},true);
sap.ui.predefine('sap/ui/unified/ShellOverlayRenderer',['jquery.sap.global'],function(q){"use strict";var S={};
S.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapUiUfdShellOvrly");if(c._opening){r.addClass("sapUiUfdShellOvrlyCntntHidden");r.addClass("sapUiUfdShellOvrlyOpening");}if(c._getAnimActive()){r.addClass("sapUiUfdShellOvrlyAnim");}r.writeClasses();if(sap.ui.getCore().getConfiguration().getAccessibility()){r.writeAccessibilityState(c,{role:"dialog"});}r.write("><span id='",c.getId(),"-focfirst' tabIndex='0'></span><div id='",c.getId(),"-inner'>");r.write("<header class='sapUiUfdShellOvrlyHead'>");r.write("<hr class='sapUiUfdShellOvrlyBrand'/>");r.write("<div class='sapUiUfdShellOvrlyHeadCntnt'");if(sap.ui.getCore().getConfiguration().getAccessibility()){r.writeAttribute("role","toolbar");}r.write("><div id='"+c.getId()+"-hdr-center' class='sapUiUfdShellOvrlyHeadCenter'>");S.renderSearch(r,c);r.write("</div>");var a=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified"),C=a.getText("SHELL_OVERLAY_CLOSE");r.write("<a tabindex='0' href='javascript:void(0);' id='"+c.getId()+"-close' class='sapUiUfdShellOvrlyHeadClose'");r.writeAttributeEscaped("title",C);if(sap.ui.getCore().getConfiguration().getAccessibility()){r.writeAttribute("role","button");}r.write(">");r.writeEscaped(C);r.write("</a></div></header>");r.write("<div id='"+c.getId()+"-cntnt' class='sapUiUfdShellOvrlyCntnt'>");S.renderContent(r,c);r.write("</div>");r.write("</div><span id='",c.getId(),"-foclast' tabIndex='0'></span></div>");};
S.renderSearch=function(r,c){var w=c._getSearchWidth();var s="";if(w>0&&c._opening){s="style='width:"+w+"px'";}r.write("<div id='"+c.getId()+"-search' class='sapUiUfdShellOvrlySearch' "+s+"><div>");var o=c.getSearch();if(o){r.renderControl(o);}r.write("</div></div>");};
S.renderContent=function(r,c){r.write("<div tabindex='-1'>");var C=c.getContent();for(var i=0;i<C.length;i++){r.renderControl(C[i]);}r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/ui/unified/ShellRenderer',['jquery.sap.global','sap/ui/core/Renderer','./ShellLayoutRenderer'],function(q,R,S){"use strict";var a=R.extend(S);return a;},true);
sap.ui.predefine('sap/ui/unified/SplitContainer',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/theming/Parameters','./library'],function(q,C,P,l){"use strict";
var S=C.extend("sap.ui.unified.SplitContainer",{metadata:{library:"sap.ui.unified",properties:{showSecondaryContent:{type:"boolean",group:"Appearance",defaultValue:null},secondaryContentSize:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'250px'},secondaryContentWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'250px',deprecated:true},orientation:{type:"sap.ui.core.Orientation",group:"Appearance",defaultValue:sap.ui.core.Orientation.Horizontal}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},secondaryContent:{type:"sap.ui.core.Control",multiple:true,singularName:"secondaryContent"}}}});
(function(w){
S.prototype.init=function(){this.bRtl=sap.ui.getCore().getConfiguration().getRTL();this._paneRenderer=new sap.ui.unified._ContentRenderer(this,this.getId()+"-panecntnt","secondaryContent");this._canvasRenderer=new sap.ui.unified._ContentRenderer(this,this.getId()+"-canvascntnt","content");this._moveContent=true;};
S.prototype.exit=function(){this._paneRenderer.destroy();delete this._paneRenderer;this._canvasRenderer.destroy();delete this._canvasRenderer;if(this._closeContentDelayId){q.sap.clearDelayedCall(this._closeContentDelayId);delete this._closeContentDelayId;}delete this._contentContainer;delete this._secondaryContentContainer;};
S.prototype.onAfterRendering=function(){this.bRtl=sap.ui.getCore().getConfiguration().getRTL();this._contentContainer=this.$("canvas");this._secondaryContentContainer=this.$("pane");this._applySecondaryContentSize();};
S.prototype._applySecondaryContentSize=function(){if(this.getDomRef()){var v=this.getOrientation()==sap.ui.core.Orientation.Vertical;var s,o;var d,O;var a=this.getSecondaryContentSize();var b=this.getShowSecondaryContent();if(v){s="height";o="width";d="top";O=this.bRtl?"right":"left";}else{s="width";o="height";d=this.bRtl?"right":"left";O="top";}if(this._closeContentDelayId){q.sap.clearDelayedCall(this._closeContentDelayId);delete this._closeContentDelayId;}this._secondaryContentContainer.css(s,a);this._secondaryContentContainer.css(o,"");this._secondaryContentContainer.css(d,b?"0":"-"+a);this._secondaryContentContainer.css(O,"");if(this._moveContent){this._contentContainer.css(d,b?a:"0");}else{this._contentContainer.css(d,"0");}if(!b){var h=parseInt(P.get("sapUiUfdSplitContAnimationDuration"),10);this._closeContentDelayId=q.sap.delayedCall(h,this,function(){this._secondaryContentContainer.toggleClass("sapUiUfdSplitContSecondClosed",true);});}else{this._secondaryContentContainer.toggleClass("sapUiUfdSplitContSecondClosed",false);}}};
S.prototype._mod=function(m,d){var r=!!this.getDomRef();var a=m.apply(this,[r]);if(r&&d){d.render();}return a;};
S.prototype.setShowSecondaryContent=function(s){var r=this.getDomRef();this.setProperty("showSecondaryContent",!!s,r);this._applySecondaryContentSize();return this;};
S.prototype.setSecondaryContentSize=function(s){this.setProperty("secondaryContentSize",s,true);this._applySecondaryContentSize();return this;};
S.prototype.getSecondaryContentWidth=function(){q.sap.log.warning("SplitContainer: Use of deprecated property \"SecondaryContentWidth\", please use "+"\"SecondaryContentSize\" instead.");return this.getSecondaryContentSize.apply(this,arguments);};
S.prototype.setSecondaryContentWidth=function(){q.sap.log.warning("SplitContainer: Use of deprecated property \"SecondaryContentWidth\", please use "+"\"SecondaryContentSize\" instead.");return this.setSecondaryContentSize.apply(this,arguments);};
S.prototype.insertContent=function(c,i){return this._mod(function(r){return this.insertAggregation("content",c,i,r);},this._canvasRenderer);};
S.prototype.addContent=function(c){return this._mod(function(r){return this.addAggregation("content",c,r);},this._canvasRenderer);};
S.prototype.removeContent=function(i){return this._mod(function(r){return this.removeAggregation("content",i,r);},this._canvasRenderer);};
S.prototype.removeAllContent=function(){return this._mod(function(r){return this.removeAllAggregation("content",r);},this._canvasRenderer);};
S.prototype.destroyContent=function(){return this._mod(function(r){return this.destroyAggregation("content",r);},this._canvasRenderer);};
S.prototype.insertSecondaryContent=function(c,i){return this._mod(function(r){return this.insertAggregation("secondaryContent",c,i,r);},this._paneRenderer);};
S.prototype.addSecondaryContent=function(c){return this._mod(function(r){return this.addAggregation("secondaryContent",c,r);},this._paneRenderer);};
S.prototype.removeSecondaryContent=function(i){return this._mod(function(r){return this.removeAggregation("secondaryContent",i,r);},this._paneRenderer);};
S.prototype.removeAllSecondaryContent=function(){return this._mod(function(r){return this.removeAllAggregation("secondaryContent",r);},this._paneRenderer);};
S.prototype.destroySecondaryContent=function(){return this._mod(function(r){return this.destroyAggregation("secondaryContent",r);},this._paneRenderer);};
})(window);return S;},true);
sap.ui.predefine('sap/ui/unified/SplitContainerRenderer',['jquery.sap.global'],function(q){"use strict";var S={};
S.render=function(r,c){var i=c.getId();var v=c.getOrientation()==sap.ui.core.Orientation.Vertical;r.write("<div");r.writeControlData(c);r.addClass("sapUiUfdSpltCont");r.addClass("sapUiUfdSpltCont"+(v?"V":"H"));if(sap.ui.getCore().getConfiguration().getAnimation()){r.addClass("sapUiUfdSpltContAnim");}if(!c.getShowSecondaryContent()){r.addClass("sapUiUfdSpltContPaneHidden");}r.writeClasses();r.write(">");var C=i+"-canvas";r.write("<section id='",C,"' class='sapUiUfdSpltContCanvas'>");this.renderContent(r,C,c.getContent(),c._bRootContent);r.write("</section>");var s=i+"-pane";var w=c.getShowSecondaryContent()?c.getSecondaryContentSize():"0";r.write("<aside id='",s,"' style='width:",w,"'");r.addClass("sapUiUfdSpltContPane");if(!c.getShowSecondaryContent()){r.addClass("sapUiUfdSplitContSecondClosed");}r.writeClasses();r.write(">");this.renderContent(r,s,c.getSecondaryContent(),c._bRootContent);r.write("</aside>");r.write("</div>");};
S.renderContent=function(r,I,c,R){r.write("<div id='",I,"cntnt' class='sapUiUfdSpltContCntnt'");if(R){r.writeAttribute("data-sap-ui-root-content","true");}r.write(">");for(var i=0;i<c.length;i++){r.renderControl(c[i]);}r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/ui/unified/calendar/CalendarUtils',['jquery.sap.global','sap/ui/core/date/UniversalDate'],function(q,U){"use strict";var C={};
C._createLocalDate=function(d,t){var l;if(d){var m;if(d instanceof U){m=d.getJSDate();}else{m=d;}l=new Date(m.getUTCFullYear(),m.getUTCMonth(),m.getUTCDate());if(m.getFullYear()<1000){l.setFullYear(m.getFullYear());}if(t){l.setHours(m.getUTCHours());l.setMinutes(m.getUTCMinutes());l.setSeconds(m.getUTCSeconds());l.setMilliseconds(m.getUTCMilliseconds());}}return l;};
C._createUTCDate=function(d,t){var u;if(d){var m;if(d instanceof U){m=d.getJSDate();}else{m=d;}u=new Date(Date.UTC(m.getFullYear(),m.getMonth(),m.getDate()));if(m.getFullYear()<1000){u.setUTCFullYear(m.getFullYear());}if(t){u.setUTCHours(m.getHours());u.setUTCMinutes(m.getMinutes());u.setUTCSeconds(m.getSeconds());u.setUTCMilliseconds(m.getMilliseconds());}}return u;};
C._createUniversalUTCDate=function(d,c,t){var u;if(c){u=U.getInstance(this._createUTCDate(d,t),c);}else{u=new U(this._createUTCDate(d,t).getTime());}return u;};
C.calculateWeekNumber=function(d,y,l,L){var w=0;var W=0;var f=L.getFirstDayOfWeek();var o=new sap.ui.core.Locale(l);if(o&&(o.getLanguage()=='en'&&o.getRegion()=='US')){var j=new U(d.getTime());j.setUTCFullYear(y,0,1);W=j.getUTCDay();var c=new U(d.getTime());c.setUTCDate(c.getUTCDate()-c.getUTCDay()+W);w=Math.round((c.getTime()-j.getTime())/86400000/7)+1;}else{var t=new U(d.getTime());t.setUTCDate(t.getUTCDate()-f);W=t.getUTCDay();t.setUTCDate(t.getUTCDate()-W+4);var F=new U(t.getTime());F.setUTCMonth(0,1);W=F.getUTCDay();var a=0;if(W>4){a=7;}var b=new U(F.getTime());b.setUTCDate(1-W+4+a);w=Math.round((t.getTime()-b.getTime())/86400000/7)+1;}return w;};
return C;},true);
sap.ui.predefine('sap/ui/unified/calendar/DatesRow',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/core/delegate/ItemNavigation','sap/ui/model/type/Date','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate','sap/ui/unified/calendar/Month','sap/ui/unified/library'],function(q,C,L,I,D,a,U,M,l){"use strict";
var b=M.extend("sap.ui.unified.calendar.DatesRow",{metadata:{library:"sap.ui.unified",properties:{startDate:{type:"object",group:"Data"},days:{type:"int",group:"Appearance",defaultValue:7},showDayNamesLine:{type:"boolean",group:"Appearance",defaultValue:true}}}});
b.prototype.init=function(){M.prototype.init.apply(this,arguments);this._iColumns=1;};
b.prototype.setStartDate=function(s){if(!(s instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var y=s.getFullYear();if(y<1||y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}var u=a._createUniversalUTCDate(s,this.getPrimaryCalendarType());this.setProperty("startDate",s,true);this._oUTCStartDate=u;if(this.getDomRef()){var o=a._createLocalDate(this._getDate());this._bNoRangeCheck=true;this.displayDate(s);this._bNoRangeCheck=false;if(o&&this.checkDateFocusable(o)){this.displayDate(o);}}return this;};
b.prototype._getStartDate=function(){if(!this._oUTCStartDate){this._oUTCStartDate=a._createUniversalUTCDate(new Date(),this.getPrimaryCalendarType());}return this._oUTCStartDate;};
b.prototype.setDate=function(d){if(!this._bNoRangeCheck&&!this.checkDateFocusable(d)){throw new Error("Date must be in visible date range; "+this);}M.prototype.setDate.apply(this,arguments);return this;};
b.prototype.displayDate=function(d){if(!this._bNoRangeCheck&&!this.checkDateFocusable(d)){throw new Error("Date must be in visible date range; "+this);}M.prototype.displayDate.apply(this,arguments);return this;};
b.prototype.setPrimaryCalendarType=function(c){M.prototype.setPrimaryCalendarType.apply(this,arguments);if(this._oUTCStartDate){this._oUTCStartDate=U.getInstance(this._oUTCStartDate.getJSDate(),c);}return this;};
b.prototype.setFirstDayOfWeek=function(f){if(f==-1){this.setProperty("firstDayOfWeek",f,false);}else{throw new Error("Property firstDayOfWeek not supported "+this);}};
b.prototype._handleBorderReached=function(c){var e=c.getParameter("event");var d=this.getDays();var o=this._getDate();var f=this._newUniversalDate(o);if(e.type){switch(e.type){case"sapnext":case"sapnextmodifiers":f.setUTCDate(f.getUTCDate()+1);break;case"sapprevious":case"sappreviousmodifiers":f.setUTCDate(f.getUTCDate()-1);break;case"sappagedown":f.setUTCDate(f.getUTCDate()+d);break;case"sappageup":f.setUTCDate(f.getUTCDate()-d);break;default:break;}this.fireFocus({date:a._createLocalDate(f),otherMonth:true});}};
b.prototype.checkDateFocusable=function(d){if(!(d instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}if(this._bNoRangeCheck){return false;}var s=this._getStartDate();var e=this._newUniversalDate(s);e.setUTCDate(e.getUTCDate()+this.getDays());var u=a._createUniversalUTCDate(d,this.getPrimaryCalendarType());if(u.getTime()>=s.getTime()&&u.getTime()<e.getTime()){return true;}else{return false;}};
b.prototype._renderHeader=function(){var s=this._getStartDate();var S=s.getUTCDay();var o=this._getLocaleData();var w=this.$("Names").children();var W=[];if(this._bLongWeekDays||!this._bNamesLengthChecked){W=o.getDaysStandAlone("abbreviated");}else{W=o.getDaysStandAlone("narrow");}var c=o.getDaysStandAlone("wide");var i=0;for(i=0;i<w.length;i++){var $=q(w[i]);$.text(W[(i+S)%7]);$.attr("aria-label",c[(i+S)%7]);}if(this._getShowHeader()){var d=this.$("Head");if(d.length>0){var r=sap.ui.getCore().createRenderManager();this.getRenderer().renderHeaderLine(r,this,o,s);r.flush(d[0]);r.destroy();}}};
b.prototype._getFirstWeekDay=function(){var s=this._getStartDate();return s.getUTCDay();};
return b;},true);
sap.ui.predefine('sap/ui/unified/calendar/DatesRowRenderer',['jquery.sap.global','sap/ui/core/Renderer','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate','./MonthRenderer'],function(q,R,C,U,M){"use strict";var D=R.extend(M);
D.getStartDate=function(d){return d._getStartDate();};
D.getClass=function(d){var c="sapUiCalDatesRow sapUiCalRow";if(!d.getShowDayNamesLine()){c=c+" sapUiCalNoNameLine";}return c;};
D.renderHeader=function(r,d,o){var l=d._getLocaleData();var i=d.getId();var a=d.getDays();var w="";if(d._getShowHeader()){r.write("<div id=\""+i+"-Head\">");this.renderHeaderLine(r,d,l,o);r.write("</div>");}w=(100/a)+"%";if(d.getShowDayNamesLine()){r.write("<div id=\""+i+"-Names\" style=\"display: inline;\">");this.renderDayNames(r,d,l,o.getUTCDay(),a,false,w);r.write("</div>");}};
D.renderHeaderLine=function(r,d,l,o){var I=d.getId();var a=d.getDays();var b=d._newUniversalDate(o);var w="";var m=0;var c=[];var i=0;for(i=0;i<a;i++){m=b.getUTCMonth();if(c.length>0&&c[c.length-1].iMonth==m){c[c.length-1].iDays++;}else{c.push({iMonth:m,iDays:1});}b.setUTCDate(b.getUTCDate()+1);}var e=l.getMonthsStandAlone("wide");for(i=0;i<c.length;i++){var f=c[i];w=(100/a*f.iDays)+"%";r.write("<div id=\""+I+"-Head"+i+"\"class=\"sapUiCalHeadText\" style=\"width:"+w+"\">");r.write(e[f.iMonth]);r.write("</div>");}};
D.renderDays=function(r,d,o){var a=d.getDays();var w=(100/a)+"%";var s=d.getShowDayNamesLine();if(!o){o=d._getFocusedDate();}var h=this.getDayHelper(d,o);if(!s){if(d._bLongWeekDays||!d._bNamesLengthChecked){h.aWeekDays=h.oLocaleData.getDaysStandAlone("abbreviated");}else{h.aWeekDays=h.oLocaleData.getDaysStandAlone("narrow");}h.aWeekDaysWide=h.oLocaleData.getDaysStandAlone("wide");}var b=d._newUniversalDate(o);for(var i=0;i<a;i++){this.renderDay(r,d,b,h,false,false,i,w,!s);b.setUTCDate(b.getUTCDate()+1);}};
return D;},true);
sap.ui.predefine('sap/ui/unified/calendar/Header',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/unified/library'],function(q,C,L,l){"use strict";
var H=C.extend("sap.ui.unified.calendar.Header",{metadata:{library:"sap.ui.unified",properties:{textButton0:{type:"string",group:"Appearance"},additionalTextButton0:{type:"string",group:"Appearance"},ariaLabelButton0:{type:"string",group:"Misc"},visibleButton0:{type:"boolean",group:"Appearance",defaultValue:false},textButton1:{type:"string",group:"Appearance"},additionalTextButton1:{type:"string",group:"Appearance"},ariaLabelButton1:{type:"string",group:"Misc"},visibleButton1:{type:"boolean",group:"Appearance",defaultValue:true},textButton2:{type:"string",group:"Appearance"},additionalTextButton2:{type:"string",group:"Appearance"},ariaLabelButton2:{type:"string",group:"Misc"},visibleButton2:{type:"boolean",group:"Appearance",defaultValue:true},enabledPrevious:{type:"boolean",group:"Behavior",defaultValue:true},enabledNext:{type:"boolean",group:"Behavior",defaultValue:true}},events:{pressPrevious:{},pressNext:{},pressButton0:{},pressButton1:{},pressButton2:{}}}});
H.prototype.setTextButton0=function(t){_.call(this,0,t);return this;};
H.prototype.setAdditionalTextButton0=function(t){a.call(this,0,t);return this;};
H.prototype.setAriaLabelButton0=function(t){b.call(this,0,t);return this;};
H.prototype.setTextButton1=function(t){_.call(this,1,t);return this;};
H.prototype.setAdditionalTextButton1=function(t){a.call(this,1,t);return this;};
H.prototype.setAriaLabelButton1=function(t){b.call(this,1,t);return this;};
H.prototype.setTextButton2=function(t){_.call(this,2,t);return this;};
H.prototype.setAdditionalTextButton2=function(t){a.call(this,2,t);return this;};
H.prototype.setAriaLabelButton2=function(t){b.call(this,2,t);return this;};
H.prototype.setEnabledPrevious=function(e){this.setProperty("enabledPrevious",e,true);if(this.getDomRef()){if(e){this.$("prev").toggleClass("sapUiCalDsbl",false).removeAttr("disabled");}else{this.$("prev").toggleClass("sapUiCalDsbl",true).attr("disabled","disabled");}}return this;};
H.prototype.setEnabledNext=function(e){this.setProperty("enabledNext",e,true);if(this.getDomRef()){if(e){this.$("next").toggleClass("sapUiCalDsbl",false).removeAttr("disabled");}else{this.$("next").toggleClass("sapUiCalDsbl",true).attr("disabled","disabled");}}return this;};
H.prototype.onclick=function(e){if(e.isMarked("delayedMouseEvent")){return;}if(q.sap.containsOrEquals(this.getDomRef("prev"),e.target)&&this.getEnabledPrevious()){this.firePressPrevious();}else if(q.sap.containsOrEquals(this.getDomRef("next"),e.target)&&this.getEnabledNext()){this.firePressNext();}else if(q.sap.containsOrEquals(this.getDomRef("B0"),e.target)){this.firePressButton0();}else if(q.sap.containsOrEquals(this.getDomRef("B1"),e.target)){this.firePressButton1();}else if(q.sap.containsOrEquals(this.getDomRef("B2"),e.target)){this.firePressButton2();}};
H.prototype.onsapnext=function(e){e.preventDefault();};
function _(B,t){this.setProperty("textButton"+B,t,true);if(this.getDomRef()&&this["getVisibleButton"+B]()){if(this.$("B"+B+"-Text").get(0)){this.$("B"+B+"-Text").text(t);}else{this.$("B"+B).text(t);}}}
function a(B,t){var r=false;var o=this["getAdditionalTextButton"+B]();if(o==t){return;}if((!o&&t)||(o&&!t)){r=true;}this.setProperty("additionalTextButton"+B,t,!r);if(!r&&this.getDomRef()&&this["getVisibleButton"+B]()){this.$("B"+B+"-AddText").text(t);}}
function b(B,t){this.setProperty("ariaLabelButton"+B,t,true);if(this.getDomRef()&&this["getVisibleButton"+B]()){if(t){this.$("B"+B).attr("aria-label",t);}else{this.$("B"+B).removeAttr("aria-label");}}}
return H;},true);
sap.ui.predefine('sap/ui/unified/calendar/HeaderRenderer',['jquery.sap.global'],function(q){"use strict";var H={};
H.render=function(r,h){var t=h.getTooltip_AsString();var I=h.getId();var a={};r.write("<div");r.writeControlData(h);r.addClass("sapUiCalHead");r.writeClasses();if(t){r.writeAttributeEscaped('title',t);}r.writeAccessibilityState(h);r.write(">");r.write("<button");r.writeAttributeEscaped('id',I+'-prev');r.addClass("sapUiCalHeadPrev");if(!h.getEnabledPrevious()){r.addClass("sapUiCalDsbl");r.writeAttribute('disabled',"disabled");}r.writeAttribute('tabindex',"-1");r.writeClasses();r.write(">");r.writeIcon("sap-icon://slim-arrow-left",null,{title:null});r.write("</button>");var f=-1;var l=-1;var i=0;for(i=0;i<3;i++){if(h["getVisibleButton"+i]()){if(f<0){f=i;}l=i;}}for(i=0;i<3;i++){if(h["getVisibleButton"+i]()){r.write("<button");r.writeAttributeEscaped('id',I+'-B'+i);r.addClass("sapUiCalHeadB");r.addClass("sapUiCalHeadB"+i);if(f==i){r.addClass("sapUiCalHeadBFirst");}if(l==i){r.addClass("sapUiCalHeadBLast");}r.writeAttribute('tabindex',"-1");r.writeClasses();if(h["getAriaLabelButton"+i]()){a["label"]=q.sap.encodeHTML(h["getAriaLabelButton"+i]());}r.writeAccessibilityState(null,a);a={};r.write(">");var T=h["getTextButton"+i]()||"";var A=h["getAdditionalTextButton"+i]()||"";if(A){r.write("<span");r.writeAttributeEscaped('id',I+'-B'+i+"-Text");r.addClass("sapUiCalHeadBText");r.writeClasses();r.write(">");r.writeEscaped(T);r.write("</span>");r.write("<span");r.writeAttributeEscaped('id',I+'-B'+i+"-AddText");r.addClass("sapUiCalHeadBAddText");r.writeClasses();r.write(">");r.writeEscaped(A);r.write("</span>");}else{r.writeEscaped(T);}r.write("</button>");}}r.write("<button");r.writeAttributeEscaped('id',I+'-next');r.addClass("sapUiCalHeadNext");if(!h.getEnabledNext()){r.addClass("sapUiCalDsbl");r.writeAttribute('disabled',"disabled");}r.writeAttribute('tabindex',"-1");r.writeClasses();r.write(">");r.writeIcon("sap-icon://slim-arrow-right",null,{title:null});r.write("</button>");r.write("</div>");};
return H;},true);
sap.ui.predefine('sap/ui/unified/calendar/Month',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/core/delegate/ItemNavigation','sap/ui/model/type/Date','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate','sap/ui/unified/library'],function(q,C,L,I,D,a,U,l){"use strict";
var M=C.extend("sap.ui.unified.calendar.Month",{metadata:{library:"sap.ui.unified",properties:{date:{type:"object",group:"Data"},intervalSelection:{type:"boolean",group:"Behavior",defaultValue:false},singleSelection:{type:"boolean",group:"Behavior",defaultValue:true},showHeader:{type:"boolean",group:"Appearance",defaultValue:false},firstDayOfWeek:{type:"int",group:"Appearance",defaultValue:-1},nonWorkingDays:{type:"int[]",group:"Appearance",defaultValue:null},primaryCalendarType:{type:"sap.ui.core.CalendarType",group:"Appearance"},secondaryCalendarType:{type:"sap.ui.core.CalendarType",group:"Appearance"},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},aggregations:{selectedDates:{type:"sap.ui.unified.DateRange",multiple:true,singularName:"selectedDate"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},disabledDates:{type:"sap.ui.unified.DateRange",multiple:true,singularName:"disabledDate"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.ui.unified.CalendarLegend",multiple:false}},events:{select:{},focus:{parameters:{date:{type:"object"},otherMonth:{type:"boolean"},restoreOldDate:{type:"boolean"}}}}}});
M.prototype.init=function(){var s=sap.ui.getCore().getConfiguration().getCalendarType();this.setProperty("primaryCalendarType",s);this.setProperty("secondaryCalendarType",s);this._oFormatYyyymmdd=sap.ui.core.format.DateFormat.getInstance({pattern:"yyyyMMdd",calendarType:sap.ui.core.CalendarType.Gregorian});this._oFormatLong=sap.ui.core.format.DateFormat.getInstance({style:"long",calendarType:s});this._mouseMoveProxy=q.proxy(this._handleMouseMove,this);this._iColumns=7;};
M.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}if(this._sInvalidateMonth){q.sap.clearDelayedCall(this._sInvalidateMonth);}};
M.prototype.onAfterRendering=function(){_.call(this);n.call(this);};
M.prototype.onsapfocusleave=function(E){if(!E.relatedControlId||!q.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(E.relatedControlId).getFocusDomRef())){if(this._bMouseMove){this._unbindMousemove(true);var s=h.call(this,this._getDate());if(!s&&this._oMoveSelectedDate){h.call(this,this._oMoveSelectedDate);}this._bMoveChange=false;this._bMousedownChange=false;this._oMoveSelectedDate=undefined;m.call(this);}if(this._bMousedownChange){this._bMousedownChange=false;m.call(this);}}};
M.prototype.invalidate=function(O){if(!this._bDateRangeChanged&&(!O||!(O instanceof sap.ui.unified.DateRange))){C.prototype.invalidate.apply(this,arguments);}else if(this.getDomRef()&&!this._sInvalidateMonth){if(this._bInvalidateSync){o.call(this);}else{this._sInvalidateMonth=q.sap.delayedCall(0,this,o,[this]);}}};
M.prototype.removeAllSelectedDates=function(){this._bDateRangeChanged=true;var r=this.removeAllAggregation("selectedDates");return r;};
M.prototype.destroySelectedDates=function(){this._bDateRangeChanged=true;var i=this.destroyAggregation("selectedDates");return i;};
M.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=true;var r=this.removeAllAggregation("specialDates");return r;};
M.prototype.destroySpecialDates=function(){this._bDateRangeChanged=true;var i=this.destroyAggregation("specialDates");return i;};
M.prototype.removeAllDisabledDates=function(){this._bDateRangeChanged=true;var r=this.removeAllAggregation("disabledDates");return r;};
M.prototype.destroyDisabledDates=function(){this._bDateRangeChanged=true;var i=this.destroyAggregation("disabledDates");return i;};
M.prototype.setDate=function(i){e.call(this,i,false);return this;};
M.prototype._setDate=function(i){var p=a._createLocalDate(i);this.setProperty("date",p,true);this._oUTCDate=i;};
M.prototype._getDate=function(){if(!this._oUTCDate){this._oUTCDate=a._createUniversalUTCDate(new Date(),this.getPrimaryCalendarType());}return this._oUTCDate;};
M.prototype.displayDate=function(i){e.call(this,i,true);return this;};
M.prototype.setPrimaryCalendarType=function(s){this.setProperty("primaryCalendarType",s);this._oFormatLong=sap.ui.core.format.DateFormat.getInstance({style:"long",calendarType:s});if(this._oUTCDate){this._oUTCDate=U.getInstance(this._oUTCDate.getJSDate(),s);}return this;};
M.prototype._newUniversalDate=function(i){var J;if((i instanceof U)){J=new Date(i.getJSDate().getTime());}else{J=new Date(i.getTime());}return U.getInstance(J,this.getPrimaryCalendarType());};
M.prototype.setSecondaryCalendarType=function(s){this._bSecondaryCalendarTypeSet=true;this.setProperty("secondaryCalendarType",s);this.invalidate();this._oFormatSecondaryLong=sap.ui.core.format.DateFormat.getInstance({style:"long",calendarType:s});return this;};
M.prototype._getSecondaryCalendarType=function(){var s;if(this._bSecondaryCalendarTypeSet){s=this.getSecondaryCalendarType();var p=this.getPrimaryCalendarType();if(s==p){s=undefined;}}return s;};
M.prototype._getLocale=function(){var p=this.getParent();if(p&&p.getLocale){return p.getLocale();}else if(!this._sLocale){this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();}return this._sLocale;};
M.prototype._getLocaleData=function(){var p=this.getParent();if(p&&p._getLocaleData){return p._getLocaleData();}else if(!this._oLocaleData){var s=this._getLocale();var i=new sap.ui.core.Locale(s);this._oLocaleData=L.getInstance(i);}return this._oLocaleData;};
M.prototype._getFormatLong=function(){var s=this._getLocale();if(this._oFormatLong.oLocale.toString()!=s){var i=new sap.ui.core.Locale(s);this._oFormatLong=sap.ui.core.format.DateFormat.getInstance({style:"long",calendarType:this.getPrimaryCalendarType()},i);if(this._oFormatSecondaryLong){this._oFormatSecondaryLong=sap.ui.core.format.DateFormat.getInstance({style:"long",calendarType:this._getSecondaryCalendarType()},i);}}return this._oFormatLong;};
M.prototype.getIntervalSelection=function(){var p=this.getParent();if(p&&p.getIntervalSelection){return p.getIntervalSelection();}else{return this.getProperty("intervalSelection");}};
M.prototype.getSingleSelection=function(){var p=this.getParent();if(p&&p.getSingleSelection){return p.getSingleSelection();}else{return this.getProperty("singleSelection");}};
M.prototype.getSelectedDates=function(){var p=this.getParent();if(p&&p.getSelectedDates){return p.getSelectedDates();}else{return this.getAggregation("selectedDates",[]);}};
M.prototype.getSpecialDates=function(){var p=this.getParent();if(p&&p.getSpecialDates){return p.getSpecialDates();}else{return this.getAggregation("specialDates",[]);}};
M.prototype.getDisabledDates=function(){var p=this.getParent();if(p&&p.getDisabledDates){return p.getDisabledDates();}else{return this.getAggregation("disabledDates",[]);}};
M.prototype._getShowHeader=function(){var p=this.getParent();if(p&&p._getShowMonthHeader){return p._getShowMonthHeader();}else{return this.getProperty("showHeader");}};
M.prototype.getAriaLabelledBy=function(){var p=this.getParent();if(p&&p.getAriaLabelledBy){return p.getAriaLabelledBy();}else{return this.getAssociation("ariaLabelledBy",[]);}};
M.prototype.getLegend=function(){var p=this.getParent();if(p&&p.getLegend){return p.getLegend();}else{return this.getAssociation("ariaLabelledBy",[]);}};
M.prototype._getFirstDayOfWeek=function(){var p=this.getParent();var F=0;if(p&&p.getFirstDayOfWeek){F=p.getFirstDayOfWeek();}else{F=this.getProperty("firstDayOfWeek");}if(F<0||F>6){var i=this._getLocaleData();F=i.getFirstDayOfWeek();}return F;};
M.prototype._getNonWorkingDays=function(){var p=this.getParent();var N;if(p&&p.getNonWorkingDays){N=p.getNonWorkingDays();}else{N=this.getProperty("nonWorkingDays");}if(N&&!q.isArray(N)){N=[];}return N;};
M.prototype._checkDateSelected=function(p){if(!(p instanceof U)){throw new Error("Date must be a UniversalDate object "+this);}var s=0;var S=this.getSelectedDates();var t=p.getTime();var r=this.getPrimaryCalendarType();for(var i=0;i<S.length;i++){var R=S[i];var u=R.getStartDate();var v=0;if(u){u=a._createUniversalUTCDate(u,r);v=u.getTime();}var E=R.getEndDate();var w=0;if(E){E=a._createUniversalUTCDate(E,r);w=E.getTime();}if(t==v&&!E){s=1;break;}else if(t==v&&E){s=2;if(E&&t==w){s=5;}break;}else if(E&&t==w){s=3;break;}else if(E&&t>v&&t<w){s=4;break;}if(this.getSingleSelection()){break;}}return s;};
M.prototype._getDateType=function(p){if(!(p instanceof U)){throw new Error("Date must be a UniversalDate object "+this);}var t;var s=this.getSpecialDates();var T=p.getTime();var r=this.getPrimaryCalendarType();for(var i=0;i<s.length;i++){var R=s[i];var S=R.getStartDate();var u=0;if(S){S=a._createUniversalUTCDate(S,r);u=S.getTime();}var E=R.getEndDate();var v=0;if(E){E=a._createUniversalUTCDate(E,r);v=E.getTime();}if((T==u&&!E)||(T>=u&&T<=v)){t={type:R.getType(),tooltip:R.getTooltip_AsString()};break;}}return t;};
M.prototype._checkDateEnabled=function(p){if(!(p instanceof U)){throw new Error("Date must be a UniversalDate object "+this);}var E=true;var r=this.getDisabledDates();var t=p.getTime();var s=this.getPrimaryCalendarType();var P=this.getParent();if(P&&P._oMinDate&&P._oMaxDate){if(t<P._oMinDate.getTime()||t>P._oMaxDate.getTime()){return false;}}for(var i=0;i<r.length;i++){var R=r[i];var S=R.getStartDate();var u=0;if(S){S=a._createUniversalUTCDate(S,s);u=S.getTime();}var v=R.getEndDate();var w=0;if(v){v=a._createUniversalUTCDate(v,s);w=v.getTime();}if(v){if(t>u&&t<w){E=false;break;}}else if(t==u){E=false;break;}}return E;};
M.prototype.setWidth=function(w){this.setProperty("width",w,true);if(this.getDomRef()){w=this.getWidth();this.$().css("width",w);}return this;};
M.prototype._handleMouseMove=function(E){if(!this.$().is(":visible")){this._unbindMousemove(true);}var t=q(E.target);if(t.hasClass("sapUiCalItemText")){t=t.parent();}if(this._sLastTargetId&&this._sLastTargetId==t.attr("id")){return;}this._sLastTargetId=t.attr("id");if(t.hasClass("sapUiCalItem")){var O=this._getDate();if(!q.sap.containsOrEquals(this.getDomRef(),E.target)){var s=this.getSelectedDates();if(s.length>0&&this.getSingleSelection()){var S=s[0].getStartDate();if(S){S=a._createUniversalUTCDate(S,this.getPrimaryCalendarType());}var i=this._newUniversalDate(this._oFormatYyyymmdd.parse(t.attr("data-sap-day"),true));if(i.getTime()>=S.getTime()){j.call(this,S,i);}else{j.call(this,i,S);}}}else{var F=this._newUniversalDate(this._oFormatYyyymmdd.parse(t.attr("data-sap-day"),true));if(F.getTime()!=O.getTime()){if(t.hasClass("sapUiCalItemOtherMonth")){this.fireFocus({date:a._createLocalDate(F),otherMonth:true});}else{this._setDate(F);var p=h.call(this,F,true);if(p){this._oMoveSelectedDate=this._newUniversalDate(F);}this._bMoveChange=true;}}}}};
M.prototype.onmouseup=function(E){if(this._bMouseMove){this._unbindMousemove(true);var F=this._getDate();var p=this._oItemNavigation.getItemDomRefs();for(var i=0;i<p.length;i++){var $=q(p[i]);if(!$.hasClass("sapUiCalItemOtherMonth")){if($.attr("data-sap-day")==this._oFormatYyyymmdd.format(F.getJSDate(),true)){$.focus();break;}}}if(this._bMoveChange){var s=h.call(this,F);if(!s&&this._oMoveSelectedDate){h.call(this,this._oMoveSelectedDate);}this._bMoveChange=false;this._bMousedownChange=false;this._oMoveSelectedDate=undefined;m.call(this);}}if(this._bMousedownChange){this._bMousedownChange=false;m.call(this);}};
M.prototype.onsapselect=function(E){var s=h.call(this,this._getDate());if(s){m.call(this);}E.stopPropagation();E.preventDefault();};
M.prototype.onsapselectmodifiers=function(E){this.onsapselect(E);};
M.prototype.onsappageupmodifiers=function(E){var F=this._newUniversalDate(this._getDate());var y=F.getUTCFullYear();if(E.metaKey||E.ctrlKey){F.setUTCFullYear(y-10);}else{F.setUTCFullYear(y-1);}this.fireFocus({date:a._createLocalDate(F),otherMonth:true});E.preventDefault();};
M.prototype.onsappagedownmodifiers=function(E){var F=this._newUniversalDate(this._getDate());var y=F.getUTCFullYear();if(E.metaKey||E.ctrlKey){F.setUTCFullYear(y+10);}else{F.setUTCFullYear(y+1);}this.fireFocus({date:a._createLocalDate(F),otherMonth:true});E.preventDefault();};
M.prototype._updateSelection=function(){var s=this.getSelectedDates();if(s.length>0&&this.getSingleSelection()){var i=this.getPrimaryCalendarType();var S=s[0].getStartDate();if(S){S=a._createUniversalUTCDate(S,i);}var E=s[0].getEndDate();if(E){E=a._createUniversalUTCDate(E,i);}j.call(this,S,E);}};
M.prototype._bindMousemove=function(F){q(window.document).bind('mousemove',this._mouseMoveProxy);this._bMouseMove=true;if(F){this.fireEvent("_bindMousemove");}};
M.prototype._unbindMousemove=function(F){q(window.document).unbind('mousemove',this._mouseMoveProxy);this._bMouseMove=undefined;this._sLastTargetId=undefined;if(F){this.fireEvent("_unbindMousemove");}};
M.prototype.onThemeChanged=function(){if(this._bNoThemeChange){return;}this._bNamesLengthChecked=undefined;this._bLongWeekDays=undefined;var w=this.$().find(".sapUiCalWH");var p=this._getLocaleData();var s=this._getFirstWeekDay();var r=p.getDaysStandAlone("abbreviated",this.getPrimaryCalendarType());for(var i=0;i<w.length;i++){var W=w[i];q(W).text(r[(i+s)%7]);}n.call(this);};
M.prototype._handleBorderReached=function(i){var E=i.getParameter("event");var p=0;var O=this._getDate();var F=this._newUniversalDate(O);if(E.type){switch(E.type){case"sapnext":case"sapnextmodifiers":if(E.keyCode==q.sap.KeyCodes.ARROW_DOWN){F.setUTCDate(F.getUTCDate()+7);}else{F.setUTCDate(F.getUTCDate()+1);}break;case"sapprevious":case"sappreviousmodifiers":if(E.keyCode==q.sap.KeyCodes.ARROW_UP){F.setUTCDate(F.getUTCDate()-7);}else{F.setUTCDate(F.getUTCDate()-1);}break;case"sappagedown":p=F.getUTCMonth()+1;F.setUTCMonth(p);if(p%12!=F.getUTCMonth()){while(p!=F.getUTCMonth()){F.setUTCDate(F.getUTCDate()-1);}}break;case"sappageup":p=F.getUTCMonth()-1;F.setUTCMonth(p);if(p<0){p=11;}if(p!=F.getUTCMonth()){while(p!=F.getUTCMonth()){F.setUTCDate(F.getUTCDate()-1);}}break;default:break;}this.fireFocus({date:a._createLocalDate(F),otherMonth:true});}};
M.prototype.checkDateFocusable=function(i){if(!(i instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var p=this._getDate();var u=a._createUniversalUTCDate(i,this.getPrimaryCalendarType());if(u.getUTCFullYear()==p.getUTCFullYear()&&u.getUTCMonth()==p.getUTCMonth()){return true;}else{return false;}};
M.prototype._renderHeader=function(){if(this._getShowHeader()){var i=this._getDate();var p=this._getLocaleData();var r=p.getMonthsStandAlone("wide",this.getPrimaryCalendarType());this.$("Head").text(r[i.getUTCMonth()]);}};
M.prototype._getFirstWeekDay=function(){return this._getFirstDayOfWeek();};
M.prototype._isMonthNameLong=function(w){var i;var W;for(i=0;i<w.length;i++){W=w[i];if(Math.abs(W.clientWidth-W.scrollWidth)>1){return true;}}return false;};
function _(){var p=this._getDate();var y=this._oFormatYyyymmdd.format(p.getJSDate(),true);var r=0;var R=this.$("days").get(0);var s=this.$("days").find(".sapUiCalItem");for(var i=0;i<s.length;i++){var $=q(s[i]);if($.attr("data-sap-day")===y){r=i;break;}}if(!this._oItemNavigation){this._oItemNavigation=new I();this._oItemNavigation.attachEvent(I.Events.AfterFocus,b,this);this._oItemNavigation.attachEvent(I.Events.FocusAgain,c,this);this._oItemNavigation.attachEvent(I.Events.BorderReached,this._handleBorderReached,this);this.addDelegate(this._oItemNavigation);if(this._iColumns>1){this._oItemNavigation.setHomeEndColumnMode(true,true);}this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"],saphome:["alt"],sapend:["alt"]});this._oItemNavigation.setCycling(false);this._oItemNavigation.setColumns(this._iColumns,true);}this._oItemNavigation.setRootDomRef(R);this._oItemNavigation.setItemDomRefs(s);this._oItemNavigation.setFocusedIndex(r);this._oItemNavigation.setPageSize(s.length);}
function b(p){var r=p.getParameter("index");var E=p.getParameter("event");if(!E){return;}var O=this._getDate();var F=this._newUniversalDate(O);var s=false;var t=true;var u=this._oItemNavigation.getItemDomRefs();var i=0;var $=q(u[r]);var v;if($.hasClass("sapUiCalItemOtherMonth")){if(E.type=="saphomemodifiers"&&(E.metaKey||E.ctrlKey)){F.setUTCDate(1);f.call(this,F);}else if(E.type=="sapendmodifiers"&&(E.metaKey||E.ctrlKey)){for(i=u.length-1;i>0;i--){v=q(u[i]);if(!v.hasClass("sapUiCalItemOtherMonth")){F=this._newUniversalDate(this._oFormatYyyymmdd.parse(v.attr("data-sap-day"),true));break;}}f.call(this,F);}else{s=true;F=this._newUniversalDate(this._oFormatYyyymmdd.parse($.attr("data-sap-day"),true));if(!F){F=this._newUniversalDate(O);}f.call(this,O);if(E.type=="mousedown"||(this._sTouchstartYyyyMMdd&&E.type=="focusin"&&this._sTouchstartYyyyMMdd==$.attr("data-sap-day"))){t=false;this.fireFocus({date:a._createLocalDate(O),otherMonth:false,restoreOldDate:true});}if(E.originalEvent&&E.originalEvent.type=="touchstart"){this._sTouchstartYyyyMMdd=$.attr("data-sap-day");}else{this._sTouchstartYyyyMMdd=undefined;}}}else{if(q(E.target).hasClass("sapUiCalWeekNum")){f.call(this,F);}else{F=this._newUniversalDate(this._oFormatYyyymmdd.parse($.attr("data-sap-day"),true));this._setDate(F);}this._sTouchstartYyyyMMdd=undefined;}if(E.type=="mousedown"&&this.getIntervalSelection()){this._sLastTargetId=$.attr("id");}if(t){this.fireFocus({date:a._createLocalDate(F),otherMonth:s});}if(E.type=="mousedown"){d.call(this,E,F,r);}}
function c(i){var p=i.getParameter("index");var E=i.getParameter("event");if(!E){return;}if(E.type=="mousedown"){var F=this._getDate();if(this.getIntervalSelection()){var r=this._oItemNavigation.getItemDomRefs();this._sLastTargetId=r[p].id;}d.call(this,E,F,p);}}
function d(E,F,i){if(E.button){return;}var s=h.call(this,F);if(s){this._bMousedownChange=true;}if(this._bMouseMove){this._unbindMousemove(true);this._bMoveChange=false;this._oMoveSelectedDate=undefined;}else if(s&&this.getIntervalSelection()&&this.$().is(":visible")){this._bindMousemove(true);this._oMoveSelectedDate=this._newUniversalDate(F);}E.preventDefault();E.setMark("cancelAutoClose");}
function e(i,N){if(!(i instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var y=i.getFullYear();if(y<1||y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}var F=true;if(!q.sap.equal(this.getDate(),i)){var u=a._createUniversalUTCDate(i,this.getPrimaryCalendarType());F=this.checkDateFocusable(i);this.setProperty("date",i,true);this._oUTCDate=u;}if(this.getDomRef()){if(F){f.call(this,this._oUTCDate,true,N);}else{g.call(this,N);}}}
function f(p,N,r){if(!N){this.setDate(a._createLocalDate(new Date(p.getTime())));}var y=this._oFormatYyyymmdd.format(p.getJSDate(),true);var s=this._oItemNavigation.getItemDomRefs();var $;for(var i=0;i<s.length;i++){$=q(s[i]);if($.attr("data-sap-day")==y){if(document.activeElement!=s[i]){if(r){this._oItemNavigation.setFocusedIndex(i);}else{this._oItemNavigation.focusItem(i);}}break;}}}
function g(N){var p=this.getRenderer().getStartDate(this);var $=this.$("days");var r;var s;var i=0;var t=0;if(this._sLastTargetId){r=this._oItemNavigation.getItemDomRefs();for(i=0;i<r.length;i++){s=q(r[i]);if(s.attr("id")==this._sLastTargetId){t=i;break;}}}if($.length>0){var R=sap.ui.getCore().createRenderManager();this.getRenderer().renderDays(R,this,p);R.flush($[0]);R.destroy();}this._renderHeader();this.fireEvent("_renderMonth",{days:$.find(".sapUiCalItem").length});_.call(this);if(!N){this._oItemNavigation.focusItem(this._oItemNavigation.getFocusedIndex());}if(this._sLastTargetId){r=this._oItemNavigation.getItemDomRefs();if(t<=r.length-1){s=q(r[t]);this._sLastTargetId=s.attr("id");}}}
function h(p,r){if(!this._checkDateEnabled(p)){return false;}var s=this.getSelectedDates();var t;var u=this._oItemNavigation.getItemDomRefs();var $;var y;var i=0;var P=this.getParent();var A=this;var S;var v=this.getPrimaryCalendarType();if(P&&P.getSelectedDates){A=P;}if(this.getSingleSelection()){if(s.length>0){t=s[0];S=t.getStartDate();if(S){S=a._createUniversalUTCDate(S,v);}}else{t=new sap.ui.unified.DateRange();A.addAggregation("selectedDates",t,true);}if(this.getIntervalSelection()&&(!t.getEndDate()||r)&&S){var E;if(p.getTime()<S.getTime()){E=S;S=p;if(!r){t.setProperty("startDate",a._createLocalDate(new Date(S.getTime())),true);t.setProperty("endDate",a._createLocalDate(new Date(E.getTime())),true);}}else if(p.getTime()>=S.getTime()){E=p;if(!r){t.setProperty("endDate",a._createLocalDate(new Date(E.getTime())),true);}}j.call(this,S,E);}else{j.call(this,p);t.setProperty("startDate",a._createLocalDate(new Date(p.getTime())),true);t.setProperty("endDate",undefined,true);}}else{if(this.getIntervalSelection()){throw new Error("Calender don't support multiple interval selection");}else{var w=this._checkDateSelected(p);if(w>0){for(i=0;i<s.length;i++){S=s[i].getStartDate();if(S&&p.getTime()==a._createUniversalUTCDate(S,v).getTime()){A.removeAggregation("selectedDates",i,true);break;}}}else{t=new sap.ui.unified.DateRange({startDate:a._createLocalDate(new Date(p.getTime()))});A.addAggregation("selectedDates",t,true);}y=this._oFormatYyyymmdd.format(p.getJSDate(),true);for(i=0;i<u.length;i++){$=q(u[i]);if($.attr("data-sap-day")==y){if(w>0){$.removeClass("sapUiCalItemSel");$.attr("aria-selected","false");}else{$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");}}}}}return true;}
function j(s,E){var p=this._oItemNavigation.getItemDomRefs();var $;var i=0;var S=false;var r=false;if(!E){var y=this._oFormatYyyymmdd.format(s.getJSDate(),true);for(i=0;i<p.length;i++){$=q(p[i]);S=false;r=false;if($.attr("data-sap-day")==y){$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");S=true;}else if($.hasClass("sapUiCalItemSel")){$.removeClass("sapUiCalItemSel");$.attr("aria-selected","false");}if($.hasClass("sapUiCalItemSelStart")){$.removeClass("sapUiCalItemSelStart");}else if($.hasClass("sapUiCalItemSelBetween")){$.removeClass("sapUiCalItemSelBetween");}else if($.hasClass("sapUiCalItemSelEnd")){$.removeClass("sapUiCalItemSelEnd");}k.call(this,$,S,r);}}else{var t;for(i=0;i<p.length;i++){$=q(p[i]);S=false;r=false;t=this._newUniversalDate(this._oFormatYyyymmdd.parse($.attr("data-sap-day"),true));if(t.getTime()==s.getTime()){$.addClass("sapUiCalItemSelStart");S=true;$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");if(E&&t.getTime()==E.getTime()){$.addClass("sapUiCalItemSelEnd");r=true;}$.removeClass("sapUiCalItemSelBetween");}else if(E&&t.getTime()>s.getTime()&&t.getTime()<E.getTime()){$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");$.addClass("sapUiCalItemSelBetween");$.removeClass("sapUiCalItemSelStart");$.removeClass("sapUiCalItemSelEnd");}else if(E&&t.getTime()==E.getTime()){$.addClass("sapUiCalItemSelEnd");r=true;$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");$.removeClass("sapUiCalItemSelStart");$.removeClass("sapUiCalItemSelBetween");}else{if($.hasClass("sapUiCalItemSel")){$.removeClass("sapUiCalItemSel");$.attr("aria-selected","false");}if($.hasClass("sapUiCalItemSelStart")){$.removeClass("sapUiCalItemSelStart");}else if($.hasClass("sapUiCalItemSelBetween")){$.removeClass("sapUiCalItemSelBetween");}else if($.hasClass("sapUiCalItemSelEnd")){$.removeClass("sapUiCalItemSelEnd");}}k.call(this,$,S,r);}}}
function k($,s,E){if(!this.getIntervalSelection()){return;}var p="";var r=[];var t=this.getId();var u=false;p=$.attr("aria-describedby");if(p){r=p.split(" ");}var S=-1;var v=-1;for(var i=0;i<r.length;i++){var w=r[i];if(w==(t+"-Start")){S=i;}if(w==(t+"-End")){v=i;}}if(S>=0&&!s){r.splice(S,1);u=true;if(v>S){v--;}}if(v>=0&&!E){r.splice(v,1);u=true;}if(S<0&&s){r.push(t+"-Start");u=true;}if(v<0&&E){r.push(t+"-End");u=true;}if(u){p=r.join(" ");$.attr("aria-describedby",p);}}
function m(){if(this._bMouseMove){this._unbindMousemove(true);}this.fireSelect();}
function n(){if(!this._bNamesLengthChecked){var w;var W=this.$().find(".sapUiCalWH");var t=this._isMonthNameLong(W);var i=0;if(t){this._bLongWeekDays=false;var p=this._getLocaleData();var s=this._getFirstWeekDay();var r=p.getDaysStandAlone("narrow",this.getPrimaryCalendarType());for(i=0;i<W.length;i++){w=W[i];q(w).text(r[(i+s)%7]);}}else{this._bLongWeekDays=true;}this._bNamesLengthChecked=true;}}
function o(){this._sInvalidateMonth=undefined;g.call(this,this._bNoFocus);this._bDateRangeChanged=undefined;this._bNoFocus=undefined;}
return M;},true);
sap.ui.predefine('sap/ui/unified/calendar/MonthPicker',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/core/delegate/ItemNavigation','sap/ui/unified/library'],function(q,C,L,I,l){"use strict";
var M=C.extend("sap.ui.unified.calendar.MonthPicker",{metadata:{library:"sap.ui.unified",properties:{month:{type:"int",group:"Data",defaultValue:0},months:{type:"int",group:"Appearance",defaultValue:12},columns:{type:"int",group:"Appearance",defaultValue:3},primaryCalendarType:{type:"sap.ui.core.CalendarType",group:"Appearance"}},events:{select:{},pageChange:{}}}});
M.prototype.init=function(){var s=sap.ui.getCore().getConfiguration().getCalendarType();this.setProperty("primaryCalendarType",s);this._iMinMonth=0;this._iMaxMonth=11;};
M.prototype.onAfterRendering=function(){_.call(this);g.call(this);};
M.prototype.setMonth=function(m){this.setProperty("month",m,true);m=this.getProperty("month");if(m<0||m>11){throw new Error("Property month must be between 0 and 11; "+this);}if(this.getDomRef()){if(this.getMonths()<12){var s=this.getStartMonth();if(m>=s&&m<=s+this.getMonths()-1){f.call(this,m,true);this._oItemNavigation.focusItem(m-s);}else{h.call(this,m);}}else{f.call(this,m,true);this._oItemNavigation.focusItem(m);}}};
M.prototype._getLocale=function(){var p=this.getParent();if(p&&p._getLocale){return p._getLocale();}else if(!this._sLocale){this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();}return this._sLocale;};
M.prototype._getLocaleData=function(){var p=this.getParent();if(p&&p._getLocaleData){return p._getLocaleData();}else if(!this._oLocaleData){var s=this._getLocale();var o=new sap.ui.core.Locale(s);this._oLocaleData=L.getInstance(o);}return this._oLocaleData;};
M.prototype.onsapspace=function(E){E.preventDefault();};
M.prototype.onsapselect=function(E){var i=this._oItemNavigation.getFocusedIndex();var m=i+this.getStartMonth();if(m>=this._iMinMonth&&m<=this._iMaxMonth){f.call(this,m);this.fireSelect();}};
M.prototype.onmouseup=function(E){if(this._bMousedownChange){this._bMousedownChange=false;this.fireSelect();}};
M.prototype.onThemeChanged=function(){if(this._bNoThemeChange){return;}this._bNamesLengthChecked=undefined;var m=this._oItemNavigation.getItemDomRefs();this._bLongMonth=false;var o=this._getLocaleData();var b=o.getMonthsStandAlone("wide",this.getPrimaryCalendarType());for(var i=0;i<m.length;i++){var $=q(m[i]);$.text(b[i]);}g.call(this);};
M.prototype.nextPage=function(){var s=this.getStartMonth();var i=this._oItemNavigation.getFocusedIndex();var m=i+s;var b=this.getMonths();m=m+b;if(m>11){m=11;}h.call(this,m);return this;};
M.prototype.previousPage=function(){var s=this.getStartMonth();var i=this._oItemNavigation.getFocusedIndex();var m=i+s;var b=this.getMonths();m=m-b;if(m<0){m=0;}h.call(this,m);return this;};
M.prototype.setMinMax=function(m,b){if(m==this._iMinMonth&&b==this._iMaxMonth){return this;}m=parseInt(m,10);if(isNaN(m)||m<0||m>11){m=0;}b=parseInt(b,10);if(isNaN(b)||b<0||b>11){b=11;}if(m<=b){this._iMinMonth=m;this._iMaxMonth=b;}else{this._iMaxMonth=m;this._iMinMonth=b;}if(this.getDomRef()){var j=this._oItemNavigation.getItemDomRefs();var k=this.getId().length+2;for(var i=0;i<j.length;i++){var D=q(j[i]);var n=parseInt(D.attr("id").slice(k),10);if(n<this._iMinMonth||n>this._iMaxMonth){D.addClass("sapUiCalItemDsbl");D.attr("aria-disabled",true);}else{D.removeClass("sapUiCalItemDsbl");D.removeAttr("aria-disabled");}}}return this;};
M.prototype.getStartMonth=function(){if(this.getMonths()<12){var F=this._oItemNavigation.getItemDomRefs()[0];return parseInt(F.id.slice(this.getId().length+2),10);}else{return 0;}};
function _(){var r=this.getDomRef();var D=this.$().find(".sapUiCalItem");var i=this.getColumns();var m=this.getMonths();var b=true;if(m<12){b=false;}if(!this._oItemNavigation){this._oItemNavigation=new I();this._oItemNavigation.attachEvent(I.Events.AfterFocus,a,this);this._oItemNavigation.attachEvent(I.Events.FocusAgain,c,this);this._oItemNavigation.attachEvent(I.Events.BorderReached,e,this);this.addDelegate(this._oItemNavigation);this._oItemNavigation.setHomeEndColumnMode(true,true);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"],saphome:["alt"],sapend:["alt"]});}this._oItemNavigation.setRootDomRef(r);this._oItemNavigation.setItemDomRefs(D);this._oItemNavigation.setCycling(b);this._oItemNavigation.setColumns(i,!b);var j=this.getMonth()-this.getStartMonth();this._oItemNavigation.setFocusedIndex(j);this._oItemNavigation.setPageSize(D.length);}
function a(o){var i=o.getParameter("index");var E=o.getParameter("event");if(!E){return;}if(E.type=="mousedown"){d.call(this,E,i);}}
function c(o){var i=o.getParameter("index");var E=o.getParameter("event");if(!E){return;}if(E.type=="mousedown"){d.call(this,E,i);}}
function d(E,i){if(E.button){return;}var m=i+this.getStartMonth();if(m>=this._iMinMonth&&m<=this._iMaxMonth){f.call(this,m);this._bMousedownChange=true;}E.preventDefault();E.setMark("cancelAutoClose");}
function e(o){var E=o.getParameter("event");if(E.type){var s=this.getStartMonth();var i=this._oItemNavigation.getFocusedIndex();var m=i+s;var b=this.getMonths();switch(E.type){case"sapnext":case"sapnextmodifiers":if(m<11){m++;h.call(this,m,true);}break;case"sapprevious":case"sappreviousmodifiers":if(m>0){m--;h.call(this,m,true);}break;case"sappagedown":if(m<12-b){m=m+b;h.call(this,m,true);}break;case"sappageup":if(m>b){m=m-b;h.call(this,m,true);}break;default:break;}}}
function f(m,n){var D=this._oItemNavigation.getItemDomRefs();var $;var s=this.getId()+"-m"+m;for(var i=0;i<D.length;i++){$=q(D[i]);if($.attr("id")==s){$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");}else{$.removeClass("sapUiCalItemSel");$.attr("aria-selected","false");}}if(!n){this.setProperty("month",m,true);}}
function g(){if(!this._bNamesLengthChecked){var i=0;var m=this._oItemNavigation.getItemDomRefs();var t=false;var j=this.getMonths();var B=Math.ceil(12/j);var k=j-1;for(var b=0;b<B;b++){if(j<12){h.call(this,k);k=k+j;if(k>11){k=11;}}for(i=0;i<m.length;i++){var o=m[i];if(Math.abs(o.clientWidth-o.scrollWidth)>1){t=true;break;}}if(t){break;}}if(j<12){k=this.getMonth();h.call(this,k);}if(t){this._bLongMonth=false;var n=this._getLocaleData();var s=this.getPrimaryCalendarType();var p=n.getMonthsStandAlone("abbreviated",s);var r=n.getMonthsStandAlone("wide",s);for(i=0;i<m.length;i++){var $=q(m[i]);$.text(p[i]);$.attr("aria-label",r[i]);}}else{this._bLongMonth=true;}this._bNamesLengthChecked=true;}}
function h(m,F){var b=this._oItemNavigation.getItemDomRefs();if(b.legth>11){return;}var j=b.length;var s=Math.floor(m/j)*j;if(s+j>12){s=12-j;}var o=this._getLocaleData();var k=[];var n=[];var p=this.getPrimaryCalendarType();if(this._bLongMonth||!this._bNamesLengthChecked){k=o.getMonthsStandAlone("wide",p);}else{k=o.getMonthsStandAlone("abbreviated",p);n=o.getMonthsStandAlone("wide",p);}var S=this.getMonth();for(var i=0;i<b.length;i++){var r=i+s;var D=q(b[i]);D.text(k[i+s]);D.attr("id",this.getId()+"-m"+(i+s));if(!this._bLongMonth){D.attr("aria-label",n[i+s]);}if(r==S){D.addClass("sapUiCalItemSel");D.attr("aria-selected","true");}else{D.removeClass("sapUiCalItemSel");D.attr("aria-selected","false");}if(r<this._iMinMonth||r>this._iMaxMonth){D.addClass("sapUiCalItemDsbl");D.attr("aria-disabled",true);}else{D.removeClass("sapUiCalItemDsbl");D.removeAttr("aria-disabled");}}this._oItemNavigation.focusItem(m-s);if(F){this.firePageChange();}}
return M;},true);
sap.ui.predefine('sap/ui/unified/calendar/MonthPickerRenderer',['jquery.sap.global'],function(q){"use strict";var M={};
M.render=function(r,m){var a=m.getMonth();var b=m.getMonths();var s=0;var c=m.getColumns();var t=m.getTooltip_AsString();var l=m._getLocaleData();var I=m.getId();var w="";var d=[];var e=[];var C=m.getPrimaryCalendarType();if(m._bLongMonth||!m._bNamesLengthChecked){d=l.getMonthsStandAlone("wide",C);}else{d=l.getMonthsStandAlone("abbreviated",C);e=l.getMonthsStandAlone("wide",C);}r.write("<div");r.writeControlData(m);r.addClass("sapUiCalMonthPicker");r.writeClasses();if(t){r.writeAttributeEscaped('title',t);}r.writeAccessibilityState(m,{role:"grid",readonly:"true",multiselectable:"false"});r.write(">");var A;if(b>12){b=12;}else if(b<12){s=Math.floor(a/b)*b;if(s+b>12){s=12-b;}}if(c>0){w=(100/c)+"%";}else{w=(100/b)+"%";}for(var i=0;i<b;i++){var f=i+s;A={role:"gridcell"};if(!m._bLongMonth&&m._bNamesLengthChecked){A["label"]=e[f];}if(c>0&&i%c==0){r.write("<div");r.writeAccessibilityState(null,{role:"row"});r.write(">");}r.write("<div");r.writeAttribute("id",I+"-m"+(f));r.addClass("sapUiCalItem");if(f==a){r.addClass("sapUiCalItemSel");A["selected"]=true;}else{A["selected"]=false;}if(f<m._iMinMonth||f>m._iMaxMonth){r.addClass("sapUiCalItemDsbl");A["disabled"]=true;}r.writeAttribute("tabindex","-1");r.addStyle("width",w);r.writeClasses();r.writeStyles();r.writeAccessibilityState(null,A);r.write(">");r.write(d[f]);r.write("</div>");if(c>0&&((i+1)%c==0)){r.write("</div>");}}r.write("</div>");};
return M;},true);
sap.ui.predefine('sap/ui/unified/calendar/MonthRenderer',['jquery.sap.global','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate'],function(q,C,U){"use strict";var M={};
M.render=function(r,m){var d=this.getStartDate(m);var t=m.getTooltip_AsString();var a=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");var i=m.getId();var A={value:i+"-Descr",append:true};var w=m.getWidth();r.write("<div");r.writeControlData(m);r.addClass(this.getClass(m));if(m._getSecondaryCalendarType()){r.addClass("sapUiCalMonthSecType");}r.writeClasses();if(t){r.writeAttributeEscaped("title",t);}if(m._getShowHeader()){A.value=A.value+" "+i+"-Head";}if(w){r.addStyle("width",w);r.writeStyles();}r.writeAccessibilityState(m,{role:"grid",readonly:"true",multiselectable:!m.getSingleSelection()||m.getIntervalSelection(),labelledby:A});r.write(">");r.write("<span id=\""+i+"-Descr\" style=\"display: none;\">"+a.getText("CALENDAR_DIALOG")+"</span>");if(m.getIntervalSelection()){r.write("<span id=\""+i+"-Start\" style=\"display: none;\">"+a.getText("CALENDAR_START_DATE")+"</span>");r.write("<span id=\""+i+"-End\" style=\"display: none;\">"+a.getText("CALENDAR_END_DATE")+"</span>");}this.renderMonth(r,m,d);r.write("</div>");};
M.getStartDate=function(m){return m._getDate();};
M.getClass=function(m){var c="sapUiCalMonthView";var s=m.getPrimaryCalendarType();if(s==sap.ui.core.CalendarType.Islamic){c=c+" sapUiCalNoWeekNum";}return c;};
M.renderMonth=function(r,m,d){var i=m.getId();this.renderHeader(r,m,d);r.write("<div id=\""+i+"-days\" class=\"sapUiCalItems\">");this.renderDays(r,m,d);r.write("</div>");};
M.renderHeader=function(r,m,d){var l=m._getLocaleData();var f=m._getFirstDayOfWeek();var i=m.getId();var a=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");this.renderHeaderLine(r,m,l,d);r.write("<div");r.writeAttribute("id",i+"-CW");r.addStyle("display","none");r.writeStyles();r.writeAccessibilityState(null,{role:"columnheader"});r.write(">");r.write(a.getText("CALENDAR_WEEK"));r.write("</div>");r.write("<div");r.writeAccessibilityState(null,{role:"row"});r.write(">");this.renderDayNames(r,m,l,f,7,true,undefined);r.write("</div>");};
M.renderHeaderLine=function(r,m,l,d){if(m._getShowHeader()){var i=m.getId();var c=m.getPrimaryCalendarType();var a=l.getMonthsStandAlone("wide",c);r.write("<div id=\""+i+"-Head\"class=\"sapUiCalHeadText\" >");r.write(a[d.getUTCMonth()]);r.write("</div>");}};
M.renderDayNames=function(r,m,l,s,d,D,w){var f=m._getFirstDayOfWeek();var I=m.getId();var a="";var c=m.getPrimaryCalendarType();var W=[];if(m._bLongWeekDays||!m._bNamesLengthChecked){W=l.getDaysStandAlone("abbreviated",c);}else{W=l.getDaysStandAlone("narrow",c);}var b=l.getDaysStandAlone("wide",c);for(var i=0;i<d;i++){r.write("<div");r.addClass("sapUiCalWH");if(D){a=I+"-WH"+((i+f)%7);}else{a=I+"-WH"+i;}r.writeAttribute("id",a);if(i==0){r.addClass("sapUiCalFirstWDay");}if(w){r.addStyle("width",w);}r.writeAccessibilityState(null,{role:"columnheader",label:b[(i+s)%7]});r.writeClasses();r.writeStyles();r.write(">");r.write(W[(i+s)%7]);r.write("</div>");}};
M.renderDays=function(r,m,d){if(!d){d=m._getFocusedDate();}if(!d.getTime()&&d.getTime()!==0){throw new Error("Date is invalid "+m);}var i=d.getUTCMonth();var h=this.getDayHelper(m,d);var c=m.getPrimaryCalendarType();var w=c!=sap.ui.core.CalendarType.Islamic;var f=m._newUniversalDate(d);f.setUTCDate(1);var W=f.getUTCDay();var D=W-h.iFirstDayOfWeek;if(D<0){D=7+D;}if(D>0){f.setUTCDate(1-D);}var o=m._newUniversalDate(f);var n=(i+1)%12;do{W=o.getUTCDay();if(W==h.iFirstDayOfWeek){r.write("<div");r.writeAccessibilityState(null,{role:"row"});r.write(">");}this.renderDay(r,m,o,h,true,w,-1,undefined,false);if(W==(h.iFirstDayOfWeek+6)%7){r.write("</div>");}o.setUTCDate(o.getUTCDate()+1);}while(o.getUTCMonth()!=n||o.getUTCDay()!=h.iFirstDayOfWeek);};
M.getDayHelper=function(m,d){var h={};h.sLocale=m._getLocale();h.oLocaleData=m._getLocaleData();h.iMonth=d.getUTCMonth();h.iYear=d.getUTCFullYear();h.iFirstDayOfWeek=m._getFirstDayOfWeek();h.iWeekendStart=h.oLocaleData.getWeekendStart();h.iWeekendEnd=h.oLocaleData.getWeekendEnd();h.aNonWorkingDays=m._getNonWorkingDays();h.sToday=h.oLocaleData.getRelativeDay(0);h.oToday=C._createUniversalUTCDate(new Date(),m.getPrimaryCalendarType());h.sId=m.getId();h.oFormatLong=m._getFormatLong();h.sSecondaryCalendarType=m._getSecondaryCalendarType();var l=m.getLegend();if(l){var L=sap.ui.getCore().byId(l);if(L){if(!(L instanceof sap.ui.unified.CalendarLegend)){throw new Error(L+" is not a sap.ui.unified.CalendarLegend. "+m);}h.aTypes=L.getItems();}else{q.sap.log.warning("CalendarLegend "+l+" does not exist!",m);}}else{h.aTypes=[];}return h;};
M.renderDay=function(r,m,d,h,o,w,n,W,D){var s=U.getInstance(d.getJSDate(),h.sSecondaryCalendarType),a={role:"gridcell",selected:false,label:"",describedby:""};var y=m._oFormatYyyymmdd.format(d.getJSDate(),true);var b=d.getUTCDay();var S=m._checkDateSelected(d);var t=m._getDateType(d);var e=m._checkDateEnabled(d);var i=0;var c=0;if(w){c=C.calculateWeekNumber(d,h.iYear,h.sLocale,h.oLocaleData);a["describedby"]=h.sId+"-CW"+" "+h.sId+"-WNum-"+c;}if(!D){var f="";if(n<0){f=h.sId+"-WH"+b;}else{f=h.sId+"-WH"+n;}a["describedby"]=a["describedby"]+" "+f;}r.write("<div");r.writeAttribute("id",h.sId+"-"+y);r.addClass("sapUiCalItem");r.addClass("sapUiCalWDay"+b);if(W){r.addStyle("width",W);}if(b==h.iFirstDayOfWeek){r.addClass("sapUiCalFirstWDay");}if(o&&h.iMonth!=d.getUTCMonth()){r.addClass("sapUiCalItemOtherMonth");a["disabled"]=true;}if(d.getUTCMonth()==h.oToday.getUTCMonth()&&d.getUTCFullYear()==h.oToday.getUTCFullYear()&&d.getUTCDate()==h.oToday.getUTCDate()){r.addClass("sapUiCalItemNow");a["label"]=h.sToday+" ";}if(S>0){r.addClass("sapUiCalItemSel");a["selected"]=true;}else{a["selected"]=false;}if(S==2){r.addClass("sapUiCalItemSelStart");a["describedby"]=a["describedby"]+" "+h.sId+"-Start";}else if(S==3){r.addClass("sapUiCalItemSelEnd");a["describedby"]=a["describedby"]+" "+h.sId+"-End";}else if(S==4){r.addClass("sapUiCalItemSelBetween");}else if(S==5){r.addClass("sapUiCalItemSelStart");r.addClass("sapUiCalItemSelEnd");a["describedby"]=a["describedby"]+" "+h.sId+"-Start";a["describedby"]=a["describedby"]+" "+h.sId+"-End";}if(t&&t.type!=sap.ui.unified.CalendarDayType.None){r.addClass("sapUiCalItem"+t.type);if(t.tooltip){r.writeAttributeEscaped('title',t.tooltip);}}if(!e){r.addClass("sapUiCalItemDsbl");a["disabled"]=true;}if(h.aNonWorkingDays){for(i=0;i<h.aNonWorkingDays.length;i++){if(b==h.aNonWorkingDays[i]){r.addClass("sapUiCalItemWeekEnd");break;}}}else if((b>=h.iWeekendStart&&b<=h.iWeekendEnd)||(h.iWeekendEnd<h.iWeekendStart&&(b>=h.iWeekendStart||b<=h.iWeekendEnd))){r.addClass("sapUiCalItemWeekEnd");}r.writeAttribute("tabindex","-1");r.writeAttribute("data-sap-day",y);if(D){a["label"]=a["label"]+h.aWeekDaysWide[b]+" ";}a["label"]=a["label"]+h.oFormatLong.format(d,true);if(t&&t.type!=sap.ui.unified.CalendarDayType.None){for(i=0;i<h.aTypes.length;i++){var l=h.aTypes[i];if(l.getType()==t.type){a["label"]=a["label"]+"; "+l.getText();break;}}}if(h.sSecondaryCalendarType){a["label"]=a["label"]+" "+m._oFormatSecondaryLong.format(s,true);}r.writeAccessibilityState(null,a);r.writeClasses();r.writeStyles();r.write(">");r.write("<span");r.addClass("sapUiCalItemText");r.writeClasses();r.write(">");r.write(d.getUTCDate());r.write("</span>");if(w&&b==h.iFirstDayOfWeek){r.write("<span");r.writeAttribute("id",h.sId+"-WNum-"+c);r.addClass("sapUiCalWeekNum");r.writeClasses();r.writeAccessibilityState(null,{role:"rowheader",desribedby:h.sId+"-CW"});r.write(">");r.write(c);r.write("</span>");}if(D){r.write("<span");r.addClass("sapUiCalDayName");r.writeClasses();r.write(">");r.write(h.aWeekDays[b]);r.write("</span>");}if(h.sSecondaryCalendarType){r.write("<span");r.addClass("sapUiCalItemSecText");r.writeClasses();r.write(">");r.write(s.getUTCDate());r.write("</span>");}r.write("</div>");};
return M;},true);
sap.ui.predefine('sap/ui/unified/calendar/MonthsRow',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/core/delegate/ItemNavigation','sap/ui/model/type/Date','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate','sap/ui/unified/library'],function(q,C,L,I,D,a,U,l){"use strict";
var M=C.extend("sap.ui.unified.calendar.MonthsRow",{metadata:{library:"sap.ui.unified",properties:{date:{type:"object",group:"Data"},startDate:{type:"object",group:"Data"},months:{type:"int",group:"Appearance",defaultValue:12},intervalSelection:{type:"boolean",group:"Behavior",defaultValue:false},singleSelection:{type:"boolean",group:"Behavior",defaultValue:true},showHeader:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{selectedDates:{type:"sap.ui.unified.DateRange",multiple:true,singularName:"selectedDate"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.ui.unified.CalendarLegend",multiple:false}},events:{select:{},focus:{parameters:{date:{type:"object"},notVisible:{type:"boolean"}}}}}});
M.prototype.init=function(){this._oFormatYyyymm=sap.ui.core.format.DateFormat.getInstance({pattern:"yyyyMMdd",calendarType:sap.ui.core.CalendarType.Gregorian});this._oFormatLong=sap.ui.core.format.DateFormat.getInstance({pattern:"MMMM y"});this._mouseMoveProxy=q.proxy(this._handleMouseMove,this);this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");};
M.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}if(this._sInvalidateMonths){q.sap.clearDelayedCall(this._sInvalidateMonths);}};
M.prototype.onAfterRendering=function(){_.call(this);r.call(this);};
M.prototype.onsapfocusleave=function(E){if(!E.relatedControlId||!q.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(E.relatedControlId).getFocusDomRef())){if(this._bMouseMove){u.call(this,true);m.call(this,this._getDate());this._bMoveChange=false;this._bMousedownChange=false;p.call(this);}if(this._bMousedownChange){this._bMousedownChange=false;p.call(this);}}};
M.prototype.invalidate=function(O){if(!this._bDateRangeChanged&&(!O||!(O instanceof sap.ui.unified.DateRange))){C.prototype.invalidate.apply(this,arguments);}else if(this.getDomRef()&&!this._sInvalidateMonths){if(this._bInvalidateSync){s.call(this);}else{this._sInvalidateMonths=q.sap.delayedCall(0,this,s);}}};
M.prototype.removeAllSelectedDates=function(){this._bDateRangeChanged=true;var R=this.removeAllAggregation("selectedDates");return R;};
M.prototype.destroySelectedDates=function(){this._bDateRangeChanged=true;var b=this.destroyAggregation("selectedDates");return b;};
M.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=true;var R=this.removeAllAggregation("specialDates");return R;};
M.prototype.destroySpecialDates=function(){this._bDateRangeChanged=true;var b=this.destroyAggregation("specialDates");return b;};
M.prototype.setDate=function(b){g.call(this,b,false);return this;};
M.prototype._setDate=function(b){var i=a._createLocalDate(b);this.setProperty("date",i,true);this._oUTCDate=b;};
M.prototype._getDate=function(){if(!this._oUTCDate){this._oUTCDate=a._createUniversalUTCDate(new Date());}return this._oUTCDate;};
M.prototype.setStartDate=function(S){if(!(S instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var y=S.getFullYear();if(y<1||y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}var b=a._createUniversalUTCDate(S);this.setProperty("startDate",S,true);this._oUTCStartDate=b;this._oUTCStartDate.setUTCDate(1);if(this.getDomRef()){var O=a._createLocalDate(this._getDate());this._bNoRangeCheck=true;this.displayDate(S);this._bNoRangeCheck=false;if(O&&this.checkDateFocusable(O)){this.setDate(O);}}return this;};
M.prototype._getStartDate=function(){if(!this._oUTCStartDate){this._oUTCStartDate=a._createUniversalUTCDate(new Date());this._oUTCStartDate.setUTCDate(1);}return this._oUTCStartDate;};
M.prototype.displayDate=function(b){g.call(this,b,true);return this;};
M.prototype._getLocale=function(){var P=this.getParent();if(P&&P.getLocale){return P.getLocale();}else if(!this._sLocale){this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();}return this._sLocale;};
M.prototype._getLocaleData=function(){var P=this.getParent();if(P&&P._getLocaleData){return P._getLocaleData();}else if(!this._oLocaleData){var b=this._getLocale();var i=new sap.ui.core.Locale(b);this._oLocaleData=L.getInstance(i);}return this._oLocaleData;};
M.prototype._getFormatLong=function(){var b=this._getLocale();if(this._oFormatLong.oLocale.toString()!=b){var i=new sap.ui.core.Locale(b);this._oFormatLong=sap.ui.core.format.DateFormat.getInstance({style:"long"},i);}return this._oFormatLong;};
M.prototype.getIntervalSelection=function(){var P=this.getParent();if(P&&P.getIntervalSelection){return P.getIntervalSelection();}else{return this.getProperty("intervalSelection");}};
M.prototype.getSingleSelection=function(){var P=this.getParent();if(P&&P.getSingleSelection){return P.getSingleSelection();}else{return this.getProperty("singleSelection");}};
M.prototype.getSelectedDates=function(){var P=this.getParent();if(P&&P.getSelectedDates){return P.getSelectedDates();}else{return this.getAggregation("selectedDates",[]);}};
M.prototype.getSpecialDates=function(){var P=this.getParent();if(P&&P.getSpecialDates){return P.getSpecialDates();}else{return this.getAggregation("specialDates",[]);}};
M.prototype._getShowHeader=function(){var P=this.getParent();if(P&&P._getShowItemHeader){return P._getShowItemHeader();}else{return this.getProperty("showHeader");}};
M.prototype.getAriaLabelledBy=function(){var P=this.getParent();if(P&&P.getAriaLabelledBy){return P.getAriaLabelledBy();}else{return this.getAssociation("ariaLabelledBy",[]);}};
M.prototype.getLegend=function(){var P=this.getParent();if(P&&P.getLegend){return P.getLegend();}else{return this.getAssociation("ariaLabelledBy",[]);}};
M.prototype._checkDateSelected=function(b){if(!(b instanceof U)){throw new Error("Date must be a UniversalDate object "+this);}var S=0;var v=this.getSelectedDates();var w=new U(b.getTime());w.setUTCDate(1);var T=w.getTime();for(var i=0;i<v.length;i++){var R=v[i];var x=R.getStartDate();var y=0;if(x){x=a._createUniversalUTCDate(x);x.setUTCDate(1);y=x.getTime();}var E=R.getEndDate();var z=0;if(E){E=a._createUniversalUTCDate(E);E.setUTCDate(1);z=E.getTime();}if(T==y&&!E){S=1;break;}else if(T==y&&E){S=2;if(E&&T==z){S=5;}break;}else if(E&&T==z){S=3;break;}else if(E&&T>y&&T<z){S=4;break;}if(this.getSingleSelection()){break;}}return S;};
M.prototype._getDateType=function(b){if(!(b instanceof U)){throw new Error("Date must be a UniversalDate object "+this);}var T;var S=this.getSpecialDates();var v=new U(b.getTime());v.setUTCDate(1);var w=v.getTime();for(var i=0;i<S.length;i++){var R=S[i];var x=R.getStartDate();var y=0;if(x){x=a._createUniversalUTCDate(x);x.setUTCDate(1);y=x.getTime();}var E=R.getEndDate();var z=0;if(E){E=a._createUniversalUTCDate(E);E.setUTCDate(1);E.setUTCMonth(E.getUTCMonth()+1);E.setUTCDate(0);z=E.getTime();}if((w==y&&!E)||(w>=y&&w<=z)){T={type:R.getType(),tooltip:R.getTooltip_AsString()};break;}}return T;};
M.prototype._checkMonthEnabled=function(b){if(!(b instanceof U)){throw new Error("Date must be a UniversalDate object "+this);}var T=b.getTime();var P=this.getParent();if(P&&P._oMinDate&&P._oMaxDate){if(T<P._oMinDate.getTime()||T>P._oMaxDate.getTime()){return false;}}return true;};
M.prototype._handleMouseMove=function(E){if(!this.$().is(":visible")){u.call(this,true);}var T=q(E.target);if(T.hasClass("sapUiCalItemText")){T=T.parent();}if(T.hasClass("sapUiCalItem")){var O=this._getDate();var F=new U(this._oFormatYyyymm.parse(T.attr("data-sap-month"),true).getTime());F.setUTCDate(1);if(F.getTime()!=O.getTime()){this._setDate(F);m.call(this,F,true);this._bMoveChange=true;}}};
M.prototype.onmouseup=function(E){if(this._bMouseMove){u.call(this,true);var F=this._getDate();var b=this._oItemNavigation.getItemDomRefs();for(var i=0;i<b.length;i++){var $=q(b[i]);if($.attr("data-sap-month")==this._oFormatYyyymm.format(F.getJSDate(),true)){$.focus();break;}}if(this._bMoveChange){var T=q(E.target);if(T.hasClass("sapUiCalItemText")){T=T.parent();}if(T.hasClass("sapUiCalItem")){F=new U(this._oFormatYyyymm.parse(T.attr("data-sap-month"),true).getTime());F.setUTCDate(1);}m.call(this,F);this._bMoveChange=false;this._bMousedownChange=false;p.call(this);}}if(this._bMousedownChange){this._bMousedownChange=false;p.call(this);}};
M.prototype.onsapselect=function(E){var S=m.call(this,this._getDate());if(S){p.call(this);}E.stopPropagation();E.preventDefault();};
M.prototype.onsapselectmodifiers=function(E){this.onsapselect(E);};
M.prototype.onsappageupmodifiers=function(E){var F=new U(this._getDate().getTime());var y=F.getUTCFullYear();if(E.metaKey||E.ctrlKey){F.setUTCFullYear(y-10);}else{var i=this.getMonths();if(i<=12){F.setUTCFullYear(y-1);}else{F.setUTCMonths(F.getUTCMonth()-i);}}this.fireFocus({date:a._createLocalDate(F),notVisible:true});E.preventDefault();};
M.prototype.onsappagedownmodifiers=function(E){var F=new U(this._getDate().getTime());var y=F.getUTCFullYear();if(E.metaKey||E.ctrlKey){F.setUTCFullYear(y+10);}else{var i=this.getMonths();if(i<=12){F.setUTCFullYear(y+1);}else{F.setUTCMonths(F.getUTCMonth()+i);}}this.fireFocus({date:a._createLocalDate(F),notVisible:true});E.preventDefault();};
M.prototype.onThemeChanged=function(){if(this._bNoThemeChange){return;}this._bNamesLengthChecked=undefined;this._bLongWeekDays=undefined;var b=this._getLocaleData();var v=b.getMonthsStandAlone("wide");var w=this.$("months").children();var x=this._getStartDate().getUTCMonth();for(var i=0;i<w.length;i++){var $=q(q(w[i]).children(".sapUiCalItemText"));$.text(v[(i+x)%12]);}r.call(this);};
M.prototype.checkDateFocusable=function(b){if(!(b instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}if(this._bNoRangeCheck){return false;}var S=this._getStartDate();var E=new U(S.getTime());E.setUTCDate(1);E.setUTCMonth(E.getUTCMonth()+this.getMonths());var i=a._createUniversalUTCDate(b);if(i.getTime()>=S.getTime()&&i.getTime()<E.getTime()){return true;}else{return false;}};
function _(){var b=this._getDate();var y=this._oFormatYyyymm.format(b.getJSDate(),true);var v=0;var R=this.$("months").get(0);var w=this.$("months").children(".sapUiCalItem");for(var i=0;i<w.length;i++){var $=q(w[i]);if($.attr("data-sap-month")===y){v=i;break;}}if(!this._oItemNavigation){this._oItemNavigation=new I();this._oItemNavigation.attachEvent(I.Events.AfterFocus,c,this);this._oItemNavigation.attachEvent(I.Events.FocusAgain,d,this);this._oItemNavigation.attachEvent(I.Events.BorderReached,e,this);this.addDelegate(this._oItemNavigation);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"],saphome:["alt"],sapend:["alt"]});this._oItemNavigation.setCycling(false);this._oItemNavigation.setColumns(1,true);}this._oItemNavigation.setRootDomRef(R);this._oItemNavigation.setItemDomRefs(w);this._oItemNavigation.setFocusedIndex(v);this._oItemNavigation.setPageSize(w.length);}
function c(b){var i=b.getParameter("index");var E=b.getParameter("event");if(!E){return;}var O=this._getDate();var F=new U(O.getTime());var v=this._oItemNavigation.getItemDomRefs();var $=q(v[i]);F=new U(this._oFormatYyyymm.parse($.attr("data-sap-month"),true).getTime());F.setUTCDate(1);this._setDate(F);this.fireFocus({date:a._createLocalDate(F),notVisible:false});if(E.type=="mousedown"){f.call(this,E,F,i);}}
function d(b){var i=b.getParameter("index");var E=b.getParameter("event");if(!E){return;}if(E.type=="mousedown"){var F=this._getDate();f.call(this,E,F,i);}}
function e(b){var E=b.getParameter("event");var i=this.getMonths();var O=this._getDate();var F=new U(O.getTime());if(E.type){switch(E.type){case"sapnext":case"sapnextmodifiers":F.setUTCMonth(F.getUTCMonth()+1);break;case"sapprevious":case"sappreviousmodifiers":F.setUTCMonth(F.getUTCMonth()-1);break;case"sappagedown":F.setUTCMonth(F.getUTCMonth()+i);break;case"sappageup":F.setUTCMonth(F.getUTCMonth()-i);break;default:break;}this.fireFocus({date:a._createLocalDate(F),notVisible:true});}}
function f(E,F,i){if(E.button){return;}var S=m.call(this,F);if(S){this._bMousedownChange=true;}if(this._bMouseMove){u.call(this,true);this._bMoveChange=false;}else if(S&&this.getIntervalSelection()&&this.$().is(":visible")){t.call(this,true);}E.preventDefault();E.setMark("cancelAutoClose");}
function g(b,N){if(!(b instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var y=b.getFullYear();if(y<1||y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}var F=true;if(!q.sap.equal(this.getDate(),b)){var i=a._createUniversalUTCDate(b);i.setUTCDate(1);F=this.checkDateFocusable(b);if(!this._bNoRangeCheck&&!F){throw new Error("Date must be in visible date range; "+this);}this.setProperty("date",b,true);this._oUTCDate=i;}if(this.getDomRef()){if(F){h.call(this,this._oUTCDate,N);}else{j.call(this,N);}}}
function h(b,N){var y=this._oFormatYyyymm.format(b.getJSDate(),true);var v=this._oItemNavigation.getItemDomRefs();var $;for(var i=0;i<v.length;i++){$=q(v[i]);if($.attr("data-sap-month")==y){if(document.activeElement!=v[i]){if(N){this._oItemNavigation.setFocusedIndex(i);}else{this._oItemNavigation.focusItem(i);}}break;}}}
function j(N){var b=this._getStartDate();var $=this.$("months");if($.length>0){var R=sap.ui.getCore().createRenderManager();this.getRenderer().renderMonths(R,this,b);R.flush($[0]);R.destroy();}k.call(this);_.call(this);if(!N){this._oItemNavigation.focusItem(this._oItemNavigation.getFocusedIndex());}}
function k(){var S=this._getStartDate();if(this._getShowHeader()){var $=this.$("Head");if($.length>0){var b=this._getLocaleData();var R=sap.ui.getCore().createRenderManager();this.getRenderer().renderHeaderLine(R,this,b,S);R.flush($[0]);R.destroy();}}}
function m(b,v){if(!this._checkMonthEnabled(b)){return false;}var S=this.getSelectedDates();var w;var x=this._oItemNavigation.getItemDomRefs();var $;var y;var i=0;var P=this.getParent();var A=this;var z;if(P&&P.getSelectedDates){A=P;}if(this.getSingleSelection()){if(S.length>0){w=S[0];z=w.getStartDate();if(z){z=a._createUniversalUTCDate(z);z.setUTCDate(1);}}else{w=new sap.ui.unified.DateRange();A.addAggregation("selectedDates",w,true);}if(this.getIntervalSelection()&&(!w.getEndDate()||v)&&z){var E;if(b.getTime()<z.getTime()){E=z;z=b;if(!v){w.setProperty("startDate",a._createLocalDate(new Date(z.getTime())),true);w.setProperty("endDate",a._createLocalDate(new Date(E.getTime())),true);}}else if(b.getTime()>=z.getTime()){E=b;if(!v){w.setProperty("endDate",a._createLocalDate(new Date(E.getTime())),true);}}n.call(this,z,E);}else{n.call(this,b);w.setProperty("startDate",a._createLocalDate(new Date(b.getTime())),true);w.setProperty("endDate",undefined,true);}}else{if(this.getIntervalSelection()){throw new Error("Calender don't support multiple interval selection");}else{var B=this._checkDateSelected(b);if(B>0){for(i=0;i<S.length;i++){z=S[i].getStartDate();if(z){z=a._createUniversalUTCDate(z);z.setUTCDate(1);if(b.getTime()==z.getTime()){A.removeAggregation("selectedDates",i,true);break;}}}}else{w=new sap.ui.unified.DateRange({startDate:a._createLocalDate(new Date(b.getTime()))});A.addAggregation("selectedDates",w,true);}y=this._oFormatYyyymm.format(b.getJSDate(),true);for(i=0;i<x.length;i++){$=q(x[i]);if($.attr("data-sap-month")==y){if(B>0){$.removeClass("sapUiCalItemSel");$.attr("aria-selected","false");}else{$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");}}}}}return true;}
function n(S,E){var b=this._oItemNavigation.getItemDomRefs();var $;var i=0;var v=false;var w=false;if(!E){var y=this._oFormatYyyymm.format(S.getJSDate(),true);for(i=0;i<b.length;i++){$=q(b[i]);v=false;w=false;if($.attr("data-sap-month")==y){$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");v=true;}else if($.hasClass("sapUiCalItemSel")){$.removeClass("sapUiCalItemSel");$.attr("aria-selected","false");}if($.hasClass("sapUiCalItemSelStart")){$.removeClass("sapUiCalItemSelStart");}else if($.hasClass("sapUiCalItemSelBetween")){$.removeClass("sapUiCalItemSelBetween");}else if($.hasClass("sapUiCalItemSelEnd")){$.removeClass("sapUiCalItemSelEnd");}o.call(this,$,v,w);}}else{var x;for(i=0;i<b.length;i++){$=q(b[i]);v=false;w=false;x=new U(this._oFormatYyyymm.parse($.attr("data-sap-month"),true).getTime());x.setUTCDate(1);if(x.getTime()==S.getTime()){$.addClass("sapUiCalItemSelStart");v=true;$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");if(E&&x.getTime()==E.getTime()){$.addClass("sapUiCalItemSelEnd");w=true;}$.removeClass("sapUiCalItemSelBetween");}else if(E&&x.getTime()>S.getTime()&&x.getTime()<E.getTime()){$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");$.addClass("sapUiCalItemSelBetween");$.removeClass("sapUiCalItemSelStart");$.removeClass("sapUiCalItemSelEnd");}else if(E&&x.getTime()==E.getTime()){$.addClass("sapUiCalItemSelEnd");w=true;$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");$.removeClass("sapUiCalItemSelStart");$.removeClass("sapUiCalItemSelBetween");}else{if($.hasClass("sapUiCalItemSel")){$.removeClass("sapUiCalItemSel");$.attr("aria-selected","false");}if($.hasClass("sapUiCalItemSelStart")){$.removeClass("sapUiCalItemSelStart");}else if($.hasClass("sapUiCalItemSelBetween")){$.removeClass("sapUiCalItemSelBetween");}else if($.hasClass("sapUiCalItemSelEnd")){$.removeClass("sapUiCalItemSelEnd");}}o.call(this,$,v,w);}}}
function o($,S,E){if(!this.getIntervalSelection()){return;}var b="";var v=[];var w=this.getId();var x=false;b=$.attr("aria-describedby");if(b){v=b.split(" ");}var y=-1;var z=-1;for(var i=0;i<v.length;i++){var A=v[i];if(A==(w+"-Start")){y=i;}if(A==(w+"-End")){z=i;}}if(y>=0&&!S){v.splice(y,1);x=true;if(z>y){z--;}}if(z>=0&&!E){v.splice(z,1);x=true;}if(y<0&&S){v.push(w+"-Start");x=true;}if(z<0&&E){v.push(w+"-End");x=true;}if(x){b=v.join(" ");$.attr("aria-describedby",b);}}
function p(){if(this._bMouseMove){u.call(this,true);}this.fireSelect();}
function r(){if(!this._bNamesLengthChecked){var i=0;var v=this.$("months").children();var T=false;var w=this.getMonths();var B=Math.ceil(12/w);var x=0;var y=this._getLocaleData();var z=y.getMonthsStandAlone("wide");var $;for(var b=0;b<B;b++){if(w<12){for(i=0;i<v.length;i++){$=q(q(v[i]).children(".sapUiCalItemText"));$.text(z[(i+x)%12]);}x=x+w;if(x>11){x=11;}}for(i=0;i<v.length;i++){var A=v[i];if(Math.abs(A.clientWidth-A.scrollWidth)>1){T=true;break;}}if(T){break;}}if(w<12){x=this._getStartDate().getUTCMonth();for(i=0;i<v.length;i++){$=q(q(v[i]).children(".sapUiCalItemText"));$.text(z[(i+x)%12]);}}if(T){this._bLongMonth=false;var E=y.getMonthsStandAlone("abbreviated");x=this._getStartDate().getUTCMonth();for(i=0;i<v.length;i++){$=q(q(v[i]).children(".sapUiCalItemText"));$.text(E[(i+x)%12]);}}else{this._bLongMonth=true;}this._bNamesLengthChecked=true;}}
function s(){this._sInvalidateMonths=undefined;j.call(this,this._bNoFocus);this._bDateRangeChanged=undefined;this._bNoFocus=undefined;}
function t(){q(window.document).bind('mousemove',this._mouseMoveProxy);this._bMouseMove=true;}
function u(){q(window.document).unbind('mousemove',this._mouseMoveProxy);this._bMouseMove=undefined;}
return M;},true);
sap.ui.predefine('sap/ui/unified/calendar/MonthsRowRenderer',['jquery.sap.global','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate'],function(q,C,U){"use strict";var M={};
M.render=function(r,m){var d=m._getStartDate();var t=m.getTooltip_AsString();var i=m.getId();var a={value:i+"-Descr",append:true};r.write("<div");r.writeControlData(m);r.addClass("sapUiCalMonthsRow");r.addClass("sapUiCalRow");r.writeClasses();if(t){r.writeAttributeEscaped("title",t);}if(m._getShowHeader()){a.value=a.value+" "+i+"-Head";}r.writeAccessibilityState(m,{role:"grid",readonly:"true",multiselectable:!m.getSingleSelection()||m.getIntervalSelection(),labelledby:a});r.write(">");r.write("<span id=\""+i+"-Descr\" style=\"display: none;\">"+m._rb.getText("CALENDAR_DIALOG")+"</span>");if(m.getIntervalSelection()){r.write("<span id=\""+i+"-Start\" style=\"display: none;\">"+m._rb.getText("CALENDAR_START_MONTH")+"</span>");r.write("<span id=\""+i+"-End\" style=\"display: none;\">"+m._rb.getText("CALENDAR_END_MONTH")+"</span>");}this.renderRow(r,m,d);r.write("</div>");};
M.renderRow=function(r,m,d){var i=m.getId();this.renderHeader(r,m,d);r.write("<div id=\""+i+"-months\" class=\"sapUiCalItems\">");this.renderMonths(r,m,d);r.write("</div>");};
M.renderHeader=function(r,m,d){if(m._getShowHeader()){var l=m._getLocaleData();var i=m.getId();r.write("<div id=\""+i+"-Head\">");this.renderHeaderLine(r,m,l,d);r.write("</div>");}};
M.renderHeaderLine=function(r,m,l,d){var I=m.getId();var a=m.getMonths();var o=new U(d.getTime());var w="";var y=0;var Y=[];var i=0;for(i=0;i<a;i++){y=o.getUTCFullYear();if(Y.length>0&&Y[Y.length-1].iYear==y){Y[Y.length-1].iMonths++;}else{Y.push({iYear:y,iMonths:1});}o.setUTCMonth(o.getUTCMonth()+1);}for(i=0;i<Y.length;i++){var b=Y[i];w=(100/a*b.iMonths)+"%";r.write("<div id=\""+I+"-Head"+i+"\"class=\"sapUiCalHeadText\" style=\"width:"+w+"\">");r.write(b.iYear);r.write("</div>");}};
M.renderMonths=function(r,m,d){var h=this.getHelper(m,d);var a=m.getMonths();var w=(100/a)+"%";var o=new U(d.getTime());o.setUTCDate(1);for(var i=0;i<a;i++){this.renderMonth(r,m,o,h,w);o.setUTCMonth(o.getUTCMonth()+1);}};
M.getHelper=function(m,d){var h={};h.sLocale=m._getLocale();h.oLocaleData=m._getLocaleData();h.oToday=C._createUniversalUTCDate(new Date());h.sCurrentMonth=m._rb.getText("CALENDAR_CURRENT_MONTH");h.sId=m.getId();h.oFormatLong=m._getFormatLong();if(m._bLongMonth||!m._bNamesLengthChecked){h.aMonthNames=h.oLocaleData.getMonthsStandAlone("wide");}else{h.aMonthNames=h.oLocaleData.getMonthsStandAlone("abbreviated");h.aMonthNamesWide=h.oLocaleData.getMonthsStandAlone("wide");}var l=m.getLegend();if(l){var L=sap.ui.getCore().byId(l);if(L){if(!(L instanceof sap.ui.unified.CalendarLegend)){throw new Error(L+" is not a sap.ui.unified.CalendarLegend. "+m);}h.aTypes=L.getItems();}else{q.sap.log.warning("CalendarLegend "+l+" does not exist!",m);}}else{h.aTypes=[];}return h;};
M.renderMonth=function(r,m,d,h,w){var a={role:"gridcell",selected:false,label:"",describedby:""};if(!m._bLongMonth&&m._bNamesLengthChecked){a["label"]=h.aMonthNamesWide[d.getUTCMonth()];}var y=m._oFormatYyyymm.format(d.getJSDate(),true);var s=m._checkDateSelected(d);var t=m._getDateType(d);var e=m._checkMonthEnabled(d);r.write("<div");r.writeAttribute("id",h.sId+"-"+y);r.addClass("sapUiCalItem");if(w){r.addStyle("width",w);}if(d.getUTCMonth()==h.oToday.getMonth()&&d.getUTCFullYear()==h.oToday.getFullYear()){r.addClass("sapUiCalItemNow");a["label"]=h.sCurrentMonth+" ";}if(s>0){r.addClass("sapUiCalItemSel");a["selected"]=true;}if(s==2){r.addClass("sapUiCalItemSelStart");a["describedby"]=a["describedby"]+" "+h.sId+"-Start";}else if(s==3){r.addClass("sapUiCalItemSelEnd");a["describedby"]=a["describedby"]+" "+h.sId+"-End";}else if(s==4){r.addClass("sapUiCalItemSelBetween");}else if(s==5){r.addClass("sapUiCalItemSelStart");r.addClass("sapUiCalItemSelEnd");a["describedby"]=a["describedby"]+" "+h.sId+"-Start";a["describedby"]=a["describedby"]+" "+h.sId+"-End";}if(t&&t.type!=sap.ui.unified.CalendarDayType.None){r.addClass("sapUiCalItem"+t.type);if(t.tooltip){r.writeAttributeEscaped('title',t.tooltip);}}if(!e){r.addClass("sapUiCalItemDsbl");a["disabled"]=true;}r.writeAttribute("tabindex","-1");r.writeAttribute("data-sap-month",y);a["label"]=a["label"]+h.oFormatLong.format(d,true);if(t&&t.type!=sap.ui.unified.CalendarDayType.None){for(var i=0;i<h.aTypes.length;i++){var l=h.aTypes[i];if(l.getType()==t.type){a["label"]=a["label"]+"; "+l.getText();break;}}}r.writeAccessibilityState(null,a);r.writeClasses();r.writeStyles();r.write(">");r.write("<span");r.addClass("sapUiCalItemText");r.writeClasses();r.write(">");r.write(h.aMonthNames[d.getUTCMonth()]);r.write("</span>");r.write("</div>");};
return M;},true);
sap.ui.predefine('sap/ui/unified/calendar/TimesRow',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/core/delegate/ItemNavigation','sap/ui/model/type/Date','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate','sap/ui/unified/library'],function(q,C,L,I,D,a,U,l){"use strict";
var T=C.extend("sap.ui.unified.calendar.TimesRow",{metadata:{library:"sap.ui.unified",properties:{date:{type:"object",group:"Data"},startDate:{type:"object",group:"Data"},items:{type:"int",group:"Appearance",defaultValue:12},intervalMinutes:{type:"int",group:"Appearance",defaultValue:60},intervalSelection:{type:"boolean",group:"Behavior",defaultValue:false},singleSelection:{type:"boolean",group:"Behavior",defaultValue:true},showHeader:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{selectedDates:{type:"sap.ui.unified.DateRange",multiple:true,singularName:"selectedDate"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.ui.unified.CalendarLegend",multiple:false}},events:{select:{},focus:{parameters:{date:{type:"object"},notVisible:{type:"boolean"}}}}}});
T.prototype.init=function(){this._oFormatYyyyMMddHHmm=sap.ui.core.format.DateFormat.getInstance({pattern:"yyyyMMddHHmm",calendarType:sap.ui.core.CalendarType.Gregorian});this._oFormatLong=sap.ui.core.format.DateFormat.getDateTimeInstance({style:"long/short"});this._oFormatDate=sap.ui.core.format.DateFormat.getDateInstance({style:"medium"});this._mouseMoveProxy=q.proxy(this._handleMouseMove,this);this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");};
T.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}if(this._sInvalidateTimes){q.sap.clearDelayedCall(this._sInvalidateTimes);}};
T.prototype.onAfterRendering=function(){_.call(this);};
T.prototype.onsapfocusleave=function(E){if(!E.relatedControlId||!q.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(E.relatedControlId).getFocusDomRef())){if(this._bMouseMove){s.call(this,true);k.call(this,this._getDate());this._bMoveChange=false;this._bMousedownChange=false;o.call(this);}if(this._bMousedownChange){this._bMousedownChange=false;o.call(this);}}};
T.prototype.invalidate=function(O){if(!this._bDateRangeChanged&&(!O||!(O instanceof sap.ui.unified.DateRange))){C.prototype.invalidate.apply(this,arguments);}else if(this.getDomRef()&&!this._sInvalidateTimes){if(this._bInvalidateSync){p.call(this);}else{this._sInvalidateTimes=q.sap.delayedCall(0,this,p);}}};
T.prototype.removeAllSelectedDates=function(){this._bDateRangeChanged=true;var R=this.removeAllAggregation("selectedDates");return R;};
T.prototype.destroySelectedDates=function(){this._bDateRangeChanged=true;var i=this.destroyAggregation("selectedDates");return i;};
T.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=true;var R=this.removeAllAggregation("specialDates");return R;};
T.prototype.destroySpecialDates=function(){this._bDateRangeChanged=true;var i=this.destroyAggregation("specialDates");return i;};
T.prototype.setIntervalMinutes=function(M){if(M>=720){throw new Error("Only intervals < 720 minutes are allowed; "+this);}if(1440%M>0){throw new Error("A day must be divisible by the interval size; "+this);}this.setProperty("intervalMinutes",M,false);this._oFormatTime=undefined;return this;};
T.prototype.setDate=function(i){f.call(this,i,false);return this;};
T.prototype._setDate=function(i){var t=a._createLocalDate(i,true);this.setProperty("date",t,true);this._oUTCDate=i;};
T.prototype._getDate=function(){if(!this._oUTCDate){this._oUTCDate=a._createUniversalUTCDate(new Date(),undefined,true);}return this._oUTCDate;};
T.prototype.setStartDate=function(S){if(!(S instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var y=S.getFullYear();if(y<1||y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}var u=a._createUniversalUTCDate(S,undefined,true);this.setProperty("startDate",S,true);this._oUTCStartDate=this._getIntervalStart(u);if(this.getDomRef()){var O=a._createLocalDate(this._getDate(),true);this._bNoRangeCheck=true;this.displayDate(S);this._bNoRangeCheck=false;if(O&&this.checkDateFocusable(O)){this.displayDate(O);}}return this;};
T.prototype._getStartDate=function(){if(!this._oUTCStartDate){this._oUTCStartDate=a._createUniversalUTCDate(new Date(),undefined,true);this._oUTCStartDate=this._getIntervalStart(this._oUTCStartDate);}return this._oUTCStartDate;};
T.prototype.displayDate=function(i){f.call(this,i,true);return this;};
T.prototype._getLocale=function(){var P=this.getParent();if(P&&P.getLocale){return P.getLocale();}else if(!this._sLocale){this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();}return this._sLocale;};
T.prototype._getLocaleData=function(){var P=this.getParent();if(P&&P._getLocaleData){return P._getLocaleData();}else if(!this._oLocaleData){var i=this._getLocale();var t=new sap.ui.core.Locale(i);this._oLocaleData=L.getInstance(t);}return this._oLocaleData;};
T.prototype._getFormatLong=function(){var i=this._getLocale();if(this._oFormatLong.oLocale.toString()!=i){var t=new sap.ui.core.Locale(i);this._oFormatLong=sap.ui.core.format.DateFormat.getInstance({style:"long/short"},t);}return this._oFormatLong;};
T.prototype._getFormatTime=function(){var i=this._getLocale();if(!this._oFormatTime||this._oFormatTime.oLocale.toString()!=i){var t=new sap.ui.core.Locale(i);var u=this.getIntervalMinutes();var v=this._getLocaleData();var P;this._oFormatTimeAmPm=undefined;if(u%60==0){P=v.getPreferredHourSymbol();if(v.getTimePattern("short").search("a")>=0){this._oFormatTimeAmPm=sap.ui.core.format.DateFormat.getTimeInstance({pattern:"a"},t);}}else{P=v.getTimePattern("short");P=P.replace("HH","H");P=P.replace("hh","h");if(P.search("a")>=0){this._oFormatTimeAmPm=sap.ui.core.format.DateFormat.getTimeInstance({pattern:"a"},t);P=P.replace("a","").trim();}}this._oFormatTime=sap.ui.core.format.DateFormat.getTimeInstance({pattern:P},t);}return this._oFormatTime;};
T.prototype._getFormatDate=function(){var i=this._getLocale();if(this._oFormatDate.oLocale.toString()!=i){var t=new sap.ui.core.Locale(i);this._oFormatDate=sap.ui.core.format.DateFormat.getDateInstance({style:"medium"},t);}return this._oFormatDate;};
T.prototype.getIntervalSelection=function(){var P=this.getParent();if(P&&P.getIntervalSelection){return P.getIntervalSelection();}else{return this.getProperty("intervalSelection");}};
T.prototype.getSingleSelection=function(){var P=this.getParent();if(P&&P.getSingleSelection){return P.getSingleSelection();}else{return this.getProperty("singleSelection");}};
T.prototype.getSelectedDates=function(){var P=this.getParent();if(P&&P.getSelectedDates){return P.getSelectedDates();}else{return this.getAggregation("selectedDates",[]);}};
T.prototype.getSpecialDates=function(){var P=this.getParent();if(P&&P.getSpecialDates){return P.getSpecialDates();}else{return this.getAggregation("specialDates",[]);}};
T.prototype._getShowHeader=function(){var P=this.getParent();if(P&&P._getShowItemHeader){return P._getShowItemHeader();}else{return this.getProperty("showHeader");}};
T.prototype.getIntervalMinutes=function(){var P=this.getParent();if(P&&P.getIntervalMinutes){return P.getIntervalMinutes();}else{return this.getProperty("intervalMinutes");}};
T.prototype.getAriaLabelledBy=function(){var P=this.getParent();if(P&&P.getAriaLabelledBy){return P.getAriaLabelledBy();}else{return this.getAssociation("ariaLabelledBy",[]);}};
T.prototype.getLegend=function(){var P=this.getParent();if(P&&P.getLegend){return P.getLegend();}else{return this.getAssociation("ariaLabelledBy",[]);}};
T.prototype._checkDateSelected=function(t){if(!(t instanceof U)){throw new Error("Date must be a UniversalDate object "+this);}var S=0;var u=this.getSelectedDates();var M=new U(t.getTime());M=this._getIntervalStart(M);var v=M.getTime();for(var i=0;i<u.length;i++){var R=u[i];var w=R.getStartDate();var x=0;if(w){w=a._createUniversalUTCDate(w,undefined,true);w=this._getIntervalStart(w);x=w.getTime();}var E=R.getEndDate();var y=0;if(E){E=a._createUniversalUTCDate(E,undefined,true);E=this._getIntervalStart(E);y=E.getTime();}if(v==x&&!E){S=1;break;}else if(v==x&&E){S=2;if(E&&v==y){S=5;}break;}else if(E&&v==y){S=3;break;}else if(E&&v>x&&v<y){S=4;break;}if(this.getSingleSelection()){break;}}return S;};
T.prototype._getDateType=function(t){if(!(t instanceof U)){throw new Error("Date must be a UniversalDate object "+this);}var u;var S=this.getSpecialDates();var M=new U(t.getTime());M=this._getIntervalStart(M);var v=M.getTime();for(var i=0;i<S.length;i++){var R=S[i];var w=R.getStartDate();var x=0;if(w){w=a._createUniversalUTCDate(w,undefined,true);w=this._getIntervalStart(w);x=w.getTime();}var E=R.getEndDate();var y=0;if(E){E=a._createUniversalUTCDate(E,undefined,true);E=this._getIntervalStart(E);E.setUTCMinutes(E.getUTCMinutes()+this.getIntervalMinutes()-1);y=E.getTime();}else if(w.getUTCHours()==0&&w.getUTCMinutes()==0&&w.getUTCSeconds()==0&&w.getUTCMilliseconds()==0){E=new U(w.getTime());E.setUTCDate(E.getUTCDate()+1);y=E.getTime();}if((v==x&&!E)||(v>=x&&v<=y)){u={type:R.getType(),tooltip:R.getTooltip_AsString()};break;}}return u;};
T.prototype._checkTimeEnabled=function(i){if(!(i instanceof U)){throw new Error("Date must be a UniversalDate object "+this);}var t=i.getTime();var P=this.getParent();if(P&&P._oMinDate&&P._oMaxDate){if(t<P._oMinDate.getTime()||t>P._oMaxDate.getTime()){return false;}}return true;};
T.prototype._handleMouseMove=function(E){if(!this.$().is(":visible")){s.call(this,true);}var t=q(E.target);if(t.hasClass("sapUiCalItemText")){t=t.parent();}if(t.hasClass("sapUiCalItem")){var O=this._getDate();var F=new U(this._oFormatYyyyMMddHHmm.parse(t.attr("data-sap-time"),true).getTime());if(F.getTime()!=O.getTime()){this._setDate(F);k.call(this,F,true);this._bMoveChange=true;}}};
T.prototype.onmouseup=function(E){if(this._bMouseMove){s.call(this,true);var F=this._getDate();var t=this._oItemNavigation.getItemDomRefs();for(var i=0;i<t.length;i++){var $=q(t[i]);if($.attr("data-sap-time")==this._oFormatYyyyMMddHHmm.format(F.getJSDate(),true)){$.focus();break;}}if(this._bMoveChange){var u=q(E.target);if(u.hasClass("sapUiCalItemText")){u=u.parent();}if(u.hasClass("sapUiCalItem")){F=new U(this._oFormatYyyyMMddHHmm.parse(u.attr("data-sap-time"),true).getTime());}k.call(this,F);this._bMoveChange=false;this._bMousedownChange=false;o.call(this);}}if(this._bMousedownChange){this._bMousedownChange=false;o.call(this);}};
T.prototype.onsapselect=function(E){var S=k.call(this,this._getDate());if(S){o.call(this);}E.stopPropagation();E.preventDefault();};
T.prototype.onsapselectmodifiers=function(E){this.onsapselect(E);};
T.prototype.onsappageupmodifiers=function(E){var F=new U(this._getDate().getTime());var i=F.getUTCDate();if(E.metaKey||E.ctrlKey){F.setUTCDate(i-7);}else{F.setUTCDate(i-1);}this.fireFocus({date:a._createLocalDate(F,true),notVisible:true});E.preventDefault();};
T.prototype.onsappagedownmodifiers=function(E){var F=new U(this._getDate().getTime());var i=F.getUTCDate();if(E.metaKey||E.ctrlKey){F.setUTCDate(i+7);}else{F.setUTCDate(i+1);}this.fireFocus({date:a._createLocalDate(F,true),notVisible:true});E.preventDefault();};
T.prototype.checkDateFocusable=function(i){if(!(i instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}if(this._bNoRangeCheck){return false;}var S=this._getStartDate();var E=new U(S.getTime());E.setUTCMinutes(E.getUTCMinutes()+this.getItems()*this.getIntervalMinutes());var u=a._createUniversalUTCDate(i,undefined,true);if(u.getTime()>=S.getTime()&&u.getTime()<E.getTime()){return true;}else{return false;}};
T.prototype._getIntervalStart=function(i){var t=i.getTime();var S=new U(i.getTime());S.setUTCHours(0);S.setUTCMinutes(0);S.setUTCSeconds(0);S.setUTCMilliseconds(0);var M=this.getIntervalMinutes();while(S.getTime()<=t){S.setUTCMinutes(S.getUTCMinutes()+M);}var u=new U(S.getTime());u.setUTCMinutes(u.getUTCMinutes()-M);return u;};
function _(){var t=this._getDate();var y=this._oFormatYyyyMMddHHmm.format(t.getJSDate(),true);var u=0;var R=this.$("times").get(0);var v=this.$("times").children(".sapUiCalItem");for(var i=0;i<v.length;i++){var $=q(v[i]);if($.attr("data-sap-time")===y){u=i;break;}}if(!this._oItemNavigation){this._oItemNavigation=new I();this._oItemNavigation.attachEvent(I.Events.AfterFocus,b,this);this._oItemNavigation.attachEvent(I.Events.FocusAgain,c,this);this._oItemNavigation.attachEvent(I.Events.BorderReached,d,this);this.addDelegate(this._oItemNavigation);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"],saphome:["alt"],sapend:["alt"]});this._oItemNavigation.setCycling(false);this._oItemNavigation.setColumns(1,true);}this._oItemNavigation.setRootDomRef(R);this._oItemNavigation.setItemDomRefs(v);this._oItemNavigation.setFocusedIndex(u);this._oItemNavigation.setPageSize(v.length);}
function b(i){var t=i.getParameter("index");var E=i.getParameter("event");if(!E){return;}var O=this._getDate();var F=new U(O.getTime());var u=this._oItemNavigation.getItemDomRefs();var $=q(u[t]);F=new U(this._oFormatYyyyMMddHHmm.parse($.attr("data-sap-time"),true).getTime());this._setDate(F);this.fireFocus({date:a._createLocalDate(F,true),notVisible:false});if(E.type=="mousedown"){e.call(this,E,F,t);}}
function c(i){var t=i.getParameter("index");var E=i.getParameter("event");if(!E){return;}if(E.type=="mousedown"){var F=this._getDate();e.call(this,E,F,t);}}
function d(i){var E=i.getParameter("event");var t=this.getItems();var M=this.getIntervalMinutes();var O=this._getDate();var F=new U(O.getTime());if(E.type){switch(E.type){case"sapnext":case"sapnextmodifiers":F.setUTCMinutes(F.getUTCMinutes()+M);break;case"sapprevious":case"sappreviousmodifiers":F.setUTCMinutes(F.getUTCMinutes()-M);break;case"sappagedown":F.setUTCMinutes(F.getUTCMinutes()+M*t);break;case"sappageup":F.setUTCMinutes(F.getUTCMinutes()-M*t);break;default:break;}this.fireFocus({date:a._createLocalDate(F,true),notVisible:true});}}
function e(E,F,i){if(E.button){return;}var S=k.call(this,F);if(S){this._bMousedownChange=true;}if(this._bMouseMove){s.call(this,true);this._bMoveChange=false;}else if(this.getIntervalSelection()&&this.$().is(":visible")){r.call(this,true);}E.preventDefault();E.setMark("cancelAutoClose");}
function f(i,N){if(!(i instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var y=i.getFullYear();if(y<1||y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}var F=true;if(!q.sap.equal(this.getDate(),i)){var u=a._createUniversalUTCDate(i,undefined,true);u=this._getIntervalStart(u);F=this.checkDateFocusable(i);if(!this._bNoRangeCheck&&!F){throw new Error("Date must be in visible date range; "+this);}this.setProperty("date",i,true);this._oUTCDate=u;}if(this.getDomRef()){if(F){g.call(this,this._oUTCDate,N);}else{h.call(this,N);}}}
function g(t,N){var y=this._oFormatYyyyMMddHHmm.format(t.getJSDate(),true);var u=this._oItemNavigation.getItemDomRefs();var $;for(var i=0;i<u.length;i++){$=q(u[i]);if($.attr("data-sap-time")==y){if(document.activeElement!=u[i]){if(N){this._oItemNavigation.setFocusedIndex(i);}else{this._oItemNavigation.focusItem(i);}}break;}}}
function h(N){var i=this._getStartDate();var $=this.$("times");if($.length>0){var R=sap.ui.getCore().createRenderManager();this.getRenderer().renderTimes(R,this,i);R.flush($[0]);R.destroy();}j.call(this);_.call(this);if(!N){this._oItemNavigation.focusItem(this._oItemNavigation.getFocusedIndex());}}
function j(){var S=this._getStartDate();if(this._getShowHeader()){var $=this.$("Head");if($.length>0){var i=this._getLocaleData();var R=sap.ui.getCore().createRenderManager();this.getRenderer().renderHeaderLine(R,this,i,S);R.flush($[0]);R.destroy();}}}
function k(t,M){if(!this._checkTimeEnabled(t)){return false;}var S=this.getSelectedDates();var u;var v=this._oItemNavigation.getItemDomRefs();var $;var y;var i=0;var P=this.getParent();var A=this;var w;if(P&&P.getSelectedDates){A=P;}if(this.getSingleSelection()){if(S.length>0){u=S[0];w=u.getStartDate();if(w){w=a._createUniversalUTCDate(w,undefined,true);w=this._getIntervalStart(w);}}else{u=new sap.ui.unified.DateRange();A.addAggregation("selectedDates",u,true);}if(this.getIntervalSelection()&&(!u.getEndDate()||M)&&w){var E;if(t.getTime()<w.getTime()){E=w;w=t;if(!M){u.setProperty("startDate",a._createLocalDate(new Date(w.getTime()),true),true);u.setProperty("endDate",a._createLocalDate(new Date(E.getTime()),true),true);}}else if(t.getTime()>=w.getTime()){E=t;if(!M){u.setProperty("endDate",a._createLocalDate(new Date(E.getTime()),true),true);}}m.call(this,w,E);}else{m.call(this,t);u.setProperty("startDate",a._createLocalDate(new Date(t.getTime()),true),true);u.setProperty("endDate",undefined,true);}}else{if(this.getIntervalSelection()){throw new Error("Calender don't support multiple interval selection");}else{var x=this._checkDateSelected(t);if(x>0){for(i=0;i<S.length;i++){w=S[i].getStartDate();if(w){w=a._createUniversalUTCDate(w,undefined,true);w=this._getIntervalStart(w);if(t.getTime()==w.getTime()){A.removeAggregation("selectedDates",i,true);break;}}}}else{u=new sap.ui.unified.DateRange({startDate:a._createLocalDate(new Date(t.getTime()),true)});A.addAggregation("selectedDates",u,true);}y=this._oFormatYyyyMMddHHmm.format(t.getJSDate(),true);for(i=0;i<v.length;i++){$=q(v[i]);if($.attr("data-sap-time")==y){if(x>0){$.removeClass("sapUiCalItemSel");$.attr("aria-selected","false");}else{$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");}}}}}return true;}
function m(S,E){var t=this._oItemNavigation.getItemDomRefs();var $;var i=0;var u=false;var v=false;if(!E){var y=this._oFormatYyyyMMddHHmm.format(S.getJSDate(),true);for(i=0;i<t.length;i++){$=q(t[i]);u=false;v=false;if($.attr("data-sap-time")==y){$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");u=true;}else if($.hasClass("sapUiCalItemSel")){$.removeClass("sapUiCalItemSel");$.attr("aria-selected","false");}if($.hasClass("sapUiCalItemSelStart")){$.removeClass("sapUiCalItemSelStart");}else if($.hasClass("sapUiCalItemSelBetween")){$.removeClass("sapUiCalItemSelBetween");}else if($.hasClass("sapUiCalItemSelEnd")){$.removeClass("sapUiCalItemSelEnd");}n.call(this,$,u,v);}}else{var w;for(i=0;i<t.length;i++){$=q(t[i]);u=false;v=false;w=new U(this._oFormatYyyyMMddHHmm.parse($.attr("data-sap-time"),true).getTime());if(w.getTime()==S.getTime()){$.addClass("sapUiCalItemSelStart");u=true;$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");if(E&&w.getTime()==E.getTime()){$.addClass("sapUiCalItemSelEnd");v=true;}$.removeClass("sapUiCalItemSelBetween");}else if(E&&w.getTime()>S.getTime()&&w.getTime()<E.getTime()){$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");$.addClass("sapUiCalItemSelBetween");$.removeClass("sapUiCalItemSelStart");$.removeClass("sapUiCalItemSelEnd");}else if(E&&w.getTime()==E.getTime()){$.addClass("sapUiCalItemSelEnd");v=true;$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");$.removeClass("sapUiCalItemSelStart");$.removeClass("sapUiCalItemSelBetween");}else{if($.hasClass("sapUiCalItemSel")){$.removeClass("sapUiCalItemSel");$.attr("aria-selected","false");}if($.hasClass("sapUiCalItemSelStart")){$.removeClass("sapUiCalItemSelStart");}else if($.hasClass("sapUiCalItemSelBetween")){$.removeClass("sapUiCalItemSelBetween");}else if($.hasClass("sapUiCalItemSelEnd")){$.removeClass("sapUiCalItemSelEnd");}}n.call(this,$,u,v);}}}
function n($,S,E){if(!this.getIntervalSelection()){return;}var t="";var u=[];var v=this.getId();var w=false;t=$.attr("aria-describedby");if(t){u=t.split(" ");}var x=-1;var y=-1;for(var i=0;i<u.length;i++){var z=u[i];if(z==(v+"-Start")){x=i;}if(z==(v+"-End")){y=i;}}if(x>=0&&!S){u.splice(x,1);w=true;if(y>x){y--;}}if(y>=0&&!E){u.splice(y,1);w=true;}if(x<0&&S){u.push(v+"-Start");w=true;}if(y<0&&E){u.push(v+"-End");w=true;}if(w){t=u.join(" ");$.attr("aria-describedby",t);}}
function o(){if(this._bMouseMove){s.call(this,true);}this.fireSelect();}
function p(){this._sInvalidateTimes=undefined;h.call(this,this._bNoFocus);this._bDateRangeChanged=undefined;this._bNoFocus=undefined;}
function r(){q(window.document).bind('mousemove',this._mouseMoveProxy);this._bMouseMove=true;}
function s(){q(window.document).unbind('mousemove',this._mouseMoveProxy);this._bMouseMove=undefined;}
return T;},true);
sap.ui.predefine('sap/ui/unified/calendar/TimesRowRenderer',['jquery.sap.global','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate'],function(q,C,U){"use strict";var T={};
T.render=function(r,t){var d=t._getStartDate();var s=t.getTooltip_AsString();var i=t.getId();var a={value:i+"-Descr",append:true};r.write("<div");r.writeControlData(t);r.addClass("sapUiCalTimesRow");r.addClass("sapUiCalRow");r.writeClasses();if(s){r.writeAttributeEscaped("title",s);}if(t._getShowHeader()){a.value=a.value+" "+i+"-Head";}r.writeAccessibilityState(t,{role:"grid",readonly:"true",multiselectable:!t.getSingleSelection()||t.getIntervalSelection(),labelledby:a});r.write(">");r.write("<span id=\""+i+"-Descr\" style=\"display: none;\">"+t._rb.getText("CALENDAR_DIALOG")+"</span>");if(t.getIntervalSelection()){r.write("<span id=\""+i+"-Start\" style=\"display: none;\">"+t._rb.getText("CALENDAR_START_TIME")+"</span>");r.write("<span id=\""+i+"-End\" style=\"display: none;\">"+t._rb.getText("CALENDAR_END_TIME")+"</span>");}this.renderRow(r,t,d);r.write("</div>");};
T.renderRow=function(r,t,d){var i=t.getId();this.renderHeader(r,t,d);r.write("<div id=\""+i+"-times\" class=\"sapUiCalItems\">");this.renderTimes(r,t,d);r.write("</div>");};
T.renderHeader=function(r,t,d){if(t._getShowHeader()){var l=t._getLocaleData();var i=t.getId();r.write("<div id=\""+i+"-Head\">");this.renderHeaderLine(r,t,l,d);r.write("</div>");}};
T.renderHeaderLine=function(r,t,l,d){var f=t._getFormatDate();var I=t.getId();var a=t.getItems();var o=t._getIntervalStart(d);var m=t.getIntervalMinutes();var w="";var D=0;var b=[];var i=0;for(i=0;i<a;i++){D=f.format(o,true);if(b.length>0&&b[b.length-1].sDay==D){b[b.length-1].iItems++;}else{b.push({sDay:D,iItems:1});}o.setUTCMinutes(o.getUTCMinutes()+m);}for(i=0;i<b.length;i++){var c=b[i];w=(100/a*c.iItems)+"%";r.write("<div id=\""+I+"-Head"+i+"\"class=\"sapUiCalHeadText\" style=\"width:"+w+"\">");r.write(c.sDay);r.write("</div>");}};
T.renderTimes=function(r,t,d){var h=this.getHelper(t,d);var I=t.getItems();var w=(100/I)+"%";var o=t._getIntervalStart(d);var O="";var a="";for(var i=0;i<I;i++){if(h.oFormatTimeAmPm){a=h.oFormatTimeAmPm.format(o,true);if(O==a){a="";}else{O=a;}}this.renderTime(r,t,o,h,w,a);o.setUTCMinutes(o.getUTCMinutes()+h.iMinutes);}};
T.getHelper=function(t,d){var h={};h.sLocale=t._getLocale();h.oLocaleData=t._getLocaleData();h.oNow=C._createUniversalUTCDate(new Date(),undefined,true);h.sCurrentTime=t._rb.getText("CALENDAR_CURRENT_TIME");h.sId=t.getId();h.oFormatLong=t._getFormatLong();h.oFormatTime=t._getFormatTime();h.oFormatTimeAmPm=t._oFormatTimeAmPm;h.iMinutes=t.getIntervalMinutes();var l=t.getLegend();if(l){var L=sap.ui.getCore().byId(l);if(L){if(!(L instanceof sap.ui.unified.CalendarLegend)){throw new Error(L+" is not a sap.ui.unified.CalendarLegend. "+t);}h.aTypes=L.getItems();}else{q.sap.log.warning("CalendarLegend "+l+" does not exist!",t);}}else{h.aTypes=[];}return h;};
T.renderTime=function(r,t,d,h,w,a){var A={role:"gridcell",selected:false,label:"",describedby:""};var y=t._oFormatYyyyMMddHHmm.format(d.getJSDate(),true);var s=t._checkDateSelected(d);var o=t._getDateType(d);var e=t._checkTimeEnabled(d);r.write("<div");r.writeAttribute("id",h.sId+"-"+y);r.addClass("sapUiCalItem");if(w){r.addStyle("width",w);}var n=new U(d.getTime());n.setUTCMinutes(n.getUTCMinutes()+h.iMinutes);if(d.getTime()<=h.oNow.getTime()&&n.getTime()>h.oNow.getTime()){r.addClass("sapUiCalItemNow");A["label"]=h.sCurrentTime+" ";}if(s>0){r.addClass("sapUiCalItemSel");A["selected"]=true;}if(s==2){r.addClass("sapUiCalItemSelStart");A["describedby"]=A["describedby"]+" "+h.sId+"-Start";}else if(s==3){r.addClass("sapUiCalItemSelEnd");A["describedby"]=A["describedby"]+" "+h.sId+"-End";}else if(s==4){r.addClass("sapUiCalItemSelBetween");}else if(s==5){r.addClass("sapUiCalItemSelStart");r.addClass("sapUiCalItemSelEnd");A["describedby"]=A["describedby"]+" "+h.sId+"-Start";A["describedby"]=A["describedby"]+" "+h.sId+"-End";}if(o&&o.type!=sap.ui.unified.CalendarDayType.None){r.addClass("sapUiCalItem"+o.type);if(o.tooltip){r.writeAttributeEscaped('title',o.tooltip);}}if(!e){r.addClass("sapUiCalItemDsbl");A["disabled"]=true;}r.writeAttribute("tabindex","-1");r.writeAttribute("data-sap-time",y);A["label"]=A["label"]+h.oFormatLong.format(d,true);if(o&&o.type!=sap.ui.unified.CalendarDayType.None){for(var i=0;i<h.aTypes.length;i++){var l=h.aTypes[i];if(l.getType()==o.type){A["label"]=A["label"]+"; "+l.getText();break;}}}r.writeAccessibilityState(null,A);r.writeClasses();r.writeStyles();r.write(">");r.write("<span");r.addClass("sapUiCalItemText");r.writeClasses();r.write(">");r.write(h.oFormatTime.format(d,true));if(a){r.write("<span");r.addClass("sapUiCalItemTextAmPm");r.writeClasses();r.write(">");r.write(a);r.write("</span>");}r.write("</span>");r.write("</div>");};
return T;},true);
sap.ui.predefine('sap/ui/unified/calendar/YearPicker',['jquery.sap.global','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation','sap/ui/model/type/Date','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate','sap/ui/unified/library'],function(q,C,I,D,a,U,l){"use strict";
var Y=C.extend("sap.ui.unified.calendar.YearPicker",{metadata:{library:"sap.ui.unified",properties:{year:{type:"int",group:"Data",defaultValue:2000},years:{type:"int",group:"Appearance",defaultValue:20},columns:{type:"int",group:"Appearance",defaultValue:4},date:{type:"object",group:"Data"},primaryCalendarType:{type:"sap.ui.core.CalendarType",group:"Appearance"}},events:{select:{},pageChange:{}}}});
Y.prototype.init=function(){var s=sap.ui.getCore().getConfiguration().getCalendarType();this.setProperty("primaryCalendarType",s);this._oYearFormat=sap.ui.core.format.DateFormat.getDateInstance({format:"y",calendarType:s});this._oFormatYyyymmdd=sap.ui.core.format.DateFormat.getInstance({pattern:"yyyyMMdd",calendarType:sap.ui.core.CalendarType.Gregorian});this._oMinDate=this._newUniversalDate(new Date(Date.UTC(1,0,1)));this._oMinDate.getJSDate().setUTCFullYear(1);this._oMaxDate=this._newUniversalDate(new Date(Date.UTC(9999,11,31)));};
Y.prototype.onAfterRendering=function(){_.call(this);};
Y.prototype.setYear=function(y){this.setProperty("year",y,true);y=this.getProperty("year");var o=this._newUniversalDate(new Date());o.setDate(1);o.setMonth(0);o.setFullYear(y);this.setDate(o.getJSDate());return this;};
Y.prototype.setDate=function(o){if(o&&!(o instanceof Date)){throw new Error("Date must be a JavaScript date object; "+this);}var y=o.getFullYear();if(y<1||y>9999){throw new Error("Date must not be in valid range (between 0001-01-01 and 9999-12-31); "+this);}var u=a._createUniversalUTCDate(o,this.getPrimaryCalendarType());u.setUTCMonth(0,1);this.setProperty("date",o,true);this.setProperty("year",u.getUTCFullYear(),true);this._oUTCDate=u;if(this.getDomRef()){var i=this.getYears();var F=this._newUniversalDate(this._oUTCDate);F.setUTCFullYear(F.getUTCFullYear()-Math.floor(i/2));h.call(this,F,Math.floor(i/2));}return this;};
Y.prototype._getDate=function(){if(!this._oUTCDate){var y=this.getYear();this._oUTCDate=this._newUniversalDate(new Date(Date.UTC(y,0,1)));if(y<100){this._oUTCDate.setUTCFullYear(y);}}return this._oUTCDate;};
Y.prototype.setPrimaryCalendarType=function(s){this.setProperty("primaryCalendarType",s);this._oYearFormat=sap.ui.core.format.DateFormat.getDateInstance({format:"y",calendarType:s});if(this._oUTCDate){this._oUTCDate=U.getInstance(this._oUTCDate.getJSDate(),s);this._oUTCDate.setUTCMonth(0,1);}this._oMinDate=U.getInstance(this._oMinDate.getJSDate(),s);this._oMaxDate=U.getInstance(this._oMaxDate.getJSDate(),s);return this;};
Y.prototype._newUniversalDate=function(o){var j;if((o instanceof U)){j=new Date(o.getJSDate().getTime());}else{j=new Date(o.getTime());}return U.getInstance(j,this.getPrimaryCalendarType());};
Y.prototype.nextPage=function(){g.call(this,true,this._oItemNavigation.getFocusedIndex());return this;};
Y.prototype.previousPage=function(){g.call(this,false,this._oItemNavigation.getFocusedIndex());return this;};
Y.prototype.onsapspace=function(E){E.preventDefault();};
Y.prototype.onsapselect=function(E){var i=this._oItemNavigation.getFocusedIndex();var s=f.call(this,i);if(s){this.fireSelect();}};
Y.prototype.onmouseup=function(E){if(this._bMousedownChange){this._bMousedownChange=false;this.fireSelect();}};
Y.prototype.getFirstRenderedDate=function(){var F;if(this.getDomRef()){var i=this._oItemNavigation.getItemDomRefs();F=this._oFormatYyyymmdd.parse(q(i[0]).attr("data-sap-year-start"),true);}return F;};
Y.prototype._checkFirstDate=function(o){var y=this.getYears();var m=this._newUniversalDate(this._oMaxDate);m.setUTCFullYear(m.getUTCFullYear()-y+1);if(o.getTime()>m.getTime()&&o.getFullYear()!=m.getUTCFullYear()){o=this._newUniversalDate(m);o.setUTCMonth(0,1);}else if(o.getTime()<this._oMinDate.getTime()&&o.getFullYear()!=this._oMinDate.getUTCFullYear()){o=this._newUniversalDate(this._oMinDate);o.setUTCMonth(0,1);}return o;};
Y.prototype._checkDateEnabled=function(o){var E=true;if((o.getTime()>this._oMaxDate.getTime()&&o.getFullYear()!=this._oMaxDate.getUTCFullYear())||(o.getTime()<this._oMinDate.getTime()&&o.getFullYear()!=this._oMinDate.getUTCFullYear())){E=false;}return E;};
function _(){var y=this.getYears();var i=this._getDate().getUTCFullYear();var m=this._oMinDate.getUTCFullYear();var M=this._oMaxDate.getUTCFullYear();var r=this.getDomRef();var j=this.$().find(".sapUiCalItem");var k=Math.floor(y/2);if(i>M-Math.floor(y/2)){k=k+i-M+Math.floor(y/2);}else if(i<=m+Math.floor(y/2)){k=i-m;}if(!this._oItemNavigation){this._oItemNavigation=new I();this._oItemNavigation.attachEvent(I.Events.AfterFocus,b,this);this._oItemNavigation.attachEvent(I.Events.FocusAgain,c,this);this._oItemNavigation.attachEvent(I.Events.BorderReached,e,this);this.addDelegate(this._oItemNavigation);this._oItemNavigation.setHomeEndColumnMode(true,true);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"],saphome:["alt"],sapend:["alt"]});}this._oItemNavigation.setRootDomRef(r);this._oItemNavigation.setItemDomRefs(j);this._oItemNavigation.setCycling(false);this._oItemNavigation.setColumns(this.getColumns(),true);this._oItemNavigation.setFocusedIndex(k);this._oItemNavigation.setPageSize(j.length);}
function b(o){var i=o.getParameter("index");var E=o.getParameter("event");if(!E){return;}if(E.type=="mousedown"){d.call(this,E,i);}}
function c(o){var i=o.getParameter("index");var E=o.getParameter("event");if(!E){return;}if(E.type=="mousedown"){d.call(this,E,i);}}
function d(E,i){if(E.button){return;}var s=f.call(this,i);if(s){this._bMousedownChange=true;}E.preventDefault();E.setMark("cancelAutoClose");}
function e(o){var E=o.getParameter("event");if(E.type){var y=this.getYears();var i=this.getColumns();if(i==0){i=y;}switch(E.type){case"sapnext":case"sapnextmodifiers":if(E.keyCode==q.sap.KeyCodes.ARROW_DOWN&&i<y){g.call(this,true,this._oItemNavigation.getFocusedIndex()-y+i,true);}else{g.call(this,true,0,true);}break;case"sapprevious":case"sappreviousmodifiers":if(E.keyCode==q.sap.KeyCodes.ARROW_UP&&i<y){g.call(this,false,y-i+this._oItemNavigation.getFocusedIndex(),true);}else{g.call(this,false,y-1,true);}break;case"sappagedown":g.call(this,true,this._oItemNavigation.getFocusedIndex(),true);break;case"sappageup":g.call(this,false,this._oItemNavigation.getFocusedIndex(),true);break;default:break;}}}
function f(j){var k=this._oItemNavigation.getItemDomRefs();var $=q(k[j]);if($.hasClass("sapUiCalItemDsbl")){return false;}var y=$.attr("data-sap-year-start");var o=this._newUniversalDate(this._oFormatYyyymmdd.parse(y,true));var s=this.getId()+"-y"+y;for(var i=0;i<k.length;i++){$=q(k[i]);if($.attr("id")==s){$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");}else{$.removeClass("sapUiCalItemSel");$.attr("aria-selected","false");}}var L=a._createLocalDate(o);this.setProperty("date",L,true);this.setProperty("year",o.getUTCFullYear(),true);return true;}
function g(F,s,i){var j=this._oItemNavigation.getItemDomRefs();var o=this._newUniversalDate(this._oFormatYyyymmdd.parse(q(j[0]).attr("data-sap-year-start"),true));var y=this.getYears();if(F){var m=this._newUniversalDate(this._oMaxDate);m.setUTCFullYear(m.getUTCFullYear()-y+1);if(o.getTime()<m.getTime()){o.setUTCFullYear(o.getUTCFullYear()+y);if(o.getTime()>m.getTime()){s=s+(o.getUTCFullYear()-m.getUTCFullYear());if(s>y-1){s=y-1;}o=this._oMaxDate;o.setUTCMonth(0,1);}}else{return;}}else{if(o.getTime()>this._oMinDate.getTime()){o.setUTCFullYear(o.getUTCFullYear()-y);if(o.getTime()<this._oMinDate.getTime()){s=s-(this._oMinDate.getUTCFullYear()-o.getUTCFullYear());if(s<0){s=0;}o=this._newUniversalDate(this._oMinDate);}}else{return;}}h.call(this,o,s);if(i){this.firePageChange();}}
function h(F,s){var j=this._oFormatYyyymmdd.format(this._getDate().getJSDate(),true);var E=false;var o=this._checkFirstDate(F);var S;if(o.getTime()!=F.getTime()){S=this._newUniversalDate(F);S.setUTCFullYear(S.getUTCFullYear()+s);F=o;E=true;}var k=this._oItemNavigation.getItemDomRefs();var m=this._newUniversalDate(F);for(var i=0;i<k.length;i++){var y=this._oFormatYyyymmdd.format(m.getJSDate(),true);var $=q(k[i]);$.attr("id",this.getId()+"-y"+y);$.text(this._oYearFormat.format(m,true));$.attr("data-sap-year-start",y);if($.hasClass("sapUiCalItemSel")&&y!=j){$.removeClass("sapUiCalItemSel");$.attr("aria-selected","false");}else if(!$.hasClass("sapUiCalItemSel")&&y==j){$.addClass("sapUiCalItemSel");$.attr("aria-selected","true");}var n=true;if(E){n=this._checkDateEnabled(m);if(m.getTime()==S.getTime()){s=i;}}if(n){$.removeClass("sapUiCalItemDsbl");$.removeAttr("aria-disabled");}else{$.addClass("sapUiCalItemDsbl");$.attr("aria-disabled",true);}m.setUTCFullYear(m.getUTCFullYear()+1);}this._oItemNavigation.focusItem(s);}
return Y;},true);
sap.ui.predefine('sap/ui/unified/calendar/YearPickerRenderer',['jquery.sap.global','sap/ui/core/date/UniversalDate'],function(q,U){"use strict";var Y={};
Y.render=function(r,y){var t=y.getTooltip_AsString();var I=y.getId();var c=y._getDate();var C=c.getUTCFullYear();var a=y.getYears();var b=y.getColumns();var w="";r.write("<div");r.writeControlData(y);r.addClass("sapUiCalYearPicker");r.writeClasses();if(t){r.writeAttributeEscaped('title',t);}r.writeAccessibilityState(y,{role:"grid",readonly:"true",multiselectable:"false"});r.write(">");var d=y._newUniversalDate(c);d.setUTCFullYear(d.getFullYear()-Math.floor(a/2));var e=false;var f=y._checkFirstDate(d);if(f.getTime()!=d.getTime()){d=f;e=true;}if(b>0){w=(100/b)+"%";}else{w=(100/a)+"%";}for(var i=0;i<a;i++){var s=y._oFormatYyyymmdd.format(d.getJSDate(),true);var A={role:"gridcell"};var E=true;if(e){E=y._checkDateEnabled(d);}if(b>0&&i%b==0){r.write("<div");r.writeAccessibilityState(null,{role:"row"});r.write(">");}r.write("<div");r.writeAttribute("id",I+"-y"+s);r.addClass("sapUiCalItem");if(d.getUTCFullYear()==C){r.addClass("sapUiCalItemSel");A["selected"]=true;}else{A["selected"]=false;}if(!E){r.addClass("sapUiCalItemDsbl");A["disabled"]=true;}r.writeAttribute("tabindex","-1");r.writeAttribute("data-sap-year-start",s);r.addStyle("width",w);r.writeClasses();r.writeStyles();r.writeAccessibilityState(null,A);r.write(">");r.write(y._oYearFormat.format(d,true));r.write("</div>");d.setUTCFullYear(d.getUTCFullYear()+1);if(b>0&&((i+1)%b==0)){r.write("</div>");}}r.write("</div>");};
return Y;},true);
sap.ui.predefine('sap/ui/unified/library',['jquery.sap.global','sap/ui/core/library'],function(q){"use strict";sap.ui.getCore().initLibrary({name:"sap.ui.unified",version:"1.42.7",dependencies:["sap.ui.core"],types:["sap.ui.unified.CalendarDayType","sap.ui.unified.ContentSwitcherAnimation"],interfaces:[],controls:["sap.ui.unified.calendar.DatesRow","sap.ui.unified.calendar.Header","sap.ui.unified.calendar.Month","sap.ui.unified.calendar.MonthPicker","sap.ui.unified.calendar.MonthsRow","sap.ui.unified.calendar.TimesRow","sap.ui.unified.calendar.YearPicker","sap.ui.unified.Calendar","sap.ui.unified.CalendarDateInterval","sap.ui.unified.CalendarMonthInterval","sap.ui.unified.CalendarTimeInterval","sap.ui.unified.CalendarLegend","sap.ui.unified.CalendarRow","sap.ui.unified.ContentSwitcher","sap.ui.unified.Currency","sap.ui.unified.FileUploader","sap.ui.unified.Menu","sap.ui.unified.Shell","sap.ui.unified.ShellLayout","sap.ui.unified.ShellOverlay","sap.ui.unified.SplitContainer"],elements:["sap.ui.unified.CalendarAppointment","sap.ui.unified.CalendarLegendItem","sap.ui.unified.DateRange","sap.ui.unified.DateTypeRange","sap.ui.unified.FileUploaderParameter","sap.ui.unified.MenuItem","sap.ui.unified.MenuItemBase","sap.ui.unified.MenuTextFieldItem","sap.ui.unified.ShellHeadItem","sap.ui.unified.ShellHeadUserItem"]});sap.ui.unified.CalendarDayType={None:"None",Type01:"Type01",Type02:"Type02",Type03:"Type03",Type04:"Type04",Type05:"Type05",Type06:"Type06",Type07:"Type07",Type08:"Type08",Type09:"Type09",Type10:"Type10"};sap.ui.unified.CalendarIntervalType={Hour:"Hour",Day:"Day",Month:"Month"};sap.ui.unified.CalendarAppointmentVisualization={Standard:"Standard",Filled:"Filled"};sap.ui.unified.ContentSwitcherAnimation={None:"None",Fade:"Fade",ZoomIn:"ZoomIn",ZoomOut:"ZoomOut",Rotate:"Rotate",SlideRight:"SlideRight",SlideOver:"SlideOver"};
sap.ui.base.Object.extend("sap.ui.unified._ContentRenderer",{
constructor:function(c,C,o,a){sap.ui.base.Object.apply(this);this._id=C;this._cntnt=o;this._ctrl=c;this._rm=sap.ui.getCore().createRenderManager();this._cb=a||function(){};},
destroy:function(){this._rm.destroy();delete this._rm;delete this._id;delete this._cntnt;delete this._cb;delete this._ctrl;if(this._rerenderTimer){q.sap.clearDelayedCall(this._rerenderTimer);delete this._rerenderTimer;}sap.ui.base.Object.prototype.destroy.apply(this,arguments);},
render:function(){if(!this._rm){return;}if(this._rerenderTimer){q.sap.clearDelayedCall(this._rerenderTimer);}this._rerenderTimer=q.sap.delayedCall(0,this,function(){var $=q.sap.byId(this._id);var d=$.length>0;if(d){if(typeof(this._cntnt)==="string"){var c=this._ctrl.getAggregation(this._cntnt,[]);for(var i=0;i<c.length;i++){this._rm.renderControl(c[i]);}}else{this._cntnt(this._rm);}this._rm.flush($[0]);}this._cb(d);});}
});
sap.ui.unified._iNumberOfOpenedShellOverlays=0;if(!sap.ui.unified.FileUploaderHelper){sap.ui.unified.FileUploaderHelper={createTextField:function(i){throw new Error("no TextField control available!");},setTextFieldContent:function(t,w){throw new Error("no TextField control available!");},createButton:function(){throw new Error("no Button control available!");},addFormClass:function(){return null;},bFinal:false};}sap.ui.unified.calendar=sap.ui.unified.calendar||{};return sap.ui.unified;});
sap.ui.predefine('sap/ui/unified/Menu',['jquery.sap.global','sap/ui/core/Control','sap/ui/Device','sap/ui/core/Popup','./MenuItemBase','./library','jquery.sap.script'],function(q,C,D,P,M,l){"use strict";
var a=C.extend("sap.ui.unified.Menu",{metadata:{library:"sap.ui.unified",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},ariaDescription:{type:"string",group:"Accessibility",defaultValue:null},maxVisibleItems:{type:"int",group:"Behavior",defaultValue:0},pageSize:{type:"int",group:"Behavior",defaultValue:5}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.unified.MenuItemBase",multiple:true,singularName:"item"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{itemSelect:{parameters:{item:{type:"sap.ui.unified.MenuItemBase"}}}}}});
(function(w){a.prototype.bCozySupported=true;a._DELAY_SUBMENU_TIMER=300;a._DELAY_SUBMENU_TIMER_EXT=400;
a.prototype.init=function(){var t=this;this.bOpen=false;this.oOpenedSubMenu=null;this.oHoveredItem=null;this.oPopup=null;this.fAnyEventHandlerProxy=q.proxy(function(e){var r=this.getRootMenu();if(r!=this||!this.bOpen||!this.getDomRef()||(e.type!="mousedown"&&e.type!="touchstart")){return;}r.handleOuterEvent(this.getId(),e);},this);this.fOrientationChangeHandler=function(){t.close();};this.bUseTopStyle=false;};
a.prototype.exit=function(){if(this.oPopup){this.oPopup.detachClosed(this._menuClosed,this);this.oPopup.destroy();delete this.oPopup;}q.sap.unbindAnyEvent(this.fAnyEventHandlerProxy);if(this._bOrientationChangeBound){q(w).unbind("orientationchange",this.fOrientationChangeHandler);this._bOrientationChangeBound=false;}this._resetDelayedRerenderItems();};
a.prototype.invalidate=function(o){if(o instanceof M&&this.getDomRef()){this._delayedRerenderItems();}else{C.prototype.invalidate.apply(this,arguments);}};
a.prototype.onBeforeRendering=function(){this._resetDelayedRerenderItems();};
a.prototype.onAfterRendering=function(){if(this.$().parent().attr("id")!="sap-ui-static"){q.sap.log.error("sap.ui.unified.Menu: The Menu is popup based and must not be rendered directly as content of the page.");this.close();this.$().remove();}var I=this.getItems();for(var i=0;i<I.length;i++){if(I[i].onAfterRendering&&I[i].getDomRef()){I[i].onAfterRendering();}}if(this.oHoveredItem){this.oHoveredItem.hover(true,this);}b(this);};
a.prototype.onThemeChanged=function(){if(this.getDomRef()&&this.getPopup().getOpenState()===sap.ui.core.OpenState.OPEN){b(this);this.getPopup()._applyPosition(this.getPopup()._oLastPosition);}};
a.prototype.setPageSize=function(S){return this.setProperty("pageSize",S,true);};
a.prototype.addItem=function(i){this.addAggregation("items",i,!!this.getDomRef());this._delayedRerenderItems();return this;};
a.prototype.insertItem=function(i,e){this.insertAggregation("items",i,e,!!this.getDomRef());this._delayedRerenderItems();return this;};
a.prototype.removeItem=function(i){this.removeAggregation("items",i,!!this.getDomRef());this._delayedRerenderItems();return this;};
a.prototype.removeAllItems=function(){var r=this.removeAllAggregation("items",!!this.getDomRef());this._delayedRerenderItems();return r;};
a.prototype.destroyItems=function(){this.destroyAggregation("items",!!this.getDomRef());this._delayedRerenderItems();return this;};
a.prototype._delayedRerenderItems=function(){if(!this.getDomRef()){return;}this._resetDelayedRerenderItems();this._discardOpenSubMenuDelayed();this._itemRerenderTimer=q.sap.delayedCall(0,this,function(){var o=this.getDomRef();if(o){var r=sap.ui.getCore().createRenderManager();sap.ui.unified.MenuRenderer.renderItems(r,this);r.flush(o);r.destroy();this.onAfterRendering();this.getPopup()._applyPosition(this.getPopup()._oLastPosition);}});};
a.prototype._resetDelayedRerenderItems=function(){if(this._itemRerenderTimer){q.sap.clearDelayedCall(this._itemRerenderTimer);delete this._itemRerenderTimer;}};
a.prototype.open=function(W,o,m,e,f,g,h){if(this.bOpen){return;}s(this,true);this.oOpenerRef=o;this.bIgnoreOpenerDOMRef=false;this.getPopup().open(0,m,e,f,g||"0 0",h||"_sapUiCommonsMenuFlip _sapUiCommonsMenuFlip",true);this.bOpen=true;var i=this.getDomRef();q(i).attr("tabIndex",0).focus();if(W){this.setHoveredItem(this.getNextSelectableItem(-1));}q.sap.bindAnyEvent(this.fAnyEventHandlerProxy);if(sap.ui.Device.support.orientation&&this.getRootMenu()===this){q(w).bind("orientationchange",this.fOrientationChangeHandler);this._bOrientationChangeBound=true;}};
a.prototype.close=function(){if(!this.bOpen||a._dbg){return;}this._discardOpenSubMenuDelayed();s(this,false);delete this._bFixed;q.sap.unbindAnyEvent(this.fAnyEventHandlerProxy);if(this._bOrientationChangeBound){q(w).unbind("orientationchange",this.fOrientationChangeHandler);this._bOrientationChangeBound=false;}this.bOpen=false;this.closeSubmenu();this.setHoveredItem();q(this.getDomRef()).attr("tabIndex",-1);this.getPopup().close(0);this._resetDelayedRerenderItems();this.$().remove();this.bOutput=false;if(this.isSubMenu()){this.getParent().getParent().oOpenedSubMenu=null;}};
a.prototype._menuClosed=function(){if(this.oOpenerRef){if(!this.bIgnoreOpenerDOMRef){try{this.oOpenerRef.focus();}catch(e){q.sap.log.warning("Menu.close cannot restore the focus on opener "+this.oOpenerRef+", "+e);}}this.oOpenerRef=undefined;}};
a.prototype.onclick=function(e){this.selectItem(this.getItemByDomRef(e.target),false,!!(e.metaKey||e.ctrlKey));e.preventDefault();e.stopPropagation();};
a.prototype.onsapnext=function(e){if(e.keyCode!=q.sap.KeyCodes.ARROW_DOWN){if(this.oHoveredItem&&this.oHoveredItem.getSubmenu()&&this.checkEnabled(this.oHoveredItem)){this.openSubmenu(this.oHoveredItem,true);}return;}var i=this.oHoveredItem?this.indexOfAggregation("items",this.oHoveredItem):-1;this.setHoveredItem(this.getNextSelectableItem(i));e.preventDefault();e.stopPropagation();};
a.prototype.onsapprevious=function(e){if(e.keyCode!=q.sap.KeyCodes.ARROW_UP){if(this.isSubMenu()){this.close();}e.preventDefault();e.stopPropagation();return;}var i=this.oHoveredItem?this.indexOfAggregation("items",this.oHoveredItem):-1;this.setHoveredItem(this.getPreviousSelectableItem(i));e.preventDefault();e.stopPropagation();};
a.prototype.onsaphome=function(e){this.setHoveredItem(this.getNextSelectableItem(-1));e.preventDefault();e.stopPropagation();};
a.prototype.onsapend=function(e){this.setHoveredItem(this.getPreviousSelectableItem(this.getItems().length));e.preventDefault();e.stopPropagation();};
a.prototype.onsappagedown=function(e){if(this.getPageSize()<1){this.onsapend(e);return;}var i=this.oHoveredItem?this.indexOfAggregation("items",this.oHoveredItem):-1;i+=this.getPageSize();if(i>=this.getItems().length){this.onsapend(e);return;}this.setHoveredItem(this.getNextSelectableItem(i-1));e.preventDefault();e.stopPropagation();};
a.prototype.onsappageup=function(e){if(this.getPageSize()<1){this.onsaphome(e);return;}var i=this.oHoveredItem?this.indexOfAggregation("items",this.oHoveredItem):-1;i-=this.getPageSize();if(i<0){this.onsaphome(e);return;}this.setHoveredItem(this.getPreviousSelectableItem(i+1));e.preventDefault();e.stopPropagation();};
a.prototype.onsapselect=function(e){this._sapSelectOnKeyDown=true;e.preventDefault();e.stopPropagation();};
a.prototype.onkeyup=function(e){if(!this._sapSelectOnKeyDown){return;}else{this._sapSelectOnKeyDown=false;}if(!q.sap.PseudoEvents.sapselect.fnCheck(e)){return;}this.selectItem(this.oHoveredItem,true,false);e.preventDefault();e.stopPropagation();};
a.prototype.onsapbackspace=function(e){if(q(e.target).prop("tagName")!="INPUT"){e.preventDefault();}};
a.prototype.onsapbackspacemodifiers=a.prototype.onsapbackspace;
a.prototype.onsapescape=function(e){this.close();e.preventDefault();e.stopPropagation();};
a.prototype.onsaptabnext=a.prototype.onsapescape;a.prototype.onsaptabprevious=a.prototype.onsapescape;
a.prototype.onmouseover=function(e){if(!sap.ui.Device.system.desktop){return;}var i=this.getItemByDomRef(e.target);if(!this.bOpen||!i||i==this.oHoveredItem){return;}if(this.oOpenedSubMenu&&q.sap.containsOrEquals(this.oOpenedSubMenu.getDomRef(),e.target)){return;}this.setHoveredItem(i);if(q.sap.checkMouseEnterOrLeave(e,this.getDomRef())){if(!D.browser.msie&&!D.browser.edge){this.getDomRef().focus();}}this._openSubMenuDelayed(i);};
a.prototype._openSubMenuDelayed=function(i){if(!i){return;}this._discardOpenSubMenuDelayed();this._delayedSubMenuTimer=q.sap.delayedCall(i.getSubmenu()&&this.checkEnabled(i)?a._DELAY_SUBMENU_TIMER:a._DELAY_SUBMENU_TIMER_EXT,this,function(){this.closeSubmenu();if(!i.getSubmenu()||!this.checkEnabled(i)){return;}this.setHoveredItem(i);this.openSubmenu(i,false,true);});};
a.prototype._discardOpenSubMenuDelayed=function(i){if(this._delayedSubMenuTimer){q.sap.clearDelayedCall(this._delayedSubMenuTimer);this._delayedSubMenuTimer=null;}};
a.prototype.onmouseout=function(e){if(!sap.ui.Device.system.desktop){return;}if(q.sap.checkMouseEnterOrLeave(e,this.getDomRef())){if(!this.oOpenedSubMenu||!(this.oOpenedSubMenu.getParent()===this.oHoveredItem)){this.setHoveredItem(null);}this._discardOpenSubMenuDelayed();}};
a.prototype.onsapfocusleave=function(e){if(this.oOpenedSubMenu||!this.bOpen){return;}this.getRootMenu().handleOuterEvent(this.getId(),e);};
a.prototype.handleOuterEvent=function(m,e){var i=false,t=this.getPopup().touchEnabled;this.bIgnoreOpenerDOMRef=false;if(e.type=="mousedown"||e.type=="touchstart"){if(t&&(e.isMarked("delayedMouseEvent")||e.isMarked("cancelAutoClose"))){return;}var f=this;while(f&&!i){if(q.sap.containsOrEquals(f.getDomRef(),e.target)){i=true;}f=f.oOpenedSubMenu;}}else if(e.type=="sapfocusleave"){if(t){return;}if(e.relatedControlId){var f=this;while(f&&!i){if((f.oOpenedSubMenu&&f.oOpenedSubMenu.getId()==e.relatedControlId)||q.sap.containsOrEquals(f.getDomRef(),q.sap.byId(e.relatedControlId).get(0))){i=true;}f=f.oOpenedSubMenu;}}if(!i){this.bIgnoreOpenerDOMRef=true;}}if(!i){this.close();}};
a.prototype.getItemByDomRef=function(o){var I=this.getItems(),L=I.length;for(var i=0;i<L;i++){var e=I[i],f=e.getDomRef();if(q.sap.containsOrEquals(f,o)){return e;}}return null;};
a.prototype.selectItem=function(i,W,e){if(!i||!(i instanceof M&&this.checkEnabled(i))){return;}var S=i.getSubmenu();if(!S){this.getRootMenu().close();}else{if(!sap.ui.Device.system.desktop&&this.oOpenedSubMenu===S){this.closeSubmenu();}else{this.openSubmenu(i,W);}}i.fireSelect({item:i,ctrlKey:e});this.getRootMenu().fireItemSelect({item:i});};
a.prototype.isSubMenu=function(){return this.getParent()&&this.getParent().getParent&&this.getParent().getParent()instanceof a;};
a.prototype.getRootMenu=function(){var t=this;while(t.isSubMenu()){t=t.getParent().getParent();}return t;};
a.prototype.getMenuLevel=function(){var L=1;var t=this;while(t.isSubMenu()){t=t.getParent().getParent();L++;}return L;};
a.prototype.getPopup=function(){if(!this.oPopup){this.oPopup=new P(this,false,true,false);this.oPopup.setDurations(0,0);this.oPopup.attachClosed(this._menuClosed,this);}return this.oPopup;};
a.prototype.setHoveredItem=function(i){if(this.oHoveredItem){this.oHoveredItem.hover(false,this);}if(!i){this.oHoveredItem=null;q(this.getDomRef()).removeAttr("aria-activedescendant");return;}this.oHoveredItem=i;i.hover(true,this);this._setActiveDescendant(this.oHoveredItem);this.scrollToItem(this.oHoveredItem);};
a.prototype._setActiveDescendant=function(i){if(sap.ui.getCore().getConfiguration().getAccessibility()&&i){var t=this;t.$().removeAttr("aria-activedescendant");setTimeout(function(){if(t.oHoveredItem===i){t.$().attr("aria-activedescendant",t.oHoveredItem.getId());}},10);}};
a.prototype.openSubmenu=function(i,W,e){var S=i.getSubmenu();if(!S){return;}if(this.oOpenedSubMenu&&this.oOpenedSubMenu!==S){this.closeSubmenu();}if(this.oOpenedSubMenu){this.oOpenedSubMenu._bFixed=(e&&this.oOpenedSubMenu._bFixed)||(!e&&!this.oOpenedSubMenu._bFixed);this.oOpenedSubMenu._bringToFront();}else{this.oOpenedSubMenu=S;var f=P.Dock;S.open(W,this,f.BeginTop,f.EndTop,i,"0 0");}};
a.prototype.closeSubmenu=function(i,I){if(this.oOpenedSubMenu){if(i&&this.oOpenedSubMenu._bFixed){return;}if(I){this.oOpenedSubMenu.bIgnoreOpenerDOMRef=true;}this.oOpenedSubMenu.close();this.oOpenedSubMenu=null;}};
a.prototype.scrollToItem=function(i){var m=this.getDomRef(),I=i?i.getDomRef():null;if(!I||!m){return;}var e=m.scrollTop,f=I.offsetTop,g=q(m).height(),h=q(I).height();if(e>f){m.scrollTop=f;}else if((f+h)>(e+g)){m.scrollTop=Math.ceil(f+h-g);}};
a.prototype._bringToFront=function(){q.sap.byId(this.getPopup().getId()).mousedown();};
a.prototype.checkEnabled=function(i){return i&&i.getEnabled()&&this.getEnabled();};
a.prototype.getNextSelectableItem=function(I){var o=null;var e=this.getItems();for(var i=I+1;i<e.length;i++){if(e[i].getVisible()&&this.checkEnabled(e[i])){o=e[i];break;}}if(!o){for(var i=0;i<=I;i++){if(e[i].getVisible()&&this.checkEnabled(e[i])){o=e[i];break;}}}return o;};
a.prototype.getPreviousSelectableItem=function(I){var o=null;var e=this.getItems();for(var i=I-1;i>=0;i--){if(e[i].getVisible()&&this.checkEnabled(e[i])){o=e[i];break;}}if(!o){for(var i=e.length-1;i>=I;i--){if(e[i].getVisible()&&this.checkEnabled(e[i])){o=e[i];break;}}}return o;};
a.prototype.setRootMenuTopStyle=function(u){this.getRootMenu().bUseTopStyle=u;a.rerenderMenu(this.getRootMenu());};
a.rerenderMenu=function(m){var I=m.getItems();for(var i=0;i<I.length;i++){var S=I[i].getSubmenu();if(S){a.rerenderMenu(S);}}m.invalidate();m.rerender();};
a.prototype.focus=function(){if(this.bOpen){C.prototype.focus.apply(this,arguments);this._setActiveDescendant(this.oHoveredItem);}};
a.prototype.isCozy=function(){if(!this.bCozySupported){return false;}if(this.hasStyleClass("sapUiSizeCozy")){return true;}if(c(this.oOpenerRef)){return true;}if(c(this.getParent())){return true;}return false;};
function c(r){if(!r){return false;}r=r.$?r.$():q(r);return r.closest(".sapUiSizeCompact,.sapUiSizeCondensed,.sapUiSizeCozy").hasClass("sapUiSizeCozy");}
function s(m,o){var p=m.getParent();if(p&&p instanceof M){p.onSubmenuToggle(o);}}
function b(m){var e=m.getMaxVisibleItems(),f=document.documentElement.clientHeight-10,$=m.$();if(e>0){var I=m.getItems();for(var i=0;i<I.length;i++){if(I[i].getDomRef()){f=Math.min(f,I[i].$().outerHeight(true)*e);break;}}}if($.outerHeight(true)>f){$.css("max-height",f+"px").toggleClass("sapUiMnuScroll",true);}else{$.css("max-height","").toggleClass("sapUiMnuScroll",false);}}
/*!
	 * The following code is taken from
	 * jQuery UI 1.10.3 - 2013-11-18
	 * jquery.ui.position.js
	 *
	 * http://jqueryui.com
	 * Copyright 2013 jQuery Foundation and other contributors; Licensed MIT
	 */

function _(e){var f=q(w);e.within={element:f,isWindow:true,offset:f.offset()||{left:0,top:0},scrollLeft:f.scrollLeft(),scrollTop:f.scrollTop(),width:f.width(),height:f.height()};e.collisionPosition={marginLeft:0,marginTop:0};return e;}
var d={fit:{left:function(p,e){var f=e.within,g=f.isWindow?f.scrollLeft:f.offset.left,o=f.width,h=p.left-e.collisionPosition.marginLeft,i=g-h,j=h+e.collisionWidth-o-g,n;if(e.collisionWidth>o){if(i>0&&j<=0){n=p.left+i+e.collisionWidth-o-g;p.left+=i-n;}else if(j>0&&i<=0){p.left=g;}else{if(i>j){p.left=g+o-e.collisionWidth;}else{p.left=g;}}}else if(i>0){p.left+=i;}else if(j>0){p.left-=j;}else{p.left=Math.max(p.left-h,p.left);}},top:function(p,e){var f=e.within,g=f.isWindow?f.scrollTop:f.offset.top,o=e.within.height,h=p.top-e.collisionPosition.marginTop,i=g-h,j=h+e.collisionHeight-o-g,n;if(e.collisionHeight>o){if(i>0&&j<=0){n=p.top+i+e.collisionHeight-o-g;p.top+=i-n;}else if(j>0&&i<=0){p.top=g;}else{if(i>j){p.top=g+o-e.collisionHeight;}else{p.top=g;}}}else if(i>0){p.top+=i;}else if(j>0){p.top-=j;}else{p.top=Math.max(p.top-h,p.top);}}},flip:{left:function(p,e){var f=e.within,g=f.offset.left+f.scrollLeft,o=f.width,h=f.isWindow?f.scrollLeft:f.offset.left,i=p.left-e.collisionPosition.marginLeft,j=i-h,k=i+e.collisionWidth-o-h,m=e.my[0]==="left"?-e.elemWidth:e.my[0]==="right"?e.elemWidth:0,n=e.at[0]==="left"?e.targetWidth:e.at[0]==="right"?-e.targetWidth:0,r=-2*e.offset[0],t,u;if(j<0){t=p.left+m+n+r+e.collisionWidth-o-g;if(t<0||t<Math.abs(j)){p.left+=m+n+r;}}else if(k>0){u=p.left-e.collisionPosition.marginLeft+m+n+r-h;if(u>0||Math.abs(u)<k){p.left+=m+n+r;}}},top:function(p,e){var f=e.within,g=f.offset.top+f.scrollTop,o=f.height,h=f.isWindow?f.scrollTop:f.offset.top,i=p.top-e.collisionPosition.marginTop,j=i-h,k=i+e.collisionHeight-o-h,t=e.my[1]==="top",m=t?-e.elemHeight:e.my[1]==="bottom"?e.elemHeight:0,n=e.at[1]==="top"?e.targetHeight:e.at[1]==="bottom"?-e.targetHeight:0,r=-2*e.offset[1],u,v;if(j<0){v=p.top+m+n+r+e.collisionHeight-o-g;if((p.top+m+n+r)>j&&(v<0||v<Math.abs(j))){p.top+=m+n+r;}}else if(k>0){u=p.top-e.collisionPosition.marginTop+m+n+r-h;if((p.top+m+n+r)>k&&(u>0||Math.abs(u)<k)){p.top+=m+n+r;}}}},flipfit:{left:function(){d.flip.left.apply(this,arguments);d.fit.left.apply(this,arguments);},top:function(){d.flip.top.apply(this,arguments);d.fit.top.apply(this,arguments);}}};q.ui.position._sapUiCommonsMenuFlip={left:function(p,e){if(q.ui.position.flipfit){q.ui.position.flipfit.left.apply(this,arguments);return;}e=_(e);d.flipfit.left.apply(this,arguments);},top:function(p,e){if(q.ui.position.flipfit){q.ui.position.flipfit.top.apply(this,arguments);return;}e=_(e);d.flipfit.top.apply(this,arguments);}};})(window);return a;},true);
jQuery.sap.registerPreloadedModules({
"name":"sap/ui/unified/library-preload",
"version":"2.0",
"modules":{
	"sap/ui/unified/manifest.json":'{\n  "_version": "1.2.0",\n  "sap.app": {\n    "_version": "1.2.0",\n    "id": "sap.ui.unified",\n    "type": "library",\n    "embeds": [],\n    "applicationVersion": {\n      "version": "1.42.7"\n    },\n    "title": "Unified controls intended for both, mobile and desktop scenarios",\n    "description": "Unified controls intended for both, mobile and desktop scenarios",\n    "ach": "CA-UI5-CTR",\n    "resources": "resources.json",\n    "offline": true\n  },\n  "sap.ui": {\n    "_version": "1.1.0",\n    "technology": "UI5",\n    "supportedThemes": [\n      "base",\n      "sap_hcb"\n    ]\n  },\n  "sap.ui5": {\n    "_version": "1.1.0",\n    "dependencies": {\n      "minUI5Version": "1.42",\n      "libs": {\n        "sap.ui.core": {\n          "minVersion": "1.42.7"\n        }\n      }\n    }\n  }\n}'
}});
